(function(){function Lexer(options){this.tokens=[],this.tokens.links={},this.options=options||marked.defaults,this.rules=block.normal,this.options.gfm&&(this.options.tables?this.rules=block.tables:this.rules=block.gfm)}function InlineLexer(links,options){if(this.options=options||marked.defaults,this.links=links,this.rules=inline.normal,this.renderer=this.options.renderer||new Renderer,this.renderer.options=this.options,!this.links)throw new Error("Tokens array requires a `links` property.");this.options.gfm?this.options.breaks?this.rules=inline.breaks:this.rules=inline.gfm:this.options.pedantic&&(this.rules=inline.pedantic)}function Renderer(options){this.options=options||{}}function Parser(options){this.tokens=[],this.token=null,this.options=options||marked.defaults,this.options.renderer=this.options.renderer||new Renderer,this.renderer=this.options.renderer,this.renderer.options=this.options}function escape(html,encode){return html.replace(encode?/&/g:/&(?!#?\w+;)/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;")}function unescape(html){return html.replace(/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/g,function(_,n){return n=n.toLowerCase(),"colon"===n?":":"#"===n.charAt(0)?"x"===n.charAt(1)?String.fromCharCode(parseInt(n.substring(2),16)):String.fromCharCode(+n.substring(1)):""})}function replace(regex,opt){return regex=regex.source,opt=opt||"",function self(name,val){return name?(val=val.source||val,val=val.replace(/(^|[^\[])\^/g,"$1"),regex=regex.replace(name,val),self):new RegExp(regex,opt)}}function noop(){}function merge(obj){for(var target,key,i=1;i<arguments.length;i++){target=arguments[i];for(key in target)Object.prototype.hasOwnProperty.call(target,key)&&(obj[key]=target[key])}return obj}function marked(src,opt,callback){if(callback||"function"==typeof opt){callback||(callback=opt,opt=null),opt=merge({},marked.defaults,opt||{});var tokens,pending,highlight=opt.highlight,i=0;try{tokens=Lexer.lex(src,opt)}catch(e){return callback(e)}pending=tokens.length;var done=function(err){if(err)return opt.highlight=highlight,callback(err);var out;try{out=Parser.parse(tokens,opt)}catch(e){err=e}return opt.highlight=highlight,err?callback(err):callback(null,out)};if(!highlight||highlight.length<3)return done();if(delete opt.highlight,!pending)return done();for(;i<tokens.length;i++)!function(token){return"code"!==token.type?--pending||done():highlight(token.text,token.lang,function(err,code){return err?done(err):null==code||code===token.text?--pending||done():(token.text=code,token.escaped=!0,void(--pending||done()))})}(tokens[i])}else try{return opt&&(opt=merge({},marked.defaults,opt)),Parser.parse(Lexer.lex(src,opt),opt)}catch(e){if(e.message+="\nPlease report this to https://github.com/chjj/marked.",(opt||marked.defaults).silent)return"<p>An error occured:</p><pre>"+escape(e.message+"",!0)+"</pre>";throw e}}var block={newline:/^\n+/,code:/^( {4}[^\n]+\n*)+/,fences:noop,hr:/^( *[-*_]){3,} *(?:\n+|$)/,heading:/^ *(#{1,6}) *([^\n]+?) *#* *(?:\n+|$)/,nptable:noop,lheading:/^([^\n]+)\n *(=|-){2,} *(?:\n+|$)/,blockquote:/^( *>[^\n]+(\n(?!def)[^\n]+)*\n*)+/,list:/^( *)(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?!\1bull )\n*|\s*$)/,html:/^ *(?:comment *(?:\n|\s*$)|closed *(?:\n{2,}|\s*$)|closing *(?:\n{2,}|\s*$))/,def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +["(]([^\n]+)[")])? *(?:\n+|$)/,table:noop,paragraph:/^((?:[^\n]+\n?(?!hr|heading|lheading|blockquote|tag|def))+)\n*/,text:/^[^\n]+/};block.bullet=/(?:[*+-]|\d+\.)/,block.item=/^( *)(bull) [^\n]*(?:\n(?!\1bull )[^\n]*)*/,block.item=replace(block.item,"gm")(/bull/g,block.bullet)(),block.list=replace(block.list)(/bull/g,block.bullet)("hr","\\n+(?=\\1?(?:[-*_] *){3,}(?:\\n+|$))")("def","\\n+(?="+block.def.source+")")(),block.blockquote=replace(block.blockquote)("def",block.def)(),block._tag="(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:/|[^\\w\\s@]*@)\\b",block.html=replace(block.html)("comment",/<!--[\s\S]*?-->/)("closed",/<(tag)[\s\S]+?<\/\1>/)("closing",/<tag(?:"[^"]*"|'[^']*'|[^'">])*?>/)(/tag/g,block._tag)(),block.paragraph=replace(block.paragraph)("hr",block.hr)("heading",block.heading)("lheading",block.lheading)("blockquote",block.blockquote)("tag","<"+block._tag)("def",block.def)(),block.normal=merge({},block),block.gfm=merge({},block.normal,{fences:/^ *(`{3,}|~{3,})[ \.]*(\S+)? *\n([\s\S]*?)\s*\1 *(?:\n+|$)/,paragraph:/^/,heading:/^ *(#{1,6}) +([^\n]+?) *#* *(?:\n+|$)/}),block.gfm.paragraph=replace(block.paragraph)("(?!","(?!"+block.gfm.fences.source.replace("\\1","\\2")+"|"+block.list.source.replace("\\1","\\3")+"|")(),block.tables=merge({},block.gfm,{nptable:/^ *(\S.*\|.*)\n *([-:]+ *\|[-| :]*)\n((?:.*\|.*(?:\n|$))*)\n*/,table:/^ *\|(.+)\n *\|( *[-:]+[-| :]*)\n((?: *\|.*(?:\n|$))*)\n*/}),Lexer.rules=block,Lexer.lex=function(src,options){var lexer=new Lexer(options);return lexer.lex(src)},Lexer.prototype.lex=function(src){return src=src.replace(/\r\n|\r/g,"\n").replace(/\t/g,"    ").replace(/\u00a0/g," ").replace(/\u2424/g,"\n"),this.token(src,!0)},Lexer.prototype.token=function(src,top,bq){for(var next,loose,cap,bull,b,item,space,i,l,src=src.replace(/^ +$/gm,"");src;)if((cap=this.rules.newline.exec(src))&&(src=src.substring(cap[0].length),cap[0].length>1&&this.tokens.push({type:"space"})),cap=this.rules.code.exec(src))src=src.substring(cap[0].length),cap=cap[0].replace(/^ {4}/gm,""),this.tokens.push({type:"code",text:this.options.pedantic?cap:cap.replace(/\n+$/,"")});else if(cap=this.rules.fences.exec(src))src=src.substring(cap[0].length),this.tokens.push({type:"code",lang:cap[2],text:cap[3]||""});else if(cap=this.rules.heading.exec(src))src=src.substring(cap[0].length),this.tokens.push({type:"heading",depth:cap[1].length,text:cap[2]});else if(top&&(cap=this.rules.nptable.exec(src))){for(src=src.substring(cap[0].length),item={type:"table",header:cap[1].replace(/^ *| *\| *$/g,"").split(/ *\| */),align:cap[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:cap[3].replace(/\n$/,"").split("\n")},i=0;i<item.align.length;i++)/^ *-+: *$/.test(item.align[i])?item.align[i]="right":/^ *:-+: *$/.test(item.align[i])?item.align[i]="center":/^ *:-+ *$/.test(item.align[i])?item.align[i]="left":item.align[i]=null;for(i=0;i<item.cells.length;i++)item.cells[i]=item.cells[i].split(/ *\| */);this.tokens.push(item)}else if(cap=this.rules.lheading.exec(src))src=src.substring(cap[0].length),this.tokens.push({type:"heading",depth:"="===cap[2]?1:2,text:cap[1]});else if(cap=this.rules.hr.exec(src))src=src.substring(cap[0].length),this.tokens.push({type:"hr"});else if(cap=this.rules.blockquote.exec(src))src=src.substring(cap[0].length),this.tokens.push({type:"blockquote_start"}),cap=cap[0].replace(/^ *> ?/gm,""),this.token(cap,top,!0),this.tokens.push({type:"blockquote_end"});else if(cap=this.rules.list.exec(src)){for(src=src.substring(cap[0].length),bull=cap[2],this.tokens.push({type:"list_start",ordered:bull.length>1}),cap=cap[0].match(this.rules.item),next=!1,l=cap.length,i=0;l>i;i++)item=cap[i],space=item.length,item=item.replace(/^ *([*+-]|\d+\.) +/,""),~item.indexOf("\n ")&&(space-=item.length,item=this.options.pedantic?item.replace(/^ {1,4}/gm,""):item.replace(new RegExp("^ {1,"+space+"}","gm"),"")),this.options.smartLists&&i!==l-1&&(b=block.bullet.exec(cap[i+1])[0],bull===b||bull.length>1&&b.length>1||(src=cap.slice(i+1).join("\n")+src,i=l-1)),loose=next||/\n\n(?!\s*$)/.test(item),i!==l-1&&(next="\n"===item.charAt(item.length-1),loose||(loose=next)),this.tokens.push({type:loose?"loose_item_start":"list_item_start"}),this.token(item,!1,bq),this.tokens.push({type:"list_item_end"});this.tokens.push({type:"list_end"})}else if(cap=this.rules.html.exec(src))src=src.substring(cap[0].length),this.tokens.push({type:this.options.sanitize?"paragraph":"html",pre:!this.options.sanitizer&&("pre"===cap[1]||"script"===cap[1]||"style"===cap[1]),text:cap[0]});else if(!bq&&top&&(cap=this.rules.def.exec(src)))src=src.substring(cap[0].length),this.tokens.links[cap[1].toLowerCase()]={href:cap[2],title:cap[3]};else if(top&&(cap=this.rules.table.exec(src))){for(src=src.substring(cap[0].length),item={type:"table",header:cap[1].replace(/^ *| *\| *$/g,"").split(/ *\| */),align:cap[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:cap[3].replace(/(?: *\| *)?\n$/,"").split("\n")},i=0;i<item.align.length;i++)/^ *-+: *$/.test(item.align[i])?item.align[i]="right":/^ *:-+: *$/.test(item.align[i])?item.align[i]="center":/^ *:-+ *$/.test(item.align[i])?item.align[i]="left":item.align[i]=null;for(i=0;i<item.cells.length;i++)item.cells[i]=item.cells[i].replace(/^ *\| *| *\| *$/g,"").split(/ *\| */);this.tokens.push(item)}else if(top&&(cap=this.rules.paragraph.exec(src)))src=src.substring(cap[0].length),this.tokens.push({type:"paragraph",text:"\n"===cap[1].charAt(cap[1].length-1)?cap[1].slice(0,-1):cap[1]});else if(cap=this.rules.text.exec(src))src=src.substring(cap[0].length),this.tokens.push({type:"text",text:cap[0]});else if(src)throw new Error("Infinite loop on byte: "+src.charCodeAt(0));return this.tokens};var inline={escape:/^\\([\\`*{}\[\]()#+\-.!_>])/,autolink:/^<([^ >]+(@|:\/)[^ >]+)>/,url:noop,tag:/^<!--[\s\S]*?-->|^<\/?\w+(?:"[^"]*"|'[^']*'|[^'">])*?>/,link:/^!?\[(inside)\]\(href\)/,reflink:/^!?\[(inside)\]\s*\[([^\]]*)\]/,nolink:/^!?\[((?:\[[^\]]*\]|[^\[\]])*)\]/,strong:/^__([\s\S]+?)__(?!_)|^\*\*([\s\S]+?)\*\*(?!\*)/,em:/^\b_((?:[^_]|__)+?)_\b|^\*((?:\*\*|[\s\S])+?)\*(?!\*)/,code:/^(`+)\s*([\s\S]*?[^`])\s*\1(?!`)/,br:/^ {2,}\n(?!\s*$)/,del:noop,text:/^[\s\S]+?(?=[\\<!\[_*`]| {2,}\n|$)/};inline._inside=/(?:\[[^\]]*\]|[^\[\]]|\](?=[^\[]*\]))*/,inline._href=/\s*<?([\s\S]*?)>?(?:\s+['"]([\s\S]*?)['"])?\s*/,inline.link=replace(inline.link)("inside",inline._inside)("href",inline._href)(),inline.reflink=replace(inline.reflink)("inside",inline._inside)(),inline.normal=merge({},inline),inline.pedantic=merge({},inline.normal,{strong:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,em:/^_(?=\S)([\s\S]*?\S)_(?!_)|^\*(?=\S)([\s\S]*?\S)\*(?!\*)/}),inline.gfm=merge({},inline.normal,{escape:replace(inline.escape)("])","~|])")(),url:/^(https?:\/\/[^\s<]+[^<.,:;"')\]\s])/,del:/^~~(?=\S)([\s\S]*?\S)~~/,text:replace(inline.text)("]|","~]|")("|","|https?://|")()}),inline.breaks=merge({},inline.gfm,{br:replace(inline.br)("{2,}","*")(),text:replace(inline.gfm.text)("{2,}","*")()}),InlineLexer.rules=inline,InlineLexer.output=function(src,links,options){var inline=new InlineLexer(links,options);return inline.output(src)},InlineLexer.prototype.output=function(src){for(var link,text,href,cap,out="";src;)if(cap=this.rules.escape.exec(src))src=src.substring(cap[0].length),out+=cap[1];else if(cap=this.rules.autolink.exec(src))src=src.substring(cap[0].length),"@"===cap[2]?(text=":"===cap[1].charAt(6)?this.mangle(cap[1].substring(7)):this.mangle(cap[1]),href=this.mangle("mailto:")+text):(text=escape(cap[1]),href=text),out+=this.renderer.link(href,null,text);else if(this.inLink||!(cap=this.rules.url.exec(src))){if(cap=this.rules.tag.exec(src))!this.inLink&&/^<a /i.test(cap[0])?this.inLink=!0:this.inLink&&/^<\/a>/i.test(cap[0])&&(this.inLink=!1),src=src.substring(cap[0].length),out+=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(cap[0]):escape(cap[0]):cap[0];else if(cap=this.rules.link.exec(src))src=src.substring(cap[0].length),this.inLink=!0,out+=this.outputLink(cap,{href:cap[2],title:cap[3]}),this.inLink=!1;else if((cap=this.rules.reflink.exec(src))||(cap=this.rules.nolink.exec(src))){if(src=src.substring(cap[0].length),link=(cap[2]||cap[1]).replace(/\s+/g," "),link=this.links[link.toLowerCase()],!link||!link.href){out+=cap[0].charAt(0),src=cap[0].substring(1)+src;continue}this.inLink=!0,out+=this.outputLink(cap,link),this.inLink=!1}else if(cap=this.rules.strong.exec(src))src=src.substring(cap[0].length),out+=this.renderer.strong(this.output(cap[2]||cap[1]));else if(cap=this.rules.em.exec(src))src=src.substring(cap[0].length),out+=this.renderer.em(this.output(cap[2]||cap[1]));else if(cap=this.rules.code.exec(src))src=src.substring(cap[0].length),out+=this.renderer.codespan(escape(cap[2],!0));else if(cap=this.rules.br.exec(src))src=src.substring(cap[0].length),out+=this.renderer.br();else if(cap=this.rules.del.exec(src))src=src.substring(cap[0].length),out+=this.renderer.del(this.output(cap[1]));else if(cap=this.rules.text.exec(src))src=src.substring(cap[0].length),out+=this.renderer.text(escape(this.smartypants(cap[0])));else if(src)throw new Error("Infinite loop on byte: "+src.charCodeAt(0))}else src=src.substring(cap[0].length),text=escape(cap[1]),href=text,out+=this.renderer.link(href,null,text);return out},InlineLexer.prototype.outputLink=function(cap,link){var href=escape(link.href),title=link.title?escape(link.title):null;return"!"!==cap[0].charAt(0)?this.renderer.link(href,title,this.output(cap[1])):this.renderer.image(href,title,escape(cap[1]))},InlineLexer.prototype.smartypants=function(text){return this.options.smartypants?text.replace(/---/g,"—").replace(/--/g,"–").replace(/(^|[-\u2014\/(\[{"\s])'/g,"$1‘").replace(/'/g,"’").replace(/(^|[-\u2014\/(\[{\u2018\s])"/g,"$1“").replace(/"/g,"”").replace(/\.{3}/g,"…"):text},InlineLexer.prototype.mangle=function(text){if(!this.options.mangle)return text;for(var ch,out="",l=text.length,i=0;l>i;i++)ch=text.charCodeAt(i),Math.random()>.5&&(ch="x"+ch.toString(16)),out+="&#"+ch+";";return out},Renderer.prototype.code=function(code,lang,escaped){if(this.options.highlight){var out=this.options.highlight(code,lang);null!=out&&out!==code&&(escaped=!0,code=out)}return lang?'<pre><code class="'+this.options.langPrefix+escape(lang,!0)+'">'+(escaped?code:escape(code,!0))+"\n</code></pre>\n":"<pre><code>"+(escaped?code:escape(code,!0))+"\n</code></pre>"},Renderer.prototype.blockquote=function(quote){return"<blockquote>\n"+quote+"</blockquote>\n"},Renderer.prototype.html=function(html){return html},Renderer.prototype.heading=function(text,level,raw){return"<h"+level+' id="'+this.options.headerPrefix+raw.toLowerCase().replace(/[^\w]+/g,"-")+'">'+text+"</h"+level+">\n"},Renderer.prototype.hr=function(){return this.options.xhtml?"<hr/>\n":"<hr>\n"},Renderer.prototype.list=function(body,ordered){var type=ordered?"ol":"ul";return"<"+type+">\n"+body+"</"+type+">\n"},Renderer.prototype.listitem=function(text){return"<li>"+text+"</li>\n"},Renderer.prototype.paragraph=function(text){return"<p>"+text+"</p>\n"},Renderer.prototype.table=function(header,body){return"<table>\n<thead>\n"+header+"</thead>\n<tbody>\n"+body+"</tbody>\n</table>\n"},Renderer.prototype.tablerow=function(content){return"<tr>\n"+content+"</tr>\n"},Renderer.prototype.tablecell=function(content,flags){var type=flags.header?"th":"td",tag=flags.align?"<"+type+' style="text-align:'+flags.align+'">':"<"+type+">";return tag+content+"</"+type+">\n"},Renderer.prototype.strong=function(text){return"<strong>"+text+"</strong>"},Renderer.prototype.em=function(text){return"<em>"+text+"</em>"},Renderer.prototype.codespan=function(text){return"<code>"+text+"</code>"},Renderer.prototype.br=function(){return this.options.xhtml?"<br/>":"<br>"},Renderer.prototype.del=function(text){return"<del>"+text+"</del>"},Renderer.prototype.link=function(href,title,text){if(this.options.sanitize){try{var prot=decodeURIComponent(unescape(href)).replace(/[^\w:]/g,"").toLowerCase()}catch(e){return""}if(0===prot.indexOf("javascript:")||0===prot.indexOf("vbscript:"))return""}var out='<a href="'+href+'"';return title&&(out+=' title="'+title+'"'),out+=">"+text+"</a>"},Renderer.prototype.image=function(href,title,text){var out='<img src="'+href+'" alt="'+text+'"';return title&&(out+=' title="'+title+'"'),out+=this.options.xhtml?"/>":">"},Renderer.prototype.text=function(text){return text},Parser.parse=function(src,options,renderer){var parser=new Parser(options,renderer);return parser.parse(src)},Parser.prototype.parse=function(src){this.inline=new InlineLexer(src.links,this.options,this.renderer),this.tokens=src.reverse();for(var out="";this.next();)out+=this.tok();return out},Parser.prototype.next=function(){return this.token=this.tokens.pop()},Parser.prototype.peek=function(){return this.tokens[this.tokens.length-1]||0},Parser.prototype.parseText=function(){for(var body=this.token.text;"text"===this.peek().type;)body+="\n"+this.next().text;return this.inline.output(body)},Parser.prototype.tok=function(){switch(this.token.type){case"space":return"";case"hr":return this.renderer.hr();case"heading":return this.renderer.heading(this.inline.output(this.token.text),this.token.depth,this.token.text);case"code":return this.renderer.code(this.token.text,this.token.lang,this.token.escaped);case"table":var i,row,cell,flags,j,header="",body="";for(cell="",i=0;i<this.token.header.length;i++)flags={header:!0,align:this.token.align[i]},cell+=this.renderer.tablecell(this.inline.output(this.token.header[i]),{header:!0,align:this.token.align[i]});for(header+=this.renderer.tablerow(cell),i=0;i<this.token.cells.length;i++){for(row=this.token.cells[i],cell="",j=0;j<row.length;j++)cell+=this.renderer.tablecell(this.inline.output(row[j]),{header:!1,align:this.token.align[j]});body+=this.renderer.tablerow(cell)}return this.renderer.table(header,body);case"blockquote_start":for(var body="";"blockquote_end"!==this.next().type;)body+=this.tok();return this.renderer.blockquote(body);case"list_start":for(var body="",ordered=this.token.ordered;"list_end"!==this.next().type;)body+=this.tok();return this.renderer.list(body,ordered);case"list_item_start":for(var body="";"list_item_end"!==this.next().type;)body+="text"===this.token.type?this.parseText():this.tok();return this.renderer.listitem(body);case"loose_item_start":for(var body="";"list_item_end"!==this.next().type;)body+=this.tok();return this.renderer.listitem(body);case"html":var html=this.token.pre||this.options.pedantic?this.token.text:this.inline.output(this.token.text);return this.renderer.html(html);case"paragraph":return this.renderer.paragraph(this.inline.output(this.token.text));case"text":return this.renderer.paragraph(this.parseText())}},noop.exec=noop,marked.options=marked.setOptions=function(opt){return merge(marked.defaults,opt),marked},marked.defaults={gfm:!0,tables:!0,breaks:!1,pedantic:!1,sanitize:!1,sanitizer:null,mangle:!0,smartLists:!1,silent:!1,highlight:null,langPrefix:"lang-",smartypants:!1,headerPrefix:"",renderer:new Renderer,xhtml:!1},marked.Parser=Parser,marked.parser=Parser.parse,marked.Renderer=Renderer,marked.Lexer=Lexer,marked.lexer=Lexer.lex,marked.InlineLexer=InlineLexer,marked.inlineLexer=InlineLexer.output,marked.parse=marked,"undefined"!=typeof module&&"object"==typeof exports?module.exports=marked:"function"==typeof define&&define.amd?define(function(){return marked}):this.marked=marked}).call(function(){return this||("undefined"!=typeof window?window:global)}()),function(root,factory){"object"==typeof exports&&"object"==typeof module?module.exports=factory(require("fs"),require("typescript"),function(){try{return require("RAML.XmlValidation")}catch(e){}}(),function(){try{return require("RAML.JsonValidation")}catch(e){}}()):"function"==typeof define&&define.amd?define(["fs","typescript","RAML.XmlValidation","RAML.JsonValidation"],factory):"object"==typeof exports?exports.Parser=factory(require("fs"),require("typescript"),function(){try{return require("RAML.XmlValidation")}catch(e){}}(),function(){try{return require("RAML.JsonValidation")}catch(e){}}()):(root.RAML=root.RAML||{},root.RAML.Parser=factory(root.fs,root.typescript,root["RAML.XmlValidation"],root["RAML.JsonValidation"]))}(this,function(__WEBPACK_EXTERNAL_MODULE_38__,__WEBPACK_EXTERNAL_MODULE_147__,__WEBPACK_EXTERNAL_MODULE_171__,__WEBPACK_EXTERNAL_MODULE_172__){return function(modules){function __webpack_require__(moduleId){if(installedModules[moduleId])return installedModules[moduleId].exports;var module=installedModules[moduleId]={exports:{},id:moduleId,loaded:!1};return modules[moduleId].call(module.exports,module,module.exports,__webpack_require__),module.loaded=!0,module.exports}var installedModules={};return __webpack_require__.m=modules,__webpack_require__.c=installedModules,__webpack_require__.p="",__webpack_require__(0)}([function(module,exports,__webpack_require__){"use strict";function loadApiSync(apiPath,arg1,arg2){return apiLoader.loadApi(apiPath,arg1,arg2).getOrElse(null)}function loadRAMLSync(ramlPath,arg1,arg2){return apiLoader.loadApi(ramlPath,arg1,arg2).getOrElse(null)}function optionsForContent(content,arg2,filePath){return{fsResolver:{content:function(pathStr){return pathStr===(filePath||path.resolve("/","#local.raml")).replace(/\\/,"/")?content:arg2&&arg2.fsResolver?arg2.fsResolver.content(pathStr):void 0},contentAsync:function(pathStr){return pathStr===(filePath||path.resolve("/","#local.raml")).replace(/\\/,"/")?Promise.resolve(content):arg2&&arg2.fsResolver?arg2.fsResolver.contentAsync(pathStr):void 0}},httpResolver:arg2?arg2.httpResolver:null,rejectOnErrors:arg2?arg2.rejectOnErrors:!1,attributeDefaults:arg2?arg2.attributeDefaults:!0}}function parseRAMLSync(content,arg2){var filePath=null;return arg2&&arg2.filePath&&(filePath=arg2.filePath),apiLoader.loadApi(filePath||"/#local.raml",[],optionsForContent(content,arg2,filePath)).getOrElse(null)}function parseRAML(content,arg2){var filePath=null;return arg2&&arg2.filePath&&(filePath=arg2.filePath),apiLoader.loadApiAsync(filePath||"/#local.raml",[],optionsForContent(content,arg2,filePath))}function loadApi(apiPath,arg1,arg2){return apiLoader.loadApiAsync(apiPath,arg1,arg2)}function loadRAML(ramlPath,arg1,arg2){return apiLoader.loadRAMLAsync(ramlPath,arg1,arg2)}function getLanguageElementByRuntimeType(runtimeType){return apiLoader.getLanguageElementByRuntimeType(runtimeType)}function isFragment(node){return exports.api10.isFragment(node)}function asFragment(node){return exports.api10.asFragment(node)}var apiLoader=__webpack_require__(9),path=__webpack_require__(15),PromiseConstructor=__webpack_require__(23);exports.api10=__webpack_require__(12),exports.api08=__webpack_require__(13),exports.loadApiSync=loadApiSync,exports.loadRAMLSync=loadRAMLSync,exports.parseRAMLSync=parseRAMLSync,exports.parseRAML=parseRAML,exports.loadApi=loadApi,exports.loadRAML=loadRAML,exports.getLanguageElementByRuntimeType=getLanguageElementByRuntimeType,exports.isFragment=isFragment,exports.asFragment=asFragment,exports.hl=__webpack_require__(10),exports.ll=__webpack_require__(11),exports.search=__webpack_require__(1),exports.stubs=__webpack_require__(2),exports.utils=__webpack_require__(3),exports.project=__webpack_require__(4),exports.universeHelpers=__webpack_require__(14),exports.ds=__webpack_require__(36),exports.schema=__webpack_require__(5),exports.universes=exports.ds.universesInfo,exports.parser=__webpack_require__(6),exports.expander=__webpack_require__(7),exports.wrapperHelper=__webpack_require__(8),"undefined"==typeof Promise&&"undefined"!=typeof window&&(window.Promise=PromiseConstructor)},function(module,exports,__webpack_require__){"use strict";function determineCompletionKind(text,offset){return search.determineCompletionKind(text,offset)}function enumValues(c,n){return search.enumValues(c,n)}function globalDeclarations(n){return search.globalDeclarations(n)}function qName(n,p){return hlimpl.qName(n,p)}function subTypesWithLocals(t,n){return search.subTypesWithLocals(t,n)}function nodesDeclaringType(t,n){return search.nodesDeclaringType(t,n)}function isExampleNodeContent(n){return search.isExampleNodeContent(n)}function findExampleContentType(n){return search.findExampleContentType(n)}function parseDocumentationContent(n,t){return search.parseDocumentationContent(n,t)}function parseStructuredExample(exampleNode,type){return search.parseStructuredExample(exampleNode,type)}function isExampleNode(node){return search.isExampleNode(node)}function referenceTargets(p0,c){return search.referenceTargets(p0,c)}function findUsages(unit,offset){return search.findUsages(unit,offset)}function findDeclaration(unit,offset,nodePart){return search.findDeclaration(unit,offset,nodePart)}var search=__webpack_require__(24),hlimpl=__webpack_require__(16);!function(LocationKind){LocationKind[LocationKind.VALUE_COMPLETION=0]="VALUE_COMPLETION",LocationKind[LocationKind.KEY_COMPLETION=1]="KEY_COMPLETION",LocationKind[LocationKind.PATH_COMPLETION=2]="PATH_COMPLETION",LocationKind[LocationKind.DIRECTIVE_COMPLETION=3]="DIRECTIVE_COMPLETION",LocationKind[LocationKind.VERSION_COMPLETION=4]="VERSION_COMPLETION",LocationKind[LocationKind.ANNOTATION_COMPLETION=5]="ANNOTATION_COMPLETION",LocationKind[LocationKind.SEQUENCE_KEY_COPLETION=6]="SEQUENCE_KEY_COPLETION",LocationKind[LocationKind.INCOMMENT=7]="INCOMMENT"}(exports.LocationKind||(exports.LocationKind={}));exports.LocationKind;exports.determineCompletionKind=determineCompletionKind,exports.enumValues=enumValues,exports.globalDeclarations=globalDeclarations,exports.qName=qName,exports.subTypesWithLocals=subTypesWithLocals,exports.nodesDeclaringType=nodesDeclaringType,exports.isExampleNodeContent=isExampleNodeContent,exports.findExampleContentType=findExampleContentType,exports.parseDocumentationContent=parseDocumentationContent,exports.parseStructuredExample=parseStructuredExample,exports.isExampleNode=isExampleNode,exports.referenceTargets=referenceTargets,exports.findUsages=findUsages,exports.findDeclaration=findDeclaration},function(module,exports,__webpack_require__){"use strict";function createStubNode(t,p,key,unit){return void 0===key&&(key=null),stubs.createStubNode(t,p,key,unit)}function createStub(parent,property,key){return stubs.createStub(parent,property,key)}function createStubNoParentPatch(parent,property,key){return stubs.createStub0(parent,property,key)}function createResourceStub(parent,key){return stubs.createResourceStub(parent,key)}function createMethodStub(parent,key){return stubs.createMethodStub(parent,key)}function createResponseStub(parent,key){return stubs.createResponseStub(parent,key)}function createBodyStub(parent,key){return stubs.createBodyStub(parent,key)}function createUriParameterStub(parent,key){return stubs.createUriParameterStub(parent,key)}function createQueryParameterStub(parent,key){return stubs.createQueryParameterStub(parent,key)}function createASTPropImpl(node,parent,_def,_prop,fk){return void 0===fk&&(fk=!1),new hlimpl.ASTPropImpl(node,parent,_def,_prop,fk)}function createASTNodeImpl(node,parent,_def,_prop){return new hlimpl.ASTNodeImpl(node,parent,_def,_prop)}function createVirtualASTPropImpl(node,parent,_def,_prop){return new VirtualAttr(node,parent,_def,_prop)}function createVirtualNodeImpl(node,parent,_def,_prop){return new VirtualNode(node,parent,_def,_prop)}function createMapping(name,value){return jsyaml.createMapping(name,value)}function createMap(){return jsyaml.createMap([])}function createAttr(_property,val){return stubs.createAttr(_property,val)}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},hlimpl=__webpack_require__(16),jsyaml=__webpack_require__(28),stubs=__webpack_require__(17);exports.createStubNode=createStubNode,exports.createStub=createStub,exports.createStubNoParentPatch=createStubNoParentPatch,exports.createResourceStub=createResourceStub,exports.createMethodStub=createMethodStub,exports.createResponseStub=createResponseStub,exports.createBodyStub=createBodyStub,exports.createUriParameterStub=createUriParameterStub,exports.createQueryParameterStub=createQueryParameterStub,exports.createASTPropImpl=createASTPropImpl,exports.createASTNodeImpl=createASTNodeImpl,exports.createVirtualASTPropImpl=createVirtualASTPropImpl,exports.createVirtualNodeImpl=createVirtualNodeImpl;var VirtualAttr=function(_super){function VirtualAttr(){_super.apply(this,arguments)}return __extends(VirtualAttr,_super),VirtualAttr.prototype.value=function(){return""},VirtualAttr}(hlimpl.ASTPropImpl),VirtualNode=function(_super){function VirtualNode(){_super.apply(this,arguments)}return __extends(VirtualNode,_super),VirtualNode.prototype.value=function(){return""},VirtualNode}(hlimpl.ASTNodeImpl);exports.createMapping=createMapping,exports.createMap=createMap,exports.createAttr=createAttr},function(module,exports,__webpack_require__){"use strict";function hasAsyncRequests(){return rs.hasAsyncRequests()}function addLoadCallback(x){rs.addLoadCallback(x)}function getTransformerNames(){return expander.getTransformNames()}function getFragmentDefenitionName(node){return hlimpl.getFragmentDefenitionName(node)}function genStructuredValue(name,parent,pr){if(pr.range()instanceof defs.ReferenceType){var mockNode=(pr.range(),jsyaml.createNode(name));return new hlimpl.StructuredValue(mockNode,parent,pr)}return name}function parseUrl(u){return(new linter.UrlParameterNameValidator).parseUrl(u)}var rs=__webpack_require__(29),hlimpl=__webpack_require__(16),defs=__webpack_require__(36),jsyaml=__webpack_require__(28),expander=__webpack_require__(25),linter=__webpack_require__(26),builder=__webpack_require__(27),universes=__webpack_require__(18);exports.hasAsyncRequests=hasAsyncRequests,exports.addLoadCallback=addLoadCallback,exports.getTransformerNames=getTransformerNames,exports.updateType=function(node){var type=builder.doDescrimination(node);null==type&&node.property()&&(type=node.property().range()),type&&node.patchType(type)},exports.getFragmentDefenitionName=getFragmentDefenitionName,exports.genStructuredValue=genStructuredValue,exports.parseUrl=parseUrl;var UnitLink=function(){function UnitLink(node,targetUnitRoot){this.node=node,this.targetUnitRoot=targetUnitRoot}return UnitLink}();exports.UnitLink=UnitLink;var PointOfViewValidationAcceptorImpl=function(){function PointOfViewValidationAcceptorImpl(errors,primaryUnitRoot){this.errors=errors,this.primaryUnitRoot=primaryUnitRoot}return PointOfViewValidationAcceptorImpl.prototype.accept=function(originalIssue){this.transformIssue(originalIssue),this.errors.push(originalIssue)},PointOfViewValidationAcceptorImpl.prototype.transformIssue=function(originalIssue){var _this=this,tailIssueUnit=null,tailIssue=this.findIssueTail(originalIssue);tailIssue.node&&(tailIssueUnit=tailIssue.node.lowLevel().unit());var primaryUnit=this.primaryUnitRoot.lowLevel().unit();if(tailIssueUnit&&primaryUnit&&tailIssueUnit!=primaryUnit){var path=this.findPathToNodeUnit(this.primaryUnitRoot,tailIssue.node);if(path&&path.length>0){var errorStack=path.map(function(connectingNode){return _this.convertConnectingNodeToError(connectingNode,originalIssue)});if(errorStack&&errorStack.length>0)for(var parentIssue=tailIssue,i=errorStack.length-1;i>=0;i--){var currentError=errorStack[i];parentIssue.extras=[],parentIssue.extras.push(currentError),parentIssue=currentError}}}},PointOfViewValidationAcceptorImpl.prototype.begin=function(){},PointOfViewValidationAcceptorImpl.prototype.end=function(){},PointOfViewValidationAcceptorImpl.prototype.acceptUnique=function(issue){for(var _i=0,_a=this.errors;_i<_a.length;_i++){var e=_a[_i];if(e.start==issue.start&&e.message==issue.message)return}this.accept(issue)},PointOfViewValidationAcceptorImpl.prototype.findPathToNodeUnit=function(primaryUnitRoot,nodeToFindPathTo){return nodeToFindPathTo.lowLevel()&&nodeToFindPathTo.lowLevel().unit()?this.findPathToNodeUnitRecursively(primaryUnitRoot,nodeToFindPathTo.lowLevel().unit()):[]},PointOfViewValidationAcceptorImpl.prototype.findPathToNodeUnitRecursively=function(unitRoot,unitToFindPathTo){for(var links=this.findUnitLinks(unitRoot),i=0;i<links.length;i++){var currentLink=links[i];if(currentLink.targetUnitRoot&&currentLink.targetUnitRoot.lowLevel()&&currentLink.targetUnitRoot.lowLevel().unit()==unitToFindPathTo)return[currentLink.node];var subLinkResult=this.findPathToNodeUnitRecursively(currentLink.targetUnitRoot,unitToFindPathTo);if(subLinkResult)return subLinkResult.unshift(currentLink.node),subLinkResult}
return null},PointOfViewValidationAcceptorImpl.prototype.findUnitLinks=function(unitRoot){var result=[];return result=result.concat(this.findMasterLinks(unitRoot))},PointOfViewValidationAcceptorImpl.prototype.findMasterLinks=function(unitRoot){if(!unitRoot.getMaster)return[];var master=unitRoot.getMaster();if(!master)return[];var extendsAttr=unitRoot.asElement().attr(universes.Universe10.Extension.properties["extends"].name);return extendsAttr&&extendsAttr.value()?[new UnitLink(extendsAttr,master)]:[]},PointOfViewValidationAcceptorImpl.prototype.convertConnectingNodeToError=function(connectingNode,originalIssue){if(!connectingNode)return null;var llNode=connectingNode.lowLevel(),st=llNode.start(),et=llNode.end(),message=this.generateLinkMessageByNode(connectingNode,originalIssue);return{code:originalIssue.code,isWarning:originalIssue.isWarning,message:message,node:connectingNode,start:st,end:et,path:llNode.unit()?llNode.unit().path():"",extras:[],unit:llNode.unit()}},PointOfViewValidationAcceptorImpl.prototype.generateLinkMessageByNode=function(connectingNode,originalIssue){return connectingNode.property().nameId()==universes.Universe10.Extension.properties["extends"].name?"Error in the master file: "+originalIssue.message:originalIssue.message},PointOfViewValidationAcceptorImpl.prototype.findIssueTail=function(issue){return issue.extras&&0!=issue.extras.length?this.findIssueTail(issue.extras[0]):issue},PointOfViewValidationAcceptorImpl}();exports.PointOfViewValidationAcceptorImpl=PointOfViewValidationAcceptorImpl},function(module,exports,__webpack_require__){"use strict";function createProject(path,r,h){return new limpl.Project(path,r,h)}var limpl=__webpack_require__(28);exports.createProject=createProject},function(module,exports,__webpack_require__){"use strict";function createSchema(c,u){return su.createSchema(c,new contentprovider.ContentProvider(u))}function getXMLSchema(c){return su.getXMLSchema(c)}function getJSONSchema(c,u){return su.getJSONSchema(c,new contentprovider.ContentProvider(u))}function completeReference(includePath,includeReference,content){return refResolvers.completeReference(includePath,includeReference,content)}function getIncludePath(p){return refResolvers.getIncludePath(p)}function getIncludeReference(p){return refResolvers.getIncludeReference(p)}function createSchemaModelGenerator(){return new schemaGenImpl.SchemaToModelGenerator}function createModelToSchemaGenerator(){return new schemaGenImpl.ModelToSchemaGenerator}var def=__webpack_require__(36),refResolvers=__webpack_require__(30),schemaGenImpl=__webpack_require__(19),contentprovider=__webpack_require__(31),su=def.getSchemaUtils();exports.createSchema=createSchema,exports.getXMLSchema=getXMLSchema,exports.getJSONSchema=getJSONSchema,exports.completeReference=completeReference,exports.getIncludePath=getIncludePath,exports.getIncludeReference=getIncludeReference,exports.createSchemaModelGenerator=createSchemaModelGenerator,exports.createModelToSchemaGenerator=createModelToSchemaGenerator},function(module,exports,__webpack_require__){"use strict";exports.modify=__webpack_require__(20)},function(module,exports,__webpack_require__){"use strict";function expandTraitsAndResourceTypes(api){return ex.expandTraitsAndResourceTypes(api)}var ex=__webpack_require__(25);exports.expandTraitsAndResourceTypes=expandTraitsAndResourceTypes},function(module,exports,__webpack_require__){"use strict";function completeRelativeUri(res){return wh.completeRelativeUri(res)}var wh=__webpack_require__(33);exports.completeRelativeUri=completeRelativeUri},function(module,exports,__webpack_require__){"use strict";function loadApi(apiPath,arg1,arg2){var api=loadRAMLInternal(apiPath,arg1,arg2);return new Opt(api)}function loadRAML(ramlPath,arg1,arg2){var result=loadRAMLInternal(ramlPath,arg1,arg2);return new Opt(result)}function loadRAMLInternal(apiPath,arg1,arg2){var gotArray=Array.isArray(arg1),extensionsAndOverlays=gotArray?arg1:null,options=gotArray?arg2:arg1;options=options||{};var project=getProject(apiPath,options),pr=apiPath.indexOf("://"),unitName=-1!=pr&&6>pr?apiPath:path.basename(apiPath),unit=project.unit(unitName);arg2&&!extensionsAndOverlays&&(extensionsAndOverlays=null);var api;if(unit)if(extensionsAndOverlays&&extensionsAndOverlays.length>0){var extensionUnits=[];extensionsAndOverlays.forEach(function(currentPath){if(!currentPath||0==currentPath.trim().length)throw new Error("Extensions and overlays list should contain legal file paths")}),extensionsAndOverlays.forEach(function(unitPath){extensionUnits.push(project.unit(path.basename(unitPath)))}),extensionUnits.forEach(function(extensionUnit){return toApi(extensionUnit,options)}),api=toApi(expander.mergeAPIs(unit,extensionUnits,hlimpl.OverlayMergeMode.MERGE),options)}else api=toApi(unit,options),api.highLevel().setMergeMode(hlimpl.OverlayMergeMode.MERGE);if(!unit)throw new Error("Can not resolve :"+apiPath);if(options.rejectOnErrors&&api&&api.errors().filter(function(x){return!x.isWarning}).length)throw toError(api);return null!=options.attributeDefaults&&api?api.setAttributeDefaults(options.attributeDefaults):api&&api.setAttributeDefaults(!0),api}function loadApiAsync(apiPath,arg1,arg2){var ramlPromise=loadRAMLAsync(apiPath,arg1,arg2);return ramlPromise.then(function(loadedRaml){return loadedRaml})}function loadRAMLAsync(ramlPath,arg1,arg2){var gotArray=Array.isArray(arg1),extensionsAndOverlays=gotArray?arg1:null,options=gotArray?arg2:arg1;options=options||{};var project=getProject(ramlPath,options),pr=ramlPath.indexOf("://"),unitName=-1!=pr&&6>pr?ramlPath:path.basename(ramlPath);return arg2&&!extensionsAndOverlays&&(extensionsAndOverlays=null),extensionsAndOverlays&&0!=extensionsAndOverlays.length?(extensionsAndOverlays.forEach(function(currentPath){if(!currentPath||0==currentPath.trim().length)throw new Error("Extensions and overlays list should contain legal file paths")}),fetchAndLoadApiAsync(project,unitName,options).then(function(masterApi){var apiPromises=[];return extensionsAndOverlays.forEach(function(extensionUnitPath){apiPromises.push(fetchAndLoadApiAsync(project,path.basename(extensionUnitPath),options))}),Promise.all(apiPromises).then(function(apis){var overlayUnits=[];apis.forEach(function(currentApi){return overlayUnits.push(currentApi.highLevel().lowLevel().unit())});var result=expander.mergeAPIs(masterApi.highLevel().lowLevel().unit(),overlayUnits,hlimpl.OverlayMergeMode.MERGE);return null!=options.attributeDefaults&&result?result.setAttributeDefaults(options.attributeDefaults):result&&result.setAttributeDefaults(!0),result}).then(function(mergedHighLevel){return toApi(mergedHighLevel,options)})})):fetchAndLoadApiAsync(project,unitName,options).then(function(masterApi){return masterApi.highLevel().setMergeMode(hlimpl.OverlayMergeMode.MERGE),null!=options.attributeDefaults&&masterApi?masterApi.setAttributeDefaults(options.attributeDefaults):masterApi&&masterApi.setAttributeDefaults(!0),masterApi})}function getLanguageElementByRuntimeType(runtimeType){if(null==runtimeType)return null;var highLevelNode=runtimeType.getAdapter(ramlServices.RAMLService).getDeclaringNode();return null==highLevelNode?null:highLevelNode.wrapperNode()}function fetchAndLoadApiAsync(project,unitName,options){return llimpl.fetchIncludesAndMasterAsync(project,unitName).then(function(x){try{var api=toApi(x,options);return options.rejectOnErrors&&api&&api.errors().filter(function(x){return!x.isWarning}).length?Promise.reject(toError(api)):api}catch(err){return Promise.reject(err)}})}function getProject(apiPath,options){options=options||{};var includeResolver=options.fsResolver,httpResolver=options.httpResolver,projectRoot=path.dirname(apiPath),project=new jsyaml.Project(projectRoot,includeResolver,httpResolver);return project}function toApi(unitOrHighlevel,options,checkApisOverlays){if(void 0===checkApisOverlays&&(checkApisOverlays=!1),!unitOrHighlevel)return null;var unit=null,highLevel=null;unitOrHighlevel.isRAMLUnit?unit=unitOrHighlevel:(highLevel=unitOrHighlevel,unit=highLevel.lowLevel().unit());var api,contents=unit.contents(),ramlFirstLine=hlimpl.ramlFirstLine(contents);if(!ramlFirstLine)throw new Error("Invalid first line. A RAML document is expected to start with '#%RAML <version> <?fragment type>'.");var typeName,ramlVersion,verStr=ramlFirstLine[1];ramlFirstLine[2];if("0.8"==verStr?ramlVersion="RAML08":"1.0"==verStr&&(ramlVersion="RAML10"),!ramlVersion)throw new Error("Unknown version of RAML expected to see one of '#%RAML 0.8' or '#%RAML 1.0'");if("RAML08"==ramlVersion&&checkApisOverlays)throw new Error("Extensions and overlays are not supported in RAML 0.8.");var universe=universeProvider(ramlVersion);universe.type(typeName);return highLevel||(highLevel=hlimpl.fromUnit(unit)),api=highLevel.wrapperNode()}function toError(api){var error=new Error("Api contains errors.");return error.parserErrors=api.errors(),error}function loadApis1(projectRoot,cacheChildren,expandTraitsAndResourceTypes){void 0===cacheChildren&&(cacheChildren=!1),void 0===expandTraitsAndResourceTypes&&(expandTraitsAndResourceTypes=!0);var universe=universeProvider("RAML10"),apiType=universe.type(universeDef.Universe10.Api.name),p=new jsyaml.Project(projectRoot),result=[];return p.units().forEach(function(x){var lowLevel=x.ast();cacheChildren&&(lowLevel=llimpl.toChildCachingNode(lowLevel));var api=new RamlWrapper1Impl.ApiImpl(new hlimpl.ASTNodeImpl(lowLevel,null,apiType,null));expandTraitsAndResourceTypes&&(api=expander.expandTraitsAndResourceTypes(api)),result.push(api)}),result}var RamlWrapper1Impl=__webpack_require__(21),path=__webpack_require__(15),Opt=__webpack_require__(22),jsyaml=__webpack_require__(28),hlimpl=__webpack_require__(16),llimpl=__webpack_require__(28),expander=__webpack_require__(25),universeDef=__webpack_require__(18),ramlServices=__webpack_require__(34),universeProvider=__webpack_require__(35);exports.loadApi=loadApi,exports.loadRAML=loadRAML,exports.loadApiAsync=loadApiAsync,exports.loadRAMLAsync=loadRAMLAsync,exports.getLanguageElementByRuntimeType=getLanguageElementByRuntimeType,exports.toError=toError,exports.loadApis1=loadApis1},function(module,exports,__webpack_require__){"use strict";function isParseResult(object){return object.asElement&&object.getKind&&object.asAttr&&object.lowLevel}!function(NodeKind){NodeKind[NodeKind.BASIC=0]="BASIC",NodeKind[NodeKind.NODE=1]="NODE",NodeKind[NodeKind.ATTRIBUTE=2]="ATTRIBUTE"}(exports.NodeKind||(exports.NodeKind={}));exports.NodeKind;!function(RAMLVersion){RAMLVersion[RAMLVersion.RAML10=0]="RAML10",RAMLVersion[RAMLVersion.RAML08=1]="RAML08"}(exports.RAMLVersion||(exports.RAMLVersion={}));exports.RAMLVersion;exports.isParseResult=isParseResult,function(IssueCode){IssueCode[IssueCode.UNRESOLVED_REFERENCE=0]="UNRESOLVED_REFERENCE",IssueCode[IssueCode.YAML_ERROR=1]="YAML_ERROR",IssueCode[IssueCode.UNKNOWN_NODE=2]="UNKNOWN_NODE",IssueCode[IssueCode.MISSING_REQUIRED_PROPERTY=3]="MISSING_REQUIRED_PROPERTY",IssueCode[IssueCode.PROPERTY_EXPECT_TO_HAVE_SINGLE_VALUE=4]="PROPERTY_EXPECT_TO_HAVE_SINGLE_VALUE",IssueCode[IssueCode.KEY_SHOULD_BE_UNIQUE_INTHISCONTEXT=5]="KEY_SHOULD_BE_UNIQUE_INTHISCONTEXT",IssueCode[IssueCode.UNABLE_TO_RESOLVE_INCLUDE_FILE=6]="UNABLE_TO_RESOLVE_INCLUDE_FILE",IssueCode[IssueCode.INVALID_VALUE_SCHEMA=7]="INVALID_VALUE_SCHEMA",IssueCode[IssueCode.MISSED_CONTEXT_REQUIREMENT=8]="MISSED_CONTEXT_REQUIREMENT",IssueCode[IssueCode.NODE_HAS_VALUE=9]="NODE_HAS_VALUE",IssueCode[IssueCode.ONLY_OVERRIDE_ALLOWED=10]="ONLY_OVERRIDE_ALLOWED",IssueCode[IssueCode.ILLEGAL_PROPERTY_VALUE=11]="ILLEGAL_PROPERTY_VALUE",IssueCode[IssueCode.ILLEGAL_PROPERTY=12]="ILLEGAL_PROPERTY",IssueCode[IssueCode.INVALID_PROPERTY=13]="INVALID_PROPERTY"}(exports.IssueCode||(exports.IssueCode={}));exports.IssueCode},function(module,exports,__webpack_require__){"use strict";function setAttr(t,value){return new ASTChangeCommand(CommandKind.CHANGE_VALUE,t,value,-1)}function setAttrStructured(t,value){return new ASTChangeCommand(CommandKind.CHANGE_VALUE,t,value.lowLevel(),-1)}function setKey(t,value){return new ASTChangeCommand(CommandKind.CHANGE_KEY,t,value,-1)}function removeNode(t,child){return new ASTChangeCommand(CommandKind.REMOVE_CHILD,t,child,-1)}function insertNode(t,child,insertAfter,toSeq){void 0===insertAfter&&(insertAfter=null),void 0===toSeq&&(toSeq=!1);var s=new ASTChangeCommand(CommandKind.ADD_CHILD,t,child,-1);return s.insertionPoint=insertAfter,s.toSeq=toSeq,s}function initRamlFile(root,newroot){return new ASTChangeCommand(CommandKind.INIT_RAML_FILE,root,newroot,-1)}function buildPath(reference,unitPath,rootPath){if(path.isAbsolute(reference)){var e=path.extname(unitPath);".xsd"!=e&&(reference=reference.substr(1),unitPath=toAbsolutePath(rootPath,path.basename(unitPath)))}return isWebPath(reference)||path.isAbsolute(reference)?reference:isWebPath(unitPath)||path.isAbsolute(unitPath)?toAbsolutePath(path.dirname(unitPath),reference):toAbsolutePath(path.dirname(toAbsolutePath(rootPath,unitPath)),reference)}function toAbsolutePath(context,reference){if(isWebPath(reference))return reference;var apath;if(isWebPath(context)){var rp=util.stringEndsWith(context,"/")?context:context+"/";apath=URL.resolve(rp,reference).replace(/\\/g,"/")}else apath=path.resolve(context,reference).replace(/\\/g,"/");return apath}function isWebPath(reference){return null==reference?!1:util.stringStartsWith(reference,"http://")||util.stringStartsWith(reference,"https://")}function isLowLevelNode(object){return object.start&&object.end&&object.unit&&object.key&&object.value&&object.children&&object.includePath}var path=__webpack_require__(15),URL=__webpack_require__(37),util=__webpack_require__(32),ASTDelta=function(){function ASTDelta(){}return ASTDelta}();exports.ASTDelta=ASTDelta,function(CommandKind){CommandKind[CommandKind.ADD_CHILD=0]="ADD_CHILD",CommandKind[CommandKind.REMOVE_CHILD=1]="REMOVE_CHILD",CommandKind[CommandKind.MOVE_CHILD=2]="MOVE_CHILD",CommandKind[CommandKind.CHANGE_KEY=3]="CHANGE_KEY",CommandKind[CommandKind.CHANGE_VALUE=4]="CHANGE_VALUE",CommandKind[CommandKind.INIT_RAML_FILE=5]="INIT_RAML_FILE"}(exports.CommandKind||(exports.CommandKind={}));var CommandKind=exports.CommandKind,TextChangeCommand=function(){function TextChangeCommand(offset,replacementLength,text,unit,target){void 0===target&&(target=null),this.offset=offset,this.replacementLength=replacementLength,this.text=text,this.unit=unit,this.target=target}return TextChangeCommand}();exports.TextChangeCommand=TextChangeCommand;var CompositeCommand=function(){function CompositeCommand(){this.commands=[]}return CompositeCommand}();exports.CompositeCommand=CompositeCommand,function(InsertionPointType){InsertionPointType[InsertionPointType.NONE=0]="NONE",InsertionPointType[InsertionPointType.START=1]="START",InsertionPointType[InsertionPointType.END=2]="END",InsertionPointType[InsertionPointType.POINT=3]="POINT"}(exports.InsertionPointType||(exports.InsertionPointType={}));var ASTChangeCommand=(exports.InsertionPointType,function(){function ASTChangeCommand(kind,target,value,position){this.toSeq=!1,this.kind=kind,this.target=target,this.value=value,this.position=position}return ASTChangeCommand}());exports.ASTChangeCommand=ASTChangeCommand,exports.setAttr=setAttr,exports.setAttrStructured=setAttrStructured,exports.setKey=setKey,exports.removeNode=removeNode,exports.insertNode=insertNode,exports.initRamlFile=initRamlFile;var LineMapperImpl=function(){function LineMapperImpl(content,absPath){this.content=content,this.absPath=absPath}return LineMapperImpl.prototype.position=function(_pos){var pos=_pos;this.initMapping();for(var i=0;i<this.mapping.length;i++){var lineLength=this.mapping[i];if(lineLength>pos)return{line:i,column:pos,position:_pos};pos-=lineLength}if(0==pos)return{line:this.mapping.length-1,column:this.mapping[this.mapping.length-1],position:this.content.length};if(1==pos)return{line:this.mapping.length-1,column:this.mapping[this.mapping.length-1]-1,position:_pos-1};throw new Error("Character position exceeds text length: "+_pos+" > + "+this.content.length+".\nUnit path: "+this.absPath)},LineMapperImpl.prototype.initMapping=function(){if(null==this.mapping){if(null==this.content)throw new Error("Line Mapper has been given null content"+(null!=this.absPath?". Path: "+this.absPath:" and null path."));this.mapping=[];for(var ind=0,l=this.content.length,i=0;l>i;i++)"\r"==this.content.charAt(i)?l-1>i&&"\n"==this.content.charAt(i+1)?(this.mapping.push(i-ind+2),ind=i+2,i++):(this.mapping.push(i-ind+1),ind=i+1):"\n"==this.content.charAt(i)&&(this.mapping.push(i-ind+1),ind=i+1);this.mapping.push(l-ind)}},LineMapperImpl}();exports.LineMapperImpl=LineMapperImpl,exports.buildPath=buildPath,exports.toAbsolutePath=toAbsolutePath,exports.isWebPath=isWebPath,exports.isLowLevelNode=isLowLevelNode},function(module,exports,__webpack_require__){"use strict";function isApi(node){return"Api"==node.kind()&&"RAML10"==node.RAMLVersion()}function isLibraryBase(node){return"LibraryBase"==node.kind()&&"RAML10"==node.RAMLVersion()}function isAnnotable(node){return"Annotable"==node.kind()&&"RAML10"==node.RAMLVersion()}function isAnnotationRef(node){return"AnnotationRef"==node.kind()&&"RAML10"==node.RAMLVersion()}function isReference(node){return"Reference"==node.kind()&&"RAML10"==node.RAMLVersion()}function isValueType(node){return"ValueType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isStringType(node){return"StringType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isUriTemplate(node){return"UriTemplate"==node.kind()&&"RAML10"==node.RAMLVersion()}function isRelativeUriString(node){return"RelativeUriString"==node.kind()&&"RAML10"==node.RAMLVersion()}function isFullUriTemplateString(node){return"FullUriTemplateString"==node.kind()&&"RAML10"==node.RAMLVersion()}function isStatusCodeString(node){return"StatusCodeString"==node.kind()&&"RAML10"==node.RAMLVersion()}function isFixedUriString(node){return"FixedUriString"==node.kind()&&"RAML10"==node.RAMLVersion()}function isContentType(node){return"ContentType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isMarkdownString(node){return"MarkdownString"==node.kind()&&"RAML10"==node.RAMLVersion()}function isSchemaString(node){return"SchemaString"==node.kind()&&"RAML10"==node.RAMLVersion()}function isMimeType(node){return"MimeType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isAnyType(node){return"AnyType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isNumberType(node){return"NumberType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isIntegerType(node){return"IntegerType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isNullType(node){return"NullType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isTimeOnlyType(node){return"TimeOnlyType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isDateOnlyType(node){return"DateOnlyType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isDateTimeOnlyType(node){return"DateTimeOnlyType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isDateTimeType(node){return"DateTimeType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isFileType(node){return"FileType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isBooleanType(node){return"BooleanType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isAnnotationTarget(node){return"AnnotationTarget"==node.kind()&&"RAML10"==node.RAMLVersion()}function isTraitRef(node){return"TraitRef"==node.kind()&&"RAML10"==node.RAMLVersion()}function isTrait(node){return"Trait"==node.kind()&&"RAML10"==node.RAMLVersion()}function isMethodBase(node){return"MethodBase"==node.kind()&&"RAML10"==node.RAMLVersion()}function isOperation(node){return"Operation"==node.kind()&&"RAML10"==node.RAMLVersion()}function isTypeDeclaration(node){return"TypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isModelLocation(node){return"ModelLocation"==node.kind()&&"RAML10"==node.RAMLVersion()}function isLocationKind(node){return"LocationKind"==node.kind()&&"RAML10"==node.RAMLVersion()}function isExampleSpec(node){return"ExampleSpec"==node.kind()&&"RAML10"==node.RAMLVersion()}function isUsesDeclaration(node){return"UsesDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isXMLFacetInfo(node){return"XMLFacetInfo"==node.kind()&&"RAML10"==node.RAMLVersion()}function isArrayTypeDeclaration(node){return"ArrayTypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isUnionTypeDeclaration(node){return"UnionTypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isObjectTypeDeclaration(node){return"ObjectTypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isStringTypeDeclaration(node){return"StringTypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isBooleanTypeDeclaration(node){return"BooleanTypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isNumberTypeDeclaration(node){return"NumberTypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isIntegerTypeDeclaration(node){return"IntegerTypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isDateOnlyTypeDeclaration(node){return"DateOnlyTypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isTimeOnlyTypeDeclaration(node){return"TimeOnlyTypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isDateTimeOnlyTypeDeclaration(node){return"DateTimeOnlyTypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isDateTimeTypeDeclaration(node){return"DateTimeTypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isFileTypeDeclaration(node){return"FileTypeDeclaration"==node.kind()&&"RAML10"==node.RAMLVersion()}function isResponse(node){return"Response"==node.kind()&&"RAML10"==node.RAMLVersion()}function isSecuritySchemePart(node){return"SecuritySchemePart"==node.kind()&&"RAML10"==node.RAMLVersion()}function isSecuritySchemeRef(node){return"SecuritySchemeRef"==node.kind()&&"RAML10"==node.RAMLVersion()}function isAbstractSecurityScheme(node){return"AbstractSecurityScheme"==node.kind()&&"RAML10"==node.RAMLVersion()}function isSecuritySchemeSettings(node){return"SecuritySchemeSettings"==node.kind()&&"RAML10"==node.RAMLVersion()}function isOAuth1SecuritySchemeSettings(node){return"OAuth1SecuritySchemeSettings"==node.kind()&&"RAML10"==node.RAMLVersion()}function isOAuth2SecuritySchemeSettings(node){return"OAuth2SecuritySchemeSettings"==node.kind()&&"RAML10"==node.RAMLVersion()}function isOAuth2SecurityScheme(node){return"OAuth2SecurityScheme"==node.kind()&&"RAML10"==node.RAMLVersion()}function isOAuth1SecurityScheme(node){return"OAuth1SecurityScheme"==node.kind()&&"RAML10"==node.RAMLVersion()}function isPassThroughSecurityScheme(node){return"PassThroughSecurityScheme"==node.kind()&&"RAML10"==node.RAMLVersion()}function isBasicSecurityScheme(node){return"BasicSecurityScheme"==node.kind()&&"RAML10"==node.RAMLVersion()}function isDigestSecurityScheme(node){return"DigestSecurityScheme"==node.kind()&&"RAML10"==node.RAMLVersion()}function isCustomSecurityScheme(node){return"CustomSecurityScheme"==node.kind()&&"RAML10"==node.RAMLVersion()}function isMethod(node){return"Method"==node.kind()&&"RAML10"==node.RAMLVersion()}function isResourceTypeRef(node){return"ResourceTypeRef"==node.kind()&&"RAML10"==node.RAMLVersion()}function isResourceType(node){return"ResourceType"==node.kind()&&"RAML10"==node.RAMLVersion()}function isResourceBase(node){return"ResourceBase"==node.kind()&&"RAML10"==node.RAMLVersion()}function isResource(node){return"Resource"==node.kind()&&"RAML10"==node.RAMLVersion()}function isDocumentationItem(node){return"DocumentationItem"==node.kind()&&"RAML10"==node.RAMLVersion()}function isLibrary(node){return"Library"==node.kind()&&"RAML10"==node.RAMLVersion()}function isOverlay(node){return"Overlay"==node.kind()&&"RAML10"==node.RAMLVersion()}function isExtension(node){return"Extension"==node.kind()&&"RAML10"==node.RAMLVersion()}function isFragment(node){return null==node.highLevel().parent()}function asFragment(node){return isFragment(node)?node:null}exports.isApi=isApi,exports.isLibraryBase=isLibraryBase,exports.isAnnotable=isAnnotable,exports.isAnnotationRef=isAnnotationRef,exports.isReference=isReference,exports.isValueType=isValueType,exports.isStringType=isStringType,exports.isUriTemplate=isUriTemplate,exports.isRelativeUriString=isRelativeUriString,exports.isFullUriTemplateString=isFullUriTemplateString,exports.isStatusCodeString=isStatusCodeString,exports.isFixedUriString=isFixedUriString,exports.isContentType=isContentType,exports.isMarkdownString=isMarkdownString,exports.isSchemaString=isSchemaString,exports.isMimeType=isMimeType,exports.isAnyType=isAnyType,exports.isNumberType=isNumberType,exports.isIntegerType=isIntegerType,exports.isNullType=isNullType,exports.isTimeOnlyType=isTimeOnlyType,exports.isDateOnlyType=isDateOnlyType,exports.isDateTimeOnlyType=isDateTimeOnlyType,exports.isDateTimeType=isDateTimeType,exports.isFileType=isFileType,exports.isBooleanType=isBooleanType,exports.isAnnotationTarget=isAnnotationTarget,exports.isTraitRef=isTraitRef,exports.isTrait=isTrait,exports.isMethodBase=isMethodBase,exports.isOperation=isOperation,exports.isTypeDeclaration=isTypeDeclaration,exports.isModelLocation=isModelLocation,exports.isLocationKind=isLocationKind,exports.isExampleSpec=isExampleSpec,exports.isUsesDeclaration=isUsesDeclaration,exports.isXMLFacetInfo=isXMLFacetInfo,exports.isArrayTypeDeclaration=isArrayTypeDeclaration,exports.isUnionTypeDeclaration=isUnionTypeDeclaration,exports.isObjectTypeDeclaration=isObjectTypeDeclaration,exports.isStringTypeDeclaration=isStringTypeDeclaration,exports.isBooleanTypeDeclaration=isBooleanTypeDeclaration,exports.isNumberTypeDeclaration=isNumberTypeDeclaration,exports.isIntegerTypeDeclaration=isIntegerTypeDeclaration,exports.isDateOnlyTypeDeclaration=isDateOnlyTypeDeclaration,exports.isTimeOnlyTypeDeclaration=isTimeOnlyTypeDeclaration,exports.isDateTimeOnlyTypeDeclaration=isDateTimeOnlyTypeDeclaration,exports.isDateTimeTypeDeclaration=isDateTimeTypeDeclaration,exports.isFileTypeDeclaration=isFileTypeDeclaration,exports.isResponse=isResponse,exports.isSecuritySchemePart=isSecuritySchemePart,exports.isSecuritySchemeRef=isSecuritySchemeRef,exports.isAbstractSecurityScheme=isAbstractSecurityScheme,exports.isSecuritySchemeSettings=isSecuritySchemeSettings,exports.isOAuth1SecuritySchemeSettings=isOAuth1SecuritySchemeSettings,exports.isOAuth2SecuritySchemeSettings=isOAuth2SecuritySchemeSettings,exports.isOAuth2SecurityScheme=isOAuth2SecurityScheme,exports.isOAuth1SecurityScheme=isOAuth1SecurityScheme,exports.isPassThroughSecurityScheme=isPassThroughSecurityScheme,exports.isBasicSecurityScheme=isBasicSecurityScheme,exports.isDigestSecurityScheme=isDigestSecurityScheme,exports.isCustomSecurityScheme=isCustomSecurityScheme,exports.isMethod=isMethod,exports.isResourceTypeRef=isResourceTypeRef,exports.isResourceType=isResourceType,exports.isResourceBase=isResourceBase,exports.isResource=isResource,exports.isDocumentationItem=isDocumentationItem,exports.isLibrary=isLibrary,exports.isOverlay=isOverlay,exports.isExtension=isExtension,exports.isFragment=isFragment,exports.asFragment=asFragment},function(module,exports,__webpack_require__){"use strict";function isApi(node){return"Api"==node.kind()&&"RAML08"==node.RAMLVersion()}function isFullUriTemplateString(node){return"FullUriTemplateString"==node.kind()&&"RAML08"==node.RAMLVersion()}function isUriTemplate(node){return"UriTemplate"==node.kind()&&"RAML08"==node.RAMLVersion()}function isStringType(node){return"StringType"==node.kind()&&"RAML08"==node.RAMLVersion()}function isValueType(node){return"ValueType"==node.kind()&&"RAML08"==node.RAMLVersion()}function isAnyType(node){return"AnyType"==node.kind()&&"RAML08"==node.RAMLVersion()}function isNumberType(node){return"NumberType"==node.kind()&&"RAML08"==node.RAMLVersion()}function isBooleanType(node){return"BooleanType"==node.kind()&&"RAML08"==node.RAMLVersion()}function isReference(node){return"Reference"==node.kind()&&"RAML08"==node.RAMLVersion()}function isResourceTypeRef(node){return"ResourceTypeRef"==node.kind()&&"RAML08"==node.RAMLVersion()}function isResourceType(node){return"ResourceType"==node.kind()&&"RAML08"==node.RAMLVersion()}function isMethod(node){return"Method"==node.kind()&&"RAML08"==node.RAMLVersion()}function isMethodBase(node){return"MethodBase"==node.kind()&&"RAML08"==node.RAMLVersion()}function isResponse(node){return"Response"==node.kind()&&"RAML08"==node.RAMLVersion()}function isStatusCodeString(node){return"StatusCodeString"==node.kind()&&"RAML08"==node.RAMLVersion()}function isParameter(node){return"Parameter"==node.kind()&&"RAML08"==node.RAMLVersion()}function isParameterLocation(node){return"ParameterLocation"==node.kind()&&"RAML08"==node.RAMLVersion()}function isMarkdownString(node){return"MarkdownString"==node.kind()&&"RAML08"==node.RAMLVersion()}function isStringTypeDeclaration(node){return"StringTypeDeclaration"==node.kind()&&"RAML08"==node.RAMLVersion()}function isBooleanTypeDeclaration(node){return"BooleanTypeDeclaration"==node.kind()&&"RAML08"==node.RAMLVersion()}function isNumberTypeDeclaration(node){return"NumberTypeDeclaration"==node.kind()&&"RAML08"==node.RAMLVersion()}function isIntegerTypeDeclaration(node){return"IntegerTypeDeclaration"==node.kind()&&"RAML08"==node.RAMLVersion()}function isDateTypeDeclaration(node){return"DateTypeDeclaration"==node.kind()&&"RAML08"==node.RAMLVersion()}function isFileTypeDeclaration(node){return"FileTypeDeclaration"==node.kind()&&"RAML08"==node.RAMLVersion()}function isBodyLike(node){return"BodyLike"==node.kind()&&"RAML08"==node.RAMLVersion()}function isSchemaString(node){return"SchemaString"==node.kind()&&"RAML08"==node.RAMLVersion()}function isJSonSchemaString(node){return"JSonSchemaString"==node.kind()&&"RAML08"==node.RAMLVersion()}function isXMLSchemaString(node){return"XMLSchemaString"==node.kind()&&"RAML08"==node.RAMLVersion()}function isExampleString(node){return"ExampleString"==node.kind()&&"RAML08"==node.RAMLVersion()}function isJSONExample(node){return"JSONExample"==node.kind()&&"RAML08"==node.RAMLVersion()}function isXMLExample(node){return"XMLExample"==node.kind()&&"RAML08"==node.RAMLVersion()}function isXMLBody(node){return"XMLBody"==node.kind()&&"RAML08"==node.RAMLVersion()}function isJSONBody(node){return"JSONBody"==node.kind()&&"RAML08"==node.RAMLVersion()}function isSecuritySchemeRef(node){return"SecuritySchemeRef"==node.kind()&&"RAML08"==node.RAMLVersion()}function isAbstractSecurityScheme(node){return"AbstractSecurityScheme"==node.kind()&&"RAML08"==node.RAMLVersion()}function isSecuritySchemePart(node){return"SecuritySchemePart"==node.kind()&&"RAML08"==node.RAMLVersion()}function isTraitRef(node){return"TraitRef"==node.kind()&&"RAML08"==node.RAMLVersion()}function isTrait(node){return"Trait"==node.kind()&&"RAML08"==node.RAMLVersion()}function isSecuritySchemeSettings(node){return"SecuritySchemeSettings"==node.kind()&&"RAML08"==node.RAMLVersion()}function isOAuth1SecuritySchemeSettings(node){return"OAuth1SecuritySchemeSettings"==node.kind()&&"RAML08"==node.RAMLVersion()}function isFixedUri(node){return"FixedUri"==node.kind()&&"RAML08"==node.RAMLVersion()}function isOAuth2SecuritySchemeSettings(node){return"OAuth2SecuritySchemeSettings"==node.kind()&&"RAML08"==node.RAMLVersion()}function isOAuth2SecurityScheme(node){return"OAuth2SecurityScheme"==node.kind()&&"RAML08"==node.RAMLVersion()}function isOAuth1SecurityScheme(node){return"OAuth1SecurityScheme"==node.kind()&&"RAML08"==node.RAMLVersion()}function isBasicSecurityScheme(node){return"BasicSecurityScheme"==node.kind()&&"RAML08"==node.RAMLVersion()}function isDigestSecurityScheme(node){return"DigestSecurityScheme"==node.kind()&&"RAML08"==node.RAMLVersion()}function isCustomSecurityScheme(node){return"CustomSecurityScheme"==node.kind()&&"RAML08"==node.RAMLVersion()}function isMimeType(node){return"MimeType"==node.kind()&&"RAML08"==node.RAMLVersion()}function isRelativeUriString(node){return"RelativeUriString"==node.kind()&&"RAML08"==node.RAMLVersion();
}function isGlobalSchema(node){return"GlobalSchema"==node.kind()&&"RAML08"==node.RAMLVersion()}function isRAMLSimpleElement(node){return"RAMLSimpleElement"==node.kind()&&"RAML08"==node.RAMLVersion()}function isDocumentationItem(node){return"DocumentationItem"==node.kind()&&"RAML08"==node.RAMLVersion()}function isResource(node){return"Resource"==node.kind()&&"RAML08"==node.RAMLVersion()}exports.isApi=isApi,exports.isFullUriTemplateString=isFullUriTemplateString,exports.isUriTemplate=isUriTemplate,exports.isStringType=isStringType,exports.isValueType=isValueType,exports.isAnyType=isAnyType,exports.isNumberType=isNumberType,exports.isBooleanType=isBooleanType,exports.isReference=isReference,exports.isResourceTypeRef=isResourceTypeRef,exports.isResourceType=isResourceType,exports.isMethod=isMethod,exports.isMethodBase=isMethodBase,exports.isResponse=isResponse,exports.isStatusCodeString=isStatusCodeString,exports.isParameter=isParameter,exports.isParameterLocation=isParameterLocation,exports.isMarkdownString=isMarkdownString,exports.isStringTypeDeclaration=isStringTypeDeclaration,exports.isBooleanTypeDeclaration=isBooleanTypeDeclaration,exports.isNumberTypeDeclaration=isNumberTypeDeclaration,exports.isIntegerTypeDeclaration=isIntegerTypeDeclaration,exports.isDateTypeDeclaration=isDateTypeDeclaration,exports.isFileTypeDeclaration=isFileTypeDeclaration,exports.isBodyLike=isBodyLike,exports.isSchemaString=isSchemaString,exports.isJSonSchemaString=isJSonSchemaString,exports.isXMLSchemaString=isXMLSchemaString,exports.isExampleString=isExampleString,exports.isJSONExample=isJSONExample,exports.isXMLExample=isXMLExample,exports.isXMLBody=isXMLBody,exports.isJSONBody=isJSONBody,exports.isSecuritySchemeRef=isSecuritySchemeRef,exports.isAbstractSecurityScheme=isAbstractSecurityScheme,exports.isSecuritySchemePart=isSecuritySchemePart,exports.isTraitRef=isTraitRef,exports.isTrait=isTrait,exports.isSecuritySchemeSettings=isSecuritySchemeSettings,exports.isOAuth1SecuritySchemeSettings=isOAuth1SecuritySchemeSettings,exports.isFixedUri=isFixedUri,exports.isOAuth2SecuritySchemeSettings=isOAuth2SecuritySchemeSettings,exports.isOAuth2SecurityScheme=isOAuth2SecurityScheme,exports.isOAuth1SecurityScheme=isOAuth1SecurityScheme,exports.isBasicSecurityScheme=isBasicSecurityScheme,exports.isDigestSecurityScheme=isDigestSecurityScheme,exports.isCustomSecurityScheme=isCustomSecurityScheme,exports.isMimeType=isMimeType,exports.isRelativeUriString=isRelativeUriString,exports.isGlobalSchema=isGlobalSchema,exports.isRAMLSimpleElement=isRAMLSimpleElement,exports.isDocumentationItem=isDocumentationItem,exports.isResource=isResource},function(module,exports,__webpack_require__){"use strict";function isDocumentationProperty(p){return p.nameId()===universe.Universe10.Api.properties.documentation.name||p.nameId()===universe.Universe08.Api.properties.documentation.name}function isUsagePropertyName(name){return name===universe.Universe10.Trait.properties.usage.name||name===universe.Universe08.Trait.properties.usage.name||name===universe.Universe10.ResourceType.properties.usage.name||name===universe.Universe08.ResourceType.properties.usage.name||name===universe.Universe10.Library.properties.usage.name||name===universe.Universe10.Overlay.properties.usage.name||name===universe.Universe10.Extension.properties.usage.name}function isUsageProperty(p){return isUsagePropertyName(p.nameId())}function isMasterRefProperty(p){return p.nameId()==universe.Universe10.Overlay.properties["extends"].name||p.nameId()==universe.Universe10.Extension.properties["extends"].name}function isDescriptionPropertyName(name){return name===universe.Universe10.TypeDeclaration.properties.description.name||"description"===name}function isDescriptionProperty(p){return isDescriptionPropertyName(p.nameId())}function isRequiredPropertyName(name){return name===universe.Universe10.TypeDeclaration.properties.required.name||name===universe.Universe08.Parameter.properties.required.name||"required"===name}function isDisplayNamePropertyName(name){return name===universe.Universe10.TypeDeclaration.properties.displayName.name||"displayName"===name}function isDisplayNameProperty(p){return isDisplayNamePropertyName(p.nameId())}function isRequiredProperty(p){return isRequiredPropertyName(p.nameId())}function isTitlePropertyName(name){return name===universe.Universe10.Api.properties.title.name||name===universe.Universe08.Api.properties.title.name||name===universe.Universe10.DocumentationItem.properties.title.name||name===universe.Universe08.DocumentationItem.properties.title.name||name===universe.Universe10.Overlay.properties.title.name||name===universe.Universe10.Extension.properties.title.name}function isTitleProperty(p){return isTitlePropertyName(p.nameId())}function isHeadersProperty(p){return isHeadersPropertyName(p.nameId())}function isHeadersPropertyName(name){return name===universe.Universe08.MethodBase.properties.headers.name||name===universe.Universe08.Response.properties.headers.name||name===universe.Universe08.SecuritySchemePart.properties.headers.name||name===universe.Universe10.MethodBase.properties.headers.name||name===universe.Universe10.Response.properties.headers.name}function isFormParametersProperty(p){return isFormParametersPropertyName(p.nameId())}function isFormParametersPropertyName(name){return name===universe.Universe08.BodyLike.properties.formParameters.name}function isQueryParametersProperty(p){return isQueryParametersPropertyName(p.nameId())}function isQueryParametersPropertyName(name){return name===universe.Universe08.MethodBase.properties.queryParameters.name||name===universe.Universe08.SecuritySchemePart.properties.queryParameters.name||name===universe.Universe10.MethodBase.properties.queryParameters.name}function isAnnotationsProperty(p){return p.nameId()===universe.Universe10.Api.properties.annotations.name||p.nameId()===universe.Universe10.TypeDeclaration.properties.annotations.name||p.nameId()===universe.Universe10.Response.properties.annotations.name}function isAnnotationProperty(p){return p.nameId()===universe.Universe10.AnnotationRef.properties.annotation.name}function isIsProperty(p){return p.nameId()===universe.Universe10.MethodBase.properties.is.name||p.nameId()===universe.Universe08.Method.properties.is.name||p.nameId()===universe.Universe10.ResourceBase.properties.is.name||p.nameId()===universe.Universe08.ResourceType.properties.is.name||p.nameId()===universe.Universe08.Resource.properties.is.name}function isSecuredByProperty(p){return p.nameId()===universe.Universe10.Api.properties.securedBy.name||p.nameId()===universe.Universe08.Api.properties.securedBy.name||p.nameId()===universe.Universe10.MethodBase.properties.securedBy.name||p.nameId()===universe.Universe08.MethodBase.properties.securedBy.name||p.nameId()===universe.Universe08.ResourceType.properties.securedBy.name||p.nameId()===universe.Universe08.Resource.properties.securedBy.name||p.nameId()===universe.Universe10.ResourceBase.properties.securedBy.name}function isSecuritySchemesProperty(p){return p.nameId()===universe.Universe10.LibraryBase.properties.securitySchemes.name||p.nameId()===universe.Universe08.Api.properties.securitySchemes.name}function isSecuritySchemeProperty(p){return p.nameId()===universe.Universe10.SecuritySchemeRef.properties.securityScheme.name||p.nameId()===universe.Universe08.SecuritySchemeRef.properties.securityScheme.name}function isTypeProperty(p){return p.nameId()===universe.Universe10.AbstractSecurityScheme.properties.type.name||p.nameId()===universe.Universe08.AbstractSecurityScheme.properties.type.name||p.nameId()===universe.Universe08.ResourceType.properties.type.name||p.nameId()===universe.Universe08.Resource.properties.type.name||p.nameId()===universe.Universe08.Parameter.properties.type.name||p.nameId()===universe.Universe10.ResourceBase.properties.type.name||p.nameId()===universe.Universe10.TypeDeclaration.properties.type.name}function isPropertiesProperty(p){return p.nameId()===universe.Universe10.ObjectTypeDeclaration.properties.properties.name}function isResponsesProperty(p){return p.nameId()===universe.Universe10.MethodBase.properties.responses.name||p.nameId()===universe.Universe08.MethodBase.properties.responses.name}function isProtocolsProperty(p){return p.nameId()===universe.Universe10.Api.properties.protocols.name||p.nameId()===universe.Universe08.Api.properties.protocols.name||p.nameId()===universe.Universe10.MethodBase.properties.protocols.name}function isNameProperty(p){return p.nameId()===universe.Universe10.TypeDeclaration.properties.name.name||p.nameId()===universe.Universe10.TypeDeclaration.properties.name.name||p.nameId()===universe.Universe08.AbstractSecurityScheme.properties.name.name||p.nameId()===universe.Universe10.AbstractSecurityScheme.properties.name.name||p.nameId()===universe.Universe08.Trait.properties.name.name||p.nameId()===universe.Universe10.Trait.properties.name.name||"name"===p.nameId()}function isBodyProperty(p){return p.nameId()===universe.Universe10.MethodBase.properties.body.name||p.nameId()===universe.Universe08.MethodBase.properties.body.name||p.nameId()===universe.Universe10.Response.properties.body.name||p.nameId()===universe.Universe08.Response.properties.body.name}function isDefaultValue(p){return p.nameId()===universe.Universe10.TypeDeclaration.properties["default"].name||p.nameId()===universe.Universe08.Parameter.properties["default"].name}function isSchemaProperty(p){return p.nameId()===universe.Universe08.BodyLike.properties.schema.name||p.nameId()===universe.Universe08.XMLBody.properties.schema.name||p.nameId()===universe.Universe08.JSONBody.properties.schema.name||p.nameId()===universe.Universe10.TypeDeclaration.properties.schema.name}function isTraitsProperty(p){return p.nameId()===universe.Universe08.Api.properties.traits.name||p.nameId()===universe.Universe10.LibraryBase.properties.traits.name}function isTraitProperty(p){return p.nameId()===universe.Universe08.TraitRef.properties.trait.name||p.nameId()===universe.Universe10.TraitRef.properties.trait.name}function isResourceTypesProperty(p){return p.nameId()===universe.Universe08.Api.properties.resourceTypes.name||p.nameId()===universe.Universe10.LibraryBase.properties.resourceTypes.name}function isResourceTypeProperty(p){return p.nameId()===universe.Universe08.ResourceTypeRef.properties.resourceType.name||p.nameId()===universe.Universe10.ResourceTypeRef.properties.resourceType.name}function isFacetsProperty(p){return p.nameId()===universe.Universe10.TypeDeclaration.properties.facets.name}function isSchemasProperty(p){return p.nameId()===universe.Universe08.Api.properties.schemas.name||p.nameId()===universe.Universe10.LibraryBase.properties.schemas.name}function isResourcesProperty(p){return p.nameId()===universe.Universe10.Api.properties.resources.name||p.nameId()===universe.Universe08.Api.properties.resources.name||p.nameId()===universe.Universe10.Resource.properties.resources.name||p.nameId()===universe.Universe08.Resource.properties.resources.name}function isMethodsProperty(p){return p.nameId()===universe.Universe10.ResourceBase.properties.methods.name||p.nameId()===universe.Universe08.Resource.properties.methods.name||p.nameId()===universe.Universe08.ResourceType.properties.methods.name}function isTypesProperty(p){return p.nameId()===universe.Universe10.LibraryBase.properties.types.name}function isExampleProperty(p){return p.nameId()===universe.Universe10.TypeDeclaration.properties.example.name||"example"===p.nameId()}function isEnumProperty(p){return p.nameId()===universe.Universe10.StringTypeDeclaration.properties["enum"].name||p.nameId()===universe.Universe10.NumberTypeDeclaration.properties["enum"].name||p.nameId()===universe.Universe08.StringTypeDeclaration.properties["enum"].name}function isExamplesProperty(p){return p.nameId()===universe.Universe10.TypeDeclaration.properties.example.name||p.nameId()===universe.Universe10.TypeDeclaration.properties.examples.name}function isValueProperty(p){return p.nameId()===universe.Universe08.GlobalSchema.properties.value.name}function isUriParametersProperty(p){return p.nameId()===universe.Universe08.Api.properties.uriParameters.name||p.nameId()===universe.Universe08.ResourceType.properties.uriParameters.name||p.nameId()===universe.Universe08.Resource.properties.uriParameters.name||p.nameId()===universe.Universe10.ResourceBase.properties.uriParameters.name}function isBaseUriParametersProperty(p){return p.nameId()===universe.Universe08.Resource.properties.baseUriParameters.name||p.nameId()===universe.Universe08.Api.properties.baseUriParameters.name||p.nameId()===universe.Universe10.Api.properties.baseUriParameters.name}function isRAMLVersionProperty(p){return p.nameId()===universe.Universe08.Api.properties.RAMLVersion.name||p.nameId()===universe.Universe10.Api.properties.RAMLVersion.name}function isUsesProperty(p){return p.nameId()===universe.Universe10.FragmentDeclaration.properties.uses.name}function isAnnotationTypesProperty(p){return p.nameId()===universe.Universe10.LibraryBase.properties.annotationTypes.name}function isMethodType(type){return type.key()==universe.Universe10.Method||type.key()==universe.Universe08.Method}function isApiType(type){return type.key()==universe.Universe10.Api||type.key()==universe.Universe08.Api}function isBooleanTypeType(type){return type.key()==universe.Universe10.BooleanType||type.key()==universe.Universe08.BooleanType}function isMarkdownStringType(type){return type.key()==universe.Universe10.MarkdownString||type.key()==universe.Universe08.MarkdownString}function isResourceType(type){return type.key()==universe.Universe10.Resource||type.key()==universe.Universe08.Resource}function isTraitType(type){return type.key()==universe.Universe10.Trait||type.key()==universe.Universe08.Trait}function isTraitRefType(type){return type.key()==universe.Universe10.TraitRef||type.key()==universe.Universe08.TraitRef}function isResourceTypeRefType(type){return type.key()==universe.Universe10.ResourceTypeRef||type.key()==universe.Universe08.ResourceTypeRef}function isGlobalSchemaType(type){return type.key()==universe.Universe08.GlobalSchema}function isSecuritySchemaType(type){return type.key()==universe.Universe10.AbstractSecurityScheme||type.key()==universe.Universe08.AbstractSecurityScheme}function isSecuritySchemaTypeDescendant(type){return type.isAssignableFrom(universe.Universe10.AbstractSecurityScheme.name)}function isSecuritySchemeRefType(type){return type.key()==universe.Universe10.SecuritySchemeRef||type.key()==universe.Universe08.SecuritySchemeRef}function isTypeDeclarationType(type){return type.key()==universe.Universe10.TypeDeclaration}function isResponseType(type){return type.key()==universe.Universe10.Response||type.key()==universe.Universe08.Response}function isBodyLikeType(type){return type.key()==universe.Universe08.BodyLike}function isOverlayType(type){return type.key()==universe.Universe10.Overlay}function isAnnotationTypeType(type){return!1}function isResourceTypeType(type){return type.key()==universe.Universe10.ResourceType||type.key()==universe.Universe08.ResourceType}function isSchemaStringType(type){return type.key()==universe.Universe10.SchemaString||type.key()==universe.Universe08.SchemaString}function isMethodBaseType(type){return type.key()==universe.Universe10.MethodBase||type.key()==universe.Universe08.MethodBase}function isLibraryType(type){return type.key()==universe.Universe10.Library}function isStringTypeType(type){return type.key()==universe.Universe10.StringType||type.key()==universe.Universe08.StringType}function isExampleSpecType(type){return type.key()==universe.Universe10.ExampleSpec}function isExtensionType(type){return type.key()==universe.Universe10.Extension}function isTypeDeclarationTypeOrDescendant(type){return type.isAssignableFrom(universe.Universe10.TypeDeclaration.name)}function isDocumentationType(type){return type.key()==universe.Universe10.DocumentationItem||type.key()==universe.Universe08.DocumentationItem}function isAnnotationRefTypeOrDescendant(type){return type.isAssignableFrom(universe.Universe10.AnnotationRef.name)}function isApiSibling(type){return type.isAssignableFrom(universe.Universe10.Api.name)||type.isAssignableFrom(universe.Universe08.Api.name)}function isLibraryBaseSibling(type){return type.isAssignableFrom(universe.Universe10.LibraryBase.name)}function isResourceBaseSibling(type){return type.isAssignableFrom(universe.Universe10.ResourceBase.name)||type.isAssignableFrom(universe.Universe08.Resource.name)}function isObjectTypeDeclarationSibling(type){return type.isAssignableFrom(universe.Universe10.ObjectTypeDeclaration.name)}function isTypeDeclarationDescendant(type){return type.isAssignableFrom(universe.Universe10.TypeDeclaration.name)}function isTypeDeclarationSibling(type){return type.isAssignableFrom(universe.Universe10.TypeDeclaration.name)}function isMethodBaseSibling(type){return type.isAssignableFrom(universe.Universe10.MethodBase.name)||type.isAssignableFrom(universe.Universe08.MethodBase.name)}function isSecuritySchemePartType(type){return type.key()==universe.Universe10.SecuritySchemePart||type.key()==universe.Universe08.SecuritySchemePart}function isMediaTypeProperty(p){return p.nameId()===universe.Universe08.Api.properties.mediaType.name||p.nameId()===universe.Universe10.Api.properties.mediaType.name}function isRAML08Type(type){return"RAML08"==type.universe().version()}function isRAML10Type(type){return"RAML10"==type.universe().version()}function isRAML08Node(node){return isRAML08Type(node.definition())}function isRAML08Attribute(node){return isRAML08Type(node.definition())}function isRAML10Node(node){return isRAML10Type(node.definition())}function isRAML10Attribute(node){return isRAML10Type(node.definition())}var universe=__webpack_require__(18);exports.isDocumentationProperty=isDocumentationProperty,exports.isUsagePropertyName=isUsagePropertyName,exports.isUsageProperty=isUsageProperty,exports.isMasterRefProperty=isMasterRefProperty,exports.isDescriptionPropertyName=isDescriptionPropertyName,exports.isDescriptionProperty=isDescriptionProperty,exports.isRequiredPropertyName=isRequiredPropertyName,exports.isDisplayNamePropertyName=isDisplayNamePropertyName,exports.isDisplayNameProperty=isDisplayNameProperty,exports.isRequiredProperty=isRequiredProperty,exports.isTitlePropertyName=isTitlePropertyName,exports.isTitleProperty=isTitleProperty,exports.isHeadersProperty=isHeadersProperty,exports.isHeadersPropertyName=isHeadersPropertyName,exports.isFormParametersProperty=isFormParametersProperty,exports.isFormParametersPropertyName=isFormParametersPropertyName,exports.isQueryParametersProperty=isQueryParametersProperty,exports.isQueryParametersPropertyName=isQueryParametersPropertyName,exports.isAnnotationsProperty=isAnnotationsProperty,exports.isAnnotationProperty=isAnnotationProperty,exports.isIsProperty=isIsProperty,exports.isSecuredByProperty=isSecuredByProperty,exports.isSecuritySchemesProperty=isSecuritySchemesProperty,exports.isSecuritySchemeProperty=isSecuritySchemeProperty,exports.isTypeProperty=isTypeProperty,exports.isPropertiesProperty=isPropertiesProperty,exports.isResponsesProperty=isResponsesProperty,exports.isProtocolsProperty=isProtocolsProperty,exports.isNameProperty=isNameProperty,exports.isBodyProperty=isBodyProperty,exports.isDefaultValue=isDefaultValue,exports.isSchemaProperty=isSchemaProperty,exports.isTraitsProperty=isTraitsProperty,exports.isTraitProperty=isTraitProperty,exports.isResourceTypesProperty=isResourceTypesProperty,exports.isResourceTypeProperty=isResourceTypeProperty,exports.isFacetsProperty=isFacetsProperty,exports.isSchemasProperty=isSchemasProperty,exports.isResourcesProperty=isResourcesProperty,exports.isMethodsProperty=isMethodsProperty,exports.isTypesProperty=isTypesProperty,exports.isExampleProperty=isExampleProperty,exports.isEnumProperty=isEnumProperty,exports.isExamplesProperty=isExamplesProperty,exports.isValueProperty=isValueProperty,exports.isUriParametersProperty=isUriParametersProperty,exports.isBaseUriParametersProperty=isBaseUriParametersProperty,exports.isRAMLVersionProperty=isRAMLVersionProperty,exports.isUsesProperty=isUsesProperty,exports.isAnnotationTypesProperty=isAnnotationTypesProperty,exports.isMethodType=isMethodType,exports.isApiType=isApiType,exports.isBooleanTypeType=isBooleanTypeType,exports.isMarkdownStringType=isMarkdownStringType,exports.isResourceType=isResourceType,exports.isTraitType=isTraitType,exports.isTraitRefType=isTraitRefType,exports.isResourceTypeRefType=isResourceTypeRefType,exports.isGlobalSchemaType=isGlobalSchemaType,exports.isSecuritySchemaType=isSecuritySchemaType,exports.isSecuritySchemaTypeDescendant=isSecuritySchemaTypeDescendant,exports.isSecuritySchemeRefType=isSecuritySchemeRefType,exports.isTypeDeclarationType=isTypeDeclarationType,exports.isResponseType=isResponseType,exports.isBodyLikeType=isBodyLikeType,exports.isOverlayType=isOverlayType,exports.isAnnotationTypeType=isAnnotationTypeType,exports.isResourceTypeType=isResourceTypeType,exports.isSchemaStringType=isSchemaStringType,exports.isMethodBaseType=isMethodBaseType,exports.isLibraryType=isLibraryType,exports.isStringTypeType=isStringTypeType,exports.isExampleSpecType=isExampleSpecType,exports.isExtensionType=isExtensionType,exports.isTypeDeclarationTypeOrDescendant=isTypeDeclarationTypeOrDescendant,exports.isDocumentationType=isDocumentationType,exports.isAnnotationRefTypeOrDescendant=isAnnotationRefTypeOrDescendant,exports.isApiSibling=isApiSibling,exports.isLibraryBaseSibling=isLibraryBaseSibling,exports.isResourceBaseSibling=isResourceBaseSibling,exports.isObjectTypeDeclarationSibling=isObjectTypeDeclarationSibling,exports.isTypeDeclarationDescendant=isTypeDeclarationDescendant,exports.isTypeDeclarationSibling=isTypeDeclarationSibling,exports.isMethodBaseSibling=isMethodBaseSibling,exports.isSecuritySchemePartType=isSecuritySchemePartType,exports.isMediaTypeProperty=isMediaTypeProperty,exports.isRAML08Type=isRAML08Type,exports.isRAML10Type=isRAML10Type,exports.isRAML08Node=isRAML08Node,exports.isRAML08Attribute=isRAML08Attribute,exports.isRAML10Node=isRAML10Node,exports.isRAML10Attribute=isRAML10Attribute},function(module,exports,__webpack_require__){(function(process){function normalizeArray(parts,allowAboveRoot){for(var up=0,i=parts.length-1;i>=0;i--){var last=parts[i];"."===last?parts.splice(i,1):".."===last?(parts.splice(i,1),up++):up&&(parts.splice(i,1),up--)}if(allowAboveRoot)for(;up--;up)parts.unshift("..");return parts}function filter(xs,f){if(xs.filter)return xs.filter(f);for(var res=[],i=0;i<xs.length;i++)f(xs[i],i,xs)&&res.push(xs[i]);return res}var splitPathRe=/^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/,splitPath=function(filename){return splitPathRe.exec(filename).slice(1)};exports.resolve=function(){for(var resolvedPath="",resolvedAbsolute=!1,i=arguments.length-1;i>=-1&&!resolvedAbsolute;i--){var path=i>=0?arguments[i]:process.cwd();if("string"!=typeof path)throw new TypeError("Arguments to path.resolve must be strings");path&&(resolvedPath=path+"/"+resolvedPath,resolvedAbsolute="/"===path.charAt(0))}return resolvedPath=normalizeArray(filter(resolvedPath.split("/"),function(p){return!!p}),!resolvedAbsolute).join("/"),(resolvedAbsolute?"/":"")+resolvedPath||"."},exports.normalize=function(path){var isAbsolute=exports.isAbsolute(path),trailingSlash="/"===substr(path,-1);return path=normalizeArray(filter(path.split("/"),function(p){return!!p}),!isAbsolute).join("/"),path||isAbsolute||(path="."),path&&trailingSlash&&(path+="/"),(isAbsolute?"/":"")+path},exports.isAbsolute=function(path){return"/"===path.charAt(0)},exports.join=function(){var paths=Array.prototype.slice.call(arguments,0);return exports.normalize(filter(paths,function(p,index){if("string"!=typeof p)throw new TypeError("Arguments to path.join must be strings");return p}).join("/"))},exports.relative=function(from,to){function trim(arr){for(var start=0;start<arr.length&&""===arr[start];start++);for(var end=arr.length-1;end>=0&&""===arr[end];end--);return start>end?[]:arr.slice(start,end-start+1)}from=exports.resolve(from).substr(1),to=exports.resolve(to).substr(1);for(var fromParts=trim(from.split("/")),toParts=trim(to.split("/")),length=Math.min(fromParts.length,toParts.length),samePartsLength=length,i=0;length>i;i++)if(fromParts[i]!==toParts[i]){samePartsLength=i;break}for(var outputParts=[],i=samePartsLength;i<fromParts.length;i++)outputParts.push("..");return outputParts=outputParts.concat(toParts.slice(samePartsLength)),outputParts.join("/")},exports.sep="/",exports.delimiter=":",exports.dirname=function(path){var result=splitPath(path),root=result[0],dir=result[1];return root||dir?(dir&&(dir=dir.substr(0,dir.length-1)),root+dir):"."},exports.basename=function(path,ext){var f=splitPath(path)[2];return ext&&f.substr(-1*ext.length)===ext&&(f=f.substr(0,f.length-ext.length)),f},exports.extname=function(path){return splitPath(path)[3]};var substr="b"==="ab".substr(-1)?function(str,start,len){return str.substr(start,len)}:function(str,start,len){return 0>start&&(start=str.length+start),str.substr(start,len)}}).call(exports,__webpack_require__(59))},function(module,exports,__webpack_require__){"use strict";function qName(x,context){var nm=x.name();if(context.lowLevel()instanceof proxy.LowLevelProxyNode){if(x.lowLevel()instanceof proxy.LowLevelProxyNode)return nm;var rootUnit=context.root().lowLevel().unit(),resolver=rootUnit.project().namespaceResolver(),unit=x.lowLevel().unit(),ns=resolver.resolveNamespace(rootUnit,unit);if(null!=ns)return ns+"."+nm}if(x.lowLevel().unit()!=context.lowLevel().unit())for(var root=context;;){if(root.lowLevel().includePath()||null==root.parent()){root.unitMap||(root.unitMap={},root.asElement().elements().forEach(function(x){if(x.definition().key()==universes.Universe10.UsesDeclaration){var mm=x.attr("value");if(mm){var unit=x.root().lowLevel().unit().resolve(mm.value());if(null!=unit){var key=x.attr("key");key&&(root.unitMap[unit.absolutePath()]=key.value())}}}}));var prefix=root.unitMap[x.lowLevel().unit().absolutePath()];if(prefix)return prefix+"."+nm}if(!root.parent())break;root=root.parent()}return nm}function ramlFirstLine(content){return content.match(/^\s*#%RAML\s+(\d\.\d)\s*(\w*)\s*$/m)}function getFragmentDefenitionName(highLevelNode){var contents=highLevelNode.lowLevel()&&highLevelNode.lowLevel().unit()&&highLevelNode.lowLevel().unit().contents();return null==contents?null:getDefinitionSystemType(contents,highLevelNode.lowLevel()).ptype}function fromUnit(l){if(null==l)return null;var contents=l.contents(),ast=l.ast(),__ret=getDefinitionSystemType(contents,ast),ptype=__ret.ptype,localUniverse=__ret.localUniverse,apiType=localUniverse.type(ptype);apiType||(apiType=localUniverse.type("Api"));var api=new ASTNodeImpl(ast,null,apiType,null);return api.setUniverse(localUniverse),api.children(),api}function createBasicValidationAcceptor(errors,primaryUnitPointerNode){if(primaryUnitPointerNode){var unit=primaryUnitPointerNode.root().lowLevel().unit();return unit?new utils.PointOfViewValidationAcceptorImpl(errors,primaryUnitPointerNode.root()):{accept:function(c){errors.push(c)},begin:function(){},end:function(){},acceptUnique:function(issue){for(var _i=0,errors_1=errors;_i<errors_1.length;_i++){var e=errors_1[_i];if(e.start==issue.start&&e.message==issue.message)return}this.accept(issue)}}}}function isAnnotationTypeFragment(node){if(null!=node.parent())return!1;var unit=node.lowLevel().unit();if(null==unit)return!1;var content=unit.contents(),fLine=ramlFirstLine(content);return fLine.length<3?!1:"AnnotationTypeDeclaration"==fLine[2]}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},defs=__webpack_require__(36),hl=__webpack_require__(10),_=__webpack_require__(65),proxy=__webpack_require__(39),def=defs,builder=__webpack_require__(27),search=__webpack_require__(24),mutators=__webpack_require__(40),linter=__webpack_require__(26),expander=__webpack_require__(25),typeBuilder=__webpack_require__(41),universes=__webpack_require__(18),jsyaml=__webpack_require__(28),textutil=__webpack_require__(42),services=def,yaml=__webpack_require__(74),wrapperHelper=__webpack_require__(33),factory10=__webpack_require__(43),factory08=__webpack_require__(44),universeHelpers=__webpack_require__(14),resourceRegistry=__webpack_require__(29),rTypes=defs.rt,contentprovider=__webpack_require__(31),utils=__webpack_require__(3);exports.qName=qName;var BasicASTNode=function(){function BasicASTNode(_node,_parent){this._node=_node,this._parent=_parent,this._implicit=!1,this.values={},_node&&_node.setHighLevelParseResult(this)}return BasicASTNode.prototype.getKind=function(){return hl.NodeKind.BASIC},BasicASTNode.prototype.asAttr=function(){return null},BasicASTNode.prototype.asElement=function(){return null},BasicASTNode.prototype.hashkey=function(){return this._hashkey||(this._hashkey=this.parent()?this.parent().hashkey()+"/"+this.name():this.name()),this._hashkey},BasicASTNode.prototype.root=function(){return this.parent()?this.parent().root():this},BasicASTNode.prototype.version=function(){return""},BasicASTNode.prototype.getLowLevelStart=function(){return this.lowLevel().kind()===jsyaml.Kind.SCALAR?this.lowLevel().start():this.lowLevel().keyStart()},BasicASTNode.prototype.getLowLevelEnd=function(){return this.lowLevel().kind()===jsyaml.Kind.SCALAR?this.lowLevel().end():this.lowLevel().keyEnd()},BasicASTNode.prototype.isSameNode=function(n){return n&&n.lowLevel().actual()==this.lowLevel().actual()?!0:!1},BasicASTNode.prototype.checkContextValue=function(name,value,thisObj){var vl=this.computedValue(name);return vl&&-1!=vl.indexOf(value)?!0:value==vl||"false"==value},BasicASTNode.prototype.printDetails=function(indent){return(indent?indent:"")+"Unkown\n"},BasicASTNode.prototype.testSerialize=function(indent){return(indent?indent:"")+"Unkown\n"},BasicASTNode.prototype.errors=function(){var errors=[],q=createBasicValidationAcceptor(errors,this);return this.validate(q),errors},BasicASTNode.prototype.markCh=function(){for(var n=this.lowLevel();n instanceof proxy.LowLevelProxyNode;)n=n.originalNode();return n=n._node?n._node:n,n.markCh?!0:void(n.markCh=1)},BasicASTNode.prototype.unmarkCh=function(){for(var n=this.lowLevel();n instanceof proxy.LowLevelProxyNode;)n=n.originalNode();n=n._node?n._node:n,delete n.markCh},BasicASTNode.prototype.validate=function(v){linter.validate(this,v)},BasicASTNode.prototype.allowRecursive=function(){return!1},BasicASTNode.prototype.setComputed=function(name,v){this.values[name]=v},BasicASTNode.prototype.computedValue=function(name){var vl=this.values[name];return!vl&&this.parent()?this.parent().computedValue(name):vl},BasicASTNode.prototype.lowLevel=function(){return this._node},BasicASTNode.prototype.name=function(){var c=this.lowLevel().key();return c?c:""},BasicASTNode.prototype.optional=function(){var llNode=this.lowLevel(),ownValue=llNode.optional();if(null!=llNode.key())return ownValue;var p=this.property();if(!p||!p.isMultiValue())return ownValue;for(var llParent=llNode.parent();llParent&&null==llParent.highLevelNode();){if(llParent.kind()==yaml.Kind.MAPPING)return llParent.optional();llParent=llParent.parent()}return ownValue},BasicASTNode.prototype.parent=function(){return this._parent},BasicASTNode.prototype.setParent=function(parent){this._parent=parent},BasicASTNode.prototype.isElement=function(){return!1},BasicASTNode.prototype.directChildren=function(){return this.children()},BasicASTNode.prototype.children=function(){return[]},BasicASTNode.prototype.isAttached=function(){return null!=this.parent()},BasicASTNode.prototype.isImplicit=function(){return this._implicit},BasicASTNode.prototype.isAttr=function(){return!1},BasicASTNode.prototype.isUnknown=function(){return!0},BasicASTNode.prototype.id=function(){var _this=this;if(this.cachedId)return this.cachedId;if(this._parent){
var parentId=this.parent().id();parentId+="."+this.name();var sameName=this.parent().directChildren().filter(function(x){return x.name()==_this.name()});if(sameName.length>1){var ind=sameName.indexOf(this);parentId+="["+ind+"]"}return this.cachedId=parentId,parentId}return this.cachedId="",this.cachedId},BasicASTNode.prototype.localId=function(){return this.name()},BasicASTNode.prototype.fullLocalId=function(){var _this=this;if(this.cachedFullId)return this.cachedFullId;if(this._parent){var result=".";result+=null!=this.property()&&universeHelpers.isAnnotationsProperty(this.property())?this.lowLevel().key():this.name();var sameName=this.parent().directChildren().filter(function(x){return x.name()==_this.name()});if(sameName.length>1){var ind=sameName.indexOf(this);result+="["+ind+"]"}return this.cachedFullId=result,result}return this.cachedFullId=this.localId(),this.cachedFullId},BasicASTNode.prototype.property=function(){return null},BasicASTNode}();exports.BasicASTNode=BasicASTNode;var StructuredValue=function(){function StructuredValue(node,_parent,_pr,kv){void 0===kv&&(kv=null),this.node=node,this._parent=_parent,this.kv=kv,this._pr=_pr}return StructuredValue.prototype.valueName=function(){var res=null;return this.kv&&(res=this.kv),res=this.node.key(),this._pr&&this._pr.isAnnotation()&&res&&"("==res.charAt(0)&&(res=res.substring(1,res.length-1)),res},StructuredValue.prototype.children=function(){return this.node.children().map(function(x){return new StructuredValue(x,null,null)})},StructuredValue.prototype.lowLevel=function(){return this.node},StructuredValue.prototype.toHighLevel=function(parent){if(!parent&&this._parent&&(parent=this._parent),this._hl)return this._hl;var vn=this.valueName(),cands=search.referenceTargets(this._pr,parent).filter(function(x){return qName(x,parent)==vn});if(cands&&cands[0]){var tp=cands[0].localType(),node=new ASTNodeImpl(this.node,parent,tp,this._pr);return this._pr&&this._pr.childRestrictions().forEach(function(y){node.setComputed(y.name,y.value)}),this._hl=node,node}return null},StructuredValue.prototype.toHighLevel2=function(parent){!parent&&this._parent&&(parent=this._parent);var vn=this.valueName(),cands=search.referenceTargets(this._pr,parent).filter(function(x){return qName(x,parent)==vn});if(cands&&cands[0]){var tp=cands[0].localType(),node=new ASTNodeImpl(this.node,parent,tp,this._pr);return this._pr&&this._pr.childRestrictions().forEach(function(y){node.setComputed(y.name,y.value)}),node}if(this._pr.range()){var node=new ASTNodeImpl(this.node.parent(),parent,this._pr.range(),this._pr);return this._pr&&this._pr.childRestrictions().forEach(function(y){node.setComputed(y.name,y.value)}),node}return null},StructuredValue}();exports.StructuredValue=StructuredValue;var ASTPropImpl=function(_super){function ASTPropImpl(node,parent,_def,_prop,fromKey){void 0===fromKey&&(fromKey=!1),_super.call(this,node,parent),this._def=_def,this._prop=_prop,this.fromKey=fromKey}return __extends(ASTPropImpl,_super),ASTPropImpl.prototype.definition=function(){return this._def},ASTPropImpl.prototype.asAttr=function(){return this},ASTPropImpl.prototype.errors=function(){var errors=[],q=createBasicValidationAcceptor(errors,this);return this.parent().validate(q),errors},ASTPropImpl.prototype.isString=function(){return!this._def||this._def.key()!==universes.Universe08.StringType&&this._def.key()!=universes.Universe10.StringType?!1:!0},ASTPropImpl.prototype.isAnnotatedScalar=function(){return this.property().isAnnotation()||this.property().isKey()?!1:this.lowLevel().isAnnotatedScalar()},ASTPropImpl.prototype.annotations=function(){var ch=this.lowLevel().children(),annotations=[],u=this.definition().universe().type(universes.Universe10.Annotable.name);if(!u)return annotations;for(var pr=u.property("annotations"),i=0;i<ch.length;i++){var child=ch[i],key=child.key();if(null!=key&&"("==key[0]&&")"==key[key.length-1]){var attr=new ASTPropImpl(child,this.parent(),pr.range(),pr);annotations.push(attr)}}return annotations},ASTPropImpl.prototype.getKind=function(){return hl.NodeKind.ATTRIBUTE},ASTPropImpl.prototype.owningWrapper=function(){return{node:this.parent().wrapperNode(),property:this.name()}},ASTPropImpl.prototype.patchType=function(t){this._def=t},ASTPropImpl.prototype.findReferenceDeclaration=function(){var _this=this,targets=search.referenceTargets(this.property(),this.parent()),vl=this.value();if(vl instanceof StructuredValue)var st=vl,nm=st.valueName();else var nm=""+vl;var t=_.find(targets,function(x){return qName(x,_this.parent())==nm});return t},ASTPropImpl.prototype.findReferencedValue=function(){var c=this.findReferenceDeclaration();if(c){var vl=c.attr("value"),ck=c.definition().key();if(ck===universes.Universe08.GlobalSchema){if(vl){var actualValue=vl.value();if(actualValue){var rf=linter.isValid(this._def,this.parent(),actualValue,vl.property());return rf}}return null}}return c},ASTPropImpl.prototype.isElement=function(){return!1},ASTPropImpl.prototype.property=function(){return this._prop},ASTPropImpl.prototype.convertMultivalueToString=function(value){for(var gap=0,pos=2;" "==value[pos];)gap++,pos++;var lines=textutil.splitOnLines(value);return lines=lines.map(function(line){return line.substring(gap,line.length)}),lines.join("")},ASTPropImpl.prototype.overrideValue=function(value){this._value=value},ASTPropImpl.prototype.value=function(){return this._value?this._value:(this._value=this.calcValue(),this._value)},ASTPropImpl.prototype.calcValue=function(){if(this._computed)return this.computedValue(this.property().nameId());if(this.fromKey){var parent=this.parent(),definition=parent.definition();if("RAML08"==definition.universe().version())return this._node.key();if(universeHelpers.isNameProperty(this.property())&&definition.isAssignableFrom(universes.Universe10.TypeDeclaration.name)){var requiredAttr=parent.attr("required");if(requiredAttr&&null!=requiredAttr.value())return this._node.optional()?this._node.key()+"?":this._node.key()}return this._node.key()}if(this.property().isAnnotation()&&this._node.key()&&"annotations"!=this._node.key())return new StructuredValue(this._node,this.parent(),this._prop);var isString=null!=this.property()&&!(null==this.parent()||null==this.parent().definition()||universeHelpers.isTypeProperty(this.property())&&universeHelpers.isTypeDeclarationSibling(this.parent().definition()))&&universeHelpers.isStringTypeType(this.property().range()),actualValue=this._node.value(isString);if(this.property().isSelfNode()&&(!actualValue||actualValue instanceof jsyaml.ASTNode)&&(actualValue=this._node,0==actualValue.children().length&&(actualValue=null)),actualValue instanceof jsyaml.ASTNode||actualValue instanceof proxy.LowLevelProxyNode){var isAnnotatedScalar=!1;if(this.property().range().hasStructure()||this._node.isAnnotatedScalar()&&this._node.children().forEach(function(x){"value"===x.key()&&(actualValue=x.value(isString),isAnnotatedScalar=!0)}),!isAnnotatedScalar)return this._sval?this._sval:(this._sval=new StructuredValue(actualValue,this.parent(),this._prop),this._sval)}if("string"==typeof actualValue&&textutil.isMultiLineValue(actualValue)){var res=this.convertMultivalueToString(actualValue);return res}return null==actualValue&&this._node.children().length>0&&this.property()&&universeHelpers.isTypeProperty(this.property())&&this.parent()&&universeHelpers.isTypeDeclarationSibling(this.parent().definition())?new StructuredValue(this._node,this.parent(),this._prop):actualValue},ASTPropImpl.prototype.name=function(){return this._prop.nameId()},ASTPropImpl.prototype.printDetails=function(indent){var className=this.definition().nameId(),definitionClassName=this.property().range().nameId(),result=(indent?indent:"")+(this.name()+" : "+className+"["+definitionClassName+"]  =  "+this.value())+(this.property().isKey()&&this.optional()?"?":"")+"\n";if(this.value()instanceof StructuredValue){var structuredHighLevel=this.value().toHighLevel();structuredHighLevel&&structuredHighLevel.printDetails&&(result+=structuredHighLevel.printDetails(indent+"	"))}return result},ASTPropImpl.prototype.testSerialize=function(indent){var className=this.definition().nameId(),result=(indent?indent:"")+(this.name()+" : "+className+"  =  "+this.value())+"\n";if(this.value()instanceof StructuredValue){var structuredHighLevel=this.value().toHighLevel();if(structuredHighLevel&&structuredHighLevel.testSerialize)result+=structuredHighLevel.testSerialize((indent?indent:"")+"  ");else{var lowLevel=this.value().lowLevel(),dumpObject=lowLevel.dumpToObject(),dump=JSON.stringify(dumpObject),indentedDump="",dumpLines=dump.split("\n");dumpLines.forEach(function(dumpLine){return indentedDump+=(indent?indent:"")+"  "+dumpLine+"\n"}),result+=indentedDump+"\n"}}return result},ASTPropImpl.prototype.isAttr=function(){return!0},ASTPropImpl.prototype.isUnknown=function(){return!1},ASTPropImpl.prototype.setValue=function(value){mutators.setValue(this,value),this._value=null},ASTPropImpl.prototype.setKey=function(value){mutators.setKey(this,value),this._value=null},ASTPropImpl.prototype.children=function(){return[]},ASTPropImpl.prototype.addStringValue=function(value){mutators.addStringValue(this,value),this._value=null},ASTPropImpl.prototype.addStructuredValue=function(sv){mutators.addStructuredValue(this,sv),this._value=null},ASTPropImpl.prototype.addValue=function(value){if(!this.property().isMultiValue())throw new Error("setValue(string) only apply to multi-values properties");"string"==typeof value?this.addStringValue(value):this.addStructuredValue(value),this._value=null},ASTPropImpl.prototype.isEmbedded=function(){var keyname=this.lowLevel().asMapping().key.value;return this.property().canBeValue()&&keyname!=this.property().nameId()},ASTPropImpl.prototype.remove=function(){mutators.removeAttr(this)},ASTPropImpl.prototype.setValues=function(values){mutators.setValues(this,values),this._value=null},ASTPropImpl.prototype.isEmpty=function(){if(!this.property().isMultiValue())throw new Error("isEmpty() only apply to multi-values attributes");var node=this.parent(),attrs=(node.lowLevel(),node.attributes(this.name()));if(0==attrs.length)return!0;if(1==attrs.length){var anode=attrs[0].lowLevel();return anode.isMapping()&&null==anode.value()?!0:!1}return!1},ASTPropImpl.prototype.isFromKey=function(){return this.fromKey},ASTPropImpl}(BasicASTNode);exports.ASTPropImpl=ASTPropImpl;var nodeBuilder=new builder.BasicNodeBuilder;!function(OverlayMergeMode){OverlayMergeMode[OverlayMergeMode.MERGE=0]="MERGE",OverlayMergeMode[OverlayMergeMode.AGGREGATE=1]="AGGREGATE"}(exports.OverlayMergeMode||(exports.OverlayMergeMode={}));var OverlayMergeMode=exports.OverlayMergeMode,LowLevelWrapperForTypeSystem=function(_super){function LowLevelWrapperForTypeSystem(_node,_highLevelRoot){_super.call(this),this._node=_node,this._highLevelRoot=_highLevelRoot;var v=_highLevelRoot.root(),mst=v.getMaster();if(mst&&this._node===_highLevelRoot.lowLevel()){var master=_highLevelRoot.getMasterCounterPart();master&&(this._toMerge=new LowLevelWrapperForTypeSystem(master.lowLevel(),master))}}return __extends(LowLevelWrapperForTypeSystem,_super),LowLevelWrapperForTypeSystem.prototype.contentProvider=function(){var root=this._node&&this._node.includeBaseUnit()&&(this._node.includePath&&this._node.includePath()?this._node.includeBaseUnit().resolve(this._node.includePath()):this._node.includeBaseUnit());return new contentprovider.ContentProvider(root)},LowLevelWrapperForTypeSystem.prototype.key=function(){var vl=this._node.key();return this._node.optional()&&(vl+="?"),vl},LowLevelWrapperForTypeSystem.prototype.value=function(){var vk=this._node.valueKind();if(vk===yaml.Kind.SEQ)return this.children().map(function(x){return x.value()});if(vk===yaml.Kind.MAP||vk===yaml.Kind.ANCHOR_REF){var vl=this._node.dumpToObject(!1);return vl[this.key()]}if(this._node.kind()==yaml.Kind.MAP){var vl=this._node.dumpToObject(!1);return vl}if(vk===yaml.Kind.INCLUDE_REF){var resolved=null,includePath=this._node.includePath();try{resolved=this._node.unit().resolve(includePath)}catch(e){}if(null!=resolved&&resolved.isRAMLUnit()){var includedAST=resolved.ast(),includedWrapper=new LowLevelWrapperForTypeSystem(includedAST,resolved.highLevel().asElement());return includedAST.kind()==yaml.Kind.SEQ?includedWrapper.children().map(function(x){return x.value()}):includedWrapper.value()}}var val=this._node.value();return val},LowLevelWrapperForTypeSystem.prototype.children=function(){var _this=this;if(this._children)return this._children;"uses"!=this.key()||this._node.parent().parent()?this._children=this._node.children().map(function(x){return new LowLevelWrapperForTypeSystem(x,_this._highLevelRoot)}):this._children=this._node.children().map(function(x){return new UsesNodeWrapperFoTypeSystem(x,_this._highLevelRoot)}),this.childByKey={};for(var i=0;i<this._children.length;i++){var c=this._children[i];this.childByKey[c.key()]=c}if(this._toMerge)for(var mrg=this._toMerge.children(),i=0;i<mrg.length;i++){var c=mrg[i],existing=this.childByKey[c.key()];existing?existing._toMerge=c:(this._children.push(c),this.childByKey[c.key()]=c)}return this._children},LowLevelWrapperForTypeSystem.prototype.childWithKey=function(k){return this._children||this.children(),this.childByKey[k]},LowLevelWrapperForTypeSystem.prototype.kind=function(){var vk=this._node.valueKind();if(vk==yaml.Kind.MAPPING||null===vk)return rTypes.NodeKind.MAP;if(vk==yaml.Kind.MAP)return rTypes.NodeKind.MAP;var knd=this._node.kind();return knd==yaml.Kind.MAP?rTypes.NodeKind.MAP:vk==yaml.Kind.SEQ?rTypes.NodeKind.ARRAY:vk==yaml.Kind.INCLUDE_REF&&this._node.children().length>0?rTypes.NodeKind.MAP:rTypes.NodeKind.SCALAR},LowLevelWrapperForTypeSystem.prototype.getSource=function(){if(!this._node)return null;var highLevelNode=this._node.highLevelNode();if(!highLevelNode){var position=this._node.start(),result=search.deepFindNode(this._highLevelRoot,position,position,!0,!1);return result&&(this._node.setHighLevelParseResult(result),result instanceof ASTNodeImpl&&this._node.setHighLevelNode(result)),result}return highLevelNode},LowLevelWrapperForTypeSystem.prototype.node=function(){return this._node},LowLevelWrapperForTypeSystem}(defs.SourceProvider);exports.LowLevelWrapperForTypeSystem=LowLevelWrapperForTypeSystem;var UsesNodeWrapperFoTypeSystem=function(_super){function UsesNodeWrapperFoTypeSystem(){_super.apply(this,arguments)}return __extends(UsesNodeWrapperFoTypeSystem,_super),UsesNodeWrapperFoTypeSystem.prototype.children=function(){var s=this._node.unit().resolve(this.value());return s&&s.isRAMLUnit()&&s.contents().trim().length>0?new LowLevelWrapperForTypeSystem(s.ast(),this._highLevelRoot).children():[]},UsesNodeWrapperFoTypeSystem.prototype.anchor=function(){return this._node.actual()},UsesNodeWrapperFoTypeSystem.prototype.childWithKey=function(k){for(var mm=this.children(),i=0;i<mm.length;i++)if(mm[i].key()==k)return mm[i];return null},UsesNodeWrapperFoTypeSystem}(LowLevelWrapperForTypeSystem);exports.UsesNodeWrapperFoTypeSystem=UsesNodeWrapperFoTypeSystem;var ASTNodeImpl=function(_super){function ASTNodeImpl(node,parent,_def,_prop){_super.call(this,node,parent),this._def=_def,this._prop=_prop,this._expanded=!1,this._allowQuestion=!1,this._subTypesCache=null,this._auxChecked=!1,this.overlayMergeMode=OverlayMergeMode.MERGE,node&&node.setHighLevelNode(this),node instanceof proxy.LowLevelProxyNode&&(this._expanded=!0)}return __extends(ASTNodeImpl,_super),ASTNodeImpl.prototype.createIssue=function(error){return linter.toIssue(error,this)},ASTNodeImpl.prototype.validate=function(v){var k=this.definition().key();if((k==universes.Universe10.Api||k==universes.Universe08.Api||k==universes.Universe10.Extension)&&!this.isExpanded()){var nm=expander.expandTraitsAndResourceTypes(this.wrapperNode()),hlnode=nm.highLevel();return hlnode.resetChildren(),hlnode.children(),hlnode._expanded=!0,hlnode.clearTypesCache(),void hlnode.validate(v)}(k==universes.Universe10.Overlay||k==universes.Universe10.Extension)&&this.clearTypesCache(),linter.validate(this,v)},ASTNodeImpl.prototype.clearTypesCache=function(){if(this._types=null,this.lowLevel()){var c=this.lowLevel().actual();c.types=null}},ASTNodeImpl.prototype.types=function(){var _this=this;if(!this._types){if(this.parent()&&this.definition().key()!==universes.Universe10.Library)return this.parent().types();var c=this.lowLevel().actual();if(c.types)return c.types;this._types=rTypes.parseFromAST(new LowLevelWrapperForTypeSystem(this.lowLevel(),this)),this._types.types().forEach(function(x){var convertedType=typeBuilder.convertType(_this,x);convertedType.putExtra(defs.USER_DEFINED_EXTRA,!0)}),c.types=this._types}return this._types},ASTNodeImpl.prototype.setTypes=function(t){this._types=t},ASTNodeImpl.prototype.parsedType=function(){if(!this._ptype){if(this.property()&&this.property().nameId()==universes.Universe10.MethodBase.properties.body.name){var isParametrizedType=this.isParametrizedType();this._ptype=rTypes.parseTypeFromAST(this.name(),new LowLevelWrapperForTypeSystem(this.lowLevel(),this),this.types(),!0,!1,!1,isParametrizedType)}else{var annotation=this.property()&&this.property().nameId()==universes.Universe10.LibraryBase.properties.annotationTypes.name,tl=!this.property()||this.property().nameId()==universes.Universe10.LibraryBase.properties.types.name||this.property().nameId()==universes.Universe10.LibraryBase.properties.schemas.name;if(!annotation&&null==this.parent()){var localUniverse=this.universe();localUniverse&&localUniverse.getOriginalTopLevelText()&&"AnnotationTypeDeclaration"==localUniverse.getOriginalTopLevelText()&&(annotation=!0)}this._ptype=rTypes.parseTypeFromAST(this.name(),new LowLevelWrapperForTypeSystem(this.lowLevel(),this),this.types(),!1,annotation,tl)}this.property()&&universeHelpers.isTypesProperty(this.property())&&this.parent()&&universeHelpers.isApiType(this.parent().definition())&&this._ptype.putExtra&&this._ptype.putExtra(defs.DEFINED_IN_TYPES_EXTRA,!0);var potentialHasExtra=this._ptype;potentialHasExtra.putExtra(defs.USER_DEFINED_EXTRA,!0),this._ptype.putExtra(defs.SOURCE_EXTRA,this)}return this._ptype},ASTNodeImpl.prototype.isParametrizedType=function(){var isParametrizedType=!1,typeAttr=this.attr(universes.Universe10.TypeDeclaration.properties.type.name);if(typeAttr){var typeAttrValue=typeAttr.value();if("string"==typeof typeAttrValue&&typeAttrValue.indexOf("<<")>=0)for(var parent=this.parent();null!=parent;){if(universeHelpers.isResourceTypeType(parent.definition())||universeHelpers.isTraitType(parent.definition())){isParametrizedType=!0;break}parent=parent.parent()}}return isParametrizedType},ASTNodeImpl.prototype.localType=function(){return typeBuilder.typeFromNode(this)},ASTNodeImpl.prototype.patchProp=function(pr){this._prop=pr},ASTNodeImpl.prototype.getKind=function(){return hl.NodeKind.NODE},ASTNodeImpl.prototype.wrapperNode=function(){if(!this._wrapperNode){if(universeHelpers.isExampleSpecType(this.definition())){var typeYamlNode=yaml.newMap([yaml.newMapping(yaml.newScalar("example"),this.lowLevel().actual())]),typesNode=yaml.newMapping(yaml.newScalar("types"),yaml.newMap([yaml.newMapping(yaml.newScalar("__AUX_TYPE__"),typeYamlNode)])),yamlNode=yaml.newMap([typesNode]),llNode=new jsyaml.ASTNode(yamlNode,this.lowLevel().unit(),null,null,null),types=rTypes.parseFromAST(new LowLevelWrapperForTypeSystem(llNode,this)),nominal=rTypes.toNominal(types.types()[0],function(x){return null}),spec=wrapperHelper.examplesFromNominal(nominal,this,!0,!1);return spec[0]}this.children(),this._wrapperNode=this.buildWrapperNode()}return this._wrapperNode},ASTNodeImpl.prototype.asElement=function(){return this},ASTNodeImpl.prototype.buildWrapperNode=function(){var ramlVersion=this.definition().universe().version();return"RAML10"==ramlVersion?factory10.buildWrapperNode(this):"RAML08"==ramlVersion?factory08.buildWrapperNode(this):null},ASTNodeImpl.prototype.propertiesAllowedToUse=function(){var _this=this;return this.definition().allProperties().filter(function(x){return _this.isAllowedToUse(x)})},ASTNodeImpl.prototype.isAllowedToUse=function(p){var _this=this,ok=!0;return p.getAdapter(services.RAMLPropertyService).isSystem()?!1:(p.getContextRequirements().forEach(function(y){if(-1!=y.name.indexOf("("))return!0;var vl=_this.computedValue(y.name);vl?ok=ok&&vl==y.value:y.value&&(ok=!1)}),ok)},ASTNodeImpl.prototype.allowRecursive=function(){return this.definition().getAdapter(services.RAMLService).isUserDefined()?!0:!1},ASTNodeImpl.prototype.setWrapperNode=function(node){this._wrapperNode=node},ASTNodeImpl.prototype.setAssociatedType=function(d){this._associatedDef=d},ASTNodeImpl.prototype.associatedType=function(){return this._associatedDef},ASTNodeImpl.prototype.knownIds=function(){return this.isAuxilary(),this._knownIds?this._knownIds:{}},ASTNodeImpl.prototype.findById=function(id){var _this=this,currentRoot=this.root();if(currentRoot!=this)return currentRoot.findById(id);if(!this._knownIds){this._knownIds={};var all=search.allChildren(this);all.forEach(function(x){return _this._knownIds[x.id()]=x})}if(this.isAuxilary()){if(!this._slaveIds){this._slaveIds={};var all=search.allChildren(this);all.forEach(function(x){return _this._slaveIds[x.id()]=x})}var nodeIndexedInSlave=this._slaveIds[id];if(nodeIndexedInSlave)return nodeIndexedInSlave}return this._knownIds[id]},ASTNodeImpl.prototype.isAuxilary=function(){if(this._isAux)return!0;if(this._auxChecked)return!1;this._auxChecked=!0;var masterApi=this.getMaster();return masterApi?(this._isAux=!0,this.initilizeKnownIDs(masterApi),!0):!1},ASTNodeImpl.prototype.initilizeKnownIDs=function(api){var _this=this;this._knownIds={};var allChildren=search.allChildren(api);allChildren.forEach(function(x){return _this._knownIds[x.id()]=x}),this._knownIds[""]=api},ASTNodeImpl.prototype.getMaster=function(){if(this.masterApi)return this.masterApi;var detectedMaster=this.calculateMasterByRef();return detectedMaster&&detectedMaster.setSlave(this),detectedMaster},ASTNodeImpl.prototype.overrideMaster=function(master){this.masterApi=master,this.resetAuxilaryState(),master&&master.setSlave(this)},ASTNodeImpl.prototype.setSlave=function(slave){this.slave=slave},ASTNodeImpl.prototype.setMergeMode=function(mergeMode){this.overlayMergeMode=mergeMode,this.resetAuxilaryState()},ASTNodeImpl.prototype.getMergeMode=function(){return this.overlayMergeMode},ASTNodeImpl.prototype.calculateMasterByRef=function(){var unit=this.lowLevel().unit();if(!unit)return null;var masterReferenceNode=unit.getMasterReferenceNode();if(!masterReferenceNode||!masterReferenceNode.value())return null;var lc=this.lowLevel();if(lc.master)return lc.master;var masterPath=masterReferenceNode.value(),masterUnit=this.lowLevel().unit().project().resolve(this.lowLevel().unit().path(),masterPath);if(!masterUnit)return null;var result=masterUnit.expandedHighLevel();return result.setMergeMode(this.overlayMergeMode),lc.master=result,result},ASTNodeImpl.prototype.resetAuxilaryState=function(){this._isAux=!1,this._auxChecked=!1,this._knownIds=null,this.clearChildrenCache()},ASTNodeImpl.prototype.printDetails=function(indent){var result="";indent||(indent="");var classname=this.definition().nameId(),definitionClasName=this.property()?this.property().range().nameId():"",parentPropertyName=this.property()?this.property().nameId():"";return result+=indent+classname+"["+definitionClasName+"] <--- "+parentPropertyName+"\n",this.children().forEach(function(child){result+=child.printDetails(indent+"	")}),result},ASTNodeImpl.prototype.testSerialize=function(indent){var result="";indent||(indent="");var classname=this.definition().nameId(),parentPropertyName=this.property()?this.property().nameId():"";return result+=indent+classname+" <-- "+parentPropertyName+"\n",this.children().forEach(function(child){child.testSerialize&&(result+=child.testSerialize(indent+"  "))}),result},ASTNodeImpl.prototype.getExtractedChildren=function(){var r=this.root();if(r.isAuxilary()){if(r._knownIds){var i=r._knownIds[this.id()];if(i){var v=i.children();return v}}return[]}return[]},ASTNodeImpl.prototype.getMasterCounterPart=function(){var r=this.root();if(r.isAuxilary()){if(r._knownIds){var i=r._knownIds[this.id()];return i}return null}return null},ASTNodeImpl.prototype.getExtractedLowLevelChildren=function(n){var r=this.root();if(r.isAuxilary()){if(r._knownLowLevelIds){var i=r._knownLowLevelIds[this.id()];if(i)return i.children()}return[]}return[]},ASTNodeImpl.prototype.allowsQuestion=function(){return this._allowQuestion||this.definition().getAdapter(services.RAMLService).getAllowQuestion()},ASTNodeImpl.prototype.findReferences=function(){var _this=this,rs=[];search.refFinder(this.root(),this,rs),rs.length>1&&(rs=rs.filter(function(x){return x!=_this&&x.parent()!=_this}));var filteredReferences=[];return rs.forEach(function(ref){_.find(filteredReferences,function(existing){return existing==ref})||filteredReferences.push(ref)}),filteredReferences},ASTNodeImpl.prototype.setNamePatch=function(s){this._patchedName=s},ASTNodeImpl.prototype.isNamePatch=function(){return this._patchedName},ASTNodeImpl.prototype.name=function(){if(this._patchedName)return this._patchedName;var ka=_.find(this.directChildren(),function(x){return x.property()&&x.property().getAdapter(services.RAMLPropertyService).isKey()});if(ka&&ka instanceof ASTPropImpl){var c=null,defClass=this.definition(),ramlVersion=defClass.universe().version();if(defClass&&"RAML10"==ramlVersion&&ka.isFromKey()){var key=this._node.key();c=this._node.optional()?key+"?":key}else c=ka.value();return c}return _super.prototype.name.call(this)},ASTNodeImpl.prototype.findElementAtOffset=function(n){return this._findNode(this,n,n)},ASTNodeImpl.prototype.isElement=function(){return!0},ASTNodeImpl.prototype.universe=function(){return this._universe?this._universe:this.definition().universe()},ASTNodeImpl.prototype.setUniverse=function(u){this._universe=u},ASTNodeImpl.prototype._findNode=function(n,offset,end){var _this=this;if(null==n)return null;if(n.lowLevel()&&n.lowLevel().start()<=offset&&n.lowLevel().end()>=end){var res=n;return n.elements().forEach(function(x){if(x.lowLevel().unit()==n.lowLevel().unit()){var m=_this._findNode(x,offset,end);m&&(res=m)}}),res}return null},ASTNodeImpl.prototype.isStub=function(){return!this.lowLevel().unit()||this.lowLevel().unit().isStubUnit()},ASTNodeImpl.prototype.add=function(node){mutators.addToNode(this,node)},ASTNodeImpl.prototype.remove=function(node){mutators.removeNodeFrom(this,node)},ASTNodeImpl.prototype.dump=function(flavor){return this._node.dump()},ASTNodeImpl.prototype.patchType=function(d){this._def=d;this._associatedDef;this._associatedDef=null,this._children=null,this._mergedChildren=null},ASTNodeImpl.prototype.children=function(){var lowLevel=this.lowLevel();return lowLevel&&lowLevel.isValueInclude&&lowLevel.isValueInclude()&&resourceRegistry.isWaitingFor(lowLevel.includePath())?(this._children=null,[]):this._children?this._mergedChildren?this._mergedChildren:(this._mergedChildren=this.mergeChildren(this._children,this.getExtractedChildren()),this._mergedChildren):this._node?(this._children=nodeBuilder.process(this,this._node.children()),this._children=this._children.filter(function(x){return null!=x}),this.mergeChildren(this._children,this.getExtractedChildren())):[]},ASTNodeImpl.prototype.mergeChildren=function(originalChildren,masterChildren){var _this=this,root=this.root();if(root.overlayMergeMode==OverlayMergeMode.AGGREGATE)return originalChildren.concat(masterChildren);if(root.overlayMergeMode==OverlayMergeMode.MERGE){var result=[];return originalChildren.forEach(function(originalChild){var masterCounterpart=_.find(masterChildren,function(masterChild){return masterChild.fullLocalId()==originalChild.fullLocalId()});masterCounterpart?_this.mergeChild(result,originalChild,masterCounterpart):result.push(originalChild)}),masterChildren.forEach(function(masterChild){var originalCounterpart=_.find(originalChildren,function(originalChild){return masterChild.fullLocalId()==originalChild.fullLocalId()});originalCounterpart||result.push(masterChild)}),result}return null},ASTNodeImpl.prototype.mergeLowLevelChildren=function(originalChildren,masterChildren){var _this=this,root=this.root();if(root.overlayMergeMode==OverlayMergeMode.AGGREGATE)return originalChildren.concat(masterChildren);if(root.overlayMergeMode==OverlayMergeMode.MERGE){var result=[];return originalChildren.forEach(function(originalChild){var masterCounterpart=_.find(masterChildren,function(masterChild){return masterChild.key()==originalChild.key()});masterCounterpart?_this.mergeLowLevelChild(result,originalChild,masterCounterpart):result.push(originalChild)}),masterChildren.forEach(function(masterChild){var originalCounterpart=_.find(originalChildren,function(originalChild){return masterChild.key()==originalChild.key()});originalCounterpart||result.push(masterChild)}),result}return null},ASTNodeImpl.prototype.mergeLowLevelChild=function(result,originalChild,masterChild){return originalChild.kind()!=masterChild.kind()?(result.push(originalChild),void result.push(masterChild)):void result.push(originalChild)},ASTNodeImpl.prototype.mergeChild=function(result,originalChild,masterChild){return originalChild.getKind()!=masterChild.getKind()?(result.push(originalChild),void result.push(masterChild)):originalChild.getKind()==hl.NodeKind.NODE?void result.push(originalChild):originalChild.getKind()==hl.NodeKind.ATTRIBUTE?void result.push(originalChild):originalChild.getKind()==hl.NodeKind.BASIC?(result.push(originalChild),void result.push(masterChild)):void 0},ASTNodeImpl.prototype.directChildren=function(){return this._children?this._children:this._node?(this._children=nodeBuilder.process(this,this._node.children()),this._children):[]},ASTNodeImpl.prototype.resetChildren=function(){this._children=null,this._mergedChildren=null},ASTNodeImpl.prototype.isEmptyRamlFile=function(){var llroot=this.lowLevel().root();return llroot.isScalar()},ASTNodeImpl.prototype.initRamlFile=function(){mutators.initEmptyRAMLFile(this)},ASTNodeImpl.prototype.createAttr=function(n,v){mutators.createAttr(this,n,v)},ASTNodeImpl.prototype.isAttr=function(){return!1},ASTNodeImpl.prototype.isUnknown=function(){return!1},ASTNodeImpl.prototype.value=function(){return this._node.value()},ASTNodeImpl.prototype.valuesOf=function(propName){var pr=this._def.property(propName);return null!=pr?this.elements().filter(function(x){return x.property()==pr}):[]},ASTNodeImpl.prototype.attr=function(n){return _.find(this.attrs(),function(y){return y.name()==n})},ASTNodeImpl.prototype.attrOrCreate=function(name){var a=this.attr(name);return a||this.createAttr(name,""),this.attr(name)},ASTNodeImpl.prototype.attrValue=function(n){var a=this.attr(n);return a?a.value():null},ASTNodeImpl.prototype.attributes=function(n){return _.filter(this.attrs(),function(y){return y.name()==n})},ASTNodeImpl.prototype.attrs=function(){var rs=this.children().filter(function(x){return x.isAttr()});if(this._patchedName){var kp=_.find(this.definition().allProperties(),function(x){return x.getAdapter(services.RAMLPropertyService).isKey()});if(kp){var mm=new ASTPropImpl(this.lowLevel(),this,kp.range(),kp,!0);return mm._value=this._patchedName,[mm].concat(rs)}}return rs},ASTNodeImpl.prototype.elements=function(){return this.children().filter(function(x){return!x.isAttr()&&!x.isUnknown()})},ASTNodeImpl.prototype.element=function(n){var r=this.elementsOfKind(n);return r.length>0?r[0]:null},ASTNodeImpl.prototype.elementsOfKind=function(n){var r=this.elements().filter(function(x){return x.property().nameId()==n});return r},ASTNodeImpl.prototype.definition=function(){return this._def},ASTNodeImpl.prototype.property=function(){return this._prop},ASTNodeImpl.prototype.isExpanded=function(){return this._expanded},ASTNodeImpl.prototype.copy=function(){return new ASTNodeImpl(this.lowLevel().copy(),this.parent(),this.definition(),this.property())},ASTNodeImpl.prototype.clearChildrenCache=function(){this._children=null,this._mergedChildren=null;
},ASTNodeImpl.prototype.optionalProperties=function(){var def=this.definition();if(null==def)return[];var result=[],map={},children=this.lowLevel().children();children.forEach(function(x){x.optional()&&(map[x.key()]=!0)});var props=def.allProperties();return props.forEach(function(x){var prop=x;map[prop.nameId()]&&result.push(prop.nameId())}),result},ASTNodeImpl}(BasicASTNode);exports.ASTNodeImpl=ASTNodeImpl,exports.universeProvider=__webpack_require__(35);var getDefinitionSystemType=function(contents,ast){var rfl=ramlFirstLine(contents),spec=rfl&&rfl[1]||"",ptype=rfl&&rfl.length>2&&rfl[2]||"Api",originalPType=rfl&&rfl.length>2&&rfl[2],localUniverse="1.0"==spec?new def.Universe(null,"RAML10",exports.universeProvider("RAML10"),"RAML10"):new def.Universe(null,"RAML08",exports.universeProvider("RAML08"));return"API"==ptype?ptype="Api":"NamedExample"==ptype?ptype="ExampleSpec":"DataType"==ptype?ptype="TypeDeclaration":"SecurityScheme"==ptype?ptype="AbstractSecurityScheme":"AnnotationTypeDeclaration"==ptype&&(ptype="TypeDeclaration"),localUniverse.setOriginalTopLevelText(originalPType),localUniverse.setTopLevel(ptype),localUniverse.setTypedVersion(spec),{ptype:ptype,localUniverse:localUniverse}};exports.ramlFirstLine=ramlFirstLine,exports.getFragmentDefenitionName=getFragmentDefenitionName,exports.fromUnit=fromUnit,exports.createBasicValidationAcceptor=createBasicValidationAcceptor,exports.isAnnotationTypeFragment=isAnnotationTypeFragment},function(module,exports,__webpack_require__){"use strict";function createStub0(parent,property,key){var p=parent.definition().property(property);if(!p)return null;var nc=p.range(),node=createStubNode(nc,p,key);return node}function genStructuredValue(type,name,mappings,parent){var map=yaml.newMap(mappings.map(function(mapping){return yaml.newMapping(yaml.newScalar(mapping.key),yaml.newScalar(mapping.value))})),node=new jsyaml.ASTNode(map,parent?parent.lowLevel().unit():null,parent?parent.lowLevel():null,null,null);return new hlimpl.StructuredValue(node,parent,parent?parent.definition().property(type):null,name)}function createStub(parent,property,key){var p=parent.definition().property(property);if(!p)return null;var nc=p.range(),su=parent.lowLevel().unit().stub(),node=createStubNode(nc,p,key,su);return node.isInEdit=!0,node.lowLevel()._unit=su,node._parent=parent.copy(),node._parent.lowLevel()._unit=su,node}function createResourceStub(parent,key){return createStub(parent,"resources",key)}function createMethodStub(parent,key){return createStub(parent,"methods",key)}function createResponseStub(parent,key){return createStub(parent,"responses",key)}function createBodyStub(parent,key){return createStub(parent,"body",key)}function createUriParameterStub(parent,key){return createStub(parent,"uriParameters",key)}function createQueryParameterStub(parent,key){return createStub(parent,"queryParameters",key)}function createAttr(_property,val){var lowLevel=jsyaml.createMapping(_property.nameId(),val),nm=new hlimpl.ASTPropImpl(lowLevel,null,_property.range(),_property);return nm}function createStubNode(t,p,key,unit){void 0===key&&(key=null);var lowLevel=jsyaml.createNode(key?key:"key",null,unit),nm=new hlimpl.ASTNodeImpl(lowLevel,null,t,p);return lowLevel.unit()||(lowLevel._unit=unit),nm.children(),nm}var jsyaml=__webpack_require__(28),hlimpl=__webpack_require__(16),yaml=__webpack_require__(74);exports.createStub0=createStub0,exports.genStructuredValue=genStructuredValue,exports.createStub=createStub,exports.createResourceStub=createResourceStub,exports.createMethodStub=createMethodStub,exports.createResponseStub=createResponseStub,exports.createBodyStub=createBodyStub,exports.createUriParameterStub=createUriParameterStub,exports.createQueryParameterStub=createQueryParameterStub,exports.createAttr=createAttr,exports.createStubNode=createStubNode},function(module,exports,__webpack_require__){"use strict";var ramlDs=__webpack_require__(36);module.exports=ramlDs.universesInfo},function(module,exports,__webpack_require__){"use strict";var _=__webpack_require__(65),textutil=__webpack_require__(42),wrapper=__webpack_require__(21),SchemaToModelGenerator=function(){function SchemaToModelGenerator(){}return SchemaToModelGenerator.prototype.generateText=function(schema){var _this=this,obj=JSON.parse(schema),items=obj.items;if(!items)return"";var text="",itemsArray=items instanceof Array?items:[items];return text+="types:\n",itemsArray.forEach(function(e){text+="  - "+e.title+":\n",text+=_this.generateObj(e,3)}),text},SchemaToModelGenerator.prototype.generateObj=function(e,lev){var text="";if(text+=textutil.indent(lev,"type: "+e.type)+"\n",e.properties){text+=textutil.indent(lev,"properties:\n");for(var name in e.properties){var p=e.properties[name];text+=textutil.indent(lev+1,name+":\n"),text+="object"==p.type?this.generateObj(p,lev+2):textutil.indent(lev+2,"type: "+p.type)+"\n"}return text}},SchemaToModelGenerator.prototype.generateTo=function(api,schema,title){var _this=this,obj=JSON.parse(schema),items=obj.items;if(items){var itemsArray=items instanceof Array?items:[items],types=[];return itemsArray.forEach(function(e){var type=new wrapper.ObjectTypeDeclarationImpl(e.title);_this.generateObjTo(type,e),new wrapper.BasicSecuritySchemeImpl(api).addToProp(type,"types"),types.push(e.title)}),types}obj.title&&(title=obj.title);var type=new wrapper.ObjectTypeDeclarationImpl(title);return this.generateObjTo(type,obj),new wrapper.BasicSecuritySchemeImpl(api).addToProp(type,"types"),[title]},SchemaToModelGenerator.prototype.generateObjTo=function(type,e){if(type.setType(e.type),e.properties)for(var name in e.properties){var p=e.properties[name],field=this.makeTypeField(name,p);"array"==p.type,type.addToProp(field,"properties")}},SchemaToModelGenerator.prototype.makeTypeField=function(name,p){var field=this.makeType(name,p.type);if(p.type&&field.setType(p.type),"number"==p.type){var n=field;void 0!=p.minimum&&n.setMinimum(p.minimum),void 0!=p.maximum&&n.setMaximum(p.maximum)}if("array"==p.type){var itype=p.items.type;field.setType(itype+"[]");var a=field;void 0!=p.minItems&&a.setMinItems(p.minItems),void 0!=p.maxItems&&a.setMaxItems(p.maxItems),void 0!=p.uniqueItems&&a.setUniqueItems(p.uniqueItems)}return"object"==p.type&&this.generateObjTo(field,p),field},SchemaToModelGenerator.prototype.makeType=function(name,type){return"number"==type?new wrapper.NumberTypeDeclarationImpl(name):"string"==type?new wrapper.StringTypeDeclarationImpl(name):"array"==type?new wrapper.ArrayTypeDeclarationImpl(name):new wrapper.ObjectTypeDeclarationImpl(name)},SchemaToModelGenerator.prototype.generateItemsTo=function(a,obj){var items=obj.items;if(items){var itemsArray=items instanceof Array?items:[items];itemsArray.forEach(function(item){})}},SchemaToModelGenerator}();exports.SchemaToModelGenerator=SchemaToModelGenerator;var ModelToSchemaGenerator=function(){function ModelToSchemaGenerator(){}return ModelToSchemaGenerator.prototype.generateSchema=function(node){var obj=this.generateType(node);return obj.$schema="http://json-schema.org/draft-04/schema#",obj},ModelToSchemaGenerator.prototype.isSimpleType=function(name){return"string"==name||"number"==name||"boolean"==name||"object"==name},ModelToSchemaGenerator.prototype.generateType=function(type){var typelist=this.allTypes(type),obj={};obj.title=type.attrValue("name");if(type.attrValue("type")){var types=type.attributes("type"),inherited=!1,simple=!1;for(var i in types){var typevalue=types[i].value(),ll=types[i].lowLevel();if(obj.type="",ll.isValueInclude()){var schema=JSON.parse(typevalue);obj.type="object",obj.properties=schema.properties}else if(this.isSimpleType(typevalue)){if(obj.type=typevalue,simple=!0,inherited)throw new Error("couldn't mix user defined and basic types in inheritance")}else{var t=this.resolveType(type,typevalue);if(t){var ppp=this.generateTypeExp(typevalue,typelist);if(obj.properties?_.extend(obj.properties,ppp.properties):obj.properties=ppp.properties,obj.type="object",inherited=!0,simple)throw new Error("couldn't mix user defined and basic types in inheritance")}else{var ppp=this.generateTypeExp(typevalue,typelist);obj.type="object",inherited=!0,ppp.anyOf&&(obj.anyOf=ppp.anyOf)}}}}else obj.type="object";var ownProps=this.generateProperties(type);return obj.properties?_.extend(obj.properties,ownProps):obj.properties=ownProps,obj},ModelToSchemaGenerator.prototype.makeUnion=function(typelist,types){var _this=this,anyof=[];return typelist.forEach(function(t){t=t.trim(),types[t]?anyof.push({type:"object",properties:_this.generateType(types[t]).properties}):anyof.push({type:t})}),anyof},ModelToSchemaGenerator.prototype.generateTypeExp=function(type,types){var obj={};if(textutil.endsWith(type,"[]"))obj.type="array",obj.items={type:type.substring(0,type.length-2)};else if(type.indexOf("|")>0){var typelist=type.split("|");obj.anyOf=this.makeUnion(typelist,types)}else if(types[type]){var schema=this.generateType(types[type]);obj.type="object",obj.properties=schema.properties}else obj.type=type;return obj},ModelToSchemaGenerator.prototype.allTypes=function(node){var api=node.root(),modelTypes=api.elementsOfKind("types"),types={};return modelTypes.forEach(function(type){types[type.name()]=type}),types},ModelToSchemaGenerator.prototype.resolveType=function(node,name){var types=this.allTypes(node);return types[name]},ModelToSchemaGenerator.prototype.generateProperty=function(node,optional){var _this=this,types=this.allTypes(node),obj={},props=node.definition().allProperties();props.forEach(function(p){if("name"!=p.nameId()){var value=node.attrValue(p.nameId());if(null!=value&&void 0!=value&&"undefined"!=value)if("type"==p.nameId()){var t=_this.generateTypeExp(value,types);_.extend(obj,t)}else if("enum"==p.nameId()){var values=node.attributes("enum"),arr=values.map(function(a){return a.value()});obj["enum"]=arr}else obj[p.nameId()]=value}}),optional&&(obj.required=!1);var properties=(node.elements(),this.generateProperties(node));return Object.getOwnPropertyNames(properties).length>0&&(obj.properties=properties),obj},ModelToSchemaGenerator.prototype.generateProperties=function(node){var _this=this,props={},elements=node.elements(),empty=!0;return elements.forEach(function(p){var name=p.attrValue("name");if("string"==typeof name){name=name.trim();var optional=p.optional();props[name]=_this.generateProperty(p,optional),empty=!1}}),props},ModelToSchemaGenerator}();exports.ModelToSchemaGenerator=ModelToSchemaGenerator},function(module,exports,__webpack_require__){"use strict";function createTypeDeclaration(typeName){return new parser10impl.TypeDeclarationImpl(typeName)}function createObjectTypeDeclaration(typeName){return new parser10impl.ObjectTypeDeclarationImpl(typeName)}function setTypeDeclarationSchema(type,schema){type.setSchema(schema)}function setTypeDeclarationExample(type,example){var examplePropName=(defSys.getUniverse("RAML10").type(defSys.universesInfo.Universe10.ExampleSpec.name),defSys.universesInfo.Universe10.TypeDeclaration.properties.example.name),hlParent=type.highLevel(),llParent=hlParent.lowLevel(),exampleNodes=hlParent.children().filter(function(x){return x.lowLevel().key()==examplePropName}),llNode=jsyaml.createNode(examplePropName);ll.setAttr(llNode,example),exampleNodes.length>0&&(ll.removeNode(llParent,exampleNodes[0].lowLevel()),exampleNodes[0]._node=llNode,ll.insertNode(llParent,llNode)),hlParent.createAttr&&hlParent.createAttr(examplePropName,example)}function addChild(parent,child){parent.add(child)}var parser10impl=__webpack_require__(21),defSys=__webpack_require__(36),jsyaml=__webpack_require__(28),ll=__webpack_require__(11);exports.createTypeDeclaration=createTypeDeclaration,exports.createObjectTypeDeclaration=createObjectTypeDeclaration,exports.setTypeDeclarationSchema=setTypeDeclarationSchema,exports.setTypeDeclarationExample=setTypeDeclarationExample,exports.addChild=addChild},function(module,exports,__webpack_require__){"use strict";function createApi(key){var universe=def.getUniverse("RAML10"),nc=universe.type("Api"),node=stubs.createStubNode(nc,null,key);return node}function createLibraryBase(key){var universe=def.getUniverse("RAML10"),nc=universe.type("LibraryBase"),node=stubs.createStubNode(nc,null,key);return node}function createFragmentDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("FragmentDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createTrait(key){var universe=def.getUniverse("RAML10"),nc=universe.type("Trait"),node=stubs.createStubNode(nc,null,key);return node}function createMethodBase(key){var universe=def.getUniverse("RAML10"),nc=universe.type("MethodBase"),node=stubs.createStubNode(nc,null,key);return node}function createOperation(key){var universe=def.getUniverse("RAML10"),nc=universe.type("Operation"),node=stubs.createStubNode(nc,null,key);return node}function createTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("TypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createUsesDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("UsesDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createXMLFacetInfo(key){var universe=def.getUniverse("RAML10"),nc=universe.type("XMLFacetInfo"),node=stubs.createStubNode(nc,null,key);return node}function createArrayTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("ArrayTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createUnionTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("UnionTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createObjectTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("ObjectTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createStringTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("StringTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createBooleanTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("BooleanTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createNumberTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("NumberTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createIntegerTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("IntegerTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createDateOnlyTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("DateOnlyTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createTimeOnlyTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("TimeOnlyTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createDateTimeOnlyTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("DateTimeOnlyTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createDateTimeTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("DateTimeTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createFileTypeDeclaration(key){var universe=def.getUniverse("RAML10"),nc=universe.type("FileTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createResponse(key){var universe=def.getUniverse("RAML10"),nc=universe.type("Response"),node=stubs.createStubNode(nc,null,key);return node}function createSecuritySchemePart(key){var universe=def.getUniverse("RAML10"),nc=universe.type("SecuritySchemePart"),node=stubs.createStubNode(nc,null,key);return node}function createAbstractSecurityScheme(key){var universe=def.getUniverse("RAML10"),nc=universe.type("AbstractSecurityScheme"),node=stubs.createStubNode(nc,null,key);return node}function createSecuritySchemeSettings(key){var universe=def.getUniverse("RAML10"),nc=universe.type("SecuritySchemeSettings"),node=stubs.createStubNode(nc,null,key);return node}function createOAuth1SecuritySchemeSettings(key){var universe=def.getUniverse("RAML10"),nc=universe.type("OAuth1SecuritySchemeSettings"),node=stubs.createStubNode(nc,null,key);return node}function createOAuth2SecuritySchemeSettings(key){var universe=def.getUniverse("RAML10"),nc=universe.type("OAuth2SecuritySchemeSettings"),node=stubs.createStubNode(nc,null,key);return node}function createOAuth2SecurityScheme(key){var universe=def.getUniverse("RAML10"),nc=universe.type("OAuth2SecurityScheme"),node=stubs.createStubNode(nc,null,key);return node}function createOAuth1SecurityScheme(key){var universe=def.getUniverse("RAML10"),nc=universe.type("OAuth1SecurityScheme"),node=stubs.createStubNode(nc,null,key);return node}function createPassThroughSecurityScheme(key){var universe=def.getUniverse("RAML10"),nc=universe.type("PassThroughSecurityScheme"),node=stubs.createStubNode(nc,null,key);return node}function createBasicSecurityScheme(key){var universe=def.getUniverse("RAML10"),nc=universe.type("BasicSecurityScheme"),node=stubs.createStubNode(nc,null,key);return node}function createDigestSecurityScheme(key){var universe=def.getUniverse("RAML10"),nc=universe.type("DigestSecurityScheme"),node=stubs.createStubNode(nc,null,key);return node}function createCustomSecurityScheme(key){var universe=def.getUniverse("RAML10"),nc=universe.type("CustomSecurityScheme"),node=stubs.createStubNode(nc,null,key);return node}function createMethod(key){var universe=def.getUniverse("RAML10"),nc=universe.type("Method"),node=stubs.createStubNode(nc,null,key);return node}function createResourceType(key){var universe=def.getUniverse("RAML10"),nc=universe.type("ResourceType"),node=stubs.createStubNode(nc,null,key);return node}function createResourceBase(key){var universe=def.getUniverse("RAML10"),nc=universe.type("ResourceBase"),node=stubs.createStubNode(nc,null,key);return node}function createResource(key){var universe=def.getUniverse("RAML10"),nc=universe.type("Resource"),node=stubs.createStubNode(nc,null,key);return node}function createDocumentationItem(key){var universe=def.getUniverse("RAML10"),nc=universe.type("DocumentationItem"),node=stubs.createStubNode(nc,null,key);return node}function createLibrary(key){var universe=def.getUniverse("RAML10"),nc=universe.type("Library"),node=stubs.createStubNode(nc,null,key);return node}function createOverlay(key){var universe=def.getUniverse("RAML10"),nc=universe.type("Overlay"),node=stubs.createStubNode(nc,null,key);return node}function createExtension(key){var universe=def.getUniverse("RAML10"),nc=universe.type("Extension"),node=stubs.createStubNode(nc,null,key);return node}function loadApiSync(apiPath,arg1,arg2){return apiLoader.loadApi(apiPath,arg1,arg2).getOrElse(null)}function loadRAMLSync(ramlPath,arg1,arg2){return apiLoader.loadApi(ramlPath,arg1,arg2).getOrElse(null)}function loadApi(apiPath,arg1,arg2){return apiLoader.loadApiAsync(apiPath,arg1,arg2)}function loadRAML(ramlPath,arg1,arg2){return apiLoader.loadRAMLAsync(ramlPath,arg1,arg2)}function getLanguageElementByRuntimeType(runtimeType){return apiLoader.getLanguageElementByRuntimeType(runtimeType)}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},stubs=__webpack_require__(17),def=__webpack_require__(36),core=__webpack_require__(45),apiLoader=__webpack_require__(9),helper=__webpack_require__(33),AnnotableImpl=function(_super){function AnnotableImpl(){_super.apply(this,arguments)}return __extends(AnnotableImpl,_super),AnnotableImpl.prototype.annotations=function(){return _super.prototype.attributes.call(this,"annotations",function(attr){return new AnnotationRefImpl(attr)})},AnnotableImpl.prototype.wrapperClassName=function(){return"AnnotableImpl"},AnnotableImpl.prototype.kind=function(){return"Annotable"},AnnotableImpl.prototype.RAMLVersion=function(){return"RAML10"},AnnotableImpl.prototype.scalarsAnnotations=function(){return new AnnotableScalarsAnnotationsImpl(this.highLevel())},AnnotableImpl}(core.BasicNodeImpl);exports.AnnotableImpl=AnnotableImpl;var ValueTypeImpl=function(_super){function ValueTypeImpl(){_super.apply(this,arguments)}return __extends(ValueTypeImpl,_super),ValueTypeImpl.prototype.wrapperClassName=function(){return"ValueTypeImpl"},ValueTypeImpl.prototype.kind=function(){return"ValueType"},ValueTypeImpl.prototype.RAMLVersion=function(){return"undefined"},ValueTypeImpl.prototype.value=function(){return this.attr.value()},ValueTypeImpl}(core.AttributeNodeImpl);exports.ValueTypeImpl=ValueTypeImpl;var StringTypeImpl=function(_super){function StringTypeImpl(){_super.apply(this,arguments)}return __extends(StringTypeImpl,_super),StringTypeImpl.prototype.wrapperClassName=function(){return"StringTypeImpl"},StringTypeImpl.prototype.kind=function(){return"StringType"},StringTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},StringTypeImpl.prototype.value=function(){return this.attr.value()},StringTypeImpl}(ValueTypeImpl);exports.StringTypeImpl=StringTypeImpl;var UriTemplateImpl=function(_super){function UriTemplateImpl(){_super.apply(this,arguments)}return __extends(UriTemplateImpl,_super),UriTemplateImpl.prototype.wrapperClassName=function(){return"UriTemplateImpl"},UriTemplateImpl.prototype.kind=function(){return"UriTemplate"},UriTemplateImpl.prototype.RAMLVersion=function(){return"RAML10"},UriTemplateImpl}(StringTypeImpl);exports.UriTemplateImpl=UriTemplateImpl;var RelativeUriStringImpl=function(_super){function RelativeUriStringImpl(){_super.apply(this,arguments)}return __extends(RelativeUriStringImpl,_super),RelativeUriStringImpl.prototype.wrapperClassName=function(){return"RelativeUriStringImpl"},RelativeUriStringImpl.prototype.kind=function(){return"RelativeUriString"},RelativeUriStringImpl.prototype.RAMLVersion=function(){return"RAML10"},RelativeUriStringImpl}(UriTemplateImpl);exports.RelativeUriStringImpl=RelativeUriStringImpl;var FullUriTemplateStringImpl=function(_super){function FullUriTemplateStringImpl(){_super.apply(this,arguments)}return __extends(FullUriTemplateStringImpl,_super),FullUriTemplateStringImpl.prototype.wrapperClassName=function(){return"FullUriTemplateStringImpl"},FullUriTemplateStringImpl.prototype.kind=function(){return"FullUriTemplateString"},FullUriTemplateStringImpl.prototype.RAMLVersion=function(){return"RAML10"},FullUriTemplateStringImpl}(UriTemplateImpl);exports.FullUriTemplateStringImpl=FullUriTemplateStringImpl;var StatusCodeStringImpl=function(_super){function StatusCodeStringImpl(){_super.apply(this,arguments)}return __extends(StatusCodeStringImpl,_super),StatusCodeStringImpl.prototype.wrapperClassName=function(){return"StatusCodeStringImpl"},StatusCodeStringImpl.prototype.kind=function(){return"StatusCodeString"},StatusCodeStringImpl.prototype.RAMLVersion=function(){return"RAML10"},StatusCodeStringImpl}(StringTypeImpl);exports.StatusCodeStringImpl=StatusCodeStringImpl;var FixedUriStringImpl=function(_super){function FixedUriStringImpl(){_super.apply(this,arguments)}return __extends(FixedUriStringImpl,_super),FixedUriStringImpl.prototype.wrapperClassName=function(){return"FixedUriStringImpl"},FixedUriStringImpl.prototype.kind=function(){return"FixedUriString"},FixedUriStringImpl.prototype.RAMLVersion=function(){return"RAML10"},FixedUriStringImpl}(StringTypeImpl);exports.FixedUriStringImpl=FixedUriStringImpl;var ContentTypeImpl=function(_super){function ContentTypeImpl(){_super.apply(this,arguments)}return __extends(ContentTypeImpl,_super),ContentTypeImpl.prototype.wrapperClassName=function(){return"ContentTypeImpl"},ContentTypeImpl.prototype.kind=function(){return"ContentType"},ContentTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},ContentTypeImpl}(StringTypeImpl);exports.ContentTypeImpl=ContentTypeImpl;var MarkdownStringImpl=function(_super){function MarkdownStringImpl(){_super.apply(this,arguments)}return __extends(MarkdownStringImpl,_super),MarkdownStringImpl.prototype.wrapperClassName=function(){return"MarkdownStringImpl"},MarkdownStringImpl.prototype.kind=function(){return"MarkdownString"},MarkdownStringImpl.prototype.RAMLVersion=function(){return"RAML10"},MarkdownStringImpl}(StringTypeImpl);exports.MarkdownStringImpl=MarkdownStringImpl;var SchemaStringImpl=function(_super){function SchemaStringImpl(){_super.apply(this,arguments)}return __extends(SchemaStringImpl,_super),SchemaStringImpl.prototype.wrapperClassName=function(){return"SchemaStringImpl"},SchemaStringImpl.prototype.kind=function(){return"SchemaString"},SchemaStringImpl.prototype.RAMLVersion=function(){return"RAML10"},SchemaStringImpl}(StringTypeImpl);exports.SchemaStringImpl=SchemaStringImpl;var MimeTypeImpl=function(_super){function MimeTypeImpl(){_super.apply(this,arguments)}return __extends(MimeTypeImpl,_super),MimeTypeImpl.prototype.wrapperClassName=function(){return"MimeTypeImpl"},MimeTypeImpl.prototype.kind=function(){return"MimeType"},MimeTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},MimeTypeImpl}(StringTypeImpl);exports.MimeTypeImpl=MimeTypeImpl;var AnyTypeImpl=function(_super){function AnyTypeImpl(){_super.apply(this,arguments)}return __extends(AnyTypeImpl,_super),AnyTypeImpl.prototype.wrapperClassName=function(){return"AnyTypeImpl"},AnyTypeImpl.prototype.kind=function(){return"AnyType"},AnyTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},AnyTypeImpl}(ValueTypeImpl);exports.AnyTypeImpl=AnyTypeImpl;var NumberTypeImpl=function(_super){function NumberTypeImpl(){_super.apply(this,arguments)}return __extends(NumberTypeImpl,_super),NumberTypeImpl.prototype.wrapperClassName=function(){return"NumberTypeImpl"},NumberTypeImpl.prototype.kind=function(){return"NumberType"},NumberTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},NumberTypeImpl.prototype.value=function(){return this.attr.value()},NumberTypeImpl}(ValueTypeImpl);exports.NumberTypeImpl=NumberTypeImpl;var IntegerTypeImpl=function(_super){function IntegerTypeImpl(){_super.apply(this,arguments)}return __extends(IntegerTypeImpl,_super),IntegerTypeImpl.prototype.wrapperClassName=function(){return"IntegerTypeImpl"},IntegerTypeImpl.prototype.kind=function(){return"IntegerType"},IntegerTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},IntegerTypeImpl}(ValueTypeImpl);exports.IntegerTypeImpl=IntegerTypeImpl;var NullTypeImpl=function(_super){function NullTypeImpl(){_super.apply(this,arguments)}return __extends(NullTypeImpl,_super),NullTypeImpl.prototype.wrapperClassName=function(){return"NullTypeImpl"},NullTypeImpl.prototype.kind=function(){return"NullType"},NullTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},NullTypeImpl}(ValueTypeImpl);exports.NullTypeImpl=NullTypeImpl;var TimeOnlyTypeImpl=function(_super){function TimeOnlyTypeImpl(){_super.apply(this,arguments)}return __extends(TimeOnlyTypeImpl,_super),TimeOnlyTypeImpl.prototype.wrapperClassName=function(){return"TimeOnlyTypeImpl"},TimeOnlyTypeImpl.prototype.kind=function(){return"TimeOnlyType"},TimeOnlyTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},TimeOnlyTypeImpl}(ValueTypeImpl);exports.TimeOnlyTypeImpl=TimeOnlyTypeImpl;var DateOnlyTypeImpl=function(_super){function DateOnlyTypeImpl(){_super.apply(this,arguments)}return __extends(DateOnlyTypeImpl,_super),DateOnlyTypeImpl.prototype.wrapperClassName=function(){return"DateOnlyTypeImpl"},DateOnlyTypeImpl.prototype.kind=function(){return"DateOnlyType"},DateOnlyTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},DateOnlyTypeImpl}(ValueTypeImpl);exports.DateOnlyTypeImpl=DateOnlyTypeImpl;var DateTimeOnlyTypeImpl=function(_super){function DateTimeOnlyTypeImpl(){_super.apply(this,arguments)}return __extends(DateTimeOnlyTypeImpl,_super),DateTimeOnlyTypeImpl.prototype.wrapperClassName=function(){return"DateTimeOnlyTypeImpl"},DateTimeOnlyTypeImpl.prototype.kind=function(){return"DateTimeOnlyType"},DateTimeOnlyTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},DateTimeOnlyTypeImpl}(ValueTypeImpl);exports.DateTimeOnlyTypeImpl=DateTimeOnlyTypeImpl;var DateTimeTypeImpl=function(_super){function DateTimeTypeImpl(){_super.apply(this,arguments)}return __extends(DateTimeTypeImpl,_super),DateTimeTypeImpl.prototype.wrapperClassName=function(){return"DateTimeTypeImpl"},DateTimeTypeImpl.prototype.kind=function(){return"DateTimeType"},DateTimeTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},DateTimeTypeImpl}(ValueTypeImpl);exports.DateTimeTypeImpl=DateTimeTypeImpl;var FileTypeImpl=function(_super){function FileTypeImpl(){_super.apply(this,arguments)}return __extends(FileTypeImpl,_super),FileTypeImpl.prototype.wrapperClassName=function(){return"FileTypeImpl"},FileTypeImpl.prototype.kind=function(){return"FileType"},FileTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},FileTypeImpl}(ValueTypeImpl);exports.FileTypeImpl=FileTypeImpl;var BooleanTypeImpl=function(_super){function BooleanTypeImpl(){_super.apply(this,arguments)}return __extends(BooleanTypeImpl,_super),BooleanTypeImpl.prototype.wrapperClassName=function(){return"BooleanTypeImpl"},BooleanTypeImpl.prototype.kind=function(){return"BooleanType"},BooleanTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},BooleanTypeImpl.prototype.value=function(){return this.attr.value()},BooleanTypeImpl}(ValueTypeImpl);exports.BooleanTypeImpl=BooleanTypeImpl;var AnnotationTargetImpl=function(_super){function AnnotationTargetImpl(){_super.apply(this,arguments)}return __extends(AnnotationTargetImpl,_super),AnnotationTargetImpl.prototype.wrapperClassName=function(){return"AnnotationTargetImpl"},AnnotationTargetImpl.prototype.kind=function(){return"AnnotationTarget"},AnnotationTargetImpl.prototype.RAMLVersion=function(){return"RAML10"},AnnotationTargetImpl}(ValueTypeImpl);exports.AnnotationTargetImpl=AnnotationTargetImpl;var ReferenceImpl=function(_super){function ReferenceImpl(){_super.apply(this,arguments)}return __extends(ReferenceImpl,_super),ReferenceImpl.prototype.wrapperClassName=function(){return"ReferenceImpl"},ReferenceImpl.prototype.kind=function(){return"Reference"},ReferenceImpl.prototype.RAMLVersion=function(){return"RAML10"},ReferenceImpl.prototype.value=function(){return core.toStructuredValue(this.attr)},ReferenceImpl.prototype.structuredValue=function(){return helper.structuredValue(this)},ReferenceImpl.prototype.name=function(){return helper.referenceName(this)},ReferenceImpl}(core.AttributeNodeImpl);exports.ReferenceImpl=ReferenceImpl;var TraitRefImpl=function(_super){function TraitRefImpl(){_super.apply(this,arguments)}return __extends(TraitRefImpl,_super),TraitRefImpl.prototype.wrapperClassName=function(){return"TraitRefImpl"},TraitRefImpl.prototype.kind=function(){return"TraitRef"},TraitRefImpl.prototype.RAMLVersion=function(){return"RAML10"},TraitRefImpl.prototype.trait=function(){return helper.referencedTrait(this)},TraitRefImpl}(ReferenceImpl);exports.TraitRefImpl=TraitRefImpl;var OperationImpl=function(_super){function OperationImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createOperation(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(OperationImpl,_super),OperationImpl.prototype.queryParameters=function(){return _super.prototype.elements.call(this,"queryParameters")},OperationImpl.prototype.headers=function(){return _super.prototype.elements.call(this,"headers")},OperationImpl.prototype.queryString=function(){return _super.prototype.element.call(this,"queryString")},OperationImpl.prototype.responses=function(){return _super.prototype.elements.call(this,"responses")},OperationImpl.prototype.wrapperClassName=function(){return"OperationImpl"},OperationImpl.prototype.kind=function(){return"Operation"},OperationImpl.prototype.RAMLVersion=function(){return"RAML10"},OperationImpl}(AnnotableImpl);exports.OperationImpl=OperationImpl;var TypeDeclarationImpl=function(_super){
function TypeDeclarationImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(TypeDeclarationImpl,_super),TypeDeclarationImpl.prototype.name=function(){return _super.prototype.attribute.call(this,"name",this.toString)},TypeDeclarationImpl.prototype.setName=function(param){return this.highLevel().attrOrCreate("name").setValue(""+param),this},TypeDeclarationImpl.prototype.displayName=function(){return _super.prototype.attribute.call(this,"displayName",this.toString)},TypeDeclarationImpl.prototype.setDisplayName=function(param){return this.highLevel().attrOrCreate("displayName").setValue(""+param),this},TypeDeclarationImpl.prototype.facets=function(){return _super.prototype.elements.call(this,"facets")},TypeDeclarationImpl.prototype.schema_original=function(){return _super.prototype.attributes.call(this,"schema",this.toString)},TypeDeclarationImpl.prototype.setSchema=function(param){return this.highLevel().attrOrCreate("schema").setValue(""+param),this},TypeDeclarationImpl.prototype.type_original=function(){return _super.prototype.attributes.call(this,"type",this.toString)},TypeDeclarationImpl.prototype.setType=function(param){return this.highLevel().attrOrCreate("type").setValue(""+param),this},TypeDeclarationImpl.prototype.location=function(){return _super.prototype.attribute.call(this,"location",function(attr){return new ModelLocationImpl(attr)})},TypeDeclarationImpl.prototype.locationKind=function(){return _super.prototype.attribute.call(this,"locationKind",function(attr){return new LocationKindImpl(attr)})},TypeDeclarationImpl.prototype["default"]=function(){return _super.prototype.attribute.call(this,"default",this.toAny)},TypeDeclarationImpl.prototype.setDefault=function(param){return this.highLevel().attrOrCreate("default").setValue(""+param),this},TypeDeclarationImpl.prototype.example_original=function(){return _super.prototype.element.call(this,"example")},TypeDeclarationImpl.prototype.examples_original=function(){return _super.prototype.elements.call(this,"examples")},TypeDeclarationImpl.prototype.required=function(){return _super.prototype.attribute.call(this,"required",this.toBoolean)},TypeDeclarationImpl.prototype.setRequired=function(param){return this.highLevel().attrOrCreate("required").setValue(""+param),this},TypeDeclarationImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},TypeDeclarationImpl.prototype.xml=function(){return _super.prototype.element.call(this,"xml")},TypeDeclarationImpl.prototype.allowedTargets=function(){return _super.prototype.attributes.call(this,"allowedTargets",function(attr){return new AnnotationTargetImpl(attr)})},TypeDeclarationImpl.prototype.isAnnotation=function(){return _super.prototype.attribute.call(this,"isAnnotation",this.toBoolean)},TypeDeclarationImpl.prototype.setIsAnnotation=function(param){return this.highLevel().attrOrCreate("isAnnotation").setValue(""+param),this},TypeDeclarationImpl.prototype.annotations=function(){return _super.prototype.attributes.call(this,"annotations",function(attr){return new AnnotationRefImpl(attr)})},TypeDeclarationImpl.prototype.uses=function(){return _super.prototype.elements.call(this,"uses")},TypeDeclarationImpl.prototype.wrapperClassName=function(){return"TypeDeclarationImpl"},TypeDeclarationImpl.prototype.kind=function(){return"TypeDeclaration"},TypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},TypeDeclarationImpl.prototype.runtimeType=function(){return helper.runtimeType(this)},TypeDeclarationImpl.prototype.validateInstance=function(value){return helper.validateInstance(this,value)},TypeDeclarationImpl.prototype.validateInstanceWithDetailedStatuses=function(value){return helper.validateInstanceWithDetailedStatuses(this,value)},TypeDeclarationImpl.prototype.example=function(){return helper.getTypeExample(this)},TypeDeclarationImpl.prototype.examples=function(){return helper.getTypeExamples(this)},TypeDeclarationImpl.prototype.fixedFacets=function(){return helper.typeFixedFacets(this)},TypeDeclarationImpl.prototype.type=function(){return helper.typeValue(this)},TypeDeclarationImpl.prototype.schema=function(){return helper.schemaValue(this)},TypeDeclarationImpl.prototype.structuredType=function(){return helper.typeStructuredValue(this)},TypeDeclarationImpl.prototype.parametrizedProperties=function(){return helper.getTemplateParametrizedProperties(this)},TypeDeclarationImpl.prototype.scalarsAnnotations=function(){return new TypeDeclarationScalarsAnnotationsImpl(this.highLevel())},TypeDeclarationImpl}(AnnotableImpl);exports.TypeDeclarationImpl=TypeDeclarationImpl;var ModelLocationImpl=function(){function ModelLocationImpl(attr){this.attr=attr}return ModelLocationImpl.prototype.wrapperClassName=function(){return"ModelLocationImpl"},ModelLocationImpl.prototype.kind=function(){return"ModelLocation"},ModelLocationImpl.prototype.RAMLVersion=function(){return"RAML10"},ModelLocationImpl}();exports.ModelLocationImpl=ModelLocationImpl;var LocationKindImpl=function(){function LocationKindImpl(attr){this.attr=attr}return LocationKindImpl.prototype.wrapperClassName=function(){return"LocationKindImpl"},LocationKindImpl.prototype.kind=function(){return"LocationKind"},LocationKindImpl.prototype.RAMLVersion=function(){return"RAML10"},LocationKindImpl}();exports.LocationKindImpl=LocationKindImpl;var UsesDeclarationImpl=function(_super){function UsesDeclarationImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createUsesDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(UsesDeclarationImpl,_super),UsesDeclarationImpl.prototype.key=function(){return _super.prototype.attribute.call(this,"key",this.toString)},UsesDeclarationImpl.prototype.setKey=function(param){return this.highLevel().attrOrCreate("key").setValue(""+param),this},UsesDeclarationImpl.prototype.value=function(){return _super.prototype.attribute.call(this,"value",this.toString)},UsesDeclarationImpl.prototype.setValue=function(param){return this.highLevel().attrOrCreate("value").setValue(""+param),this},UsesDeclarationImpl.prototype.wrapperClassName=function(){return"UsesDeclarationImpl"},UsesDeclarationImpl.prototype.kind=function(){return"UsesDeclaration"},UsesDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},UsesDeclarationImpl.prototype.ast=function(){return helper.referencedNode(this)},UsesDeclarationImpl.prototype.scalarsAnnotations=function(){return new UsesDeclarationScalarsAnnotationsImpl(this.highLevel())},UsesDeclarationImpl}(AnnotableImpl);exports.UsesDeclarationImpl=UsesDeclarationImpl;var AnnotableScalarsAnnotationsImpl=function(){function AnnotableScalarsAnnotationsImpl(node){this.node=node}return AnnotableScalarsAnnotationsImpl.prototype.annotations=function(){var attrs=this.node.attributes("annotations");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},AnnotableScalarsAnnotationsImpl}();exports.AnnotableScalarsAnnotationsImpl=AnnotableScalarsAnnotationsImpl;var UsesDeclarationScalarsAnnotationsImpl=function(_super){function UsesDeclarationScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(UsesDeclarationScalarsAnnotationsImpl,_super),UsesDeclarationScalarsAnnotationsImpl.prototype.value=function(){var attr=this.node.attr("value");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},UsesDeclarationScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.UsesDeclarationScalarsAnnotationsImpl=UsesDeclarationScalarsAnnotationsImpl;var XMLFacetInfoImpl=function(_super){function XMLFacetInfoImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createXMLFacetInfo(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(XMLFacetInfoImpl,_super),XMLFacetInfoImpl.prototype.attribute=function(){return _super.prototype.attribute.call(this,"attribute",this.toBoolean)},XMLFacetInfoImpl.prototype.setAttribute=function(param){return this.highLevel().attrOrCreate("attribute").setValue(""+param),this},XMLFacetInfoImpl.prototype.wrapped=function(){return _super.prototype.attribute.call(this,"wrapped",this.toBoolean)},XMLFacetInfoImpl.prototype.setWrapped=function(param){return this.highLevel().attrOrCreate("wrapped").setValue(""+param),this},XMLFacetInfoImpl.prototype.name=function(){return _super.prototype.attribute.call(this,"name",this.toString)},XMLFacetInfoImpl.prototype.setName=function(param){return this.highLevel().attrOrCreate("name").setValue(""+param),this},XMLFacetInfoImpl.prototype.namespace=function(){return _super.prototype.attribute.call(this,"namespace",this.toString)},XMLFacetInfoImpl.prototype.setNamespace=function(param){return this.highLevel().attrOrCreate("namespace").setValue(""+param),this},XMLFacetInfoImpl.prototype.prefix=function(){return _super.prototype.attribute.call(this,"prefix",this.toString)},XMLFacetInfoImpl.prototype.setPrefix=function(param){return this.highLevel().attrOrCreate("prefix").setValue(""+param),this},XMLFacetInfoImpl.prototype.wrapperClassName=function(){return"XMLFacetInfoImpl"},XMLFacetInfoImpl.prototype.kind=function(){return"XMLFacetInfo"},XMLFacetInfoImpl.prototype.RAMLVersion=function(){return"RAML10"},XMLFacetInfoImpl.prototype.scalarsAnnotations=function(){return new XMLFacetInfoScalarsAnnotationsImpl(this.highLevel())},XMLFacetInfoImpl}(AnnotableImpl);exports.XMLFacetInfoImpl=XMLFacetInfoImpl;var XMLFacetInfoScalarsAnnotationsImpl=function(_super){function XMLFacetInfoScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(XMLFacetInfoScalarsAnnotationsImpl,_super),XMLFacetInfoScalarsAnnotationsImpl.prototype.attribute=function(){var attr=this.node.attr("attribute");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},XMLFacetInfoScalarsAnnotationsImpl.prototype.wrapped=function(){var attr=this.node.attr("wrapped");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},XMLFacetInfoScalarsAnnotationsImpl.prototype.name=function(){var attr=this.node.attr("name");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},XMLFacetInfoScalarsAnnotationsImpl.prototype.namespace=function(){var attr=this.node.attr("namespace");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},XMLFacetInfoScalarsAnnotationsImpl.prototype.prefix=function(){var attr=this.node.attr("prefix");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},XMLFacetInfoScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.XMLFacetInfoScalarsAnnotationsImpl=XMLFacetInfoScalarsAnnotationsImpl;var ArrayTypeDeclarationImpl=function(_super){function ArrayTypeDeclarationImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createArrayTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(ArrayTypeDeclarationImpl,_super),ArrayTypeDeclarationImpl.prototype.uniqueItems=function(){return _super.prototype.attribute.call(this,"uniqueItems",this.toBoolean)},ArrayTypeDeclarationImpl.prototype.setUniqueItems=function(param){return this.highLevel().attrOrCreate("uniqueItems").setValue(""+param),this},ArrayTypeDeclarationImpl.prototype.items_original=function(){return _super.prototype.element.call(this,"items")},ArrayTypeDeclarationImpl.prototype.minItems=function(){return _super.prototype.attribute.call(this,"minItems",this.toNumber)},ArrayTypeDeclarationImpl.prototype.setMinItems=function(param){return this.highLevel().attrOrCreate("minItems").setValue(""+param),this},ArrayTypeDeclarationImpl.prototype.maxItems=function(){return _super.prototype.attribute.call(this,"maxItems",this.toNumber)},ArrayTypeDeclarationImpl.prototype.setMaxItems=function(param){return this.highLevel().attrOrCreate("maxItems").setValue(""+param),this},ArrayTypeDeclarationImpl.prototype.wrapperClassName=function(){return"ArrayTypeDeclarationImpl"},ArrayTypeDeclarationImpl.prototype.kind=function(){return"ArrayTypeDeclaration"},ArrayTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},ArrayTypeDeclarationImpl.prototype.items=function(){return helper.getItems(this)},ArrayTypeDeclarationImpl.prototype.findComponentTypeDeclaration=function(){return helper.findComponentTypeDeclaration(this)},ArrayTypeDeclarationImpl.prototype.scalarsAnnotations=function(){return new ArrayTypeDeclarationScalarsAnnotationsImpl(this.highLevel())},ArrayTypeDeclarationImpl}(TypeDeclarationImpl);exports.ArrayTypeDeclarationImpl=ArrayTypeDeclarationImpl;var TypeDeclarationScalarsAnnotationsImpl=function(_super){function TypeDeclarationScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(TypeDeclarationScalarsAnnotationsImpl,_super),TypeDeclarationScalarsAnnotationsImpl.prototype.displayName=function(){var attr=this.node.attr("displayName");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},TypeDeclarationScalarsAnnotationsImpl.prototype.schema=function(){var attrs=this.node.attributes("schema");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},TypeDeclarationScalarsAnnotationsImpl.prototype.type=function(){var attrs=this.node.attributes("type");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},TypeDeclarationScalarsAnnotationsImpl.prototype.location=function(){var attr=this.node.attr("location");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},TypeDeclarationScalarsAnnotationsImpl.prototype.locationKind=function(){var attr=this.node.attr("locationKind");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},TypeDeclarationScalarsAnnotationsImpl.prototype["default"]=function(){var attr=this.node.attr("default");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},TypeDeclarationScalarsAnnotationsImpl.prototype.required=function(){var attr=this.node.attr("required");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},TypeDeclarationScalarsAnnotationsImpl.prototype.description=function(){var attr=this.node.attr("description");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},TypeDeclarationScalarsAnnotationsImpl.prototype.allowedTargets=function(){var attrs=this.node.attributes("allowedTargets");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},TypeDeclarationScalarsAnnotationsImpl.prototype.isAnnotation=function(){var attr=this.node.attr("isAnnotation");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},TypeDeclarationScalarsAnnotationsImpl.prototype.annotations=function(){var attrs=this.node.attributes("annotations");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},TypeDeclarationScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.TypeDeclarationScalarsAnnotationsImpl=TypeDeclarationScalarsAnnotationsImpl;var ArrayTypeDeclarationScalarsAnnotationsImpl=function(_super){function ArrayTypeDeclarationScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(ArrayTypeDeclarationScalarsAnnotationsImpl,_super),ArrayTypeDeclarationScalarsAnnotationsImpl.prototype.uniqueItems=function(){var attr=this.node.attr("uniqueItems");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ArrayTypeDeclarationScalarsAnnotationsImpl.prototype.minItems=function(){var attr=this.node.attr("minItems");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ArrayTypeDeclarationScalarsAnnotationsImpl.prototype.maxItems=function(){var attr=this.node.attr("maxItems");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ArrayTypeDeclarationScalarsAnnotationsImpl}(TypeDeclarationScalarsAnnotationsImpl);exports.ArrayTypeDeclarationScalarsAnnotationsImpl=ArrayTypeDeclarationScalarsAnnotationsImpl;var UnionTypeDeclarationImpl=function(_super){function UnionTypeDeclarationImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createUnionTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(UnionTypeDeclarationImpl,_super),UnionTypeDeclarationImpl.prototype.wrapperClassName=function(){return"UnionTypeDeclarationImpl"},UnionTypeDeclarationImpl.prototype.kind=function(){return"UnionTypeDeclaration"},UnionTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},UnionTypeDeclarationImpl}(TypeDeclarationImpl);exports.UnionTypeDeclarationImpl=UnionTypeDeclarationImpl;var ObjectTypeDeclarationImpl=function(_super){function ObjectTypeDeclarationImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createObjectTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(ObjectTypeDeclarationImpl,_super),ObjectTypeDeclarationImpl.prototype.properties=function(){return _super.prototype.elements.call(this,"properties")},ObjectTypeDeclarationImpl.prototype.minProperties=function(){return _super.prototype.attribute.call(this,"minProperties",this.toNumber)},ObjectTypeDeclarationImpl.prototype.setMinProperties=function(param){return this.highLevel().attrOrCreate("minProperties").setValue(""+param),this},ObjectTypeDeclarationImpl.prototype.maxProperties=function(){return _super.prototype.attribute.call(this,"maxProperties",this.toNumber)},ObjectTypeDeclarationImpl.prototype.setMaxProperties=function(param){return this.highLevel().attrOrCreate("maxProperties").setValue(""+param),this},ObjectTypeDeclarationImpl.prototype.additionalProperties=function(){return _super.prototype.attribute.call(this,"additionalProperties",this.toBoolean)},ObjectTypeDeclarationImpl.prototype.setAdditionalProperties=function(param){return this.highLevel().attrOrCreate("additionalProperties").setValue(""+param),this},ObjectTypeDeclarationImpl.prototype.discriminator=function(){return _super.prototype.attribute.call(this,"discriminator",this.toString)},ObjectTypeDeclarationImpl.prototype.setDiscriminator=function(param){return this.highLevel().attrOrCreate("discriminator").setValue(""+param),this},ObjectTypeDeclarationImpl.prototype.discriminatorValue=function(){return _super.prototype.attribute.call(this,"discriminatorValue",this.toString)},ObjectTypeDeclarationImpl.prototype.setDiscriminatorValue=function(param){return this.highLevel().attrOrCreate("discriminatorValue").setValue(""+param),this},ObjectTypeDeclarationImpl.prototype.wrapperClassName=function(){return"ObjectTypeDeclarationImpl"},ObjectTypeDeclarationImpl.prototype.kind=function(){return"ObjectTypeDeclaration"},ObjectTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},ObjectTypeDeclarationImpl.prototype.scalarsAnnotations=function(){return new ObjectTypeDeclarationScalarsAnnotationsImpl(this.highLevel())},ObjectTypeDeclarationImpl}(TypeDeclarationImpl);exports.ObjectTypeDeclarationImpl=ObjectTypeDeclarationImpl;var ObjectTypeDeclarationScalarsAnnotationsImpl=function(_super){function ObjectTypeDeclarationScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(ObjectTypeDeclarationScalarsAnnotationsImpl,_super),ObjectTypeDeclarationScalarsAnnotationsImpl.prototype.minProperties=function(){var attr=this.node.attr("minProperties");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ObjectTypeDeclarationScalarsAnnotationsImpl.prototype.maxProperties=function(){var attr=this.node.attr("maxProperties");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ObjectTypeDeclarationScalarsAnnotationsImpl.prototype.additionalProperties=function(){var attr=this.node.attr("additionalProperties");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ObjectTypeDeclarationScalarsAnnotationsImpl.prototype.discriminator=function(){var attr=this.node.attr("discriminator");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ObjectTypeDeclarationScalarsAnnotationsImpl.prototype.discriminatorValue=function(){var attr=this.node.attr("discriminatorValue");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ObjectTypeDeclarationScalarsAnnotationsImpl}(TypeDeclarationScalarsAnnotationsImpl);exports.ObjectTypeDeclarationScalarsAnnotationsImpl=ObjectTypeDeclarationScalarsAnnotationsImpl;var StringTypeDeclarationImpl=function(_super){function StringTypeDeclarationImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createStringTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(StringTypeDeclarationImpl,_super),StringTypeDeclarationImpl.prototype.pattern=function(){return _super.prototype.attribute.call(this,"pattern",this.toString)},StringTypeDeclarationImpl.prototype.setPattern=function(param){return this.highLevel().attrOrCreate("pattern").setValue(""+param),this},StringTypeDeclarationImpl.prototype.minLength=function(){return _super.prototype.attribute.call(this,"minLength",this.toNumber)},StringTypeDeclarationImpl.prototype.setMinLength=function(param){return this.highLevel().attrOrCreate("minLength").setValue(""+param),this},StringTypeDeclarationImpl.prototype.maxLength=function(){return _super.prototype.attribute.call(this,"maxLength",this.toNumber)},StringTypeDeclarationImpl.prototype.setMaxLength=function(param){return this.highLevel().attrOrCreate("maxLength").setValue(""+param),this},StringTypeDeclarationImpl.prototype["enum"]=function(){return _super.prototype.attributes.call(this,"enum",this.toString)},StringTypeDeclarationImpl.prototype.setEnum=function(param){return this.highLevel().attrOrCreate("enum").setValue(""+param),this},StringTypeDeclarationImpl.prototype.wrapperClassName=function(){return"StringTypeDeclarationImpl"},StringTypeDeclarationImpl.prototype.kind=function(){return"StringTypeDeclaration"},StringTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},StringTypeDeclarationImpl.prototype.scalarsAnnotations=function(){return new StringTypeDeclarationScalarsAnnotationsImpl(this.highLevel())},StringTypeDeclarationImpl}(TypeDeclarationImpl);exports.StringTypeDeclarationImpl=StringTypeDeclarationImpl;var StringTypeDeclarationScalarsAnnotationsImpl=function(_super){function StringTypeDeclarationScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(StringTypeDeclarationScalarsAnnotationsImpl,_super),StringTypeDeclarationScalarsAnnotationsImpl.prototype.pattern=function(){var attr=this.node.attr("pattern");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},StringTypeDeclarationScalarsAnnotationsImpl.prototype.minLength=function(){var attr=this.node.attr("minLength");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},StringTypeDeclarationScalarsAnnotationsImpl.prototype.maxLength=function(){var attr=this.node.attr("maxLength");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},StringTypeDeclarationScalarsAnnotationsImpl.prototype["enum"]=function(){var attrs=this.node.attributes("enum");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},StringTypeDeclarationScalarsAnnotationsImpl}(TypeDeclarationScalarsAnnotationsImpl);exports.StringTypeDeclarationScalarsAnnotationsImpl=StringTypeDeclarationScalarsAnnotationsImpl;var BooleanTypeDeclarationImpl=function(_super){function BooleanTypeDeclarationImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createBooleanTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(BooleanTypeDeclarationImpl,_super),BooleanTypeDeclarationImpl.prototype.wrapperClassName=function(){return"BooleanTypeDeclarationImpl"},BooleanTypeDeclarationImpl.prototype.kind=function(){return"BooleanTypeDeclaration"},BooleanTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},BooleanTypeDeclarationImpl}(TypeDeclarationImpl);exports.BooleanTypeDeclarationImpl=BooleanTypeDeclarationImpl;var NumberTypeDeclarationImpl=function(_super){function NumberTypeDeclarationImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createNumberTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(NumberTypeDeclarationImpl,_super),NumberTypeDeclarationImpl.prototype.minimum=function(){return _super.prototype.attribute.call(this,"minimum",this.toNumber)},NumberTypeDeclarationImpl.prototype.setMinimum=function(param){return this.highLevel().attrOrCreate("minimum").setValue(""+param),this},NumberTypeDeclarationImpl.prototype.maximum=function(){return _super.prototype.attribute.call(this,"maximum",this.toNumber)},NumberTypeDeclarationImpl.prototype.setMaximum=function(param){return this.highLevel().attrOrCreate("maximum").setValue(""+param),this},NumberTypeDeclarationImpl.prototype["enum"]=function(){return _super.prototype.attributes.call(this,"enum",this.toString)},NumberTypeDeclarationImpl.prototype.setEnum=function(param){return this.highLevel().attrOrCreate("enum").setValue(""+param),this},NumberTypeDeclarationImpl.prototype.format=function(){return _super.prototype.attribute.call(this,"format",this.toString)},NumberTypeDeclarationImpl.prototype.setFormat=function(param){return this.highLevel().attrOrCreate("format").setValue(""+param),this},NumberTypeDeclarationImpl.prototype.multipleOf=function(){return _super.prototype.attribute.call(this,"multipleOf",this.toNumber)},NumberTypeDeclarationImpl.prototype.setMultipleOf=function(param){return this.highLevel().attrOrCreate("multipleOf").setValue(""+param),this},NumberTypeDeclarationImpl.prototype.wrapperClassName=function(){return"NumberTypeDeclarationImpl"},NumberTypeDeclarationImpl.prototype.kind=function(){return"NumberTypeDeclaration"},NumberTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},NumberTypeDeclarationImpl.prototype.scalarsAnnotations=function(){return new NumberTypeDeclarationScalarsAnnotationsImpl(this.highLevel())},NumberTypeDeclarationImpl}(TypeDeclarationImpl);exports.NumberTypeDeclarationImpl=NumberTypeDeclarationImpl;var IntegerTypeDeclarationImpl=function(_super){function IntegerTypeDeclarationImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createIntegerTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(IntegerTypeDeclarationImpl,_super),IntegerTypeDeclarationImpl.prototype.format=function(){return _super.prototype.attribute.call(this,"format",this.toString)},IntegerTypeDeclarationImpl.prototype.setFormat=function(param){return this.highLevel().attrOrCreate("format").setValue(""+param),this},IntegerTypeDeclarationImpl.prototype.wrapperClassName=function(){return"IntegerTypeDeclarationImpl"},IntegerTypeDeclarationImpl.prototype.kind=function(){return"IntegerTypeDeclaration"},IntegerTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},IntegerTypeDeclarationImpl.prototype.scalarsAnnotations=function(){return new IntegerTypeDeclarationScalarsAnnotationsImpl(this.highLevel())},IntegerTypeDeclarationImpl}(NumberTypeDeclarationImpl);exports.IntegerTypeDeclarationImpl=IntegerTypeDeclarationImpl;var NumberTypeDeclarationScalarsAnnotationsImpl=function(_super){function NumberTypeDeclarationScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(NumberTypeDeclarationScalarsAnnotationsImpl,_super),NumberTypeDeclarationScalarsAnnotationsImpl.prototype.minimum=function(){var attr=this.node.attr("minimum");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},NumberTypeDeclarationScalarsAnnotationsImpl.prototype.maximum=function(){var attr=this.node.attr("maximum");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},NumberTypeDeclarationScalarsAnnotationsImpl.prototype["enum"]=function(){var attrs=this.node.attributes("enum");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},NumberTypeDeclarationScalarsAnnotationsImpl.prototype.format=function(){
var attr=this.node.attr("format");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},NumberTypeDeclarationScalarsAnnotationsImpl.prototype.multipleOf=function(){var attr=this.node.attr("multipleOf");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},NumberTypeDeclarationScalarsAnnotationsImpl}(TypeDeclarationScalarsAnnotationsImpl);exports.NumberTypeDeclarationScalarsAnnotationsImpl=NumberTypeDeclarationScalarsAnnotationsImpl;var IntegerTypeDeclarationScalarsAnnotationsImpl=function(_super){function IntegerTypeDeclarationScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(IntegerTypeDeclarationScalarsAnnotationsImpl,_super),IntegerTypeDeclarationScalarsAnnotationsImpl.prototype.format=function(){var attr=this.node.attr("format");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},IntegerTypeDeclarationScalarsAnnotationsImpl}(NumberTypeDeclarationScalarsAnnotationsImpl);exports.IntegerTypeDeclarationScalarsAnnotationsImpl=IntegerTypeDeclarationScalarsAnnotationsImpl;var DateOnlyTypeDeclarationImpl=function(_super){function DateOnlyTypeDeclarationImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createDateOnlyTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(DateOnlyTypeDeclarationImpl,_super),DateOnlyTypeDeclarationImpl.prototype.wrapperClassName=function(){return"DateOnlyTypeDeclarationImpl"},DateOnlyTypeDeclarationImpl.prototype.kind=function(){return"DateOnlyTypeDeclaration"},DateOnlyTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},DateOnlyTypeDeclarationImpl}(TypeDeclarationImpl);exports.DateOnlyTypeDeclarationImpl=DateOnlyTypeDeclarationImpl;var TimeOnlyTypeDeclarationImpl=function(_super){function TimeOnlyTypeDeclarationImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createTimeOnlyTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(TimeOnlyTypeDeclarationImpl,_super),TimeOnlyTypeDeclarationImpl.prototype.wrapperClassName=function(){return"TimeOnlyTypeDeclarationImpl"},TimeOnlyTypeDeclarationImpl.prototype.kind=function(){return"TimeOnlyTypeDeclaration"},TimeOnlyTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},TimeOnlyTypeDeclarationImpl}(TypeDeclarationImpl);exports.TimeOnlyTypeDeclarationImpl=TimeOnlyTypeDeclarationImpl;var DateTimeOnlyTypeDeclarationImpl=function(_super){function DateTimeOnlyTypeDeclarationImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createDateTimeOnlyTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(DateTimeOnlyTypeDeclarationImpl,_super),DateTimeOnlyTypeDeclarationImpl.prototype.wrapperClassName=function(){return"DateTimeOnlyTypeDeclarationImpl"},DateTimeOnlyTypeDeclarationImpl.prototype.kind=function(){return"DateTimeOnlyTypeDeclaration"},DateTimeOnlyTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},DateTimeOnlyTypeDeclarationImpl}(TypeDeclarationImpl);exports.DateTimeOnlyTypeDeclarationImpl=DateTimeOnlyTypeDeclarationImpl;var DateTimeTypeDeclarationImpl=function(_super){function DateTimeTypeDeclarationImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createDateTimeTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(DateTimeTypeDeclarationImpl,_super),DateTimeTypeDeclarationImpl.prototype.format=function(){return _super.prototype.attribute.call(this,"format",this.toString)},DateTimeTypeDeclarationImpl.prototype.setFormat=function(param){return this.highLevel().attrOrCreate("format").setValue(""+param),this},DateTimeTypeDeclarationImpl.prototype.wrapperClassName=function(){return"DateTimeTypeDeclarationImpl"},DateTimeTypeDeclarationImpl.prototype.kind=function(){return"DateTimeTypeDeclaration"},DateTimeTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},DateTimeTypeDeclarationImpl.prototype.scalarsAnnotations=function(){return new DateTimeTypeDeclarationScalarsAnnotationsImpl(this.highLevel())},DateTimeTypeDeclarationImpl}(TypeDeclarationImpl);exports.DateTimeTypeDeclarationImpl=DateTimeTypeDeclarationImpl;var DateTimeTypeDeclarationScalarsAnnotationsImpl=function(_super){function DateTimeTypeDeclarationScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(DateTimeTypeDeclarationScalarsAnnotationsImpl,_super),DateTimeTypeDeclarationScalarsAnnotationsImpl.prototype.format=function(){var attr=this.node.attr("format");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},DateTimeTypeDeclarationScalarsAnnotationsImpl}(TypeDeclarationScalarsAnnotationsImpl);exports.DateTimeTypeDeclarationScalarsAnnotationsImpl=DateTimeTypeDeclarationScalarsAnnotationsImpl;var FileTypeDeclarationImpl=function(_super){function FileTypeDeclarationImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createFileTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(FileTypeDeclarationImpl,_super),FileTypeDeclarationImpl.prototype.fileTypes=function(){return _super.prototype.attributes.call(this,"fileTypes",function(attr){return new ContentTypeImpl(attr)})},FileTypeDeclarationImpl.prototype.minLength=function(){return _super.prototype.attribute.call(this,"minLength",this.toNumber)},FileTypeDeclarationImpl.prototype.setMinLength=function(param){return this.highLevel().attrOrCreate("minLength").setValue(""+param),this},FileTypeDeclarationImpl.prototype.maxLength=function(){return _super.prototype.attribute.call(this,"maxLength",this.toNumber)},FileTypeDeclarationImpl.prototype.setMaxLength=function(param){return this.highLevel().attrOrCreate("maxLength").setValue(""+param),this},FileTypeDeclarationImpl.prototype.wrapperClassName=function(){return"FileTypeDeclarationImpl"},FileTypeDeclarationImpl.prototype.kind=function(){return"FileTypeDeclaration"},FileTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},FileTypeDeclarationImpl.prototype.scalarsAnnotations=function(){return new FileTypeDeclarationScalarsAnnotationsImpl(this.highLevel())},FileTypeDeclarationImpl}(TypeDeclarationImpl);exports.FileTypeDeclarationImpl=FileTypeDeclarationImpl;var FileTypeDeclarationScalarsAnnotationsImpl=function(_super){function FileTypeDeclarationScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(FileTypeDeclarationScalarsAnnotationsImpl,_super),FileTypeDeclarationScalarsAnnotationsImpl.prototype.fileTypes=function(){var attrs=this.node.attributes("fileTypes");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},FileTypeDeclarationScalarsAnnotationsImpl.prototype.minLength=function(){var attr=this.node.attr("minLength");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},FileTypeDeclarationScalarsAnnotationsImpl.prototype.maxLength=function(){var attr=this.node.attr("maxLength");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},FileTypeDeclarationScalarsAnnotationsImpl}(TypeDeclarationScalarsAnnotationsImpl);exports.FileTypeDeclarationScalarsAnnotationsImpl=FileTypeDeclarationScalarsAnnotationsImpl;var ResponseImpl=function(_super){function ResponseImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createResponse(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(ResponseImpl,_super),ResponseImpl.prototype.code=function(){return _super.prototype.attribute.call(this,"code",function(attr){return new StatusCodeStringImpl(attr)})},ResponseImpl.prototype.headers=function(){return _super.prototype.elements.call(this,"headers")},ResponseImpl.prototype.body=function(){return _super.prototype.elements.call(this,"body")},ResponseImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},ResponseImpl.prototype.annotations=function(){return _super.prototype.attributes.call(this,"annotations",function(attr){return new AnnotationRefImpl(attr)})},ResponseImpl.prototype.wrapperClassName=function(){return"ResponseImpl"},ResponseImpl.prototype.kind=function(){return"Response"},ResponseImpl.prototype.RAMLVersion=function(){return"RAML10"},ResponseImpl.prototype.isOkRange=function(){return helper.isOkRange(this)},ResponseImpl.prototype.scalarsAnnotations=function(){return new ResponseScalarsAnnotationsImpl(this.highLevel())},ResponseImpl}(AnnotableImpl);exports.ResponseImpl=ResponseImpl;var ResponseScalarsAnnotationsImpl=function(_super){function ResponseScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(ResponseScalarsAnnotationsImpl,_super),ResponseScalarsAnnotationsImpl.prototype.description=function(){var attr=this.node.attr("description");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ResponseScalarsAnnotationsImpl.prototype.annotations=function(){var attrs=this.node.attributes("annotations");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},ResponseScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.ResponseScalarsAnnotationsImpl=ResponseScalarsAnnotationsImpl;var SecuritySchemePartImpl=function(_super){function SecuritySchemePartImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createSecuritySchemePart(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(SecuritySchemePartImpl,_super),SecuritySchemePartImpl.prototype.annotations=function(){return _super.prototype.attributes.call(this,"annotations",function(attr){return new AnnotationRefImpl(attr)})},SecuritySchemePartImpl.prototype.wrapperClassName=function(){return"SecuritySchemePartImpl"},SecuritySchemePartImpl.prototype.kind=function(){return"SecuritySchemePart"},SecuritySchemePartImpl.prototype.RAMLVersion=function(){return"RAML10"},SecuritySchemePartImpl.prototype.scalarsAnnotations=function(){return new SecuritySchemePartScalarsAnnotationsImpl(this.highLevel())},SecuritySchemePartImpl}(OperationImpl);exports.SecuritySchemePartImpl=SecuritySchemePartImpl;var SecuritySchemePartScalarsAnnotationsImpl=function(_super){function SecuritySchemePartScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(SecuritySchemePartScalarsAnnotationsImpl,_super),SecuritySchemePartScalarsAnnotationsImpl.prototype.annotations=function(){var attrs=this.node.attributes("annotations");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},SecuritySchemePartScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.SecuritySchemePartScalarsAnnotationsImpl=SecuritySchemePartScalarsAnnotationsImpl;var MethodBaseImpl=function(_super){function MethodBaseImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createMethodBase(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(MethodBaseImpl,_super),MethodBaseImpl.prototype.body=function(){return _super.prototype.elements.call(this,"body")},MethodBaseImpl.prototype.protocols=function(){return _super.prototype.attributes.call(this,"protocols",this.toString)},MethodBaseImpl.prototype.setProtocols=function(param){return this.highLevel().attrOrCreate("protocols").setValue(""+param),this},MethodBaseImpl.prototype.is=function(){return _super.prototype.attributes.call(this,"is",function(attr){return new TraitRefImpl(attr)})},MethodBaseImpl.prototype.securedBy=function(){return _super.prototype.attributes.call(this,"securedBy",function(attr){return new SecuritySchemeRefImpl(attr)})},MethodBaseImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},MethodBaseImpl.prototype.displayName=function(){return _super.prototype.attribute.call(this,"displayName",this.toString)},MethodBaseImpl.prototype.setDisplayName=function(param){return this.highLevel().attrOrCreate("displayName").setValue(""+param),this},MethodBaseImpl.prototype.wrapperClassName=function(){return"MethodBaseImpl"},MethodBaseImpl.prototype.kind=function(){return"MethodBase"},MethodBaseImpl.prototype.RAMLVersion=function(){return"RAML10"},MethodBaseImpl.prototype.scalarsAnnotations=function(){return new MethodBaseScalarsAnnotationsImpl(this.highLevel())},MethodBaseImpl}(OperationImpl);exports.MethodBaseImpl=MethodBaseImpl;var SecuritySchemeRefImpl=function(_super){function SecuritySchemeRefImpl(){_super.apply(this,arguments)}return __extends(SecuritySchemeRefImpl,_super),SecuritySchemeRefImpl.prototype.wrapperClassName=function(){return"SecuritySchemeRefImpl"},SecuritySchemeRefImpl.prototype.kind=function(){return"SecuritySchemeRef"},SecuritySchemeRefImpl.prototype.RAMLVersion=function(){return"RAML10"},SecuritySchemeRefImpl.prototype.securitySchemeName=function(){return helper.securitySchemeName(this)},SecuritySchemeRefImpl.prototype.securityScheme=function(){return helper.securityScheme(this)},SecuritySchemeRefImpl}(ReferenceImpl);exports.SecuritySchemeRefImpl=SecuritySchemeRefImpl;var AbstractSecuritySchemeImpl=function(_super){function AbstractSecuritySchemeImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createAbstractSecurityScheme(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(AbstractSecuritySchemeImpl,_super),AbstractSecuritySchemeImpl.prototype.name=function(){return _super.prototype.attribute.call(this,"name",this.toString)},AbstractSecuritySchemeImpl.prototype.setName=function(param){return this.highLevel().attrOrCreate("name").setValue(""+param),this},AbstractSecuritySchemeImpl.prototype.type=function(){return _super.prototype.attribute.call(this,"type",this.toString)},AbstractSecuritySchemeImpl.prototype.setType=function(param){return this.highLevel().attrOrCreate("type").setValue(""+param),this},AbstractSecuritySchemeImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},AbstractSecuritySchemeImpl.prototype.describedBy=function(){return _super.prototype.element.call(this,"describedBy")},AbstractSecuritySchemeImpl.prototype.displayName=function(){return _super.prototype.attribute.call(this,"displayName",this.toString)},AbstractSecuritySchemeImpl.prototype.setDisplayName=function(param){return this.highLevel().attrOrCreate("displayName").setValue(""+param),this},AbstractSecuritySchemeImpl.prototype.settings=function(){return _super.prototype.element.call(this,"settings")},AbstractSecuritySchemeImpl.prototype.wrapperClassName=function(){return"AbstractSecuritySchemeImpl"},AbstractSecuritySchemeImpl.prototype.kind=function(){return"AbstractSecurityScheme"},AbstractSecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML10"},AbstractSecuritySchemeImpl.prototype.scalarsAnnotations=function(){return new AbstractSecuritySchemeScalarsAnnotationsImpl(this.highLevel())},AbstractSecuritySchemeImpl}(AnnotableImpl);exports.AbstractSecuritySchemeImpl=AbstractSecuritySchemeImpl;var SecuritySchemeSettingsImpl=function(_super){function SecuritySchemeSettingsImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createSecuritySchemeSettings(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(SecuritySchemeSettingsImpl,_super),SecuritySchemeSettingsImpl.prototype.wrapperClassName=function(){return"SecuritySchemeSettingsImpl"},SecuritySchemeSettingsImpl.prototype.kind=function(){return"SecuritySchemeSettings"},SecuritySchemeSettingsImpl.prototype.RAMLVersion=function(){return"RAML10"},SecuritySchemeSettingsImpl}(AnnotableImpl);exports.SecuritySchemeSettingsImpl=SecuritySchemeSettingsImpl;var OAuth1SecuritySchemeSettingsImpl=function(_super){function OAuth1SecuritySchemeSettingsImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createOAuth1SecuritySchemeSettings(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(OAuth1SecuritySchemeSettingsImpl,_super),OAuth1SecuritySchemeSettingsImpl.prototype.requestTokenUri=function(){return _super.prototype.attribute.call(this,"requestTokenUri",function(attr){return new FixedUriStringImpl(attr)})},OAuth1SecuritySchemeSettingsImpl.prototype.authorizationUri=function(){return _super.prototype.attribute.call(this,"authorizationUri",function(attr){return new FixedUriStringImpl(attr)})},OAuth1SecuritySchemeSettingsImpl.prototype.tokenCredentialsUri=function(){return _super.prototype.attribute.call(this,"tokenCredentialsUri",function(attr){return new FixedUriStringImpl(attr)})},OAuth1SecuritySchemeSettingsImpl.prototype.signatures=function(){return _super.prototype.attributes.call(this,"signatures",this.toString)},OAuth1SecuritySchemeSettingsImpl.prototype.setSignatures=function(param){return this.highLevel().attrOrCreate("signatures").setValue(""+param),this},OAuth1SecuritySchemeSettingsImpl.prototype.wrapperClassName=function(){return"OAuth1SecuritySchemeSettingsImpl"},OAuth1SecuritySchemeSettingsImpl.prototype.kind=function(){return"OAuth1SecuritySchemeSettings"},OAuth1SecuritySchemeSettingsImpl.prototype.RAMLVersion=function(){return"RAML10"},OAuth1SecuritySchemeSettingsImpl.prototype.scalarsAnnotations=function(){return new OAuth1SecuritySchemeSettingsScalarsAnnotationsImpl(this.highLevel())},OAuth1SecuritySchemeSettingsImpl}(SecuritySchemeSettingsImpl);exports.OAuth1SecuritySchemeSettingsImpl=OAuth1SecuritySchemeSettingsImpl;var OAuth1SecuritySchemeSettingsScalarsAnnotationsImpl=function(_super){function OAuth1SecuritySchemeSettingsScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(OAuth1SecuritySchemeSettingsScalarsAnnotationsImpl,_super),OAuth1SecuritySchemeSettingsScalarsAnnotationsImpl.prototype.requestTokenUri=function(){var attr=this.node.attr("requestTokenUri");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},OAuth1SecuritySchemeSettingsScalarsAnnotationsImpl.prototype.authorizationUri=function(){var attr=this.node.attr("authorizationUri");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},OAuth1SecuritySchemeSettingsScalarsAnnotationsImpl.prototype.tokenCredentialsUri=function(){var attr=this.node.attr("tokenCredentialsUri");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},OAuth1SecuritySchemeSettingsScalarsAnnotationsImpl.prototype.signatures=function(){var attrs=this.node.attributes("signatures");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},OAuth1SecuritySchemeSettingsScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.OAuth1SecuritySchemeSettingsScalarsAnnotationsImpl=OAuth1SecuritySchemeSettingsScalarsAnnotationsImpl;var OAuth2SecuritySchemeSettingsImpl=function(_super){function OAuth2SecuritySchemeSettingsImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createOAuth2SecuritySchemeSettings(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(OAuth2SecuritySchemeSettingsImpl,_super),OAuth2SecuritySchemeSettingsImpl.prototype.accessTokenUri=function(){return _super.prototype.attribute.call(this,"accessTokenUri",function(attr){return new FixedUriStringImpl(attr)})},OAuth2SecuritySchemeSettingsImpl.prototype.authorizationUri=function(){return _super.prototype.attribute.call(this,"authorizationUri",function(attr){return new FixedUriStringImpl(attr)})},OAuth2SecuritySchemeSettingsImpl.prototype.authorizationGrants=function(){return _super.prototype.attributes.call(this,"authorizationGrants",this.toString)},OAuth2SecuritySchemeSettingsImpl.prototype.setAuthorizationGrants=function(param){return this.highLevel().attrOrCreate("authorizationGrants").setValue(""+param),this},OAuth2SecuritySchemeSettingsImpl.prototype.scopes=function(){return _super.prototype.attributes.call(this,"scopes",this.toString)},OAuth2SecuritySchemeSettingsImpl.prototype.setScopes=function(param){return this.highLevel().attrOrCreate("scopes").setValue(""+param),this},OAuth2SecuritySchemeSettingsImpl.prototype.wrapperClassName=function(){return"OAuth2SecuritySchemeSettingsImpl"},OAuth2SecuritySchemeSettingsImpl.prototype.kind=function(){return"OAuth2SecuritySchemeSettings"},OAuth2SecuritySchemeSettingsImpl.prototype.RAMLVersion=function(){return"RAML10"},OAuth2SecuritySchemeSettingsImpl.prototype.scalarsAnnotations=function(){return new OAuth2SecuritySchemeSettingsScalarsAnnotationsImpl(this.highLevel())},OAuth2SecuritySchemeSettingsImpl}(SecuritySchemeSettingsImpl);exports.OAuth2SecuritySchemeSettingsImpl=OAuth2SecuritySchemeSettingsImpl;var OAuth2SecuritySchemeSettingsScalarsAnnotationsImpl=function(_super){function OAuth2SecuritySchemeSettingsScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(OAuth2SecuritySchemeSettingsScalarsAnnotationsImpl,_super),OAuth2SecuritySchemeSettingsScalarsAnnotationsImpl.prototype.accessTokenUri=function(){var attr=this.node.attr("accessTokenUri");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},OAuth2SecuritySchemeSettingsScalarsAnnotationsImpl.prototype.authorizationUri=function(){var attr=this.node.attr("authorizationUri");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},OAuth2SecuritySchemeSettingsScalarsAnnotationsImpl.prototype.authorizationGrants=function(){var attrs=this.node.attributes("authorizationGrants");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},OAuth2SecuritySchemeSettingsScalarsAnnotationsImpl.prototype.scopes=function(){var attrs=this.node.attributes("scopes");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},OAuth2SecuritySchemeSettingsScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.OAuth2SecuritySchemeSettingsScalarsAnnotationsImpl=OAuth2SecuritySchemeSettingsScalarsAnnotationsImpl;var OAuth2SecuritySchemeImpl=function(_super){function OAuth2SecuritySchemeImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createOAuth2SecurityScheme(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(OAuth2SecuritySchemeImpl,_super),OAuth2SecuritySchemeImpl.prototype.settings=function(){return _super.prototype.element.call(this,"settings")},OAuth2SecuritySchemeImpl.prototype.wrapperClassName=function(){return"OAuth2SecuritySchemeImpl"},OAuth2SecuritySchemeImpl.prototype.kind=function(){return"OAuth2SecurityScheme"},OAuth2SecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML10"},OAuth2SecuritySchemeImpl}(AbstractSecuritySchemeImpl);exports.OAuth2SecuritySchemeImpl=OAuth2SecuritySchemeImpl;var OAuth1SecuritySchemeImpl=function(_super){function OAuth1SecuritySchemeImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createOAuth1SecurityScheme(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(OAuth1SecuritySchemeImpl,_super),OAuth1SecuritySchemeImpl.prototype.settings=function(){return _super.prototype.element.call(this,"settings")},OAuth1SecuritySchemeImpl.prototype.wrapperClassName=function(){return"OAuth1SecuritySchemeImpl"},OAuth1SecuritySchemeImpl.prototype.kind=function(){return"OAuth1SecurityScheme"},OAuth1SecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML10"},OAuth1SecuritySchemeImpl}(AbstractSecuritySchemeImpl);exports.OAuth1SecuritySchemeImpl=OAuth1SecuritySchemeImpl;var PassThroughSecuritySchemeImpl=function(_super){function PassThroughSecuritySchemeImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createPassThroughSecurityScheme(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(PassThroughSecuritySchemeImpl,_super),PassThroughSecuritySchemeImpl.prototype.settings=function(){return _super.prototype.element.call(this,"settings")},PassThroughSecuritySchemeImpl.prototype.wrapperClassName=function(){return"PassThroughSecuritySchemeImpl"},PassThroughSecuritySchemeImpl.prototype.kind=function(){return"PassThroughSecurityScheme"},PassThroughSecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML10"},PassThroughSecuritySchemeImpl}(AbstractSecuritySchemeImpl);exports.PassThroughSecuritySchemeImpl=PassThroughSecuritySchemeImpl;var BasicSecuritySchemeImpl=function(_super){function BasicSecuritySchemeImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createBasicSecurityScheme(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(BasicSecuritySchemeImpl,_super),BasicSecuritySchemeImpl.prototype.wrapperClassName=function(){return"BasicSecuritySchemeImpl"},BasicSecuritySchemeImpl.prototype.kind=function(){return"BasicSecurityScheme"},BasicSecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML10"},BasicSecuritySchemeImpl}(AbstractSecuritySchemeImpl);exports.BasicSecuritySchemeImpl=BasicSecuritySchemeImpl;var DigestSecuritySchemeImpl=function(_super){function DigestSecuritySchemeImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createDigestSecurityScheme(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(DigestSecuritySchemeImpl,_super),DigestSecuritySchemeImpl.prototype.wrapperClassName=function(){return"DigestSecuritySchemeImpl"},DigestSecuritySchemeImpl.prototype.kind=function(){return"DigestSecurityScheme"},DigestSecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML10"},DigestSecuritySchemeImpl}(AbstractSecuritySchemeImpl);exports.DigestSecuritySchemeImpl=DigestSecuritySchemeImpl;var CustomSecuritySchemeImpl=function(_super){function CustomSecuritySchemeImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createCustomSecurityScheme(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(CustomSecuritySchemeImpl,_super),CustomSecuritySchemeImpl.prototype.wrapperClassName=function(){return"CustomSecuritySchemeImpl"},CustomSecuritySchemeImpl.prototype.kind=function(){return"CustomSecurityScheme"},CustomSecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML10"},CustomSecuritySchemeImpl}(AbstractSecuritySchemeImpl);exports.CustomSecuritySchemeImpl=CustomSecuritySchemeImpl;var AbstractSecuritySchemeScalarsAnnotationsImpl=function(_super){function AbstractSecuritySchemeScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(AbstractSecuritySchemeScalarsAnnotationsImpl,_super),AbstractSecuritySchemeScalarsAnnotationsImpl.prototype.type=function(){var attr=this.node.attr("type");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},AbstractSecuritySchemeScalarsAnnotationsImpl.prototype.description=function(){var attr=this.node.attr("description");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},AbstractSecuritySchemeScalarsAnnotationsImpl.prototype.displayName=function(){var attr=this.node.attr("displayName");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},AbstractSecuritySchemeScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.AbstractSecuritySchemeScalarsAnnotationsImpl=AbstractSecuritySchemeScalarsAnnotationsImpl;var MethodImpl=function(_super){function MethodImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createMethod(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(MethodImpl,_super),MethodImpl.prototype.method=function(){return _super.prototype.attribute.call(this,"method",this.toString)},MethodImpl.prototype.setMethod=function(param){return this.highLevel().attrOrCreate("method").setValue(""+param),this},MethodImpl.prototype.displayName=function(){return _super.prototype.attribute.call(this,"displayName",this.toString)},MethodImpl.prototype.setDisplayName=function(param){return this.highLevel().attrOrCreate("displayName").setValue(""+param),this},MethodImpl.prototype.wrapperClassName=function(){return"MethodImpl"},MethodImpl.prototype.kind=function(){return"Method"},MethodImpl.prototype.RAMLVersion=function(){return"RAML10"},MethodImpl.prototype.parentResource=function(){return helper.parentResource(this)},MethodImpl.prototype.ownerApi=function(){return helper.ownerApi(this)},MethodImpl.prototype.methodId=function(){return helper.methodId(this)},MethodImpl.prototype.allSecuredBy=function(){return helper.allSecuredBy(this)},MethodImpl.prototype.parametrizedProperties=function(){return helper.getTemplateParametrizedProperties(this)},MethodImpl.prototype.scalarsAnnotations=function(){return new MethodScalarsAnnotationsImpl(this.highLevel());
},MethodImpl}(MethodBaseImpl);exports.MethodImpl=MethodImpl;var MethodBaseScalarsAnnotationsImpl=function(_super){function MethodBaseScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(MethodBaseScalarsAnnotationsImpl,_super),MethodBaseScalarsAnnotationsImpl.prototype.protocols=function(){var attrs=this.node.attributes("protocols");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},MethodBaseScalarsAnnotationsImpl.prototype.is=function(){var attrs=this.node.attributes("is");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},MethodBaseScalarsAnnotationsImpl.prototype.securedBy=function(){var attrs=this.node.attributes("securedBy");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},MethodBaseScalarsAnnotationsImpl.prototype.description=function(){var attr=this.node.attr("description");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},MethodBaseScalarsAnnotationsImpl.prototype.displayName=function(){var attr=this.node.attr("displayName");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},MethodBaseScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.MethodBaseScalarsAnnotationsImpl=MethodBaseScalarsAnnotationsImpl;var MethodScalarsAnnotationsImpl=function(_super){function MethodScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(MethodScalarsAnnotationsImpl,_super),MethodScalarsAnnotationsImpl.prototype.displayName=function(){var attr=this.node.attr("displayName");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},MethodScalarsAnnotationsImpl}(MethodBaseScalarsAnnotationsImpl);exports.MethodScalarsAnnotationsImpl=MethodScalarsAnnotationsImpl;var TraitImpl=function(_super){function TraitImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createTrait(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(TraitImpl,_super),TraitImpl.prototype.name=function(){return _super.prototype.attribute.call(this,"name",this.toString)},TraitImpl.prototype.setName=function(param){return this.highLevel().attrOrCreate("name").setValue(""+param),this},TraitImpl.prototype.usage=function(){return _super.prototype.attribute.call(this,"usage",this.toString)},TraitImpl.prototype.setUsage=function(param){return this.highLevel().attrOrCreate("usage").setValue(""+param),this},TraitImpl.prototype.displayName=function(){return _super.prototype.attribute.call(this,"displayName",this.toString)},TraitImpl.prototype.setDisplayName=function(param){return this.highLevel().attrOrCreate("displayName").setValue(""+param),this},TraitImpl.prototype.uses=function(){return _super.prototype.elements.call(this,"uses")},TraitImpl.prototype.wrapperClassName=function(){return"TraitImpl"},TraitImpl.prototype.kind=function(){return"Trait"},TraitImpl.prototype.RAMLVersion=function(){return"RAML10"},TraitImpl.prototype.parametrizedProperties=function(){return helper.getTemplateParametrizedProperties(this)},TraitImpl.prototype.scalarsAnnotations=function(){return new TraitScalarsAnnotationsImpl(this.highLevel())},TraitImpl}(MethodBaseImpl);exports.TraitImpl=TraitImpl;var TraitScalarsAnnotationsImpl=function(_super){function TraitScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(TraitScalarsAnnotationsImpl,_super),TraitScalarsAnnotationsImpl.prototype.usage=function(){var attr=this.node.attr("usage");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},TraitScalarsAnnotationsImpl.prototype.displayName=function(){var attr=this.node.attr("displayName");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},TraitScalarsAnnotationsImpl}(MethodBaseScalarsAnnotationsImpl);exports.TraitScalarsAnnotationsImpl=TraitScalarsAnnotationsImpl;var ResourceTypeRefImpl=function(_super){function ResourceTypeRefImpl(){_super.apply(this,arguments)}return __extends(ResourceTypeRefImpl,_super),ResourceTypeRefImpl.prototype.wrapperClassName=function(){return"ResourceTypeRefImpl"},ResourceTypeRefImpl.prototype.kind=function(){return"ResourceTypeRef"},ResourceTypeRefImpl.prototype.RAMLVersion=function(){return"RAML10"},ResourceTypeRefImpl.prototype.resourceType=function(){return helper.referencedResourceType(this)},ResourceTypeRefImpl}(ReferenceImpl);exports.ResourceTypeRefImpl=ResourceTypeRefImpl;var ResourceBaseImpl=function(_super){function ResourceBaseImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createResourceBase(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(ResourceBaseImpl,_super),ResourceBaseImpl.prototype.methods=function(){return _super.prototype.elements.call(this,"methods")},ResourceBaseImpl.prototype.is=function(){return _super.prototype.attributes.call(this,"is",function(attr){return new TraitRefImpl(attr)})},ResourceBaseImpl.prototype.type=function(){return _super.prototype.attribute.call(this,"type",function(attr){return new ResourceTypeRefImpl(attr)})},ResourceBaseImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},ResourceBaseImpl.prototype.securedBy=function(){return _super.prototype.attributes.call(this,"securedBy",function(attr){return new SecuritySchemeRefImpl(attr)})},ResourceBaseImpl.prototype.uriParameters_original=function(){return _super.prototype.elements.call(this,"uriParameters")},ResourceBaseImpl.prototype.wrapperClassName=function(){return"ResourceBaseImpl"},ResourceBaseImpl.prototype.kind=function(){return"ResourceBase"},ResourceBaseImpl.prototype.RAMLVersion=function(){return"RAML10"},ResourceBaseImpl.prototype.uriParameters=function(){return helper.uriParametersPrimary(this)},ResourceBaseImpl.prototype.allUriParameters=function(){return helper.uriParameters(this)},ResourceBaseImpl.prototype.allSecuredBy=function(){return helper.allSecuredBy(this)},ResourceBaseImpl.prototype.scalarsAnnotations=function(){return new ResourceBaseScalarsAnnotationsImpl(this.highLevel())},ResourceBaseImpl}(AnnotableImpl);exports.ResourceBaseImpl=ResourceBaseImpl;var ResourceImpl=function(_super){function ResourceImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createResource(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(ResourceImpl,_super),ResourceImpl.prototype.relativeUri=function(){return _super.prototype.attribute.call(this,"relativeUri",function(attr){return new RelativeUriStringImpl(attr)})},ResourceImpl.prototype.displayName=function(){return _super.prototype.attribute.call(this,"displayName",this.toString)},ResourceImpl.prototype.setDisplayName=function(param){return this.highLevel().attrOrCreate("displayName").setValue(""+param),this},ResourceImpl.prototype.resources=function(){return _super.prototype.elements.call(this,"resources")},ResourceImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},ResourceImpl.prototype.annotations=function(){return _super.prototype.attributes.call(this,"annotations",function(attr){return new AnnotationRefImpl(attr)})},ResourceImpl.prototype.wrapperClassName=function(){return"ResourceImpl"},ResourceImpl.prototype.kind=function(){return"Resource"},ResourceImpl.prototype.RAMLVersion=function(){return"RAML10"},ResourceImpl.prototype.completeRelativeUri=function(){return helper.completeRelativeUri(this)},ResourceImpl.prototype.absoluteUri=function(){return helper.absoluteUri(this)},ResourceImpl.prototype.parentResource=function(){return helper.parent(this)},ResourceImpl.prototype.childResource=function(relPath){return helper.childResource(this,relPath)},ResourceImpl.prototype.childMethod=function(method){return helper.childMethod(this,method)},ResourceImpl.prototype.ownerApi=function(){return helper.ownerApi(this)},ResourceImpl.prototype.absoluteUriParameters=function(){return helper.absoluteUriParameters(this)},ResourceImpl.prototype.scalarsAnnotations=function(){return new ResourceScalarsAnnotationsImpl(this.highLevel())},ResourceImpl}(ResourceBaseImpl);exports.ResourceImpl=ResourceImpl;var ResourceBaseScalarsAnnotationsImpl=function(_super){function ResourceBaseScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(ResourceBaseScalarsAnnotationsImpl,_super),ResourceBaseScalarsAnnotationsImpl.prototype.is=function(){var attrs=this.node.attributes("is");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},ResourceBaseScalarsAnnotationsImpl.prototype.type=function(){var attr=this.node.attr("type");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ResourceBaseScalarsAnnotationsImpl.prototype.description=function(){var attr=this.node.attr("description");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ResourceBaseScalarsAnnotationsImpl.prototype.securedBy=function(){var attrs=this.node.attributes("securedBy");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},ResourceBaseScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.ResourceBaseScalarsAnnotationsImpl=ResourceBaseScalarsAnnotationsImpl;var ResourceScalarsAnnotationsImpl=function(_super){function ResourceScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(ResourceScalarsAnnotationsImpl,_super),ResourceScalarsAnnotationsImpl.prototype.displayName=function(){var attr=this.node.attr("displayName");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ResourceScalarsAnnotationsImpl.prototype.description=function(){var attr=this.node.attr("description");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ResourceScalarsAnnotationsImpl.prototype.annotations=function(){var attrs=this.node.attributes("annotations");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},ResourceScalarsAnnotationsImpl}(ResourceBaseScalarsAnnotationsImpl);exports.ResourceScalarsAnnotationsImpl=ResourceScalarsAnnotationsImpl;var ResourceTypeImpl=function(_super){function ResourceTypeImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createResourceType(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(ResourceTypeImpl,_super),ResourceTypeImpl.prototype.displayName=function(){return _super.prototype.attribute.call(this,"displayName",this.toString)},ResourceTypeImpl.prototype.setDisplayName=function(param){return this.highLevel().attrOrCreate("displayName").setValue(""+param),this},ResourceTypeImpl.prototype.name=function(){return _super.prototype.attribute.call(this,"name",this.toString)},ResourceTypeImpl.prototype.setName=function(param){return this.highLevel().attrOrCreate("name").setValue(""+param),this},ResourceTypeImpl.prototype.usage=function(){return _super.prototype.attribute.call(this,"usage",this.toString)},ResourceTypeImpl.prototype.setUsage=function(param){return this.highLevel().attrOrCreate("usage").setValue(""+param),this},ResourceTypeImpl.prototype.uses=function(){return _super.prototype.elements.call(this,"uses")},ResourceTypeImpl.prototype.wrapperClassName=function(){return"ResourceTypeImpl"},ResourceTypeImpl.prototype.kind=function(){return"ResourceType"},ResourceTypeImpl.prototype.RAMLVersion=function(){return"RAML10"},ResourceTypeImpl.prototype.parametrizedProperties=function(){return helper.getTemplateParametrizedProperties(this)},ResourceTypeImpl.prototype.scalarsAnnotations=function(){return new ResourceTypeScalarsAnnotationsImpl(this.highLevel())},ResourceTypeImpl}(ResourceBaseImpl);exports.ResourceTypeImpl=ResourceTypeImpl;var ResourceTypeScalarsAnnotationsImpl=function(_super){function ResourceTypeScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(ResourceTypeScalarsAnnotationsImpl,_super),ResourceTypeScalarsAnnotationsImpl.prototype.displayName=function(){var attr=this.node.attr("displayName");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ResourceTypeScalarsAnnotationsImpl.prototype.usage=function(){var attr=this.node.attr("usage");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ResourceTypeScalarsAnnotationsImpl}(ResourceBaseScalarsAnnotationsImpl);exports.ResourceTypeScalarsAnnotationsImpl=ResourceTypeScalarsAnnotationsImpl;var AnnotationRefImpl=function(_super){function AnnotationRefImpl(){_super.apply(this,arguments)}return __extends(AnnotationRefImpl,_super),AnnotationRefImpl.prototype.wrapperClassName=function(){return"AnnotationRefImpl"},AnnotationRefImpl.prototype.kind=function(){return"AnnotationRef"},AnnotationRefImpl.prototype.RAMLVersion=function(){return"RAML10"},AnnotationRefImpl.prototype.annotation=function(){return helper.referencedAnnotation(this)},AnnotationRefImpl}(ReferenceImpl);exports.AnnotationRefImpl=AnnotationRefImpl;var DocumentationItemImpl=function(_super){function DocumentationItemImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createDocumentationItem(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(DocumentationItemImpl,_super),DocumentationItemImpl.prototype.title=function(){return _super.prototype.attribute.call(this,"title",this.toString)},DocumentationItemImpl.prototype.setTitle=function(param){return this.highLevel().attrOrCreate("title").setValue(""+param),this},DocumentationItemImpl.prototype.content=function(){return _super.prototype.attribute.call(this,"content",function(attr){return new MarkdownStringImpl(attr)})},DocumentationItemImpl.prototype.uses=function(){return _super.prototype.elements.call(this,"uses")},DocumentationItemImpl.prototype.wrapperClassName=function(){return"DocumentationItemImpl"},DocumentationItemImpl.prototype.kind=function(){return"DocumentationItem"},DocumentationItemImpl.prototype.RAMLVersion=function(){return"RAML10"},DocumentationItemImpl.prototype.scalarsAnnotations=function(){return new DocumentationItemScalarsAnnotationsImpl(this.highLevel())},DocumentationItemImpl}(AnnotableImpl);exports.DocumentationItemImpl=DocumentationItemImpl;var DocumentationItemScalarsAnnotationsImpl=function(_super){function DocumentationItemScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(DocumentationItemScalarsAnnotationsImpl,_super),DocumentationItemScalarsAnnotationsImpl.prototype.title=function(){var attr=this.node.attr("title");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},DocumentationItemScalarsAnnotationsImpl.prototype.content=function(){var attr=this.node.attr("content");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},DocumentationItemScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.DocumentationItemScalarsAnnotationsImpl=DocumentationItemScalarsAnnotationsImpl;var FragmentDeclarationImpl=function(_super){function FragmentDeclarationImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createFragmentDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(FragmentDeclarationImpl,_super),FragmentDeclarationImpl.prototype.uses=function(){return _super.prototype.elements.call(this,"uses")},FragmentDeclarationImpl.prototype.wrapperClassName=function(){return"FragmentDeclarationImpl"},FragmentDeclarationImpl.prototype.kind=function(){return"FragmentDeclaration"},FragmentDeclarationImpl.prototype.RAMLVersion=function(){return"RAML10"},FragmentDeclarationImpl}(AnnotableImpl);exports.FragmentDeclarationImpl=FragmentDeclarationImpl;var LibraryBaseImpl=function(_super){function LibraryBaseImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createLibraryBase(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(LibraryBaseImpl,_super),LibraryBaseImpl.prototype.schemas=function(){return _super.prototype.elements.call(this,"schemas")},LibraryBaseImpl.prototype.types=function(){return _super.prototype.elements.call(this,"types")},LibraryBaseImpl.prototype.traits_original=function(){return _super.prototype.elements.call(this,"traits")},LibraryBaseImpl.prototype.resourceTypes_original=function(){return _super.prototype.elements.call(this,"resourceTypes")},LibraryBaseImpl.prototype.annotationTypes=function(){return _super.prototype.elements.call(this,"annotationTypes")},LibraryBaseImpl.prototype.securitySchemes=function(){return _super.prototype.elements.call(this,"securitySchemes")},LibraryBaseImpl.prototype.wrapperClassName=function(){return"LibraryBaseImpl"},LibraryBaseImpl.prototype.kind=function(){return"LibraryBase"},LibraryBaseImpl.prototype.RAMLVersion=function(){return"RAML10"},LibraryBaseImpl.prototype.traits=function(){return helper.traitsPrimary(this)},LibraryBaseImpl.prototype.allTraits=function(){return helper.allTraits(this)},LibraryBaseImpl.prototype.resourceTypes=function(){return helper.resourceTypesPrimary(this)},LibraryBaseImpl.prototype.allResourceTypes=function(){return helper.allResourceTypes(this)},LibraryBaseImpl}(FragmentDeclarationImpl);exports.LibraryBaseImpl=LibraryBaseImpl;var LibraryImpl=function(_super){function LibraryImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createLibrary(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(LibraryImpl,_super),LibraryImpl.prototype.usage=function(){return _super.prototype.attribute.call(this,"usage",this.toString)},LibraryImpl.prototype.setUsage=function(param){return this.highLevel().attrOrCreate("usage").setValue(""+param),this},LibraryImpl.prototype.name=function(){return _super.prototype.attribute.call(this,"name",this.toString)},LibraryImpl.prototype.setName=function(param){return this.highLevel().attrOrCreate("name").setValue(""+param),this},LibraryImpl.prototype.wrapperClassName=function(){return"LibraryImpl"},LibraryImpl.prototype.kind=function(){return"Library"},LibraryImpl.prototype.RAMLVersion=function(){return"RAML10"},LibraryImpl.prototype.scalarsAnnotations=function(){return new LibraryScalarsAnnotationsImpl(this.highLevel())},LibraryImpl}(LibraryBaseImpl);exports.LibraryImpl=LibraryImpl;var LibraryScalarsAnnotationsImpl=function(_super){function LibraryScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(LibraryScalarsAnnotationsImpl,_super),LibraryScalarsAnnotationsImpl.prototype.usage=function(){var attr=this.node.attr("usage");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},LibraryScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.LibraryScalarsAnnotationsImpl=LibraryScalarsAnnotationsImpl;var ApiImpl=function(_super){function ApiImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createApi(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(ApiImpl,_super),ApiImpl.prototype.title=function(){return _super.prototype.attribute.call(this,"title",this.toString)},ApiImpl.prototype.setTitle=function(param){return this.highLevel().attrOrCreate("title").setValue(""+param),this},ApiImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},ApiImpl.prototype.version=function(){return _super.prototype.attribute.call(this,"version",this.toString)},ApiImpl.prototype.setVersion=function(param){return this.highLevel().attrOrCreate("version").setValue(""+param),this},ApiImpl.prototype.baseUri=function(){return _super.prototype.attribute.call(this,"baseUri",function(attr){return new FullUriTemplateStringImpl(attr)})},ApiImpl.prototype.baseUriParameters_original=function(){return _super.prototype.elements.call(this,"baseUriParameters")},ApiImpl.prototype.protocols=function(){return _super.prototype.attributes.call(this,"protocols",this.toString)},ApiImpl.prototype.setProtocols=function(param){return this.highLevel().attrOrCreate("protocols").setValue(""+param),this},ApiImpl.prototype.mediaType=function(){return _super.prototype.attributes.call(this,"mediaType",function(attr){return new MimeTypeImpl(attr)})},ApiImpl.prototype.securedBy=function(){return _super.prototype.attributes.call(this,"securedBy",function(attr){return new SecuritySchemeRefImpl(attr)})},ApiImpl.prototype.resources=function(){return _super.prototype.elements.call(this,"resources")},ApiImpl.prototype.documentation=function(){return _super.prototype.elements.call(this,"documentation")},ApiImpl.prototype.annotations=function(){return _super.prototype.attributes.call(this,"annotations",function(attr){return new AnnotationRefImpl(attr)})},ApiImpl.prototype.wrapperClassName=function(){return"ApiImpl"},ApiImpl.prototype.kind=function(){return"Api"},ApiImpl.prototype.RAMLVersion_original=function(){return"RAML10"},ApiImpl.prototype.expand=function(expLib){return void 0===expLib&&(expLib=!1),helper.expandSpec(this,expLib)},ApiImpl.prototype.childResource=function(relPath){return helper.childResource(this,relPath)},ApiImpl.prototype.allResources=function(){return helper.allResources(this)},ApiImpl.prototype.baseUriParameters=function(){return helper.baseUriParametersPrimary(this)},ApiImpl.prototype.allBaseUriParameters=function(){return helper.baseUriParameters(this)},ApiImpl.prototype.allProtocols=function(){return helper.allProtocols(this)},ApiImpl.prototype.RAMLVersion=function(){return helper.RAMLVersion(this)},ApiImpl.prototype.scalarsAnnotations=function(){return new ApiScalarsAnnotationsImpl(this.highLevel())},ApiImpl}(LibraryBaseImpl);exports.ApiImpl=ApiImpl;var OverlayImpl=function(_super){function OverlayImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createOverlay(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(OverlayImpl,_super),OverlayImpl.prototype.usage=function(){return _super.prototype.attribute.call(this,"usage",this.toString)},OverlayImpl.prototype.setUsage=function(param){return this.highLevel().attrOrCreate("usage").setValue(""+param),this},OverlayImpl.prototype["extends"]=function(){return _super.prototype.attribute.call(this,"extends",this.toString)},OverlayImpl.prototype.setExtends=function(param){return this.highLevel().attrOrCreate("extends").setValue(""+param),this},OverlayImpl.prototype.title=function(){return _super.prototype.attribute.call(this,"title",this.toString)},OverlayImpl.prototype.setTitle=function(param){return this.highLevel().attrOrCreate("title").setValue(""+param),this},OverlayImpl.prototype.wrapperClassName=function(){return"OverlayImpl"},OverlayImpl.prototype.kind=function(){return"Overlay"},OverlayImpl.prototype.RAMLVersion=function(){return"RAML10"},OverlayImpl.prototype.scalarsAnnotations=function(){return new OverlayScalarsAnnotationsImpl(this.highLevel())},OverlayImpl}(ApiImpl);exports.OverlayImpl=OverlayImpl;var ApiScalarsAnnotationsImpl=function(_super){function ApiScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(ApiScalarsAnnotationsImpl,_super),ApiScalarsAnnotationsImpl.prototype.title=function(){var attr=this.node.attr("title");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ApiScalarsAnnotationsImpl.prototype.description=function(){var attr=this.node.attr("description");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ApiScalarsAnnotationsImpl.prototype.version=function(){var attr=this.node.attr("version");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ApiScalarsAnnotationsImpl.prototype.baseUri=function(){var attr=this.node.attr("baseUri");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ApiScalarsAnnotationsImpl.prototype.protocols=function(){var attrs=this.node.attributes("protocols");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},ApiScalarsAnnotationsImpl.prototype.mediaType=function(){var attrs=this.node.attributes("mediaType");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},ApiScalarsAnnotationsImpl.prototype.securedBy=function(){var attrs=this.node.attributes("securedBy");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},ApiScalarsAnnotationsImpl.prototype.annotations=function(){var attrs=this.node.attributes("annotations");return attrs.map(function(x){var annotationAttrs=x.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result})},ApiScalarsAnnotationsImpl}(AnnotableScalarsAnnotationsImpl);exports.ApiScalarsAnnotationsImpl=ApiScalarsAnnotationsImpl;var OverlayScalarsAnnotationsImpl=function(_super){function OverlayScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(OverlayScalarsAnnotationsImpl,_super),OverlayScalarsAnnotationsImpl.prototype.usage=function(){var attr=this.node.attr("usage");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},OverlayScalarsAnnotationsImpl.prototype["extends"]=function(){var attr=this.node.attr("extends");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},OverlayScalarsAnnotationsImpl.prototype.title=function(){var attr=this.node.attr("title");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},OverlayScalarsAnnotationsImpl}(ApiScalarsAnnotationsImpl);exports.OverlayScalarsAnnotationsImpl=OverlayScalarsAnnotationsImpl;var ExtensionImpl=function(_super){function ExtensionImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createExtension(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(ExtensionImpl,_super),ExtensionImpl.prototype.usage=function(){return _super.prototype.attribute.call(this,"usage",this.toString)},ExtensionImpl.prototype.setUsage=function(param){return this.highLevel().attrOrCreate("usage").setValue(""+param),this},ExtensionImpl.prototype["extends"]=function(){return _super.prototype.attribute.call(this,"extends",this.toString)},ExtensionImpl.prototype.setExtends=function(param){return this.highLevel().attrOrCreate("extends").setValue(""+param),this},ExtensionImpl.prototype.title=function(){return _super.prototype.attribute.call(this,"title",this.toString)},ExtensionImpl.prototype.setTitle=function(param){return this.highLevel().attrOrCreate("title").setValue(""+param),this},ExtensionImpl.prototype.wrapperClassName=function(){return"ExtensionImpl"},ExtensionImpl.prototype.kind=function(){return"Extension"},ExtensionImpl.prototype.RAMLVersion=function(){return"RAML10"},ExtensionImpl.prototype.scalarsAnnotations=function(){return new ExtensionScalarsAnnotationsImpl(this.highLevel())},ExtensionImpl}(ApiImpl);exports.ExtensionImpl=ExtensionImpl;var ExtensionScalarsAnnotationsImpl=function(_super){function ExtensionScalarsAnnotationsImpl(){_super.apply(this,arguments)}return __extends(ExtensionScalarsAnnotationsImpl,_super),ExtensionScalarsAnnotationsImpl.prototype.usage=function(){var attr=this.node.attr("usage");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ExtensionScalarsAnnotationsImpl.prototype["extends"]=function(){var attr=this.node.attr("extends");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ExtensionScalarsAnnotationsImpl.prototype.title=function(){var attr=this.node.attr("title");if(null==attr)return[];var annotationAttrs=attr.annotations(),result=core.attributesToValues(annotationAttrs,function(a){return new AnnotationRefImpl(a)});return result},ExtensionScalarsAnnotationsImpl}(ApiScalarsAnnotationsImpl);exports.ExtensionScalarsAnnotationsImpl=ExtensionScalarsAnnotationsImpl,exports.loadApiSync=loadApiSync,exports.loadRAMLSync=loadRAMLSync,exports.loadApi=loadApi,exports.loadRAML=loadRAML,exports.getLanguageElementByRuntimeType=getLanguageElementByRuntimeType},function(module,exports,__webpack_require__){"use strict";var globalEmptyOpt,invariant=__webpack_require__(69),exists=function(v){return null!=v},Opt=function(){function Opt(_value){var _this=this;this._value=_value,this._isDefined=!1,
this._isEmpty=!0,this._arr=void 0,this.getOrThrow=function(){return invariant(_this._isDefined,"Opt is empty. Use `Opt#getOrElse` or check `Opt#isDefined`."),_this._value},this.value=function(){return _this._value},this.isDefined=function(){return _this._isDefined},this.isEmpty=function(){return _this._isEmpty},this.toArray=function(){return _this._arr||(_this._arr=_this._isDefined?[_this._value]:[])},this.getOrElse=function(v){return _this._isDefined?_this._value:v},this.getOrElseF=function(v){return _this._isDefined?_this._value:v()},this.map=function(f){return _this._isEmpty?Opt.empty():new Opt(f(_this._value))},this.flatMap=function(f){return _this.map(f).getOrElse(Opt.empty())},this.equals=function(other){return invariant(other instanceof Opt,"Expected other to be an `Opt`, but got `%s`",typeof other),_this._isDefined===other.isDefined()&&_this._value===other.value()},exists(this._value)&&(this._isDefined=!0,this._isEmpty=!1)}return Opt.prototype.forEach=function(fn){this.isDefined()&&fn(this._value)},Opt.empty=function(){return globalEmptyOpt||(globalEmptyOpt=new Opt)},Opt}();module.exports=Opt},function(module,exports,__webpack_require__){!function(root){function noop(){}function bind(fn,thisArg){return function(){fn.apply(thisArg,arguments)}}function Promise(fn){if("object"!=typeof this)throw new TypeError("Promises must be constructed via new");if("function"!=typeof fn)throw new TypeError("not a function");this._state=0,this._handled=!1,this._value=void 0,this._deferreds=[],doResolve(fn,this)}function handle(self,deferred){for(;3===self._state;)self=self._value;return 0===self._state?void self._deferreds.push(deferred):(self._handled=!0,void asap(function(){var cb=1===self._state?deferred.onFulfilled:deferred.onRejected;if(null===cb)return void(1===self._state?resolve:reject)(deferred.promise,self._value);var ret;try{ret=cb(self._value)}catch(e){return void reject(deferred.promise,e)}resolve(deferred.promise,ret)}))}function resolve(self,newValue){try{if(newValue===self)throw new TypeError("A promise cannot be resolved with itself.");if(newValue&&("object"==typeof newValue||"function"==typeof newValue)){var then=newValue.then;if(newValue instanceof Promise)return self._state=3,self._value=newValue,void finale(self);if("function"==typeof then)return void doResolve(bind(then,newValue),self)}self._state=1,self._value=newValue,finale(self)}catch(e){reject(self,e)}}function reject(self,newValue){self._state=2,self._value=newValue,finale(self)}function finale(self){2===self._state&&0===self._deferreds.length&&asap(function(){self._handled||onUnhandledRejection(self._value)},1);for(var i=0,len=self._deferreds.length;len>i;i++)handle(self,self._deferreds[i]);self._deferreds=null}function Handler(onFulfilled,onRejected,promise){this.onFulfilled="function"==typeof onFulfilled?onFulfilled:null,this.onRejected="function"==typeof onRejected?onRejected:null,this.promise=promise}function doResolve(fn,self){var done=!1;try{fn(function(value){done||(done=!0,resolve(self,value))},function(reason){done||(done=!0,reject(self,reason))})}catch(ex){if(done)return;done=!0,reject(self,ex)}}var setTimeoutFunc=setTimeout,asap="function"==typeof setImmediate&&setImmediate||function(fn){setTimeoutFunc(fn,1)},onUnhandledRejection=function(err){"undefined"!=typeof console&&console&&console.warn("Possible Unhandled Promise Rejection:",err)};Promise.prototype["catch"]=function(onRejected){return this.then(null,onRejected)},Promise.prototype.then=function(onFulfilled,onRejected){var prom=new Promise(noop);return handle(this,new Handler(onFulfilled,onRejected,prom)),prom},Promise.all=function(arr){var args=Array.prototype.slice.call(arr);return new Promise(function(resolve,reject){function res(i,val){try{if(val&&("object"==typeof val||"function"==typeof val)){var then=val.then;if("function"==typeof then)return void then.call(val,function(val){res(i,val)},reject)}args[i]=val,0===--remaining&&resolve(args)}catch(ex){reject(ex)}}if(0===args.length)return resolve([]);for(var remaining=args.length,i=0;i<args.length;i++)res(i,args[i])})},Promise.resolve=function(value){return value&&"object"==typeof value&&value.constructor===Promise?value:new Promise(function(resolve){resolve(value)})},Promise.reject=function(value){return new Promise(function(resolve,reject){reject(value)})},Promise.race=function(values){return new Promise(function(resolve,reject){for(var i=0,len=values.length;len>i;i++)values[i].then(resolve,reject)})},Promise._setImmediateFn=function(fn){asap=fn},Promise._setUnhandledRejectionFn=function(fn){onUnhandledRejection=fn},"undefined"!=typeof module&&module.exports?module.exports=Promise:root.Promise||(root.Promise=Promise)}(this)},function(module,exports,__webpack_require__){"use strict";function globalDeclarations(h){for(var result=[],visitedUnits={};null!=h.parent();)h.lowLevel().includePath()&&(result=result.concat(findDeclarations(h,visitedUnits))),h=h.parent();return result=result.concat(findDeclarations(h,visitedUnits))}function getUserDefinedPropertySource(property){var result=property.node();if(result&&hl.isParseResult(result))return result;var sourceProvider=sourceFinder.getNominalPropertySource2(property);return sourceProvider?sourceProvider.getSource():null}function findDeclarations(h,visitedUnits,rs){if(void 0===visitedUnits&&(visitedUnits={}),void 0===rs&&(rs=[]),!h.lowLevel())return[];var aPath=h.lowLevel().unit().absolutePath();if(visitedUnits[aPath]=!0,!(h instanceof hlimpl.ASTNodeImpl))return rs;var skipAll=!1;return h.elements().forEach(function(x){if(x.definition().key()==universes.Universe10.UsesDeclaration){if(skipAll)return;var mm=x.attr("value");if(mm){var unit=x.root().lowLevel().unit().resolve(mm.value());if(unit&&resourceRegistry.isWaitingFor(unit.absolutePath()))return void(skipAll=!0);null!=unit&&unit.isRAMLUnit()&&!visitedUnits[unit.absolutePath()]&&unit.highLevel().isElement()&&findDeclarations(unit.highLevel().asElement(),visitedUnits,rs)}}else rs.push(x)}),rs}function getIndent2(offset,text){for(var spaces="",i=offset-1;i>=0;i--){var c=text.charAt(i);if(" "==c||"	"==c)spaces?spaces+=c:spaces=c;else if("\r"==c||"\n"==c)return spaces}}function deepFindNode(n,offset,end,goToOtherUnits,returnAttrs){if(void 0===goToOtherUnits&&(goToOtherUnits=!0),void 0===returnAttrs&&(returnAttrs=!0),null==n)return null;if(n.lowLevel()&&n.lowLevel().start()<=offset&&n.lowLevel().end()>=end){if(n instanceof hlimpl.ASTNodeImpl){for(var hn=n,all=goToOtherUnits?hn.children():hn.directChildren(),i=0;i<all.length;i++)if(goToOtherUnits||all[i].lowLevel().unit()==n.lowLevel().unit()){var node=deepFindNode(all[i],offset,end,goToOtherUnits);if(node)return!returnAttrs&&node instanceof hlimpl.ASTPropImpl&&(node=node.parent()),node}return n}if(n instanceof hlimpl.ASTPropImpl){var attr=n;if(!attr.property().isKey()){var vl=attr.value();if(vl instanceof hlimpl.StructuredValue){var st=vl,hl=st.toHighLevel2();if(hl&&!goToOtherUnits&&hl.lowLevel().unit()!=n.lowLevel().unit())return null;var node=deepFindNode(hl,offset,end,goToOtherUnits);if(node)return!returnAttrs&&node instanceof hlimpl.ASTPropImpl&&(node=node.parent()),node}return returnAttrs?attr:attr.parent()}return null}return null}return null}function getValueAt(text,offset){for(var sp=-1,i=offset-1;i>=0;i--){var c=text.charAt(i);if("\r"==c||"\n"==c||" "==c||"	"==c||'"'==c||"'"==c||":"==c){sp=i+1;break}}for(var ep=-1,i=offset;i<text.length;i++){var c=text.charAt(i);if("\r"==c||"\n"==c||" "==c||"	"==c||'"'==c||"'"==c||":"==c){ep=i;break}}return-1!=sp&&-1!=ep?text.substring(sp,ep):""}function extractName(cleaned,offset){for(var txt="",i=offset;i>=0;i--){var c=cleaned[i];if(" "==c||"\r"==c||"\n"==c||"|"==c||"["==c||"]"==c||":"==c||"("==c||")"==c)break;txt=c+txt}for(var i=offset+1;i<cleaned.length;i++){var c=cleaned[i];if(" "==c||"\r"==c||"\n"==c||"|"==c||"["==c||"]"==c||":"==c||"("==c||")"==c||","==c)break;txt+=c}return txt}function findUsages(unit,offset){var decl=findDeclaration(unit,offset);if(decl){if(decl instanceof hlimpl.ASTNodeImpl){var hnode=decl;return{node:hnode,results:hnode.findReferences()}}decl instanceof hlimpl.ASTPropImpl}var node=deepFindNode(hlimpl.fromUnit(unit),offset,offset,!1);if(node instanceof hlimpl.ASTNodeImpl)return{node:node,results:node.findReferences()};if(node instanceof hlimpl.ASTPropImpl){var prop=node;if(prop.property().canBeValue())return{node:prop.parent(),results:prop.parent().findReferences()}}return{node:null,results:[]}}function referenceTargets(p0,c){var p=p0;if(p.getAdapter(ramlServices.RAMLPropertyService).isTypeExpr()){var definitionNodes=globalDeclarations(c).filter(function(node){var nc=node.definition().key();return nc===universes.Universe08.GlobalSchema?!0:node.definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name)});return definitionNodes}if(p.getAdapter(ramlServices.RAMLPropertyService).isDescriminating()){var subTypes=nodesDeclaringType(p.range(),c);return subTypes}if(p.isReference()){var rt=p.referencesTo(),subTypes=nodesDeclaringType(rt,c);return subTypes}if(p.range().hasValueTypeInHierarchy()){var vt=p.range().getAdapter(ramlServices.RAMLService);if(vt.globallyDeclaredBy().length>0){var definitionNodes=globalDeclarations(c).filter(function(z){return null!=_.find(vt.globallyDeclaredBy(),function(x){return x==z.definition()})});return definitionNodes}}return[]}function enumValues(p,c){if(c){var rs=[];if(p.getAdapter(ramlServices.RAMLPropertyService).isTypeExpr()){var definitionNodes=globalDeclarations(c).filter(function(node){var nc=node.definition().key();return nc===universes.Universe08.GlobalSchema?!0:node.definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name)});rs=definitionNodes.map(function(x){return hlimpl.qName(x,c)});var de=c.definition().universe().type(universes.Universe10.TypeDeclaration.name);if(de){var subTypes=de.allSubTypes();rs=rs.concat(subTypes.map(function(x){return x.getAdapter(ramlServices.RAMLService).descriminatorValue()}))}return rs}var rangeKey=p.range().key();if((rangeKey==universes.Universe08.SchemaString||rangeKey==universes.Universe10.SchemaString)&&"RAML10"==p.range().universe().version()&&p.range().hasValueTypeInHierarchy()){var definitionNodes=globalDeclarations(c).filter(function(node){return node.definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name)});rs=definitionNodes.map(function(x){return hlimpl.qName(x,c)})}if(p.getAdapter(ramlServices.RAMLPropertyService).isDescriminating()){var subTypes=subTypesWithLocals(p.domain(),c);rs=rs.concat(subTypes.map(function(x){return x.getAdapter(ramlServices.RAMLService).descriminatorValue()}))}else if(p.isReference())rs=nodesDeclaringType(p.referencesTo(),c).map(function(x){return hlimpl.qName(x,c)});else if(p.range().hasValueTypeInHierarchy()){var vt=p.range().getAdapter(ramlServices.RAMLService);if(vt.globallyDeclaredBy().length>0){var definitionNodes=globalDeclarations(c).filter(function(z){return null!=_.find(vt.globallyDeclaredBy(),function(x){return x==z.definition()})});rs=rs.concat(definitionNodes.map(function(x){return hlimpl.qName(x,c)}))}}return p.isAllowNull()&&rs.push("null"),p.enumOptions()&&(rs=rs.concat(p.enumOptions())),rs}return p.enumOptions()&&"string"==typeof p.enumOptions()?[p.enumOptions()+""]:p.enumOptions()}function getLibraryName(node){return node.isElement()&&node.asElement().definition().key()!=universes.Universe10.Library?null:node.asElement().attrValue("name")}function findDeclarationByNode(node,nodePart){var unit=node.lowLevel().unit();if(!unit)return null;var start=node.lowLevel().start(),end=node.lowLevel().end();if(nodePart&&nodePart==LocationKind.KEY_COMPLETION?(start=node.lowLevel().keyStart(),end=node.lowLevel().keyEnd()):nodePart&&nodePart==LocationKind.VALUE_COMPLETION&&(start=node.lowLevel().valueStart(),end=node.lowLevel().valueEnd()),-1==start||-1==end)return null;var offset=Math.floor((start+end)/2);return findDeclaration(unit,offset,nodePart)}function findDeclaration(unit,offset,nodePart){var node=deepFindNode(hlimpl.fromUnit(unit),offset,offset,!1),result=null;if(node.isElement()&&node.asElement().definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name)&&node.asElement().directChildren().forEach(function(x){if(x.isUnknown()&&x.getLowLevelStart()<offset&&x.getLowLevelEnd()>offset){var tp=node.asElement().localType();tp.allFacets().forEach(function(f){if(f.nameId()==x.lowLevel().key()&&f instanceof def.UserDefinedProp){var up=getUserDefinedPropertySource(f);result=up}})}}),!node.property())return node;if("example"==node.property().nameId()){node.parent().localType();node.lowLevel().children().forEach(function(y){"example"==y.key()&&y.children().forEach(function(x){if(x.start()<offset&&x.end()>offset){var tp=node.parent().asElement().localType();tp.allProperties().forEach(function(f){if(f.nameId()==x.key()&&f instanceof def.UserDefinedProp){var up=getUserDefinedPropertySource(f);result=up}})}})})}if(result)return result;var kind=null!=nodePart?nodePart:determineCompletionKind(unit.contents(),offset);if(kind==LocationKind.VALUE_COMPLETION){var hlnode=node;if(node instanceof hlimpl.ASTPropImpl){var attr=node;if(attr&&attr.value()){if(!(attr.value()instanceof hlimpl.StructuredValue))return searchInTheValue(offset,unit.contents(),attr,hlnode);var sval=attr.value(),hlvalue=sval.toHighLevel();if(hlvalue){var newAttr=_.find(hlvalue.attrs(),function(x){return x.lowLevel().start()<offset&&x.lowLevel().end()>=offset});if(newAttr)return searchInTheValue(offset,unit.contents(),newAttr,hlvalue,attr.property())}}}else{var nodeProperty=hlnode.property();if(nodeProperty)return searchInTheValue(offset,unit.contents(),null,hlnode,nodeProperty)}}if(kind==LocationKind.KEY_COMPLETION||kind==LocationKind.SEQUENCE_KEY_COPLETION){var hlnode=node,pp=node.property();if(pp instanceof defs.UserDefinedProp){var up=pp;return getUserDefinedPropertySource(up)}if(node instanceof hlimpl.ASTNodeImpl&&hlnode.definition()instanceof defs.UserDefinedClass){var uc=hlnode.definition();return uc.isAssignableFrom("TypeDeclaration")?node:uc.getAdapter(ramlServices.RAMLService).getDeclaringNode()}if(node instanceof hlimpl.ASTPropImpl){var pr=node;if(isExampleNodeContent(pr)){var contentType=findExampleContentType(pr);if(contentType){var documentationRoot=parseDocumentationContent(pr,contentType);if(documentationRoot){var node=deepFindNode(documentationRoot,offset,offset);if(pp=node.property(),pp instanceof defs.UserDefinedProp){var up=pp;return getUserDefinedPropertySource(up)}if(node instanceof hlimpl.ASTNodeImpl&&hlnode.definition()instanceof defs.UserDefinedClass){var uc=hlnode.definition();return uc.getAdapter(ramlServices.RAMLService).getDeclaringNode()}}}}}}if(kind==LocationKind.PATH_COMPLETION){var inclpath=getValueAt(unit.contents(),offset);if(inclpath){var ap=unit.resolve(inclpath);return ap}}}function findExampleContentType(node){var potentialTypeNode=null;if(node.isElement()?potentialTypeNode=node:node.isAttr()&&(potentialTypeNode=node.parent()),!potentialTypeNode.definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name)){var parent=potentialTypeNode.parent();if(!parent)return null;if(parent.definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name))potentialTypeNode=parent;else{if(parent=parent.parent(),null==parent)return null;if(!parent.definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name))return null;potentialTypeNode=parent}}return potentialTypeNode.localType()}function parseDocumentationContent(attribute,type){return attribute.value()instanceof hlimpl.StructuredValue?new hlimpl.ASTNodeImpl(attribute.value().lowLevel(),attribute.parent(),type,attribute.property()):null}function parseStructuredExample(exampleNode,type){return new hlimpl.ASTNodeImpl(exampleNode.lowLevel(),exampleNode,type,exampleNode.property())}function isExampleNode(node){return node.definition().key()==universes.Universe10.ExampleSpec}function isExampleNodeContent(node){var typeExampleName10=universes.Universe10.TypeDeclaration.properties.example.name,objectName10=universes.Universe10.ObjectTypeDeclaration.name;if(!(node instanceof hlimpl.ASTPropImpl))return!1;var property=node,parent=property.parent(),parentProperty=parent&&parent.property();parentProperty&&parentProperty.nameId();return typeExampleName10===property.name()&&property.isString()&&parent instanceof hlimpl.ASTNodeImpl&&parent.definition().isAssignableFrom(objectName10)?!0:!1}function determineCompletionKind(text,offset){for(var hasIn=!1,hasSeq=!1,canBeAnnotation=!1,i=offset-1;i>=0;i--){var c=text.charAt(i);if("("==c)canBeAnnotation=!0;else{if(canBeAnnotation){if("\r"==c||"\n"==c){for(var hasClosing=!1,j=offset-1;j<text.length;j++){var ch=text[j];if(")"==ch&&(hasClosing=!0),"\r"==ch||"\n"==ch)break;if(":"==ch){canBeAnnotation=!1;break}}if(canBeAnnotation&&hasClosing)return LocationKind.ANNOTATION_COMPLETION;break}if(" "==c||"	"==c)continue;break}if("\r"==c||"\n"==c)break;if(":"==c)break}}for(var i=offset-1;i>=0;i--){var c=text.charAt(i);if("#"==c){if(0==i)return LocationKind.VERSION_COMPLETION;for(var j=i-1;j>=0;j--){var currentChar=text.charAt(j);if("\r"==currentChar||"\n"==currentChar)break;if("!"==currentChar&&text.indexOf("!include",j)==j)return LocationKind.PATH_COMPLETION}return LocationKind.INCOMMENT}if(":"==c)return hasIn?LocationKind.DIRECTIVE_COMPLETION:LocationKind.VALUE_COMPLETION;if("\r"==c||"\n"==c){for(var insideOfMultiline=!1,ind=getIndent2(offset,text),a=i;a>0;a--){if(c=text.charAt(a),":"==c){if(insideOfMultiline){var ll=getIndent2(a,text);if(ll.length<ind.length)return LocationKind.VALUE_COMPLETION}break}"|"!=c?(("\r"==c||"\n"==c)&&(insideOfMultiline=!1)," "!=c&&"	"!=c&&(insideOfMultiline=!1)):insideOfMultiline=!0}return hasSeq?LocationKind.SEQUENCE_KEY_COPLETION:LocationKind.KEY_COMPLETION}if("-"==c&&(hasSeq=!0),"!"==c){if(text.indexOf("!include",i)==i)return LocationKind.PATH_COMPLETION;text.indexOf("!i",i)==i&&(hasIn=!0)}}}function resolveReference(point,path){if(!path)return null;for(var sp=path.split("/"),result=point,i=0;i<sp.length;i++)if("#"!=sp[i]){if(result=_.find(result.children(),function(x){return x.key()==sp[i]}),!result)return null}else result=point.unit().ast();return result}function subTypesWithLocals(range,parentNode){if(null==range)return[];var name=range.nameId();parentNode=exports.declRoot(parentNode);var actual=parentNode;if(actual._subTypesCache){var cached=actual._subTypesCache[name];if(cached)return cached}else actual._subTypesCache={};var result=range.allSubTypes();if(range.getAdapter(ramlServices.RAMLService).getRuntimeExtenders().length>0&&parentNode){var decls=globalDeclarations(parentNode),extenders=range.getAdapter(ramlServices.RAMLService).getRuntimeExtenders();parentNode.root();extenders.forEach(function(x){var definitionNodes=decls.filter(function(z){var def=z.definition().allSuperTypes();def.push(z.definition());var rr=z.definition()==x||null!=_.find(def,function(d){return d==x})||null!=_.find(def,function(d){return d==range});return rr});result=result.concat(definitionNodes.map(function(x){return x.localType()}))})}return result=_.unique(result),actual._subTypesCache[name]=result,result}function subTypesWithName(tname,parentNode,backup){parentNode=exports.declRoot(parentNode);var decls=globalDeclarations(parentNode),declNode=_.find(decls,function(x){return hlimpl.qName(x,parentNode)==tname&&x.property()&&x.property().nameId()==universes.Universe10.LibraryBase.properties.types.name});return declNode.localType()}function schemasWithName(tname,parentNode,backup){parentNode=exports.declRoot(parentNode);var decls=globalDeclarations(parentNode),declNode=_.find(decls,function(x){return hlimpl.qName(x,parentNode)==tname&&x.property()&&x.property().nameId()==universes.Universe10.LibraryBase.properties.schemas.name});return declNode.localType()}function nodesDeclaringType(range,n){var result=[],extenders=[range].concat(range.getAdapter(ramlServices.RAMLService).getRuntimeExtenders());if(n){var root=n;extenders.forEach(function(x){var definitionNodes=globalDeclarations(root).filter(function(z){return z.definition().isAssignableFrom(x.nameId())});result=result.concat(definitionNodes)})}var isElementType=!range.hasValueTypeInHierarchy();if(isElementType&&range.getAdapter(ramlServices.RAMLService).isInlinedTemplates()&&n){var root=n,definitionNodes=globalDeclarations(root).filter(function(z){return z.definition()==range});result=result.concat(definitionNodes)}else{var root=n,q={};range.allSubTypes().forEach(function(x){return q[x.nameId()]=!0}),q[range.nameId()]=!0;var definitionNodes=globalDeclarations(root).filter(function(z){return q[z.definition().nameId()]});result=result.concat(definitionNodes)}return result}function findAllSubTypes(p,n){var range=p.range();return subTypesWithLocals(range,n)}function possibleNodes(p,c){if(c){if(p.isDescriminator()){var range=p.range(),extenders=range.getAdapter(ramlServices.RAMLService).getRuntimeExtenders();if(extenders.length>0&&c){var result=[];return extenders.forEach(function(x){var definitionNodes=globalDeclarations(c).filter(function(z){return z.definition()==x});result=result.concat(definitionNodes)}),result}return[]}if(p.isReference())return nodesDeclaringType(p.referencesTo(),c);if(p.range().hasValueTypeInHierarchy()){var vt=p.range().getAdapter(ramlServices.RAMLService);if(vt.globallyDeclaredBy&&vt.globallyDeclaredBy().length>0){var definitionNodes=globalDeclarations(c).filter(function(z){return null!=_.find(vt.globallyDeclaredBy(),function(x){return x==z.definition()})});return definitionNodes}}}return[]}function allChildren(node){var res=[];return gather(node,res),res}function gather(node,result){node.children().forEach(function(x){result.push(x),gather(x,result)})}function refFinder(root,node,result){root.elements().forEach(function(x){refFinder(x,node,result);x.definition()}),root.attrs().forEach(function(a){var pr=a.property(),vl=a.value();if(pr instanceof defs.UserDefinedProp){var up=pr.node();up==node?result.push(a):up.lowLevel().start()==node.lowLevel().start()&&up.lowLevel().unit()==node.lowLevel().unit()&&result.push(a)}if(isExampleNodeContent(a)){var contentType=findExampleContentType(a);if(contentType){var documentationRoot=parseDocumentationContent(a,contentType);documentationRoot&&refFinder(documentationRoot,node,result)}}else if(pr.getAdapter(ramlServices.RAMLPropertyService).isTypeExpr()&&"string"==typeof vl){var tpa=root.localType();testUsage(tpa,a,node,result);var libraryName=getLibraryName(node);if(libraryName&&-1!=vl.indexOf(libraryName)){var referencingLibrary=getLibraryDefiningNode(a);referencingLibrary&&referencingLibrary.lowLevel().start()==node.lowLevel().start()&&result.push(a)}}if(pr.isReference()||pr.isDescriminator())if("string"==typeof vl){var pn=possibleNodes(pr,root);_.find(pn,function(x){return x.name()==vl&&x==node})&&result.push(a);var libraryName=getLibraryName(node);if(libraryName&&-1!=vl.indexOf(libraryName)){var referencingLibrary=getLibraryDefiningNode(a);referencingLibrary&&referencingLibrary.lowLevel().start()==node.lowLevel().start()&&result.push(a)}}else{var st=vl;if(st){var vn=st.valueName(),pn=possibleNodes(pr,root);_.find(pn,function(x){return x.name()==vn&&x==node})&&result.push(a);var hnode=st.toHighLevel();hnode&&refFinder(hnode,node,result);var libraryName=getLibraryName(node);if(libraryName&&-1!=vn.indexOf(libraryName)){var referencingLibrary=getLibraryDefiningNode(hnode);referencingLibrary&&referencingLibrary.lowLevel().start()==node.lowLevel().start()&&result.push(a)}}}else{var pn=possibleNodes(pr,root);_.find(pn,function(x){return x.name()==vl&&x==node})&&result.push(a)}})}function getLibraryDefiningNode(nodeToCheck){if(!nodeToCheck.lowLevel)return null;var lowLevelNode=nodeToCheck.lowLevel();if(!lowLevelNode)return null;if(lowLevelNode.key()){var offset=Math.floor((lowLevelNode.keyEnd()+lowLevelNode.keyStart())/2),result=getLibraryDefiningNodeByOffset(lowLevelNode.unit(),offset);if(result)return result}if(lowLevelNode.value()){var offset=Math.floor((lowLevelNode.valueEnd()+lowLevelNode.valueStart())/2),result=getLibraryDefiningNodeByOffset(lowLevelNode.unit(),offset);if(result)return result}return null}function getLibraryDefiningNodeByOffset(unit,offset){var declaration=findDeclaration(unit,offset);if(declaration&&declaration.isElement&&declaration.isElement())for(var declarationNode=declaration.asElement(),parent=declarationNode;parent;){if(parent.definition().key()==universes.Universe10.Library)return parent;parent=parent.parent()}return null}var defs=__webpack_require__(36),hl=__webpack_require__(10),_=__webpack_require__(65),def=__webpack_require__(36),hlimpl=__webpack_require__(16),universes=__webpack_require__(18),ramlServices=def,sourceFinder=__webpack_require__(46),resourceRegistry=__webpack_require__(29);exports.declRoot=function(h){for(var declRoot=h;;){if(declRoot.definition().key()==universes.Universe10.Library)break;var np=declRoot.parent();if(!np)break;declRoot=np}return declRoot},exports.globalDeclarations=globalDeclarations,exports.findDeclarations=findDeclarations,exports.deepFindNode=deepFindNode,exports.extractName=extractName;var searchInTheValue=function(offset,content,attr,hlnode,p){void 0===p&&(p=attr.property());var targets=referenceTargets(p,hlnode),txt=extractName(content,offset),t=_.find(targets,function(x){return hlimpl.qName(x,hlnode)==txt});if(t)return t;if(p instanceof defs.UserDefinedProp){var up=p;return getUserDefinedPropertySource(up)}return null};exports.findUsages=findUsages,exports.referenceTargets=referenceTargets,exports.enumValues=enumValues,exports.findDeclarationByNode=findDeclarationByNode,exports.findDeclaration=findDeclaration,exports.findExampleContentType=findExampleContentType,exports.parseDocumentationContent=parseDocumentationContent,exports.parseStructuredExample=parseStructuredExample,exports.isExampleNode=isExampleNode,exports.isExampleNodeContent=isExampleNodeContent,exports.determineCompletionKind=determineCompletionKind,function(LocationKind){LocationKind[LocationKind.VALUE_COMPLETION=0]="VALUE_COMPLETION",LocationKind[LocationKind.KEY_COMPLETION=1]="KEY_COMPLETION",LocationKind[LocationKind.PATH_COMPLETION=2]="PATH_COMPLETION",LocationKind[LocationKind.DIRECTIVE_COMPLETION=3]="DIRECTIVE_COMPLETION",LocationKind[LocationKind.VERSION_COMPLETION=4]="VERSION_COMPLETION",LocationKind[LocationKind.ANNOTATION_COMPLETION=5]="ANNOTATION_COMPLETION",LocationKind[LocationKind.SEQUENCE_KEY_COPLETION=6]="SEQUENCE_KEY_COPLETION",LocationKind[LocationKind.INCOMMENT=7]="INCOMMENT"}(exports.LocationKind||(exports.LocationKind={}));var LocationKind=exports.LocationKind;exports.resolveReference=resolveReference,exports.subTypesWithLocals=subTypesWithLocals,exports.subTypesWithName=subTypesWithName,exports.schemasWithName=schemasWithName,exports.nodesDeclaringType=nodesDeclaringType,exports.findAllSubTypes=findAllSubTypes,exports.allChildren=allChildren;var testUsage=function(ck,x,node,result){var tp=ck.getAdapter(ramlServices.RAMLService).getDeclaringNode();if(tp&&node.isSameNode(tp))return void result.push(x);if(ck.isArray()&&testUsage(ck.array().componentType(),x,node,result),ck.isUnion()){var uni=ck.union();testUsage(uni.leftType(),x,node,result),testUsage(uni.rightType(),x,node,result)}ck.superTypes().some(function(x){return x.nameId()==node.name()})&&result.push(x)};exports.refFinder=refFinder},function(module,exports,__webpack_require__){"use strict";function expandTraitsAndResourceTypes(api){return api instanceof RamlWrapperImpl.ApiImpl||api instanceof RamlWrapper08Impl.ApiImpl?(new TraitsAndResourceTypesExpander).expandTraitsAndResourceTypes(api):null}function expandLibraries(api){return(new LibraryExpander).expandLibraries(api)}function mergeAPIs(masterUnit,extensionsAndOverlays,mergeMode){var masterApi=hlimpl.fromUnit(masterUnit);if(!masterApi)throw new Error("couldn't load api from "+masterUnit.absolutePath());if(!extensionsAndOverlays||0==extensionsAndOverlays.length)return masterApi;for(var highLevelNodes=[],i=0;i<extensionsAndOverlays.length;i++){var unit=extensionsAndOverlays[i],hlNode=hlimpl.fromUnit(unit);if(!hlNode)throw new Error("couldn't load api from "+unit.absolutePath());highLevelNodes.push(hlNode)}var lastExtensionOrOverlay=mergeHighLevelNodes(masterApi,highLevelNodes,mergeMode);return lastExtensionOrOverlay}function mergeHighLevelNodes(masterApi,highLevelNodes,mergeMode,rp,expand){void 0===rp&&(rp=null),void 0===expand&&(expand=!1);for(var currentMaster=masterApi,_i=0,highLevelNodes_1=highLevelNodes;_i<highLevelNodes_1.length;_i++){var currentApi=highLevelNodes_1[_i];expand&&currentMaster.lowLevel()instanceof proxy.LowLevelProxyNode&&(currentMaster=(new TraitsAndResourceTypesExpander).expandHighLevelNode(currentMaster,rp,masterApi.wrapperNode()).highLevel()),currentApi.overrideMaster(currentMaster),currentApi.setMergeMode(mergeMode),currentMaster=currentApi}return currentMaster}function toUnits1(nodes){for(var result=[],_i=0,nodes_1=nodes;_i<nodes_1.length;_i++){var n=nodes_1[_i];toUnits2(result,n,!0)}return result}function toUnits2(chainStart,node,append){void 0===append&&(append=!1);var result=append?chainStart:chainStart.concat([]),unit=node.lowLevel().unit();if(null==unit)return result;if(0==result.length)result.push(unit);else{var prevPath=result[result.length-1].absolutePath();unit.absolutePath()!=prevPath&&result.push(unit)}return result}function toUnits(node){for(var nodes=[];node;)nodes.push(node),node=node.parent();return toUnits1(nodes)}function getTransformNames(){return transformers.map(function(transformer){return transformer.name})}function getTransformersForOccurence(occurence){for(var result=[],functions=occurence.split("|").slice(1),_i=0,functions_1=functions;_i<functions_1.length;_i++)for(var f=functions_1[_i],i=0;i<transformers.length;i++)if(f.match(transformers[i].regexp)){result.push(transformers[i].transformer);break}return result}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},hl=__webpack_require__(10),hlimpl=__webpack_require__(16),yaml=__webpack_require__(74),util=__webpack_require__(32),proxy=__webpack_require__(39),RamlWrapperImpl=__webpack_require__(21),RamlWrapper08Impl=__webpack_require__(47),wrapperHelper=__webpack_require__(33),wrapperHelper08=__webpack_require__(48),pluralize=__webpack_require__(70),universeDef=__webpack_require__(18),_=__webpack_require__(65),referencePatcher=__webpack_require__(49),namespaceResolver=__webpack_require__(50),universeHelpers=__webpack_require__(14),changeCase=__webpack_require__(71);exports.expandTraitsAndResourceTypes=expandTraitsAndResourceTypes,exports.expandLibraries=expandLibraries,exports.mergeAPIs=mergeAPIs;var TraitsAndResourceTypesExpander=function(){function TraitsAndResourceTypesExpander(){this.namespaceResolver=new namespaceResolver.NamespaceResolver}return TraitsAndResourceTypesExpander.prototype.expandTraitsAndResourceTypes=function(api,rp,forceProxy){if(void 0===rp&&(rp=null),void 0===forceProxy&&(forceProxy=!1),this.init(api),!api.highLevel().lowLevel())return api;var unit=api.highLevel().lowLevel().unit(),hasFragments=unit.project().namespaceResolver().hasFragments(unit),hasTemplates=0!=this.globalTraits.length||0!=this.globalResourceTypes.length;if(!hasTemplates&&!hasFragments&&!forceProxy)return api;var hlNode=this.createHighLevelNode(api.highLevel(),!1,rp);if(api.definition().key()==universeDef.Universe10.Overlay)return hlNode.wrapperNode();var result=this.expandHighLevelNode(hlNode,rp,api);return result},TraitsAndResourceTypesExpander.prototype.init=function(api){this.ramlVersion=api.highLevel().definition().universe().version(),this.globalTraits="RAML10"==this.ramlVersion?wrapperHelper.allTraits(api):wrapperHelper08.allTraits(api),this.globalResourceTypes="RAML10"==this.ramlVersion?wrapperHelper.allResourceTypes(api):wrapperHelper08.allResourceTypes(api)},TraitsAndResourceTypesExpander.prototype.expandHighLevelNode=function(hlNode,rp,api){
var _this=this;this.init(api);var result=hlNode.wrapperNode();result.setAttributeDefaults(api.getDefaultsCalculator().isEnabled()),result.highLevel().setMergeMode(api.highLevel().getMergeMode());var resources=result.resources();return resources.forEach(function(x){return _this.processResource(x)}),"RAML10"==this.ramlVersion&&(rp=rp||new referencePatcher.ReferencePatcher,rp.process(hlNode),hlNode.lowLevel().actual().referencePatcher=rp),result},TraitsAndResourceTypesExpander.prototype.getTemplate=function(name,context,cache,globalList){var unitPath=context.lowLevel().unit().path(),unitCache=cache[unitPath];unitCache||(unitCache={},cache[unitPath]=unitCache);var val=unitCache[name];return void 0!==val?val:(val=null,val=_.find(globalList,function(x){return hlimpl.qName(x.highLevel(),context)==name}),val||(val=null),unitCache[name]=val,val)},TraitsAndResourceTypesExpander.prototype.createHighLevelNode=function(_api,merge,rp,forceProxy){void 0===merge&&(merge=!0),void 0===rp&&(rp=null),void 0===forceProxy&&(forceProxy=!1);for(var api=_api,highLevelNodes=[],node=api;node;){var topComposite,llNode=node.lowLevel();topComposite=api.definition().key()!=universeDef.Universe10.Overlay||forceProxy?new proxy.LowLevelCompositeNode(llNode,null,null,this.ramlVersion):llNode;var nodeType=node.definition(),newNode=new hlimpl.ASTNodeImpl(topComposite,null,nodeType,null);if(highLevelNodes.push(newNode),!merge)break;node=node.getMaster()}var masterApi=highLevelNodes.pop();highLevelNodes=highLevelNodes.reverse();var mergeMode=api.getMergeMode();return mergeHighLevelNodes(masterApi,highLevelNodes,mergeMode,rp,forceProxy)},TraitsAndResourceTypesExpander.prototype.processResource=function(resource,_nodes){var _this=this;void 0===_nodes&&(_nodes=[]);var nodes=_nodes.concat(resource.highLevel()),resourceData=this.collectResourceData(resource,resource,void 0,void 0,nodes),resourceLowLevel=resource.highLevel().lowLevel();resourceData.filter(function(x){return null!=x.resourceType}).forEach(function(x){var resourceTypeLowLevel=x.resourceType.node.highLevel().lowLevel(),resourceTypeTransformer=x.resourceType.transformer;resourceTypeTransformer.owner=resource,resourceLowLevel.adopt(resourceTypeLowLevel,resourceTypeTransformer)});var methods=resource.methods();methods.forEach(function(m){var methodLowLevel=m.highLevel().lowLevel(),name=m.method(),allTraits=[];resourceData.forEach(function(x){var methodTraits=x.methodTraits[name];methodTraits&&(allTraits=allTraits.concat(methodTraits),methodTraits.forEach(function(x){var traitLowLevel=x.node.highLevel().lowLevel(),traitTransformer=x.transformer;traitTransformer.owner=m,methodLowLevel.adopt(traitLowLevel,traitTransformer)}));var resourceTraits=x.traits;resourceTraits&&(allTraits=allTraits.concat(resourceTraits),resourceTraits.forEach(function(x){var traitLowLevel=x.node.highLevel().lowLevel(),traitTransformer=x.transformer;traitTransformer.owner=m,methodLowLevel.adopt(traitLowLevel,traitTransformer)}))})});var resources=resource.resources();resources.forEach(function(x){return _this.processResource(x,nodes)})},TraitsAndResourceTypesExpander.prototype.collectResourceData=function(original,obj,arr,transformer,nodesChain,occuredResourceTypes){var _this=this;void 0===arr&&(arr=[]),void 0===nodesChain&&(nodesChain=[]),void 0===occuredResourceTypes&&(occuredResourceTypes={}),nodesChain=nodesChain.concat([obj.highLevel()]);var ownTraits=this.extractTraits(obj,transformer,nodesChain),methodTraitsMap={},methods=obj.methods();methods.forEach(function(x){var methodTraits=_this.extractTraits(x,transformer,nodesChain);methodTraits&&methodTraits.length>0&&(methodTraitsMap[x.method()]=methodTraits)});var rtData,rtRef=obj.type();if(null!=rtRef){var units=toUnits1(nodesChain);rtData=this.readGenerictData(original,rtRef,obj.highLevel(),"resource type",transformer,units)}var result={resourceType:rtData,traits:ownTraits,methodTraits:methodTraitsMap};if(arr.push(result),rtData){var rt=rtData.node,qName=hlimpl.qName(rt.highLevel(),original.highLevel());occuredResourceTypes[qName]?result.resourceType=null:(occuredResourceTypes[qName]=!0,this.collectResourceData(original,rt,arr,rtData.transformer,nodesChain,occuredResourceTypes))}return arr},TraitsAndResourceTypesExpander.prototype.extractTraits=function(obj,_transformer,nodesChain,occuredTraits){var _this=this;void 0===occuredTraits&&(occuredTraits={}),nodesChain=nodesChain.concat([obj.highLevel()]);for(var arr=[],i=-1;i<arr.length;i++){var gd=0>i?null:arr[i],_obj=gd?gd.node:obj,units=gd?gd.unitsChain:toUnits1(nodesChain),transformer=gd?gd.transformer:_transformer;_obj.is&&_obj.is().forEach(function(x){var unitsChain=toUnits2(units,x.highLevel()),traitData=_this.readGenerictData(obj,x,_obj.highLevel(),"trait",transformer,unitsChain);if(traitData){var name=traitData.name;occuredTraits[name]=!0,arr.push(traitData)}})}return arr},TraitsAndResourceTypesExpander.prototype.readGenerictData=function(r,obj,context,template,transformer,unitsChain){void 0===unitsChain&&(unitsChain=[]);var value=obj.value(),propName=pluralize.plural(changeCase.camelCase(template));if("string"==typeof value){transformer&&(value=transformer.transform(value).value);var _node=referencePatcher.getDeclaration(value,propName,this.namespaceResolver,unitsChain);if(_node){var node=_node.wrapperNode();return{name:value,transformer:null,parentTransformer:transformer,node:node,ref:obj,unitsChain:unitsChain}}}else if(value instanceof hlimpl.StructuredValue){var sv=value,name=sv.valueName();transformer&&(name=transformer.transform(name).value);var scalarParams={},structuredParams={},_node=referencePatcher.getDeclaration(name,propName,this.namespaceResolver,unitsChain);if(_node){var node=_node.wrapperNode();"RAML08"==this.ramlVersion?sv.children().forEach(function(x){return scalarParams[x.valueName()]=x.lowLevel().value()}):sv.children().forEach(function(x){var llNode=x.lowLevel();llNode.valueKind()==yaml.Kind.SCALAR?scalarParams[x.valueName()]=llNode.value():llNode.valueKind()==yaml.Kind.INCLUDE_REF&&0==llNode.children().length?scalarParams[x.valueName()]=llNode.value():structuredParams[x.valueName()]=llNode});var ds=new DefaultTransformer(r,null,unitsChain);Object.keys(scalarParams).forEach(function(x){var q=ds.transform(scalarParams[x]);q&&"object"!=typeof q&&(scalarParams[x]=q)});var valTransformer=new ValueTransformer(template,name,unitsChain,scalarParams,structuredParams,transformer),resourceTypeTransformer=new DefaultTransformer(null,valTransformer,unitsChain);return{name:name,transformer:resourceTypeTransformer,parentTransformer:transformer,node:node,ref:obj,unitsChain:unitsChain}}}return null},TraitsAndResourceTypesExpander.prototype.appendTraitReferences=function(m,traits){if(0!=traits.length){var traitsData=traits.map(function(x){return{node:x.ref.highLevel().lowLevel(),transformer:x.parentTransformer}});referencePatcher.patchMethodIs(m.highLevel(),traitsData)}},TraitsAndResourceTypesExpander}();exports.TraitsAndResourceTypesExpander=TraitsAndResourceTypesExpander;var LibraryExpander=function(){function LibraryExpander(){}return LibraryExpander.prototype.expandLibraries=function(_api){var api=_api;if(null==api)return null;api.highLevel().lowLevel()instanceof proxy.LowLevelCompositeNode&&(api=api.highLevel().lowLevel().unit().highLevel().asElement().wrapperNode());var expander=new TraitsAndResourceTypesExpander,rp=new referencePatcher.ReferencePatcher,hlNode=expander.createHighLevelNode(api.highLevel(),!0,rp,!0),result=expander.expandHighLevelNode(hlNode,rp,api);return this.processNode(rp,result.highLevel()),result},LibraryExpander.prototype.processNode=function(rp,hlNode){if(null!=hlNode){var master=hlNode.getMaster();this.processNode(rp,master),universeHelpers.isOverlayType(hlNode.definition())&&rp.process(hlNode),rp.expandLibraries(hlNode)}},LibraryExpander}();exports.LibraryExpander=LibraryExpander,exports.toUnits=toUnits;var TransformMatches=function(){function TransformMatches(name,transformer){this.name=name,this.regexp=new RegExp(TransformMatches.leftTransformRegexp.source+name+TransformMatches.rightTransformRegexp.source),this.transformer=transformer}return TransformMatches.leftTransformRegexp=/\s*!\s*/,TransformMatches.rightTransformRegexp=/\s*$/,TransformMatches}(),transformers=[new TransformMatches("singularize",function(arg){return pluralize.singular(arg)}),new TransformMatches("pluralize",function(arg){return pluralize.plural(arg)}),new TransformMatches("uppercase",function(arg){return arg?arg.toUpperCase():arg}),new TransformMatches("lowercase",function(arg){return arg?arg.toLowerCase():arg}),new TransformMatches("lowercamelcase",function(arg){return arg?changeCase.camelCase(arg):arg}),new TransformMatches("uppercamelcase",function(arg){if(!arg)return arg;var lowerCamelCase=changeCase.camelCase(arg);return lowerCamelCase[0].toUpperCase()+lowerCamelCase.substring(1,lowerCamelCase.length)}),new TransformMatches("lowerunderscorecase",function(arg){if(!arg)return arg;var snakeCase=changeCase.snake(arg);return snakeCase.toLowerCase()}),new TransformMatches("upperunderscorecase",function(arg){if(!arg)return arg;var snakeCase=changeCase.snake(arg);return snakeCase.toUpperCase()}),new TransformMatches("lowerhyphencase",function(arg){if(!arg)return arg;var paramCase=changeCase.param(arg);return paramCase.toLowerCase()}),new TransformMatches("upperhyphencase",function(arg){if(!arg)return arg;var paramCase=changeCase.param(arg);return paramCase.toUpperCase()})];exports.getTransformNames=getTransformNames,exports.getTransformersForOccurence=getTransformersForOccurence;var TransformationBuffer=function(){function TransformationBuffer(){this.buf=null}return TransformationBuffer.prototype.append=function(value){""!==value&&(null!=this.buf?null!=value&&("string"!=typeof this.buf&&(this.buf=""+this.buf),this.buf+=value):""!==value&&(this.buf=value))},TransformationBuffer.prototype.value=function(){return null!=this.buf?this.buf:""},TransformationBuffer}(),ValueTransformer=function(){function ValueTransformer(templateKind,templateName,unitsChain,params,structuredParams,vDelegate){this.templateKind=templateKind,this.templateName=templateName,this.unitsChain=unitsChain,this.params=params,this.structuredParams=structuredParams,this.vDelegate=vDelegate}return ValueTransformer.prototype.transform=function(obj,toString,doBreak,callback){var undefParams={},errors=[];if("string"==typeof obj){if(this.structuredParams&&util.stringStartsWith(obj,"<<")&&util.stringEndsWith(obj,">>")){var paramName=obj.substring(2,obj.length-2),structuredValue=this.structuredParams[paramName];if(null!=structuredValue)return{value:structuredValue.value(toString),errors:errors}}for(var str=obj,buf=new TransformationBuffer,prev=0,i=str.indexOf("<<");i>=0;i=str.indexOf("<<",prev)){buf.append(str.substring(prev,i));var i0=i;if(i+="<<".length,prev=this.paramUpperBound(str,i),-1==prev)break;var paramOccurence=str.substring(i,prev);prev+=">>".length;var val,paramName,originalString=str.substring(i0,prev),transformers=getTransformersForOccurence(paramOccurence);if(transformers.length>0){var ind=paramOccurence.indexOf("|");if(paramName=paramOccurence.substring(0,ind).trim(),val=this.params[paramName],val&&"string"==typeof val&&val.indexOf("<<")>=0&&this.vDelegate&&(val=this.vDelegate.transform(val,toString,doBreak,callback).value),val)for(var _i=0,transformers_1=transformers;_i<transformers_1.length;_i++){var tr=transformers_1[_i];val=tr(val)}}else paramName=paramOccurence.trim(),val=this.params[paramName],val&&"string"==typeof val&&val.indexOf("<<")>=0&&this.vDelegate&&(val=this.vDelegate.transform(val,toString,doBreak,callback).value);(null===val||void 0===val)&&(undefParams[paramName]=!0,val=originalString),buf.append(val)}var upArr=Object.keys(undefParams);if(upArr.length>0){var errStr=upArr.join(", ").trim(),message="Undefined "+this.templateKind+" parameter"+(upArr.length>1?"s":"")+": "+errStr,error={code:hl.IssueCode.MISSING_REQUIRED_PROPERTY,isWarning:!1,message:message,node:null,start:-1,end:-1,path:null};errors.push(error)}return buf.append(str.substring(prev,str.length)),{value:buf.value(),errors:errors}}return{value:obj,errors:errors}},ValueTransformer.prototype.paramUpperBound=function(str,pos){for(var count=0,i=pos;i<str.length;i++)if(util.stringStartsWith(str,"<<",i))count++,i++;else if(util.stringStartsWith(str,">>",i)){if(0==count)return i;count--,i++}return str.length},ValueTransformer.prototype.children=function(node){var substitution=this.substitutionNode(node);return substitution?substitution.children():null},ValueTransformer.prototype.valueKind=function(node){var substitution=this.substitutionNode(node);return substitution?substitution.valueKind():null},ValueTransformer.prototype.substitutionNode=function(node){var paramName=this.paramName(node);return paramName&&this.structuredParams[paramName]},ValueTransformer.prototype.paramName=function(node){var paramName=null;if(node.valueKind()==yaml.Kind.SCALAR){var val=(""+node.value()).trim();util.stringStartsWith(val,"<<")&&util.stringEndsWith(val,">>")&&(paramName=val.substring(2,val.length-2))}return paramName},ValueTransformer}();exports.ValueTransformer=ValueTransformer;var DefaultTransformer=function(_super){function DefaultTransformer(owner,delegate,unitsChain){_super.call(this,null!=delegate?delegate.templateKind:"",null!=delegate?delegate.templateName:"",unitsChain),this.owner=owner,this.delegate=delegate}return __extends(DefaultTransformer,_super),DefaultTransformer.prototype.transform=function(obj,toString,doContinue,callback){if(null==obj||null!=doContinue&&!doContinue())return{value:obj,errors:[]};var ownResult={value:obj,errors:[]},gotDefaultParam=!1;defaultParameters.forEach(function(x){return gotDefaultParam=gotDefaultParam||obj.toString().indexOf("<<"+x)>=0}),gotDefaultParam&&(this.initParams(),ownResult=_super.prototype.transform.call(this,obj,toString,doContinue,callback));var result=null!=this.delegate?this.delegate.transform(ownResult.value,toString,doContinue,callback):ownResult.value;return null!=doContinue&&doContinue()&&null!=callback&&(result.value=callback(result.value,this)),result},DefaultTransformer.prototype.initParams=function(){for(var methodName,resourcePathName,resourcePath="",ll=this.owner.highLevel().lowLevel(),node=ll,last=null;node;){var key=node.key();if(null!=key)if(util.stringStartsWith(key,"/")){if(!resourcePathName)for(var arr=key.split("/"),i=arr.length-1;i>=0;i--){var seg=arr[i];if(-1==seg.indexOf("{")){resourcePathName=arr[i];break}seg.length>0&&(last=seg)}resourcePath=key+resourcePath}else methodName=key;node=node.parent()}resourcePathName||last&&(resourcePathName=""),this.params={resourcePath:resourcePath,resourcePathName:resourcePathName},methodName&&(this.params.methodName=methodName)},DefaultTransformer.prototype.children=function(node){return null!=this.delegate?this.delegate.children(node):null},DefaultTransformer.prototype.valueKind=function(node){return null!=this.delegate?this.delegate.valueKind(node):null},DefaultTransformer}(ValueTransformer);exports.DefaultTransformer=DefaultTransformer;var defaultParameters=["resourcePath","resourcePathName","methodName"]},function(module,exports,__webpack_require__){(function(process){"use strict";function evalInSandbox(code,thisArg,args){return new loophole.Function(code).call(thisArg,args)}function checkPropertyQuard(n,v){var pr=n.property();return pr&&pr.getContextRequirements().forEach(function(x){n.checkContextValue(x.name,x.value,x.value)||v.accept(createIssue(hl.IssueCode.MISSED_CONTEXT_REQUIREMENT,x.name+" should be "+x.value+" to use property '"+pr.nameId()+"'",n))}),pr}function lintNode(astNode,acceptor){var fsEnabled;try{fsEnabled=astNode.lowLevel().unit().project().fsEnabled()}catch(exception){fsEnabled=!0}if(fsEnabled&&"undefined"!=typeof fs&&fs){for(var fsMethods=["exists","readFile","writeFile","readdir","existsSync","readFileSync","writeFileSync","readdirSync"],i=(Object.keys(fs),0);i<fsMethods.length;i++)if(!fs[fsMethods[i]])return;var ps=astNode.lowLevel().unit().absolutePath(),dr=path.dirname(ps),customLinter=path.resolve(dr,"raml-lint.js");lintWithFile(customLinter,acceptor,astNode);var dir=path.resolve(dr,".raml");if(fs.existsSync(dir)){var st=fs.statSync(dir);if(st.isDirectory()){var files=fs.readdirSync(dir);files.forEach(function(x){-1!=x.indexOf("-lint.js")&&lintWithFile(path.resolve(dir,x),acceptor,astNode)})}}}}function isTypeOrSchema(d){return d.nameId()==universes.Universe10.TypeDeclaration.properties.type.name||d.nameId()==universes.Universe10.TypeDeclaration.properties.schema.name}function isDefaultValueProp(d){return checkIfDomainIsUserDefined(d)?d.nameId()==universes.Universe10.TypeDeclaration.properties["default"].name:!1}function isExampleProp(d){return checkIfDomainIsUserDefined(d)?d.nameId()==universes.Universe10.TypeDeclaration.properties.example.name:!1}function checkIfDomainIsUserDefined(d){return d.domain()?d.domain().getAdapter(services.RAMLService).isUserDefined()?!1:!0:!1}function isSecuredBy(d){return checkIfDomainIsUserDefined(d)?d.nameId()==universes.Universe08.MethodBase.properties.securedBy.name:!1}function typeOfContainingTemplate(h){for(var declRoot=h;;){if(declRoot.definition().getAdapter(services.RAMLService).isInlinedTemplates())return declRoot.definition().nameId();var np=declRoot.parent();if(!np)break;declRoot=np}return null}function restrictUnknownNodeError(node){var parentNode=node.parent(),issue=null,parentDef=parentNode.definition();if(parentNode&&parentDef instanceof def.UserDefinedClass){var parentProperty=parentNode.property();if(universeHelpers.isIsProperty(parentProperty)||universeHelpers.isTypeProperty(parentProperty)){var paramName=node.name();issue=null!=exports.RESERVED_TEMPLATE_PARAMETERS[paramName]?createIssue(hl.IssueCode.INVALID_PROPERTY,"Invalid parameter name: '"+paramName+"' is reserved",node):createIssue(hl.IssueCode.UNKNOWN_NODE,"Unused parameter: '"+paramName+"'",node)}}if(!issue){var propName=node.name(),universe08=universeProvider("RAML08"),isRAML08=parentDef.universe().version()==universe08.version();if(isRAML08){var parameterTypeName=universes.Universe08.Parameter.name;universes.Universe10.TypeDeclaration.name;if(isRAML08&&parentDef.isAssignableFrom(parameterTypeName)){for(var possibleDefs=universe08.type(parameterTypeName).allSubTypes().filter(function(x){return null!=universes.Universe08[x.nameId()].properties[propName]}),possibleDefsMap={},i=0;i<possibleDefs.length;i++){var x=possibleDefs[i];if(!possibleDefsMap[x.nameId()]){var valueRequirements=x.valueRequirements();if(valueRequirements&&0!=valueRequirements.length){var typeRquirements=valueRequirements.filter(function(x){return"type"==x.name}).map(function(x){return x.value});if(0!=typeRquirements.length){var runtimeName=typeRquirements[0];possibleDefsMap[x.nameId()]=runtimeName,x.allSubTypes().forEach(function(y){return possibleDefs.push(y)})}}}}var runtimeNames=Object.keys(possibleDefsMap).map(function(x){return possibleDefsMap[x]}).sort();if(runtimeNames.length>0){var namesStr=runtimeNames.map(function(x,i){var x1="'"+x+"'";return i==runtimeNames.length-1?x1:i==runtimeNames.length-2?x1+" or ":x1+", "}).join(""),message="Property '"+propName+"' can only be used if type is "+namesStr;issue=createIssue(hl.IssueCode.ILLEGAL_PROPERTY,message,node)}}}}return issue}function validateTopLevelNodeSkippingChildren(node,v){if(node.isElement()){if(node.invalidSequence){var pName=node.property().nameId(),msg=changeCase.sentenceCase(pluralize.singular(pName));msg="In RAML 1.0 "+msg+" is not allowed to have sequence as definition",v.acceptUnique(createLLIssue(hl.IssueCode.UNKNOWN_NODE,msg,node.lowLevel().parent().parent(),node,!1))}var highLevelNode=node.asElement();if(highLevelNode.definition().isAssignableFrom(universes.Universe10.LibraryBase.name)){var vv,hasSchemas=!1,hasTypes=!1;highLevelNode.lowLevel().children().forEach(function(x){"schemas"==x.key()&&(hasSchemas=!0,vv=x),"types"==x.key()&&(hasTypes=!0)}),hasSchemas&&hasTypes&&v.accept(localLowLevelError(vv,highLevelNode,hl.IssueCode.ILLEGAL_PROPERTY_VALUE,!1,"types and schemas are mutually exclusive",!1))}highLevelNode.definition().requiredProperties()&&highLevelNode.definition().requiredProperties().length>0;validateBasicFlat(node,v),(new CompositeNodeValidator).validate(highLevelNode,v),(new TemplateCyclesDetector).validate(highLevelNode,v)}else validateBasicFlat(node,v);(new OptionalPropertiesValidator).validate(node,v)}function validateBasicFlat(node,v,requiredOnly){void 0===requiredOnly&&(requiredOnly=!1);var parentNode=node.parent(),llValue=node.lowLevel().value();if(node.lowLevel()){if(node.lowLevel().keyKind()==yaml.Kind.MAP&&v.accept(createIssue(hl.IssueCode.UNKNOWN_NODE,"Node key can not be a map",node)),node.lowLevel().keyKind()==yaml.Kind.SEQ&&null==llValue){var isPattern=!1;node.isElement()&&node.asElement().definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name)&&(isPattern=!0),isPattern||v.accept(createIssue(hl.IssueCode.UNKNOWN_NODE,"Node key can not be a sequence",node))}null==parentNode&&node.lowLevel().errors().forEach(function(x){var ps=x.mark?x.mark.position:0,em={code:hl.IssueCode.YAML_ERROR,message:x.message,node:null,start:ps,end:ps+1,isWarning:!1,path:node.lowLevel().unit()==node.root().lowLevel().unit()?null:node.lowLevel().unit().path(),unit:node.lowLevel().unit()};v.accept(em)})}if(node.isUnknown()){if(-1!=node.name().indexOf("<<")&&null!=typeOfContainingTemplate(parentNode))return(new TraitVariablesValidator).validateName(node,v),!1;if(node.needSequence&&v.accept(createIssue(hl.IssueCode.UNKNOWN_NODE,"Node: '"+node.name()+"' should be wrapped in sequence",node)),node.needMap)return v.accept(createIssue(hl.IssueCode.UNKNOWN_NODE,(node.knownProperty?"'"+node.knownProperty.nameId()+"' ":"")+"should be a map in RAML 1.0",node)),!1;if(node.unresolvedRef&&v.accept(createIssue(hl.IssueCode.UNKNOWN_NODE,"Reference: '"+llValue+"' can not be resolved",node)),node.knownProperty){if(0==node.lowLevel().includeErrors().length){if(typeOfContainingTemplate(parentNode)&&util.startsWith(llValue,"<<")&&util.endsWith(llValue,">>"))return!1;if("body"==node.name()&&node.computedValue("mediaType"))return!1;"~"!=node.lowLevel().value()&&v.accept(createIssue(hl.IssueCode.UNKNOWN_NODE,"Property '"+node.name()+"' can not have scalar value",node))}}else{var issue=restrictUnknownNodeError(node);issue||(issue=createIssue(hl.IssueCode.UNKNOWN_NODE,"Unknown node: '"+node.name()+"'",node)),v.accept(issue)}}if(node.markCh()&&!node.allowRecursive())return node.property()?(v.accept(createIssue(hl.IssueCode.UNKNOWN_NODE,"Recursive definition: '"+node.name()+"'",node)),!1):!1;if(node.definition&&node.definition().isAssignableFrom(universes.Universe10.Operation.name)){var queryStringNode=node.element(universes.Universe10.Operation.properties.queryString.name),queryParamsNode=node.lowLevel&&_.find(node.lowLevel().children(),function(child){return child.key&&child.key()===universes.Universe10.Operation.properties.queryParameters.name});queryStringNode&&queryParamsNode&&(v.accept(createIssue(hl.IssueCode.UNKNOWN_NODE,"'"+universes.Universe10.Operation.properties.queryParameters.name+"' is already specified.",queryStringNode)),v.accept(createLLIssue(hl.IssueCode.UNKNOWN_NODE,"'"+universes.Universe10.Operation.properties.queryString.name+"' is already specified.",queryParamsNode,node)))}var isOverlay=node.definition&&node.definition()&&(node.definition().key()===universes.Universe10.Overlay||node.definition().key()===universes.Universe10.Extension);return isOverlay&&validateMasterFlat(node,v,requiredOnly),!0}function validateMasterFlat(node,acceptor,requiredOnly){if(void 0===requiredOnly&&(requiredOnly=!1),!node.parent()){var nodeAsElement=node.asElement();if(nodeAsElement&&nodeAsElement.isAuxilary()){var master=nodeAsElement.getMaster();master&&validateTopLevelNodeSkippingChildren(master,acceptor)}}}function validateBasic(node,v,requiredOnly){if(void 0===requiredOnly&&(requiredOnly=!1),validateBasicFlat(node,v,requiredOnly))try{var isOverlay=node.definition&&node.definition()&&(node.definition().key()===universes.Universe10.Overlay||node.definition().key()===universes.Universe10.Extension),children=isOverlay?node.children():node.directChildren();children.filter(function(child){return!requiredOnly||child.property&&child.property()&&child.property().isRequired()}).forEach(function(x){return x&&x.errorMessage?void v.accept(createIssue(hl.IssueCode.UNKNOWN_NODE,x.errorMessage,x.name()?x:node)):void x.validate(v)})}finally{node.unmarkCh()}}function hasTemplateArgs(node){var vl=node.value();if("string"==typeof vl&&-1!=vl.indexOf("<<"))return!0;for(var x=node.children(),i=0;i<x.length;i++)if(hasTemplateArgs(x[i]))return!0;return!1}function validate(node,v){if(!node.parent())try{validateIncludes(node,v)}finally{cleanupIncludesFlag(node,v)}if(node.isAttr())(new CompositePropertyValidator).validate(node,v);else if(node.isElement()){if(node.invalidSequence){var pName=node.property().nameId(),msg=changeCase.sentenceCase(pluralize.singular(pName));msg="In RAML 1.0 "+msg+" is not allowed to have sequence as definition",v.acceptUnique(createLLIssue(hl.IssueCode.UNKNOWN_NODE,msg,node.lowLevel().parent().parent(),node,!1))}var highLevelNode=node.asElement();if(universeHelpers.isExampleSpecType(highLevelNode.definition())){var hlChildren=highLevelNode.children();if(0==hlChildren.length)return void validateBasic(node,v,!0);var content=hlChildren.filter(function(x){var propName=x.lowLevel().key();return propName?"("==propName.charAt(0)&&")"==propName.charAt(propName.length-1)?!1:null==highLevelNode.definition().property(propName):!0});if(content.length>0)return void validateBasic(node,v,!0)}if(highLevelNode.definition().isAnnotationType()||highLevelNode.property()&&"annotations"==highLevelNode.property().nameId())return void(new FixedFacetsValidator).validate(highLevelNode,v);if(highLevelNode.definition().isAssignableFrom(universes.Universe10.UsesDeclaration.name)){var vn=highLevelNode.attr(universes.Universe10.UsesDeclaration.properties.value.name);if(vn&&vn.value()){var rs=highLevelNode.lowLevel().unit().resolve(vn.value());if(rs){if(!resourceRegistry.isWaitingFor(vn.value())){var issues=[];if(0===rs.contents().trim().length)return void v.accept(createIssue(hl.IssueCode.UNRESOLVED_REFERENCE,"Empty file: "+vn.value(),highLevelNode,!1));if(rs.highLevel().validate(hlimpl.createBasicValidationAcceptor(issues,rs.highLevel())),issues.length>0){var brand=createLibraryIssue(vn,highLevelNode);issues.forEach(function(x){x.unit=null==x.unit?rs:x.unit,x.path||(x.path=rs.absolutePath())});for(var _i=0,issues_1=issues;_i<issues_1.length;_i++){for(var issue=issues_1[_i],_issue=issue;_issue.extras.length>0;)_issue=_issue.extras[0];_issue.extras.push(brand),v.accept(issue)}}}}else v.accept(createIssue(hl.IssueCode.UNRESOLVED_REFERENCE,"Can not resolve library from path: '"+vn.value()+"'",highLevelNode,!1))}}if(highLevelNode.definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name)){if(typeOfContainingTemplate(highLevelNode)&&hasTemplateArgs(highLevelNode.lowLevel()))return;return highLevelNode.attrs().forEach(function(a){var range=a.property().range().key();if(range==universes.Universe08.RelativeUriString||range==universes.Universe10.RelativeUriString)return void(new UriValidator).validate(a,v);if(range==universes.Universe08.FullUriTemplateString||range==universes.Universe10.FullUriTemplateString)return void(new UriValidator).validate(a,v);if(a.property().getAdapter(services.RAMLPropertyService).isKey()){var nameId=node.property()&&node.property().nameId();if(nameId==universes.Universe08.Resource.properties.uriParameters.name||nameId==universes.Universe08.Resource.properties.baseUriParameters.name)return;if(highLevelNode.property()&&highLevelNode.property().nameId()==universes.Universe10.MethodBase.properties.body.name)return void(new MediaTypeValidator).validate(a,v)}}),(new RecurrentOverlayValidator).validate(highLevelNode,v),(new RecurrentValidateChildrenKeys).validate(highLevelNode,v),(new NodeSpecificValidator).validate(highLevelNode,v),void(new TypeDeclarationValidator).validate(highLevelNode,v)}if(highLevelNode.definition().isAssignableFrom(universes.Universe10.LibraryBase.name)){var vv,hasSchemas=!1,hasTypes=!1;highLevelNode.lowLevel().children().forEach(function(x){"schemas"==x.key()&&(hasSchemas=!0,vv=x),"types"==x.key()&&(hasTypes=!0)}),hasSchemas&&hasTypes&&v.accept(localLowLevelError(vv,highLevelNode,hl.IssueCode.ILLEGAL_PROPERTY_VALUE,!1,"types and schemas are mutually exclusive",!1))}var hasRequireds=highLevelNode.definition().requiredProperties()&&highLevelNode.definition().requiredProperties().length>0,isAllowAny=highLevelNode.definition().getAdapter(services.RAMLService).getAllowAny();isAllowAny?hasRequireds&&validateBasic(node,v,!0):validateBasic(node,v),(new UriParametersValidator).validate(highLevelNode,v),(new CompositeNodeValidator).validate(highLevelNode,v),(new TemplateCyclesDetector).validate(highLevelNode,v)}else validateBasic(node,v);(new OptionalPropertiesValidator).validate(node,v)}function cleanupIncludesFlag(node,v){if(node.lowLevel()){var val=node.lowLevel().actual();delete val._inc,node.children().forEach(function(x){return cleanupIncludesFlag(x,v)})}}function validateIncludes(node,v){var llNode=node.lowLevel();if(llNode){var val=llNode.actual();if(!val._inc){if(node.isElement()){var vl=node.name();"string"==typeof vl&&null!=vl&&-1!=vl.indexOf(" ")&&v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Keys should not have spaces '"+vl+"'",node,!0))}if(val._inc=!0,llNode){llNode.includeErrors().forEach(function(x){var isWarn=!1;node.lowLevel().hasInnerIncludeError()&&(isWarn=!0);var em=createIssue(hl.IssueCode.UNABLE_TO_RESOLVE_INCLUDE_FILE,x,node,isWarn);v.accept(em)});var includePath=llNode.includePath();if(null!=includePath&&!path.isAbsolute(includePath)&&!ll.isWebPath(includePath)){var unitPath=llNode.unit().absolutePath(),exceeding=calculateExceeding(path.dirname(unitPath),includePath);if(exceeding>0){var em=createIssue(hl.IssueCode.UNABLE_TO_RESOLVE_INCLUDE_FILE,"Resolved include path exceeds file system root",node,!0);v.accept(em)}}}node.children().forEach(function(x){return validateIncludes(x,v)}),0==node.children().length&&null!=llNode&&llNode.children().forEach(function(x){return validateIncludesLL(x,v,node)})}}}function validateIncludesLL(llNode,v,node){llNode.includeErrors().forEach(function(x){var isWarn=!1;llNode.hasInnerIncludeError()&&(isWarn=!0);var em=createLLIssue(hl.IssueCode.UNABLE_TO_RESOLVE_INCLUDE_FILE,x,llNode,node,isWarn);v.accept(em)});var includePath=llNode.includePath();if(null!=includePath&&!path.isAbsolute(includePath)&&!ll.isWebPath(includePath)){var unitPath=llNode.unit().absolutePath(),exceeding=calculateExceeding(path.dirname(unitPath),includePath);if(exceeding>0){var em=createLLIssue(hl.IssueCode.UNABLE_TO_RESOLVE_INCLUDE_FILE,"Resolved include path exceeds file system root",llNode,node,!0);v.accept(em)}}llNode.children().forEach(function(x){return validateIncludesLL(x,v,node)})}function calculateExceeding(rootPath,relativePath){for(var rootSegments=actualSegments(rootPath),relativeSegments=actualSegments(relativePath),count=rootSegments.length,result=0,_i=0,relativeSegments_1=relativeSegments;_i<relativeSegments_1.length;_i++){var segment=relativeSegments_1[_i];".."==segment?(count--,0>count&&(result=Math.min(count,result))):count++}return-1*result}function isValid(t,h,value,p,attr){return t.hasArrayInHierarchy()?isValidArray(t,h,value,p,attr):t.hasValueTypeInHierarchy()?isValidValueType(t,h,value,p,attr):!0}function isValidArray(t,h,v,p,attr){return t.arrayInHierarchy().componentType()?isValid(t.arrayInHierarchy().componentType(),h,v,p):!0}function isValidValueType(t,h,v,p,attr){try{if(t.key()==universes.Universe10.AnnotationRef){var targets=search.referenceTargets(p,h),actualAnnotation=_.find(targets,function(x){return hlimpl.qName(x,h)==v});if(null!=actualAnnotation){var attrs=actualAnnotation.attributes("allowedTargets");
if(attrs){var aVals=attrs.map(function(x){return x.value()});if(aVals.length>0){var found=!1,tps=h.definition().allSuperTypes();tps=tps.concat([h.definition()]);var tpNames=tps.map(function(x){return x.nameId()});if(aVals.forEach(function(x){"API"==x&&(x="Api"),"NamedExample"==x&&(x="ExampleSpec"),"SecurityScheme"==x&&(x="AbstractSecurityScheme"),"SecuritySchemeSettings"==x&&(x="SecuritySchemeSettings"),_.find(tpNames,function(y){return y==x})?found=!0:("Parameter"==x&&h.computedValue("location")&&(found=!0),"Field"==x&&h.computedValue("field")&&(found=!0))}),!found){var list=aVals.map(function(x){return"'"+x+"'"}).join(", ");return new Error("Annotation '"+v+"' can not be placed at this location, allowed targets are: "+list)}}}}return tm}if(t.key()==universes.Universe08.SchemaString||t.key()==universes.Universe10.SchemaString){var tm=su.createSchema(v,contentProvider(h.lowLevel()));return tm instanceof Error&&(tm.canBeRef=!0),tm}if(t.key()==universes.Universe08.StatusCodeString||t.key()==universes.Universe10.StatusCodeString){var err=validateResponseString(v);if(null!=err)return err}if(t.key()==universes.Universe08.BooleanType||t.isAssignableFrom(universes.Universe10.BooleanType.name)){if("true"!==v&&"false"!==v&&v!==!0&&v!==!1)return new Error("'true' or 'false' is expected here");if(attr){var stringValue=attr.lowLevel().value(!0);if("true"!==stringValue&&"false"!==stringValue)return new Error("'true' or 'false' is expected here")}}if(t.key()==universes.Universe08.NumberType||t.isAssignableFrom(universes.Universe10.NumberType.name)){var q=parseFloat(v);if(isNaN(q))return new Error("the value of "+p.nameId()+" must be a number")}if((t.key()==universes.Universe08.StringType||t.isAssignableFrom(universes.Universe10.StringType.name))&&null===v&&h&&p){var highLevelProperty=h.attr(p.nameId());if(highLevelProperty){var lowLevelChildren=highLevelProperty.lowLevel().children();if(lowLevelChildren&&lowLevelChildren.length>0)return new Error(p.nameId()+" must be a string")}}return!0}catch(e){return e.canBeRef=!0,e}}function getHumanReadableNodeName(astNode){if(!astNode)return null;if(astNode.isElement()){var element=astNode,definition=element.definition();if(definition&&exports.typeToName.hasOwnProperty(definition.nameId()))return exports.typeToName[definition.nameId()];if(definition.isAssignableFrom(universes.Universe10.TypeDeclaration.name)||definition.isAssignableFrom(universes.Universe08.Parameter.name)){if(element.property()&&exports.parameterPropertyToName.hasOwnProperty(element.property().nameId()))return exports.parameterPropertyToName[element.property().nameId()];if(element.property()&&element.parent()&&element.property().nameId()==universes.Universe10.LibraryBase.properties.types.name&&element.parent().definition()&&element.parent().definition().isAssignableFrom(universes.Universe10.LibraryBase.name))return"type";if(element.property()&&element.parent()&&element.property().nameId()==universes.Universe10.LibraryBase.properties.securitySchemes.name&&element.parent().definition()&&element.parent().definition().isAssignableFrom(universes.Universe10.LibraryBase.name))return"security scheme"}}return null}function isValidPropertyValue(pr,vl,c){var node=search.declRoot(c);node._cach||(node._cach={});var id=pr.id();if(pr.domain()&&(id+=pr.domain().nameId()),id){var cached=node._cach[id];if(cached)return null!=cached[vl]}var vls=search.enumValues(pr,c),mm={};return vls.forEach(function(x){return mm[x]=1}),pr.id()&&(node._cach[id]=mm),null!=mm[vl]}function checkReference(pr,astNode,vl,cb){if(checkTraitReference(pr,astNode,cb),checkResourceTypeReference(pr,astNode,cb),vl&&("null"!=vl||!pr.isAllowNull())){var adapter=pr.getAdapter(services.RAMLPropertyService),valid=isValidPropertyValue(pr,vl,astNode.parent());if(valid||astNode.lowLevel().unit().absolutePath()===astNode.parent().lowLevel().unit().absolutePath()||(valid=isValidPropertyValue(pr,vl,hlimpl.fromUnit(astNode.lowLevel().unit()))),!valid){if("string"==typeof vl&&0==vl.indexOf("x-")&&pr.nameId()==universes.Universe10.TypeDeclaration.properties.type.name)return!0;var expected=adapter.isReference&&adapter.isReference()&&adapter.referencesTo&&adapter.referencesTo()&&adapter.referencesTo().nameId&&adapter.referencesTo().nameId(),referencedToName=exports.typeToName[expected]||nameForNonReference(astNode),message=referencedToName?"Unrecognized "+referencedToName+": '"+vl+"'.":"Unresolved reference: '"+vl+"'.",spesializedMessage=specializeReferenceError(message,pr,astNode);return cb.accept(createIssue(hl.IssueCode.UNRESOLVED_REFERENCE,spesializedMessage,astNode,pr.range().key()===universes.Universe08.SchemaString)),!0}if(isDuplicateSibling(astNode)&&universeHelpers.isTraitRefType(astNode.definition())){var message="Duplicate trait reference: '"+vl+"'.",spesializedMessage=specializeReferenceError(message,pr,astNode);return cb.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,spesializedMessage,astNode)),!0}return!1}}function isDuplicateSibling(attr){var siblingName,ramlVersion=attr.property().domain().universe().version();if(siblingName="RAML10"==ramlVersion?stringify(json.serialize(attr.lowLevel())):attr.value()&&attr.value().valueName&&attr.value().valueName(),!siblingName)return!1;var parent=attr.parent&&attr.parent();if(!parent)return!1;var propertyName=attr.name&&attr.name();if(!propertyName)return!1;var siblings=parent.attributes&&parent.attributes(propertyName);if(!siblings)return!1;if(0===siblings.length)return!1;var count=0;return siblings.forEach(function(sibling){var name;"RAML10"==ramlVersion?siblingName=stringify(json.serialize(sibling.lowLevel())):name=sibling.value&&sibling.value()&&sibling.value().valueName&&sibling.value().valueName(),name===siblingName&&count++}),count>1}function checkTraitReference(property,astNode,acceptor){if(universeHelpers.isIsProperty(property)){var lowLevel=astNode.lowLevel();if(null!=lowLevel){var isMappingNode=null,lowLevelParent=lowLevel.parent(),lowLevelParentParent=null!=lowLevelParent?lowLevelParent.parent():null;if(lowLevel.kind()==yaml.Kind.MAPPING&&lowLevel.key()&&"is"==lowLevel.key()?isMappingNode=lowLevel:null!=lowLevelParent&&lowLevelParent.kind()==yaml.Kind.MAPPING&&lowLevelParent.key()&&"is"==lowLevelParent.key()?isMappingNode=lowLevelParent:null!=lowLevelParentParent&&lowLevelParentParent.kind()==yaml.Kind.MAPPING&&lowLevelParentParent.key()&&"is"==lowLevelParentParent.key()&&(isMappingNode=lowLevelParentParent),null!=isMappingNode){null==isMappingNode.value()||isMappingNode.children()&&0!=isMappingNode.children().length||acceptor.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,"Property 'is' must be an array",astNode));var illegalChildFound=!1;isMappingNode.children().forEach(function(child){child.kind()!=yaml.Kind.SCALAR&&child.kind()!=yaml.Kind.MAP&&(illegalChildFound=!0)}),illegalChildFound&&acceptor.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,"Property 'is' must be an array",astNode))}}}}function checkResourceTypeReference(property,astNode,acceptor){if(universeHelpers.isTypeProperty(property)&&universeHelpers.isResourceTypeRefType(astNode.definition())){var lowLevel=astNode.lowLevel();null==astNode.value()&&lowLevel&&lowLevel.children()&&0==lowLevel.children().length?lowLevel.kind()==yaml.Kind.MAPPING&&null!=lowLevel.valueKind()&&acceptor.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,"Resource type name must be provided",astNode)):null==astNode.value()&&lowLevel&&lowLevel.children()&&lowLevel.children().length>1&&acceptor.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,"A resource or resourceType can inherit from a single resourceType",astNode))}}function specializeReferenceError(originalMessage,property,astNode){return"type"==property.nameId()&&"RAML08"==property.domain().universe().version()&&property.domain().isAssignableFrom(universes.Universe08.Parameter.name)?"Type can be either of: string, number, integer, file, date or boolean":null!=astNode.parent()&&universeHelpers.isSecuritySchemaType(astNode.parent().definition())?originalMessage+" Allowed values are: 'OAuth 1.0', 'OAuth 2.0', 'Basic Authentication', 'DigestSecurityScheme Authentication', 'x-{other}'":originalMessage}function nameForNonReference(astNode){var propertyName=astNode&&astNode.lowLevel()&&astNode.lowLevel().key();if(propertyName===universes.Universe10.AbstractSecurityScheme.properties.type.name){var domain=astNode.parent()&&astNode.parent().definition()&&astNode.parent().definition().nameId();if(domain===universes.Universe10.AbstractSecurityScheme.name)return"security scheme type"}else if(propertyName===universes.Universe08.BodyLike.properties.schema.name){var domain=astNode.parent()&&astNode.parent().definition()&&astNode.parent().definition().nameId();if(domain===universes.Universe08.BodyLike.name)return"schema"}}function mapPath(node,e){var src=e.getValidationPath();return findElementAtPath(node,src)}function extractLowLevelNode(e){var pn=e.getExtra(rtypes.SOURCE_EXTRA);return pn instanceof hlimpl.LowLevelWrapperForTypeSystem?pn.node():null}function findElementAtPath(n,p){if(!p)return n;for(var chld=n.children(),_i=0,chld_1=chld;_i<chld_1.length;_i++){var ch=chld_1[_i];if(!(ch.isAttr()&&ch.asAttr().isFromKey()||ch.name()!==p.name))return findElementAtPath(ch,p.child)}if(!n.lowLevel())return n;for(var lchld=n.lowLevel().children(),i=0;i<lchld.length;i++)if(lchld[i].key()===p.name){var nn=new hlimpl.BasicASTNode(lchld[i],n);return findElementAtPath(nn,p.child)}if(!isNaN(p.name)&&lchld[p.name]){var node=lchld[p.name],nn=new hlimpl.BasicASTNode(node,n);return findElementAtPath(nn,p.child)}return n}function contentProvider(lowLevel){var root=lowLevel&&lowLevel.includeBaseUnit()&&(lowLevel.includePath&&lowLevel.includePath()?lowLevel.includeBaseUnit().resolve(lowLevel.includePath()):lowLevel.includeBaseUnit());return new contentprovider.ContentProvider(root)}function isJson(s){return-1!=s.indexOf("json")}function isXML(s){return-1!=s.indexOf("xml")}function getMediaType(node){var vl=getMediaType2(node);if("body"==vl){var rootMedia=node.root().attr("mediaType");return rootMedia?rootMedia.value():null}return vl}function getMediaType2(node){if(node.parent()){var pc=node.parent().definition();if(pc.key()==universes.Universe08.BodyLike)return node.parent().name();if(node.parent().parent()){var ppc=node.parent().parent().definition().key();if(ppc==universes.Universe08.Response||ppc==universes.Universe10.Response)return node.parent().property().nameId()==universes.Universe08.Response.properties.headers.name?null:node.parent().name();if(ppc==universes.Universe08.Method||ppc==universes.Universe10.Method)return node.parent().property().nameId()==universes.Universe10.MethodBase.properties.queryParameters.name||node.parent().property().nameId()==universes.Universe10.MethodBase.properties.headers.name?null:node.parent().name()}}return null}function toIssue(error,node){return createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,error.getMessage(),mapPath(node,error),error.isWarning())}function createIssue(issueCode,message,node,isWarning){void 0===isWarning&&(isWarning=!1);var original=null,pr=null;if(node.lowLevel()instanceof proxy.LowLevelProxyNode)for(var proxyNode=node.lowLevel();!proxyNode.primaryNode();)original||(original=localError(node,issueCode,isWarning,message,!0,pr)),node=node.parent(),proxyNode=node.lowLevel();if(node&&(pr=node.property(),node.lowLevel().unit()!=node.root().lowLevel().unit())){original=localError(node,issueCode,isWarning,message,!0,pr);for(node.lowLevel().unit();node.lowLevel().unit()!=node.root().lowLevel().unit();)pr=node.property(),node=node.parent()}original&&node.property()&&node.property().nameId()==universes.Universe10.FragmentDeclaration.properties.uses.name&&null!=node.parent()&&(pr=node.property(),node=node.parent());var error=localError(node,issueCode,isWarning,message,!1,pr);return original&&(original.extras.push(error),node.lowLevel().valueKind()==yaml.Kind.INCLUDE_REF&&(error.message="Error in the included file: "+error.message),error=original),error}function createLLIssue(issueCode,message,node,rootCalculationAnchor,isWarning,p){void 0===isWarning&&(isWarning=!1),void 0===p&&(p=!1);var original=null;if(node&&rootCalculationAnchor.lowLevel().unit()!=rootCalculationAnchor.root().lowLevel().unit()){original=localLowLevelError(node,rootCalculationAnchor,issueCode,isWarning,message,!0);var v=rootCalculationAnchor.lowLevel().unit();for(v&&(message=message+" "+v.path());rootCalculationAnchor.lowLevel().unit()!=rootCalculationAnchor.root().lowLevel().unit();)rootCalculationAnchor=rootCalculationAnchor.parent()}original&&rootCalculationAnchor.property()&&rootCalculationAnchor.property().nameId()==universes.Universe10.FragmentDeclaration.properties.uses.name&&null!=rootCalculationAnchor.parent()&&(rootCalculationAnchor=rootCalculationAnchor.parent());var error=localLowLevelError(node,rootCalculationAnchor,issueCode,isWarning,message,p);return original&&(original.extras.push(error),node.valueKind()==yaml.Kind.INCLUDE_REF&&(error.message="Error in the included file: "+error.message),error=original),error}function validateResponseString(v){if(3!=v.length)return new Error("Status code should be 3 digits number.");for(var i=0;i<v.length;i++){var c=v[i];if(!_.find(["0","1","2","3","4","5","6","7","8","9"],function(x){return x==c}))return new Error("Status code should be 3 digits number.")}return null}var jsyaml=__webpack_require__(28),json=__webpack_require__(51),stringify=__webpack_require__(61),proxy=__webpack_require__(39),hl=__webpack_require__(10),ll=__webpack_require__(11),_=__webpack_require__(65),yaml=__webpack_require__(74),def=__webpack_require__(36),hlimpl=__webpack_require__(16),path=__webpack_require__(15),fs=__webpack_require__(38),universes=__webpack_require__(18),universeHelpers=__webpack_require__(14),universeProvider=__webpack_require__(35),services=def,OverloadingValidator=__webpack_require__(52),expander=__webpack_require__(25),search=__webpack_require__(24),rtypes=def.rt,util=__webpack_require__(42),contentprovider=__webpack_require__(31),resourceRegistry=__webpack_require__(29),su=def.getSchemaUtils(),mediaTypeParser=__webpack_require__(62),xmlutil=__webpack_require__(53),changeCase=__webpack_require__(71),pluralize=__webpack_require__(70),LinterSettings=function(){function LinterSettings(){this.validateNotStrictExamples=!0}return LinterSettings}(),settings=new LinterSettings,loophole=__webpack_require__(79);exports.RESERVED_TEMPLATE_PARAMETERS={resourcePathName:'Part of the resource path following the rightmost "/"',methodName:"Method name",resourcePath:"Path of the resource"};var lintWithFile=function(customLinter,acceptor,astNode){if(fs.existsSync(customLinter))try{var content=fs.readFileSync(customLinter).toString(),factr=new LinterExtensionsImpl(acceptor);evalInSandbox(content,factr,null),factr.visit(astNode)}catch(e){console.log("Error in custom linter"),console.log(e)}},LinterExtensionsImpl=function(){function LinterExtensionsImpl(acceptor){this.acceptor=acceptor,this.nodes={}}return LinterExtensionsImpl.prototype.error=function(w,message){this.acceptor.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,message,w.highLevel()))},LinterExtensionsImpl.prototype.errorOnProperty=function(w,property,message){var pr=w.highLevel().attr(property);this.acceptor.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,message,pr))},LinterExtensionsImpl.prototype.warningOnProperty=function(w,property,message){var pr=w.highLevel().attr(property);this.acceptor.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,message,pr,!0))},LinterExtensionsImpl.prototype.warning=function(w,message){this.acceptor.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,message,w.highLevel(),!0))},LinterExtensionsImpl.prototype.registerRule=function(nodeType,rule){var q=this.nodes[nodeType];q||(q=[],this.nodes[nodeType]=q),q.push(rule)},LinterExtensionsImpl.prototype.visit=function(h){var _this=this,nd=h.definition();this.process(nd,h),nd.allSuperTypes().forEach(function(x){return _this.process(x,h)}),h.elements().forEach(function(y){return _this.visit(y)})},LinterExtensionsImpl.prototype.process=function(d,h){var _this=this;if(d instanceof def.NodeClass&&!d.getAdapter(services.RAMLService).getDeclaringNode()){var rules=this.nodes[d.nameId()];rules&&rules.forEach(function(x){return x(h.wrapperNode(),_this)})}},LinterExtensionsImpl}();(function(){function StackNode(){}return StackNode.prototype.toString=function(){return this.prev?this.value+"."+this.prev.toString():this.value},StackNode.prototype.last=function(){return this.prev?this.prev.last():this},StackNode})();exports.validateBasicFlat=validateBasicFlat,exports.validateBasic=validateBasic;var createLibraryIssue=function(attr,hlNode){var start=hlNode.lowLevel().start(),usesNodes=[];if(0>start){for(var seq=hlNode.attr("key").value().split("."),nodes=[],parent=hlNode.parent(),_i=0,seq_1=seq;_i<seq_1.length;_i++){var segment=seq_1[_i],n=_.find(parent.elementsOfKind("uses"),function(x){return x.attr("key")&&x.attr("key").value()==segment});nodes.push(n),parent=n.lowLevel().unit().resolve(n.attr("value").value()).highLevel().asElement()}var issues=nodes.map(function(x){return createIssue(hl.IssueCode.UNRESOLVED_REFERENCE,"Issues in the used library: '"+x.attr("value").value()+"'",x,!0)});issues=issues.reverse();for(var i=0;i<issues.length-1;i++)issues[i].extras.push(issues[i+1]);return issues[0]}return usesNodes.push(hlNode),createIssue(hl.IssueCode.UNRESOLVED_REFERENCE,"Issues in the used library: '"+attr.value()+"'",hlNode,!0)};exports.validate=validate;var actualSegments=function(rootPath){rootPath=rootPath.replace(/\\/g,"/").trim(),rootPath.length>1&&":"==rootPath.charAt(1)&&/^win/.test(process.platform)&&(rootPath=rootPath.substring(2));var segments=rootPath.split("/");return 0==segments[0].length&&(segments=segments.slice(1)),segments.length>0&&0==segments[segments.length-1].length&&(segments=segments.slice(0,segments.length-1)),segments},validateRegexp=function(cleanedValue,v,node){try{new RegExp(cleanedValue)}catch(Error){v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Illegal pattern: '"+cleanedValue,node))}},TraitVariablesValidator=function(){function TraitVariablesValidator(){}return TraitVariablesValidator.prototype.validateName=function(node,acceptor){var name=node.name();if(name){var start=node.lowLevel().keyStart();this.check(name,start,node,acceptor)}},TraitVariablesValidator.prototype.validateValue=function(node,acceptor){var value=node.value();if("string"==typeof value){var start=node.lowLevel().valueStart();this.check(value,start,node,acceptor)}},TraitVariablesValidator.prototype.hasTraitOrResourceTypeParent=function(node){for(var parent=node.parent();null!=parent;){if(!parent.definition())return!1;if(universeHelpers.isTraitType(parent.definition())||universeHelpers.isResourceTypeType(parent.definition()))return!0;parent=parent.parent()}return!1},TraitVariablesValidator.prototype.check=function(str,start,node,acceptor){if(!this.hasTraitOrResourceTypeParent(node))return[];for(var errors=[],prev=0,i=str.indexOf("<<");i>=0;i=str.indexOf("<<",prev)){i+="<<".length,prev=str.indexOf(">>",i);var paramOccurence=str.substring(i,prev),ind=paramOccurence.indexOf("|"),paramName=ind>=0?paramOccurence.substring(0,ind):paramOccurence;if(0==paramName.trim().length){var msg="Trait or resource type parameter name must contain non whitespace characters",issue=createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,msg,node,!1);issue.start=start+i,issue.end=start+prev,acceptor.accept(issue)}if(-1!=ind){ind++;for(var transformerNames=paramOccurence.split("|").slice(1).map(function(x){return x.trim()}),functionNames=expander.getTransformNames(),_i=0,transformerNames_1=transformerNames;_i<transformerNames_1.length;_i++){var transformerName=transformerNames_1[_i];if(!_.find(functionNames,function(functionName){return transformerName===functionName||transformerName==="!"+functionName})){var msg="Unknown function applied to parameter: '"+transformerName+"'",issue=createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,msg,node,!1);issue.start=start+ind,issue.end=start+prev,acceptor.accept(issue)}}}prev+=">>".length}return errors},TraitVariablesValidator}(),MethodBodyValidator=function(){function MethodBodyValidator(){}return MethodBodyValidator.prototype.validate=function(node,validationAcceptor){var methodNode=node.parent();if(methodNode&&(methodNode.definition().isAssignableFrom(universes.Universe08.Method.name)||methodNode.definition().isAssignableFrom(universes.Universe10.Method.name))){var hasBody=_.find(methodNode.lowLevel()&&methodNode.lowLevel().children()||[],function(child){var keyValue=child.key();return keyValue&&(universes.Universe08.MethodBase.properties.body.name===keyValue||universes.Universe10.MethodBase.properties.body.name===keyValue)});hasBody&&_.find(MethodBodyValidator.methodsWithoutRequestBody,function(methodDisabled){return methodNode.name()===methodDisabled})&&validationAcceptor.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Request body is disabled for '"+methodNode.name()+"' method.",methodNode))}},MethodBodyValidator.methodsWithoutRequestBody=["trace"],MethodBodyValidator}(),CompositePropertyValidator=function(){function CompositePropertyValidator(){}return CompositePropertyValidator.prototype.validate=function(node,v){var pr=checkPropertyQuard(node,v),vl=node.value();if(!node.property().range().hasStructure()){if(vl instanceof hlimpl.StructuredValue&&!node.property().isSelfNode()){if(isTypeOrSchema(node.property())&&node.property().domain().key()==universes.Universe08.BodyLike){var newNode=new hlimpl.ASTNodeImpl(node.lowLevel(),node.parent(),node.parent().definition().universe().type(universes.Universe08.BodyLike.name),node.property());return void newNode.validate(v)}if("RAML10"==node.parent().definition().universe().version()&&null!=typeOfContainingTemplate(node.parent()))return;v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Scalar is expected here",node))}else{var vk=node.lowLevel().valueKind();if(node.lowLevel().valueKind()!=yaml.Kind.INCLUDE_REF&&!node.property().getAdapter(services.RAMLPropertyService).isKey()&&!node.property().isMultiValue()){var k=node.property().range().key();(k==universes.Universe08.StringType||k==universes.Universe08.MarkdownString||k==universes.Universe08.MimeType)&&(vk!=yaml.Kind.SEQ&&vk!=yaml.Kind.MAPPING&&vk!=yaml.Kind.MAP&&(!node.property().isRequired()&&"mediaType"!=node.property().nameId()||null!=vk&&void 0!==vk)||node.property().domain().getAdapter(services.RAMLService).isInlinedTemplates()||v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Property '"+node.name()+"' must be a string",node)))}}if(node.isAnnotatedScalar()){var fvl=new FixedFacetsValidator;node.annotations().forEach(function(x){var vl=x.value(),highLevel=vl.toHighLevel();highLevel?fvl.validate(highLevel,v):v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Unknown annotation: '"+vl.valueName()+"'",x))})}}var refName;if("string"==typeof vl?refName=vl:vl instanceof hlimpl.StructuredValue&&(refName=vl.valueName()),!(refName&&-1!=refName.indexOf("<<")&&refName.indexOf(">>")>refName.indexOf("<<")&&((new TraitVariablesValidator).validateValue(node,v),null!=typeOfContainingTemplate(node.parent())))){if((new MethodBodyValidator).validate(node,v),node.property().range().key()==universes.Universe08.MimeType||node.property().range().key()==universes.Universe10.MimeType||node.property().nameId()==universes.Universe10.TypeDeclaration.properties.name.name&&node.parent().property().nameId()==universes.Universe10.MethodBase.properties.body.name)return void(new MediaTypeValidator).validate(node,v);if(isExampleProp(node.property())||isDefaultValueProp(node.property())){if("RAML08"==node.definition().universe().version()){node.lowLevel().value();if(node.lowLevel().children().length>0){var valName=isExampleProp(node.property())?"'example'":"'defaultValue'";v.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,valName+" value should be a string",node,!1))}}(new ExampleAndDefaultValueValidator).validate(node,v)}if(isSecuredBy(node.property())){if("RAML08"==node.definition().universe().version()){var np=node.lowLevel().parent(),ysc=yaml.Kind.SEQ,msg="'securedBy' should be a list in RAML08";node.lowLevel()instanceof proxy.LowLevelProxyNode?np.valueKind()!=ysc&&v.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,msg,node,!1)):np.kind()!=ysc&&v.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,msg,node,!1))}(new ExampleAndDefaultValueValidator).validate(node,v)}if(node.property().nameId()==universes.Universe10.TypeDeclaration.properties.name.name){var nameId=node.parent().property()&&node.parent().property().nameId();if(nameId==universes.Universe08.Resource.properties.uriParameters.name||nameId==universes.Universe08.Resource.properties.baseUriParameters.name)return}var range=node.property().range().key();if(range==universes.Universe08.RelativeUriString||range==universes.Universe10.RelativeUriString)return void(new UriValidator).validate(node,v);if(range==universes.Universe08.FullUriTemplateString||range==universes.Universe10.FullUriTemplateString)return void(new UriValidator).validate(node,v);if("pattern"==node.name()&&universes.Universe10.StringType==node.definition().key()&&node.parent().definition().isAssignableFrom("StringTypeDeclaration")&&validateRegexp(node.value(),v,node),"name"==node.name()&&universes.Universe10.StringType==node.definition().key()&&"string"==typeof node.value()&&0==node.value().indexOf("[")&&node.value().lastIndexOf("]")==node.value().length-1&&node.parent()instanceof hlimpl.ASTNodeImpl&&universes.Universe10.ObjectTypeDeclaration.properties.properties.name==node.parent().property().nameId()&&node.parent().parent()instanceof hlimpl.ASTNodeImpl&&universes.Universe10.ObjectTypeDeclaration==node.parent().parent().definition().key()){var cleanedValue=node.value().substr(1,node.value().length-2);validateRegexp(cleanedValue,v,node)}pr.isReference()||pr.isDescriminator()?(new DescriminatorOrReferenceValidator).validate(node,v):(new NormalValidator).validate(node,v)}},CompositePropertyValidator}();exports.isValid=isValid;var NormalValidator=function(){function NormalValidator(){}return NormalValidator.prototype.validate=function(node,cb){var vl=node.value(),pr=node.property(),range=pr.range(),dnode=range.getAdapter(services.RAMLService).getDeclaringNode();if(dnode&&range.isUserDefined()){var rof=dnode.parsedType(),dp=node.parent().lowLevel().dumpToObject(),tempVal=dp[node.parent().name()],isVal=pr.canBeValue(),val=isVal||null===tempVal||void 0===tempVal?tempVal:tempVal[pr.nameId()],validateObject=rof.validate(val,!0);validateObject.isOk()||validateObject.getErrors().forEach(function(e){return cb.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,e.getMessage(),node,!1))})}var v=cb;if(node.lowLevel().keyKind()!=yaml.Kind.SEQ)var validation=isValid(pr.range(),node.parent(),vl,pr,node);else validation=!0;if(validation instanceof Error&&!validation.canBeRef)return v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,validation.message,node)),void(validation=null);if(!validation||validation instanceof Error)if("value"!=pr.nameId()){if(!checkReference(pr,node,vl,v)){if((pr.nameId()==universes.Universe10.TypeDeclaration.properties.schema.name||universes.Universe10.TypeDeclaration.properties.type.name)&&vl&&vl.trim()&&(pr.domain().key()==universes.Universe08.BodyLike||pr.domain().key()==universes.Universe10.TypeDeclaration)){var testSchema=vl.trim().charAt(0);if("{"!=testSchema&&"<"!=testSchema)return}var decl=node.findReferencedValue();if(decl instanceof Error&&v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,decl.message,node)),!decl){if(vl&&pr.nameId()==universes.Universe10.TypeDeclaration.properties.schema.name){var z=vl.trim();if("{"!=z.charAt(0)&&"<"!=z.charAt(0)&&(-1!=vl.indexOf("|")||-1!=vl.indexOf("[]")||-1!=vl.indexOf("(")))return}if(validation instanceof Error&&vl)return v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,validation.message,node)),void(validation=null);if(node.property().isRequired()&&null==node.value())v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Empty value is not allowed here",node));else{var ck=node.lowLevel().valueKind();(ck==yaml.Kind.MAP||ck==yaml.Kind.SEQ||ck==yaml.Kind.MAPPING)&&v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Empty value is not allowed here",node))}}}}else{var vl=node.value(),message="Invalid value schema: '"+vl;validation instanceof Error&&(message=validation.message),v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,message,node,pr.range().key()==universes.Universe08.SchemaString))}var values=pr.enumOptions();if(values){if("string"!=typeof vl)return;"string"==typeof values?values!=vl&&(vl&&0==vl.indexOf("x-")&&pr.nameId()==universes.Universe08.AbstractSecurityScheme.properties.type.name||v.accept(createIssue(hl.IssueCode.UNRESOLVED_REFERENCE,"Invalid value: '"+vl+"' allowed value is: '"+values+"'",node))):values.length>0&&(_.find(values,function(x){return x==vl})||vl&&0==vl.indexOf("x-")&&pr.nameId()==universes.Universe08.AbstractSecurityScheme.properties.type.name||v.accept(createIssue(hl.IssueCode.UNRESOLVED_REFERENCE,"Invalid value: '"+vl+"' allowed values are: "+values.map(function(x){return"'"+x+"'"}).join(", "),node)))}},NormalValidator}(),UriValidator=function(){function UriValidator(){}return UriValidator.prototype.validate=function(node,cb){try{var values=(new UrlParameterNameValidator).parseUrl(node.value());if(values.some(function(x){return"version"==x})&&"baseUri"==node.property().nameId()){var version=node.root().attr("version");version||cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Missing 'version'",node,!1))}values.some(function(x){return 0==x.length})&&cb.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,"URI parameter must have name specified",node,!1))}catch(e){cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,e.message,node,!1))}},UriValidator}(),MediaTypeValidator=function(){function MediaTypeValidator(){}return MediaTypeValidator.prototype.validate=function(node,cb){try{var v=node.value();if(!v)return;if("*/*"==v)return;if(v.indexOf("/*")==v.length-2&&(v=v.substring(0,v.length-2)+"/xxx"),node.parent()&&node.parent().parent()&&node.parent().parent().definition().isAssignableFrom(universes.Universe10.Trait.name)&&v.indexOf("<<")>=0)return;if("body"==v&&node.parent().parent()){var ppc=node.parent().parent().definition().key();(ppc===universes.Universe08.Response||ppc===universes.Universe10.Response||node.parent().parent().definition().isAssignableFrom(universes.Universe10.MethodBase.name))&&(v=node.parent().computedValue("mediaType"))}var res=mediaTypeParser.parse(v);res.type.match(/[\w\d][\w\d!#\$&\-\^_+\.]*/)||cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Invalid media type '"+res.type+"'",node))}catch(e){cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,""+e.message,node))}(node.value()&&"multipart/form-data"==node.value()||"application/x-www-form-urlencoded"==node.value())&&node.parent()&&node.parent().parent()&&node.parent().parent().property()&&node.parent().parent().property().nameId()==universes.Universe10.MethodBase.properties.responses.name&&cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Form related media types can not be used in responses",node,!0))},MediaTypeValidator}(),UrlParameterNameValidator=function(){function UrlParameterNameValidator(){}return UrlParameterNameValidator.prototype.checkBaseUri=function(node,c,vl,v){var bu=c.root().attr("baseUri");if(bu){var tnv=bu.value();try{var pNames=this.parseUrl(tnv);_.find(pNames,function(x){return x==vl})||v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Unused url parameter",node))}catch(e){}}else v.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Unused url parameter",node))},UrlParameterNameValidator.prototype.parseUrl=function(value){for(var result=[],temp="",inPar=!1,count=0,a=0;a<value.length;a++){var c=value[a];"{"!=c?"}"!=c?inPar&&(temp+=c):(count--,
inPar=!1,result.push(temp),temp=""):(count++,inPar=!0)}if(count>0)throw new Error("Invalid resource name: unmatched '{'");if(0>count)throw new Error("Invalid resource name: unmatched '}'");return result},UrlParameterNameValidator.prototype.validate=function(node,cb){var vl=node.value();if(node.parent().property().nameId()==universes.Universe10.Api.properties.baseUri.name){var c=node.parent().parent();return void this.checkBaseUri(node,c,vl,cb)}var c=node.parent().parent(),tn=c.name();if(c.definition().key()===universes.Universe10.Api||c.definition().key()===universes.Universe08.Api)return void this.checkBaseUri(node,c,vl,cb);if(c.definition().key()!=universes.Universe10.ResourceType&&c.definition().key()!=universes.Universe08.ResourceType)try{var pNames=this.parseUrl(tn),foundInLocalParameters=_.find(pNames,function(x){return x==vl});if(!foundInLocalParameters){var baseUri=node.root().attr(universes.Universe10.Api.properties.baseUri.name);if(baseUri&&node.name()===universes.Universe08.Api.properties.baseUriParameters.name){var baseUriValue=baseUri.value();if(baseUriValue&&(pNames=this.parseUrl(baseUriValue),pNames&&pNames.length>0&&_.find(pNames,function(x){return x==vl})))return}cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Unused url parameter '"+vl+"'",node))}}catch(e){}},UrlParameterNameValidator}();exports.UrlParameterNameValidator=UrlParameterNameValidator,exports.typeToName={},exports.typeToName[universes.Universe08.Trait.name]="trait",exports.typeToName[universes.Universe08.ResourceType.name]="resource type",exports.typeToName[universes.Universe10.Trait.name]="trait",exports.typeToName[universes.Universe10.ResourceType.name]="resource type",exports.typeToName[universes.Universe10.AbstractSecurityScheme.name]="security scheme",exports.typeToName[universes.Universe10.Method.name]="method",exports.typeToName[universes.Universe08.Method.name]="method",exports.typeToName[universes.Universe10.Resource.name]="resource",exports.typeToName[universes.Universe08.Resource.name]="resource",exports.typeToName[universes.Universe10.Api.name]="api",exports.typeToName[universes.Universe08.Api.name]="api",exports.typeToName[universes.Universe10.Response.name]="response",exports.typeToName[universes.Universe08.Response.name]="response",exports.typeToName[universes.Universe08.BodyLike.name]="body",exports.parameterPropertyToName={},exports.parameterPropertyToName[universes.Universe08.MethodBase.properties.headers.name]="header",exports.parameterPropertyToName[universes.Universe08.MethodBase.properties.queryParameters.name]="query parameter",exports.parameterPropertyToName[universes.Universe08.Api.properties.uriParameters.name]="uri parameter",exports.parameterPropertyToName[universes.Universe08.Api.properties.baseUriParameters.name]="base uri parameter",exports.parameterPropertyToName[universes.Universe08.BodyLike.properties.formParameters.name]="form parameter",exports.parameterPropertyToName[universes.Universe10.MethodBase.properties.headers.name]="header",exports.parameterPropertyToName[universes.Universe10.MethodBase.properties.queryParameters.name]="query parameter",exports.parameterPropertyToName[universes.Universe10.ResourceBase.properties.uriParameters.name]="uri parameter",exports.parameterPropertyToName[universes.Universe10.Api.properties.baseUriParameters.name]="base uri parameter",exports.parameterPropertyToName[universes.Universe10.MethodBase.properties.body.name]="body",exports.getHumanReadableNodeName=getHumanReadableNodeName;var DescriminatorOrReferenceValidator=function(){function DescriminatorOrReferenceValidator(){}return DescriminatorOrReferenceValidator.prototype.validate=function(node,cb){var vl=node.value(),valueKey=vl,pr=node.property();if("string"==typeof vl){if(checkReference(pr,node,vl,cb),pr.range()instanceof def.ReferenceType){var mockNode=(pr.range(),jsyaml.createNode(""+vl,node.lowLevel().parent(),node.lowLevel().unit()));mockNode._actualNode().startPosition=node.lowLevel().valueStart(),mockNode._actualNode().endPosition=node.lowLevel().valueEnd();var stv=new hlimpl.StructuredValue(mockNode,node.parent(),node.property()),hn=stv.toHighLevel();hn&&hn.validate(cb)}}else if(null!=vl){var st=vl;if(st){valueKey=st.valueName();var vn=st.valueName();if(!checkReference(pr,node,vn,cb)){var hnode=st.toHighLevel();hnode&&hnode.validate(cb)}}else valueKey=null}else node.definition().isAssignableFrom(universes.Universe10.Reference.name)&&checkReference(pr,node,null,cb);if(valueKey){var validation=isValid(pr.range(),node.parent(),valueKey,pr);validation instanceof Error&&(cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,validation.message,node)),validation=null)}},DescriminatorOrReferenceValidator}(),RAMLVersionAndFragmentValidator=function(){function RAMLVersionAndFragmentValidator(){}return RAMLVersionAndFragmentValidator.prototype.validate=function(node,v){var u=node.universe(),tv=u.getTypedVersion();if(tv){if("0.8"!==tv&&"1.0"!==tv){var i=createIssue(hl.IssueCode.NODE_HAS_VALUE,"Unknown version of RAML expected to see one of '#%RAML 0.8' or '#%RAML 1.0'",node);v.accept(i)}var tl=u.getOriginalTopLevelText();if(tl)if(tl!=node.definition().nameId()){if("Api"==node.definition().nameId()){var i=createIssue(hl.IssueCode.NODE_HAS_VALUE,"Unknown top level type: '"+tl+"'",node);v.accept(i)}}else if("Api"==u.getOriginalTopLevelText()){var i=createIssue(hl.IssueCode.NODE_HAS_VALUE,"Redundant fragment name: '"+tl+"'",node);v.accept(i)}}},RAMLVersionAndFragmentValidator}(),RequiredPropertiesAndContextRequirementsValidator=function(){function RequiredPropertiesAndContextRequirementsValidator(){}return RequiredPropertiesAndContextRequirementsValidator.prototype.validate=function(node,v){var _this=this;node.definition().getAdapter(services.RAMLService).getContextRequirements().forEach(function(x){if(!node.checkContextValue(x.name,x.value,x.value)){var message=x.name+(" should be "+x.value+" to use type "+node.definition().nameId());"location"==x.name&&"ParameterLocation.FORM"==x.value&&(message="File type can be only used in web forms"),v.accept(createIssue(hl.IssueCode.MISSED_CONTEXT_REQUIREMENT,message,node))}});var t,isInlinedTemplate=node.definition().getAdapter(services.RAMLService).isInlinedTemplates();if(isInlinedTemplate){for(var paramsMap={},_i=0,_a=node.lowLevel().children();_i<_a.length;_i++){var ch=_a[_i];paramsMap[ch.key()]=ch.value(!0)}for(var templateKind=node.definition().isAssignableFrom(universes.Universe10.Trait.name)?"trait":"resource type",unitsChain=expander.toUnits(node),vt=new expander.ValueTransformer(templateKind,node.definition().nameId(),unitsChain,paramsMap),parent=node.parent(),def=parent?parent.definition():node.definition();null!=parent&&!universeHelpers.isResourceType(def)&&!universeHelpers.isMethodType(def);)parent=parent.parent();t=new expander.DefaultTransformer(parent,vt,unitsChain)}node.definition().requiredProperties().forEach(function(x){if(isInlinedTemplate){var paths=x.getAdapter(services.RAMLPropertyService).meta("templatePaths");if(paths){for(var parent=node.parent(),hasSufficientChild=!1,_i=0,paths_1=paths;_i<paths_1.length;_i++){var path=paths_1[_i];if(path=path.map(function(x){return t.transform(x).value}),_this.checkPathSufficiency(parent.lowLevel(),path,parent)){hasSufficientChild=!0;break}}if(!hasSufficientChild)return}}var r=x.range();if(r.hasArrayInHierarchy()&&(r=r.arrayInHierarchy().componentType()),r.hasValueTypeInHierarchy()){var nm=node.attr(x.nameId()),gotValue=!1;if(null!=nm&&(nm.lowLevel().kind()==yaml.Kind.SCALAR||nm.lowLevel().valueKind()==yaml.Kind.SCALAR||nm.lowLevel().kind()==yaml.Kind.INCLUDE_REF||nm.lowLevel().valueKind()==yaml.Kind.INCLUDE_REF||null===nm.lowLevel().valueKind()&&!isInlinedTemplate?gotValue=!0:0!=nm.lowLevel().children().length&&(gotValue=!0)),!gotValue){var msg="Missing required property '"+x.nameId()+"'";isInlinedTemplate&&(msg="Value is not provided for parameter: '"+x.nameId()+"'");var i=createIssue(hl.IssueCode.MISSING_REQUIRED_PROPERTY,msg,node);v.accept(i)}}else{var el=node.elementsOfKind(x.nameId());if(!el||0==el.length){var i=createIssue(hl.IssueCode.MISSING_REQUIRED_PROPERTY,"Missing required property '"+x.nameId()+"'",node);v.accept(i)}}})},RequiredPropertiesAndContextRequirementsValidator.prototype.checkPathSufficiency=function(node,path,hlParent){if(null==hlParent||null==hlParent.definition())return!1;var definition=hlParent.definition();if(universeHelpers.isResourceTypeType(definition)||universeHelpers.isTraitType(definition))return!0;if(0==path.length)return!1;if(null==node)return!1;var segment=path[0];if(null==segment)return!1;if("/"==segment)return this.checkPathSufficiency(node,path.slice(1),hlParent);if(0==segment.length)return!0;var children=node.children().filter(function(x){return x.key()==segment});0==children.length&&path.indexOf("/")<0;var lowLevel=children[0];if(lowLevel instanceof proxy.LowLevelCompositeNode&&(lowLevel=lowLevel.primaryNode()),null==lowLevel)return path.indexOf("/")<0;if("type"==lowLevel.key())return!0;if(1==path.length)return null==lowLevel||null==lowLevel.value();var path1=path.slice(1);return this.checkPathSufficiency(lowLevel,path1,hlParent)},RequiredPropertiesAndContextRequirementsValidator}(),ScalarQuoteValidator=function(){function ScalarQuoteValidator(){}return ScalarQuoteValidator.prototype.validate=function(node,v){var r=node.lowLevel().unit();node.lowLevel().visit(function(x){if(x.unit()!=r)return!1;if(x.value()&&x._node&&x._node.value&&x._node.value.doubleQuoted){var ind=(x.value()+"").indexOf(":"),nl=(x.value()+"").indexOf("\n");if(-1!=ind&&-1!=nl&&(!x.includePath()||0==x.includePath().length)){var i=createIssue(hl.IssueCode.NODE_HAS_VALUE,'Suspicious double quoted multiline scalar, it is likely that you forgot closing "'+x.value(),node,!0);i.start=x._node.value.startPosition,i.end=x._node.value.endPosition,i.start==i.end&&i.end++,v.accept(i)}}return!0})},ScalarQuoteValidator}(),FixedFacetsValidator=function(){function FixedFacetsValidator(){}return FixedFacetsValidator.prototype.validate=function(node,v){var nc=node.definition(),dnode=nc.getAdapter(services.RAMLService).getDeclaringNode();if(dnode){var rof=dnode.parsedType(),dp=node.lowLevel().dumpToObject(!0);dp&&(dp=dp[Object.keys(dp)[0]]);var validateObject=rof.validate(dp,!1,!1);validateObject.isOk()||validateObject.getErrors().forEach(function(e){return v.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,e.getMessage(),mapPath(node,e),!1))})}},FixedFacetsValidator}(),TypeDeclarationValidator=function(){function TypeDeclarationValidator(){this.annotables={API:!0,DocumentationItem:!0,Resource:!0,Method:!0,Response:!0,RequestBody:!0,ResponseBody:!0,TypeDeclaration:!0,Example:!0,ResourceType:!0,Trait:!0,SecurityScheme:!0,SecuritySchemeSettings:!0,AnnotationType:!0,Library:!0,Overlay:!0,Extension:!0}}return TypeDeclarationValidator.prototype.validate=function(node,v){var rof=(node.definition(),node.parsedType()),validateObject=rof.validateType(node.types().getAnnotationTypeRegistry());if(!validateObject.isOk())for(var _i=0,_a=validateObject.getErrors();_i<_a.length;_i++){var issue,e=_a[_i],n=extractLowLevelNode(e);issue=n?createLLIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,e.getMessage(),n,mapPath(node,e),e.isWarning(),!0):createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,e.getMessage(),mapPath(node,e),e.isWarning()),v.accept(issue)}var examplesLowLevel=node.lowLevel()&&_.find(node.lowLevel().children(),function(x){return"examples"==x.key()});if(examplesLowLevel&&examplesLowLevel.valueKind&&examplesLowLevel.valueKind()===yaml.Kind.SEQ&&(issue=createLLIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,"Map is expected here.",examplesLowLevel,node,!1),v.accept(issue)),node.property()&&universeHelpers.isAnnotationTypesProperty(node.property())||hlimpl.isAnnotationTypeFragment(node))for(var atAttrs=node.attributes(universes.Universe10.TypeDeclaration.properties.allowedTargets.name),_b=0,atAttrs_1=atAttrs;_b<atAttrs_1.length;_b++){var attr=atAttrs_1[_b];this.checkAnnotationTarget(attr,v)}},TypeDeclarationValidator.prototype.checkAnnotationTarget=function(attr,v){var val=attr.value();if(null!=val){"string"!=typeof val&&v.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,"Annotation target must be set by a string",attr,!1));var str=val;val.replace(/\w|\s/g,"").length>0?v.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,"'allowedTargets' property value must be an array of type names or a single type name",attr,!1)):this.annotables[str]||v.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,"Unsupported annotation target: '"+str+"'",attr,!1))}},TypeDeclarationValidator}(),CompositeNodeValidator=function(){function CompositeNodeValidator(){}return CompositeNodeValidator.prototype.validate=function(node,acceptor){if(!node.definition().isAnnotationType()){if(node.lowLevel().keyKind()==yaml.Kind.SEQ){var isPattern=node.definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name);isPattern||acceptor.accept(createIssue(hl.IssueCode.UNKNOWN_NODE,"Node key can not be sequence",node))}if(node.definition().key()==universes.Universe08.GlobalSchema&&node.lowLevel().valueKind()!=yaml.Kind.SCALAR){var isString=!1;if(node.lowLevel().valueKind()==yaml.Kind.ANCHOR_REF||node.lowLevel().valueKind()==yaml.Kind.INCLUDE_REF){var vl=node.lowLevel().value();"string"==typeof vl&&(isString=!0)}isString||acceptor.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Schema '"+node.name()+"' must be a string",node))}node.parent()||((new RAMLVersionAndFragmentValidator).validate(node,acceptor),(node.definition().key()==universes.Universe08.Api||node.definition().key()==universes.Universe10.Api)&&(new OverloadingValidator).validateApi(node.wrapperNode(),acceptor),(new ScalarQuoteValidator).validate(node,acceptor),lintNode(node,acceptor)),(new OverlayNodesValidator).validate(node,acceptor);var nc=node.definition();if(nc.key()==universes.Universe08.BodyLike&&node.lowLevel().children().map(function(x){return x.key()}).some(function(x){return"formParameters"===x}))if(node.parent()&&node.parent().definition().key()==universes.Universe08.Response){var i=createIssue(hl.IssueCode.NODE_HAS_VALUE,"Form parameters can not be used in response",node);acceptor.accept(i)}else if(node.lowLevel().children().map(function(x){return x.key()}).some(function(x){return"schema"===x||"example"===x})){var i=createIssue(hl.IssueCode.NODE_HAS_VALUE,"'formParameters' property cannot be used together with the 'example' or 'schema' properties",node);acceptor.accept(i)}if(nc.key()==universes.Universe10.OAuth2SecuritySchemeSettings){var requireUrl=!1;if(node.attributes("authorizationGrants").forEach(function(x){var vl=x.value();if("authorization_code"===vl||"implicit"===vl)requireUrl=!0;else if("password"!==vl&&"client_credentials"!==vl&&vl&&"string"==typeof vl&&-1==vl.indexOf("://")&&-1==vl.indexOf(":")){var i=createIssue(hl.IssueCode.NODE_HAS_VALUE,"'authorizationGrants' value should be one of 'authorization_code', 'implicit', 'password', 'client_credentials' or to be an abolute URI",x);acceptor.accept(i)}}),requireUrl&&!node.attr("authorizationUri")){var i=createIssue(hl.IssueCode.NODE_HAS_VALUE,"'authorizationUri' is required when `authorization_code` or `implicit` grant type are used ",node);acceptor.accept(i)}}if(node.definition().isAssignableFrom(universes.Universe08.Parameter.name)||node.definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name)){var vls=node.attributes("enum").map(function(x){return x.value()});if(vls.length!=_.uniq(vls).length){var i=createIssue(hl.IssueCode.NODE_HAS_VALUE,"'enum' value contains repeating components",node);acceptor.accept(i)}if(node.definition().isAssignableFrom(universes.Universe08.NumberTypeDeclaration.name)||node.definition().isAssignableFrom(universes.Universe10.NumberTypeDeclaration.name)){var isInteger=node.definition().isAssignableFrom(universes.Universe08.IntegerTypeDeclaration.name)||node.definition().isAssignableFrom(universes.Universe10.IntegerTypeDeclaration.name);node.attributes("enum").forEach(function(attribute){var value=isInteger?parseInt(attribute.value()):parseFloat(attribute.value()),isValid=isInteger?!isNaN(value)&&-1===attribute.value().indexOf("."):!isNaN(value);if(!isValid){var issue=createIssue(hl.IssueCode.NODE_HAS_VALUE,(isInteger?"Integer":"Number")+" is expected",attribute);acceptor.accept(issue)}})}}universeHelpers.isResourceTypeType(node.definition())&&null==node.value()&&"null"===node.lowLevel().value(!0)&&acceptor.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Resource type can not be null",node)),checkPropertyQuard(node,acceptor);var nodeValue=node.value();if(("string"==typeof nodeValue||"number"==typeof nodeValue||"boolean"==typeof nodeValue)&&!node.definition().getAdapter(services.RAMLService).allowValue()&&node.parent()&&"~"!=nodeValue){var i=createIssue(hl.IssueCode.NODE_HAS_VALUE,"Node '"+node.name()+"' can not be a scalar",node);acceptor.accept(i)}(new RequiredPropertiesAndContextRequirementsValidator).validate(node,acceptor),(new ValidateChildrenKeys).validate(node,acceptor),(new NodeSpecificValidator).validate(node,acceptor)}},CompositeNodeValidator}(),BaseUriParameterValidator=function(){function BaseUriParameterValidator(){}return BaseUriParameterValidator.prototype.validate=function(node,acceptor){var nameAttributeValue=node.attrValue(universes.Universe10.TypeDeclaration.properties.name.name);"version"==nameAttributeValue&&acceptor.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY,"'version' parameter not allowed here",node))},BaseUriParameterValidator}(),NodeSpecificValidatorRegistryEntry=function(){function NodeSpecificValidatorRegistryEntry(definitions,propertyName,validator,assignableFrom){void 0===assignableFrom&&(assignableFrom=!1),this.definitions=definitions,this.propertyName=propertyName,this.assignableFrom=assignableFrom,this.validator=validator}return NodeSpecificValidatorRegistryEntry.prototype.validate=function(node,acceptor){var nodeDefinition=node.definition();if(null!=nodeDefinition){var definitionMatched=!1;if(definitionMatched=this.assignableFrom?this.definitions.some(function(currentDefinition){return nodeDefinition.isAssignableFrom(currentDefinition.name)}):this.definitions.some(function(currentDefinition){return currentDefinition===nodeDefinition})){if(null!=this.propertyName){if(null==node.property())return;if(node.property().nameId()!=this.propertyName)return}this.validator.validate(node,acceptor)}}},NodeSpecificValidatorRegistryEntry}(),NodeSpecificValidator=function(){function NodeSpecificValidator(){}return NodeSpecificValidator.createRegistry=function(){var result=[];return NodeSpecificValidator.registerValidator(result,[universes.Universe10.TypeDeclaration,universes.Universe08.Parameter],universes.Universe10.Api.properties.baseUriParameters.name,new BaseUriParameterValidator,!0),result},NodeSpecificValidator.registerValidator=function(listToAddTo,definitions,propertyName,validator,assignableFrom){void 0===assignableFrom&&(assignableFrom=!1);var entry=new NodeSpecificValidatorRegistryEntry(definitions,propertyName,validator,assignableFrom);listToAddTo.push(entry)},NodeSpecificValidator.prototype.validate=function(node,acceptor){NodeSpecificValidator.entries.forEach(function(entry){return entry.validate(node,acceptor)})},NodeSpecificValidator.entries=NodeSpecificValidator.createRegistry(),NodeSpecificValidator}(),OverlayNodesValidator=function(){function OverlayNodesValidator(){}return OverlayNodesValidator.prototype.allowsAnyChildren=function(node,root){var property=node.property(),definition=node.definition();return(universeHelpers.isAnnotationTypeType(definition)||universeHelpers.isTypeDeclarationTypeOrDescendant(definition))&&universeHelpers.isAnnotationTypesProperty(property)?!0:node.parent()==root&&universeHelpers.isTypesProperty(property)&&universeHelpers.isTypeDeclarationTypeOrDescendant(definition)?!0:universeHelpers.isSchemasProperty(property)&&universeHelpers.isTypeDeclarationTypeOrDescendant(definition)?!0:node.parent()==root&&universeHelpers.isDocumentationProperty(property)&&universeHelpers.isDocumentationType(definition)?!0:universeHelpers.isAnnotationsProperty(property)?!0:universeHelpers.isUsesProperty(property)?!0:universeHelpers.isExamplesProperty(property)?!0:!1},OverlayNodesValidator.prototype.nodeAllowedDueToParent=function(node,root){for(var currentNode=node;currentNode!=root&&null!=currentNode;){if(this.allowsAnyChildren(currentNode,root))return!0;currentNode=currentNode.parent()}return!1},OverlayNodesValidator.prototype.validate=function(node,v){var root=node.root();node.property(),node.definition();if(universeHelpers.isOverlayType(root.definition())){if(node==root)return void this.validateProperties(node,v);if(!this.nodeAllowedDueToParent(node,root)){var overrides=root.knownIds();if(overrides){var override=overrides.hasOwnProperty(node.id());return override?void this.validateProperties(node,v):void v.accept(createIssue(hl.IssueCode.ONLY_OVERRIDE_ALLOWED,"The '"+node.id()+"' node does not match any node of the master api.",node))}}}},OverlayNodesValidator.prototype.validateProperties=function(node,acceptor){node.attrs().forEach(function(attribute){if(!(attribute.property().getAdapter(services.RAMLPropertyService).isKey()||attribute.parent()!=node||attribute.isElement()||universeHelpers.isTitlePropertyName(attribute.name())||universeHelpers.isDescriptionPropertyName(attribute.name())||universeHelpers.isDisplayNamePropertyName(attribute.name())||universeHelpers.isUsagePropertyName(attribute.name())||universeHelpers.isExampleProperty(attribute.property())||universeHelpers.isMasterRefProperty(attribute.property())||universeHelpers.isAnnotationsProperty(attribute.property())||universeHelpers.isUsesProperty(attribute.property()))){var message="Property '"+attribute.name()+"' is not allowed to be overriden or added in overlays";acceptor.accept(createIssue(hl.IssueCode.ONLY_OVERRIDE_ALLOWED,message,attribute))}})},OverlayNodesValidator}(),RecurrentOverlayValidator=function(){function RecurrentOverlayValidator(){}return RecurrentOverlayValidator.prototype.validate=function(node,v){var _this=this,z=new OverlayNodesValidator;z.validate(node,v),node.directChildren().forEach(function(x){x.isElement()&&_this.validate(x.asElement(),v)})},RecurrentOverlayValidator}(),RecurrentValidateChildrenKeys=function(){function RecurrentValidateChildrenKeys(){}return RecurrentValidateChildrenKeys.prototype.val=function(node,v,p){var _this=this;if(node.kind()==yaml.Kind.MAP||node.kind()==yaml.Kind.MAPPING){var ms={};node.children().forEach(function(x){var c=x.key();if(c){if(ms.hasOwnProperty(c)){var issue=createIssue(hl.IssueCode.KEY_SHOULD_BE_UNIQUE_INTHISCONTEXT,"Keys should be unique",p,!1);x.unit()==p.lowLevel().unit()&&(issue.start=x.keyStart(),issue.end=x.keyEnd()),v.accept(issue)}ms[c]=1}})}node.children().forEach(function(x){_this.val(x,v,p)})},RecurrentValidateChildrenKeys.prototype.validate=function(node,v){this.val(node.lowLevel(),v,node)},RecurrentValidateChildrenKeys}(),ValidateChildrenKeys=function(){function ValidateChildrenKeys(){}return ValidateChildrenKeys.prototype.validate=function(node,acceptor){this.validateChildElements(node,acceptor);var lowLevelChildren=node.lowLevel().children(),keyToLowLevelChildren=_.groupBy(lowLevelChildren.filter(function(x){return null!=x.key()}),function(x){return x.key()});this.validateChildAttributes(node,keyToLowLevelChildren,acceptor),this.validateUnrecognizedLowLevelChildren(node,keyToLowLevelChildren,acceptor)},ValidateChildrenKeys.prototype.validateChildElements=function(node,acceptor){var keyToElements={},childElements=node.directChildren().filter(function(x){return x.isElement()});childElements.forEach(function(childNode){var childElement=childNode;if(!childElement._computed&&childElement.name()){var elementKey=childElement.name()+childElement.property().nameId();keyToElements.hasOwnProperty(elementKey)?childElement.isNamePatch()||keyToElements[elementKey].push(childElement):keyToElements[elementKey]=[childElement]}}),Object.keys(keyToElements).forEach(function(key){var childElements=keyToElements[key];!childElements||childElements.length<2||childElements.forEach(function(childElement){var message="",humanReadableName=getHumanReadableNodeName(childElement);if(humanReadableName){var capitalized=changeCase.upperCaseFirst(humanReadableName);message=capitalized+" '"+childElement.name()+"' already exists"}else message="'"+childElement.name()+"' already exists in this context";var issue=createIssue(hl.IssueCode.KEY_SHOULD_BE_UNIQUE_INTHISCONTEXT,message,childElement);acceptor.accept(issue)})})},ValidateChildrenKeys.prototype.validateChildAttributes=function(node,keyToLowLevelChildren,acceptor){var highLevelAttributes=this.getHighLevelAttributes(node),nameToHighLevelAttributes=_.groupBy(highLevelAttributes,function(x){return x.name()}),allowsAnyAndHasRequireds=this.allowsAnyAndHasRequireds(node);Object.keys(nameToHighLevelAttributes).forEach(function(attributeName){if(!(nameToHighLevelAttributes[attributeName].length<2)){var isUnknown=nameToHighLevelAttributes[attributeName][0].isUnknown(),isMultiValue=!isUnknown&&nameToHighLevelAttributes[attributeName][0].property().isMultiValue();isMultiValue&&(node.definition().isAssignableFrom(universes.Universe08.SecuritySchemeSettings.name)||node.definition().isAssignableFrom(universes.Universe10.SecuritySchemeSettings.name))&&(isMultiValue=keyToLowLevelChildren[attributeName]&&1===keyToLowLevelChildren[attributeName].length),(isUnknown&&allowsAnyAndHasRequireds||!isMultiValue||isMultiValue&&null!=keyToLowLevelChildren[attributeName]&&keyToLowLevelChildren[attributeName].length>1)&&nameToHighLevelAttributes[attributeName].forEach(function(attribute){var message="Property already used: '"+(attribute.property()?attribute.property().nameId():attribute.name())+"'",humanReadableParent=getHumanReadableNodeName(attribute.parent());if(humanReadableParent){var capitalizedParent=changeCase.upperCaseFirst(humanReadableParent);message=capitalizedParent+" "+changeCase.lowerCaseFirst(message)}var issue=createIssue(hl.IssueCode.PROPERTY_EXPECT_TO_HAVE_SINGLE_VALUE,message,attribute);acceptor.accept(issue)})}})},ValidateChildrenKeys.prototype.validateUnrecognizedLowLevelChildren=function(node,keyToLowLevelChildren,acceptor){var highLevelChildren=node.directChildren(),nameToHighLevelChildren=_.groupBy(highLevelChildren,function(x){return x.name()});Object.keys(keyToLowLevelChildren).forEach(function(lowLevelChildKey){if(lowLevelChildKey&&keyToLowLevelChildren[lowLevelChildKey].length>1&&!nameToHighLevelChildren[lowLevelChildKey]){if(node.definition().isAssignableFrom(universes.Universe10.ObjectTypeDeclaration.name))return;var message="property already used: '"+lowLevelChildKey+"'",humanReadableNode=getHumanReadableNodeName(node);if(humanReadableNode){var capitalizedParent=humanReadableNode.charAt(0).toUpperCase()+humanReadableNode.slice(1);message=capitalizedParent+" "+message}keyToLowLevelChildren[lowLevelChildKey].forEach(function(lowLevelChild){var i=createLLIssue(hl.IssueCode.PROPERTY_EXPECT_TO_HAVE_SINGLE_VALUE,message,lowLevelChild,node);i.start=lowLevelChild.keyStart(),i.end=lowLevelChild.keyEnd(),acceptor.accept(i)})}})},ValidateChildrenKeys.prototype.filterMultiValueAnnotations=function(node,keyToLowLevelChildren,acceptor){this.getHighLevelAttributes(node);Object.keys(keyToLowLevelChildren).forEach(function(lowLevelChildKey){"("!==lowLevelChildKey.charAt(0)||keyToLowLevelChildren[lowLevelChildKey].length<2})},ValidateChildrenKeys.prototype.getHighLevelAttributes=function(node){var allowsAnyAndHasRequireds=this.allowsAnyAndHasRequireds(node);return node.directChildren().filter(function(x){return x.isAttr()||allowsAnyAndHasRequireds})},ValidateChildrenKeys.prototype.allowsAnyAndHasRequireds=function(node){var requireds=node.definition().requiredProperties(),hasRequireds=requireds&&requireds.length>0,ramlService=node.definition().getAdapter(services.RAMLService),isAllowAny=ramlService&&ramlService.getAllowAny(),anyExceptRequireds=isAllowAny&&hasRequireds;return anyExceptRequireds},ValidateChildrenKeys}(),ExampleAndDefaultValueValidator=function(){function ExampleAndDefaultValueValidator(){}return ExampleAndDefaultValueValidator.prototype.validate=function(node,cb){var strictValidation=this.isStrict(node);if(strictValidation||settings.validateNotStrictExamples){var pObj=this.parseObject(node,cb,strictValidation);if(pObj){var schema=this.aquireSchema(node);schema&&schema.validate(pObj,cb,strictValidation)}}},ExampleAndDefaultValueValidator.prototype.isExampleNode=function(node){return this.isSingleExampleNode(node)||this.isExampleNodeInMultipleDecl(node)},ExampleAndDefaultValueValidator.prototype.isSingleExampleNode=function(node){return node.name()==universes.Universe10.TypeDeclaration.properties.example.name},ExampleAndDefaultValueValidator.prototype.isExampleNodeInMultipleDecl=function(node){var parent=node.parent();return parent?universeHelpers.isExampleSpecType(parent.definition()):!1},ExampleAndDefaultValueValidator.prototype.findParentSchemaOrTypeAttribute=function(node){var attribute=node.parent().attr(universes.Universe10.TypeDeclaration.properties.schema.name);return attribute?attribute:(attribute=node.parent().attr(universes.Universe10.TypeDeclaration.properties.type.name))?attribute:node.parent()?(attribute=node.parent().parent().attr(universes.Universe10.TypeDeclaration.properties.schema.name))?attribute:(attribute=node.parent().parent().attr(universes.Universe10.TypeDeclaration.properties.type.name),attribute?attribute:null):null},ExampleAndDefaultValueValidator.prototype.aquireSchema=function(node){var sp=node.parent().definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name);if(this.isExampleNode(node)){var sampleRoot=node;if(this.isExampleNodeInMultipleDecl(node)&&(sampleRoot=node.parent()),sampleRoot.parent()&&(sampleRoot.parent().definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name)&&null===sampleRoot.parent().parent()?sp=!1:sampleRoot.parent().property().nameId()==universes.Universe10.LibraryBase.properties.types.name&&(sp=!1),sampleRoot.parent().parent())){var ppc=sampleRoot.parent().parent().definition().key();(ppc==universes.Universe08.Method||ppc==universes.Universe10.Method)&&(sampleRoot.parent().property().nameId()==universes.Universe10.MethodBase.properties.queryParameters.name||(sp=!0)),(ppc==universes.Universe08.Response||ppc==universes.Universe10.Response)&&(sp=!0)}}if(node.parent().definition().key()==universes.Universe08.BodyLike||sp){var sa=this.findParentSchemaOrTypeAttribute(node);if(sa){var val=sa.value();if(val instanceof hlimpl.StructuredValue)return null;var strVal=(""+val).trim(),so=null;if("{"==strVal.charAt(0))try{so=su.getJSONSchema(strVal,contentProvider(sa.lowLevel()))}catch(e){return null}if("<"==strVal.charAt(0))try{so=su.getXMLSchema(strVal)}catch(e){return null}if(so)return{validate:function(pObje,cb,strict){try{if(pObje.__$validated)return;if(so instanceof Error)return void cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,so.message,node,!strict));so.validateObject(pObje)}catch(e){var illegalRequiredMessageStart="Cannot assign to read only property '__$validated' of ";if(e.message&&0==e.message.indexOf(illegalRequiredMessageStart)){var propertyName=e.message.substr(illegalRequiredMessageStart.length,e.message.length-illegalRequiredMessageStart.length),patchedErrorMessage="Invalid JSON schema. Potentially, required array containing value '"+propertyName+"' has invalid location";return void cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,patchedErrorMessage,sa,!strict))}if("Object.keys called on non-object"==e.message)return;return void cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Example does not conform to schema: "+e.message,node,!strict))}}};if(strVal.length>0){var nodeParent=node.parent(),grandParent=nodeParent&&nodeParent.parent(),owner=nodeParent&&nodeParent.definition()&&nodeParent.definition().isAssignableFrom(universes.Universe10.ObjectTypeDeclaration.name)&&nodeParent;
if(owner=owner||grandParent&&grandParent.definition()&&grandParent.definition().isAssignableFrom(universes.Universe10.ObjectTypeDeclaration.name)&&grandParent)return this.typeValidator(owner,node)}}}return this.getSchemaFromModel(node)},ExampleAndDefaultValueValidator.prototype.getSchemaFromModel=function(node){var p=node.parent();return this.typeValidator(p,node)},ExampleAndDefaultValueValidator.prototype.typeValidator=function(p,node){var newVar={validate:function(pObje,cb,strict){var pt=p.parsedType();if(pt&&!pt.isUnknown()){"number"==typeof pObje&&pt.isString()&&(pObje=""+pObje),"boolean"==typeof pObje&&pt.isString()&&(pObje=""+pObje),pt.getExtra("repeat")&&(pObje=[pObje]);var validateObject=pt.validate(pObje,!1);validateObject.isOk()||validateObject.getErrors().forEach(function(e){return cb.accept(createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,e.getMessage(),node,!strict))})}}};return newVar},ExampleAndDefaultValueValidator.prototype.toObject=function(h,v,cb){var res=v.lowLevel().dumpToObject(!0);return this.testDublication(h,v.lowLevel(),cb),res.example?res.example:res.content?res.content:void 0},ExampleAndDefaultValueValidator.prototype.testDublication=function(h,v,cb){var _this=this,map={};v.children().forEach(function(x){x.key()&&(map[x.key()]&&cb.accept(createIssue(hl.IssueCode.KEY_SHOULD_BE_UNIQUE_INTHISCONTEXT,"Keys should be unique",new hlimpl.BasicASTNode(x,h.parent()))),map[x.key()]=x),_this.testDublication(h,x,cb)})},ExampleAndDefaultValueValidator.prototype.parseObject=function(node,cb,strictValidation){var pObj=null,vl=node.value(),mediaType=getMediaType(node);if(vl instanceof hlimpl.StructuredValue)pObj=this.toObject(node,vl,cb);else if(mediaType){if(isJson(mediaType))try{pObj=JSON.parse(vl)}catch(e){return void cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Can not parse JSON: "+e.message,node,!strictValidation))}if(isXML(mediaType))try{pObj=xmlutil(vl)}catch(e){return void cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Can not parse XML: "+e.message,node,!strictValidation))}}else try{if(!(vl&&vl.length>0)||"["!=vl.trim().charAt(0)&&"{"!=vl.trim().charAt(0)&&"<"!=vl.trim().charAt(0)){if("true"==vl)return!0;if("false"==vl)return!1;var n=parseFloat(vl);return isNaN(n)?vl:n}pObj=JSON.parse(vl)}catch(e){if(0!=vl.trim().indexOf("<"))return vl;try{pObj=xmlutil(vl)}catch(e){return void cb.accept(createIssue(hl.IssueCode.INVALID_VALUE_SCHEMA,"Can not parse XML: "+e.message,node,!strictValidation))}}return pObj},ExampleAndDefaultValueValidator.prototype.isStrict=function(node){if(universeHelpers.isDefaultValue(node.property()))return!0;if(universeHelpers.isExampleProperty(node.property())&&"RAML08"==node.parent().definition().universe().version())return!1;var strictValidation=!1,strict=node.parent().attr("strict");return strict&&"true"==strict.value()&&(strictValidation=!0),strictValidation},ExampleAndDefaultValueValidator}();exports.ExampleAndDefaultValueValidator=ExampleAndDefaultValueValidator;var toReadableName=function(template,toLowerCase,pluralize_){var templateName=changeCase.sentence(template);return toLowerCase||(templateName=changeCase.ucFirst(templateName)),pluralize_&&(templateName=pluralize.plural(templateName)),templateName},OptionalPropertiesValidator=function(){function OptionalPropertiesValidator(){}return OptionalPropertiesValidator.prototype.validate=function(node,v){if(node.isAttr()){if(!node.optional())return;var attr=node,prop=attr.property();if(prop.isMultiValue()||prop.range().isArray())return;if(!prop.isFromParentKey()){var template=typeOfContainingTemplate(attr.parent());if(template&&prop.isValueProperty()){var templateNamePlural=toReadableName(template,!0,!0),message="Optional scalar properties are not allowed in "+templateNamePlural+" and their descendants: '"+attr.name()+"?'",issue=createIssue(hl.IssueCode.INVALID_PROPERTY,message,attr,!1);v.accept(issue)}}}else if(node.isElement()){var aNode=node,prop=aNode.property(),allowsQuestion=aNode.allowsQuestion();if(!allowsQuestion){var propName=prop?toReadableName(prop.nameId(),!0,!0):"API root";aNode.optionalProperties().forEach(function(x){aNode.children().forEach(function(y){var message="Optional properties are not allowed in '"+propName+"': '"+y.lowLevel().key()+"?'",issue=createIssue(hl.IssueCode.INVALID_PROPERTY,message,node,!1);v.accept(issue)})})}var def=node.asElement().definition();if(node.optional()&&"RAML10"==def.universe().version()){var prop=node.property(),isParam=universeHelpers.isQueryParametersProperty(prop)||universeHelpers.isUriParametersProperty(prop)||universeHelpers.isHeadersProperty(prop);if(!(universeHelpers.isMethodType(def)||universeHelpers.isTypeDeclarationType(def)&&isParam)){var issue=createIssue(hl.IssueCode.MISSED_CONTEXT_REQUIREMENT,"Only method nodes can be optional",node,!1);v.accept(issue)}}}},OptionalPropertiesValidator}(),UriParametersValidator=function(){function UriParametersValidator(){}return UriParametersValidator.prototype.validate=function(node,v){var def=node.definition(),baseUriPropName=universes.Universe10.Api.properties.baseUri.name,baseUriParamsPropName=universes.Universe10.Api.properties.baseUriParameters.name,uriPropName=universes.Universe10.Resource.properties.relativeUri.name,uriParamsPropName=universes.Universe10.ResourceBase.properties.uriParameters.name;if(universeHelpers.isApiSibling(def))this.inspectParameters(node,v,baseUriPropName,baseUriParamsPropName);else if(universeHelpers.isResourceType(def)){var rootNode=node.root();this.inspectParameters(node,v,baseUriPropName,baseUriParamsPropName,rootNode),this.inspectParameters(node,v,uriPropName,uriParamsPropName)}else if(universeHelpers.isResourceTypeType(def)){var rootNode=node.root();this.inspectParameters(node,v,baseUriPropName,baseUriParamsPropName,rootNode)}},UriParametersValidator.prototype.inspectParameters=function(node,v,uriPropName,paramsPropName,rootNode){rootNode=rootNode||node;var uriValue="",uriAttr=rootNode.attr(uriPropName);uriAttr&&(uriValue=uriAttr.value(),uriValue&&"string"==typeof uriValue||(uriValue=""));var paramElements=node.elementsOfKind(paramsPropName);paramElements.forEach(function(x){var nameAttr=x.attr(universes.Universe10.TypeDeclaration.properties.name.name);if(nameAttr){var name=nameAttr.value();if(null!=name&&uriValue.indexOf("{"+name+"}")<0){if(universeHelpers.isResourceTypeType(node.definition())&&name.indexOf("<<")>=0)return;var propNameReadable=pluralize.singular(changeCase.sentence(paramsPropName)),message=changeCase.upperCaseFirst(propNameReadable)+" unused",issue=createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,message,x,!0);v.accept(issue)}}})},UriParametersValidator}(),TemplateCyclesDetector=function(){function TemplateCyclesDetector(){this.nameProperty=universes.Universe10.ResourceType.properties.name.name}return TemplateCyclesDetector.prototype.validate=function(node,v){var definition=node.definition();if(universeHelpers.isLibraryBaseSibling(definition)||universeHelpers.isApiType(definition)){var typeProp=(universes.Universe10.LibraryBase.properties.resourceTypes.name,universes.Universe10.ResourceBase.properties.type.name),isProp=(universes.Universe10.LibraryBase.properties.traits.name,universes.Universe10.MethodBase.properties.is.name),allResourceTypes=search.globalDeclarations(node).filter(function(x){return universeHelpers.isResourceTypeType(x.definition())}),alltraits=search.globalDeclarations(node).filter(function(x){return universeHelpers.isTraitType(x.definition())});this.checkCycles(allResourceTypes,typeProp,v),this.checkCycles(alltraits,isProp,v)}},TemplateCyclesDetector.prototype.checkCycles=function(templates,propName,v){var _this=this,templatesMap={};templates.forEach(function(x){var name=_this.templateName(x);templatesMap[name]=x});var templatesWithCycle={};templates.forEach(function(template){var name=_this.templateName(template);templatesWithCycle[name]||_this.findCyclesInDefinition(template,propName,templatesMap).forEach(function(cycle){cycle.forEach(function(x){return templatesWithCycle[x]=!0}),cycle=cycle.reverse();var message=toReadableName(template.definition().nameId())+" definition contains cycle: "+cycle.join(" -> "),issue=createIssue(hl.IssueCode.ILLEGAL_PROPERTY_VALUE,message,template,!1);v.accept(issue)})})},TemplateCyclesDetector.prototype.templateName=function(node){var nameAttribute=node.attr(this.nameProperty);return nameAttribute?nameAttribute.value():null},TemplateCyclesDetector.prototype.findCyclesInDefinition=function(node,propName,templatesMap,occuredTemplates){void 0===occuredTemplates&&(occuredTemplates={});var name=this.templateName(node);if(occuredTemplates[name])return[[name]];var nextOccuredTemplates={};Object.keys(occuredTemplates).forEach(function(x){return nextOccuredTemplates[x]=occuredTemplates[x]}),nextOccuredTemplates[name]=!0;for(var occuredCycles=[],templatesRefs=node.attributes(propName),i=0;i<templatesRefs.length;i++){var ref=templatesRefs[i],val=ref.value();if(val){var refName="string"==typeof val?val:val.valueName(),template=templatesMap[refName];if(null!=template){var newCycles=this.findCyclesInDefinition(template,propName,templatesMap,nextOccuredTemplates);newCycles.forEach(function(x){return occuredCycles.push(x)})}}}return occuredCycles.forEach(function(x){return x.push(name)}),occuredCycles},TemplateCyclesDetector}();exports.isJson=isJson,exports.isXML=isXML,exports.getMediaType=getMediaType;var localError=function(node,c,w,message,p,prop,positionsSource){var llNode=positionsSource?positionsSource:node.lowLevel(),contents=llNode.unit()&&llNode.unit().contents(),contentLength=contents&&contents.length,st=llNode.start(),et=llNode.end();if(contentLength&&et>contentLength&&(et=contentLength-1),llNode.key()&&llNode.keyStart()){var ks=llNode.keyStart();ks>0&&(st=ks);var ke=llNode.keyEnd();ke>0&&(et=ke)}if(st>et&&(et=st+1,node.isElement())){var definition=node.definition();universeHelpers.isApiType(definition)&&(st=0==contentLength?0:contentLength-1,et=st)}if(prop&&!prop.getAdapter(services.RAMLPropertyService).isMerged()&&null==node.parent()){var nm=_.find(llNode.children(),function(x){return x.key()==prop.nameId()});if(nm){var ks=nm.keyStart(),ke=nm.keyEnd();ks>0&&ke>ks&&(st=ks,et=ke)}}return{code:c,isWarning:w,message:message,node:node,start:st,end:et,path:p?llNode.unit()?llNode.unit().path():"":null,extras:[],unit:node?llNode.unit():null}},localLowLevelError=function(node,highLevelAnchor,issueCode,isWarning,message,path){var contents=node.unit()&&node.unit().contents(),contentLength=contents&&contents.length,st=node.start(),et=node.end();if(contentLength&&contentLength>=et&&(et=contentLength-1),node.key()&&node.keyStart()){var ks=node.keyStart();ks>0&&(st=ks);var ke=node.keyEnd();ke>0&&(et=ke)}return{code:issueCode,isWarning:isWarning,message:message,node:highLevelAnchor,start:st,end:et,path:path?node.unit()?node.unit().path():"":null,extras:[],unit:node?node.unit():null}};exports.toIssue=toIssue,exports.createIssue=createIssue,exports.createLLIssue=createLLIssue,exports.validateResponseString=validateResponseString}).call(exports,__webpack_require__(59))},function(module,exports,__webpack_require__){"use strict";function getAllOptions(c,deep){if(void 0===deep&&(deep=0),deep>20)return[];try{var result=[],tp=c.leftType();tp&&result.push(tp);var r=c.rightType();if(r)if(r.hasUnionInHierarchy()){var options=getAllOptions(r.unionInHierarchy(),deep+1);result=result.concat(options)}else result.push(r);return result}finally{}}function getBaseType(node,expression){if(!expression)return node.definition().universe().type(universes.Universe10.StringTypeDeclaration.name);var pt=node.parsedType();return pt.isString()?node.definition().universe().type(universes.Universe10.StringTypeDeclaration.name):pt.isNumber()?pt.isInteger()?node.definition().universe().type(universes.Universe10.IntegerTypeDeclaration.name):node.definition().universe().type(universes.Universe10.NumberTypeDeclaration.name):pt.isBoolean()?node.definition().universe().type(universes.Universe10.BooleanTypeDeclaration.name):pt.isObject()?node.definition().universe().type(universes.Universe10.ObjectTypeDeclaration.name):pt.isArray()?node.definition().universe().type(universes.Universe10.ArrayTypeDeclaration.name):pt.isFile()?node.definition().universe().type(universes.Universe10.FileTypeDeclaration.name):pt.isDateTime()?node.definition().universe().type(universes.Universe10.DateTimeTypeDeclaration.name):pt.isDateTimeOnly()?node.definition().universe().type(universes.Universe10.DateTimeOnlyTypeDeclaration.name):pt.isDateOnly()?node.definition().universe().type(universes.Universe10.DateOnlyTypeDeclaration.name):pt.isTimeOnly()?node.definition().universe().type(universes.Universe10.TimeOnlyTypeDeclaration.name):pt.isUnion()?node.definition().universe().type(universes.Universe10.UnionTypeDeclaration.name):node.definition().universe().type(universes.Universe10.TypeDeclaration.name)}function transform(u){return function(x){var m=u.type(x);if(!m){new defs.UserDefinedClass("",u,null,"","")}return m}}function findFacetInTypeNode(typeNode,facetName){var typeNodeElement=typeNode.asElement();if(null==typeNodeElement)return null;var facets=typeNodeElement.elementsOfKind(universes.Universe10.TypeDeclaration.properties.facets.name);return null==facets||0==facets.length?null:_.find(facets,function(facet){return facetName==facet.attrValue(universes.Universe10.TypeDeclaration.properties.name.name)})}function findFacetDeclaration(facet){var owner=facet.owner();if(null==owner)return null;var facetName=facet.facetName();if(!facetName)return null;var ownerSource=owner.getExtra(ramlTypes.SOURCE_EXTRA);return null==ownerSource?null:def.isSourceProvider(ownerSource)||hl.isParseResult(ownerSource)?{getSource:function(){if(def.isSourceProvider(ownerSource)){var resolvedSource=ownerSource.getSource();if(resolvedSource&&hl.isParseResult(resolvedSource))return findFacetInTypeNode(resolvedSource,facetName)}else if(hl.isParseResult(ownerSource))return findFacetInTypeNode(ownerSource,facetName);return null}}:null}function patchTypeWithFacets(originalType,nodeReferencingType,parentOfReferencingNode){if(null==originalType)return null;var patchedType=new defs.NodeClass(nodeReferencingType.name(),nodeReferencingType.definition().universe(),"",""),parsedRType=nodeReferencingType.parsedType();return parsedRType.allFacets().forEach(function(facet){if(facet.kind()==defs.tsInterfaces.MetaInformationKind.FacetDeclaration){var propertySource=findFacetDeclaration(facet),facetBasedProperty=null;null!=propertySource?(facetBasedProperty=new defs.UserDefinedProp(facet.facetName(),null),facetBasedProperty.setSourceProvider(propertySource)):facetBasedProperty=new defs.Property(facet.facetName(),""),facetBasedProperty.withRange(parentOfReferencingNode.definition().universe().type("StringType")),facetBasedProperty.withDomain(patchedType),facetBasedProperty.withGroupName(facet.facetName()),facetBasedProperty.withRequired(!1),facet.value(),ramlTypes.setPropertyConstructor(function(x){var v=new defs.Property(x,"");return v.unmerge(),v}),facetBasedProperty.withRange(ramlTypes.toNominal(facet.value(),transform(nodeReferencingType.definition().universe())))}}),patchedType._superTypes.push(originalType),patchedType}function desc1(p,parent,x){var tp=x.attr("type");if(tp){var baseType=getBaseType(x,tp.value()),patchedType=patchTypeWithFacets(baseType,x,parent);return patchedType&&0==patchedType.superTypes().length&&patchedType._superTypes.push(x.definition().universe().type(universes.Universe10.TypeDeclaration.name)),patchedType}var propertiesName=universes.Universe10.ObjectTypeDeclaration.properties.properties.name;if(p){if("body"==p.nameId()||_.find(x.lowLevel().children(),function(x){return x.key()===propertiesName}))return x.definition().universe().type(universes.Universe10.ObjectTypeDeclaration.name)}else if(!parent&&x.lowLevel()&&_.find(x.lowLevel().children(),function(x){return x.key()===propertiesName}))return x.definition().universe().type(universes.Universe10.ObjectTypeDeclaration.name);return x.definition().universe().type(universes.Universe10.StringTypeDeclaration.name)}function doDescrimination(node){try{var nodeDefenitionName=node.definition().nameId(),isApi=nodeDefenitionName===universes.Universe10.Api.name||nodeDefenitionName===universes.Universe08.Api.name;if(!isApi&&!node.property()&&!node.parent()&&node.definition().nameId()===hlimpl.getFragmentDefenitionName(node)){if(node.property()&&node.property().nameId()===universes.Universe10.LibraryBase.properties.annotationTypes.name)return descriminate(null,null,node);var result=null,subTypes=node.definition().allSubTypes();return subTypes.forEach(function(subType){!result&&match(subType,node,null)&&(result=subType)}),result}}catch(exception){}return descriminate(node.property(),node.parent(),node)}function descriminate(p,parent,x){var n=x.lowLevel();p&&p.nameId()==universes.Universe10.FragmentDeclaration.properties.uses.name&&p.range().nameId()==universes.Universe10.Library.name;var range=p?p.range().nameId():x.definition().nameId();if(n._node&&n._node.descriminate)return null;n._node&&(n._node.descriminate=1);try{if(range==universes.Universe10.TypeDeclaration.name){var res=desc1(p,parent,x);if(p||!p&&!parent&&x.lowLevel()){if(p&&null!=res&&(p.nameId()==universes.Universe10.MethodBase.properties.body.name||p.nameId()==universes.Universe10.Response.properties.headers.name||p.nameId()==universes.Universe10.MethodBase.properties.queryParameters.name)){var ares=new defs.UserDefinedClass(x.lowLevel().key(),res.universe(),x,x.lowLevel().unit()?x.lowLevel().unit().path():"","");return ares._superTypes.push(res),ares}if(null!=res&&universeHelpers.isAnnotationTypeType(x.definition())){var annotationType=descriminateAnnotationType(res),ares=new defs.UserDefinedClass(x.lowLevel().key(),res.universe(),x,x.lowLevel().unit()?x.lowLevel().unit().path():"","");return ares._superTypes.push(annotationType),ares._superTypes.push(res),ares}}if(res)return res}var rt=null;if(p&&parent){var types=search.findAllSubTypes(p,parent);return types.length>0&&types.forEach(function(y){rt||match(y,x,rt)&&(rt=y)}),rt}}finally{n._node&&delete n._node.descriminate}}function descriminateAnnotationType(type){for(var candidate,arr=[type].concat(type.allSuperTypes()),i=0;i<arr.length;i++){var t=arr[i];if(!t.isUserDefined()){if(t.isUnion()){var ut=t,lt=ut.leftType(),lat=(ut.leftType(),descriminateAnnotationType(lt)),rat=descriminateAnnotationType(lt);if(lat.isAssignableFrom(rat.nameId())&&(null==candidate||lat.isAssignableFrom(candidate.nameId()))){candidate=lat;continue}if(rat.isAssignableFrom(lat.nameId())&&(null==candidate||rat.isAssignableFrom(candidate.nameId()))){candidate=rat;continue}candidate=type.universe().type(universes.Universe10.UnionTypeDeclaration.name);break}if(t.isArray()){candidate=type.universe().type(universes.Universe10.ArrayTypeDeclaration.name);break}for(var subTypes=t.subTypes(),j=0;j<subTypes.length;j++){var st=subTypes[j];st.isAssignableFrom(universes.Universe10.TypeDeclaration.name)&&(null==candidate?candidate=st:st.isAssignableFrom(candidate.nameId())&&(candidate=st))}}}return null!=candidate?candidate:type.universe().type(universes.Universe10.TypeDeclaration.name)}function match(t,r,alreadyFound){if(r.isAttr()||r.isUnknown())return!1;var el=r,hasSuperType=_.find(t.superTypes(),function(x){var dp=_.find(x.allProperties(),function(x){return x.isDescriminator()});if(dp){var a=el.attr(dp.nameId());if(a&&a.value()==t.nameId())return!0}return!1});if(hasSuperType)return!0;if(0==t.valueRequirements().length)return!1;var matches=!0;return t.valueRequirements().forEach(function(x){var a=el.attr(x.name);if(a)if(a.value()==x.value);else if(t.getAdapter(services.RAMLService).getConsumesRefs()){var vl=a.value(),allSubs=[];t.superTypes().forEach(function(x){return x.allSubTypes().forEach(function(y){allSubs.push(y)})});var allSubNames=[];_.unique(allSubs).forEach(function(x){allSubNames.push(x.nameId()),x.valueRequirements().forEach(function(y){allSubNames.push(y.value)}),x.getAdapter(services.RAMLService).getAliases().forEach(function(y){return allSubNames.push(y)})}),_.find(allSubNames,function(x){return x==vl})&&(matches=!1)}else matches=!1;else{var m=t.getAdapter(services.RAMLService).getDefining(),ms=!1;if(m.forEach(function(x){el.lowLevel().children().forEach(function(y){y.key()==x&&(ms=!0)})}),ms)return void(matches=!0);if(alreadyFound)matches=!1;else{var pr=t.property(x.name);pr&&pr.defaultValue()==x.value||(matches=!1)}}}),matches}var defs=__webpack_require__(36),hl=__webpack_require__(10),yaml=__webpack_require__(74),_=__webpack_require__(65),def=defs,hlimpl=__webpack_require__(16),proxy=__webpack_require__(39),search=__webpack_require__(24),universes=__webpack_require__(18),universeHelpers=__webpack_require__(14),services=defs,ramlTypes=defs.rt,mediaTypeParser=__webpack_require__(62),KeyMatcher=function(){function KeyMatcher(_props){this._props=_props,this.parentValue=_.find(_props,function(x){return x.isFromParentValue()}),this.parentKey=_.find(_props,function(x){return x.isFromParentKey()}),this.canBeValue=_.find(_props,function(x){return x.canBeValue()})}return KeyMatcher.prototype.add=function(p){this._props.push(p)},KeyMatcher.prototype.match=function(key){var _this=this,_res=null,lastPref="";return this._props.forEach(function(p){p.getAdapter(services.RAMLPropertyService).isSystem()||p!=_this.parentValue&&p!=_this.parentKey&&p.matchKey(key)&&(null!=p.keyPrefix()?p.keyPrefix().length>=lastPref.length&&(lastPref=p.keyPrefix(),_res=p):(_res=p,lastPref=p.nameId()))}),_res},KeyMatcher}(),ad=0,BasicNodeBuilder=function(){function BasicNodeBuilder(){this.shouldDescriminate=!1}return BasicNodeBuilder.prototype.process=function(node,childrenToAdopt){var _this=this,nn=node.lowLevel(),cv=node;cv._mergedChildren=null;var cha=nn._node?nn._node:nn;try{if(cha.currentChildren)return cha.currentChildren;if(!node.definition())return;if(null==node.parent()&&!this.shouldDescriminate){this.shouldDescriminate=!0;try{var children=this.process(node,childrenToAdopt),ts=node;ts._children=children;var t=doDescrimination(node);t&&ts.patchType(t);var children=this.process(node,childrenToAdopt);ts._children=children}finally{this.shouldDescriminate=!1}}if(node.definition().hasUnionInHierarchy()&&node.parent()&&node.property().nameId()==universes.Universe10.LibraryBase.properties.annotations.name){var optins=getAllOptions(node.definition().unionInHierarchy()),actualResult=null,bestResult=null,bestType=null,bestCount=1e3,llnode=node;if(optins.forEach(function(x){if(!actualResult&&!x.hasUnionInHierarchy()){llnode.patchType(x);if(0==ad){ad++;try{for(var result=_this.process(node,childrenToAdopt),uc=0,i=0;i<result.length;i++)result[i].isUnknown()&&uc++;0==uc&&(actualResult=result),bestCount>uc&&(bestCount=uc,bestResult=result,bestType=x)}finally{ad--}}}}),actualResult)return llnode.patchType(bestType),actualResult;bestResult&&llnode.patchType(bestType)}var km=new KeyMatcher(node.definition().allProperties());if(null==node.parent()||node.lowLevel().includePath()){var u=node.definition().universe();"RAML10"==u.version()&&(node.definition().property("uses")||u.type("FragmentDeclaration").allProperties().forEach(function(x){return km.add(x)}))}var aNode=node,allowsQuestion=aNode._allowQuestion||node.definition().getAdapter(services.RAMLService).getAllowQuestion(),res=[];if(km.parentKey){if(node.lowLevel().key()){var keyAttr=new hlimpl.ASTPropImpl(node.lowLevel(),node,km.parentKey.range(),km.parentKey,!0);res.push(keyAttr);var isDefaultMediaType=node.property()&&universeHelpers.isBodyProperty(node.property())&&node.lowLevel().key()==node.property().nameId();if(isDefaultMediaType){var isInsideTraitOrResourceType=isInTtraitOrResourceType(aNode);!isInsideTraitOrResourceType&&aNode._computedKey&&keyAttr.overrideValue(aNode._computedKey)}}if(node.lowLevel().valueKind()===yaml.Kind.SEQ){var error=new hlimpl.BasicASTNode(node.lowLevel(),aNode);return error.errorMessage=""+node.definition().nameId()+" definition should be a map",res.push(error),res}}if(null!=node.lowLevel().value(!0))if(km.parentValue)res.push(new hlimpl.ASTPropImpl(node.lowLevel(),node,km.parentValue.range(),km.parentValue));else if(km.canBeValue){var s=node.lowLevel().value();null==s&&(s=node.lowLevel().value(!0)),"string"==typeof s&&s.trim().length>0&&res.push(new hlimpl.ASTPropImpl(node.lowLevel(),node,km.canBeValue.range(),km.canBeValue))}if(aNode._children=res,aNode.definition().getAdapter(services.RAMLService).isUserDefined())res=this.processChildren(childrenToAdopt,aNode,res,allowsQuestion,km);else if(aNode.definition().key()==universes.Universe08.Api||aNode.definition().key()==universes.Universe10.Api){var uses=childrenToAdopt.filter(function(x){return"uses"==x.key()});res=this.processChildren(uses,aNode,res,allowsQuestion,km);var types=childrenToAdopt.filter(function(x){return"types"==x.key()});res=this.processChildren(types,aNode,res,allowsQuestion,km);var other=childrenToAdopt.filter(function(x){return"types"!=x.key()&&"uses"!=x.key()});res=this.processChildren(other,aNode,res,allowsQuestion,km)}else res=this.processChildren(childrenToAdopt,aNode,res,allowsQuestion,km);return aNode._children=res,res}finally{}},BasicNodeBuilder.prototype.isTypeDeclarationShortcut=function(node,property){var isTypeDeclarationType=universeHelpers.isTypeProperty(property),isTypeDeclaration=node.definition()&&universeHelpers.isTypeDeclarationTypeOrDescendant(node.definition());return isTypeDeclaration&&isTypeDeclarationType&&node.lowLevel()&&node.lowLevel().valueKind()===yaml.Kind.SEQ?!0:!1},BasicNodeBuilder.prototype.processChildren=function(childrenToAdopt,aNode,res,allowsQuestion,km){var _this=this,typeDeclarationName=universes.Universe10.TypeDeclaration.name,typePropertyName=universes.Universe10.TypeDeclaration.properties.type.name;return aNode.definition()&&aNode.definition().isAssignableFrom(typeDeclarationName)&&aNode.lowLevel()&&km.canBeValue&&km.canBeValue.nameId()===typePropertyName&&aNode.lowLevel()._node&&aNode.lowLevel()._node.value&&aNode.lowLevel()._node.value.kind===yaml.Kind.SEQ?(childrenToAdopt.forEach(function(child){var property=new hlimpl.ASTPropImpl(child,aNode,km.canBeValue.range(),km.canBeValue);res.push(property)}),res):(childrenToAdopt.forEach(function(x){if(km.canBeValue&&_this.isTypeDeclarationShortcut(aNode,km.canBeValue))return void res.push(new hlimpl.ASTPropImpl(x,aNode,km.canBeValue.range(),km.canBeValue));var key=x.key(),p=null!=key?km.match(key):null;if(null!=p){var range=p.range();if(p.isAnnotation()&&"annotations"!=key){var pi=new hlimpl.ASTPropImpl(x,aNode,range,p);return void res.push(pi)}var um=!1,multyValue=p.isMultiValue();if(range.isArray()?(multyValue=!0,range=range.array().componentType(),um=!0):range.hasArrayInHierarchy()&&(multyValue=!0,um=!0),range.hasValueTypeInHierarchy()){var ch=x.children(),seq=x.valueKind()==yaml.Kind.SEQ;if((seq&&ch.length>0||ch.length>1)&&multyValue)if(ch.length>1&&universeHelpers.isTypeDeclarationSibling(aNode.definition())&&universeHelpers.isTypeProperty(p)&&x.valueKind()!=yaml.Kind.SEQ){var pi=new hlimpl.ASTPropImpl(x,aNode,range,p);res.push(pi),aNode.setComputed(p.nameId(),pi)}else{var values=[];ch.forEach(function(y){var pi=new hlimpl.ASTPropImpl(y,aNode,range,p);res.push(pi),values.push(y.value())}),p.isInherited()&&aNode.setComputed(p.nameId(),values)}else{p.isInherited()&&aNode.setComputed(p.nameId(),x.value());var attrNode=new hlimpl.ASTPropImpl(x,aNode,range,p);if(seq||x.valueKind()==yaml.Kind.MAP){var rng=p.range().nameId();p.getAdapter(services.RAMLPropertyService).isExampleProperty()||("StringType"==rng&&(rng="string"),"NumberType"==rng&&(rng="number"),"BooleanType"==rng&&(rng="boolean"),("string"==rng||"number"==rng||"boolean"==rng)&&(x.isAnnotatedScalar()||(attrNode.errorMessage="property '"+p.groupName()+"' must be a "+rng,0==x.children().length&&"enum"==p.groupName()&&(attrNode.errorMessage="enum is empty",x.valueKind()==yaml.Kind.MAP&&(attrNode.errorMessage="the value of enum must be an array")))))}res.push(attrNode)}return}var rs=[];if(aNode._children=res,null!=x.value()&&("string"==typeof x.value()||"boolean"==typeof x.value()||"number"==typeof x.value())&&(""+x.value()).trim().length>0){var c=p.range();if(!c.allProperties().some(function(x){var srv=x;return srv?srv.canBeValue()&&srv.isFromParentValue():!1})){var bnode=new hlimpl.BasicASTNode(x,aNode);bnode.getLowLevelEnd=function(){return-1},bnode.getLowLevelStart=function(){return-1},bnode.knownProperty=p,res.push(bnode)}}if(p.isMerged()){var node=new hlimpl.ASTNodeImpl(x,aNode,range,p);node._allowQuestion=allowsQuestion,rs.push(node)}else if(multyValue)if(p.getAdapter(services.RAMLPropertyService).isEmbedMap()){var chld=x.children(),newChld=[],hasSequenceComposition=!1;if(chld.forEach(function(n){n.kind()==yaml.Kind.INCLUDE_REF&&"RAML08"==aNode.universe().version()?n.children().forEach(function(y){var node=new hlimpl.ASTNodeImpl(y,aNode,range,p);node._allowQuestion=allowsQuestion,rs.push(node),hasSequenceComposition=!0}):newChld.push(n)}),chld=newChld,0==chld.length){if(p.range().key()==universes.Universe08.ResourceType&&!hasSequenceComposition){var error=new hlimpl.BasicASTNode(x,aNode);error.errorMessage="property: '"+p.nameId()+"' must be a map",res.push(error)}if(x.valueKind()==yaml.Kind.SCALAR&&p.range().key()==universes.Universe08.AbstractSecurityScheme){var error=new hlimpl.BasicASTNode(x.parent(),aNode);error.errorMessage="property: '"+p.nameId()+"' must be a map",res.push(error)}}var exit=!1;chld.forEach(function(y){if(!exit){var cld=y.children();if(y.key()||1!=cld.length)if("RAML10"==aNode.universe().version()){var node=new hlimpl.ASTNodeImpl(y,aNode,range,p);node._allowQuestion=allowsQuestion,rs.push(node)}else{var bnode=new hlimpl.BasicASTNode(y,aNode);res.push(bnode),y.key()&&(bnode.needSequence=!0)}else if("RAML10"!=aNode.universe().version()||aNode.parent()){var node=new hlimpl.ASTNodeImpl(cld[0],aNode,range,p);node._allowQuestion=allowsQuestion,rs.push(node)}else{var bnode=new hlimpl.BasicASTNode(x,aNode);res.push(bnode),bnode.needMap=!0,bnode.knownProperty=p,exit=!0}}})}else{var filter={},inherited=[];if(range instanceof defs.NodeClass){var nc=range;nc.getAdapter(services.RAMLService).getCanInherit().length>0&&nc.getAdapter(services.RAMLService).getCanInherit().forEach(function(v){for(var originalValue=aNode.computedValue(v),actualValue=Array.isArray(originalValue)?originalValue:[originalValue],pos=0;pos<actualValue.length;pos++){var vl=actualValue[pos];if(vl&&p.nameId()==universes.Universe10.Response.properties.body.name){for(var exists=_.find(x.children(),function(x){return x.key()==vl}),originalParent=x;originalParent.originalNode;)originalParent=originalParent.originalNode();var mediaTypeSibling=_.find(originalParent.children(),function(sibling){try{return mediaTypeParser.parse(sibling.key()),!0}catch(exception){return!1}});if(!mediaTypeSibling){var pc=aNode.parent().definition().key(),node=new hlimpl.ASTNodeImpl(x,aNode,range,p);node._computedKey=vl,(pc==universes.Universe10.MethodBase||pc==universes.Universe08.MethodBase)&&node.setComputed("form","true");var isInsideTraitOrResourceType=isInTtraitOrResourceType(aNode),t=descriminate(p,aNode,node);t&&(isInsideTraitOrResourceType||t.setName(vl),node.patchType(t));var ch=node.children();node._children=ch.filter(function(x){return!x.isUnknown()}),node._allowQuestion=allowsQuestion,exists||inherited.push(node),node.children().forEach(function(x){if(x.property().getAdapter(services.RAMLPropertyService).isKey()){var atr=x;return void(atr._computed=!0)}if(x.isElement()&&(x.property().getAdapter(services.RAMLPropertyService).isMerged()||(filter[x.property().nameId()]=!0)),x.property().isAnnotation()){var atr=x,vl=atr.value(),strVal="";strVal=vl instanceof hlimpl.StructuredValue?vl.valueName():""+vl,filter["("+strVal+")"]=!0}else filter[x.name()]=!0});var ap=node.definition().allProperties();ap.forEach(function(p){p.getAdapter(services.RAMLPropertyService).isKey()||p.getAdapter(services.RAMLPropertyService).isSystem()||node.lowLevel().children().some(function(x){
return x.key()==p.nameId()})&&(filter[p.nameId()]=!0)}),node._computed=!0}}}})}var parsed=[];if(0==x.children().length&&x.valueKind()==yaml.Kind.SEQ&&p.range().key()==universes.Universe08.Parameter){var error=new hlimpl.BasicASTNode(x,aNode);error.errorMessage="property: '"+p.nameId()+"' must be a map",res.push(error)}if("documentation"===p.nameId()&&x.valueKind()!==yaml.Kind.SEQ){if(!aNode.definition().getAdapter(services.RAMLService).isUserDefined()){var error=new hlimpl.BasicASTNode(x,aNode);error.errorMessage="property: '"+p.nameId()+"' should be a sequence",res.push(error)}}else x.children().forEach(function(y){if(!filter[y.key()])if(y.valueKind()==yaml.Kind.SEQ){var isRaml1="RAML10"==aNode.definition().universe().version();if(y.children().forEach(function(z){var node=new hlimpl.ASTNodeImpl(z,aNode,range,p);node._allowQuestion=allowsQuestion,node.setNamePatch(y.key()),isRaml1&&(node.invalidSequence=!0),parsed.push(node)}),0==y.children().length){var error=new hlimpl.BasicASTNode(y,aNode);p.range().key()==universes.Universe08.Parameter?error.errorMessage="named parameter needs at least one type":error.errorMessage="node should have at least one member value",res.push(error)}}else{var node=new hlimpl.ASTNodeImpl(y,aNode,range,p),dc=p.domain().key();"body"!=p.nameId()||dc!=universes.Universe08.MethodBase&&dc!=universes.Universe10.MethodBase||node.setComputed("form","true"),node._allowQuestion=allowsQuestion,parsed.push(node)}});parsed.length>0?parsed.forEach(function(x){return rs.push(x)}):inherited.forEach(function(x){return rs.push(x)})}else rs.push(new hlimpl.ASTNodeImpl(x,aNode,range,p));aNode._children=aNode._children.concat(rs),res=res.concat(rs),rs.forEach(function(x){var rt=descriminate(p,aNode,x);rt&&rt!=x.definition()&&x.patchType(rt),x._associatedDef=null,p.childRestrictions().forEach(function(y){x.setComputed(y.name,y.value)});x.definition()})}else x instanceof proxy.LowLevelCompositeNode&&null==x.primaryNode()||res.push(new hlimpl.BasicASTNode(x,aNode))}),res)},BasicNodeBuilder}();exports.BasicNodeBuilder=BasicNodeBuilder,exports.doDescrimination=doDescrimination;var isInTtraitOrResourceType=function(aNode){for(var isInsideTraitOrResourceType=!1,parent_=aNode;parent_;){var pDef=parent_.definition();if(universeHelpers.isTraitType(pDef)||universeHelpers.isResourceTypeType(pDef)){isInsideTraitOrResourceType=!0;break}parent_=parent_.parent()}return isInsideTraitOrResourceType}},function(module,exports,__webpack_require__){"use strict";function buildXHR(){return new XMLHttpRequestWrapper}function copyNode(n){if(null==n)return null;switch(n.kind){case yaml.Kind.SCALAR:return{errors:[],startPosition:n.startPosition,endPosition:n.endPosition,value:n.value,kind:yaml.Kind.SCALAR,parent:n.parent};case yaml.Kind.MAPPING:var map=n;return{errors:[],key:copyNode(map.key),value:copyNode(map.value),startPosition:map.startPosition,endPosition:map.endPosition,kind:yaml.Kind.MAPPING,parent:map.parent};case yaml.Kind.MAP:var ymap=n;return{errors:[],startPosition:n.startPosition,endPosition:n.endPosition,mappings:ymap.mappings.map(function(x){return copyNode(x)}),kind:yaml.Kind.MAP,parent:ymap.parent}}return n}function splitOnLines(text){var lines=text.match(/^.*((\r\n|\n|\r)|$)/gm);return lines}function stripIndent(text,indent){for(var lines=splitOnLines(text),rs=[],i=0;i<lines.length;i++)0==i?rs.push(lines[0]):rs.push(lines[i].substring(indent.length));return rs.join("")}function indent(line){for(var rs="",i=0;i<line.length;i++){var c=line[i];if("\r"!=c&&"\n"!=c){if(" "!=c&&"	"!=c)break;rs+=c}}return rs}function breaksTheLine(oc,textCommand){var oldText=oc.substr(textCommand.offset,textCommand.replacementLength);return-1!=oldText.indexOf("\n")?!0:-1!=textCommand.text.indexOf("\n")?!0:void 0}function tryParseScalar(q){if("null"==q)q=null;else if("~"==q)q=null;else if("true"==q)q=!0;else if("false"==q)q=!1;else{var vl=parseFloat(q);isNaN(vl)||(""+q).match("^[-+]?[0-9]*\\.?[0-9]+$")&&(q=vl)}return q}function createNode(key,parent,unit){var node=yaml.newMapping(yaml.newScalar(key),yaml.newMap());return new ASTNode(node,unit,parent,null,null)}function createMap(mappings){var node=yaml.newMap(mappings);return new ASTNode(node,null,null,null,null)}function createScalar(value){var node=yaml.newScalar(value);return new ASTNode(node,null,null,null,null)}function createSeq(sn,parent,unit){return new ASTNode(sn,unit,parent,null,null)}function createSeqNode(key){var node=yaml.newMapping(yaml.newScalar(key),yaml.newItems());return new ASTNode(node,null,null,null,null)}function createMapNode(key){var node=yaml.newMapping(yaml.newScalar(key),yaml.newMap());return new ASTNode(node,null,null,null,null)}function createMapping(key,v){var node=yaml.newMapping(yaml.newScalar(key),yaml.newScalar(v));return new ASTNode(node,null,null,null,null)}function toChildCachingNode(node){if(!(node instanceof ASTNode))return null;var astNode=node,result=new ASTNode(astNode.yamlNode(),astNode.unit(),null,null,null,!0);return result._errors=astNode._errors,result}function toIncludingNode(node){if(!(node instanceof ASTNode))return null;var astNode=node,result=new ASTNode(astNode.yamlNode(),astNode.unit(),null,null,null,!1);return result._errors=astNode._errors,result}function getDefinitionForLowLevelNode(node){var hl=node.highLevelNode();if(hl)return hl.definition();var parent=node.parent();if(!parent)return null;var key=node.key();if(!key)return null;var parentDef=parent.nodeDefinition();if(!parentDef)return null;if(!parentDef.property)return null;var prop=parentDef.property(key);return prop?prop.range():null}function fetchMasterReference(unit,map,errors,lMap){if(unit.isOverlayOrExtension()){var masterReferenceNode=unit.getMasterReferenceNode();if(masterReferenceNode){var masterReferenceText=masterReferenceNode.value();if(masterReferenceText){var unitPath=path.dirname(unit.absolutePath()),absIncludePath=lowlevel.toAbsolutePath(unitPath,masterReferenceText);if(!map[absIncludePath]){if(errors[absIncludePath])return void masterReferenceNode.errors().push(new Error(errors[masterReferenceText]));var arr=lMap[absIncludePath];arr||(arr=[],lMap[absIncludePath]=arr),arr.push(masterReferenceNode)}}}}}function fetchIncludesAndMasterAsync(project,apiPath){var map={},errors={},units=[],processUnits=function(ind){for(var refs=[],lMap={};ind<units.length;){var unit=units[ind],unitPath=unit.absolutePath();fetchMasterReference(unit,map,errors,lMap);var includeNodes=unit.getIncludeNodes();includeNodes.forEach(function(x){var ip=x.includePath();if(ip){var includeReference=refResolvers.getIncludeReference(ip);if(includeReference)return void refs.push(project.resolveAsync(unit.absolutePath(),ip));if(ip){var absIncludePath=lowlevel.buildPath(ip,unitPath,project.getRootPath());if(!map[absIncludePath]){if(errors[absIncludePath]&&x.errors)return void x.errors().push(new Error(errors[ip]));var arr=lMap[absIncludePath];arr||(arr=[],lMap[absIncludePath]=arr),arr.push(x)}}}}),ind++}var unitPaths=Object.keys(lMap);if(0==refs.length&&0==unitPaths.length)return Promise.resolve();var promises=refs;return unitPaths.forEach(function(unitPath){promises.push(project.unitAsync(unitPath,!0).then(function(x){map[x.absolutePath()]||(map[x.absolutePath()]=!0,units.push(x))},function(x){var innerError=project.pathToUnit[unitPath];lMap[unitPath].forEach(function(node){innerError||node.errors&&node.errors().push(new Error(x))}),errors[unitPath]=x,project.failedUnits[unitPath]=x,innerError&&(x.inner=!0)}))}),Promise.all(promises).then(function(x){return processUnits(ind)})};return project.unitAsync(apiPath).then(function(x){return units.push(x),map[x.absolutePath()]=!0,processUnits(0)}).then(function(x){return units.length>0?units[0]:null})}var lowlevel=__webpack_require__(11),path=__webpack_require__(15),fs=__webpack_require__(38),yaml=__webpack_require__(74),_=__webpack_require__(65),textutil=__webpack_require__(42),hli=__webpack_require__(16),services=__webpack_require__(34),rr=__webpack_require__(29),util=__webpack_require__(32),refResolvers=__webpack_require__(30),schemes=__webpack_require__(54),universes=__webpack_require__(18),expander=__webpack_require__(25),namespaceResolver=__webpack_require__(50),Error=yaml.YAMLException;exports.Kind={SCALAR:yaml.Kind.SCALAR};var MarkupIndentingBuffer=function(){function MarkupIndentingBuffer(indent){this.text="",this.indent=indent}return MarkupIndentingBuffer.prototype.isLastNL=function(){return this.text.length>0&&"\n"==this.text[this.text.length-1]},MarkupIndentingBuffer.prototype.addWithIndent=function(lev,s){this.isLastNL()&&(this.text+=textutil.indent(lev),this.text+=this.indent),this.text+=s},MarkupIndentingBuffer.prototype.addChar=function(ch){this.isLastNL()&&(this.text+=this.indent),this.text+=ch},MarkupIndentingBuffer.prototype.append=function(s){for(var i=0;i<s.length;i++)this.addChar(s[i])},MarkupIndentingBuffer}();exports.MarkupIndentingBuffer=MarkupIndentingBuffer;var CompilationUnit=function(){function CompilationUnit(_path,_content,_tl,_project,_apath){this._path=_path,this._content=_content,this._tl=_tl,this._project=_project,this._apath=_apath,this._includedByPaths=[],this._path=null!=this._path?this._path.replace(/\\/g,"/"):null}return CompilationUnit.prototype.highLevel=function(){return this._hl?this._hl:(this._hl=hli.fromUnit(this),this._hl)},CompilationUnit.prototype.isStubUnit=function(){return this.stu},CompilationUnit.prototype.resolveAsync=function(p){var unit=this._project.resolveAsync(this._path,p);return unit},CompilationUnit.prototype.getIncludeNodes=function(){var ast=this.ast(),arr=[];return null==ast?[]:(ast.gatherIncludes(arr),ast.children().forEach(function(x){"uses"==x.key()&&x.children().forEach(function(y){arr.push({includePath:function(){var val=y.value();return"string"!=typeof val?null:val}})})}),arr)},CompilationUnit.prototype.cloneToProject=function(p){var newUnit=new CompilationUnit(this._path,this._content,this._tl,p,this._apath);return newUnit},CompilationUnit.prototype.clone=function(){var newUnit=new CompilationUnit(this._path,this._content,this._tl,this.project(),this._apath);return newUnit},CompilationUnit.prototype.stub=function(){var newUnit=new CompilationUnit(this._path,this._content,this._tl,this.project(),this._apath);return newUnit.stu=!0,newUnit},CompilationUnit.prototype.isDirty=function(){return!1},CompilationUnit.prototype.expandedHighLevel=function(){if(this.expanded)return this.expanded;var result=this.highLevel().asElement(),nm=expander.expandTraitsAndResourceTypes(result.wrapperNode()),hlnode=nm.highLevel();return hlnode._expanded=!0,this.expanded=hlnode,hlnode},CompilationUnit.prototype.absolutePath=function(){return this._apath},CompilationUnit.prototype.isRAMLUnit=function(){var en=path.extname(this._path);return".raml"==en||".yaml"==en||".yml"==en},CompilationUnit.prototype.contents=function(){return this._content},CompilationUnit.prototype.resolve=function(p){"string"!=typeof p&&(p=""+p);var unit=this._project.resolve(this._path,p);return unit},CompilationUnit.prototype.path=function(){return this._path},CompilationUnit.prototype.lexerErrors=function(){return null==this.errors&&this.ast(),this.errors},CompilationUnit.prototype.ast=function(){var _this=this;if(this._node)return this._node;try{var result=yaml.load(this._content,{});return this.errors=result.errors,this.errors.forEach(function(x){x.mark&&(x.mark.filePath=_this.absolutePath())}),this._node=new ASTNode(result,this,null,null,null),this._node._errors=this.errors,this._node}catch(e){return this.errors=[],this.errors.push(new Error(e.message)),this._node=null,this._node}},CompilationUnit.prototype.isTopLevel=function(){return this._tl},CompilationUnit.prototype.updateContent=function(n){this._content=n,this.errors=null,this._node=null,this._lineMapper=null},CompilationUnit.prototype.updateContentSafe=function(n){this._content=n,this._lineMapper=null,this._hl=null},CompilationUnit.prototype.project=function(){return this._project},CompilationUnit.prototype.lineMapper=function(){return null==this._lineMapper&&(this._lineMapper=new lowlevel.LineMapperImpl(this.contents(),this.absolutePath())),this._lineMapper},CompilationUnit.prototype.isOverlayOrExtension=function(){for(var contents=this.contents(),spec="",ptype=null,num=0,pt=0,n=0;n<contents.length;n++){var c=contents.charAt(n);if("\r"==c||"\n"==c){spec?ptype=contents.substring(pt,n).trim():spec=contents.substring(0,n).trim();break}" "==c&&(num++,spec||2!=num||(spec=contents.substring(0,n),pt=n))}return"Extension"==ptype||"Overlay"==ptype},CompilationUnit.prototype.getMasterReferenceNode=function(){return _.find(this.ast().children(),function(x){return x.key()==universes.Universe10.Overlay.properties["extends"].name})},CompilationUnit.prototype.addIncludedBy=function(path){this.includedByContains(path)||this._includedByPaths.push(path)},CompilationUnit.prototype.includedByContains=function(path){return null!=_.find(this._includedByPaths,function(currentPath){return currentPath==path})},CompilationUnit.prototype.getIncludedByPaths=function(){return this._includedByPaths},CompilationUnit}();exports.CompilationUnit=CompilationUnit;var XhrSync=__webpack_require__(60).XMLHttpRequest,XhrAsync=__webpack_require__(60).XMLHttpRequest,XMLHttpRequestWrapper=function(){function XMLHttpRequestWrapper(){}return XMLHttpRequestWrapper.prototype.open=function(method,url,async){this.xhr=async?new XhrAsync:new XhrSync,this.async=async,this.xhr.open(method,url,async)},XMLHttpRequestWrapper.prototype.setRequestHeader=function(name,value){this.xhr.setRequestHeader(name,value)},XMLHttpRequestWrapper.prototype.getResponseHeader=function(name){return this.xhr.getResponseHeader(name)},XMLHttpRequestWrapper.prototype.getAllResponseHeaders=function(){return this.xhr.getAllResponseHeaders()},XMLHttpRequestWrapper.prototype.send=function(content){var _this=this;this.xhr.onload=function(){return _this.onResponse(!1)},this.xhr.onerror=function(){return _this.onResponse(!0)},this.xhr.send(content)},XMLHttpRequestWrapper.prototype.onResponse=function(isError){return this.statusText=this.xhr.statusText,this.responseText=this.xhr.responseText,this.responseType=this.xhr.responseType,this.status=this.xhr.status,isError&&this.onerror?void this.onerror():void(this.onload&&this.onload())},XMLHttpRequestWrapper}();exports.XMLHttpRequestWrapper=XMLHttpRequestWrapper,exports.buildXHR=buildXHR;var SimpleExecutor=function(){function SimpleExecutor(){}return SimpleExecutor.prototype.execute=function(req,doAppendParams){void 0===doAppendParams&&(doAppendParams=!0);var xhr=buildXHR(),url=req.url;doAppendParams&&(url=this.appendParams(req,req.url)),xhr.open(req.method,url,!1),this.doRequest(req,xhr);var status=xhr.status;if(status>300&&400>status){var locHeader=xhr.getResponseHeader("location");if(locHeader)return req.url=locHeader,this.execute(req,!1)}var response={status:status,statusText:xhr.statusText,headers:xhr.getAllResponseHeaders().split("\n").map(function(x){var ind=x.indexOf(":");return{name:x.substring(0,ind).trim(),value:x.substring(ind+1).trim()}}),content:{text:xhr.responseText,mimeType:xhr.responseType}};return response},SimpleExecutor.prototype.appendParams=function(req,url){var gotQueryParams=req.queryString&&req.queryString.length>0;if(gotQueryParams){url+="?";var arr=[];gotQueryParams&&(arr=arr.concat(req.queryString.map(function(q){return encodeURIComponent(q.name)+"="+encodeURIComponent(q.value)}))),url+=arr.join("&")}return url},SimpleExecutor.prototype.log=function(varName,value){},SimpleExecutor.prototype.executeAsync=function(req,doAppendParams){void 0===doAppendParams&&(doAppendParams=!0);var xhr=buildXHR(),url=req.url;doAppendParams&&(url=this.appendParams(req,req.url));var outer=this;return new Promise(function(resolve,reject){xhr.open(req.method,url,!0),xhr.onload=function(){var status=xhr.status,response={status:status,statusText:xhr.statusText,headers:xhr.getAllResponseHeaders().split("\n").map(function(x){var ind=x.indexOf(":");return{name:x.substring(0,ind).trim(),value:x.substring(ind+1).trim()}}),content:{text:xhr.responseText,mimeType:xhr.responseType}};resolve(response)},xhr.onerror=function(){reject(new Error("Network Error"))},outer.doRequest(req,xhr)})},SimpleExecutor.prototype.doRequest=function(req,xhr){if(req.headers&&req.headers.forEach(function(x){return xhr.setRequestHeader(x.name,x.value)}),req.postData)if(req.postData.params){var body=req.postData.params.map(function(p){return encodeURIComponent(p.name)+"="+encodeURIComponent(p.value)}).join("&");xhr.send(body)}else xhr.send(req.postData.text);else xhr.send()},SimpleExecutor}();exports.SimpleExecutor=SimpleExecutor;var HTTPResolverImpl=function(){function HTTPResolverImpl(){this.executor=new SimpleExecutor}return HTTPResolverImpl.prototype.getResource=function(url){if("undefined"!=typeof atom&&null!=atom){var cached=rr.get(url);if(cached)return cached;rr.addNotify(url);try{var resultWithCallback={content:""};return this.getResourceAsync(url).then(function(x){try{x.errorMessage?rr.set(url,{content:null,errorMessage:null}):(x.errorMessage=null,rr.set(url,x))}finally{resultWithCallback.callback&&resultWithCallback.callback(rr.get(url)),rr.removeNotity(url)}},function(e){rr.set(url,{content:null,errorMessage:null}),resultWithCallback.callback&&resultWithCallback.callback(rr.get(url)),rr.removeNotity(url)}),resultWithCallback}catch(e){console.log("Error"),console.log(e)}}var response=this.executor.execute({method:"get",url:url});if(!response)throw new Error("Unable to execute GET "+url);var result=this.toResponse(response,url);return result},HTTPResolverImpl.prototype.getResourceAsync=function(url){var _this=this;return this.executor.executeAsync({method:"get",url:url}).then(function(x){if(!x)return Promise.reject(new Error("Unable to execute GET "+url));var result=_this.toResponse(x,url);return result},function(x){return Promise.reject(new Error("Unable to execute GET "+url))})},HTTPResolverImpl.prototype.toResponse=function(response,url){var msg=null;response.status>=400&&(msg="GET "+url+"\nreturned error: "+response.status,response.statusText&&(msg+=" "+response.statusText));var content=null;response.content&&response.content.text&&(content=response.content.text);var result={content:content,errorMessage:msg};return result},HTTPResolverImpl}();exports.HTTPResolverImpl=HTTPResolverImpl;var FSResolverImpl=function(){function FSResolverImpl(){}return FSResolverImpl.prototype.content=function(path){if("string"!=typeof path&&(path=""+path),!fs.existsSync(path))return null;try{return fs.readFileSync(path).toString()}catch(e){return null}},FSResolverImpl.prototype.list=function(path){return fs.readdirSync(path)},FSResolverImpl.prototype.contentAsync=function(path){return new Promise(function(resolve,reject){fs.readFile(path,function(err,data){if(null!=err)return reject(err);var content=data.toString();resolve(content)})})},FSResolverImpl.prototype.listAsync=function(path){return new Promise(function(reject,resolve){fs.readdir(path,function(err,files){return null!=err?reject(err):void resolve(files)})})},FSResolverImpl}();exports.FSResolverImpl=FSResolverImpl;var innerShift=function(offset,yaNode,shift){if(yaNode&&(yaNode.startPosition>=offset&&(yaNode.startPosition+=shift),yaNode.endPosition>offset&&(yaNode.endPosition+=shift),yaNode.kind==yaml.Kind.MAPPING)){var m=yaNode;innerShift(offset,m.key,shift),innerShift(offset,m.value,shift)}},leadingIndent=function(node,text){for(var leading="",pos=node.start()-1;pos>0;){var ch=text[pos];if(" "!=ch&&"-"!=ch)break;leading=" "+leading,pos--}return leading},Project=function(){function Project(rootPath,resolver,_httpResolver){this.rootPath=rootPath,this.resolver=resolver,this._httpResolver=_httpResolver,this.listeners=[],this.tlisteners=[],this.pathToUnit={},this.failedUnits={},this._fsEnabled=!0,this._namespaceResolver=new namespaceResolver.NamespaceResolver,null==this.resolver?this.resolver=new FSResolverImpl:this._fsEnabled=!1,null==this._httpResolver&&(this._httpResolver=new HTTPResolverImpl)}return Project.prototype.getRootPath=function(){return this.rootPath},Project.prototype.fsEnabled=function(){return this._fsEnabled},Project.prototype.cloneWithResolver=function(newResolver,httpResolver){void 0===httpResolver&&(httpResolver=null);var newProject=new Project(this.rootPath,newResolver,httpResolver?httpResolver:this._httpResolver);for(var unitPath in this.pathToUnit)newProject.pathToUnit[unitPath]=this.pathToUnit[unitPath].cloneToProject(newProject);return newProject},Project.prototype.setCachedUnitContent=function(pth,cnt,tl){void 0===tl&&(tl=!0);var relPath=pth,apath=lowlevel.toAbsolutePath(this.rootPath,pth),unit=new CompilationUnit(relPath,cnt,tl,this,apath);return this.pathToUnit[apath]=unit,unit},Project.prototype.resolveAsync=function(unitPath,pathInUnit){var _this=this;if(!pathInUnit)return Promise.reject(new Error("Unit path is null"));var includeReference=refResolvers.getIncludeReference(pathInUnit),oldPath=pathInUnit;includeReference&&(pathInUnit=includeReference.getIncludePath());var absPath=lowlevel.buildPath(pathInUnit,unitPath,this.rootPath);if(includeReference){var result,refPath=lowlevel.toAbsolutePath(path.dirname(lowlevel.toAbsolutePath(this.rootPath,unitPath)),includeReference.encodedName());this.pathToUnit[absPath]?Promise.resolve(result).then(function(unit){return _this.pathToUnit[refPath]=new CompilationUnit(includeReference.encodedName(),refResolvers.resolveContents(oldPath,_this.pathToUnit[absPath].contents()),!1,_this,refPath),_this.pathToUnit[refPath]}):this.unitAsync(absPath,!0).then(function(unit){return _this.pathToUnit[absPath]=unit,_this.pathToUnit[refPath]=new CompilationUnit(includeReference.encodedName(),refResolvers.resolveContents(oldPath,_this.pathToUnit[absPath].contents()),!1,_this,refPath),_this.pathToUnit[refPath]})}return this.unitAsync(absPath,!0)},Project.prototype.resolve=function(unitPath,pathInUnit){if(!pathInUnit)return null;pathInUnit=pathInUnit.replace(/\\/g,"/");var includeReference=refResolvers.getIncludeReference(pathInUnit),oldPath=pathInUnit;includeReference&&(pathInUnit=includeReference.getIncludePath());var absPath=lowlevel.buildPath(pathInUnit,unitPath,this.rootPath);if(includeReference){this.pathToUnit[absPath]||(this.pathToUnit[absPath]=this.unit(absPath,!0));var wrappedUnit=this.pathToUnit[absPath],refPath=lowlevel.toAbsolutePath(path.dirname(lowlevel.toAbsolutePath(this.rootPath,unitPath)),includeReference.encodedName());return this.pathToUnit[refPath]?this.pathToUnit[refPath]:(this.pathToUnit[refPath]=new CompilationUnit(includeReference.encodedName(),refResolvers.resolveContents(oldPath,wrappedUnit&&wrappedUnit.contents()),!1,this,refPath),this.pathToUnit[refPath])}return this.unit(absPath,!0)},Project.prototype.units=function(){var _this=this;if(!this.resolver.list)throw new Error("Provided FSResolver is unable to list files. Please, use ExtendedFSResolver.");var names=this.resolver.list(this.rootPath).filter(function(x){return".raml"==path.extname(x)});return names.map(function(x){return _this.unit(x)}).filter(function(y){return y.isTopLevel()})},Project.prototype.unitsAsync=function(){var _this=this;return this.resolver.listAsync?this.resolver.listAsync(this.rootPath).then(function(x){var promises=x.filter(function(x){return".raml"==path.extname(x)}).map(function(x){return _this.unitAsync(x).then(function(x){return x.isTopLevel()?x:null},function(x){return null})});return Promise.all(promises).then(function(arr){return arr.filter(function(x){return null!=x})})}):Promise.reject(new Error("Provided FSResolver is unable to list files. Please, use ExtendedFSResolver."))},Project.prototype.lexerErrors=function(){var results=[];return this.units().forEach(function(x){results=results.concat(x.lexerErrors())}),results},Project.prototype.deleteUnit=function(p,absolute){void 0===absolute&&(absolute=!1);var apath=null;apath=lowlevel.isWebPath(p)?p:absolute?p:lowlevel.toAbsolutePath(this.rootPath,p),delete this.pathToUnit[apath]},Project.prototype.unit=function(p,absolute){if(void 0===absolute&&(absolute=!1),absolute||lowlevel.isWebPath(p)){if(null!=this.failedUnits[p]&&!this.failedUnits[p].inner)return null}else{var ap=lowlevel.toAbsolutePath(this.rootPath,p);if(this.failedUnits[ap]&&!this.failedUnits[p].inner)return null}var response,cnt=null,apath=p;if(lowlevel.isWebPath(p)){if(this.pathToUnit[apath])return this.pathToUnit[apath];if(this._httpResolver){if(response=this._httpResolver.getResource(p),response&&response.errorMessage)throw new Error(response.errorMessage);cnt=response?response.content:null}else response=(new HTTPResolverImpl).getResource(apath),cnt=response?response.content:null}else{"/"!=p.charAt(0)||absolute||(p=p.substr(1));var apath=lowlevel.toAbsolutePath(this.rootPath,p);if(this.pathToUnit[apath])return this.pathToUnit[apath];if(lowlevel.isWebPath(apath))if(this._httpResolver){var resp=this._httpResolver.getResource(apath);if(resp&&resp.errorMessage)throw new Error(resp.errorMessage);cnt=resp?resp.content:null}else{var resourceResponse=(new HTTPResolverImpl).getResource(apath);cnt=resourceResponse?resourceResponse.content:null}else cnt=this.resolver.content(apath)}if(null==cnt)return null;var tl=util.stringStartsWith(cnt,"#%RAML"),relPath=lowlevel.isWebPath(this.rootPath)==lowlevel.isWebPath(apath)?path.relative(this.rootPath,apath):apath,unit=new CompilationUnit(relPath,cnt,tl,this,apath);return this.pathToUnit[apath]=unit,response&&(response.callback=function(contentHolder){unit.updateContent(contentHolder&&contentHolder.content)}),unit},Project.prototype.unitAsync=function(p,absolute){var _this=this;void 0===absolute&&(absolute=!1);var cnt=null,apath=p;if(lowlevel.isWebPath(p)){if(this.pathToUnit[apath])return Promise.resolve(this.pathToUnit[apath]);if(this._httpResolver){var resp=this._httpResolver.getResourceAsync(apath);cnt=resp.then(function(x){return x.errorMessage?Promise.reject(new Error(x.errorMessage)):x.content})}else cnt=(new HTTPResolverImpl).getResourceAsync(apath)}else{if("/"!=p.charAt(0)||absolute||(p=p.substr(1)),apath=absolute?p:lowlevel.toAbsolutePath(this.rootPath,p),this.pathToUnit[apath])return Promise.resolve(this.pathToUnit[apath]);if(lowlevel.isWebPath(apath))if(this._httpResolver){var resp=this._httpResolver.getResourceAsync(apath);cnt=resp.then(function(x){return x.errorMessage?Promise.reject(new Error(x.errorMessage)):x.content})}else cnt=(new HTTPResolverImpl).getResourceAsync(apath);else cnt=this.resolver.contentAsync(apath)}if(null==cnt)return Promise.resolve(null);var relPath=lowlevel.isWebPath(this.rootPath)==lowlevel.isWebPath(apath)?path.relative(this.rootPath,apath):apath;return cnt.then(function(x){if(null==x)return Promise.reject(new Error("Can note resolve "+apath));var tl=util.stringStartsWith(x,"#%RAML"),unit=new CompilationUnit(relPath,x,tl,_this,apath);return _this.pathToUnit[apath]=unit,unit},function(err){return"object"==typeof err&&err instanceof Error?Promise.reject(err):Promise.reject(new Error(err.toString()))}).then(function(unit){return unit.isRAMLUnit()?unit:schemes.isScheme(unit.contents())?schemes.startDownloadingReferencesAsync(unit.contents(),unit):unit})},Project.prototype.visualizeNewlines=function(s){for(var res="",i=0;i<s.length;i++){var ch=s[i];"\r"==ch&&(ch="\\r"),"\n"==ch&&(ch="\\n"),res+=ch}return res},Project.prototype.indent=function(node){var text=node.unit().contents();if(node==node.root())return"";var leading=leadingIndent(node,text),dmp=splitOnLines(node.dump());if(dmp.length>1&&dmp[1].trim().length>0){var extra=indent(dmp[1]);return leading+extra}return leading+"  "},Project.prototype.startIndent=function(node){node.unit().contents();if(node==node.root())return"";var dmp=splitOnLines(node.dump());if(dmp.length>0){console.log("FIRST: "+dmp[0]);var extra=indent(dmp[0]);return extra+"  "}return""},Project.prototype.canWriteInOneLine=function(node){return!1},Project.prototype.isOneLine=function(node){return node.text().indexOf("\n")<0},Project.prototype.recalcPositionsUp=function(target){for(var np=target;np;)np.recalcEndPositionFromChilds(),np=np.parent()},Project.prototype.add2=function(target,node,toSeq,ipoint,json){void 0===json&&(json=!1);var unit=target.unit(),point=(target.root(),null);if(ipoint&&(ipoint instanceof ASTNode&&(point=ipoint),ipoint instanceof InsertionPoint&&(point=ipoint.point)),target.isValueInclude()){var childs=target.children();if(0==childs.length)throw new Error("not implemented: insert into empty include ref");var parent=childs[0].parent();return void this.add2(parent,node,toSeq,point,json)}var unitText=(new textutil.TextRange(unit.contents(),node.start(),node.end()),new textutil.TextRange(unit.contents(),target.start(),target.end()),target.unit().contents());target.valueKind()==yaml.Kind.SEQ&&(target=createSeq(target.valueAsSeq(),target,target.unit()));var json=this.isJson(target),originalIndent=json?"":this.indent(target.isSeq()?target.parent():target),xindent=originalIndent,indentLength=originalIndent.length,isTargetSeq=target.isSeq()||target.isMapping()&&(target.isValueSeq()||target.isValueScalar()||!target.asMapping().value);toSeq=toSeq,toSeq&&(json||isTargetSeq&&(xindent+="  ",indentLength+=2));var buf=new MarkupIndentingBuffer(xindent);node.markupNode(buf,node._actualNode(),0,json);var text=buf.text;if(toSeq){var trimText=textutil.trimEnd(text),trimLen=text.length-trimText.length;if(trimLen>0){var textlen=text.length;text=text.substring(0,textlen-trimLen),node.shiftNodes(textlen-trimLen,-trimLen)}}toSeq&&!json?(node.highLevelNode(),target.isMapping(),text=target.isSeq()||target.isMapping()&&(target.isValueSeq()||target.isValueScalar()||!target.asMapping().value)?originalIndent+"- "+text:originalIndent+text):text=originalIndent+text;var pos=target.end();if(point)point!=target?pos=point.end():json&&toSeq||(pos=target.keyEnd()+1,pos=new textutil.TextRange(unitText,pos,pos).extendAnyUntilNewLines().endpos());else if(json&&toSeq){var seq=target.asSeq();seq&&(pos=seq.items.length>0?seq.items[seq.items.length-1].endPosition:seq.endPosition-1)}else if(ipoint&&ipoint instanceof InsertionPoint){var ip=ipoint;ip.type==InsertionPointType.START&&(pos=target.keyEnd()+1,pos=new textutil.TextRange(unitText,pos,pos).extendAnyUntilNewLines().endpos())}var insertionRange=new textutil.TextRange(unitText,0,pos);if(pos=insertionRange.extendToNewlines().reduceSpaces().endpos(),json&&target.isSeq()){var seq=target.asSeq();seq.items.length>0&&(text=", "+text,indentLength+=2)}else pos>0&&"\n"!=unitText[pos-1]&&(text="\n"+text,indentLength++);var suffixLen=0;toSeq&&!json&&(text+="\n",suffixLen++);var newtext=unitText.substring(0,pos)+text+unitText.substring(pos,unitText.length),cu=unit;if(cu.updateContentSafe(newtext),this.executeReplace(new textutil.TextRange(unitText,pos,pos),text,cu),target.root().shiftNodes(pos,indentLength+(node.end()-node.start())+suffixLen),point){for(var childs=target.children(),index=-1,i=0;i<childs.length;i++){var x=childs[i];if(x.start()==point.start()&&x.end()==point.end()){index=i;break}}index>=0?target.addChild(node,index+1):target.addChild(node)}else target.addChild(node);node.shiftNodes(0,pos+indentLength),this.recalcPositionsUp(target),node.setUnit(target.unit()),node.visit(function(n){var node=n;return node.setUnit(target.unit()),!0})},Project.prototype.isJsonMap=function(node){if(!node.isMap())return!1;var text=node.text().trim();return text.length>=2&&"{"==text[0]&&"}"==text[text.length-1]},Project.prototype.isJsonSeq=function(node){if(!node.isSeq())return!1;var text=node.text().trim();return text.length>=2&&"["==text[0]&&"]"==text[text.length-1]},Project.prototype.isJson=function(node){return this.isJsonMap(node)||this.isJsonSeq(node)},Project.prototype.remove=function(unit,target,node){var parent=node.parent();if(node._oldText=node.dump(),this.isOneLine(node)&&node.isMapping()&&node.parent().isMap()){var mapnode=node.parent();if(1==mapnode.asMap().mappings.length&&null!=mapnode.parent())return void this.remove(unit,mapnode.parent(),mapnode)}if(this.isOneLine(node)&&node.isScalar()&&node.parent().isSeq()){
var seqnode=node.parent(),seqn=seqnode.asSeq();if(1==seqn.items.length)return void this.remove(unit,seqnode.parent(),seqnode)}if(target.isMapping()&&node.isSeq()){var map=target.parent();return void this.remove(unit,map,target)}var range=new textutil.TextRange(unit.contents(),node.start(),node.end()),originalStartPos=(new textutil.TextRange(unit.contents(),target.start(),target.end()),new textutil.TextRange(unit.contents(),parent.start(),parent.end()),range.startpos());if(target.isSeq()){var seq=node.isSeq()?node:node.parentOfKind(yaml.Kind.SEQ);range=seq&&this.isJson(seq)?range.extendSpaces().extendCharIfAny(",").extendSpaces():range.extendToStartOfLine().extendAnyUntilNewLines().extendToNewlines()}target.isMap()&&(range=range.trimEnd().extendAnyUntilNewLines().extendToNewlines(),range=range.extendToStartOfLine().extendUntilNewlinesBack()),target.kind()==yaml.Kind.MAPPING&&(this.isJson(node)&&this.isOneLine(node)||(range=range.extendSpacesUntilNewLines(),range=range.extendToNewlines(),range=range.extendToStartOfLine().extendUntilNewlinesBack())),node.isSeq()&&(range=range.reduceSpaces());var cu=unit;cu.updateContentSafe(range.remove()),this.executeReplace(range,"",cu),node.parent().removeChild(node);var shift=-range.len();target.root().shiftNodes(originalStartPos,shift),this.recalcPositionsUp(target)},Project.prototype.changeKey=function(unit,attr,newval){var range=new textutil.TextRange(attr.unit().contents(),attr.keyStart(),attr.keyEnd());if(attr.kind()==yaml.Kind.MAPPING){var sc=attr._actualNode().key;sc.value=newval,sc.endPosition=sc.startPosition+newval.length}var cu=unit;this.executeReplace(range,newval,cu);var shift=newval.length-range.len();attr.root().shiftNodes(range.startpos(),shift,attr),this.recalcPositionsUp(attr)},Project.prototype.executeReplace=function(r,txt,unit){var command=new lowlevel.TextChangeCommand(r.startpos(),r.endpos()-r.startpos(),txt,unit);unit.project();try{this.tlisteners.forEach(function(x){return x(command)})}catch(e){return!1}var newtext=r.replace(txt);return unit.updateContentSafe(newtext),!0},Project.prototype.changeValue=function(unit,attr,newval){var newNodeText,range=new textutil.TextRange(attr.unit().contents(),attr.start(),attr.end()),prefix=0,delta=0,replacer=null,mapping=null;if(attr.kind()==yaml.Kind.SCALAR){if("string"!=typeof newval)throw new Error("not implemented");attr.asScalar().value=newval,newNodeText=newval}else if(attr.kind()==yaml.Kind.MAPPING){if(mapping=attr.asMapping(),attr.isValueInclude()){var inc=attr.valueAsInclude(),includeString=inc.value,includePath=includeString,resolved=attr.unit().resolve(includePath);if(null==resolved)return void console.log("attr.setValue: couldn't resolve: "+includePath);if(resolved.isRAMLUnit())return;return void(refResolvers.getIncludeReference(includeString)||resolved.updateContent(newval))}if(range=mapping.value?range.withStart(attr.valueStart()).withEnd(attr.valueEnd()):range.withStart(attr.keyEnd()+1).withEnd(attr.keyEnd()+1),range=range.reduceNewlinesEnd(),null==newval)newNodeText="",mapping.value=null;else if("string"==typeof newval||null==newval){var newstr=newval,ind=this.indent(attr);if(newstr&&textutil.isMultiLine(newstr)&&(newstr=""+textutil.makeMutiLine(newstr,ind.length/2)),newNodeText=newstr,mapping.value){if(mapping.value.kind==yaml.Kind.SEQ){console.log("seq value");mapping.value.items[0];throw"assign value!!!"}if(mapping.value.kind==yaml.Kind.SCALAR){var sc=mapping.value,oldtext=sc.value||"";sc.value=newstr,mapping.value.endPosition=mapping.value.startPosition+newstr.length,mapping.endPosition=mapping.value.endPosition,delta+=newstr.length-oldtext.length}}else if(console.log("no value"),mapping.value=yaml.newScalar(newstr),mapping.value.startPosition=attr.keyEnd()+1,mapping.value.endPosition=mapping.value.startPosition+newstr.length,mapping.endPosition=mapping.value.endPosition,unit.contents().length>attr.keyEnd()+1){var vlPos=attr.keyEnd()+1;":"==unit.contents()[vlPos-1]&&(newNodeText=" "+newNodeText,mapping.value.startPosition++,mapping.value.endPosition++,mapping.endPosition++,delta++)}}else{var n=newval;if(n.isMapping())newval=createMap([n.asMapping()]),n=newval;else if(!n.isMap())throw new Error("only MAP/MAPPING nodes allowed as values");var buf=new MarkupIndentingBuffer("");n.markupNode(buf,n._actualNode(),0,!0),newNodeText=""+buf.text,n.shiftNodes(0,range.startpos()+delta),replacer=n}}else console.log("Unsupported change value case: "+attr.kindName());var cu=unit;this.executeReplace(range,newNodeText,cu);var shift=newNodeText.length-range.len();attr.root().shiftNodes(range.endpos()+prefix,shift,attr),replacer&&(mapping.value=replacer._actualNode()),this.recalcPositionsUp(attr)},Project.prototype.initWithRoot=function(root,newroot){var shift=root.end();newroot.markup(!1),newroot._actualNode().startPosition=shift,newroot._actualNode().endPosition=shift,newroot.setUnit(root.unit())},Project.prototype.execute=function(cmd){var _this=this;cmd.commands.forEach(function(x){switch(x.kind){case lowlevel.CommandKind.CHANGE_VALUE:var attr=x.target,curval=attr.value();curval||(curval="");var newval=x.value;if(console.log("set value: "+typeof curval+" ==> "+typeof newval),"string"!=typeof curval&&"number"!=typeof curval&&"boolean"!=typeof curval||"string"!=typeof newval)if("string"!=typeof curval&&"number"!=typeof curval&&"boolean"!=typeof curval||"string"==typeof newval)if("string"!=typeof curval&&"string"==typeof newval){var newstr=x.value;if(curval.kind()!=yaml.Kind.MAPPING)throw new Error("unsupported case: attribute value conversion: "+typeof curval+" ==> "+typeof newval+" not supported");textutil.isMultiLine(newstr)?(attr.children().forEach(function(n){_this.remove(attr.unit(),attr,n)}),_this.changeValue(attr.unit(),attr,newstr)):_this.changeKey(attr.unit(),curval,newstr)}else{if("string"==typeof curval||"string"==typeof newval)throw new Error("shouldn't be this case: attribute value conversion "+typeof curval+" ==> "+typeof newval+" not supported");var newvalnode=newval;if(newvalnode.isMapping()&&(newval=createMap([newvalnode.asMapping()])),curval==newval)break;var node=newval;node.asMap();attr.children().forEach(function(n){_this.remove(attr.unit(),attr,n)}),node.children().forEach(function(m){}),_this.changeValue(attr.unit(),attr,newval)}else _this.changeValue(attr.unit(),attr,newval);else curval!=newval&&_this.changeValue(attr.unit(),attr,newval);return;case lowlevel.CommandKind.CHANGE_KEY:var attr=x.target;return void _this.changeKey(attr.unit(),attr,x.value);case lowlevel.CommandKind.ADD_CHILD:var attr=x.target,newValueNode=x.value;return void _this.add2(attr,newValueNode,x.toSeq,x.insertionPoint);case lowlevel.CommandKind.REMOVE_CHILD:var target=x.target,node=x.value;return void _this.remove(target.unit(),target,node);case lowlevel.CommandKind.INIT_RAML_FILE:var root=x.target,newroot=x.value;return void _this.initWithRoot(root,newroot);default:return void console.log("UNSUPPORTED COMMAND: "+lowlevel.CommandKind[x.kind])}})},Project.prototype.replaceYamlNode=function(target,newNodeContent,offset,shift,unit){var newYamlNode=yaml.load(newNodeContent,{});this.updatePositions(target.start(),newYamlNode),target.root().shiftNodes(offset,shift);var targetParent=target.parent(),targetYamlNode=target._actualNode(),parent=targetYamlNode.parent;if(newYamlNode.parent=parent,targetParent&&targetParent.kind()==yaml.Kind.MAP){var targetParentMapNode=targetParent._actualNode();targetParentMapNode.mappings=targetParentMapNode.mappings.map(function(x){return x!=targetYamlNode?x:newYamlNode})}target.updateFrom(newYamlNode),this.recalcPositionsUp(target)},Project.prototype.executeTextChange2=function(textCommand){var cu=textCommand.unit,unitText=cu.contents(),target=textCommand.target;if(target){var cnt=unitText.substring(target.start(),target.end());unitText=unitText.substr(0,textCommand.offset)+textCommand.text+unitText.substr(textCommand.offset+textCommand.replacementLength);var newNodeContent=cnt.substr(0,textCommand.offset-target.start())+textCommand.text+cnt.substr(textCommand.offset-target.start()+textCommand.replacementLength);if(cu.updateContentSafe(unitText),textCommand.offset>target.start())try{var shift=textCommand.text.length-textCommand.replacementLength,offset=textCommand.offset;target.unit().project().replaceYamlNode(target,newNodeContent,offset,shift,textCommand.unit)}catch(e){console.log("New node contents (causes error below): \n"+newNodeContent),console.log("Reparse error: "+e.stack)}}else unitText=unitText.substr(0,textCommand.offset)+textCommand.text+unitText.substr(textCommand.offset+textCommand.replacementLength);cu.updateContent(unitText),this.listeners.forEach(function(x){x(null)}),this.tlisteners.forEach(function(x){x(textCommand)})},Project.prototype.executeTextChange=function(textCommand){(new Date).getTime();try{var oc=textCommand.unit.contents(),target=textCommand.target;null==target&&(target=this.findNode(textCommand.unit.ast(),textCommand.offset,textCommand.offset+textCommand.replacementLength));var cu=textCommand.unit;if(target){var cnt=oc.substring(target.start(),target.end()),original=oc;oc=oc.substr(0,textCommand.offset)+textCommand.text+oc.substr(textCommand.offset+textCommand.replacementLength);var newNodeContent=cnt.substr(0,textCommand.offset-target.start())+textCommand.text+cnt.substr(textCommand.offset-target.start()+textCommand.replacementLength);cu.updateContentSafe(oc);breaksTheLine(original,textCommand);if(textCommand.offset>target.start())try{var newYamlNode=yaml.load(newNodeContent,{});this.updatePositions(target.start(),newYamlNode);var shift=textCommand.text.length-textCommand.replacementLength;if(textCommand.unit.ast().shiftNodes(textCommand.offset,shift),null!=newYamlNode&&newYamlNode.kind==yaml.Kind.MAP){var actualResult=newYamlNode.mappings[0],targetYamlNode=target._actualNode(),parent=targetYamlNode.parent,cmd=new lowlevel.ASTDelta,unit=textCommand.unit;if(cmd.commands=[new lowlevel.ASTChangeCommand(lowlevel.CommandKind.CHANGE_VALUE,new ASTNode(copyNode(targetYamlNode),unit,null,null,null),new ASTNode(actualResult,unit,null,null,null),0)],parent&&parent.kind==yaml.Kind.MAP){var map=parent;map.mappings=map.mappings.map(function(x){return x!=targetYamlNode?x:actualResult})}return actualResult.parent=parent,this.recalcPositionsUp(target),target.updateFrom(actualResult),this.listeners.forEach(function(x){x(cmd)}),void this.tlisteners.forEach(function(x){x(textCommand)})}}catch(e){console.log("New node contents (causes error below): \n"+newNodeContent),console.log("Reparse error: "+e.stack)}}else oc=oc.substr(0,textCommand.offset)+textCommand.text+oc.substr(textCommand.offset+textCommand.replacementLength);(new Date).getTime();cu.updateContent(oc),this.listeners.forEach(function(x){x(null)}),this.tlisteners.forEach(function(x){x(textCommand)})}finally{(new Date).getTime()}},Project.prototype.updatePositions=function(offset,n){var _this=this;if(null!=n)switch(-1==n.startPosition?n.startPosition=offset:n.startPosition=offset+n.startPosition,n.endPosition=offset+n.endPosition,n.kind){case yaml.Kind.MAP:var m=n;m.mappings.forEach(function(x){return _this.updatePositions(offset,x)});break;case yaml.Kind.MAPPING:var ma=n;this.updatePositions(offset,ma.key),this.updatePositions(offset,ma.value);break;case yaml.Kind.SCALAR:break;case yaml.Kind.SEQ:var s=n;s.items.forEach(function(x){return _this.updatePositions(offset,x)})}},Project.prototype.findNode=function(n,offset,end){var _this=this;if(null==n)return null;var node=n;if(n.start()<=offset&&n.end()>=end){var res=n;return node.directChildren().forEach(function(x){var m=_this.findNode(x,offset,end);m&&(res=m)}),res}return null},Project.prototype.addTextChangeListener=function(listener){this.tlisteners.push(listener)},Project.prototype.removeTextChangeListener=function(listener){this.tlisteners=this.tlisteners.filter(function(x){return x!=listener})},Project.prototype.addListener=function(listener){this.listeners.push(listener)},Project.prototype.removeListener=function(listener){this.listeners=this.listeners.filter(function(x){return x!=listener})},Project.prototype.namespaceResolver=function(){return this._namespaceResolver},Project}();exports.Project=Project;var ASTNode=function(){function ASTNode(_node,_unit,_parent,_anchor,_include,cacheChildren,_includesContents){void 0===cacheChildren&&(cacheChildren=!1),void 0===_includesContents&&(_includesContents=!1),this._node=_node,this._unit=_unit,this._parent=_parent,this._anchor=_anchor,this._include=_include,this.cacheChildren=cacheChildren,this._includesContents=_includesContents,this._errors=[],null==_node&&console.log("null")}return ASTNode.prototype.actual=function(){return this._node},ASTNode.prototype.yamlNode=function(){return this._node},ASTNode.prototype.includesContents=function(){return this._includesContents},ASTNode.prototype.setIncludesContents=function(includesContents){this._includesContents=includesContents},ASTNode.prototype.gatherIncludes=function(s,inc,anc,inOneMemberMap){var _this=this;if(void 0===s&&(s=[]),void 0===inc&&(inc=null),void 0===anc&&(anc=null),void 0===inOneMemberMap&&(inOneMemberMap=!0),null!=this._node){var kind=this._node.kind;if(kind!=yaml.Kind.SCALAR)if(kind==yaml.Kind.MAP){var map=this._node;1!=map.mappings.length||inOneMemberMap?map.mappings.map(function(x){return new ASTNode(x,_this._unit,_this,anc?anc:_this._anchor,inc?inc:_this._include,_this.cacheChildren)}).forEach(function(x){return x.gatherIncludes(s)}):new ASTNode(map.mappings[0].value,this._unit,this,inc,anc,this.cacheChildren).gatherIncludes(s)}else if(kind==yaml.Kind.MAPPING){var mapping=this._node;null==mapping.value||new ASTNode(mapping.value,this._unit,this,anc?anc:this._anchor,inc?inc:this._include,this.cacheChildren).gatherIncludes(s)}else if(kind==yaml.Kind.SEQ){var seq=this._node;seq.items.filter(function(x){return null!=x}).map(function(x){return new ASTNode(x,_this._unit,_this,anc?anc:_this._anchor,inc?inc:_this._include,_this.cacheChildren)}).forEach(function(x){return x.gatherIncludes(s)})}else kind==yaml.Kind.INCLUDE_REF&&this._unit&&s.push(this);else if(schemes.isScheme(this._node.value)){var references=schemes.getReferences(this._node.value,this.unit());references.forEach(function(reference){var includeNode=yaml.newScalar(reference);includeNode.kind=yaml.Kind.INCLUDE_REF;var includeAST=new ASTNode(includeNode,_this.unit(),null,null,null);s.push(includeAST)})}}},ASTNode.prototype.setHighLevelParseResult=function(highLevelParseResult){this._highLevelParseResult=highLevelParseResult},ASTNode.prototype.highLevelParseResult=function(){return this._highLevelParseResult},ASTNode.prototype.setHighLevelNode=function(highLevel){this._highLevelNode=highLevel},ASTNode.prototype.highLevelNode=function(){return this._highLevelNode},ASTNode.prototype.start=function(){return this._node.startPosition},ASTNode.prototype.errors=function(){return this._errors},ASTNode.prototype.addIncludeError=function(error){if(!_.find(this._errors,function(currentError){return currentError.message==error.message})){var node=this._node;node.includeErrors||(node.includeErrors=[]),_.find(node.includeErrors,function(currentError){return currentError.message==error.message})||(this._errors.push(error),node.includeErrors.push(error))}},ASTNode.prototype.parent=function(){return this._parent},ASTNode.prototype.recalcEndPositionFromChilds=function(){var first=(this.children(),this.children()[0]),last=this.children()[this.children().length-1];if(this.isMapping()){var mapping=this.asMapping();if(mapping.value)if(mapping.value.kind==yaml.Kind.MAP){var map=mapping.value;map.startPosition<0&&first&&(map.startPosition=first.start()),last&&(this._node.endPosition=last._node.endPosition),this._node.endPosition=Math.max(this._node.endPosition,mapping.value.endPosition)}else if(mapping.value.kind==yaml.Kind.SEQ){var seq=mapping.value;if(seq.startPosition<0&&seq.items.length>0){var pos=seq.items[0].startPosition,range=new textutil.TextRange(this.unit().contents(),pos,pos);range=range.extendSpacesBack().extendCharIfAnyBack("-"),seq.startPosition=range.startpos()}if(seq.items.length>0){var ilast=seq.items[seq.items.length-1];this._node.endPosition=Math.max(this._node.endPosition,seq.endPosition,ilast.endPosition),seq.endPosition=Math.max(this._node.endPosition,seq.endPosition,ilast.endPosition)}}else mapping.value.kind==yaml.Kind.SCALAR||last&&(this._node.endPosition=last._node.endPosition)}else last&&(this._node.endPosition=last._node.endPosition)},ASTNode.prototype.isValueLocal=function(){if(this._node.kind==yaml.Kind.MAPPING){var knd=this._node.value.kind;return knd!=yaml.Kind.INCLUDE_REF&&knd!=yaml.Kind.ANCHOR_REF}return!0},ASTNode.prototype.keyStart=function(){return this._node.kind==yaml.Kind.MAPPING?this._node.key.startPosition:-1},ASTNode.prototype.keyEnd=function(){return this._node.kind==yaml.Kind.MAPPING?this._node.key.endPosition:-1},ASTNode.prototype.valueStart=function(){if(this._node.kind==yaml.Kind.MAPPING){var mapping=this.asMapping();return mapping.value?mapping.value.startPosition:mapping.endPosition}return-1},ASTNode.prototype.valueEnd=function(){if(this._node.kind==yaml.Kind.MAPPING){var mapping=this.asMapping();return mapping.value?mapping.value.endPosition:mapping.endPosition}return-1},ASTNode.prototype.end=function(){return this._node.endPosition},ASTNode.prototype.dump=function(){if(this._oldText)return this._oldText;if(this._unit&&this._node.startPosition>0&&this._node.endPosition>0){var originalText=this._unit.contents().substring(this._node.startPosition,this._node.endPosition);return originalText=stripIndent(originalText,leadingIndent(this,this._unit.contents()))}return yaml.dump(this.dumpToObject(),{})},ASTNode.prototype.dumpToObject=function(full){return void 0===full&&(full=!1),this.dumpNode(this._node,full)},ASTNode.prototype.dumpNode=function(n,full){var _this=this;if(void 0===full&&(full=!1),!n)return null;if(n.kind==yaml.Kind.INCLUDE_REF){if(this._unit){var s=n,includePath=s.value,resolved=null;try{resolved=this._unit.resolve(includePath)}catch(Error){}if(null==resolved)return null;if(resolved.isRAMLUnit()&&this.canInclude(resolved)){var currentUnit=this.unit(),resolvedUnit=resolved;resolvedUnit.addIncludedBy(currentUnit.absolutePath()),currentUnit.getIncludedByPaths().forEach(function(includedByPath){resolvedUnit.addIncludedBy(includedByPath)});var ast=resolved.ast();if(ast)return ast.dumpToObject(full)}else if(this.canInclude(resolved))return resolved.contents()}return null}if(n.kind==yaml.Kind.SEQ){var seq=n,arr=[];return seq.items.forEach(function(x){return arr.push(_this.dumpNode(x,full))}),arr}if(n.kind==yaml.Kind.ANCHOR_REF){var aref=n;return this.dumpNode(aref.value,full)}if(n.kind==yaml.Kind.MAPPING){var c=n,v={},val=c.value,mm=this.dumpNode(val,full);return v[""+this.dumpNode(c.key,full)]=mm,v}if(n.kind==yaml.Kind.SCALAR){var s=n,q=s.value;return s.plainScalar&&(q=tryParseScalar(q)),q}if(n.kind==yaml.Kind.MAP){var map=n,res={};return map.mappings&&map.mappings.forEach(function(x){var ms=_this.dumpNode(x.value,full);null==ms&&(ms=full?"!$$$novalue":ms),res[_this.dumpNode(x.key,full)+""]=ms}),res}},ASTNode.prototype.keyKind=function(){return this._node.key?this._node.key.kind:null},ASTNode.prototype._actualNode=function(){return this._node},ASTNode.prototype.execute=function(cmd){this.unit()?this.unit().project().execute(cmd):cmd.commands.forEach(function(x){switch(x.kind){case lowlevel.CommandKind.CHANGE_VALUE:var attr=x.target,newValue=x.value,va=attr._actualNode();attr.start();return void(va.kind==yaml.Kind.MAPPING&&(va.value=yaml.newScalar(""+newValue)));case lowlevel.CommandKind.CHANGE_KEY:var attr=x.target,newValue=x.value,va=attr._actualNode();if(va.kind==yaml.Kind.MAPPING){var sc=va.key;sc.value=newValue}return}})},ASTNode.prototype.updateFrom=function(n){this._node=n},ASTNode.prototype.isAnnotatedScalar=function(){if(this.kind()==yaml.Kind.MAPPING&&this.unit()&&this.valueKind()==yaml.Kind.MAP&&this._node.value.mappings){var isScalar=this._node.value.mappings.length>0;return this._node.value.mappings.forEach(function(x){"value"!==x.key.value&&(x.key.value&&"("==x.key.value.charAt(0)&&")"==x.key.value.charAt(x.key.value.length-1)||(isScalar=!1))}),isScalar}return!1},ASTNode.prototype.value=function(toString){if(!this._node)return"";if(this._node.kind==yaml.Kind.SCALAR){if("~"===this._node.value&&null===this._node.valueObject)return toString?"null":null;if(!toString&&""+this._node.valueObject===this._node.value)return this._node.valueObject;var q=this._node.value;return toString||this._node.plainScalar&&(q=tryParseScalar(q)),q}if(this._node.kind==yaml.Kind.ANCHOR_REF){var ref=this._node;return new ASTNode(ref.value,this._unit,this,null,null).value(toString)}if(this._node.kind==yaml.Kind.MAPPING){var map=this._node;if(null==map.value)return null;if(this.isAnnotatedScalar())for(var child=new ASTNode(map.value,this._unit,this,null,null),ch=child.children(),i=0;i<ch.length;i++)if("value"===ch[i].key())return ch[i].value();return new ASTNode(map.value,this._unit,this,null,null).value(toString)}if(this._node.kind==yaml.Kind.INCLUDE_REF){var includeString=this._node.value,includePath=includeString,resolved=null;try{resolved=this._unit.resolve(includePath)}catch(Error){return"can not resolve "+includePath+" due to: "+Error.message}if(null==resolved)return"can not resolve "+includePath;if(resolved.isRAMLUnit()){var ast=resolved.ast();return ast?ast.value():"can not resolve "+includePath+" due to: file is empty"}var text=resolved.contents();return textutil.isMultiLineValue(text)&&(text=textutil.fromMutiLine(text)),text}if(this._node.kind==yaml.Kind.MAP){var amap=this._node;if(1==amap.mappings.length)return new ASTNode(amap.mappings[0],this._unit,this,null,null)}if(this._node.kind==yaml.Kind.SEQ){var aseq=this._node;if(1==aseq.items.length)return new ASTNode(aseq.items[0],this._unit,this,null,null).value(toString)}return null},ASTNode.prototype.printDetails=function(indent){var result="";indent||(indent="");var typeName=this.kindName();return this.kind()==yaml.Kind.SCALAR?result+=indent+"["+typeName+"] "+this.value()+"\n":this.kind()==yaml.Kind.MAPPING&&this._node.value&&this._node.value.kind==yaml.Kind.SCALAR?result+=indent+"["+typeName+"] "+this.key()+" = "+this.value()+"\n":this.kind()==yaml.Kind.MAPPING?(result+=indent+"["+typeName+"] "+this.key()+" = :\n",this.children().forEach(function(child){result+=child.printDetails(indent+"	")})):(result+=indent+"["+typeName+"] :\n",this.children().forEach(function(child){result+=child.printDetails(indent+"	")})),result},ASTNode.prototype.visit=function(v){this.children().forEach(function(x){v(x)&&x.visit(v)})},ASTNode.prototype.rawKey=function(){if(!this._node)return"";if(this._node.kind==yaml.Kind.MAPPING){var map=this._node;if(map.key.kind==yaml.Kind.SEQ){var items=map.key,mn="[";return items.items.forEach(function(x){return mn+=x.value}),mn+"]"}return map.key.value}if(this._node.kind==yaml.Kind.INCLUDE_REF){var m=this.children();if(1==m.length)return m[0].key()}return null},ASTNode.prototype.key=function(raw){void 0===raw&&(raw=!1);var key=this.rawKey();return raw?key:(null!=key&&util.stringEndsWith(key,"?")&&(key=key.substring(0,key.length-1)),key)},ASTNode.prototype.optional=function(){var key=this.rawKey();return null!=key&&util.stringEndsWith(key,"?")},ASTNode.prototype.addChild=function(n,pos){void 0===pos&&(pos=-1);var node=n;if(node._parent=this,this._oldText=null,this.isMap()){var map=this.asMap();(null==map.mappings||void 0==map.mappings)&&(map.mappings=[]),pos>=0?map.mappings.splice(pos,0,node.asMapping()):map.mappings.push(node.asMapping())}else if(this.isMapping()){var mapping=this.asMapping(),val=mapping.value;if(!mapping.value&&node.isMap())return void(mapping.value=node._actualNode());if(mapping.value&&mapping.value.kind==yaml.Kind.SCALAR&&(mapping.value=null,val=null),val||(val=node.isScalar()||node.highLevelNode()&&node.highLevelNode().property().getAdapter(services.RAMLPropertyParserService).isEmbedMap()?yaml.newSeq():yaml.newMap(),mapping.value=val),val.kind==yaml.Kind.MAP){var map=val;(null==map.mappings||void 0==map.mappings)&&(map.mappings=[]),node.isScalar(),pos>=0?map.mappings.splice(pos,0,node.asMapping()):map.mappings.push(node.asMapping())}else{if(val.kind!=yaml.Kind.SEQ)throw new Error("Insert into mapping with "+yaml.Kind[mapping.value.kind]+" value not supported");var seq=val;pos>=0?seq.items.splice(pos,0,node._actualNode()):seq.items.push(node._actualNode())}}else{if(!this.isSeq())throw new Error("Insert into "+this.kindName()+" not supported");var seq=this.asSeq();pos>=0?seq.items.splice(pos,0,node._actualNode()):seq.items.push(node._actualNode())}},ASTNode.prototype.removeChild=function(n){this._oldText=null;var ynode,index,node=n;if(this.kind()==yaml.Kind.SEQ){var seq=this.asSeq();ynode=node._node,index=seq.items.indexOf(ynode),index>-1&&seq.items.splice(index,1)}else if(this.kind()==yaml.Kind.MAP){var map=this.asMap();ynode=node.asMapping(),index=map.mappings.indexOf(ynode),index>-1&&map.mappings.splice(index,1)}else{if(this.kind()!=yaml.Kind.MAPPING)throw new Error("Delete from "+yaml.Kind[this.kind()]+" unsupported");var mapping=this.asMapping();if(node._actualNode()==mapping.value)mapping.value=null;else{var map=mapping.value;ynode=node.asMapping(),map&&map.mappings&&(index=map.mappings.indexOf(ynode),index>-1&&map.mappings.splice(index,1))}}},ASTNode.prototype.hasInnerIncludeError=function(){return this.innerIncludeErrors},ASTNode.prototype.includeErrors=function(){if(this._node.kind==yaml.Kind.MAPPING){var mapping=this._node;if(null==mapping.value)return[];var node=new ASTNode(mapping.value,this._unit,this,this._anchor,this._include),res=node.includeErrors();return this.innerIncludeErrors=node.hasInnerIncludeError(),res}var rs=[];if(this._node.kind==yaml.Kind.INCLUDE_REF){var mapping=this._node;if(null==mapping.value)return[];var includePath=this.includePath(),resolved=null;try{resolved=this._unit.resolve(includePath)}catch(Error){this.innerIncludeErrors=Error.inner;var s="Can not resolve "+includePath+" due to: "+Error.message;return rs.push(s),rs}var innerIncludeErrors=this._node.includeErrors;if(innerIncludeErrors&&innerIncludeErrors.length>0)return this.innerIncludeErrors=!0,rs=innerIncludeErrors.map(function(innerError){return"object"==typeof innerError&&innerError instanceof Error?innerError.message:innerError.toString()});if(null==resolved)return rs.push("Can not resolve "+includePath),rs;if(resolved.isRAMLUnit()){var ast=resolved.ast();if(ast)return[];rs.push(""+includePath+" can not be parsed")}}return rs},ASTNode.prototype.joinMappingsWithFullIncludeAnchor=function(mappings,inc,anc){var _this=this,fullAnchorMapping=_.find(mappings,function(mapping){return mapping.key&&mapping.value&&mapping.key.kind==yaml.Kind.SCALAR&&"<<"==mapping.key.value&&mapping.value.kind==yaml.Kind.ANCHOR_REF});if(!fullAnchorMapping)return mappings.map(function(x){return new ASTNode(x,_this._unit,_this,anc?anc:_this._anchor,inc?inc:_this._include,_this.cacheChildren)});var filteredMappings=_.filter(mappings,function(mapping){return!(mapping.key.kind==yaml.Kind.SCALAR&&"<<"==mapping.key.value&&mapping.value.kind==yaml.Kind.ANCHOR_REF)}),childrenFromAnchor=new ASTNode(fullAnchorMapping.value,this._unit,this,inc,anc,this.cacheChildren).children(null,null,!0),filteredChildren=filteredMappings.map(function(x){return new ASTNode(x,_this._unit,_this,anc?anc:_this._anchor,inc?inc:_this._include,_this.cacheChildren)});return filteredChildren.concat(childrenFromAnchor)},ASTNode.prototype.children=function(inc,anc,inOneMemberMap){var _this=this;if(void 0===inc&&(inc=null),void 0===anc&&(anc=null),void 0===inOneMemberMap&&(inOneMemberMap=!0),null==this._node)return[];if(this.cacheChildren&&this._children)return this._children;var result,kind=this._node.kind;if(kind==yaml.Kind.SCALAR)result=[];else if(kind==yaml.Kind.MAP){var map=this._node;result=1!=map.mappings.length||inOneMemberMap?this.joinMappingsWithFullIncludeAnchor(map.mappings,inc,anc):new ASTNode(map.mappings[0].value,this._unit,this,inc,anc,this.cacheChildren).children(null,null,!0)}else if(kind==yaml.Kind.MAPPING){var mapping=this._node;if(null==mapping.value)result=[];else{var proxy=new ASTNode(mapping.value,this._unit,this,anc?anc:this._anchor,inc?inc:this._include,this.cacheChildren);result=proxy.children(),proxy.includesContents()&&this.setIncludesContents(!0)}}else if(kind==yaml.Kind.SEQ){var seq=this._node;result=seq.items.filter(function(x){return null!=x}).map(function(x){return new ASTNode(x,_this._unit,_this,anc?anc:_this._anchor,inc?inc:_this._include,_this.cacheChildren)})}else if(kind==yaml.Kind.INCLUDE_REF){if(this._unit){var includePath=this.includePath(),resolved=null;try{resolved=this._unit.resolve(includePath)}catch(Error){}if(null==resolved)result=[];else if(resolved.isRAMLUnit())if(this.canInclude(resolved)){var currentUnit=this.unit(),resolvedUnit=resolved;resolvedUnit.addIncludedBy(currentUnit.absolutePath()),currentUnit.getIncludedByPaths().forEach(function(includedByPath){resolvedUnit.addIncludedBy(includedByPath)});var ast=resolved.ast();ast&&(this.cacheChildren&&(ast=toChildCachingNode(ast)),result=resolved.ast().children(this,null),this.setIncludesContents(!0))}else this.addIncludeError&&this.addIncludeError(new Error("Recursive definition"))}result||(result=[])}else{if(kind!=yaml.Kind.ANCHOR_REF)throw new Error("Should never happen; kind : "+yaml.Kind[this._node.kind]);var ref=this._node;result=new ASTNode(ref.value,this._unit,this,null,null,this.cacheChildren).children()}return this.cacheChildren&&(this._children=result),result},ASTNode.prototype.canInclude=function(unit){for(var includedFrom=this.includedFrom();null!=includedFrom;){if(includedFrom.unit().absolutePath()==unit.absolutePath())return!1;includedFrom=includedFrom.includedFrom()}return!this.unit().includedByContains(unit.absolutePath())},ASTNode.prototype.directChildren=function(inc,anc,inOneMemberMap){var _this=this;if(void 0===inc&&(inc=null),void 0===anc&&(anc=null),void 0===inOneMemberMap&&(inOneMemberMap=!0),this._node){switch(this._node.kind){case yaml.Kind.SCALAR:return[];case yaml.Kind.MAP:var map=this._node;return 1!=map.mappings.length||inOneMemberMap?map.mappings.map(function(x){return new ASTNode(x,_this._unit,_this,anc?anc:_this._anchor,inc?inc:_this._include)}):new ASTNode(map.mappings[0].value,this._unit,this,inc,anc).directChildren(null,null,!0);case yaml.Kind.MAPPING:var mapping=this._node;return null==mapping.value?[]:new ASTNode(mapping.value,this._unit,this,anc?anc:this._anchor,inc?inc:this._include).directChildren();case yaml.Kind.SEQ:var seq=this._node;return seq.items.filter(function(x){return null!=x}).map(function(x){return new ASTNode(x,_this._unit,_this,anc?anc:_this._anchor,inc?inc:_this._include)});case yaml.Kind.INCLUDE_REF:return[];case yaml.Kind.ANCHOR_REF:return[]}throw new Error("Should never happen; kind : "+yaml.Kind[this._node.kind])}return[]},ASTNode.prototype.anchorId=function(){return this._node.anchorId},ASTNode.prototype.unit=function(){return this._unit},ASTNode.prototype.includeBaseUnit=function(){return this._unit},ASTNode.prototype.setUnit=function(unit){this._unit=unit},ASTNode.prototype.includePath=function(){var includeString=this.getIncludeString();return includeString?includeString:null},ASTNode.prototype.includeReference=function(){var includeString=this.getIncludeString();return includeString?refResolvers.getIncludeReference(includeString):null},ASTNode.prototype.getIncludeString=function(){if(this._node.kind==yaml.Kind.INCLUDE_REF){var includePath=this._node.value;return includePath}if(this._node.kind==yaml.Kind.MAPPING){var mapping=this._node;return null==mapping.value?null:new ASTNode(mapping.value,this._unit,this,null,null).getIncludeString()}return null},ASTNode.prototype.anchoredFrom=function(){return this._anchor},ASTNode.prototype.includedFrom=function(){return this._include},ASTNode.prototype.kind=function(){return this._actualNode().kind},ASTNode.prototype.valueKind=function(){
if(this._node.kind!=yaml.Kind.MAPPING)return null;var map=this._node;return map.value?map.value.kind:null},ASTNode.prototype.anchorValueKind=function(){if(this.valueKind()==yaml.Kind.ANCHOR_REF){var ref=this._node.value;return ref.value.kind}return null},ASTNode.prototype.valueKindName=function(){var kind=this.valueKind();return void 0!=kind?yaml.Kind[kind]:null},ASTNode.prototype.kindName=function(){return yaml.Kind[this.kind()]},ASTNode.prototype.indent=function(lev,str){void 0===str&&(str="");for(var leading="",i=0;lev>i;i++)leading+="  ";return leading+str},ASTNode.prototype.replaceNewlines=function(s,rep){void 0===rep&&(rep=null);for(var res="",i=0;i<s.length;i++){var ch=s[i];"\r"==ch&&(ch=null==rep?"\\r":rep),"\n"==ch&&(ch=null==rep?"\\n":rep),res+=ch}return res},ASTNode.prototype.shortText=function(unittext,maxlen){void 0===maxlen&&(maxlen=50);var elen=this.end()-this.start(),len=elen,unit=this.unit();!unittext&&unit&&(unittext=unit.contents());var text;if(unittext){var s=unittext;text=s?s.substring(this.start(),this.end()):"[no-text]"}else text="[no-unit]";return text="["+this.start()+".."+this.end()+"] "+elen+" // "+text+" //",elen>len&&(text+="..."),text=this.replaceNewlines(text)},ASTNode.prototype.nodeShortText=function(node,unittext,maxlen){void 0===maxlen&&(maxlen=50);var elen=node.endPosition-node.startPosition,len=elen,unit=this.unit();!unittext&&unit&&(unittext=unit.contents());var text;if(unittext){var s=unittext;text=s?s.substring(node.startPosition,node.endPosition):"[no-text]"}else text="[no-unit]";return text="["+node.startPosition+".."+node.endPosition+"] "+elen+" // "+text+" //",elen>len&&(text+="..."),text=this.replaceNewlines(text)},ASTNode.prototype.show=function(message,lev,text){void 0===message&&(message=null),void 0===lev&&(lev=0),void 0===text&&(text=null),message&&0==lev&&console.log(message);var children=this.children(),desc=this.kindName(),val=this._actualNode().value;this.kind()==yaml.Kind.MAPPING&&(desc+="["+this._actualNode().key.value+"]"),desc+=val?"/"+yaml.Kind[val.kind]:"",0==children.length?(console.log(this.indent(lev)+desc+" // "+this.shortText(text)),this.isMapping()&&this.asMapping().value&&console.log(this.indent(lev+1)+"// "+this.valueKindName()+": "+this.nodeShortText(this.asMapping().value,text))):(console.log(this.indent(lev)+desc+" { // "+this.shortText(text)),this.isMapping()&&this.asMapping().value&&console.log(this.indent(lev+1)+"// "+this.valueKindName()+": "+this.nodeShortText(this.asMapping().value,text)),children.forEach(function(node){var n=node;n.show(null,lev+1,text)}),console.log(this.indent(lev)+"}"))},ASTNode.prototype.showParents=function(message,lev){void 0===lev&&(lev=0),message&&0==lev&&console.log(message);var depth=0;if(this.parent()){var n=this.parent();depth=n.showParents(null,lev+1)}var desc=this.kindName(),val=this._actualNode().value;return desc+=val?"/"+yaml.Kind[val.kind]:"/null",console.log(this.indent(depth)+desc+" // "+this.shortText(null)),depth+1},ASTNode.prototype.inlined=function(kind){return kind==yaml.Kind.SCALAR||kind==yaml.Kind.INCLUDE_REF},ASTNode.prototype.markupNode=function(xbuf,node,lev,json){void 0===json&&(json=!1);var start=xbuf.text.length;switch(node.kind){case yaml.Kind.MAP:json&&xbuf.append("{");for(var mappings=node.mappings,i=0;i<mappings.length;i++)json&&i>0&&xbuf.append(", "),this.markupNode(xbuf,mappings[i],lev,json);json&&xbuf.append("}");break;case yaml.Kind.SEQ:for(var items=node.items,i=0;i<items.length;i++)xbuf.append(this.indent(lev,"- ")),this.markupNode(xbuf,items[i],lev+1,json);break;case yaml.Kind.MAPPING:var mapping=node,val=mapping.value;if(json){if(!val){xbuf.append("\n");break}if(xbuf.append(mapping.key.value),xbuf.append(": "),val.kind==yaml.Kind.SCALAR){var sc=val;xbuf.append(sc.value)}else{if(val.kind!=yaml.Kind.MAP)throw new Error("markup not implemented: "+yaml.Kind[val.kind]);this.markupNode(xbuf,mapping.value,lev+1,json)}break}if(xbuf.addWithIndent(lev,mapping.key.value+":"),!val){xbuf.append("\n");break}if(val.kind==yaml.Kind.SCALAR)var sc=val;mapping.value?(xbuf.append(this.inlined(mapping.value.kind)?" ":"\n"),this.markupNode(xbuf,mapping.value,lev+1,json)):xbuf.append("\n");break;case yaml.Kind.SCALAR:var sc=node;if(textutil.isMultiLine(sc.value)){xbuf.append("|\n");for(var lines=splitOnLines(sc.value),i=0;i<lines.length;i++)xbuf.append(this.indent(lev,lines[i]));xbuf.append("\n")}else xbuf.append(sc.value+"\n");break;case yaml.Kind.INCLUDE_REF:var ref=node;xbuf.append("!include "+ref.value+"\n");break;default:throw new Error("Unknown node kind: "+yaml.Kind[node.kind])}for(;start<xbuf.text.length&&" "==xbuf.text[start];)start++;node.startPosition=start,node.endPosition=xbuf.text.length},ASTNode.prototype.markup=function(json){void 0===json&&(json=!1);var buf=new MarkupIndentingBuffer("");return this.markupNode(buf,this._actualNode(),0,json),buf.text},ASTNode.prototype.root=function(){for(var node=this;node.parent();){var p=node.parent();node=p}return node},ASTNode.prototype.parentOfKind=function(kind){for(var p=this.parent();p;){if(p.kind()==kind)return p;p=p.parent()}return null},ASTNode.prototype.find=function(name){var found=null;return this.directChildren().forEach(function(y){y.key()&&y.key()==name&&(found||(found=y))}),found},ASTNode.prototype.shiftNodes=function(offset,shift,exclude){if(this.directChildren().forEach(function(x){if(exclude&&exclude.start()==x.start()&&exclude.end()==x.end());else{x.shiftNodes(offset,shift,exclude)}}),exclude&&exclude.start()==this.start()&&exclude.end()==this.end());else{var yaNode=this._actualNode();yaNode&&innerShift(offset,yaNode,shift)}return null},ASTNode.prototype.isMap=function(){return this.kind()==yaml.Kind.MAP},ASTNode.prototype.isMapping=function(){return this.kind()==yaml.Kind.MAPPING},ASTNode.prototype.isSeq=function(){return this.kind()==yaml.Kind.SEQ},ASTNode.prototype.isScalar=function(){return this.kind()==yaml.Kind.SCALAR},ASTNode.prototype.asMap=function(){if(!this.isMap())throw new Error("map expected instead of "+this.kindName());return this._actualNode()},ASTNode.prototype.asMapping=function(){if(!this.isMapping())throw new Error("maping expected instead of "+this.kindName());return this._actualNode()},ASTNode.prototype.asSeq=function(){if(!this.isSeq())throw new Error("seq expected instead of "+this.kindName());return this._actualNode()},ASTNode.prototype.asScalar=function(){if(!this.isScalar())throw new Error("scalar expected instead of "+this.kindName());return this._actualNode()},ASTNode.prototype.isValueSeq=function(){return this.valueKind()==yaml.Kind.SEQ},ASTNode.prototype.isValueMap=function(){return this.valueKind()==yaml.Kind.MAP},ASTNode.prototype.isValueInclude=function(){return this.valueKind()==yaml.Kind.INCLUDE_REF},ASTNode.prototype.isValueScalar=function(){return this.valueKind()==yaml.Kind.SCALAR},ASTNode.prototype.valueAsSeq=function(){if(!this.isMapping())throw new Error("mapping expected instead of "+this.kindName());if(this.valueKind()!=yaml.Kind.SEQ)throw new Error("mappng/seq expected instead of mapping/"+this.kindName());return this.asMapping().value},ASTNode.prototype.valueAsMap=function(){if(!this.isMapping())throw new Error("mapping expected instead of "+this.kindName());if(this.valueKind()!=yaml.Kind.MAP)throw new Error("mappng/map expected instead of mapping/"+this.kindName());return this.asMapping().value},ASTNode.prototype.valueAsScalar=function(){if(!this.isMapping())throw new Error("mapping expected instead of "+this.kindName());if(this.valueKind()!=yaml.Kind.SCALAR)throw new Error("mappng/scalar expected instead of mapping/"+this.kindName());return this.asMapping().value},ASTNode.prototype.valueAsInclude=function(){if(!this.isMapping())throw new Error("mapping expected instead of "+this.kindName());if(this.valueKind()!=yaml.Kind.INCLUDE_REF)throw new Error("mappng/include expected instead of mapping/"+this.kindName());return this.asMapping().value},ASTNode.prototype.text=function(unitText){if(void 0===unitText&&(unitText=null),!unitText){if(!this.unit())return"[no-text]";unitText=this.unit().contents()}return unitText.substring(this.start(),this.end())},ASTNode.prototype.copy=function(){var yn=copyNode(this._actualNode());return new ASTNode(yn,this._unit,this._parent,this._anchor,this._include,this._includesContents)},ASTNode.prototype.nodeDefinition=function(){return getDefinitionForLowLevelNode(this)},ASTNode}();exports.ASTNode=ASTNode,function(InsertionPointType){InsertionPointType[InsertionPointType.NONE=0]="NONE",InsertionPointType[InsertionPointType.START=1]="START",InsertionPointType[InsertionPointType.END=2]="END",InsertionPointType[InsertionPointType.POINT=3]="POINT"}(exports.InsertionPointType||(exports.InsertionPointType={}));var InsertionPointType=exports.InsertionPointType,InsertionPoint=function(){function InsertionPoint(type,point){void 0===point&&(point=null),this.type=type,this.point=point}return InsertionPoint.after=function(point){return new InsertionPoint(InsertionPointType.POINT,point)},InsertionPoint.atStart=function(){return new InsertionPoint(InsertionPointType.START)},InsertionPoint.atEnd=function(){return new InsertionPoint(InsertionPointType.END)},InsertionPoint.node=function(){return new InsertionPoint(InsertionPointType.NONE)},InsertionPoint.prototype.show=function(msg){msg?(console.log(msg),console.log("  insertion point type: "+InsertionPointType[this.type])):console.log("insertion point type: "+InsertionPointType[this.type]),this.type==InsertionPointType.POINT&&this.point&&this.point.show()},InsertionPoint}();exports.InsertionPoint=InsertionPoint,exports.createNode=createNode,exports.createMap=createMap,exports.createScalar=createScalar,exports.createSeq=createSeq,exports.createSeqNode=createSeqNode,exports.createMapNode=createMapNode,exports.createMapping=createMapping,exports.toChildCachingNode=toChildCachingNode,exports.toIncludingNode=toIncludingNode,exports.getDefinitionForLowLevelNode=getDefinitionForLowLevelNode,exports.fetchIncludesAndMasterAsync=fetchIncludesAndMasterAsync},function(module,exports,__webpack_require__){"use strict";function hasAsyncRequests(){return Object.keys(notifies).length>0}function addLoadCallback(listener){nlisteners.push(listener)}function addNotify(url){notifies[url]=!0}function removeNotity(url){delete notifies[url],nlisteners.forEach(function(x){return x(url)})}function isWaitingFor(url){return notifies[url]?!0:!1}function set(url,content){globalCache.set(url,content)}function get(url){return globalCache.get(url)}__webpack_require__(63);__webpack_require__(64),__webpack_require__(72);var lru=__webpack_require__(73),globalCache=lru(50);exports.hasAsyncRequests=hasAsyncRequests,exports.addLoadCallback=addLoadCallback;var nlisteners=[],notifies={};exports.addNotify=addNotify,exports.removeNotity=removeNotity,exports.isWaitingFor=isWaitingFor,exports.set=set,exports.get=get},function(module,exports,__webpack_require__){"use strict";function getIncludePath(includeString){if(!includeString)return includeString;var index=includeString.indexOf("#");return-1==index?includeString:includeString.substring(0,index)}function getIncludeReference(includeString){if(!includeString)return null;"string"!=typeof includeString&&(includeString=""+includeString);var index=includeString.indexOf("#");if(-1==index)return null;var referenceString=index==includeString.length-1?"":includeString.substring(index+1,includeString.length),segments=referenceString.split("/");return 0==segments.length?null:(""==segments[0].trim()&&segments.splice(0,1),new IncludeReferenceImpl(referenceString,getIncludePath(includeString),segments))}function getIncludeReferenceResolvers(){return[new JSONResolver,new XMLResolver]}function resolveContents(includeString,content){if(!includeString)return content;var reference=getIncludeReference(includeString);if(!reference)return content;var includePath=getIncludePath(includeString);return resolve(includePath,reference,content).content}function resolve(includePath,includeReference,content){var resolver=_.find(getIncludeReferenceResolvers(),function(currentResolver){return currentResolver.isApplicable(includePath,content)});return resolver?resolver.resolveReference(content,includeReference):{content:content,validation:[]}}function completeReference(includePath,includeReference,content){if(!content)return[];var resolver=_.find(getIncludeReferenceResolvers(),function(currentResolver){return currentResolver.isApplicable(includePath,content)});return resolver?resolver.completeReference(content,includeReference):[]}function endsWith(input,ends){return input&&ends?input.lastIndexOf(ends)===input.length-ends.length:!1}function elementChildrenByName(parent,tagName){for(var elements=parent.getElementsByTagName(tagName),result=[],i=0;i<elements.length;i++){var child=elements[i];child.parentNode===parent&&result.push(child)}return result}var _=__webpack_require__(65),DOMParser=__webpack_require__(75).DOMParser,base64=__webpack_require__(66);exports.getIncludePath=getIncludePath,exports.getIncludeReference=getIncludeReference,exports.getIncludeReferenceResolvers=getIncludeReferenceResolvers,exports.resolveContents=resolveContents,exports.resolve=resolve,exports.completeReference=completeReference;var IncludeReferenceImpl=function(){function IncludeReferenceImpl(originalString,includePath,segments){this.includePath=includePath,this.segments=segments,this.originalString=originalString}return IncludeReferenceImpl.prototype.getIncludePath=function(){return this.includePath},IncludeReferenceImpl.prototype.getFragments=function(){return this.segments},IncludeReferenceImpl.prototype.asString=function(){return this.originalString},IncludeReferenceImpl.prototype.encodedName=function(withExtention){return void 0===withExtention&&(withExtention=!0),base64(this.includePath+"/"+this.asString())+(withExtention?this.includePath.substring(this.includePath.lastIndexOf(".")):"")},IncludeReferenceImpl}(),JSONResolver=function(){function JSONResolver(){}return JSONResolver.prototype.isApplicable=function(includePath,content){return includePath&&(endsWith(includePath.trim(),".js")||endsWith(includePath.trim(),".json"))},JSONResolver.prototype.resolveReference=function(content,reference){try{var resultJson={};return resultJson.$ref=reference.getIncludePath()+"#"+reference.asString(),{content:JSON.stringify(resultJson,null,2),validation:[]}}catch(Error){console.log(Error)}return{content:content,validation:[]}},JSONResolver.prototype.completeReference=function(content,reference){try{var jsonRoot=JSON.parse(content),fragments=reference.getFragments();if(!fragments||0==fragments.length)return this.getChildren(jsonRoot);for(var currentJSON=jsonRoot,emptyPrefixCompletion=reference.asString().lastIndexOf("/")==reference.asString().length-1,i=(emptyPrefixCompletion?fragments.length:fragments.length-1,0);i<fragments.length-1;i++){var fragment=fragments[i];if(currentJSON=this.findChild(currentJSON,fragment),!currentJSON)return[]}if(emptyPrefixCompletion)return this.getChildren(currentJSON);var lastPrefix=fragments[fragments.length-1],result=[];return this.getChildren(currentJSON).forEach(function(child){0==child.indexOf(lastPrefix)&&result.push(child)}),result}catch(Error){console.log(Error)}return[]},JSONResolver.prototype.findChild=function(jsonObject,fragment){var decoded=fragment.replace("~1","/");return decoded=fragment.replace("~0","~"),jsonObject[decoded]},JSONResolver.prototype.getChildren=function(jsonObject){return Object.keys(jsonObject)},JSONResolver}(),XMLResolver=function(){function XMLResolver(){}return XMLResolver.prototype.isApplicable=function(includePath,content){return includePath&&(endsWith(includePath.trim(),".xml")||endsWith(includePath.trim(),".xsd"))},XMLResolver.prototype.resolveReference=function(content,reference){try{var doc=(new DOMParser).parseFromString(content),requestedName=reference.asString(),uniqueName=reference.encodedName(!1),schema=elementChildrenByName(doc,"xs:schema")[0],elements=elementChildrenByName(schema,"xs:element"),types=elementChildrenByName(schema,"xs:complexType"),canBeElement=_.find(elements,function(element){return element.getAttribute("name")===requestedName}),canBeType=canBeElement?_.find(types,function(type){return type.getAttribute("name")===canBeElement.getAttribute("type")}):_.find(types,function(type){return type.getAttribute("name")===requestedName}),element=doc.createElement("xs:element");return element.setAttribute("name",uniqueName),canBeType&&element.setAttribute("type",canBeType.getAttribute("name")),canBeElement&&element.setAttribute("originalname",canBeElement.getAttribute("name")),element.setAttribute("requestedname",requestedName),element.setAttribute("extraelement","true"),schema.appendChild(element),{content:doc.toString(),validation:[]}}catch(throwable){console.log(throwable)}return{content:content,validation:[]}},XMLResolver.prototype.completeReference=function(content,reference){try{var doc=(new DOMParser).parseFromString(content),result=[],schema=elementChildrenByName(doc,"xs:schema")[0],elements=elementChildrenByName(schema,"xs:element"),types=elementChildrenByName(schema,"xs:complexType");elements.forEach(function(element){return result.push(element.getAttribute("name"))}),types.forEach(function(type){return result.push(type.getAttribute("name"))});var emptyPrefixCompletion=0===reference.asString().trim().length;return emptyPrefixCompletion?result:result.filter(function(value){return 0===value.indexOf(reference.asString())})}catch(exception){return[]}},XMLResolver}()},function(module,exports,__webpack_require__){"use strict";function isWebPath(str){return ll.isWebPath(str)}var path=__webpack_require__(15),ll=__webpack_require__(11),resourceRegistry=__webpack_require__(29),ContentProvider=function(){function ContentProvider(unit){this.unit=unit}return ContentProvider.prototype.contextPath=function(){if(!this.unit)return"";var rootPath=this.unit.absolutePath();return rootPath||""},ContentProvider.prototype.normalizePath=function(url){if(!url)return url;var result;if(isWebPath(url)){var prefix=0===url.toLowerCase().indexOf("https")?"https://":"http://";result=prefix+path.normalize(url.substring(prefix.length)).replace(/\\/g,"/")}else result=path.normalize(url).replace(/\\/g,"/");return result},ContentProvider.prototype.content=function(reference){var normalized=this.normalizePath(reference),unitPath=this.toRelativeIfNeeded(normalized),unit=this.unit.resolve(unitPath);return unit?unit.contents()||"":""},ContentProvider.prototype.contentAsync=function(reference){var normaized=this.normalizePath(reference),unitPath=this.toRelativeIfNeeded(normaized),unitPromise=this.unit.resolveAsync(unitPath);if(!unitPromise)return Promise.resolve("");var result=unitPromise.then(function(unit){return unit&&unit.contents()||""});return result},ContentProvider.prototype.toRelativeIfNeeded=function(normaized){var unitPath=normaized;return path.isAbsolute(normaized)&&!isWebPath(normaized)&&(unitPath=path.relative(path.dirname(this.unit.absolutePath()),normaized)),unitPath},ContentProvider.prototype.hasAsyncRequests=function(){return resourceRegistry.hasAsyncRequests()},ContentProvider.prototype.resolvePath=function(context,relativePath){return ll.buildPath(relativePath,context,this.unit.project().getRootPath())},ContentProvider.prototype.isAbsolutePath=function(uri){return uri?isWebPath(uri)?!0:path.isAbsolute(uri):!1},ContentProvider.prototype.promiseResolve=function(arg){return Promise.resolve(arg)},ContentProvider}();exports.ContentProvider=ContentProvider},function(module,exports,__webpack_require__){"use strict";function flattenArrayOfObjects(x){var res={};return x.forEach(function(v){return Object.keys(v).forEach(function(k){return res[k]=v[k]})}),res}function find(xs,f){return new Opt(_.find(xs||[],f))}function toTuples(map){return Object.keys(map).map(function(k){return[k,map[k]]})}function fromTuples(tuples){var obj={};return tuples.forEach(function(x){return obj[x[0]]=x[1]}),obj}function tap(v,f){return f(v),v}function kv(obj,iter){"object"==typeof obj&&Object.keys(obj).forEach(function(k){return iter(k,obj[k])})}function indexed(objects,key,delKey){void 0===delKey&&(delKey=!1);var obj={};return objects.forEach(function(original){var copy=exports.shallowCopy(original);delKey&&delete copy[key],obj[original[key]]=copy}),obj}function stringEndsWith(str,search){var dif=str.length-search.length;return dif>=0&&str.lastIndexOf(search)===dif}function stringStartsWith(str,search,ind){return void 0===ind&&(ind=0),str.length-search.length>=ind&&str.substring(ind,ind+search.length)===search}function lazypropkeyfilter(k){return"_"==k[k.length-1]}function lazyprop(obj,key,func){var result,ready=!1;obj[key]=function(){return ready||(ready=!0,result=func.apply(obj)),result}}function lazyprops(obj,keyfilter){void 0===keyfilter&&(keyfilter=lazypropkeyfilter);for(var k in obj)keyfilter(k)&&exports.ifInstanceOf(obj[k],Function,function(vf){return 0===vf.length?lazyprop(obj,k,vf):null})}function iff(v,f){void 0!==v&&f(v)}function isRAMLUrl(str){return"string"!=typeof str||""==str?!1:stringEndsWith(str,".raml")}function getAllRequiredExternalModulesFromCode(code){for(var match,mods=[],r1=new RegExp("require\\('([^']+)'\\)","gi");match=r1.exec(code);)mods.push(match[1]);for(var r2=new RegExp('require\\("([^"]+)"\\)',"gi");match=r2.exec(code);)mods.push(match[1]);return mods=_.unique(mods).filter(function(x){return""!=x}),mods.sort(),mods}function isEssential(arg){return"undefined"!=typeof arg&&null!=arg}function firstToUpper(q){return 0==q.length?q:q.charAt(0).toUpperCase()+q.substr(1)}function updateObject(source,target,addNewFields){void 0===addNewFields&&(addNewFields=!1);var keySet=Object.keys(target);if(addNewFields){var map={};keySet.forEach(function(x){return map[x]=!0}),Object.keys(source).forEach(function(x){return map[x]=!0}),keySet=Object.keys(map)}keySet.forEach(function(x){var value=source[x];value instanceof Object?(target[x]||(target[x]={}),updateObject(value,target[x],!0)):void 0!=value&&(target[x]=source[x])})}function replaceMap(str,map){return Object.keys(map).forEach(function(x){return str=replace(str,x,map[x])}),str}function replace(str,x,r){for(var result="",prev=0,i=str.indexOf(x);i<str.length&&i>=0;i=str.indexOf(x,prev))result+=str.substring(prev,i),result+=r,prev=i+x.length;return result+=str.substring(prev,str.length)}var _=__webpack_require__(65),Opt=__webpack_require__(22);exports.defined=function(x){return null!==x&&void 0!==x},exports.flattenArrayOfObjects=flattenArrayOfObjects,exports.find=find,exports.isInstance=function(v,C){return v instanceof C?[v]:[]},exports.ifInstanceOf=function(v,C,f){return v instanceof C?f(v):null},exports.toTuples=toTuples,exports.fromTuples=fromTuples,exports.collectInstancesOf=function(xs,C){return tap([],function(res){return xs.forEach(function(v){return exports.ifInstanceOf(v,C,function(x){return res.push(x)})})})},exports.collectInstancesOfInMap=function(map,C){return Object.keys(map).map(function(k){return[k,map[k]]}).filter(function(x){return x[1]instanceof C}).map(function(x){return x})},exports.asArray=function(v){return exports.defined(v)?v instanceof Array?v:[v]:[]},exports.shallowCopy=function(obj){return tap({},function(copy){return Object.keys(obj).forEach(function(k){return copy[k]=obj[k]})})},exports.flatMap=function(xs,f){return exports.flatten(xs.map(f))},exports.flatten=function(xss){return Array.prototype.concat.apply([],xss)},exports.takeWhile=function(xs,f){return tap([],function(res){for(var i=0;i<xs.length&&f(xs[i]);i++)res.push(xs[i])})},exports.tap=tap,exports.kv=kv,exports.indexed=indexed,exports.stringEndsWith=stringEndsWith,exports.stringStartsWith=stringStartsWith,exports.lazypropkeyfilter=lazypropkeyfilter,exports.lazyprops=lazyprops,exports.iff=iff,exports.isRAMLUrl=isRAMLUrl,exports.getAllRequiredExternalModulesFromCode=getAllRequiredExternalModulesFromCode,exports.serial=function(){var i=0;return function(){return i++}}(),exports.isEssential=isEssential,exports.firstToUpper=firstToUpper,exports.updateObject=updateObject,exports.replaceMap=replaceMap,exports.replace=replace},function(module,exports,__webpack_require__){"use strict";function resolveType(p){return p.highLevel().localType()}function runtimeType(p){return p.highLevel().localType()}function load(pth){var m=new ll.Project(path.dirname(pth)),unit=m.unit(path.basename(pth));return unit&&unit.isRAMLUnit()?hlimpl.fromUnit(unit).wrapperNode():null}function completeRelativeUri(res){var uri="",parent=res;do res=parent,uri=res.relativeUri().value()+uri,parent=res.parent();while(parent.definition().key().name==universes.Universe10.Resource.name);return uri}function expandSpec(api,expLib){return void 0===expLib&&(expLib=!1),expLib?expandLibraries(api):expandTraitsAndResourceTypes(api)}function expandTraitsAndResourceTypes(api){var lowLevelNode=api.highLevel().lowLevel();return lowLevelNode instanceof lowLevelProxy.LowLevelProxyNode?api:expander.expandTraitsAndResourceTypes(api)}function expandLibraries(api){return expander.expandLibraries(api)}function absoluteUri(res){var uri="",parent=res;do res=parent,uri=res.relativeUri().value()+uri,parent=res.parent();while(parent.definition().key().name==universes.Universe10.Resource.name);uri=uri.replace(/\/\//g,"/");var buri=parent.baseUri(),base=buri?buri.value():"";return base=base?base:"",util.stringEndsWith(base,"/")&&(uri=uri.substring(1)),uri=base+uri}function validateInstance(res,value){return res.runtimeType().validate(value).map(function(x){return x.getMessage()})}function validateInstanceWithDetailedStatuses(res,value){return res.runtimeType().validate(value)}function traitsPrimary(a){return allTraits(a)}function allTraits(a){return a.highLevel().lowLevel().actual().libExpanded?a.traits_original():findTemplates(a,function(d){return universeHelpers.isTraitType(d)})}function resourceTypesPrimary(a){return allResourceTypes(a)}function allResourceTypes(a){return a.highLevel().lowLevel().actual().libExpanded?a.resourceTypes_original():findTemplates(a,function(d){return universeHelpers.isResourceTypeType(d)})}function findTemplates(a,filter){var arr=search.globalDeclarations(a.highLevel()).filter(function(x){return filter(x.definition())}),ll=a.highLevel().lowLevel(),nodePath=ll.includePath();nodePath||(nodePath=ll.unit().path());var isProxy=a.highLevel().lowLevel()instanceof proxy.LowLevelProxyNode,exp=isProxy?new expander.TraitsAndResourceTypesExpander:null,topLevelArr=arr.map(function(x){var topLevelNode,p=x.lowLevel().unit().path();return isProxy&&(x.lowLevel()instanceof proxy.LowLevelProxyNode||(x=exp.createHighLevelNode(x,!1)),(new referencePatcher.ReferencePatcher).process(x,a.highLevel(),!0,!0)),p!=nodePath?(topLevelNode=factory.buildWrapperNode(x,!1),topLevelNode.meta().setCalculated()):topLevelNode=x.wrapperNode(),topLevelNode});return topLevelArr}function relativeUriSegments(res){var result=[],parent=res;do res=parent,result.push(res.relativeUri().value()),parent=res.parent();while(parent.definition().key().name==universes.Universe10.Resource.name);return result.reverse()}function parentResource(method){return method.parent()instanceof RamlWrapperImpl.ResourceImpl?method.parent():null}function parent(resource){var parent=resource.parent();return parent.definition().key().name==universes.Universe10.Resource.name?parent:null}function childResource(container,relPath){if(null==container)return null;var resources=container.resources();return resources?(resources=resources.filter(function(x){return x.relativeUri().value()==relPath}),0==resources.length?null:resources[0]):null}function getResource(container,path){if(!container)return null;for(var res=null,i=0;i<path.length;i++){if(res=childResource(container,path[i]),!res)return null;container=res}return res}function childMethod(resource,method){return resource?resource.methods().filter(function(x){return x.method()==method}):null}function getMethod(container,path,method){var resource=getResource(container,path);return resource?childMethod(resource,method):null}function isApi(obj){return universeHelpers.isApiSibling(obj.definition())}function ownerApi(method){for(var obj=method;!isApi(obj);)obj=obj.parent();return obj}function methodId(method){var parent=method.parent();if(parent instanceof RamlWrapperImpl.ResourceImpl)return completeRelativeUri(parent)+" "+method.method().toLowerCase();if(parent instanceof RamlWrapperImpl.ResourceTypeImpl)return parent.name()+" "+method.method().toLowerCase();throw new Error("Method is supposed to be owned by Resource or ResourceType.\nHere the method is owned by "+method.definition().key().name)}function isOkRange(response){var str=response.code().value(),err=linter.validateResponseString(str);if(null!=err)return!1;try{if(parseInt(str.charAt(0))<4)return!0}catch(e){}return!1}function allResources(api){var resources=[],visitor=function(res){resources.push(res),res.resources().forEach(function(x){return visitor(x)})};return api.resources().forEach(function(x){return visitor(x)}),resources}function matchUri(apiRootRelativeUri,resource){for(var allParameters={};null!=resource;)uriParameters(resource).forEach(function(x){return allParameters[x.name()]=new ParamWrapper(x)}),resource=parent(resource);var result=ramlPathMatch.ramlPathMatch(completeRelativeUri(resource),allParameters,{})(apiRootRelativeUri);return result?new Opt(Object.keys(result.params).map(function(x){return new ParamValue(x,result.params[x])})):Opt.empty()}function uriParametersPrimary(resource){return uriParameters(resource)}function uriParameters(resource){var params=resource.uriParameters_original();if(!(resource instanceof RamlWrapperImpl.ResourceImpl))return params;var uri=resource.relativeUri().value(),propName=universes.Universe10.ResourceBase.properties.uriParameters.name;return extractParams(params,uri,resource,propName)}function baseUriParametersPrimary(api){return baseUriParameters(api)}function baseUriParameters(api){var uri=api.baseUri()?api.baseUri().value():"",params=api.baseUriParameters_original(),propName=universes.Universe10.Api.properties.baseUriParameters.name;return extractParams(params,uri,api,propName)}function absoluteUriParameters(res){var params=[],parent=res;do res=parent,params=uriParameters(res).concat(params),parent=res.parent();while(parent.definition().key().name==universes.Universe10.Resource.name);var api=parent;api.baseUriParameters();return params=baseUriParameters(api).concat(params)}function protocolsPrimary(api){return allProtocols(api)}function allProtocols(api){return api.protocols().map(function(x){return x.toUpperCase()})}function securedByPrimary(resourceOrMethod){return allSecuredBy(resourceOrMethod)}function allSecuredBy(resourceOrMethod){return resourceOrMethod.securedBy()}function securitySchemeName(schemeReference){var highLevel=schemeReference.highLevel();if(!highLevel)return"";var attributeValue=highLevel.value();return attributeValue?attributeValue.toString():""}function securityScheme(schemeReference){var highLevel=schemeReference.highLevel();if(!highLevel)return null;var declaration=search.findDeclarationByNode(highLevel,search.LocationKind.VALUE_COMPLETION);if(!declaration)return null;if(!declaration.getKind||declaration.getKind()!=hl.NodeKind.NODE)return null;var result=declaration.wrapperNode();return result instanceof RamlWrapperImpl.AbstractSecuritySchemeImpl?result:null}function RAMLVersion(api){return api.highLevel().definition().universe().version()}function structuredValue(reference){var llNode=reference.value().lowLevel(),type=null,hlNode=llNode.highLevelParseResult();if(hlNode){var types=null,isAnnotations=!1;if(hlNode.isAttr()?(isAnnotations=universeHelpers.isAnnotationsProperty(hlNode.property()),types=hlNode.parent().types()):hlNode.isElement()&&(types=hlNode.asElement().types()),types){var refName=reference.name(),fromLib=refName.indexOf(".")>=0;if(fromLib){var reg=isAnnotations?types.getAnnotationTypeRegistry():types.getTypeRegistry();type=reg.get(refName)}else type=isAnnotations?types.getAnnotationType(refName):types.getType(refName);
}}return new core.TypeInstanceImpl(llNode,type)}function referenceName(reference){var val=reference.highLevel().value();return"string"==typeof val||null==val?val:val.valueName()}function referencedTrait(ref){return referencedObject(ref)}function referencedAnnotation(ref){return referencedObject(ref)}function referencedResourceType(ref){return referencedObject(ref)}function referencedObject(ref){var attr=ref.highLevel(),parent=attr.parent(),vn=ref.name(),cands=search.referenceTargets(attr.property(),parent).filter(function(x){return hlimpl.qName(x,parent)==vn});return 0==cands.length?null:cands[0].wrapperNode()}function examplesFromNominal(runtimeDefinition,hlParent,isSingle,patchHL){void 0===patchHL&&(patchHL=!0);var llParent=hlParent.lowLevel(),property=hlParent.definition().property(isSingle?"example":"examples"),universe=defs.getUniverse("RAML10"),definition=universe.type(universeDef.Universe10.ExampleSpec.name),expandables=runtimeDefinition.examples().filter(function(x){return null!=x&&!x.isEmpty()&&x.isSingle()==isSingle});return expandables.map(function(x){var obj=x.asJSON(),key=x.isSingle()?"example":null,jsonNode=new json.AstNode(llParent.unit(),obj,llParent,null,key),hlNode=patchHL?new hlimpl.ASTNodeImpl(jsonNode,hlParent,definition,property):hlParent,wrapperAnnotations=[],annotations=x.annotations();if(annotations)for(var aProp=universe.type("Annotable").property("annotations"),_i=0,_a=Object.keys(annotations);_i<_a.length;_i++){var aName=_a[_i],aObj=annotations[aName],aJson=new json.AstNode(llParent.unit(),aObj,jsonNode,null,"("+aName+")"),aHlNode=new hlimpl.ASTPropImpl(aJson,hlNode,aProp.range(),aProp),wAnnotation=new RamlWrapperImpl.AnnotationRefImpl(aHlNode);wrapperAnnotations.push(wAnnotation)}return new ExampleSpecImpl(hlNode,x,wrapperAnnotations)})}function getExpandableExamples(node,isSingle){void 0===isSingle&&(isSingle=!1);var runtimeDefinition=node.runtimeDefinition();if(!runtimeDefinition)return[];var hlParent=node.highLevel();return examplesFromNominal(runtimeDefinition,hlParent,isSingle)}function getTypeExample(td){var examples=getExpandableExamples(td,!0);return examples.length>0?examples[0]:null}function getTypeExamples(td){return getExpandableExamples(td)}function typeFixedFacets(td){var rDef=td.runtimeDefinition(),obj=rDef.getFixedFacets(),keys=Object.keys(obj);if(td.kind()!=universeDef.Universe10.UnionTypeDeclaration.name)for(var _i=0,keys_1=keys;_i<keys_1.length;_i++){var key=keys_1[_i];null==rDef.facet(key)&&delete obj[key]}if(0==Object.keys(obj).length)return null;var node=new json.AstNode(null,obj);return new core.TypeInstanceImpl(node)}function typeValue(typeDeclaration){var attrs=typeDeclaration.highLevel().attributes(defs.universesInfo.Universe10.TypeDeclaration.properties.type.name),structuredAttrs=attrs.filter(function(x){return x.value()instanceof hlimpl.StructuredValue});if(0==structuredAttrs.length)return typeDeclaration.type_original().map(function(x){return null===x||"NULL"===x||"Null"===x?"string":x});var nullify=!1,values=attrs.map(function(x){var val=x.value();return null==val?null:"string"==typeof val?val:(val instanceof hlimpl.StructuredValue&&(nullify=!0),val.toString())});return nullify?null:values}function schemaValue(typeDeclaration){var nullify=!1,attrs=typeDeclaration.highLevel().attributes(defs.universesInfo.Universe10.TypeDeclaration.properties.schema.name);if(nullify)return null;var structuredAttrs=attrs.filter(function(x){return x.value()instanceof hlimpl.StructuredValue});if(0==structuredAttrs.length)return typeDeclaration.schema_original();var values=attrs.map(function(x){var val=x.value();return"string"==typeof val?val:(val instanceof hlimpl.StructuredValue&&(nullify=!0),val.toString())});return nullify?null:values}function typeStructuredValue(typeDeclaration){var attrs=typeDeclaration.highLevel().attributes(defs.universesInfo.Universe10.TypeDeclaration.properties.type.name);attrs=attrs.concat(typeDeclaration.highLevel().attributes(defs.universesInfo.Universe10.TypeDeclaration.properties.schema.name));for(var values=attrs.map(function(x){return x.value()}),_i=0,values_1=values;_i<values_1.length;_i++){var val=values_1[_i];if(val instanceof hlimpl.StructuredValue){var typeInstance=new core.TypeInstanceImpl(val.lowLevel());return typeInstance}}return null}function referencedNode(usesDecl){var ref=usesDecl.value(),unit=usesDecl.highLevel().lowLevel().unit().resolve(ref),hlNode=unit.highLevel(),hlElement=hlNode.asElement();if(hlElement){var wrapperNode=hlElement.wrapperNode();return RamlWrapper.isLibrary(wrapperNode)?(wrapperNode.setAttributeDefaults(usesDecl.attributeDefaults()),wrapperNode):null}return null}function getItems(arrayTypeDecl){return arrayTypeDecl.items_original()}function findComponentTypeDeclBySearch(arrayTypeDecl){var typeHighLevel=arrayTypeDecl.highLevel();if(!typeHighLevel)return null;var attrType=typeHighLevel.attr(universes.Universe10.TypeDeclaration.properties.type.name);if(null==attrType)return null;var attrTypeLowLevel=attrType.lowLevel();if(null==attrTypeLowLevel)return null;var attrTypeValue=attrType.value();if(!attrTypeValue||"string"!=typeof attrTypeValue)return null;var offset=attrTypeLowLevel.end()-attrTypeValue.length+1,unit=attrType.lowLevel().unit();if(!unit)return null;var declaration=search.findDeclaration(unit,offset);return declaration&&declaration.getKind&&declaration.getKind()==hl.NodeKind.NODE&&universeHelpers.isTypeDeclarationSibling(declaration.definition())?declaration.wrapperNode():null}function findComponentTypeDeclByRuntimeType(arrayTypeDecl){var runtimeType=arrayTypeDecl.runtimeType();if(!runtimeType)return null;if(!runtimeType.isArray()||!runtimeType.componentType)return null;var runtimeArrayType=runtimeType,componentType=runtimeArrayType.componentType();if(!componentType)return null;var componentTypeHLSourceProvider=sourceFinder.getNominalTypeSource(componentType);if(!componentTypeHLSourceProvider)return null;var componentTypeSource=componentTypeHLSourceProvider.getSource();if(!componentTypeSource)return null;if(!componentTypeSource.isElement())return null;if(!universeHelpers.isTypeDeclarationSibling(componentTypeSource.definition()))return null;var basicNodeSource=componentTypeSource.wrapperNode();return basicNodeSource}function findComponentTypeDeclaration(arrayTypeDecl){var original=arrayTypeDecl.items_original();if(original)return original;var foundByRuntimeType=findComponentTypeDeclByRuntimeType(arrayTypeDecl);return foundByRuntimeType?foundByRuntimeType:findComponentTypeDeclBySearch(arrayTypeDecl)}function extractParams(params,uri,owner,propName){if("string"!=typeof uri)return[];var ownerHl=owner.highLevel(),definition=ownerHl.definition(),prop=definition.property(propName);if(!uri)return[];var describedParams={};params.forEach(function(x){var arr=describedParams[x.name()];arr||(arr=[],describedParams[x.name()]=arr),arr.push(x)});for(var allParams=[],prev=0,mentionedParams={},i=uri.indexOf("{");i>=0&&(prev=uri.indexOf("}",++i),!(0>prev));i=uri.indexOf("{",prev)){var paramName=uri.substring(i,prev);if(mentionedParams[paramName]=!0,describedParams[paramName])describedParams[paramName].forEach(function(x){return allParams.push(x)});else{var universe=definition.universe(),nc=universe.type(universeDef.Universe10.StringTypeDeclaration.name),node=stubs.createStubNode(nc,null,paramName,ownerHl.lowLevel().unit()),uriParameter=factory.buildWrapperNode(node),hlNode=uriParameter.highLevel();hlNode.setParent(ownerHl),uriParameter.meta().setCalculated(),uriParameter.setName(paramName),hlNode.patchProp(prop),allParams.push(uriParameter)}}return Object.keys(describedParams).filter(function(x){return!mentionedParams[x]}).forEach(function(x){return describedParams[x].forEach(function(y){return allParams.push(y)})}),allParams}function getTemplateParametrizedProperties(node){if(node.kind()==universeDef.Universe10.Method.name||universeHelpers.isTypeDeclarationSibling(node.definition())){for(var isInsideTemplate=!1,parent=node.highLevel().parent();null!=parent;){var pDef=parent.definition();if(universeHelpers.isResourceTypeType(pDef)||universeHelpers.isTraitType(pDef)){isInsideTemplate=!0;break}parent=parent.parent()}if(!isInsideTemplate)return null}var highLevelNode=node.highLevel();if(null==highLevelNode)return null;var lowLevelNode=highLevelNode.lowLevel();if(null==lowLevelNode)return null;var children=lowLevelNode.children().filter(function(x){var key=x.key();return key?"("==key.charAt(0)&&")"==key.charAt(key.length-1)?!1:key.indexOf("<<")>=0:!1});if(0==children.length)return null;var result=new core.TypeInstanceImpl(children);return result}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},RamlWrapper=__webpack_require__(12),RamlWrapperImpl=__webpack_require__(21),factory=__webpack_require__(43),core=__webpack_require__(45),ramlPathMatch=__webpack_require__(55),hl=__webpack_require__(10),hlimpl=__webpack_require__(16),linter=__webpack_require__(26),stubs=__webpack_require__(17),defs=__webpack_require__(36),universeDef=__webpack_require__(18),universes=__webpack_require__(18),Opt=__webpack_require__(22),util=__webpack_require__(32),expander=__webpack_require__(25),proxy=__webpack_require__(39),referencePatcher=__webpack_require__(49),lowLevelProxy=__webpack_require__(39),search=__webpack_require__(24),ll=__webpack_require__(28),json=__webpack_require__(51),path=__webpack_require__(15),universeHelpers=__webpack_require__(14),sourceFinder=__webpack_require__(46);exports.resolveType=resolveType,exports.runtimeType=runtimeType,exports.load=load,exports.completeRelativeUri=completeRelativeUri,exports.expandSpec=expandSpec,exports.expandTraitsAndResourceTypes=expandTraitsAndResourceTypes,exports.expandLibraries=expandLibraries,exports.absoluteUri=absoluteUri,exports.validateInstance=validateInstance,exports.validateInstanceWithDetailedStatuses=validateInstanceWithDetailedStatuses,exports.traitsPrimary=traitsPrimary,exports.allTraits=allTraits,exports.resourceTypesPrimary=resourceTypesPrimary,exports.allResourceTypes=allResourceTypes,exports.relativeUriSegments=relativeUriSegments,exports.parentResource=parentResource,exports.parent=parent,exports.childResource=childResource,exports.getResource=getResource,exports.childMethod=childMethod,exports.getMethod=getMethod,exports.ownerApi=ownerApi,exports.methodId=methodId,exports.isOkRange=isOkRange,exports.allResources=allResources,exports.matchUri=matchUri;exports.uriParametersPrimary=uriParametersPrimary,exports.uriParameters=uriParameters,exports.baseUriParametersPrimary=baseUriParametersPrimary,exports.baseUriParameters=baseUriParameters,exports.absoluteUriParameters=absoluteUriParameters,exports.protocolsPrimary=protocolsPrimary,exports.allProtocols=allProtocols,exports.securedByPrimary=securedByPrimary,exports.allSecuredBy=allSecuredBy,exports.securitySchemeName=securitySchemeName,exports.securityScheme=securityScheme,exports.RAMLVersion=RAMLVersion,exports.structuredValue=structuredValue,exports.referenceName=referenceName,exports.referencedTrait=referencedTrait,exports.referencedAnnotation=referencedAnnotation,exports.referencedResourceType=referencedResourceType,exports.examplesFromNominal=examplesFromNominal,exports.getTypeExample=getTypeExample,exports.getTypeExamples=getTypeExamples,exports.typeFixedFacets=typeFixedFacets,exports.typeValue=typeValue,exports.schemaValue=schemaValue,exports.typeStructuredValue=typeStructuredValue,exports.referencedNode=referencedNode,exports.getItems=getItems,exports.findComponentTypeDeclaration=findComponentTypeDeclaration,exports.getTemplateParametrizedProperties=getTemplateParametrizedProperties;var SchemaDef=function(){function SchemaDef(_content,_name){this._content=_content,this._name=_name}return SchemaDef.prototype.name=function(){return this._name},SchemaDef.prototype.content=function(){return this._content},SchemaDef}();exports.SchemaDef=SchemaDef;var ParamValue=function(){function ParamValue(key,value){this.key=key,this.value=value}return ParamValue}();exports.ParamValue=ParamValue;var ParamWrapper=function(){function ParamWrapper(_param){this._param=_param,this.description=_param.description()?_param.description().value():this.description,this.displayName=_param.displayName(),this.type=_param.type().length>0?_param.type()[0]:"string",this.example=_param.example(),this.required=_param.required(),this["default"]=_param["default"]()}return ParamWrapper}(),ExampleSpecImpl=function(_super){function ExampleSpecImpl(hlNode,expandable,_annotations){_super.call(this,hlNode),this.expandable=expandable,this._annotations=_annotations}return __extends(ExampleSpecImpl,_super),ExampleSpecImpl.prototype.value=function(){return this.expandable.asString()},ExampleSpecImpl.prototype.structuredValue=function(){var obj;obj=this.expandable.isJSONString()||this.expandable.isYAML()?this.expandable.asJSON():this.expandable.original();var llParent=this._node.lowLevel(),key=this.expandable.isSingle()?"example":null,jsonNode=new json.AstNode(llParent.unit(),obj,llParent,null,key);return new core.TypeInstanceImpl(jsonNode)},ExampleSpecImpl.prototype.strict=function(){return this.expandable.strict()},ExampleSpecImpl.prototype.description=function(){var descriptionValue=this.expandable.description();if(null==descriptionValue&&null!==descriptionValue)return null;var attr=stubs.createAttr(this._node.definition().property(universeDef.Universe10.ExampleSpec.properties.description.name),descriptionValue),result=new RamlWrapperImpl.MarkdownStringImpl(attr);return result},ExampleSpecImpl.prototype.name=function(){return this.expandable.name()},ExampleSpecImpl.prototype.displayName=function(){return this.expandable.displayName()},ExampleSpecImpl.prototype.annotations=function(){return this._annotations},ExampleSpecImpl.prototype.scalarsAnnotations=function(){return{}},ExampleSpecImpl.prototype.uses=function(){return _super.prototype.elements.call(this,"uses")},ExampleSpecImpl}(core.BasicNodeImpl);exports.ExampleSpecImpl=ExampleSpecImpl},function(module,exports,__webpack_require__){"use strict";var serv=__webpack_require__(36);module.exports=serv},function(module,exports,__webpack_require__){"use strict";var ramlDS=__webpack_require__(36);module.exports=ramlDS.getUniverse},function(module,exports,__webpack_require__){"use strict";function getSchemaUtils(){return exports.rt.getSchemaUtils()}function registerAdapters(a){a.isUnion?a.addAdapter(new RAMLService(a)):a.range&&a.addAdapter(new RAMLPropertyService(a))}function isSourceProvider(object){return object.getSource&&"function"==typeof object.getSource}function prop(name,desc,domain,range,custom){var prop=new Property(name,desc);return prop.withDomain(domain,custom).withRange(range)}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)};exports.rt=__webpack_require__(80);var typeSystem=exports.rt.nominalTypes;exports.getSchemaUtils=getSchemaUtils,exports.TOP_LEVEL_EXTRA=exports.rt.TOP_LEVEL_EXTRA,exports.DEFINED_IN_TYPES_EXTRA=exports.rt.DEFINED_IN_TYPES_EXTRA,exports.USER_DEFINED_EXTRA=exports.rt.USER_DEFINED_EXTRA,exports.SOURCE_EXTRA=exports.rt.SOURCE_EXTRA,exports.tsInterfaces=exports.rt.tsInterfaces,exports.injector={inject:function(a){registerAdapters(a)}},typeSystem.registerInjector(exports.injector);var AbstractType=function(_super){function AbstractType(){_super.apply(this,arguments)}return __extends(AbstractType,_super),AbstractType}(typeSystem.AbstractType);exports.AbstractType=AbstractType;var ValueType=function(_super){function ValueType(){_super.apply(this,arguments)}return __extends(ValueType,_super),ValueType}(typeSystem.ValueType);exports.ValueType=ValueType;var SourceProvider=function(){function SourceProvider(){}return SourceProvider.prototype.getSource=function(){return null},SourceProvider}();exports.SourceProvider=SourceProvider,exports.isSourceProvider=isSourceProvider;var EnumType=function(_super){function EnumType(){_super.apply(this,arguments),this.values=[]}return __extends(EnumType,_super),EnumType}(ValueType);exports.EnumType=EnumType;var ReferenceType=function(_super){function ReferenceType(name,path,referenceTo,_universe){_super.call(this,name,_universe,path),this.referenceTo=referenceTo}return __extends(ReferenceType,_super),ReferenceType.prototype.getReferencedType=function(){return this.universe().type(this.referenceTo)},ReferenceType.prototype.hasStructure=function(){return!0},ReferenceType}(ValueType);exports.ReferenceType=ReferenceType;var NodeClass=function(_super){function NodeClass(_name,universe,path,_description){void 0===_description&&(_description=""),_super.call(this,_name,universe,path)}return __extends(NodeClass,_super),NodeClass.prototype.allProperties=function(v){return void 0===v&&(v={}),_super.prototype.allProperties.call(this,v)},NodeClass}(typeSystem.StructuredType);exports.NodeClass=NodeClass;var UserDefinedClass=function(_super){function UserDefinedClass(name,universe,hl,path,description){_super.call(this,name,universe,path,description),this.getAdapter(RAMLService).setDeclaringNode(hl)}return __extends(UserDefinedClass,_super),UserDefinedClass.prototype.key=function(){return null},UserDefinedClass.prototype.isUserDefined=function(){return!0},UserDefinedClass.prototype.typeId=function(){var rs=this.nameId(),node=this.getAdapter(RAMLService).getDeclaringNode();if(node){rs+=node.lowLevel().start();var unit=node.lowLevel().unit();unit&&(rs+=unit.absolutePath())}return rs},UserDefinedClass.prototype.hasValueTypeInHierarchy=function(){return this._value?!0:this.isAssignableFrom("ObjectTypeDeclaration")?!1:!1},UserDefinedClass.prototype.isGenuineUserDefinedType=function(){return null!=this.genuineUserDefinedType()},UserDefinedClass.prototype.genuineUserDefinedType=function(){var declaringNode=this.getAdapter(RAMLService).getDeclaringNode();return declaringNode?this:null},UserDefinedClass}(NodeClass);exports.UserDefinedClass=UserDefinedClass;var AnnotationType=function(_super){function AnnotationType(){_super.apply(this,arguments)}return __extends(AnnotationType,_super),AnnotationType.prototype.allProperties=function(ps){void 0===ps&&(ps={});var rs=this.superTypes()[0].allProperties();if(0==rs.length){var node=this.getAdapter(RAMLService).getDeclaringNode(),up=new UserDefinedProp("value",node);up.withDomain(this),up.withCanBeValue(),up.withRequired(!1);this.superTypes()[0];rs=[],up.withRange(up.node().asElement().definition().universe().type("string")),rs.push(up)}return rs},AnnotationType.prototype.isAnnotationType=function(){return!0},AnnotationType}(UserDefinedClass);exports.AnnotationType=AnnotationType;var Universe=function(_super){function Universe(dec,name,_parent,v){void 0===name&&(name=""),void 0===_parent&&(_parent=null),void 0===v&&(v="RAML08"),_super.call(this,name),this._parent=_parent,this._classes=[],this._uversion="RAML08",this.aMap={},this.matchedObjects=dec,this._uversion=v}return __extends(Universe,_super),Universe.prototype.matched=function(){return this.matchedObjects?this.matchedObjects:this._parent?this._parent.matched():void 0},Universe.prototype.setTopLevel=function(t){this._topLevel=t},Universe.prototype.getTopLevel=function(){return this._topLevel},Universe.prototype.setOriginalTopLevelText=function(t){this._originalTopLevelText=t},Universe.prototype.getOriginalTopLevelText=function(){return this._originalTopLevelText},Universe.prototype.setTypedVersion=function(tv){this._typedVersion=tv},Universe.prototype.getTypedVersion=function(){return this._typedVersion},Universe.prototype.version=function(){return this._uversion},Universe.prototype.setUniverseVersion=function(version){this._uversion=version},Universe.prototype.types=function(){var result=[].concat(this._classes);return null!=this._parent&&(result=result.concat(this._parent.types())),result},Universe.prototype.type=function(name){if(this.aMap[name])return this.aMap[name];for(var tp,i=0;i<this._classes.length;i++)if(this._classes[i].nameId()==name){tp=this._classes[i];break}if(null==tp&&this._parent){var tp=this._parent.type(name);if(tp instanceof AbstractType){var at=tp;at._universe=this}}return tp},Universe.prototype.register=function(t){return this._classes.push(t),t instanceof NodeClass&&this._classes.forEach(function(x){if(x instanceof NodeClass){var nc=x;nc.getAdapter(RAMLService).getExtendedType()==t&&t.getAdapter(RAMLService).getRuntimeExtenders().push(x)}}),this},Universe.prototype.registerAlias=function(a,t){this.aMap[a]=t},Universe.prototype.unregister=function(t){this._classes=this._classes.filter(function(x){return x!=t});var st=t.superTypes();return st.forEach(function(x){var a=x;a._superTypes=a._superTypes.filter(function(x){return x!=t})}),st=t.subTypes(),st.forEach(function(x){var a=x;a._subTypes=a._subTypes.filter(function(x){return x!=t})}),this},Universe.prototype.registerSuperClass=function(t0,t1){var a0=t0,a1=t1;a0._superTypes.push(t1),a1._subTypes.push(t0)},Universe}(typeSystem.Described);exports.Universe=Universe,exports.prop=prop;var ChildValueConstraint=function(){function ChildValueConstraint(name,value){this.name=name,this.value=value}return ChildValueConstraint}();exports.ChildValueConstraint=ChildValueConstraint;var Property=function(_super){function Property(){_super.apply(this,arguments),this._isFromParentValue=!1,this._isFromParentKey=!1,this._key=!1,this._declaresFields=!1,this._describes=null,this._canBeDuplicator=!1,this._allowsNull=!1,this._canBeValue=!1,this._isInherited=!1,this._selfNode=!1,this._noDirectParse=!1,this._contextReq=[],this.determinesChildValues=[]}return __extends(Property,_super),Property.prototype.isPrimitive=function(){return this.range().isValueType()&&!(this.range()instanceof ReferenceType)},Property.prototype.withNoDirectParse=function(){this._noDirectParse=!0},Property.prototype.isNoDirectParse=function(){return this._noDirectParse},Property.prototype.withSelfNode=function(){this._selfNode=!0},Property.prototype.isSelfNode=function(){return this._selfNode},Property.prototype.matchKey=function(k){return null!=this._groupName?this.isAnnotation()?"("==k.charAt(0)&&")"==k.charAt(k.length-1)?!0:!1:this._groupName==k:_super.prototype.matchKey.call(this,k)},Property.prototype.valueDocProvider=function(){return this._vprovider},Property.prototype.setValueDocProvider=function(v){return this._vprovider=v,this},Property.prototype.suggester=function(){return this._suggester},Property.prototype.setValueSuggester=function(s){this._suggester=s},Property.prototype.enumOptions=function(){return this._enumOptions&&"string"==typeof this._enumOptions?[this._enumOptions+""]:this._enumOptions},Property.prototype.getOftenKeys=function(){return this._oftenKeys},Property.prototype.withOftenKeys=function(keys){return this._oftenKeys=keys,this},Property.prototype.withCanBeValue=function(){return this._canBeValue=!0,this},Property.prototype.withInherited=function(w){this._isInherited=w},Property.prototype.isInherited=function(){return this._isInherited},Property.prototype.isAllowNull=function(){return this._allowsNull},Property.prototype.withAllowNull=function(){this._allowsNull=!0},Property.prototype.getCanBeDuplicator=function(){return this._canBeDuplicator},Property.prototype.canBeValue=function(){return this._canBeValue},Property.prototype.setCanBeDuplicator=function(){return this._canBeDuplicator=!0,!0},Property.prototype.inheritedContextValue=function(){return this._inheritsValueFromContext},Property.prototype.withInheritedContextValue=function(v){return this._inheritsValueFromContext=v,this},Property.prototype.withContextRequirement=function(name,value){this._contextReq.push({name:name,value:value})},Property.prototype.getContextRequirements=function(){return this._contextReq},Property.prototype.withDescribes=function(a){return this._describes=a,this},Property.prototype.describesAnnotation=function(){return null!=this._describes},Property.prototype.describedAnnotation=function(){return this._describes},Property.prototype.isReference=function(){return this.range()instanceof ReferenceType},Property.prototype.referencesTo=function(){return this.range().getReferencedType()},Property.prototype.newInstanceName=function(){return this._newInstanceName?this._newInstanceName:this.range().nameId()},Property.prototype.withThisPropertyDeclaresFields=function(b){return void 0===b&&(b=!0),this._declaresFields=b,this},Property.prototype.isThisPropertyDeclaresTypeFields=function(){return this._declaresFields},Property.prototype.withNewInstanceName=function(name){return this._newInstanceName=name,this},Property.prototype.addChildValueConstraint=function(c){this.determinesChildValues.push(c)},Property.prototype.getChildValueConstraints=function(){return this.determinesChildValues},Property.prototype.childRestrictions=function(){return this.determinesChildValues},Property.prototype.id=function(){return this._id?this._id:this._groupName?this.domain().getAdapter(RAMLService).getDeclaringNode()?null:(this._id=this._groupName+this.domain().nameId(),this._id):null},Property.prototype.isAnnotation=function(){return"annotations"==this._groupName&&this.domain()&&!this.domain().isUserDefined()},Property.prototype.withFromParentValue=function(v){return void 0===v&&(v=!0),this._isFromParentValue=v,this},Property.prototype.withFromParentKey=function(v){return void 0===v&&(v=!0),this._isFromParentKey=v,this},Property.prototype.isFromParentKey=function(){return this._isFromParentKey},Property.prototype.isFromParentValue=function(){return this._isFromParentValue},Property.prototype.withGroupName=function(gname){return this._groupName=gname,this},Property.prototype.unmerge=function(){return this._groupName=this.nameId(),this},Property.prototype.merge=function(){return this._groupName=null,this},Property.prototype.withKey=function(isKey){return this._key=isKey,this},Property.prototype.isKey=function(){return this._key},Property.prototype.isMerged=function(){return null==this._groupName},Property.prototype.groupName=function(){return this._groupName},Property.prototype.key=function(){return null},Property}(typeSystem.Property);exports.Property=Property;var UserDefinedProp=function(_super){function UserDefinedProp(name,source){_super.call(this,name),this._node=source}return __extends(UserDefinedProp,_super),UserDefinedProp.prototype.withDisplayName=function(name){this._displayName=name},UserDefinedProp.prototype.getDisplayName=function(){return this._displayName},UserDefinedProp.prototype.node=function(){return this._node||null==this.sourceProvider||(this._node=this.sourceProvider.getSource()),this._node},UserDefinedProp.prototype.setSourceProvider=function(sourceProvider){this.sourceProvider=sourceProvider},UserDefinedProp}(Property);exports.UserDefinedProp=UserDefinedProp;var RAMLPropertyDocumentationService=function(){function RAMLPropertyDocumentationService(){}return RAMLPropertyDocumentationService.prototype.setDocTableName=function(val){this._documentationTableName=val},RAMLPropertyDocumentationService.prototype.docTableName=function(){return this._documentationTableName},RAMLPropertyDocumentationService.prototype.setHidden=function(val){this._isHidden=val},RAMLPropertyDocumentationService.prototype.isHidden=function(){return this._isHidden},RAMLPropertyDocumentationService.prototype.setMarkdownDescription=function(val){this._markdownDescription=val},RAMLPropertyDocumentationService.prototype.markdownDescription=function(){return this._markdownDescription},RAMLPropertyDocumentationService.prototype.setValueDescription=function(val){this._valueDescription=val},RAMLPropertyDocumentationService.prototype.valueDescription=function(){return this._valueDescription},RAMLPropertyDocumentationService}();exports.RAMLPropertyDocumentationService=RAMLPropertyDocumentationService;var RAMLPropertyParserService=function(_super){function RAMLPropertyParserService(){_super.apply(this,arguments)}return __extends(RAMLPropertyParserService,_super),RAMLPropertyParserService.prototype.isSystem=function(){return this._isSystemProperty},RAMLPropertyParserService.prototype.withSystem=function(s){return this._isSystemProperty=s,this},RAMLPropertyParserService.prototype.isEmbedMap=function(){return this._isEmbededMap},RAMLPropertyParserService.prototype.withEmbedMap=function(){return this._isEmbededMap=!0,this},RAMLPropertyParserService}(RAMLPropertyDocumentationService);exports.RAMLPropertyParserService=RAMLPropertyParserService;var RAMLPropertyService=function(_super){function RAMLPropertyService(_property){if(_super.call(this),this._property=_property,this._meta={},!_property)throw new Error;_super.call(this)}return __extends(RAMLPropertyService,_super),RAMLPropertyService.prototype.valueDocProvider=function(){return this._property.valueDocProvider()},RAMLPropertyService.prototype.withPropertyGrammarType=function(pt){this._propertyGrammarType=pt},RAMLPropertyService.prototype.getPropertyGrammarType=function(){return this._propertyGrammarType},RAMLPropertyService.prototype.id=function(){return this._property.nameId()},RAMLPropertyService.prototype.range=function(){return this._property.range()},RAMLPropertyService.prototype.domain=function(){return this._property.domain()},RAMLPropertyService.prototype.isAllowNull=function(){return this._property.isAllowNull()},RAMLPropertyService.prototype.referencesTo=function(){return this._property.referencesTo()},RAMLPropertyService.prototype.isReference=function(){return this._property.isReference()},RAMLPropertyService.prototype.nameId=function(){return this._property.nameId()},RAMLPropertyService.prototype.priority=function(){return this.isKey()?128:this.isReference()?64:this.isTypeExpr()?32:"example"==this.nameId()?0:-1024},RAMLPropertyService.prototype.isKey=function(){return this._property instanceof Property?this._property.isKey():!1},RAMLPropertyService.prototype.isMerged=function(){return this._property instanceof Property?this._property.isMerged():!1},RAMLPropertyService.prototype.isTypeExpr=function(){return this.texpr},RAMLPropertyService.prototype.isExampleProperty=function(){return this.example},RAMLPropertyService.prototype.setExample=function(e){this.example=e},RAMLPropertyService.prototype.setTypeExpression=function(e){this.texpr=e},RAMLPropertyService.prototype.isDescriminating=function(){return this._property.isDescriminator()},RAMLPropertyService.prototype.putMeta=function(key,value){this._meta[key]=value},RAMLPropertyService.prototype.meta=function(key){return this._meta[key]},RAMLPropertyService}(RAMLPropertyParserService);exports.RAMLPropertyService=RAMLPropertyService;var RAMLService=function(){function RAMLService(d){this._allowsOptionalProperties=!1,this._possibleInterfaces=[],this._canInherit=[],this._declaredBy=[],this._aliases=[],this._defining=[],this._runtimeExtenders=[],this._declaresType=null,this._isTemplate=!1,this._contextRequirements=[],this._type=d}return RAMLService.prototype.withAllowQuestion=function(){this._allowsOptionalProperties=!0},RAMLService.prototype.getAllowQuestion=function(){return this._allowsOptionalProperties},RAMLService.prototype.withCanInherit=function(clazz){this._canInherit.push(clazz)},RAMLService.prototype.getReferenceIs=function(){return this._referenceIs},RAMLService.prototype.withReferenceIs=function(fname){this._referenceIs=fname},RAMLService.prototype.descriminatorValue=function(){return 0==this.valueRequirements().length?this.nameId():this.valueRequirements()[0].value},RAMLService.prototype.getCanInherit=function(){return this._canInherit},RAMLService.prototype.withAllowAny=function(){this._allowsAnyChildren=!0},RAMLService.prototype.getAllowAny=function(){return this._allowsAnyChildren||this._type.isExternal()},RAMLService.prototype.globallyDeclaredBy=function(){return this._declaredBy},RAMLService.prototype.setGloballyDeclaredBy=function(c){this._declaredBy.push(c)},RAMLService.prototype.setDeclaringNode=function(n){
this._node=n},RAMLService.prototype.nameId=function(){return this._type.nameId()},RAMLService.prototype.universe=function(){return this._type.universe()},RAMLService.prototype.isAssignableFrom=function(name){return this._type.isAssignableFrom(name)},RAMLService.prototype.setConsumesRefs=function(b){this._consumesRef=b},RAMLService.prototype.definingPropertyIsEnough=function(v){this._defining.push(v)},RAMLService.prototype.getDefining=function(){return this._defining},RAMLService.prototype.getConsumesRefs=function(){return this._consumesRef},RAMLService.prototype.addAlias=function(al){this._aliases.push(al)},RAMLService.prototype.getAliases=function(){return this._aliases},RAMLService.prototype.valueRequirements=function(){return this._type.valueRequirements()},RAMLService.prototype.isAnnotation=function(){return this._annotationChecked?this._isAnnotation:(this._annotationChecked=!0,this._isAnnotation=this._type.allSuperTypes().some(function(x){return x.key()&&"AnnotationRef"==x.key().name}),this._isAnnotation)},RAMLService.prototype.allowValue=function(){return this._allowsValueSet?this._allowsValue:this._type.allProperties().some(function(x){return x.isFromParentValue()||x.canBeValue()})?(this._allowsValue=!0,this._allowsValueSet=!0,!0):(this._allowsValueSet=!0,!1)},RAMLService.prototype.key=function(){return this._type.key()},RAMLService.prototype.getRepresentationOf=function(){return this._representationOf},RAMLService.prototype.getPath=function(){return""},RAMLService.prototype.isDeclaration=function(){return this._isTemplate?!0:this._convertsToGlobal?!0:this._declaresType?!0:this.key()&&"Library"===this.key().name?!0:!1},RAMLService.prototype.isGlobalDeclaration=function(){return this._actuallyExports?!0:this._isTemplate?!0:this._declaresType?!0:!1},RAMLService.prototype.isTypeSystemMember=function(){return null!=this._declaresType},RAMLService.prototype.getExtendedType=function(){return this.universe().type(this._declaresType)},RAMLService.prototype.setInlinedTemplates=function(b){return this._isTemplate=b,this},RAMLService.prototype.getRuntimeExtenders=function(){return this._runtimeExtenders},RAMLService.prototype.isInlinedTemplates=function(){return this._isTemplate},RAMLService.prototype.setExtendedTypeName=function(name){this._declaresType=name;var tp=this.universe().type(name);if(tp instanceof NodeClass){var nc=tp;nc.getAdapter(RAMLService)._runtimeExtenders.push(this._type)}},RAMLService.prototype.getKeyProp=function(){for(var c=this._type.allProperties(),i=0;i<c.length;i++)if(c[i].getAdapter(RAMLPropertyService).isKey())return c[i];return null},RAMLService.prototype.withActuallyExports=function(pname){this._actuallyExports=pname},RAMLService.prototype.withConvertsToGlobal=function(pname){this._convertsToGlobal=pname},RAMLService.prototype.getConvertsToGlobal=function(){return this._convertsToGlobal},RAMLService.prototype.getActuallyExports=function(){return this._actuallyExports},RAMLService.prototype.isUserDefined=function(){return this._type instanceof NodeClass?this._type.isUserDefined():this._type instanceof AbstractType?this._type.isUserDefined():!1},RAMLService.prototype.withContextRequirement=function(name,value){this._contextRequirements.push({name:name,value:value})},RAMLService.prototype.getContextRequirements=function(){return this._contextRequirements},RAMLService.prototype.findMembersDeterminer=function(){for(var c=this._type.allProperties(),i=0;i<c.length;i++)if(c[i].isThisPropertyDeclaresTypeFields())return c[i];return null},RAMLService.prototype.getDeclaringNode=function(){if(this._node)return this._node;if(this._type){var sourceNode=this._type.getExtra(exports.SOURCE_EXTRA);return sourceNode?sourceNode instanceof SourceProvider||sourceNode.getSource&&"function"==typeof sourceNode.getSource?sourceNode.getSource():sourceNode:null}return null},RAMLService.prototype.registerSupertypes=function(classNames){var _this=this,universe=this._type.universe();classNames.forEach(function(x){var supertype=universe.type(x);supertype&&_this._type.addSuperType(supertype)})},RAMLService.prototype.registerPossibleInterfaces=function(classNames){for(var universe=this._type.universe(),_i=0,classNames_1=classNames;_i<classNames_1.length;_i++){var x=classNames_1[_i],supertype=universe.type(x);if(!supertype)return;this._possibleInterfaces.push(supertype)}},RAMLService.prototype.possibleInterfaces=function(){return this._possibleInterfaces},RAMLService}();exports.RAMLService=RAMLService;var universes={},ramlDS=__webpack_require__(56),jsonDefinitions=ramlDS.universeDumps,ts2def=__webpack_require__(57),unDesc=__webpack_require__(58);exports.universesInfo=unDesc,exports.getUniverse=function(){var x=function(key){if(universes[key])return universes[key];var src=jsonDefinitions[key],universe=ts2def.toDefSystem(src,"RAML08"==key?unDesc.Universe08:unDesc.Universe10);return universe&&(universe.setUniverseVersion(key),universes[key]=universe),universe};return x.availableUniverses=function(){return Object.keys(jsonDefinitions)},x}()},function(module,exports,__webpack_require__){function Url(){this.protocol=null,this.slashes=null,this.auth=null,this.host=null,this.port=null,this.hostname=null,this.hash=null,this.search=null,this.query=null,this.pathname=null,this.path=null,this.href=null}function urlParse(url,parseQueryString,slashesDenoteHost){if(url&&isObject(url)&&url instanceof Url)return url;var u=new Url;return u.parse(url,parseQueryString,slashesDenoteHost),u}function urlFormat(obj){return isString(obj)&&(obj=urlParse(obj)),obj instanceof Url?obj.format():Url.prototype.format.call(obj)}function urlResolve(source,relative){return urlParse(source,!1,!0).resolve(relative)}function urlResolveObject(source,relative){return source?urlParse(source,!1,!0).resolveObject(relative):relative}function isString(arg){return"string"==typeof arg}function isObject(arg){return"object"==typeof arg&&null!==arg}function isNull(arg){return null===arg}function isNullOrUndefined(arg){return null==arg}var punycode=__webpack_require__(82);exports.parse=urlParse,exports.resolve=urlResolve,exports.resolveObject=urlResolveObject,exports.format=urlFormat,exports.Url=Url;var protocolPattern=/^([a-z0-9.+-]+:)/i,portPattern=/:[0-9]*$/,delims=["<",">",'"',"`"," ","\r","\n","	"],unwise=["{","}","|","\\","^","`"].concat(delims),autoEscape=["'"].concat(unwise),nonHostChars=["%","/","?",";","#"].concat(autoEscape),hostEndingChars=["/","?","#"],hostnameMaxLen=255,hostnamePartPattern=/^[a-z0-9A-Z_-]{0,63}$/,hostnamePartStart=/^([a-z0-9A-Z_-]{0,63})(.*)$/,unsafeProtocol={javascript:!0,"javascript:":!0},hostlessProtocol={javascript:!0,"javascript:":!0},slashedProtocol={http:!0,https:!0,ftp:!0,gopher:!0,file:!0,"http:":!0,"https:":!0,"ftp:":!0,"gopher:":!0,"file:":!0},querystring=__webpack_require__(81);Url.prototype.parse=function(url,parseQueryString,slashesDenoteHost){if(!isString(url))throw new TypeError("Parameter 'url' must be a string, not "+typeof url);var rest=url;rest=rest.trim();var proto=protocolPattern.exec(rest);if(proto){proto=proto[0];var lowerProto=proto.toLowerCase();this.protocol=lowerProto,rest=rest.substr(proto.length)}if(slashesDenoteHost||proto||rest.match(/^\/\/[^@\/]+@[^@\/]+/)){var slashes="//"===rest.substr(0,2);!slashes||proto&&hostlessProtocol[proto]||(rest=rest.substr(2),this.slashes=!0)}if(!hostlessProtocol[proto]&&(slashes||proto&&!slashedProtocol[proto])){for(var hostEnd=-1,i=0;i<hostEndingChars.length;i++){var hec=rest.indexOf(hostEndingChars[i]);-1!==hec&&(-1===hostEnd||hostEnd>hec)&&(hostEnd=hec)}var auth,atSign;atSign=-1===hostEnd?rest.lastIndexOf("@"):rest.lastIndexOf("@",hostEnd),-1!==atSign&&(auth=rest.slice(0,atSign),rest=rest.slice(atSign+1),this.auth=decodeURIComponent(auth)),hostEnd=-1;for(var i=0;i<nonHostChars.length;i++){var hec=rest.indexOf(nonHostChars[i]);-1!==hec&&(-1===hostEnd||hostEnd>hec)&&(hostEnd=hec)}-1===hostEnd&&(hostEnd=rest.length),this.host=rest.slice(0,hostEnd),rest=rest.slice(hostEnd),this.parseHost(),this.hostname=this.hostname||"";var ipv6Hostname="["===this.hostname[0]&&"]"===this.hostname[this.hostname.length-1];if(!ipv6Hostname)for(var hostparts=this.hostname.split(/\./),i=0,l=hostparts.length;l>i;i++){var part=hostparts[i];if(part&&!part.match(hostnamePartPattern)){for(var newpart="",j=0,k=part.length;k>j;j++)newpart+=part.charCodeAt(j)>127?"x":part[j];if(!newpart.match(hostnamePartPattern)){var validParts=hostparts.slice(0,i),notHost=hostparts.slice(i+1),bit=part.match(hostnamePartStart);bit&&(validParts.push(bit[1]),notHost.unshift(bit[2])),notHost.length&&(rest="/"+notHost.join(".")+rest),this.hostname=validParts.join(".");break}}}if(this.hostname.length>hostnameMaxLen?this.hostname="":this.hostname=this.hostname.toLowerCase(),!ipv6Hostname){for(var domainArray=this.hostname.split("."),newOut=[],i=0;i<domainArray.length;++i){var s=domainArray[i];newOut.push(s.match(/[^A-Za-z0-9_-]/)?"xn--"+punycode.encode(s):s)}this.hostname=newOut.join(".")}var p=this.port?":"+this.port:"",h=this.hostname||"";this.host=h+p,this.href+=this.host,ipv6Hostname&&(this.hostname=this.hostname.substr(1,this.hostname.length-2),"/"!==rest[0]&&(rest="/"+rest))}if(!unsafeProtocol[lowerProto])for(var i=0,l=autoEscape.length;l>i;i++){var ae=autoEscape[i],esc=encodeURIComponent(ae);esc===ae&&(esc=escape(ae)),rest=rest.split(ae).join(esc)}var hash=rest.indexOf("#");-1!==hash&&(this.hash=rest.substr(hash),rest=rest.slice(0,hash));var qm=rest.indexOf("?");if(-1!==qm?(this.search=rest.substr(qm),this.query=rest.substr(qm+1),parseQueryString&&(this.query=querystring.parse(this.query)),rest=rest.slice(0,qm)):parseQueryString&&(this.search="",this.query={}),rest&&(this.pathname=rest),slashedProtocol[lowerProto]&&this.hostname&&!this.pathname&&(this.pathname="/"),this.pathname||this.search){var p=this.pathname||"",s=this.search||"";this.path=p+s}return this.href=this.format(),this},Url.prototype.format=function(){var auth=this.auth||"";auth&&(auth=encodeURIComponent(auth),auth=auth.replace(/%3A/i,":"),auth+="@");var protocol=this.protocol||"",pathname=this.pathname||"",hash=this.hash||"",host=!1,query="";this.host?host=auth+this.host:this.hostname&&(host=auth+(-1===this.hostname.indexOf(":")?this.hostname:"["+this.hostname+"]"),this.port&&(host+=":"+this.port)),this.query&&isObject(this.query)&&Object.keys(this.query).length&&(query=querystring.stringify(this.query));var search=this.search||query&&"?"+query||"";return protocol&&":"!==protocol.substr(-1)&&(protocol+=":"),this.slashes||(!protocol||slashedProtocol[protocol])&&host!==!1?(host="//"+(host||""),pathname&&"/"!==pathname.charAt(0)&&(pathname="/"+pathname)):host||(host=""),hash&&"#"!==hash.charAt(0)&&(hash="#"+hash),search&&"?"!==search.charAt(0)&&(search="?"+search),pathname=pathname.replace(/[?#]/g,function(match){return encodeURIComponent(match)}),search=search.replace("#","%23"),protocol+host+pathname+search+hash},Url.prototype.resolve=function(relative){return this.resolveObject(urlParse(relative,!1,!0)).format()},Url.prototype.resolveObject=function(relative){if(isString(relative)){var rel=new Url;rel.parse(relative,!1,!0),relative=rel}var result=new Url;if(Object.keys(this).forEach(function(k){result[k]=this[k]},this),result.hash=relative.hash,""===relative.href)return result.href=result.format(),result;if(relative.slashes&&!relative.protocol)return Object.keys(relative).forEach(function(k){"protocol"!==k&&(result[k]=relative[k])}),slashedProtocol[result.protocol]&&result.hostname&&!result.pathname&&(result.path=result.pathname="/"),result.href=result.format(),result;if(relative.protocol&&relative.protocol!==result.protocol){if(!slashedProtocol[relative.protocol])return Object.keys(relative).forEach(function(k){result[k]=relative[k]}),result.href=result.format(),result;if(result.protocol=relative.protocol,relative.host||hostlessProtocol[relative.protocol])result.pathname=relative.pathname;else{for(var relPath=(relative.pathname||"").split("/");relPath.length&&!(relative.host=relPath.shift()););relative.host||(relative.host=""),relative.hostname||(relative.hostname=""),""!==relPath[0]&&relPath.unshift(""),relPath.length<2&&relPath.unshift(""),result.pathname=relPath.join("/")}if(result.search=relative.search,result.query=relative.query,result.host=relative.host||"",result.auth=relative.auth,result.hostname=relative.hostname||relative.host,result.port=relative.port,result.pathname||result.search){var p=result.pathname||"",s=result.search||"";result.path=p+s}return result.slashes=result.slashes||relative.slashes,result.href=result.format(),result}var isSourceAbs=result.pathname&&"/"===result.pathname.charAt(0),isRelAbs=relative.host||relative.pathname&&"/"===relative.pathname.charAt(0),mustEndAbs=isRelAbs||isSourceAbs||result.host&&relative.pathname,removeAllDots=mustEndAbs,srcPath=result.pathname&&result.pathname.split("/")||[],relPath=relative.pathname&&relative.pathname.split("/")||[],psychotic=result.protocol&&!slashedProtocol[result.protocol];if(psychotic&&(result.hostname="",result.port=null,result.host&&(""===srcPath[0]?srcPath[0]=result.host:srcPath.unshift(result.host)),result.host="",relative.protocol&&(relative.hostname=null,relative.port=null,relative.host&&(""===relPath[0]?relPath[0]=relative.host:relPath.unshift(relative.host)),relative.host=null),mustEndAbs=mustEndAbs&&(""===relPath[0]||""===srcPath[0])),isRelAbs)result.host=relative.host||""===relative.host?relative.host:result.host,result.hostname=relative.hostname||""===relative.hostname?relative.hostname:result.hostname,result.search=relative.search,result.query=relative.query,srcPath=relPath;else if(relPath.length)srcPath||(srcPath=[]),srcPath.pop(),srcPath=srcPath.concat(relPath),result.search=relative.search,result.query=relative.query;else if(!isNullOrUndefined(relative.search)){if(psychotic){result.hostname=result.host=srcPath.shift();var authInHost=result.host&&result.host.indexOf("@")>0?result.host.split("@"):!1;authInHost&&(result.auth=authInHost.shift(),result.host=result.hostname=authInHost.shift())}return result.search=relative.search,result.query=relative.query,isNull(result.pathname)&&isNull(result.search)||(result.path=(result.pathname?result.pathname:"")+(result.search?result.search:"")),result.href=result.format(),result}if(!srcPath.length)return result.pathname=null,result.search?result.path="/"+result.search:result.path=null,result.href=result.format(),result;for(var last=srcPath.slice(-1)[0],hasTrailingSlash=(result.host||relative.host)&&("."===last||".."===last)||""===last,up=0,i=srcPath.length;i>=0;i--)last=srcPath[i],"."==last?srcPath.splice(i,1):".."===last?(srcPath.splice(i,1),up++):up&&(srcPath.splice(i,1),up--);if(!mustEndAbs&&!removeAllDots)for(;up--;up)srcPath.unshift("..");!mustEndAbs||""===srcPath[0]||srcPath[0]&&"/"===srcPath[0].charAt(0)||srcPath.unshift(""),hasTrailingSlash&&"/"!==srcPath.join("/").substr(-1)&&srcPath.push("");var isAbsolute=""===srcPath[0]||srcPath[0]&&"/"===srcPath[0].charAt(0);if(psychotic){result.hostname=result.host=isAbsolute?"":srcPath.length?srcPath.shift():"";var authInHost=result.host&&result.host.indexOf("@")>0?result.host.split("@"):!1;authInHost&&(result.auth=authInHost.shift(),result.host=result.hostname=authInHost.shift())}return mustEndAbs=mustEndAbs||result.host&&srcPath.length,mustEndAbs&&!isAbsolute&&srcPath.unshift(""),srcPath.length?result.pathname=srcPath.join("/"):(result.pathname=null,result.path=null),isNull(result.pathname)&&isNull(result.search)||(result.path=(result.pathname?result.pathname:"")+(result.search?result.search:"")),result.auth=relative.auth||result.auth,result.slashes=result.slashes||relative.slashes,result.href=result.format(),result},Url.prototype.parseHost=function(){var host=this.host,port=portPattern.exec(host);port&&(port=port[0],":"!==port&&(this.port=port.substr(1)),host=host.substr(0,host.length-port.length)),host&&(this.hostname=host)}},function(module,exports,__webpack_require__){module.exports=__WEBPACK_EXTERNAL_MODULE_38__},function(module,exports,__webpack_require__){"use strict";var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},yaml=__webpack_require__(74),json=__webpack_require__(51),stringify=__webpack_require__(61),impl=__webpack_require__(28),util=__webpack_require__(32),universes=__webpack_require__(18),def=__webpack_require__(36),universeHelpers=__webpack_require__(14),_=__webpack_require__(65),LowLevelProxyNode=function(){function LowLevelProxyNode(_parent,_transformer,ramlVersion){this._parent=_parent,this._transformer=_transformer,this.ramlVersion=ramlVersion}return LowLevelProxyNode.prototype.hasInnerIncludeError=function(){return this._originalNode.hasInnerIncludeError()},LowLevelProxyNode.prototype.keyKind=function(){return this._originalNode.keyKind()},LowLevelProxyNode.prototype.primaryNode=function(){return null},LowLevelProxyNode.prototype.isAnnotatedScalar=function(){return this._originalNode.isAnnotatedScalar()},LowLevelProxyNode.prototype.actual=function(){return this._originalNode?this._originalNode.actual():this},LowLevelProxyNode.prototype.transformer=function(){return this._transformer},LowLevelProxyNode.prototype.originalNode=function(){return this._originalNode},LowLevelProxyNode.prototype.start=function(){return this._originalNode.start()},LowLevelProxyNode.prototype.end=function(){return this._originalNode.end()},LowLevelProxyNode.prototype.value=function(toString){throw new Error("The method must be overridden")},LowLevelProxyNode.prototype.includeErrors=function(){return this._originalNode.includeErrors()},LowLevelProxyNode.prototype.includePath=function(){return this._originalNode.includePath()},LowLevelProxyNode.prototype.includeReference=function(){return this._originalNode.includeReference()},LowLevelProxyNode.prototype.setKeyOverride=function(_key){this._keyOverride=_key},LowLevelProxyNode.prototype.setValueOverride=function(value){this._valueOverride=value},LowLevelProxyNode.prototype.key=function(raw){return void 0===raw&&(raw=!1),this._keyOverride?this._keyOverride:this._originalNode.key(raw)},LowLevelProxyNode.prototype.optional=function(){return this.originalNode().optional()},LowLevelProxyNode.prototype.children=function(){throw new Error("The method must be overridden")},LowLevelProxyNode.prototype.parent=function(){return this._parent},LowLevelProxyNode.prototype.unit=function(){return this._originalNode.unit()},LowLevelProxyNode.prototype.includeBaseUnit=function(){return this._originalNode.unit()},LowLevelProxyNode.prototype.anchorId=function(){return this._originalNode.anchorId()},LowLevelProxyNode.prototype.errors=function(){return this._originalNode.errors()},LowLevelProxyNode.prototype.anchoredFrom=function(){return this._originalNode.anchoredFrom()},LowLevelProxyNode.prototype.includedFrom=function(){return this._originalNode.includedFrom()},LowLevelProxyNode.prototype.visit=function(v){v(this)&&this.children().forEach(function(x){return x.visit(v)})},LowLevelProxyNode.prototype.addChild=function(n){},LowLevelProxyNode.prototype.execute=function(cmd){},LowLevelProxyNode.prototype.dump=function(){return null},LowLevelProxyNode.prototype.dumpToObject=function(){var serialized=json.serialize2(this,!1);if(this.kind()==yaml.Kind.MAPPING){var obj={};return obj[this.key(!0)]=serialized,obj}return serialized},LowLevelProxyNode.prototype.keyStart=function(){return this._originalNode.keyStart()},LowLevelProxyNode.prototype.keyEnd=function(){return this._originalNode.keyEnd()},LowLevelProxyNode.prototype.valueStart=function(){return this._originalNode.valueStart()},LowLevelProxyNode.prototype.valueEnd=function(){return this._originalNode.valueEnd()},LowLevelProxyNode.prototype.isValueLocal=function(){return this._originalNode.isValueLocal()},LowLevelProxyNode.prototype.kind=function(){return this._originalNode.kind()},LowLevelProxyNode.prototype.valueKind=function(){return this._originalNode.valueKind()},LowLevelProxyNode.prototype.anchorValueKind=function(){return this._originalNode.anchorValueKind()},LowLevelProxyNode.prototype.show=function(msg){this._originalNode.show(msg)},LowLevelProxyNode.prototype.setHighLevelParseResult=function(highLevelParseResult){this._highLevelParseResult=highLevelParseResult},LowLevelProxyNode.prototype.highLevelParseResult=function(){return this._highLevelParseResult},LowLevelProxyNode.prototype.setHighLevelNode=function(highLevel){this._highLevelNode=highLevel},LowLevelProxyNode.prototype.highLevelNode=function(){return this._highLevelNode?this._highLevelNode:this._originalNode.highLevelNode()},LowLevelProxyNode.prototype.text=function(unitText){throw new Error("not implemented")},LowLevelProxyNode.prototype.copy=function(){throw new Error("not implemented")},LowLevelProxyNode.prototype.markup=function(json){throw new Error("not implemented")},LowLevelProxyNode.prototype.nodeDefinition=function(){return impl.getDefinitionForLowLevelNode(this)},LowLevelProxyNode.prototype.includesContents=function(){return this._originalNode.includesContents()},LowLevelProxyNode}();exports.LowLevelProxyNode=LowLevelProxyNode;var LowLevelCompositeNode=function(_super){function LowLevelCompositeNode(node,parent,transformer,ramlVersion,isPrimary){void 0===isPrimary&&(isPrimary=!0),_super.call(this,parent,transformer,ramlVersion),this.isPrimary=isPrimary,this._adoptedNodes=[],this._preserveAnnotations=!1;var originalParent=this.parent()?this.parent().originalNode():null;node instanceof LowLevelValueTransformingNode?this._originalNode=node:this._originalNode=new LowLevelValueTransformingNode(node,originalParent,transformer,this.ramlVersion),this._adoptedNodes.push(this._originalNode)}return __extends(LowLevelCompositeNode,_super),LowLevelCompositeNode.prototype.adoptedNodes=function(){return this._adoptedNodes},LowLevelCompositeNode.prototype.primaryNode=function(){return this.isPrimary?this._originalNode:null},LowLevelCompositeNode.prototype.parent=function(){return this._parent},LowLevelCompositeNode.prototype.adopt=function(node,transformer){transformer||(transformer=this._transformer);var originalParent=this.parent()?this.parent().originalNode():null,tNode=new LowLevelValueTransformingNode(node,originalParent,transformer,this.ramlVersion);this._adoptedNodes.push(tNode),this._children&&this._children.forEach(function(x){return x._parent=null}),this._children=null,this.highLevelNode()&&this.highLevelNode().resetChildren()},LowLevelCompositeNode.prototype.value=function(toString){if(this._valueOverride)return this._valueOverride;var val,valuableNodes=this._adoptedNodes.filter(function(x){return null!=x.value()});return val=valuableNodes.length>0?valuableNodes[0].value(toString):this._originalNode.value(toString),val instanceof LowLevelValueTransformingNode&&(this._valueOverride=val),val},LowLevelCompositeNode.prototype.children=function(){var _this=this;if(this._children)return this._children;for(var result=[],canBeMap=!1,canBeSeq=!1,_i=0,_a=this._adoptedNodes;_i<_a.length;_i++){var x=_a[_i],adoptedNodeChildren=x.children();adoptedNodeChildren&&adoptedNodeChildren.length>0&&(canBeSeq=!0,adoptedNodeChildren[0].key()&&this.originalNode().valueKind()!=yaml.Kind.SEQ&&(canBeMap=!0))}if(canBeMap)result=this.collectChildrenWithKeys();else if(canBeSeq){result=this.collectChildrenWithKeys();var map={};this._adoptedNodes.forEach(function(x){return x.children().filter(function(y){return!y.key()}).forEach(function(y){var isPrimary=x==_this.primaryNode(),key=_this.buildKey(y);if(isPrimary||!map[key]){map[key]=!0;var transformer=x.transformer()?x.transformer():_this.transformer(),ch=y instanceof LowLevelValueTransformingNode?y.originalNode():y;result.push(new LowLevelCompositeNode(ch,_this,transformer,_this.ramlVersion,isPrimary))}})})}else result=[];return this._children=result,result},LowLevelCompositeNode.prototype.buildKey=function(y){var obj=json.serialize(y),def=this.nodeDefinition();if(def&&(def.key()==universes.Universe08.TraitRef||def.key()==universes.Universe08.ResourceTypeRef||def.key()==universes.Universe10.TraitRef||def.key()==universes.Universe10.ResourceTypeRef)&&obj&&"object"==typeof obj){var keys=Object.keys(obj);keys.length>0&&(obj=keys[0])}return null==obj?"":stringify(obj)},LowLevelCompositeNode.prototype.collectChildrenWithKeys=function(){for(var _this=this,result=[],m={},_i=0,_a=this._adoptedNodes;_i<_a.length;_i++)for(var x=_a[_i],isPrimary=x==this.primaryNode(),_b=0,_c=x.children();_b<_c.length;_b++){var y=_c[_b],key=y.originalNode().key();if(key&&x.transformer()){var isAnnotation=null!=key&&(this._preserveAnnotations||this.isResource())&&util.stringStartsWith(key,"(")&&util.stringEndsWith(key,")");isAnnotation||(key=x.transformer().transform(key).value)}if(!this.skipKey(key,isPrimary)&&key){var arr=m[key];arr||(arr=[],m[key]=arr),arr.push({node:y.originalNode(),transformer:x.transformer(),isPrimary:isPrimary})}}var ramlVersion=this.unit().highLevel().root().definition().universe().version(),isResource=this.key()&&"/"==this.key()[0],methodType=def.getUniverse("RAML10").type(universes.Universe10.Method.name),options=methodType.property(universes.Universe10.Method.properties.method.name).enumOptions();return Object.keys(m).forEach(function(key){var arr=m[key],allOptional=!0,hasPrimaryChildren=!1,isMethod=options.indexOf(key)>=0;if(arr.forEach(function(x){var isOpt=x.node.optional()&&("RAML10"!=ramlVersion||isResource&&isMethod);allOptional=allOptional&&isOpt,hasPrimaryChildren=hasPrimaryChildren||x.isPrimary}),hasPrimaryChildren){var primaryChildren=[];arr.filter(function(x){return x.isPrimary}).forEach(function(x){var tr=x.transformer?x.transformer:_this.transformer();primaryChildren.push(new LowLevelCompositeNode(x.node,_this,tr,_this.ramlVersion,!0))});var primaryChild=primaryChildren[0];arr.filter(function(x){return!x.isPrimary}).forEach(function(x){primaryChild.adopt(x.node,x.transformer)}),primaryChildren.forEach(function(x){return result.push(x)})}else if(!allOptional){for(var tr=arr[0].transformer?arr[0].transformer:_this.transformer(),primaryChild=new LowLevelCompositeNode(arr[0].node,_this,tr,_this.ramlVersion,!1),i=1;i<arr.length;i++)primaryChild.adopt(arr[i].node,arr[i].transformer);result.push(primaryChild)}}),result},LowLevelCompositeNode.prototype.isResource=function(){return this.highLevelNode()&&universeHelpers.isResourceType(this.highLevelNode().definition())},LowLevelCompositeNode.prototype.skipKey=function(key,isPrimary){if(isPrimary)return!1;if("RAML08"!=this.ramlVersion)return!1;universes.Universe08.Method,universes.Universe08.Resource;return!1},LowLevelCompositeNode.prototype.valueKind=function(){if(this._originalNode.kind()!=yaml.Kind.MAPPING)return null;for(var i=0;i<this._adoptedNodes.length;i++){var node=this._adoptedNodes[i],yamlNode=node.originalNode().actual();if(yamlNode&&null!=yamlNode.value)return node.valueKind()}return null},LowLevelCompositeNode.prototype.includePath=function(){for(var i=0;i<this._adoptedNodes.length;i++){var node=this._adoptedNodes[i],includePath=node.includePath();if(null!=includePath)return includePath}return null},LowLevelCompositeNode.prototype.includeBaseUnit=function(){for(var i=0;i<this._adoptedNodes.length;i++){var node=this._adoptedNodes[i],includePath=node.includePath();if(null!=includePath)return node.unit()}return _super.prototype.includeBaseUnit.call(this)},LowLevelCompositeNode.prototype.includeReference=function(){for(var i=0;i<this._adoptedNodes.length;i++){var node=this._adoptedNodes[i];if(null!=node.value())return node.includeReference()}return null},LowLevelCompositeNode.prototype.optional=function(){return _.all(this._adoptedNodes,function(x){return x.optional()})},LowLevelCompositeNode.prototype.replaceChild=function(oldNode,newNode,isPrimary,transformer){void 0===isPrimary&&(isPrimary=!1),void 0===transformer&&(transformer=null),this._children||(this._children=[]);var newCNode=new LowLevelCompositeNode(newNode,this,null,this.ramlVersion);if(null==oldNode)return this._children.push(newCNode),newCNode;var ind=this._children.indexOf(oldNode);return ind>=0?this._children[ind]=newCNode:this._children.push(newCNode),newCNode},LowLevelCompositeNode.prototype.removeChild=function(oldNode){if(this._children&&null!=oldNode){var ind=this._children.indexOf(oldNode);if(ind>=0){for(var i=ind;i<this._children.length-1;i++)this._children[i]=this._children[i+1];this._children.pop()}}},LowLevelCompositeNode.prototype.setChildren=function(nodes){var _this=this;return null==nodes?void(this._children=null):void(this._children=nodes.map(function(x){return x instanceof LowLevelCompositeNode?x:new LowLevelCompositeNode(x,_this,null,_this.ramlVersion)}))},LowLevelCompositeNode.prototype.preserveAnnotations=function(){if(!this._preserveAnnotations){if(void 0===this.isInsideResource&&(this.isInsideResource=!1,!this.isResource()))for(var parent=this._parent;parent;){if(parent.isResource()){this.isInsideResource=!0;break}parent=parent.parent()}this.isInsideResource&&(this._preserveAnnotations=!0,this._children=null)}},LowLevelCompositeNode.prototype.filterChildren=function(){this.children();var map={},filtered=[];this._children.forEach(function(x){if(null!=x.key())return void filtered.push(x);var key=JSON.stringify(json.serialize(x));map[key]||(map[key]=!0,filtered.push(x))}),this._children=filtered},LowLevelCompositeNode}(LowLevelProxyNode);exports.LowLevelCompositeNode=LowLevelCompositeNode;var LowLevelValueTransformingNode=function(_super){function LowLevelValueTransformingNode(node,parent,transformer,ramlVersion){_super.call(this,parent,transformer,ramlVersion),this._originalNode=node}return __extends(LowLevelValueTransformingNode,_super),LowLevelValueTransformingNode.prototype.value=function(toString){var val=this.originalNode().value(toString),t=this.transformer();if(t){var transformationResult=t.transform(val,toString);val=transformationResult.value}return val&&"object"==typeof val?new LowLevelValueTransformingNode(val,this._parent,this._transformer,this.ramlVersion):val},LowLevelValueTransformingNode.prototype.children=function(){var _this=this,childNodes=null,originalNode=this.originalNode();if(null!=this._transformer){var substitution=this._transformer.children(originalNode);null!=substitution&&(childNodes=substitution)}return null==childNodes&&(childNodes=originalNode.children()),childNodes.map(function(x){return new LowLevelValueTransformingNode(x,_this,_this._transformer,_this.ramlVersion)})},LowLevelValueTransformingNode.prototype.valueKind=function(){var kind=this._transformer&&this._transformer.valueKind(this.originalNode());return null!=kind?kind:_super.prototype.valueKind.call(this)},LowLevelValueTransformingNode.prototype.parent=function(){return this._parent},LowLevelValueTransformingNode.prototype.key=function(raw){void 0===raw&&(raw=!1);var key=_super.prototype.key.call(this,raw);return null!=this.transformer()?this.transformer().transform(key).value:key},LowLevelValueTransformingNode}(LowLevelProxyNode);exports.LowLevelValueTransformingNode=LowLevelValueTransformingNode},function(module,exports,__webpack_require__){"use strict";function findLastAttributeIndex(n){for(var last=-1,children=n.lowLevel().children(),i=0;i<children.length;i++){var node=children[i];if(node.isMapping()){var name=node.asMapping().key.value,property=n.definition().property(name);property&&(property.isFromParentValue()||property.range().hasValueTypeInHierarchy())&&(last=i)}}return last}function findInsertionPointLowLevel(node,llnode,property,attr){var insertionPoint=null,embed=property&&property.getAdapter(services.RAMLPropertyService).isEmbedMap();if(embed&&_.find(node.lowLevel().children(),function(x){return x.key()==property.nameId()})&&(embed=!1),attr||embed){var last=findLastAttribute(node);insertionPoint=last?last:jsyaml.InsertionPoint.atStart()}return insertionPoint}function findInsertionPoint(where,node){where.isStub()||where.clearChildrenCache();var ch=where.children(),embed=node.property()&&node.property().getAdapter(services.RAMLPropertyService).isEmbedMap();
embed&&_.find(where.lowLevel().children(),function(x){return x.key()==node.property().nameId()})&&(embed=!1);if(!node.isAttr()&&!embed||universeHelpers.isMethodType(where.definition())&&node.property&&universeHelpers.isIsProperty(node.property())){var pname=node.property().nameId(),cls=where.definition(),pindex=(cls.allProperties(),cls.propertyIndex(pname));if(0>pindex)return null;for(var llchilds=where.lowLevel().children(),i=0;i<llchilds.length;i++){var llch=llchilds[i];if(llch.isMapping()){var cpnme=llch.asMapping().key.value,pi=cls.propertyIndex(cpnme);if(pi>pindex){var lastok=i-1;return 0>lastok?null:(console.log("insert to node: "+lastok),llchilds[lastok])}}}return null}for(var toRet=null,i=0;i<ch.length&&ch[i].isAttr();i++)toRet=ch[i].lowLevel();return null==toRet&&(toRet=where.lowLevel()),toRet}function removeNodeFrom(source,node){if(source.isStub()){if(node instanceof hlimpl.ASTNodeImpl){var cm=node;if(cm.isInEdit)return}if(!source._children)return;return void(source._children=source._children.filter(function(x){return x!=node}))}var command=new ll.CompositeCommand;if(node instanceof hlimpl.ASTNodeImpl){var aNode=node;aNode.property().getAdapter(services.RAMLPropertyService).isMerged()?command.commands.push(ll.removeNode(source.lowLevel(),aNode.lowLevel())):1==source.elementsOfKind(aNode.property().nameId()).length?command.commands.push(ll.removeNode(source.lowLevel(),aNode.lowLevel().parent().parent())):command.commands.push(ll.removeNode(source.lowLevel(),aNode.lowLevel()))}else command.commands.push(ll.removeNode(source.lowLevel(),node.lowLevel()));source.lowLevel().execute(command)}function initEmptyRAMLFile(node){var command=(node.lowLevel().root(),new ll.CompositeCommand),newroot=jsyaml.createMap([]);command.commands.push(ll.initRamlFile(node.lowLevel(),newroot)),node.lowLevel().execute(command);var root=node.root();root._node=newroot,root.clearChildrenCache()}function setValue(node,value){if(value!=node.value()){var c=new ll.CompositeCommand;if("string"==typeof value){var val=value;node.property().isFromParentKey()||node.property().isAnnotation()?(node.property().isAnnotation()&&(val="("+val+")"),c.commands.push(ll.setKey(node.lowLevel(),val))):val&&0!=val.length||node.isEmbedded()?(val||(val=""),c.commands.push(ll.setAttr(node.lowLevel(),val))):(c.commands.push(ll.removeNode(node.lowLevel().parent(),node.lowLevel())),node.parent().clearChildrenCache())}else{if(node.property().isFromParentKey())throw new Error("couldn't set structured value to a key: "+node.property().nameId());var sval=value;c.commands.push(ll.setAttrStructured(node.lowLevel(),sval))}node.lowLevel().execute(c)}}function addStringValue(attr,value){var sc=jsyaml.createScalar(value),target=attr.lowLevel();target.isScalar()?target=target.parent():target.isMapping();var command=new ll.CompositeCommand;command.commands.push(ll.insertNode(target,sc,null,!0)),attr.lowLevel().execute(command),attr.parent().clearChildrenCache()}function addStructuredValue(attr,sv){var target=attr.lowLevel();if(target.isScalar())target=target.parent();else if(target.isMapping()){attr.lowLevel()}var command=new ll.CompositeCommand;command.commands.push(ll.insertNode(target,sv.lowLevel(),null,!0)),attr.lowLevel().execute(command),attr.parent().clearChildrenCache()}function removeAttr(attr){var llparent=attr.lowLevel().parent();if(!attr.property().isMultiValue()&&attr.isEmbedded())attr.setValue("");else{var command=new ll.CompositeCommand;command.commands.push(ll.removeNode(llparent,attr.lowLevel())),attr.lowLevel().execute(command),attr.parent().clearChildrenCache()}}function setValues(attr,values){if(!attr.property().isMultiValue())throw new Error("setValue(string[]) only apply to multi-values properties");var node=attr.parent();if(node&&isTypeShortcut(node)){var command=new ll.CompositeCommand;return command.commands.push(ll.setAttr(node.lowLevel(),values[0])),void node.lowLevel().execute(command)}if(attr.isEmpty());else{var attrs=(node.lowLevel(),node.attributes(attr.name()));attrs.forEach(function(attr){return attr.remove()})}1==values.length&&attr.property().isDescriminator()?node.attrOrCreate(attr.name()).setValue(values[0]):values.forEach(function(val){return node.attrOrCreate(attr.name()).addValue(val)})}function setKey(node,value){if(value!=node.name()){var c=new ll.CompositeCommand;c.commands.push(ll.setKey(node.lowLevel(),value)),node.lowLevel().execute(c)}}function isTypeShortcut(node){return node.definition()&&node.definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name)&&node.lowLevel()&&node.lowLevel().valueKind()===yaml.Kind.SCALAR?!0:!1}function createAttr(node,n,v){var mapping=jsyaml.createMapping(n,v);if(node.definition()&&node.definition().isAssignableFrom(universes.Universe10.TypeDeclaration.name)&&node.lowLevel()&&(node.lowLevel().valueKind()===yaml.Kind.SCALAR||!node.lowLevel()._node.value)){var typePropertyName=n,typeMapping=jsyaml.createMapping(typePropertyName,node.lowLevel().value()),command=new ll.CompositeCommand;command.commands.push(ll.setAttr(node.lowLevel(),"")),node.lowLevel().execute(command),command=new ll.CompositeCommand;var insertionPoint=findInsertionPointLowLevel(node,typeMapping,node.definition().property(typePropertyName),!0);command.commands.push(ll.insertNode(node.lowLevel(),typeMapping,insertionPoint)),node.lowLevel().execute(command),node.resetChildren();var attribute=node.attr(typePropertyName)&&node.attr(typePropertyName).lowLevel();if(attribute)return command=new ll.CompositeCommand,command.commands.push(ll.setAttr(attribute,v)),attribute.execute(command),void node.clearChildrenCache()}if(node.isStub()){var insertionIndex=findLastAttributeIndex(node);node.lowLevel().addChild(mapping,insertionIndex+1)}else{node.isEmptyRamlFile()&&node.initRamlFile();var command=new ll.CompositeCommand,insertionPoint=findInsertionPointLowLevel(node,mapping,node.definition().property(n),!0);command.commands.push(ll.insertNode(node.lowLevel(),mapping,insertionPoint)),node.lowLevel().execute(command)}node.clearChildrenCache()}function findLastAttribute(node){var childs=node.lowLevel().children(),index=findLastAttributeIndex(node);return 0>index?null:childs[index]}function addToNode(target,node){!target.isStub()&&target.isEmptyRamlFile()&&target.initRamlFile();var llnode=node.lowLevel();if(target._children||(target._children=[]),!node.property()){var an=node,allProps=target.definition().allProperties(),cp=null;if(allProps.forEach(function(x){var r=x.range();r==an.definition()&&(cp=x);var isOk=_.find(an.definition().allSuperTypes(),function(x){return x==r});isOk&&(cp=x)}),!cp)throw new Error("Unable to find correct child");an.patchProp(cp)}var insertionPoint=findInsertionPoint(target,node),command=new ll.CompositeCommand,insertionTarget=null;if(node.property().getAdapter(services.RAMLPropertyService).isMerged()||node.property().range().hasValueTypeInHierarchy())command.commands.push(ll.insertNode(target.lowLevel(),node.lowLevel(),insertionPoint)),insertionTarget=target.lowLevel();else{var name=node.property().nameId(),target2=target.lowLevel(),found=target.lowLevel().find(name);if(insertionTarget=found,found){var isEmptyTypes=null===found.value()&&found.key&&found.key()===universes.Universe10.Api.properties.types.name,needSeq=!isEmptyTypes&&node.property().getAdapter(services.RAMLPropertyService).isEmbedMap();command.commands.push(ll.insertNode(found,node.lowLevel(),insertionPoint,needSeq))}else{var nn=null;if(node.property().getAdapter(services.RAMLPropertyService).isEmbedMap()){var v10="RAML10"==target.definition().universe().version();nn=llnode.isValueMap()&&v10?jsyaml.createMapNode(name):jsyaml.createSeqNode(name),nn.addChild(node.lowLevel())}else nn=jsyaml.createNode(name),nn.addChild(node.lowLevel());command.commands.push(ll.insertNode(target2,nn,insertionPoint)),insertionTarget=target2}}if(target.isStub()){var insertionIndex=findLastAttributeIndex(target);return 0>insertionIndex?target._children.push(node):target._children.splice(insertionIndex,0,node),void command.commands.forEach(function(x){return insertionTarget.addChild(x.value)})}target.lowLevel().execute(command),target._children.push(node),node.setParent(target)}var jsyaml=__webpack_require__(28),defs=__webpack_require__(36),ll=__webpack_require__(11),_=__webpack_require__(65),yaml=__webpack_require__(74),hlimpl=__webpack_require__(16),universes=__webpack_require__(18),universeHelpers=__webpack_require__(14),services=defs;exports.removeNodeFrom=removeNodeFrom,exports.initEmptyRAMLFile=initEmptyRAMLFile,exports.setValue=setValue,exports.addStringValue=addStringValue,exports.addStructuredValue=addStructuredValue,exports.removeAttr=removeAttr,exports.setValues=setValues,exports.setKey=setKey,exports.createAttr=createAttr,exports.addToNode=addToNode},function(module,exports,__webpack_require__){"use strict";function templateFields(node,d){var u=node.root().definition().universe(),key=node.lowLevel().key();if(key&&handleValue(key,d,null,!0,u),node.children().forEach(function(x){return templateFields(x,d)}),node instanceof hlimpl.ASTPropImpl){var prop=node,v=prop.value();if("string"==typeof v){var strV=v;handleValue(strV,d,prop,!1,u)}else node.lowLevel().visit(function(x){if(x.value()){var strV=x.value()+"";handleValue(strV,d,prop,!0,u)}return!0})}else if(node instanceof hlimpl.BasicASTNode){var v=node.lowLevel().value();if("string"==typeof v){var strV=v;handleValue(strV,d,null,!1,u)}else node.lowLevel().visit(function(x){if(x.value()){var strV=x.value()+"";handleValue(strV,d,null,!0,u)}return!0})}}function fillParamPaths(node,paramPaths,path){void 0===path&&(path=[]),node.optional()&&(path=path.concat("/"));var v=node.value();if("string"==typeof v)for(var strV=v,__ret=extractUsedParamNames(strV),parameterUsages=__ret.parameterUsages,_i=0,parameterUsages_2=parameterUsages;_i<parameterUsages_2.length;_i++){var pu=parameterUsages_2[_i],paths=paramPaths[pu];null==paths&&(paths=[],paramPaths[pu]=paths),paths.push(path)}else for(var _a=0,_b=node.children();_a<_b.length;_a++){var ch=_b[_a];fillParamPaths(ch,paramPaths,path.concat(ch.key()))}}function fillTemplateType(result,node){var usages={},paramPaths={};templateFields(node,usages),fillParamPaths(node.lowLevel(),paramPaths);for(var _i=0,_a=Object.keys(paramPaths);_i<_a.length;_i++){var pu=_a[_i];paramPaths[pu]=_.unique(paramPaths[pu])}result.getAdapter(services.RAMLService).setInlinedTemplates(!0),Object.keys(usages).forEach(function(x){var propSource=null;usages[x].length>0&&(propSource=usages[x][0].attr);var prop=new defs.UserDefinedProp(x,propSource);prop.withDomain(result);var paths=paramPaths[x];prop.getAdapter(services.RAMLPropertyService).putMeta("templatePaths",paths);var defaultType;if("RAML10"==node.definition().universe().version()){var hasString=usages[x].filter(function(y){return universeHelpers.isStringTypeType(y.tp)}).length>0;defaultType=hasString?universes.Universe10.StringType.name:universes.Universe10.AnyType.name}else defaultType=universes.Universe08.StringType.name;var tp=_.unique(usages[x].map(function(x){return x.tp})).filter(function(x){return x&&x.nameId()!=defaultType});prop.withRange(1==tp.length?tp[0]:node.definition().universe().type(defaultType)),prop.withRequired(!0),1==tp.length&&"RAML10"==node.definition().universe().version()&&tp[0].key()==universes.Universe10.SchemaString&&prop.getAdapter(services.RAMLPropertyService).setTypeExpression(!0),prop.unmerge()});var keyProp=new defs.UserDefinedProp("____key",node);return keyProp.withDomain(result),keyProp.withKey(!0),keyProp.withFromParentKey(!0),keyProp.withRange(node.definition().universe().type(universes.Universe08.StringType.name)),result}function fillReferenceType(result,def){"RAML08"==def.universe().version()&&result.getAdapter(services.RAMLService).withAllowAny();var p=def.property(def.getAdapter(services.RAMLService).getReferenceIs());return p&&p.range().properties().forEach(function(x){var prop=new defs.Property(x.nameId());prop.unmerge(),prop.withDomain(result),prop.withRange(x.range()),prop.withMultiValue(x.isMultiValue())}),result}function typeFromNode(node){if(!node)return null;if(node.associatedType())return node.associatedType();var u=node.lowLevel().unit(),upath=u?u.path():"";ramlTypes.setPropertyConstructor(function(x){var propertySource=null,rs=node.elementsOfKind("properties").filter(function(y){return y.name()==x});rs&&(propertySource=rs[0]);var v=new defs.UserDefinedProp(x,propertySource);return v.unmerge(),v});try{var def=node.definition();if(node.property()&&node.property().nameId()==universes.Universe10.LibraryBase.properties.annotationTypes.name){var result=new AnnotationType(node.name(),node.definition().universe(),node,upath,""),st=getSimpleType(node);result._superTypes.push(st),0==node.elementsOfKind(universes.Universe10.ObjectTypeDeclaration.properties.properties.name).length&&result.getAdapter(services.RAMLService).withAllowAny();var extType=def.getAdapter(services.RAMLService).getExtendedType();return extType&&result._superTypes.push(extType),result}var result=new defs.UserDefinedClass(node.name(),node.definition().universe(),node,upath,"");if(node.setAssociatedType(result),def.getAdapter(services.RAMLService).isInlinedTemplates())return fillTemplateType(result,node);if(def.getAdapter(services.RAMLService).getReferenceIs())return fillReferenceType(result,def);var rs=getSimpleType(node);rs.getAdapter(services.RAMLService).setDeclaringNode(node),node.setAssociatedType(rs)}finally{ramlTypes.setPropertyConstructor(null)}return rs}function getSimpleType(node){return ramlTypes.toNominal(node.parsedType(),function(x){var m=node.definition().universe().type(x);if(!m){new defs.UserDefinedClass("",node.definition().universe(),node,"","")}return m})}function transform(u){return function(x){var m=u.type(x);if(!m){new defs.UserDefinedClass("",u,null,"","")}return m}}function convertType(root,t){var node=_.find(root.elementsOfKind("types"),function(x){return x.name()==t.name()});node&&ramlTypes.setPropertyConstructor(function(x){var rs=node.elementsOfKind("properties").filter(function(y){return y.name()==x}),propertySource=null;if(rs&&rs.length>0)propertySource=rs[0];else{var rs=node.elementsOfKind("facets").filter(function(y){return y.name()==x});rs&&rs.length>0&&(propertySource=rs[0])}var v=new defs.UserDefinedProp(x,propertySource);return v.unmerge(),v});var u=transform(root.definition().universe());return ramlTypes.toNominal(t,u)}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},defs=__webpack_require__(36),ramlTypes=defs.rt,_=__webpack_require__(65),universes=__webpack_require__(18),hlimpl=__webpack_require__(16),services=defs,linter=__webpack_require__(26),universeHelpers=__webpack_require__(14);ramlTypes.setPropertyConstructor(function(x){var v=new defs.Property(x);return v.unmerge(),v});var extractUsedParamNames=function(strV){for(var parameterUsages=[],ps=0;;){var pos=strV.indexOf("<<",ps);if(-1==pos)break;var end=strV.indexOf(">>",pos),isFull=0==pos&&end==strV.length-2,parameterUsage=strV.substring(pos+2,end);ps=pos+2;var directiveIndex=parameterUsage.indexOf("|");-1!=directiveIndex&&(parameterUsage=parameterUsage.substring(0,directiveIndex)),parameterUsage=parameterUsage.trim(),parameterUsages.push(parameterUsage)}return{parameterUsages:parameterUsages,isFull:isFull}},handleValue=function(strV,d,prop,allwaysString,u){var __ret=extractUsedParamNames(strV),parameterUsages=__ret.parameterUsages,isFull=__ret.isFull,r=prop?prop.property().range():null;prop&&(prop.property().nameId()==universes.Universe10.TypeDeclaration.properties.type.name||prop.property().nameId()==universes.Universe10.TypeDeclaration.properties.schema.name)&&prop.property().domain().key()==universes.Universe10.TypeDeclaration&&(r=u.type(universes.Universe10.SchemaString.name)),!isFull||allwaysString?r=u.type(universes.Universe10.StringType.name):null==r&&"RAML10"==u.version()&&(r=u.type(universes.Universe10.AnyType.name));for(var _i=0,parameterUsages_1=parameterUsages;_i<parameterUsages_1.length;_i++){var parameterUsage=parameterUsages_1[_i];if(null==linter.RESERVED_TEMPLATE_PARAMETERS[parameterUsage]){var q=d[parameterUsage];q?q.push({tp:r,attr:prop}):d[parameterUsage]=[{tp:r,attr:prop}]}}},AnnotationType=function(_super){function AnnotationType(){_super.apply(this,arguments)}return __extends(AnnotationType,_super),AnnotationType.prototype.allProperties=function(ps){void 0===ps&&(ps={});var rs=this.superTypes()[0].allProperties();if(1==rs.length&&"annotations"==rs[0].nameId()){var propertyNode=this.getAdapter(defs.RAMLService).getDeclaringNode(),property=new defs.UserDefinedProp("value",propertyNode);property.withDomain(this),property.withCanBeValue(),property.withRequired(!1);this.superTypes()[0];rs=[],property.withRange(property.node().asElement().definition().universe().type("string")),rs.push(property)}return rs},AnnotationType.prototype.isAnnotationType=function(){return!0},AnnotationType}(defs.UserDefinedClass);exports.typeFromNode=typeFromNode,exports.convertType=convertType},function(module,exports,__webpack_require__){"use strict";function isMultiLine(s){return s&&s.indexOf("\n")>=0}function isMultiLineValue(s){return isMultiLine(s)&&s.length>2&&"|"==s[0]&&("\n"==s[1]||"\r"==s[1]||"\n"==s[2])}function makeMutiLine(s,lev){var xbuf="";if(isMultiLine(s)){xbuf+="|\n";for(var lines=splitOnLines(s),i=0;i<lines.length;i++)xbuf+=indent(lev,lines[i])}else xbuf+=s;return xbuf}function fromMutiLine(s){if(!isMultiLineValue(s))return s;for(var res=null,lines=splitOnLines(s),i=1;i<lines.length;i++){var line=lines[i],str=line.substring(2);res?res+=str:res=str}return res}function trimStart(s){if(!s)return s;for(var pos=0;pos<s.length;){var ch=s[pos];if("\r"!=ch&&"\n"!=ch&&" "!=ch&&"	"!=ch)break;pos++}return s.substring(pos,s.length)}function indent(lev,str){void 0===str&&(str="");for(var leading="",i=0;lev>i;i++)leading+="  ";return leading+str}function print(lev,str){void 0===str&&(str=""),console.log(indent(lev,str))}function replaceNewlines(s,rep){void 0===rep&&(rep=null);for(var res="",i=0;i<s.length;i++){var ch=s[i];"\r"==ch&&(ch=null==rep?"\\r":rep),"\n"==ch&&(ch=null==rep?"\\n":rep),res+=ch}return res}function trimEnd(s){for(var pos=s.length;pos>0;){var ch=s[pos-1];if(" "!=ch&&"	"!=ch&&"\r"!=ch&&"\n"!=ch)break;pos--}return s.substring(0,pos)}function trim(s){return trimStart(trimEnd(s))}function splitOnLines(text){var lines=text.match(/^.*((\r\n|\n|\r)|$)/gm);return lines}function startsWith(s,suffix){if(!s||!suffix||s.length<suffix.length)return!1;for(var i=0;i<suffix.length;i++)if(s[i]!=suffix[i])return!1;return!0}function endsWith(s,suffix){if(!s||!suffix||s.length<suffix.length)return!1;for(var i=0;i<suffix.length;i++)if(s[s.length-1-i]!=suffix[suffix.length-1-i])return!1;return!0}function capitalize(s){return s.charAt(0).toUpperCase()+s.slice(1)}exports.isMultiLine=isMultiLine,exports.isMultiLineValue=isMultiLineValue,exports.makeMutiLine=makeMutiLine,exports.fromMutiLine=fromMutiLine,exports.trimStart=trimStart,exports.indent=indent,exports.print=print,exports.replaceNewlines=replaceNewlines,exports.trimEnd=trimEnd,exports.trim=trim,exports.splitOnLines=splitOnLines,exports.startsWith=startsWith,exports.endsWith=endsWith,exports.capitalize=capitalize;var TextRange=function(){function TextRange(contents,start,end){this.contents=contents,this.start=start,this.end=end}return TextRange.prototype.text=function(){return this.contents.substring(this.start,this.end)},TextRange.prototype.startpos=function(){return this.start},TextRange.prototype.endpos=function(){return this.end},TextRange.prototype.len=function(){return this.end-this.start},TextRange.prototype.unitText=function(){return this.contents},TextRange.prototype.withStart=function(start){return new TextRange(this.contents,start,this.end)},TextRange.prototype.withEnd=function(end){return new TextRange(this.contents,this.start,end)},TextRange.prototype.sub=function(start,end){return this.contents.substring(start,end)},TextRange.prototype.trimStart=function(){for(var pos=this.start;pos<this.contents.length-1;){var ch=this.contents[pos];if(" "!=ch&&"	"!=ch)break;pos++}return new TextRange(this.contents,pos,this.end)},TextRange.prototype.trimEnd=function(){for(var pos=this.end;pos>0;){var ch=this.contents[pos-1];if(" "!=ch&&"	"!=ch)break;pos--}return new TextRange(this.contents,this.start,pos)},TextRange.prototype.extendToStartOfLine=function(){for(var pos=this.start;pos>0;){var prevchar=this.contents[pos-1];if("\r"==prevchar||"\n"==prevchar)break;pos--}return new TextRange(this.contents,pos,this.end)},TextRange.prototype.extendAnyUntilNewLines=function(){var pos=this.end;if(pos>0){var last=this.contents[pos-1];if("\n"==last)return this}for(;pos<this.contents.length-1;){var nextchar=this.contents[pos];if("\r"==nextchar||"\n"==nextchar)break;pos++}return new TextRange(this.contents,this.start,pos)},TextRange.prototype.extendSpacesUntilNewLines=function(){var pos=this.end;if(pos>0){var last=this.contents[pos-1];if("\n"==last)return this}for(;pos<this.contents.length-1;){var nextchar=this.contents[pos];if(" "!=nextchar||"\r"==nextchar||"\n"==nextchar)break;pos++}return new TextRange(this.contents,this.start,pos)},TextRange.prototype.extendSpaces=function(){for(var pos=this.end;pos<this.contents.length-1;){var nextchar=this.contents[pos];if(" "!=nextchar)break;pos++}return new TextRange(this.contents,this.start,pos)},TextRange.prototype.extendSpacesBack=function(){for(var pos=this.start;pos>0;){var nextchar=this.contents[pos-1];if(" "!=nextchar)break;pos--}return new TextRange(this.contents,pos,this.end)},TextRange.prototype.extendCharIfAny=function(ch){var pos=this.end;return pos<this.contents.length-1&&this.contents[pos]==ch&&pos++,new TextRange(this.contents,this.start,pos)},TextRange.prototype.extendCharIfAnyBack=function(ch){var pos=this.start;return pos>0&&this.contents[pos-1]==ch&&pos--,new TextRange(this.contents,pos,this.end)},TextRange.prototype.extendToNewlines=function(){var pos=this.end;if(pos>0){var last=this.contents[pos-1];if("\n"==last)return this}for(;pos<this.contents.length-1;){var nextchar=this.contents[pos];if("\r"!=nextchar&&"\n"!=nextchar)break;pos++}return new TextRange(this.contents,this.start,pos)},TextRange.prototype.extendUntilNewlinesBack=function(){for(var pos=this.start;pos>0;){var nextchar=this.contents[pos-1];if("\r"==nextchar||"\n"==nextchar)break;pos--}return new TextRange(this.contents,pos,this.end)},TextRange.prototype.reduceNewlinesEnd=function(){for(var pos=this.end;pos>this.start;){var last=this.contents[pos-1];if("\r"!=last&&"\n"!=last)break;pos--}return new TextRange(this.contents,this.start,pos)},TextRange.prototype.reduceSpaces=function(){for(var pos=this.end;pos>this.start;){var last=this.contents[pos-1];if(" "!=last)break;pos--}return new TextRange(this.contents,this.start,pos)},TextRange.prototype.replace=function(text){return this.sub(0,this.start)+text+this.sub(this.end,this.unitText().length)},TextRange.prototype.remove=function(){return this.sub(0,this.start)+this.sub(this.end,this.unitText().length)},TextRange}();exports.TextRange=TextRange},function(module,exports,__webpack_require__){"use strict";function getWrapperConstructor(definition){return definition.isBuiltIn()?classMap[definition.nameId()]:null}function buildWrapperNode(node,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0);var definition=node.definition(),wrapperConstructor=(definition.nameId(),getWrapperConstructor(definition));if(!wrapperConstructor){for(var priorities=determineSuperclassesPriorities(definition),superTypes=definition.allSuperTypes().sort(function(x,y){return priorities[x.nameId()]-priorities[y.nameId()]}),wr=null,i=0;i<superTypes.length;i++){var superTypeName=superTypes[i].nameId();if(wrapperConstructor=getWrapperConstructor(superTypes[i]),"DataElement"!=superTypeName){if("hl.BasicNode"!=superTypeName&&wrapperConstructor)break}else wr=superTypeName}wrapperConstructor||(wr=superTypeName)}return wrapperConstructor||(wrapperConstructor=classMap["hl.BasicNode"]),wrapperConstructor(node,setAsTopLevel)}function determineSuperclassesPriorities(td,priorities,path){void 0===priorities&&(priorities={}),void 0===path&&(path={});var typeName=td.nameId();if(!path[typeName]){path[typeName]=!0;var rank=null!=priorities[typeName]&&priorities[typeName]+1||0,superTypes=td.superTypes();return superTypes.forEach(function(x){var name=x.nameId(),r=priorities[name];(null==r||rank>r)&&(priorities[name]=rank,determineSuperclassesPriorities(x,priorities,path))}),delete path[typeName],priorities}}var RamlWrapper=__webpack_require__(21);exports.buildWrapperNode=buildWrapperNode;var classMap={AbstractSecurityScheme:function(x,y){return new RamlWrapper.AbstractSecuritySchemeImpl(x,y)},Annotable:function(x,y){return new RamlWrapper.AnnotableImpl(x,y)},AnnotationRef:function(x){return new RamlWrapper.AnnotationRefImpl(x)},AnnotationTarget:function(x){return new RamlWrapper.AnnotationTargetImpl(x)},AnyType:function(x){return new RamlWrapper.AnyTypeImpl(x)},Api:function(x,y){return new RamlWrapper.ApiImpl(x,y)},ArrayTypeDeclaration:function(x,y){return new RamlWrapper.ArrayTypeDeclarationImpl(x,y)},BasicSecurityScheme:function(x,y){return new RamlWrapper.BasicSecuritySchemeImpl(x,y)},BooleanType:function(x){return new RamlWrapper.BooleanTypeImpl(x)},BooleanTypeDeclaration:function(x,y){return new RamlWrapper.BooleanTypeDeclarationImpl(x,y)},ContentType:function(x){return new RamlWrapper.ContentTypeImpl(x)},CustomSecurityScheme:function(x,y){return new RamlWrapper.CustomSecuritySchemeImpl(x,y)},DateOnlyType:function(x){return new RamlWrapper.DateOnlyTypeImpl(x)},DateOnlyTypeDeclaration:function(x,y){return new RamlWrapper.DateOnlyTypeDeclarationImpl(x,y)},DateTimeOnlyType:function(x){return new RamlWrapper.DateTimeOnlyTypeImpl(x)},DateTimeOnlyTypeDeclaration:function(x,y){return new RamlWrapper.DateTimeOnlyTypeDeclarationImpl(x,y)},DateTimeType:function(x){return new RamlWrapper.DateTimeTypeImpl(x)},DateTimeTypeDeclaration:function(x,y){return new RamlWrapper.DateTimeTypeDeclarationImpl(x,y)},DigestSecurityScheme:function(x,y){return new RamlWrapper.DigestSecuritySchemeImpl(x,y)},DocumentationItem:function(x,y){return new RamlWrapper.DocumentationItemImpl(x,y)},Extension:function(x,y){return new RamlWrapper.ExtensionImpl(x,y)},FileType:function(x){return new RamlWrapper.FileTypeImpl(x)},FileTypeDeclaration:function(x,y){return new RamlWrapper.FileTypeDeclarationImpl(x,y)},FixedUriString:function(x){return new RamlWrapper.FixedUriStringImpl(x)},FragmentDeclaration:function(x,y){return new RamlWrapper.FragmentDeclarationImpl(x,y)},FullUriTemplateString:function(x){return new RamlWrapper.FullUriTemplateStringImpl(x)},IntegerType:function(x){return new RamlWrapper.IntegerTypeImpl(x)},IntegerTypeDeclaration:function(x,y){return new RamlWrapper.IntegerTypeDeclarationImpl(x,y)},Library:function(x,y){return new RamlWrapper.LibraryImpl(x,y)},LibraryBase:function(x,y){return new RamlWrapper.LibraryBaseImpl(x,y)},LocationKind:function(x){return new RamlWrapper.LocationKindImpl(x)},MarkdownString:function(x){return new RamlWrapper.MarkdownStringImpl(x)},Method:function(x,y){return new RamlWrapper.MethodImpl(x,y)},MethodBase:function(x,y){return new RamlWrapper.MethodBaseImpl(x,y)},MimeType:function(x){return new RamlWrapper.MimeTypeImpl(x)},ModelLocation:function(x){return new RamlWrapper.ModelLocationImpl(x)},NullType:function(x){return new RamlWrapper.NullTypeImpl(x)},NumberType:function(x){return new RamlWrapper.NumberTypeImpl(x)},NumberTypeDeclaration:function(x,y){return new RamlWrapper.NumberTypeDeclarationImpl(x,y)},OAuth1SecurityScheme:function(x,y){return new RamlWrapper.OAuth1SecuritySchemeImpl(x,y)},OAuth1SecuritySchemeSettings:function(x,y){return new RamlWrapper.OAuth1SecuritySchemeSettingsImpl(x,y)},OAuth2SecurityScheme:function(x,y){return new RamlWrapper.OAuth2SecuritySchemeImpl(x,y)},OAuth2SecuritySchemeSettings:function(x,y){return new RamlWrapper.OAuth2SecuritySchemeSettingsImpl(x,y)},ObjectTypeDeclaration:function(x,y){return new RamlWrapper.ObjectTypeDeclarationImpl(x,y)},Operation:function(x,y){return new RamlWrapper.OperationImpl(x,y)},Overlay:function(x,y){return new RamlWrapper.OverlayImpl(x,y)},PassThroughSecurityScheme:function(x,y){return new RamlWrapper.PassThroughSecuritySchemeImpl(x,y)},Reference:function(x){return new RamlWrapper.ReferenceImpl(x)},RelativeUriString:function(x){return new RamlWrapper.RelativeUriStringImpl(x)},Resource:function(x,y){return new RamlWrapper.ResourceImpl(x,y)},ResourceBase:function(x,y){return new RamlWrapper.ResourceBaseImpl(x,y)},ResourceType:function(x,y){return new RamlWrapper.ResourceTypeImpl(x,y)},ResourceTypeRef:function(x){return new RamlWrapper.ResourceTypeRefImpl(x)},Response:function(x,y){return new RamlWrapper.ResponseImpl(x,y)},SchemaString:function(x){return new RamlWrapper.SchemaStringImpl(x)},SecuritySchemePart:function(x,y){return new RamlWrapper.SecuritySchemePartImpl(x,y)},SecuritySchemeRef:function(x){return new RamlWrapper.SecuritySchemeRefImpl(x)},SecuritySchemeSettings:function(x,y){return new RamlWrapper.SecuritySchemeSettingsImpl(x,y)},StatusCodeString:function(x){return new RamlWrapper.StatusCodeStringImpl(x)},StringType:function(x){return new RamlWrapper.StringTypeImpl(x)},StringTypeDeclaration:function(x,y){return new RamlWrapper.StringTypeDeclarationImpl(x,y)},TimeOnlyType:function(x){return new RamlWrapper.TimeOnlyTypeImpl(x)},TimeOnlyTypeDeclaration:function(x,y){return new RamlWrapper.TimeOnlyTypeDeclarationImpl(x,y)},Trait:function(x,y){return new RamlWrapper.TraitImpl(x,y)},TraitRef:function(x){return new RamlWrapper.TraitRefImpl(x)},TypeDeclaration:function(x,y){return new RamlWrapper.TypeDeclarationImpl(x,y)},UnionTypeDeclaration:function(x,y){return new RamlWrapper.UnionTypeDeclarationImpl(x,y)},UriTemplate:function(x){return new RamlWrapper.UriTemplateImpl(x)},UsesDeclaration:function(x,y){return new RamlWrapper.UsesDeclarationImpl(x,y)},ValueType:function(x){return new RamlWrapper.ValueTypeImpl(x)},XMLFacetInfo:function(x,y){return new RamlWrapper.XMLFacetInfoImpl(x,y)}}},function(module,exports,__webpack_require__){"use strict";function getWrapperConstructor(definition){return definition.isBuiltIn()?classMap[definition.nameId()]:null}function buildWrapperNode(node,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0);var definition=node.definition(),wrapperConstructor=(definition.nameId(),getWrapperConstructor(definition));if(!wrapperConstructor){for(var priorities=determineSuperclassesPriorities(definition),superTypes=definition.allSuperTypes().sort(function(x,y){return priorities[x.nameId()]-priorities[y.nameId()]}),wr=null,i=0;i<superTypes.length;i++){var superTypeName=superTypes[i].nameId();if(wrapperConstructor=getWrapperConstructor(superTypes[i]),"DataElement"!=superTypeName){if("hl.BasicNode"!=superTypeName&&wrapperConstructor)break}else wr=superTypeName}wrapperConstructor||(wr=superTypeName)}return wrapperConstructor||(wrapperConstructor=classMap["hl.BasicNode"]),wrapperConstructor(node,setAsTopLevel)}function determineSuperclassesPriorities(td,priorities,path){void 0===priorities&&(priorities={}),void 0===path&&(path={});var typeName=td.nameId();if(!path[typeName]){path[typeName]=!0;var rank=null!=priorities[typeName]&&priorities[typeName]+1||0,superTypes=td.superTypes();return superTypes.forEach(function(x){var name=x.nameId(),r=priorities[name];(null==r||rank>r)&&(priorities[name]=rank,determineSuperclassesPriorities(x,priorities,path))}),delete path[typeName],priorities}}var RamlWrapper=__webpack_require__(47);exports.buildWrapperNode=buildWrapperNode;var classMap={AbstractSecurityScheme:function(x,y){return new RamlWrapper.AbstractSecuritySchemeImpl(x,y)},AnyType:function(x){return new RamlWrapper.AnyTypeImpl(x)},Api:function(x,y){return new RamlWrapper.ApiImpl(x,y)},BasicSecurityScheme:function(x,y){
return new RamlWrapper.BasicSecuritySchemeImpl(x,y)},BodyLike:function(x,y){return new RamlWrapper.BodyLikeImpl(x,y)},BooleanType:function(x){return new RamlWrapper.BooleanTypeImpl(x)},BooleanTypeDeclaration:function(x,y){return new RamlWrapper.BooleanTypeDeclarationImpl(x,y)},CustomSecurityScheme:function(x,y){return new RamlWrapper.CustomSecuritySchemeImpl(x,y)},DateTypeDeclaration:function(x,y){return new RamlWrapper.DateTypeDeclarationImpl(x,y)},DigestSecurityScheme:function(x,y){return new RamlWrapper.DigestSecuritySchemeImpl(x,y)},DocumentationItem:function(x,y){return new RamlWrapper.DocumentationItemImpl(x,y)},ExampleString:function(x){return new RamlWrapper.ExampleStringImpl(x)},FileTypeDeclaration:function(x,y){return new RamlWrapper.FileTypeDeclarationImpl(x,y)},FixedUri:function(x){return new RamlWrapper.FixedUriImpl(x)},FullUriTemplateString:function(x){return new RamlWrapper.FullUriTemplateStringImpl(x)},GlobalSchema:function(x,y){return new RamlWrapper.GlobalSchemaImpl(x,y)},IntegerTypeDeclaration:function(x,y){return new RamlWrapper.IntegerTypeDeclarationImpl(x,y)},JSONBody:function(x,y){return new RamlWrapper.JSONBodyImpl(x,y)},JSONExample:function(x){return new RamlWrapper.JSONExampleImpl(x)},JSonSchemaString:function(x){return new RamlWrapper.JSonSchemaStringImpl(x)},MarkdownString:function(x){return new RamlWrapper.MarkdownStringImpl(x)},Method:function(x,y){return new RamlWrapper.MethodImpl(x,y)},MethodBase:function(x,y){return new RamlWrapper.MethodBaseImpl(x,y)},MimeType:function(x){return new RamlWrapper.MimeTypeImpl(x)},NumberType:function(x){return new RamlWrapper.NumberTypeImpl(x)},NumberTypeDeclaration:function(x,y){return new RamlWrapper.NumberTypeDeclarationImpl(x,y)},OAuth1SecurityScheme:function(x,y){return new RamlWrapper.OAuth1SecuritySchemeImpl(x,y)},OAuth1SecuritySchemeSettings:function(x,y){return new RamlWrapper.OAuth1SecuritySchemeSettingsImpl(x,y)},OAuth2SecurityScheme:function(x,y){return new RamlWrapper.OAuth2SecuritySchemeImpl(x,y)},OAuth2SecuritySchemeSettings:function(x,y){return new RamlWrapper.OAuth2SecuritySchemeSettingsImpl(x,y)},Parameter:function(x,y){return new RamlWrapper.ParameterImpl(x,y)},ParameterLocation:function(x){return new RamlWrapper.ParameterLocationImpl(x)},RAMLSimpleElement:function(x,y){return new RamlWrapper.RAMLSimpleElementImpl(x,y)},Reference:function(x){return new RamlWrapper.ReferenceImpl(x)},RelativeUriString:function(x){return new RamlWrapper.RelativeUriStringImpl(x)},Resource:function(x,y){return new RamlWrapper.ResourceImpl(x,y)},ResourceType:function(x,y){return new RamlWrapper.ResourceTypeImpl(x,y)},ResourceTypeRef:function(x){return new RamlWrapper.ResourceTypeRefImpl(x)},Response:function(x,y){return new RamlWrapper.ResponseImpl(x,y)},SchemaString:function(x){return new RamlWrapper.SchemaStringImpl(x)},SecuritySchemePart:function(x,y){return new RamlWrapper.SecuritySchemePartImpl(x,y)},SecuritySchemeRef:function(x){return new RamlWrapper.SecuritySchemeRefImpl(x)},SecuritySchemeSettings:function(x,y){return new RamlWrapper.SecuritySchemeSettingsImpl(x,y)},StatusCodeString:function(x){return new RamlWrapper.StatusCodeStringImpl(x)},StringType:function(x){return new RamlWrapper.StringTypeImpl(x)},StringTypeDeclaration:function(x,y){return new RamlWrapper.StringTypeDeclarationImpl(x,y)},Trait:function(x,y){return new RamlWrapper.TraitImpl(x,y)},TraitRef:function(x){return new RamlWrapper.TraitRefImpl(x)},UriTemplate:function(x){return new RamlWrapper.UriTemplateImpl(x)},ValueType:function(x){return new RamlWrapper.ValueTypeImpl(x)},XMLBody:function(x,y){return new RamlWrapper.XMLBodyImpl(x,y)},XMLExample:function(x){return new RamlWrapper.XMLExampleImpl(x)},XMLSchemaString:function(x){return new RamlWrapper.XMLSchemaStringImpl(x)}}},function(module,exports,__webpack_require__){"use strict";function toStructuredValue(node){var value=node.value();if("string"==typeof value||null==value){var mockNode=jsyaml.createNode(value,null,node.lowLevel().unit());mockNode._actualNode().startPosition=node.lowLevel().valueStart(),mockNode._actualNode().endPosition=node.lowLevel().valueEnd();var stv=new hlImpl.StructuredValue(mockNode,node.parent(),node.property());return stv}return value}function fillElementMeta(node){var meta=node._meta;meta.resetPrimitiveValuesMeta();var highLevelNode=node.highLevel();return highLevelNode.definition().allProperties().forEach(function(p){var name=p.nameId(),attrs=highLevelNode.attributes(name),gotValue=!1,optional=!1;if(attrs.forEach(function(a){gotValue=gotValue||null!=a.value(),optional=optional||a.optional()}),!gotValue){var calculator=node.getDefaultsCalculator(),defVal=calculator.attributeDefaultIfEnabled(highLevelNode,p);if(null!=defVal){var insertionKind=calculator.insertionKind(highLevelNode,p);insertionKind==defaultCalculator.InsertionKind.CALCULATED?meta.registerCalculatedValue(name):insertionKind==defaultCalculator.InsertionKind.BY_DEFAULT&&meta.registerInsertedAsDefaultValue(name)}}}),meta}function attributesToValues(attrs,constr){return constr?attrs.map(function(x){return constr(x)}):attrs.map(function(x){return x.value()})}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},hlImpl=__webpack_require__(16),jsyaml=__webpack_require__(28),defaultCalculator=(__webpack_require__(36),__webpack_require__(67)),search=__webpack_require__(24),universeHelpers=__webpack_require__(14),tckDumper=__webpack_require__(68),yaml=__webpack_require__(74),BasicNodeImpl=function(){function BasicNodeImpl(_node,setAsWrapper){void 0===setAsWrapper&&(setAsWrapper=!0),this._node=_node,this._meta=new NodeMetadataImpl(!1,!1,universeHelpers.isMethodType(this.highLevel().definition())&&this.optional()),setAsWrapper&&_node.setWrapperNode(this)}return BasicNodeImpl.prototype.wrapperClassName=function(){return"BasicNodeImpl"},BasicNodeImpl.prototype.kind=function(){return"BasicNode"},BasicNodeImpl.prototype.parent=function(){var parent=this._node.parent();return parent?parent.wrapperNode():null},BasicNodeImpl.prototype.highLevel=function(){return this._node},BasicNodeImpl.prototype.patchNode=function(node){this._node=node},BasicNodeImpl.prototype.attributes=function(name,constr){var attrs=this._node.attributes(name);if(!attrs||0==attrs.length){var defaultValue=this.getDefaultsCalculator().attributeDefaultIfEnabled(this._node,this._node.definition().property(name));return null==defaultValue?[]:Array.isArray(defaultValue)?defaultValue:[defaultValue]}return attributesToValues(attrs,constr)},BasicNodeImpl.prototype.attribute=function(name,constr){var attr=this._node.attr(name);if(constr&&constr!=this.toString&&constr!=this.toBoolean&&constr!=this.toNumber&&constr!=this.toAny)return null==attr?null:constr(attr);var attributeValue=attr?attr.value():null;return null==attributeValue&&(attributeValue=this.getDefaultsCalculator().attributeDefaultIfEnabled(this._node,this._node.definition().property(name))),null==attributeValue?null:constr?constr(attributeValue):attributeValue},BasicNodeImpl.prototype.elements=function(name){var elements=this._node.elementsOfKind(name);return elements?elements.map(function(x){return x.wrapperNode()}):null},BasicNodeImpl.prototype.element=function(name){var element=this._node.element(name);return element?element.wrapperNode():null},BasicNodeImpl.prototype.add=function(node){this.highLevel().add(node.highLevel())},BasicNodeImpl.prototype.addToProp=function(node,prop){var hl=node.highLevel(),pr=this.highLevel().definition().property(prop);hl._prop=pr,this.highLevel().add(hl)},BasicNodeImpl.prototype.remove=function(node){this.highLevel().remove(node.highLevel())},BasicNodeImpl.prototype.dump=function(){return this.highLevel().dump("yaml")},BasicNodeImpl.prototype.toString=function(arg){var obj;return obj=arg.lowLevel&&arg.property?arg.value():arg,null!=obj?obj.toString():obj},BasicNodeImpl.prototype.toAny=function(arg){return arg},BasicNodeImpl.prototype.toBoolean=function(arg){var obj;return obj=arg.lowLevel&&arg.property?arg.value():arg,null!=obj?"true"==obj.toString():obj},BasicNodeImpl.prototype.toNumber=function(arg){var obj;if(obj=arg.lowLevel&&arg.property?arg.value():arg,!obj)return obj;try{var nValue=parseFloat(obj.toString());return nValue}catch(e){}return Number.MAX_VALUE},BasicNodeImpl.prototype.errors=function(){var _this=this,issues=[],highLevelErrors=this._node.errors();null!=highLevelErrors&&(issues=issues.concat(highLevelErrors));var rawResult=issues.map(function(x){return _this.basicError(x)}),result=this.filterErrors(rawResult);return result},BasicNodeImpl.prototype.filterErrors=function(rawErrors){var result=[],errorsMap={};rawErrors.map(function(x){errorsMap[JSON.stringify(x)]=x});for(var keys=Object.keys(errorsMap),i=0;i<keys.length;i++)result.push(errorsMap[keys[i]]);return result},BasicNodeImpl.prototype.basicError=function(x){var _this=this,lineMapper=x.node&&x.node.lowLevel()&&x.node.lowLevel().unit().lineMapper()||this._node.lowLevel().unit().lineMapper(),startPoint=null;try{startPoint=lineMapper.position(x.start)}catch(e){console.warn(e)}var endPoint=null;try{endPoint=lineMapper.position(x.end)}catch(e){console.warn(e)}var path;path=x.path?x.path:x.node?x.node.lowLevel().unit().path():search.declRoot(this.highLevel()).lowLevel().unit().path();var eObj={code:x.code,message:x.message,path:path,range:{start:startPoint,end:endPoint},isWarning:x.isWarning};return x.extras&&x.extras.length>0&&(eObj.trace=x.extras.map(function(y){return _this.basicError(y)})),eObj},BasicNodeImpl.prototype.definition=function(){return this.highLevel().definition()},BasicNodeImpl.prototype.runtimeDefinition=function(){return universeHelpers.isTypeDeclarationSibling(this.highLevel().definition())?this.highLevel().localType():null},BasicNodeImpl.prototype.toJSON=function(serializeOptions){var oldDefaults=defaultAttributeDefaultsValue;defaultAttributeDefaultsValue=this.attributeDefaults();try{return new tckDumper.TCKDumper(serializeOptions).dump(this)}finally{defaultAttributeDefaultsValue=oldDefaults}},BasicNodeImpl.prototype.optional=function(){var highLevel=this.highLevel();return null!=highLevel?highLevel.optional():!1},BasicNodeImpl.prototype.optionalProperties=function(){return this.highLevel()?this.highLevel().optionalProperties():[]},BasicNodeImpl.prototype.getDefaultsCalculator=function(){return this.defaultsCalculator?this.defaultsCalculator:(this.parent()&&(this.defaultsCalculator=this.parent().getDefaultsCalculator()),this.defaultsCalculator||(this.defaultsCalculator=new defaultCalculator.AttributeDefaultsCalculator(defaultAttributeDefaultsValue)),this.defaultsCalculator)},BasicNodeImpl.prototype.setAttributeDefaults=function(attributeDefaults){this.defaultsCalculator=new defaultCalculator.AttributeDefaultsCalculator(attributeDefaults)},BasicNodeImpl.prototype.attributeDefaults=function(){return this.getDefaultsCalculator()&&this.getDefaultsCalculator().isEnabled()},BasicNodeImpl.prototype.meta=function(){return fillElementMeta(this)},BasicNodeImpl.prototype.RAMLVersion=function(){return this.highLevel().definition().universe().version()},BasicNodeImpl}();exports.BasicNodeImpl=BasicNodeImpl;var defaultAttributeDefaultsValue=!0,AttributeNodeImpl=function(){function AttributeNodeImpl(attr){this._meta=new ValueMetadataImpl,this.attr=attr}return AttributeNodeImpl.prototype.highLevel=function(){return this.attr},AttributeNodeImpl.prototype.wrapperClassName=function(){return"AttributeNodeImpl"},AttributeNodeImpl.prototype.kind=function(){return"AttributeNode"},AttributeNodeImpl.prototype.optional=function(){var highLevel=this.highLevel();return null!=highLevel?highLevel.optional():!1},AttributeNodeImpl.prototype.meta=function(){return this._meta},AttributeNodeImpl.prototype.RAMLVersion=function(){return this.highLevel().definition().universe().version()},AttributeNodeImpl.prototype.parent=function(){var parent=this.attr.parent();return parent?parent.wrapperNode():null},AttributeNodeImpl.prototype.toJSON=function(serializeOptions){return new tckDumper.TCKDumper(serializeOptions).dump(this)},AttributeNodeImpl}();exports.AttributeNodeImpl=AttributeNodeImpl,exports.toStructuredValue=toStructuredValue;var TypeInstanceImpl=function(){function TypeInstanceImpl(nodes,type){this.type=type,Array.isArray(nodes)?this.children=nodes:this.node=nodes}return TypeInstanceImpl.prototype.properties=function(){return this.isArray()?[]:this.getChildren().map(function(x){return new TypeInstancePropertyImpl(x)})},TypeInstanceImpl.prototype.getChildren=function(){return this.node&&this.node.children()||this.children},TypeInstanceImpl.prototype.value=function(){return this.node&&this.node.value()},TypeInstanceImpl.prototype.isScalar=function(){return this.node?0!=this.node.children().length?!1:this.type?this.type.isScalar():!0:!1},TypeInstanceImpl.prototype.toJSON=function(){return(new tckDumper.TCKDumper).serializeTypeInstance(this)},TypeInstanceImpl.prototype.isArray=function(){return this.node?this.type?this.type.isArray():this.node&&this.node.valueKind()==yaml.Kind.SEQ:!1},TypeInstanceImpl.prototype.items=function(){return this.isArray()?this.node.children().map(function(x){return new TypeInstanceImpl(x)}):null},TypeInstanceImpl}();exports.TypeInstanceImpl=TypeInstanceImpl;var TypeInstancePropertyImpl=function(){function TypeInstancePropertyImpl(node){this.node=node}return TypeInstancePropertyImpl.prototype.name=function(){return this.node.optional()?this.node.key()+"?":this.node.key()},TypeInstancePropertyImpl.prototype.value=function(){if(this.isArray()){var children=this.node.children();return children.length>0?new TypeInstanceImpl(children[0]):null}return new TypeInstanceImpl(this.node)},TypeInstancePropertyImpl.prototype.values=function(){return this.isArray()?this.node.children().map(function(x){return new TypeInstanceImpl(x)}):[new TypeInstanceImpl(this.node)]},TypeInstancePropertyImpl.prototype.isArray=function(){var children=this.node.children();if(children.length>0&&null==children[0].key())return!0;var hl=this.node.highLevelNode();if(hl){var prop=hl.property();if(prop){var range=prop.range();if(range)return range.isArray()}}return this.node.valueKind()==yaml.Kind.SEQ},TypeInstancePropertyImpl}();exports.TypeInstancePropertyImpl=TypeInstancePropertyImpl;var ValueMetadataImpl=function(){function ValueMetadataImpl(_insertedAsDefault,_calculated,_optional){void 0===_insertedAsDefault&&(_insertedAsDefault=!1),void 0===_calculated&&(_calculated=!1),void 0===_optional&&(_optional=!1),this._insertedAsDefault=_insertedAsDefault,this._calculated=_calculated,this._optional=_optional}return ValueMetadataImpl.prototype.calculated=function(){return this._calculated},ValueMetadataImpl.prototype.insertedAsDefault=function(){return this._insertedAsDefault},ValueMetadataImpl.prototype.setCalculated=function(){this._calculated=!0},ValueMetadataImpl.prototype.setInsertedAsDefault=function(){this._insertedAsDefault=!0},ValueMetadataImpl.prototype.setOptional=function(){this._optional=!0},ValueMetadataImpl.prototype.optional=function(){return this._optional},ValueMetadataImpl.prototype.isDefault=function(){return!(this._insertedAsDefault||this._calculated||this._optional)},ValueMetadataImpl.prototype.toJSON=function(){var obj={};return this._calculated&&(obj.calculated=!0),this._insertedAsDefault&&(obj.insertedAsDefault=!0),this._optional&&(obj.optional=!0),obj},ValueMetadataImpl}();exports.ValueMetadataImpl=ValueMetadataImpl;var NodeMetadataImpl=function(_super){function NodeMetadataImpl(){_super.apply(this,arguments),this.valuesMeta={}}return __extends(NodeMetadataImpl,_super),NodeMetadataImpl.prototype.primitiveValuesMeta=function(){return this.valuesMeta},NodeMetadataImpl.prototype.registerInsertedAsDefaultValue=function(propName){var pMeta=this.valuesMeta[propName];null==pMeta?this.valuesMeta[propName]=new ValueMetadataImpl(!0):pMeta.setInsertedAsDefault()},NodeMetadataImpl.prototype.registerCalculatedValue=function(propName){var pMeta=this.valuesMeta[propName];null==pMeta?this.valuesMeta[propName]=new ValueMetadataImpl(!1,!0):pMeta.setCalculated()},NodeMetadataImpl.prototype.registerOptionalValue=function(propName){var pMeta=this.valuesMeta[propName];null==pMeta?this.valuesMeta[propName]=new ValueMetadataImpl(!1,!1,!0):pMeta.setOptional()},NodeMetadataImpl.prototype.resetPrimitiveValuesMeta=function(){this.valuesMeta={}},NodeMetadataImpl.prototype.isDefault=function(){return _super.prototype.isDefault.call(this)?0==Object.keys(this.valuesMeta).length:!1},NodeMetadataImpl.prototype.toJSON=function(){var _this=this,obj=_super.prototype.toJSON.call(this),valuesObj={},propKeys=Object.keys(this.valuesMeta);return propKeys.length>0&&(propKeys.forEach(function(x){var childMeta=_this.valuesMeta[x].toJSON();Object.keys(childMeta).length>0&&(valuesObj[x]=childMeta)}),obj.primitiveValuesMeta=valuesObj),obj},NodeMetadataImpl}(ValueMetadataImpl);exports.NodeMetadataImpl=NodeMetadataImpl,exports.fillElementMeta=fillElementMeta,exports.attributesToValues=attributesToValues},function(module,exports,__webpack_require__){"use strict";function getExtraProviderSource(extraProvider){var sourceExtra=extraProvider.getExtra(ramlTypes.SOURCE_EXTRA);return null==sourceExtra?null:def.isSourceProvider(sourceExtra)?sourceExtra:lowLevel.isLowLevelNode(sourceExtra)?{getSource:function(){return sourceExtra.highLevelNode()}}:hl.isParseResult(sourceExtra)?{getSource:function(){return sourceExtra}}:null}function getRTypeSource(rType){return getExtraProviderSource(rType)}function findRTypeByNominal(nominalType){var adapters=nominalType.getAdapters();return adapters?_.find(adapters,function(adapter){return def.rt.isParsedType(adapter)}):null}function getNominalTypeSource(nominalType){if(!nominalType)return null;var sourceExtra=nominalType.getExtra(ramlTypes.SOURCE_EXTRA);if(sourceExtra)return getExtraProviderSource(nominalType);var rType=findRTypeByNominal(nominalType);return rType?getRTypeSource(rType):null}function getNominalPropertySource(type,name){var typeSource=getNominalTypeSource(type);return typeSource?{getSource:function(){var typeNode=typeSource.getSource(),typeNodeElement=typeNode.asElement();if(null==typeNodeElement)return null;var propertyElements=typeNodeElement.elementsOfKind(universes.Universe10.ObjectTypeDeclaration.properties.properties.name);return null==propertyElements||0==propertyElements.length?null:_.find(propertyElements,function(propertyElement){return name==propertyElement.attrValue(universes.Universe10.TypeDeclaration.properties.name.name)})}}:null}function getNominalPropertySource2(property){return getNominalPropertySource(property.domain(),property.nameId())}var def=__webpack_require__(36),ramlTypes=def.rt,hl=__webpack_require__(10),lowLevel=__webpack_require__(11),universes=__webpack_require__(18),_=__webpack_require__(65);exports.getExtraProviderSource=getExtraProviderSource,exports.getRTypeSource=getRTypeSource,exports.findRTypeByNominal=findRTypeByNominal,exports.getNominalTypeSource=getNominalTypeSource,exports.getNominalPropertySource=getNominalPropertySource,exports.getNominalPropertySource2=getNominalPropertySource2},function(module,exports,__webpack_require__){"use strict";function createMethod(key){var universe=def.getUniverse("RAML08"),nc=universe.type("Method"),node=stubs.createStubNode(nc,null,key);return node}function createStringTypeDeclaration(key){var universe=def.getUniverse("RAML08"),nc=universe.type("StringTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createBooleanTypeDeclaration(key){var universe=def.getUniverse("RAML08"),nc=universe.type("BooleanTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createNumberTypeDeclaration(key){var universe=def.getUniverse("RAML08"),nc=universe.type("NumberTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createIntegerTypeDeclaration(key){var universe=def.getUniverse("RAML08"),nc=universe.type("IntegerTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createDateTypeDeclaration(key){var universe=def.getUniverse("RAML08"),nc=universe.type("DateTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createFileTypeDeclaration(key){var universe=def.getUniverse("RAML08"),nc=universe.type("FileTypeDeclaration"),node=stubs.createStubNode(nc,null,key);return node}function createXMLBody(key){var universe=def.getUniverse("RAML08"),nc=universe.type("XMLBody"),node=stubs.createStubNode(nc,null,key);return node}function createJSONBody(key){var universe=def.getUniverse("RAML08"),nc=universe.type("JSONBody"),node=stubs.createStubNode(nc,null,key);return node}function createSecuritySchemePart(key){var universe=def.getUniverse("RAML08"),nc=universe.type("SecuritySchemePart"),node=stubs.createStubNode(nc,null,key);return node}function createTrait(key){var universe=def.getUniverse("RAML08"),nc=universe.type("Trait"),node=stubs.createStubNode(nc,null,key);return node}function createOAuth1SecuritySchemeSettings(key){var universe=def.getUniverse("RAML08"),nc=universe.type("OAuth1SecuritySchemeSettings"),node=stubs.createStubNode(nc,null,key);return node}function createOAuth2SecuritySchemeSettings(key){var universe=def.getUniverse("RAML08"),nc=universe.type("OAuth2SecuritySchemeSettings"),node=stubs.createStubNode(nc,null,key);return node}function createOAuth2SecurityScheme(key){var universe=def.getUniverse("RAML08"),nc=universe.type("OAuth2SecurityScheme"),node=stubs.createStubNode(nc,null,key);return node}function createOAuth1SecurityScheme(key){var universe=def.getUniverse("RAML08"),nc=universe.type("OAuth1SecurityScheme"),node=stubs.createStubNode(nc,null,key);return node}function createBasicSecurityScheme(key){var universe=def.getUniverse("RAML08"),nc=universe.type("BasicSecurityScheme"),node=stubs.createStubNode(nc,null,key);return node}function createDigestSecurityScheme(key){var universe=def.getUniverse("RAML08"),nc=universe.type("DigestSecurityScheme"),node=stubs.createStubNode(nc,null,key);return node}function createCustomSecurityScheme(key){var universe=def.getUniverse("RAML08"),nc=universe.type("CustomSecurityScheme"),node=stubs.createStubNode(nc,null,key);return node}function createGlobalSchema(key){var universe=def.getUniverse("RAML08"),nc=universe.type("GlobalSchema"),node=stubs.createStubNode(nc,null,key);return node}function createDocumentationItem(key){var universe=def.getUniverse("RAML08"),nc=universe.type("DocumentationItem"),node=stubs.createStubNode(nc,null,key);return node}function loadApiSync(apiPath,arg1,arg2){return apiLoader.loadApi(apiPath,arg1,arg2).getOrElse(null)}function loadRAMLSync(ramlPath,arg1,arg2){return apiLoader.loadApi(ramlPath,arg1,arg2).getOrElse(null)}function loadApi(apiPath,arg1,arg2){return apiLoader.loadApiAsync(apiPath,arg1,arg2)}function loadRAML(ramlPath,arg1,arg2){return apiLoader.loadRAMLAsync(ramlPath,arg1,arg2)}function getLanguageElementByRuntimeType(runtimeType){return apiLoader.getLanguageElementByRuntimeType(runtimeType)}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},stubs=__webpack_require__(17),def=__webpack_require__(36),core=__webpack_require__(45),apiLoader=__webpack_require__(9),helper=__webpack_require__(48),ApiImpl=function(_super){function ApiImpl(){_super.apply(this,arguments)}return __extends(ApiImpl,_super),ApiImpl.prototype.title=function(){return _super.prototype.attribute.call(this,"title",this.toString)},ApiImpl.prototype.setTitle=function(param){return this.highLevel().attrOrCreate("title").setValue(""+param),this},ApiImpl.prototype.version=function(){return _super.prototype.attribute.call(this,"version",this.toString)},ApiImpl.prototype.setVersion=function(param){return this.highLevel().attrOrCreate("version").setValue(""+param),this},ApiImpl.prototype.baseUri=function(){return _super.prototype.attribute.call(this,"baseUri",function(attr){return new FullUriTemplateStringImpl(attr)})},ApiImpl.prototype.baseUriParameters_original=function(){return _super.prototype.elements.call(this,"baseUriParameters")},ApiImpl.prototype.uriParameters=function(){return _super.prototype.elements.call(this,"uriParameters")},ApiImpl.prototype.protocols=function(){return _super.prototype.attributes.call(this,"protocols",this.toString)},ApiImpl.prototype.setProtocols=function(param){return this.highLevel().attrOrCreate("protocols").setValue(""+param),this},ApiImpl.prototype.mediaType=function(){return _super.prototype.attribute.call(this,"mediaType",function(attr){return new MimeTypeImpl(attr)})},ApiImpl.prototype.schemas=function(){return _super.prototype.elements.call(this,"schemas")},ApiImpl.prototype.traits_original=function(){return _super.prototype.elements.call(this,"traits")},ApiImpl.prototype.securedBy=function(){return _super.prototype.attributes.call(this,"securedBy",function(attr){return new SecuritySchemeRefImpl(attr)})},ApiImpl.prototype.securitySchemes=function(){return _super.prototype.elements.call(this,"securitySchemes")},ApiImpl.prototype.resourceTypes_original=function(){return _super.prototype.elements.call(this,"resourceTypes")},ApiImpl.prototype.resources=function(){return _super.prototype.elements.call(this,"resources")},ApiImpl.prototype.documentation=function(){return _super.prototype.elements.call(this,"documentation")},ApiImpl.prototype.wrapperClassName=function(){return"ApiImpl"},ApiImpl.prototype.kind=function(){return"Api"},ApiImpl.prototype.RAMLVersion_original=function(){return"RAML08"},ApiImpl.prototype.expand=function(){return helper.expandTraitsAndResourceTypes(this)},ApiImpl.prototype.traits=function(){return helper.traitsPrimary(this)},ApiImpl.prototype.allTraits=function(){return helper.allTraits(this)},ApiImpl.prototype.resourceTypes=function(){return helper.resourceTypesPrimary(this)},ApiImpl.prototype.allResourceTypes=function(){return helper.allResourceTypes(this)},ApiImpl.prototype.childResource=function(relPath){return helper.childResource(this,relPath)},ApiImpl.prototype.allResources=function(){return helper.allResources(this)},ApiImpl.prototype.baseUriParameters=function(){return helper.baseUriParametersPrimary(this)},ApiImpl.prototype.allBaseUriParameters=function(){return helper.baseUriParameters(this)},ApiImpl.prototype.allProtocols=function(){return helper.allProtocols(this)},ApiImpl.prototype.RAMLVersion=function(){return helper.RAMLVersion(this)},ApiImpl}(core.BasicNodeImpl);exports.ApiImpl=ApiImpl;var ValueTypeImpl=function(_super){function ValueTypeImpl(){_super.apply(this,arguments)}return __extends(ValueTypeImpl,_super),ValueTypeImpl.prototype.wrapperClassName=function(){return"ValueTypeImpl"},ValueTypeImpl.prototype.kind=function(){return"ValueType"},ValueTypeImpl.prototype.RAMLVersion=function(){return"undefined"},ValueTypeImpl.prototype.value=function(){return this.attr.value()},ValueTypeImpl}(core.AttributeNodeImpl);exports.ValueTypeImpl=ValueTypeImpl;var AnyTypeImpl=function(_super){function AnyTypeImpl(){_super.apply(this,arguments)}return __extends(AnyTypeImpl,_super),AnyTypeImpl.prototype.wrapperClassName=function(){return"AnyTypeImpl"},AnyTypeImpl.prototype.kind=function(){return"AnyType"},AnyTypeImpl.prototype.RAMLVersion=function(){return"RAML08"},AnyTypeImpl}(ValueTypeImpl);exports.AnyTypeImpl=AnyTypeImpl;var NumberTypeImpl=function(_super){function NumberTypeImpl(){_super.apply(this,arguments)}return __extends(NumberTypeImpl,_super),NumberTypeImpl.prototype.wrapperClassName=function(){return"NumberTypeImpl"},NumberTypeImpl.prototype.kind=function(){return"NumberType"},NumberTypeImpl.prototype.RAMLVersion=function(){return"RAML08"},NumberTypeImpl.prototype.value=function(){return this.attr.value()},NumberTypeImpl}(ValueTypeImpl);exports.NumberTypeImpl=NumberTypeImpl;var BooleanTypeImpl=function(_super){function BooleanTypeImpl(){_super.apply(this,arguments)}return __extends(BooleanTypeImpl,_super),BooleanTypeImpl.prototype.wrapperClassName=function(){return"BooleanTypeImpl"},BooleanTypeImpl.prototype.kind=function(){return"BooleanType"},BooleanTypeImpl.prototype.RAMLVersion=function(){return"RAML08"},BooleanTypeImpl.prototype.value=function(){return this.attr.value()},BooleanTypeImpl}(ValueTypeImpl);exports.BooleanTypeImpl=BooleanTypeImpl;var ReferenceImpl=function(_super){function ReferenceImpl(){_super.apply(this,arguments)}return __extends(ReferenceImpl,_super),ReferenceImpl.prototype.wrapperClassName=function(){return"ReferenceImpl"},ReferenceImpl.prototype.kind=function(){return"Reference"},ReferenceImpl.prototype.RAMLVersion=function(){return"RAML08"},ReferenceImpl.prototype.value=function(){return core.toStructuredValue(this.attr)},ReferenceImpl.prototype.structuredValue=function(){return helper.structuredValue(this)},ReferenceImpl.prototype.name=function(){return helper.referenceName(this)},ReferenceImpl}(core.AttributeNodeImpl);exports.ReferenceImpl=ReferenceImpl;var ResourceTypeRefImpl=function(_super){function ResourceTypeRefImpl(){_super.apply(this,arguments)}return __extends(ResourceTypeRefImpl,_super),ResourceTypeRefImpl.prototype.wrapperClassName=function(){return"ResourceTypeRefImpl"},ResourceTypeRefImpl.prototype.kind=function(){return"ResourceTypeRef"},ResourceTypeRefImpl.prototype.RAMLVersion=function(){return"RAML08"},ResourceTypeRefImpl.prototype.resourceType=function(){return helper.referencedResourceType(this)},ResourceTypeRefImpl}(ReferenceImpl);exports.ResourceTypeRefImpl=ResourceTypeRefImpl;var ResourceTypeImpl=function(_super){function ResourceTypeImpl(){_super.apply(this,arguments)}return __extends(ResourceTypeImpl,_super),ResourceTypeImpl.prototype.name=function(){return _super.prototype.attribute.call(this,"name",this.toString)},ResourceTypeImpl.prototype.setName=function(param){return this.highLevel().attrOrCreate("name").setValue(""+param),this},ResourceTypeImpl.prototype.usage=function(){return _super.prototype.attribute.call(this,"usage",this.toString)},ResourceTypeImpl.prototype.setUsage=function(param){return this.highLevel().attrOrCreate("usage").setValue(""+param),this},ResourceTypeImpl.prototype.methods=function(){return _super.prototype.elements.call(this,"methods")},ResourceTypeImpl.prototype.is=function(){return _super.prototype.attributes.call(this,"is",function(attr){return new TraitRefImpl(attr)})},ResourceTypeImpl.prototype.type=function(){return _super.prototype.attribute.call(this,"type",function(attr){return new ResourceTypeRefImpl(attr)})},ResourceTypeImpl.prototype.securedBy=function(){return _super.prototype.attributes.call(this,"securedBy",function(attr){return new SecuritySchemeRefImpl(attr)})},ResourceTypeImpl.prototype.uriParameters=function(){return _super.prototype.elements.call(this,"uriParameters")},ResourceTypeImpl.prototype.displayName=function(){return _super.prototype.attribute.call(this,"displayName",this.toString)},ResourceTypeImpl.prototype.setDisplayName=function(param){return this.highLevel().attrOrCreate("displayName").setValue(""+param),this},ResourceTypeImpl.prototype.baseUriParameters=function(){return _super.prototype.elements.call(this,"baseUriParameters")},ResourceTypeImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},ResourceTypeImpl.prototype.wrapperClassName=function(){return"ResourceTypeImpl"},ResourceTypeImpl.prototype.kind=function(){return"ResourceType"},ResourceTypeImpl.prototype.RAMLVersion=function(){return"RAML08"},ResourceTypeImpl.prototype.parametrizedProperties=function(){return helper.getTemplateParametrizedProperties(this)},ResourceTypeImpl}(core.BasicNodeImpl);exports.ResourceTypeImpl=ResourceTypeImpl;var MethodBaseImpl=function(_super){function MethodBaseImpl(){_super.apply(this,arguments)}return __extends(MethodBaseImpl,_super),MethodBaseImpl.prototype.responses=function(){
return _super.prototype.elements.call(this,"responses")},MethodBaseImpl.prototype.body=function(){return _super.prototype.elements.call(this,"body")},MethodBaseImpl.prototype.protocols=function(){return _super.prototype.attributes.call(this,"protocols",this.toString)},MethodBaseImpl.prototype.setProtocols=function(param){return this.highLevel().attrOrCreate("protocols").setValue(""+param),this},MethodBaseImpl.prototype.securedBy=function(){return _super.prototype.attributes.call(this,"securedBy",function(attr){return new SecuritySchemeRefImpl(attr)})},MethodBaseImpl.prototype.baseUriParameters=function(){return _super.prototype.elements.call(this,"baseUriParameters")},MethodBaseImpl.prototype.queryParameters=function(){return _super.prototype.elements.call(this,"queryParameters")},MethodBaseImpl.prototype.headers=function(){return _super.prototype.elements.call(this,"headers")},MethodBaseImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},MethodBaseImpl.prototype.wrapperClassName=function(){return"MethodBaseImpl"},MethodBaseImpl.prototype.kind=function(){return"MethodBase"},MethodBaseImpl.prototype.RAMLVersion=function(){return"RAML08"},MethodBaseImpl}(core.BasicNodeImpl);exports.MethodBaseImpl=MethodBaseImpl;var ResponseImpl=function(_super){function ResponseImpl(){_super.apply(this,arguments)}return __extends(ResponseImpl,_super),ResponseImpl.prototype.code=function(){return _super.prototype.attribute.call(this,"code",function(attr){return new StatusCodeStringImpl(attr)})},ResponseImpl.prototype.headers=function(){return _super.prototype.elements.call(this,"headers")},ResponseImpl.prototype.body=function(){return _super.prototype.elements.call(this,"body")},ResponseImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},ResponseImpl.prototype.wrapperClassName=function(){return"ResponseImpl"},ResponseImpl.prototype.kind=function(){return"Response"},ResponseImpl.prototype.RAMLVersion=function(){return"RAML08"},ResponseImpl.prototype.isOkRange=function(){return helper.isOkRange(this)},ResponseImpl}(core.BasicNodeImpl);exports.ResponseImpl=ResponseImpl;var StringTypeImpl=function(_super){function StringTypeImpl(){_super.apply(this,arguments)}return __extends(StringTypeImpl,_super),StringTypeImpl.prototype.wrapperClassName=function(){return"StringTypeImpl"},StringTypeImpl.prototype.kind=function(){return"StringType"},StringTypeImpl.prototype.RAMLVersion=function(){return"RAML08"},StringTypeImpl.prototype.value=function(){return this.attr.value()},StringTypeImpl}(ValueTypeImpl);exports.StringTypeImpl=StringTypeImpl;var StatusCodeStringImpl=function(_super){function StatusCodeStringImpl(){_super.apply(this,arguments)}return __extends(StatusCodeStringImpl,_super),StatusCodeStringImpl.prototype.wrapperClassName=function(){return"StatusCodeStringImpl"},StatusCodeStringImpl.prototype.kind=function(){return"StatusCodeString"},StatusCodeStringImpl.prototype.RAMLVersion=function(){return"RAML08"},StatusCodeStringImpl}(StringTypeImpl);exports.StatusCodeStringImpl=StatusCodeStringImpl;var ParameterImpl=function(_super){function ParameterImpl(){_super.apply(this,arguments)}return __extends(ParameterImpl,_super),ParameterImpl.prototype.name=function(){return _super.prototype.attribute.call(this,"name",this.toString)},ParameterImpl.prototype.setName=function(param){return this.highLevel().attrOrCreate("name").setValue(""+param),this},ParameterImpl.prototype.displayName=function(){return _super.prototype.attribute.call(this,"displayName",this.toString)},ParameterImpl.prototype.setDisplayName=function(param){return this.highLevel().attrOrCreate("displayName").setValue(""+param),this},ParameterImpl.prototype.type=function(){return _super.prototype.attribute.call(this,"type",this.toString)},ParameterImpl.prototype.setType=function(param){return this.highLevel().attrOrCreate("type").setValue(""+param),this},ParameterImpl.prototype.location=function(){return _super.prototype.attribute.call(this,"location",function(attr){return new ParameterLocationImpl(attr)})},ParameterImpl.prototype.required=function(){return _super.prototype.attribute.call(this,"required",this.toBoolean)},ParameterImpl.prototype.setRequired=function(param){return this.highLevel().attrOrCreate("required").setValue(""+param),this},ParameterImpl.prototype["default"]=function(){return _super.prototype.attribute.call(this,"default",this.toAny)},ParameterImpl.prototype.setDefault=function(param){return this.highLevel().attrOrCreate("default").setValue(""+param),this},ParameterImpl.prototype.example=function(){return _super.prototype.attribute.call(this,"example",this.toString)},ParameterImpl.prototype.setExample=function(param){return this.highLevel().attrOrCreate("example").setValue(""+param),this},ParameterImpl.prototype.repeat=function(){return _super.prototype.attribute.call(this,"repeat",this.toBoolean)},ParameterImpl.prototype.setRepeat=function(param){return this.highLevel().attrOrCreate("repeat").setValue(""+param),this},ParameterImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},ParameterImpl.prototype.wrapperClassName=function(){return"ParameterImpl"},ParameterImpl.prototype.kind=function(){return"Parameter"},ParameterImpl.prototype.RAMLVersion=function(){return"RAML08"},ParameterImpl}(core.BasicNodeImpl);exports.ParameterImpl=ParameterImpl;var ParameterLocationImpl=function(){function ParameterLocationImpl(attr){this.attr=attr}return ParameterLocationImpl.prototype.wrapperClassName=function(){return"ParameterLocationImpl"},ParameterLocationImpl.prototype.kind=function(){return"ParameterLocation"},ParameterLocationImpl.prototype.RAMLVersion=function(){return"RAML08"},ParameterLocationImpl}();exports.ParameterLocationImpl=ParameterLocationImpl;var MarkdownStringImpl=function(_super){function MarkdownStringImpl(){_super.apply(this,arguments)}return __extends(MarkdownStringImpl,_super),MarkdownStringImpl.prototype.wrapperClassName=function(){return"MarkdownStringImpl"},MarkdownStringImpl.prototype.kind=function(){return"MarkdownString"},MarkdownStringImpl.prototype.RAMLVersion=function(){return"RAML08"},MarkdownStringImpl}(StringTypeImpl);exports.MarkdownStringImpl=MarkdownStringImpl;var StringTypeDeclarationImpl=function(_super){function StringTypeDeclarationImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createStringTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(StringTypeDeclarationImpl,_super),StringTypeDeclarationImpl.prototype.pattern=function(){return _super.prototype.attribute.call(this,"pattern",this.toString)},StringTypeDeclarationImpl.prototype.setPattern=function(param){return this.highLevel().attrOrCreate("pattern").setValue(""+param),this},StringTypeDeclarationImpl.prototype["enum"]=function(){return _super.prototype.attributes.call(this,"enum",this.toString)},StringTypeDeclarationImpl.prototype.setEnum=function(param){return this.highLevel().attrOrCreate("enum").setValue(""+param),this},StringTypeDeclarationImpl.prototype.minLength=function(){return _super.prototype.attribute.call(this,"minLength",this.toNumber)},StringTypeDeclarationImpl.prototype.setMinLength=function(param){return this.highLevel().attrOrCreate("minLength").setValue(""+param),this},StringTypeDeclarationImpl.prototype.maxLength=function(){return _super.prototype.attribute.call(this,"maxLength",this.toNumber)},StringTypeDeclarationImpl.prototype.setMaxLength=function(param){return this.highLevel().attrOrCreate("maxLength").setValue(""+param),this},StringTypeDeclarationImpl.prototype.wrapperClassName=function(){return"StringTypeDeclarationImpl"},StringTypeDeclarationImpl.prototype.kind=function(){return"StringTypeDeclaration"},StringTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML08"},StringTypeDeclarationImpl}(ParameterImpl);exports.StringTypeDeclarationImpl=StringTypeDeclarationImpl;var BooleanTypeDeclarationImpl=function(_super){function BooleanTypeDeclarationImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createBooleanTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(BooleanTypeDeclarationImpl,_super),BooleanTypeDeclarationImpl.prototype.wrapperClassName=function(){return"BooleanTypeDeclarationImpl"},BooleanTypeDeclarationImpl.prototype.kind=function(){return"BooleanTypeDeclaration"},BooleanTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML08"},BooleanTypeDeclarationImpl}(ParameterImpl);exports.BooleanTypeDeclarationImpl=BooleanTypeDeclarationImpl;var NumberTypeDeclarationImpl=function(_super){function NumberTypeDeclarationImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createNumberTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(NumberTypeDeclarationImpl,_super),NumberTypeDeclarationImpl.prototype.minimum=function(){return _super.prototype.attribute.call(this,"minimum",this.toNumber)},NumberTypeDeclarationImpl.prototype.setMinimum=function(param){return this.highLevel().attrOrCreate("minimum").setValue(""+param),this},NumberTypeDeclarationImpl.prototype.maximum=function(){return _super.prototype.attribute.call(this,"maximum",this.toNumber)},NumberTypeDeclarationImpl.prototype.setMaximum=function(param){return this.highLevel().attrOrCreate("maximum").setValue(""+param),this},NumberTypeDeclarationImpl.prototype.wrapperClassName=function(){return"NumberTypeDeclarationImpl"},NumberTypeDeclarationImpl.prototype.kind=function(){return"NumberTypeDeclaration"},NumberTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML08"},NumberTypeDeclarationImpl}(ParameterImpl);exports.NumberTypeDeclarationImpl=NumberTypeDeclarationImpl;var IntegerTypeDeclarationImpl=function(_super){function IntegerTypeDeclarationImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createIntegerTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(IntegerTypeDeclarationImpl,_super),IntegerTypeDeclarationImpl.prototype.wrapperClassName=function(){return"IntegerTypeDeclarationImpl"},IntegerTypeDeclarationImpl.prototype.kind=function(){return"IntegerTypeDeclaration"},IntegerTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML08"},IntegerTypeDeclarationImpl}(NumberTypeDeclarationImpl);exports.IntegerTypeDeclarationImpl=IntegerTypeDeclarationImpl;var DateTypeDeclarationImpl=function(_super){function DateTypeDeclarationImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createDateTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(DateTypeDeclarationImpl,_super),DateTypeDeclarationImpl.prototype.wrapperClassName=function(){return"DateTypeDeclarationImpl"},DateTypeDeclarationImpl.prototype.kind=function(){return"DateTypeDeclaration"},DateTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML08"},DateTypeDeclarationImpl}(ParameterImpl);exports.DateTypeDeclarationImpl=DateTypeDeclarationImpl;var FileTypeDeclarationImpl=function(_super){function FileTypeDeclarationImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createFileTypeDeclaration(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(FileTypeDeclarationImpl,_super),FileTypeDeclarationImpl.prototype.wrapperClassName=function(){return"FileTypeDeclarationImpl"},FileTypeDeclarationImpl.prototype.kind=function(){return"FileTypeDeclaration"},FileTypeDeclarationImpl.prototype.RAMLVersion=function(){return"RAML08"},FileTypeDeclarationImpl}(ParameterImpl);exports.FileTypeDeclarationImpl=FileTypeDeclarationImpl;var BodyLikeImpl=function(_super){function BodyLikeImpl(){_super.apply(this,arguments)}return __extends(BodyLikeImpl,_super),BodyLikeImpl.prototype.name=function(){return _super.prototype.attribute.call(this,"name",this.toString)},BodyLikeImpl.prototype.setName=function(param){return this.highLevel().attrOrCreate("name").setValue(""+param),this},BodyLikeImpl.prototype.schema=function(){return _super.prototype.attribute.call(this,"schema",function(attr){return new SchemaStringImpl(attr)})},BodyLikeImpl.prototype.example=function(){return _super.prototype.attribute.call(this,"example",function(attr){return new ExampleStringImpl(attr)})},BodyLikeImpl.prototype.formParameters=function(){return _super.prototype.elements.call(this,"formParameters")},BodyLikeImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},BodyLikeImpl.prototype.wrapperClassName=function(){return"BodyLikeImpl"},BodyLikeImpl.prototype.kind=function(){return"BodyLike"},BodyLikeImpl.prototype.RAMLVersion=function(){return"RAML08"},BodyLikeImpl.prototype.schemaContent=function(){return helper.schemaContent(this)},BodyLikeImpl}(core.BasicNodeImpl);exports.BodyLikeImpl=BodyLikeImpl;var SchemaStringImpl=function(_super){function SchemaStringImpl(){_super.apply(this,arguments)}return __extends(SchemaStringImpl,_super),SchemaStringImpl.prototype.wrapperClassName=function(){return"SchemaStringImpl"},SchemaStringImpl.prototype.kind=function(){return"SchemaString"},SchemaStringImpl.prototype.RAMLVersion=function(){return"RAML08"},SchemaStringImpl}(StringTypeImpl);exports.SchemaStringImpl=SchemaStringImpl;var JSonSchemaStringImpl=function(_super){function JSonSchemaStringImpl(){_super.apply(this,arguments)}return __extends(JSonSchemaStringImpl,_super),JSonSchemaStringImpl.prototype.wrapperClassName=function(){return"JSonSchemaStringImpl"},JSonSchemaStringImpl.prototype.kind=function(){return"JSonSchemaString"},JSonSchemaStringImpl.prototype.RAMLVersion=function(){return"RAML08"},JSonSchemaStringImpl}(SchemaStringImpl);exports.JSonSchemaStringImpl=JSonSchemaStringImpl;var XMLSchemaStringImpl=function(_super){function XMLSchemaStringImpl(){_super.apply(this,arguments)}return __extends(XMLSchemaStringImpl,_super),XMLSchemaStringImpl.prototype.wrapperClassName=function(){return"XMLSchemaStringImpl"},XMLSchemaStringImpl.prototype.kind=function(){return"XMLSchemaString"},XMLSchemaStringImpl.prototype.RAMLVersion=function(){return"RAML08"},XMLSchemaStringImpl}(SchemaStringImpl);exports.XMLSchemaStringImpl=XMLSchemaStringImpl;var ExampleStringImpl=function(_super){function ExampleStringImpl(){_super.apply(this,arguments)}return __extends(ExampleStringImpl,_super),ExampleStringImpl.prototype.wrapperClassName=function(){return"ExampleStringImpl"},ExampleStringImpl.prototype.kind=function(){return"ExampleString"},ExampleStringImpl.prototype.RAMLVersion=function(){return"RAML08"},ExampleStringImpl}(StringTypeImpl);exports.ExampleStringImpl=ExampleStringImpl;var JSONExampleImpl=function(_super){function JSONExampleImpl(){_super.apply(this,arguments)}return __extends(JSONExampleImpl,_super),JSONExampleImpl.prototype.wrapperClassName=function(){return"JSONExampleImpl"},JSONExampleImpl.prototype.kind=function(){return"JSONExample"},JSONExampleImpl.prototype.RAMLVersion=function(){return"RAML08"},JSONExampleImpl}(ExampleStringImpl);exports.JSONExampleImpl=JSONExampleImpl;var XMLExampleImpl=function(_super){function XMLExampleImpl(){_super.apply(this,arguments)}return __extends(XMLExampleImpl,_super),XMLExampleImpl.prototype.wrapperClassName=function(){return"XMLExampleImpl"},XMLExampleImpl.prototype.kind=function(){return"XMLExample"},XMLExampleImpl.prototype.RAMLVersion=function(){return"RAML08"},XMLExampleImpl}(ExampleStringImpl);exports.XMLExampleImpl=XMLExampleImpl;var XMLBodyImpl=function(_super){function XMLBodyImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createXMLBody(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(XMLBodyImpl,_super),XMLBodyImpl.prototype.schema=function(){return _super.prototype.attribute.call(this,"schema",function(attr){return new XMLSchemaStringImpl(attr)})},XMLBodyImpl.prototype.wrapperClassName=function(){return"XMLBodyImpl"},XMLBodyImpl.prototype.kind=function(){return"XMLBody"},XMLBodyImpl.prototype.RAMLVersion=function(){return"RAML08"},XMLBodyImpl}(BodyLikeImpl);exports.XMLBodyImpl=XMLBodyImpl;var JSONBodyImpl=function(_super){function JSONBodyImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createJSONBody(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(JSONBodyImpl,_super),JSONBodyImpl.prototype.schema=function(){return _super.prototype.attribute.call(this,"schema",function(attr){return new JSonSchemaStringImpl(attr)})},JSONBodyImpl.prototype.wrapperClassName=function(){return"JSONBodyImpl"},JSONBodyImpl.prototype.kind=function(){return"JSONBody"},JSONBodyImpl.prototype.RAMLVersion=function(){return"RAML08"},JSONBodyImpl}(BodyLikeImpl);exports.JSONBodyImpl=JSONBodyImpl;var SecuritySchemeRefImpl=function(_super){function SecuritySchemeRefImpl(){_super.apply(this,arguments)}return __extends(SecuritySchemeRefImpl,_super),SecuritySchemeRefImpl.prototype.wrapperClassName=function(){return"SecuritySchemeRefImpl"},SecuritySchemeRefImpl.prototype.kind=function(){return"SecuritySchemeRef"},SecuritySchemeRefImpl.prototype.RAMLVersion=function(){return"RAML08"},SecuritySchemeRefImpl.prototype.securitySchemeName=function(){return helper.securitySchemeName(this)},SecuritySchemeRefImpl.prototype.securityScheme=function(){return helper.securityScheme(this)},SecuritySchemeRefImpl}(ReferenceImpl);exports.SecuritySchemeRefImpl=SecuritySchemeRefImpl;var AbstractSecuritySchemeImpl=function(_super){function AbstractSecuritySchemeImpl(){_super.apply(this,arguments)}return __extends(AbstractSecuritySchemeImpl,_super),AbstractSecuritySchemeImpl.prototype.name=function(){return _super.prototype.attribute.call(this,"name",this.toString)},AbstractSecuritySchemeImpl.prototype.setName=function(param){return this.highLevel().attrOrCreate("name").setValue(""+param),this},AbstractSecuritySchemeImpl.prototype.type=function(){return _super.prototype.attribute.call(this,"type",this.toString)},AbstractSecuritySchemeImpl.prototype.setType=function(param){return this.highLevel().attrOrCreate("type").setValue(""+param),this},AbstractSecuritySchemeImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},AbstractSecuritySchemeImpl.prototype.describedBy=function(){return _super.prototype.element.call(this,"describedBy")},AbstractSecuritySchemeImpl.prototype.settings=function(){return _super.prototype.element.call(this,"settings")},AbstractSecuritySchemeImpl.prototype.wrapperClassName=function(){return"AbstractSecuritySchemeImpl"},AbstractSecuritySchemeImpl.prototype.kind=function(){return"AbstractSecurityScheme"},AbstractSecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML08"},AbstractSecuritySchemeImpl}(core.BasicNodeImpl);exports.AbstractSecuritySchemeImpl=AbstractSecuritySchemeImpl;var SecuritySchemePartImpl=function(_super){function SecuritySchemePartImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createSecuritySchemePart(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(SecuritySchemePartImpl,_super),SecuritySchemePartImpl.prototype.displayName=function(){return _super.prototype.attribute.call(this,"displayName",this.toString)},SecuritySchemePartImpl.prototype.setDisplayName=function(param){return this.highLevel().attrOrCreate("displayName").setValue(""+param),this},SecuritySchemePartImpl.prototype.is=function(){return _super.prototype.attributes.call(this,"is",function(attr){return new TraitRefImpl(attr)})},SecuritySchemePartImpl.prototype.headers=function(){return _super.prototype.elements.call(this,"headers")},SecuritySchemePartImpl.prototype.queryParameters=function(){return _super.prototype.elements.call(this,"queryParameters")},SecuritySchemePartImpl.prototype.responses=function(){return _super.prototype.elements.call(this,"responses")},SecuritySchemePartImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},SecuritySchemePartImpl.prototype.wrapperClassName=function(){return"SecuritySchemePartImpl"},SecuritySchemePartImpl.prototype.kind=function(){return"SecuritySchemePart"},SecuritySchemePartImpl.prototype.RAMLVersion=function(){return"RAML08"},SecuritySchemePartImpl}(MethodBaseImpl);exports.SecuritySchemePartImpl=SecuritySchemePartImpl;var TraitRefImpl=function(_super){function TraitRefImpl(){_super.apply(this,arguments)}return __extends(TraitRefImpl,_super),TraitRefImpl.prototype.wrapperClassName=function(){return"TraitRefImpl"},TraitRefImpl.prototype.kind=function(){return"TraitRef"},TraitRefImpl.prototype.RAMLVersion=function(){return"RAML08"},TraitRefImpl.prototype.trait=function(){return helper.referencedTrait(this)},TraitRefImpl}(ReferenceImpl);exports.TraitRefImpl=TraitRefImpl;var TraitImpl=function(_super){function TraitImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createTrait(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(TraitImpl,_super),TraitImpl.prototype.name=function(){return _super.prototype.attribute.call(this,"name",this.toString)},TraitImpl.prototype.setName=function(param){return this.highLevel().attrOrCreate("name").setValue(""+param),this},TraitImpl.prototype.usage=function(){return _super.prototype.attribute.call(this,"usage",this.toString)},TraitImpl.prototype.setUsage=function(param){return this.highLevel().attrOrCreate("usage").setValue(""+param),this},TraitImpl.prototype.displayName=function(){return _super.prototype.attribute.call(this,"displayName",this.toString)},TraitImpl.prototype.setDisplayName=function(param){return this.highLevel().attrOrCreate("displayName").setValue(""+param),this},TraitImpl.prototype.wrapperClassName=function(){return"TraitImpl"},TraitImpl.prototype.kind=function(){return"Trait"},TraitImpl.prototype.RAMLVersion=function(){return"RAML08"},TraitImpl.prototype.parametrizedProperties=function(){return helper.getTemplateParametrizedProperties(this)},TraitImpl}(MethodBaseImpl);exports.TraitImpl=TraitImpl;var SecuritySchemeSettingsImpl=function(_super){function SecuritySchemeSettingsImpl(){_super.apply(this,arguments)}return __extends(SecuritySchemeSettingsImpl,_super),SecuritySchemeSettingsImpl.prototype.wrapperClassName=function(){return"SecuritySchemeSettingsImpl"},SecuritySchemeSettingsImpl.prototype.kind=function(){return"SecuritySchemeSettings"},SecuritySchemeSettingsImpl.prototype.RAMLVersion=function(){return"RAML08"},SecuritySchemeSettingsImpl}(core.BasicNodeImpl);exports.SecuritySchemeSettingsImpl=SecuritySchemeSettingsImpl;var OAuth1SecuritySchemeSettingsImpl=function(_super){function OAuth1SecuritySchemeSettingsImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createOAuth1SecuritySchemeSettings(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(OAuth1SecuritySchemeSettingsImpl,_super),OAuth1SecuritySchemeSettingsImpl.prototype.requestTokenUri=function(){return _super.prototype.attribute.call(this,"requestTokenUri",function(attr){return new FixedUriImpl(attr)})},OAuth1SecuritySchemeSettingsImpl.prototype.authorizationUri=function(){return _super.prototype.attribute.call(this,"authorizationUri",function(attr){return new FixedUriImpl(attr)})},OAuth1SecuritySchemeSettingsImpl.prototype.tokenCredentialsUri=function(){return _super.prototype.attribute.call(this,"tokenCredentialsUri",function(attr){return new FixedUriImpl(attr)})},OAuth1SecuritySchemeSettingsImpl.prototype.wrapperClassName=function(){return"OAuth1SecuritySchemeSettingsImpl"},OAuth1SecuritySchemeSettingsImpl.prototype.kind=function(){return"OAuth1SecuritySchemeSettings"},OAuth1SecuritySchemeSettingsImpl.prototype.RAMLVersion=function(){return"RAML08"},OAuth1SecuritySchemeSettingsImpl}(SecuritySchemeSettingsImpl);exports.OAuth1SecuritySchemeSettingsImpl=OAuth1SecuritySchemeSettingsImpl;var FixedUriImpl=function(_super){function FixedUriImpl(){_super.apply(this,arguments)}return __extends(FixedUriImpl,_super),FixedUriImpl.prototype.wrapperClassName=function(){return"FixedUriImpl"},FixedUriImpl.prototype.kind=function(){return"FixedUri"},FixedUriImpl.prototype.RAMLVersion=function(){return"RAML08"},FixedUriImpl}(StringTypeImpl);exports.FixedUriImpl=FixedUriImpl;var OAuth2SecuritySchemeSettingsImpl=function(_super){function OAuth2SecuritySchemeSettingsImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createOAuth2SecuritySchemeSettings(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(OAuth2SecuritySchemeSettingsImpl,_super),OAuth2SecuritySchemeSettingsImpl.prototype.accessTokenUri=function(){return _super.prototype.attribute.call(this,"accessTokenUri",function(attr){return new FixedUriImpl(attr)})},OAuth2SecuritySchemeSettingsImpl.prototype.authorizationUri=function(){return _super.prototype.attribute.call(this,"authorizationUri",function(attr){return new FixedUriImpl(attr)})},OAuth2SecuritySchemeSettingsImpl.prototype.authorizationGrants=function(){return _super.prototype.attributes.call(this,"authorizationGrants",this.toString)},OAuth2SecuritySchemeSettingsImpl.prototype.setAuthorizationGrants=function(param){return this.highLevel().attrOrCreate("authorizationGrants").setValue(""+param),this},OAuth2SecuritySchemeSettingsImpl.prototype.scopes=function(){return _super.prototype.attributes.call(this,"scopes",this.toString)},OAuth2SecuritySchemeSettingsImpl.prototype.setScopes=function(param){return this.highLevel().attrOrCreate("scopes").setValue(""+param),this},OAuth2SecuritySchemeSettingsImpl.prototype.wrapperClassName=function(){return"OAuth2SecuritySchemeSettingsImpl"},OAuth2SecuritySchemeSettingsImpl.prototype.kind=function(){return"OAuth2SecuritySchemeSettings"},OAuth2SecuritySchemeSettingsImpl.prototype.RAMLVersion=function(){return"RAML08"},OAuth2SecuritySchemeSettingsImpl}(SecuritySchemeSettingsImpl);exports.OAuth2SecuritySchemeSettingsImpl=OAuth2SecuritySchemeSettingsImpl;var OAuth2SecuritySchemeImpl=function(_super){function OAuth2SecuritySchemeImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createOAuth2SecurityScheme(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(OAuth2SecuritySchemeImpl,_super),OAuth2SecuritySchemeImpl.prototype.settings=function(){return _super.prototype.element.call(this,"settings")},OAuth2SecuritySchemeImpl.prototype.wrapperClassName=function(){return"OAuth2SecuritySchemeImpl"},OAuth2SecuritySchemeImpl.prototype.kind=function(){return"OAuth2SecurityScheme"},OAuth2SecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML08"},OAuth2SecuritySchemeImpl}(AbstractSecuritySchemeImpl);exports.OAuth2SecuritySchemeImpl=OAuth2SecuritySchemeImpl;var OAuth1SecuritySchemeImpl=function(_super){function OAuth1SecuritySchemeImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createOAuth1SecurityScheme(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(OAuth1SecuritySchemeImpl,_super),OAuth1SecuritySchemeImpl.prototype.settings=function(){return _super.prototype.element.call(this,"settings")},OAuth1SecuritySchemeImpl.prototype.wrapperClassName=function(){return"OAuth1SecuritySchemeImpl"},OAuth1SecuritySchemeImpl.prototype.kind=function(){return"OAuth1SecurityScheme"},OAuth1SecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML08"},OAuth1SecuritySchemeImpl}(AbstractSecuritySchemeImpl);exports.OAuth1SecuritySchemeImpl=OAuth1SecuritySchemeImpl;var BasicSecuritySchemeImpl=function(_super){function BasicSecuritySchemeImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createBasicSecurityScheme(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(BasicSecuritySchemeImpl,_super),BasicSecuritySchemeImpl.prototype.wrapperClassName=function(){return"BasicSecuritySchemeImpl"},BasicSecuritySchemeImpl.prototype.kind=function(){return"BasicSecurityScheme"},BasicSecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML08"},BasicSecuritySchemeImpl}(AbstractSecuritySchemeImpl);exports.BasicSecuritySchemeImpl=BasicSecuritySchemeImpl;var DigestSecuritySchemeImpl=function(_super){function DigestSecuritySchemeImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createDigestSecurityScheme(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(DigestSecuritySchemeImpl,_super),DigestSecuritySchemeImpl.prototype.wrapperClassName=function(){return"DigestSecuritySchemeImpl"},DigestSecuritySchemeImpl.prototype.kind=function(){return"DigestSecurityScheme"},DigestSecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML08"},DigestSecuritySchemeImpl}(AbstractSecuritySchemeImpl);exports.DigestSecuritySchemeImpl=DigestSecuritySchemeImpl;var CustomSecuritySchemeImpl=function(_super){function CustomSecuritySchemeImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createCustomSecurityScheme(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(CustomSecuritySchemeImpl,_super),CustomSecuritySchemeImpl.prototype.wrapperClassName=function(){return"CustomSecuritySchemeImpl"},CustomSecuritySchemeImpl.prototype.kind=function(){return"CustomSecurityScheme"},CustomSecuritySchemeImpl.prototype.RAMLVersion=function(){return"RAML08"},CustomSecuritySchemeImpl}(AbstractSecuritySchemeImpl);exports.CustomSecuritySchemeImpl=CustomSecuritySchemeImpl;var MethodImpl=function(_super){function MethodImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createMethod(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(MethodImpl,_super),MethodImpl.prototype.method=function(){return _super.prototype.attribute.call(this,"method",this.toString)},MethodImpl.prototype.setMethod=function(param){return this.highLevel().attrOrCreate("method").setValue(""+param),this},MethodImpl.prototype.is=function(){return _super.prototype.attributes.call(this,"is",function(attr){return new TraitRefImpl(attr)})},MethodImpl.prototype.wrapperClassName=function(){return"MethodImpl"},MethodImpl.prototype.kind=function(){return"Method"},MethodImpl.prototype.RAMLVersion=function(){return"RAML08"},MethodImpl.prototype.parentResource=function(){return helper.parentResource(this);
},MethodImpl.prototype.ownerApi=function(){return helper.ownerApi(this)},MethodImpl.prototype.methodId=function(){return helper.methodId(this)},MethodImpl.prototype.allSecuredBy=function(){return helper.allSecuredBy(this)},MethodImpl}(MethodBaseImpl);exports.MethodImpl=MethodImpl;var MimeTypeImpl=function(_super){function MimeTypeImpl(){_super.apply(this,arguments)}return __extends(MimeTypeImpl,_super),MimeTypeImpl.prototype.wrapperClassName=function(){return"MimeTypeImpl"},MimeTypeImpl.prototype.kind=function(){return"MimeType"},MimeTypeImpl.prototype.RAMLVersion=function(){return"RAML08"},MimeTypeImpl}(StringTypeImpl);exports.MimeTypeImpl=MimeTypeImpl;var UriTemplateImpl=function(_super){function UriTemplateImpl(){_super.apply(this,arguments)}return __extends(UriTemplateImpl,_super),UriTemplateImpl.prototype.wrapperClassName=function(){return"UriTemplateImpl"},UriTemplateImpl.prototype.kind=function(){return"UriTemplate"},UriTemplateImpl.prototype.RAMLVersion=function(){return"RAML08"},UriTemplateImpl}(StringTypeImpl);exports.UriTemplateImpl=UriTemplateImpl;var RelativeUriStringImpl=function(_super){function RelativeUriStringImpl(){_super.apply(this,arguments)}return __extends(RelativeUriStringImpl,_super),RelativeUriStringImpl.prototype.wrapperClassName=function(){return"RelativeUriStringImpl"},RelativeUriStringImpl.prototype.kind=function(){return"RelativeUriString"},RelativeUriStringImpl.prototype.RAMLVersion=function(){return"RAML08"},RelativeUriStringImpl}(UriTemplateImpl);exports.RelativeUriStringImpl=RelativeUriStringImpl;var FullUriTemplateStringImpl=function(_super){function FullUriTemplateStringImpl(){_super.apply(this,arguments)}return __extends(FullUriTemplateStringImpl,_super),FullUriTemplateStringImpl.prototype.wrapperClassName=function(){return"FullUriTemplateStringImpl"},FullUriTemplateStringImpl.prototype.kind=function(){return"FullUriTemplateString"},FullUriTemplateStringImpl.prototype.RAMLVersion=function(){return"RAML08"},FullUriTemplateStringImpl}(UriTemplateImpl);exports.FullUriTemplateStringImpl=FullUriTemplateStringImpl;var RAMLSimpleElementImpl=function(_super){function RAMLSimpleElementImpl(){_super.apply(this,arguments)}return __extends(RAMLSimpleElementImpl,_super),RAMLSimpleElementImpl.prototype.wrapperClassName=function(){return"RAMLSimpleElementImpl"},RAMLSimpleElementImpl.prototype.kind=function(){return"RAMLSimpleElement"},RAMLSimpleElementImpl.prototype.RAMLVersion=function(){return"RAML08"},RAMLSimpleElementImpl}(core.BasicNodeImpl);exports.RAMLSimpleElementImpl=RAMLSimpleElementImpl;var DocumentationItemImpl=function(_super){function DocumentationItemImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createDocumentationItem(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(DocumentationItemImpl,_super),DocumentationItemImpl.prototype.title=function(){return _super.prototype.attribute.call(this,"title",this.toString)},DocumentationItemImpl.prototype.setTitle=function(param){return this.highLevel().attrOrCreate("title").setValue(""+param),this},DocumentationItemImpl.prototype.content=function(){return _super.prototype.attribute.call(this,"content",function(attr){return new MarkdownStringImpl(attr)})},DocumentationItemImpl.prototype.wrapperClassName=function(){return"DocumentationItemImpl"},DocumentationItemImpl.prototype.kind=function(){return"DocumentationItem"},DocumentationItemImpl.prototype.RAMLVersion=function(){return"RAML08"},DocumentationItemImpl}(RAMLSimpleElementImpl);exports.DocumentationItemImpl=DocumentationItemImpl;var GlobalSchemaImpl=function(_super){function GlobalSchemaImpl(nodeOrKey,setAsTopLevel){void 0===setAsTopLevel&&(setAsTopLevel=!0),_super.call(this,"string"==typeof nodeOrKey?createGlobalSchema(nodeOrKey):nodeOrKey,setAsTopLevel),this.nodeOrKey=nodeOrKey,this.setAsTopLevel=setAsTopLevel}return __extends(GlobalSchemaImpl,_super),GlobalSchemaImpl.prototype.key=function(){return _super.prototype.attribute.call(this,"key",this.toString)},GlobalSchemaImpl.prototype.setKey=function(param){return this.highLevel().attrOrCreate("key").setValue(""+param),this},GlobalSchemaImpl.prototype.value=function(){return _super.prototype.attribute.call(this,"value",function(attr){return new SchemaStringImpl(attr)})},GlobalSchemaImpl.prototype.wrapperClassName=function(){return"GlobalSchemaImpl"},GlobalSchemaImpl.prototype.kind=function(){return"GlobalSchema"},GlobalSchemaImpl.prototype.RAMLVersion=function(){return"RAML08"},GlobalSchemaImpl}(RAMLSimpleElementImpl);exports.GlobalSchemaImpl=GlobalSchemaImpl;var ResourceImpl=function(_super){function ResourceImpl(){_super.apply(this,arguments)}return __extends(ResourceImpl,_super),ResourceImpl.prototype.relativeUri=function(){return _super.prototype.attribute.call(this,"relativeUri",function(attr){return new RelativeUriStringImpl(attr)})},ResourceImpl.prototype.type=function(){return _super.prototype.attribute.call(this,"type",function(attr){return new ResourceTypeRefImpl(attr)})},ResourceImpl.prototype.is=function(){return _super.prototype.attributes.call(this,"is",function(attr){return new TraitRefImpl(attr)})},ResourceImpl.prototype.securedBy=function(){return _super.prototype.attributes.call(this,"securedBy",function(attr){return new SecuritySchemeRefImpl(attr)})},ResourceImpl.prototype.uriParameters_original=function(){return _super.prototype.elements.call(this,"uriParameters")},ResourceImpl.prototype.methods=function(){return _super.prototype.elements.call(this,"methods")},ResourceImpl.prototype.resources=function(){return _super.prototype.elements.call(this,"resources")},ResourceImpl.prototype.displayName=function(){return _super.prototype.attribute.call(this,"displayName",this.toString)},ResourceImpl.prototype.setDisplayName=function(param){return this.highLevel().attrOrCreate("displayName").setValue(""+param),this},ResourceImpl.prototype.baseUriParameters=function(){return _super.prototype.elements.call(this,"baseUriParameters")},ResourceImpl.prototype.description=function(){return _super.prototype.attribute.call(this,"description",function(attr){return new MarkdownStringImpl(attr)})},ResourceImpl.prototype.wrapperClassName=function(){return"ResourceImpl"},ResourceImpl.prototype.kind=function(){return"Resource"},ResourceImpl.prototype.RAMLVersion=function(){return"RAML08"},ResourceImpl.prototype.completeRelativeUri=function(){return helper.completeRelativeUri(this)},ResourceImpl.prototype.absoluteUri=function(){return helper.absoluteUri(this)},ResourceImpl.prototype.parentResource=function(){return helper.parent(this)},ResourceImpl.prototype.childResource=function(relPath){return helper.childResource(this,relPath)},ResourceImpl.prototype.childMethod=function(method){return helper.childMethod(this,method)},ResourceImpl.prototype.ownerApi=function(){return helper.ownerApi(this)},ResourceImpl.prototype.uriParameters=function(){return helper.uriParametersPrimary(this)},ResourceImpl.prototype.allUriParameters=function(){return helper.uriParameters(this)},ResourceImpl.prototype.absoluteUriParameters=function(){return helper.absoluteUriParameters(this)},ResourceImpl.prototype.allSecuredBy=function(){return helper.allSecuredBy(this)},ResourceImpl}(core.BasicNodeImpl);exports.ResourceImpl=ResourceImpl,exports.loadApiSync=loadApiSync,exports.loadRAMLSync=loadRAMLSync,exports.loadApi=loadApi,exports.loadRAML=loadRAML,exports.getLanguageElementByRuntimeType=getLanguageElementByRuntimeType},function(module,exports,__webpack_require__){"use strict";function load(pth){var m=new ll.Project(path.dirname(pth)),unit=m.unit(path.basename(pth));return unit&&unit.isRAMLUnit()?hlimpl.fromUnit(unit).wrapperNode():null}function expandTraitsAndResourceTypes(api){var lowLevelNode=api.highLevel().lowLevel();return lowLevelNode instanceof lowLevelProxy.LowLevelProxyNode?api:expander.expandTraitsAndResourceTypes(api)}function completeRelativeUri(res){var uri="",parent=res;do res=parent,uri=res.relativeUri().value()+uri,parent=res.parent();while(parent.definition().key().name==universes.Universe08.Resource.name);return uri}function absoluteUri(res){var uri="",parent=res;do res=parent,uri=res.relativeUri().value()+uri,parent=res.parent();while(parent.definition().key().name==universes.Universe08.Resource.name);uri=uri.replace(/\/\//g,"/");var buri=parent.baseUri(),base=buri?buri.value():"";return base=base?base:"",util.stringEndsWith(base,"/")&&(uri=uri.substring(1)),uri=base+uri}function qName(c){return hlimpl.qName(c.highLevel(),c.highLevel().root())}function traitsPrimary(a){return allTraits(a)}function allTraits(a){return findTemplates(a,function(d){return universeHelpers.isTraitType(d)})}function resourceTypesPrimary(a){return allResourceTypes(a)}function allResourceTypes(a){return findTemplates(a,function(d){return universeHelpers.isResourceTypeType(d)})}function findTemplates(a,filter){var arr=search.globalDeclarations(a.highLevel()).filter(function(x){return filter(x.definition())}),ll=a.highLevel().lowLevel();if(!ll)return[];var nodePath=ll.includePath();nodePath||(nodePath=ll.unit().path());var topLevelArr=arr.map(function(x){var topLevelNode,p=x.lowLevel().unit().path();return p!=nodePath?(topLevelNode=factory.buildWrapperNode(x,!1),topLevelNode.meta().setCalculated()):topLevelNode=x.wrapperNode(),topLevelNode});return topLevelArr}function relativeUriSegments(res){var result=[],parent=res;do res=parent,result.push(res.relativeUri().value()),parent=res.parent();while(parent.definition().key().name==universes.Universe08.Resource.name);return result.reverse()}function parentResource(method){return method.parent()instanceof RamlWrapperImpl.ResourceImpl?method.parent():null}function parent(resource){var parent=resource.parent();return parent.definition().key().name==universes.Universe08.Resource.name,null}function childResource(container,relPath){if(null==container)return null;var resources=container.resources();return resources?(resources=resources.filter(function(x){return x.relativeUri().value()==relPath}),0==resources.length?null:resources[0]):null}function getResource(container,path){if(!container)return null;for(var res=null,i=0;i<path.length;i++){if(res=childResource(container,path[i]),!res)return null;container=res}return res}function childMethod(resource,method){return resource?resource.methods().filter(function(x){return x.method()==method}):null}function getMethod(container,path,method){var resource=getResource(container,path);return null==resource?null:childMethod(resource,method)}function isApi(obj){return obj.definition().key().name==universes.Universe08.Api.name}function ownerApi(method){for(var obj=method;!isApi(obj);)obj=obj.parent();return obj}function methodId(method){var parent=method.parent();if(parent instanceof RamlWrapperImpl.ResourceImpl)return completeRelativeUri(parent)+" "+method.method().toLowerCase();if(parent instanceof RamlWrapperImpl.ResourceTypeImpl)return parent.name()+" "+method.method().toLowerCase();throw new Error("Method is supposed to be owned by Resource or ResourceType.\nHere the method is owned by "+method.definition().key().name)}function isOkRange(response){var str=response.code().value(),err=linter.validateResponseString(str);if(null!=err)return!1;try{if(parseInt(str.charAt(0))<4)return!0}catch(e){}return!1}function allResources(api){var resources=[],visitor=function(res){resources.push(res),res.resources().forEach(function(x){return visitor(x)})};return api.resources().forEach(function(x){return visitor(x)}),resources}function uriParametersPrimary(resource){return uriParameters(resource)}function uriParameters(resource){var uri=resource.relativeUri().value(),params=resource.uriParameters_original(),propName=universes.Universe08.Resource.properties.uriParameters.name;return extractParams(params,uri,resource,propName)}function baseUriParametersPrimary(api){return baseUriParameters(api)}function baseUriParameters(api){var uri=api.baseUri()?api.baseUri().value():"",params=api.baseUriParameters_original(),propName=universes.Universe08.Api.properties.baseUriParameters.name;return extractParams(params,uri,api,propName)}function absoluteUriParameters(res){var params=[],parent=res;do res=parent,params=uriParameters(res).concat(params),parent=res.parent();while(parent.definition().key().name==universes.Universe10.Resource.name);var api=parent;api.baseUriParameters();return params=baseUriParameters(api).concat(params)}function protocolsPrimary(api){return allProtocols(api)}function allProtocols(api){return api.protocols().map(function(x){return x.toUpperCase()})}function securedByPrimary(resourceOrMethod){return allSecuredBy(resourceOrMethod)}function allSecuredBy(resourceOrMethod){return resourceOrMethod.securedBy()}function securitySchemeName(schemeReference){var highLevel=schemeReference.highLevel();if(!highLevel)return"";var attributeValue=highLevel.value();return attributeValue?attributeValue.toString():""}function securityScheme(schemeReference){var highLevel=schemeReference.highLevel();if(!highLevel)return null;var declaration=search.findDeclarationByNode(highLevel,search.LocationKind.VALUE_COMPLETION);if(!declaration)return null;if(!declaration.getKind||declaration.getKind()!=hl.NodeKind.NODE)return null;var result=declaration.wrapperNode();return result instanceof RamlWrapperImpl.AbstractSecuritySchemeImpl?result:null}function RAMLVersion(api){return api.highLevel().definition().universe().version()}function structuredValue(reference){var hl=reference.value().lowLevel();return new core.TypeInstanceImpl(hl)}function referenceName(reference){var val=reference.highLevel().value();return"string"==typeof val||null==val?val:val.valueName()}function referencedTrait(ref){return referencedObject(ref)}function referencedResourceType(ref){return referencedObject(ref)}function referencedObject(ref){var attr=ref.highLevel(),parent=attr.parent(),vn=ref.name(),cands=search.referenceTargets(attr.property(),parent).filter(function(x){return hlimpl.qName(x,parent)==vn});return 0==cands.length?null:cands[0].wrapperNode()}function extractParams(params,uri,owner,propName){var ownerHl=owner.highLevel(),prop=ownerHl.definition().property(propName);if(!uri)return[];var describedParams={};params.forEach(function(x){var arr=describedParams[x.name()];arr||(arr=[],describedParams[x.name()]=arr),arr.push(x)});for(var allParams=[],prev=0,mentionedParams={},i=uri.indexOf("{");i>=0;i=uri.indexOf("{",prev)){prev=uri.indexOf("}",++i);var paramName=uri.substring(i,prev);if(mentionedParams[paramName]=!0,describedParams[paramName])describedParams[paramName].forEach(function(x){return allParams.push(x)});else{var uriParameter=new RamlWrapperImpl.StringTypeDeclarationImpl(paramName);uriParameter.setName(paramName);var hlNode=uriParameter.highLevel();hlNode.setParent(ownerHl),uriParameter.meta().setCalculated(),hlNode.patchProp(prop),allParams.push(uriParameter)}}return Object.keys(describedParams).filter(function(x){return!mentionedParams[x]}).forEach(function(x){return describedParams[x].forEach(function(y){return allParams.push(y)})}),allParams}function schemaContent(bodyDeclaration){var schemaDecl=bodyDeclaration.schema();if(null==schemaDecl)return null;var schemaString=schemaDecl.value();if(!schemaString)return null;var schemaAttribute=bodyDeclaration.highLevel().attr(universes.Universe08.BodyLike.properties.schema.name);if(!schemaAttribute)return schemaString;var declaration=search.findDeclarationByNode(schemaAttribute,search.LocationKind.VALUE_COMPLETION);if(!declaration)return schemaString;if(!declaration.getKind||declaration.getKind()!=hl.NodeKind.NODE)return schemaString;if(declaration.definition().key()!=universes.Universe08.GlobalSchema)return schemaString;var valueAttribute=declaration.attr(universes.Universe08.GlobalSchema.properties.value.name);return null==valueAttribute?null:valueAttribute.value()}function getTemplateParametrizedProperties(node){var highLevelNode=node.highLevel();if(null==highLevelNode)return null;var lowLevelNode=highLevelNode.lowLevel();if(null==lowLevelNode)return null;var children=lowLevelNode.children().filter(function(x){return x.key().indexOf("<<")>=0});if(0==children.length)return null;var result=new core.TypeInstanceImpl(children);return result}var RamlWrapperImpl=__webpack_require__(47),factory=__webpack_require__(44),core=__webpack_require__(45),hl=__webpack_require__(10),hlimpl=__webpack_require__(16),universes=__webpack_require__(18),expander=__webpack_require__(25),lowLevelProxy=__webpack_require__(39),linter=__webpack_require__(26),util=__webpack_require__(32),search=__webpack_require__(24),universeHelpers=__webpack_require__(14),ll=__webpack_require__(28),path=__webpack_require__(15);exports.load=load,exports.expandTraitsAndResourceTypes=expandTraitsAndResourceTypes,exports.completeRelativeUri=completeRelativeUri,exports.absoluteUri=absoluteUri,exports.qName=qName,exports.traitsPrimary=traitsPrimary,exports.allTraits=allTraits,exports.resourceTypesPrimary=resourceTypesPrimary,exports.allResourceTypes=allResourceTypes,exports.relativeUriSegments=relativeUriSegments,exports.parentResource=parentResource,exports.parent=parent,exports.childResource=childResource,exports.getResource=getResource,exports.childMethod=childMethod,exports.getMethod=getMethod,exports.ownerApi=ownerApi,exports.methodId=methodId,exports.isOkRange=isOkRange,exports.allResources=allResources;exports.uriParametersPrimary=uriParametersPrimary,exports.uriParameters=uriParameters,exports.baseUriParametersPrimary=baseUriParametersPrimary,exports.baseUriParameters=baseUriParameters,exports.absoluteUriParameters=absoluteUriParameters,exports.protocolsPrimary=protocolsPrimary,exports.allProtocols=allProtocols,exports.securedByPrimary=securedByPrimary,exports.allSecuredBy=allSecuredBy,exports.securitySchemeName=securitySchemeName,exports.securityScheme=securityScheme,exports.RAMLVersion=RAMLVersion,exports.structuredValue=structuredValue,exports.referenceName=referenceName,exports.referencedTrait=referencedTrait,exports.referencedResourceType=referencedResourceType,exports.schemaContent=schemaContent,exports.getTemplateParametrizedProperties=getTemplateParametrizedProperties},function(module,exports,__webpack_require__){"use strict";function escapeTemplateParameters(str){if(null==str||"string"!=typeof str)return{status:ParametersEscapingStatus.NOT_REQUIRED};for(var resultingString="",map={},prev=0,i=str.indexOf("<<");i>=0;i=str.indexOf("<<",prev)){if(resultingString+=str.substring(prev,i),prev=str.indexOf(">>",i),0>prev)return{status:ParametersEscapingStatus.ERROR};prev+=">>".length;var paramStr=str.substring(i,prev),substitution=PARAM_OCCURENCE_STR+i+PARAM_OCCURENCE_STR;map[substitution]=paramStr,resultingString+=substitution}return 0==resultingString.length?{status:ParametersEscapingStatus.NOT_REQUIRED}:(resultingString+=str.substring(prev,str.length),{resultingString:resultingString,substitutions:map,status:ParametersEscapingStatus.OK})}function unescapeTemplateParameters(str,substitutions){if(null==str)return{status:ParametersEscapingStatus.NOT_REQUIRED};for(var resultingString="",prev=0,i=str.indexOf(PARAM_OCCURENCE_STR);i>=0;i=str.indexOf(PARAM_OCCURENCE_STR,prev)){if(prev=str.indexOf(PARAM_OCCURENCE_STR,i+1),prev+=PARAM_OCCURENCE_STR.length,0>prev)return{status:ParametersEscapingStatus.ERROR};var substitution=str.substring(i,prev),originalParamOccurence=substitutions[substitution];if(null==originalParamOccurence)return{status:ParametersEscapingStatus.ERROR};resultingString+=originalParamOccurence}return 0==resultingString.length?{status:ParametersEscapingStatus.NOT_REQUIRED}:(resultingString+=str.substring(prev,str.length),{resultingString:resultingString,substitutions:substitutions,status:ParametersEscapingStatus.OK})}function checkExpression(value){for(var gotExpression=!1,i=0;i<value.length;i++){var ch=value.charAt(i);if("|"==ch||"("==ch||"["==ch){gotExpression=!0;break}}return gotExpression}function patchMethodIs(node,traits){var llMethod=node.lowLevel(),ramlVersion=node.definition().universe().version(),originalLlMethod=toOriginal(llMethod),isPropertyName=universeDef.Universe10.MethodBase.properties.is.name,isNode=_.find(llMethod.children(),function(x){return x.key()==isPropertyName});if(null==isNode){var newLLIsNode=new jsyaml.ASTNode(yaml.newMapping(yaml.newScalar(isPropertyName),yaml.newItems()),originalLlMethod.unit(),originalLlMethod,null,null);isNode=llMethod.replaceChild(null,newLLIsNode)}var originalIsNode=_.find(originalLlMethod.children(),function(x){return x.key()==isPropertyName}),childrenToPreserve=null!=originalIsNode?originalIsNode.children():[],newTraits=childrenToPreserve.concat(traits.map(function(x){var llChNode=prepareTraitRefNode(x.node,isNode);if(null!=llChNode){var cNode=new proxy.LowLevelCompositeNode(llChNode,isNode,x.transformer,ramlVersion);return cNode}return null})).filter(function(x){return null!=x});return isNode.setChildren(newTraits),isNode.filterChildren(),isNode}function prepareTraitRefNode(llNode,llParent){llParent=toOriginal(llParent),llNode=toOriginal(llNode);var yNode=llNode.actual();if(null==yNode)return null;if(llNode.key()==universeDef.Universe10.MethodBase.properties.is.name&&(yNode=llNode.yamlNode().value),null==yNode)return null;if(yNode.kind==yaml.Kind.SEQ&&(yNode=yNode.items[0]),null==yNode)return null;var result=new jsyaml.ASTNode(yNode,llNode.unit(),llParent,null,null);return result}function toOriginal(node){for(var i=0;2>i&&node instanceof proxy.LowLevelProxyNode;i++)node=node.originalNode();return node}function instanceOfPatchedReference(instance){return instance?null!=instance.namespace&&"function"==typeof instance.namespace&&null!=instance.name&&"function"==typeof instance.name&&null!=instance.collectionName&&"function"==typeof instance.collectionName&&null!=instance.referencedUnit&&"function"==typeof instance.referencedUnit&&null!=instance.mode&&"function"==typeof instance.mode:!1}function getDeclaration(elementName,typeName,resolver,units){if(!elementName)return null;var ns="",name=elementName,ind=elementName.lastIndexOf(".");ind>=0&&(ns=elementName.substring(0,ind),name=elementName.substring(ind+1));for(var result,gotLibrary=!1,i=units.length;i>0;i--){var u=units[i-1],hl=u.highLevel();if(hl.isElement()&&universeHelpers.isLibraryType(hl.asElement().definition())){if(gotLibrary)break;gotLibrary=!0}var actualUnit=u;if(ns){actualUnit=null;var map=resolver.nsMap(u);if(map){var info=map[ns];info&&(actualUnit=info.unit)}}if(actualUnit){var ahl=actualUnit.highLevel();if(ahl&&ahl.isElement()&&(result=_.find(ahl.asElement().elementsOfKind(typeName),function(x){return x.name()==name})))break}}return result}var ll=__webpack_require__(11),hlimpl=__webpack_require__(16),yaml=__webpack_require__(74),jsyaml=__webpack_require__(28),util=__webpack_require__(32),proxy=__webpack_require__(39),universeDef=__webpack_require__(18),_=__webpack_require__(65),universeHelpers=__webpack_require__(14),namespaceResolver=__webpack_require__(50),def=__webpack_require__(36),typeExpressions=def.rt.typeExpressions;!function(PatchMode){PatchMode[PatchMode.DEFAULT=0]="DEFAULT",PatchMode[PatchMode.PATH=1]="PATH"}(exports.PatchMode||(exports.PatchMode={}));var PatchMode=exports.PatchMode,ReferencePatcher=function(){function ReferencePatcher(mode){void 0===mode&&(mode=PatchMode.DEFAULT),this.mode=mode,this._outerDependencies={},this._libModels={}}return ReferencePatcher.prototype.process=function(hlNode,rootNode,removeUses,patchNodeName){if(void 0===rootNode&&(rootNode=hlNode),void 0===removeUses&&(removeUses=!1),void 0===patchNodeName&&(patchNodeName=!1),!hlNode.lowLevel().libProcessed){var resolver=hlNode.lowLevel().unit().project().namespaceResolver();this.patchReferences(hlNode,rootNode,resolver),patchNodeName&&this.patchNodeName(hlNode,rootNode.lowLevel().unit(),resolver),removeUses?this.removeUses(hlNode.lowLevel()):this.patchUses(hlNode.lowLevel(),resolver),this.resetTypes(hlNode),hlNode.resetChildren(),hlNode.lowLevel().libProcessed=!0}},ReferencePatcher.prototype.patchReferences=function(node,rootNode,resolver,units){void 0===rootNode&&(rootNode=node),void 0===resolver&&(resolver=new namespaceResolver.NamespaceResolver),void 0===units&&(units=[rootNode.lowLevel().unit()]);var isNode;if(null!=node.definition().property(universeDef.Universe10.TypeDeclaration.properties.annotations.name)){var cNode=node.lowLevel();if(!(cNode instanceof proxy.LowLevelCompositeNode))return;var isPropertyName=universeDef.Universe10.MethodBase.properties.is.name,traitNodes=node.attributes(isPropertyName);cNode.preserveAnnotations(),node.resetChildren(),0!=traitNodes.length&&(isNode=patchMethodIs(node,traitNodes.map(function(x){return x.lowLevel()}).map(function(x){return{node:x,transformer:x.transformer()}})))}for(var attrs=node.attrs(),_i=0,attrs_1=attrs;_i<attrs_1.length;_i++){var attr=attrs_1[_i],appended=this.appendUnitIfNeeded(attr,units);this.patchReferenceAttr(attr,rootNode,resolver,units),this.popUnitIfNeeded(units,appended)}if(universeHelpers.isTypeDeclarationDescendant(node.definition())){var appended=this.appendUnitIfNeeded(node,units);this.patchType(node,rootNode,resolver,units),this.popUnitIfNeeded(units,appended)}for(var childNodes=node.elements(),_a=0,childNodes_1=childNodes;_a<childNodes_1.length;_a++){var ch=childNodes_1[_a],appended=this.appendUnitIfNeeded(ch,units);this.patchReferences(ch,rootNode,resolver,units),this.popUnitIfNeeded(units,appended)}isNode&&isNode.filterChildren()},ReferencePatcher.prototype.patchReferenceAttr=function(attr,rootNode,resolver,units){var property=attr.property(),range=property.range();if(range.isAssignableFrom(universeDef.Universe10.Reference.name)){var value=attr.value();if(null!=value){var llNode=attr.lowLevel();if(llNode instanceof proxy.LowLevelProxyNode){var transformer=llNode.transformer(),isAnnotation=universeHelpers.isAnnotationsProperty(property);if("string"==typeof value){var stringToPatch=value;if(null!=transformer){var actualNode=toOriginal(llNode);stringToPatch=actualNode.value()}isAnnotation&&(stringToPatch=stringToPatch.substring(1,stringToPatch.length-1));var newValue=this.resolveReferenceValue(stringToPatch,rootNode.lowLevel().unit(),units,resolver,transformer,range);if(null!=newValue){var newValue1=isAnnotation?"("+newValue.value()+")":newValue.value();attr.lowLevel().setValueOverride(newValue1),this.registerPatchedReference(newValue)}}else{var sValue=value,key=sValue.lowLevel().key(),stringToPatch=key;if(null!=transformer){var actualNode=toOriginal(sValue.lowLevel());stringToPatch=actualNode.key()}if(null!=key){isAnnotation&&(stringToPatch=stringToPatch.substring(1,stringToPatch.length-1));var newValue=this.resolveReferenceValue(stringToPatch,rootNode.lowLevel().unit(),units,resolver,transformer,range);if(null!=newValue){var newValue1=isAnnotation?"("+newValue.value()+")":newValue.value();sValue.lowLevel().setKeyOverride(newValue1),this.registerPatchedReference(newValue)}}}}}}},ReferencePatcher.prototype.patchType=function(node,rootNode,resolver,units){var _this=this,nodeType=node.definition(),isExternal=node.localType().isExternal();if(!isExternal)for(var _i=0,_a=node.localType().allSuperTypes();_i<_a.length;_i++){var st=_a[_i];if(isExternal=st.isExternal())break}if(!isExternal){var rootUnit=rootNode.lowLevel().unit(),typeAttributes=(rootUnit.absolutePath(),node.attributes(universeDef.Universe10.TypeDeclaration.properties.type.name));0==typeAttributes.length&&(typeAttributes=node.attributes(universeDef.Universe10.TypeDeclaration.properties.schema.name));for(var _b=0,typeAttributes_1=typeAttributes;_b<typeAttributes_1.length;_b++){var typeAttr=typeAttributes_1[_b],llNode=typeAttr.lowLevel();if(llNode instanceof proxy.LowLevelProxyNode){var localUnit=typeAttr.lowLevel().unit(),value=(localUnit.absolutePath(),typeAttr.value());if("string"==typeof value){var gotExpression=checkExpression(value),transformer=llNode.transformer(),stringToPatch=value,escapeData={status:ParametersEscapingStatus.NOT_REQUIRED},additionalUnits=transformer?transformer.unitsChain:null;if(null!=transformer||value.indexOf("<<")>=0){var actualNode=toOriginal(llNode),actualValue=actualNode.value();escapeData=escapeTemplateParameters(actualValue),escapeData.status==ParametersEscapingStatus.OK?stringToPatch=gotExpression?escapeData.resultingString:actualValue:transformer=null}var appendedAdditional;if(additionalUnits){appendedAdditional=[];for(var _c=0,additionalUnits_1=additionalUnits;_c<additionalUnits_1.length;_c++){var u=additionalUnits_1[_c];appendedAdditional.push(this.appendUnitIfNeeded(u,units))}}var newValue,appendedAttrUnit=this.appendUnitIfNeeded(typeAttr,units);if(gotExpression){var expressionPatchFailed=!1,expr=typeExpressions.parse(stringToPatch),gotPatch=!1;typeExpressions.visit(expr,function(x){if("name"==x.type){var unescaped,lit=x,typeName=lit.value,unescapeData={status:ParametersEscapingStatus.NOT_REQUIRED};if(escapeData.status==ParametersEscapingStatus.OK)if(unescaped=escapeData.substitutions[typeName],null==unescaped){if(unescapeData=unescapeTemplateParameters(typeName,escapeData.substitutions),unescapeData.status==ParametersEscapingStatus.OK)typeName=unescapeData.resultingString;else if(unescapeData.status==ParametersEscapingStatus.ERROR)return void(expressionPatchFailed=!0)}else typeName=unescaped;if(null==transformer&&(null!=unescaped||unescapeData.status==ParametersEscapingStatus.OK))return void(lit.value=typeName);var patchTransformedValue=!0;typeName.indexOf("<<")>=0&&_this.isCompoundValue(typeName)&&(patchTransformedValue=!1);var patched=_this.resolveReferenceValue(typeName,rootUnit,units,resolver,transformer,nodeType,patchTransformedValue);null!=patched&&(lit.value=patched.value(),gotPatch=!0,_this.registerPatchedReference(patched))}}),newValue=gotPatch&&!expressionPatchFailed?typeExpressions.serializeToString(expr):value}else if(escapeData.status!=ParametersEscapingStatus.OK||null!=transformer){stringToPatch.indexOf("<<")>=0&&this.isCompoundValue(stringToPatch)&&(stringToPatch=value,transformer=null);var patched=this.resolveReferenceValue(stringToPatch,rootUnit,units,resolver,transformer,nodeType);null!=patched&&(this.registerPatchedReference(patched),newValue=patched.value())}if(null!=newValue&&(typeAttr.lowLevel().setValueOverride(newValue),typeAttr.overrideValue(null)),this.popUnitIfNeeded(units,appendedAttrUnit),appendedAdditional)for(var _d=0,_e=appendedAdditional.reverse();_d<_e.length;_d++){var ap=_e[_d];this.popUnitIfNeeded(units,ap)}}else{var llTypeNode=_.find(node.lowLevel().children(),function(x){return"type"==x.key()});if(llTypeNode){var def=node.definition().universe().type(universeDef.Universe10.TypeDeclaration.name),newNode=new hlimpl.ASTNodeImpl(llTypeNode,null,def,null),appended=this.appendUnitIfNeeded(newNode,units);this.patchReferences(newNode,rootNode,resolver,units),this.popUnitIfNeeded(units,appended)}}}}}},ReferencePatcher.prototype.resolveReferenceValue=function(stringToPatch,rootUnit,units,resolver,transformer,range,patchTransformedValue){var _this=this;void 0===patchTransformedValue&&(patchTransformedValue=!0);var newValue,isAnnotation=universeHelpers.isAnnotationRefTypeOrDescendant(range);if(transformer&&stringToPatch&&stringToPatch.indexOf("<<")>=0){var doContinue=!0,types=rootUnit.highLevel().types(),newValue1=transformer.transform(stringToPatch,!0,function(){return doContinue},function(val,tr){var newVal=_this.resolveReferenceValueBasic(val,rootUnit,resolver,tr.unitsChain,range);return null==newVal&&(newVal=new PatchedReference(null,val,_this.collectionName(range),rootUnit,PatchMode.DEFAULT)),doContinue=isAnnotation?null!=types.getAnnotationType(newVal.value())?!1:!1:null!=types.getType(newVal.value())?!1:!1,newVal});newValue=newValue1.value}return void 0!==newValue&&instanceOfPatchedReference(newValue)||(newValue=this.resolveReferenceValueBasic(stringToPatch,rootUnit,resolver,units,range)),newValue},ReferencePatcher.prototype.patchNodeName=function(hlNode,rootUnit,resolver){
var llNode=hlNode.lowLevel(),key=llNode.key(),range=hlNode.definition();if(universeHelpers.isTypeDeclarationSibling(range)){var localType=hlNode.localType();localType.isAnnotationType()&&(range=localType)}var patched=this.resolveReferenceValueBasic(key,rootUnit,resolver,[llNode.unit()],range);null!=patched&&llNode.setKeyOverride(patched.value())},ReferencePatcher.prototype.resolveReferenceValueBasic=function(_value,rootUnit,resolver,units,range){if(null==_value||"string"!=typeof _value)return null;var referencedUnit,plainName,isType=universeHelpers.isTypeDeclarationDescendant(range),gotQuestion=isType&&util.stringEndsWith(_value,"?"),value=gotQuestion?_value.substring(0,_value.length-1):_value,ind=value.lastIndexOf(".");if(ind>=0){var oldNS=value.substring(0,ind);plainName=value.substring(ind+1);for(var i=units.length;i>0;i--){var localUnit=units[i-1],nsMap=resolver.nsMap(localUnit);if(null!=nsMap){var info=nsMap[oldNS];if(null!=info&&(referencedUnit=info.unit,null!=referencedUnit))break}}}else{if(isType&&null!=def.rt.builtInTypes().get(value))return null;plainName=value,referencedUnit=units[units.length-1]}var collectionName=this.collectionName(range);if(null==referencedUnit||referencedUnit.absolutePath()==rootUnit.absolutePath())return null;if(this.mode==PatchMode.PATH){if(null==resolver.resolveNamespace(rootUnit,referencedUnit))return null;var aPath=referencedUnit.absolutePath().replace(/\\/g,"/");ll.isWebPath(aPath)||(aPath="file://"+aPath),newNS=aPath+"#/"+collectionName}else{var newNS=resolver.resolveNamespace(rootUnit,referencedUnit);if(null==newNS)return null}return gotQuestion&&(plainName+="?"),new PatchedReference(newNS,plainName,collectionName,referencedUnit,this.mode)},ReferencePatcher.prototype.patchUses=function(node,resolver){if(node instanceof proxy.LowLevelCompositeNode){var unit=node.unit(),extendedUnitMap=resolver.expandedPathMap(unit);if(null!=extendedUnitMap){var unitMap=resolver.pathMap(unit);unitMap||(unitMap={});for(var cNode=node,originalChildren=node.children(),usesNodes=originalChildren.filter(function(x){return x.key()==universeDef.Universe10.FragmentDeclaration.properties.uses.name}),oNode=toOriginal(node),yamlNode=oNode;yamlNode instanceof proxy.LowLevelProxyNode;)yamlNode=yamlNode.originalNode();var usesNode,usesInfos=Object.keys(unitMap).map(function(x){return extendedUnitMap[x]}),extendedUsesInfos=Object.keys(extendedUnitMap).map(function(x){return extendedUnitMap[x]}).filter(function(x){return!unitMap[x.absolutePath()]}),u=node.unit(),existingLibs=(u.absolutePath(),{});if(usesNodes.length>0)usesNode=usesNodes[0],usesNode.children().forEach(function(x){return existingLibs[x.key()]=!0});else{var newUses=jsyaml.createMapNode("uses");newUses._parent=yamlNode,newUses.setUnit(yamlNode.unit()),usesNode=cNode.replaceChild(null,newUses)}for(var _i=0,_a=usesInfos.concat(extendedUsesInfos);_i<_a.length;_i++){var ui=_a[_i];ui.absolutePath();if(!existingLibs[ui.namespace()]){var ip=ui.includePath,mapping=jsyaml.createMapping(ui.namespace(),ip);mapping.setUnit(yamlNode.unit()),usesNode.replaceChild(null,mapping)}}}}},ReferencePatcher.prototype.removeUses=function(node){if(node instanceof proxy.LowLevelCompositeNode){var cNode=node,originalChildren=node.children(),usesNodes=originalChildren.filter(function(x){return x.key()==universeDef.Universe10.FragmentDeclaration.properties.uses.name});usesNodes.length>0&&cNode.removeChild(usesNodes[0])}},ReferencePatcher.prototype.resetTypes=function(hlNode){for(var _i=0,_a=hlNode.elements();_i<_a.length;_i++){var ch=_a[_i];this.resetTypes(ch)}delete hlNode.lowLevel().actual().types,delete hlNode._ptype,delete hlNode._types,hlNode.setAssociatedType(null)},ReferencePatcher.prototype.appendUnitIfNeeded=function(node,units){if(node instanceof jsyaml.CompilationUnit){var unit=node;return unit.absolutePath()!=units[units.length-1].absolutePath()?(units.push(unit),!0):!1}var originalNode=toOriginal(node.lowLevel()),originalUnit=originalNode.unit();if(originalNode.valueKind()==yaml.Kind.INCLUDE_REF){var ref=originalNode.includePath(),includedUnit=originalUnit.resolve(ref);return units.push(includedUnit),!0}return originalUnit.absolutePath()!=units[units.length-1].absolutePath()?(units.push(originalUnit),!0):!1},ReferencePatcher.prototype.popUnitIfNeeded=function(units,appended){appended&&units.pop()},ReferencePatcher.prototype.registerPatchedReference=function(ref){var collectionName=ref.collectionName();if(collectionName){var aPath=ref.referencedUnit().absolutePath(),libMap=this._outerDependencies[aPath];null==libMap&&(libMap={},this._outerDependencies[aPath]=libMap);var collectionMap=libMap[collectionName];null==collectionMap&&(collectionMap={},libMap[collectionName]=collectionMap),collectionMap[ref.name()]=ref}},ReferencePatcher.prototype.collectionName=function(range){var collectionName;return universeHelpers.isResourceTypeRefType(range)||universeHelpers.isResourceTypeType(range)?collectionName=def.universesInfo.Universe10.LibraryBase.properties.resourceTypes.name:universeHelpers.isTraitRefType(range)||universeHelpers.isTraitType(range)?collectionName=def.universesInfo.Universe10.LibraryBase.properties.traits.name:universeHelpers.isSecuritySchemeRefType(range)||universeHelpers.isSecuritySchemaTypeDescendant(range)?collectionName=def.universesInfo.Universe10.LibraryBase.properties.securitySchemes.name:universeHelpers.isAnnotationRefTypeOrDescendant(range)||range.isAnnotationType()?collectionName=def.universesInfo.Universe10.LibraryBase.properties.annotationTypes.name:universeHelpers.isTypeDeclarationDescendant(range)&&(collectionName=def.universesInfo.Universe10.LibraryBase.properties.types.name),collectionName},ReferencePatcher.prototype.expandLibraries=function(api){if(!api.lowLevel().actual().libExpanded){var llNode=api.lowLevel(),unit=llNode.unit(),project=(unit.absolutePath(),unit.project()),libModels=[],resolver=llNode.unit().project().namespaceResolver(),expandedPathMap=resolver.expandedPathMap(unit);if(null!=expandedPathMap){for(var libPaths=Object.keys(expandedPathMap).sort(),_i=0,libPaths_1=libPaths;_i<libPaths_1.length;_i++){var ns=libPaths_1[_i],libModel=this._libModels[ns];if(null==libModel){var libUnit=project.unit(ns,!0);libUnit&&null!=resolver.resolveNamespace(unit,libUnit)&&(libModel=this.extractLibModel(libUnit))}libModel&&libModels.push(libModel)}for(var gotContribution=!1,_a=0,libModels_1=libModels;_a<libModels_1.length;_a++)for(var libModel=libModels_1[_a],_b=0,_c=Object.keys(libModel);_b<_c.length;_b++){var cName=_c[_b],collection=libModel[cName];collection instanceof ElementsCollection&&(gotContribution=this.contributeCollection(api.lowLevel(),collection)||gotContribution)}if(this.resetTypes(api),api.resetChildren(),gotContribution){var gotPatch=!1;do gotPatch=this.patchDependencies(api);while(gotPatch);this.removeUnusedDependencies(api)}}this.removeUses(api.lowLevel()),api.lowLevel().actual().libExpanded=!0,this.resetTypes(api),api.resetChildren()}},ReferencePatcher.prototype.patchDependencies=function(api){for(var result=!1,apiPath=api.lowLevel().unit().absolutePath(),_i=0,_a=api.children();_i<_a.length;_i++){var ch=_a[_i];if(ch.isElement()&&!ch.lowLevel().libProcessed){var chNode=ch.asElement();this.removeUses(chNode.lowLevel());var chPath=ch.lowLevel().unit().absolutePath();if(chPath!=apiPath||null!=ch.lowLevel().includePath()){var dependencies=this._outerDependencies[chPath];if(null!=dependencies){var pName=chNode.property().nameId(),depCollection=dependencies[pName];if(null!=depCollection){var chName=chNode.name();null!=depCollection[chName]&&(this.process(chNode,api,!0,!0),result=!0)}}}}}return result},ReferencePatcher.prototype.removeUnusedDependencies=function(api){for(var llNode=api.lowLevel(),apiPath=llNode.unit().absolutePath(),children=[].concat(api.children()),_i=0,children_1=children;_i<children_1.length;_i++){var ch=children_1[_i],chLl=ch.lowLevel();if(!ch.isElement()||!chLl.libProcessed){var chPath=chLl.unit().absolutePath();chPath!=apiPath&&chLl.parent().removeChild(chLl)}}},ReferencePatcher.prototype.contributeCollection=function(llApi,collection){var name=collection.name,llNode=_.find(llApi.children(),function(x){return x.key()==name});if(null==llNode){var n=jsyaml.createMapNode(name);llNode=llApi.replaceChild(null,n)}for(var result=!1,_i=0,_a=collection.array;_i<_a.length;_i++){var e=_a[_i];llNode.children().some(function(x){var oNode=toOriginal(x);return oNode.unit().absolutePath()!=e.lowLevel().unit().absolutePath()?!1:e.lowLevel().key()==oNode.key()&&e.lowLevel().unit().absolutePath()==oNode.unit().absolutePath()})||(llNode.replaceChild(null,e.lowLevel()),result=!0)}return result},ReferencePatcher.prototype.extractLibModel=function(unit){var result=this._libModels[unit.absolutePath()];if(null!=result)return result;result=new LibModel(unit),this._libModels[unit.absolutePath()]=result;var hlNode=unit.highLevel();if(hlNode&&hlNode.isElement())for(var _i=0,_a=["resourceTypes","traits","types","annotationTypes","securitySchemes"];_i<_a.length;_i++){for(var cName=_a[_i],collection=new ElementsCollection(cName),_b=0,_c=hlNode.asElement().elementsOfKind(cName);_b<_c.length;_b++){var el=_c[_b];collection.array.push(el)}result[cName]=collection}return result},ReferencePatcher.prototype.isCompoundValue=function(str){var i0=str.indexOf("<<");if(0>i0)return!1;if(0!=i0)return!0;var i1=str.indexOf(">>",i0);return i1+">>".length!=str.length?!0:!1},ReferencePatcher}();exports.ReferencePatcher=ReferencePatcher;var ParametersEscapingStatus;!function(ParametersEscapingStatus){ParametersEscapingStatus[ParametersEscapingStatus.OK=0]="OK",ParametersEscapingStatus[ParametersEscapingStatus.NOT_REQUIRED=1]="NOT_REQUIRED",ParametersEscapingStatus[ParametersEscapingStatus.ERROR=2]="ERROR"}(ParametersEscapingStatus||(ParametersEscapingStatus={}));var PARAM_OCCURENCE_STR="__P_A_R_A_M_E_T_E_R__";exports.patchMethodIs=patchMethodIs,exports.prepareTraitRefNode=prepareTraitRefNode;var PatchedReference=function(){function PatchedReference(_namespace,_name,_collectionName,_referencedUnit,_mode){this._namespace=_namespace,this._name=_name,this._collectionName=_collectionName,this._referencedUnit=_referencedUnit,this._mode=_mode}return PatchedReference.prototype.namespace=function(){return this._namespace},PatchedReference.prototype.name=function(){return this._name},PatchedReference.prototype.collectionName=function(){return this._collectionName},PatchedReference.prototype.referencedUnit=function(){return this._referencedUnit},PatchedReference.prototype.mode=function(){return this._mode},PatchedReference.prototype.value=function(){if(null==this._namespace)return this._name;var delim=this._mode==PatchMode.PATH?"/":".";return this._namespace+delim+this._name},PatchedReference}();exports.PatchedReference=PatchedReference,exports.instanceOfPatchedReference=instanceOfPatchedReference;var ElementsCollection=function(){function ElementsCollection(name){this.name=name,this.array=[]}return ElementsCollection}(),LibModel=function(){function LibModel(unit){this.unit=unit}return LibModel}();exports.getDeclaration=getDeclaration},function(module,exports,__webpack_require__){"use strict";var ll=__webpack_require__(11),path=__webpack_require__(15),universes=__webpack_require__(18),universeHelpers=__webpack_require__(14),resourceRegistry=__webpack_require__(29),NamespaceResolver=function(){function NamespaceResolver(){this.expandedAbsToNsMap={},this.byPathMap={},this.byNsMap={},this._hasFragments={}}return NamespaceResolver.prototype.resolveNamespace=function(from,to){if(null==to)return null;var toPath=to.absolutePath(),unitMap=this.expandedPathMap(from);if(!unitMap)return null;var usesInfo=unitMap[toPath];return null!=usesInfo?usesInfo.namespace():null},NamespaceResolver.prototype.expandedPathMap=function(unit){var fromPath=unit.absolutePath(),unitMap=this.expandedAbsToNsMap[fromPath];return void 0===unitMap&&(unitMap=this.calculateExpandedNamespaces(unit),0==Object.keys(unitMap).length&&(unitMap=null),this.expandedAbsToNsMap[fromPath]=unitMap),unitMap},NamespaceResolver.prototype.calculateExpandedNamespaces=function(_unit){for(var _this=this,rootPath=path.dirname(_unit.absolutePath()),result={},usesInfoArray=[];_unit;){usesInfoArray.push(new UsesInfo([],_unit,""));var u=_unit;_unit=null;var hlNode=u.highLevel();if(hlNode.isElement()){var hlElem=hlNode.asElement(),definition=hlElem.definition();if(universeHelpers.isOverlayType(definition)||universeHelpers.isExtensionType(definition)){var eValue=hlElem.attrValue(universes.Universe10.Extension.properties["extends"].name);eValue&&(_unit=u.resolve(eValue),_unit&&resourceRegistry.isWaitingFor(_unit.absolutePath())&&(_unit=null))}}}for(var i=0;i<usesInfoArray.length;i++){var visited={},usedUnits={},info=usesInfoArray[i],unit=info.unit,hlPR=unit.highLevel();if(hlPR.isElement()){var steps=info.steps()+1,visit=function(x){if(x){var children=x.children();if(null==x.parent()){var nodeUnit=x.unit(),localPath=nodeUnit.absolutePath();if(visited[localPath])return;visited[localPath]=!0,localPath!=unit.absolutePath()&&(_this._hasFragments[unit.absolutePath()]=!0);var map=_this.pathMap(nodeUnit);if(map)for(var _i=0,_a=Object.keys(map);_i<_a.length;_i++){var absPath=_a[_i],childInfo=map[absPath],segments=info.namespaceSegments.concat(childInfo.namespaceSegments),existing=result[absPath];if(existing){if(existing.steps()<steps)continue;if(existing.steps()==steps&&_this.lexLessEq(existing.namespaceSegments,segments))continue}var includePath,childInclude=childInfo.includePath,absChildPath=childInfo.absolutePath();includePath=path.isAbsolute(info.includePath)||ll.isWebPath(info.includePath)?absChildPath:path.isAbsolute(childInclude)||ll.isWebPath(childInclude)?absChildPath:ll.isWebPath(rootPath)!=ll.isWebPath(absChildPath)?absChildPath:rootPath.length>0&&absChildPath.length>0&&rootPath.charAt(0).toLowerCase()!=absChildPath.charAt(0).toLowerCase()?absChildPath:path.relative(rootPath,absChildPath),includePath=includePath.replace(/\\/g,"/");var ui=new UsesInfo(segments,childInfo.unit,includePath);usedUnits[ui.absolutePath()]||(result[absPath]=ui,usesInfoArray.push(ui),usedUnits[ui.absolutePath()]=!0)}}children.forEach(function(y){y.includedFrom()&&(y=y.parent()),visit(y)}),null==x.parent()&&(visited[x.unit().absolutePath()]=!1)}};visit(unit.ast())}}for(var namespaces={},_i=0,_a=Object.keys(result);_i<_a.length;_i++){for(var key=_a[_i],info=result[key],ns=info.namespace(),i=0;namespaces[ns];)ns=info.namespace()+i++;ns!=info.namespace()&&(info.namespaceSegments=ns.split(".")),namespaces[ns]=!0}return result},NamespaceResolver.prototype.pathMap=function(unit){var fromPath=unit.absolutePath(),unitMap=this.byPathMap[fromPath];return void 0===unitMap&&(unitMap=this.calculateNamespaces(unit),0==Object.keys(unitMap).length&&(unitMap=null),this.byPathMap[fromPath]=unitMap),unitMap},NamespaceResolver.prototype.nsMap=function(unit){var fromPath=unit.absolutePath(),unitMap=this.byNsMap[fromPath];if(void 0===unitMap){var map=this.pathMap(unit);if(null==map)unitMap=null;else{unitMap={};for(var _i=0,_a=Object.keys(map);_i<_a.length;_i++){var aPath=_a[_i],info=map[aPath];unitMap[info.namespace()]=info}}this.byNsMap[fromPath]=unitMap}return unitMap},NamespaceResolver.prototype.calculateNamespaces=function(unit){var rootPath=path.dirname(unit.absolutePath()),result={},rootNode=unit.ast(),usesNodes=rootNode.children().filter(function(x){return x.key()==universes.Universe10.FragmentDeclaration.properties.uses.name});if(rootNode.actual()&&rootNode.actual().usesNode&&(usesNodes=[rootNode.actual().usesNode]),0==usesNodes.length)return result;for(var usesDeclarationNodes=[],_i=0,usesNodes_1=usesNodes;_i<usesNodes_1.length;_i++){var un=usesNodes_1[_i];usesDeclarationNodes=usesDeclarationNodes.concat(un.children())}if(0==usesDeclarationNodes.length)return result;for(var _a=0,usesDeclarationNodes_1=usesDeclarationNodes;_a<usesDeclarationNodes_1.length;_a++){var un=usesDeclarationNodes_1[_a],key=un.key(),value=un.value(),libUnit=unit.resolve(value);if(null!=libUnit){var includePath,segments=[key],absPath=libUnit.absolutePath();includePath=path.isAbsolute(value)||ll.isWebPath(value)?libUnit.absolutePath():path.relative(rootPath,libUnit.absolutePath()),includePath=includePath.replace(/\\/g,"/");var ui=new UsesInfo(segments,libUnit,includePath);result[absPath]=ui}}var hlNode=unit.highLevel();if(hlNode.isElement()){var hlElem=hlNode.asElement(),definition=hlElem.definition();if(universeHelpers.isOverlayType(definition)||universeHelpers.isExtensionType(definition)){var extendedUnit,eValue=hlElem.attr(universes.Universe10.Extension.properties["extends"].name).value();try{extendedUnit=unit.resolve(eValue)}catch(e){}if(extendedUnit){var m=this.pathMap(extendedUnit);if(m)for(var _b=0,_c=Object.keys(m);_b<_c.length;_b++){var k=_c[_b];result[k]=m[k]}}}}return result},NamespaceResolver.prototype.lexLessEq=function(a,b){if(a.length>b.length)return!1;if(a.length<b.length)return!0;for(var i=0;i<a.length;i++){var seg_a=a[i],seg_b=b[i];if(seg_b>seg_a)return!0;if(seg_a>seg_b)return!1}return!0},NamespaceResolver.prototype.hasFragments=function(unit){return this.calculateExpandedNamespaces(unit),this._hasFragments[unit.absolutePath()]?!0:!1},NamespaceResolver}();exports.NamespaceResolver=NamespaceResolver;var UsesInfo=function(){function UsesInfo(namespaceSegments,unit,includePath){this.namespaceSegments=namespaceSegments,this.unit=unit,this.includePath=includePath}return UsesInfo.prototype.steps=function(){return this.namespaceSegments.length},UsesInfo.prototype.namespace=function(){return this.namespaceSegments.join(".")},UsesInfo.prototype.absolutePath=function(){return this.unit.absolutePath()},UsesInfo}();exports.UsesInfo=UsesInfo},function(module,exports,__webpack_require__){"use strict";function serialize2(n,full){if(void 0===full&&(full=!1),!n)return null;var kind=n.kind();if(kind==yaml.Kind.ANCHOR_REF&&(kind=n.anchorValueKind()),kind==yaml.Kind.INCLUDE_REF){if(null!=n.unit()){var includePath=n.includePath(),resolved=null;try{resolved=n.unit().resolve(includePath)}catch(Error){}if(null==resolved)return null;if(resolved.isRAMLUnit()&&this.canInclude(resolved)){var ast=resolved.ast();if(ast)return serialize2(ast,full)}}return null}if(kind==yaml.Kind.SEQ){for(var arr=[],_i=0,_a=n.children();_i<_a.length;_i++){var ch=_a[_i];arr.push(serialize2(ch,full))}return arr}if(kind==yaml.Kind.ANCHOR_REF)return serialize2(n.anchoredFrom(),full);if(kind==yaml.Kind.MAPPING){var v={},key=""+n.key(!0),valueKind=n.valueKind();if(valueKind==yaml.Kind.INCLUDE_REF){var children=n.children();0==children.length?v[key]=n.value():valueKind=null==children[0].key()?yaml.Kind.SEQ:yaml.Kind.MAP}if(valueKind==yaml.Kind.ANCHOR_REF&&(valueKind=n.anchorValueKind()),valueKind==yaml.Kind.SCALAR)v[key]=n.value();else if(valueKind==yaml.Kind.SEQ){var arr=[];v[key]=arr;for(var _b=0,_c=n.children();_b<_c.length;_b++){var ch=_c[_b];arr.push(serialize2(ch,!0))}}else if(valueKind==yaml.Kind.MAP){var obj={};v[key]=obj;for(var _d=0,_e=n.children();_d<_e.length;_d++){var ch=_e[_d],chKey=""+ch.key(!0),serialized=serialize2(ch,!0);obj[chKey]=void 0===serialized?null:serialized}}return v[key]}if(kind==yaml.Kind.SCALAR){var q=n.value(!1);return q}if(kind==yaml.Kind.MAP){for(var obj={},_f=0,_g=n.children();_f<_g.length;_f++){var ch=_g[_f],chKey=""+ch.key(!0),serialized=serialize2(ch,!0);obj[chKey]=void 0===serialized?null:serialized}return obj}}function serialize(node,options){if(void 0===options&&(options={}),options=options||{},0==node.children().length)return node.value();if(node.children()[0].key()){var obj={};if(node.children().forEach(function(x){obj[escapeKey(x.key(options.rawKey),options)]=serialize(x,options)}),options&&options.writeErrors){var errors=collectErrors(node);null!=errors&&errors.length>0&&(obj.__$errors__=errors)}return obj}var arr=[];return node.children().forEach(function(x){arr.push(serialize(x,options))}),arr}function collectErrors(node){var errors=[].concat(node.errors());return node.children().forEach(function(ch){var children=ch.children();return 0==children.length?void ch.errors().forEach(function(e){return errors.push(e)}):void(children[0].key()||children.forEach(function(x){0==x.children().length&&x.errors().forEach(function(e){return errors.push(e)})}))}),errors}function escapeKey(key,options){return options&&key&&options.escapeNumericKeys&&0==key.replace(/\d/g,"").trim().length?"__$EscapedKey$__"+key:key}function unescapeKey(key,options){return key?(options=options||{},options.escapeNumericKeys&&util.stringStartsWith(key,"__$EscapedKey$__")&&0==key.substring("__$EscapedKey$__".length).replace(/\d/g,"").trim().length?key.substring("__$EscapedKey$__".length):key):key}var yaml=__webpack_require__(74),lowlevel=__webpack_require__(11),hlimpl=__webpack_require__(16),util=__webpack_require__(32),llImpl=__webpack_require__(28),Error=yaml.YAMLException,CompilationUnit=function(){function CompilationUnit(_absolutePath,_path,_content,_project,_isTopoLevel,serializeOptions){void 0===serializeOptions&&(serializeOptions={}),this._absolutePath=_absolutePath,this._path=_path,this._content=_content,this._project=_project,this._isTopoLevel=_isTopoLevel,this.serializeOptions=serializeOptions,this._node=new AstNode(this,JSON.parse(this._content),null,serializeOptions)}return CompilationUnit.prototype.highLevel=function(){return hlimpl.fromUnit(this)},CompilationUnit.prototype.absolutePath=function(){return this._absolutePath},CompilationUnit.prototype.clone=function(){return null},CompilationUnit.prototype.contents=function(){return this._content},CompilationUnit.prototype.lexerErrors=function(){return[]},CompilationUnit.prototype.path=function(){return this._content},CompilationUnit.prototype.isTopLevel=function(){return this._isTopoLevel},CompilationUnit.prototype.ast=function(){return this._node},CompilationUnit.prototype.expandedHighLevel=function(){return this.highLevel()},CompilationUnit.prototype.isDirty=function(){return!0},CompilationUnit.prototype.getIncludeNodes=function(){return[]},CompilationUnit.prototype.resolveAsync=function(p){return null},CompilationUnit.prototype.isRAMLUnit=function(){return!0},CompilationUnit.prototype.project=function(){return this._project},CompilationUnit.prototype.updateContent=function(newContent){},CompilationUnit.prototype.ramlVersion=function(){throw new Error("not implemented")},CompilationUnit.prototype.lineMapper=function(){return new lowlevel.LineMapperImpl(this.contents(),this.absolutePath())},CompilationUnit.prototype.resolve=function(p){return null},CompilationUnit.prototype.isOverlayOrExtension=function(){return!1},CompilationUnit.prototype.getMasterReferenceNode=function(){return null},CompilationUnit}();exports.CompilationUnit=CompilationUnit;var AstNode=function(){function AstNode(_unit,_object,_parent,options,_key){var _this=this;void 0===options&&(options={}),this._unit=_unit,this._object=_object,this._parent=_parent,this.options=options,this._key=_key,this._isOptional=!1,this._object instanceof Object&&Object.keys(this._object).forEach(function(x){var u=unescapeKey(x,_this.options);if(u!=x){var val=_this._object[x];delete _this._object[x],_this._object[u]=val}}),this._key&&util.stringEndsWith(this._key,"?")&&(this._isOptional=!0,this._key=this._key.substring(0,this._key.length-1))}return AstNode.prototype.keyKind=function(){return null},AstNode.prototype.isAnnotatedScalar=function(){return!1},AstNode.prototype.hasInnerIncludeError=function(){return!1},AstNode.prototype.start=function(){return-1},AstNode.prototype.end=function(){return-1},AstNode.prototype.value=function(){return this._object},AstNode.prototype.actual=function(){return this._object},AstNode.prototype.includeErrors=function(){return[]},AstNode.prototype.includePath=function(){return null},AstNode.prototype.includeReference=function(){return null},AstNode.prototype.key=function(){return this._key},AstNode.prototype.optional=function(){return this._isOptional},AstNode.prototype.children=function(){var _this=this;return this._object?Array.isArray(this._object)?this._object.map(function(x){return new AstNode(_this._unit,x,_this,_this.options)}):this._object instanceof Object?Object.keys(this._object).map(function(x){return new AstNode(_this._unit,_this._object[x],_this,_this.options,x)}):[]:[]},AstNode.prototype.parent=function(){return this._parent},AstNode.prototype.unit=function(){return this._unit},AstNode.prototype.includeBaseUnit=function(){return this._unit},AstNode.prototype.anchorId=function(){return null},AstNode.prototype.errors=function(){return[]},AstNode.prototype.anchoredFrom=function(){return this},AstNode.prototype.includedFrom=function(){return this},AstNode.prototype.visit=function(v){v(this)&&this.children().forEach(function(x){return x.visit(v)})},AstNode.prototype.dumpToObject=function(){return this._object},AstNode.prototype.addChild=function(n){},AstNode.prototype.execute=function(cmd){},AstNode.prototype.dump=function(){return JSON.stringify(this._object)},AstNode.prototype.keyStart=function(){return-1},AstNode.prototype.keyEnd=function(){return-1},AstNode.prototype.valueStart=function(){return-1},AstNode.prototype.valueEnd=function(){return-1},AstNode.prototype.isValueLocal=function(){return!0},AstNode.prototype.kind=function(){return Array.isArray(this._object)?yaml.Kind.SEQ:this._object instanceof Object?yaml.Kind.MAP:yaml.Kind.SCALAR},AstNode.prototype.valueKind=function(){if(!this._object)return null;var valType=typeof this._object;return Array.isArray(this._object)?yaml.Kind.SEQ:"object"==valType?yaml.Kind.MAP:"string"==valType||"number"==valType||"boolean"==valType?yaml.Kind.SCALAR:null},AstNode.prototype.anchorValueKind=function(){return null},AstNode.prototype.show=function(msg){},AstNode.prototype.setHighLevelParseResult=function(highLevelParseResult){this._highLevelParseResult=highLevelParseResult},AstNode.prototype.highLevelParseResult=function(){return this._highLevelParseResult},AstNode.prototype.setHighLevelNode=function(highLevel){this._highLevelNode=highLevel},AstNode.prototype.highLevelNode=function(){return this._highLevelNode},AstNode.prototype.text=function(unitText){throw new Error("not implemented")},AstNode.prototype.copy=function(){throw new Error("not implemented")},AstNode.prototype.markup=function(json){throw new Error("not implemented")},AstNode.prototype.nodeDefinition=function(){return llImpl.getDefinitionForLowLevelNode(this)},AstNode.prototype.includesContents=function(){return!1},AstNode}();exports.AstNode=AstNode,exports.serialize2=serialize2,exports.serialize=serialize},function(module,exports,__webpack_require__){"use strict";var hl=__webpack_require__(10),linter=__webpack_require__(26),OverloadingValidator=function(){function OverloadingValidator(){this.uriToResources={},this.conflictingUriToResources={}}return OverloadingValidator.prototype.validateApi=function(api,acceptor){var _this=this,resources=api.resources();resources.forEach(function(resource){_this.acceptResource(resource);var subResources=resource.resources();subResources.forEach(function(subResource){return _this.acceptResource(subResource)})});for(var uri in this.conflictingUriToResources){var resources=this.conflictingUriToResources[uri];if(resources.length>1){var idToSimilarResources={};resources.forEach(function(resource){var highLevel=resource.highLevel(),complexId="";null!=highLevel.parent()&&(complexId+=highLevel.parent().id()+"."),complexId+=highLevel.localId();var resourcesWithId=idToSimilarResources[complexId];null==resourcesWithId&&(resourcesWithId=[],idToSimilarResources[complexId]=resourcesWithId),resourcesWithId.push(resource)});var ids=Object.keys(idToSimilarResources);ids.length>1&&resources.forEach(function(resource){acceptor.accept(linter.createIssue(hl.IssueCode.KEY_SHOULD_BE_UNIQUE_INTHISCONTEXT,"Resources share same URI",resource.highLevel(),!1))})}}},OverloadingValidator.prototype.acceptResource=function(resource){var uri=resource.absoluteUri(),resources=this.uriToResources[uri];resources||(resources=[],this.uriToResources[uri]=resources),resources.push(resource),resources.length>1&&(this.conflictingUriToResources[uri]=resources)},OverloadingValidator}();module.exports=OverloadingValidator},function(module,exports,__webpack_require__){"use strict";function xmlToJson(xml){var obj={};if(1==xml.nodeType){if(xml.attributes.length>0)for(var j=0;j<xml.attributes.length;j++){var attribute=xml.attributes.item(j);obj["@"+attribute.nodeName]=attribute.nodeValue}}else 3==xml.nodeType&&(obj=xml.nodeValue);if(xml.hasChildNodes())for(var i=0;i<xml.childNodes.length;i++){var item=xml.childNodes.item(i),nodeName=item.nodeName;if(void 0!=nodeName)if("undefined"==typeof obj[nodeName])obj[nodeName]=xmlToJson(item);else{if("undefined"==typeof obj[nodeName].push){var old=obj[nodeName];obj[nodeName]=[],obj[nodeName].push(old)}obj[nodeName].push(xmlToJson(item))}}return obj}function cleanupText(j){if("object"==typeof j)for(var p in j)if("object"==typeof j[p]){for(var k in j[p])if("#text"==k){var txt=j[p]["#text"];"string"!=typeof txt&&(txt=txt.join("")),txt=txt.trim(),0==txt.length&&delete j[p]["#text"]}cleanupText(j[p])}return j}function cleanupJson(j){if("object"==typeof j)for(var p in j)if("object"==typeof j[p]){var keys=Object.keys(j[p]);1==keys.length&&"#text"==keys[0]&&(j[p]=j[p]["#text"]),cleanupJson(j[p])}return j}function parseXML(value){var v=new DomParser.DOMParser;if(!value||0==value.trim().indexOf("<<"))return null;var parsed=v.parseFromString(value);return cleanupJson(cleanupText(xmlToJson(parsed)))}var DomParser=__webpack_require__(75);module.exports=parseXML},function(module,exports,__webpack_require__){"use strict";function isScheme(content){try{var schemeObject=JSON.parse(content);return schemeObject.$schema}catch(exception){return!1}}function startDownloadingReferencesAsync(schemaContent,unit){var schemaObject=su.getJSONSchema(schemaContent,new contentprovider.ContentProvider(unit)),missedReferences=schemaObject.getMissingReferences([]).map(function(reference){return schemaObject.contentAsync(reference)});if(0===missedReferences.length)return Promise.resolve(unit);var allReferences=Promise.all(missedReferences),result=getRefs(allReferences,schemaObject);return result.then(function(){return unit})}function getReferences(schemaContent,unit){var schemaObject=su.getJSONSchema(schemaContent,new contentprovider.ContentProvider(unit));return schemaObject.getMissingReferences([],!0)}function getRefs(promise,schemaObject){return promise.then(function(references){if(references.length>0){var missedRefs=schemaObject.getMissingReferences(references);if(0===missedRefs.length)return[];var promises=[];return missedRefs.forEach(function(ref){promises.push(schemaObject.contentAsync(ref))}),getRefs(Promise.all(promises.concat(references)),schemaObject)}return Promise.resolve([])})}var contentprovider=__webpack_require__(31),def=__webpack_require__(36),su=def.getSchemaUtils();exports.isScheme=isScheme,exports.startDownloadingReferencesAsync=startDownloadingReferencesAsync,exports.getReferences=getReferences},function(module,exports,__webpack_require__){"use strict";function toRegExp(path,parameters,keys,options){var end=options.end!==!1,strict=options.strict,flags="";options.sensitive||(flags+="i");var route=path.replace(REGEXP_REPLACE,function(match,prefix,key,escape){if(escape)return"\\"+escape;keys.push({name:key,prefix:prefix||"/"}),prefix=prefix?"\\"+prefix:"";var param=parameters[key],capture=param&&REGEXP_MATCH[param.type]||"[^"+(prefix||"\\/")+"]+",optional=param&&param.required===!1;return Array.isArray(param["enum"])&&param["enum"].length&&(capture="(?:"+param["enum"].map(function(value){return String(value).replace(ESCAPE_CHARACTERS,"\\$1")}).join("|")+")"),prefix+"("+capture+")"+(optional?"?":"")}),endsWithSlash="/"===path.charAt(path.length-1);return strict||(route=(endsWithSlash?route.slice(0,-2):route)+"(?:\\/(?=$))?"),route+=end?"$":strict&&endsWithSlash?"":"(?=\\/|$)",new RegExp("^"+route+(end?"$":""),flags)}function decodeParam(param){
try{return decodeURIComponent(param)}catch(_){var err=new Error('Failed to decode param "'+param+'"');throw err.status=400,err}}function ramlPathMatch(path,parameters,options){if(options=options||{},"/"===path&&options.end===!1)return truth;parameters=parameters||{};var keys=[],re=toRegExp(path,parameters,keys,options),sanitize=ramlSanitize.sanitize()(parameters),validate=ramlValidate.validate()(parameters);return function(pathname){var m=re.exec(pathname);if(!m)return!1;if(parameters.mediaTypeExtension&&m.length>1&&!m[m.length-1]){var beforeLast=m[m.length-2],ind=beforeLast.lastIndexOf(".");ind>=0&&(m[m.length-2]=beforeLast.substring(0,ind),m[m.length-1]=beforeLast.substring(ind))}for(var path=m[0],params={},i=1;i<m.length;i++){var key=keys[i-1],param=m[i];params[key.name]=null==param?param:decodeParam(param)}return params=sanitize(params),validate(params).valid?{path:path,params:params}:!1}}function truth(path){return{path:"",params:{}}}var ramlSanitize=__webpack_require__(76),ramlValidate=__webpack_require__(77),REGEXP_MATCH={number:"[-+]?\\d+(?:\\.\\d+)?",integer:"[-+]?\\d+",date:"(?:Mon|Tue|Wed|Thu|Fri|Sat|Sun), \\d{2} (?:Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec) \\d{4} (?:[0-1]\\d|2[0-3]):[0-5]\\d:[0-5]\\d GMT","boolean":"(?:true|false)"},ESCAPE_CHARACTERS=/([.*+?=^!:${}()|[\]\/\\])/g,REGEXP_REPLACE=new RegExp(["([.\\/])?\\{([^}]+)\\}",ESCAPE_CHARACTERS.source].join("|"),"g");exports.ramlPathMatch=ramlPathMatch},function(module,exports,__webpack_require__){"use strict";function toModule(arr){var main=arr[0],map={};return arr.forEach(function(x){return map[x.name]=x}),arr.forEach(function(x){var imports=x.imports;Object.keys(imports).forEach(function(y){var name=imports[y];imports[y]=map[name]})}),main}exports.universeDumps={RAML08:toModule(__webpack_require__(87)),RAML10:toModule(__webpack_require__(88))}},function(module,exports,__webpack_require__){"use strict";function toDefSystem(ts,q){var u=new def.Universe(q,""),c={};return processModule(ts,u,{},c),Object.keys(c).forEach(function(x){registerClasses(c[x],u)}),Object.keys(c).forEach(function(x){registerHierarchy(c[x],u)}),Object.keys(c).forEach(function(x){registerEverything(c[x],u)}),u.types().forEach(function(x){if(x instanceof def.NodeClass){var cl=x;if(cl.properties().forEach(function(y){var t=y.range(),ap=y;t.hasValueTypeInHierarchy()||t.properties().forEach(function(p0){if(p0.getAdapter(services.RAMLPropertyService).isKey()){var kp=p0.keyPrefix();kp&&(ap.withKeyRestriction(kp),ap.merge());var eo=p0.enumOptions();eo&&(ap.withEnumOptions(eo),ap.merge())}})}),cl.getAdapter(services.RAMLService).isGlobalDeclaration()){if(cl.getAdapter(services.RAMLService).getActuallyExports()&&"$self"!=cl.getAdapter(services.RAMLService).getActuallyExports()){var tp=cl.property(cl.getAdapter(services.RAMLService).getActuallyExports()).range();if(tp.hasValueTypeInHierarchy()){var vt=tp.getAdapter(services.RAMLService);vt.setGloballyDeclaredBy(cl)}}if(cl.getAdapter(services.RAMLService).getConvertsToGlobal()){var tp=u.type(cl.getAdapter(services.RAMLService).getConvertsToGlobal());if(tp.hasValueTypeInHierarchy()){var vt=tp.getAdapter(services.RAMLService);vt.setGloballyDeclaredBy(cl)}}}}}),u}function createProp(x,clazz,t,custom,annotations){var p=def.prop(x.name(),"",clazz,t,custom);x.isMultiValue()&&p.withMultiValue(!0),p.unmerge(),t||console.log(x.name()+":"+clazz.nameId()+" has undefined type"),t.hasValueTypeInHierarchy()||t.properties().forEach(function(p0){if(p0.getAdapter(services.RAMLPropertyService).isKey()){var kp=p0.keyPrefix();kp&&(p.withKeyRestriction(kp),p.merge());var eo=p0.enumOptions();eo&&(p.withEnumOptions(eo),p.merge())}}),processAnnotations(x,p,annotations)}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},tsModel=__webpack_require__(91),def=__webpack_require__(36),_=__webpack_require__(89),aHandlers=__webpack_require__(78),services=def,FieldWrapper=function(){function FieldWrapper(_field,_clazz){this._field=_field,this._clazz=_clazz}return FieldWrapper.prototype.name=function(){return this._field.name},FieldWrapper.prototype.range=function(){return this._clazz.getModule().typeFor(this._field.type,this._clazz)},FieldWrapper.prototype.isMultiValue=function(){return this._field.type.typeKind==tsModel.TypeKind.ARRAY},FieldWrapper.prototype.isKey=function(){return null!=_.find(this._field.annotations,function(x){return"MetaModel.key"==x.name})},FieldWrapper.prototype.isSimpleValue=function(){return null!=_.find(this._field.annotations,function(x){return"MetaModel.value"==x.name})},FieldWrapper.prototype.annotations=function(){return this._field.annotations},FieldWrapper}(),FieldConstraint=function(){function FieldConstraint(_field,_clazz){this._field=_field,this._clazz=_clazz}return FieldConstraint.prototype.name=function(){return this._field.name},FieldConstraint.prototype.value=function(){return this._field.valueConstraint},FieldConstraint}(),ClassWrapper=function(){function ClassWrapper(_clazz,mw){this._clazz=_clazz,this.mw=mw}return ClassWrapper.prototype.typeMeta=function(){return this._clazz.annotations},ClassWrapper.prototype.path=function(){return this.mw.path()},ClassWrapper.prototype.getModule=function(){return this.mw},ClassWrapper.prototype.typeArgs=function(){return this._clazz.typeParameters},ClassWrapper.prototype.typConstraints=function(){var _this=this;return this._clazz.typeParameterConstraint.map(function(x){return x?_this.mw.classForName(x):null})},ClassWrapper.prototype.methods=function(){return this._clazz.methods},ClassWrapper.prototype.name=function(){return this._clazz.name},ClassWrapper.prototype.members=function(){var _this=this;return this._clazz.fields.filter(function(x){return null==x.valueConstraint}).map(function(x){return new FieldWrapper(x,_this)})},ClassWrapper.prototype.constraints=function(){var _this=this;return this._clazz.fields.filter(function(x){return null!=x.valueConstraint}).map(function(x){return new FieldConstraint(x,_this)})},ClassWrapper.prototype.isSubTypeOf=function(of){if(this==of)return!0;var _res=!1;return this.getAllSuperTypes().forEach(function(x){_res||(_res=_res||x.isSubTypeOf(of))}),_res},ClassWrapper.prototype.getExtendsClauses=function(){return this._clazz["extends"]},ClassWrapper.prototype.getSuperTypes=function(){var _this=this,result=[];return this._clazz["extends"].forEach(function(x){var tp=_this.mw.classForName(x.typeName);tp&&result.push(tp)}),result},ClassWrapper.prototype.getAllSuperTypes=function(){var _this=this,result=[];return this._clazz["extends"].forEach(function(x){var tp=_this.mw.classForName(x.typeName);if(tp){var mm=tp.getAllSuperTypes();result.push(tp),result.concat(mm)}}),_.unique(result)},ClassWrapper.prototype.annotationOverridings=function(){return this._clazz.annotationOverridings},ClassWrapper}(),AbstractSimpleWrapper=function(){function AbstractSimpleWrapper(){}return AbstractSimpleWrapper.prototype.members=function(){return[]},AbstractSimpleWrapper.prototype.methods=function(){return[]},AbstractSimpleWrapper.prototype.isSubTypeOf=function(of){return!1},AbstractSimpleWrapper.prototype.getSuperTypes=function(){return[]},AbstractSimpleWrapper.prototype.getAllSuperTypes=function(){return[]},AbstractSimpleWrapper.prototype.name=function(){return null},AbstractSimpleWrapper.prototype.constraints=function(){return[]},AbstractSimpleWrapper.prototype.typeMeta=function(){return[]},AbstractSimpleWrapper.prototype.getModule=function(){throw new Error("Not implemented")},AbstractSimpleWrapper.prototype.annotationOverridings=function(){return{}},AbstractSimpleWrapper}(),EnumWrapper=function(_super){function EnumWrapper(_clazz,mw){_super.call(this),this._clazz=_clazz,this.mw=mw}return __extends(EnumWrapper,_super),EnumWrapper.prototype.getModule=function(){return this.mw},EnumWrapper.prototype.values=function(){return this._clazz.members},EnumWrapper.prototype.name=function(){return this._clazz.name},EnumWrapper}(AbstractSimpleWrapper),UnionWrapper=function(_super){function UnionWrapper(_clazz,mw){_super.call(this),this._clazz=_clazz,this.mw=mw}return __extends(UnionWrapper,_super),UnionWrapper.prototype.elements=function(){return this._clazz},UnionWrapper.prototype.name=function(){return this._clazz.map(function(x){return x.name()}).join("|")},UnionWrapper}(AbstractSimpleWrapper),ModuleWrapper=function(){function ModuleWrapper(_univers){var _this=this;this._univers=_univers,this.name2Class={},this.namespaceToMod={},this._classes=[],_univers.classes.forEach(function(x){var c=new ClassWrapper(x,_this);_this._classes.push(c),_this.name2Class[x.name]=c,x.moduleName&&(_this.name2Class[x.moduleName+"."+x.name]=c)}),_univers.enumDeclarations.forEach(function(x){var c=new EnumWrapper(x,_this);_this._classes.push(c),_this.name2Class[x.name]=c})}return ModuleWrapper.prototype.typeFor=function(t,ow){var _this=this;switch(t.typeKind){case tsModel.TypeKind.BASIC:var bt=t,typeName=bt.typeName;"string"==typeName&&(typeName="StringType"),"number"==typeName&&(typeName="NumberType"),"boolean"==typeName&&(typeName="BooleanType"),"any"==typeName&&(typeName="AnyType");var ti=_.indexOf(ow.typeArgs(),typeName);if(-1!=ti){var cnst=ow.typConstraints()[ti];return cnst?cnst:this.classForName("ValueType")}return this.classForName(typeName);case tsModel.TypeKind.UNION:var ut=t;return new UnionWrapper(ut.options.map(function(x){return _this.typeFor(x,ow)}),this);case tsModel.TypeKind.ARRAY:var at=t;return this.typeFor(at.base,ow)}return null},ModuleWrapper.prototype.path=function(){return this._univers.name},ModuleWrapper.prototype.classForName=function(name,stack){var _this=this;if(void 0===stack&&(stack={}),!name)return null;var result=this.name2Class[name];if(!result&&!stack[this.path()]){stack[this.path()]=this;var nmsp=name.indexOf(".");if(-1!=nmsp){var actualMod=this.namespaceToMod[name.substring(0,nmsp)];if(!actualMod)throw new Error;return actualMod.classForName(name.substring(nmsp+1),stack)}Object.keys(this.namespaceToMod).forEach(function(x){if("MetaModel"!=x){var nm=_this.namespaceToMod[x].classForName(name,stack);nm&&(result=nm)}})}return result},ModuleWrapper.prototype.classes=function(){return this._classes},ModuleWrapper}(),wrapperToType=function(range,u){if(range){var rangeType;if(range instanceof UnionWrapper){throw new Error("Union type support was removed from definition system")}return rangeType=u.type(range.name())}},registerClasses=function(m,u){var valueType=m.classForName("ValueType");m.classes().forEach(function(x){if(x instanceof EnumWrapper){var et=new def.EnumType(x.name(),u,x.getModule().path());return et.values=x.values(),void u.register(et)}if(x.isSubTypeOf(valueType)){var st=x.getAllSuperTypes();st.push(x);var refTo=null;if(st.forEach(function(t){var cs=t.getExtendsClauses();cs.forEach(function(z){if(z.typeKind==tsModel.TypeKind.BASIC){var bas=z;if("Reference"==bas.basicName){var of=bas.typeArguments[0];refTo=of.typeName;var di=refTo.indexOf(".");-1!=di&&(refTo=refTo.substring(di+1))}}})}),refTo){var ref=new def.ReferenceType(x.name(),x.getModule().path(),refTo,u);ref.setBuiltIn(!0),u.register(ref)}else{var vt=new def.ValueType(x.name(),u,x.getModule().path());vt.setBuiltIn(!0),u.register(vt)}}else{var gt=new def.NodeClass(x.name(),u,x.getModule().path());gt.setBuiltIn(!0),u.register(gt)}})},registerHierarchy=function(m,u){m.classes().forEach(function(x){x.getSuperTypes().forEach(function(y){var tp0=u.type(x.name()),tp1=u.type(y.name());if(!tp0||!tp1){var tp0=u.type(x.name()),tp1=u.type(y.name());throw new Error}u.registerSuperClass(tp0,tp1)})})},registerEverything=function(m,u){m.classes().forEach(function(x){var tp=u.type(x.name());x.typeMeta().forEach(function(a){var rangeType=wrapperToType(x,u);aHandlers.handleTypeAnnotation(a,rangeType)}),x.members().forEach(function(x){var range=x.range(),rangeType=wrapperToType(range,u);null==rangeType&&console.log(range+":"+x.name());var custom=x.annotations().map(function(y){return y.name}).indexOf("MetaModel.customHandling")>=0;createProp(x,tp,rangeType,custom)}),Object.keys(x.annotationOverridings()).forEach(function(fName){var arr=[].concat(x.annotationOverridings()[fName]),map={};arr.forEach(function(ann){return map[ann.name]=!0});for(var targetField,stArr=x.getSuperTypes(),stMap={},i=0;i<stArr.length;i++){var st=stArr[i];if(!stMap[st.name()]){stMap[st.name()]=!0,st.getSuperTypes().forEach(function(sst){return stArr.push(sst)});var arr1=st.annotationOverridings()[fName];if(arr1)arr1.filter(function(ann){return!map[ann.name]}).forEach(function(ann){map[ann.name]=!0,arr.push(ann)});else for(var stFields=st.members(),j=0;j<stFields.length;j++){var stField=stFields[j];if(stField.name()==fName){targetField=stField;break}}if(targetField){var arr2=targetField.annotations();arr2.filter(function(ann){return!map[ann.name]}).forEach(function(ann){map[ann.name]=!0,arr.push(ann)});break}}}if(targetField){var range=targetField.range(),rangeType=wrapperToType(range,u);null==rangeType&&console.log(range+":"+x.name()),createProp(targetField,tp,rangeType,!1,arr)}}),x.methods().forEach(function(x){}),x.constraints().forEach(function(x){if(x.value().isCallConstraint)throw new Error;var mm=x.value();tp.addRequirement(x.name(),""+mm.value)})}),u.types().forEach(function(x){var at=x;at.getAdapter(services.RAMLService).getAliases().forEach(function(y){return u.registerAlias(y,at)})})},processModule=function(ts,u,used,declared){if(-1==ts.name.indexOf("metamodel.ts")){if(declared[ts.name])return declared[ts.name];var m=new ModuleWrapper(ts);return used[ts.name]=m,declared[ts.name]=m,Object.keys(ts.imports).forEach(function(x){var pMod=ts.imports[x];if(used[pMod.name])return void(m.namespaceToMod[x]=used[pMod.name]);var vMod=processModule(pMod,u,used,declared);m.namespaceToMod[x]=vMod}),used[ts.name]=null,m}};exports.toDefSystem=toDefSystem;var processAnnotations=function(x,p,annotations){annotations||(annotations=x.annotations()),annotations.forEach(function(x){var nm=x.name.substring(x.name.lastIndexOf(".")+1);aHandlers.annotationHandlers[nm]||console.log("Can not find handler for:"),aHandlers.annotationHandlers[nm](x,p)})}},function(module,exports,__webpack_require__){"use strict";var Universes={Universe08:{GlobalSchema:{name:"GlobalSchema",properties:{key:{name:"key",range:"StringType",domain:"GlobalSchema"},value:{name:"value",range:"SchemaString",domain:"GlobalSchema"}}},Api:{name:"Api",properties:{title:{name:"title",range:"StringType",domain:"Api"},version:{name:"version",range:"StringType",domain:"Api"},baseUri:{name:"baseUri",range:"FullUriTemplateString",domain:"Api"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"Api"},uriParameters:{name:"uriParameters",range:"Parameter",domain:"Api"},protocols:{name:"protocols",range:"StringType",domain:"Api"},mediaType:{name:"mediaType",range:"MimeType",domain:"Api"},schemas:{name:"schemas",range:"GlobalSchema",domain:"Api"},traits:{name:"traits",range:"Trait",domain:"Api"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"Api"},securitySchemes:{name:"securitySchemes",range:"AbstractSecurityScheme",domain:"Api"},resourceTypes:{name:"resourceTypes",range:"ResourceType",domain:"Api"},resources:{name:"resources",range:"Resource",domain:"Api"},documentation:{name:"documentation",range:"DocumentationItem",domain:"Api"},RAMLVersion:{name:"RAMLVersion"}}},DocumentationItem:{name:"DocumentationItem",properties:{title:{name:"title",range:"StringType",domain:"DocumentationItem"},content:{name:"content",range:"MarkdownString",domain:"DocumentationItem"}}},ValueType:{name:"ValueType",properties:{}},StringType:{name:"StringType",properties:{}},AnyType:{name:"AnyType",properties:{}},NumberType:{name:"NumberType",properties:{}},BooleanType:{name:"BooleanType",properties:{}},Referencable:{name:"Referencable",properties:{}},Reference:{name:"Reference",properties:{structuredValue:{name:"structuredValue"},name:{name:"name"}}},DeclaresDynamicType:{name:"DeclaresDynamicType",properties:{}},UriTemplate:{name:"UriTemplate",properties:{}},RelativeUriString:{name:"RelativeUriString",properties:{}},FullUriTemplateString:{name:"FullUriTemplateString",properties:{}},FixedUri:{name:"FixedUri",properties:{}},MarkdownString:{name:"MarkdownString",properties:{}},SchemaString:{name:"SchemaString",properties:{}},JSonSchemaString:{name:"JSonSchemaString",properties:{}},XMLSchemaString:{name:"XMLSchemaString",properties:{}},ExampleString:{name:"ExampleString",properties:{}},StatusCodeString:{name:"StatusCodeString",properties:{}},JSONExample:{name:"JSONExample",properties:{}},XMLExample:{name:"XMLExample",properties:{}},TypeInstance:{name:"TypeInstance",properties:{properties:{name:"properties",range:"TypeInstanceProperty",domain:"TypeInstance"},isScalar:{name:"isScalar",range:"BooleanType",domain:"TypeInstance"},value:{name:"value",range:"AnyType",domain:"TypeInstance"}}},TypeInstanceProperty:{name:"TypeInstanceProperty",properties:{name:{name:"name",range:"StringType",domain:"TypeInstanceProperty"},value:{name:"value",range:"TypeInstance",domain:"TypeInstanceProperty"},values:{name:"values",range:"TypeInstance",domain:"TypeInstanceProperty"},isArray:{name:"isArray",range:"BooleanType",domain:"TypeInstanceProperty"}}},RAMLSimpleElement:{name:"RAMLSimpleElement",properties:{}},Parameter:{name:"Parameter",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},"default":{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"StringType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"}}},StringTypeDeclaration:{name:"StringTypeDeclaration",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},"default":{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"StringType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"},pattern:{name:"pattern",range:"StringType",domain:"StringTypeDeclaration"},"enum":{name:"enum",range:"StringType",domain:"StringTypeDeclaration"},minLength:{name:"minLength",range:"NumberType",domain:"StringTypeDeclaration"},maxLength:{name:"maxLength",range:"NumberType",domain:"StringTypeDeclaration"}}},BooleanTypeDeclaration:{name:"BooleanTypeDeclaration",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},"default":{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"StringType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"}}},NumberTypeDeclaration:{name:"NumberTypeDeclaration",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},"default":{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"StringType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"},minimum:{name:"minimum",range:"NumberType",domain:"NumberTypeDeclaration"},maximum:{name:"maximum",range:"NumberType",domain:"NumberTypeDeclaration"}}},IntegerTypeDeclaration:{name:"IntegerTypeDeclaration",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},"default":{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"StringType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"},minimum:{name:"minimum",range:"NumberType",domain:"NumberTypeDeclaration"},maximum:{name:"maximum",range:"NumberType",domain:"NumberTypeDeclaration"}}},DateTypeDeclaration:{name:"DateTypeDeclaration",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},"default":{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"StringType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"}}},FileTypeDeclaration:{name:"FileTypeDeclaration",properties:{name:{name:"name",range:"StringType",domain:"Parameter"},displayName:{name:"displayName",range:"StringType",domain:"Parameter"},type:{name:"type",range:"StringType",domain:"Parameter"},location:{name:"location",range:"ParameterLocation",domain:"Parameter"},required:{name:"required",range:"BooleanType",domain:"Parameter"},"default":{name:"default",range:"AnyType",domain:"Parameter"},example:{name:"example",range:"StringType",domain:"Parameter"},repeat:{name:"repeat",range:"BooleanType",domain:"Parameter"},description:{name:"description",range:"MarkdownString",domain:"Parameter"}}},ParameterLocation:{name:"ParameterLocation",properties:{}},MimeType:{name:"MimeType",properties:{}},BodyLike:{name:"BodyLike",properties:{name:{name:"name",range:"StringType",domain:"BodyLike"},schema:{name:"schema",range:"SchemaString",domain:"BodyLike"},example:{name:"example",range:"ExampleString",domain:"BodyLike"},formParameters:{name:"formParameters",range:"Parameter",domain:"BodyLike"},description:{name:"description",range:"MarkdownString",domain:"BodyLike"},schemaContent:{name:"schemaContent"}}},XMLBody:{name:"XMLBody",properties:{name:{name:"name",range:"StringType",domain:"BodyLike"},schema:{name:"schema",range:"XMLSchemaString",domain:"XMLBody"},example:{name:"example",range:"ExampleString",domain:"BodyLike"},formParameters:{name:"formParameters",range:"Parameter",domain:"BodyLike"},description:{name:"description",range:"MarkdownString",domain:"BodyLike"}}},JSONBody:{name:"JSONBody",properties:{name:{name:"name",range:"StringType",domain:"BodyLike"},schema:{name:"schema",range:"JSonSchemaString",domain:"JSONBody"},example:{name:"example",range:"ExampleString",domain:"BodyLike"},formParameters:{name:"formParameters",range:"Parameter",domain:"BodyLike"},description:{name:"description",range:"MarkdownString",domain:"BodyLike"}}},Response:{name:"Response",properties:{code:{name:"code",range:"StatusCodeString",domain:"Response"},headers:{name:"headers",range:"Parameter",domain:"Response"},body:{name:"body",range:"BodyLike",domain:"Response"},description:{name:"description",range:"MarkdownString",domain:"Response"}}},Resource:{name:"Resource",properties:{relativeUri:{name:"relativeUri",range:"RelativeUriString",domain:"Resource"},type:{name:"type",range:"ResourceTypeRef",domain:"Resource"},is:{name:"is",range:"TraitRef",domain:"Resource"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"Resource"},uriParameters:{name:"uriParameters",range:"Parameter",domain:"Resource"},methods:{name:"methods",range:"Method",domain:"Resource"},resources:{name:"resources",range:"Resource",domain:"Resource"},displayName:{name:"displayName",range:"StringType",domain:"Resource"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"Resource"},description:{name:"description",range:"MarkdownString",domain:"Resource"}}},ResourceTypeRef:{name:"ResourceTypeRef",properties:{resourceType:{name:"resourceType"}}},ResourceType:{name:"ResourceType",properties:{name:{name:"name",range:"StringType",domain:"ResourceType"},usage:{name:"usage",range:"StringType",domain:"ResourceType"},methods:{name:"methods",range:"Method",domain:"ResourceType"},is:{name:"is",range:"TraitRef",domain:"ResourceType"},type:{name:"type",range:"ResourceTypeRef",domain:"ResourceType"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"ResourceType"},uriParameters:{name:"uriParameters",range:"Parameter",domain:"ResourceType"},displayName:{name:"displayName",range:"StringType",domain:"ResourceType"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"ResourceType"},description:{name:"description",range:"MarkdownString",domain:"ResourceType"},parametrizedProperties:{name:"parametrizedProperties"}}},MethodBase:{name:"MethodBase",properties:{responses:{name:"responses",range:"Response",domain:"MethodBase"},body:{name:"body",range:"BodyLike",domain:"MethodBase"},protocols:{name:"protocols",range:"StringType",domain:"MethodBase"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"MethodBase"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"MethodBase"},queryParameters:{name:"queryParameters",range:"Parameter",domain:"MethodBase"},headers:{name:"headers",range:"Parameter",domain:"MethodBase"},description:{name:"description",range:"MarkdownString",domain:"MethodBase"}}},Method:{name:"Method",properties:{responses:{name:"responses",range:"Response",domain:"MethodBase"},body:{name:"body",range:"BodyLike",domain:"MethodBase"},protocols:{name:"protocols",range:"StringType",domain:"MethodBase"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"MethodBase"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"MethodBase"},queryParameters:{name:"queryParameters",range:"Parameter",domain:"MethodBase"},headers:{name:"headers",range:"Parameter",domain:"MethodBase"},description:{name:"description",range:"MarkdownString",domain:"MethodBase"},method:{name:"method",range:"StringType",domain:"Method"},is:{name:"is",range:"TraitRef",domain:"Method"}}},Trait:{name:"Trait",properties:{responses:{name:"responses",range:"Response",domain:"MethodBase"},body:{name:"body",range:"BodyLike",domain:"MethodBase"},protocols:{name:"protocols",range:"StringType",domain:"MethodBase"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"MethodBase"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"MethodBase"},queryParameters:{name:"queryParameters",range:"Parameter",domain:"MethodBase"},headers:{name:"headers",range:"Parameter",domain:"MethodBase"},description:{name:"description",range:"MarkdownString",domain:"MethodBase"},name:{name:"name",range:"StringType",domain:"Trait"},usage:{name:"usage",range:"StringType",domain:"Trait"},displayName:{name:"displayName",range:"StringType",domain:"Trait"},parametrizedProperties:{name:"parametrizedProperties"}}},TraitRef:{name:"TraitRef",properties:{trait:{name:"trait"}}},SecuritySchemePart:{name:"SecuritySchemePart",properties:{responses:{name:"responses",range:"Response",domain:"SecuritySchemePart"},body:{name:"body",range:"BodyLike",domain:"MethodBase"},protocols:{name:"protocols",range:"StringType",domain:"MethodBase"},securedBy:{name:"securedBy",range:"SecuritySchemeRef",domain:"MethodBase"},baseUriParameters:{name:"baseUriParameters",range:"Parameter",domain:"MethodBase"},queryParameters:{name:"queryParameters",range:"Parameter",domain:"SecuritySchemePart"},headers:{name:"headers",range:"Parameter",domain:"SecuritySchemePart"},description:{name:"description",range:"MarkdownString",domain:"SecuritySchemePart"},displayName:{name:"displayName",range:"StringType",domain:"SecuritySchemePart"},is:{name:"is",range:"TraitRef",domain:"SecuritySchemePart"}}},SecuritySchemeSettings:{name:"SecuritySchemeSettings",properties:{}},AbstractSecurityScheme:{name:"AbstractSecurityScheme",properties:{name:{name:"name",range:"StringType",domain:"AbstractSecurityScheme"},type:{name:"type",range:"StringType",domain:"AbstractSecurityScheme"},description:{name:"description",range:"MarkdownString",domain:"AbstractSecurityScheme"},describedBy:{name:"describedBy",range:"SecuritySchemePart",domain:"AbstractSecurityScheme"},settings:{name:"settings",range:"SecuritySchemeSettings",domain:"AbstractSecurityScheme"}}},SecuritySchemeRef:{name:"SecuritySchemeRef",properties:{securitySchemeName:{name:"securitySchemeName"},securityScheme:{name:"securityScheme"}}},OAuth1SecuritySchemeSettings:{name:"OAuth1SecuritySchemeSettings",properties:{requestTokenUri:{name:"requestTokenUri",range:"FixedUri",domain:"OAuth1SecuritySchemeSettings"},authorizationUri:{name:"authorizationUri",range:"FixedUri",domain:"OAuth1SecuritySchemeSettings"},tokenCredentialsUri:{name:"tokenCredentialsUri",range:"FixedUri",domain:"OAuth1SecuritySchemeSettings"}}},OAuth2SecuritySchemeSettings:{name:"OAuth2SecuritySchemeSettings",properties:{accessTokenUri:{name:"accessTokenUri",range:"FixedUri",domain:"OAuth2SecuritySchemeSettings"},authorizationUri:{name:"authorizationUri",range:"FixedUri",domain:"OAuth2SecuritySchemeSettings"},authorizationGrants:{name:"authorizationGrants",range:"StringType",domain:"OAuth2SecuritySchemeSettings"},scopes:{name:"scopes",range:"StringType",domain:"OAuth2SecuritySchemeSettings"}}},OAuth2SecurityScheme:{name:"OAuth2SecurityScheme",properties:{name:{name:"name",range:"StringType",domain:"AbstractSecurityScheme"},type:{name:"type",range:"StringType",domain:"AbstractSecurityScheme"},description:{name:"description",range:"MarkdownString",domain:"AbstractSecurityScheme"},describedBy:{name:"describedBy",range:"SecuritySchemePart",domain:"AbstractSecurityScheme"},settings:{name:"settings",range:"OAuth2SecuritySchemeSettings",domain:"OAuth2SecurityScheme"}}},OAuth1SecurityScheme:{name:"OAuth1SecurityScheme",properties:{name:{name:"name",range:"StringType",domain:"AbstractSecurityScheme"},type:{name:"type",range:"StringType",domain:"AbstractSecurityScheme"},description:{name:"description",range:"MarkdownString",domain:"AbstractSecurityScheme"},describedBy:{name:"describedBy",range:"SecuritySchemePart",domain:"AbstractSecurityScheme"},settings:{name:"settings",range:"OAuth1SecuritySchemeSettings",domain:"OAuth1SecurityScheme"}}},BasicSecurityScheme:{name:"BasicSecurityScheme",properties:{name:{name:"name",range:"StringType",domain:"AbstractSecurityScheme"},type:{name:"type",range:"StringType",domain:"AbstractSecurityScheme"},description:{name:"description",range:"MarkdownString",domain:"AbstractSecurityScheme"},describedBy:{name:"describedBy",range:"SecuritySchemePart",domain:"AbstractSecurityScheme"},settings:{name:"settings",range:"SecuritySchemeSettings",domain:"AbstractSecurityScheme"}}},DigestSecurityScheme:{name:"DigestSecurityScheme",properties:{name:{name:"name",range:"StringType",domain:"AbstractSecurityScheme"},type:{name:"type",range:"StringType",domain:"AbstractSecurityScheme"},description:{name:"description",range:"MarkdownString",domain:"AbstractSecurityScheme"},describedBy:{name:"describedBy",range:"SecuritySchemePart",domain:"AbstractSecurityScheme"
},settings:{name:"settings",range:"SecuritySchemeSettings",domain:"AbstractSecurityScheme"}}},CustomSecurityScheme:{name:"CustomSecurityScheme",properties:{name:{name:"name",range:"StringType",domain:"AbstractSecurityScheme"},type:{name:"type",range:"StringType",domain:"AbstractSecurityScheme"},description:{name:"description",range:"MarkdownString",domain:"AbstractSecurityScheme"},describedBy:{name:"describedBy",range:"SecuritySchemePart",domain:"AbstractSecurityScheme"},settings:{name:"settings",range:"SecuritySchemeSettings",domain:"AbstractSecurityScheme"}}}},Universe10:{Library:{name:"Library",properties:{annotations:{name:"annotations"},uses:{name:"uses"},schemas:{name:"schemas"},types:{name:"types"},traits:{name:"traits"},resourceTypes:{name:"resourceTypes"},annotationTypes:{name:"annotationTypes"},securitySchemes:{name:"securitySchemes"},usage:{name:"usage"},name:{name:"name"}}},LibraryBase:{name:"LibraryBase",properties:{annotations:{name:"annotations"},uses:{name:"uses"},schemas:{name:"schemas"},types:{name:"types"},traits:{name:"traits"},resourceTypes:{name:"resourceTypes"},annotationTypes:{name:"annotationTypes"},securitySchemes:{name:"securitySchemes"}}},Api:{name:"Api",properties:{annotations:{name:"annotations"},uses:{name:"uses"},schemas:{name:"schemas"},types:{name:"types"},traits:{name:"traits"},resourceTypes:{name:"resourceTypes"},annotationTypes:{name:"annotationTypes"},securitySchemes:{name:"securitySchemes"},title:{name:"title"},description:{name:"description"},version:{name:"version"},baseUri:{name:"baseUri"},baseUriParameters:{name:"baseUriParameters"},protocols:{name:"protocols"},mediaType:{name:"mediaType"},securedBy:{name:"securedBy"},resources:{name:"resources"},documentation:{name:"documentation"},RAMLVersion:{name:"RAMLVersion",range:"StringType",domain:"Api"}}},Overlay:{name:"Overlay",properties:{annotations:{name:"annotations"},uses:{name:"uses"},schemas:{name:"schemas"},types:{name:"types"},traits:{name:"traits"},resourceTypes:{name:"resourceTypes"},annotationTypes:{name:"annotationTypes"},securitySchemes:{name:"securitySchemes"},title:{name:"title"},description:{name:"description"},version:{name:"version"},baseUri:{name:"baseUri"},baseUriParameters:{name:"baseUriParameters"},protocols:{name:"protocols"},mediaType:{name:"mediaType"},securedBy:{name:"securedBy"},resources:{name:"resources"},documentation:{name:"documentation"},usage:{name:"usage"},"extends":{name:"extends"}}},Extension:{name:"Extension",properties:{annotations:{name:"annotations"},uses:{name:"uses"},schemas:{name:"schemas"},types:{name:"types"},traits:{name:"traits"},resourceTypes:{name:"resourceTypes"},annotationTypes:{name:"annotationTypes"},securitySchemes:{name:"securitySchemes"},title:{name:"title"},description:{name:"description"},version:{name:"version"},baseUri:{name:"baseUri"},baseUriParameters:{name:"baseUriParameters"},protocols:{name:"protocols"},mediaType:{name:"mediaType"},securedBy:{name:"securedBy"},resources:{name:"resources"},documentation:{name:"documentation"},usage:{name:"usage"},"extends":{name:"extends"}}},UsesDeclaration:{name:"UsesDeclaration",properties:{annotations:{name:"annotations"},key:{name:"key"},value:{name:"value"}}},FragmentDeclaration:{name:"FragmentDeclaration",properties:{annotations:{name:"annotations"},uses:{name:"uses"}}},DocumentationItem:{name:"DocumentationItem",properties:{annotations:{name:"annotations"},title:{name:"title"},content:{name:"content"}}},ValueType:{name:"ValueType",properties:{annotations:{name:"annotations"}}},StringType:{name:"StringType",properties:{annotations:{name:"annotations"}}},AnyType:{name:"AnyType",properties:{annotations:{name:"annotations"}}},NumberType:{name:"NumberType",properties:{annotations:{name:"annotations"}}},IntegerType:{name:"IntegerType",properties:{annotations:{name:"annotations"}}},NullType:{name:"NullType",properties:{annotations:{name:"annotations"}}},TimeOnlyType:{name:"TimeOnlyType",properties:{annotations:{name:"annotations"}}},DateOnlyType:{name:"DateOnlyType",properties:{annotations:{name:"annotations"}}},DateTimeOnlyType:{name:"DateTimeOnlyType",properties:{annotations:{name:"annotations"}}},DateTimeType:{name:"DateTimeType",properties:{annotations:{name:"annotations"}}},FileType:{name:"FileType",properties:{annotations:{name:"annotations"}}},BooleanType:{name:"BooleanType",properties:{annotations:{name:"annotations"}}},Reference:{name:"Reference",properties:{annotations:{name:"annotations"},structuredValue:{name:"structuredValue",range:"TypeInstance",domain:"Reference"},name:{name:"name",range:"StringType",domain:"Reference"}}},UriTemplate:{name:"UriTemplate",properties:{annotations:{name:"annotations"}}},StatusCodeString:{name:"StatusCodeString",properties:{annotations:{name:"annotations"}}},RelativeUriString:{name:"RelativeUriString",properties:{annotations:{name:"annotations"}}},FullUriTemplateString:{name:"FullUriTemplateString",properties:{annotations:{name:"annotations"}}},FixedUriString:{name:"FixedUriString",properties:{annotations:{name:"annotations"}}},ContentType:{name:"ContentType",properties:{annotations:{name:"annotations"}}},MarkdownString:{name:"MarkdownString",properties:{annotations:{name:"annotations"}}},SchemaString:{name:"SchemaString",properties:{annotations:{name:"annotations"}}},ExampleSpec:{name:"ExampleSpec",properties:{annotations:{name:"annotations"},value:{name:"value"},strict:{name:"strict"},name:{name:"name"},displayName:{name:"displayName"},description:{name:"description"},structuredValue:{name:"structuredValue",range:"TypeInstance",domain:"ExampleSpec"}}},TypeDeclaration:{name:"TypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},fixedFacets:{name:"fixedFacets",range:"TypeInstance",domain:"TypeDeclaration"},structuredType:{name:"structuredType",range:"TypeInstance",domain:"TypeDeclaration"},parametrizedProperties:{name:"parametrizedProperties",range:"TypeInstance",domain:"TypeDeclaration"}}},XMLFacetInfo:{name:"XMLFacetInfo",properties:{annotations:{name:"annotations"},attribute:{name:"attribute"},wrapped:{name:"wrapped"},name:{name:"name"},namespace:{name:"namespace"},prefix:{name:"prefix"}}},ArrayTypeDeclaration:{name:"ArrayTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},uniqueItems:{name:"uniqueItems"},items:{name:"items"},minItems:{name:"minItems"},maxItems:{name:"maxItems"}}},UnionTypeDeclaration:{name:"UnionTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"}}},ObjectTypeDeclaration:{name:"ObjectTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},properties:{name:"properties"},minProperties:{name:"minProperties"},maxProperties:{name:"maxProperties"},additionalProperties:{name:"additionalProperties"},discriminator:{name:"discriminator"},discriminatorValue:{name:"discriminatorValue"}}},StringTypeDeclaration:{name:"StringTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},pattern:{name:"pattern"},minLength:{name:"minLength"},maxLength:{name:"maxLength"},"enum":{name:"enum"}}},BooleanTypeDeclaration:{name:"BooleanTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"}}},NumberTypeDeclaration:{name:"NumberTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},minimum:{name:"minimum"},maximum:{name:"maximum"},"enum":{name:"enum"},format:{name:"format"},multipleOf:{name:"multipleOf"}}},IntegerTypeDeclaration:{name:"IntegerTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},minimum:{name:"minimum"},maximum:{name:"maximum"},"enum":{name:"enum"},format:{name:"format"},multipleOf:{name:"multipleOf"}}},DateOnlyTypeDeclaration:{name:"DateOnlyTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"}}},TimeOnlyTypeDeclaration:{name:"TimeOnlyTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"}}},DateTimeOnlyTypeDeclaration:{name:"DateTimeOnlyTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"}}},DateTimeTypeDeclaration:{name:"DateTimeTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},format:{name:"format"}}},TypeInstance:{name:"TypeInstance",properties:{properties:{name:"properties"},isScalar:{name:"isScalar"},value:{name:"value"},isArray:{name:"isArray"},items:{name:"items"}}},TypeInstanceProperty:{name:"TypeInstanceProperty",properties:{name:{name:"name"},value:{name:"value"},values:{name:"values"},isArray:{name:"isArray"}}},ModelLocation:{name:"ModelLocation",properties:{}},LocationKind:{name:"LocationKind",properties:{}},MimeType:{name:"MimeType",properties:{annotations:{name:"annotations"}}},Response:{name:"Response",properties:{annotations:{name:"annotations"},code:{name:"code"},headers:{name:"headers"},body:{name:"body"},description:{name:"description"}}},Annotable:{name:"Annotable",properties:{annotations:{name:"annotations"}}},AnnotationRef:{name:"AnnotationRef",properties:{annotations:{name:"annotations"},annotation:{name:"annotation",range:"TypeDeclaration",domain:"AnnotationRef"}}},AnnotationTarget:{name:"AnnotationTarget",properties:{annotations:{name:"annotations"}}},TraitRef:{name:"TraitRef",properties:{annotations:{name:"annotations"},trait:{name:"trait",range:"Trait",domain:"TraitRef"}}},Trait:{name:"Trait",properties:{annotations:{name:"annotations"},queryParameters:{name:"queryParameters"},headers:{name:"headers"},queryString:{name:"queryString"},responses:{name:"responses"},body:{name:"body"},protocols:{name:"protocols"},is:{name:"is"},securedBy:{name:"securedBy"},description:{name:"description"},displayName:{name:"displayName"},name:{name:"name"},usage:{name:"usage"},parametrizedProperties:{name:"parametrizedProperties",range:"TypeInstance",domain:"Trait"}}},MethodBase:{name:"MethodBase",properties:{annotations:{name:"annotations"},queryParameters:{name:"queryParameters"},headers:{name:"headers"},queryString:{name:"queryString"},responses:{name:"responses"},body:{name:"body"},protocols:{name:"protocols"},is:{name:"is"},securedBy:{name:"securedBy"},description:{name:"description"},displayName:{name:"displayName"}}},Method:{name:"Method",properties:{annotations:{name:"annotations"},queryParameters:{name:"queryParameters"},headers:{name:"headers"},queryString:{name:"queryString"},responses:{name:"responses"},body:{name:"body"},protocols:{name:"protocols"},is:{name:"is"},securedBy:{name:"securedBy"},description:{name:"description"},displayName:{name:"displayName"},method:{name:"method"},parametrizedProperties:{name:"parametrizedProperties",range:"TypeInstance",domain:"Method"}}},Operation:{name:"Operation",properties:{annotations:{name:"annotations"},queryParameters:{name:"queryParameters"},headers:{name:"headers"},queryString:{name:"queryString"},responses:{name:"responses"}}},SecuritySchemePart:{name:"SecuritySchemePart",properties:{annotations:{name:"annotations"},queryParameters:{name:"queryParameters"},headers:{name:"headers"},queryString:{name:"queryString"},responses:{name:"responses"}}},SecuritySchemeSettings:{name:"SecuritySchemeSettings",properties:{annotations:{name:"annotations"}}},OAuth1SecuritySchemeSettings:{name:"OAuth1SecuritySchemeSettings",properties:{annotations:{name:"annotations"},requestTokenUri:{name:"requestTokenUri"},authorizationUri:{name:"authorizationUri"},tokenCredentialsUri:{name:"tokenCredentialsUri"},signatures:{name:"signatures"}}},OAuth2SecuritySchemeSettings:{name:"OAuth2SecuritySchemeSettings",properties:{annotations:{name:"annotations"},accessTokenUri:{name:"accessTokenUri"},authorizationUri:{name:"authorizationUri"},authorizationGrants:{name:"authorizationGrants"},scopes:{name:"scopes"}}},SecuritySchemeRef:{name:"SecuritySchemeRef",properties:{annotations:{name:"annotations"},securitySchemeName:{name:"securitySchemeName",range:"StringType",domain:"SecuritySchemeRef"},securityScheme:{name:"securityScheme",range:"AbstractSecurityScheme",domain:"SecuritySchemeRef"}}},AbstractSecurityScheme:{name:"AbstractSecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},OAuth2SecurityScheme:{name:"OAuth2SecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},OAuth1SecurityScheme:{name:"OAuth1SecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},PassThroughSecurityScheme:{name:"PassThroughSecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},BasicSecurityScheme:{name:"BasicSecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},DigestSecurityScheme:{name:"DigestSecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},CustomSecurityScheme:{name:"CustomSecurityScheme",properties:{annotations:{name:"annotations"},name:{name:"name"},type:{name:"type"},description:{name:"description"},describedBy:{name:"describedBy"},displayName:{name:"displayName"},settings:{name:"settings"}}},ResourceTypeRef:{name:"ResourceTypeRef",properties:{annotations:{name:"annotations"},resourceType:{name:"resourceType",range:"ResourceType",domain:"ResourceTypeRef"}}},ResourceType:{name:"ResourceType",properties:{annotations:{name:"annotations"},methods:{name:"methods"},is:{name:"is"},type:{name:"type"},description:{name:"description"},securedBy:{name:"securedBy"},uriParameters:{name:"uriParameters"},displayName:{name:"displayName"},name:{name:"name"},usage:{name:"usage"},parametrizedProperties:{name:"parametrizedProperties",range:"TypeInstance",domain:"ResourceType"}}},ResourceBase:{name:"ResourceBase",properties:{annotations:{name:"annotations"},methods:{name:"methods"},is:{name:"is"},type:{name:"type"},description:{name:"description"},securedBy:{name:"securedBy"},uriParameters:{name:"uriParameters"}}},Resource:{name:"Resource",properties:{annotations:{name:"annotations"},methods:{name:"methods"},is:{name:"is"},type:{name:"type"},description:{name:"description"},securedBy:{name:"securedBy"},uriParameters:{name:"uriParameters"},relativeUri:{name:"relativeUri"},displayName:{name:"displayName"},resources:{name:"resources"}}},FileTypeDeclaration:{name:"FileTypeDeclaration",properties:{annotations:{name:"annotations"},name:{name:"name"},displayName:{name:"displayName"},facets:{name:"facets"},schema:{name:"schema"},type:{name:"type"},location:{name:"location"},locationKind:{name:"locationKind"},"default":{name:"default"},example:{name:"example"},examples:{name:"examples"},required:{name:"required"},description:{name:"description"},xml:{name:"xml"},allowedTargets:{name:"allowedTargets"},isAnnotation:{name:"isAnnotation"},fileTypes:{name:"fileTypes"},minLength:{name:"minLength"},maxLength:{name:"maxLength"}}}}};module.exports=Universes},function(module,exports,__webpack_require__){function drainQueue(){if(!draining){draining=!0;for(var currentQueue,len=queue.length;len;){currentQueue=queue,queue=[];for(var i=-1;++i<len;)currentQueue[i]();len=queue.length}draining=!1}}function noop(){}var process=module.exports={},queue=[],draining=!1;process.nextTick=function(fun){queue.push(fun),draining||setTimeout(drainQueue,0)},process.title="browser",process.browser=!0,process.env={},process.argv=[],process.version="",process.versions={},process.on=noop,process.addListener=noop,process.once=noop,process.off=noop,process.removeListener=noop,process.removeAllListeners=noop,process.emit=noop,process.binding=function(name){throw new Error("process.binding is not supported")},process.cwd=function(){return"/"},process.chdir=function(dir){throw new Error("process.chdir is not supported")},process.umask=function(){return 0}},function(module,exports,__webpack_require__){exports.XMLHttpRequest=XMLHttpRequest},function(module,exports,__webpack_require__){var json="undefined"!=typeof JSON?JSON:__webpack_require__(106);module.exports=function(obj,opts){opts||(opts={}),"function"==typeof opts&&(opts={cmp:opts});var space=opts.space||"";"number"==typeof space&&(space=Array(space+1).join(" "));var cycles="boolean"==typeof opts.cycles?opts.cycles:!1,replacer=opts.replacer||function(key,value){return value},cmp=opts.cmp&&function(f){return function(node){return function(a,b){var aobj={key:a,value:node[a]},bobj={key:b,value:node[b]};return f(aobj,bobj)}}}(opts.cmp),seen=[];return function stringify(parent,key,node,level){var indent=space?"\n"+new Array(level+1).join(space):"",colonSeparator=space?": ":":";if(node&&node.toJSON&&"function"==typeof node.toJSON&&(node=node.toJSON()),node=replacer.call(parent,key,node),void 0!==node){if("object"!=typeof node||null===node)return json.stringify(node);if(isArray(node)){for(var out=[],i=0;i<node.length;i++){var item=stringify(node,i,node[i],level+1)||json.stringify(null);out.push(indent+space+item)}return"["+out.join(",")+indent+"]"}if(-1!==seen.indexOf(node)){if(cycles)return json.stringify("__cycle__");throw new TypeError("Converting circular structure to JSON")}seen.push(node);for(var keys=objectKeys(node).sort(cmp&&cmp(node)),out=[],i=0;i<keys.length;i++){var key=keys[i],value=stringify(node,key,node[key],level+1);if(value){var keyValue=json.stringify(key)+colonSeparator+value;out.push(indent+space+keyValue)}}return seen.splice(seen.indexOf(node),1),"{"+out.join(",")+indent+"}"}}({"":obj},"",obj,0)};var isArray=Array.isArray||function(x){return"[object Array]"==={}.toString.call(x)},objectKeys=Object.keys||function(obj){var has=Object.prototype.hasOwnProperty||function(){return!0},keys=[];for(var key in obj)has.call(obj,key)&&keys.push(key);return keys}},function(module,exports,__webpack_require__){function format(obj){if(!obj||"object"!=typeof obj)throw new TypeError("argument obj is required");var parameters=obj.parameters,subtype=obj.subtype,suffix=obj.suffix,type=obj.type;if(!type||!typeNameRegExp.test(type))throw new TypeError("invalid type");if(!subtype||!subtypeNameRegExp.test(subtype))throw new TypeError("invalid subtype");var string=type+"/"+subtype;if(suffix){if(!typeNameRegExp.test(suffix))throw new TypeError("invalid suffix");string+="+"+suffix}if(parameters&&"object"==typeof parameters)for(var param,params=Object.keys(parameters).sort(),i=0;i<params.length;i++){if(param=params[i],!tokenRegExp.test(param))throw new TypeError("invalid parameter name");string+="; "+param+"="+qstring(parameters[param])}return string}function parse(string){if(!string)throw new TypeError("argument string is required");if("object"==typeof string&&(string=getcontenttype(string)),"string"!=typeof string)throw new TypeError("argument string is required to be a string");var key,match,value,index=string.indexOf(";"),type=-1!==index?string.substr(0,index):string,obj=splitType(type),params={};for(paramRegExp.lastIndex=index;match=paramRegExp.exec(string);){if(match.index!==index)throw new TypeError("invalid parameter format");index+=match[0].length,key=match[1].toLowerCase(),value=match[2],'"'===value[0]&&(value=value.substr(1,value.length-2).replace(qescRegExp,"$1")),params[key]=value}if(-1!==index&&index!==string.length)throw new TypeError("invalid parameter format");return obj.parameters=params,obj}function getcontenttype(obj){return"function"==typeof obj.getHeader?obj.getHeader("content-type"):"object"==typeof obj.headers?obj.headers&&obj.headers["content-type"]:void 0}function qstring(val){var str=String(val);if(tokenRegExp.test(str))return str;if(str.length>0&&!textRegExp.test(str))throw new TypeError("invalid parameter value");return'"'+str.replace(quoteRegExp,"\\$1")+'"'}function splitType(string){var match=typeRegExp.exec(string.toLowerCase());if(!match)throw new TypeError("invalid media type");var suffix,type=match[1],subtype=match[2],index=subtype.lastIndexOf("+");-1!==index&&(suffix=subtype.substr(index+1),subtype=subtype.substr(0,index));var obj={type:type,subtype:subtype,suffix:suffix};return obj}var paramRegExp=/; *([!#$%&'\*\+\-\.0-9A-Z\^_`a-z\|~]+) *= *("(?:[ !\u0023-\u005b\u005d-\u007e\u0080-\u00ff]|\\[\u0020-\u007e])*"|[!#$%&'\*\+\-\.0-9A-Z\^_`a-z\|~]+) */g,textRegExp=/^[\u0020-\u007e\u0080-\u00ff]+$/,tokenRegExp=/^[!#$%&'\*\+\-\.0-9A-Z\^_`a-z\|~]+$/,qescRegExp=/\\([\u0000-\u007f])/g,quoteRegExp=/([\\"])/g,subtypeNameRegExp=/^[A-Za-z0-9][A-Za-z0-9!#$&^_.-]{0,126}$/,typeNameRegExp=/^[A-Za-z0-9][A-Za-z0-9!#$&^_-]{0,126}$/,typeRegExp=/^ *([A-Za-z0-9][A-Za-z0-9!#$&^_-]{0,126})\/([A-Za-z0-9][A-Za-z0-9!#$&^_.+-]{0,126}) *$/;exports.format=format,exports.parse=parse},function(module,exports,__webpack_require__){"use strict";function Response(statusCode,headers,body,url){if("number"!=typeof statusCode)throw new TypeError("statusCode must be a number but was "+typeof statusCode);if(null===headers)throw new TypeError("headers cannot be null");if("object"!=typeof headers)throw new TypeError("headers must be an object but was "+typeof headers);this.statusCode=statusCode,this.headers={};for(var key in headers)this.headers[key.toLowerCase()]=headers[key];this.body=body,this.url=url}module.exports=Response,Response.prototype.getBody=function(encoding){if(this.statusCode>=300){var err=new Error("Server responded with status code "+this.statusCode+":\n"+this.body.toString());throw err.statusCode=this.statusCode,err.headers=this.headers,err.body=this.body,err.url=this.url,err}return encoding?this.body.toString(encoding):this.body}},function(module,exports,__webpack_require__){(function(Buffer){function ConcatStream(opts,cb){if(!(this instanceof ConcatStream))return new ConcatStream(opts,cb);"function"==typeof opts&&(cb=opts,opts={}),opts||(opts={});var encoding=opts.encoding,shouldInferEncoding=!1;encoding?(encoding=String(encoding).toLowerCase(),("u8"===encoding||"uint8"===encoding)&&(encoding="uint8array")):shouldInferEncoding=!0,Writable.call(this,{objectMode:!0}),this.encoding=encoding,this.shouldInferEncoding=shouldInferEncoding,cb&&this.on("finish",function(){cb(this.getBody())}),this.body=[]}function isArrayish(arr){return/Array\]$/.test(Object.prototype.toString.call(arr))}function stringConcat(parts){for(var strings=[],i=0;i<parts.length;i++){var p=parts[i];"string"==typeof p?strings.push(p):Buffer.isBuffer(p)?strings.push(p):strings.push(Buffer(p))}return Buffer.isBuffer(parts[0])?(strings=Buffer.concat(strings),strings=strings.toString("utf8")):strings=strings.join(""),strings}function bufferConcat(parts){for(var bufs=[],i=0;i<parts.length;i++){var p=parts[i];Buffer.isBuffer(p)?bufs.push(p):"string"==typeof p||isArrayish(p)||p&&"function"==typeof p.subarray?bufs.push(Buffer(p)):bufs.push(Buffer(String(p)))}return Buffer.concat(bufs)}function arrayConcat(parts){for(var res=[],i=0;i<parts.length;i++)res.push.apply(res,parts[i]);return res}function u8Concat(parts){for(var len=0,i=0;i<parts.length;i++)"string"==typeof parts[i]&&(parts[i]=Buffer(parts[i])),len+=parts[i].length;for(var u8=new U8(len),i=0,offset=0;i<parts.length;i++)for(var part=parts[i],j=0;j<part.length;j++)u8[offset++]=part[j];return u8}var Writable=__webpack_require__(109).Writable,inherits=__webpack_require__(110);if("undefined"==typeof Uint8Array)var U8=__webpack_require__(107).Uint8Array;else var U8=Uint8Array;module.exports=ConcatStream,inherits(ConcatStream,Writable),ConcatStream.prototype._write=function(chunk,enc,next){this.body.push(chunk),next()},ConcatStream.prototype.inferEncoding=function(buff){var firstBuffer=void 0===buff?this.body[0]:buff;return Buffer.isBuffer(firstBuffer)?"buffer":"undefined"!=typeof Uint8Array&&firstBuffer instanceof Uint8Array?"uint8array":Array.isArray(firstBuffer)?"array":"string"==typeof firstBuffer?"string":"[object Object]"===Object.prototype.toString.call(firstBuffer)?"object":"buffer"},ConcatStream.prototype.getBody=function(){return this.encoding||0!==this.body.length?(this.shouldInferEncoding&&(this.encoding=this.inferEncoding()),"array"===this.encoding?arrayConcat(this.body):"string"===this.encoding?stringConcat(this.body):"buffer"===this.encoding?bufferConcat(this.body):"uint8array"===this.encoding?u8Concat(this.body):this.body):[]};Array.isArray||function(arr){return"[object Array]"==Object.prototype.toString.call(arr)}}).call(exports,__webpack_require__(92).Buffer)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;(function(){function createReduce(dir){function iterator(obj,iteratee,memo,keys,index,length){for(;index>=0&&length>index;index+=dir){var currentKey=keys?keys[index]:index;memo=iteratee(memo,obj[currentKey],currentKey,obj)}return memo}return function(obj,iteratee,memo,context){iteratee=optimizeCb(iteratee,context,4);var keys=!isArrayLike(obj)&&_.keys(obj),length=(keys||obj).length,index=dir>0?0:length-1;return arguments.length<3&&(memo=obj[keys?keys[index]:index],index+=dir),iterator(obj,iteratee,memo,keys,index,length)}}function createPredicateIndexFinder(dir){return function(array,predicate,context){predicate=cb(predicate,context);for(var length=getLength(array),index=dir>0?0:length-1;index>=0&&length>index;index+=dir)if(predicate(array[index],index,array))return index;return-1}}function createIndexFinder(dir,predicateFind,sortedIndex){return function(array,item,idx){var i=0,length=getLength(array);if("number"==typeof idx)dir>0?i=idx>=0?idx:Math.max(idx+length,i):length=idx>=0?Math.min(idx+1,length):idx+length+1;else if(sortedIndex&&idx&&length)return idx=sortedIndex(array,item),array[idx]===item?idx:-1;if(item!==item)return idx=predicateFind(slice.call(array,i,length),_.isNaN),idx>=0?idx+i:-1;for(idx=dir>0?i:length-1;idx>=0&&length>idx;idx+=dir)if(array[idx]===item)return idx;return-1}}function collectNonEnumProps(obj,keys){var nonEnumIdx=nonEnumerableProps.length,constructor=obj.constructor,proto=_.isFunction(constructor)&&constructor.prototype||ObjProto,prop="constructor";for(_.has(obj,prop)&&!_.contains(keys,prop)&&keys.push(prop);nonEnumIdx--;)prop=nonEnumerableProps[nonEnumIdx],prop in obj&&obj[prop]!==proto[prop]&&!_.contains(keys,prop)&&keys.push(prop)}var root=this,previousUnderscore=root._,ArrayProto=Array.prototype,ObjProto=Object.prototype,FuncProto=Function.prototype,push=ArrayProto.push,slice=ArrayProto.slice,toString=ObjProto.toString,hasOwnProperty=ObjProto.hasOwnProperty,nativeIsArray=Array.isArray,nativeKeys=Object.keys,nativeBind=FuncProto.bind,nativeCreate=Object.create,Ctor=function(){},_=function(obj){return obj instanceof _?obj:this instanceof _?void(this._wrapped=obj):new _(obj)};"undefined"!=typeof module&&module.exports&&(exports=module.exports=_),exports._=_,_.VERSION="1.8.3";var optimizeCb=function(func,context,argCount){
if(void 0===context)return func;switch(null==argCount?3:argCount){case 1:return function(value){return func.call(context,value)};case 2:return function(value,other){return func.call(context,value,other)};case 3:return function(value,index,collection){return func.call(context,value,index,collection)};case 4:return function(accumulator,value,index,collection){return func.call(context,accumulator,value,index,collection)}}return function(){return func.apply(context,arguments)}},cb=function(value,context,argCount){return null==value?_.identity:_.isFunction(value)?optimizeCb(value,context,argCount):_.isObject(value)?_.matcher(value):_.property(value)};_.iteratee=function(value,context){return cb(value,context,1/0)};var createAssigner=function(keysFunc,undefinedOnly){return function(obj){var length=arguments.length;if(2>length||null==obj)return obj;for(var index=1;length>index;index++)for(var source=arguments[index],keys=keysFunc(source),l=keys.length,i=0;l>i;i++){var key=keys[i];undefinedOnly&&void 0!==obj[key]||(obj[key]=source[key])}return obj}},baseCreate=function(prototype){if(!_.isObject(prototype))return{};if(nativeCreate)return nativeCreate(prototype);Ctor.prototype=prototype;var result=new Ctor;return Ctor.prototype=null,result},property=function(key){return function(obj){return null==obj?void 0:obj[key]}},MAX_ARRAY_INDEX=Math.pow(2,53)-1,getLength=property("length"),isArrayLike=function(collection){var length=getLength(collection);return"number"==typeof length&&length>=0&&MAX_ARRAY_INDEX>=length};_.each=_.forEach=function(obj,iteratee,context){iteratee=optimizeCb(iteratee,context);var i,length;if(isArrayLike(obj))for(i=0,length=obj.length;length>i;i++)iteratee(obj[i],i,obj);else{var keys=_.keys(obj);for(i=0,length=keys.length;length>i;i++)iteratee(obj[keys[i]],keys[i],obj)}return obj},_.map=_.collect=function(obj,iteratee,context){iteratee=cb(iteratee,context);for(var keys=!isArrayLike(obj)&&_.keys(obj),length=(keys||obj).length,results=Array(length),index=0;length>index;index++){var currentKey=keys?keys[index]:index;results[index]=iteratee(obj[currentKey],currentKey,obj)}return results},_.reduce=_.foldl=_.inject=createReduce(1),_.reduceRight=_.foldr=createReduce(-1),_.find=_.detect=function(obj,predicate,context){var key;return key=isArrayLike(obj)?_.findIndex(obj,predicate,context):_.findKey(obj,predicate,context),void 0!==key&&-1!==key?obj[key]:void 0},_.filter=_.select=function(obj,predicate,context){var results=[];return predicate=cb(predicate,context),_.each(obj,function(value,index,list){predicate(value,index,list)&&results.push(value)}),results},_.reject=function(obj,predicate,context){return _.filter(obj,_.negate(cb(predicate)),context)},_.every=_.all=function(obj,predicate,context){predicate=cb(predicate,context);for(var keys=!isArrayLike(obj)&&_.keys(obj),length=(keys||obj).length,index=0;length>index;index++){var currentKey=keys?keys[index]:index;if(!predicate(obj[currentKey],currentKey,obj))return!1}return!0},_.some=_.any=function(obj,predicate,context){predicate=cb(predicate,context);for(var keys=!isArrayLike(obj)&&_.keys(obj),length=(keys||obj).length,index=0;length>index;index++){var currentKey=keys?keys[index]:index;if(predicate(obj[currentKey],currentKey,obj))return!0}return!1},_.contains=_.includes=_.include=function(obj,item,fromIndex,guard){return isArrayLike(obj)||(obj=_.values(obj)),("number"!=typeof fromIndex||guard)&&(fromIndex=0),_.indexOf(obj,item,fromIndex)>=0},_.invoke=function(obj,method){var args=slice.call(arguments,2),isFunc=_.isFunction(method);return _.map(obj,function(value){var func=isFunc?method:value[method];return null==func?func:func.apply(value,args)})},_.pluck=function(obj,key){return _.map(obj,_.property(key))},_.where=function(obj,attrs){return _.filter(obj,_.matcher(attrs))},_.findWhere=function(obj,attrs){return _.find(obj,_.matcher(attrs))},_.max=function(obj,iteratee,context){var value,computed,result=-(1/0),lastComputed=-(1/0);if(null==iteratee&&null!=obj){obj=isArrayLike(obj)?obj:_.values(obj);for(var i=0,length=obj.length;length>i;i++)value=obj[i],value>result&&(result=value)}else iteratee=cb(iteratee,context),_.each(obj,function(value,index,list){computed=iteratee(value,index,list),(computed>lastComputed||computed===-(1/0)&&result===-(1/0))&&(result=value,lastComputed=computed)});return result},_.min=function(obj,iteratee,context){var value,computed,result=1/0,lastComputed=1/0;if(null==iteratee&&null!=obj){obj=isArrayLike(obj)?obj:_.values(obj);for(var i=0,length=obj.length;length>i;i++)value=obj[i],result>value&&(result=value)}else iteratee=cb(iteratee,context),_.each(obj,function(value,index,list){computed=iteratee(value,index,list),(lastComputed>computed||computed===1/0&&result===1/0)&&(result=value,lastComputed=computed)});return result},_.shuffle=function(obj){for(var rand,set=isArrayLike(obj)?obj:_.values(obj),length=set.length,shuffled=Array(length),index=0;length>index;index++)rand=_.random(0,index),rand!==index&&(shuffled[index]=shuffled[rand]),shuffled[rand]=set[index];return shuffled},_.sample=function(obj,n,guard){return null==n||guard?(isArrayLike(obj)||(obj=_.values(obj)),obj[_.random(obj.length-1)]):_.shuffle(obj).slice(0,Math.max(0,n))},_.sortBy=function(obj,iteratee,context){return iteratee=cb(iteratee,context),_.pluck(_.map(obj,function(value,index,list){return{value:value,index:index,criteria:iteratee(value,index,list)}}).sort(function(left,right){var a=left.criteria,b=right.criteria;if(a!==b){if(a>b||void 0===a)return 1;if(b>a||void 0===b)return-1}return left.index-right.index}),"value")};var group=function(behavior){return function(obj,iteratee,context){var result={};return iteratee=cb(iteratee,context),_.each(obj,function(value,index){var key=iteratee(value,index,obj);behavior(result,value,key)}),result}};_.groupBy=group(function(result,value,key){_.has(result,key)?result[key].push(value):result[key]=[value]}),_.indexBy=group(function(result,value,key){result[key]=value}),_.countBy=group(function(result,value,key){_.has(result,key)?result[key]++:result[key]=1}),_.toArray=function(obj){return obj?_.isArray(obj)?slice.call(obj):isArrayLike(obj)?_.map(obj,_.identity):_.values(obj):[]},_.size=function(obj){return null==obj?0:isArrayLike(obj)?obj.length:_.keys(obj).length},_.partition=function(obj,predicate,context){predicate=cb(predicate,context);var pass=[],fail=[];return _.each(obj,function(value,key,obj){(predicate(value,key,obj)?pass:fail).push(value)}),[pass,fail]},_.first=_.head=_.take=function(array,n,guard){return null==array?void 0:null==n||guard?array[0]:_.initial(array,array.length-n)},_.initial=function(array,n,guard){return slice.call(array,0,Math.max(0,array.length-(null==n||guard?1:n)))},_.last=function(array,n,guard){return null==array?void 0:null==n||guard?array[array.length-1]:_.rest(array,Math.max(0,array.length-n))},_.rest=_.tail=_.drop=function(array,n,guard){return slice.call(array,null==n||guard?1:n)},_.compact=function(array){return _.filter(array,_.identity)};var flatten=function(input,shallow,strict,startIndex){for(var output=[],idx=0,i=startIndex||0,length=getLength(input);length>i;i++){var value=input[i];if(isArrayLike(value)&&(_.isArray(value)||_.isArguments(value))){shallow||(value=flatten(value,shallow,strict));var j=0,len=value.length;for(output.length+=len;len>j;)output[idx++]=value[j++]}else strict||(output[idx++]=value)}return output};_.flatten=function(array,shallow){return flatten(array,shallow,!1)},_.without=function(array){return _.difference(array,slice.call(arguments,1))},_.uniq=_.unique=function(array,isSorted,iteratee,context){_.isBoolean(isSorted)||(context=iteratee,iteratee=isSorted,isSorted=!1),null!=iteratee&&(iteratee=cb(iteratee,context));for(var result=[],seen=[],i=0,length=getLength(array);length>i;i++){var value=array[i],computed=iteratee?iteratee(value,i,array):value;isSorted?(i&&seen===computed||result.push(value),seen=computed):iteratee?_.contains(seen,computed)||(seen.push(computed),result.push(value)):_.contains(result,value)||result.push(value)}return result},_.union=function(){return _.uniq(flatten(arguments,!0,!0))},_.intersection=function(array){for(var result=[],argsLength=arguments.length,i=0,length=getLength(array);length>i;i++){var item=array[i];if(!_.contains(result,item)){for(var j=1;argsLength>j&&_.contains(arguments[j],item);j++);j===argsLength&&result.push(item)}}return result},_.difference=function(array){var rest=flatten(arguments,!0,!0,1);return _.filter(array,function(value){return!_.contains(rest,value)})},_.zip=function(){return _.unzip(arguments)},_.unzip=function(array){for(var length=array&&_.max(array,getLength).length||0,result=Array(length),index=0;length>index;index++)result[index]=_.pluck(array,index);return result},_.object=function(list,values){for(var result={},i=0,length=getLength(list);length>i;i++)values?result[list[i]]=values[i]:result[list[i][0]]=list[i][1];return result},_.findIndex=createPredicateIndexFinder(1),_.findLastIndex=createPredicateIndexFinder(-1),_.sortedIndex=function(array,obj,iteratee,context){iteratee=cb(iteratee,context,1);for(var value=iteratee(obj),low=0,high=getLength(array);high>low;){var mid=Math.floor((low+high)/2);iteratee(array[mid])<value?low=mid+1:high=mid}return low},_.indexOf=createIndexFinder(1,_.findIndex,_.sortedIndex),_.lastIndexOf=createIndexFinder(-1,_.findLastIndex),_.range=function(start,stop,step){null==stop&&(stop=start||0,start=0),step=step||1;for(var length=Math.max(Math.ceil((stop-start)/step),0),range=Array(length),idx=0;length>idx;idx++,start+=step)range[idx]=start;return range};var executeBound=function(sourceFunc,boundFunc,context,callingContext,args){if(!(callingContext instanceof boundFunc))return sourceFunc.apply(context,args);var self=baseCreate(sourceFunc.prototype),result=sourceFunc.apply(self,args);return _.isObject(result)?result:self};_.bind=function(func,context){if(nativeBind&&func.bind===nativeBind)return nativeBind.apply(func,slice.call(arguments,1));if(!_.isFunction(func))throw new TypeError("Bind must be called on a function");var args=slice.call(arguments,2),bound=function(){return executeBound(func,bound,context,this,args.concat(slice.call(arguments)))};return bound},_.partial=function(func){var boundArgs=slice.call(arguments,1),bound=function(){for(var position=0,length=boundArgs.length,args=Array(length),i=0;length>i;i++)args[i]=boundArgs[i]===_?arguments[position++]:boundArgs[i];for(;position<arguments.length;)args.push(arguments[position++]);return executeBound(func,bound,this,this,args)};return bound},_.bindAll=function(obj){var i,key,length=arguments.length;if(1>=length)throw new Error("bindAll must be passed function names");for(i=1;length>i;i++)key=arguments[i],obj[key]=_.bind(obj[key],obj);return obj},_.memoize=function(func,hasher){var memoize=function(key){var cache=memoize.cache,address=""+(hasher?hasher.apply(this,arguments):key);return _.has(cache,address)||(cache[address]=func.apply(this,arguments)),cache[address]};return memoize.cache={},memoize},_.delay=function(func,wait){var args=slice.call(arguments,2);return setTimeout(function(){return func.apply(null,args)},wait)},_.defer=_.partial(_.delay,_,1),_.throttle=function(func,wait,options){var context,args,result,timeout=null,previous=0;options||(options={});var later=function(){previous=options.leading===!1?0:_.now(),timeout=null,result=func.apply(context,args),timeout||(context=args=null)};return function(){var now=_.now();previous||options.leading!==!1||(previous=now);var remaining=wait-(now-previous);return context=this,args=arguments,0>=remaining||remaining>wait?(timeout&&(clearTimeout(timeout),timeout=null),previous=now,result=func.apply(context,args),timeout||(context=args=null)):timeout||options.trailing===!1||(timeout=setTimeout(later,remaining)),result}},_.debounce=function(func,wait,immediate){var timeout,args,context,timestamp,result,later=function(){var last=_.now()-timestamp;wait>last&&last>=0?timeout=setTimeout(later,wait-last):(timeout=null,immediate||(result=func.apply(context,args),timeout||(context=args=null)))};return function(){context=this,args=arguments,timestamp=_.now();var callNow=immediate&&!timeout;return timeout||(timeout=setTimeout(later,wait)),callNow&&(result=func.apply(context,args),context=args=null),result}},_.wrap=function(func,wrapper){return _.partial(wrapper,func)},_.negate=function(predicate){return function(){return!predicate.apply(this,arguments)}},_.compose=function(){var args=arguments,start=args.length-1;return function(){for(var i=start,result=args[start].apply(this,arguments);i--;)result=args[i].call(this,result);return result}},_.after=function(times,func){return function(){return--times<1?func.apply(this,arguments):void 0}},_.before=function(times,func){var memo;return function(){return--times>0&&(memo=func.apply(this,arguments)),1>=times&&(func=null),memo}},_.once=_.partial(_.before,2);var hasEnumBug=!{toString:null}.propertyIsEnumerable("toString"),nonEnumerableProps=["valueOf","isPrototypeOf","toString","propertyIsEnumerable","hasOwnProperty","toLocaleString"];_.keys=function(obj){if(!_.isObject(obj))return[];if(nativeKeys)return nativeKeys(obj);var keys=[];for(var key in obj)_.has(obj,key)&&keys.push(key);return hasEnumBug&&collectNonEnumProps(obj,keys),keys},_.allKeys=function(obj){if(!_.isObject(obj))return[];var keys=[];for(var key in obj)keys.push(key);return hasEnumBug&&collectNonEnumProps(obj,keys),keys},_.values=function(obj){for(var keys=_.keys(obj),length=keys.length,values=Array(length),i=0;length>i;i++)values[i]=obj[keys[i]];return values},_.mapObject=function(obj,iteratee,context){iteratee=cb(iteratee,context);for(var currentKey,keys=_.keys(obj),length=keys.length,results={},index=0;length>index;index++)currentKey=keys[index],results[currentKey]=iteratee(obj[currentKey],currentKey,obj);return results},_.pairs=function(obj){for(var keys=_.keys(obj),length=keys.length,pairs=Array(length),i=0;length>i;i++)pairs[i]=[keys[i],obj[keys[i]]];return pairs},_.invert=function(obj){for(var result={},keys=_.keys(obj),i=0,length=keys.length;length>i;i++)result[obj[keys[i]]]=keys[i];return result},_.functions=_.methods=function(obj){var names=[];for(var key in obj)_.isFunction(obj[key])&&names.push(key);return names.sort()},_.extend=createAssigner(_.allKeys),_.extendOwn=_.assign=createAssigner(_.keys),_.findKey=function(obj,predicate,context){predicate=cb(predicate,context);for(var key,keys=_.keys(obj),i=0,length=keys.length;length>i;i++)if(key=keys[i],predicate(obj[key],key,obj))return key},_.pick=function(object,oiteratee,context){var iteratee,keys,result={},obj=object;if(null==obj)return result;_.isFunction(oiteratee)?(keys=_.allKeys(obj),iteratee=optimizeCb(oiteratee,context)):(keys=flatten(arguments,!1,!1,1),iteratee=function(value,key,obj){return key in obj},obj=Object(obj));for(var i=0,length=keys.length;length>i;i++){var key=keys[i],value=obj[key];iteratee(value,key,obj)&&(result[key]=value)}return result},_.omit=function(obj,iteratee,context){if(_.isFunction(iteratee))iteratee=_.negate(iteratee);else{var keys=_.map(flatten(arguments,!1,!1,1),String);iteratee=function(value,key){return!_.contains(keys,key)}}return _.pick(obj,iteratee,context)},_.defaults=createAssigner(_.allKeys,!0),_.create=function(prototype,props){var result=baseCreate(prototype);return props&&_.extendOwn(result,props),result},_.clone=function(obj){return _.isObject(obj)?_.isArray(obj)?obj.slice():_.extend({},obj):obj},_.tap=function(obj,interceptor){return interceptor(obj),obj},_.isMatch=function(object,attrs){var keys=_.keys(attrs),length=keys.length;if(null==object)return!length;for(var obj=Object(object),i=0;length>i;i++){var key=keys[i];if(attrs[key]!==obj[key]||!(key in obj))return!1}return!0};var eq=function(a,b,aStack,bStack){if(a===b)return 0!==a||1/a===1/b;if(null==a||null==b)return a===b;a instanceof _&&(a=a._wrapped),b instanceof _&&(b=b._wrapped);var className=toString.call(a);if(className!==toString.call(b))return!1;switch(className){case"[object RegExp]":case"[object String]":return""+a==""+b;case"[object Number]":return+a!==+a?+b!==+b:0===+a?1/+a===1/b:+a===+b;case"[object Date]":case"[object Boolean]":return+a===+b}var areArrays="[object Array]"===className;if(!areArrays){if("object"!=typeof a||"object"!=typeof b)return!1;var aCtor=a.constructor,bCtor=b.constructor;if(aCtor!==bCtor&&!(_.isFunction(aCtor)&&aCtor instanceof aCtor&&_.isFunction(bCtor)&&bCtor instanceof bCtor)&&"constructor"in a&&"constructor"in b)return!1}aStack=aStack||[],bStack=bStack||[];for(var length=aStack.length;length--;)if(aStack[length]===a)return bStack[length]===b;if(aStack.push(a),bStack.push(b),areArrays){if(length=a.length,length!==b.length)return!1;for(;length--;)if(!eq(a[length],b[length],aStack,bStack))return!1}else{var key,keys=_.keys(a);if(length=keys.length,_.keys(b).length!==length)return!1;for(;length--;)if(key=keys[length],!_.has(b,key)||!eq(a[key],b[key],aStack,bStack))return!1}return aStack.pop(),bStack.pop(),!0};_.isEqual=function(a,b){return eq(a,b)},_.isEmpty=function(obj){return null==obj?!0:isArrayLike(obj)&&(_.isArray(obj)||_.isString(obj)||_.isArguments(obj))?0===obj.length:0===_.keys(obj).length},_.isElement=function(obj){return!(!obj||1!==obj.nodeType)},_.isArray=nativeIsArray||function(obj){return"[object Array]"===toString.call(obj)},_.isObject=function(obj){var type=typeof obj;return"function"===type||"object"===type&&!!obj},_.each(["Arguments","Function","String","Number","Date","RegExp","Error"],function(name){_["is"+name]=function(obj){return toString.call(obj)==="[object "+name+"]"}}),_.isArguments(arguments)||(_.isArguments=function(obj){return _.has(obj,"callee")}),"function"!=typeof/./&&"object"!=typeof Int8Array&&(_.isFunction=function(obj){return"function"==typeof obj||!1}),_.isFinite=function(obj){return isFinite(obj)&&!isNaN(parseFloat(obj))},_.isNaN=function(obj){return _.isNumber(obj)&&obj!==+obj},_.isBoolean=function(obj){return obj===!0||obj===!1||"[object Boolean]"===toString.call(obj)},_.isNull=function(obj){return null===obj},_.isUndefined=function(obj){return void 0===obj},_.has=function(obj,key){return null!=obj&&hasOwnProperty.call(obj,key)},_.noConflict=function(){return root._=previousUnderscore,this},_.identity=function(value){return value},_.constant=function(value){return function(){return value}},_.noop=function(){},_.property=property,_.propertyOf=function(obj){return null==obj?function(){}:function(key){return obj[key]}},_.matcher=_.matches=function(attrs){return attrs=_.extendOwn({},attrs),function(obj){return _.isMatch(obj,attrs)}},_.times=function(n,iteratee,context){var accum=Array(Math.max(0,n));iteratee=optimizeCb(iteratee,context,1);for(var i=0;n>i;i++)accum[i]=iteratee(i);return accum},_.random=function(min,max){return null==max&&(max=min,min=0),min+Math.floor(Math.random()*(max-min+1))},_.now=Date.now||function(){return(new Date).getTime()};var escapeMap={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#x27;","`":"&#x60;"},unescapeMap=_.invert(escapeMap),createEscaper=function(map){var escaper=function(match){return map[match]},source="(?:"+_.keys(map).join("|")+")",testRegexp=RegExp(source),replaceRegexp=RegExp(source,"g");return function(string){return string=null==string?"":""+string,testRegexp.test(string)?string.replace(replaceRegexp,escaper):string}};_.escape=createEscaper(escapeMap),_.unescape=createEscaper(unescapeMap),_.result=function(object,property,fallback){var value=null==object?void 0:object[property];return void 0===value&&(value=fallback),_.isFunction(value)?value.call(object):value};var idCounter=0;_.uniqueId=function(prefix){var id=++idCounter+"";return prefix?prefix+id:id},_.templateSettings={evaluate:/<%([\s\S]+?)%>/g,interpolate:/<%=([\s\S]+?)%>/g,escape:/<%-([\s\S]+?)%>/g};var noMatch=/(.)^/,escapes={"'":"'","\\":"\\","\r":"r","\n":"n","\u2028":"u2028","\u2029":"u2029"},escaper=/\\|'|\r|\n|\u2028|\u2029/g,escapeChar=function(match){return"\\"+escapes[match]};_.template=function(text,settings,oldSettings){!settings&&oldSettings&&(settings=oldSettings),settings=_.defaults({},settings,_.templateSettings);var matcher=RegExp([(settings.escape||noMatch).source,(settings.interpolate||noMatch).source,(settings.evaluate||noMatch).source].join("|")+"|$","g"),index=0,source="__p+='";text.replace(matcher,function(match,escape,interpolate,evaluate,offset){return source+=text.slice(index,offset).replace(escaper,escapeChar),index=offset+match.length,escape?source+="'+\n((__t=("+escape+"))==null?'':_.escape(__t))+\n'":interpolate?source+="'+\n((__t=("+interpolate+"))==null?'':__t)+\n'":evaluate&&(source+="';\n"+evaluate+"\n__p+='"),match}),source+="';\n",settings.variable||(source="with(obj||{}){\n"+source+"}\n"),source="var __t,__p='',__j=Array.prototype.join,print=function(){__p+=__j.call(arguments,'');};\n"+source+"return __p;\n";try{var render=new Function(settings.variable||"obj","_",source)}catch(e){throw e.source=source,e}var template=function(data){return render.call(this,data,_)},argument=settings.variable||"obj";return template.source="function("+argument+"){\n"+source+"}",template},_.chain=function(obj){var instance=_(obj);return instance._chain=!0,instance};var result=function(instance,obj){return instance._chain?_(obj).chain():obj};_.mixin=function(obj){_.each(_.functions(obj),function(name){var func=_[name]=obj[name];_.prototype[name]=function(){var args=[this._wrapped];return push.apply(args,arguments),result(this,func.apply(_,args))}})},_.mixin(_),_.each(["pop","push","reverse","shift","sort","splice","unshift"],function(name){var method=ArrayProto[name];_.prototype[name]=function(){var obj=this._wrapped;return method.apply(obj,arguments),"shift"!==name&&"splice"!==name||0!==obj.length||delete obj[0],result(this,obj)}}),_.each(["concat","join","slice"],function(name){var method=ArrayProto[name];_.prototype[name]=function(){return result(this,method.apply(this._wrapped,arguments))}}),_.prototype.value=function(){return this._wrapped},_.prototype.valueOf=_.prototype.toJSON=_.prototype.value,_.prototype.toString=function(){return""+this._wrapped},__WEBPACK_AMD_DEFINE_ARRAY__=[],__WEBPACK_AMD_DEFINE_RESULT__=function(){return _}.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__),!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__))}).call(this)},function(module,exports,__webpack_require__){(function(Buffer){function fromBase64(base64string){return base64string.replace(/=/g,"").replace(/\+/g,"-").replace(/\//g,"_")}function toBase64(base64UrlString){Buffer.isBuffer(base64UrlString)&&(base64UrlString=base64UrlString.toString());var b64str=padString(base64UrlString).replace(/\-/g,"+").replace(/_/g,"/");return b64str}function padString(string){var segmentLength=4,stringLength=string.length,diff=string.length%segmentLength;if(!diff)return string;var position=stringLength,padLength=segmentLength-diff,paddedStringLength=stringLength+padLength,buffer=Buffer(paddedStringLength);for(buffer.write(string);padLength--;)buffer.write("=",position++);return buffer.toString()}function decodeBase64Url(base64UrlString,encoding){return Buffer(toBase64(base64UrlString),"base64").toString(encoding)}function base64url(stringOrBuffer,encoding){return fromBase64(Buffer(stringOrBuffer,encoding).toString("base64"))}function toBuffer(base64string){return Buffer(toBase64(base64string),"base64")}base64url.toBase64=toBase64,base64url.fromBase64=fromBase64,base64url.decode=decodeBase64Url,base64url.encode=base64url,base64url.toBuffer=toBuffer,module.exports=base64url}).call(exports,__webpack_require__(92).Buffer)},function(module,exports,__webpack_require__){"use strict";var def=__webpack_require__(36),universes=__webpack_require__(18),universeHelpers=__webpack_require__(14),services=def,search=__webpack_require__(24),AttributeDefaultsCalculator=function(){function AttributeDefaultsCalculator(enabled){this.enabled=enabled,this.valueCalculators=[new RequiredPropertyCalculator,new TypePropertyCalculator,new DisplayNamePropertyCalculator,new MediaTypeCalculator,new SecuredByPropertyCalculator,new ProtocolsPropertyCalculator,new VersionParamEnumCalculator]}return AttributeDefaultsCalculator.prototype.attributeDefaultIfEnabled=function(node,attributeProperty){return this.enabled?this.getAttributeDefault(node,attributeProperty):null},AttributeDefaultsCalculator.prototype.getAttributeDefault=function(node,attributeProperty){if(!node||!attributeProperty)return null;try{return this.getAttributeDefault2(attributeProperty,node)}catch(Error){return console.log(Error),null}},AttributeDefaultsCalculator.prototype.getWrapperAttributeDefault=function(wrapperNode,attributeName){var highLevelNode=wrapperNode.highLevel();if(null==highLevelNode)return null;var property=highLevelNode.definition().property(attributeName);return null==property?null:this.getAttributeDefault(highLevelNode,property)},AttributeDefaultsCalculator.prototype.getAttributeDefault2=function(attributeProperty,node){for(var i=0;i<this.valueCalculators.length;i++){var calculator=this.valueCalculators[i];if(calculator.matches(attributeProperty,node)){var value=calculator.calculate(attributeProperty,node);if(null!=value)return value}}return null!=attributeProperty.defaultValue()?attributeProperty.defaultValue():null},AttributeDefaultsCalculator.prototype.isEnabled=function(){return this.enabled},AttributeDefaultsCalculator.prototype.insertionKind=function(node,attributeProperty){for(var i=0;i<this.valueCalculators.length;i++){var calculator=this.valueCalculators[i];if(calculator.matches(attributeProperty,node))return calculator.kind()}return null!=attributeProperty.defaultValue()?InsertionKind.BY_DEFAULT:null},AttributeDefaultsCalculator}();exports.AttributeDefaultsCalculator=AttributeDefaultsCalculator,function(InsertionKind){InsertionKind[InsertionKind.CALCULATED=0]="CALCULATED",InsertionKind[InsertionKind.BY_DEFAULT=1]="BY_DEFAULT"}(exports.InsertionKind||(exports.InsertionKind={}));var InsertionKind=exports.InsertionKind,MediaTypeCalculator=function(){function MediaTypeCalculator(){}return MediaTypeCalculator.prototype.calculate=function(attributeProperty,node){var root=search.declRoot(node);if(root&&universeHelpers.isApiSibling(root.definition())){var defaultMediaTypeAttr=root.attr(universes.Universe10.Api.properties.mediaType.name);if(defaultMediaTypeAttr)return defaultMediaTypeAttr.value()}return null},MediaTypeCalculator.prototype.matches=function(attributeProperty,node){if(!universeHelpers.isNameProperty(attributeProperty))return!1;var nodeDefinition=node.definition();if(!nodeDefinition)return!1;if(!universeHelpers.isBodyLikeType(nodeDefinition)&&!universeHelpers.isTypeDeclarationSibling(nodeDefinition))return!1;var parentNode=node.parent();if(null==parentNode)return!1;var parentDefinition=parentNode.definition();if(null==parentDefinition)return!1;if(!universeHelpers.isResponseType(parentDefinition)&&!universeHelpers.isMethodBaseSibling(parentDefinition))return!1;for(var ancestor=parentNode;ancestor;){var aDef=ancestor.definition();if(universeHelpers.isTraitType(aDef))return!1;if(universeHelpers.isResourceTypeType(aDef))return!1;ancestor=ancestor.parent()}return!0},MediaTypeCalculator.prototype.kind=function(){return InsertionKind.CALCULATED},MediaTypeCalculator}(),DisplayNamePropertyCalculator=function(){function DisplayNamePropertyCalculator(){}return DisplayNamePropertyCalculator.prototype.calculate=function(attributeProperty,node){var nodeDefinition=node.definition();if(null==nodeDefinition)return null;var adapter=nodeDefinition.getAdapter(services.RAMLService),keyProperty=adapter.getKeyProp();if(null!=keyProperty){var attributeValue=node.attrValue(keyProperty.nameId());return null!=attributeValue?attributeValue:new AttributeDefaultsCalculator(!0).getAttributeDefault(node,keyProperty)}return null},DisplayNamePropertyCalculator.prototype.matches=function(attributeProperty,node){var nodeDefinition=node.definition();return null==nodeDefinition?!1:(universeHelpers.isTypeDeclarationSibling(nodeDefinition)||nodeDefinition.isAssignableFrom(universes.Universe08.Parameter.name)||universeHelpers.isResourceType(nodeDefinition))&&universeHelpers.isDisplayNameProperty(attributeProperty)},DisplayNamePropertyCalculator.prototype.kind=function(){return InsertionKind.CALCULATED},DisplayNamePropertyCalculator}(),TypePropertyCalculator=function(){function TypePropertyCalculator(){}return TypePropertyCalculator.prototype.calculate=function(attributeProperty,node){return"object"},TypePropertyCalculator.prototype.matches=function(attributeProperty,node){return universeHelpers.isTypeProperty(attributeProperty)&&null!=node.definition()&&universeHelpers.isObjectTypeDeclarationSibling(node.definition())},TypePropertyCalculator.prototype.kind=function(){return InsertionKind.BY_DEFAULT},TypePropertyCalculator}(),RequiredPropertyCalculator=function(){function RequiredPropertyCalculator(){}return RequiredPropertyCalculator.prototype.calculate=function(attributeProperty,node){var nodeDefinition=node.definition(),nodeProperty=node.property();if(null==nodeDefinition)return null;var adapter=nodeDefinition.getAdapter(services.RAMLService),keyProperty=adapter.getKeyProp();if(null!=keyProperty){var attribute=node.attr(keyProperty.nameId());if(null!=attribute&&attribute.optional())return!1}if(null!=nodeProperty){if(universeHelpers.isHeadersProperty(nodeProperty)||universeHelpers.isFormParametersProperty(nodeProperty)||universeHelpers.isQueryParametersProperty(nodeProperty))return"RAML08"==attributeProperty.domain().universe().version()?!1:!0;if(universeHelpers.isUriParametersProperty(nodeProperty)||universeHelpers.isBaseUriParametersProperty(nodeProperty))return!0}return null!=attributeProperty.defaultValue()?attributeProperty.defaultValue():null},RequiredPropertyCalculator.prototype.matches=function(attributeProperty,node){return universeHelpers.isRequiredProperty(attributeProperty)},RequiredPropertyCalculator.prototype.kind=function(){return InsertionKind.BY_DEFAULT},RequiredPropertyCalculator}(),SecuredByPropertyCalculator=function(){function SecuredByPropertyCalculator(){}return SecuredByPropertyCalculator.prototype.calculate=function(attributeProperty,node){if(universeHelpers.isApiSibling(node.definition()))return null;var values,definition=node.definition();if(universeHelpers.isMethodType(definition)){var resource=node.parent();resource&&(values=resource.wrapperNode().securedBy())}if(!values||0==values.length){for(;null!=node&&!universeHelpers.isApiSibling(node.definition());)node=node.parent();node&&(values=node.wrapperNode().securedBy())}return values&&values.length>0?values:null},SecuredByPropertyCalculator.prototype.matches=function(attributeProperty,node){var nodeDefinition=node.definition();return null==nodeDefinition?!1:universeHelpers.isSecuredByProperty(attributeProperty)},SecuredByPropertyCalculator.prototype.kind=function(){return InsertionKind.CALCULATED},SecuredByPropertyCalculator}(),ProtocolsPropertyCalculator=function(){function ProtocolsPropertyCalculator(){}return ProtocolsPropertyCalculator.prototype.calculate=function(attributeProperty,node){for(;null!=node&&!universeHelpers.isApiSibling(node.definition());)node=node.parent();var result,baseUriAttr=node.attr(universes.Universe10.Api.properties.baseUri.name);if(baseUriAttr){var baseUri=baseUriAttr.value();if(baseUri){var ind=baseUri.indexOf("://");ind>=0&&(result=[baseUri.substring(0,ind).toUpperCase()]),result||(result=["HTTP"])}}return result},ProtocolsPropertyCalculator.prototype.matches=function(attributeProperty,node){if(!universeHelpers.isProtocolsProperty(attributeProperty))return!1;var nodeDefinition=node.definition(),hasAppropriateLocation=!1;if(universeHelpers.isApiSibling(nodeDefinition))hasAppropriateLocation=!0;else if(universeHelpers.isResourceType(nodeDefinition))hasAppropriateLocation=!0;else if(universeHelpers.isMethodType(nodeDefinition)){var parentNode=node.parent();hasAppropriateLocation=parentNode&&universeHelpers.isResourceType(parentNode.definition())}return hasAppropriateLocation;
},ProtocolsPropertyCalculator.prototype.kind=function(){return InsertionKind.CALCULATED},ProtocolsPropertyCalculator}(),VersionParamEnumCalculator=function(){function VersionParamEnumCalculator(){}return VersionParamEnumCalculator.prototype.calculate=function(attributeProperty,node){for(;null!=node&&!universeHelpers.isApiSibling(node.definition());)node=node.parent();var versionAttr=node.attr(universes.Universe10.Api.properties.version.name);if(versionAttr){var versionValue=versionAttr.value();if(versionValue&&versionValue.trim())return[versionValue]}return null},VersionParamEnumCalculator.prototype.matches=function(attributeProperty,node){if(!universeHelpers.isEnumProperty(attributeProperty))return!1;var nodeProperty=node.property();if(!nodeProperty)return!1;if(!universeHelpers.isBaseUriParametersProperty(nodeProperty))return!1;var nameAttr=node.attr(universes.Universe10.TypeDeclaration.properties.name.name),paramName=nameAttr&&nameAttr.value();return"version"!=paramName?!1:!0},VersionParamEnumCalculator.prototype.kind=function(){return InsertionKind.CALCULATED},VersionParamEnumCalculator}()},function(module,exports,__webpack_require__){"use strict";function dump(node,serializeMeta){return void 0===serializeMeta&&(serializeMeta=!0),new TCKDumper({rootNodeDetails:!0,serializeMetadata:serializeMeta}).dump(node)}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},universe=__webpack_require__(18),core=__webpack_require__(45),proxy=__webpack_require__(39),def=__webpack_require__(36),hlImpl=__webpack_require__(16),builder=__webpack_require__(27),universeHelpers=__webpack_require__(14),universes=__webpack_require__(18),util=__webpack_require__(32),RamlWrapper10=__webpack_require__(12);exports.dump=dump;var TCKDumper=function(){function TCKDumper(options){this.options=options,this.nodeTransformers=[new ResourcesTransformer,new TypeExampleTransformer,new ArrayExpressionTransformer,new TypesTransformer,new SecuritySchemesTransformer,new AnnotationTypesTransformer,new TemplateParametrizedPropertiesTransformer,new TraitsTransformer,new ResourceTypesTransformer,new SchemasTransformer,new ProtocolsToUpperCaseTransformer,new ResourceTypeMethodsToMapTransformer,new ReferencesTransformer,new SimpleNamesTransformer],this.nodePropertyTransformers=[new ParametersTransformer,new PropertiesTransformer,new ResponsesTransformer,new BodiesTransformer,new AnnotationsTransformer,new FacetsTransformer,new OneElementArrayTransformer],this.ignore=new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(universeHelpers.isResponseType,universeHelpers.isDisplayNameProperty),new BasicObjectPropertyMatcher(universeHelpers.isApiSibling,universeHelpers.isDisplayNameProperty),new BasicObjectPropertyMatcher(universeHelpers.isAnnotationRefTypeOrDescendant,universeHelpers.isAnnotationProperty),new BasicObjectPropertyMatcher(universeHelpers.isSecuritySchemeRefType,universeHelpers.isSecuritySchemeProperty),new BasicObjectPropertyMatcher(universeHelpers.isTraitRefType,universeHelpers.isTraitProperty),new BasicObjectPropertyMatcher(universeHelpers.isResourceTypeRefType,universeHelpers.isResourceTypeProperty),new BasicObjectPropertyMatcher(universeHelpers.isApiSibling,universeHelpers.isRAMLVersionProperty)]),this.missingProperties=new PropertiesData,this.options=this.options||{},null==this.options.serializeMetadata&&(this.options.serializeMetadata=!0)}return TCKDumper.prototype.printMissingProperties=function(){return this.missingProperties.print()},TCKDumper.prototype.dump=function(node){var highLevelNode=node.highLevel(),highLevelParent=highLevelNode&&highLevelNode.parent(),rootNodeDetails=!highLevelParent&&this.options.rootNodeDetails,result=this.dumpInternal(node,rootNodeDetails);return result},TCKDumper.prototype.dumpInternal=function(node,rootNodeDetails){var _this=this;if(void 0===rootNodeDetails&&(rootNodeDetails=!1),null==node)return null;if(node instanceof core.BasicNodeImpl){var props={},basicNode=node,definition=basicNode.highLevel().definition();definition.allProperties().filter(function(x){return!_this.ignore.match(basicNode.definition(),x)}).forEach(function(x){props[x.nameId()]=x}),definition.allCustomProperties().filter(function(x){return!_this.ignore.match(basicNode.definition(),x)}).forEach(function(x){props[x.nameId()]=x});var obj=this.dumpProperties(props,node);if(props.schema&&this.options.dumpSchemaContents&&props.schema.range().key()==universes.Universe08.SchemaString){var schemas=basicNode.highLevel().root().elementsOfKind("schemas");schemas.forEach(function(x){if(x.name()==obj.schema){var vl=x.attr("value");vl&&(obj.schema=vl.value(),obj.schemaContent=vl.value())}})}if(this.serializeScalarsAnnotations(obj,basicNode,props),this.serializeMeta(obj,basicNode),this.canBeFragment(node)&&RamlWrapper10.isFragment(node)){var fragment=RamlWrapper10.asFragment(node),uses=fragment.uses();uses.length>0&&(obj.uses=uses.map(function(x){return x.toJSON()}))}this.nodeTransformers.forEach(function(x){x.match(node,node.highLevel().property())&&(obj=x.transform(obj,node))});var result={};if(rootNodeDetails){if(definition){var ramlVersion=definition.universe().version();result.ramlVersion=ramlVersion,result.type=definition.nameId()}result.specification=obj,result.errors=this.dumpErrors(basicNode.errors())}else result=obj;return result}if(node instanceof core.AttributeNodeImpl){var props={},attrNode=node,definition=attrNode.highLevel().definition();definition.allCustomProperties().filter(function(x){return!_this.ignore.match(attrNode.highLevel().property().range(),x)}).forEach(function(x){props[x.nameId()]=x});var isValueType=attrNode.highLevel().property().range().isValueType();if(isValueType&&attrNode.value){var val=attrNode.value();if("number"==typeof val||"string"==typeof val||"boolean"==typeof val)return val}var obj=this.dumpProperties(props,node);return this.nodeTransformers.forEach(function(x){x.match(node,node.highLevel().property())&&(obj=x.transform(obj,node))}),this.serializeScalarsAnnotations(obj,node,props),this.serializeMeta(obj,attrNode),obj}return node instanceof core.TypeInstanceImpl?this.serializeTypeInstance(node):node instanceof core.TypeInstancePropertyImpl?this.serializeTypeInstanceProperty(node):node},TCKDumper.prototype.canBeFragment=function(node){var definition=node.definition(),arr=[definition].concat(definition.allSubTypes()),arr1=arr.filter(function(x){return x.getAdapter(def.RAMLService).possibleInterfaces().filter(function(y){return y.nameId()==def.universesInfo.Universe10.FragmentDeclaration.name}).length>0});return arr1.length>0},TCKDumper.prototype.dumpErrors=function(errors){var _this=this;return errors.map(function(x){var eObj=_this.dumpErrorBasic(x);return x.trace&&x.trace.length>0&&(eObj.trace=_this.dumpErrors(x.trace)),eObj}).sort(function(x,y){return x.path!=y.path?x.path.localeCompare(y.path):x.range.start.position!=y.range.start.position?x.range.start.position-y.range.start.position:x.code-y.code})},TCKDumper.prototype.dumpErrorBasic=function(x){var eObj={code:x.code,message:x.message,path:x.path,line:x.line,column:x.column,position:x.start,range:x.range};return x.isWarning===!0&&(eObj.isWarning=!0),eObj},TCKDumper.prototype.dumpProperties=function(props,node){var _this=this,obj={};return Object.keys(props).forEach(function(propName){if(!node[propName])return void _this.missingProperties.addProperty(props[propName],node.kind());var property=props[propName],value=node[propName]();if(value&&"structuredType"==propName&&"object"==typeof value){value=null;var highLevelNode=node.highLevel(),a=highLevelNode.lowLevel();a.children().forEach(function(x){if("type"==x.key()||"schema"==x.key()){var td=highLevelNode.definition().universe().type(universe.Universe10.TypeDeclaration.name),hasType=highLevelNode.definition().universe().type(universe.Universe10.LibraryBase.name),tNode=new hlImpl.ASTNodeImpl(x,highLevelNode,td,hasType.property(universe.Universe10.LibraryBase.properties.types.name));tNode.patchType(builder.doDescrimination(tNode)),value=dump(tNode.wrapperNode()),propName=x.key()}})}if((value||"type"!=propName)&&(value||"schema"!=propName)){if(node.definition&&universeHelpers.isTypeDeclarationSibling(node.definition())&&universeHelpers.isTypeProperty(property)){var schemaValue=node[universe.Universe10.TypeDeclaration.properties.schema.name]();if(null!=schemaValue&&(!Array.isArray(schemaValue)||0!=schemaValue.length))return;var highLevelNode=node.highLevel(),a=highLevelNode.lowLevel(),hasSchema=!1;if(a.children().forEach(function(x){return"schema"==x.key()?void(hasSchema=!0):void 0}),hasSchema)return}if(Array.isArray(value)){for(var propertyValue=[],_i=0,value_1=value;_i<value_1.length;_i++){var val=value_1[_i],dumped=_this.dumpInternal(val);"examples"===propName&&_this.options&&_this.options.dumpXMLRepresentationOfExamples&&val.expandable&&val.expandable._owner&&(dumped.asXMLString=val.expandable.asXMLString()),propertyValue.push(dumped)}if(0==propertyValue.length&&node instanceof core.BasicNodeImpl&&!_this.isDefined(node,propName))return;for(var _a=0,_b=_this.nodePropertyTransformers;_a<_b.length;_a++){var x=_b[_a];x.match(node,property)&&(propertyValue=x.transform(propertyValue,node))}obj[propName]=propertyValue}else{var val=_this.dumpInternal(value);if(null==val&&node instanceof core.BasicNodeImpl&&!_this.isDefined(node,propName))return;node instanceof core.BasicNodeImpl&&_this.nodePropertyTransformers.forEach(function(x){x.match(node,property)&&(val=x.transform(val,node))}),obj[propName]=val,"example"===propName&&_this.options&&_this.options.dumpXMLRepresentationOfExamples&&value.expandable&&value.expandable._owner&&(val.asXMLString=value.expandable.asXMLString())}}}),obj},TCKDumper.prototype.serializeScalarsAnnotations=function(obj,node,props){var _this=this;if(node.scalarsAnnotations){for(var val={},accessor=node.scalarsAnnotations(),_i=0,_a=Object.keys(props);_i<_a.length;_i++){var propName=_a[_i];if(accessor[propName]){var arr=accessor[propName]();if(arr.length>0)if(Array.isArray(arr[0])){var arr1=[];arr.forEach(function(x,i){arr1.push(x.map(function(y){return _this.dumpInternal(y)}))}),arr1.filter(function(x){return x.length>0}).length>0&&(val[propName]=arr1)}else val[propName]=arr.map(function(x){return _this.dumpInternal(x)})}}Object.keys(val).length>0&&(obj.scalarsAnnotations=val)}},TCKDumper.prototype.serializeMeta=function(obj,node){if(this.options.serializeMetadata){var meta=node.meta();meta.isDefault()||(obj.__METADATA__=meta.toJSON())}},TCKDumper.prototype.serializeTypeInstance=function(inst){var _this=this;if(inst.isScalar())return inst.value();if(inst.isArray())return inst.items().map(function(x){return _this.serializeTypeInstance(x)});var props=inst.properties();if(0==props.length)return null;var obj={};return props.forEach(function(x){return obj[x.name()]=_this.serializeTypeInstanceProperty(x)}),obj},TCKDumper.prototype.serializeTypeInstanceProperty=function(prop){var _this=this;if(prop.isArray()){var values=prop.values(),arr=[];return values.forEach(function(x){return arr.push(_this.serializeTypeInstance(x))}),arr}return this.serializeTypeInstance(prop.value())},TCKDumper.prototype.isDefined=function(node,name){var hl=node.highLevel();return hl.elementsOfKind(name).length>0?!0:hl.attributes(name).length>0?!0:!1},TCKDumper}();exports.TCKDumper=TCKDumper;var BasicObjectPropertyMatcher=function(){function BasicObjectPropertyMatcher(typeMatcher,propMatcher){this.typeMatcher=typeMatcher,this.propMatcher=propMatcher}return BasicObjectPropertyMatcher.prototype.match=function(td,prop){return(null==td||this.typeMatcher(td))&&(null==prop||this.propMatcher(prop))},BasicObjectPropertyMatcher}(),CompositeObjectPropertyMatcher=function(){function CompositeObjectPropertyMatcher(matchers){this.matchers=matchers}return CompositeObjectPropertyMatcher.prototype.match=function(td,prop){for(var l=this.matchers.length,i=0;l>i;i++)if(this.matchers[i].match(td,prop))return!0;return!1},CompositeObjectPropertyMatcher}(),ArrayToMapTransformer=function(){function ArrayToMapTransformer(matcher,propName){this.matcher=matcher,this.propName=propName}return ArrayToMapTransformer.prototype.match=function(node,prop){return this.matcher.match(node.definition(),prop)},ArrayToMapTransformer.prototype.transform=function(value){var _this=this;if(Array.isArray(value)&&value.length>0&&value[0][this.propName]){var obj={};return value.forEach(function(x){var key=x[_this.propName],previous=obj[key];previous?Array.isArray(previous)?previous.push(x):obj[key]=[previous,x]:obj[key]=x}),obj}return value},ArrayToMapTransformer}(),ArrayToMappingsArrayTransformer=function(){function ArrayToMappingsArrayTransformer(matcher,propName){this.matcher=matcher,this.propName=propName}return ArrayToMappingsArrayTransformer.prototype.match=function(node,prop){return this.matcher.match(node.definition?node.definition():null,prop)},ArrayToMappingsArrayTransformer.prototype.transform=function(value){if(Array.isArray(value))return value;var obj={};return obj[value[this.propName]]=value,obj},ArrayToMappingsArrayTransformer}(),ParametersTransformer=function(_super){function ParametersTransformer(){_super.call(this,new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(universeHelpers.isApiSibling,universeHelpers.isBaseUriParametersProperty),new BasicObjectPropertyMatcher(universeHelpers.isResourceBaseSibling,universeHelpers.isUriParametersProperty),new BasicObjectPropertyMatcher(universeHelpers.isResourceBaseSibling,universeHelpers.isQueryParametersProperty),new BasicObjectPropertyMatcher(universeHelpers.isTraitType,universeHelpers.isQueryParametersProperty),new BasicObjectPropertyMatcher(universeHelpers.isMethodType,universeHelpers.isQueryParametersProperty),new BasicObjectPropertyMatcher(universeHelpers.isSecuritySchemePartType,universeHelpers.isQueryParametersProperty),new BasicObjectPropertyMatcher(universeHelpers.isTraitType,universeHelpers.isHeadersProperty),new BasicObjectPropertyMatcher(universeHelpers.isMethodType,universeHelpers.isHeadersProperty),new BasicObjectPropertyMatcher(universeHelpers.isSecuritySchemePartType,universeHelpers.isHeadersProperty),new BasicObjectPropertyMatcher(universeHelpers.isBodyLikeType,universeHelpers.isFormParametersProperty)]),"name")}return __extends(ParametersTransformer,_super),ParametersTransformer}(ArrayToMapTransformer),TypesTransformer=function(_super){function TypesTransformer(){_super.call(this,new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(universeHelpers.isLibraryBaseSibling,universeHelpers.isTypesProperty),new BasicObjectPropertyMatcher(function(x){return universeHelpers.isLibraryBaseSibling(x)&&universeHelpers.isRAML10Type(x)},universeHelpers.isSchemasProperty)]),"name")}return __extends(TypesTransformer,_super),TypesTransformer.prototype.match=function(node,prop){return null!=node.parent()&&this.matcher.match(node.parent().definition(),prop)},TypesTransformer}(ArrayToMappingsArrayTransformer),PropertiesTransformer=(function(_super){function UsesTransformer(){_super.call(this,new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(universeHelpers.isLibraryBaseSibling,universeHelpers.isUsesProperty)]),"name")}return __extends(UsesTransformer,_super),UsesTransformer}(ArrayToMapTransformer),function(_super){function PropertiesTransformer(){_super.call(this,new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(universeHelpers.isObjectTypeDeclarationSibling,universeHelpers.isPropertiesProperty)]),"name")}return __extends(PropertiesTransformer,_super),PropertiesTransformer}(ArrayToMapTransformer)),ResponsesTransformer=function(_super){function ResponsesTransformer(){_super.call(this,new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(universeHelpers.isMethodBaseSibling,universeHelpers.isResponsesProperty)]),"code")}return __extends(ResponsesTransformer,_super),ResponsesTransformer}(ArrayToMapTransformer),AnnotationsTransformer=function(_super){function AnnotationsTransformer(){_super.call(this,new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(function(x){return!0},universeHelpers.isAnnotationsProperty)]),"name")}return __extends(AnnotationsTransformer,_super),AnnotationsTransformer}(ArrayToMapTransformer),BodiesTransformer=function(_super){function BodiesTransformer(){_super.call(this,new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(universeHelpers.isResponseType,universeHelpers.isBodyProperty),new BasicObjectPropertyMatcher(universeHelpers.isMethodBaseSibling,universeHelpers.isBodyProperty)]),"name")}return __extends(BodiesTransformer,_super),BodiesTransformer}(ArrayToMapTransformer),TraitsTransformer=function(_super){function TraitsTransformer(){_super.call(this,new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(universeHelpers.isTraitType,universeHelpers.isTraitsProperty)]),"name")}return __extends(TraitsTransformer,_super),TraitsTransformer}(ArrayToMappingsArrayTransformer),ResourceTypesTransformer=function(_super){function ResourceTypesTransformer(){_super.call(this,new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(universeHelpers.isResourceTypeType,universeHelpers.isResourceTypesProperty)]),"name")}return __extends(ResourceTypesTransformer,_super),ResourceTypesTransformer.prototype.transform=function(value){var methodsPropertyName=universes.Universe10.ResourceBase.properties.methods.name;if(Array.isArray(value))return value;var methods=value[methodsPropertyName];return methods&&methods.forEach(function(m){var keys=Object.keys(m);if(keys.length>0){var methodName=keys[0];value[methodName]=m[methodName]}}),delete value[methodsPropertyName],_super.prototype.transform.call(this,value)},ResourceTypesTransformer}(ArrayToMappingsArrayTransformer),FacetsTransformer=function(_super){function FacetsTransformer(){_super.call(this,new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(universeHelpers.isTypeDeclarationSibling,universeHelpers.isFacetsProperty)]),"name")}return __extends(FacetsTransformer,_super),FacetsTransformer}(ArrayToMapTransformer),SecuritySchemesTransformer=function(_super){function SecuritySchemesTransformer(){_super.call(this,null,"name")}return __extends(SecuritySchemesTransformer,_super),SecuritySchemesTransformer.prototype.match=function(node,prop){return null!=prop&&universeHelpers.isSecuritySchemesProperty(prop)},SecuritySchemesTransformer}(ArrayToMappingsArrayTransformer),AnnotationTypesTransformer=function(_super){function AnnotationTypesTransformer(){_super.call(this,new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(universeHelpers.isLibraryBaseSibling,universeHelpers.isAnnotationTypesProperty)]),"name")}return __extends(AnnotationTypesTransformer,_super),AnnotationTypesTransformer.prototype.match=function(node,prop){return null!=node.parent()&&this.matcher.match(node.parent().definition(),prop)},AnnotationTypesTransformer}(ArrayToMappingsArrayTransformer),ResourceTypeMethodsToMapTransformer=function(_super){function ResourceTypeMethodsToMapTransformer(){_super.call(this,null,"method")}return __extends(ResourceTypeMethodsToMapTransformer,_super),ResourceTypeMethodsToMapTransformer.prototype.match=function(node,prop){return null!=node.parent()&&universeHelpers.isResourceTypeType(node.parent().definition())&&universeHelpers.isMethodsProperty(prop)},ResourceTypeMethodsToMapTransformer}(ArrayToMappingsArrayTransformer),exampleNameProp=universe.Universe10.ExampleSpec.properties.name.name,exampleContentProp=universe.Universe10.ExampleSpec.properties.value.name,exampleStructuredContentProp="structuredContent",TypeExampleTransformer=(function(){function ExamplesTransformer(){}return ExamplesTransformer.prototype.match=function(node,prop){return universeHelpers.isExampleSpecType(node.definition())},ExamplesTransformer.prototype.transform=function(value){var _this=this;if(Array.isArray(value)&&value.length>0){if(value[0][exampleNameProp]){var obj={};return value.forEach(function(x){return obj[x[exampleNameProp]]=_this.getActualExample(x)}),obj}var arr=value.map(function(x){return _this.getActualExample(x)});return arr}return value},ExamplesTransformer.prototype.getActualExample=function(exampleSpecObj){return exampleSpecObj[exampleStructuredContentProp]?exampleSpecObj[exampleStructuredContentProp]:exampleSpecObj[exampleContentProp]},ExamplesTransformer}(),function(){function TypeExampleTransformer(){}return TypeExampleTransformer.prototype.match=function(node,prop){return node.definition&&universeHelpers.isTypeDeclarationSibling(node.definition())},TypeExampleTransformer.prototype.transform=function(value){var isArray=Array.isArray(value),arr=isArray?value:[value];return arr.forEach(function(x){var structuredExample=x.example;structuredExample&&(x.example=structuredExample.structuredValue,x.structuredExample=structuredExample)}),isArray?arr:arr[0]},TypeExampleTransformer}()),SchemasTransformer=function(){function SchemasTransformer(){this.matcher=new BasicObjectPropertyMatcher(function(x){return universeHelpers.isApiType(x)&&universeHelpers.isRAML08Type(x)},universeHelpers.isSchemasProperty)}return SchemasTransformer.prototype.match=function(node,prop){return null!=node.parent()&&this.matcher.match(node.parent().definition(),prop)},SchemasTransformer.prototype.transform=function(value){if(Array.isArray(value))return value;var obj={};return obj[value.key]=value.value,obj},SchemasTransformer.prototype.getActualExample=function(exampleSpecObj){return exampleSpecObj[exampleStructuredContentProp]?exampleSpecObj[exampleStructuredContentProp]:exampleSpecObj[exampleContentProp]},SchemasTransformer}(),ProtocolsToUpperCaseTransformer=function(){function ProtocolsToUpperCaseTransformer(){}return ProtocolsToUpperCaseTransformer.prototype.match=function(node,prop){return null!=prop&&universeHelpers.isProtocolsProperty(prop)},ProtocolsToUpperCaseTransformer.prototype.transform=function(value){return"string"==typeof value?value.toUpperCase():Array.isArray(value)?value.map(function(x){return x.toUpperCase()}):value},ProtocolsToUpperCaseTransformer}(),OneElementArrayTransformer=function(){function OneElementArrayTransformer(){this.usecases=new CompositeObjectPropertyMatcher([new BasicObjectPropertyMatcher(universeHelpers.isApiSibling,universeHelpers.isMediaTypeProperty)])}return OneElementArrayTransformer.prototype.match=function(node,prop){return this.usecases.match(node.definition(),prop)},OneElementArrayTransformer.prototype.transform=function(value){return Array.isArray(value)&&1==value.length?value[0]:value},OneElementArrayTransformer}(),ResourcesTransformer=function(){function ResourcesTransformer(){}return ResourcesTransformer.prototype.match=function(node,prop){return null!=prop&&universeHelpers.isResourcesProperty(prop)},ResourcesTransformer.prototype.transform=function(value,node){if(Array.isArray(value))return value;var relUri=value[universes.Universe10.Resource.properties.relativeUri.name];if(relUri){for(var segments=relUri.trim().split("/");segments.length>0&&0==segments[0].length;)segments.shift();value.relativeUriPathSegments=segments,value.absoluteUri=node.absoluteUri()}return value},ResourcesTransformer}(),SimpleNamesTransformer=function(){function SimpleNamesTransformer(){}return SimpleNamesTransformer.prototype.match=function(node,prop){return node.parent()&&node.parent().highLevel().lowLevel().libProcessed?universeHelpers.isAnnotationTypesProperty(prop)||universeHelpers.isTypesProperty(prop)||universeHelpers.isResourceTypesProperty(prop)||universeHelpers.isTraitsProperty(prop)||universeHelpers.isSecuritySchemesProperty(prop):!1},SimpleNamesTransformer.prototype.transform=function(value,node){for(var llNode=node.highLevel().lowLevel(),key=llNode.key(),original=llNode;original instanceof proxy.LowLevelProxyNode;)original=original.originalNode();var oKey=original.key(),aVal=value[Object.keys(value)[0]];return aVal.name=oKey,aVal.displayName==key&&(aVal.displayName=oKey),value},SimpleNamesTransformer}(),TemplateParametrizedPropertiesTransformer=function(){function TemplateParametrizedPropertiesTransformer(){}return TemplateParametrizedPropertiesTransformer.prototype.match=function(node,prop){var hlNode=node.highLevel();if(!hlNode)return!1;var d=hlNode.definition();return d?universeHelpers.isResourceTypeType(d)||universeHelpers.isTraitType(d)||universeHelpers.isMethodType(d)||universeHelpers.isTypeDeclarationSibling(d):!1},TemplateParametrizedPropertiesTransformer.prototype.transform=function(value){if(Array.isArray(value))return value;var propName=universe.Universe10.Trait.properties.parametrizedProperties.name,parametrizedProps=value[propName];return parametrizedProps&&(Object.keys(parametrizedProps).forEach(function(y){value[y]=parametrizedProps[y]}),delete value[propName]),value},TemplateParametrizedPropertiesTransformer}(),ReferencesTransformer=function(){function ReferencesTransformer(){}return ReferencesTransformer.prototype.match=function(node,prop){return null!=prop&&(universeHelpers.isSecuredByProperty(prop)||universeHelpers.isIsProperty(prop)||null!=node.parent()&&(universeHelpers.isResourceType(node.parent().highLevel().definition())||universeHelpers.isResourceTypeType(node.parent().highLevel().definition()))&&universeHelpers.isTypeProperty(prop))},ReferencesTransformer.prototype.transform=function(value){return value?Array.isArray(value)?value:this.toSimpleValue(value):null},ReferencesTransformer.prototype.toSimpleValue=function(x){var name=x.name,params=x.structuredValue;if(params){var obj={};return obj[name]=params,obj}return name},ReferencesTransformer}(),ArrayExpressionTransformer=function(){function ArrayExpressionTransformer(){}return ArrayExpressionTransformer.prototype.match=function(node,prop){if(!(node instanceof core.BasicNodeImpl))return!1;var hlNode=node.highLevel(),definition=hlNode.definition();if(!universeHelpers.isTypeDeclarationDescendant(definition))return!1;var lType=hlNode.localType();return lType&&lType.isArray()?!0:!1},ArrayExpressionTransformer.prototype.transform=function(value){var typePropName=universes.Universe10.TypeDeclaration.properties.type.name,itemsPropName=universes.Universe10.ArrayTypeDeclaration.properties.items.name,tValue=value[typePropName];return 1==tValue.length&&util.stringEndsWith(tValue[0],"[]")&&(null==value[itemsPropName]&&(value[itemsPropName]=tValue[0].substring(0,tValue[0].length-2)),tValue[0]="array"),value},ArrayExpressionTransformer}(),PropertiesData=function(){function PropertiesData(){this.map={}}return PropertiesData.prototype.addProperty=function(prop,wrapperKind){var data=this.map[wrapperKind];data||(data=new TypePropertiesData(wrapperKind),this.map[wrapperKind]=data),data.addProperty(prop)},PropertiesData.prototype.print=function(){var _this=this;return Object.keys(this.map).map(function(x){return _this.map[x].print()}).join("\n")+"\n"},PropertiesData}(),TypePropertiesData=function(){function TypePropertiesData(typeName){this.typeName=typeName,this.map={}}return TypePropertiesData.prototype.addProperty=function(prop){var name=prop.domain().nameId(),data=this.map[name];data||(data=new TypePropertiesData2(name),this.map[name]=data),data.addProperty(prop)},TypePropertiesData.prototype.print=function(){var _this=this;return this.typeName+":\n"+Object.keys(this.map).map(function(x){return"    "+_this.map[x].print()}).join("\n")},TypePropertiesData}(),TypePropertiesData2=function(){function TypePropertiesData2(typeName){this.typeName=typeName,this.map={}}return TypePropertiesData2.prototype.addProperty=function(prop){var name=prop.nameId();this.map[name]=prop},TypePropertiesData2.prototype.print=function(){return this.typeName+": "+Object.keys(this.map).sort().join(", ")},TypePropertiesData2}()},function(module,exports,__webpack_require__){(function(process){"use strict";var invariant=function(condition,format,a,b,c,d,e,f){if("production"!==process.env.NODE_ENV&&void 0===format)throw new Error("invariant requires an error message argument");if(!condition){var error;if(void 0===format)error=new Error("Minified exception occurred; use the non-minified dev environment for the full error message and additional helpful warnings.");else{var args=[a,b,c,d,e,f],argIndex=0;error=new Error(format.replace(/%s/g,function(){return args[argIndex++]})),error.name="Invariant Violation"}throw error.framesToPop=1,error}};module.exports=invariant}).call(exports,__webpack_require__(59))},function(module,exports,__webpack_require__){!function(root,pluralize){module.exports=pluralize()}(this,function(){function toTitleCase(str){return str.charAt(0).toUpperCase()+str.substr(1).toLowerCase()}function sanitizeRule(rule){return"string"==typeof rule?new RegExp("^"+rule+"$","i"):rule}function restoreCase(word,token){return word===word.toUpperCase()?token.toUpperCase():word[0]===word[0].toUpperCase()?toTitleCase(token):token.toLowerCase()}function interpolate(str,args){return str.replace(/\$(\d{1,2})/g,function(match,index){return args[index]||""})}function sanitizeWord(token,word,collection){if(!token.length||uncountables.hasOwnProperty(token))return word;for(var len=collection.length;len--;){var rule=collection[len];if(rule[0].test(word))return word.replace(rule[0],function(match,index,word){var result=interpolate(rule[1],arguments);return""===match?restoreCase(word[index-1],result):restoreCase(match,result)})}return word}function replaceWord(replaceMap,keepMap,rules){return function(word){var token=word.toLowerCase();return keepMap.hasOwnProperty(token)?restoreCase(word,token):replaceMap.hasOwnProperty(token)?restoreCase(word,replaceMap[token]):sanitizeWord(token,word,rules)}}function pluralize(word,count,inclusive){var pluralized=1===count?pluralize.singular(word):pluralize.plural(word);return(inclusive?count+" ":"")+pluralized}var pluralRules=[],singularRules=[],uncountables={},irregularPlurals={},irregularSingles={};return pluralize.plural=replaceWord(irregularSingles,irregularPlurals,pluralRules),pluralize.singular=replaceWord(irregularPlurals,irregularSingles,singularRules),pluralize.addPluralRule=function(rule,replacement){pluralRules.push([sanitizeRule(rule),replacement])},pluralize.addSingularRule=function(rule,replacement){singularRules.push([sanitizeRule(rule),replacement])},pluralize.addUncountableRule=function(word){return"string"==typeof word?void(uncountables[word.toLowerCase()]=!0):(pluralize.addPluralRule(word,"$0"),void pluralize.addSingularRule(word,"$0"))},pluralize.addIrregularRule=function(single,plural){plural=plural.toLowerCase(),single=single.toLowerCase(),irregularSingles[single]=plural,irregularPlurals[plural]=single},[["I","we"],["me","us"],["he","they"],["she","they"],["them","them"],["myself","ourselves"],["yourself","yourselves"],["itself","themselves"],["herself","themselves"],["himself","themselves"],["themself","themselves"],["is","are"],["this","these"],["that","those"],["echo","echoes"],["dingo","dingoes"],["volcano","volcanoes"],["tornado","tornadoes"],["torpedo","torpedoes"],["genus","genera"],["viscus","viscera"],["stigma","stigmata"],["stoma","stomata"],["dogma","dogmata"],["lemma","lemmata"],["schema","schemata"],["anathema","anathemata"],["ox","oxen"],["axe","axes"],["die","dice"],["yes","yeses"],["foot","feet"],["eave","eaves"],["goose","geese"],["tooth","teeth"],["quiz","quizzes"],["human","humans"],["proof","proofs"],["carve","carves"],["valve","valves"],["thief","thieves"],["genie","genies"],["groove","grooves"],["pickaxe","pickaxes"],["whiskey","whiskies"]].forEach(function(rule){return pluralize.addIrregularRule(rule[0],rule[1])}),[[/s?$/i,"s"],[/([^aeiou]ese)$/i,"$1"],[/(ax|test)is$/i,"$1es"],[/(alias|[^aou]us|tlas|gas|ris)$/i,"$1es"],[/(e[mn]u)s?$/i,"$1s"],[/([^l]ias|[aeiou]las|[emjzr]as|[iu]am)$/i,"$1"],[/(alumn|syllab|octop|vir|radi|nucle|fung|cact|stimul|termin|bacill|foc|uter|loc|strat)(?:us|i)$/i,"$1i"],[/(alumn|alg|vertebr)(?:a|ae)$/i,"$1ae"],[/(seraph|cherub)(?:im)?$/i,"$1im"],[/(her|at|gr)o$/i,"$1oes"],[/(agend|addend|millenni|dat|extrem|bacteri|desiderat|strat|candelabr|errat|ov|symposi|curricul|automat|quor)(?:a|um)$/i,"$1a"],[/(apheli|hyperbat|periheli|asyndet|noumen|phenomen|criteri|organ|prolegomen|hedr|automat)(?:a|on)$/i,"$1a"],[/sis$/i,"ses"],[/(?:(kni|wi|li)fe|(ar|l|ea|eo|oa|hoo)f)$/i,"$1$2ves"],[/([^aeiouy]|qu)y$/i,"$1ies"],[/([^ch][ieo][ln])ey$/i,"$1ies"],[/(x|ch|ss|sh|zz)$/i,"$1es"],[/(matr|cod|mur|sil|vert|ind|append)(?:ix|ex)$/i,"$1ices"],[/(m|l)(?:ice|ouse)$/i,"$1ice"],[/(pe)(?:rson|ople)$/i,"$1ople"],[/(child)(?:ren)?$/i,"$1ren"],[/eaux$/i,"$0"],[/m[ae]n$/i,"men"],["thou","you"]].forEach(function(rule){
return pluralize.addPluralRule(rule[0],rule[1])}),[[/s$/i,""],[/(ss)$/i,"$1"],[/((a)naly|(b)a|(d)iagno|(p)arenthe|(p)rogno|(s)ynop|(t)he)(?:sis|ses)$/i,"$1sis"],[/(^analy)(?:sis|ses)$/i,"$1sis"],[/(wi|kni|(?:after|half|high|low|mid|non|night|[^\w]|^)li)ves$/i,"$1fe"],[/(ar|(?:wo|[ae])l|[eo][ao])ves$/i,"$1f"],[/([^aeiouy]|qu)ies$/i,"$1y"],[/(^[pl]|zomb|^(?:neck)?t|[aeo][lt]|cut)ies$/i,"$1ie"],[/(\b(?:mon|smil))ies$/i,"$1ey"],[/(m|l)ice$/i,"$1ouse"],[/(seraph|cherub)im$/i,"$1"],[/(x|ch|ss|sh|zz|tto|go|cho|alias|[^aou]us|tlas|gas|(?:her|at|gr)o|ris)(?:es)?$/i,"$1"],[/(e[mn]u)s?$/i,"$1"],[/(movie|twelve)s$/i,"$1"],[/(cris|test|diagnos)(?:is|es)$/i,"$1is"],[/(alumn|syllab|octop|vir|radi|nucle|fung|cact|stimul|termin|bacill|foc|uter|loc|strat)(?:us|i)$/i,"$1us"],[/(agend|addend|millenni|dat|extrem|bacteri|desiderat|strat|candelabr|errat|ov|symposi|curricul|quor)a$/i,"$1um"],[/(apheli|hyperbat|periheli|asyndet|noumen|phenomen|criteri|organ|prolegomen|hedr|automat)a$/i,"$1on"],[/(alumn|alg|vertebr)ae$/i,"$1a"],[/(cod|mur|sil|vert|ind)ices$/i,"$1ex"],[/(matr|append)ices$/i,"$1ix"],[/(pe)(rson|ople)$/i,"$1rson"],[/(child)ren$/i,"$1"],[/(eau)x?$/i,"$1"],[/men$/i,"man"]].forEach(function(rule){return pluralize.addSingularRule(rule[0],rule[1])}),["advice","agenda","bison","bream","buffalo","carp","chassis","cod","cooperation","corps","digestion","debris","diabetes","energy","equipment","elk","excretion","expertise","flounder","gallows","garbage","graffiti","headquarters","health","herpes","highjinks","homework","information","jeans","justice","kudos","labour","machinery","mackerel","media","mews","moose","news","pike","plankton","pliers","pollution","premises","rain","rice","salmon","scissors","series","sewage","shambles","shrimp","species","staff","swine","trout","tuna","whiting","wildebeest","wildlife","you",/pox$/i,/ois$/i,/deer$/i,/fish$/i,/sheep$/i,/measles$/i,/[^aeiou]ese$/i].forEach(pluralize.addUncountableRule),pluralize})},function(module,exports,__webpack_require__){exports.dot=exports.dotCase=__webpack_require__(116),exports.swap=exports.swapCase=__webpack_require__(117),exports.path=exports.pathCase=__webpack_require__(118),exports.upper=exports.upperCase=__webpack_require__(119),exports.lower=exports.lowerCase=__webpack_require__(120),exports.camel=exports.camelCase=__webpack_require__(121),exports.snake=exports.snakeCase=__webpack_require__(122),exports.title=exports.titleCase=__webpack_require__(123),exports.param=exports.paramCase=__webpack_require__(124),exports.pascal=exports.pascalCase=__webpack_require__(125),exports.constant=exports.constantCase=__webpack_require__(126),exports.sentence=exports.sentenceCase=__webpack_require__(127),exports.isUpper=exports.isUpperCase=__webpack_require__(128),exports.isLower=exports.isLowerCase=__webpack_require__(129),exports.ucFirst=exports.upperCaseFirst=__webpack_require__(130),exports.lcFirst=exports.lowerCaseFirst=__webpack_require__(131)},function(module,exports,__webpack_require__){"use strict";function doRequest(method,url,options,callback){var result=new Promise(function(resolve,reject){function attempt(n){doRequest(method,url,{qs:options.qs,headers:options.headers,timeout:options.timeout}).nodeify(function(err,res){var retry=err||res.statusCode>=400;if("function"==typeof options.retry&&(retry=options.retry(err,res,n+1)),n>=(5|options.maxRetries)&&(retry=!1),retry){var delay=options.retryDelay;"function"==typeof options.retryDelay&&(delay=options.retryDelay(err,res,n+1)),delay=delay||200,setTimeout(function(){attempt(n+1)},delay)}else err?reject(err):resolve(res)})}var xhr=new window.XMLHttpRequest;if("string"!=typeof method)throw new TypeError("The method must be a string.");if("string"!=typeof url)throw new TypeError("The URL/path must be a string.");if("function"==typeof options&&(callback=options,options={}),(null===options||void 0===options)&&(options={}),"object"!=typeof options)throw new TypeError("Options must be an object (or null).");if("function"!=typeof callback&&(callback=void 0),method=method.toUpperCase(),options.headers=options.headers||{},options.retry&&"GET"===method)return attempt(0);var match,crossDomain=!(!(match=/^([\w-]+:)?\/\/([^\/]+)/.exec(url))||match[2]==window.location.host);if(crossDomain||(options.headers["X-Requested-With"]="XMLHttpRequest"),options.qs&&(url=handleQs(url,options.qs)),options.json&&(options.body=JSON.stringify(options.json),options.headers["Content-Type"]="application/json"),options.timeout){xhr.timeout=options.timeout;var start=Date.now();xhr.ontimeout=function(){var duration=Date.now()-start,err=new Error("Request timed out after "+duration+"ms");err.timeout=!0,err.duration=duration,reject(err)}}xhr.onreadystatechange=function(){if(4===xhr.readyState){var headers={};xhr.getAllResponseHeaders().split("\r\n").forEach(function(header){var h=header.split(":");h.length>1&&(headers[h[0].toLowerCase()]=h.slice(1).join(":").trim())});var res=new Response(xhr.status,headers,xhr.responseText);res.url=url,resolve(res)}},xhr.open(method,url,!0);for(var name in options.headers)xhr.setRequestHeader(name,options.headers[name]);xhr.send(options.body?options.body:null)});return result.getBody=function(){return result.then(function(res){return res.getBody()})},result.nodeify(callback)}var Promise=__webpack_require__(115),Response=__webpack_require__(63),handleQs=__webpack_require__(90);module.exports=doRequest},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(root,factory){"use strict";"object"==typeof module&&"object"==typeof module.exports?module.exports=factory():(__WEBPACK_AMD_DEFINE_ARRAY__=[],__WEBPACK_AMD_DEFINE_FACTORY__=factory,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}("object"==typeof window?window:this,function(){"use strict";function CacheState(capacity){this.capacity=capacity>0?+capacity:Number.MAX_VALUE,this.data=Object.create?Object.create(null):{},this.hash=Object.create?Object.create(null):{},this.linkedList={length:0,head:null,end:null}}function LRUCache(capacity){return this instanceof LRUCache?void(this._LRUCacheState=new CacheState(capacity)):new LRUCache(capacity)}function refresh(linkedList,entry){entry!==linkedList.head&&(linkedList.end?linkedList.end===entry&&(linkedList.end=entry.n):linkedList.end=entry,link(entry.n,entry.p),link(entry,linkedList.head),linkedList.head=entry,linkedList.head.n=null)}function link(nextEntry,prevEntry){nextEntry!==prevEntry&&(nextEntry&&(nextEntry.p=prevEntry),prevEntry&&(prevEntry.n=nextEntry))}var proto=LRUCache.prototype;return proto.get=function(key){var state=this._LRUCacheState,lruEntry=state.hash[key];return lruEntry?(refresh(state.linkedList,lruEntry),state.data[key]):void 0},proto.set=function(key,value){var state=this._LRUCacheState,lruEntry=state.hash[key];return void 0===value?this:(lruEntry||(state.hash[key]={key:key},state.linkedList.length+=1,lruEntry=state.hash[key]),refresh(state.linkedList,lruEntry),state.data[key]=value,state.linkedList.length>state.capacity&&this.remove(state.linkedList.end.key),this)},proto.update=function(key,parseFn){this._LRUCacheState;if(this.has(key)){var data=this.get(key);this.set(key,parseFn(data))}return this},proto.remove=function(key){var state=this._LRUCacheState,lruEntry=state.hash[key];return lruEntry?(lruEntry===state.linkedList.head&&(state.linkedList.head=lruEntry.p),lruEntry===state.linkedList.end&&(state.linkedList.end=lruEntry.n),link(lruEntry.n,lruEntry.p),delete state.hash[key],delete state.data[key],state.linkedList.length-=1,this):this},proto.removeAll=function(){return this._LRUCacheState=new CacheState(this._LRUCacheState.capacity),this},proto.info=function(){var state=this._LRUCacheState;return{capacity:state.capacity,length:state.linkedList.length}},proto.keys=function(){for(var state=this._LRUCacheState,keys=[],lruEntry=state.linkedList.head;lruEntry;)keys.push(lruEntry.key),lruEntry=lruEntry.p;return keys},proto.has=function(key){return!!this._LRUCacheState.hash[key]},proto.staleKey=function(){return this._LRUCacheState.linkedList.end&&this._LRUCacheState.linkedList.end.key},proto.popStale=function(){var staleKey=this.staleKey();if(!staleKey)return null;var stale=[staleKey,this._LRUCacheState.data[staleKey]];return this.remove(staleKey),stale},LRUCache.NAME="LRUCache",LRUCache.VERSION="v0.2.0",LRUCache})},function(module,exports,__webpack_require__){"use strict";function newMapping(key,value){var end=value?value.endPosition:key.endPosition+1,node={key:key,value:value,startPosition:key.startPosition,endPosition:end,kind:Kind.MAPPING,parent:null,errors:[]};return node}function newAnchorRef(key,start,end,value){return{errors:[],referencesAnchor:key,value:value,startPosition:start,endPosition:end,kind:Kind.ANCHOR_REF,parent:null}}function newScalar(v){return void 0===v&&(v=""),{errors:[],startPosition:-1,endPosition:-1,value:v,kind:Kind.SCALAR,parent:null,doubleQuoted:!1}}function newItems(){return{errors:[],startPosition:-1,endPosition:-1,items:[],kind:Kind.SEQ,parent:null}}function newSeq(){return newItems()}function newMap(mappings){return{errors:[],startPosition:-1,endPosition:-1,mappings:mappings?mappings:[],kind:Kind.MAP,parent:null}}var loader=__webpack_require__(83),dumper=__webpack_require__(84),YAMLException=function(){function YAMLException(reason,mark){void 0===mark&&(mark=null),this.name="YAMLException",this.reason=reason,this.mark=mark,this.message=this.toString(!1)}return YAMLException.prototype.toString=function(compact){void 0===compact&&(compact=!1);var result;return result="JS-YAML: "+(this.reason||"(unknown reason)"),!compact&&this.mark&&(result+=" "+this.mark.toString()),result},YAMLException}();exports.YAMLException=YAMLException,function(Kind){Kind[Kind.SCALAR=0]="SCALAR",Kind[Kind.MAPPING=1]="MAPPING",Kind[Kind.MAP=2]="MAP",Kind[Kind.SEQ=3]="SEQ",Kind[Kind.ANCHOR_REF=4]="ANCHOR_REF",Kind[Kind.INCLUDE_REF=5]="INCLUDE_REF"}(exports.Kind||(exports.Kind={}));var Kind=exports.Kind;exports.newMapping=newMapping,exports.newAnchorRef=newAnchorRef,exports.newScalar=newScalar,exports.newItems=newItems,exports.newSeq=newSeq,exports.newMap=newMap,exports.load=loader.load,exports.loadAll=loader.loadAll,exports.safeLoad=loader.safeLoad,exports.dump=dumper.dump,exports.safeDump=dumper.safeDump},function(module,exports,__webpack_require__){function DOMParser(options){this.options=options||{locator:{}}}function buildErrorHandler(errorImpl,domBuilder,locator){function build(key){var fn=errorImpl[key];!fn&&isCallback&&(fn=2==errorImpl.length?function(msg){errorImpl(key,msg)}:errorImpl),errorHandler[key]=fn&&function(msg){fn("[xmldom "+key+"]	"+msg+_locator(locator))}||function(){}}if(!errorImpl){if(domBuilder instanceof DOMHandler)return domBuilder;errorImpl=domBuilder}var errorHandler={},isCallback=errorImpl instanceof Function;return locator=locator||{},build("warning"),build("error"),build("fatalError"),errorHandler}function DOMHandler(){this.cdata=!1}function position(locator,node){node.lineNumber=locator.lineNumber,node.columnNumber=locator.columnNumber}function _locator(l){return l?"\n@"+(l.systemId||"")+"#[line:"+l.lineNumber+",col:"+l.columnNumber+"]":void 0}function _toString(chars,start,length){return"string"==typeof chars?chars.substr(start,length):chars.length>=start+length||start?new java.lang.String(chars,start,length)+"":chars}function appendElement(hander,node){hander.currentElement?hander.currentElement.appendChild(node):hander.document.appendChild(node)}DOMParser.prototype.parseFromString=function(source,mimeType){var options=this.options,sax=new XMLReader,domBuilder=options.domBuilder||new DOMHandler,errorHandler=options.errorHandler,locator=options.locator,defaultNSMap=options.xmlns||{},entityMap={lt:"<",gt:">",amp:"&",quot:'"',apos:"'"};return locator&&domBuilder.setDocumentLocator(locator),sax.errorHandler=buildErrorHandler(errorHandler,domBuilder,locator),sax.domBuilder=options.domBuilder||domBuilder,/\/x?html?$/.test(mimeType)&&(entityMap.nbsp=" ",entityMap.copy="©",defaultNSMap[""]="http://www.w3.org/1999/xhtml"),defaultNSMap.xml=defaultNSMap.xml||"http://www.w3.org/XML/1998/namespace",source?sax.parse(source,defaultNSMap,entityMap):sax.errorHandler.error("invalid document source"),domBuilder.document},DOMHandler.prototype={startDocument:function(){this.document=(new DOMImplementation).createDocument(null,null,null),this.locator&&(this.document.documentURI=this.locator.systemId)},startElement:function(namespaceURI,localName,qName,attrs){var doc=this.document,el=doc.createElementNS(namespaceURI,qName||localName),len=attrs.length;appendElement(this,el),this.currentElement=el,this.locator&&position(this.locator,el);for(var i=0;len>i;i++){var namespaceURI=attrs.getURI(i),value=attrs.getValue(i),qName=attrs.getQName(i),attr=doc.createAttributeNS(namespaceURI,qName);attr.getOffset&&position(attr.getOffset(1),attr),attr.value=attr.nodeValue=value,el.setAttributeNode(attr)}},endElement:function(namespaceURI,localName,qName){var current=this.currentElement;current.tagName;this.currentElement=current.parentNode},startPrefixMapping:function(prefix,uri){},endPrefixMapping:function(prefix){},processingInstruction:function(target,data){var ins=this.document.createProcessingInstruction(target,data);this.locator&&position(this.locator,ins),appendElement(this,ins)},ignorableWhitespace:function(ch,start,length){},characters:function(chars,start,length){if(chars=_toString.apply(this,arguments),this.currentElement&&chars){if(this.cdata){var charNode=this.document.createCDATASection(chars);this.currentElement.appendChild(charNode)}else{var charNode=this.document.createTextNode(chars);this.currentElement.appendChild(charNode)}this.locator&&position(this.locator,charNode)}},skippedEntity:function(name){},endDocument:function(){this.document.normalize()},setDocumentLocator:function(locator){(this.locator=locator)&&(locator.lineNumber=0)},comment:function(chars,start,length){chars=_toString.apply(this,arguments);var comm=this.document.createComment(chars);this.locator&&position(this.locator,comm),appendElement(this,comm)},startCDATA:function(){this.cdata=!0},endCDATA:function(){this.cdata=!1},startDTD:function(name,publicId,systemId){var impl=this.document.implementation;if(impl&&impl.createDocumentType){var dt=impl.createDocumentType(name,publicId,systemId);this.locator&&position(this.locator,dt),appendElement(this,dt)}},warning:function(error){console.warn("[xmldom warning]	"+error,_locator(this.locator))},error:function(error){console.error("[xmldom error]	"+error,_locator(this.locator))},fatalError:function(error){throw console.error("[xmldom fatalError]	"+error,_locator(this.locator)),error}},"endDTD,startEntity,endEntity,attributeDecl,elementDecl,externalEntityDecl,internalEntityDecl,resolveEntity,getExternalSubset,notationDecl,unparsedEntityDecl".replace(/\w+/g,function(key){DOMHandler.prototype[key]=function(){return null}});var XMLReader=__webpack_require__(85).XMLReader,DOMImplementation=exports.DOMImplementation=__webpack_require__(86).DOMImplementation;exports.XMLSerializer=__webpack_require__(86).XMLSerializer,exports.DOMParser=DOMParser},function(module,exports,__webpack_require__){"use strict";function isEmpty(value){return null==value}function toString(value){return isEmpty(value)?"":String(value)}function toBoolean(value){return-1===[0,!1,"","0","false"].indexOf(value)}function toNumber(value){return isFinite(value)?Number(value):null}function toInteger(value){return value%1===0?Number(value):null}function toDate(value){return isNaN(Date.parse(value))?null:new Date(value)}function toSanitization(parameter,rules,types){var parameters=Array.isArray(parameter)?parameter:[parameter],sanitizations=parameters.map(function(parameter){function sanitize(value,key,src){for(var i=0;i<fns.length;i++){var fn=fns[i],value=fn(value,key,src);if(null!=value)return value}return null}var fns=[],typeSanitization=types[parameter.type];return"function"==typeof typeSanitization&&fns.push(typeSanitization),Object.keys(parameter).filter(function(key){return"type"!==key&&"repeat"!==key&&"default"!==key}).forEach(function(key){var fn=rules[key];"function"==typeof fn&&fns.push(fn(parameter[key],key))}),function(value,key,src){if(isEmpty(value))return null!=parameter["default"]?sanitize(parameter["default"],key,src):parameter.repeat&&!parameter.required?[]:value;if(parameter.repeat){var values=Array.isArray(value)?value:[value];return values=values.map(function(value){return sanitize(value,key,src)}),values.some(isEmpty)?null:value}if(Array.isArray(value)){if(value.length>1)return null;value=value[0]}return sanitize(value,key,src)}});return function(value,key,src){for(var i=0;i<sanitizations.length;i++){var sanitization=sanitizations[i],result=sanitization(value,key,src);if(null!=result)return result}return value}}function sanitize(){function rule(parameter){return toSanitization(parameter,RULES,TYPES)}var s,RULES={},TYPES={string:toString,number:toNumber,integer:toInteger,"boolean":toBoolean,date:toDate},sanitize=function(parameterMap){if(!parameterMap)return function(){return{}};var sanitizations={};return Object.keys(parameterMap).forEach(function(key){sanitizations[key]=sanitize.rule(parameterMap[key])}),function(src){src=src||{};var dest={};return Object.keys(sanitizations).forEach(function(key){var value=src[key],fn=sanitizations[key];Object.prototype.hasOwnProperty.call(src,key)&&(dest[key]=fn(value,key,src))}),dest}};return s=sanitize,s.rule=rule,s.TYPES=TYPES,s.RULES=RULES,s}exports.sanitize=sanitize},function(module,exports,__webpack_require__){(function(Buffer){"use strict";function isDateType(check){return"[object Date]"===_toString.call(check)&&!isNaN(check.getTime())}function isBooleanType(check){return"boolean"==typeof check}function isStringType(check){return"string"==typeof check}function isIntegerType(check){return"number"==typeof check&&check%1===0}function isNumberType(check){return"number"==typeof check&&isFinite(check)}function isMinimum(min){return function(check){return check>=min}}function isMaximum(max){return function(check){return max>=check}}function isMinimumLength(min){return function(check){return Buffer.byteLength(check)>=min}}function isMaximumLength(max){return function(check){return Buffer.byteLength(check)<=max}}function isEnum(values){return values&&0!=values.length?function(check){return values.indexOf(check)>-1}:function(check){return!0}}function isPattern(pattern){var regexp="string"==typeof pattern?new RegExp(pattern):pattern;return regexp.test.bind(regexp)}function toValidationResult(valid,key,value,rule,attr){return{valid:valid,rule:rule,attr:attr,value:value,key:key}}function toValidationFunction(parameter,rules){var validations=[];return Object.keys(parameter).forEach(function(name){var rule=rules[name];if(rule){var value=parameter[name];validations.push([name,rule(value,name),value])}}),function(value,key,src){for(var i=0;i<validations.length;i++){var validation=validations[i],name=validation[0],fn=validation[1],attr=validation[2],valid=fn(value,key,src);if(!valid)return toValidationResult(!1,key,value,name,attr)}return toValidationResult(!0,key,value)}}function toValidation(parameter,rules,types){var parameters=Array.isArray(parameter)?parameter:[parameter],isOptional=!parameters.length,simpleValidations=[],repeatValidations=[];return parameters.forEach(function(parameter){var validation=[parameter.type||"string",toValidationFunction(parameter,rules)];parameter.required||(isOptional=!0),parameter.repeat?repeatValidations.push(validation):simpleValidations.push(validation)}),function(value,key,src){if(null==value)return toValidationResult(isOptional,key,value,"required",!isOptional);var isArray=Array.isArray(value),values=isArray?value:[value],validations=isArray?repeatValidations:simpleValidations;if(!validations.length)return toValidationResult(!1,key,value,"repeat",!isArray);var response=null,originalValue=value;return validations.some(function(validation){var isValidType=values.every(function(value){var paramType=validation[0],isValidType=types[paramType]&&types[paramType](value,key,src);return isValidType||(response=toValidationResult(!1,key,originalValue,"type",paramType)),isValidType});return isValidType?(values.every(function(value){var fn=validation[1];return response=fn(value,key),response.valid}),!0):!1}),response}}function validate(){function rule(parameter){return toValidation(parameter,RULES,TYPES)}var v,TYPES={date:isDateType,number:isNumberType,integer:isIntegerType,"boolean":isBooleanType,string:isStringType},RULES={minimum:isMinimum,maximum:isMaximum,minLength:isMinimumLength,maxLength:isMaximumLength,"enum":isEnum,pattern:isPattern},validate=function(parameterMap){if(!parameterMap)return function(check){return{valid:!0,errors:[]}};var validations={};return Object.keys(parameterMap).forEach(function(key){validations[key]=rule(parameterMap[key])}),function(src){src=src||{};var errors=Object.keys(validations).map(function(param){var value=src[param],fn=validations[param];return fn(value,param,src)}).filter(function(result){return!result.valid});return{valid:0===errors.length,errors:errors}}};return v=validate,v.rule=rule,v.TYPES=TYPES,v.RULES=RULES,v}var _toString=Object.prototype.toString;exports.validate=validate}).call(exports,__webpack_require__(92).Buffer)},function(module,exports,__webpack_require__){"use strict";function handleTypeAnnotation(a,rangeType){"MetaModel.declaresSubTypeOf"==a.name&&rangeType.getAdapter(services.RAMLService).setExtendedTypeName(a.arguments[0]),"MetaModel.nameAtRuntime"==a.name&&rangeType.setNameAtRuntime(a.arguments[0]),"MetaModel.description"==a.name&&rangeType.withDescription(a.arguments[0]),"MetaModel.inlinedTemplates"==a.name&&rangeType.getAdapter(services.RAMLService).setInlinedTemplates(!0),"MetaModel.requireValue"==a.name&&rangeType.getAdapter(services.RAMLService).withContextRequirement(""+a.arguments[0],""+a.arguments[1]),"MetaModel.referenceIs"==a.name&&rangeType.getAdapter(services.RAMLService).withReferenceIs(""+a.arguments[0]),"MetaModel.actuallyExports"==a.name&&rangeType.getAdapter(services.RAMLService).withActuallyExports(""+a.arguments[0]),"MetaModel.convertsToGlobalOfType"==a.name&&rangeType.getAdapter(services.RAMLService).withConvertsToGlobal(""+a.arguments[0]),"MetaModel.allowAny"==a.name&&rangeType.getAdapter(services.RAMLService).withAllowAny(),"MetaModel.allowQuestion"==a.name&&rangeType.getAdapter(services.RAMLService).withAllowQuestion(),"MetaModel.alias"==a.name&&rangeType.getAdapter(services.RAMLService).addAlias(""+a.arguments[0]),"MetaModel.consumesRefs"==a.name&&rangeType.getAdapter(services.RAMLService).setConsumesRefs(!0),"MetaModel.canInherit"==a.name&&rangeType.getAdapter(services.RAMLService).withCanInherit(""+a.arguments[0]),"MetaModel.definingPropertyIsEnough"==a.name&&rangeType.getAdapter(services.RAMLService).definingPropertyIsEnough(""+a.arguments[0]),"MetaModel.customHandling"==a.name&&rangeType.setCustom(!0),"MetaModel.superclasses"==a.name&&rangeType.getAdapter(services.RAMLService).registerSupertypes(a.arguments[0]),"MetaModel.possibleInterfaces"==a.name&&rangeType.getAdapter(services.RAMLService).registerPossibleInterfaces(a.arguments[0])}function recordAnnotation(p,a){exports.annotationHandlers[a.name](a,p)}var def=__webpack_require__(36),khttp=__webpack_require__(136),_=__webpack_require__(89),services=def;exports.handleTypeAnnotation=handleTypeAnnotation,exports.annotationHandlers={key:function(a,f){f.withFromParentKey(),f.withKey(!0)},value:function(a,f){f.withFromParentValue()},canBeValue:function(a,f){f.withCanBeValue()},unmerged:function(a,f){f.unmerge()},startFrom:function(a,f){f.withKeyRestriction(a.arguments[0]),f.merge()},oneOf:function(a,f){f.withEnumOptions(a.arguments[0])},oftenKeys:function(a,f){f.withOftenKeys(a.arguments[0])},embeddedInMaps:function(a,f){f.getAdapter(services.RAMLPropertyParserService).withEmbedMap()},system:function(a,f){f.getAdapter(services.RAMLPropertyParserService).withSystem(!0)},required:function(a,f){"false"!=a.arguments[0]&&a.arguments[0]!==!1&&f.withRequired(!0)},noDirectParse:function(a,f){"false"!=a.arguments[0]&&a.arguments[0]!==!1&&f.withNoDirectParse()},setsContextValue:function(a,f){f.addChildValueConstraint(new def.ChildValueConstraint(""+a.arguments[0],""+a.arguments[1]))},defaultValue:function(a,f){f.setDefaultVal(""+a.arguments[0])},defaultIntegerValue:function(a,f){f.setDefaultIntegerVal(a.arguments[0])},defaultBooleanValue:function(a,f){f.setDefaultBooleanVal(a.arguments[0])},facetId:function(a,f){"minItems"==a.arguments[0]&&f.setFacetValidator(function(x,f){if(x instanceof Array){var length=Number.parseInt(""+f.value());if(length>x.length)return"array should contain at least "+f.value()+" items"}return null}),"enum"==a.arguments[0]&&f.setFacetValidator(function(x,f){var validateAgainst=x+"",array=f;try{if(!array.some(function(x){return x==validateAgainst}))return"value should be one of :"+array.join(",")}catch(e){return}return null}),"maxItems"==a.arguments[0]&&f.setFacetValidator(function(x,f){if(x instanceof Array){var length=Number.parseInt(""+f);if(length<x.length)return"array should contain not more then "+f.value()+" items"}return null}),"minProperties"==a.arguments[0]&&f.setFacetValidator(function(x,f){if(x instanceof Object){var length=Number.parseInt(""+f);if(length>Object.keys(x).length)return"object should contain at least "+f.value()+" properties"}return null}),"maxProperties"==a.arguments[0]&&f.setFacetValidator(function(x,f){if(x instanceof Object){var length=Number.parseInt(""+f);if(length<Object.keys(x).length)return"object should contain not more then "+f.value()+" properties"}return null}),"uniqueItems"==a.arguments[0]&&f.setFacetValidator(function(x,f){if(f instanceof Array){var length=_.unique(f).length;if(length<f.length)return"array should contain only unique items"}return null}),"minLength"==a.arguments[0]&&f.setFacetValidator(function(x,f){if(("number"==typeof x||"boolean"==typeof x)&&(x=""+x),"string"==typeof x){var length=Number.parseInt(""+f);if(length>x.length)return"string length should be at least "+length}return null}),"maxLength"==a.arguments[0]&&f.setFacetValidator(function(x,f){if(("number"==typeof x||"boolean"==typeof x)&&(x=""+x),"string"==typeof x){var length=Number.parseInt(""+f);if(length<x.length)return"string length should be not more then "+length}return null}),"minimum"==a.arguments[0]&&f.setFacetValidator(function(x,f){if("string"==typeof x&&(x=parseFloat(x)),"number"==typeof x){var length=parseFloat(f);if(length>x)return"value should be not less then "+length}return null}),"maximum"==a.arguments[0]&&f.setFacetValidator(function(x,f){if("string"==typeof x&&(x=parseFloat(x)),"number"==typeof x){var length=parseFloat(f);if(x>length)return"value should be not more then "+length}return null}),"pattern"==a.arguments[0]&&f.setFacetValidator(function(x,f){if(("number"==typeof x||"boolean"==typeof x)&&(x=""+x),"string"==typeof x){var regExp=new RegExp(f);if(!regExp.test(x))return"string should match to "+f}return null})},extraMetaKey:function(a,f){"statusCodes"==a.arguments[0]&&(f.withOftenKeys(khttp.statusCodes.filter(function(statusCode){return statusCode.code.indexOf("x")<0}).map(function(x){return x.code})),f.setValueDocProvider(function(name){var s=_.find(khttp.statusCodes,function(x){return x.code==name});return s?name+":"+s.description:null})),"headers"==a.arguments[0]&&(f.setValueSuggester(function(x){if(x.property()){var c=x.property().getChildValueConstraints();if(_.find(c,function(x){return"location"==x.name&&"Params.ParameterLocation.HEADERS"==x.value}))return khttp.headers.map(function(x){return x.header});if(x.property()&&"headers"==x.property().nameId())return khttp.headers.map(function(x){return x.header})}return null}),f.setValueDocProvider(function(name){var s=_.find(khttp.headers,function(x){return x.header==name});return s?name+":"+s.description:null})),"methods"==a.arguments[0]&&f.setValueDocProvider(function(name){var s=_.find(khttp.methods,function(x){return x.method==name.toUpperCase()});return s?name+":"+s.description:null})},requireValue:function(a,f){f.withContextRequirement(""+a.arguments[0],""+a.arguments[1])},allowMultiple:function(a,f){f.withMultiValue(!0)},constraint:function(a,f){},newInstanceName:function(a,f){f.withNewInstanceName(""+a.arguments[0])},declaringFields:function(a,f){f.withThisPropertyDeclaresFields()},describesAnnotation:function(a,f){f.withDescribes(a.arguments[0])},allowNull:function(a,f){f.withAllowNull()},descriminatingProperty:function(a,f){f.withDescriminating(!0)},description:function(a,f){f.withDescription(""+a.arguments[0])},inherited:function(a,f){f.withInherited(!0)},selfNode:function(a,f){f.withSelfNode()},grammarTokenKind:function(a,f){f.getAdapter(services.RAMLPropertyService).withPropertyGrammarType(""+a.arguments[0])},canInherit:function(a,f){f.withInheritedContextValue(""+a.arguments[0])},canBeDuplicator:function(a,f){f.setCanBeDuplicator()},example:function(a,f){f.getAdapter(services.RAMLPropertyService).setExample(!0)},typeExpression:function(a,f){f.getAdapter(services.RAMLPropertyService).setTypeExpression(!0)},hide:function(a,f){0==a.arguments.length?f.getAdapter(services.RAMLPropertyDocumentationService).setHidden(!0):f.getAdapter(services.RAMLPropertyDocumentationService).setHidden(a.arguments[0])},documentationTableLabel:function(a,f){f.getAdapter(services.RAMLPropertyDocumentationService).setDocTableName(""+a.arguments[0])},markdownDescription:function(a,f){f.getAdapter(services.RAMLPropertyDocumentationService).setMarkdownDescription(""+a.arguments[0])},valueDescription:function(a,f){f.getAdapter(services.RAMLPropertyDocumentationService).setValueDescription(null!=a.arguments[0]?""+a.arguments[0]:null)},customHandling:function(a,f){}},exports.recordAnnotation=recordAnnotation},function(module,exports,__webpack_require__){(function(global){(function(){var vm,__slice=[].slice;vm=__webpack_require__(108),exports.allowUnsafeEval=function(fn){var previousEval;previousEval=global.eval;try{return global.eval=function(source){return vm.runInThisContext(source)},fn()}finally{global.eval=previousEval}},exports.allowUnsafeNewFunction=function(fn){var previousFunction;previousFunction=global.Function;try{return global.Function=exports.Function,fn()}finally{global.Function=previousFunction}},exports.Function=function(){var body,paramList,paramLists,params,_i,_j,_len;for(paramLists=2<=arguments.length?__slice.call(arguments,0,_i=arguments.length-1):(_i=0,[]),body=arguments[_i++],params=[],_j=0,_len=paramLists.length;_len>_j;_j++)paramList=paramLists[_j],"string"==typeof paramList&&(paramList=paramList.split(/\s*,\s*/)),params.push.apply(params,paramList);return vm.runInThisContext("(function("+params.join(", ")+") {\n  "+body+"\n})")},exports.Function.prototype=global.Function.prototype}).call(this)}).call(exports,function(){return this}())},function(module,exports,__webpack_require__){"use strict";function getSchemaUtils(){return schemaUtil}function isParsedType(object){return object instanceof ts.AbstractType}function loadTypeCollection(data,registry){return void 0===registry&&(registry=ts.builtInRegistry()),tc.parseJSONTypeCollection(data,registry)}function loadType(data){return tc.parseJSON(null,data,ts.builtInRegistry())}function parse(data){return data.types||data.annotationTypes?tc.parseJSONTypeCollection(data):tc.parseJSON(null,data)}function parseType(data,collection){return tc.parseJSON(null,data,collection?collection.getTypeRegistry():ts.builtInRegistry())}function parseFromAST(data){return tc.parseTypeCollection(data,ts.builtInRegistry())}function parseTypeFromAST(name,data,collection,defaultsToAny,annotation,global,ignoreTypeAttr){if(void 0===defaultsToAny&&(defaultsToAny=!1),
void 0===annotation&&(annotation=!1),void 0===global&&(global=!0),void 0===ignoreTypeAttr&&(ignoreTypeAttr=!1),global){var t;if(t=annotation?collection.getAnnotationType(name):collection.getType(name),null!=t)return t}return tc.parse(name,data,collection?collection.getTypeRegistry():ts.builtInRegistry(),defaultsToAny,annotation,global,ignoreTypeAttr)}function dump(ts){return tc.storeAsJSON(ts)}function validate(i,t,autoClose){void 0===autoClose&&(autoClose=!1),ts.autoCloseFlag=autoClose;try{return t.validate(i,autoClose)}finally{ts.autoCloseFlag=!1}}function validateTypeDefinition(t,collection){return t.validateType(collection.getAnnotationTypeRegistry())}function performAC(i,t){return t.ac(i)}function checkACStatus(t){return t.canDoAc()}function builtInFacets(){return fr.getInstance().allPrototypes()}function builtInTypes(){return ts.builtInRegistry()}function derive(name){for(var types=[],_i=1;_i<arguments.length;_i++)types[_i-1]=arguments[_i];return ts.derive(name,types)}function unify(name){for(var types=[],_i=1;_i<arguments.length;_i++)types[_i-1]=arguments[_i];return ts.union(name,types)}function setPropertyConstructor(c){nm.setPropertyConstructor(c)}function toNominal(t,bt){return nm.toNominal(t,bt)}var ts=__webpack_require__(93);exports.tsInterfaces=__webpack_require__(94);var tc=__webpack_require__(95),fr=__webpack_require__(96),restrictions_1=__webpack_require__(97),metainfo_1=__webpack_require__(98),metainfo_2=__webpack_require__(98),metainfo_3=__webpack_require__(98),nm=__webpack_require__(99);exports.nominalTypes=__webpack_require__(100),exports.nominalInterfaces=__webpack_require__(101),exports.typeExpressions=__webpack_require__(102);var schemaUtil=__webpack_require__(103);exports.TOP_LEVEL_EXTRA=exports.tsInterfaces.TOP_LEVEL_EXTRA,exports.DEFINED_IN_TYPES_EXTRA=exports.tsInterfaces.DEFINED_IN_TYPES_EXTRA,exports.USER_DEFINED_EXTRA=exports.tsInterfaces.USER_DEFINED_EXTRA,exports.SOURCE_EXTRA=exports.tsInterfaces.SOURCE_EXTRA,exports.getSchemaUtils=getSchemaUtils,exports.isParsedType=isParsedType,exports.loadTypeCollection=loadTypeCollection,exports.loadType=loadType,exports.parse=parse,exports.parseType=parseType,function(NodeKind){NodeKind[NodeKind.SCALAR=0]="SCALAR",NodeKind[NodeKind.ARRAY=1]="ARRAY",NodeKind[NodeKind.MAP=2]="MAP"}(exports.NodeKind||(exports.NodeKind={}));exports.NodeKind;exports.parseFromAST=parseFromAST,exports.parseTypeFromAST=parseTypeFromAST,exports.dump=dump,exports.validate=validate,exports.validateTypeDefinition=validateTypeDefinition,exports.performAC=performAC,exports.checkACStatus=checkACStatus,exports.builtInFacets=builtInFacets,exports.builtInTypes=builtInTypes,exports.derive=derive,exports.unify=unify;var TypeConstructor=function(){function TypeConstructor(target){this.target=target}return TypeConstructor.prototype.addProperty=function(name,type,optional){return this.target.declareProperty(name,type,optional),this},TypeConstructor.prototype.closeType=function(){return this.target.addMeta(new restrictions_1.KnownPropertyRestriction(!1)),this},TypeConstructor.prototype.annotate=function(name,value){return this.target.addMeta(new metainfo_1.Annotation(name,value)),this},TypeConstructor.prototype.customFacet=function(name,value){return this.target.addMeta(new metainfo_2.CustomFacet(name,value)),this},TypeConstructor.prototype.customFacetDeclaration=function(name,value,optional){return void 0===optional&&(optional=!0),this.target.addMeta(new metainfo_3.FacetDeclaration(name,value,optional)),this},TypeConstructor.prototype.addSimpleFacet=function(name,value){return this.target.addMeta(fr.getInstance().buildFacet(name,value)),this},TypeConstructor.prototype.getResult=function(){return this.target},TypeConstructor}();exports.TypeConstructor=TypeConstructor,exports.setPropertyConstructor=setPropertyConstructor,exports.toNominal=toNominal},function(module,exports,__webpack_require__){"use strict";exports.decode=exports.parse=__webpack_require__(104),exports.encode=exports.stringify=__webpack_require__(105)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_RESULT__;(function(module,global){!function(root){function error(type){throw RangeError(errors[type])}function map(array,fn){for(var length=array.length,result=[];length--;)result[length]=fn(array[length]);return result}function mapDomain(string,fn){var parts=string.split("@"),result="";parts.length>1&&(result=parts[0]+"@",string=parts[1]),string=string.replace(regexSeparators,".");var labels=string.split("."),encoded=map(labels,fn).join(".");return result+encoded}function ucs2decode(string){for(var value,extra,output=[],counter=0,length=string.length;length>counter;)value=string.charCodeAt(counter++),value>=55296&&56319>=value&&length>counter?(extra=string.charCodeAt(counter++),56320==(64512&extra)?output.push(((1023&value)<<10)+(1023&extra)+65536):(output.push(value),counter--)):output.push(value);return output}function ucs2encode(array){return map(array,function(value){var output="";return value>65535&&(value-=65536,output+=stringFromCharCode(value>>>10&1023|55296),value=56320|1023&value),output+=stringFromCharCode(value)}).join("")}function basicToDigit(codePoint){return 10>codePoint-48?codePoint-22:26>codePoint-65?codePoint-65:26>codePoint-97?codePoint-97:base}function digitToBasic(digit,flag){return digit+22+75*(26>digit)-((0!=flag)<<5)}function adapt(delta,numPoints,firstTime){var k=0;for(delta=firstTime?floor(delta/damp):delta>>1,delta+=floor(delta/numPoints);delta>baseMinusTMin*tMax>>1;k+=base)delta=floor(delta/baseMinusTMin);return floor(k+(baseMinusTMin+1)*delta/(delta+skew))}function decode(input){var out,basic,j,index,oldi,w,k,digit,t,baseMinusT,output=[],inputLength=input.length,i=0,n=initialN,bias=initialBias;for(basic=input.lastIndexOf(delimiter),0>basic&&(basic=0),j=0;basic>j;++j)input.charCodeAt(j)>=128&&error("not-basic"),output.push(input.charCodeAt(j));for(index=basic>0?basic+1:0;inputLength>index;){for(oldi=i,w=1,k=base;index>=inputLength&&error("invalid-input"),digit=basicToDigit(input.charCodeAt(index++)),(digit>=base||digit>floor((maxInt-i)/w))&&error("overflow"),i+=digit*w,t=bias>=k?tMin:k>=bias+tMax?tMax:k-bias,!(t>digit);k+=base)baseMinusT=base-t,w>floor(maxInt/baseMinusT)&&error("overflow"),w*=baseMinusT;out=output.length+1,bias=adapt(i-oldi,out,0==oldi),floor(i/out)>maxInt-n&&error("overflow"),n+=floor(i/out),i%=out,output.splice(i++,0,n)}return ucs2encode(output)}function encode(input){var n,delta,handledCPCount,basicLength,bias,j,m,q,k,t,currentValue,inputLength,handledCPCountPlusOne,baseMinusT,qMinusT,output=[];for(input=ucs2decode(input),inputLength=input.length,n=initialN,delta=0,bias=initialBias,j=0;inputLength>j;++j)currentValue=input[j],128>currentValue&&output.push(stringFromCharCode(currentValue));for(handledCPCount=basicLength=output.length,basicLength&&output.push(delimiter);inputLength>handledCPCount;){for(m=maxInt,j=0;inputLength>j;++j)currentValue=input[j],currentValue>=n&&m>currentValue&&(m=currentValue);for(handledCPCountPlusOne=handledCPCount+1,m-n>floor((maxInt-delta)/handledCPCountPlusOne)&&error("overflow"),delta+=(m-n)*handledCPCountPlusOne,n=m,j=0;inputLength>j;++j)if(currentValue=input[j],n>currentValue&&++delta>maxInt&&error("overflow"),currentValue==n){for(q=delta,k=base;t=bias>=k?tMin:k>=bias+tMax?tMax:k-bias,!(t>q);k+=base)qMinusT=q-t,baseMinusT=base-t,output.push(stringFromCharCode(digitToBasic(t+qMinusT%baseMinusT,0))),q=floor(qMinusT/baseMinusT);output.push(stringFromCharCode(digitToBasic(q,0))),bias=adapt(delta,handledCPCountPlusOne,handledCPCount==basicLength),delta=0,++handledCPCount}++delta,++n}return output.join("")}function toUnicode(input){return mapDomain(input,function(string){return regexPunycode.test(string)?decode(string.slice(4).toLowerCase()):string})}function toASCII(input){return mapDomain(input,function(string){return regexNonASCII.test(string)?"xn--"+encode(string):string})}var freeGlobal=("object"==typeof exports&&exports&&!exports.nodeType&&exports,"object"==typeof module&&module&&!module.nodeType&&module,"object"==typeof global&&global);(freeGlobal.global===freeGlobal||freeGlobal.window===freeGlobal||freeGlobal.self===freeGlobal)&&(root=freeGlobal);var punycode,maxInt=2147483647,base=36,tMin=1,tMax=26,skew=38,damp=700,initialBias=72,initialN=128,delimiter="-",regexPunycode=/^xn--/,regexNonASCII=/[^\x20-\x7E]/,regexSeparators=/[\x2E\u3002\uFF0E\uFF61]/g,errors={overflow:"Overflow: input needs wider integers to process","not-basic":"Illegal input >= 0x80 (not a basic code point)","invalid-input":"Invalid input"},baseMinusTMin=base-tMin,floor=Math.floor,stringFromCharCode=String.fromCharCode;punycode={version:"1.3.2",ucs2:{decode:ucs2decode,encode:ucs2encode},decode:decode,encode:encode,toASCII:toASCII,toUnicode:toUnicode},__WEBPACK_AMD_DEFINE_RESULT__=function(){return punycode}.call(exports,__webpack_require__,exports,module),!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__))}(this)}).call(exports,__webpack_require__(146)(module),function(){return this}())},function(module,exports,__webpack_require__){"use strict";function is_EOL(c){return 10===c||13===c}function is_WHITE_SPACE(c){return 9===c||32===c}function is_WS_OR_EOL(c){return 9===c||32===c||10===c||13===c}function is_FLOW_INDICATOR(c){return 44===c||91===c||93===c||123===c||125===c}function fromHexCode(c){var lc;return c>=48&&57>=c?c-48:(lc=32|c,lc>=97&&102>=lc?lc-97+10:-1)}function escapedHexLen(c){return 120===c?2:117===c?4:85===c?8:0}function fromDecimalCode(c){return c>=48&&57>=c?c-48:-1}function simpleEscapeSequence(c){return 48===c?"\x00":97===c?"":98===c?"\b":116===c?"	":9===c?"	":110===c?"\n":118===c?"":102===c?"\f":114===c?"\r":101===c?"":32===c?" ":34===c?'"':47===c?"/":92===c?"\\":78===c?"":95===c?" ":76===c?"\u2028":80===c?"\u2029":""}function charFromCodepoint(c){return 65535>=c?String.fromCharCode(c):String.fromCharCode((c-65536>>10)+55296,(c-65536&1023)+56320)}function generateError(state,message){return new YAMLException(message,new Mark(state.filename,state.input,state.position,state.line-1,state.position-state.lineStart))}function throwError(state,message){var error=generateError(state,message),hash=error.message+error.mark.position;state.errorMap[hash]||(state.errors.push(error),state.errorMap[hash]=1);for(var or=state.position;;){if(state.position>=state.input.length-1)return;var c=state.input.charAt(state.position);if("\n"==c)return state.position--,void(state.position==or&&(state.position+=1));if("\r"==c)return state.position--,void(state.position==or&&(state.position+=1));state.position++}}function throwWarning(state,message){var error=generateError(state,message);state.onWarning&&state.onWarning.call(null,error)}function captureSegment(state,start,end,checkJson){var _position,_length,_character,_result,scalar=state.result;if(-1==scalar.startPosition&&(scalar.startPosition=start),end>=start){if(_result=state.input.slice(start,end),checkJson)for(_position=0,_length=_result.length;_length>_position;_position+=1)_character=_result.charCodeAt(_position),9===_character||_character>=32&&1114111>=_character||throwError(state,"expected valid JSON character");scalar.value+=_result,scalar.endPosition=end}}function storeMappingPair(state,_result,keyTag,keyNode,valueNode){if(null!=keyNode){null===_result&&(_result={startPosition:keyNode.startPosition,endPosition:valueNode.endPosition,parent:null,errors:[],mappings:[],kind:ast.Kind.MAP});var mapping=ast.newMapping(keyNode,valueNode);return mapping.parent=_result,keyNode.parent=mapping,null!=valueNode&&(valueNode.parent=mapping),_result.mappings.push(mapping),_result.endPosition=valueNode?valueNode.endPosition:keyNode.endPosition+1,_result}}function readLineBreak(state){var ch;ch=state.input.charCodeAt(state.position),10===ch?state.position++:13===ch?(state.position++,10===state.input.charCodeAt(state.position)&&state.position++):throwError(state,"a line break is expected"),state.line+=1,state.lineStart=state.position}function skipSeparationSpace(state,allowComments,checkIndent){for(var lineBreaks=0,ch=state.input.charCodeAt(state.position);0!==ch;){for(;is_WHITE_SPACE(ch);)ch=state.input.charCodeAt(++state.position);if(allowComments&&35===ch)do ch=state.input.charCodeAt(++state.position);while(10!==ch&&13!==ch&&0!==ch);if(!is_EOL(ch))break;for(readLineBreak(state),ch=state.input.charCodeAt(state.position),lineBreaks++,state.lineIndent=0;32===ch;)state.lineIndent++,ch=state.input.charCodeAt(++state.position)}return-1!==checkIndent&&0!==lineBreaks&&state.lineIndent<checkIndent&&throwWarning(state,"deficient indentation"),lineBreaks}function testDocumentSeparator(state){var ch,_position=state.position;return ch=state.input.charCodeAt(_position),45!==ch&&46!==ch||state.input.charCodeAt(_position+1)!==ch||state.input.charCodeAt(_position+2)!==ch||(_position+=3,ch=state.input.charCodeAt(_position),0!==ch&&!is_WS_OR_EOL(ch))?!1:!0}function writeFoldedLines(state,scalar,count){1===count?scalar.value+=" ":count>1&&(scalar.value+=common.repeat("\n",count-1))}function readPlainScalar(state,nodeIndent,withinFlowCollection){var preceding,following,captureStart,captureEnd,hasPendingContent,_line,_lineStart,_lineIndent,ch,_kind=state.kind,_result=state.result,state_result=ast.newScalar();if(state_result.plainScalar=!0,state.result=state_result,ch=state.input.charCodeAt(state.position),is_WS_OR_EOL(ch)||is_FLOW_INDICATOR(ch)||35===ch||38===ch||42===ch||33===ch||124===ch||62===ch||39===ch||34===ch||37===ch||64===ch||96===ch)return!1;if((63===ch||45===ch)&&(following=state.input.charCodeAt(state.position+1),is_WS_OR_EOL(following)||withinFlowCollection&&is_FLOW_INDICATOR(following)))return!1;for(state.kind="scalar",captureStart=captureEnd=state.position,hasPendingContent=!1;0!==ch;){if(58===ch){if(following=state.input.charCodeAt(state.position+1),is_WS_OR_EOL(following)||withinFlowCollection&&is_FLOW_INDICATOR(following))break}else if(35===ch){if(preceding=state.input.charCodeAt(state.position-1),is_WS_OR_EOL(preceding))break}else{if(state.position===state.lineStart&&testDocumentSeparator(state)||withinFlowCollection&&is_FLOW_INDICATOR(ch))break;if(is_EOL(ch)){if(_line=state.line,_lineStart=state.lineStart,_lineIndent=state.lineIndent,skipSeparationSpace(state,!1,-1),state.lineIndent>=nodeIndent){hasPendingContent=!0,ch=state.input.charCodeAt(state.position);continue}state.position=captureEnd,state.line=_line,state.lineStart=_lineStart,state.lineIndent=_lineIndent;break}}if(hasPendingContent&&(captureSegment(state,captureStart,captureEnd,!1),writeFoldedLines(state,state_result,state.line-_line),captureStart=captureEnd=state.position,hasPendingContent=!1),is_WHITE_SPACE(ch)||(captureEnd=state.position+1),ch=state.input.charCodeAt(++state.position),state.position>=state.input.length)return!1}return captureSegment(state,captureStart,captureEnd,!1),-1!=state.result.startPosition?(state_result.rawValue=state.input.substring(state_result.startPosition,state_result.endPosition),!0):(state.kind=_kind,state.result=_result,!1)}function readSingleQuotedScalar(state,nodeIndent){var ch,captureStart,captureEnd;if(ch=state.input.charCodeAt(state.position),39!==ch)return!1;var scalar=ast.newScalar();for(state.kind="scalar",state.result=scalar,scalar.startPosition=state.position,state.position++,captureStart=captureEnd=state.position;0!==(ch=state.input.charCodeAt(state.position));)if(39===ch){if(captureSegment(state,captureStart,state.position,!0),ch=state.input.charCodeAt(++state.position),scalar.endPosition=state.position,39!==ch)return!0;captureStart=captureEnd=state.position,state.position++}else is_EOL(ch)?(captureSegment(state,captureStart,captureEnd,!0),writeFoldedLines(state,scalar,skipSeparationSpace(state,!1,nodeIndent)),captureStart=captureEnd=state.position):state.position===state.lineStart&&testDocumentSeparator(state)?throwError(state,"unexpected end of the document within a single quoted scalar"):(state.position++,captureEnd=state.position,scalar.endPosition=state.position);throwError(state,"unexpected end of the stream within a single quoted scalar")}function readDoubleQuotedScalar(state,nodeIndent){var captureStart,captureEnd,hexLength,hexResult,tmp,ch;if(ch=state.input.charCodeAt(state.position),34!==ch)return!1;state.kind="scalar";var scalar=ast.newScalar();for(scalar.doubleQuoted=!0,state.result=scalar,scalar.startPosition=state.position,state.position++,captureStart=captureEnd=state.position;0!==(ch=state.input.charCodeAt(state.position));){if(34===ch)return captureSegment(state,captureStart,state.position,!0),state.position++,scalar.endPosition=state.position,scalar.rawValue=state.input.substring(scalar.startPosition,scalar.endPosition),!0;if(92===ch){if(captureSegment(state,captureStart,state.position,!0),ch=state.input.charCodeAt(++state.position),is_EOL(ch))skipSeparationSpace(state,!1,nodeIndent);else if(256>ch&&(state.allowAnyEscape?customEscapeCheck[ch]:simpleEscapeCheck[ch]))scalar.value+=state.allowAnyEscape?customEscapeMap[ch]:simpleEscapeMap[ch],state.position++;else if((tmp=escapedHexLen(ch))>0){for(hexLength=tmp,hexResult=0;hexLength>0;hexLength--)ch=state.input.charCodeAt(++state.position),(tmp=fromHexCode(ch))>=0?hexResult=(hexResult<<4)+tmp:throwError(state,"expected hexadecimal character");scalar.value+=charFromCodepoint(hexResult),state.position++}else throwError(state,"unknown escape sequence");captureStart=captureEnd=state.position}else is_EOL(ch)?(captureSegment(state,captureStart,captureEnd,!0),writeFoldedLines(state,scalar,skipSeparationSpace(state,!1,nodeIndent)),captureStart=captureEnd=state.position):state.position===state.lineStart&&testDocumentSeparator(state)?throwError(state,"unexpected end of the document within a double quoted scalar"):(state.position++,captureEnd=state.position)}throwError(state,"unexpected end of the stream within a double quoted scalar")}function readFlowCollection(state,nodeIndent){var _line,_result,following,terminator,isPair,isExplicitPair,isMapping,keyNode,keyTag,valueNode,ch,readNext=!0,_tag=state.tag,_anchor=state.anchor;if(ch=state.input.charCodeAt(state.position),91===ch)terminator=93,isMapping=!1,_result=ast.newItems(),_result.startPosition=state.position;else{if(123!==ch)return!1;terminator=125,isMapping=!0,_result=ast.newMap(),_result.startPosition=state.position}for(null!==state.anchor&&(_result.anchorId=state.anchor,state.anchorMap[state.anchor]=_result),ch=state.input.charCodeAt(++state.position);0!==ch;){if(skipSeparationSpace(state,!0,nodeIndent),ch=state.input.charCodeAt(state.position),ch===terminator)return state.position++,state.tag=_tag,state.anchor=_anchor,state.kind=isMapping?"mapping":"sequence",state.result=_result,_result.endPosition=state.position,!0;if(!readNext){var p=state.position;throwError(state,"missed comma between flow collection entries"),state.position=p+1}if(keyTag=keyNode=valueNode=null,isPair=isExplicitPair=!1,63===ch&&(following=state.input.charCodeAt(state.position+1),is_WS_OR_EOL(following)&&(isPair=isExplicitPair=!0,state.position++,skipSeparationSpace(state,!0,nodeIndent))),_line=state.line,composeNode(state,nodeIndent,CONTEXT_FLOW_IN,!1,!0),keyTag=state.tag,keyNode=state.result,skipSeparationSpace(state,!0,nodeIndent),ch=state.input.charCodeAt(state.position),!isExplicitPair&&state.line!==_line||58!==ch||(isPair=!0,ch=state.input.charCodeAt(++state.position),skipSeparationSpace(state,!0,nodeIndent),composeNode(state,nodeIndent,CONTEXT_FLOW_IN,!1,!0),valueNode=state.result),isMapping)storeMappingPair(state,_result,keyTag,keyNode,valueNode);else if(isPair){var mp=storeMappingPair(state,null,keyTag,keyNode,valueNode);mp.parent=_result,_result.items.push(mp)}else keyNode.parent=_result,_result.items.push(keyNode);_result.endPosition=state.position+1,skipSeparationSpace(state,!0,nodeIndent),ch=state.input.charCodeAt(state.position),44===ch?(readNext=!0,ch=state.input.charCodeAt(++state.position)):readNext=!1}throwError(state,"unexpected end of the stream within a flow collection")}function readBlockScalar(state,nodeIndent){var captureStart,folding,tmp,ch,chomping=CHOMPING_CLIP,detectedIndent=!1,textIndent=nodeIndent,emptyLines=0,atMoreIndented=!1;if(ch=state.input.charCodeAt(state.position),124===ch)folding=!1;else{if(62!==ch)return!1;folding=!0}var sc=ast.newScalar();for(state.kind="scalar",state.result=sc,sc.startPosition=state.position;0!==ch;)if(ch=state.input.charCodeAt(++state.position),43===ch||45===ch)CHOMPING_CLIP===chomping?chomping=43===ch?CHOMPING_KEEP:CHOMPING_STRIP:throwError(state,"repeat of a chomping mode identifier");else{if(!((tmp=fromDecimalCode(ch))>=0))break;0===tmp?throwError(state,"bad explicit indentation width of a block scalar; it cannot be less than one"):detectedIndent?throwError(state,"repeat of an indentation width identifier"):(textIndent=nodeIndent+tmp-1,detectedIndent=!0)}if(is_WHITE_SPACE(ch)){do ch=state.input.charCodeAt(++state.position);while(is_WHITE_SPACE(ch));if(35===ch)do ch=state.input.charCodeAt(++state.position);while(!is_EOL(ch)&&0!==ch)}for(;0!==ch;){for(readLineBreak(state),state.lineIndent=0,ch=state.input.charCodeAt(state.position);(!detectedIndent||state.lineIndent<textIndent)&&32===ch;)state.lineIndent++,ch=state.input.charCodeAt(++state.position);if(!detectedIndent&&state.lineIndent>textIndent&&(textIndent=state.lineIndent),is_EOL(ch))emptyLines++;else{if(state.lineIndent<textIndent){chomping===CHOMPING_KEEP?sc.value+=common.repeat("\n",emptyLines):chomping===CHOMPING_CLIP&&detectedIndent&&(sc.value+="\n");break}for(folding?is_WHITE_SPACE(ch)?(atMoreIndented=!0,sc.value+=common.repeat("\n",emptyLines+1)):atMoreIndented?(atMoreIndented=!1,sc.value+=common.repeat("\n",emptyLines+1)):0===emptyLines?detectedIndent&&(sc.value+=" "):sc.value+=common.repeat("\n",emptyLines):detectedIndent&&(sc.value+=common.repeat("\n",emptyLines+1)),detectedIndent=!0,emptyLines=0,captureStart=state.position;!is_EOL(ch)&&0!==ch;)ch=state.input.charCodeAt(++state.position);captureSegment(state,captureStart,state.position,!1)}}sc.endPosition=state.position;for(var i=state.position-1,needMinus=!1;;){var c=state.input[i];if("\r"==c||"\n"==c){needMinus&&i--;break}if(" "!=c&&"	"!=c)break;i--}return sc.endPosition=i,sc.rawValue=state.input.substring(sc.startPosition,sc.endPosition),!0}function readBlockSequence(state,nodeIndent){var _line,following,ch,_tag=state.tag,_anchor=state.anchor,_result=ast.newItems(),detected=!1;for(null!==state.anchor&&(_result.anchorId=state.anchor,state.anchorMap[state.anchor]=_result),_result.startPosition=state.position,ch=state.input.charCodeAt(state.position);0!==ch&&45===ch&&(following=state.input.charCodeAt(state.position+1),is_WS_OR_EOL(following));)if(detected=!0,state.position++,skipSeparationSpace(state,!0,-1)&&state.lineIndent<=nodeIndent)_result.items.push(null),ch=state.input.charCodeAt(state.position);else if(_line=state.line,composeNode(state,nodeIndent,CONTEXT_BLOCK_IN,!1,!0),state.result.parent=_result,_result.items.push(state.result),skipSeparationSpace(state,!0,-1),ch=state.input.charCodeAt(state.position),(state.line===_line||state.lineIndent>nodeIndent)&&0!==ch)throwError(state,"bad indentation of a sequence entry");else if(state.lineIndent<nodeIndent)break;return _result.endPosition=state.position,detected?(state.tag=_tag,state.anchor=_anchor,state.kind="sequence",state.result=_result,_result.endPosition=state.position,!0):!1}function readBlockMapping(state,nodeIndent,flowIndent){var following,allowCompact,_line,ch,_tag=state.tag,_anchor=state.anchor,_result=ast.newMap(),keyTag=null,keyNode=null,valueNode=null,atExplicitKey=!1,detected=!1;for(_result.startPosition=state.position,null!==state.anchor&&(_result.anchorId=state.anchor,state.anchorMap[state.anchor]=_result),ch=state.input.charCodeAt(state.position);0!==ch;){if(following=state.input.charCodeAt(state.position+1),_line=state.line,63!==ch&&58!==ch||!is_WS_OR_EOL(following)){if(!composeNode(state,flowIndent,CONTEXT_FLOW_OUT,!1,!0))break;if(state.line===_line){for(ch=state.input.charCodeAt(state.position);is_WHITE_SPACE(ch);)ch=state.input.charCodeAt(++state.position);if(58===ch)ch=state.input.charCodeAt(++state.position),is_WS_OR_EOL(ch)||throwError(state,"a whitespace character is expected after the key-value separator within a block mapping"),atExplicitKey&&(storeMappingPair(state,_result,keyTag,keyNode,null),keyTag=keyNode=valueNode=null),detected=!0,atExplicitKey=!1,allowCompact=!1,keyTag=state.tag,keyNode=state.result;else{if(!detected)return state.tag=_tag,state.anchor=_anchor,!0;throwError(state,"can not read an implicit mapping pair; a colon is missed")}}else{if(!detected)return state.tag=_tag,state.anchor=_anchor,!0;for(throwError(state,"can not read a block mapping entry; a multiline key may not be an implicit key");state.position>0;)if(ch=state.input.charCodeAt(--state.position),is_EOL(ch)){state.position++;break}}}else 63===ch?(atExplicitKey&&(storeMappingPair(state,_result,keyTag,keyNode,null),keyTag=keyNode=valueNode=null),detected=!0,atExplicitKey=!0,allowCompact=!0):atExplicitKey?(atExplicitKey=!1,allowCompact=!0):throwError(state,"incomplete explicit mapping pair; a key node is missed"),state.position+=1,ch=following;if((state.line===_line||state.lineIndent>nodeIndent)&&(composeNode(state,nodeIndent,CONTEXT_BLOCK_OUT,!0,allowCompact)&&(atExplicitKey?keyNode=state.result:valueNode=state.result),atExplicitKey||(storeMappingPair(state,_result,keyTag,keyNode,valueNode),keyTag=keyNode=valueNode=null),skipSeparationSpace(state,!0,-1),ch=state.input.charCodeAt(state.position)),state.lineIndent>nodeIndent&&0!==ch)throwError(state,"bad indentation of a mapping entry");else if(state.lineIndent<nodeIndent)break}return atExplicitKey&&storeMappingPair(state,_result,keyTag,keyNode,null),detected&&(state.tag=_tag,state.anchor=_anchor,state.kind="mapping",state.result=_result),detected}function readTagProperty(state){var _position,tagHandle,tagName,ch,isVerbatim=!1,isNamed=!1;if(ch=state.input.charCodeAt(state.position),33!==ch)return!1;if(null!==state.tag&&throwError(state,"duplication of a tag property"),ch=state.input.charCodeAt(++state.position),60===ch?(isVerbatim=!0,ch=state.input.charCodeAt(++state.position)):33===ch?(isNamed=!0,tagHandle="!!",ch=state.input.charCodeAt(++state.position)):tagHandle="!",_position=state.position,isVerbatim){do ch=state.input.charCodeAt(++state.position);while(0!==ch&&62!==ch);state.position<state.length?(tagName=state.input.slice(_position,state.position),ch=state.input.charCodeAt(++state.position)):throwError(state,"unexpected end of the stream within a verbatim tag")}else{for(;0!==ch&&!is_WS_OR_EOL(ch);)33===ch&&(isNamed?throwError(state,"tag suffix cannot contain exclamation marks"):(tagHandle=state.input.slice(_position-1,state.position+1),PATTERN_TAG_HANDLE.test(tagHandle)||throwError(state,"named tag handle cannot contain such characters"),isNamed=!0,_position=state.position+1)),ch=state.input.charCodeAt(++state.position);tagName=state.input.slice(_position,state.position),PATTERN_FLOW_INDICATORS.test(tagName)&&throwError(state,"tag suffix cannot contain flow indicator characters")}return tagName&&!PATTERN_TAG_URI.test(tagName)&&throwError(state,"tag name cannot contain such characters: "+tagName),isVerbatim?state.tag=tagName:_hasOwnProperty.call(state.tagMap,tagHandle)?state.tag=state.tagMap[tagHandle]+tagName:"!"===tagHandle?state.tag="!"+tagName:"!!"===tagHandle?state.tag="tag:yaml.org,2002:"+tagName:throwError(state,'undeclared tag handle "'+tagHandle+'"'),!0}function readAnchorProperty(state){var _position,ch;if(ch=state.input.charCodeAt(state.position),38!==ch)return!1;for(null!==state.anchor&&throwError(state,"duplication of an anchor property"),ch=state.input.charCodeAt(++state.position),_position=state.position;0!==ch&&!is_WS_OR_EOL(ch)&&!is_FLOW_INDICATOR(ch);)ch=state.input.charCodeAt(++state.position);return state.position===_position&&throwError(state,"name of an anchor node must contain at least one character"),state.anchor=state.input.slice(_position,state.position),!0}function readAlias(state){var _position,alias,ch;state.length,state.input;if(ch=state.input.charCodeAt(state.position),42!==ch)return!1;for(ch=state.input.charCodeAt(++state.position),_position=state.position;0!==ch&&!is_WS_OR_EOL(ch)&&!is_FLOW_INDICATOR(ch);)ch=state.input.charCodeAt(++state.position);return state.position<=_position&&(throwError(state,"name of an alias node must contain at least one character"),state.position=_position+1),alias=state.input.slice(_position,state.position),state.anchorMap.hasOwnProperty(alias)||(throwError(state,'unidentified alias "'+alias+'"'),state.position<=_position&&(state.position=_position+1)),state.result=ast.newAnchorRef(alias,_position,state.position,state.anchorMap[alias]),skipSeparationSpace(state,!0,-1),!0}function composeNode(state,parentIndent,nodeContext,allowToSeek,allowCompact){var allowBlockStyles,allowBlockScalars,allowBlockCollections,typeIndex,typeQuantity,type,flowIndent,blockIndent,indentStatus=1,atNewLine=!1,hasContent=!1;if(state.tag=null,state.anchor=null,state.kind=null,state.result=null,allowBlockStyles=allowBlockScalars=allowBlockCollections=CONTEXT_BLOCK_OUT===nodeContext||CONTEXT_BLOCK_IN===nodeContext,allowToSeek&&skipSeparationSpace(state,!0,-1)&&(atNewLine=!0,state.lineIndent>parentIndent?indentStatus=1:state.lineIndent===parentIndent?indentStatus=0:state.lineIndent<parentIndent&&(indentStatus=-1)),1===indentStatus)for(;readTagProperty(state)||readAnchorProperty(state);)skipSeparationSpace(state,!0,-1)?(atNewLine=!0,allowBlockCollections=allowBlockStyles,state.lineIndent>parentIndent?indentStatus=1:state.lineIndent===parentIndent?indentStatus=0:state.lineIndent<parentIndent&&(indentStatus=-1)):allowBlockCollections=!1;if(allowBlockCollections&&(allowBlockCollections=atNewLine||allowCompact),(1===indentStatus||CONTEXT_BLOCK_OUT===nodeContext)&&(flowIndent=CONTEXT_FLOW_IN===nodeContext||CONTEXT_FLOW_OUT===nodeContext?parentIndent:parentIndent+1,blockIndent=state.position-state.lineStart,1===indentStatus?allowBlockCollections&&(readBlockSequence(state,blockIndent)||readBlockMapping(state,blockIndent,flowIndent))||readFlowCollection(state,flowIndent)?hasContent=!0:(allowBlockScalars&&readBlockScalar(state,flowIndent)||readSingleQuotedScalar(state,flowIndent)||readDoubleQuotedScalar(state,flowIndent)?hasContent=!0:readAlias(state)?(hasContent=!0,(null!==state.tag||null!==state.anchor)&&throwError(state,"alias node should not have any properties")):readPlainScalar(state,flowIndent,CONTEXT_FLOW_IN===nodeContext)&&(hasContent=!0,null===state.tag&&(state.tag="?")),null!==state.anchor&&(state.anchorMap[state.anchor]=state.result,state.result.anchorId=state.anchor)):0===indentStatus&&(hasContent=allowBlockCollections&&readBlockSequence(state,blockIndent))),null!==state.tag&&"!"!==state.tag)if("!include"==state.tag)state.result||(state.result=ast.newScalar(),state.result.startPosition=state.position,state.result.endPosition=state.position,throwError(state,"!include without value")),state.result.kind=ast.Kind.INCLUDE_REF;else if("?"===state.tag)for(typeIndex=0,typeQuantity=state.implicitTypes.length;typeQuantity>typeIndex;typeIndex+=1){type=state.implicitTypes[typeIndex];var vl=state.result.value;if(type.resolve(vl)){state.result.valueObject=type.construct(state.result.value),state.tag=type.tag,null!==state.anchor&&(state.result.anchorId=state.anchor,state.anchorMap[state.anchor]=state.result);break}}else _hasOwnProperty.call(state.typeMap,state.tag)?(type=state.typeMap[state.tag],null!==state.result&&type.kind!==state.kind&&throwError(state,"unacceptable node kind for !<"+state.tag+'> tag; it should be "'+type.kind+'", not "'+state.kind+'"'),type.resolve(state.result)?(state.result=type.construct(state.result),null!==state.anchor&&(state.result.anchorId=state.anchor,state.anchorMap[state.anchor]=state.result)):throwError(state,"cannot resolve a node with !<"+state.tag+"> explicit tag")):throwWarning(state,"unknown tag !<"+state.tag+">");return null!==state.tag||null!==state.anchor||hasContent;
}function readDocument(state){var _position,directiveName,directiveArgs,ch,documentStart=state.position,hasDirectives=!1;for(state.version=null,state.checkLineBreaks=state.legacy,state.tagMap={},state.anchorMap={};0!==(ch=state.input.charCodeAt(state.position))&&(skipSeparationSpace(state,!0,-1),ch=state.input.charCodeAt(state.position),!(state.lineIndent>0||37!==ch));){for(hasDirectives=!0,ch=state.input.charCodeAt(++state.position),_position=state.position;0!==ch&&!is_WS_OR_EOL(ch);)ch=state.input.charCodeAt(++state.position);for(directiveName=state.input.slice(_position,state.position),directiveArgs=[],directiveName.length<1&&throwError(state,"directive name must not be less than one character in length");0!==ch;){for(;is_WHITE_SPACE(ch);)ch=state.input.charCodeAt(++state.position);if(35===ch){do ch=state.input.charCodeAt(++state.position);while(0!==ch&&!is_EOL(ch));break}if(is_EOL(ch))break;for(_position=state.position;0!==ch&&!is_WS_OR_EOL(ch);)ch=state.input.charCodeAt(++state.position);directiveArgs.push(state.input.slice(_position,state.position))}0!==ch&&readLineBreak(state),_hasOwnProperty.call(directiveHandlers,directiveName)?directiveHandlers[directiveName](state,directiveName,directiveArgs):(throwWarning(state,'unknown document directive "'+directiveName+'"'),state.position++)}return skipSeparationSpace(state,!0,-1),0===state.lineIndent&&45===state.input.charCodeAt(state.position)&&45===state.input.charCodeAt(state.position+1)&&45===state.input.charCodeAt(state.position+2)?(state.position+=3,skipSeparationSpace(state,!0,-1)):hasDirectives&&throwError(state,"directives end mark is expected"),composeNode(state,state.lineIndent-1,CONTEXT_BLOCK_OUT,!1,!0),skipSeparationSpace(state,!0,-1),state.checkLineBreaks&&PATTERN_NON_ASCII_LINE_BREAKS.test(state.input.slice(documentStart,state.position))&&throwWarning(state,"non-ASCII line breaks are interpreted as content"),state.documents.push(state.result),state.position===state.lineStart&&testDocumentSeparator(state)?void(46===state.input.charCodeAt(state.position)&&(state.position+=3,skipSeparationSpace(state,!0,-1))):void(state.position<state.length-1&&throwError(state,"end of the stream or a document separator is expected"))}function loadDocuments(input,options){input=String(input),options=options||{},0!==input.length&&(10!==input.charCodeAt(input.length-1)&&13!==input.charCodeAt(input.length-1)&&(input+="\n"),65279===input.charCodeAt(0)&&(input=input.slice(1)));var state=new State(input,options);for(PATTERN_NON_PRINTABLE.test(state.input)&&throwError(state,"the stream contains non-printable characters"),state.input+="\x00";32===state.input.charCodeAt(state.position);)state.lineIndent+=1,state.position+=1;for(;state.position<state.length-1;){var q=state.position;if(readDocument(state),state.position<=q)for(;state.position<state.length-1;state.position++){var c=state.input.charAt(state.position);if("\n"==c)break}}return state.documents.forEach(function(x){return x.errors=state.errors}),state.documents}function loadAll(input,iterator,options){var index,length,documents=loadDocuments(input,options);for(index=0,length=documents.length;length>index;index+=1)iterator(documents[index])}function load(input,options){var documents=loadDocuments(input,options);if(0===documents.length)return void 0;if(1===documents.length){var result=documents[0];return result.endPosition=input.length,result.startPosition>result.endPosition&&(result.startPosition=result.endPosition),result}var e=new YAMLException("expected a single document in the stream, but found more");return e.mark=new Mark("","",0,0,0),e.mark.position=documents[0].endPosition,documents[0].errors.push(e),documents[0]}function safeLoadAll(input,output,options){loadAll(input,output,common.extend({schema:DEFAULT_SAFE_SCHEMA},options))}function safeLoad(input,options){return load(input,common.extend({schema:DEFAULT_SAFE_SCHEMA},options))}for(var ast=__webpack_require__(111),common=__webpack_require__(112),YAMLException=__webpack_require__(113),Mark=__webpack_require__(114),DEFAULT_SAFE_SCHEMA=__webpack_require__(132),DEFAULT_FULL_SCHEMA=__webpack_require__(133),_hasOwnProperty=Object.prototype.hasOwnProperty,CONTEXT_FLOW_IN=1,CONTEXT_FLOW_OUT=2,CONTEXT_BLOCK_IN=3,CONTEXT_BLOCK_OUT=4,CHOMPING_CLIP=1,CHOMPING_STRIP=2,CHOMPING_KEEP=3,PATTERN_NON_PRINTABLE=/[\x00-\x08\x0B\x0C\x0E-\x1F\x7F-\x84\x86-\x9F\uD800-\uDFFF\uFFFE\uFFFF]/,PATTERN_NON_ASCII_LINE_BREAKS=/[\x85\u2028\u2029]/,PATTERN_FLOW_INDICATORS=/[,\[\]\{\}]/,PATTERN_TAG_HANDLE=/^(?:!|!!|![a-z\-]+!)$/i,PATTERN_TAG_URI=/^(?:!|[^,\[\]\{\}])(?:%[0-9a-f]{2}|[0-9a-z\-#;\/\?:@&=\+\$,_\.!~\*'\(\)\[\]])*$/i,simpleEscapeCheck=new Array(256),simpleEscapeMap=new Array(256),customEscapeCheck=new Array(256),customEscapeMap=new Array(256),i=0;256>i;i++)customEscapeMap[i]=simpleEscapeMap[i]=simpleEscapeSequence(i),simpleEscapeCheck[i]=simpleEscapeMap[i]?1:0,customEscapeCheck[i]=1,simpleEscapeCheck[i]||(customEscapeMap[i]="\\"+String.fromCharCode(i));var State=function(){function State(input,options){this.errorMap={},this.errors=[],this.input=input,this.filename=options.filename||null,this.schema=options.schema||DEFAULT_FULL_SCHEMA,this.onWarning=options.onWarning||null,this.legacy=options.legacy||!1,this.allowAnyEscape=options.allowAnyEscape||!1,this.implicitTypes=this.schema.compiledImplicit,this.typeMap=this.schema.compiledTypeMap,this.length=input.length,this.position=0,this.line=0,this.lineStart=0,this.lineIndent=0,this.documents=[]}return State}(),directiveHandlers={YAML:function(state,name,args){var match,major,minor;null!==state.version&&throwError(state,"duplication of %YAML directive"),1!==args.length&&throwError(state,"YAML directive accepts exactly one argument"),match=/^([0-9]+)\.([0-9]+)$/.exec(args[0]),null===match&&throwError(state,"ill-formed argument of the YAML directive"),major=parseInt(match[1],10),minor=parseInt(match[2],10),1!==major&&throwError(state,"found incompatible YAML document (version 1.2 is required)"),state.version=args[0],state.checkLineBreaks=2>minor,2!==minor&&throwError(state,"found incompatible YAML document (version 1.2 is required)")},TAG:function(state,name,args){var handle,prefix;2!==args.length&&throwError(state,"TAG directive accepts exactly two arguments"),handle=args[0],prefix=args[1],PATTERN_TAG_HANDLE.test(handle)||throwError(state,"ill-formed tag handle (first argument) of the TAG directive"),_hasOwnProperty.call(state.tagMap,handle)&&throwError(state,'there is a previously declared suffix for "'+handle+'" tag handle'),PATTERN_TAG_URI.test(prefix)||throwError(state,"ill-formed tag prefix (second argument) of the TAG directive"),state.tagMap[handle]=prefix}};exports.loadAll=loadAll,exports.load=load,exports.safeLoadAll=safeLoadAll,exports.safeLoad=safeLoad,module.exports.loadAll=loadAll,module.exports.load=load,module.exports.safeLoadAll=safeLoadAll,module.exports.safeLoad=safeLoad},function(module,exports,__webpack_require__){"use strict";function compileStyleMap(schema,map){var result,keys,index,length,tag,style,type;if(null===map)return{};for(result={},keys=Object.keys(map),index=0,length=keys.length;length>index;index+=1)tag=keys[index],style=String(map[tag]),"!!"===tag.slice(0,2)&&(tag="tag:yaml.org,2002:"+tag.slice(2)),type=schema.compiledTypeMap[tag],type&&_hasOwnProperty.call(type.styleAliases,style)&&(style=type.styleAliases[style]),result[tag]=style;return result}function encodeHex(character){var string,handle,length;if(string=character.toString(16).toUpperCase(),255>=character)handle="x",length=2;else if(65535>=character)handle="u",length=4;else{if(!(4294967295>=character))throw new YAMLException("code point within a string may not be greater than 0xFFFFFFFF");handle="U",length=8}return"\\"+handle+common.repeat("0",length-string.length)+string}function State(options){this.schema=options.schema||DEFAULT_FULL_SCHEMA,this.indent=Math.max(1,options.indent||2),this.skipInvalid=options.skipInvalid||!1,this.flowLevel=common.isNothing(options.flowLevel)?-1:options.flowLevel,this.styleMap=compileStyleMap(this.schema,options.styles||null),this.implicitTypes=this.schema.compiledImplicit,this.explicitTypes=this.schema.compiledExplicit,this.tag=null,this.result="",this.duplicates=[],this.usedDuplicates=null}function indentString(string,spaces){for(var line,ind=common.repeat(" ",spaces),position=0,next=-1,result="",length=string.length;length>position;)next=string.indexOf("\n",position),-1===next?(line=string.slice(position),position=length):(line=string.slice(position,next+1),position=next+1),line.length&&"\n"!==line&&(result+=ind),result+=line;return result}function generateNextLine(state,level){return"\n"+common.repeat(" ",state.indent*level)}function testImplicitResolving(state,str){var index,length,type;for(index=0,length=state.implicitTypes.length;length>index;index+=1)if(type=state.implicitTypes[index],type.resolve(str))return!0;return!1}function StringBuilder(source){this.source=source,this.result="",this.checkpoint=0}function writeScalar(state,object,level){var simple,first,spaceWrap,folded,literal,single,double,sawLineFeed,linePosition,longestLine,indent,max,character,position,escapeSeq,hexEsc,previous,lineLength,modifier,trailingLineBreaks,result;if(0===object.length)return void(state.dump="''");if(0==object.indexOf("!include"))return void(state.dump=""+object);if(0==object.indexOf("!$$$novalue"))return void(state.dump="");if(-1!==DEPRECATED_BOOLEANS_SYNTAX.indexOf(object))return void(state.dump="'"+object+"'");for(simple=!0,first=object.length?object.charCodeAt(0):0,spaceWrap=CHAR_SPACE===first||CHAR_SPACE===object.charCodeAt(object.length-1),(CHAR_MINUS===first||CHAR_QUESTION===first||CHAR_COMMERCIAL_AT===first||CHAR_GRAVE_ACCENT===first)&&(simple=!1),spaceWrap?(simple=!1,folded=!1,literal=!1):(folded=!0,literal=!0),single=!0,double=new StringBuilder(object),sawLineFeed=!1,linePosition=0,longestLine=0,indent=state.indent*level,max=80,40>indent?max-=indent:max=40,position=0;position<object.length;position++){if(character=object.charCodeAt(position),simple){if(simpleChar(character))continue;simple=!1}single&&character===CHAR_SINGLE_QUOTE&&(single=!1),escapeSeq=ESCAPE_SEQUENCES[character],hexEsc=needsHexEscape(character),(escapeSeq||hexEsc)&&(character!==CHAR_LINE_FEED&&character!==CHAR_DOUBLE_QUOTE&&character!==CHAR_SINGLE_QUOTE?(folded=!1,literal=!1):character===CHAR_LINE_FEED&&(sawLineFeed=!0,single=!1,position>0&&(previous=object.charCodeAt(position-1),previous===CHAR_SPACE&&(literal=!1,folded=!1)),folded&&(lineLength=position-linePosition,linePosition=position,lineLength>longestLine&&(longestLine=lineLength))),character!==CHAR_DOUBLE_QUOTE&&(single=!1),double.takeUpTo(position),double.escapeChar())}if(simple&&testImplicitResolving(state,object)&&(simple=!1),modifier="",(folded||literal)&&(trailingLineBreaks=0,object.charCodeAt(object.length-1)===CHAR_LINE_FEED&&(trailingLineBreaks+=1,object.charCodeAt(object.length-2)===CHAR_LINE_FEED&&(trailingLineBreaks+=1)),0===trailingLineBreaks?modifier="-":2===trailingLineBreaks&&(modifier="+")),literal&&max>longestLine&&(folded=!1),sawLineFeed||(literal=!1),simple)state.dump=object;else if(single)state.dump="'"+object+"'";else if(folded)result=fold(object,max),state.dump=">"+modifier+"\n"+indentString(result,indent);else if(literal)modifier||(object=object.replace(/\n$/,"")),state.dump="|"+modifier+"\n"+indentString(object,indent);else{if(!double)throw new Error("Failed to dump scalar value");double.finish(),state.dump='"'+double.result+'"'}}function fold(object,max){var newLine,result="",position=0,length=object.length,trailing=/\n+$/.exec(object);for(trailing&&(length=trailing.index+1);length>position;)newLine=object.indexOf("\n",position),newLine>length||-1===newLine?(result&&(result+="\n\n"),result+=foldLine(object.slice(position,length),max),position=length):(result&&(result+="\n\n"),result+=foldLine(object.slice(position,newLine),max),position=newLine+1);return trailing&&"\n"!==trailing[0]&&(result+=trailing[0]),result}function foldLine(line,max){if(""===line)return line;for(var index,foldEnd,folded,foldRe=/[^\s] [^\s]/g,result="",prevMatch=0,foldStart=0,match=foldRe.exec(line);match;)index=match.index,index-foldStart>max&&(foldEnd=prevMatch!==foldStart?prevMatch:index,result&&(result+="\n"),folded=line.slice(foldStart,foldEnd),result+=folded,foldStart=foldEnd+1),prevMatch=index+1,match=foldRe.exec(line);return result&&(result+="\n"),result+=foldStart!==prevMatch&&line.length-foldStart>max?line.slice(foldStart,prevMatch)+"\n"+line.slice(prevMatch+1):line.slice(foldStart)}function simpleChar(character){return CHAR_TAB!==character&&CHAR_LINE_FEED!==character&&CHAR_CARRIAGE_RETURN!==character&&CHAR_COMMA!==character&&CHAR_LEFT_SQUARE_BRACKET!==character&&CHAR_RIGHT_SQUARE_BRACKET!==character&&CHAR_LEFT_CURLY_BRACKET!==character&&CHAR_RIGHT_CURLY_BRACKET!==character&&CHAR_SHARP!==character&&CHAR_AMPERSAND!==character&&CHAR_ASTERISK!==character&&CHAR_EXCLAMATION!==character&&CHAR_VERTICAL_LINE!==character&&CHAR_GREATER_THAN!==character&&CHAR_SINGLE_QUOTE!==character&&CHAR_DOUBLE_QUOTE!==character&&CHAR_PERCENT!==character&&CHAR_COLON!==character&&!ESCAPE_SEQUENCES[character]&&!needsHexEscape(character)}function needsHexEscape(character){return!(character>=32&&126>=character||133===character||character>=160&&55295>=character||character>=57344&&65533>=character||character>=65536&&1114111>=character)}function writeFlowSequence(state,level,object){var index,length,_result="",_tag=state.tag;for(index=0,length=object.length;length>index;index+=1)writeNode(state,level,object[index],!1,!1)&&(0!==index&&(_result+=", "),_result+=state.dump);state.tag=_tag,state.dump="["+_result+"]"}function writeBlockSequence(state,level,object,compact){var index,length,_result="",_tag=state.tag;for(index=0,length=object.length;length>index;index+=1)writeNode(state,level+1,object[index],!0,!0)&&(compact&&0===index||(_result+=generateNextLine(state,level)),_result+="- "+state.dump);state.tag=_tag,state.dump=_result||"[]"}function writeFlowMapping(state,level,object){var index,length,objectKey,objectValue,pairBuffer,_result="",_tag=state.tag,objectKeyList=Object.keys(object);for(index=0,length=objectKeyList.length;length>index;index+=1)pairBuffer="",0!==index&&(pairBuffer+=", "),objectKey=objectKeyList[index],objectValue=object[objectKey],writeNode(state,level,objectKey,!1,!1)&&(state.dump.length>1024&&(pairBuffer+="? "),pairBuffer+=state.dump+": ",writeNode(state,level,objectValue,!1,!1)&&(pairBuffer+=state.dump,_result+=pairBuffer));state.tag=_tag,state.dump="{"+_result+"}"}function writeBlockMapping(state,level,object,compact){var index,length,objectKey,objectValue,explicitPair,pairBuffer,_result="",_tag=state.tag,objectKeyList=Object.keys(object);for(index=0,length=objectKeyList.length;length>index;index+=1)pairBuffer="",compact&&0===index||(pairBuffer+=generateNextLine(state,level)),objectKey=objectKeyList[index],objectValue=object[objectKey],writeNode(state,level+1,objectKey,!0,!0)&&(explicitPair=null!==state.tag&&"?"!==state.tag||state.dump&&state.dump.length>1024,explicitPair&&(pairBuffer+=state.dump&&CHAR_LINE_FEED===state.dump.charCodeAt(0)?"?":"? "),pairBuffer+=state.dump,explicitPair&&(pairBuffer+=generateNextLine(state,level)),writeNode(state,level+1,objectValue,!0,explicitPair)&&(pairBuffer+=state.dump&&CHAR_LINE_FEED===state.dump.charCodeAt(0)?":":": ",pairBuffer+=state.dump,_result+=pairBuffer));state.tag=_tag,state.dump=_result||"{}"}function detectType(state,object,explicit){var _result,typeList,index,length,type,style;for(typeList=explicit?state.explicitTypes:state.implicitTypes,index=0,length=typeList.length;length>index;index+=1)if(type=typeList[index],(type.instanceOf||type.predicate)&&(!type.instanceOf||"object"==typeof object&&object instanceof type.instanceOf)&&(!type.predicate||type.predicate(object))){if(state.tag=explicit?type.tag:"?",type.represent){if(style=state.styleMap[type.tag]||type.defaultStyle,"[object Function]"===_toString.call(type.represent))_result=type.represent(object,style);else{if(!_hasOwnProperty.call(type.represent,style))throw new YAMLException("!<"+type.tag+'> tag resolver accepts not "'+style+'" style');_result=type.represent[style](object,style)}state.dump=_result}return!0}return!1}function writeNode(state,level,object,block,compact){state.tag=null,state.dump=object,detectType(state,object,!1)||detectType(state,object,!0);var type=_toString.call(state.dump);block&&(block=0>state.flowLevel||state.flowLevel>level),(null!==state.tag&&"?"!==state.tag||2!==state.indent&&level>0)&&(compact=!1);var duplicateIndex,duplicate,objectOrArray="[object Object]"===type||"[object Array]"===type;if(objectOrArray&&(duplicateIndex=state.duplicates.indexOf(object),duplicate=-1!==duplicateIndex),duplicate&&state.usedDuplicates[duplicateIndex])state.dump="*ref_"+duplicateIndex;else{if(objectOrArray&&duplicate&&!state.usedDuplicates[duplicateIndex]&&(state.usedDuplicates[duplicateIndex]=!0),"[object Object]"===type)block&&0!==Object.keys(state.dump).length?(writeBlockMapping(state,level,state.dump,compact),duplicate&&(state.dump="&ref_"+duplicateIndex+(0===level?"\n":"")+state.dump)):(writeFlowMapping(state,level,state.dump),duplicate&&(state.dump="&ref_"+duplicateIndex+" "+state.dump));else if("[object Array]"===type)block&&0!==state.dump.length?(writeBlockSequence(state,level,state.dump,compact),duplicate&&(state.dump="&ref_"+duplicateIndex+(0===level?"\n":"")+state.dump)):(writeFlowSequence(state,level,state.dump),duplicate&&(state.dump="&ref_"+duplicateIndex+" "+state.dump));else{if("[object String]"!==type){if(state.skipInvalid)return!1;throw new YAMLException("unacceptable kind of an object to dump "+type)}"?"!==state.tag&&writeScalar(state,state.dump,level)}null!==state.tag&&"?"!==state.tag&&(state.dump="!<"+state.tag+"> "+state.dump)}return!0}function getDuplicateReferences(object,state){var index,length,objects=[],duplicatesIndexes=[];for(inspectNode(object,objects,duplicatesIndexes),index=0,length=duplicatesIndexes.length;length>index;index+=1)state.duplicates.push(objects[duplicatesIndexes[index]]);state.usedDuplicates=new Array(length)}function inspectNode(object,objects,duplicatesIndexes){var objectKeyList,index,length;_toString.call(object);if(null!==object&&"object"==typeof object)if(index=objects.indexOf(object),-1!==index)-1===duplicatesIndexes.indexOf(index)&&duplicatesIndexes.push(index);else if(objects.push(object),Array.isArray(object))for(index=0,length=object.length;length>index;index+=1)inspectNode(object[index],objects,duplicatesIndexes);else for(objectKeyList=Object.keys(object),index=0,length=objectKeyList.length;length>index;index+=1)inspectNode(object[objectKeyList[index]],objects,duplicatesIndexes)}function dump(input,options){options=options||{};var state=new State(options);return getDuplicateReferences(input,state),writeNode(state,0,input,!0,!0)?state.dump+"\n":""}function safeDump(input,options){return dump(input,common.extend({schema:DEFAULT_SAFE_SCHEMA},options))}var common=__webpack_require__(112),YAMLException=__webpack_require__(113),DEFAULT_FULL_SCHEMA=__webpack_require__(133),DEFAULT_SAFE_SCHEMA=__webpack_require__(132),_toString=Object.prototype.toString,_hasOwnProperty=Object.prototype.hasOwnProperty,CHAR_TAB=9,CHAR_LINE_FEED=10,CHAR_CARRIAGE_RETURN=13,CHAR_SPACE=32,CHAR_EXCLAMATION=33,CHAR_DOUBLE_QUOTE=34,CHAR_SHARP=35,CHAR_PERCENT=37,CHAR_AMPERSAND=38,CHAR_SINGLE_QUOTE=39,CHAR_ASTERISK=42,CHAR_COMMA=44,CHAR_MINUS=45,CHAR_COLON=58,CHAR_GREATER_THAN=62,CHAR_QUESTION=63,CHAR_COMMERCIAL_AT=64,CHAR_LEFT_SQUARE_BRACKET=91,CHAR_RIGHT_SQUARE_BRACKET=93,CHAR_GRAVE_ACCENT=96,CHAR_LEFT_CURLY_BRACKET=123,CHAR_VERTICAL_LINE=124,CHAR_RIGHT_CURLY_BRACKET=125,ESCAPE_SEQUENCES={};ESCAPE_SEQUENCES[0]="\\0",ESCAPE_SEQUENCES[7]="\\a",ESCAPE_SEQUENCES[8]="\\b",ESCAPE_SEQUENCES[9]="\\t",ESCAPE_SEQUENCES[10]="\\n",ESCAPE_SEQUENCES[11]="\\v",ESCAPE_SEQUENCES[12]="\\f",ESCAPE_SEQUENCES[13]="\\r",ESCAPE_SEQUENCES[27]="\\e",ESCAPE_SEQUENCES[34]='\\"',ESCAPE_SEQUENCES[92]="\\\\",ESCAPE_SEQUENCES[133]="\\N",ESCAPE_SEQUENCES[160]="\\_",ESCAPE_SEQUENCES[8232]="\\L",ESCAPE_SEQUENCES[8233]="\\P";var DEPRECATED_BOOLEANS_SYNTAX=["y","Y","yes","Yes","YES","on","On","ON","n","N","no","No","NO","off","Off","OFF"];StringBuilder.prototype.takeUpTo=function(position){var er;if(position<this.checkpoint)throw er=new Error("position should be > checkpoint"),er.position=position,er.checkpoint=this.checkpoint,er;return this.result+=this.source.slice(this.checkpoint,position),this.checkpoint=position,this},StringBuilder.prototype.escapeChar=function(){var character,esc;return character=this.source.charCodeAt(this.checkpoint),esc=ESCAPE_SEQUENCES[character]||encodeHex(character),this.result+=esc,this.checkpoint+=1,this},StringBuilder.prototype.finish=function(){this.source.length>this.checkpoint&&this.takeUpTo(this.source.length)},exports.dump=dump,exports.safeDump=safeDump},function(module,exports,__webpack_require__){function XMLReader(){}function parse(source,defaultNSMapCopy,entityMap,domBuilder,errorHandler){function fixedFromCharCode(code){if(code>65535){code-=65536;var surrogate1=55296+(code>>10),surrogate2=56320+(1023&code);return String.fromCharCode(surrogate1,surrogate2)}return String.fromCharCode(code)}function entityReplacer(a){var k=a.slice(1,-1);return k in entityMap?entityMap[k]:"#"===k.charAt(0)?fixedFromCharCode(parseInt(k.substr(1).replace("x","0x"))):(errorHandler.error("entity not found:"+a),a)}function appendText(end){if(end>start){var xt=source.substring(start,end).replace(/&#?\w+;/g,entityReplacer);locator&&position(start),domBuilder.characters(xt,0,end-start),start=end}}function position(p,m){for(;p>=lineEnd&&(m=linePattern.exec(source));)lineStart=m.index,lineEnd=lineStart+m[0].length,locator.lineNumber++;locator.columnNumber=p-lineStart+1}for(var lineStart=0,lineEnd=0,linePattern=/.+(?:\r\n?|\n)|.*$/g,locator=domBuilder.locator,parseStack=[{currentNSMap:defaultNSMapCopy}],closeMap={},start=0;;){try{var tagStart=source.indexOf("<",start);if(0>tagStart){if(!source.substr(start).match(/^\s*$/)){var doc=domBuilder.document,text=doc.createTextNode(source.substr(start));doc.appendChild(text),domBuilder.currentElement=text}return}switch(tagStart>start&&appendText(tagStart),source.charAt(tagStart+1)){case"/":var end=source.indexOf(">",tagStart+3),tagName=source.substring(tagStart+2,end),config=parseStack.pop(),localNSMap=config.localNSMap;if(config.tagName!=tagName&&errorHandler.fatalError("end tag name: "+tagName+" is not match the current start tagName:"+config.tagName),domBuilder.endElement(config.uri,config.localName,tagName),localNSMap)for(var prefix in localNSMap)domBuilder.endPrefixMapping(prefix);end++;break;case"?":locator&&position(tagStart),end=parseInstruction(source,tagStart,domBuilder);break;case"!":locator&&position(tagStart),end=parseDCC(source,tagStart,domBuilder,errorHandler);break;default:locator&&position(tagStart);var el=new ElementAttributes,end=parseElementStartPart(source,tagStart,el,entityReplacer,errorHandler),len=el.length;if(locator){if(len)for(var i=0;len>i;i++){var a=el[i];position(a.offset),a.offset=copyLocator(locator,{})}position(end)}!el.closed&&fixSelfClosed(source,end,el.tagName,closeMap)&&(el.closed=!0,entityMap.nbsp||errorHandler.warning("unclosed xml attribute")),appendElement(el,domBuilder,parseStack),"http://www.w3.org/1999/xhtml"!==el.uri||el.closed?end++:end=parseHtmlSpecialContent(source,end,el.tagName,entityReplacer,domBuilder)}}catch(e){errorHandler.error("element parse error: "+e),end=-1}end>start?start=end:appendText(Math.max(tagStart,start)+1)}}function copyLocator(f,t){return t.lineNumber=f.lineNumber,t.columnNumber=f.columnNumber,t}function parseElementStartPart(source,start,el,entityReplacer,errorHandler){for(var attrName,value,p=++start,s=S_TAG;;){var c=source.charAt(p);switch(c){case"=":if(s===S_ATTR)attrName=source.slice(start,p),s=S_EQ;else{if(s!==S_ATTR_S)throw new Error("attribute equal must after attrName");s=S_EQ}break;case"'":case'"':if(s===S_EQ){if(start=p+1,p=source.indexOf(c,start),!(p>0))throw new Error("attribute value no end '"+c+"' match");value=source.slice(start,p).replace(/&#?\w+;/g,entityReplacer),el.add(attrName,value,start-1),s=S_E}else{if(s!=S_V)throw new Error('attribute value must after "="');value=source.slice(start,p).replace(/&#?\w+;/g,entityReplacer),el.add(attrName,value,start),errorHandler.warning('attribute "'+attrName+'" missed start quot('+c+")!!"),start=p+1,s=S_E}break;case"/":switch(s){case S_TAG:el.setTagName(source.slice(start,p));case S_E:case S_S:case S_C:s=S_C,el.closed=!0;case S_V:case S_ATTR:case S_ATTR_S:break;default:throw new Error("attribute invalid close char('/')")}break;case"":errorHandler.error("unexpected end of input");case">":switch(s){case S_TAG:el.setTagName(source.slice(start,p));case S_E:case S_S:case S_C:break;case S_V:case S_ATTR:value=source.slice(start,p),"/"===value.slice(-1)&&(el.closed=!0,value=value.slice(0,-1));case S_ATTR_S:s===S_ATTR_S&&(value=attrName),s==S_V?(errorHandler.warning('attribute "'+value+'" missed quot(")!!'),el.add(attrName,value.replace(/&#?\w+;/g,entityReplacer),start)):(errorHandler.warning('attribute "'+value+'" missed value!! "'+value+'" instead!!'),el.add(value,value,start));break;case S_EQ:throw new Error("attribute value missed!!")}return p;case"":c=" ";default:if(" ">=c)switch(s){case S_TAG:el.setTagName(source.slice(start,p)),s=S_S;break;case S_ATTR:attrName=source.slice(start,p),s=S_ATTR_S;break;case S_V:var value=source.slice(start,p).replace(/&#?\w+;/g,entityReplacer);errorHandler.warning('attribute "'+value+'" missed quot(")!!'),el.add(attrName,value,start);case S_E:s=S_S}else switch(s){case S_ATTR_S:errorHandler.warning('attribute "'+attrName+'" missed value!! "'+attrName+'" instead!!'),el.add(attrName,attrName,start),start=p,s=S_ATTR;break;case S_E:errorHandler.warning('attribute space is required"'+attrName+'"!!');case S_S:s=S_ATTR,start=p;break;case S_EQ:s=S_V,start=p;break;case S_C:throw new Error("elements closed character '/' and '>' must be connected to")}}p++}}function appendElement(el,domBuilder,parseStack){for(var tagName=el.tagName,localNSMap=null,currentNSMap=parseStack[parseStack.length-1].currentNSMap,i=el.length;i--;){var a=el[i],qName=a.qName,value=a.value,nsp=qName.indexOf(":");if(nsp>0)var prefix=a.prefix=qName.slice(0,nsp),localName=qName.slice(nsp+1),nsPrefix="xmlns"===prefix&&localName;else localName=qName,prefix=null,nsPrefix="xmlns"===qName&&"";a.localName=localName,nsPrefix!==!1&&(null==localNSMap&&(localNSMap={},_copy(currentNSMap,currentNSMap={})),currentNSMap[nsPrefix]=localNSMap[nsPrefix]=value,a.uri="http://www.w3.org/2000/xmlns/",domBuilder.startPrefixMapping(nsPrefix,value))}for(var i=el.length;i--;){a=el[i];var prefix=a.prefix;prefix&&("xml"===prefix&&(a.uri="http://www.w3.org/XML/1998/namespace"),"xmlns"!==prefix&&(a.uri=currentNSMap[prefix]))}var nsp=tagName.indexOf(":");nsp>0?(prefix=el.prefix=tagName.slice(0,nsp),localName=el.localName=tagName.slice(nsp+1)):(prefix=null,localName=el.localName=tagName);var ns=el.uri=currentNSMap[prefix||""];if(domBuilder.startElement(ns,localName,tagName,el),el.closed){if(domBuilder.endElement(ns,localName,tagName),localNSMap)for(prefix in localNSMap)domBuilder.endPrefixMapping(prefix)}else el.currentNSMap=currentNSMap,el.localNSMap=localNSMap,parseStack.push(el)}function parseHtmlSpecialContent(source,elStartEnd,tagName,entityReplacer,domBuilder){if(/^(?:script|textarea)$/i.test(tagName)){var elEndStart=source.indexOf("</"+tagName+">",elStartEnd),text=source.substring(elStartEnd+1,elEndStart);if(/[&<]/.test(text))return/^script$/i.test(tagName)?(domBuilder.characters(text,0,text.length),elEndStart):(text=text.replace(/&#?\w+;/g,entityReplacer),domBuilder.characters(text,0,text.length),elEndStart)}return elStartEnd+1}function fixSelfClosed(source,elStartEnd,tagName,closeMap){var pos=closeMap[tagName];return null==pos&&(pos=closeMap[tagName]=source.lastIndexOf("</"+tagName+">")),elStartEnd>pos}function _copy(source,target){for(var n in source)target[n]=source[n]}function parseDCC(source,start,domBuilder,errorHandler){var next=source.charAt(start+2);switch(next){case"-":if("-"===source.charAt(start+3)){var end=source.indexOf("-->",start+4);return end>start?(domBuilder.comment(source,start+4,end-start-4),end+3):(errorHandler.error("Unclosed comment"),-1)}return-1;default:if("CDATA["==source.substr(start+3,6)){var end=source.indexOf("]]>",start+9);return domBuilder.startCDATA(),domBuilder.characters(source,start+9,end-start-9),domBuilder.endCDATA(),end+3}var matchs=split(source,start),len=matchs.length;if(len>1&&/!doctype/i.test(matchs[0][0])){var name=matchs[1][0],pubid=len>3&&/^public$/i.test(matchs[2][0])&&matchs[3][0],sysid=len>4&&matchs[4][0],lastMatch=matchs[len-1];return domBuilder.startDTD(name,pubid&&pubid.replace(/^(['"])(.*?)\1$/,"$2"),sysid&&sysid.replace(/^(['"])(.*?)\1$/,"$2")),domBuilder.endDTD(),lastMatch.index+lastMatch[0].length}}return-1}function parseInstruction(source,start,domBuilder){var end=source.indexOf("?>",start);if(end){var match=source.substring(start,end).match(/^<\?(\S*)\s*([\s\S]*?)\s*$/);if(match){match[0].length;return domBuilder.processingInstruction(match[1],match[2]),end+2}return-1}return-1}function ElementAttributes(source){}function _set_proto_(thiz,parent){return thiz.__proto__=parent,thiz}function split(source,start){var match,buf=[],reg=/'[^']+'|"[^"]+"|[^\s<>\/=]+=?|(\/?\s*>|<)/g;for(reg.lastIndex=start,reg.exec(source);match=reg.exec(source);)if(buf.push(match),match[1])return buf}var nameStartChar=/[A-Z_a-z\xC0-\xD6\xD8-\xF6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/,nameChar=new RegExp("[\\-\\.0-9"+nameStartChar.source.slice(1,-1)+"·̀-ͯ\\u203F-⁀]"),tagNamePattern=new RegExp("^"+nameStartChar.source+nameChar.source+"*(?::"+nameStartChar.source+nameChar.source+"*)?$"),S_TAG=0,S_ATTR=1,S_ATTR_S=2,S_EQ=3,S_V=4,S_E=5,S_S=6,S_C=7;XMLReader.prototype={parse:function(source,defaultNSMap,entityMap){var domBuilder=this.domBuilder;domBuilder.startDocument(),_copy(defaultNSMap,defaultNSMap={}),parse(source,defaultNSMap,entityMap,domBuilder,this.errorHandler),domBuilder.endDocument()}},ElementAttributes.prototype={setTagName:function(tagName){if(!tagNamePattern.test(tagName))throw new Error("invalid tagName:"+tagName);this.tagName=tagName},add:function(qName,value,offset){if(!tagNamePattern.test(qName))throw new Error("invalid attribute:"+qName);this[this.length++]={qName:qName,value:value,offset:offset}},length:0,getLocalName:function(i){return this[i].localName},getOffset:function(i){return this[i].offset},getQName:function(i){return this[i].qName},getURI:function(i){return this[i].uri},getValue:function(i){return this[i].value}},_set_proto_({},_set_proto_.prototype)instanceof _set_proto_||(_set_proto_=function(thiz,parent){function p(){}p.prototype=parent,p=new p;for(parent in thiz)p[parent]=thiz[parent];return p}),exports.XMLReader=XMLReader},function(module,exports,__webpack_require__){function copy(src,dest){for(var p in src)dest[p]=src[p]}function _extends(Class,Super){function t(){}var pt=Class.prototype;if(Object.create){var ppt=Object.create(Super.prototype);pt.__proto__=ppt}pt instanceof Super||(t.prototype=Super.prototype,t=new t,copy(pt,t),Class.prototype=pt=t),pt.constructor!=Class&&("function"!=typeof Class&&console.error("unknow Class:"+Class),pt.constructor=Class)}function DOMException(code,message){if(message instanceof Error)var error=message;else error=this,Error.call(this,ExceptionMessage[code]),this.message=ExceptionMessage[code],Error.captureStackTrace&&Error.captureStackTrace(this,DOMException);return error.code=code,message&&(this.message=this.message+": "+message),error}function NodeList(){}function LiveNodeList(node,refresh){this._node=node,this._refresh=refresh,_updateLiveList(this)}function _updateLiveList(list){var inc=list._node._inc||list._node.ownerDocument._inc;if(list._inc!=inc){
var ls=list._refresh(list._node);__set__(list,"length",ls.length),copy(ls,list),list._inc=inc}}function NamedNodeMap(){}function _findNodeIndex(list,node){for(var i=list.length;i--;)if(list[i]===node)return i}function _addNamedNode(el,list,newAttr,oldAttr){if(oldAttr?list[_findNodeIndex(list,oldAttr)]=newAttr:list[list.length++]=newAttr,el){newAttr.ownerElement=el;var doc=el.ownerDocument;doc&&(oldAttr&&_onRemoveAttribute(doc,el,oldAttr),_onAddAttribute(doc,el,newAttr))}}function _removeNamedNode(el,list,attr){var i=_findNodeIndex(list,attr);if(!(i>=0))throw DOMException(NOT_FOUND_ERR,new Error);for(var lastIndex=list.length-1;lastIndex>i;)list[i]=list[++i];if(list.length=lastIndex,el){var doc=el.ownerDocument;doc&&(_onRemoveAttribute(doc,el,attr),attr.ownerElement=null)}}function DOMImplementation(features){if(this._features={},features)for(var feature in features)this._features=features[feature]}function Node(){}function _xmlEncoder(c){return"<"==c&&"&lt;"||">"==c&&"&gt;"||"&"==c&&"&amp;"||'"'==c&&"&quot;"||"&#"+c.charCodeAt()+";"}function _visitNode(node,callback){if(callback(node))return!0;if(node=node.firstChild)do if(_visitNode(node,callback))return!0;while(node=node.nextSibling)}function Document(){}function _onAddAttribute(doc,el,newAttr){doc&&doc._inc++;var ns=newAttr.namespaceURI;"http://www.w3.org/2000/xmlns/"==ns&&(el._nsMap[newAttr.prefix?newAttr.localName:""]=newAttr.value)}function _onRemoveAttribute(doc,el,newAttr,remove){doc&&doc._inc++;var ns=newAttr.namespaceURI;"http://www.w3.org/2000/xmlns/"==ns&&delete el._nsMap[newAttr.prefix?newAttr.localName:""]}function _onUpdateChild(doc,el,newChild){if(doc&&doc._inc){doc._inc++;var cs=el.childNodes;if(newChild)cs[cs.length++]=newChild;else{for(var child=el.firstChild,i=0;child;)cs[i++]=child,child=child.nextSibling;cs.length=i}}}function _removeChild(parentNode,child){var previous=child.previousSibling,next=child.nextSibling;return previous?previous.nextSibling=next:parentNode.firstChild=next,next?next.previousSibling=previous:parentNode.lastChild=previous,_onUpdateChild(parentNode.ownerDocument,parentNode),child}function _insertBefore(parentNode,newChild,nextChild){var cp=newChild.parentNode;if(cp&&cp.removeChild(newChild),newChild.nodeType===DOCUMENT_FRAGMENT_NODE){var newFirst=newChild.firstChild;if(null==newFirst)return newChild;var newLast=newChild.lastChild}else newFirst=newLast=newChild;var pre=nextChild?nextChild.previousSibling:parentNode.lastChild;newFirst.previousSibling=pre,newLast.nextSibling=nextChild,pre?pre.nextSibling=newFirst:parentNode.firstChild=newFirst,null==nextChild?parentNode.lastChild=newLast:nextChild.previousSibling=newLast;do newFirst.parentNode=parentNode;while(newFirst!==newLast&&(newFirst=newFirst.nextSibling));return _onUpdateChild(parentNode.ownerDocument||parentNode,parentNode),newChild.nodeType==DOCUMENT_FRAGMENT_NODE&&(newChild.firstChild=newChild.lastChild=null),newChild}function _appendSingleChild(parentNode,newChild){var cp=newChild.parentNode;if(cp){var pre=parentNode.lastChild;cp.removeChild(newChild);var pre=parentNode.lastChild}var pre=parentNode.lastChild;return newChild.parentNode=parentNode,newChild.previousSibling=pre,newChild.nextSibling=null,pre?pre.nextSibling=newChild:parentNode.firstChild=newChild,parentNode.lastChild=newChild,_onUpdateChild(parentNode.ownerDocument,parentNode,newChild),newChild}function Element(){this._nsMap={}}function Attr(){}function CharacterData(){}function Text(){}function Comment(){}function CDATASection(){}function DocumentType(){}function Notation(){}function Entity(){}function EntityReference(){}function DocumentFragment(){}function ProcessingInstruction(){}function XMLSerializer(){}function serializeToString(node,buf,attributeSorter,isHTML){switch(node.nodeType){case ELEMENT_NODE:var attrs=node.attributes,len=attrs.length,child=node.firstChild,nodeName=node.tagName;isHTML=htmlns===node.namespaceURI||isHTML,buf.push("<",nodeName),attributeSorter&&buf.sort.apply(attrs,attributeSorter);for(var i=0;len>i;i++)serializeToString(attrs.item(i),buf,attributeSorter,isHTML);if(child||isHTML&&!/^(?:meta|link|img|br|hr|input|button)$/i.test(nodeName)){if(buf.push(">"),isHTML&&/^script$/i.test(nodeName))child&&buf.push(child.data);else for(;child;)serializeToString(child,buf,attributeSorter,isHTML),child=child.nextSibling;buf.push("</",nodeName,">")}else buf.push("/>");return;case DOCUMENT_NODE:case DOCUMENT_FRAGMENT_NODE:for(var child=node.firstChild;child;)serializeToString(child,buf,attributeSorter,isHTML),child=child.nextSibling;return;case ATTRIBUTE_NODE:return buf.push(" ",node.name,'="',node.value.replace(/[<&"]/g,_xmlEncoder),'"');case TEXT_NODE:return buf.push(node.data.replace(/[<&]/g,_xmlEncoder));case CDATA_SECTION_NODE:return buf.push("<![CDATA[",node.data,"]]>");case COMMENT_NODE:return buf.push("<!--",node.data,"-->");case DOCUMENT_TYPE_NODE:var pubid=node.publicId,sysid=node.systemId;if(buf.push("<!DOCTYPE ",node.name),pubid)buf.push(' PUBLIC "',pubid),sysid&&"."!=sysid&&buf.push('" "',sysid),buf.push('">');else if(sysid&&"."!=sysid)buf.push(' SYSTEM "',sysid,'">');else{var sub=node.internalSubset;sub&&buf.push(" [",sub,"]"),buf.push(">")}return;case PROCESSING_INSTRUCTION_NODE:return buf.push("<?",node.target," ",node.data,"?>");case ENTITY_REFERENCE_NODE:return buf.push("&",node.nodeName,";");default:buf.push("??",node.nodeName)}}function importNode(doc,node,deep){var node2;switch(node.nodeType){case ELEMENT_NODE:node2=node.cloneNode(!1),node2.ownerDocument=doc;case DOCUMENT_FRAGMENT_NODE:break;case ATTRIBUTE_NODE:deep=!0}if(node2||(node2=node.cloneNode(!1)),node2.ownerDocument=doc,node2.parentNode=null,deep)for(var child=node.firstChild;child;)node2.appendChild(importNode(doc,child,deep)),child=child.nextSibling;return node2}function cloneNode(doc,node,deep){var node2=new node.constructor;for(var n in node){var v=node[n];"object"!=typeof v&&v!=node2[n]&&(node2[n]=v)}switch(node.childNodes&&(node2.childNodes=new NodeList),node2.ownerDocument=doc,node2.nodeType){case ELEMENT_NODE:var attrs=node.attributes,attrs2=node2.attributes=new NamedNodeMap,len=attrs.length;attrs2._ownerElement=node2;for(var i=0;len>i;i++)node2.setAttributeNode(cloneNode(doc,attrs.item(i),!0));break;case ATTRIBUTE_NODE:deep=!0}if(deep)for(var child=node.firstChild;child;)node2.appendChild(cloneNode(doc,child,deep)),child=child.nextSibling;return node2}function __set__(object,key,value){object[key]=value}function getTextContent(node){switch(node.nodeType){case 1:case 11:var buf=[];for(node=node.firstChild;node;)7!==node.nodeType&&8!==node.nodeType&&buf.push(getTextContent(node)),node=node.nextSibling;return buf.join("");default:return node.nodeValue}}var htmlns="http://www.w3.org/1999/xhtml",NodeType={},ELEMENT_NODE=NodeType.ELEMENT_NODE=1,ATTRIBUTE_NODE=NodeType.ATTRIBUTE_NODE=2,TEXT_NODE=NodeType.TEXT_NODE=3,CDATA_SECTION_NODE=NodeType.CDATA_SECTION_NODE=4,ENTITY_REFERENCE_NODE=NodeType.ENTITY_REFERENCE_NODE=5,ENTITY_NODE=NodeType.ENTITY_NODE=6,PROCESSING_INSTRUCTION_NODE=NodeType.PROCESSING_INSTRUCTION_NODE=7,COMMENT_NODE=NodeType.COMMENT_NODE=8,DOCUMENT_NODE=NodeType.DOCUMENT_NODE=9,DOCUMENT_TYPE_NODE=NodeType.DOCUMENT_TYPE_NODE=10,DOCUMENT_FRAGMENT_NODE=NodeType.DOCUMENT_FRAGMENT_NODE=11,NOTATION_NODE=NodeType.NOTATION_NODE=12,ExceptionCode={},ExceptionMessage={},NOT_FOUND_ERR=(ExceptionCode.INDEX_SIZE_ERR=(ExceptionMessage[1]="Index size error",1),ExceptionCode.DOMSTRING_SIZE_ERR=(ExceptionMessage[2]="DOMString size error",2),ExceptionCode.HIERARCHY_REQUEST_ERR=(ExceptionMessage[3]="Hierarchy request error",3),ExceptionCode.WRONG_DOCUMENT_ERR=(ExceptionMessage[4]="Wrong document",4),ExceptionCode.INVALID_CHARACTER_ERR=(ExceptionMessage[5]="Invalid character",5),ExceptionCode.NO_DATA_ALLOWED_ERR=(ExceptionMessage[6]="No data allowed",6),ExceptionCode.NO_MODIFICATION_ALLOWED_ERR=(ExceptionMessage[7]="No modification allowed",7),ExceptionCode.NOT_FOUND_ERR=(ExceptionMessage[8]="Not found",8)),INUSE_ATTRIBUTE_ERR=(ExceptionCode.NOT_SUPPORTED_ERR=(ExceptionMessage[9]="Not supported",9),ExceptionCode.INUSE_ATTRIBUTE_ERR=(ExceptionMessage[10]="Attribute in use",10));ExceptionCode.INVALID_STATE_ERR=(ExceptionMessage[11]="Invalid state",11),ExceptionCode.SYNTAX_ERR=(ExceptionMessage[12]="Syntax error",12),ExceptionCode.INVALID_MODIFICATION_ERR=(ExceptionMessage[13]="Invalid modification",13),ExceptionCode.NAMESPACE_ERR=(ExceptionMessage[14]="Invalid namespace",14),ExceptionCode.INVALID_ACCESS_ERR=(ExceptionMessage[15]="Invalid access",15);DOMException.prototype=Error.prototype,copy(ExceptionCode,DOMException),NodeList.prototype={length:0,item:function(index){return this[index]||null},toString:function(){for(var buf=[],i=0;i<this.length;i++)serializeToString(this[i],buf);return buf.join("")}},LiveNodeList.prototype.item=function(i){return _updateLiveList(this),this[i]},_extends(LiveNodeList,NodeList),NamedNodeMap.prototype={length:0,item:NodeList.prototype.item,getNamedItem:function(key){for(var i=this.length;i--;){var attr=this[i];if(attr.nodeName==key)return attr}},setNamedItem:function(attr){var el=attr.ownerElement;if(el&&el!=this._ownerElement)throw new DOMException(INUSE_ATTRIBUTE_ERR);var oldAttr=this.getNamedItem(attr.nodeName);return _addNamedNode(this._ownerElement,this,attr,oldAttr),oldAttr},setNamedItemNS:function(attr){var oldAttr,el=attr.ownerElement;if(el&&el!=this._ownerElement)throw new DOMException(INUSE_ATTRIBUTE_ERR);return oldAttr=this.getNamedItemNS(attr.namespaceURI,attr.localName),_addNamedNode(this._ownerElement,this,attr,oldAttr),oldAttr},removeNamedItem:function(key){var attr=this.getNamedItem(key);return _removeNamedNode(this._ownerElement,this,attr),attr},removeNamedItemNS:function(namespaceURI,localName){var attr=this.getNamedItemNS(namespaceURI,localName);return _removeNamedNode(this._ownerElement,this,attr),attr},getNamedItemNS:function(namespaceURI,localName){for(var i=this.length;i--;){var node=this[i];if(node.localName==localName&&node.namespaceURI==namespaceURI)return node}return null}},DOMImplementation.prototype={hasFeature:function(feature,version){var versions=this._features[feature.toLowerCase()];return versions&&(!version||version in versions)?!0:!1},createDocument:function(namespaceURI,qualifiedName,doctype){var doc=new Document;if(doc.implementation=this,doc.childNodes=new NodeList,doc.doctype=doctype,doctype&&doc.appendChild(doctype),qualifiedName){var root=doc.createElementNS(namespaceURI,qualifiedName);doc.appendChild(root)}return doc},createDocumentType:function(qualifiedName,publicId,systemId){var node=new DocumentType;return node.name=qualifiedName,node.nodeName=qualifiedName,node.publicId=publicId,node.systemId=systemId,node}},Node.prototype={firstChild:null,lastChild:null,previousSibling:null,nextSibling:null,attributes:null,parentNode:null,childNodes:null,ownerDocument:null,nodeValue:null,namespaceURI:null,prefix:null,localName:null,insertBefore:function(newChild,refChild){return _insertBefore(this,newChild,refChild)},replaceChild:function(newChild,oldChild){this.insertBefore(newChild,oldChild),oldChild&&this.removeChild(oldChild)},removeChild:function(oldChild){return _removeChild(this,oldChild)},appendChild:function(newChild){return this.insertBefore(newChild,null)},hasChildNodes:function(){return null!=this.firstChild},cloneNode:function(deep){return cloneNode(this.ownerDocument||this,this,deep)},normalize:function(){for(var child=this.firstChild;child;){var next=child.nextSibling;next&&next.nodeType==TEXT_NODE&&child.nodeType==TEXT_NODE?(this.removeChild(next),child.appendData(next.data)):(child.normalize(),child=next)}},isSupported:function(feature,version){return this.ownerDocument.implementation.hasFeature(feature,version)},hasAttributes:function(){return this.attributes.length>0},lookupPrefix:function(namespaceURI){for(var el=this;el;){var map=el._nsMap;if(map)for(var n in map)if(map[n]==namespaceURI)return n;el=2==el.nodeType?el.ownerDocument:el.parentNode}return null},lookupNamespaceURI:function(prefix){for(var el=this;el;){var map=el._nsMap;if(map&&prefix in map)return map[prefix];el=2==el.nodeType?el.ownerDocument:el.parentNode}return null},isDefaultNamespace:function(namespaceURI){var prefix=this.lookupPrefix(namespaceURI);return null==prefix}},copy(NodeType,Node),copy(NodeType,Node.prototype),Document.prototype={nodeName:"#document",nodeType:DOCUMENT_NODE,doctype:null,documentElement:null,_inc:1,insertBefore:function(newChild,refChild){if(newChild.nodeType==DOCUMENT_FRAGMENT_NODE){for(var child=newChild.firstChild;child;){var next=child.nextSibling;this.insertBefore(child,refChild),child=next}return newChild}return null==this.documentElement&&1==newChild.nodeType&&(this.documentElement=newChild),_insertBefore(this,newChild,refChild),newChild.ownerDocument=this,newChild},removeChild:function(oldChild){return this.documentElement==oldChild&&(this.documentElement=null),_removeChild(this,oldChild)},importNode:function(importedNode,deep){return importNode(this,importedNode,deep)},getElementById:function(id){var rtv=null;return _visitNode(this.documentElement,function(node){return 1==node.nodeType&&node.getAttribute("id")==id?(rtv=node,!0):void 0}),rtv},createElement:function(tagName){var node=new Element;node.ownerDocument=this,node.nodeName=tagName,node.tagName=tagName,node.childNodes=new NodeList;var attrs=node.attributes=new NamedNodeMap;return attrs._ownerElement=node,node},createDocumentFragment:function(){var node=new DocumentFragment;return node.ownerDocument=this,node.childNodes=new NodeList,node},createTextNode:function(data){var node=new Text;return node.ownerDocument=this,node.appendData(data),node},createComment:function(data){var node=new Comment;return node.ownerDocument=this,node.appendData(data),node},createCDATASection:function(data){var node=new CDATASection;return node.ownerDocument=this,node.appendData(data),node},createProcessingInstruction:function(target,data){var node=new ProcessingInstruction;return node.ownerDocument=this,node.tagName=node.target=target,node.nodeValue=node.data=data,node},createAttribute:function(name){var node=new Attr;return node.ownerDocument=this,node.name=name,node.nodeName=name,node.localName=name,node.specified=!0,node},createEntityReference:function(name){var node=new EntityReference;return node.ownerDocument=this,node.nodeName=name,node},createElementNS:function(namespaceURI,qualifiedName){var node=new Element,pl=qualifiedName.split(":"),attrs=node.attributes=new NamedNodeMap;return node.childNodes=new NodeList,node.ownerDocument=this,node.nodeName=qualifiedName,node.tagName=qualifiedName,node.namespaceURI=namespaceURI,2==pl.length?(node.prefix=pl[0],node.localName=pl[1]):node.localName=qualifiedName,attrs._ownerElement=node,node},createAttributeNS:function(namespaceURI,qualifiedName){var node=new Attr,pl=qualifiedName.split(":");return node.ownerDocument=this,node.nodeName=qualifiedName,node.name=qualifiedName,node.namespaceURI=namespaceURI,node.specified=!0,2==pl.length?(node.prefix=pl[0],node.localName=pl[1]):node.localName=qualifiedName,node}},_extends(Document,Node),Element.prototype={nodeType:ELEMENT_NODE,hasAttribute:function(name){return null!=this.getAttributeNode(name)},getAttribute:function(name){var attr=this.getAttributeNode(name);return attr&&attr.value||""},getAttributeNode:function(name){return this.attributes.getNamedItem(name)},setAttribute:function(name,value){var attr=this.ownerDocument.createAttribute(name);attr.value=attr.nodeValue=""+value,this.setAttributeNode(attr)},removeAttribute:function(name){var attr=this.getAttributeNode(name);attr&&this.removeAttributeNode(attr)},appendChild:function(newChild){return newChild.nodeType===DOCUMENT_FRAGMENT_NODE?this.insertBefore(newChild,null):_appendSingleChild(this,newChild)},setAttributeNode:function(newAttr){return this.attributes.setNamedItem(newAttr)},setAttributeNodeNS:function(newAttr){return this.attributes.setNamedItemNS(newAttr)},removeAttributeNode:function(oldAttr){return this.attributes.removeNamedItem(oldAttr.nodeName)},removeAttributeNS:function(namespaceURI,localName){var old=this.getAttributeNodeNS(namespaceURI,localName);old&&this.removeAttributeNode(old)},hasAttributeNS:function(namespaceURI,localName){return null!=this.getAttributeNodeNS(namespaceURI,localName)},getAttributeNS:function(namespaceURI,localName){var attr=this.getAttributeNodeNS(namespaceURI,localName);return attr&&attr.value||""},setAttributeNS:function(namespaceURI,qualifiedName,value){var attr=this.ownerDocument.createAttributeNS(namespaceURI,qualifiedName);attr.value=attr.nodeValue=""+value,this.setAttributeNode(attr)},getAttributeNodeNS:function(namespaceURI,localName){return this.attributes.getNamedItemNS(namespaceURI,localName)},getElementsByTagName:function(tagName){return new LiveNodeList(this,function(base){var ls=[];return _visitNode(base,function(node){node===base||node.nodeType!=ELEMENT_NODE||"*"!==tagName&&node.tagName!=tagName||ls.push(node)}),ls})},getElementsByTagNameNS:function(namespaceURI,localName){return new LiveNodeList(this,function(base){var ls=[];return _visitNode(base,function(node){node===base||node.nodeType!==ELEMENT_NODE||"*"!==namespaceURI&&node.namespaceURI!==namespaceURI||"*"!==localName&&node.localName!=localName||ls.push(node)}),ls})}},Document.prototype.getElementsByTagName=Element.prototype.getElementsByTagName,Document.prototype.getElementsByTagNameNS=Element.prototype.getElementsByTagNameNS,_extends(Element,Node),Attr.prototype.nodeType=ATTRIBUTE_NODE,_extends(Attr,Node),CharacterData.prototype={data:"",substringData:function(offset,count){return this.data.substring(offset,offset+count)},appendData:function(text){text=this.data+text,this.nodeValue=this.data=text,this.length=text.length},insertData:function(offset,text){this.replaceData(offset,0,text)},appendChild:function(newChild){throw new Error(ExceptionMessage[3])},deleteData:function(offset,count){this.replaceData(offset,count,"")},replaceData:function(offset,count,text){var start=this.data.substring(0,offset),end=this.data.substring(offset+count);text=start+text+end,this.nodeValue=this.data=text,this.length=text.length}},_extends(CharacterData,Node),Text.prototype={nodeName:"#text",nodeType:TEXT_NODE,splitText:function(offset){var text=this.data,newText=text.substring(offset);text=text.substring(0,offset),this.data=this.nodeValue=text,this.length=text.length;var newNode=this.ownerDocument.createTextNode(newText);return this.parentNode&&this.parentNode.insertBefore(newNode,this.nextSibling),newNode}},_extends(Text,CharacterData),Comment.prototype={nodeName:"#comment",nodeType:COMMENT_NODE},_extends(Comment,CharacterData),CDATASection.prototype={nodeName:"#cdata-section",nodeType:CDATA_SECTION_NODE},_extends(CDATASection,CharacterData),DocumentType.prototype.nodeType=DOCUMENT_TYPE_NODE,_extends(DocumentType,Node),Notation.prototype.nodeType=NOTATION_NODE,_extends(Notation,Node),Entity.prototype.nodeType=ENTITY_NODE,_extends(Entity,Node),EntityReference.prototype.nodeType=ENTITY_REFERENCE_NODE,_extends(EntityReference,Node),DocumentFragment.prototype.nodeName="#document-fragment",DocumentFragment.prototype.nodeType=DOCUMENT_FRAGMENT_NODE,_extends(DocumentFragment,Node),ProcessingInstruction.prototype.nodeType=PROCESSING_INSTRUCTION_NODE,_extends(ProcessingInstruction,Node),XMLSerializer.prototype.serializeToString=function(node,attributeSorter){return node.toString(attributeSorter)},Node.prototype.toString=function(attributeSorter){var buf=[];return serializeToString(this,buf,attributeSorter),buf.join("")};try{Object.defineProperty&&(Object.defineProperty(LiveNodeList.prototype,"length",{get:function(){return _updateLiveList(this),this.$$length}}),Object.defineProperty(Node.prototype,"textContent",{get:function(){return getTextContent(this)},set:function(data){switch(this.nodeType){case 1:case 11:for(;this.firstChild;)this.removeChild(this.firstChild);(data||String(data))&&this.appendChild(this.ownerDocument.createTextNode(data));break;default:this.data=data,this.value=value,this.nodeValue=data}}}),__set__=function(object,key,value){object["$$"+key]=value})}catch(e){}exports.DOMImplementation=DOMImplementation,exports.XMLSerializer=XMLSerializer},function(module,exports,__webpack_require__){module.exports=[{classes:[{name:"GlobalSchema",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[{typeName:"Referencable",nameSpace:"",basicName:"Referencable",typeKind:0,typeArguments:[{typeName:"Sys.SchemaString",nameSpace:"Sys",basicName:"SchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"}],fields:[{name:"key",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Name of the global schema, used to refer on schema content"]}],valueConstraint:null,optional:!1},{name:"value",type:{typeName:"Sys.SchemaString",nameSpace:"Sys",basicName:"SchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},annotations:[{name:"MetaModel.description",arguments:["Content of the schema"]},{name:"MetaModel.value",arguments:[]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.actuallyExports",arguments:["value"]},{name:"MetaModel.description",arguments:["Content of the schema"]}],"extends":[{typeName:"RAMLSimpleElement",nameSpace:"",basicName:"RAMLSimpleElement",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"}],moduleName:"RAMLSpec",annotationOverridings:{}},{name:"Api",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"title",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The title property is a short plain text description of the RESTful API. The value SHOULD be suitable for use as a title for the contained user documentation."]}],valueConstraint:null,optional:!1},{name:"version",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["If the RAML API definition is targeted to a specific API version, the API definition MUST contain a version property. The version property is OPTIONAL and should not be used if: The API itself is not versioned. The API definition does not change between versions. The API architect can decide whether a change to user documentation elements, but no change to the API's resources, constitutes a version change. The API architect MAY use any versioning scheme so long as version numbers retain the same format. For example, 'v3', 'v3.0', and 'V3' are all allowed, but are not considered to be equal."]}],valueConstraint:null,optional:!1},{name:"baseUri",type:{typeName:"Sys.FullUriTemplateString",nameSpace:"Sys",basicName:"FullUriTemplateString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},annotations:[{name:"MetaModel.description",arguments:["(Optional during development; Required after implementation) A RESTful API's resources are defined relative to the API's base URI. The use of the baseUri field is OPTIONAL to allow describing APIs that have not yet been implemented. After the API is implemented (even a mock implementation) and can be accessed at a service endpoint, the API definition MUST contain a baseUri property. The baseUri property's value MUST conform to the URI specification RFC2396 or a Level 1 Template URI as defined in RFC6570. The baseUri property SHOULD only be used as a reference value."]}],valueConstraint:null,optional:!1},{name:"baseUriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.BURI"]},{name:"MetaModel.description",arguments:["Base uri parameters are named parameters which described template parameters in the base uri"]}],valueConstraint:null,optional:!1},{name:"uriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.BURI"]},{name:"MetaModel.description",arguments:["URI parameters can be further defined by using the uriParameters property. The use of uriParameters is OPTIONAL. The uriParameters property MUST be a map in which each key MUST be the name of the URI parameter as defined in the baseUri property. The uriParameters CANNOT contain a key named version because it is a reserved URI parameter name. The value of the uriParameters property is itself a map that specifies  the property's attributes as named parameters"]}],valueConstraint:null,optional:!1},{name:"protocols",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.oneOf",arguments:[["HTTP","HTTPS"]]},{name:"MetaModel.description",arguments:["A RESTful API can be reached HTTP, HTTPS, or both. The protocols property MAY be used to specify the protocols that an API supports. If the protocols property is not specified, the protocol specified at the baseUri property is used. The protocols property MUST be an array of strings, of values `HTTP` and/or `HTTPS`."]}],valueConstraint:null,optional:!1},{name:"mediaType",type:{typeName:"Bodies.MimeType",nameSpace:"Bodies",basicName:"MimeType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},annotations:[{name:"MetaModel.oftenKeys",arguments:[["application/json","application/xml","application/x-www-form-urlencoded","multipart/formdata"]]},{name:"MetaModel.description",arguments:["(Optional) The media types returned by API responses, and expected from API requests that accept a body, MAY be defaulted by specifying the mediaType property. This property is specified at the root level of the API definition. The property's value MAY be a single string with a valid media type described in the specification."]},{name:"MetaModel.inherited",arguments:[]}],valueConstraint:null,optional:!1},{name:"schemas",type:{base:{typeName:"GlobalSchema",nameSpace:"",basicName:"GlobalSchema",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["To better achieve consistency and simplicity, the API definition SHOULD include an OPTIONAL schemas property in the root section. The schemas property specifies collections of schemas that could be used anywhere in the API definition. The value of the schemas property is an array of maps; in each map, the keys are the schema name, and the values are schema definitions. The schema definitions MAY be included inline or by using the RAML !include user-defined data type."]}],valueConstraint:null,optional:!1},{name:"traits",type:{base:{typeName:"Methods.Trait",nameSpace:"Methods",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Declarations of traits used in this API"]}],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"Security.SecuritySchemeRef",nameSpace:"Security",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.allowNull",arguments:[]},{name:"MetaModel.description",arguments:["A list of the security schemes to apply to all methods, these must be defined in the securitySchemes declaration."]}],valueConstraint:null,optional:!1},{name:"securitySchemes",type:{base:{typeName:"Security.AbstractSecurityScheme",nameSpace:"Security",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Security schemes that can be applied using securedBy"]}],valueConstraint:null,optional:!1},{name:"resourceTypes",type:{base:{typeName:"Resources.ResourceType",nameSpace:"Resources",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Declaration of resource types used in this API"]}],valueConstraint:null,optional:!1},{name:"resources",type:{base:{typeName:"Resources.Resource",nameSpace:"Resources",basicName:"Resource",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Resource"]},{name:"MetaModel.description",arguments:["Resources are identified by their relative URI, which MUST begin with a slash (/). A resource defined as a root-level property is called a top-level resource. Its property's key is the resource's URI relative to the baseUri. A resource defined as a child property of another resource is called a nested resource, and its property's key is its URI relative to its parent resource's URI. Every property whose key begins with a slash (/), and is either at the root of the API definition or is the child property of a resource property, is a resource property. The key of a resource, i.e. its relative URI, MAY consist of multiple URI path fragments separated by slashes; e.g. `/bom/items` may indicate the collection of items in a bill of materials as a single resource. However, if the individual URI path fragments are themselves resources, the API definition SHOULD use nested resources to describe this structure; e.g. if `/bom` is itself a resource then `/items` should be a nested resource of `/bom`, while `/bom/items` should not be used."]}],valueConstraint:null,optional:!1},{name:"documentation",type:{base:{typeName:"DocumentationItem",nameSpace:"",basicName:"DocumentationItem",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["The API definition can include a variety of documents that serve as a user guides and reference documentation for the API. Such documents can clarify how the API works or provide business context. Documentation-generators MUST include all the sections in an API definition's documentation property in the documentation output, and they MUST preserve the order in which the documentation is declared. To add user documentation to the API, include the documentation property at the root of the API definition. The documentation property MUST be an array of documents. Each document MUST contain title and content attributes, both of which are REQUIRED. If the documentation property is specified, it MUST include at least one document. Documentation-generators MUST process the content field as if it was defined using Markdown."]
}],valueConstraint:null,optional:!1},{name:"RAMLVersion",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns AST node of security scheme, this reference refers to, or null."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[],moduleName:"RAMLSpec",annotationOverridings:{}},{name:"DocumentationItem",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"title",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["title of documentation section"]},{name:"MetaModel.required",arguments:[]}],valueConstraint:null,optional:!1},{name:"content",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},annotations:[{name:"MetaModel.description",arguments:["Content of documentation section"]},{name:"MetaModel.required",arguments:[]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"RAMLSimpleElement",nameSpace:"",basicName:"RAMLSimpleElement",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"}],moduleName:"RAMLSpec",annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts",Params:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts",Resources:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts",Methods:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts",Security:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/api.ts"},{classes:[{name:"SpecPartMetaData",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!0,annotations:[],"extends":[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts"},{classes:[{name:"ValueType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[],"extends":[],moduleName:null,annotationOverridings:{}},{name:"StringType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["string"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"AnyType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["any"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"NumberType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["number"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"BooleanType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["boolean"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"Referencable",methods:[],typeParameters:["T"],typeParameterConstraint:[null],"implements":[],fields:[],isInterface:!0,annotations:[],"extends":[],moduleName:null,annotationOverridings:{}},{name:"Reference",methods:[],typeParameters:["T"],typeParameterConstraint:[null],"implements":[],fields:[{name:"structuredValue",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns a structured object if the reference point to one."]}],valueConstraint:null,optional:!1},{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns name of referenced object"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"DeclaresDynamicType",methods:[],typeParameters:["T"],typeParameterConstraint:[null],"implements":[],fields:[],isInterface:!0,annotations:[],"extends":[{typeName:"Referencable",nameSpace:"",basicName:"Referencable",typeKind:0,typeArguments:[{typeName:"T",nameSpace:"",basicName:"T",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"UriTemplate",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This type currently serves both for absolute and relative urls"]}],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"RelativeUriString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This  type describes relative uri templates"]}],"extends":[{typeName:"UriTemplate",nameSpace:"",basicName:"UriTemplate",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"FullUriTemplateString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This  type describes absolute uri templates"]}],"extends":[{typeName:"UriTemplate",nameSpace:"",basicName:"UriTemplate",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"FixedUri",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This  type describes fixed uris"]}],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"MarkdownString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.innerType",arguments:["markdown"]},{name:"MetaModel.description",arguments:["Mardown string is a string which can contain markdown as an extension this markdown should support links with RAML Pointers since 1.0"]}],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"SchemaString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Schema at this moment only two subtypes are supported (json schema and xsd)"]}],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"JSonSchemaString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.functionalDescriminator",arguments:["this.mediaType&&this.mediaType.isJSON()"]},{name:"MetaModel.description",arguments:["JSON schema"]}],"extends":[{typeName:"SchemaString",nameSpace:"",basicName:"SchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"XMLSchemaString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.innerType",arguments:["xml"]},{name:"MetaModel.description",arguments:["XSD schema"]}],"extends":[{typeName:"SchemaString",nameSpace:"",basicName:"SchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"ExampleString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"StatusCodeString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"JSONExample",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.functionalDescriminator",arguments:["this.mediaType.isJSON()"]}],"extends":[{typeName:"ExampleString",nameSpace:"",basicName:"ExampleString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"XMLExample",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.functionalDescriminator",arguments:["this.mediaType.isXML()"]}],"extends":[{typeName:"ExampleString",nameSpace:"",basicName:"ExampleString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"TypeInstance",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"properties",type:{base:{typeName:"TypeInstanceProperty",nameSpace:"",basicName:"TypeInstanceProperty",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Array of instance properties"]}],valueConstraint:null,optional:!1},{name:"isScalar",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Whether the type is scalar"]}],valueConstraint:null,optional:!1},{name:"value",type:{typeName:"any",nameSpace:"",basicName:"any",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["For instances of scalar types returns scalar value"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.customHandling",arguments:[]}],"extends":[],moduleName:null,annotationOverridings:{}},{name:"TypeInstanceProperty",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Property name"]}],valueConstraint:null,optional:!1},{name:"value",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"},annotations:[{name:"MetaModel.description",arguments:["Property value"]}],valueConstraint:null,optional:!1},{name:"values",type:{base:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Array of values if property value is array"]}],valueConstraint:null,optional:!1},{name:"isArray",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Whether property has array as value"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.customHandling",arguments:[]}],"extends":[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"},{classes:[{name:"RAMLSimpleElement",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[],"extends":[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts"},{classes:[{name:"Parameter",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["name of the parameter"]},{name:"MetaModel.extraMetaKey",arguments:["headers"]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the parameter"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.defaultValue",arguments:["string"]},{name:"MetaModel.descriminatingProperty",arguments:[]},{name:"MetaModel.description",arguments:["The type attribute specifies the primitive type of the parameter's resolved value. API clients MUST return/throw an error if the parameter's resolved value does not match the specified type. If type is not specified, it defaults to string."]},{name:"MetaModel.canBeDuplicator",arguments:[]}],valueConstraint:null,optional:!1},{name:"location",type:{typeName:"ParameterLocation",nameSpace:"",basicName:"ParameterLocation",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"},annotations:[{name:"MetaModel.system",arguments:[]},{name:"MetaModel.description",arguments:["Location of the parameter (can not be edited by user)"]}],valueConstraint:null,optional:!1},{name:"required",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Set to true if parameter is required"]},{name:"MetaModel.defaultBooleanValue",arguments:[!0]}],valueConstraint:null,optional:!1},{name:"default",type:{typeName:"any",nameSpace:"",basicName:"any",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The default attribute specifies the default value to use for the property if the property is omitted or its value is not specified. This SHOULD NOT be interpreted as a requirement for the client to send the default attribute's value if there is no other value to send. Instead, the default attribute's value is the value the server uses if the client does not send a value."]}],valueConstraint:null,optional:!1},{name:"example",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["(Optional) The example attribute shows an example value for the property. This can be used, e.g., by documentation generators to generate sample values for the property."]}],valueConstraint:null,optional:!1},{name:"repeat",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The repeat attribute specifies that the parameter can be repeated. If the parameter can be used multiple times, the repeat parameter value MUST be set to 'true'. Otherwise, the default value is 'false' and the parameter may not be repeated."]},{name:"MetaModel.defaultBooleanValue",arguments:[!1]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"},annotations:[{name:"MetaModel.description",arguments:["The description attribute describes the intended use or meaning of the $self. This value MAY be formatted using Markdown."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[],moduleName:null,annotationOverridings:{}},{name:"StringTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"string"},optional:!1},{name:"pattern",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type string) The pattern attribute is a regular expression that a parameter of type string MUST match. Regular expressions MUST follow the regular expression specification from ECMA 262/Perl 5. The pattern MAY be enclosed in double quotes for readability and clarity."]}],valueConstraint:null,optional:!1},{name:"enum",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type string) The enum attribute provides an enumeration of the parameter's valid values. This MUST be an array. If the enum attribute is defined, API clients and servers MUST verify that a parameter's value matches a value in the enum array. If there is no matching value, the clients and servers MUST treat this as an error."]}],valueConstraint:null,optional:!1},{name:"minLength",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type string) The minLength attribute specifies the parameter value's minimum number of characters."]}],valueConstraint:null,optional:!1},{name:"maxLength",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type string) The maxLength attribute specifies the parameter value's maximum number of characters."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value must be a string"]}],"extends":[{typeName:"Parameter",nameSpace:"",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"}],moduleName:null,annotationOverridings:{}},{name:"BooleanTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"boolean"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value must be a boolean"]}],"extends":[{typeName:"Parameter",nameSpace:"",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"}],moduleName:null,annotationOverridings:{}},{name:"NumberTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"number"},optional:!1},{name:"minimum",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type number or integer) The minimum attribute specifies the parameter's minimum value."]}],valueConstraint:null,optional:!1},{name:"maximum",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type number or integer) The maximum attribute specifies the parameter's maximum value."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value MUST be a number. Indicate floating point numbers as defined by YAML."]}],"extends":[{typeName:"Parameter",nameSpace:"",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"}],moduleName:null,annotationOverridings:{}},{name:"IntegerTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"integer"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value MUST be a integer."]}],"extends":[{typeName:"NumberTypeDeclaration",nameSpace:"",basicName:"NumberTypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"date"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value MUST be a string representation of a date as defined in RFC2616 Section 3.3. "]}],"extends":[{typeName:"Parameter",nameSpace:"",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"}],moduleName:null,annotationOverridings:{}},{name:"FileTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"file"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.requireValue",arguments:["location","ParameterLocation.FORM"]},{name:"MetaModel.description",arguments:["(Applicable only to Form properties) Value is a file. Client generators SHOULD use this type to handle file uploads correctly."]}],"extends":[{typeName:"Parameter",nameSpace:"",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[{name:"ParameterLocation",members:["QUERY","HEADERS","URI","FORM","BURI"]}],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts"},{classes:[{name:"MimeType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This sub type of the string represents mime types"]}],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"}],moduleName:null,annotationOverridings:{}},{name:"BodyLike",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Mime type of the request or response body"]},{name:"MetaModel.canInherit",arguments:["mediaType"]},{name:"MetaModel.oftenKeys",arguments:[["application/json","application/xml","application/x-www-form-urlencoded","multipart/form-data"]]}],valueConstraint:null,optional:!1},{name:"schema",type:{typeName:"Sys.SchemaString",nameSpace:"Sys",basicName:"SchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.requireValue",arguments:["this.name.isForm()","false"]},{name:"MetaModel.description",arguments:["The structure of a request or response body MAY be further specified by the schema property under the appropriate media type. The schema key CANNOT be specified if a body's media type is application/x-www-form-urlencoded or multipart/form-data. All parsers of RAML MUST be able to interpret JSON Schema and XML Schema. Schema MAY be declared inline or in an external file. However, if the schema is sufficiently large so as to make it difficult for a person to read the API definition, or the schema is reused across multiple APIs or across multiple miles in the same API, the !include user-defined data type SHOULD be used instead of including the content inline. Alternatively, the value of the schema field MAY be the name of a schema specified in the root-level schemas property, or it MAY be declared in an external file and included by using the by using the RAML !include user-defined data type."]}],valueConstraint:null,optional:!1},{name:"example",type:{typeName:"Sys.ExampleString",nameSpace:"Sys",basicName:"ExampleString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.description",arguments:["Documentation generators MUST use body properties' example attributes to generate example invocations."]}],valueConstraint:null,optional:!1},{name:"formParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.FORM"]},{name:"MetaModel.description",arguments:["Web forms REQUIRE special encoding and custom declaration. If the API's media type is either application/x-www-form-urlencoded or multipart/form-data, the formParameters property MUST specify the name-value pairs that the API is expecting. The formParameters property is a map in which the key is the name of the web form parameter, and the value is itself a map the specifies the web form parameter's attributes."]}],valueConstraint:null,optional:!1},{name:"schemaContent",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns schema content for the cases when schema is inlined, when schema is included, and when schema is a reference."]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.description",arguments:["Human readable description of the body"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.canInherit",arguments:["mediaType"]}],"extends":[],moduleName:null,annotationOverridings:{}},{name:"XMLBody",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"schema",type:{typeName:"Sys.XMLSchemaString",nameSpace:"Sys",basicName:"XMLSchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.description",arguments:["XSD Schema"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.functionalDescriminator",arguments:["this.mime.isXML()"]},{name:"MetaModel.description",
arguments:["Needed to set connection between xml related mime types and xsd schema"]}],"extends":[{typeName:"BodyLike",nameSpace:"",basicName:"BodyLike",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"}],moduleName:null,annotationOverridings:{}},{name:"JSONBody",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"schema",type:{typeName:"Sys.JSonSchemaString",nameSpace:"Sys",basicName:"JSonSchemaString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.description",arguments:["JSON Schema"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.functionalDescriminator",arguments:["this.mime.isJSON()"]},{name:"MetaModel.description",arguments:["Needed to set connection between json related mime types and json schema"]}],"extends":[{typeName:"BodyLike",nameSpace:"",basicName:"BodyLike",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"}],moduleName:null,annotationOverridings:{}},{name:"Response",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"code",type:{typeName:"Sys.StatusCodeString",nameSpace:"Sys",basicName:"StatusCodeString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.extraMetaKey",arguments:["statusCodes"]},{name:"MetaModel.description",arguments:["Responses MUST be a map of one or more HTTP status codes, where each status code itself is a map that describes that status code."]}],valueConstraint:null,optional:!1},{name:"headers",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.HEADERS"]},{name:"MetaModel.newInstanceName",arguments:["New Header"]},{name:"MetaModel.description",arguments:["An API's methods may support custom header values in responses. The custom, non-standard HTTP headers MUST be specified by the headers property. API's may include the the placeholder token {?} in a header name to indicate that any number of headers that conform to the specified format can be sent in responses. This is particularly useful for APIs that allow HTTP headers that conform to some naming convention to send arbitrary, custom data."]}],valueConstraint:null,optional:!1},{name:"body",type:{base:{typeName:"BodyLike",nameSpace:"",basicName:"BodyLike",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Body"]},{name:"MetaModel.description",arguments:["Each response MAY contain a body property, which conforms to the same structure as request body properties (see Body). Responses that can return more than one response code MAY therefore have multiple bodies defined. For APIs without a priori knowledge of the response types for their responses, `*/*` MAY be used to indicate that responses that do not matching other defined data types MUST be accepted. Processing applications MUST match the most descriptive media type first if `*/*` is used."]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},annotations:[{name:"MetaModel.description",arguments:["The description attribute describes the intended use or meaning of the $self. This value MAY be formatted using Markdown."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts",Params:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts"},{classes:[{name:"Resource",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"relativeUri",type:{typeName:"Sys.RelativeUriString",nameSpace:"Sys",basicName:"RelativeUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.startFrom",arguments:["/"]},{name:"MetaModel.description",arguments:["Relative URL of this resource from the parent resource"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"ResourceTypeRef",nameSpace:"",basicName:"ResourceTypeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed resource type"]}],valueConstraint:null,optional:!1},{name:"is",type:{base:{typeName:"TraitRef",nameSpace:"",basicName:"TraitRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed traits"]}],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"SecuritySchemeRef",nameSpace:"",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.allowNull",arguments:[]},{name:"MetaModel.description",arguments:["securityScheme may also be applied to a resource by using the securedBy key, which is equivalent to applying the securityScheme to all methods that may be declared, explicitly or implicitly, by defining the resourceTypes or traits property for that resource. To indicate that the method may be called without applying any securityScheme, the method may be annotated with the null securityScheme."]}],valueConstraint:null,optional:!1},{name:"uriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.URI"]},{name:"MetaModel.description",arguments:["Uri parameters of this resource"]}],valueConstraint:null,optional:!1},{name:"methods",type:{base:{typeName:"Methods.Method",nameSpace:"Methods",basicName:"Method",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Method"]},{name:"MetaModel.description",arguments:["Methods that can be called on this resource"]}],valueConstraint:null,optional:!1},{name:"resources",type:{base:{typeName:"Resource",nameSpace:"",basicName:"Resource",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Resource"]},{name:"MetaModel.description",arguments:["Children resources"]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the resource"]}],valueConstraint:null,optional:!1},{name:"baseUriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.BURI"]},{name:"MetaModel.description",arguments:["A resource or a method can override a base URI template's values. This is useful to restrict or change the default or parameter selection in the base URI. The baseUriParameters property MAY be used to override any or all parameters defined at the root level baseUriParameters property, as well as base URI parameters not specified at the root level."]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.description",arguments:["The description attribute describes the intended use or meaning of the $self. This value MAY be formatted using Markdown."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[],moduleName:null,annotationOverridings:{}},{name:"ResourceTypeRef",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"resourceType",type:{typeName:"ResourceType",nameSpace:"",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns referenced resource type"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"ResourceType",nameSpace:"",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"}],moduleName:null,annotationOverridings:{}},{name:"ResourceType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[{typeName:"DeclaresDynamicType",nameSpace:"",basicName:"DeclaresDynamicType",typeKind:0,typeArguments:[{typeName:"ResourceType",nameSpace:"",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"}],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Name of the resource type"]}],valueConstraint:null,optional:!1},{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Instructions on how and when the resource type should be used."]}],valueConstraint:null,optional:!1},{name:"methods",type:{base:{typeName:"Methods.Method",nameSpace:"Methods",basicName:"Method",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Methods that are part of this resource type definition"]}],valueConstraint:null,optional:!1},{name:"is",type:{base:{typeName:"Security.TraitRef",nameSpace:"Security",basicName:"TraitRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed traits"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"ResourceTypeRef",nameSpace:"",basicName:"ResourceTypeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed resource type"]}],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"Security.SecuritySchemeRef",nameSpace:"Security",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.allowNull",arguments:[]},{name:"MetaModel.description",arguments:["securityScheme may also be applied to a resource by using the securedBy key, which is equivalent to applying the securityScheme to all methods that may be declared, explicitly or implicitly, by defining the resourceTypes or traits property for that resource. To indicate that the method may be called without applying any securityScheme, the method may be annotated with the null securityScheme."]}],valueConstraint:null,optional:!1},{name:"uriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.URI"]},{name:"MetaModel.description",arguments:["Uri parameters of this resource"]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the resource type"]}],valueConstraint:null,optional:!1},{name:"baseUriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.BURI"]},{name:"MetaModel.description",arguments:["A resource or a method can override a base URI template's values. This is useful to restrict or change the default or parameter selection in the base URI. The baseUriParameters property MAY be used to override any or all parameters defined at the root level baseUriParameters property, as well as base URI parameters not specified at the root level."]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"Sys.TypeInstance",nameSpace:"Sys",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns object representation of parametrized properties of the resource type"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},annotations:[{name:"MetaModel.description",arguments:["The description attribute describes the intended use or meaning of the $self. This value MAY be formatted using Markdown."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.inlinedTemplates",arguments:[]},{name:"MetaModel.allowQuestion",arguments:[]}],"extends":[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts",Params:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts",Methods:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts",Security:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/resources.ts"},{classes:[{name:"MethodBase",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"responses",type:{base:{typeName:"Bodies.Response",nameSpace:"Bodies",basicName:"Response",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Response"]},{name:"MetaModel.description",arguments:["Resource methods MAY have one or more responses. Responses MAY be described using the description property, and MAY include example attributes or schema properties."]}],valueConstraint:null,optional:!1},{name:"body",type:{base:{typeName:"Bodies.BodyLike",nameSpace:"Bodies",basicName:"BodyLike",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Body"]},{name:"MetaModel.description",arguments:["Some method verbs expect the resource to be sent as a request body. For example, to create a resource, the request must include the details of the resource to create. Resources CAN have alternate representations. For example, an API might support both JSON and XML representations. A method's body is defined in the body property as a hashmap, in which the key MUST be a valid media type."]}],valueConstraint:null,optional:!1},{name:"protocols",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.oneOf",arguments:[["HTTP","HTTPS"]]},{name:"MetaModel.description",arguments:["A method can override an API's protocols value for that single method by setting a different value for the fields."]}],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"SecuritySchemeRef",nameSpace:"",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.allowNull",arguments:[]},{name:"MetaModel.description",arguments:["A list of the security schemas to apply, these must be defined in the securitySchemes declaration. To indicate that the method may be called without applying any securityScheme, the method may be annotated with the null securityScheme. Security schemas may also be applied to a resource with securedBy, which is equivalent to applying the security schemas to all methods that may be declared, explicitly or implicitly, by defining the resourceTypes or traits property for that resource."]}],valueConstraint:null,optional:!1},{name:"baseUriParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","Params.ParameterLocation.BURI"]},{name:"MetaModel.description",arguments:["A resource or a method can override a base URI template's values. This is useful to restrict or change the default or parameter selection in the base URI. The baseUriParameters property MAY be used to override any or all parameters defined at the root level baseUriParameters property, as well as base URI parameters not specified at the root level."]}],valueConstraint:null,optional:!1},{name:"queryParameters",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","ParameterLocation.QUERY"]},{name:"MetaModel.newInstanceName",arguments:["New query parameter"]},{name:"MetaModel.description",arguments:["An APIs resources MAY be filtered (to return a subset of results) or altered (such as transforming a response body from JSON to XML format) by the use of query strings. If the resource or its method supports a query string, the query string MUST be defined by the queryParameters property"]}],valueConstraint:null,optional:!1},{name:"headers",type:{base:{typeName:"Params.Parameter",nameSpace:"Params",basicName:"Parameter",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","ParameterLocation.HEADERS"]},{name:"MetaModel.description",arguments:["Headers that allowed at this position"]},{name:"MetaModel.newInstanceName",arguments:["New Header"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Method object allows description of http methods"]}],"extends":[],moduleName:null,annotationOverridings:{}},{name:"Method",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"method",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.extraMetaKey",arguments:["methods"]},{name:"MetaModel.oneOf",arguments:[["get","put","post","delete","patch","options","head","trace","connect"]]},{name:"MetaModel.description",arguments:["Method that can be called"]}],valueConstraint:null,optional:!1},{name:"is",type:{base:{typeName:"TraitRef",nameSpace:"",basicName:"TraitRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed traits"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"MethodBase",nameSpace:"",basicName:"MethodBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"}],moduleName:null,annotationOverridings:{}},{name:"Trait",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[{typeName:"DeclaresDynamicType",nameSpace:"",basicName:"DeclaresDynamicType",typeKind:0,typeArguments:[{typeName:"Trait",nameSpace:"",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"}],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Name of the trait"]}],valueConstraint:null,optional:!1},{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Instructions on how and when the trait should be used."]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"Sys.TypeInstance",nameSpace:"Sys",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns object representation of parametrized properties of the trait"]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the trait"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.inlinedTemplates",arguments:[]},{name:"MetaModel.allowQuestion",arguments:[]}],"extends":[{typeName:"MethodBase",nameSpace:"",basicName:"MethodBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"}],moduleName:null,annotationOverridings:{}},{name:"TraitRef",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"trait",type:{typeName:"Trait",nameSpace:"",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns referenced trait"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"Trait",nameSpace:"",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts",Params:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts",Security:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},{classes:[{name:"SecuritySchemePart",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the security scheme part"]}],valueConstraint:null,optional:!1},{name:"is",type:{base:{typeName:"TraitRef",nameSpace:"",basicName:"TraitRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed traits"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"MethodBase",nameSpace:"",basicName:"MethodBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{headers:[{name:"MetaModel.markdownDescription",arguments:["Optional array of headers, documenting the possible headers that could be accepted."]},{name:"MetaModel.valueDescription",arguments:["Object whose property names are the request header names and whose values describe the values."]}],queryParameters:[{name:"MetaModel.markdownDescription",arguments:["Query parameters, used by the schema in order to authorize the request. Mutually exclusive with queryString."]},{name:"MetaModel.valueDescription",arguments:["Object whose property names are the query parameter names and whose values describe the values."]}],queryString:[{name:"MetaModel.description",arguments:["Specifies the query string, used by the schema in order to authorize the request. Mutually exclusive with queryParameters."]},{name:"MetaModel.valueDescription",arguments:["Type name or type declaration"]}],responses:[{name:"MetaModel.description",arguments:["Optional array of responses, describing the possible responses that could be sent."]}],description:[{name:"MetaModel.description",arguments:["A longer, human-friendly description of the security scheme part"]},{name:"MetaModel.valueDescription",arguments:["Markdown string"]}]}},{name:"SecuritySchemeSettings",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]}],"extends":[],moduleName:null,annotationOverridings:{}},{name:"AbstractSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[{typeName:"Referencable",nameSpace:"",basicName:"Referencable",typeKind:0,typeArguments:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.startFrom",arguments:[""]},{name:"MetaModel.hide",arguments:[]},{name:"MetaModel.description",arguments:["Name of the security scheme"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.oneOf",arguments:[["OAuth 1.0","OAuth 2.0","Basic Authentication","DigestSecurityScheme Authentication","x-{other}"]]},{name:"MetaModel.descriminatingProperty",arguments:[]},{name:"MetaModel.description",arguments:["The securitySchemes property MUST be used to specify an API's security mechanisms, including the required settings and the authentication methods that the API supports. one authentication method is allowed if the API supports them."]
},{name:"MetaModel.valueDescription",arguments:["string<br><br>The value MUST be one of<br>* OAuth 1.0,<br>* OAuth 2.0, <br>* BasicSecurityScheme Authentication<br>* DigestSecurityScheme Authentication<br>* x-&lt;other&gt;"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.description",arguments:["The description attribute MAY be used to describe a security schemes property."]}],valueConstraint:null,optional:!1},{name:"describedBy",type:{typeName:"SecuritySchemePart",nameSpace:"",basicName:"SecuritySchemePart",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.description",arguments:["A description of the request components related to Security that are determined by the scheme: the headers, query parameters or responses. As a best practice, even for standard security schemes, API designers SHOULD describe these properties of security schemes. Including the security scheme description completes an API documentation."]}],valueConstraint:null,optional:!1},{name:"settings",type:{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.description",arguments:["The settings attribute MAY be used to provide security scheme-specific information. The required attributes vary depending on the type of security scheme is being declared. It describes the minimum set of properties which any processing application MUST provide and validate if it chooses to implement the security scheme. Processing applications MAY choose to recognize other properties for things such as token lifetime, preferred cryptographic algorithms, and more."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security schema definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[],moduleName:null,annotationOverridings:{}},{name:"SecuritySchemeRef",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"securitySchemeName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns the name of security scheme, this reference refers to."]}],valueConstraint:null,optional:!1},{name:"securityScheme",type:{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns AST node of security scheme, this reference refers to, or null."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]}],"extends":[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth1SecuritySchemeSettings",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"requestTokenUri",type:{typeName:"Sys.FixedUri",nameSpace:"Sys",basicName:"FixedUri",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Temporary Credential Request endpoint as defined in RFC5849 Section 2.1"]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"authorizationUri",type:{typeName:"Sys.FixedUri",nameSpace:"Sys",basicName:"FixedUri",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Resource Owner Authorization endpoint as defined in RFC5849 Section 2.2"]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"tokenCredentialsUri",type:{typeName:"Sys.FixedUri",nameSpace:"Sys",basicName:"FixedUri",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Token Request endpoint as defined in RFC5849 Section 2.3"]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]},{name:"MetaModel.functionalDescriminator",arguments:["$parent.type=='OAuth 1.0'"]}],"extends":[{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth2SecuritySchemeSettings",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"accessTokenUri",type:{typeName:"Sys.FixedUri",nameSpace:"Sys",basicName:"FixedUri",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Token Endpoint as defined in RFC6749 Section 3.2. Not required forby implicit grant type."]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"authorizationUri",type:{typeName:"Sys.FixedUri",nameSpace:"Sys",basicName:"FixedUri",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Authorization Endpoint as defined in RFC6749 Section 3.1. Required forby authorization_code and implicit grant types."]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"authorizationGrants",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["A list of the Authorization grants supported by the API as defined in RFC6749 Sections 4.1, 4.2, 4.3 and 4.4, can be any of: authorization_code, password, client_credentials, implicit, or refresh_token."]},{name:"MetaModel.markdownDescription",arguments:["A list of the Authorization grants supported by the API as defined in RFC6749 Sections 4.1, 4.2, 4.3 and 4.4, can be any of:<br>* authorization_code<br>* password<br>* client_credentials <br>* implicit<br>* refresh_token."]}],valueConstraint:null,optional:!1},{name:"scopes",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["A list of scopes supported by the security scheme as defined in RFC6749 Section 3.3"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]}],"extends":[{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth2SecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"OAuth 2.0"},optional:!1},{name:"settings",type:{typeName:"OAuth2SecuritySchemeSettings",nameSpace:"",basicName:"OAuth2SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security schema definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth1SecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"OAuth 1.0"},optional:!1},{name:"settings",type:{typeName:"OAuth1SecuritySchemeSettings",nameSpace:"",basicName:"OAuth1SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security schema definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"BasicSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"Basic Authentication"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security schema definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"DigestSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"Digest Authentication"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security schema definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"CustomSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"x-{other}"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security schema definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/systemTypes.ts",Params:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/parameters.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/bodies.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/common.ts",Methods:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/methods.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-0.8/security.ts"}]},function(module,exports,__webpack_require__){module.exports=[{classes:[{name:"Library",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["contains description of why library exist"]}],valueConstraint:null,optional:!1},{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Namespace which the library is imported under"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"LibraryBase",nameSpace:"",basicName:"LibraryBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}},{name:"LibraryBase",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"schemas",type:{base:{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:['Alias for the equivalent "types" property, for compatibility with RAML 0.8. Deprecated - API definitions should use the "types" property, as the "schemas" alias for that property name may be removed in a future RAML version. The "types" property allows for XML and JSON schemas.']}],valueConstraint:null,optional:!1},{name:"types",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.setsContextValue",arguments:["locationKind","DataModel.LocationKind.MODELS"]},{name:"MetaModel.description",arguments:["Declarations of (data) types for use within this API"]},{name:"MetaModel.markdownDescription",arguments:["Declarations of (data) types for use within this API."]},{name:"MetaModel.valueDescription",arguments:["An object whose properties map type names to type declarations; or an array of such objects"]}],valueConstraint:null,optional:!1},{name:"traits",type:{base:{typeName:"Methods.Trait",nameSpace:"Methods",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Declarations of traits used in this API"]},{name:"MetaModel.description",arguments:["Declarations of traits for use within this API"]},{name:"MetaModel.markdownDescription",arguments:["Declarations of traits for use within this API."]},{name:"MetaModel.valueDescription",arguments:["An object whose properties map trait names to trait declarations; or an array of such objects"]}],valueConstraint:null,optional:!1},{name:"resourceTypes",type:{base:{typeName:"Resources.ResourceType",nameSpace:"Resources",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Declaration of resource types used in this API"]},{name:"MetaModel.description",arguments:["Declarations of resource types for use within this API"]},{name:"MetaModel.markdownDescription",arguments:["Declarations of resource types for use within this API."]},{name:"MetaModel.valueDescription",arguments:["An object whose properties map resource type names to resource type declarations; or an array of such objects"]}],valueConstraint:null,optional:!1},{name:"annotationTypes",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["decls","true"]},{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Declarations of annotation types for use by annotations"]},{name:"MetaModel.markdownDescription",arguments:["Declarations of annotation types for use by annotations."]},{name:"MetaModel.valueDescription",arguments:["An object whose properties map annotation type names to annotation type declarations; or an array of such objects"]}],valueConstraint:null,optional:!1},{name:"securitySchemes",type:{base:{typeName:"Security.AbstractSecurityScheme",nameSpace:"Security",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]},{name:"MetaModel.description",arguments:["Security schemas declarations"]},{name:"MetaModel.description",arguments:["Declarations of security schemes for use within this API."]},{name:"MetaModel.markdownDescription",arguments:["Declarations of security schemes for use within this API."]},{name:"MetaModel.valueDescription",arguments:["An object whose properties map security scheme names to security scheme declarations; or an array of such objects"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.internalClass",arguments:[]}],"extends":[{typeName:"FragmentDeclaration",nameSpace:"",basicName:"FragmentDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}},{name:"Api",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"title",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["Short plain-text label for the API"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},annotations:[{name:"MetaModel.description",arguments:["A longer, human-friendly description of the API"]}],valueConstraint:null,optional:!1},{name:"version",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The version of the API, e.g. 'v1'"]}],valueConstraint:null,optional:!1},{name:"baseUri",type:{typeName:"Sys.FullUriTemplateString",nameSpace:"Sys",basicName:"FullUriTemplateString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},annotations:[{name:"MetaModel.description",arguments:["A URI that's to be used as the base of all the resources' URIs. Often used as the base of the URL of each resource, containing the location of the API. Can be a template URI."]}],valueConstraint:null,optional:!1},{name:"baseUriParameters",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","DataModel.ModelLocation.BURI"]},{name:"MetaModel.setsContextValue",arguments:["locationKind","DataModel.LocationKind.APISTRUCTURE"]},{name:"MetaModel.description",arguments:["Named parameters used in the baseUri (template)"]}],valueConstraint:null,optional:!1},{name:"protocols",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.oneOf",arguments:[["HTTP","HTTPS"]]},{name:"MetaModel.description",arguments:["The protocols supported by the API"]},{name:"MetaModel.valueDescription",arguments:['Array of strings, with each being "HTTP" or "HTTPS", case-insensitive']}],valueConstraint:null,optional:!1},{name:"mediaType",type:{base:{typeName:"Bodies.MimeType",nameSpace:"Bodies",basicName:"MimeType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.oftenKeys",arguments:[["application/json","application/xml","application/x-www-form-urlencoded","multipart/form-data"]]},{name:"MetaModel.description",arguments:['The default media type to use for request and response bodies (payloads), e.g. "application/json"']},{name:"MetaModel.inherited",arguments:[]},{name:"MetaModel.valueDescription",arguments:["Media type string"]}],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"Security.SecuritySchemeRef",nameSpace:"Security",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["The security schemes that apply to every resource and method in the API"]}],valueConstraint:null,optional:!1},{name:"resources",type:{base:{typeName:"Resources.Resource",nameSpace:"Resources",basicName:"Resource",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.documentationTableLabel",arguments:["/&lt;relativeUri&gt;"]},{name:"MetaModel.newInstanceName",arguments:["New Resource"]},{name:"MetaModel.description",arguments:["The resources of the API, identified as relative URIs that begin with a slash (/). Every property whose key begins with a slash (/), and is either at the root of the API definition or is the child property of a resource property, is a resource property, e.g.: /users, /{groupId}, etc"]}],valueConstraint:null,optional:!1},{name:"documentation",type:{base:{typeName:"DocumentationItem",nameSpace:"",basicName:"DocumentationItem",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Additional overall documentation for the API"]}],valueConstraint:null,optional:!1},{name:"RAMLVersion",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:['Returns RAML version. "RAML10" string is returned for RAML 1.0. "RAML08" string is returned for RAML 0.8.']}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"LibraryBase",nameSpace:"",basicName:"LibraryBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{annotations:[{name:"MetaModel.markdownDescription",arguments:['Annotations to be applied to this API. Annotations are any property whose key begins with "(" and ends with ")" and whose name (the part between the beginning and ending parentheses) is a declared annotation name.']}]}},{name:"Overlay",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["contains description of why overlay exist"]}],valueConstraint:null,optional:!1},{name:"extends",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["Location of a valid RAML API definition (or overlay or extension), the overlay is applied to."]}],valueConstraint:null,optional:!1},{name:"title",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Short plain-text label for the API"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Api",nameSpace:"",basicName:"Api",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}},{name:"Extension",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["contains description of why extension exist"]}],valueConstraint:null,optional:!1},{name:"extends",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["Location of a valid RAML API definition (or overlay or extension), the extension is applied to"]}],valueConstraint:null,optional:!1},{name:"title",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Short plain-text label for the API"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Api",nameSpace:"",basicName:"Api",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}},{name:"UsesDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"key",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Name prefix (without dot) used to refer imported declarations"]}],valueConstraint:null,optional:!1},{name:"value",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Content of the schema"]},{name:"MetaModel.canBeValue",arguments:[]},{name:"MetaModel.value",arguments:[]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}},{name:"FragmentDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"uses",type:{base:{typeName:"UsesDeclaration",nameSpace:"",basicName:"UsesDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},typeKind:1},annotations:[{name:"MetaModel.embeddedInMaps",arguments:[]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}},{name:"DocumentationItem",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"title",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Title of documentation section"]},{name:"MetaModel.required",arguments:[]}],valueConstraint:null,optional:!1},{name:"content",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"},annotations:[{name:"MetaModel.description",arguments:["Content of documentation section"]},{name:"MetaModel.required",arguments:[]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.possibleInterfaces",arguments:[["FragmentDeclaration"]]}],"extends":[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",Methods:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts",Resources:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts",Decls:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts",Params:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/parameters.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts",Security:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/api.ts"
},{classes:[{name:"SpecPartMetaData",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!0,annotations:[],"extends":[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts"},{classes:[{name:"ValueType",methods:[{returnType:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},name:"value",start:170,end:210,text:"\n\n  value():string {\n    return null\n  }",arguments:[]}],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[],"extends":[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"StringType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["string"]},{name:"MetaModel.alias",arguments:["string"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"AnyType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["any"]},{name:"MetaModel.alias",arguments:["any"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"NumberType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["number"]},{name:"MetaModel.alias",arguments:["number"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"IntegerType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["integer"]},{name:"MetaModel.alias",arguments:["integer"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"NullType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["null"]},{name:"MetaModel.alias",arguments:["null"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"TimeOnlyType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["time-only"]},{name:"MetaModel.alias",arguments:["time-only"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateOnlyType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["date-only"]},{name:"MetaModel.alias",arguments:["date-only"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateTimeOnlyType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["datetime-only"]},{name:"MetaModel.alias",arguments:["datetime-only"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateTimeType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["datetime"]},{name:"MetaModel.alias",arguments:["datetime"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"FileType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["file"]},{name:"MetaModel.alias",arguments:["file"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"BooleanType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.nameAtRuntime",arguments:["boolean"]},{name:"MetaModel.alias",arguments:["boolean"]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"Reference",methods:[],typeParameters:["T"],typeParameterConstraint:[null],"implements":[],fields:[{name:"structuredValue",type:{typeName:"DataModel.TypeInstance",nameSpace:"DataModel",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns a structured object if the reference point to one."]}],valueConstraint:null,optional:!1},{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns name of referenced object"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"UriTemplate",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This type currently serves both for absolute and relative urls"]}],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"StatusCodeString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"RelativeUriString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This  type describes relative uri templates"]}],"extends":[{typeName:"UriTemplate",nameSpace:"",basicName:"UriTemplate",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"FullUriTemplateString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This  type describes absolute uri templates"]}],"extends":[{typeName:"UriTemplate",nameSpace:"",basicName:"UriTemplate",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"FixedUriString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This  type describes fixed uris"]}],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"ContentType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"MarkdownString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.innerType",arguments:["markdown"]},{name:"MetaModel.description",arguments:["[GitHub Flavored Markdown](https://help.github.com/articles/github-flavored-markdown/)"]}],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}},{name:"SchemaString",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Schema at this moment only two subtypes are supported (json schema and xsd)"]},{name:"MetaModel.alias",arguments:["schema"]}],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts"},{classes:[{name:"ExampleSpec",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"value",type:{typeName:"any",nameSpace:"",basicName:"any",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.example",arguments:[]},{name:"MetaModel.selfNode",arguments:[]},{name:"MetaModel.description",arguments:["String representation of example"]},{name:"MetaModel.required",arguments:[]},{name:"MetaModel.valueDescription",arguments:["* Valid value for this type<br>* String representing the serialized version of a valid value"]}],valueConstraint:null,optional:!1},{name:"structuredValue",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns object representation of example, if possible"]}],valueConstraint:null,optional:!1},{name:"strict",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["By default, examples are validated against any type declaration. Set this to false to allow examples that need not validate."]}],valueConstraint:null,optional:!1},{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.hide",arguments:[]},{name:"MetaModel.description",arguments:["Example identifier, if specified"]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the example"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.description",arguments:["A longer, human-friendly description of the example"]},{name:"MetaModel.valueDescription",arguments:["markdown string"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.possibleInterfaces",arguments:[["FragmentDeclaration"]]}],"extends":[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{annotations:[{name:"MetaModel.markdownDescription",arguments:['Annotations to be applied to this example. Annotations are any property whose key begins with "(" and ends with ")" and whose name (the part between the beginning and ending parentheses) is a declared annotation name.']}]}},{name:"TypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["name of the parameter"]},{name:"MetaModel.extraMetaKey",arguments:["headers"]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The displayName attribute specifies the type display name. It is a friendly name used only for  display or documentation purposes. If displayName is not specified, it defaults to the element's key (the name of the property itself)."]}],valueConstraint:null,optional:!1},{name:"facets",type:{base:{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.declaringFields",arguments:[]},{name:"MetaModel.description",arguments:["When extending from a type you can define new facets (which can then be set to concrete values by subtypes)."]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"fixedFacets",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns facets fixed by the type. Value is an object with properties named after facets fixed. Value of each property is a value of the corresponding facet."]}],valueConstraint:null,optional:!1},{name:"schema",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.typeExpression",arguments:[]},{name:"MetaModel.allowMultiple",arguments:[]},{name:"MetaModel.description",arguments:['Alias for the equivalent "type" property, for compatibility with RAML 0.8. Deprecated - API definitions should use the "type" property, as the "schema" alias for that property name may be removed in a future RAML version. The "type" property allows for XML and JSON schemas.']},{name:"MetaModel.valueDescription",arguments:["Single string denoting the base type or type expression"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.typeExpression",arguments:[]},{name:"MetaModel.allowMultiple",arguments:[]},{name:"MetaModel.canBeValue",arguments:[]},{name:"MetaModel.defaultValue",arguments:["string"]},{name:"MetaModel.descriminatingProperty",arguments:[]},{name:"MetaModel.description",arguments:["A base type which the current type extends, or more generally a type expression."]},{name:"MetaModel.valueDescription",arguments:["string denoting the base type or type expression"]}],valueConstraint:null,optional:!1},{name:"structuredType",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.typeExpression",arguments:[]},{name:"MetaModel.description",arguments:["Inlined supertype definition."]},{name:"MetaModel.valueDescription",arguments:["Inlined supertype definition"]}],valueConstraint:null,optional:!1},{name:"location",type:{typeName:"ModelLocation",nameSpace:"",basicName:"ModelLocation",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.system",arguments:[]},{name:"MetaModel.description",arguments:["Location of the parameter (can not be edited by user)"]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"locationKind",type:{typeName:"LocationKind",nameSpace:"",basicName:"LocationKind",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.system",arguments:[]},{name:"MetaModel.description",arguments:["Kind of location"]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"default",type:{typeName:"any",nameSpace:"",basicName:"any",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Provides default value for a property"]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"example",type:{typeName:"ExampleSpec",nameSpace:"",basicName:"ExampleSpec",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.example",arguments:[]},{name:"MetaModel.selfNode",arguments:[]},{name:"MetaModel.description",arguments:["An example of this type instance represented as string or yaml map/sequence. This can be used, e.g., by documentation generators to generate sample values for an object of this type. Cannot be present if the examples property is present."]},{name:"MetaModel.valueDescription",arguments:["* Valid value for this type<br>* String representing the serialized version of a valid value"]}],valueConstraint:null,optional:!1},{name:"examples",type:{base:{typeName:"ExampleSpec",nameSpace:"",basicName:"ExampleSpec",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.example",arguments:[]},{name:"MetaModel.selfNode",arguments:[]},{name:"MetaModel.description",arguments:["An example of this type instance represented as string. This can be used, e.g., by documentation generators to generate sample values for an object of this type. Cannot be present if the example property is present."]},{name:"MetaModel.valueDescription",arguments:["* Valid value for this type<br>* String representing the serialized version of a valid value"]}],valueConstraint:null,optional:!1},{name:"required",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.requireValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.description",arguments:["Sets if property is optional or not"]},{name:"MetaModel.describesAnnotation",arguments:["required"]},{name:"MetaModel.hide",arguments:[]},{name:"MetaModel.defaultBooleanValue",arguments:[!0]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.description",arguments:["A longer, human-friendly description of the type"]},{name:"MetaModel.valueDescription",arguments:["markdown string"]}],valueConstraint:null,optional:!1},{name:"xml",type:{typeName:"XMLFacetInfo",nameSpace:"",basicName:"XMLFacetInfo",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[],valueConstraint:null,optional:!1},{name:"allowedTargets",type:{base:{typeName:"AnnotationTarget",nameSpace:"",basicName:"AnnotationTarget",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.oneOf",arguments:[["API","DocumentationItem","Resource","Method","Response","RequestBody","ResponseBody","TypeDeclaration","NamedExample","ResourceType","Trait","SecurityScheme","SecuritySchemeSettings","AnnotationTypeDeclaration","Library","Overlay","Extension","Scalar"]]},{name:"MetaModel.description",arguments:["Restrictions on where annotations of this type can be applied. If this property is specified, annotations of this type may only be applied on a property corresponding to one of the target names specified as the value of this property."]},{name:"MetaModel.valueDescription",arguments:["An array, or single, of names allowed target nodes."]}],valueConstraint:null,optional:!1},{name:"isAnnotation",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Whether the type represents annotation"]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["For types defined in traits or resource types returns object representation of parametrized properties"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.convertsToGlobalOfType",arguments:["SchemaString"]},{name:"MetaModel.canInherit",arguments:["mediaType"]},{name:"MetaModel.possibleInterfaces",arguments:[["FragmentDeclaration"]]}],"extends":[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{annotations:[{name:"MetaModel.markdownDescription",arguments:['Annotations to be applied to this type. Annotations are any property whose key begins with "(" and ends with ")" and whose name (the part between the beginning and ending parentheses) is a declared annotation name.']}]}},{name:"XMLFacetInfo",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"attribute",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["If attribute is set to true, a type instance should be serialized as an XML attribute. It can only be true for scalar types."]}],valueConstraint:null,optional:!1},{name:"wrapped",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["If wrapped is set to true, a type instance should be wrapped in its own XML element. It can not be true for scalar types and it can not be true at the same moment when attribute is true."]}],valueConstraint:null,optional:!1},{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Allows to override the name of the XML element or XML attribute in it's XML representation."]}],valueConstraint:null,optional:!1},{name:"namespace",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Allows to configure the name of the XML namespace."]}],valueConstraint:null,optional:!1},{name:"prefix",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Allows to configure the prefix which will be used during serialization to XML."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"ArrayTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"array"},optional:!1},{name:"uniqueItems",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["uniqueItems"]},{name:"MetaModel.description",arguments:["Should items in array be unique"]}],valueConstraint:null,optional:!1},{name:"items",type:{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.description",arguments:["Array component type."]},{name:"MetaModel.valueDescription",arguments:["Inline type declaration or type name."]}],valueConstraint:null,optional:!1},{name:"minItems",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["minItems"]},{name:"MetaModel.description",arguments:["Minimum amount of items in array"]},{name:"MetaModel.valueDescription",arguments:["integer ( >= 0 ). Defaults to 0"]}],valueConstraint:null,optional:!1},{name:"maxItems",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["maxItems"]},{name:"MetaModel.description",arguments:["Maximum amount of items in array"]},{name:"MetaModel.valueDescription",arguments:["integer ( >= 0 ). Defaults to undefined."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.convertsToGlobalOfType",arguments:["SchemaString"]},{name:"MetaModel.alias",arguments:["array"]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],"extends":[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"UnionTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"union"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.convertsToGlobalOfType",arguments:["SchemaString"]},{name:"MetaModel.requireValue",arguments:["locationKind","LocationKind.MODELS"]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],"extends":[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"ObjectTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[{name:"MetaModel.hide",arguments:[]}],valueConstraint:{isCallConstraint:!1,value:"object"},optional:!1},{name:"properties",type:{base:{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.description",arguments:["The properties that instances of this type may or must have."]},{name:"MetaModel.valueDescription",arguments:["An object whose keys are the properties' names and whose values are property declarations."]}],valueConstraint:null,optional:!1},{name:"minProperties",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["minProperties"]},{name:"MetaModel.description",arguments:["The minimum number of properties allowed for instances of this type."]}],valueConstraint:null,optional:!1},{name:"maxProperties",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["maxProperties"]},{name:"MetaModel.description",arguments:["The maximum number of properties allowed for instances of this type."]}],valueConstraint:null,optional:!1},{name:"additionalProperties",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["A Boolean that indicates if an object instance has additional properties."]}],valueConstraint:null,optional:!1},{name:"discriminator",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Type property name to be used as discriminator, or boolean"]
}],valueConstraint:null,optional:!1},{name:"discriminatorValue",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The value of discriminator for the type."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.definingPropertyIsEnough",arguments:["properties"]},{name:"MetaModel.setsContextValue",arguments:["field","true"]},{name:"MetaModel.convertsToGlobalOfType",arguments:["SchemaString"]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],"extends":[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"StringTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"string"},optional:!1},{name:"pattern",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["pattern"]},{name:"MetaModel.description",arguments:["Regular expression that this string should path"]},{name:"MetaModel.valueDescription",arguments:["regexp"]}],valueConstraint:null,optional:!1},{name:"minLength",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["minLength"]},{name:"MetaModel.description",arguments:["Minimum length of the string"]}],valueConstraint:null,optional:!1},{name:"maxLength",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["maxLength"]},{name:"MetaModel.description",arguments:["Maximum length of the string"]}],valueConstraint:null,optional:!1},{name:"enum",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.facetId",arguments:["enum"]},{name:"MetaModel.describesAnnotation",arguments:["oneOf"]},{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type string) The enum attribute provides an enumeration of the parameter's valid values. This MUST be an array. If the enum attribute is defined, API clients and servers MUST verify that a parameter's value matches a value in the enum array. If there is no matching value, the clients and servers MUST treat this as an error."]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value must be a string"]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],"extends":[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"BooleanTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"boolean"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value must be a boolean"]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],"extends":[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"NumberTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"number"},optional:!1},{name:"minimum",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["minimum"]},{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type number or integer) The minimum attribute specifies the parameter's minimum value."]}],valueConstraint:null,optional:!1},{name:"maximum",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.facetId",arguments:["maximum"]},{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type number or integer) The maximum attribute specifies the parameter's maximum value."]}],valueConstraint:null,optional:!1},{name:"enum",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.facetId",arguments:["enum"]},{name:"MetaModel.describesAnnotation",arguments:["oneOf"]},{name:"MetaModel.description",arguments:["(Optional, applicable only for parameters of type string) The enum attribute provides an enumeration of the parameter's valid values. This MUST be an array. If the enum attribute is defined, API clients and servers MUST verify that a parameter's value matches a value in the enum array. If there is no matching value, the clients and servers MUST treat this as an error."]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"format",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.oneOf",arguments:[["int32","int64","int","long","float","double","int16","int8"]]},{name:"MetaModel.description",arguments:["Value format"]}],valueConstraint:null,optional:!1},{name:"multipleOf",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:['A numeric instance is valid against "multipleOf" if the result of the division of the instance by this keyword\'s value is an integer.']}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value MUST be a number. Indicate floating point numbers as defined by YAML."]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],"extends":[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"IntegerTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"integer"},optional:!1},{name:"format",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.oneOf",arguments:[["int32","int64","int","long","int16","int8"]]},{name:"MetaModel.description",arguments:["Value format"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Value MUST be a integer."]},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],"extends":[{typeName:"NumberTypeDeclaration",nameSpace:"",basicName:"NumberTypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateOnlyTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"date-only"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:['the "full-date" notation of RFC3339, namely yyyy-mm-dd (no implications about time or timezone-offset)']},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],"extends":[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"TimeOnlyTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"time-only"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:['the "partial-time" notation of RFC3339, namely hh:mm:ss[.ff...] (no implications about date or timezone-offset)']},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],"extends":[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateTimeOnlyTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"datetime-only"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:['combined date-only and time-only with a separator of "T", namely yyyy-mm-ddThh:mm:ss[.ff...] (no implications about timezone-offset)']},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],"extends":[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"DateTimeTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"datetime"},optional:!1},{name:"format",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.oneOf",arguments:[["rfc3339","rfc2616"]]},{name:"MetaModel.description",arguments:["Format used for this date time rfc3339 or rfc2616"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:['a timestamp, either in the "date-time" notation of RFC3339, if format is omitted or is set to rfc3339, or in the format defined in RFC2616, if format is set to rfc2616.']},{name:"MetaModel.declaresSubTypeOf",arguments:["TypeDeclaration"]}],"extends":[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"}],moduleName:null,annotationOverridings:{}},{name:"TypeInstance",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"properties",type:{base:{typeName:"TypeInstanceProperty",nameSpace:"",basicName:"TypeInstanceProperty",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Array of instance properties"]}],valueConstraint:null,optional:!1},{name:"isScalar",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Whether the type is scalar"]}],valueConstraint:null,optional:!1},{name:"value",type:{typeName:"any",nameSpace:"",basicName:"any",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["For instances of scalar types returns scalar value"]}],valueConstraint:null,optional:!1},{name:"isArray",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Indicates whether the instance is array"]}],valueConstraint:null,optional:!1},{name:"items",type:{base:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Returns components of array instances"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.customHandling",arguments:[]}],"extends":[],moduleName:null,annotationOverridings:{}},{name:"TypeInstanceProperty",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Property name"]}],valueConstraint:null,optional:!1},{name:"value",type:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},annotations:[{name:"MetaModel.description",arguments:["Property value"]}],valueConstraint:null,optional:!1},{name:"values",type:{base:{typeName:"TypeInstance",nameSpace:"",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Array of values if property value is array"]}],valueConstraint:null,optional:!1},{name:"isArray",type:{typeName:"boolean",nameSpace:"",basicName:"boolean",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Whether property has array as value"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.customHandling",arguments:[]}],"extends":[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[{name:"ModelLocation",members:["QUERY","HEADERS","URI","FORM","BURI","ANNOTATION","MODEL","SECURITYSCHEMATYPE"]},{name:"LocationKind",members:["APISTRUCTURE","DECLARATIONS","MODELS"]}],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts",Declarations:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},{classes:[{name:"MimeType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["This sub type of the string represents mime types"]}],"extends":[{typeName:"StringType",nameSpace:"",basicName:"StringType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"}],moduleName:null,annotationOverridings:{}},{name:"Response",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"code",type:{typeName:"Sys.StatusCodeString",nameSpace:"Sys",basicName:"StatusCodeString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.extraMetaKey",arguments:["statusCodes"]},{name:"MetaModel.description",arguments:["Responses MUST be a map of one or more HTTP status codes, where each status code itself is a map that describes that status code."]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"headers",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","DataModel.ModelLocation.HEADERS"]},{name:"MetaModel.setsContextValue",arguments:["locationKind","DataModel.LocationKind.APISTRUCTURE"]},{name:"MetaModel.newInstanceName",arguments:["New Header"]},{name:"MetaModel.description",arguments:["Detailed information about any response headers returned by this method"]},{name:"MetaModel.valueDescription",arguments:["Object whose property names are the response header names and whose values describe the values."]}],valueConstraint:null,optional:!1},{name:"body",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Body"]},{name:"MetaModel.description",arguments:["The body of the response: a body declaration"]},{name:"MetaModel.valueDescription",arguments:["Object whose properties are either<br>* Media types and whose values are type objects describing the request body for that media type, or<br>* a type object describing the request body for the default media type specified in the root mediaType property."]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"},annotations:[{name:"MetaModel.description",arguments:["A longer, human-friendly description of the response"]},{name:"MetaModel.valueDescription",arguments:["Markdown string"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"}],moduleName:null,annotationOverridings:{displayName:[{name:"MetaModel.description",arguments:["An alternate, human-friendly name for the response"]}],annotations:[{name:"MetaModel.markdownDescription",arguments:['Annotations to be applied to this response. Annotations are any property whose key begins with "(" and ends with ")" and whose name (the part between the beginning and ending parentheses) is a declared annotation name.']}]}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts"},{classes:[{name:"Annotable",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"annotations",type:{base:{typeName:"Decls.AnnotationRef",nameSpace:"Decls",basicName:"AnnotationRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts"},typeKind:1},annotations:[{name:"MetaModel.noDirectParse",arguments:[]},{name:"MetaModel.setsContextValue",arguments:["locationKind","datamodel.LocationKind.APISTRUCTURE"]},{name:"MetaModel.setsContextValue",arguments:["location","datamodel.ModelLocation.ANNOTATION"]},{name:"MetaModel.description",arguments:["Most of RAML model elements may have attached annotations decribing additional meta data about this element"]},{name:"MetaModel.documentationTableLabel",arguments:["(&lt;annotationName&gt;)"]},{name:"MetaModel.valueDescription",arguments:["A value corresponding to the declared type of this annotation."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",Decls:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts"},{classes:[{name:"AnnotationRef",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"annotation",type:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns referenced annotation"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Annotations allow you to attach information to your API"]},{name:"MetaModel.tags",arguments:[["annotations"]]}],"extends":[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"}],moduleName:null,annotationOverridings:{}},{name:"AnnotationTarget",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Elements to which this Annotation can be applied (enum)"]},{name:"MetaModel.tags",arguments:[["annotations"]]}],"extends":[{typeName:"ValueType",nameSpace:"",basicName:"ValueType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts",Common:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/common.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/declarations.ts"},{classes:[{name:"TraitRef",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"trait",type:{typeName:"Trait",nameSpace:"",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns referenced trait"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"Trait",nameSpace:"",basicName:"Trait",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"}],moduleName:null,annotationOverridings:{}},{name:"Trait",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Name of the trait"]}],valueConstraint:null,optional:!1},{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Instructions on how and when the trait should be used."]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"DataModel.TypeInstance",nameSpace:"DataModel",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns object representation of parametrized properties of the trait"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.inlinedTemplates",arguments:[]},{name:"MetaModel.allowQuestion",arguments:[]},{name:"MetaModel.possibleInterfaces",arguments:[["FragmentDeclaration"]]}],"extends":[{typeName:"MethodBase",nameSpace:"",basicName:"MethodBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"}],moduleName:null,annotationOverridings:{displayName:[{name:"MetaModel.description",arguments:["The displayName attribute specifies the trait display name. It is a friendly name used only for  display or documentation purposes. If displayName is not specified, it defaults to the element's key (the name of the property itself)."]}]}},{name:"MethodBase",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"body",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Body"]},{name:"MetaModel.description",arguments:["Some method verbs expect the resource to be sent as a request body. For example, to create a resource, the request must include the details of the resource to create. Resources CAN have alternate representations. For example, an API might support both JSON and XML representations. A method's body is defined in the body property as a hashmap, in which the key MUST be a valid media type."]}],valueConstraint:null,optional:!1},{name:"protocols",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.oneOf",arguments:[["HTTP","HTTPS"]]},{name:"MetaModel.description",arguments:["A method can override the protocols specified in the resource or at the API root, by employing this property."]},{name:"MetaModel.valueDescription",arguments:["array of strings of value HTTP or HTTPS, or a single string of such kind, case-insensitive"]}],valueConstraint:null,optional:!1},{name:"is",type:{base:{typeName:"TraitRef",nameSpace:"",basicName:"TraitRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Instantiation of applyed traits"]}],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"Security.SecuritySchemeRef",nameSpace:"Security",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.allowNull",arguments:[]},{name:"MetaModel.description",arguments:["securityScheme may also be applied to a resource by using the securedBy key, which is equivalent to applying the securityScheme to all methods that may be declared, explicitly or implicitly, by defining the resourceTypes or traits property for that resource. To indicate that the method may be called without applying any securityScheme, the method may be annotated with the null securityScheme."]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},annotations:[],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Operation",nameSpace:"",basicName:"Operation",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"}],moduleName:null,annotationOverridings:{}},{name:"Method",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"method",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.extraMetaKey",arguments:["methods"]},{name:"MetaModel.oneOf",arguments:[["get","put","post","delete","options","head","patch"]]},{name:"MetaModel.description",arguments:["Method that can be called"]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"DataModel.TypeInstance",nameSpace:"DataModel",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["For types defined in resource types returns object representation of parametrized properties"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"MethodBase",nameSpace:"",basicName:"MethodBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"}],moduleName:null,annotationOverridings:{displayName:[{name:"MetaModel.description",arguments:["The displayName attribute specifies the method display name. It is a friendly name used only for  display or documentation purposes. If displayName is not specified, it defaults to the element's key (the name of the property itself)."]}]}},{name:"Operation",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"queryParameters",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","DataModel.ModelLocation.QUERY"]},{name:"MetaModel.setsContextValue",arguments:["locationKind","DataModel.LocationKind.APISTRUCTURE"]},{name:"MetaModel.newInstanceName",arguments:["New query parameter"]},{name:"MetaModel.description",
arguments:["An APIs resources MAY be filtered (to return a subset of results) or altered (such as transforming  a response body from JSON to XML format) by the use of query strings. If the resource or its method supports a query string, the query string MUST be defined by the queryParameters property"]}],valueConstraint:null,optional:!1},{name:"headers",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.setsContextValue",arguments:["location","DataModel.ModelLocation.HEADERS"]},{name:"MetaModel.setsContextValue",arguments:["locationKind","DataModel.LocationKind.APISTRUCTURE"]},{name:"MetaModel.description",arguments:["Headers that allowed at this position"]},{name:"MetaModel.newInstanceName",arguments:["New Header"]}],valueConstraint:null,optional:!1},{name:"queryString",type:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},annotations:[{name:"MetaModel.description",arguments:["Specifies the query string needed by this method. Mutually exclusive with queryParameters."]}],valueConstraint:null,optional:!1},{name:"responses",type:{base:{typeName:"Bodies.Response",nameSpace:"Bodies",basicName:"Response",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["response","true"]},{name:"MetaModel.newInstanceName",arguments:["New Response"]},{name:"MetaModel.description",arguments:["Information about the expected responses to a request"]},{name:"MetaModel.valueDescription",arguments:["An object whose keys are the HTTP status codes of the responses and whose values describe the responses."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",Bodies:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/bodies.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts",Security:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},{classes:[{name:"SecuritySchemePart",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[],"extends":[{typeName:"Operation",nameSpace:"",basicName:"Operation",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{annotations:[{name:"MetaModel.description",arguments:['Annotations to be applied to this security scheme part. Annotations are any property whose key begins with "(" and ends with ")" and whose name (the part between the beginning and ending parentheses) is a declared annotation name.']}]}},{name:"SecuritySchemeSettings",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]}],"extends":[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth1SecuritySchemeSettings",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"requestTokenUri",type:{typeName:"Sys.FixedUriString",nameSpace:"Sys",basicName:"FixedUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Temporary Credential Request endpoint as defined in RFC5849 Section 2.1"]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"authorizationUri",type:{typeName:"Sys.FixedUriString",nameSpace:"Sys",basicName:"FixedUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Resource Owner Authorization endpoint as defined in RFC5849 Section 2.2"]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"tokenCredentialsUri",type:{typeName:"Sys.FixedUriString",nameSpace:"Sys",basicName:"FixedUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Token Request endpoint as defined in RFC5849 Section 2.3"]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"signatures",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.oneOf",arguments:[["HMAC-SHA1","RSA-SHA1","PLAINTEXT"]]},{name:"MetaModel.hide",arguments:[]},{name:"MetaModel.description",arguments:["List of the signature methods used by the server. Available methods: HMAC-SHA1, RSA-SHA1, PLAINTEXT"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]},{name:"MetaModel.functionalDescriminator",arguments:["$parent.type=='OAuth 1.0'"]}],"extends":[{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth2SecuritySchemeSettings",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"accessTokenUri",type:{typeName:"Sys.FixedUriString",nameSpace:"Sys",basicName:"FixedUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.description",arguments:["The URI of the Token Endpoint as defined in RFC6749 Section 3.2. Not required forby implicit grant type."]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"authorizationUri",type:{typeName:"Sys.FixedUriString",nameSpace:"Sys",basicName:"FixedUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.description",arguments:["The URI of the Authorization Endpoint as defined in RFC6749 Section 3.1. Required forby authorization_code and implicit grant types."]},{name:"MetaModel.valueDescription",arguments:["FixedUriString"]}],valueConstraint:null,optional:!1},{name:"authorizationGrants",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.oftenKeys",arguments:[["authorization_code","password","client_credentials","implicit"]]},{name:"MetaModel.description",arguments:["A list of the Authorization grants supported by the API as defined in RFC6749 Sections 4.1, 4.2, 4.3 and 4.4, can be any of: authorization_code, password, client_credentials, implicit, or any absolute url."]},{name:"MetaModel.markdownDescription",arguments:["A list of the Authorization grants supported by the API as defined in RFC6749 Sections 4.1, 4.2, 4.3 and 4.4, can be any of:<br>* authorization_code<br>* password<br>* client_credentials<br>* implicit <br>*  or any absolute url."]}],valueConstraint:null,optional:!1},{name:"scopes",type:{base:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["A list of scopes supported by the security scheme as defined in RFC6749 Section 3.3"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.allowAny",arguments:[]}],"extends":[{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"SecuritySchemeRef",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"securitySchemeName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns the name of security scheme, this reference refers to."]}],valueConstraint:null,optional:!1},{name:"securityScheme",type:{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns AST node of security scheme, this reference refers to, or null."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"AbstractSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.startFrom",arguments:[""]},{name:"MetaModel.hide",arguments:[]},{name:"MetaModel.description",arguments:["Name of the security scheme"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.required",arguments:[]},{name:"MetaModel.oneOf",arguments:[["OAuth 1.0","OAuth 2.0","Basic Authentication","Digest Authentication","Pass Through","x-{other}"]]},{name:"MetaModel.descriminatingProperty",arguments:[]},{name:"MetaModel.description",arguments:["The securitySchemes property MUST be used to specify an API's security mechanisms, including the required settings and the authentication methods that the API supports. one authentication method is allowed if the API supports them."]},{name:"MetaModel.valueDescription",arguments:["string<br><br>The value MUST be one of<br>* OAuth 1.0,<br>* OAuth 2.0,<br>* BasicSecurityScheme Authentication<br>* DigestSecurityScheme Authentication<br>* Pass Through<br>* x-&lt;other&gt;"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.description",arguments:["The description attribute MAY be used to describe a security schemes property."]},{name:"MetaModel.description",arguments:["The description MAY be used to describe a securityScheme."]}],valueConstraint:null,optional:!1},{name:"describedBy",type:{typeName:"SecuritySchemePart",nameSpace:"",basicName:"SecuritySchemePart",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.description",arguments:["A description of the request components related to Security that are determined by the scheme: the headers, query parameters or responses. As a best practice, even for standard security schemes, API designers SHOULD describe these properties of security schemes. Including the security scheme description completes an API documentation."]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The displayName attribute specifies the security scheme display name. It is a friendly name used only for  display or documentation purposes. If displayName is not specified, it defaults to the element's key (the name of the property itself)."]}],valueConstraint:null,optional:!1},{name:"settings",type:{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[{name:"MetaModel.description",arguments:["The settings attribute MAY be used to provide security scheme-specific information. The required attributes vary depending on the type of security scheme is being declared. It describes the minimum set of properties which any processing application MUST provide and validate if it chooses to implement the security scheme. Processing applications MAY choose to recognize other properties for things such as token lifetime, preferred cryptographic algorithms, and more."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth2SecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"OAuth 2.0"},optional:!1},{name:"settings",type:{typeName:"OAuth2SecuritySchemeSettings",nameSpace:"",basicName:"OAuth2SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"OAuth1SecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"OAuth 1.0"},optional:!1},{name:"settings",type:{typeName:"OAuth1SecuritySchemeSettings",nameSpace:"",basicName:"OAuth1SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"PassThroughSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"Pass Through"},optional:!1},{name:"settings",type:{typeName:"SecuritySchemeSettings",nameSpace:"",basicName:"SecuritySchemeSettings",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},annotations:[],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"BasicSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"Basic Authentication"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"DigestSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"Digest Authentication"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}},{name:"CustomSecurityScheme",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"x-{other}"},optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["Declares globally referable security scheme definition"]},{name:"MetaModel.actuallyExports",arguments:["$self"]},{name:"MetaModel.referenceIs",arguments:["settings"]}],"extends":[{typeName:"AbstractSecurityScheme",nameSpace:"",basicName:"AbstractSecurityScheme",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",Methods:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts"},{classes:[{name:"ResourceTypeRef",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"resourceType",type:{typeName:"ResourceType",nameSpace:"",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns referenced resource type"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Reference",nameSpace:"",basicName:"Reference",typeKind:0,typeArguments:[{typeName:"ResourceType",nameSpace:"",basicName:"ResourceType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"}],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"}],moduleName:null,annotationOverridings:{}},{name:"ResourceType",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The displayName attribute specifies the resource type display name. It is a friendly name used only for  display or documentation purposes. If displayName is not specified, it defaults to the element's key (the name of the property itself)."]}],valueConstraint:null,optional:!1},{name:"name",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.description",arguments:["Name of the resource type"]}],valueConstraint:null,optional:!1},{name:"usage",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["Instructions on how and when the resource type should be used."]}],valueConstraint:null,optional:!1},{name:"parametrizedProperties",type:{typeName:"DataModel.TypeInstance",nameSpace:"DataModel",basicName:"TypeInstance",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},annotations:[{name:"MetaModel.customHandling",arguments:[]},{name:"MetaModel.description",arguments:["Returns object representation of parametrized properties of the resource type"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.inlinedTemplates",arguments:[]},{name:"MetaModel.allowQuestion",arguments:[]},{name:"MetaModel.possibleInterfaces",arguments:[["FragmentDeclaration"]]}],"extends":[{typeName:"ResourceBase",nameSpace:"",basicName:"ResourceBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"}],moduleName:null,annotationOverridings:{}},{name:"ResourceBase",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"methods",type:{base:{typeName:"Methods.Method",nameSpace:"Methods",basicName:"Method",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["Methods that are part of this resource type definition"]},{name:"MetaModel.markdownDescription",arguments:["The methods available on this resource."]},{name:"MetaModel.documentationTableLabel",arguments:["get?<br>patch?<br>put?<br>post?<br>delete?<br>options?<br>head?"]},{name:"MetaModel.valueDescription",arguments:["Object describing the method"]}],valueConstraint:null,optional:!1},{name:"is",type:{base:{typeName:"Methods.TraitRef",nameSpace:"Methods",basicName:"TraitRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["A list of the traits to apply to all methods declared (implicitly or explicitly) for this resource. Individual methods may override this declaration"]},{name:"MetaModel.valueDescription",arguments:["array, which can contain each of the following elements:<br>* name of unparametrized trait <br>* a key-value pair with trait name as key and a map of trait parameters as value<br>* inline trait declaration <br><br>(or a single element of any above kind)"]}],valueConstraint:null,optional:!1},{name:"type",type:{typeName:"ResourceTypeRef",nameSpace:"",basicName:"ResourceTypeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},annotations:[{name:"MetaModel.description",arguments:["The resource type which this resource inherits."]},{name:"MetaModel.valueDescription",arguments:["one of the following elements:<br>* name of unparametrized resource type<br>* a key-value pair with resource type name as key and a map of its parameters as value<br>* inline resource type declaration"]}],valueConstraint:null,optional:!1},{name:"description",type:{typeName:"Sys.MarkdownString",nameSpace:"Sys",basicName:"MarkdownString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},annotations:[],valueConstraint:null,optional:!1},{name:"securedBy",type:{base:{typeName:"Security.SecuritySchemeRef",nameSpace:"Security",basicName:"SecuritySchemeRef",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.allowNull",arguments:[]},{name:"MetaModel.description",arguments:["The security schemes that apply to all methods declared (implicitly or explicitly) for this resource."]},{name:"MetaModel.valueDescription",arguments:["array of security scheme names or a single security scheme name"]}],valueConstraint:null,optional:!1},{name:"uriParameters",type:{base:{typeName:"DataModel.TypeDeclaration",nameSpace:"DataModel",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.setsContextValue",arguments:["location","DataModel.ModelLocation.URI"]},{name:"MetaModel.setsContextValue",arguments:["locationKind","DataModel.LocationKind.APISTRUCTURE"]},{name:"MetaModel.setsContextValue",arguments:["fieldOrParam",!0]},{name:"MetaModel.description",arguments:["Detailed information about any URI parameters of this resource"]},{name:"MetaModel.valueDescription",arguments:["object whose property names are the URI parameter names and whose values describe the values"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"Annotable",nameSpace:"",basicName:"Annotable",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"}],moduleName:null,annotationOverridings:{}},{name:"Resource",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"relativeUri",type:{typeName:"Sys.RelativeUriString",nameSpace:"Sys",basicName:"RelativeUriString",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},annotations:[{name:"MetaModel.key",arguments:[]},{name:"MetaModel.startFrom",arguments:["/"]},{name:"MetaModel.description",arguments:["Relative URL of this resource from the parent resource"]},{name:"MetaModel.hide",arguments:[]}],valueConstraint:null,optional:!1},{name:"displayName",type:{typeName:"string",nameSpace:"",basicName:"string",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The displayName attribute specifies the resource display name. It is a friendly name used only for  display or documentation purposes. If displayName is not specified, it defaults to the element's key (the name of the property itself)."]}],valueConstraint:null,optional:!1},{name:"resources",type:{base:{typeName:"Resource",nameSpace:"",basicName:"Resource",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},typeKind:1},annotations:[{name:"MetaModel.newInstanceName",arguments:["New Resource"]},{name:"MetaModel.description",arguments:['A nested resource is identified as any property whose name begins with a slash ("/") and is therefore treated as a relative URI.']},{name:"MetaModel.documentationTableLabel",arguments:["/&lt;relativeUri&gt;"]},{name:"MetaModel.valueDescription",arguments:["object describing the nested resource"]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[],"extends":[{typeName:"ResourceBase",nameSpace:"",basicName:"ResourceBase",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"}],moduleName:null,annotationOverridings:{description:[{name:"MetaModel.description",arguments:["A longer, human-friendly description of the resource."]},{name:"MetaModel.valueDescription",arguments:["Markdown string"]}],annotations:[{name:"MetaModel.markdownDescription",arguments:['Annotations to be applied to this resource. Annotations are any property whose key begins with "(" and ends with ")" and whose name (the part between the beginning and ending parentheses) is a declared annotation name.']}]}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts",Security:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/security.ts",Methods:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/methods.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/resources.ts"},{classes:[{name:"FileTypeDeclaration",methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[{name:"type",type:null,annotations:[],valueConstraint:{isCallConstraint:!1,value:"file"},optional:!1},{name:"fileTypes",type:{base:{typeName:"Sys.ContentType",nameSpace:"Sys",basicName:"ContentType",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/parameters.ts"
},typeKind:1},annotations:[{name:"MetaModel.description",arguments:["It should also include a new property: fileTypes, which should be a list of valid content-type strings for the file. The file type */* should be a valid value."]}],valueConstraint:null,optional:!1},{name:"minLength",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The minLength attribute specifies the parameter value's minimum number of bytes."]}],valueConstraint:null,optional:!1},{name:"maxLength",type:{typeName:"number",nameSpace:"",basicName:"number",typeKind:0,typeArguments:[],modulePath:null},annotations:[{name:"MetaModel.description",arguments:["The maxLength attribute specifies the parameter value's maximum number of bytes."]}],valueConstraint:null,optional:!1}],isInterface:!1,annotations:[{name:"MetaModel.description",arguments:["(Applicable only to Form properties) Value is a file. Client generators SHOULD use this type to handle file uploads correctly."]}],"extends":[{typeName:"TypeDeclaration",nameSpace:"",basicName:"TypeDeclaration",typeKind:0,typeArguments:[],modulePath:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/parameters.ts"}],moduleName:null,annotationOverridings:{}}],aliases:[],enumDeclarations:[],imports:{MetaModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/metamodel.ts",Sys:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/systemTypes.ts",DataModel:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/datamodel.ts"},name:"/Users/munch/work/repositories_official/raml-definition-system/raml-definition/spec-1.0/parameters.ts"}]},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;(function(){function createReduce(dir){function iterator(obj,iteratee,memo,keys,index,length){for(;index>=0&&length>index;index+=dir){var currentKey=keys?keys[index]:index;memo=iteratee(memo,obj[currentKey],currentKey,obj)}return memo}return function(obj,iteratee,memo,context){iteratee=optimizeCb(iteratee,context,4);var keys=!isArrayLike(obj)&&_.keys(obj),length=(keys||obj).length,index=dir>0?0:length-1;return arguments.length<3&&(memo=obj[keys?keys[index]:index],index+=dir),iterator(obj,iteratee,memo,keys,index,length)}}function createPredicateIndexFinder(dir){return function(array,predicate,context){predicate=cb(predicate,context);for(var length=getLength(array),index=dir>0?0:length-1;index>=0&&length>index;index+=dir)if(predicate(array[index],index,array))return index;return-1}}function createIndexFinder(dir,predicateFind,sortedIndex){return function(array,item,idx){var i=0,length=getLength(array);if("number"==typeof idx)dir>0?i=idx>=0?idx:Math.max(idx+length,i):length=idx>=0?Math.min(idx+1,length):idx+length+1;else if(sortedIndex&&idx&&length)return idx=sortedIndex(array,item),array[idx]===item?idx:-1;if(item!==item)return idx=predicateFind(slice.call(array,i,length),_.isNaN),idx>=0?idx+i:-1;for(idx=dir>0?i:length-1;idx>=0&&length>idx;idx+=dir)if(array[idx]===item)return idx;return-1}}function collectNonEnumProps(obj,keys){var nonEnumIdx=nonEnumerableProps.length,constructor=obj.constructor,proto=_.isFunction(constructor)&&constructor.prototype||ObjProto,prop="constructor";for(_.has(obj,prop)&&!_.contains(keys,prop)&&keys.push(prop);nonEnumIdx--;)prop=nonEnumerableProps[nonEnumIdx],prop in obj&&obj[prop]!==proto[prop]&&!_.contains(keys,prop)&&keys.push(prop)}var root=this,previousUnderscore=root._,ArrayProto=Array.prototype,ObjProto=Object.prototype,FuncProto=Function.prototype,push=ArrayProto.push,slice=ArrayProto.slice,toString=ObjProto.toString,hasOwnProperty=ObjProto.hasOwnProperty,nativeIsArray=Array.isArray,nativeKeys=Object.keys,nativeBind=FuncProto.bind,nativeCreate=Object.create,Ctor=function(){},_=function(obj){return obj instanceof _?obj:this instanceof _?void(this._wrapped=obj):new _(obj)};"undefined"!=typeof module&&module.exports&&(exports=module.exports=_),exports._=_,_.VERSION="1.8.3";var optimizeCb=function(func,context,argCount){if(void 0===context)return func;switch(null==argCount?3:argCount){case 1:return function(value){return func.call(context,value)};case 2:return function(value,other){return func.call(context,value,other)};case 3:return function(value,index,collection){return func.call(context,value,index,collection)};case 4:return function(accumulator,value,index,collection){return func.call(context,accumulator,value,index,collection)}}return function(){return func.apply(context,arguments)}},cb=function(value,context,argCount){return null==value?_.identity:_.isFunction(value)?optimizeCb(value,context,argCount):_.isObject(value)?_.matcher(value):_.property(value)};_.iteratee=function(value,context){return cb(value,context,1/0)};var createAssigner=function(keysFunc,undefinedOnly){return function(obj){var length=arguments.length;if(2>length||null==obj)return obj;for(var index=1;length>index;index++)for(var source=arguments[index],keys=keysFunc(source),l=keys.length,i=0;l>i;i++){var key=keys[i];undefinedOnly&&void 0!==obj[key]||(obj[key]=source[key])}return obj}},baseCreate=function(prototype){if(!_.isObject(prototype))return{};if(nativeCreate)return nativeCreate(prototype);Ctor.prototype=prototype;var result=new Ctor;return Ctor.prototype=null,result},property=function(key){return function(obj){return null==obj?void 0:obj[key]}},MAX_ARRAY_INDEX=Math.pow(2,53)-1,getLength=property("length"),isArrayLike=function(collection){var length=getLength(collection);return"number"==typeof length&&length>=0&&MAX_ARRAY_INDEX>=length};_.each=_.forEach=function(obj,iteratee,context){iteratee=optimizeCb(iteratee,context);var i,length;if(isArrayLike(obj))for(i=0,length=obj.length;length>i;i++)iteratee(obj[i],i,obj);else{var keys=_.keys(obj);for(i=0,length=keys.length;length>i;i++)iteratee(obj[keys[i]],keys[i],obj)}return obj},_.map=_.collect=function(obj,iteratee,context){iteratee=cb(iteratee,context);for(var keys=!isArrayLike(obj)&&_.keys(obj),length=(keys||obj).length,results=Array(length),index=0;length>index;index++){var currentKey=keys?keys[index]:index;results[index]=iteratee(obj[currentKey],currentKey,obj)}return results},_.reduce=_.foldl=_.inject=createReduce(1),_.reduceRight=_.foldr=createReduce(-1),_.find=_.detect=function(obj,predicate,context){var key;return key=isArrayLike(obj)?_.findIndex(obj,predicate,context):_.findKey(obj,predicate,context),void 0!==key&&-1!==key?obj[key]:void 0},_.filter=_.select=function(obj,predicate,context){var results=[];return predicate=cb(predicate,context),_.each(obj,function(value,index,list){predicate(value,index,list)&&results.push(value)}),results},_.reject=function(obj,predicate,context){return _.filter(obj,_.negate(cb(predicate)),context)},_.every=_.all=function(obj,predicate,context){predicate=cb(predicate,context);for(var keys=!isArrayLike(obj)&&_.keys(obj),length=(keys||obj).length,index=0;length>index;index++){var currentKey=keys?keys[index]:index;if(!predicate(obj[currentKey],currentKey,obj))return!1}return!0},_.some=_.any=function(obj,predicate,context){predicate=cb(predicate,context);for(var keys=!isArrayLike(obj)&&_.keys(obj),length=(keys||obj).length,index=0;length>index;index++){var currentKey=keys?keys[index]:index;if(predicate(obj[currentKey],currentKey,obj))return!0}return!1},_.contains=_.includes=_.include=function(obj,item,fromIndex,guard){return isArrayLike(obj)||(obj=_.values(obj)),("number"!=typeof fromIndex||guard)&&(fromIndex=0),_.indexOf(obj,item,fromIndex)>=0},_.invoke=function(obj,method){var args=slice.call(arguments,2),isFunc=_.isFunction(method);return _.map(obj,function(value){var func=isFunc?method:value[method];return null==func?func:func.apply(value,args)})},_.pluck=function(obj,key){return _.map(obj,_.property(key))},_.where=function(obj,attrs){return _.filter(obj,_.matcher(attrs))},_.findWhere=function(obj,attrs){return _.find(obj,_.matcher(attrs))},_.max=function(obj,iteratee,context){var value,computed,result=-(1/0),lastComputed=-(1/0);if(null==iteratee&&null!=obj){obj=isArrayLike(obj)?obj:_.values(obj);for(var i=0,length=obj.length;length>i;i++)value=obj[i],value>result&&(result=value)}else iteratee=cb(iteratee,context),_.each(obj,function(value,index,list){computed=iteratee(value,index,list),(computed>lastComputed||computed===-(1/0)&&result===-(1/0))&&(result=value,lastComputed=computed)});return result},_.min=function(obj,iteratee,context){var value,computed,result=1/0,lastComputed=1/0;if(null==iteratee&&null!=obj){obj=isArrayLike(obj)?obj:_.values(obj);for(var i=0,length=obj.length;length>i;i++)value=obj[i],result>value&&(result=value)}else iteratee=cb(iteratee,context),_.each(obj,function(value,index,list){computed=iteratee(value,index,list),(lastComputed>computed||computed===1/0&&result===1/0)&&(result=value,lastComputed=computed)});return result},_.shuffle=function(obj){for(var rand,set=isArrayLike(obj)?obj:_.values(obj),length=set.length,shuffled=Array(length),index=0;length>index;index++)rand=_.random(0,index),rand!==index&&(shuffled[index]=shuffled[rand]),shuffled[rand]=set[index];return shuffled},_.sample=function(obj,n,guard){return null==n||guard?(isArrayLike(obj)||(obj=_.values(obj)),obj[_.random(obj.length-1)]):_.shuffle(obj).slice(0,Math.max(0,n))},_.sortBy=function(obj,iteratee,context){return iteratee=cb(iteratee,context),_.pluck(_.map(obj,function(value,index,list){return{value:value,index:index,criteria:iteratee(value,index,list)}}).sort(function(left,right){var a=left.criteria,b=right.criteria;if(a!==b){if(a>b||void 0===a)return 1;if(b>a||void 0===b)return-1}return left.index-right.index}),"value")};var group=function(behavior){return function(obj,iteratee,context){var result={};return iteratee=cb(iteratee,context),_.each(obj,function(value,index){var key=iteratee(value,index,obj);behavior(result,value,key)}),result}};_.groupBy=group(function(result,value,key){_.has(result,key)?result[key].push(value):result[key]=[value]}),_.indexBy=group(function(result,value,key){result[key]=value}),_.countBy=group(function(result,value,key){_.has(result,key)?result[key]++:result[key]=1}),_.toArray=function(obj){return obj?_.isArray(obj)?slice.call(obj):isArrayLike(obj)?_.map(obj,_.identity):_.values(obj):[]},_.size=function(obj){return null==obj?0:isArrayLike(obj)?obj.length:_.keys(obj).length},_.partition=function(obj,predicate,context){predicate=cb(predicate,context);var pass=[],fail=[];return _.each(obj,function(value,key,obj){(predicate(value,key,obj)?pass:fail).push(value)}),[pass,fail]},_.first=_.head=_.take=function(array,n,guard){return null==array?void 0:null==n||guard?array[0]:_.initial(array,array.length-n)},_.initial=function(array,n,guard){return slice.call(array,0,Math.max(0,array.length-(null==n||guard?1:n)))},_.last=function(array,n,guard){return null==array?void 0:null==n||guard?array[array.length-1]:_.rest(array,Math.max(0,array.length-n))},_.rest=_.tail=_.drop=function(array,n,guard){return slice.call(array,null==n||guard?1:n)},_.compact=function(array){return _.filter(array,_.identity)};var flatten=function(input,shallow,strict,startIndex){for(var output=[],idx=0,i=startIndex||0,length=getLength(input);length>i;i++){var value=input[i];if(isArrayLike(value)&&(_.isArray(value)||_.isArguments(value))){shallow||(value=flatten(value,shallow,strict));var j=0,len=value.length;for(output.length+=len;len>j;)output[idx++]=value[j++]}else strict||(output[idx++]=value)}return output};_.flatten=function(array,shallow){return flatten(array,shallow,!1)},_.without=function(array){return _.difference(array,slice.call(arguments,1))},_.uniq=_.unique=function(array,isSorted,iteratee,context){_.isBoolean(isSorted)||(context=iteratee,iteratee=isSorted,isSorted=!1),null!=iteratee&&(iteratee=cb(iteratee,context));for(var result=[],seen=[],i=0,length=getLength(array);length>i;i++){var value=array[i],computed=iteratee?iteratee(value,i,array):value;isSorted?(i&&seen===computed||result.push(value),seen=computed):iteratee?_.contains(seen,computed)||(seen.push(computed),result.push(value)):_.contains(result,value)||result.push(value)}return result},_.union=function(){return _.uniq(flatten(arguments,!0,!0))},_.intersection=function(array){for(var result=[],argsLength=arguments.length,i=0,length=getLength(array);length>i;i++){var item=array[i];if(!_.contains(result,item)){for(var j=1;argsLength>j&&_.contains(arguments[j],item);j++);j===argsLength&&result.push(item)}}return result},_.difference=function(array){var rest=flatten(arguments,!0,!0,1);return _.filter(array,function(value){return!_.contains(rest,value)})},_.zip=function(){return _.unzip(arguments)},_.unzip=function(array){for(var length=array&&_.max(array,getLength).length||0,result=Array(length),index=0;length>index;index++)result[index]=_.pluck(array,index);return result},_.object=function(list,values){for(var result={},i=0,length=getLength(list);length>i;i++)values?result[list[i]]=values[i]:result[list[i][0]]=list[i][1];return result},_.findIndex=createPredicateIndexFinder(1),_.findLastIndex=createPredicateIndexFinder(-1),_.sortedIndex=function(array,obj,iteratee,context){iteratee=cb(iteratee,context,1);for(var value=iteratee(obj),low=0,high=getLength(array);high>low;){var mid=Math.floor((low+high)/2);iteratee(array[mid])<value?low=mid+1:high=mid}return low},_.indexOf=createIndexFinder(1,_.findIndex,_.sortedIndex),_.lastIndexOf=createIndexFinder(-1,_.findLastIndex),_.range=function(start,stop,step){null==stop&&(stop=start||0,start=0),step=step||1;for(var length=Math.max(Math.ceil((stop-start)/step),0),range=Array(length),idx=0;length>idx;idx++,start+=step)range[idx]=start;return range};var executeBound=function(sourceFunc,boundFunc,context,callingContext,args){if(!(callingContext instanceof boundFunc))return sourceFunc.apply(context,args);var self=baseCreate(sourceFunc.prototype),result=sourceFunc.apply(self,args);return _.isObject(result)?result:self};_.bind=function(func,context){if(nativeBind&&func.bind===nativeBind)return nativeBind.apply(func,slice.call(arguments,1));if(!_.isFunction(func))throw new TypeError("Bind must be called on a function");var args=slice.call(arguments,2),bound=function(){return executeBound(func,bound,context,this,args.concat(slice.call(arguments)))};return bound},_.partial=function(func){var boundArgs=slice.call(arguments,1),bound=function(){for(var position=0,length=boundArgs.length,args=Array(length),i=0;length>i;i++)args[i]=boundArgs[i]===_?arguments[position++]:boundArgs[i];for(;position<arguments.length;)args.push(arguments[position++]);return executeBound(func,bound,this,this,args)};return bound},_.bindAll=function(obj){var i,key,length=arguments.length;if(1>=length)throw new Error("bindAll must be passed function names");for(i=1;length>i;i++)key=arguments[i],obj[key]=_.bind(obj[key],obj);return obj},_.memoize=function(func,hasher){var memoize=function(key){var cache=memoize.cache,address=""+(hasher?hasher.apply(this,arguments):key);return _.has(cache,address)||(cache[address]=func.apply(this,arguments)),cache[address]};return memoize.cache={},memoize},_.delay=function(func,wait){var args=slice.call(arguments,2);return setTimeout(function(){return func.apply(null,args)},wait)},_.defer=_.partial(_.delay,_,1),_.throttle=function(func,wait,options){var context,args,result,timeout=null,previous=0;options||(options={});var later=function(){previous=options.leading===!1?0:_.now(),timeout=null,result=func.apply(context,args),timeout||(context=args=null)};return function(){var now=_.now();previous||options.leading!==!1||(previous=now);var remaining=wait-(now-previous);return context=this,args=arguments,0>=remaining||remaining>wait?(timeout&&(clearTimeout(timeout),timeout=null),previous=now,result=func.apply(context,args),timeout||(context=args=null)):timeout||options.trailing===!1||(timeout=setTimeout(later,remaining)),result}},_.debounce=function(func,wait,immediate){var timeout,args,context,timestamp,result,later=function(){var last=_.now()-timestamp;wait>last&&last>=0?timeout=setTimeout(later,wait-last):(timeout=null,immediate||(result=func.apply(context,args),timeout||(context=args=null)))};return function(){context=this,args=arguments,timestamp=_.now();var callNow=immediate&&!timeout;return timeout||(timeout=setTimeout(later,wait)),callNow&&(result=func.apply(context,args),context=args=null),result}},_.wrap=function(func,wrapper){return _.partial(wrapper,func)},_.negate=function(predicate){return function(){return!predicate.apply(this,arguments)}},_.compose=function(){var args=arguments,start=args.length-1;return function(){for(var i=start,result=args[start].apply(this,arguments);i--;)result=args[i].call(this,result);return result}},_.after=function(times,func){return function(){return--times<1?func.apply(this,arguments):void 0}},_.before=function(times,func){var memo;return function(){return--times>0&&(memo=func.apply(this,arguments)),1>=times&&(func=null),memo}},_.once=_.partial(_.before,2);var hasEnumBug=!{toString:null}.propertyIsEnumerable("toString"),nonEnumerableProps=["valueOf","isPrototypeOf","toString","propertyIsEnumerable","hasOwnProperty","toLocaleString"];_.keys=function(obj){if(!_.isObject(obj))return[];if(nativeKeys)return nativeKeys(obj);var keys=[];for(var key in obj)_.has(obj,key)&&keys.push(key);return hasEnumBug&&collectNonEnumProps(obj,keys),keys},_.allKeys=function(obj){if(!_.isObject(obj))return[];var keys=[];for(var key in obj)keys.push(key);return hasEnumBug&&collectNonEnumProps(obj,keys),keys},_.values=function(obj){for(var keys=_.keys(obj),length=keys.length,values=Array(length),i=0;length>i;i++)values[i]=obj[keys[i]];return values},_.mapObject=function(obj,iteratee,context){iteratee=cb(iteratee,context);for(var currentKey,keys=_.keys(obj),length=keys.length,results={},index=0;length>index;index++)currentKey=keys[index],results[currentKey]=iteratee(obj[currentKey],currentKey,obj);return results},_.pairs=function(obj){for(var keys=_.keys(obj),length=keys.length,pairs=Array(length),i=0;length>i;i++)pairs[i]=[keys[i],obj[keys[i]]];return pairs},_.invert=function(obj){for(var result={},keys=_.keys(obj),i=0,length=keys.length;length>i;i++)result[obj[keys[i]]]=keys[i];return result},_.functions=_.methods=function(obj){var names=[];for(var key in obj)_.isFunction(obj[key])&&names.push(key);return names.sort()},_.extend=createAssigner(_.allKeys),_.extendOwn=_.assign=createAssigner(_.keys),_.findKey=function(obj,predicate,context){predicate=cb(predicate,context);for(var key,keys=_.keys(obj),i=0,length=keys.length;length>i;i++)if(key=keys[i],predicate(obj[key],key,obj))return key},_.pick=function(object,oiteratee,context){var iteratee,keys,result={},obj=object;if(null==obj)return result;_.isFunction(oiteratee)?(keys=_.allKeys(obj),iteratee=optimizeCb(oiteratee,context)):(keys=flatten(arguments,!1,!1,1),iteratee=function(value,key,obj){return key in obj},obj=Object(obj));for(var i=0,length=keys.length;length>i;i++){var key=keys[i],value=obj[key];iteratee(value,key,obj)&&(result[key]=value)}return result},_.omit=function(obj,iteratee,context){if(_.isFunction(iteratee))iteratee=_.negate(iteratee);else{var keys=_.map(flatten(arguments,!1,!1,1),String);iteratee=function(value,key){return!_.contains(keys,key)}}return _.pick(obj,iteratee,context)},_.defaults=createAssigner(_.allKeys,!0),_.create=function(prototype,props){var result=baseCreate(prototype);return props&&_.extendOwn(result,props),result},_.clone=function(obj){return _.isObject(obj)?_.isArray(obj)?obj.slice():_.extend({},obj):obj},_.tap=function(obj,interceptor){return interceptor(obj),obj},_.isMatch=function(object,attrs){var keys=_.keys(attrs),length=keys.length;if(null==object)return!length;for(var obj=Object(object),i=0;length>i;i++){var key=keys[i];if(attrs[key]!==obj[key]||!(key in obj))return!1}return!0};var eq=function(a,b,aStack,bStack){if(a===b)return 0!==a||1/a===1/b;if(null==a||null==b)return a===b;a instanceof _&&(a=a._wrapped),b instanceof _&&(b=b._wrapped);var className=toString.call(a);if(className!==toString.call(b))return!1;switch(className){case"[object RegExp]":case"[object String]":return""+a==""+b;case"[object Number]":return+a!==+a?+b!==+b:0===+a?1/+a===1/b:+a===+b;case"[object Date]":case"[object Boolean]":return+a===+b}var areArrays="[object Array]"===className;if(!areArrays){if("object"!=typeof a||"object"!=typeof b)return!1;var aCtor=a.constructor,bCtor=b.constructor;if(aCtor!==bCtor&&!(_.isFunction(aCtor)&&aCtor instanceof aCtor&&_.isFunction(bCtor)&&bCtor instanceof bCtor)&&"constructor"in a&&"constructor"in b)return!1}aStack=aStack||[],bStack=bStack||[];for(var length=aStack.length;length--;)if(aStack[length]===a)return bStack[length]===b;if(aStack.push(a),bStack.push(b),areArrays){if(length=a.length,length!==b.length)return!1;for(;length--;)if(!eq(a[length],b[length],aStack,bStack))return!1}else{var key,keys=_.keys(a);if(length=keys.length,_.keys(b).length!==length)return!1;for(;length--;)if(key=keys[length],!_.has(b,key)||!eq(a[key],b[key],aStack,bStack))return!1}return aStack.pop(),bStack.pop(),!0};_.isEqual=function(a,b){return eq(a,b)},_.isEmpty=function(obj){return null==obj?!0:isArrayLike(obj)&&(_.isArray(obj)||_.isString(obj)||_.isArguments(obj))?0===obj.length:0===_.keys(obj).length},_.isElement=function(obj){return!(!obj||1!==obj.nodeType)},_.isArray=nativeIsArray||function(obj){return"[object Array]"===toString.call(obj)},_.isObject=function(obj){var type=typeof obj;return"function"===type||"object"===type&&!!obj},_.each(["Arguments","Function","String","Number","Date","RegExp","Error"],function(name){_["is"+name]=function(obj){return toString.call(obj)==="[object "+name+"]"}}),_.isArguments(arguments)||(_.isArguments=function(obj){return _.has(obj,"callee")}),"function"!=typeof/./&&"object"!=typeof Int8Array&&(_.isFunction=function(obj){return"function"==typeof obj||!1}),_.isFinite=function(obj){return isFinite(obj)&&!isNaN(parseFloat(obj))},_.isNaN=function(obj){return _.isNumber(obj)&&obj!==+obj},_.isBoolean=function(obj){return obj===!0||obj===!1||"[object Boolean]"===toString.call(obj)},_.isNull=function(obj){return null===obj},_.isUndefined=function(obj){return void 0===obj},_.has=function(obj,key){return null!=obj&&hasOwnProperty.call(obj,key)},_.noConflict=function(){return root._=previousUnderscore,this},_.identity=function(value){return value},_.constant=function(value){return function(){return value}},_.noop=function(){},_.property=property,_.propertyOf=function(obj){return null==obj?function(){}:function(key){return obj[key]}},_.matcher=_.matches=function(attrs){return attrs=_.extendOwn({},attrs),function(obj){return _.isMatch(obj,attrs)}},_.times=function(n,iteratee,context){var accum=Array(Math.max(0,n));iteratee=optimizeCb(iteratee,context,1);for(var i=0;n>i;i++)accum[i]=iteratee(i);return accum},_.random=function(min,max){return null==max&&(max=min,min=0),min+Math.floor(Math.random()*(max-min+1))},_.now=Date.now||function(){return(new Date).getTime()};var escapeMap={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#x27;","`":"&#x60;"},unescapeMap=_.invert(escapeMap),createEscaper=function(map){var escaper=function(match){return map[match]},source="(?:"+_.keys(map).join("|")+")",testRegexp=RegExp(source),replaceRegexp=RegExp(source,"g");return function(string){return string=null==string?"":""+string,testRegexp.test(string)?string.replace(replaceRegexp,escaper):string}};_.escape=createEscaper(escapeMap),_.unescape=createEscaper(unescapeMap),_.result=function(object,property,fallback){var value=null==object?void 0:object[property];return void 0===value&&(value=fallback),_.isFunction(value)?value.call(object):value};var idCounter=0;_.uniqueId=function(prefix){var id=++idCounter+"";return prefix?prefix+id:id},_.templateSettings={evaluate:/<%([\s\S]+?)%>/g,interpolate:/<%=([\s\S]+?)%>/g,escape:/<%-([\s\S]+?)%>/g};var noMatch=/(.)^/,escapes={"'":"'","\\":"\\","\r":"r","\n":"n","\u2028":"u2028","\u2029":"u2029"},escaper=/\\|'|\r|\n|\u2028|\u2029/g,escapeChar=function(match){return"\\"+escapes[match]};_.template=function(text,settings,oldSettings){!settings&&oldSettings&&(settings=oldSettings),settings=_.defaults({},settings,_.templateSettings);var matcher=RegExp([(settings.escape||noMatch).source,(settings.interpolate||noMatch).source,(settings.evaluate||noMatch).source].join("|")+"|$","g"),index=0,source="__p+='";text.replace(matcher,function(match,escape,interpolate,evaluate,offset){return source+=text.slice(index,offset).replace(escaper,escapeChar),index=offset+match.length,escape?source+="'+\n((__t=("+escape+"))==null?'':_.escape(__t))+\n'":interpolate?source+="'+\n((__t=("+interpolate+"))==null?'':__t)+\n'":evaluate&&(source+="';\n"+evaluate+"\n__p+='"),match}),source+="';\n",settings.variable||(source="with(obj||{}){\n"+source+"}\n"),source="var __t,__p='',__j=Array.prototype.join,print=function(){__p+=__j.call(arguments,'');};\n"+source+"return __p;\n";try{var render=new Function(settings.variable||"obj","_",source)}catch(e){throw e.source=source,e}var template=function(data){return render.call(this,data,_)},argument=settings.variable||"obj";return template.source="function("+argument+"){\n"+source+"}",template},_.chain=function(obj){var instance=_(obj);return instance._chain=!0,instance};var result=function(instance,obj){return instance._chain?_(obj).chain():obj};_.mixin=function(obj){_.each(_.functions(obj),function(name){var func=_[name]=obj[name];_.prototype[name]=function(){var args=[this._wrapped];return push.apply(args,arguments),result(this,func.apply(_,args))}})},_.mixin(_),_.each(["pop","push","reverse","shift","sort","splice","unshift"],function(name){var method=ArrayProto[name];_.prototype[name]=function(){var obj=this._wrapped;return method.apply(obj,arguments),"shift"!==name&&"splice"!==name||0!==obj.length||delete obj[0],result(this,obj)}}),_.each(["concat","join","slice"],function(name){var method=ArrayProto[name];_.prototype[name]=function(){return result(this,method.apply(this._wrapped,arguments))}}),_.prototype.value=function(){return this._wrapped},_.prototype.valueOf=_.prototype.toJSON=_.prototype.value,_.prototype.toString=function(){return""+this._wrapped},__WEBPACK_AMD_DEFINE_ARRAY__=[],__WEBPACK_AMD_DEFINE_RESULT__=function(){return _}.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__),!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__))}).call(this)},function(module,exports,__webpack_require__){"use strict";function handleQs(url,query){url=url.split("?");var start=url[0],qs=(url[1]||"").split("#")[0],end=url[1]&&url[1].split("#").length>1?"#"+url[1].split("#")[1]:"",baseQs=parse(qs);for(var i in query)baseQs[i]=query[i];return qs=stringify(baseQs),""!==qs&&(qs="?"+qs),start+qs+end}var parse=__webpack_require__(170).parse,stringify=__webpack_require__(170).stringify;module.exports=handleQs},function(module,exports,__webpack_require__){"use strict";function classDecl(name,isInteface){return{name:name,methods:[],typeParameters:[],typeParameterConstraint:[],"implements":[],fields:[],isInterface:isInteface,annotations:[],"extends":[],moduleName:null,annotationOverridings:{}}}function parseStruct(content,modules,mpth){return tsStructureParser.parseStruct(content,modules,mpth)}exports.helpers=__webpack_require__(134);var tsStructureParser=__webpack_require__(135),EnumDeclaration=function(){function EnumDeclaration(){}return EnumDeclaration}();exports.EnumDeclaration=EnumDeclaration,function(TypeKind){TypeKind[TypeKind.BASIC=0]="BASIC",TypeKind[TypeKind.ARRAY=1]="ARRAY",TypeKind[TypeKind.UNION=2]="UNION"}(exports.TypeKind||(exports.TypeKind={}));exports.TypeKind;exports.classDecl=classDecl,exports.parseStruct=parseStruct},function(module,exports,__webpack_require__){(function(Buffer,global){"use strict";function typedArraySupport(){function Bar(){}try{var arr=new Uint8Array(1);return arr.foo=function(){return 42},arr.constructor=Bar,42===arr.foo()&&arr.constructor===Bar&&"function"==typeof arr.subarray&&0===arr.subarray(1,1).byteLength}catch(e){return!1}}function kMaxLength(){return Buffer.TYPED_ARRAY_SUPPORT?2147483647:1073741823}function Buffer(arg){return this instanceof Buffer?(Buffer.TYPED_ARRAY_SUPPORT||(this.length=0,this.parent=void 0),"number"==typeof arg?fromNumber(this,arg):"string"==typeof arg?fromString(this,arg,arguments.length>1?arguments[1]:"utf8"):fromObject(this,arg)):arguments.length>1?new Buffer(arg,arguments[1]):new Buffer(arg)}function fromNumber(that,length){if(that=allocate(that,0>length?0:0|checked(length)),!Buffer.TYPED_ARRAY_SUPPORT)for(var i=0;length>i;i++)that[i]=0;return that}function fromString(that,string,encoding){("string"!=typeof encoding||""===encoding)&&(encoding="utf8");var length=0|byteLength(string,encoding);return that=allocate(that,length),that.write(string,encoding),that}function fromObject(that,object){if(Buffer.isBuffer(object))return fromBuffer(that,object);if(isArray(object))return fromArray(that,object);if(null==object)throw new TypeError("must start with number, buffer, array or string");if("undefined"!=typeof ArrayBuffer){if(object.buffer instanceof ArrayBuffer)return fromTypedArray(that,object);if(object instanceof ArrayBuffer)return fromArrayBuffer(that,object)}return object.length?fromArrayLike(that,object):fromJsonObject(that,object)}function fromBuffer(that,buffer){var length=0|checked(buffer.length);return that=allocate(that,length),buffer.copy(that,0,0,length),that}function fromArray(that,array){var length=0|checked(array.length);that=allocate(that,length);for(var i=0;length>i;i+=1)that[i]=255&array[i];return that}function fromTypedArray(that,array){var length=0|checked(array.length);that=allocate(that,length);for(var i=0;length>i;i+=1)that[i]=255&array[i];return that}function fromArrayBuffer(that,array){return Buffer.TYPED_ARRAY_SUPPORT?(array.byteLength,that=Buffer._augment(new Uint8Array(array))):that=fromTypedArray(that,new Uint8Array(array)),that}function fromArrayLike(that,array){var length=0|checked(array.length);that=allocate(that,length);for(var i=0;length>i;i+=1)that[i]=255&array[i];return that}function fromJsonObject(that,object){var array,length=0;"Buffer"===object.type&&isArray(object.data)&&(array=object.data,length=0|checked(array.length)),that=allocate(that,length);for(var i=0;length>i;i+=1)that[i]=255&array[i];return that}function allocate(that,length){Buffer.TYPED_ARRAY_SUPPORT?(that=Buffer._augment(new Uint8Array(length)),that.__proto__=Buffer.prototype):(that.length=length,that._isBuffer=!0);var fromPool=0!==length&&length<=Buffer.poolSize>>>1;return fromPool&&(that.parent=rootParent),that}function checked(length){if(length>=kMaxLength())throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x"+kMaxLength().toString(16)+" bytes");return 0|length}function SlowBuffer(subject,encoding){if(!(this instanceof SlowBuffer))return new SlowBuffer(subject,encoding);var buf=new Buffer(subject,encoding);return delete buf.parent,buf}function byteLength(string,encoding){"string"!=typeof string&&(string=""+string);var len=string.length;if(0===len)return 0;for(var loweredCase=!1;;)switch(encoding){case"ascii":case"binary":case"raw":case"raws":return len;case"utf8":case"utf-8":return utf8ToBytes(string).length;case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return 2*len;case"hex":return len>>>1;case"base64":return base64ToBytes(string).length;default:if(loweredCase)return utf8ToBytes(string).length;encoding=(""+encoding).toLowerCase(),loweredCase=!0}}function slowToString(encoding,start,end){var loweredCase=!1;if(start=0|start,end=void 0===end||end===1/0?this.length:0|end,encoding||(encoding="utf8"),0>start&&(start=0),end>this.length&&(end=this.length),start>=end)return"";for(;;)switch(encoding){case"hex":return hexSlice(this,start,end);case"utf8":case"utf-8":return utf8Slice(this,start,end);case"ascii":return asciiSlice(this,start,end);case"binary":return binarySlice(this,start,end);
case"base64":return base64Slice(this,start,end);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return utf16leSlice(this,start,end);default:if(loweredCase)throw new TypeError("Unknown encoding: "+encoding);encoding=(encoding+"").toLowerCase(),loweredCase=!0}}function hexWrite(buf,string,offset,length){offset=Number(offset)||0;var remaining=buf.length-offset;length?(length=Number(length),length>remaining&&(length=remaining)):length=remaining;var strLen=string.length;if(strLen%2!==0)throw new Error("Invalid hex string");length>strLen/2&&(length=strLen/2);for(var i=0;length>i;i++){var parsed=parseInt(string.substr(2*i,2),16);if(isNaN(parsed))throw new Error("Invalid hex string");buf[offset+i]=parsed}return i}function utf8Write(buf,string,offset,length){return blitBuffer(utf8ToBytes(string,buf.length-offset),buf,offset,length)}function asciiWrite(buf,string,offset,length){return blitBuffer(asciiToBytes(string),buf,offset,length)}function binaryWrite(buf,string,offset,length){return asciiWrite(buf,string,offset,length)}function base64Write(buf,string,offset,length){return blitBuffer(base64ToBytes(string),buf,offset,length)}function ucs2Write(buf,string,offset,length){return blitBuffer(utf16leToBytes(string,buf.length-offset),buf,offset,length)}function base64Slice(buf,start,end){return 0===start&&end===buf.length?base64.fromByteArray(buf):base64.fromByteArray(buf.slice(start,end))}function utf8Slice(buf,start,end){end=Math.min(buf.length,end);for(var res=[],i=start;end>i;){var firstByte=buf[i],codePoint=null,bytesPerSequence=firstByte>239?4:firstByte>223?3:firstByte>191?2:1;if(end>=i+bytesPerSequence){var secondByte,thirdByte,fourthByte,tempCodePoint;switch(bytesPerSequence){case 1:128>firstByte&&(codePoint=firstByte);break;case 2:secondByte=buf[i+1],128===(192&secondByte)&&(tempCodePoint=(31&firstByte)<<6|63&secondByte,tempCodePoint>127&&(codePoint=tempCodePoint));break;case 3:secondByte=buf[i+1],thirdByte=buf[i+2],128===(192&secondByte)&&128===(192&thirdByte)&&(tempCodePoint=(15&firstByte)<<12|(63&secondByte)<<6|63&thirdByte,tempCodePoint>2047&&(55296>tempCodePoint||tempCodePoint>57343)&&(codePoint=tempCodePoint));break;case 4:secondByte=buf[i+1],thirdByte=buf[i+2],fourthByte=buf[i+3],128===(192&secondByte)&&128===(192&thirdByte)&&128===(192&fourthByte)&&(tempCodePoint=(15&firstByte)<<18|(63&secondByte)<<12|(63&thirdByte)<<6|63&fourthByte,tempCodePoint>65535&&1114112>tempCodePoint&&(codePoint=tempCodePoint))}}null===codePoint?(codePoint=65533,bytesPerSequence=1):codePoint>65535&&(codePoint-=65536,res.push(codePoint>>>10&1023|55296),codePoint=56320|1023&codePoint),res.push(codePoint),i+=bytesPerSequence}return decodeCodePointsArray(res)}function decodeCodePointsArray(codePoints){var len=codePoints.length;if(MAX_ARGUMENTS_LENGTH>=len)return String.fromCharCode.apply(String,codePoints);for(var res="",i=0;len>i;)res+=String.fromCharCode.apply(String,codePoints.slice(i,i+=MAX_ARGUMENTS_LENGTH));return res}function asciiSlice(buf,start,end){var ret="";end=Math.min(buf.length,end);for(var i=start;end>i;i++)ret+=String.fromCharCode(127&buf[i]);return ret}function binarySlice(buf,start,end){var ret="";end=Math.min(buf.length,end);for(var i=start;end>i;i++)ret+=String.fromCharCode(buf[i]);return ret}function hexSlice(buf,start,end){var len=buf.length;(!start||0>start)&&(start=0),(!end||0>end||end>len)&&(end=len);for(var out="",i=start;end>i;i++)out+=toHex(buf[i]);return out}function utf16leSlice(buf,start,end){for(var bytes=buf.slice(start,end),res="",i=0;i<bytes.length;i+=2)res+=String.fromCharCode(bytes[i]+256*bytes[i+1]);return res}function checkOffset(offset,ext,length){if(offset%1!==0||0>offset)throw new RangeError("offset is not uint");if(offset+ext>length)throw new RangeError("Trying to access beyond buffer length")}function checkInt(buf,value,offset,ext,max,min){if(!Buffer.isBuffer(buf))throw new TypeError("buffer must be a Buffer instance");if(value>max||min>value)throw new RangeError("value is out of bounds");if(offset+ext>buf.length)throw new RangeError("index out of range")}function objectWriteUInt16(buf,value,offset,littleEndian){0>value&&(value=65535+value+1);for(var i=0,j=Math.min(buf.length-offset,2);j>i;i++)buf[offset+i]=(value&255<<8*(littleEndian?i:1-i))>>>8*(littleEndian?i:1-i)}function objectWriteUInt32(buf,value,offset,littleEndian){0>value&&(value=4294967295+value+1);for(var i=0,j=Math.min(buf.length-offset,4);j>i;i++)buf[offset+i]=value>>>8*(littleEndian?i:3-i)&255}function checkIEEE754(buf,value,offset,ext,max,min){if(value>max||min>value)throw new RangeError("value is out of bounds");if(offset+ext>buf.length)throw new RangeError("index out of range");if(0>offset)throw new RangeError("index out of range")}function writeFloat(buf,value,offset,littleEndian,noAssert){return noAssert||checkIEEE754(buf,value,offset,4,3.4028234663852886e38,-3.4028234663852886e38),ieee754.write(buf,value,offset,littleEndian,23,4),offset+4}function writeDouble(buf,value,offset,littleEndian,noAssert){return noAssert||checkIEEE754(buf,value,offset,8,1.7976931348623157e308,-1.7976931348623157e308),ieee754.write(buf,value,offset,littleEndian,52,8),offset+8}function base64clean(str){if(str=stringtrim(str).replace(INVALID_BASE64_RE,""),str.length<2)return"";for(;str.length%4!==0;)str+="=";return str}function stringtrim(str){return str.trim?str.trim():str.replace(/^\s+|\s+$/g,"")}function toHex(n){return 16>n?"0"+n.toString(16):n.toString(16)}function utf8ToBytes(string,units){units=units||1/0;for(var codePoint,length=string.length,leadSurrogate=null,bytes=[],i=0;length>i;i++){if(codePoint=string.charCodeAt(i),codePoint>55295&&57344>codePoint){if(!leadSurrogate){if(codePoint>56319){(units-=3)>-1&&bytes.push(239,191,189);continue}if(i+1===length){(units-=3)>-1&&bytes.push(239,191,189);continue}leadSurrogate=codePoint;continue}if(56320>codePoint){(units-=3)>-1&&bytes.push(239,191,189),leadSurrogate=codePoint;continue}codePoint=(leadSurrogate-55296<<10|codePoint-56320)+65536}else leadSurrogate&&(units-=3)>-1&&bytes.push(239,191,189);if(leadSurrogate=null,128>codePoint){if((units-=1)<0)break;bytes.push(codePoint)}else if(2048>codePoint){if((units-=2)<0)break;bytes.push(codePoint>>6|192,63&codePoint|128)}else if(65536>codePoint){if((units-=3)<0)break;bytes.push(codePoint>>12|224,codePoint>>6&63|128,63&codePoint|128)}else{if(!(1114112>codePoint))throw new Error("Invalid code point");if((units-=4)<0)break;bytes.push(codePoint>>18|240,codePoint>>12&63|128,codePoint>>6&63|128,63&codePoint|128)}}return bytes}function asciiToBytes(str){for(var byteArray=[],i=0;i<str.length;i++)byteArray.push(255&str.charCodeAt(i));return byteArray}function utf16leToBytes(str,units){for(var c,hi,lo,byteArray=[],i=0;i<str.length&&!((units-=2)<0);i++)c=str.charCodeAt(i),hi=c>>8,lo=c%256,byteArray.push(lo),byteArray.push(hi);return byteArray}function base64ToBytes(str){return base64.toByteArray(base64clean(str))}function blitBuffer(src,dst,offset,length){for(var i=0;length>i&&!(i+offset>=dst.length||i>=src.length);i++)dst[i+offset]=src[i];return i}var base64=__webpack_require__(185),ieee754=__webpack_require__(173),isArray=__webpack_require__(174);exports.Buffer=Buffer,exports.SlowBuffer=SlowBuffer,exports.INSPECT_MAX_BYTES=50,Buffer.poolSize=8192;var rootParent={};Buffer.TYPED_ARRAY_SUPPORT=void 0!==global.TYPED_ARRAY_SUPPORT?global.TYPED_ARRAY_SUPPORT:typedArraySupport(),Buffer.TYPED_ARRAY_SUPPORT?(Buffer.prototype.__proto__=Uint8Array.prototype,Buffer.__proto__=Uint8Array):(Buffer.prototype.length=void 0,Buffer.prototype.parent=void 0),Buffer.isBuffer=function(b){return!(null==b||!b._isBuffer)},Buffer.compare=function(a,b){if(!Buffer.isBuffer(a)||!Buffer.isBuffer(b))throw new TypeError("Arguments must be Buffers");if(a===b)return 0;for(var x=a.length,y=b.length,i=0,len=Math.min(x,y);len>i&&a[i]===b[i];)++i;return i!==len&&(x=a[i],y=b[i]),y>x?-1:x>y?1:0},Buffer.isEncoding=function(encoding){switch(String(encoding).toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"binary":case"base64":case"raw":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return!0;default:return!1}},Buffer.concat=function(list,length){if(!isArray(list))throw new TypeError("list argument must be an Array of Buffers.");if(0===list.length)return new Buffer(0);var i;if(void 0===length)for(length=0,i=0;i<list.length;i++)length+=list[i].length;var buf=new Buffer(length),pos=0;for(i=0;i<list.length;i++){var item=list[i];item.copy(buf,pos),pos+=item.length}return buf},Buffer.byteLength=byteLength,Buffer.prototype.toString=function(){var length=0|this.length;return 0===length?"":0===arguments.length?utf8Slice(this,0,length):slowToString.apply(this,arguments)},Buffer.prototype.equals=function(b){if(!Buffer.isBuffer(b))throw new TypeError("Argument must be a Buffer");return this===b?!0:0===Buffer.compare(this,b)},Buffer.prototype.inspect=function(){var str="",max=exports.INSPECT_MAX_BYTES;return this.length>0&&(str=this.toString("hex",0,max).match(/.{2}/g).join(" "),this.length>max&&(str+=" ... ")),"<Buffer "+str+">"},Buffer.prototype.compare=function(b){if(!Buffer.isBuffer(b))throw new TypeError("Argument must be a Buffer");return this===b?0:Buffer.compare(this,b)},Buffer.prototype.indexOf=function(val,byteOffset){function arrayIndexOf(arr,val,byteOffset){for(var foundIndex=-1,i=0;byteOffset+i<arr.length;i++)if(arr[byteOffset+i]===val[-1===foundIndex?0:i-foundIndex]){if(-1===foundIndex&&(foundIndex=i),i-foundIndex+1===val.length)return byteOffset+foundIndex}else foundIndex=-1;return-1}if(byteOffset>2147483647?byteOffset=2147483647:-2147483648>byteOffset&&(byteOffset=-2147483648),byteOffset>>=0,0===this.length)return-1;if(byteOffset>=this.length)return-1;if(0>byteOffset&&(byteOffset=Math.max(this.length+byteOffset,0)),"string"==typeof val)return 0===val.length?-1:String.prototype.indexOf.call(this,val,byteOffset);if(Buffer.isBuffer(val))return arrayIndexOf(this,val,byteOffset);if("number"==typeof val)return Buffer.TYPED_ARRAY_SUPPORT&&"function"===Uint8Array.prototype.indexOf?Uint8Array.prototype.indexOf.call(this,val,byteOffset):arrayIndexOf(this,[val],byteOffset);throw new TypeError("val must be string, number or Buffer")},Buffer.prototype.get=function(offset){return console.log(".get() is deprecated. Access using array indexes instead."),this.readUInt8(offset)},Buffer.prototype.set=function(v,offset){return console.log(".set() is deprecated. Access using array indexes instead."),this.writeUInt8(v,offset)},Buffer.prototype.write=function(string,offset,length,encoding){if(void 0===offset)encoding="utf8",length=this.length,offset=0;else if(void 0===length&&"string"==typeof offset)encoding=offset,length=this.length,offset=0;else if(isFinite(offset))offset=0|offset,isFinite(length)?(length=0|length,void 0===encoding&&(encoding="utf8")):(encoding=length,length=void 0);else{var swap=encoding;encoding=offset,offset=0|length,length=swap}var remaining=this.length-offset;if((void 0===length||length>remaining)&&(length=remaining),string.length>0&&(0>length||0>offset)||offset>this.length)throw new RangeError("attempt to write outside buffer bounds");encoding||(encoding="utf8");for(var loweredCase=!1;;)switch(encoding){case"hex":return hexWrite(this,string,offset,length);case"utf8":case"utf-8":return utf8Write(this,string,offset,length);case"ascii":return asciiWrite(this,string,offset,length);case"binary":return binaryWrite(this,string,offset,length);case"base64":return base64Write(this,string,offset,length);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return ucs2Write(this,string,offset,length);default:if(loweredCase)throw new TypeError("Unknown encoding: "+encoding);encoding=(""+encoding).toLowerCase(),loweredCase=!0}},Buffer.prototype.toJSON=function(){return{type:"Buffer",data:Array.prototype.slice.call(this._arr||this,0)}};var MAX_ARGUMENTS_LENGTH=4096;Buffer.prototype.slice=function(start,end){var len=this.length;start=~~start,end=void 0===end?len:~~end,0>start?(start+=len,0>start&&(start=0)):start>len&&(start=len),0>end?(end+=len,0>end&&(end=0)):end>len&&(end=len),start>end&&(end=start);var newBuf;if(Buffer.TYPED_ARRAY_SUPPORT)newBuf=Buffer._augment(this.subarray(start,end));else{var sliceLen=end-start;newBuf=new Buffer(sliceLen,void 0);for(var i=0;sliceLen>i;i++)newBuf[i]=this[i+start]}return newBuf.length&&(newBuf.parent=this.parent||this),newBuf},Buffer.prototype.readUIntLE=function(offset,byteLength,noAssert){offset=0|offset,byteLength=0|byteLength,noAssert||checkOffset(offset,byteLength,this.length);for(var val=this[offset],mul=1,i=0;++i<byteLength&&(mul*=256);)val+=this[offset+i]*mul;return val},Buffer.prototype.readUIntBE=function(offset,byteLength,noAssert){offset=0|offset,byteLength=0|byteLength,noAssert||checkOffset(offset,byteLength,this.length);for(var val=this[offset+--byteLength],mul=1;byteLength>0&&(mul*=256);)val+=this[offset+--byteLength]*mul;return val},Buffer.prototype.readUInt8=function(offset,noAssert){return noAssert||checkOffset(offset,1,this.length),this[offset]},Buffer.prototype.readUInt16LE=function(offset,noAssert){return noAssert||checkOffset(offset,2,this.length),this[offset]|this[offset+1]<<8},Buffer.prototype.readUInt16BE=function(offset,noAssert){return noAssert||checkOffset(offset,2,this.length),this[offset]<<8|this[offset+1]},Buffer.prototype.readUInt32LE=function(offset,noAssert){return noAssert||checkOffset(offset,4,this.length),(this[offset]|this[offset+1]<<8|this[offset+2]<<16)+16777216*this[offset+3]},Buffer.prototype.readUInt32BE=function(offset,noAssert){return noAssert||checkOffset(offset,4,this.length),16777216*this[offset]+(this[offset+1]<<16|this[offset+2]<<8|this[offset+3])},Buffer.prototype.readIntLE=function(offset,byteLength,noAssert){offset=0|offset,byteLength=0|byteLength,noAssert||checkOffset(offset,byteLength,this.length);for(var val=this[offset],mul=1,i=0;++i<byteLength&&(mul*=256);)val+=this[offset+i]*mul;return mul*=128,val>=mul&&(val-=Math.pow(2,8*byteLength)),val},Buffer.prototype.readIntBE=function(offset,byteLength,noAssert){offset=0|offset,byteLength=0|byteLength,noAssert||checkOffset(offset,byteLength,this.length);for(var i=byteLength,mul=1,val=this[offset+--i];i>0&&(mul*=256);)val+=this[offset+--i]*mul;return mul*=128,val>=mul&&(val-=Math.pow(2,8*byteLength)),val},Buffer.prototype.readInt8=function(offset,noAssert){return noAssert||checkOffset(offset,1,this.length),128&this[offset]?-1*(255-this[offset]+1):this[offset]},Buffer.prototype.readInt16LE=function(offset,noAssert){noAssert||checkOffset(offset,2,this.length);var val=this[offset]|this[offset+1]<<8;return 32768&val?4294901760|val:val},Buffer.prototype.readInt16BE=function(offset,noAssert){noAssert||checkOffset(offset,2,this.length);var val=this[offset+1]|this[offset]<<8;return 32768&val?4294901760|val:val},Buffer.prototype.readInt32LE=function(offset,noAssert){return noAssert||checkOffset(offset,4,this.length),this[offset]|this[offset+1]<<8|this[offset+2]<<16|this[offset+3]<<24},Buffer.prototype.readInt32BE=function(offset,noAssert){return noAssert||checkOffset(offset,4,this.length),this[offset]<<24|this[offset+1]<<16|this[offset+2]<<8|this[offset+3]},Buffer.prototype.readFloatLE=function(offset,noAssert){return noAssert||checkOffset(offset,4,this.length),ieee754.read(this,offset,!0,23,4)},Buffer.prototype.readFloatBE=function(offset,noAssert){return noAssert||checkOffset(offset,4,this.length),ieee754.read(this,offset,!1,23,4)},Buffer.prototype.readDoubleLE=function(offset,noAssert){return noAssert||checkOffset(offset,8,this.length),ieee754.read(this,offset,!0,52,8)},Buffer.prototype.readDoubleBE=function(offset,noAssert){return noAssert||checkOffset(offset,8,this.length),ieee754.read(this,offset,!1,52,8)},Buffer.prototype.writeUIntLE=function(value,offset,byteLength,noAssert){value=+value,offset=0|offset,byteLength=0|byteLength,noAssert||checkInt(this,value,offset,byteLength,Math.pow(2,8*byteLength),0);var mul=1,i=0;for(this[offset]=255&value;++i<byteLength&&(mul*=256);)this[offset+i]=value/mul&255;return offset+byteLength},Buffer.prototype.writeUIntBE=function(value,offset,byteLength,noAssert){value=+value,offset=0|offset,byteLength=0|byteLength,noAssert||checkInt(this,value,offset,byteLength,Math.pow(2,8*byteLength),0);var i=byteLength-1,mul=1;for(this[offset+i]=255&value;--i>=0&&(mul*=256);)this[offset+i]=value/mul&255;return offset+byteLength},Buffer.prototype.writeUInt8=function(value,offset,noAssert){return value=+value,offset=0|offset,noAssert||checkInt(this,value,offset,1,255,0),Buffer.TYPED_ARRAY_SUPPORT||(value=Math.floor(value)),this[offset]=255&value,offset+1},Buffer.prototype.writeUInt16LE=function(value,offset,noAssert){return value=+value,offset=0|offset,noAssert||checkInt(this,value,offset,2,65535,0),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=255&value,this[offset+1]=value>>>8):objectWriteUInt16(this,value,offset,!0),offset+2},Buffer.prototype.writeUInt16BE=function(value,offset,noAssert){return value=+value,offset=0|offset,noAssert||checkInt(this,value,offset,2,65535,0),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=value>>>8,this[offset+1]=255&value):objectWriteUInt16(this,value,offset,!1),offset+2},Buffer.prototype.writeUInt32LE=function(value,offset,noAssert){return value=+value,offset=0|offset,noAssert||checkInt(this,value,offset,4,4294967295,0),Buffer.TYPED_ARRAY_SUPPORT?(this[offset+3]=value>>>24,this[offset+2]=value>>>16,this[offset+1]=value>>>8,this[offset]=255&value):objectWriteUInt32(this,value,offset,!0),offset+4},Buffer.prototype.writeUInt32BE=function(value,offset,noAssert){return value=+value,offset=0|offset,noAssert||checkInt(this,value,offset,4,4294967295,0),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=value>>>24,this[offset+1]=value>>>16,this[offset+2]=value>>>8,this[offset+3]=255&value):objectWriteUInt32(this,value,offset,!1),offset+4},Buffer.prototype.writeIntLE=function(value,offset,byteLength,noAssert){if(value=+value,offset=0|offset,!noAssert){var limit=Math.pow(2,8*byteLength-1);checkInt(this,value,offset,byteLength,limit-1,-limit)}var i=0,mul=1,sub=0>value?1:0;for(this[offset]=255&value;++i<byteLength&&(mul*=256);)this[offset+i]=(value/mul>>0)-sub&255;return offset+byteLength},Buffer.prototype.writeIntBE=function(value,offset,byteLength,noAssert){if(value=+value,offset=0|offset,!noAssert){var limit=Math.pow(2,8*byteLength-1);checkInt(this,value,offset,byteLength,limit-1,-limit)}var i=byteLength-1,mul=1,sub=0>value?1:0;for(this[offset+i]=255&value;--i>=0&&(mul*=256);)this[offset+i]=(value/mul>>0)-sub&255;return offset+byteLength},Buffer.prototype.writeInt8=function(value,offset,noAssert){return value=+value,offset=0|offset,noAssert||checkInt(this,value,offset,1,127,-128),Buffer.TYPED_ARRAY_SUPPORT||(value=Math.floor(value)),0>value&&(value=255+value+1),this[offset]=255&value,offset+1},Buffer.prototype.writeInt16LE=function(value,offset,noAssert){return value=+value,offset=0|offset,noAssert||checkInt(this,value,offset,2,32767,-32768),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=255&value,this[offset+1]=value>>>8):objectWriteUInt16(this,value,offset,!0),offset+2},Buffer.prototype.writeInt16BE=function(value,offset,noAssert){return value=+value,offset=0|offset,noAssert||checkInt(this,value,offset,2,32767,-32768),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=value>>>8,this[offset+1]=255&value):objectWriteUInt16(this,value,offset,!1),offset+2},Buffer.prototype.writeInt32LE=function(value,offset,noAssert){return value=+value,offset=0|offset,noAssert||checkInt(this,value,offset,4,2147483647,-2147483648),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=255&value,this[offset+1]=value>>>8,this[offset+2]=value>>>16,this[offset+3]=value>>>24):objectWriteUInt32(this,value,offset,!0),offset+4},Buffer.prototype.writeInt32BE=function(value,offset,noAssert){return value=+value,offset=0|offset,noAssert||checkInt(this,value,offset,4,2147483647,-2147483648),0>value&&(value=4294967295+value+1),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=value>>>24,this[offset+1]=value>>>16,this[offset+2]=value>>>8,this[offset+3]=255&value):objectWriteUInt32(this,value,offset,!1),offset+4},Buffer.prototype.writeFloatLE=function(value,offset,noAssert){return writeFloat(this,value,offset,!0,noAssert)},Buffer.prototype.writeFloatBE=function(value,offset,noAssert){return writeFloat(this,value,offset,!1,noAssert)},Buffer.prototype.writeDoubleLE=function(value,offset,noAssert){return writeDouble(this,value,offset,!0,noAssert)},Buffer.prototype.writeDoubleBE=function(value,offset,noAssert){return writeDouble(this,value,offset,!1,noAssert)},Buffer.prototype.copy=function(target,targetStart,start,end){if(start||(start=0),end||0===end||(end=this.length),targetStart>=target.length&&(targetStart=target.length),targetStart||(targetStart=0),end>0&&start>end&&(end=start),end===start)return 0;if(0===target.length||0===this.length)return 0;if(0>targetStart)throw new RangeError("targetStart out of bounds");if(0>start||start>=this.length)throw new RangeError("sourceStart out of bounds");if(0>end)throw new RangeError("sourceEnd out of bounds");end>this.length&&(end=this.length),target.length-targetStart<end-start&&(end=target.length-targetStart+start);var i,len=end-start;if(this===target&&targetStart>start&&end>targetStart)for(i=len-1;i>=0;i--)target[i+targetStart]=this[i+start];else if(1e3>len||!Buffer.TYPED_ARRAY_SUPPORT)for(i=0;len>i;i++)target[i+targetStart]=this[i+start];else target._set(this.subarray(start,start+len),targetStart);return len},Buffer.prototype.fill=function(value,start,end){if(value||(value=0),start||(start=0),end||(end=this.length),start>end)throw new RangeError("end < start");if(end!==start&&0!==this.length){if(0>start||start>=this.length)throw new RangeError("start out of bounds");if(0>end||end>this.length)throw new RangeError("end out of bounds");var i;if("number"==typeof value)for(i=start;end>i;i++)this[i]=value;else{var bytes=utf8ToBytes(value.toString()),len=bytes.length;for(i=start;end>i;i++)this[i]=bytes[i%len]}return this}},Buffer.prototype.toArrayBuffer=function(){if("undefined"!=typeof Uint8Array){if(Buffer.TYPED_ARRAY_SUPPORT)return new Buffer(this).buffer;for(var buf=new Uint8Array(this.length),i=0,len=buf.length;len>i;i+=1)buf[i]=this[i];return buf.buffer}throw new TypeError("Buffer.toArrayBuffer not supported in this browser")};var BP=Buffer.prototype;Buffer._augment=function(arr){return arr.constructor=Buffer,arr._isBuffer=!0,arr._set=arr.set,arr.get=BP.get,arr.set=BP.set,arr.write=BP.write,arr.toString=BP.toString,arr.toLocaleString=BP.toString,arr.toJSON=BP.toJSON,arr.equals=BP.equals,arr.compare=BP.compare,arr.indexOf=BP.indexOf,arr.copy=BP.copy,arr.slice=BP.slice,arr.readUIntLE=BP.readUIntLE,arr.readUIntBE=BP.readUIntBE,arr.readUInt8=BP.readUInt8,arr.readUInt16LE=BP.readUInt16LE,arr.readUInt16BE=BP.readUInt16BE,arr.readUInt32LE=BP.readUInt32LE,arr.readUInt32BE=BP.readUInt32BE,arr.readIntLE=BP.readIntLE,arr.readIntBE=BP.readIntBE,arr.readInt8=BP.readInt8,arr.readInt16LE=BP.readInt16LE,arr.readInt16BE=BP.readInt16BE,arr.readInt32LE=BP.readInt32LE,arr.readInt32BE=BP.readInt32BE,arr.readFloatLE=BP.readFloatLE,arr.readFloatBE=BP.readFloatBE,arr.readDoubleLE=BP.readDoubleLE,arr.readDoubleBE=BP.readDoubleBE,arr.writeUInt8=BP.writeUInt8,arr.writeUIntLE=BP.writeUIntLE,arr.writeUIntBE=BP.writeUIntBE,arr.writeUInt16LE=BP.writeUInt16LE,arr.writeUInt16BE=BP.writeUInt16BE,arr.writeUInt32LE=BP.writeUInt32LE,arr.writeUInt32BE=BP.writeUInt32BE,arr.writeIntLE=BP.writeIntLE,arr.writeIntBE=BP.writeIntBE,arr.writeInt8=BP.writeInt8,arr.writeInt16LE=BP.writeInt16LE,arr.writeInt16BE=BP.writeInt16BE,arr.writeInt32LE=BP.writeInt32LE,arr.writeInt32BE=BP.writeInt32BE,arr.writeFloatLE=BP.writeFloatLE,arr.writeFloatBE=BP.writeFloatBE,arr.writeDoubleLE=BP.writeDoubleLE,arr.writeDoubleBE=BP.writeDoubleBE,arr.fill=BP.fill,arr.inspect=BP.inspect,arr.toArrayBuffer=BP.toArrayBuffer,arr};var INVALID_BASE64_RE=/[^+\/0-9A-Za-z-_]/g}).call(exports,__webpack_require__(92).Buffer,function(){return this}())},function(module,exports,__webpack_require__){"use strict";function ok(){return new Status(Status.OK,Status.OK,"",null)}function error(message,source,takeNodeFromSource){return void 0===takeNodeFromSource&&(takeNodeFromSource=!1),new Status(Status.ERROR,0,message,source,takeNodeFromSource)}function builtInRegistry(){return registry}function union(name,t){return new UnionType(name,t)}function intersect(name,t){return new IntersectionType(name,t)}function derive(name,t){var r=new InheritedType(name);return t.forEach(function(x){return r.addSuper(x)}),r.isSubTypeOf(exports.NIL)&&(r.nullable=!0),r}function deriveObjectType(name){return derive(name,[exports.OBJECT])}function select(obj,t0,t1){if(t0.isScalar()&&t1.isScalar()){if(-1!=t0.allSubTypes().indexOf(t1))return t0;if(-1!=t1.allSubTypes().indexOf(t0))return t1}var d0=t0.oneMeta(metaInfo.Discriminator),d1=t1.oneMeta(metaInfo.Discriminator);if(d0&&d1&&d0.property===d1.property){var v0=t0.descValue(),v1=t1.descValue();if(v0!==v1){var val=obj[d0.property];if(val===v0)return t0;if(val===v1)return t1}}return null}function is_int(value){return parseFloat(value)!=parseInt(value)||isNaN(value)?!1:!0}function typePath(t){for(var arr=[];null!=t;){if(null!=t.name()){arr.push(t.name());break}if(!(t instanceof InheritedType))break;var contextMeta=t.contextMeta();if(null==contextMeta)break;arr.push(contextMeta.path()),t=contextMeta._owner}return arr.reverse()}function checkDescriminator(i,t,path){var discriminator=t.metaOfType(metaInfo.Discriminator);if(0==discriminator.length)return null;var dName=discriminator[0].value(),owner=_.find([t].concat(t.allSuperTypes()),function(x){return x.getExtra(exports.GLOBAL)});if(!owner)return null;var dVal=owner.name(),discriminatorValue=t.metaOfType(metaInfo.DiscriminatorValue);if(0!=discriminatorValue.length&&(dVal=discriminatorValue[0].value()),dVal){if(i.hasOwnProperty(dName)){var adVal=i[dName];if(adVal!=dVal){var wrng=new Status(Status.WARNING,Status.CODE_INCORRECT_DISCRIMINATOR,"None of the '"+owner.name()+"' type known subtypes declare '"+adVal+"' as value of discriminating property '"+dName+"'.",this);return wrng.setValidationPath({name:dName,child:path}),wrng}return ok()}var err=new Status(Status.ERROR,Status.CODE_MISSING_DISCRIMINATOR,"Instance of '"+owner.name()+"' subtype misses value of the discriminating property '"+dName+"'.",this);return err.setValidationPath(path),err}}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},_=__webpack_require__(177),su=__webpack_require__(103),tsInterfaces=__webpack_require__(94),Status=function(){function Status(severity,code,message,source,takeNodeFromSource){void 0===takeNodeFromSource&&(takeNodeFromSource=!1),this.takeNodeFromSource=takeNodeFromSource,this.subStatus=[],this.severity=severity,this.code=code,this.message=message,this.source=source}return Status.prototype.getValidationPath=function(){return this.vp},Status.prototype.getValidationPathAsString=function(){if(!this.vp)return"";for(var s="",c=this.vp;c;)s+=c.name,c.child&&(s+="/"),c=c.child;return s},Status.prototype.patchPath=function(p){if(p){for(var c=p,r=null,cp=null;c;)if(r){var news={name:c.name};cp.child=news,c=c.child,cp=news}else r={name:c.name},cp=r,c=c.child,cp=r;return r}return null},Status.prototype.setValidationPath=function(_c){if(this.vp){for(var c=this.patchPath(_c),m=c;m.child;)m=m.child;m.child=this.vp,this.vp=c}else this.vp=_c;this.subStatus.forEach(function(x){x.setValidationPath(_c)})},Status.prototype.addSubStatus=function(st,pathName){void 0===pathName&&(pathName=null),pathName&&st.setValidationPath({name:pathName}),this.subStatus.push(st),this.severity<st.severity&&(this.severity=st.severity,this.message=st.message)},Status.prototype.getErrors=function(){if(this.isError()||this.isWarning()){if(this.subStatus.length>0){var rs=[];return this.subStatus.forEach(function(x){return rs=rs.concat(x.getErrors())}),rs}return[this]}return[]},Status.prototype.getSubStatuses=function(){return this.subStatus},Status.prototype.getSeverity=function(){return this.severity},Status.prototype.getMessage=function(){return this.message},Status.prototype.setMessage=function(message){this.message=message},Status.prototype.getSource=function(){return this.source},Status.prototype.getCode=function(){return this.code},Status.prototype.isWarning=function(){return this.severity==Status.WARNING},Status.prototype.isError=function(){return this.severity==Status.ERROR},Status.prototype.isOk=function(){return this.severity===Status.OK},Status.prototype.isInfo=function(){return this.severity===Status.INFO},Status.prototype.setSource=function(s){this.source=s},Status.prototype.toString=function(){return this.isOk()?"OK":this.message},Status.prototype.getExtra=function(name){return this.takeNodeFromSource&&name==tsInterfaces.SOURCE_EXTRA&&this.source instanceof TypeInformation?this.source.node():null},Status.prototype.putExtra=function(name,value){},Status.CODE_CONFLICTING_TYPE_KIND=4,Status.CODE_INCORRECT_DISCRIMINATOR=5,Status.CODE_MISSING_DISCRIMINATOR=6,Status.ERROR=3,Status.INFO=1,Status.OK=0,Status.WARNING=2,Status}();exports.Status=Status,exports.ok=ok,exports.SCHEMA_AND_TYPE=tsInterfaces.SCHEMA_AND_TYPE_EXTRA,exports.GLOBAL=tsInterfaces.GLOBAL_EXTRA,exports.TOPLEVEL=tsInterfaces.TOP_LEVEL_EXTRA,exports.SOURCE_EXTRA=tsInterfaces.SOURCE_EXTRA,exports.error=error;var TypeInformation=function(){function TypeInformation(_inheritable){this._inheritable=_inheritable}return TypeInformation.prototype.node=function(){return this._node},TypeInformation.prototype.setNode=function(node){this._node=node},TypeInformation.prototype.owner=function(){return this._owner},TypeInformation.prototype.isInheritable=function(){return this._inheritable},TypeInformation.prototype.validateSelf=function(registry){return ok()},TypeInformation.prototype.requiredTypes=function(){return[]},TypeInformation}();exports.TypeInformation=TypeInformation;var stack=null,Constraint=function(_super){function Constraint(_inheritable){void 0===_inheritable&&(_inheritable=!0),_super.call(this,_inheritable)}return __extends(Constraint,_super),Constraint.prototype.intersect=function(t0,t1){var nm=t0.id()+""+t1.id();if(Constraint.intersections.hasOwnProperty(nm))return Constraint.intersections[nm];var is=intersect(nm,[t0,t1]);return Constraint.intersections[nm]=is,is},Constraint.prototype.release=function(t){delete Constraint.intersections[t.name()]},Constraint.prototype.nothing=function(c,message){return void 0===message&&(message="Conflicting restrictions"),new NothingRestrictionWithLocation(stack,message,c)},Constraint.prototype.composeWith=function(r){return null},Constraint.prototype.preoptimize=function(){null===stack&&(stack=new RestrictionStackEntry(null,null,"top")),stack=stack.push(this);try{return this.innerOptimize()}finally{stack=stack.pop()}},Constraint.prototype.innerOptimize=function(){return this},Constraint.prototype.tryCompose=function(r){null===stack&&(stack=new RestrictionStackEntry(null,null,"top")),stack=stack.push(this);try{return this.composeWith(r)}finally{stack=stack.pop()}},Constraint.prototype.kind=function(){return tsInterfaces.MetaInformationKind.Constraint},Constraint.prototype.conflictMessage=function(otherPath,otherValue){return null},Constraint.intersections={},Constraint}(TypeInformation);exports.Constraint=Constraint;var restr=__webpack_require__(97),metaInfo=__webpack_require__(98),fr=__webpack_require__(96),restrictions_1=__webpack_require__(97),metainfo_1=__webpack_require__(98),metainfo_2=__webpack_require__(98),restrictions_2=__webpack_require__(97),restrictions_3=__webpack_require__(97),exO=__webpack_require__(137),metainfo_3=__webpack_require__(98),restrictions_4=__webpack_require__(97);exports.autoCloseFlag=!1;var TypeRegistry=function(){function TypeRegistry(_parent){void 0===_parent&&(_parent=null),this._parent=_parent,this._types={},this.typeList=[]}return TypeRegistry.prototype.put=function(alias,t){this._types[alias]=t},TypeRegistry.prototype.addType=function(t){
t.isAnonymous()||(this._types[t.name()]=t,this.typeList.push(t))},TypeRegistry.prototype.get=function(name){return this._types.hasOwnProperty(name)?this._types[name]:null!=this._parent?this._parent.get(name):null},TypeRegistry.prototype.types=function(){return this.typeList},TypeRegistry.prototype.typeMap=function(){return this._types},TypeRegistry.prototype.parent=function(){return this._parent},TypeRegistry}();exports.TypeRegistry=TypeRegistry;var PropertyCyclesValidator=function(){function PropertyCyclesValidator(){}return PropertyCyclesValidator.prototype.getInfos=function(t){if(t.getExtra("PInfos"))return t.getExtra("PInfos");var m={};return t.meta().forEach(function(x){if(x instanceof restr.HasProperty){var id=x.value();m[id]={name:id,type:null}}}),t.meta().forEach(function(x){if(x instanceof restr.PropertyIs){var id=x.propertyName();m[id]&&(m[id].type=x.value())}}),t.putExtra("PInfos",m),m},PropertyCyclesValidator.prototype.validate=function(t,visited){var _this=this,i=this.getInfos(t),result=!1;return Object.keys(i).forEach(function(x){result=result||_this.validateInfo(i[x],visited)}),result},PropertyCyclesValidator.prototype.validateInfo=function(t,visited){var _this=this;if(visited.some(function(y){return y==t}))return!0;if(t.type instanceof UnionType){var ut=t.type,passing=!0;return ut.options().forEach(function(o){_this.validate(o,[t].concat(visited))||(passing=!1)}),passing}return t.type.isArray()?void 0:this.validate(t.type,[t].concat(visited))},PropertyCyclesValidator.prototype.validateType=function(t){var _this=this,i=this.getInfos(t),result=[];return Object.keys(i).forEach(function(x){_this.validateInfo(i[x],[])&&result.push(x)}),result},PropertyCyclesValidator}(),RestrictionsConflict=function(_super){function RestrictionsConflict(_conflicting,_stack,source){_super.call(this,Status.ERROR,0,null,source),this._conflicting=_conflicting,this._stack=_stack,this.source=source,this.computeMessage()}return __extends(RestrictionsConflict,_super),RestrictionsConflict.prototype.computeMessage=function(){var conflictingMessage=null;if(null!=this._stack&&this._stack.getRestriction()instanceof restr.MinMaxRestriction){var mmr=this._stack.getRestriction();conflictingMessage=this._conflicting.conflictMessage(mmr.facetPath(),mmr.value())}null==conflictingMessage&&(conflictingMessage=this._conflicting+" and "+(null!=this._stack?this._stack.getRestriction().toString():""));var typeInfo="";if(this.source instanceof AbstractType){for(var path=[],rse=this._stack;rse;){var restri=rse.getRestriction();if(restri instanceof restrictions_2.PropertyIs){var vp={name:restri.propId()};path.length>0&&(vp.child=path[path.length-1]),path.push(vp)}rse=rse.pop()}this.setValidationPath(path.pop());var arc=restr.anotherRestrictionComponent();typeInfo=arc?" between types '"+typePath(this.source)+"' and '"+typePath(arc)+"'":" in type '"+typePath(this.source)+"'"}this.message="Restrictions conflict"+typeInfo+": "+conflictingMessage},RestrictionsConflict.prototype.getConflictDescription=function(){var rs="";return rs+="Restrictions coflict:\n",rs+=this._stack.getRestriction()+" conflicts with "+this._conflicting+"\n",rs+="at\n",rs+=this._stack.pop()},RestrictionsConflict.prototype.getConflicting=function(){return this._conflicting},RestrictionsConflict.prototype.getStack=function(){return this._stack},RestrictionsConflict.prototype.toRestriction=function(){return new NothingRestrictionWithLocation(this._stack,this.message,this._conflicting)},RestrictionsConflict}(Status);exports.RestrictionsConflict=RestrictionsConflict;var globalId=0;exports.VALIDATED_TYPE=null;var AbstractType=function(){function AbstractType(_name){this._name=_name,this.metaInfo=[],this._subTypes=[],this.innerid=globalId++,this.extras={},this._locked=!1}return AbstractType.prototype.getExtra=function(name){return this.extras[name]},AbstractType.prototype.putExtra=function(name,v){this.extras[name]=v},AbstractType.prototype.id=function(){return this.innerid},AbstractType.prototype.knownProperties=function(){return this.metaOfType(restrictions_4.MatchesProperty)},AbstractType.prototype.lock=function(){this._locked=!0},AbstractType.prototype.isLocked=function(){return this._locked},AbstractType.prototype.allFacets=function(){return this.meta()},AbstractType.prototype.declaredFacets=function(){return this.declaredMeta()},AbstractType.prototype.isSubTypeOf=function(t){return t===exports.ANY||this===t||this.superTypes().some(function(x){return x.isSubTypeOf(t)})},AbstractType.prototype.isSuperTypeOf=function(t){return this===t||-1!=this.allSubTypes().indexOf(t)},AbstractType.prototype.addMeta=function(info){this.metaInfo.push(info),info._owner=this},AbstractType.prototype.name=function(){return this._name},AbstractType.prototype.label=function(){return this._name},AbstractType.prototype.subTypes=function(){return this._subTypes},AbstractType.prototype.superTypes=function(){return[]},AbstractType.prototype.validateType=function(tr){var _this=this;void 0===tr&&(tr=builtInRegistry());var rs=new Status(Status.OK,0,"",this);if(this.validateHierarchy(rs),this.getExtra(tsInterfaces.PARSE_ERROR)&&rs.addSubStatus(this.getExtra(tsInterfaces.PARSE_ERROR)),rs.isOk()){if(rs.addSubStatus(this.checkConfluent()),this.isExternal()){var allS=this.allSuperTypes(),mma=allS.filter(function(x){return x instanceof ExternalType});this instanceof ExternalType&&mma.push(this),mma.forEach(function(x){if(x.isJSON())try{su.getJSONSchema(x.schema(),x.getContentProvider&&x.getContentProvider())}catch(e){rs.addSubStatus(new Status(Status.ERROR,0,e.message,_this))}})}rs.isOk()&&this.superTypes().forEach(function(x){x.isAnonymous()&&rs.addSubStatus(x.validateType(tr))})}if(this.getExtra(exports.SCHEMA_AND_TYPE)&&rs.addSubStatus(new Status(Status.ERROR,0,"'schema' and 'type' are mutually exclusive",this)),rs.isOk()&&this.validateMeta(tr).getErrors().forEach(function(x){return rs.addSubStatus(x)}),this.isObject()){var required={};this.restrictions().forEach(function(x){x.owner()!=_this&&x instanceof restr.HasProperty&&(required[x.value()]=!0)}),this.declaredMeta().forEach(function(x){x instanceof restr.HasProperty&&delete required[x.value()]}),this.declaredMeta().forEach(function(x){if(x instanceof restr.PropertyIs){var pr=x;required.hasOwnProperty(pr.propertyName())&&rs.addSubStatus(new Status(Status.ERROR,0,"Can not override required property '"+pr.propertyName()+"' to be optional",_this))}});var propertyCycles=(new PropertyCyclesValidator).validateType(this);propertyCycles.length>0&&propertyCycles.forEach(function(p){var st=new Status(Status.ERROR,0,"'"+p+"' has cyclic dependency",_this);st.setValidationPath({name:p}),rs.addSubStatus(st)})}return rs},AbstractType.prototype.validateHierarchy=function(rs){var _this=this;if(this.isAnonymous()||this.getExtra(tsInterfaces.TOP_LEVEL_EXTRA)&&builtInRegistry().get(this.name())&&rs.addSubStatus(new Status(Status.ERROR,0,"Redefining a built in type: "+this.name(),this)),this.isSubTypeOf(exports.RECURRENT)&&rs.addSubStatus(new Status(Status.ERROR,0,"Recurrent type definition",this),"type"),this.isSubTypeOf(exports.UNKNOWN)&&rs.addSubStatus(new Status(Status.ERROR,0,"Inheriting from unknown type",this),"type"),this.isUnion()){var tf=this.typeFamily();tf.some(function(x){return x.isSubTypeOf(exports.RECURRENT)})&&rs.addSubStatus(new Status(Status.ERROR,0,"Recurrent type as an option of union type",this),"type"),tf.some(function(x){return x.isSubTypeOf(exports.UNKNOWN)})&&rs.addSubStatus(new Status(Status.ERROR,0,"Unknown type as an option of union type",this),"type")}if(this.isArray()){var fs_1=this.familyWithArray(),ps=this.getExtra(tsInterfaces.HAS_ITEMS)?"items":"type";if(-1!=fs_1.indexOf(this)||fs_1.some(function(x){return x===exports.RECURRENT}))rs.addSubStatus(new Status(Status.ERROR,0,"Recurrent array type definition",this),ps);else if(fs_1.some(function(x){return x===exports.UNKNOWN})){var componentTypeName=this.oneMeta(restrictions_3.ComponentShouldBeOfType).value().name();rs.addSubStatus(new Status(Status.ERROR,0,"Referring to unknown type '"+componentTypeName+"' as an array component type",this),ps)}}var supers=this.superTypes(),hasExternal=!1,hasNotExternal=!1;if(supers.length>1&&supers.forEach(function(x){x.isExternal()?hasExternal=!0:hasNotExternal=!0}),hasExternal&&hasNotExternal&&rs.addSubStatus(new Status(Status.ERROR,0,"It is not allowed to mix RAML types with externals",this),"type"),this instanceof UnionType){var ut=this;ut.options().forEach(function(x){x.isExternal()&&rs.addSubStatus(new Status(Status.ERROR,0,"It is not allowed to mix RAML types with externals",_this),"type")})}if(this.isExternal()&&this.getExtra(tsInterfaces.HAS_FACETS)){var fs=new Status(Status.ERROR,0,"External types can not declare facet '"+this.getExtra(tsInterfaces.HAS_FACETS)+"'",this);fs.setValidationPath({name:this.getExtra(tsInterfaces.HAS_FACETS)}),rs.addSubStatus(fs)}},AbstractType.prototype.familyWithArray=function(){var ts=this.allSuperTypes(),mn=this.oneMeta(restrictions_3.ComponentShouldBeOfType);if(mn){var at=mn.value();ts=ts.concat(at.familyWithArray())}return ts},AbstractType.prototype.validateMeta=function(tr){var rs=new Status(Status.OK,0,"",this);return this.declaredMeta().forEach(function(x){x.validateSelf(tr).getErrors().forEach(function(y){return rs.addSubStatus(y)})}),this.validateFacets(rs),rs},AbstractType.prototype.validateFacets=function(rs){var _this=this,fds={},super_facets={},rfds={};this.meta().forEach(function(x){if(x instanceof metainfo_1.FacetDeclaration){var fd=x;fds[fd.actualName()]=fd,fd.isOptional()||fd.owner()!==_this&&(rfds[fd.actualName()]=fd),fd.owner()!=_this&&(super_facets[fd.actualName()]=fd)}}),this.declaredMeta().forEach(function(x){if(x instanceof metainfo_1.FacetDeclaration){var fd=x;if(fd.owner()==_this){var an=fd.actualName();super_facets.hasOwnProperty(an)&&rs.addSubStatus(new Status(Status.ERROR,0,"Facet '"+an+"' can not be overriden",_this));var fp=fr.getInstance().facetPrototypeWithName(an);(fp&&fp.isApplicable(_this)||"type"==an||"properties"==fd.facetName()||"schema"==an||"facets"==an||"uses"==an)&&rs.addSubStatus(new Status(Status.ERROR,0,"Built in facet '"+an+"' can not be overriden",_this)),"("==an.charAt(0)&&rs.addSubStatus(new Status(Status.ERROR,0,"Facet '"+an+"' can not start from '('",_this))}}});var knownPropertySet={};this.meta().forEach(function(x){x instanceof restrictions_2.PropertyIs&&(knownPropertySet[x.propId()]=!0)}),this.meta().forEach(function(x){if(x instanceof metainfo_2.CustomFacet){var cd=x;if(fds.hasOwnProperty(cd.facetName())){var ft=fds[cd.facetName()].value();rs.addSubStatus(ft.validateDirect(cd.value(),!1,!1)),delete rfds[cd.facetName()]}else{var msg=_this.isExternal()?"'"+cd.facetName()+"' facet is prohibited for external types":"Specifying unknown facet: '"+cd.facetName()+"'";rs.addSubStatus(new Status(Status.ERROR,0,msg,cd,!0))}}}),Object.getOwnPropertyNames(rfds).length>0&&rs.addSubStatus(new Status(Status.ERROR,0,"Missing required facets: "+Object.keys(rfds).map(function(x){return"'"+x+"'"}).join(","),this))},AbstractType.prototype.allSuperTypes=function(){var rs=[];return this.fillSuperTypes(rs),rs},AbstractType.prototype.fillSuperTypes=function(r){this.superTypes().forEach(function(x){_.contains(r,x)||(r.push(x),x.fillSuperTypes(r))})},AbstractType.prototype.allSubTypes=function(){var rs=[];return this.fillSubTypes(rs),rs},AbstractType.prototype.fillSubTypes=function(r){this.subTypes().forEach(function(x){_.contains(r,x)||(r.push(x),x.fillSubTypes(r))})},AbstractType.prototype.inherit=function(name){var rs=new InheritedType(name);return rs.addSuper(this),rs},AbstractType.prototype.isAnonymous=function(){return!this._name||0===this._name.length},AbstractType.prototype.isEmpty=function(){return this.metaInfo.length>2?!1:0==this.metaInfo.filter(function(x){return x instanceof metainfo_3.NotScalar?!1:x instanceof metaInfo.DiscriminatorValue?x.isStrict():!0}).length},AbstractType.prototype.isArray=function(){return this===exports.ARRAY||-1!=this.allSuperTypes().indexOf(exports.ARRAY)},AbstractType.prototype.propertySet=function(){var rs=[];return this.meta().forEach(function(x){if(x instanceof restrictions_2.PropertyIs){var p=x;rs.push(p.propertyName())}}),_.uniq(rs)},AbstractType.prototype.checkConfluent=function(){if(this.computeConfluent)return ok();this.computeConfluent=!0;var arcc=restr.anotherRestrictionComponentsCount();try{var os=restr.optimize(this.restrictions()),ns=_.find(os,function(x){return x instanceof NothingRestriction});if(ns){var lstack=null,another=null;if(ns instanceof NothingRestrictionWithLocation){var nswl=ns;lstack=nswl.getStack(),another=nswl.another()}var status=new RestrictionsConflict(another,lstack,this);return status}return ok()}finally{this.computeConfluent=!1,restr.releaseAnotherRestrictionComponent(arcc)}},AbstractType.prototype.isObject=function(){return this==exports.OBJECT||-1!=this.allSuperTypes().indexOf(exports.OBJECT)},AbstractType.prototype.isExternal=function(){return this==exports.EXTERNAL||-1!=this.allSuperTypes().indexOf(exports.EXTERNAL)},AbstractType.prototype.isBoolean=function(){return this==exports.BOOLEAN||-1!=this.allSuperTypes().indexOf(exports.BOOLEAN)},AbstractType.prototype.isString=function(){return this==exports.STRING||-1!=this.allSuperTypes().indexOf(exports.STRING)},AbstractType.prototype.isNumber=function(){return this==exports.NUMBER||-1!=this.allSuperTypes().indexOf(exports.NUMBER)},AbstractType.prototype.isFile=function(){return this==exports.FILE||-1!=this.allSuperTypes().indexOf(exports.FILE)},AbstractType.prototype.isScalar=function(){return this==exports.SCALAR||-1!=this.allSuperTypes().indexOf(exports.SCALAR)},AbstractType.prototype.isDateTime=function(){return this==exports.DATETIME||-1!=this.allSuperTypes().indexOf(exports.DATETIME)},AbstractType.prototype.isDateOnly=function(){return this==exports.DATE_ONLY||-1!=this.allSuperTypes().indexOf(exports.DATE_ONLY)},AbstractType.prototype.isTimeOnly=function(){return this==exports.TIME_ONLY||-1!=this.allSuperTypes().indexOf(exports.TIME_ONLY)},AbstractType.prototype.isInteger=function(){return this==exports.INTEGER||-1!=this.allSuperTypes().indexOf(exports.INTEGER)},AbstractType.prototype.isDateTimeOnly=function(){return this==exports.DATETIME_ONLY||-1!=this.allSuperTypes().indexOf(exports.DATETIME_ONLY)},AbstractType.prototype.isUnknown=function(){return this==exports.UNKNOWN||-1!=this.allSuperTypes().indexOf(exports.UNKNOWN)},AbstractType.prototype.isRecurrent=function(){return this==exports.RECURRENT||-1!=this.allSuperTypes().indexOf(exports.RECURRENT)},AbstractType.prototype.isBuiltin=function(){return-1!=this.metaInfo.indexOf(BUILT_IN)},AbstractType.prototype.exampleObject=function(){return exO.example(this)},AbstractType.prototype.isPolymorphic=function(){return this.meta().some(function(x){return x instanceof Polymorphic})},AbstractType.prototype.restrictions=function(forValidation){if(void 0===forValidation&&(forValidation=!1),this.isUnion()){var rs=[];return this.superTypes().forEach(function(x){rs=rs.concat(x.restrictions())}),rs=rs.concat(this.meta().filter(function(x){return x instanceof Constraint}))}var result=[],generic=null;return this.meta().forEach(function(x){if(x instanceof Constraint){if(x instanceof GenericTypeOf&&forValidation){if(generic)return;generic=x}result.push(x)}}),result},AbstractType.prototype.customFacets=function(){return this.declaredMeta().filter(function(x){return x instanceof metaInfo.CustomFacet})},AbstractType.prototype.allCustomFacets=function(){return this.meta().filter(function(x){return x instanceof metaInfo.CustomFacet})},AbstractType.prototype.isUnion=function(){var rs=!1;return this.isBuiltin()?!1:(this.allSuperTypes().forEach(function(x){return rs=rs||x instanceof UnionType}),rs)},AbstractType.prototype.meta=function(){return[].concat(this.metaInfo)},AbstractType.prototype.validateDirect=function(i,autoClose,nullAllowed,path){var _this=this;void 0===autoClose&&(autoClose=!1),void 0===nullAllowed&&(nullAllowed=!0),void 0===path&&(path=null);var prevValidated=exports.VALIDATED_TYPE;try{var g=exports.autoCloseFlag;autoClose&&(exports.autoCloseFlag=!0),exports.VALIDATED_TYPE=this;var result=new Status(Status.OK,0,"",this);if(!(nullAllowed||null!==i&&void 0!==i||this.nullable))return error("object is expected",this);if(this.restrictions(!0).forEach(function(x){return result.addSubStatus(x.check(i,path))}),(autoClose||exports.autoCloseFlag)&&this.isObject()&&!this.oneMeta(restrictions_1.KnownPropertyRestriction)){var cp=new restrictions_1.KnownPropertyRestriction(!1);cp.patchOwner(this),cp.check(i).getErrors().forEach(function(x){var rs=new Status(Status.WARNING,0,x.getMessage(),_this);rs.setValidationPath(x.getValidationPath()),result.addSubStatus(rs)})}}finally{exports.autoCloseFlag=g,exports.VALIDATED_TYPE=prevValidated}return result},AbstractType.prototype.validate=function(i,autoClose,nullAllowed){void 0===autoClose&&(autoClose=!1),void 0===nullAllowed&&(nullAllowed=!0);var g=exports.autoCloseFlag;if(!(nullAllowed||null!==i&&void 0!==i||this.nullable))return error("Null or undefined value is not allowed",this);autoClose&&(exports.autoCloseFlag=!0);try{for(var lastStatus,statuses=[],queue=this.subTypes().concat(this),_i=0,queue_1=queue;_i<queue_1.length;_i++){var subType=queue_1[_i],dStatus=checkDescriminator(i,subType),vr=subType.validateDirect(i,autoClose||g);if(dStatus){if(dStatus.isOk())return vr;statuses.push(dStatus)}else if(vr.isOk())return vr;lastStatus=vr}if(0==statuses.length)return lastStatus;var result=ok();return statuses.forEach(function(x){return result.addSubStatus(x)}),statuses.pop()}finally{exports.autoCloseFlag=g}},AbstractType.prototype.declareMapProperty=function(name,type){return null!=type&&this.addMeta(new restr.MapPropertyIs(name,type)),type},AbstractType.prototype.closeUnknownProperties=function(){this.addMeta(new restrictions_1.KnownPropertyRestriction(!1))},AbstractType.prototype.canDoAc=function(){for(var tf=_.uniq(this.typeFamily()),s=new Status(Status.OK,0,"",this),i=0;i<tf.length;i++)for(var j=0;j<tf.length;j++)if(i!=j){var t0=tf[i],t1=tf[j],ed=this.emptyIntersectionOrDiscriminator(t0,t1);s.addSubStatus(ed)}return s},AbstractType.prototype.emptyIntersectionOrDiscriminator=function(t0,t1){if(t1===t0)return ok();if(t1.isScalar()&&t0.isScalar())return ok();var it=intersect("",[t0,t1]),innerCheckConfluent=it.checkConfluent();return innerCheckConfluent.isOk()?this.checkDiscriminator(t0,t1):ok()},AbstractType.prototype.checkDiscriminator=function(t1,t2){var found=new Status(Status.ERROR,0,"Can not discriminate types '"+t1.name()+"' and '"+t2.name()+"' without discriminator",this),oneMeta=t1.oneMeta(metaInfo.Discriminator),anotherMeta=t2.oneMeta(metaInfo.Discriminator);if(null!=oneMeta&&null!=anotherMeta&&oneMeta.value()===anotherMeta.value()){var d1=t1.name(),d2=t2.name(),dv1=t1.oneMeta(metaInfo.DiscriminatorValue);null!=dv1&&(d1=dv1.value());var dv2=t2.oneMeta(metaInfo.DiscriminatorValue);if(null!=dv2&&(d2=dv2.value()),d1!==d2)return ok();found=new Status(Status.ERROR,0,"Types '"+t1.name()+"' and '"+t2.name()+"' have same discriminator value",this)}return found},AbstractType.prototype.ac=function(obj){if(!this.isPolymorphic()&&!this.isUnion())return this;if(this.isBuiltin())return this;var tf=_.uniq(this.typeFamily());if(0==tf.length)return exports.NOTHING;if(this.isScalar())return this.isNumber()?"number"==typeof obj?this:exports.NOTHING:this.isString()?"string"==typeof obj?this:exports.NOTHING:this.isBoolean()?"boolean"==typeof obj?this:exports.NOTHING:this;if(1===tf.length)return tf[0];var options=[];tf.forEach(function(x){var ds=x.validateDirect(obj,!0);ds.isOk()&&options.push(x)});var t=this.discriminate(obj,options);return t?t:exports.NOTHING},AbstractType.prototype.declareProperty=function(name,t,optional){return optional||this.addMeta(new restr.HasProperty(name)),null!=t&&this.addMeta(new restr.PropertyIs(name,t)),this},AbstractType.prototype.discriminate=function(obj,opt){for(var newOpts=[].concat(opt),opts=[].concat(opt);newOpts.length>1;){var found=!1;l2:for(var i=0;i<opts.length;i++)for(var j=0;j<opts.length;j++){var t0=opts[i],t1=opts[j];if(t0!=t1){var nt=select(obj,t0,t1);if(nt===t0){opts=opts.filter(function(x){return x!=t1}),found=!0;break l2}if(nt===t1){opts=opts.filter(function(x){return x!=t0}),found=!0;break l2}opts=opts.filter(function(x){return x!=t0&&x!=t1}),found=!0;break l2}}newOpts=opts}return 1==newOpts.length?newOpts[0]:null},AbstractType.prototype.oneMeta=function(clazz){return _.find(this.meta(),function(x){return x instanceof clazz})},AbstractType.prototype.metaOfType=function(clazz){return this.meta().filter(function(x){return x instanceof clazz})},AbstractType.prototype.declaredMeta=function(){return this.metaInfo},AbstractType.prototype.descValue=function(){var dv=this.oneMeta(metaInfo.DiscriminatorValue);return dv?dv.value():this.name()},AbstractType.prototype.isAbstractOrInternal=function(){return this.metaInfo.some(function(x){return x instanceof Abstract||x instanceof Internal})},AbstractType.prototype.typeFamily=function(){if(this.isUnion()){var res=[];return this.allSuperTypes().forEach(function(x){if(x instanceof UnionType)for(var opts=x.allOptions(),i=0;i<opts.length;i++)res=res.concat(opts[i].typeFamily())}),_.unique(res)}var rs=[];return this.isAbstractOrInternal()||rs.push(this),this.allSubTypes().forEach(function(x){x.isAbstractOrInternal()||rs.push(x)}),_.unique(rs)},AbstractType.prototype.hasPropertiesFacet=function(){return this.metaInfo.some(function(x){return x instanceof metaInfo.HasPropertiesFacet})},AbstractType}();exports.AbstractType=AbstractType;var Modifier=function(_super){function Modifier(){_super.apply(this,arguments)}return __extends(Modifier,_super),Modifier.prototype.requiredType=function(){return exports.ANY},Modifier.prototype.kind=function(){return tsInterfaces.MetaInformationKind.Modifier},Modifier}(TypeInformation);exports.Modifier=Modifier;var Polymorphic=function(_super){function Polymorphic(){_super.call(this,!0)}return __extends(Polymorphic,_super),Polymorphic.prototype.facetName=function(){return"polymorphic"},Polymorphic.prototype.value=function(){return!0},Polymorphic}(Modifier);exports.Polymorphic=Polymorphic;var Abstract=function(_super){function Abstract(){_super.call(this,!1)}return __extends(Abstract,_super),Abstract.prototype.value=function(){return!0},Abstract.prototype.facetName=function(){return"abstract"},Abstract}(Modifier);exports.Abstract=Abstract;var Internal=function(_super){function Internal(){_super.call(this,!1)}return __extends(Internal,_super),Internal.prototype.facetName=function(){return"abstract"},Internal.prototype.value=function(){return!0},Internal}(Modifier);exports.Internal=Internal;var BuiltIn=function(_super){function BuiltIn(){_super.call(this,!1)}return __extends(BuiltIn,_super),BuiltIn.prototype.facetName=function(){return"builtIn"},BuiltIn.prototype.value=function(){return!0},BuiltIn}(Modifier),BUILT_IN=new BuiltIn,RootType=function(_super){function RootType(){_super.apply(this,arguments)}return __extends(RootType,_super),RootType.prototype.kind=function(){return"root"},RootType}(AbstractType);exports.RootType=RootType;var InheritedType=function(_super){function InheritedType(){_super.apply(this,arguments),this._superTypes=[]}return __extends(InheritedType,_super),InheritedType.prototype.superTypes=function(){return this._superTypes},InheritedType.prototype.knownProperties=function(){var vs=this.metaOfType(restrictions_4.MatchesProperty);return this.superTypes().forEach(function(x){vs=vs.concat(x.knownProperties())}),vs},InheritedType.prototype.kind=function(){return"inherited"},InheritedType.prototype.meta=function(){var _this=this,rs=_super.prototype.meta.call(this),hasKp=!1;return this.superTypes().forEach(function(x){x.meta().forEach(function(m){if(m instanceof restrictions_1.KnownPropertyRestriction){if(hasKp)return;var kp=new restrictions_1.KnownPropertyRestriction(!1);return kp.patchOwner(_this),void rs.push(kp)}m.isInheritable()&&rs.push(m)})}),rs},InheritedType.prototype.addSuper=function(t){this._superTypes.push(t),t.isLocked()||t._subTypes.push(this),t.nullable&&(this.nullable=!0)},InheritedType.prototype.label=function(){var cmp=this.metaOfType(restrictions_3.ComponentShouldBeOfType);return cmp.length>0?cmp[0].value().label()+"[]":_super.prototype.label.call(this)},InheritedType.prototype.contextMeta=function(){return this._contextMeta},InheritedType.prototype.setContextMeta=function(contextMeta){this._contextMeta=contextMeta},InheritedType.prototype.patch=function(another){for(var prop in another)another.hasOwnProperty(prop)&&(this[prop]=another[prop])},InheritedType}(AbstractType);exports.InheritedType=InheritedType;var DerivedType=function(_super){function DerivedType(name,_options){_super.call(this,name),this._options=_options}return __extends(DerivedType,_super),DerivedType.prototype.allOptions=function(){var _this=this,rs=[];return this._options.forEach(function(x){x.kind()==_this.kind()?rs=rs.concat(x.allOptions()):rs.push(x)}),_.unique(rs)},DerivedType.prototype.options=function(){return this._options},DerivedType}(AbstractType);exports.DerivedType=DerivedType;var UnionType=function(_super){function UnionType(name,_options){var _this=this;_super.call(this,name,_options),this.options().forEach(function(x){x.nullable&&(_this.nullable=!0)})}return __extends(UnionType,_super),UnionType.prototype.kind=function(){return"union"},UnionType.prototype.isSubTypeOf=function(t){var isSubType=!0;return this.allOptions().forEach(function(x){x.isSubTypeOf(t)||(isSubType=!1)}),isSubType},UnionType.prototype.validate=function(i){return this.validateDirect(i)},UnionType.prototype.typeFamily=function(){var res=[];return this.allOptions().forEach(function(x){res=res.concat(x.typeFamily())}),res},UnionType.prototype.knownProperties=function(){var vs=this.metaOfType(restrictions_4.MatchesProperty);return this.options().forEach(function(x){vs=vs.concat(x.knownProperties())}),vs},UnionType.prototype.validateDirect=function(i,autoClose){void 0===autoClose&&(autoClose=!1);var result=new Status(Status.OK,0,"",this);return this.restrictions().forEach(function(x){return result.addSubStatus(x.check(i,null))}),result},UnionType.prototype.isUnion=function(){return!0},UnionType.prototype.restrictions=function(){return[new OrRestriction(this.allOptions().map(function(x){return new AndRestriction(x.restrictions())}),"Union type options do not pass validation","Union type option does not pass validation")]},UnionType.prototype.label=function(){return this.options().map(function(x){return x.label()}).join("|")},UnionType}(DerivedType);exports.UnionType=UnionType;var IntersectionType=function(_super){function IntersectionType(){_super.apply(this,arguments)}return __extends(IntersectionType,_super),IntersectionType.prototype.kind=function(){return"intersection"},IntersectionType.prototype.restrictions=function(){var rs=[];return this.allOptions().forEach(function(x){return rs=rs.concat(x.restrictions())}),[new AndRestriction(rs)]},IntersectionType.prototype.label=function(){return this.options().map(function(x){return x.label()}).join("&")},IntersectionType}(DerivedType);exports.IntersectionType=IntersectionType;var registry=new TypeRegistry;exports.builtInRegistry=builtInRegistry,exports.union=union,exports.intersect=intersect,exports.derive=derive,exports.deriveObjectType=deriveObjectType;var NothingRestriction=function(_super){function NothingRestriction(){_super.apply(this,arguments)}return __extends(NothingRestriction,_super),NothingRestriction.prototype.check=function(i){return null===i||void 0===i?ok():error("nothing ",this)},NothingRestriction.prototype.requiredType=function(){return exports.ANY},NothingRestriction.prototype.facetName=function(){return"nothing"},NothingRestriction.prototype.value=function(){return"!!!"},NothingRestriction}(Constraint);exports.NothingRestriction=NothingRestriction;var RestrictionStackEntry=function(){function RestrictionStackEntry(_previous,_restriction,id){this._previous=_previous,this._restriction=_restriction,this.id=id}return RestrictionStackEntry.prototype.getRestriction=function(){return this._restriction},RestrictionStackEntry.prototype.pop=function(){return this._previous},RestrictionStackEntry.prototype.push=function(r){return new RestrictionStackEntry(this,r,r.toString())},RestrictionStackEntry}();exports.RestrictionStackEntry=RestrictionStackEntry;var NothingRestrictionWithLocation=function(_super){function NothingRestrictionWithLocation(_entry,_message,_another){_super.call(this),this._entry=_entry,this._message=_message,this._another=_another}return __extends(NothingRestrictionWithLocation,_super),NothingRestrictionWithLocation.prototype.getMessage=function(){return this._message},NothingRestrictionWithLocation.prototype.getStack=function(){return this._entry},NothingRestrictionWithLocation.prototype.another=function(){return this._another},NothingRestrictionWithLocation}(NothingRestriction);exports.NothingRestrictionWithLocation=NothingRestrictionWithLocation;var GenericTypeOf=function(_super){function GenericTypeOf(){_super.apply(this,arguments)}return __extends(GenericTypeOf,_super),GenericTypeOf}(Constraint);exports.GenericTypeOf=GenericTypeOf;var TypeOfRestriction=function(_super){function TypeOfRestriction(val){_super.call(this),this.val=val}return __extends(TypeOfRestriction,_super),TypeOfRestriction.prototype.check=function(i){var to=typeof i;return null===i||void 0===i?ok():(Array.isArray(i)&&(to="array"),to===this.val?ok():error(this.val+" is expected",this))},TypeOfRestriction.prototype.value=function(){return this.val},TypeOfRestriction.prototype.requiredType=function(){return exports.ANY},TypeOfRestriction.prototype.facetName=function(){return"typeOf"},TypeOfRestriction.prototype.composeWith=function(r){if(r instanceof TypeOfRestriction){var to=r;return to.val==this.val?this:this.nothing(r)}return null},TypeOfRestriction.prototype.toString=function(){return"should be of type "+this.val},TypeOfRestriction}(GenericTypeOf);exports.TypeOfRestriction=TypeOfRestriction;var IntegerRestriction=function(_super){function IntegerRestriction(){_super.call(this)}return __extends(IntegerRestriction,_super),IntegerRestriction.prototype.check=function(i){return"number"==typeof i&&is_int(i)?ok():error("integer is expected",this)},IntegerRestriction.prototype.requiredType=function(){return exports.ANY},IntegerRestriction.prototype.value=function(){return!0},IntegerRestriction.prototype.facetName=function(){return"should be integer"},IntegerRestriction}(GenericTypeOf);exports.IntegerRestriction=IntegerRestriction;var NullRestriction=function(_super){function NullRestriction(){_super.call(this)}return __extends(NullRestriction,_super),NullRestriction.prototype.check=function(i){return null===i||void 0==i||"null"===i?ok():error("null is expected",this)},NullRestriction.prototype.requiredType=function(){return exports.ANY},NullRestriction.prototype.value=function(){return!0},NullRestriction.prototype.facetName=function(){return"should be null"},NullRestriction}(GenericTypeOf);exports.NullRestriction=NullRestriction;var ScalarRestriction=function(_super){function ScalarRestriction(){_super.call(this)}return __extends(ScalarRestriction,_super),ScalarRestriction.prototype.check=function(i){return i?"number"==typeof i||"boolean"==typeof i||"string"==typeof i?ok():error("scalar is expected",this):ok()},ScalarRestriction.prototype.requiredType=function(){return exports.ANY},ScalarRestriction.prototype.facetName=function(){return"should be scalar"},ScalarRestriction.prototype.value=function(){return!0},ScalarRestriction}(GenericTypeOf);exports.ScalarRestriction=ScalarRestriction;var OrRestriction=function(_super){function OrRestriction(val,_extraMessage,_extraOptionMessage){_super.call(this),this.val=val,this._extraMessage=_extraMessage,this._extraOptionMessage=_extraOptionMessage}return __extends(OrRestriction,_super),OrRestriction.prototype.check=function(i,p){
for(var _this=this,cs=new Status(Status.OK,0,"",this),results=[],j=0;j<this.val.length;j++){var m=this.val[j].check(i,p);if(m.isOk())return ok();results.push(m)}if(results.length>0){for(var _i=0,results_1=results;_i<results_1.length;_i++){var r=results_1[_i],ownerName=null,src=r.getSource();if(src instanceof TypeInformation){var owner=src.owner();owner&&(ownerName=owner.label())}r.getErrors().forEach(function(x){var msg=x.getMessage();ownerName&&(msg=ownerName+": "+msg),_this._extraOptionMessage&&(msg=_this._extraOptionMessage+" ("+msg+")"),x.setMessage(msg),cs.addSubStatus(x)})}if(this._extraMessage){var severity=0;results.forEach(function(x){return severity=Math.max(severity,x.getSeverity())}),cs.addSubStatus(new Status(severity,0,this._extraMessage,this))}}return cs},OrRestriction.prototype.value=function(){return this.val.map(function(x){return x.value()})},OrRestriction.prototype.requiredType=function(){return exports.ANY},OrRestriction.prototype.facetName=function(){return"or"},OrRestriction}(Constraint);exports.OrRestriction=OrRestriction;var AndRestriction=function(_super){function AndRestriction(val){_super.call(this),this.val=val}return __extends(AndRestriction,_super),AndRestriction.prototype.value=function(){return this.val.map(function(x){return x.value()})},AndRestriction.prototype.options=function(){return this.val},AndRestriction.prototype.check=function(i,p){for(var j=0;j<this.val.length;j++){var st=this.val[j].check(i,p);if(!st.isOk())return st}return ok()},AndRestriction.prototype.requiredType=function(){return exports.ANY},AndRestriction.prototype.facetName=function(){return"and"},AndRestriction}(Constraint);exports.AndRestriction=AndRestriction,exports.ANY=new RootType("any"),exports.SCALAR=exports.ANY.inherit("scalar"),exports.OBJECT=exports.ANY.inherit("object"),exports.ARRAY=exports.ANY.inherit("array"),exports.NIL=exports.ANY.inherit("nil"),exports.EXTERNAL=exports.ANY.inherit("external"),exports.NUMBER=exports.SCALAR.inherit("number"),exports.INTEGER=exports.NUMBER.inherit("integer"),exports.BOOLEAN=exports.SCALAR.inherit("boolean"),exports.STRING=exports.SCALAR.inherit("string"),exports.DATE_ONLY=exports.SCALAR.inherit("date-only"),exports.TIME_ONLY=exports.SCALAR.inherit("time-only"),exports.DATETIME_ONLY=exports.SCALAR.inherit("datetime-only"),exports.DATETIME=exports.SCALAR.inherit("datetime"),exports.FILE=exports.SCALAR.inherit("file"),exports.NOTHING=new RootType("nothing"),exports.UNION=exports.ANY.inherit("union"),exports.UNKNOWN=exports.NOTHING.inherit("unknown"),exports.REFERENCE=exports.NOTHING.inherit("reference"),exports.RECURRENT=exports.NOTHING.inherit("recurrent"),exports.ANY.addMeta(BUILT_IN),exports.NIL.addMeta(BUILT_IN),exports.UNION.addMeta(BUILT_IN),exports.SCALAR.addMeta(BUILT_IN),exports.OBJECT.addMeta(BUILT_IN),exports.ARRAY.addMeta(BUILT_IN),exports.NUMBER.addMeta(BUILT_IN),exports.INTEGER.addMeta(BUILT_IN),exports.BOOLEAN.addMeta(BUILT_IN),exports.STRING.addMeta(BUILT_IN),exports.EXTERNAL.addMeta(BUILT_IN),exports.UNKNOWN.addMeta(BUILT_IN),exports.RECURRENT.addMeta(BUILT_IN),exports.DATE_ONLY.addMeta(BUILT_IN),exports.TIME_ONLY.addMeta(BUILT_IN),exports.DATETIME_ONLY.addMeta(BUILT_IN),exports.DATETIME.addMeta(BUILT_IN),exports.FILE.addMeta(BUILT_IN),exports.UNKNOWN.addMeta(BUILT_IN),exports.UNKNOWN.lock(),exports.RECURRENT.addMeta(BUILT_IN),exports.RECURRENT.lock(),exports.EXTERNAL.lock(),exports.UNION.lock(),registry.addType(exports.ANY),registry.addType(exports.SCALAR),registry.addType(exports.OBJECT),registry.addType(exports.ARRAY),registry.addType(exports.NUMBER),registry.addType(exports.INTEGER),registry.addType(exports.BOOLEAN),registry.addType(exports.NIL),registry.addType(exports.STRING),registry.addType(exports.DATE_ONLY),registry.addType(exports.TIME_ONLY),registry.addType(exports.DATETIME_ONLY),registry.addType(exports.DATETIME),registry.addType(exports.FILE),exports.NOTHING.addMeta(new NothingRestriction),exports.NUMBER.addMeta(new TypeOfRestriction("number")),exports.NUMBER.addMeta(new metainfo_1.FacetDeclaration("format",exports.STRING,!0)),exports.BOOLEAN.addMeta(new TypeOfRestriction("boolean")),exports.OBJECT.addMeta(new TypeOfRestriction("object")),exports.ARRAY.addMeta(new TypeOfRestriction("array")),exports.STRING.addMeta(new TypeOfRestriction("string")),exports.INTEGER.addMeta(new IntegerRestriction),exports.NIL.addMeta(new NullRestriction);var dt=__webpack_require__(138);exports.DATE_ONLY.addMeta(new dt.DateOnlyR),exports.TIME_ONLY.addMeta(new dt.TimeOnlyR),exports.DATETIME_ONLY.addMeta(new dt.DateTimeOnlyR),exports.DATETIME.addMeta(new dt.DateTimeR),exports.FILE.addMeta(new TypeOfRestriction("string"));var arrayOfString=exports.ARRAY.inherit("");arrayOfString.addMeta(new restrictions_3.ComponentShouldBeOfType(exports.STRING)),exports.FILE.addMeta(new metainfo_1.FacetDeclaration("fileTypes",arrayOfString,!0)),exports.FILE.addMeta(new metainfo_1.FacetDeclaration("minLength",exports.INTEGER,!0)),exports.FILE.addMeta(new metainfo_1.FacetDeclaration("maxLength",exports.INTEGER,!0)),exports.DATETIME.addMeta(new metainfo_1.FacetDeclaration("format",exports.STRING,!0)),exports.NIL.nullable=!0,exports.SCALAR.addMeta(new ScalarRestriction),registry.types().forEach(function(x){return x.lock()});var ExternalType=function(_super){function ExternalType(name,_content,json,provider){_super.call(this,name),this._content=_content,this.json=json,this.provider=provider,this.addMeta(new restr.MatchToSchema(_content,provider)),this.addSuper(exports.EXTERNAL)}return __extends(ExternalType,_super),ExternalType.prototype.getContentProvider=function(){return this.provider},ExternalType.prototype.setContentProvider=function(provider){this.provider=provider},ExternalType.prototype.kind=function(){return"external"},ExternalType.prototype.isJSON=function(){return this.json},ExternalType.prototype.schema=function(){return this._content},ExternalType}(InheritedType);exports.ExternalType=ExternalType,exports.typePath=typePath},function(module,exports,__webpack_require__){"use strict";exports.REPEAT="repeat",exports.PARSE_ERROR="parseError",exports.TOP_LEVEL_EXTRA="topLevel",exports.DEFINED_IN_TYPES_EXTRA="definedInTypes",exports.USER_DEFINED_EXTRA="USER_DEFINED",exports.SOURCE_EXTRA="SOURCE",exports.SCHEMA_AND_TYPE_EXTRA="SCHEMA",exports.GLOBAL_EXTRA="GLOBAL",exports.HAS_FACETS="HAS_FACETS",exports.HAS_ITEMS="HAS_ITEMS",function(MetaInformationKind){MetaInformationKind[MetaInformationKind.Description=0]="Description",MetaInformationKind[MetaInformationKind.NotScalar=1]="NotScalar",MetaInformationKind[MetaInformationKind.DisplayName=2]="DisplayName",MetaInformationKind[MetaInformationKind.Usage=3]="Usage",MetaInformationKind[MetaInformationKind.Annotation=4]="Annotation",MetaInformationKind[MetaInformationKind.FacetDeclaration=5]="FacetDeclaration",MetaInformationKind[MetaInformationKind.CustomFacet=6]="CustomFacet",MetaInformationKind[MetaInformationKind.Example=7]="Example",MetaInformationKind[MetaInformationKind.Required=8]="Required",MetaInformationKind[MetaInformationKind.HasPropertiesFacet=9]="HasPropertiesFacet",MetaInformationKind[MetaInformationKind.AllowedTargets=10]="AllowedTargets",MetaInformationKind[MetaInformationKind.Examples=11]="Examples",MetaInformationKind[MetaInformationKind.XMLInfo=12]="XMLInfo",MetaInformationKind[MetaInformationKind.Default=13]="Default",MetaInformationKind[MetaInformationKind.Constraint=14]="Constraint",MetaInformationKind[MetaInformationKind.Modifier=15]="Modifier",MetaInformationKind[MetaInformationKind.Discriminator=16]="Discriminator",MetaInformationKind[MetaInformationKind.DiscriminatorValue=17]="DiscriminatorValue"}(exports.MetaInformationKind||(exports.MetaInformationKind={}));exports.MetaInformationKind},function(module,exports,__webpack_require__){"use strict";function parseJSON(name,n,r,provider){return void 0===r&&(r=ts.builtInRegistry()),parse(name,new JSObjectNode(null,n,!1,provider),r)}function parseJSONTypeCollection(n,r,provider){return void 0===r&&(r=ts.builtInRegistry()),parseTypeCollection(new JSObjectNode(null,n,!1,provider),r)}function endsWithQuestionMark(p){return"?"==p.charAt(p.length-1)}function parseTypes(n,tr){void 0===tr&&(tr=ts.builtInRegistry());var provider=n.provider&&n.provider();return parseTypeCollection(new JSObjectNode(null,n,!1,provider),tr)}function transformToArray(n){return new WrapArrayNode(n)}function parseTypeCollection(n,tr){var result=new TypeCollection;if(n.anchor){if(n.anchor().__$$)return n.anchor().__$$;n.anchor().__$$=result}var tpes=n.childWithKey("types");tpes&&tpes.kind()===NodeKind.ARRAY&&(tpes=transformToArray(tpes));var schemas=n.childWithKey("schemas");schemas&&schemas.kind()===NodeKind.ARRAY&&(schemas=transformToArray(schemas));var reg=new AccumulatingRegistry(tpes,schemas,tr,result);tpes&&tpes.kind()!==NodeKind.SCALAR&&tpes.children().filter(function(x){return x.key()&&!0}).forEach(function(x){var t=ts.derive(x.key(),[ts.REFERENCE]);result.add(t),reg.addType(t)}),schemas&&schemas.kind()!==NodeKind.SCALAR&&schemas.children().filter(function(x){return x.key()&&!0}).forEach(function(x){var t=ts.derive(x.key(),[ts.REFERENCE]);result.add(t),reg.addType(t)});var uses=n.childWithKey("uses");uses&&uses.kind()===NodeKind.ARRAY&&(uses=transformToArray(uses)),uses&&uses.kind()===NodeKind.MAP&&uses.children().forEach(function(c){result.addLibrary(c.key(),parseTypeCollection(c,tr))}),tpes&&tpes.kind()!==NodeKind.SCALAR&&tpes.children().filter(function(x){return x.key()&&!0}).forEach(function(x){reg.get(x.key())}),schemas&&schemas.kind()!==NodeKind.SCALAR&&schemas.children().filter(function(x){return x.key()&&!0}).forEach(function(x){reg.get(x.key())}),reg.types().forEach(function(x){return result.add(x)});var tpes=n.childWithKey("annotationTypes");return tpes&&tpes.kind()===NodeKind.ARRAY&&(tpes=transformToArray(tpes)),null!=tpes&&tpes.kind()===NodeKind.MAP&&tpes.children().forEach(function(x){result.addAnnotationType(parse(x.key(),x,reg,!1,!0,!1))}),result}function parsePropertyBean(n,tr){var result=new PropertyBean,hasRequiredFacet=!1,rs=n.childWithKey("required");if(rs){var rsValue=rs.value();"boolean"==typeof rsValue&&(hasRequiredFacet=!0),rsValue===!1&&(result.optional=!0,result.id=n.key())}var name=n.key();return!hasRequiredFacet&&endsWithQuestionMark(n.key())&&(name=name.substr(0,name.length-1),result.optional=!0),0==name.length||"/.*/"===name?result.additonal=!0:"/"==name.charAt(0)&&"/"==name.charAt(name.length-1)&&(name=name.substring(1,name.length-1),result.regExp=!0),result.type=parse(null,n,tr,!1,!1,!1),result.id=name,result}function toProto(type){var result=new TypeProto;result.name=type.name(),result.superTypes=type.superTypes().map(function(x){return typeToSignature(x)}),result.annotations=[],result.customFacets=[],result.facetDeclarations=[],result.basicFacets=[],result.properties=[];var pmap={};return type.declaredMeta().forEach(function(x){if(x instanceof meta.Annotation)result.annotations.push(x);else if(x instanceof meta.CustomFacet)result.customFacets.push(x);else if(x instanceof meta.NotScalar)result.notAScalar=!0;else if(x instanceof metainfo_1.FacetDeclaration)result.facetDeclarations.push(x);else if(x instanceof rs.HasProperty)if(pmap.hasOwnProperty(x.value()))pmap[x.value()].optional=!1;else{var pbean=new PropertyBean;pbean.optional=!1,pbean.id=x.value(),pbean.type=ts.ANY,pmap[x.value()]=pbean}else if(x instanceof rs.AdditionalPropertyIs){var pbean=new PropertyBean;pbean.optional=!1,pbean.id="/.*/",pbean.additonal=!0,pbean.type=x.value(),pmap["/.*/"]=pbean}else if(x instanceof rs.MapPropertyIs){var pbean=new PropertyBean;pbean.optional=!1,pbean.id=x.regexpValue(),pbean.regExp=!0,pbean.type=x.value(),pmap[x.regexpValue()]=pbean}else if(x instanceof rs.PropertyIs)if(pmap.hasOwnProperty(x.propertyName()))pmap[x.propertyName()].type=x.value();else{var pbean=new PropertyBean;pbean.optional=!0,pbean.id=x.propertyName(),pbean.type=x.value(),pmap[x.propertyName()]=pbean}else x instanceof rs.KnownPropertyRestriction?result.additionalProperties=x.value():x instanceof meta.DiscriminatorValue?x.isStrict()&&result.basicFacets.push(x):x instanceof meta.HasPropertiesFacet||result.basicFacets.push(x)}),Object.keys(pmap).forEach(function(x){return result.properties.push(pmap[x])}),result}function storeAsJSON(ts){return ts instanceof typesystem_1.AbstractType?toProto(ts).toJSON():storeTypeCollection(ts)}function storeTypeCollection(tc){var res={},types={};tc.types().forEach(function(x){types[x.name()]=storeAsJSON(x)}),Object.keys(types).length>0&&(res.types=types);var types={};return tc.annotationTypes().forEach(function(x){types[x.name()]=storeAsJSON(x)}),Object.keys(types).length>0&&(res.annotationTypes=types),res}function typeToSignature(t){if(t.isAnonymous()){if(t.isArray()){var ci=t.oneMeta(rs.ComponentShouldBeOfType);if(ci){var vl=ci.value();return vl.isAnonymous()&&vl.isUnion()?"("+typeToSignature(vl)+")[]":typeToSignature(vl)+"[]"}}return t.isUnion()?t.options().map(function(x){return typeToSignature(x)}).join(" | "):t.superTypes().map(function(x){return typeToSignature(x)}).join(" , ")}return t.name()}function isSubtypeOf(potentialSubtype,potentialSupertype){if(potentialSupertype===ts.ANY||potentialSubtype===potentialSupertype||potentialSubtype.superTypes().some(function(currentSuperType){return isSubtypeOf(currentSuperType,potentialSupertype)}))return!0;if(potentialSubtype.isUnion()&&potentialSubtype.options){var options=potentialSubtype.options();if(options.some(function(option){return isSubtypeOf(option,potentialSupertype)}))return!0}if(potentialSupertype.isUnion()&&potentialSupertype.options){var options=potentialSupertype.options();if(options.some(function(option){return potentialSubtype==option}))return!0}return!1}function testFacetAgainstType(facet,type){var requiredType=facet.requiredType(),requiredTypes=facet.requiredTypes();return requiredTypes&&requiredTypes.length>0?requiredTypes.some(function(currentRType){return isSubtypeOf(type,currentRType)}):isSubtypeOf(type,requiredType)}function parse(name,n,r,defaultsToAny,annotation,global,ignoreTypeAttr){void 0===r&&(r=ts.builtInRegistry()),void 0===defaultsToAny&&(defaultsToAny=!1),void 0===annotation&&(annotation=!1),void 0===global&&(global=!0),void 0===ignoreTypeAttr&&(ignoreTypeAttr=!1);var uses=n.childWithKey("uses");if(uses&&(uses.kind()===NodeKind.ARRAY&&(uses=transformToArray(uses)),uses.kind()===NodeKind.MAP)){var col=new TypeCollection;uses.children().forEach(function(c){col.addLibrary(c.key(),parseTypeCollection(c,ts.builtInRegistry()))}),r=new AccumulatingRegistry(null,null,r,col)}var provider=n.contentProvider?n.contentProvider():null;if(n.kind()==NodeKind.SCALAR){var sp,valString=n.value();if(sp=null==valString||"Null"==valString||"NULL"==valString?ts.STRING:typeExpressions.parseToType(""+valString,r,provider),null==name)return sp;var res=ts.derive(name,[sp]);return r instanceof AccumulatingRegistry&&(res=contributeToAccumulatingRegistry(res,r)),res}if(n.kind()==NodeKind.ARRAY){var supers=[];n.children().forEach(function(x){supers.push(typeExpressions.parseToType(""+x.value(),r,provider))});var res=ts.derive(name,supers);return r instanceof AccumulatingRegistry&&(res=contributeToAccumulatingRegistry(res,r)),res}var superTypes=[],tp=n.childWithKey("type"),shAndType=!1;if(tp?n.childWithKey("schema")&&(shAndType=!0):tp=n.childWithKey("schema"),!tp||ignoreTypeAttr)superTypes=defaultsToAny?n.childWithKey("properties")?[ts.OBJECT]:[ts.ANY]:n.childWithKey("properties")?[ts.OBJECT]:[ts.STRING];else if(tp.kind()==NodeKind.SCALAR){var valString=tp.value();superTypes=null==valString||"Null"==valString||"NULL"==valString?[ts.STRING]:[typeExpressions.parseToType(""+valString,r,provider)]}else tp.kind()==NodeKind.ARRAY?superTypes=tp.children().map(function(x){return x.value()}).map(function(y){return typeExpressions.parseToType(""+y,r,provider)}):tp.kind()==NodeKind.MAP&&(superTypes=[parse("",tp,r,!1,!1,!1)]);var result=ts.derive(name,superTypes);r instanceof AccumulatingRegistry&&(result=contributeToAccumulatingRegistry(result,r));var actualResult=result,hasfacetsOrOtherStuffDoesNotAllowedInExternals=null;if(n.children().forEach(function(x){var key=x.key();if(key&&"type"!==key&&"uses"!==key&&"schema"!==key&&("properties"!=key&&"additionalProperties"!=key||!result.isSubTypeOf(ts.OBJECT))){if("items"==key&&result.isSubTypeOf(ts.ARRAY)){var tp=parse(null,x,r,!1,!1,!1);return actualResult.addMeta(new restrictions_1.ComponentShouldBeOfType(tp)),void actualResult.putExtra(tsInterfaces.HAS_ITEMS,!0)}if("facets"===key)return void(hasfacetsOrOtherStuffDoesNotAllowedInExternals=key);if(("default"==key||"xml"==key||"required"==key)&&(hasfacetsOrOtherStuffDoesNotAllowedInExternals=key),"("==key.charAt(0)&&")"==key.charAt(key.length-1))return void result.addMeta(new meta.Annotation(key.substr(1,key.length-2),x.value()));var vl=facetR.getInstance().buildFacet(key,x.value());if(vl&&("format"!=key||testFacetAgainstType(vl,result)))vl.setNode(x),result.addMeta(vl);else if(annotation&&"allowedTargets"===key)result.addMeta(new meta.AllowedTargets(x.value()));else{var customFacet=new meta.CustomFacet(key,x.value());customFacet.setNode(x),result.addMeta(customFacet)}}}),0==result.metaOfType(meta.DiscriminatorValue).length&&result.addMeta(new meta.DiscriminatorValue(result.name(),!1)),result.isSubTypeOf(ts.OBJECT)){var props=n.childWithKey("properties"),hasProps=!1;if(props)if(result.addMeta(new meta.HasPropertiesFacet),props.kind()==NodeKind.MAP)props.children().forEach(function(x){hasProps=!0,parsePropertyBean(x,r).add(result)});else{var err=new ts.Status(ts.Status.ERROR,2,"'properties' should be a map",actualResult);err.setValidationPath({name:"properties"}),result.putExtra(tsInterfaces.PARSE_ERROR,err)}var ap=n.childWithKey("additionalProperties");ap&&result.addMeta(new restrictions_2.KnownPropertyRestriction(ap.value()))}var props=n.childWithKey("facets");if(props)if(props.kind()==NodeKind.MAP)props.children().forEach(function(x){var bean=parsePropertyBean(x,r);result.addMeta(new meta.FacetDeclaration(bean.id,bean.type,bean.optional))});else{var err=new ts.Status(ts.Status.ERROR,2,"'facets' should be a map",actualResult);err.setValidationPath({name:"facets"}),result.putExtra(tsInterfaces.PARSE_ERROR,err)}return result.isAnonymous()&&result.isEmpty()&&1==result.superTypes().length?result.superTypes()[0]:(n.kind()!=NodeKind.SCALAR&&result.addMeta(new meta.NotScalar),shAndType&&actualResult.putExtra(ts.SCHEMA_AND_TYPE,!0),actualResult.putExtra(ts.GLOBAL,global),actualResult.putExtra(ts.SOURCE_EXTRA,n),actualResult.putExtra(tsInterfaces.HAS_FACETS,hasfacetsOrOtherStuffDoesNotAllowedInExternals),actualResult)}function contributeToAccumulatingRegistry(result,r){for(var existing,_r=r;_r&&!(existing=_r.typeMap()[result.name()]);)_r=_r.parent();return null!=existing&&existing.isSubTypeOf(ts.REFERENCE)?null!=existing&&existing.isSubTypeOf(ts.REFERENCE)&&(existing.patch(result),result=existing):r.addType(result),result.putExtra(tsInterfaces.TOP_LEVEL_EXTRA,!0),result}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},ts=__webpack_require__(93),tsInterfaces=__webpack_require__(94),rs=__webpack_require__(97),typesystem_1=__webpack_require__(93),typeExpressions=__webpack_require__(139),facetR=__webpack_require__(96),meta=__webpack_require__(98),metainfo_1=__webpack_require__(98),typesystem_2=__webpack_require__(93),restrictions_1=__webpack_require__(97),restrictions_2=__webpack_require__(97);!function(NodeKind){NodeKind[NodeKind.SCALAR=0]="SCALAR",NodeKind[NodeKind.ARRAY=1]="ARRAY",NodeKind[NodeKind.MAP=2]="MAP"}(exports.NodeKind||(exports.NodeKind={}));var NodeKind=exports.NodeKind,JSObjectNode=function(){function JSObjectNode(_key,obj,inArr,provider){void 0===inArr&&(inArr=!1),this._key=_key,this.obj=obj,this.inArr=inArr,this.provider=provider}return JSObjectNode.prototype.value=function(){return this.obj},JSObjectNode.prototype.key=function(){if(!this._key&&this.kind()===NodeKind.MAP&&this.inArr){var l=Object.keys(this.obj);if(1===l.length)return l[0]}return this._key},JSObjectNode.prototype.childWithKey=function(k){return null==this.obj?null:this.obj.hasOwnProperty(k)?new JSObjectNode(k,this.obj[k],!1,this.contentProvider()):null},JSObjectNode.prototype.children=function(){var _this=this;return Array.isArray(this.obj)?this.obj.map(function(x){return new JSObjectNode(null,x,!0,_this.contentProvider())}):this.obj&&"object"==typeof this.obj?Object.keys(this.obj).map(function(x){return new JSObjectNode(x,_this.obj[x],!1,_this.provider)}):[]},JSObjectNode.prototype.kind=function(){return this.obj?Array.isArray(this.obj)?NodeKind.ARRAY:"object"==typeof this.obj?NodeKind.MAP:NodeKind.SCALAR:NodeKind.SCALAR},JSObjectNode.prototype.contentProvider=function(){return this.provider},JSObjectNode}();exports.parseJSON=parseJSON,exports.parseJSONTypeCollection=parseJSONTypeCollection;var PropertyBean=function(){function PropertyBean(){}return PropertyBean.prototype.add=function(t){this.optional||this.additonal||this.regExp||this.type.isSubTypeOf(ts.NIL)||t.addMeta(new rs.HasProperty(this.id));var matchesPropertyFacet;matchesPropertyFacet=this.additonal?new rs.AdditionalPropertyIs(this.type):this.regExp?new rs.MapPropertyIs(this.id,this.type):new rs.PropertyIs(this.id,this.type,this.optional),null!=matchesPropertyFacet&&(t.addMeta(matchesPropertyFacet),this.type instanceof ts.InheritedType&&null==this.type.name()&&this.type.setContextMeta(matchesPropertyFacet))},PropertyBean}();exports.PropertyBean=PropertyBean;var TypeCollection=function(){function TypeCollection(){this._types=[],this._typeMap={},this.uses={},this._annotationTypes=[],this._annotationTypeMap={}}return TypeCollection.prototype.library=function(n){return this.uses[n]},TypeCollection.prototype.addLibrary=function(n,t){this.uses[n]=t},TypeCollection.prototype.add=function(t){this._types.push(t),this._typeMap[t.name()]=t},TypeCollection.prototype.getType=function(name){return this._typeMap.hasOwnProperty(name)?this._typeMap[name]:null},TypeCollection.prototype.addAnnotationType=function(t){this._annotationTypes.push(t),this._annotationTypeMap[t.name()]=t},TypeCollection.prototype.getAnnotationType=function(name){return this._annotationTypeMap.hasOwnProperty(name)?this._annotationTypeMap[name]:null},TypeCollection.prototype.types=function(){return this._types},TypeCollection.prototype.annotationTypes=function(){return this._annotationTypes},TypeCollection.prototype.getAnnotationTypeRegistry=function(){var _this=this,r=new typesystem_2.TypeRegistry(ts.builtInRegistry());return this.annotationTypes().forEach(function(x){return r.addType(x)}),Object.keys(this.uses).forEach(function(x){_this.uses[x].annotationTypes().forEach(function(y){return r.put(x+"."+y.name(),y)})}),r},TypeCollection.prototype.getTypeRegistry=function(){var _this=this,r=new typesystem_2.TypeRegistry(ts.builtInRegistry());return this.types().forEach(function(x){return r.addType(x)}),Object.keys(this.uses).forEach(function(x){_this.uses[x].types().forEach(function(y){return r.put(x+"."+y.name(),y)})}),r},TypeCollection}();exports.TypeCollection=TypeCollection;var AccumulatingRegistry=function(_super){function AccumulatingRegistry(toParse,schemas,ts,_c){_super.call(this,ts),this.toParse=toParse,this.schemas=schemas,this._c=_c,this.parsing={}}return __extends(AccumulatingRegistry,_super),AccumulatingRegistry.prototype.get=function(name){var result=_super.prototype.get.call(this,name);if(!result||result.isSubTypeOf(ts.REFERENCE)){var chld=this.toParse?this.toParse.childWithKey(name):null;if(chld||(chld=this.schemas?this.schemas.childWithKey(name):null),chld){if(this.parsing[name]){var recurrent=ts.derive(name,[ts.RECURRENT]);return result&&result.isSubTypeOf(ts.REFERENCE)?result.patch(recurrent):result=recurrent,result}this.parsing[name]=!0;try{var tp=parse(name,chld,this)}finally{delete this.parsing[name]}return tp}var dt=name.indexOf(".");if(-1!=dt){var ln=name.substring(0,dt),tn=name.substr(dt+1),lib=this._c.library(ln);if(lib){var t=lib.getType(tn);if(t)return t}}}return result},AccumulatingRegistry}(ts.TypeRegistry);exports.AccumulatingRegistry=AccumulatingRegistry,exports.parseTypes=parseTypes;var WrapArrayNode=function(){function WrapArrayNode(n){this.n=n}return WrapArrayNode.prototype.key=function(){return null},WrapArrayNode.prototype.value=function(){return null},WrapArrayNode.prototype.childWithKey=function(k){for(var r=this.children(),i=0;i<r.length;i++)if(r[i].key()==k)return r[i];return null},WrapArrayNode.prototype.children=function(){return this.n.children().map(function(x){var c=x.children();return 1==c.length?c[0]:x})},WrapArrayNode.prototype.kind=function(){return NodeKind.MAP},WrapArrayNode}();exports.parseTypeCollection=parseTypeCollection,exports.parsePropertyBean=parsePropertyBean;var TypeProto=function(){function TypeProto(){}return TypeProto.prototype.toJSON=function(){var result={};if(this.superTypes&&this.superTypes.length>0&&(1==this.superTypes.length?result.type=this.superTypes[0]:result.type=this.superTypes),this.customFacets&&this.customFacets.forEach(function(x){return result[x.facetName()]=x.value()}),this.annotations&&this.annotations.forEach(function(x){return result["("+x.facetName()+")"]=x.value()}),this.facetDeclarations&&this.facetDeclarations.length>0){var facets={};this.facetDeclarations.forEach(function(x){var nm=x.facetName();x.isOptional()&&(nm+="?");var vl=null;vl=x.type().isAnonymous()?x.type().isEmpty()?typeToSignature(x.type()):toProto(x.type()).toJSON():typeToSignature(x.type()),facets[nm]=vl}),result.facets=facets}if(this.properties&&this.properties.length>0){var properties={};this.properties.forEach(function(x){var nm=x.id;x.optional&&(nm+="?"),x.additonal&&(nm="/.*/"),x.regExp&&(nm="/"+nm+"/");var vl=null;vl=x.type.isAnonymous()?x.type.isEmpty()?typeToSignature(x.type):toProto(x.type).toJSON():typeToSignature(x.type),properties[nm]=vl}),result.properties=properties}return this.basicFacets&&this.basicFacets.forEach(function(x){result[x.facetName()]=x.value()}),1==Object.keys(result).length&&!this.notAScalar&&result.type?result.type:(void 0!==this.additionalProperties&&(result.additionalProperties=this.additionalProperties),result)},TypeProto}();exports.TypeProto=TypeProto,exports.toProto=toProto,exports.storeAsJSON=storeAsJSON,exports.parse=parse},function(module,exports,__webpack_require__){"use strict";function getInstance(){return instance?instance:instance=new Registry}var ts=__webpack_require__(93),ms=__webpack_require__(98),typesystem_1=__webpack_require__(93),restrictions_1=__webpack_require__(97),metainfo_1=__webpack_require__(98),metainfo_2=__webpack_require__(98),metainfo_3=__webpack_require__(98),metainfo_4=__webpack_require__(98),restrictions_2=__webpack_require__(97),FacetPrototype=function(){function FacetPrototype(_construct,_constructWithValue){this._construct=_construct,this._constructWithValue=_constructWithValue}return FacetPrototype.prototype.isSimple=function(){return null!=this._constructWithValue},FacetPrototype.prototype.newInstance=function(){return this._construct()},FacetPrototype.prototype.createWithValue=function(v){return this._constructWithValue(v)},FacetPrototype.prototype.isApplicable=function(t){var instance=this.newInstance(),requiredType=instance.requiredType(),requiredTypes=instance.requiredTypes();return requiredTypes&&requiredTypes.length>0?requiredTypes.some(function(currentRType){return t.isSubTypeOf(currentRType)}):t.isSubTypeOf(requiredType)},FacetPrototype.prototype.isInheritable=function(){return this.newInstance().isInheritable()},FacetPrototype.prototype.isConstraint=function(){return this.newInstance()instanceof ts.Constraint},FacetPrototype.prototype.isMeta=function(){return!this.isConstraint()},FacetPrototype.prototype.name=function(){return this.newInstance().facetName()},FacetPrototype}();exports.FacetPrototype=FacetPrototype;var Registry=function(){function Registry(){var _this=this;this.constraints=[new FacetPrototype(function(){return new restrictions_1.MinProperties(1)},function(x){return new restrictions_1.MinProperties(x)}),new FacetPrototype(function(){return new restrictions_1.MaxProperties(1)},function(x){return new restrictions_1.MaxProperties(x)}),new FacetPrototype(function(){return new restrictions_1.MinItems(1)},function(x){return new restrictions_1.MinItems(x)}),new FacetPrototype(function(){return new restrictions_1.MaxItems(1)},function(x){return new restrictions_1.MaxItems(x)}),new FacetPrototype(function(){return new restrictions_1.MinLength(1)},function(x){return new restrictions_1.MinLength(x)}),new FacetPrototype(function(){return new restrictions_1.MaxLength(1)},function(x){return new restrictions_1.MaxLength(x)}),new FacetPrototype(function(){return new restrictions_1.Minimum(1)},function(x){return new restrictions_1.Minimum(x)}),new FacetPrototype(function(){return new restrictions_2.MultipleOf(1)},function(x){return new restrictions_2.MultipleOf(x)}),new FacetPrototype(function(){return new restrictions_1.Maximum(1)},function(x){return new restrictions_1.Maximum(x)}),new FacetPrototype(function(){return new restrictions_1.Enum([""])},function(x){return new restrictions_1.Enum(x)}),new FacetPrototype(function(){return new restrictions_1.Pattern(".")},function(x){return new restrictions_1.Pattern(x)}),new FacetPrototype(function(){return new restrictions_1.Format("")},function(x){return new restrictions_1.Format(x)}),new FacetPrototype(function(){return new restrictions_1.PropertyIs("x",ts.ANY)},null),new FacetPrototype(function(){return new restrictions_1.AdditionalPropertyIs(ts.ANY)},null),new FacetPrototype(function(){return new restrictions_1.MapPropertyIs(".",ts.ANY)},null),new FacetPrototype(function(){return new restrictions_1.HasProperty("x")},null),new FacetPrototype(function(){return new restrictions_1.UniqueItems(!0)},function(x){return new restrictions_1.UniqueItems(x)}),new FacetPrototype(function(){return new restrictions_1.ComponentShouldBeOfType(ts.ANY)},null),new FacetPrototype(function(){return new restrictions_1.KnownPropertyRestriction(!1)},function(x){return new restrictions_1.KnownPropertyRestriction(x)})],this.meta=[new FacetPrototype(function(){return new ms.Discriminator("kind")},function(x){return new ms.Discriminator(x)}),new FacetPrototype(function(){return new ms.DiscriminatorValue("x")},function(x){return new ms.DiscriminatorValue(x)}),new FacetPrototype(function(){return new metainfo_1.Default("")},function(x){return new metainfo_1.Default(x)}),new FacetPrototype(function(){return new metainfo_4.Usage("")},function(x){return new metainfo_4.Usage(x)}),new FacetPrototype(function(){return new metainfo_1.Example("")},function(x){return new metainfo_1.Example(x)}),new FacetPrototype(function(){return new metainfo_3.Required(!0)},function(x){return new metainfo_3.Required(x)}),new FacetPrototype(function(){return new ms.Examples({})},function(x){return new ms.Examples(x)}),new FacetPrototype(function(){return new metainfo_1.Description("")},function(x){return new metainfo_1.Description(x)}),new FacetPrototype(function(){return new metainfo_1.DisplayName("")},function(x){return new metainfo_1.DisplayName(x)}),new FacetPrototype(function(){return new typesystem_1.Abstract},function(x){return new typesystem_1.Abstract}),new FacetPrototype(function(){return new typesystem_1.Polymorphic},function(x){return new typesystem_1.Polymorphic}),new FacetPrototype(function(){return new metainfo_2.XMLInfo({})},function(x){return new metainfo_2.XMLInfo(x)})],this.known={},this.allPrototypes().forEach(function(x){return _this.known[x.name()]=x})}return Registry.prototype.allPrototypes=function(){return this.meta.concat(this.constraints)},Registry.prototype.buildFacet=function(n,value){return this.known.hasOwnProperty(n)&&this.known[n].isSimple()?this.known[n].createWithValue(value):null},Registry.prototype.facetPrototypeWithName=function(n){
return this.known.hasOwnProperty(n)?this.known[n]:null},Registry.prototype.applyableTo=function(t){return this.allPrototypes().filter(function(x){return x.isApplicable(t)})},Registry.prototype.allMeta=function(){return this.allPrototypes().filter(function(x){return x.isMeta()})},Registry}();exports.Registry=Registry;var instance;exports.getInstance=getInstance},function(module,exports,__webpack_require__){"use strict";function anotherRestrictionComponent(){return anotherSource.length>0?anotherSource[anotherSource.length-1]:null}function setAnotherRestrictionComponent(src){for(var owner;src;)owner=src.owner(),src=owner instanceof ts.InheritedType?owner.contextMeta():null;anotherSource.push(owner)}function releaseAnotherRestrictionComponent(l){for(void 0===l&&(l=0);anotherSource.length>l;)anotherSource.pop()}function anotherRestrictionComponentsCount(){return anotherSource.length}function is_int(value){return parseFloat(value)!=parseInt(value)||isNaN(value)?!1:!0}function optimize(r){r=r.map(function(x){return x.preoptimize()});var optimized=[];r.forEach(function(x){if(x instanceof typesystem_1.AndRestriction){var ar=x;ar.options().forEach(function(y){optimized.push(y)})}else optimized.push(x)});for(var transformed=!0;transformed;){transformed=!1;for(var i=0;i<optimized.length;i++){for(var j=0;j<optimized.length;j++){var rs0=optimized[i],rs1=optimized[j];if(rs0!==rs1){var compose=rs0.tryCompose(rs1);if(compose){var newOptimized=optimized.filter(function(x){return x!==rs0&&x!==rs1});newOptimized.push(compose),transformed=!0,optimized=newOptimized;break}}}if(transformed)break}}return optimized}function actualUnknownType(t){if(!t.isSubTypeOf(ts.UNKNOWN))return null;if(null!=t.name())return t;for(var _i=0,_a=t.superTypes();_i<_a.length;_i++){var st=_a[_i],ust=actualUnknownType(st);if(null!=ust)return ust}return t}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},ts=__webpack_require__(93),su=__webpack_require__(103),_=__webpack_require__(177),typesystem_1=__webpack_require__(93),typesystem_2=__webpack_require__(93),MatchesProperty=function(_super){function MatchesProperty(_type){_super.call(this),this._type=_type}return __extends(MatchesProperty,_super),MatchesProperty.prototype.matches=function(s){return!1},MatchesProperty.prototype.check=function(i,p){throw new Error("Should be never called")},MatchesProperty.prototype.patchPath=function(p){if(p){for(var c=p,r=null,cp=null;c;)if(r){var news={name:c.name};cp.child=news,c=c.child,cp=news}else r={name:c.name},cp=r;return r.child={name:this.propId()},r}return{name:this.propId()}},MatchesProperty.prototype.validateProp=function(i,n,t,q){var vl=i[n],st=t.validate(vl,!1,!1);if(!st.isOk()){if(t.isUnknown()||t.isRecurrent()){var s=new typesystem_2.Status(typesystem_2.Status.ERROR,0,"Validating instance against unknown type: '"+t.name()+"'",this);return s.setValidationPath(this.patchPath(q)),s}var s=new typesystem_2.Status(typesystem_2.Status.OK,0,"",this);return st.getErrors().forEach(function(x){return s.addSubStatus(x)}),s.setValidationPath(this.patchPath(q)),s}return ts.ok()},MatchesProperty.prototype.validateSelf=function(registry){if(this._type.isExternal()){var p=new typesystem_2.Status(typesystem_2.Status.ERROR,0,"It is not allowed to use external types in property definitions",this);return p.setValidationPath({name:this.propId()}),p}if(this._type.isSubTypeOf(ts.UNKNOWN)||this._type.isSubTypeOf(ts.RECURRENT)){var actualUnknown=actualUnknownType(this._type),p=new typesystem_2.Status(typesystem_2.Status.ERROR,0,"Property '"+this.propId()+"' refers to unknown type '"+actualUnknown.name()+"'",this);return p.setValidationPath({name:this.propId(),child:{name:"type"}}),p}if(this._type.isAnonymous()){var st=this._type.validateType(registry);if(!st.isOk()){var p=new typesystem_2.Status(typesystem_2.Status.ERROR,0,"Property '"+this.propId()+"' range type has error: "+st.getMessage(),this);return st.getErrors().forEach(function(y){p.addSubStatus(y)}),p.setValidationPath({name:this.propId()}),p}return st}if(this._type.isUnion()){var ui=_.find(this._type.typeFamily(),function(x){return x.isSubTypeOf(ts.UNKNOWN)});if(ui){var p=new typesystem_2.Status(typesystem_2.Status.ERROR,0,"Property '"+this.propId()+"' refers to unknown type "+ui.name(),this);return p.setValidationPath({name:this.propId()}),p}}return ts.ok()},MatchesProperty}(ts.Constraint);exports.MatchesProperty=MatchesProperty;var MatchToSchema=function(_super){function MatchToSchema(_value,provider){_super.call(this),this._value=_value,this.provider=provider}return __extends(MatchToSchema,_super),MatchToSchema.prototype.value=function(){return this._value},MatchToSchema.prototype.check=function(i){var so=null,strVal=this.value();if("{"==strVal.charAt(0))try{so=su.getJSONSchema(strVal,this.provider)}catch(e){return new ts.Status(ts.Status.ERROR,0,"Incorrect schema: "+e.message,this)}if("<"==strVal.charAt(0))try{so=su.getXMLSchema(strVal,this.provider)}catch(e){return ts.ok()}if(so)try{so.validateObject(i)}catch(e){return"!_PERF_!"==e.message?new ts.Status(ts.Status.WARNING,0,"Unable to validate example against schema (xmllint)",this):"Cannot assign to read only property '__$validated' of object"==e.message?ts.ok():"Object.keys called on non-object"==e.message?ts.ok():"Maximum call stack size exceeded"==e.message?new ts.Status(ts.Status.ERROR,0,"JSON schema contains circular references",this):new ts.Status(ts.Status.ERROR,0,"Example does not conform to schema: "+e.message,this)}return ts.ok()},MatchToSchema.prototype.facetName=function(){return"schema"},MatchToSchema.prototype.requiredType=function(){return ts.EXTERNAL},MatchToSchema}(ts.Constraint);exports.MatchToSchema=MatchToSchema;var KnownPropertyRestriction=function(_super){function KnownPropertyRestriction(_value){_super.call(this),this._value=_value}return __extends(KnownPropertyRestriction,_super),KnownPropertyRestriction.prototype.facetName=function(){return"closed"},KnownPropertyRestriction.prototype.requiredType=function(){return ts.OBJECT},KnownPropertyRestriction.prototype.value=function(){return this._value},KnownPropertyRestriction.prototype.patchOwner=function(t){this._owner=t},KnownPropertyRestriction.prototype.check=function(i){var _this=this;if(this._value===!1&&i&&"object"==typeof i&&!Array.isArray(i)){var nm={};Object.getOwnPropertyNames(i).forEach(function(n){return nm[n]=!0});var mp=this.owner().knownProperties();Object.getOwnPropertyNames(i).forEach(function(p){mp.forEach(function(v){v.matches(p)&&delete nm[p]})});var unknownPropertyNames=Object.keys(nm);if((this.owner().hasPropertiesFacet()||mp.length>0)&&unknownPropertyNames.length>0){var s=new ts.Status(ts.Status.OK,0,"",this);return unknownPropertyNames.forEach(function(x){var err=ts.error("Unknown property: '"+x+"'",_this);err.setValidationPath({name:x}),s.addSubStatus(err)}),s}}return ts.ok()},KnownPropertyRestriction.prototype.composeWith=function(restriction){if(!this._value)return null;if(restriction instanceof KnownPropertyRestriction){var mm=restriction;if(_.isEqual(this.owner().propertySet(),mm.owner().propertySet()))return mm}if(restriction instanceof HasProperty){var ps=restriction,name=ps.value(),allowedPropertySet=this.owner().propertySet();if(-1==allowedPropertySet.indexOf(name))return this.nothing(ps)}},KnownPropertyRestriction}(ts.Constraint);exports.KnownPropertyRestriction=KnownPropertyRestriction;var HasProperty=function(_super){function HasProperty(name){_super.call(this),this.name=name}return __extends(HasProperty,_super),HasProperty.prototype.check=function(i){return i&&"object"==typeof i&&!Array.isArray(i)?i.hasOwnProperty(this.name)?ts.ok():ts.error("Required property '"+this.name+"' is missing",this):ts.ok()},HasProperty.prototype.requiredType=function(){return ts.OBJECT},HasProperty.prototype.facetName=function(){return"hasProperty"},HasProperty.prototype.value=function(){return this.name},HasProperty.prototype.composeWith=function(r){if(r instanceof HasProperty){var hp=r;if(hp.name===this.name)return this}return null},HasProperty}(ts.Constraint);exports.HasProperty=HasProperty;var PropertyIs=function(_super){function PropertyIs(name,type,optional){void 0===optional&&(optional=!1),_super.call(this,type),this.name=name,this.type=type,this.optional=optional}return __extends(PropertyIs,_super),PropertyIs.prototype.matches=function(s){return s===this.name},PropertyIs.prototype.path=function(){return this.name},PropertyIs.prototype.check=function(i,p){if(i&&"object"==typeof i&&i.hasOwnProperty(this.name)){var st=this.validateProp(i,this.name,this.type,p);return!st.isOk()&&this.optional&&null==i[this.name]?ts.ok():st}return ts.ok()},PropertyIs.prototype.requiredType=function(){return ts.OBJECT},PropertyIs.prototype.propId=function(){return this.name},PropertyIs.prototype.propertyName=function(){return this.name},PropertyIs.prototype.facetName=function(){return"propertyIs"},PropertyIs.prototype.value=function(){return this.type},PropertyIs.prototype.composeWith=function(t){if(t instanceof PropertyIs){var pi=t;if(pi.name===this.name){if(-1!=this.type.typeFamily().indexOf(pi.type))return pi;if(-1!=pi.type.typeFamily().indexOf(this.type))return this;setAnotherRestrictionComponent(t);var intersectionType=this.intersect(this.type,pi.type);try{var is=intersectionType.checkConfluent();if(!is.isOk()){var rc=is;return rc.toRestriction()}return new PropertyIs(this.name,intersectionType)}finally{this.release(intersectionType)}}}return null},PropertyIs}(MatchesProperty);exports.PropertyIs=PropertyIs;var anotherSource=[];exports.anotherRestrictionComponent=anotherRestrictionComponent,exports.releaseAnotherRestrictionComponent=releaseAnotherRestrictionComponent,exports.anotherRestrictionComponentsCount=anotherRestrictionComponentsCount;var MapPropertyIs=function(_super){function MapPropertyIs(regexp,type){_super.call(this,type),this.regexp=regexp,this.type=type}return __extends(MapPropertyIs,_super),MapPropertyIs.prototype.path=function(){return"/"+this.regexp+"/"},MapPropertyIs.prototype.matches=function(s){return s.match(this.regexp)?!0:!1},MapPropertyIs.prototype.requiredType=function(){return ts.OBJECT},MapPropertyIs.prototype.propId=function(){return"["+this.regexp+"]"},MapPropertyIs.prototype.facetName=function(){return"mapPropertyIs"},MapPropertyIs.prototype.value=function(){return this.type},MapPropertyIs.prototype.regexpValue=function(){return this.regexp},MapPropertyIs.prototype.validateSelf=function(t){var m=this.checkValue();return m?new typesystem_2.Status(typesystem_2.Status.ERROR,0,m,this):_super.prototype.validateSelf.call(this,t)},MapPropertyIs.prototype.checkValue=function(){try{new RegExp(this.regexp)}catch(e){return e.message}return null},MapPropertyIs.prototype.composeWith=function(t){if(t instanceof MapPropertyIs){var pi=t;if(pi.regexp===this.regexp){if(-1!=this.type.typeFamily().indexOf(pi.type))return pi;if(-1!=pi.type.typeFamily().indexOf(this.type))return this;var intersectionType=this.intersect(this.type,pi.type);try{var is=intersectionType.checkConfluent();if(!is.isOk()){var rc=is;return rc.toRestriction()}return new MapPropertyIs(this.regexp,intersectionType)}finally{this.release(intersectionType)}}}return null},MapPropertyIs.prototype.check=function(i,p){if(i&&"object"==typeof i){var fixedProperties={};null!=this._owner&&this._owner.meta().filter(function(x){return x instanceof PropertyIs}).forEach(function(x){fixedProperties[x.propertyName()]=!0});for(var rs=new ts.Status(ts.Status.OK,0,"",this),_i=0,_a=Object.getOwnPropertyNames(i);_i<_a.length;_i++){var n=_a[_i];if(!fixedProperties[n]&&n.match(this.regexp)){var stat=this.validateProp(i,n,this.type,p);stat.isOk()||rs.addSubStatus(stat)}}return rs}return ts.ok()},MapPropertyIs}(MatchesProperty);exports.MapPropertyIs=MapPropertyIs;var AdditionalPropertyIs=function(_super){function AdditionalPropertyIs(type){_super.call(this,type),this.type=type}return __extends(AdditionalPropertyIs,_super),AdditionalPropertyIs.prototype.path=function(){return this.facetName()},AdditionalPropertyIs.prototype.matches=function(s){return!0},AdditionalPropertyIs.prototype.requiredType=function(){return ts.OBJECT},AdditionalPropertyIs.prototype.propId=function(){return"[]"},AdditionalPropertyIs.prototype.facetName=function(){return"additionalProperties"},AdditionalPropertyIs.prototype.value=function(){return this.type},AdditionalPropertyIs.prototype.match=function(n){for(var all=this.owner().metaOfType(PropertyIs),map=this.owner().metaOfType(MapPropertyIs),i=0;i<all.length;i++)if(all[i].matches(n))return!0;for(var i=0;i<map.length;i++)if(map[i].matches(n))return!0;return!1},AdditionalPropertyIs.prototype.composeWith=function(t){if(t instanceof AdditionalPropertyIs){var pi=t;if(-1!=this.type.typeFamily().indexOf(pi.type))return pi;if(-1!=pi.type.typeFamily().indexOf(this.type))return this;var intersectionType=this.intersect(this.type,pi.type);try{var is=intersectionType.checkConfluent();if(!is.isOk()){var rc=is;return rc.toRestriction()}return new AdditionalPropertyIs(intersectionType)}finally{this.release(intersectionType)}}return null},AdditionalPropertyIs.prototype.check=function(i,p){var _this=this,t=this.type,res=new ts.Status(ts.Status.OK,0,"",this);return i&&"object"==typeof i&&Object.getOwnPropertyNames(i).forEach(function(n){if(!_this.match(n)){var stat=_this.validateProp(i,n,t,p);stat.isOk()||res.addSubStatus(stat)}}),res},AdditionalPropertyIs}(MatchesProperty);exports.AdditionalPropertyIs=AdditionalPropertyIs;var FacetRestriction=function(_super){function FacetRestriction(){_super.apply(this,arguments)}return __extends(FacetRestriction,_super),FacetRestriction.prototype.requiredTypes=function(){return[]},FacetRestriction.prototype.checkOwner=function(requiredType){var ownerIsCorrect=!1;if(requiredType.isUnion())for(var family=requiredType.typeFamily(),_i=0,family_1=family;_i<family_1.length;_i++){var tp=family_1[_i];if(this.owner().isSubTypeOf(tp)){ownerIsCorrect=!0;break}}else ownerIsCorrect=this.owner().isSubTypeOf(requiredType);return ownerIsCorrect},FacetRestriction.prototype.validateSelf=function(registry){var _this=this,ownerIsCorrect=!1;if(this.checkOwner(this.requiredType()))if(this.requiredTypes()&&this.requiredTypes().length>0){var correctRequiredSuperType=(this.owner(),_.find(this.requiredTypes(),function(requiredType){return _this.checkOwner(requiredType)}));correctRequiredSuperType&&(ownerIsCorrect=!0)}else ownerIsCorrect=!0;if(!ownerIsCorrect){var typeNames=this.requiredType().name();this.requiredTypes()&&this.requiredTypes().length>0&&(typeNames="["+this.requiredTypes().map(function(requiredType){return requiredType.name()}).join()+"]");var rs=ts.error(this.facetName()+" facet can only be used with "+typeNames+" types",this);return rs.setValidationPath({name:this.facetName()}),rs}var m=this.checkValue();if(m){var rs=ts.error(m,this,!0);return rs.setValidationPath({name:this.facetName()}),rs}return ts.ok()},FacetRestriction}(ts.Constraint);exports.FacetRestriction=FacetRestriction;var MinMaxRestriction=function(_super){function MinMaxRestriction(_facetName,_value,_max,_opposite,_requiredType,_isInt){_super.call(this),this._facetName=_facetName,this._value=_value,this._max=_max,this._opposite=_opposite,this._requiredType=_requiredType,this._isInt=_isInt}return __extends(MinMaxRestriction,_super),MinMaxRestriction.prototype.facetName=function(){return this._facetName},MinMaxRestriction.prototype.isIntConstraint=function(){return this._isInt},MinMaxRestriction.prototype.isMax=function(){return this._max},MinMaxRestriction.prototype.value=function(){return this._value},MinMaxRestriction.prototype.check=function(i){var o=this.extractValue(i);if("number"==typeof o)if(this.isMax()){if(this.value()<o)return this.createError()}else if(this.value()>o)return this.createError();return ts.ok()},MinMaxRestriction.prototype.createError=function(){return ts.error(this.toString(),this)},MinMaxRestriction.prototype.minValue=function(){return this._isInt?0:Number.NEGATIVE_INFINITY},MinMaxRestriction.prototype.requiredType=function(){return this._requiredType},MinMaxRestriction.prototype.checkValue=function(){return"number"!=typeof this._value?"'"+this.facetName()+"' value should be a number":this.isIntConstraint()&&!is_int(this.value())?"'"+this.facetName()+"' value should be an integer":this.value()<this.minValue()?this.facetName()+"' value should be at least "+this.minValue():void 0},MinMaxRestriction.prototype.composeWith=function(t){if(t instanceof MinMaxRestriction){var mx=t;if(mx.facetName()==this.facetName()&&mx.isMax()==this.isMax())return this.isMax()?this.value()<mx.value()?mx:this:this.value()>mx.value()?mx:this;if(mx.facetName()===this._opposite)if(this.isMax()){if(mx.value()>this.value())return this.nothing(t)}else if(mx.value()<this.value())return this.nothing(t)}return null},MinMaxRestriction.prototype.facetPath=function(){var arr=[this.facetName()],owner=this._owner;if(null!=owner&&owner instanceof ts.InheritedType){var it=owner;arr=ts.typePath(it).concat(arr)}return arr.join(".")},MinMaxRestriction.prototype.toString=function(){return"'"+this.facetPath()+"="+this.value()+"' i.e. "+this.textMessagePart()+" "+this.value()},MinMaxRestriction.prototype.conflictMessage=function(otherPath,otherValue){var arr=this.isMax()?["less","higher"]:["higher","less"];return"['"+this.facetPath()+"="+this.value()+"' is "+arr[0]+" than '"+otherPath+"="+otherValue+"'. The "+this._opposite+" cannot be "+arr[1]+" than the "+this.facetName()+".]"},MinMaxRestriction}(FacetRestriction);exports.MinMaxRestriction=MinMaxRestriction;var MultipleOf=function(_super){function MultipleOf(_value){_super.call(this),this._value=_value}return __extends(MultipleOf,_super),MultipleOf.prototype.value=function(){return this._value},MultipleOf.prototype.check=function(o){if("number"==typeof o){var q=o/this.value();if(!is_int(q))return new ts.Status(ts.Status.ERROR,0,"result of division of "+o+" on "+this.value()+" should be integer",this)}return ts.ok()},MultipleOf.prototype.composeWith=function(t){return null},MultipleOf.prototype.facetName=function(){return"multipleOf"},MultipleOf.prototype.checkValue=function(){return"number"!=typeof this._value?"'"+this.facetName()+"' value should be a number":null},MultipleOf.prototype.requiredType=function(){return ts.NUMBER},MultipleOf}(FacetRestriction);exports.MultipleOf=MultipleOf;var Maximum=function(_super){function Maximum(val){_super.call(this,"maximum",val,!0,"minimum",ts.NUMBER,!1)}return __extends(Maximum,_super),Maximum.prototype.extractValue=function(i){return i},Maximum.prototype.textMessagePart=function(){return"value should not be more than"},Maximum}(MinMaxRestriction);exports.Maximum=Maximum;var Minimum=function(_super){function Minimum(val){_super.call(this,"minimum",val,!1,"maximum",ts.NUMBER,!1)}return __extends(Minimum,_super),Minimum.prototype.extractValue=function(i){return i},Minimum.prototype.textMessagePart=function(){return"value should not be less than"},Minimum}(MinMaxRestriction);exports.Minimum=Minimum;var MaxItems=function(_super){function MaxItems(val){_super.call(this,"maxItems",val,!0,"minItems",ts.ARRAY,!0)}return __extends(MaxItems,_super),MaxItems.prototype.extractValue=function(i){return Array.isArray(i)?i.length:void 0},MaxItems.prototype.textMessagePart=function(){return"array items count should not be more than"},MaxItems}(MinMaxRestriction);exports.MaxItems=MaxItems;var MinItems=function(_super){function MinItems(val){_super.call(this,"minItems",val,!1,"maxItems",ts.ARRAY,!0)}return __extends(MinItems,_super),MinItems.prototype.extractValue=function(i){return Array.isArray(i)?i.length:void 0},MinItems.prototype.textMessagePart=function(){return"array items count should not be less than"},MinItems}(MinMaxRestriction);exports.MinItems=MinItems;var MaxLength=function(_super){function MaxLength(val){_super.call(this,"maxLength",val,!0,"minLength",new ts.UnionType("string and file",[ts.STRING,ts.FILE]),!0)}return __extends(MaxLength,_super),MaxLength.prototype.extractValue=function(i){return"string"==typeof i?i.length:0},MaxLength.prototype.textMessagePart=function(){return"string length should not be more than"},MaxLength}(MinMaxRestriction);exports.MaxLength=MaxLength;var MinLength=function(_super){function MinLength(val){_super.call(this,"minLength",val,!1,"maxLength",new ts.UnionType("string and file",[ts.STRING,ts.FILE]),!0)}return __extends(MinLength,_super),MinLength.prototype.extractValue=function(i){return"string"==typeof i?i.length:0},MinLength.prototype.textMessagePart=function(){return"string length should not be less than"},MinLength}(MinMaxRestriction);exports.MinLength=MinLength;var MaxProperties=function(_super){function MaxProperties(val){_super.call(this,"maxProperties",val,!0,"minProperties",ts.OBJECT,!0)}return __extends(MaxProperties,_super),MaxProperties.prototype.extractValue=function(i){return Object.keys(i).length},MaxProperties.prototype.textMessagePart=function(){return"object properties count should not be more than"},MaxProperties}(MinMaxRestriction);exports.MaxProperties=MaxProperties;var MinProperties=function(_super){function MinProperties(val){_super.call(this,"minProperties",val,!1,"maxProperties",ts.OBJECT,!0)}return __extends(MinProperties,_super),MinProperties.prototype.extractValue=function(i){return Object.keys(i).length},MinProperties.prototype.textMessagePart=function(){return"object properties count should not be less than"},MinProperties}(MinMaxRestriction);exports.MinProperties=MinProperties;var UniqueItems=function(_super){function UniqueItems(_value){_super.call(this),this._value=_value}return __extends(UniqueItems,_super),UniqueItems.prototype.facetName=function(){return"uniqueItems"},UniqueItems.prototype.requiredType=function(){return ts.ARRAY},UniqueItems.prototype.check=function(i){if(!this._value)return ts.ok();if(Array.isArray(i)){var r=i;if(_.unique(r).length!=r.length)return ts.error(this.toString(),this)}return ts.ok()},UniqueItems.prototype.composeWith=function(r){if(r instanceof UniqueItems){var mm=r;if(mm._value==this._value)return this}return null},UniqueItems.prototype.value=function(){return this._value},UniqueItems.prototype.checkValue=function(){return null},UniqueItems.prototype.toString=function(){return"items should be unique"},UniqueItems}(FacetRestriction);exports.UniqueItems=UniqueItems;var ComponentShouldBeOfType=function(_super){function ComponentShouldBeOfType(type){_super.call(this),this.type=type}return __extends(ComponentShouldBeOfType,_super),ComponentShouldBeOfType.prototype.facetName=function(){return"items"},ComponentShouldBeOfType.prototype.requiredType=function(){return ts.ARRAY},ComponentShouldBeOfType.prototype.toString=function(){return"items should be of type "+this.type},ComponentShouldBeOfType.prototype.check=function(i){var rs=new ts.Status(ts.Status.OK,0,"",this);if(Array.isArray(i))for(var ar=i,j=0;j<ar.length;j++){var ss=this.type.validate(ar[j],!1,!1);if(!ss.isOk()){var t=this.type;if(t.isUnknown()||t.isRecurrent()){var s=new typesystem_2.Status(typesystem_2.Status.ERROR,0,"Array instance is validated against unknown type: '"+t.name()+"'",this);return s}}ss.setValidationPath({name:""+j}),rs.addSubStatus(ss)}return rs},ComponentShouldBeOfType.prototype.validateSelf=function(registry){if(this.type.isAnonymous()){var st=this.type.validateType(registry);return st.isOk()?st:new typesystem_2.Status(typesystem_2.Status.ERROR,0,"Component type has error: "+st.getMessage(),this)}if(this.type.isExternal()){var p=new typesystem_2.Status(typesystem_2.Status.ERROR,0,"It is not allowed to use external types in component type definitions",this);return p}if(this.type.isSubTypeOf(ts.UNKNOWN)||this.type.isSubTypeOf(ts.RECURRENT))return new typesystem_2.Status(typesystem_2.Status.ERROR,0,"Component refers to unknown type '"+this.type.name()+"'",this);if(this.type.isUnion()){var ui=_.find(this.type.typeFamily(),function(x){return x.isSubTypeOf(ts.UNKNOWN)});if(ui)return new typesystem_2.Status(typesystem_2.Status.ERROR,0,"Component refers to unknown type '"+ui.name()+"'",this)}return ts.ok()},ComponentShouldBeOfType.prototype.composeWith=function(t){if(t instanceof ComponentShouldBeOfType){var pi=t;if(-1!=this.type.typeFamily().indexOf(pi.type))return pi;if(-1!=pi.type.typeFamily().indexOf(this.type))return this;var intersectionType=this.intersect(this.type,pi.type);try{var is=intersectionType.checkConfluent();if(!is.isOk()){var rc=is;return rc.toRestriction()}return new ComponentShouldBeOfType(intersectionType)}finally{this.release(intersectionType)}}return null},ComponentShouldBeOfType.prototype.checkValue=function(){return null},ComponentShouldBeOfType.prototype.value=function(){return this.type},ComponentShouldBeOfType}(FacetRestriction);exports.ComponentShouldBeOfType=ComponentShouldBeOfType;var Pattern=function(_super){function Pattern(_value){_super.call(this),this._value=_value}return __extends(Pattern,_super),Pattern.prototype.facetName=function(){return"pattern"},Pattern.prototype.requiredType=function(){return ts.STRING},Pattern.prototype.check=function(i){if("string"==typeof i){var st=i;try{var matches=st.match(this._value),gotMatch=!1;if(matches)for(var _i=0,matches_1=matches;_i<matches_1.length;_i++){var m=matches_1[_i];if(m.length==st.length){gotMatch=!0;break}}if(!gotMatch)return new ts.Status(ts.Status.ERROR,0,"String should match to '"+this.value()+"'",this)}catch(e){}}return ts.ok()},Pattern.prototype.composeWith=function(r){if(r instanceof Pattern){var v=r;return v._value===this._value?this:this.nothing(r,"pattern restrictions can not be composed at one type")}return null},Pattern.prototype.value=function(){return this._value},Pattern.prototype.checkValue=function(){try{new RegExp(this._value)}catch(e){return e.message}return null},Pattern.prototype.toString=function(){return"should pass reg exp:"+this.value},Pattern}(FacetRestriction);exports.Pattern=Pattern;var Format=function(_super){function Format(_value){_super.call(this),this._value=_value}return __extends(Format,_super),Format.prototype.facetName=function(){return"format"},Format.prototype.requiredType=function(){return ts.SCALAR},Format.prototype.requiredTypes=function(){return[ts.NUMBER,ts.INTEGER,ts.DATETIME]},Format.prototype.check=function(i){return ts.ok()},Format.prototype.composeWith=function(r){if(r instanceof Format){var v=r;return v._value===this._value?this:this.nothing(r,"Format restrictions can not be composed at one type")}return null},Format.prototype.value=function(){return this._value},Format.prototype.checkValue=function(){var _this=this;try{var allowedValues=[];if(this.owner().isSubTypeOf(ts.INTEGER))allowedValues=["int32","int64","int","int16","int8"];else if(this.owner().isSubTypeOf(ts.NUMBER))allowedValues=["int32","int64","int","long","float","double","int16","int8"];else{if(!this.owner().isSubTypeOf(ts.DATETIME))return null;allowedValues=["rfc3339","rfc2616"]}var found=_.find(allowedValues,function(allowedValue){return allowedValue==_this.value()});if(!found)return"Following format values are allowed: "+allowedValues.map(function(x){return"'"+x+"'"}).join(", ")}catch(e){return e.message}return null},Format.prototype.toString=function(){return"should have format:"+this.value},Format}(FacetRestriction);exports.Format=Format;var Enum=function(_super){function Enum(_value){_super.call(this),this._value=_value}return __extends(Enum,_super),Enum.prototype.facetName=function(){return"enum"},Enum.prototype.requiredType=function(){return ts.SCALAR},Enum.prototype.check=function(i){if(!this.checkStatus){var opts=this.value();if(Array.isArray(opts)||(opts=[opts]),!opts.some(function(x){return x==i}))return ts.error(this.toString(),this)}return ts.ok()},Enum.prototype.composeWith=function(r){if(r instanceof Enum){var v=r,sss=_.intersection(this._value,v._value);return 0==sss.length?this.nothing(r):new Enum(sss)}return null},Enum.prototype.value=function(){return this._value},Enum.prototype.checkValue=function(){var _this=this;if(!this.owner().isSubTypeOf(this.requiredType()))return"'enum' facet can only be used with: "+this.requiredType().name();if(this.requiredTypes()&&this.requiredTypes().length>0){var owner=this.owner(),requiredSuperType=_.find(this.requiredTypes(),function(requiredType){return owner.isSubTypeOf(requiredType)});if(!requiredSuperType){var typeNames="["+this.requiredTypes().map(function(requiredType){return"'"+requiredType.name()+"'"}).join(", ")+"]";return"'enum' facet can only be used with: "+typeNames}}if(!Array.isArray(this._value))return"'enum' facet value must be defined by array";var result=null;this.checkStatus=!0;try{this._value.forEach(function(x){var res=_this.owner().validate(x);res.isOk()||(result=res.getMessage())})}finally{this.checkStatus=!1}return result},Enum.prototype.toString=function(){var valStr=Array.isArray(this._value)?this._value.map(function(x){return"'"+x+"'"}).join(", "):"'"+this._value+"'";return"value should be one of: "+valStr},Enum}(FacetRestriction);exports.Enum=Enum,exports.optimize=optimize},function(module,exports,__webpack_require__){"use strict";function serializeToXml(value,type){return xmlio.serializeToXML(value,type)}function parseExampleIfNeeded(val,type){if("string"==typeof val&&(type.isObject()||type.isArray()||type.isExternal()||type.isUnion())){var exampleString=val,firstChar=exampleString.trim().charAt(0);if("{"==firstChar||"["==firstChar||"null"==exampleString.trim())try{return JSON.parse(exampleString)}catch(e){if(type.isObject()||type.isArray()){var c=new typesystem_1.Status(typesystem_1.Status.ERROR,0,"Can not parse JSON example: "+e.message,this);return c}}if("<"==firstChar)try{var jsonFromXml=xmlio.readObject(exampleString,type),errors=xmlio.getXmlErrors(jsonFromXml);if(errors){var error=new typesystem_1.Status(typesystem_1.Status.ERROR,0,"Invalid XML.",{});return errors.forEach(function(child){return error.addSubStatus(child)}),error}return jsonFromXml}catch(e){}}return type.getExtra(tsInterfaces.REPEAT)&&(val=[val]),val}function examplesPatchPath(example,noVal,x){noVal?example.setValidationPath({name:"examples",child:{name:x}}):example.setValidationPath({name:"examples",child:{name:x,child:{name:"value"}}})}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},ts=__webpack_require__(93),typesystem_1=__webpack_require__(93),restrictions_1=__webpack_require__(97),_=__webpack_require__(177),xmlio=__webpack_require__(140),tsInterfaces=__webpack_require__(94),MetaInfo=function(_super){function MetaInfo(_name,_value,inhertitable){void 0===inhertitable&&(inhertitable=!1),_super.call(this,inhertitable),this._name=_name,this._value=_value}return __extends(MetaInfo,_super),MetaInfo.prototype.value=function(){return this._value},MetaInfo.prototype.requiredType=function(){return ts.ANY},MetaInfo.prototype.facetName=function(){return this._name},MetaInfo.prototype.kind=function(){return null},MetaInfo}(ts.TypeInformation);exports.MetaInfo=MetaInfo;var Description=function(_super){function Description(value){_super.call(this,"description",value)}return __extends(Description,_super),Description.prototype.kind=function(){return tsInterfaces.MetaInformationKind.Description},Description}(MetaInfo);exports.Description=Description;var NotScalar=function(_super){function NotScalar(){_super.call(this,"notScalar",!0)}return __extends(NotScalar,_super),NotScalar.prototype.kind=function(){return tsInterfaces.MetaInformationKind.NotScalar},NotScalar}(MetaInfo);exports.NotScalar=NotScalar;var DisplayName=function(_super){function DisplayName(value){_super.call(this,"displayName",value)}return __extends(DisplayName,_super),DisplayName.prototype.kind=function(){return tsInterfaces.MetaInformationKind.DisplayName},DisplayName}(MetaInfo);exports.DisplayName=DisplayName;
var Usage=function(_super){function Usage(value){_super.call(this,"usage",value)}return __extends(Usage,_super),Usage.prototype.kind=function(){return tsInterfaces.MetaInformationKind.Usage},Usage}(MetaInfo);exports.Usage=Usage;var Annotation=function(_super){function Annotation(name,value){_super.call(this,name,value)}return __extends(Annotation,_super),Annotation.prototype.validateSelf=function(registry,ofExample){void 0===ofExample&&(ofExample=!1);var tp=registry.get(this.facetName());if(!tp)return new typesystem_1.Status(typesystem_1.Status.ERROR,0,"Using unknown annotation type: '"+this.facetName()+"'",this);var result=ts.ok(),q=this.value();q||tp.isString()&&(q="");var aTargets=tp.metaOfType(AllowedTargets),contextTarget=ofExample?"Example":"TypeDeclaration";if(aTargets.length>0){var arr=[],at=aTargets.filter(function(x){var val=x.value();return Array.isArray(val)?(arr=arr.concat(val),val.indexOf(contextTarget)>=0):(arr.push(val),val==contextTarget)});if(0==at.length){var list=arr.map(function(x){return"'"+x+"'"}).join(", "),msg="Annotation '"+_super.prototype.facetName.call(this)+"' can not be placed at this location, allowed targets are: "+list,targetStatus=new typesystem_1.Status(typesystem_1.Status.ERROR,0,msg,this);result.addSubStatus(targetStatus)}}var valOwner=tp.validateDirect(q,!0,!1);if(!valOwner.isOk()){var res=new typesystem_1.Status(typesystem_1.Status.OK,0,"Invalid annotation value "+valOwner.getMessage(),this);res.addSubStatus(valOwner),result.addSubStatus(res)}return result.setValidationPath({name:"("+this.facetName()+")"}),result},Annotation.prototype.kind=function(){return tsInterfaces.MetaInformationKind.Annotation},Annotation}(MetaInfo);exports.Annotation=Annotation;var FacetDeclaration=function(_super){function FacetDeclaration(name,_type,optional){_super.call(this,name,_type,!0),this.name=name,this._type=_type,this.optional=optional}return __extends(FacetDeclaration,_super),FacetDeclaration.prototype.actualName=function(){return"?"==this.name.charAt(this.name.length-1)?this.name.substr(0,this.name.length-1):this.name},FacetDeclaration.prototype.isOptional=function(){return this.optional},FacetDeclaration.prototype.type=function(){return this._type},FacetDeclaration.prototype.kind=function(){return tsInterfaces.MetaInformationKind.FacetDeclaration},FacetDeclaration}(MetaInfo);exports.FacetDeclaration=FacetDeclaration;var CustomFacet=function(_super){function CustomFacet(name,value){_super.call(this,name,value,!0)}return __extends(CustomFacet,_super),CustomFacet.prototype.kind=function(){return tsInterfaces.MetaInformationKind.CustomFacet},CustomFacet}(MetaInfo);exports.CustomFacet=CustomFacet;var Example=function(_super){function Example(value){_super.call(this,"example",value)}return __extends(Example,_super),Example.prototype.validateSelf=function(registry){var status=ts.ok();status.addSubStatus(this.validateValue(registry));var aStatus=this.validateAnnotations(registry);return aStatus.setValidationPath({name:this.facetName()}),status.addSubStatus(aStatus),status},Example.prototype.validateValue=function(registry){var val=this.value(),isVal=!1;if("object"==typeof val&&val&&val.value){if(val.strict===!1)return ts.ok();if(val.strict&&"boolean"!=typeof val.strict){var s=new typesystem_1.Status(typesystem_1.Status.ERROR,0,"'strict' should be boolean",this);return s.setValidationPath({name:"example",child:{name:"strict"}}),s}val=val.value,isVal=!0}var rr=parseExampleIfNeeded(val,this.owner());if(rr instanceof ts.Status)return rr.setValidationPath({name:"example"}),rr;var valOwner=this.owner().validateDirect(rr,!0,!1);if(!valOwner.isOk()){"string"==typeof this.value();var c=new typesystem_1.Status(typesystem_1.Status.ERROR,0,"Using invalid 'example': "+valOwner.getMessage(),this);return valOwner.getErrors().forEach(function(x){c.addSubStatus(x),isVal?x.setValidationPath({name:"example",child:{name:"value"}}):x.setValidationPath({name:"example"})}),c}return ts.ok()},Example.prototype.validateAnnotations=function(registry){var status=ts.ok(),val=this.value();if("object"==typeof val&&val&&val.value)for(var usedAnnotations=Object.keys(val).filter(function(x){return x.length>2&&"("==x.charAt(0)&&")"==x.charAt(x.length-1)}),_i=0,usedAnnotations_1=usedAnnotations;_i<usedAnnotations_1.length;_i++){var ua=usedAnnotations_1[_i],aValue=val[ua],aName=ua.substring(1,ua.length-1),aInstance=new Annotation(aName,aValue);status.addSubStatus(aInstance.validateSelf(registry,!0))}return status},Example.prototype.example=function(){var val=this.value();return"object"==typeof val&&val&&val.value&&(val=val.value),parseExampleIfNeeded(val,this.owner())},Example.prototype.asXMLString=function(){var value=this.value();if("string"==typeof value&&0===value.trim().indexOf("<"))return value;var parsedValue=parseExampleIfNeeded(value,this.owner());return serializeToXml(parsedValue,this.owner())},Example.prototype.kind=function(){return tsInterfaces.MetaInformationKind.Example},Example}(MetaInfo);exports.Example=Example;var Required=function(_super){function Required(value){_super.call(this,"required",value)}return __extends(Required,_super),Required.prototype.validateSelf=function(registry){return"boolean"!=typeof this.value()?new typesystem_1.Status(typesystem_1.Status.ERROR,0,"Value of required facet should be boolean",this):ts.ok()},Required.prototype.kind=function(){return tsInterfaces.MetaInformationKind.Required},Required}(MetaInfo);exports.Required=Required;var HasPropertiesFacet=function(_super){function HasPropertiesFacet(){_super.call(this,"hasPropertiesFacet",null)}return __extends(HasPropertiesFacet,_super),HasPropertiesFacet.prototype.validateSelf=function(registry){return ts.ok()},HasPropertiesFacet.prototype.kind=function(){return tsInterfaces.MetaInformationKind.HasPropertiesFacet},HasPropertiesFacet}(MetaInfo);exports.HasPropertiesFacet=HasPropertiesFacet;var AllowedTargets=function(_super){function AllowedTargets(value){_super.call(this,"allowedTargets",value)}return __extends(AllowedTargets,_super),AllowedTargets.prototype.validateSelf=function(registry){return ts.ok()},AllowedTargets.prototype.kind=function(){return tsInterfaces.MetaInformationKind.AllowedTargets},AllowedTargets}(MetaInfo);exports.AllowedTargets=AllowedTargets;var Examples=function(_super){function Examples(value){_super.call(this,"examples",value)}return __extends(Examples,_super),Examples.prototype.examples=function(){var _this=this,v=this.value(),result=[];return Object.keys(v).forEach(function(x){if("object"==typeof v[x]&&v[x]){var val=v[x].value;val||(val=v[x]);var example=parseExampleIfNeeded(val,_this.owner());result.push(example)}}),result},Examples.prototype.asXMLStrings=function(){var _this=this,value=this.value(),result={};return Object.keys(value).forEach(function(key){var childValue=value[key];if("string"==typeof childValue&&0===childValue.trim().indexOf("<"))return void(result[key]=childValue);var parsedValue=parseExampleIfNeeded(childValue,_this.owner());result[key]=serializeToXml(parsedValue,_this.owner())}),result},Examples.prototype.validateSelf=function(registry){var _this=this;if("object"==typeof this.value()){var rs=new typesystem_1.Status(typesystem_1.Status.OK,0,"",this),v=this.value();return v&&Object.keys(v).forEach(function(x){if(v[x]){var val=v[x].value,noVal=!val;if(noVal)val=v[x];else{if(v[x].strict===!1)return;if(v[x].strict&&"boolean"!=typeof v[x].strict){var s=new typesystem_1.Status(typesystem_1.Status.ERROR,0,"'strict' should be boolean",_this);return s.setValidationPath({name:x,child:{name:"strict",child:{name:"strict"}}}),s}}var example=parseExampleIfNeeded(val,_this.owner());if(example instanceof ts.Status)return examplesPatchPath(example,noVal,x),void rs.addSubStatus(example);var res=_this.owner().validate(example,!0,!1);res.getErrors().forEach(function(ex){rs.addSubStatus(ex),examplesPatchPath(ex,noVal,x)}),"object"==typeof v[x]&&v[x].value&&Object.keys(v[x]).forEach(function(key){if("("==key.charAt(0)&&")"==key.charAt(key.length-1)){var a=new Annotation(key.substring(1,key.length-1),v[x][key]),aRes=a.validateSelf(registry,!0);examplesPatchPath(aRes,!0,x),rs.addSubStatus(aRes)}})}}),rs}return new typesystem_1.Status(typesystem_1.Status.ERROR,0,"'examples' value should be a map",this)},Examples.prototype.kind=function(){return tsInterfaces.MetaInformationKind.Examples},Examples}(MetaInfo);exports.Examples=Examples;var XMLInfo=function(_super){function XMLInfo(o){_super.call(this,"xml",o)}return __extends(XMLInfo,_super),XMLInfo.prototype.kind=function(){return tsInterfaces.MetaInformationKind.XMLInfo},XMLInfo}(MetaInfo);exports.XMLInfo=XMLInfo;var Default=function(_super){function Default(value){_super.call(this,"default",value)}return __extends(Default,_super),Default.prototype.validateSelf=function(registry){var valOwner=this.owner().validateDirect(this.value(),!0);return valOwner.isOk()?ts.ok():new typesystem_1.Status(typesystem_1.Status.ERROR,0,"Using invalid 'defaultValue': "+valOwner.getMessage(),this)},Default.prototype.kind=function(){return tsInterfaces.MetaInformationKind.Default},Default}(MetaInfo);exports.Default=Default;var Discriminator=function(_super){function Discriminator(property){_super.call(this,!0),this.property=property}return __extends(Discriminator,_super),Discriminator.prototype.requiredType=function(){return ts.OBJECT},Discriminator.prototype.value=function(){return this.property},Discriminator.prototype.facetName=function(){return"discriminator"},Discriminator.prototype.validateSelf=function(registry){var _this=this,result=ts.ok();if(this.owner().isUnion())result=new typesystem_1.Status(typesystem_1.Status.ERROR,0,"You can not specify 'discriminator' for union types",this);else if(this.owner().isSubTypeOf(ts.OBJECT))if(this.owner().getExtra(ts.GLOBAL)===!1)result=new typesystem_1.Status(typesystem_1.Status.ERROR,0,"You can not specify 'discriminator' for inline type declarations",this);else{var prop=_.find(this.owner().meta(),function(x){return x instanceof restrictions_1.PropertyIs&&x.propertyName()==_this.value()});prop?prop.value().isScalar()||(result=new typesystem_1.Status(typesystem_1.Status.ERROR,0,"It is only allowed to use scalar properties as discriminators",this)):result=new typesystem_1.Status(typesystem_1.Status.ERROR,0,"Using unknown property '"+this.value()+"' as discriminator",this,!0)}else result=new typesystem_1.Status(typesystem_1.Status.ERROR,0,"You only can use 'discriminator' with object types",this);return result.setValidationPath({name:this.facetName()}),result},Discriminator.prototype.kind=function(){return tsInterfaces.MetaInformationKind.Discriminator},Discriminator}(ts.TypeInformation);exports.Discriminator=Discriminator;var DiscriminatorValue=function(_super){function DiscriminatorValue(_value,strict){void 0===strict&&(strict=!0),_super.call(this,!1),this._value=_value,this.strict=strict}return __extends(DiscriminatorValue,_super),DiscriminatorValue.prototype.check=function(i,path){var owner=this.owner(),dVal=this.value(),discriminator=owner.metaOfType(Discriminator);if(0==discriminator.length)return ts.ok();var dName=discriminator[0].value();if(dVal){if(i.hasOwnProperty(dName)){var adVal=i[dName];if(adVal!=dVal){var wrng=new typesystem_1.Status(typesystem_1.Status.WARNING,typesystem_1.Status.CODE_INCORRECT_DISCRIMINATOR,"None of the '"+owner.name()+"' type known subtypes declare '"+adVal+"' as value of discriminating property '"+dName+"'.",this);return wrng.setValidationPath({name:dName,child:path}),wrng}return ts.ok()}var err=new typesystem_1.Status(typesystem_1.Status.ERROR,typesystem_1.Status.CODE_MISSING_DISCRIMINATOR,"Instance of '"+owner.name()+"' subtype misses value of the discriminating property '"+dName+"'.",this);return err.setValidationPath(path),err}},DiscriminatorValue.prototype.facetName=function(){return"discriminatorValue"},DiscriminatorValue.prototype.validateSelf=function(registry){if(!this.strict)return ts.ok();if(!this.owner().isSubTypeOf(ts.OBJECT))return new typesystem_1.Status(typesystem_1.Status.ERROR,0,"You only can use 'discriminator' with object types",this);if(this.owner().getExtra(ts.GLOBAL)===!1)return new typesystem_1.Status(typesystem_1.Status.ERROR,0,"You only can use 'discriminator' with top level type definitions",this);var ds=this.owner().oneMeta(Discriminator);if(!ds)return new typesystem_1.Status(typesystem_1.Status.ERROR,0,"You can not use 'discriminatorValue' without declaring 'discriminator'",this);var prop=_.find(this.owner().meta(),function(x){return x instanceof restrictions_1.PropertyIs&&x.propertyName()==ds.value()});if(prop){var sm=prop.value().validate(this.value());if(!sm.isOk())return new typesystem_1.Status(typesystem_1.Status.ERROR,0,"Using invalid 'disciminatorValue': "+sm.getMessage(),this)}return ts.ok()},DiscriminatorValue.prototype.requiredType=function(){return ts.OBJECT},DiscriminatorValue.prototype.value=function(){return this._value},DiscriminatorValue.prototype.kind=function(){return tsInterfaces.MetaInformationKind.DiscriminatorValue},DiscriminatorValue.prototype.isStrict=function(){return this.strict},DiscriminatorValue}(ts.Constraint);exports.DiscriminatorValue=DiscriminatorValue},function(module,exports,__webpack_require__){"use strict";function setPropertyConstructor(p){pc=p}function toNominal(t,callback,customizer){void 0===customizer&&(customizer=null);var vs=null;if(t.getExtra(NOMINAL))return t.getExtra(NOMINAL);if(!t){var res=callback("any");res||(vs=new nt.StructuredType(t.name()))}if(t.isBuiltin()){var s="any"!=t.name()&&"array"!=t.name()?callback(t.name()):null;vs=s?s:t.isScalar()?new nt.ValueType(t.name(),null):new nt.StructuredType(t.name())}else if(t.isObject())vs=new nt.StructuredType(t.name(),null);else if(t.isArray()){var ar=new nt.Array(t.name(),null);vs=ar,t.putExtra(NOMINAL,vs);var cm=t.oneMeta(restrictions.ComponentShouldBeOfType),r=cm?cm.value():ts.ANY;ar.setComponent(toNominal(r,callback))}else if(t instanceof ts.UnionType){var ut=new nt.Union(t.name(),null);0==t.superTypes().length&&ut._superTypes.push(toNominal(ts.UNION,callback,customizer)),t.putExtra(NOMINAL,ut),t.options().forEach(function(x){if(null==ut.left)ut.left=toNominal(x,callback);else if(null==ut.right)ut.right=toNominal(x,callback);else{var nu=new nt.Union(t.name(),null);nu.left=ut.right,nu.right=toNominal(x,callback),ut.right=nu}}),vs=ut}else if(t.isScalar())vs=new nt.ValueType(t.name(),null);else if(t instanceof ts.ExternalType){var e=t,et=new nt.ExternalType(e.name());et.schemaString=e.schema(),vs=et}if(vs||(vs=new nt.StructuredType(t.name())),t.superTypes().forEach(function(x){var mn=toNominal(x,callback);x.isBuiltin()?vs._superTypes.push(mn):vs.addSuperType(mn)}),t.isEmpty()){if(t.isArray()&&1==t.superTypes().length&&t.superTypes()[0].isAnonymous()){var q=vs.superTypes()[0];q.setName(t.name()),q._subTypes=q._subTypes.filter(function(x){return x!=vs}),vs=q}if(t.isUnion()&&1==t.superTypes().length&&t.superTypes()[0].isAnonymous()){var q=vs.superTypes()[0];q.setName(t.name()),q._subTypes=q._subTypes.filter(function(x){return x!=vs}),vs=q}}t.putExtra(NOMINAL,vs);var proto=parse.toProto(t);proto.properties.forEach(function(x){var prop=pc?pc(x.id):new nt.Property(x.id);prop.withDomain(vs),prop.withRange(toNominal(x.type,callback)),x.optional||prop.withRequired(!0)}),proto.facetDeclarations.forEach(function(x){var prop=pc?pc(x.facetName()):new nt.Property(x.facetName());prop.withRange(toNominal(x.type(),callback)),vs.addFacet(prop)}),t.customFacets().forEach(function(x){vs.fixFacet(x.facetName(),x.value())});for(var basicFacets=t.metaOfType(restrictions.FacetRestriction),_i=0,basicFacets_1=basicFacets;_i<basicFacets_1.length;_i++){var x=basicFacets_1[_i];vs.fixFacet(x.facetName(),x.value())}return vs.addAdapter(t),t.isEmpty()&&vs.addAdapter(new nt.Empty),vs._validator=function(x){return t.validate(x,!1).getErrors()},t.isBuiltin()?vs.buildIn=!0:t.subTypes().forEach(function(x){toNominal(x,callback,customizer)}),vs}var pc,ts=__webpack_require__(93),nt=__webpack_require__(100),parse=__webpack_require__(95),restrictions=__webpack_require__(97),NOMINAL="nominal";exports.setPropertyConstructor=setPropertyConstructor,exports.toNominal=toNominal},function(module,exports,__webpack_require__){(function(global){"use strict";function registerInjector(i){global.extraInjectors.push(i)}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},ti=__webpack_require__(101),tsInterfaces=__webpack_require__(94),_=__webpack_require__(141);global.extraInjectors=[],exports.registerInjector=registerInjector;var Adaptable=function(){function Adaptable(){var _this=this;this.adapters=[],global.extraInjectors.forEach(function(x){return x.inject(_this)})}return Adaptable.prototype.addAdapter=function(q){this.adapters.push(q)},Adaptable.prototype.getAdapter=function(adapterType){var result=null;return this.adapters.forEach(function(x){x instanceof adapterType&&(result=x)}),result},Adaptable.prototype.getAdapters=function(){return this.adapters},Adaptable}();exports.Adaptable=Adaptable;var Described=function(_super){function Described(_name,_description){void 0===_description&&(_description=""),_super.call(this),this._name=_name,this._description=_description,this._tags=[],this._annotations=[]}return __extends(Described,_super),Described.prototype.nameId=function(){return this._name},Described.prototype.description=function(){return this._description},Described.prototype.addAnnotation=function(a){this._annotations.push(a)},Described.prototype.removeAnnotation=function(a){this._annotations=this._annotations.filter(function(x){return x!=a})},Described.prototype.annotations=function(){return[].concat(this._annotations)},Described.prototype.tags=function(){return this._tags},Described.prototype.withDescription=function(d){return this._description=d,this},Described.prototype.setName=function(name){this._name=name},Described}(Adaptable);exports.Described=Described;var Annotation=function(_super){function Annotation(type,parameters){_super.call(this,type.nameId()),this.type=type,this.parameters=parameters}return __extends(Annotation,_super),Annotation.prototype.parameterNames=function(){return Object.keys(this.parameters)},Annotation.prototype.parameter=function(name){return this.parameters[name]},Annotation.prototype.getType=function(){return this.type},Annotation}(Described);exports.Annotation=Annotation;var Empty=function(){function Empty(){}return Empty}();exports.Empty=Empty;var EmptyUniverse=function(){function EmptyUniverse(){}return EmptyUniverse.prototype.type=function(name){return null},EmptyUniverse.prototype.version=function(){return"Empty"},EmptyUniverse.prototype.types=function(){return[]},EmptyUniverse.prototype.matched=function(){return{}},EmptyUniverse}(),emptyUniverse=new EmptyUniverse,ebuilder=__webpack_require__(137),AbstractType=function(_super){function AbstractType(_name,_universe,_path){void 0===_universe&&(_universe=emptyUniverse),void 0===_path&&(_path=""),_super.call(this,_name),this._universe=_universe,this._path=_path,this._customProperties=[],this._facets=[],this._superTypes=[],this._subTypes=[],this._requirements=[],this.fixedFacets={},this.uc=!1}return __extends(AbstractType,_super),AbstractType.prototype.properties=function(){return[]},AbstractType.prototype.externalInHierarchy=function(){var x=this.allSuperTypes(),res=null;return x.forEach(function(y){y instanceof ExternalType&&(res=y)}),res},AbstractType.prototype.addFacet=function(q){this._facets.push(q)},AbstractType.prototype.validate=function(x){if(!this._validator)throw new Error("Validate can be used only on runtime types instances");return this._validator(x)},AbstractType.prototype.allFacets=function(ps){if(void 0===ps&&(ps={}),this._allFacets)return this._allFacets;if(ps[this.nameId()])return[];ps[this.typeId()]=this;var n={};return this.superTypes().length>0&&this.superTypes().forEach(function(x){x instanceof AbstractType&&x.allFacets(ps).forEach(function(y){return n[y.nameId()]=y})}),this._facets.forEach(function(x){return n[x.nameId()]=x}),this._allFacets=Object.keys(n).map(function(x){return n[x]}),this._allFacets},AbstractType.prototype.facets=function(){return[].concat(this._facets)},AbstractType.prototype.facet=function(name){return _.find(this.allFacets(),function(x){return x.nameId()==name})},AbstractType.prototype.typeId=function(){return this.nameId()},AbstractType.prototype.allProperties=function(ps){if(void 0===ps&&(ps={}),this._props)return this._props;if(ps[this.typeId()])return[];ps[this.typeId()]=this;var n={};this.superTypes().length>0&&this.superTypes().forEach(function(x){x instanceof AbstractType?x.allProperties(ps).forEach(function(y){return n[y.nameId()]=y}):x.allProperties().forEach(function(y){return n[y.nameId()]=y})});for(var x in this.getFixedFacets())delete n[x];return this.properties().forEach(function(x){return n[x.nameId()]=x}),this._props=Object.keys(n).map(function(x){return n[x]}),this._props},AbstractType.prototype.property=function(propName){return _.find(this.allProperties(),function(x){return x.nameId()==propName})},AbstractType.prototype.hasValueTypeInHierarchy=function(){return null!=_.find(this.allSuperTypes(),function(x){var mm=x;if(mm.uc)return!1;mm.uc=!0;try{return x.hasValueTypeInHierarchy()}finally{mm.uc=!1}})},AbstractType.prototype.isAnnotationType=function(){return!1},AbstractType.prototype.hasStructure=function(){return!1},AbstractType.prototype.key=function(){return this._key?this._key:this._universe&&(this._key=this.universe().matched()[this.nameId()],!this._key)?null:this._key},AbstractType.prototype.hasArrayInHierarchy=function(){var arr=null!=_.find(this.allSuperTypes(),function(x){return x instanceof Array});return arr},AbstractType.prototype.arrayInHierarchy=function(){var x=this.allSuperTypes(),res=null;return x.forEach(function(y){y instanceof Array&&(res=y)}),res},AbstractType.prototype.unionInHierarchy=function(){var x=this.allSuperTypes(),res=null;return x.forEach(function(y){y instanceof Union&&(res=y)}),res},AbstractType.prototype.hasExternalInHierarchy=function(){return null!=_.find(this.allSuperTypes(),function(x){var mm=x;if(mm.uc)return!1;mm.uc=!0;try{return x instanceof ExternalType}finally{mm.uc=!1}})},AbstractType.prototype.hasUnionInHierarchy=function(){return null!=_.find(this.allSuperTypes(),function(x){var mm=x;if(mm.uc)return!1;mm.uc=!0;try{return x.hasUnionInHierarchy()}finally{mm.uc=!1}})},AbstractType.prototype.fixFacet=function(name,v){this.fixedFacets[name]=v},AbstractType.prototype.getFixedFacets=function(){var mm={};for(var q in this.fixedFacets)mm[q]=this.fixedFacets[q];return this.contributeFacets(mm),mm},AbstractType.prototype.allFixedFacets=function(){if(this._af)return this._af;var sp=this.allSuperTypes();sp.push(this);var mm={};return sp.forEach(function(x){var ff=x.getFixedFacets();for(var key in Object.keys(ff))mm[key]=ff[key]}),this._af=mm,mm},AbstractType.prototype.contributeFacets=function(x){},AbstractType.prototype.getPath=function(){return this._path},AbstractType.prototype.setNameAtRuntime=function(name){this._nameAtRuntime=name},AbstractType.prototype.getNameAtRuntime=function(){return this._nameAtRuntime},AbstractType.prototype.universe=function(){return this._universe?this._universe:new EmptyUniverse},AbstractType.prototype.superTypes=function(){return[].concat(this._superTypes)},AbstractType.prototype.isAssignableFrom=function(typeName){if(this.nameId()==typeName)return this.isUserDefined()?!1:!0;for(var currentSuperTypes=this.allSuperTypes(),i=0;i<currentSuperTypes.length;i++)if(currentSuperTypes[i].nameId()==typeName)return!0;return!1},AbstractType.prototype.annotationType=function(){return null},AbstractType.prototype.subTypes=function(){return[].concat(this._subTypes)},AbstractType.prototype.allSubTypes=function(){var rs=[];return this.subTypes().forEach(function(x){rs.push(x),rs=rs.concat(x.allSubTypes())}),_.unique(rs)},AbstractType.prototype.allSuperTypes=function(){if(this._allSupers)return this._allSupers;var rs=[];return this.allSuperTypesRecurrent(this,{},rs),this._allSupers=_.unique(rs),this._allSupers},AbstractType.prototype.allSuperTypesRecurrent=function(t,m,result){var _this=this;t.superTypes().forEach(function(x){m[x.typeId()]||(result.push(x),m[x.typeId()]=x,_this.allSuperTypesRecurrent(x,m,result))})},AbstractType.prototype.addSuperType=function(q){q._subTypes.push(this),this._superTypes.push(q)},AbstractType.prototype.addRequirement=function(name,value){this._requirements.push(new ti.ValueRequirement(name,value))},AbstractType.prototype.valueRequirements=function(){return this._requirements},AbstractType.prototype.requiredProperties=function(){return this.allProperties().filter(function(x){return x.isRequired()})},AbstractType.prototype.printDetails=function(indent,settings){var _this=this;indent||(indent=""),settings||(settings={hideProperties:!1,hideSuperTypeProperties:!1,printStandardSuperclasses:!1});var standardIndent="  ",result="",className=this.getTypeClassName();result+=indent+this.nameId()+"["+className+"]\n";var properties=this.properties();properties&&properties.length>0&&!settings.hideProperties&&(result+=indent+standardIndent+"Properties:\n",properties.forEach(function(property){var propertyType="",propertyRange=property.range();propertyRange instanceof Described&&(propertyType+=propertyRange.nameId()),propertyRange instanceof AbstractType&&(propertyType+="[",propertyType+=propertyRange.getTypeClassName(),propertyType+="]"),result+=indent+standardIndent+standardIndent+property.nameId()+" : "+propertyType+"\n"}));var superTypes=this.superTypes(),filteredSuperTypes=superTypes;return superTypes&&!settings.printStandardSuperclasses&&(filteredSuperTypes=_.filter(superTypes,function(superType){var name=superType instanceof Described?superType.nameId():"",type=superType instanceof AbstractType?superType.getTypeClassName():"";return!_this.isStandardSuperclass(name,type)})),filteredSuperTypes&&filteredSuperTypes.length>0&&(result+=indent+standardIndent+"Super types:\n",filteredSuperTypes.forEach(function(superType){result+=superType.printDetails(indent+standardIndent+standardIndent,{hideProperties:settings.hideSuperTypeProperties,hideSuperTypeProperties:settings.hideSuperTypeProperties,printStandardSuperclasses:settings.printStandardSuperclasses})})),result},AbstractType.prototype.getTypeClassName=function(){return this.constructor.toString().match(/\w+/g)[1]},AbstractType.prototype.isStandardSuperclass=function(nameId,className){return"TypeDeclaration"===nameId&&"NodeClass"===className?!0:"ObjectTypeDeclaration"===nameId&&"NodeClass"===className?!0:"RAMLLanguageElement"===nameId&&"NodeClass"===className?!0:!1},AbstractType.prototype.examples=function(collectFromSupertype){return ebuilder.exampleFromNominal(this,collectFromSupertype)},AbstractType.prototype.isGenuineUserDefinedType=function(){return this.buildIn?!1:this.properties()&&this.properties().length>0?!0:this.getFixedFacets()&&Object.keys(this.getFixedFacets()).length>0?!0:this.isTopLevel()&&this.nameId()&&this.nameId().length>0},AbstractType.prototype.genuineUserDefinedTypeInHierarchy=function(){if(this.isGenuineUserDefinedType())return this;var result=null,allSuperTypes=this.allSuperTypes();return allSuperTypes.forEach(function(currentSuperType){!result&&currentSuperType.isGenuineUserDefinedType()&&(result=currentSuperType)}),result},AbstractType.prototype.hasGenuineUserDefinedTypeInHierarchy=function(){return null!=_.find(this.allSuperTypes(),function(x){var mm=x;if(mm.uc)return!1;mm.uc=!0;try{return x.isGenuineUserDefinedType()}finally{mm.uc=!1}})},AbstractType.prototype.customProperties=function(){return[].concat(this._customProperties)},AbstractType.prototype.allCustomProperties=function(){var props=[];return this.superTypes().forEach(function(x){return props=props.concat(x.allCustomProperties())}),props=props.concat(this.customProperties())},AbstractType.prototype.registerCustomProperty=function(p){if(p.domain()!=this)throw new Error("Should be already owned by this");if(-1!=this._customProperties.indexOf(p))throw new Error("Already included");this._customProperties.push(p)},AbstractType.prototype.setCustom=function(val){this._isCustom=val},AbstractType.prototype.isCustom=function(){return this._isCustom},AbstractType.prototype.isUnion=function(){return!1},AbstractType.prototype.union=function(){return null},AbstractType.prototype.isExternal=function(){return!1},AbstractType.prototype.external=function(){return null},AbstractType.prototype.isArray=function(){return!1},AbstractType.prototype.isObject=function(){if("object"==this.nameId())return!0;for(var _i=0,_a=this.allSuperTypes();_i<_a.length;_i++){var t=_a[_i];if(t.isObject())return!0}return!1},AbstractType.prototype.array=function(){return null},AbstractType.prototype.isValueType=function(){return!1},AbstractType.prototype.kind=function(){var result=[];return this.isObject()&&result.push("object"),this.isArray()&&result.push("array"),this.isValueType()&&result.push("value"),this.isUnion()&&result.push("union"),this.isAnnotationType()&&result.push("annotation"),this.isExternal()&&result.push("external"),result},AbstractType.prototype.isBuiltIn=function(){return this.buildIn},AbstractType.prototype.setBuiltIn=function(builtIn){this.buildIn=builtIn},AbstractType.prototype.isTopLevel=function(){return this.getExtra(tsInterfaces.DEFINED_IN_TYPES_EXTRA)||this.getExtra(tsInterfaces.TOP_LEVEL_EXTRA)?!0:!1},AbstractType.prototype.isUserDefined=function(){return this.getExtra(tsInterfaces.USER_DEFINED_EXTRA)&&!this.buildIn},AbstractType.prototype.putExtra=function(extraName,value){var extraAdapter=this.getExtraAdapter();extraAdapter&&extraAdapter.putExtra(extraName,value)},AbstractType.prototype.getExtra=function(name){var extraAdapter=this.getExtraAdapter();return extraAdapter?extraAdapter.getExtra(name):null},AbstractType.prototype.getExtraAdapter=function(){if(this.getAdapters()){var extraAdapter=_.find(this.getAdapters(),function(adapter){return adapter.getExtra&&"function"==typeof adapter.getExtra&&adapter.putExtra&&"function"==typeof adapter.putExtra?!0:void 0});return extraAdapter}return null},AbstractType}(Described);exports.AbstractType=AbstractType;var ValueType=function(_super){function ValueType(name,_universe,path,description){void 0===_universe&&(_universe=null),void 0===path&&(path=""),void 0===description&&(description=""),_super.call(this,name,_universe,path)}return __extends(ValueType,_super),ValueType.prototype.hasStructure=function(){return!1},ValueType.prototype.hasValueTypeInHierarchy=function(){return!0},ValueType.prototype.isValueType=function(){return!0},ValueType.prototype.isUnionType=function(){return!1},ValueType.prototype.isObject=function(){return!1},ValueType}(AbstractType);exports.ValueType=ValueType;var StructuredType=function(_super){function StructuredType(){_super.apply(this,arguments),this._properties=[]}return __extends(StructuredType,_super),StructuredType.prototype.hasStructure=function(){return!0},StructuredType.prototype.propertyIndex=function(name){for(var props=this.properties(),i=0;i<props.length;i++)if(props[i].nameId()==name)return i;return-1},StructuredType.prototype.addProperty=function(name,range){return new Property(name).withDomain(this).withRange(range)},StructuredType.prototype.allPropertyIndex=function(name){for(var props=this.allProperties(),i=0;i<props.length;i++)if(props[i].nameId()==name)return i;return-1},StructuredType.prototype.properties=function(){return[].concat(this._properties)},StructuredType.prototype.registerProperty=function(p){if(p.domain()!=this)throw new Error("Should be already owned by this");if(-1!=this._properties.indexOf(p))throw new Error("Already included");this._properties.push(p)},StructuredType}(AbstractType);exports.StructuredType=StructuredType;var Property=function(_super){function Property(){_super.apply(this,arguments),this._keyShouldStartFrom=null,
this._isRequired=!1,this._isMultiValue=!1,this._descriminates=!1,this._defaultBooleanValue=null,this._defaultIntegerValue=null}return __extends(Property,_super),Property.prototype.withMultiValue=function(v){return void 0===v&&(v=!0),this._isMultiValue=v,this},Property.prototype.withDescriminating=function(b){return this._descriminates=b,this},Property.prototype.withRequired=function(req){return this._isRequired=req,this},Property.prototype.isRequired=function(){return this._isRequired},Property.prototype.withKeyRestriction=function(keyShouldStartFrom){return this._keyShouldStartFrom=keyShouldStartFrom,this},Property.prototype.withDomain=function(d,custom){return void 0===custom&&(custom=!1),this._ownerClass=d,custom?d.registerCustomProperty(this):d.registerProperty(this),this},Property.prototype.setDefaultVal=function(s){return this._defaultValue=s,this},Property.prototype.setDefaultBooleanVal=function(s){return this._defaultBooleanValue=s,this},Property.prototype.setDefaultIntegerVal=function(s){return this._defaultIntegerValue=s,this},Property.prototype.defaultValue=function(){return null!=this._defaultValue?this._defaultValue:null!=this._defaultBooleanValue?this._defaultBooleanValue:null!=this._defaultIntegerValue?this._defaultIntegerValue:null},Property.prototype.isPrimitive=function(){return!1},Property.prototype.withRange=function(t){return this._nodeRange=t,this},Property.prototype.isValueProperty=function(){return this._nodeRange.hasValueTypeInHierarchy()},Property.prototype.enumOptions=function(){return this._enumOptions&&"string"==typeof this._enumOptions?[this._enumOptions+""]:this._enumOptions},Property.prototype.keyPrefix=function(){return this._keyShouldStartFrom},Property.prototype.withEnumOptions=function(op){return this._enumOptions=op,this},Property.prototype.withKeyRegexp=function(regexp){return this._keyRegexp=regexp,this},Property.prototype.getKeyRegexp=function(){return this._keyRegexp},Property.prototype.matchKey=function(k){if(null==k)return!1;if(null!=this._groupName)return this._groupName==k;if(null!=this._keyShouldStartFrom&&0==k.indexOf(this._keyShouldStartFrom))return!0;if(this._enumOptions&&-1!=this._enumOptions.indexOf(k))return!0;if(this.getKeyRegexp())try{if(new RegExp(this.getKeyRegexp()).test(k))return!0}catch(Error){}return!1},Property.prototype.getFacetValidator=function(){return this.facetValidator},Property.prototype.setFacetValidator=function(f){this.facetValidator=f},Property.prototype.domain=function(){return this._ownerClass},Property.prototype.range=function(){return this._nodeRange},Property.prototype.isMultiValue=function(){return this.range()&&this.range().hasArrayInHierarchy()?!0:this._isMultiValue},Property.prototype.isDescriminator=function(){return this._descriminates},Property}(Described);exports.Property=Property;var Union=function(_super){function Union(){_super.apply(this,arguments)}return __extends(Union,_super),Union.prototype.key=function(){return null},Union.prototype.leftType=function(){return this.left},Union.prototype.rightType=function(){return this.right},Union.prototype.isUserDefined=function(){return!0},Union.prototype.unionInHierarchy=function(){return this},Union.prototype.union=function(){return this},Union.prototype.hasUnionInHierarchy=function(){return!0},Union.prototype.isUnion=function(){return!0},Union.prototype.isObject=function(){return this.leftType().isObject()&&this.rightType().isObject()},Union.prototype.hasArrayInHierarchy=function(){return this.left&&this.right?this.left.hasArrayInHierarchy()||this.right.hasArrayInHierarchy():this.left?this.left.hasArrayInHierarchy():this.right?this.right.hasArrayInHierarchy():void 0},Union}(AbstractType);exports.Union=Union;var Array=function(_super){function Array(){_super.apply(this,arguments)}return __extends(Array,_super),Array.prototype.hasArrayInHierarchy=function(){return!0},Array.prototype.isArray=function(){return!0},Array.prototype.isObject=function(){return!1},Array.prototype.arrayInHierarchy=function(){return this},Array.prototype.array=function(){return this},Array.prototype.isUserDefined=function(){return!0},Array.prototype.componentType=function(){return this.component},Array.prototype.setComponent=function(t){this.component=t},Array.prototype.key=function(){return null},Array}(AbstractType);exports.Array=Array;var ExternalType=function(_super){function ExternalType(){_super.apply(this,arguments)}return __extends(ExternalType,_super),ExternalType.prototype.externalInHierarchy=function(){return this},ExternalType.prototype.typeId=function(){return this.schemaString},ExternalType.prototype.schema=function(){return this.schemaString},ExternalType.prototype.isUserDefined=function(){return!0},ExternalType.prototype.hasExternalInHierarchy=function(){return!0},ExternalType.prototype.isExternal=function(){return!0},ExternalType.prototype.external=function(){return this},ExternalType}(StructuredType);exports.ExternalType=ExternalType}).call(exports,function(){return this}())},function(module,exports,__webpack_require__){"use strict";var ValueRequirement=function(){function ValueRequirement(name,value){this.name=name,this.value=value}return ValueRequirement}();exports.ValueRequirement=ValueRequirement},function(module,exports,__webpack_require__){"use strict";function visit(node,action){te.visit(node,action)}function serializeToString(node){return te.serializeToString(node)}function parse(str){return te.parse(str)}var te=__webpack_require__(139);exports.visit=visit,exports.serializeToString=serializeToString,exports.parse=parse},function(module,exports,__webpack_require__){(function(global){"use strict";function getJSONSchema(content,provider){var key=schemaKey(provider,content),rs=useLint?globalCache.getValue(key):!1;if(rs&&rs.provider)return rs;var res=new JSONSchemaObject(content,provider);return globalCache.setValue(key,res),res}function getXMLSchema(content,provider){var rs=(schemaKey(provider,content),useLint?globalCache.getValue(content):!1);if(rs)return rs;var res=new XMLSchemaObject(content);return useLint&&globalCache.setValue(content,res),res}function createSchema(content,provider){var key=schemaKey(provider,content),rs=useLint?globalCache.getValue(key):!1;if(rs)return rs;try{var res=new JSONSchemaObject(content,provider);return useLint&&globalCache.setValue(key,res),res}catch(e){try{var res=new XMLSchemaObject(content);return useLint&&globalCache.setValue(key,res),res}catch(e){return useLint&&globalCache.setValue(key,new Error("Can not parse schema")),null}}}function elementChildrenByName(parent,tagName){for(var elements=parent.getElementsByTagName(tagName),result=[],i=0;i<elements.length;i++){var child=elements[i];child.parentNode===parent&&result.push(child)}return result}var _=__webpack_require__(141),xmlUtil=__webpack_require__(142),jsonUtil=__webpack_require__(143),DOMParser=__webpack_require__(178).DOMParser,ValidationResult=function(){function ValidationResult(){}return ValidationResult}();exports.ValidationResult=ValidationResult;var useLint=!0,ErrorsCache=function(){function ErrorsCache(){this.errors={}}return ErrorsCache.prototype.getValue=function(key){return this.errors[key]},ErrorsCache.prototype.setValue=function(key,value){this.errors[key]=value},ErrorsCache}(),globalCache=new ErrorsCache;global.cleanCache=function(){globalCache=new ErrorsCache};var DummyProvider=function(){function DummyProvider(){}return DummyProvider.prototype.contextPath=function(){return""},DummyProvider.prototype.normalizePath=function(url){return""},DummyProvider.prototype.content=function(reference){return""},DummyProvider.prototype.hasAsyncRequests=function(){return!1},DummyProvider.prototype.resolvePath=function(context,relativePath){return""},DummyProvider.prototype.isAbsolutePath=function(uri){return!1},DummyProvider.prototype.contentAsync=function(reference){var _this=this;return{then:function(arg){return arg(_this.content(reference))},resolve:function(){return null}}},DummyProvider.prototype.promiseResolve=function(arg){return{then:function(arg1){return arg1(arg)},resolve:function(){return null}}},DummyProvider}(),exampleKey=function(content,schema,contextPath){return"__EXAMPLE_"+content+schema+contextPath},JSONSchemaObject=function(){function JSONSchemaObject(schema,provider){if(this.schema=schema,this.provider=provider,provider?this.provider=provider:this.provider=new DummyProvider,!schema||0==schema.trim().length||"{"!=schema.trim().charAt(0))throw new Error("Invalid JSON schema content");var jsonSchemaObject;try{var jsonSchemaObject=JSON.parse(schema)}catch(err){throw new Error("It is not JSON schema(can not parse JSON: "+err.message+")")}if(jsonSchemaObject){try{var api=__webpack_require__(179);this.setupId(jsonSchemaObject,this.provider.contextPath());var schemaVer=""+jsonSchemaObject.$schema;-1==schemaVer.indexOf("http://json-schema.org/draft-04/")?jsonSchemaObject=api.v4(jsonSchemaObject):this.fixRequired(jsonSchemaObject)}catch(e){throw new Error("Can not parse schema"+schema)}delete jsonSchemaObject.$schema,this.jsonSchema=jsonSchemaObject}}return JSONSchemaObject.prototype.fixRequired=function(obj){},JSONSchemaObject.prototype.getType=function(){return"source.json"},JSONSchemaObject.prototype.validateObject=function(object){this.validate(JSON.stringify(object))},JSONSchemaObject.prototype.getMissingReferences=function(references,normalize){var _this=this;void 0===normalize&&(normalize=!1);var result=[],validator=jsonUtil.getValidator();references.forEach(function(reference){return validator.setRemoteReference(reference.reference,reference.content||{})});var schemaUrl=null;if(this.jsonSchema.id&&"string"==typeof this.jsonSchema.id){schemaUrl=this.jsonSchema.id;var innerPos=schemaUrl.indexOf("#");-1!=innerPos&&(schemaUrl=schemaUrl.substr(0,innerPos))}try{validator.validateSchema(this.jsonSchema)}catch(Error){return[]}var result=validator.getMissingRemoteReferences(),filteredReferences=[];return result&&(filteredReferences=_.filter(result,function(referenceUrl){return!validator.isResourceLoaded(referenceUrl)&&referenceUrl!=schemaUrl})),normalize?filteredReferences.map(function(reference){return _this.provider.normalizePath(reference)}):filteredReferences},JSONSchemaObject.prototype.getSchemaPath=function(schema,normalize){if(void 0===normalize&&(normalize=!1),!schema)return"";if(!schema.id)return"";var id=schema.id.trim();if(id.lastIndexOf("#")!==id.length-1)return id;var result=id.substr(0,id.length-1);return normalize?this.provider.normalizePath(result):result},JSONSchemaObject.prototype.patchSchema=function(schema){var _this=this;if(!schema)return schema;if(!schema.id)return schema;var id=schema.id.trim();id.lastIndexOf("#")!==id.length-1&&(id+="#",schema.id=id);var currentPath=id.substr(0,id.length-1);if(!this.provider.isAbsolutePath(currentPath))return schema;currentPath=this.provider.normalizePath(currentPath);var refContainers=[];this.collectRefContainers(schema,refContainers),refContainers.forEach(function(refConatiner){var reference=refConatiner.$ref;if("string"==typeof reference&&0!==reference.indexOf("#")){-1===reference.indexOf("#")&&(reference+="#");var resolvedRef=_this.provider.resolvePath(currentPath,reference);refConatiner.$ref=resolvedRef}})},JSONSchemaObject.prototype.collectRefContainers=function(rootObject,refContainers){var _this=this;Object.keys(rootObject).forEach(function(key){return"$ref"===key?void refContainers.push(rootObject):void(rootObject[key]&&"object"==typeof rootObject[key]&&_this.collectRefContainers(rootObject[key],refContainers))})},JSONSchemaObject.prototype.validate=function(content,alreadyAccepted){var _this=this;void 0===alreadyAccepted&&(alreadyAccepted=[]);var key=exampleKey(content,this.schema,this.provider.contextPath()),error=globalCache.getValue(key);if(error){if(error instanceof Error)throw error}else{var validator=jsonUtil.getValidator();alreadyAccepted.forEach(function(accepted){return validator.setRemoteReference(accepted.reference,accepted.content)}),validator.validate(JSON.parse(content),this.jsonSchema);var missingReferences=validator.getMissingRemoteReferences().filter(function(reference){return!_.find(alreadyAccepted,function(acceptedReference){return reference===acceptedReference.reference})});if(!missingReferences||0===missingReferences.length)return void this.acceptErrors(key,validator.getLastErrors(),!0);var acceptedReferences=[];missingReferences.forEach(function(reference){var remoteSchemeContent,result={reference:reference};try{var api=__webpack_require__(179),jsonObject=JSON.parse(_this.provider.content(reference));_this.setupId(jsonObject,_this.provider.normalizePath(reference)),remoteSchemeContent=api.v4(jsonObject),delete remoteSchemeContent.$schema,result.content=remoteSchemeContent}catch(exception){result.error=exception}finally{acceptedReferences.push(result)}}),this.provider.hasAsyncRequests()||(acceptedReferences.forEach(function(accepted){alreadyAccepted.push(accepted)}),this.validate(content,alreadyAccepted))}},JSONSchemaObject.prototype.setupId=function(json,path){if(path&&json){if(json.id)return json.id=json.id.trim(),void(json.id.indexOf("#")<0&&(json.id=json.id+"#"));json.id=path.replace(/\\/g,"/")+"#",this.patchSchema(json)}},JSONSchemaObject.prototype.acceptErrors=function(key,errors,throwImmediately){if(void 0===throwImmediately&&(throwImmediately=!1),errors&&errors.length>0){var res=new Error("Content is not valid according to schema: "+errors.map(function(x){return x.message+" "+x.params}).join(", "));if(res.errors=errors,globalCache.setValue(key,res),throwImmediately)throw res}else globalCache.setValue(key,1)},JSONSchemaObject.prototype.contentAsync=function(reference){var remoteSchemeContent,_this=this,api=__webpack_require__(179),contentPromise=this.provider.contentAsync(reference);if(!contentPromise)return this.provider.promiseResolve({reference:reference,content:null,error:new Error("Reference not found: '"+reference+"'")});var result=contentPromise.then(function(cnt){var content={reference:reference};try{var jsonObject=JSON.parse(cnt);_this.setupId(jsonObject,_this.provider.normalizePath(reference)),remoteSchemeContent=api.v4(jsonObject),delete remoteSchemeContent.$schema,content.content=remoteSchemeContent}catch(exception){content.error=exception}return content});return result},JSONSchemaObject}();exports.JSONSchemaObject=JSONSchemaObject;var MAX_EXAMPLES_TRESHOLD=10,XMLSchemaObject=function(){function XMLSchemaObject(schema){if(this.schema=schema,this.extraElementData=null,this.contentToResult={},"<"!=schema.charAt(0))throw new Error("Invalid JSON schema");this.schemaObj=xmlUtil.getValidator(this.handleReferenceElement(schema))}return XMLSchemaObject.prototype.getType=function(){return"text.xml"},XMLSchemaObject.prototype.validateObject=function(object){if(this.extraElementData){var objectName=Object.keys(object)[0];if(!this.extraElementData.type&&!this.extraElementData.originalName)return void this.acceptErrors("key",[new Error("Referenced type '"+this.extraElementData.requestedName+"' does not match '"+objectName+"' root node")],!0);if(this.extraElementData.originalName&&objectName!==this.extraElementData.originalName)return void this.acceptErrors("key",[new Error("Referenced type '"+this.extraElementData.requestedName+"' does not match '"+objectName+"' root node")],!0);if(this.extraElementData.type){var root=object[objectName];delete object[objectName],object[this.extraElementData.name]=root}}this.validate(xmlUtil.jsonToXml(object))},XMLSchemaObject.prototype.validate=function(xml){try{var rs=this.contentToResult[xml];if(rs===!1)return;if(rs)throw rs;var validationErrors=this.schemaObj.validate(xml);this.acceptErrors("key",validationErrors,!0),this.contentToResult[xml]=!1,Object.keys(this.contentToResult).length>MAX_EXAMPLES_TRESHOLD&&(this.contentToResult={})}catch(e){throw this.contentToResult[xml]=e,e}},XMLSchemaObject.prototype.handleReferenceElement=function(content){var doc=(new DOMParser).parseFromString(content),schema=elementChildrenByName(doc,"xs:schema")[0],elements=elementChildrenByName(schema,"xs:element"),element=_.find(elements,function(element){return"true"===element.getAttribute("extraelement")});if(!element)return content;var extraElementData={};return extraElementData.name=element.getAttribute("name"),extraElementData.type=element.getAttribute("type"),extraElementData.originalName=element.getAttribute("originalname"),extraElementData.requestedName=element.getAttribute("requestedname"),extraElementData.type||schema.removeChild(element),element.removeAttribute("originalname"),element.removeAttribute("requestedname"),element.removeAttribute("extraelement"),this.extraElementData=extraElementData,doc.toString()},XMLSchemaObject.prototype.acceptErrors=function(key,errors,throwImmediately){if(void 0===throwImmediately&&(throwImmediately=!1),errors&&errors.length>0){var res=new Error("Content is not valid according to schema: "+errors.map(function(x){return x.message}).join(", "));if(res.errors=errors,globalCache.setValue(key,res),throwImmediately)throw res}else;},XMLSchemaObject}();exports.XMLSchemaObject=XMLSchemaObject,exports.getJSONSchema=getJSONSchema;var schemaKey=function(provider,content){var contextPath="";provider&&(contextPath=provider.contextPath());var key="__SCHEMA_"+content+contextPath;return key};exports.getXMLSchema=getXMLSchema,exports.createSchema=createSchema}).call(exports,function(){return this}())},function(module,exports,__webpack_require__){"use strict";function hasOwnProperty(obj,prop){return Object.prototype.hasOwnProperty.call(obj,prop)}module.exports=function(qs,sep,eq,options){sep=sep||"&",eq=eq||"=";var obj={};if("string"!=typeof qs||0===qs.length)return obj;var regexp=/\+/g;qs=qs.split(sep);var maxKeys=1e3;options&&"number"==typeof options.maxKeys&&(maxKeys=options.maxKeys);var len=qs.length;maxKeys>0&&len>maxKeys&&(len=maxKeys);for(var i=0;len>i;++i){var kstr,vstr,k,v,x=qs[i].replace(regexp,"%20"),idx=x.indexOf(eq);idx>=0?(kstr=x.substr(0,idx),vstr=x.substr(idx+1)):(kstr=x,vstr=""),k=decodeURIComponent(kstr),v=decodeURIComponent(vstr),hasOwnProperty(obj,k)?Array.isArray(obj[k])?obj[k].push(v):obj[k]=[obj[k],v]:obj[k]=v}return obj}},function(module,exports,__webpack_require__){"use strict";var stringifyPrimitive=function(v){switch(typeof v){case"string":return v;case"boolean":return v?"true":"false";case"number":return isFinite(v)?v:"";default:return""}};module.exports=function(obj,sep,eq,name){return sep=sep||"&",eq=eq||"=",null===obj&&(obj=void 0),"object"==typeof obj?Object.keys(obj).map(function(k){var ks=encodeURIComponent(stringifyPrimitive(k))+eq;return Array.isArray(obj[k])?obj[k].map(function(v){return ks+encodeURIComponent(stringifyPrimitive(v))}).join(sep):ks+encodeURIComponent(stringifyPrimitive(obj[k]))}).join(sep):name?encodeURIComponent(stringifyPrimitive(name))+eq+encodeURIComponent(stringifyPrimitive(obj)):""}},function(module,exports,__webpack_require__){exports.parse=__webpack_require__(144),exports.stringify=__webpack_require__(145)},function(module,exports,__webpack_require__){function configureProperties(obj){if(getOwnPropNames&&defineProp){var i,props=getOwnPropNames(obj);for(i=0;i<props.length;i+=1)defineProp(obj,props[i],{value:obj[props[i]],writable:!1,enumerable:!1,configurable:!1})}}function makeArrayAccessors(obj){function makeArrayAccessor(index){defineProp(obj,index,{get:function(){return obj._getter(index)},set:function(v){obj._setter(index,v)},enumerable:!0,configurable:!1})}if(defineProp){if(obj.length>MAX_ARRAY_LENGTH)throw new RangeError("Array too large for polyfill");var i;for(i=0;i<obj.length;i+=1)makeArrayAccessor(i)}}function as_signed(value,bits){var s=32-bits;return value<<s>>s}function as_unsigned(value,bits){var s=32-bits;return value<<s>>>s}function packI8(n){return[255&n]}function unpackI8(bytes){return as_signed(bytes[0],8)}function packU8(n){return[255&n]}function unpackU8(bytes){return as_unsigned(bytes[0],8)}function packU8Clamped(n){return n=round(Number(n)),[0>n?0:n>255?255:255&n]}function packI16(n){return[n>>8&255,255&n]}function unpackI16(bytes){return as_signed(bytes[0]<<8|bytes[1],16)}function packU16(n){return[n>>8&255,255&n]}function unpackU16(bytes){return as_unsigned(bytes[0]<<8|bytes[1],16)}function packI32(n){return[n>>24&255,n>>16&255,n>>8&255,255&n]}function unpackI32(bytes){return as_signed(bytes[0]<<24|bytes[1]<<16|bytes[2]<<8|bytes[3],32)}function packU32(n){return[n>>24&255,n>>16&255,n>>8&255,255&n]}function unpackU32(bytes){return as_unsigned(bytes[0]<<24|bytes[1]<<16|bytes[2]<<8|bytes[3],32)}function packIEEE754(v,ebits,fbits){function roundToEven(n){var w=floor(n),f=n-w;return.5>f?w:f>.5?w+1:w%2?w+1:w}var s,e,f,i,bits,str,bytes,bias=(1<<ebits-1)-1;for(v!==v?(e=(1<<ebits)-1,f=pow(2,fbits-1),s=0):v===1/0||v===-(1/0)?(e=(1<<ebits)-1,f=0,s=0>v?1:0):0===v?(e=0,f=0,s=1/v===-(1/0)?1:0):(s=0>v,v=abs(v),v>=pow(2,1-bias)?(e=min(floor(log(v)/LN2),1023),f=roundToEven(v/pow(2,e)*pow(2,fbits)),f/pow(2,fbits)>=2&&(e+=1,f=1),e>bias?(e=(1<<ebits)-1,f=0):(e+=bias,f-=pow(2,fbits))):(e=0,f=roundToEven(v/pow(2,1-bias-fbits)))),bits=[],i=fbits;i;i-=1)bits.push(f%2?1:0),f=floor(f/2);for(i=ebits;i;i-=1)bits.push(e%2?1:0),e=floor(e/2);for(bits.push(s?1:0),bits.reverse(),str=bits.join(""),bytes=[];str.length;)bytes.push(parseInt(str.substring(0,8),2)),str=str.substring(8);return bytes}function unpackIEEE754(bytes,ebits,fbits){var i,j,b,str,bias,s,e,f,bits=[];for(i=bytes.length;i;i-=1)for(b=bytes[i-1],j=8;j;j-=1)bits.push(b%2?1:0),b>>=1;return bits.reverse(),str=bits.join(""),bias=(1<<ebits-1)-1,s=parseInt(str.substring(0,1),2)?-1:1,e=parseInt(str.substring(1,1+ebits),2),f=parseInt(str.substring(1+ebits),2),e===(1<<ebits)-1?0!==f?NaN:s*(1/0):e>0?s*pow(2,e-bias)*(1+f/pow(2,fbits)):0!==f?s*pow(2,-(bias-1))*(f/pow(2,fbits)):0>s?-0:0}function unpackF64(b){return unpackIEEE754(b,11,52)}function packF64(v){return packIEEE754(v,11,52)}function unpackF32(b){return unpackIEEE754(b,8,23)}function packF32(v){return packIEEE754(v,8,23)}var defineProp,undefined=void 0,MAX_ARRAY_LENGTH=1e5,ECMAScript=function(){var opts=Object.prototype.toString,ophop=Object.prototype.hasOwnProperty;return{Class:function(v){return opts.call(v).replace(/^\[object *|\]$/g,"")},HasProperty:function(o,p){return p in o},HasOwnProperty:function(o,p){return ophop.call(o,p)},IsCallable:function(o){return"function"==typeof o},ToInt32:function(v){return v>>0},ToUint32:function(v){return v>>>0}}}(),LN2=Math.LN2,abs=Math.abs,floor=Math.floor,log=Math.log,min=Math.min,pow=Math.pow,round=Math.round;defineProp=Object.defineProperty&&function(){try{return Object.defineProperty({},"x",{}),!0}catch(e){return!1}}()?Object.defineProperty:function(o,p,desc){if(!o===Object(o))throw new TypeError("Object.defineProperty called on non-object");return ECMAScript.HasProperty(desc,"get")&&Object.prototype.__defineGetter__&&Object.prototype.__defineGetter__.call(o,p,desc.get),ECMAScript.HasProperty(desc,"set")&&Object.prototype.__defineSetter__&&Object.prototype.__defineSetter__.call(o,p,desc.set),ECMAScript.HasProperty(desc,"value")&&(o[p]=desc.value),o};var getOwnPropNames=Object.getOwnPropertyNames||function(o){if(o!==Object(o))throw new TypeError("Object.getOwnPropertyNames called on non-object");var p,props=[];for(p in o)ECMAScript.HasOwnProperty(o,p)&&props.push(p);return props};!function(){function makeConstructor(bytesPerElement,pack,unpack){var ctor;return ctor=function(buffer,byteOffset,length){var array,sequence,i,s;if(arguments.length&&"number"!=typeof arguments[0])if("object"==typeof arguments[0]&&arguments[0].constructor===ctor)for(array=arguments[0],this.length=array.length,this.byteLength=this.length*this.BYTES_PER_ELEMENT,this.buffer=new ArrayBuffer(this.byteLength),this.byteOffset=0,i=0;i<this.length;i+=1)this._setter(i,array._getter(i));else if("object"!=typeof arguments[0]||(arguments[0]instanceof ArrayBuffer||"ArrayBuffer"===ECMAScript.Class(arguments[0]))){if("object"!=typeof arguments[0]||!(arguments[0]instanceof ArrayBuffer||"ArrayBuffer"===ECMAScript.Class(arguments[0])))throw new TypeError("Unexpected argument type(s)");if(this.buffer=buffer,this.byteOffset=ECMAScript.ToUint32(byteOffset),this.byteOffset>this.buffer.byteLength)throw new RangeError("byteOffset out of range");if(this.byteOffset%this.BYTES_PER_ELEMENT)throw new RangeError("ArrayBuffer length minus the byteOffset is not a multiple of the element size.");if(arguments.length<3){if(this.byteLength=this.buffer.byteLength-this.byteOffset,this.byteLength%this.BYTES_PER_ELEMENT)throw new RangeError("length of buffer minus byteOffset not a multiple of the element size");this.length=this.byteLength/this.BYTES_PER_ELEMENT}else this.length=ECMAScript.ToUint32(length),this.byteLength=this.length*this.BYTES_PER_ELEMENT;if(this.byteOffset+this.byteLength>this.buffer.byteLength)throw new RangeError("byteOffset and length reference an area beyond the end of the buffer")}else for(sequence=arguments[0],this.length=ECMAScript.ToUint32(sequence.length),this.byteLength=this.length*this.BYTES_PER_ELEMENT,this.buffer=new ArrayBuffer(this.byteLength),this.byteOffset=0,i=0;i<this.length;i+=1)s=sequence[i],this._setter(i,Number(s));else{if(this.length=ECMAScript.ToInt32(arguments[0]),0>length)throw new RangeError("ArrayBufferView size is not a small enough positive integer");this.byteLength=this.length*this.BYTES_PER_ELEMENT,this.buffer=new ArrayBuffer(this.byteLength),this.byteOffset=0}this.constructor=ctor,configureProperties(this),makeArrayAccessors(this)},ctor.prototype=new ArrayBufferView,ctor.prototype.BYTES_PER_ELEMENT=bytesPerElement,ctor.prototype._pack=pack,ctor.prototype._unpack=unpack,ctor.BYTES_PER_ELEMENT=bytesPerElement,ctor.prototype._getter=function(index){if(arguments.length<1)throw new SyntaxError("Not enough arguments");if(index=ECMAScript.ToUint32(index),index>=this.length)return undefined;var i,o,bytes=[];for(i=0,o=this.byteOffset+index*this.BYTES_PER_ELEMENT;i<this.BYTES_PER_ELEMENT;i+=1,o+=1)bytes.push(this.buffer._bytes[o]);return this._unpack(bytes)},ctor.prototype.get=ctor.prototype._getter,ctor.prototype._setter=function(index,value){if(arguments.length<2)throw new SyntaxError("Not enough arguments");if(index=ECMAScript.ToUint32(index),index>=this.length)return undefined;var i,o,bytes=this._pack(value);for(i=0,o=this.byteOffset+index*this.BYTES_PER_ELEMENT;i<this.BYTES_PER_ELEMENT;i+=1,o+=1)this.buffer._bytes[o]=bytes[i]},ctor.prototype.set=function(index,value){if(arguments.length<1)throw new SyntaxError("Not enough arguments");var array,sequence,offset,len,i,s,d,byteOffset,byteLength,tmp;if("object"==typeof arguments[0]&&arguments[0].constructor===this.constructor){if(array=arguments[0],offset=ECMAScript.ToUint32(arguments[1]),offset+array.length>this.length)throw new RangeError("Offset plus length of array is out of range");if(byteOffset=this.byteOffset+offset*this.BYTES_PER_ELEMENT,byteLength=array.length*this.BYTES_PER_ELEMENT,array.buffer===this.buffer){for(tmp=[],i=0,s=array.byteOffset;byteLength>i;i+=1,s+=1)tmp[i]=array.buffer._bytes[s];for(i=0,d=byteOffset;byteLength>i;i+=1,d+=1)this.buffer._bytes[d]=tmp[i]}else for(i=0,s=array.byteOffset,d=byteOffset;byteLength>i;i+=1,s+=1,d+=1)this.buffer._bytes[d]=array.buffer._bytes[s]}else{if("object"!=typeof arguments[0]||"undefined"==typeof arguments[0].length)throw new TypeError("Unexpected argument type(s)");if(sequence=arguments[0],len=ECMAScript.ToUint32(sequence.length),offset=ECMAScript.ToUint32(arguments[1]),offset+len>this.length)throw new RangeError("Offset plus length of array is out of range");for(i=0;len>i;i+=1)s=sequence[i],this._setter(offset+i,Number(s))}},ctor.prototype.subarray=function(start,end){function clamp(v,min,max){return min>v?min:v>max?max:v}start=ECMAScript.ToInt32(start),end=ECMAScript.ToInt32(end),arguments.length<1&&(start=0),arguments.length<2&&(end=this.length),0>start&&(start=this.length+start),0>end&&(end=this.length+end),start=clamp(start,0,this.length),end=clamp(end,0,this.length);var len=end-start;return 0>len&&(len=0),new this.constructor(this.buffer,this.byteOffset+start*this.BYTES_PER_ELEMENT,len)},ctor}var ArrayBuffer=function(length){if(length=ECMAScript.ToInt32(length),0>length)throw new RangeError("ArrayBuffer size is not a small enough positive integer");this.byteLength=length,this._bytes=[],this._bytes.length=length;var i;for(i=0;i<this.byteLength;i+=1)this._bytes[i]=0;configureProperties(this)};exports.ArrayBuffer=exports.ArrayBuffer||ArrayBuffer;var ArrayBufferView=function(){},Int8Array=makeConstructor(1,packI8,unpackI8),Uint8Array=makeConstructor(1,packU8,unpackU8),Uint8ClampedArray=makeConstructor(1,packU8Clamped,unpackU8),Int16Array=makeConstructor(2,packI16,unpackI16),Uint16Array=makeConstructor(2,packU16,unpackU16),Int32Array=makeConstructor(4,packI32,unpackI32),Uint32Array=makeConstructor(4,packU32,unpackU32),Float32Array=makeConstructor(4,packF32,unpackF32),Float64Array=makeConstructor(8,packF64,unpackF64);exports.Int8Array=exports.Int8Array||Int8Array,exports.Uint8Array=exports.Uint8Array||Uint8Array,exports.Uint8ClampedArray=exports.Uint8ClampedArray||Uint8ClampedArray,exports.Int16Array=exports.Int16Array||Int16Array,exports.Uint16Array=exports.Uint16Array||Uint16Array,exports.Int32Array=exports.Int32Array||Int32Array,exports.Uint32Array=exports.Uint32Array||Uint32Array,exports.Float32Array=exports.Float32Array||Float32Array,exports.Float64Array=exports.Float64Array||Float64Array}(),function(){function r(array,index){return ECMAScript.IsCallable(array.get)?array.get(index):array[index]}function makeGetter(arrayType){return function(byteOffset,littleEndian){if(byteOffset=ECMAScript.ToUint32(byteOffset),byteOffset+arrayType.BYTES_PER_ELEMENT>this.byteLength)throw new RangeError("Array index out of range");byteOffset+=this.byteOffset;var i,uint8Array=new exports.Uint8Array(this.buffer,byteOffset,arrayType.BYTES_PER_ELEMENT),bytes=[];for(i=0;i<arrayType.BYTES_PER_ELEMENT;i+=1)bytes.push(r(uint8Array,i));return Boolean(littleEndian)===Boolean(IS_BIG_ENDIAN)&&bytes.reverse(),r(new arrayType(new exports.Uint8Array(bytes).buffer),0)}}function makeSetter(arrayType){return function(byteOffset,value,littleEndian){if(byteOffset=ECMAScript.ToUint32(byteOffset),byteOffset+arrayType.BYTES_PER_ELEMENT>this.byteLength)throw new RangeError("Array index out of range");var i,byteView,typeArray=new arrayType([value]),byteArray=new exports.Uint8Array(typeArray.buffer),bytes=[];for(i=0;i<arrayType.BYTES_PER_ELEMENT;i+=1)bytes.push(r(byteArray,i));Boolean(littleEndian)===Boolean(IS_BIG_ENDIAN)&&bytes.reverse(),byteView=new exports.Uint8Array(this.buffer,byteOffset,arrayType.BYTES_PER_ELEMENT),byteView.set(bytes)}}var IS_BIG_ENDIAN=function(){var u16array=new exports.Uint16Array([4660]),u8array=new exports.Uint8Array(u16array.buffer);return 18===r(u8array,0)}(),DataView=function(buffer,byteOffset,byteLength){if(0===arguments.length)buffer=new exports.ArrayBuffer(0);else if(!(buffer instanceof exports.ArrayBuffer||"ArrayBuffer"===ECMAScript.Class(buffer)))throw new TypeError("TypeError");if(this.buffer=buffer||new exports.ArrayBuffer(0),this.byteOffset=ECMAScript.ToUint32(byteOffset),this.byteOffset>this.buffer.byteLength)throw new RangeError("byteOffset out of range");if(arguments.length<3?this.byteLength=this.buffer.byteLength-this.byteOffset:this.byteLength=ECMAScript.ToUint32(byteLength),this.byteOffset+this.byteLength>this.buffer.byteLength)throw new RangeError("byteOffset and length reference an area beyond the end of the buffer");configureProperties(this)};DataView.prototype.getUint8=makeGetter(exports.Uint8Array),DataView.prototype.getInt8=makeGetter(exports.Int8Array),DataView.prototype.getUint16=makeGetter(exports.Uint16Array),DataView.prototype.getInt16=makeGetter(exports.Int16Array),DataView.prototype.getUint32=makeGetter(exports.Uint32Array),DataView.prototype.getInt32=makeGetter(exports.Int32Array),DataView.prototype.getFloat32=makeGetter(exports.Float32Array),DataView.prototype.getFloat64=makeGetter(exports.Float64Array),DataView.prototype.setUint8=makeSetter(exports.Uint8Array),
DataView.prototype.setInt8=makeSetter(exports.Int8Array),DataView.prototype.setUint16=makeSetter(exports.Uint16Array),DataView.prototype.setInt16=makeSetter(exports.Int16Array),DataView.prototype.setUint32=makeSetter(exports.Uint32Array),DataView.prototype.setInt32=makeSetter(exports.Int32Array),DataView.prototype.setFloat32=makeSetter(exports.Float32Array),DataView.prototype.setFloat64=makeSetter(exports.Float64Array),exports.DataView=exports.DataView||DataView}()},function(module,exports,__webpack_require__){function Context(){}var indexOf=__webpack_require__(186),Object_keys=function(obj){if(Object.keys)return Object.keys(obj);var res=[];for(var key in obj)res.push(key);return res},forEach=function(xs,fn){if(xs.forEach)return xs.forEach(fn);for(var i=0;i<xs.length;i++)fn(xs[i],i,xs)},defineProp=function(){try{return Object.defineProperty({},"_",{}),function(obj,name,value){Object.defineProperty(obj,name,{writable:!0,enumerable:!1,configurable:!0,value:value})}}catch(e){return function(obj,name,value){obj[name]=value}}}(),globals=["Array","Boolean","Date","Error","EvalError","Function","Infinity","JSON","Math","NaN","Number","Object","RangeError","ReferenceError","RegExp","String","SyntaxError","TypeError","URIError","decodeURI","decodeURIComponent","encodeURI","encodeURIComponent","escape","eval","isFinite","isNaN","parseFloat","parseInt","undefined","unescape"];Context.prototype={};var Script=exports.Script=function(code){return this instanceof Script?void(this.code=code):new Script(code)};Script.prototype.runInContext=function(context){if(!(context instanceof Context))throw new TypeError("needs a 'context' argument.");var iframe=document.createElement("iframe");iframe.style||(iframe.style={}),iframe.style.display="none",document.body.appendChild(iframe);var win=iframe.contentWindow,wEval=win.eval,wExecScript=win.execScript;!wEval&&wExecScript&&(wExecScript.call(win,"null"),wEval=win.eval),forEach(Object_keys(context),function(key){win[key]=context[key]}),forEach(globals,function(key){context[key]&&(win[key]=context[key])});var winKeys=Object_keys(win),res=wEval.call(win,this.code);return forEach(Object_keys(win),function(key){(key in context||-1===indexOf(winKeys,key))&&(context[key]=win[key])}),forEach(globals,function(key){key in context||defineProp(context,key,win[key])}),document.body.removeChild(iframe),res},Script.prototype.runInThisContext=function(){return eval(this.code)},Script.prototype.runInNewContext=function(context){var ctx=Script.createContext(context),res=this.runInContext(ctx);return forEach(Object_keys(ctx),function(key){context[key]=ctx[key]}),res},forEach(Object_keys(Script.prototype),function(name){exports[name]=Script[name]=function(code){var s=Script(code);return s[name].apply(s,[].slice.call(arguments,1))}}),exports.createScript=function(code){return exports.Script(code)},exports.createContext=Script.createContext=function(context){var copy=new Context;return"object"==typeof context&&forEach(Object_keys(context),function(key){copy[key]=context[key]}),copy}},function(module,exports,__webpack_require__){var Stream=function(){try{return __webpack_require__(176)}catch(_){}}();exports=module.exports=__webpack_require__(148),exports.Stream=Stream||exports,exports.Readable=exports,exports.Writable=__webpack_require__(149),exports.Duplex=__webpack_require__(150),exports.Transform=__webpack_require__(151),exports.PassThrough=__webpack_require__(152)},function(module,exports,__webpack_require__){"function"==typeof Object.create?module.exports=function(ctor,superCtor){ctor.super_=superCtor,ctor.prototype=Object.create(superCtor.prototype,{constructor:{value:ctor,enumerable:!1,writable:!0,configurable:!0}})}:module.exports=function(ctor,superCtor){ctor.super_=superCtor;var TempCtor=function(){};TempCtor.prototype=superCtor.prototype,ctor.prototype=new TempCtor,ctor.prototype.constructor=ctor}},function(module,exports,__webpack_require__){"use strict";function newMapping(key,value){var end=value?value.endPosition:key.endPosition+1,node={key:key,value:value,startPosition:key.startPosition,endPosition:end,kind:Kind.MAPPING,parent:null,errors:[]};return node}function newAnchorRef(key,start,end,value){return{errors:[],referencesAnchor:key,value:value,startPosition:start,endPosition:end,kind:Kind.ANCHOR_REF,parent:null}}function newScalar(v){return void 0===v&&(v=""),{errors:[],startPosition:-1,endPosition:-1,value:v,kind:Kind.SCALAR,parent:null,doubleQuoted:!1,rawValue:v}}function newItems(){return{errors:[],startPosition:-1,endPosition:-1,items:[],kind:Kind.SEQ,parent:null}}function newSeq(){return newItems()}function newMap(mappings){return{errors:[],startPosition:-1,endPosition:-1,mappings:mappings?mappings:[],kind:Kind.MAP,parent:null}}!function(Kind){Kind[Kind.SCALAR=0]="SCALAR",Kind[Kind.MAPPING=1]="MAPPING",Kind[Kind.MAP=2]="MAP",Kind[Kind.SEQ=3]="SEQ",Kind[Kind.ANCHOR_REF=4]="ANCHOR_REF",Kind[Kind.INCLUDE_REF=5]="INCLUDE_REF"}(exports.Kind||(exports.Kind={}));var Kind=exports.Kind;exports.newMapping=newMapping,exports.newAnchorRef=newAnchorRef,exports.newScalar=newScalar,exports.newItems=newItems,exports.newSeq=newSeq,exports.newMap=newMap},function(module,exports,__webpack_require__){"use strict";function isNothing(subject){return"undefined"==typeof subject||null===subject}function isObject(subject){return"object"==typeof subject&&null!==subject}function toArray(sequence){return Array.isArray(sequence)?sequence:isNothing(sequence)?[]:[sequence]}function extend(target,source){var index,length,key,sourceKeys;if(source)for(sourceKeys=Object.keys(source),index=0,length=sourceKeys.length;length>index;index+=1)key=sourceKeys[index],target[key]=source[key];return target}function repeat(string,count){var cycle,result="";for(cycle=0;count>cycle;cycle+=1)result+=string;return result}function isNegativeZero(number){return 0===number&&Number.NEGATIVE_INFINITY===1/number}exports.isNothing=isNothing,exports.isObject=isObject,exports.toArray=toArray,exports.extend=extend,exports.repeat=repeat,exports.isNegativeZero=isNegativeZero},function(module,exports,__webpack_require__){"use strict";var YAMLException=function(){function YAMLException(reason,mark){void 0===mark&&(mark=null),this.name="YAMLException",this.reason=reason,this.mark=mark,this.message=this.toString(!1)}return YAMLException.prototype.toString=function(compact){void 0===compact&&(compact=!1);var result;return result="JS-YAML: "+(this.reason||"(unknown reason)"),!compact&&this.mark&&(result+=" "+this.mark.toString()),result},YAMLException}();module.exports=YAMLException},function(module,exports,__webpack_require__){"use strict";var common=__webpack_require__(112),Mark=function(){function Mark(name,buffer,position,line,column){this.name=name,this.buffer=buffer,this.position=position,this.line=line,this.column=column}return Mark.prototype.getSnippet=function(indent,maxLength){void 0===indent&&(indent=0),void 0===maxLength&&(maxLength=75);var head,start,tail,end,snippet;if(!this.buffer)return null;for(indent=indent||4,maxLength=maxLength||75,head="",start=this.position;start>0&&-1==="\x00\r\n\u2028\u2029".indexOf(this.buffer.charAt(start-1));)if(start-=1,this.position-start>maxLength/2-1){head=" ... ",start+=5;break}for(tail="",end=this.position;end<this.buffer.length&&-1==="\x00\r\n\u2028\u2029".indexOf(this.buffer.charAt(end));)if(end+=1,end-this.position>maxLength/2-1){tail=" ... ",end-=5;break}return snippet=this.buffer.slice(start,end),common.repeat(" ",indent)+head+snippet+tail+"\n"+common.repeat(" ",indent+this.position-start+head.length)+"^"},Mark.prototype.toString=function(compact){void 0===compact&&(compact=!0);var snippet,where="";return this.name&&(where+='in "'+this.name+'" '),where+="at line "+(this.line+1)+", column "+(this.column+1),compact||(snippet=this.getSnippet(),snippet&&(where+=":\n"+snippet)),where},Mark}();module.exports=Mark},function(module,exports,__webpack_require__){"use strict";module.exports=__webpack_require__(155)},function(module,exports,__webpack_require__){var sentenceCase=__webpack_require__(127);module.exports=function(string,locale){return sentenceCase(string,locale,".")}},function(module,exports,__webpack_require__){var upperCase=__webpack_require__(119),lowerCase=__webpack_require__(120);module.exports=function(str,locale){if(null==str)return"";for(var result="",i=0;i<str.length;i++){var c=str[i],u=upperCase(c,locale);result+=u===c?lowerCase(c,locale):u}return result}},function(module,exports,__webpack_require__){var sentenceCase=__webpack_require__(127);module.exports=function(string,locale){return sentenceCase(string,locale,"/")}},function(module,exports,__webpack_require__){var LANGUAGES={tr:{regexp:/[\u0069]/g,map:{i:"İ"}},az:{regexp:/[\u0069]/g,map:{i:"İ"}},lt:{regexp:/[\u0069\u006A\u012F]\u0307|\u0069\u0307[\u0300\u0301\u0303]/g,map:{"i̇":"I","j̇":"J","į̇":"Į","i̇̀":"Ì","i̇́":"Í","i̇̃":"Ĩ"}}};module.exports=function(str,locale){var lang=LANGUAGES[locale];return str=null==str?"":String(str),lang&&(str=str.replace(lang.regexp,function(m){return lang.map[m]})),str.toUpperCase()}},function(module,exports,__webpack_require__){var LANGUAGES={tr:{regexp:/\u0130|\u0049|\u0049\u0307/g,map:{"İ":"i",I:"ı","İ":"i"}},az:{regexp:/[\u0130]/g,map:{"İ":"i",I:"ı","İ":"i"}},lt:{regexp:/[\u0049\u004A\u012E\u00CC\u00CD\u0128]/g,map:{I:"i̇",J:"j̇","Į":"į̇","Ì":"i̇̀","Í":"i̇́","Ĩ":"i̇̃"}}};module.exports=function(str,locale){var lang=LANGUAGES[locale];return str=null==str?"":String(str),lang&&(str=str.replace(lang.regexp,function(m){return lang.map[m]})),str.toLowerCase()}},function(module,exports,__webpack_require__){var upperCase=__webpack_require__(119),sentenceCase=__webpack_require__(127);module.exports=function(string,locale,mergeNumbers){var result=sentenceCase(string,locale);return mergeNumbers||(result=result.replace(/(\d) (?=\d)/g,"$1_")),result.replace(/ (.)/g,function(m,$1){return upperCase($1,locale)})}},function(module,exports,__webpack_require__){var sentenceCase=__webpack_require__(127);module.exports=function(str,locale){return sentenceCase(str,locale,"_")}},function(module,exports,__webpack_require__){var upperCase=__webpack_require__(119),sentenceCase=__webpack_require__(127);module.exports=function(str,locale){return sentenceCase(str,locale).replace(/^.| ./g,function(m){return upperCase(m,locale)})}},function(module,exports,__webpack_require__){var sentenceCase=__webpack_require__(127);module.exports=function(string,locale){return sentenceCase(string,locale,"-")}},function(module,exports,__webpack_require__){var camelCase=__webpack_require__(121),upperCaseFirst=__webpack_require__(130);module.exports=function(string,locale){return upperCaseFirst(camelCase(string,locale),locale)}},function(module,exports,__webpack_require__){var upperCase=__webpack_require__(119),snakeCase=__webpack_require__(122);module.exports=function(string,locale){return upperCase(snakeCase(string,locale),locale)}},function(module,exports,__webpack_require__){var lowerCase=__webpack_require__(120),NON_WORD_REGEXP=__webpack_require__(159),CAMEL_CASE_REGEXP=__webpack_require__(160),TRAILING_DIGIT_REGEXP=__webpack_require__(161);module.exports=function(str,locale,replacement){function replace(match,index,string){return 0===index||index===string.length-match.length?"":replacement}return null==str?"":(replacement=replacement||" ",str=String(str).replace(CAMEL_CASE_REGEXP,"$1 $2").replace(TRAILING_DIGIT_REGEXP,"$1 $2").replace(NON_WORD_REGEXP,replace),lowerCase(str,locale))}},function(module,exports,__webpack_require__){var upperCase=__webpack_require__(119);module.exports=function(string,locale){return upperCase(string,locale)===string}},function(module,exports,__webpack_require__){var lowerCase=__webpack_require__(120);module.exports=function(string,locale){return lowerCase(string,locale)===string}},function(module,exports,__webpack_require__){var upperCase=__webpack_require__(119);module.exports=function(str,locale){return null==str?"":(str=String(str),upperCase(str.charAt(0),locale)+str.substr(1))}},function(module,exports,__webpack_require__){var lowerCase=__webpack_require__(120);module.exports=function(str,locale){return null==str?"":(str=String(str),lowerCase(str.charAt(0),locale)+str.substr(1))}},function(module,exports,__webpack_require__){"use strict";var Schema=__webpack_require__(153),schema=new Schema({include:[__webpack_require__(154)],implicit:[__webpack_require__(162),__webpack_require__(163)],explicit:[__webpack_require__(164),__webpack_require__(165),__webpack_require__(166),__webpack_require__(167)]});module.exports=schema},function(module,exports,__webpack_require__){"use strict";var Schema=__webpack_require__(153),schema=new Schema({include:[__webpack_require__(132)],explicit:[__webpack_require__(168),__webpack_require__(169)]});Schema.DEFAULT=schema,module.exports=schema},function(module,exports,__webpack_require__){"use strict";function flatten(t,namespaces){if(t.typeKind==index.TypeKind.ARRAY)return namespaces?[]:[flatten(t.base)[0]+"[]"];if(t.typeKind==index.TypeKind.BASIC){var bt=t,str=bt.basicName,nameSpace=bt.nameSpace&&bt.nameSpace.trim();return null!=nameSpace&&nameSpace.length>0&&"RamlWrapper"!=nameSpace&&(str=nameSpace+"."+str),bt.typeArguments&&0!=bt.typeArguments.length&&(str+="<"+bt.typeArguments.map(function(x){return flatten(x)}).join(", ")+">"),namespaces?bt.nameSpace&&namespaces[bt.nameSpace]?[str]:[]:[str]}if(t.typeKind==index.TypeKind.UNION){var ut=t,result=[];return ut.options.forEach(function(x){return result=result.concat(flatten(x,namespaces))}),result}return[]}function getHelperMethods(srcPath){return helperMethodExtractor.getHelperMethods(srcPath)}var index=__webpack_require__(91),helperMethodExtractor=__webpack_require__(156),ns={RamlWrapper:!0},HelperMethod=function(){function HelperMethod(originalName,wrapperMethodName,returnType,args,meta){this.originalName=originalName,this.wrapperMethodName=wrapperMethodName,this.returnType=returnType,this.args=args,this.meta=meta}return HelperMethod.prototype.targetWrappers=function(){var isValid=!0,result=[];return this.args.forEach(function(x){var arr=flatten(x.type,ns);if(0!=arr.length)return isValid&&0==result.length?void(result=result.concat(arr)):(result=[],void(isValid=!1))}),result},HelperMethod.prototype.callArgs=function(){return this.args.map(function(x){return 0==flatten(x.type,ns).length?x:{name:"this",type:null,optional:!1,defaultValue:void 0}})},HelperMethod}();exports.HelperMethod=HelperMethod,exports.flatten=flatten,exports.getHelperMethods=getHelperMethods},function(module,exports,__webpack_require__){"use strict";function parse(content){return ts.createSourceFile("sample.ts",content,ts.ScriptTarget.ES3,!0)}function parseStruct(content,modules,mpth){var mod=parse(content),module={classes:[],aliases:[],enumDeclarations:[],imports:{},name:mpth};modules[mpth]=module;var currentModule=null;return exports.tsm.Matching.visit(mod,function(x){if(x.kind==ts.SyntaxKind.ModuleDeclaration){var cmod=x;currentModule=cmod.name.text}if(x.kind==ts.SyntaxKind.ImportEqualsDeclaration){var imp=x,namespace=imp.name.text;if("RamlWrapper"==namespace)return;var path=imp.moduleReference,literal=path.expression,importPath=literal.text,absPath=fsUtil.resolve(fsUtil.dirname(mpth)+"/",importPath)+".ts";if(!fsUtil.existsSync(absPath))throw new Error("Path "+importPath+" resolve to "+absPath+"do not exists");if(!modules[absPath]){var cnt=fsUtil.readFileSync(absPath);parseStruct(cnt,modules,absPath)}module.imports[namespace]=modules[absPath]}if(x.kind==ts.SyntaxKind.TypeAliasDeclaration){var u=x;if(u.name){var aliasName=u.name.text,type=buildType(u.type,mpth);module.aliases.push({name:aliasName,type:type})}}if(x.kind==ts.SyntaxKind.EnumDeclaration){var e=x,members=[];e.members&&e.members.forEach(function(y){members.push(y.name.text)}),e.name&&module.enumDeclarations.push({name:e.name.text,members:members})}var isInterface=x.kind==ts.SyntaxKind.InterfaceDeclaration,isClass=x.kind==ts.SyntaxKind.ClassDeclaration;if(isInterface||isClass){var c=x;if(c){var fields={},clazz=index_2.classDecl(c.name.text,isInterface);return clazz.moduleName=currentModule,module.classes.push(clazz),c.members.forEach(function(x){if(x.kind==ts.SyntaxKind.MethodDeclaration){var md=x,method=buildMethod(md,content,mpth);clazz.methods.push(method)}var field=fld.doMatch(x);if(field){var f=buildField(field,mpth);if("$"==f.name)clazz.annotations=f.annotations;else if("$"!=f.name.charAt(0)||"$ref"==f.name)fields[f.name]=f,clazz.fields.push(f);else{var targetField=f.name.substr(1),of=fields[targetField];if(of)of.annotations=f.annotations;else if("$$"!=f.name){var overridings=clazz.annotationOverridings[targetField];overridings||(overridings=[]),clazz.annotationOverridings[targetField]=overridings.concat(f.annotations)}}}}),c.typeParameters&&c.typeParameters.forEach(function(x){clazz.typeParameters.push(x.name.text),null==x.constraint?clazz.typeParameterConstraint.push(null):clazz.typeParameterConstraint.push(x.constraint.typeName.text)}),c.heritageClauses&&c.heritageClauses.forEach(function(x){x.types.forEach(function(y){if(x.token==ts.SyntaxKind.ExtendsKeyword)clazz["extends"].push(buildType(y,mpth));else{if(x.token!=ts.SyntaxKind.ImplementsKeyword)throw new Error("Unknown token class heritage");clazz["implements"].push(buildType(y,mpth))}})}),exports.tsm.Matching.SKIP}}}),module}function buildField(f,path){return{name:f.name.text,type:buildType(f.type,path),annotations:"$"==f.name.text.charAt(0)?buildInitializer(f.initializer):[],valueConstraint:"$"!=f.name.text.charAt(0)?buildConstraint(f.initializer):null,optional:null!=f.questionToken}}function buildMethod(md,content,path){var aliasName=md.name.text,text=content.substring(md.pos,md.end),params=[];md.parameters.forEach(function(x){params.push(buildParameter(x,content,path))});var method={returnType:buildType(md.type,path),name:aliasName,start:md.pos,end:md.end,text:text,arguments:params};return method}function buildParameter(f,content,path){var text=content.substring(f.pos,f.end);return{name:f.name.text,start:f.pos,end:f.end,text:text,type:buildType(f.type,path)}}function buildConstraint(e){return null==e?null:e.kind==ts.SyntaxKind.CallExpression?{isCallConstraint:!0,value:buildAnnotation(e)}:{isCallConstraint:!1,value:parseArg(e)}}function buildInitializer(i){if(null==i)return[];if(i.kind==ts.SyntaxKind.ArrayLiteralExpression){var arr=i,annotations=[];return arr.elements.forEach(function(x){annotations.push(buildAnnotation(x))}),annotations}throw new Error("Only Array Literals supported now")}function buildAnnotation(e){if(e.kind==ts.SyntaxKind.CallExpression){var call=e,name=parseName(call.expression),a={name:name,arguments:[]};return call.arguments.forEach(function(x){a.arguments.push(parseArg(x))}),a}throw new Error("Only call expressions may be annotations")}function parseArg(n){if(n.kind==ts.SyntaxKind.StringLiteral){var l=n;return l.text}if(n.kind==ts.SyntaxKind.NoSubstitutionTemplateLiteral){var ls=n;return ls.text}if(n.kind==ts.SyntaxKind.ArrayLiteralExpression){var arr=n,annotations=[];return arr.elements.forEach(function(x){annotations.push(parseArg(x))}),annotations}if(n.kind==ts.SyntaxKind.TrueKeyword)return!0;if(n.kind==ts.SyntaxKind.PropertyAccessExpression){var pa=n;return parseArg(pa.expression)+"."+parseArg(pa.name)}if(n.kind==ts.SyntaxKind.Identifier){var ident=n;return ident.text}if(n.kind==ts.SyntaxKind.FalseKeyword)return!1;if(n.kind==ts.SyntaxKind.NumericLiteral){var nl=n;return Number(nl.text)}if(n.kind==ts.SyntaxKind.BinaryExpression){var bin=n;if(bin.operatorToken.kind=ts.SyntaxKind.PlusToken)return parseArg(bin.left)+parseArg(bin.right)}throw new Error("Unknown value in annotation")}function parseName(n){if(n.kind==ts.SyntaxKind.Identifier)return n.text;if(n.kind==ts.SyntaxKind.PropertyAccessExpression){var m=n;return parseName(m.expression)+"."+parseName(m.name)}throw new Error("Only simple identifiers are supported now")}function basicType(n,path){var namespaceIndex=n.indexOf("."),namespace=-1!=namespaceIndex?n.substring(0,namespaceIndex):"",basicName=-1!=namespaceIndex?n.substring(namespaceIndex+1):n;return{typeName:n,nameSpace:namespace,basicName:basicName,typeKind:index_1.TypeKind.BASIC,typeArguments:[],modulePath:path}}function arrayType(b){return{base:b,typeKind:index_1.TypeKind.ARRAY}}function unionType(b){return{options:b,typeKind:index_1.TypeKind.UNION}}function buildType(t,path){if(null==t)return null;if(t.kind==ts.SyntaxKind.StringKeyword)return basicType("string",null);if(t.kind==ts.SyntaxKind.NumberKeyword)return basicType("number",null);if(t.kind==ts.SyntaxKind.BooleanKeyword)return basicType("boolean",null);if(t.kind==ts.SyntaxKind.AnyKeyword)return basicType("any",null);if(t.kind==ts.SyntaxKind.VoidKeyword)return basicType("void",null);if(t.kind==ts.SyntaxKind.TypeReference){var tr=t,res=basicType(parseQualified(tr.typeName),path);return tr.typeArguments&&tr.typeArguments.forEach(function(x){res.typeArguments.push(buildType(x,path))}),res}if(t.kind==ts.SyntaxKind.ArrayType){var q=t;return arrayType(buildType(q.elementType,path))}if(t.kind==ts.SyntaxKind.UnionType){var ut=t;return unionType(ut.types.map(function(x){return buildType(x,path)}))}if(t.kind==ts.SyntaxKind.ExpressionWithTypeArguments){var tra=t,res=basicType(parseQualified2(tra.expression),path);return tra.typeArguments&&tra.typeArguments.forEach(function(x){res.typeArguments.push(buildType(x,path))}),res}throw new Error("Case not supported: "+t.kind)}function parseQualified2(n){return n.name?n.name.text:n.text}function parseQualified(n){if(n.kind==ts.SyntaxKind.Identifier)return n.text;var q=n;return parseQualified(q.left)+"."+parseQualified(q.right)}var ts=__webpack_require__(147);exports.tsm=__webpack_require__(157),exports.helperMethodExtractor=__webpack_require__(156);var fsUtil=__webpack_require__(158),index_1=__webpack_require__(91),index_2=__webpack_require__(91),fld=exports.tsm.Matching.field();exports.parseStruct=parseStruct,exports.parseArg=parseArg,exports.buildType=buildType},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_RESULT__;__WEBPACK_AMD_DEFINE_RESULT__=function(){"use strict";var statusCodes=__webpack_require__(180),statusCodesToPhrases={},statusPhrasesToCodes={},methods=__webpack_require__(181),headers=__webpack_require__(182),relations=__webpack_require__(183);return statusCodes.forEach(function(item){var phrase,code=parseInt(item.code,10);code.toString()===item.code&&(phrase=item.phrase.toUpperCase().replace(/[^A-Z]/g,"_"),statusCodesToPhrases[code]=item.phrase,statusPhrasesToCodes[phrase]=item.code)}),{statusCodes:statusCodes,statusCodesToPhrases:statusCodesToPhrases,statusPhrasesToCodes:statusPhrasesToCodes,methods:methods,headers:headers,relations:relations}}.call(exports,__webpack_require__,exports,module),!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__))},function(module,exports,__webpack_require__){"use strict";function example(t){var ms=t.oneMeta(meta.Example);if(ms)return ms.example();if(t.getExtra(exCalcFlag))return null;t.putExtra(exCalcFlag,!0);try{var ms1=t.oneMeta(meta.Examples);if(ms1){var examples=ms1.examples();if(examples&&examples.length>0)return examples[0]}var d=t.oneMeta(meta.Default);if(d)return d.value();if(t.isObject()){var result={};return t.meta().forEach(function(x){if(x instanceof restrictions_2.PropertyIs){var p=x,ex=example(p.value());result[p.propertyName()]=ex}}),t.superTypes().forEach(function(x){if(x.oneMeta(meta.Example)||x.oneMeta(meta.Examples)){var ex=example(x);ex&&"object"==typeof ex&&Object.keys(ex).forEach(function(key){result[key]=ex[key]})}}),result}if(t.isArray()){var c=t.oneMeta(restrictions_1.ComponentShouldBeOfType),resultArray=[];return c&&resultArray.push(example(c.value())),resultArray}return t.isUnion()?example(t.typeFamily()[0]):t.isNumber()?1:t.isBoolean()?!0:"some value"}finally{t.putExtra(exCalcFlag,!1)}}function exampleFromInheritedType(inheritedType){var result=[],ms1=inheritedType.oneMeta(meta.Examples);if(ms1){var vl=ms1.value();if(vl&&"object"==typeof vl){var xmlValues;Object.keys(vl).forEach(function(key){var name=Array.isArray(vl)?null:key,exampleObj=vl[key],example=toExample({asXMLString:function(){return xmlValues||(xmlValues=ms1.asXMLStrings()),xmlValues[key]}},exampleObj,name);result.push(example)})}}var ms=inheritedType.oneMeta(meta.Example);if(ms){var exampleV=ms.example();null!=exampleV&&result.push(toExample(ms,ms.value(),void 0,!0))}return result}function exampleFromNominal(nominalType,collectFromSupertype){var originalInherited=nominalType.getAdapter(rt.InheritedType);if(originalInherited){var originalTypeExamples=exampleFromInheritedType(originalInherited);if(originalTypeExamples&&originalTypeExamples.length>0)return originalTypeExamples;if(collectFromSupertype&&nominalType.isUserDefined()&&!nominalType.isGenuineUserDefinedType()&&nominalType.genuineUserDefinedTypeInHierarchy()){var genuineNominal=nominalType.genuineUserDefinedTypeInHierarchy(),genuineInherited=genuineNominal.getAdapter(rt.InheritedType);if(genuineInherited){var genuineTypeExamples=exampleFromInheritedType(genuineInherited);if(genuineTypeExamples&&genuineTypeExamples.length>0)return genuineTypeExamples}}}return originalInherited?[new Example(example(originalInherited),void 0,void 0,void 0,!1,void 0,void 0,!0)]:[]}var rt=__webpack_require__(93),meta=__webpack_require__(98),restrictions_1=__webpack_require__(97),restrictions_2=__webpack_require__(97),exCalcFlag="exampleCalculation";exports.example=example;var Example=function(){function Example(_value,_name,_displayName,_description,_strict,_annotations,_isSingle,_empty){void 0===_name&&(_name=void 0),void 0===_displayName&&(_displayName=void 0),void 0===_description&&(_description=void 0),void 0===_strict&&(_strict=!0),void 0===_annotations&&(_annotations=void 0),void 0===_isSingle&&(_isSingle=!1),void 0===_empty&&(_empty=!1),this._value=_value,this._name=_name,this._displayName=_displayName,this._description=_description,this._strict=_strict,this._annotations=_annotations,this._isSingle=_isSingle,this._empty=_empty}return Example.prototype.isEmpty=function(){return this._empty},Example.prototype.isJSONString=function(){return"string"==typeof this._value&&(0==(this._value+"").trim().indexOf("{")||0==(this._value+"").trim().indexOf("["))},Example.prototype.isXMLString=function(){return"string"==typeof this._value&&0==(this._value+"").trim().indexOf("<")},Example.prototype.asXMLString=function(){return this.isXMLString()?this._value:this._owner?this._owner.asXMLString():null},Example.prototype.isYAML=function(){return"string"==typeof this._value?!(this.isJSONString()||this.isXMLString()):!0},Example.prototype.asString=function(){return"string"==typeof this._value?""+this._value:this.expandAsString()},Example.prototype.asJSON=function(){if(this.isJSONString())try{return JSON.parse(this._value)}catch(e){return null}return this.isYAML()?this._value:this.expandAsString()},Example.prototype.original=function(){return this._value},Example.prototype.expandAsString=function(){return JSON.stringify(this.expandAsJSON(),null,2)},Example.prototype.expandAsJSON=function(){return this._value},Example.prototype.isSingle=function(){return this._isSingle},Example.prototype.strict=function(){return this._strict},Example.prototype.description=function(){return this._description},Example.prototype.displayName=function(){return this._displayName},Example.prototype.annotations=function(){return this._annotations},Example.prototype.name=function(){return this._name},Example}(),toExample=function(owner,exampleObj,name,isSingle){void 0===name&&(name=null),void 0===isSingle&&(isSingle=!1);var example;if(null!=exampleObj){var val=exampleObj.value;if(val){var displayName=exampleObj.displayName,description=exampleObj.description,strict=exampleObj.strict,aObj=null,annotationNames=Object.keys(exampleObj).filter(function(x){return"("==x.charAt(0)});if(annotationNames.length>0){aObj={};for(var _i=0,annotationNames_1=annotationNames;_i<annotationNames_1.length;_i++){var aName=annotationNames_1[_i],aVal=exampleObj[aName];aName=aName.substring(1,aName.length-1),aObj[aName]=aVal}}example=new Example(val,name,displayName,description,strict,aObj,isSingle)}else val=exampleObj,example=new Example(val,name,void 0,void 0,!0,void 0,isSingle)}return example&&(example._owner=owner),example};exports.exampleFromNominal=exampleFromNominal},function(module,exports,__webpack_require__){"use strict";function checkDate(dateStr){return checkDateString(dateStr,"YYYY-MM-DD")}function checkTime(time){return checkDateString("11 "+time.trim(),"YY HH:mm:ss")}function checkDateString(dateStr,dateFormat){if(!date.isValid(dateStr,dateFormat))return!1;var d=date.parse(dateStr,dateFormat,!1),ds=date.format(d,dateFormat,!1);return ds.trim()==dateStr.trim()}var __extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},date=__webpack_require__(197),ts=__webpack_require__(93),DateOnlyR=function(_super){function DateOnlyR(){_super.apply(this,arguments)}return __extends(DateOnlyR,_super),DateOnlyR.prototype.check=function(value){return"string"==typeof value&&checkDate(value)?ts.ok():new ts.Status(ts.Status.ERROR,0,"'date-only' instance should match 'yyyy-mm-dd' pattern",this)},DateOnlyR.prototype.requiredType=function(){return ts.STRING},DateOnlyR.prototype.value=function(){return!0},DateOnlyR.prototype.facetName=function(){return"should be date-only"},DateOnlyR}(ts.GenericTypeOf);exports.DateOnlyR=DateOnlyR;var TimeOnlyR=function(_super){function TimeOnlyR(){_super.apply(this,arguments)}return __extends(TimeOnlyR,_super),TimeOnlyR.prototype.check=function(value){if("string"==typeof value){var regexp=/^([0-9][0-9]:[0-9][0-9]:[0-9][0-9])(.[0-9]+)?$/,matches=value.match(regexp);if(!matches)return new ts.Status(ts.Status.ERROR,0,"'time-only' instance should match 'hh:mm:ss[.ff...]' pattern",this);var hhmmssTime=matches[1];return checkTime(hhmmssTime)?ts.ok():new ts.Status(ts.Status.ERROR,0,"'time-only' instance should match 'hh:mm:ss[.ff...]' pattern",this)}return new ts.Status(ts.Status.ERROR,0,"'time-only' instance should match 'hh:mm:ss[.ff...]' pattern",this)},TimeOnlyR.prototype.requiredType=function(){return ts.STRING},TimeOnlyR.prototype.value=function(){return!0},TimeOnlyR.prototype.facetName=function(){return"should be time-only"},TimeOnlyR}(ts.GenericTypeOf);exports.TimeOnlyR=TimeOnlyR;var DateTimeOnlyR=function(_super){function DateTimeOnlyR(){_super.apply(this,arguments)}return __extends(DateTimeOnlyR,_super),DateTimeOnlyR.prototype.check=function(value){if("string"==typeof value){var regexp=/^(\d{4}-\d{2}-\d{2})T([0-9][0-9]:[0-9][0-9]:[0-9][0-9])(.[0-9]+)?$/,matches=value.match(regexp);if(!matches||matches.length<3)return new ts.Status(ts.Status.ERROR,0,"'datetime-only' instance should match 'yyyy-mm-ddThh:mm:ss[.ff...]' pattern",this);var date=matches[1],time=matches[2];return checkDate(date)&&checkTime(time)?ts.ok():new ts.Status(ts.Status.ERROR,0,"'datetime-only' instance should match 'yyyy-mm-ddThh:mm:ss[.ff...]' pattern",this)}return new ts.Status(ts.Status.ERROR,0,"'datetime-only' instance should be string matching 'yyyy-mm-ddThh:mm:ss[.ff...]' pattern",this)},DateTimeOnlyR.prototype.requiredType=function(){return ts.STRING},DateTimeOnlyR.prototype.value=function(){return!0},DateTimeOnlyR.prototype.facetName=function(){return"should be datetime-only"},DateTimeOnlyR}(ts.GenericTypeOf);exports.DateTimeOnlyR=DateTimeOnlyR;var r1=/(Mon|Tue|Wed|Thu|Fri|Sat|Sun)\,[ ]+\d{2}[ ]+(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)[ ]+\d{4}[ ]+\d{2}:\d{2}:\d{2}[ ]+GMT/,r2=/(Monday|Tuesday|Wednesday|Thursday|Friday|Saturday|Sunday)\,[ ]+\d{2}-(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)-\d{2}[ ]+\d{2}:\d{2}:\d{2}[ ]+GMT/,r3=/(Mon|Tue|Wed|Thu|Fri|Sat|Sun)\,[ ]+(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)[ ]+\d{1,2}[ ]+\d{2}:\d{2}:\d{2}[ ]+GMT/,r0=/^(\d{4}-\d{2}-\d{2})T(\d{2}:\d{2}:\d{2})(?:\.\d{1,3})?((?:[\+\-]\d{2}:\d{2})|Z)$/,DateTimeR=function(_super){
function DateTimeR(){_super.apply(this,arguments)}return __extends(DateTimeR,_super),DateTimeR.prototype.check=function(value){var c=ts.VALIDATED_TYPE,rfc2616=!1;if(c.allFacets().forEach(function(x){"format"==x.facetName()&&"rfc2616"===x.value()&&(rfc2616=!0)}),"string"==typeof value){if(!rfc2616){var rfc3339Matches=value.match(r0);if(!rfc3339Matches||rfc3339Matches.length<3)return new ts.Status(ts.Status.ERROR,0,"Valid rfc3339 formatted string is expected",this);var date=rfc3339Matches[1],time=rfc3339Matches[2];return checkDate(date)&&checkTime(time)?ts.ok():new ts.Status(ts.Status.ERROR,0,"Valid rfc3339 formatted string is expected",this)}return value.match(r1)||value.match(r2)||value.match(r3)?ts.ok():new ts.Status(ts.Status.ERROR,0,"Valid rfc2616 formatted string is expected",this)}return new ts.Status(ts.Status.ERROR,0,"Valid datetime formatted string is expected",this)},DateTimeR.prototype.requiredType=function(){return ts.STRING},DateTimeR.prototype.value=function(){return!0},DateTimeR.prototype.facetName=function(){return"should be datetime-only"},DateTimeR}(ts.GenericTypeOf);exports.DateTimeR=DateTimeR},function(module,exports,__webpack_require__){"use strict";function parseToType(val,t,contentProvider){void 0===contentProvider&&(contentProvider=null);try{var q=val.trim();if(q.length>0){var json="{"==q.charAt(0);if(json||"<"==q.charAt(0)&&q.length>1&&"<"!=q.charAt(1))return new ts.ExternalType("",q,json,contentProvider);var node=typeExpression.parse(val),result=parseNode(node,t);return result}return ts.derive(val,[ts.STRING])}catch(e){return ts.derive(val,[ts.UNKNOWN])}}function wrapArray(a,result){for(;a>0;){var nt=ts.derive("",[ts.ARRAY]);nt.addMeta(new restrictions_1.ComponentShouldBeOfType(result)),result=nt,a--}return result}function parseNode(node,t){if("union"==node.type){var ut=node;return ts.union("",[parseNode(ut.first,t),parseNode(ut.rest,t)])}if("parens"==node.type){var ps=node,rs=parseNode(ps.expr,t);return wrapArray(ps.arr,rs)}var lit=node;if("?"==lit.value.charAt(lit.value.length-1)){var result=t.get(lit.value.substr(0,lit.value.length-1));result||(result=ts.derive(lit.value,[ts.UNKNOWN])),result=ts.union(lit.value,[result,ts.NIL]);var a=lit.arr;return wrapArray(a,result)}var result=t.get(lit.value);result||(result=ts.derive(lit.value,[ts.UNKNOWN]));var a=lit.arr;return wrapArray(a,result)}function storeToString(t){if(t.isSubTypeOf(ts.ARRAY)){var cm=t.oneMeta(restrictions_1.ComponentShouldBeOfType);return cm?cm.value().isUnion()?"("+storeToString(cm.value())+")[]":storeToString(cm.value())+"[]":"array"}if(t instanceof ts.UnionType){var ut=t;return ut.options().map(function(x){return storeToString(x)}).join(" | ")}return t.isAnonymous()&&t.isEmpty()?t.superTypes().map(function(x){return storeToString(x)}).join(" , "):t.name()}function visit(node,action){if(action(node),"union"==node.type){var union=node;visit(union.first,action),visit(union.rest,action)}else if("parens"==node.type){var parens=node;visit(parens.expr,action)}}function serializeToString(node){var str,arr=0;if("name"==node.type){var literal=node;str=literal.value,arr=literal.arr}else if("union"==node.type){var union=node;str=serializeToString(union.first)+" | "+serializeToString(union.rest)}else if("parens"==node.type){var parens=node;str="("+serializeToString(parens.expr)+")",arr=parens.arr}for(;--arr>=0;)str+="[]";return str}function parse(str){return typeExpression.parse(str)}var typeExpression=__webpack_require__(175),ts=__webpack_require__(93),restrictions_1=__webpack_require__(97);exports.parseToType=parseToType,exports.storeToString=storeToString,exports.visit=visit,exports.serializeToString=serializeToString,exports.parse=parse},function(module,exports,__webpack_require__){"use strict";function xmlOpen(tagname,attributes,level,newLine){void 0===level&&(level=0),void 0===newLine&&(newLine=!0);for(var result="<"+tagname,i=0;level>i;i++)result="    "+result;return attributes&&Object.keys(attributes).length>0&&Object.keys(attributes).forEach(function(key){"string"==typeof attributes[key]&&(result=result+" "+key+'="'+attributes[key]+'"')}),result=result+">"+(newLine?"\n":"")}function xmlClose(tagname,level){void 0===level&&(level=0);for(var result="</"+tagname,i=0;level>i&&i>-1;i++)result="    "+result;var result=(level>-1?"\n":"")+result+">\n";return result}function serializeToXML(object,type){type=actualType(type);var expectedRootNodeName=rootXmlName(type),infos=getInfos(type),result=xmlOpen(expectedRootNodeName,getAttributesFromJson(object,infos)),valueWrapper={};if(valueWrapper[expectedRootNodeName]=object,type.isArray()){type.meta().filter(function(metaInfo){return metaInfo instanceof restrictions_1.ComponentShouldBeOfType})[0];result+=getArrayFromJson(valueWrapper,type,1,!0)}else result+=getElementsFromJson(object,infos,1);var result=result+xmlClose(expectedRootNodeName);return result}function getAttributesFromJson(node,infos){var nodeAttributes={},attributeInfos=_.filter(infos,function(info){return xmlDescriptor(info.value()).attribute});return attributeInfos.forEach(function(info){var key=info.propId(),xmlKey=xmlName(info);node[key]&&(nodeAttributes[xmlKey]=node[key].toString())}),nodeAttributes}function getElementFromJson(node,type,level){var jsonKey=Object.keys(node)[0],jsonValue=node[jsonKey],result=null;if(type.isScalar()){var infos=getInfos(type);result=xmlOpen(jsonKey,getAttributesFromJson(jsonValue,infos),level,!type.isScalar())+jsonValue.toString()}else{if(type.isUnion())return getElementFromJson(node,selectTypeFromJson(jsonValue,type),level);var infos=getInfos(type);result=xmlOpen(jsonKey,getAttributesFromJson(jsonValue,infos),level,!type.isScalar())+getElementsFromJson(jsonValue,infos,level+1)}return result+=xmlClose(jsonKey,type.isScalar()?-1:level)}function selectTypeFromJson(value,unionType){var canBeTypes=unionType.typeFamily(),results=[],result=null;return canBeTypes.forEach(function(type){var xmlValue=serializeToXML(value,type);if(xmlValue){var jsonValue=readObject(xmlValue,type);if(jsonValue){var errors=getXmlErrors(jsonValue);results.push({type:type,errors:errors&&errors.length||0})}}}),result=results.length>0?results[0]:{type:canBeTypes[0]},results.forEach(function(canBe){canBe.errors<result.errors&&(result=canBe)}),result.type}function getElementsFromJson(node,infos,level){var elementInfos=_.filter(infos,function(info){return!xmlDescriptor(info.value()).attribute}),result="";return elementInfos.forEach(function(info){var xmlKey=xmlName(info),key=info.propId(),value={};value[xmlKey]=node[key],result+=info.value().isArray()?getArrayFromJson(value,info.value(),level):node[key]||""===node[key]?getElementFromJson(value,info.value(),level):""}),result}function getArrayFromJson(values,type,level,rootNode){void 0===rootNode&&(rootNode=!1);var jsonKey=Object.keys(values)[0],jsonValue=values[jsonKey],descriptor=xmlDescriptor(type),isWrapped=rootNode||descriptor.wrapped,result="",componentType=arrayElementType(type),typeName=componentType&&componentType.name(),elementsLevel=level;return isWrapped&&!rootNode&&(result=xmlOpen(jsonKey,null,level),elementsLevel+=1),jsonValue&&isArray(jsonValue)&&jsonValue.forEach(function(item){var itemWrapper={};itemWrapper[isWrapped?typeName:jsonKey]=item,result+=getElementFromJson(itemWrapper,componentType,elementsLevel)}),isWrapped&&(result+=xmlClose(jsonKey,level)),result}function readObject(content,t){var result=null,opts={};return opts.explicitChildren=!1,opts.explicitArray=!1,opts.explicitRoot=isSchema(t)||!t.isExternal(),xml2js.parseString(content,opts,function(err,res){if(result=res,err)throw new Error}),result=isSchema(t)?result:postProcess(result,actualType(t))}function getXmlErrors(root){var errors=root[XML_ERRORS];return delete root[XML_ERRORS],errors&&0!==errors.length?errors.map(function(error){return new typesystem_1.Status(typesystem_1.Status.ERROR,0,error,{})}):null}function actualType(type){return type&&isBodyLike(type)&&type.superTypes()&&0!==type.superTypes().length?1===type.superTypes().length?type.superTypes()[0]:_.find(type.allSuperTypes(),function(superType){return"object"===superType.name()})||type:type}function isBodyLike(type){return type&&_.find(bodyNames,function(name){return type.name()===name})?!0:!1}function isSchema(t){return isXmlContent(t)?!0:_.find(t.allSuperTypes(),function(supertype){return isXmlContent(supertype)})?!0:!1}function isXmlContent(t){return t.isExternal()&&t._content&&"string"==typeof t._content&&0===t._content.trim().indexOf("<")?!0:!1}function postProcess(result,type){var rootNodeName=Object.keys(result)[0],rootNode=result[rootNodeName],errors=[],expectedRootNodeName=rootXmlName(type);expectedRootNodeName!==rootNodeName&&errors.push('Unexpected root node "'+rootNodeName+'", "'+expectedRootNodeName+'" is expected.');var newJson;if(type.isArray()){var expectedAttributeNames=[],expectedElementNames=[],componentMeta=type.meta().filter(function(metaInfo){return metaInfo instanceof restrictions_1.ComponentShouldBeOfType})[0],typeName=componentMeta&&componentMeta.value().name();expectedElementNames.push(typeName),newJson=getArray(rootNode,type,errors,!0),fillExtras(rootNode,errors,expectedAttributeNames,expectedElementNames)}else newJson=buildJson(rootNode,type.isUnion()?selectFromUnion(rootNode,type):type,errors);return newJson[XML_ERRORS]=errors,newJson}function checkErrors(rootNode,actualType){var newJson,errors=[];newJson=buildJson(rootNode,actualType,errors);var validationErrors=actualType.validateDirect(newJson,!0,!1).getErrors();return errors.length+(validationErrors&&validationErrors.length)}function selectFromUnion(rootNode,union){var results=[];if(union.typeFamily().forEach(function(type){return results.push({type:type,errors:checkErrors(JSON.parse(JSON.stringify(rootNode)),type)})}),0===results.length)return union;var result=results[0];return results.forEach(function(oneOf){oneOf.errors<result.errors&&(result=oneOf)}),result.type}function buildJson(node,type,errors){var initialRoot={};if(!type)return node;if(type.isScalar())return toPrimitiveValue(type,node,errors);if(type.isUnion())return buildJson(node,selectFromUnion(node,type),errors);var infos=getInfos(type),expectedAttributeNames=[],expectedElementNames=[];return getAttributes(node,infos,expectedAttributeNames).forEach(function(attribute){return initialRoot[Object.keys(attribute)[0]]=attribute[Object.keys(attribute)[0]]}),getElements(node,infos,expectedElementNames,errors).forEach(function(element){return initialRoot[Object.keys(element)[0]]=element[Object.keys(element)[0]]}),fillExtras(node,errors,expectedAttributeNames,expectedElementNames),initialRoot}function fillExtras(node,errors,expectedAttributeNames,expectedElementNames,remove){if(void 0===remove&&(remove=!1),"object"==typeof node){node.$||(node.$={}),expectedAttributeNames.forEach(function(name){delete node.$[name]}),expectedElementNames.forEach(function(name){delete node[name]});var extraAttributes=Object.keys(node.$);delete node.$;var extraElements=Object.keys(node);extraAttributes.forEach(function(name){errors.push('Unexpected attribute "'+name+'".')}),extraElements.forEach(function(name){errors.push('Unexpected element "'+name+'".'),remove&&delete node[name]})}}function getInfos(type){return type.meta().filter(function(info){return info instanceof restrictions_1.PropertyIs}).map(function(info){return info})||[]}function getAttributes(node,infos,expectedNames){var nodeAttributes=node.$;if(!nodeAttributes)return[];var attributeInfos=_.filter(infos,function(info){return xmlDescriptor(info.value()).attribute});return attributeInfos.map(function(info){var attribute={},key=info.propId(),xmlKey=xmlName(info);expectedNames.push(xmlKey);var value=nodeAttributes[xmlKey];return attribute[key]=toPrimitiveValue(info.value(),value),null===attribute[key]?null:attribute}).filter(function(attribute){return attribute})}function getElements(node,infos,expectedNames,errors){var elementInfos=_.filter(infos,function(info){return!xmlDescriptor(info.value()).attribute});return elementInfos.map(function(info){var element={},key=(xmlDescriptor(info.value()),info.propId()),xmlKey=xmlName(info);expectedNames.push(xmlKey);var value=node[xmlKey];return info.value().isArray()?element[key]=getArray(node[xmlKey],info.value(),errors):element[key]=value||""===value?buildJson(value,info.value(),errors):null,null===element[key]?null:element}).filter(function(info){return info})}function getArray(values,type,errors,rootNode){void 0===rootNode&&(rootNode=!1);var descriptor=xmlDescriptor(type),isWrapped=rootNode||descriptor.wrapped,componentType=arrayElementType(type),typeName=componentType&&componentType.name();if(isWrapped){var valuesWrapper=values;values=values&&values[typeName],fillExtras(valuesWrapper,errors,[],[typeName],!0)}return values?(values=getArrayValues(values),values=isArray(values)?values.map(function(value){return buildJson(value,componentType,errors)}):"object"==typeof values&&values||[]):[]}function getArrayValues(preValues){return isArray(preValues)?preValues:"object"==typeof preValues?[preValues]:[]}function arrayElementType(arrayType){if(!arrayType||!arrayType.isArray())return null;var componentMetas=arrayType.meta().filter(function(metaInfo){return metaInfo instanceof restrictions_1.ComponentShouldBeOfType});return componentMetas&&componentMetas.length>0&&componentMetas[0].value()}function xmlName(property){var descriptor=xmlDescriptor(property.value()),ramlName=property.propId(),actualName=descriptor.name||ramlName;return descriptor.namespace&&(actualName=descriptor.namespace+":"+actualName),(descriptor.prefix||"")+actualName}function rootXmlName(type){var descriptor=xmlDescriptor(type),ramlName=type.name();""===ramlName&&type.isUnion()&&(ramlName="object");var actualName=descriptor.name||ramlName;return(descriptor.prefix||"")+actualName}function xmlDescriptor(type){var info=type.meta().filter(function(xmlInfo){return xmlInfo instanceof metainfo_1.XMLInfo}).map(function(xmlInfo){return xmlInfo})[0],result={attribute:!1,wrapped:!1,name:!1,namespace:!1,prefix:!1};if(!info)return result;var infoValue=info.value();return infoValue?(Object.keys(result).forEach(function(key){result[key]=infoValue[key]||result[key]}),result):result}function toPrimitiveValue(type,actual,errors){if(void 0===errors&&(errors=[]),"object"==typeof actual){var result=toPrimitiveValue(type,actual._);return delete actual._,fillExtras(actual,errors,[],[],!0),result}if(!actual&&""!==actual.trim())return null;if(type.isNumber()){var parsedValue=parseFloat(actual);if(!isNaN(parsedValue))return parsedValue}if(type.isBoolean()){if("true"===actual)return!0;if("false"===actual)return!1}return"string"==typeof actual?actual:null}function isArray(instance){return instance?"object"==typeof instance&&"number"==typeof instance.length:!1}var xml2js=__webpack_require__(200),_=__webpack_require__(177),restrictions_1=__webpack_require__(97),metainfo_1=__webpack_require__(98),typesystem_1=__webpack_require__(93),XML_ERRORS="@unexpected_root_attributes_and_elements",bodyNames=["application/x-www-form-urlencoded","application/json","application/xml","multipart/form-data"];exports.serializeToXML=serializeToXML,exports.readObject=readObject,exports.getXmlErrors=getXmlErrors},function(module,exports,__webpack_require__){"use strict";function find(t,it){return _.find(t,it)}function filter(t,it){return _.filter(t,it)}function unique(t){return _.unique(t)}var _=__webpack_require__(177);exports.find=find,exports.filter=filter,exports.unique=unique},function(module,exports,__webpack_require__){"use strict";function objectToXml(object){if(!object)return"";var nodeName=Object.keys(object)[0],root=object[nodeName];if(!root&&""!==root)return"";var result="<"+nodeName,attributes=root.$||{};return Object.keys(attributes).forEach(function(key){result=result+" "+key+'="'+attributes[key]+'"'}),result+=">","string"==typeof root?result+=root:Object.keys(root).forEach(function(key){if("$"!==key)if("object"!=typeof root[key]||root[key].length)if("string"!=typeof root[key]&&root[key]){if("array"==typeof root[key]||root[key].length)for(var children=root[key],i=0;i<children.length;i++){var member=children[i],child={};child[key]=member,result+=objectToXml(child)}}else{var child={};child[key]=root[key]||"",result+=objectToXml(child)}else{var child={};child[key]=root[key],result+=objectToXml(child)}}),result=result+"</"+nodeName+">"}function getValidator(arg){return new XMLValidatorConstructor(arg)}function jsonToXml(jsonObject){var nodeName=jsonObject&&Object.keys(jsonObject)[0];if(nodeName){var root=jsonObject[nodeName];checkAttributes(root)}return objectToXml(jsonObject)}function checkAttributes(root){if(root&&"string"!=typeof root){var attributes=[];Object.keys(root).forEach(function(key){if("$"!=key)if(0===key.indexOf("@")){var attribute={key:key,value:root[key]};attributes.push(attribute)}else if(isArray(root[key])){var elements=root[key];elements.forEach(function(element){return checkAttributes(element)})}else"string"!=typeof root[key]&&checkAttributes(root[key])}),root.$||(root.$={});var newAttributes=root.$;attributes.forEach(function(attribute){delete root[attribute.key];var newKey=attribute.key.substring(1);newAttributes[newKey]=attribute.value})}}function isArray(instance){return instance?"object"==typeof instance&&"number"==typeof instance.length:!1}var XMLValidatorConstructor;try{XMLValidatorConstructor=__webpack_require__(171).XMLValidator}catch(exception){var XMLValidatorDummyImpl=function(){function XMLValidatorDummyImpl(arg){}return XMLValidatorDummyImpl.prototype.validate=function(xml){return[]},XMLValidatorDummyImpl}();XMLValidatorConstructor=XMLValidatorDummyImpl}exports.getValidator=getValidator,exports.jsonToXml=jsonToXml},function(module,exports,__webpack_require__){"use strict";function getValidator(){return new JSONValidatorConstructor}var JSONValidatorConstructor;try{JSONValidatorConstructor=__webpack_require__(172).JSONValidator}catch(exception){var JSONValidatorDummyImpl=function(){function JSONValidatorDummyImpl(){}return JSONValidatorDummyImpl.prototype.setRemoteReference=function(reference,content){},JSONValidatorDummyImpl.prototype.validateSchema=function(jsonSchema){},JSONValidatorDummyImpl.prototype.getMissingRemoteReferences=function(){return[]},JSONValidatorDummyImpl.prototype.isResourceLoaded=function(reference){return!0},JSONValidatorDummyImpl.prototype.validate=function(content,schema){},JSONValidatorDummyImpl.prototype.getLastErrors=function(){return[]},JSONValidatorDummyImpl}();JSONValidatorConstructor=JSONValidatorDummyImpl}exports.getValidator=getValidator},function(module,exports,__webpack_require__){var at,ch,text,value,escapee={'"':'"',"\\":"\\","/":"/",b:"\b",f:"\f",n:"\n",r:"\r",t:"	"},error=function(m){throw{name:"SyntaxError",message:m,at:at,text:text}},next=function(c){return c&&c!==ch&&error("Expected '"+c+"' instead of '"+ch+"'"),ch=text.charAt(at),at+=1,ch},number=function(){var number,string="";for("-"===ch&&(string="-",next("-"));ch>="0"&&"9">=ch;)string+=ch,next();if("."===ch)for(string+=".";next()&&ch>="0"&&"9">=ch;)string+=ch;if("e"===ch||"E"===ch)for(string+=ch,next(),("-"===ch||"+"===ch)&&(string+=ch,next());ch>="0"&&"9">=ch;)string+=ch,next();return number=+string,isFinite(number)?number:void error("Bad number")},string=function(){var hex,i,uffff,string="";if('"'===ch)for(;next();){if('"'===ch)return next(),string;if("\\"===ch)if(next(),"u"===ch){for(uffff=0,i=0;4>i&&(hex=parseInt(next(),16),isFinite(hex));i+=1)uffff=16*uffff+hex;string+=String.fromCharCode(uffff)}else{if("string"!=typeof escapee[ch])break;string+=escapee[ch]}else string+=ch}error("Bad string")},white=function(){for(;ch&&" ">=ch;)next()},word=function(){switch(ch){case"t":return next("t"),next("r"),next("u"),next("e"),!0;case"f":return next("f"),next("a"),next("l"),next("s"),next("e"),!1;case"n":return next("n"),next("u"),next("l"),next("l"),null}error("Unexpected '"+ch+"'")},array=function(){var array=[];if("["===ch){if(next("["),white(),"]"===ch)return next("]"),array;for(;ch;){if(array.push(value()),white(),"]"===ch)return next("]"),array;next(","),white()}}error("Bad array")},object=function(){var key,object={};if("{"===ch){if(next("{"),white(),"}"===ch)return next("}"),object;for(;ch;){if(key=string(),white(),next(":"),Object.hasOwnProperty.call(object,key)&&error('Duplicate key "'+key+'"'),object[key]=value(),white(),"}"===ch)return next("}"),object;next(","),white()}}error("Bad object")};value=function(){switch(white(),ch){case"{":return object();case"[":return array();case'"':return string();case"-":return number();default:return ch>="0"&&"9">=ch?number():word()}},module.exports=function(source,reviver){var result;return text=source,at=0,ch=" ",result=value(),white(),ch&&error("Syntax error"),"function"==typeof reviver?function walk(holder,key){var k,v,value=holder[key];if(value&&"object"==typeof value)for(k in value)Object.prototype.hasOwnProperty.call(value,k)&&(v=walk(value,k),void 0!==v?value[k]=v:delete value[k]);return reviver.call(holder,key,value)}({"":result},""):result}},function(module,exports,__webpack_require__){function quote(string){return escapable.lastIndex=0,escapable.test(string)?'"'+string.replace(escapable,function(a){var c=meta[a];return"string"==typeof c?c:"\\u"+("0000"+a.charCodeAt(0).toString(16)).slice(-4)})+'"':'"'+string+'"'}function str(key,holder){var i,k,v,length,partial,mind=gap,value=holder[key];switch(value&&"object"==typeof value&&"function"==typeof value.toJSON&&(value=value.toJSON(key)),"function"==typeof rep&&(value=rep.call(holder,key,value)),typeof value){case"string":return quote(value);case"number":return isFinite(value)?String(value):"null";case"boolean":case"null":return String(value);case"object":if(!value)return"null";if(gap+=indent,partial=[],"[object Array]"===Object.prototype.toString.apply(value)){for(length=value.length,i=0;length>i;i+=1)partial[i]=str(i,value)||"null";return v=0===partial.length?"[]":gap?"[\n"+gap+partial.join(",\n"+gap)+"\n"+mind+"]":"["+partial.join(",")+"]",gap=mind,v}if(rep&&"object"==typeof rep)for(length=rep.length,i=0;length>i;i+=1)k=rep[i],"string"==typeof k&&(v=str(k,value),v&&partial.push(quote(k)+(gap?": ":":")+v));else for(k in value)Object.prototype.hasOwnProperty.call(value,k)&&(v=str(k,value),v&&partial.push(quote(k)+(gap?": ":":")+v));return v=0===partial.length?"{}":gap?"{\n"+gap+partial.join(",\n"+gap)+"\n"+mind+"}":"{"+partial.join(",")+"}",gap=mind,v}}var gap,indent,rep,escapable=/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,meta={"\b":"\\b","	":"\\t","\n":"\\n","\f":"\\f","\r":"\\r",'"':'\\"',"\\":"\\\\"};module.exports=function(value,replacer,space){var i;if(gap="",indent="","number"==typeof space)for(i=0;space>i;i+=1)indent+=" ";else"string"==typeof space&&(indent=space);if(rep=replacer,replacer&&"function"!=typeof replacer&&("object"!=typeof replacer||"number"!=typeof replacer.length))throw new Error("JSON.stringify");return str("",{"":value})}},function(module,exports,__webpack_require__){module.exports=function(module){return module.webpackPolyfill||(module.deprecate=function(){},module.paths=[],module.children=[],module.webpackPolyfill=1),module}},function(module,exports,__webpack_require__){module.exports=__WEBPACK_EXTERNAL_MODULE_147__},function(module,exports,__webpack_require__){(function(process){"use strict";function ReadableState(options,stream){Duplex=Duplex||__webpack_require__(150),options=options||{},this.objectMode=!!options.objectMode,stream instanceof Duplex&&(this.objectMode=this.objectMode||!!options.readableObjectMode);var hwm=options.highWaterMark,defaultHwm=this.objectMode?16:16384;this.highWaterMark=hwm||0===hwm?hwm:defaultHwm,this.highWaterMark=~~this.highWaterMark,this.buffer=[],this.length=0,this.pipes=null,this.pipesCount=0,this.flowing=null,this.ended=!1,this.endEmitted=!1,this.reading=!1,this.sync=!0,this.needReadable=!1,this.emittedReadable=!1,this.readableListening=!1,this.resumeScheduled=!1,this.defaultEncoding=options.defaultEncoding||"utf8",this.ranOut=!1,this.awaitDrain=0,this.readingMore=!1,this.decoder=null,this.encoding=null,options.encoding&&(StringDecoder||(StringDecoder=__webpack_require__(204).StringDecoder),this.decoder=new StringDecoder(options.encoding),this.encoding=options.encoding)}function Readable(options){return Duplex=Duplex||__webpack_require__(150),this instanceof Readable?(this._readableState=new ReadableState(options,this),this.readable=!0,options&&"function"==typeof options.read&&(this._read=options.read),void Stream.call(this)):new Readable(options)}function readableAddChunk(stream,state,chunk,encoding,addToFront){var er=chunkInvalid(state,chunk);if(er)stream.emit("error",er);else if(null===chunk)state.reading=!1,onEofChunk(stream,state);else if(state.objectMode||chunk&&chunk.length>0)if(state.ended&&!addToFront){var e=new Error("stream.push() after EOF");stream.emit("error",e)}else if(state.endEmitted&&addToFront){var e=new Error("stream.unshift() after end event");stream.emit("error",e)}else{var skipAdd;!state.decoder||addToFront||encoding||(chunk=state.decoder.write(chunk),skipAdd=!state.objectMode&&0===chunk.length),addToFront||(state.reading=!1),skipAdd||(state.flowing&&0===state.length&&!state.sync?(stream.emit("data",chunk),stream.read(0)):(state.length+=state.objectMode?1:chunk.length,addToFront?state.buffer.unshift(chunk):state.buffer.push(chunk),state.needReadable&&emitReadable(stream))),maybeReadMore(stream,state)}else addToFront||(state.reading=!1);return needMoreData(state)}function needMoreData(state){return!state.ended&&(state.needReadable||state.length<state.highWaterMark||0===state.length)}function computeNewHighWaterMark(n){return n>=MAX_HWM?n=MAX_HWM:(n--,n|=n>>>1,n|=n>>>2,n|=n>>>4,n|=n>>>8,n|=n>>>16,n++),n}function howMuchToRead(n,state){return 0===state.length&&state.ended?0:state.objectMode?0===n?0:1:null===n||isNaN(n)?state.flowing&&state.buffer.length?state.buffer[0].length:state.length:0>=n?0:(n>state.highWaterMark&&(state.highWaterMark=computeNewHighWaterMark(n)),n>state.length?state.ended?state.length:(state.needReadable=!0,0):n)}function chunkInvalid(state,chunk){var er=null;return Buffer.isBuffer(chunk)||"string"==typeof chunk||null===chunk||void 0===chunk||state.objectMode||(er=new TypeError("Invalid non-string/buffer chunk")),er}function onEofChunk(stream,state){if(!state.ended){if(state.decoder){var chunk=state.decoder.end();chunk&&chunk.length&&(state.buffer.push(chunk),state.length+=state.objectMode?1:chunk.length)}state.ended=!0,emitReadable(stream)}}function emitReadable(stream){var state=stream._readableState;state.needReadable=!1,state.emittedReadable||(debug("emitReadable",state.flowing),state.emittedReadable=!0,state.sync?processNextTick(emitReadable_,stream):emitReadable_(stream))}function emitReadable_(stream){debug("emit readable"),stream.emit("readable"),flow(stream)}function maybeReadMore(stream,state){state.readingMore||(state.readingMore=!0,processNextTick(maybeReadMore_,stream,state))}function maybeReadMore_(stream,state){for(var len=state.length;!state.reading&&!state.flowing&&!state.ended&&state.length<state.highWaterMark&&(debug("maybeReadMore read 0"),stream.read(0),len!==state.length);)len=state.length;state.readingMore=!1}function pipeOnDrain(src){return function(){var state=src._readableState;debug("pipeOnDrain",state.awaitDrain),state.awaitDrain&&state.awaitDrain--,0===state.awaitDrain&&EElistenerCount(src,"data")&&(state.flowing=!0,flow(src))}}function nReadingNextTick(self){debug("readable nexttick read 0"),self.read(0)}function resume(stream,state){state.resumeScheduled||(state.resumeScheduled=!0,processNextTick(resume_,stream,state))}function resume_(stream,state){state.reading||(debug("resume read 0"),stream.read(0)),state.resumeScheduled=!1,stream.emit("resume"),flow(stream),state.flowing&&!state.reading&&stream.read(0)}function flow(stream){var state=stream._readableState;if(debug("flow",state.flowing),state.flowing)do var chunk=stream.read();while(null!==chunk&&state.flowing)}function fromList(n,state){var ret,list=state.buffer,length=state.length,stringMode=!!state.decoder,objectMode=!!state.objectMode;if(0===list.length)return null;if(0===length)ret=null;else if(objectMode)ret=list.shift();else if(!n||n>=length)ret=stringMode?list.join(""):1===list.length?list[0]:Buffer.concat(list,length),list.length=0;else if(n<list[0].length){var buf=list[0];ret=buf.slice(0,n),list[0]=buf.slice(n)}else if(n===list[0].length)ret=list.shift();else{ret=stringMode?"":new Buffer(n);for(var c=0,i=0,l=list.length;l>i&&n>c;i++){var buf=list[0],cpy=Math.min(n-c,buf.length);stringMode?ret+=buf.slice(0,cpy):buf.copy(ret,c,0,cpy),cpy<buf.length?list[0]=buf.slice(cpy):list.shift(),c+=cpy}}return ret}function endReadable(stream){var state=stream._readableState;if(state.length>0)throw new Error("endReadable called on non-empty stream");state.endEmitted||(state.ended=!0,processNextTick(endReadableNT,state,stream))}function endReadableNT(state,stream){state.endEmitted||0!==state.length||(state.endEmitted=!0,stream.readable=!1,stream.emit("end"))}function forEach(xs,f){for(var i=0,l=xs.length;l>i;i++)f(xs[i],i)}function indexOf(xs,x){for(var i=0,l=xs.length;l>i;i++)if(xs[i]===x)return i;return-1}module.exports=Readable;var processNextTick=__webpack_require__(201),isArray=__webpack_require__(202),Buffer=__webpack_require__(92).Buffer;Readable.ReadableState=ReadableState;var Stream,EElistenerCount=(__webpack_require__(203),function(emitter,type){return emitter.listeners(type).length});!function(){try{Stream=__webpack_require__(176)}catch(_){}finally{Stream||(Stream=__webpack_require__(203).EventEmitter)}}();var Buffer=__webpack_require__(92).Buffer,util=__webpack_require__(211);util.inherits=__webpack_require__(110);var debugUtil=__webpack_require__(184),debug=void 0;debug=debugUtil&&debugUtil.debuglog?debugUtil.debuglog("stream"):function(){};var StringDecoder;util.inherits(Readable,Stream);var Duplex,Duplex;Readable.prototype.push=function(chunk,encoding){var state=this._readableState;return state.objectMode||"string"!=typeof chunk||(encoding=encoding||state.defaultEncoding,encoding!==state.encoding&&(chunk=new Buffer(chunk,encoding),encoding="")),readableAddChunk(this,state,chunk,encoding,!1)},Readable.prototype.unshift=function(chunk){var state=this._readableState;return readableAddChunk(this,state,chunk,"",!0)},Readable.prototype.isPaused=function(){return this._readableState.flowing===!1},Readable.prototype.setEncoding=function(enc){return StringDecoder||(StringDecoder=__webpack_require__(204).StringDecoder),this._readableState.decoder=new StringDecoder(enc),this._readableState.encoding=enc,this};var MAX_HWM=8388608;Readable.prototype.read=function(n){debug("read",n);var state=this._readableState,nOrig=n;if(("number"!=typeof n||n>0)&&(state.emittedReadable=!1),0===n&&state.needReadable&&(state.length>=state.highWaterMark||state.ended))return debug("read: emitReadable",state.length,state.ended),0===state.length&&state.ended?endReadable(this):emitReadable(this),null;if(n=howMuchToRead(n,state),0===n&&state.ended)return 0===state.length&&endReadable(this),null;var doRead=state.needReadable;debug("need readable",doRead),(0===state.length||state.length-n<state.highWaterMark)&&(doRead=!0,debug("length less than watermark",doRead)),(state.ended||state.reading)&&(doRead=!1,debug("reading or ended",doRead)),doRead&&(debug("do read"),state.reading=!0,state.sync=!0,0===state.length&&(state.needReadable=!0),this._read(state.highWaterMark),state.sync=!1),doRead&&!state.reading&&(n=howMuchToRead(nOrig,state));var ret;return ret=n>0?fromList(n,state):null,null===ret&&(state.needReadable=!0,n=0),state.length-=n,0!==state.length||state.ended||(state.needReadable=!0),nOrig!==n&&state.ended&&0===state.length&&endReadable(this),null!==ret&&this.emit("data",ret),ret},Readable.prototype._read=function(n){this.emit("error",new Error("not implemented"))},Readable.prototype.pipe=function(dest,pipeOpts){
function onunpipe(readable){debug("onunpipe"),readable===src&&cleanup()}function onend(){debug("onend"),dest.end()}function cleanup(){debug("cleanup"),dest.removeListener("close",onclose),dest.removeListener("finish",onfinish),dest.removeListener("drain",ondrain),dest.removeListener("error",onerror),dest.removeListener("unpipe",onunpipe),src.removeListener("end",onend),src.removeListener("end",cleanup),src.removeListener("data",ondata),cleanedUp=!0,!state.awaitDrain||dest._writableState&&!dest._writableState.needDrain||ondrain()}function ondata(chunk){debug("ondata");var ret=dest.write(chunk);!1===ret&&(1!==state.pipesCount||state.pipes[0]!==dest||1!==src.listenerCount("data")||cleanedUp||(debug("false write response, pause",src._readableState.awaitDrain),src._readableState.awaitDrain++),src.pause())}function onerror(er){debug("onerror",er),unpipe(),dest.removeListener("error",onerror),0===EElistenerCount(dest,"error")&&dest.emit("error",er)}function onclose(){dest.removeListener("finish",onfinish),unpipe()}function onfinish(){debug("onfinish"),dest.removeListener("close",onclose),unpipe()}function unpipe(){debug("unpipe"),src.unpipe(dest)}var src=this,state=this._readableState;switch(state.pipesCount){case 0:state.pipes=dest;break;case 1:state.pipes=[state.pipes,dest];break;default:state.pipes.push(dest)}state.pipesCount+=1,debug("pipe count=%d opts=%j",state.pipesCount,pipeOpts);var doEnd=(!pipeOpts||pipeOpts.end!==!1)&&dest!==process.stdout&&dest!==process.stderr,endFn=doEnd?onend:cleanup;state.endEmitted?processNextTick(endFn):src.once("end",endFn),dest.on("unpipe",onunpipe);var ondrain=pipeOnDrain(src);dest.on("drain",ondrain);var cleanedUp=!1;return src.on("data",ondata),dest._events&&dest._events.error?isArray(dest._events.error)?dest._events.error.unshift(onerror):dest._events.error=[onerror,dest._events.error]:dest.on("error",onerror),dest.once("close",onclose),dest.once("finish",onfinish),dest.emit("pipe",src),state.flowing||(debug("pipe resume"),src.resume()),dest},Readable.prototype.unpipe=function(dest){var state=this._readableState;if(0===state.pipesCount)return this;if(1===state.pipesCount)return dest&&dest!==state.pipes?this:(dest||(dest=state.pipes),state.pipes=null,state.pipesCount=0,state.flowing=!1,dest&&dest.emit("unpipe",this),this);if(!dest){var dests=state.pipes,len=state.pipesCount;state.pipes=null,state.pipesCount=0,state.flowing=!1;for(var _i=0;len>_i;_i++)dests[_i].emit("unpipe",this);return this}var i=indexOf(state.pipes,dest);return-1===i?this:(state.pipes.splice(i,1),state.pipesCount-=1,1===state.pipesCount&&(state.pipes=state.pipes[0]),dest.emit("unpipe",this),this)},Readable.prototype.on=function(ev,fn){var res=Stream.prototype.on.call(this,ev,fn);if("data"===ev&&!1!==this._readableState.flowing&&this.resume(),"readable"===ev&&!this._readableState.endEmitted){var state=this._readableState;state.readableListening||(state.readableListening=!0,state.emittedReadable=!1,state.needReadable=!0,state.reading?state.length&&emitReadable(this,state):processNextTick(nReadingNextTick,this))}return res},Readable.prototype.addListener=Readable.prototype.on,Readable.prototype.resume=function(){var state=this._readableState;return state.flowing||(debug("resume"),state.flowing=!0,resume(this,state)),this},Readable.prototype.pause=function(){return debug("call pause flowing=%j",this._readableState.flowing),!1!==this._readableState.flowing&&(debug("pause"),this._readableState.flowing=!1,this.emit("pause")),this},Readable.prototype.wrap=function(stream){var state=this._readableState,paused=!1,self=this;stream.on("end",function(){if(debug("wrapped end"),state.decoder&&!state.ended){var chunk=state.decoder.end();chunk&&chunk.length&&self.push(chunk)}self.push(null)}),stream.on("data",function(chunk){if(debug("wrapped data"),state.decoder&&(chunk=state.decoder.write(chunk)),(!state.objectMode||null!==chunk&&void 0!==chunk)&&(state.objectMode||chunk&&chunk.length)){var ret=self.push(chunk);ret||(paused=!0,stream.pause())}});for(var i in stream)void 0===this[i]&&"function"==typeof stream[i]&&(this[i]=function(method){return function(){return stream[method].apply(stream,arguments)}}(i));var events=["error","close","destroy","pause","resume"];return forEach(events,function(ev){stream.on(ev,self.emit.bind(self,ev))}),self._read=function(n){debug("wrapped _read",n),paused&&(paused=!1,stream.resume())},self},Readable._fromList=fromList}).call(exports,__webpack_require__(59))},function(module,exports,__webpack_require__){(function(process){"use strict";function nop(){}function WriteReq(chunk,encoding,cb){this.chunk=chunk,this.encoding=encoding,this.callback=cb,this.next=null}function WritableState(options,stream){Duplex=Duplex||__webpack_require__(150),options=options||{},this.objectMode=!!options.objectMode,stream instanceof Duplex&&(this.objectMode=this.objectMode||!!options.writableObjectMode);var hwm=options.highWaterMark,defaultHwm=this.objectMode?16:16384;this.highWaterMark=hwm||0===hwm?hwm:defaultHwm,this.highWaterMark=~~this.highWaterMark,this.needDrain=!1,this.ending=!1,this.ended=!1,this.finished=!1;var noDecode=options.decodeStrings===!1;this.decodeStrings=!noDecode,this.defaultEncoding=options.defaultEncoding||"utf8",this.length=0,this.writing=!1,this.corked=0,this.sync=!0,this.bufferProcessing=!1,this.onwrite=function(er){onwrite(stream,er)},this.writecb=null,this.writelen=0,this.bufferedRequest=null,this.lastBufferedRequest=null,this.pendingcb=0,this.prefinished=!1,this.errorEmitted=!1,this.bufferedRequestCount=0,this.corkedRequestsFree=new CorkedRequest(this),this.corkedRequestsFree.next=new CorkedRequest(this)}function Writable(options){return Duplex=Duplex||__webpack_require__(150),this instanceof Writable||this instanceof Duplex?(this._writableState=new WritableState(options,this),this.writable=!0,options&&("function"==typeof options.write&&(this._write=options.write),"function"==typeof options.writev&&(this._writev=options.writev)),void Stream.call(this)):new Writable(options)}function writeAfterEnd(stream,cb){var er=new Error("write after end");stream.emit("error",er),processNextTick(cb,er)}function validChunk(stream,state,chunk,cb){var valid=!0;if(!Buffer.isBuffer(chunk)&&"string"!=typeof chunk&&null!==chunk&&void 0!==chunk&&!state.objectMode){var er=new TypeError("Invalid non-string/buffer chunk");stream.emit("error",er),processNextTick(cb,er),valid=!1}return valid}function decodeChunk(state,chunk,encoding){return state.objectMode||state.decodeStrings===!1||"string"!=typeof chunk||(chunk=new Buffer(chunk,encoding)),chunk}function writeOrBuffer(stream,state,chunk,encoding,cb){chunk=decodeChunk(state,chunk,encoding),Buffer.isBuffer(chunk)&&(encoding="buffer");var len=state.objectMode?1:chunk.length;state.length+=len;var ret=state.length<state.highWaterMark;if(ret||(state.needDrain=!0),state.writing||state.corked){var last=state.lastBufferedRequest;state.lastBufferedRequest=new WriteReq(chunk,encoding,cb),last?last.next=state.lastBufferedRequest:state.bufferedRequest=state.lastBufferedRequest,state.bufferedRequestCount+=1}else doWrite(stream,state,!1,len,chunk,encoding,cb);return ret}function doWrite(stream,state,writev,len,chunk,encoding,cb){state.writelen=len,state.writecb=cb,state.writing=!0,state.sync=!0,writev?stream._writev(chunk,state.onwrite):stream._write(chunk,encoding,state.onwrite),state.sync=!1}function onwriteError(stream,state,sync,er,cb){--state.pendingcb,sync?processNextTick(cb,er):cb(er),stream._writableState.errorEmitted=!0,stream.emit("error",er)}function onwriteStateUpdate(state){state.writing=!1,state.writecb=null,state.length-=state.writelen,state.writelen=0}function onwrite(stream,er){var state=stream._writableState,sync=state.sync,cb=state.writecb;if(onwriteStateUpdate(state),er)onwriteError(stream,state,sync,er,cb);else{var finished=needFinish(state);finished||state.corked||state.bufferProcessing||!state.bufferedRequest||clearBuffer(stream,state),sync?asyncWrite(afterWrite,stream,state,finished,cb):afterWrite(stream,state,finished,cb)}}function afterWrite(stream,state,finished,cb){finished||onwriteDrain(stream,state),state.pendingcb--,cb(),finishMaybe(stream,state)}function onwriteDrain(stream,state){0===state.length&&state.needDrain&&(state.needDrain=!1,stream.emit("drain"))}function clearBuffer(stream,state){state.bufferProcessing=!0;var entry=state.bufferedRequest;if(stream._writev&&entry&&entry.next){var l=state.bufferedRequestCount,buffer=new Array(l),holder=state.corkedRequestsFree;holder.entry=entry;for(var count=0;entry;)buffer[count]=entry,entry=entry.next,count+=1;doWrite(stream,state,!0,state.length,buffer,"",holder.finish),state.pendingcb++,state.lastBufferedRequest=null,state.corkedRequestsFree=holder.next,holder.next=null}else{for(;entry;){var chunk=entry.chunk,encoding=entry.encoding,cb=entry.callback,len=state.objectMode?1:chunk.length;if(doWrite(stream,state,!1,len,chunk,encoding,cb),entry=entry.next,state.writing)break}null===entry&&(state.lastBufferedRequest=null)}state.bufferedRequestCount=0,state.bufferedRequest=entry,state.bufferProcessing=!1}function needFinish(state){return state.ending&&0===state.length&&null===state.bufferedRequest&&!state.finished&&!state.writing}function prefinish(stream,state){state.prefinished||(state.prefinished=!0,stream.emit("prefinish"))}function finishMaybe(stream,state){var need=needFinish(state);return need&&(0===state.pendingcb?(prefinish(stream,state),state.finished=!0,stream.emit("finish")):prefinish(stream,state)),need}function endWritable(stream,state,cb){state.ending=!0,finishMaybe(stream,state),cb&&(state.finished?processNextTick(cb):stream.once("finish",cb)),state.ended=!0,stream.writable=!1}function CorkedRequest(state){var _this=this;this.next=null,this.entry=null,this.finish=function(err){var entry=_this.entry;for(_this.entry=null;entry;){var cb=entry.callback;state.pendingcb--,cb(err),entry=entry.next}state.corkedRequestsFree?state.corkedRequestsFree.next=_this:state.corkedRequestsFree=_this}}module.exports=Writable;var processNextTick=__webpack_require__(201),asyncWrite=!process.browser&&["v0.10","v0.9."].indexOf(process.version.slice(0,5))>-1?setImmediate:processNextTick,Buffer=__webpack_require__(92).Buffer;Writable.WritableState=WritableState;var util=__webpack_require__(211);util.inherits=__webpack_require__(110);var Stream,internalUtil={deprecate:__webpack_require__(205)};!function(){try{Stream=__webpack_require__(176)}catch(_){}finally{Stream||(Stream=__webpack_require__(203).EventEmitter)}}();var Buffer=__webpack_require__(92).Buffer;util.inherits(Writable,Stream);var Duplex;WritableState.prototype.getBuffer=function(){for(var current=this.bufferedRequest,out=[];current;)out.push(current),current=current.next;return out},function(){try{Object.defineProperty(WritableState.prototype,"buffer",{get:internalUtil.deprecate(function(){return this.getBuffer()},"_writableState.buffer is deprecated. Use _writableState.getBuffer instead.")})}catch(_){}}();var Duplex;Writable.prototype.pipe=function(){this.emit("error",new Error("Cannot pipe. Not readable."))},Writable.prototype.write=function(chunk,encoding,cb){var state=this._writableState,ret=!1;return"function"==typeof encoding&&(cb=encoding,encoding=null),Buffer.isBuffer(chunk)?encoding="buffer":encoding||(encoding=state.defaultEncoding),"function"!=typeof cb&&(cb=nop),state.ended?writeAfterEnd(this,cb):validChunk(this,state,chunk,cb)&&(state.pendingcb++,ret=writeOrBuffer(this,state,chunk,encoding,cb)),ret},Writable.prototype.cork=function(){var state=this._writableState;state.corked++},Writable.prototype.uncork=function(){var state=this._writableState;state.corked&&(state.corked--,state.writing||state.corked||state.finished||state.bufferProcessing||!state.bufferedRequest||clearBuffer(this,state))},Writable.prototype.setDefaultEncoding=function(encoding){if("string"==typeof encoding&&(encoding=encoding.toLowerCase()),!(["hex","utf8","utf-8","ascii","binary","base64","ucs2","ucs-2","utf16le","utf-16le","raw"].indexOf((encoding+"").toLowerCase())>-1))throw new TypeError("Unknown encoding: "+encoding);this._writableState.defaultEncoding=encoding},Writable.prototype._write=function(chunk,encoding,cb){cb(new Error("not implemented"))},Writable.prototype._writev=null,Writable.prototype.end=function(chunk,encoding,cb){var state=this._writableState;"function"==typeof chunk?(cb=chunk,chunk=null,encoding=null):"function"==typeof encoding&&(cb=encoding,encoding=null),null!==chunk&&void 0!==chunk&&this.write(chunk,encoding),state.corked&&(state.corked=1,this.uncork()),state.ending||state.finished||endWritable(this,state,cb)}}).call(exports,__webpack_require__(59))},function(module,exports,__webpack_require__){"use strict";function Duplex(options){return this instanceof Duplex?(Readable.call(this,options),Writable.call(this,options),options&&options.readable===!1&&(this.readable=!1),options&&options.writable===!1&&(this.writable=!1),this.allowHalfOpen=!0,options&&options.allowHalfOpen===!1&&(this.allowHalfOpen=!1),void this.once("end",onend)):new Duplex(options)}function onend(){this.allowHalfOpen||this._writableState.ended||processNextTick(onEndNT,this)}function onEndNT(self){self.end()}var objectKeys=Object.keys||function(obj){var keys=[];for(var key in obj)keys.push(key);return keys};module.exports=Duplex;var processNextTick=__webpack_require__(201),util=__webpack_require__(211);util.inherits=__webpack_require__(110);var Readable=__webpack_require__(148),Writable=__webpack_require__(149);util.inherits(Duplex,Readable);for(var keys=objectKeys(Writable.prototype),v=0;v<keys.length;v++){var method=keys[v];Duplex.prototype[method]||(Duplex.prototype[method]=Writable.prototype[method])}},function(module,exports,__webpack_require__){"use strict";function TransformState(stream){this.afterTransform=function(er,data){return afterTransform(stream,er,data)},this.needTransform=!1,this.transforming=!1,this.writecb=null,this.writechunk=null,this.writeencoding=null}function afterTransform(stream,er,data){var ts=stream._transformState;ts.transforming=!1;var cb=ts.writecb;if(!cb)return stream.emit("error",new Error("no writecb in Transform class"));ts.writechunk=null,ts.writecb=null,null!==data&&void 0!==data&&stream.push(data),cb(er);var rs=stream._readableState;rs.reading=!1,(rs.needReadable||rs.length<rs.highWaterMark)&&stream._read(rs.highWaterMark)}function Transform(options){if(!(this instanceof Transform))return new Transform(options);Duplex.call(this,options),this._transformState=new TransformState(this);var stream=this;this._readableState.needReadable=!0,this._readableState.sync=!1,options&&("function"==typeof options.transform&&(this._transform=options.transform),"function"==typeof options.flush&&(this._flush=options.flush)),this.once("prefinish",function(){"function"==typeof this._flush?this._flush(function(er){done(stream,er)}):done(stream)})}function done(stream,er){if(er)return stream.emit("error",er);var ws=stream._writableState,ts=stream._transformState;if(ws.length)throw new Error("calling transform done when ws.length != 0");if(ts.transforming)throw new Error("calling transform done when still transforming");return stream.push(null)}module.exports=Transform;var Duplex=__webpack_require__(150),util=__webpack_require__(211);util.inherits=__webpack_require__(110),util.inherits(Transform,Duplex),Transform.prototype.push=function(chunk,encoding){return this._transformState.needTransform=!1,Duplex.prototype.push.call(this,chunk,encoding)},Transform.prototype._transform=function(chunk,encoding,cb){throw new Error("not implemented")},Transform.prototype._write=function(chunk,encoding,cb){var ts=this._transformState;if(ts.writecb=cb,ts.writechunk=chunk,ts.writeencoding=encoding,!ts.transforming){var rs=this._readableState;(ts.needTransform||rs.needReadable||rs.length<rs.highWaterMark)&&this._read(rs.highWaterMark)}},Transform.prototype._read=function(n){var ts=this._transformState;null!==ts.writechunk&&ts.writecb&&!ts.transforming?(ts.transforming=!0,this._transform(ts.writechunk,ts.writeencoding,ts.afterTransform)):ts.needTransform=!0}},function(module,exports,__webpack_require__){"use strict";function PassThrough(options){return this instanceof PassThrough?void Transform.call(this,options):new PassThrough(options)}module.exports=PassThrough;var Transform=__webpack_require__(151),util=__webpack_require__(211);util.inherits=__webpack_require__(110),util.inherits(PassThrough,Transform),PassThrough.prototype._transform=function(chunk,encoding,cb){cb(null,chunk)}},function(module,exports,__webpack_require__){"use strict";function compileList(schema,name,result){var exclude=[];return schema.include.forEach(function(includedSchema){result=compileList(includedSchema,name,result)}),schema[name].forEach(function(currentType){result.forEach(function(previousType,previousIndex){previousType.tag===currentType.tag&&exclude.push(previousIndex)}),result.push(currentType)}),result.filter(function(type,index){return-1===exclude.indexOf(index)})}function compileMap(){function collectType(type){result[type.tag]=type}var index,length,result={};for(index=0,length=arguments.length;length>index;index+=1)arguments[index].forEach(collectType);return result}var common=__webpack_require__(112),YAMLException=__webpack_require__(113),Type=__webpack_require__(187),Schema=function(){function Schema(definition){this.include=definition.include||[],this.implicit=definition.implicit||[],this.explicit=definition.explicit||[],this.implicit.forEach(function(type){if(type.loadKind&&"scalar"!==type.loadKind)throw new YAMLException("There is a non-scalar type in the implicit list of a schema. Implicit resolving of such types is not supported.")}),this.compiledImplicit=compileList(this,"implicit",[]),this.compiledExplicit=compileList(this,"explicit",[]),this.compiledTypeMap=compileMap(this.compiledImplicit,this.compiledExplicit)}return Schema.DEFAULT=null,Schema.create=function(){var schemas,types;switch(arguments.length){case 1:schemas=Schema.DEFAULT,types=arguments[0];break;case 2:schemas=arguments[0],types=arguments[1];break;default:throw new YAMLException("Wrong number of arguments for Schema.create function")}if(schemas=common.toArray(schemas),types=common.toArray(types),!schemas.every(function(schema){return schema instanceof Schema}))throw new YAMLException("Specified list of super schemas (or a single Schema object) contains a non-Schema object.");if(!types.every(function(type){return type instanceof Type}))throw new YAMLException("Specified list of YAML types (or a single Type object) contains a non-Type object.");return new Schema({include:schemas,explicit:types})},Schema}();module.exports=Schema},function(module,exports,__webpack_require__){"use strict";var Schema=__webpack_require__(153);module.exports=new Schema({include:[__webpack_require__(188)]})},function(module,exports,__webpack_require__){"use strict";module.exports=__webpack_require__(189),__webpack_require__(190),__webpack_require__(191),__webpack_require__(192),__webpack_require__(193),__webpack_require__(194)},function(module,exports,__webpack_require__){"use strict";function getHelperMethods(srcPath){var result=[],content=fs.readFileSync(path.resolve(srcPath)).toString(),mod=ts.createSourceFile("sample.ts",content,ts.ScriptTarget.ES3,!0);return tsm.Matching.visit(mod,function(x){var node=x;if(node.kind==ts.SyntaxKind.FunctionDeclaration){var meta=getMeta(node,content);if(!meta)return;var originalName=node.name.text,wrapperMethodName=originalName;meta.name?wrapperMethodName=meta.name:meta.name=originalName;var wrapperMethodName=meta.name?meta.name:originalName,args=node.parameters?node.parameters.map(function(a){return readArg(a,srcPath)}):[],returnType=(meta.override?meta.override:!1,tsStructureParser.buildType(node.type,srcPath));result.push(new helpers_1.HelperMethod(originalName,wrapperMethodName,returnType,args,meta))}}),result}function getMeta(node,content){var cRange=ts.getLeadingCommentRanges(content,node.pos);if(!cRange)return null;var comment=cRange.map(function(x){return content.substring(x.pos,x.end)}).join("\n"),ind=comment.indexOf("__$helperMethod__");if(0>ind)return null;ind+="__$helperMethod__".length;var indMeta=comment.indexOf("__$meta__");if(0>indMeta)return{comment:refineComment(comment.substring(ind))};var commentStr=refineComment(comment.substring(ind,indMeta)),indMetaObj=comment.indexOf("{",indMeta);if(0>indMetaObj)return{comment:commentStr};try{var meta=JSON.parse(refineComment(comment.substring(indMetaObj)));return meta.comment=commentStr.trim().length>0?commentStr:null,meta.override=meta.override||!1,meta.primary=meta.primary||!1,meta.deprecated=meta.deprecated||!1,meta}catch(e){console.log(e)}return{}}function readArg(node,srcPath){var defaultValue,name=node.name.text,type=tsStructureParser.buildType(node.type,srcPath),optional=null!=node.questionToken;return null!=node.initializer&&(defaultValue=tsStructureParser.parseArg(node.initializer),optional=!0),{name:name,type:type,defaultValue:defaultValue,optional:optional}}var ts=__webpack_require__(147),tsm=__webpack_require__(157),path=__webpack_require__(15),fs=__webpack_require__(38),tsStructureParser=__webpack_require__(135),helpers_1=__webpack_require__(134);exports.getHelperMethods=getHelperMethods;var refineComment=function(comment){return comment.replace(/^\s*\/\*+/g,"").replace(/\*+\/\s*$/g,"").split("\n").map(function(x){return x.replace(/^\s*\/\//g,"").replace(/^\s*\* {0,1}/g,"")}).join("\n").trim()}},function(module,exports,__webpack_require__){"use strict";var Matching,__extends=this&&this.__extends||function(d,b){function __(){this.constructor=d}for(var p in b)b.hasOwnProperty(p)&&(d[p]=b[p]);d.prototype=null===b?Object.create(b):(__.prototype=b.prototype,new __)},ts=__webpack_require__(147);!function(Matching){function visit(n,cb){var r0=cb(n);if(r0)return r0==Matching.SKIP?null:r0;var r=ts.forEachChild(n,function(x){var r=visit(x,cb);return r?r:void 0});return r}function memberFromExp(objMatcher,tr){void 0===tr&&(tr=function(x){return!0});for(var array=objMatcher.split("."),result=null,a=0;a<array.length;a++){var arg=array[a],ci=arg.indexOf("(*)"),isCall=!1;-1!=ci&&(arg=arg.substr(0,ci),isCall=!0),result=null==result?"*"==arg?anyNode():ident(arg):new MemberExpressionMatcher(result,"*"==arg?anyNode():ident(arg),tr),isCall&&(result=new CallExpressionMatcher(result,tr))}return result}function ident(name){return new SimpleIdentMatcher(name)}function anyNode(){return new TrueMatcher}function call(calleeMatcher,tr){return void 0===tr&&(tr=function(x){return!0}),new CallExpressionMatcher(calleeMatcher,tr)}function exprStmt(eM,tr){return void 0===tr&&(tr=function(x){return!0}),new ExpressionStatementMatcher(eM,tr)}function assign(left,right,tr){return void 0===tr&&(tr=function(x){return!0}),new AssignmentExpressionMatcher(left,right,tr)}function varDecl(left,right,tr){return void 0===tr&&(tr=function(x){return!0}),new VariableDeclarationMatcher(left,right,tr)}function field(){return new FieldMatcher}function classDeclaration(){return new ClassDeclarationMatcher}var BasicMatcher=function(){function BasicMatcher(){}return BasicMatcher.prototype.match=function(node){throw new Error},BasicMatcher.prototype.nodeType=function(){throw new Error},BasicMatcher.prototype.doMatch=function(n){return n?this.nodeType()==n.kind?this.match(n):void 0:null},BasicMatcher}();Matching.BasicMatcher=BasicMatcher;var ClassDeclarationMatcher=function(_super){function ClassDeclarationMatcher(){_super.call(this)}return __extends(ClassDeclarationMatcher,_super),ClassDeclarationMatcher.prototype.match=function(node){return node},ClassDeclarationMatcher.prototype.nodeType=function(){return ts.SyntaxKind.ClassDeclaration},ClassDeclarationMatcher}(BasicMatcher);Matching.ClassDeclarationMatcher=ClassDeclarationMatcher;var FieldMatcher=function(_super){function FieldMatcher(){_super.apply(this,arguments)}return __extends(FieldMatcher,_super),FieldMatcher.prototype.match=function(node){return node},FieldMatcher.prototype.nodeType=function(){return ts.SyntaxKind.PropertyDeclaration},FieldMatcher}(BasicMatcher);Matching.FieldMatcher=FieldMatcher;var AssignmentExpressionMatcher=function(_super){function AssignmentExpressionMatcher(left,right,tr){_super.call(this),this.left=left,this.right=right,this.tr=tr}return __extends(AssignmentExpressionMatcher,_super),AssignmentExpressionMatcher.prototype.match=function(node){return node.operatorToken.kind==ts.SyntaxKind.EqualsToken&&this.left.doMatch(node.left)&&this.right.doMatch(node.right)?this.tr(node):null},AssignmentExpressionMatcher.prototype.nodeType=function(){return ts.SyntaxKind.BinaryExpression},AssignmentExpressionMatcher}(BasicMatcher);Matching.AssignmentExpressionMatcher=AssignmentExpressionMatcher;var VariableDeclarationMatcher=function(_super){function VariableDeclarationMatcher(left,right,tr){_super.call(this),this.left=left,this.right=right,this.tr=tr}return __extends(VariableDeclarationMatcher,_super),VariableDeclarationMatcher.prototype.match=function(node){return this.left.doMatch(node.name)&&this.right.doMatch(node.initializer)?this.tr(node):void 0},VariableDeclarationMatcher.prototype.nodeType=function(){return ts.SyntaxKind.VariableDeclaration},VariableDeclarationMatcher}(BasicMatcher);Matching.VariableDeclarationMatcher=VariableDeclarationMatcher;var ExpressionStatementMatcher=function(_super){function ExpressionStatementMatcher(expression,tr){_super.call(this),this.expression=expression,this.tr=tr}return __extends(ExpressionStatementMatcher,_super),ExpressionStatementMatcher.prototype.match=function(node){var exp=this.expression.doMatch(node.expression);if(exp){var v=this.tr(node.expression);return 1==v?exp:v}return null},ExpressionStatementMatcher.prototype.nodeType=function(){return ts.SyntaxKind.ExpressionStatement},ExpressionStatementMatcher}(BasicMatcher),SimpleIdentMatcher=function(_super){function SimpleIdentMatcher(val){_super.call(this),this.val=val}return __extends(SimpleIdentMatcher,_super),SimpleIdentMatcher.prototype.match=function(node){return node.text==this.val?!0:null},SimpleIdentMatcher.prototype.nodeType=function(){return ts.SyntaxKind.Identifier},SimpleIdentMatcher}(BasicMatcher),TrueMatcher=function(){function TrueMatcher(){}return TrueMatcher.prototype.doMatch=function(node){return!0},TrueMatcher.prototype.nodeType=function(){return null},TrueMatcher}(),CallExpressionMatcher=function(_super){function CallExpressionMatcher(calleeMatcher,tr){_super.call(this),this.calleeMatcher=calleeMatcher,this.tr=tr}return __extends(CallExpressionMatcher,_super),CallExpressionMatcher.prototype.match=function(node){return this.calleeMatcher.doMatch(node.expression)?this.tr(node):null},CallExpressionMatcher.prototype.nodeType=function(){return ts.SyntaxKind.CallExpression},CallExpressionMatcher}(BasicMatcher);Matching.SKIP={},Matching.visit=visit;var PathNode=function(){function PathNode(name,_base){this._base=_base,this.arguments=null,this.name=name}return PathNode}();Matching.PathNode=PathNode;var CallPath=function(){function CallPath(base,_baseNode){this._baseNode=_baseNode,this.path=[],this.base=base}return CallPath.prototype.start=function(){return this._baseNode.pos},CallPath.prototype.startLocation=function(){return this._baseNode.getSourceFile().getLineAndCharacterOfPosition(this.start())},CallPath.prototype.endLocation=function(){return this._baseNode.getSourceFile().getLineAndCharacterOfPosition(this.end())},CallPath.prototype.end=function(){var ce=this.path[this.path.length-1]._callExpression;return ce?ce.end:this.start()},CallPath.prototype.toString=function(){return this.path.map(function(x){return x.name}).join(".")},CallPath}();Matching.CallPath=CallPath;var MemberExpressionMatcher=function(_super){function MemberExpressionMatcher(objectMatcher,propertyMatcher,tr){_super.call(this),this.objectMatcher=objectMatcher,this.propertyMatcher=propertyMatcher,this.tr=tr}return __extends(MemberExpressionMatcher,_super),MemberExpressionMatcher.prototype.match=function(node){return this.objectMatcher.doMatch(node.expression)&&this.propertyMatcher.doMatch(node.name)?this.tr(node):null},MemberExpressionMatcher.prototype.nodeType=function(){return ts.SyntaxKind.PropertyAccessExpression},MemberExpressionMatcher}(BasicMatcher);Matching.memberFromExp=memberFromExp;var CallBaseMatcher=function(){function CallBaseMatcher(rootMatcher){this.rootMatcher=rootMatcher}return CallBaseMatcher.prototype.doMatch=function(node){if(node.kind==ts.SyntaxKind.CallExpression){var call=node,res=this.doMatch(call.expression);if(res)return res.path.length>0&&null==res.path[res.path.length-1].arguments?(res.path[res.path.length-1].arguments=call.arguments,res.path[res.path.length-1]._callExpression=call,res):null}else if(node.kind==ts.SyntaxKind.PropertyAccessExpression){var me=node,v=this.doMatch(me.expression);if(v)return me.name.kind==ts.SyntaxKind.Identifier?(v.path.push(new PathNode(me.name.text,me.name)),v):null}else if(node.kind==ts.SyntaxKind.Identifier){var id=node;if(this.rootMatcher.doMatch(id))return new CallPath(id.text,id)}return null},CallBaseMatcher.prototype.nodeType=function(){return null},CallBaseMatcher}();Matching.CallBaseMatcher=CallBaseMatcher,Matching.ident=ident,Matching.anyNode=anyNode,Matching.call=call,Matching.exprStmt=exprStmt,Matching.assign=assign,Matching.varDecl=varDecl,Matching.field=field,Matching.classDeclaration=classDeclaration}(Matching=exports.Matching||(exports.Matching={}))},function(module,exports,__webpack_require__){"use strict";function resolve(p1,p2){return pth.resolve(p1,p2)}function readFileSync(p){return fs.readFileSync(p).toString()}function dirname(p){return pth.dirname(p)}function existsSync(p){return fs.existsSync(p)}var pth=__webpack_require__(15),fs=__webpack_require__(38);exports.resolve=resolve,exports.readFileSync=readFileSync,exports.dirname=dirname,exports.existsSync=existsSync},function(module,exports,__webpack_require__){module.exports=/[^\u0041-\u005A\u0061-\u007A\u00AA\u00B5\u00BA\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u0527\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u08A0\u08A2-\u08AC\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0977\u0979-\u097F\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C33\u0C35-\u0C39\u0C3D\u0C58\u0C59\u0C60\u0C61\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D60\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F4\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191C\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19C1-\u19C7\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2183\u2184\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005\u3006\u3031-\u3035\u303B\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FCC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA697\uA6A0-\uA6E5\uA717-\uA71F\uA722-\uA788\uA78B-\uA78E\uA790-\uA793\uA7A0-\uA7AA\uA7F8-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA80-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uABC0-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC\u0030-\u0039\u00B2\u00B3\u00B9\u00BC-\u00BE\u0660-\u0669\u06F0-\u06F9\u07C0-\u07C9\u0966-\u096F\u09E6-\u09EF\u09F4-\u09F9\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0B72-\u0B77\u0BE6-\u0BF2\u0C66-\u0C6F\u0C78-\u0C7E\u0CE6-\u0CEF\u0D66-\u0D75\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F33\u1040-\u1049\u1090-\u1099\u1369-\u137C\u16EE-\u16F0\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1946-\u194F\u19D0-\u19DA\u1A80-\u1A89\u1A90-\u1A99\u1B50-\u1B59\u1BB0-\u1BB9\u1C40-\u1C49\u1C50-\u1C59\u2070\u2074-\u2079\u2080-\u2089\u2150-\u2182\u2185-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2CFD\u3007\u3021-\u3029\u3038-\u303A\u3192-\u3195\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\uA620-\uA629\uA6E6-\uA6EF\uA830-\uA835\uA8D0-\uA8D9\uA900-\uA909\uA9D0-\uA9D9\uAA50-\uAA59\uABF0-\uABF9\uFF10-\uFF19]+/g;
},function(module,exports,__webpack_require__){module.exports=/([\u0061-\u007A\u00B5\u00DF-\u00F6\u00F8-\u00FF\u0101\u0103\u0105\u0107\u0109\u010B\u010D\u010F\u0111\u0113\u0115\u0117\u0119\u011B\u011D\u011F\u0121\u0123\u0125\u0127\u0129\u012B\u012D\u012F\u0131\u0133\u0135\u0137\u0138\u013A\u013C\u013E\u0140\u0142\u0144\u0146\u0148\u0149\u014B\u014D\u014F\u0151\u0153\u0155\u0157\u0159\u015B\u015D\u015F\u0161\u0163\u0165\u0167\u0169\u016B\u016D\u016F\u0171\u0173\u0175\u0177\u017A\u017C\u017E-\u0180\u0183\u0185\u0188\u018C\u018D\u0192\u0195\u0199-\u019B\u019E\u01A1\u01A3\u01A5\u01A8\u01AA\u01AB\u01AD\u01B0\u01B4\u01B6\u01B9\u01BA\u01BD-\u01BF\u01C6\u01C9\u01CC\u01CE\u01D0\u01D2\u01D4\u01D6\u01D8\u01DA\u01DC\u01DD\u01DF\u01E1\u01E3\u01E5\u01E7\u01E9\u01EB\u01ED\u01EF\u01F0\u01F3\u01F5\u01F9\u01FB\u01FD\u01FF\u0201\u0203\u0205\u0207\u0209\u020B\u020D\u020F\u0211\u0213\u0215\u0217\u0219\u021B\u021D\u021F\u0221\u0223\u0225\u0227\u0229\u022B\u022D\u022F\u0231\u0233-\u0239\u023C\u023F\u0240\u0242\u0247\u0249\u024B\u024D\u024F-\u0293\u0295-\u02AF\u0371\u0373\u0377\u037B-\u037D\u0390\u03AC-\u03CE\u03D0\u03D1\u03D5-\u03D7\u03D9\u03DB\u03DD\u03DF\u03E1\u03E3\u03E5\u03E7\u03E9\u03EB\u03ED\u03EF-\u03F3\u03F5\u03F8\u03FB\u03FC\u0430-\u045F\u0461\u0463\u0465\u0467\u0469\u046B\u046D\u046F\u0471\u0473\u0475\u0477\u0479\u047B\u047D\u047F\u0481\u048B\u048D\u048F\u0491\u0493\u0495\u0497\u0499\u049B\u049D\u049F\u04A1\u04A3\u04A5\u04A7\u04A9\u04AB\u04AD\u04AF\u04B1\u04B3\u04B5\u04B7\u04B9\u04BB\u04BD\u04BF\u04C2\u04C4\u04C6\u04C8\u04CA\u04CC\u04CE\u04CF\u04D1\u04D3\u04D5\u04D7\u04D9\u04DB\u04DD\u04DF\u04E1\u04E3\u04E5\u04E7\u04E9\u04EB\u04ED\u04EF\u04F1\u04F3\u04F5\u04F7\u04F9\u04FB\u04FD\u04FF\u0501\u0503\u0505\u0507\u0509\u050B\u050D\u050F\u0511\u0513\u0515\u0517\u0519\u051B\u051D\u051F\u0521\u0523\u0525\u0527\u0561-\u0587\u1D00-\u1D2B\u1D6B-\u1D77\u1D79-\u1D9A\u1E01\u1E03\u1E05\u1E07\u1E09\u1E0B\u1E0D\u1E0F\u1E11\u1E13\u1E15\u1E17\u1E19\u1E1B\u1E1D\u1E1F\u1E21\u1E23\u1E25\u1E27\u1E29\u1E2B\u1E2D\u1E2F\u1E31\u1E33\u1E35\u1E37\u1E39\u1E3B\u1E3D\u1E3F\u1E41\u1E43\u1E45\u1E47\u1E49\u1E4B\u1E4D\u1E4F\u1E51\u1E53\u1E55\u1E57\u1E59\u1E5B\u1E5D\u1E5F\u1E61\u1E63\u1E65\u1E67\u1E69\u1E6B\u1E6D\u1E6F\u1E71\u1E73\u1E75\u1E77\u1E79\u1E7B\u1E7D\u1E7F\u1E81\u1E83\u1E85\u1E87\u1E89\u1E8B\u1E8D\u1E8F\u1E91\u1E93\u1E95-\u1E9D\u1E9F\u1EA1\u1EA3\u1EA5\u1EA7\u1EA9\u1EAB\u1EAD\u1EAF\u1EB1\u1EB3\u1EB5\u1EB7\u1EB9\u1EBB\u1EBD\u1EBF\u1EC1\u1EC3\u1EC5\u1EC7\u1EC9\u1ECB\u1ECD\u1ECF\u1ED1\u1ED3\u1ED5\u1ED7\u1ED9\u1EDB\u1EDD\u1EDF\u1EE1\u1EE3\u1EE5\u1EE7\u1EE9\u1EEB\u1EED\u1EEF\u1EF1\u1EF3\u1EF5\u1EF7\u1EF9\u1EFB\u1EFD\u1EFF-\u1F07\u1F10-\u1F15\u1F20-\u1F27\u1F30-\u1F37\u1F40-\u1F45\u1F50-\u1F57\u1F60-\u1F67\u1F70-\u1F7D\u1F80-\u1F87\u1F90-\u1F97\u1FA0-\u1FA7\u1FB0-\u1FB4\u1FB6\u1FB7\u1FBE\u1FC2-\u1FC4\u1FC6\u1FC7\u1FD0-\u1FD3\u1FD6\u1FD7\u1FE0-\u1FE7\u1FF2-\u1FF4\u1FF6\u1FF7\u210A\u210E\u210F\u2113\u212F\u2134\u2139\u213C\u213D\u2146-\u2149\u214E\u2184\u2C30-\u2C5E\u2C61\u2C65\u2C66\u2C68\u2C6A\u2C6C\u2C71\u2C73\u2C74\u2C76-\u2C7B\u2C81\u2C83\u2C85\u2C87\u2C89\u2C8B\u2C8D\u2C8F\u2C91\u2C93\u2C95\u2C97\u2C99\u2C9B\u2C9D\u2C9F\u2CA1\u2CA3\u2CA5\u2CA7\u2CA9\u2CAB\u2CAD\u2CAF\u2CB1\u2CB3\u2CB5\u2CB7\u2CB9\u2CBB\u2CBD\u2CBF\u2CC1\u2CC3\u2CC5\u2CC7\u2CC9\u2CCB\u2CCD\u2CCF\u2CD1\u2CD3\u2CD5\u2CD7\u2CD9\u2CDB\u2CDD\u2CDF\u2CE1\u2CE3\u2CE4\u2CEC\u2CEE\u2CF3\u2D00-\u2D25\u2D27\u2D2D\uA641\uA643\uA645\uA647\uA649\uA64B\uA64D\uA64F\uA651\uA653\uA655\uA657\uA659\uA65B\uA65D\uA65F\uA661\uA663\uA665\uA667\uA669\uA66B\uA66D\uA681\uA683\uA685\uA687\uA689\uA68B\uA68D\uA68F\uA691\uA693\uA695\uA697\uA723\uA725\uA727\uA729\uA72B\uA72D\uA72F-\uA731\uA733\uA735\uA737\uA739\uA73B\uA73D\uA73F\uA741\uA743\uA745\uA747\uA749\uA74B\uA74D\uA74F\uA751\uA753\uA755\uA757\uA759\uA75B\uA75D\uA75F\uA761\uA763\uA765\uA767\uA769\uA76B\uA76D\uA76F\uA771-\uA778\uA77A\uA77C\uA77F\uA781\uA783\uA785\uA787\uA78C\uA78E\uA791\uA793\uA7A1\uA7A3\uA7A5\uA7A7\uA7A9\uA7FA\uFB00-\uFB06\uFB13-\uFB17\uFF41-\uFF5A])([\u0041-\u005A\u00C0-\u00D6\u00D8-\u00DE\u0100\u0102\u0104\u0106\u0108\u010A\u010C\u010E\u0110\u0112\u0114\u0116\u0118\u011A\u011C\u011E\u0120\u0122\u0124\u0126\u0128\u012A\u012C\u012E\u0130\u0132\u0134\u0136\u0139\u013B\u013D\u013F\u0141\u0143\u0145\u0147\u014A\u014C\u014E\u0150\u0152\u0154\u0156\u0158\u015A\u015C\u015E\u0160\u0162\u0164\u0166\u0168\u016A\u016C\u016E\u0170\u0172\u0174\u0176\u0178\u0179\u017B\u017D\u0181\u0182\u0184\u0186\u0187\u0189-\u018B\u018E-\u0191\u0193\u0194\u0196-\u0198\u019C\u019D\u019F\u01A0\u01A2\u01A4\u01A6\u01A7\u01A9\u01AC\u01AE\u01AF\u01B1-\u01B3\u01B5\u01B7\u01B8\u01BC\u01C4\u01C7\u01CA\u01CD\u01CF\u01D1\u01D3\u01D5\u01D7\u01D9\u01DB\u01DE\u01E0\u01E2\u01E4\u01E6\u01E8\u01EA\u01EC\u01EE\u01F1\u01F4\u01F6-\u01F8\u01FA\u01FC\u01FE\u0200\u0202\u0204\u0206\u0208\u020A\u020C\u020E\u0210\u0212\u0214\u0216\u0218\u021A\u021C\u021E\u0220\u0222\u0224\u0226\u0228\u022A\u022C\u022E\u0230\u0232\u023A\u023B\u023D\u023E\u0241\u0243-\u0246\u0248\u024A\u024C\u024E\u0370\u0372\u0376\u0386\u0388-\u038A\u038C\u038E\u038F\u0391-\u03A1\u03A3-\u03AB\u03CF\u03D2-\u03D4\u03D8\u03DA\u03DC\u03DE\u03E0\u03E2\u03E4\u03E6\u03E8\u03EA\u03EC\u03EE\u03F4\u03F7\u03F9\u03FA\u03FD-\u042F\u0460\u0462\u0464\u0466\u0468\u046A\u046C\u046E\u0470\u0472\u0474\u0476\u0478\u047A\u047C\u047E\u0480\u048A\u048C\u048E\u0490\u0492\u0494\u0496\u0498\u049A\u049C\u049E\u04A0\u04A2\u04A4\u04A6\u04A8\u04AA\u04AC\u04AE\u04B0\u04B2\u04B4\u04B6\u04B8\u04BA\u04BC\u04BE\u04C0\u04C1\u04C3\u04C5\u04C7\u04C9\u04CB\u04CD\u04D0\u04D2\u04D4\u04D6\u04D8\u04DA\u04DC\u04DE\u04E0\u04E2\u04E4\u04E6\u04E8\u04EA\u04EC\u04EE\u04F0\u04F2\u04F4\u04F6\u04F8\u04FA\u04FC\u04FE\u0500\u0502\u0504\u0506\u0508\u050A\u050C\u050E\u0510\u0512\u0514\u0516\u0518\u051A\u051C\u051E\u0520\u0522\u0524\u0526\u0531-\u0556\u10A0-\u10C5\u10C7\u10CD\u1E00\u1E02\u1E04\u1E06\u1E08\u1E0A\u1E0C\u1E0E\u1E10\u1E12\u1E14\u1E16\u1E18\u1E1A\u1E1C\u1E1E\u1E20\u1E22\u1E24\u1E26\u1E28\u1E2A\u1E2C\u1E2E\u1E30\u1E32\u1E34\u1E36\u1E38\u1E3A\u1E3C\u1E3E\u1E40\u1E42\u1E44\u1E46\u1E48\u1E4A\u1E4C\u1E4E\u1E50\u1E52\u1E54\u1E56\u1E58\u1E5A\u1E5C\u1E5E\u1E60\u1E62\u1E64\u1E66\u1E68\u1E6A\u1E6C\u1E6E\u1E70\u1E72\u1E74\u1E76\u1E78\u1E7A\u1E7C\u1E7E\u1E80\u1E82\u1E84\u1E86\u1E88\u1E8A\u1E8C\u1E8E\u1E90\u1E92\u1E94\u1E9E\u1EA0\u1EA2\u1EA4\u1EA6\u1EA8\u1EAA\u1EAC\u1EAE\u1EB0\u1EB2\u1EB4\u1EB6\u1EB8\u1EBA\u1EBC\u1EBE\u1EC0\u1EC2\u1EC4\u1EC6\u1EC8\u1ECA\u1ECC\u1ECE\u1ED0\u1ED2\u1ED4\u1ED6\u1ED8\u1EDA\u1EDC\u1EDE\u1EE0\u1EE2\u1EE4\u1EE6\u1EE8\u1EEA\u1EEC\u1EEE\u1EF0\u1EF2\u1EF4\u1EF6\u1EF8\u1EFA\u1EFC\u1EFE\u1F08-\u1F0F\u1F18-\u1F1D\u1F28-\u1F2F\u1F38-\u1F3F\u1F48-\u1F4D\u1F59\u1F5B\u1F5D\u1F5F\u1F68-\u1F6F\u1FB8-\u1FBB\u1FC8-\u1FCB\u1FD8-\u1FDB\u1FE8-\u1FEC\u1FF8-\u1FFB\u2102\u2107\u210B-\u210D\u2110-\u2112\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u2130-\u2133\u213E\u213F\u2145\u2183\u2C00-\u2C2E\u2C60\u2C62-\u2C64\u2C67\u2C69\u2C6B\u2C6D-\u2C70\u2C72\u2C75\u2C7E-\u2C80\u2C82\u2C84\u2C86\u2C88\u2C8A\u2C8C\u2C8E\u2C90\u2C92\u2C94\u2C96\u2C98\u2C9A\u2C9C\u2C9E\u2CA0\u2CA2\u2CA4\u2CA6\u2CA8\u2CAA\u2CAC\u2CAE\u2CB0\u2CB2\u2CB4\u2CB6\u2CB8\u2CBA\u2CBC\u2CBE\u2CC0\u2CC2\u2CC4\u2CC6\u2CC8\u2CCA\u2CCC\u2CCE\u2CD0\u2CD2\u2CD4\u2CD6\u2CD8\u2CDA\u2CDC\u2CDE\u2CE0\u2CE2\u2CEB\u2CED\u2CF2\uA640\uA642\uA644\uA646\uA648\uA64A\uA64C\uA64E\uA650\uA652\uA654\uA656\uA658\uA65A\uA65C\uA65E\uA660\uA662\uA664\uA666\uA668\uA66A\uA66C\uA680\uA682\uA684\uA686\uA688\uA68A\uA68C\uA68E\uA690\uA692\uA694\uA696\uA722\uA724\uA726\uA728\uA72A\uA72C\uA72E\uA732\uA734\uA736\uA738\uA73A\uA73C\uA73E\uA740\uA742\uA744\uA746\uA748\uA74A\uA74C\uA74E\uA750\uA752\uA754\uA756\uA758\uA75A\uA75C\uA75E\uA760\uA762\uA764\uA766\uA768\uA76A\uA76C\uA76E\uA779\uA77B\uA77D\uA77E\uA780\uA782\uA784\uA786\uA78B\uA78D\uA790\uA792\uA7A0\uA7A2\uA7A4\uA7A6\uA7A8\uA7AA\uFF21-\uFF3A\u0030-\u0039\u00B2\u00B3\u00B9\u00BC-\u00BE\u0660-\u0669\u06F0-\u06F9\u07C0-\u07C9\u0966-\u096F\u09E6-\u09EF\u09F4-\u09F9\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0B72-\u0B77\u0BE6-\u0BF2\u0C66-\u0C6F\u0C78-\u0C7E\u0CE6-\u0CEF\u0D66-\u0D75\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F33\u1040-\u1049\u1090-\u1099\u1369-\u137C\u16EE-\u16F0\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1946-\u194F\u19D0-\u19DA\u1A80-\u1A89\u1A90-\u1A99\u1B50-\u1B59\u1BB0-\u1BB9\u1C40-\u1C49\u1C50-\u1C59\u2070\u2074-\u2079\u2080-\u2089\u2150-\u2182\u2185-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2CFD\u3007\u3021-\u3029\u3038-\u303A\u3192-\u3195\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\uA620-\uA629\uA6E6-\uA6EF\uA830-\uA835\uA8D0-\uA8D9\uA900-\uA909\uA9D0-\uA9D9\uAA50-\uAA59\uABF0-\uABF9\uFF10-\uFF19])/g},function(module,exports,__webpack_require__){module.exports=/([\u0030-\u0039\u00B2\u00B3\u00B9\u00BC-\u00BE\u0660-\u0669\u06F0-\u06F9\u07C0-\u07C9\u0966-\u096F\u09E6-\u09EF\u09F4-\u09F9\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0B72-\u0B77\u0BE6-\u0BF2\u0C66-\u0C6F\u0C78-\u0C7E\u0CE6-\u0CEF\u0D66-\u0D75\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F33\u1040-\u1049\u1090-\u1099\u1369-\u137C\u16EE-\u16F0\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1946-\u194F\u19D0-\u19DA\u1A80-\u1A89\u1A90-\u1A99\u1B50-\u1B59\u1BB0-\u1BB9\u1C40-\u1C49\u1C50-\u1C59\u2070\u2074-\u2079\u2080-\u2089\u2150-\u2182\u2185-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2CFD\u3007\u3021-\u3029\u3038-\u303A\u3192-\u3195\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\uA620-\uA629\uA6E6-\uA6EF\uA830-\uA835\uA8D0-\uA8D9\uA900-\uA909\uA9D0-\uA9D9\uAA50-\uAA59\uABF0-\uABF9\uFF10-\uFF19])([^\u0030-\u0039\u00B2\u00B3\u00B9\u00BC-\u00BE\u0660-\u0669\u06F0-\u06F9\u07C0-\u07C9\u0966-\u096F\u09E6-\u09EF\u09F4-\u09F9\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0B72-\u0B77\u0BE6-\u0BF2\u0C66-\u0C6F\u0C78-\u0C7E\u0CE6-\u0CEF\u0D66-\u0D75\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F33\u1040-\u1049\u1090-\u1099\u1369-\u137C\u16EE-\u16F0\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1946-\u194F\u19D0-\u19DA\u1A80-\u1A89\u1A90-\u1A99\u1B50-\u1B59\u1BB0-\u1BB9\u1C40-\u1C49\u1C50-\u1C59\u2070\u2074-\u2079\u2080-\u2089\u2150-\u2182\u2185-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2CFD\u3007\u3021-\u3029\u3038-\u303A\u3192-\u3195\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\uA620-\uA629\uA6E6-\uA6EF\uA830-\uA835\uA8D0-\uA8D9\uA900-\uA909\uA9D0-\uA9D9\uAA50-\uAA59\uABF0-\uABF9\uFF10-\uFF19])/g},function(module,exports,__webpack_require__){"use strict";function resolveYamlTimestamp(data){if(null===data)return!1;var match;return match=YAML_TIMESTAMP_REGEXP.exec(data),null===match?!1:!0}function constructYamlTimestamp(data){var match,year,month,day,hour,minute,second,tz_hour,tz_minute,date,fraction=0,delta=null;if(match=YAML_TIMESTAMP_REGEXP.exec(data),null===match)throw new Error("Date resolve error");if(year=+match[1],month=+match[2]-1,day=+match[3],!match[4])return new Date(Date.UTC(year,month,day));if(hour=+match[4],minute=+match[5],second=+match[6],match[7]){for(fraction=match[7].slice(0,3);fraction.length<3;)fraction+="0";fraction=+fraction}return match[9]&&(tz_hour=+match[10],tz_minute=+(match[11]||0),delta=6e4*(60*tz_hour+tz_minute),"-"===match[9]&&(delta=-delta)),date=new Date(Date.UTC(year,month,day,hour,minute,second,fraction)),delta&&date.setTime(date.getTime()-delta),date}function representYamlTimestamp(object){return object.toISOString()}var Type=__webpack_require__(187),YAML_TIMESTAMP_REGEXP=new RegExp("^([0-9][0-9][0-9][0-9])-([0-9][0-9]?)-([0-9][0-9]?)(?:(?:[Tt]|[ \\t]+)([0-9][0-9]?):([0-9][0-9]):([0-9][0-9])(?:\\.([0-9]*))?(?:[ \\t]*(Z|([-+])([0-9][0-9]?)(?::([0-9][0-9]))?))?)?$");module.exports=new Type("tag:yaml.org,2002:timestamp",{kind:"scalar",resolve:resolveYamlTimestamp,construct:constructYamlTimestamp,instanceOf:Date,represent:representYamlTimestamp})},function(module,exports,__webpack_require__){"use strict";function resolveYamlMerge(data){return"<<"===data||null===data}var Type=__webpack_require__(187);module.exports=new Type("tag:yaml.org,2002:merge",{kind:"scalar",resolve:resolveYamlMerge})},function(module,exports,__webpack_require__){"use strict";function resolveYamlBinary(data){if(null===data)return!1;var code,idx,bitlen=0,max=data.length,map=BASE64_MAP;for(idx=0;max>idx;idx++)if(code=map.indexOf(data.charAt(idx)),!(code>64)){if(0>code)return!1;bitlen+=6}return bitlen%8===0}function constructYamlBinary(data){var idx,tailbits,input=data.replace(/[\r\n=]/g,""),max=input.length,map=BASE64_MAP,bits=0,result=[];for(idx=0;max>idx;idx++)idx%4===0&&idx&&(result.push(bits>>16&255),result.push(bits>>8&255),result.push(255&bits)),bits=bits<<6|map.indexOf(input.charAt(idx));return tailbits=max%4*6,0===tailbits?(result.push(bits>>16&255),result.push(bits>>8&255),result.push(255&bits)):18===tailbits?(result.push(bits>>10&255),result.push(bits>>2&255)):12===tailbits&&result.push(bits>>4&255),NodeBuffer?new NodeBuffer(result):result}function representYamlBinary(object){var idx,tail,result="",bits=0,max=object.length,map=BASE64_MAP;for(idx=0;max>idx;idx++)idx%3===0&&idx&&(result+=map[bits>>18&63],result+=map[bits>>12&63],result+=map[bits>>6&63],result+=map[63&bits]),bits=(bits<<8)+object[idx];return tail=max%3,0===tail?(result+=map[bits>>18&63],result+=map[bits>>12&63],result+=map[bits>>6&63],result+=map[63&bits]):2===tail?(result+=map[bits>>10&63],result+=map[bits>>4&63],result+=map[bits<<2&63],result+=map[64]):1===tail&&(result+=map[bits>>2&63],result+=map[bits<<4&63],result+=map[64],result+=map[64]),result}function isBinary(object){return NodeBuffer&&NodeBuffer.isBuffer(object)}var NodeBuffer=__webpack_require__(92).Buffer,Type=__webpack_require__(187),BASE64_MAP="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=\n\r";module.exports=new Type("tag:yaml.org,2002:binary",{kind:"scalar",resolve:resolveYamlBinary,construct:constructYamlBinary,predicate:isBinary,represent:representYamlBinary})},function(module,exports,__webpack_require__){"use strict";function resolveYamlOmap(data){if(null===data)return!0;var index,length,pair,pairKey,pairHasKey,objectKeys=[],object=data;for(index=0,length=object.length;length>index;index+=1){if(pair=object[index],pairHasKey=!1,"[object Object]"!==_toString.call(pair))return!1;for(pairKey in pair)if(_hasOwnProperty.call(pair,pairKey)){if(pairHasKey)return!1;pairHasKey=!0}if(!pairHasKey)return!1;if(-1!==objectKeys.indexOf(pairKey))return!1;objectKeys.push(pairKey)}return!0}function constructYamlOmap(data){return null!==data?data:[]}var Type=__webpack_require__(187),_hasOwnProperty=Object.prototype.hasOwnProperty,_toString=Object.prototype.toString;module.exports=new Type("tag:yaml.org,2002:omap",{kind:"sequence",resolve:resolveYamlOmap,construct:constructYamlOmap})},function(module,exports,__webpack_require__){"use strict";function resolveYamlPairs(data){if(null===data)return!0;var index,length,pair,keys,result,object=data;for(result=new Array(object.length),index=0,length=object.length;length>index;index+=1){if(pair=object[index],"[object Object]"!==_toString.call(pair))return!1;if(keys=Object.keys(pair),1!==keys.length)return!1;result[index]=[keys[0],pair[keys[0]]]}return!0}function constructYamlPairs(data){if(null===data)return[];var index,length,pair,keys,result,object=data;for(result=new Array(object.length),index=0,length=object.length;length>index;index+=1)pair=object[index],keys=Object.keys(pair),result[index]=[keys[0],pair[keys[0]]];return result}var Type=__webpack_require__(187),_toString=Object.prototype.toString;module.exports=new Type("tag:yaml.org,2002:pairs",{kind:"sequence",resolve:resolveYamlPairs,construct:constructYamlPairs})},function(module,exports,__webpack_require__){"use strict";function resolveYamlSet(data){if(null===data)return!0;var key,object=data;for(key in object)if(_hasOwnProperty.call(object,key)&&null!==object[key])return!1;return!0}function constructYamlSet(data){return null!==data?data:{}}var Type=__webpack_require__(187),_hasOwnProperty=Object.prototype.hasOwnProperty;module.exports=new Type("tag:yaml.org,2002:set",{kind:"mapping",resolve:resolveYamlSet,construct:constructYamlSet})},function(module,exports,__webpack_require__){"use strict";function resolveJavascriptUndefined(){return!0}function constructJavascriptUndefined(){return void 0}function representJavascriptUndefined(){return""}function isUndefined(object){return"undefined"==typeof object}var Type=__webpack_require__(187);module.exports=new Type("tag:yaml.org,2002:js/undefined",{kind:"scalar",resolve:resolveJavascriptUndefined,construct:constructJavascriptUndefined,predicate:isUndefined,represent:representJavascriptUndefined})},function(module,exports,__webpack_require__){"use strict";function resolveJavascriptRegExp(data){if(null===data)return!1;if(0===data.length)return!1;var regexp=data,tail=/\/([gim]*)$/.exec(data),modifiers="";if("/"===regexp[0]){if(tail&&(modifiers=tail[1]),modifiers.length>3)return!1;if("/"!==regexp[regexp.length-modifiers.length-1])return!1;regexp=regexp.slice(1,regexp.length-modifiers.length-1)}try{new RegExp(regexp,modifiers);return!0}catch(error){return!1}}function constructJavascriptRegExp(data){var regexp=data,tail=/\/([gim]*)$/.exec(data),modifiers="";return"/"===regexp[0]&&(tail&&(modifiers=tail[1]),regexp=regexp.slice(1,regexp.length-modifiers.length-1)),new RegExp(regexp,modifiers)}function representJavascriptRegExp(object){var result="/"+object.source+"/";return object.global&&(result+="g"),object.multiline&&(result+="m"),object.ignoreCase&&(result+="i"),result}function isRegExp(object){return"[object RegExp]"===Object.prototype.toString.call(object)}var Type=__webpack_require__(187);module.exports=new Type("tag:yaml.org,2002:js/regexp",{kind:"scalar",resolve:resolveJavascriptRegExp,construct:constructJavascriptRegExp,predicate:isRegExp,represent:representJavascriptRegExp})},function(module,exports,__webpack_require__){"use strict";var Stringify=__webpack_require__(195),Parse=__webpack_require__(196);module.exports={stringify:Stringify,parse:Parse}},function(module,exports,__webpack_require__){if("undefined"==typeof __WEBPACK_EXTERNAL_MODULE_171__){var e=new Error('Cannot find module "RAML.XmlValidation"');throw e.code="MODULE_NOT_FOUND",e}module.exports=__WEBPACK_EXTERNAL_MODULE_171__},function(module,exports,__webpack_require__){if("undefined"==typeof __WEBPACK_EXTERNAL_MODULE_172__){var e=new Error('Cannot find module "RAML.JsonValidation"');throw e.code="MODULE_NOT_FOUND",e}module.exports=__WEBPACK_EXTERNAL_MODULE_172__},function(module,exports,__webpack_require__){exports.read=function(buffer,offset,isLE,mLen,nBytes){var e,m,eLen=8*nBytes-mLen-1,eMax=(1<<eLen)-1,eBias=eMax>>1,nBits=-7,i=isLE?nBytes-1:0,d=isLE?-1:1,s=buffer[offset+i];for(i+=d,e=s&(1<<-nBits)-1,s>>=-nBits,nBits+=eLen;nBits>0;e=256*e+buffer[offset+i],i+=d,nBits-=8);for(m=e&(1<<-nBits)-1,e>>=-nBits,nBits+=mLen;nBits>0;m=256*m+buffer[offset+i],i+=d,nBits-=8);if(0===e)e=1-eBias;else{if(e===eMax)return m?NaN:(s?-1:1)*(1/0);m+=Math.pow(2,mLen),e-=eBias}return(s?-1:1)*m*Math.pow(2,e-mLen)},exports.write=function(buffer,value,offset,isLE,mLen,nBytes){var e,m,c,eLen=8*nBytes-mLen-1,eMax=(1<<eLen)-1,eBias=eMax>>1,rt=23===mLen?Math.pow(2,-24)-Math.pow(2,-77):0,i=isLE?0:nBytes-1,d=isLE?1:-1,s=0>value||0===value&&0>1/value?1:0;for(value=Math.abs(value),isNaN(value)||value===1/0?(m=isNaN(value)?1:0,e=eMax):(e=Math.floor(Math.log(value)/Math.LN2),value*(c=Math.pow(2,-e))<1&&(e--,c*=2),value+=e+eBias>=1?rt/c:rt*Math.pow(2,1-eBias),value*c>=2&&(e++,c/=2),e+eBias>=eMax?(m=0,e=eMax):e+eBias>=1?(m=(value*c-1)*Math.pow(2,mLen),e+=eBias):(m=value*Math.pow(2,eBias-1)*Math.pow(2,mLen),e=0));mLen>=8;buffer[offset+i]=255&m,i+=d,m/=256,mLen-=8);for(e=e<<mLen|m,eLen+=mLen;eLen>0;buffer[offset+i]=255&e,i+=d,e/=256,eLen-=8);buffer[offset+i-d]|=128*s}},function(module,exports,__webpack_require__){var toString={}.toString;module.exports=Array.isArray||function(arr){return"[object Array]"==toString.call(arr)}},function(module,exports,__webpack_require__){"use strict";var parser=function(){function peg$subclass(child,parent){function ctor(){this.constructor=child}ctor.prototype=parent.prototype,child.prototype=new ctor}function peg$SyntaxError(message,expected,found,location){this.message=message,this.expected=expected,this.found=found,this.location=location,this.name="SyntaxError","function"==typeof Error.captureStackTrace&&Error.captureStackTrace(this,peg$SyntaxError)}function peg$parse(input){function peg$computePosDetails(pos){var p,ch,details=peg$posDetailsCache[pos];if(details)return details;for(p=pos-1;!peg$posDetailsCache[p];)p--;for(details=peg$posDetailsCache[p],details={line:details.line,column:details.column,seenCR:details.seenCR};pos>p;)ch=input.charAt(p),"\n"===ch?(details.seenCR||details.line++,details.column=1,details.seenCR=!1):"\r"===ch||"\u2028"===ch||"\u2029"===ch?(details.line++,details.column=1,details.seenCR=!0):(details.column++,details.seenCR=!1),p++;return peg$posDetailsCache[pos]=details,details}function peg$computeLocation(startPos,endPos){var startPosDetails=peg$computePosDetails(startPos),endPosDetails=peg$computePosDetails(endPos);return{start:{offset:startPos,line:startPosDetails.line,column:startPosDetails.column},end:{offset:endPos,line:endPosDetails.line,column:endPosDetails.column}}}function peg$fail(expected){peg$maxFailPos>peg$currPos||(peg$currPos>peg$maxFailPos&&(peg$maxFailPos=peg$currPos,peg$maxFailExpected=[]),peg$maxFailExpected.push(expected))}function peg$buildException(message,expected,found,location){function cleanupExpected(expected){var i=1;for(expected.sort(function(a,b){return a.description<b.description?-1:a.description>b.description?1:0});i<expected.length;)expected[i-1]===expected[i]?expected.splice(i,1):i++}function buildMessage(expected,found){function stringEscape(s){function hex(ch){return ch.charCodeAt(0).toString(16).toUpperCase()}return s.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/\x08/g,"\\b").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\f/g,"\\f").replace(/\r/g,"\\r").replace(/[\x00-\x07\x0B\x0E\x0F]/g,function(ch){return"\\x0"+hex(ch)}).replace(/[\x10-\x1F\x80-\xFF]/g,function(ch){return"\\x"+hex(ch)}).replace(/[\u0100-\u0FFF]/g,function(ch){return"\\u0"+hex(ch)}).replace(/[\u1000-\uFFFF]/g,function(ch){return"\\u"+hex(ch)})}var expectedDesc,foundDesc,i,expectedDescs=new Array(expected.length);for(i=0;i<expected.length;i++)expectedDescs[i]=expected[i].description;return expectedDesc=expected.length>1?expectedDescs.slice(0,-1).join(", ")+" or "+expectedDescs[expected.length-1]:expectedDescs[0],foundDesc=found?'"'+stringEscape(found)+'"':"end of input","Expected "+expectedDesc+" but "+foundDesc+" found."}return null!==expected&&cleanupExpected(expected),new peg$SyntaxError(null!==message?message:buildMessage(expected,found),expected,found,location)}function peg$parseTerm(){var s0,s1,s2,s3,s4,s5,s6,s7;return s0=peg$currPos,s1=peg$parse_(),s1!==peg$FAILED?(s2=peg$parseFactor(),s2!==peg$FAILED?(s3=peg$currPos,s4=peg$parse_(),s4!==peg$FAILED?(124===input.charCodeAt(peg$currPos)?(s5=peg$c0,peg$currPos++):(s5=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c1)),s5!==peg$FAILED?(s6=peg$parse_(),s6!==peg$FAILED?(s7=peg$parseTerm(),s7!==peg$FAILED?(s4=[s4,s5,s6,s7],s3=s4):(peg$currPos=s3,s3=peg$FAILED)):(peg$currPos=s3,s3=peg$FAILED)):(peg$currPos=s3,s3=peg$FAILED)):(peg$currPos=s3,s3=peg$FAILED),s3===peg$FAILED&&(s3=null),s3!==peg$FAILED?(peg$savedPos=s0,s1=peg$c2(s2,s3),s0=s1):(peg$currPos=s0,s0=peg$FAILED)):(peg$currPos=s0,s0=peg$FAILED)):(peg$currPos=s0,s0=peg$FAILED),s0}function peg$parseFactor(){var s0,s1,s2,s3,s4,s5,s6,s7,s8,s9;if(s0=peg$currPos,40===input.charCodeAt(peg$currPos)?(s1=peg$c3,peg$currPos++):(s1=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c4)),s1!==peg$FAILED)if(s2=peg$parse_(),s2!==peg$FAILED)if(s3=peg$parseTerm(),s3!==peg$FAILED)if(s4=peg$parse_(),s4!==peg$FAILED)if(41===input.charCodeAt(peg$currPos)?(s5=peg$c5,peg$currPos++):(s5=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c6)),s5!==peg$FAILED){for(s6=[],s7=peg$currPos,s8=peg$parse_(),s8!==peg$FAILED?(input.substr(peg$currPos,2)===peg$c7?(s9=peg$c7,peg$currPos+=2):(s9=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c8)),s9!==peg$FAILED?(s8=[s8,s9],s7=s8):(peg$currPos=s7,s7=peg$FAILED)):(peg$currPos=s7,s7=peg$FAILED);s7!==peg$FAILED;)s6.push(s7),s7=peg$currPos,s8=peg$parse_(),s8!==peg$FAILED?(input.substr(peg$currPos,2)===peg$c7?(s9=peg$c7,peg$currPos+=2):(s9=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c8)),s9!==peg$FAILED?(s8=[s8,s9],s7=s8):(peg$currPos=s7,s7=peg$FAILED)):(peg$currPos=s7,s7=peg$FAILED);s6!==peg$FAILED?(peg$savedPos=s0,s1=peg$c9(s3,s6),s0=s1):(peg$currPos=s0,s0=peg$FAILED)}else peg$currPos=s0,s0=peg$FAILED;else peg$currPos=s0,s0=peg$FAILED;else peg$currPos=s0,s0=peg$FAILED;else peg$currPos=s0,s0=peg$FAILED;else peg$currPos=s0,s0=peg$FAILED;return s0===peg$FAILED&&(s0=peg$parseLiteral()),s0}function peg$parseLiteral(){var s0,s1,s2,s3,s4,s5;if(peg$silentFails++,s0=peg$currPos,s1=[],s2=peg$parsechar(),s2!==peg$FAILED)for(;s2!==peg$FAILED;)s1.push(s2),s2=peg$parsechar();else s1=peg$FAILED;if(s1!==peg$FAILED){for(s2=[],s3=peg$currPos,s4=peg$parse_(),s4!==peg$FAILED?(input.substr(peg$currPos,2)===peg$c7?(s5=peg$c7,peg$currPos+=2):(s5=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c8)),s5!==peg$FAILED?(s4=[s4,s5],s3=s4):(peg$currPos=s3,s3=peg$FAILED)):(peg$currPos=s3,s3=peg$FAILED);s3!==peg$FAILED;)s2.push(s3),s3=peg$currPos,s4=peg$parse_(),s4!==peg$FAILED?(input.substr(peg$currPos,2)===peg$c7?(s5=peg$c7,peg$currPos+=2):(s5=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c8)),s5!==peg$FAILED?(s4=[s4,s5],s3=s4):(peg$currPos=s3,s3=peg$FAILED)):(peg$currPos=s3,s3=peg$FAILED);s2!==peg$FAILED?(peg$savedPos=s0,s1=peg$c19(s1,s2),s0=s1):(peg$currPos=s0,s0=peg$FAILED)}else peg$currPos=s0,s0=peg$FAILED;return peg$silentFails--,s0===peg$FAILED&&(s1=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c18)),s0}function peg$parse_(){var s0,s1;for(peg$silentFails++,s0=[],peg$c21.test(input.charAt(peg$currPos))?(s1=input.charAt(peg$currPos),peg$currPos++):(s1=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c22));s1!==peg$FAILED;)s0.push(s1),peg$c21.test(input.charAt(peg$currPos))?(s1=input.charAt(peg$currPos),peg$currPos++):(s1=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c22));return peg$silentFails--,s0===peg$FAILED&&(s1=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c20)),s0}function peg$parsechar(){var s0;return peg$c23.test(input.charAt(peg$currPos))?(s0=input.charAt(peg$currPos),peg$currPos++):(s0=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c24)),s0===peg$FAILED&&(95===input.charCodeAt(peg$currPos)?(s0=peg$c25,peg$currPos++):(s0=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c26)),s0===peg$FAILED&&(45===input.charCodeAt(peg$currPos)?(s0=peg$c27,peg$currPos++):(s0=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c28)),s0===peg$FAILED&&(46===input.charCodeAt(peg$currPos)?(s0=peg$c29,peg$currPos++):(s0=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c30)),s0===peg$FAILED&&(peg$c31.test(input.charAt(peg$currPos))?(s0=input.charAt(peg$currPos),peg$currPos++):(s0=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c32)),s0===peg$FAILED&&(peg$c33.test(input.charAt(peg$currPos))?(s0=input.charAt(peg$currPos),peg$currPos++):(s0=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c34)),s0===peg$FAILED&&(63===input.charCodeAt(peg$currPos)?(s0=peg$c35,peg$currPos++):(s0=peg$FAILED,0===peg$silentFails&&peg$fail(peg$c36)))))))),s0}var peg$result,options=arguments.length>1?arguments[1]:{},peg$FAILED={},peg$startRuleFunctions={Term:peg$parseTerm},peg$startRuleFunction=peg$parseTerm,peg$c0="|",peg$c1={type:"literal",value:"|",description:'"|"'},peg$c2=function(first,rest){return rest?{type:"union",first:first,rest:rest[3]}:first},peg$c3="(",peg$c4={type:"literal",value:"(",description:'"("'},peg$c5=")",peg$c6={type:"literal",value:")",description:'")"'},peg$c7="[]",peg$c8={type:"literal",value:"[]",description:'"[]"'},peg$c9=function(expr,arr){return{type:"parens",expr:expr,arr:arr.length}},peg$c18={type:"other",description:"name"},peg$c19=function(r,c){return{type:"name",value:r.join(""),arr:c.length}},peg$c20={type:"other",description:"whitespace"},peg$c21=/^[ \t\n\r]/,peg$c22={type:"class",value:"[ \\t\\n\\r]",description:"[ \\t\\n\\r]"},peg$c23=/^[A-Z]/,peg$c24={type:"class",value:"[A-Z]",description:"[A-Z]"},peg$c25="_",peg$c26={type:"literal",value:"_",description:'"_"'},peg$c27="-",peg$c28={type:"literal",value:"-",description:'"-"'},peg$c29=".",peg$c30={type:"literal",value:".",description:'"."'},peg$c31=/^[a-z:#\/]/,peg$c32={type:"class",value:"[a-z]",description:"[a-z]"},peg$c33=/^[0-9]/,peg$c34={type:"class",value:"[0-9]",description:"[0-9]"},peg$c35="?",peg$c36={type:"literal",value:"?",description:'"?"'},peg$currPos=0,peg$savedPos=0,peg$posDetailsCache=[{line:1,column:1,seenCR:!1}],peg$maxFailPos=0,peg$maxFailExpected=[],peg$silentFails=0;if("startRule"in options){if(!(options.startRule in peg$startRuleFunctions))throw new Error("Can't start parsing from rule \""+options.startRule+'".');peg$startRuleFunction=peg$startRuleFunctions[options.startRule]}if(peg$result=peg$startRuleFunction(),peg$result!==peg$FAILED&&peg$currPos===input.length)return peg$result;throw peg$result!==peg$FAILED&&peg$currPos<input.length&&peg$fail({type:"end",description:"end of input"}),peg$buildException(null,peg$maxFailExpected,peg$maxFailPos<input.length?input.charAt(peg$maxFailPos):null,peg$maxFailPos<input.length?peg$computeLocation(peg$maxFailPos,peg$maxFailPos+1):peg$computeLocation(peg$maxFailPos,peg$maxFailPos))}return peg$subclass(peg$SyntaxError,Error),{SyntaxError:peg$SyntaxError,parse:peg$parse}}();module.exports=parser},function(module,exports,__webpack_require__){function Stream(){EE.call(this)}module.exports=Stream;var EE=__webpack_require__(203).EventEmitter,inherits=__webpack_require__(221);inherits(Stream,EE),Stream.Readable=__webpack_require__(214),Stream.Writable=__webpack_require__(215),Stream.Duplex=__webpack_require__(216),Stream.Transform=__webpack_require__(217),Stream.PassThrough=__webpack_require__(218),Stream.Stream=Stream,Stream.prototype.pipe=function(dest,options){function ondata(chunk){dest.writable&&!1===dest.write(chunk)&&source.pause&&source.pause()}function ondrain(){source.readable&&source.resume&&source.resume()}function onend(){didOnEnd||(didOnEnd=!0,dest.end())}function onclose(){didOnEnd||(didOnEnd=!0,"function"==typeof dest.destroy&&dest.destroy())}function onerror(er){if(cleanup(),0===EE.listenerCount(this,"error"))throw er}function cleanup(){source.removeListener("data",ondata),dest.removeListener("drain",ondrain),source.removeListener("end",onend),source.removeListener("close",onclose),source.removeListener("error",onerror),dest.removeListener("error",onerror),source.removeListener("end",cleanup),source.removeListener("close",cleanup),dest.removeListener("close",cleanup)}var source=this;source.on("data",ondata),dest.on("drain",ondrain),dest._isStdio||options&&options.end===!1||(source.on("end",onend),source.on("close",onclose));var didOnEnd=!1;return source.on("error",onerror),dest.on("error",onerror),source.on("end",cleanup),source.on("close",cleanup),dest.on("close",cleanup),dest.emit("pipe",source),dest}},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;(function(){function createReduce(dir){function iterator(obj,iteratee,memo,keys,index,length){for(;index>=0&&length>index;index+=dir){var currentKey=keys?keys[index]:index;memo=iteratee(memo,obj[currentKey],currentKey,obj)}return memo}return function(obj,iteratee,memo,context){iteratee=optimizeCb(iteratee,context,4);var keys=!isArrayLike(obj)&&_.keys(obj),length=(keys||obj).length,index=dir>0?0:length-1;return arguments.length<3&&(memo=obj[keys?keys[index]:index],index+=dir),iterator(obj,iteratee,memo,keys,index,length)}}function createPredicateIndexFinder(dir){return function(array,predicate,context){predicate=cb(predicate,context);for(var length=getLength(array),index=dir>0?0:length-1;index>=0&&length>index;index+=dir)if(predicate(array[index],index,array))return index;return-1}}function createIndexFinder(dir,predicateFind,sortedIndex){
return function(array,item,idx){var i=0,length=getLength(array);if("number"==typeof idx)dir>0?i=idx>=0?idx:Math.max(idx+length,i):length=idx>=0?Math.min(idx+1,length):idx+length+1;else if(sortedIndex&&idx&&length)return idx=sortedIndex(array,item),array[idx]===item?idx:-1;if(item!==item)return idx=predicateFind(slice.call(array,i,length),_.isNaN),idx>=0?idx+i:-1;for(idx=dir>0?i:length-1;idx>=0&&length>idx;idx+=dir)if(array[idx]===item)return idx;return-1}}function collectNonEnumProps(obj,keys){var nonEnumIdx=nonEnumerableProps.length,constructor=obj.constructor,proto=_.isFunction(constructor)&&constructor.prototype||ObjProto,prop="constructor";for(_.has(obj,prop)&&!_.contains(keys,prop)&&keys.push(prop);nonEnumIdx--;)prop=nonEnumerableProps[nonEnumIdx],prop in obj&&obj[prop]!==proto[prop]&&!_.contains(keys,prop)&&keys.push(prop)}var root=this,previousUnderscore=root._,ArrayProto=Array.prototype,ObjProto=Object.prototype,FuncProto=Function.prototype,push=ArrayProto.push,slice=ArrayProto.slice,toString=ObjProto.toString,hasOwnProperty=ObjProto.hasOwnProperty,nativeIsArray=Array.isArray,nativeKeys=Object.keys,nativeBind=FuncProto.bind,nativeCreate=Object.create,Ctor=function(){},_=function(obj){return obj instanceof _?obj:this instanceof _?void(this._wrapped=obj):new _(obj)};"undefined"!=typeof module&&module.exports&&(exports=module.exports=_),exports._=_,_.VERSION="1.8.3";var optimizeCb=function(func,context,argCount){if(void 0===context)return func;switch(null==argCount?3:argCount){case 1:return function(value){return func.call(context,value)};case 2:return function(value,other){return func.call(context,value,other)};case 3:return function(value,index,collection){return func.call(context,value,index,collection)};case 4:return function(accumulator,value,index,collection){return func.call(context,accumulator,value,index,collection)}}return function(){return func.apply(context,arguments)}},cb=function(value,context,argCount){return null==value?_.identity:_.isFunction(value)?optimizeCb(value,context,argCount):_.isObject(value)?_.matcher(value):_.property(value)};_.iteratee=function(value,context){return cb(value,context,1/0)};var createAssigner=function(keysFunc,undefinedOnly){return function(obj){var length=arguments.length;if(2>length||null==obj)return obj;for(var index=1;length>index;index++)for(var source=arguments[index],keys=keysFunc(source),l=keys.length,i=0;l>i;i++){var key=keys[i];undefinedOnly&&void 0!==obj[key]||(obj[key]=source[key])}return obj}},baseCreate=function(prototype){if(!_.isObject(prototype))return{};if(nativeCreate)return nativeCreate(prototype);Ctor.prototype=prototype;var result=new Ctor;return Ctor.prototype=null,result},property=function(key){return function(obj){return null==obj?void 0:obj[key]}},MAX_ARRAY_INDEX=Math.pow(2,53)-1,getLength=property("length"),isArrayLike=function(collection){var length=getLength(collection);return"number"==typeof length&&length>=0&&MAX_ARRAY_INDEX>=length};_.each=_.forEach=function(obj,iteratee,context){iteratee=optimizeCb(iteratee,context);var i,length;if(isArrayLike(obj))for(i=0,length=obj.length;length>i;i++)iteratee(obj[i],i,obj);else{var keys=_.keys(obj);for(i=0,length=keys.length;length>i;i++)iteratee(obj[keys[i]],keys[i],obj)}return obj},_.map=_.collect=function(obj,iteratee,context){iteratee=cb(iteratee,context);for(var keys=!isArrayLike(obj)&&_.keys(obj),length=(keys||obj).length,results=Array(length),index=0;length>index;index++){var currentKey=keys?keys[index]:index;results[index]=iteratee(obj[currentKey],currentKey,obj)}return results},_.reduce=_.foldl=_.inject=createReduce(1),_.reduceRight=_.foldr=createReduce(-1),_.find=_.detect=function(obj,predicate,context){var key;return key=isArrayLike(obj)?_.findIndex(obj,predicate,context):_.findKey(obj,predicate,context),void 0!==key&&-1!==key?obj[key]:void 0},_.filter=_.select=function(obj,predicate,context){var results=[];return predicate=cb(predicate,context),_.each(obj,function(value,index,list){predicate(value,index,list)&&results.push(value)}),results},_.reject=function(obj,predicate,context){return _.filter(obj,_.negate(cb(predicate)),context)},_.every=_.all=function(obj,predicate,context){predicate=cb(predicate,context);for(var keys=!isArrayLike(obj)&&_.keys(obj),length=(keys||obj).length,index=0;length>index;index++){var currentKey=keys?keys[index]:index;if(!predicate(obj[currentKey],currentKey,obj))return!1}return!0},_.some=_.any=function(obj,predicate,context){predicate=cb(predicate,context);for(var keys=!isArrayLike(obj)&&_.keys(obj),length=(keys||obj).length,index=0;length>index;index++){var currentKey=keys?keys[index]:index;if(predicate(obj[currentKey],currentKey,obj))return!0}return!1},_.contains=_.includes=_.include=function(obj,item,fromIndex,guard){return isArrayLike(obj)||(obj=_.values(obj)),("number"!=typeof fromIndex||guard)&&(fromIndex=0),_.indexOf(obj,item,fromIndex)>=0},_.invoke=function(obj,method){var args=slice.call(arguments,2),isFunc=_.isFunction(method);return _.map(obj,function(value){var func=isFunc?method:value[method];return null==func?func:func.apply(value,args)})},_.pluck=function(obj,key){return _.map(obj,_.property(key))},_.where=function(obj,attrs){return _.filter(obj,_.matcher(attrs))},_.findWhere=function(obj,attrs){return _.find(obj,_.matcher(attrs))},_.max=function(obj,iteratee,context){var value,computed,result=-(1/0),lastComputed=-(1/0);if(null==iteratee&&null!=obj){obj=isArrayLike(obj)?obj:_.values(obj);for(var i=0,length=obj.length;length>i;i++)value=obj[i],value>result&&(result=value)}else iteratee=cb(iteratee,context),_.each(obj,function(value,index,list){computed=iteratee(value,index,list),(computed>lastComputed||computed===-(1/0)&&result===-(1/0))&&(result=value,lastComputed=computed)});return result},_.min=function(obj,iteratee,context){var value,computed,result=1/0,lastComputed=1/0;if(null==iteratee&&null!=obj){obj=isArrayLike(obj)?obj:_.values(obj);for(var i=0,length=obj.length;length>i;i++)value=obj[i],result>value&&(result=value)}else iteratee=cb(iteratee,context),_.each(obj,function(value,index,list){computed=iteratee(value,index,list),(lastComputed>computed||computed===1/0&&result===1/0)&&(result=value,lastComputed=computed)});return result},_.shuffle=function(obj){for(var rand,set=isArrayLike(obj)?obj:_.values(obj),length=set.length,shuffled=Array(length),index=0;length>index;index++)rand=_.random(0,index),rand!==index&&(shuffled[index]=shuffled[rand]),shuffled[rand]=set[index];return shuffled},_.sample=function(obj,n,guard){return null==n||guard?(isArrayLike(obj)||(obj=_.values(obj)),obj[_.random(obj.length-1)]):_.shuffle(obj).slice(0,Math.max(0,n))},_.sortBy=function(obj,iteratee,context){return iteratee=cb(iteratee,context),_.pluck(_.map(obj,function(value,index,list){return{value:value,index:index,criteria:iteratee(value,index,list)}}).sort(function(left,right){var a=left.criteria,b=right.criteria;if(a!==b){if(a>b||void 0===a)return 1;if(b>a||void 0===b)return-1}return left.index-right.index}),"value")};var group=function(behavior){return function(obj,iteratee,context){var result={};return iteratee=cb(iteratee,context),_.each(obj,function(value,index){var key=iteratee(value,index,obj);behavior(result,value,key)}),result}};_.groupBy=group(function(result,value,key){_.has(result,key)?result[key].push(value):result[key]=[value]}),_.indexBy=group(function(result,value,key){result[key]=value}),_.countBy=group(function(result,value,key){_.has(result,key)?result[key]++:result[key]=1}),_.toArray=function(obj){return obj?_.isArray(obj)?slice.call(obj):isArrayLike(obj)?_.map(obj,_.identity):_.values(obj):[]},_.size=function(obj){return null==obj?0:isArrayLike(obj)?obj.length:_.keys(obj).length},_.partition=function(obj,predicate,context){predicate=cb(predicate,context);var pass=[],fail=[];return _.each(obj,function(value,key,obj){(predicate(value,key,obj)?pass:fail).push(value)}),[pass,fail]},_.first=_.head=_.take=function(array,n,guard){return null==array?void 0:null==n||guard?array[0]:_.initial(array,array.length-n)},_.initial=function(array,n,guard){return slice.call(array,0,Math.max(0,array.length-(null==n||guard?1:n)))},_.last=function(array,n,guard){return null==array?void 0:null==n||guard?array[array.length-1]:_.rest(array,Math.max(0,array.length-n))},_.rest=_.tail=_.drop=function(array,n,guard){return slice.call(array,null==n||guard?1:n)},_.compact=function(array){return _.filter(array,_.identity)};var flatten=function(input,shallow,strict,startIndex){for(var output=[],idx=0,i=startIndex||0,length=getLength(input);length>i;i++){var value=input[i];if(isArrayLike(value)&&(_.isArray(value)||_.isArguments(value))){shallow||(value=flatten(value,shallow,strict));var j=0,len=value.length;for(output.length+=len;len>j;)output[idx++]=value[j++]}else strict||(output[idx++]=value)}return output};_.flatten=function(array,shallow){return flatten(array,shallow,!1)},_.without=function(array){return _.difference(array,slice.call(arguments,1))},_.uniq=_.unique=function(array,isSorted,iteratee,context){_.isBoolean(isSorted)||(context=iteratee,iteratee=isSorted,isSorted=!1),null!=iteratee&&(iteratee=cb(iteratee,context));for(var result=[],seen=[],i=0,length=getLength(array);length>i;i++){var value=array[i],computed=iteratee?iteratee(value,i,array):value;isSorted?(i&&seen===computed||result.push(value),seen=computed):iteratee?_.contains(seen,computed)||(seen.push(computed),result.push(value)):_.contains(result,value)||result.push(value)}return result},_.union=function(){return _.uniq(flatten(arguments,!0,!0))},_.intersection=function(array){for(var result=[],argsLength=arguments.length,i=0,length=getLength(array);length>i;i++){var item=array[i];if(!_.contains(result,item)){for(var j=1;argsLength>j&&_.contains(arguments[j],item);j++);j===argsLength&&result.push(item)}}return result},_.difference=function(array){var rest=flatten(arguments,!0,!0,1);return _.filter(array,function(value){return!_.contains(rest,value)})},_.zip=function(){return _.unzip(arguments)},_.unzip=function(array){for(var length=array&&_.max(array,getLength).length||0,result=Array(length),index=0;length>index;index++)result[index]=_.pluck(array,index);return result},_.object=function(list,values){for(var result={},i=0,length=getLength(list);length>i;i++)values?result[list[i]]=values[i]:result[list[i][0]]=list[i][1];return result},_.findIndex=createPredicateIndexFinder(1),_.findLastIndex=createPredicateIndexFinder(-1),_.sortedIndex=function(array,obj,iteratee,context){iteratee=cb(iteratee,context,1);for(var value=iteratee(obj),low=0,high=getLength(array);high>low;){var mid=Math.floor((low+high)/2);iteratee(array[mid])<value?low=mid+1:high=mid}return low},_.indexOf=createIndexFinder(1,_.findIndex,_.sortedIndex),_.lastIndexOf=createIndexFinder(-1,_.findLastIndex),_.range=function(start,stop,step){null==stop&&(stop=start||0,start=0),step=step||1;for(var length=Math.max(Math.ceil((stop-start)/step),0),range=Array(length),idx=0;length>idx;idx++,start+=step)range[idx]=start;return range};var executeBound=function(sourceFunc,boundFunc,context,callingContext,args){if(!(callingContext instanceof boundFunc))return sourceFunc.apply(context,args);var self=baseCreate(sourceFunc.prototype),result=sourceFunc.apply(self,args);return _.isObject(result)?result:self};_.bind=function(func,context){if(nativeBind&&func.bind===nativeBind)return nativeBind.apply(func,slice.call(arguments,1));if(!_.isFunction(func))throw new TypeError("Bind must be called on a function");var args=slice.call(arguments,2),bound=function(){return executeBound(func,bound,context,this,args.concat(slice.call(arguments)))};return bound},_.partial=function(func){var boundArgs=slice.call(arguments,1),bound=function(){for(var position=0,length=boundArgs.length,args=Array(length),i=0;length>i;i++)args[i]=boundArgs[i]===_?arguments[position++]:boundArgs[i];for(;position<arguments.length;)args.push(arguments[position++]);return executeBound(func,bound,this,this,args)};return bound},_.bindAll=function(obj){var i,key,length=arguments.length;if(1>=length)throw new Error("bindAll must be passed function names");for(i=1;length>i;i++)key=arguments[i],obj[key]=_.bind(obj[key],obj);return obj},_.memoize=function(func,hasher){var memoize=function(key){var cache=memoize.cache,address=""+(hasher?hasher.apply(this,arguments):key);return _.has(cache,address)||(cache[address]=func.apply(this,arguments)),cache[address]};return memoize.cache={},memoize},_.delay=function(func,wait){var args=slice.call(arguments,2);return setTimeout(function(){return func.apply(null,args)},wait)},_.defer=_.partial(_.delay,_,1),_.throttle=function(func,wait,options){var context,args,result,timeout=null,previous=0;options||(options={});var later=function(){previous=options.leading===!1?0:_.now(),timeout=null,result=func.apply(context,args),timeout||(context=args=null)};return function(){var now=_.now();previous||options.leading!==!1||(previous=now);var remaining=wait-(now-previous);return context=this,args=arguments,0>=remaining||remaining>wait?(timeout&&(clearTimeout(timeout),timeout=null),previous=now,result=func.apply(context,args),timeout||(context=args=null)):timeout||options.trailing===!1||(timeout=setTimeout(later,remaining)),result}},_.debounce=function(func,wait,immediate){var timeout,args,context,timestamp,result,later=function(){var last=_.now()-timestamp;wait>last&&last>=0?timeout=setTimeout(later,wait-last):(timeout=null,immediate||(result=func.apply(context,args),timeout||(context=args=null)))};return function(){context=this,args=arguments,timestamp=_.now();var callNow=immediate&&!timeout;return timeout||(timeout=setTimeout(later,wait)),callNow&&(result=func.apply(context,args),context=args=null),result}},_.wrap=function(func,wrapper){return _.partial(wrapper,func)},_.negate=function(predicate){return function(){return!predicate.apply(this,arguments)}},_.compose=function(){var args=arguments,start=args.length-1;return function(){for(var i=start,result=args[start].apply(this,arguments);i--;)result=args[i].call(this,result);return result}},_.after=function(times,func){return function(){return--times<1?func.apply(this,arguments):void 0}},_.before=function(times,func){var memo;return function(){return--times>0&&(memo=func.apply(this,arguments)),1>=times&&(func=null),memo}},_.once=_.partial(_.before,2);var hasEnumBug=!{toString:null}.propertyIsEnumerable("toString"),nonEnumerableProps=["valueOf","isPrototypeOf","toString","propertyIsEnumerable","hasOwnProperty","toLocaleString"];_.keys=function(obj){if(!_.isObject(obj))return[];if(nativeKeys)return nativeKeys(obj);var keys=[];for(var key in obj)_.has(obj,key)&&keys.push(key);return hasEnumBug&&collectNonEnumProps(obj,keys),keys},_.allKeys=function(obj){if(!_.isObject(obj))return[];var keys=[];for(var key in obj)keys.push(key);return hasEnumBug&&collectNonEnumProps(obj,keys),keys},_.values=function(obj){for(var keys=_.keys(obj),length=keys.length,values=Array(length),i=0;length>i;i++)values[i]=obj[keys[i]];return values},_.mapObject=function(obj,iteratee,context){iteratee=cb(iteratee,context);for(var currentKey,keys=_.keys(obj),length=keys.length,results={},index=0;length>index;index++)currentKey=keys[index],results[currentKey]=iteratee(obj[currentKey],currentKey,obj);return results},_.pairs=function(obj){for(var keys=_.keys(obj),length=keys.length,pairs=Array(length),i=0;length>i;i++)pairs[i]=[keys[i],obj[keys[i]]];return pairs},_.invert=function(obj){for(var result={},keys=_.keys(obj),i=0,length=keys.length;length>i;i++)result[obj[keys[i]]]=keys[i];return result},_.functions=_.methods=function(obj){var names=[];for(var key in obj)_.isFunction(obj[key])&&names.push(key);return names.sort()},_.extend=createAssigner(_.allKeys),_.extendOwn=_.assign=createAssigner(_.keys),_.findKey=function(obj,predicate,context){predicate=cb(predicate,context);for(var key,keys=_.keys(obj),i=0,length=keys.length;length>i;i++)if(key=keys[i],predicate(obj[key],key,obj))return key},_.pick=function(object,oiteratee,context){var iteratee,keys,result={},obj=object;if(null==obj)return result;_.isFunction(oiteratee)?(keys=_.allKeys(obj),iteratee=optimizeCb(oiteratee,context)):(keys=flatten(arguments,!1,!1,1),iteratee=function(value,key,obj){return key in obj},obj=Object(obj));for(var i=0,length=keys.length;length>i;i++){var key=keys[i],value=obj[key];iteratee(value,key,obj)&&(result[key]=value)}return result},_.omit=function(obj,iteratee,context){if(_.isFunction(iteratee))iteratee=_.negate(iteratee);else{var keys=_.map(flatten(arguments,!1,!1,1),String);iteratee=function(value,key){return!_.contains(keys,key)}}return _.pick(obj,iteratee,context)},_.defaults=createAssigner(_.allKeys,!0),_.create=function(prototype,props){var result=baseCreate(prototype);return props&&_.extendOwn(result,props),result},_.clone=function(obj){return _.isObject(obj)?_.isArray(obj)?obj.slice():_.extend({},obj):obj},_.tap=function(obj,interceptor){return interceptor(obj),obj},_.isMatch=function(object,attrs){var keys=_.keys(attrs),length=keys.length;if(null==object)return!length;for(var obj=Object(object),i=0;length>i;i++){var key=keys[i];if(attrs[key]!==obj[key]||!(key in obj))return!1}return!0};var eq=function(a,b,aStack,bStack){if(a===b)return 0!==a||1/a===1/b;if(null==a||null==b)return a===b;a instanceof _&&(a=a._wrapped),b instanceof _&&(b=b._wrapped);var className=toString.call(a);if(className!==toString.call(b))return!1;switch(className){case"[object RegExp]":case"[object String]":return""+a==""+b;case"[object Number]":return+a!==+a?+b!==+b:0===+a?1/+a===1/b:+a===+b;case"[object Date]":case"[object Boolean]":return+a===+b}var areArrays="[object Array]"===className;if(!areArrays){if("object"!=typeof a||"object"!=typeof b)return!1;var aCtor=a.constructor,bCtor=b.constructor;if(aCtor!==bCtor&&!(_.isFunction(aCtor)&&aCtor instanceof aCtor&&_.isFunction(bCtor)&&bCtor instanceof bCtor)&&"constructor"in a&&"constructor"in b)return!1}aStack=aStack||[],bStack=bStack||[];for(var length=aStack.length;length--;)if(aStack[length]===a)return bStack[length]===b;if(aStack.push(a),bStack.push(b),areArrays){if(length=a.length,length!==b.length)return!1;for(;length--;)if(!eq(a[length],b[length],aStack,bStack))return!1}else{var key,keys=_.keys(a);if(length=keys.length,_.keys(b).length!==length)return!1;for(;length--;)if(key=keys[length],!_.has(b,key)||!eq(a[key],b[key],aStack,bStack))return!1}return aStack.pop(),bStack.pop(),!0};_.isEqual=function(a,b){return eq(a,b)},_.isEmpty=function(obj){return null==obj?!0:isArrayLike(obj)&&(_.isArray(obj)||_.isString(obj)||_.isArguments(obj))?0===obj.length:0===_.keys(obj).length},_.isElement=function(obj){return!(!obj||1!==obj.nodeType)},_.isArray=nativeIsArray||function(obj){return"[object Array]"===toString.call(obj)},_.isObject=function(obj){var type=typeof obj;return"function"===type||"object"===type&&!!obj},_.each(["Arguments","Function","String","Number","Date","RegExp","Error"],function(name){_["is"+name]=function(obj){return toString.call(obj)==="[object "+name+"]"}}),_.isArguments(arguments)||(_.isArguments=function(obj){return _.has(obj,"callee")}),"function"!=typeof/./&&"object"!=typeof Int8Array&&(_.isFunction=function(obj){return"function"==typeof obj||!1}),_.isFinite=function(obj){return isFinite(obj)&&!isNaN(parseFloat(obj))},_.isNaN=function(obj){return _.isNumber(obj)&&obj!==+obj},_.isBoolean=function(obj){return obj===!0||obj===!1||"[object Boolean]"===toString.call(obj)},_.isNull=function(obj){return null===obj},_.isUndefined=function(obj){return void 0===obj},_.has=function(obj,key){return null!=obj&&hasOwnProperty.call(obj,key)},_.noConflict=function(){return root._=previousUnderscore,this},_.identity=function(value){return value},_.constant=function(value){return function(){return value}},_.noop=function(){},_.property=property,_.propertyOf=function(obj){return null==obj?function(){}:function(key){return obj[key]}},_.matcher=_.matches=function(attrs){return attrs=_.extendOwn({},attrs),function(obj){return _.isMatch(obj,attrs)}},_.times=function(n,iteratee,context){var accum=Array(Math.max(0,n));iteratee=optimizeCb(iteratee,context,1);for(var i=0;n>i;i++)accum[i]=iteratee(i);return accum},_.random=function(min,max){return null==max&&(max=min,min=0),min+Math.floor(Math.random()*(max-min+1))},_.now=Date.now||function(){return(new Date).getTime()};var escapeMap={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#x27;","`":"&#x60;"},unescapeMap=_.invert(escapeMap),createEscaper=function(map){var escaper=function(match){return map[match]},source="(?:"+_.keys(map).join("|")+")",testRegexp=RegExp(source),replaceRegexp=RegExp(source,"g");return function(string){return string=null==string?"":""+string,testRegexp.test(string)?string.replace(replaceRegexp,escaper):string}};_.escape=createEscaper(escapeMap),_.unescape=createEscaper(unescapeMap),_.result=function(object,property,fallback){var value=null==object?void 0:object[property];return void 0===value&&(value=fallback),_.isFunction(value)?value.call(object):value};var idCounter=0;_.uniqueId=function(prefix){var id=++idCounter+"";return prefix?prefix+id:id},_.templateSettings={evaluate:/<%([\s\S]+?)%>/g,interpolate:/<%=([\s\S]+?)%>/g,escape:/<%-([\s\S]+?)%>/g};var noMatch=/(.)^/,escapes={"'":"'","\\":"\\","\r":"r","\n":"n","\u2028":"u2028","\u2029":"u2029"},escaper=/\\|'|\r|\n|\u2028|\u2029/g,escapeChar=function(match){return"\\"+escapes[match]};_.template=function(text,settings,oldSettings){!settings&&oldSettings&&(settings=oldSettings),settings=_.defaults({},settings,_.templateSettings);var matcher=RegExp([(settings.escape||noMatch).source,(settings.interpolate||noMatch).source,(settings.evaluate||noMatch).source].join("|")+"|$","g"),index=0,source="__p+='";text.replace(matcher,function(match,escape,interpolate,evaluate,offset){return source+=text.slice(index,offset).replace(escaper,escapeChar),index=offset+match.length,escape?source+="'+\n((__t=("+escape+"))==null?'':_.escape(__t))+\n'":interpolate?source+="'+\n((__t=("+interpolate+"))==null?'':__t)+\n'":evaluate&&(source+="';\n"+evaluate+"\n__p+='"),match}),source+="';\n",settings.variable||(source="with(obj||{}){\n"+source+"}\n"),source="var __t,__p='',__j=Array.prototype.join,print=function(){__p+=__j.call(arguments,'');};\n"+source+"return __p;\n";try{var render=new Function(settings.variable||"obj","_",source)}catch(e){throw e.source=source,e}var template=function(data){return render.call(this,data,_)},argument=settings.variable||"obj";return template.source="function("+argument+"){\n"+source+"}",template},_.chain=function(obj){var instance=_(obj);return instance._chain=!0,instance};var result=function(instance,obj){return instance._chain?_(obj).chain():obj};_.mixin=function(obj){_.each(_.functions(obj),function(name){var func=_[name]=obj[name];_.prototype[name]=function(){var args=[this._wrapped];return push.apply(args,arguments),result(this,func.apply(_,args))}})},_.mixin(_),_.each(["pop","push","reverse","shift","sort","splice","unshift"],function(name){var method=ArrayProto[name];_.prototype[name]=function(){var obj=this._wrapped;return method.apply(obj,arguments),"shift"!==name&&"splice"!==name||0!==obj.length||delete obj[0],result(this,obj)}}),_.each(["concat","join","slice"],function(name){var method=ArrayProto[name];_.prototype[name]=function(){return result(this,method.apply(this._wrapped,arguments))}}),_.prototype.value=function(){return this._wrapped},_.prototype.valueOf=_.prototype.toJSON=_.prototype.value,_.prototype.toString=function(){return""+this._wrapped},__WEBPACK_AMD_DEFINE_ARRAY__=[],__WEBPACK_AMD_DEFINE_RESULT__=function(){return _}.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__),!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__))}).call(this)},function(module,exports,__webpack_require__){function DOMParser(options){this.options=options||{locator:{}}}function buildErrorHandler(errorImpl,domBuilder,locator){function build(key){var fn=errorImpl[key];!fn&&isCallback&&(fn=2==errorImpl.length?function(msg){errorImpl(key,msg)}:errorImpl),errorHandler[key]=fn&&function(msg){fn("[xmldom "+key+"]	"+msg+_locator(locator))}||function(){}}if(!errorImpl){if(domBuilder instanceof DOMHandler)return domBuilder;errorImpl=domBuilder}var errorHandler={},isCallback=errorImpl instanceof Function;return locator=locator||{},build("warning"),build("error"),build("fatalError"),errorHandler}function DOMHandler(){this.cdata=!1}function position(locator,node){node.lineNumber=locator.lineNumber,node.columnNumber=locator.columnNumber}function _locator(l){return l?"\n@"+(l.systemId||"")+"#[line:"+l.lineNumber+",col:"+l.columnNumber+"]":void 0}function _toString(chars,start,length){return"string"==typeof chars?chars.substr(start,length):chars.length>=start+length||start?new java.lang.String(chars,start,length)+"":chars}function appendElement(hander,node){hander.currentElement?hander.currentElement.appendChild(node):hander.document.appendChild(node)}DOMParser.prototype.parseFromString=function(source,mimeType){var options=this.options,sax=new XMLReader,domBuilder=options.domBuilder||new DOMHandler,errorHandler=options.errorHandler,locator=options.locator,defaultNSMap=options.xmlns||{},entityMap={lt:"<",gt:">",amp:"&",quot:'"',apos:"'"};return locator&&domBuilder.setDocumentLocator(locator),sax.errorHandler=buildErrorHandler(errorHandler,domBuilder,locator),sax.domBuilder=options.domBuilder||domBuilder,/\/x?html?$/.test(mimeType)&&(entityMap.nbsp=" ",entityMap.copy="©",defaultNSMap[""]="http://www.w3.org/1999/xhtml"),defaultNSMap.xml=defaultNSMap.xml||"http://www.w3.org/XML/1998/namespace",source?sax.parse(source,defaultNSMap,entityMap):sax.errorHandler.error("invalid document source"),domBuilder.document},DOMHandler.prototype={startDocument:function(){this.document=(new DOMImplementation).createDocument(null,null,null),this.locator&&(this.document.documentURI=this.locator.systemId)},startElement:function(namespaceURI,localName,qName,attrs){var doc=this.document,el=doc.createElementNS(namespaceURI,qName||localName),len=attrs.length;appendElement(this,el),this.currentElement=el,this.locator&&position(this.locator,el);for(var i=0;len>i;i++){var namespaceURI=attrs.getURI(i),value=attrs.getValue(i),qName=attrs.getQName(i),attr=doc.createAttributeNS(namespaceURI,qName);attr.getOffset&&position(attr.getOffset(1),attr),attr.value=attr.nodeValue=value,el.setAttributeNode(attr)}},endElement:function(namespaceURI,localName,qName){var current=this.currentElement;current.tagName;this.currentElement=current.parentNode},startPrefixMapping:function(prefix,uri){},endPrefixMapping:function(prefix){},processingInstruction:function(target,data){var ins=this.document.createProcessingInstruction(target,data);this.locator&&position(this.locator,ins),appendElement(this,ins)},ignorableWhitespace:function(ch,start,length){},characters:function(chars,start,length){if(chars=_toString.apply(this,arguments),this.currentElement&&chars){if(this.cdata){var charNode=this.document.createCDATASection(chars);this.currentElement.appendChild(charNode)}else{var charNode=this.document.createTextNode(chars);this.currentElement.appendChild(charNode)}this.locator&&position(this.locator,charNode)}},skippedEntity:function(name){},endDocument:function(){this.document.normalize()},setDocumentLocator:function(locator){(this.locator=locator)&&(locator.lineNumber=0)},comment:function(chars,start,length){chars=_toString.apply(this,arguments);var comm=this.document.createComment(chars);this.locator&&position(this.locator,comm),appendElement(this,comm)},startCDATA:function(){this.cdata=!0},endCDATA:function(){this.cdata=!1},startDTD:function(name,publicId,systemId){var impl=this.document.implementation;if(impl&&impl.createDocumentType){var dt=impl.createDocumentType(name,publicId,systemId);this.locator&&position(this.locator,dt),appendElement(this,dt)}},warning:function(error){console.warn("[xmldom warning]	"+error,_locator(this.locator))},error:function(error){console.error("[xmldom error]	"+error,_locator(this.locator))},fatalError:function(error){throw console.error("[xmldom fatalError]	"+error,_locator(this.locator)),error}},"endDTD,startEntity,endEntity,attributeDecl,elementDecl,externalEntityDecl,internalEntityDecl,resolveEntity,getExternalSubset,notationDecl,unparsedEntityDecl".replace(/\w+/g,function(key){DOMHandler.prototype[key]=function(){return null}});var XMLReader=__webpack_require__(198).XMLReader,DOMImplementation=exports.DOMImplementation=__webpack_require__(199).DOMImplementation;exports.XMLSerializer=__webpack_require__(199).XMLSerializer,exports.DOMParser=DOMParser},function(module,exports,__webpack_require__){(function(){function convert3to4Type(types,always){Array.isArray(types)||(types=[types]);for(var needsReplacement=!!always,result=[],i=0;i<types.length;i++){var entry=types[i];"object"==typeof entry?(result.push(entry),needsReplacement=!0):result.push({type:entry})}return needsReplacement&&result}function convert3to4(obj){if(obj.type)if("string"!=typeof obj.type){var anyOf=convert3to4Type(obj.type);anyOf&&(obj.anyOf=anyOf,delete obj.type)}else"any"==obj.type&&delete obj.type;if(obj["extends"]){var allOf=obj["extends"];Array.isArray(allOf)||(allOf=[allOf]),obj.allOf=allOf,delete obj["extends"]}if(obj.disallow&&("string"==typeof obj.disallow?obj.not={type:obj.disallow}:obj.not={anyOf:convert3to4Type(obj.disallow,!0)},delete obj.disallow),obj.properties){var required=Array.isArray(obj.required)?obj.required:[];for(var key in obj.properties){var subSchema=obj.properties[key];subSchema&&"boolean"==typeof subSchema.required&&(subSchema.required&&required.push(key),delete subSchema.required)}required.length&&(obj.required=required)}if(obj.dependencies)for(var key in obj.dependencies)"string"==typeof obj.dependencies[key]&&(obj.dependencies[key]=[obj.dependencies[key]]);"boolean"==typeof obj.required&&delete obj.required,"undefined"!=typeof obj.divisibleBy&&(obj.multipleOf=obj.divisibleBy,delete obj.divisibleBy);for(var key in obj)if("properties"===key||"patternProperties"===key||"dependencies"===key)for(var subKey in obj[key])obj[key][subKey]=convert3to4(obj[key][subKey]);else if("enum"!==key)if(Array.isArray(obj[key]))for(var i=0;i<obj[key].length;i++)obj[key][i]=convert3to4(obj[key][i]);else"object"==typeof obj[key]&&(obj[key]=convert3to4(obj[key]));return obj}var api={v4:convert3to4};return module.exports=api,api})()},function(module,exports,__webpack_require__){module.exports=[{code:"1xx",phrase:"**Informational**",description:'"indicates an interim response for communicating connection status or request progress prior to completing the requested action and sending a final response." ~ [sure](http://www.urbandictionary.com/define.php?term=sure)',spec_title:"RFC7231#6.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.2"},{code:"100",phrase:"Continue",description:'"indicates that the initial part of a request has been received and has not yet been rejected by the server."',spec_title:"RFC7231#6.2.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.2.1"},{code:"101",phrase:"Switching Protocols",description:'"indicates that the server understands and is willing to comply with the client\'s request, via the Upgrade header field, for a change in the application protocol being used on this connection."',spec_title:"RFC7231#6.2.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.2.2"},{code:"2xx",phrase:"**Successful**",description:'"indicates that the client\'s request was successfully received, understood, and accepted." ~ [cool](https://twitter.com/DanaDanger/status/183316183494311936)',spec_title:"RFC7231#6.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.3"},{code:"200",phrase:"OK",description:'"indicates that the request has succeeded."',spec_title:"RFC7231#6.3.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.3.1"},{code:"201",phrase:"Created",description:'"indicates that the request has been fulfilled and has resulted in one or more new resources being created."',
spec_title:"RFC7231#6.3.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.3.2"},{code:"202",phrase:"Accepted",description:'"indicates that the request has been accepted for processing, but the processing has not been completed."',spec_title:"RFC7231#6.3.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.3.3"},{code:"203",phrase:"Non-Authoritative Information",description:'"indicates that the request was successful but the enclosed payload has been modified from that of the origin server\'s 200 (OK) response by a transforming proxy."',spec_title:"RFC7231#6.3.4",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.3.4"},{code:"204",phrase:"No Content",description:'"indicates that the server has successfully fulfilled the request and that there is no additional content to send in the response payload body."',spec_title:"RFC7231#6.3.5",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.3.5"},{code:"205",phrase:"Reset Content",description:'"indicates that the server has fulfilled the request and desires that the user agent reset the "document view", which caused the request to be sent, to its original state as received from the origin server."',spec_title:"RFC7231#6.3.6",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.3.6"},{code:"206",phrase:"Partial Content",description:'"indicates that the server is successfully fulfilling a range request for the target resource by transferring one or more parts of the selected representation that correspond to the satisfiable ranges found in the requests\'s Range header field."',spec_title:"RFC7233#4.1",spec_href:"http://tools.ietf.org/html/rfc7233#section-4.1"},{code:"3xx",phrase:"**Redirection**",description:'"indicates that further action needs to be taken by the user agent in order to fulfill the request." ~ [ask that dude over there](https://twitter.com/DanaDanger/status/183316183494311936)',spec_title:"RFC7231#6.4",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.4"},{code:"300",phrase:"Multiple Choices",description:'"indicates that the target resource has more than one representation, each with its own more specific identifier, and information about the alternatives is being provided so that the user (or user agent) can select a preferred representation by redirecting its request to one or more of those identifiers."',spec_title:"RFC7231#6.4.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.4.1"},{code:"301",phrase:"Moved Permanently",description:'"indicates that the target resource has been assigned a new permanent URI and any future references to this resource ought to use one of the enclosed URIs."',spec_title:"RFC7231#6.4.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.4.2"},{code:"302",phrase:"Found",description:'"indicates that the target resource resides temporarily under a different URI."',spec_title:"RFC7231#6.4.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.4.3"},{code:"303",phrase:"See Other",description:'"indicates that the server is redirecting the user agent to a different resource, as indicated by a URI in the Location header field, that is intended to provide an indirect response to the original request."',spec_title:"RFC7231#6.4.4",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.4.4"},{code:"304",phrase:"Not Modified",description:'"indicates that a conditional GET request has been received and would have resulted in a 200 (OK) response if it were not for the fact that the condition has evaluated to false."',spec_title:"RFC7232#4.1",spec_href:"http://tools.ietf.org/html/rfc7232#section-4.1"},{code:"305",phrase:"Use Proxy",description:"*deprecated*",spec_title:"RFC7231#6.4.5",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.4.5"},{code:"307",phrase:"Temporary Redirect",description:'"indicates that the target resource resides temporarily under a different URI and the user agent MUST NOT change the request method if it performs an automatic redirection to that URI."',spec_title:"RFC7231#6.4.7",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.4.7"},{code:"4xx",phrase:"**Client Error**",description:'"indicates that the client seems to have erred." ~ [*you* fucked up](https://twitter.com/DanaDanger/status/183316183494311936)',spec_title:"RFC7231#6.5",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5"},{code:"400",phrase:"Bad Request",description:'"indicates that the server cannot or will not process the request because the received syntax is invalid, nonsensical, or exceeds some limitation on what the server is willing to process."',spec_title:"RFC7231#6.5.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.1"},{code:"401",phrase:"Unauthorized",description:'"indicates that the request has not been applied because it lacks valid authentication credentials for the target resource."',spec_title:"RFC7235#6.3.1",spec_href:"http://tools.ietf.org/html/rfc7235#section-3.1"},{code:"402",phrase:"Payment Required",description:"*reserved*",spec_title:"RFC7231#6.5.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.2"},{code:"403",phrase:"Forbidden",description:'"indicates that the server understood the request but refuses to authorize it."',spec_title:"RFC7231#6.5.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.3"},{code:"404",phrase:"Not Found",description:'"indicates that the origin server did not find a current representation for the target resource or is not willing to disclose that one exists."',spec_title:"RFC7231#6.5.4",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.4"},{code:"405",phrase:"Method Not Allowed",description:'"indicates that the method specified in the request-line is known by the origin server but not supported by the target resource."',spec_title:"RFC7231#6.5.5",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.5"},{code:"406",phrase:"Not Acceptable",description:'"indicates that the target resource does not have a current representation that would be acceptable to the user agent, according to the proactive negotiation header fields received in the request, and the server is unwilling to supply a default representation."',spec_title:"RFC7231#6.5.6",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.6"},{code:"407",phrase:"Proxy Authentication Required",description:'"is similar to 401 (Unauthorized), but indicates that the client needs to authenticate itself in order to use a proxy."',spec_title:"RFC7231#6.3.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.3.2"},{code:"408",phrase:"Request Timeout",description:'"indicates that the server did not receive a complete request message within the time that it was prepared to wait."',spec_title:"RFC7231#6.5.7",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.7"},{code:"409",phrase:"Conflict",description:'"indicates that the request could not be completed due to a conflict with the current state of the resource."',spec_title:"RFC7231#6.5.8",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.8"},{code:"410",phrase:"Gone",description:'"indicates that access to the target resource is no longer available at the origin server and that this condition is likely to be permanent."',spec_title:"RFC7231#6.5.9",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.9"},{code:"411",phrase:"Length Required",description:'"indicates that the server refuses to accept the request without a defined Content-Length."',spec_title:"RFC7231#6.5.10",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.10"},{code:"412",phrase:"Precondition Failed",description:'"indicates that one or more preconditions given in the request header fields evaluated to false when tested on the server."',spec_title:"RFC7232#4.2",spec_href:"http://tools.ietf.org/html/rfc7232#section-4.2"},{code:"413",phrase:"Payload Too Large",description:'"indicates that the server is refusing to process a request because the request payload is larger than the server is willing or able to process."',spec_title:"RFC7231#6.5.11",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.11"},{code:"414",phrase:"URI Too Long",description:'"indicates that the server is refusing to service the request because the request-target is longer than the server is willing to interpret."',spec_title:"RFC7231#6.5.12",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.12"},{code:"415",phrase:"Unsupported Media Type",description:'"indicates that the origin server is refusing to service the request because the payload is in a format not supported by the target resource for this method."',spec_title:"RFC7231#6.5.13",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.13"},{code:"416",phrase:"Range Not Satisfiable",description:'"indicates that none of the ranges in the request\'s Range header field overlap the current extent of the selected resource or that the set of ranges requested has been rejected due to invalid ranges or an excessive request of small or overlapping ranges."',spec_title:"RFC7233#4.4",spec_href:"http://tools.ietf.org/html/rfc7233#section-4.4"},{code:"417",phrase:"Expectation Failed",description:'"indicates that the expectation given in the request\'s Expect header field could not be met by at least one of the inbound servers."',spec_title:"RFC7231#6.5.14",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.14"},{code:"426",phrase:"Upgrade Required",description:'"indicates that the server refuses to perform the request using the current protocol but might be willing to do so after the client upgrades to a different protocol."',spec_title:"RFC7231#6.5.15",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.5.15"},{code:"5xx",phrase:"**Server Error**",description:'"indicates that the server is aware that it has erred or is incapable of performing the requested method." ~ [*we* fucked up](https://twitter.com/DanaDanger/status/183316183494311936)',spec_title:"RFC7231#6.6",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.6"},{code:"500",phrase:"Internal Server Error",description:'"indicates that the server encountered an unexpected condition that prevented it from fulfilling the request."',spec_title:"RFC7231#6.6.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.6.1"},{code:"501",phrase:"Not Implemented",description:'"indicates that the server does not support the functionality required to fulfill the request."',spec_title:"RFC7231#6.6.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.6.2"},{code:"502",phrase:"Bad Gateway",description:'"indicates that the server, while acting as a gateway or proxy, received an invalid response from an inbound server it accessed while attempting to fulfill the request."',spec_title:"RFC7231#6.6.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.6.3"},{code:"503",phrase:"Service Unavailable",description:'"indicates that the server is currently unable to handle the request due to a temporary overload or scheduled maintenance, which will likely be alleviated after some delay."',spec_title:"RFC7231#6.6.4",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.6.4"},{code:"504",phrase:"Gateway Time-out",description:'"indicates that the server, while acting as a gateway or proxy, did not receive a timely response from an upstream server it needed to access in order to complete the request."',spec_title:"RFC7231#6.6.5",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.6.5"},{code:"505",phrase:"HTTP Version Not Supported",description:'"indicates that the server does not support, or refuses to support, the protocol version that was used in the request message."',spec_title:"RFC7231#6.6.6",spec_href:"http://tools.ietf.org/html/rfc7231#section-6.6.6"},{code:"102",phrase:"Processing",description:'"is an interim response used to inform the client that the server has accepted the complete request, but has not yet completed it."',spec_title:"RFC5218#10.1",spec_href:"http://tools.ietf.org/html/rfc2518#section-10.1"},{code:"207",phrase:"Multi-Status",description:'"provides status for multiple independent operations."',spec_title:"RFC5218#10.2",spec_href:"http://tools.ietf.org/html/rfc2518#section-10.2"},{code:"226",phrase:"IM Used",description:'"The server has fulfilled a GET request for the resource, and the response is a representation of the result of one or more instance-manipulations applied to the current instance."',spec_title:"RFC3229#10.4.1",spec_href:"http://tools.ietf.org/html/rfc3229#section-10.4.1"},{code:"308",phrase:"Permanent Redirect",description:'"The target resource has been assigned a new permanent URI and any future references to this resource SHOULD use one of the returned URIs. [...] This status code is similar to 301 Moved Permanently (Section 7.3.2 of rfc7231), except that it does not allow rewriting the request method from POST to GET."',spec_title:"RFC7238",spec_href:"http://tools.ietf.org/html/rfc7238"},{code:"422",phrase:"Unprocessable Entity",description:'"means the server understands the content type of the request entity (hence a 415(Unsupported Media Type) status code is inappropriate), and the syntax of the request entity is correct (thus a 400 (Bad Request) status code is inappropriate) but was unable to process the contained instructions."',spec_title:"RFC5218#10.3",spec_href:"http://tools.ietf.org/html/rfc2518#section-10.3"},{code:"423",phrase:"Locked",description:'"means the source or destination resource of a method is locked."',spec_title:"RFC5218#10.4",spec_href:"http://tools.ietf.org/html/rfc2518#section-10.4"},{code:"424",phrase:"Failed Dependency",description:'"means that the method could not be performed on the resource because the requested action depended on another action and that action failed."',spec_title:"RFC5218#10.5",spec_href:"http://tools.ietf.org/html/rfc2518#section-10.5"},{code:"428",phrase:"Precondition Required",description:'"indicates that the origin server requires the request to be conditional."',spec_title:"RFC6585#3",spec_href:"http://tools.ietf.org/html/rfc6585#section-3"},{code:"429",phrase:"Too Many Requests",description:'"indicates that the user has sent too many requests in a given amount of time ("rate limiting")."',spec_title:"RFC6585#4",spec_href:"http://tools.ietf.org/html/rfc6585#section-4"},{code:"431",phrase:"Request Header Fields Too Large",description:'"indicates that the server is unwilling to process the request because its header fields are too large."',spec_title:"RFC6585#5",spec_href:"http://tools.ietf.org/html/rfc6585#section-5"},{code:"451",phrase:"Unavailable For Legal Reasons",description:'"This status code indicates that the server is denying access to the resource in response to a legal demand."',spec_title:"draft-tbray-http-legally-restricted-status",spec_href:"http://tools.ietf.org/html/draft-tbray-http-legally-restricted-status"},{code:"506",phrase:"Variant Also Negotiates",description:'"indicates that the server has an internal configuration error: the chosen variant resource is configured to engage in transparent content negotiation itself, and is therefore not a proper end point in the negotiation process."',spec_title:"RFC2295#8.1",spec_href:"http://tools.ietf.org/html/rfc2295#section-8.1"},{code:"507",phrase:"Insufficient Storage",description:'"means the method could not be performed on the resource because the server is unable to store the representation needed to successfully complete the request."',spec_title:"RFC5218#10.6",spec_href:"http://tools.ietf.org/html/rfc2518#section-10.6"},{code:"511",phrase:"Network Authentication Required",description:'"indicates that the client needs to authenticate to gain network access."',spec_title:"RFC6585#6",spec_href:"http://tools.ietf.org/html/rfc6585#section-6"},{code:"7xx",phrase:"**Developer Error**",description:"[err](http://www.urbandictionary.com/define.php?term=err)",spec_title:"7xx-rfc",spec_href:"http://documentup.com/joho/7XX-rfc"}]},function(module,exports,__webpack_require__){module.exports=[{method:"CONNECT",description:'"requests that the recipient establish a tunnel to the destination origin server identified by the request-target and, if successful, thereafter restrict its behavior to blind forwarding of packets, in both directions, until the connection is closed."',safe:!0,idempotent:!0,cacheable:!1,spec_title:"RFC7231#4.3.6",spec_href:"http://tools.ietf.org/html/rfc7231#section-4.3.6"},{method:"DELETE",description:'"requests that the origin server remove the association between the target resource and its current functionality."',safe:!1,idempotent:!0,cacheable:!1,spec_title:"RFC7231#4.3.5",spec_href:"http://tools.ietf.org/html/rfc7231#section-4.3.5"},{method:"GET",description:'"requests transfer of a current selected representation for the target resource."',safe:!0,idempotent:!0,cacheable:!0,spec_title:"RFC7231#4.3.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-4.3.1"},{method:"HEAD",description:'"is identical to GET except that the server MUST NOT send a message body in the response (i.e., the response terminates at the end of the header block)."',safe:!0,idempotent:!0,cacheable:!0,spec_title:"RFC7231#4.3.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-4.3.2"},{method:"OPTIONS",description:'"requests information about the communication options available on the request/response chain identified by the effective request URI."',safe:!0,idempotent:!0,cacheable:!1,spec_title:"RFC7231#4.3.7",spec_href:"http://tools.ietf.org/html/rfc7231#section-4.3.7"},{method:"POST",description:'"requests that the target resource process the representation enclosed in the request according to the resource\'s own specific semantics."',safe:!1,idempotent:!1,cacheable:!1,spec_title:"RFC7231#4.3.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-4.3.3"},{method:"PUT",description:'"requests that the state of the target resource be created or replaced with the state defined by the representation enclosed in the request message payload."',safe:!1,idempotent:!0,cacheable:!1,spec_title:"RFC7231#4.3.4",spec_href:"http://tools.ietf.org/html/rfc7231#section-4.3.4"},{method:"TRACE",description:'"is used to invoke a remote, application-layer loopback of the request message."',safe:!0,idempotent:!0,cacheable:!1,spec_title:"RFC7231#4.3.8",spec_href:"http://tools.ietf.org/html/rfc7231#section-4.3.8"},{method:"ACL",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3744#8.1",spec_href:"http://tools.ietf.org/html/rfc3744#section-8.1"},{method:"BASELINE-CONTROL",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#12.6",spec_href:"http://tools.ietf.org/html/rfc3253#section-12.6"},{method:"BIND",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC5842#4",spec_href:"http://tools.ietf.org/html/rfc5842#section-4"},{method:"CHECKIN",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#4.4",spec_href:"http://tools.ietf.org/html/rfc3253#section-4.4"},{method:"CHECKOUT",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#4.3",spec_href:"http://tools.ietf.org/html/rfc3253#section-4.3"},{method:"COPY",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4918#9.8",spec_href:"http://tools.ietf.org/html/rfc4918#section-9.8"},{method:"LABEL",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#8.2",spec_href:"http://tools.ietf.org/html/rfc3253#section-8.2"},{method:"LINK",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC2068#19.6.1.2",spec_href:"http://tools.ietf.org/html/rfc2068#section-19.6.1.2"},{method:"LOCK",description:"",safe:!1,idempotent:!1,cacheable:"",spec_title:"RFC4918#9.10",spec_href:"http://tools.ietf.org/html/rfc4918#section-9.10"},{method:"MERGE",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#11.2",spec_href:"http://tools.ietf.org/html/rfc3253#section-11.2"},{method:"MKACTIVITY",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#13.5",spec_href:"http://tools.ietf.org/html/rfc3253#section-13.5"},{method:"MKCALENDAR",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4791#5.3.1",spec_href:"http://tools.ietf.org/html/rfc4791#section-5.3.1"},{method:"MKCOL",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4918#9.3",spec_href:"http://tools.ietf.org/html/rfc4918#section-9.3"},{method:"MKREDIRECTREF",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4437#6",spec_href:"http://tools.ietf.org/html/rfc4437#section-6"},{method:"MKWORKSPACE",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#6.3",spec_href:"http://tools.ietf.org/html/rfc3253#section-6.3"},{method:"MOVE",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4918#9.9",spec_href:"http://tools.ietf.org/html/rfc4918#section-9.9"},{method:"ORDERPATCH",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3648#7",spec_href:"http://tools.ietf.org/html/rfc3648#section-7"},{method:"PATCH",description:'"requests that a set of changes described in the request entity be applied to the resource identified by the Request-URI."',safe:!1,idempotent:!1,cacheable:!1,spec_title:"RFC5789",spec_href:"http://tools.ietf.org/html/rfc5789#section-2"},{method:"PROPFIND",description:"",safe:!0,idempotent:!0,cacheable:"",spec_title:"RFC4918#9.1",spec_href:"http://tools.ietf.org/html/rfc4918#section-9.1"},{method:"PROPPATCH",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4918#9.2",spec_href:"http://tools.ietf.org/html/rfc4918#section-9.2"},{method:"REBIND",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC5842#6",spec_href:"http://tools.ietf.org/html/rfc5842#section-6"},{method:"REPORT",description:"",safe:!0,idempotent:!0,cacheable:"",spec_title:"RFC3253#3.6",spec_href:"http://tools.ietf.org/html/rfc3253#section-3.6"},{method:"SEARCH",description:"",safe:!0,idempotent:!0,cacheable:"",spec_title:"RFC5323#2",spec_href:"http://tools.ietf.org/html/rfc5323#section-2"},{method:"UNBIND",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC5842#5",spec_href:"http://tools.ietf.org/html/rfc5842#section-5"},{method:"UNCHECKOUT",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#4.5",spec_href:"http://tools.ietf.org/html/rfc3253#section-4.5"},{method:"UNLINK",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC2068#19.6.1.3",spec_href:"http://tools.ietf.org/html/rfc2068#section-19.6.1.3"},{method:"UNLOCK",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4918#9.11",spec_href:"http://tools.ietf.org/html/rfc4918#section-9.11"},{method:"UPDATE",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#7.1",spec_href:"http://tools.ietf.org/html/rfc3253#section-7.1"},{method:"UPDATEREDIRECTREF",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC4437#7",spec_href:"http://tools.ietf.org/html/rfc4437#section-7"},{method:"VERSION-CONTROL",description:"",safe:!1,idempotent:!0,cacheable:"",spec_title:"RFC3253#3.5",spec_href:"http://tools.ietf.org/html/rfc3253#section-3.5"}]},function(module,exports,__webpack_require__){module.exports=[{header:"Content-Encoding",description:'"indicates what content codings have been applied to the representation, beyond those inherent in the media type, and thus what decoding mechanisms have to be applied in order to obtain data in the media type referenced by the Content-Type header field."',spec_title:"RFC7231#3.1.2.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-3.1.2.2"},{header:"Content-Language",description:'"describes the natural language(s) of the intended audience for the representation."',spec_title:"RFC7231#3.1.3.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-3.1.3.2"},{header:"Content-Location",description:'"references a URI that can be used as an identifier for a specific resource corresponding to the representation in this message\'s payload."',spec_title:"RFC7231#3.1.4.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-3.1.4.2"},{header:"Content-Type",description:'"indicates the media type of the associated representation: either the representation enclosed in the message payload or the selected representation, as determined by the message semantics."',spec_title:"RFC7231#3.1.1.5",spec_href:"http://tools.ietf.org/html/rfc7231#section-3.1.1.5"},{header:"Content-Length",description:'"can provide the anticipated size, as a decimal number of octets, for a potential payload body."',spec_title:"RFC7230#3.3.2",spec_href:"http://tools.ietf.org/html/rfc7230#section-3.3.2"},{header:"Content-Range",description:'"is sent in a single part 206 (Partial Content) response to indicate the partial range of the selected representation enclosed as the message payload, sent in each part of a multipart 206 response to indicate the range enclosed within each body part, and sent in 416 (Range Not Satisfiable) responses to provide information about the selected representation."',spec_title:"RFC7233#4.2",spec_href:"http://tools.ietf.org/html/rfc7233#section-4.2"},{header:"Transfer-Encoding",description:'"lists the transfer coding names corresponding to the sequence of transfer codings that have been (or will be) applied to the payload body in order to form the message body."',spec_title:"RFC7230#3.3.1",spec_href:"http://tools.ietf.org/html/rfc7230#section-3.3.1"},{header:"Cache-Control",description:'"is used to specify directives for caches along the request/response chain."',spec_title:"RFC7234#7.2",spec_href:"http://tools.ietf.org/html/rfc7234#section-7.2"},{header:"Expect",description:'"is used to indicate that particular server behaviors are required by the client."',spec_title:"RFC7231#5.1.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.1.1"},{header:"Host",description:'"provides the host and port information from the target URI, enabling the origin server to distinguish among resources while servicing requests for multiple host names on a single IP address."',spec_title:"RFC7230#5.4",spec_href:"http://tools.ietf.org/html/rfc7230#section-5.4"},{header:"Max-Forwards",description:'"provides a mechanism with the TRACE and OPTIONS methods to limit the number of times that the request is forwarded by proxies."',spec_title:"RFC7231#5.1.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.1.2"},{header:"Pragma",description:'"allows backwards compatibility with HTTP/1.0 caches, so that clients can specify a "no-cache" request that they will understand (as Cache-Control was not defined until HTTP/1.1)."',spec_title:"RFC7234#7.4",spec_href:"http://tools.ietf.org/html/rfc7234#section-7.4"},{header:"Range",description:'"modifies the method semantics to request transfer of only one or more subranges of the selected representation data, rather than the entire selected representation data."',spec_title:"RFC7233#3.1",spec_href:"http://tools.ietf.org/html/rfc7233#section-3.1"},{header:"TE",description:'"indicates what transfer codings, besides chunked, the client is willing to accept in response, and whether or not the client is willing to accept trailer fields in a chunked transfer coding."',spec_title:"RFC7230#4.3",spec_href:"http://tools.ietf.org/html/rfc7230#section-4.3"},{header:"If-Match",description:'"can be used to make a request method conditional on the current existence or value of an entity-tag for one or more representations of the target resource."',spec_title:"RFC7232#3.1",spec_href:"http://tools.ietf.org/html/rfc7232#section-3.1"},{header:"If-Modified-Since",description:'"can be used with GET or HEAD to make the method conditional by modification date: if the selected representation has not been modified since the time specified in this field, then do not perform the request method; instead, respond as detailed below."',spec_title:"RFC7232#3.3",spec_href:"http://tools.ietf.org/html/rfc7232#section-3.3"},{header:"If-None-Match",description:'"can be used to make a request method conditional on not matching any of the current entity-tag values for representations of the target resource."',spec_title:"RFC7232#3.2",spec_href:"http://tools.ietf.org/html/rfc7232#section-3.2"},{header:"If-Range",description:'"Informally, its meaning is: if the representation is unchanged, send me the part(s) that I am requesting in Range; otherwise, send me the entire representation."',spec_title:"RFC7233#3.2",spec_href:"http://tools.ietf.org/html/rfc7233#section-3.2"},{header:"If-Unmodified-Since",description:'"can be used to make a request method conditional by modification date: if the selected representation has been modified since the time specified in this field, then the server MUST NOT perform the requested operation and MUST instead respond with the 412 (Precondition Failed) status code."',spec_title:"RFC7232#3.4",spec_href:"http://tools.ietf.org/html/rfc7232#section-3.4"},{header:"Accept",description:'"can be used to specify certain media types which are acceptable for the response."',spec_title:"RFC7231#5.3.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.3.2"},{header:"Accept-Charset",description:'"can be sent by a user agent to indicate what charsets are acceptable in textual response content."',spec_title:"RFC7231#5.3.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.3.3"},{header:"Accept-Encoding",description:'"can be used by user agents to indicate what response content-codings are acceptable in the response."',spec_title:"RFC7231#5.3.4",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.3.4"},{header:"Accept-Language",description:'"can be used by user agents to indicate the set of natural languages that are preferred in the response."',spec_title:"RFC7231#5.3.5",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.3.5"},{header:"Authorization",description:'"allows a user agent to authenticate itself with a server -- usually, but not necessarily, after receiving a 401 (Unauthorized) response."',spec_title:"RFC7235#4.1",spec_href:"http://tools.ietf.org/html/rfc7235#section-4.1"},{header:"Proxy-Authorization",description:'"allows the client to identify itself (or its user) to a proxy that requires authentication."',spec_title:"RFC7235#4.3",spec_href:"http://tools.ietf.org/html/rfc7235#section-4.3"},{header:"DNT",description:'"defined as the means for expressing a user\'s tracking preference via HTTP."',spec_title:"Tracking Preference Expression (DNT)",spec_href:"http://www.w3.org/TR/tracking-dnt/#dnt-header-field"},{header:"From",description:'"contains an Internet email address for a human user who controls the requesting user agent."',spec_title:"RFC7231#5.5.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.5.1"},{header:"Referer",description:'"allows the user agent to specify a URI reference for the resource from which the target URI was obtained (i.e., the "referrer", though the field name is misspelled)."',spec_title:"RFC7231#5.5.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.5.2"},{header:"User-Agent",description:'"contains information about the user agent originating the request, which is often used by servers to help identify the scope of reported interoperability problems, to work around or tailor responses to avoid particular user agent limitations, and for analytics regarding browser or operating system use."',spec_title:"RFC7231#5.5.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-5.5.3"},{header:"Age",description:'"conveys the sender\'s estimate of the amount of time since the response was generated or successfully validated at the origin server."',spec_title:"RFC7234#5.1",spec_href:"http://tools.ietf.org/html/rfc7234#section-5.1"},{header:"Cache-Control",description:'"is used to specify directives for caches along the request/response chain."',spec_title:"RFC7234#7.2",spec_href:"http://tools.ietf.org/html/rfc7234#section-7.2"},{header:"Expires",description:'"gives the date/time after which the response is considered stale."',spec_title:"RFC7234#7.3",spec_href:"http://tools.ietf.org/html/rfc7234#section-7.3"},{header:"Date",description:'"represents the date and time at which the message was originated"',
spec_title:"RFC7231#7.1.1.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-7.1.1.2"},{header:"Location",description:'"is used in some responses to refer to a specific resource in relation to the response."',spec_title:"RFC7231#7.1.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-7.1.2"},{header:"Retry-After",description:'"indicates how long the user agent ought to wait before making a follow-up request."',spec_title:"RFC7231#7.1.3",spec_href:"http://tools.ietf.org/html/rfc7231#section-7.1.3"},{header:"Tk",description:'"defined as an OPTIONAL means for indicating the tracking status that applied to the corresponding request and as a REQUIRED means for indicating that a state-changing request has resulted in an interactive change to the tracking status. "',spec_title:"Tracking Preference Expression (DNT)",spec_href:"http://www.w3.org/TR/tracking-dnt/#response-header-field"},{header:"Vary",description:'"describes what parts of a request message, aside from the method and request target, might influence the origin server\'s process for selecting and representing the response."',spec_title:"RFC7231#7.1.4",spec_href:"http://tools.ietf.org/html/rfc7231#section-7.1.4"},{header:"Warning",description:'"is used to carry additional information about the status or transformation of a message that might not be reflected in the message."',spec_title:"RFC7234#7.6",spec_href:"http://tools.ietf.org/html/rfc7234#section-7.6"},{header:"ETag",description:'"provides the current entity-tag for the selected representation, as determined at the conclusion of handling the request."',spec_title:"RFC7232#2.3",spec_href:"http://tools.ietf.org/html/rfc7232#section-2.3"},{header:"Last-Modified",description:'"provides a timestamp indicating the date and time at which the origin server believes the selected representation was last modified, as determined at the conclusion of handling the request."',spec_title:"RFC7232#2.2",spec_href:"http://tools.ietf.org/html/rfc7232#section-2.2"},{header:"WWW-Authenticate",description:'"consists of at least one challenge that indicates the authentication scheme(s) and parameters applicable to the effective request URI."',spec_title:"RFC7235#4.4",spec_href:"http://tools.ietf.org/html/rfc7235#section-4.4"},{header:"Proxy-Authenticate",description:'"consists of at least one challenge that indicates the authentication scheme(s) and parameters applicable to the proxy for this effective request URI."',spec_title:"RFC7235#4.2",spec_href:"http://tools.ietf.org/html/rfc7235#section-4.2"},{header:"Accept-Ranges",description:'"allows a server to indicate that it supports range requests for the target resource."',spec_title:"RFC7233#2.3",spec_href:"http://tools.ietf.org/html/rfc7233#section-2.3"},{header:"Allow",description:'"lists the set of methods advertised as supported by the target resource."',spec_title:"RFC7231#7.4.1",spec_href:"http://tools.ietf.org/html/rfc7231#section-7.4.1"},{header:"Server",description:'"contains information about the software used by the origin server to handle the request, which is often used by clients to help identify the scope of reported interoperability problems, to work around or tailor requests to avoid particular server limitations, and for analytics regarding server or operating system use."',spec_title:"RFC7231#7.4.2",spec_href:"http://tools.ietf.org/html/rfc7231#section-7.4.2"},{header:"Accept-Patch",description:'"used to specify the patch document formats accepted by the server."',spec_title:"RFC5789#3.1",spec_href:"http://tools.ietf.org/html/rfc5789#section-3.1"},{header:"Accept-Post",description:'"indicates server support for specific media types for entity bodies in HTTP POST requests."',spec_title:"draft-wilde-accept-post",spec_href:"http://tools.ietf.org/html/draft-wilde-accept-post"},{header:"Access-Control-Allow-Credentials",description:'"indicates whether the response to request can be exposed when the omit credentials flag is unset"',spec_title:"CORS",spec_href:"http://www.w3.org/TR/cors/#access-control-allow-credentials-response-header"},{header:"Access-Control-Allow-Headers",description:'"indicates, as part of the response to a preflight request, which header field names can be used during the actual request"',spec_title:"CORS",spec_href:"http://www.w3.org/TR/cors/#access-control-allow-headers-response-header"},{header:"Access-Control-Allow-Methods",description:'"indicates, as part of the response to a preflight request, which methods can be used during the actual request"',spec_title:"CORS",spec_href:"http://www.w3.org/TR/cors/#access-control-allow-methods-response-header"},{header:"Access-Control-Allow-Origin",description:'"indicates whether a resource can be shared"',spec_title:"CORS",spec_href:"http://www.w3.org/TR/cors/#access-control-allow-origin-response-header"},{header:"Access-Control-Expose-Headers",description:'"indicates which headers are safe to expose to the API of a CORS API specification"',spec_title:"CORS",spec_href:"http://www.w3.org/TR/cors/#access-control-expose-headers-response-header"},{header:"Access-Control-Max-Age",description:'"indicates how long the results of a preflight request can be cached in a preflight result cache"',spec_title:"CORS",spec_href:"http://www.w3.org/TR/cors/#access-control-max-age-response-header"},{header:"Access-Control-Request-Headers",description:'"indicates which headers will be used in the actual request as part of the preflight request"',spec_title:"CORS",spec_href:"http://www.w3.org/TR/cors/#access-control-request-headers-request-header"},{header:"Access-Control-Request-Method",description:'"indicates which method will be used in the actual request as part of the preflight request"',spec_title:"CORS",spec_href:"http://www.w3.org/TR/cors/#access-control-request-method-request-header"},{header:"Content-Disposition",description:'"standard"',spec_title:"RFC6266",spec_href:"http://tools.ietf.org/html/rfc6266"},{header:"Content-Security-Policy",description:'"is the preferred mechanism for delivering a CSP policy"',spec_title:"CSP",spec_href:"http://www.w3.org/TR/CSP/#content-security-policy-header-field"},{header:"Content-Security-Policy-Report-Only",description:'"lets servers experiment with policies by monitoring (rather than enforcing) a policy"',spec_title:"CSP",spec_href:"http://www.w3.org/TR/CSP/#content-security-policy-report-only-header-field"},{header:"Cookie",description:'"standard"',spec_title:"RFC6265",spec_href:"http://tools.ietf.org/html/rfc6265"},{header:"Forwarded",description:'"standard"',spec_title:"RFC7239",spec_href:"http://tools.ietf.org/html/rfc7239"},{header:"Link",description:'"provides a means for serialising one or more links in HTTP headers."',spec_title:"RFC5988#5",spec_href:"http://tools.ietf.org/html/rfc5988#section-5"},{header:"Origin",description:'"standard"',spec_title:"RFC6454",spec_href:"http://tools.ietf.org/html/rfc6454"},{header:"Prefer",description:'"is used to indicate that particular server behaviors are preferred by the client, but not required for successful completion of the request."',spec_title:"draft-snell-http-prefer#2",spec_href:"http://tools.ietf.org/html/draft-snell-http-prefer#section-2"},{header:"Preference-Applied",description:'"MAY be included within a response message as an indication as to which Prefer tokens were honored by the server and applied to the processing of a request."',spec_title:"draft-snell-http-prefer#3",spec_href:"http://tools.ietf.org/html/draft-snell-http-prefer#section-3"},{header:"Set-Cookie",description:'"standard"',spec_title:"RFC6265",spec_href:"http://tools.ietf.org/html/rfc6265"},{header:"Strict-Transport-Security",description:'"standard"',spec_title:"RFC6797",spec_href:"http://tools.ietf.org/html/rfc6797"},{header:"Via",description:'""',spec_title:"RFC7230#5.7.1",spec_href:"http://tools.ietf.org/html/rfc7230#section-5.7.1"},{header:"A-IM",description:'""',spec_title:"RFC3229#10.5.3",spec_href:"http://tools.ietf.org/html/rfc3229#section-10.5.3"},{header:"Accept-Features",description:'"can be used by a user agent to give information about the presence or absence of certain features in the feature set of the current request."',spec_title:"RFC2295#8.2",spec_href:"http://tools.ietf.org/html/rfc2295#section-8.2"},{header:"Alt-Svc",description:'"is advertising the availability of alternate services to HTTP/1.1 and HTTP/2.0 clients by adding an Alt-Svc header field to responses."',spec_title:"draft-nottingham-httpbis-alt-svc",spec_href:"http://tools.ietf.org/html/draft-nottingham-httpbis-alt-svc"},{header:"Alternates",description:'"is used to convey the list of variants bound to a negotiable resource."',spec_title:"RFC2295#8.3",spec_href:"http://tools.ietf.org/html/rfc2295#section-8.3"},{header:"Apply-To-Redirect-Ref",description:'""',spec_title:"RFC4437",spec_href:"http://tools.ietf.org/html/rfc4437"},{header:"CH",description:'"describes an example list of client preferences that the server can use to adapt and optimize the resource to satisfy a given request."',spec_title:"draft-grigorik-http-client-hints",spec_href:"http://tools.ietf.org/html/draft-grigorik-http-client-hints"},{header:"Content-Base",description:'"obsoleted"',spec_title:"RFC2068",spec_href:"http://tools.ietf.org/html/rfc2068"},{header:"Cookie2",description:'"obsoleted"',spec_title:"RFC2965",spec_href:"http://tools.ietf.org/html/rfc2965"},{header:"DASL",description:'"standard"',spec_title:"RFC5323",spec_href:"http://tools.ietf.org/html/rfc5323"},{header:"DAV",description:'"standard"',spec_title:"RFC4918",spec_href:"http://tools.ietf.org/html/rfc4918"},{header:"Delta-Base",description:'""',spec_title:"RFC3229#10.5.1",spec_href:"http://tools.ietf.org/html/rfc3229#section-10.5.1"},{header:"Depth",description:'"standard"',spec_title:"RFC4918",spec_href:"http://tools.ietf.org/html/rfc4918"},{header:"Destination",description:'"standard"',spec_title:"RFC4918",spec_href:"http://tools.ietf.org/html/rfc4918"},{header:"IM",description:'""',spec_title:"RFC3229#10.5.2",spec_href:"http://tools.ietf.org/html/rfc3229#section-10.5.2"},{header:"If",description:'"standard"',spec_title:"RFC4918",spec_href:"http://tools.ietf.org/html/rfc4918"},{header:"If-Schedule-Tag-Match",description:'"standard"',spec_title:"RFC6638",spec_href:"http://tools.ietf.org/html/rfc6638"},{header:"Last-Event-ID",description:'"The value of the event source\'s last event ID string, encoded as UTF-8."',spec_title:"Server-Sent Events",spec_href:"http://www.w3.org/TR/eventsource/#last-event-id"},{header:"Link-Template",description:'"provides a means for serialising one or more links into HTTP headers."',spec_title:"draft-nottingham-link-template",spec_href:"http://tools.ietf.org/html/draft-nottingham-link-template"},{header:"Lock-Token",description:'"standard"',spec_title:"RFC4918",spec_href:"http://tools.ietf.org/html/rfc4918"},{header:"Negotiate",description:'"can contain directives for any content negotiation process initiated by the request."',spec_title:"RFC2295#8.4",spec_href:"http://tools.ietf.org/html/rfc2295#section-8.4"},{header:"Nice",description:'"indicates that a request is less important than a request that doesn\'t bear this header."',spec_title:"draft-thomson-http-nice",spec_href:"http://tools.ietf.org/html/draft-thomson-http-nice"},{header:"Overwrite",description:'"standard"',spec_title:"RFC4918",spec_href:"http://tools.ietf.org/html/rfc4918"},{header:"Redirect-Ref",description:'""',spec_title:"RFC4437",spec_href:"http://tools.ietf.org/html/rfc4437"},{header:"Schedule-Reply",description:'"standard"',spec_title:"RFC6638",spec_href:"http://tools.ietf.org/html/rfc6638"},{header:"Schedule-Tag",description:'"standard"',spec_title:"RFC6638",spec_href:"http://tools.ietf.org/html/rfc6638"},{header:"Sec-WebSocket-Accept",description:'"standard"',spec_title:"RFC6455",spec_href:"http://tools.ietf.org/html/rfc6455"},{header:"Sec-WebSocket-Extensions",description:'"standard"',spec_title:"RFC6455",spec_href:"http://tools.ietf.org/html/rfc6455"},{header:"Sec-WebSocket-Key",description:'"standard"',spec_title:"RFC6455",spec_href:"http://tools.ietf.org/html/rfc6455"},{header:"Sec-WebSocket-Protocol",description:'"standard"',spec_title:"RFC6455",spec_href:"http://tools.ietf.org/html/rfc6455"},{header:"Sec-WebSocket-Version",description:'"standard"',spec_title:"RFC6455",spec_href:"http://tools.ietf.org/html/rfc6455"},{header:"Set-Cookie2",description:'"obsoleted"',spec_title:"RFC2965",spec_href:"http://tools.ietf.org/html/rfc2965"},{header:"SLUG",description:'"standard"',spec_title:"RFC5023",spec_href:"http://tools.ietf.org/html/rfc5023"},{header:"TCN",description:'"is used by a server to signal that the resource is transparently negotiated."',spec_title:"RFC2295#8.5",spec_href:"http://tools.ietf.org/html/rfc2295#section-8.5"},{header:"Timeout",description:'"standard"',spec_title:"RFC4918",spec_href:"http://tools.ietf.org/html/rfc4918"},{header:"Variant-Vary",description:'"can be used in a choice response to record any vary information which applies to the variant data (the entity body combined with some of the entity headers) contained in the response, rather than to the response as a whole."',spec_title:"RFC2295#8.6",spec_href:"http://tools.ietf.org/html/rfc2295#section-8.6"},{header:"X-Frame-Options",description:'"indicates a policy that specifies whether the browser should render the transmitted resource within a <frame> or an <iframe>. Servers can declare this policy in the header of their HTTP responses to prevent clickjacking attacks, which ensures that their content is not embedded into other pages or frames."',spec_title:"RFC7034",spec_href:"http://tools.ietf.org/html/rfc7034"}]},function(module,exports,__webpack_require__){module.exports=[{relation:"about",description:'"Refers to a resource that is the subject of the link\'s context."',spec_title:"RFC6903",spec_href:"http://tools.ietf.org/html/rfc6903"},{relation:"alternate",description:'"Refers to a substitute for this context"',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-alternate"},{relation:"appendix",description:'"Refers to an appendix."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"archives",description:'"Refers to a collection of records, documents, or other materials of historical interest."',spec_title:"HTML5linksWD",spec_href:"http://www.w3.org/TR/2011/WD-html5-20110113/links.html#rel-archives"},{relation:"author",description:'"Refers to the context\'s author."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-author"},{relation:"bookmark",description:'"Gives a permanent link to use for bookmarking purposes."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-bookmark"},{relation:"canonical",description:'"Designates the preferred version of a resource (the IRI and its contents)."',spec_title:"RFC6596",spec_href:"http://tools.ietf.org/html/rfc6596"},{relation:"chapter",description:'"Refers to a chapter in a collection of resources."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"collection",description:'"The target IRI points to a resource which represents the collection resource for the context IRI."',spec_title:"RFC6573",spec_href:"http://tools.ietf.org/html/rfc6573"},{relation:"contents",description:'"Refers to a table of contents."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"copyright",description:'"Refers to a copyright statement that applies to the link\'s context."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"create-form",description:'"The target IRI points to a resource where a submission form can be obtained."',spec_title:"RFC6861",spec_href:"http://tools.ietf.org/html/rfc6861"},{relation:"current",description:'"Refers to a resource containing the most recent item(s) in a collection of resources."',spec_title:"RFC5005",spec_href:"http://tools.ietf.org/html/rfc5005"},{relation:"describedby",description:'"Refers to a resource providing information about the link\'s context."',spec_title:"POWDER",spec_href:"http://www.w3.org/TR/powder-dr/#assoc-linking"},{relation:"describes",description:"\"The relationship A 'describes' B asserts that resource A provides a description of resource B. There are no constraints on the format or representation of either A or B, neither are there any further constraints on either resource.\"",spec_title:"RFC6892",spec_href:"http://tools.ietf.org/html/rfc6892"},{relation:"disclosure",description:'"Refers to a list of patent disclosures made with respect to material for which `disclosure` relation is specified."',spec_title:"RFC6579",spec_href:"http://tools.ietf.org/html/rfc6579"},{relation:"duplicate",description:'"Refers to a resource whose available representations are byte-for-byte identical with the corresponding representations of the context IRI."',spec_title:"RFC6249",spec_href:"http://tools.ietf.org/html/rfc6249"},{relation:"edit",description:'"Refers to a resource that can be used to edit the link\'s context."',spec_title:"RFC5023",spec_href:"http://tools.ietf.org/html/rfc5023"},{relation:"edit-form",description:'"The target IRI points to a resource where a submission form for editing associated resource can be obtained."',spec_title:"RFC6861",spec_href:"http://tools.ietf.org/html/rfc6861"},{relation:"edit-media",description:'"Refers to a resource that can be used to edit media associated with the link\'s context."',spec_title:"RFC5023",spec_href:"http://tools.ietf.org/html/rfc5023"},{relation:"enclosure",description:'"Identifies a related resource that is potentially large and might require special handling."',spec_title:"RFC4287",spec_href:"http://tools.ietf.org/html/rfc4287"},{relation:"first",description:'"An IRI that refers to the furthest preceding resource in a series of resources."',spec_title:"RFC5988",spec_href:"http://tools.ietf.org/html/rfc5988"},{relation:"glossary",description:'"Refers to a glossary of terms."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"help",description:'"Refers to context-sensitive help."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-help"},{relation:"hosts",description:'"Refers to a resource hosted by the server indicated by the link context."',spec_title:"RFC6690",spec_href:"http://tools.ietf.org/html/rfc6690"},{relation:"hub",description:'"Refers to a hub that enables registration for notification of updates to the context."',spec_title:"pubsubhubbub",spec_href:"http://pubsubhubbub.googlecode.com"},{relation:"icon",description:'"Refers to an icon representing the link\'s context."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-icon"},{relation:"index",description:'"Refers to an index."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"item",description:'"The target IRI points to a resource that is a member of the collection represented by the context IRI."',spec_title:"RFC6573",spec_href:"http://tools.ietf.org/html/rfc6573"},{relation:"last",description:'"An IRI that refers to the furthest following resource in a series of resources."',spec_title:"RFC5988",spec_href:"http://tools.ietf.org/html/rfc5988"},{relation:"latest-version",description:'"Points to a resource containing the latest (e.g., current) version of the context."',spec_title:"RFC5829",spec_href:"http://tools.ietf.org/html/rfc5829"},{relation:"license",description:'"Refers to a license associated with this context."',spec_title:"RFC4946",spec_href:"http://tools.ietf.org/html/rfc4946"},{relation:"lrdd",description:'"Refers to further information about the link\'s context, expressed as a LRDD (Link-based Resource Descriptor Document) resource. See [RFC6415](http://tools.ietf.org/html/rfc6415) for information about processing this relation type in host-meta documents. When used elsewhere, it refers to additional links and other metadata. Multiple instances indicate additional LRDD resources. LRDD resources MUST have an "application/xrd+xml" representation, and MAY have others."',spec_title:"RFC6415",spec_href:"http://tools.ietf.org/html/rfc6415"},{relation:"monitor",description:'"Refers to a resource that can be used to monitor changes in an HTTP resource."',spec_title:"RFC5989",spec_href:"http://tools.ietf.org/html/rfc5989"},{relation:"monitor-group",description:'"Refers to a resource that can be used to monitor changes in a specified group of HTTP resources."',spec_title:"RFC5989",spec_href:"http://tools.ietf.org/html/rfc5989"},{relation:"next",description:'"Indicates that the link\'s context is a part of a series, and that the next in the series is the link target."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-next"},{relation:"next-archive",description:'"Refers to the immediately following archive resource."',spec_title:"RFC5005",spec_href:"http://tools.ietf.org/html/rfc5005"},{relation:"nofollow",description:'"Indicates that the context’s original author or publisher does not endorse the link target."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-nofollow"},{relation:"noreferrer",description:'"Indicates that no referrer information is to be leaked when following the link."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-noreferrer"},{relation:"payment",description:'"Indicates a resource where payment is accepted."',spec_title:"RFC5988",spec_href:"http://tools.ietf.org/html/rfc5988"},{relation:"predecessor-version",description:'"Points to a resource containing the predecessor version in the version history."',spec_title:"RFC5829",spec_href:"http://tools.ietf.org/html/rfc5829"},{relation:"prefetch",description:'"Indicates that the link target should be preemptively cached."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-prefetch"},{relation:"prev",description:'"Indicates that the link\'s context is a part of a series, and that the previous in the series is the link target."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-prev"},{relation:"preview",description:'"Refers to a resource that provides a preview of the link\'s context."',spec_title:"RFC6903",spec_href:"http://tools.ietf.org/html/rfc6903"},{relation:"previous",description:'"Refers to the previous resource in an ordered series of resources. Synonym for `prev`."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"prev-archive",description:'"Refers to the immediately preceding archive resource."',spec_title:"RFC5005",spec_href:"http://tools.ietf.org/html/rfc5005"},{relation:"privacy-policy",description:'"Refers to a privacy policy associated with the link\'s context."',spec_title:"RFC6903",spec_href:"http://tools.ietf.org/html/rfc6903"},{relation:"profile",description:"Identifying that a resource representation conforms to a certain profile, without affecting the non-profile semantics of the resource representation",spec_title:"RFC6906",spec_href:"http://tools.ietf.org/html/rfc6906"},{relation:"related",description:'"Identifies a related resource."',spec_title:"RFC4287",spec_href:"http://tools.ietf.org/html/rfc4287"},{relation:"replies",description:'"Identifies a resource that is a reply to the context of the link."',spec_title:"RFC4685",spec_href:"http://tools.ietf.org/html/rfc4685"},{relation:"search",description:'"Refers to a resource that can be used to search through the link\'s context and related resources."',spec_title:"OpenSearch",spec_href:"http://www.opensearch.org/Specifications/OpenSearch/1.1"},{relation:"section",description:'"Refers to a section in a collection of resources."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"self",description:'"Conveys an identifier for the link\'s context."',spec_title:"RFC4287",spec_href:"http://tools.ietf.org/html/rfc4287"},{relation:"service",description:'"Indicates a URI that can be used to retrieve a service document."',spec_title:"RFC5023",spec_href:"http://tools.ietf.org/html/rfc5023"},{relation:"start",description:'"Refers to the first resource in a collection of resources."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"stylesheet",description:'"Refers to a stylesheet."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-stylesheet"},{relation:"subsection",description:'"Refers to a resource serving as a subsection in a collection of resources."',spec_title:"HTML401",spec_href:"http://www.w3.org/TR/1999/REC-html401-19991224"},{relation:"successor-version",description:'"Points to a resource containing the successor version in the version history."',spec_title:"RFC5829",spec_href:"http://tools.ietf.org/html/rfc5829"},{relation:"tag",description:'"Gives a tag (identified by the given address) that applies to the current document."',spec_title:"HTML5links",spec_href:"http://www.w3.org/TR/html5/links.html#link-type-tag"},{relation:"terms-of-service",description:'"Refers to the terms of service associated with the link\'s context."',spec_title:"RFC6903",spec_href:"http://tools.ietf.org/html/rfc6903"},{relation:"type",description:'"Refers to a resource identifying the abstract semantic type of which the link\'s context is considered to be an instance."',spec_title:"RFC6903",spec_href:"http://tools.ietf.org/html/rfc6903"},{relation:"up",description:'"Refers to a parent document in a hierarchy of documents."',spec_title:"RFC5988",spec_href:"http://tools.ietf.org/html/rfc5988"},{relation:"version-history",description:'"Points to a resource containing the version history for the context."',spec_title:"RFC5829",spec_href:"http://tools.ietf.org/html/rfc5829"},{relation:"via",description:'"Identifies a resource that is the source of the information in the link\'s context."',spec_title:"RFC4287",spec_href:"http://tools.ietf.org/html/rfc4287"},{relation:"working-copy",description:'"Points to a working copy for this resource."',spec_title:"RFC5829",spec_href:"http://tools.ietf.org/html/rfc5829"},{relation:"working-copy-of",description:'"Points to the versioned resource from which this working copy was obtained."',spec_title:"RFC5829",spec_href:"http://tools.ietf.org/html/rfc5829"}]},function(module,exports,__webpack_require__){},function(module,exports,__webpack_require__){var lookup="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";!function(exports){"use strict";function decode(elt){var code=elt.charCodeAt(0);return code===PLUS||code===PLUS_URL_SAFE?62:code===SLASH||code===SLASH_URL_SAFE?63:NUMBER>code?-1:NUMBER+10>code?code-NUMBER+26+26:UPPER+26>code?code-UPPER:LOWER+26>code?code-LOWER+26:void 0}function b64ToByteArray(b64){function push(v){arr[L++]=v}var i,j,l,tmp,placeHolders,arr;if(b64.length%4>0)throw new Error("Invalid string. Length must be a multiple of 4");var len=b64.length;placeHolders="="===b64.charAt(len-2)?2:"="===b64.charAt(len-1)?1:0,arr=new Arr(3*b64.length/4-placeHolders),l=placeHolders>0?b64.length-4:b64.length;var L=0;for(i=0,j=0;l>i;i+=4,j+=3)tmp=decode(b64.charAt(i))<<18|decode(b64.charAt(i+1))<<12|decode(b64.charAt(i+2))<<6|decode(b64.charAt(i+3)),push((16711680&tmp)>>16),push((65280&tmp)>>8),push(255&tmp);return 2===placeHolders?(tmp=decode(b64.charAt(i))<<2|decode(b64.charAt(i+1))>>4,push(255&tmp)):1===placeHolders&&(tmp=decode(b64.charAt(i))<<10|decode(b64.charAt(i+1))<<4|decode(b64.charAt(i+2))>>2,push(tmp>>8&255),push(255&tmp)),arr}function uint8ToBase64(uint8){function encode(num){return lookup.charAt(num)}function tripletToBase64(num){return encode(num>>18&63)+encode(num>>12&63)+encode(num>>6&63)+encode(63&num)}var i,temp,length,extraBytes=uint8.length%3,output="";for(i=0,length=uint8.length-extraBytes;length>i;i+=3)temp=(uint8[i]<<16)+(uint8[i+1]<<8)+uint8[i+2],output+=tripletToBase64(temp);switch(extraBytes){case 1:temp=uint8[uint8.length-1],output+=encode(temp>>2),output+=encode(temp<<4&63),output+="==";break;case 2:temp=(uint8[uint8.length-2]<<8)+uint8[uint8.length-1],output+=encode(temp>>10),output+=encode(temp>>4&63),output+=encode(temp<<2&63),output+="="}return output}var Arr="undefined"!=typeof Uint8Array?Uint8Array:Array,PLUS="+".charCodeAt(0),SLASH="/".charCodeAt(0),NUMBER="0".charCodeAt(0),LOWER="a".charCodeAt(0),UPPER="A".charCodeAt(0),PLUS_URL_SAFE="-".charCodeAt(0),SLASH_URL_SAFE="_".charCodeAt(0);exports.toByteArray=b64ToByteArray,exports.fromByteArray=uint8ToBase64}("undefined"==typeof exports?this.base64js={}:exports)},function(module,exports,__webpack_require__){var indexOf=[].indexOf;module.exports=function(arr,obj){if(indexOf)return arr.indexOf(obj);for(var i=0;i<arr.length;++i)if(arr[i]===obj)return i;return-1}},function(module,exports,__webpack_require__){"use strict";function compileStyleAliases(map){var result={};return null!==map&&Object.keys(map).forEach(function(style){map[style].forEach(function(alias){result[String(alias)]=style})}),result}function Type(tag,options){if(options=options||{},Object.keys(options).forEach(function(name){if(-1===TYPE_CONSTRUCTOR_OPTIONS.indexOf(name))throw new YAMLException('Unknown option "'+name+'" is met in definition of "'+tag+'" YAML type.')}),this.tag=tag,this.kind=options.kind||null,this.resolve=options.resolve||function(){return!0},this.construct=options.construct||function(data){return data},this.instanceOf=options.instanceOf||null,this.predicate=options.predicate||null,this.represent=options.represent||null,this.defaultStyle=options.defaultStyle||null,this.styleAliases=compileStyleAliases(options.styleAliases||null),-1===YAML_NODE_KINDS.indexOf(this.kind))throw new YAMLException('Unknown kind "'+this.kind+'" is specified for "'+tag+'" YAML type.')}var YAMLException=__webpack_require__(113),TYPE_CONSTRUCTOR_OPTIONS=["kind","resolve","construct","instanceOf","predicate","represent","defaultStyle","styleAliases"],YAML_NODE_KINDS=["scalar","sequence","mapping"];module.exports=Type},function(module,exports,__webpack_require__){"use strict";var Schema=__webpack_require__(153);module.exports=new Schema({include:[__webpack_require__(206)],implicit:[__webpack_require__(207),__webpack_require__(208),__webpack_require__(209),__webpack_require__(210)]})},function(module,exports,__webpack_require__){"use strict";function noop(){}function getThen(obj){try{return obj.then}catch(ex){return LAST_ERROR=ex,IS_ERROR}}function tryCallOne(fn,a){try{return fn(a)}catch(ex){return LAST_ERROR=ex,IS_ERROR}}function tryCallTwo(fn,a,b){try{fn(a,b)}catch(ex){return LAST_ERROR=ex,IS_ERROR}}function Promise(fn){if("object"!=typeof this)throw new TypeError("Promises must be constructed via new");if("function"!=typeof fn)throw new TypeError("not a function");this._45=0,this._81=0,this._65=null,this._54=null,fn!==noop&&doResolve(fn,this)}function safeThen(self,onFulfilled,onRejected){return new self.constructor(function(resolve,reject){var res=new Promise(noop);res.then(resolve,reject),handle(self,new Handler(onFulfilled,onRejected,res))})}function handle(self,deferred){for(;3===self._81;)self=self._65;return Promise._10&&Promise._10(self),0===self._81?0===self._45?(self._45=1,void(self._54=deferred)):1===self._45?(self._45=2,void(self._54=[self._54,deferred])):void self._54.push(deferred):void handleResolved(self,deferred)}function handleResolved(self,deferred){asap(function(){var cb=1===self._81?deferred.onFulfilled:deferred.onRejected;if(null===cb)return void(1===self._81?resolve(deferred.promise,self._65):reject(deferred.promise,self._65));var ret=tryCallOne(cb,self._65);ret===IS_ERROR?reject(deferred.promise,LAST_ERROR):resolve(deferred.promise,ret)})}function resolve(self,newValue){if(newValue===self)return reject(self,new TypeError("A promise cannot be resolved with itself."));if(newValue&&("object"==typeof newValue||"function"==typeof newValue)){
var then=getThen(newValue);if(then===IS_ERROR)return reject(self,LAST_ERROR);if(then===self.then&&newValue instanceof Promise)return self._81=3,self._65=newValue,void finale(self);if("function"==typeof then)return void doResolve(then.bind(newValue),self)}self._81=1,self._65=newValue,finale(self)}function reject(self,newValue){self._81=2,self._65=newValue,Promise._97&&Promise._97(self,newValue),finale(self)}function finale(self){if(1===self._45&&(handle(self,self._54),self._54=null),2===self._45){for(var i=0;i<self._54.length;i++)handle(self,self._54[i]);self._54=null}}function Handler(onFulfilled,onRejected,promise){this.onFulfilled="function"==typeof onFulfilled?onFulfilled:null,this.onRejected="function"==typeof onRejected?onRejected:null,this.promise=promise}function doResolve(fn,promise){var done=!1,res=tryCallTwo(fn,function(value){done||(done=!0,resolve(promise,value))},function(reason){done||(done=!0,reject(promise,reason))});done||res!==IS_ERROR||(done=!0,reject(promise,LAST_ERROR))}var asap=__webpack_require__(238),LAST_ERROR=null,IS_ERROR={};module.exports=Promise,Promise._10=null,Promise._97=null,Promise._61=noop,Promise.prototype.then=function(onFulfilled,onRejected){if(this.constructor!==Promise)return safeThen(this,onFulfilled,onRejected);var res=new Promise(noop);return handle(this,new Handler(onFulfilled,onRejected,res)),res}},function(module,exports,__webpack_require__){"use strict";var Promise=__webpack_require__(189);module.exports=Promise,Promise.prototype.done=function(onFulfilled,onRejected){var self=arguments.length?this.then.apply(this,arguments):this;self.then(null,function(err){setTimeout(function(){throw err},0)})}},function(module,exports,__webpack_require__){"use strict";var Promise=__webpack_require__(189);module.exports=Promise,Promise.prototype["finally"]=function(f){return this.then(function(value){return Promise.resolve(f()).then(function(){return value})},function(err){return Promise.resolve(f()).then(function(){throw err})})}},function(module,exports,__webpack_require__){"use strict";function valuePromise(value){var p=new Promise(Promise._61);return p._81=1,p._65=value,p}var Promise=__webpack_require__(189);module.exports=Promise;var TRUE=valuePromise(!0),FALSE=valuePromise(!1),NULL=valuePromise(null),UNDEFINED=valuePromise(void 0),ZERO=valuePromise(0),EMPTYSTRING=valuePromise("");Promise.resolve=function(value){if(value instanceof Promise)return value;if(null===value)return NULL;if(void 0===value)return UNDEFINED;if(value===!0)return TRUE;if(value===!1)return FALSE;if(0===value)return ZERO;if(""===value)return EMPTYSTRING;if("object"==typeof value||"function"==typeof value)try{var then=value.then;if("function"==typeof then)return new Promise(then.bind(value))}catch(ex){return new Promise(function(resolve,reject){reject(ex)})}return valuePromise(value)},Promise.all=function(arr){var args=Array.prototype.slice.call(arr);return new Promise(function(resolve,reject){function res(i,val){if(val&&("object"==typeof val||"function"==typeof val)){if(val instanceof Promise&&val.then===Promise.prototype.then){for(;3===val._81;)val=val._65;return 1===val._81?res(i,val._65):(2===val._81&&reject(val._65),void val.then(function(val){res(i,val)},reject))}var then=val.then;if("function"==typeof then){var p=new Promise(then.bind(val));return void p.then(function(val){res(i,val)},reject)}}args[i]=val,0===--remaining&&resolve(args)}if(0===args.length)return resolve([]);for(var remaining=args.length,i=0;i<args.length;i++)res(i,args[i])})},Promise.reject=function(value){return new Promise(function(resolve,reject){reject(value)})},Promise.race=function(values){return new Promise(function(resolve,reject){values.forEach(function(value){Promise.resolve(value).then(resolve,reject)})})},Promise.prototype["catch"]=function(onRejected){return this.then(null,onRejected)}},function(module,exports,__webpack_require__){"use strict";function denodeifyWithCount(fn,argumentCount){for(var args=[],i=0;argumentCount>i;i++)args.push("a"+i);var body=["return function ("+args.join(",")+") {","var self = this;","return new Promise(function (rs, rj) {","var res = fn.call(",["self"].concat(args).concat([callbackFn]).join(","),");","if (res &&",'(typeof res === "object" || typeof res === "function") &&','typeof res.then === "function"',") {rs(res);}","});","};"].join("");return Function(["Promise","fn"],body)(Promise,fn)}function denodeifyWithoutCount(fn){for(var fnLength=Math.max(fn.length-1,3),args=[],i=0;fnLength>i;i++)args.push("a"+i);var body=["return function ("+args.join(",")+") {","var self = this;","var args;","var argLength = arguments.length;","if (arguments.length > "+fnLength+") {","args = new Array(arguments.length + 1);","for (var i = 0; i < arguments.length; i++) {","args[i] = arguments[i];","}","}","return new Promise(function (rs, rj) {","var cb = "+callbackFn+";","var res;","switch (argLength) {",args.concat(["extra"]).map(function(_,index){return"case "+index+":res = fn.call("+["self"].concat(args.slice(0,index)).concat("cb").join(",")+");break;"}).join(""),"default:","args[argLength] = cb;","res = fn.apply(self, args);","}","if (res &&",'(typeof res === "object" || typeof res === "function") &&','typeof res.then === "function"',") {rs(res);}","});","};"].join("");return Function(["Promise","fn"],body)(Promise,fn)}var Promise=__webpack_require__(189),asap=__webpack_require__(239);module.exports=Promise,Promise.denodeify=function(fn,argumentCount){return"number"==typeof argumentCount&&argumentCount!==1/0?denodeifyWithCount(fn,argumentCount):denodeifyWithoutCount(fn)};var callbackFn="function (err, res) {if (err) { rj(err); } else { rs(res); }}";Promise.nodeify=function(fn){return function(){var args=Array.prototype.slice.call(arguments),callback="function"==typeof args[args.length-1]?args.pop():null,ctx=this;try{return fn.apply(this,arguments).nodeify(callback,ctx)}catch(ex){if(null===callback||"undefined"==typeof callback)return new Promise(function(resolve,reject){reject(ex)});asap(function(){callback.call(ctx,ex)})}}},Promise.prototype.nodeify=function(callback,ctx){return"function"!=typeof callback?this:void this.then(function(value){asap(function(){callback.call(ctx,null,value)})},function(err){asap(function(){callback.call(ctx,err)})})}},function(module,exports,__webpack_require__){"use strict";var Promise=__webpack_require__(189);module.exports=Promise,Promise.enableSynchronous=function(){Promise.prototype.isPending=function(){return 0==this.getState()},Promise.prototype.isFulfilled=function(){return 1==this.getState()},Promise.prototype.isRejected=function(){return 2==this.getState()},Promise.prototype.getValue=function(){if(3===this._81)return this._65.getValue();if(!this.isFulfilled())throw new Error("Cannot get a value of an unfulfilled promise.");return this._65},Promise.prototype.getReason=function(){if(3===this._81)return this._65.getReason();if(!this.isRejected())throw new Error("Cannot get a rejection reason of a non-rejected promise.");return this._65},Promise.prototype.getState=function(){return 3===this._81?this._65.getState():-1===this._81||-2===this._81?0:this._81}},Promise.disableSynchronous=function(){Promise.prototype.isPending=void 0,Promise.prototype.isFulfilled=void 0,Promise.prototype.isRejected=void 0,Promise.prototype.getValue=void 0,Promise.prototype.getReason=void 0,Promise.prototype.getState=void 0}},function(module,exports,__webpack_require__){"use strict";var Utils=__webpack_require__(212),internals={delimiter:"&",arrayPrefixGenerators:{brackets:function(prefix){return prefix+"[]"},indices:function(prefix,key){return prefix+"["+key+"]"},repeat:function(prefix){return prefix}},strictNullHandling:!1,skipNulls:!1,encode:!0};internals.stringify=function(object,prefix,generateArrayPrefix,strictNullHandling,skipNulls,encode,filter,sort,allowDots){var obj=object;if("function"==typeof filter)obj=filter(prefix,obj);else if(Utils.isBuffer(obj))obj=String(obj);else if(obj instanceof Date)obj=obj.toISOString();else if(null===obj){if(strictNullHandling)return encode?Utils.encode(prefix):prefix;obj=""}if("string"==typeof obj||"number"==typeof obj||"boolean"==typeof obj)return encode?[Utils.encode(prefix)+"="+Utils.encode(obj)]:[prefix+"="+obj];var values=[];if("undefined"==typeof obj)return values;var objKeys;if(Array.isArray(filter))objKeys=filter;else{var keys=Object.keys(obj);objKeys=sort?keys.sort(sort):keys}for(var i=0;i<objKeys.length;++i){var key=objKeys[i];skipNulls&&null===obj[key]||(values=Array.isArray(obj)?values.concat(internals.stringify(obj[key],generateArrayPrefix(prefix,key),generateArrayPrefix,strictNullHandling,skipNulls,encode,filter,sort,allowDots)):values.concat(internals.stringify(obj[key],prefix+(allowDots?"."+key:"["+key+"]"),generateArrayPrefix,strictNullHandling,skipNulls,encode,filter,sort,allowDots)))}return values},module.exports=function(object,opts){var objKeys,filter,obj=object,options=opts||{},delimiter="undefined"==typeof options.delimiter?internals.delimiter:options.delimiter,strictNullHandling="boolean"==typeof options.strictNullHandling?options.strictNullHandling:internals.strictNullHandling,skipNulls="boolean"==typeof options.skipNulls?options.skipNulls:internals.skipNulls,encode="boolean"==typeof options.encode?options.encode:internals.encode,sort="function"==typeof options.sort?options.sort:null,allowDots="undefined"==typeof options.allowDots?!1:options.allowDots;"function"==typeof options.filter?(filter=options.filter,obj=filter("",obj)):Array.isArray(options.filter)&&(objKeys=filter=options.filter);var keys=[];if("object"!=typeof obj||null===obj)return"";var arrayFormat;arrayFormat=options.arrayFormat in internals.arrayPrefixGenerators?options.arrayFormat:"indices"in options?options.indices?"indices":"repeat":"indices";var generateArrayPrefix=internals.arrayPrefixGenerators[arrayFormat];objKeys||(objKeys=Object.keys(obj)),sort&&objKeys.sort(sort);for(var i=0;i<objKeys.length;++i){var key=objKeys[i];skipNulls&&null===obj[key]||(keys=keys.concat(internals.stringify(obj[key],key,generateArrayPrefix,strictNullHandling,skipNulls,encode,filter,sort,allowDots)))}return keys.join(delimiter)}},function(module,exports,__webpack_require__){"use strict";var Utils=__webpack_require__(212),internals={delimiter:"&",depth:5,arrayLimit:20,parameterLimit:1e3,strictNullHandling:!1,plainObjects:!1,allowPrototypes:!1,allowDots:!1};internals.parseValues=function(str,options){for(var obj={},parts=str.split(options.delimiter,options.parameterLimit===1/0?void 0:options.parameterLimit),i=0;i<parts.length;++i){var part=parts[i],pos=-1===part.indexOf("]=")?part.indexOf("="):part.indexOf("]=")+1;if(-1===pos)obj[Utils.decode(part)]="",options.strictNullHandling&&(obj[Utils.decode(part)]=null);else{var key=Utils.decode(part.slice(0,pos)),val=Utils.decode(part.slice(pos+1));Object.prototype.hasOwnProperty.call(obj,key)?obj[key]=[].concat(obj[key]).concat(val):obj[key]=val}}return obj},internals.parseObject=function(chain,val,options){if(!chain.length)return val;var obj,root=chain.shift();if("[]"===root)obj=[],obj=obj.concat(internals.parseObject(chain,val,options));else{obj=options.plainObjects?Object.create(null):{};var cleanRoot="["===root[0]&&"]"===root[root.length-1]?root.slice(1,root.length-1):root,index=parseInt(cleanRoot,10);!isNaN(index)&&root!==cleanRoot&&String(index)===cleanRoot&&index>=0&&options.parseArrays&&index<=options.arrayLimit?(obj=[],obj[index]=internals.parseObject(chain,val,options)):obj[cleanRoot]=internals.parseObject(chain,val,options)}return obj},internals.parseKeys=function(givenKey,val,options){if(givenKey){var key=options.allowDots?givenKey.replace(/\.([^\.\[]+)/g,"[$1]"):givenKey,parent=/^([^\[\]]*)/,child=/(\[[^\[\]]*\])/g,segment=parent.exec(key),keys=[];if(segment[1]){if(!options.plainObjects&&Object.prototype.hasOwnProperty(segment[1])&&!options.allowPrototypes)return;keys.push(segment[1])}for(var i=0;null!==(segment=child.exec(key))&&i<options.depth;)i+=1,(options.plainObjects||!Object.prototype.hasOwnProperty(segment[1].replace(/\[|\]/g,""))||options.allowPrototypes)&&keys.push(segment[1]);return segment&&keys.push("["+key.slice(segment.index)+"]"),internals.parseObject(keys,val,options)}},module.exports=function(str,opts){var options=opts||{};if(options.delimiter="string"==typeof options.delimiter||Utils.isRegExp(options.delimiter)?options.delimiter:internals.delimiter,options.depth="number"==typeof options.depth?options.depth:internals.depth,options.arrayLimit="number"==typeof options.arrayLimit?options.arrayLimit:internals.arrayLimit,options.parseArrays=options.parseArrays!==!1,options.allowDots="boolean"==typeof options.allowDots?options.allowDots:internals.allowDots,options.plainObjects="boolean"==typeof options.plainObjects?options.plainObjects:internals.plainObjects,options.allowPrototypes="boolean"==typeof options.allowPrototypes?options.allowPrototypes:internals.allowPrototypes,options.parameterLimit="number"==typeof options.parameterLimit?options.parameterLimit:internals.parameterLimit,options.strictNullHandling="boolean"==typeof options.strictNullHandling?options.strictNullHandling:internals.strictNullHandling,""===str||null===str||"undefined"==typeof str)return options.plainObjects?Object.create(null):{};for(var tempObj="string"==typeof str?internals.parseValues(str,options):str,obj=options.plainObjects?Object.create(null):{},keys=Object.keys(tempObj),i=0;i<keys.length;++i){var key=keys[i],newObj=internals.parseKeys(key,tempObj[key],options);obj=Utils.merge(obj,newObj,options)}return Utils.compact(obj)}},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var date={},lang="en",locales={en:{MMMM:["January","February","March","April","May","June","July","August","September","October","November","December"],MMM:["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"],dddd:["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],ddd:["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],dd:["Su","Mo","Tu","We","Th","Fr","Sa"],A:["a.m.","p.m."],formats:{YYYY:function(d){return("000"+d.getFullYear()).slice(-4)},YY:function(d){return("0"+d.getFullYear()).slice(-2)},Y:function(d){return""+d.getFullYear()},MMMM:function(d){return this.MMMM[d.getMonth()]},MMM:function(d){return this.MMM[d.getMonth()]},MM:function(d){return("0"+(d.getMonth()+1)).slice(-2)},M:function(d){return""+(d.getMonth()+1)},DD:function(d){return("0"+d.getDate()).slice(-2)},D:function(d){return""+d.getDate()},HH:function(d){return("0"+d.getHours()).slice(-2)},H:function(d){return""+d.getHours()},A:function(d){return this.A[d.getHours()>11|0]},hh:function(d){return("0"+(d.getHours()%12||12)).slice(-2)},h:function(d){return""+(d.getHours()%12||12)},mm:function(d){return("0"+d.getMinutes()).slice(-2)},m:function(d){return""+d.getMinutes()},ss:function(d){return("0"+d.getSeconds()).slice(-2)},s:function(d){return""+d.getSeconds()},SSS:function(d){return("00"+d.getMilliseconds()).slice(-3)},SS:function(d){return("0"+(d.getMilliseconds()/10|0)).slice(-2)},S:function(d){return""+(d.getMilliseconds()/100|0)},dddd:function(d){return this.dddd[d.getDay()]},ddd:function(d){return this.ddd[d.getDay()]},dd:function(d){return this.dd[d.getDay()]},Z:function(d){var offset=d.utc?0:d.getTimezoneOffset()/.6;return(offset>0?"-":"+")+("000"+Math.abs(offset-offset%100*.4)).slice(-4)},post:function(str){return str}},parsers:{h:function(h,a){return(12===h?0:h)+12*a},pre:function(str){return str}}}},isCommonJS=function(){return"object"==typeof module&&"object"==typeof module.exports},forEach=function(array,fn){for(var i=0,len=array.length;len>i&&0!==fn(array[i],i);i++);},parse=function(dateString,formatString){var k,length,str,offset=0,keys=formatString.match(/YYYY|YY|MMM?M?|DD|HH|hh|mm|ss|SSS?|./g),dt={Y:0,M:1,D:1,A:0,H:0,h:0,m:0,s:0,S:0};return dateString=locales[lang].parsers.pre(dateString),forEach(keys,function(key){k=key.charAt(0),length=key.length,str=dateString.slice(offset),/^(MM|DD|HH|hh|mm|ss|SS?S?)$/.test(key)?dt[k]=0|str.slice(0,length):/^(YYYY|YY|M|D|H|h|m|s)$/.test(key)?(str=(str.match(4===length?/^\d{1,4}/:/^\d\d?/)||[""])[0],length=str.length,dt[k]=0|str,"Y"===k&&dt.Y<70&&(dt.Y+=2e3)):/^(MMMM?|A)$/.test(key)&&forEach(locales[lang][key],function(val,i){return str.indexOf(val)?void 0:(dt[k]="M"===k?i+1:i,length=val.length,0)}),offset+=length}),dt},toH=function(h,a){return locales[lang].parsers.h(h,a)};date.format=function(dateObj,formatString,utc){var d=new Date(dateObj.getTime()+(utc?6e4*dateObj.getTimezoneOffset():0)),locale=locales[lang],formats=locale.formats;return d.utc=utc,formatString.replace(/(\[[^\[\]]*]|\[.*\][^\[]*\]|YYYY|YY|MMM?M?|DD|HH|hh|mm|ss|SSS?|ddd?d?|.)/g,function(token){var format=formats[token];return format?formats.post(format.call(locale,d)):token.replace(/\[(.*)]/,"$1")})},date.parse=function(dateString,formatString,utc){var dt=parse(dateString,formatString),dateObj=new Date(dt.Y,dt.M-1,dt.D,dt.H||toH(dt.h,dt.A),dt.m,dt.s,dt.S);return utc?new Date(dateObj.getTime()-6e4*dateObj.getTimezoneOffset()):dateObj},date.isValid=function(dateString,formatString){var dt=parse(dateString,formatString),H=dt.H||toH(dt.h,dt.A),d=new Date(dt.Y,dt.M-1,dt.D,H,dt.m,dt.s,dt.S);return dt.Y===d.getFullYear()&&dt.M-1===d.getMonth()&&dt.D===d.getDate()&&H===d.getHours()&&dt.m===d.getMinutes()&&dt.s===d.getSeconds()&&dt.S===d.getMilliseconds()},date.addYears=function(dateObj,years){var d=new Date(dateObj.getTime());return d.setFullYear(d.getFullYear()+years),d},date.addMonths=function(dateObj,months){var d=new Date(dateObj.getTime());return d.setMonth(d.getMonth()+months),d},date.addDays=function(dateObj,days){return new Date(dateObj.getTime()+864e5*days)},date.addHours=function(dateObj,hours){return new Date(dateObj.getTime()+36e5*hours)},date.addMinutes=function(dateObj,minutes){return new Date(dateObj.getTime()+6e4*minutes)},date.addSeconds=function(dateObj,seconds){return new Date(dateObj.getTime()+1e3*seconds)},date.addMilliseconds=function(dateObj,milliseconds){return new Date(dateObj.getTime()+milliseconds)},date.subtract=function(date1,date2){var delta=date1.getTime()-date2.getTime();return{toMilliseconds:function(){return delta},toSeconds:function(){return delta/1e3|0},toMinutes:function(){return delta/6e4|0},toHours:function(){return delta/36e5|0},toDays:function(){return delta/864e5|0}}},date.isLeapYear=function(dateObj){var y=dateObj.getFullYear();return!((y%4||!(y%100))&&y%400)},date.locale=function(code){return code&&("en"!==code&&isCommonJS()&&__webpack_require__(213)("./"+code),lang=code),lang},date.getLocales=function(code){return locales[code||lang]},date.setLocales=function(code,options){var copy=function(src,proto){var dst,key,Locale=function(){};Locale.prototype=proto,dst=new Locale;for(key in src)src.hasOwnProperty(key)&&(dst[key]=src[key]);return dst},base=locales[code]||locales.en,locale=copy(options,base);options.formats&&(locale.formats=copy(options.formats,base.formats)),options.parsers&&(locale.parsers=copy(options.parsers,base.parsers)),locales[code]=locale},isCommonJS()?module.exports=date:(__WEBPACK_AMD_DEFINE_ARRAY__=[],__WEBPACK_AMD_DEFINE_RESULT__=function(){return date}.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__),!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){function XMLReader(){}function parse(source,defaultNSMapCopy,entityMap,domBuilder,errorHandler){function fixedFromCharCode(code){if(code>65535){code-=65536;var surrogate1=55296+(code>>10),surrogate2=56320+(1023&code);return String.fromCharCode(surrogate1,surrogate2)}return String.fromCharCode(code)}function entityReplacer(a){var k=a.slice(1,-1);return k in entityMap?entityMap[k]:"#"===k.charAt(0)?fixedFromCharCode(parseInt(k.substr(1).replace("x","0x"))):(errorHandler.error("entity not found:"+a),a)}function appendText(end){if(end>start){var xt=source.substring(start,end).replace(/&#?\w+;/g,entityReplacer);locator&&position(start),domBuilder.characters(xt,0,end-start),start=end}}function position(p,m){for(;p>=lineEnd&&(m=linePattern.exec(source));)lineStart=m.index,lineEnd=lineStart+m[0].length,locator.lineNumber++;locator.columnNumber=p-lineStart+1}for(var lineStart=0,lineEnd=0,linePattern=/.+(?:\r\n?|\n)|.*$/g,locator=domBuilder.locator,parseStack=[{currentNSMap:defaultNSMapCopy}],closeMap={},start=0;;){try{var tagStart=source.indexOf("<",start);if(0>tagStart){if(!source.substr(start).match(/^\s*$/)){var doc=domBuilder.document,text=doc.createTextNode(source.substr(start));doc.appendChild(text),domBuilder.currentElement=text}return}switch(tagStart>start&&appendText(tagStart),source.charAt(tagStart+1)){case"/":var end=source.indexOf(">",tagStart+3),tagName=source.substring(tagStart+2,end),config=parseStack.pop(),localNSMap=config.localNSMap;if(config.tagName!=tagName&&errorHandler.fatalError("end tag name: "+tagName+" is not match the current start tagName:"+config.tagName),domBuilder.endElement(config.uri,config.localName,tagName),localNSMap)for(var prefix in localNSMap)domBuilder.endPrefixMapping(prefix);end++;break;case"?":locator&&position(tagStart),end=parseInstruction(source,tagStart,domBuilder);break;case"!":locator&&position(tagStart),end=parseDCC(source,tagStart,domBuilder,errorHandler);break;default:locator&&position(tagStart);var el=new ElementAttributes,end=parseElementStartPart(source,tagStart,el,entityReplacer,errorHandler),len=el.length;if(locator){if(len)for(var i=0;len>i;i++){var a=el[i];position(a.offset),a.offset=copyLocator(locator,{})}position(end)}!el.closed&&fixSelfClosed(source,end,el.tagName,closeMap)&&(el.closed=!0,entityMap.nbsp||errorHandler.warning("unclosed xml attribute")),appendElement(el,domBuilder,parseStack),"http://www.w3.org/1999/xhtml"!==el.uri||el.closed?end++:end=parseHtmlSpecialContent(source,end,el.tagName,entityReplacer,domBuilder)}}catch(e){errorHandler.error("element parse error: "+e),end=-1}end>start?start=end:appendText(Math.max(tagStart,start)+1)}}function copyLocator(f,t){return t.lineNumber=f.lineNumber,t.columnNumber=f.columnNumber,t}function parseElementStartPart(source,start,el,entityReplacer,errorHandler){for(var attrName,value,p=++start,s=S_TAG;;){var c=source.charAt(p);switch(c){case"=":if(s===S_ATTR)attrName=source.slice(start,p),s=S_EQ;else{if(s!==S_ATTR_S)throw new Error("attribute equal must after attrName");s=S_EQ}break;case"'":case'"':if(s===S_EQ){if(start=p+1,p=source.indexOf(c,start),!(p>0))throw new Error("attribute value no end '"+c+"' match");value=source.slice(start,p).replace(/&#?\w+;/g,entityReplacer),el.add(attrName,value,start-1),s=S_E}else{if(s!=S_V)throw new Error('attribute value must after "="');value=source.slice(start,p).replace(/&#?\w+;/g,entityReplacer),el.add(attrName,value,start),errorHandler.warning('attribute "'+attrName+'" missed start quot('+c+")!!"),start=p+1,s=S_E}break;case"/":switch(s){case S_TAG:el.setTagName(source.slice(start,p));case S_E:case S_S:case S_C:s=S_C,el.closed=!0;case S_V:case S_ATTR:case S_ATTR_S:break;default:throw new Error("attribute invalid close char('/')")}break;case"":errorHandler.error("unexpected end of input");case">":switch(s){case S_TAG:el.setTagName(source.slice(start,p));case S_E:case S_S:case S_C:break;case S_V:case S_ATTR:value=source.slice(start,p),"/"===value.slice(-1)&&(el.closed=!0,value=value.slice(0,-1));case S_ATTR_S:s===S_ATTR_S&&(value=attrName),s==S_V?(errorHandler.warning('attribute "'+value+'" missed quot(")!!'),el.add(attrName,value.replace(/&#?\w+;/g,entityReplacer),start)):(errorHandler.warning('attribute "'+value+'" missed value!! "'+value+'" instead!!'),el.add(value,value,start));break;case S_EQ:throw new Error("attribute value missed!!")}return p;case"":c=" ";default:if(" ">=c)switch(s){case S_TAG:el.setTagName(source.slice(start,p)),s=S_S;break;case S_ATTR:attrName=source.slice(start,p),s=S_ATTR_S;break;case S_V:var value=source.slice(start,p).replace(/&#?\w+;/g,entityReplacer);errorHandler.warning('attribute "'+value+'" missed quot(")!!'),el.add(attrName,value,start);case S_E:s=S_S}else switch(s){case S_ATTR_S:errorHandler.warning('attribute "'+attrName+'" missed value!! "'+attrName+'" instead!!'),el.add(attrName,attrName,start),start=p,s=S_ATTR;break;case S_E:errorHandler.warning('attribute space is required"'+attrName+'"!!');case S_S:s=S_ATTR,start=p;break;case S_EQ:s=S_V,start=p;break;case S_C:throw new Error("elements closed character '/' and '>' must be connected to")}}p++}}function appendElement(el,domBuilder,parseStack){for(var tagName=el.tagName,localNSMap=null,currentNSMap=parseStack[parseStack.length-1].currentNSMap,i=el.length;i--;){var a=el[i],qName=a.qName,value=a.value,nsp=qName.indexOf(":");if(nsp>0)var prefix=a.prefix=qName.slice(0,nsp),localName=qName.slice(nsp+1),nsPrefix="xmlns"===prefix&&localName;else localName=qName,prefix=null,nsPrefix="xmlns"===qName&&"";a.localName=localName,nsPrefix!==!1&&(null==localNSMap&&(localNSMap={},_copy(currentNSMap,currentNSMap={})),currentNSMap[nsPrefix]=localNSMap[nsPrefix]=value,a.uri="http://www.w3.org/2000/xmlns/",domBuilder.startPrefixMapping(nsPrefix,value))}for(var i=el.length;i--;){a=el[i];var prefix=a.prefix;prefix&&("xml"===prefix&&(a.uri="http://www.w3.org/XML/1998/namespace"),"xmlns"!==prefix&&(a.uri=currentNSMap[prefix]))}var nsp=tagName.indexOf(":");nsp>0?(prefix=el.prefix=tagName.slice(0,nsp),localName=el.localName=tagName.slice(nsp+1)):(prefix=null,localName=el.localName=tagName);var ns=el.uri=currentNSMap[prefix||""];if(domBuilder.startElement(ns,localName,tagName,el),el.closed){if(domBuilder.endElement(ns,localName,tagName),localNSMap)for(prefix in localNSMap)domBuilder.endPrefixMapping(prefix)}else el.currentNSMap=currentNSMap,el.localNSMap=localNSMap,parseStack.push(el)}function parseHtmlSpecialContent(source,elStartEnd,tagName,entityReplacer,domBuilder){if(/^(?:script|textarea)$/i.test(tagName)){var elEndStart=source.indexOf("</"+tagName+">",elStartEnd),text=source.substring(elStartEnd+1,elEndStart);if(/[&<]/.test(text))return/^script$/i.test(tagName)?(domBuilder.characters(text,0,text.length),elEndStart):(text=text.replace(/&#?\w+;/g,entityReplacer),domBuilder.characters(text,0,text.length),elEndStart)}return elStartEnd+1}function fixSelfClosed(source,elStartEnd,tagName,closeMap){var pos=closeMap[tagName];return null==pos&&(pos=closeMap[tagName]=source.lastIndexOf("</"+tagName+">")),elStartEnd>pos}function _copy(source,target){for(var n in source)target[n]=source[n]}function parseDCC(source,start,domBuilder,errorHandler){var next=source.charAt(start+2);switch(next){case"-":if("-"===source.charAt(start+3)){var end=source.indexOf("-->",start+4);return end>start?(domBuilder.comment(source,start+4,end-start-4),end+3):(errorHandler.error("Unclosed comment"),-1)}return-1;default:if("CDATA["==source.substr(start+3,6)){var end=source.indexOf("]]>",start+9);return domBuilder.startCDATA(),domBuilder.characters(source,start+9,end-start-9),domBuilder.endCDATA(),end+3}var matchs=split(source,start),len=matchs.length;if(len>1&&/!doctype/i.test(matchs[0][0])){var name=matchs[1][0],pubid=len>3&&/^public$/i.test(matchs[2][0])&&matchs[3][0],sysid=len>4&&matchs[4][0],lastMatch=matchs[len-1];return domBuilder.startDTD(name,pubid&&pubid.replace(/^(['"])(.*?)\1$/,"$2"),sysid&&sysid.replace(/^(['"])(.*?)\1$/,"$2")),domBuilder.endDTD(),lastMatch.index+lastMatch[0].length}}return-1}function parseInstruction(source,start,domBuilder){var end=source.indexOf("?>",start);if(end){var match=source.substring(start,end).match(/^<\?(\S*)\s*([\s\S]*?)\s*$/);if(match){match[0].length;return domBuilder.processingInstruction(match[1],match[2]),end+2}return-1}return-1}function ElementAttributes(source){}function _set_proto_(thiz,parent){return thiz.__proto__=parent,thiz}function split(source,start){var match,buf=[],reg=/'[^']+'|"[^"]+"|[^\s<>\/=]+=?|(\/?\s*>|<)/g;for(reg.lastIndex=start,reg.exec(source);match=reg.exec(source);)if(buf.push(match),match[1])return buf}var nameStartChar=/[A-Z_a-z\xC0-\xD6\xD8-\xF6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/,nameChar=new RegExp("[\\-\\.0-9"+nameStartChar.source.slice(1,-1)+"·̀-ͯ\\u203F-⁀]"),tagNamePattern=new RegExp("^"+nameStartChar.source+nameChar.source+"*(?::"+nameStartChar.source+nameChar.source+"*)?$"),S_TAG=0,S_ATTR=1,S_ATTR_S=2,S_EQ=3,S_V=4,S_E=5,S_S=6,S_C=7;XMLReader.prototype={parse:function(source,defaultNSMap,entityMap){var domBuilder=this.domBuilder;domBuilder.startDocument(),_copy(defaultNSMap,defaultNSMap={}),parse(source,defaultNSMap,entityMap,domBuilder,this.errorHandler),domBuilder.endDocument()}},ElementAttributes.prototype={setTagName:function(tagName){if(!tagNamePattern.test(tagName))throw new Error("invalid tagName:"+tagName);this.tagName=tagName},add:function(qName,value,offset){if(!tagNamePattern.test(qName))throw new Error("invalid attribute:"+qName);this[this.length++]={qName:qName,value:value,offset:offset}},length:0,getLocalName:function(i){return this[i].localName},getOffset:function(i){return this[i].offset},getQName:function(i){return this[i].qName},getURI:function(i){return this[i].uri},getValue:function(i){return this[i].value}},_set_proto_({},_set_proto_.prototype)instanceof _set_proto_||(_set_proto_=function(thiz,parent){function p(){}p.prototype=parent,p=new p;for(parent in thiz)p[parent]=thiz[parent];return p}),exports.XMLReader=XMLReader},function(module,exports,__webpack_require__){function copy(src,dest){for(var p in src)dest[p]=src[p]}function _extends(Class,Super){function t(){}var pt=Class.prototype;if(Object.create){var ppt=Object.create(Super.prototype);pt.__proto__=ppt}pt instanceof Super||(t.prototype=Super.prototype,t=new t,copy(pt,t),Class.prototype=pt=t),pt.constructor!=Class&&("function"!=typeof Class&&console.error("unknow Class:"+Class),pt.constructor=Class)}function DOMException(code,message){if(message instanceof Error)var error=message;else error=this,Error.call(this,ExceptionMessage[code]),this.message=ExceptionMessage[code],Error.captureStackTrace&&Error.captureStackTrace(this,DOMException);return error.code=code,message&&(this.message=this.message+": "+message),error}function NodeList(){}function LiveNodeList(node,refresh){this._node=node,this._refresh=refresh,_updateLiveList(this)}function _updateLiveList(list){var inc=list._node._inc||list._node.ownerDocument._inc;if(list._inc!=inc){var ls=list._refresh(list._node);__set__(list,"length",ls.length),copy(ls,list),list._inc=inc}}function NamedNodeMap(){}function _findNodeIndex(list,node){for(var i=list.length;i--;)if(list[i]===node)return i}function _addNamedNode(el,list,newAttr,oldAttr){if(oldAttr?list[_findNodeIndex(list,oldAttr)]=newAttr:list[list.length++]=newAttr,el){newAttr.ownerElement=el;var doc=el.ownerDocument;doc&&(oldAttr&&_onRemoveAttribute(doc,el,oldAttr),_onAddAttribute(doc,el,newAttr))}}function _removeNamedNode(el,list,attr){var i=_findNodeIndex(list,attr);if(!(i>=0))throw DOMException(NOT_FOUND_ERR,new Error);for(var lastIndex=list.length-1;lastIndex>i;)list[i]=list[++i];if(list.length=lastIndex,el){var doc=el.ownerDocument;doc&&(_onRemoveAttribute(doc,el,attr),attr.ownerElement=null)}}function DOMImplementation(features){if(this._features={},features)for(var feature in features)this._features=features[feature]}function Node(){}function _xmlEncoder(c){return"<"==c&&"&lt;"||">"==c&&"&gt;"||"&"==c&&"&amp;"||'"'==c&&"&quot;"||"&#"+c.charCodeAt()+";"}function _visitNode(node,callback){if(callback(node))return!0;if(node=node.firstChild)do if(_visitNode(node,callback))return!0;while(node=node.nextSibling)}function Document(){}function _onAddAttribute(doc,el,newAttr){doc&&doc._inc++;var ns=newAttr.namespaceURI;"http://www.w3.org/2000/xmlns/"==ns&&(el._nsMap[newAttr.prefix?newAttr.localName:""]=newAttr.value)}function _onRemoveAttribute(doc,el,newAttr,remove){doc&&doc._inc++;var ns=newAttr.namespaceURI;"http://www.w3.org/2000/xmlns/"==ns&&delete el._nsMap[newAttr.prefix?newAttr.localName:""];
}function _onUpdateChild(doc,el,newChild){if(doc&&doc._inc){doc._inc++;var cs=el.childNodes;if(newChild)cs[cs.length++]=newChild;else{for(var child=el.firstChild,i=0;child;)cs[i++]=child,child=child.nextSibling;cs.length=i}}}function _removeChild(parentNode,child){var previous=child.previousSibling,next=child.nextSibling;return previous?previous.nextSibling=next:parentNode.firstChild=next,next?next.previousSibling=previous:parentNode.lastChild=previous,_onUpdateChild(parentNode.ownerDocument,parentNode),child}function _insertBefore(parentNode,newChild,nextChild){var cp=newChild.parentNode;if(cp&&cp.removeChild(newChild),newChild.nodeType===DOCUMENT_FRAGMENT_NODE){var newFirst=newChild.firstChild;if(null==newFirst)return newChild;var newLast=newChild.lastChild}else newFirst=newLast=newChild;var pre=nextChild?nextChild.previousSibling:parentNode.lastChild;newFirst.previousSibling=pre,newLast.nextSibling=nextChild,pre?pre.nextSibling=newFirst:parentNode.firstChild=newFirst,null==nextChild?parentNode.lastChild=newLast:nextChild.previousSibling=newLast;do newFirst.parentNode=parentNode;while(newFirst!==newLast&&(newFirst=newFirst.nextSibling));return _onUpdateChild(parentNode.ownerDocument||parentNode,parentNode),newChild.nodeType==DOCUMENT_FRAGMENT_NODE&&(newChild.firstChild=newChild.lastChild=null),newChild}function _appendSingleChild(parentNode,newChild){var cp=newChild.parentNode;if(cp){var pre=parentNode.lastChild;cp.removeChild(newChild);var pre=parentNode.lastChild}var pre=parentNode.lastChild;return newChild.parentNode=parentNode,newChild.previousSibling=pre,newChild.nextSibling=null,pre?pre.nextSibling=newChild:parentNode.firstChild=newChild,parentNode.lastChild=newChild,_onUpdateChild(parentNode.ownerDocument,parentNode,newChild),newChild}function Element(){this._nsMap={}}function Attr(){}function CharacterData(){}function Text(){}function Comment(){}function CDATASection(){}function DocumentType(){}function Notation(){}function Entity(){}function EntityReference(){}function DocumentFragment(){}function ProcessingInstruction(){}function XMLSerializer(){}function serializeToString(node,buf,attributeSorter,isHTML){switch(node.nodeType){case ELEMENT_NODE:var attrs=node.attributes,len=attrs.length,child=node.firstChild,nodeName=node.tagName;isHTML=htmlns===node.namespaceURI||isHTML,buf.push("<",nodeName),attributeSorter&&buf.sort.apply(attrs,attributeSorter);for(var i=0;len>i;i++)serializeToString(attrs.item(i),buf,attributeSorter,isHTML);if(child||isHTML&&!/^(?:meta|link|img|br|hr|input|button)$/i.test(nodeName)){if(buf.push(">"),isHTML&&/^script$/i.test(nodeName))child&&buf.push(child.data);else for(;child;)serializeToString(child,buf,attributeSorter,isHTML),child=child.nextSibling;buf.push("</",nodeName,">")}else buf.push("/>");return;case DOCUMENT_NODE:case DOCUMENT_FRAGMENT_NODE:for(var child=node.firstChild;child;)serializeToString(child,buf,attributeSorter,isHTML),child=child.nextSibling;return;case ATTRIBUTE_NODE:return buf.push(" ",node.name,'="',node.value.replace(/[<&"]/g,_xmlEncoder),'"');case TEXT_NODE:return buf.push(node.data.replace(/[<&]/g,_xmlEncoder));case CDATA_SECTION_NODE:return buf.push("<![CDATA[",node.data,"]]>");case COMMENT_NODE:return buf.push("<!--",node.data,"-->");case DOCUMENT_TYPE_NODE:var pubid=node.publicId,sysid=node.systemId;if(buf.push("<!DOCTYPE ",node.name),pubid)buf.push(' PUBLIC "',pubid),sysid&&"."!=sysid&&buf.push('" "',sysid),buf.push('">');else if(sysid&&"."!=sysid)buf.push(' SYSTEM "',sysid,'">');else{var sub=node.internalSubset;sub&&buf.push(" [",sub,"]"),buf.push(">")}return;case PROCESSING_INSTRUCTION_NODE:return buf.push("<?",node.target," ",node.data,"?>");case ENTITY_REFERENCE_NODE:return buf.push("&",node.nodeName,";");default:buf.push("??",node.nodeName)}}function importNode(doc,node,deep){var node2;switch(node.nodeType){case ELEMENT_NODE:node2=node.cloneNode(!1),node2.ownerDocument=doc;case DOCUMENT_FRAGMENT_NODE:break;case ATTRIBUTE_NODE:deep=!0}if(node2||(node2=node.cloneNode(!1)),node2.ownerDocument=doc,node2.parentNode=null,deep)for(var child=node.firstChild;child;)node2.appendChild(importNode(doc,child,deep)),child=child.nextSibling;return node2}function cloneNode(doc,node,deep){var node2=new node.constructor;for(var n in node){var v=node[n];"object"!=typeof v&&v!=node2[n]&&(node2[n]=v)}switch(node.childNodes&&(node2.childNodes=new NodeList),node2.ownerDocument=doc,node2.nodeType){case ELEMENT_NODE:var attrs=node.attributes,attrs2=node2.attributes=new NamedNodeMap,len=attrs.length;attrs2._ownerElement=node2;for(var i=0;len>i;i++)node2.setAttributeNode(cloneNode(doc,attrs.item(i),!0));break;case ATTRIBUTE_NODE:deep=!0}if(deep)for(var child=node.firstChild;child;)node2.appendChild(cloneNode(doc,child,deep)),child=child.nextSibling;return node2}function __set__(object,key,value){object[key]=value}function getTextContent(node){switch(node.nodeType){case 1:case 11:var buf=[];for(node=node.firstChild;node;)7!==node.nodeType&&8!==node.nodeType&&buf.push(getTextContent(node)),node=node.nextSibling;return buf.join("");default:return node.nodeValue}}var htmlns="http://www.w3.org/1999/xhtml",NodeType={},ELEMENT_NODE=NodeType.ELEMENT_NODE=1,ATTRIBUTE_NODE=NodeType.ATTRIBUTE_NODE=2,TEXT_NODE=NodeType.TEXT_NODE=3,CDATA_SECTION_NODE=NodeType.CDATA_SECTION_NODE=4,ENTITY_REFERENCE_NODE=NodeType.ENTITY_REFERENCE_NODE=5,ENTITY_NODE=NodeType.ENTITY_NODE=6,PROCESSING_INSTRUCTION_NODE=NodeType.PROCESSING_INSTRUCTION_NODE=7,COMMENT_NODE=NodeType.COMMENT_NODE=8,DOCUMENT_NODE=NodeType.DOCUMENT_NODE=9,DOCUMENT_TYPE_NODE=NodeType.DOCUMENT_TYPE_NODE=10,DOCUMENT_FRAGMENT_NODE=NodeType.DOCUMENT_FRAGMENT_NODE=11,NOTATION_NODE=NodeType.NOTATION_NODE=12,ExceptionCode={},ExceptionMessage={},NOT_FOUND_ERR=(ExceptionCode.INDEX_SIZE_ERR=(ExceptionMessage[1]="Index size error",1),ExceptionCode.DOMSTRING_SIZE_ERR=(ExceptionMessage[2]="DOMString size error",2),ExceptionCode.HIERARCHY_REQUEST_ERR=(ExceptionMessage[3]="Hierarchy request error",3),ExceptionCode.WRONG_DOCUMENT_ERR=(ExceptionMessage[4]="Wrong document",4),ExceptionCode.INVALID_CHARACTER_ERR=(ExceptionMessage[5]="Invalid character",5),ExceptionCode.NO_DATA_ALLOWED_ERR=(ExceptionMessage[6]="No data allowed",6),ExceptionCode.NO_MODIFICATION_ALLOWED_ERR=(ExceptionMessage[7]="No modification allowed",7),ExceptionCode.NOT_FOUND_ERR=(ExceptionMessage[8]="Not found",8)),INUSE_ATTRIBUTE_ERR=(ExceptionCode.NOT_SUPPORTED_ERR=(ExceptionMessage[9]="Not supported",9),ExceptionCode.INUSE_ATTRIBUTE_ERR=(ExceptionMessage[10]="Attribute in use",10));ExceptionCode.INVALID_STATE_ERR=(ExceptionMessage[11]="Invalid state",11),ExceptionCode.SYNTAX_ERR=(ExceptionMessage[12]="Syntax error",12),ExceptionCode.INVALID_MODIFICATION_ERR=(ExceptionMessage[13]="Invalid modification",13),ExceptionCode.NAMESPACE_ERR=(ExceptionMessage[14]="Invalid namespace",14),ExceptionCode.INVALID_ACCESS_ERR=(ExceptionMessage[15]="Invalid access",15);DOMException.prototype=Error.prototype,copy(ExceptionCode,DOMException),NodeList.prototype={length:0,item:function(index){return this[index]||null},toString:function(){for(var buf=[],i=0;i<this.length;i++)serializeToString(this[i],buf);return buf.join("")}},LiveNodeList.prototype.item=function(i){return _updateLiveList(this),this[i]},_extends(LiveNodeList,NodeList),NamedNodeMap.prototype={length:0,item:NodeList.prototype.item,getNamedItem:function(key){for(var i=this.length;i--;){var attr=this[i];if(attr.nodeName==key)return attr}},setNamedItem:function(attr){var el=attr.ownerElement;if(el&&el!=this._ownerElement)throw new DOMException(INUSE_ATTRIBUTE_ERR);var oldAttr=this.getNamedItem(attr.nodeName);return _addNamedNode(this._ownerElement,this,attr,oldAttr),oldAttr},setNamedItemNS:function(attr){var oldAttr,el=attr.ownerElement;if(el&&el!=this._ownerElement)throw new DOMException(INUSE_ATTRIBUTE_ERR);return oldAttr=this.getNamedItemNS(attr.namespaceURI,attr.localName),_addNamedNode(this._ownerElement,this,attr,oldAttr),oldAttr},removeNamedItem:function(key){var attr=this.getNamedItem(key);return _removeNamedNode(this._ownerElement,this,attr),attr},removeNamedItemNS:function(namespaceURI,localName){var attr=this.getNamedItemNS(namespaceURI,localName);return _removeNamedNode(this._ownerElement,this,attr),attr},getNamedItemNS:function(namespaceURI,localName){for(var i=this.length;i--;){var node=this[i];if(node.localName==localName&&node.namespaceURI==namespaceURI)return node}return null}},DOMImplementation.prototype={hasFeature:function(feature,version){var versions=this._features[feature.toLowerCase()];return versions&&(!version||version in versions)?!0:!1},createDocument:function(namespaceURI,qualifiedName,doctype){var doc=new Document;if(doc.implementation=this,doc.childNodes=new NodeList,doc.doctype=doctype,doctype&&doc.appendChild(doctype),qualifiedName){var root=doc.createElementNS(namespaceURI,qualifiedName);doc.appendChild(root)}return doc},createDocumentType:function(qualifiedName,publicId,systemId){var node=new DocumentType;return node.name=qualifiedName,node.nodeName=qualifiedName,node.publicId=publicId,node.systemId=systemId,node}},Node.prototype={firstChild:null,lastChild:null,previousSibling:null,nextSibling:null,attributes:null,parentNode:null,childNodes:null,ownerDocument:null,nodeValue:null,namespaceURI:null,prefix:null,localName:null,insertBefore:function(newChild,refChild){return _insertBefore(this,newChild,refChild)},replaceChild:function(newChild,oldChild){this.insertBefore(newChild,oldChild),oldChild&&this.removeChild(oldChild)},removeChild:function(oldChild){return _removeChild(this,oldChild)},appendChild:function(newChild){return this.insertBefore(newChild,null)},hasChildNodes:function(){return null!=this.firstChild},cloneNode:function(deep){return cloneNode(this.ownerDocument||this,this,deep)},normalize:function(){for(var child=this.firstChild;child;){var next=child.nextSibling;next&&next.nodeType==TEXT_NODE&&child.nodeType==TEXT_NODE?(this.removeChild(next),child.appendData(next.data)):(child.normalize(),child=next)}},isSupported:function(feature,version){return this.ownerDocument.implementation.hasFeature(feature,version)},hasAttributes:function(){return this.attributes.length>0},lookupPrefix:function(namespaceURI){for(var el=this;el;){var map=el._nsMap;if(map)for(var n in map)if(map[n]==namespaceURI)return n;el=2==el.nodeType?el.ownerDocument:el.parentNode}return null},lookupNamespaceURI:function(prefix){for(var el=this;el;){var map=el._nsMap;if(map&&prefix in map)return map[prefix];el=2==el.nodeType?el.ownerDocument:el.parentNode}return null},isDefaultNamespace:function(namespaceURI){var prefix=this.lookupPrefix(namespaceURI);return null==prefix}},copy(NodeType,Node),copy(NodeType,Node.prototype),Document.prototype={nodeName:"#document",nodeType:DOCUMENT_NODE,doctype:null,documentElement:null,_inc:1,insertBefore:function(newChild,refChild){if(newChild.nodeType==DOCUMENT_FRAGMENT_NODE){for(var child=newChild.firstChild;child;){var next=child.nextSibling;this.insertBefore(child,refChild),child=next}return newChild}return null==this.documentElement&&1==newChild.nodeType&&(this.documentElement=newChild),_insertBefore(this,newChild,refChild),newChild.ownerDocument=this,newChild},removeChild:function(oldChild){return this.documentElement==oldChild&&(this.documentElement=null),_removeChild(this,oldChild)},importNode:function(importedNode,deep){return importNode(this,importedNode,deep)},getElementById:function(id){var rtv=null;return _visitNode(this.documentElement,function(node){return 1==node.nodeType&&node.getAttribute("id")==id?(rtv=node,!0):void 0}),rtv},createElement:function(tagName){var node=new Element;node.ownerDocument=this,node.nodeName=tagName,node.tagName=tagName,node.childNodes=new NodeList;var attrs=node.attributes=new NamedNodeMap;return attrs._ownerElement=node,node},createDocumentFragment:function(){var node=new DocumentFragment;return node.ownerDocument=this,node.childNodes=new NodeList,node},createTextNode:function(data){var node=new Text;return node.ownerDocument=this,node.appendData(data),node},createComment:function(data){var node=new Comment;return node.ownerDocument=this,node.appendData(data),node},createCDATASection:function(data){var node=new CDATASection;return node.ownerDocument=this,node.appendData(data),node},createProcessingInstruction:function(target,data){var node=new ProcessingInstruction;return node.ownerDocument=this,node.tagName=node.target=target,node.nodeValue=node.data=data,node},createAttribute:function(name){var node=new Attr;return node.ownerDocument=this,node.name=name,node.nodeName=name,node.localName=name,node.specified=!0,node},createEntityReference:function(name){var node=new EntityReference;return node.ownerDocument=this,node.nodeName=name,node},createElementNS:function(namespaceURI,qualifiedName){var node=new Element,pl=qualifiedName.split(":"),attrs=node.attributes=new NamedNodeMap;return node.childNodes=new NodeList,node.ownerDocument=this,node.nodeName=qualifiedName,node.tagName=qualifiedName,node.namespaceURI=namespaceURI,2==pl.length?(node.prefix=pl[0],node.localName=pl[1]):node.localName=qualifiedName,attrs._ownerElement=node,node},createAttributeNS:function(namespaceURI,qualifiedName){var node=new Attr,pl=qualifiedName.split(":");return node.ownerDocument=this,node.nodeName=qualifiedName,node.name=qualifiedName,node.namespaceURI=namespaceURI,node.specified=!0,2==pl.length?(node.prefix=pl[0],node.localName=pl[1]):node.localName=qualifiedName,node}},_extends(Document,Node),Element.prototype={nodeType:ELEMENT_NODE,hasAttribute:function(name){return null!=this.getAttributeNode(name)},getAttribute:function(name){var attr=this.getAttributeNode(name);return attr&&attr.value||""},getAttributeNode:function(name){return this.attributes.getNamedItem(name)},setAttribute:function(name,value){var attr=this.ownerDocument.createAttribute(name);attr.value=attr.nodeValue=""+value,this.setAttributeNode(attr)},removeAttribute:function(name){var attr=this.getAttributeNode(name);attr&&this.removeAttributeNode(attr)},appendChild:function(newChild){return newChild.nodeType===DOCUMENT_FRAGMENT_NODE?this.insertBefore(newChild,null):_appendSingleChild(this,newChild)},setAttributeNode:function(newAttr){return this.attributes.setNamedItem(newAttr)},setAttributeNodeNS:function(newAttr){return this.attributes.setNamedItemNS(newAttr)},removeAttributeNode:function(oldAttr){return this.attributes.removeNamedItem(oldAttr.nodeName)},removeAttributeNS:function(namespaceURI,localName){var old=this.getAttributeNodeNS(namespaceURI,localName);old&&this.removeAttributeNode(old)},hasAttributeNS:function(namespaceURI,localName){return null!=this.getAttributeNodeNS(namespaceURI,localName)},getAttributeNS:function(namespaceURI,localName){var attr=this.getAttributeNodeNS(namespaceURI,localName);return attr&&attr.value||""},setAttributeNS:function(namespaceURI,qualifiedName,value){var attr=this.ownerDocument.createAttributeNS(namespaceURI,qualifiedName);attr.value=attr.nodeValue=""+value,this.setAttributeNode(attr)},getAttributeNodeNS:function(namespaceURI,localName){return this.attributes.getNamedItemNS(namespaceURI,localName)},getElementsByTagName:function(tagName){return new LiveNodeList(this,function(base){var ls=[];return _visitNode(base,function(node){node===base||node.nodeType!=ELEMENT_NODE||"*"!==tagName&&node.tagName!=tagName||ls.push(node)}),ls})},getElementsByTagNameNS:function(namespaceURI,localName){return new LiveNodeList(this,function(base){var ls=[];return _visitNode(base,function(node){node===base||node.nodeType!==ELEMENT_NODE||"*"!==namespaceURI&&node.namespaceURI!==namespaceURI||"*"!==localName&&node.localName!=localName||ls.push(node)}),ls})}},Document.prototype.getElementsByTagName=Element.prototype.getElementsByTagName,Document.prototype.getElementsByTagNameNS=Element.prototype.getElementsByTagNameNS,_extends(Element,Node),Attr.prototype.nodeType=ATTRIBUTE_NODE,_extends(Attr,Node),CharacterData.prototype={data:"",substringData:function(offset,count){return this.data.substring(offset,offset+count)},appendData:function(text){text=this.data+text,this.nodeValue=this.data=text,this.length=text.length},insertData:function(offset,text){this.replaceData(offset,0,text)},appendChild:function(newChild){throw new Error(ExceptionMessage[3])},deleteData:function(offset,count){this.replaceData(offset,count,"")},replaceData:function(offset,count,text){var start=this.data.substring(0,offset),end=this.data.substring(offset+count);text=start+text+end,this.nodeValue=this.data=text,this.length=text.length}},_extends(CharacterData,Node),Text.prototype={nodeName:"#text",nodeType:TEXT_NODE,splitText:function(offset){var text=this.data,newText=text.substring(offset);text=text.substring(0,offset),this.data=this.nodeValue=text,this.length=text.length;var newNode=this.ownerDocument.createTextNode(newText);return this.parentNode&&this.parentNode.insertBefore(newNode,this.nextSibling),newNode}},_extends(Text,CharacterData),Comment.prototype={nodeName:"#comment",nodeType:COMMENT_NODE},_extends(Comment,CharacterData),CDATASection.prototype={nodeName:"#cdata-section",nodeType:CDATA_SECTION_NODE},_extends(CDATASection,CharacterData),DocumentType.prototype.nodeType=DOCUMENT_TYPE_NODE,_extends(DocumentType,Node),Notation.prototype.nodeType=NOTATION_NODE,_extends(Notation,Node),Entity.prototype.nodeType=ENTITY_NODE,_extends(Entity,Node),EntityReference.prototype.nodeType=ENTITY_REFERENCE_NODE,_extends(EntityReference,Node),DocumentFragment.prototype.nodeName="#document-fragment",DocumentFragment.prototype.nodeType=DOCUMENT_FRAGMENT_NODE,_extends(DocumentFragment,Node),ProcessingInstruction.prototype.nodeType=PROCESSING_INSTRUCTION_NODE,_extends(ProcessingInstruction,Node),XMLSerializer.prototype.serializeToString=function(node,attributeSorter){return node.toString(attributeSorter)},Node.prototype.toString=function(attributeSorter){var buf=[];return serializeToString(this,buf,attributeSorter),buf.join("")};try{Object.defineProperty&&(Object.defineProperty(LiveNodeList.prototype,"length",{get:function(){return _updateLiveList(this),this.$$length}}),Object.defineProperty(Node.prototype,"textContent",{get:function(){return getTextContent(this)},set:function(data){switch(this.nodeType){case 1:case 11:for(;this.firstChild;)this.removeChild(this.firstChild);(data||String(data))&&this.appendChild(this.ownerDocument.createTextNode(data));break;default:this.data=data,this.value=value,this.nodeValue=data}}}),__set__=function(object,key,value){object["$$"+key]=value})}catch(e){}exports.DOMImplementation=DOMImplementation,exports.XMLSerializer=XMLSerializer},function(module,exports,__webpack_require__){(function(){"use strict";var bom,builder,escapeCDATA,events,isEmpty,processName,processors,requiresCDATA,sax,setImmediate,wrapCDATA,extend=function(child,parent){function ctor(){this.constructor=child}for(var key in parent)hasProp.call(parent,key)&&(child[key]=parent[key]);return ctor.prototype=parent.prototype,child.prototype=new ctor,child.__super__=parent.prototype,child},hasProp={}.hasOwnProperty,bind=function(fn,me){return function(){return fn.apply(me,arguments)}};sax=__webpack_require__(246),events=__webpack_require__(203),builder=__webpack_require__(247),bom=__webpack_require__(219),processors=__webpack_require__(220),setImmediate=__webpack_require__(240).setImmediate,isEmpty=function(thing){return"object"==typeof thing&&null!=thing&&0===Object.keys(thing).length},processName=function(processors,processedName){var i,len,process;for(i=0,len=processors.length;len>i;i++)process=processors[i],processedName=process(processedName);return processedName},requiresCDATA=function(entry){return entry.indexOf("&")>=0||entry.indexOf(">")>=0||entry.indexOf("<")>=0},wrapCDATA=function(entry){return"<![CDATA["+escapeCDATA(entry)+"]]>"},escapeCDATA=function(entry){return entry.replace("]]>","]]]]><![CDATA[>")},exports.processors=processors,exports.defaults={.1:{explicitCharkey:!1,trim:!0,normalize:!0,normalizeTags:!1,attrkey:"@",charkey:"#",explicitArray:!1,ignoreAttrs:!1,mergeAttrs:!1,explicitRoot:!1,validator:null,xmlns:!1,explicitChildren:!1,childkey:"@@",charsAsChildren:!1,async:!1,strict:!0,attrNameProcessors:null,attrValueProcessors:null,tagNameProcessors:null,valueProcessors:null,emptyTag:""},.2:{explicitCharkey:!1,trim:!1,normalize:!1,normalizeTags:!1,attrkey:"$",charkey:"_",explicitArray:!0,ignoreAttrs:!1,mergeAttrs:!1,explicitRoot:!0,validator:null,xmlns:!1,explicitChildren:!1,preserveChildrenOrder:!1,childkey:"$$",charsAsChildren:!1,async:!1,strict:!0,attrNameProcessors:null,attrValueProcessors:null,tagNameProcessors:null,valueProcessors:null,rootName:"root",xmldec:{version:"1.0",encoding:"UTF-8",standalone:!0},doctype:null,renderOpts:{pretty:!0,indent:"  ",newline:"\n"},headless:!1,chunkSize:1e4,emptyTag:"",cdata:!1}},exports.ValidationError=function(superClass){function ValidationError(message){this.message=message}return extend(ValidationError,superClass),ValidationError}(Error),exports.Builder=function(){function Builder(opts){var key,ref,value;this.options={},ref=exports.defaults[.2];for(key in ref)hasProp.call(ref,key)&&(value=ref[key],this.options[key]=value);for(key in opts)hasProp.call(opts,key)&&(value=opts[key],this.options[key]=value)}return Builder.prototype.buildObject=function(rootObj){var attrkey,charkey,render,rootElement,rootName;return attrkey=this.options.attrkey,charkey=this.options.charkey,1===Object.keys(rootObj).length&&this.options.rootName===exports.defaults[.2].rootName?(rootName=Object.keys(rootObj)[0],rootObj=rootObj[rootName]):rootName=this.options.rootName,render=function(_this){return function(element,obj){var attr,child,entry,index,key,value;if("object"!=typeof obj)_this.options.cdata&&requiresCDATA(obj)?element.raw(wrapCDATA(obj)):element.txt(obj);else for(key in obj)if(hasProp.call(obj,key))if(child=obj[key],key===attrkey){if("object"==typeof child)for(attr in child)value=child[attr],element=element.att(attr,value)}else if(key===charkey)element=_this.options.cdata&&requiresCDATA(child)?element.raw(wrapCDATA(child)):element.txt(child);else if(Array.isArray(child))for(index in child)hasProp.call(child,index)&&(entry=child[index],element="string"==typeof entry?_this.options.cdata&&requiresCDATA(entry)?element.ele(key).raw(wrapCDATA(entry)).up():element.ele(key,entry).up():render(element.ele(key),entry).up());else"object"==typeof child?element=render(element.ele(key),child).up():"string"==typeof child&&_this.options.cdata&&requiresCDATA(child)?element=element.ele(key).raw(wrapCDATA(child)).up():(null==child&&(child=""),element=element.ele(key,child.toString()).up());return element}}(this),rootElement=builder.create(rootName,this.options.xmldec,this.options.doctype,{headless:this.options.headless,allowSurrogateChars:this.options.allowSurrogateChars}),render(rootElement,rootObj).end(this.options.renderOpts)},Builder}(),exports.Parser=function(superClass){function Parser(opts){this.parseString=bind(this.parseString,this),this.reset=bind(this.reset,this),this.assignOrPush=bind(this.assignOrPush,this),this.processAsync=bind(this.processAsync,this);var key,ref,value;if(!(this instanceof exports.Parser))return new exports.Parser(opts);this.options={},ref=exports.defaults[.2];for(key in ref)hasProp.call(ref,key)&&(value=ref[key],this.options[key]=value);for(key in opts)hasProp.call(opts,key)&&(value=opts[key],this.options[key]=value);this.options.xmlns&&(this.options.xmlnskey=this.options.attrkey+"ns"),this.options.normalizeTags&&(this.options.tagNameProcessors||(this.options.tagNameProcessors=[]),this.options.tagNameProcessors.unshift(processors.normalize)),this.reset()}return extend(Parser,superClass),Parser.prototype.processAsync=function(){var chunk,err,error1;try{return this.remaining.length<=this.options.chunkSize?(chunk=this.remaining,this.remaining="",this.saxParser=this.saxParser.write(chunk),this.saxParser.close()):(chunk=this.remaining.substr(0,this.options.chunkSize),this.remaining=this.remaining.substr(this.options.chunkSize,this.remaining.length),this.saxParser=this.saxParser.write(chunk),setImmediate(this.processAsync))}catch(error1){if(err=error1,!this.saxParser.errThrown)return this.saxParser.errThrown=!0,this.emit(err)}},Parser.prototype.assignOrPush=function(obj,key,newValue){return key in obj?(obj[key]instanceof Array||(obj[key]=[obj[key]]),obj[key].push(newValue)):this.options.explicitArray?obj[key]=[newValue]:obj[key]=newValue},Parser.prototype.reset=function(){var attrkey,charkey,ontext,stack;return this.removeAllListeners(),this.saxParser=sax.parser(this.options.strict,{trim:!1,normalize:!1,xmlns:this.options.xmlns}),this.saxParser.errThrown=!1,this.saxParser.onerror=function(_this){return function(error){return _this.saxParser.resume(),_this.saxParser.errThrown?void 0:(_this.saxParser.errThrown=!0,_this.emit("error",error))}}(this),this.saxParser.onend=function(_this){return function(){return _this.saxParser.ended?void 0:(_this.saxParser.ended=!0,_this.emit("end",_this.resultObject))}}(this),this.saxParser.ended=!1,this.EXPLICIT_CHARKEY=this.options.explicitCharkey,this.resultObject=null,stack=[],attrkey=this.options.attrkey,charkey=this.options.charkey,this.saxParser.onopentag=function(_this){return function(node){var key,newValue,obj,processedKey,ref;if(obj={},obj[charkey]="",!_this.options.ignoreAttrs){ref=node.attributes;for(key in ref)hasProp.call(ref,key)&&(attrkey in obj||_this.options.mergeAttrs||(obj[attrkey]={}),newValue=_this.options.attrValueProcessors?processName(_this.options.attrValueProcessors,node.attributes[key]):node.attributes[key],processedKey=_this.options.attrNameProcessors?processName(_this.options.attrNameProcessors,key):key,_this.options.mergeAttrs?_this.assignOrPush(obj,processedKey,newValue):obj[attrkey][processedKey]=newValue)}return obj["#name"]=_this.options.tagNameProcessors?processName(_this.options.tagNameProcessors,node.name):node.name,_this.options.xmlns&&(obj[_this.options.xmlnskey]={uri:node.uri,local:node.local}),stack.push(obj)}}(this),this.saxParser.onclosetag=function(_this){return function(){var cdata,emptyStr,err,error1,key,node,nodeName,obj,objClone,old,s,xpath;if(obj=stack.pop(),nodeName=obj["#name"],_this.options.explicitChildren&&_this.options.preserveChildrenOrder||delete obj["#name"],obj.cdata===!0&&(cdata=obj.cdata,delete obj.cdata),s=stack[stack.length-1],obj[charkey].match(/^\s*$/)&&!cdata?(emptyStr=obj[charkey],delete obj[charkey]):(_this.options.trim&&(obj[charkey]=obj[charkey].trim()),_this.options.normalize&&(obj[charkey]=obj[charkey].replace(/\s{2,}/g," ").trim()),obj[charkey]=_this.options.valueProcessors?processName(_this.options.valueProcessors,obj[charkey]):obj[charkey],1===Object.keys(obj).length&&charkey in obj&&!_this.EXPLICIT_CHARKEY&&(obj=obj[charkey])),isEmpty(obj)&&(obj=""!==_this.options.emptyTag?_this.options.emptyTag:emptyStr),null!=_this.options.validator){xpath="/"+function(){var i,len,results;for(results=[],i=0,len=stack.length;len>i;i++)node=stack[i],results.push(node["#name"]);return results}().concat(nodeName).join("/");try{obj=_this.options.validator(xpath,s&&s[nodeName],obj)}catch(error1){err=error1,_this.emit("error",err)}}if(_this.options.explicitChildren&&!_this.options.mergeAttrs&&"object"==typeof obj)if(_this.options.preserveChildrenOrder){if(s){s[_this.options.childkey]=s[_this.options.childkey]||[],objClone={};for(key in obj)hasProp.call(obj,key)&&(objClone[key]=obj[key]);s[_this.options.childkey].push(objClone),delete obj["#name"],1===Object.keys(obj).length&&charkey in obj&&!_this.EXPLICIT_CHARKEY&&(obj=obj[charkey])}}else node={},_this.options.attrkey in obj&&(node[_this.options.attrkey]=obj[_this.options.attrkey],delete obj[_this.options.attrkey]),!_this.options.charsAsChildren&&_this.options.charkey in obj&&(node[_this.options.charkey]=obj[_this.options.charkey],delete obj[_this.options.charkey]),Object.getOwnPropertyNames(obj).length>0&&(node[_this.options.childkey]=obj),obj=node;return stack.length>0?_this.assignOrPush(s,nodeName,obj):(_this.options.explicitRoot&&(old=obj,obj={},obj[nodeName]=old),_this.resultObject=obj,_this.saxParser.ended=!0,_this.emit("end",_this.resultObject))}}(this),ontext=function(_this){return function(text){var charChild,s;return s=stack[stack.length-1],s?(s[charkey]+=text,_this.options.explicitChildren&&_this.options.preserveChildrenOrder&&_this.options.charsAsChildren&&""!==text.replace(/\\n/g,"").trim()&&(s[_this.options.childkey]=s[_this.options.childkey]||[],charChild={"#name":"__text__"},charChild[charkey]=text,s[_this.options.childkey].push(charChild)),s):void 0}}(this),this.saxParser.ontext=ontext,this.saxParser.oncdata=function(_this){return function(text){var s;return s=ontext(text),s?s.cdata=!0:void 0}}(this)},Parser.prototype.parseString=function(str,cb){var err,error1;null!=cb&&"function"==typeof cb&&(this.on("end",function(result){return this.reset(),cb(null,result)}),this.on("error",function(err){return this.reset(),cb(err)}));try{return str=str.toString(),""===str.trim()?(this.emit("end",null),!0):(str=bom.stripBOM(str),this.options.async?(this.remaining=str,setImmediate(this.processAsync),this.saxParser):this.saxParser.write(str).close())}catch(error1){if(err=error1,!this.saxParser.errThrown&&!this.saxParser.ended)return this.emit("error",err),this.saxParser.errThrown=!0;if(this.saxParser.ended)throw err}},Parser}(events.EventEmitter),exports.parseString=function(str,a,b){var cb,options,parser;return null!=b?("function"==typeof b&&(cb=b),"object"==typeof a&&(options=a)):("function"==typeof a&&(cb=a),options={}),parser=new exports.Parser(options),parser.parseString(str,cb)}}).call(this)},function(module,exports,__webpack_require__){(function(process){"use strict";function nextTick(fn){for(var args=new Array(arguments.length-1),i=0;i<args.length;)args[i++]=arguments[i];process.nextTick(function(){fn.apply(null,args)})}!process.version||0===process.version.indexOf("v0.")||0===process.version.indexOf("v1.")&&0!==process.version.indexOf("v1.8.")?module.exports=nextTick:module.exports=process.nextTick}).call(exports,__webpack_require__(59))},function(module,exports,__webpack_require__){var toString={}.toString;module.exports=Array.isArray||function(arr){return"[object Array]"==toString.call(arr)}},function(module,exports,__webpack_require__){function EventEmitter(){this._events=this._events||{},this._maxListeners=this._maxListeners||void 0}function isFunction(arg){return"function"==typeof arg}function isNumber(arg){return"number"==typeof arg}function isObject(arg){return"object"==typeof arg&&null!==arg}function isUndefined(arg){return void 0===arg}module.exports=EventEmitter,EventEmitter.EventEmitter=EventEmitter,EventEmitter.prototype._events=void 0,EventEmitter.prototype._maxListeners=void 0,EventEmitter.defaultMaxListeners=10,EventEmitter.prototype.setMaxListeners=function(n){if(!isNumber(n)||0>n||isNaN(n))throw TypeError("n must be a positive number");return this._maxListeners=n,this},EventEmitter.prototype.emit=function(type){var er,handler,len,args,i,listeners;if(this._events||(this._events={}),"error"===type&&(!this._events.error||isObject(this._events.error)&&!this._events.error.length)){if(er=arguments[1],er instanceof Error)throw er;throw TypeError('Uncaught, unspecified "error" event.')}if(handler=this._events[type],isUndefined(handler))return!1;if(isFunction(handler))switch(arguments.length){case 1:handler.call(this);break;case 2:handler.call(this,arguments[1]);break;case 3:handler.call(this,arguments[1],arguments[2]);break;default:args=Array.prototype.slice.call(arguments,1),handler.apply(this,args)}else if(isObject(handler))for(args=Array.prototype.slice.call(arguments,1),listeners=handler.slice(),len=listeners.length,i=0;len>i;i++)listeners[i].apply(this,args);return!0},EventEmitter.prototype.addListener=function(type,listener){var m;if(!isFunction(listener))throw TypeError("listener must be a function");return this._events||(this._events={}),this._events.newListener&&this.emit("newListener",type,isFunction(listener.listener)?listener.listener:listener),
this._events[type]?isObject(this._events[type])?this._events[type].push(listener):this._events[type]=[this._events[type],listener]:this._events[type]=listener,isObject(this._events[type])&&!this._events[type].warned&&(m=isUndefined(this._maxListeners)?EventEmitter.defaultMaxListeners:this._maxListeners,m&&m>0&&this._events[type].length>m&&(this._events[type].warned=!0,console.error("(node) warning: possible EventEmitter memory leak detected. %d listeners added. Use emitter.setMaxListeners() to increase limit.",this._events[type].length),"function"==typeof console.trace&&console.trace())),this},EventEmitter.prototype.on=EventEmitter.prototype.addListener,EventEmitter.prototype.once=function(type,listener){function g(){this.removeListener(type,g),fired||(fired=!0,listener.apply(this,arguments))}if(!isFunction(listener))throw TypeError("listener must be a function");var fired=!1;return g.listener=listener,this.on(type,g),this},EventEmitter.prototype.removeListener=function(type,listener){var list,position,length,i;if(!isFunction(listener))throw TypeError("listener must be a function");if(!this._events||!this._events[type])return this;if(list=this._events[type],length=list.length,position=-1,list===listener||isFunction(list.listener)&&list.listener===listener)delete this._events[type],this._events.removeListener&&this.emit("removeListener",type,listener);else if(isObject(list)){for(i=length;i-->0;)if(list[i]===listener||list[i].listener&&list[i].listener===listener){position=i;break}if(0>position)return this;1===list.length?(list.length=0,delete this._events[type]):list.splice(position,1),this._events.removeListener&&this.emit("removeListener",type,listener)}return this},EventEmitter.prototype.removeAllListeners=function(type){var key,listeners;if(!this._events)return this;if(!this._events.removeListener)return 0===arguments.length?this._events={}:this._events[type]&&delete this._events[type],this;if(0===arguments.length){for(key in this._events)"removeListener"!==key&&this.removeAllListeners(key);return this.removeAllListeners("removeListener"),this._events={},this}if(listeners=this._events[type],isFunction(listeners))this.removeListener(type,listeners);else if(listeners)for(;listeners.length;)this.removeListener(type,listeners[listeners.length-1]);return delete this._events[type],this},EventEmitter.prototype.listeners=function(type){var ret;return ret=this._events&&this._events[type]?isFunction(this._events[type])?[this._events[type]]:this._events[type].slice():[]},EventEmitter.prototype.listenerCount=function(type){if(this._events){var evlistener=this._events[type];if(isFunction(evlistener))return 1;if(evlistener)return evlistener.length}return 0},EventEmitter.listenerCount=function(emitter,type){return emitter.listenerCount(type)}},function(module,exports,__webpack_require__){function assertEncoding(encoding){if(encoding&&!isBufferEncoding(encoding))throw new Error("Unknown encoding: "+encoding)}function passThroughWrite(buffer){return buffer.toString(this.encoding)}function utf16DetectIncompleteChar(buffer){this.charReceived=buffer.length%2,this.charLength=this.charReceived?2:0}function base64DetectIncompleteChar(buffer){this.charReceived=buffer.length%3,this.charLength=this.charReceived?3:0}var Buffer=__webpack_require__(92).Buffer,isBufferEncoding=Buffer.isEncoding||function(encoding){switch(encoding&&encoding.toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":case"raw":return!0;default:return!1}},StringDecoder=exports.StringDecoder=function(encoding){switch(this.encoding=(encoding||"utf8").toLowerCase().replace(/[-_]/,""),assertEncoding(encoding),this.encoding){case"utf8":this.surrogateSize=3;break;case"ucs2":case"utf16le":this.surrogateSize=2,this.detectIncompleteChar=utf16DetectIncompleteChar;break;case"base64":this.surrogateSize=3,this.detectIncompleteChar=base64DetectIncompleteChar;break;default:return void(this.write=passThroughWrite)}this.charBuffer=new Buffer(6),this.charReceived=0,this.charLength=0};StringDecoder.prototype.write=function(buffer){for(var charStr="";this.charLength;){var available=buffer.length>=this.charLength-this.charReceived?this.charLength-this.charReceived:buffer.length;if(buffer.copy(this.charBuffer,this.charReceived,0,available),this.charReceived+=available,this.charReceived<this.charLength)return"";buffer=buffer.slice(available,buffer.length),charStr=this.charBuffer.slice(0,this.charLength).toString(this.encoding);var charCode=charStr.charCodeAt(charStr.length-1);if(!(charCode>=55296&&56319>=charCode)){if(this.charReceived=this.charLength=0,0===buffer.length)return charStr;break}this.charLength+=this.surrogateSize,charStr=""}this.detectIncompleteChar(buffer);var end=buffer.length;this.charLength&&(buffer.copy(this.charBuffer,0,buffer.length-this.charReceived,end),end-=this.charReceived),charStr+=buffer.toString(this.encoding,0,end);var end=charStr.length-1,charCode=charStr.charCodeAt(end);if(charCode>=55296&&56319>=charCode){var size=this.surrogateSize;return this.charLength+=size,this.charReceived+=size,this.charBuffer.copy(this.charBuffer,size,0,size),buffer.copy(this.charBuffer,0,0,size),charStr.substring(0,end)}return charStr},StringDecoder.prototype.detectIncompleteChar=function(buffer){for(var i=buffer.length>=3?3:buffer.length;i>0;i--){var c=buffer[buffer.length-i];if(1==i&&c>>5==6){this.charLength=2;break}if(2>=i&&c>>4==14){this.charLength=3;break}if(3>=i&&c>>3==30){this.charLength=4;break}}this.charReceived=i},StringDecoder.prototype.end=function(buffer){var res="";if(buffer&&buffer.length&&(res=this.write(buffer)),this.charReceived){var cr=this.charReceived,buf=this.charBuffer,enc=this.encoding;res+=buf.slice(0,cr).toString(enc)}return res}},function(module,exports,__webpack_require__){(function(global){function deprecate(fn,msg){function deprecated(){if(!warned){if(config("throwDeprecation"))throw new Error(msg);config("traceDeprecation")?console.trace(msg):console.warn(msg),warned=!0}return fn.apply(this,arguments)}if(config("noDeprecation"))return fn;var warned=!1;return deprecated}function config(name){try{if(!global.localStorage)return!1}catch(_){return!1}var val=global.localStorage[name];return null==val?!1:"true"===String(val).toLowerCase()}module.exports=deprecate}).call(exports,function(){return this}())},function(module,exports,__webpack_require__){"use strict";var Schema=__webpack_require__(153);module.exports=new Schema({explicit:[__webpack_require__(222),__webpack_require__(223),__webpack_require__(224)]})},function(module,exports,__webpack_require__){"use strict";function resolveYamlNull(data){if(null===data)return!0;var max=data.length;return 1===max&&"~"===data||4===max&&("null"===data||"Null"===data||"NULL"===data)}function constructYamlNull(){return null}function isNull(object){return null===object}var Type=__webpack_require__(187);module.exports=new Type("tag:yaml.org,2002:null",{kind:"scalar",resolve:resolveYamlNull,construct:constructYamlNull,predicate:isNull,represent:{canonical:function(){return"~"},lowercase:function(){return"null"},uppercase:function(){return"NULL"},camelcase:function(){return"Null"}},defaultStyle:"lowercase"})},function(module,exports,__webpack_require__){"use strict";function resolveYamlBoolean(data){if(null===data)return!1;var max=data.length;return 4===max&&("true"===data||"True"===data||"TRUE"===data)||5===max&&("false"===data||"False"===data||"FALSE"===data)}function constructYamlBoolean(data){return"true"===data||"True"===data||"TRUE"===data}function isBoolean(object){return"[object Boolean]"===Object.prototype.toString.call(object)}var Type=__webpack_require__(187);module.exports=new Type("tag:yaml.org,2002:bool",{kind:"scalar",resolve:resolveYamlBoolean,construct:constructYamlBoolean,predicate:isBoolean,represent:{lowercase:function(object){return object?"true":"false"},uppercase:function(object){return object?"TRUE":"FALSE"},camelcase:function(object){return object?"True":"False"}},defaultStyle:"lowercase"})},function(module,exports,__webpack_require__){"use strict";function isHexCode(c){return c>=48&&57>=c||c>=65&&70>=c||c>=97&&102>=c}function isOctCode(c){return c>=48&&55>=c}function isDecCode(c){return c>=48&&57>=c}function resolveYamlInteger(data){if(null===data)return!1;var ch,max=data.length,index=0,hasDigits=!1;if(!max)return!1;if(ch=data[index],("-"===ch||"+"===ch)&&(ch=data[++index]),"0"===ch){if(index+1===max)return!0;if(ch=data[++index],"b"===ch){for(index++;max>index;index++)if(ch=data[index],"_"!==ch){if("0"!==ch&&"1"!==ch)return!1;hasDigits=!0}return hasDigits}if("x"===ch){for(index++;max>index;index++)if(ch=data[index],"_"!==ch){if(!isHexCode(data.charCodeAt(index)))return!1;hasDigits=!0}return hasDigits}for(;max>index;index++)if(ch=data[index],"_"!==ch){if(!isOctCode(data.charCodeAt(index)))return!1;hasDigits=!0}return hasDigits}for(;max>index;index++)if(ch=data[index],"_"!==ch){if(":"===ch)break;if(!isDecCode(data.charCodeAt(index)))return!1;hasDigits=!0}return hasDigits?":"!==ch?!0:/^(:[0-5]?[0-9])+$/.test(data.slice(index)):!1}function constructYamlInteger(data){var ch,base,value=data,sign=1,digits=[];return-1!==value.indexOf("_")&&(value=value.replace(/_/g,"")),ch=value[0],("-"===ch||"+"===ch)&&("-"===ch&&(sign=-1),value=value.slice(1),ch=value[0]),"0"===value?0:"0"===ch?"b"===value[1]?sign*parseInt(value.slice(2),2):"x"===value[1]?sign*parseInt(value,16):sign*parseInt(value,8):-1!==value.indexOf(":")?(value.split(":").forEach(function(v){digits.unshift(parseInt(v,10))}),value=0,base=1,digits.forEach(function(d){value+=d*base,base*=60}),sign*value):sign*parseInt(value,10)}function isInteger(object){return"[object Number]"===Object.prototype.toString.call(object)&&0===object%1&&!common.isNegativeZero(object)}var common=__webpack_require__(112),Type=__webpack_require__(187);module.exports=new Type("tag:yaml.org,2002:int",{kind:"scalar",resolve:resolveYamlInteger,construct:constructYamlInteger,predicate:isInteger,represent:{binary:function(object){return"0b"+object.toString(2)},octal:function(object){return"0"+object.toString(8)},decimal:function(object){return object.toString(10)},hexadecimal:function(object){return"0x"+object.toString(16).toUpperCase()}},defaultStyle:"decimal",styleAliases:{binary:[2,"bin"],octal:[8,"oct"],decimal:[10,"dec"],hexadecimal:[16,"hex"]}})},function(module,exports,__webpack_require__){"use strict";function resolveYamlFloat(data){if(null===data)return!1;return YAML_FLOAT_PATTERN.test(data)?!0:!1}function constructYamlFloat(data){var value,sign,base,digits;return value=data.replace(/_/g,"").toLowerCase(),sign="-"===value[0]?-1:1,digits=[],0<="+-".indexOf(value[0])&&(value=value.slice(1)),".inf"===value?1===sign?Number.POSITIVE_INFINITY:Number.NEGATIVE_INFINITY:".nan"===value?NaN:0<=value.indexOf(":")?(value.split(":").forEach(function(v){digits.unshift(parseFloat(v,10))}),value=0,base=1,digits.forEach(function(d){value+=d*base,base*=60}),sign*value):sign*parseFloat(value,10)}function representYamlFloat(object,style){if(isNaN(object))switch(style){case"lowercase":return".nan";case"uppercase":return".NAN";case"camelcase":return".NaN"}else if(Number.POSITIVE_INFINITY===object)switch(style){case"lowercase":return".inf";case"uppercase":return".INF";case"camelcase":return".Inf"}else if(Number.NEGATIVE_INFINITY===object)switch(style){case"lowercase":return"-.inf";case"uppercase":return"-.INF";case"camelcase":return"-.Inf"}else if(common.isNegativeZero(object))return"-0.0";return object.toString(10)}function isFloat(object){return"[object Number]"===Object.prototype.toString.call(object)&&(0!==object%1||common.isNegativeZero(object))}var common=__webpack_require__(112),Type=__webpack_require__(187),YAML_FLOAT_PATTERN=new RegExp("^(?:[-+]?(?:[0-9][0-9_]*)\\.[0-9_]*(?:[eE][-+][0-9]+)?|\\.[0-9_]+(?:[eE][-+][0-9]+)?|[-+]?[0-9][0-9_]*(?::[0-5]?[0-9])+\\.[0-9_]*|[-+]?\\.(?:inf|Inf|INF)|\\.(?:nan|NaN|NAN))$");module.exports=new Type("tag:yaml.org,2002:float",{kind:"scalar",resolve:resolveYamlFloat,construct:constructYamlFloat,predicate:isFloat,represent:representYamlFloat,defaultStyle:"lowercase"})},function(module,exports,__webpack_require__){(function(Buffer){function isArray(arg){return Array.isArray?Array.isArray(arg):"[object Array]"===objectToString(arg)}function isBoolean(arg){return"boolean"==typeof arg}function isNull(arg){return null===arg}function isNullOrUndefined(arg){return null==arg}function isNumber(arg){return"number"==typeof arg}function isString(arg){return"string"==typeof arg}function isSymbol(arg){return"symbol"==typeof arg}function isUndefined(arg){return void 0===arg}function isRegExp(re){return"[object RegExp]"===objectToString(re)}function isObject(arg){return"object"==typeof arg&&null!==arg}function isDate(d){return"[object Date]"===objectToString(d)}function isError(e){return"[object Error]"===objectToString(e)||e instanceof Error}function isFunction(arg){return"function"==typeof arg}function isPrimitive(arg){return null===arg||"boolean"==typeof arg||"number"==typeof arg||"string"==typeof arg||"symbol"==typeof arg||"undefined"==typeof arg}function objectToString(o){return Object.prototype.toString.call(o)}exports.isArray=isArray,exports.isBoolean=isBoolean,exports.isNull=isNull,exports.isNullOrUndefined=isNullOrUndefined,exports.isNumber=isNumber,exports.isString=isString,exports.isSymbol=isSymbol,exports.isUndefined=isUndefined,exports.isRegExp=isRegExp,exports.isObject=isObject,exports.isDate=isDate,exports.isError=isError,exports.isFunction=isFunction,exports.isPrimitive=isPrimitive,exports.isBuffer=Buffer.isBuffer}).call(exports,__webpack_require__(92).Buffer)},function(module,exports,__webpack_require__){"use strict";var hexTable=function(){for(var array=new Array(256),i=0;256>i;++i)array[i]="%"+((16>i?"0":"")+i.toString(16)).toUpperCase();return array}();exports.arrayToObject=function(source,options){for(var obj=options.plainObjects?Object.create(null):{},i=0;i<source.length;++i)"undefined"!=typeof source[i]&&(obj[i]=source[i]);return obj},exports.merge=function(target,source,options){if(!source)return target;if("object"!=typeof source){if(Array.isArray(target))target.push(source);else{if("object"!=typeof target)return[target,source];target[source]=!0}return target}if("object"!=typeof target)return[target].concat(source);var mergeTarget=target;return Array.isArray(target)&&!Array.isArray(source)&&(mergeTarget=exports.arrayToObject(target,options)),Object.keys(source).reduce(function(acc,key){var value=source[key];return Object.prototype.hasOwnProperty.call(acc,key)?acc[key]=exports.merge(acc[key],value,options):acc[key]=value,acc},mergeTarget)},exports.decode=function(str){try{return decodeURIComponent(str.replace(/\+/g," "))}catch(e){return str}},exports.encode=function(str){if(0===str.length)return str;for(var string="string"==typeof str?str:String(str),out="",i=0;i<string.length;++i){var c=string.charCodeAt(i);45===c||46===c||95===c||126===c||c>=48&&57>=c||c>=65&&90>=c||c>=97&&122>=c?out+=string.charAt(i):128>c?out+=hexTable[c]:2048>c?out+=hexTable[192|c>>6]+hexTable[128|63&c]:55296>c||c>=57344?out+=hexTable[224|c>>12]+hexTable[128|c>>6&63]+hexTable[128|63&c]:(i+=1,c=65536+((1023&c)<<10|1023&string.charCodeAt(i)),out+=hexTable[240|c>>18]+hexTable[128|c>>12&63]+hexTable[128|c>>6&63]+hexTable[128|63&c])}return out},exports.compact=function(obj,references){if("object"!=typeof obj||null===obj)return obj;var refs=references||[],lookup=refs.indexOf(obj);if(-1!==lookup)return refs[lookup];if(refs.push(obj),Array.isArray(obj)){for(var compacted=[],i=0;i<obj.length;++i)"undefined"!=typeof obj[i]&&compacted.push(obj[i]);return compacted}for(var keys=Object.keys(obj),j=0;j<keys.length;++j){var key=keys[j];obj[key]=exports.compact(obj[key],refs)}return obj},exports.isRegExp=function(obj){return"[object RegExp]"===Object.prototype.toString.call(obj)},exports.isBuffer=function(obj){return null===obj||"undefined"==typeof obj?!1:!!(obj.constructor&&obj.constructor.isBuffer&&obj.constructor.isBuffer(obj))}},function(module,exports,__webpack_require__){function webpackContext(req){return __webpack_require__(webpackContextResolve(req))}function webpackContextResolve(req){return map[req]||function(){throw new Error("Cannot find module '"+req+"'.")}()}var map={"./ar":225,"./ar.js":225,"./bn":226,"./bn.js":226,"./de":227,"./de.js":227,"./es":228,"./es.js":228,"./fr":229,"./fr.js":229,"./hi":230,"./hi.js":230,"./it":231,"./it.js":231,"./ja":232,"./ja.js":232,"./ko":233,"./ko.js":233,"./pt":234,"./pt.js":234,"./ru":235,"./ru.js":235,"./zh-cn":236,"./zh-cn.js":236,"./zh-tw":237,"./zh-tw.js":237};webpackContext.id=213,webpackContext.keys=function(){return Object.keys(map)},webpackContext.resolve=webpackContextResolve,module.exports=webpackContext},function(module,exports,__webpack_require__){(function(process){exports=module.exports=__webpack_require__(241),exports.Stream=__webpack_require__(176),exports.Readable=exports,exports.Writable=__webpack_require__(242),exports.Duplex=__webpack_require__(243),exports.Transform=__webpack_require__(244),exports.PassThrough=__webpack_require__(245),process.browser||"disable"!==process.env.READABLE_STREAM||(module.exports=__webpack_require__(176))}).call(exports,__webpack_require__(59))},function(module,exports,__webpack_require__){module.exports=__webpack_require__(242)},function(module,exports,__webpack_require__){module.exports=__webpack_require__(243)},function(module,exports,__webpack_require__){module.exports=__webpack_require__(244)},function(module,exports,__webpack_require__){module.exports=__webpack_require__(245)},function(module,exports,__webpack_require__){(function(){"use strict";var xml2js;xml2js=__webpack_require__(200),exports.stripBOM=function(str){return"\ufeff"===str[0]?str.substring(1):str}}).call(this)},function(module,exports,__webpack_require__){(function(){"use strict";var prefixMatch;prefixMatch=new RegExp(/(?!xmlns)^.*:/),exports.normalize=function(str){return str.toLowerCase()},exports.firstCharLowerCase=function(str){return str.charAt(0).toLowerCase()+str.slice(1)},exports.stripPrefix=function(str){return str.replace(prefixMatch,"")},exports.parseNumbers=function(str){return isNaN(str)||(str=str%1===0?parseInt(str,10):parseFloat(str)),str},exports.parseBooleans=function(str){return/^(?:true|false)$/i.test(str)&&(str="true"===str.toLowerCase()),str}}).call(this)},function(module,exports,__webpack_require__){"function"==typeof Object.create?module.exports=function(ctor,superCtor){ctor.super_=superCtor,ctor.prototype=Object.create(superCtor.prototype,{constructor:{value:ctor,enumerable:!1,writable:!0,configurable:!0}})}:module.exports=function(ctor,superCtor){ctor.super_=superCtor;var TempCtor=function(){};TempCtor.prototype=superCtor.prototype,ctor.prototype=new TempCtor,ctor.prototype.constructor=ctor}},function(module,exports,__webpack_require__){"use strict";var Type=__webpack_require__(187);module.exports=new Type("tag:yaml.org,2002:str",{kind:"scalar",construct:function(data){return null!==data?data:""}})},function(module,exports,__webpack_require__){"use strict";var Type=__webpack_require__(187);module.exports=new Type("tag:yaml.org,2002:seq",{kind:"sequence",construct:function(data){return null!==data?data:[]}})},function(module,exports,__webpack_require__){"use strict";var Type=__webpack_require__(187);module.exports=new Type("tag:yaml.org,2002:map",{kind:"mapping",construct:function(data){return null!==data?data:{}}})},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){var num=["٠","١","٢","٣","٤","٥","٦","٧","٨","٩"],map={"٠":0,"١":1,"٢":2,"٣":3,"٤":4,"٥":5,"٦":6,"٧":7,"٨":8,"٩":9};date.setLocales("ar",{MMMM:["كانون الثاني يناير","شباط فبراير","آذار مارس","نيسان أبريل","أيار مايو","حزيران يونيو","تموز يوليو","آب أغسطس","أيلول سبتمبر","تشرين الأول أكتوبر","تشرين الثاني نوفمبر","كانون الأول ديسمبر"],MMM:["كانون الثاني يناير","شباط فبراير","آذار مارس","نيسان أبريل","أيار مايو","حزيران يونيو","تموز يوليو","آب أغسطس","أيلول سبتمبر","تشرين الأول أكتوبر","تشرين الثاني نوفمبر","كانون الأول ديسمبر"],dddd:["الأحد","الإثنين","الثلاثاء","الأربعاء","الخميس","الجمعة","السبت"],ddd:["أحد","إثنين","ثلاثاء","أربعاء","خميس","جمعة","سبت"],dd:["ح","ن","ث","ر","خ","ج","س"],A:["ص","م"],formats:{post:function(str){return str.replace(/\d/g,function(i){return num[0|i]})}},parsers:{pre:function(str){return str.replace(/[٠١٢٣٤٥٦٧٨٩]/g,function(i){return""+map[i]})}}})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(197)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(197)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){date.setLocales("bn",{MMMM:["জানুয়ারী","ফেবুয়ারী","মার্চ","এপ্রিল","মে","জুন","জুলাই","অগাস্ট","সেপ্টেম্বর","অক্টোবর","নভেম্বর","ডিসেম্বর"],MMM:["জানু","ফেব","মার্চ","এপর","মে","জুন","জুল","অগ","সেপ্ট","অক্টো","নভ","ডিসেম্"],dddd:["রবিবার","সোমবার","মঙ্গলবার","বুধবার","বৃহস্পত্তিবার","শুক্রবার","শনিবার"],ddd:["রবি","সোম","মঙ্গল","বুধ","বৃহস্পত্তি","শুক্র","শনি"],dd:["রব","সম","মঙ্গ","বু","ব্রিহ","শু","শনি"],A:["রাত","সকাল","দুপুর","বিকাল"],formats:{A:function(d){var h=d.getHours();return 4>h?this.A[0]:10>h?this.A[1]:17>h?this.A[2]:20>h?this.A[3]:this.A[0]}},parsers:{h:function(h,a){return 1>a?4>h||h>11?h:h+12:2>a?h:3>a&&h>9?h:h+12}}})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(197)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(197)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){date.setLocales("de",{MMMM:["Januar","Februar","März","April","Mai","Juni","Juli","August","September","Oktober","November","Dezember"],MMM:["Jan.","Febr.","Mrz.","Apr.","Mai","Jun.","Jul.","Aug.","Sept.","Okt.","Nov.","Dez."],dddd:["Sonntag","Montag","Dienstag","Mittwoch","Donnerstag","Freitag","Samstag"],ddd:["So.","Mo.","Di.","Mi.","Do.","Fr.","Sa."],dd:["So","Mo","Di","Mi","Do","Fr","Sa"],A:["Uhr nachmittags","Uhr morgens"]})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(197)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(197)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){date.setLocales("es",{MMMM:["enero","febrero","marzo","abril","mayo","junio","julio","agosto","septiembre","octubre","noviembre","diciembre"],MMM:["ene.","feb.","mar.","abr.","may.","jun.","jul.","ago.","sep.","oct.","nov.","dic."],dddd:["domingo","lunes","martes","miércoles","jueves","viernes","sábado"],ddd:["dom.","lun.","mar.","mié.","jue.","vie.","sáb."],dd:["do","lu","ma","mi","ju","vi","sá"],A:["de la mañana","de la tarde","de la noche"],formats:{A:function(d){var h=d.getHours();return 12>h?this.A[0]:19>h?this.A[1]:this.A[2]}},parsers:{h:function(h,a){return 1>a?h:h>11?h:h+12}}})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(197)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(197)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){date.setLocales("fr",{MMMM:["janvier","février","mars","avril","mai","juin","juillet","août","septembre","octobre","novembre","décembre"],MMM:["janv.","févr.","mars","avr.","mai","juin","juil.","août","sept.","oct.","nov.","déc."],dddd:["dimanche","lundi","mardi","mercredi","jeudi","vendredi","samedi"],ddd:["dim.","lun.","mar.","mer.","jeu.","ven.","sam."],dd:["Di","Lu","Ma","Me","Je","Ve","Sa"],A:["matin","l'après-midi"]})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(197)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(197)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){date.setLocales("hi",{MMMM:["जनवरी","फ़रवरी","मार्च","अप्रैल","मई","जून","जुलाई","अगस्त","सितम्बर","अक्टूबर","नवम्बर","दिसम्बर"],MMM:["जन.","फ़र.","मार्च","अप्रै.","मई","जून","जुल.","अग.","सित.","अक्टू.","नव.","दिस."],dddd:["रविवार","सोमवार","मंगलवार","बुधवार","गुरूवार","शुक्रवार","शनिवार"],ddd:["रवि","सोम","मंगल","बुध","गुरू","शुक्र","शनि"],dd:["र","सो","मं","बु","गु","शु","श"],A:["रात","सुबह","दोपहर","शाम"],formats:{A:function(d){var h=d.getHours();return 4>h?this.A[0]:10>h?this.A[1]:17>h?this.A[2]:20>h?this.A[3]:this.A[0]}},parsers:{h:function(h,a){return 1>a?4>h||h>11?h:h+12:2>a?h:3>a&&h>9?h:h+12}}})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(197)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(197)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){date.setLocales("it",{MMMM:["gennaio","febbraio","marzo","aprile","maggio","giugno","luglio","agosto","settembre","ottobre","novembre","dicembre"],MMM:["gen","feb","mar","apr","mag","giu","lug","ago","set","ott","nov","dic"],dddd:["Domenica","Lunedì","Martedì","Mercoledì","Giovedì","Venerdì","Sabato"],ddd:["Dom","Lun","Mar","Mer","Gio","Ven","Sab"],dd:["Do","Lu","Ma","Me","Gi","Ve","Sa"],A:["di mattina","di pomerrigio"]})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(197)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(197)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){date.setLocales("ja",{MMMM:["1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"],MMM:["1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"],dddd:["日曜日","月曜日","火曜日","水曜日","木曜日","金曜日","土曜日"],ddd:["日","月","火","水","木","金","土"],dd:["日","月","火","水","木","金","土"],A:["午前","午後"],formats:{hh:function(d){return("0"+d.getHours()%12).slice(-2)},h:function(d){return d.getHours()%12}}})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(197)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(197)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){date.setLocales("ko",{MMMM:["1월","2월","3월","4월","5월","6월","7월","8월","9월","10월","11월","12월"],MMM:["1월","2월","3월","4월","5월","6월","7월","8월","9월","10월","11월","12월"],dddd:["일요일","월요일","화요일","수요일","목요일","금요일","토요일"],ddd:["일","월","화","수","목","금","토"],dd:["일","월","화","수","목","금","토"],A:["오전","오후"]})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(197)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(197)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){date.setLocales("pt",{MMMM:["Janeiro","Fevereiro","Março","Abril","Maio","Junho","Julho","Agosto","Setembro","Outubro","Novembro","Dezembro"],MMM:["Jan","Fev","Mar","Abr","Mai","Jun","Jul","Ago","Set","Out","Nov","Dez"],dddd:["Domingo","Segunda-Feira","Terça-Feira","Quarta-Feira","Quinta-Feira","Sexta-Feira","Sábado"],ddd:["Dom","Seg","Ter","Qua","Qui","Sex","Sáb"],dd:["Dom","2ª","3ª","4ª","5ª","6ª","Sáb"],A:["da madrugada","da manhã","da tarde","da noite"],formats:{A:function(d){var h=d.getHours();return 5>h?this.A[0]:12>h?this.A[1]:19>h?this.A[2]:this.A[3]}},parsers:{h:function(h,a){return 2>a?h:h>11?h:h+12}}})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(197)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(197)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){date.setLocales("ru",{MMMM:["Января","Февраля","Марта","Апреля","Мая","Июня","Июля","Августа","Сентября","Октября","Ноября","Декабря"],MMM:["янв","фев","мар","апр","мая","июня","июля","авг","сен","окт","ноя","дек"],dddd:["Воскресенье","Понедельник","Вторник","Среду","Четверг","Пятницу","Субботу"],ddd:["Вс","Пн","Вт","Ср","Чт","Пт","Сб"],
dd:["Вс","Пн","Вт","Ср","Чт","Пт","Сб"],A:["ночи","утра","дня","вечера"],formats:{A:function(d){var h=d.getHours();return 4>h?this.A[0]:12>h?this.A[1]:17>h?this.A[2]:this.A[3]}},parsers:{h:function(h,a){return 2>a?h:h>11?h:h+12}}})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(197)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(197)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){date.setLocales("zh-cn",{MMMM:["一月","二月","三月","四月","五月","六月","七月","八月","九月","十月","十一月","十二月"],MMM:["1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"],dddd:["星期日","星期一","星期二","星期三","星期四","星期五","星期六"],ddd:["周日","周一","周二","周三","周四","周五","周六"],dd:["日","一","二","三","四","五","六"],A:["凌晨","早上","上午","中午","下午","晚上"],formats:{A:function(d){var hm=100*d.getHours()+d.getMinutes();return 600>hm?this.A[0]:900>hm?this.A[1]:1130>hm?this.A[2]:1230>hm?this.A[3]:1800>hm?this.A[4]:this.A[5]}},parsers:{h:function(h,a){return 4>a?h:h>11?h:h+12}}})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(197)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(197)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){var __WEBPACK_AMD_DEFINE_FACTORY__,__WEBPACK_AMD_DEFINE_ARRAY__,__WEBPACK_AMD_DEFINE_RESULT__;!function(global){"use strict";var locale=function(date){date.setLocales("zh-tw",{MMMM:["一月","二月","三月","四月","五月","六月","七月","八月","九月","十月","十一月","十二月"],MMM:["1月","2月","3月","4月","5月","6月","7月","8月","9月","10月","11月","12月"],dddd:["星期日","星期一","星期二","星期三","星期四","星期五","星期六"],ddd:["周日","周一","周二","周三","周四","周五","周六"],dd:["日","一","二","三","四","五","六"],A:["早上","上午","中午","下午","晚上"],formats:{A:function(d){var hm=100*d.getHours()+d.getMinutes();return 900>hm?this.A[0]:1130>hm?this.A[1]:1230>hm?this.A[2]:1800>hm?this.A[3]:this.A[4]}},parsers:{h:function(h,a){return 3>a?h:h>11?h:h+12}}})};"object"==typeof module&&"object"==typeof module.exports?locale(__webpack_require__(197)):(__WEBPACK_AMD_DEFINE_ARRAY__=[__webpack_require__(197)],__WEBPACK_AMD_DEFINE_FACTORY__=locale,__WEBPACK_AMD_DEFINE_RESULT__="function"==typeof __WEBPACK_AMD_DEFINE_FACTORY__?__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports,__WEBPACK_AMD_DEFINE_ARRAY__):__WEBPACK_AMD_DEFINE_FACTORY__,!(void 0!==__WEBPACK_AMD_DEFINE_RESULT__&&(module.exports=__WEBPACK_AMD_DEFINE_RESULT__)))}(this)},function(module,exports,__webpack_require__){(function(global){"use strict";function rawAsap(task){queue.length||(requestFlush(),flushing=!0),queue[queue.length]=task}function flush(){for(;index<queue.length;){var currentIndex=index;if(index+=1,queue[currentIndex].call(),index>capacity){for(var scan=0,newLength=queue.length-index;newLength>scan;scan++)queue[scan]=queue[scan+index];queue.length-=index,index=0}}queue.length=0,index=0,flushing=!1}function makeRequestCallFromMutationObserver(callback){var toggle=1,observer=new BrowserMutationObserver(callback),node=document.createTextNode("");return observer.observe(node,{characterData:!0}),function(){toggle=-toggle,node.data=toggle}}function makeRequestCallFromTimer(callback){return function(){function handleTimer(){clearTimeout(timeoutHandle),clearInterval(intervalHandle),callback()}var timeoutHandle=setTimeout(handleTimer,0),intervalHandle=setInterval(handleTimer,50)}}module.exports=rawAsap;var requestFlush,queue=[],flushing=!1,index=0,capacity=1024,BrowserMutationObserver=global.MutationObserver||global.WebKitMutationObserver;requestFlush="function"==typeof BrowserMutationObserver?makeRequestCallFromMutationObserver(flush):makeRequestCallFromTimer(flush),rawAsap.requestFlush=requestFlush,rawAsap.makeRequestCallFromTimer=makeRequestCallFromTimer}).call(exports,function(){return this}())},function(module,exports,__webpack_require__){"use strict";function throwFirstError(){if(pendingErrors.length)throw pendingErrors.shift()}function asap(task){var rawTask;rawTask=freeTasks.length?freeTasks.pop():new RawTask,rawTask.task=task,rawAsap(rawTask)}function RawTask(){this.task=null}var rawAsap=__webpack_require__(238),freeTasks=[],pendingErrors=[],requestErrorThrow=rawAsap.makeRequestCallFromTimer(throwFirstError);module.exports=asap,RawTask.prototype.call=function(){try{this.task.call()}catch(error){asap.onerror?asap.onerror(error):(pendingErrors.push(error),requestErrorThrow())}finally{this.task=null,freeTasks[freeTasks.length]=this}}},function(module,exports,__webpack_require__){function Timeout(id,clearFn){this._id=id,this._clearFn=clearFn}var nextTick=__webpack_require__(253).nextTick,apply=Function.prototype.apply,slice=Array.prototype.slice,immediateIds={},nextImmediateId=0;exports.setTimeout=function(){return new Timeout(apply.call(setTimeout,window,arguments),clearTimeout)},exports.setInterval=function(){return new Timeout(apply.call(setInterval,window,arguments),clearInterval)},exports.clearTimeout=exports.clearInterval=function(timeout){timeout.close()},Timeout.prototype.unref=Timeout.prototype.ref=function(){},Timeout.prototype.close=function(){this._clearFn.call(window,this._id)},exports.enroll=function(item,msecs){clearTimeout(item._idleTimeoutId),item._idleTimeout=msecs},exports.unenroll=function(item){clearTimeout(item._idleTimeoutId),item._idleTimeout=-1},exports._unrefActive=exports.active=function(item){clearTimeout(item._idleTimeoutId);var msecs=item._idleTimeout;msecs>=0&&(item._idleTimeoutId=setTimeout(function(){item._onTimeout&&item._onTimeout()},msecs))},exports.setImmediate="function"==typeof setImmediate?setImmediate:function(fn){var id=nextImmediateId++,args=arguments.length<2?!1:slice.call(arguments,1);return immediateIds[id]=!0,nextTick(function(){immediateIds[id]&&(args?fn.apply(null,args):fn.call(null),exports.clearImmediate(id))}),id},exports.clearImmediate="function"==typeof clearImmediate?clearImmediate:function(id){delete immediateIds[id]}},function(module,exports,__webpack_require__){(function(process){function ReadableState(options,stream){var Duplex=__webpack_require__(243);options=options||{};var hwm=options.highWaterMark,defaultHwm=options.objectMode?16:16384;this.highWaterMark=hwm||0===hwm?hwm:defaultHwm,this.highWaterMark=~~this.highWaterMark,this.buffer=[],this.length=0,this.pipes=null,this.pipesCount=0,this.flowing=null,this.ended=!1,this.endEmitted=!1,this.reading=!1,this.sync=!0,this.needReadable=!1,this.emittedReadable=!1,this.readableListening=!1,this.objectMode=!!options.objectMode,stream instanceof Duplex&&(this.objectMode=this.objectMode||!!options.readableObjectMode),this.defaultEncoding=options.defaultEncoding||"utf8",this.ranOut=!1,this.awaitDrain=0,this.readingMore=!1,this.decoder=null,this.encoding=null,options.encoding&&(StringDecoder||(StringDecoder=__webpack_require__(249).StringDecoder),this.decoder=new StringDecoder(options.encoding),this.encoding=options.encoding)}function Readable(options){__webpack_require__(243);return this instanceof Readable?(this._readableState=new ReadableState(options,this),this.readable=!0,void Stream.call(this)):new Readable(options)}function readableAddChunk(stream,state,chunk,encoding,addToFront){var er=chunkInvalid(state,chunk);if(er)stream.emit("error",er);else if(util.isNullOrUndefined(chunk))state.reading=!1,state.ended||onEofChunk(stream,state);else if(state.objectMode||chunk&&chunk.length>0)if(state.ended&&!addToFront){var e=new Error("stream.push() after EOF");stream.emit("error",e)}else if(state.endEmitted&&addToFront){var e=new Error("stream.unshift() after end event");stream.emit("error",e)}else!state.decoder||addToFront||encoding||(chunk=state.decoder.write(chunk)),addToFront||(state.reading=!1),state.flowing&&0===state.length&&!state.sync?(stream.emit("data",chunk),stream.read(0)):(state.length+=state.objectMode?1:chunk.length,addToFront?state.buffer.unshift(chunk):state.buffer.push(chunk),state.needReadable&&emitReadable(stream)),maybeReadMore(stream,state);else addToFront||(state.reading=!1);return needMoreData(state)}function needMoreData(state){return!state.ended&&(state.needReadable||state.length<state.highWaterMark||0===state.length)}function roundUpToNextPowerOf2(n){if(n>=MAX_HWM)n=MAX_HWM;else{n--;for(var p=1;32>p;p<<=1)n|=n>>p;n++}return n}function howMuchToRead(n,state){return 0===state.length&&state.ended?0:state.objectMode?0===n?0:1:isNaN(n)||util.isNull(n)?state.flowing&&state.buffer.length?state.buffer[0].length:state.length:0>=n?0:(n>state.highWaterMark&&(state.highWaterMark=roundUpToNextPowerOf2(n)),n>state.length?state.ended?state.length:(state.needReadable=!0,0):n)}function chunkInvalid(state,chunk){var er=null;return util.isBuffer(chunk)||util.isString(chunk)||util.isNullOrUndefined(chunk)||state.objectMode||(er=new TypeError("Invalid non-string/buffer chunk")),er}function onEofChunk(stream,state){if(state.decoder&&!state.ended){var chunk=state.decoder.end();chunk&&chunk.length&&(state.buffer.push(chunk),state.length+=state.objectMode?1:chunk.length)}state.ended=!0,emitReadable(stream)}function emitReadable(stream){var state=stream._readableState;state.needReadable=!1,state.emittedReadable||(debug("emitReadable",state.flowing),state.emittedReadable=!0,state.sync?process.nextTick(function(){emitReadable_(stream)}):emitReadable_(stream))}function emitReadable_(stream){debug("emit readable"),stream.emit("readable"),flow(stream)}function maybeReadMore(stream,state){state.readingMore||(state.readingMore=!0,process.nextTick(function(){maybeReadMore_(stream,state)}))}function maybeReadMore_(stream,state){for(var len=state.length;!state.reading&&!state.flowing&&!state.ended&&state.length<state.highWaterMark&&(debug("maybeReadMore read 0"),stream.read(0),len!==state.length);)len=state.length;state.readingMore=!1}function pipeOnDrain(src){return function(){var state=src._readableState;debug("pipeOnDrain",state.awaitDrain),state.awaitDrain&&state.awaitDrain--,0===state.awaitDrain&&EE.listenerCount(src,"data")&&(state.flowing=!0,flow(src))}}function resume(stream,state){state.resumeScheduled||(state.resumeScheduled=!0,process.nextTick(function(){resume_(stream,state)}))}function resume_(stream,state){state.resumeScheduled=!1,stream.emit("resume"),flow(stream),state.flowing&&!state.reading&&stream.read(0)}function flow(stream){var state=stream._readableState;if(debug("flow",state.flowing),state.flowing)do var chunk=stream.read();while(null!==chunk&&state.flowing)}function fromList(n,state){var ret,list=state.buffer,length=state.length,stringMode=!!state.decoder,objectMode=!!state.objectMode;if(0===list.length)return null;if(0===length)ret=null;else if(objectMode)ret=list.shift();else if(!n||n>=length)ret=stringMode?list.join(""):Buffer.concat(list,length),list.length=0;else if(n<list[0].length){var buf=list[0];ret=buf.slice(0,n),list[0]=buf.slice(n)}else if(n===list[0].length)ret=list.shift();else{ret=stringMode?"":new Buffer(n);for(var c=0,i=0,l=list.length;l>i&&n>c;i++){var buf=list[0],cpy=Math.min(n-c,buf.length);stringMode?ret+=buf.slice(0,cpy):buf.copy(ret,c,0,cpy),cpy<buf.length?list[0]=buf.slice(cpy):list.shift(),c+=cpy}}return ret}function endReadable(stream){var state=stream._readableState;if(state.length>0)throw new Error("endReadable called on non-empty stream");state.endEmitted||(state.ended=!0,process.nextTick(function(){state.endEmitted||0!==state.length||(state.endEmitted=!0,stream.readable=!1,stream.emit("end"))}))}function forEach(xs,f){for(var i=0,l=xs.length;l>i;i++)f(xs[i],i)}function indexOf(xs,x){for(var i=0,l=xs.length;l>i;i++)if(xs[i]===x)return i;return-1}module.exports=Readable;var isArray=__webpack_require__(251),Buffer=__webpack_require__(92).Buffer;Readable.ReadableState=ReadableState;var EE=__webpack_require__(203).EventEmitter;EE.listenerCount||(EE.listenerCount=function(emitter,type){return emitter.listeners(type).length});var Stream=__webpack_require__(176),util=__webpack_require__(254);util.inherits=__webpack_require__(252);var StringDecoder,debug=__webpack_require__(248);debug=debug&&debug.debuglog?debug.debuglog("stream"):function(){},util.inherits(Readable,Stream),Readable.prototype.push=function(chunk,encoding){var state=this._readableState;return util.isString(chunk)&&!state.objectMode&&(encoding=encoding||state.defaultEncoding,encoding!==state.encoding&&(chunk=new Buffer(chunk,encoding),encoding="")),readableAddChunk(this,state,chunk,encoding,!1)},Readable.prototype.unshift=function(chunk){var state=this._readableState;return readableAddChunk(this,state,chunk,"",!0)},Readable.prototype.setEncoding=function(enc){return StringDecoder||(StringDecoder=__webpack_require__(249).StringDecoder),this._readableState.decoder=new StringDecoder(enc),this._readableState.encoding=enc,this};var MAX_HWM=8388608;Readable.prototype.read=function(n){debug("read",n);var state=this._readableState,nOrig=n;if((!util.isNumber(n)||n>0)&&(state.emittedReadable=!1),0===n&&state.needReadable&&(state.length>=state.highWaterMark||state.ended))return debug("read: emitReadable",state.length,state.ended),0===state.length&&state.ended?endReadable(this):emitReadable(this),null;if(n=howMuchToRead(n,state),0===n&&state.ended)return 0===state.length&&endReadable(this),null;var doRead=state.needReadable;debug("need readable",doRead),(0===state.length||state.length-n<state.highWaterMark)&&(doRead=!0,debug("length less than watermark",doRead)),(state.ended||state.reading)&&(doRead=!1,debug("reading or ended",doRead)),doRead&&(debug("do read"),state.reading=!0,state.sync=!0,0===state.length&&(state.needReadable=!0),this._read(state.highWaterMark),state.sync=!1),doRead&&!state.reading&&(n=howMuchToRead(nOrig,state));var ret;return ret=n>0?fromList(n,state):null,util.isNull(ret)&&(state.needReadable=!0,n=0),state.length-=n,0!==state.length||state.ended||(state.needReadable=!0),nOrig!==n&&state.ended&&0===state.length&&endReadable(this),util.isNull(ret)||this.emit("data",ret),ret},Readable.prototype._read=function(n){this.emit("error",new Error("not implemented"))},Readable.prototype.pipe=function(dest,pipeOpts){function onunpipe(readable){debug("onunpipe"),readable===src&&cleanup()}function onend(){debug("onend"),dest.end()}function cleanup(){debug("cleanup"),dest.removeListener("close",onclose),dest.removeListener("finish",onfinish),dest.removeListener("drain",ondrain),dest.removeListener("error",onerror),dest.removeListener("unpipe",onunpipe),src.removeListener("end",onend),src.removeListener("end",cleanup),src.removeListener("data",ondata),!state.awaitDrain||dest._writableState&&!dest._writableState.needDrain||ondrain()}function ondata(chunk){debug("ondata");var ret=dest.write(chunk);!1===ret&&(debug("false write response, pause",src._readableState.awaitDrain),src._readableState.awaitDrain++,src.pause())}function onerror(er){debug("onerror",er),unpipe(),dest.removeListener("error",onerror),0===EE.listenerCount(dest,"error")&&dest.emit("error",er)}function onclose(){dest.removeListener("finish",onfinish),unpipe()}function onfinish(){debug("onfinish"),dest.removeListener("close",onclose),unpipe()}function unpipe(){debug("unpipe"),src.unpipe(dest)}var src=this,state=this._readableState;switch(state.pipesCount){case 0:state.pipes=dest;break;case 1:state.pipes=[state.pipes,dest];break;default:state.pipes.push(dest)}state.pipesCount+=1,debug("pipe count=%d opts=%j",state.pipesCount,pipeOpts);var doEnd=(!pipeOpts||pipeOpts.end!==!1)&&dest!==process.stdout&&dest!==process.stderr,endFn=doEnd?onend:cleanup;state.endEmitted?process.nextTick(endFn):src.once("end",endFn),dest.on("unpipe",onunpipe);var ondrain=pipeOnDrain(src);return dest.on("drain",ondrain),src.on("data",ondata),dest._events&&dest._events.error?isArray(dest._events.error)?dest._events.error.unshift(onerror):dest._events.error=[onerror,dest._events.error]:dest.on("error",onerror),dest.once("close",onclose),dest.once("finish",onfinish),dest.emit("pipe",src),state.flowing||(debug("pipe resume"),src.resume()),dest},Readable.prototype.unpipe=function(dest){var state=this._readableState;if(0===state.pipesCount)return this;if(1===state.pipesCount)return dest&&dest!==state.pipes?this:(dest||(dest=state.pipes),state.pipes=null,state.pipesCount=0,state.flowing=!1,dest&&dest.emit("unpipe",this),this);if(!dest){var dests=state.pipes,len=state.pipesCount;state.pipes=null,state.pipesCount=0,state.flowing=!1;for(var i=0;len>i;i++)dests[i].emit("unpipe",this);return this}var i=indexOf(state.pipes,dest);return-1===i?this:(state.pipes.splice(i,1),state.pipesCount-=1,1===state.pipesCount&&(state.pipes=state.pipes[0]),dest.emit("unpipe",this),this)},Readable.prototype.on=function(ev,fn){var res=Stream.prototype.on.call(this,ev,fn);if("data"===ev&&!1!==this._readableState.flowing&&this.resume(),"readable"===ev&&this.readable){var state=this._readableState;if(!state.readableListening)if(state.readableListening=!0,state.emittedReadable=!1,state.needReadable=!0,state.reading)state.length&&emitReadable(this,state);else{var self=this;process.nextTick(function(){debug("readable nexttick read 0"),self.read(0)})}}return res},Readable.prototype.addListener=Readable.prototype.on,Readable.prototype.resume=function(){var state=this._readableState;return state.flowing||(debug("resume"),state.flowing=!0,state.reading||(debug("resume read 0"),this.read(0)),resume(this,state)),this},Readable.prototype.pause=function(){return debug("call pause flowing=%j",this._readableState.flowing),!1!==this._readableState.flowing&&(debug("pause"),this._readableState.flowing=!1,this.emit("pause")),this},Readable.prototype.wrap=function(stream){var state=this._readableState,paused=!1,self=this;stream.on("end",function(){if(debug("wrapped end"),state.decoder&&!state.ended){var chunk=state.decoder.end();chunk&&chunk.length&&self.push(chunk)}self.push(null)}),stream.on("data",function(chunk){if(debug("wrapped data"),state.decoder&&(chunk=state.decoder.write(chunk)),chunk&&(state.objectMode||chunk.length)){var ret=self.push(chunk);ret||(paused=!0,stream.pause())}});for(var i in stream)util.isFunction(stream[i])&&util.isUndefined(this[i])&&(this[i]=function(method){return function(){return stream[method].apply(stream,arguments)}}(i));var events=["error","close","destroy","pause","resume"];return forEach(events,function(ev){stream.on(ev,self.emit.bind(self,ev))}),self._read=function(n){debug("wrapped _read",n),paused&&(paused=!1,stream.resume())},self},Readable._fromList=fromList}).call(exports,__webpack_require__(59))},function(module,exports,__webpack_require__){(function(process){function WriteReq(chunk,encoding,cb){this.chunk=chunk,this.encoding=encoding,this.callback=cb}function WritableState(options,stream){var Duplex=__webpack_require__(243);options=options||{};var hwm=options.highWaterMark,defaultHwm=options.objectMode?16:16384;this.highWaterMark=hwm||0===hwm?hwm:defaultHwm,this.objectMode=!!options.objectMode,stream instanceof Duplex&&(this.objectMode=this.objectMode||!!options.writableObjectMode),this.highWaterMark=~~this.highWaterMark,this.needDrain=!1,this.ending=!1,this.ended=!1,this.finished=!1;var noDecode=options.decodeStrings===!1;this.decodeStrings=!noDecode,this.defaultEncoding=options.defaultEncoding||"utf8",this.length=0,this.writing=!1,this.corked=0,this.sync=!0,this.bufferProcessing=!1,this.onwrite=function(er){onwrite(stream,er)},this.writecb=null,this.writelen=0,this.buffer=[],this.pendingcb=0,this.prefinished=!1,this.errorEmitted=!1}function Writable(options){var Duplex=__webpack_require__(243);return this instanceof Writable||this instanceof Duplex?(this._writableState=new WritableState(options,this),this.writable=!0,void Stream.call(this)):new Writable(options)}function writeAfterEnd(stream,state,cb){var er=new Error("write after end");stream.emit("error",er),process.nextTick(function(){cb(er)})}function validChunk(stream,state,chunk,cb){var valid=!0;if(!(util.isBuffer(chunk)||util.isString(chunk)||util.isNullOrUndefined(chunk)||state.objectMode)){var er=new TypeError("Invalid non-string/buffer chunk");stream.emit("error",er),process.nextTick(function(){cb(er)}),valid=!1}return valid}function decodeChunk(state,chunk,encoding){return!state.objectMode&&state.decodeStrings!==!1&&util.isString(chunk)&&(chunk=new Buffer(chunk,encoding)),chunk}function writeOrBuffer(stream,state,chunk,encoding,cb){chunk=decodeChunk(state,chunk,encoding),util.isBuffer(chunk)&&(encoding="buffer");var len=state.objectMode?1:chunk.length;state.length+=len;var ret=state.length<state.highWaterMark;return ret||(state.needDrain=!0),state.writing||state.corked?state.buffer.push(new WriteReq(chunk,encoding,cb)):doWrite(stream,state,!1,len,chunk,encoding,cb),ret}function doWrite(stream,state,writev,len,chunk,encoding,cb){state.writelen=len,state.writecb=cb,state.writing=!0,state.sync=!0,writev?stream._writev(chunk,state.onwrite):stream._write(chunk,encoding,state.onwrite),state.sync=!1}function onwriteError(stream,state,sync,er,cb){sync?process.nextTick(function(){state.pendingcb--,cb(er)}):(state.pendingcb--,cb(er)),stream._writableState.errorEmitted=!0,stream.emit("error",er)}function onwriteStateUpdate(state){state.writing=!1,state.writecb=null,state.length-=state.writelen,state.writelen=0}function onwrite(stream,er){var state=stream._writableState,sync=state.sync,cb=state.writecb;if(onwriteStateUpdate(state),er)onwriteError(stream,state,sync,er,cb);else{var finished=needFinish(stream,state);finished||state.corked||state.bufferProcessing||!state.buffer.length||clearBuffer(stream,state),sync?process.nextTick(function(){afterWrite(stream,state,finished,cb)}):afterWrite(stream,state,finished,cb)}}function afterWrite(stream,state,finished,cb){finished||onwriteDrain(stream,state),state.pendingcb--,cb(),finishMaybe(stream,state)}function onwriteDrain(stream,state){0===state.length&&state.needDrain&&(state.needDrain=!1,stream.emit("drain"))}function clearBuffer(stream,state){if(state.bufferProcessing=!0,stream._writev&&state.buffer.length>1){for(var cbs=[],c=0;c<state.buffer.length;c++)cbs.push(state.buffer[c].callback);state.pendingcb++,doWrite(stream,state,!0,state.length,state.buffer,"",function(err){for(var i=0;i<cbs.length;i++)state.pendingcb--,cbs[i](err)}),state.buffer=[]}else{for(var c=0;c<state.buffer.length;c++){var entry=state.buffer[c],chunk=entry.chunk,encoding=entry.encoding,cb=entry.callback,len=state.objectMode?1:chunk.length;if(doWrite(stream,state,!1,len,chunk,encoding,cb),state.writing){c++;break}}c<state.buffer.length?state.buffer=state.buffer.slice(c):state.buffer.length=0}state.bufferProcessing=!1}function needFinish(stream,state){return state.ending&&0===state.length&&!state.finished&&!state.writing}function prefinish(stream,state){state.prefinished||(state.prefinished=!0,stream.emit("prefinish"))}function finishMaybe(stream,state){var need=needFinish(stream,state);return need&&(0===state.pendingcb?(prefinish(stream,state),state.finished=!0,stream.emit("finish")):prefinish(stream,state)),need}function endWritable(stream,state,cb){state.ending=!0,finishMaybe(stream,state),cb&&(state.finished?process.nextTick(cb):stream.once("finish",cb)),state.ended=!0}module.exports=Writable;var Buffer=__webpack_require__(92).Buffer;Writable.WritableState=WritableState;var util=__webpack_require__(254);util.inherits=__webpack_require__(252);var Stream=__webpack_require__(176);util.inherits(Writable,Stream),Writable.prototype.pipe=function(){this.emit("error",new Error("Cannot pipe. Not readable."))},Writable.prototype.write=function(chunk,encoding,cb){var state=this._writableState,ret=!1;return util.isFunction(encoding)&&(cb=encoding,encoding=null),util.isBuffer(chunk)?encoding="buffer":encoding||(encoding=state.defaultEncoding),util.isFunction(cb)||(cb=function(){}),state.ended?writeAfterEnd(this,state,cb):validChunk(this,state,chunk,cb)&&(state.pendingcb++,ret=writeOrBuffer(this,state,chunk,encoding,cb)),ret},Writable.prototype.cork=function(){var state=this._writableState;state.corked++},Writable.prototype.uncork=function(){var state=this._writableState;state.corked&&(state.corked--,state.writing||state.corked||state.finished||state.bufferProcessing||!state.buffer.length||clearBuffer(this,state))},Writable.prototype._write=function(chunk,encoding,cb){cb(new Error("not implemented"))},Writable.prototype._writev=null,Writable.prototype.end=function(chunk,encoding,cb){var state=this._writableState;util.isFunction(chunk)?(cb=chunk,chunk=null,encoding=null):util.isFunction(encoding)&&(cb=encoding,encoding=null),util.isNullOrUndefined(chunk)||this.write(chunk,encoding),state.corked&&(state.corked=1,this.uncork()),state.ending||state.finished||endWritable(this,state,cb)}}).call(exports,__webpack_require__(59))},function(module,exports,__webpack_require__){(function(process){function Duplex(options){return this instanceof Duplex?(Readable.call(this,options),Writable.call(this,options),options&&options.readable===!1&&(this.readable=!1),options&&options.writable===!1&&(this.writable=!1),this.allowHalfOpen=!0,options&&options.allowHalfOpen===!1&&(this.allowHalfOpen=!1),void this.once("end",onend)):new Duplex(options)}function onend(){this.allowHalfOpen||this._writableState.ended||process.nextTick(this.end.bind(this))}function forEach(xs,f){for(var i=0,l=xs.length;l>i;i++)f(xs[i],i)}module.exports=Duplex;var objectKeys=Object.keys||function(obj){var keys=[];for(var key in obj)keys.push(key);return keys},util=__webpack_require__(254);util.inherits=__webpack_require__(252);var Readable=__webpack_require__(241),Writable=__webpack_require__(242);util.inherits(Duplex,Readable),forEach(objectKeys(Writable.prototype),function(method){Duplex.prototype[method]||(Duplex.prototype[method]=Writable.prototype[method])})}).call(exports,__webpack_require__(59))},function(module,exports,__webpack_require__){function TransformState(options,stream){this.afterTransform=function(er,data){return afterTransform(stream,er,data)},this.needTransform=!1,this.transforming=!1,this.writecb=null,this.writechunk=null}function afterTransform(stream,er,data){var ts=stream._transformState;ts.transforming=!1;var cb=ts.writecb;if(!cb)return stream.emit("error",new Error("no writecb in Transform class"));ts.writechunk=null,ts.writecb=null,util.isNullOrUndefined(data)||stream.push(data),cb&&cb(er);var rs=stream._readableState;rs.reading=!1,(rs.needReadable||rs.length<rs.highWaterMark)&&stream._read(rs.highWaterMark)}function Transform(options){if(!(this instanceof Transform))return new Transform(options);Duplex.call(this,options),this._transformState=new TransformState(options,this);var stream=this;this._readableState.needReadable=!0,this._readableState.sync=!1,this.once("prefinish",function(){util.isFunction(this._flush)?this._flush(function(er){done(stream,er)}):done(stream)})}function done(stream,er){if(er)return stream.emit("error",er);var ws=stream._writableState,ts=stream._transformState;if(ws.length)throw new Error("calling transform done when ws.length != 0");if(ts.transforming)throw new Error("calling transform done when still transforming");return stream.push(null)}module.exports=Transform;var Duplex=__webpack_require__(243),util=__webpack_require__(254);util.inherits=__webpack_require__(252),util.inherits(Transform,Duplex),Transform.prototype.push=function(chunk,encoding){return this._transformState.needTransform=!1,Duplex.prototype.push.call(this,chunk,encoding)},Transform.prototype._transform=function(chunk,encoding,cb){throw new Error("not implemented")},Transform.prototype._write=function(chunk,encoding,cb){var ts=this._transformState;if(ts.writecb=cb,ts.writechunk=chunk,ts.writeencoding=encoding,!ts.transforming){var rs=this._readableState;(ts.needTransform||rs.needReadable||rs.length<rs.highWaterMark)&&this._read(rs.highWaterMark)}},Transform.prototype._read=function(n){var ts=this._transformState;util.isNull(ts.writechunk)||!ts.writecb||ts.transforming?ts.needTransform=!0:(ts.transforming=!0,this._transform(ts.writechunk,ts.writeencoding,ts.afterTransform))}},function(module,exports,__webpack_require__){function PassThrough(options){return this instanceof PassThrough?void Transform.call(this,options):new PassThrough(options)}module.exports=PassThrough;var Transform=__webpack_require__(244),util=__webpack_require__(254);util.inherits=__webpack_require__(252),util.inherits(PassThrough,Transform),PassThrough.prototype._transform=function(chunk,encoding,cb){cb(null,chunk)}},function(module,exports,__webpack_require__){(function(Buffer){!function(sax){function SAXParser(strict,opt){if(!(this instanceof SAXParser))return new SAXParser(strict,opt);var parser=this;clearBuffers(parser),parser.q=parser.c="",parser.bufferCheckPosition=sax.MAX_BUFFER_LENGTH,parser.opt=opt||{},parser.opt.lowercase=parser.opt.lowercase||parser.opt.lowercasetags,parser.looseCase=parser.opt.lowercase?"toLowerCase":"toUpperCase",parser.tags=[],parser.closed=parser.closedRoot=parser.sawRoot=!1,parser.tag=parser.error=null,parser.strict=!!strict,parser.noscript=!(!strict&&!parser.opt.noscript),parser.state=S.BEGIN,parser.strictEntities=parser.opt.strictEntities,parser.ENTITIES=parser.strictEntities?Object.create(sax.XML_ENTITIES):Object.create(sax.ENTITIES),parser.attribList=[],parser.opt.xmlns&&(parser.ns=Object.create(rootNS)),parser.trackPosition=parser.opt.position!==!1,parser.trackPosition&&(parser.position=parser.line=parser.column=0),emit(parser,"onready")}function checkBufferLength(parser){for(var maxAllowed=Math.max(sax.MAX_BUFFER_LENGTH,10),maxActual=0,i=0,l=buffers.length;l>i;i++){var len=parser[buffers[i]].length;if(len>maxAllowed)switch(buffers[i]){case"textNode":closeText(parser);break;case"cdata":emitNode(parser,"oncdata",parser.cdata),parser.cdata="";break;case"script":emitNode(parser,"onscript",parser.script),parser.script="";break;default:error(parser,"Max buffer length exceeded: "+buffers[i])}maxActual=Math.max(maxActual,len)}var m=sax.MAX_BUFFER_LENGTH-maxActual;parser.bufferCheckPosition=m+parser.position}function clearBuffers(parser){for(var i=0,l=buffers.length;l>i;i++)parser[buffers[i]]=""}function flushBuffers(parser){closeText(parser),""!==parser.cdata&&(emitNode(parser,"oncdata",parser.cdata),parser.cdata=""),""!==parser.script&&(emitNode(parser,"onscript",parser.script),parser.script="")}function createStream(strict,opt){return new SAXStream(strict,opt)}function SAXStream(strict,opt){if(!(this instanceof SAXStream))return new SAXStream(strict,opt);Stream.apply(this),this._parser=new SAXParser(strict,opt),this.writable=!0,this.readable=!0;var me=this;this._parser.onend=function(){me.emit("end")},this._parser.onerror=function(er){me.emit("error",er),me._parser.error=null},this._decoder=null,streamWraps.forEach(function(ev){Object.defineProperty(me,"on"+ev,{get:function(){return me._parser["on"+ev]},set:function(h){return h?void me.on(ev,h):(me.removeAllListeners(ev),me._parser["on"+ev]=h,h)},enumerable:!0,configurable:!1})})}function charClass(str){return str.split("").reduce(function(s,c){return s[c]=!0,s},{})}function isRegExp(c){return"[object RegExp]"===Object.prototype.toString.call(c)}function is(charclass,c){return isRegExp(charclass)?!!c.match(charclass):charclass[c]}function not(charclass,c){return!is(charclass,c)}function emit(parser,event,data){parser[event]&&parser[event](data)}function emitNode(parser,nodeType,data){parser.textNode&&closeText(parser),emit(parser,nodeType,data)}function closeText(parser){parser.textNode=textopts(parser.opt,parser.textNode),
parser.textNode&&emit(parser,"ontext",parser.textNode),parser.textNode=""}function textopts(opt,text){return opt.trim&&(text=text.trim()),opt.normalize&&(text=text.replace(/\s+/g," ")),text}function error(parser,er){return closeText(parser),parser.trackPosition&&(er+="\nLine: "+parser.line+"\nColumn: "+parser.column+"\nChar: "+parser.c),er=new Error(er),parser.error=er,emit(parser,"onerror",er),parser}function end(parser){return parser.sawRoot&&!parser.closedRoot&&strictFail(parser,"Unclosed root tag"),parser.state!==S.BEGIN&&parser.state!==S.BEGIN_WHITESPACE&&parser.state!==S.TEXT&&error(parser,"Unexpected end"),closeText(parser),parser.c="",parser.closed=!0,emit(parser,"onend"),SAXParser.call(parser,parser.strict,parser.opt),parser}function strictFail(parser,message){if("object"!=typeof parser||!(parser instanceof SAXParser))throw new Error("bad call to strictFail");parser.strict&&error(parser,message)}function newTag(parser){parser.strict||(parser.tagName=parser.tagName[parser.looseCase]());var parent=parser.tags[parser.tags.length-1]||parser,tag=parser.tag={name:parser.tagName,attributes:{}};parser.opt.xmlns&&(tag.ns=parent.ns),parser.attribList.length=0,emitNode(parser,"onopentagstart",tag)}function qname(name,attribute){var i=name.indexOf(":"),qualName=0>i?["",name]:name.split(":"),prefix=qualName[0],local=qualName[1];return attribute&&"xmlns"===name&&(prefix="xmlns",local=""),{prefix:prefix,local:local}}function attrib(parser){if(parser.strict||(parser.attribName=parser.attribName[parser.looseCase]()),-1!==parser.attribList.indexOf(parser.attribName)||parser.tag.attributes.hasOwnProperty(parser.attribName))return void(parser.attribName=parser.attribValue="");if(parser.opt.xmlns){var qn=qname(parser.attribName,!0),prefix=qn.prefix,local=qn.local;if("xmlns"===prefix)if("xml"===local&&parser.attribValue!==XML_NAMESPACE)strictFail(parser,"xml: prefix must be bound to "+XML_NAMESPACE+"\nActual: "+parser.attribValue);else if("xmlns"===local&&parser.attribValue!==XMLNS_NAMESPACE)strictFail(parser,"xmlns: prefix must be bound to "+XMLNS_NAMESPACE+"\nActual: "+parser.attribValue);else{var tag=parser.tag,parent=parser.tags[parser.tags.length-1]||parser;tag.ns===parent.ns&&(tag.ns=Object.create(parent.ns)),tag.ns[local]=parser.attribValue}parser.attribList.push([parser.attribName,parser.attribValue])}else parser.tag.attributes[parser.attribName]=parser.attribValue,emitNode(parser,"onattribute",{name:parser.attribName,value:parser.attribValue});parser.attribName=parser.attribValue=""}function openTag(parser,selfClosing){if(parser.opt.xmlns){var tag=parser.tag,qn=qname(parser.tagName);tag.prefix=qn.prefix,tag.local=qn.local,tag.uri=tag.ns[qn.prefix]||"",tag.prefix&&!tag.uri&&(strictFail(parser,"Unbound namespace prefix: "+JSON.stringify(parser.tagName)),tag.uri=qn.prefix);var parent=parser.tags[parser.tags.length-1]||parser;tag.ns&&parent.ns!==tag.ns&&Object.keys(tag.ns).forEach(function(p){emitNode(parser,"onopennamespace",{prefix:p,uri:tag.ns[p]})});for(var i=0,l=parser.attribList.length;l>i;i++){var nv=parser.attribList[i],name=nv[0],value=nv[1],qualName=qname(name,!0),prefix=qualName.prefix,local=qualName.local,uri=""===prefix?"":tag.ns[prefix]||"",a={name:name,value:value,prefix:prefix,local:local,uri:uri};prefix&&"xmlns"!==prefix&&!uri&&(strictFail(parser,"Unbound namespace prefix: "+JSON.stringify(prefix)),a.uri=prefix),parser.tag.attributes[name]=a,emitNode(parser,"onattribute",a)}parser.attribList.length=0}parser.tag.isSelfClosing=!!selfClosing,parser.sawRoot=!0,parser.tags.push(parser.tag),emitNode(parser,"onopentag",parser.tag),selfClosing||(parser.noscript||"script"!==parser.tagName.toLowerCase()?parser.state=S.TEXT:parser.state=S.SCRIPT,parser.tag=null,parser.tagName=""),parser.attribName=parser.attribValue="",parser.attribList.length=0}function closeTag(parser){if(!parser.tagName)return strictFail(parser,"Weird empty close tag."),parser.textNode+="</>",void(parser.state=S.TEXT);if(parser.script){if("script"!==parser.tagName)return parser.script+="</"+parser.tagName+">",parser.tagName="",void(parser.state=S.SCRIPT);emitNode(parser,"onscript",parser.script),parser.script=""}var t=parser.tags.length,tagName=parser.tagName;parser.strict||(tagName=tagName[parser.looseCase]());for(var closeTo=tagName;t--;){var close=parser.tags[t];if(close.name===closeTo)break;strictFail(parser,"Unexpected close tag")}if(0>t)return strictFail(parser,"Unmatched closing tag: "+parser.tagName),parser.textNode+="</"+parser.tagName+">",void(parser.state=S.TEXT);parser.tagName=tagName;for(var s=parser.tags.length;s-->t;){var tag=parser.tag=parser.tags.pop();parser.tagName=parser.tag.name,emitNode(parser,"onclosetag",parser.tagName);var x={};for(var i in tag.ns)x[i]=tag.ns[i];var parent=parser.tags[parser.tags.length-1]||parser;parser.opt.xmlns&&tag.ns!==parent.ns&&Object.keys(tag.ns).forEach(function(p){var n=tag.ns[p];emitNode(parser,"onclosenamespace",{prefix:p,uri:n})})}0===t&&(parser.closedRoot=!0),parser.tagName=parser.attribValue=parser.attribName="",parser.attribList.length=0,parser.state=S.TEXT}function parseEntity(parser){var num,entity=parser.entity,entityLC=entity.toLowerCase(),numStr="";return parser.ENTITIES[entity]?parser.ENTITIES[entity]:parser.ENTITIES[entityLC]?parser.ENTITIES[entityLC]:(entity=entityLC,"#"===entity.charAt(0)&&("x"===entity.charAt(1)?(entity=entity.slice(2),num=parseInt(entity,16),numStr=num.toString(16)):(entity=entity.slice(1),num=parseInt(entity,10),numStr=num.toString(10))),entity=entity.replace(/^0+/,""),numStr.toLowerCase()!==entity?(strictFail(parser,"Invalid character entity"),"&"+parser.entity+";"):String.fromCodePoint(num))}function beginWhiteSpace(parser,c){"<"===c?(parser.state=S.OPEN_WAKA,parser.startTagPosition=parser.position):not(whitespace,c)&&(strictFail(parser,"Non-whitespace before first tag."),parser.textNode=c,parser.state=S.TEXT)}function charAt(chunk,i){var result="";return i<chunk.length&&(result=chunk.charAt(i)),result}function write(chunk){var parser=this;if(this.error)throw this.error;if(parser.closed)return error(parser,"Cannot write after close. Assign an onready handler.");if(null===chunk)return end(parser);"object"==typeof chunk&&(chunk=chunk.toString());for(var i=0,c="";;){if(c=charAt(chunk,i++),parser.c=c,!c)break;switch(parser.trackPosition&&(parser.position++,"\n"===c?(parser.line++,parser.column=0):parser.column++),parser.state){case S.BEGIN:if(parser.state=S.BEGIN_WHITESPACE,"\ufeff"===c)continue;beginWhiteSpace(parser,c);continue;case S.BEGIN_WHITESPACE:beginWhiteSpace(parser,c);continue;case S.TEXT:if(parser.sawRoot&&!parser.closedRoot){for(var starti=i-1;c&&"<"!==c&&"&"!==c;)c=charAt(chunk,i++),c&&parser.trackPosition&&(parser.position++,"\n"===c?(parser.line++,parser.column=0):parser.column++);parser.textNode+=chunk.substring(starti,i-1)}"<"!==c||parser.sawRoot&&parser.closedRoot&&!parser.strict?(!not(whitespace,c)||parser.sawRoot&&!parser.closedRoot||strictFail(parser,"Text data outside of root node."),"&"===c?parser.state=S.TEXT_ENTITY:parser.textNode+=c):(parser.state=S.OPEN_WAKA,parser.startTagPosition=parser.position);continue;case S.SCRIPT:"<"===c?parser.state=S.SCRIPT_ENDING:parser.script+=c;continue;case S.SCRIPT_ENDING:"/"===c?parser.state=S.CLOSE_TAG:(parser.script+="<"+c,parser.state=S.SCRIPT);continue;case S.OPEN_WAKA:if("!"===c)parser.state=S.SGML_DECL,parser.sgmlDecl="";else if(is(whitespace,c));else if(is(nameStart,c))parser.state=S.OPEN_TAG,parser.tagName=c;else if("/"===c)parser.state=S.CLOSE_TAG,parser.tagName="";else if("?"===c)parser.state=S.PROC_INST,parser.procInstName=parser.procInstBody="";else{if(strictFail(parser,"Unencoded <"),parser.startTagPosition+1<parser.position){var pad=parser.position-parser.startTagPosition;c=new Array(pad).join(" ")+c}parser.textNode+="<"+c,parser.state=S.TEXT}continue;case S.SGML_DECL:(parser.sgmlDecl+c).toUpperCase()===CDATA?(emitNode(parser,"onopencdata"),parser.state=S.CDATA,parser.sgmlDecl="",parser.cdata=""):parser.sgmlDecl+c==="--"?(parser.state=S.COMMENT,parser.comment="",parser.sgmlDecl=""):(parser.sgmlDecl+c).toUpperCase()===DOCTYPE?(parser.state=S.DOCTYPE,(parser.doctype||parser.sawRoot)&&strictFail(parser,"Inappropriately located doctype declaration"),parser.doctype="",parser.sgmlDecl=""):">"===c?(emitNode(parser,"onsgmldeclaration",parser.sgmlDecl),parser.sgmlDecl="",parser.state=S.TEXT):is(quote,c)?(parser.state=S.SGML_DECL_QUOTED,parser.sgmlDecl+=c):parser.sgmlDecl+=c;continue;case S.SGML_DECL_QUOTED:c===parser.q&&(parser.state=S.SGML_DECL,parser.q=""),parser.sgmlDecl+=c;continue;case S.DOCTYPE:">"===c?(parser.state=S.TEXT,emitNode(parser,"ondoctype",parser.doctype),parser.doctype=!0):(parser.doctype+=c,"["===c?parser.state=S.DOCTYPE_DTD:is(quote,c)&&(parser.state=S.DOCTYPE_QUOTED,parser.q=c));continue;case S.DOCTYPE_QUOTED:parser.doctype+=c,c===parser.q&&(parser.q="",parser.state=S.DOCTYPE);continue;case S.DOCTYPE_DTD:parser.doctype+=c,"]"===c?parser.state=S.DOCTYPE:is(quote,c)&&(parser.state=S.DOCTYPE_DTD_QUOTED,parser.q=c);continue;case S.DOCTYPE_DTD_QUOTED:parser.doctype+=c,c===parser.q&&(parser.state=S.DOCTYPE_DTD,parser.q="");continue;case S.COMMENT:"-"===c?parser.state=S.COMMENT_ENDING:parser.comment+=c;continue;case S.COMMENT_ENDING:"-"===c?(parser.state=S.COMMENT_ENDED,parser.comment=textopts(parser.opt,parser.comment),parser.comment&&emitNode(parser,"oncomment",parser.comment),parser.comment=""):(parser.comment+="-"+c,parser.state=S.COMMENT);continue;case S.COMMENT_ENDED:">"!==c?(strictFail(parser,"Malformed comment"),parser.comment+="--"+c,parser.state=S.COMMENT):parser.state=S.TEXT;continue;case S.CDATA:"]"===c?parser.state=S.CDATA_ENDING:parser.cdata+=c;continue;case S.CDATA_ENDING:"]"===c?parser.state=S.CDATA_ENDING_2:(parser.cdata+="]"+c,parser.state=S.CDATA);continue;case S.CDATA_ENDING_2:">"===c?(parser.cdata&&emitNode(parser,"oncdata",parser.cdata),emitNode(parser,"onclosecdata"),parser.cdata="",parser.state=S.TEXT):"]"===c?parser.cdata+="]":(parser.cdata+="]]"+c,parser.state=S.CDATA);continue;case S.PROC_INST:"?"===c?parser.state=S.PROC_INST_ENDING:is(whitespace,c)?parser.state=S.PROC_INST_BODY:parser.procInstName+=c;continue;case S.PROC_INST_BODY:if(!parser.procInstBody&&is(whitespace,c))continue;"?"===c?parser.state=S.PROC_INST_ENDING:parser.procInstBody+=c;continue;case S.PROC_INST_ENDING:">"===c?(emitNode(parser,"onprocessinginstruction",{name:parser.procInstName,body:parser.procInstBody}),parser.procInstName=parser.procInstBody="",parser.state=S.TEXT):(parser.procInstBody+="?"+c,parser.state=S.PROC_INST_BODY);continue;case S.OPEN_TAG:is(nameBody,c)?parser.tagName+=c:(newTag(parser),">"===c?openTag(parser):"/"===c?parser.state=S.OPEN_TAG_SLASH:(not(whitespace,c)&&strictFail(parser,"Invalid character in tag name"),parser.state=S.ATTRIB));continue;case S.OPEN_TAG_SLASH:">"===c?(openTag(parser,!0),closeTag(parser)):(strictFail(parser,"Forward-slash in opening tag not followed by >"),parser.state=S.ATTRIB);continue;case S.ATTRIB:if(is(whitespace,c))continue;">"===c?openTag(parser):"/"===c?parser.state=S.OPEN_TAG_SLASH:is(nameStart,c)?(parser.attribName=c,parser.attribValue="",parser.state=S.ATTRIB_NAME):strictFail(parser,"Invalid attribute name");continue;case S.ATTRIB_NAME:"="===c?parser.state=S.ATTRIB_VALUE:">"===c?(strictFail(parser,"Attribute without value"),parser.attribValue=parser.attribName,attrib(parser),openTag(parser)):is(whitespace,c)?parser.state=S.ATTRIB_NAME_SAW_WHITE:is(nameBody,c)?parser.attribName+=c:strictFail(parser,"Invalid attribute name");continue;case S.ATTRIB_NAME_SAW_WHITE:if("="===c)parser.state=S.ATTRIB_VALUE;else{if(is(whitespace,c))continue;strictFail(parser,"Attribute without value"),parser.tag.attributes[parser.attribName]="",parser.attribValue="",emitNode(parser,"onattribute",{name:parser.attribName,value:""}),parser.attribName="",">"===c?openTag(parser):is(nameStart,c)?(parser.attribName=c,parser.state=S.ATTRIB_NAME):(strictFail(parser,"Invalid attribute name"),parser.state=S.ATTRIB)}continue;case S.ATTRIB_VALUE:if(is(whitespace,c))continue;is(quote,c)?(parser.q=c,parser.state=S.ATTRIB_VALUE_QUOTED):(strictFail(parser,"Unquoted attribute value"),parser.state=S.ATTRIB_VALUE_UNQUOTED,parser.attribValue=c);continue;case S.ATTRIB_VALUE_QUOTED:if(c!==parser.q){"&"===c?parser.state=S.ATTRIB_VALUE_ENTITY_Q:parser.attribValue+=c;continue}attrib(parser),parser.q="",parser.state=S.ATTRIB_VALUE_CLOSED;continue;case S.ATTRIB_VALUE_CLOSED:is(whitespace,c)?parser.state=S.ATTRIB:">"===c?openTag(parser):"/"===c?parser.state=S.OPEN_TAG_SLASH:is(nameStart,c)?(strictFail(parser,"No whitespace between attributes"),parser.attribName=c,parser.attribValue="",parser.state=S.ATTRIB_NAME):strictFail(parser,"Invalid attribute name");continue;case S.ATTRIB_VALUE_UNQUOTED:if(not(attribEnd,c)){"&"===c?parser.state=S.ATTRIB_VALUE_ENTITY_U:parser.attribValue+=c;continue}attrib(parser),">"===c?openTag(parser):parser.state=S.ATTRIB;continue;case S.CLOSE_TAG:if(parser.tagName)">"===c?closeTag(parser):is(nameBody,c)?parser.tagName+=c:parser.script?(parser.script+="</"+parser.tagName,parser.tagName="",parser.state=S.SCRIPT):(not(whitespace,c)&&strictFail(parser,"Invalid tagname in closing tag"),parser.state=S.CLOSE_TAG_SAW_WHITE);else{if(is(whitespace,c))continue;not(nameStart,c)?parser.script?(parser.script+="</"+c,parser.state=S.SCRIPT):strictFail(parser,"Invalid tagname in closing tag."):parser.tagName=c}continue;case S.CLOSE_TAG_SAW_WHITE:if(is(whitespace,c))continue;">"===c?closeTag(parser):strictFail(parser,"Invalid characters in closing tag");continue;case S.TEXT_ENTITY:case S.ATTRIB_VALUE_ENTITY_Q:case S.ATTRIB_VALUE_ENTITY_U:var returnState,buffer;switch(parser.state){case S.TEXT_ENTITY:returnState=S.TEXT,buffer="textNode";break;case S.ATTRIB_VALUE_ENTITY_Q:returnState=S.ATTRIB_VALUE_QUOTED,buffer="attribValue";break;case S.ATTRIB_VALUE_ENTITY_U:returnState=S.ATTRIB_VALUE_UNQUOTED,buffer="attribValue"}";"===c?(parser[buffer]+=parseEntity(parser),parser.entity="",parser.state=returnState):is(parser.entity.length?entityBody:entityStart,c)?parser.entity+=c:(strictFail(parser,"Invalid character in entity name"),parser[buffer]+="&"+parser.entity+c,parser.entity="",parser.state=returnState);continue;default:throw new Error(parser,"Unknown state: "+parser.state)}}return parser.position>=parser.bufferCheckPosition&&checkBufferLength(parser),parser}sax.parser=function(strict,opt){return new SAXParser(strict,opt)},sax.SAXParser=SAXParser,sax.SAXStream=SAXStream,sax.createStream=createStream,sax.MAX_BUFFER_LENGTH=65536;var buffers=["comment","sgmlDecl","textNode","tagName","doctype","procInstName","procInstBody","entity","attribName","attribValue","cdata","script"];sax.EVENTS=["text","processinginstruction","sgmldeclaration","doctype","comment","opentagstart","attribute","opentag","closetag","opencdata","cdata","closecdata","error","end","ready","script","opennamespace","closenamespace"],Object.create||(Object.create=function(o){function F(){}F.prototype=o;var newf=new F;return newf}),Object.keys||(Object.keys=function(o){var a=[];for(var i in o)o.hasOwnProperty(i)&&a.push(i);return a}),SAXParser.prototype={end:function(){end(this)},write:write,resume:function(){return this.error=null,this},close:function(){return this.write(null)},flush:function(){flushBuffers(this)}};var Stream;try{Stream=__webpack_require__(176).Stream}catch(ex){Stream=function(){}}var streamWraps=sax.EVENTS.filter(function(ev){return"error"!==ev&&"end"!==ev});SAXStream.prototype=Object.create(Stream.prototype,{constructor:{value:SAXStream}}),SAXStream.prototype.write=function(data){if("function"==typeof Buffer&&"function"==typeof Buffer.isBuffer&&Buffer.isBuffer(data)){if(!this._decoder){var SD=__webpack_require__(249).StringDecoder;this._decoder=new SD("utf8")}data=this._decoder.write(data)}return this._parser.write(data.toString()),this.emit("data",data),!0},SAXStream.prototype.end=function(chunk){return chunk&&chunk.length&&this.write(chunk),this._parser.end(),!0},SAXStream.prototype.on=function(ev,handler){var me=this;return me._parser["on"+ev]||-1===streamWraps.indexOf(ev)||(me._parser["on"+ev]=function(){var args=1===arguments.length?[arguments[0]]:Array.apply(null,arguments);args.splice(0,0,ev),me.emit.apply(me,args)}),Stream.prototype.on.call(me,ev,handler)};var whitespace="\r\n	 ",number="0124356789",letter="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ",quote="'\"",attribEnd=whitespace+">",CDATA="[CDATA[",DOCTYPE="DOCTYPE",XML_NAMESPACE="http://www.w3.org/XML/1998/namespace",XMLNS_NAMESPACE="http://www.w3.org/2000/xmlns/",rootNS={xml:XML_NAMESPACE,xmlns:XMLNS_NAMESPACE};whitespace=charClass(whitespace),number=charClass(number),letter=charClass(letter);var nameStart=/[:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/,nameBody=/[:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\u00B7\u0300-\u036F\u203F-\u2040\.\d-]/,entityStart=/[#:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD]/,entityBody=/[#:_A-Za-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\u00B7\u0300-\u036F\u203F-\u2040\.\d-]/;quote=charClass(quote),attribEnd=charClass(attribEnd);var S=0;sax.STATE={BEGIN:S++,BEGIN_WHITESPACE:S++,TEXT:S++,TEXT_ENTITY:S++,OPEN_WAKA:S++,SGML_DECL:S++,SGML_DECL_QUOTED:S++,DOCTYPE:S++,DOCTYPE_QUOTED:S++,DOCTYPE_DTD:S++,DOCTYPE_DTD_QUOTED:S++,COMMENT_STARTING:S++,COMMENT:S++,COMMENT_ENDING:S++,COMMENT_ENDED:S++,CDATA:S++,CDATA_ENDING:S++,CDATA_ENDING_2:S++,PROC_INST:S++,PROC_INST_BODY:S++,PROC_INST_ENDING:S++,OPEN_TAG:S++,OPEN_TAG_SLASH:S++,ATTRIB:S++,ATTRIB_NAME:S++,ATTRIB_NAME_SAW_WHITE:S++,ATTRIB_VALUE:S++,ATTRIB_VALUE_QUOTED:S++,ATTRIB_VALUE_CLOSED:S++,ATTRIB_VALUE_UNQUOTED:S++,ATTRIB_VALUE_ENTITY_Q:S++,ATTRIB_VALUE_ENTITY_U:S++,CLOSE_TAG:S++,CLOSE_TAG_SAW_WHITE:S++,SCRIPT:S++,SCRIPT_ENDING:S++},sax.XML_ENTITIES={amp:"&",gt:">",lt:"<",quot:'"',apos:"'"},sax.ENTITIES={amp:"&",gt:">",lt:"<",quot:'"',apos:"'",AElig:198,Aacute:193,Acirc:194,Agrave:192,Aring:197,Atilde:195,Auml:196,Ccedil:199,ETH:208,Eacute:201,Ecirc:202,Egrave:200,Euml:203,Iacute:205,Icirc:206,Igrave:204,Iuml:207,Ntilde:209,Oacute:211,Ocirc:212,Ograve:210,Oslash:216,Otilde:213,Ouml:214,THORN:222,Uacute:218,Ucirc:219,Ugrave:217,Uuml:220,Yacute:221,aacute:225,acirc:226,aelig:230,agrave:224,aring:229,atilde:227,auml:228,ccedil:231,eacute:233,ecirc:234,egrave:232,eth:240,euml:235,iacute:237,icirc:238,igrave:236,iuml:239,ntilde:241,oacute:243,ocirc:244,ograve:242,oslash:248,otilde:245,ouml:246,szlig:223,thorn:254,uacute:250,ucirc:251,ugrave:249,uuml:252,yacute:253,yuml:255,copy:169,reg:174,nbsp:160,iexcl:161,cent:162,pound:163,curren:164,yen:165,brvbar:166,sect:167,uml:168,ordf:170,laquo:171,not:172,shy:173,macr:175,deg:176,plusmn:177,sup1:185,sup2:178,sup3:179,acute:180,micro:181,para:182,middot:183,cedil:184,ordm:186,raquo:187,frac14:188,frac12:189,frac34:190,iquest:191,times:215,divide:247,OElig:338,oelig:339,Scaron:352,scaron:353,Yuml:376,fnof:402,circ:710,tilde:732,Alpha:913,Beta:914,Gamma:915,Delta:916,Epsilon:917,Zeta:918,Eta:919,Theta:920,Iota:921,Kappa:922,Lambda:923,Mu:924,Nu:925,Xi:926,Omicron:927,Pi:928,Rho:929,Sigma:931,Tau:932,Upsilon:933,Phi:934,Chi:935,Psi:936,Omega:937,alpha:945,beta:946,gamma:947,delta:948,epsilon:949,zeta:950,eta:951,theta:952,iota:953,kappa:954,lambda:955,mu:956,nu:957,xi:958,omicron:959,pi:960,rho:961,sigmaf:962,sigma:963,tau:964,upsilon:965,phi:966,chi:967,psi:968,omega:969,thetasym:977,upsih:978,piv:982,ensp:8194,emsp:8195,thinsp:8201,zwnj:8204,zwj:8205,lrm:8206,rlm:8207,ndash:8211,mdash:8212,lsquo:8216,rsquo:8217,sbquo:8218,ldquo:8220,rdquo:8221,bdquo:8222,dagger:8224,Dagger:8225,bull:8226,hellip:8230,permil:8240,prime:8242,Prime:8243,lsaquo:8249,rsaquo:8250,oline:8254,frasl:8260,euro:8364,image:8465,weierp:8472,real:8476,trade:8482,alefsym:8501,larr:8592,uarr:8593,rarr:8594,darr:8595,harr:8596,crarr:8629,lArr:8656,uArr:8657,rArr:8658,dArr:8659,hArr:8660,forall:8704,part:8706,exist:8707,empty:8709,nabla:8711,isin:8712,notin:8713,ni:8715,prod:8719,sum:8721,minus:8722,lowast:8727,radic:8730,prop:8733,infin:8734,ang:8736,and:8743,or:8744,cap:8745,cup:8746,"int":8747,there4:8756,sim:8764,cong:8773,asymp:8776,ne:8800,equiv:8801,le:8804,ge:8805,sub:8834,sup:8835,nsub:8836,sube:8838,supe:8839,oplus:8853,otimes:8855,perp:8869,sdot:8901,lceil:8968,rceil:8969,lfloor:8970,rfloor:8971,lang:9001,rang:9002,loz:9674,spades:9824,clubs:9827,hearts:9829,diams:9830},Object.keys(sax.ENTITIES).forEach(function(key){var e=sax.ENTITIES[key],s="number"==typeof e?String.fromCharCode(e):e;sax.ENTITIES[key]=s});for(var s in sax.STATE)sax.STATE[sax.STATE[s]]=s;S=sax.STATE,String.fromCodePoint||!function(){var stringFromCharCode=String.fromCharCode,floor=Math.floor,fromCodePoint=function(){var highSurrogate,lowSurrogate,MAX_SIZE=16384,codeUnits=[],index=-1,length=arguments.length;if(!length)return"";for(var result="";++index<length;){var codePoint=Number(arguments[index]);if(!isFinite(codePoint)||0>codePoint||codePoint>1114111||floor(codePoint)!==codePoint)throw RangeError("Invalid code point: "+codePoint);65535>=codePoint?codeUnits.push(codePoint):(codePoint-=65536,highSurrogate=(codePoint>>10)+55296,lowSurrogate=codePoint%1024+56320,codeUnits.push(highSurrogate,lowSurrogate)),(index+1===length||codeUnits.length>MAX_SIZE)&&(result+=stringFromCharCode.apply(null,codeUnits),codeUnits.length=0)}return result};Object.defineProperty?Object.defineProperty(String,"fromCodePoint",{value:fromCodePoint,configurable:!0,writable:!0}):String.fromCodePoint=fromCodePoint}()}("undefined"==typeof exports?this.sax={}:exports)}).call(exports,__webpack_require__(92).Buffer)},function(module,exports,__webpack_require__){(function(){var XMLBuilder,assign;assign=__webpack_require__(259),XMLBuilder=__webpack_require__(250),module.exports.create=function(name,xmldec,doctype,options){return options=assign({},xmldec,doctype,options),new XMLBuilder(name,options).root()}}).call(this)},function(module,exports,__webpack_require__){},function(module,exports,__webpack_require__){function assertEncoding(encoding){if(encoding&&!isBufferEncoding(encoding))throw new Error("Unknown encoding: "+encoding)}function passThroughWrite(buffer){return buffer.toString(this.encoding)}function utf16DetectIncompleteChar(buffer){this.charReceived=buffer.length%2,this.charLength=this.charReceived?2:0}function base64DetectIncompleteChar(buffer){this.charReceived=buffer.length%3,this.charLength=this.charReceived?3:0}var Buffer=__webpack_require__(92).Buffer,isBufferEncoding=Buffer.isEncoding||function(encoding){switch(encoding&&encoding.toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":case"raw":return!0;default:return!1}},StringDecoder=exports.StringDecoder=function(encoding){switch(this.encoding=(encoding||"utf8").toLowerCase().replace(/[-_]/,""),assertEncoding(encoding),this.encoding){case"utf8":this.surrogateSize=3;break;case"ucs2":case"utf16le":this.surrogateSize=2,this.detectIncompleteChar=utf16DetectIncompleteChar;break;case"base64":this.surrogateSize=3,this.detectIncompleteChar=base64DetectIncompleteChar;break;default:return void(this.write=passThroughWrite)}this.charBuffer=new Buffer(6),this.charReceived=0,this.charLength=0};StringDecoder.prototype.write=function(buffer){for(var charStr="";this.charLength;){var available=buffer.length>=this.charLength-this.charReceived?this.charLength-this.charReceived:buffer.length;if(buffer.copy(this.charBuffer,this.charReceived,0,available),this.charReceived+=available,this.charReceived<this.charLength)return"";buffer=buffer.slice(available,buffer.length),charStr=this.charBuffer.slice(0,this.charLength).toString(this.encoding);var charCode=charStr.charCodeAt(charStr.length-1);if(!(charCode>=55296&&56319>=charCode)){if(this.charReceived=this.charLength=0,0===buffer.length)return charStr;break}this.charLength+=this.surrogateSize,charStr=""}this.detectIncompleteChar(buffer);var end=buffer.length;this.charLength&&(buffer.copy(this.charBuffer,0,buffer.length-this.charReceived,end),end-=this.charReceived),charStr+=buffer.toString(this.encoding,0,end);var end=charStr.length-1,charCode=charStr.charCodeAt(end);if(charCode>=55296&&56319>=charCode){var size=this.surrogateSize;return this.charLength+=size,this.charReceived+=size,this.charBuffer.copy(this.charBuffer,size,0,size),buffer.copy(this.charBuffer,0,0,size),charStr.substring(0,end)}return charStr},StringDecoder.prototype.detectIncompleteChar=function(buffer){for(var i=buffer.length>=3?3:buffer.length;i>0;i--){var c=buffer[buffer.length-i];if(1==i&&c>>5==6){this.charLength=2;break}if(2>=i&&c>>4==14){this.charLength=3;break}if(3>=i&&c>>3==30){this.charLength=4;break}}this.charReceived=i},StringDecoder.prototype.end=function(buffer){var res="";if(buffer&&buffer.length&&(res=this.write(buffer)),this.charReceived){var cr=this.charReceived,buf=this.charBuffer,enc=this.encoding;res+=buf.slice(0,cr).toString(enc)}return res}},function(module,exports,__webpack_require__){(function(){var XMLBuilder,XMLDeclaration,XMLDocType,XMLElement,XMLStringifier;XMLStringifier=__webpack_require__(255),XMLDeclaration=__webpack_require__(256),XMLDocType=__webpack_require__(257),XMLElement=__webpack_require__(258),module.exports=XMLBuilder=function(){function XMLBuilder(name,options){var root,temp;if(null==name)throw new Error("Root element needs a name");null==options&&(options={}),this.options=options,this.stringify=new XMLStringifier(options),temp=new XMLElement(this,"doc"),root=temp.element(name),root.isRoot=!0,root.documentObject=this,this.rootObject=root,options.headless||(root.declaration(options),(null!=options.pubID||null!=options.sysID)&&root.doctype(options))}return XMLBuilder.prototype.root=function(){return this.rootObject},XMLBuilder.prototype.end=function(options){return this.toString(options)},XMLBuilder.prototype.toString=function(options){var indent,newline,offset,pretty,r,ref,ref1,ref2;return pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",r="",null!=this.xmldec&&(r+=this.xmldec.toString(options)),null!=this.doctype&&(r+=this.doctype.toString(options)),r+=this.rootObject.toString(options),pretty&&r.slice(-newline.length)===newline&&(r=r.slice(0,-newline.length)),r},XMLBuilder}()}).call(this)},function(module,exports,__webpack_require__){module.exports=Array.isArray||function(arr){return"[object Array]"==Object.prototype.toString.call(arr)}},function(module,exports,__webpack_require__){"function"==typeof Object.create?module.exports=function(ctor,superCtor){ctor.super_=superCtor,ctor.prototype=Object.create(superCtor.prototype,{constructor:{value:ctor,enumerable:!1,writable:!0,configurable:!0}})}:module.exports=function(ctor,superCtor){ctor.super_=superCtor;var TempCtor=function(){};TempCtor.prototype=superCtor.prototype,ctor.prototype=new TempCtor,ctor.prototype.constructor=ctor}},function(module,exports,__webpack_require__){function cleanUpNextTick(){draining&&currentQueue&&(draining=!1,currentQueue.length?queue=currentQueue.concat(queue):queueIndex=-1,queue.length&&drainQueue())}function drainQueue(){if(!draining){var timeout=setTimeout(cleanUpNextTick);draining=!0;for(var len=queue.length;len;){for(currentQueue=queue,queue=[];++queueIndex<len;)currentQueue&&currentQueue[queueIndex].run();queueIndex=-1,len=queue.length}currentQueue=null,draining=!1,clearTimeout(timeout)}}function Item(fun,array){this.fun=fun,this.array=array}function noop(){}var currentQueue,process=module.exports={},queue=[],draining=!1,queueIndex=-1;process.nextTick=function(fun){var args=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)args[i-1]=arguments[i];queue.push(new Item(fun,args)),1!==queue.length||draining||setTimeout(drainQueue,0)},Item.prototype.run=function(){this.fun.apply(null,this.array)},process.title="browser",process.browser=!0,process.env={},process.argv=[],process.version="",process.versions={},process.on=noop,process.addListener=noop,process.once=noop,process.off=noop,process.removeListener=noop,process.removeAllListeners=noop,process.emit=noop,process.binding=function(name){throw new Error("process.binding is not supported")},process.cwd=function(){return"/"},process.chdir=function(dir){throw new Error("process.chdir is not supported")},process.umask=function(){return 0}},function(module,exports,__webpack_require__){(function(Buffer){function isArray(arg){return Array.isArray?Array.isArray(arg):"[object Array]"===objectToString(arg)}function isBoolean(arg){return"boolean"==typeof arg}function isNull(arg){return null===arg}function isNullOrUndefined(arg){return null==arg}function isNumber(arg){return"number"==typeof arg}function isString(arg){return"string"==typeof arg}function isSymbol(arg){return"symbol"==typeof arg}function isUndefined(arg){return void 0===arg}function isRegExp(re){return"[object RegExp]"===objectToString(re)}function isObject(arg){return"object"==typeof arg&&null!==arg}function isDate(d){return"[object Date]"===objectToString(d)}function isError(e){return"[object Error]"===objectToString(e)||e instanceof Error}function isFunction(arg){return"function"==typeof arg}function isPrimitive(arg){return null===arg||"boolean"==typeof arg||"number"==typeof arg||"string"==typeof arg||"symbol"==typeof arg||"undefined"==typeof arg}function objectToString(o){return Object.prototype.toString.call(o)}exports.isArray=isArray,exports.isBoolean=isBoolean,exports.isNull=isNull,exports.isNullOrUndefined=isNullOrUndefined,exports.isNumber=isNumber,exports.isString=isString,exports.isSymbol=isSymbol,exports.isUndefined=isUndefined,exports.isRegExp=isRegExp,exports.isObject=isObject,exports.isDate=isDate,exports.isError=isError,exports.isFunction=isFunction,exports.isPrimitive=isPrimitive,exports.isBuffer=Buffer.isBuffer}).call(exports,__webpack_require__(92).Buffer)},function(module,exports,__webpack_require__){(function(){var XMLStringifier,bind=function(fn,me){return function(){return fn.apply(me,arguments)}},hasProp={}.hasOwnProperty;module.exports=XMLStringifier=function(){function XMLStringifier(options){this.assertLegalChar=bind(this.assertLegalChar,this);var key,ref,value;this.allowSurrogateChars=null!=options?options.allowSurrogateChars:void 0,this.noDoubleEncoding=null!=options?options.noDoubleEncoding:void 0,ref=(null!=options?options.stringify:void 0)||{};for(key in ref)hasProp.call(ref,key)&&(value=ref[key],this[key]=value)}return XMLStringifier.prototype.eleName=function(val){return val=""+val||"",this.assertLegalChar(val)},XMLStringifier.prototype.eleText=function(val){return val=""+val||"",this.assertLegalChar(this.elEscape(val))},XMLStringifier.prototype.cdata=function(val){if(val=""+val||"",val.match(/]]>/))throw new Error("Invalid CDATA text: "+val);return this.assertLegalChar(val)},XMLStringifier.prototype.comment=function(val){if(val=""+val||"",val.match(/--/))throw new Error("Comment text cannot contain double-hypen: "+val);return this.assertLegalChar(val)},XMLStringifier.prototype.raw=function(val){return""+val||""},XMLStringifier.prototype.attName=function(val){return""+val||""},XMLStringifier.prototype.attValue=function(val){return val=""+val||"",this.attEscape(val)},XMLStringifier.prototype.insTarget=function(val){return""+val||""},XMLStringifier.prototype.insValue=function(val){if(val=""+val||"",val.match(/\?>/))throw new Error("Invalid processing instruction value: "+val);return val},XMLStringifier.prototype.xmlVersion=function(val){if(val=""+val||"",
!val.match(/1\.[0-9]+/))throw new Error("Invalid version number: "+val);return val},XMLStringifier.prototype.xmlEncoding=function(val){if(val=""+val||"",!val.match(/^[A-Za-z](?:[A-Za-z0-9._-]|-)*$/))throw new Error("Invalid encoding: "+val);return val},XMLStringifier.prototype.xmlStandalone=function(val){return val?"yes":"no"},XMLStringifier.prototype.dtdPubID=function(val){return""+val||""},XMLStringifier.prototype.dtdSysID=function(val){return""+val||""},XMLStringifier.prototype.dtdElementValue=function(val){return""+val||""},XMLStringifier.prototype.dtdAttType=function(val){return""+val||""},XMLStringifier.prototype.dtdAttDefault=function(val){return null!=val?""+val||"":val},XMLStringifier.prototype.dtdEntityValue=function(val){return""+val||""},XMLStringifier.prototype.dtdNData=function(val){return""+val||""},XMLStringifier.prototype.convertAttKey="@",XMLStringifier.prototype.convertPIKey="?",XMLStringifier.prototype.convertTextKey="#text",XMLStringifier.prototype.convertCDataKey="#cdata",XMLStringifier.prototype.convertCommentKey="#comment",XMLStringifier.prototype.convertRawKey="#raw",XMLStringifier.prototype.assertLegalChar=function(str){var chars,chr;if(chars=this.allowSurrogateChars?/[\u0000-\u0008\u000B-\u000C\u000E-\u001F\uFFFE-\uFFFF]/:/[\u0000-\u0008\u000B-\u000C\u000E-\u001F\uD800-\uDFFF\uFFFE-\uFFFF]/,chr=str.match(chars))throw new Error("Invalid character ("+chr+") in string: "+str+" at index "+chr.index);return str},XMLStringifier.prototype.elEscape=function(str){var ampregex;return ampregex=this.noDoubleEncoding?/(?!&\S+;)&/g:/&/g,str.replace(ampregex,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/\r/g,"&#xD;")},XMLStringifier.prototype.attEscape=function(str){var ampregex;return ampregex=this.noDoubleEncoding?/(?!&\S+;)&/g:/&/g,str.replace(ampregex,"&amp;").replace(/</g,"&lt;").replace(/"/g,"&quot;")},XMLStringifier}()}).call(this)},function(module,exports,__webpack_require__){(function(){var XMLDeclaration,XMLNode,create,isObject,extend=function(child,parent){function ctor(){this.constructor=child}for(var key in parent)hasProp.call(parent,key)&&(child[key]=parent[key]);return ctor.prototype=parent.prototype,child.prototype=new ctor,child.__super__=parent.prototype,child},hasProp={}.hasOwnProperty;create=__webpack_require__(260),isObject=__webpack_require__(261),XMLNode=__webpack_require__(269),module.exports=XMLDeclaration=function(superClass){function XMLDeclaration(parent,version,encoding,standalone){var ref;XMLDeclaration.__super__.constructor.call(this,parent),isObject(version)&&(ref=version,version=ref.version,encoding=ref.encoding,standalone=ref.standalone),version||(version="1.0"),this.version=this.stringify.xmlVersion(version),null!=encoding&&(this.encoding=this.stringify.xmlEncoding(encoding)),null!=standalone&&(this.standalone=this.stringify.xmlStandalone(standalone))}return extend(XMLDeclaration,superClass),XMLDeclaration.prototype.toString=function(options,level){var indent,newline,offset,pretty,r,ref,ref1,ref2,space;return pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",level||(level=0),space=new Array(level+offset+1).join(indent),r="",pretty&&(r+=space),r+="<?xml",r+=' version="'+this.version+'"',null!=this.encoding&&(r+=' encoding="'+this.encoding+'"'),null!=this.standalone&&(r+=' standalone="'+this.standalone+'"'),r+="?>",pretty&&(r+=newline),r},XMLDeclaration}(XMLNode)}).call(this)},function(module,exports,__webpack_require__){(function(){var XMLCData,XMLComment,XMLDTDAttList,XMLDTDElement,XMLDTDEntity,XMLDTDNotation,XMLDocType,XMLProcessingInstruction,create,isObject;create=__webpack_require__(260),isObject=__webpack_require__(261),XMLCData=__webpack_require__(262),XMLComment=__webpack_require__(263),XMLDTDAttList=__webpack_require__(264),XMLDTDEntity=__webpack_require__(265),XMLDTDElement=__webpack_require__(266),XMLDTDNotation=__webpack_require__(267),XMLProcessingInstruction=__webpack_require__(268),module.exports=XMLDocType=function(){function XMLDocType(parent,pubID,sysID){var ref,ref1;this.documentObject=parent,this.stringify=this.documentObject.stringify,this.children=[],isObject(pubID)&&(ref=pubID,pubID=ref.pubID,sysID=ref.sysID),null==sysID&&(ref1=[pubID,sysID],sysID=ref1[0],pubID=ref1[1]),null!=pubID&&(this.pubID=this.stringify.dtdPubID(pubID)),null!=sysID&&(this.sysID=this.stringify.dtdSysID(sysID))}return XMLDocType.prototype.element=function(name,value){var child;return child=new XMLDTDElement(this,name,value),this.children.push(child),this},XMLDocType.prototype.attList=function(elementName,attributeName,attributeType,defaultValueType,defaultValue){var child;return child=new XMLDTDAttList(this,elementName,attributeName,attributeType,defaultValueType,defaultValue),this.children.push(child),this},XMLDocType.prototype.entity=function(name,value){var child;return child=new XMLDTDEntity(this,!1,name,value),this.children.push(child),this},XMLDocType.prototype.pEntity=function(name,value){var child;return child=new XMLDTDEntity(this,!0,name,value),this.children.push(child),this},XMLDocType.prototype.notation=function(name,value){var child;return child=new XMLDTDNotation(this,name,value),this.children.push(child),this},XMLDocType.prototype.cdata=function(value){var child;return child=new XMLCData(this,value),this.children.push(child),this},XMLDocType.prototype.comment=function(value){var child;return child=new XMLComment(this,value),this.children.push(child),this},XMLDocType.prototype.instruction=function(target,value){var child;return child=new XMLProcessingInstruction(this,target,value),this.children.push(child),this},XMLDocType.prototype.root=function(){return this.documentObject.root()},XMLDocType.prototype.document=function(){return this.documentObject},XMLDocType.prototype.toString=function(options,level){var child,i,indent,len,newline,offset,pretty,r,ref,ref1,ref2,ref3,space;if(pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",level||(level=0),space=new Array(level+offset+1).join(indent),r="",pretty&&(r+=space),r+="<!DOCTYPE "+this.root().name,this.pubID&&this.sysID?r+=' PUBLIC "'+this.pubID+'" "'+this.sysID+'"':this.sysID&&(r+=' SYSTEM "'+this.sysID+'"'),this.children.length>0){for(r+=" [",pretty&&(r+=newline),ref3=this.children,i=0,len=ref3.length;len>i;i++)child=ref3[i],r+=child.toString(options,level+1);r+="]"}return r+=">",pretty&&(r+=newline),r},XMLDocType.prototype.ele=function(name,value){return this.element(name,value)},XMLDocType.prototype.att=function(elementName,attributeName,attributeType,defaultValueType,defaultValue){return this.attList(elementName,attributeName,attributeType,defaultValueType,defaultValue)},XMLDocType.prototype.ent=function(name,value){return this.entity(name,value)},XMLDocType.prototype.pent=function(name,value){return this.pEntity(name,value)},XMLDocType.prototype.not=function(name,value){return this.notation(name,value)},XMLDocType.prototype.dat=function(value){return this.cdata(value)},XMLDocType.prototype.com=function(value){return this.comment(value)},XMLDocType.prototype.ins=function(target,value){return this.instruction(target,value)},XMLDocType.prototype.up=function(){return this.root()},XMLDocType.prototype.doc=function(){return this.document()},XMLDocType}()}).call(this)},function(module,exports,__webpack_require__){(function(){var XMLAttribute,XMLElement,XMLNode,XMLProcessingInstruction,create,every,isFunction,isObject,extend=function(child,parent){function ctor(){this.constructor=child}for(var key in parent)hasProp.call(parent,key)&&(child[key]=parent[key]);return ctor.prototype=parent.prototype,child.prototype=new ctor,child.__super__=parent.prototype,child},hasProp={}.hasOwnProperty;create=__webpack_require__(260),isObject=__webpack_require__(261),isFunction=__webpack_require__(270),every=__webpack_require__(271),XMLNode=__webpack_require__(269),XMLAttribute=__webpack_require__(272),XMLProcessingInstruction=__webpack_require__(268),module.exports=XMLElement=function(superClass){function XMLElement(parent,name,attributes){if(XMLElement.__super__.constructor.call(this,parent),null==name)throw new Error("Missing element name");this.name=this.stringify.eleName(name),this.children=[],this.instructions=[],this.attributes={},null!=attributes&&this.attribute(attributes)}return extend(XMLElement,superClass),XMLElement.prototype.clone=function(){var att,attName,clonedSelf,i,len,pi,ref,ref1;clonedSelf=create(XMLElement.prototype,this),clonedSelf.isRoot&&(clonedSelf.documentObject=null),clonedSelf.attributes={},ref=this.attributes;for(attName in ref)hasProp.call(ref,attName)&&(att=ref[attName],clonedSelf.attributes[attName]=att.clone());for(clonedSelf.instructions=[],ref1=this.instructions,i=0,len=ref1.length;len>i;i++)pi=ref1[i],clonedSelf.instructions.push(pi.clone());return clonedSelf.children=[],this.children.forEach(function(child){var clonedChild;return clonedChild=child.clone(),clonedChild.parent=clonedSelf,clonedSelf.children.push(clonedChild)}),clonedSelf},XMLElement.prototype.attribute=function(name,value){var attName,attValue;if(null!=name&&(name=name.valueOf()),isObject(name))for(attName in name)hasProp.call(name,attName)&&(attValue=name[attName],this.attribute(attName,attValue));else isFunction(value)&&(value=value.apply()),this.options.skipNullAttributes&&null==value||(this.attributes[name]=new XMLAttribute(this,name,value));return this},XMLElement.prototype.removeAttribute=function(name){var attName,i,len;if(null==name)throw new Error("Missing attribute name");if(name=name.valueOf(),Array.isArray(name))for(i=0,len=name.length;len>i;i++)attName=name[i],delete this.attributes[attName];else delete this.attributes[name];return this},XMLElement.prototype.instruction=function(target,value){var i,insTarget,insValue,instruction,len;if(null!=target&&(target=target.valueOf()),null!=value&&(value=value.valueOf()),Array.isArray(target))for(i=0,len=target.length;len>i;i++)insTarget=target[i],this.instruction(insTarget);else if(isObject(target))for(insTarget in target)hasProp.call(target,insTarget)&&(insValue=target[insTarget],this.instruction(insTarget,insValue));else isFunction(value)&&(value=value.apply()),instruction=new XMLProcessingInstruction(this,target,value),this.instructions.push(instruction);return this},XMLElement.prototype.toString=function(options,level){var att,child,i,indent,instruction,j,len,len1,name,newline,offset,pretty,r,ref,ref1,ref2,ref3,ref4,ref5,space;for(pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",level||(level=0),space=new Array(level+offset+1).join(indent),r="",ref3=this.instructions,i=0,len=ref3.length;len>i;i++)instruction=ref3[i],r+=instruction.toString(options,level);pretty&&(r+=space),r+="<"+this.name,ref4=this.attributes;for(name in ref4)hasProp.call(ref4,name)&&(att=ref4[name],r+=att.toString(options));if(0===this.children.length||every(this.children,function(e){return""===e.value}))r+="/>",pretty&&(r+=newline);else if(pretty&&1===this.children.length&&null!=this.children[0].value)r+=">",r+=this.children[0].value,r+="</"+this.name+">",r+=newline;else{for(r+=">",pretty&&(r+=newline),ref5=this.children,j=0,len1=ref5.length;len1>j;j++)child=ref5[j],r+=child.toString(options,level+1);pretty&&(r+=space),r+="</"+this.name+">",pretty&&(r+=newline)}return r},XMLElement.prototype.att=function(name,value){return this.attribute(name,value)},XMLElement.prototype.ins=function(target,value){return this.instruction(target,value)},XMLElement.prototype.a=function(name,value){return this.attribute(name,value)},XMLElement.prototype.i=function(target,value){return this.instruction(target,value)},XMLElement}(XMLNode)}).call(this)},function(module,exports,__webpack_require__){var assignValue=__webpack_require__(273),copyObject=__webpack_require__(274),createAssigner=__webpack_require__(275),isArrayLike=__webpack_require__(276),isPrototype=__webpack_require__(277),keys=__webpack_require__(278),objectProto=Object.prototype,hasOwnProperty=objectProto.hasOwnProperty,propertyIsEnumerable=objectProto.propertyIsEnumerable,nonEnumShadows=!propertyIsEnumerable.call({valueOf:1},"valueOf"),assign=createAssigner(function(object,source){if(nonEnumShadows||isPrototype(source)||isArrayLike(source))return void copyObject(source,keys(source),object);for(var key in source)hasOwnProperty.call(source,key)&&assignValue(object,key,source[key])});module.exports=assign},function(module,exports,__webpack_require__){function create(prototype,properties){var result=baseCreate(prototype);return properties?baseAssign(result,properties):result}var baseAssign=__webpack_require__(279),baseCreate=__webpack_require__(280);module.exports=create},function(module,exports,__webpack_require__){function isObject(value){var type=typeof value;return!!value&&("object"==type||"function"==type)}module.exports=isObject},function(module,exports,__webpack_require__){(function(){var XMLCData,XMLNode,create,extend=function(child,parent){function ctor(){this.constructor=child}for(var key in parent)hasProp.call(parent,key)&&(child[key]=parent[key]);return ctor.prototype=parent.prototype,child.prototype=new ctor,child.__super__=parent.prototype,child},hasProp={}.hasOwnProperty;create=__webpack_require__(260),XMLNode=__webpack_require__(269),module.exports=XMLCData=function(superClass){function XMLCData(parent,text){if(XMLCData.__super__.constructor.call(this,parent),null==text)throw new Error("Missing CDATA text");this.text=this.stringify.cdata(text)}return extend(XMLCData,superClass),XMLCData.prototype.clone=function(){return create(XMLCData.prototype,this)},XMLCData.prototype.toString=function(options,level){var indent,newline,offset,pretty,r,ref,ref1,ref2,space;return pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",level||(level=0),space=new Array(level+offset+1).join(indent),r="",pretty&&(r+=space),r+="<![CDATA["+this.text+"]]>",pretty&&(r+=newline),r},XMLCData}(XMLNode)}).call(this)},function(module,exports,__webpack_require__){(function(){var XMLComment,XMLNode,create,extend=function(child,parent){function ctor(){this.constructor=child}for(var key in parent)hasProp.call(parent,key)&&(child[key]=parent[key]);return ctor.prototype=parent.prototype,child.prototype=new ctor,child.__super__=parent.prototype,child},hasProp={}.hasOwnProperty;create=__webpack_require__(260),XMLNode=__webpack_require__(269),module.exports=XMLComment=function(superClass){function XMLComment(parent,text){if(XMLComment.__super__.constructor.call(this,parent),null==text)throw new Error("Missing comment text");this.text=this.stringify.comment(text)}return extend(XMLComment,superClass),XMLComment.prototype.clone=function(){return create(XMLComment.prototype,this)},XMLComment.prototype.toString=function(options,level){var indent,newline,offset,pretty,r,ref,ref1,ref2,space;return pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",level||(level=0),space=new Array(level+offset+1).join(indent),r="",pretty&&(r+=space),r+="<!-- "+this.text+" -->",pretty&&(r+=newline),r},XMLComment}(XMLNode)}).call(this)},function(module,exports,__webpack_require__){(function(){var XMLDTDAttList,create;create=__webpack_require__(260),module.exports=XMLDTDAttList=function(){function XMLDTDAttList(parent,elementName,attributeName,attributeType,defaultValueType,defaultValue){if(this.stringify=parent.stringify,null==elementName)throw new Error("Missing DTD element name");if(null==attributeName)throw new Error("Missing DTD attribute name");if(!attributeType)throw new Error("Missing DTD attribute type");if(!defaultValueType)throw new Error("Missing DTD attribute default");if(0!==defaultValueType.indexOf("#")&&(defaultValueType="#"+defaultValueType),!defaultValueType.match(/^(#REQUIRED|#IMPLIED|#FIXED|#DEFAULT)$/))throw new Error("Invalid default value type; expected: #REQUIRED, #IMPLIED, #FIXED or #DEFAULT");if(defaultValue&&!defaultValueType.match(/^(#FIXED|#DEFAULT)$/))throw new Error("Default value only applies to #FIXED or #DEFAULT");this.elementName=this.stringify.eleName(elementName),this.attributeName=this.stringify.attName(attributeName),this.attributeType=this.stringify.dtdAttType(attributeType),this.defaultValue=this.stringify.dtdAttDefault(defaultValue),this.defaultValueType=defaultValueType}return XMLDTDAttList.prototype.toString=function(options,level){var indent,newline,offset,pretty,r,ref,ref1,ref2,space;return pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",level||(level=0),space=new Array(level+offset+1).join(indent),r="",pretty&&(r+=space),r+="<!ATTLIST "+this.elementName+" "+this.attributeName+" "+this.attributeType,"#DEFAULT"!==this.defaultValueType&&(r+=" "+this.defaultValueType),this.defaultValue&&(r+=' "'+this.defaultValue+'"'),r+=">",pretty&&(r+=newline),r},XMLDTDAttList}()}).call(this)},function(module,exports,__webpack_require__){(function(){var XMLDTDEntity,create,isObject;create=__webpack_require__(260),isObject=__webpack_require__(261),module.exports=XMLDTDEntity=function(){function XMLDTDEntity(parent,pe,name,value){if(this.stringify=parent.stringify,null==name)throw new Error("Missing entity name");if(null==value)throw new Error("Missing entity value");if(this.pe=!!pe,this.name=this.stringify.eleName(name),isObject(value)){if(!value.pubID&&!value.sysID)throw new Error("Public and/or system identifiers are required for an external entity");if(value.pubID&&!value.sysID)throw new Error("System identifier is required for a public external entity");if(null!=value.pubID&&(this.pubID=this.stringify.dtdPubID(value.pubID)),null!=value.sysID&&(this.sysID=this.stringify.dtdSysID(value.sysID)),null!=value.nData&&(this.nData=this.stringify.dtdNData(value.nData)),this.pe&&this.nData)throw new Error("Notation declaration is not allowed in a parameter entity")}else this.value=this.stringify.dtdEntityValue(value)}return XMLDTDEntity.prototype.toString=function(options,level){var indent,newline,offset,pretty,r,ref,ref1,ref2,space;return pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",level||(level=0),space=new Array(level+offset+1).join(indent),r="",pretty&&(r+=space),r+="<!ENTITY",this.pe&&(r+=" %"),r+=" "+this.name,this.value?r+=' "'+this.value+'"':(this.pubID&&this.sysID?r+=' PUBLIC "'+this.pubID+'" "'+this.sysID+'"':this.sysID&&(r+=' SYSTEM "'+this.sysID+'"'),this.nData&&(r+=" NDATA "+this.nData)),r+=">",pretty&&(r+=newline),r},XMLDTDEntity}()}).call(this)},function(module,exports,__webpack_require__){(function(){var XMLDTDElement,create;create=__webpack_require__(260),module.exports=XMLDTDElement=function(){function XMLDTDElement(parent,name,value){if(this.stringify=parent.stringify,null==name)throw new Error("Missing DTD element name");value||(value="(#PCDATA)"),Array.isArray(value)&&(value="("+value.join(",")+")"),this.name=this.stringify.eleName(name),this.value=this.stringify.dtdElementValue(value)}return XMLDTDElement.prototype.toString=function(options,level){var indent,newline,offset,pretty,r,ref,ref1,ref2,space;return pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",level||(level=0),space=new Array(level+offset+1).join(indent),r="",pretty&&(r+=space),r+="<!ELEMENT "+this.name+" "+this.value+">",pretty&&(r+=newline),r},XMLDTDElement}()}).call(this)},function(module,exports,__webpack_require__){(function(){var XMLDTDNotation,create;create=__webpack_require__(260),module.exports=XMLDTDNotation=function(){function XMLDTDNotation(parent,name,value){if(this.stringify=parent.stringify,null==name)throw new Error("Missing notation name");if(!value.pubID&&!value.sysID)throw new Error("Public or system identifiers are required for an external entity");this.name=this.stringify.eleName(name),null!=value.pubID&&(this.pubID=this.stringify.dtdPubID(value.pubID)),null!=value.sysID&&(this.sysID=this.stringify.dtdSysID(value.sysID))}return XMLDTDNotation.prototype.toString=function(options,level){var indent,newline,offset,pretty,r,ref,ref1,ref2,space;return pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",level||(level=0),space=new Array(level+offset+1).join(indent),r="",pretty&&(r+=space),r+="<!NOTATION "+this.name,this.pubID&&this.sysID?r+=' PUBLIC "'+this.pubID+'" "'+this.sysID+'"':this.pubID?r+=' PUBLIC "'+this.pubID+'"':this.sysID&&(r+=' SYSTEM "'+this.sysID+'"'),r+=">",pretty&&(r+=newline),r},XMLDTDNotation}()}).call(this)},function(module,exports,__webpack_require__){(function(){var XMLProcessingInstruction,create;create=__webpack_require__(260),module.exports=XMLProcessingInstruction=function(){function XMLProcessingInstruction(parent,target,value){if(this.stringify=parent.stringify,null==target)throw new Error("Missing instruction target");this.target=this.stringify.insTarget(target),value&&(this.value=this.stringify.insValue(value))}return XMLProcessingInstruction.prototype.clone=function(){return create(XMLProcessingInstruction.prototype,this)},XMLProcessingInstruction.prototype.toString=function(options,level){var indent,newline,offset,pretty,r,ref,ref1,ref2,space;return pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",level||(level=0),space=new Array(level+offset+1).join(indent),r="",pretty&&(r+=space),r+="<?",r+=this.target,this.value&&(r+=" "+this.value),r+="?>",pretty&&(r+=newline),r},XMLProcessingInstruction}()}).call(this)},function(module,exports,__webpack_require__){(function(){var XMLCData,XMLComment,XMLDeclaration,XMLDocType,XMLElement,XMLNode,XMLRaw,XMLText,isEmpty,isFunction,isObject,hasProp={}.hasOwnProperty;isObject=__webpack_require__(261),isFunction=__webpack_require__(270),isEmpty=__webpack_require__(281),XMLElement=null,XMLCData=null,XMLComment=null,XMLDeclaration=null,XMLDocType=null,XMLRaw=null,XMLText=null,module.exports=XMLNode=function(){function XMLNode(parent){this.parent=parent,this.options=this.parent.options,this.stringify=this.parent.stringify,null===XMLElement&&(XMLElement=__webpack_require__(258),XMLCData=__webpack_require__(262),XMLComment=__webpack_require__(263),XMLDeclaration=__webpack_require__(256),XMLDocType=__webpack_require__(257),XMLRaw=__webpack_require__(282),XMLText=__webpack_require__(283))}return XMLNode.prototype.element=function(name,attributes,text){var childNode,item,j,k,key,lastChild,len,len1,ref,val;if(lastChild=null,null==attributes&&(attributes={}),attributes=attributes.valueOf(),isObject(attributes)||(ref=[attributes,text],text=ref[0],attributes=ref[1]),null!=name&&(name=name.valueOf()),Array.isArray(name))for(j=0,len=name.length;len>j;j++)item=name[j],lastChild=this.element(item);else if(isFunction(name))lastChild=this.element(name.apply());else if(isObject(name)){for(key in name)if(hasProp.call(name,key))if(val=name[key],isFunction(val)&&(val=val.apply()),isObject(val)&&isEmpty(val)&&(val=null),!this.options.ignoreDecorators&&this.stringify.convertAttKey&&0===key.indexOf(this.stringify.convertAttKey))lastChild=this.attribute(key.substr(this.stringify.convertAttKey.length),val);else if(!this.options.ignoreDecorators&&this.stringify.convertPIKey&&0===key.indexOf(this.stringify.convertPIKey))lastChild=this.instruction(key.substr(this.stringify.convertPIKey.length),val);else if(!this.options.separateArrayItems&&Array.isArray(val))for(k=0,len1=val.length;len1>k;k++)item=val[k],childNode={},childNode[key]=item,lastChild=this.element(childNode);else isObject(val)?(lastChild=this.element(key),lastChild.element(val)):lastChild=this.element(key,val)}else lastChild=!this.options.ignoreDecorators&&this.stringify.convertTextKey&&0===name.indexOf(this.stringify.convertTextKey)?this.text(text):!this.options.ignoreDecorators&&this.stringify.convertCDataKey&&0===name.indexOf(this.stringify.convertCDataKey)?this.cdata(text):!this.options.ignoreDecorators&&this.stringify.convertCommentKey&&0===name.indexOf(this.stringify.convertCommentKey)?this.comment(text):!this.options.ignoreDecorators&&this.stringify.convertRawKey&&0===name.indexOf(this.stringify.convertRawKey)?this.raw(text):this.node(name,attributes,text);if(null==lastChild)throw new Error("Could not create any elements with: "+name);return lastChild},XMLNode.prototype.insertBefore=function(name,attributes,text){var child,i,removed;if(this.isRoot)throw new Error("Cannot insert elements at root level");return i=this.parent.children.indexOf(this),removed=this.parent.children.splice(i),child=this.parent.element(name,attributes,text),Array.prototype.push.apply(this.parent.children,removed),child},XMLNode.prototype.insertAfter=function(name,attributes,text){var child,i,removed;if(this.isRoot)throw new Error("Cannot insert elements at root level");return i=this.parent.children.indexOf(this),removed=this.parent.children.splice(i+1),child=this.parent.element(name,attributes,text),Array.prototype.push.apply(this.parent.children,removed),child},XMLNode.prototype.remove=function(){var i,ref;if(this.isRoot)throw new Error("Cannot remove the root element");return i=this.parent.children.indexOf(this),[].splice.apply(this.parent.children,[i,i-i+1].concat(ref=[])),ref,this.parent},XMLNode.prototype.node=function(name,attributes,text){var child,ref;return null!=name&&(name=name.valueOf()),null==attributes&&(attributes={}),attributes=attributes.valueOf(),isObject(attributes)||(ref=[attributes,text],text=ref[0],attributes=ref[1]),child=new XMLElement(this,name,attributes),null!=text&&child.text(text),this.children.push(child),child},XMLNode.prototype.text=function(value){var child;return child=new XMLText(this,value),this.children.push(child),this},XMLNode.prototype.cdata=function(value){var child;return child=new XMLCData(this,value),this.children.push(child),this},XMLNode.prototype.comment=function(value){var child;return child=new XMLComment(this,value),this.children.push(child),this},XMLNode.prototype.raw=function(value){var child;return child=new XMLRaw(this,value),this.children.push(child),this},XMLNode.prototype.declaration=function(version,encoding,standalone){var doc,xmldec;return doc=this.document(),xmldec=new XMLDeclaration(doc,version,encoding,standalone),doc.xmldec=xmldec,doc.root()},XMLNode.prototype.doctype=function(pubID,sysID){var doc,doctype;return doc=this.document(),doctype=new XMLDocType(doc,pubID,sysID),doc.doctype=doctype,doctype},XMLNode.prototype.up=function(){if(this.isRoot)throw new Error("The root node has no parent. Use doc() if you need to get the document object.");return this.parent},XMLNode.prototype.root=function(){var child;if(this.isRoot)return this;for(child=this.parent;!child.isRoot;)child=child.parent;return child},XMLNode.prototype.document=function(){return this.root().documentObject},XMLNode.prototype.end=function(options){return this.document().toString(options)},XMLNode.prototype.prev=function(){var i;if(this.isRoot)throw new Error("Root node has no siblings");if(i=this.parent.children.indexOf(this),1>i)throw new Error("Already at the first node");return this.parent.children[i-1]},XMLNode.prototype.next=function(){var i;if(this.isRoot)throw new Error("Root node has no siblings");if(i=this.parent.children.indexOf(this),-1===i||i===this.parent.children.length-1)throw new Error("Already at the last node");return this.parent.children[i+1]},XMLNode.prototype.importXMLBuilder=function(xmlbuilder){var clonedRoot;return clonedRoot=xmlbuilder.root().clone(),clonedRoot.parent=this,clonedRoot.isRoot=!1,this.children.push(clonedRoot),this},XMLNode.prototype.ele=function(name,attributes,text){return this.element(name,attributes,text)},XMLNode.prototype.nod=function(name,attributes,text){return this.node(name,attributes,text)},XMLNode.prototype.txt=function(value){return this.text(value)},XMLNode.prototype.dat=function(value){return this.cdata(value)},XMLNode.prototype.com=function(value){return this.comment(value)},XMLNode.prototype.doc=function(){return this.document()},XMLNode.prototype.dec=function(version,encoding,standalone){return this.declaration(version,encoding,standalone)},XMLNode.prototype.dtd=function(pubID,sysID){return this.doctype(pubID,sysID)},XMLNode.prototype.e=function(name,attributes,text){return this.element(name,attributes,text)},XMLNode.prototype.n=function(name,attributes,text){return this.node(name,attributes,text)},XMLNode.prototype.t=function(value){return this.text(value)},XMLNode.prototype.d=function(value){return this.cdata(value)},XMLNode.prototype.c=function(value){return this.comment(value)},XMLNode.prototype.r=function(value){return this.raw(value)},XMLNode.prototype.u=function(){return this.up()},XMLNode}()}).call(this)},function(module,exports,__webpack_require__){function isFunction(value){var tag=isObject(value)?objectToString.call(value):"";return tag==funcTag||tag==genTag}var isObject=__webpack_require__(261),funcTag="[object Function]",genTag="[object GeneratorFunction]",objectProto=Object.prototype,objectToString=objectProto.toString;module.exports=isFunction},function(module,exports,__webpack_require__){function every(collection,predicate,guard){var func=isArray(collection)?arrayEvery:baseEvery;return guard&&isIterateeCall(collection,predicate,guard)&&(predicate=void 0),func(collection,baseIteratee(predicate,3))}var arrayEvery=__webpack_require__(284),baseEvery=__webpack_require__(285),baseIteratee=__webpack_require__(286),isArray=__webpack_require__(287),isIterateeCall=__webpack_require__(288);module.exports=every},function(module,exports,__webpack_require__){(function(){var XMLAttribute,create;create=__webpack_require__(260),module.exports=XMLAttribute=function(){function XMLAttribute(parent,name,value){if(this.stringify=parent.stringify,null==name)throw new Error("Missing attribute name of element "+parent.name);if(null==value)throw new Error("Missing attribute value for attribute "+name+" of element "+parent.name);this.name=this.stringify.attName(name),this.value=this.stringify.attValue(value)}return XMLAttribute.prototype.clone=function(){return create(XMLAttribute.prototype,this)},XMLAttribute.prototype.toString=function(options,level){return" "+this.name+'="'+this.value+'"'},XMLAttribute}()}).call(this)},function(module,exports,__webpack_require__){function assignValue(object,key,value){var objValue=object[key];hasOwnProperty.call(object,key)&&eq(objValue,value)&&(void 0!==value||key in object)||(object[key]=value)}var eq=__webpack_require__(289),objectProto=Object.prototype,hasOwnProperty=objectProto.hasOwnProperty;
module.exports=assignValue},function(module,exports,__webpack_require__){function copyObject(source,props,object,customizer){object||(object={});for(var index=-1,length=props.length;++index<length;){var key=props[index],newValue=customizer?customizer(object[key],source[key],key,object,source):source[key];assignValue(object,key,newValue)}return object}var assignValue=__webpack_require__(273);module.exports=copyObject},function(module,exports,__webpack_require__){function createAssigner(assigner){return rest(function(object,sources){var index=-1,length=sources.length,customizer=length>1?sources[length-1]:void 0,guard=length>2?sources[2]:void 0;for(customizer="function"==typeof customizer?(length--,customizer):void 0,guard&&isIterateeCall(sources[0],sources[1],guard)&&(customizer=3>length?void 0:customizer,length=1),object=Object(object);++index<length;){var source=sources[index];source&&assigner(object,source,index,customizer)}return object})}var isIterateeCall=__webpack_require__(288),rest=__webpack_require__(290);module.exports=createAssigner},function(module,exports,__webpack_require__){function isArrayLike(value){return null!=value&&isLength(getLength(value))&&!isFunction(value)}var getLength=__webpack_require__(291),isFunction=__webpack_require__(270),isLength=__webpack_require__(292);module.exports=isArrayLike},function(module,exports,__webpack_require__){function isPrototype(value){var Ctor=value&&value.constructor,proto="function"==typeof Ctor&&Ctor.prototype||objectProto;return value===proto}var objectProto=Object.prototype;module.exports=isPrototype},function(module,exports,__webpack_require__){function keys(object){var isProto=isPrototype(object);if(!isProto&&!isArrayLike(object))return baseKeys(object);var indexes=indexKeys(object),skipIndexes=!!indexes,result=indexes||[],length=result.length;for(var key in object)!baseHas(object,key)||skipIndexes&&("length"==key||isIndex(key,length))||isProto&&"constructor"==key||result.push(key);return result}var baseHas=__webpack_require__(293),baseKeys=__webpack_require__(294),indexKeys=__webpack_require__(295),isArrayLike=__webpack_require__(276),isIndex=__webpack_require__(296),isPrototype=__webpack_require__(277);module.exports=keys},function(module,exports,__webpack_require__){function baseAssign(object,source){return object&&copyObject(source,keys(source),object)}var copyObject=__webpack_require__(274),keys=__webpack_require__(278);module.exports=baseAssign},function(module,exports,__webpack_require__){function baseCreate(proto){return isObject(proto)?objectCreate(proto):{}}var isObject=__webpack_require__(261),objectCreate=Object.create;module.exports=baseCreate},function(module,exports,__webpack_require__){function isEmpty(value){if(isArrayLike(value)&&(isArray(value)||isString(value)||isFunction(value.splice)||isArguments(value)||isBuffer(value)))return!value.length;if(isObjectLike(value)){var tag=getTag(value);if(tag==mapTag||tag==setTag)return!value.size}for(var key in value)if(hasOwnProperty.call(value,key))return!1;return!(nonEnumShadows&&keys(value).length)}var getTag=__webpack_require__(297),isArguments=__webpack_require__(298),isArray=__webpack_require__(287),isArrayLike=__webpack_require__(276),isBuffer=__webpack_require__(299),isFunction=__webpack_require__(270),isObjectLike=__webpack_require__(300),isString=__webpack_require__(301),keys=__webpack_require__(278),mapTag="[object Map]",setTag="[object Set]",objectProto=Object.prototype,hasOwnProperty=objectProto.hasOwnProperty,propertyIsEnumerable=objectProto.propertyIsEnumerable,nonEnumShadows=!propertyIsEnumerable.call({valueOf:1},"valueOf");module.exports=isEmpty},function(module,exports,__webpack_require__){(function(){var XMLNode,XMLRaw,create,extend=function(child,parent){function ctor(){this.constructor=child}for(var key in parent)hasProp.call(parent,key)&&(child[key]=parent[key]);return ctor.prototype=parent.prototype,child.prototype=new ctor,child.__super__=parent.prototype,child},hasProp={}.hasOwnProperty;create=__webpack_require__(260),XMLNode=__webpack_require__(269),module.exports=XMLRaw=function(superClass){function XMLRaw(parent,text){if(XMLRaw.__super__.constructor.call(this,parent),null==text)throw new Error("Missing raw text");this.value=this.stringify.raw(text)}return extend(XMLRaw,superClass),XMLRaw.prototype.clone=function(){return create(XMLRaw.prototype,this)},XMLRaw.prototype.toString=function(options,level){var indent,newline,offset,pretty,r,ref,ref1,ref2,space;return pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",level||(level=0),space=new Array(level+offset+1).join(indent),r="",pretty&&(r+=space),r+=this.value,pretty&&(r+=newline),r},XMLRaw}(XMLNode)}).call(this)},function(module,exports,__webpack_require__){(function(){var XMLNode,XMLText,create,extend=function(child,parent){function ctor(){this.constructor=child}for(var key in parent)hasProp.call(parent,key)&&(child[key]=parent[key]);return ctor.prototype=parent.prototype,child.prototype=new ctor,child.__super__=parent.prototype,child},hasProp={}.hasOwnProperty;create=__webpack_require__(260),XMLNode=__webpack_require__(269),module.exports=XMLText=function(superClass){function XMLText(parent,text){if(XMLText.__super__.constructor.call(this,parent),null==text)throw new Error("Missing element text");this.value=this.stringify.eleText(text)}return extend(XMLText,superClass),XMLText.prototype.clone=function(){return create(XMLText.prototype,this)},XMLText.prototype.toString=function(options,level){var indent,newline,offset,pretty,r,ref,ref1,ref2,space;return pretty=(null!=options?options.pretty:void 0)||!1,indent=null!=(ref=null!=options?options.indent:void 0)?ref:"  ",offset=null!=(ref1=null!=options?options.offset:void 0)?ref1:0,newline=null!=(ref2=null!=options?options.newline:void 0)?ref2:"\n",level||(level=0),space=new Array(level+offset+1).join(indent),r="",pretty&&(r+=space),r+=this.value,pretty&&(r+=newline),r},XMLText}(XMLNode)}).call(this)},function(module,exports,__webpack_require__){function arrayEvery(array,predicate){for(var index=-1,length=array.length;++index<length;)if(!predicate(array[index],index,array))return!1;return!0}module.exports=arrayEvery},function(module,exports,__webpack_require__){function baseEvery(collection,predicate){var result=!0;return baseEach(collection,function(value,index,collection){return result=!!predicate(value,index,collection)}),result}var baseEach=__webpack_require__(302);module.exports=baseEvery},function(module,exports,__webpack_require__){function baseIteratee(value){return"function"==typeof value?value:null==value?identity:"object"==typeof value?isArray(value)?baseMatchesProperty(value[0],value[1]):baseMatches(value):property(value)}var baseMatches=__webpack_require__(303),baseMatchesProperty=__webpack_require__(304),identity=__webpack_require__(305),isArray=__webpack_require__(287),property=__webpack_require__(306);module.exports=baseIteratee},function(module,exports,__webpack_require__){var isArray=Array.isArray;module.exports=isArray},function(module,exports,__webpack_require__){function isIterateeCall(value,index,object){if(!isObject(object))return!1;var type=typeof index;return("number"==type?isArrayLike(object)&&isIndex(index,object.length):"string"==type&&index in object)?eq(object[index],value):!1}var eq=__webpack_require__(289),isArrayLike=__webpack_require__(276),isIndex=__webpack_require__(296),isObject=__webpack_require__(261);module.exports=isIterateeCall},function(module,exports,__webpack_require__){function eq(value,other){return value===other||value!==value&&other!==other}module.exports=eq},function(module,exports,__webpack_require__){function rest(func,start){if("function"!=typeof func)throw new TypeError(FUNC_ERROR_TEXT);return start=nativeMax(void 0===start?func.length-1:toInteger(start),0),function(){for(var args=arguments,index=-1,length=nativeMax(args.length-start,0),array=Array(length);++index<length;)array[index]=args[start+index];switch(start){case 0:return func.call(this,array);case 1:return func.call(this,args[0],array);case 2:return func.call(this,args[0],args[1],array)}var otherArgs=Array(start+1);for(index=-1;++index<start;)otherArgs[index]=args[index];return otherArgs[start]=array,apply(func,this,otherArgs)}}var apply=__webpack_require__(307),toInteger=__webpack_require__(308),FUNC_ERROR_TEXT="Expected a function",nativeMax=Math.max;module.exports=rest},function(module,exports,__webpack_require__){var baseProperty=__webpack_require__(309),getLength=baseProperty("length");module.exports=getLength},function(module,exports,__webpack_require__){function isLength(value){return"number"==typeof value&&value>-1&&value%1==0&&MAX_SAFE_INTEGER>=value}var MAX_SAFE_INTEGER=9007199254740991;module.exports=isLength},function(module,exports,__webpack_require__){function baseHas(object,key){return hasOwnProperty.call(object,key)||"object"==typeof object&&key in object&&null===getPrototype(object)}var getPrototype=__webpack_require__(310),objectProto=Object.prototype,hasOwnProperty=objectProto.hasOwnProperty;module.exports=baseHas},function(module,exports,__webpack_require__){function baseKeys(object){return nativeKeys(Object(object))}var nativeKeys=Object.keys;module.exports=baseKeys},function(module,exports,__webpack_require__){function indexKeys(object){var length=object?object.length:void 0;return isLength(length)&&(isArray(object)||isString(object)||isArguments(object))?baseTimes(length,String):null}var baseTimes=__webpack_require__(311),isArguments=__webpack_require__(298),isArray=__webpack_require__(287),isLength=__webpack_require__(292),isString=__webpack_require__(301);module.exports=indexKeys},function(module,exports,__webpack_require__){function isIndex(value,length){return value="number"==typeof value||reIsUint.test(value)?+value:-1,length=null==length?MAX_SAFE_INTEGER:length,value>-1&&value%1==0&&length>value}var MAX_SAFE_INTEGER=9007199254740991,reIsUint=/^(?:0|[1-9]\d*)$/;module.exports=isIndex},function(module,exports,__webpack_require__){function getTag(value){return objectToString.call(value)}var DataView=__webpack_require__(312),Map=__webpack_require__(313),Promise=__webpack_require__(314),Set=__webpack_require__(315),WeakMap=__webpack_require__(316),toSource=__webpack_require__(317),mapTag="[object Map]",objectTag="[object Object]",promiseTag="[object Promise]",setTag="[object Set]",weakMapTag="[object WeakMap]",dataViewTag="[object DataView]",objectProto=Object.prototype,objectToString=objectProto.toString,dataViewCtorString=toSource(DataView),mapCtorString=toSource(Map),promiseCtorString=toSource(Promise),setCtorString=toSource(Set),weakMapCtorString=toSource(WeakMap);(DataView&&getTag(new DataView(new ArrayBuffer(1)))!=dataViewTag||Map&&getTag(new Map)!=mapTag||Promise&&getTag(Promise.resolve())!=promiseTag||Set&&getTag(new Set)!=setTag||WeakMap&&getTag(new WeakMap)!=weakMapTag)&&(getTag=function(value){var result=objectToString.call(value),Ctor=result==objectTag?value.constructor:void 0,ctorString=Ctor?toSource(Ctor):void 0;if(ctorString)switch(ctorString){case dataViewCtorString:return dataViewTag;case mapCtorString:return mapTag;case promiseCtorString:return promiseTag;case setCtorString:return setTag;case weakMapCtorString:return weakMapTag}return result}),module.exports=getTag},function(module,exports,__webpack_require__){function isArguments(value){return isArrayLikeObject(value)&&hasOwnProperty.call(value,"callee")&&(!propertyIsEnumerable.call(value,"callee")||objectToString.call(value)==argsTag)}var isArrayLikeObject=__webpack_require__(318),argsTag="[object Arguments]",objectProto=Object.prototype,hasOwnProperty=objectProto.hasOwnProperty,objectToString=objectProto.toString,propertyIsEnumerable=objectProto.propertyIsEnumerable;module.exports=isArguments},function(module,exports,__webpack_require__){(function(module){var constant=__webpack_require__(319),root=__webpack_require__(320),objectTypes={"function":!0,object:!0},freeExports=objectTypes[typeof exports]&&exports&&!exports.nodeType?exports:void 0,freeModule=objectTypes[typeof module]&&module&&!module.nodeType?module:void 0,moduleExports=freeModule&&freeModule.exports===freeExports?freeExports:void 0,Buffer=moduleExports?root.Buffer:void 0,isBuffer=Buffer?function(value){return value instanceof Buffer}:constant(!1);module.exports=isBuffer}).call(exports,__webpack_require__(146)(module))},function(module,exports,__webpack_require__){function isObjectLike(value){return!!value&&"object"==typeof value}module.exports=isObjectLike},function(module,exports,__webpack_require__){function isString(value){return"string"==typeof value||!isArray(value)&&isObjectLike(value)&&objectToString.call(value)==stringTag}var isArray=__webpack_require__(287),isObjectLike=__webpack_require__(300),stringTag="[object String]",objectProto=Object.prototype,objectToString=objectProto.toString;module.exports=isString},function(module,exports,__webpack_require__){var baseForOwn=__webpack_require__(321),createBaseEach=__webpack_require__(322),baseEach=createBaseEach(baseForOwn);module.exports=baseEach},function(module,exports,__webpack_require__){function baseMatches(source){var matchData=getMatchData(source);return 1==matchData.length&&matchData[0][2]?matchesStrictComparable(matchData[0][0],matchData[0][1]):function(object){return object===source||baseIsMatch(object,source,matchData)}}var baseIsMatch=__webpack_require__(323),getMatchData=__webpack_require__(324),matchesStrictComparable=__webpack_require__(325);module.exports=baseMatches},function(module,exports,__webpack_require__){function baseMatchesProperty(path,srcValue){return isKey(path)&&isStrictComparable(srcValue)?matchesStrictComparable(path,srcValue):function(object){var objValue=get(object,path);return void 0===objValue&&objValue===srcValue?hasIn(object,path):baseIsEqual(srcValue,objValue,void 0,UNORDERED_COMPARE_FLAG|PARTIAL_COMPARE_FLAG)}}var baseIsEqual=__webpack_require__(326),get=__webpack_require__(327),hasIn=__webpack_require__(328),isKey=__webpack_require__(329),isStrictComparable=__webpack_require__(330),matchesStrictComparable=__webpack_require__(325),UNORDERED_COMPARE_FLAG=1,PARTIAL_COMPARE_FLAG=2;module.exports=baseMatchesProperty},function(module,exports,__webpack_require__){function identity(value){return value}module.exports=identity},function(module,exports,__webpack_require__){function property(path){return isKey(path)?baseProperty(path):basePropertyDeep(path)}var baseProperty=__webpack_require__(309),basePropertyDeep=__webpack_require__(331),isKey=__webpack_require__(329);module.exports=property},function(module,exports,__webpack_require__){function apply(func,thisArg,args){var length=args.length;switch(length){case 0:return func.call(thisArg);case 1:return func.call(thisArg,args[0]);case 2:return func.call(thisArg,args[0],args[1]);case 3:return func.call(thisArg,args[0],args[1],args[2])}return func.apply(thisArg,args)}module.exports=apply},function(module,exports,__webpack_require__){function toInteger(value){if(!value)return 0===value?value:0;if(value=toNumber(value),value===INFINITY||value===-INFINITY){var sign=0>value?-1:1;return sign*MAX_INTEGER}var remainder=value%1;return value===value?remainder?value-remainder:value:0}var toNumber=__webpack_require__(332),INFINITY=1/0,MAX_INTEGER=1.7976931348623157e308;module.exports=toInteger},function(module,exports,__webpack_require__){function baseProperty(key){return function(object){return null==object?void 0:object[key]}}module.exports=baseProperty},function(module,exports,__webpack_require__){function getPrototype(value){return nativeGetPrototype(Object(value))}var nativeGetPrototype=Object.getPrototypeOf;module.exports=getPrototype},function(module,exports,__webpack_require__){function baseTimes(n,iteratee){for(var index=-1,result=Array(n);++index<n;)result[index]=iteratee(index);return result}module.exports=baseTimes},function(module,exports,__webpack_require__){var getNative=__webpack_require__(333),root=__webpack_require__(320),DataView=getNative(root,"DataView");module.exports=DataView},function(module,exports,__webpack_require__){var getNative=__webpack_require__(333),root=__webpack_require__(320),Map=getNative(root,"Map");module.exports=Map},function(module,exports,__webpack_require__){var getNative=__webpack_require__(333),root=__webpack_require__(320),Promise=getNative(root,"Promise");module.exports=Promise},function(module,exports,__webpack_require__){var getNative=__webpack_require__(333),root=__webpack_require__(320),Set=getNative(root,"Set");module.exports=Set},function(module,exports,__webpack_require__){var getNative=__webpack_require__(333),root=__webpack_require__(320),WeakMap=getNative(root,"WeakMap");module.exports=WeakMap},function(module,exports,__webpack_require__){function toSource(func){if(null!=func){try{return funcToString.call(func)}catch(e){}try{return func+""}catch(e){}}return""}var funcToString=Function.prototype.toString;module.exports=toSource},function(module,exports,__webpack_require__){function isArrayLikeObject(value){return isObjectLike(value)&&isArrayLike(value)}var isArrayLike=__webpack_require__(276),isObjectLike=__webpack_require__(300);module.exports=isArrayLikeObject},function(module,exports,__webpack_require__){function constant(value){return function(){return value}}module.exports=constant},function(module,exports,__webpack_require__){(function(module,global){var checkGlobal=__webpack_require__(334),objectTypes={"function":!0,object:!0},freeExports=objectTypes[typeof exports]&&exports&&!exports.nodeType?exports:void 0,freeModule=objectTypes[typeof module]&&module&&!module.nodeType?module:void 0,freeGlobal=checkGlobal(freeExports&&freeModule&&"object"==typeof global&&global),freeSelf=checkGlobal(objectTypes[typeof self]&&self),freeWindow=checkGlobal(objectTypes[typeof window]&&window),thisGlobal=checkGlobal(objectTypes[typeof this]&&this),root=freeGlobal||freeWindow!==(thisGlobal&&thisGlobal.window)&&freeWindow||freeSelf||thisGlobal||Function("return this")();module.exports=root}).call(exports,__webpack_require__(146)(module),function(){return this}())},function(module,exports,__webpack_require__){function baseForOwn(object,iteratee){return object&&baseFor(object,iteratee,keys)}var baseFor=__webpack_require__(335),keys=__webpack_require__(278);module.exports=baseForOwn},function(module,exports,__webpack_require__){function createBaseEach(eachFunc,fromRight){return function(collection,iteratee){if(null==collection)return collection;if(!isArrayLike(collection))return eachFunc(collection,iteratee);for(var length=collection.length,index=fromRight?length:-1,iterable=Object(collection);(fromRight?index--:++index<length)&&iteratee(iterable[index],index,iterable)!==!1;);return collection}}var isArrayLike=__webpack_require__(276);module.exports=createBaseEach},function(module,exports,__webpack_require__){function baseIsMatch(object,source,matchData,customizer){var index=matchData.length,length=index,noCustomizer=!customizer;if(null==object)return!length;for(object=Object(object);index--;){var data=matchData[index];if(noCustomizer&&data[2]?data[1]!==object[data[0]]:!(data[0]in object))return!1}for(;++index<length;){data=matchData[index];var key=data[0],objValue=object[key],srcValue=data[1];if(noCustomizer&&data[2]){if(void 0===objValue&&!(key in object))return!1}else{var stack=new Stack;if(customizer)var result=customizer(objValue,srcValue,key,object,source,stack);if(!(void 0===result?baseIsEqual(srcValue,objValue,customizer,UNORDERED_COMPARE_FLAG|PARTIAL_COMPARE_FLAG,stack):result))return!1}}return!0}var Stack=__webpack_require__(336),baseIsEqual=__webpack_require__(326),UNORDERED_COMPARE_FLAG=1,PARTIAL_COMPARE_FLAG=2;module.exports=baseIsMatch},function(module,exports,__webpack_require__){function getMatchData(object){for(var result=toPairs(object),length=result.length;length--;)result[length][2]=isStrictComparable(result[length][1]);return result}var isStrictComparable=__webpack_require__(330),toPairs=__webpack_require__(337);module.exports=getMatchData},function(module,exports,__webpack_require__){function matchesStrictComparable(key,srcValue){return function(object){return null==object?!1:object[key]===srcValue&&(void 0!==srcValue||key in Object(object))}}module.exports=matchesStrictComparable},function(module,exports,__webpack_require__){function baseIsEqual(value,other,customizer,bitmask,stack){return value===other?!0:null==value||null==other||!isObject(value)&&!isObjectLike(other)?value!==value&&other!==other:baseIsEqualDeep(value,other,baseIsEqual,customizer,bitmask,stack)}var baseIsEqualDeep=__webpack_require__(338),isObject=__webpack_require__(261),isObjectLike=__webpack_require__(300);module.exports=baseIsEqual},function(module,exports,__webpack_require__){function get(object,path,defaultValue){var result=null==object?void 0:baseGet(object,path);return void 0===result?defaultValue:result}var baseGet=__webpack_require__(339);module.exports=get},function(module,exports,__webpack_require__){function hasIn(object,path){return null!=object&&hasPath(object,path,baseHasIn)}var baseHasIn=__webpack_require__(340),hasPath=__webpack_require__(341);module.exports=hasIn},function(module,exports,__webpack_require__){function isKey(value,object){var type=typeof value;return"number"==type||"symbol"==type?!0:!isArray(value)&&(isSymbol(value)||reIsPlainProp.test(value)||!reIsDeepProp.test(value)||null!=object&&value in Object(object))}var isArray=__webpack_require__(287),isSymbol=__webpack_require__(342),reIsDeepProp=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,reIsPlainProp=/^\w*$/;module.exports=isKey},function(module,exports,__webpack_require__){function isStrictComparable(value){return value===value&&!isObject(value)}var isObject=__webpack_require__(261);module.exports=isStrictComparable},function(module,exports,__webpack_require__){function basePropertyDeep(path){return function(object){return baseGet(object,path)}}var baseGet=__webpack_require__(339);module.exports=basePropertyDeep},function(module,exports,__webpack_require__){function toNumber(value){if("number"==typeof value)return value;if(isSymbol(value))return NAN;if(isObject(value)){var other=isFunction(value.valueOf)?value.valueOf():value;value=isObject(other)?other+"":other}if("string"!=typeof value)return 0===value?value:+value;value=value.replace(reTrim,"");var isBinary=reIsBinary.test(value);return isBinary||reIsOctal.test(value)?freeParseInt(value.slice(2),isBinary?2:8):reIsBadHex.test(value)?NAN:+value}var isFunction=__webpack_require__(270),isObject=__webpack_require__(261),isSymbol=__webpack_require__(342),NAN=NaN,reTrim=/^\s+|\s+$/g,reIsBadHex=/^[-+]0x[0-9a-f]+$/i,reIsBinary=/^0b[01]+$/i,reIsOctal=/^0o[0-7]+$/i,freeParseInt=parseInt;module.exports=toNumber},function(module,exports,__webpack_require__){function getNative(object,key){var value=object[key];return isNative(value)?value:void 0}var isNative=__webpack_require__(343);module.exports=getNative},function(module,exports,__webpack_require__){function checkGlobal(value){return value&&value.Object===Object?value:null}module.exports=checkGlobal},function(module,exports,__webpack_require__){var createBaseFor=__webpack_require__(344),baseFor=createBaseFor();module.exports=baseFor},function(module,exports,__webpack_require__){function Stack(values){var index=-1,length=values?values.length:0;for(this.clear();++index<length;){var entry=values[index];this.set(entry[0],entry[1])}}var stackClear=__webpack_require__(345),stackDelete=__webpack_require__(346),stackGet=__webpack_require__(347),stackHas=__webpack_require__(348),stackSet=__webpack_require__(349);Stack.prototype.clear=stackClear,Stack.prototype["delete"]=stackDelete,Stack.prototype.get=stackGet,Stack.prototype.has=stackHas,Stack.prototype.set=stackSet,module.exports=Stack},function(module,exports,__webpack_require__){function toPairs(object){return baseToPairs(object,keys(object))}var baseToPairs=__webpack_require__(350),keys=__webpack_require__(278);module.exports=toPairs},function(module,exports,__webpack_require__){function baseIsEqualDeep(object,other,equalFunc,customizer,bitmask,stack){var objIsArr=isArray(object),othIsArr=isArray(other),objTag=arrayTag,othTag=arrayTag;objIsArr||(objTag=getTag(object),objTag=objTag==argsTag?objectTag:objTag),othIsArr||(othTag=getTag(other),othTag=othTag==argsTag?objectTag:othTag);var objIsObj=objTag==objectTag&&!isHostObject(object),othIsObj=othTag==objectTag&&!isHostObject(other),isSameTag=objTag==othTag;if(isSameTag&&!objIsObj)return stack||(stack=new Stack),objIsArr||isTypedArray(object)?equalArrays(object,other,equalFunc,customizer,bitmask,stack):equalByTag(object,other,objTag,equalFunc,customizer,bitmask,stack);if(!(bitmask&PARTIAL_COMPARE_FLAG)){var objIsWrapped=objIsObj&&hasOwnProperty.call(object,"__wrapped__"),othIsWrapped=othIsObj&&hasOwnProperty.call(other,"__wrapped__");if(objIsWrapped||othIsWrapped){var objUnwrapped=objIsWrapped?object.value():object,othUnwrapped=othIsWrapped?other.value():other;return stack||(stack=new Stack),equalFunc(objUnwrapped,othUnwrapped,customizer,bitmask,stack)}}return isSameTag?(stack||(stack=new Stack),equalObjects(object,other,equalFunc,customizer,bitmask,stack)):!1}var Stack=__webpack_require__(336),equalArrays=__webpack_require__(351),equalByTag=__webpack_require__(352),equalObjects=__webpack_require__(353),getTag=__webpack_require__(297),isArray=__webpack_require__(287),isHostObject=__webpack_require__(354),isTypedArray=__webpack_require__(355),PARTIAL_COMPARE_FLAG=2,argsTag="[object Arguments]",arrayTag="[object Array]",objectTag="[object Object]",objectProto=Object.prototype,hasOwnProperty=objectProto.hasOwnProperty;module.exports=baseIsEqualDeep},function(module,exports,__webpack_require__){function baseGet(object,path){path=isKey(path,object)?[path]:castPath(path);for(var index=0,length=path.length;null!=object&&length>index;)object=object[path[index++]];return index&&index==length?object:void 0}var castPath=__webpack_require__(356),isKey=__webpack_require__(329);module.exports=baseGet},function(module,exports,__webpack_require__){function baseHasIn(object,key){return key in Object(object)}module.exports=baseHasIn},function(module,exports,__webpack_require__){function hasPath(object,path,hasFunc){path=isKey(path,object)?[path]:castPath(path);for(var result,index=-1,length=path.length;++index<length;){var key=path[index];if(!(result=null!=object&&hasFunc(object,key)))break;object=object[key]}if(result)return result;var length=object?object.length:0;return!!length&&isLength(length)&&isIndex(key,length)&&(isArray(object)||isString(object)||isArguments(object))}var castPath=__webpack_require__(356),isArguments=__webpack_require__(298),isArray=__webpack_require__(287),isIndex=__webpack_require__(296),isKey=__webpack_require__(329),isLength=__webpack_require__(292),isString=__webpack_require__(301);module.exports=hasPath},function(module,exports,__webpack_require__){function isSymbol(value){return"symbol"==typeof value||isObjectLike(value)&&objectToString.call(value)==symbolTag}var isObjectLike=__webpack_require__(300),symbolTag="[object Symbol]",objectProto=Object.prototype,objectToString=objectProto.toString;module.exports=isSymbol},function(module,exports,__webpack_require__){function isNative(value){if(!isObject(value))return!1;var pattern=isFunction(value)||isHostObject(value)?reIsNative:reIsHostCtor;return pattern.test(toSource(value))}var isFunction=__webpack_require__(270),isHostObject=__webpack_require__(354),isObject=__webpack_require__(261),toSource=__webpack_require__(317),reRegExpChar=/[\\^$.*+?()[\]{}|]/g,reIsHostCtor=/^\[object .+?Constructor\]$/,objectProto=Object.prototype,funcToString=Function.prototype.toString,hasOwnProperty=objectProto.hasOwnProperty,reIsNative=RegExp("^"+funcToString.call(hasOwnProperty).replace(reRegExpChar,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$");module.exports=isNative},function(module,exports,__webpack_require__){function createBaseFor(fromRight){return function(object,iteratee,keysFunc){for(var index=-1,iterable=Object(object),props=keysFunc(object),length=props.length;length--;){var key=props[fromRight?length:++index];if(iteratee(iterable[key],key,iterable)===!1)break}return object}}module.exports=createBaseFor},function(module,exports,__webpack_require__){function stackClear(){this.__data__={array:[],map:null}}module.exports=stackClear},function(module,exports,__webpack_require__){function stackDelete(key){var data=this.__data__,array=data.array;return array?assocDelete(array,key):data.map["delete"](key)}var assocDelete=__webpack_require__(357);module.exports=stackDelete},function(module,exports,__webpack_require__){function stackGet(key){var data=this.__data__,array=data.array;return array?assocGet(array,key):data.map.get(key)}var assocGet=__webpack_require__(358);module.exports=stackGet},function(module,exports,__webpack_require__){function stackHas(key){var data=this.__data__,array=data.array;return array?assocHas(array,key):data.map.has(key)}var assocHas=__webpack_require__(359);module.exports=stackHas},function(module,exports,__webpack_require__){function stackSet(key,value){var data=this.__data__,array=data.array;array&&(array.length<LARGE_ARRAY_SIZE-1?assocSet(array,key,value):(data.array=null,data.map=new MapCache(array)));var map=data.map;return map&&map.set(key,value),this}var MapCache=__webpack_require__(360),assocSet=__webpack_require__(361),LARGE_ARRAY_SIZE=200;module.exports=stackSet},function(module,exports,__webpack_require__){function baseToPairs(object,props){return arrayMap(props,function(key){return[key,object[key]]})}var arrayMap=__webpack_require__(362);module.exports=baseToPairs},function(module,exports,__webpack_require__){function equalArrays(array,other,equalFunc,customizer,bitmask,stack){var index=-1,isPartial=bitmask&PARTIAL_COMPARE_FLAG,isUnordered=bitmask&UNORDERED_COMPARE_FLAG,arrLength=array.length,othLength=other.length;if(arrLength!=othLength&&!(isPartial&&othLength>arrLength))return!1;var stacked=stack.get(array);if(stacked)return stacked==other;var result=!0;for(stack.set(array,other);++index<arrLength;){var arrValue=array[index],othValue=other[index];if(customizer)var compared=isPartial?customizer(othValue,arrValue,index,other,array,stack):customizer(arrValue,othValue,index,array,other,stack);if(void 0!==compared){if(compared)continue;result=!1;break}if(isUnordered){if(!arraySome(other,function(othValue){return arrValue===othValue||equalFunc(arrValue,othValue,customizer,bitmask,stack)})){result=!1;break}}else if(arrValue!==othValue&&!equalFunc(arrValue,othValue,customizer,bitmask,stack)){result=!1;break}}return stack["delete"](array),result}var arraySome=__webpack_require__(363),UNORDERED_COMPARE_FLAG=1,PARTIAL_COMPARE_FLAG=2;module.exports=equalArrays},function(module,exports,__webpack_require__){function equalByTag(object,other,tag,equalFunc,customizer,bitmask,stack){switch(tag){case dataViewTag:if(object.byteLength!=other.byteLength||object.byteOffset!=other.byteOffset)return!1;object=object.buffer,other=other.buffer;case arrayBufferTag:return object.byteLength==other.byteLength&&equalFunc(new Uint8Array(object),new Uint8Array(other))?!0:!1;case boolTag:case dateTag:return+object==+other;case errorTag:return object.name==other.name&&object.message==other.message;case numberTag:return object!=+object?other!=+other:object==+other;case regexpTag:case stringTag:return object==other+"";case mapTag:var convert=mapToArray;case setTag:var isPartial=bitmask&PARTIAL_COMPARE_FLAG;if(convert||(convert=setToArray),object.size!=other.size&&!isPartial)return!1;var stacked=stack.get(object);return stacked?stacked==other:(bitmask|=UNORDERED_COMPARE_FLAG,stack.set(object,other),equalArrays(convert(object),convert(other),equalFunc,customizer,bitmask,stack));
case symbolTag:if(symbolValueOf)return symbolValueOf.call(object)==symbolValueOf.call(other)}return!1}var Symbol=__webpack_require__(364),Uint8Array=__webpack_require__(365),equalArrays=__webpack_require__(351),mapToArray=__webpack_require__(366),setToArray=__webpack_require__(367),UNORDERED_COMPARE_FLAG=1,PARTIAL_COMPARE_FLAG=2,boolTag="[object Boolean]",dateTag="[object Date]",errorTag="[object Error]",mapTag="[object Map]",numberTag="[object Number]",regexpTag="[object RegExp]",setTag="[object Set]",stringTag="[object String]",symbolTag="[object Symbol]",arrayBufferTag="[object ArrayBuffer]",dataViewTag="[object DataView]",symbolProto=Symbol?Symbol.prototype:void 0,symbolValueOf=symbolProto?symbolProto.valueOf:void 0;module.exports=equalByTag},function(module,exports,__webpack_require__){function equalObjects(object,other,equalFunc,customizer,bitmask,stack){var isPartial=bitmask&PARTIAL_COMPARE_FLAG,objProps=keys(object),objLength=objProps.length,othProps=keys(other),othLength=othProps.length;if(objLength!=othLength&&!isPartial)return!1;for(var index=objLength;index--;){var key=objProps[index];if(!(isPartial?key in other:baseHas(other,key)))return!1}var stacked=stack.get(object);if(stacked)return stacked==other;var result=!0;stack.set(object,other);for(var skipCtor=isPartial;++index<objLength;){key=objProps[index];var objValue=object[key],othValue=other[key];if(customizer)var compared=isPartial?customizer(othValue,objValue,key,other,object,stack):customizer(objValue,othValue,key,object,other,stack);if(!(void 0===compared?objValue===othValue||equalFunc(objValue,othValue,customizer,bitmask,stack):compared)){result=!1;break}skipCtor||(skipCtor="constructor"==key)}if(result&&!skipCtor){var objCtor=object.constructor,othCtor=other.constructor;objCtor!=othCtor&&"constructor"in object&&"constructor"in other&&!("function"==typeof objCtor&&objCtor instanceof objCtor&&"function"==typeof othCtor&&othCtor instanceof othCtor)&&(result=!1)}return stack["delete"](object),result}var baseHas=__webpack_require__(293),keys=__webpack_require__(278),PARTIAL_COMPARE_FLAG=2;module.exports=equalObjects},function(module,exports,__webpack_require__){function isHostObject(value){var result=!1;if(null!=value&&"function"!=typeof value.toString)try{result=!!(value+"")}catch(e){}return result}module.exports=isHostObject},function(module,exports,__webpack_require__){function isTypedArray(value){return isObjectLike(value)&&isLength(value.length)&&!!typedArrayTags[objectToString.call(value)]}var isLength=__webpack_require__(292),isObjectLike=__webpack_require__(300),argsTag="[object Arguments]",arrayTag="[object Array]",boolTag="[object Boolean]",dateTag="[object Date]",errorTag="[object Error]",funcTag="[object Function]",mapTag="[object Map]",numberTag="[object Number]",objectTag="[object Object]",regexpTag="[object RegExp]",setTag="[object Set]",stringTag="[object String]",weakMapTag="[object WeakMap]",arrayBufferTag="[object ArrayBuffer]",dataViewTag="[object DataView]",float32Tag="[object Float32Array]",float64Tag="[object Float64Array]",int8Tag="[object Int8Array]",int16Tag="[object Int16Array]",int32Tag="[object Int32Array]",uint8Tag="[object Uint8Array]",uint8ClampedTag="[object Uint8ClampedArray]",uint16Tag="[object Uint16Array]",uint32Tag="[object Uint32Array]",typedArrayTags={};typedArrayTags[float32Tag]=typedArrayTags[float64Tag]=typedArrayTags[int8Tag]=typedArrayTags[int16Tag]=typedArrayTags[int32Tag]=typedArrayTags[uint8Tag]=typedArrayTags[uint8ClampedTag]=typedArrayTags[uint16Tag]=typedArrayTags[uint32Tag]=!0,typedArrayTags[argsTag]=typedArrayTags[arrayTag]=typedArrayTags[arrayBufferTag]=typedArrayTags[boolTag]=typedArrayTags[dataViewTag]=typedArrayTags[dateTag]=typedArrayTags[errorTag]=typedArrayTags[funcTag]=typedArrayTags[mapTag]=typedArrayTags[numberTag]=typedArrayTags[objectTag]=typedArrayTags[regexpTag]=typedArrayTags[setTag]=typedArrayTags[stringTag]=typedArrayTags[weakMapTag]=!1;var objectProto=Object.prototype,objectToString=objectProto.toString;module.exports=isTypedArray},function(module,exports,__webpack_require__){function castPath(value){return isArray(value)?value:stringToPath(value)}var isArray=__webpack_require__(287),stringToPath=__webpack_require__(368);module.exports=castPath},function(module,exports,__webpack_require__){function assocDelete(array,key){var index=assocIndexOf(array,key);if(0>index)return!1;var lastIndex=array.length-1;return index==lastIndex?array.pop():splice.call(array,index,1),!0}var assocIndexOf=__webpack_require__(369),arrayProto=Array.prototype,splice=arrayProto.splice;module.exports=assocDelete},function(module,exports,__webpack_require__){function assocGet(array,key){var index=assocIndexOf(array,key);return 0>index?void 0:array[index][1]}var assocIndexOf=__webpack_require__(369);module.exports=assocGet},function(module,exports,__webpack_require__){function assocHas(array,key){return assocIndexOf(array,key)>-1}var assocIndexOf=__webpack_require__(369);module.exports=assocHas},function(module,exports,__webpack_require__){function MapCache(values){var index=-1,length=values?values.length:0;for(this.clear();++index<length;){var entry=values[index];this.set(entry[0],entry[1])}}var mapClear=__webpack_require__(370),mapDelete=__webpack_require__(371),mapGet=__webpack_require__(372),mapHas=__webpack_require__(373),mapSet=__webpack_require__(374);MapCache.prototype.clear=mapClear,MapCache.prototype["delete"]=mapDelete,MapCache.prototype.get=mapGet,MapCache.prototype.has=mapHas,MapCache.prototype.set=mapSet,module.exports=MapCache},function(module,exports,__webpack_require__){function assocSet(array,key,value){var index=assocIndexOf(array,key);0>index?array.push([key,value]):array[index][1]=value}var assocIndexOf=__webpack_require__(369);module.exports=assocSet},function(module,exports,__webpack_require__){function arrayMap(array,iteratee){for(var index=-1,length=array.length,result=Array(length);++index<length;)result[index]=iteratee(array[index],index,array);return result}module.exports=arrayMap},function(module,exports,__webpack_require__){function arraySome(array,predicate){for(var index=-1,length=array.length;++index<length;)if(predicate(array[index],index,array))return!0;return!1}module.exports=arraySome},function(module,exports,__webpack_require__){var root=__webpack_require__(320),Symbol=root.Symbol;module.exports=Symbol},function(module,exports,__webpack_require__){var root=__webpack_require__(320),Uint8Array=root.Uint8Array;module.exports=Uint8Array},function(module,exports,__webpack_require__){function mapToArray(map){var index=-1,result=Array(map.size);return map.forEach(function(value,key){result[++index]=[key,value]}),result}module.exports=mapToArray},function(module,exports,__webpack_require__){function setToArray(set){var index=-1,result=Array(set.size);return set.forEach(function(value){result[++index]=value}),result}module.exports=setToArray},function(module,exports,__webpack_require__){var memoize=__webpack_require__(375),toString=__webpack_require__(376),rePropName=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]/g,reEscapeChar=/\\(\\)?/g,stringToPath=memoize(function(string){var result=[];return toString(string).replace(rePropName,function(match,number,quote,string){result.push(quote?string.replace(reEscapeChar,"$1"):number||match)}),result});module.exports=stringToPath},function(module,exports,__webpack_require__){function assocIndexOf(array,key){for(var length=array.length;length--;)if(eq(array[length][0],key))return length;return-1}var eq=__webpack_require__(289);module.exports=assocIndexOf},function(module,exports,__webpack_require__){function mapClear(){this.__data__={hash:new Hash,map:Map?new Map:[],string:new Hash}}var Hash=__webpack_require__(377),Map=__webpack_require__(313);module.exports=mapClear},function(module,exports,__webpack_require__){function mapDelete(key){var data=this.__data__;return isKeyable(key)?hashDelete("string"==typeof key?data.string:data.hash,key):Map?data.map["delete"](key):assocDelete(data.map,key)}var Map=__webpack_require__(313),assocDelete=__webpack_require__(357),hashDelete=__webpack_require__(378),isKeyable=__webpack_require__(379);module.exports=mapDelete},function(module,exports,__webpack_require__){function mapGet(key){var data=this.__data__;return isKeyable(key)?hashGet("string"==typeof key?data.string:data.hash,key):Map?data.map.get(key):assocGet(data.map,key)}var Map=__webpack_require__(313),assocGet=__webpack_require__(358),hashGet=__webpack_require__(380),isKeyable=__webpack_require__(379);module.exports=mapGet},function(module,exports,__webpack_require__){function mapHas(key){var data=this.__data__;return isKeyable(key)?hashHas("string"==typeof key?data.string:data.hash,key):Map?data.map.has(key):assocHas(data.map,key)}var Map=__webpack_require__(313),assocHas=__webpack_require__(359),hashHas=__webpack_require__(381),isKeyable=__webpack_require__(379);module.exports=mapHas},function(module,exports,__webpack_require__){function mapSet(key,value){var data=this.__data__;return isKeyable(key)?hashSet("string"==typeof key?data.string:data.hash,key,value):Map?data.map.set(key,value):assocSet(data.map,key,value),this}var Map=__webpack_require__(313),assocSet=__webpack_require__(361),hashSet=__webpack_require__(382),isKeyable=__webpack_require__(379);module.exports=mapSet},function(module,exports,__webpack_require__){function memoize(func,resolver){if("function"!=typeof func||resolver&&"function"!=typeof resolver)throw new TypeError(FUNC_ERROR_TEXT);var memoized=function(){var args=arguments,key=resolver?resolver.apply(this,args):args[0],cache=memoized.cache;if(cache.has(key))return cache.get(key);var result=func.apply(this,args);return memoized.cache=cache.set(key,result),result};return memoized.cache=new(memoize.Cache||MapCache),memoized}var MapCache=__webpack_require__(360),FUNC_ERROR_TEXT="Expected a function";memoize.Cache=MapCache,module.exports=memoize},function(module,exports,__webpack_require__){function toString(value){if("string"==typeof value)return value;if(null==value)return"";if(isSymbol(value))return symbolToString?symbolToString.call(value):"";var result=value+"";return"0"==result&&1/value==-INFINITY?"-0":result}var Symbol=__webpack_require__(364),isSymbol=__webpack_require__(342),INFINITY=1/0,symbolProto=Symbol?Symbol.prototype:void 0,symbolToString=symbolProto?symbolProto.toString:void 0;module.exports=toString},function(module,exports,__webpack_require__){function Hash(){}var nativeCreate=__webpack_require__(383),objectProto=Object.prototype;Hash.prototype=nativeCreate?nativeCreate(null):objectProto,module.exports=Hash},function(module,exports,__webpack_require__){function hashDelete(hash,key){return hashHas(hash,key)&&delete hash[key]}var hashHas=__webpack_require__(381);module.exports=hashDelete},function(module,exports,__webpack_require__){function isKeyable(value){var type=typeof value;return"number"==type||"boolean"==type||"string"==type&&"__proto__"!=value||null==value}module.exports=isKeyable},function(module,exports,__webpack_require__){function hashGet(hash,key){if(nativeCreate){var result=hash[key];return result===HASH_UNDEFINED?void 0:result}return hasOwnProperty.call(hash,key)?hash[key]:void 0}var nativeCreate=__webpack_require__(383),HASH_UNDEFINED="__lodash_hash_undefined__",objectProto=Object.prototype,hasOwnProperty=objectProto.hasOwnProperty;module.exports=hashGet},function(module,exports,__webpack_require__){function hashHas(hash,key){return nativeCreate?void 0!==hash[key]:hasOwnProperty.call(hash,key)}var nativeCreate=__webpack_require__(383),objectProto=Object.prototype,hasOwnProperty=objectProto.hasOwnProperty;module.exports=hashHas},function(module,exports,__webpack_require__){function hashSet(hash,key,value){hash[key]=nativeCreate&&void 0===value?HASH_UNDEFINED:value}var nativeCreate=__webpack_require__(383),HASH_UNDEFINED="__lodash_hash_undefined__";module.exports=hashSet},function(module,exports,__webpack_require__){var getNative=__webpack_require__(333),nativeCreate=getNative(Object,"create");module.exports=nativeCreate}])}),function(factory){"undefined"!=typeof exports?factory(exports):(window.hljs=factory({}),"function"==typeof define&&define.amd&&define("hljs",[],function(){return window.hljs}))}(function(hljs){function escape(value){return value.replace(/&/gm,"&amp;").replace(/</gm,"&lt;").replace(/>/gm,"&gt;")}function tag(node){return node.nodeName.toLowerCase()}function testRe(re,lexeme){var match=re&&re.exec(lexeme);return match&&0==match.index}function isNotHighlighted(language){return/^(no-?highlight|plain|text)$/i.test(language)}function blockLanguage(block){var i,match,length,classes=block.className+" ";if(classes+=block.parentNode?block.parentNode.className:"",match=/\blang(?:uage)?-([\w-]+)\b/i.exec(classes))return getLanguage(match[1])?match[1]:"no-highlight";for(classes=classes.split(/\s+/),i=0,length=classes.length;length>i;i++)if(getLanguage(classes[i])||isNotHighlighted(classes[i]))return classes[i]}function inherit(parent,obj){var key,result={};for(key in parent)result[key]=parent[key];if(obj)for(key in obj)result[key]=obj[key];return result}function nodeStream(node){var result=[];return function _nodeStream(node,offset){for(var child=node.firstChild;child;child=child.nextSibling)3==child.nodeType?offset+=child.nodeValue.length:1==child.nodeType&&(result.push({event:"start",offset:offset,node:child}),offset=_nodeStream(child,offset),tag(child).match(/br|hr|img|input/)||result.push({event:"stop",offset:offset,node:child}));return offset}(node,0),result}function mergeStreams(original,highlighted,value){function selectStream(){return original.length&&highlighted.length?original[0].offset!=highlighted[0].offset?original[0].offset<highlighted[0].offset?original:highlighted:"start"==highlighted[0].event?original:highlighted:original.length?original:highlighted}function open(node){function attr_str(a){return" "+a.nodeName+'="'+escape(a.value)+'"'}result+="<"+tag(node)+Array.prototype.map.call(node.attributes,attr_str).join("")+">"}function close(node){result+="</"+tag(node)+">"}function render(event){("start"==event.event?open:close)(event.node)}for(var processed=0,result="",nodeStack=[];original.length||highlighted.length;){var stream=selectStream();if(result+=escape(value.substr(processed,stream[0].offset-processed)),processed=stream[0].offset,stream==original){nodeStack.reverse().forEach(close);do render(stream.splice(0,1)[0]),stream=selectStream();while(stream==original&&stream.length&&stream[0].offset==processed);nodeStack.reverse().forEach(open)}else"start"==stream[0].event?nodeStack.push(stream[0].node):nodeStack.pop(),render(stream.splice(0,1)[0])}return result+escape(value.substr(processed))}function compileLanguage(language){function reStr(re){return re&&re.source||re}function langRe(value,global){return new RegExp(reStr(value),"m"+(language.case_insensitive?"i":"")+(global?"g":""))}function compileMode(mode,parent){if(!mode.compiled){if(mode.compiled=!0,mode.keywords=mode.keywords||mode.beginKeywords,mode.keywords){var compiled_keywords={},flatten=function(className,str){language.case_insensitive&&(str=str.toLowerCase()),str.split(" ").forEach(function(kw){var pair=kw.split("|");compiled_keywords[pair[0]]=[className,pair[1]?Number(pair[1]):1]})};"string"==typeof mode.keywords?flatten("keyword",mode.keywords):Object.keys(mode.keywords).forEach(function(className){flatten(className,mode.keywords[className])}),mode.keywords=compiled_keywords}mode.lexemesRe=langRe(mode.lexemes||/\b\w+\b/,!0),parent&&(mode.beginKeywords&&(mode.begin="\\b("+mode.beginKeywords.split(" ").join("|")+")\\b"),mode.begin||(mode.begin=/\B|\b/),mode.beginRe=langRe(mode.begin),mode.end||mode.endsWithParent||(mode.end=/\B|\b/),mode.end&&(mode.endRe=langRe(mode.end)),mode.terminator_end=reStr(mode.end)||"",mode.endsWithParent&&parent.terminator_end&&(mode.terminator_end+=(mode.end?"|":"")+parent.terminator_end)),mode.illegal&&(mode.illegalRe=langRe(mode.illegal)),void 0===mode.relevance&&(mode.relevance=1),mode.contains||(mode.contains=[]);var expanded_contains=[];mode.contains.forEach(function(c){c.variants?c.variants.forEach(function(v){expanded_contains.push(inherit(c,v))}):expanded_contains.push("self"==c?mode:c)}),mode.contains=expanded_contains,mode.contains.forEach(function(c){compileMode(c,mode)}),mode.starts&&compileMode(mode.starts,parent);var terminators=mode.contains.map(function(c){return c.beginKeywords?"\\.?("+c.begin+")\\.?":c.begin}).concat([mode.terminator_end,mode.illegal]).map(reStr).filter(Boolean);mode.terminators=terminators.length?langRe(terminators.join("|"),!0):{exec:function(){return null}}}}compileMode(language)}function highlight(name,value,ignore_illegals,continuation){function subMode(lexeme,mode){for(var i=0;i<mode.contains.length;i++)if(testRe(mode.contains[i].beginRe,lexeme))return mode.contains[i]}function endOfMode(mode,lexeme){if(testRe(mode.endRe,lexeme)){for(;mode.endsParent&&mode.parent;)mode=mode.parent;return mode}return mode.endsWithParent?endOfMode(mode.parent,lexeme):void 0}function isIllegal(lexeme,mode){return!ignore_illegals&&testRe(mode.illegalRe,lexeme)}function keywordMatch(mode,match){var match_str=language.case_insensitive?match[0].toLowerCase():match[0];return mode.keywords.hasOwnProperty(match_str)&&mode.keywords[match_str]}function buildSpan(classname,insideSpan,leaveOpen,noPrefix){var classPrefix=noPrefix?"":options.classPrefix,openSpan='<span class="'+classPrefix,closeSpan=leaveOpen?"":"</span>";return openSpan+=classname+'">',openSpan+insideSpan+closeSpan}function processKeywords(){if(!top.keywords)return escape(mode_buffer);var result="",last_index=0;top.lexemesRe.lastIndex=0;for(var match=top.lexemesRe.exec(mode_buffer);match;){result+=escape(mode_buffer.substr(last_index,match.index-last_index));var keyword_match=keywordMatch(top,match);keyword_match?(relevance+=keyword_match[1],result+=buildSpan(keyword_match[0],escape(match[0]))):result+=escape(match[0]),last_index=top.lexemesRe.lastIndex,match=top.lexemesRe.exec(mode_buffer)}return result+escape(mode_buffer.substr(last_index))}function processSubLanguage(){var explicit="string"==typeof top.subLanguage;if(explicit&&!languages[top.subLanguage])return escape(mode_buffer);var result=explicit?highlight(top.subLanguage,mode_buffer,!0,continuations[top.subLanguage]):highlightAuto(mode_buffer,top.subLanguage.length?top.subLanguage:void 0);return top.relevance>0&&(relevance+=result.relevance),explicit&&(continuations[top.subLanguage]=result.top),buildSpan(result.language,result.value,!1,!0)}function processBuffer(){return void 0!==top.subLanguage?processSubLanguage():processKeywords()}function startNewMode(mode,lexeme){var markup=mode.className?buildSpan(mode.className,"",!0):"";mode.returnBegin?(result+=markup,mode_buffer=""):mode.excludeBegin?(result+=escape(lexeme)+markup,mode_buffer=""):(result+=markup,mode_buffer=lexeme),top=Object.create(mode,{parent:{value:top}})}function processLexeme(buffer,lexeme){if(mode_buffer+=buffer,void 0===lexeme)return result+=processBuffer(),0;var new_mode=subMode(lexeme,top);if(new_mode)return result+=processBuffer(),startNewMode(new_mode,lexeme),new_mode.returnBegin?0:lexeme.length;var end_mode=endOfMode(top,lexeme);if(end_mode){var origin=top;origin.returnEnd||origin.excludeEnd||(mode_buffer+=lexeme),result+=processBuffer();do top.className&&(result+="</span>"),relevance+=top.relevance,top=top.parent;while(top!=end_mode.parent);return origin.excludeEnd&&(result+=escape(lexeme)),mode_buffer="",end_mode.starts&&startNewMode(end_mode.starts,""),origin.returnEnd?0:lexeme.length}if(isIllegal(lexeme,top))throw new Error('Illegal lexeme "'+lexeme+'" for mode "'+(top.className||"<unnamed>")+'"');return mode_buffer+=lexeme,lexeme.length||1}var language=getLanguage(name);if(!language)throw new Error('Unknown language: "'+name+'"');compileLanguage(language);var current,top=continuation||language,continuations={},result="";for(current=top;current!=language;current=current.parent)current.className&&(result=buildSpan(current.className,"",!0)+result);var mode_buffer="",relevance=0;try{for(var match,count,index=0;;){if(top.terminators.lastIndex=index,match=top.terminators.exec(value),!match)break;count=processLexeme(value.substr(index,match.index-index),match[0]),index=match.index+count}for(processLexeme(value.substr(index)),current=top;current.parent;current=current.parent)current.className&&(result+="</span>");return{relevance:relevance,value:result,language:name,top:top}}catch(e){if(-1!=e.message.indexOf("Illegal"))return{relevance:0,value:escape(value)};throw e}}function highlightAuto(text,languageSubset){languageSubset=languageSubset||options.languages||Object.keys(languages);var result={relevance:0,value:escape(text)},second_best=result;return languageSubset.forEach(function(name){if(getLanguage(name)){var current=highlight(name,text,!1);current.language=name,current.relevance>second_best.relevance&&(second_best=current),current.relevance>result.relevance&&(second_best=result,result=current)}}),second_best.language&&(result.second_best=second_best),result}function fixMarkup(value){return options.tabReplace&&(value=value.replace(/^((<[^>]+>|\t)+)/gm,function(match,p1){return p1.replace(/\t/g,options.tabReplace)})),options.useBR&&(value=value.replace(/\n/g,"<br>")),value}function buildClassName(prevClassName,currentLang,resultLang){var language=currentLang?aliases[currentLang]:resultLang,result=[prevClassName.trim()];return prevClassName.match(/\bhljs\b/)||result.push("hljs"),-1===prevClassName.indexOf(language)&&result.push(language),result.join(" ").trim()}function highlightBlock(block){var language=blockLanguage(block);if(!isNotHighlighted(language)){var node;options.useBR?(node=document.createElementNS("http://www.w3.org/1999/xhtml","div"),node.innerHTML=block.innerHTML.replace(/\n/g,"").replace(/<br[ \/]*>/g,"\n")):node=block;var text=node.textContent,result=language?highlight(language,text,!0):highlightAuto(text),originalStream=nodeStream(node);if(originalStream.length){var resultNode=document.createElementNS("http://www.w3.org/1999/xhtml","div");resultNode.innerHTML=result.value,result.value=mergeStreams(originalStream,nodeStream(resultNode),text)}result.value=fixMarkup(result.value),block.innerHTML=result.value,block.className=buildClassName(block.className,language,result.language),block.result={language:result.language,re:result.relevance},result.second_best&&(block.second_best={language:result.second_best.language,re:result.second_best.relevance})}}function configure(user_options){options=inherit(options,user_options)}function initHighlighting(){if(!initHighlighting.called){initHighlighting.called=!0;var blocks=document.querySelectorAll("pre code");Array.prototype.forEach.call(blocks,highlightBlock)}}function initHighlightingOnLoad(){addEventListener("DOMContentLoaded",initHighlighting,!1),addEventListener("load",initHighlighting,!1)}function registerLanguage(name,language){var lang=languages[name]=language(hljs);lang.aliases&&lang.aliases.forEach(function(alias){aliases[alias]=name})}function listLanguages(){return Object.keys(languages)}function getLanguage(name){return name=(name||"").toLowerCase(),languages[name]||languages[aliases[name]]}var options={classPrefix:"hljs-",tabReplace:null,useBR:!1,languages:void 0},languages={},aliases={};return hljs.highlight=highlight,hljs.highlightAuto=highlightAuto,hljs.fixMarkup=fixMarkup,hljs.highlightBlock=highlightBlock,hljs.configure=configure,hljs.initHighlighting=initHighlighting,hljs.initHighlightingOnLoad=initHighlightingOnLoad,hljs.registerLanguage=registerLanguage,hljs.listLanguages=listLanguages,hljs.getLanguage=getLanguage,hljs.inherit=inherit,hljs.IDENT_RE="[a-zA-Z]\\w*",hljs.UNDERSCORE_IDENT_RE="[a-zA-Z_]\\w*",hljs.NUMBER_RE="\\b\\d+(\\.\\d+)?",hljs.C_NUMBER_RE="(\\b0[xX][a-fA-F0-9]+|(\\b\\d+(\\.\\d*)?|\\.\\d+)([eE][-+]?\\d+)?)",hljs.BINARY_NUMBER_RE="\\b(0b[01]+)",hljs.RE_STARTERS_RE="!|!=|!==|%|%=|&|&&|&=|\\*|\\*=|\\+|\\+=|,|-|-=|/=|/|:|;|<<|<<=|<=|<|===|==|=|>>>=|>>=|>=|>>>|>>|>|\\?|\\[|\\{|\\(|\\^|\\^=|\\||\\|=|\\|\\||~",hljs.BACKSLASH_ESCAPE={begin:"\\\\[\\s\\S]",relevance:0},hljs.APOS_STRING_MODE={className:"string",begin:"'",end:"'",illegal:"\\n",contains:[hljs.BACKSLASH_ESCAPE]},hljs.QUOTE_STRING_MODE={className:"string",begin:'"',end:'"',illegal:"\\n",contains:[hljs.BACKSLASH_ESCAPE]},hljs.PHRASAL_WORDS_MODE={begin:/\b(a|an|the|are|I|I'm|isn't|don't|doesn't|won't|but|just|should|pretty|simply|enough|gonna|going|wtf|so|such|will|you|your|like)\b/},hljs.COMMENT=function(begin,end,inherits){var mode=hljs.inherit({className:"comment",begin:begin,end:end,contains:[]},inherits||{});return mode.contains.push(hljs.PHRASAL_WORDS_MODE),mode.contains.push({className:"doctag",begin:"(?:TODO|FIXME|NOTE|BUG|XXX):",relevance:0}),mode},hljs.C_LINE_COMMENT_MODE=hljs.COMMENT("//","$"),hljs.C_BLOCK_COMMENT_MODE=hljs.COMMENT("/\\*","\\*/"),hljs.HASH_COMMENT_MODE=hljs.COMMENT("#","$"),hljs.NUMBER_MODE={className:"number",begin:hljs.NUMBER_RE,relevance:0},hljs.C_NUMBER_MODE={className:"number",begin:hljs.C_NUMBER_RE,relevance:0},hljs.BINARY_NUMBER_MODE={className:"number",begin:hljs.BINARY_NUMBER_RE,relevance:0},hljs.CSS_NUMBER_MODE={className:"number",begin:hljs.NUMBER_RE+"(%|em|ex|ch|rem|vw|vh|vmin|vmax|cm|mm|in|pt|pc|px|deg|grad|rad|turn|s|ms|Hz|kHz|dpi|dpcm|dppx)?",relevance:0},hljs.REGEXP_MODE={className:"regexp",begin:/\//,end:/\/[gimuy]*/,illegal:/\n/,contains:[hljs.BACKSLASH_ESCAPE,{begin:/\[/,end:/\]/,relevance:0,contains:[hljs.BACKSLASH_ESCAPE]}]},hljs.TITLE_MODE={className:"title",begin:hljs.IDENT_RE,relevance:0},hljs.UNDERSCORE_TITLE_MODE={className:"title",begin:hljs.UNDERSCORE_IDENT_RE,relevance:0},hljs.registerLanguage("1c",function(hljs){var IDENT_RE_RU="[a-zA-Zа-яА-Я][a-zA-Z0-9_а-яА-Я]*",OneS_KEYWORDS="возврат дата для если и или иначе иначеесли исключение конецесли конецпопытки конецпроцедуры конецфункции конеццикла константа не перейти перем перечисление по пока попытка прервать продолжить процедура строка тогда фс функция цикл число экспорт",OneS_BUILT_IN="ansitooem oemtoansi ввестивидсубконто ввестидату ввестизначение ввестиперечисление ввестипериод ввестиплансчетов ввестистроку ввестичисло вопрос восстановитьзначение врег выбранныйплансчетов вызватьисключение датагод датамесяц датачисло добавитьмесяц завершитьработусистемы заголовоксистемы записьжурналарегистрации запуститьприложение зафиксироватьтранзакцию значениевстроку значениевстрокувнутр значениевфайл значениеизстроки значениеизстрокивнутр значениеизфайла имякомпьютера имяпользователя каталогвременныхфайлов каталогиб каталогпользователя каталогпрограммы кодсимв командасистемы конгода конецпериодаби конецрассчитанногопериодаби конецстандартногоинтервала конквартала конмесяца коннедели лев лог лог10 макс максимальноеколичествосубконто мин монопольныйрежим названиеинтерфейса названиенабораправ назначитьвид назначитьсчет найти найтипомеченныенаудаление найтиссылки началопериодаби началостандартногоинтервала начатьтранзакцию начгода начквартала начмесяца начнедели номерднягода номерднянедели номернеделигода нрег обработкаожидания окр описаниеошибки основнойжурналрасчетов основнойплансчетов основнойязык открытьформу открытьформумодально отменитьтранзакцию очиститьокносообщений периодстр полноеимяпользователя получитьвремята получитьдатута получитьдокументта получитьзначенияотбора получитьпозициюта получитьпустоезначение получитьта прав праводоступа предупреждение префиксавтонумерации пустаястрока пустоезначение рабочаядаттьпустоезначение рабочаядата разделительстраниц разделительстрок разм разобратьпозициюдокумента рассчитатьрегистрына рассчитатьрегистрыпо сигнал симв символтабуляции создатьобъект сокрл сокрлп сокрп сообщить состояние сохранитьзначение сред статусвозврата стрдлина стрзаменить стрколичествострок стрполучитьстроку  стрчисловхождений сформироватьпозициюдокумента счетпокоду текущаядата текущеевремя типзначения типзначениястр удалитьобъекты установитьтана установитьтапо фиксшаблон формат цел шаблон",DQUOTE={className:"dquote",begin:'""'},STR_START={className:"string",begin:'"',end:'"|$',contains:[DQUOTE]},STR_CONT={className:"string",begin:"\\|",end:'"|$',contains:[DQUOTE]};return{case_insensitive:!0,lexemes:IDENT_RE_RU,keywords:{keyword:OneS_KEYWORDS,built_in:OneS_BUILT_IN},contains:[hljs.C_LINE_COMMENT_MODE,hljs.NUMBER_MODE,STR_START,STR_CONT,{className:"function",begin:"(процедура|функция)",end:"$",lexemes:IDENT_RE_RU,keywords:"процедура функция",contains:[hljs.inherit(hljs.TITLE_MODE,{begin:IDENT_RE_RU}),{className:"tail",endsWithParent:!0,contains:[{className:"params",begin:"\\(",end:"\\)",lexemes:IDENT_RE_RU,keywords:"знач",contains:[STR_START,STR_CONT]},{className:"export",begin:"экспорт",endsWithParent:!0,lexemes:IDENT_RE_RU,keywords:"экспорт",contains:[hljs.C_LINE_COMMENT_MODE]}]},hljs.C_LINE_COMMENT_MODE]},{className:"preprocessor",begin:"#",end:"$"},{className:"date",begin:"'\\d{2}\\.\\d{2}\\.(\\d{2}|\\d{4})'"}]}}),hljs.registerLanguage("accesslog",function(hljs){return{contains:[{className:"number",begin:"\\b\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}(:\\d{1,5})?\\b"},{className:"number",begin:"\\b\\d+\\b",relevance:0},{className:"string",begin:'"(GET|POST|HEAD|PUT|DELETE|CONNECT|OPTIONS|PATCH|TRACE)',end:'"',keywords:"GET POST HEAD PUT DELETE CONNECT OPTIONS PATCH TRACE",illegal:"\\n",relevance:10},{className:"string",begin:/\[/,end:/\]/,illegal:"\\n"},{className:"string",begin:'"',end:'"',illegal:"\\n"}]}}),hljs.registerLanguage("actionscript",function(hljs){var IDENT_RE="[a-zA-Z_$][a-zA-Z0-9_$]*",IDENT_FUNC_RETURN_TYPE_RE="([*]|[a-zA-Z_$][a-zA-Z0-9_$]*)",AS3_REST_ARG_MODE={className:"rest_arg",begin:"[.]{3}",end:IDENT_RE,relevance:10};return{aliases:["as"],keywords:{keyword:"as break case catch class const continue default delete do dynamic each else extends final finally for function get if implements import in include instanceof interface internal is namespace native new override package private protected public return set static super switch this throw try typeof use var void while with",literal:"true false null undefined"},contains:[hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.C_NUMBER_MODE,{className:"package",beginKeywords:"package",end:"{",contains:[hljs.TITLE_MODE]},{className:"class",beginKeywords:"class interface",end:"{",excludeEnd:!0,contains:[{beginKeywords:"extends implements"},hljs.TITLE_MODE]},{className:"preprocessor",beginKeywords:"import include",end:";"},{className:"function",beginKeywords:"function",end:"[{;]",excludeEnd:!0,illegal:"\\S",contains:[hljs.TITLE_MODE,{className:"params",begin:"\\(",end:"\\)",contains:[hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,AS3_REST_ARG_MODE]},{className:"type",begin:":",end:IDENT_FUNC_RETURN_TYPE_RE,relevance:10}]}],illegal:/#/}}),hljs.registerLanguage("apache",function(hljs){var NUMBER={className:"number",begin:"[\\$%]\\d+"};return{aliases:["apacheconf"],case_insensitive:!0,contains:[hljs.HASH_COMMENT_MODE,{className:"tag",begin:"</?",end:">"},{className:"keyword",begin:/\w+/,relevance:0,keywords:{common:"order deny allow setenv rewriterule rewriteengine rewritecond documentroot sethandler errordocument loadmodule options header listen serverroot servername"},starts:{end:/$/,relevance:0,keywords:{literal:"on off all"},contains:[{className:"sqbracket",begin:"\\s\\[",end:"\\]$"},{className:"cbracket",begin:"[\\$%]\\{",end:"\\}",contains:["self",NUMBER]},NUMBER,hljs.QUOTE_STRING_MODE]}}],illegal:/\S/}}),hljs.registerLanguage("applescript",function(hljs){var STRING=hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:""}),PARAMS={className:"params",begin:"\\(",end:"\\)",contains:["self",hljs.C_NUMBER_MODE,STRING]},COMMENT_MODE_1=hljs.COMMENT("--","$"),COMMENT_MODE_2=hljs.COMMENT("\\(\\*","\\*\\)",{contains:["self",COMMENT_MODE_1]}),COMMENTS=[COMMENT_MODE_1,COMMENT_MODE_2,hljs.HASH_COMMENT_MODE];return{aliases:["osascript"],
keywords:{keyword:"about above after against and around as at back before beginning behind below beneath beside between but by considering contain contains continue copy div does eighth else end equal equals error every exit fifth first for fourth from front get given global if ignoring in into is it its last local me middle mod my ninth not of on onto or over prop property put ref reference repeat returning script second set seventh since sixth some tell tenth that the|0 then third through thru timeout times to transaction try until where while whose with without",constant:"AppleScript false linefeed return pi quote result space tab true",type:"alias application boolean class constant date file integer list number real record string text",command:"activate beep count delay launch log offset read round run say summarize write",property:"character characters contents day frontmost id item length month name paragraph paragraphs rest reverse running time version weekday word words year"},contains:[STRING,hljs.C_NUMBER_MODE,{className:"type",begin:"\\bPOSIX file\\b"},{className:"command",begin:"\\b(clipboard info|the clipboard|info for|list (disks|folder)|mount volume|path to|(close|open for) access|(get|set) eof|current date|do shell script|get volume settings|random number|set volume|system attribute|system info|time to GMT|(load|run|store) script|scripting components|ASCII (character|number)|localized string|choose (application|color|file|file name|folder|from list|remote application|URL)|display (alert|dialog))\\b|^\\s*return\\b"},{className:"constant",begin:"\\b(text item delimiters|current application|missing value)\\b"},{className:"keyword",begin:"\\b(apart from|aside from|instead of|out of|greater than|isn't|(doesn't|does not) (equal|come before|come after|contain)|(greater|less) than( or equal)?|(starts?|ends|begins?) with|contained by|comes (before|after)|a (ref|reference))\\b"},{className:"property",begin:"\\b(POSIX path|(date|time) string|quoted form)\\b"},{className:"function_start",beginKeywords:"on",illegal:"[${=;\\n]",contains:[hljs.UNDERSCORE_TITLE_MODE,PARAMS]}].concat(COMMENTS),illegal:"//|->|=>|\\[\\["}}),hljs.registerLanguage("armasm",function(hljs){return{case_insensitive:!0,aliases:["arm"],lexemes:"\\.?"+hljs.IDENT_RE,keywords:{literal:"r0 r1 r2 r3 r4 r5 r6 r7 r8 r9 r10 r11 r12 r13 r14 r15 pc lr sp ip sl sb fp a1 a2 a3 a4 v1 v2 v3 v4 v5 v6 v7 v8 f0 f1 f2 f3 f4 f5 f6 f7 p0 p1 p2 p3 p4 p5 p6 p7 p8 p9 p10 p11 p12 p13 p14 p15 c0 c1 c2 c3 c4 c5 c6 c7 c8 c9 c10 c11 c12 c13 c14 c15 q0 q1 q2 q3 q4 q5 q6 q7 q8 q9 q10 q11 q12 q13 q14 q15 cpsr_c cpsr_x cpsr_s cpsr_f cpsr_cx cpsr_cxs cpsr_xs cpsr_xsf cpsr_sf cpsr_cxsf spsr_c spsr_x spsr_s spsr_f spsr_cx spsr_cxs spsr_xs spsr_xsf spsr_sf spsr_cxsf s0 s1 s2 s3 s4 s5 s6 s7 s8 s9 s10 s11 s12 s13 s14 s15 s16 s17 s18 s19 s20 s21 s22 s23 s24 s25 s26 s27 s28 s29 s30 s31 d0 d1 d2 d3 d4 d5 d6 d7 d8 d9 d10 d11 d12 d13 d14 d15 d16 d17 d18 d19 d20 d21 d22 d23 d24 d25 d26 d27 d28 d29 d30 d31 ",preprocessor:".2byte .4byte .align .ascii .asciz .balign .byte .code .data .else .end .endif .endm .endr .equ .err .exitm .extern .global .hword .if .ifdef .ifndef .include .irp .long .macro .rept .req .section .set .skip .space .text .word .arm .thumb .code16 .code32 .force_thumb .thumb_func .ltorg ALIAS ALIGN ARM AREA ASSERT ATTR CN CODE CODE16 CODE32 COMMON CP DATA DCB DCD DCDU DCDO DCFD DCFDU DCI DCQ DCQU DCW DCWU DN ELIF ELSE END ENDFUNC ENDIF ENDP ENTRY EQU EXPORT EXPORTAS EXTERN FIELD FILL FUNCTION GBLA GBLL GBLS GET GLOBAL IF IMPORT INCBIN INCLUDE INFO KEEP LCLA LCLL LCLS LTORG MACRO MAP MEND MEXIT NOFP OPT PRESERVE8 PROC QN READONLY RELOC REQUIRE REQUIRE8 RLIST FN ROUT SETA SETL SETS SN SPACE SUBT THUMB THUMBX TTL WHILE WEND ",built_in:"{PC} {VAR} {TRUE} {FALSE} {OPT} {CONFIG} {ENDIAN} {CODESIZE} {CPU} {FPU} {ARCHITECTURE} {PCSTOREOFFSET} {ARMASM_VERSION} {INTER} {ROPI} {RWPI} {SWST} {NOSWST} . @ "},contains:[{className:"keyword",begin:"\\b(adc|(qd?|sh?|u[qh]?)?add(8|16)?|usada?8|(q|sh?|u[qh]?)?(as|sa)x|and|adrl?|sbc|rs[bc]|asr|b[lx]?|blx|bxj|cbn?z|tb[bh]|bic|bfc|bfi|[su]bfx|bkpt|cdp2?|clz|clrex|cmp|cmn|cpsi[ed]|cps|setend|dbg|dmb|dsb|eor|isb|it[te]{0,3}|lsl|lsr|ror|rrx|ldm(([id][ab])|f[ds])?|ldr((s|ex)?[bhd])?|movt?|mvn|mra|mar|mul|[us]mull|smul[bwt][bt]|smu[as]d|smmul|smmla|mla|umlaal|smlal?([wbt][bt]|d)|mls|smlsl?[ds]|smc|svc|sev|mia([bt]{2}|ph)?|mrr?c2?|mcrr2?|mrs|msr|orr|orn|pkh(tb|bt)|rbit|rev(16|sh)?|sel|[su]sat(16)?|nop|pop|push|rfe([id][ab])?|stm([id][ab])?|str(ex)?[bhd]?|(qd?)?sub|(sh?|q|u[qh]?)?sub(8|16)|[su]xt(a?h|a?b(16)?)|srs([id][ab])?|swpb?|swi|smi|tst|teq|wfe|wfi|yield)(eq|ne|cs|cc|mi|pl|vs|vc|hi|ls|ge|lt|gt|le|al|hs|lo)?[sptrx]?",end:"\\s"},hljs.COMMENT("[;@]","$",{relevance:0}),hljs.C_BLOCK_COMMENT_MODE,hljs.QUOTE_STRING_MODE,{className:"string",begin:"'",end:"[^\\\\]'",relevance:0},{className:"title",begin:"\\|",end:"\\|",illegal:"\\n",relevance:0},{className:"number",variants:[{begin:"[#$=]?0x[0-9a-f]+"},{begin:"[#$=]?0b[01]+"},{begin:"[#$=]\\d+"},{begin:"\\b\\d+"}],relevance:0},{className:"label",variants:[{begin:"^[a-z_\\.\\$][a-z0-9_\\.\\$]+"},{begin:"^\\s*[a-z_\\.\\$][a-z0-9_\\.\\$]+:"},{begin:"[=#]\\w+"}],relevance:0}]}}),hljs.registerLanguage("xml",function(hljs){var XML_IDENT_RE="[A-Za-z0-9\\._:-]+",PHP={begin:/<\?(php)?(?!\w)/,end:/\?>/,subLanguage:"php"},TAG_INTERNALS={endsWithParent:!0,illegal:/</,relevance:0,contains:[PHP,{className:"attribute",begin:XML_IDENT_RE,relevance:0},{begin:"=",relevance:0,contains:[{className:"value",contains:[PHP],variants:[{begin:/"/,end:/"/},{begin:/'/,end:/'/},{begin:/[^\s\/>]+/}]}]}]};return{aliases:["html","xhtml","rss","atom","xsl","plist"],case_insensitive:!0,contains:[{className:"doctype",begin:"<!DOCTYPE",end:">",relevance:10,contains:[{begin:"\\[",end:"\\]"}]},hljs.COMMENT("<!--","-->",{relevance:10}),{className:"cdata",begin:"<\\!\\[CDATA\\[",end:"\\]\\]>",relevance:10},{className:"tag",begin:"<style(?=\\s|>|$)",end:">",keywords:{title:"style"},contains:[TAG_INTERNALS],starts:{end:"</style>",returnEnd:!0,subLanguage:"css"}},{className:"tag",begin:"<script(?=\\s|>|$)",end:">",keywords:{title:"script"},contains:[TAG_INTERNALS],starts:{end:"</script>",returnEnd:!0,subLanguage:["actionscript","javascript","handlebars"]}},PHP,{className:"pi",begin:/<\?\w+/,end:/\?>/,relevance:10},{className:"tag",begin:"</?",end:"/?>",contains:[{className:"title",begin:/[^ \/><\n\t]+/,relevance:0},TAG_INTERNALS]}]}}),hljs.registerLanguage("asciidoc",function(hljs){return{aliases:["adoc"],contains:[hljs.COMMENT("^/{4,}\\n","\\n/{4,}$",{relevance:10}),hljs.COMMENT("^//","$",{relevance:0}),{className:"title",begin:"^\\.\\w.*$"},{begin:"^[=\\*]{4,}\\n",end:"\\n^[=\\*]{4,}$",relevance:10},{className:"header",begin:"^(={1,5}) .+?( \\1)?$",relevance:10},{className:"header",begin:"^[^\\[\\]\\n]+?\\n[=\\-~\\^\\+]{2,}$",relevance:10},{className:"attribute",begin:"^:.+?:",end:"\\s",excludeEnd:!0,relevance:10},{className:"attribute",begin:"^\\[.+?\\]$",relevance:0},{className:"blockquote",begin:"^_{4,}\\n",end:"\\n_{4,}$",relevance:10},{className:"code",begin:"^[\\-\\.]{4,}\\n",end:"\\n[\\-\\.]{4,}$",relevance:10},{begin:"^\\+{4,}\\n",end:"\\n\\+{4,}$",contains:[{begin:"<",end:">",subLanguage:"xml",relevance:0}],relevance:10},{className:"bullet",begin:"^(\\*+|\\-+|\\.+|[^\\n]+?::)\\s+"},{className:"label",begin:"^(NOTE|TIP|IMPORTANT|WARNING|CAUTION):\\s+",relevance:10},{className:"strong",begin:"\\B\\*(?![\\*\\s])",end:"(\\n{2}|\\*)",contains:[{begin:"\\\\*\\w",relevance:0}]},{className:"emphasis",begin:"\\B'(?!['\\s])",end:"(\\n{2}|')",contains:[{begin:"\\\\'\\w",relevance:0}],relevance:0},{className:"emphasis",begin:"_(?![_\\s])",end:"(\\n{2}|_)",relevance:0},{className:"smartquote",variants:[{begin:"``.+?''"},{begin:"`.+?'"}]},{className:"code",begin:"(`.+?`|\\+.+?\\+)",relevance:0},{className:"code",begin:"^[ \\t]",end:"$",relevance:0},{className:"horizontal_rule",begin:"^'{3,}[ \\t]*$",relevance:10},{begin:"(link:)?(http|https|ftp|file|irc|image:?):\\S+\\[.*?\\]",returnBegin:!0,contains:[{begin:"(link|image:?):",relevance:0},{className:"link_url",begin:"\\w",end:"[^\\[]+",relevance:0},{className:"link_label",begin:"\\[",end:"\\]",excludeBegin:!0,excludeEnd:!0,relevance:0}],relevance:10}]}}),hljs.registerLanguage("aspectj",function(hljs){var KEYWORDS="false synchronized int abstract float private char boolean static null if const for true while long throw strictfp finally protected import native final return void enum else extends implements break transient new catch instanceof byte super volatile case assert short package default double public try this switch continue throws privileged aspectOf adviceexecution proceed cflowbelow cflow initialization preinitialization staticinitialization withincode target within execution getWithinTypeName handler thisJoinPoint thisJoinPointStaticPart thisEnclosingJoinPointStaticPart declare parents warning error soft precedence thisAspectInstance",SHORTKEYS="get set args call";return{keywords:KEYWORDS,illegal:/<\/|#/,contains:[hljs.COMMENT("/\\*\\*","\\*/",{relevance:0,contains:[{className:"doctag",begin:"@[A-Za-z]+"}]}),hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,{className:"aspect",beginKeywords:"aspect",end:/[{;=]/,excludeEnd:!0,illegal:/[:;"\[\]]/,contains:[{beginKeywords:"extends implements pertypewithin perthis pertarget percflowbelow percflow issingleton"},hljs.UNDERSCORE_TITLE_MODE,{begin:/\([^\)]*/,end:/[)]+/,keywords:KEYWORDS+" "+SHORTKEYS,excludeEnd:!1}]},{className:"class",beginKeywords:"class interface",end:/[{;=]/,excludeEnd:!0,relevance:0,keywords:"class interface",illegal:/[:"\[\]]/,contains:[{beginKeywords:"extends implements"},hljs.UNDERSCORE_TITLE_MODE]},{beginKeywords:"pointcut after before around throwing returning",end:/[)]/,excludeEnd:!1,illegal:/["\[\]]/,contains:[{begin:hljs.UNDERSCORE_IDENT_RE+"\\s*\\(",returnBegin:!0,contains:[hljs.UNDERSCORE_TITLE_MODE]}]},{begin:/[:]/,returnBegin:!0,end:/[{;]/,relevance:0,excludeEnd:!1,keywords:KEYWORDS,illegal:/["\[\]]/,contains:[{begin:hljs.UNDERSCORE_IDENT_RE+"\\s*\\(",keywords:KEYWORDS+" "+SHORTKEYS},hljs.QUOTE_STRING_MODE]},{beginKeywords:"new throw",relevance:0},{className:"function",begin:/\w+ +\w+(\.)?\w+\s*\([^\)]*\)\s*((throws)[\w\s,]+)?[\{;]/,returnBegin:!0,end:/[{;=]/,keywords:KEYWORDS,excludeEnd:!0,contains:[{begin:hljs.UNDERSCORE_IDENT_RE+"\\s*\\(",returnBegin:!0,relevance:0,contains:[hljs.UNDERSCORE_TITLE_MODE]},{className:"params",begin:/\(/,end:/\)/,relevance:0,keywords:KEYWORDS,contains:[hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE,hljs.C_BLOCK_COMMENT_MODE]},hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE]},hljs.C_NUMBER_MODE,{className:"annotation",begin:"@[A-Za-z]+"}]}}),hljs.registerLanguage("autohotkey",function(hljs){var BACKTICK_ESCAPE={className:"escape",begin:"`[\\s\\S]"},COMMENTS=hljs.COMMENT(";","$",{relevance:0}),BUILT_IN=[{className:"built_in",begin:"A_[a-zA-Z0-9]+"},{className:"built_in",beginKeywords:"ComSpec Clipboard ClipboardAll ErrorLevel"}];return{case_insensitive:!0,keywords:{keyword:"Break Continue Else Gosub If Loop Return While",literal:"A true false NOT AND OR"},contains:BUILT_IN.concat([BACKTICK_ESCAPE,hljs.inherit(hljs.QUOTE_STRING_MODE,{contains:[BACKTICK_ESCAPE]}),COMMENTS,{className:"number",begin:hljs.NUMBER_RE,relevance:0},{className:"var_expand",begin:"%",end:"%",illegal:"\\n",contains:[BACKTICK_ESCAPE]},{className:"label",contains:[BACKTICK_ESCAPE],variants:[{begin:'^[^\\n";]+::(?!=)'},{begin:'^[^\\n";]+:(?!=)',relevance:0}]},{begin:",\\s*,",relevance:10}])}}),hljs.registerLanguage("autoit",function(hljs){var KEYWORDS="ByRef Case Const ContinueCase ContinueLoop Default Dim Do Else ElseIf EndFunc EndIf EndSelect EndSwitch EndWith Enum Exit ExitLoop For Func Global If In Local Next ReDim Return Select Static Step Switch Then To Until Volatile WEnd While With",LITERAL="True False And Null Not Or",BUILT_IN="Abs ACos AdlibRegister AdlibUnRegister Asc AscW ASin Assign ATan AutoItSetOption AutoItWinGetTitle AutoItWinSetTitle Beep Binary BinaryLen BinaryMid BinaryToString BitAND BitNOT BitOR BitRotate BitShift BitXOR BlockInput Break Call CDTray Ceiling Chr ChrW ClipGet ClipPut ConsoleRead ConsoleWrite ConsoleWriteError ControlClick ControlCommand ControlDisable ControlEnable ControlFocus ControlGetFocus ControlGetHandle ControlGetPos ControlGetText ControlHide ControlListView ControlMove ControlSend ControlSetText ControlShow ControlTreeView Cos Dec DirCopy DirCreate DirGetSize DirMove DirRemove DllCall DllCallAddress DllCallbackFree DllCallbackGetPtr DllCallbackRegister DllClose DllOpen DllStructCreate DllStructGetData DllStructGetPtr DllStructGetSize DllStructSetData DriveGetDrive DriveGetFileSystem DriveGetLabel DriveGetSerial DriveGetType DriveMapAdd DriveMapDel DriveMapGet DriveSetLabel DriveSpaceFree DriveSpaceTotal DriveStatus EnvGet EnvSet EnvUpdate Eval Execute Exp FileChangeDir FileClose FileCopy FileCreateNTFSLink FileCreateShortcut FileDelete FileExists FileFindFirstFile FileFindNextFile FileFlush FileGetAttrib FileGetEncoding FileGetLongName FileGetPos FileGetShortcut FileGetShortName FileGetSize FileGetTime FileGetVersion FileInstall FileMove FileOpen FileOpenDialog FileRead FileReadLine FileReadToArray FileRecycle FileRecycleEmpty FileSaveDialog FileSelectFolder FileSetAttrib FileSetEnd FileSetPos FileSetTime FileWrite FileWriteLine Floor FtpSetProxy FuncName GUICreate GUICtrlCreateAvi GUICtrlCreateButton GUICtrlCreateCheckbox GUICtrlCreateCombo GUICtrlCreateContextMenu GUICtrlCreateDate GUICtrlCreateDummy GUICtrlCreateEdit GUICtrlCreateGraphic GUICtrlCreateGroup GUICtrlCreateIcon GUICtrlCreateInput GUICtrlCreateLabel GUICtrlCreateList GUICtrlCreateListView GUICtrlCreateListViewItem GUICtrlCreateMenu GUICtrlCreateMenuItem GUICtrlCreateMonthCal GUICtrlCreateObj GUICtrlCreatePic GUICtrlCreateProgress GUICtrlCreateRadio GUICtrlCreateSlider GUICtrlCreateTab GUICtrlCreateTabItem GUICtrlCreateTreeView GUICtrlCreateTreeViewItem GUICtrlCreateUpdown GUICtrlDelete GUICtrlGetHandle GUICtrlGetState GUICtrlRead GUICtrlRecvMsg GUICtrlRegisterListViewSort GUICtrlSendMsg GUICtrlSendToDummy GUICtrlSetBkColor GUICtrlSetColor GUICtrlSetCursor GUICtrlSetData GUICtrlSetDefBkColor GUICtrlSetDefColor GUICtrlSetFont GUICtrlSetGraphic GUICtrlSetImage GUICtrlSetLimit GUICtrlSetOnEvent GUICtrlSetPos GUICtrlSetResizing GUICtrlSetState GUICtrlSetStyle GUICtrlSetTip GUIDelete GUIGetCursorInfo GUIGetMsg GUIGetStyle GUIRegisterMsg GUISetAccelerators GUISetBkColor GUISetCoord GUISetCursor GUISetFont GUISetHelp GUISetIcon GUISetOnEvent GUISetState GUISetStyle GUIStartGroup GUISwitch Hex HotKeySet HttpSetProxy HttpSetUserAgent HWnd InetClose InetGet InetGetInfo InetGetSize InetRead IniDelete IniRead IniReadSection IniReadSectionNames IniRenameSection IniWrite IniWriteSection InputBox Int IsAdmin IsArray IsBinary IsBool IsDeclared IsDllStruct IsFloat IsFunc IsHWnd IsInt IsKeyword IsNumber IsObj IsPtr IsString Log MemGetStats Mod MouseClick MouseClickDrag MouseDown MouseGetCursor MouseGetPos MouseMove MouseUp MouseWheel MsgBox Number ObjCreate ObjCreateInterface ObjEvent ObjGet ObjName OnAutoItExitRegister OnAutoItExitUnRegister Opt Ping PixelChecksum PixelGetColor PixelSearch ProcessClose ProcessExists ProcessGetStats ProcessList ProcessSetPriority ProcessWait ProcessWaitClose ProgressOff ProgressOn ProgressSet Ptr Random RegDelete RegEnumKey RegEnumVal RegRead RegWrite Round Run RunAs RunAsWait RunWait Send SendKeepActive SetError SetExtended ShellExecute ShellExecuteWait Shutdown Sin Sleep SoundPlay SoundSetWaveVolume SplashImageOn SplashOff SplashTextOn Sqrt SRandom StatusbarGetText StderrRead StdinWrite StdioClose StdoutRead String StringAddCR StringCompare StringFormat StringFromASCIIArray StringInStr StringIsAlNum StringIsAlpha StringIsASCII StringIsDigit StringIsFloat StringIsInt StringIsLower StringIsSpace StringIsUpper StringIsXDigit StringLeft StringLen StringLower StringMid StringRegExp StringRegExpReplace StringReplace StringReverse StringRight StringSplit StringStripCR StringStripWS StringToASCIIArray StringToBinary StringTrimLeft StringTrimRight StringUpper Tan TCPAccept TCPCloseSocket TCPConnect TCPListen TCPNameToIP TCPRecv TCPSend TCPShutdown TCPStartup TimerDiff TimerInit ToolTip TrayCreateItem TrayCreateMenu TrayGetMsg TrayItemDelete TrayItemGetHandle TrayItemGetState TrayItemGetText TrayItemSetOnEvent TrayItemSetState TrayItemSetText TraySetClick TraySetIcon TraySetOnEvent TraySetPauseIcon TraySetState TraySetToolTip TrayTip UBound UDPBind UDPCloseSocket UDPOpen UDPRecv UDPSend UDPShutdown UDPStartup VarGetType WinActivate WinActive WinClose WinExists WinFlash WinGetCaretPos WinGetClassList WinGetClientSize WinGetHandle WinGetPos WinGetProcess WinGetState WinGetText WinGetTitle WinKill WinList WinMenuSelectItem WinMinimizeAll WinMinimizeAllUndo WinMove WinSetOnTop WinSetState WinSetTitle WinSetTrans WinWait WinWaitActive WinWaitClose WinWaitNotActive Array1DToHistogram ArrayAdd ArrayBinarySearch ArrayColDelete ArrayColInsert ArrayCombinations ArrayConcatenate ArrayDelete ArrayDisplay ArrayExtract ArrayFindAll ArrayInsert ArrayMax ArrayMaxIndex ArrayMin ArrayMinIndex ArrayPermute ArrayPop ArrayPush ArrayReverse ArraySearch ArrayShuffle ArraySort ArraySwap ArrayToClip ArrayToString ArrayTranspose ArrayTrim ArrayUnique Assert ChooseColor ChooseFont ClipBoard_ChangeChain ClipBoard_Close ClipBoard_CountFormats ClipBoard_Empty ClipBoard_EnumFormats ClipBoard_FormatStr ClipBoard_GetData ClipBoard_GetDataEx ClipBoard_GetFormatName ClipBoard_GetOpenWindow ClipBoard_GetOwner ClipBoard_GetPriorityFormat ClipBoard_GetSequenceNumber ClipBoard_GetViewer ClipBoard_IsFormatAvailable ClipBoard_Open ClipBoard_RegisterFormat ClipBoard_SetData ClipBoard_SetDataEx ClipBoard_SetViewer ClipPutFile ColorConvertHSLtoRGB ColorConvertRGBtoHSL ColorGetBlue ColorGetCOLORREF ColorGetGreen ColorGetRed ColorGetRGB ColorSetCOLORREF ColorSetRGB Crypt_DecryptData Crypt_DecryptFile Crypt_DeriveKey Crypt_DestroyKey Crypt_EncryptData Crypt_EncryptFile Crypt_GenRandom Crypt_HashData Crypt_HashFile Crypt_Shutdown Crypt_Startup DateAdd DateDayOfWeek DateDaysInMonth DateDiff DateIsLeapYear DateIsValid DateTimeFormat DateTimeSplit DateToDayOfWeek DateToDayOfWeekISO DateToDayValue DateToMonth Date_Time_CompareFileTime Date_Time_DOSDateTimeToArray Date_Time_DOSDateTimeToFileTime Date_Time_DOSDateTimeToStr Date_Time_DOSDateToArray Date_Time_DOSDateToStr Date_Time_DOSTimeToArray Date_Time_DOSTimeToStr Date_Time_EncodeFileTime Date_Time_EncodeSystemTime Date_Time_FileTimeToArray Date_Time_FileTimeToDOSDateTime Date_Time_FileTimeToLocalFileTime Date_Time_FileTimeToStr Date_Time_FileTimeToSystemTime Date_Time_GetFileTime Date_Time_GetLocalTime Date_Time_GetSystemTime Date_Time_GetSystemTimeAdjustment Date_Time_GetSystemTimeAsFileTime Date_Time_GetSystemTimes Date_Time_GetTickCount Date_Time_GetTimeZoneInformation Date_Time_LocalFileTimeToFileTime Date_Time_SetFileTime Date_Time_SetLocalTime Date_Time_SetSystemTime Date_Time_SetSystemTimeAdjustment Date_Time_SetTimeZoneInformation Date_Time_SystemTimeToArray Date_Time_SystemTimeToDateStr Date_Time_SystemTimeToDateTimeStr Date_Time_SystemTimeToFileTime Date_Time_SystemTimeToTimeStr Date_Time_SystemTimeToTzSpecificLocalTime Date_Time_TzSpecificLocalTimeToSystemTime DayValueToDate DebugBugReportEnv DebugCOMError DebugOut DebugReport DebugReportEx DebugReportVar DebugSetup Degree EventLog__Backup EventLog__Clear EventLog__Close EventLog__Count EventLog__DeregisterSource EventLog__Full EventLog__Notify EventLog__Oldest EventLog__Open EventLog__OpenBackup EventLog__Read EventLog__RegisterSource EventLog__Report Excel_BookAttach Excel_BookClose Excel_BookList Excel_BookNew Excel_BookOpen Excel_BookOpenText Excel_BookSave Excel_BookSaveAs Excel_Close Excel_ColumnToLetter Excel_ColumnToNumber Excel_ConvertFormula Excel_Export Excel_FilterGet Excel_FilterSet Excel_Open Excel_PictureAdd Excel_Print Excel_RangeCopyPaste Excel_RangeDelete Excel_RangeFind Excel_RangeInsert Excel_RangeLinkAddRemove Excel_RangeRead Excel_RangeReplace Excel_RangeSort Excel_RangeValidate Excel_RangeWrite Excel_SheetAdd Excel_SheetCopyMove Excel_SheetDelete Excel_SheetList FileCountLines FileCreate FileListToArray FileListToArrayRec FilePrint FileReadToArray FileWriteFromArray FileWriteLog FileWriteToLine FTP_Close FTP_Command FTP_Connect FTP_DecodeInternetStatus FTP_DirCreate FTP_DirDelete FTP_DirGetCurrent FTP_DirPutContents FTP_DirSetCurrent FTP_FileClose FTP_FileDelete FTP_FileGet FTP_FileGetSize FTP_FileOpen FTP_FilePut FTP_FileRead FTP_FileRename FTP_FileTimeLoHiToStr FTP_FindFileClose FTP_FindFileFirst FTP_FindFileNext FTP_GetLastResponseInfo FTP_ListToArray FTP_ListToArray2D FTP_ListToArrayEx FTP_Open FTP_ProgressDownload FTP_ProgressUpload FTP_SetStatusCallback GDIPlus_ArrowCapCreate GDIPlus_ArrowCapDispose GDIPlus_ArrowCapGetFillState GDIPlus_ArrowCapGetHeight GDIPlus_ArrowCapGetMiddleInset GDIPlus_ArrowCapGetWidth GDIPlus_ArrowCapSetFillState GDIPlus_ArrowCapSetHeight GDIPlus_ArrowCapSetMiddleInset GDIPlus_ArrowCapSetWidth GDIPlus_BitmapApplyEffect GDIPlus_BitmapApplyEffectEx GDIPlus_BitmapCloneArea GDIPlus_BitmapConvertFormat GDIPlus_BitmapCreateApplyEffect GDIPlus_BitmapCreateApplyEffectEx GDIPlus_BitmapCreateDIBFromBitmap GDIPlus_BitmapCreateFromFile GDIPlus_BitmapCreateFromGraphics GDIPlus_BitmapCreateFromHBITMAP GDIPlus_BitmapCreateFromHICON GDIPlus_BitmapCreateFromHICON32 GDIPlus_BitmapCreateFromMemory GDIPlus_BitmapCreateFromResource GDIPlus_BitmapCreateFromScan0 GDIPlus_BitmapCreateFromStream GDIPlus_BitmapCreateHBITMAPFromBitmap GDIPlus_BitmapDispose GDIPlus_BitmapGetHistogram GDIPlus_BitmapGetHistogramEx GDIPlus_BitmapGetHistogramSize GDIPlus_BitmapGetPixel GDIPlus_BitmapLockBits GDIPlus_BitmapSetPixel GDIPlus_BitmapUnlockBits GDIPlus_BrushClone GDIPlus_BrushCreateSolid GDIPlus_BrushDispose GDIPlus_BrushGetSolidColor GDIPlus_BrushGetType GDIPlus_BrushSetSolidColor GDIPlus_ColorMatrixCreate GDIPlus_ColorMatrixCreateGrayScale GDIPlus_ColorMatrixCreateNegative GDIPlus_ColorMatrixCreateSaturation GDIPlus_ColorMatrixCreateScale GDIPlus_ColorMatrixCreateTranslate GDIPlus_CustomLineCapClone GDIPlus_CustomLineCapCreate GDIPlus_CustomLineCapDispose GDIPlus_CustomLineCapGetStrokeCaps GDIPlus_CustomLineCapSetStrokeCaps GDIPlus_Decoders GDIPlus_DecodersGetCount GDIPlus_DecodersGetSize GDIPlus_DrawImageFX GDIPlus_DrawImageFXEx GDIPlus_DrawImagePoints GDIPlus_EffectCreate GDIPlus_EffectCreateBlur GDIPlus_EffectCreateBrightnessContrast GDIPlus_EffectCreateColorBalance GDIPlus_EffectCreateColorCurve GDIPlus_EffectCreateColorLUT GDIPlus_EffectCreateColorMatrix GDIPlus_EffectCreateHueSaturationLightness GDIPlus_EffectCreateLevels GDIPlus_EffectCreateRedEyeCorrection GDIPlus_EffectCreateSharpen GDIPlus_EffectCreateTint GDIPlus_EffectDispose GDIPlus_EffectGetParameters GDIPlus_EffectSetParameters GDIPlus_Encoders GDIPlus_EncodersGetCLSID GDIPlus_EncodersGetCount GDIPlus_EncodersGetParamList GDIPlus_EncodersGetParamListSize GDIPlus_EncodersGetSize GDIPlus_FontCreate GDIPlus_FontDispose GDIPlus_FontFamilyCreate GDIPlus_FontFamilyCreateFromCollection GDIPlus_FontFamilyDispose GDIPlus_FontFamilyGetCellAscent GDIPlus_FontFamilyGetCellDescent GDIPlus_FontFamilyGetEmHeight GDIPlus_FontFamilyGetLineSpacing GDIPlus_FontGetHeight GDIPlus_FontPrivateAddFont GDIPlus_FontPrivateAddMemoryFont GDIPlus_FontPrivateCollectionDispose GDIPlus_FontPrivateCreateCollection GDIPlus_GraphicsClear GDIPlus_GraphicsCreateFromHDC GDIPlus_GraphicsCreateFromHWND GDIPlus_GraphicsDispose GDIPlus_GraphicsDrawArc GDIPlus_GraphicsDrawBezier GDIPlus_GraphicsDrawClosedCurve GDIPlus_GraphicsDrawClosedCurve2 GDIPlus_GraphicsDrawCurve GDIPlus_GraphicsDrawCurve2 GDIPlus_GraphicsDrawEllipse GDIPlus_GraphicsDrawImage GDIPlus_GraphicsDrawImagePointsRect GDIPlus_GraphicsDrawImageRect GDIPlus_GraphicsDrawImageRectRect GDIPlus_GraphicsDrawLine GDIPlus_GraphicsDrawPath GDIPlus_GraphicsDrawPie GDIPlus_GraphicsDrawPolygon GDIPlus_GraphicsDrawRect GDIPlus_GraphicsDrawString GDIPlus_GraphicsDrawStringEx GDIPlus_GraphicsFillClosedCurve GDIPlus_GraphicsFillClosedCurve2 GDIPlus_GraphicsFillEllipse GDIPlus_GraphicsFillPath GDIPlus_GraphicsFillPie GDIPlus_GraphicsFillPolygon GDIPlus_GraphicsFillRect GDIPlus_GraphicsFillRegion GDIPlus_GraphicsGetCompositingMode GDIPlus_GraphicsGetCompositingQuality GDIPlus_GraphicsGetDC GDIPlus_GraphicsGetInterpolationMode GDIPlus_GraphicsGetSmoothingMode GDIPlus_GraphicsGetTransform GDIPlus_GraphicsMeasureCharacterRanges GDIPlus_GraphicsMeasureString GDIPlus_GraphicsReleaseDC GDIPlus_GraphicsResetClip GDIPlus_GraphicsResetTransform GDIPlus_GraphicsRestore GDIPlus_GraphicsRotateTransform GDIPlus_GraphicsSave GDIPlus_GraphicsScaleTransform GDIPlus_GraphicsSetClipPath GDIPlus_GraphicsSetClipRect GDIPlus_GraphicsSetClipRegion GDIPlus_GraphicsSetCompositingMode GDIPlus_GraphicsSetCompositingQuality GDIPlus_GraphicsSetInterpolationMode GDIPlus_GraphicsSetPixelOffsetMode GDIPlus_GraphicsSetSmoothingMode GDIPlus_GraphicsSetTextRenderingHint GDIPlus_GraphicsSetTransform GDIPlus_GraphicsTransformPoints GDIPlus_GraphicsTranslateTransform GDIPlus_HatchBrushCreate GDIPlus_HICONCreateFromBitmap GDIPlus_ImageAttributesCreate GDIPlus_ImageAttributesDispose GDIPlus_ImageAttributesSetColorKeys GDIPlus_ImageAttributesSetColorMatrix GDIPlus_ImageDispose GDIPlus_ImageGetDimension GDIPlus_ImageGetFlags GDIPlus_ImageGetGraphicsContext GDIPlus_ImageGetHeight GDIPlus_ImageGetHorizontalResolution GDIPlus_ImageGetPixelFormat GDIPlus_ImageGetRawFormat GDIPlus_ImageGetThumbnail GDIPlus_ImageGetType GDIPlus_ImageGetVerticalResolution GDIPlus_ImageGetWidth GDIPlus_ImageLoadFromFile GDIPlus_ImageLoadFromStream GDIPlus_ImageResize GDIPlus_ImageRotateFlip GDIPlus_ImageSaveToFile GDIPlus_ImageSaveToFileEx GDIPlus_ImageSaveToStream GDIPlus_ImageScale GDIPlus_LineBrushCreate GDIPlus_LineBrushCreateFromRect GDIPlus_LineBrushCreateFromRectWithAngle GDIPlus_LineBrushGetColors GDIPlus_LineBrushGetRect GDIPlus_LineBrushMultiplyTransform GDIPlus_LineBrushResetTransform GDIPlus_LineBrushSetBlend GDIPlus_LineBrushSetColors GDIPlus_LineBrushSetGammaCorrection GDIPlus_LineBrushSetLinearBlend GDIPlus_LineBrushSetPresetBlend GDIPlus_LineBrushSetSigmaBlend GDIPlus_LineBrushSetTransform GDIPlus_MatrixClone GDIPlus_MatrixCreate GDIPlus_MatrixDispose GDIPlus_MatrixGetElements GDIPlus_MatrixInvert GDIPlus_MatrixMultiply GDIPlus_MatrixRotate GDIPlus_MatrixScale GDIPlus_MatrixSetElements GDIPlus_MatrixShear GDIPlus_MatrixTransformPoints GDIPlus_MatrixTranslate GDIPlus_PaletteInitialize GDIPlus_ParamAdd GDIPlus_ParamInit GDIPlus_ParamSize GDIPlus_PathAddArc GDIPlus_PathAddBezier GDIPlus_PathAddClosedCurve GDIPlus_PathAddClosedCurve2 GDIPlus_PathAddCurve GDIPlus_PathAddCurve2 GDIPlus_PathAddCurve3 GDIPlus_PathAddEllipse GDIPlus_PathAddLine GDIPlus_PathAddLine2 GDIPlus_PathAddPath GDIPlus_PathAddPie GDIPlus_PathAddPolygon GDIPlus_PathAddRectangle GDIPlus_PathAddString GDIPlus_PathBrushCreate GDIPlus_PathBrushCreateFromPath GDIPlus_PathBrushGetCenterPoint GDIPlus_PathBrushGetFocusScales GDIPlus_PathBrushGetPointCount GDIPlus_PathBrushGetRect GDIPlus_PathBrushGetWrapMode GDIPlus_PathBrushMultiplyTransform GDIPlus_PathBrushResetTransform GDIPlus_PathBrushSetBlend GDIPlus_PathBrushSetCenterColor GDIPlus_PathBrushSetCenterPoint GDIPlus_PathBrushSetFocusScales GDIPlus_PathBrushSetGammaCorrection GDIPlus_PathBrushSetLinearBlend GDIPlus_PathBrushSetPresetBlend GDIPlus_PathBrushSetSigmaBlend GDIPlus_PathBrushSetSurroundColor GDIPlus_PathBrushSetSurroundColorsWithCount GDIPlus_PathBrushSetTransform GDIPlus_PathBrushSetWrapMode GDIPlus_PathClone GDIPlus_PathCloseFigure GDIPlus_PathCreate GDIPlus_PathCreate2 GDIPlus_PathDispose GDIPlus_PathFlatten GDIPlus_PathGetData GDIPlus_PathGetFillMode GDIPlus_PathGetLastPoint GDIPlus_PathGetPointCount GDIPlus_PathGetPoints GDIPlus_PathGetWorldBounds GDIPlus_PathIsOutlineVisiblePoint GDIPlus_PathIsVisiblePoint GDIPlus_PathIterCreate GDIPlus_PathIterDispose GDIPlus_PathIterGetSubpathCount GDIPlus_PathIterNextMarkerPath GDIPlus_PathIterNextSubpathPath GDIPlus_PathIterRewind GDIPlus_PathReset GDIPlus_PathReverse GDIPlus_PathSetFillMode GDIPlus_PathSetMarker GDIPlus_PathStartFigure GDIPlus_PathTransform GDIPlus_PathWarp GDIPlus_PathWiden GDIPlus_PathWindingModeOutline GDIPlus_PenCreate GDIPlus_PenCreate2 GDIPlus_PenDispose GDIPlus_PenGetAlignment GDIPlus_PenGetColor GDIPlus_PenGetCustomEndCap GDIPlus_PenGetDashCap GDIPlus_PenGetDashStyle GDIPlus_PenGetEndCap GDIPlus_PenGetMiterLimit GDIPlus_PenGetWidth GDIPlus_PenSetAlignment GDIPlus_PenSetColor GDIPlus_PenSetCustomEndCap GDIPlus_PenSetDashCap GDIPlus_PenSetDashStyle GDIPlus_PenSetEndCap GDIPlus_PenSetLineCap GDIPlus_PenSetLineJoin GDIPlus_PenSetMiterLimit GDIPlus_PenSetStartCap GDIPlus_PenSetWidth GDIPlus_RectFCreate GDIPlus_RegionClone GDIPlus_RegionCombinePath GDIPlus_RegionCombineRect GDIPlus_RegionCombineRegion GDIPlus_RegionCreate GDIPlus_RegionCreateFromPath GDIPlus_RegionCreateFromRect GDIPlus_RegionDispose GDIPlus_RegionGetBounds GDIPlus_RegionGetHRgn GDIPlus_RegionTransform GDIPlus_RegionTranslate GDIPlus_Shutdown GDIPlus_Startup GDIPlus_StringFormatCreate GDIPlus_StringFormatDispose GDIPlus_StringFormatGetMeasurableCharacterRangeCount GDIPlus_StringFormatSetAlign GDIPlus_StringFormatSetLineAlign GDIPlus_StringFormatSetMeasurableCharacterRanges GDIPlus_TextureCreate GDIPlus_TextureCreate2 GDIPlus_TextureCreateIA GetIP GUICtrlAVI_Close GUICtrlAVI_Create GUICtrlAVI_Destroy GUICtrlAVI_IsPlaying GUICtrlAVI_Open GUICtrlAVI_OpenEx GUICtrlAVI_Play GUICtrlAVI_Seek GUICtrlAVI_Show GUICtrlAVI_Stop GUICtrlButton_Click GUICtrlButton_Create GUICtrlButton_Destroy GUICtrlButton_Enable GUICtrlButton_GetCheck GUICtrlButton_GetFocus GUICtrlButton_GetIdealSize GUICtrlButton_GetImage GUICtrlButton_GetImageList GUICtrlButton_GetNote GUICtrlButton_GetNoteLength GUICtrlButton_GetSplitInfo GUICtrlButton_GetState GUICtrlButton_GetText GUICtrlButton_GetTextMargin GUICtrlButton_SetCheck GUICtrlButton_SetDontClick GUICtrlButton_SetFocus GUICtrlButton_SetImage GUICtrlButton_SetImageList GUICtrlButton_SetNote GUICtrlButton_SetShield GUICtrlButton_SetSize GUICtrlButton_SetSplitInfo GUICtrlButton_SetState GUICtrlButton_SetStyle GUICtrlButton_SetText GUICtrlButton_SetTextMargin GUICtrlButton_Show GUICtrlComboBoxEx_AddDir GUICtrlComboBoxEx_AddString GUICtrlComboBoxEx_BeginUpdate GUICtrlComboBoxEx_Create GUICtrlComboBoxEx_CreateSolidBitMap GUICtrlComboBoxEx_DeleteString GUICtrlComboBoxEx_Destroy GUICtrlComboBoxEx_EndUpdate GUICtrlComboBoxEx_FindStringExact GUICtrlComboBoxEx_GetComboBoxInfo GUICtrlComboBoxEx_GetComboControl GUICtrlComboBoxEx_GetCount GUICtrlComboBoxEx_GetCurSel GUICtrlComboBoxEx_GetDroppedControlRect GUICtrlComboBoxEx_GetDroppedControlRectEx GUICtrlComboBoxEx_GetDroppedState GUICtrlComboBoxEx_GetDroppedWidth GUICtrlComboBoxEx_GetEditControl GUICtrlComboBoxEx_GetEditSel GUICtrlComboBoxEx_GetEditText GUICtrlComboBoxEx_GetExtendedStyle GUICtrlComboBoxEx_GetExtendedUI GUICtrlComboBoxEx_GetImageList GUICtrlComboBoxEx_GetItem GUICtrlComboBoxEx_GetItemEx GUICtrlComboBoxEx_GetItemHeight GUICtrlComboBoxEx_GetItemImage GUICtrlComboBoxEx_GetItemIndent GUICtrlComboBoxEx_GetItemOverlayImage GUICtrlComboBoxEx_GetItemParam GUICtrlComboBoxEx_GetItemSelectedImage GUICtrlComboBoxEx_GetItemText GUICtrlComboBoxEx_GetItemTextLen GUICtrlComboBoxEx_GetList GUICtrlComboBoxEx_GetListArray GUICtrlComboBoxEx_GetLocale GUICtrlComboBoxEx_GetLocaleCountry GUICtrlComboBoxEx_GetLocaleLang GUICtrlComboBoxEx_GetLocalePrimLang GUICtrlComboBoxEx_GetLocaleSubLang GUICtrlComboBoxEx_GetMinVisible GUICtrlComboBoxEx_GetTopIndex GUICtrlComboBoxEx_GetUnicode GUICtrlComboBoxEx_InitStorage GUICtrlComboBoxEx_InsertString GUICtrlComboBoxEx_LimitText GUICtrlComboBoxEx_ReplaceEditSel GUICtrlComboBoxEx_ResetContent GUICtrlComboBoxEx_SetCurSel GUICtrlComboBoxEx_SetDroppedWidth GUICtrlComboBoxEx_SetEditSel GUICtrlComboBoxEx_SetEditText GUICtrlComboBoxEx_SetExtendedStyle GUICtrlComboBoxEx_SetExtendedUI GUICtrlComboBoxEx_SetImageList GUICtrlComboBoxEx_SetItem GUICtrlComboBoxEx_SetItemEx GUICtrlComboBoxEx_SetItemHeight GUICtrlComboBoxEx_SetItemImage GUICtrlComboBoxEx_SetItemIndent GUICtrlComboBoxEx_SetItemOverlayImage GUICtrlComboBoxEx_SetItemParam GUICtrlComboBoxEx_SetItemSelectedImage GUICtrlComboBoxEx_SetMinVisible GUICtrlComboBoxEx_SetTopIndex GUICtrlComboBoxEx_SetUnicode GUICtrlComboBoxEx_ShowDropDown GUICtrlComboBox_AddDir GUICtrlComboBox_AddString GUICtrlComboBox_AutoComplete GUICtrlComboBox_BeginUpdate GUICtrlComboBox_Create GUICtrlComboBox_DeleteString GUICtrlComboBox_Destroy GUICtrlComboBox_EndUpdate GUICtrlComboBox_FindString GUICtrlComboBox_FindStringExact GUICtrlComboBox_GetComboBoxInfo GUICtrlComboBox_GetCount GUICtrlComboBox_GetCueBanner GUICtrlComboBox_GetCurSel GUICtrlComboBox_GetDroppedControlRect GUICtrlComboBox_GetDroppedControlRectEx GUICtrlComboBox_GetDroppedState GUICtrlComboBox_GetDroppedWidth GUICtrlComboBox_GetEditSel GUICtrlComboBox_GetEditText GUICtrlComboBox_GetExtendedUI GUICtrlComboBox_GetHorizontalExtent GUICtrlComboBox_GetItemHeight GUICtrlComboBox_GetLBText GUICtrlComboBox_GetLBTextLen GUICtrlComboBox_GetList GUICtrlComboBox_GetListArray GUICtrlComboBox_GetLocale GUICtrlComboBox_GetLocaleCountry GUICtrlComboBox_GetLocaleLang GUICtrlComboBox_GetLocalePrimLang GUICtrlComboBox_GetLocaleSubLang GUICtrlComboBox_GetMinVisible GUICtrlComboBox_GetTopIndex GUICtrlComboBox_InitStorage GUICtrlComboBox_InsertString GUICtrlComboBox_LimitText GUICtrlComboBox_ReplaceEditSel GUICtrlComboBox_ResetContent GUICtrlComboBox_SelectString GUICtrlComboBox_SetCueBanner GUICtrlComboBox_SetCurSel GUICtrlComboBox_SetDroppedWidth GUICtrlComboBox_SetEditSel GUICtrlComboBox_SetEditText GUICtrlComboBox_SetExtendedUI GUICtrlComboBox_SetHorizontalExtent GUICtrlComboBox_SetItemHeight GUICtrlComboBox_SetMinVisible GUICtrlComboBox_SetTopIndex GUICtrlComboBox_ShowDropDown GUICtrlDTP_Create GUICtrlDTP_Destroy GUICtrlDTP_GetMCColor GUICtrlDTP_GetMCFont GUICtrlDTP_GetMonthCal GUICtrlDTP_GetRange GUICtrlDTP_GetRangeEx GUICtrlDTP_GetSystemTime GUICtrlDTP_GetSystemTimeEx GUICtrlDTP_SetFormat GUICtrlDTP_SetMCColor GUICtrlDTP_SetMCFont GUICtrlDTP_SetRange GUICtrlDTP_SetRangeEx GUICtrlDTP_SetSystemTime GUICtrlDTP_SetSystemTimeEx GUICtrlEdit_AppendText GUICtrlEdit_BeginUpdate GUICtrlEdit_CanUndo GUICtrlEdit_CharFromPos GUICtrlEdit_Create GUICtrlEdit_Destroy GUICtrlEdit_EmptyUndoBuffer GUICtrlEdit_EndUpdate GUICtrlEdit_Find GUICtrlEdit_FmtLines GUICtrlEdit_GetCueBanner GUICtrlEdit_GetFirstVisibleLine GUICtrlEdit_GetLimitText GUICtrlEdit_GetLine GUICtrlEdit_GetLineCount GUICtrlEdit_GetMargins GUICtrlEdit_GetModify GUICtrlEdit_GetPasswordChar GUICtrlEdit_GetRECT GUICtrlEdit_GetRECTEx GUICtrlEdit_GetSel GUICtrlEdit_GetText GUICtrlEdit_GetTextLen GUICtrlEdit_HideBalloonTip GUICtrlEdit_InsertText GUICtrlEdit_LineFromChar GUICtrlEdit_LineIndex GUICtrlEdit_LineLength GUICtrlEdit_LineScroll GUICtrlEdit_PosFromChar GUICtrlEdit_ReplaceSel GUICtrlEdit_Scroll GUICtrlEdit_SetCueBanner GUICtrlEdit_SetLimitText GUICtrlEdit_SetMargins GUICtrlEdit_SetModify GUICtrlEdit_SetPasswordChar GUICtrlEdit_SetReadOnly GUICtrlEdit_SetRECT GUICtrlEdit_SetRECTEx GUICtrlEdit_SetRECTNP GUICtrlEdit_SetRectNPEx GUICtrlEdit_SetSel GUICtrlEdit_SetTabStops GUICtrlEdit_SetText GUICtrlEdit_ShowBalloonTip GUICtrlEdit_Undo GUICtrlHeader_AddItem GUICtrlHeader_ClearFilter GUICtrlHeader_ClearFilterAll GUICtrlHeader_Create GUICtrlHeader_CreateDragImage GUICtrlHeader_DeleteItem GUICtrlHeader_Destroy GUICtrlHeader_EditFilter GUICtrlHeader_GetBitmapMargin GUICtrlHeader_GetImageList GUICtrlHeader_GetItem GUICtrlHeader_GetItemAlign GUICtrlHeader_GetItemBitmap GUICtrlHeader_GetItemCount GUICtrlHeader_GetItemDisplay GUICtrlHeader_GetItemFlags GUICtrlHeader_GetItemFormat GUICtrlHeader_GetItemImage GUICtrlHeader_GetItemOrder GUICtrlHeader_GetItemParam GUICtrlHeader_GetItemRect GUICtrlHeader_GetItemRectEx GUICtrlHeader_GetItemText GUICtrlHeader_GetItemWidth GUICtrlHeader_GetOrderArray GUICtrlHeader_GetUnicodeFormat GUICtrlHeader_HitTest GUICtrlHeader_InsertItem GUICtrlHeader_Layout GUICtrlHeader_OrderToIndex GUICtrlHeader_SetBitmapMargin GUICtrlHeader_SetFilterChangeTimeout GUICtrlHeader_SetHotDivider GUICtrlHeader_SetImageList GUICtrlHeader_SetItem GUICtrlHeader_SetItemAlign GUICtrlHeader_SetItemBitmap GUICtrlHeader_SetItemDisplay GUICtrlHeader_SetItemFlags GUICtrlHeader_SetItemFormat GUICtrlHeader_SetItemImage GUICtrlHeader_SetItemOrder GUICtrlHeader_SetItemParam GUICtrlHeader_SetItemText GUICtrlHeader_SetItemWidth GUICtrlHeader_SetOrderArray GUICtrlHeader_SetUnicodeFormat GUICtrlIpAddress_ClearAddress GUICtrlIpAddress_Create GUICtrlIpAddress_Destroy GUICtrlIpAddress_Get GUICtrlIpAddress_GetArray GUICtrlIpAddress_GetEx GUICtrlIpAddress_IsBlank GUICtrlIpAddress_Set GUICtrlIpAddress_SetArray GUICtrlIpAddress_SetEx GUICtrlIpAddress_SetFocus GUICtrlIpAddress_SetFont GUICtrlIpAddress_SetRange GUICtrlIpAddress_ShowHide GUICtrlListBox_AddFile GUICtrlListBox_AddString GUICtrlListBox_BeginUpdate GUICtrlListBox_ClickItem GUICtrlListBox_Create GUICtrlListBox_DeleteString GUICtrlListBox_Destroy GUICtrlListBox_Dir GUICtrlListBox_EndUpdate GUICtrlListBox_FindInText GUICtrlListBox_FindString GUICtrlListBox_GetAnchorIndex GUICtrlListBox_GetCaretIndex GUICtrlListBox_GetCount GUICtrlListBox_GetCurSel GUICtrlListBox_GetHorizontalExtent GUICtrlListBox_GetItemData GUICtrlListBox_GetItemHeight GUICtrlListBox_GetItemRect GUICtrlListBox_GetItemRectEx GUICtrlListBox_GetListBoxInfo GUICtrlListBox_GetLocale GUICtrlListBox_GetLocaleCountry GUICtrlListBox_GetLocaleLang GUICtrlListBox_GetLocalePrimLang GUICtrlListBox_GetLocaleSubLang GUICtrlListBox_GetSel GUICtrlListBox_GetSelCount GUICtrlListBox_GetSelItems GUICtrlListBox_GetSelItemsText GUICtrlListBox_GetText GUICtrlListBox_GetTextLen GUICtrlListBox_GetTopIndex GUICtrlListBox_InitStorage GUICtrlListBox_InsertString GUICtrlListBox_ItemFromPoint GUICtrlListBox_ReplaceString GUICtrlListBox_ResetContent GUICtrlListBox_SelectString GUICtrlListBox_SelItemRange GUICtrlListBox_SelItemRangeEx GUICtrlListBox_SetAnchorIndex GUICtrlListBox_SetCaretIndex GUICtrlListBox_SetColumnWidth GUICtrlListBox_SetCurSel GUICtrlListBox_SetHorizontalExtent GUICtrlListBox_SetItemData GUICtrlListBox_SetItemHeight GUICtrlListBox_SetLocale GUICtrlListBox_SetSel GUICtrlListBox_SetTabStops GUICtrlListBox_SetTopIndex GUICtrlListBox_Sort GUICtrlListBox_SwapString GUICtrlListBox_UpdateHScroll GUICtrlListView_AddArray GUICtrlListView_AddColumn GUICtrlListView_AddItem GUICtrlListView_AddSubItem GUICtrlListView_ApproximateViewHeight GUICtrlListView_ApproximateViewRect GUICtrlListView_ApproximateViewWidth GUICtrlListView_Arrange GUICtrlListView_BeginUpdate GUICtrlListView_CancelEditLabel GUICtrlListView_ClickItem GUICtrlListView_CopyItems GUICtrlListView_Create GUICtrlListView_CreateDragImage GUICtrlListView_CreateSolidBitMap GUICtrlListView_DeleteAllItems GUICtrlListView_DeleteColumn GUICtrlListView_DeleteItem GUICtrlListView_DeleteItemsSelected GUICtrlListView_Destroy GUICtrlListView_DrawDragImage GUICtrlListView_EditLabel GUICtrlListView_EnableGroupView GUICtrlListView_EndUpdate GUICtrlListView_EnsureVisible GUICtrlListView_FindInText GUICtrlListView_FindItem GUICtrlListView_FindNearest GUICtrlListView_FindParam GUICtrlListView_FindText GUICtrlListView_GetBkColor GUICtrlListView_GetBkImage GUICtrlListView_GetCallbackMask GUICtrlListView_GetColumn GUICtrlListView_GetColumnCount GUICtrlListView_GetColumnOrder GUICtrlListView_GetColumnOrderArray GUICtrlListView_GetColumnWidth GUICtrlListView_GetCounterPage GUICtrlListView_GetEditControl GUICtrlListView_GetExtendedListViewStyle GUICtrlListView_GetFocusedGroup GUICtrlListView_GetGroupCount GUICtrlListView_GetGroupInfo GUICtrlListView_GetGroupInfoByIndex GUICtrlListView_GetGroupRect GUICtrlListView_GetGroupViewEnabled GUICtrlListView_GetHeader GUICtrlListView_GetHotCursor GUICtrlListView_GetHotItem GUICtrlListView_GetHoverTime GUICtrlListView_GetImageList GUICtrlListView_GetISearchString GUICtrlListView_GetItem GUICtrlListView_GetItemChecked GUICtrlListView_GetItemCount GUICtrlListView_GetItemCut GUICtrlListView_GetItemDropHilited GUICtrlListView_GetItemEx GUICtrlListView_GetItemFocused GUICtrlListView_GetItemGroupID GUICtrlListView_GetItemImage GUICtrlListView_GetItemIndent GUICtrlListView_GetItemParam GUICtrlListView_GetItemPosition GUICtrlListView_GetItemPositionX GUICtrlListView_GetItemPositionY GUICtrlListView_GetItemRect GUICtrlListView_GetItemRectEx GUICtrlListView_GetItemSelected GUICtrlListView_GetItemSpacing GUICtrlListView_GetItemSpacingX GUICtrlListView_GetItemSpacingY GUICtrlListView_GetItemState GUICtrlListView_GetItemStateImage GUICtrlListView_GetItemText GUICtrlListView_GetItemTextArray GUICtrlListView_GetItemTextString GUICtrlListView_GetNextItem GUICtrlListView_GetNumberOfWorkAreas GUICtrlListView_GetOrigin GUICtrlListView_GetOriginX GUICtrlListView_GetOriginY GUICtrlListView_GetOutlineColor GUICtrlListView_GetSelectedColumn GUICtrlListView_GetSelectedCount GUICtrlListView_GetSelectedIndices GUICtrlListView_GetSelectionMark GUICtrlListView_GetStringWidth GUICtrlListView_GetSubItemRect GUICtrlListView_GetTextBkColor GUICtrlListView_GetTextColor GUICtrlListView_GetToolTips GUICtrlListView_GetTopIndex GUICtrlListView_GetUnicodeFormat GUICtrlListView_GetView GUICtrlListView_GetViewDetails GUICtrlListView_GetViewLarge GUICtrlListView_GetViewList GUICtrlListView_GetViewRect GUICtrlListView_GetViewSmall GUICtrlListView_GetViewTile GUICtrlListView_HideColumn GUICtrlListView_HitTest GUICtrlListView_InsertColumn GUICtrlListView_InsertGroup GUICtrlListView_InsertItem GUICtrlListView_JustifyColumn GUICtrlListView_MapIDToIndex GUICtrlListView_MapIndexToID GUICtrlListView_RedrawItems GUICtrlListView_RegisterSortCallBack GUICtrlListView_RemoveAllGroups GUICtrlListView_RemoveGroup GUICtrlListView_Scroll GUICtrlListView_SetBkColor GUICtrlListView_SetBkImage GUICtrlListView_SetCallBackMask GUICtrlListView_SetColumn GUICtrlListView_SetColumnOrder GUICtrlListView_SetColumnOrderArray GUICtrlListView_SetColumnWidth GUICtrlListView_SetExtendedListViewStyle GUICtrlListView_SetGroupInfo GUICtrlListView_SetHotItem GUICtrlListView_SetHoverTime GUICtrlListView_SetIconSpacing GUICtrlListView_SetImageList GUICtrlListView_SetItem GUICtrlListView_SetItemChecked GUICtrlListView_SetItemCount GUICtrlListView_SetItemCut GUICtrlListView_SetItemDropHilited GUICtrlListView_SetItemEx GUICtrlListView_SetItemFocused GUICtrlListView_SetItemGroupID GUICtrlListView_SetItemImage GUICtrlListView_SetItemIndent GUICtrlListView_SetItemParam GUICtrlListView_SetItemPosition GUICtrlListView_SetItemPosition32 GUICtrlListView_SetItemSelected GUICtrlListView_SetItemState GUICtrlListView_SetItemStateImage GUICtrlListView_SetItemText GUICtrlListView_SetOutlineColor GUICtrlListView_SetSelectedColumn GUICtrlListView_SetSelectionMark GUICtrlListView_SetTextBkColor GUICtrlListView_SetTextColor GUICtrlListView_SetToolTips GUICtrlListView_SetUnicodeFormat GUICtrlListView_SetView GUICtrlListView_SetWorkAreas GUICtrlListView_SimpleSort GUICtrlListView_SortItems GUICtrlListView_SubItemHitTest GUICtrlListView_UnRegisterSortCallBack GUICtrlMenu_AddMenuItem GUICtrlMenu_AppendMenu GUICtrlMenu_CalculatePopupWindowPosition GUICtrlMenu_CheckMenuItem GUICtrlMenu_CheckRadioItem GUICtrlMenu_CreateMenu GUICtrlMenu_CreatePopup GUICtrlMenu_DeleteMenu GUICtrlMenu_DestroyMenu GUICtrlMenu_DrawMenuBar GUICtrlMenu_EnableMenuItem GUICtrlMenu_FindItem GUICtrlMenu_FindParent GUICtrlMenu_GetItemBmp GUICtrlMenu_GetItemBmpChecked GUICtrlMenu_GetItemBmpUnchecked GUICtrlMenu_GetItemChecked GUICtrlMenu_GetItemCount GUICtrlMenu_GetItemData GUICtrlMenu_GetItemDefault GUICtrlMenu_GetItemDisabled GUICtrlMenu_GetItemEnabled GUICtrlMenu_GetItemGrayed GUICtrlMenu_GetItemHighlighted GUICtrlMenu_GetItemID GUICtrlMenu_GetItemInfo GUICtrlMenu_GetItemRect GUICtrlMenu_GetItemRectEx GUICtrlMenu_GetItemState GUICtrlMenu_GetItemStateEx GUICtrlMenu_GetItemSubMenu GUICtrlMenu_GetItemText GUICtrlMenu_GetItemType GUICtrlMenu_GetMenu GUICtrlMenu_GetMenuBackground GUICtrlMenu_GetMenuBarInfo GUICtrlMenu_GetMenuContextHelpID GUICtrlMenu_GetMenuData GUICtrlMenu_GetMenuDefaultItem GUICtrlMenu_GetMenuHeight GUICtrlMenu_GetMenuInfo GUICtrlMenu_GetMenuStyle GUICtrlMenu_GetSystemMenu GUICtrlMenu_InsertMenuItem GUICtrlMenu_InsertMenuItemEx GUICtrlMenu_IsMenu GUICtrlMenu_LoadMenu GUICtrlMenu_MapAccelerator GUICtrlMenu_MenuItemFromPoint GUICtrlMenu_RemoveMenu GUICtrlMenu_SetItemBitmaps GUICtrlMenu_SetItemBmp GUICtrlMenu_SetItemBmpChecked GUICtrlMenu_SetItemBmpUnchecked GUICtrlMenu_SetItemChecked GUICtrlMenu_SetItemData GUICtrlMenu_SetItemDefault GUICtrlMenu_SetItemDisabled GUICtrlMenu_SetItemEnabled GUICtrlMenu_SetItemGrayed GUICtrlMenu_SetItemHighlighted GUICtrlMenu_SetItemID GUICtrlMenu_SetItemInfo GUICtrlMenu_SetItemState GUICtrlMenu_SetItemSubMenu GUICtrlMenu_SetItemText GUICtrlMenu_SetItemType GUICtrlMenu_SetMenu GUICtrlMenu_SetMenuBackground GUICtrlMenu_SetMenuContextHelpID GUICtrlMenu_SetMenuData GUICtrlMenu_SetMenuDefaultItem GUICtrlMenu_SetMenuHeight GUICtrlMenu_SetMenuInfo GUICtrlMenu_SetMenuStyle GUICtrlMenu_TrackPopupMenu GUICtrlMonthCal_Create GUICtrlMonthCal_Destroy GUICtrlMonthCal_GetCalendarBorder GUICtrlMonthCal_GetCalendarCount GUICtrlMonthCal_GetColor GUICtrlMonthCal_GetColorArray GUICtrlMonthCal_GetCurSel GUICtrlMonthCal_GetCurSelStr GUICtrlMonthCal_GetFirstDOW GUICtrlMonthCal_GetFirstDOWStr GUICtrlMonthCal_GetMaxSelCount GUICtrlMonthCal_GetMaxTodayWidth GUICtrlMonthCal_GetMinReqHeight GUICtrlMonthCal_GetMinReqRect GUICtrlMonthCal_GetMinReqRectArray GUICtrlMonthCal_GetMinReqWidth GUICtrlMonthCal_GetMonthDelta GUICtrlMonthCal_GetMonthRange GUICtrlMonthCal_GetMonthRangeMax GUICtrlMonthCal_GetMonthRangeMaxStr GUICtrlMonthCal_GetMonthRangeMin GUICtrlMonthCal_GetMonthRangeMinStr GUICtrlMonthCal_GetMonthRangeSpan GUICtrlMonthCal_GetRange GUICtrlMonthCal_GetRangeMax GUICtrlMonthCal_GetRangeMaxStr GUICtrlMonthCal_GetRangeMin GUICtrlMonthCal_GetRangeMinStr GUICtrlMonthCal_GetSelRange GUICtrlMonthCal_GetSelRangeMax GUICtrlMonthCal_GetSelRangeMaxStr GUICtrlMonthCal_GetSelRangeMin GUICtrlMonthCal_GetSelRangeMinStr GUICtrlMonthCal_GetToday GUICtrlMonthCal_GetTodayStr GUICtrlMonthCal_GetUnicodeFormat GUICtrlMonthCal_HitTest GUICtrlMonthCal_SetCalendarBorder GUICtrlMonthCal_SetColor GUICtrlMonthCal_SetCurSel GUICtrlMonthCal_SetDayState GUICtrlMonthCal_SetFirstDOW GUICtrlMonthCal_SetMaxSelCount GUICtrlMonthCal_SetMonthDelta GUICtrlMonthCal_SetRange GUICtrlMonthCal_SetSelRange GUICtrlMonthCal_SetToday GUICtrlMonthCal_SetUnicodeFormat GUICtrlRebar_AddBand GUICtrlRebar_AddToolBarBand GUICtrlRebar_BeginDrag GUICtrlRebar_Create GUICtrlRebar_DeleteBand GUICtrlRebar_Destroy GUICtrlRebar_DragMove GUICtrlRebar_EndDrag GUICtrlRebar_GetBandBackColor GUICtrlRebar_GetBandBorders GUICtrlRebar_GetBandBordersEx GUICtrlRebar_GetBandChildHandle GUICtrlRebar_GetBandChildSize GUICtrlRebar_GetBandCount GUICtrlRebar_GetBandForeColor GUICtrlRebar_GetBandHeaderSize GUICtrlRebar_GetBandID GUICtrlRebar_GetBandIdealSize GUICtrlRebar_GetBandLength GUICtrlRebar_GetBandLParam GUICtrlRebar_GetBandMargins GUICtrlRebar_GetBandMarginsEx GUICtrlRebar_GetBandRect GUICtrlRebar_GetBandRectEx GUICtrlRebar_GetBandStyle GUICtrlRebar_GetBandStyleBreak GUICtrlRebar_GetBandStyleChildEdge GUICtrlRebar_GetBandStyleFixedBMP GUICtrlRebar_GetBandStyleFixedSize GUICtrlRebar_GetBandStyleGripperAlways GUICtrlRebar_GetBandStyleHidden GUICtrlRebar_GetBandStyleHideTitle GUICtrlRebar_GetBandStyleNoGripper GUICtrlRebar_GetBandStyleTopAlign GUICtrlRebar_GetBandStyleUseChevron GUICtrlRebar_GetBandStyleVariableHeight GUICtrlRebar_GetBandText GUICtrlRebar_GetBarHeight GUICtrlRebar_GetBarInfo GUICtrlRebar_GetBKColor GUICtrlRebar_GetColorScheme GUICtrlRebar_GetRowCount GUICtrlRebar_GetRowHeight GUICtrlRebar_GetTextColor GUICtrlRebar_GetToolTips GUICtrlRebar_GetUnicodeFormat GUICtrlRebar_HitTest GUICtrlRebar_IDToIndex GUICtrlRebar_MaximizeBand GUICtrlRebar_MinimizeBand GUICtrlRebar_MoveBand GUICtrlRebar_SetBandBackColor GUICtrlRebar_SetBandForeColor GUICtrlRebar_SetBandHeaderSize GUICtrlRebar_SetBandID GUICtrlRebar_SetBandIdealSize GUICtrlRebar_SetBandLength GUICtrlRebar_SetBandLParam GUICtrlRebar_SetBandStyle GUICtrlRebar_SetBandStyleBreak GUICtrlRebar_SetBandStyleChildEdge GUICtrlRebar_SetBandStyleFixedBMP GUICtrlRebar_SetBandStyleFixedSize GUICtrlRebar_SetBandStyleGripperAlways GUICtrlRebar_SetBandStyleHidden GUICtrlRebar_SetBandStyleHideTitle GUICtrlRebar_SetBandStyleNoGripper GUICtrlRebar_SetBandStyleTopAlign GUICtrlRebar_SetBandStyleUseChevron GUICtrlRebar_SetBandStyleVariableHeight GUICtrlRebar_SetBandText GUICtrlRebar_SetBarInfo GUICtrlRebar_SetBKColor GUICtrlRebar_SetColorScheme GUICtrlRebar_SetTextColor GUICtrlRebar_SetToolTips GUICtrlRebar_SetUnicodeFormat GUICtrlRebar_ShowBand GUICtrlRichEdit_AppendText GUICtrlRichEdit_AutoDetectURL GUICtrlRichEdit_CanPaste GUICtrlRichEdit_CanPasteSpecial GUICtrlRichEdit_CanRedo GUICtrlRichEdit_CanUndo GUICtrlRichEdit_ChangeFontSize GUICtrlRichEdit_Copy GUICtrlRichEdit_Create GUICtrlRichEdit_Cut GUICtrlRichEdit_Deselect GUICtrlRichEdit_Destroy GUICtrlRichEdit_EmptyUndoBuffer GUICtrlRichEdit_FindText GUICtrlRichEdit_FindTextInRange GUICtrlRichEdit_GetBkColor GUICtrlRichEdit_GetCharAttributes GUICtrlRichEdit_GetCharBkColor GUICtrlRichEdit_GetCharColor GUICtrlRichEdit_GetCharPosFromXY GUICtrlRichEdit_GetCharPosOfNextWord GUICtrlRichEdit_GetCharPosOfPreviousWord GUICtrlRichEdit_GetCharWordBreakInfo GUICtrlRichEdit_GetFirstCharPosOnLine GUICtrlRichEdit_GetFont GUICtrlRichEdit_GetLineCount GUICtrlRichEdit_GetLineLength GUICtrlRichEdit_GetLineNumberFromCharPos GUICtrlRichEdit_GetNextRedo GUICtrlRichEdit_GetNextUndo GUICtrlRichEdit_GetNumberOfFirstVisibleLine GUICtrlRichEdit_GetParaAlignment GUICtrlRichEdit_GetParaAttributes GUICtrlRichEdit_GetParaBorder GUICtrlRichEdit_GetParaIndents GUICtrlRichEdit_GetParaNumbering GUICtrlRichEdit_GetParaShading GUICtrlRichEdit_GetParaSpacing GUICtrlRichEdit_GetParaTabStops GUICtrlRichEdit_GetPasswordChar GUICtrlRichEdit_GetRECT GUICtrlRichEdit_GetScrollPos GUICtrlRichEdit_GetSel GUICtrlRichEdit_GetSelAA GUICtrlRichEdit_GetSelText GUICtrlRichEdit_GetSpaceUnit GUICtrlRichEdit_GetText GUICtrlRichEdit_GetTextInLine GUICtrlRichEdit_GetTextInRange GUICtrlRichEdit_GetTextLength GUICtrlRichEdit_GetVersion GUICtrlRichEdit_GetXYFromCharPos GUICtrlRichEdit_GetZoom GUICtrlRichEdit_GotoCharPos GUICtrlRichEdit_HideSelection GUICtrlRichEdit_InsertText GUICtrlRichEdit_IsModified GUICtrlRichEdit_IsTextSelected GUICtrlRichEdit_Paste GUICtrlRichEdit_PasteSpecial GUICtrlRichEdit_PauseRedraw GUICtrlRichEdit_Redo GUICtrlRichEdit_ReplaceText GUICtrlRichEdit_ResumeRedraw GUICtrlRichEdit_ScrollLineOrPage GUICtrlRichEdit_ScrollLines GUICtrlRichEdit_ScrollToCaret GUICtrlRichEdit_SetBkColor GUICtrlRichEdit_SetCharAttributes GUICtrlRichEdit_SetCharBkColor GUICtrlRichEdit_SetCharColor GUICtrlRichEdit_SetEventMask GUICtrlRichEdit_SetFont GUICtrlRichEdit_SetLimitOnText GUICtrlRichEdit_SetModified GUICtrlRichEdit_SetParaAlignment GUICtrlRichEdit_SetParaAttributes GUICtrlRichEdit_SetParaBorder GUICtrlRichEdit_SetParaIndents GUICtrlRichEdit_SetParaNumbering GUICtrlRichEdit_SetParaShading GUICtrlRichEdit_SetParaSpacing GUICtrlRichEdit_SetParaTabStops GUICtrlRichEdit_SetPasswordChar GUICtrlRichEdit_SetReadOnly GUICtrlRichEdit_SetRECT GUICtrlRichEdit_SetScrollPos GUICtrlRichEdit_SetSel GUICtrlRichEdit_SetSpaceUnit GUICtrlRichEdit_SetTabStops GUICtrlRichEdit_SetText GUICtrlRichEdit_SetUndoLimit GUICtrlRichEdit_SetZoom GUICtrlRichEdit_StreamFromFile GUICtrlRichEdit_StreamFromVar GUICtrlRichEdit_StreamToFile GUICtrlRichEdit_StreamToVar GUICtrlRichEdit_Undo GUICtrlSlider_ClearSel GUICtrlSlider_ClearTics GUICtrlSlider_Create GUICtrlSlider_Destroy GUICtrlSlider_GetBuddy GUICtrlSlider_GetChannelRect GUICtrlSlider_GetChannelRectEx GUICtrlSlider_GetLineSize GUICtrlSlider_GetLogicalTics GUICtrlSlider_GetNumTics GUICtrlSlider_GetPageSize GUICtrlSlider_GetPos GUICtrlSlider_GetRange GUICtrlSlider_GetRangeMax GUICtrlSlider_GetRangeMin GUICtrlSlider_GetSel GUICtrlSlider_GetSelEnd GUICtrlSlider_GetSelStart GUICtrlSlider_GetThumbLength GUICtrlSlider_GetThumbRect GUICtrlSlider_GetThumbRectEx GUICtrlSlider_GetTic GUICtrlSlider_GetTicPos GUICtrlSlider_GetToolTips GUICtrlSlider_GetUnicodeFormat GUICtrlSlider_SetBuddy GUICtrlSlider_SetLineSize GUICtrlSlider_SetPageSize GUICtrlSlider_SetPos GUICtrlSlider_SetRange GUICtrlSlider_SetRangeMax GUICtrlSlider_SetRangeMin GUICtrlSlider_SetSel GUICtrlSlider_SetSelEnd GUICtrlSlider_SetSelStart GUICtrlSlider_SetThumbLength GUICtrlSlider_SetTic GUICtrlSlider_SetTicFreq GUICtrlSlider_SetTipSide GUICtrlSlider_SetToolTips GUICtrlSlider_SetUnicodeFormat GUICtrlStatusBar_Create GUICtrlStatusBar_Destroy GUICtrlStatusBar_EmbedControl GUICtrlStatusBar_GetBorders GUICtrlStatusBar_GetBordersHorz GUICtrlStatusBar_GetBordersRect GUICtrlStatusBar_GetBordersVert GUICtrlStatusBar_GetCount GUICtrlStatusBar_GetHeight GUICtrlStatusBar_GetIcon GUICtrlStatusBar_GetParts GUICtrlStatusBar_GetRect GUICtrlStatusBar_GetRectEx GUICtrlStatusBar_GetText GUICtrlStatusBar_GetTextFlags GUICtrlStatusBar_GetTextLength GUICtrlStatusBar_GetTextLengthEx GUICtrlStatusBar_GetTipText GUICtrlStatusBar_GetUnicodeFormat GUICtrlStatusBar_GetWidth GUICtrlStatusBar_IsSimple GUICtrlStatusBar_Resize GUICtrlStatusBar_SetBkColor GUICtrlStatusBar_SetIcon GUICtrlStatusBar_SetMinHeight GUICtrlStatusBar_SetParts GUICtrlStatusBar_SetSimple GUICtrlStatusBar_SetText GUICtrlStatusBar_SetTipText GUICtrlStatusBar_SetUnicodeFormat GUICtrlStatusBar_ShowHide GUICtrlTab_ActivateTab GUICtrlTab_ClickTab GUICtrlTab_Create GUICtrlTab_DeleteAllItems GUICtrlTab_DeleteItem GUICtrlTab_DeselectAll GUICtrlTab_Destroy GUICtrlTab_FindTab GUICtrlTab_GetCurFocus GUICtrlTab_GetCurSel GUICtrlTab_GetDisplayRect GUICtrlTab_GetDisplayRectEx GUICtrlTab_GetExtendedStyle GUICtrlTab_GetImageList GUICtrlTab_GetItem GUICtrlTab_GetItemCount GUICtrlTab_GetItemImage GUICtrlTab_GetItemParam GUICtrlTab_GetItemRect GUICtrlTab_GetItemRectEx GUICtrlTab_GetItemState GUICtrlTab_GetItemText GUICtrlTab_GetRowCount GUICtrlTab_GetToolTips GUICtrlTab_GetUnicodeFormat GUICtrlTab_HighlightItem GUICtrlTab_HitTest GUICtrlTab_InsertItem GUICtrlTab_RemoveImage GUICtrlTab_SetCurFocus GUICtrlTab_SetCurSel GUICtrlTab_SetExtendedStyle GUICtrlTab_SetImageList GUICtrlTab_SetItem GUICtrlTab_SetItemImage GUICtrlTab_SetItemParam GUICtrlTab_SetItemSize GUICtrlTab_SetItemState GUICtrlTab_SetItemText GUICtrlTab_SetMinTabWidth GUICtrlTab_SetPadding GUICtrlTab_SetToolTips GUICtrlTab_SetUnicodeFormat GUICtrlToolbar_AddBitmap GUICtrlToolbar_AddButton GUICtrlToolbar_AddButtonSep GUICtrlToolbar_AddString GUICtrlToolbar_ButtonCount GUICtrlToolbar_CheckButton GUICtrlToolbar_ClickAccel GUICtrlToolbar_ClickButton GUICtrlToolbar_ClickIndex GUICtrlToolbar_CommandToIndex GUICtrlToolbar_Create GUICtrlToolbar_Customize GUICtrlToolbar_DeleteButton GUICtrlToolbar_Destroy GUICtrlToolbar_EnableButton GUICtrlToolbar_FindToolbar GUICtrlToolbar_GetAnchorHighlight GUICtrlToolbar_GetBitmapFlags GUICtrlToolbar_GetButtonBitmap GUICtrlToolbar_GetButtonInfo GUICtrlToolbar_GetButtonInfoEx GUICtrlToolbar_GetButtonParam GUICtrlToolbar_GetButtonRect GUICtrlToolbar_GetButtonRectEx GUICtrlToolbar_GetButtonSize GUICtrlToolbar_GetButtonState GUICtrlToolbar_GetButtonStyle GUICtrlToolbar_GetButtonText GUICtrlToolbar_GetColorScheme GUICtrlToolbar_GetDisabledImageList GUICtrlToolbar_GetExtendedStyle GUICtrlToolbar_GetHotImageList GUICtrlToolbar_GetHotItem GUICtrlToolbar_GetImageList GUICtrlToolbar_GetInsertMark GUICtrlToolbar_GetInsertMarkColor GUICtrlToolbar_GetMaxSize GUICtrlToolbar_GetMetrics GUICtrlToolbar_GetPadding GUICtrlToolbar_GetRows GUICtrlToolbar_GetString GUICtrlToolbar_GetStyle GUICtrlToolbar_GetStyleAltDrag GUICtrlToolbar_GetStyleCustomErase GUICtrlToolbar_GetStyleFlat GUICtrlToolbar_GetStyleList GUICtrlToolbar_GetStyleRegisterDrop GUICtrlToolbar_GetStyleToolTips GUICtrlToolbar_GetStyleTransparent GUICtrlToolbar_GetStyleWrapable GUICtrlToolbar_GetTextRows GUICtrlToolbar_GetToolTips GUICtrlToolbar_GetUnicodeFormat GUICtrlToolbar_HideButton GUICtrlToolbar_HighlightButton GUICtrlToolbar_HitTest GUICtrlToolbar_IndexToCommand GUICtrlToolbar_InsertButton GUICtrlToolbar_InsertMarkHitTest GUICtrlToolbar_IsButtonChecked GUICtrlToolbar_IsButtonEnabled GUICtrlToolbar_IsButtonHidden GUICtrlToolbar_IsButtonHighlighted GUICtrlToolbar_IsButtonIndeterminate GUICtrlToolbar_IsButtonPressed GUICtrlToolbar_LoadBitmap GUICtrlToolbar_LoadImages GUICtrlToolbar_MapAccelerator GUICtrlToolbar_MoveButton GUICtrlToolbar_PressButton GUICtrlToolbar_SetAnchorHighlight GUICtrlToolbar_SetBitmapSize GUICtrlToolbar_SetButtonBitMap GUICtrlToolbar_SetButtonInfo GUICtrlToolbar_SetButtonInfoEx GUICtrlToolbar_SetButtonParam GUICtrlToolbar_SetButtonSize GUICtrlToolbar_SetButtonState GUICtrlToolbar_SetButtonStyle GUICtrlToolbar_SetButtonText GUICtrlToolbar_SetButtonWidth GUICtrlToolbar_SetCmdID GUICtrlToolbar_SetColorScheme GUICtrlToolbar_SetDisabledImageList GUICtrlToolbar_SetDrawTextFlags GUICtrlToolbar_SetExtendedStyle GUICtrlToolbar_SetHotImageList GUICtrlToolbar_SetHotItem GUICtrlToolbar_SetImageList GUICtrlToolbar_SetIndent GUICtrlToolbar_SetIndeterminate GUICtrlToolbar_SetInsertMark GUICtrlToolbar_SetInsertMarkColor GUICtrlToolbar_SetMaxTextRows GUICtrlToolbar_SetMetrics GUICtrlToolbar_SetPadding GUICtrlToolbar_SetParent GUICtrlToolbar_SetRows GUICtrlToolbar_SetStyle GUICtrlToolbar_SetStyleAltDrag GUICtrlToolbar_SetStyleCustomErase GUICtrlToolbar_SetStyleFlat GUICtrlToolbar_SetStyleList GUICtrlToolbar_SetStyleRegisterDrop GUICtrlToolbar_SetStyleToolTips GUICtrlToolbar_SetStyleTransparent GUICtrlToolbar_SetStyleWrapable GUICtrlToolbar_SetToolTips GUICtrlToolbar_SetUnicodeFormat GUICtrlToolbar_SetWindowTheme GUICtrlTreeView_Add GUICtrlTreeView_AddChild GUICtrlTreeView_AddChildFirst GUICtrlTreeView_AddFirst GUICtrlTreeView_BeginUpdate GUICtrlTreeView_ClickItem GUICtrlTreeView_Create GUICtrlTreeView_CreateDragImage GUICtrlTreeView_CreateSolidBitMap GUICtrlTreeView_Delete GUICtrlTreeView_DeleteAll GUICtrlTreeView_DeleteChildren GUICtrlTreeView_Destroy GUICtrlTreeView_DisplayRect GUICtrlTreeView_DisplayRectEx GUICtrlTreeView_EditText GUICtrlTreeView_EndEdit GUICtrlTreeView_EndUpdate GUICtrlTreeView_EnsureVisible GUICtrlTreeView_Expand GUICtrlTreeView_ExpandedOnce GUICtrlTreeView_FindItem GUICtrlTreeView_FindItemEx GUICtrlTreeView_GetBkColor GUICtrlTreeView_GetBold GUICtrlTreeView_GetChecked GUICtrlTreeView_GetChildCount GUICtrlTreeView_GetChildren GUICtrlTreeView_GetCount GUICtrlTreeView_GetCut GUICtrlTreeView_GetDropTarget GUICtrlTreeView_GetEditControl GUICtrlTreeView_GetExpanded GUICtrlTreeView_GetFirstChild GUICtrlTreeView_GetFirstItem GUICtrlTreeView_GetFirstVisible GUICtrlTreeView_GetFocused GUICtrlTreeView_GetHeight GUICtrlTreeView_GetImageIndex GUICtrlTreeView_GetImageListIconHandle GUICtrlTreeView_GetIndent GUICtrlTreeView_GetInsertMarkColor GUICtrlTreeView_GetISearchString GUICtrlTreeView_GetItemByIndex GUICtrlTreeView_GetItemHandle GUICtrlTreeView_GetItemParam GUICtrlTreeView_GetLastChild GUICtrlTreeView_GetLineColor GUICtrlTreeView_GetNext GUICtrlTreeView_GetNextChild GUICtrlTreeView_GetNextSibling GUICtrlTreeView_GetNextVisible GUICtrlTreeView_GetNormalImageList GUICtrlTreeView_GetParentHandle GUICtrlTreeView_GetParentParam GUICtrlTreeView_GetPrev GUICtrlTreeView_GetPrevChild GUICtrlTreeView_GetPrevSibling GUICtrlTreeView_GetPrevVisible GUICtrlTreeView_GetScrollTime GUICtrlTreeView_GetSelected GUICtrlTreeView_GetSelectedImageIndex GUICtrlTreeView_GetSelection GUICtrlTreeView_GetSiblingCount GUICtrlTreeView_GetState GUICtrlTreeView_GetStateImageIndex GUICtrlTreeView_GetStateImageList GUICtrlTreeView_GetText GUICtrlTreeView_GetTextColor GUICtrlTreeView_GetToolTips GUICtrlTreeView_GetTree GUICtrlTreeView_GetUnicodeFormat GUICtrlTreeView_GetVisible GUICtrlTreeView_GetVisibleCount GUICtrlTreeView_HitTest GUICtrlTreeView_HitTestEx GUICtrlTreeView_HitTestItem GUICtrlTreeView_Index GUICtrlTreeView_InsertItem GUICtrlTreeView_IsFirstItem GUICtrlTreeView_IsParent GUICtrlTreeView_Level GUICtrlTreeView_SelectItem GUICtrlTreeView_SelectItemByIndex GUICtrlTreeView_SetBkColor GUICtrlTreeView_SetBold GUICtrlTreeView_SetChecked GUICtrlTreeView_SetCheckedByIndex GUICtrlTreeView_SetChildren GUICtrlTreeView_SetCut GUICtrlTreeView_SetDropTarget GUICtrlTreeView_SetFocused GUICtrlTreeView_SetHeight GUICtrlTreeView_SetIcon GUICtrlTreeView_SetImageIndex GUICtrlTreeView_SetIndent GUICtrlTreeView_SetInsertMark GUICtrlTreeView_SetInsertMarkColor GUICtrlTreeView_SetItemHeight GUICtrlTreeView_SetItemParam GUICtrlTreeView_SetLineColor GUICtrlTreeView_SetNormalImageList GUICtrlTreeView_SetScrollTime GUICtrlTreeView_SetSelected GUICtrlTreeView_SetSelectedImageIndex GUICtrlTreeView_SetState GUICtrlTreeView_SetStateImageIndex GUICtrlTreeView_SetStateImageList GUICtrlTreeView_SetText GUICtrlTreeView_SetTextColor GUICtrlTreeView_SetToolTips GUICtrlTreeView_SetUnicodeFormat GUICtrlTreeView_Sort GUIImageList_Add GUIImageList_AddBitmap GUIImageList_AddIcon GUIImageList_AddMasked GUIImageList_BeginDrag GUIImageList_Copy GUIImageList_Create GUIImageList_Destroy GUIImageList_DestroyIcon GUIImageList_DragEnter GUIImageList_DragLeave GUIImageList_DragMove GUIImageList_Draw GUIImageList_DrawEx GUIImageList_Duplicate GUIImageList_EndDrag GUIImageList_GetBkColor GUIImageList_GetIcon GUIImageList_GetIconHeight GUIImageList_GetIconSize GUIImageList_GetIconSizeEx GUIImageList_GetIconWidth GUIImageList_GetImageCount GUIImageList_GetImageInfoEx GUIImageList_Remove GUIImageList_ReplaceIcon GUIImageList_SetBkColor GUIImageList_SetIconSize GUIImageList_SetImageCount GUIImageList_Swap GUIScrollBars_EnableScrollBar GUIScrollBars_GetScrollBarInfoEx GUIScrollBars_GetScrollBarRect GUIScrollBars_GetScrollBarRGState GUIScrollBars_GetScrollBarXYLineButton GUIScrollBars_GetScrollBarXYThumbBottom GUIScrollBars_GetScrollBarXYThumbTop GUIScrollBars_GetScrollInfo GUIScrollBars_GetScrollInfoEx GUIScrollBars_GetScrollInfoMax GUIScrollBars_GetScrollInfoMin GUIScrollBars_GetScrollInfoPage GUIScrollBars_GetScrollInfoPos GUIScrollBars_GetScrollInfoTrackPos GUIScrollBars_GetScrollPos GUIScrollBars_GetScrollRange GUIScrollBars_Init GUIScrollBars_ScrollWindow GUIScrollBars_SetScrollInfo GUIScrollBars_SetScrollInfoMax GUIScrollBars_SetScrollInfoMin GUIScrollBars_SetScrollInfoPage GUIScrollBars_SetScrollInfoPos GUIScrollBars_SetScrollRange GUIScrollBars_ShowScrollBar GUIToolTip_Activate GUIToolTip_AddTool GUIToolTip_AdjustRect GUIToolTip_BitsToTTF GUIToolTip_Create GUIToolTip_Deactivate GUIToolTip_DelTool GUIToolTip_Destroy GUIToolTip_EnumTools GUIToolTip_GetBubbleHeight GUIToolTip_GetBubbleSize GUIToolTip_GetBubbleWidth GUIToolTip_GetCurrentTool GUIToolTip_GetDelayTime GUIToolTip_GetMargin GUIToolTip_GetMarginEx GUIToolTip_GetMaxTipWidth GUIToolTip_GetText GUIToolTip_GetTipBkColor GUIToolTip_GetTipTextColor GUIToolTip_GetTitleBitMap GUIToolTip_GetTitleText GUIToolTip_GetToolCount GUIToolTip_GetToolInfo GUIToolTip_HitTest GUIToolTip_NewToolRect GUIToolTip_Pop GUIToolTip_PopUp GUIToolTip_SetDelayTime GUIToolTip_SetMargin GUIToolTip_SetMaxTipWidth GUIToolTip_SetTipBkColor GUIToolTip_SetTipTextColor GUIToolTip_SetTitle GUIToolTip_SetToolInfo GUIToolTip_SetWindowTheme GUIToolTip_ToolExists GUIToolTip_ToolToArray GUIToolTip_TrackActivate GUIToolTip_TrackPosition GUIToolTip_Update GUIToolTip_UpdateTipText HexToString IEAction IEAttach IEBodyReadHTML IEBodyReadText IEBodyWriteHTML IECreate IECreateEmbedded IEDocGetObj IEDocInsertHTML IEDocInsertText IEDocReadHTML IEDocWriteHTML IEErrorNotify IEFormElementCheckBoxSelect IEFormElementGetCollection IEFormElementGetObjByName IEFormElementGetValue IEFormElementOptionSelect IEFormElementRadioSelect IEFormElementSetValue IEFormGetCollection IEFormGetObjByName IEFormImageClick IEFormReset IEFormSubmit IEFrameGetCollection IEFrameGetObjByName IEGetObjById IEGetObjByName IEHeadInsertEventScript IEImgClick IEImgGetCollection IEIsFrameSet IELinkClickByIndex IELinkClickByText IELinkGetCollection IELoadWait IELoadWaitTimeout IENavigate IEPropertyGet IEPropertySet IEQuit IETableGetCollection IETableWriteToArray IETagNameAllGetCollection IETagNameGetCollection IE_Example IE_Introduction IE_VersionInfo INetExplorerCapable INetGetSource INetMail INetSmtpMail IsPressed MathCheckDiv Max MemGlobalAlloc MemGlobalFree MemGlobalLock MemGlobalSize MemGlobalUnlock MemMoveMemory MemVirtualAlloc MemVirtualAllocEx MemVirtualFree MemVirtualFreeEx Min MouseTrap NamedPipes_CallNamedPipe NamedPipes_ConnectNamedPipe NamedPipes_CreateNamedPipe NamedPipes_CreatePipe NamedPipes_DisconnectNamedPipe NamedPipes_GetNamedPipeHandleState NamedPipes_GetNamedPipeInfo NamedPipes_PeekNamedPipe NamedPipes_SetNamedPipeHandleState NamedPipes_TransactNamedPipe NamedPipes_WaitNamedPipe Net_Share_ConnectionEnum Net_Share_FileClose Net_Share_FileEnum Net_Share_FileGetInfo Net_Share_PermStr Net_Share_ResourceStr Net_Share_SessionDel Net_Share_SessionEnum Net_Share_SessionGetInfo Net_Share_ShareAdd Net_Share_ShareCheck Net_Share_ShareDel Net_Share_ShareEnum Net_Share_ShareGetInfo Net_Share_ShareSetInfo Net_Share_StatisticsGetSvr Net_Share_StatisticsGetWrk Now NowCalc NowCalcDate NowDate NowTime PathFull PathGetRelative PathMake PathSplit ProcessGetName ProcessGetPriority Radian ReplaceStringInFile RunDos ScreenCapture_Capture ScreenCapture_CaptureWnd ScreenCapture_SaveImage ScreenCapture_SetBMPFormat ScreenCapture_SetJPGQuality ScreenCapture_SetTIFColorDepth ScreenCapture_SetTIFCompression Security__AdjustTokenPrivileges Security__CreateProcessWithToken Security__DuplicateTokenEx Security__GetAccountSid Security__GetLengthSid Security__GetTokenInformation Security__ImpersonateSelf Security__IsValidSid Security__LookupAccountName Security__LookupAccountSid Security__LookupPrivilegeValue Security__OpenProcessToken Security__OpenThreadToken Security__OpenThreadTokenEx Security__SetPrivilege Security__SetTokenInformation Security__SidToStringSid Security__SidTypeStr Security__StringSidToSid SendMessage SendMessageA SetDate SetTime Singleton SoundClose SoundLength SoundOpen SoundPause SoundPlay SoundPos SoundResume SoundSeek SoundStatus SoundStop SQLite_Changes SQLite_Close SQLite_Display2DResult SQLite_Encode SQLite_ErrCode SQLite_ErrMsg SQLite_Escape SQLite_Exec SQLite_FastEncode SQLite_FastEscape SQLite_FetchData SQLite_FetchNames SQLite_GetTable SQLite_GetTable2d SQLite_LastInsertRowID SQLite_LibVersion SQLite_Open SQLite_Query SQLite_QueryFinalize SQLite_QueryReset SQLite_QuerySingleRow SQLite_SafeMode SQLite_SetTimeout SQLite_Shutdown SQLite_SQLiteExe SQLite_Startup SQLite_TotalChanges StringBetween StringExplode StringInsert StringProper StringRepeat StringTitleCase StringToHex TCPIpToName TempFile TicksToTime Timer_Diff Timer_GetIdleTime Timer_GetTimerID Timer_Init Timer_KillAllTimers Timer_KillTimer Timer_SetTimer TimeToTicks VersionCompare viClose viExecCommand viFindGpib viGpibBusReset viGTL viInteractiveControl viOpen viSetAttribute viSetTimeout WeekNumberISO WinAPI_AbortPath WinAPI_ActivateKeyboardLayout WinAPI_AddClipboardFormatListener WinAPI_AddFontMemResourceEx WinAPI_AddFontResourceEx WinAPI_AddIconOverlay WinAPI_AddIconTransparency WinAPI_AddMRUString WinAPI_AdjustBitmap WinAPI_AdjustTokenPrivileges WinAPI_AdjustWindowRectEx WinAPI_AlphaBlend WinAPI_AngleArc WinAPI_AnimateWindow WinAPI_Arc WinAPI_ArcTo WinAPI_ArrayToStruct WinAPI_AssignProcessToJobObject WinAPI_AssocGetPerceivedType WinAPI_AssocQueryString WinAPI_AttachConsole WinAPI_AttachThreadInput WinAPI_BackupRead WinAPI_BackupReadAbort WinAPI_BackupSeek WinAPI_BackupWrite WinAPI_BackupWriteAbort WinAPI_Beep WinAPI_BeginBufferedPaint WinAPI_BeginDeferWindowPos WinAPI_BeginPaint WinAPI_BeginPath WinAPI_BeginUpdateResource WinAPI_BitBlt WinAPI_BringWindowToTop WinAPI_BroadcastSystemMessage WinAPI_BrowseForFolderDlg WinAPI_BufferedPaintClear WinAPI_BufferedPaintInit WinAPI_BufferedPaintSetAlpha WinAPI_BufferedPaintUnInit WinAPI_CallNextHookEx WinAPI_CallWindowProc WinAPI_CallWindowProcW WinAPI_CascadeWindows WinAPI_ChangeWindowMessageFilterEx WinAPI_CharToOem WinAPI_ChildWindowFromPointEx WinAPI_ClientToScreen WinAPI_ClipCursor WinAPI_CloseDesktop WinAPI_CloseEnhMetaFile WinAPI_CloseFigure WinAPI_CloseHandle WinAPI_CloseThemeData WinAPI_CloseWindow WinAPI_CloseWindowStation WinAPI_CLSIDFromProgID WinAPI_CoInitialize WinAPI_ColorAdjustLuma WinAPI_ColorHLSToRGB WinAPI_ColorRGBToHLS WinAPI_CombineRgn WinAPI_CombineTransform WinAPI_CommandLineToArgv WinAPI_CommDlgExtendedError WinAPI_CommDlgExtendedErrorEx WinAPI_CompareString WinAPI_CompressBitmapBits WinAPI_CompressBuffer WinAPI_ComputeCrc32 WinAPI_ConfirmCredentials WinAPI_CopyBitmap WinAPI_CopyCursor WinAPI_CopyEnhMetaFile WinAPI_CopyFileEx WinAPI_CopyIcon WinAPI_CopyImage WinAPI_CopyRect WinAPI_CopyStruct WinAPI_CoTaskMemAlloc WinAPI_CoTaskMemFree WinAPI_CoTaskMemRealloc WinAPI_CoUninitialize WinAPI_Create32BitHBITMAP WinAPI_Create32BitHICON WinAPI_CreateANDBitmap WinAPI_CreateBitmap WinAPI_CreateBitmapIndirect WinAPI_CreateBrushIndirect WinAPI_CreateBuffer WinAPI_CreateBufferFromStruct WinAPI_CreateCaret WinAPI_CreateColorAdjustment WinAPI_CreateCompatibleBitmap WinAPI_CreateCompatibleBitmapEx WinAPI_CreateCompatibleDC WinAPI_CreateDesktop WinAPI_CreateDIB WinAPI_CreateDIBColorTable WinAPI_CreateDIBitmap WinAPI_CreateDIBSection WinAPI_CreateDirectory WinAPI_CreateDirectoryEx WinAPI_CreateEllipticRgn WinAPI_CreateEmptyIcon WinAPI_CreateEnhMetaFile WinAPI_CreateEvent WinAPI_CreateFile WinAPI_CreateFileEx WinAPI_CreateFileMapping WinAPI_CreateFont WinAPI_CreateFontEx WinAPI_CreateFontIndirect WinAPI_CreateGUID WinAPI_CreateHardLink WinAPI_CreateIcon WinAPI_CreateIconFromResourceEx WinAPI_CreateIconIndirect WinAPI_CreateJobObject WinAPI_CreateMargins WinAPI_CreateMRUList WinAPI_CreateMutex WinAPI_CreateNullRgn WinAPI_CreateNumberFormatInfo WinAPI_CreateObjectID WinAPI_CreatePen WinAPI_CreatePoint WinAPI_CreatePolygonRgn WinAPI_CreateProcess WinAPI_CreateProcessWithToken WinAPI_CreateRect WinAPI_CreateRectEx WinAPI_CreateRectRgn WinAPI_CreateRectRgnIndirect WinAPI_CreateRoundRectRgn WinAPI_CreateSemaphore WinAPI_CreateSize WinAPI_CreateSolidBitmap WinAPI_CreateSolidBrush WinAPI_CreateStreamOnHGlobal WinAPI_CreateString WinAPI_CreateSymbolicLink WinAPI_CreateTransform WinAPI_CreateWindowEx WinAPI_CreateWindowStation WinAPI_DecompressBuffer WinAPI_DecryptFile WinAPI_DeferWindowPos WinAPI_DefineDosDevice WinAPI_DefRawInputProc WinAPI_DefSubclassProc WinAPI_DefWindowProc WinAPI_DefWindowProcW WinAPI_DeleteDC WinAPI_DeleteEnhMetaFile WinAPI_DeleteFile WinAPI_DeleteObject WinAPI_DeleteObjectID WinAPI_DeleteVolumeMountPoint WinAPI_DeregisterShellHookWindow WinAPI_DestroyCaret WinAPI_DestroyCursor WinAPI_DestroyIcon WinAPI_DestroyWindow WinAPI_DeviceIoControl WinAPI_DisplayStruct WinAPI_DllGetVersion WinAPI_DllInstall WinAPI_DllUninstall WinAPI_DPtoLP WinAPI_DragAcceptFiles WinAPI_DragFinish WinAPI_DragQueryFileEx WinAPI_DragQueryPoint WinAPI_DrawAnimatedRects WinAPI_DrawBitmap WinAPI_DrawEdge WinAPI_DrawFocusRect WinAPI_DrawFrameControl WinAPI_DrawIcon WinAPI_DrawIconEx WinAPI_DrawLine WinAPI_DrawShadowText WinAPI_DrawText WinAPI_DrawThemeBackground WinAPI_DrawThemeEdge WinAPI_DrawThemeIcon WinAPI_DrawThemeParentBackground WinAPI_DrawThemeText WinAPI_DrawThemeTextEx WinAPI_DuplicateEncryptionInfoFile WinAPI_DuplicateHandle WinAPI_DuplicateTokenEx WinAPI_DwmDefWindowProc WinAPI_DwmEnableBlurBehindWindow WinAPI_DwmEnableComposition WinAPI_DwmExtendFrameIntoClientArea WinAPI_DwmGetColorizationColor WinAPI_DwmGetColorizationParameters WinAPI_DwmGetWindowAttribute WinAPI_DwmInvalidateIconicBitmaps WinAPI_DwmIsCompositionEnabled WinAPI_DwmQueryThumbnailSourceSize WinAPI_DwmRegisterThumbnail WinAPI_DwmSetColorizationParameters WinAPI_DwmSetIconicLivePreviewBitmap WinAPI_DwmSetIconicThumbnail WinAPI_DwmSetWindowAttribute WinAPI_DwmUnregisterThumbnail WinAPI_DwmUpdateThumbnailProperties WinAPI_DWordToFloat WinAPI_DWordToInt WinAPI_EjectMedia WinAPI_Ellipse WinAPI_EmptyWorkingSet WinAPI_EnableWindow WinAPI_EncryptFile WinAPI_EncryptionDisable WinAPI_EndBufferedPaint WinAPI_EndDeferWindowPos WinAPI_EndPaint WinAPI_EndPath WinAPI_EndUpdateResource WinAPI_EnumChildProcess WinAPI_EnumChildWindows WinAPI_EnumDesktops WinAPI_EnumDesktopWindows WinAPI_EnumDeviceDrivers WinAPI_EnumDisplayDevices WinAPI_EnumDisplayMonitors WinAPI_EnumDisplaySettings WinAPI_EnumDllProc WinAPI_EnumFiles WinAPI_EnumFileStreams WinAPI_EnumFontFamilies WinAPI_EnumHardLinks WinAPI_EnumMRUList WinAPI_EnumPageFiles WinAPI_EnumProcessHandles WinAPI_EnumProcessModules WinAPI_EnumProcessThreads WinAPI_EnumProcessWindows WinAPI_EnumRawInputDevices WinAPI_EnumResourceLanguages WinAPI_EnumResourceNames WinAPI_EnumResourceTypes WinAPI_EnumSystemGeoID WinAPI_EnumSystemLocales WinAPI_EnumUILanguages WinAPI_EnumWindows WinAPI_EnumWindowsPopup WinAPI_EnumWindowStations WinAPI_EnumWindowsTop WinAPI_EqualMemory WinAPI_EqualRect WinAPI_EqualRgn WinAPI_ExcludeClipRect WinAPI_ExpandEnvironmentStrings WinAPI_ExtCreatePen WinAPI_ExtCreateRegion WinAPI_ExtFloodFill WinAPI_ExtractIcon WinAPI_ExtractIconEx WinAPI_ExtSelectClipRgn WinAPI_FatalAppExit WinAPI_FatalExit WinAPI_FileEncryptionStatus WinAPI_FileExists WinAPI_FileIconInit WinAPI_FileInUse WinAPI_FillMemory WinAPI_FillPath WinAPI_FillRect WinAPI_FillRgn WinAPI_FindClose WinAPI_FindCloseChangeNotification WinAPI_FindExecutable WinAPI_FindFirstChangeNotification WinAPI_FindFirstFile WinAPI_FindFirstFileName WinAPI_FindFirstStream WinAPI_FindNextChangeNotification WinAPI_FindNextFile WinAPI_FindNextFileName WinAPI_FindNextStream WinAPI_FindResource WinAPI_FindResourceEx WinAPI_FindTextDlg WinAPI_FindWindow WinAPI_FlashWindow WinAPI_FlashWindowEx WinAPI_FlattenPath WinAPI_FloatToDWord WinAPI_FloatToInt WinAPI_FlushFileBuffers WinAPI_FlushFRBuffer WinAPI_FlushViewOfFile WinAPI_FormatDriveDlg WinAPI_FormatMessage WinAPI_FrameRect WinAPI_FrameRgn WinAPI_FreeLibrary WinAPI_FreeMemory WinAPI_FreeMRUList WinAPI_FreeResource WinAPI_GdiComment WinAPI_GetActiveWindow WinAPI_GetAllUsersProfileDirectory WinAPI_GetAncestor WinAPI_GetApplicationRestartSettings WinAPI_GetArcDirection WinAPI_GetAsyncKeyState WinAPI_GetBinaryType WinAPI_GetBitmapBits WinAPI_GetBitmapDimension WinAPI_GetBitmapDimensionEx WinAPI_GetBkColor WinAPI_GetBkMode WinAPI_GetBoundsRect WinAPI_GetBrushOrg WinAPI_GetBufferedPaintBits WinAPI_GetBufferedPaintDC WinAPI_GetBufferedPaintTargetDC WinAPI_GetBufferedPaintTargetRect WinAPI_GetBValue WinAPI_GetCaretBlinkTime WinAPI_GetCaretPos WinAPI_GetCDType WinAPI_GetClassInfoEx WinAPI_GetClassLongEx WinAPI_GetClassName WinAPI_GetClientHeight WinAPI_GetClientRect WinAPI_GetClientWidth WinAPI_GetClipboardSequenceNumber WinAPI_GetClipBox WinAPI_GetClipCursor WinAPI_GetClipRgn WinAPI_GetColorAdjustment WinAPI_GetCompressedFileSize WinAPI_GetCompression WinAPI_GetConnectedDlg WinAPI_GetCurrentDirectory WinAPI_GetCurrentHwProfile WinAPI_GetCurrentObject WinAPI_GetCurrentPosition WinAPI_GetCurrentProcess WinAPI_GetCurrentProcessExplicitAppUserModelID WinAPI_GetCurrentProcessID WinAPI_GetCurrentThemeName WinAPI_GetCurrentThread WinAPI_GetCurrentThreadId WinAPI_GetCursor WinAPI_GetCursorInfo WinAPI_GetDateFormat WinAPI_GetDC WinAPI_GetDCEx WinAPI_GetDefaultPrinter WinAPI_GetDefaultUserProfileDirectory WinAPI_GetDesktopWindow WinAPI_GetDeviceCaps WinAPI_GetDeviceDriverBaseName WinAPI_GetDeviceDriverFileName WinAPI_GetDeviceGammaRamp WinAPI_GetDIBColorTable WinAPI_GetDIBits WinAPI_GetDiskFreeSpaceEx WinAPI_GetDlgCtrlID WinAPI_GetDlgItem WinAPI_GetDllDirectory WinAPI_GetDriveBusType WinAPI_GetDriveGeometryEx WinAPI_GetDriveNumber WinAPI_GetDriveType WinAPI_GetDurationFormat WinAPI_GetEffectiveClientRect WinAPI_GetEnhMetaFile WinAPI_GetEnhMetaFileBits WinAPI_GetEnhMetaFileDescription WinAPI_GetEnhMetaFileDimension WinAPI_GetEnhMetaFileHeader WinAPI_GetErrorMessage WinAPI_GetErrorMode WinAPI_GetExitCodeProcess WinAPI_GetExtended WinAPI_GetFileAttributes WinAPI_GetFileID WinAPI_GetFileInformationByHandle WinAPI_GetFileInformationByHandleEx WinAPI_GetFilePointerEx WinAPI_GetFileSizeEx WinAPI_GetFileSizeOnDisk WinAPI_GetFileTitle WinAPI_GetFileType WinAPI_GetFileVersionInfo WinAPI_GetFinalPathNameByHandle WinAPI_GetFinalPathNameByHandleEx WinAPI_GetFocus WinAPI_GetFontMemoryResourceInfo WinAPI_GetFontName WinAPI_GetFontResourceInfo WinAPI_GetForegroundWindow WinAPI_GetFRBuffer WinAPI_GetFullPathName WinAPI_GetGeoInfo WinAPI_GetGlyphOutline WinAPI_GetGraphicsMode WinAPI_GetGuiResources WinAPI_GetGUIThreadInfo WinAPI_GetGValue WinAPI_GetHandleInformation WinAPI_GetHGlobalFromStream WinAPI_GetIconDimension WinAPI_GetIconInfo WinAPI_GetIconInfoEx WinAPI_GetIdleTime WinAPI_GetKeyboardLayout WinAPI_GetKeyboardLayoutList WinAPI_GetKeyboardState WinAPI_GetKeyboardType WinAPI_GetKeyNameText WinAPI_GetKeyState WinAPI_GetLastActivePopup WinAPI_GetLastError WinAPI_GetLastErrorMessage WinAPI_GetLayeredWindowAttributes WinAPI_GetLocaleInfo WinAPI_GetLogicalDrives WinAPI_GetMapMode WinAPI_GetMemorySize WinAPI_GetMessageExtraInfo WinAPI_GetModuleFileNameEx WinAPI_GetModuleHandle WinAPI_GetModuleHandleEx WinAPI_GetModuleInformation WinAPI_GetMonitorInfo WinAPI_GetMousePos WinAPI_GetMousePosX WinAPI_GetMousePosY WinAPI_GetMUILanguage WinAPI_GetNumberFormat WinAPI_GetObject WinAPI_GetObjectID WinAPI_GetObjectInfoByHandle WinAPI_GetObjectNameByHandle WinAPI_GetObjectType WinAPI_GetOpenFileName WinAPI_GetOutlineTextMetrics WinAPI_GetOverlappedResult WinAPI_GetParent WinAPI_GetParentProcess WinAPI_GetPerformanceInfo WinAPI_GetPEType WinAPI_GetPhysicallyInstalledSystemMemory WinAPI_GetPixel WinAPI_GetPolyFillMode WinAPI_GetPosFromRect WinAPI_GetPriorityClass WinAPI_GetProcAddress WinAPI_GetProcessAffinityMask WinAPI_GetProcessCommandLine WinAPI_GetProcessFileName WinAPI_GetProcessHandleCount WinAPI_GetProcessID WinAPI_GetProcessIoCounters WinAPI_GetProcessMemoryInfo WinAPI_GetProcessName WinAPI_GetProcessShutdownParameters WinAPI_GetProcessTimes WinAPI_GetProcessUser WinAPI_GetProcessWindowStation WinAPI_GetProcessWorkingDirectory WinAPI_GetProfilesDirectory WinAPI_GetPwrCapabilities WinAPI_GetRawInputBuffer WinAPI_GetRawInputBufferLength WinAPI_GetRawInputData WinAPI_GetRawInputDeviceInfo WinAPI_GetRegionData WinAPI_GetRegisteredRawInputDevices WinAPI_GetRegKeyNameByHandle WinAPI_GetRgnBox WinAPI_GetROP2 WinAPI_GetRValue WinAPI_GetSaveFileName WinAPI_GetShellWindow WinAPI_GetStartupInfo WinAPI_GetStdHandle WinAPI_GetStockObject WinAPI_GetStretchBltMode WinAPI_GetString WinAPI_GetSysColor WinAPI_GetSysColorBrush WinAPI_GetSystemDefaultLangID WinAPI_GetSystemDefaultLCID WinAPI_GetSystemDefaultUILanguage WinAPI_GetSystemDEPPolicy WinAPI_GetSystemInfo WinAPI_GetSystemMetrics WinAPI_GetSystemPowerStatus WinAPI_GetSystemTimes WinAPI_GetSystemWow64Directory WinAPI_GetTabbedTextExtent WinAPI_GetTempFileName WinAPI_GetTextAlign WinAPI_GetTextCharacterExtra WinAPI_GetTextColor WinAPI_GetTextExtentPoint32 WinAPI_GetTextFace WinAPI_GetTextMetrics WinAPI_GetThemeAppProperties WinAPI_GetThemeBackgroundContentRect WinAPI_GetThemeBackgroundExtent WinAPI_GetThemeBackgroundRegion WinAPI_GetThemeBitmap WinAPI_GetThemeBool WinAPI_GetThemeColor WinAPI_GetThemeDocumentationProperty WinAPI_GetThemeEnumValue WinAPI_GetThemeFilename WinAPI_GetThemeFont WinAPI_GetThemeInt WinAPI_GetThemeMargins WinAPI_GetThemeMetric WinAPI_GetThemePartSize WinAPI_GetThemePosition WinAPI_GetThemePropertyOrigin WinAPI_GetThemeRect WinAPI_GetThemeString WinAPI_GetThemeSysBool WinAPI_GetThemeSysColor WinAPI_GetThemeSysColorBrush WinAPI_GetThemeSysFont WinAPI_GetThemeSysInt WinAPI_GetThemeSysSize WinAPI_GetThemeSysString WinAPI_GetThemeTextExtent WinAPI_GetThemeTextMetrics WinAPI_GetThemeTransitionDuration WinAPI_GetThreadDesktop WinAPI_GetThreadErrorMode WinAPI_GetThreadLocale WinAPI_GetThreadUILanguage WinAPI_GetTickCount WinAPI_GetTickCount64 WinAPI_GetTimeFormat WinAPI_GetTopWindow WinAPI_GetUDFColorMode WinAPI_GetUpdateRect WinAPI_GetUpdateRgn WinAPI_GetUserDefaultLangID WinAPI_GetUserDefaultLCID WinAPI_GetUserDefaultUILanguage WinAPI_GetUserGeoID WinAPI_GetUserObjectInformation WinAPI_GetVersion WinAPI_GetVersionEx WinAPI_GetVolumeInformation WinAPI_GetVolumeInformationByHandle WinAPI_GetVolumeNameForVolumeMountPoint WinAPI_GetWindow WinAPI_GetWindowDC WinAPI_GetWindowDisplayAffinity WinAPI_GetWindowExt WinAPI_GetWindowFileName WinAPI_GetWindowHeight WinAPI_GetWindowInfo WinAPI_GetWindowLong WinAPI_GetWindowOrg WinAPI_GetWindowPlacement WinAPI_GetWindowRect WinAPI_GetWindowRgn WinAPI_GetWindowRgnBox WinAPI_GetWindowSubclass WinAPI_GetWindowText WinAPI_GetWindowTheme WinAPI_GetWindowThreadProcessId WinAPI_GetWindowWidth WinAPI_GetWorkArea WinAPI_GetWorldTransform WinAPI_GetXYFromPoint WinAPI_GlobalMemoryStatus WinAPI_GradientFill WinAPI_GUIDFromString WinAPI_GUIDFromStringEx WinAPI_HashData WinAPI_HashString WinAPI_HiByte WinAPI_HideCaret WinAPI_HiDWord WinAPI_HiWord WinAPI_InflateRect WinAPI_InitMUILanguage WinAPI_InProcess WinAPI_IntersectClipRect WinAPI_IntersectRect WinAPI_IntToDWord WinAPI_IntToFloat WinAPI_InvalidateRect WinAPI_InvalidateRgn WinAPI_InvertANDBitmap WinAPI_InvertColor WinAPI_InvertRect WinAPI_InvertRgn WinAPI_IOCTL WinAPI_IsAlphaBitmap WinAPI_IsBadCodePtr WinAPI_IsBadReadPtr WinAPI_IsBadStringPtr WinAPI_IsBadWritePtr WinAPI_IsChild WinAPI_IsClassName WinAPI_IsDoorOpen WinAPI_IsElevated WinAPI_IsHungAppWindow WinAPI_IsIconic WinAPI_IsInternetConnected WinAPI_IsLoadKBLayout WinAPI_IsMemory WinAPI_IsNameInExpression WinAPI_IsNetworkAlive WinAPI_IsPathShared WinAPI_IsProcessInJob WinAPI_IsProcessorFeaturePresent WinAPI_IsRectEmpty WinAPI_IsThemeActive WinAPI_IsThemeBackgroundPartiallyTransparent WinAPI_IsThemePartDefined WinAPI_IsValidLocale WinAPI_IsWindow WinAPI_IsWindowEnabled WinAPI_IsWindowUnicode WinAPI_IsWindowVisible WinAPI_IsWow64Process WinAPI_IsWritable WinAPI_IsZoomed WinAPI_Keybd_Event WinAPI_KillTimer WinAPI_LineDDA WinAPI_LineTo WinAPI_LoadBitmap WinAPI_LoadCursor WinAPI_LoadCursorFromFile WinAPI_LoadIcon WinAPI_LoadIconMetric WinAPI_LoadIconWithScaleDown WinAPI_LoadImage WinAPI_LoadIndirectString WinAPI_LoadKeyboardLayout WinAPI_LoadLibrary WinAPI_LoadLibraryEx WinAPI_LoadMedia WinAPI_LoadResource WinAPI_LoadShell32Icon WinAPI_LoadString WinAPI_LoadStringEx WinAPI_LoByte WinAPI_LocalFree WinAPI_LockDevice WinAPI_LockFile WinAPI_LockResource WinAPI_LockWindowUpdate WinAPI_LockWorkStation WinAPI_LoDWord WinAPI_LongMid WinAPI_LookupIconIdFromDirectoryEx WinAPI_LoWord WinAPI_LPtoDP WinAPI_MAKELANGID WinAPI_MAKELCID WinAPI_MakeLong WinAPI_MakeQWord WinAPI_MakeWord WinAPI_MapViewOfFile WinAPI_MapVirtualKey WinAPI_MaskBlt WinAPI_MessageBeep WinAPI_MessageBoxCheck WinAPI_MessageBoxIndirect WinAPI_MirrorIcon WinAPI_ModifyWorldTransform WinAPI_MonitorFromPoint WinAPI_MonitorFromRect WinAPI_MonitorFromWindow WinAPI_Mouse_Event WinAPI_MoveFileEx WinAPI_MoveMemory WinAPI_MoveTo WinAPI_MoveToEx WinAPI_MoveWindow WinAPI_MsgBox WinAPI_MulDiv WinAPI_MultiByteToWideChar WinAPI_MultiByteToWideCharEx WinAPI_NtStatusToDosError WinAPI_OemToChar WinAPI_OffsetClipRgn WinAPI_OffsetPoints WinAPI_OffsetRect WinAPI_OffsetRgn WinAPI_OffsetWindowOrg WinAPI_OpenDesktop WinAPI_OpenFileById WinAPI_OpenFileDlg WinAPI_OpenFileMapping WinAPI_OpenIcon WinAPI_OpenInputDesktop WinAPI_OpenJobObject WinAPI_OpenMutex WinAPI_OpenProcess WinAPI_OpenProcessToken WinAPI_OpenSemaphore WinAPI_OpenThemeData WinAPI_OpenWindowStation WinAPI_PageSetupDlg WinAPI_PaintDesktop WinAPI_PaintRgn WinAPI_ParseURL WinAPI_ParseUserName WinAPI_PatBlt WinAPI_PathAddBackslash WinAPI_PathAddExtension WinAPI_PathAppend WinAPI_PathBuildRoot WinAPI_PathCanonicalize WinAPI_PathCommonPrefix WinAPI_PathCompactPath WinAPI_PathCompactPathEx WinAPI_PathCreateFromUrl WinAPI_PathFindExtension WinAPI_PathFindFileName WinAPI_PathFindNextComponent WinAPI_PathFindOnPath WinAPI_PathGetArgs WinAPI_PathGetCharType WinAPI_PathGetDriveNumber WinAPI_PathIsContentType WinAPI_PathIsDirectory WinAPI_PathIsDirectoryEmpty WinAPI_PathIsExe WinAPI_PathIsFileSpec WinAPI_PathIsLFNFileSpec WinAPI_PathIsRelative WinAPI_PathIsRoot WinAPI_PathIsSameRoot WinAPI_PathIsSystemFolder WinAPI_PathIsUNC WinAPI_PathIsUNCServer WinAPI_PathIsUNCServerShare WinAPI_PathMakeSystemFolder WinAPI_PathMatchSpec WinAPI_PathParseIconLocation WinAPI_PathRelativePathTo WinAPI_PathRemoveArgs WinAPI_PathRemoveBackslash WinAPI_PathRemoveExtension WinAPI_PathRemoveFileSpec WinAPI_PathRenameExtension WinAPI_PathSearchAndQualify WinAPI_PathSkipRoot WinAPI_PathStripPath WinAPI_PathStripToRoot WinAPI_PathToRegion WinAPI_PathUndecorate WinAPI_PathUnExpandEnvStrings WinAPI_PathUnmakeSystemFolder WinAPI_PathUnquoteSpaces WinAPI_PathYetAnotherMakeUniqueName WinAPI_PickIconDlg WinAPI_PlayEnhMetaFile WinAPI_PlaySound WinAPI_PlgBlt WinAPI_PointFromRect WinAPI_PolyBezier WinAPI_PolyBezierTo WinAPI_PolyDraw WinAPI_Polygon WinAPI_PostMessage WinAPI_PrimaryLangId WinAPI_PrintDlg WinAPI_PrintDlgEx WinAPI_PrintWindow WinAPI_ProgIDFromCLSID WinAPI_PtInRect WinAPI_PtInRectEx WinAPI_PtInRegion WinAPI_PtVisible WinAPI_QueryDosDevice WinAPI_QueryInformationJobObject WinAPI_QueryPerformanceCounter WinAPI_QueryPerformanceFrequency WinAPI_RadialGradientFill WinAPI_ReadDirectoryChanges WinAPI_ReadFile WinAPI_ReadProcessMemory WinAPI_Rectangle WinAPI_RectInRegion WinAPI_RectIsEmpty WinAPI_RectVisible WinAPI_RedrawWindow WinAPI_RegCloseKey WinAPI_RegConnectRegistry WinAPI_RegCopyTree WinAPI_RegCopyTreeEx WinAPI_RegCreateKey WinAPI_RegDeleteEmptyKey WinAPI_RegDeleteKey WinAPI_RegDeleteKeyValue WinAPI_RegDeleteTree WinAPI_RegDeleteTreeEx WinAPI_RegDeleteValue WinAPI_RegDisableReflectionKey WinAPI_RegDuplicateHKey WinAPI_RegEnableReflectionKey WinAPI_RegEnumKey WinAPI_RegEnumValue WinAPI_RegFlushKey WinAPI_RegisterApplicationRestart WinAPI_RegisterClass WinAPI_RegisterClassEx WinAPI_RegisterHotKey WinAPI_RegisterPowerSettingNotification WinAPI_RegisterRawInputDevices WinAPI_RegisterShellHookWindow WinAPI_RegisterWindowMessage WinAPI_RegLoadMUIString WinAPI_RegNotifyChangeKeyValue WinAPI_RegOpenKey WinAPI_RegQueryInfoKey WinAPI_RegQueryLastWriteTime WinAPI_RegQueryMultipleValues WinAPI_RegQueryReflectionKey WinAPI_RegQueryValue WinAPI_RegRestoreKey WinAPI_RegSaveKey WinAPI_RegSetValue WinAPI_ReleaseCapture WinAPI_ReleaseDC WinAPI_ReleaseMutex WinAPI_ReleaseSemaphore WinAPI_ReleaseStream WinAPI_RemoveClipboardFormatListener WinAPI_RemoveDirectory WinAPI_RemoveFontMemResourceEx WinAPI_RemoveFontResourceEx WinAPI_RemoveWindowSubclass WinAPI_ReOpenFile WinAPI_ReplaceFile WinAPI_ReplaceTextDlg WinAPI_ResetEvent WinAPI_RestartDlg WinAPI_RestoreDC WinAPI_RGB WinAPI_RotatePoints WinAPI_RoundRect WinAPI_SaveDC WinAPI_SaveFileDlg WinAPI_SaveHBITMAPToFile WinAPI_SaveHICONToFile WinAPI_ScaleWindowExt WinAPI_ScreenToClient WinAPI_SearchPath WinAPI_SelectClipPath WinAPI_SelectClipRgn WinAPI_SelectObject WinAPI_SendMessageTimeout WinAPI_SetActiveWindow WinAPI_SetArcDirection WinAPI_SetBitmapBits WinAPI_SetBitmapDimensionEx WinAPI_SetBkColor WinAPI_SetBkMode WinAPI_SetBoundsRect WinAPI_SetBrushOrg WinAPI_SetCapture WinAPI_SetCaretBlinkTime WinAPI_SetCaretPos WinAPI_SetClassLongEx WinAPI_SetColorAdjustment WinAPI_SetCompression WinAPI_SetCurrentDirectory WinAPI_SetCurrentProcessExplicitAppUserModelID WinAPI_SetCursor WinAPI_SetDCBrushColor WinAPI_SetDCPenColor WinAPI_SetDefaultPrinter WinAPI_SetDeviceGammaRamp WinAPI_SetDIBColorTable WinAPI_SetDIBits WinAPI_SetDIBitsToDevice WinAPI_SetDllDirectory WinAPI_SetEndOfFile WinAPI_SetEnhMetaFileBits WinAPI_SetErrorMode WinAPI_SetEvent WinAPI_SetFileAttributes WinAPI_SetFileInformationByHandleEx WinAPI_SetFilePointer WinAPI_SetFilePointerEx WinAPI_SetFileShortName WinAPI_SetFileValidData WinAPI_SetFocus WinAPI_SetFont WinAPI_SetForegroundWindow WinAPI_SetFRBuffer WinAPI_SetGraphicsMode WinAPI_SetHandleInformation WinAPI_SetInformationJobObject WinAPI_SetKeyboardLayout WinAPI_SetKeyboardState WinAPI_SetLastError WinAPI_SetLayeredWindowAttributes WinAPI_SetLocaleInfo WinAPI_SetMapMode WinAPI_SetMessageExtraInfo WinAPI_SetParent WinAPI_SetPixel WinAPI_SetPolyFillMode WinAPI_SetPriorityClass WinAPI_SetProcessAffinityMask WinAPI_SetProcessShutdownParameters WinAPI_SetProcessWindowStation WinAPI_SetRectRgn WinAPI_SetROP2 WinAPI_SetSearchPathMode WinAPI_SetStretchBltMode WinAPI_SetSysColors WinAPI_SetSystemCursor WinAPI_SetTextAlign WinAPI_SetTextCharacterExtra WinAPI_SetTextColor WinAPI_SetTextJustification WinAPI_SetThemeAppProperties WinAPI_SetThreadDesktop WinAPI_SetThreadErrorMode WinAPI_SetThreadExecutionState WinAPI_SetThreadLocale WinAPI_SetThreadUILanguage WinAPI_SetTimer WinAPI_SetUDFColorMode WinAPI_SetUserGeoID WinAPI_SetUserObjectInformation WinAPI_SetVolumeMountPoint WinAPI_SetWindowDisplayAffinity WinAPI_SetWindowExt WinAPI_SetWindowLong WinAPI_SetWindowOrg WinAPI_SetWindowPlacement WinAPI_SetWindowPos WinAPI_SetWindowRgn WinAPI_SetWindowsHookEx WinAPI_SetWindowSubclass WinAPI_SetWindowText WinAPI_SetWindowTheme WinAPI_SetWinEventHook WinAPI_SetWorldTransform WinAPI_SfcIsFileProtected WinAPI_SfcIsKeyProtected WinAPI_ShellAboutDlg WinAPI_ShellAddToRecentDocs WinAPI_ShellChangeNotify WinAPI_ShellChangeNotifyDeregister WinAPI_ShellChangeNotifyRegister WinAPI_ShellCreateDirectory WinAPI_ShellEmptyRecycleBin WinAPI_ShellExecute WinAPI_ShellExecuteEx WinAPI_ShellExtractAssociatedIcon WinAPI_ShellExtractIcon WinAPI_ShellFileOperation WinAPI_ShellFlushSFCache WinAPI_ShellGetFileInfo WinAPI_ShellGetIconOverlayIndex WinAPI_ShellGetImageList WinAPI_ShellGetKnownFolderIDList WinAPI_ShellGetKnownFolderPath WinAPI_ShellGetLocalizedName WinAPI_ShellGetPathFromIDList WinAPI_ShellGetSetFolderCustomSettings WinAPI_ShellGetSettings WinAPI_ShellGetSpecialFolderLocation WinAPI_ShellGetSpecialFolderPath WinAPI_ShellGetStockIconInfo WinAPI_ShellILCreateFromPath WinAPI_ShellNotifyIcon WinAPI_ShellNotifyIconGetRect WinAPI_ShellObjectProperties WinAPI_ShellOpenFolderAndSelectItems WinAPI_ShellOpenWithDlg WinAPI_ShellQueryRecycleBin WinAPI_ShellQueryUserNotificationState WinAPI_ShellRemoveLocalizedName WinAPI_ShellRestricted WinAPI_ShellSetKnownFolderPath WinAPI_ShellSetLocalizedName WinAPI_ShellSetSettings WinAPI_ShellStartNetConnectionDlg WinAPI_ShellUpdateImage WinAPI_ShellUserAuthenticationDlg WinAPI_ShellUserAuthenticationDlgEx WinAPI_ShortToWord WinAPI_ShowCaret WinAPI_ShowCursor WinAPI_ShowError WinAPI_ShowLastError WinAPI_ShowMsg WinAPI_ShowOwnedPopups WinAPI_ShowWindow WinAPI_ShutdownBlockReasonCreate WinAPI_ShutdownBlockReasonDestroy WinAPI_ShutdownBlockReasonQuery WinAPI_SizeOfResource WinAPI_StretchBlt WinAPI_StretchDIBits WinAPI_StrFormatByteSize WinAPI_StrFormatByteSizeEx WinAPI_StrFormatKBSize WinAPI_StrFromTimeInterval WinAPI_StringFromGUID WinAPI_StringLenA WinAPI_StringLenW WinAPI_StrLen WinAPI_StrokeAndFillPath WinAPI_StrokePath WinAPI_StructToArray WinAPI_SubLangId WinAPI_SubtractRect WinAPI_SwapDWord WinAPI_SwapQWord WinAPI_SwapWord WinAPI_SwitchColor WinAPI_SwitchDesktop WinAPI_SwitchToThisWindow WinAPI_SystemParametersInfo WinAPI_TabbedTextOut WinAPI_TerminateJobObject WinAPI_TerminateProcess WinAPI_TextOut WinAPI_TileWindows WinAPI_TrackMouseEvent WinAPI_TransparentBlt WinAPI_TwipsPerPixelX WinAPI_TwipsPerPixelY WinAPI_UnhookWindowsHookEx WinAPI_UnhookWinEvent WinAPI_UnionRect WinAPI_UnionStruct WinAPI_UniqueHardwareID WinAPI_UnloadKeyboardLayout WinAPI_UnlockFile WinAPI_UnmapViewOfFile WinAPI_UnregisterApplicationRestart WinAPI_UnregisterClass WinAPI_UnregisterHotKey WinAPI_UnregisterPowerSettingNotification WinAPI_UpdateLayeredWindow WinAPI_UpdateLayeredWindowEx WinAPI_UpdateLayeredWindowIndirect WinAPI_UpdateResource WinAPI_UpdateWindow WinAPI_UrlApplyScheme WinAPI_UrlCanonicalize WinAPI_UrlCombine WinAPI_UrlCompare WinAPI_UrlCreateFromPath WinAPI_UrlFixup WinAPI_UrlGetPart WinAPI_UrlHash WinAPI_UrlIs WinAPI_UserHandleGrantAccess WinAPI_ValidateRect WinAPI_ValidateRgn WinAPI_VerQueryRoot WinAPI_VerQueryValue WinAPI_VerQueryValueEx WinAPI_WaitForInputIdle WinAPI_WaitForMultipleObjects WinAPI_WaitForSingleObject WinAPI_WideCharToMultiByte WinAPI_WidenPath WinAPI_WindowFromDC WinAPI_WindowFromPoint WinAPI_WordToShort WinAPI_Wow64EnableWow64FsRedirection WinAPI_WriteConsole WinAPI_WriteFile WinAPI_WriteProcessMemory WinAPI_ZeroMemory WinNet_AddConnection WinNet_AddConnection2 WinNet_AddConnection3 WinNet_CancelConnection WinNet_CancelConnection2 WinNet_CloseEnum WinNet_ConnectionDialog WinNet_ConnectionDialog1 WinNet_DisconnectDialog WinNet_DisconnectDialog1 WinNet_EnumResource WinNet_GetConnection WinNet_GetConnectionPerformance WinNet_GetLastError WinNet_GetNetworkInformation WinNet_GetProviderName WinNet_GetResourceInformation WinNet_GetResourceParent WinNet_GetUniversalName WinNet_GetUser WinNet_OpenEnum WinNet_RestoreConnection WinNet_UseConnection Word_Create Word_DocAdd Word_DocAttach Word_DocClose Word_DocExport Word_DocFind Word_DocFindReplace Word_DocGet Word_DocLinkAdd Word_DocLinkGet Word_DocOpen Word_DocPictureAdd Word_DocPrint Word_DocRangeSet Word_DocSave Word_DocSaveAs Word_DocTableRead Word_DocTableWrite Word_Quit",COMMENT={
variants:[hljs.COMMENT(";","$",{relevance:0}),hljs.COMMENT("#cs","#ce"),hljs.COMMENT("#comments-start","#comments-end")]},VARIABLE={className:"variable",begin:"\\$[A-z0-9_]+"},STRING={className:"string",variants:[{begin:/"/,end:/"/,contains:[{begin:/""/,relevance:0}]},{begin:/'/,end:/'/,contains:[{begin:/''/,relevance:0}]}]},NUMBER={variants:[hljs.BINARY_NUMBER_MODE,hljs.C_NUMBER_MODE]},PREPROCESSOR={className:"preprocessor",begin:"#",end:"$",keywords:"include include-once NoTrayIcon OnAutoItStartRegister RequireAdmin pragma Au3Stripper_Ignore_Funcs Au3Stripper_Ignore_Variables Au3Stripper_Off Au3Stripper_On Au3Stripper_Parameters AutoIt3Wrapper_Add_Constants AutoIt3Wrapper_Au3Check_Parameters AutoIt3Wrapper_Au3Check_Stop_OnWarning AutoIt3Wrapper_Aut2Exe AutoIt3Wrapper_AutoIt3 AutoIt3Wrapper_AutoIt3Dir AutoIt3Wrapper_Change2CUI AutoIt3Wrapper_Compile_Both AutoIt3Wrapper_Compression AutoIt3Wrapper_EndIf AutoIt3Wrapper_Icon AutoIt3Wrapper_If_Compile AutoIt3Wrapper_If_Run AutoIt3Wrapper_Jump_To_First_Error AutoIt3Wrapper_OutFile AutoIt3Wrapper_OutFile_Type AutoIt3Wrapper_OutFile_X64 AutoIt3Wrapper_PlugIn_Funcs AutoIt3Wrapper_Res_Comment Autoit3Wrapper_Res_Compatibility AutoIt3Wrapper_Res_Description AutoIt3Wrapper_Res_Field AutoIt3Wrapper_Res_File_Add AutoIt3Wrapper_Res_FileVersion AutoIt3Wrapper_Res_FileVersion_AutoIncrement AutoIt3Wrapper_Res_Icon_Add AutoIt3Wrapper_Res_Language AutoIt3Wrapper_Res_LegalCopyright AutoIt3Wrapper_Res_ProductVersion AutoIt3Wrapper_Res_requestedExecutionLevel AutoIt3Wrapper_Res_SaveSource AutoIt3Wrapper_Run_After AutoIt3Wrapper_Run_Au3Check AutoIt3Wrapper_Run_Au3Stripper AutoIt3Wrapper_Run_Before AutoIt3Wrapper_Run_Debug_Mode AutoIt3Wrapper_Run_SciTE_Minimized AutoIt3Wrapper_Run_SciTE_OutputPane_Minimized AutoIt3Wrapper_Run_Tidy AutoIt3Wrapper_ShowProgress AutoIt3Wrapper_Testing AutoIt3Wrapper_Tidy_Stop_OnError AutoIt3Wrapper_UPX_Parameters AutoIt3Wrapper_UseUPX AutoIt3Wrapper_UseX64 AutoIt3Wrapper_Version AutoIt3Wrapper_Versioning AutoIt3Wrapper_Versioning_Parameters Tidy_Off Tidy_On Tidy_Parameters EndRegion Region",contains:[{begin:/\\\n/,relevance:0},{beginKeywords:"include",end:"$",contains:[STRING,{className:"string",variants:[{begin:"<",end:">"},{begin:/"/,end:/"/,contains:[{begin:/""/,relevance:0}]},{begin:/'/,end:/'/,contains:[{begin:/''/,relevance:0}]}]}]},STRING,COMMENT]},CONSTANT={className:"constant",begin:"@[A-z0-9_]+"},FUNCTION={className:"function",beginKeywords:"Func",end:"$",excludeEnd:!0,illegal:"\\$|\\[|%",contains:[hljs.UNDERSCORE_TITLE_MODE,{className:"params",begin:"\\(",end:"\\)",contains:[VARIABLE,STRING,NUMBER]}]};return{case_insensitive:!0,illegal:/\/\*/,keywords:{keyword:KEYWORDS,built_in:BUILT_IN,literal:LITERAL},contains:[COMMENT,VARIABLE,STRING,NUMBER,PREPROCESSOR,CONSTANT,FUNCTION]}}),hljs.registerLanguage("avrasm",function(hljs){return{case_insensitive:!0,lexemes:"\\.?"+hljs.IDENT_RE,keywords:{keyword:"adc add adiw and andi asr bclr bld brbc brbs brcc brcs break breq brge brhc brhs brid brie brlo brlt brmi brne brpl brsh brtc brts brvc brvs bset bst call cbi cbr clc clh cli cln clr cls clt clv clz com cp cpc cpi cpse dec eicall eijmp elpm eor fmul fmuls fmulsu icall ijmp in inc jmp ld ldd ldi lds lpm lsl lsr mov movw mul muls mulsu neg nop or ori out pop push rcall ret reti rjmp rol ror sbc sbr sbrc sbrs sec seh sbi sbci sbic sbis sbiw sei sen ser ses set sev sez sleep spm st std sts sub subi swap tst wdr",built_in:"r0 r1 r2 r3 r4 r5 r6 r7 r8 r9 r10 r11 r12 r13 r14 r15 r16 r17 r18 r19 r20 r21 r22 r23 r24 r25 r26 r27 r28 r29 r30 r31 x|0 xh xl y|0 yh yl z|0 zh zl ucsr1c udr1 ucsr1a ucsr1b ubrr1l ubrr1h ucsr0c ubrr0h tccr3c tccr3a tccr3b tcnt3h tcnt3l ocr3ah ocr3al ocr3bh ocr3bl ocr3ch ocr3cl icr3h icr3l etimsk etifr tccr1c ocr1ch ocr1cl twcr twdr twar twsr twbr osccal xmcra xmcrb eicra spmcsr spmcr portg ddrg ping portf ddrf sreg sph spl xdiv rampz eicrb eimsk gimsk gicr eifr gifr timsk tifr mcucr mcucsr tccr0 tcnt0 ocr0 assr tccr1a tccr1b tcnt1h tcnt1l ocr1ah ocr1al ocr1bh ocr1bl icr1h icr1l tccr2 tcnt2 ocr2 ocdr wdtcr sfior eearh eearl eedr eecr porta ddra pina portb ddrb pinb portc ddrc pinc portd ddrd pind spdr spsr spcr udr0 ucsr0a ucsr0b ubrr0l acsr admux adcsr adch adcl porte ddre pine pinf",preprocessor:".byte .cseg .db .def .device .dseg .dw .endmacro .equ .eseg .exit .include .list .listmac .macro .nolist .org .set"},contains:[hljs.C_BLOCK_COMMENT_MODE,hljs.COMMENT(";","$",{relevance:0}),hljs.C_NUMBER_MODE,hljs.BINARY_NUMBER_MODE,{className:"number",begin:"\\b(\\$[a-zA-Z0-9]+|0o[0-7]+)"},hljs.QUOTE_STRING_MODE,{className:"string",begin:"'",end:"[^\\\\]'",illegal:"[^\\\\][^']"},{className:"label",begin:"^[A-Za-z0-9_.$]+:"},{className:"preprocessor",begin:"#",end:"$"},{className:"localvars",begin:"@[0-9]+"}]}}),hljs.registerLanguage("axapta",function(hljs){return{keywords:"false int abstract private char boolean static null if for true while long throw finally protected final return void enum else break new catch byte super case short default double public try this switch continue reverse firstfast firstonly forupdate nofetch sum avg minof maxof count order group by asc desc index hint like dispaly edit client server ttsbegin ttscommit str real date container anytype common div mod",contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE,{className:"preprocessor",begin:"#",end:"$"},{className:"class",beginKeywords:"class interface",end:"{",excludeEnd:!0,illegal:":",contains:[{beginKeywords:"extends implements"},hljs.UNDERSCORE_TITLE_MODE]}]}}),hljs.registerLanguage("bash",function(hljs){var VAR={className:"variable",variants:[{begin:/\$[\w\d#@][\w\d_]*/},{begin:/\$\{(.*?)}/}]},QUOTE_STRING={className:"string",begin:/"/,end:/"/,contains:[hljs.BACKSLASH_ESCAPE,VAR,{className:"variable",begin:/\$\(/,end:/\)/,contains:[hljs.BACKSLASH_ESCAPE]}]},APOS_STRING={className:"string",begin:/'/,end:/'/};return{aliases:["sh","zsh"],lexemes:/-?[a-z\.]+/,keywords:{keyword:"if then else elif fi for while in do done case esac function",literal:"true false",built_in:"break cd continue eval exec exit export getopts hash pwd readonly return shift test times trap umask unset alias bind builtin caller command declare echo enable help let local logout mapfile printf read readarray source type typeset ulimit unalias set shopt autoload bg bindkey bye cap chdir clone comparguments compcall compctl compdescribe compfiles compgroups compquote comptags comptry compvalues dirs disable disown echotc echoti emulate fc fg float functions getcap getln history integer jobs kill limit log noglob popd print pushd pushln rehash sched setcap setopt stat suspend ttyctl unfunction unhash unlimit unsetopt vared wait whence where which zcompile zformat zftp zle zmodload zparseopts zprof zpty zregexparse zsocket zstyle ztcp",operator:"-ne -eq -lt -gt -f -d -e -s -l -a"},contains:[{className:"shebang",begin:/^#![^\n]+sh\s*$/,relevance:10},{className:"function",begin:/\w[\w\d_]*\s*\(\s*\)\s*\{/,returnBegin:!0,contains:[hljs.inherit(hljs.TITLE_MODE,{begin:/\w[\w\d_]*/})],relevance:0},hljs.HASH_COMMENT_MODE,hljs.NUMBER_MODE,QUOTE_STRING,APOS_STRING,VAR]}}),hljs.registerLanguage("brainfuck",function(hljs){var LITERAL={className:"literal",begin:"[\\+\\-]",relevance:0};return{aliases:["bf"],contains:[hljs.COMMENT("[^\\[\\]\\.,\\+\\-<> \r\n]","[\\[\\]\\.,\\+\\-<> \r\n]",{returnEnd:!0,relevance:0}),{className:"title",begin:"[\\[\\]]",relevance:0},{className:"string",begin:"[\\.,]",relevance:0},{begin:/\+\+|\-\-/,returnBegin:!0,contains:[LITERAL]},LITERAL]}}),hljs.registerLanguage("cal",function(hljs){var KEYWORDS="div mod in and or not xor asserterror begin case do downto else end exit for if of repeat then to until while with var",LITERALS="false true",COMMENT_MODES=[hljs.C_LINE_COMMENT_MODE,hljs.COMMENT(/\{/,/\}/,{relevance:0}),hljs.COMMENT(/\(\*/,/\*\)/,{relevance:10})],STRING={className:"string",begin:/'/,end:/'/,contains:[{begin:/''/}]},CHAR_STRING={className:"string",begin:/(#\d+)+/},DATE={className:"date",begin:"\\b\\d+(\\.\\d+)?(DT|D|T)",relevance:0},DBL_QUOTED_VARIABLE={className:"variable",begin:'"',end:'"'},PROCEDURE={className:"function",beginKeywords:"procedure",end:/[:;]/,keywords:"procedure|10",contains:[hljs.TITLE_MODE,{className:"params",begin:/\(/,end:/\)/,keywords:KEYWORDS,contains:[STRING,CHAR_STRING]}].concat(COMMENT_MODES)},OBJECT={className:"class",begin:"OBJECT (Table|Form|Report|Dataport|Codeunit|XMLport|MenuSuite|Page|Query) (\\d+) ([^\\r\\n]+)",returnBegin:!0,contains:[hljs.TITLE_MODE,PROCEDURE]};return{case_insensitive:!0,keywords:{keyword:KEYWORDS,literal:LITERALS},illegal:/\/\*/,contains:[STRING,CHAR_STRING,DATE,DBL_QUOTED_VARIABLE,hljs.NUMBER_MODE,OBJECT,PROCEDURE]}}),hljs.registerLanguage("capnproto",function(hljs){return{aliases:["capnp"],keywords:{keyword:"struct enum interface union group import using const annotation extends in of on as with from fixed",built_in:"Void Bool Int8 Int16 Int32 Int64 UInt8 UInt16 UInt32 UInt64 Float32 Float64 Text Data AnyPointer AnyStruct Capability List",literal:"true false"},contains:[hljs.QUOTE_STRING_MODE,hljs.NUMBER_MODE,hljs.HASH_COMMENT_MODE,{className:"shebang",begin:/@0x[\w\d]{16};/,illegal:/\n/},{className:"number",begin:/@\d+\b/},{className:"class",beginKeywords:"struct enum",end:/\{/,illegal:/\n/,contains:[hljs.inherit(hljs.TITLE_MODE,{starts:{endsWithParent:!0,excludeEnd:!0}})]},{className:"class",beginKeywords:"interface",end:/\{/,illegal:/\n/,contains:[hljs.inherit(hljs.TITLE_MODE,{starts:{endsWithParent:!0,excludeEnd:!0}})]}]}}),hljs.registerLanguage("ceylon",function(hljs){var KEYWORDS="assembly module package import alias class interface object given value assign void function new of extends satisfies abstracts in out return break continue throw assert dynamic if else switch case for while try catch finally then let this outer super is exists nonempty",DECLARATION_MODIFIERS="shared abstract formal default actual variable late native deprecatedfinal sealed annotation suppressWarnings small",DOCUMENTATION="doc by license see throws tagged",LANGUAGE_ANNOTATIONS=DECLARATION_MODIFIERS+" "+DOCUMENTATION,SUBST={className:"subst",excludeBegin:!0,excludeEnd:!0,begin:/``/,end:/``/,keywords:KEYWORDS,relevance:10},EXPRESSIONS=[{className:"string",begin:'"""',end:'"""',relevance:10},{className:"string",begin:'"',end:'"',contains:[SUBST]},{className:"string",begin:"'",end:"'"},{className:"number",begin:"#[0-9a-fA-F_]+|\\$[01_]+|[0-9_]+(?:\\.[0-9_](?:[eE][+-]?\\d+)?)?[kMGTPmunpf]?",relevance:0}];return SUBST.contains=EXPRESSIONS,{keywords:{keyword:KEYWORDS,annotation:LANGUAGE_ANNOTATIONS},illegal:"\\$[^01]|#[^0-9a-fA-F]",contains:[hljs.C_LINE_COMMENT_MODE,hljs.COMMENT("/\\*","\\*/",{contains:["self"]}),{className:"annotation",begin:'@[a-z]\\w*(?:\\:"[^"]*")?'}].concat(EXPRESSIONS)}}),hljs.registerLanguage("clojure",function(hljs){var keywords={built_in:"def defonce cond apply if-not if-let if not not= = < > <= >= == + / * - rem quot neg? pos? delay? symbol? keyword? true? false? integer? empty? coll? list? set? ifn? fn? associative? sequential? sorted? counted? reversible? number? decimal? class? distinct? isa? float? rational? reduced? ratio? odd? even? char? seq? vector? string? map? nil? contains? zero? instance? not-every? not-any? libspec? -> ->> .. . inc compare do dotimes mapcat take remove take-while drop letfn drop-last take-last drop-while while intern condp case reduced cycle split-at split-with repeat replicate iterate range merge zipmap declare line-seq sort comparator sort-by dorun doall nthnext nthrest partition eval doseq await await-for let agent atom send send-off release-pending-sends add-watch mapv filterv remove-watch agent-error restart-agent set-error-handler error-handler set-error-mode! error-mode shutdown-agents quote var fn loop recur throw try monitor-enter monitor-exit defmacro defn defn- macroexpand macroexpand-1 for dosync and or when when-not when-let comp juxt partial sequence memoize constantly complement identity assert peek pop doto proxy defstruct first rest cons defprotocol cast coll deftype defrecord last butlast sigs reify second ffirst fnext nfirst nnext defmulti defmethod meta with-meta ns in-ns create-ns import refer keys select-keys vals key val rseq name namespace promise into transient persistent! conj! assoc! dissoc! pop! disj! use class type num float double short byte boolean bigint biginteger bigdec print-method print-dup throw-if printf format load compile get-in update-in pr pr-on newline flush read slurp read-line subvec with-open memfn time re-find re-groups rand-int rand mod locking assert-valid-fdecl alias resolve ref deref refset swap! reset! set-validator! compare-and-set! alter-meta! reset-meta! commute get-validator alter ref-set ref-history-count ref-min-history ref-max-history ensure sync io! new next conj set! to-array future future-call into-array aset gen-class reduce map filter find empty hash-map hash-set sorted-map sorted-map-by sorted-set sorted-set-by vec vector seq flatten reverse assoc dissoc list disj get union difference intersection extend extend-type extend-protocol int nth delay count concat chunk chunk-buffer chunk-append chunk-first chunk-rest max min dec unchecked-inc-int unchecked-inc unchecked-dec-inc unchecked-dec unchecked-negate unchecked-add-int unchecked-add unchecked-subtract-int unchecked-subtract chunk-next chunk-cons chunked-seq? prn vary-meta lazy-seq spread list* str find-keyword keyword symbol gensym force rationalize"},SYMBOLSTART="a-zA-Z_\\-!.?+*=<>&#'",SYMBOL_RE="["+SYMBOLSTART+"]["+SYMBOLSTART+"0-9/;:]*",SIMPLE_NUMBER_RE="[-+]?\\d+(\\.\\d+)?",SYMBOL={begin:SYMBOL_RE,relevance:0},NUMBER={className:"number",begin:SIMPLE_NUMBER_RE,relevance:0},STRING=hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null}),COMMENT=hljs.COMMENT(";","$",{relevance:0}),LITERAL={className:"literal",begin:/\b(true|false|nil)\b/},COLLECTION={className:"collection",begin:"[\\[\\{]",end:"[\\]\\}]"},HINT={className:"comment",begin:"\\^"+SYMBOL_RE},HINT_COL=hljs.COMMENT("\\^\\{","\\}"),KEY={className:"attribute",begin:"[:]"+SYMBOL_RE},LIST={className:"list",begin:"\\(",end:"\\)"},BODY={endsWithParent:!0,relevance:0},NAME={keywords:keywords,lexemes:SYMBOL_RE,className:"keyword",begin:SYMBOL_RE,starts:BODY},DEFAULT_CONTAINS=[LIST,STRING,HINT,HINT_COL,COMMENT,KEY,COLLECTION,NUMBER,LITERAL,SYMBOL];return LIST.contains=[hljs.COMMENT("comment",""),NAME,BODY],BODY.contains=DEFAULT_CONTAINS,COLLECTION.contains=DEFAULT_CONTAINS,{aliases:["clj"],illegal:/\S/,contains:[LIST,STRING,HINT,HINT_COL,COMMENT,KEY,COLLECTION,NUMBER,LITERAL]}}),hljs.registerLanguage("clojure-repl",function(hljs){return{contains:[{className:"prompt",begin:/^([\w.-]+|\s*#_)=>/,starts:{end:/$/,subLanguage:"clojure"}}]}}),hljs.registerLanguage("cmake",function(hljs){return{aliases:["cmake.in"],case_insensitive:!0,keywords:{keyword:"add_custom_command add_custom_target add_definitions add_dependencies add_executable add_library add_subdirectory add_test aux_source_directory break build_command cmake_minimum_required cmake_policy configure_file create_test_sourcelist define_property else elseif enable_language enable_testing endforeach endfunction endif endmacro endwhile execute_process export find_file find_library find_package find_path find_program fltk_wrap_ui foreach function get_cmake_property get_directory_property get_filename_component get_property get_source_file_property get_target_property get_test_property if include include_directories include_external_msproject include_regular_expression install link_directories load_cache load_command macro mark_as_advanced message option output_required_files project qt_wrap_cpp qt_wrap_ui remove_definitions return separate_arguments set set_directory_properties set_property set_source_files_properties set_target_properties set_tests_properties site_name source_group string target_link_libraries try_compile try_run unset variable_watch while build_name exec_program export_library_dependencies install_files install_programs install_targets link_libraries make_directory remove subdir_depends subdirs use_mangled_mesa utility_source variable_requires write_file qt5_use_modules qt5_use_package qt5_wrap_cpp on off true false and or",operator:"equal less greater strless strgreater strequal matches"},contains:[{className:"envvar",begin:"\\${",end:"}"},hljs.HASH_COMMENT_MODE,hljs.QUOTE_STRING_MODE,hljs.NUMBER_MODE]}}),hljs.registerLanguage("coffeescript",function(hljs){var KEYWORDS={keyword:"in if for while finally new do return else break catch instanceof throw try this switch continue typeof delete debugger super then unless until loop of by when and or is isnt not",literal:"true false null undefined yes no on off",built_in:"npm require console print module global window document"},JS_IDENT_RE="[A-Za-z$_][0-9A-Za-z$_]*",SUBST={className:"subst",begin:/#\{/,end:/}/,keywords:KEYWORDS},EXPRESSIONS=[hljs.BINARY_NUMBER_MODE,hljs.inherit(hljs.C_NUMBER_MODE,{starts:{end:"(\\s*/)?",relevance:0}}),{className:"string",variants:[{begin:/'''/,end:/'''/,contains:[hljs.BACKSLASH_ESCAPE]},{begin:/'/,end:/'/,contains:[hljs.BACKSLASH_ESCAPE]},{begin:/"""/,end:/"""/,contains:[hljs.BACKSLASH_ESCAPE,SUBST]},{begin:/"/,end:/"/,contains:[hljs.BACKSLASH_ESCAPE,SUBST]}]},{className:"regexp",variants:[{begin:"///",end:"///",contains:[SUBST,hljs.HASH_COMMENT_MODE]},{begin:"//[gim]*",relevance:0},{begin:/\/(?![ *])(\\\/|.)*?\/[gim]*(?=\W|$)/}]},{className:"property",begin:"@"+JS_IDENT_RE},{begin:"`",end:"`",excludeBegin:!0,excludeEnd:!0,subLanguage:"javascript"}];SUBST.contains=EXPRESSIONS;var TITLE=hljs.inherit(hljs.TITLE_MODE,{begin:JS_IDENT_RE}),PARAMS_RE="(\\(.*\\))?\\s*\\B[-=]>",PARAMS={className:"params",begin:"\\([^\\(]",returnBegin:!0,contains:[{begin:/\(/,end:/\)/,keywords:KEYWORDS,contains:["self"].concat(EXPRESSIONS)}]};return{aliases:["coffee","cson","iced"],keywords:KEYWORDS,illegal:/\/\*/,contains:EXPRESSIONS.concat([hljs.COMMENT("###","###"),hljs.HASH_COMMENT_MODE,{className:"function",begin:"^\\s*"+JS_IDENT_RE+"\\s*=\\s*"+PARAMS_RE,end:"[-=]>",returnBegin:!0,contains:[TITLE,PARAMS]},{begin:/[:\(,=]\s*/,relevance:0,contains:[{className:"function",begin:PARAMS_RE,end:"[-=]>",returnBegin:!0,contains:[PARAMS]}]},{className:"class",beginKeywords:"class",end:"$",illegal:/[:="\[\]]/,contains:[{beginKeywords:"extends",endsWithParent:!0,illegal:/[:="\[\]]/,contains:[TITLE]},TITLE]},{className:"attribute",begin:JS_IDENT_RE+":",end:":",returnBegin:!0,returnEnd:!0,relevance:0}])}}),hljs.registerLanguage("cpp",function(hljs){var CPP_PRIMATIVE_TYPES={className:"keyword",begin:"\\b[a-z\\d_]*_t\\b"},STRINGS={className:"string",variants:[hljs.inherit(hljs.QUOTE_STRING_MODE,{begin:'((u8?|U)|L)?"'}),{begin:'(u8?|U)?R"',end:'"',contains:[hljs.BACKSLASH_ESCAPE]},{begin:"'\\\\?.",end:"'",illegal:"."}]},NUMBERS={className:"number",variants:[{begin:"\\b(\\d+(\\.\\d*)?|\\.\\d+)(u|U|l|L|ul|UL|f|F)"},{begin:hljs.C_NUMBER_RE}]},PREPROCESSOR={className:"preprocessor",begin:"#",end:"$",keywords:"if else elif endif define undef warning error line pragma ifdef ifndef",contains:[{begin:/\\\n/,relevance:0},{beginKeywords:"include",end:"$",contains:[STRINGS,{className:"string",begin:"<",end:">",illegal:"\\n"}]},STRINGS,NUMBERS,hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE]},FUNCTION_TITLE=hljs.IDENT_RE+"\\s*\\(",CPP_KEYWORDS={keyword:"int float while private char catch export virtual operator sizeof dynamic_cast|10 typedef const_cast|10 const struct for static_cast|10 union namespace unsigned long volatile static protected bool template mutable if public friend do goto auto void enum else break extern using class asm case typeid short reinterpret_cast|10 default double register explicit signed typename try this switch continue inline delete alignof constexpr decltype noexcept static_assert thread_local restrict _Bool complex _Complex _Imaginary atomic_bool atomic_char atomic_schar atomic_uchar atomic_short atomic_ushort atomic_int atomic_uint atomic_long atomic_ulong atomic_llong atomic_ullong",built_in:"std string cin cout cerr clog stdin stdout stderr stringstream istringstream ostringstream auto_ptr deque list queue stack vector map set bitset multiset multimap unordered_set unordered_map unordered_multiset unordered_multimap array shared_ptr abort abs acos asin atan2 atan calloc ceil cosh cos exit exp fabs floor fmod fprintf fputs free frexp fscanf isalnum isalpha iscntrl isdigit isgraph islower isprint ispunct isspace isupper isxdigit tolower toupper labs ldexp log10 log malloc realloc memchr memcmp memcpy memset modf pow printf putchar puts scanf sinh sin snprintf sprintf sqrt sscanf strcat strchr strcmp strcpy strcspn strlen strncat strncmp strncpy strpbrk strrchr strspn strstr tanh tan vfprintf vprintf vsprintf",literal:"true false nullptr NULL"};return{aliases:["c","cc","h","c++","h++","hpp"],keywords:CPP_KEYWORDS,illegal:"</",contains:[CPP_PRIMATIVE_TYPES,hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,NUMBERS,STRINGS,PREPROCESSOR,{begin:"\\b(deque|list|queue|stack|vector|map|set|bitset|multiset|multimap|unordered_map|unordered_set|unordered_multiset|unordered_multimap|array)\\s*<",end:">",keywords:CPP_KEYWORDS,contains:["self",CPP_PRIMATIVE_TYPES]},{begin:hljs.IDENT_RE+"::",keywords:CPP_KEYWORDS},{beginKeywords:"new throw return else",relevance:0},{className:"function",begin:"("+hljs.IDENT_RE+"[\\*&\\s]+)+"+FUNCTION_TITLE,returnBegin:!0,end:/[{;=]/,excludeEnd:!0,keywords:CPP_KEYWORDS,illegal:/[^\w\s\*&]/,contains:[{begin:FUNCTION_TITLE,returnBegin:!0,contains:[hljs.TITLE_MODE],relevance:0},{className:"params",begin:/\(/,end:/\)/,keywords:CPP_KEYWORDS,relevance:0,contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,STRINGS,NUMBERS]},hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,PREPROCESSOR]}]}}),hljs.registerLanguage("crmsh",function(hljs){var RESOURCES="primitive rsc_template",COMMANDS="group clone ms master location colocation order fencing_topology rsc_ticket acl_target acl_group user role tag xml",PROPERTY_SETS="property rsc_defaults op_defaults",KEYWORDS="params meta operations op rule attributes utilization",OPERATORS="read write deny defined not_defined in_range date spec in ref reference attribute type xpath version and or lt gt tag lte gte eq ne \\",TYPES="number string",LITERALS="Master Started Slave Stopped start promote demote stop monitor true false";return{aliases:["crm","pcmk"],case_insensitive:!0,keywords:{keyword:KEYWORDS,operator:OPERATORS,type:TYPES,literal:LITERALS},contains:[hljs.HASH_COMMENT_MODE,{beginKeywords:"node",starts:{className:"identifier",end:"\\s*([\\w_-]+:)?",starts:{className:"title",end:"\\s*[\\$\\w_][\\w_-]*"}}},{beginKeywords:RESOURCES,starts:{className:"title",end:"\\s*[\\$\\w_][\\w_-]*",starts:{className:"pragma",end:"\\s*@?[\\w_][\\w_\\.:-]*"}}},{begin:"\\b("+COMMANDS.split(" ").join("|")+")\\s+",keywords:COMMANDS,starts:{className:"title",end:"[\\$\\w_][\\w_-]*"}},{beginKeywords:PROPERTY_SETS,starts:{className:"title",end:"\\s*([\\w_-]+:)?"}},hljs.QUOTE_STRING_MODE,{className:"pragma",begin:"(ocf|systemd|service|lsb):[\\w_:-]+",relevance:0},{className:"number",begin:"\\b\\d+(\\.\\d+)?(ms|s|h|m)?",relevance:0},{className:"number",begin:"[-]?(infinity|inf)",relevance:0},{className:"variable",begin:/([A-Za-z\$_\#][\w_-]+)=/,relevance:0},{className:"tag",begin:"</?",end:"/?>",relevance:0}]}}),hljs.registerLanguage("crystal",function(hljs){function recursiveParen(begin,end){var contains=[{begin:begin,end:end}];return contains[0].contains=contains,contains}var NUM_SUFFIX="(_[uif](8|16|32|64))?",CRYSTAL_IDENT_RE="[a-zA-Z_]\\w*[!?=]?",RE_STARTER="!=|!==|%|%=|&|&&|&=|\\*|\\*=|\\+|\\+=|,|-|-=|/=|/|:|;|<<|<<=|<=|<|===|==|=|>>>=|>>=|>=|>>>|>>|>|\\[|\\{|\\(|\\^|\\^=|\\||\\|=|\\|\\||~",CRYSTAL_METHOD_RE="[a-zA-Z_]\\w*[!?=]?|[-+~]\\@|<<|>>|=~|===?|<=>|[<>]=?|\\*\\*|[-/+%^&*~`|]|\\[\\][=?]?",CRYSTAL_KEYWORDS={keyword:"abstract alias as asm begin break case class def do else elsif end ensure enum extend for fun if ifdef include instance_sizeof is_a? lib macro module next of out pointerof private protected rescue responds_to? return require self sizeof struct super then type typeof union unless until when while with yield __DIR__ __FILE__ __LINE__",literal:"false nil true"},SUBST={className:"subst",begin:"#{",end:"}",keywords:CRYSTAL_KEYWORDS},EXPANSION={className:"expansion",variants:[{begin:"\\{\\{",end:"\\}\\}"},{begin:"\\{%",end:"%\\}"}],keywords:CRYSTAL_KEYWORDS,relevance:10},STRING={className:"string",contains:[hljs.BACKSLASH_ESCAPE,SUBST],variants:[{begin:/'/,end:/'/},{begin:/"/,end:/"/},{begin:/`/,end:/`/},{begin:"%w?\\(",end:"\\)",contains:recursiveParen("\\(","\\)")},{begin:"%w?\\[",end:"\\]",contains:recursiveParen("\\[","\\]")},{begin:"%w?{",end:"}",contains:recursiveParen("{","}")},{begin:"%w?<",end:">",contains:recursiveParen("<",">")},{begin:"%w?/",end:"/"},{begin:"%w?%",end:"%"},{begin:"%w?-",end:"-"},{begin:"%w?\\|",end:"\\|"}],relevance:0},REGEXP={begin:"("+RE_STARTER+")\\s*",contains:[{className:"regexp",contains:[hljs.BACKSLASH_ESCAPE,SUBST],variants:[{begin:"/",end:"/[a-z]*"},{begin:"%r\\(",end:"\\)",contains:recursiveParen("\\(","\\)")},{begin:"%r\\[",end:"\\]",contains:recursiveParen("\\[","\\]")},{begin:"%r{",end:"}",contains:recursiveParen("{","}")},{begin:"%r<",end:">",contains:recursiveParen("<",">")},{begin:"%r/",end:"/"},{begin:"%r%",end:"%"},{begin:"%r-",end:"-"},{begin:"%r\\|",end:"\\|"}]}],relevance:0},REGEXP2={className:"regexp",contains:[hljs.BACKSLASH_ESCAPE,SUBST],variants:[{begin:"%r\\(",end:"\\)",contains:recursiveParen("\\(","\\)")},{begin:"%r\\[",end:"\\]",contains:recursiveParen("\\[","\\]")},{begin:"%r{",end:"}",contains:recursiveParen("{","}")},{begin:"%r<",end:">",contains:recursiveParen("<",">")},{begin:"%r/",end:"/"},{begin:"%r%",end:"%"},{begin:"%r-",end:"-"},{begin:"%r\\|",end:"\\|"}],relevance:0},ATTRIBUTE={className:"annotation",begin:"@\\[",end:"\\]",relevance:5},CRYSTAL_DEFAULT_CONTAINS=[EXPANSION,STRING,REGEXP,REGEXP2,ATTRIBUTE,hljs.HASH_COMMENT_MODE,{className:"class",beginKeywords:"class module struct",end:"$|;",illegal:/=/,contains:[hljs.HASH_COMMENT_MODE,hljs.inherit(hljs.TITLE_MODE,{begin:"[A-Za-z_]\\w*(::\\w+)*(\\?|\\!)?"}),{className:"inheritance",begin:"<\\s*",contains:[{className:"parent",begin:"("+hljs.IDENT_RE+"::)?"+hljs.IDENT_RE}]}]},{className:"class",beginKeywords:"lib enum union",end:"$|;",illegal:/=/,contains:[hljs.HASH_COMMENT_MODE,hljs.inherit(hljs.TITLE_MODE,{begin:"[A-Za-z_]\\w*(::\\w+)*(\\?|\\!)?"})],relevance:10},{className:"function",beginKeywords:"def",end:/\B\b/,contains:[hljs.inherit(hljs.TITLE_MODE,{begin:CRYSTAL_METHOD_RE,endsParent:!0})]},{className:"function",beginKeywords:"fun macro",end:/\B\b/,contains:[hljs.inherit(hljs.TITLE_MODE,{begin:CRYSTAL_METHOD_RE,endsParent:!0})],relevance:5},{className:"constant",begin:"(::)?(\\b[A-Z]\\w*(::)?)+",relevance:0},{className:"symbol",begin:hljs.UNDERSCORE_IDENT_RE+"(\\!|\\?)?:",relevance:0},{className:"symbol",begin:":",contains:[STRING,{begin:CRYSTAL_METHOD_RE}],relevance:0},{className:"number",variants:[{begin:"\\b0b([01_]*[01])"+NUM_SUFFIX},{begin:"\\b0o([0-7_]*[0-7])"+NUM_SUFFIX},{begin:"\\b0x([A-Fa-f0-9_]*[A-Fa-f0-9])"+NUM_SUFFIX},{begin:"\\b(([0-9][0-9_]*[0-9]|[0-9])(\\.[0-9_]*[0-9])?([eE][+-]?[0-9_]*[0-9])?)"+NUM_SUFFIX}],relevance:0},{className:"variable",begin:"(\\$\\W)|((\\$|\\@\\@?|%)(\\w+))"}];return SUBST.contains=CRYSTAL_DEFAULT_CONTAINS,ATTRIBUTE.contains=CRYSTAL_DEFAULT_CONTAINS,EXPANSION.contains=CRYSTAL_DEFAULT_CONTAINS.slice(1),{aliases:["cr"],lexemes:CRYSTAL_IDENT_RE,keywords:CRYSTAL_KEYWORDS,contains:CRYSTAL_DEFAULT_CONTAINS}}),hljs.registerLanguage("cs",function(hljs){var KEYWORDS="abstract as base bool break byte case catch char checked const continue decimal dynamic default delegate do double else enum event explicit extern false finally fixed float for foreach goto if implicit in int interface internal is lock long null when object operator out override params private protected public readonly ref sbyte sealed short sizeof stackalloc static string struct switch this true try typeof uint ulong unchecked unsafe ushort using virtual volatile void while async protected public private internal ascending descending from get group into join let orderby partial select set value var where yield",GENERIC_IDENT_RE=hljs.IDENT_RE+"(<"+hljs.IDENT_RE+">)?";return{aliases:["csharp"],keywords:KEYWORDS,illegal:/::/,contains:[hljs.COMMENT("///","$",{returnBegin:!0,contains:[{className:"xmlDocTag",variants:[{begin:"///",relevance:0},{begin:"<!--|-->"},{begin:"</?",end:">"}]}]}),hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,{className:"preprocessor",begin:"#",end:"$",keywords:"if else elif endif define undef warning error line region endregion pragma checksum"},{className:"string",begin:'@"',end:'"',contains:[{begin:'""'}]},hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE,{beginKeywords:"class interface",end:/[{;=]/,illegal:/[^\s:]/,contains:[hljs.TITLE_MODE,hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE]},{beginKeywords:"namespace",end:/[{;=]/,illegal:/[^\s:]/,contains:[{className:"title",begin:"[a-zA-Z](\\.?\\w)*",relevance:0},hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE]},{beginKeywords:"new return throw await",relevance:0},{className:"function",begin:"("+GENERIC_IDENT_RE+"\\s+)+"+hljs.IDENT_RE+"\\s*\\(",returnBegin:!0,end:/[{;=]/,excludeEnd:!0,keywords:KEYWORDS,contains:[{begin:hljs.IDENT_RE+"\\s*\\(",returnBegin:!0,contains:[hljs.TITLE_MODE],relevance:0},{className:"params",begin:/\(/,end:/\)/,excludeBegin:!0,excludeEnd:!0,keywords:KEYWORDS,relevance:0,contains:[hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE,hljs.C_BLOCK_COMMENT_MODE]},hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE]}]}}),hljs.registerLanguage("css",function(hljs){var IDENT_RE="[a-zA-Z-][a-zA-Z0-9_-]*",FUNCTION={className:"function",begin:IDENT_RE+"\\(",returnBegin:!0,excludeEnd:!0,end:"\\("},RULE={className:"rule",begin:/[A-Z\_\.\-]+\s*:/,returnBegin:!0,end:";",endsWithParent:!0,contains:[{className:"attribute",begin:/\S/,end:":",excludeEnd:!0,starts:{className:"value",endsWithParent:!0,excludeEnd:!0,contains:[FUNCTION,hljs.CSS_NUMBER_MODE,hljs.QUOTE_STRING_MODE,hljs.APOS_STRING_MODE,hljs.C_BLOCK_COMMENT_MODE,{className:"hexcolor",begin:"#[0-9A-Fa-f]+"},{className:"important",begin:"!important"}]}}]};return{case_insensitive:!0,illegal:/[=\/|'\$]/,contains:[hljs.C_BLOCK_COMMENT_MODE,{className:"id",begin:/\#[A-Za-z0-9_-]+/},{className:"class",begin:/\.[A-Za-z0-9_-]+/},{className:"attr_selector",begin:/\[/,end:/\]/,illegal:"$"},{className:"pseudo",begin:/:(:)?[a-zA-Z0-9\_\-\+\(\)"']+/},{className:"at_rule",begin:"@(font-face|page)",lexemes:"[a-z-]+",keywords:"font-face page"},{className:"at_rule",begin:"@",end:"[{;]",contains:[{className:"keyword",begin:/\S+/},{begin:/\s/,endsWithParent:!0,excludeEnd:!0,relevance:0,contains:[FUNCTION,hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.CSS_NUMBER_MODE]}]},{className:"tag",begin:IDENT_RE,relevance:0},{className:"rules",begin:"{",end:"}",illegal:/\S/,contains:[hljs.C_BLOCK_COMMENT_MODE,RULE]}]}}),hljs.registerLanguage("d",function(hljs){var D_KEYWORDS={keyword:"abstract alias align asm assert auto body break byte case cast catch class const continue debug default delete deprecated do else enum export extern final finally for foreach foreach_reverse|10 goto if immutable import in inout int interface invariant is lazy macro mixin module new nothrow out override package pragma private protected public pure ref return scope shared static struct super switch synchronized template this throw try typedef typeid typeof union unittest version void volatile while with __FILE__ __LINE__ __gshared|10 __thread __traits __DATE__ __EOF__ __TIME__ __TIMESTAMP__ __VENDOR__ __VERSION__",built_in:"bool cdouble cent cfloat char creal dchar delegate double dstring float function idouble ifloat ireal long real short string ubyte ucent uint ulong ushort wchar wstring",literal:"false null true"
},decimal_integer_re="(0|[1-9][\\d_]*)",decimal_integer_nosus_re="(0|[1-9][\\d_]*|\\d[\\d_]*|[\\d_]+?\\d)",binary_integer_re="0[bB][01_]+",hexadecimal_digits_re="([\\da-fA-F][\\da-fA-F_]*|_[\\da-fA-F][\\da-fA-F_]*)",hexadecimal_integer_re="0[xX]"+hexadecimal_digits_re,decimal_exponent_re="([eE][+-]?"+decimal_integer_nosus_re+")",decimal_float_re="("+decimal_integer_nosus_re+"(\\.\\d*|"+decimal_exponent_re+")|\\d+\\."+decimal_integer_nosus_re+decimal_integer_nosus_re+"|\\."+decimal_integer_re+decimal_exponent_re+"?)",hexadecimal_float_re="(0[xX]("+hexadecimal_digits_re+"\\."+hexadecimal_digits_re+"|\\.?"+hexadecimal_digits_re+")[pP][+-]?"+decimal_integer_nosus_re+")",integer_re="("+decimal_integer_re+"|"+binary_integer_re+"|"+hexadecimal_integer_re+")",float_re="("+hexadecimal_float_re+"|"+decimal_float_re+")",escape_sequence_re="\\\\(['\"\\?\\\\abfnrtv]|u[\\dA-Fa-f]{4}|[0-7]{1,3}|x[\\dA-Fa-f]{2}|U[\\dA-Fa-f]{8})|&[a-zA-Z\\d]{2,};",D_INTEGER_MODE={className:"number",begin:"\\b"+integer_re+"(L|u|U|Lu|LU|uL|UL)?",relevance:0},D_FLOAT_MODE={className:"number",begin:"\\b("+float_re+"([fF]|L|i|[fF]i|Li)?|"+integer_re+"(i|[fF]i|Li))",relevance:0},D_CHARACTER_MODE={className:"string",begin:"'("+escape_sequence_re+"|.)",end:"'",illegal:"."},D_ESCAPE_SEQUENCE={begin:escape_sequence_re,relevance:0},D_STRING_MODE={className:"string",begin:'"',contains:[D_ESCAPE_SEQUENCE],end:'"[cwd]?'},D_WYSIWYG_DELIMITED_STRING_MODE={className:"string",begin:'[rq]"',end:'"[cwd]?',relevance:5},D_ALTERNATE_WYSIWYG_STRING_MODE={className:"string",begin:"`",end:"`[cwd]?"},D_HEX_STRING_MODE={className:"string",begin:'x"[\\da-fA-F\\s\\n\\r]*"[cwd]?',relevance:10},D_TOKEN_STRING_MODE={className:"string",begin:'q"\\{',end:'\\}"'},D_HASHBANG_MODE={className:"shebang",begin:"^#!",end:"$",relevance:5},D_SPECIAL_TOKEN_SEQUENCE_MODE={className:"preprocessor",begin:"#(line)",end:"$",relevance:5},D_ATTRIBUTE_MODE={className:"keyword",begin:"@[a-zA-Z_][a-zA-Z_\\d]*"},D_NESTING_COMMENT_MODE=hljs.COMMENT("\\/\\+","\\+\\/",{contains:["self"],relevance:10});return{lexemes:hljs.UNDERSCORE_IDENT_RE,keywords:D_KEYWORDS,contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,D_NESTING_COMMENT_MODE,D_HEX_STRING_MODE,D_STRING_MODE,D_WYSIWYG_DELIMITED_STRING_MODE,D_ALTERNATE_WYSIWYG_STRING_MODE,D_TOKEN_STRING_MODE,D_FLOAT_MODE,D_INTEGER_MODE,D_CHARACTER_MODE,D_HASHBANG_MODE,D_SPECIAL_TOKEN_SEQUENCE_MODE,D_ATTRIBUTE_MODE]}}),hljs.registerLanguage("markdown",function(hljs){return{aliases:["md","mkdown","mkd"],contains:[{className:"header",variants:[{begin:"^#{1,6}",end:"$"},{begin:"^.+?\\n[=-]{2,}$"}]},{begin:"<",end:">",subLanguage:"xml",relevance:0},{className:"bullet",begin:"^([*+-]|(\\d+\\.))\\s+"},{className:"strong",begin:"[*_]{2}.+?[*_]{2}"},{className:"emphasis",variants:[{begin:"\\*.+?\\*"},{begin:"_.+?_",relevance:0}]},{className:"blockquote",begin:"^>\\s+",end:"$"},{className:"code",variants:[{begin:"`.+?`"},{begin:"^( {4}|	)",end:"$",relevance:0}]},{className:"horizontal_rule",begin:"^[-\\*]{3,}",end:"$"},{begin:"\\[.+?\\][\\(\\[].*?[\\)\\]]",returnBegin:!0,contains:[{className:"link_label",begin:"\\[",end:"\\]",excludeBegin:!0,returnEnd:!0,relevance:0},{className:"link_url",begin:"\\]\\(",end:"\\)",excludeBegin:!0,excludeEnd:!0},{className:"link_reference",begin:"\\]\\[",end:"\\]",excludeBegin:!0,excludeEnd:!0}],relevance:10},{begin:"^\\[.+\\]:",returnBegin:!0,contains:[{className:"link_reference",begin:"\\[",end:"\\]:",excludeBegin:!0,excludeEnd:!0,starts:{className:"link_url",end:"$"}}]}]}}),hljs.registerLanguage("dart",function(hljs){var SUBST={className:"subst",begin:"\\$\\{",end:"}",keywords:"true false null this is new super"},STRING={className:"string",variants:[{begin:"r'''",end:"'''"},{begin:'r"""',end:'"""'},{begin:"r'",end:"'",illegal:"\\n"},{begin:'r"',end:'"',illegal:"\\n"},{begin:"'''",end:"'''",contains:[hljs.BACKSLASH_ESCAPE,SUBST]},{begin:'"""',end:'"""',contains:[hljs.BACKSLASH_ESCAPE,SUBST]},{begin:"'",end:"'",illegal:"\\n",contains:[hljs.BACKSLASH_ESCAPE,SUBST]},{begin:'"',end:'"',illegal:"\\n",contains:[hljs.BACKSLASH_ESCAPE,SUBST]}]};SUBST.contains=[hljs.C_NUMBER_MODE,STRING];var KEYWORDS={keyword:"assert break case catch class const continue default do else enum extends false final finally for if in is new null rethrow return super switch this throw true try var void while with",literal:"abstract as dynamic export external factory get implements import library operator part set static typedef",built_in:"print Comparable DateTime Duration Function Iterable Iterator List Map Match Null Object Pattern RegExp Set Stopwatch String StringBuffer StringSink Symbol Type Uri bool double int num document window querySelector querySelectorAll Element ElementList"};return{keywords:KEYWORDS,contains:[STRING,hljs.COMMENT("/\\*\\*","\\*/",{subLanguage:"markdown"}),hljs.COMMENT("///","$",{subLanguage:"markdown"}),hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,{className:"class",beginKeywords:"class interface",end:"{",excludeEnd:!0,contains:[{beginKeywords:"extends implements"},hljs.UNDERSCORE_TITLE_MODE]},hljs.C_NUMBER_MODE,{className:"annotation",begin:"@[A-Za-z]+"},{begin:"=>"}]}}),hljs.registerLanguage("delphi",function(hljs){var KEYWORDS="exports register file shl array record property for mod while set ally label uses raise not stored class safecall var interface or private static exit index inherited to else stdcall override shr asm far resourcestring finalization packed virtual out and protected library do xorwrite goto near function end div overload object unit begin string on inline repeat until destructor write message program with read initialization except default nil if case cdecl in downto threadvar of try pascal const external constructor type public then implementation finally published procedure",COMMENT_MODES=[hljs.C_LINE_COMMENT_MODE,hljs.COMMENT(/\{/,/\}/,{relevance:0}),hljs.COMMENT(/\(\*/,/\*\)/,{relevance:10})],STRING={className:"string",begin:/'/,end:/'/,contains:[{begin:/''/}]},CHAR_STRING={className:"string",begin:/(#\d+)+/},CLASS={begin:hljs.IDENT_RE+"\\s*=\\s*class\\s*\\(",returnBegin:!0,contains:[hljs.TITLE_MODE]},FUNCTION={className:"function",beginKeywords:"function constructor destructor procedure",end:/[:;]/,keywords:"function constructor|10 destructor|10 procedure|10",contains:[hljs.TITLE_MODE,{className:"params",begin:/\(/,end:/\)/,keywords:KEYWORDS,contains:[STRING,CHAR_STRING]}].concat(COMMENT_MODES)};return{case_insensitive:!0,keywords:KEYWORDS,illegal:/"|\$[G-Zg-z]|\/\*|<\/|\|/,contains:[STRING,CHAR_STRING,hljs.NUMBER_MODE,CLASS,FUNCTION].concat(COMMENT_MODES)}}),hljs.registerLanguage("diff",function(hljs){return{aliases:["patch"],contains:[{className:"chunk",relevance:10,variants:[{begin:/^@@ +\-\d+,\d+ +\+\d+,\d+ +@@$/},{begin:/^\*\*\* +\d+,\d+ +\*\*\*\*$/},{begin:/^\-\-\- +\d+,\d+ +\-\-\-\-$/}]},{className:"header",variants:[{begin:/Index: /,end:/$/},{begin:/=====/,end:/=====$/},{begin:/^\-\-\-/,end:/$/},{begin:/^\*{3} /,end:/$/},{begin:/^\+\+\+/,end:/$/},{begin:/\*{5}/,end:/\*{5}$/}]},{className:"addition",begin:"^\\+",end:"$"},{className:"deletion",begin:"^\\-",end:"$"},{className:"change",begin:"^\\!",end:"$"}]}}),hljs.registerLanguage("django",function(hljs){var FILTER={className:"filter",begin:/\|[A-Za-z]+:?/,keywords:"truncatewords removetags linebreaksbr yesno get_digit timesince random striptags filesizeformat escape linebreaks length_is ljust rjust cut urlize fix_ampersands title floatformat capfirst pprint divisibleby add make_list unordered_list urlencode timeuntil urlizetrunc wordcount stringformat linenumbers slice date dictsort dictsortreversed default_if_none pluralize lower join center default truncatewords_html upper length phone2numeric wordwrap time addslashes slugify first escapejs force_escape iriencode last safe safeseq truncatechars localize unlocalize localtime utc timezone",contains:[{className:"argument",begin:/"/,end:/"/},{className:"argument",begin:/'/,end:/'/}]};return{aliases:["jinja"],case_insensitive:!0,subLanguage:"xml",contains:[hljs.COMMENT(/\{%\s*comment\s*%}/,/\{%\s*endcomment\s*%}/),hljs.COMMENT(/\{#/,/#}/),{className:"template_tag",begin:/\{%/,end:/%}/,keywords:"comment endcomment load templatetag ifchanged endifchanged if endif firstof for endfor in ifnotequal endifnotequal widthratio extends include spaceless endspaceless regroup by as ifequal endifequal ssi now with cycle url filter endfilter debug block endblock else autoescape endautoescape csrf_token empty elif endwith static trans blocktrans endblocktrans get_static_prefix get_media_prefix plural get_current_language language get_available_languages get_current_language_bidi get_language_info get_language_info_list localize endlocalize localtime endlocaltime timezone endtimezone get_current_timezone verbatim",contains:[FILTER]},{className:"variable",begin:/\{\{/,end:/}}/,contains:[FILTER]}]}}),hljs.registerLanguage("dns",function(hljs){return{aliases:["bind","zone"],keywords:{keyword:"IN A AAAA AFSDB APL CAA CDNSKEY CDS CERT CNAME DHCID DLV DNAME DNSKEY DS HIP IPSECKEY KEY KX LOC MX NAPTR NS NSEC NSEC3 NSEC3PARAM PTR RRSIG RP SIG SOA SRV SSHFP TA TKEY TLSA TSIG TXT"},contains:[hljs.COMMENT(";","$"),{className:"operator",beginKeywords:"$TTL $GENERATE $INCLUDE $ORIGIN"},{className:"number",begin:"((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3}))|:))|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3}))|:)))"},{className:"number",begin:"((25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9]).){3,3}(25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9])"}]}}),hljs.registerLanguage("dockerfile",function(hljs){return{aliases:["docker"],case_insensitive:!0,keywords:{built_ins:"from maintainer cmd expose add copy entrypoint volume user workdir onbuild run env label"},contains:[hljs.HASH_COMMENT_MODE,{keywords:{built_in:"run cmd entrypoint volume add copy workdir onbuild label"},begin:/^ *(onbuild +)?(run|cmd|entrypoint|volume|add|copy|workdir|label) +/,starts:{end:/[^\\]\n/,subLanguage:"bash"}},{keywords:{built_in:"from maintainer expose env user onbuild"},begin:/^ *(onbuild +)?(from|maintainer|expose|env|user|onbuild) +/,end:/[^\\]\n/,contains:[hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.NUMBER_MODE,hljs.HASH_COMMENT_MODE]}]}}),hljs.registerLanguage("dos",function(hljs){var COMMENT=hljs.COMMENT(/@?rem\b/,/$/,{relevance:10}),LABEL={className:"label",begin:"^\\s*[A-Za-z._?][A-Za-z0-9_$#@~.?]*(:|\\s+label)",relevance:0};return{aliases:["bat","cmd"],case_insensitive:!0,illegal:/\/\*/,keywords:{flow:"if else goto for in do call exit not exist errorlevel defined",operator:"equ neq lss leq gtr geq",keyword:"shift cd dir echo setlocal endlocal set pause copy",stream:"prn nul lpt3 lpt2 lpt1 con com4 com3 com2 com1 aux",winutils:"ping net ipconfig taskkill xcopy ren del",built_in:"append assoc at attrib break cacls cd chcp chdir chkdsk chkntfs cls cmd color comp compact convert date dir diskcomp diskcopy doskey erase fs find findstr format ftype graftabl help keyb label md mkdir mode more move path pause print popd pushd promt rd recover rem rename replace restore rmdir shiftsort start subst time title tree type ver verify vol"},contains:[{className:"envvar",begin:/%%[^ ]|%[^ ]+?%|![^ ]+?!/},{className:"function",begin:LABEL.begin,end:"goto:eof",contains:[hljs.inherit(hljs.TITLE_MODE,{begin:"([_a-zA-Z]\\w*\\.)*([_a-zA-Z]\\w*:)?[_a-zA-Z]\\w*"}),COMMENT]},{className:"number",begin:"\\b\\d+",relevance:0},COMMENT]}}),hljs.registerLanguage("dust",function(hljs){var EXPRESSION_KEYWORDS="if eq ne lt lte gt gte select default math sep";return{aliases:["dst"],case_insensitive:!0,subLanguage:"xml",contains:[{className:"expression",begin:"{",end:"}",relevance:0,contains:[{className:"begin-block",begin:"#[a-zA-Z- .]+",keywords:EXPRESSION_KEYWORDS},{className:"string",begin:'"',end:'"'},{className:"end-block",begin:"\\/[a-zA-Z- .]+",keywords:EXPRESSION_KEYWORDS},{className:"variable",begin:"[a-zA-Z-.]+",keywords:EXPRESSION_KEYWORDS,relevance:0}]}]}}),hljs.registerLanguage("elixir",function(hljs){var ELIXIR_IDENT_RE="[a-zA-Z_][a-zA-Z0-9_]*(\\!|\\?)?",ELIXIR_METHOD_RE="[a-zA-Z_]\\w*[!?=]?|[-+~]\\@|<<|>>|=~|===?|<=>|[<>]=?|\\*\\*|[-/+%^&*~`|]|\\[\\]=?",ELIXIR_KEYWORDS="and false then defined module in return redo retry end for true self when next until do begin unless nil break not case cond alias while ensure or include use alias fn quote",SUBST={className:"subst",begin:"#\\{",end:"}",lexemes:ELIXIR_IDENT_RE,keywords:ELIXIR_KEYWORDS},STRING={className:"string",contains:[hljs.BACKSLASH_ESCAPE,SUBST],variants:[{begin:/'/,end:/'/},{begin:/"/,end:/"/}]},FUNCTION={className:"function",beginKeywords:"def defp defmacro",end:/\B\b/,contains:[hljs.inherit(hljs.TITLE_MODE,{begin:ELIXIR_IDENT_RE,endsParent:!0})]},CLASS=hljs.inherit(FUNCTION,{className:"class",beginKeywords:"defmodule defrecord",end:/\bdo\b|$|;/}),ELIXIR_DEFAULT_CONTAINS=[STRING,hljs.HASH_COMMENT_MODE,CLASS,FUNCTION,{className:"constant",begin:"(\\b[A-Z_]\\w*(.)?)+",relevance:0},{className:"symbol",begin:":",contains:[STRING,{begin:ELIXIR_METHOD_RE}],relevance:0},{className:"symbol",begin:ELIXIR_IDENT_RE+":",relevance:0},{className:"number",begin:"(\\b0[0-7_]+)|(\\b0x[0-9a-fA-F_]+)|(\\b[1-9][0-9_]*(\\.[0-9_]+)?)|[0_]\\b",relevance:0},{className:"variable",begin:"(\\$\\W)|((\\$|\\@\\@?)(\\w+))"},{begin:"->"},{begin:"("+hljs.RE_STARTERS_RE+")\\s*",contains:[hljs.HASH_COMMENT_MODE,{className:"regexp",illegal:"\\n",contains:[hljs.BACKSLASH_ESCAPE,SUBST],variants:[{begin:"/",end:"/[a-z]*"},{begin:"%r\\[",end:"\\][a-z]*"}]}],relevance:0}];return SUBST.contains=ELIXIR_DEFAULT_CONTAINS,{lexemes:ELIXIR_IDENT_RE,keywords:ELIXIR_KEYWORDS,contains:ELIXIR_DEFAULT_CONTAINS}}),hljs.registerLanguage("elm",function(hljs){var COMMENT_MODES=[hljs.COMMENT("--","$"),hljs.COMMENT("{-","-}",{contains:["self"]})],CONSTRUCTOR={className:"type",begin:"\\b[A-Z][\\w']*",relevance:0},LIST={className:"container",begin:"\\(",end:"\\)",illegal:'"',contains:[{className:"type",begin:"\\b[A-Z][\\w]*(\\((\\.\\.|,|\\w+)\\))?"}].concat(COMMENT_MODES)},RECORD={className:"container",begin:"{",end:"}",contains:LIST.contains};return{keywords:"let in if then else case of where module import exposing type alias as infix infixl infixr port",contains:[{className:"module",begin:"\\bmodule\\b",end:"where",keywords:"module where",contains:[LIST].concat(COMMENT_MODES),illegal:"\\W\\.|;"},{className:"import",begin:"\\bimport\\b",end:"$",keywords:"import|0 as exposing",contains:[LIST].concat(COMMENT_MODES),illegal:"\\W\\.|;"},{className:"typedef",begin:"\\btype\\b",end:"$",keywords:"type alias",contains:[CONSTRUCTOR,LIST,RECORD].concat(COMMENT_MODES)},{className:"infix",beginKeywords:"infix infixl infixr",end:"$",contains:[hljs.C_NUMBER_MODE].concat(COMMENT_MODES)},{className:"foreign",begin:"\\bport\\b",end:"$",keywords:"port",contains:COMMENT_MODES},hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE,CONSTRUCTOR,hljs.inherit(hljs.TITLE_MODE,{begin:"^[_a-z][\\w']*"}),{begin:"->|<-"}].concat(COMMENT_MODES)}}),hljs.registerLanguage("ruby",function(hljs){var RUBY_METHOD_RE="[a-zA-Z_]\\w*[!?=]?|[-+~]\\@|<<|>>|=~|===?|<=>|[<>]=?|\\*\\*|[-/+%^&*~`|]|\\[\\]=?",RUBY_KEYWORDS="and false then defined module in return redo if BEGIN retry end for true self when next until do begin unless END rescue nil else break undef not super class case require yield alias while ensure elsif or include attr_reader attr_writer attr_accessor",YARDOCTAG={className:"doctag",begin:"@[A-Za-z]+"},IRB_OBJECT={className:"value",begin:"#<",end:">"},COMMENT_MODES=[hljs.COMMENT("#","$",{contains:[YARDOCTAG]}),hljs.COMMENT("^\\=begin","^\\=end",{contains:[YARDOCTAG],relevance:10}),hljs.COMMENT("^__END__","\\n$")],SUBST={className:"subst",begin:"#\\{",end:"}",keywords:RUBY_KEYWORDS},STRING={className:"string",contains:[hljs.BACKSLASH_ESCAPE,SUBST],variants:[{begin:/'/,end:/'/},{begin:/"/,end:/"/},{begin:/`/,end:/`/},{begin:"%[qQwWx]?\\(",end:"\\)"},{begin:"%[qQwWx]?\\[",end:"\\]"},{begin:"%[qQwWx]?{",end:"}"},{begin:"%[qQwWx]?<",end:">"},{begin:"%[qQwWx]?/",end:"/"},{begin:"%[qQwWx]?%",end:"%"},{begin:"%[qQwWx]?-",end:"-"},{begin:"%[qQwWx]?\\|",end:"\\|"},{begin:/\B\?(\\\d{1,3}|\\x[A-Fa-f0-9]{1,2}|\\u[A-Fa-f0-9]{4}|\\?\S)\b/}]},PARAMS={className:"params",begin:"\\(",end:"\\)",keywords:RUBY_KEYWORDS},RUBY_DEFAULT_CONTAINS=[STRING,IRB_OBJECT,{className:"class",beginKeywords:"class module",end:"$|;",illegal:/=/,contains:[hljs.inherit(hljs.TITLE_MODE,{begin:"[A-Za-z_]\\w*(::\\w+)*(\\?|\\!)?"}),{className:"inheritance",begin:"<\\s*",contains:[{className:"parent",begin:"("+hljs.IDENT_RE+"::)?"+hljs.IDENT_RE}]}].concat(COMMENT_MODES)},{className:"function",beginKeywords:"def",end:"$|;",contains:[hljs.inherit(hljs.TITLE_MODE,{begin:RUBY_METHOD_RE}),PARAMS].concat(COMMENT_MODES)},{className:"constant",begin:"(::)?(\\b[A-Z]\\w*(::)?)+",relevance:0},{className:"symbol",begin:hljs.UNDERSCORE_IDENT_RE+"(\\!|\\?)?:",relevance:0},{className:"symbol",begin:":",contains:[STRING,{begin:RUBY_METHOD_RE}],relevance:0},{className:"number",begin:"(\\b0[0-7_]+)|(\\b0x[0-9a-fA-F_]+)|(\\b[1-9][0-9_]*(\\.[0-9_]+)?)|[0_]\\b",relevance:0},{className:"variable",begin:"(\\$\\W)|((\\$|\\@\\@?)(\\w+))"},{begin:"("+hljs.RE_STARTERS_RE+")\\s*",contains:[IRB_OBJECT,{className:"regexp",contains:[hljs.BACKSLASH_ESCAPE,SUBST],illegal:/\n/,variants:[{begin:"/",end:"/[a-z]*"},{begin:"%r{",end:"}[a-z]*"},{begin:"%r\\(",end:"\\)[a-z]*"},{begin:"%r!",end:"![a-z]*"},{begin:"%r\\[",end:"\\][a-z]*"}]}].concat(COMMENT_MODES),relevance:0}].concat(COMMENT_MODES);SUBST.contains=RUBY_DEFAULT_CONTAINS,PARAMS.contains=RUBY_DEFAULT_CONTAINS;var SIMPLE_PROMPT="[>?]>",DEFAULT_PROMPT="[\\w#]+\\(\\w+\\):\\d+:\\d+>",RVM_PROMPT="(\\w+-)?\\d+\\.\\d+\\.\\d(p\\d+)?[^>]+>",IRB_DEFAULT=[{begin:/^\s*=>/,className:"status",starts:{end:"$",contains:RUBY_DEFAULT_CONTAINS}},{className:"prompt",begin:"^("+SIMPLE_PROMPT+"|"+DEFAULT_PROMPT+"|"+RVM_PROMPT+")",starts:{end:"$",contains:RUBY_DEFAULT_CONTAINS}}];return{aliases:["rb","gemspec","podspec","thor","irb"],keywords:RUBY_KEYWORDS,illegal:/\/\*/,contains:COMMENT_MODES.concat(IRB_DEFAULT).concat(RUBY_DEFAULT_CONTAINS)}}),hljs.registerLanguage("erb",function(hljs){return{subLanguage:"xml",contains:[hljs.COMMENT("<%#","%>"),{begin:"<%[%=-]?",end:"[%-]?%>",subLanguage:"ruby",excludeBegin:!0,excludeEnd:!0}]}}),hljs.registerLanguage("erlang-repl",function(hljs){return{keywords:{special_functions:"spawn spawn_link self",reserved:"after and andalso|10 band begin bnot bor bsl bsr bxor case catch cond div end fun if let not of or orelse|10 query receive rem try when xor"},contains:[{className:"prompt",begin:"^[0-9]+> ",relevance:10},hljs.COMMENT("%","$"),{className:"number",begin:"\\b(\\d+#[a-fA-F0-9]+|\\d+(\\.\\d+)?([eE][-+]?\\d+)?)",relevance:0},hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,{className:"constant",begin:"\\?(::)?([A-Z]\\w*(::)?)+"},{className:"arrow",begin:"->"},{className:"ok",begin:"ok"},{className:"exclamation_mark",begin:"!"},{className:"function_or_atom",begin:"(\\b[a-z'][a-zA-Z0-9_']*:[a-z'][a-zA-Z0-9_']*)|(\\b[a-z'][a-zA-Z0-9_']*)",relevance:0},{className:"variable",begin:"[A-Z][a-zA-Z0-9_']*",relevance:0}]}}),hljs.registerLanguage("erlang",function(hljs){var BASIC_ATOM_RE="[a-z'][a-zA-Z0-9_']*",FUNCTION_NAME_RE="("+BASIC_ATOM_RE+":"+BASIC_ATOM_RE+"|"+BASIC_ATOM_RE+")",ERLANG_RESERVED={keyword:"after and andalso|10 band begin bnot bor bsl bzr bxor case catch cond div end fun if let not of orelse|10 query receive rem try when xor",literal:"false true"},COMMENT=hljs.COMMENT("%","$"),NUMBER={className:"number",begin:"\\b(\\d+#[a-fA-F0-9]+|\\d+(\\.\\d+)?([eE][-+]?\\d+)?)",relevance:0},NAMED_FUN={begin:"fun\\s+"+BASIC_ATOM_RE+"/\\d+"},FUNCTION_CALL={begin:FUNCTION_NAME_RE+"\\(",end:"\\)",returnBegin:!0,relevance:0,contains:[{className:"function_name",begin:FUNCTION_NAME_RE,relevance:0},{begin:"\\(",end:"\\)",endsWithParent:!0,returnEnd:!0,relevance:0}]},TUPLE={className:"tuple",begin:"{",end:"}",relevance:0},VAR1={className:"variable",begin:"\\b_([A-Z][A-Za-z0-9_]*)?",relevance:0},VAR2={className:"variable",begin:"[A-Z][a-zA-Z0-9_]*",relevance:0},RECORD_ACCESS={begin:"#"+hljs.UNDERSCORE_IDENT_RE,relevance:0,returnBegin:!0,contains:[{className:"record_name",begin:"#"+hljs.UNDERSCORE_IDENT_RE,relevance:0},{begin:"{",end:"}",relevance:0}]},BLOCK_STATEMENTS={beginKeywords:"fun receive if try case",end:"end",keywords:ERLANG_RESERVED};BLOCK_STATEMENTS.contains=[COMMENT,NAMED_FUN,hljs.inherit(hljs.APOS_STRING_MODE,{className:""}),BLOCK_STATEMENTS,FUNCTION_CALL,hljs.QUOTE_STRING_MODE,NUMBER,TUPLE,VAR1,VAR2,RECORD_ACCESS];var BASIC_MODES=[COMMENT,NAMED_FUN,BLOCK_STATEMENTS,FUNCTION_CALL,hljs.QUOTE_STRING_MODE,NUMBER,TUPLE,VAR1,VAR2,RECORD_ACCESS];FUNCTION_CALL.contains[1].contains=BASIC_MODES,TUPLE.contains=BASIC_MODES,RECORD_ACCESS.contains[1].contains=BASIC_MODES;var PARAMS={className:"params",begin:"\\(",end:"\\)",contains:BASIC_MODES};return{aliases:["erl"],keywords:ERLANG_RESERVED,illegal:"(</|\\*=|\\+=|-=|/\\*|\\*/|\\(\\*|\\*\\))",contains:[{className:"function",begin:"^"+BASIC_ATOM_RE+"\\s*\\(",end:"->",returnBegin:!0,illegal:"\\(|#|//|/\\*|\\\\|:|;",contains:[PARAMS,hljs.inherit(hljs.TITLE_MODE,{begin:BASIC_ATOM_RE})],starts:{end:";|\\.",keywords:ERLANG_RESERVED,contains:BASIC_MODES}},COMMENT,{className:"pp",begin:"^-",end:"\\.",relevance:0,excludeEnd:!0,returnBegin:!0,lexemes:"-"+hljs.IDENT_RE,keywords:"-module -record -undef -export -ifdef -ifndef -author -copyright -doc -vsn -import -include -include_lib -compile -define -else -endif -file -behaviour -behavior -spec",contains:[PARAMS]},NUMBER,hljs.QUOTE_STRING_MODE,RECORD_ACCESS,VAR1,VAR2,TUPLE,{begin:/\.$/}]}}),hljs.registerLanguage("fix",function(hljs){return{contains:[{begin:/[^\u2401\u0001]+/,end:/[\u2401\u0001]/,excludeEnd:!0,returnBegin:!0,returnEnd:!1,contains:[{begin:/([^\u2401\u0001=]+)/,end:/=([^\u2401\u0001=]+)/,returnEnd:!0,returnBegin:!1,className:"attribute"},{begin:/=/,end:/([\u2401\u0001])/,excludeEnd:!0,excludeBegin:!0,className:"string"}]}],case_insensitive:!0}}),hljs.registerLanguage("fortran",function(hljs){var PARAMS={className:"params",begin:"\\(",end:"\\)"},F_KEYWORDS={constant:".False. .True.",type:"integer real character complex logical dimension allocatable|10 parameter external implicit|10 none double precision assign intent optional pointer target in out common equivalence data",keyword:"kind do while private call intrinsic where elsewhere type endtype endmodule endselect endinterface end enddo endif if forall endforall only contains default return stop then public subroutine|10 function program .and. .or. .not. .le. .eq. .ge. .gt. .lt. goto save else use module select case access blank direct exist file fmt form formatted iostat name named nextrec number opened rec recl sequential status unformatted unit continue format pause cycle exit c_null_char c_alert c_backspace c_form_feed flush wait decimal round iomsg synchronous nopass non_overridable pass protected volatile abstract extends import non_intrinsic value deferred generic final enumerator class associate bind enum c_int c_short c_long c_long_long c_signed_char c_size_t c_int8_t c_int16_t c_int32_t c_int64_t c_int_least8_t c_int_least16_t c_int_least32_t c_int_least64_t c_int_fast8_t c_int_fast16_t c_int_fast32_t c_int_fast64_t c_intmax_t C_intptr_t c_float c_double c_long_double c_float_complex c_double_complex c_long_double_complex c_bool c_char c_null_ptr c_null_funptr c_new_line c_carriage_return c_horizontal_tab c_vertical_tab iso_c_binding c_loc c_funloc c_associated  c_f_pointer c_ptr c_funptr iso_fortran_env character_storage_size error_unit file_storage_size input_unit iostat_end iostat_eor numeric_storage_size output_unit c_f_procpointer ieee_arithmetic ieee_support_underflow_control ieee_get_underflow_mode ieee_set_underflow_mode newunit contiguous recursive pad position action delim readwrite eor advance nml interface procedure namelist include sequence elemental pure",built_in:"alog alog10 amax0 amax1 amin0 amin1 amod cabs ccos cexp clog csin csqrt dabs dacos dasin datan datan2 dcos dcosh ddim dexp dint dlog dlog10 dmax1 dmin1 dmod dnint dsign dsin dsinh dsqrt dtan dtanh float iabs idim idint idnint ifix isign max0 max1 min0 min1 sngl algama cdabs cdcos cdexp cdlog cdsin cdsqrt cqabs cqcos cqexp cqlog cqsin cqsqrt dcmplx dconjg derf derfc dfloat dgamma dimag dlgama iqint qabs qacos qasin qatan qatan2 qcmplx qconjg qcos qcosh qdim qerf qerfc qexp qgamma qimag qlgama qlog qlog10 qmax1 qmin1 qmod qnint qsign qsin qsinh qsqrt qtan qtanh abs acos aimag aint anint asin atan atan2 char cmplx conjg cos cosh exp ichar index int log log10 max min nint sign sin sinh sqrt tan tanh print write dim lge lgt lle llt mod nullify allocate deallocate adjustl adjustr all allocated any associated bit_size btest ceiling count cshift date_and_time digits dot_product eoshift epsilon exponent floor fraction huge iand ibclr ibits ibset ieor ior ishft ishftc lbound len_trim matmul maxexponent maxloc maxval merge minexponent minloc minval modulo mvbits nearest pack present product radix random_number random_seed range repeat reshape rrspacing scale scan selected_int_kind selected_real_kind set_exponent shape size spacing spread sum system_clock tiny transpose trim ubound unpack verify achar iachar transfer dble entry dprod cpu_time command_argument_count get_command get_command_argument get_environment_variable is_iostat_end ieee_arithmetic ieee_support_underflow_control ieee_get_underflow_mode ieee_set_underflow_mode is_iostat_eor move_alloc new_line selected_char_kind same_type_as extends_type_ofacosh asinh atanh bessel_j0 bessel_j1 bessel_jn bessel_y0 bessel_y1 bessel_yn erf erfc erfc_scaled gamma log_gamma hypot norm2 atomic_define atomic_ref execute_command_line leadz trailz storage_size merge_bits bge bgt ble blt dshiftl dshiftr findloc iall iany iparity image_index lcobound ucobound maskl maskr num_images parity popcnt poppar shifta shiftl shiftr this_image"};return{case_insensitive:!0,aliases:["f90","f95"],keywords:F_KEYWORDS,illegal:/\/\*/,contains:[hljs.inherit(hljs.APOS_STRING_MODE,{className:"string",relevance:0}),hljs.inherit(hljs.QUOTE_STRING_MODE,{className:"string",relevance:0}),{className:"function",beginKeywords:"subroutine function program",illegal:"[${=\\n]",contains:[hljs.UNDERSCORE_TITLE_MODE,PARAMS]},hljs.COMMENT("!","$",{relevance:0}),{className:"number",begin:"(?=\\b|\\+|\\-|\\.)(?=\\.\\d|\\d)(?:\\d+)?(?:\\.?\\d*)(?:[de][+-]?\\d+)?\\b\\.?",relevance:0}]}}),hljs.registerLanguage("fsharp",function(hljs){var TYPEPARAM={begin:"<",end:">",contains:[hljs.inherit(hljs.TITLE_MODE,{begin:/'[a-zA-Z0-9_]+/})]};return{aliases:["fs"],keywords:"abstract and as assert base begin class default delegate do done downcast downto elif else end exception extern false finally for fun function global if in inherit inline interface internal lazy let match member module mutable namespace new null of open or override private public rec return sig static struct then to true try type upcast use val void when while with yield",illegal:/\/\*/,contains:[{className:"keyword",begin:/\b(yield|return|let|do)!/},{className:"string",begin:'@"',end:'"',contains:[{begin:'""'}]},{className:"string",begin:'"""',end:'"""'},hljs.COMMENT("\\(\\*","\\*\\)"),{className:"class",beginKeywords:"type",end:"\\(|=|$",excludeEnd:!0,contains:[hljs.UNDERSCORE_TITLE_MODE,TYPEPARAM]},{className:"annotation",begin:"\\[<",end:">\\]",relevance:10},{className:"attribute",begin:"\\B('[A-Za-z])\\b",contains:[hljs.BACKSLASH_ESCAPE]},hljs.C_LINE_COMMENT_MODE,hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null}),hljs.C_NUMBER_MODE]}}),hljs.registerLanguage("gams",function(hljs){var KEYWORDS="abort acronym acronyms alias all and assign binary card diag display else1 eps eq equation equations file files for1 free ge gt if inf integer le loop lt maximizing minimizing model models na ne negative no not option options or ord parameter parameters positive prod putpage puttl repeat sameas scalar scalars semicont semiint set1 sets smax smin solve sos1 sos2 sum system table then until using variable variables while1 xor yes";return{aliases:["gms"],case_insensitive:!0,keywords:KEYWORDS,contains:[{className:"section",beginKeywords:"sets parameters variables equations",end:";",contains:[{begin:"/",end:"/",contains:[hljs.NUMBER_MODE]}]},{className:"string",begin:"\\*{3}",end:"\\*{3}"},hljs.NUMBER_MODE,{className:"number",begin:"\\$[a-zA-Z0-9]+"}]}}),hljs.registerLanguage("gcode",function(hljs){var GCODE_IDENT_RE="[A-Z_][A-Z0-9_.]*",GCODE_CLOSE_RE="\\%",GCODE_KEYWORDS={literal:"",built_in:"",keyword:"IF DO WHILE ENDWHILE CALL ENDIF SUB ENDSUB GOTO REPEAT ENDREPEAT EQ LT GT NE GE LE OR XOR"},GCODE_START={className:"preprocessor",begin:"([O])([0-9]+)"},GCODE_CODE=[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.COMMENT(/\(/,/\)/),hljs.inherit(hljs.C_NUMBER_MODE,{begin:"([-+]?([0-9]*\\.?[0-9]+\\.?))|"+hljs.C_NUMBER_RE}),hljs.inherit(hljs.APOS_STRING_MODE,{illegal:null}),hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null}),{className:"keyword",begin:"([G])([0-9]+\\.?[0-9]?)"},{className:"title",begin:"([M])([0-9]+\\.?[0-9]?)"},{className:"title",begin:"(VC|VS|#)",end:"(\\d+)"},{className:"title",begin:"(VZOFX|VZOFY|VZOFZ)"},{className:"built_in",begin:"(ATAN|ABS|ACOS|ASIN|SIN|COS|EXP|FIX|FUP|ROUND|LN|TAN)(\\[)",end:"([-+]?([0-9]*\\.?[0-9]+\\.?))(\\])"},{className:"label",variants:[{begin:"N",end:"\\d+",illegal:"\\W"}]}];return{aliases:["nc"],case_insensitive:!0,lexemes:GCODE_IDENT_RE,keywords:GCODE_KEYWORDS,contains:[{className:"preprocessor",begin:GCODE_CLOSE_RE},GCODE_START].concat(GCODE_CODE)}}),hljs.registerLanguage("gherkin",function(hljs){return{aliases:["feature"],keywords:"Feature Background Ability Business Need Scenario Scenarios Scenario Outline Scenario Template Examples Given And Then But When",contains:[{className:"keyword",begin:"\\*"},hljs.COMMENT("@[^@\r\n	 ]+","$"),{begin:"\\|",end:"\\|\\w*$",contains:[{className:"string",begin:"[^|]+"}]},{className:"variable",begin:"<",end:">"},hljs.HASH_COMMENT_MODE,{className:"string",begin:'"""',end:'"""'},hljs.QUOTE_STRING_MODE]}}),hljs.registerLanguage("glsl",function(hljs){return{keywords:{keyword:"atomic_uint attribute bool break bvec2 bvec3 bvec4 case centroid coherent const continue default discard dmat2 dmat2x2 dmat2x3 dmat2x4 dmat3 dmat3x2 dmat3x3 dmat3x4 dmat4 dmat4x2 dmat4x3 dmat4x4 do double dvec2 dvec3 dvec4 else flat float for highp if iimage1D iimage1DArray iimage2D iimage2DArray iimage2DMS iimage2DMSArray iimage2DRect iimage3D iimageBuffer iimageCube iimageCubeArray image1D image1DArray image2D image2DArray image2DMS image2DMSArray image2DRect image3D imageBuffer imageCube imageCubeArray in inout int invariant isampler1D isampler1DArray isampler2D isampler2DArray isampler2DMS isampler2DMSArray isampler2DRect isampler3D isamplerBuffer isamplerCube isamplerCubeArray ivec2 ivec3 ivec4 layout lowp mat2 mat2x2 mat2x3 mat2x4 mat3 mat3x2 mat3x3 mat3x4 mat4 mat4x2 mat4x3 mat4x4 mediump noperspective out patch precision readonly restrict return sample sampler1D sampler1DArray sampler1DArrayShadow sampler1DShadow sampler2D sampler2DArray sampler2DArrayShadow sampler2DMS sampler2DMSArray sampler2DRect sampler2DRectShadow sampler2DShadow sampler3D samplerBuffer samplerCube samplerCubeArray samplerCubeArrayShadow samplerCubeShadow smooth struct subroutine switch uimage1D uimage1DArray uimage2D uimage2DArray uimage2DMS uimage2DMSArray uimage2DRect uimage3D uimageBuffer uimageCube uimageCubeArray uint uniform usampler1D usampler1DArray usampler2D usampler2DArray usampler2DMS usampler2DMSArray usampler2DRect usampler3D usamplerBuffer usamplerCube usamplerCubeArray uvec2 uvec3 uvec4 varying vec2 vec3 vec4 void volatile while writeonly",
built_in:"gl_BackColor gl_BackLightModelProduct gl_BackLightProduct gl_BackMaterial gl_BackSecondaryColor gl_ClipDistance gl_ClipPlane gl_ClipVertex gl_Color gl_DepthRange gl_EyePlaneQ gl_EyePlaneR gl_EyePlaneS gl_EyePlaneT gl_Fog gl_FogCoord gl_FogFragCoord gl_FragColor gl_FragCoord gl_FragData gl_FragDepth gl_FrontColor gl_FrontFacing gl_FrontLightModelProduct gl_FrontLightProduct gl_FrontMaterial gl_FrontSecondaryColor gl_InstanceID gl_InvocationID gl_Layer gl_LightModel gl_LightSource gl_MaxAtomicCounterBindings gl_MaxAtomicCounterBufferSize gl_MaxClipDistances gl_MaxClipPlanes gl_MaxCombinedAtomicCounterBuffers gl_MaxCombinedAtomicCounters gl_MaxCombinedImageUniforms gl_MaxCombinedImageUnitsAndFragmentOutputs gl_MaxCombinedTextureImageUnits gl_MaxDrawBuffers gl_MaxFragmentAtomicCounterBuffers gl_MaxFragmentAtomicCounters gl_MaxFragmentImageUniforms gl_MaxFragmentInputComponents gl_MaxFragmentUniformComponents gl_MaxFragmentUniformVectors gl_MaxGeometryAtomicCounterBuffers gl_MaxGeometryAtomicCounters gl_MaxGeometryImageUniforms gl_MaxGeometryInputComponents gl_MaxGeometryOutputComponents gl_MaxGeometryOutputVertices gl_MaxGeometryTextureImageUnits gl_MaxGeometryTotalOutputComponents gl_MaxGeometryUniformComponents gl_MaxGeometryVaryingComponents gl_MaxImageSamples gl_MaxImageUnits gl_MaxLights gl_MaxPatchVertices gl_MaxProgramTexelOffset gl_MaxTessControlAtomicCounterBuffers gl_MaxTessControlAtomicCounters gl_MaxTessControlImageUniforms gl_MaxTessControlInputComponents gl_MaxTessControlOutputComponents gl_MaxTessControlTextureImageUnits gl_MaxTessControlTotalOutputComponents gl_MaxTessControlUniformComponents gl_MaxTessEvaluationAtomicCounterBuffers gl_MaxTessEvaluationAtomicCounters gl_MaxTessEvaluationImageUniforms gl_MaxTessEvaluationInputComponents gl_MaxTessEvaluationOutputComponents gl_MaxTessEvaluationTextureImageUnits gl_MaxTessEvaluationUniformComponents gl_MaxTessGenLevel gl_MaxTessPatchComponents gl_MaxTextureCoords gl_MaxTextureImageUnits gl_MaxTextureUnits gl_MaxVaryingComponents gl_MaxVaryingFloats gl_MaxVaryingVectors gl_MaxVertexAtomicCounterBuffers gl_MaxVertexAtomicCounters gl_MaxVertexAttribs gl_MaxVertexImageUniforms gl_MaxVertexOutputComponents gl_MaxVertexTextureImageUnits gl_MaxVertexUniformComponents gl_MaxVertexUniformVectors gl_MaxViewports gl_MinProgramTexelOffsetgl_ModelViewMatrix gl_ModelViewMatrixInverse gl_ModelViewMatrixInverseTranspose gl_ModelViewMatrixTranspose gl_ModelViewProjectionMatrix gl_ModelViewProjectionMatrixInverse gl_ModelViewProjectionMatrixInverseTranspose gl_ModelViewProjectionMatrixTranspose gl_MultiTexCoord0 gl_MultiTexCoord1 gl_MultiTexCoord2 gl_MultiTexCoord3 gl_MultiTexCoord4 gl_MultiTexCoord5 gl_MultiTexCoord6 gl_MultiTexCoord7 gl_Normal gl_NormalMatrix gl_NormalScale gl_ObjectPlaneQ gl_ObjectPlaneR gl_ObjectPlaneS gl_ObjectPlaneT gl_PatchVerticesIn gl_PerVertex gl_Point gl_PointCoord gl_PointSize gl_Position gl_PrimitiveID gl_PrimitiveIDIn gl_ProjectionMatrix gl_ProjectionMatrixInverse gl_ProjectionMatrixInverseTranspose gl_ProjectionMatrixTranspose gl_SampleID gl_SampleMask gl_SampleMaskIn gl_SamplePosition gl_SecondaryColor gl_TessCoord gl_TessLevelInner gl_TessLevelOuter gl_TexCoord gl_TextureEnvColor gl_TextureMatrixInverseTranspose gl_TextureMatrixTranspose gl_Vertex gl_VertexID gl_ViewportIndex gl_in gl_out EmitStreamVertex EmitVertex EndPrimitive EndStreamPrimitive abs acos acosh all any asin asinh atan atanh atomicCounter atomicCounterDecrement atomicCounterIncrement barrier bitCount bitfieldExtract bitfieldInsert bitfieldReverse ceil clamp cos cosh cross dFdx dFdy degrees determinant distance dot equal exp exp2 faceforward findLSB findMSB floatBitsToInt floatBitsToUint floor fma fract frexp ftransform fwidth greaterThan greaterThanEqual imageAtomicAdd imageAtomicAnd imageAtomicCompSwap imageAtomicExchange imageAtomicMax imageAtomicMin imageAtomicOr imageAtomicXor imageLoad imageStore imulExtended intBitsToFloat interpolateAtCentroid interpolateAtOffset interpolateAtSample inverse inversesqrt isinf isnan ldexp length lessThan lessThanEqual log log2 matrixCompMult max memoryBarrier min mix mod modf noise1 noise2 noise3 noise4 normalize not notEqual outerProduct packDouble2x32 packHalf2x16 packSnorm2x16 packSnorm4x8 packUnorm2x16 packUnorm4x8 pow radians reflect refract round roundEven shadow1D shadow1DLod shadow1DProj shadow1DProjLod shadow2D shadow2DLod shadow2DProj shadow2DProjLod sign sin sinh smoothstep sqrt step tan tanh texelFetch texelFetchOffset texture texture1D texture1DLod texture1DProj texture1DProjLod texture2D texture2DLod texture2DProj texture2DProjLod texture3D texture3DLod texture3DProj texture3DProjLod textureCube textureCubeLod textureGather textureGatherOffset textureGatherOffsets textureGrad textureGradOffset textureLod textureLodOffset textureOffset textureProj textureProjGrad textureProjGradOffset textureProjLod textureProjLodOffset textureProjOffset textureQueryLod textureSize transpose trunc uaddCarry uintBitsToFloat umulExtended unpackDouble2x32 unpackHalf2x16 unpackSnorm2x16 unpackSnorm4x8 unpackUnorm2x16 unpackUnorm4x8 usubBorrow gl_TextureMatrix gl_TextureMatrixInverse",literal:"true false"},illegal:'"',contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.C_NUMBER_MODE,{className:"preprocessor",begin:"#",end:"$"}]}}),hljs.registerLanguage("go",function(hljs){var GO_KEYWORDS={keyword:"break default func interface select case map struct chan else goto package switch const fallthrough if range type continue for import return var go defer",constant:"true false iota nil",typename:"bool byte complex64 complex128 float32 float64 int8 int16 int32 int64 string uint8 uint16 uint32 uint64 int uint uintptr rune",built_in:"append cap close complex copy imag len make new panic print println real recover delete"};return{aliases:["golang"],keywords:GO_KEYWORDS,illegal:"</",contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.QUOTE_STRING_MODE,{className:"string",begin:"'",end:"[^\\\\]'"},{className:"string",begin:"`",end:"`"},{className:"number",begin:hljs.C_NUMBER_RE+"[dflsi]?",relevance:0},hljs.C_NUMBER_MODE]}}),hljs.registerLanguage("golo",function(hljs){return{keywords:{keyword:"println readln print import module function local return let var while for foreach times in case when match with break continue augment augmentation each find filter reduce if then else otherwise try catch finally raise throw orIfNull",typename:"DynamicObject|10 DynamicVariable struct Observable map set vector list array",literal:"true false null"},contains:[hljs.HASH_COMMENT_MODE,hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE,{className:"annotation",begin:"@[A-Za-z]+"}]}}),hljs.registerLanguage("gradle",function(hljs){return{case_insensitive:!0,keywords:{keyword:"task project allprojects subprojects artifacts buildscript configurations dependencies repositories sourceSets description delete from into include exclude source classpath destinationDir includes options sourceCompatibility targetCompatibility group flatDir doLast doFirst flatten todir fromdir ant def abstract break case catch continue default do else extends final finally for if implements instanceof native new private protected public return static switch synchronized throw throws transient try volatile while strictfp package import false null super this true antlrtask checkstyle codenarc copy boolean byte char class double float int interface long short void compile runTime file fileTree abs any append asList asWritable call collect compareTo count div dump each eachByte eachFile eachLine every find findAll flatten getAt getErr getIn getOut getText grep immutable inject inspect intersect invokeMethods isCase join leftShift minus multiply newInputStream newOutputStream newPrintWriter newReader newWriter next plus pop power previous print println push putAt read readBytes readLines reverse reverseEach round size sort splitEachLine step subMap times toInteger toList tokenize upto waitForOrKill withPrintWriter withReader withStream withWriter withWriterAppend write writeLine"},contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.NUMBER_MODE,hljs.REGEXP_MODE]}}),hljs.registerLanguage("groovy",function(hljs){return{keywords:{typename:"byte short char int long boolean float double void",literal:"true false null",keyword:"def as in assert trait super this abstract static volatile transient public private protected synchronized final class interface enum if else for while switch case break default continue throw throws try catch finally implements extends new import package return instanceof"},contains:[hljs.COMMENT("/\\*\\*","\\*/",{relevance:0,contains:[{className:"doctag",begin:"@[A-Za-z]+"}]}),hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,{className:"string",begin:'"""',end:'"""'},{className:"string",begin:"'''",end:"'''"},{className:"string",begin:"\\$/",end:"/\\$",relevance:10},hljs.APOS_STRING_MODE,{className:"regexp",begin:/~?\/[^\/\n]+\//,contains:[hljs.BACKSLASH_ESCAPE]},hljs.QUOTE_STRING_MODE,{className:"shebang",begin:"^#!/usr/bin/env",end:"$",illegal:"\n"},hljs.BINARY_NUMBER_MODE,{className:"class",beginKeywords:"class interface trait enum",end:"{",illegal:":",contains:[{beginKeywords:"extends implements"},hljs.UNDERSCORE_TITLE_MODE]},hljs.C_NUMBER_MODE,{className:"annotation",begin:"@[A-Za-z]+"},{className:"string",begin:/[^\?]{0}[A-Za-z0-9_$]+ *:/},{begin:/\?/,end:/\:/},{className:"label",begin:"^\\s*[A-Za-z0-9_$]+:",relevance:0}],illegal:/#/}}),hljs.registerLanguage("haml",function(hljs){return{case_insensitive:!0,contains:[{className:"doctype",begin:"^!!!( (5|1\\.1|Strict|Frameset|Basic|Mobile|RDFa|XML\\b.*))?$",relevance:10},hljs.COMMENT("^\\s*(!=#|=#|-#|/).*$",!1,{relevance:0}),{begin:"^\\s*(-|=|!=)(?!#)",starts:{end:"\\n",subLanguage:"ruby"}},{className:"tag",begin:"^\\s*%",contains:[{className:"title",begin:"\\w+"},{className:"value",begin:"[#\\.][\\w-]+"},{begin:"{\\s*",end:"\\s*}",excludeEnd:!0,contains:[{begin:":\\w+\\s*=>",end:",\\s+",returnBegin:!0,endsWithParent:!0,contains:[{className:"symbol",begin:":\\w+"},hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,{begin:"\\w+",relevance:0}]}]},{begin:"\\(\\s*",end:"\\s*\\)",excludeEnd:!0,contains:[{begin:"\\w+\\s*=",end:"\\s+",returnBegin:!0,endsWithParent:!0,contains:[{className:"attribute",begin:"\\w+",relevance:0},hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,{begin:"\\w+",relevance:0}]}]}]},{className:"bullet",begin:"^\\s*[=~]\\s*",relevance:0},{begin:"#{",starts:{end:"}",subLanguage:"ruby"}}]}}),hljs.registerLanguage("handlebars",function(hljs){var EXPRESSION_KEYWORDS="each in with if else unless bindattr action collection debugger log outlet template unbound view yield";return{aliases:["hbs","html.hbs","html.handlebars"],case_insensitive:!0,subLanguage:"xml",contains:[{className:"expression",begin:"{{",end:"}}",contains:[{className:"begin-block",begin:"#[a-zA-Z- .]+",keywords:EXPRESSION_KEYWORDS},{className:"string",begin:'"',end:'"'},{className:"end-block",begin:"\\/[a-zA-Z- .]+",keywords:EXPRESSION_KEYWORDS},{className:"variable",begin:"[a-zA-Z-.]+",keywords:EXPRESSION_KEYWORDS}]}]}}),hljs.registerLanguage("haskell",function(hljs){var COMMENT_MODES=[hljs.COMMENT("--","$"),hljs.COMMENT("{-","-}",{contains:["self"]})],PRAGMA={className:"pragma",begin:"{-#",end:"#-}"},PREPROCESSOR={className:"preprocessor",begin:"^#",end:"$"},CONSTRUCTOR={className:"type",begin:"\\b[A-Z][\\w']*",relevance:0},LIST={className:"container",begin:"\\(",end:"\\)",illegal:'"',contains:[PRAGMA,PREPROCESSOR,{className:"type",begin:"\\b[A-Z][\\w]*(\\((\\.\\.|,|\\w+)\\))?"},hljs.inherit(hljs.TITLE_MODE,{begin:"[_a-z][\\w']*"})].concat(COMMENT_MODES)},RECORD={className:"container",begin:"{",end:"}",contains:LIST.contains};return{aliases:["hs"],keywords:"let in if then else case of where do module import hiding qualified type data newtype deriving class instance as default infix infixl infixr foreign export ccall stdcall cplusplus jvm dotnet safe unsafe family forall mdo proc rec",contains:[{className:"module",begin:"\\bmodule\\b",end:"where",keywords:"module where",contains:[LIST].concat(COMMENT_MODES),illegal:"\\W\\.|;"},{className:"import",begin:"\\bimport\\b",end:"$",keywords:"import|0 qualified as hiding",contains:[LIST].concat(COMMENT_MODES),illegal:"\\W\\.|;"},{className:"class",begin:"^(\\s*)?(class|instance)\\b",end:"where",keywords:"class family instance where",contains:[CONSTRUCTOR,LIST].concat(COMMENT_MODES)},{className:"typedef",begin:"\\b(data|(new)?type)\\b",end:"$",keywords:"data family type newtype deriving",contains:[PRAGMA,CONSTRUCTOR,LIST,RECORD].concat(COMMENT_MODES)},{className:"default",beginKeywords:"default",end:"$",contains:[CONSTRUCTOR,LIST].concat(COMMENT_MODES)},{className:"infix",beginKeywords:"infix infixl infixr",end:"$",contains:[hljs.C_NUMBER_MODE].concat(COMMENT_MODES)},{className:"foreign",begin:"\\bforeign\\b",end:"$",keywords:"foreign import export ccall stdcall cplusplus jvm dotnet safe unsafe",contains:[CONSTRUCTOR,hljs.QUOTE_STRING_MODE].concat(COMMENT_MODES)},{className:"shebang",begin:"#!\\/usr\\/bin\\/env runhaskell",end:"$"},PRAGMA,PREPROCESSOR,hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE,CONSTRUCTOR,hljs.inherit(hljs.TITLE_MODE,{begin:"^[_a-z][\\w']*"}),{begin:"->|<-"}].concat(COMMENT_MODES)}}),hljs.registerLanguage("haxe",function(hljs){var IDENT_FUNC_RETURN_TYPE_RE="([*]|[a-zA-Z_$][a-zA-Z0-9_$]*)";return{aliases:["hx"],keywords:{keyword:"break callback case cast catch class continue default do dynamic else enum extends extern for function here if implements import in inline interface never new override package private public return static super switch this throw trace try typedef untyped using var while",literal:"true false null"},contains:[hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.C_NUMBER_MODE,{className:"class",beginKeywords:"class interface",end:"{",excludeEnd:!0,contains:[{beginKeywords:"extends implements"},hljs.TITLE_MODE]},{className:"preprocessor",begin:"#",end:"$",keywords:"if else elseif end error"},{className:"function",beginKeywords:"function",end:"[{;]",excludeEnd:!0,illegal:"\\S",contains:[hljs.TITLE_MODE,{className:"params",begin:"\\(",end:"\\)",contains:[hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE]},{className:"type",begin:":",end:IDENT_FUNC_RETURN_TYPE_RE,relevance:10}]}]}}),hljs.registerLanguage("http",function(hljs){return{aliases:["https"],illegal:"\\S",contains:[{className:"status",begin:"^HTTP/[0-9\\.]+",end:"$",contains:[{className:"number",begin:"\\b\\d{3}\\b"}]},{className:"request",begin:"^[A-Z]+ (.*?) HTTP/[0-9\\.]+$",returnBegin:!0,end:"$",contains:[{className:"string",begin:" ",end:" ",excludeBegin:!0,excludeEnd:!0}]},{className:"attribute",begin:"^\\w",end:": ",excludeEnd:!0,illegal:"\\n|\\s|=",starts:{className:"string",end:"$"}},{begin:"\\n\\n",starts:{subLanguage:[],endsWithParent:!0}}]}}),hljs.registerLanguage("inform7",function(hljs){var START_BRACKET="\\[",END_BRACKET="\\]";return{aliases:["i7"],case_insensitive:!0,keywords:{keyword:"thing room person man woman animal container supporter backdrop door scenery open closed locked inside gender is are say understand kind of rule"},contains:[{className:"string",begin:'"',end:'"',relevance:0,contains:[{className:"subst",begin:START_BRACKET,end:END_BRACKET}]},{className:"title",begin:/^(Volume|Book|Part|Chapter|Section|Table)\b/,end:"$"},{begin:/^(Check|Carry out|Report|Instead of|To|Rule|When|Before|After)\b/,end:":",contains:[{begin:"\\b\\(This",end:"\\)"}]},{className:"comment",begin:START_BRACKET,end:END_BRACKET,contains:["self"]}]}}),hljs.registerLanguage("ini",function(hljs){var STRING={className:"string",contains:[hljs.BACKSLASH_ESCAPE],variants:[{begin:"'''",end:"'''",relevance:10},{begin:'"""',end:'"""',relevance:10},{begin:'"',end:'"'},{begin:"'",end:"'"}]};return{aliases:["toml"],case_insensitive:!0,illegal:/\S/,contains:[hljs.COMMENT(";","$"),hljs.HASH_COMMENT_MODE,{className:"title",begin:/^\s*\[+/,end:/\]+/},{className:"setting",begin:/^[a-z0-9\[\]_-]+\s*=\s*/,end:"$",contains:[{className:"value",endsWithParent:!0,keywords:"on off true false yes no",contains:[{className:"variable",variants:[{begin:/\$[\w\d"][\w\d_]*/},{begin:/\$\{(.*?)}/}]},STRING,{className:"number",begin:/([\+\-]+)?[\d]+_[\d_]+/},hljs.NUMBER_MODE],relevance:0}]}]}}),hljs.registerLanguage("irpf90",function(hljs){var PARAMS={className:"params",begin:"\\(",end:"\\)"},F_KEYWORDS={constant:".False. .True.",type:"integer real character complex logical dimension allocatable|10 parameter external implicit|10 none double precision assign intent optional pointer target in out common equivalence data",keyword:"kind do while private call intrinsic where elsewhere type endtype endmodule endselect endinterface end enddo endif if forall endforall only contains default return stop then public subroutine|10 function program .and. .or. .not. .le. .eq. .ge. .gt. .lt. goto save else use module select case access blank direct exist file fmt form formatted iostat name named nextrec number opened rec recl sequential status unformatted unit continue format pause cycle exit c_null_char c_alert c_backspace c_form_feed flush wait decimal round iomsg synchronous nopass non_overridable pass protected volatile abstract extends import non_intrinsic value deferred generic final enumerator class associate bind enum c_int c_short c_long c_long_long c_signed_char c_size_t c_int8_t c_int16_t c_int32_t c_int64_t c_int_least8_t c_int_least16_t c_int_least32_t c_int_least64_t c_int_fast8_t c_int_fast16_t c_int_fast32_t c_int_fast64_t c_intmax_t C_intptr_t c_float c_double c_long_double c_float_complex c_double_complex c_long_double_complex c_bool c_char c_null_ptr c_null_funptr c_new_line c_carriage_return c_horizontal_tab c_vertical_tab iso_c_binding c_loc c_funloc c_associated  c_f_pointer c_ptr c_funptr iso_fortran_env character_storage_size error_unit file_storage_size input_unit iostat_end iostat_eor numeric_storage_size output_unit c_f_procpointer ieee_arithmetic ieee_support_underflow_control ieee_get_underflow_mode ieee_set_underflow_mode newunit contiguous recursive pad position action delim readwrite eor advance nml interface procedure namelist include sequence elemental pure begin_provider &begin_provider end_provider begin_shell end_shell begin_template end_template subst assert touch soft_touch provide no_dep free irp_if irp_else irp_endif irp_write irp_read",built_in:"alog alog10 amax0 amax1 amin0 amin1 amod cabs ccos cexp clog csin csqrt dabs dacos dasin datan datan2 dcos dcosh ddim dexp dint dlog dlog10 dmax1 dmin1 dmod dnint dsign dsin dsinh dsqrt dtan dtanh float iabs idim idint idnint ifix isign max0 max1 min0 min1 sngl algama cdabs cdcos cdexp cdlog cdsin cdsqrt cqabs cqcos cqexp cqlog cqsin cqsqrt dcmplx dconjg derf derfc dfloat dgamma dimag dlgama iqint qabs qacos qasin qatan qatan2 qcmplx qconjg qcos qcosh qdim qerf qerfc qexp qgamma qimag qlgama qlog qlog10 qmax1 qmin1 qmod qnint qsign qsin qsinh qsqrt qtan qtanh abs acos aimag aint anint asin atan atan2 char cmplx conjg cos cosh exp ichar index int log log10 max min nint sign sin sinh sqrt tan tanh print write dim lge lgt lle llt mod nullify allocate deallocate adjustl adjustr all allocated any associated bit_size btest ceiling count cshift date_and_time digits dot_product eoshift epsilon exponent floor fraction huge iand ibclr ibits ibset ieor ior ishft ishftc lbound len_trim matmul maxexponent maxloc maxval merge minexponent minloc minval modulo mvbits nearest pack present product radix random_number random_seed range repeat reshape rrspacing scale scan selected_int_kind selected_real_kind set_exponent shape size spacing spread sum system_clock tiny transpose trim ubound unpack verify achar iachar transfer dble entry dprod cpu_time command_argument_count get_command get_command_argument get_environment_variable is_iostat_end ieee_arithmetic ieee_support_underflow_control ieee_get_underflow_mode ieee_set_underflow_mode is_iostat_eor move_alloc new_line selected_char_kind same_type_as extends_type_ofacosh asinh atanh bessel_j0 bessel_j1 bessel_jn bessel_y0 bessel_y1 bessel_yn erf erfc erfc_scaled gamma log_gamma hypot norm2 atomic_define atomic_ref execute_command_line leadz trailz storage_size merge_bits bge bgt ble blt dshiftl dshiftr findloc iall iany iparity image_index lcobound ucobound maskl maskr num_images parity popcnt poppar shifta shiftl shiftr this_image IRP_ALIGN irp_here"};return{case_insensitive:!0,keywords:F_KEYWORDS,illegal:/\/\*/,contains:[hljs.inherit(hljs.APOS_STRING_MODE,{className:"string",relevance:0}),hljs.inherit(hljs.QUOTE_STRING_MODE,{className:"string",relevance:0}),{className:"function",beginKeywords:"subroutine function program",illegal:"[${=\\n]",contains:[hljs.UNDERSCORE_TITLE_MODE,PARAMS]},hljs.COMMENT("!","$",{relevance:0}),hljs.COMMENT("begin_doc","end_doc",{relevance:10}),{className:"number",begin:"(?=\\b|\\+|\\-|\\.)(?=\\.\\d|\\d)(?:\\d+)?(?:\\.?\\d*)(?:[de][+-]?\\d+)?\\b\\.?",relevance:0}]}}),hljs.registerLanguage("java",function(hljs){var GENERIC_IDENT_RE=hljs.UNDERSCORE_IDENT_RE+"(<"+hljs.UNDERSCORE_IDENT_RE+">)?",KEYWORDS="false synchronized int abstract float private char boolean static null if const for true while long strictfp finally protected import native final void enum else break transient catch instanceof byte super volatile case assert short package default double public try this switch continue throws protected public private",JAVA_NUMBER_RE="\\b(0[bB]([01]+[01_]+[01]+|[01]+)|0[xX]([a-fA-F0-9]+[a-fA-F0-9_]+[a-fA-F0-9]+|[a-fA-F0-9]+)|(([\\d]+[\\d_]+[\\d]+|[\\d]+)(\\.([\\d]+[\\d_]+[\\d]+|[\\d]+))?|\\.([\\d]+[\\d_]+[\\d]+|[\\d]+))([eE][-+]?\\d+)?)[lLfF]?",JAVA_NUMBER_MODE={className:"number",begin:JAVA_NUMBER_RE,relevance:0};return{aliases:["jsp"],keywords:KEYWORDS,illegal:/<\/|#/,contains:[hljs.COMMENT("/\\*\\*","\\*/",{relevance:0,contains:[{className:"doctag",begin:"@[A-Za-z]+"}]}),hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,{className:"class",beginKeywords:"class interface",end:/[{;=]/,excludeEnd:!0,keywords:"class interface",illegal:/[:"\[\]]/,contains:[{beginKeywords:"extends implements"},hljs.UNDERSCORE_TITLE_MODE]},{beginKeywords:"new throw return else",relevance:0},{className:"function",begin:"("+GENERIC_IDENT_RE+"\\s+)+"+hljs.UNDERSCORE_IDENT_RE+"\\s*\\(",returnBegin:!0,end:/[{;=]/,excludeEnd:!0,keywords:KEYWORDS,contains:[{begin:hljs.UNDERSCORE_IDENT_RE+"\\s*\\(",returnBegin:!0,relevance:0,contains:[hljs.UNDERSCORE_TITLE_MODE]},{className:"params",begin:/\(/,end:/\)/,keywords:KEYWORDS,relevance:0,contains:[hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE,hljs.C_BLOCK_COMMENT_MODE]},hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE]},JAVA_NUMBER_MODE,{className:"annotation",begin:"@[A-Za-z]+"}]}}),hljs.registerLanguage("javascript",function(hljs){return{aliases:["js"],keywords:{keyword:"in of if for while finally var new function do return void else break catch instanceof with throw case default try this switch continue typeof delete let yield const export super debugger as async await",literal:"true false null undefined NaN Infinity",built_in:"eval isFinite isNaN parseFloat parseInt decodeURI decodeURIComponent encodeURI encodeURIComponent escape unescape Object Function Boolean Error EvalError InternalError RangeError ReferenceError StopIteration SyntaxError TypeError URIError Number Math Date String RegExp Array Float32Array Float64Array Int16Array Int32Array Int8Array Uint16Array Uint32Array Uint8Array Uint8ClampedArray ArrayBuffer DataView JSON Intl arguments require module console window document Symbol Set Map WeakSet WeakMap Proxy Reflect Promise"},contains:[{className:"pi",relevance:10,begin:/^\s*['"]use (strict|asm)['"]/},hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,{className:"string",begin:"`",end:"`",contains:[hljs.BACKSLASH_ESCAPE,{className:"subst",begin:"\\$\\{",end:"\\}"}]},hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,{className:"number",variants:[{begin:"\\b(0[bB][01]+)"},{begin:"\\b(0[oO][0-7]+)"},{begin:hljs.C_NUMBER_RE}],relevance:0},{begin:"("+hljs.RE_STARTERS_RE+"|\\b(case|return|throw)\\b)\\s*",keywords:"return throw case",contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.REGEXP_MODE,{begin:/</,end:/>\s*[);\]]/,relevance:0,subLanguage:"xml"}],relevance:0},{className:"function",beginKeywords:"function",end:/\{/,excludeEnd:!0,contains:[hljs.inherit(hljs.TITLE_MODE,{begin:/[A-Za-z$_][0-9A-Za-z$_]*/}),{className:"params",begin:/\(/,end:/\)/,excludeBegin:!0,excludeEnd:!0,contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE]}],illegal:/\[|%/},{begin:/\$[(.]/},{begin:"\\."+hljs.IDENT_RE,relevance:0},{beginKeywords:"import",end:"[;$]",keywords:"import from as",contains:[hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE]},{className:"class",beginKeywords:"class",end:/[{;=]/,excludeEnd:!0,illegal:/[:"\[\]]/,contains:[{beginKeywords:"extends"},hljs.UNDERSCORE_TITLE_MODE]}],illegal:/#/}}),hljs.registerLanguage("json",function(hljs){var LITERALS={literal:"true false null"},TYPES=[hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE],VALUE_CONTAINER={className:"value",end:",",endsWithParent:!0,excludeEnd:!0,contains:TYPES,keywords:LITERALS},OBJECT={begin:"{",end:"}",contains:[{className:"attribute",begin:'\\s*"',end:'"\\s*:\\s*',excludeBegin:!0,excludeEnd:!0,contains:[hljs.BACKSLASH_ESCAPE],illegal:"\\n",starts:VALUE_CONTAINER}],illegal:"\\S"},ARRAY={begin:"\\[",end:"\\]",contains:[hljs.inherit(VALUE_CONTAINER,{className:null})],illegal:"\\S"};return TYPES.splice(TYPES.length,0,OBJECT,ARRAY),{contains:TYPES,keywords:LITERALS,illegal:"\\S"}}),hljs.registerLanguage("julia",function(hljs){var KEYWORDS={keyword:"in abstract baremodule begin bitstype break catch ccall const continue do else elseif end export finally for function global if immutable import importall let local macro module quote return try type typealias using while",literal:"true false ANY ARGS CPU_CORES C_NULL DL_LOAD_PATH DevNull ENDIAN_BOM ENV I|0 Inf Inf16 Inf32 InsertionSort JULIA_HOME LOAD_PATH MS_ASYNC MS_INVALIDATE MS_SYNC MergeSort NaN NaN16 NaN32 OS_NAME QuickSort RTLD_DEEPBIND RTLD_FIRST RTLD_GLOBAL RTLD_LAZY RTLD_LOCAL RTLD_NODELETE RTLD_NOLOAD RTLD_NOW RoundDown RoundFromZero RoundNearest RoundToZero RoundUp STDERR STDIN STDOUT VERSION WORD_SIZE catalan cglobal e|0 eu|0 eulergamma golden im nothing pi γ π φ",built_in:"ASCIIString AbstractArray AbstractRNG AbstractSparseArray Any ArgumentError Array Associative Base64Pipe Bidiagonal BigFloat BigInt BitArray BitMatrix BitVector Bool BoundsError Box CFILE Cchar Cdouble Cfloat Char CharString Cint Clong Clonglong ClusterManager Cmd Coff_t Colon Complex Complex128 Complex32 Complex64 Condition Cptrdiff_t Cshort Csize_t Cssize_t Cuchar Cuint Culong Culonglong Cushort Cwchar_t DArray DataType DenseArray Diagonal Dict DimensionMismatch DirectIndexString Display DivideError DomainError EOFError EachLine Enumerate ErrorException Exception Expr Factorization FileMonitor FileOffset Filter Float16 Float32 Float64 FloatRange FloatingPoint Function GetfieldNode GotoNode Hermitian IO IOBuffer IOStream IPv4 IPv6 InexactError Int Int128 Int16 Int32 Int64 Int8 IntSet Integer InterruptException IntrinsicFunction KeyError LabelNode LambdaStaticData LineNumberNode LoadError LocalProcess MIME MathConst MemoryError MersenneTwister Method MethodError MethodTable Module NTuple NewvarNode Nothing Number ObjectIdDict OrdinalRange OverflowError ParseError PollingFileWatcher ProcessExitedException ProcessGroup Ptr QuoteNode Range Range1 Ranges Rational RawFD Real Regex RegexMatch RemoteRef RepString RevString RopeString RoundingMode Set SharedArray Signed SparseMatrixCSC StackOverflowError Stat StatStruct StepRange String SubArray SubString SymTridiagonal Symbol SymbolNode Symmetric SystemError Task TextDisplay Timer TmStruct TopNode Triangular Tridiagonal Type TypeConstructor TypeError TypeName TypeVar UTF16String UTF32String UTF8String UdpSocket Uint Uint128 Uint16 Uint32 Uint64 Uint8 UndefRefError UndefVarError UniformScaling UnionType UnitRange Unsigned Vararg VersionNumber WString WeakKeyDict WeakRef Woodbury Zip"},VARIABLE_NAME_RE="[A-Za-z_\\u00A1-\\uFFFF][A-Za-z_0-9\\u00A1-\\uFFFF]*",DEFAULT={lexemes:VARIABLE_NAME_RE,keywords:KEYWORDS},TYPE_ANNOTATION={className:"type-annotation",begin:/::/},SUBTYPE={className:"subtype",begin:/<:/},NUMBER={className:"number",begin:/(\b0x[\d_]*(\.[\d_]*)?|0x\.\d[\d_]*)p[-+]?\d+|\b0[box][a-fA-F0-9][a-fA-F0-9_]*|(\b\d[\d_]*(\.[\d_]*)?|\.\d[\d_]*)([eEfF][-+]?\d+)?/,relevance:0},CHAR={className:"char",begin:/'(.|\\[xXuU][a-zA-Z0-9]+)'/},INTERPOLATION={className:"subst",begin:/\$\(/,end:/\)/,keywords:KEYWORDS},INTERPOLATED_VARIABLE={className:"variable",begin:"\\$"+VARIABLE_NAME_RE},STRING={className:"string",contains:[hljs.BACKSLASH_ESCAPE,INTERPOLATION,INTERPOLATED_VARIABLE],variants:[{begin:/\w*"/,end:/"\w*/},{begin:/\w*"""/,end:/"""\w*/}]},COMMAND={className:"string",contains:[hljs.BACKSLASH_ESCAPE,INTERPOLATION,INTERPOLATED_VARIABLE],begin:"`",end:"`"},MACROCALL={className:"macrocall",begin:"@"+VARIABLE_NAME_RE},COMMENT={className:"comment",variants:[{begin:"#=",end:"=#",relevance:10},{begin:"#",end:"$"}]};return DEFAULT.contains=[NUMBER,CHAR,TYPE_ANNOTATION,SUBTYPE,STRING,COMMAND,MACROCALL,COMMENT,hljs.HASH_COMMENT_MODE],INTERPOLATION.contains=DEFAULT.contains,DEFAULT}),hljs.registerLanguage("kotlin",function(hljs){var KEYWORDS="val var get set class trait object public open private protected final enum if else do while for when break continue throw try catch finally import package is as in return fun override default companion reified inline volatile transient native";return{keywords:{typename:"Byte Short Char Int Long Boolean Float Double Void Unit Nothing",literal:"true false null",keyword:KEYWORDS},contains:[hljs.COMMENT("/\\*\\*","\\*/",{relevance:0,contains:[{className:"doctag",begin:"@[A-Za-z]+"}]}),hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,{className:"type",begin:/</,end:/>/,returnBegin:!0,excludeEnd:!1,relevance:0},{className:"function",beginKeywords:"fun",end:"[(]|$",returnBegin:!0,excludeEnd:!0,keywords:KEYWORDS,illegal:/fun\s+(<.*>)?[^\s\(]+(\s+[^\s\(]+)\s*=/,relevance:5,contains:[{begin:hljs.UNDERSCORE_IDENT_RE+"\\s*\\(",returnBegin:!0,relevance:0,contains:[hljs.UNDERSCORE_TITLE_MODE]},{className:"type",begin:/</,end:/>/,keywords:"reified",relevance:0},{className:"params",begin:/\(/,end:/\)/,keywords:KEYWORDS,relevance:0,illegal:/\([^\(,\s:]+,/,contains:[{className:"typename",begin:/:\s*/,end:/\s*[=\)]/,excludeBegin:!0,returnEnd:!0,relevance:0}]},hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE]},{className:"class",beginKeywords:"class trait",end:/[:\{(]|$/,excludeEnd:!0,illegal:"extends implements",contains:[hljs.UNDERSCORE_TITLE_MODE,{className:"type",begin:/</,end:/>/,excludeBegin:!0,excludeEnd:!0,relevance:0},{className:"typename",begin:/[,:]\s*/,end:/[<\(,]|$/,excludeBegin:!0,returnEnd:!0}]},{className:"variable",beginKeywords:"var val",end:/\s*[=:$]/,excludeEnd:!0},hljs.QUOTE_STRING_MODE,{className:"shebang",begin:"^#!/usr/bin/env",end:"$",illegal:"\n"},hljs.C_NUMBER_MODE]}}),hljs.registerLanguage("lasso",function(hljs){var LASSO_IDENT_RE="[a-zA-Z_][a-zA-Z0-9_.]*",LASSO_ANGLE_RE="<\\?(lasso(script)?|=)",LASSO_CLOSE_RE="\\]|\\?>",LASSO_KEYWORDS={literal:"true false none minimal full all void bw nbw ew new cn ncn lt lte gt gte eq neq rx nrx ft",built_in:"array date decimal duration integer map pair string tag xml null boolean bytes keyword list locale queue set stack staticarray local var variable global data self inherited currentcapture givenblock",keyword:"error_code error_msg error_pop error_push error_reset cache database_names database_schemanames database_tablenames define_tag define_type email_batch encode_set html_comment handle handle_error header if inline iterate ljax_target link link_currentaction link_currentgroup link_currentrecord link_detail link_firstgroup link_firstrecord link_lastgroup link_lastrecord link_nextgroup link_nextrecord link_prevgroup link_prevrecord log loop namespace_using output_none portal private protect records referer referrer repeating resultset rows search_args search_arguments select sort_args sort_arguments thread_atomic value_list while abort case else if_empty if_false if_null if_true loop_abort loop_continue loop_count params params_up return return_value run_children soap_definetag soap_lastrequest soap_lastresponse tag_name ascending average by define descending do equals frozen group handle_failure import in into join let match max min on order parent protected provide public require returnhome skip split_thread sum take thread to trait type where with yield yieldhome"
},HTML_COMMENT=hljs.COMMENT("<!--","-->",{relevance:0}),LASSO_NOPROCESS={className:"preprocessor",begin:"\\[noprocess\\]",starts:{className:"markup",end:"\\[/noprocess\\]",returnEnd:!0,contains:[HTML_COMMENT]}},LASSO_START={className:"preprocessor",begin:"\\[/noprocess|"+LASSO_ANGLE_RE},LASSO_DATAMEMBER={className:"variable",begin:"'"+LASSO_IDENT_RE+"'"},LASSO_CODE=[hljs.COMMENT("/\\*\\*!","\\*/"),hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.inherit(hljs.C_NUMBER_MODE,{begin:hljs.C_NUMBER_RE+"|(infinity|nan)\\b"}),hljs.inherit(hljs.APOS_STRING_MODE,{illegal:null}),hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null}),{className:"string",begin:"`",end:"`"},{className:"variable",variants:[{begin:"[#$]"+LASSO_IDENT_RE},{begin:"#",end:"\\d+",illegal:"\\W"}]},{className:"tag",begin:"::\\s*",end:LASSO_IDENT_RE,illegal:"\\W"},{className:"attribute",variants:[{begin:"-(?!infinity)"+hljs.UNDERSCORE_IDENT_RE,relevance:0},{begin:"(\\.\\.\\.)"}]},{className:"subst",variants:[{begin:"->\\s*",contains:[LASSO_DATAMEMBER]},{begin:"->|\\\\|&&?|\\|\\||!(?!=|>)|(and|or|not)\\b",relevance:0}]},{className:"built_in",begin:"\\.\\.?\\s*",relevance:0,contains:[LASSO_DATAMEMBER]},{className:"class",beginKeywords:"define",returnEnd:!0,end:"\\(|=>",contains:[hljs.inherit(hljs.TITLE_MODE,{begin:hljs.UNDERSCORE_IDENT_RE+"(=(?!>))?"})]}];return{aliases:["ls","lassoscript"],case_insensitive:!0,lexemes:LASSO_IDENT_RE+"|&[lg]t;",keywords:LASSO_KEYWORDS,contains:[{className:"preprocessor",begin:LASSO_CLOSE_RE,relevance:0,starts:{className:"markup",end:"\\[|"+LASSO_ANGLE_RE,returnEnd:!0,relevance:0,contains:[HTML_COMMENT]}},LASSO_NOPROCESS,LASSO_START,{className:"preprocessor",begin:"\\[no_square_brackets",starts:{end:"\\[/no_square_brackets\\]",lexemes:LASSO_IDENT_RE+"|&[lg]t;",keywords:LASSO_KEYWORDS,contains:[{className:"preprocessor",begin:LASSO_CLOSE_RE,relevance:0,starts:{className:"markup",end:"\\[noprocess\\]|"+LASSO_ANGLE_RE,returnEnd:!0,contains:[HTML_COMMENT]}},LASSO_NOPROCESS,LASSO_START].concat(LASSO_CODE)}},{className:"preprocessor",begin:"\\[",relevance:0},{className:"shebang",begin:"^#!.+lasso9\\b",relevance:10}].concat(LASSO_CODE)}}),hljs.registerLanguage("less",function(hljs){var IDENT_RE="[\\w-]+",INTERP_IDENT_RE="("+IDENT_RE+"|@{"+IDENT_RE+"})",RULES=[],VALUE=[],STRING_MODE=function(c){return{className:"string",begin:"~?"+c+".*?"+c}},IDENT_MODE=function(name,begin,relevance){return{className:name,begin:begin,relevance:relevance}},FUNCT_MODE=function(name,ident,obj){return hljs.inherit({className:name,begin:ident+"\\(",end:"\\(",returnBegin:!0,excludeEnd:!0,relevance:0},obj)},PARENS_MODE={begin:"\\(",end:"\\)",contains:VALUE,relevance:0};VALUE.push(hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,STRING_MODE("'"),STRING_MODE('"'),hljs.CSS_NUMBER_MODE,IDENT_MODE("hexcolor","#[0-9A-Fa-f]+\\b"),FUNCT_MODE("function","(url|data-uri)",{starts:{className:"string",end:"[\\)\\n]",excludeEnd:!0}}),FUNCT_MODE("function",IDENT_RE),PARENS_MODE,IDENT_MODE("variable","@@?"+IDENT_RE,10),IDENT_MODE("variable","@{"+IDENT_RE+"}"),IDENT_MODE("built_in","~?`[^`]*?`"),{className:"attribute",begin:IDENT_RE+"\\s*:",end:":",returnBegin:!0,excludeEnd:!0});var VALUE_WITH_RULESETS=VALUE.concat({begin:"{",end:"}",contains:RULES}),MIXIN_GUARD_MODE={beginKeywords:"when",endsWithParent:!0,contains:[{beginKeywords:"and not"}].concat(VALUE)},RULE_MODE={className:"attribute",begin:INTERP_IDENT_RE,end:":",excludeEnd:!0,contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE],illegal:/\S/,starts:{end:"[;}]",returnEnd:!0,contains:VALUE,illegal:"[<=$]"}},AT_RULE_MODE={className:"at_rule",begin:"@(import|media|charset|font-face|(-[a-z]+-)?keyframes|supports|document|namespace|page|viewport|host)\\b",starts:{end:"[;{}]",returnEnd:!0,contains:VALUE,relevance:0}},VAR_RULE_MODE={className:"variable",variants:[{begin:"@"+IDENT_RE+"\\s*:",relevance:15},{begin:"@"+IDENT_RE}],starts:{end:"[;}]",returnEnd:!0,contains:VALUE_WITH_RULESETS}},SELECTOR_MODE={variants:[{begin:"[\\.#:&\\[]",end:"[;{}]"},{begin:INTERP_IDENT_RE+"[^;]*{",end:"{"}],returnBegin:!0,returnEnd:!0,illegal:"[<='$\"]",contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,MIXIN_GUARD_MODE,IDENT_MODE("keyword","all\\b"),IDENT_MODE("variable","@{"+IDENT_RE+"}"),IDENT_MODE("tag",INTERP_IDENT_RE+"%?",0),IDENT_MODE("id","#"+INTERP_IDENT_RE),IDENT_MODE("class","\\."+INTERP_IDENT_RE,0),IDENT_MODE("keyword","&",0),FUNCT_MODE("pseudo",":not"),FUNCT_MODE("keyword",":extend"),IDENT_MODE("pseudo","::?"+INTERP_IDENT_RE),{className:"attr_selector",begin:"\\[",end:"\\]"},{begin:"\\(",end:"\\)",contains:VALUE_WITH_RULESETS},{begin:"!important"}]};return RULES.push(hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,AT_RULE_MODE,VAR_RULE_MODE,SELECTOR_MODE,RULE_MODE),{case_insensitive:!0,illegal:"[=>'/<($\"]",contains:RULES}}),hljs.registerLanguage("lisp",function(hljs){var LISP_IDENT_RE="[a-zA-Z_\\-\\+\\*\\/\\<\\=\\>\\&\\#][a-zA-Z0-9_\\-\\+\\*\\/\\<\\=\\>\\&\\#!]*",MEC_RE="\\|[^]*?\\|",LISP_SIMPLE_NUMBER_RE="(\\-|\\+)?\\d+(\\.\\d+|\\/\\d+)?((d|e|f|l|s|D|E|F|L|S)(\\+|\\-)?\\d+)?",SHEBANG={className:"shebang",begin:"^#!",end:"$"},LITERAL={className:"literal",begin:"\\b(t{1}|nil)\\b"},NUMBER={className:"number",variants:[{begin:LISP_SIMPLE_NUMBER_RE,relevance:0},{begin:"#(b|B)[0-1]+(/[0-1]+)?"},{begin:"#(o|O)[0-7]+(/[0-7]+)?"},{begin:"#(x|X)[0-9a-fA-F]+(/[0-9a-fA-F]+)?"},{begin:"#(c|C)\\("+LISP_SIMPLE_NUMBER_RE+" +"+LISP_SIMPLE_NUMBER_RE,end:"\\)"}]},STRING=hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null}),COMMENT=hljs.COMMENT(";","$",{relevance:0}),VARIABLE={className:"variable",begin:"\\*",end:"\\*"},KEYWORD={className:"keyword",begin:"[:&]"+LISP_IDENT_RE},IDENT={begin:LISP_IDENT_RE,relevance:0},MEC={begin:MEC_RE},QUOTED_LIST={begin:"\\(",end:"\\)",contains:["self",LITERAL,STRING,NUMBER,IDENT]},QUOTED={className:"quoted",contains:[NUMBER,STRING,VARIABLE,KEYWORD,QUOTED_LIST,IDENT],variants:[{begin:"['`]\\(",end:"\\)"},{begin:"\\(quote ",end:"\\)",keywords:"quote"},{begin:"'"+MEC_RE}]},QUOTED_ATOM={className:"quoted",variants:[{begin:"'"+LISP_IDENT_RE},{begin:"#'"+LISP_IDENT_RE+"(::"+LISP_IDENT_RE+")*"}]},LIST={className:"list",begin:"\\(\\s*",end:"\\)"},BODY={endsWithParent:!0,relevance:0};return LIST.contains=[{className:"keyword",variants:[{begin:LISP_IDENT_RE},{begin:MEC_RE}]},BODY],BODY.contains=[QUOTED,QUOTED_ATOM,LIST,LITERAL,NUMBER,STRING,COMMENT,VARIABLE,KEYWORD,MEC,IDENT],{illegal:/\S/,contains:[NUMBER,SHEBANG,LITERAL,STRING,COMMENT,QUOTED,QUOTED_ATOM,LIST,IDENT]}}),hljs.registerLanguage("livecodeserver",function(hljs){var VARIABLE={className:"variable",begin:"\\b[gtps][A-Z]+[A-Za-z0-9_\\-]*\\b|\\$_[A-Z]+",relevance:0},COMMENT_MODES=[hljs.C_BLOCK_COMMENT_MODE,hljs.HASH_COMMENT_MODE,hljs.COMMENT("--","$"),hljs.COMMENT("[^:]//","$")],TITLE1=hljs.inherit(hljs.TITLE_MODE,{variants:[{begin:"\\b_*rig[A-Z]+[A-Za-z0-9_\\-]*"},{begin:"\\b_[a-z0-9\\-]+"}]}),TITLE2=hljs.inherit(hljs.TITLE_MODE,{begin:"\\b([A-Za-z0-9_\\-]+)\\b"});return{case_insensitive:!1,keywords:{keyword:"$_COOKIE $_FILES $_GET $_GET_BINARY $_GET_RAW $_POST $_POST_BINARY $_POST_RAW $_SESSION $_SERVER codepoint codepoints segment segments codeunit codeunits sentence sentences trueWord trueWords paragraph after byte bytes english the until http forever descending using line real8 with seventh for stdout finally element word words fourth before black ninth sixth characters chars stderr uInt1 uInt1s uInt2 uInt2s stdin string lines relative rel any fifth items from middle mid at else of catch then third it file milliseconds seconds second secs sec int1 int1s int4 int4s internet int2 int2s normal text item last long detailed effective uInt4 uInt4s repeat end repeat URL in try into switch to words https token binfile each tenth as ticks tick system real4 by dateItems without char character ascending eighth whole dateTime numeric short first ftp integer abbreviated abbr abbrev private case while if",constant:"SIX TEN FORMFEED NINE ZERO NONE SPACE FOUR FALSE COLON CRLF PI COMMA ENDOFFILE EOF EIGHT FIVE QUOTE EMPTY ONE TRUE RETURN CR LINEFEED RIGHT BACKSLASH NULL SEVEN TAB THREE TWO six ten formfeed nine zero none space four false colon crlf pi comma endoffile eof eight five quote empty one true return cr linefeed right backslash null seven tab three two RIVERSION RISTATE FILE_READ_MODE FILE_WRITE_MODE FILE_WRITE_MODE DIR_WRITE_MODE FILE_READ_UMASK FILE_WRITE_UMASK DIR_READ_UMASK DIR_WRITE_UMASK",operator:"div mod wrap and or bitAnd bitNot bitOr bitXor among not in a an within contains ends with begins the keys of keys",built_in:"put abs acos aliasReference annuity arrayDecode arrayEncode asin atan atan2 average avg avgDev base64Decode base64Encode baseConvert binaryDecode binaryEncode byteOffset byteToNum cachedURL cachedURLs charToNum cipherNames codepointOffset codepointProperty codepointToNum codeunitOffset commandNames compound compress constantNames cos date dateFormat decompress directories diskSpace DNSServers exp exp1 exp2 exp10 extents files flushEvents folders format functionNames geometricMean global globals hasMemory harmonicMean hostAddress hostAddressToName hostName hostNameToAddress isNumber ISOToMac itemOffset keys len length libURLErrorData libUrlFormData libURLftpCommand libURLLastHTTPHeaders libURLLastRHHeaders libUrlMultipartFormAddPart libUrlMultipartFormData libURLVersion lineOffset ln ln1 localNames log log2 log10 longFilePath lower macToISO matchChunk matchText matrixMultiply max md5Digest median merge millisec millisecs millisecond milliseconds min monthNames nativeCharToNum normalizeText num number numToByte numToChar numToCodepoint numToNativeChar offset open openfiles openProcesses openProcessIDs openSockets paragraphOffset paramCount param params peerAddress pendingMessages platform popStdDev populationStandardDeviation populationVariance popVariance processID random randomBytes replaceText result revCreateXMLTree revCreateXMLTreeFromFile revCurrentRecord revCurrentRecordIsFirst revCurrentRecordIsLast revDatabaseColumnCount revDatabaseColumnIsNull revDatabaseColumnLengths revDatabaseColumnNames revDatabaseColumnNamed revDatabaseColumnNumbered revDatabaseColumnTypes revDatabaseConnectResult revDatabaseCursors revDatabaseID revDatabaseTableNames revDatabaseType revDataFromQuery revdb_closeCursor revdb_columnbynumber revdb_columncount revdb_columnisnull revdb_columnlengths revdb_columnnames revdb_columntypes revdb_commit revdb_connect revdb_connections revdb_connectionerr revdb_currentrecord revdb_cursorconnection revdb_cursorerr revdb_cursors revdb_dbtype revdb_disconnect revdb_execute revdb_iseof revdb_isbof revdb_movefirst revdb_movelast revdb_movenext revdb_moveprev revdb_query revdb_querylist revdb_recordcount revdb_rollback revdb_tablenames revGetDatabaseDriverPath revNumberOfRecords revOpenDatabase revOpenDatabases revQueryDatabase revQueryDatabaseBlob revQueryResult revQueryIsAtStart revQueryIsAtEnd revUnixFromMacPath revXMLAttribute revXMLAttributes revXMLAttributeValues revXMLChildContents revXMLChildNames revXMLCreateTreeFromFileWithNamespaces revXMLCreateTreeWithNamespaces revXMLDataFromXPathQuery revXMLEvaluateXPath revXMLFirstChild revXMLMatchingNode revXMLNextSibling revXMLNodeContents revXMLNumberOfChildren revXMLParent revXMLPreviousSibling revXMLRootNode revXMLRPC_CreateRequest revXMLRPC_Documents revXMLRPC_Error revXMLRPC_GetHost revXMLRPC_GetMethod revXMLRPC_GetParam revXMLText revXMLRPC_Execute revXMLRPC_GetParamCount revXMLRPC_GetParamNode revXMLRPC_GetParamType revXMLRPC_GetPath revXMLRPC_GetPort revXMLRPC_GetProtocol revXMLRPC_GetRequest revXMLRPC_GetResponse revXMLRPC_GetSocket revXMLTree revXMLTrees revXMLValidateDTD revZipDescribeItem revZipEnumerateItems revZipOpenArchives round sampVariance sec secs seconds sentenceOffset sha1Digest shell shortFilePath sin specialFolderPath sqrt standardDeviation statRound stdDev sum sysError systemVersion tan tempName textDecode textEncode tick ticks time to tokenOffset toLower toUpper transpose truewordOffset trunc uniDecode uniEncode upper URLDecode URLEncode URLStatus uuid value variableNames variance version waitDepth weekdayNames wordOffset xsltApplyStylesheet xsltApplyStylesheetFromFile xsltLoadStylesheet xsltLoadStylesheetFromFile add breakpoint cancel clear local variable file word line folder directory URL close socket process combine constant convert create new alias folder directory decrypt delete variable word line folder directory URL dispatch divide do encrypt filter get include intersect kill libURLDownloadToFile libURLFollowHttpRedirects libURLftpUpload libURLftpUploadFile libURLresetAll libUrlSetAuthCallback libURLSetCustomHTTPHeaders libUrlSetExpect100 libURLSetFTPListCommand libURLSetFTPMode libURLSetFTPStopTime libURLSetStatusCallback load multiply socket prepare process post seek rel relative read from process rename replace require resetAll resolve revAddXMLNode revAppendXML revCloseCursor revCloseDatabase revCommitDatabase revCopyFile revCopyFolder revCopyXMLNode revDeleteFolder revDeleteXMLNode revDeleteAllXMLTrees revDeleteXMLTree revExecuteSQL revGoURL revInsertXMLNode revMoveFolder revMoveToFirstRecord revMoveToLastRecord revMoveToNextRecord revMoveToPreviousRecord revMoveToRecord revMoveXMLNode revPutIntoXMLNode revRollBackDatabase revSetDatabaseDriverPath revSetXMLAttribute revXMLRPC_AddParam revXMLRPC_DeleteAllDocuments revXMLAddDTD revXMLRPC_Free revXMLRPC_FreeAll revXMLRPC_DeleteDocument revXMLRPC_DeleteParam revXMLRPC_SetHost revXMLRPC_SetMethod revXMLRPC_SetPort revXMLRPC_SetProtocol revXMLRPC_SetSocket revZipAddItemWithData revZipAddItemWithFile revZipAddUncompressedItemWithData revZipAddUncompressedItemWithFile revZipCancel revZipCloseArchive revZipDeleteItem revZipExtractItemToFile revZipExtractItemToVariable revZipSetProgressCallback revZipRenameItem revZipReplaceItemWithData revZipReplaceItemWithFile revZipOpenArchive send set sort split start stop subtract union unload wait write"},contains:[VARIABLE,{className:"keyword",begin:"\\bend\\sif\\b"},{className:"function",beginKeywords:"function",end:"$",contains:[VARIABLE,TITLE2,hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.BINARY_NUMBER_MODE,hljs.C_NUMBER_MODE,TITLE1]},{className:"function",begin:"\\bend\\s+",end:"$",keywords:"end",contains:[TITLE2,TITLE1]},{className:"command",beginKeywords:"command on",end:"$",contains:[VARIABLE,TITLE2,hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.BINARY_NUMBER_MODE,hljs.C_NUMBER_MODE,TITLE1]},{className:"preprocessor",variants:[{begin:"<\\?(rev|lc|livecode)",relevance:10},{begin:"<\\?"},{begin:"\\?>"}]},hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.BINARY_NUMBER_MODE,hljs.C_NUMBER_MODE,TITLE1].concat(COMMENT_MODES),illegal:";$|^\\[|^="}}),hljs.registerLanguage("livescript",function(hljs){var KEYWORDS={keyword:"in if for while finally new do return else break catch instanceof throw try this switch continue typeof delete debugger case default function var with then unless until loop of by when and or is isnt not it that otherwise from to til fallthrough super case default function var void const let enum export import native __hasProp __extends __slice __bind __indexOf",literal:"true false null undefined yes no on off it that void",built_in:"npm require console print module global window document"},JS_IDENT_RE="[A-Za-z$_](?:-[0-9A-Za-z$_]|[0-9A-Za-z$_])*",TITLE=hljs.inherit(hljs.TITLE_MODE,{begin:JS_IDENT_RE}),SUBST={className:"subst",begin:/#\{/,end:/}/,keywords:KEYWORDS},SUBST_SIMPLE={className:"subst",begin:/#[A-Za-z$_]/,end:/(?:\-[0-9A-Za-z$_]|[0-9A-Za-z$_])*/,keywords:KEYWORDS},EXPRESSIONS=[hljs.BINARY_NUMBER_MODE,{className:"number",begin:"(\\b0[xX][a-fA-F0-9_]+)|(\\b\\d(\\d|_\\d)*(\\.(\\d(\\d|_\\d)*)?)?(_*[eE]([-+]\\d(_\\d|\\d)*)?)?[_a-z]*)",relevance:0,starts:{end:"(\\s*/)?",relevance:0}},{className:"string",variants:[{begin:/'''/,end:/'''/,contains:[hljs.BACKSLASH_ESCAPE]},{begin:/'/,end:/'/,contains:[hljs.BACKSLASH_ESCAPE]},{begin:/"""/,end:/"""/,contains:[hljs.BACKSLASH_ESCAPE,SUBST,SUBST_SIMPLE]},{begin:/"/,end:/"/,contains:[hljs.BACKSLASH_ESCAPE,SUBST,SUBST_SIMPLE]},{begin:/\\/,end:/(\s|$)/,excludeEnd:!0}]},{className:"pi",variants:[{begin:"//",end:"//[gim]*",contains:[SUBST,hljs.HASH_COMMENT_MODE]},{begin:/\/(?![ *])(\\\/|.)*?\/[gim]*(?=\W|$)/}]},{className:"property",begin:"@"+JS_IDENT_RE},{begin:"``",end:"``",excludeBegin:!0,excludeEnd:!0,subLanguage:"javascript"}];SUBST.contains=EXPRESSIONS;var PARAMS={className:"params",begin:"\\(",returnBegin:!0,contains:[{begin:/\(/,end:/\)/,keywords:KEYWORDS,contains:["self"].concat(EXPRESSIONS)}]};return{aliases:["ls"],keywords:KEYWORDS,illegal:/\/\*/,contains:EXPRESSIONS.concat([hljs.COMMENT("\\/\\*","\\*\\/"),hljs.HASH_COMMENT_MODE,{className:"function",contains:[TITLE,PARAMS],returnBegin:!0,variants:[{begin:"("+JS_IDENT_RE+"\\s*(?:=|:=)\\s*)?(\\(.*\\))?\\s*\\B\\->\\*?",end:"\\->\\*?"},{begin:"("+JS_IDENT_RE+"\\s*(?:=|:=)\\s*)?!?(\\(.*\\))?\\s*\\B[-~]{1,2}>\\*?",end:"[-~]{1,2}>\\*?"},{begin:"("+JS_IDENT_RE+"\\s*(?:=|:=)\\s*)?(\\(.*\\))?\\s*\\B!?[-~]{1,2}>\\*?",end:"!?[-~]{1,2}>\\*?"}]},{className:"class",beginKeywords:"class",end:"$",illegal:/[:="\[\]]/,contains:[{beginKeywords:"extends",endsWithParent:!0,illegal:/[:="\[\]]/,contains:[TITLE]},TITLE]},{className:"attribute",begin:JS_IDENT_RE+":",end:":",returnBegin:!0,returnEnd:!0,relevance:0}])}}),hljs.registerLanguage("lua",function(hljs){var OPENING_LONG_BRACKET="\\[=*\\[",CLOSING_LONG_BRACKET="\\]=*\\]",LONG_BRACKETS={begin:OPENING_LONG_BRACKET,end:CLOSING_LONG_BRACKET,contains:["self"]},COMMENTS=[hljs.COMMENT("--(?!"+OPENING_LONG_BRACKET+")","$"),hljs.COMMENT("--"+OPENING_LONG_BRACKET,CLOSING_LONG_BRACKET,{contains:[LONG_BRACKETS],relevance:10})];return{lexemes:hljs.UNDERSCORE_IDENT_RE,keywords:{keyword:"and break do else elseif end false for if in local nil not or repeat return then true until while",built_in:"_G _VERSION assert collectgarbage dofile error getfenv getmetatable ipairs load loadfile loadstring module next pairs pcall print rawequal rawget rawset require select setfenv setmetatable tonumber tostring type unpack xpcall coroutine debug io math os package string table"},contains:COMMENTS.concat([{className:"function",beginKeywords:"function",end:"\\)",contains:[hljs.inherit(hljs.TITLE_MODE,{begin:"([_a-zA-Z]\\w*\\.)*([_a-zA-Z]\\w*:)?[_a-zA-Z]\\w*"}),{className:"params",begin:"\\(",endsWithParent:!0,contains:COMMENTS}].concat(COMMENTS)},hljs.C_NUMBER_MODE,hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,{className:"string",begin:OPENING_LONG_BRACKET,end:CLOSING_LONG_BRACKET,contains:[LONG_BRACKETS],relevance:5}])}}),hljs.registerLanguage("makefile",function(hljs){var VARIABLE={className:"variable",begin:/\$\(/,end:/\)/,contains:[hljs.BACKSLASH_ESCAPE]};return{aliases:["mk","mak"],contains:[hljs.HASH_COMMENT_MODE,{begin:/^\w+\s*\W*=/,returnBegin:!0,relevance:0,starts:{className:"constant",end:/\s*\W*=/,excludeEnd:!0,starts:{end:/$/,relevance:0,contains:[VARIABLE]}}},{className:"title",begin:/^[\w]+:\s*$/},{className:"phony",begin:/^\.PHONY:/,end:/$/,keywords:".PHONY",lexemes:/[\.\w]+/},{begin:/^\t+/,end:/$/,relevance:0,contains:[hljs.QUOTE_STRING_MODE,VARIABLE]}]}}),hljs.registerLanguage("mathematica",function(hljs){return{aliases:["mma"],lexemes:"(\\$|\\b)"+hljs.IDENT_RE+"\\b",keywords:"AbelianGroup Abort AbortKernels AbortProtect Above Abs Absolute AbsoluteCorrelation AbsoluteCorrelationFunction AbsoluteCurrentValue AbsoluteDashing AbsoluteFileName AbsoluteOptions AbsolutePointSize AbsoluteThickness AbsoluteTime AbsoluteTiming AccountingForm Accumulate Accuracy AccuracyGoal ActionDelay ActionMenu ActionMenuBox ActionMenuBoxOptions Active ActiveItem ActiveStyle AcyclicGraphQ AddOnHelpPath AddTo AdjacencyGraph AdjacencyList AdjacencyMatrix AdjustmentBox AdjustmentBoxOptions AdjustTimeSeriesForecast AffineTransform After AiryAi AiryAiPrime AiryAiZero AiryBi AiryBiPrime AiryBiZero AlgebraicIntegerQ AlgebraicNumber AlgebraicNumberDenominator AlgebraicNumberNorm AlgebraicNumberPolynomial AlgebraicNumberTrace AlgebraicRules AlgebraicRulesData Algebraics AlgebraicUnitQ Alignment AlignmentMarker AlignmentPoint All AllowedDimensions AllowGroupClose AllowInlineCells AllowKernelInitialization AllowReverseGroupClose AllowScriptLevelChange AlphaChannel AlternatingGroup AlternativeHypothesis Alternatives AmbientLight Analytic AnchoredSearch And AndersonDarlingTest AngerJ AngleBracket AngularGauge Animate AnimationCycleOffset AnimationCycleRepetitions AnimationDirection AnimationDisplayTime AnimationRate AnimationRepetitions AnimationRunning Animator AnimatorBox AnimatorBoxOptions AnimatorElements Annotation Annuity AnnuityDue Antialiasing Antisymmetric Apart ApartSquareFree Appearance AppearanceElements AppellF1 Append AppendTo Apply ArcCos ArcCosh ArcCot ArcCoth ArcCsc ArcCsch ArcSec ArcSech ArcSin ArcSinDistribution ArcSinh ArcTan ArcTanh Arg ArgMax ArgMin ArgumentCountQ ARIMAProcess ArithmeticGeometricMean ARMAProcess ARProcess Array ArrayComponents ArrayDepth ArrayFlatten ArrayPad ArrayPlot ArrayQ ArrayReshape ArrayRules Arrays Arrow Arrow3DBox ArrowBox Arrowheads AspectRatio AspectRatioFixed Assert Assuming Assumptions AstronomicalData Asynchronous AsynchronousTaskObject AsynchronousTasks AtomQ Attributes AugmentedSymmetricPolynomial AutoAction AutoDelete AutoEvaluateEvents AutoGeneratedPackage AutoIndent AutoIndentSpacings AutoItalicWords AutoloadPath AutoMatch Automatic AutomaticImageSize AutoMultiplicationSymbol AutoNumberFormatting AutoOpenNotebooks AutoOpenPalettes AutorunSequencing AutoScaling AutoScroll AutoSpacing AutoStyleOptions AutoStyleWords Axes AxesEdge AxesLabel AxesOrigin AxesStyle Axis BabyMonsterGroupB Back Background BackgroundTasksSettings Backslash Backsubstitution Backward Band BandpassFilter BandstopFilter BarabasiAlbertGraphDistribution BarChart BarChart3D BarLegend BarlowProschanImportance BarnesG BarOrigin BarSpacing BartlettHannWindow BartlettWindow BaseForm Baseline BaselinePosition BaseStyle BatesDistribution BattleLemarieWavelet Because BeckmannDistribution Beep Before Begin BeginDialogPacket BeginFrontEndInteractionPacket BeginPackage BellB BellY Below BenfordDistribution BeniniDistribution BenktanderGibratDistribution BenktanderWeibullDistribution BernoulliB BernoulliDistribution BernoulliGraphDistribution BernoulliProcess BernsteinBasis BesselFilterModel BesselI BesselJ BesselJZero BesselK BesselY BesselYZero Beta BetaBinomialDistribution BetaDistribution BetaNegativeBinomialDistribution BetaPrimeDistribution BetaRegularized BetweennessCentrality BezierCurve BezierCurve3DBox BezierCurve3DBoxOptions BezierCurveBox BezierCurveBoxOptions BezierFunction BilateralFilter Binarize BinaryFormat BinaryImageQ BinaryRead BinaryReadList BinaryWrite BinCounts BinLists Binomial BinomialDistribution BinomialProcess BinormalDistribution BiorthogonalSplineWavelet BipartiteGraphQ BirnbaumImportance BirnbaumSaundersDistribution BitAnd BitClear BitGet BitLength BitNot BitOr BitSet BitShiftLeft BitShiftRight BitXor Black BlackmanHarrisWindow BlackmanNuttallWindow BlackmanWindow Blank BlankForm BlankNullSequence BlankSequence Blend Block BlockRandom BlomqvistBeta BlomqvistBetaTest Blue Blur BodePlot BohmanWindow Bold Bookmarks Boole BooleanConsecutiveFunction BooleanConvert BooleanCountingFunction BooleanFunction BooleanGraph BooleanMaxterms BooleanMinimize BooleanMinterms Booleans BooleanTable BooleanVariables BorderDimensions BorelTannerDistribution Bottom BottomHatTransform BoundaryStyle Bounds Box BoxBaselineShift BoxData BoxDimensions Boxed Boxes BoxForm BoxFormFormatTypes BoxFrame BoxID BoxMargins BoxMatrix BoxRatios BoxRotation BoxRotationPoint BoxStyle BoxWhiskerChart Bra BracketingBar BraKet BrayCurtisDistance BreadthFirstScan Break Brown BrownForsytheTest BrownianBridgeProcess BrowserCategory BSplineBasis BSplineCurve BSplineCurve3DBox BSplineCurveBox BSplineCurveBoxOptions BSplineFunction BSplineSurface BSplineSurface3DBox BubbleChart BubbleChart3D BubbleScale BubbleSizes BulletGauge BusinessDayQ ButterflyGraph ButterworthFilterModel Button ButtonBar ButtonBox ButtonBoxOptions ButtonCell ButtonContents ButtonData ButtonEvaluator ButtonExpandable ButtonFrame ButtonFunction ButtonMargins ButtonMinHeight ButtonNote ButtonNotebook ButtonSource ButtonStyle ButtonStyleMenuListing Byte ByteCount ByteOrdering C CachedValue CacheGraphics CalendarData CalendarType CallPacket CanberraDistance Cancel CancelButton CandlestickChart Cap CapForm CapitalDifferentialD CardinalBSplineBasis CarmichaelLambda Cases Cashflow Casoratian Catalan CatalanNumber Catch CauchyDistribution CauchyWindow CayleyGraph CDF CDFDeploy CDFInformation CDFWavelet Ceiling Cell CellAutoOverwrite CellBaseline CellBoundingBox CellBracketOptions CellChangeTimes CellContents CellContext CellDingbat CellDynamicExpression CellEditDuplicate CellElementsBoundingBox CellElementSpacings CellEpilog CellEvaluationDuplicate CellEvaluationFunction CellEventActions CellFrame CellFrameColor CellFrameLabelMargins CellFrameLabels CellFrameMargins CellGroup CellGroupData CellGrouping CellGroupingRules CellHorizontalScrolling CellID CellLabel CellLabelAutoDelete CellLabelMargins CellLabelPositioning CellMargins CellObject CellOpen CellPrint CellProlog Cells CellSize CellStyle CellTags CellularAutomaton CensoredDistribution Censoring Center CenterDot CentralMoment CentralMomentGeneratingFunction CForm ChampernowneNumber ChanVeseBinarize Character CharacterEncoding CharacterEncodingsPath CharacteristicFunction CharacteristicPolynomial CharacterRange Characters ChartBaseStyle ChartElementData ChartElementDataFunction ChartElementFunction ChartElements ChartLabels ChartLayout ChartLegends ChartStyle Chebyshev1FilterModel Chebyshev2FilterModel ChebyshevDistance ChebyshevT ChebyshevU Check CheckAbort CheckAll Checkbox CheckboxBar CheckboxBox CheckboxBoxOptions ChemicalData ChessboardDistance ChiDistribution ChineseRemainder ChiSquareDistribution ChoiceButtons ChoiceDialog CholeskyDecomposition Chop Circle CircleBox CircleDot CircleMinus CirclePlus CircleTimes CirculantGraph CityData Clear ClearAll ClearAttributes ClearSystemCache ClebschGordan ClickPane Clip ClipboardNotebook ClipFill ClippingStyle ClipPlanes ClipRange Clock ClockGauge ClockwiseContourIntegral Close Closed CloseKernels ClosenessCentrality Closing ClosingAutoSave ClosingEvent ClusteringComponents CMYKColor Coarse Coefficient CoefficientArrays CoefficientDomain CoefficientList CoefficientRules CoifletWavelet Collect Colon ColonForm ColorCombine ColorConvert ColorData ColorDataFunction ColorFunction ColorFunctionScaling Colorize ColorNegate ColorOutput ColorProfileData ColorQuantize ColorReplace ColorRules ColorSelectorSettings ColorSeparate ColorSetter ColorSetterBox ColorSetterBoxOptions ColorSlider ColorSpace Column ColumnAlignments ColumnBackgrounds ColumnForm ColumnLines ColumnsEqual ColumnSpacings ColumnWidths CommonDefaultFormatTypes Commonest CommonestFilter CommonUnits CommunityBoundaryStyle CommunityGraphPlot CommunityLabels CommunityRegionStyle CompatibleUnitQ CompilationOptions CompilationTarget Compile Compiled CompiledFunction Complement CompleteGraph CompleteGraphQ CompleteKaryTree CompletionsListPacket Complex Complexes ComplexExpand ComplexInfinity ComplexityFunction ComponentMeasurements ComponentwiseContextMenu Compose ComposeList ComposeSeries Composition CompoundExpression CompoundPoissonDistribution CompoundPoissonProcess CompoundRenewalProcess Compress CompressedData Condition ConditionalExpression Conditioned Cone ConeBox ConfidenceLevel ConfidenceRange ConfidenceTransform ConfigurationPath Congruent Conjugate ConjugateTranspose Conjunction Connect ConnectedComponents ConnectedGraphQ ConnesWindow ConoverTest ConsoleMessage ConsoleMessagePacket ConsolePrint Constant ConstantArray Constants ConstrainedMax ConstrainedMin ContentPadding ContentsBoundingBox ContentSelectable ContentSize Context ContextMenu Contexts ContextToFilename ContextToFileName Continuation Continue ContinuedFraction ContinuedFractionK ContinuousAction ContinuousMarkovProcess ContinuousTimeModelQ ContinuousWaveletData ContinuousWaveletTransform ContourDetect ContourGraphics ContourIntegral ContourLabels ContourLines ContourPlot ContourPlot3D Contours ContourShading ContourSmoothing ContourStyle ContraharmonicMean Control ControlActive ControlAlignment ControllabilityGramian ControllabilityMatrix ControllableDecomposition ControllableModelQ ControllerDuration ControllerInformation ControllerInformationData ControllerLinking ControllerManipulate ControllerMethod ControllerPath ControllerState ControlPlacement ControlsRendering ControlType Convergents ConversionOptions ConversionRules ConvertToBitmapPacket ConvertToPostScript ConvertToPostScriptPacket Convolve ConwayGroupCo1 ConwayGroupCo2 ConwayGroupCo3 CoordinateChartData CoordinatesToolOptions CoordinateTransform CoordinateTransformData CoprimeQ Coproduct CopulaDistribution Copyable CopyDirectory CopyFile CopyTag CopyToClipboard CornerFilter CornerNeighbors Correlation CorrelationDistance CorrelationFunction CorrelationTest Cos Cosh CoshIntegral CosineDistance CosineWindow CosIntegral Cot Coth Count CounterAssignments CounterBox CounterBoxOptions CounterClockwiseContourIntegral CounterEvaluator CounterFunction CounterIncrements CounterStyle CounterStyleMenuListing CountRoots CountryData Covariance CovarianceEstimatorFunction CovarianceFunction CoxianDistribution CoxIngersollRossProcess CoxModel CoxModelFit CramerVonMisesTest CreateArchive CreateDialog CreateDirectory CreateDocument CreateIntermediateDirectories CreatePalette CreatePalettePacket CreateScheduledTask CreateTemporary CreateWindow CriticalityFailureImportance CriticalitySuccessImportance CriticalSection Cross CrossingDetect CrossMatrix Csc Csch CubeRoot Cubics Cuboid CuboidBox Cumulant CumulantGeneratingFunction Cup CupCap Curl CurlyDoubleQuote CurlyQuote CurrentImage CurrentlySpeakingPacket CurrentValue CurvatureFlowFilter CurveClosed Cyan CycleGraph CycleIndexPolynomial Cycles CyclicGroup Cyclotomic Cylinder CylinderBox CylindricalDecomposition D DagumDistribution DamerauLevenshteinDistance DampingFactor Darker Dashed Dashing DataCompression DataDistribution DataRange DataReversed Date DateDelimiters DateDifference DateFunction DateList DateListLogPlot DateListPlot DatePattern DatePlus DateRange DateString DateTicksFormat DaubechiesWavelet DavisDistribution DawsonF DayCount DayCountConvention DayMatchQ DayName DayPlus DayRange DayRound DeBruijnGraph Debug DebugTag Decimal DeclareKnownSymbols DeclarePackage Decompose Decrement DedekindEta Default DefaultAxesStyle DefaultBaseStyle DefaultBoxStyle DefaultButton DefaultColor DefaultControlPlacement DefaultDuplicateCellStyle DefaultDuration DefaultElement DefaultFaceGridsStyle DefaultFieldHintStyle DefaultFont DefaultFontProperties DefaultFormatType DefaultFormatTypeForStyle DefaultFrameStyle DefaultFrameTicksStyle DefaultGridLinesStyle DefaultInlineFormatType DefaultInputFormatType DefaultLabelStyle DefaultMenuStyle DefaultNaturalLanguage DefaultNewCellStyle DefaultNewInlineCellStyle DefaultNotebook DefaultOptions DefaultOutputFormatType DefaultStyle DefaultStyleDefinitions DefaultTextFormatType DefaultTextInlineFormatType DefaultTicksStyle DefaultTooltipStyle DefaultValues Defer DefineExternal DefineInputStreamMethod DefineOutputStreamMethod Definition Degree DegreeCentrality DegreeGraphDistribution DegreeLexicographic DegreeReverseLexicographic Deinitialization Del Deletable Delete DeleteBorderComponents DeleteCases DeleteContents DeleteDirectory DeleteDuplicates DeleteFile DeleteSmallComponents DeleteWithContents DeletionWarning Delimiter DelimiterFlashTime DelimiterMatching Delimiters Denominator DensityGraphics DensityHistogram DensityPlot DependentVariables Deploy Deployed Depth DepthFirstScan Derivative DerivativeFilter DescriptorStateSpace DesignMatrix Det DGaussianWavelet DiacriticalPositioning Diagonal DiagonalMatrix Dialog DialogIndent DialogInput DialogLevel DialogNotebook DialogProlog DialogReturn DialogSymbols Diamond DiamondMatrix DiceDissimilarity DictionaryLookup DifferenceDelta DifferenceOrder DifferenceRoot DifferenceRootReduce Differences DifferentialD DifferentialRoot DifferentialRootReduce DifferentiatorFilter DigitBlock DigitBlockMinimum DigitCharacter DigitCount DigitQ DihedralGroup Dilation Dimensions DiracComb DiracDelta DirectedEdge DirectedEdges DirectedGraph DirectedGraphQ DirectedInfinity Direction Directive Directory DirectoryName DirectoryQ DirectoryStack DirichletCharacter DirichletConvolve DirichletDistribution DirichletL DirichletTransform DirichletWindow DisableConsolePrintPacket DiscreteChirpZTransform DiscreteConvolve DiscreteDelta DiscreteHadamardTransform DiscreteIndicator DiscreteLQEstimatorGains DiscreteLQRegulatorGains DiscreteLyapunovSolve DiscreteMarkovProcess DiscretePlot DiscretePlot3D DiscreteRatio DiscreteRiccatiSolve DiscreteShift DiscreteTimeModelQ DiscreteUniformDistribution DiscreteVariables DiscreteWaveletData DiscreteWaveletPacketTransform DiscreteWaveletTransform Discriminant Disjunction Disk DiskBox DiskMatrix Dispatch DispersionEstimatorFunction Display DisplayAllSteps DisplayEndPacket DisplayFlushImagePacket DisplayForm DisplayFunction DisplayPacket DisplayRules DisplaySetSizePacket DisplayString DisplayTemporary DisplayWith DisplayWithRef DisplayWithVariable DistanceFunction DistanceTransform Distribute Distributed DistributedContexts DistributeDefinitions DistributionChart DistributionDomain DistributionFitTest DistributionParameterAssumptions DistributionParameterQ Dithering Div Divergence Divide DivideBy Dividers Divisible Divisors DivisorSigma DivisorSum DMSList DMSString Do DockedCells DocumentNotebook DominantColors DOSTextFormat Dot DotDashed DotEqual Dotted DoubleBracketingBar DoubleContourIntegral DoubleDownArrow DoubleLeftArrow DoubleLeftRightArrow DoubleLeftTee DoubleLongLeftArrow DoubleLongLeftRightArrow DoubleLongRightArrow DoubleRightArrow DoubleRightTee DoubleUpArrow DoubleUpDownArrow DoubleVerticalBar DoublyInfinite Down DownArrow DownArrowBar DownArrowUpArrow DownLeftRightVector DownLeftTeeVector DownLeftVector DownLeftVectorBar DownRightTeeVector DownRightVector DownRightVectorBar Downsample DownTee DownTeeArrow DownValues DragAndDrop DrawEdges DrawFrontFaces DrawHighlighted Drop DSolve Dt DualLinearProgramming DualSystemsModel DumpGet DumpSave DuplicateFreeQ Dynamic DynamicBox DynamicBoxOptions DynamicEvaluationTimeout DynamicLocation DynamicModule DynamicModuleBox DynamicModuleBoxOptions DynamicModuleParent DynamicModuleValues DynamicName DynamicNamespace DynamicReference DynamicSetting DynamicUpdating DynamicWrapper DynamicWrapperBox DynamicWrapperBoxOptions E EccentricityCentrality EdgeAdd EdgeBetweennessCentrality EdgeCapacity EdgeCapForm EdgeColor EdgeConnectivity EdgeCost EdgeCount EdgeCoverQ EdgeDashing EdgeDelete EdgeDetect EdgeForm EdgeIndex EdgeJoinForm EdgeLabeling EdgeLabels EdgeLabelStyle EdgeList EdgeOpacity EdgeQ EdgeRenderingFunction EdgeRules EdgeShapeFunction EdgeStyle EdgeThickness EdgeWeight Editable EditButtonSettings EditCellTagsSettings EditDistance EffectiveInterest Eigensystem Eigenvalues EigenvectorCentrality Eigenvectors Element ElementData Eliminate EliminationOrder EllipticE EllipticExp EllipticExpPrime EllipticF EllipticFilterModel EllipticK EllipticLog EllipticNomeQ EllipticPi EllipticReducedHalfPeriods EllipticTheta EllipticThetaPrime EmitSound EmphasizeSyntaxErrors EmpiricalDistribution Empty EmptyGraphQ EnableConsolePrintPacket Enabled Encode End EndAdd EndDialogPacket EndFrontEndInteractionPacket EndOfFile EndOfLine EndOfString EndPackage EngineeringForm Enter EnterExpressionPacket EnterTextPacket Entropy EntropyFilter Environment Epilog Equal EqualColumns EqualRows EqualTilde EquatedTo Equilibrium EquirippleFilterKernel Equivalent Erf Erfc Erfi ErlangB ErlangC ErlangDistribution Erosion ErrorBox ErrorBoxOptions ErrorNorm ErrorPacket ErrorsDialogSettings EstimatedDistribution EstimatedProcess EstimatorGains EstimatorRegulator EuclideanDistance EulerE EulerGamma EulerianGraphQ EulerPhi Evaluatable Evaluate Evaluated EvaluatePacket EvaluationCell EvaluationCompletionAction EvaluationElements EvaluationMode EvaluationMonitor EvaluationNotebook EvaluationObject EvaluationOrder Evaluator EvaluatorNames EvenQ EventData EventEvaluator EventHandler EventHandlerTag EventLabels ExactBlackmanWindow ExactNumberQ ExactRootIsolation ExampleData Except ExcludedForms ExcludePods Exclusions ExclusionsStyle Exists Exit ExitDialog Exp Expand ExpandAll ExpandDenominator ExpandFileName ExpandNumerator Expectation ExpectationE ExpectedValue ExpGammaDistribution ExpIntegralE ExpIntegralEi Exponent ExponentFunction ExponentialDistribution ExponentialFamily ExponentialGeneratingFunction ExponentialMovingAverage ExponentialPowerDistribution ExponentPosition ExponentStep Export ExportAutoReplacements ExportPacket ExportString Expression ExpressionCell ExpressionPacket ExpToTrig ExtendedGCD Extension ExtentElementFunction ExtentMarkers ExtentSize ExternalCall ExternalDataCharacterEncoding Extract ExtractArchive ExtremeValueDistribution FaceForm FaceGrids FaceGridsStyle Factor FactorComplete Factorial Factorial2 FactorialMoment FactorialMomentGeneratingFunction FactorialPower FactorInteger FactorList FactorSquareFree FactorSquareFreeList FactorTerms FactorTermsList Fail FailureDistribution False FARIMAProcess FEDisableConsolePrintPacket FeedbackSector FeedbackSectorStyle FeedbackType FEEnableConsolePrintPacket Fibonacci FieldHint FieldHintStyle FieldMasked FieldSize File FileBaseName FileByteCount FileDate FileExistsQ FileExtension FileFormat FileHash FileInformation FileName FileNameDepth FileNameDialogSettings FileNameDrop FileNameJoin FileNames FileNameSetter FileNameSplit FileNameTake FilePrint FileType FilledCurve FilledCurveBox Filling FillingStyle FillingTransform FilterRules FinancialBond FinancialData FinancialDerivative FinancialIndicator Find FindArgMax FindArgMin FindClique FindClusters FindCurvePath FindDistributionParameters FindDivisions FindEdgeCover FindEdgeCut FindEulerianCycle FindFaces FindFile FindFit FindGeneratingFunction FindGeoLocation FindGeometricTransform FindGraphCommunities FindGraphIsomorphism FindGraphPartition FindHamiltonianCycle FindIndependentEdgeSet FindIndependentVertexSet FindInstance FindIntegerNullVector FindKClan FindKClique FindKClub FindKPlex FindLibrary FindLinearRecurrence FindList FindMaximum FindMaximumFlow FindMaxValue FindMinimum FindMinimumCostFlow FindMinimumCut FindMinValue FindPermutation FindPostmanTour FindProcessParameters FindRoot FindSequenceFunction FindSettings FindShortestPath FindShortestTour FindThreshold FindVertexCover FindVertexCut Fine FinishDynamic FiniteAbelianGroupCount FiniteGroupCount FiniteGroupData First FirstPassageTimeDistribution FischerGroupFi22 FischerGroupFi23 FischerGroupFi24Prime FisherHypergeometricDistribution FisherRatioTest FisherZDistribution Fit FitAll FittedModel FixedPoint FixedPointList FlashSelection Flat Flatten FlattenAt FlatTopWindow FlipView Floor FlushPrintOutputPacket Fold FoldList Font FontColor FontFamily FontForm FontName FontOpacity FontPostScriptName FontProperties FontReencoding FontSize FontSlant FontSubstitutions FontTracking FontVariations FontWeight For ForAll Format FormatRules FormatType FormatTypeAutoConvert FormatValues FormBox FormBoxOptions FortranForm Forward ForwardBackward Fourier FourierCoefficient FourierCosCoefficient FourierCosSeries FourierCosTransform FourierDCT FourierDCTFilter FourierDCTMatrix FourierDST FourierDSTMatrix FourierMatrix FourierParameters FourierSequenceTransform FourierSeries FourierSinCoefficient FourierSinSeries FourierSinTransform FourierTransform FourierTrigSeries FractionalBrownianMotionProcess FractionalPart FractionBox FractionBoxOptions FractionLine Frame FrameBox FrameBoxOptions Framed FrameInset FrameLabel Frameless FrameMargins FrameStyle FrameTicks FrameTicksStyle FRatioDistribution FrechetDistribution FreeQ FrequencySamplingFilterKernel FresnelC FresnelS Friday FrobeniusNumber FrobeniusSolve FromCharacterCode FromCoefficientRules FromContinuedFraction FromDate FromDigits FromDMS Front FrontEndDynamicExpression FrontEndEventActions FrontEndExecute FrontEndObject FrontEndResource FrontEndResourceString FrontEndStackSize FrontEndToken FrontEndTokenExecute FrontEndValueCache FrontEndVersion FrontFaceColor FrontFaceOpacity Full FullAxes FullDefinition FullForm FullGraphics FullOptions FullSimplify Function FunctionExpand FunctionInterpolation FunctionSpace FussellVeselyImportance GaborFilter GaborMatrix GaborWavelet GainMargins GainPhaseMargins Gamma GammaDistribution GammaRegularized GapPenalty Gather GatherBy GaugeFaceElementFunction GaugeFaceStyle GaugeFrameElementFunction GaugeFrameSize GaugeFrameStyle GaugeLabels GaugeMarkers GaugeStyle GaussianFilter GaussianIntegers GaussianMatrix GaussianWindow GCD GegenbauerC General GeneralizedLinearModelFit GenerateConditions GeneratedCell GeneratedParameters GeneratingFunction Generic GenericCylindricalDecomposition GenomeData GenomeLookup GeodesicClosing GeodesicDilation GeodesicErosion GeodesicOpening GeoDestination GeodesyData GeoDirection GeoDistance GeoGridPosition GeometricBrownianMotionProcess GeometricDistribution GeometricMean GeometricMeanFilter GeometricTransformation GeometricTransformation3DBox GeometricTransformation3DBoxOptions GeometricTransformationBox GeometricTransformationBoxOptions GeoPosition GeoPositionENU GeoPositionXYZ GeoProjectionData GestureHandler GestureHandlerTag Get GetBoundingBoxSizePacket GetContext GetEnvironment GetFileName GetFrontEndOptionsDataPacket GetLinebreakInformationPacket GetMenusPacket GetPageBreakInformationPacket Glaisher GlobalClusteringCoefficient GlobalPreferences GlobalSession Glow GoldenRatio GompertzMakehamDistribution GoodmanKruskalGamma GoodmanKruskalGammaTest Goto Grad Gradient GradientFilter GradientOrientationFilter Graph GraphAssortativity GraphCenter GraphComplement GraphData GraphDensity GraphDiameter GraphDifference GraphDisjointUnion GraphDistance GraphDistanceMatrix GraphElementData GraphEmbedding GraphHighlight GraphHighlightStyle GraphHub Graphics Graphics3D Graphics3DBox Graphics3DBoxOptions GraphicsArray GraphicsBaseline GraphicsBox GraphicsBoxOptions GraphicsColor GraphicsColumn GraphicsComplex GraphicsComplex3DBox GraphicsComplex3DBoxOptions GraphicsComplexBox GraphicsComplexBoxOptions GraphicsContents GraphicsData GraphicsGrid GraphicsGridBox GraphicsGroup GraphicsGroup3DBox GraphicsGroup3DBoxOptions GraphicsGroupBox GraphicsGroupBoxOptions GraphicsGrouping GraphicsHighlightColor GraphicsRow GraphicsSpacing GraphicsStyle GraphIntersection GraphLayout GraphLinkEfficiency GraphPeriphery GraphPlot GraphPlot3D GraphPower GraphPropertyDistribution GraphQ GraphRadius GraphReciprocity GraphRoot GraphStyle GraphUnion Gray GrayLevel GreatCircleDistance Greater GreaterEqual GreaterEqualLess GreaterFullEqual GreaterGreater GreaterLess GreaterSlantEqual GreaterTilde Green Grid GridBaseline GridBox GridBoxAlignment GridBoxBackground GridBoxDividers GridBoxFrame GridBoxItemSize GridBoxItemStyle GridBoxOptions GridBoxSpacings GridCreationSettings GridDefaultElement GridElementStyleOptions GridFrame GridFrameMargins GridGraph GridLines GridLinesStyle GroebnerBasis GroupActionBase GroupCentralizer GroupElementFromWord GroupElementPosition GroupElementQ GroupElements GroupElementToWord GroupGenerators GroupMultiplicationTable GroupOrbits GroupOrder GroupPageBreakWithin GroupSetwiseStabilizer GroupStabilizer GroupStabilizerChain Gudermannian GumbelDistribution HaarWavelet HadamardMatrix HalfNormalDistribution HamiltonianGraphQ HammingDistance HammingWindow HankelH1 HankelH2 HankelMatrix HannPoissonWindow HannWindow HaradaNortonGroupHN HararyGraph HarmonicMean HarmonicMeanFilter HarmonicNumber Hash HashTable Haversine HazardFunction Head HeadCompose Heads HeavisideLambda HeavisidePi HeavisideTheta HeldGroupHe HeldPart HelpBrowserLookup HelpBrowserNotebook HelpBrowserSettings HermiteDecomposition HermiteH HermitianMatrixQ HessenbergDecomposition Hessian HexadecimalCharacter Hexahedron HexahedronBox HexahedronBoxOptions HiddenSurface HighlightGraph HighlightImage HighpassFilter HigmanSimsGroupHS HilbertFilter HilbertMatrix Histogram Histogram3D HistogramDistribution HistogramList HistogramTransform HistogramTransformInterpolation HitMissTransform HITSCentrality HodgeDual HoeffdingD HoeffdingDTest Hold HoldAll HoldAllComplete HoldComplete HoldFirst HoldForm HoldPattern HoldRest HolidayCalendar HomeDirectory HomePage Horizontal HorizontalForm HorizontalGauge HorizontalScrollPosition HornerForm HotellingTSquareDistribution HoytDistribution HTMLSave Hue HumpDownHump HumpEqual HurwitzLerchPhi HurwitzZeta HyperbolicDistribution HypercubeGraph HyperexponentialDistribution Hyperfactorial Hypergeometric0F1 Hypergeometric0F1Regularized Hypergeometric1F1 Hypergeometric1F1Regularized Hypergeometric2F1 Hypergeometric2F1Regularized HypergeometricDistribution HypergeometricPFQ HypergeometricPFQRegularized HypergeometricU Hyperlink HyperlinkCreationSettings Hyphenation HyphenationOptions HypoexponentialDistribution HypothesisTestData I Identity IdentityMatrix If IgnoreCase Im Image Image3D Image3DSlices ImageAccumulate ImageAdd ImageAdjust ImageAlign ImageApply ImageAspectRatio ImageAssemble ImageCache ImageCacheValid ImageCapture ImageChannels ImageClip ImageColorSpace ImageCompose ImageConvolve ImageCooccurrence ImageCorners ImageCorrelate ImageCorrespondingPoints ImageCrop ImageData ImageDataPacket ImageDeconvolve ImageDemosaic ImageDifference ImageDimensions ImageDistance ImageEffect ImageFeatureTrack ImageFileApply ImageFileFilter ImageFileScan ImageFilter ImageForestingComponents ImageForwardTransformation ImageHistogram ImageKeypoints ImageLevels ImageLines ImageMargins ImageMarkers ImageMeasurements ImageMultiply ImageOffset ImagePad ImagePadding ImagePartition ImagePeriodogram ImagePerspectiveTransformation ImageQ ImageRangeCache ImageReflect ImageRegion ImageResize ImageResolution ImageRotate ImageRotated ImageScaled ImageScan ImageSize ImageSizeAction ImageSizeCache ImageSizeMultipliers ImageSizeRaw ImageSubtract ImageTake ImageTransformation ImageTrim ImageType ImageValue ImageValuePositions Implies Import ImportAutoReplacements ImportString ImprovementImportance In IncidenceGraph IncidenceList IncidenceMatrix IncludeConstantBasis IncludeFileExtension IncludePods IncludeSingularTerm Increment Indent IndentingNewlineSpacings IndentMaxFraction IndependenceTest IndependentEdgeSetQ IndependentUnit IndependentVertexSetQ Indeterminate IndexCreationOptions Indexed IndexGraph IndexTag Inequality InexactNumberQ InexactNumbers Infinity Infix Information Inherited InheritScope Initialization InitializationCell InitializationCellEvaluation InitializationCellWarning InlineCounterAssignments InlineCounterIncrements InlineRules Inner Inpaint Input InputAliases InputAssumptions InputAutoReplacements InputField InputFieldBox InputFieldBoxOptions InputForm InputGrouping InputNamePacket InputNotebook InputPacket InputSettings InputStream InputString InputStringPacket InputToBoxFormPacket Insert InsertionPointObject InsertResults Inset Inset3DBox Inset3DBoxOptions InsetBox InsetBoxOptions Install InstallService InString Integer IntegerDigits IntegerExponent IntegerLength IntegerPart IntegerPartitions IntegerQ Integers IntegerString Integral Integrate Interactive InteractiveTradingChart Interlaced Interleaving InternallyBalancedDecomposition InterpolatingFunction InterpolatingPolynomial Interpolation InterpolationOrder InterpolationPoints InterpolationPrecision Interpretation InterpretationBox InterpretationBoxOptions InterpretationFunction InterpretTemplate InterquartileRange Interrupt InterruptSettings Intersection Interval IntervalIntersection IntervalMemberQ IntervalUnion Inverse InverseBetaRegularized InverseCDF InverseChiSquareDistribution InverseContinuousWaveletTransform InverseDistanceTransform InverseEllipticNomeQ InverseErf InverseErfc InverseFourier InverseFourierCosTransform InverseFourierSequenceTransform InverseFourierSinTransform InverseFourierTransform InverseFunction InverseFunctions InverseGammaDistribution InverseGammaRegularized InverseGaussianDistribution InverseGudermannian InverseHaversine InverseJacobiCD InverseJacobiCN InverseJacobiCS InverseJacobiDC InverseJacobiDN InverseJacobiDS InverseJacobiNC InverseJacobiND InverseJacobiNS InverseJacobiSC InverseJacobiSD InverseJacobiSN InverseLaplaceTransform InversePermutation InverseRadon InverseSeries InverseSurvivalFunction InverseWaveletTransform InverseWeierstrassP InverseZTransform Invisible InvisibleApplication InvisibleTimes IrreduciblePolynomialQ IsolatingInterval IsomorphicGraphQ IsotopeData Italic Item ItemBox ItemBoxOptions ItemSize ItemStyle ItoProcess JaccardDissimilarity JacobiAmplitude Jacobian JacobiCD JacobiCN JacobiCS JacobiDC JacobiDN JacobiDS JacobiNC JacobiND JacobiNS JacobiP JacobiSC JacobiSD JacobiSN JacobiSymbol JacobiZeta JankoGroupJ1 JankoGroupJ2 JankoGroupJ3 JankoGroupJ4 JarqueBeraALMTest JohnsonDistribution Join Joined JoinedCurve JoinedCurveBox JoinForm JordanDecomposition JordanModelDecomposition K KagiChart KaiserBesselWindow KaiserWindow KalmanEstimator KalmanFilter KarhunenLoeveDecomposition KaryTree KatzCentrality KCoreComponents KDistribution KelvinBei KelvinBer KelvinKei KelvinKer KendallTau KendallTauTest KernelExecute KernelMixtureDistribution KernelObject Kernels Ket Khinchin KirchhoffGraph KirchhoffMatrix KleinInvariantJ KnightTourGraph KnotData KnownUnitQ KolmogorovSmirnovTest KroneckerDelta KroneckerModelDecomposition KroneckerProduct KroneckerSymbol KuiperTest KumaraswamyDistribution Kurtosis KuwaharaFilter Label Labeled LabeledSlider LabelingFunction LabelStyle LaguerreL LambdaComponents LambertW LanczosWindow LandauDistribution Language LanguageCategory LaplaceDistribution LaplaceTransform Laplacian LaplacianFilter LaplacianGaussianFilter Large Larger Last Latitude LatitudeLongitude LatticeData LatticeReduce Launch LaunchKernels LayeredGraphPlot LayerSizeFunction LayoutInformation LCM LeafCount LeapYearQ LeastSquares LeastSquaresFilterKernel Left LeftArrow LeftArrowBar LeftArrowRightArrow LeftDownTeeVector LeftDownVector LeftDownVectorBar LeftRightArrow LeftRightVector LeftTee LeftTeeArrow LeftTeeVector LeftTriangle LeftTriangleBar LeftTriangleEqual LeftUpDownVector LeftUpTeeVector LeftUpVector LeftUpVectorBar LeftVector LeftVectorBar LegendAppearance Legended LegendFunction LegendLabel LegendLayout LegendMargins LegendMarkers LegendMarkerSize LegendreP LegendreQ LegendreType Length LengthWhile LerchPhi Less LessEqual LessEqualGreater LessFullEqual LessGreater LessLess LessSlantEqual LessTilde LetterCharacter LetterQ Level LeveneTest LeviCivitaTensor LevyDistribution Lexicographic LibraryFunction LibraryFunctionError LibraryFunctionInformation LibraryFunctionLoad LibraryFunctionUnload LibraryLoad LibraryUnload LicenseID LiftingFilterData LiftingWaveletTransform LightBlue LightBrown LightCyan Lighter LightGray LightGreen Lighting LightingAngle LightMagenta LightOrange LightPink LightPurple LightRed LightSources LightYellow Likelihood Limit LimitsPositioning LimitsPositioningTokens LindleyDistribution Line Line3DBox LinearFilter LinearFractionalTransform LinearModelFit LinearOffsetFunction LinearProgramming LinearRecurrence LinearSolve LinearSolveFunction LineBox LineBreak LinebreakAdjustments LineBreakChart LineBreakWithin LineColor LineForm LineGraph LineIndent LineIndentMaxFraction LineIntegralConvolutionPlot LineIntegralConvolutionScale LineLegend LineOpacity LineSpacing LineWrapParts LinkActivate LinkClose LinkConnect LinkConnectedQ LinkCreate LinkError LinkFlush LinkFunction LinkHost LinkInterrupt LinkLaunch LinkMode LinkObject LinkOpen LinkOptions LinkPatterns LinkProtocol LinkRead LinkReadHeld LinkReadyQ Links LinkWrite LinkWriteHeld LiouvilleLambda List Listable ListAnimate ListContourPlot ListContourPlot3D ListConvolve ListCorrelate ListCurvePathPlot ListDeconvolve ListDensityPlot Listen ListFourierSequenceTransform ListInterpolation ListLineIntegralConvolutionPlot ListLinePlot ListLogLinearPlot ListLogLogPlot ListLogPlot ListPicker ListPickerBox ListPickerBoxBackground ListPickerBoxOptions ListPlay ListPlot ListPlot3D ListPointPlot3D ListPolarPlot ListQ ListStreamDensityPlot ListStreamPlot ListSurfacePlot3D ListVectorDensityPlot ListVectorPlot ListVectorPlot3D ListZTransform Literal LiteralSearch LocalClusteringCoefficient LocalizeVariables LocationEquivalenceTest LocationTest Locator LocatorAutoCreate LocatorBox LocatorBoxOptions LocatorCentering LocatorPane LocatorPaneBox LocatorPaneBoxOptions LocatorRegion Locked Log Log10 Log2 LogBarnesG LogGamma LogGammaDistribution LogicalExpand LogIntegral LogisticDistribution LogitModelFit LogLikelihood LogLinearPlot LogLogisticDistribution LogLogPlot LogMultinormalDistribution LogNormalDistribution LogPlot LogRankTest LogSeriesDistribution LongEqual Longest LongestAscendingSequence LongestCommonSequence LongestCommonSequencePositions LongestCommonSubsequence LongestCommonSubsequencePositions LongestMatch LongForm Longitude LongLeftArrow LongLeftRightArrow LongRightArrow Loopback LoopFreeGraphQ LowerCaseQ LowerLeftArrow LowerRightArrow LowerTriangularize LowpassFilter LQEstimatorGains LQGRegulator LQOutputRegulatorGains LQRegulatorGains LUBackSubstitution LucasL LuccioSamiComponents LUDecomposition LyapunovSolve LyonsGroupLy MachineID MachineName MachineNumberQ MachinePrecision MacintoshSystemPageSetup Magenta Magnification Magnify MainSolve MaintainDynamicCaches Majority MakeBoxes MakeExpression MakeRules MangoldtLambda ManhattanDistance Manipulate Manipulator MannWhitneyTest MantissaExponent Manual Map MapAll MapAt MapIndexed MAProcess MapThread MarcumQ MardiaCombinedTest MardiaKurtosisTest MardiaSkewnessTest MarginalDistribution MarkovProcessProperties Masking MatchingDissimilarity MatchLocalNameQ MatchLocalNames MatchQ Material MathematicaNotation MathieuC MathieuCharacteristicA MathieuCharacteristicB MathieuCharacteristicExponent MathieuCPrime MathieuGroupM11 MathieuGroupM12 MathieuGroupM22 MathieuGroupM23 MathieuGroupM24 MathieuS MathieuSPrime MathMLForm MathMLText Matrices MatrixExp MatrixForm MatrixFunction MatrixLog MatrixPlot MatrixPower MatrixQ MatrixRank Max MaxBend MaxDetect MaxExtraBandwidths MaxExtraConditions MaxFeatures MaxFilter Maximize MaxIterations MaxMemoryUsed MaxMixtureKernels MaxPlotPoints MaxPoints MaxRecursion MaxStableDistribution MaxStepFraction MaxSteps MaxStepSize MaxValue MaxwellDistribution McLaughlinGroupMcL Mean MeanClusteringCoefficient MeanDegreeConnectivity MeanDeviation MeanFilter MeanGraphDistance MeanNeighborDegree MeanShift MeanShiftFilter Median MedianDeviation MedianFilter Medium MeijerG MeixnerDistribution MemberQ MemoryConstrained MemoryInUse Menu MenuAppearance MenuCommandKey MenuEvaluator MenuItem MenuPacket MenuSortingValue MenuStyle MenuView MergeDifferences Mesh MeshFunctions MeshRange MeshShading MeshStyle Message MessageDialog MessageList MessageName MessageOptions MessagePacket Messages MessagesNotebook MetaCharacters MetaInformation Method MethodOptions MexicanHatWavelet MeyerWavelet Min MinDetect MinFilter MinimalPolynomial MinimalStateSpaceModel Minimize Minors MinRecursion MinSize MinStableDistribution Minus MinusPlus MinValue Missing MissingDataMethod MittagLefflerE MixedRadix MixedRadixQuantity MixtureDistribution Mod Modal Mode Modular ModularLambda Module Modulus MoebiusMu Moment Momentary MomentConvert MomentEvaluate MomentGeneratingFunction Monday Monitor MonomialList MonomialOrder MonsterGroupM MorletWavelet MorphologicalBinarize MorphologicalBranchPoints MorphologicalComponents MorphologicalEulerNumber MorphologicalGraph MorphologicalPerimeter MorphologicalTransform Most MouseAnnotation MouseAppearance MouseAppearanceTag MouseButtons Mouseover MousePointerNote MousePosition MovingAverage MovingMedian MoyalDistribution MultiedgeStyle MultilaunchWarning MultiLetterItalics MultiLetterStyle MultilineFunction Multinomial MultinomialDistribution MultinormalDistribution MultiplicativeOrder Multiplicity Multiselection MultivariateHypergeometricDistribution MultivariatePoissonDistribution MultivariateTDistribution N NakagamiDistribution NameQ Names NamespaceBox Nand NArgMax NArgMin NBernoulliB NCache NDSolve NDSolveValue Nearest NearestFunction NeedCurrentFrontEndPackagePacket NeedCurrentFrontEndSymbolsPacket NeedlemanWunschSimilarity Needs Negative NegativeBinomialDistribution NegativeMultinomialDistribution NeighborhoodGraph Nest NestedGreaterGreater NestedLessLess NestedScriptRules NestList NestWhile NestWhileList NevilleThetaC NevilleThetaD NevilleThetaN NevilleThetaS NewPrimitiveStyle NExpectation Next NextPrime NHoldAll NHoldFirst NHoldRest NicholsGridLines NicholsPlot NIntegrate NMaximize NMaxValue NMinimize NMinValue NominalVariables NonAssociative NoncentralBetaDistribution NoncentralChiSquareDistribution NoncentralFRatioDistribution NoncentralStudentTDistribution NonCommutativeMultiply NonConstants None NonlinearModelFit NonlocalMeansFilter NonNegative NonPositive Nor NorlundB Norm Normal NormalDistribution NormalGrouping Normalize NormalizedSquaredEuclideanDistance NormalsFunction NormFunction Not NotCongruent NotCupCap NotDoubleVerticalBar Notebook NotebookApply NotebookAutoSave NotebookClose NotebookConvertSettings NotebookCreate NotebookCreateReturnObject NotebookDefault NotebookDelete NotebookDirectory NotebookDynamicExpression NotebookEvaluate NotebookEventActions NotebookFileName NotebookFind NotebookFindReturnObject NotebookGet NotebookGetLayoutInformationPacket NotebookGetMisspellingsPacket NotebookInformation NotebookInterfaceObject NotebookLocate NotebookObject NotebookOpen NotebookOpenReturnObject NotebookPath NotebookPrint NotebookPut NotebookPutReturnObject NotebookRead NotebookResetGeneratedCells Notebooks NotebookSave NotebookSaveAs NotebookSelection NotebookSetupLayoutInformationPacket NotebooksMenu NotebookWrite NotElement NotEqualTilde NotExists NotGreater NotGreaterEqual NotGreaterFullEqual NotGreaterGreater NotGreaterLess NotGreaterSlantEqual NotGreaterTilde NotHumpDownHump NotHumpEqual NotLeftTriangle NotLeftTriangleBar NotLeftTriangleEqual NotLess NotLessEqual NotLessFullEqual NotLessGreater NotLessLess NotLessSlantEqual NotLessTilde NotNestedGreaterGreater NotNestedLessLess NotPrecedes NotPrecedesEqual NotPrecedesSlantEqual NotPrecedesTilde NotReverseElement NotRightTriangle NotRightTriangleBar NotRightTriangleEqual NotSquareSubset NotSquareSubsetEqual NotSquareSuperset NotSquareSupersetEqual NotSubset NotSubsetEqual NotSucceeds NotSucceedsEqual NotSucceedsSlantEqual NotSucceedsTilde NotSuperset NotSupersetEqual NotTilde NotTildeEqual NotTildeFullEqual NotTildeTilde NotVerticalBar NProbability NProduct NProductFactors NRoots NSolve NSum NSumTerms Null NullRecords NullSpace NullWords Number NumberFieldClassNumber NumberFieldDiscriminant NumberFieldFundamentalUnits NumberFieldIntegralBasis NumberFieldNormRepresentatives NumberFieldRegulator NumberFieldRootsOfUnity NumberFieldSignature NumberForm NumberFormat NumberMarks NumberMultiplier NumberPadding NumberPoint NumberQ NumberSeparator NumberSigns NumberString Numerator NumericFunction NumericQ NuttallWindow NValues NyquistGridLines NyquistPlot O ObservabilityGramian ObservabilityMatrix ObservableDecomposition ObservableModelQ OddQ Off Offset OLEData On ONanGroupON OneIdentity Opacity Open OpenAppend Opener OpenerBox OpenerBoxOptions OpenerView OpenFunctionInspectorPacket Opening OpenRead OpenSpecialOptions OpenTemporary OpenWrite Operate OperatingSystem OptimumFlowData Optional OptionInspectorSettings OptionQ Options OptionsPacket OptionsPattern OptionValue OptionValueBox OptionValueBoxOptions Or Orange Order OrderDistribution OrderedQ Ordering Orderless OrnsteinUhlenbeckProcess Orthogonalize Out Outer OutputAutoOverwrite OutputControllabilityMatrix OutputControllableModelQ OutputForm OutputFormData OutputGrouping OutputMathEditExpression OutputNamePacket OutputResponse OutputSizeLimit OutputStream Over OverBar OverDot Overflow OverHat Overlaps Overlay OverlayBox OverlayBoxOptions Overscript OverscriptBox OverscriptBoxOptions OverTilde OverVector OwenT OwnValues PackingMethod PaddedForm Padding PadeApproximant PadLeft PadRight PageBreakAbove PageBreakBelow PageBreakWithin PageFooterLines PageFooters PageHeaderLines PageHeaders PageHeight PageRankCentrality PageWidth PairedBarChart PairedHistogram PairedSmoothHistogram PairedTTest PairedZTest PaletteNotebook PalettePath Pane PaneBox PaneBoxOptions Panel PanelBox PanelBoxOptions Paneled PaneSelector PaneSelectorBox PaneSelectorBoxOptions PaperWidth ParabolicCylinderD ParagraphIndent ParagraphSpacing ParallelArray ParallelCombine ParallelDo ParallelEvaluate Parallelization Parallelize ParallelMap ParallelNeeds ParallelProduct ParallelSubmit ParallelSum ParallelTable ParallelTry Parameter ParameterEstimator ParameterMixtureDistribution ParameterVariables ParametricFunction ParametricNDSolve ParametricNDSolveValue ParametricPlot ParametricPlot3D ParentConnect ParentDirectory ParentForm Parenthesize ParentList ParetoDistribution Part PartialCorrelationFunction PartialD ParticleData Partition PartitionsP PartitionsQ ParzenWindow PascalDistribution PassEventsDown PassEventsUp Paste PasteBoxFormInlineCells PasteButton Path PathGraph PathGraphQ Pattern PatternSequence PatternTest PauliMatrix PaulWavelet Pause PausedTime PDF PearsonChiSquareTest PearsonCorrelationTest PearsonDistribution PerformanceGoal PeriodicInterpolation Periodogram PeriodogramArray PermutationCycles PermutationCyclesQ PermutationGroup PermutationLength PermutationList PermutationListQ PermutationMax PermutationMin PermutationOrder PermutationPower PermutationProduct PermutationReplace Permutations PermutationSupport Permute PeronaMalikFilter Perpendicular PERTDistribution PetersenGraph PhaseMargins Pi Pick PIDData PIDDerivativeFilter PIDFeedforward PIDTune Piecewise PiecewiseExpand PieChart PieChart3D PillaiTrace PillaiTraceTest Pink Pivoting PixelConstrained PixelValue PixelValuePositions Placed Placeholder PlaceholderReplace Plain PlanarGraphQ Play PlayRange Plot Plot3D Plot3Matrix PlotDivision PlotJoined PlotLabel PlotLayout PlotLegends PlotMarkers PlotPoints PlotRange PlotRangeClipping PlotRangePadding PlotRegion PlotStyle Plus PlusMinus Pochhammer PodStates PodWidth Point Point3DBox PointBox PointFigureChart PointForm PointLegend PointSize PoissonConsulDistribution PoissonDistribution PoissonProcess PoissonWindow PolarAxes PolarAxesOrigin PolarGridLines PolarPlot PolarTicks PoleZeroMarkers PolyaAeppliDistribution PolyGamma Polygon Polygon3DBox Polygon3DBoxOptions PolygonBox PolygonBoxOptions PolygonHoleScale PolygonIntersections PolygonScale PolyhedronData PolyLog PolynomialExtendedGCD PolynomialForm PolynomialGCD PolynomialLCM PolynomialMod PolynomialQ PolynomialQuotient PolynomialQuotientRemainder PolynomialReduce PolynomialRemainder Polynomials PopupMenu PopupMenuBox PopupMenuBoxOptions PopupView PopupWindow Position Positive PositiveDefiniteMatrixQ PossibleZeroQ Postfix PostScript Power PowerDistribution PowerExpand PowerMod PowerModList PowerSpectralDensity PowersRepresentations PowerSymmetricPolynomial Precedence PrecedenceForm Precedes PrecedesEqual PrecedesSlantEqual PrecedesTilde Precision PrecisionGoal PreDecrement PredictionRoot PreemptProtect PreferencesPath Prefix PreIncrement Prepend PrependTo PreserveImageOptions Previous PriceGraphDistribution PrimaryPlaceholder Prime PrimeNu PrimeOmega PrimePi PrimePowerQ PrimeQ Primes PrimeZetaP PrimitiveRoot PrincipalComponents PrincipalValue Print PrintAction PrintForm PrintingCopies PrintingOptions PrintingPageRange PrintingStartingPageNumber PrintingStyleEnvironment PrintPrecision PrintTemporary Prism PrismBox PrismBoxOptions PrivateCellOptions PrivateEvaluationOptions PrivateFontOptions PrivateFrontEndOptions PrivateNotebookOptions PrivatePaths Probability ProbabilityDistribution ProbabilityPlot ProbabilityPr ProbabilityScalePlot ProbitModelFit ProcessEstimator ProcessParameterAssumptions ProcessParameterQ ProcessStateDomain ProcessTimeDomain Product ProductDistribution ProductLog ProgressIndicator ProgressIndicatorBox ProgressIndicatorBoxOptions Projection Prolog PromptForm Properties Property PropertyList PropertyValue Proportion Proportional Protect Protected ProteinData Pruning PseudoInverse Purple Put PutAppend Pyramid PyramidBox PyramidBoxOptions QBinomial QFactorial QGamma QHypergeometricPFQ QPochhammer QPolyGamma QRDecomposition QuadraticIrrationalQ Quantile QuantilePlot Quantity QuantityForm QuantityMagnitude QuantityQ QuantityUnit Quartics QuartileDeviation Quartiles QuartileSkewness QueueingNetworkProcess QueueingProcess QueueProperties Quiet Quit Quotient QuotientRemainder RadialityCentrality RadicalBox RadicalBoxOptions RadioButton RadioButtonBar RadioButtonBox RadioButtonBoxOptions Radon RamanujanTau RamanujanTauL RamanujanTauTheta RamanujanTauZ Random RandomChoice RandomComplex RandomFunction RandomGraph RandomImage RandomInteger RandomPermutation RandomPrime RandomReal RandomSample RandomSeed RandomVariate RandomWalkProcess Range RangeFilter RangeSpecification RankedMax RankedMin Raster Raster3D Raster3DBox Raster3DBoxOptions RasterArray RasterBox RasterBoxOptions Rasterize RasterSize Rational RationalFunctions Rationalize Rationals Ratios Raw RawArray RawBoxes RawData RawMedium RayleighDistribution Re Read ReadList ReadProtected Real RealBlockDiagonalForm RealDigits RealExponent Reals Reap Record RecordLists RecordSeparators Rectangle RectangleBox RectangleBoxOptions RectangleChart RectangleChart3D RecurrenceFilter RecurrenceTable RecurringDigitsForm Red Reduce RefBox ReferenceLineStyle ReferenceMarkers ReferenceMarkerStyle Refine ReflectionMatrix ReflectionTransform Refresh RefreshRate RegionBinarize RegionFunction RegionPlot RegionPlot3D RegularExpression Regularization Reinstall Release ReleaseHold ReliabilityDistribution ReliefImage ReliefPlot Remove RemoveAlphaChannel RemoveAsynchronousTask Removed RemoveInputStreamMethod RemoveOutputStreamMethod RemoveProperty RemoveScheduledTask RenameDirectory RenameFile RenderAll RenderingOptions RenewalProcess RenkoChart Repeated RepeatedNull RepeatedString Replace ReplaceAll ReplaceHeldPart ReplaceImageValue ReplaceList ReplacePart ReplacePixelValue ReplaceRepeated Resampling Rescale RescalingTransform ResetDirectory ResetMenusPacket ResetScheduledTask Residue Resolve Rest Resultant ResumePacket Return ReturnExpressionPacket ReturnInputFormPacket ReturnPacket ReturnTextPacket Reverse ReverseBiorthogonalSplineWavelet ReverseElement ReverseEquilibrium ReverseGraph ReverseUpEquilibrium RevolutionAxis RevolutionPlot3D RGBColor RiccatiSolve RiceDistribution RidgeFilter RiemannR RiemannSiegelTheta RiemannSiegelZ Riffle Right RightArrow RightArrowBar RightArrowLeftArrow RightCosetRepresentative RightDownTeeVector RightDownVector RightDownVectorBar RightTee RightTeeArrow RightTeeVector RightTriangle RightTriangleBar RightTriangleEqual RightUpDownVector RightUpTeeVector RightUpVector RightUpVectorBar RightVector RightVectorBar RiskAchievementImportance RiskReductionImportance RogersTanimotoDissimilarity Root RootApproximant RootIntervals RootLocusPlot RootMeanSquare RootOfUnityQ RootReduce Roots RootSum Rotate RotateLabel RotateLeft RotateRight RotationAction RotationBox RotationBoxOptions RotationMatrix RotationTransform Round RoundImplies RoundingRadius Row RowAlignments RowBackgrounds RowBox RowHeights RowLines RowMinHeight RowReduce RowsEqual RowSpacings RSolve RudvalisGroupRu Rule RuleCondition RuleDelayed RuleForm RulerUnits Run RunScheduledTask RunThrough RuntimeAttributes RuntimeOptions RussellRaoDissimilarity SameQ SameTest SampleDepth SampledSoundFunction SampledSoundList SampleRate SamplingPeriod SARIMAProcess SARMAProcess SatisfiabilityCount SatisfiabilityInstances SatisfiableQ Saturday Save Saveable SaveAutoDelete SaveDefinitions SawtoothWave Scale Scaled ScaleDivisions ScaledMousePosition ScaleOrigin ScalePadding ScaleRanges ScaleRangeStyle ScalingFunctions ScalingMatrix ScalingTransform Scan ScheduledTaskActiveQ ScheduledTaskData ScheduledTaskObject ScheduledTasks SchurDecomposition ScientificForm ScreenRectangle ScreenStyleEnvironment ScriptBaselineShifts ScriptLevel ScriptMinSize ScriptRules ScriptSizeMultipliers Scrollbars ScrollingOptions ScrollPosition Sec Sech SechDistribution SectionGrouping SectorChart SectorChart3D SectorOrigin SectorSpacing SeedRandom Select Selectable SelectComponents SelectedCells SelectedNotebook Selection SelectionAnimate SelectionCell SelectionCellCreateCell SelectionCellDefaultStyle SelectionCellParentStyle SelectionCreateCell SelectionDebuggerTag SelectionDuplicateCell SelectionEvaluate SelectionEvaluateCreateCell SelectionMove SelectionPlaceholder SelectionSetStyle SelectWithContents SelfLoops SelfLoopStyle SemialgebraicComponentInstances SendMail Sequence SequenceAlignment SequenceForm SequenceHold SequenceLimit Series SeriesCoefficient SeriesData SessionTime Set SetAccuracy SetAlphaChannel SetAttributes Setbacks SetBoxFormNamesPacket SetDelayed SetDirectory SetEnvironment SetEvaluationNotebook SetFileDate SetFileLoadingContext SetNotebookStatusLine SetOptions SetOptionsPacket SetPrecision SetProperty SetSelectedNotebook SetSharedFunction SetSharedVariable SetSpeechParametersPacket SetStreamPosition SetSystemOptions Setter SetterBar SetterBox SetterBoxOptions Setting SetValue Shading Shallow ShannonWavelet ShapiroWilkTest Share Sharpen ShearingMatrix ShearingTransform ShenCastanMatrix Short ShortDownArrow Shortest ShortestMatch ShortestPathFunction ShortLeftArrow ShortRightArrow ShortUpArrow Show ShowAutoStyles ShowCellBracket ShowCellLabel ShowCellTags ShowClosedCellArea ShowContents ShowControls ShowCursorTracker ShowGroupOpenCloseIcon ShowGroupOpener ShowInvisibleCharacters ShowPageBreaks ShowPredictiveInterface ShowSelection ShowShortBoxForm ShowSpecialCharacters ShowStringCharacters ShowSyntaxStyles ShrinkingDelay ShrinkWrapBoundingBox SiegelTheta SiegelTukeyTest Sign Signature SignedRankTest SignificanceLevel SignPadding SignTest SimilarityRules SimpleGraph SimpleGraphQ Simplify Sin Sinc SinghMaddalaDistribution SingleEvaluation SingleLetterItalics SingleLetterStyle SingularValueDecomposition SingularValueList SingularValuePlot SingularValues Sinh SinhIntegral SinIntegral SixJSymbol Skeleton SkeletonTransform SkellamDistribution Skewness SkewNormalDistribution Skip SliceDistribution Slider Slider2D Slider2DBox Slider2DBoxOptions SliderBox SliderBoxOptions SlideView Slot SlotSequence Small SmallCircle Smaller SmithDelayCompensator SmithWatermanSimilarity SmoothDensityHistogram SmoothHistogram SmoothHistogram3D SmoothKernelDistribution SocialMediaData Socket SokalSneathDissimilarity Solve SolveAlways SolveDelayed Sort SortBy Sound SoundAndGraphics SoundNote SoundVolume Sow Space SpaceForm Spacer Spacings Span SpanAdjustments SpanCharacterRounding SpanFromAbove SpanFromBoth SpanFromLeft SpanLineThickness SpanMaxSize SpanMinSize SpanningCharacters SpanSymmetric SparseArray SpatialGraphDistribution Speak SpeakTextPacket SpearmanRankTest SpearmanRho Spectrogram SpectrogramArray Specularity SpellingCorrection SpellingDictionaries SpellingDictionariesPath SpellingOptions SpellingSuggestionsPacket Sphere SphereBox SphericalBesselJ SphericalBesselY SphericalHankelH1 SphericalHankelH2 SphericalHarmonicY SphericalPlot3D SphericalRegion SpheroidalEigenvalue SpheroidalJoiningFactor SpheroidalPS SpheroidalPSPrime SpheroidalQS SpheroidalQSPrime SpheroidalRadialFactor SpheroidalS1 SpheroidalS1Prime SpheroidalS2 SpheroidalS2Prime Splice SplicedDistribution SplineClosed SplineDegree SplineKnots SplineWeights Split SplitBy SpokenString Sqrt SqrtBox SqrtBoxOptions Square SquaredEuclideanDistance SquareFreeQ SquareIntersection SquaresR SquareSubset SquareSubsetEqual SquareSuperset SquareSupersetEqual SquareUnion SquareWave StabilityMargins StabilityMarginsStyle StableDistribution Stack StackBegin StackComplete StackInhibit StandardDeviation StandardDeviationFilter StandardForm Standardize StandbyDistribution Star StarGraph StartAsynchronousTask StartingStepSize StartOfLine StartOfString StartScheduledTask StartupSound StateDimensions StateFeedbackGains StateOutputEstimator StateResponse StateSpaceModel StateSpaceRealization StateSpaceTransform StationaryDistribution StationaryWaveletPacketTransform StationaryWaveletTransform StatusArea StatusCentrality StepMonitor StieltjesGamma StirlingS1 StirlingS2 StopAsynchronousTask StopScheduledTask StrataVariables StratonovichProcess StreamColorFunction StreamColorFunctionScaling StreamDensityPlot StreamPlot StreamPoints StreamPosition Streams StreamScale StreamStyle String StringBreak StringByteCount StringCases StringCount StringDrop StringExpression StringForm StringFormat StringFreeQ StringInsert StringJoin StringLength StringMatchQ StringPosition StringQ StringReplace StringReplaceList StringReplacePart StringReverse StringRotateLeft StringRotateRight StringSkeleton StringSplit StringTake StringToStream StringTrim StripBoxes StripOnInput StripWrapperBoxes StrokeForm StructuralImportance StructuredArray StructuredSelection StruveH StruveL Stub StudentTDistribution Style StyleBox StyleBoxAutoDelete StyleBoxOptions StyleData StyleDefinitions StyleForm StyleKeyMapping StyleMenuListing StyleNameDialogSettings StyleNames StylePrint StyleSheetPath Subfactorial Subgraph SubMinus SubPlus SubresultantPolynomialRemainders SubresultantPolynomials Subresultants Subscript SubscriptBox SubscriptBoxOptions Subscripted Subset SubsetEqual Subsets SubStar Subsuperscript SubsuperscriptBox SubsuperscriptBoxOptions Subtract SubtractFrom SubValues Succeeds SucceedsEqual SucceedsSlantEqual SucceedsTilde SuchThat Sum SumConvergence Sunday SuperDagger SuperMinus SuperPlus Superscript SuperscriptBox SuperscriptBoxOptions Superset SupersetEqual SuperStar Surd SurdForm SurfaceColor SurfaceGraphics SurvivalDistribution SurvivalFunction SurvivalModel SurvivalModelFit SuspendPacket SuzukiDistribution SuzukiGroupSuz SwatchLegend Switch Symbol SymbolName SymletWavelet Symmetric SymmetricGroup SymmetricMatrixQ SymmetricPolynomial SymmetricReduction Symmetrize SymmetrizedArray SymmetrizedArrayRules SymmetrizedDependentComponents SymmetrizedIndependentComponents SymmetrizedReplacePart SynchronousInitialization SynchronousUpdating Syntax SyntaxForm SyntaxInformation SyntaxLength SyntaxPacket SyntaxQ SystemDialogInput SystemException SystemHelpPath SystemInformation SystemInformationData SystemOpen SystemOptions SystemsModelDelay SystemsModelDelayApproximate SystemsModelDelete SystemsModelDimensions SystemsModelExtract SystemsModelFeedbackConnect SystemsModelLabels SystemsModelOrder SystemsModelParallelConnect SystemsModelSeriesConnect SystemsModelStateFeedbackConnect SystemStub Tab TabFilling Table TableAlignments TableDepth TableDirections TableForm TableHeadings TableSpacing TableView TableViewBox TabSpacings TabView TabViewBox TabViewBoxOptions TagBox TagBoxNote TagBoxOptions TaggingRules TagSet TagSetDelayed TagStyle TagUnset Take TakeWhile Tally Tan Tanh TargetFunctions TargetUnits TautologyQ TelegraphProcess TemplateBox TemplateBoxOptions TemplateSlotSequence TemporalData Temporary TemporaryVariable TensorContract TensorDimensions TensorExpand TensorProduct TensorQ TensorRank TensorReduce TensorSymmetry TensorTranspose TensorWedge Tetrahedron TetrahedronBox TetrahedronBoxOptions TeXForm TeXSave Text Text3DBox Text3DBoxOptions TextAlignment TextBand TextBoundingBox TextBox TextCell TextClipboardType TextData TextForm TextJustification TextLine TextPacket TextParagraph TextRecognize TextRendering TextStyle Texture TextureCoordinateFunction TextureCoordinateScaling Therefore ThermometerGauge Thick Thickness Thin Thinning ThisLink ThompsonGroupTh Thread ThreeJSymbol Threshold Through Throw Thumbnail Thursday Ticks TicksStyle Tilde TildeEqual TildeFullEqual TildeTilde TimeConstrained TimeConstraint Times TimesBy TimeSeriesForecast TimeSeriesInvertibility TimeUsed TimeValue TimeZone Timing Tiny TitleGrouping TitsGroupT ToBoxes ToCharacterCode ToColor ToContinuousTimeModel ToDate ToDiscreteTimeModel ToeplitzMatrix ToExpression ToFileName Together Toggle ToggleFalse Toggler TogglerBar TogglerBox TogglerBoxOptions ToHeldExpression ToInvertibleTimeSeries TokenWords Tolerance ToLowerCase ToNumberField TooBig Tooltip TooltipBox TooltipBoxOptions TooltipDelay TooltipStyle Top TopHatTransform TopologicalSort ToRadicals ToRules ToString Total TotalHeight TotalVariationFilter TotalWidth TouchscreenAutoZoom TouchscreenControlPlacement ToUpperCase Tr Trace TraceAbove TraceAction TraceBackward TraceDepth TraceDialog TraceForward TraceInternal TraceLevel TraceOff TraceOn TraceOriginal TracePrint TraceScan TrackedSymbols TradingChart TraditionalForm TraditionalFunctionNotation TraditionalNotation TraditionalOrder TransferFunctionCancel TransferFunctionExpand TransferFunctionFactor TransferFunctionModel TransferFunctionPoles TransferFunctionTransform TransferFunctionZeros TransformationFunction TransformationFunctions TransformationMatrix TransformedDistribution TransformedField Translate TranslationTransform TransparentColor Transpose TreeForm TreeGraph TreeGraphQ TreePlot TrendStyle TriangleWave TriangularDistribution Trig TrigExpand TrigFactor TrigFactorList Trigger TrigReduce TrigToExp TrimmedMean True TrueQ TruncatedDistribution TsallisQExponentialDistribution TsallisQGaussianDistribution TTest Tube TubeBezierCurveBox TubeBezierCurveBoxOptions TubeBox TubeBSplineCurveBox TubeBSplineCurveBoxOptions Tuesday TukeyLambdaDistribution TukeyWindow Tuples TuranGraph TuringMachine Transparent UnateQ Uncompress Undefined UnderBar Underflow Underlined Underoverscript UnderoverscriptBox UnderoverscriptBoxOptions Underscript UnderscriptBox UnderscriptBoxOptions UndirectedEdge UndirectedGraph UndirectedGraphQ UndocumentedTestFEParserPacket UndocumentedTestGetSelectionPacket Unequal Unevaluated UniformDistribution UniformGraphDistribution UniformSumDistribution Uninstall Union UnionPlus Unique UnitBox UnitConvert UnitDimensions Unitize UnitRootTest UnitSimplify UnitStep UnitTriangle UnitVector Unprotect UnsameQ UnsavedVariables Unset UnsetShared UntrackedVariables Up UpArrow UpArrowBar UpArrowDownArrow Update UpdateDynamicObjects UpdateDynamicObjectsSynchronous UpdateInterval UpDownArrow UpEquilibrium UpperCaseQ UpperLeftArrow UpperRightArrow UpperTriangularize Upsample UpSet UpSetDelayed UpTee UpTeeArrow UpValues URL URLFetch URLFetchAsynchronous URLSave URLSaveAsynchronous UseGraphicsRange Using UsingFrontEnd V2Get ValidationLength Value ValueBox ValueBoxOptions ValueForm ValueQ ValuesData Variables Variance VarianceEquivalenceTest VarianceEstimatorFunction VarianceGammaDistribution VarianceTest VectorAngle VectorColorFunction VectorColorFunctionScaling VectorDensityPlot VectorGlyphData VectorPlot VectorPlot3D VectorPoints VectorQ Vectors VectorScale VectorStyle Vee Verbatim Verbose VerboseConvertToPostScriptPacket VerifyConvergence VerifySolutions VerifyTestAssumptions Version VersionNumber VertexAdd VertexCapacity VertexColors VertexComponent VertexConnectivity VertexCoordinateRules VertexCoordinates VertexCorrelationSimilarity VertexCosineSimilarity VertexCount VertexCoverQ VertexDataCoordinates VertexDegree VertexDelete VertexDiceSimilarity VertexEccentricity VertexInComponent VertexInDegree VertexIndex VertexJaccardSimilarity VertexLabeling VertexLabels VertexLabelStyle VertexList VertexNormals VertexOutComponent VertexOutDegree VertexQ VertexRenderingFunction VertexReplace VertexShape VertexShapeFunction VertexSize VertexStyle VertexTextureCoordinates VertexWeight Vertical VerticalBar VerticalForm VerticalGauge VerticalSeparator VerticalSlider VerticalTilde ViewAngle ViewCenter ViewMatrix ViewPoint ViewPointSelectorSettings ViewPort ViewRange ViewVector ViewVertical VirtualGroupData Visible VisibleCell VoigtDistribution VonMisesDistribution WaitAll WaitAsynchronousTask WaitNext WaitUntil WakebyDistribution WalleniusHypergeometricDistribution WaringYuleDistribution WatershedComponents WatsonUSquareTest WattsStrogatzGraphDistribution WaveletBestBasis WaveletFilterCoefficients WaveletImagePlot WaveletListPlot WaveletMapIndexed WaveletMatrixPlot WaveletPhi WaveletPsi WaveletScale WaveletScalogram WaveletThreshold WeaklyConnectedComponents WeaklyConnectedGraphQ WeakStationarity WeatherData WeberE Wedge Wednesday WeibullDistribution WeierstrassHalfPeriods WeierstrassInvariants WeierstrassP WeierstrassPPrime WeierstrassSigma WeierstrassZeta WeightedAdjacencyGraph WeightedAdjacencyMatrix WeightedData WeightedGraphQ Weights WelchWindow WheelGraph WhenEvent Which While White Whitespace WhitespaceCharacter WhittakerM WhittakerW WienerFilter WienerProcess WignerD WignerSemicircleDistribution WilksW WilksWTest WindowClickSelect WindowElements WindowFloating WindowFrame WindowFrameElements WindowMargins WindowMovable WindowOpacity WindowSelected WindowSize WindowStatusArea WindowTitle WindowToolbars WindowWidth With WolframAlpha WolframAlphaDate WolframAlphaQuantity WolframAlphaResult Word WordBoundary WordCharacter WordData WordSearch WordSeparators WorkingPrecision Write WriteString Wronskian XMLElement XMLObject Xnor Xor Yellow YuleDissimilarity ZernikeR ZeroSymmetric ZeroTest ZeroWidthTimes Zeta ZetaZero ZipfDistribution ZTest ZTransform $Aborted $ActivationGroupID $ActivationKey $ActivationUserRegistered $AddOnsDirectory $AssertFunction $Assumptions $AsynchronousTask $BaseDirectory $BatchInput $BatchOutput $BoxForms $ByteOrdering $Canceled $CharacterEncoding $CharacterEncodings $CommandLine $CompilationTarget $ConditionHold $ConfiguredKernels $Context $ContextPath $ControlActiveSetting $CreationDate $CurrentLink $DateStringFormat $DefaultFont $DefaultFrontEnd $DefaultImagingDevice $DefaultPath $Display $DisplayFunction $DistributedContexts $DynamicEvaluation $Echo $Epilog $ExportFormats $Failed $FinancialDataSource $FormatType $FrontEnd $FrontEndSession $GeoLocation $HistoryLength $HomeDirectory $HTTPCookies $IgnoreEOF $ImagingDevices $ImportFormats $InitialDirectory $Input $InputFileName $InputStreamMethods $Inspector $InstallationDate $InstallationDirectory $InterfaceEnvironment $IterationLimit $KernelCount $KernelID $Language $LaunchDirectory $LibraryPath $LicenseExpirationDate $LicenseID $LicenseProcesses $LicenseServer $LicenseSubprocesses $LicenseType $Line $Linked $LinkSupported $LoadedFiles $MachineAddresses $MachineDomain $MachineDomains $MachineEpsilon $MachineID $MachineName $MachinePrecision $MachineType $MaxExtraPrecision $MaxLicenseProcesses $MaxLicenseSubprocesses $MaxMachineNumber $MaxNumber $MaxPiecewiseCases $MaxPrecision $MaxRootDegree $MessageGroups $MessageList $MessagePrePrint $Messages $MinMachineNumber $MinNumber $MinorReleaseNumber $MinPrecision $ModuleNumber $NetworkLicense $NewMessage $NewSymbol $Notebooks $NumberMarks $Off $OperatingSystem $Output $OutputForms $OutputSizeLimit $OutputStreamMethods $Packages $ParentLink $ParentProcessID $PasswordFile $PatchLevelID $Path $PathnameSeparator $PerformanceGoal $PipeSupported $Post $Pre $PreferencesDirectory $PrePrint $PreRead $PrintForms $PrintLiteral $ProcessID $ProcessorCount $ProcessorType $ProductInformation $ProgramName $RandomState $RecursionLimit $ReleaseNumber $RootDirectory $ScheduledTask $ScriptCommandLine $SessionID $SetParentLink $SharedFunctions $SharedVariables $SoundDisplay $SoundDisplayFunction $SuppressInputFormHeads $SynchronousEvaluation $SyntaxHandler $System $SystemCharacterEncoding $SystemID $SystemWordLength $TemporaryDirectory $TemporaryPrefix $TextStyle $TimedOut $TimeUnit $TimeZone $TopDirectory $TraceOff $TraceOn $TracePattern $TracePostAction $TracePreAction $Urgent $UserAddOnsDirectory $UserBaseDirectory $UserDocumentsDirectory $UserName $Version $VersionNumber",
contains:[{className:"comment",begin:/\(\*/,end:/\*\)/},hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE,{className:"list",begin:/\{/,end:/\}/,illegal:/:/}]}}),hljs.registerLanguage("matlab",function(hljs){var COMMON_CONTAINS=[hljs.C_NUMBER_MODE,{className:"string",begin:"'",end:"'",contains:[hljs.BACKSLASH_ESCAPE,{begin:"''"}]}],TRANSPOSE={relevance:0,contains:[{className:"operator",begin:/'['\.]*/}]};return{keywords:{keyword:"break case catch classdef continue else elseif end enumerated events for function global if methods otherwise parfor persistent properties return spmd switch try while",built_in:"sin sind sinh asin asind asinh cos cosd cosh acos acosd acosh tan tand tanh atan atand atan2 atanh sec secd sech asec asecd asech csc cscd csch acsc acscd acsch cot cotd coth acot acotd acoth hypot exp expm1 log log1p log10 log2 pow2 realpow reallog realsqrt sqrt nthroot nextpow2 abs angle complex conj imag real unwrap isreal cplxpair fix floor ceil round mod rem sign airy besselj bessely besselh besseli besselk beta betainc betaln ellipj ellipke erf erfc erfcx erfinv expint gamma gammainc gammaln psi legendre cross dot factor isprime primes gcd lcm rat rats perms nchoosek factorial cart2sph cart2pol pol2cart sph2cart hsv2rgb rgb2hsv zeros ones eye repmat rand randn linspace logspace freqspace meshgrid accumarray size length ndims numel disp isempty isequal isequalwithequalnans cat reshape diag blkdiag tril triu fliplr flipud flipdim rot90 find sub2ind ind2sub bsxfun ndgrid permute ipermute shiftdim circshift squeeze isscalar isvector ans eps realmax realmin pi i inf nan isnan isinf isfinite j why compan gallery hadamard hankel hilb invhilb magic pascal rosser toeplitz vander wilkinson"},illegal:'(//|"|#|/\\*|\\s+/\\w+)',contains:[{className:"function",beginKeywords:"function",end:"$",contains:[hljs.UNDERSCORE_TITLE_MODE,{className:"params",begin:"\\(",end:"\\)"},{className:"params",begin:"\\[",end:"\\]"}]},{begin:/[a-zA-Z_][a-zA-Z_0-9]*'['\.]*/,returnBegin:!0,relevance:0,contains:[{begin:/[a-zA-Z_][a-zA-Z_0-9]*/,relevance:0},TRANSPOSE.contains[0]]},{className:"matrix",begin:"\\[",end:"\\]",contains:COMMON_CONTAINS,relevance:0,starts:TRANSPOSE},{className:"cell",begin:"\\{",end:/}/,contains:COMMON_CONTAINS,relevance:0,starts:TRANSPOSE},{begin:/\)/,relevance:0,starts:TRANSPOSE},hljs.COMMENT("^\\s*\\%\\{\\s*$","^\\s*\\%\\}\\s*$"),hljs.COMMENT("\\%","$")].concat(COMMON_CONTAINS)}}),hljs.registerLanguage("mel",function(hljs){return{keywords:"int float string vector matrix if else switch case default while do for in break continue global proc return about abs addAttr addAttributeEditorNodeHelp addDynamic addNewShelfTab addPP addPanelCategory addPrefixToName advanceToNextDrivenKey affectedNet affects aimConstraint air alias aliasAttr align alignCtx alignCurve alignSurface allViewFit ambientLight angle angleBetween animCone animCurveEditor animDisplay animView annotate appendStringArray applicationName applyAttrPreset applyTake arcLenDimContext arcLengthDimension arclen arrayMapper art3dPaintCtx artAttrCtx artAttrPaintVertexCtx artAttrSkinPaintCtx artAttrTool artBuildPaintMenu artFluidAttrCtx artPuttyCtx artSelectCtx artSetPaintCtx artUserPaintCtx assignCommand assignInputDevice assignViewportFactories attachCurve attachDeviceAttr attachSurface attrColorSliderGrp attrCompatibility attrControlGrp attrEnumOptionMenu attrEnumOptionMenuGrp attrFieldGrp attrFieldSliderGrp attrNavigationControlGrp attrPresetEditWin attributeExists attributeInfo attributeMenu attributeQuery autoKeyframe autoPlace bakeClip bakeFluidShading bakePartialHistory bakeResults bakeSimulation basename basenameEx batchRender bessel bevel bevelPlus binMembership bindSkin blend2 blendShape blendShapeEditor blendShapePanel blendTwoAttr blindDataType boneLattice boundary boxDollyCtx boxZoomCtx bufferCurve buildBookmarkMenu buildKeyframeMenu button buttonManip CBG cacheFile cacheFileCombine cacheFileMerge cacheFileTrack camera cameraView canCreateManip canvas capitalizeString catch catchQuiet ceil changeSubdivComponentDisplayLevel changeSubdivRegion channelBox character characterMap characterOutlineEditor characterize chdir checkBox checkBoxGrp checkDefaultRenderGlobals choice circle circularFillet clamp clear clearCache clip clipEditor clipEditorCurrentTimeCtx clipSchedule clipSchedulerOutliner clipTrimBefore closeCurve closeSurface cluster cmdFileOutput cmdScrollFieldExecuter cmdScrollFieldReporter cmdShell coarsenSubdivSelectionList collision color colorAtPoint colorEditor colorIndex colorIndexSliderGrp colorSliderButtonGrp colorSliderGrp columnLayout commandEcho commandLine commandPort compactHairSystem componentEditor compositingInterop computePolysetVolume condition cone confirmDialog connectAttr connectControl connectDynamic connectJoint connectionInfo constrain constrainValue constructionHistory container containsMultibyte contextInfo control convertFromOldLayers convertIffToPsd convertLightmap convertSolidTx convertTessellation convertUnit copyArray copyFlexor copyKey copySkinWeights cos cpButton cpCache cpClothSet cpCollision cpConstraint cpConvClothToMesh cpForces cpGetSolverAttr cpPanel cpProperty cpRigidCollisionFilter cpSeam cpSetEdit cpSetSolverAttr cpSolver cpSolverTypes cpTool cpUpdateClothUVs createDisplayLayer createDrawCtx createEditor createLayeredPsdFile createMotionField createNewShelf createNode createRenderLayer createSubdivRegion cross crossProduct ctxAbort ctxCompletion ctxEditMode ctxTraverse currentCtx currentTime currentTimeCtx currentUnit curve curveAddPtCtx curveCVCtx curveEPCtx curveEditorCtx curveIntersect curveMoveEPCtx curveOnSurface curveSketchCtx cutKey cycleCheck cylinder dagPose date defaultLightListCheckBox defaultNavigation defineDataServer defineVirtualDevice deformer deg_to_rad delete deleteAttr deleteShadingGroupsAndMaterials deleteShelfTab deleteUI deleteUnusedBrushes delrandstr detachCurve detachDeviceAttr detachSurface deviceEditor devicePanel dgInfo dgdirty dgeval dgtimer dimWhen directKeyCtx directionalLight dirmap dirname disable disconnectAttr disconnectJoint diskCache displacementToPoly displayAffected displayColor displayCull displayLevelOfDetail displayPref displayRGBColor displaySmoothness displayStats displayString displaySurface distanceDimContext distanceDimension doBlur dolly dollyCtx dopeSheetEditor dot dotProduct doubleProfileBirailSurface drag dragAttrContext draggerContext dropoffLocator duplicate duplicateCurve duplicateSurface dynCache dynControl dynExport dynExpression dynGlobals dynPaintEditor dynParticleCtx dynPref dynRelEdPanel dynRelEditor dynamicLoad editAttrLimits editDisplayLayerGlobals editDisplayLayerMembers editRenderLayerAdjustment editRenderLayerGlobals editRenderLayerMembers editor editorTemplate effector emit emitter enableDevice encodeString endString endsWith env equivalent equivalentTol erf error eval evalDeferred evalEcho event exactWorldBoundingBox exclusiveLightCheckBox exec executeForEachObject exists exp expression expressionEditorListen extendCurve extendSurface extrude fcheck fclose feof fflush fgetline fgetword file fileBrowserDialog fileDialog fileExtension fileInfo filetest filletCurve filter filterCurve filterExpand filterStudioImport findAllIntersections findAnimCurves findKeyframe findMenuItem findRelatedSkinCluster finder firstParentOf fitBspline flexor floatEq floatField floatFieldGrp floatScrollBar floatSlider floatSlider2 floatSliderButtonGrp floatSliderGrp floor flow fluidCacheInfo fluidEmitter fluidVoxelInfo flushUndo fmod fontDialog fopen formLayout format fprint frameLayout fread freeFormFillet frewind fromNativePath fwrite gamma gauss geometryConstraint getApplicationVersionAsFloat getAttr getClassification getDefaultBrush getFileList getFluidAttr getInputDeviceRange getMayaPanelTypes getModifiers getPanel getParticleAttr getPluginResource getenv getpid glRender glRenderEditor globalStitch gmatch goal gotoBindPose grabColor gradientControl gradientControlNoAttr graphDollyCtx graphSelectContext graphTrackCtx gravity grid gridLayout group groupObjectsByName HfAddAttractorToAS HfAssignAS HfBuildEqualMap HfBuildFurFiles HfBuildFurImages HfCancelAFR HfConnectASToHF HfCreateAttractor HfDeleteAS HfEditAS HfPerformCreateAS HfRemoveAttractorFromAS HfSelectAttached HfSelectAttractors HfUnAssignAS hardenPointCurve hardware hardwareRenderPanel headsUpDisplay headsUpMessage help helpLine hermite hide hilite hitTest hotBox hotkey hotkeyCheck hsv_to_rgb hudButton hudSlider hudSliderButton hwReflectionMap hwRender hwRenderLoad hyperGraph hyperPanel hyperShade hypot iconTextButton iconTextCheckBox iconTextRadioButton iconTextRadioCollection iconTextScrollList iconTextStaticLabel ikHandle ikHandleCtx ikHandleDisplayScale ikSolver ikSplineHandleCtx ikSystem ikSystemInfo ikfkDisplayMethod illustratorCurves image imfPlugins inheritTransform insertJoint insertJointCtx insertKeyCtx insertKnotCurve insertKnotSurface instance instanceable instancer intField intFieldGrp intScrollBar intSlider intSliderGrp interToUI internalVar intersect iprEngine isAnimCurve isConnected isDirty isParentOf isSameObject isTrue isValidObjectName isValidString isValidUiName isolateSelect itemFilter itemFilterAttr itemFilterRender itemFilterType joint jointCluster jointCtx jointDisplayScale jointLattice keyTangent keyframe keyframeOutliner keyframeRegionCurrentTimeCtx keyframeRegionDirectKeyCtx keyframeRegionDollyCtx keyframeRegionInsertKeyCtx keyframeRegionMoveKeyCtx keyframeRegionScaleKeyCtx keyframeRegionSelectKeyCtx keyframeRegionSetKeyCtx keyframeRegionTrackCtx keyframeStats lassoContext lattice latticeDeformKeyCtx launch launchImageEditor layerButton layeredShaderPort layeredTexturePort layout layoutDialog lightList lightListEditor lightListPanel lightlink lineIntersection linearPrecision linstep listAnimatable listAttr listCameras listConnections listDeviceAttachments listHistory listInputDeviceAxes listInputDeviceButtons listInputDevices listMenuAnnotation listNodeTypes listPanelCategories listRelatives listSets listTransforms listUnselected listerEditor loadFluid loadNewShelf loadPlugin loadPluginLanguageResources loadPrefObjects localizedPanelLabel lockNode loft log longNameOf lookThru ls lsThroughFilter lsType lsUI Mayatomr mag makeIdentity makeLive makePaintable makeRoll makeSingleSurface makeTubeOn makebot manipMoveContext manipMoveLimitsCtx manipOptions manipRotateContext manipRotateLimitsCtx manipScaleContext manipScaleLimitsCtx marker match max memory menu menuBarLayout menuEditor menuItem menuItemToShelf menuSet menuSetPref messageLine min minimizeApp mirrorJoint modelCurrentTimeCtx modelEditor modelPanel mouse movIn movOut move moveIKtoFK moveKeyCtx moveVertexAlongDirection multiProfileBirailSurface mute nParticle nameCommand nameField namespace namespaceInfo newPanelItems newton nodeCast nodeIconButton nodeOutliner nodePreset nodeType noise nonLinear normalConstraint normalize nurbsBoolean nurbsCopyUVSet nurbsCube nurbsEditUV nurbsPlane nurbsSelect nurbsSquare nurbsToPoly nurbsToPolygonsPref nurbsToSubdiv nurbsToSubdivPref nurbsUVSet nurbsViewDirectionVector objExists objectCenter objectLayer objectType objectTypeUI obsoleteProc oceanNurbsPreviewPlane offsetCurve offsetCurveOnSurface offsetSurface openGLExtension openMayaPref optionMenu optionMenuGrp optionVar orbit orbitCtx orientConstraint outlinerEditor outlinerPanel overrideModifier paintEffectsDisplay pairBlend palettePort paneLayout panel panelConfiguration panelHistory paramDimContext paramDimension paramLocator parent parentConstraint particle particleExists particleInstancer particleRenderInfo partition pasteKey pathAnimation pause pclose percent performanceOptions pfxstrokes pickWalk picture pixelMove planarSrf plane play playbackOptions playblast plugAttr plugNode pluginInfo pluginResourceUtil pointConstraint pointCurveConstraint pointLight pointMatrixMult pointOnCurve pointOnSurface pointPosition poleVectorConstraint polyAppend polyAppendFacetCtx polyAppendVertex polyAutoProjection polyAverageNormal polyAverageVertex polyBevel polyBlendColor polyBlindData polyBoolOp polyBridgeEdge polyCacheMonitor polyCheck polyChipOff polyClipboard polyCloseBorder polyCollapseEdge polyCollapseFacet polyColorBlindData polyColorDel polyColorPerVertex polyColorSet polyCompare polyCone polyCopyUV polyCrease polyCreaseCtx polyCreateFacet polyCreateFacetCtx polyCube polyCut polyCutCtx polyCylinder polyCylindricalProjection polyDelEdge polyDelFacet polyDelVertex polyDuplicateAndConnect polyDuplicateEdge polyEditUV polyEditUVShell polyEvaluate polyExtrudeEdge polyExtrudeFacet polyExtrudeVertex polyFlipEdge polyFlipUV polyForceUV polyGeoSampler polyHelix polyInfo polyInstallAction polyLayoutUV polyListComponentConversion polyMapCut polyMapDel polyMapSew polyMapSewMove polyMergeEdge polyMergeEdgeCtx polyMergeFacet polyMergeFacetCtx polyMergeUV polyMergeVertex polyMirrorFace polyMoveEdge polyMoveFacet polyMoveFacetUV polyMoveUV polyMoveVertex polyNormal polyNormalPerVertex polyNormalizeUV polyOptUvs polyOptions polyOutput polyPipe polyPlanarProjection polyPlane polyPlatonicSolid polyPoke polyPrimitive polyPrism polyProjection polyPyramid polyQuad polyQueryBlindData polyReduce polySelect polySelectConstraint polySelectConstraintMonitor polySelectCtx polySelectEditCtx polySeparate polySetToFaceNormal polySewEdge polyShortestPathCtx polySmooth polySoftEdge polySphere polySphericalProjection polySplit polySplitCtx polySplitEdge polySplitRing polySplitVertex polyStraightenUVBorder polySubdivideEdge polySubdivideFacet polyToSubdiv polyTorus polyTransfer polyTriangulate polyUVSet polyUnite polyWedgeFace popen popupMenu pose pow preloadRefEd print progressBar progressWindow projFileViewer projectCurve projectTangent projectionContext projectionManip promptDialog propModCtx propMove psdChannelOutliner psdEditTextureFile psdExport psdTextureFile putenv pwd python querySubdiv quit rad_to_deg radial radioButton radioButtonGrp radioCollection radioMenuItemCollection rampColorPort rand randomizeFollicles randstate rangeControl readTake rebuildCurve rebuildSurface recordAttr recordDevice redo reference referenceEdit referenceQuery refineSubdivSelectionList refresh refreshAE registerPluginResource rehash reloadImage removeJoint removeMultiInstance removePanelCategory rename renameAttr renameSelectionList renameUI render renderGlobalsNode renderInfo renderLayerButton renderLayerParent renderLayerPostProcess renderLayerUnparent renderManip renderPartition renderQualityNode renderSettings renderThumbnailUpdate renderWindowEditor renderWindowSelectContext renderer reorder reorderDeformers requires reroot resampleFluid resetAE resetPfxToPolyCamera resetTool resolutionNode retarget reverseCurve reverseSurface revolve rgb_to_hsv rigidBody rigidSolver roll rollCtx rootOf rot rotate rotationInterpolation roundConstantRadius rowColumnLayout rowLayout runTimeCommand runup sampleImage saveAllShelves saveAttrPreset saveFluid saveImage saveInitialState saveMenu savePrefObjects savePrefs saveShelf saveToolSettings scale scaleBrushBrightness scaleComponents scaleConstraint scaleKey scaleKeyCtx sceneEditor sceneUIReplacement scmh scriptCtx scriptEditorInfo scriptJob scriptNode scriptTable scriptToShelf scriptedPanel scriptedPanelType scrollField scrollLayout sculpt searchPathArray seed selLoadSettings select selectContext selectCurveCV selectKey selectKeyCtx selectKeyframeRegionCtx selectMode selectPref selectPriority selectType selectedNodes selectionConnection separator setAttr setAttrEnumResource setAttrMapping setAttrNiceNameResource setConstraintRestPosition setDefaultShadingGroup setDrivenKeyframe setDynamic setEditCtx setEditor setFluidAttr setFocus setInfinity setInputDeviceMapping setKeyCtx setKeyPath setKeyframe setKeyframeBlendshapeTargetWts setMenuMode setNodeNiceNameResource setNodeTypeFlag setParent setParticleAttr setPfxToPolyCamera setPluginResource setProject setStampDensity setStartupMessage setState setToolTo setUITemplate setXformManip sets shadingConnection shadingGeometryRelCtx shadingLightRelCtx shadingNetworkCompare shadingNode shapeCompare shelfButton shelfLayout shelfTabLayout shellField shortNameOf showHelp showHidden showManipCtx showSelectionInTitle showShadingGroupAttrEditor showWindow sign simplify sin singleProfileBirailSurface size sizeBytes skinCluster skinPercent smoothCurve smoothTangentSurface smoothstep snap2to2 snapKey snapMode snapTogetherCtx snapshot soft softMod softModCtx sort sound soundControl source spaceLocator sphere sphrand spotLight spotLightPreviewPort spreadSheetEditor spring sqrt squareSurface srtContext stackTrace startString startsWith stitchAndExplodeShell stitchSurface stitchSurfacePoints strcmp stringArrayCatenate stringArrayContains stringArrayCount stringArrayInsertAtIndex stringArrayIntersector stringArrayRemove stringArrayRemoveAtIndex stringArrayRemoveDuplicates stringArrayRemoveExact stringArrayToString stringToStringArray strip stripPrefixFromName stroke subdAutoProjection subdCleanTopology subdCollapse subdDuplicateAndConnect subdEditUV subdListComponentConversion subdMapCut subdMapSewMove subdMatchTopology subdMirror subdToBlind subdToPoly subdTransferUVsToCache subdiv subdivCrease subdivDisplaySmoothness substitute substituteAllString substituteGeometry substring surface surfaceSampler surfaceShaderList swatchDisplayPort switchTable symbolButton symbolCheckBox sysFile system tabLayout tan tangentConstraint texLatticeDeformContext texManipContext texMoveContext texMoveUVShellContext texRotateContext texScaleContext texSelectContext texSelectShortestPathCtx texSmudgeUVContext texWinToolCtx text textCurves textField textFieldButtonGrp textFieldGrp textManip textScrollList textToShelf textureDisplacePlane textureHairColor texturePlacementContext textureWindow threadCount threePointArcCtx timeControl timePort timerX toNativePath toggle toggleAxis toggleWindowVisibility tokenize tokenizeList tolerance tolower toolButton toolCollection toolDropped toolHasOptions toolPropertyWindow torus toupper trace track trackCtx transferAttributes transformCompare transformLimits translator trim trunc truncateFluidCache truncateHairCache tumble tumbleCtx turbulence twoPointArcCtx uiRes uiTemplate unassignInputDevice undo undoInfo ungroup uniform unit unloadPlugin untangleUV untitledFileName untrim upAxis updateAE userCtx uvLink uvSnapshot validateShelfName vectorize view2dToolCtx viewCamera viewClipPlane viewFit viewHeadOn viewLookAt viewManip viewPlace viewSet visor volumeAxis vortex waitCursor warning webBrowser webBrowserPrefs whatIs window windowPref wire wireContext workspace wrinkle wrinkleContext writeTake xbmLangPathList xform",illegal:"</",contains:[hljs.C_NUMBER_MODE,hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,{className:"string",begin:"`",end:"`",contains:[hljs.BACKSLASH_ESCAPE]},{className:"variable",variants:[{begin:"\\$\\d"},{begin:"[\\$\\%\\@](\\^\\w\\b|#\\w+|[^\\s\\w{]|{\\w+}|\\w+)"},{begin:"\\*(\\^\\w\\b|#\\w+|[^\\s\\w{]|{\\w+}|\\w+)",relevance:0}]},hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE]}}),hljs.registerLanguage("mercury",function(hljs){var KEYWORDS={keyword:"module use_module import_module include_module end_module initialise mutable initialize finalize finalise interface implementation pred mode func type inst solver any_pred any_func is semidet det nondet multi erroneous failure cc_nondet cc_multi typeclass instance where pragma promise external trace atomic or_else require_complete_switch require_det require_semidet require_multi require_nondet require_cc_multi require_cc_nondet require_erroneous require_failure",pragma:"inline no_inline type_spec source_file fact_table obsolete memo loop_check minimal_model terminates does_not_terminate check_termination promise_equivalent_clauses",preprocessor:"foreign_proc foreign_decl foreign_code foreign_type foreign_import_module foreign_export_enum foreign_export foreign_enum may_call_mercury will_not_call_mercury thread_safe not_thread_safe maybe_thread_safe promise_pure promise_semipure tabled_for_io local untrailed trailed attach_to_io_state can_pass_as_mercury_type stable will_not_throw_exception may_modify_trail will_not_modify_trail may_duplicate may_not_duplicate affects_liveness does_not_affect_liveness doesnt_affect_liveness no_sharing unknown_sharing sharing",built_in:"some all not if then else true fail false try catch catch_any semidet_true semidet_false semidet_fail impure_true impure semipure"},TODO={className:"label",begin:"XXX",end:"$",endsWithParent:!0,relevance:0},COMMENT=hljs.inherit(hljs.C_LINE_COMMENT_MODE,{begin:"%"}),CCOMMENT=hljs.inherit(hljs.C_BLOCK_COMMENT_MODE,{relevance:0});COMMENT.contains.push(TODO),CCOMMENT.contains.push(TODO);var NUMCODE={className:"number",begin:"0'.\\|0[box][0-9a-fA-F]*"},ATOM=hljs.inherit(hljs.APOS_STRING_MODE,{relevance:0}),STRING=hljs.inherit(hljs.QUOTE_STRING_MODE,{relevance:0}),STRING_FMT={className:"constant",begin:"\\\\[abfnrtv]\\|\\\\x[0-9a-fA-F]*\\\\\\|%[-+# *.0-9]*[dioxXucsfeEgGp]",relevance:0};STRING.contains.push(STRING_FMT);var IMPLICATION={className:"built_in",variants:[{begin:"<=>"},{begin:"<=",relevance:0},{begin:"=>",relevance:0},{begin:"/\\\\"},{begin:"\\\\/"}]},HEAD_BODY_CONJUNCTION={className:"built_in",variants:[{begin:":-\\|-->"},{begin:"=",relevance:0}]};return{aliases:["m","moo"],keywords:KEYWORDS,contains:[IMPLICATION,HEAD_BODY_CONJUNCTION,COMMENT,CCOMMENT,NUMCODE,hljs.NUMBER_MODE,ATOM,STRING,{begin:/:-/}]}}),hljs.registerLanguage("mizar",function(hljs){return{keywords:"environ vocabularies notations constructors definitions registrations theorems schemes requirements begin end definition registration cluster existence pred func defpred deffunc theorem proof let take assume then thus hence ex for st holds consider reconsider such that and in provided of as from be being by means equals implies iff redefine define now not or attr is mode suppose per cases set thesis contradiction scheme reserve struct correctness compatibility coherence symmetry assymetry reflexivity irreflexivity connectedness uniqueness commutativity idempotence involutiveness projectivity",contains:[hljs.COMMENT("::","$")]}}),hljs.registerLanguage("perl",function(hljs){var PERL_KEYWORDS="getpwent getservent quotemeta msgrcv scalar kill dbmclose undef lc ma syswrite tr send umask sysopen shmwrite vec qx utime local oct semctl localtime readpipe do return format read sprintf dbmopen pop getpgrp not getpwnam rewinddir qqfileno qw endprotoent wait sethostent bless s|0 opendir continue each sleep endgrent shutdown dump chomp connect getsockname die socketpair close flock exists index shmgetsub for endpwent redo lstat msgctl setpgrp abs exit select print ref gethostbyaddr unshift fcntl syscall goto getnetbyaddr join gmtime symlink semget splice x|0 getpeername recv log setsockopt cos last reverse gethostbyname getgrnam study formline endhostent times chop length gethostent getnetent pack getprotoent getservbyname rand mkdir pos chmod y|0 substr endnetent printf next open msgsnd readdir use unlink getsockopt getpriority rindex wantarray hex system getservbyport endservent int chr untie rmdir prototype tell listen fork shmread ucfirst setprotoent else sysseek link getgrgid shmctl waitpid unpack getnetbyname reset chdir grep split require caller lcfirst until warn while values shift telldir getpwuid my getprotobynumber delete and sort uc defined srand accept package seekdir getprotobyname semop our rename seek if q|0 chroot sysread setpwent no crypt getc chown sqrt write setnetent setpriority foreach tie sin msgget map stat getlogin unless elsif truncate exec keys glob tied closedirioctl socket readlink eval xor readline binmode setservent eof ord bind alarm pipe atan2 getgrent exp time push setgrent gt lt or ne m|0 break given say state when",SUBST={className:"subst",begin:"[$@]\\{",end:"\\}",keywords:PERL_KEYWORDS},METHOD={begin:"->{",end:"}"},VAR={className:"variable",variants:[{begin:/\$\d/},{begin:/[\$%@](\^\w\b|#\w+(::\w+)*|{\w+}|\w+(::\w*)*)/},{begin:/[\$%@][^\s\w{]/,relevance:0}]},STRING_CONTAINS=[hljs.BACKSLASH_ESCAPE,SUBST,VAR],PERL_DEFAULT_CONTAINS=[VAR,hljs.HASH_COMMENT_MODE,hljs.COMMENT("^\\=\\w","\\=cut",{endsWithParent:!0}),METHOD,{className:"string",contains:STRING_CONTAINS,variants:[{begin:"q[qwxr]?\\s*\\(",end:"\\)",relevance:5},{begin:"q[qwxr]?\\s*\\[",end:"\\]",relevance:5},{begin:"q[qwxr]?\\s*\\{",end:"\\}",relevance:5},{begin:"q[qwxr]?\\s*\\|",end:"\\|",relevance:5},{begin:"q[qwxr]?\\s*\\<",end:"\\>",relevance:5},{begin:"qw\\s+q",end:"q",relevance:5},{begin:"'",end:"'",contains:[hljs.BACKSLASH_ESCAPE]},{begin:'"',end:'"'},{begin:"`",end:"`",contains:[hljs.BACKSLASH_ESCAPE]},{begin:"{\\w+}",contains:[],relevance:0},{begin:"-?\\w+\\s*\\=\\>",contains:[],relevance:0}]},{className:"number",begin:"(\\b0[0-7_]+)|(\\b0x[0-9a-fA-F_]+)|(\\b[1-9][0-9_]*(\\.[0-9_]+)?)|[0_]\\b",relevance:0},{begin:"(\\/\\/|"+hljs.RE_STARTERS_RE+"|\\b(split|return|print|reverse|grep)\\b)\\s*",keywords:"split return print reverse grep",relevance:0,contains:[hljs.HASH_COMMENT_MODE,{className:"regexp",begin:"(s|tr|y)/(\\\\.|[^/])*/(\\\\.|[^/])*/[a-z]*",relevance:10},{className:"regexp",begin:"(m|qr)?/",end:"/[a-z]*",contains:[hljs.BACKSLASH_ESCAPE],relevance:0}]},{className:"sub",beginKeywords:"sub",end:"(\\s*\\(.*?\\))?[;{]",relevance:5},{className:"operator",begin:"-\\w\\b",relevance:0},{begin:"^__DATA__$",end:"^__END__$",subLanguage:"mojolicious",contains:[{begin:"^@@.*",end:"$",className:"comment"}]}];return SUBST.contains=PERL_DEFAULT_CONTAINS,METHOD.contains=PERL_DEFAULT_CONTAINS,{aliases:["pl"],keywords:PERL_KEYWORDS,contains:PERL_DEFAULT_CONTAINS}}),hljs.registerLanguage("mojolicious",function(hljs){return{subLanguage:"xml",contains:[{className:"preprocessor",begin:"^__(END|DATA)__$"},{begin:"^\\s*%{1,2}={0,2}",end:"$",subLanguage:"perl"},{begin:"<%{1,2}={0,2}",end:"={0,1}%>",subLanguage:"perl",excludeBegin:!0,excludeEnd:!0}]}}),hljs.registerLanguage("monkey",function(hljs){var NUMBER={className:"number",relevance:0,variants:[{begin:"[$][a-fA-F0-9]+"},hljs.NUMBER_MODE]};return{case_insensitive:!0,keywords:{keyword:"public private property continue exit extern new try catch eachin not abstract final select case default const local global field end if then else elseif endif while wend repeat until forever for to step next return module inline throw",built_in:"DebugLog DebugStop Error Print ACos ACosr ASin ASinr ATan ATan2 ATan2r ATanr Abs Abs Ceil Clamp Clamp Cos Cosr Exp Floor Log Max Max Min Min Pow Sgn Sgn Sin Sinr Sqrt Tan Tanr Seed PI HALFPI TWOPI",literal:"true false null and or shl shr mod"},illegal:/\/\*/,contains:[hljs.COMMENT("#rem","#end"),hljs.COMMENT("'","$",{relevance:0}),{className:"function",beginKeywords:"function method",end:"[(=:]|$",illegal:/\n/,contains:[hljs.UNDERSCORE_TITLE_MODE]},{className:"class",beginKeywords:"class interface",end:"$",contains:[{beginKeywords:"extends implements"},hljs.UNDERSCORE_TITLE_MODE]},{className:"variable",begin:"\\b(self|super)\\b"},{className:"preprocessor",beginKeywords:"import",end:"$"},{className:"preprocessor",begin:"\\s*#",end:"$",keywords:"if else elseif endif end then"},{className:"pi",begin:"^\\s*strict\\b"},{beginKeywords:"alias",end:"=",contains:[hljs.UNDERSCORE_TITLE_MODE]},hljs.QUOTE_STRING_MODE,NUMBER]}}),hljs.registerLanguage("nginx",function(hljs){var VAR={className:"variable",variants:[{begin:/\$\d+/},{begin:/\$\{/,end:/}/},{begin:"[\\$\\@]"+hljs.UNDERSCORE_IDENT_RE}]},DEFAULT={endsWithParent:!0,lexemes:"[a-z/_]+",keywords:{built_in:"on off yes no true false none blocked debug info notice warn error crit select break last permanent redirect kqueue rtsig epoll poll /dev/poll"},relevance:0,illegal:"=>",contains:[hljs.HASH_COMMENT_MODE,{className:"string",contains:[hljs.BACKSLASH_ESCAPE,VAR],variants:[{begin:/"/,end:/"/},{begin:/'/,end:/'/}]},{className:"url",begin:"([a-z]+):/",end:"\\s",endsWithParent:!0,excludeEnd:!0,contains:[VAR]},{className:"regexp",contains:[hljs.BACKSLASH_ESCAPE,VAR],variants:[{begin:"\\s\\^",end:"\\s|{|;",returnEnd:!0},{begin:"~\\*?\\s+",end:"\\s|{|;",returnEnd:!0},{begin:"\\*(\\.[a-z\\-]+)+"},{begin:"([a-z\\-]+\\.)+\\*"}]},{className:"number",begin:"\\b\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}(:\\d{1,5})?\\b"},{className:"number",begin:"\\b\\d+[kKmMgGdshdwy]*\\b",relevance:0},VAR]};return{aliases:["nginxconf"],contains:[hljs.HASH_COMMENT_MODE,{begin:hljs.UNDERSCORE_IDENT_RE+"\\s",end:";|{",returnBegin:!0,contains:[{className:"title",begin:hljs.UNDERSCORE_IDENT_RE,starts:DEFAULT}],relevance:0}],illegal:"[^\\s\\}]"}}),hljs.registerLanguage("nimrod",function(hljs){return{aliases:["nim"],keywords:{keyword:"addr and as asm bind block break|0 case|0 cast const|0 continue|0 converter discard distinct|10 div do elif else|0 end|0 enum|0 except export finally for from generic if|0 import|0 in include|0 interface is isnot|10 iterator|10 let|0 macro method|10 mixin mod nil not notin|10 object|0 of or out proc|10 ptr raise ref|10 return shl shr static template try|0 tuple type|0 using|0 var|0 when while|0 with without xor yield",literal:"shared guarded stdin stdout stderr result|10 true false"},contains:[{className:"decorator",begin:/{\./,end:/\.}/,relevance:10},{className:"string",begin:/[a-zA-Z]\w*"/,end:/"/,contains:[{begin:/""/}]},{className:"string",begin:/([a-zA-Z]\w*)?"""/,end:/"""/},hljs.QUOTE_STRING_MODE,{className:"type",begin:/\b[A-Z]\w+\b/,relevance:0},{className:"type",begin:/\b(int|int8|int16|int32|int64|uint|uint8|uint16|uint32|uint64|float|float32|float64|bool|char|string|cstring|pointer|expr|stmt|void|auto|any|range|array|openarray|varargs|seq|set|clong|culong|cchar|cschar|cshort|cint|csize|clonglong|cfloat|cdouble|clongdouble|cuchar|cushort|cuint|culonglong|cstringarray|semistatic)\b/},{className:"number",begin:/\b(0[xX][0-9a-fA-F][_0-9a-fA-F]*)('?[iIuU](8|16|32|64))?/,relevance:0},{className:"number",begin:/\b(0o[0-7][_0-7]*)('?[iIuUfF](8|16|32|64))?/,relevance:0},{className:"number",begin:/\b(0(b|B)[01][_01]*)('?[iIuUfF](8|16|32|64))?/,relevance:0},{className:"number",begin:/\b(\d[_\d]*)('?[iIuUfF](8|16|32|64))?/,relevance:0},hljs.HASH_COMMENT_MODE]}}),hljs.registerLanguage("nix",function(hljs){var NIX_KEYWORDS={keyword:"rec with let in inherit assert if else then",constant:"true false or and null",built_in:"import abort baseNameOf dirOf isNull builtins map removeAttrs throw toString derivation"},ANTIQUOTE={className:"subst",begin:/\$\{/,end:/}/,keywords:NIX_KEYWORDS},ATTRS={className:"variable",begin:/[a-zA-Z0-9-_]+(\s*=)/,relevance:0},SINGLE_QUOTE={className:"string",begin:"''",end:"''",contains:[ANTIQUOTE]},DOUBLE_QUOTE={className:"string",begin:'"',end:'"',contains:[ANTIQUOTE]},EXPRESSIONS=[hljs.NUMBER_MODE,hljs.HASH_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,SINGLE_QUOTE,DOUBLE_QUOTE,ATTRS];return ANTIQUOTE.contains=EXPRESSIONS,{aliases:["nixos"],keywords:NIX_KEYWORDS,contains:EXPRESSIONS}}),hljs.registerLanguage("nsis",function(hljs){var CONSTANTS={className:"symbol",begin:"\\$(ADMINTOOLS|APPDATA|CDBURN_AREA|CMDLINE|COMMONFILES32|COMMONFILES64|COMMONFILES|COOKIES|DESKTOP|DOCUMENTS|EXEDIR|EXEFILE|EXEPATH|FAVORITES|FONTS|HISTORY|HWNDPARENT|INSTDIR|INTERNET_CACHE|LANGUAGE|LOCALAPPDATA|MUSIC|NETHOOD|OUTDIR|PICTURES|PLUGINSDIR|PRINTHOOD|PROFILE|PROGRAMFILES32|PROGRAMFILES64|PROGRAMFILES|QUICKLAUNCH|RECENT|RESOURCES_LOCALIZED|RESOURCES|SENDTO|SMPROGRAMS|SMSTARTUP|STARTMENU|SYSDIR|TEMP|TEMPLATES|VIDEOS|WINDIR)"},DEFINES={className:"constant",begin:"\\$+{[a-zA-Z0-9_]+}"},VARIABLES={className:"variable",begin:"\\$+[a-zA-Z0-9_]+",illegal:"\\(\\){}"},LANGUAGES={className:"constant",begin:"\\$+\\([a-zA-Z0-9_]+\\)"},PARAMETERS={className:"params",begin:"(ARCHIVE|FILE_ATTRIBUTE_ARCHIVE|FILE_ATTRIBUTE_NORMAL|FILE_ATTRIBUTE_OFFLINE|FILE_ATTRIBUTE_READONLY|FILE_ATTRIBUTE_SYSTEM|FILE_ATTRIBUTE_TEMPORARY|HKCR|HKCU|HKDD|HKEY_CLASSES_ROOT|HKEY_CURRENT_CONFIG|HKEY_CURRENT_USER|HKEY_DYN_DATA|HKEY_LOCAL_MACHINE|HKEY_PERFORMANCE_DATA|HKEY_USERS|HKLM|HKPD|HKU|IDABORT|IDCANCEL|IDIGNORE|IDNO|IDOK|IDRETRY|IDYES|MB_ABORTRETRYIGNORE|MB_DEFBUTTON1|MB_DEFBUTTON2|MB_DEFBUTTON3|MB_DEFBUTTON4|MB_ICONEXCLAMATION|MB_ICONINFORMATION|MB_ICONQUESTION|MB_ICONSTOP|MB_OK|MB_OKCANCEL|MB_RETRYCANCEL|MB_RIGHT|MB_RTLREADING|MB_SETFOREGROUND|MB_TOPMOST|MB_USERICON|MB_YESNO|NORMAL|OFFLINE|READONLY|SHCTX|SHELL_CONTEXT|SYSTEM|TEMPORARY)"
},COMPILER={className:"constant",begin:"\\!(addincludedir|addplugindir|appendfile|cd|define|delfile|echo|else|endif|error|execute|finalize|getdllversionsystem|ifdef|ifmacrodef|ifmacrondef|ifndef|if|include|insertmacro|macroend|macro|makensis|packhdr|searchparse|searchreplace|tempfile|undef|verbose|warning)"};return{case_insensitive:!1,keywords:{keyword:"Abort AddBrandingImage AddSize AllowRootDirInstall AllowSkipFiles AutoCloseWindow BGFont BGGradient BrandingText BringToFront Call CallInstDLL Caption ChangeUI CheckBitmap ClearErrors CompletedText ComponentText CopyFiles CRCCheck CreateDirectory CreateFont CreateShortCut Delete DeleteINISec DeleteINIStr DeleteRegKey DeleteRegValue DetailPrint DetailsButtonText DirText DirVar DirVerify EnableWindow EnumRegKey EnumRegValue Exch Exec ExecShell ExecWait ExpandEnvStrings File FileBufSize FileClose FileErrorText FileOpen FileRead FileReadByte FileReadUTF16LE FileReadWord FileSeek FileWrite FileWriteByte FileWriteUTF16LE FileWriteWord FindClose FindFirst FindNext FindWindow FlushINI FunctionEnd GetCurInstType GetCurrentAddress GetDlgItem GetDLLVersion GetDLLVersionLocal GetErrorLevel GetFileTime GetFileTimeLocal GetFullPathName GetFunctionAddress GetInstDirError GetLabelAddress GetTempFileName Goto HideWindow Icon IfAbort IfErrors IfFileExists IfRebootFlag IfSilent InitPluginsDir InstallButtonText InstallColors InstallDir InstallDirRegKey InstProgressFlags InstType InstTypeGetText InstTypeSetText IntCmp IntCmpU IntFmt IntOp IsWindow LangString LicenseBkColor LicenseData LicenseForceSelection LicenseLangString LicenseText LoadLanguageFile LockWindow LogSet LogText ManifestDPIAware ManifestSupportedOS MessageBox MiscButtonText Name Nop OutFile Page PageCallbacks PageExEnd Pop Push Quit ReadEnvStr ReadINIStr ReadRegDWORD ReadRegStr Reboot RegDLL Rename RequestExecutionLevel ReserveFile Return RMDir SearchPath SectionEnd SectionGetFlags SectionGetInstTypes SectionGetSize SectionGetText SectionGroupEnd SectionIn SectionSetFlags SectionSetInstTypes SectionSetSize SectionSetText SendMessage SetAutoClose SetBrandingImage SetCompress SetCompressor SetCompressorDictSize SetCtlColors SetCurInstType SetDatablockOptimize SetDateSave SetDetailsPrint SetDetailsView SetErrorLevel SetErrors SetFileAttributes SetFont SetOutPath SetOverwrite SetPluginUnload SetRebootFlag SetRegView SetShellVarContext SetSilent ShowInstDetails ShowUninstDetails ShowWindow SilentInstall SilentUnInstall Sleep SpaceTexts StrCmp StrCmpS StrCpy StrLen SubCaption SubSectionEnd Unicode UninstallButtonText UninstallCaption UninstallIcon UninstallSubCaption UninstallText UninstPage UnRegDLL Var VIAddVersionKey VIFileVersion VIProductVersion WindowIcon WriteINIStr WriteRegBin WriteRegDWORD WriteRegExpandStr WriteRegStr WriteUninstaller XPStyle",literal:"admin all auto both colored current false force hide highest lastused leave listonly none normal notset off on open print show silent silentlog smooth textonly true user "},contains:[hljs.HASH_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,{className:"string",begin:'"',end:'"',illegal:"\\n",contains:[{className:"symbol",begin:"\\$(\\\\(n|r|t)|\\$)"},CONSTANTS,DEFINES,VARIABLES,LANGUAGES]},hljs.COMMENT(";","$",{relevance:0}),{className:"function",beginKeywords:"Function PageEx Section SectionGroup SubSection",end:"$"},COMPILER,DEFINES,VARIABLES,LANGUAGES,PARAMETERS,hljs.NUMBER_MODE,{className:"literal",begin:hljs.IDENT_RE+"::"+hljs.IDENT_RE}]}}),hljs.registerLanguage("objectivec",function(hljs){var API_CLASS={className:"built_in",begin:"(AV|CA|CF|CG|CI|MK|MP|NS|UI)\\w+"},OBJC_KEYWORDS={keyword:"int float while char export sizeof typedef const struct for union unsigned long volatile static bool mutable if do return goto void enum else break extern asm case short default double register explicit signed typename this switch continue wchar_t inline readonly assign readwrite self @synchronized id typeof nonatomic super unichar IBOutlet IBAction strong weak copy in out inout bycopy byref oneway __strong __weak __block __autoreleasing @private @protected @public @try @property @end @throw @catch @finally @autoreleasepool @synthesize @dynamic @selector @optional @required",literal:"false true FALSE TRUE nil YES NO NULL",built_in:"BOOL dispatch_once_t dispatch_queue_t dispatch_sync dispatch_async dispatch_once"},LEXEMES=/[a-zA-Z@][a-zA-Z0-9_]*/,CLASS_KEYWORDS="@interface @class @protocol @implementation";return{aliases:["mm","objc","obj-c"],keywords:OBJC_KEYWORDS,lexemes:LEXEMES,illegal:"</",contains:[API_CLASS,hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.C_NUMBER_MODE,hljs.QUOTE_STRING_MODE,{className:"string",variants:[{begin:'@"',end:'"',illegal:"\\n",contains:[hljs.BACKSLASH_ESCAPE]},{begin:"'",end:"[^\\\\]'",illegal:"[^\\\\][^']"}]},{className:"preprocessor",begin:"#",end:"$",contains:[{className:"title",variants:[{begin:'"',end:'"'},{begin:"<",end:">"}]}]},{className:"class",begin:"("+CLASS_KEYWORDS.split(" ").join("|")+")\\b",end:"({|$)",excludeEnd:!0,keywords:CLASS_KEYWORDS,lexemes:LEXEMES,contains:[hljs.UNDERSCORE_TITLE_MODE]},{className:"variable",begin:"\\."+hljs.UNDERSCORE_IDENT_RE,relevance:0}]}}),hljs.registerLanguage("ocaml",function(hljs){return{aliases:["ml"],keywords:{keyword:"and as assert asr begin class constraint do done downto else end exception external for fun function functor if in include inherit! inherit initializer land lazy let lor lsl lsr lxor match method!|10 method mod module mutable new object of open! open or private rec sig struct then to try type val! val virtual when while with parser value",built_in:"array bool bytes char exn|5 float int int32 int64 list lazy_t|5 nativeint|5 string unit in_channel out_channel ref",literal:"true false"},illegal:/\/\/|>>/,lexemes:"[a-z_]\\w*!?",contains:[{className:"literal",begin:"\\[(\\|\\|)?\\]|\\(\\)",relevance:0},hljs.COMMENT("\\(\\*","\\*\\)",{contains:["self"]}),{className:"symbol",begin:"'[A-Za-z_](?!')[\\w']*"},{className:"tag",begin:"`[A-Z][\\w']*"},{className:"type",begin:"\\b[A-Z][\\w']*",relevance:0},{begin:"[a-z_]\\w*'[\\w']*"},hljs.inherit(hljs.APOS_STRING_MODE,{className:"char",relevance:0}),hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null}),{className:"number",begin:"\\b(0[xX][a-fA-F0-9_]+[Lln]?|0[oO][0-7_]+[Lln]?|0[bB][01_]+[Lln]?|[0-9][0-9_]*([Lln]|(\\.[0-9_]*)?([eE][-+]?[0-9_]+)?)?)",relevance:0},{begin:/[-=]>/}]}}),hljs.registerLanguage("openscad",function(hljs){var SPECIAL_VARS={className:"keyword",begin:"\\$(f[asn]|t|vp[rtd]|children)"},LITERALS={className:"literal",begin:"false|true|PI|undef"},NUMBERS={className:"number",begin:"\\b\\d+(\\.\\d+)?(e-?\\d+)?",relevance:0},STRING=hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null}),PREPRO={className:"preprocessor",keywords:"include use",begin:"include|use <",end:">"},PARAMS={className:"params",begin:"\\(",end:"\\)",contains:["self",NUMBERS,STRING,SPECIAL_VARS,LITERALS]},MODIFIERS={className:"built_in",begin:"[*!#%]",relevance:0},FUNCTIONS={className:"function",beginKeywords:"module function",end:"\\=|\\{",contains:[PARAMS,hljs.UNDERSCORE_TITLE_MODE]};return{aliases:["scad"],keywords:{keyword:"function module include use for intersection_for if else \\%",literal:"false true PI undef",built_in:"circle square polygon text sphere cube cylinder polyhedron translate rotate scale resize mirror multmatrix color offset hull minkowski union difference intersection abs sign sin cos tan acos asin atan atan2 floor round ceil ln log pow sqrt exp rands min max concat lookup str chr search version version_num norm cross parent_module echo import import_dxf dxf_linear_extrude linear_extrude rotate_extrude surface projection render children dxf_cross dxf_dim let assign"},contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,NUMBERS,PREPRO,STRING,SPECIAL_VARS,MODIFIERS,FUNCTIONS]}}),hljs.registerLanguage("oxygene",function(hljs){var OXYGENE_KEYWORDS="abstract add and array as asc aspect assembly async begin break block by case class concat const copy constructor continue create default delegate desc distinct div do downto dynamic each else empty end ensure enum equals event except exit extension external false final finalize finalizer finally flags for forward from function future global group has if implementation implements implies in index inherited inline interface into invariants is iterator join locked locking loop matching method mod module namespace nested new nil not notify nullable of old on operator or order out override parallel params partial pinned private procedure property protected public queryable raise read readonly record reintroduce remove repeat require result reverse sealed select self sequence set shl shr skip static step soft take then to true try tuple type union unit unsafe until uses using var virtual raises volatile where while with write xor yield await mapped deprecated stdcall cdecl pascal register safecall overload library platform reference packed strict published autoreleasepool selector strong weak unretained",CURLY_COMMENT=hljs.COMMENT("{","}",{relevance:0}),PAREN_COMMENT=hljs.COMMENT("\\(\\*","\\*\\)",{relevance:10}),STRING={className:"string",begin:"'",end:"'",contains:[{begin:"''"}]},CHAR_STRING={className:"string",begin:"(#\\d+)+"},FUNCTION={className:"function",beginKeywords:"function constructor destructor procedure method",end:"[:;]",keywords:"function constructor|10 destructor|10 procedure|10 method|10",contains:[hljs.TITLE_MODE,{className:"params",begin:"\\(",end:"\\)",keywords:OXYGENE_KEYWORDS,contains:[STRING,CHAR_STRING]},CURLY_COMMENT,PAREN_COMMENT]};return{case_insensitive:!0,keywords:OXYGENE_KEYWORDS,illegal:'("|\\$[G-Zg-z]|\\/\\*|</|=>|->)',contains:[CURLY_COMMENT,PAREN_COMMENT,hljs.C_LINE_COMMENT_MODE,STRING,CHAR_STRING,hljs.NUMBER_MODE,FUNCTION,{className:"class",begin:"=\\bclass\\b",end:"end;",keywords:OXYGENE_KEYWORDS,contains:[STRING,CHAR_STRING,CURLY_COMMENT,PAREN_COMMENT,hljs.C_LINE_COMMENT_MODE,FUNCTION]}]}}),hljs.registerLanguage("parser3",function(hljs){var CURLY_SUBCOMMENT=hljs.COMMENT("{","}",{contains:["self"]});return{subLanguage:"xml",relevance:0,contains:[hljs.COMMENT("^#","$"),hljs.COMMENT("\\^rem{","}",{relevance:10,contains:[CURLY_SUBCOMMENT]}),{className:"preprocessor",begin:"^@(?:BASE|USE|CLASS|OPTIONS)$",relevance:10},{className:"title",begin:"@[\\w\\-]+\\[[\\w^;\\-]*\\](?:\\[[\\w^;\\-]*\\])?(?:.*)$"},{className:"variable",begin:"\\$\\{?[\\w\\-\\.\\:]+\\}?"},{className:"keyword",begin:"\\^[\\w\\-\\.\\:]+"},{className:"number",begin:"\\^#[0-9a-fA-F]+"},hljs.C_NUMBER_MODE]}}),hljs.registerLanguage("pf",function(hljs){var MACRO={className:"variable",begin:/\$[\w\d#@][\w\d_]*/},TABLE={className:"variable",begin:/</,end:/>/};return{aliases:["pf.conf"],lexemes:/[a-z0-9_<>-]+/,keywords:{built_in:"block match pass load anchor|5 antispoof|10 set table",keyword:"in out log quick on rdomain inet inet6 proto from port os to routeallow-opts divert-packet divert-reply divert-to flags group icmp-typeicmp6-type label once probability recieved-on rtable prio queuetos tag tagged user keep fragment for os dropaf-to|10 binat-to|10 nat-to|10 rdr-to|10 bitmask least-stats random round-robinsource-hash static-portdup-to reply-to route-toparent bandwidth default min max qlimitblock-policy debug fingerprints hostid limit loginterface optimizationreassemble ruleset-optimization basic none profile skip state-defaultsstate-policy timeoutconst counters persistno modulate synproxy state|5 floating if-bound no-sync pflow|10 sloppysource-track global rule max-src-nodes max-src-states max-src-connmax-src-conn-rate overload flushscrub|5 max-mss min-ttl no-df|10 random-id",literal:"all any no-route self urpf-failed egress|5 unknown"},contains:[hljs.HASH_COMMENT_MODE,hljs.NUMBER_MODE,hljs.QUOTE_STRING_MODE,MACRO,TABLE]}}),hljs.registerLanguage("php",function(hljs){var VARIABLE={className:"variable",begin:"\\$+[a-zA-Z_-ÿ][a-zA-Z0-9_-ÿ]*"},PREPROCESSOR={className:"preprocessor",begin:/<\?(php)?|\?>/},STRING={className:"string",contains:[hljs.BACKSLASH_ESCAPE,PREPROCESSOR],variants:[{begin:'b"',end:'"'},{begin:"b'",end:"'"},hljs.inherit(hljs.APOS_STRING_MODE,{illegal:null}),hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null})]},NUMBER={variants:[hljs.BINARY_NUMBER_MODE,hljs.C_NUMBER_MODE]};return{aliases:["php3","php4","php5","php6"],case_insensitive:!0,keywords:"and include_once list abstract global private echo interface as static endswitch array null if endwhile or const for endforeach self var while isset public protected exit foreach throw elseif include __FILE__ empty require_once do xor return parent clone use __CLASS__ __LINE__ else break print eval new catch __METHOD__ case exception default die require __FUNCTION__ enddeclare final try switch continue endfor endif declare unset true false trait goto instanceof insteadof __DIR__ __NAMESPACE__ yield finally",contains:[hljs.C_LINE_COMMENT_MODE,hljs.HASH_COMMENT_MODE,hljs.COMMENT("/\\*","\\*/",{contains:[{className:"doctag",begin:"@[A-Za-z]+"},PREPROCESSOR]}),hljs.COMMENT("__halt_compiler.+?;",!1,{endsWithParent:!0,keywords:"__halt_compiler",lexemes:hljs.UNDERSCORE_IDENT_RE}),{className:"string",begin:/<<<['"]?\w+['"]?$/,end:/^\w+;?$/,contains:[hljs.BACKSLASH_ESCAPE,{className:"subst",variants:[{begin:/\$\w+/},{begin:/\{\$/,end:/\}/}]}]},PREPROCESSOR,VARIABLE,{begin:/(::|->)+[a-zA-Z_\x7f-\xff][a-zA-Z0-9_\x7f-\xff]*/},{className:"function",beginKeywords:"function",end:/[;{]/,excludeEnd:!0,illegal:"\\$|\\[|%",contains:[hljs.UNDERSCORE_TITLE_MODE,{className:"params",begin:"\\(",end:"\\)",contains:["self",VARIABLE,hljs.C_BLOCK_COMMENT_MODE,STRING,NUMBER]}]},{className:"class",beginKeywords:"class interface",end:"{",excludeEnd:!0,illegal:/[:\(\$"]/,contains:[{beginKeywords:"extends implements"},hljs.UNDERSCORE_TITLE_MODE]},{beginKeywords:"namespace",end:";",illegal:/[\.']/,contains:[hljs.UNDERSCORE_TITLE_MODE]},{beginKeywords:"use",end:";",contains:[hljs.UNDERSCORE_TITLE_MODE]},{begin:"=>"},STRING,NUMBER]}}),hljs.registerLanguage("powershell",function(hljs){var backtickEscape={begin:"`[\\s\\S]",relevance:0},VAR={className:"variable",variants:[{begin:/\$[\w\d][\w\d_:]*/}]},QUOTE_STRING={className:"string",begin:/"/,end:/"/,contains:[backtickEscape,VAR,{className:"variable",begin:/\$[A-z]/,end:/[^A-z]/}]},APOS_STRING={className:"string",begin:/'/,end:/'/};return{aliases:["ps"],lexemes:/-?[A-z\.\-]+/,case_insensitive:!0,keywords:{keyword:"if else foreach return function do while until elseif begin for trap data dynamicparam end break throw param continue finally in switch exit filter try process catch",literal:"$null $true $false",built_in:"Add-Content Add-History Add-Member Add-PSSnapin Clear-Content Clear-Item Clear-Item Property Clear-Variable Compare-Object ConvertFrom-SecureString Convert-Path ConvertTo-Html ConvertTo-SecureString Copy-Item Copy-ItemProperty Export-Alias Export-Clixml Export-Console Export-Csv ForEach-Object Format-Custom Format-List Format-Table Format-Wide Get-Acl Get-Alias Get-AuthenticodeSignature Get-ChildItem Get-Command Get-Content Get-Credential Get-Culture Get-Date Get-EventLog Get-ExecutionPolicy Get-Help Get-History Get-Host Get-Item Get-ItemProperty Get-Location Get-Member Get-PfxCertificate Get-Process Get-PSDrive Get-PSProvider Get-PSSnapin Get-Service Get-TraceSource Get-UICulture Get-Unique Get-Variable Get-WmiObject Group-Object Import-Alias Import-Clixml Import-Csv Invoke-Expression Invoke-History Invoke-Item Join-Path Measure-Command Measure-Object Move-Item Move-ItemProperty New-Alias New-Item New-ItemProperty New-Object New-PSDrive New-Service New-TimeSpan New-Variable Out-Default Out-File Out-Host Out-Null Out-Printer Out-String Pop-Location Push-Location Read-Host Remove-Item Remove-ItemProperty Remove-PSDrive Remove-PSSnapin Remove-Variable Rename-Item Rename-ItemProperty Resolve-Path Restart-Service Resume-Service Select-Object Select-String Set-Acl Set-Alias Set-AuthenticodeSignature Set-Content Set-Date Set-ExecutionPolicy Set-Item Set-ItemProperty Set-Location Set-PSDebug Set-Service Set-TraceSource Set-Variable Sort-Object Split-Path Start-Service Start-Sleep Start-Transcript Stop-Process Stop-Service Stop-Transcript Suspend-Service Tee-Object Test-Path Trace-Command Update-FormatData Update-TypeData Where-Object Write-Debug Write-Error Write-Host Write-Output Write-Progress Write-Verbose Write-Warning",operator:"-ne -eq -lt -gt -ge -le -not -like -notlike -match -notmatch -contains -notcontains -in -notin -replace"},contains:[hljs.HASH_COMMENT_MODE,hljs.NUMBER_MODE,QUOTE_STRING,APOS_STRING,VAR]}}),hljs.registerLanguage("processing",function(hljs){return{keywords:{keyword:"BufferedReader PVector PFont PImage PGraphics HashMap boolean byte char color double float int long String Array FloatDict FloatList IntDict IntList JSONArray JSONObject Object StringDict StringList Table TableRow XML false synchronized int abstract float private char boolean static null if const for true while long throw strictfp finally protected import native final return void enum else break transient new catch instanceof byte super volatile case assert short package default double public try this switch continue throws protected public private",constant:"P2D P3D HALF_PI PI QUARTER_PI TAU TWO_PI",variable:"displayHeight displayWidth mouseY mouseX mousePressed pmouseX pmouseY key keyCode pixels focused frameCount frameRate height width",title:"setup draw",built_in:"size createGraphics beginDraw createShape loadShape PShape arc ellipse line point quad rect triangle bezier bezierDetail bezierPoint bezierTangent curve curveDetail curvePoint curveTangent curveTightness shape shapeMode beginContour beginShape bezierVertex curveVertex endContour endShape quadraticVertex vertex ellipseMode noSmooth rectMode smooth strokeCap strokeJoin strokeWeight mouseClicked mouseDragged mouseMoved mousePressed mouseReleased mouseWheel keyPressed keyPressedkeyReleased keyTyped print println save saveFrame day hour millis minute month second year background clear colorMode fill noFill noStroke stroke alpha blue brightness color green hue lerpColor red saturation modelX modelY modelZ screenX screenY screenZ ambient emissive shininess specular add createImage beginCamera camera endCamera frustum ortho perspective printCamera printProjection cursor frameRate noCursor exit loop noLoop popStyle pushStyle redraw binary boolean byte char float hex int str unbinary unhex join match matchAll nf nfc nfp nfs split splitTokens trim append arrayCopy concat expand reverse shorten sort splice subset box sphere sphereDetail createInput createReader loadBytes loadJSONArray loadJSONObject loadStrings loadTable loadXML open parseXML saveTable selectFolder selectInput beginRaw beginRecord createOutput createWriter endRaw endRecord PrintWritersaveBytes saveJSONArray saveJSONObject saveStream saveStrings saveXML selectOutput popMatrix printMatrix pushMatrix resetMatrix rotate rotateX rotateY rotateZ scale shearX shearY translate ambientLight directionalLight lightFalloff lights lightSpecular noLights normal pointLight spotLight image imageMode loadImage noTint requestImage tint texture textureMode textureWrap blend copy filter get loadPixels set updatePixels blendMode loadShader PShaderresetShader shader createFont loadFont text textFont textAlign textLeading textMode textSize textWidth textAscent textDescent abs ceil constrain dist exp floor lerp log mag map max min norm pow round sq sqrt acos asin atan atan2 cos degrees radians sin tan noise noiseDetail noiseSeed random randomGaussian randomSeed"},contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE]}}),hljs.registerLanguage("profile",function(hljs){return{contains:[hljs.C_NUMBER_MODE,{className:"built_in",begin:"{",end:"}$",excludeBegin:!0,excludeEnd:!0,contains:[hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE],relevance:0},{className:"filename",begin:"[a-zA-Z_][\\da-zA-Z_]+\\.[\\da-zA-Z_]{1,3}",end:":",excludeEnd:!0},{className:"header",begin:"(ncalls|tottime|cumtime)",end:"$",keywords:"ncalls tottime|10 cumtime|10 filename",relevance:10},{className:"summary",begin:"function calls",end:"$",contains:[hljs.C_NUMBER_MODE],relevance:10},hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,{className:"function",begin:"\\(",end:"\\)$",contains:[hljs.UNDERSCORE_TITLE_MODE],relevance:0}]}}),hljs.registerLanguage("prolog",function(hljs){var ATOM={className:"atom",begin:/[a-z][A-Za-z0-9_]*/,relevance:0},VAR={className:"name",variants:[{begin:/[A-Z][a-zA-Z0-9_]*/},{begin:/_[A-Za-z0-9_]*/}],relevance:0},PARENTED={begin:/\(/,end:/\)/,relevance:0},LIST={begin:/\[/,end:/\]/},LINE_COMMENT={className:"comment",begin:/%/,end:/$/,contains:[hljs.PHRASAL_WORDS_MODE]},BACKTICK_STRING={className:"string",begin:/`/,end:/`/,contains:[hljs.BACKSLASH_ESCAPE]},CHAR_CODE={className:"string",begin:/0\'(\\\'|.)/},SPACE_CODE={className:"string",begin:/0\'\\s/},PRED_OP={begin:/:-/},inner=[ATOM,VAR,PARENTED,PRED_OP,LIST,LINE_COMMENT,hljs.C_BLOCK_COMMENT_MODE,hljs.QUOTE_STRING_MODE,hljs.APOS_STRING_MODE,BACKTICK_STRING,CHAR_CODE,SPACE_CODE,hljs.C_NUMBER_MODE];return PARENTED.contains=inner,LIST.contains=inner,{contains:inner.concat([{begin:/\.$/}])}}),hljs.registerLanguage("protobuf",function(hljs){return{keywords:{keyword:"package import option optional required repeated group",built_in:"double float int32 int64 uint32 uint64 sint32 sint64 fixed32 fixed64 sfixed32 sfixed64 bool string bytes",literal:"true false"},contains:[hljs.QUOTE_STRING_MODE,hljs.NUMBER_MODE,hljs.C_LINE_COMMENT_MODE,{className:"class",beginKeywords:"message enum service",end:/\{/,illegal:/\n/,contains:[hljs.inherit(hljs.TITLE_MODE,{starts:{endsWithParent:!0,excludeEnd:!0}})]},{className:"function",beginKeywords:"rpc",end:/;/,excludeEnd:!0,keywords:"rpc returns"},{className:"constant",begin:/^\s*[A-Z_]+/,end:/\s*=/,excludeEnd:!0}]}}),hljs.registerLanguage("puppet",function(hljs){var PUPPET_KEYWORDS={keyword:"and case default else elsif false if in import enherits node or true undef unless main settings $string ",literal:"alias audit before loglevel noop require subscribe tag owner ensure group mode name|0 changes context force incl lens load_path onlyif provider returns root show_diff type_check en_address ip_address realname command environment hour monute month monthday special target weekday creates cwd ogoutput refresh refreshonly tries try_sleep umask backup checksum content ctime force ignore links mtime purge recurse recurselimit replace selinux_ignore_defaults selrange selrole seltype seluser source souirce_permissions sourceselect validate_cmd validate_replacement allowdupe attribute_membership auth_membership forcelocal gid ia_load_module members system host_aliases ip allowed_trunk_vlans description device_url duplex encapsulation etherchannel native_vlan speed principals allow_root auth_class auth_type authenticate_user k_of_n mechanisms rule session_owner shared options device fstype enable hasrestart directory present absent link atboot blockdevice device dump pass remounts poller_tag use message withpath adminfile allow_virtual allowcdrom category configfiles flavor install_options instance package_settings platform responsefile status uninstall_options vendor unless_system_user unless_uid binary control flags hasstatus manifest pattern restart running start stop allowdupe auths expiry gid groups home iterations key_membership keys managehome membership password password_max_age password_min_age profile_membership profiles project purge_ssh_keys role_membership roles salt shell uid baseurl cost descr enabled enablegroups exclude failovermethod gpgcheck gpgkey http_caching include includepkgs keepalive metadata_expire metalink mirrorlist priority protect proxy proxy_password proxy_username repo_gpgcheck s3_enabled skip_if_unavailable sslcacert sslclientcert sslclientkey sslverify mounted",built_in:"architecture augeasversion blockdevices boardmanufacturer boardproductname boardserialnumber cfkey dhcp_servers domain ec2_ ec2_userdata facterversion filesystems ldom fqdn gid hardwareisa hardwaremodel hostname id|0 interfaces ipaddress ipaddress_ ipaddress6 ipaddress6_ iphostnumber is_virtual kernel kernelmajversion kernelrelease kernelversion kernelrelease kernelversion lsbdistcodename lsbdistdescription lsbdistid lsbdistrelease lsbmajdistrelease lsbminordistrelease lsbrelease macaddress macaddress_ macosx_buildversion macosx_productname macosx_productversion macosx_productverson_major macosx_productversion_minor manufacturer memoryfree memorysize netmask metmask_ network_ operatingsystem operatingsystemmajrelease operatingsystemrelease osfamily partitions path physicalprocessorcount processor processorcount productname ps puppetversion rubysitedir rubyversion selinux selinux_config_mode selinux_config_policy selinux_current_mode selinux_current_mode selinux_enforced selinux_policyversion serialnumber sp_ sshdsakey sshecdsakey sshrsakey swapencrypted swapfree swapsize timezone type uniqueid uptime uptime_days uptime_hours uptime_seconds uuid virtual vlans xendomains zfs_version zonenae zones zpool_version"},COMMENT=hljs.COMMENT("#","$"),IDENT_RE="([A-Za-z_]|::)(\\w|::)*",TITLE=hljs.inherit(hljs.TITLE_MODE,{begin:IDENT_RE}),VARIABLE={className:"variable",begin:"\\$"+IDENT_RE},STRING={className:"string",contains:[hljs.BACKSLASH_ESCAPE,VARIABLE],variants:[{begin:/'/,end:/'/},{begin:/"/,end:/"/}]};return{aliases:["pp"],contains:[COMMENT,VARIABLE,STRING,{beginKeywords:"class",end:"\\{|;",illegal:/=/,contains:[TITLE,COMMENT]},{beginKeywords:"define",end:/\{/,contains:[{className:"title",begin:hljs.IDENT_RE,endsParent:!0}]},{begin:hljs.IDENT_RE+"\\s+\\{",returnBegin:!0,end:/\S/,contains:[{className:"name",begin:hljs.IDENT_RE},{begin:/\{/,end:/\}/,keywords:PUPPET_KEYWORDS,relevance:0,contains:[STRING,COMMENT,{begin:"[a-zA-Z_]+\\s*=>"},{className:"number",begin:"(\\b0[0-7_]+)|(\\b0x[0-9a-fA-F_]+)|(\\b[1-9][0-9_]*(\\.[0-9_]+)?)|[0_]\\b",relevance:0},VARIABLE]}],relevance:0}]}}),hljs.registerLanguage("python",function(hljs){var PROMPT={className:"prompt",begin:/^(>>>|\.\.\.) /},STRING={className:"string",contains:[hljs.BACKSLASH_ESCAPE],variants:[{begin:/(u|b)?r?'''/,end:/'''/,contains:[PROMPT],relevance:10},{begin:/(u|b)?r?"""/,end:/"""/,contains:[PROMPT],relevance:10},{begin:/(u|r|ur)'/,end:/'/,relevance:10},{begin:/(u|r|ur)"/,end:/"/,relevance:10},{begin:/(b|br)'/,end:/'/},{begin:/(b|br)"/,end:/"/},hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE]},NUMBER={className:"number",relevance:0,variants:[{begin:hljs.BINARY_NUMBER_RE+"[lLjJ]?"},{begin:"\\b(0o[0-7]+)[lLjJ]?"},{begin:hljs.C_NUMBER_RE+"[lLjJ]?"}]},PARAMS={className:"params",begin:/\(/,end:/\)/,contains:["self",PROMPT,NUMBER,STRING]};return{aliases:["py","gyp"],keywords:{keyword:"and elif is global as in if from raise for except finally print import pass return exec else break not with class assert yield try while continue del or def lambda async await nonlocal|10 None True False",built_in:"Ellipsis NotImplemented"},illegal:/(<\/|->|\?)/,contains:[PROMPT,NUMBER,STRING,hljs.HASH_COMMENT_MODE,{variants:[{className:"function",beginKeywords:"def",relevance:10},{className:"class",beginKeywords:"class"}],end:/:/,illegal:/[${=;\n,]/,contains:[hljs.UNDERSCORE_TITLE_MODE,PARAMS]},{className:"decorator",begin:/^[\t ]*@/,end:/$/},{begin:/\b(print|exec)\(/}]}}),hljs.registerLanguage("q",function(hljs){var Q_KEYWORDS={keyword:"do while select delete by update from",constant:"0b 1b",built_in:"neg not null string reciprocal floor ceiling signum mod xbar xlog and or each scan over prior mmu lsq inv md5 ltime gtime count first var dev med cov cor all any rand sums prds mins maxs fills deltas ratios avgs differ prev next rank reverse iasc idesc asc desc msum mcount mavg mdev xrank mmin mmax xprev rotate distinct group where flip type key til get value attr cut set upsert raze union inter except cross sv vs sublist enlist read0 read1 hopen hclose hdel hsym hcount peach system ltrim rtrim trim lower upper ssr view tables views cols xcols keys xkey xcol xasc xdesc fkeys meta lj aj aj0 ij pj asof uj ww wj wj1 fby xgroup ungroup ej save load rsave rload show csv parse eval min max avg wavg wsum sin cos tan sum",typename:"`float `double int `timestamp `timespan `datetime `time `boolean `symbol `char `byte `short `long `real `month `date `minute `second `guid"};return{aliases:["k","kdb"],keywords:Q_KEYWORDS,lexemes:/\b(`?)[A-Za-z0-9_]+\b/,contains:[hljs.C_LINE_COMMENT_MODE,hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE]}}),hljs.registerLanguage("r",function(hljs){var IDENT_RE="([a-zA-Z]|\\.[a-zA-Z.])[a-zA-Z0-9._]*";return{contains:[hljs.HASH_COMMENT_MODE,{begin:IDENT_RE,lexemes:IDENT_RE,keywords:{keyword:"function if in break next repeat else for return switch while try tryCatch stop warning require library attach detach source setMethod setGeneric setGroupGeneric setClass ...",literal:"NULL NA TRUE FALSE T F Inf NaN NA_integer_|10 NA_real_|10 NA_character_|10 NA_complex_|10"},relevance:0},{className:"number",begin:"0[xX][0-9a-fA-F]+[Li]?\\b",relevance:0},{className:"number",begin:"\\d+(?:[eE][+\\-]?\\d*)?L\\b",relevance:0},{className:"number",begin:"\\d+\\.(?!\\d)(?:i\\b)?",relevance:0},{className:"number",begin:"\\d+(?:\\.\\d*)?(?:[eE][+\\-]?\\d*)?i?\\b",relevance:0},{className:"number",begin:"\\.\\d+(?:[eE][+\\-]?\\d*)?i?\\b",relevance:0},{begin:"`",end:"`",relevance:0},{className:"string",contains:[hljs.BACKSLASH_ESCAPE],variants:[{begin:'"',end:'"'},{begin:"'",end:"'"}]}]}}),hljs.registerLanguage("rib",function(hljs){return{keywords:"ArchiveRecord AreaLightSource Atmosphere Attribute AttributeBegin AttributeEnd Basis Begin Blobby Bound Clipping ClippingPlane Color ColorSamples ConcatTransform Cone CoordinateSystem CoordSysTransform CropWindow Curves Cylinder DepthOfField Detail DetailRange Disk Displacement Display End ErrorHandler Exposure Exterior Format FrameAspectRatio FrameBegin FrameEnd GeneralPolygon GeometricApproximation Geometry Hider Hyperboloid Identity Illuminate Imager Interior LightSource MakeCubeFaceEnvironment MakeLatLongEnvironment MakeShadow MakeTexture Matte MotionBegin MotionEnd NuPatch ObjectBegin ObjectEnd ObjectInstance Opacity Option Orientation Paraboloid Patch PatchMesh Perspective PixelFilter PixelSamples PixelVariance Points PointsGeneralPolygons PointsPolygons Polygon Procedural Projection Quantize ReadArchive RelativeDetail ReverseOrientation Rotate Scale ScreenWindow ShadingInterpolation ShadingRate Shutter Sides Skew SolidBegin SolidEnd Sphere SubdivisionMesh Surface TextureCoordinates Torus Transform TransformBegin TransformEnd TransformPoints Translate TrimCurve WorldBegin WorldEnd",illegal:"</",contains:[hljs.HASH_COMMENT_MODE,hljs.C_NUMBER_MODE,hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE]}}),hljs.registerLanguage("roboconf",function(hljs){var IDENTIFIER="[a-zA-Z-_][^\n{\r\n]+\\{";return{aliases:["graph","instances"],case_insensitive:!0,keywords:"import",contains:[{className:"facet",begin:"^facet "+IDENTIFIER,end:"}",keywords:"facet installer exports children extends",contains:[hljs.HASH_COMMENT_MODE]},{className:"instance-of",begin:"^instance of "+IDENTIFIER,end:"}",keywords:"name count channels instance-data instance-state instance of",contains:[{className:"keyword",begin:"[a-zA-Z-_]+( |	)*:"},hljs.HASH_COMMENT_MODE]},{className:"component",begin:"^"+IDENTIFIER,end:"}",lexemes:"\\(?[a-zA-Z]+\\)?",keywords:"installer exports children extends imports facets alias (optional)",contains:[{className:"string",begin:"\\.[a-zA-Z-_]+",end:"\\s|,|;",excludeEnd:!0},hljs.HASH_COMMENT_MODE]},hljs.HASH_COMMENT_MODE]}}),hljs.registerLanguage("rsl",function(hljs){return{keywords:{keyword:"float color point normal vector matrix while for if do return else break extern continue",built_in:"abs acos ambient area asin atan atmosphere attribute calculatenormal ceil cellnoise clamp comp concat cos degrees depth Deriv diffuse distance Du Dv environment exp faceforward filterstep floor format fresnel incident length lightsource log match max min mod noise normalize ntransform opposite option phong pnoise pow printf ptlined radians random reflect refract renderinfo round setcomp setxcomp setycomp setzcomp shadow sign sin smoothstep specular specularbrdf spline sqrt step tan texture textureinfo trace transform vtransform xcomp ycomp zcomp"
},illegal:"</",contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.QUOTE_STRING_MODE,hljs.APOS_STRING_MODE,hljs.C_NUMBER_MODE,{className:"preprocessor",begin:"#",end:"$"},{className:"shader",beginKeywords:"surface displacement light volume imager",end:"\\("},{className:"shading",beginKeywords:"illuminate illuminance gather",end:"\\("}]}}),hljs.registerLanguage("ruleslanguage",function(hljs){return{keywords:{keyword:"BILL_PERIOD BILL_START BILL_STOP RS_EFFECTIVE_START RS_EFFECTIVE_STOP RS_JURIS_CODE RS_OPCO_CODE INTDADDATTRIBUTE|5 INTDADDVMSG|5 INTDBLOCKOP|5 INTDBLOCKOPNA|5 INTDCLOSE|5 INTDCOUNT|5 INTDCOUNTSTATUSCODE|5 INTDCREATEMASK|5 INTDCREATEDAYMASK|5 INTDCREATEFACTORMASK|5 INTDCREATEHANDLE|5 INTDCREATEOVERRIDEDAYMASK|5 INTDCREATEOVERRIDEMASK|5 INTDCREATESTATUSCODEMASK|5 INTDCREATETOUPERIOD|5 INTDDELETE|5 INTDDIPTEST|5 INTDEXPORT|5 INTDGETERRORCODE|5 INTDGETERRORMESSAGE|5 INTDISEQUAL|5 INTDJOIN|5 INTDLOAD|5 INTDLOADACTUALCUT|5 INTDLOADDATES|5 INTDLOADHIST|5 INTDLOADLIST|5 INTDLOADLISTDATES|5 INTDLOADLISTENERGY|5 INTDLOADLISTHIST|5 INTDLOADRELATEDCHANNEL|5 INTDLOADSP|5 INTDLOADSTAGING|5 INTDLOADUOM|5 INTDLOADUOMDATES|5 INTDLOADUOMHIST|5 INTDLOADVERSION|5 INTDOPEN|5 INTDREADFIRST|5 INTDREADNEXT|5 INTDRECCOUNT|5 INTDRELEASE|5 INTDREPLACE|5 INTDROLLAVG|5 INTDROLLPEAK|5 INTDSCALAROP|5 INTDSCALE|5 INTDSETATTRIBUTE|5 INTDSETDSTPARTICIPANT|5 INTDSETSTRING|5 INTDSETVALUE|5 INTDSETVALUESTATUS|5 INTDSHIFTSTARTTIME|5 INTDSMOOTH|5 INTDSORT|5 INTDSPIKETEST|5 INTDSUBSET|5 INTDTOU|5 INTDTOURELEASE|5 INTDTOUVALUE|5 INTDUPDATESTATS|5 INTDVALUE|5 STDEV INTDDELETEEX|5 INTDLOADEXACTUAL|5 INTDLOADEXCUT|5 INTDLOADEXDATES|5 INTDLOADEX|5 INTDLOADEXRELATEDCHANNEL|5 INTDSAVEEX|5 MVLOAD|5 MVLOADACCT|5 MVLOADACCTDATES|5 MVLOADACCTHIST|5 MVLOADDATES|5 MVLOADHIST|5 MVLOADLIST|5 MVLOADLISTDATES|5 MVLOADLISTHIST|5 IF FOR NEXT DONE SELECT END CALL ABORT CLEAR CHANNEL FACTOR LIST NUMBER OVERRIDE SET WEEK DISTRIBUTIONNODE ELSE WHEN THEN OTHERWISE IENUM CSV INCLUDE LEAVE RIDER SAVE DELETE NOVALUE SECTION WARN SAVE_UPDATE DETERMINANT LABEL REPORT REVENUE EACH IN FROM TOTAL CHARGE BLOCK AND OR CSV_FILE RATE_CODE AUXILIARY_DEMAND UIDACCOUNT RS BILL_PERIOD_SELECT HOURS_PER_MONTH INTD_ERROR_STOP SEASON_SCHEDULE_NAME ACCOUNTFACTOR ARRAYUPPERBOUND CALLSTOREDPROC GETADOCONNECTION GETCONNECT GETDATASOURCE GETQUALIFIER GETUSERID HASVALUE LISTCOUNT LISTOP LISTUPDATE LISTVALUE PRORATEFACTOR RSPRORATE SETBINPATH SETDBMONITOR WQ_OPEN BILLINGHOURS DATE DATEFROMFLOAT DATETIMEFROMSTRING DATETIMETOSTRING DATETOFLOAT DAY DAYDIFF DAYNAME DBDATETIME HOUR MINUTE MONTH MONTHDIFF MONTHHOURS MONTHNAME ROUNDDATE SAMEWEEKDAYLASTYEAR SECOND WEEKDAY WEEKDIFF YEAR YEARDAY YEARSTR COMPSUM HISTCOUNT HISTMAX HISTMIN HISTMINNZ HISTVALUE MAXNRANGE MAXRANGE MINRANGE COMPIKVA COMPKVA COMPKVARFROMKQKW COMPLF IDATTR FLAG LF2KW LF2KWH MAXKW POWERFACTOR READING2USAGE AVGSEASON MAXSEASON MONTHLYMERGE SEASONVALUE SUMSEASON ACCTREADDATES ACCTTABLELOAD CONFIGADD CONFIGGET CREATEOBJECT CREATEREPORT EMAILCLIENT EXPBLKMDMUSAGE EXPMDMUSAGE EXPORT_USAGE FACTORINEFFECT GETUSERSPECIFIEDSTOP INEFFECT ISHOLIDAY RUNRATE SAVE_PROFILE SETREPORTTITLE USEREXIT WATFORRUNRATE TO TABLE ACOS ASIN ATAN ATAN2 BITAND CEIL COS COSECANT COSH COTANGENT DIVQUOT DIVREM EXP FABS FLOOR FMOD FREPM FREXPN LOG LOG10 MAX MAXN MIN MINNZ MODF POW ROUND ROUND2VALUE ROUNDINT SECANT SIN SINH SQROOT TAN TANH FLOAT2STRING FLOAT2STRINGNC INSTR LEFT LEN LTRIM MID RIGHT RTRIM STRING STRINGNC TOLOWER TOUPPER TRIM NUMDAYS READ_DATE STAGING",built_in:"IDENTIFIER OPTIONS XML_ELEMENT XML_OP XML_ELEMENT_OF DOMDOCCREATE DOMDOCLOADFILE DOMDOCLOADXML DOMDOCSAVEFILE DOMDOCGETROOT DOMDOCADDPI DOMNODEGETNAME DOMNODEGETTYPE DOMNODEGETVALUE DOMNODEGETCHILDCT DOMNODEGETFIRSTCHILD DOMNODEGETSIBLING DOMNODECREATECHILDELEMENT DOMNODESETATTRIBUTE DOMNODEGETCHILDELEMENTCT DOMNODEGETFIRSTCHILDELEMENT DOMNODEGETSIBLINGELEMENT DOMNODEGETATTRIBUTECT DOMNODEGETATTRIBUTEI DOMNODEGETATTRIBUTEBYNAME DOMNODEGETBYNAME"},contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE,{className:"array",variants:[{begin:"#\\s+[a-zA-Z\\ \\.]*",relevance:0},{begin:"#[a-zA-Z\\ \\.]+"}]}]}}),hljs.registerLanguage("rust",function(hljs){var NUM_SUFFIX="([uif](8|16|32|64|size))?",BLOCK_COMMENT=hljs.inherit(hljs.C_BLOCK_COMMENT_MODE);return BLOCK_COMMENT.contains.push("self"),{aliases:["rs"],keywords:{keyword:"alignof as be box break const continue crate do else enum extern false fn for if impl in let loop match mod mut offsetof once priv proc pub pure ref return self Self sizeof static struct super trait true type typeof unsafe unsized use virtual while where yield int i8 i16 i32 i64 uint u8 u32 u64 float f32 f64 str char bool",built_in:"Copy Send Sized Sync Drop Fn FnMut FnOnce drop Box ToOwned Clone PartialEq PartialOrd Eq Ord AsRef AsMut Into From Default Iterator Extend IntoIterator DoubleEndedIterator ExactSizeIterator Option Some None Result Ok Err SliceConcatExt String ToString Vec assert! assert_eq! bitflags! bytes! cfg! col! concat! concat_idents! debug_assert! debug_assert_eq! env! panic! file! format! format_args! include_bin! include_str! line! local_data_key! module_path! option_env! print! println! select! stringify! try! unimplemented! unreachable! vec! write! writeln!"},lexemes:hljs.IDENT_RE+"!?",illegal:"</",contains:[hljs.C_LINE_COMMENT_MODE,BLOCK_COMMENT,hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null}),{className:"string",variants:[{begin:/r(#*)".*?"\1(?!#)/},{begin:/'\\?(x\w{2}|u\w{4}|U\w{8}|.)'/},{begin:/'[a-zA-Z_][a-zA-Z0-9_]*/}]},{className:"number",variants:[{begin:"\\b0b([01_]+)"+NUM_SUFFIX},{begin:"\\b0o([0-7_]+)"+NUM_SUFFIX},{begin:"\\b0x([A-Fa-f0-9_]+)"+NUM_SUFFIX},{begin:"\\b(\\d[\\d_]*(\\.[0-9_]+)?([eE][+-]?[0-9_]+)?)"+NUM_SUFFIX}],relevance:0},{className:"function",beginKeywords:"fn",end:"(\\(|<)",excludeEnd:!0,contains:[hljs.UNDERSCORE_TITLE_MODE]},{className:"preprocessor",begin:"#\\!?\\[",end:"\\]"},{beginKeywords:"type",end:"(=|<)",contains:[hljs.UNDERSCORE_TITLE_MODE],illegal:"\\S"},{beginKeywords:"trait enum",end:"{",contains:[hljs.inherit(hljs.UNDERSCORE_TITLE_MODE,{endsParent:!0})],illegal:"[\\w\\d]"},{begin:hljs.IDENT_RE+"::"},{begin:"->"}]}}),hljs.registerLanguage("scala",function(hljs){var ANNOTATION={className:"annotation",begin:"@[A-Za-z]+"},STRING={className:"string",begin:'u?r?"""',end:'"""',relevance:10},SYMBOL={className:"symbol",begin:"'\\w[\\w\\d_]*(?!')"},TYPE={className:"type",begin:"\\b[A-Z][A-Za-z0-9_]*",relevance:0},NAME={className:"title",begin:/[^0-9\n\t "'(),.`{}\[\]:;][^\n\t "'(),.`{}\[\]:;]+|[^0-9\n\t "'(),.`{}\[\]:;=]/,relevance:0},CLASS={className:"class",beginKeywords:"class object trait type",end:/[:={\[(\n;]/,contains:[{className:"keyword",beginKeywords:"extends with",relevance:10},NAME]},METHOD={className:"function",beginKeywords:"def",end:/[:={\[(\n;]/,contains:[NAME]};return{keywords:{literal:"true false null",keyword:"type yield lazy override def with val var sealed abstract private trait object if forSome for while throw finally protected extends import final return else break new catch super class case package default try this match continue throws implicit"},contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,STRING,hljs.QUOTE_STRING_MODE,SYMBOL,TYPE,METHOD,CLASS,hljs.C_NUMBER_MODE,ANNOTATION]}}),hljs.registerLanguage("scheme",function(hljs){var SCHEME_IDENT_RE="[^\\(\\)\\[\\]\\{\\}\",'`;#|\\\\\\s]+",SCHEME_SIMPLE_NUMBER_RE="(\\-|\\+)?\\d+([./]\\d+)?",SCHEME_COMPLEX_NUMBER_RE=SCHEME_SIMPLE_NUMBER_RE+"[+\\-]"+SCHEME_SIMPLE_NUMBER_RE+"i",BUILTINS={built_in:"case-lambda call/cc class define-class exit-handler field import inherit init-field interface let*-values let-values let/ec mixin opt-lambda override protect provide public rename require require-for-syntax syntax syntax-case syntax-error unit/sig unless when with-syntax and begin call-with-current-continuation call-with-input-file call-with-output-file case cond define define-syntax delay do dynamic-wind else for-each if lambda let let* let-syntax letrec letrec-syntax map or syntax-rules ' * + , ,@ - ... / ; < <= = => > >= ` abs acos angle append apply asin assoc assq assv atan boolean? caar cadr call-with-input-file call-with-output-file call-with-values car cdddar cddddr cdr ceiling char->integer char-alphabetic? char-ci<=? char-ci<? char-ci=? char-ci>=? char-ci>? char-downcase char-lower-case? char-numeric? char-ready? char-upcase char-upper-case? char-whitespace? char<=? char<? char=? char>=? char>? char? close-input-port close-output-port complex? cons cos current-input-port current-output-port denominator display eof-object? eq? equal? eqv? eval even? exact->inexact exact? exp expt floor force gcd imag-part inexact->exact inexact? input-port? integer->char integer? interaction-environment lcm length list list->string list->vector list-ref list-tail list? load log magnitude make-polar make-rectangular make-string make-vector max member memq memv min modulo negative? newline not null-environment null? number->string number? numerator odd? open-input-file open-output-file output-port? pair? peek-char port? positive? procedure? quasiquote quote quotient rational? rationalize read read-char real-part real? remainder reverse round scheme-report-environment set! set-car! set-cdr! sin sqrt string string->list string->number string->symbol string-append string-ci<=? string-ci<? string-ci=? string-ci>=? string-ci>? string-copy string-fill! string-length string-ref string-set! string<=? string<? string=? string>=? string>? string? substring symbol->string symbol? tan transcript-off transcript-on truncate values vector vector->list vector-fill! vector-length vector-ref vector-set! with-input-from-file with-output-to-file write write-char zero?"},SHEBANG={className:"shebang",begin:"^#!",end:"$"},LITERAL={className:"literal",begin:"(#t|#f|#\\\\"+SCHEME_IDENT_RE+"|#\\\\.)"},NUMBER={className:"number",variants:[{begin:SCHEME_SIMPLE_NUMBER_RE,relevance:0},{begin:SCHEME_COMPLEX_NUMBER_RE,relevance:0},{begin:"#b[0-1]+(/[0-1]+)?"},{begin:"#o[0-7]+(/[0-7]+)?"},{begin:"#x[0-9a-f]+(/[0-9a-f]+)?"}]},STRING=hljs.QUOTE_STRING_MODE,COMMENT_MODES=[hljs.COMMENT(";","$",{relevance:0}),hljs.COMMENT("#\\|","\\|#")],IDENT={begin:SCHEME_IDENT_RE,relevance:0},QUOTED_IDENT={className:"variable",begin:"'"+SCHEME_IDENT_RE},BODY={endsWithParent:!0,relevance:0},LIST={className:"list",variants:[{begin:"\\(",end:"\\)"},{begin:"\\[",end:"\\]"}],contains:[{className:"keyword",begin:SCHEME_IDENT_RE,lexemes:SCHEME_IDENT_RE,keywords:BUILTINS},BODY]};return BODY.contains=[LITERAL,NUMBER,STRING,IDENT,QUOTED_IDENT,LIST].concat(COMMENT_MODES),{illegal:/\S/,contains:[SHEBANG,NUMBER,STRING,QUOTED_IDENT,LIST].concat(COMMENT_MODES)}}),hljs.registerLanguage("scilab",function(hljs){var COMMON_CONTAINS=[hljs.C_NUMBER_MODE,{className:"string",begin:"'|\"",end:"'|\"",contains:[hljs.BACKSLASH_ESCAPE,{begin:"''"}]}];return{aliases:["sci"],keywords:{keyword:"abort break case clear catch continue do elseif else endfunction end for functionglobal if pause return resume select try then while%f %F %t %T %pi %eps %inf %nan %e %i %z %s",built_in:"abs and acos asin atan ceil cd chdir clearglobal cosh cos cumprod deff disp errorexec execstr exists exp eye gettext floor fprintf fread fsolve imag isdef isemptyisinfisnan isvector lasterror length load linspace list listfiles log10 log2 logmax min msprintf mclose mopen ones or pathconvert poly printf prod pwd rand realround sinh sin size gsort sprintf sqrt strcat strcmps tring sum system tanh tantype typename warning zeros matrix"},illegal:'("|#|/\\*|\\s+/\\w+)',contains:[{className:"function",beginKeywords:"function endfunction",end:"$",keywords:"function endfunction|10",contains:[hljs.UNDERSCORE_TITLE_MODE,{className:"params",begin:"\\(",end:"\\)"}]},{className:"transposed_variable",begin:"[a-zA-Z_][a-zA-Z_0-9]*('+[\\.']*|[\\.']+)",end:"",relevance:0},{className:"matrix",begin:"\\[",end:"\\]'*[\\.']*",relevance:0,contains:COMMON_CONTAINS},hljs.COMMENT("//","$")].concat(COMMON_CONTAINS)}}),hljs.registerLanguage("scss",function(hljs){var IDENT_RE="[a-zA-Z-][a-zA-Z0-9_-]*",VARIABLE={className:"variable",begin:"(\\$"+IDENT_RE+")\\b"},FUNCTION={className:"function",begin:IDENT_RE+"\\(",returnBegin:!0,excludeEnd:!0,end:"\\("},HEXCOLOR={className:"hexcolor",begin:"#[0-9A-Fa-f]+"};({className:"attribute",begin:"[A-Z\\_\\.\\-]+",end:":",excludeEnd:!0,illegal:"[^\\s]",starts:{className:"value",endsWithParent:!0,excludeEnd:!0,contains:[FUNCTION,HEXCOLOR,hljs.CSS_NUMBER_MODE,hljs.QUOTE_STRING_MODE,hljs.APOS_STRING_MODE,hljs.C_BLOCK_COMMENT_MODE,{className:"important",begin:"!important"}]}});return{case_insensitive:!0,illegal:"[=/|']",contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,FUNCTION,{className:"id",begin:"\\#[A-Za-z0-9_-]+",relevance:0},{className:"class",begin:"\\.[A-Za-z0-9_-]+",relevance:0},{className:"attr_selector",begin:"\\[",end:"\\]",illegal:"$"},{className:"tag",begin:"\\b(a|abbr|acronym|address|area|article|aside|audio|b|base|big|blockquote|body|br|button|canvas|caption|cite|code|col|colgroup|command|datalist|dd|del|details|dfn|div|dl|dt|em|embed|fieldset|figcaption|figure|footer|form|frame|frameset|(h[1-6])|head|header|hgroup|hr|html|i|iframe|img|input|ins|kbd|keygen|label|legend|li|link|map|mark|meta|meter|nav|noframes|noscript|object|ol|optgroup|option|output|p|param|pre|progress|q|rp|rt|ruby|samp|script|section|select|small|span|strike|strong|style|sub|sup|table|tbody|td|textarea|tfoot|th|thead|time|title|tr|tt|ul|var|video)\\b",relevance:0},{className:"pseudo",begin:":(visited|valid|root|right|required|read-write|read-only|out-range|optional|only-of-type|only-child|nth-of-type|nth-last-of-type|nth-last-child|nth-child|not|link|left|last-of-type|last-child|lang|invalid|indeterminate|in-range|hover|focus|first-of-type|first-line|first-letter|first-child|first|enabled|empty|disabled|default|checked|before|after|active)"},{className:"pseudo",begin:"::(after|before|choices|first-letter|first-line|repeat-index|repeat-item|selection|value)"},VARIABLE,{className:"attribute",begin:"\\b(z-index|word-wrap|word-spacing|word-break|width|widows|white-space|visibility|vertical-align|unicode-bidi|transition-timing-function|transition-property|transition-duration|transition-delay|transition|transform-style|transform-origin|transform|top|text-underline-position|text-transform|text-shadow|text-rendering|text-overflow|text-indent|text-decoration-style|text-decoration-line|text-decoration-color|text-decoration|text-align-last|text-align|tab-size|table-layout|right|resize|quotes|position|pointer-events|perspective-origin|perspective|page-break-inside|page-break-before|page-break-after|padding-top|padding-right|padding-left|padding-bottom|padding|overflow-y|overflow-x|overflow-wrap|overflow|outline-width|outline-style|outline-offset|outline-color|outline|orphans|order|opacity|object-position|object-fit|normal|none|nav-up|nav-right|nav-left|nav-index|nav-down|min-width|min-height|max-width|max-height|mask|marks|margin-top|margin-right|margin-left|margin-bottom|margin|list-style-type|list-style-position|list-style-image|list-style|line-height|letter-spacing|left|justify-content|initial|inherit|ime-mode|image-orientation|image-resolution|image-rendering|icon|hyphens|height|font-weight|font-variant-ligatures|font-variant|font-style|font-stretch|font-size-adjust|font-size|font-language-override|font-kerning|font-feature-settings|font-family|font|float|flex-wrap|flex-shrink|flex-grow|flex-flow|flex-direction|flex-basis|flex|filter|empty-cells|display|direction|cursor|counter-reset|counter-increment|content|column-width|column-span|column-rule-width|column-rule-style|column-rule-color|column-rule|column-gap|column-fill|column-count|columns|color|clip-path|clip|clear|caption-side|break-inside|break-before|break-after|box-sizing|box-shadow|box-decoration-break|bottom|border-width|border-top-width|border-top-style|border-top-right-radius|border-top-left-radius|border-top-color|border-top|border-style|border-spacing|border-right-width|border-right-style|border-right-color|border-right|border-radius|border-left-width|border-left-style|border-left-color|border-left|border-image-width|border-image-source|border-image-slice|border-image-repeat|border-image-outset|border-image|border-color|border-collapse|border-bottom-width|border-bottom-style|border-bottom-right-radius|border-bottom-left-radius|border-bottom-color|border-bottom|border|background-size|background-repeat|background-position|background-origin|background-image|background-color|background-clip|background-attachment|background-blend-mode|background|backface-visibility|auto|animation-timing-function|animation-play-state|animation-name|animation-iteration-count|animation-fill-mode|animation-duration|animation-direction|animation-delay|animation|align-self|align-items|align-content)\\b",illegal:"[^\\s]"},{className:"value",begin:"\\b(whitespace|wait|w-resize|visible|vertical-text|vertical-ideographic|uppercase|upper-roman|upper-alpha|underline|transparent|top|thin|thick|text|text-top|text-bottom|tb-rl|table-header-group|table-footer-group|sw-resize|super|strict|static|square|solid|small-caps|separate|se-resize|scroll|s-resize|rtl|row-resize|ridge|right|repeat|repeat-y|repeat-x|relative|progress|pointer|overline|outside|outset|oblique|nowrap|not-allowed|normal|none|nw-resize|no-repeat|no-drop|newspaper|ne-resize|n-resize|move|middle|medium|ltr|lr-tb|lowercase|lower-roman|lower-alpha|loose|list-item|line|line-through|line-edge|lighter|left|keep-all|justify|italic|inter-word|inter-ideograph|inside|inset|inline|inline-block|inherit|inactive|ideograph-space|ideograph-parenthesis|ideograph-numeric|ideograph-alpha|horizontal|hidden|help|hand|groove|fixed|ellipsis|e-resize|double|dotted|distribute|distribute-space|distribute-letter|distribute-all-lines|disc|disabled|default|decimal|dashed|crosshair|collapse|col-resize|circle|char|center|capitalize|break-word|break-all|bottom|both|bolder|bold|block|bidi-override|below|baseline|auto|always|all-scroll|absolute|table|table-cell)\\b"},{className:"value",begin:":",end:";",contains:[FUNCTION,VARIABLE,HEXCOLOR,hljs.CSS_NUMBER_MODE,hljs.QUOTE_STRING_MODE,hljs.APOS_STRING_MODE,{className:"important",begin:"!important"}]},{className:"at_rule",begin:"@",end:"[{;]",keywords:"mixin include extend for if else each while charset import debug media page content font-face namespace warn",contains:[FUNCTION,VARIABLE,hljs.QUOTE_STRING_MODE,hljs.APOS_STRING_MODE,HEXCOLOR,hljs.CSS_NUMBER_MODE,{className:"preprocessor",begin:"\\s[A-Za-z0-9_.-]+",relevance:0}]}]}}),hljs.registerLanguage("smali",function(hljs){var smali_instr_low_prio=["add","and","cmp","cmpg","cmpl","const","div","double","float","goto","if","int","long","move","mul","neg","new","nop","not","or","rem","return","shl","shr","sput","sub","throw","ushr","xor"],smali_instr_high_prio=["aget","aput","array","check","execute","fill","filled","goto/16","goto/32","iget","instance","invoke","iput","monitor","packed","sget","sparse"],smali_keywords=["transient","constructor","abstract","final","synthetic","public","private","protected","static","bridge","system"];return{aliases:["smali"],contains:[{className:"string",begin:'"',end:'"',relevance:0},hljs.COMMENT("#","$",{relevance:0}),{className:"keyword",begin:"\\s*\\.end\\s[a-zA-Z0-9]*",relevance:1},{className:"keyword",begin:"^[ ]*\\.[a-zA-Z]*",relevance:0},{className:"keyword",begin:"\\s:[a-zA-Z_0-9]*",relevance:0},{className:"keyword",begin:"\\s("+smali_keywords.join("|")+")",relevance:1},{className:"keyword",begin:"\\[",relevance:0},{className:"instruction",begin:"\\s("+smali_instr_low_prio.join("|")+")\\s",relevance:1},{className:"instruction",begin:"\\s("+smali_instr_low_prio.join("|")+")((\\-|/)[a-zA-Z0-9]+)+\\s",relevance:10},{className:"instruction",begin:"\\s("+smali_instr_high_prio.join("|")+")((\\-|/)[a-zA-Z0-9]+)*\\s",relevance:10},{className:"class",begin:"L[^(;:\n]*;",relevance:0},{className:"function",begin:'( |->)[^(\n ;"]*\\(',relevance:0},{className:"function",begin:"\\)",relevance:0},{className:"variable",begin:"[vp][0-9]+",relevance:0}]}}),hljs.registerLanguage("smalltalk",function(hljs){var VAR_IDENT_RE="[a-z][a-zA-Z0-9_]*",CHAR={className:"char",begin:"\\$.{1}"},SYMBOL={className:"symbol",begin:"#"+hljs.UNDERSCORE_IDENT_RE};return{aliases:["st"],keywords:"self super nil true false thisContext",contains:[hljs.COMMENT('"','"'),hljs.APOS_STRING_MODE,{className:"class",begin:"\\b[A-Z][A-Za-z0-9_]*",relevance:0},{className:"method",begin:VAR_IDENT_RE+":",relevance:0},hljs.C_NUMBER_MODE,SYMBOL,CHAR,{className:"localvars",begin:"\\|[ ]*"+VAR_IDENT_RE+"([ ]+"+VAR_IDENT_RE+")*[ ]*\\|",returnBegin:!0,end:/\|/,illegal:/\S/,contains:[{begin:"(\\|[ ]*)?"+VAR_IDENT_RE}]},{className:"array",begin:"\\#\\(",end:"\\)",contains:[hljs.APOS_STRING_MODE,CHAR,hljs.C_NUMBER_MODE,SYMBOL]}]}}),hljs.registerLanguage("sml",function(hljs){return{aliases:["ml"],keywords:{keyword:"abstype and andalso as case datatype do else end eqtype exception fn fun functor handle if in include infix infixr let local nonfix of op open orelse raise rec sharing sig signature struct structure then type val with withtype where while",built_in:"array bool char exn int list option order real ref string substring vector unit word",literal:"true false NONE SOME LESS EQUAL GREATER nil"},illegal:/\/\/|>>/,lexemes:"[a-z_]\\w*!?",contains:[{className:"literal",begin:"\\[(\\|\\|)?\\]|\\(\\)"},hljs.COMMENT("\\(\\*","\\*\\)",{contains:["self"]}),{className:"symbol",begin:"'[A-Za-z_](?!')[\\w']*"},{className:"tag",begin:"`[A-Z][\\w']*"},{className:"type",begin:"\\b[A-Z][\\w']*",relevance:0},{begin:"[a-z_]\\w*'[\\w']*"},hljs.inherit(hljs.APOS_STRING_MODE,{className:"char",relevance:0}),hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null}),{className:"number",begin:"\\b(0[xX][a-fA-F0-9_]+[Lln]?|0[oO][0-7_]+[Lln]?|0[bB][01_]+[Lln]?|[0-9][0-9_]*([Lln]|(\\.[0-9_]*)?([eE][-+]?[0-9_]+)?)?)",relevance:0},{begin:/[-=]>/}]}}),hljs.registerLanguage("sqf",function(hljs){var allCommands=["!","-","+","!=","%","&&","*","/","=","==",">",">=","<","<=","or","plus","^",":",">>","abs","accTime","acos","action","actionKeys","actionKeysImages","actionKeysNames","actionKeysNamesArray","actionName","activateAddons","activatedAddons","activateKey","addAction","addBackpack","addBackpackCargo","addBackpackCargoGlobal","addBackpackGlobal","addCamShake","addCuratorAddons","addCuratorCameraArea","addCuratorEditableObjects","addCuratorEditingArea","addCuratorPoints","addEditorObject","addEventHandler","addGoggles","addGroupIcon","addHandgunItem","addHeadgear","addItem","addItemCargo","addItemCargoGlobal","addItemPool","addItemToBackpack","addItemToUniform","addItemToVest","addLiveStats","addMagazine","addMagazine array","addMagazineAmmoCargo","addMagazineCargo","addMagazineCargoGlobal","addMagazineGlobal","addMagazinePool","addMagazines","addMagazineTurret","addMenu","addMenuItem","addMissionEventHandler","addMPEventHandler","addMusicEventHandler","addPrimaryWeaponItem","addPublicVariableEventHandler","addRating","addResources","addScore","addScoreSide","addSecondaryWeaponItem","addSwitchableUnit","addTeamMember","addToRemainsCollector","addUniform","addVehicle","addVest","addWaypoint","addWeapon","addWeaponCargo","addWeaponCargoGlobal","addWeaponGlobal","addWeaponPool","addWeaponTurret","agent","agents","AGLToASL","aimedAtTarget","aimPos","airDensityRTD","airportSide","AISFinishHeal","alive","allControls","allCurators","allDead","allDeadMen","allDisplays","allGroups","allMapMarkers","allMines","allMissionObjects","allow3DMode","allowCrewInImmobile","allowCuratorLogicIgnoreAreas","allowDamage","allowDammage","allowFileOperations","allowFleeing","allowGetIn","allPlayers","allSites","allTurrets","allUnits","allUnitsUAV","allVariables","ammo","and","animate","animateDoor","animationPhase","animationState","append","armoryPoints","arrayIntersect","asin","ASLToAGL","ASLToATL","assert","assignAsCargo","assignAsCargoIndex","assignAsCommander","assignAsDriver","assignAsGunner","assignAsTurret","assignCurator","assignedCargo","assignedCommander","assignedDriver","assignedGunner","assignedItems","assignedTarget","assignedTeam","assignedVehicle","assignedVehicleRole","assignItem","assignTeam","assignToAirport","atan","atan2","atg","ATLToASL","attachedObject","attachedObjects","attachedTo","attachObject","attachTo","attackEnabled","backpack","backpackCargo","backpackContainer","backpackItems","backpackMagazines","backpackSpaceFor","behaviour","benchmark","binocular","blufor","boundingBox","boundingBoxReal","boundingCenter","breakOut","breakTo","briefingName","buildingExit","buildingPos","buttonAction","buttonSetAction","cadetMode","call","callExtension","camCommand","camCommit","camCommitPrepared","camCommitted","camConstuctionSetParams","camCreate","camDestroy","cameraEffect","cameraEffectEnableHUD","cameraInterest","cameraOn","cameraView","campaignConfigFile","camPreload","camPreloaded","camPrepareBank","camPrepareDir","camPrepareDive","camPrepareFocus","camPrepareFov","camPrepareFovRange","camPreparePos","camPrepareRelPos","camPrepareTarget","camSetBank","camSetDir","camSetDive","camSetFocus","camSetFov","camSetFovRange","camSetPos","camSetRelPos","camSetTarget","camTarget","camUseNVG","canAdd","canAddItemToBackpack","canAddItemToUniform","canAddItemToVest","cancelSimpleTaskDestination","canFire","canMove","canSlingLoad","canStand","canUnloadInCombat","captive","captiveNum","case","catch","cbChecked","cbSetChecked","ceil","cheatsEnabled","checkAIFeature","civilian","className","clearAllItemsFromBackpack","clearBackpackCargo","clearBackpackCargoGlobal","clearGroupIcons","clearItemCargo","clearItemCargoGlobal","clearItemPool","clearMagazineCargo","clearMagazineCargoGlobal","clearMagazinePool","clearOverlay","clearRadio","clearWeaponCargo","clearWeaponCargoGlobal","clearWeaponPool","closeDialog","closeDisplay","closeOverlay","collapseObjectTree","combatMode","commandArtilleryFire","commandChat","commander","commandFire","commandFollow","commandFSM","commandGetOut","commandingMenu","commandMove","commandRadio","commandStop","commandTarget","commandWatch","comment","commitOverlay","compile","compileFinal","completedFSM","composeText","configClasses","configFile","configHierarchy","configName","configProperties","configSourceMod","configSourceModList","connectTerminalToUAV","controlNull","controlsGroupCtrl","copyFromClipboard","copyToClipboard","copyWaypoints","cos","count","countEnemy","countFriendly","countSide","countType","countUnknown","createAgent","createCenter","createDialog","createDiaryLink","createDiaryRecord","createDiarySubject","createDisplay","createGearDialog","createGroup","createGuardedPoint","createLocation","createMarker","createMarkerLocal","createMenu","createMine","createMissionDisplay","createSimpleTask","createSite","createSoundSource","createTask","createTeam","createTrigger","createUnit","createUnit array","createVehicle","createVehicle array","createVehicleCrew","createVehicleLocal","crew","ctrlActivate","ctrlAddEventHandler","ctrlAutoScrollDelay","ctrlAutoScrollRewind","ctrlAutoScrollSpeed","ctrlChecked","ctrlClassName","ctrlCommit","ctrlCommitted","ctrlCreate","ctrlDelete","ctrlEnable","ctrlEnabled","ctrlFade","ctrlHTMLLoaded","ctrlIDC","ctrlIDD","ctrlMapAnimAdd","ctrlMapAnimClear","ctrlMapAnimCommit","ctrlMapAnimDone","ctrlMapCursor","ctrlMapMouseOver","ctrlMapScale","ctrlMapScreenToWorld","ctrlMapWorldToScreen","ctrlModel","ctrlModelDirAndUp","ctrlModelScale","ctrlParent","ctrlPosition","ctrlRemoveAllEventHandlers","ctrlRemoveEventHandler","ctrlScale","ctrlSetActiveColor","ctrlSetAutoScrollDelay","ctrlSetAutoScrollRewind","ctrlSetAutoScrollSpeed","ctrlSetBackgroundColor","ctrlSetChecked","ctrlSetEventHandler","ctrlSetFade","ctrlSetFocus","ctrlSetFont","ctrlSetFontH1","ctrlSetFontH1B","ctrlSetFontH2","ctrlSetFontH2B","ctrlSetFontH3","ctrlSetFontH3B","ctrlSetFontH4","ctrlSetFontH4B","ctrlSetFontH5","ctrlSetFontH5B","ctrlSetFontH6","ctrlSetFontH6B","ctrlSetFontHeight","ctrlSetFontHeightH1","ctrlSetFontHeightH2","ctrlSetFontHeightH3","ctrlSetFontHeightH4","ctrlSetFontHeightH5","ctrlSetFontHeightH6","ctrlSetFontP","ctrlSetFontPB","ctrlSetForegroundColor","ctrlSetModel","ctrlSetModelDirAndUp","ctrlSetModelScale","ctrlSetPosition","ctrlSetScale","ctrlSetStructuredText","ctrlSetText","ctrlSetTextColor","ctrlSetTooltip","ctrlSetTooltipColorBox","ctrlSetTooltipColorShade","ctrlSetTooltipColorText","ctrlShow","ctrlShown","ctrlText","ctrlTextHeight","ctrlType","ctrlVisible","curatorAddons","curatorCamera","curatorCameraArea","curatorCameraAreaCeiling","curatorCoef","curatorEditableObjects","curatorEditingArea","curatorEditingAreaType","curatorMouseOver","curatorPoints","curatorRegisteredObjects","curatorSelected","curatorWaypointCost","currentChannel","currentCommand","currentMagazine","currentMagazineDetail","currentMagazineDetailTurret","currentMagazineTurret","currentMuzzle","currentNamespace","currentTask","currentTasks","currentThrowable","currentVisionMode","currentWaypoint","currentWeapon","currentWeaponMode","currentWeaponTurret","currentZeroing","cursorTarget","customChat","customRadio","cutFadeOut","cutObj","cutRsc","cutText","damage","date","dateToNumber","daytime","deActivateKey","debriefingText","debugFSM","debugLog","default","deg","deleteAt","deleteCenter","deleteCollection","deleteEditorObject","deleteGroup","deleteIdentity","deleteLocation","deleteMarker","deleteMarkerLocal","deleteRange","deleteResources","deleteSite","deleteStatus","deleteTeam","deleteVehicle","deleteVehicleCrew","deleteWaypoint","detach","detectedMines","diag activeMissionFSMs","diag activeSQFScripts","diag activeSQSScripts","diag captureFrame","diag captureSlowFrame","diag fps","diag fpsMin","diag frameNo","diag log","diag logSlowFrame","diag tickTime","dialog","diarySubjectExists","didJIP","didJIPOwner","difficulty","difficultyEnabled","difficultyEnabledRTD","direction","directSay","disableAI","disableCollisionWith","disableConversation","disableDebriefingStats","disableSerialization","disableTIEquipment","disableUAVConnectability","disableUserInput","displayAddEventHandler","displayCtrl","displayNull","displayRemoveAllEventHandlers","displayRemoveEventHandler","displaySetEventHandler","dissolveTeam","distance","distance2D","distanceSqr","distributionRegion","do","doArtilleryFire","doFire","doFollow","doFSM","doGetOut","doMove","doorPhase","doStop","doTarget","doWatch","drawArrow","drawEllipse","drawIcon","drawIcon3D","drawLine","drawLine3D","drawLink","drawLocation","drawRectangle","driver","drop","east","echo","editObject","editorSetEventHandler","effectiveCommander","else","emptyPositions","enableAI","enableAIFeature","enableAttack","enableCamShake","enableCaustics","enableCollisionWith","enableCopilot","enableDebriefingStats","enableDiagLegend","enableEndDialog","enableEngineArtillery","enableEnvironment","enableFatigue","enableGunLights","enableIRLasers","enableMimics","enablePersonTurret","enableRadio","enableReload","enableRopeAttach","enableSatNormalOnDetail","enableSaving","enableSentences","enableSimulation","enableSimulationGlobal","enableTeamSwitch","enableUAVConnectability","enableUAVWaypoints","endLoadingScreen","endMission","engineOn","enginesIsOnRTD","enginesRpmRTD","enginesTorqueRTD","entities","estimatedEndServerTime","estimatedTimeLeft","evalObjectArgument","everyBackpack","everyContainer","exec","execEditorScript","execFSM","execVM","exit","exitWith","exp","expectedDestination","eyeDirection","eyePos","face","faction","fadeMusic","fadeRadio","fadeSound","fadeSpeech","failMission","false","fillWeaponsFromPool","find","findCover","findDisplay","findEditorObject","findEmptyPosition","findEmptyPositionReady","findNearestEnemy","finishMissionInit","finite","fire","fireAtTarget","firstBackpack","flag","flagOwner","fleeing","floor","flyInHeight","fog","fogForecast","fogParams","for","forceAddUniform","forceEnd","forceMap","forceRespawn","forceSpeed","forceWalk","forceWeaponFire","forceWeatherChange","forEach","forEachMember","forEachMemberAgent","forEachMemberTeam","format","formation","formationDirection","formationLeader","formationMembers","formationPosition","formationTask","formatText","formLeader","freeLook","from","fromEditor","fuel","fullCrew","gearSlotAmmoCount","gearSlotData","getAllHitPointsDamage","getAmmoCargo","getArray","getArtilleryAmmo","getArtilleryComputerSettings","getArtilleryETA","getAssignedCuratorLogic","getAssignedCuratorUnit","getBackpackCargo","getBleedingRemaining","getBurningValue","getCargoIndex","getCenterOfMass","getClientState","getConnectedUAV","getDammage","getDescription","getDir","getDirVisual","getDLCs","getEditorCamera","getEditorMode","getEditorObjectScope","getElevationOffset","getFatigue","getFriend","getFSMVariable","getFuelCargo","getGroupIcon","getGroupIconParams","getGroupIcons","getHideFrom","getHit","getHitIndex","getHitPointDamage","getItemCargo","getMagazineCargo","getMarkerColor","getMarkerPos","getMarkerSize","getMarkerType","getMass","getModelInfo","getNumber","getObjectArgument","getObjectChildren","getObjectDLC","getObjectMaterials","getObjectProxy","getObjectTextures","getObjectType","getObjectViewDistance","getOxygenRemaining","getPersonUsedDLCs","getPlayerChannel","getPlayerUID","getPos","getPosASL","getPosASLVisual","getPosASLW","getPosATL","getPosATLVisual","getPosVisual","getPosWorld","getRepairCargo","getResolution","getShadowDistance","getSlingLoad","getSpeed","getSuppression","getTerrainHeightASL","getText","getVariable","getWeaponCargo","getWPPos","glanceAt","globalChat","globalRadio","goggles","goto","group","groupChat","groupFromNetId","groupIconSelectable","groupIconsVisible","groupId","groupOwner","groupRadio","groupSelectedUnits","groupSelectUnit","grpNull","gunner","gusts","halt","handgunItems","handgunMagazine","handgunWeapon","handsHit","hasInterface","hasWeapon","hcAllGroups","hcGroupParams","hcLeader","hcRemoveAllGroups","hcRemoveGroup","hcSelected","hcSelectGroup","hcSetGroup","hcShowBar","hcShownBar","headgear","hideBody","hideObject","hideObjectGlobal","hint","hintC","hintCadet","hintSilent","hmd","hostMission","htmlLoad","HUDMovementLevels","humidity","if","image","importAllGroups","importance","in","incapacitatedState","independent","inflame","inflamed","inGameUISetEventHandler","inheritsFrom","initAmbientLife","inputAction","inRangeOfArtillery","insertEditorObject","intersect","isAbleToBreathe","isAgent","isArray","isAutoHoverOn","isAutonomous","isAutotest","isBleeding","isBurning","isClass","isCollisionLightOn","isCopilotEnabled","isDedicated","isDLCAvailable","isEngineOn","isEqualTo","isFlashlightOn","isFlatEmpty","isForcedWalk","isFormationLeader","isHidden","isInRemainsCollector","isInstructorFigureEnabled","isIRLaserOn","isKeyActive","isKindOf","isLightOn","isLocalized","isManualFire","isMarkedForCollection","isMultiplayer","isNil","isNull","isNumber","isObjectHidden","isObjectRTD","isOnRoad","isPipEnabled","isPlayer","isRealTime","isServer","isShowing3DIcons","isSteamMission","isStreamFriendlyUIEnabled","isText","isTouchingGround","isTurnedOut","isTutHintsEnabled","isUAVConnectable","isUAVConnected","isUniformAllowed","isWalking","isWeaponDeployed","isWeaponRested","itemCargo","items","itemsWithMagazines","join","joinAs","joinAsSilent","joinSilent","joinString","kbAddDatabase","kbAddDatabaseTargets","kbAddTopic","kbHasTopic","kbReact","kbRemoveTopic","kbTell","kbWasSaid","keyImage","keyName","knowsAbout","land","landAt","landResult","language","laserTarget","lbAdd","lbClear","lbColor","lbCurSel","lbData","lbDelete","lbIsSelected","lbPicture","lbSelection","lbSetColor","lbSetCurSel","lbSetData","lbSetPicture","lbSetPictureColor","lbSetPictureColorDisabled","lbSetPictureColorSelected","lbSetSelectColor","lbSetSelectColorRight","lbSetSelected","lbSetTooltip","lbSetValue","lbSize","lbSort","lbSortByValue","lbText","lbValue","leader","leaderboardDeInit","leaderboardGetRows","leaderboardInit","leaveVehicle","libraryCredits","libraryDisclaimers","lifeState","lightAttachObject","lightDetachObject","lightIsOn","lightnings","limitSpeed","linearConversion","lineBreak","lineIntersects","lineIntersectsObjs","lineIntersectsSurfaces","lineIntersectsWith","linkItem","list","listObjects","ln","lnbAddArray","lnbAddColumn","lnbAddRow","lnbClear","lnbColor","lnbCurSelRow","lnbData","lnbDeleteColumn","lnbDeleteRow","lnbGetColumnsPosition","lnbPicture","lnbSetColor","lnbSetColumnsPos","lnbSetCurSelRow","lnbSetData","lnbSetPicture","lnbSetText","lnbSetValue","lnbSize","lnbText","lnbValue","load","loadAbs","loadBackpack","loadFile","loadGame","loadIdentity","loadMagazine","loadOverlay","loadStatus","loadUniform","loadVest","local","localize","locationNull","locationPosition","lock","lockCameraTo","lockCargo","lockDriver","locked","lockedCargo","lockedDriver","lockedTurret","lockTurret","lockWP","log","logEntities","lookAt","lookAtPos","magazineCargo","magazines","magazinesAllTurrets","magazinesAmmo","magazinesAmmoCargo","magazinesAmmoFull","magazinesDetail","magazinesDetailBackpack","magazinesDetailUniform","magazinesDetailVest","magazinesTurret","magazineTurretAmmo","mapAnimAdd","mapAnimClear","mapAnimCommit","mapAnimDone","mapCenterOnCamera","mapGridPosition","markAsFinishedOnSteam","markerAlpha","markerBrush","markerColor","markerDir","markerPos","markerShape","markerSize","markerText","markerType","max","members","min","mineActive","mineDetectedBy","missionConfigFile","missionName","missionNamespace","missionStart","mod","modelToWorld","modelToWorldVisual","moonIntensity","morale","move","moveInAny","moveInCargo","moveInCommander","moveInDriver","moveInGunner","moveInTurret","moveObjectToEnd","moveOut","moveTime","moveTo","moveToCompleted","moveToFailed","musicVolume","name","name location","nameSound","nearEntities","nearestBuilding","nearestLocation","nearestLocations","nearestLocationWithDubbing","nearestObject","nearestObjects","nearObjects","nearObjectsReady","nearRoads","nearSupplies","nearTargets","needReload","netId","netObjNull","newOverlay","nextMenuItemIndex","nextWeatherChange","nil","nMenuItems","not","numberToDate","objectCurators","objectFromNetId","objectParent","objNull","objStatus","onBriefingGroup","onBriefingNotes","onBriefingPlan","onBriefingTeamSwitch","onCommandModeChanged","onDoubleClick","onEachFrame","onGroupIconClick","onGroupIconOverEnter","onGroupIconOverLeave","onHCGroupSelectionChanged","onMapSingleClick","onPlayerConnected","onPlayerDisconnected","onPreloadFinished","onPreloadStarted","onShowNewObject","onTeamSwitch","openCuratorInterface","openMap","openYoutubeVideo","opfor","or","orderGetIn","overcast","overcastForecast","owner","param","params","parseNumber","parseText","parsingNamespace","particlesQuality","pi","pickWeaponPool","pitch","playableSlotsNumber","playableUnits","playAction","playActionNow","player","playerRespawnTime","playerSide","playersNumber","playGesture","playMission","playMove","playMoveNow","playMusic","playScriptedMission","playSound","playSound3D","position","positionCameraToWorld","posScreenToWorld","posWorldToScreen","ppEffectAdjust","ppEffectCommit","ppEffectCommitted","ppEffectCreate","ppEffectDestroy","ppEffectEnable","ppEffectForceInNVG","precision","preloadCamera","preloadObject","preloadSound","preloadTitleObj","preloadTitleRsc","preprocessFile","preprocessFileLineNumbers","primaryWeapon","primaryWeaponItems","primaryWeaponMagazine","priority","private","processDiaryLink","productVersion","profileName","profileNamespace","profileNameSteam","progressLoadingScreen","progressPosition","progressSetPosition","publicVariable","publicVariableClient","publicVariableServer","pushBack","putWeaponPool","queryItemsPool","queryMagazinePool","queryWeaponPool","rad","radioChannelAdd","radioChannelCreate","radioChannelRemove","radioChannelSetCallSign","radioChannelSetLabel","radioVolume","rain","rainbow","random","rank","rankId","rating","rectangular","registeredTasks","registerTask","reload","reloadEnabled","remoteControl","remoteExec","remoteExecCall","removeAction","removeAllActions","removeAllAssignedItems","removeAllContainers","removeAllCuratorAddons","removeAllCuratorCameraAreas","removeAllCuratorEditingAreas","removeAllEventHandlers","removeAllHandgunItems","removeAllItems","removeAllItemsWithMagazines","removeAllMissionEventHandlers","removeAllMPEventHandlers","removeAllMusicEventHandlers","removeAllPrimaryWeaponItems","removeAllWeapons","removeBackpack","removeBackpackGlobal","removeCuratorAddons","removeCuratorCameraArea","removeCuratorEditableObjects","removeCuratorEditingArea","removeDrawIcon","removeDrawLinks","removeEventHandler","removeFromRemainsCollector","removeGoggles","removeGroupIcon","removeHandgunItem","removeHeadgear","removeItem","removeItemFromBackpack","removeItemFromUniform","removeItemFromVest","removeItems","removeMagazine","removeMagazineGlobal","removeMagazines","removeMagazinesTurret","removeMagazineTurret","removeMenuItem","removeMissionEventHandler","removeMPEventHandler","removeMusicEventHandler","removePrimaryWeaponItem","removeSecondaryWeaponItem","removeSimpleTask","removeSwitchableUnit","removeTeamMember","removeUniform","removeVest","removeWeapon","removeWeaponGlobal","removeWeaponTurret","requiredVersion","resetCamShake","resetSubgroupDirection","resistance","resize","resources","respawnVehicle","restartEditorCamera","reveal","revealMine","reverse","reversedMouseY","roadsConnectedTo","roleDescription","ropeAttachedObjects","ropeAttachedTo","ropeAttachEnabled","ropeAttachTo","ropeCreate","ropeCut","ropeEndPosition","ropeLength","ropes","ropeUnwind","ropeUnwound","rotorsForcesRTD","rotorsRpmRTD","round","runInitScript","safeZoneH","safeZoneW","safeZoneWAbs","safeZoneX","safeZoneXAbs","safeZoneY","saveGame","saveIdentity","saveJoysticks","saveOverlay","saveProfileNamespace","saveStatus","saveVar","savingEnabled","say","say2D","say3D","scopeName","score","scoreSide","screenToWorld","scriptDone","scriptName","scriptNull","scudState","secondaryWeapon","secondaryWeaponItems","secondaryWeaponMagazine","select","selectBestPlaces","selectDiarySubject","selectedEditorObjects","selectEditorObject","selectionPosition","selectLeader","selectNoPlayer","selectPlayer","selectWeapon","selectWeaponTurret","sendAUMessage","sendSimpleCommand","sendTask","sendTaskResult","sendUDPMessage","serverCommand","serverCommandAvailable","serverCommandExecutable","serverName","serverTime","set","setAccTime","setAirportSide","setAmmo","setAmmoCargo","setAperture","setApertureNew","setArmoryPoints","setAttributes","setAutonomous","setBehaviour","setBleedingRemaining","setCameraInterest","setCamShakeDefParams","setCamShakeParams","setCamUseTi","setCaptive","setCenterOfMass","setCollisionLight","setCombatMode","setCompassOscillation","setCuratorCameraAreaCeiling","setCuratorCoef","setCuratorEditingAreaType","setCuratorWaypointCost","setCurrentChannel","setCurrentTask","setCurrentWaypoint","setDamage","setDammage","setDate","setDebriefingText","setDefaultCamera","setDestination","setDetailMapBlendPars","setDir","setDirection","setDrawIcon","setDropInterval","setEditorMode","setEditorObjectScope","setEffectCondition","setFace","setFaceAnimation","setFatigue","setFlagOwner","setFlagSide","setFlagTexture","setFog","setFog array","setFormation","setFormationTask","setFormDir","setFriend","setFromEditor","setFSMVariable","setFuel","setFuelCargo","setGroupIcon","setGroupIconParams","setGroupIconsSelectable","setGroupIconsVisible","setGroupId","setGroupIdGlobal","setGroupOwner","setGusts","setHideBehind","setHit","setHitIndex","setHitPointDamage","setHorizonParallaxCoef","setHUDMovementLevels","setIdentity","setImportance","setLeader","setLightAmbient","setLightAttenuation","setLightBrightness","setLightColor","setLightDayLight","setLightFlareMaxDistance","setLightFlareSize","setLightIntensity","setLightnings","setLightUseFlare","setLocalWindParams","setMagazineTurretAmmo","setMarkerAlpha","setMarkerAlphaLocal","setMarkerBrush","setMarkerBrushLocal","setMarkerColor","setMarkerColorLocal","setMarkerDir","setMarkerDirLocal","setMarkerPos","setMarkerPosLocal","setMarkerShape","setMarkerShapeLocal","setMarkerSize","setMarkerSizeLocal","setMarkerText","setMarkerTextLocal","setMarkerType","setMarkerTypeLocal","setMass","setMimic","setMousePosition","setMusicEffect","setMusicEventHandler","setName","setNameSound","setObjectArguments","setObjectMaterial","setObjectProxy","setObjectTexture","setObjectTextureGlobal","setObjectViewDistance","setOvercast","setOwner","setOxygenRemaining","setParticleCircle","setParticleClass","setParticleFire","setParticleParams","setParticleRandom","setPilotLight","setPiPEffect","setPitch","setPlayable","setPlayerRespawnTime","setPos","setPosASL","setPosASL2","setPosASLW","setPosATL","setPosition","setPosWorld","setRadioMsg","setRain","setRainbow","setRandomLip","setRank","setRectangular","setRepairCargo","setShadowDistance","setSide","setSimpleTaskDescription","setSimpleTaskDestination","setSimpleTaskTarget","setSimulWeatherLayers","setSize","setSkill","setSkill array","setSlingLoad","setSoundEffect","setSpeaker","setSpeech","setSpeedMode","setStatValue","setSuppression","setSystemOfUnits","setTargetAge","setTaskResult","setTaskState","setTerrainGrid","setText","setTimeMultiplier","setTitleEffect","setTriggerActivation","setTriggerArea","setTriggerStatements","setTriggerText","setTriggerTimeout","setTriggerType","setType","setUnconscious","setUnitAbility","setUnitPos","setUnitPosWeak","setUnitRank","setUnitRecoilCoefficient","setUnloadInCombat","setUserActionText","setVariable","setVectorDir","setVectorDirAndUp","setVectorUp","setVehicleAmmo","setVehicleAmmoDef","setVehicleArmor","setVehicleId","setVehicleLock","setVehiclePosition","setVehicleTiPars","setVehicleVarName","setVelocity","setVelocityTransformation","setViewDistance","setVisibleIfTreeCollapsed","setWaves","setWaypointBehaviour","setWaypointCombatMode","setWaypointCompletionRadius","setWaypointDescription","setWaypointFormation","setWaypointHousePosition","setWaypointLoiterRadius","setWaypointLoiterType","setWaypointName","setWaypointPosition","setWaypointScript","setWaypointSpeed","setWaypointStatements","setWaypointTimeout","setWaypointType","setWaypointVisible","setWeaponReloadingTime","setWind","setWindDir","setWindForce","setWindStr","setWPPos","show3DIcons","showChat","showCinemaBorder","showCommandingMenu","showCompass","showCuratorCompass","showGPS","showHUD","showLegend","showMap","shownArtilleryComputer","shownChat","shownCompass","shownCuratorCompass","showNewEditorObject","shownGPS","shownHUD","shownMap","shownPad","shownRadio","shownUAVFeed","shownWarrant","shownWatch","showPad","showRadio","showSubtitles","showUAVFeed","showWarrant","showWatch","showWaypoint","side","sideChat","sideEnemy","sideFriendly","sideLogic","sideRadio","sideUnknown","simpleTasks","simulationEnabled","simulCloudDensity","simulCloudOcclusion","simulInClouds","simulWeatherSync","sin","size","sizeOf","skill","skillFinal","skipTime","sleep","sliderPosition","sliderRange","sliderSetPosition","sliderSetRange","sliderSetSpeed","sliderSpeed","slingLoadAssistantShown","soldierMagazines","someAmmo","sort","soundVolume","spawn","speaker","speed","speedMode","splitString","sqrt","squadParams","stance","startLoadingScreen","step","stop","stopped","str","sunOrMoon","supportInfo","suppressFor","surfaceIsWater","surfaceNormal","surfaceType","swimInDepth","switch","switchableUnits","switchAction","switchCamera","switchGesture","switchLight","switchMove","synchronizedObjects","synchronizedTriggers","synchronizedWaypoints","synchronizeObjectsAdd","synchronizeObjectsRemove","synchronizeTrigger","synchronizeWaypoint","synchronizeWaypoint trigger","systemChat","systemOfUnits","tan","targetKnowledge","targetsAggregate","targetsQuery","taskChildren","taskCompleted","taskDescription","taskDestination","taskHint","taskNull","taskParent","taskResult","taskState","teamMember","teamMemberNull","teamName","teams","teamSwitch","teamSwitchEnabled","teamType","terminate","terrainIntersect","terrainIntersectASL","text","text location","textLog","textLogFormat","tg","then","throw","time","timeMultiplier","titleCut","titleFadeOut","titleObj","titleRsc","titleText","to","toArray","toLower","toString","toUpper","triggerActivated","triggerActivation","triggerArea","triggerAttachedVehicle","triggerAttachObject","triggerAttachVehicle","triggerStatements","triggerText","triggerTimeout","triggerTimeoutCurrent","triggerType","true","try","turretLocal","turretOwner","turretUnit","tvAdd","tvClear","tvCollapse","tvCount","tvCurSel","tvData","tvDelete","tvExpand","tvPicture","tvSetCurSel","tvSetData","tvSetPicture","tvSetPictureColor","tvSetTooltip","tvSetValue","tvSort","tvSortByValue","tvText","tvValue","type","typeName","typeOf","UAVControl","uiNamespace","uiSleep","unassignCurator","unassignItem","unassignTeam","unassignVehicle","underwater","uniform","uniformContainer","uniformItems","uniformMagazines","unitAddons","unitBackpack","unitPos","unitReady","unitRecoilCoefficient","units","unitsBelowHeight","unlinkItem","unlockAchievement","unregisterTask","updateDrawIcon","updateMenuItem","updateObjectTree","useAudioTimeForMoves","vectorAdd","vectorCos","vectorCrossProduct","vectorDiff","vectorDir","vectorDirVisual","vectorDistance","vectorDistanceSqr","vectorDotProduct","vectorFromTo","vectorMagnitude","vectorMagnitudeSqr","vectorMultiply","vectorNormalized","vectorUp","vectorUpVisual","vehicle","vehicleChat","vehicleRadio","vehicles","vehicleVarName","velocity","velocityModelSpace","verifySignature","vest","vestContainer","vestItems","vestMagazines","viewDistance","visibleCompass","visibleGPS","visibleMap","visiblePosition","visiblePositionASL","visibleWatch","waitUntil","waves","waypointAttachedObject","waypointAttachedVehicle","waypointAttachObject","waypointAttachVehicle","waypointBehaviour","waypointCombatMode","waypointCompletionRadius","waypointDescription","waypointFormation","waypointHousePosition","waypointLoiterRadius","waypointLoiterType","waypointName","waypointPosition","waypoints","waypointScript","waypointsEnabledUAV","waypointShow","waypointSpeed","waypointStatements","waypointTimeout","waypointTimeoutCurrent","waypointType","waypointVisible","weaponAccessories","weaponCargo","weaponDirection","weaponLowered","weapons","weaponsItems","weaponsItemsCargo","weaponState","weaponsTurret","weightRTD","west","WFSideText","while","wind","windDir","windStr","wingsForcesRTD","with","worldName","worldSize","worldToModel","worldToModelVisual","worldToScreen"],control=["case","catch","default","do","else","exit","exitWith|5","for","forEach","from","if","switch","then","throw","to","try","while","with"],operators=["!","-","+","!=","%","&&","*","/","=","==",">",">=","<","<=","^",":",">>"],specials=["_forEachIndex|10","_this|10","_x|10"],literals=["true","false","nil"],builtins=allCommands.filter(function(command){
return-1==control.indexOf(command)&&-1==literals.indexOf(command)&&-1==operators.indexOf(command)});builtins=builtins.concat(specials);var STRINGS={className:"string",relevance:0,variants:[{begin:'"',end:'"',contains:[{begin:'""'}]},{begin:"'",end:"'",contains:[{begin:"''"}]}]},NUMBERS={className:"number",begin:hljs.NUMBER_RE,relevance:0},PREPROCESSOR_STRINGS={className:"string",variants:[hljs.QUOTE_STRING_MODE,{begin:"'\\\\?.",end:"'",illegal:"."}]},PREPROCESSOR={className:"preprocessor",begin:"#",end:"$",keywords:"if else elif endif define undef warning error line pragma ifdef ifndef",contains:[{begin:/\\\n/,relevance:0},{beginKeywords:"include",end:"$",contains:[PREPROCESSOR_STRINGS,{className:"string",begin:"<",end:">",illegal:"\\n"}]},PREPROCESSOR_STRINGS,NUMBERS,hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE]};return{aliases:["sqf"],case_insensitive:!0,keywords:{keyword:control.join(" "),built_in:builtins.join(" "),literal:literals.join(" ")},contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,NUMBERS,STRINGS,PREPROCESSOR]}}),hljs.registerLanguage("sql",function(hljs){var COMMENT_MODE=hljs.COMMENT("--","$");return{case_insensitive:!0,illegal:/[<>{}*]/,contains:[{className:"operator",beginKeywords:"begin end start commit rollback savepoint lock alter create drop rename call delete do handler insert load replace select truncate update set show pragma grant merge describe use explain help declare prepare execute deallocate release unlock purge reset change stop analyze cache flush optimize repair kill install uninstall checksum restore check backup revoke",end:/;/,endsWithParent:!0,keywords:{keyword:"abort abs absolute acc acce accep accept access accessed accessible account acos action activate add addtime admin administer advanced advise aes_decrypt aes_encrypt after agent aggregate ali alia alias allocate allow alter always analyze ancillary and any anydata anydataset anyschema anytype apply archive archived archivelog are as asc ascii asin assembly assertion associate asynchronous at atan atn2 attr attri attrib attribu attribut attribute attributes audit authenticated authentication authid authors auto autoallocate autodblink autoextend automatic availability avg backup badfile basicfile before begin beginning benchmark between bfile bfile_base big bigfile bin binary_double binary_float binlog bit_and bit_count bit_length bit_or bit_xor bitmap blob_base block blocksize body both bound buffer_cache buffer_pool build bulk by byte byteordermark bytes c cache caching call calling cancel capacity cascade cascaded case cast catalog category ceil ceiling chain change changed char_base char_length character_length characters characterset charindex charset charsetform charsetid check checksum checksum_agg child choose chr chunk class cleanup clear client clob clob_base clone close cluster_id cluster_probability cluster_set clustering coalesce coercibility col collate collation collect colu colum column column_value columns columns_updated comment commit compact compatibility compiled complete composite_limit compound compress compute concat concat_ws concurrent confirm conn connec connect connect_by_iscycle connect_by_isleaf connect_by_root connect_time connection consider consistent constant constraint constraints constructor container content contents context contributors controlfile conv convert convert_tz corr corr_k corr_s corresponding corruption cos cost count count_big counted covar_pop covar_samp cpu_per_call cpu_per_session crc32 create creation critical cross cube cume_dist curdate current current_date current_time current_timestamp current_user cursor curtime customdatum cycle d data database databases datafile datafiles datalength date_add date_cache date_format date_sub dateadd datediff datefromparts datename datepart datetime2fromparts day day_to_second dayname dayofmonth dayofweek dayofyear days db_role_change dbtimezone ddl deallocate declare decode decompose decrement decrypt deduplicate def defa defau defaul default defaults deferred defi defin define degrees delayed delegate delete delete_all delimited demand dense_rank depth dequeue des_decrypt des_encrypt des_key_file desc descr descri describ describe descriptor deterministic diagnostics difference dimension direct_load directory disable disable_all disallow disassociate discardfile disconnect diskgroup distinct distinctrow distribute distributed div do document domain dotnet double downgrade drop dumpfile duplicate duration e each edition editionable editions element ellipsis else elsif elt empty enable enable_all enclosed encode encoding encrypt end end-exec endian enforced engine engines enqueue enterprise entityescaping eomonth error errors escaped evalname evaluate event eventdata events except exception exceptions exchange exclude excluding execu execut execute exempt exists exit exp expire explain export export_set extended extent external external_1 external_2 externally extract f failed failed_login_attempts failover failure far fast feature_set feature_value fetch field fields file file_name_convert filesystem_like_logging final finish first first_value fixed flash_cache flashback floor flush following follows for forall force form forma format found found_rows freelist freelists freepools fresh from from_base64 from_days ftp full function g general generated get get_format get_lock getdate getutcdate global global_name globally go goto grant grants greatest group group_concat group_id grouping grouping_id groups gtid_subtract guarantee guard handler hash hashkeys having hea head headi headin heading heap help hex hierarchy high high_priority hosts hour http i id ident_current ident_incr ident_seed identified identity idle_time if ifnull ignore iif ilike ilm immediate import in include including increment index indexes indexing indextype indicator indices inet6_aton inet6_ntoa inet_aton inet_ntoa infile initial initialized initially initrans inmemory inner innodb input insert install instance instantiable instr interface interleaved intersect into invalidate invisible is is_free_lock is_ipv4 is_ipv4_compat is_not is_not_null is_used_lock isdate isnull isolation iterate java join json json_exists k keep keep_duplicates key keys kill l language large last last_day last_insert_id last_value lax lcase lead leading least leaves left len lenght length less level levels library like like2 like4 likec limit lines link list listagg little ln load load_file lob lobs local localtime localtimestamp locate locator lock locked log log10 log2 logfile logfiles logging logical logical_reads_per_call logoff logon logs long loop low low_priority lower lpad lrtrim ltrim m main make_set makedate maketime managed management manual map mapping mask master master_pos_wait match matched materialized max maxextents maximize maxinstances maxlen maxlogfiles maxloghistory maxlogmembers maxsize maxtrans md5 measures median medium member memcompress memory merge microsecond mid migration min minextents minimum mining minus minute minvalue missing mod mode model modification modify module monitoring month months mount move movement multiset mutex n name name_const names nan national native natural nav nchar nclob nested never new newline next nextval no no_write_to_binlog noarchivelog noaudit nobadfile nocheck nocompress nocopy nocycle nodelay nodiscardfile noentityescaping noguarantee nokeep nologfile nomapping nomaxvalue nominimize nominvalue nomonitoring none noneditionable nonschema noorder nopr nopro noprom nopromp noprompt norely noresetlogs noreverse normal norowdependencies noschemacheck noswitch not nothing notice notrim novalidate now nowait nth_value nullif nulls num numb numbe nvarchar nvarchar2 object ocicoll ocidate ocidatetime ociduration ociinterval ociloblocator ocinumber ociref ocirefcursor ocirowid ocistring ocitype oct octet_length of off offline offset oid oidindex old on online only opaque open operations operator optimal optimize option optionally or oracle oracle_date oradata ord ordaudio orddicom orddoc order ordimage ordinality ordvideo organization orlany orlvary out outer outfile outline output over overflow overriding p package pad parallel parallel_enable parameters parent parse partial partition partitions pascal passing password password_grace_time password_lock_time password_reuse_max password_reuse_time password_verify_function patch path patindex pctincrease pctthreshold pctused pctversion percent percent_rank percentile_cont percentile_disc performance period period_add period_diff permanent physical pi pipe pipelined pivot pluggable plugin policy position post_transaction pow power pragma prebuilt precedes preceding precision prediction prediction_cost prediction_details prediction_probability prediction_set prepare present preserve prior priority private private_sga privileges procedural procedure procedure_analyze processlist profiles project prompt protection public publishingservername purge quarter query quick quiesce quota quotename radians raise rand range rank raw read reads readsize rebuild record records recover recovery recursive recycle redo reduced ref reference referenced references referencing refresh regexp_like register regr_avgx regr_avgy regr_count regr_intercept regr_r2 regr_slope regr_sxx regr_sxy reject rekey relational relative relaylog release release_lock relies_on relocate rely rem remainder rename repair repeat replace replicate replication required reset resetlogs resize resource respect restore restricted result result_cache resumable resume retention return returning returns reuse reverse revoke right rlike role roles rollback rolling rollup round row row_count rowdependencies rowid rownum rows rtrim rules safe salt sample save savepoint sb1 sb2 sb4 scan schema schemacheck scn scope scroll sdo_georaster sdo_topo_geometry search sec_to_time second section securefile security seed segment select self sequence sequential serializable server servererror session session_user sessions_per_user set sets settings sha sha1 sha2 share shared shared_pool short show shrink shutdown si_averagecolor si_colorhistogram si_featurelist si_positionalcolor si_stillimage si_texture siblings sid sign sin size size_t sizes skip slave sleep smalldatetimefromparts smallfile snapshot some soname sort soundex source space sparse spfile split sql sql_big_result sql_buffer_result sql_cache sql_calc_found_rows sql_small_result sql_variant_property sqlcode sqldata sqlerror sqlname sqlstate sqrt square standalone standby start starting startup statement static statistics stats_binomial_test stats_crosstab stats_ks_test stats_mode stats_mw_test stats_one_way_anova stats_t_test_ stats_t_test_indep stats_t_test_one stats_t_test_paired stats_wsr_test status std stddev stddev_pop stddev_samp stdev stop storage store stored str str_to_date straight_join strcmp strict string struct stuff style subdate subpartition subpartitions substitutable substr substring subtime subtring_index subtype success sum suspend switch switchoffset switchover sync synchronous synonym sys sys_xmlagg sysasm sysaux sysdate sysdatetimeoffset sysdba sysoper system system_user sysutcdatetime t table tables tablespace tan tdo template temporary terminated tertiary_weights test than then thread through tier ties time time_format time_zone timediff timefromparts timeout timestamp timestampadd timestampdiff timezone_abbr timezone_minute timezone_region to to_base64 to_date to_days to_seconds todatetimeoffset trace tracking transaction transactional translate translation treat trigger trigger_nestlevel triggers trim truncate try_cast try_convert try_parse type ub1 ub2 ub4 ucase unarchived unbounded uncompress under undo unhex unicode uniform uninstall union unique unix_timestamp unknown unlimited unlock unpivot unrecoverable unsafe unsigned until untrusted unusable unused update updated upgrade upped upper upsert url urowid usable usage use use_stored_outlines user user_data user_resources users using utc_date utc_timestamp uuid uuid_short validate validate_password_strength validation valist value values var var_samp varcharc vari varia variab variabl variable variables variance varp varraw varrawc varray verify version versions view virtual visible void wait wallet warning warnings week weekday weekofyear wellformed when whene whenev wheneve whenever where while whitespace with within without work wrapped xdb xml xmlagg xmlattributes xmlcast xmlcolattval xmlelement xmlexists xmlforest xmlindex xmlnamespaces xmlpi xmlquery xmlroot xmlschema xmlserialize xmltable xmltype xor year year_to_month years yearweek",literal:"true false null",built_in:"array bigint binary bit blob boolean char character date dec decimal float int int8 integer interval number numeric real record serial serial8 smallint text varchar varying void"},contains:[{className:"string",begin:"'",end:"'",contains:[hljs.BACKSLASH_ESCAPE,{begin:"''"}]},{className:"string",begin:'"',end:'"',contains:[hljs.BACKSLASH_ESCAPE,{begin:'""'}]},{className:"string",begin:"`",end:"`",contains:[hljs.BACKSLASH_ESCAPE]},hljs.C_NUMBER_MODE,hljs.C_BLOCK_COMMENT_MODE,COMMENT_MODE]},hljs.C_BLOCK_COMMENT_MODE,COMMENT_MODE]}}),hljs.registerLanguage("stata",function(hljs){return{aliases:["do","ado"],case_insensitive:!0,keywords:"if else in foreach for forv forva forval forvalu forvalue forvalues by bys bysort xi quietly qui capture about ac ac_7 acprplot acprplot_7 adjust ado adopath adoupdate alpha ameans an ano anov anova anova_estat anova_terms anovadef aorder ap app appe appen append arch arch_dr arch_estat arch_p archlm areg areg_p args arima arima_dr arima_estat arima_p as asmprobit asmprobit_estat asmprobit_lf asmprobit_mfx__dlg asmprobit_p ass asse asser assert avplot avplot_7 avplots avplots_7 bcskew0 bgodfrey binreg bip0_lf biplot bipp_lf bipr_lf bipr_p biprobit bitest bitesti bitowt blogit bmemsize boot bootsamp bootstrap bootstrap_8 boxco_l boxco_p boxcox boxcox_6 boxcox_p bprobit br break brier bro brow brows browse brr brrstat bs bs_7 bsampl_w bsample bsample_7 bsqreg bstat bstat_7 bstat_8 bstrap bstrap_7 ca ca_estat ca_p cabiplot camat canon canon_8 canon_8_p canon_estat canon_p cap caprojection capt captu captur capture cat cc cchart cchart_7 cci cd censobs_table centile cf char chdir checkdlgfiles checkestimationsample checkhlpfiles checksum chelp ci cii cl class classutil clear cli clis clist clo clog clog_lf clog_p clogi clogi_sw clogit clogit_lf clogit_p clogitp clogl_sw cloglog clonevar clslistarray cluster cluster_measures cluster_stop cluster_tree cluster_tree_8 clustermat cmdlog cnr cnre cnreg cnreg_p cnreg_sw cnsreg codebook collaps4 collapse colormult_nb colormult_nw compare compress conf confi confir confirm conren cons const constr constra constrai constrain constraint continue contract copy copyright copysource cor corc corr corr2data corr_anti corr_kmo corr_smc corre correl correla correlat correlate corrgram cou coun count cox cox_p cox_sw coxbase coxhaz coxvar cprplot cprplot_7 crc cret cretu cretur creturn cross cs cscript cscript_log csi ct ct_is ctset ctst_5 ctst_st cttost cumsp cumsp_7 cumul cusum cusum_7 cutil d datasig datasign datasigna datasignat datasignatu datasignatur datasignature datetof db dbeta de dec deco decod decode deff des desc descr descri describ describe destring dfbeta dfgls dfuller di di_g dir dirstats dis discard disp disp_res disp_s displ displa display distinct do doe doed doedi doedit dotplot dotplot_7 dprobit drawnorm drop ds ds_util dstdize duplicates durbina dwstat dydx e ed edi edit egen eivreg emdef en enc enco encod encode eq erase ereg ereg_lf ereg_p ereg_sw ereghet ereghet_glf ereghet_glf_sh ereghet_gp ereghet_ilf ereghet_ilf_sh ereghet_ip eret eretu eretur ereturn err erro error est est_cfexist est_cfname est_clickable est_expand est_hold est_table est_unhold est_unholdok estat estat_default estat_summ estat_vce_only esti estimates etodow etof etomdy ex exi exit expand expandcl fac fact facto factor factor_estat factor_p factor_pca_rotated factor_rotate factormat fcast fcast_compute fcast_graph fdades fdadesc fdadescr fdadescri fdadescrib fdadescribe fdasav fdasave fdause fh_st file open file read file close file filefilter fillin find_hlp_file findfile findit findit_7 fit fl fli flis flist for5_0 form forma format fpredict frac_154 frac_adj frac_chk frac_cox frac_ddp frac_dis frac_dv frac_in frac_mun frac_pp frac_pq frac_pv frac_wgt frac_xo fracgen fracplot fracplot_7 fracpoly fracpred fron_ex fron_hn fron_p fron_tn fron_tn2 frontier ftodate ftoe ftomdy ftowdate g gamhet_glf gamhet_gp gamhet_ilf gamhet_ip gamma gamma_d2 gamma_p gamma_sw gammahet gdi_hexagon gdi_spokes ge gen gene gener genera generat generate genrank genstd genvmean gettoken gl gladder gladder_7 glim_l01 glim_l02 glim_l03 glim_l04 glim_l05 glim_l06 glim_l07 glim_l08 glim_l09 glim_l10 glim_l11 glim_l12 glim_lf glim_mu glim_nw1 glim_nw2 glim_nw3 glim_p glim_v1 glim_v2 glim_v3 glim_v4 glim_v5 glim_v6 glim_v7 glm glm_6 glm_p glm_sw glmpred glo glob globa global glogit glogit_8 glogit_p gmeans gnbre_lf gnbreg gnbreg_5 gnbreg_p gomp_lf gompe_sw gomper_p gompertz gompertzhet gomphet_glf gomphet_glf_sh gomphet_gp gomphet_ilf gomphet_ilf_sh gomphet_ip gphdot gphpen gphprint gprefs gprobi_p gprobit gprobit_8 gr gr7 gr_copy gr_current gr_db gr_describe gr_dir gr_draw gr_draw_replay gr_drop gr_edit gr_editviewopts gr_example gr_example2 gr_export gr_print gr_qscheme gr_query gr_read gr_rename gr_replay gr_save gr_set gr_setscheme gr_table gr_undo gr_use graph graph7 grebar greigen greigen_7 greigen_8 grmeanby grmeanby_7 gs_fileinfo gs_filetype gs_graphinfo gs_stat gsort gwood h hadimvo hareg hausman haver he heck_d2 heckma_p heckman heckp_lf heckpr_p heckprob hel help hereg hetpr_lf hetpr_p hetprob hettest hexdump hilite hist hist_7 histogram hlogit hlu hmeans hotel hotelling hprobit hreg hsearch icd9 icd9_ff icd9p iis impute imtest inbase include inf infi infil infile infix inp inpu input ins insheet insp inspe inspec inspect integ inten intreg intreg_7 intreg_p intrg2_ll intrg_ll intrg_ll2 ipolate iqreg ir irf irf_create irfm iri is_svy is_svysum isid istdize ivprob_1_lf ivprob_lf ivprobit ivprobit_p ivreg ivreg_footnote ivtob_1_lf ivtob_lf ivtobit ivtobit_p jackknife jacknife jknife jknife_6 jknife_8 jkstat joinby kalarma1 kap kap_3 kapmeier kappa kapwgt kdensity kdensity_7 keep ksm ksmirnov ktau kwallis l la lab labe label labelbook ladder levels levelsof leverage lfit lfit_p li lincom line linktest lis list lloghet_glf lloghet_glf_sh lloghet_gp lloghet_ilf lloghet_ilf_sh lloghet_ip llogi_sw llogis_p llogist llogistic llogistichet lnorm_lf lnorm_sw lnorma_p lnormal lnormalhet lnormhet_glf lnormhet_glf_sh lnormhet_gp lnormhet_ilf lnormhet_ilf_sh lnormhet_ip lnskew0 loadingplot loc loca local log logi logis_lf logistic logistic_p logit logit_estat logit_p loglogs logrank loneway lookfor lookup lowess lowess_7 lpredict lrecomp lroc lroc_7 lrtest ls lsens lsens_7 lsens_x lstat ltable ltable_7 ltriang lv lvr2plot lvr2plot_7 m ma mac macr macro makecns man manova manova_estat manova_p manovatest mantel mark markin markout marksample mat mat_capp mat_order mat_put_rr mat_rapp mata mata_clear mata_describe mata_drop mata_matdescribe mata_matsave mata_matuse mata_memory mata_mlib mata_mosave mata_rename mata_which matalabel matcproc matlist matname matr matri matrix matrix_input__dlg matstrik mcc mcci md0_ md1_ md1debug_ md2_ md2debug_ mds mds_estat mds_p mdsconfig mdslong mdsmat mdsshepard mdytoe mdytof me_derd mean means median memory memsize meqparse mer merg merge mfp mfx mhelp mhodds minbound mixed_ll mixed_ll_reparm mkassert mkdir mkmat mkspline ml ml_5 ml_adjs ml_bhhhs ml_c_d ml_check ml_clear ml_cnt ml_debug ml_defd ml_e0 ml_e0_bfgs ml_e0_cycle ml_e0_dfp ml_e0i ml_e1 ml_e1_bfgs ml_e1_bhhh ml_e1_cycle ml_e1_dfp ml_e2 ml_e2_cycle ml_ebfg0 ml_ebfr0 ml_ebfr1 ml_ebh0q ml_ebhh0 ml_ebhr0 ml_ebr0i ml_ecr0i ml_edfp0 ml_edfr0 ml_edfr1 ml_edr0i ml_eds ml_eer0i ml_egr0i ml_elf ml_elf_bfgs ml_elf_bhhh ml_elf_cycle ml_elf_dfp ml_elfi ml_elfs ml_enr0i ml_enrr0 ml_erdu0 ml_erdu0_bfgs ml_erdu0_bhhh ml_erdu0_bhhhq ml_erdu0_cycle ml_erdu0_dfp ml_erdu0_nrbfgs ml_exde ml_footnote ml_geqnr ml_grad0 ml_graph ml_hbhhh ml_hd0 ml_hold ml_init ml_inv ml_log ml_max ml_mlout ml_mlout_8 ml_model ml_nb0 ml_opt ml_p ml_plot ml_query ml_rdgrd ml_repor ml_s_e ml_score ml_searc ml_technique ml_unhold mleval mlf_ mlmatbysum mlmatsum mlog mlogi mlogit mlogit_footnote mlogit_p mlopts mlsum mlvecsum mnl0_ mor more mov move mprobit mprobit_lf mprobit_p mrdu0_ mrdu1_ mvdecode mvencode mvreg mvreg_estat n nbreg nbreg_al nbreg_lf nbreg_p nbreg_sw nestreg net newey newey_7 newey_p news nl nl_7 nl_9 nl_9_p nl_p nl_p_7 nlcom nlcom_p nlexp2 nlexp2_7 nlexp2a nlexp2a_7 nlexp3 nlexp3_7 nlgom3 nlgom3_7 nlgom4 nlgom4_7 nlinit nllog3 nllog3_7 nllog4 nllog4_7 nlog_rd nlogit nlogit_p nlogitgen nlogittree nlpred no nobreak noi nois noisi noisil noisily note notes notes_dlg nptrend numlabel numlist odbc old_ver olo olog ologi ologi_sw ologit ologit_p ologitp on one onew onewa oneway op_colnm op_comp op_diff op_inv op_str opr opro oprob oprob_sw oprobi oprobi_p oprobit oprobitp opts_exclusive order orthog orthpoly ou out outf outfi outfil outfile outs outsh outshe outshee outsheet ovtest pac pac_7 palette parse parse_dissim pause pca pca_8 pca_display pca_estat pca_p pca_rotate pcamat pchart pchart_7 pchi pchi_7 pcorr pctile pentium pergram pergram_7 permute permute_8 personal peto_st pkcollapse pkcross pkequiv pkexamine pkexamine_7 pkshape pksumm pksumm_7 pl plo plot plugin pnorm pnorm_7 poisgof poiss_lf poiss_sw poisso_p poisson poisson_estat post postclose postfile postutil pperron pr prais prais_e prais_e2 prais_p predict predictnl preserve print pro prob probi probit probit_estat probit_p proc_time procoverlay procrustes procrustes_estat procrustes_p profiler prog progr progra program prop proportion prtest prtesti pwcorr pwd q\\s qby qbys qchi qchi_7 qladder qladder_7 qnorm qnorm_7 qqplot qqplot_7 qreg qreg_c qreg_p qreg_sw qu quadchk quantile quantile_7 que quer query range ranksum ratio rchart rchart_7 rcof recast reclink recode reg reg3 reg3_p regdw regr regre regre_p2 regres regres_p regress regress_estat regriv_p remap ren rena renam rename renpfix repeat replace report reshape restore ret retu retur return rm rmdir robvar roccomp roccomp_7 roccomp_8 rocf_lf rocfit rocfit_8 rocgold rocplot rocplot_7 roctab roctab_7 rolling rologit rologit_p rot rota rotat rotate rotatemat rreg rreg_p ru run runtest rvfplot rvfplot_7 rvpplot rvpplot_7 sa safesum sample sampsi sav save savedresults saveold sc sca scal scala scalar scatter scm_mine sco scob_lf scob_p scobi_sw scobit scor score scoreplot scoreplot_help scree screeplot screeplot_help sdtest sdtesti se search separate seperate serrbar serrbar_7 serset set set_defaults sfrancia sh she shel shell shewhart shewhart_7 signestimationsample signrank signtest simul simul_7 simulate simulate_8 sktest sleep slogit slogit_d2 slogit_p smooth snapspan so sor sort spearman spikeplot spikeplot_7 spikeplt spline_x split sqreg sqreg_p sret sretu sretur sreturn ssc st st_ct st_hc st_hcd st_hcd_sh st_is st_issys st_note st_promo st_set st_show st_smpl st_subid stack statsby statsby_8 stbase stci stci_7 stcox stcox_estat stcox_fr stcox_fr_ll stcox_p stcox_sw stcoxkm stcoxkm_7 stcstat stcurv stcurve stcurve_7 stdes stem stepwise stereg stfill stgen stir stjoin stmc stmh stphplot stphplot_7 stphtest stphtest_7 stptime strate strate_7 streg streg_sw streset sts sts_7 stset stsplit stsum sttocc sttoct stvary stweib su suest suest_8 sum summ summa summar summari summariz summarize sunflower sureg survcurv survsum svar svar_p svmat svy svy_disp svy_dreg svy_est svy_est_7 svy_estat svy_get svy_gnbreg_p svy_head svy_header svy_heckman_p svy_heckprob_p svy_intreg_p svy_ivreg_p svy_logistic_p svy_logit_p svy_mlogit_p svy_nbreg_p svy_ologit_p svy_oprobit_p svy_poisson_p svy_probit_p svy_regress_p svy_sub svy_sub_7 svy_x svy_x_7 svy_x_p svydes svydes_8 svygen svygnbreg svyheckman svyheckprob svyintreg svyintreg_7 svyintrg svyivreg svylc svylog_p svylogit svymarkout svymarkout_8 svymean svymlog svymlogit svynbreg svyolog svyologit svyoprob svyoprobit svyopts svypois svypois_7 svypoisson svyprobit svyprobt svyprop svyprop_7 svyratio svyreg svyreg_p svyregress svyset svyset_7 svyset_8 svytab svytab_7 svytest svytotal sw sw_8 swcnreg swcox swereg swilk swlogis swlogit swologit swoprbt swpois swprobit swqreg swtobit swweib symmetry symmi symplot symplot_7 syntax sysdescribe sysdir sysuse szroeter ta tab tab1 tab2 tab_or tabd tabdi tabdis tabdisp tabi table tabodds tabodds_7 tabstat tabu tabul tabula tabulat tabulate te tempfile tempname tempvar tes test testnl testparm teststd tetrachoric time_it timer tis tob tobi tobit tobit_p tobit_sw token tokeni tokeniz tokenize tostring total translate translator transmap treat_ll treatr_p treatreg trim trnb_cons trnb_mean trpoiss_d2 trunc_ll truncr_p truncreg tsappend tset tsfill tsline tsline_ex tsreport tsrevar tsrline tsset tssmooth tsunab ttest ttesti tut_chk tut_wait tutorial tw tware_st two twoway twoway__fpfit_serset twoway__function_gen twoway__histogram_gen twoway__ipoint_serset twoway__ipoints_serset twoway__kdensity_gen twoway__lfit_serset twoway__normgen_gen twoway__pci_serset twoway__qfit_serset twoway__scatteri_serset twoway__sunflower_gen twoway_ksm_serset ty typ type typeof u unab unabbrev unabcmd update us use uselabel var var_mkcompanion var_p varbasic varfcast vargranger varirf varirf_add varirf_cgraph varirf_create varirf_ctable varirf_describe varirf_dir varirf_drop varirf_erase varirf_graph varirf_ograph varirf_rename varirf_set varirf_table varlist varlmar varnorm varsoc varstable varstable_w varstable_w2 varwle vce vec vec_fevd vec_mkphi vec_p vec_p_w vecirf_create veclmar veclmar_w vecnorm vecnorm_w vecrank vecstable verinst vers versi versio version view viewsource vif vwls wdatetof webdescribe webseek webuse weib1_lf weib2_lf weib_lf weib_lf0 weibhet_glf weibhet_glf_sh weibhet_glfa weibhet_glfa_sh weibhet_gp weibhet_ilf weibhet_ilf_sh weibhet_ilfa weibhet_ilfa_sh weibhet_ip weibu_sw weibul_p weibull weibull_c weibull_s weibullhet wh whelp whi which whil while wilc_st wilcoxon win wind windo window winexec wntestb wntestb_7 wntestq xchart xchart_7 xcorr xcorr_7 xi xi_6 xmlsav xmlsave xmluse xpose xsh xshe xshel xshell xt_iis xt_tis xtab_p xtabond xtbin_p xtclog xtcloglog xtcloglog_8 xtcloglog_d2 xtcloglog_pa_p xtcloglog_re_p xtcnt_p xtcorr xtdata xtdes xtfront_p xtfrontier xtgee xtgee_elink xtgee_estat xtgee_makeivar xtgee_p xtgee_plink xtgls xtgls_p xthaus xthausman xtht_p xthtaylor xtile xtint_p xtintreg xtintreg_8 xtintreg_d2 xtintreg_p xtivp_1 xtivp_2 xtivreg xtline xtline_ex xtlogit xtlogit_8 xtlogit_d2 xtlogit_fe_p xtlogit_pa_p xtlogit_re_p xtmixed xtmixed_estat xtmixed_p xtnb_fe xtnb_lf xtnbreg xtnbreg_pa_p xtnbreg_refe_p xtpcse xtpcse_p xtpois xtpoisson xtpoisson_d2 xtpoisson_pa_p xtpoisson_refe_p xtpred xtprobit xtprobit_8 xtprobit_d2 xtprobit_re_p xtps_fe xtps_lf xtps_ren xtps_ren_8 xtrar_p xtrc xtrc_p xtrchh xtrefe_p xtreg xtreg_be xtreg_fe xtreg_ml xtreg_pa_p xtreg_re xtregar xtrere_p xtset xtsf_ll xtsf_llti xtsum xttab xttest0 xttobit xttobit_8 xttobit_p xttrans yx yxview__barlike_draw yxview_area_draw yxview_bar_draw yxview_dot_draw yxview_dropline_draw yxview_function_draw yxview_iarrow_draw yxview_ilabels_draw yxview_normal_draw yxview_pcarrow_draw yxview_pcbarrow_draw yxview_pccapsym_draw yxview_pcscatter_draw yxview_pcspike_draw yxview_rarea_draw yxview_rbar_draw yxview_rbarm_draw yxview_rcap_draw yxview_rcapsym_draw yxview_rconnected_draw yxview_rline_draw yxview_rscatter_draw yxview_rspike_draw yxview_spike_draw yxview_sunflower_draw zap_s zinb zinb_llf zinb_plf zip zip_llf zip_p zip_plf zt_ct_5 zt_hc_5 zt_hcd_5 zt_is_5 zt_iss_5 zt_sho_5 zt_smp_5 ztbase_5 ztcox_5 ztdes_5 ztereg_5 ztfill_5 ztgen_5 ztir_5 ztjoin_5 ztnb ztnb_p ztp ztp_p zts_5 ztset_5 ztspli_5 ztsum_5 zttoct_5 ztvary_5 ztweib_5",contains:[{className:"label",variants:[{begin:"\\$\\{?[a-zA-Z0-9_]+\\}?"},{begin:"`[a-zA-Z0-9_]+'"}]},{className:"string",variants:[{begin:'`"[^\r\n]*?"\''},{begin:'"[^\r\n"]*"'}]},{className:"literal",variants:[{begin:"\\b(abs|acos|asin|atan|atan2|atanh|ceil|cloglog|comb|cos|digamma|exp|floor|invcloglog|invlogit|ln|lnfact|lnfactorial|lngamma|log|log10|max|min|mod|reldif|round|sign|sin|sqrt|sum|tan|tanh|trigamma|trunc|betaden|Binomial|binorm|binormal|chi2|chi2tail|dgammapda|dgammapdada|dgammapdadx|dgammapdx|dgammapdxdx|F|Fden|Ftail|gammaden|gammap|ibeta|invbinomial|invchi2|invchi2tail|invF|invFtail|invgammap|invibeta|invnchi2|invnFtail|invnibeta|invnorm|invnormal|invttail|nbetaden|nchi2|nFden|nFtail|nibeta|norm|normal|normalden|normd|npnchi2|tden|ttail|uniform|abbrev|char|index|indexnot|length|lower|ltrim|match|plural|proper|real|regexm|regexr|regexs|reverse|rtrim|string|strlen|strlower|strltrim|strmatch|strofreal|strpos|strproper|strreverse|strrtrim|strtrim|strupper|subinstr|subinword|substr|trim|upper|word|wordcount|_caller|autocode|byteorder|chop|clip|cond|e|epsdouble|epsfloat|group|inlist|inrange|irecode|matrix|maxbyte|maxdouble|maxfloat|maxint|maxlong|mi|minbyte|mindouble|minfloat|minint|minlong|missing|r|recode|replay|return|s|scalar|d|date|day|dow|doy|halfyear|mdy|month|quarter|week|year|d|daily|dofd|dofh|dofm|dofq|dofw|dofy|h|halfyearly|hofd|m|mofd|monthly|q|qofd|quarterly|tin|twithin|w|weekly|wofd|y|yearly|yh|ym|yofd|yq|yw|cholesky|colnumb|colsof|corr|det|diag|diag0cnt|el|get|hadamard|I|inv|invsym|issym|issymmetric|J|matmissing|matuniform|mreldif|nullmat|rownumb|rowsof|sweep|syminv|trace|vec|vecdiag)(?=\\(|$)"}]},hljs.COMMENT("^[ 	]*\\*.*$",!1),hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE]}}),hljs.registerLanguage("step21",function(hljs){var STEP21_IDENT_RE="[A-Z_][A-Z0-9_.]*",STEP21_CLOSE_RE="END-ISO-10303-21;",STEP21_KEYWORDS={literal:"",built_in:"",keyword:"HEADER ENDSEC DATA"},STEP21_START={className:"preprocessor",begin:"ISO-10303-21;",relevance:10},STEP21_CODE=[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.COMMENT("/\\*\\*!","\\*/"),hljs.C_NUMBER_MODE,hljs.inherit(hljs.APOS_STRING_MODE,{illegal:null}),hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null}),{className:"string",begin:"'",end:"'"},{className:"label",variants:[{begin:"#",end:"\\d+",illegal:"\\W"}]}];return{aliases:["p21","step","stp"],case_insensitive:!0,lexemes:STEP21_IDENT_RE,keywords:STEP21_KEYWORDS,contains:[{className:"preprocessor",begin:STEP21_CLOSE_RE,relevance:10},STEP21_START].concat(STEP21_CODE)}}),hljs.registerLanguage("stylus",function(hljs){var VARIABLE={className:"variable",begin:"\\$"+hljs.IDENT_RE},HEX_COLOR={className:"hexcolor",begin:"#([a-fA-F0-9]{6}|[a-fA-F0-9]{3})",relevance:10},AT_KEYWORDS=["charset","css","debug","extend","font-face","for","import","include","media","mixin","page","warn","while"],PSEUDO_SELECTORS=["after","before","first-letter","first-line","active","first-child","focus","hover","lang","link","visited"],TAGS=["a","abbr","address","article","aside","audio","b","blockquote","body","button","canvas","caption","cite","code","dd","del","details","dfn","div","dl","dt","em","fieldset","figcaption","figure","footer","form","h1","h2","h3","h4","h5","h6","header","hgroup","html","i","iframe","img","input","ins","kbd","label","legend","li","mark","menu","nav","object","ol","p","q","quote","samp","section","span","strong","summary","sup","table","tbody","td","textarea","tfoot","th","thead","time","tr","ul","var","video"],TAG_END="[\\.\\s\\n\\[\\:,]",ATTRIBUTES=["align-content","align-items","align-self","animation","animation-delay","animation-direction","animation-duration","animation-fill-mode","animation-iteration-count","animation-name","animation-play-state","animation-timing-function","auto","backface-visibility","background","background-attachment","background-clip","background-color","background-image","background-origin","background-position","background-repeat","background-size","border","border-bottom","border-bottom-color","border-bottom-left-radius","border-bottom-right-radius","border-bottom-style","border-bottom-width","border-collapse","border-color","border-image","border-image-outset","border-image-repeat","border-image-slice","border-image-source","border-image-width","border-left","border-left-color","border-left-style","border-left-width","border-radius","border-right","border-right-color","border-right-style","border-right-width","border-spacing","border-style","border-top","border-top-color","border-top-left-radius","border-top-right-radius","border-top-style","border-top-width","border-width","bottom","box-decoration-break","box-shadow","box-sizing","break-after","break-before","break-inside","caption-side","clear","clip","clip-path","color","column-count","column-fill","column-gap","column-rule","column-rule-color","column-rule-style","column-rule-width","column-span","column-width","columns","content","counter-increment","counter-reset","cursor","direction","display","empty-cells","filter","flex","flex-basis","flex-direction","flex-flow","flex-grow","flex-shrink","flex-wrap","float","font","font-family","font-feature-settings","font-kerning","font-language-override","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-variant-ligatures","font-weight","height","hyphens","icon","image-orientation","image-rendering","image-resolution","ime-mode","inherit","initial","justify-content","left","letter-spacing","line-height","list-style","list-style-image","list-style-position","list-style-type","margin","margin-bottom","margin-left","margin-right","margin-top","marks","mask","max-height","max-width","min-height","min-width","nav-down","nav-index","nav-left","nav-right","nav-up","none","normal","object-fit","object-position","opacity","order","orphans","outline","outline-color","outline-offset","outline-style","outline-width","overflow","overflow-wrap","overflow-x","overflow-y","padding","padding-bottom","padding-left","padding-right","padding-top","page-break-after","page-break-before","page-break-inside","perspective","perspective-origin","pointer-events","position","quotes","resize","right","tab-size","table-layout","text-align","text-align-last","text-decoration","text-decoration-color","text-decoration-line","text-decoration-style","text-indent","text-overflow","text-rendering","text-shadow","text-transform","text-underline-position","top","transform","transform-origin","transform-style","transition","transition-delay","transition-duration","transition-property","transition-timing-function","unicode-bidi","vertical-align","visibility","white-space","widows","width","word-break","word-spacing","word-wrap","z-index"],ILLEGAL=["\\{","\\}","\\?","(\\bReturn\\b)","(\\bEnd\\b)","(\\bend\\b)",";","#\\s","\\*\\s","===\\s","\\|","%"];
return{aliases:["styl"],case_insensitive:!1,illegal:"("+ILLEGAL.join("|")+")",keywords:"if else for in",contains:[hljs.QUOTE_STRING_MODE,hljs.APOS_STRING_MODE,hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,HEX_COLOR,{begin:"\\.[a-zA-Z][a-zA-Z0-9_-]*"+TAG_END,returnBegin:!0,contains:[{className:"class",begin:"\\.[a-zA-Z][a-zA-Z0-9_-]*"}]},{begin:"\\#[a-zA-Z][a-zA-Z0-9_-]*"+TAG_END,returnBegin:!0,contains:[{className:"id",begin:"\\#[a-zA-Z][a-zA-Z0-9_-]*"}]},{begin:"\\b("+TAGS.join("|")+")"+TAG_END,returnBegin:!0,contains:[{className:"tag",begin:"\\b[a-zA-Z][a-zA-Z0-9_-]*"}]},{className:"pseudo",begin:"&?:?:\\b("+PSEUDO_SELECTORS.join("|")+")"+TAG_END},{className:"at_rule",begin:"@("+AT_KEYWORDS.join("|")+")\\b"},VARIABLE,hljs.CSS_NUMBER_MODE,hljs.NUMBER_MODE,{className:"function",begin:"\\b[a-zA-Z][a-zA-Z0-9_-]*\\(.*\\)",illegal:"[\\n]",returnBegin:!0,contains:[{className:"title",begin:"\\b[a-zA-Z][a-zA-Z0-9_-]*"},{className:"params",begin:/\(/,end:/\)/,contains:[HEX_COLOR,VARIABLE,hljs.APOS_STRING_MODE,hljs.CSS_NUMBER_MODE,hljs.NUMBER_MODE,hljs.QUOTE_STRING_MODE]}]},{className:"attribute",begin:"\\b("+ATTRIBUTES.reverse().join("|")+")\\b"}]}}),hljs.registerLanguage("swift",function(hljs){var SWIFT_KEYWORDS={keyword:"__COLUMN__ __FILE__ __FUNCTION__ __LINE__ as as! as? associativity break case catch class continue convenience default defer deinit didSet do dynamic dynamicType else enum extension fallthrough false final for func get guard if import in indirect infix init inout internal is lazy left let mutating nil none nonmutating operator optional override postfix precedence prefix private protocol Protocol public repeat required rethrows return right self Self set static struct subscript super switch throw throws true try try! try? Type typealias unowned var weak where while willSet",literal:"true false nil",built_in:"abs advance alignof alignofValue anyGenerator assert assertionFailure bridgeFromObjectiveC bridgeFromObjectiveCUnconditional bridgeToObjectiveC bridgeToObjectiveCUnconditional c contains count countElements countLeadingZeros debugPrint debugPrintln distance dropFirst dropLast dump encodeBitsAsWords enumerate equal fatalError filter find getBridgedObjectiveCType getVaList indices insertionSort isBridgedToObjectiveC isBridgedVerbatimToObjectiveC isUniquelyReferenced isUniquelyReferencedNonObjC join lazy lexicographicalCompare map max maxElement min minElement numericCast overlaps partition posix precondition preconditionFailure print println quickSort readLine reduce reflect reinterpretCast reverse roundUpToAlignment sizeof sizeofValue sort split startsWith stride strideof strideofValue swap toString transcode underestimateCount unsafeAddressOf unsafeBitCast unsafeDowncast unsafeUnwrap unsafeReflect withExtendedLifetime withObjectAtPlusZero withUnsafePointer withUnsafePointerToObject withUnsafeMutablePointer withUnsafeMutablePointers withUnsafePointer withUnsafePointers withVaList zip"},TYPE={className:"type",begin:"\\b[A-Z][\\w']*",relevance:0},BLOCK_COMMENT=hljs.COMMENT("/\\*","\\*/",{contains:["self"]}),SUBST={className:"subst",begin:/\\\(/,end:"\\)",keywords:SWIFT_KEYWORDS,contains:[]},NUMBERS={className:"number",begin:"\\b([\\d_]+(\\.[\\deE_]+)?|0x[a-fA-F0-9_]+(\\.[a-fA-F0-9p_]+)?|0b[01_]+|0o[0-7_]+)\\b",relevance:0},QUOTE_STRING_MODE=hljs.inherit(hljs.QUOTE_STRING_MODE,{contains:[SUBST,hljs.BACKSLASH_ESCAPE]});return SUBST.contains=[NUMBERS],{keywords:SWIFT_KEYWORDS,contains:[QUOTE_STRING_MODE,hljs.C_LINE_COMMENT_MODE,BLOCK_COMMENT,TYPE,NUMBERS,{className:"func",beginKeywords:"func",end:"{",excludeEnd:!0,contains:[hljs.inherit(hljs.TITLE_MODE,{begin:/[A-Za-z$_][0-9A-Za-z$_]*/,illegal:/\(/}),{className:"generics",begin:/</,end:/>/,illegal:/>/},{className:"params",begin:/\(/,end:/\)/,endsParent:!0,keywords:SWIFT_KEYWORDS,contains:["self",NUMBERS,QUOTE_STRING_MODE,hljs.C_BLOCK_COMMENT_MODE,{begin:":"}],illegal:/["']/}],illegal:/\[|%/},{className:"class",beginKeywords:"struct protocol class extension enum",keywords:SWIFT_KEYWORDS,end:"\\{",excludeEnd:!0,contains:[hljs.inherit(hljs.TITLE_MODE,{begin:/[A-Za-z$_][0-9A-Za-z$_]*/})]},{className:"preprocessor",begin:"(@warn_unused_result|@exported|@lazy|@noescape|@NSCopying|@NSManaged|@objc|@convention|@required|@noreturn|@IBAction|@IBDesignable|@IBInspectable|@IBOutlet|@infix|@prefix|@postfix|@autoclosure|@testable|@available|@nonobjc|@NSApplicationMain|@UIApplicationMain)"},{beginKeywords:"import",end:/$/,contains:[hljs.C_LINE_COMMENT_MODE,BLOCK_COMMENT]}]}}),hljs.registerLanguage("tcl",function(hljs){return{aliases:["tk"],keywords:"after append apply array auto_execok auto_import auto_load auto_mkindex auto_mkindex_old auto_qualify auto_reset bgerror binary break catch cd chan clock close concat continue dde dict encoding eof error eval exec exit expr fblocked fconfigure fcopy file fileevent filename flush for foreach format gets glob global history http if incr info interp join lappend|10 lassign|10 lindex|10 linsert|10 list llength|10 load lrange|10 lrepeat|10 lreplace|10 lreverse|10 lsearch|10 lset|10 lsort|10 mathfunc mathop memory msgcat namespace open package parray pid pkg::create pkg_mkIndex platform platform::shell proc puts pwd read refchan regexp registry regsub|10 rename return safe scan seek set socket source split string subst switch tcl_endOfWord tcl_findLibrary tcl_startOfNextWord tcl_startOfPreviousWord tcl_wordBreakAfter tcl_wordBreakBefore tcltest tclvars tell time tm trace unknown unload unset update uplevel upvar variable vwait while",contains:[hljs.COMMENT(";[ \\t]*#","$"),hljs.COMMENT("^[ \\t]*#","$"),{beginKeywords:"proc",end:"[\\{]",excludeEnd:!0,contains:[{className:"symbol",begin:"[ \\t\\n\\r]+(::)?[a-zA-Z_]((::)?[a-zA-Z0-9_])*",end:"[ \\t\\n\\r]",endsWithParent:!0,excludeEnd:!0}]},{className:"variable",excludeEnd:!0,variants:[{begin:"\\$(\\{)?(::)?[a-zA-Z_]((::)?[a-zA-Z0-9_])*\\(([a-zA-Z0-9_])*\\)",end:"[^a-zA-Z0-9_\\}\\$]"},{begin:"\\$(\\{)?(::)?[a-zA-Z_]((::)?[a-zA-Z0-9_])*",end:"(\\))?[^a-zA-Z0-9_\\}\\$]"}]},{className:"string",contains:[hljs.BACKSLASH_ESCAPE],variants:[hljs.inherit(hljs.APOS_STRING_MODE,{illegal:null}),hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null})]},{className:"number",variants:[hljs.BINARY_NUMBER_MODE,hljs.C_NUMBER_MODE]}]}}),hljs.registerLanguage("tex",function(hljs){var COMMAND1={className:"command",begin:"\\\\[a-zA-Zа-яА-я]+[\\*]?"},COMMAND2={className:"command",begin:"\\\\[^a-zA-Zа-яА-я0-9]"},SPECIAL={className:"special",begin:"[{}\\[\\]\\&#~]",relevance:0};return{contains:[{begin:"\\\\[a-zA-Zа-яА-я]+[\\*]? *= *-?\\d*\\.?\\d+(pt|pc|mm|cm|in|dd|cc|ex|em)?",returnBegin:!0,contains:[COMMAND1,COMMAND2,{className:"number",begin:" *=",end:"-?\\d*\\.?\\d+(pt|pc|mm|cm|in|dd|cc|ex|em)?",excludeBegin:!0}],relevance:10},COMMAND1,COMMAND2,SPECIAL,{className:"formula",begin:"\\$\\$",end:"\\$\\$",contains:[COMMAND1,COMMAND2,SPECIAL],relevance:0},{className:"formula",begin:"\\$",end:"\\$",contains:[COMMAND1,COMMAND2,SPECIAL],relevance:0},hljs.COMMENT("%","$",{relevance:0})]}}),hljs.registerLanguage("thrift",function(hljs){var BUILT_IN_TYPES="bool byte i16 i32 i64 double string binary";return{keywords:{keyword:"namespace const typedef struct enum service exception void oneway set list map required optional",built_in:BUILT_IN_TYPES,literal:"true false"},contains:[hljs.QUOTE_STRING_MODE,hljs.NUMBER_MODE,hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,{className:"class",beginKeywords:"struct enum service exception",end:/\{/,illegal:/\n/,contains:[hljs.inherit(hljs.TITLE_MODE,{starts:{endsWithParent:!0,excludeEnd:!0}})]},{begin:"\\b(set|list|map)\\s*<",end:">",keywords:BUILT_IN_TYPES,contains:["self"]}]}}),hljs.registerLanguage("tp",function(hljs){var TPID={className:"number",begin:"[1-9][0-9]*",relevance:0},TPLABEL={className:"comment",begin:":[^\\]]+"},TPDATA={className:"built_in",begin:"(AR|P|PAYLOAD|PR|R|SR|RSR|LBL|VR|UALM|MESSAGE|UTOOL|UFRAME|TIMER|    TIMER_OVERFLOW|JOINT_MAX_SPEED|RESUME_PROG|DIAG_REC)\\[",end:"\\]",contains:["self",TPID,TPLABEL]},TPIO={className:"built_in",begin:"(AI|AO|DI|DO|F|RI|RO|UI|UO|GI|GO|SI|SO)\\[",end:"\\]",contains:["self",TPID,hljs.QUOTE_STRING_MODE,TPLABEL]};return{keywords:{keyword:"ABORT ACC ADJUST AND AP_LD BREAK CALL CNT COL CONDITION CONFIG DA DB DIV DETECT ELSE END ENDFOR ERR_NUM ERROR_PROG FINE FOR GP GUARD INC IF JMP LINEAR_MAX_SPEED LOCK MOD MONITOR OFFSET Offset OR OVERRIDE PAUSE PREG PTH RT_LD RUN SELECT SKIP Skip TA TB TO TOOL_OFFSET Tool_Offset UF UT UFRAME_NUM UTOOL_NUM UNLOCK WAIT X Y Z W P R STRLEN SUBSTR FINDSTR VOFFSET",constant:"ON OFF max_speed LPOS JPOS ENABLE DISABLE START STOP RESET"},contains:[TPDATA,TPIO,{className:"keyword",begin:"/(PROG|ATTR|MN|POS|END)\\b"},{className:"keyword",begin:"(CALL|RUN|POINT_LOGIC|LBL)\\b"},{className:"keyword",begin:"\\b(ACC|CNT|Skip|Offset|PSPD|RT_LD|AP_LD|Tool_Offset)"},{className:"number",begin:"\\d+(sec|msec|mm/sec|cm/min|inch/min|deg/sec|mm|in|cm)?\\b",relevance:0},hljs.COMMENT("//","[;$]"),hljs.COMMENT("!","[;$]"),hljs.COMMENT("--eg:","$"),hljs.QUOTE_STRING_MODE,{className:"string",begin:"'",end:"'"},hljs.C_NUMBER_MODE,{className:"variable",begin:"\\$[A-Za-z0-9_]+"}]}}),hljs.registerLanguage("twig",function(hljs){var PARAMS={className:"params",begin:"\\(",end:"\\)"},FUNCTION_NAMES="attribute block constant cycle date dump include max min parent random range source template_from_string",FUNCTIONS={className:"function",beginKeywords:FUNCTION_NAMES,relevance:0,contains:[PARAMS]},FILTER={className:"filter",begin:/\|[A-Za-z_]+:?/,keywords:"abs batch capitalize convert_encoding date date_modify default escape first format join json_encode keys last length lower merge nl2br number_format raw replace reverse round slice sort split striptags title trim upper url_encode",contains:[FUNCTIONS]},TAGS="autoescape block do embed extends filter flush for if import include macro sandbox set spaceless use verbatim";return TAGS=TAGS+" "+TAGS.split(" ").map(function(t){return"end"+t}).join(" "),{aliases:["craftcms"],case_insensitive:!0,subLanguage:"xml",contains:[hljs.COMMENT(/\{#/,/#}/),{className:"template_tag",begin:/\{%/,end:/%}/,keywords:TAGS,contains:[FILTER,FUNCTIONS]},{className:"variable",begin:/\{\{/,end:/}}/,contains:[FILTER,FUNCTIONS]}]}}),hljs.registerLanguage("typescript",function(hljs){var KEYWORDS={keyword:"in if for while finally var new function|0 do return void else break catch instanceof with throw case default try this switch continue typeof delete let yield const class public private protected get set super static implements enum export import declare type namespace abstract",literal:"true false null undefined NaN Infinity",built_in:"eval isFinite isNaN parseFloat parseInt decodeURI decodeURIComponent encodeURI encodeURIComponent escape unescape Object Function Boolean Error EvalError InternalError RangeError ReferenceError StopIteration SyntaxError TypeError URIError Number Math Date String RegExp Array Float32Array Float64Array Int16Array Int32Array Int8Array Uint16Array Uint32Array Uint8Array Uint8ClampedArray ArrayBuffer DataView JSON Intl arguments require module console window document any number boolean string void"};return{aliases:["ts"],keywords:KEYWORDS,contains:[{className:"pi",begin:/^\s*['"]use strict['"]/,relevance:0},hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,{className:"number",variants:[{begin:"\\b(0[bB][01]+)"},{begin:"\\b(0[oO][0-7]+)"},{begin:hljs.C_NUMBER_RE}],relevance:0},{begin:"("+hljs.RE_STARTERS_RE+"|\\b(case|return|throw)\\b)\\s*",keywords:"return throw case",contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,hljs.REGEXP_MODE],relevance:0},{className:"function",begin:"function",end:/[\{;]/,excludeEnd:!0,keywords:KEYWORDS,contains:["self",hljs.inherit(hljs.TITLE_MODE,{begin:/[A-Za-z$_][0-9A-Za-z$_]*/}),{className:"params",begin:/\(/,end:/\)/,excludeBegin:!0,excludeEnd:!0,keywords:KEYWORDS,contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE],illegal:/["'\(]/}],illegal:/\[|%/,relevance:0},{className:"constructor",beginKeywords:"constructor",end:/\{/,excludeEnd:!0,relevance:10},{className:"module",beginKeywords:"module",end:/\{/,excludeEnd:!0},{className:"interface",beginKeywords:"interface",end:/\{/,excludeEnd:!0,keywords:"interface extends"},{begin:/\$[(.]/},{begin:"\\."+hljs.IDENT_RE,relevance:0}]}}),hljs.registerLanguage("vala",function(hljs){return{keywords:{keyword:"char uchar unichar int uint long ulong short ushort int8 int16 int32 int64 uint8 uint16 uint32 uint64 float double bool struct enum string void weak unowned owned async signal static abstract interface override while do for foreach else switch case break default return try catch public private protected internal using new this get set const stdout stdin stderr var",built_in:"DBus GLib CCode Gee Object",literal:"false true null"},contains:[{className:"class",beginKeywords:"class interface delegate namespace",end:"{",excludeEnd:!0,illegal:"[^,:\\n\\s\\.]",contains:[hljs.UNDERSCORE_TITLE_MODE]},hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,{className:"string",begin:'"""',end:'"""',relevance:5},hljs.APOS_STRING_MODE,hljs.QUOTE_STRING_MODE,hljs.C_NUMBER_MODE,{className:"preprocessor",begin:"^#",end:"$",relevance:2},{className:"constant",begin:" [A-Z_]+ ",relevance:0}]}}),hljs.registerLanguage("vbnet",function(hljs){return{aliases:["vb"],case_insensitive:!0,keywords:{keyword:"addhandler addressof alias and andalso aggregate ansi as assembly auto binary by byref byval call case catch class compare const continue custom declare default delegate dim distinct do each equals else elseif end enum erase error event exit explicit finally for friend from function get global goto group handles if implements imports in inherits interface into is isfalse isnot istrue join key let lib like loop me mid mod module mustinherit mustoverride mybase myclass namespace narrowing new next not notinheritable notoverridable of off on operator option optional or order orelse overloads overridable overrides paramarray partial preserve private property protected public raiseevent readonly redim rem removehandler resume return select set shadows shared skip static step stop structure strict sub synclock take text then throw to try unicode until using when where while widening with withevents writeonly xor",built_in:"boolean byte cbool cbyte cchar cdate cdec cdbl char cint clng cobj csbyte cshort csng cstr ctype date decimal directcast double gettype getxmlnamespace iif integer long object sbyte short single string trycast typeof uinteger ulong ushort",literal:"true false nothing"},illegal:"//|{|}|endif|gosub|variant|wend",contains:[hljs.inherit(hljs.QUOTE_STRING_MODE,{contains:[{begin:'""'}]}),hljs.COMMENT("'","$",{returnBegin:!0,contains:[{className:"xmlDocTag",begin:"'''|<!--|-->",contains:[hljs.PHRASAL_WORDS_MODE]},{className:"xmlDocTag",begin:"</?",end:">",contains:[hljs.PHRASAL_WORDS_MODE]}]}),hljs.C_NUMBER_MODE,{className:"preprocessor",begin:"#",end:"$",keywords:"if else elseif end region externalsource"}]}}),hljs.registerLanguage("vbscript",function(hljs){return{aliases:["vbs"],case_insensitive:!0,keywords:{keyword:"call class const dim do loop erase execute executeglobal exit for each next function if then else on error option explicit new private property let get public randomize redim rem select case set stop sub while wend with end to elseif is or xor and not class_initialize class_terminate default preserve in me byval byref step resume goto",built_in:"lcase month vartype instrrev ubound setlocale getobject rgb getref string weekdayname rnd dateadd monthname now day minute isarray cbool round formatcurrency conversions csng timevalue second year space abs clng timeserial fixs len asc isempty maths dateserial atn timer isobject filter weekday datevalue ccur isdate instr datediff formatdatetime replace isnull right sgn array snumeric log cdbl hex chr lbound msgbox ucase getlocale cos cdate cbyte rtrim join hour oct typename trim strcomp int createobject loadpicture tan formatnumber mid scriptenginebuildversion scriptengine split scriptengineminorversion cint sin datepart ltrim sqr scriptenginemajorversion time derived eval date formatpercent exp inputbox left ascw chrw regexp server response request cstr err",literal:"true false null nothing empty"},illegal:"//",contains:[hljs.inherit(hljs.QUOTE_STRING_MODE,{contains:[{begin:'""'}]}),hljs.COMMENT(/'/,/$/,{relevance:0}),hljs.C_NUMBER_MODE]}}),hljs.registerLanguage("vbscript-html",function(hljs){return{subLanguage:"xml",contains:[{begin:"<%",end:"%>",subLanguage:"vbscript"}]}}),hljs.registerLanguage("verilog",function(hljs){return{aliases:["v"],case_insensitive:!0,keywords:{keyword:"always and assign begin buf bufif0 bufif1 case casex casez cmos deassign default defparam disable edge else end endcase endfunction endmodule endprimitive endspecify endtable endtask event for force forever fork function if ifnone initial inout input join macromodule module nand negedge nmos nor not notif0 notif1 or output parameter pmos posedge primitive pulldown pullup rcmos release repeat rnmos rpmos rtran rtranif0 rtranif1 specify specparam table task timescale tran tranif0 tranif1 wait while xnor xor",typename:"highz0 highz1 integer large medium pull0 pull1 real realtime reg scalared signed small strong0 strong1 supply0 supply0 supply1 supply1 time tri tri0 tri1 triand trior trireg vectored wand weak0 weak1 wire wor"},contains:[hljs.C_BLOCK_COMMENT_MODE,hljs.C_LINE_COMMENT_MODE,hljs.QUOTE_STRING_MODE,{className:"number",begin:"\\b(\\d+'(b|h|o|d|B|H|O|D))?[0-9xzXZ]+",contains:[hljs.BACKSLASH_ESCAPE],relevance:0},{className:"typename",begin:"\\.\\w+",relevance:0},{className:"value",begin:"#\\((?!parameter).+\\)"},{className:"keyword",begin:"\\+|-|\\*|/|%|<|>|=|#|`|\\!|&|\\||@|:|\\^|~|\\{|\\}",relevance:0}]}}),hljs.registerLanguage("vhdl",function(hljs){var INTEGER_RE="\\d(_|\\d)*",EXPONENT_RE="[eE][-+]?"+INTEGER_RE,DECIMAL_LITERAL_RE=INTEGER_RE+"(\\."+INTEGER_RE+")?("+EXPONENT_RE+")?",BASED_INTEGER_RE="\\w+",BASED_LITERAL_RE=INTEGER_RE+"#"+BASED_INTEGER_RE+"(\\."+BASED_INTEGER_RE+")?#("+EXPONENT_RE+")?",NUMBER_RE="\\b("+BASED_LITERAL_RE+"|"+DECIMAL_LITERAL_RE+")";return{case_insensitive:!0,keywords:{keyword:"abs access after alias all and architecture array assert attribute begin block body buffer bus case component configuration constant context cover disconnect downto default else elsif end entity exit fairness file for force function generate generic group guarded if impure in inertial inout is label library linkage literal loop map mod nand new next nor not null of on open or others out package port postponed procedure process property protected pure range record register reject release rem report restrict restrict_guarantee return rol ror select sequence severity shared signal sla sll sra srl strong subtype then to transport type unaffected units until use variable vmode vprop vunit wait when while with xnor xor",typename:"boolean bit character severity_level integer time delay_length natural positive string bit_vector file_open_kind file_open_status std_ulogic std_ulogic_vector std_logic std_logic_vector unsigned signed boolean_vector integer_vector real_vector time_vector"},illegal:"{",contains:[hljs.C_BLOCK_COMMENT_MODE,hljs.COMMENT("--","$"),hljs.QUOTE_STRING_MODE,{className:"number",begin:NUMBER_RE,relevance:0},{className:"literal",begin:"'(U|X|0|1|Z|W|L|H|-)'",contains:[hljs.BACKSLASH_ESCAPE]},{className:"attribute",begin:"'[A-Za-z](_?[A-Za-z0-9])*",contains:[hljs.BACKSLASH_ESCAPE]}]}}),hljs.registerLanguage("vim",function(hljs){return{lexemes:/[!#@\w]+/,keywords:{keyword:"N|0 P|0 X|0 a|0 ab abc abo al am an|0 ar arga argd arge argdo argg argl argu as au aug aun b|0 bN ba bad bd be bel bf bl bm bn bo bp br brea breaka breakd breakl bro bufdo buffers bun bw c|0 cN cNf ca cabc caddb cad caddf cal cat cb cc ccl cd ce cex cf cfir cgetb cgete cg changes chd che checkt cl cla clo cm cmapc cme cn cnew cnf cno cnorea cnoreme co col colo com comc comp con conf cope cp cpf cq cr cs cst cu cuna cunme cw d|0 delm deb debugg delc delf dif diffg diffo diffp diffpu diffs diffthis dig di dl dell dj dli do doautoa dp dr ds dsp e|0 ea ec echoe echoh echom echon el elsei em en endfo endf endt endw ene ex exe exi exu f|0 files filet fin fina fini fir fix fo foldc foldd folddoc foldo for fu g|0 go gr grepa gu gv ha h|0 helpf helpg helpt hi hid his i|0 ia iabc if ij il im imapc ime ino inorea inoreme int is isp iu iuna iunme j|0 ju k|0 keepa kee keepj lN lNf l|0 lad laddb laddf la lan lat lb lc lch lcl lcs le lefta let lex lf lfir lgetb lgete lg lgr lgrepa lh ll lla lli lmak lm lmapc lne lnew lnf ln loadk lo loc lockv lol lope lp lpf lr ls lt lu lua luad luaf lv lvimgrepa lw m|0 ma mak map mapc marks mat me menut mes mk mks mksp mkv mkvie mod mz mzf nbc nb nbs n|0 new nm nmapc nme nn nnoreme noa no noh norea noreme norm nu nun nunme ol o|0 om omapc ome on ono onoreme opt ou ounme ow p|0 profd prof pro promptr pc ped pe perld po popu pp pre prev ps pt ptN ptf ptj ptl ptn ptp ptr pts pu pw py3 python3 py3d py3f py pyd pyf q|0 quita qa r|0 rec red redi redr redraws reg res ret retu rew ri rightb rub rubyd rubyf rund ru rv s|0 sN san sa sal sav sb sbN sba sbf sbl sbm sbn sbp sbr scrip scripte scs se setf setg setl sf sfir sh sim sig sil sl sla sm smap smapc sme sn sni sno snor snoreme sor so spelld spe spelli spellr spellu spellw sp spr sre st sta startg startr star stopi stj sts sun sunm sunme sus sv sw sy synti sync t|0 tN tabN tabc tabdo tabe tabf tabfir tabl tabm tabnew tabn tabo tabp tabr tabs tab ta tags tc tcld tclf te tf th tj tl tm tn to tp tr try ts tu u|0 undoj undol una unh unl unlo unm unme uns up v|0 ve verb vert vim vimgrepa vi viu vie vm vmapc vme vne vn vnoreme vs vu vunme windo w|0 wN wa wh wi winc winp wn wp wq wqa ws wu wv x|0 xa xmapc xm xme xn xnoreme xu xunme y|0 z|0 ~ Next Print append abbreviate abclear aboveleft all amenu anoremenu args argadd argdelete argedit argglobal arglocal argument ascii autocmd augroup aunmenu buffer bNext ball badd bdelete behave belowright bfirst blast bmodified bnext botright bprevious brewind break breakadd breakdel breaklist browse bunload bwipeout change cNext cNfile cabbrev cabclear caddbuffer caddexpr caddfile call catch cbuffer cclose center cexpr cfile cfirst cgetbuffer cgetexpr cgetfile chdir checkpath checktime clist clast close cmap cmapclear cmenu cnext cnewer cnfile cnoremap cnoreabbrev cnoremenu copy colder colorscheme command comclear compiler continue confirm copen cprevious cpfile cquit crewind cscope cstag cunmap cunabbrev cunmenu cwindow delete delmarks debug debuggreedy delcommand delfunction diffupdate diffget diffoff diffpatch diffput diffsplit digraphs display deletel djump dlist doautocmd doautoall deletep drop dsearch dsplit edit earlier echo echoerr echohl echomsg else elseif emenu endif endfor endfunction endtry endwhile enew execute exit exusage file filetype find finally finish first fixdel fold foldclose folddoopen folddoclosed foldopen function global goto grep grepadd gui gvim hardcopy help helpfind helpgrep helptags highlight hide history insert iabbrev iabclear ijump ilist imap imapclear imenu inoremap inoreabbrev inoremenu intro isearch isplit iunmap iunabbrev iunmenu join jumps keepalt keepmarks keepjumps lNext lNfile list laddexpr laddbuffer laddfile last language later lbuffer lcd lchdir lclose lcscope left leftabove lexpr lfile lfirst lgetbuffer lgetexpr lgetfile lgrep lgrepadd lhelpgrep llast llist lmake lmap lmapclear lnext lnewer lnfile lnoremap loadkeymap loadview lockmarks lockvar lolder lopen lprevious lpfile lrewind ltag lunmap luado luafile lvimgrep lvimgrepadd lwindow move mark make mapclear match menu menutranslate messages mkexrc mksession mkspell mkvimrc mkview mode mzscheme mzfile nbclose nbkey nbsart next nmap nmapclear nmenu nnoremap nnoremenu noautocmd noremap nohlsearch noreabbrev noremenu normal number nunmap nunmenu oldfiles open omap omapclear omenu only onoremap onoremenu options ounmap ounmenu ownsyntax print profdel profile promptfind promptrepl pclose pedit perl perldo pop popup ppop preserve previous psearch ptag ptNext ptfirst ptjump ptlast ptnext ptprevious ptrewind ptselect put pwd py3do py3file python pydo pyfile quit quitall qall read recover redo redir redraw redrawstatus registers resize retab return rewind right rightbelow ruby rubydo rubyfile rundo runtime rviminfo substitute sNext sandbox sargument sall saveas sbuffer sbNext sball sbfirst sblast sbmodified sbnext sbprevious sbrewind scriptnames scriptencoding scscope set setfiletype setglobal setlocal sfind sfirst shell simalt sign silent sleep slast smagic smapclear smenu snext sniff snomagic snoremap snoremenu sort source spelldump spellgood spellinfo spellrepall spellundo spellwrong split sprevious srewind stop stag startgreplace startreplace startinsert stopinsert stjump stselect sunhide sunmap sunmenu suspend sview swapname syntax syntime syncbind tNext tabNext tabclose tabedit tabfind tabfirst tablast tabmove tabnext tabonly tabprevious tabrewind tag tcl tcldo tclfile tearoff tfirst throw tjump tlast tmenu tnext topleft tprevious trewind tselect tunmenu undo undojoin undolist unabbreviate unhide unlet unlockvar unmap unmenu unsilent update vglobal version verbose vertical vimgrep vimgrepadd visual viusage view vmap vmapclear vmenu vnew vnoremap vnoremenu vsplit vunmap vunmenu write wNext wall while winsize wincmd winpos wnext wprevious wqall wsverb wundo wviminfo xit xall xmapclear xmap xmenu xnoremap xnoremenu xunmap xunmenu yank",built_in:"abs acos add and append argc argidx argv asin atan atan2 browse browsedir bufexists buflisted bufloaded bufname bufnr bufwinnr byte2line byteidx call ceil changenr char2nr cindent clearmatches col complete complete_add complete_check confirm copy cos cosh count cscope_connection cursor deepcopy delete did_filetype diff_filler diff_hlID empty escape eval eventhandler executable exists exp expand extend feedkeys filereadable filewritable filter finddir findfile float2nr floor fmod fnameescape fnamemodify foldclosed foldclosedend foldlevel foldtext foldtextresult foreground function garbagecollect get getbufline getbufvar getchar getcharmod getcmdline getcmdpos getcmdtype getcwd getfontname getfperm getfsize getftime getftype getline getloclist getmatches getpid getpos getqflist getreg getregtype gettabvar gettabwinvar getwinposx getwinposy getwinvar glob globpath has has_key haslocaldir hasmapto histadd histdel histget histnr hlexists hlID hostname iconv indent index input inputdialog inputlist inputrestore inputsave inputsecret insert invert isdirectory islocked items join keys len libcall libcallnr line line2byte lispindent localtime log log10 luaeval map maparg mapcheck match matchadd matcharg matchdelete matchend matchlist matchstr max min mkdir mode mzeval nextnonblank nr2char or pathshorten pow prevnonblank printf pumvisible py3eval pyeval range readfile reltime reltimestr remote_expr remote_foreground remote_peek remote_read remote_send remove rename repeat resolve reverse round screenattr screenchar screencol screenrow search searchdecl searchpair searchpairpos searchpos server2client serverlist setbufvar setcmdpos setline setloclist setmatches setpos setqflist setreg settabvar settabwinvar setwinvar sha256 shellescape shiftwidth simplify sin sinh sort soundfold spellbadword spellsuggest split sqrt str2float str2nr strchars strdisplaywidth strftime stridx string strlen strpart strridx strtrans strwidth submatch substitute synconcealed synID synIDattr synIDtrans synstack system tabpagebuflist tabpagenr tabpagewinnr tagfiles taglist tan tanh tempname tolower toupper tr trunc type undofile undotree values virtcol visualmode wildmenumode winbufnr wincol winheight winline winnr winrestcmd winrestview winsaveview winwidth writefile xor"},illegal:/[{:]/,contains:[hljs.NUMBER_MODE,hljs.APOS_STRING_MODE,{className:"string",begin:/"((\\")|[^"\n])*("|\n)/},{className:"variable",begin:/[bwtglsav]:[\w\d_]*/},{className:"function",beginKeywords:"function function!",end:"$",relevance:0,contains:[hljs.TITLE_MODE,{className:"params",begin:"\\(",end:"\\)"}]}]}}),hljs.registerLanguage("x86asm",function(hljs){return{case_insensitive:!0,lexemes:"\\.?"+hljs.IDENT_RE,keywords:{keyword:"lock rep repe repz repne repnz xaquire xrelease bnd nobnd aaa aad aam aas adc add and arpl bb0_reset bb1_reset bound bsf bsr bswap bt btc btr bts call cbw cdq cdqe clc cld cli clts cmc cmp cmpsb cmpsd cmpsq cmpsw cmpxchg cmpxchg486 cmpxchg8b cmpxchg16b cpuid cpu_read cpu_write cqo cwd cwde daa das dec div dmint emms enter equ f2xm1 fabs fadd faddp fbld fbstp fchs fclex fcmovb fcmovbe fcmove fcmovnb fcmovnbe fcmovne fcmovnu fcmovu fcom fcomi fcomip fcomp fcompp fcos fdecstp fdisi fdiv fdivp fdivr fdivrp femms feni ffree ffreep fiadd ficom ficomp fidiv fidivr fild fimul fincstp finit fist fistp fisttp fisub fisubr fld fld1 fldcw fldenv fldl2e fldl2t fldlg2 fldln2 fldpi fldz fmul fmulp fnclex fndisi fneni fninit fnop fnsave fnstcw fnstenv fnstsw fpatan fprem fprem1 fptan frndint frstor fsave fscale fsetpm fsin fsincos fsqrt fst fstcw fstenv fstp fstsw fsub fsubp fsubr fsubrp ftst fucom fucomi fucomip fucomp fucompp fxam fxch fxtract fyl2x fyl2xp1 hlt ibts icebp idiv imul in inc incbin insb insd insw int int01 int1 int03 int3 into invd invpcid invlpg invlpga iret iretd iretq iretw jcxz jecxz jrcxz jmp jmpe lahf lar lds lea leave les lfence lfs lgdt lgs lidt lldt lmsw loadall loadall286 lodsb lodsd lodsq lodsw loop loope loopne loopnz loopz lsl lss ltr mfence monitor mov movd movq movsb movsd movsq movsw movsx movsxd movzx mul mwait neg nop not or out outsb outsd outsw packssdw packsswb packuswb paddb paddd paddsb paddsiw paddsw paddusb paddusw paddw pand pandn pause paveb pavgusb pcmpeqb pcmpeqd pcmpeqw pcmpgtb pcmpgtd pcmpgtw pdistib pf2id pfacc pfadd pfcmpeq pfcmpge pfcmpgt pfmax pfmin pfmul pfrcp pfrcpit1 pfrcpit2 pfrsqit1 pfrsqrt pfsub pfsubr pi2fd pmachriw pmaddwd pmagw pmulhriw pmulhrwa pmulhrwc pmulhw pmullw pmvgezb pmvlzb pmvnzb pmvzb pop popa popad popaw popf popfd popfq popfw por prefetch prefetchw pslld psllq psllw psrad psraw psrld psrlq psrlw psubb psubd psubsb psubsiw psubsw psubusb psubusw psubw punpckhbw punpckhdq punpckhwd punpcklbw punpckldq punpcklwd push pusha pushad pushaw pushf pushfd pushfq pushfw pxor rcl rcr rdshr rdmsr rdpmc rdtsc rdtscp ret retf retn rol ror rdm rsdc rsldt rsm rsts sahf sal salc sar sbb scasb scasd scasq scasw sfence sgdt shl shld shr shrd sidt sldt skinit smi smint smintold smsw stc std sti stosb stosd stosq stosw str sub svdc svldt svts swapgs syscall sysenter sysexit sysret test ud0 ud1 ud2b ud2 ud2a umov verr verw fwait wbinvd wrshr wrmsr xadd xbts xchg xlatb xlat xor cmove cmovz cmovne cmovnz cmova cmovnbe cmovae cmovnb cmovb cmovnae cmovbe cmovna cmovg cmovnle cmovge cmovnl cmovl cmovnge cmovle cmovng cmovc cmovnc cmovo cmovno cmovs cmovns cmovp cmovpe cmovnp cmovpo je jz jne jnz ja jnbe jae jnb jb jnae jbe jna jg jnle jge jnl jl jnge jle jng jc jnc jo jno js jns jpo jnp jpe jp sete setz setne setnz seta setnbe setae setnb setnc setb setnae setcset setbe setna setg setnle setge setnl setl setnge setle setng sets setns seto setno setpe setp setpo setnp addps addss andnps andps cmpeqps cmpeqss cmpleps cmpless cmpltps cmpltss cmpneqps cmpneqss cmpnleps cmpnless cmpnltps cmpnltss cmpordps cmpordss cmpunordps cmpunordss cmpps cmpss comiss cvtpi2ps cvtps2pi cvtsi2ss cvtss2si cvttps2pi cvttss2si divps divss ldmxcsr maxps maxss minps minss movaps movhps movlhps movlps movhlps movmskps movntps movss movups mulps mulss orps rcpps rcpss rsqrtps rsqrtss shufps sqrtps sqrtss stmxcsr subps subss ucomiss unpckhps unpcklps xorps fxrstor fxrstor64 fxsave fxsave64 xgetbv xsetbv xsave xsave64 xsaveopt xsaveopt64 xrstor xrstor64 prefetchnta prefetcht0 prefetcht1 prefetcht2 maskmovq movntq pavgb pavgw pextrw pinsrw pmaxsw pmaxub pminsw pminub pmovmskb pmulhuw psadbw pshufw pf2iw pfnacc pfpnacc pi2fw pswapd maskmovdqu clflush movntdq movnti movntpd movdqa movdqu movdq2q movq2dq paddq pmuludq pshufd pshufhw pshuflw pslldq psrldq psubq punpckhqdq punpcklqdq addpd addsd andnpd andpd cmpeqpd cmpeqsd cmplepd cmplesd cmpltpd cmpltsd cmpneqpd cmpneqsd cmpnlepd cmpnlesd cmpnltpd cmpnltsd cmpordpd cmpordsd cmpunordpd cmpunordsd cmppd comisd cvtdq2pd cvtdq2ps cvtpd2dq cvtpd2pi cvtpd2ps cvtpi2pd cvtps2dq cvtps2pd cvtsd2si cvtsd2ss cvtsi2sd cvtss2sd cvttpd2pi cvttpd2dq cvttps2dq cvttsd2si divpd divsd maxpd maxsd minpd minsd movapd movhpd movlpd movmskpd movupd mulpd mulsd orpd shufpd sqrtpd sqrtsd subpd subsd ucomisd unpckhpd unpcklpd xorpd addsubpd addsubps haddpd haddps hsubpd hsubps lddqu movddup movshdup movsldup clgi stgi vmcall vmclear vmfunc vmlaunch vmload vmmcall vmptrld vmptrst vmread vmresume vmrun vmsave vmwrite vmxoff vmxon invept invvpid pabsb pabsw pabsd palignr phaddw phaddd phaddsw phsubw phsubd phsubsw pmaddubsw pmulhrsw pshufb psignb psignw psignd extrq insertq movntsd movntss lzcnt blendpd blendps blendvpd blendvps dppd dpps extractps insertps movntdqa mpsadbw packusdw pblendvb pblendw pcmpeqq pextrb pextrd pextrq phminposuw pinsrb pinsrd pinsrq pmaxsb pmaxsd pmaxud pmaxuw pminsb pminsd pminud pminuw pmovsxbw pmovsxbd pmovsxbq pmovsxwd pmovsxwq pmovsxdq pmovzxbw pmovzxbd pmovzxbq pmovzxwd pmovzxwq pmovzxdq pmuldq pmulld ptest roundpd roundps roundsd roundss crc32 pcmpestri pcmpestrm pcmpistri pcmpistrm pcmpgtq popcnt getsec pfrcpv pfrsqrtv movbe aesenc aesenclast aesdec aesdeclast aesimc aeskeygenassist vaesenc vaesenclast vaesdec vaesdeclast vaesimc vaeskeygenassist vaddpd vaddps vaddsd vaddss vaddsubpd vaddsubps vandpd vandps vandnpd vandnps vblendpd vblendps vblendvpd vblendvps vbroadcastss vbroadcastsd vbroadcastf128 vcmpeq_ospd vcmpeqpd vcmplt_ospd vcmpltpd vcmple_ospd vcmplepd vcmpunord_qpd vcmpunordpd vcmpneq_uqpd vcmpneqpd vcmpnlt_uspd vcmpnltpd vcmpnle_uspd vcmpnlepd vcmpord_qpd vcmpordpd vcmpeq_uqpd vcmpnge_uspd vcmpngepd vcmpngt_uspd vcmpngtpd vcmpfalse_oqpd vcmpfalsepd vcmpneq_oqpd vcmpge_ospd vcmpgepd vcmpgt_ospd vcmpgtpd vcmptrue_uqpd vcmptruepd vcmplt_oqpd vcmple_oqpd vcmpunord_spd vcmpneq_uspd vcmpnlt_uqpd vcmpnle_uqpd vcmpord_spd vcmpeq_uspd vcmpnge_uqpd vcmpngt_uqpd vcmpfalse_ospd vcmpneq_ospd vcmpge_oqpd vcmpgt_oqpd vcmptrue_uspd vcmppd vcmpeq_osps vcmpeqps vcmplt_osps vcmpltps vcmple_osps vcmpleps vcmpunord_qps vcmpunordps vcmpneq_uqps vcmpneqps vcmpnlt_usps vcmpnltps vcmpnle_usps vcmpnleps vcmpord_qps vcmpordps vcmpeq_uqps vcmpnge_usps vcmpngeps vcmpngt_usps vcmpngtps vcmpfalse_oqps vcmpfalseps vcmpneq_oqps vcmpge_osps vcmpgeps vcmpgt_osps vcmpgtps vcmptrue_uqps vcmptrueps vcmplt_oqps vcmple_oqps vcmpunord_sps vcmpneq_usps vcmpnlt_uqps vcmpnle_uqps vcmpord_sps vcmpeq_usps vcmpnge_uqps vcmpngt_uqps vcmpfalse_osps vcmpneq_osps vcmpge_oqps vcmpgt_oqps vcmptrue_usps vcmpps vcmpeq_ossd vcmpeqsd vcmplt_ossd vcmpltsd vcmple_ossd vcmplesd vcmpunord_qsd vcmpunordsd vcmpneq_uqsd vcmpneqsd vcmpnlt_ussd vcmpnltsd vcmpnle_ussd vcmpnlesd vcmpord_qsd vcmpordsd vcmpeq_uqsd vcmpnge_ussd vcmpngesd vcmpngt_ussd vcmpngtsd vcmpfalse_oqsd vcmpfalsesd vcmpneq_oqsd vcmpge_ossd vcmpgesd vcmpgt_ossd vcmpgtsd vcmptrue_uqsd vcmptruesd vcmplt_oqsd vcmple_oqsd vcmpunord_ssd vcmpneq_ussd vcmpnlt_uqsd vcmpnle_uqsd vcmpord_ssd vcmpeq_ussd vcmpnge_uqsd vcmpngt_uqsd vcmpfalse_ossd vcmpneq_ossd vcmpge_oqsd vcmpgt_oqsd vcmptrue_ussd vcmpsd vcmpeq_osss vcmpeqss vcmplt_osss vcmpltss vcmple_osss vcmpless vcmpunord_qss vcmpunordss vcmpneq_uqss vcmpneqss vcmpnlt_usss vcmpnltss vcmpnle_usss vcmpnless vcmpord_qss vcmpordss vcmpeq_uqss vcmpnge_usss vcmpngess vcmpngt_usss vcmpngtss vcmpfalse_oqss vcmpfalsess vcmpneq_oqss vcmpge_osss vcmpgess vcmpgt_osss vcmpgtss vcmptrue_uqss vcmptruess vcmplt_oqss vcmple_oqss vcmpunord_sss vcmpneq_usss vcmpnlt_uqss vcmpnle_uqss vcmpord_sss vcmpeq_usss vcmpnge_uqss vcmpngt_uqss vcmpfalse_osss vcmpneq_osss vcmpge_oqss vcmpgt_oqss vcmptrue_usss vcmpss vcomisd vcomiss vcvtdq2pd vcvtdq2ps vcvtpd2dq vcvtpd2ps vcvtps2dq vcvtps2pd vcvtsd2si vcvtsd2ss vcvtsi2sd vcvtsi2ss vcvtss2sd vcvtss2si vcvttpd2dq vcvttps2dq vcvttsd2si vcvttss2si vdivpd vdivps vdivsd vdivss vdppd vdpps vextractf128 vextractps vhaddpd vhaddps vhsubpd vhsubps vinsertf128 vinsertps vlddqu vldqqu vldmxcsr vmaskmovdqu vmaskmovps vmaskmovpd vmaxpd vmaxps vmaxsd vmaxss vminpd vminps vminsd vminss vmovapd vmovaps vmovd vmovq vmovddup vmovdqa vmovqqa vmovdqu vmovqqu vmovhlps vmovhpd vmovhps vmovlhps vmovlpd vmovlps vmovmskpd vmovmskps vmovntdq vmovntqq vmovntdqa vmovntpd vmovntps vmovsd vmovshdup vmovsldup vmovss vmovupd vmovups vmpsadbw vmulpd vmulps vmulsd vmulss vorpd vorps vpabsb vpabsw vpabsd vpacksswb vpackssdw vpackuswb vpackusdw vpaddb vpaddw vpaddd vpaddq vpaddsb vpaddsw vpaddusb vpaddusw vpalignr vpand vpandn vpavgb vpavgw vpblendvb vpblendw vpcmpestri vpcmpestrm vpcmpistri vpcmpistrm vpcmpeqb vpcmpeqw vpcmpeqd vpcmpeqq vpcmpgtb vpcmpgtw vpcmpgtd vpcmpgtq vpermilpd vpermilps vperm2f128 vpextrb vpextrw vpextrd vpextrq vphaddw vphaddd vphaddsw vphminposuw vphsubw vphsubd vphsubsw vpinsrb vpinsrw vpinsrd vpinsrq vpmaddwd vpmaddubsw vpmaxsb vpmaxsw vpmaxsd vpmaxub vpmaxuw vpmaxud vpminsb vpminsw vpminsd vpminub vpminuw vpminud vpmovmskb vpmovsxbw vpmovsxbd vpmovsxbq vpmovsxwd vpmovsxwq vpmovsxdq vpmovzxbw vpmovzxbd vpmovzxbq vpmovzxwd vpmovzxwq vpmovzxdq vpmulhuw vpmulhrsw vpmulhw vpmullw vpmulld vpmuludq vpmuldq vpor vpsadbw vpshufb vpshufd vpshufhw vpshuflw vpsignb vpsignw vpsignd vpslldq vpsrldq vpsllw vpslld vpsllq vpsraw vpsrad vpsrlw vpsrld vpsrlq vptest vpsubb vpsubw vpsubd vpsubq vpsubsb vpsubsw vpsubusb vpsubusw vpunpckhbw vpunpckhwd vpunpckhdq vpunpckhqdq vpunpcklbw vpunpcklwd vpunpckldq vpunpcklqdq vpxor vrcpps vrcpss vrsqrtps vrsqrtss vroundpd vroundps vroundsd vroundss vshufpd vshufps vsqrtpd vsqrtps vsqrtsd vsqrtss vstmxcsr vsubpd vsubps vsubsd vsubss vtestps vtestpd vucomisd vucomiss vunpckhpd vunpckhps vunpcklpd vunpcklps vxorpd vxorps vzeroall vzeroupper pclmullqlqdq pclmulhqlqdq pclmullqhqdq pclmulhqhqdq pclmulqdq vpclmullqlqdq vpclmulhqlqdq vpclmullqhqdq vpclmulhqhqdq vpclmulqdq vfmadd132ps vfmadd132pd vfmadd312ps vfmadd312pd vfmadd213ps vfmadd213pd vfmadd123ps vfmadd123pd vfmadd231ps vfmadd231pd vfmadd321ps vfmadd321pd vfmaddsub132ps vfmaddsub132pd vfmaddsub312ps vfmaddsub312pd vfmaddsub213ps vfmaddsub213pd vfmaddsub123ps vfmaddsub123pd vfmaddsub231ps vfmaddsub231pd vfmaddsub321ps vfmaddsub321pd vfmsub132ps vfmsub132pd vfmsub312ps vfmsub312pd vfmsub213ps vfmsub213pd vfmsub123ps vfmsub123pd vfmsub231ps vfmsub231pd vfmsub321ps vfmsub321pd vfmsubadd132ps vfmsubadd132pd vfmsubadd312ps vfmsubadd312pd vfmsubadd213ps vfmsubadd213pd vfmsubadd123ps vfmsubadd123pd vfmsubadd231ps vfmsubadd231pd vfmsubadd321ps vfmsubadd321pd vfnmadd132ps vfnmadd132pd vfnmadd312ps vfnmadd312pd vfnmadd213ps vfnmadd213pd vfnmadd123ps vfnmadd123pd vfnmadd231ps vfnmadd231pd vfnmadd321ps vfnmadd321pd vfnmsub132ps vfnmsub132pd vfnmsub312ps vfnmsub312pd vfnmsub213ps vfnmsub213pd vfnmsub123ps vfnmsub123pd vfnmsub231ps vfnmsub231pd vfnmsub321ps vfnmsub321pd vfmadd132ss vfmadd132sd vfmadd312ss vfmadd312sd vfmadd213ss vfmadd213sd vfmadd123ss vfmadd123sd vfmadd231ss vfmadd231sd vfmadd321ss vfmadd321sd vfmsub132ss vfmsub132sd vfmsub312ss vfmsub312sd vfmsub213ss vfmsub213sd vfmsub123ss vfmsub123sd vfmsub231ss vfmsub231sd vfmsub321ss vfmsub321sd vfnmadd132ss vfnmadd132sd vfnmadd312ss vfnmadd312sd vfnmadd213ss vfnmadd213sd vfnmadd123ss vfnmadd123sd vfnmadd231ss vfnmadd231sd vfnmadd321ss vfnmadd321sd vfnmsub132ss vfnmsub132sd vfnmsub312ss vfnmsub312sd vfnmsub213ss vfnmsub213sd vfnmsub123ss vfnmsub123sd vfnmsub231ss vfnmsub231sd vfnmsub321ss vfnmsub321sd rdfsbase rdgsbase rdrand wrfsbase wrgsbase vcvtph2ps vcvtps2ph adcx adox rdseed clac stac xstore xcryptecb xcryptcbc xcryptctr xcryptcfb xcryptofb montmul xsha1 xsha256 llwpcb slwpcb lwpval lwpins vfmaddpd vfmaddps vfmaddsd vfmaddss vfmaddsubpd vfmaddsubps vfmsubaddpd vfmsubaddps vfmsubpd vfmsubps vfmsubsd vfmsubss vfnmaddpd vfnmaddps vfnmaddsd vfnmaddss vfnmsubpd vfnmsubps vfnmsubsd vfnmsubss vfrczpd vfrczps vfrczsd vfrczss vpcmov vpcomb vpcomd vpcomq vpcomub vpcomud vpcomuq vpcomuw vpcomw vphaddbd vphaddbq vphaddbw vphadddq vphaddubd vphaddubq vphaddubw vphaddudq vphadduwd vphadduwq vphaddwd vphaddwq vphsubbw vphsubdq vphsubwd vpmacsdd vpmacsdqh vpmacsdql vpmacssdd vpmacssdqh vpmacssdql vpmacsswd vpmacssww vpmacswd vpmacsww vpmadcsswd vpmadcswd vpperm vprotb vprotd vprotq vprotw vpshab vpshad vpshaq vpshaw vpshlb vpshld vpshlq vpshlw vbroadcasti128 vpblendd vpbroadcastb vpbroadcastw vpbroadcastd vpbroadcastq vpermd vpermpd vpermps vpermq vperm2i128 vextracti128 vinserti128 vpmaskmovd vpmaskmovq vpsllvd vpsllvq vpsravd vpsrlvd vpsrlvq vgatherdpd vgatherqpd vgatherdps vgatherqps vpgatherdd vpgatherqd vpgatherdq vpgatherqq xabort xbegin xend xtest andn bextr blci blcic blsi blsic blcfill blsfill blcmsk blsmsk blsr blcs bzhi mulx pdep pext rorx sarx shlx shrx tzcnt tzmsk t1mskc valignd valignq vblendmpd vblendmps vbroadcastf32x4 vbroadcastf64x4 vbroadcasti32x4 vbroadcasti64x4 vcompresspd vcompressps vcvtpd2udq vcvtps2udq vcvtsd2usi vcvtss2usi vcvttpd2udq vcvttps2udq vcvttsd2usi vcvttss2usi vcvtudq2pd vcvtudq2ps vcvtusi2sd vcvtusi2ss vexpandpd vexpandps vextractf32x4 vextractf64x4 vextracti32x4 vextracti64x4 vfixupimmpd vfixupimmps vfixupimmsd vfixupimmss vgetexppd vgetexpps vgetexpsd vgetexpss vgetmantpd vgetmantps vgetmantsd vgetmantss vinsertf32x4 vinsertf64x4 vinserti32x4 vinserti64x4 vmovdqa32 vmovdqa64 vmovdqu32 vmovdqu64 vpabsq vpandd vpandnd vpandnq vpandq vpblendmd vpblendmq vpcmpltd vpcmpled vpcmpneqd vpcmpnltd vpcmpnled vpcmpd vpcmpltq vpcmpleq vpcmpneqq vpcmpnltq vpcmpnleq vpcmpq vpcmpequd vpcmpltud vpcmpleud vpcmpnequd vpcmpnltud vpcmpnleud vpcmpud vpcmpequq vpcmpltuq vpcmpleuq vpcmpnequq vpcmpnltuq vpcmpnleuq vpcmpuq vpcompressd vpcompressq vpermi2d vpermi2pd vpermi2ps vpermi2q vpermt2d vpermt2pd vpermt2ps vpermt2q vpexpandd vpexpandq vpmaxsq vpmaxuq vpminsq vpminuq vpmovdb vpmovdw vpmovqb vpmovqd vpmovqw vpmovsdb vpmovsdw vpmovsqb vpmovsqd vpmovsqw vpmovusdb vpmovusdw vpmovusqb vpmovusqd vpmovusqw vpord vporq vprold vprolq vprolvd vprolvq vprord vprorq vprorvd vprorvq vpscatterdd vpscatterdq vpscatterqd vpscatterqq vpsraq vpsravq vpternlogd vpternlogq vptestmd vptestmq vptestnmd vptestnmq vpxord vpxorq vrcp14pd vrcp14ps vrcp14sd vrcp14ss vrndscalepd vrndscaleps vrndscalesd vrndscaless vrsqrt14pd vrsqrt14ps vrsqrt14sd vrsqrt14ss vscalefpd vscalefps vscalefsd vscalefss vscatterdpd vscatterdps vscatterqpd vscatterqps vshuff32x4 vshuff64x2 vshufi32x4 vshufi64x2 kandnw kandw kmovw knotw kortestw korw kshiftlw kshiftrw kunpckbw kxnorw kxorw vpbroadcastmb2q vpbroadcastmw2d vpconflictd vpconflictq vplzcntd vplzcntq vexp2pd vexp2ps vrcp28pd vrcp28ps vrcp28sd vrcp28ss vrsqrt28pd vrsqrt28ps vrsqrt28sd vrsqrt28ss vgatherpf0dpd vgatherpf0dps vgatherpf0qpd vgatherpf0qps vgatherpf1dpd vgatherpf1dps vgatherpf1qpd vgatherpf1qps vscatterpf0dpd vscatterpf0dps vscatterpf0qpd vscatterpf0qps vscatterpf1dpd vscatterpf1dps vscatterpf1qpd vscatterpf1qps prefetchwt1 bndmk bndcl bndcu bndcn bndmov bndldx bndstx sha1rnds4 sha1nexte sha1msg1 sha1msg2 sha256rnds2 sha256msg1 sha256msg2 hint_nop0 hint_nop1 hint_nop2 hint_nop3 hint_nop4 hint_nop5 hint_nop6 hint_nop7 hint_nop8 hint_nop9 hint_nop10 hint_nop11 hint_nop12 hint_nop13 hint_nop14 hint_nop15 hint_nop16 hint_nop17 hint_nop18 hint_nop19 hint_nop20 hint_nop21 hint_nop22 hint_nop23 hint_nop24 hint_nop25 hint_nop26 hint_nop27 hint_nop28 hint_nop29 hint_nop30 hint_nop31 hint_nop32 hint_nop33 hint_nop34 hint_nop35 hint_nop36 hint_nop37 hint_nop38 hint_nop39 hint_nop40 hint_nop41 hint_nop42 hint_nop43 hint_nop44 hint_nop45 hint_nop46 hint_nop47 hint_nop48 hint_nop49 hint_nop50 hint_nop51 hint_nop52 hint_nop53 hint_nop54 hint_nop55 hint_nop56 hint_nop57 hint_nop58 hint_nop59 hint_nop60 hint_nop61 hint_nop62 hint_nop63",
literal:"ip eip rip al ah bl bh cl ch dl dh sil dil bpl spl r8b r9b r10b r11b r12b r13b r14b r15b ax bx cx dx si di bp sp r8w r9w r10w r11w r12w r13w r14w r15w eax ebx ecx edx esi edi ebp esp eip r8d r9d r10d r11d r12d r13d r14d r15d rax rbx rcx rdx rsi rdi rbp rsp r8 r9 r10 r11 r12 r13 r14 r15 cs ds es fs gs ss st st0 st1 st2 st3 st4 st5 st6 st7 mm0 mm1 mm2 mm3 mm4 mm5 mm6 mm7 xmm0  xmm1  xmm2  xmm3  xmm4  xmm5  xmm6  xmm7  xmm8  xmm9 xmm10  xmm11 xmm12 xmm13 xmm14 xmm15 xmm16 xmm17 xmm18 xmm19 xmm20 xmm21 xmm22 xmm23 xmm24 xmm25 xmm26 xmm27 xmm28 xmm29 xmm30 xmm31 ymm0  ymm1  ymm2  ymm3  ymm4  ymm5  ymm6  ymm7  ymm8  ymm9 ymm10  ymm11 ymm12 ymm13 ymm14 ymm15 ymm16 ymm17 ymm18 ymm19 ymm20 ymm21 ymm22 ymm23 ymm24 ymm25 ymm26 ymm27 ymm28 ymm29 ymm30 ymm31 zmm0  zmm1  zmm2  zmm3  zmm4  zmm5  zmm6  zmm7  zmm8  zmm9 zmm10  zmm11 zmm12 zmm13 zmm14 zmm15 zmm16 zmm17 zmm18 zmm19 zmm20 zmm21 zmm22 zmm23 zmm24 zmm25 zmm26 zmm27 zmm28 zmm29 zmm30 zmm31 k0 k1 k2 k3 k4 k5 k6 k7 bnd0 bnd1 bnd2 bnd3 cr0 cr1 cr2 cr3 cr4 cr8 dr0 dr1 dr2 dr3 dr8 tr3 tr4 tr5 tr6 tr7 r0 r1 r2 r3 r4 r5 r6 r7 r0b r1b r2b r3b r4b r5b r6b r7b r0w r1w r2w r3w r4w r5w r6w r7w r0d r1d r2d r3d r4d r5d r6d r7d r0h r1h r2h r3h r0l r1l r2l r3l r4l r5l r6l r7l r8l r9l r10l r11l r12l r13l r14l r15l",pseudo:"db dw dd dq dt ddq do dy dz resb resw resd resq rest resdq reso resy resz incbin equ times",preprocessor:"%define %xdefine %+ %undef %defstr %deftok %assign %strcat %strlen %substr %rotate %elif %else %endif %ifmacro %ifctx %ifidn %ifidni %ifid %ifnum %ifstr %iftoken %ifempty %ifenv %error %warning %fatal %rep %endrep %include %push %pop %repl %pathsearch %depend %use %arg %stacksize %local %line %comment %endcomment .nolist byte word dword qword nosplit rel abs seg wrt strict near far a32 ptr __FILE__ __LINE__ __SECT__  __BITS__ __OUTPUT_FORMAT__ __DATE__ __TIME__ __DATE_NUM__ __TIME_NUM__ __UTC_DATE__ __UTC_TIME__ __UTC_DATE_NUM__ __UTC_TIME_NUM__  __PASS__ struc endstruc istruc at iend align alignb sectalign daz nodaz up down zero default option assume public ",built_in:"bits use16 use32 use64 default section segment absolute extern global common cpu float __utf16__ __utf16le__ __utf16be__ __utf32__ __utf32le__ __utf32be__ __float8__ __float16__ __float32__ __float64__ __float80m__ __float80e__ __float128l__ __float128h__ __Infinity__ __QNaN__ __SNaN__ Inf NaN QNaN SNaN float8 float16 float32 float64 float80m float80e float128l float128h __FLOAT_DAZ__ __FLOAT_ROUND__ __FLOAT__"},contains:[hljs.COMMENT(";","$",{relevance:0}),{className:"number",variants:[{begin:"\\b(?:([0-9][0-9_]*)?\\.[0-9_]*(?:[eE][+-]?[0-9_]+)?|(0[Xx])?[0-9][0-9_]*\\.?[0-9_]*(?:[pP](?:[+-]?[0-9_]+)?)?)\\b",relevance:0},{begin:"\\$[0-9][0-9A-Fa-f]*",relevance:0},{begin:"\\b(?:[0-9A-Fa-f][0-9A-Fa-f_]*[Hh]|[0-9][0-9_]*[DdTt]?|[0-7][0-7_]*[QqOo]|[0-1][0-1_]*[BbYy])\\b"},{begin:"\\b(?:0[Xx][0-9A-Fa-f_]+|0[DdTt][0-9_]+|0[QqOo][0-7_]+|0[BbYy][0-1_]+)\\b"}]},hljs.QUOTE_STRING_MODE,{className:"string",variants:[{begin:"'",end:"[^\\\\]'"},{begin:"`",end:"[^\\\\]`"},{begin:"\\.[A-Za-z0-9]+"}],relevance:0},{className:"label",variants:[{begin:"^\\s*[A-Za-z._?][A-Za-z0-9_$#@~.?]*(:|\\s+label)"},{begin:"^\\s*%%[A-Za-z0-9_$#@~.?]*:"}],relevance:0},{className:"argument",begin:"%[0-9]+",relevance:0},{className:"built_in",begin:"%!S+",relevance:0}]}}),hljs.registerLanguage("xl",function(hljs){var BUILTIN_MODULES="ObjectLoader Animate MovieCredits Slides Filters Shading Materials LensFlare Mapping VLCAudioVideo StereoDecoder PointCloud NetworkAccess RemoteControl RegExp ChromaKey Snowfall NodeJS Speech Charts",XL_KEYWORDS={keyword:"if then else do while until for loop import with is as where when by data constant",literal:"true false nil",type:"integer real text name boolean symbol infix prefix postfix block tree",built_in:"in mod rem and or xor not abs sign floor ceil sqrt sin cos tan asin acos atan exp expm1 log log2 log10 log1p pi at",module:BUILTIN_MODULES,id:"text_length text_range text_find text_replace contains page slide basic_slide title_slide title subtitle fade_in fade_out fade_at clear_color color line_color line_width texture_wrap texture_transform texture scale_?x scale_?y scale_?z? translate_?x translate_?y translate_?z? rotate_?x rotate_?y rotate_?z? rectangle circle ellipse sphere path line_to move_to quad_to curve_to theme background contents locally time mouse_?x mouse_?y mouse_buttons"},XL_CONSTANT={className:"constant",begin:"[A-Z][A-Z_0-9]+",relevance:0},XL_VARIABLE={className:"variable",begin:"([A-Z][a-z_0-9]+)+",relevance:0},XL_ID={className:"id",begin:"[a-z][a-z_0-9]+",relevance:0},DOUBLE_QUOTE_TEXT={className:"string",begin:'"',end:'"',illegal:"\\n"},SINGLE_QUOTE_TEXT={className:"string",begin:"'",end:"'",illegal:"\\n"},LONG_TEXT={className:"string",begin:"<<",end:">>"},BASED_NUMBER={className:"number",begin:"[0-9]+#[0-9A-Z_]+(\\.[0-9-A-Z_]+)?#?([Ee][+-]?[0-9]+)?",relevance:10},IMPORT={className:"import",beginKeywords:"import",end:"$",keywords:{keyword:"import",module:BUILTIN_MODULES},relevance:0,contains:[DOUBLE_QUOTE_TEXT]},FUNCTION_DEFINITION={className:"function",begin:"[a-z].*->"};return{aliases:["tao"],lexemes:/[a-zA-Z][a-zA-Z0-9_?]*/,keywords:XL_KEYWORDS,contains:[hljs.C_LINE_COMMENT_MODE,hljs.C_BLOCK_COMMENT_MODE,DOUBLE_QUOTE_TEXT,SINGLE_QUOTE_TEXT,LONG_TEXT,FUNCTION_DEFINITION,IMPORT,XL_CONSTANT,XL_VARIABLE,XL_ID,BASED_NUMBER,hljs.NUMBER_MODE]}}),hljs.registerLanguage("xquery",function(hljs){var KEYWORDS="for let if while then else return where group by xquery encoding versionmodule namespace boundary-space preserve strip default collation base-uri orderingcopy-namespaces order declare import schema namespace function option in allowing emptyat tumbling window sliding window start when only end when previous next stable ascendingdescending empty greatest least some every satisfies switch case typeswitch try catch andor to union intersect instance of treat as castable cast map array delete insert intoreplace value rename copy modify update",LITERAL="false true xs:string xs:integer element item xs:date xs:datetime xs:float xs:double xs:decimal QName xs:anyURI xs:long xs:int xs:short xs:byte attribute",VAR={className:"variable",begin:/\$[a-zA-Z0-9\-]+/,relevance:5},NUMBER={className:"number",begin:"(\\b0[0-7_]+)|(\\b0x[0-9a-fA-F_]+)|(\\b[1-9][0-9_]*(\\.[0-9_]+)?)|[0_]\\b",relevance:0},STRING={className:"string",variants:[{begin:/"/,end:/"/,contains:[{begin:/""/,relevance:0}]},{begin:/'/,end:/'/,contains:[{begin:/''/,relevance:0}]}]},ANNOTATION={className:"decorator",begin:"%\\w+"},COMMENT={className:"comment",begin:"\\(:",end:":\\)",relevance:10,contains:[{className:"doc",begin:"@\\w+"}]},METHOD={begin:"{",end:"}"},CONTAINS=[VAR,STRING,NUMBER,COMMENT,ANNOTATION,METHOD];return METHOD.contains=CONTAINS,{aliases:["xpath","xq"],case_insensitive:!1,lexemes:/[a-zA-Z\$][a-zA-Z0-9_:\-]*/,illegal:/(proc)|(abstract)|(extends)|(until)|(#)/,keywords:{keyword:KEYWORDS,literal:LITERAL},contains:CONTAINS}}),hljs.registerLanguage("zephir",function(hljs){var STRING={className:"string",contains:[hljs.BACKSLASH_ESCAPE],variants:[{begin:'b"',end:'"'},{begin:"b'",end:"'"},hljs.inherit(hljs.APOS_STRING_MODE,{illegal:null}),hljs.inherit(hljs.QUOTE_STRING_MODE,{illegal:null})]},NUMBER={variants:[hljs.BINARY_NUMBER_MODE,hljs.C_NUMBER_MODE]};return{aliases:["zep"],case_insensitive:!0,keywords:"and include_once list abstract global private echo interface as static endswitch array null if endwhile or const for endforeach self var let while isset public protected exit foreach throw elseif include __FILE__ empty require_once do xor return parent clone use __CLASS__ __LINE__ else break print eval new catch __METHOD__ case exception default die require __FUNCTION__ enddeclare final try switch continue endfor endif declare unset true false trait goto instanceof insteadof __DIR__ __NAMESPACE__ yield finally int uint long ulong char uchar double float bool boolean stringlikely unlikely",contains:[hljs.C_LINE_COMMENT_MODE,hljs.HASH_COMMENT_MODE,hljs.COMMENT("/\\*","\\*/",{contains:[{className:"doctag",begin:"@[A-Za-z]+"}]}),hljs.COMMENT("__halt_compiler.+?;",!1,{endsWithParent:!0,keywords:"__halt_compiler",lexemes:hljs.UNDERSCORE_IDENT_RE}),{className:"string",begin:"<<<['\"]?\\w+['\"]?$",end:"^\\w+;",contains:[hljs.BACKSLASH_ESCAPE]},{begin:/(::|->)+[a-zA-Z_\x7f-\xff][a-zA-Z0-9_\x7f-\xff]*/},{className:"function",beginKeywords:"function",end:/[;{]/,excludeEnd:!0,illegal:"\\$|\\[|%",contains:[hljs.UNDERSCORE_TITLE_MODE,{className:"params",begin:"\\(",end:"\\)",contains:["self",hljs.C_BLOCK_COMMENT_MODE,STRING,NUMBER]}]},{className:"class",beginKeywords:"class interface",end:"{",excludeEnd:!0,illegal:/[:\(\$"]/,contains:[{beginKeywords:"extends implements"},hljs.UNDERSCORE_TITLE_MODE]},{beginKeywords:"namespace",end:";",illegal:/[\.']/,contains:[hljs.UNDERSCORE_TITLE_MODE]},{beginKeywords:"use",end:";",contains:[hljs.UNDERSCORE_TITLE_MODE]},{begin:"=>"},STRING,NUMBER]}}),hljs}),function(){function createShiftArr(step){var space="    ";if(isNaN(parseInt(step)))space=step;else switch(step){case 1:space=" ";break;case 2:space="  ";break;case 3:space="   ";break;case 4:space="    ";break;case 5:space="     ";break;case 6:space="      ";break;case 7:space="       ";break;case 8:space="        ";break;case 9:space="         ";break;case 10:space="          ";break;case 11:space="           ";break;case 12:space="            "}var shift=["\n"];for(ix=0;ix<100;ix++)shift.push(shift[ix]+space);return shift}function vkbeautify(){this.step="    ",this.shift=createShiftArr(this.step)}function isSubquery(str,parenthesisLevel){return parenthesisLevel-(str.replace(/\(/g,"").length-str.replace(/\)/g,"").length)}function split_sql(str,tab){return str.replace(/\s{1,}/g," ").replace(/ AND /gi,"~::~"+tab+tab+"AND ").replace(/ BETWEEN /gi,"~::~"+tab+"BETWEEN ").replace(/ CASE /gi,"~::~"+tab+"CASE ").replace(/ ELSE /gi,"~::~"+tab+"ELSE ").replace(/ END /gi,"~::~"+tab+"END ").replace(/ FROM /gi,"~::~FROM ").replace(/ GROUP\s{1,}BY/gi,"~::~GROUP BY ").replace(/ HAVING /gi,"~::~HAVING ").replace(/ IN /gi," IN ").replace(/ JOIN /gi,"~::~JOIN ").replace(/ CROSS~::~{1,}JOIN /gi,"~::~CROSS JOIN ").replace(/ INNER~::~{1,}JOIN /gi,"~::~INNER JOIN ").replace(/ LEFT~::~{1,}JOIN /gi,"~::~LEFT JOIN ").replace(/ RIGHT~::~{1,}JOIN /gi,"~::~RIGHT JOIN ").replace(/ ON /gi,"~::~"+tab+"ON ").replace(/ OR /gi,"~::~"+tab+tab+"OR ").replace(/ ORDER\s{1,}BY/gi,"~::~ORDER BY ").replace(/ OVER /gi,"~::~"+tab+"OVER ").replace(/\(\s{0,}SELECT /gi,"~::~(SELECT ").replace(/\)\s{0,}SELECT /gi,")~::~SELECT ").replace(/ THEN /gi," THEN~::~"+tab).replace(/ UNION /gi,"~::~UNION~::~").replace(/ USING /gi,"~::~USING ").replace(/ WHEN /gi,"~::~"+tab+"WHEN ").replace(/ WHERE /gi,"~::~WHERE ").replace(/ WITH /gi,"~::~WITH ").replace(/ ALL /gi," ALL ").replace(/ AS /gi," AS ").replace(/ ASC /gi," ASC ").replace(/ DESC /gi," DESC ").replace(/ DISTINCT /gi," DISTINCT ").replace(/ EXISTS /gi," EXISTS ").replace(/ NOT /gi," NOT ").replace(/ NULL /gi," NULL ").replace(/ LIKE /gi," LIKE ").replace(/\s{0,}SELECT /gi,"SELECT ").replace(/\s{0,}UPDATE /gi,"UPDATE ").replace(/ SET /gi," SET ").replace(/~::~{1,}/g,"~::~").split("~::~")}vkbeautify.prototype.xml=function(text,step){var ar=text.replace(/>\s{0,}</g,"><").replace(/</g,"~::~<").replace(/\s*xmlns\:/g,"~::~xmlns:").replace(/\s*xmlns\=/g,"~::~xmlns=").split("~::~"),len=ar.length,inComment=!1,deep=0,str="",ix=0,shift=step?createShiftArr(step):this.shift;for(ix=0;len>ix;ix++)ar[ix].search(/<!/)>-1?(str+=shift[deep]+ar[ix],inComment=!0,(ar[ix].search(/-->/)>-1||ar[ix].search(/\]>/)>-1||ar[ix].search(/!DOCTYPE/)>-1)&&(inComment=!1)):ar[ix].search(/-->/)>-1||ar[ix].search(/\]>/)>-1?(str+=ar[ix],inComment=!1):/^<\w/.exec(ar[ix-1])&&/^<\/\w/.exec(ar[ix])&&/^<[\w:\-\.\,]+/.exec(ar[ix-1])==/^<\/[\w:\-\.\,]+/.exec(ar[ix])[0].replace("/","")?(str+=ar[ix],inComment||deep--):ar[ix].search(/<\w/)>-1&&-1==ar[ix].search(/<\//)&&-1==ar[ix].search(/\/>/)?str=str+=inComment?ar[ix]:shift[deep++]+ar[ix]:ar[ix].search(/<\w/)>-1&&ar[ix].search(/<\//)>-1?str=str+=inComment?ar[ix]:shift[deep]+ar[ix]:ar[ix].search(/<\//)>-1?str=str+=inComment?ar[ix]:shift[--deep]+ar[ix]:ar[ix].search(/\/>/)>-1?str=str+=inComment?ar[ix]:shift[deep]+ar[ix]:str+=ar[ix].search(/<\?/)>-1?shift[deep]+ar[ix]:ar[ix].search(/xmlns\:/)>-1||ar[ix].search(/xmlns\=/)>-1?shift[deep]+ar[ix]:ar[ix];return"\n"==str[0]?str.slice(1):str},vkbeautify.prototype.json=function(text,step){var step=step?step:this.step;return"undefined"==typeof JSON?text:"string"==typeof text?JSON.stringify(JSON.parse(text),null,step):"object"==typeof text?JSON.stringify(text,null,step):text},vkbeautify.prototype.css=function(text,step){var ar=text.replace(/\s{1,}/g," ").replace(/\{/g,"{~::~").replace(/\}/g,"~::~}~::~").replace(/\;/g,";~::~").replace(/\/\*/g,"~::~/*").replace(/\*\//g,"*/~::~").replace(/~::~\s{0,}~::~/g,"~::~").split("~::~"),len=ar.length,deep=0,str="",ix=0,shift=step?createShiftArr(step):this.shift;for(ix=0;len>ix;ix++)str+=/\{/.exec(ar[ix])?shift[deep++]+ar[ix]:/\}/.exec(ar[ix])?shift[--deep]+ar[ix]:/\*\\/.exec(ar[ix])?shift[deep]+ar[ix]:shift[deep]+ar[ix];return str.replace(/^\n{1,}/,"")},vkbeautify.prototype.sql=function(text,step){var ar_by_quote=text.replace(/\s{1,}/g," ").replace(/\'/gi,"~::~'").split("~::~"),len=ar_by_quote.length,ar=[],deep=0,tab=this.step,parenthesisLevel=0,str="",ix=0,shift=step?createShiftArr(step):this.shift;for(ix=0;len>ix;ix++)ar=ix%2?ar.concat(ar_by_quote[ix]):ar.concat(split_sql(ar_by_quote[ix],tab));for(len=ar.length,ix=0;len>ix;ix++){parenthesisLevel=isSubquery(ar[ix],parenthesisLevel),/\s{0,}\s{0,}SELECT\s{0,}/.exec(ar[ix])&&(ar[ix]=ar[ix].replace(/\,/g,",\n"+tab+tab)),/\s{0,}\s{0,}SET\s{0,}/.exec(ar[ix])&&(ar[ix]=ar[ix].replace(/\,/g,",\n"+tab+tab)),/\s{0,}\(\s{0,}SELECT\s{0,}/.exec(ar[ix])?(deep++,str+=shift[deep]+ar[ix]):/\'/.exec(ar[ix])?(1>parenthesisLevel&&deep&&deep--,str+=ar[ix]):(str+=shift[deep]+ar[ix],1>parenthesisLevel&&deep&&deep--)}return str=str.replace(/^\n{1,}/,"").replace(/\n{1,}/g,"\n")},vkbeautify.prototype.xmlmin=function(text,preserveComments){var str=preserveComments?text:text.replace(/\<![ \r\n\t]*(--([^\-]|[\r\n]|-[^\-])*--[ \r\n\t]*)\>/g,"").replace(/[ \r\n\t]{1,}xmlns/g," xmlns");return str.replace(/>\s{0,}</g,"><")},vkbeautify.prototype.jsonmin=function(text){return"undefined"==typeof JSON?text:JSON.stringify(JSON.parse(text),null,0)},vkbeautify.prototype.cssmin=function(text,preserveComments){var str=preserveComments?text:text.replace(/\/\*([^*]|[\r\n]|(\*+([^*\/]|[\r\n])))*\*+\//g,"");return str.replace(/\s{1,}/g," ").replace(/\{\s{1,}/g,"{").replace(/\}\s{1,}/g,"}").replace(/\;\s{1,}/g,";").replace(/\/\*\s{1,}/g,"/*").replace(/\*\/\s{1,}/g,"*/")},vkbeautify.prototype.sqlmin=function(text){return text.replace(/\s{1,}/g," ").replace(/\s{1,}\(/,"(").replace(/\s{1,}\)/,")")},window.vkbeautify=new vkbeautify}(),function(global,factory){"object"==typeof module&&"object"==typeof module.exports?module.exports=global.document?factory(global,!0):function(w){if(!w.document)throw new Error("jQuery requires a window with a document");return factory(w)}:factory(global)}("undefined"!=typeof window?window:this,function(window,noGlobal){function isArraylike(obj){var length="length"in obj&&obj.length,type=jQuery.type(obj);return"function"===type||jQuery.isWindow(obj)?!1:1===obj.nodeType&&length?!0:"array"===type||0===length||"number"==typeof length&&length>0&&length-1 in obj}function winnow(elements,qualifier,not){if(jQuery.isFunction(qualifier))return jQuery.grep(elements,function(elem,i){return!!qualifier.call(elem,i,elem)!==not});if(qualifier.nodeType)return jQuery.grep(elements,function(elem){return elem===qualifier!==not});if("string"==typeof qualifier){if(risSimple.test(qualifier))return jQuery.filter(qualifier,elements,not);qualifier=jQuery.filter(qualifier,elements)}return jQuery.grep(elements,function(elem){return indexOf.call(qualifier,elem)>=0!==not})}function sibling(cur,dir){for(;(cur=cur[dir])&&1!==cur.nodeType;);return cur}function createOptions(options){var object=optionsCache[options]={};return jQuery.each(options.match(rnotwhite)||[],function(_,flag){object[flag]=!0}),object}function completed(){document.removeEventListener("DOMContentLoaded",completed,!1),window.removeEventListener("load",completed,!1),jQuery.ready()}function Data(){Object.defineProperty(this.cache={},0,{get:function(){return{}}}),this.expando=jQuery.expando+Data.uid++}function dataAttr(elem,key,data){var name;if(void 0===data&&1===elem.nodeType)if(name="data-"+key.replace(rmultiDash,"-$1").toLowerCase(),data=elem.getAttribute(name),"string"==typeof data){try{data="true"===data?!0:"false"===data?!1:"null"===data?null:+data+""===data?+data:rbrace.test(data)?jQuery.parseJSON(data):data}catch(e){}data_user.set(elem,key,data)}else data=void 0;return data}function returnTrue(){return!0}function returnFalse(){return!1}function safeActiveElement(){try{return document.activeElement}catch(err){}}function manipulationTarget(elem,content){return jQuery.nodeName(elem,"table")&&jQuery.nodeName(11!==content.nodeType?content:content.firstChild,"tr")?elem.getElementsByTagName("tbody")[0]||elem.appendChild(elem.ownerDocument.createElement("tbody")):elem}function disableScript(elem){return elem.type=(null!==elem.getAttribute("type"))+"/"+elem.type,elem}function restoreScript(elem){var match=rscriptTypeMasked.exec(elem.type);return match?elem.type=match[1]:elem.removeAttribute("type"),elem}function setGlobalEval(elems,refElements){for(var i=0,l=elems.length;l>i;i++)data_priv.set(elems[i],"globalEval",!refElements||data_priv.get(refElements[i],"globalEval"))}function cloneCopyEvent(src,dest){var i,l,type,pdataOld,pdataCur,udataOld,udataCur,events;if(1===dest.nodeType){if(data_priv.hasData(src)&&(pdataOld=data_priv.access(src),pdataCur=data_priv.set(dest,pdataOld),events=pdataOld.events)){delete pdataCur.handle,pdataCur.events={};for(type in events)for(i=0,l=events[type].length;l>i;i++)jQuery.event.add(dest,type,events[type][i])}data_user.hasData(src)&&(udataOld=data_user.access(src),udataCur=jQuery.extend({},udataOld),data_user.set(dest,udataCur))}}function getAll(context,tag){var ret=context.getElementsByTagName?context.getElementsByTagName(tag||"*"):context.querySelectorAll?context.querySelectorAll(tag||"*"):[];return void 0===tag||tag&&jQuery.nodeName(context,tag)?jQuery.merge([context],ret):ret}function fixInput(src,dest){var nodeName=dest.nodeName.toLowerCase();"input"===nodeName&&rcheckableType.test(src.type)?dest.checked=src.checked:("input"===nodeName||"textarea"===nodeName)&&(dest.defaultValue=src.defaultValue)}function actualDisplay(name,doc){var style,elem=jQuery(doc.createElement(name)).appendTo(doc.body),display=window.getDefaultComputedStyle&&(style=window.getDefaultComputedStyle(elem[0]))?style.display:jQuery.css(elem[0],"display");return elem.detach(),display}function defaultDisplay(nodeName){var doc=document,display=elemdisplay[nodeName];return display||(display=actualDisplay(nodeName,doc),"none"!==display&&display||(iframe=(iframe||jQuery("<iframe frameborder='0' width='0' height='0'/>")).appendTo(doc.documentElement),doc=iframe[0].contentDocument,doc.write(),doc.close(),display=actualDisplay(nodeName,doc),iframe.detach()),elemdisplay[nodeName]=display),display}function curCSS(elem,name,computed){var width,minWidth,maxWidth,ret,style=elem.style;return computed=computed||getStyles(elem),computed&&(ret=computed.getPropertyValue(name)||computed[name]),computed&&(""!==ret||jQuery.contains(elem.ownerDocument,elem)||(ret=jQuery.style(elem,name)),rnumnonpx.test(ret)&&rmargin.test(name)&&(width=style.width,minWidth=style.minWidth,maxWidth=style.maxWidth,style.minWidth=style.maxWidth=style.width=ret,ret=computed.width,style.width=width,style.minWidth=minWidth,style.maxWidth=maxWidth)),void 0!==ret?ret+"":ret}function addGetHookIf(conditionFn,hookFn){return{get:function(){return conditionFn()?void delete this.get:(this.get=hookFn).apply(this,arguments)}}}function vendorPropName(style,name){if(name in style)return name;for(var capName=name[0].toUpperCase()+name.slice(1),origName=name,i=cssPrefixes.length;i--;)if(name=cssPrefixes[i]+capName,name in style)return name;return origName}function setPositiveNumber(elem,value,subtract){var matches=rnumsplit.exec(value);return matches?Math.max(0,matches[1]-(subtract||0))+(matches[2]||"px"):value}function augmentWidthOrHeight(elem,name,extra,isBorderBox,styles){for(var i=extra===(isBorderBox?"border":"content")?4:"width"===name?1:0,val=0;4>i;i+=2)"margin"===extra&&(val+=jQuery.css(elem,extra+cssExpand[i],!0,styles)),isBorderBox?("content"===extra&&(val-=jQuery.css(elem,"padding"+cssExpand[i],!0,styles)),"margin"!==extra&&(val-=jQuery.css(elem,"border"+cssExpand[i]+"Width",!0,styles))):(val+=jQuery.css(elem,"padding"+cssExpand[i],!0,styles),"padding"!==extra&&(val+=jQuery.css(elem,"border"+cssExpand[i]+"Width",!0,styles)));return val}function getWidthOrHeight(elem,name,extra){var valueIsBorderBox=!0,val="width"===name?elem.offsetWidth:elem.offsetHeight,styles=getStyles(elem),isBorderBox="border-box"===jQuery.css(elem,"boxSizing",!1,styles);if(0>=val||null==val){if(val=curCSS(elem,name,styles),(0>val||null==val)&&(val=elem.style[name]),rnumnonpx.test(val))return val;valueIsBorderBox=isBorderBox&&(support.boxSizingReliable()||val===elem.style[name]),val=parseFloat(val)||0}return val+augmentWidthOrHeight(elem,name,extra||(isBorderBox?"border":"content"),valueIsBorderBox,styles)+"px"}function showHide(elements,show){for(var display,elem,hidden,values=[],index=0,length=elements.length;length>index;index++)elem=elements[index],elem.style&&(values[index]=data_priv.get(elem,"olddisplay"),display=elem.style.display,show?(values[index]||"none"!==display||(elem.style.display=""),""===elem.style.display&&isHidden(elem)&&(values[index]=data_priv.access(elem,"olddisplay",defaultDisplay(elem.nodeName)))):(hidden=isHidden(elem),"none"===display&&hidden||data_priv.set(elem,"olddisplay",hidden?display:jQuery.css(elem,"display"))));for(index=0;length>index;index++)elem=elements[index],elem.style&&(show&&"none"!==elem.style.display&&""!==elem.style.display||(elem.style.display=show?values[index]||"":"none"));return elements}function Tween(elem,options,prop,end,easing){return new Tween.prototype.init(elem,options,prop,end,easing)}function createFxNow(){return setTimeout(function(){fxNow=void 0}),fxNow=jQuery.now()}function genFx(type,includeWidth){var which,i=0,attrs={height:type};for(includeWidth=includeWidth?1:0;4>i;i+=2-includeWidth)which=cssExpand[i],attrs["margin"+which]=attrs["padding"+which]=type;return includeWidth&&(attrs.opacity=attrs.width=type),attrs}function createTween(value,prop,animation){for(var tween,collection=(tweeners[prop]||[]).concat(tweeners["*"]),index=0,length=collection.length;length>index;index++)if(tween=collection[index].call(animation,prop,value))return tween}function defaultPrefilter(elem,props,opts){var prop,value,toggle,tween,hooks,oldfire,display,checkDisplay,anim=this,orig={},style=elem.style,hidden=elem.nodeType&&isHidden(elem),dataShow=data_priv.get(elem,"fxshow");opts.queue||(hooks=jQuery._queueHooks(elem,"fx"),null==hooks.unqueued&&(hooks.unqueued=0,oldfire=hooks.empty.fire,hooks.empty.fire=function(){hooks.unqueued||oldfire()}),hooks.unqueued++,anim.always(function(){anim.always(function(){hooks.unqueued--,jQuery.queue(elem,"fx").length||hooks.empty.fire()})})),1===elem.nodeType&&("height"in props||"width"in props)&&(opts.overflow=[style.overflow,style.overflowX,style.overflowY],display=jQuery.css(elem,"display"),checkDisplay="none"===display?data_priv.get(elem,"olddisplay")||defaultDisplay(elem.nodeName):display,"inline"===checkDisplay&&"none"===jQuery.css(elem,"float")&&(style.display="inline-block")),opts.overflow&&(style.overflow="hidden",anim.always(function(){style.overflow=opts.overflow[0],style.overflowX=opts.overflow[1],style.overflowY=opts.overflow[2]}));for(prop in props)if(value=props[prop],rfxtypes.exec(value)){if(delete props[prop],toggle=toggle||"toggle"===value,value===(hidden?"hide":"show")){if("show"!==value||!dataShow||void 0===dataShow[prop])continue;hidden=!0}orig[prop]=dataShow&&dataShow[prop]||jQuery.style(elem,prop)}else display=void 0;if(jQuery.isEmptyObject(orig))"inline"===("none"===display?defaultDisplay(elem.nodeName):display)&&(style.display=display);else{dataShow?"hidden"in dataShow&&(hidden=dataShow.hidden):dataShow=data_priv.access(elem,"fxshow",{}),toggle&&(dataShow.hidden=!hidden),hidden?jQuery(elem).show():anim.done(function(){jQuery(elem).hide()}),anim.done(function(){var prop;data_priv.remove(elem,"fxshow");for(prop in orig)jQuery.style(elem,prop,orig[prop])});for(prop in orig)tween=createTween(hidden?dataShow[prop]:0,prop,anim),prop in dataShow||(dataShow[prop]=tween.start,hidden&&(tween.end=tween.start,tween.start="width"===prop||"height"===prop?1:0))}}function propFilter(props,specialEasing){var index,name,easing,value,hooks;for(index in props)if(name=jQuery.camelCase(index),easing=specialEasing[name],value=props[index],jQuery.isArray(value)&&(easing=value[1],value=props[index]=value[0]),index!==name&&(props[name]=value,delete props[index]),hooks=jQuery.cssHooks[name],hooks&&"expand"in hooks){value=hooks.expand(value),delete props[name];for(index in value)index in props||(props[index]=value[index],specialEasing[index]=easing)}else specialEasing[name]=easing}function Animation(elem,properties,options){var result,stopped,index=0,length=animationPrefilters.length,deferred=jQuery.Deferred().always(function(){delete tick.elem}),tick=function(){if(stopped)return!1;for(var currentTime=fxNow||createFxNow(),remaining=Math.max(0,animation.startTime+animation.duration-currentTime),temp=remaining/animation.duration||0,percent=1-temp,index=0,length=animation.tweens.length;length>index;index++)animation.tweens[index].run(percent);return deferred.notifyWith(elem,[animation,percent,remaining]),1>percent&&length?remaining:(deferred.resolveWith(elem,[animation]),!1)},animation=deferred.promise({elem:elem,props:jQuery.extend({},properties),opts:jQuery.extend(!0,{specialEasing:{}},options),originalProperties:properties,originalOptions:options,startTime:fxNow||createFxNow(),duration:options.duration,tweens:[],createTween:function(prop,end){var tween=jQuery.Tween(elem,animation.opts,prop,end,animation.opts.specialEasing[prop]||animation.opts.easing);return animation.tweens.push(tween),tween},stop:function(gotoEnd){var index=0,length=gotoEnd?animation.tweens.length:0;if(stopped)return this;for(stopped=!0;length>index;index++)animation.tweens[index].run(1);return gotoEnd?deferred.resolveWith(elem,[animation,gotoEnd]):deferred.rejectWith(elem,[animation,gotoEnd]),this}}),props=animation.props;for(propFilter(props,animation.opts.specialEasing);length>index;index++)if(result=animationPrefilters[index].call(animation,elem,props,animation.opts))return result;return jQuery.map(props,createTween,animation),jQuery.isFunction(animation.opts.start)&&animation.opts.start.call(elem,animation),jQuery.fx.timer(jQuery.extend(tick,{elem:elem,anim:animation,queue:animation.opts.queue})),animation.progress(animation.opts.progress).done(animation.opts.done,animation.opts.complete).fail(animation.opts.fail).always(animation.opts.always)}function addToPrefiltersOrTransports(structure){return function(dataTypeExpression,func){"string"!=typeof dataTypeExpression&&(func=dataTypeExpression,dataTypeExpression="*");var dataType,i=0,dataTypes=dataTypeExpression.toLowerCase().match(rnotwhite)||[];if(jQuery.isFunction(func))for(;dataType=dataTypes[i++];)"+"===dataType[0]?(dataType=dataType.slice(1)||"*",(structure[dataType]=structure[dataType]||[]).unshift(func)):(structure[dataType]=structure[dataType]||[]).push(func)}}function inspectPrefiltersOrTransports(structure,options,originalOptions,jqXHR){function inspect(dataType){var selected;return inspected[dataType]=!0,jQuery.each(structure[dataType]||[],function(_,prefilterOrFactory){var dataTypeOrTransport=prefilterOrFactory(options,originalOptions,jqXHR);return"string"!=typeof dataTypeOrTransport||seekingTransport||inspected[dataTypeOrTransport]?seekingTransport?!(selected=dataTypeOrTransport):void 0:(options.dataTypes.unshift(dataTypeOrTransport),inspect(dataTypeOrTransport),!1)}),selected}var inspected={},seekingTransport=structure===transports;return inspect(options.dataTypes[0])||!inspected["*"]&&inspect("*")}function ajaxExtend(target,src){var key,deep,flatOptions=jQuery.ajaxSettings.flatOptions||{};for(key in src)void 0!==src[key]&&((flatOptions[key]?target:deep||(deep={}))[key]=src[key]);return deep&&jQuery.extend(!0,target,deep),target}function ajaxHandleResponses(s,jqXHR,responses){for(var ct,type,finalDataType,firstDataType,contents=s.contents,dataTypes=s.dataTypes;"*"===dataTypes[0];)dataTypes.shift(),void 0===ct&&(ct=s.mimeType||jqXHR.getResponseHeader("Content-Type"));if(ct)for(type in contents)if(contents[type]&&contents[type].test(ct)){dataTypes.unshift(type);break}if(dataTypes[0]in responses)finalDataType=dataTypes[0];else{for(type in responses){if(!dataTypes[0]||s.converters[type+" "+dataTypes[0]]){finalDataType=type;break}firstDataType||(firstDataType=type)}finalDataType=finalDataType||firstDataType}return finalDataType?(finalDataType!==dataTypes[0]&&dataTypes.unshift(finalDataType),responses[finalDataType]):void 0}function ajaxConvert(s,response,jqXHR,isSuccess){var conv2,current,conv,tmp,prev,converters={},dataTypes=s.dataTypes.slice();if(dataTypes[1])for(conv in s.converters)converters[conv.toLowerCase()]=s.converters[conv];for(current=dataTypes.shift();current;)if(s.responseFields[current]&&(jqXHR[s.responseFields[current]]=response),!prev&&isSuccess&&s.dataFilter&&(response=s.dataFilter(response,s.dataType)),prev=current,current=dataTypes.shift())if("*"===current)current=prev;else if("*"!==prev&&prev!==current){if(conv=converters[prev+" "+current]||converters["* "+current],!conv)for(conv2 in converters)if(tmp=conv2.split(" "),tmp[1]===current&&(conv=converters[prev+" "+tmp[0]]||converters["* "+tmp[0]])){conv===!0?conv=converters[conv2]:converters[conv2]!==!0&&(current=tmp[0],dataTypes.unshift(tmp[1]));break}if(conv!==!0)if(conv&&s["throws"])response=conv(response);else try{response=conv(response)}catch(e){return{state:"parsererror",error:conv?e:"No conversion from "+prev+" to "+current}}}return{state:"success",data:response}}function buildParams(prefix,obj,traditional,add){var name;if(jQuery.isArray(obj))jQuery.each(obj,function(i,v){traditional||rbracket.test(prefix)?add(prefix,v):buildParams(prefix+"["+("object"==typeof v?i:"")+"]",v,traditional,add)});else if(traditional||"object"!==jQuery.type(obj))add(prefix,obj);else for(name in obj)buildParams(prefix+"["+name+"]",obj[name],traditional,add)}function getWindow(elem){return jQuery.isWindow(elem)?elem:9===elem.nodeType&&elem.defaultView}var arr=[],slice=arr.slice,concat=arr.concat,push=arr.push,indexOf=arr.indexOf,class2type={},toString=class2type.toString,hasOwn=class2type.hasOwnProperty,support={},document=window.document,version="2.1.4",jQuery=function(selector,context){return new jQuery.fn.init(selector,context)},rtrim=/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g,rmsPrefix=/^-ms-/,rdashAlpha=/-([\da-z])/gi,fcamelCase=function(all,letter){return letter.toUpperCase()};jQuery.fn=jQuery.prototype={jquery:version,constructor:jQuery,selector:"",length:0,toArray:function(){return slice.call(this)},get:function(num){return null!=num?0>num?this[num+this.length]:this[num]:slice.call(this)},pushStack:function(elems){var ret=jQuery.merge(this.constructor(),elems);return ret.prevObject=this,ret.context=this.context,ret},each:function(callback,args){return jQuery.each(this,callback,args)},map:function(callback){return this.pushStack(jQuery.map(this,function(elem,i){return callback.call(elem,i,elem)}))},slice:function(){return this.pushStack(slice.apply(this,arguments))},first:function(){return this.eq(0)},last:function(){return this.eq(-1)},eq:function(i){var len=this.length,j=+i+(0>i?len:0);
return this.pushStack(j>=0&&len>j?[this[j]]:[])},end:function(){return this.prevObject||this.constructor(null)},push:push,sort:arr.sort,splice:arr.splice},jQuery.extend=jQuery.fn.extend=function(){var options,name,src,copy,copyIsArray,clone,target=arguments[0]||{},i=1,length=arguments.length,deep=!1;for("boolean"==typeof target&&(deep=target,target=arguments[i]||{},i++),"object"==typeof target||jQuery.isFunction(target)||(target={}),i===length&&(target=this,i--);length>i;i++)if(null!=(options=arguments[i]))for(name in options)src=target[name],copy=options[name],target!==copy&&(deep&&copy&&(jQuery.isPlainObject(copy)||(copyIsArray=jQuery.isArray(copy)))?(copyIsArray?(copyIsArray=!1,clone=src&&jQuery.isArray(src)?src:[]):clone=src&&jQuery.isPlainObject(src)?src:{},target[name]=jQuery.extend(deep,clone,copy)):void 0!==copy&&(target[name]=copy));return target},jQuery.extend({expando:"jQuery"+(version+Math.random()).replace(/\D/g,""),isReady:!0,error:function(msg){throw new Error(msg)},noop:function(){},isFunction:function(obj){return"function"===jQuery.type(obj)},isArray:Array.isArray,isWindow:function(obj){return null!=obj&&obj===obj.window},isNumeric:function(obj){return!jQuery.isArray(obj)&&obj-parseFloat(obj)+1>=0},isPlainObject:function(obj){return"object"!==jQuery.type(obj)||obj.nodeType||jQuery.isWindow(obj)?!1:obj.constructor&&!hasOwn.call(obj.constructor.prototype,"isPrototypeOf")?!1:!0},isEmptyObject:function(obj){var name;for(name in obj)return!1;return!0},type:function(obj){return null==obj?obj+"":"object"==typeof obj||"function"==typeof obj?class2type[toString.call(obj)]||"object":typeof obj},globalEval:function(code){var script,indirect=eval;code=jQuery.trim(code),code&&(1===code.indexOf("use strict")?(script=document.createElement("script"),script.text=code,document.head.appendChild(script).parentNode.removeChild(script)):indirect(code))},camelCase:function(string){return string.replace(rmsPrefix,"ms-").replace(rdashAlpha,fcamelCase)},nodeName:function(elem,name){return elem.nodeName&&elem.nodeName.toLowerCase()===name.toLowerCase()},each:function(obj,callback,args){var value,i=0,length=obj.length,isArray=isArraylike(obj);if(args){if(isArray)for(;length>i&&(value=callback.apply(obj[i],args),value!==!1);i++);else for(i in obj)if(value=callback.apply(obj[i],args),value===!1)break}else if(isArray)for(;length>i&&(value=callback.call(obj[i],i,obj[i]),value!==!1);i++);else for(i in obj)if(value=callback.call(obj[i],i,obj[i]),value===!1)break;return obj},trim:function(text){return null==text?"":(text+"").replace(rtrim,"")},makeArray:function(arr,results){var ret=results||[];return null!=arr&&(isArraylike(Object(arr))?jQuery.merge(ret,"string"==typeof arr?[arr]:arr):push.call(ret,arr)),ret},inArray:function(elem,arr,i){return null==arr?-1:indexOf.call(arr,elem,i)},merge:function(first,second){for(var len=+second.length,j=0,i=first.length;len>j;j++)first[i++]=second[j];return first.length=i,first},grep:function(elems,callback,invert){for(var callbackInverse,matches=[],i=0,length=elems.length,callbackExpect=!invert;length>i;i++)callbackInverse=!callback(elems[i],i),callbackInverse!==callbackExpect&&matches.push(elems[i]);return matches},map:function(elems,callback,arg){var value,i=0,length=elems.length,isArray=isArraylike(elems),ret=[];if(isArray)for(;length>i;i++)value=callback(elems[i],i,arg),null!=value&&ret.push(value);else for(i in elems)value=callback(elems[i],i,arg),null!=value&&ret.push(value);return concat.apply([],ret)},guid:1,proxy:function(fn,context){var tmp,args,proxy;return"string"==typeof context&&(tmp=fn[context],context=fn,fn=tmp),jQuery.isFunction(fn)?(args=slice.call(arguments,2),proxy=function(){return fn.apply(context||this,args.concat(slice.call(arguments)))},proxy.guid=fn.guid=fn.guid||jQuery.guid++,proxy):void 0},now:Date.now,support:support}),jQuery.each("Boolean Number String Function Array Date RegExp Object Error".split(" "),function(i,name){class2type["[object "+name+"]"]=name.toLowerCase()});var Sizzle=function(window){function Sizzle(selector,context,results,seed){var match,elem,m,nodeType,i,groups,old,nid,newContext,newSelector;if((context?context.ownerDocument||context:preferredDoc)!==document&&setDocument(context),context=context||document,results=results||[],nodeType=context.nodeType,"string"!=typeof selector||!selector||1!==nodeType&&9!==nodeType&&11!==nodeType)return results;if(!seed&&documentIsHTML){if(11!==nodeType&&(match=rquickExpr.exec(selector)))if(m=match[1]){if(9===nodeType){if(elem=context.getElementById(m),!elem||!elem.parentNode)return results;if(elem.id===m)return results.push(elem),results}else if(context.ownerDocument&&(elem=context.ownerDocument.getElementById(m))&&contains(context,elem)&&elem.id===m)return results.push(elem),results}else{if(match[2])return push.apply(results,context.getElementsByTagName(selector)),results;if((m=match[3])&&support.getElementsByClassName)return push.apply(results,context.getElementsByClassName(m)),results}if(support.qsa&&(!rbuggyQSA||!rbuggyQSA.test(selector))){if(nid=old=expando,newContext=context,newSelector=1!==nodeType&&selector,1===nodeType&&"object"!==context.nodeName.toLowerCase()){for(groups=tokenize(selector),(old=context.getAttribute("id"))?nid=old.replace(rescape,"\\$&"):context.setAttribute("id",nid),nid="[id='"+nid+"'] ",i=groups.length;i--;)groups[i]=nid+toSelector(groups[i]);newContext=rsibling.test(selector)&&testContext(context.parentNode)||context,newSelector=groups.join(",")}if(newSelector)try{return push.apply(results,newContext.querySelectorAll(newSelector)),results}catch(qsaError){}finally{old||context.removeAttribute("id")}}}return select(selector.replace(rtrim,"$1"),context,results,seed)}function createCache(){function cache(key,value){return keys.push(key+" ")>Expr.cacheLength&&delete cache[keys.shift()],cache[key+" "]=value}var keys=[];return cache}function markFunction(fn){return fn[expando]=!0,fn}function assert(fn){var div=document.createElement("div");try{return!!fn(div)}catch(e){return!1}finally{div.parentNode&&div.parentNode.removeChild(div),div=null}}function addHandle(attrs,handler){for(var arr=attrs.split("|"),i=attrs.length;i--;)Expr.attrHandle[arr[i]]=handler}function siblingCheck(a,b){var cur=b&&a,diff=cur&&1===a.nodeType&&1===b.nodeType&&(~b.sourceIndex||MAX_NEGATIVE)-(~a.sourceIndex||MAX_NEGATIVE);if(diff)return diff;if(cur)for(;cur=cur.nextSibling;)if(cur===b)return-1;return a?1:-1}function createInputPseudo(type){return function(elem){var name=elem.nodeName.toLowerCase();return"input"===name&&elem.type===type}}function createButtonPseudo(type){return function(elem){var name=elem.nodeName.toLowerCase();return("input"===name||"button"===name)&&elem.type===type}}function createPositionalPseudo(fn){return markFunction(function(argument){return argument=+argument,markFunction(function(seed,matches){for(var j,matchIndexes=fn([],seed.length,argument),i=matchIndexes.length;i--;)seed[j=matchIndexes[i]]&&(seed[j]=!(matches[j]=seed[j]))})})}function testContext(context){return context&&"undefined"!=typeof context.getElementsByTagName&&context}function setFilters(){}function toSelector(tokens){for(var i=0,len=tokens.length,selector="";len>i;i++)selector+=tokens[i].value;return selector}function addCombinator(matcher,combinator,base){var dir=combinator.dir,checkNonElements=base&&"parentNode"===dir,doneName=done++;return combinator.first?function(elem,context,xml){for(;elem=elem[dir];)if(1===elem.nodeType||checkNonElements)return matcher(elem,context,xml)}:function(elem,context,xml){var oldCache,outerCache,newCache=[dirruns,doneName];if(xml){for(;elem=elem[dir];)if((1===elem.nodeType||checkNonElements)&&matcher(elem,context,xml))return!0}else for(;elem=elem[dir];)if(1===elem.nodeType||checkNonElements){if(outerCache=elem[expando]||(elem[expando]={}),(oldCache=outerCache[dir])&&oldCache[0]===dirruns&&oldCache[1]===doneName)return newCache[2]=oldCache[2];if(outerCache[dir]=newCache,newCache[2]=matcher(elem,context,xml))return!0}}}function elementMatcher(matchers){return matchers.length>1?function(elem,context,xml){for(var i=matchers.length;i--;)if(!matchers[i](elem,context,xml))return!1;return!0}:matchers[0]}function multipleContexts(selector,contexts,results){for(var i=0,len=contexts.length;len>i;i++)Sizzle(selector,contexts[i],results);return results}function condense(unmatched,map,filter,context,xml){for(var elem,newUnmatched=[],i=0,len=unmatched.length,mapped=null!=map;len>i;i++)(elem=unmatched[i])&&(!filter||filter(elem,context,xml))&&(newUnmatched.push(elem),mapped&&map.push(i));return newUnmatched}function setMatcher(preFilter,selector,matcher,postFilter,postFinder,postSelector){return postFilter&&!postFilter[expando]&&(postFilter=setMatcher(postFilter)),postFinder&&!postFinder[expando]&&(postFinder=setMatcher(postFinder,postSelector)),markFunction(function(seed,results,context,xml){var temp,i,elem,preMap=[],postMap=[],preexisting=results.length,elems=seed||multipleContexts(selector||"*",context.nodeType?[context]:context,[]),matcherIn=!preFilter||!seed&&selector?elems:condense(elems,preMap,preFilter,context,xml),matcherOut=matcher?postFinder||(seed?preFilter:preexisting||postFilter)?[]:results:matcherIn;if(matcher&&matcher(matcherIn,matcherOut,context,xml),postFilter)for(temp=condense(matcherOut,postMap),postFilter(temp,[],context,xml),i=temp.length;i--;)(elem=temp[i])&&(matcherOut[postMap[i]]=!(matcherIn[postMap[i]]=elem));if(seed){if(postFinder||preFilter){if(postFinder){for(temp=[],i=matcherOut.length;i--;)(elem=matcherOut[i])&&temp.push(matcherIn[i]=elem);postFinder(null,matcherOut=[],temp,xml)}for(i=matcherOut.length;i--;)(elem=matcherOut[i])&&(temp=postFinder?indexOf(seed,elem):preMap[i])>-1&&(seed[temp]=!(results[temp]=elem))}}else matcherOut=condense(matcherOut===results?matcherOut.splice(preexisting,matcherOut.length):matcherOut),postFinder?postFinder(null,results,matcherOut,xml):push.apply(results,matcherOut)})}function matcherFromTokens(tokens){for(var checkContext,matcher,j,len=tokens.length,leadingRelative=Expr.relative[tokens[0].type],implicitRelative=leadingRelative||Expr.relative[" "],i=leadingRelative?1:0,matchContext=addCombinator(function(elem){return elem===checkContext},implicitRelative,!0),matchAnyContext=addCombinator(function(elem){return indexOf(checkContext,elem)>-1},implicitRelative,!0),matchers=[function(elem,context,xml){var ret=!leadingRelative&&(xml||context!==outermostContext)||((checkContext=context).nodeType?matchContext(elem,context,xml):matchAnyContext(elem,context,xml));return checkContext=null,ret}];len>i;i++)if(matcher=Expr.relative[tokens[i].type])matchers=[addCombinator(elementMatcher(matchers),matcher)];else{if(matcher=Expr.filter[tokens[i].type].apply(null,tokens[i].matches),matcher[expando]){for(j=++i;len>j&&!Expr.relative[tokens[j].type];j++);return setMatcher(i>1&&elementMatcher(matchers),i>1&&toSelector(tokens.slice(0,i-1).concat({value:" "===tokens[i-2].type?"*":""})).replace(rtrim,"$1"),matcher,j>i&&matcherFromTokens(tokens.slice(i,j)),len>j&&matcherFromTokens(tokens=tokens.slice(j)),len>j&&toSelector(tokens))}matchers.push(matcher)}return elementMatcher(matchers)}function matcherFromGroupMatchers(elementMatchers,setMatchers){var bySet=setMatchers.length>0,byElement=elementMatchers.length>0,superMatcher=function(seed,context,xml,results,outermost){var elem,j,matcher,matchedCount=0,i="0",unmatched=seed&&[],setMatched=[],contextBackup=outermostContext,elems=seed||byElement&&Expr.find.TAG("*",outermost),dirrunsUnique=dirruns+=null==contextBackup?1:Math.random()||.1,len=elems.length;for(outermost&&(outermostContext=context!==document&&context);i!==len&&null!=(elem=elems[i]);i++){if(byElement&&elem){for(j=0;matcher=elementMatchers[j++];)if(matcher(elem,context,xml)){results.push(elem);break}outermost&&(dirruns=dirrunsUnique)}bySet&&((elem=!matcher&&elem)&&matchedCount--,seed&&unmatched.push(elem))}if(matchedCount+=i,bySet&&i!==matchedCount){for(j=0;matcher=setMatchers[j++];)matcher(unmatched,setMatched,context,xml);if(seed){if(matchedCount>0)for(;i--;)unmatched[i]||setMatched[i]||(setMatched[i]=pop.call(results));setMatched=condense(setMatched)}push.apply(results,setMatched),outermost&&!seed&&setMatched.length>0&&matchedCount+setMatchers.length>1&&Sizzle.uniqueSort(results)}return outermost&&(dirruns=dirrunsUnique,outermostContext=contextBackup),unmatched};return bySet?markFunction(superMatcher):superMatcher}var i,support,Expr,getText,isXML,tokenize,compile,select,outermostContext,sortInput,hasDuplicate,setDocument,document,docElem,documentIsHTML,rbuggyQSA,rbuggyMatches,matches,contains,expando="sizzle"+1*new Date,preferredDoc=window.document,dirruns=0,done=0,classCache=createCache(),tokenCache=createCache(),compilerCache=createCache(),sortOrder=function(a,b){return a===b&&(hasDuplicate=!0),0},MAX_NEGATIVE=1<<31,hasOwn={}.hasOwnProperty,arr=[],pop=arr.pop,push_native=arr.push,push=arr.push,slice=arr.slice,indexOf=function(list,elem){for(var i=0,len=list.length;len>i;i++)if(list[i]===elem)return i;return-1},booleans="checked|selected|async|autofocus|autoplay|controls|defer|disabled|hidden|ismap|loop|multiple|open|readonly|required|scoped",whitespace="[\\x20\\t\\r\\n\\f]",characterEncoding="(?:\\\\.|[\\w-]|[^\\x00-\\xa0])+",identifier=characterEncoding.replace("w","w#"),attributes="\\["+whitespace+"*("+characterEncoding+")(?:"+whitespace+"*([*^$|!~]?=)"+whitespace+"*(?:'((?:\\\\.|[^\\\\'])*)'|\"((?:\\\\.|[^\\\\\"])*)\"|("+identifier+"))|)"+whitespace+"*\\]",pseudos=":("+characterEncoding+")(?:\\((('((?:\\\\.|[^\\\\'])*)'|\"((?:\\\\.|[^\\\\\"])*)\")|((?:\\\\.|[^\\\\()[\\]]|"+attributes+")*)|.*)\\)|)",rwhitespace=new RegExp(whitespace+"+","g"),rtrim=new RegExp("^"+whitespace+"+|((?:^|[^\\\\])(?:\\\\.)*)"+whitespace+"+$","g"),rcomma=new RegExp("^"+whitespace+"*,"+whitespace+"*"),rcombinators=new RegExp("^"+whitespace+"*([>+~]|"+whitespace+")"+whitespace+"*"),rattributeQuotes=new RegExp("="+whitespace+"*([^\\]'\"]*?)"+whitespace+"*\\]","g"),rpseudo=new RegExp(pseudos),ridentifier=new RegExp("^"+identifier+"$"),matchExpr={ID:new RegExp("^#("+characterEncoding+")"),CLASS:new RegExp("^\\.("+characterEncoding+")"),TAG:new RegExp("^("+characterEncoding.replace("w","w*")+")"),ATTR:new RegExp("^"+attributes),PSEUDO:new RegExp("^"+pseudos),CHILD:new RegExp("^:(only|first|last|nth|nth-last)-(child|of-type)(?:\\("+whitespace+"*(even|odd|(([+-]|)(\\d*)n|)"+whitespace+"*(?:([+-]|)"+whitespace+"*(\\d+)|))"+whitespace+"*\\)|)","i"),bool:new RegExp("^(?:"+booleans+")$","i"),needsContext:new RegExp("^"+whitespace+"*[>+~]|:(even|odd|eq|gt|lt|nth|first|last)(?:\\("+whitespace+"*((?:-\\d)?\\d*)"+whitespace+"*\\)|)(?=[^-]|$)","i")},rinputs=/^(?:input|select|textarea|button)$/i,rheader=/^h\d$/i,rnative=/^[^{]+\{\s*\[native \w/,rquickExpr=/^(?:#([\w-]+)|(\w+)|\.([\w-]+))$/,rsibling=/[+~]/,rescape=/'|\\/g,runescape=new RegExp("\\\\([\\da-f]{1,6}"+whitespace+"?|("+whitespace+")|.)","ig"),funescape=function(_,escaped,escapedWhitespace){var high="0x"+escaped-65536;return high!==high||escapedWhitespace?escaped:0>high?String.fromCharCode(high+65536):String.fromCharCode(high>>10|55296,1023&high|56320)},unloadHandler=function(){setDocument()};try{push.apply(arr=slice.call(preferredDoc.childNodes),preferredDoc.childNodes),arr[preferredDoc.childNodes.length].nodeType}catch(e){push={apply:arr.length?function(target,els){push_native.apply(target,slice.call(els))}:function(target,els){for(var j=target.length,i=0;target[j++]=els[i++];);target.length=j-1}}}support=Sizzle.support={},isXML=Sizzle.isXML=function(elem){var documentElement=elem&&(elem.ownerDocument||elem).documentElement;return documentElement?"HTML"!==documentElement.nodeName:!1},setDocument=Sizzle.setDocument=function(node){var hasCompare,parent,doc=node?node.ownerDocument||node:preferredDoc;return doc!==document&&9===doc.nodeType&&doc.documentElement?(document=doc,docElem=doc.documentElement,parent=doc.defaultView,parent&&parent!==parent.top&&(parent.addEventListener?parent.addEventListener("unload",unloadHandler,!1):parent.attachEvent&&parent.attachEvent("onunload",unloadHandler)),documentIsHTML=!isXML(doc),support.attributes=assert(function(div){return div.className="i",!div.getAttribute("className")}),support.getElementsByTagName=assert(function(div){return div.appendChild(doc.createComment("")),!div.getElementsByTagName("*").length}),support.getElementsByClassName=rnative.test(doc.getElementsByClassName),support.getById=assert(function(div){return docElem.appendChild(div).id=expando,!doc.getElementsByName||!doc.getElementsByName(expando).length}),support.getById?(Expr.find.ID=function(id,context){if("undefined"!=typeof context.getElementById&&documentIsHTML){var m=context.getElementById(id);return m&&m.parentNode?[m]:[]}},Expr.filter.ID=function(id){var attrId=id.replace(runescape,funescape);return function(elem){return elem.getAttribute("id")===attrId}}):(delete Expr.find.ID,Expr.filter.ID=function(id){var attrId=id.replace(runescape,funescape);return function(elem){var node="undefined"!=typeof elem.getAttributeNode&&elem.getAttributeNode("id");return node&&node.value===attrId}}),Expr.find.TAG=support.getElementsByTagName?function(tag,context){return"undefined"!=typeof context.getElementsByTagName?context.getElementsByTagName(tag):support.qsa?context.querySelectorAll(tag):void 0}:function(tag,context){var elem,tmp=[],i=0,results=context.getElementsByTagName(tag);if("*"===tag){for(;elem=results[i++];)1===elem.nodeType&&tmp.push(elem);return tmp}return results},Expr.find.CLASS=support.getElementsByClassName&&function(className,context){return documentIsHTML?context.getElementsByClassName(className):void 0},rbuggyMatches=[],rbuggyQSA=[],(support.qsa=rnative.test(doc.querySelectorAll))&&(assert(function(div){docElem.appendChild(div).innerHTML="<a id='"+expando+"'></a><select id='"+expando+"-\f]' msallowcapture=''><option selected=''></option></select>",div.querySelectorAll("[msallowcapture^='']").length&&rbuggyQSA.push("[*^$]="+whitespace+"*(?:''|\"\")"),div.querySelectorAll("[selected]").length||rbuggyQSA.push("\\["+whitespace+"*(?:value|"+booleans+")"),div.querySelectorAll("[id~="+expando+"-]").length||rbuggyQSA.push("~="),div.querySelectorAll(":checked").length||rbuggyQSA.push(":checked"),div.querySelectorAll("a#"+expando+"+*").length||rbuggyQSA.push(".#.+[+~]")}),assert(function(div){var input=doc.createElement("input");input.setAttribute("type","hidden"),div.appendChild(input).setAttribute("name","D"),div.querySelectorAll("[name=d]").length&&rbuggyQSA.push("name"+whitespace+"*[*^$|!~]?="),div.querySelectorAll(":enabled").length||rbuggyQSA.push(":enabled",":disabled"),div.querySelectorAll("*,:x"),rbuggyQSA.push(",.*:")})),(support.matchesSelector=rnative.test(matches=docElem.matches||docElem.webkitMatchesSelector||docElem.mozMatchesSelector||docElem.oMatchesSelector||docElem.msMatchesSelector))&&assert(function(div){support.disconnectedMatch=matches.call(div,"div"),matches.call(div,"[s!='']:x"),rbuggyMatches.push("!=",pseudos)}),rbuggyQSA=rbuggyQSA.length&&new RegExp(rbuggyQSA.join("|")),rbuggyMatches=rbuggyMatches.length&&new RegExp(rbuggyMatches.join("|")),hasCompare=rnative.test(docElem.compareDocumentPosition),contains=hasCompare||rnative.test(docElem.contains)?function(a,b){var adown=9===a.nodeType?a.documentElement:a,bup=b&&b.parentNode;return a===bup||!(!bup||1!==bup.nodeType||!(adown.contains?adown.contains(bup):a.compareDocumentPosition&&16&a.compareDocumentPosition(bup)))}:function(a,b){if(b)for(;b=b.parentNode;)if(b===a)return!0;return!1},sortOrder=hasCompare?function(a,b){if(a===b)return hasDuplicate=!0,0;var compare=!a.compareDocumentPosition-!b.compareDocumentPosition;return compare?compare:(compare=(a.ownerDocument||a)===(b.ownerDocument||b)?a.compareDocumentPosition(b):1,1&compare||!support.sortDetached&&b.compareDocumentPosition(a)===compare?a===doc||a.ownerDocument===preferredDoc&&contains(preferredDoc,a)?-1:b===doc||b.ownerDocument===preferredDoc&&contains(preferredDoc,b)?1:sortInput?indexOf(sortInput,a)-indexOf(sortInput,b):0:4&compare?-1:1)}:function(a,b){if(a===b)return hasDuplicate=!0,0;var cur,i=0,aup=a.parentNode,bup=b.parentNode,ap=[a],bp=[b];if(!aup||!bup)return a===doc?-1:b===doc?1:aup?-1:bup?1:sortInput?indexOf(sortInput,a)-indexOf(sortInput,b):0;if(aup===bup)return siblingCheck(a,b);for(cur=a;cur=cur.parentNode;)ap.unshift(cur);for(cur=b;cur=cur.parentNode;)bp.unshift(cur);for(;ap[i]===bp[i];)i++;return i?siblingCheck(ap[i],bp[i]):ap[i]===preferredDoc?-1:bp[i]===preferredDoc?1:0},doc):document},Sizzle.matches=function(expr,elements){return Sizzle(expr,null,null,elements)},Sizzle.matchesSelector=function(elem,expr){if((elem.ownerDocument||elem)!==document&&setDocument(elem),expr=expr.replace(rattributeQuotes,"='$1']"),support.matchesSelector&&documentIsHTML&&(!rbuggyMatches||!rbuggyMatches.test(expr))&&(!rbuggyQSA||!rbuggyQSA.test(expr)))try{var ret=matches.call(elem,expr);if(ret||support.disconnectedMatch||elem.document&&11!==elem.document.nodeType)return ret}catch(e){}return Sizzle(expr,document,null,[elem]).length>0},Sizzle.contains=function(context,elem){return(context.ownerDocument||context)!==document&&setDocument(context),contains(context,elem)},Sizzle.attr=function(elem,name){(elem.ownerDocument||elem)!==document&&setDocument(elem);var fn=Expr.attrHandle[name.toLowerCase()],val=fn&&hasOwn.call(Expr.attrHandle,name.toLowerCase())?fn(elem,name,!documentIsHTML):void 0;return void 0!==val?val:support.attributes||!documentIsHTML?elem.getAttribute(name):(val=elem.getAttributeNode(name))&&val.specified?val.value:null},Sizzle.error=function(msg){throw new Error("Syntax error, unrecognized expression: "+msg)},Sizzle.uniqueSort=function(results){var elem,duplicates=[],j=0,i=0;if(hasDuplicate=!support.detectDuplicates,sortInput=!support.sortStable&&results.slice(0),results.sort(sortOrder),hasDuplicate){for(;elem=results[i++];)elem===results[i]&&(j=duplicates.push(i));for(;j--;)results.splice(duplicates[j],1)}return sortInput=null,results},getText=Sizzle.getText=function(elem){var node,ret="",i=0,nodeType=elem.nodeType;if(nodeType){if(1===nodeType||9===nodeType||11===nodeType){if("string"==typeof elem.textContent)return elem.textContent;for(elem=elem.firstChild;elem;elem=elem.nextSibling)ret+=getText(elem)}else if(3===nodeType||4===nodeType)return elem.nodeValue}else for(;node=elem[i++];)ret+=getText(node);return ret},Expr=Sizzle.selectors={cacheLength:50,createPseudo:markFunction,match:matchExpr,attrHandle:{},find:{},relative:{">":{dir:"parentNode",first:!0}," ":{dir:"parentNode"},"+":{dir:"previousSibling",first:!0},"~":{dir:"previousSibling"}},preFilter:{ATTR:function(match){return match[1]=match[1].replace(runescape,funescape),match[3]=(match[3]||match[4]||match[5]||"").replace(runescape,funescape),"~="===match[2]&&(match[3]=" "+match[3]+" "),match.slice(0,4)},CHILD:function(match){return match[1]=match[1].toLowerCase(),"nth"===match[1].slice(0,3)?(match[3]||Sizzle.error(match[0]),match[4]=+(match[4]?match[5]+(match[6]||1):2*("even"===match[3]||"odd"===match[3])),match[5]=+(match[7]+match[8]||"odd"===match[3])):match[3]&&Sizzle.error(match[0]),match},PSEUDO:function(match){var excess,unquoted=!match[6]&&match[2];return matchExpr.CHILD.test(match[0])?null:(match[3]?match[2]=match[4]||match[5]||"":unquoted&&rpseudo.test(unquoted)&&(excess=tokenize(unquoted,!0))&&(excess=unquoted.indexOf(")",unquoted.length-excess)-unquoted.length)&&(match[0]=match[0].slice(0,excess),match[2]=unquoted.slice(0,excess)),match.slice(0,3))}},filter:{TAG:function(nodeNameSelector){var nodeName=nodeNameSelector.replace(runescape,funescape).toLowerCase();return"*"===nodeNameSelector?function(){return!0}:function(elem){return elem.nodeName&&elem.nodeName.toLowerCase()===nodeName}},CLASS:function(className){var pattern=classCache[className+" "];return pattern||(pattern=new RegExp("(^|"+whitespace+")"+className+"("+whitespace+"|$)"))&&classCache(className,function(elem){return pattern.test("string"==typeof elem.className&&elem.className||"undefined"!=typeof elem.getAttribute&&elem.getAttribute("class")||"")})},ATTR:function(name,operator,check){return function(elem){var result=Sizzle.attr(elem,name);return null==result?"!="===operator:operator?(result+="","="===operator?result===check:"!="===operator?result!==check:"^="===operator?check&&0===result.indexOf(check):"*="===operator?check&&result.indexOf(check)>-1:"$="===operator?check&&result.slice(-check.length)===check:"~="===operator?(" "+result.replace(rwhitespace," ")+" ").indexOf(check)>-1:"|="===operator?result===check||result.slice(0,check.length+1)===check+"-":!1):!0}},CHILD:function(type,what,argument,first,last){var simple="nth"!==type.slice(0,3),forward="last"!==type.slice(-4),ofType="of-type"===what;return 1===first&&0===last?function(elem){return!!elem.parentNode}:function(elem,context,xml){var cache,outerCache,node,diff,nodeIndex,start,dir=simple!==forward?"nextSibling":"previousSibling",parent=elem.parentNode,name=ofType&&elem.nodeName.toLowerCase(),useCache=!xml&&!ofType;if(parent){if(simple){for(;dir;){for(node=elem;node=node[dir];)if(ofType?node.nodeName.toLowerCase()===name:1===node.nodeType)return!1;start=dir="only"===type&&!start&&"nextSibling"}return!0}if(start=[forward?parent.firstChild:parent.lastChild],forward&&useCache){for(outerCache=parent[expando]||(parent[expando]={}),cache=outerCache[type]||[],nodeIndex=cache[0]===dirruns&&cache[1],diff=cache[0]===dirruns&&cache[2],node=nodeIndex&&parent.childNodes[nodeIndex];node=++nodeIndex&&node&&node[dir]||(diff=nodeIndex=0)||start.pop();)if(1===node.nodeType&&++diff&&node===elem){outerCache[type]=[dirruns,nodeIndex,diff];break}}else if(useCache&&(cache=(elem[expando]||(elem[expando]={}))[type])&&cache[0]===dirruns)diff=cache[1];else for(;(node=++nodeIndex&&node&&node[dir]||(diff=nodeIndex=0)||start.pop())&&((ofType?node.nodeName.toLowerCase()!==name:1!==node.nodeType)||!++diff||(useCache&&((node[expando]||(node[expando]={}))[type]=[dirruns,diff]),node!==elem)););return diff-=last,diff===first||diff%first===0&&diff/first>=0}}},PSEUDO:function(pseudo,argument){var args,fn=Expr.pseudos[pseudo]||Expr.setFilters[pseudo.toLowerCase()]||Sizzle.error("unsupported pseudo: "+pseudo);return fn[expando]?fn(argument):fn.length>1?(args=[pseudo,pseudo,"",argument],Expr.setFilters.hasOwnProperty(pseudo.toLowerCase())?markFunction(function(seed,matches){for(var idx,matched=fn(seed,argument),i=matched.length;i--;)idx=indexOf(seed,matched[i]),seed[idx]=!(matches[idx]=matched[i])}):function(elem){return fn(elem,0,args)}):fn}},pseudos:{not:markFunction(function(selector){var input=[],results=[],matcher=compile(selector.replace(rtrim,"$1"));return matcher[expando]?markFunction(function(seed,matches,context,xml){for(var elem,unmatched=matcher(seed,null,xml,[]),i=seed.length;i--;)(elem=unmatched[i])&&(seed[i]=!(matches[i]=elem))}):function(elem,context,xml){return input[0]=elem,matcher(input,null,xml,results),input[0]=null,!results.pop()}}),has:markFunction(function(selector){return function(elem){return Sizzle(selector,elem).length>0}}),contains:markFunction(function(text){return text=text.replace(runescape,funescape),function(elem){return(elem.textContent||elem.innerText||getText(elem)).indexOf(text)>-1}}),lang:markFunction(function(lang){return ridentifier.test(lang||"")||Sizzle.error("unsupported lang: "+lang),lang=lang.replace(runescape,funescape).toLowerCase(),function(elem){var elemLang;do if(elemLang=documentIsHTML?elem.lang:elem.getAttribute("xml:lang")||elem.getAttribute("lang"))return elemLang=elemLang.toLowerCase(),elemLang===lang||0===elemLang.indexOf(lang+"-");while((elem=elem.parentNode)&&1===elem.nodeType);return!1}}),target:function(elem){var hash=window.location&&window.location.hash;return hash&&hash.slice(1)===elem.id},root:function(elem){return elem===docElem},focus:function(elem){return elem===document.activeElement&&(!document.hasFocus||document.hasFocus())&&!!(elem.type||elem.href||~elem.tabIndex)},enabled:function(elem){return elem.disabled===!1},disabled:function(elem){return elem.disabled===!0},checked:function(elem){var nodeName=elem.nodeName.toLowerCase();return"input"===nodeName&&!!elem.checked||"option"===nodeName&&!!elem.selected},selected:function(elem){return elem.parentNode&&elem.parentNode.selectedIndex,elem.selected===!0},empty:function(elem){for(elem=elem.firstChild;elem;elem=elem.nextSibling)if(elem.nodeType<6)return!1;return!0},parent:function(elem){return!Expr.pseudos.empty(elem)},header:function(elem){return rheader.test(elem.nodeName)},input:function(elem){return rinputs.test(elem.nodeName)},button:function(elem){var name=elem.nodeName.toLowerCase();return"input"===name&&"button"===elem.type||"button"===name},text:function(elem){var attr;return"input"===elem.nodeName.toLowerCase()&&"text"===elem.type&&(null==(attr=elem.getAttribute("type"))||"text"===attr.toLowerCase())},first:createPositionalPseudo(function(){return[0]}),last:createPositionalPseudo(function(matchIndexes,length){return[length-1]}),eq:createPositionalPseudo(function(matchIndexes,length,argument){return[0>argument?argument+length:argument]}),even:createPositionalPseudo(function(matchIndexes,length){for(var i=0;length>i;i+=2)matchIndexes.push(i);return matchIndexes}),odd:createPositionalPseudo(function(matchIndexes,length){for(var i=1;length>i;i+=2)matchIndexes.push(i);return matchIndexes}),lt:createPositionalPseudo(function(matchIndexes,length,argument){for(var i=0>argument?argument+length:argument;--i>=0;)matchIndexes.push(i);return matchIndexes}),gt:createPositionalPseudo(function(matchIndexes,length,argument){for(var i=0>argument?argument+length:argument;++i<length;)matchIndexes.push(i);return matchIndexes})}},Expr.pseudos.nth=Expr.pseudos.eq;for(i in{radio:!0,checkbox:!0,file:!0,password:!0,image:!0})Expr.pseudos[i]=createInputPseudo(i);for(i in{submit:!0,reset:!0})Expr.pseudos[i]=createButtonPseudo(i);return setFilters.prototype=Expr.filters=Expr.pseudos,Expr.setFilters=new setFilters,tokenize=Sizzle.tokenize=function(selector,parseOnly){var matched,match,tokens,type,soFar,groups,preFilters,cached=tokenCache[selector+" "];if(cached)return parseOnly?0:cached.slice(0);for(soFar=selector,groups=[],preFilters=Expr.preFilter;soFar;){(!matched||(match=rcomma.exec(soFar)))&&(match&&(soFar=soFar.slice(match[0].length)||soFar),groups.push(tokens=[])),matched=!1,(match=rcombinators.exec(soFar))&&(matched=match.shift(),tokens.push({value:matched,type:match[0].replace(rtrim," ")}),soFar=soFar.slice(matched.length));for(type in Expr.filter)!(match=matchExpr[type].exec(soFar))||preFilters[type]&&!(match=preFilters[type](match))||(matched=match.shift(),tokens.push({value:matched,type:type,matches:match}),soFar=soFar.slice(matched.length));if(!matched)break}return parseOnly?soFar.length:soFar?Sizzle.error(selector):tokenCache(selector,groups).slice(0)},compile=Sizzle.compile=function(selector,match){var i,setMatchers=[],elementMatchers=[],cached=compilerCache[selector+" "];if(!cached){for(match||(match=tokenize(selector)),i=match.length;i--;)cached=matcherFromTokens(match[i]),cached[expando]?setMatchers.push(cached):elementMatchers.push(cached);cached=compilerCache(selector,matcherFromGroupMatchers(elementMatchers,setMatchers)),cached.selector=selector}return cached},select=Sizzle.select=function(selector,context,results,seed){var i,tokens,token,type,find,compiled="function"==typeof selector&&selector,match=!seed&&tokenize(selector=compiled.selector||selector);if(results=results||[],1===match.length){if(tokens=match[0]=match[0].slice(0),tokens.length>2&&"ID"===(token=tokens[0]).type&&support.getById&&9===context.nodeType&&documentIsHTML&&Expr.relative[tokens[1].type]){if(context=(Expr.find.ID(token.matches[0].replace(runescape,funescape),context)||[])[0],!context)return results;compiled&&(context=context.parentNode),selector=selector.slice(tokens.shift().value.length)}for(i=matchExpr.needsContext.test(selector)?0:tokens.length;i--&&(token=tokens[i],!Expr.relative[type=token.type]);)if((find=Expr.find[type])&&(seed=find(token.matches[0].replace(runescape,funescape),rsibling.test(tokens[0].type)&&testContext(context.parentNode)||context))){
if(tokens.splice(i,1),selector=seed.length&&toSelector(tokens),!selector)return push.apply(results,seed),results;break}}return(compiled||compile(selector,match))(seed,context,!documentIsHTML,results,rsibling.test(selector)&&testContext(context.parentNode)||context),results},support.sortStable=expando.split("").sort(sortOrder).join("")===expando,support.detectDuplicates=!!hasDuplicate,setDocument(),support.sortDetached=assert(function(div1){return 1&div1.compareDocumentPosition(document.createElement("div"))}),assert(function(div){return div.innerHTML="<a href='#'></a>","#"===div.firstChild.getAttribute("href")})||addHandle("type|href|height|width",function(elem,name,isXML){return isXML?void 0:elem.getAttribute(name,"type"===name.toLowerCase()?1:2)}),support.attributes&&assert(function(div){return div.innerHTML="<input/>",div.firstChild.setAttribute("value",""),""===div.firstChild.getAttribute("value")})||addHandle("value",function(elem,name,isXML){return isXML||"input"!==elem.nodeName.toLowerCase()?void 0:elem.defaultValue}),assert(function(div){return null==div.getAttribute("disabled")})||addHandle(booleans,function(elem,name,isXML){var val;return isXML?void 0:elem[name]===!0?name.toLowerCase():(val=elem.getAttributeNode(name))&&val.specified?val.value:null}),Sizzle}(window);jQuery.find=Sizzle,jQuery.expr=Sizzle.selectors,jQuery.expr[":"]=jQuery.expr.pseudos,jQuery.unique=Sizzle.uniqueSort,jQuery.text=Sizzle.getText,jQuery.isXMLDoc=Sizzle.isXML,jQuery.contains=Sizzle.contains;var rneedsContext=jQuery.expr.match.needsContext,rsingleTag=/^<(\w+)\s*\/?>(?:<\/\1>|)$/,risSimple=/^.[^:#\[\.,]*$/;jQuery.filter=function(expr,elems,not){var elem=elems[0];return not&&(expr=":not("+expr+")"),1===elems.length&&1===elem.nodeType?jQuery.find.matchesSelector(elem,expr)?[elem]:[]:jQuery.find.matches(expr,jQuery.grep(elems,function(elem){return 1===elem.nodeType}))},jQuery.fn.extend({find:function(selector){var i,len=this.length,ret=[],self=this;if("string"!=typeof selector)return this.pushStack(jQuery(selector).filter(function(){for(i=0;len>i;i++)if(jQuery.contains(self[i],this))return!0}));for(i=0;len>i;i++)jQuery.find(selector,self[i],ret);return ret=this.pushStack(len>1?jQuery.unique(ret):ret),ret.selector=this.selector?this.selector+" "+selector:selector,ret},filter:function(selector){return this.pushStack(winnow(this,selector||[],!1))},not:function(selector){return this.pushStack(winnow(this,selector||[],!0))},is:function(selector){return!!winnow(this,"string"==typeof selector&&rneedsContext.test(selector)?jQuery(selector):selector||[],!1).length}});var rootjQuery,rquickExpr=/^(?:\s*(<[\w\W]+>)[^>]*|#([\w-]*))$/,init=jQuery.fn.init=function(selector,context){var match,elem;if(!selector)return this;if("string"==typeof selector){if(match="<"===selector[0]&&">"===selector[selector.length-1]&&selector.length>=3?[null,selector,null]:rquickExpr.exec(selector),!match||!match[1]&&context)return!context||context.jquery?(context||rootjQuery).find(selector):this.constructor(context).find(selector);if(match[1]){if(context=context instanceof jQuery?context[0]:context,jQuery.merge(this,jQuery.parseHTML(match[1],context&&context.nodeType?context.ownerDocument||context:document,!0)),rsingleTag.test(match[1])&&jQuery.isPlainObject(context))for(match in context)jQuery.isFunction(this[match])?this[match](context[match]):this.attr(match,context[match]);return this}return elem=document.getElementById(match[2]),elem&&elem.parentNode&&(this.length=1,this[0]=elem),this.context=document,this.selector=selector,this}return selector.nodeType?(this.context=this[0]=selector,this.length=1,this):jQuery.isFunction(selector)?"undefined"!=typeof rootjQuery.ready?rootjQuery.ready(selector):selector(jQuery):(void 0!==selector.selector&&(this.selector=selector.selector,this.context=selector.context),jQuery.makeArray(selector,this))};init.prototype=jQuery.fn,rootjQuery=jQuery(document);var rparentsprev=/^(?:parents|prev(?:Until|All))/,guaranteedUnique={children:!0,contents:!0,next:!0,prev:!0};jQuery.extend({dir:function(elem,dir,until){for(var matched=[],truncate=void 0!==until;(elem=elem[dir])&&9!==elem.nodeType;)if(1===elem.nodeType){if(truncate&&jQuery(elem).is(until))break;matched.push(elem)}return matched},sibling:function(n,elem){for(var matched=[];n;n=n.nextSibling)1===n.nodeType&&n!==elem&&matched.push(n);return matched}}),jQuery.fn.extend({has:function(target){var targets=jQuery(target,this),l=targets.length;return this.filter(function(){for(var i=0;l>i;i++)if(jQuery.contains(this,targets[i]))return!0})},closest:function(selectors,context){for(var cur,i=0,l=this.length,matched=[],pos=rneedsContext.test(selectors)||"string"!=typeof selectors?jQuery(selectors,context||this.context):0;l>i;i++)for(cur=this[i];cur&&cur!==context;cur=cur.parentNode)if(cur.nodeType<11&&(pos?pos.index(cur)>-1:1===cur.nodeType&&jQuery.find.matchesSelector(cur,selectors))){matched.push(cur);break}return this.pushStack(matched.length>1?jQuery.unique(matched):matched)},index:function(elem){return elem?"string"==typeof elem?indexOf.call(jQuery(elem),this[0]):indexOf.call(this,elem.jquery?elem[0]:elem):this[0]&&this[0].parentNode?this.first().prevAll().length:-1},add:function(selector,context){return this.pushStack(jQuery.unique(jQuery.merge(this.get(),jQuery(selector,context))))},addBack:function(selector){return this.add(null==selector?this.prevObject:this.prevObject.filter(selector))}}),jQuery.each({parent:function(elem){var parent=elem.parentNode;return parent&&11!==parent.nodeType?parent:null},parents:function(elem){return jQuery.dir(elem,"parentNode")},parentsUntil:function(elem,i,until){return jQuery.dir(elem,"parentNode",until)},next:function(elem){return sibling(elem,"nextSibling")},prev:function(elem){return sibling(elem,"previousSibling")},nextAll:function(elem){return jQuery.dir(elem,"nextSibling")},prevAll:function(elem){return jQuery.dir(elem,"previousSibling")},nextUntil:function(elem,i,until){return jQuery.dir(elem,"nextSibling",until)},prevUntil:function(elem,i,until){return jQuery.dir(elem,"previousSibling",until)},siblings:function(elem){return jQuery.sibling((elem.parentNode||{}).firstChild,elem)},children:function(elem){return jQuery.sibling(elem.firstChild)},contents:function(elem){return elem.contentDocument||jQuery.merge([],elem.childNodes)}},function(name,fn){jQuery.fn[name]=function(until,selector){var matched=jQuery.map(this,fn,until);return"Until"!==name.slice(-5)&&(selector=until),selector&&"string"==typeof selector&&(matched=jQuery.filter(selector,matched)),this.length>1&&(guaranteedUnique[name]||jQuery.unique(matched),rparentsprev.test(name)&&matched.reverse()),this.pushStack(matched)}});var rnotwhite=/\S+/g,optionsCache={};jQuery.Callbacks=function(options){options="string"==typeof options?optionsCache[options]||createOptions(options):jQuery.extend({},options);var memory,fired,firing,firingStart,firingLength,firingIndex,list=[],stack=!options.once&&[],fire=function(data){for(memory=options.memory&&data,fired=!0,firingIndex=firingStart||0,firingStart=0,firingLength=list.length,firing=!0;list&&firingLength>firingIndex;firingIndex++)if(list[firingIndex].apply(data[0],data[1])===!1&&options.stopOnFalse){memory=!1;break}firing=!1,list&&(stack?stack.length&&fire(stack.shift()):memory?list=[]:self.disable())},self={add:function(){if(list){var start=list.length;!function add(args){jQuery.each(args,function(_,arg){var type=jQuery.type(arg);"function"===type?options.unique&&self.has(arg)||list.push(arg):arg&&arg.length&&"string"!==type&&add(arg)})}(arguments),firing?firingLength=list.length:memory&&(firingStart=start,fire(memory))}return this},remove:function(){return list&&jQuery.each(arguments,function(_,arg){for(var index;(index=jQuery.inArray(arg,list,index))>-1;)list.splice(index,1),firing&&(firingLength>=index&&firingLength--,firingIndex>=index&&firingIndex--)}),this},has:function(fn){return fn?jQuery.inArray(fn,list)>-1:!(!list||!list.length)},empty:function(){return list=[],firingLength=0,this},disable:function(){return list=stack=memory=void 0,this},disabled:function(){return!list},lock:function(){return stack=void 0,memory||self.disable(),this},locked:function(){return!stack},fireWith:function(context,args){return!list||fired&&!stack||(args=args||[],args=[context,args.slice?args.slice():args],firing?stack.push(args):fire(args)),this},fire:function(){return self.fireWith(this,arguments),this},fired:function(){return!!fired}};return self},jQuery.extend({Deferred:function(func){var tuples=[["resolve","done",jQuery.Callbacks("once memory"),"resolved"],["reject","fail",jQuery.Callbacks("once memory"),"rejected"],["notify","progress",jQuery.Callbacks("memory")]],state="pending",promise={state:function(){return state},always:function(){return deferred.done(arguments).fail(arguments),this},then:function(){var fns=arguments;return jQuery.Deferred(function(newDefer){jQuery.each(tuples,function(i,tuple){var fn=jQuery.isFunction(fns[i])&&fns[i];deferred[tuple[1]](function(){var returned=fn&&fn.apply(this,arguments);returned&&jQuery.isFunction(returned.promise)?returned.promise().done(newDefer.resolve).fail(newDefer.reject).progress(newDefer.notify):newDefer[tuple[0]+"With"](this===promise?newDefer.promise():this,fn?[returned]:arguments)})}),fns=null}).promise()},promise:function(obj){return null!=obj?jQuery.extend(obj,promise):promise}},deferred={};return promise.pipe=promise.then,jQuery.each(tuples,function(i,tuple){var list=tuple[2],stateString=tuple[3];promise[tuple[1]]=list.add,stateString&&list.add(function(){state=stateString},tuples[1^i][2].disable,tuples[2][2].lock),deferred[tuple[0]]=function(){return deferred[tuple[0]+"With"](this===deferred?promise:this,arguments),this},deferred[tuple[0]+"With"]=list.fireWith}),promise.promise(deferred),func&&func.call(deferred,deferred),deferred},when:function(subordinate){var progressValues,progressContexts,resolveContexts,i=0,resolveValues=slice.call(arguments),length=resolveValues.length,remaining=1!==length||subordinate&&jQuery.isFunction(subordinate.promise)?length:0,deferred=1===remaining?subordinate:jQuery.Deferred(),updateFunc=function(i,contexts,values){return function(value){contexts[i]=this,values[i]=arguments.length>1?slice.call(arguments):value,values===progressValues?deferred.notifyWith(contexts,values):--remaining||deferred.resolveWith(contexts,values)}};if(length>1)for(progressValues=new Array(length),progressContexts=new Array(length),resolveContexts=new Array(length);length>i;i++)resolveValues[i]&&jQuery.isFunction(resolveValues[i].promise)?resolveValues[i].promise().done(updateFunc(i,resolveContexts,resolveValues)).fail(deferred.reject).progress(updateFunc(i,progressContexts,progressValues)):--remaining;return remaining||deferred.resolveWith(resolveContexts,resolveValues),deferred.promise()}});var readyList;jQuery.fn.ready=function(fn){return jQuery.ready.promise().done(fn),this},jQuery.extend({isReady:!1,readyWait:1,holdReady:function(hold){hold?jQuery.readyWait++:jQuery.ready(!0)},ready:function(wait){(wait===!0?--jQuery.readyWait:jQuery.isReady)||(jQuery.isReady=!0,wait!==!0&&--jQuery.readyWait>0||(readyList.resolveWith(document,[jQuery]),jQuery.fn.triggerHandler&&(jQuery(document).triggerHandler("ready"),jQuery(document).off("ready"))))}}),jQuery.ready.promise=function(obj){return readyList||(readyList=jQuery.Deferred(),"complete"===document.readyState?setTimeout(jQuery.ready):(document.addEventListener("DOMContentLoaded",completed,!1),window.addEventListener("load",completed,!1))),readyList.promise(obj)},jQuery.ready.promise();var access=jQuery.access=function(elems,fn,key,value,chainable,emptyGet,raw){var i=0,len=elems.length,bulk=null==key;if("object"===jQuery.type(key)){chainable=!0;for(i in key)jQuery.access(elems,fn,i,key[i],!0,emptyGet,raw)}else if(void 0!==value&&(chainable=!0,jQuery.isFunction(value)||(raw=!0),bulk&&(raw?(fn.call(elems,value),fn=null):(bulk=fn,fn=function(elem,key,value){return bulk.call(jQuery(elem),value)})),fn))for(;len>i;i++)fn(elems[i],key,raw?value:value.call(elems[i],i,fn(elems[i],key)));return chainable?elems:bulk?fn.call(elems):len?fn(elems[0],key):emptyGet};jQuery.acceptData=function(owner){return 1===owner.nodeType||9===owner.nodeType||!+owner.nodeType},Data.uid=1,Data.accepts=jQuery.acceptData,Data.prototype={key:function(owner){if(!Data.accepts(owner))return 0;var descriptor={},unlock=owner[this.expando];if(!unlock){unlock=Data.uid++;try{descriptor[this.expando]={value:unlock},Object.defineProperties(owner,descriptor)}catch(e){descriptor[this.expando]=unlock,jQuery.extend(owner,descriptor)}}return this.cache[unlock]||(this.cache[unlock]={}),unlock},set:function(owner,data,value){var prop,unlock=this.key(owner),cache=this.cache[unlock];if("string"==typeof data)cache[data]=value;else if(jQuery.isEmptyObject(cache))jQuery.extend(this.cache[unlock],data);else for(prop in data)cache[prop]=data[prop];return cache},get:function(owner,key){var cache=this.cache[this.key(owner)];return void 0===key?cache:cache[key]},access:function(owner,key,value){var stored;return void 0===key||key&&"string"==typeof key&&void 0===value?(stored=this.get(owner,key),void 0!==stored?stored:this.get(owner,jQuery.camelCase(key))):(this.set(owner,key,value),void 0!==value?value:key)},remove:function(owner,key){var i,name,camel,unlock=this.key(owner),cache=this.cache[unlock];if(void 0===key)this.cache[unlock]={};else{jQuery.isArray(key)?name=key.concat(key.map(jQuery.camelCase)):(camel=jQuery.camelCase(key),key in cache?name=[key,camel]:(name=camel,name=name in cache?[name]:name.match(rnotwhite)||[])),i=name.length;for(;i--;)delete cache[name[i]]}},hasData:function(owner){return!jQuery.isEmptyObject(this.cache[owner[this.expando]]||{})},discard:function(owner){owner[this.expando]&&delete this.cache[owner[this.expando]]}};var data_priv=new Data,data_user=new Data,rbrace=/^(?:\{[\w\W]*\}|\[[\w\W]*\])$/,rmultiDash=/([A-Z])/g;jQuery.extend({hasData:function(elem){return data_user.hasData(elem)||data_priv.hasData(elem)},data:function(elem,name,data){return data_user.access(elem,name,data)},removeData:function(elem,name){data_user.remove(elem,name)},_data:function(elem,name,data){return data_priv.access(elem,name,data)},_removeData:function(elem,name){data_priv.remove(elem,name)}}),jQuery.fn.extend({data:function(key,value){var i,name,data,elem=this[0],attrs=elem&&elem.attributes;if(void 0===key){if(this.length&&(data=data_user.get(elem),1===elem.nodeType&&!data_priv.get(elem,"hasDataAttrs"))){for(i=attrs.length;i--;)attrs[i]&&(name=attrs[i].name,0===name.indexOf("data-")&&(name=jQuery.camelCase(name.slice(5)),dataAttr(elem,name,data[name])));data_priv.set(elem,"hasDataAttrs",!0)}return data}return"object"==typeof key?this.each(function(){data_user.set(this,key)}):access(this,function(value){var data,camelKey=jQuery.camelCase(key);if(elem&&void 0===value){if(data=data_user.get(elem,key),void 0!==data)return data;if(data=data_user.get(elem,camelKey),void 0!==data)return data;if(data=dataAttr(elem,camelKey,void 0),void 0!==data)return data}else this.each(function(){var data=data_user.get(this,camelKey);data_user.set(this,camelKey,value),-1!==key.indexOf("-")&&void 0!==data&&data_user.set(this,key,value)})},null,value,arguments.length>1,null,!0)},removeData:function(key){return this.each(function(){data_user.remove(this,key)})}}),jQuery.extend({queue:function(elem,type,data){var queue;return elem?(type=(type||"fx")+"queue",queue=data_priv.get(elem,type),data&&(!queue||jQuery.isArray(data)?queue=data_priv.access(elem,type,jQuery.makeArray(data)):queue.push(data)),queue||[]):void 0},dequeue:function(elem,type){type=type||"fx";var queue=jQuery.queue(elem,type),startLength=queue.length,fn=queue.shift(),hooks=jQuery._queueHooks(elem,type),next=function(){jQuery.dequeue(elem,type)};"inprogress"===fn&&(fn=queue.shift(),startLength--),fn&&("fx"===type&&queue.unshift("inprogress"),delete hooks.stop,fn.call(elem,next,hooks)),!startLength&&hooks&&hooks.empty.fire()},_queueHooks:function(elem,type){var key=type+"queueHooks";return data_priv.get(elem,key)||data_priv.access(elem,key,{empty:jQuery.Callbacks("once memory").add(function(){data_priv.remove(elem,[type+"queue",key])})})}}),jQuery.fn.extend({queue:function(type,data){var setter=2;return"string"!=typeof type&&(data=type,type="fx",setter--),arguments.length<setter?jQuery.queue(this[0],type):void 0===data?this:this.each(function(){var queue=jQuery.queue(this,type,data);jQuery._queueHooks(this,type),"fx"===type&&"inprogress"!==queue[0]&&jQuery.dequeue(this,type)})},dequeue:function(type){return this.each(function(){jQuery.dequeue(this,type)})},clearQueue:function(type){return this.queue(type||"fx",[])},promise:function(type,obj){var tmp,count=1,defer=jQuery.Deferred(),elements=this,i=this.length,resolve=function(){--count||defer.resolveWith(elements,[elements])};for("string"!=typeof type&&(obj=type,type=void 0),type=type||"fx";i--;)tmp=data_priv.get(elements[i],type+"queueHooks"),tmp&&tmp.empty&&(count++,tmp.empty.add(resolve));return resolve(),defer.promise(obj)}});var pnum=/[+-]?(?:\d*\.|)\d+(?:[eE][+-]?\d+|)/.source,cssExpand=["Top","Right","Bottom","Left"],isHidden=function(elem,el){return elem=el||elem,"none"===jQuery.css(elem,"display")||!jQuery.contains(elem.ownerDocument,elem)},rcheckableType=/^(?:checkbox|radio)$/i;!function(){var fragment=document.createDocumentFragment(),div=fragment.appendChild(document.createElement("div")),input=document.createElement("input");input.setAttribute("type","radio"),input.setAttribute("checked","checked"),input.setAttribute("name","t"),div.appendChild(input),support.checkClone=div.cloneNode(!0).cloneNode(!0).lastChild.checked,div.innerHTML="<textarea>x</textarea>",support.noCloneChecked=!!div.cloneNode(!0).lastChild.defaultValue}();var strundefined="undefined";support.focusinBubbles="onfocusin"in window;var rkeyEvent=/^key/,rmouseEvent=/^(?:mouse|pointer|contextmenu)|click/,rfocusMorph=/^(?:focusinfocus|focusoutblur)$/,rtypenamespace=/^([^.]*)(?:\.(.+)|)$/;jQuery.event={global:{},add:function(elem,types,handler,data,selector){var handleObjIn,eventHandle,tmp,events,t,handleObj,special,handlers,type,namespaces,origType,elemData=data_priv.get(elem);if(elemData)for(handler.handler&&(handleObjIn=handler,handler=handleObjIn.handler,selector=handleObjIn.selector),handler.guid||(handler.guid=jQuery.guid++),(events=elemData.events)||(events=elemData.events={}),(eventHandle=elemData.handle)||(eventHandle=elemData.handle=function(e){return typeof jQuery!==strundefined&&jQuery.event.triggered!==e.type?jQuery.event.dispatch.apply(elem,arguments):void 0}),types=(types||"").match(rnotwhite)||[""],t=types.length;t--;)tmp=rtypenamespace.exec(types[t])||[],type=origType=tmp[1],namespaces=(tmp[2]||"").split(".").sort(),type&&(special=jQuery.event.special[type]||{},type=(selector?special.delegateType:special.bindType)||type,special=jQuery.event.special[type]||{},handleObj=jQuery.extend({type:type,origType:origType,data:data,handler:handler,guid:handler.guid,selector:selector,needsContext:selector&&jQuery.expr.match.needsContext.test(selector),namespace:namespaces.join(".")},handleObjIn),(handlers=events[type])||(handlers=events[type]=[],handlers.delegateCount=0,special.setup&&special.setup.call(elem,data,namespaces,eventHandle)!==!1||elem.addEventListener&&elem.addEventListener(type,eventHandle,!1)),special.add&&(special.add.call(elem,handleObj),handleObj.handler.guid||(handleObj.handler.guid=handler.guid)),selector?handlers.splice(handlers.delegateCount++,0,handleObj):handlers.push(handleObj),jQuery.event.global[type]=!0)},remove:function(elem,types,handler,selector,mappedTypes){var j,origCount,tmp,events,t,handleObj,special,handlers,type,namespaces,origType,elemData=data_priv.hasData(elem)&&data_priv.get(elem);if(elemData&&(events=elemData.events)){for(types=(types||"").match(rnotwhite)||[""],t=types.length;t--;)if(tmp=rtypenamespace.exec(types[t])||[],type=origType=tmp[1],namespaces=(tmp[2]||"").split(".").sort(),type){for(special=jQuery.event.special[type]||{},type=(selector?special.delegateType:special.bindType)||type,handlers=events[type]||[],tmp=tmp[2]&&new RegExp("(^|\\.)"+namespaces.join("\\.(?:.*\\.|)")+"(\\.|$)"),origCount=j=handlers.length;j--;)handleObj=handlers[j],!mappedTypes&&origType!==handleObj.origType||handler&&handler.guid!==handleObj.guid||tmp&&!tmp.test(handleObj.namespace)||selector&&selector!==handleObj.selector&&("**"!==selector||!handleObj.selector)||(handlers.splice(j,1),handleObj.selector&&handlers.delegateCount--,special.remove&&special.remove.call(elem,handleObj));origCount&&!handlers.length&&(special.teardown&&special.teardown.call(elem,namespaces,elemData.handle)!==!1||jQuery.removeEvent(elem,type,elemData.handle),delete events[type])}else for(type in events)jQuery.event.remove(elem,type+types[t],handler,selector,!0);jQuery.isEmptyObject(events)&&(delete elemData.handle,data_priv.remove(elem,"events"))}},trigger:function(event,data,elem,onlyHandlers){var i,cur,tmp,bubbleType,ontype,handle,special,eventPath=[elem||document],type=hasOwn.call(event,"type")?event.type:event,namespaces=hasOwn.call(event,"namespace")?event.namespace.split("."):[];if(cur=tmp=elem=elem||document,3!==elem.nodeType&&8!==elem.nodeType&&!rfocusMorph.test(type+jQuery.event.triggered)&&(type.indexOf(".")>=0&&(namespaces=type.split("."),type=namespaces.shift(),namespaces.sort()),ontype=type.indexOf(":")<0&&"on"+type,event=event[jQuery.expando]?event:new jQuery.Event(type,"object"==typeof event&&event),event.isTrigger=onlyHandlers?2:3,event.namespace=namespaces.join("."),event.namespace_re=event.namespace?new RegExp("(^|\\.)"+namespaces.join("\\.(?:.*\\.|)")+"(\\.|$)"):null,event.result=void 0,event.target||(event.target=elem),data=null==data?[event]:jQuery.makeArray(data,[event]),special=jQuery.event.special[type]||{},onlyHandlers||!special.trigger||special.trigger.apply(elem,data)!==!1)){if(!onlyHandlers&&!special.noBubble&&!jQuery.isWindow(elem)){for(bubbleType=special.delegateType||type,rfocusMorph.test(bubbleType+type)||(cur=cur.parentNode);cur;cur=cur.parentNode)eventPath.push(cur),tmp=cur;tmp===(elem.ownerDocument||document)&&eventPath.push(tmp.defaultView||tmp.parentWindow||window)}for(i=0;(cur=eventPath[i++])&&!event.isPropagationStopped();)event.type=i>1?bubbleType:special.bindType||type,handle=(data_priv.get(cur,"events")||{})[event.type]&&data_priv.get(cur,"handle"),handle&&handle.apply(cur,data),handle=ontype&&cur[ontype],handle&&handle.apply&&jQuery.acceptData(cur)&&(event.result=handle.apply(cur,data),event.result===!1&&event.preventDefault());return event.type=type,onlyHandlers||event.isDefaultPrevented()||special._default&&special._default.apply(eventPath.pop(),data)!==!1||!jQuery.acceptData(elem)||ontype&&jQuery.isFunction(elem[type])&&!jQuery.isWindow(elem)&&(tmp=elem[ontype],tmp&&(elem[ontype]=null),jQuery.event.triggered=type,elem[type](),jQuery.event.triggered=void 0,tmp&&(elem[ontype]=tmp)),event.result}},dispatch:function(event){event=jQuery.event.fix(event);var i,j,ret,matched,handleObj,handlerQueue=[],args=slice.call(arguments),handlers=(data_priv.get(this,"events")||{})[event.type]||[],special=jQuery.event.special[event.type]||{};if(args[0]=event,event.delegateTarget=this,!special.preDispatch||special.preDispatch.call(this,event)!==!1){for(handlerQueue=jQuery.event.handlers.call(this,event,handlers),i=0;(matched=handlerQueue[i++])&&!event.isPropagationStopped();)for(event.currentTarget=matched.elem,j=0;(handleObj=matched.handlers[j++])&&!event.isImmediatePropagationStopped();)(!event.namespace_re||event.namespace_re.test(handleObj.namespace))&&(event.handleObj=handleObj,event.data=handleObj.data,ret=((jQuery.event.special[handleObj.origType]||{}).handle||handleObj.handler).apply(matched.elem,args),void 0!==ret&&(event.result=ret)===!1&&(event.preventDefault(),event.stopPropagation()));return special.postDispatch&&special.postDispatch.call(this,event),event.result}},handlers:function(event,handlers){var i,matches,sel,handleObj,handlerQueue=[],delegateCount=handlers.delegateCount,cur=event.target;if(delegateCount&&cur.nodeType&&(!event.button||"click"!==event.type))for(;cur!==this;cur=cur.parentNode||this)if(cur.disabled!==!0||"click"!==event.type){for(matches=[],i=0;delegateCount>i;i++)handleObj=handlers[i],sel=handleObj.selector+" ",void 0===matches[sel]&&(matches[sel]=handleObj.needsContext?jQuery(sel,this).index(cur)>=0:jQuery.find(sel,this,null,[cur]).length),matches[sel]&&matches.push(handleObj);matches.length&&handlerQueue.push({elem:cur,handlers:matches})}return delegateCount<handlers.length&&handlerQueue.push({elem:this,handlers:handlers.slice(delegateCount)}),handlerQueue},props:"altKey bubbles cancelable ctrlKey currentTarget eventPhase metaKey relatedTarget shiftKey target timeStamp view which".split(" "),fixHooks:{},keyHooks:{props:"char charCode key keyCode".split(" "),filter:function(event,original){return null==event.which&&(event.which=null!=original.charCode?original.charCode:original.keyCode),event}},mouseHooks:{props:"button buttons clientX clientY offsetX offsetY pageX pageY screenX screenY toElement".split(" "),filter:function(event,original){var eventDoc,doc,body,button=original.button;return null==event.pageX&&null!=original.clientX&&(eventDoc=event.target.ownerDocument||document,doc=eventDoc.documentElement,body=eventDoc.body,event.pageX=original.clientX+(doc&&doc.scrollLeft||body&&body.scrollLeft||0)-(doc&&doc.clientLeft||body&&body.clientLeft||0),event.pageY=original.clientY+(doc&&doc.scrollTop||body&&body.scrollTop||0)-(doc&&doc.clientTop||body&&body.clientTop||0)),event.which||void 0===button||(event.which=1&button?1:2&button?3:4&button?2:0),event}},fix:function(event){if(event[jQuery.expando])return event;var i,prop,copy,type=event.type,originalEvent=event,fixHook=this.fixHooks[type];for(fixHook||(this.fixHooks[type]=fixHook=rmouseEvent.test(type)?this.mouseHooks:rkeyEvent.test(type)?this.keyHooks:{}),copy=fixHook.props?this.props.concat(fixHook.props):this.props,event=new jQuery.Event(originalEvent),i=copy.length;i--;)prop=copy[i],event[prop]=originalEvent[prop];return event.target||(event.target=document),3===event.target.nodeType&&(event.target=event.target.parentNode),fixHook.filter?fixHook.filter(event,originalEvent):event},special:{load:{noBubble:!0},focus:{trigger:function(){return this!==safeActiveElement()&&this.focus?(this.focus(),!1):void 0},delegateType:"focusin"},blur:{trigger:function(){return this===safeActiveElement()&&this.blur?(this.blur(),!1):void 0},delegateType:"focusout"},click:{trigger:function(){return"checkbox"===this.type&&this.click&&jQuery.nodeName(this,"input")?(this.click(),!1):void 0},_default:function(event){return jQuery.nodeName(event.target,"a")}},beforeunload:{postDispatch:function(event){void 0!==event.result&&event.originalEvent&&(event.originalEvent.returnValue=event.result)}}},simulate:function(type,elem,event,bubble){var e=jQuery.extend(new jQuery.Event,event,{type:type,isSimulated:!0,originalEvent:{}});bubble?jQuery.event.trigger(e,null,elem):jQuery.event.dispatch.call(elem,e),e.isDefaultPrevented()&&event.preventDefault()}},jQuery.removeEvent=function(elem,type,handle){elem.removeEventListener&&elem.removeEventListener(type,handle,!1)},jQuery.Event=function(src,props){return this instanceof jQuery.Event?(src&&src.type?(this.originalEvent=src,this.type=src.type,this.isDefaultPrevented=src.defaultPrevented||void 0===src.defaultPrevented&&src.returnValue===!1?returnTrue:returnFalse):this.type=src,props&&jQuery.extend(this,props),this.timeStamp=src&&src.timeStamp||jQuery.now(),void(this[jQuery.expando]=!0)):new jQuery.Event(src,props)},jQuery.Event.prototype={isDefaultPrevented:returnFalse,isPropagationStopped:returnFalse,isImmediatePropagationStopped:returnFalse,preventDefault:function(){var e=this.originalEvent;this.isDefaultPrevented=returnTrue,e&&e.preventDefault&&e.preventDefault()},stopPropagation:function(){var e=this.originalEvent;this.isPropagationStopped=returnTrue,e&&e.stopPropagation&&e.stopPropagation()},stopImmediatePropagation:function(){var e=this.originalEvent;this.isImmediatePropagationStopped=returnTrue,e&&e.stopImmediatePropagation&&e.stopImmediatePropagation(),this.stopPropagation()}},jQuery.each({mouseenter:"mouseover",mouseleave:"mouseout",pointerenter:"pointerover",pointerleave:"pointerout"},function(orig,fix){jQuery.event.special[orig]={delegateType:fix,bindType:fix,handle:function(event){var ret,target=this,related=event.relatedTarget,handleObj=event.handleObj;return(!related||related!==target&&!jQuery.contains(target,related))&&(event.type=handleObj.origType,ret=handleObj.handler.apply(this,arguments),event.type=fix),ret}}}),support.focusinBubbles||jQuery.each({focus:"focusin",blur:"focusout"},function(orig,fix){var handler=function(event){jQuery.event.simulate(fix,event.target,jQuery.event.fix(event),!0)};jQuery.event.special[fix]={setup:function(){var doc=this.ownerDocument||this,attaches=data_priv.access(doc,fix);attaches||doc.addEventListener(orig,handler,!0),data_priv.access(doc,fix,(attaches||0)+1)},teardown:function(){var doc=this.ownerDocument||this,attaches=data_priv.access(doc,fix)-1;attaches?data_priv.access(doc,fix,attaches):(doc.removeEventListener(orig,handler,!0),data_priv.remove(doc,fix))}}}),jQuery.fn.extend({on:function(types,selector,data,fn,one){var origFn,type;if("object"==typeof types){"string"!=typeof selector&&(data=data||selector,selector=void 0);for(type in types)this.on(type,selector,data,types[type],one);return this}if(null==data&&null==fn?(fn=selector,data=selector=void 0):null==fn&&("string"==typeof selector?(fn=data,data=void 0):(fn=data,data=selector,selector=void 0)),fn===!1)fn=returnFalse;else if(!fn)return this;return 1===one&&(origFn=fn,fn=function(event){return jQuery().off(event),origFn.apply(this,arguments)},fn.guid=origFn.guid||(origFn.guid=jQuery.guid++)),this.each(function(){jQuery.event.add(this,types,fn,data,selector)})},one:function(types,selector,data,fn){return this.on(types,selector,data,fn,1)},off:function(types,selector,fn){var handleObj,type;if(types&&types.preventDefault&&types.handleObj)return handleObj=types.handleObj,jQuery(types.delegateTarget).off(handleObj.namespace?handleObj.origType+"."+handleObj.namespace:handleObj.origType,handleObj.selector,handleObj.handler),this;if("object"==typeof types){for(type in types)this.off(type,selector,types[type]);return this}return(selector===!1||"function"==typeof selector)&&(fn=selector,selector=void 0),fn===!1&&(fn=returnFalse),this.each(function(){jQuery.event.remove(this,types,fn,selector)})},trigger:function(type,data){return this.each(function(){jQuery.event.trigger(type,data,this)})},triggerHandler:function(type,data){var elem=this[0];return elem?jQuery.event.trigger(type,data,elem,!0):void 0}});var rxhtmlTag=/<(?!area|br|col|embed|hr|img|input|link|meta|param)(([\w:]+)[^>]*)\/>/gi,rtagName=/<([\w:]+)/,rhtml=/<|&#?\w+;/,rnoInnerhtml=/<(?:script|style|link)/i,rchecked=/checked\s*(?:[^=]|=\s*.checked.)/i,rscriptType=/^$|\/(?:java|ecma)script/i,rscriptTypeMasked=/^true\/(.*)/,rcleanScript=/^\s*<!(?:\[CDATA\[|--)|(?:\]\]|--)>\s*$/g,wrapMap={option:[1,"<select multiple='multiple'>","</select>"],thead:[1,"<table>","</table>"],col:[2,"<table><colgroup>","</colgroup></table>"],tr:[2,"<table><tbody>","</tbody></table>"],td:[3,"<table><tbody><tr>","</tr></tbody></table>"],_default:[0,"",""]};wrapMap.optgroup=wrapMap.option,wrapMap.tbody=wrapMap.tfoot=wrapMap.colgroup=wrapMap.caption=wrapMap.thead,wrapMap.th=wrapMap.td,jQuery.extend({clone:function(elem,dataAndEvents,deepDataAndEvents){var i,l,srcElements,destElements,clone=elem.cloneNode(!0),inPage=jQuery.contains(elem.ownerDocument,elem);if(!(support.noCloneChecked||1!==elem.nodeType&&11!==elem.nodeType||jQuery.isXMLDoc(elem)))for(destElements=getAll(clone),srcElements=getAll(elem),i=0,l=srcElements.length;l>i;i++)fixInput(srcElements[i],destElements[i]);if(dataAndEvents)if(deepDataAndEvents)for(srcElements=srcElements||getAll(elem),destElements=destElements||getAll(clone),
i=0,l=srcElements.length;l>i;i++)cloneCopyEvent(srcElements[i],destElements[i]);else cloneCopyEvent(elem,clone);return destElements=getAll(clone,"script"),destElements.length>0&&setGlobalEval(destElements,!inPage&&getAll(elem,"script")),clone},buildFragment:function(elems,context,scripts,selection){for(var elem,tmp,tag,wrap,contains,j,fragment=context.createDocumentFragment(),nodes=[],i=0,l=elems.length;l>i;i++)if(elem=elems[i],elem||0===elem)if("object"===jQuery.type(elem))jQuery.merge(nodes,elem.nodeType?[elem]:elem);else if(rhtml.test(elem)){for(tmp=tmp||fragment.appendChild(context.createElement("div")),tag=(rtagName.exec(elem)||["",""])[1].toLowerCase(),wrap=wrapMap[tag]||wrapMap._default,tmp.innerHTML=wrap[1]+elem.replace(rxhtmlTag,"<$1></$2>")+wrap[2],j=wrap[0];j--;)tmp=tmp.lastChild;jQuery.merge(nodes,tmp.childNodes),tmp=fragment.firstChild,tmp.textContent=""}else nodes.push(context.createTextNode(elem));for(fragment.textContent="",i=0;elem=nodes[i++];)if((!selection||-1===jQuery.inArray(elem,selection))&&(contains=jQuery.contains(elem.ownerDocument,elem),tmp=getAll(fragment.appendChild(elem),"script"),contains&&setGlobalEval(tmp),scripts))for(j=0;elem=tmp[j++];)rscriptType.test(elem.type||"")&&scripts.push(elem);return fragment},cleanData:function(elems){for(var data,elem,type,key,special=jQuery.event.special,i=0;void 0!==(elem=elems[i]);i++){if(jQuery.acceptData(elem)&&(key=elem[data_priv.expando],key&&(data=data_priv.cache[key]))){if(data.events)for(type in data.events)special[type]?jQuery.event.remove(elem,type):jQuery.removeEvent(elem,type,data.handle);data_priv.cache[key]&&delete data_priv.cache[key]}delete data_user.cache[elem[data_user.expando]]}}}),jQuery.fn.extend({text:function(value){return access(this,function(value){return void 0===value?jQuery.text(this):this.empty().each(function(){(1===this.nodeType||11===this.nodeType||9===this.nodeType)&&(this.textContent=value)})},null,value,arguments.length)},append:function(){return this.domManip(arguments,function(elem){if(1===this.nodeType||11===this.nodeType||9===this.nodeType){var target=manipulationTarget(this,elem);target.appendChild(elem)}})},prepend:function(){return this.domManip(arguments,function(elem){if(1===this.nodeType||11===this.nodeType||9===this.nodeType){var target=manipulationTarget(this,elem);target.insertBefore(elem,target.firstChild)}})},before:function(){return this.domManip(arguments,function(elem){this.parentNode&&this.parentNode.insertBefore(elem,this)})},after:function(){return this.domManip(arguments,function(elem){this.parentNode&&this.parentNode.insertBefore(elem,this.nextSibling)})},remove:function(selector,keepData){for(var elem,elems=selector?jQuery.filter(selector,this):this,i=0;null!=(elem=elems[i]);i++)keepData||1!==elem.nodeType||jQuery.cleanData(getAll(elem)),elem.parentNode&&(keepData&&jQuery.contains(elem.ownerDocument,elem)&&setGlobalEval(getAll(elem,"script")),elem.parentNode.removeChild(elem));return this},empty:function(){for(var elem,i=0;null!=(elem=this[i]);i++)1===elem.nodeType&&(jQuery.cleanData(getAll(elem,!1)),elem.textContent="");return this},clone:function(dataAndEvents,deepDataAndEvents){return dataAndEvents=null==dataAndEvents?!1:dataAndEvents,deepDataAndEvents=null==deepDataAndEvents?dataAndEvents:deepDataAndEvents,this.map(function(){return jQuery.clone(this,dataAndEvents,deepDataAndEvents)})},html:function(value){return access(this,function(value){var elem=this[0]||{},i=0,l=this.length;if(void 0===value&&1===elem.nodeType)return elem.innerHTML;if("string"==typeof value&&!rnoInnerhtml.test(value)&&!wrapMap[(rtagName.exec(value)||["",""])[1].toLowerCase()]){value=value.replace(rxhtmlTag,"<$1></$2>");try{for(;l>i;i++)elem=this[i]||{},1===elem.nodeType&&(jQuery.cleanData(getAll(elem,!1)),elem.innerHTML=value);elem=0}catch(e){}}elem&&this.empty().append(value)},null,value,arguments.length)},replaceWith:function(){var arg=arguments[0];return this.domManip(arguments,function(elem){arg=this.parentNode,jQuery.cleanData(getAll(this)),arg&&arg.replaceChild(elem,this)}),arg&&(arg.length||arg.nodeType)?this:this.remove()},detach:function(selector){return this.remove(selector,!0)},domManip:function(args,callback){args=concat.apply([],args);var fragment,first,scripts,hasScripts,node,doc,i=0,l=this.length,set=this,iNoClone=l-1,value=args[0],isFunction=jQuery.isFunction(value);if(isFunction||l>1&&"string"==typeof value&&!support.checkClone&&rchecked.test(value))return this.each(function(index){var self=set.eq(index);isFunction&&(args[0]=value.call(this,index,self.html())),self.domManip(args,callback)});if(l&&(fragment=jQuery.buildFragment(args,this[0].ownerDocument,!1,this),first=fragment.firstChild,1===fragment.childNodes.length&&(fragment=first),first)){for(scripts=jQuery.map(getAll(fragment,"script"),disableScript),hasScripts=scripts.length;l>i;i++)node=fragment,i!==iNoClone&&(node=jQuery.clone(node,!0,!0),hasScripts&&jQuery.merge(scripts,getAll(node,"script"))),callback.call(this[i],node,i);if(hasScripts)for(doc=scripts[scripts.length-1].ownerDocument,jQuery.map(scripts,restoreScript),i=0;hasScripts>i;i++)node=scripts[i],rscriptType.test(node.type||"")&&!data_priv.access(node,"globalEval")&&jQuery.contains(doc,node)&&(node.src?jQuery._evalUrl&&jQuery._evalUrl(node.src):jQuery.globalEval(node.textContent.replace(rcleanScript,"")))}return this}}),jQuery.each({appendTo:"append",prependTo:"prepend",insertBefore:"before",insertAfter:"after",replaceAll:"replaceWith"},function(name,original){jQuery.fn[name]=function(selector){for(var elems,ret=[],insert=jQuery(selector),last=insert.length-1,i=0;last>=i;i++)elems=i===last?this:this.clone(!0),jQuery(insert[i])[original](elems),push.apply(ret,elems.get());return this.pushStack(ret)}});var iframe,elemdisplay={},rmargin=/^margin/,rnumnonpx=new RegExp("^("+pnum+")(?!px)[a-z%]+$","i"),getStyles=function(elem){return elem.ownerDocument.defaultView.opener?elem.ownerDocument.defaultView.getComputedStyle(elem,null):window.getComputedStyle(elem,null)};!function(){function computePixelPositionAndBoxSizingReliable(){div.style.cssText="-webkit-box-sizing:border-box;-moz-box-sizing:border-box;box-sizing:border-box;display:block;margin-top:1%;top:1%;border:1px;padding:1px;width:4px;position:absolute",div.innerHTML="",docElem.appendChild(container);var divStyle=window.getComputedStyle(div,null);pixelPositionVal="1%"!==divStyle.top,boxSizingReliableVal="4px"===divStyle.width,docElem.removeChild(container)}var pixelPositionVal,boxSizingReliableVal,docElem=document.documentElement,container=document.createElement("div"),div=document.createElement("div");div.style&&(div.style.backgroundClip="content-box",div.cloneNode(!0).style.backgroundClip="",support.clearCloneStyle="content-box"===div.style.backgroundClip,container.style.cssText="border:0;width:0;height:0;top:0;left:-9999px;margin-top:1px;position:absolute",container.appendChild(div),window.getComputedStyle&&jQuery.extend(support,{pixelPosition:function(){return computePixelPositionAndBoxSizingReliable(),pixelPositionVal},boxSizingReliable:function(){return null==boxSizingReliableVal&&computePixelPositionAndBoxSizingReliable(),boxSizingReliableVal},reliableMarginRight:function(){var ret,marginDiv=div.appendChild(document.createElement("div"));return marginDiv.style.cssText=div.style.cssText="-webkit-box-sizing:content-box;-moz-box-sizing:content-box;box-sizing:content-box;display:block;margin:0;border:0;padding:0",marginDiv.style.marginRight=marginDiv.style.width="0",div.style.width="1px",docElem.appendChild(container),ret=!parseFloat(window.getComputedStyle(marginDiv,null).marginRight),docElem.removeChild(container),div.removeChild(marginDiv),ret}}))}(),jQuery.swap=function(elem,options,callback,args){var ret,name,old={};for(name in options)old[name]=elem.style[name],elem.style[name]=options[name];ret=callback.apply(elem,args||[]);for(name in options)elem.style[name]=old[name];return ret};var rdisplayswap=/^(none|table(?!-c[ea]).+)/,rnumsplit=new RegExp("^("+pnum+")(.*)$","i"),rrelNum=new RegExp("^([+-])=("+pnum+")","i"),cssShow={position:"absolute",visibility:"hidden",display:"block"},cssNormalTransform={letterSpacing:"0",fontWeight:"400"},cssPrefixes=["Webkit","O","Moz","ms"];jQuery.extend({cssHooks:{opacity:{get:function(elem,computed){if(computed){var ret=curCSS(elem,"opacity");return""===ret?"1":ret}}}},cssNumber:{columnCount:!0,fillOpacity:!0,flexGrow:!0,flexShrink:!0,fontWeight:!0,lineHeight:!0,opacity:!0,order:!0,orphans:!0,widows:!0,zIndex:!0,zoom:!0},cssProps:{"float":"cssFloat"},style:function(elem,name,value,extra){if(elem&&3!==elem.nodeType&&8!==elem.nodeType&&elem.style){var ret,type,hooks,origName=jQuery.camelCase(name),style=elem.style;return name=jQuery.cssProps[origName]||(jQuery.cssProps[origName]=vendorPropName(style,origName)),hooks=jQuery.cssHooks[name]||jQuery.cssHooks[origName],void 0===value?hooks&&"get"in hooks&&void 0!==(ret=hooks.get(elem,!1,extra))?ret:style[name]:(type=typeof value,"string"===type&&(ret=rrelNum.exec(value))&&(value=(ret[1]+1)*ret[2]+parseFloat(jQuery.css(elem,name)),type="number"),null!=value&&value===value&&("number"!==type||jQuery.cssNumber[origName]||(value+="px"),support.clearCloneStyle||""!==value||0!==name.indexOf("background")||(style[name]="inherit"),hooks&&"set"in hooks&&void 0===(value=hooks.set(elem,value,extra))||(style[name]=value)),void 0)}},css:function(elem,name,extra,styles){var val,num,hooks,origName=jQuery.camelCase(name);return name=jQuery.cssProps[origName]||(jQuery.cssProps[origName]=vendorPropName(elem.style,origName)),hooks=jQuery.cssHooks[name]||jQuery.cssHooks[origName],hooks&&"get"in hooks&&(val=hooks.get(elem,!0,extra)),void 0===val&&(val=curCSS(elem,name,styles)),"normal"===val&&name in cssNormalTransform&&(val=cssNormalTransform[name]),""===extra||extra?(num=parseFloat(val),extra===!0||jQuery.isNumeric(num)?num||0:val):val}}),jQuery.each(["height","width"],function(i,name){jQuery.cssHooks[name]={get:function(elem,computed,extra){return computed?rdisplayswap.test(jQuery.css(elem,"display"))&&0===elem.offsetWidth?jQuery.swap(elem,cssShow,function(){return getWidthOrHeight(elem,name,extra)}):getWidthOrHeight(elem,name,extra):void 0},set:function(elem,value,extra){var styles=extra&&getStyles(elem);return setPositiveNumber(elem,value,extra?augmentWidthOrHeight(elem,name,extra,"border-box"===jQuery.css(elem,"boxSizing",!1,styles),styles):0)}}}),jQuery.cssHooks.marginRight=addGetHookIf(support.reliableMarginRight,function(elem,computed){return computed?jQuery.swap(elem,{display:"inline-block"},curCSS,[elem,"marginRight"]):void 0}),jQuery.each({margin:"",padding:"",border:"Width"},function(prefix,suffix){jQuery.cssHooks[prefix+suffix]={expand:function(value){for(var i=0,expanded={},parts="string"==typeof value?value.split(" "):[value];4>i;i++)expanded[prefix+cssExpand[i]+suffix]=parts[i]||parts[i-2]||parts[0];return expanded}},rmargin.test(prefix)||(jQuery.cssHooks[prefix+suffix].set=setPositiveNumber)}),jQuery.fn.extend({css:function(name,value){return access(this,function(elem,name,value){var styles,len,map={},i=0;if(jQuery.isArray(name)){for(styles=getStyles(elem),len=name.length;len>i;i++)map[name[i]]=jQuery.css(elem,name[i],!1,styles);return map}return void 0!==value?jQuery.style(elem,name,value):jQuery.css(elem,name)},name,value,arguments.length>1)},show:function(){return showHide(this,!0)},hide:function(){return showHide(this)},toggle:function(state){return"boolean"==typeof state?state?this.show():this.hide():this.each(function(){isHidden(this)?jQuery(this).show():jQuery(this).hide()})}}),jQuery.Tween=Tween,Tween.prototype={constructor:Tween,init:function(elem,options,prop,end,easing,unit){this.elem=elem,this.prop=prop,this.easing=easing||"swing",this.options=options,this.start=this.now=this.cur(),this.end=end,this.unit=unit||(jQuery.cssNumber[prop]?"":"px")},cur:function(){var hooks=Tween.propHooks[this.prop];return hooks&&hooks.get?hooks.get(this):Tween.propHooks._default.get(this)},run:function(percent){var eased,hooks=Tween.propHooks[this.prop];return this.options.duration?this.pos=eased=jQuery.easing[this.easing](percent,this.options.duration*percent,0,1,this.options.duration):this.pos=eased=percent,this.now=(this.end-this.start)*eased+this.start,this.options.step&&this.options.step.call(this.elem,this.now,this),hooks&&hooks.set?hooks.set(this):Tween.propHooks._default.set(this),this}},Tween.prototype.init.prototype=Tween.prototype,Tween.propHooks={_default:{get:function(tween){var result;return null==tween.elem[tween.prop]||tween.elem.style&&null!=tween.elem.style[tween.prop]?(result=jQuery.css(tween.elem,tween.prop,""),result&&"auto"!==result?result:0):tween.elem[tween.prop]},set:function(tween){jQuery.fx.step[tween.prop]?jQuery.fx.step[tween.prop](tween):tween.elem.style&&(null!=tween.elem.style[jQuery.cssProps[tween.prop]]||jQuery.cssHooks[tween.prop])?jQuery.style(tween.elem,tween.prop,tween.now+tween.unit):tween.elem[tween.prop]=tween.now}}},Tween.propHooks.scrollTop=Tween.propHooks.scrollLeft={set:function(tween){tween.elem.nodeType&&tween.elem.parentNode&&(tween.elem[tween.prop]=tween.now)}},jQuery.easing={linear:function(p){return p},swing:function(p){return.5-Math.cos(p*Math.PI)/2}},jQuery.fx=Tween.prototype.init,jQuery.fx.step={};var fxNow,timerId,rfxtypes=/^(?:toggle|show|hide)$/,rfxnum=new RegExp("^(?:([+-])=|)("+pnum+")([a-z%]*)$","i"),rrun=/queueHooks$/,animationPrefilters=[defaultPrefilter],tweeners={"*":[function(prop,value){var tween=this.createTween(prop,value),target=tween.cur(),parts=rfxnum.exec(value),unit=parts&&parts[3]||(jQuery.cssNumber[prop]?"":"px"),start=(jQuery.cssNumber[prop]||"px"!==unit&&+target)&&rfxnum.exec(jQuery.css(tween.elem,prop)),scale=1,maxIterations=20;if(start&&start[3]!==unit){unit=unit||start[3],parts=parts||[],start=+target||1;do scale=scale||".5",start/=scale,jQuery.style(tween.elem,prop,start+unit);while(scale!==(scale=tween.cur()/target)&&1!==scale&&--maxIterations)}return parts&&(start=tween.start=+start||+target||0,tween.unit=unit,tween.end=parts[1]?start+(parts[1]+1)*parts[2]:+parts[2]),tween}]};jQuery.Animation=jQuery.extend(Animation,{tweener:function(props,callback){jQuery.isFunction(props)?(callback=props,props=["*"]):props=props.split(" ");for(var prop,index=0,length=props.length;length>index;index++)prop=props[index],tweeners[prop]=tweeners[prop]||[],tweeners[prop].unshift(callback)},prefilter:function(callback,prepend){prepend?animationPrefilters.unshift(callback):animationPrefilters.push(callback)}}),jQuery.speed=function(speed,easing,fn){var opt=speed&&"object"==typeof speed?jQuery.extend({},speed):{complete:fn||!fn&&easing||jQuery.isFunction(speed)&&speed,duration:speed,easing:fn&&easing||easing&&!jQuery.isFunction(easing)&&easing};return opt.duration=jQuery.fx.off?0:"number"==typeof opt.duration?opt.duration:opt.duration in jQuery.fx.speeds?jQuery.fx.speeds[opt.duration]:jQuery.fx.speeds._default,(null==opt.queue||opt.queue===!0)&&(opt.queue="fx"),opt.old=opt.complete,opt.complete=function(){jQuery.isFunction(opt.old)&&opt.old.call(this),opt.queue&&jQuery.dequeue(this,opt.queue)},opt},jQuery.fn.extend({fadeTo:function(speed,to,easing,callback){return this.filter(isHidden).css("opacity",0).show().end().animate({opacity:to},speed,easing,callback)},animate:function(prop,speed,easing,callback){var empty=jQuery.isEmptyObject(prop),optall=jQuery.speed(speed,easing,callback),doAnimation=function(){var anim=Animation(this,jQuery.extend({},prop),optall);(empty||data_priv.get(this,"finish"))&&anim.stop(!0)};return doAnimation.finish=doAnimation,empty||optall.queue===!1?this.each(doAnimation):this.queue(optall.queue,doAnimation)},stop:function(type,clearQueue,gotoEnd){var stopQueue=function(hooks){var stop=hooks.stop;delete hooks.stop,stop(gotoEnd)};return"string"!=typeof type&&(gotoEnd=clearQueue,clearQueue=type,type=void 0),clearQueue&&type!==!1&&this.queue(type||"fx",[]),this.each(function(){var dequeue=!0,index=null!=type&&type+"queueHooks",timers=jQuery.timers,data=data_priv.get(this);if(index)data[index]&&data[index].stop&&stopQueue(data[index]);else for(index in data)data[index]&&data[index].stop&&rrun.test(index)&&stopQueue(data[index]);for(index=timers.length;index--;)timers[index].elem!==this||null!=type&&timers[index].queue!==type||(timers[index].anim.stop(gotoEnd),dequeue=!1,timers.splice(index,1));(dequeue||!gotoEnd)&&jQuery.dequeue(this,type)})},finish:function(type){return type!==!1&&(type=type||"fx"),this.each(function(){var index,data=data_priv.get(this),queue=data[type+"queue"],hooks=data[type+"queueHooks"],timers=jQuery.timers,length=queue?queue.length:0;for(data.finish=!0,jQuery.queue(this,type,[]),hooks&&hooks.stop&&hooks.stop.call(this,!0),index=timers.length;index--;)timers[index].elem===this&&timers[index].queue===type&&(timers[index].anim.stop(!0),timers.splice(index,1));for(index=0;length>index;index++)queue[index]&&queue[index].finish&&queue[index].finish.call(this);delete data.finish})}}),jQuery.each(["toggle","show","hide"],function(i,name){var cssFn=jQuery.fn[name];jQuery.fn[name]=function(speed,easing,callback){return null==speed||"boolean"==typeof speed?cssFn.apply(this,arguments):this.animate(genFx(name,!0),speed,easing,callback)}}),jQuery.each({slideDown:genFx("show"),slideUp:genFx("hide"),slideToggle:genFx("toggle"),fadeIn:{opacity:"show"},fadeOut:{opacity:"hide"},fadeToggle:{opacity:"toggle"}},function(name,props){jQuery.fn[name]=function(speed,easing,callback){return this.animate(props,speed,easing,callback)}}),jQuery.timers=[],jQuery.fx.tick=function(){var timer,i=0,timers=jQuery.timers;for(fxNow=jQuery.now();i<timers.length;i++)timer=timers[i],timer()||timers[i]!==timer||timers.splice(i--,1);timers.length||jQuery.fx.stop(),fxNow=void 0},jQuery.fx.timer=function(timer){jQuery.timers.push(timer),timer()?jQuery.fx.start():jQuery.timers.pop()},jQuery.fx.interval=13,jQuery.fx.start=function(){timerId||(timerId=setInterval(jQuery.fx.tick,jQuery.fx.interval))},jQuery.fx.stop=function(){clearInterval(timerId),timerId=null},jQuery.fx.speeds={slow:600,fast:200,_default:400},jQuery.fn.delay=function(time,type){return time=jQuery.fx?jQuery.fx.speeds[time]||time:time,type=type||"fx",this.queue(type,function(next,hooks){var timeout=setTimeout(next,time);hooks.stop=function(){clearTimeout(timeout)}})},function(){var input=document.createElement("input"),select=document.createElement("select"),opt=select.appendChild(document.createElement("option"));input.type="checkbox",support.checkOn=""!==input.value,support.optSelected=opt.selected,select.disabled=!0,support.optDisabled=!opt.disabled,input=document.createElement("input"),input.value="t",input.type="radio",support.radioValue="t"===input.value}();var nodeHook,boolHook,attrHandle=jQuery.expr.attrHandle;jQuery.fn.extend({attr:function(name,value){return access(this,jQuery.attr,name,value,arguments.length>1)},removeAttr:function(name){return this.each(function(){jQuery.removeAttr(this,name)})}}),jQuery.extend({attr:function(elem,name,value){var hooks,ret,nType=elem.nodeType;if(elem&&3!==nType&&8!==nType&&2!==nType)return typeof elem.getAttribute===strundefined?jQuery.prop(elem,name,value):(1===nType&&jQuery.isXMLDoc(elem)||(name=name.toLowerCase(),hooks=jQuery.attrHooks[name]||(jQuery.expr.match.bool.test(name)?boolHook:nodeHook)),void 0===value?hooks&&"get"in hooks&&null!==(ret=hooks.get(elem,name))?ret:(ret=jQuery.find.attr(elem,name),null==ret?void 0:ret):null!==value?hooks&&"set"in hooks&&void 0!==(ret=hooks.set(elem,value,name))?ret:(elem.setAttribute(name,value+""),value):void jQuery.removeAttr(elem,name))},removeAttr:function(elem,value){var name,propName,i=0,attrNames=value&&value.match(rnotwhite);if(attrNames&&1===elem.nodeType)for(;name=attrNames[i++];)propName=jQuery.propFix[name]||name,jQuery.expr.match.bool.test(name)&&(elem[propName]=!1),elem.removeAttribute(name)},attrHooks:{type:{set:function(elem,value){if(!support.radioValue&&"radio"===value&&jQuery.nodeName(elem,"input")){var val=elem.value;return elem.setAttribute("type",value),val&&(elem.value=val),value}}}}}),boolHook={set:function(elem,value,name){return value===!1?jQuery.removeAttr(elem,name):elem.setAttribute(name,name),name}},jQuery.each(jQuery.expr.match.bool.source.match(/\w+/g),function(i,name){var getter=attrHandle[name]||jQuery.find.attr;attrHandle[name]=function(elem,name,isXML){var ret,handle;return isXML||(handle=attrHandle[name],attrHandle[name]=ret,ret=null!=getter(elem,name,isXML)?name.toLowerCase():null,attrHandle[name]=handle),ret}});var rfocusable=/^(?:input|select|textarea|button)$/i;jQuery.fn.extend({prop:function(name,value){return access(this,jQuery.prop,name,value,arguments.length>1)},removeProp:function(name){return this.each(function(){delete this[jQuery.propFix[name]||name]})}}),jQuery.extend({propFix:{"for":"htmlFor","class":"className"},prop:function(elem,name,value){var ret,hooks,notxml,nType=elem.nodeType;if(elem&&3!==nType&&8!==nType&&2!==nType)return notxml=1!==nType||!jQuery.isXMLDoc(elem),notxml&&(name=jQuery.propFix[name]||name,hooks=jQuery.propHooks[name]),void 0!==value?hooks&&"set"in hooks&&void 0!==(ret=hooks.set(elem,value,name))?ret:elem[name]=value:hooks&&"get"in hooks&&null!==(ret=hooks.get(elem,name))?ret:elem[name]},propHooks:{tabIndex:{get:function(elem){return elem.hasAttribute("tabindex")||rfocusable.test(elem.nodeName)||elem.href?elem.tabIndex:-1}}}}),support.optSelected||(jQuery.propHooks.selected={get:function(elem){var parent=elem.parentNode;return parent&&parent.parentNode&&parent.parentNode.selectedIndex,null}}),jQuery.each(["tabIndex","readOnly","maxLength","cellSpacing","cellPadding","rowSpan","colSpan","useMap","frameBorder","contentEditable"],function(){jQuery.propFix[this.toLowerCase()]=this});var rclass=/[\t\r\n\f]/g;jQuery.fn.extend({addClass:function(value){var classes,elem,cur,clazz,j,finalValue,proceed="string"==typeof value&&value,i=0,len=this.length;if(jQuery.isFunction(value))return this.each(function(j){jQuery(this).addClass(value.call(this,j,this.className))});if(proceed)for(classes=(value||"").match(rnotwhite)||[];len>i;i++)if(elem=this[i],cur=1===elem.nodeType&&(elem.className?(" "+elem.className+" ").replace(rclass," "):" ")){for(j=0;clazz=classes[j++];)cur.indexOf(" "+clazz+" ")<0&&(cur+=clazz+" ");finalValue=jQuery.trim(cur),elem.className!==finalValue&&(elem.className=finalValue)}return this},removeClass:function(value){var classes,elem,cur,clazz,j,finalValue,proceed=0===arguments.length||"string"==typeof value&&value,i=0,len=this.length;if(jQuery.isFunction(value))return this.each(function(j){jQuery(this).removeClass(value.call(this,j,this.className))});if(proceed)for(classes=(value||"").match(rnotwhite)||[];len>i;i++)if(elem=this[i],cur=1===elem.nodeType&&(elem.className?(" "+elem.className+" ").replace(rclass," "):"")){for(j=0;clazz=classes[j++];)for(;cur.indexOf(" "+clazz+" ")>=0;)cur=cur.replace(" "+clazz+" "," ");finalValue=value?jQuery.trim(cur):"",elem.className!==finalValue&&(elem.className=finalValue)}return this},toggleClass:function(value,stateVal){var type=typeof value;return"boolean"==typeof stateVal&&"string"===type?stateVal?this.addClass(value):this.removeClass(value):jQuery.isFunction(value)?this.each(function(i){jQuery(this).toggleClass(value.call(this,i,this.className,stateVal),stateVal)}):this.each(function(){if("string"===type)for(var className,i=0,self=jQuery(this),classNames=value.match(rnotwhite)||[];className=classNames[i++];)self.hasClass(className)?self.removeClass(className):self.addClass(className);else(type===strundefined||"boolean"===type)&&(this.className&&data_priv.set(this,"__className__",this.className),this.className=this.className||value===!1?"":data_priv.get(this,"__className__")||"")})},hasClass:function(selector){for(var className=" "+selector+" ",i=0,l=this.length;l>i;i++)if(1===this[i].nodeType&&(" "+this[i].className+" ").replace(rclass," ").indexOf(className)>=0)return!0;return!1}});var rreturn=/\r/g;jQuery.fn.extend({val:function(value){var hooks,ret,isFunction,elem=this[0];{if(arguments.length)return isFunction=jQuery.isFunction(value),this.each(function(i){var val;1===this.nodeType&&(val=isFunction?value.call(this,i,jQuery(this).val()):value,null==val?val="":"number"==typeof val?val+="":jQuery.isArray(val)&&(val=jQuery.map(val,function(value){return null==value?"":value+""})),hooks=jQuery.valHooks[this.type]||jQuery.valHooks[this.nodeName.toLowerCase()],hooks&&"set"in hooks&&void 0!==hooks.set(this,val,"value")||(this.value=val))});if(elem)return hooks=jQuery.valHooks[elem.type]||jQuery.valHooks[elem.nodeName.toLowerCase()],hooks&&"get"in hooks&&void 0!==(ret=hooks.get(elem,"value"))?ret:(ret=elem.value,"string"==typeof ret?ret.replace(rreturn,""):null==ret?"":ret)}}}),jQuery.extend({valHooks:{option:{get:function(elem){var val=jQuery.find.attr(elem,"value");return null!=val?val:jQuery.trim(jQuery.text(elem))}},select:{get:function(elem){for(var value,option,options=elem.options,index=elem.selectedIndex,one="select-one"===elem.type||0>index,values=one?null:[],max=one?index+1:options.length,i=0>index?max:one?index:0;max>i;i++)if(option=options[i],(option.selected||i===index)&&(support.optDisabled?!option.disabled:null===option.getAttribute("disabled"))&&(!option.parentNode.disabled||!jQuery.nodeName(option.parentNode,"optgroup"))){if(value=jQuery(option).val(),one)return value;values.push(value)}return values},set:function(elem,value){for(var optionSet,option,options=elem.options,values=jQuery.makeArray(value),i=options.length;i--;)option=options[i],(option.selected=jQuery.inArray(option.value,values)>=0)&&(optionSet=!0);return optionSet||(elem.selectedIndex=-1),values}}}}),jQuery.each(["radio","checkbox"],function(){jQuery.valHooks[this]={set:function(elem,value){return jQuery.isArray(value)?elem.checked=jQuery.inArray(jQuery(elem).val(),value)>=0:void 0}},support.checkOn||(jQuery.valHooks[this].get=function(elem){return null===elem.getAttribute("value")?"on":elem.value})}),jQuery.each("blur focus focusin focusout load resize scroll unload click dblclick mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave change select submit keydown keypress keyup error contextmenu".split(" "),function(i,name){jQuery.fn[name]=function(data,fn){return arguments.length>0?this.on(name,null,data,fn):this.trigger(name)}}),jQuery.fn.extend({hover:function(fnOver,fnOut){return this.mouseenter(fnOver).mouseleave(fnOut||fnOver)},bind:function(types,data,fn){return this.on(types,null,data,fn)},unbind:function(types,fn){return this.off(types,null,fn)},delegate:function(selector,types,data,fn){return this.on(types,selector,data,fn)},undelegate:function(selector,types,fn){return 1===arguments.length?this.off(selector,"**"):this.off(types,selector||"**",fn)}});var nonce=jQuery.now(),rquery=/\?/;jQuery.parseJSON=function(data){return JSON.parse(data+"")},jQuery.parseXML=function(data){var xml,tmp;if(!data||"string"!=typeof data)return null;try{tmp=new DOMParser,xml=tmp.parseFromString(data,"text/xml")}catch(e){xml=void 0}return(!xml||xml.getElementsByTagName("parsererror").length)&&jQuery.error("Invalid XML: "+data),xml};var rhash=/#.*$/,rts=/([?&])_=[^&]*/,rheaders=/^(.*?):[ \t]*([^\r\n]*)$/gm,rlocalProtocol=/^(?:about|app|app-storage|.+-extension|file|res|widget):$/,rnoContent=/^(?:GET|HEAD)$/,rprotocol=/^\/\//,rurl=/^([\w.+-]+:)(?:\/\/(?:[^\/?#]*@|)([^\/?#:]*)(?::(\d+)|)|)/,prefilters={},transports={},allTypes="*/".concat("*"),ajaxLocation=window.location.href,ajaxLocParts=rurl.exec(ajaxLocation.toLowerCase())||[];jQuery.extend({active:0,lastModified:{},etag:{},ajaxSettings:{url:ajaxLocation,type:"GET",isLocal:rlocalProtocol.test(ajaxLocParts[1]),global:!0,processData:!0,async:!0,contentType:"application/x-www-form-urlencoded; charset=UTF-8",accepts:{"*":allTypes,text:"text/plain",html:"text/html",xml:"application/xml, text/xml",json:"application/json, text/javascript"},contents:{xml:/xml/,html:/html/,json:/json/},responseFields:{xml:"responseXML",text:"responseText",json:"responseJSON"},converters:{"* text":String,"text html":!0,"text json":jQuery.parseJSON,"text xml":jQuery.parseXML},flatOptions:{url:!0,context:!0}},ajaxSetup:function(target,settings){return settings?ajaxExtend(ajaxExtend(target,jQuery.ajaxSettings),settings):ajaxExtend(jQuery.ajaxSettings,target)},ajaxPrefilter:addToPrefiltersOrTransports(prefilters),ajaxTransport:addToPrefiltersOrTransports(transports),ajax:function(url,options){function done(status,nativeStatusText,responses,headers){var isSuccess,success,error,response,modified,statusText=nativeStatusText;2!==state&&(state=2,timeoutTimer&&clearTimeout(timeoutTimer),transport=void 0,responseHeadersString=headers||"",jqXHR.readyState=status>0?4:0,isSuccess=status>=200&&300>status||304===status,responses&&(response=ajaxHandleResponses(s,jqXHR,responses)),response=ajaxConvert(s,response,jqXHR,isSuccess),isSuccess?(s.ifModified&&(modified=jqXHR.getResponseHeader("Last-Modified"),modified&&(jQuery.lastModified[cacheURL]=modified),modified=jqXHR.getResponseHeader("etag"),modified&&(jQuery.etag[cacheURL]=modified)),204===status||"HEAD"===s.type?statusText="nocontent":304===status?statusText="notmodified":(statusText=response.state,success=response.data,error=response.error,isSuccess=!error)):(error=statusText,(status||!statusText)&&(statusText="error",0>status&&(status=0))),jqXHR.status=status,jqXHR.statusText=(nativeStatusText||statusText)+"",isSuccess?deferred.resolveWith(callbackContext,[success,statusText,jqXHR]):deferred.rejectWith(callbackContext,[jqXHR,statusText,error]),jqXHR.statusCode(statusCode),statusCode=void 0,fireGlobals&&globalEventContext.trigger(isSuccess?"ajaxSuccess":"ajaxError",[jqXHR,s,isSuccess?success:error]),completeDeferred.fireWith(callbackContext,[jqXHR,statusText]),fireGlobals&&(globalEventContext.trigger("ajaxComplete",[jqXHR,s]),--jQuery.active||jQuery.event.trigger("ajaxStop")))}"object"==typeof url&&(options=url,url=void 0),options=options||{};var transport,cacheURL,responseHeadersString,responseHeaders,timeoutTimer,parts,fireGlobals,i,s=jQuery.ajaxSetup({},options),callbackContext=s.context||s,globalEventContext=s.context&&(callbackContext.nodeType||callbackContext.jquery)?jQuery(callbackContext):jQuery.event,deferred=jQuery.Deferred(),completeDeferred=jQuery.Callbacks("once memory"),statusCode=s.statusCode||{},requestHeaders={},requestHeadersNames={},state=0,strAbort="canceled",jqXHR={readyState:0,getResponseHeader:function(key){var match;if(2===state){if(!responseHeaders)for(responseHeaders={};match=rheaders.exec(responseHeadersString);)responseHeaders[match[1].toLowerCase()]=match[2];match=responseHeaders[key.toLowerCase()]}return null==match?null:match},getAllResponseHeaders:function(){return 2===state?responseHeadersString:null},setRequestHeader:function(name,value){var lname=name.toLowerCase();return state||(name=requestHeadersNames[lname]=requestHeadersNames[lname]||name,requestHeaders[name]=value),this},overrideMimeType:function(type){return state||(s.mimeType=type),this},statusCode:function(map){var code;if(map)if(2>state)for(code in map)statusCode[code]=[statusCode[code],map[code]];else jqXHR.always(map[jqXHR.status]);return this},abort:function(statusText){var finalText=statusText||strAbort;return transport&&transport.abort(finalText),done(0,finalText),this}};if(deferred.promise(jqXHR).complete=completeDeferred.add,jqXHR.success=jqXHR.done,jqXHR.error=jqXHR.fail,s.url=((url||s.url||ajaxLocation)+"").replace(rhash,"").replace(rprotocol,ajaxLocParts[1]+"//"),s.type=options.method||options.type||s.method||s.type,s.dataTypes=jQuery.trim(s.dataType||"*").toLowerCase().match(rnotwhite)||[""],null==s.crossDomain&&(parts=rurl.exec(s.url.toLowerCase()),s.crossDomain=!(!parts||parts[1]===ajaxLocParts[1]&&parts[2]===ajaxLocParts[2]&&(parts[3]||("http:"===parts[1]?"80":"443"))===(ajaxLocParts[3]||("http:"===ajaxLocParts[1]?"80":"443")))),s.data&&s.processData&&"string"!=typeof s.data&&(s.data=jQuery.param(s.data,s.traditional)),inspectPrefiltersOrTransports(prefilters,s,options,jqXHR),
2===state)return jqXHR;fireGlobals=jQuery.event&&s.global,fireGlobals&&0===jQuery.active++&&jQuery.event.trigger("ajaxStart"),s.type=s.type.toUpperCase(),s.hasContent=!rnoContent.test(s.type),cacheURL=s.url,s.hasContent||(s.data&&(cacheURL=s.url+=(rquery.test(cacheURL)?"&":"?")+s.data,delete s.data),s.cache===!1&&(s.url=rts.test(cacheURL)?cacheURL.replace(rts,"$1_="+nonce++):cacheURL+(rquery.test(cacheURL)?"&":"?")+"_="+nonce++)),s.ifModified&&(jQuery.lastModified[cacheURL]&&jqXHR.setRequestHeader("If-Modified-Since",jQuery.lastModified[cacheURL]),jQuery.etag[cacheURL]&&jqXHR.setRequestHeader("If-None-Match",jQuery.etag[cacheURL])),(s.data&&s.hasContent&&s.contentType!==!1||options.contentType)&&jqXHR.setRequestHeader("Content-Type",s.contentType),jqXHR.setRequestHeader("Accept",s.dataTypes[0]&&s.accepts[s.dataTypes[0]]?s.accepts[s.dataTypes[0]]+("*"!==s.dataTypes[0]?", "+allTypes+"; q=0.01":""):s.accepts["*"]);for(i in s.headers)jqXHR.setRequestHeader(i,s.headers[i]);if(s.beforeSend&&(s.beforeSend.call(callbackContext,jqXHR,s)===!1||2===state))return jqXHR.abort();strAbort="abort";for(i in{success:1,error:1,complete:1})jqXHR[i](s[i]);if(transport=inspectPrefiltersOrTransports(transports,s,options,jqXHR)){jqXHR.readyState=1,fireGlobals&&globalEventContext.trigger("ajaxSend",[jqXHR,s]),s.async&&s.timeout>0&&(timeoutTimer=setTimeout(function(){jqXHR.abort("timeout")},s.timeout));try{state=1,transport.send(requestHeaders,done)}catch(e){if(!(2>state))throw e;done(-1,e)}}else done(-1,"No Transport");return jqXHR},getJSON:function(url,data,callback){return jQuery.get(url,data,callback,"json")},getScript:function(url,callback){return jQuery.get(url,void 0,callback,"script")}}),jQuery.each(["get","post"],function(i,method){jQuery[method]=function(url,data,callback,type){return jQuery.isFunction(data)&&(type=type||callback,callback=data,data=void 0),jQuery.ajax({url:url,type:method,dataType:type,data:data,success:callback})}}),jQuery._evalUrl=function(url){return jQuery.ajax({url:url,type:"GET",dataType:"script",async:!1,global:!1,"throws":!0})},jQuery.fn.extend({wrapAll:function(html){var wrap;return jQuery.isFunction(html)?this.each(function(i){jQuery(this).wrapAll(html.call(this,i))}):(this[0]&&(wrap=jQuery(html,this[0].ownerDocument).eq(0).clone(!0),this[0].parentNode&&wrap.insertBefore(this[0]),wrap.map(function(){for(var elem=this;elem.firstElementChild;)elem=elem.firstElementChild;return elem}).append(this)),this)},wrapInner:function(html){return jQuery.isFunction(html)?this.each(function(i){jQuery(this).wrapInner(html.call(this,i))}):this.each(function(){var self=jQuery(this),contents=self.contents();contents.length?contents.wrapAll(html):self.append(html)})},wrap:function(html){var isFunction=jQuery.isFunction(html);return this.each(function(i){jQuery(this).wrapAll(isFunction?html.call(this,i):html)})},unwrap:function(){return this.parent().each(function(){jQuery.nodeName(this,"body")||jQuery(this).replaceWith(this.childNodes)}).end()}}),jQuery.expr.filters.hidden=function(elem){return elem.offsetWidth<=0&&elem.offsetHeight<=0},jQuery.expr.filters.visible=function(elem){return!jQuery.expr.filters.hidden(elem)};var r20=/%20/g,rbracket=/\[\]$/,rCRLF=/\r?\n/g,rsubmitterTypes=/^(?:submit|button|image|reset|file)$/i,rsubmittable=/^(?:input|select|textarea|keygen)/i;jQuery.param=function(a,traditional){var prefix,s=[],add=function(key,value){value=jQuery.isFunction(value)?value():null==value?"":value,s[s.length]=encodeURIComponent(key)+"="+encodeURIComponent(value)};if(void 0===traditional&&(traditional=jQuery.ajaxSettings&&jQuery.ajaxSettings.traditional),jQuery.isArray(a)||a.jquery&&!jQuery.isPlainObject(a))jQuery.each(a,function(){add(this.name,this.value)});else for(prefix in a)buildParams(prefix,a[prefix],traditional,add);return s.join("&").replace(r20,"+")},jQuery.fn.extend({serialize:function(){return jQuery.param(this.serializeArray())},serializeArray:function(){return this.map(function(){var elements=jQuery.prop(this,"elements");return elements?jQuery.makeArray(elements):this}).filter(function(){var type=this.type;return this.name&&!jQuery(this).is(":disabled")&&rsubmittable.test(this.nodeName)&&!rsubmitterTypes.test(type)&&(this.checked||!rcheckableType.test(type))}).map(function(i,elem){var val=jQuery(this).val();return null==val?null:jQuery.isArray(val)?jQuery.map(val,function(val){return{name:elem.name,value:val.replace(rCRLF,"\r\n")}}):{name:elem.name,value:val.replace(rCRLF,"\r\n")}}).get()}}),jQuery.ajaxSettings.xhr=function(){try{return new XMLHttpRequest}catch(e){}};var xhrId=0,xhrCallbacks={},xhrSuccessStatus={0:200,1223:204},xhrSupported=jQuery.ajaxSettings.xhr();window.attachEvent&&window.attachEvent("onunload",function(){for(var key in xhrCallbacks)xhrCallbacks[key]()}),support.cors=!!xhrSupported&&"withCredentials"in xhrSupported,support.ajax=xhrSupported=!!xhrSupported,jQuery.ajaxTransport(function(options){var callback;return support.cors||xhrSupported&&!options.crossDomain?{send:function(headers,complete){var i,xhr=options.xhr(),id=++xhrId;if(xhr.open(options.type,options.url,options.async,options.username,options.password),options.xhrFields)for(i in options.xhrFields)xhr[i]=options.xhrFields[i];options.mimeType&&xhr.overrideMimeType&&xhr.overrideMimeType(options.mimeType),options.crossDomain||headers["X-Requested-With"]||(headers["X-Requested-With"]="XMLHttpRequest");for(i in headers)xhr.setRequestHeader(i,headers[i]);callback=function(type){return function(){callback&&(delete xhrCallbacks[id],callback=xhr.onload=xhr.onerror=null,"abort"===type?xhr.abort():"error"===type?complete(xhr.status,xhr.statusText):complete(xhrSuccessStatus[xhr.status]||xhr.status,xhr.statusText,"string"==typeof xhr.responseText?{text:xhr.responseText}:void 0,xhr.getAllResponseHeaders()))}},xhr.onload=callback(),xhr.onerror=callback("error"),callback=xhrCallbacks[id]=callback("abort");try{xhr.send(options.hasContent&&options.data||null)}catch(e){if(callback)throw e}},abort:function(){callback&&callback()}}:void 0}),jQuery.ajaxSetup({accepts:{script:"text/javascript, application/javascript, application/ecmascript, application/x-ecmascript"},contents:{script:/(?:java|ecma)script/},converters:{"text script":function(text){return jQuery.globalEval(text),text}}}),jQuery.ajaxPrefilter("script",function(s){void 0===s.cache&&(s.cache=!1),s.crossDomain&&(s.type="GET")}),jQuery.ajaxTransport("script",function(s){if(s.crossDomain){var script,callback;return{send:function(_,complete){script=jQuery("<script>").prop({async:!0,charset:s.scriptCharset,src:s.url}).on("load error",callback=function(evt){script.remove(),callback=null,evt&&complete("error"===evt.type?404:200,evt.type)}),document.head.appendChild(script[0])},abort:function(){callback&&callback()}}}});var oldCallbacks=[],rjsonp=/(=)\?(?=&|$)|\?\?/;jQuery.ajaxSetup({jsonp:"callback",jsonpCallback:function(){var callback=oldCallbacks.pop()||jQuery.expando+"_"+nonce++;return this[callback]=!0,callback}}),jQuery.ajaxPrefilter("json jsonp",function(s,originalSettings,jqXHR){var callbackName,overwritten,responseContainer,jsonProp=s.jsonp!==!1&&(rjsonp.test(s.url)?"url":"string"==typeof s.data&&!(s.contentType||"").indexOf("application/x-www-form-urlencoded")&&rjsonp.test(s.data)&&"data");return jsonProp||"jsonp"===s.dataTypes[0]?(callbackName=s.jsonpCallback=jQuery.isFunction(s.jsonpCallback)?s.jsonpCallback():s.jsonpCallback,jsonProp?s[jsonProp]=s[jsonProp].replace(rjsonp,"$1"+callbackName):s.jsonp!==!1&&(s.url+=(rquery.test(s.url)?"&":"?")+s.jsonp+"="+callbackName),s.converters["script json"]=function(){return responseContainer||jQuery.error(callbackName+" was not called"),responseContainer[0]},s.dataTypes[0]="json",overwritten=window[callbackName],window[callbackName]=function(){responseContainer=arguments},jqXHR.always(function(){window[callbackName]=overwritten,s[callbackName]&&(s.jsonpCallback=originalSettings.jsonpCallback,oldCallbacks.push(callbackName)),responseContainer&&jQuery.isFunction(overwritten)&&overwritten(responseContainer[0]),responseContainer=overwritten=void 0}),"script"):void 0}),jQuery.parseHTML=function(data,context,keepScripts){if(!data||"string"!=typeof data)return null;"boolean"==typeof context&&(keepScripts=context,context=!1),context=context||document;var parsed=rsingleTag.exec(data),scripts=!keepScripts&&[];return parsed?[context.createElement(parsed[1])]:(parsed=jQuery.buildFragment([data],context,scripts),scripts&&scripts.length&&jQuery(scripts).remove(),jQuery.merge([],parsed.childNodes))};var _load=jQuery.fn.load;jQuery.fn.load=function(url,params,callback){if("string"!=typeof url&&_load)return _load.apply(this,arguments);var selector,type,response,self=this,off=url.indexOf(" ");return off>=0&&(selector=jQuery.trim(url.slice(off)),url=url.slice(0,off)),jQuery.isFunction(params)?(callback=params,params=void 0):params&&"object"==typeof params&&(type="POST"),self.length>0&&jQuery.ajax({url:url,type:type,dataType:"html",data:params}).done(function(responseText){response=arguments,self.html(selector?jQuery("<div>").append(jQuery.parseHTML(responseText)).find(selector):responseText)}).complete(callback&&function(jqXHR,status){self.each(callback,response||[jqXHR.responseText,status,jqXHR])}),this},jQuery.each(["ajaxStart","ajaxStop","ajaxComplete","ajaxError","ajaxSuccess","ajaxSend"],function(i,type){jQuery.fn[type]=function(fn){return this.on(type,fn)}}),jQuery.expr.filters.animated=function(elem){return jQuery.grep(jQuery.timers,function(fn){return elem===fn.elem}).length};var docElem=window.document.documentElement;jQuery.offset={setOffset:function(elem,options,i){var curPosition,curLeft,curCSSTop,curTop,curOffset,curCSSLeft,calculatePosition,position=jQuery.css(elem,"position"),curElem=jQuery(elem),props={};"static"===position&&(elem.style.position="relative"),curOffset=curElem.offset(),curCSSTop=jQuery.css(elem,"top"),curCSSLeft=jQuery.css(elem,"left"),calculatePosition=("absolute"===position||"fixed"===position)&&(curCSSTop+curCSSLeft).indexOf("auto")>-1,calculatePosition?(curPosition=curElem.position(),curTop=curPosition.top,curLeft=curPosition.left):(curTop=parseFloat(curCSSTop)||0,curLeft=parseFloat(curCSSLeft)||0),jQuery.isFunction(options)&&(options=options.call(elem,i,curOffset)),null!=options.top&&(props.top=options.top-curOffset.top+curTop),null!=options.left&&(props.left=options.left-curOffset.left+curLeft),"using"in options?options.using.call(elem,props):curElem.css(props)}},jQuery.fn.extend({offset:function(options){if(arguments.length)return void 0===options?this:this.each(function(i){jQuery.offset.setOffset(this,options,i)});var docElem,win,elem=this[0],box={top:0,left:0},doc=elem&&elem.ownerDocument;if(doc)return docElem=doc.documentElement,jQuery.contains(docElem,elem)?(typeof elem.getBoundingClientRect!==strundefined&&(box=elem.getBoundingClientRect()),win=getWindow(doc),{top:box.top+win.pageYOffset-docElem.clientTop,left:box.left+win.pageXOffset-docElem.clientLeft}):box},position:function(){if(this[0]){var offsetParent,offset,elem=this[0],parentOffset={top:0,left:0};return"fixed"===jQuery.css(elem,"position")?offset=elem.getBoundingClientRect():(offsetParent=this.offsetParent(),offset=this.offset(),jQuery.nodeName(offsetParent[0],"html")||(parentOffset=offsetParent.offset()),parentOffset.top+=jQuery.css(offsetParent[0],"borderTopWidth",!0),parentOffset.left+=jQuery.css(offsetParent[0],"borderLeftWidth",!0)),{top:offset.top-parentOffset.top-jQuery.css(elem,"marginTop",!0),left:offset.left-parentOffset.left-jQuery.css(elem,"marginLeft",!0)}}},offsetParent:function(){return this.map(function(){for(var offsetParent=this.offsetParent||docElem;offsetParent&&!jQuery.nodeName(offsetParent,"html")&&"static"===jQuery.css(offsetParent,"position");)offsetParent=offsetParent.offsetParent;return offsetParent||docElem})}}),jQuery.each({scrollLeft:"pageXOffset",scrollTop:"pageYOffset"},function(method,prop){var top="pageYOffset"===prop;jQuery.fn[method]=function(val){return access(this,function(elem,method,val){var win=getWindow(elem);return void 0===val?win?win[prop]:elem[method]:void(win?win.scrollTo(top?window.pageXOffset:val,top?val:window.pageYOffset):elem[method]=val)},method,val,arguments.length,null)}}),jQuery.each(["top","left"],function(i,prop){jQuery.cssHooks[prop]=addGetHookIf(support.pixelPosition,function(elem,computed){return computed?(computed=curCSS(elem,prop),rnumnonpx.test(computed)?jQuery(elem).position()[prop]+"px":computed):void 0})}),jQuery.each({Height:"height",Width:"width"},function(name,type){jQuery.each({padding:"inner"+name,content:type,"":"outer"+name},function(defaultExtra,funcName){jQuery.fn[funcName]=function(margin,value){var chainable=arguments.length&&(defaultExtra||"boolean"!=typeof margin),extra=defaultExtra||(margin===!0||value===!0?"margin":"border");return access(this,function(elem,type,value){var doc;return jQuery.isWindow(elem)?elem.document.documentElement["client"+name]:9===elem.nodeType?(doc=elem.documentElement,Math.max(elem.body["scroll"+name],doc["scroll"+name],elem.body["offset"+name],doc["offset"+name],doc["client"+name])):void 0===value?jQuery.css(elem,type,extra):jQuery.style(elem,type,value,extra)},type,chainable?margin:void 0,chainable,null)}})}),jQuery.fn.size=function(){return this.length},jQuery.fn.andSelf=jQuery.fn.addBack,"function"==typeof define&&define.amd&&define("jquery",[],function(){return jQuery});var _jQuery=window.jQuery,_$=window.$;return jQuery.noConflict=function(deep){return window.$===jQuery&&(window.$=_$),deep&&window.jQuery===jQuery&&(window.jQuery=_jQuery),jQuery},typeof noGlobal===strundefined&&(window.jQuery=window.$=jQuery),jQuery}),function(window){function isArraylike(obj){var length=obj.length,type=$.type(obj);return"function"===type||$.isWindow(obj)?!1:1===obj.nodeType&&length?!0:"array"===type||0===length||"number"==typeof length&&length>0&&length-1 in obj}if(!window.jQuery){var $=function(selector,context){return new $.fn.init(selector,context)};$.isWindow=function(obj){return null!=obj&&obj==obj.window},$.type=function(obj){return null==obj?obj+"":"object"==typeof obj||"function"==typeof obj?class2type[toString.call(obj)]||"object":typeof obj},$.isArray=Array.isArray||function(obj){return"array"===$.type(obj)},$.isPlainObject=function(obj){var key;if(!obj||"object"!==$.type(obj)||obj.nodeType||$.isWindow(obj))return!1;try{if(obj.constructor&&!hasOwn.call(obj,"constructor")&&!hasOwn.call(obj.constructor.prototype,"isPrototypeOf"))return!1}catch(e){return!1}for(key in obj);return void 0===key||hasOwn.call(obj,key)},$.each=function(obj,callback,args){var value,i=0,length=obj.length,isArray=isArraylike(obj);if(args){if(isArray)for(;length>i&&(value=callback.apply(obj[i],args),value!==!1);i++);else for(i in obj)if(value=callback.apply(obj[i],args),value===!1)break}else if(isArray)for(;length>i&&(value=callback.call(obj[i],i,obj[i]),value!==!1);i++);else for(i in obj)if(value=callback.call(obj[i],i,obj[i]),value===!1)break;return obj},$.data=function(node,key,value){if(void 0===value){var id=node[$.expando],store=id&&cache[id];if(void 0===key)return store;if(store&&key in store)return store[key]}else if(void 0!==key){var id=node[$.expando]||(node[$.expando]=++$.uuid);return cache[id]=cache[id]||{},cache[id][key]=value,value}},$.removeData=function(node,keys){var id=node[$.expando],store=id&&cache[id];store&&$.each(keys,function(_,key){delete store[key]})},$.extend=function(){var src,copyIsArray,copy,name,options,clone,target=arguments[0]||{},i=1,length=arguments.length,deep=!1;for("boolean"==typeof target&&(deep=target,target=arguments[i]||{},i++),"object"!=typeof target&&"function"!==$.type(target)&&(target={}),i===length&&(target=this,i--);length>i;i++)if(null!=(options=arguments[i]))for(name in options)src=target[name],copy=options[name],target!==copy&&(deep&&copy&&($.isPlainObject(copy)||(copyIsArray=$.isArray(copy)))?(copyIsArray?(copyIsArray=!1,clone=src&&$.isArray(src)?src:[]):clone=src&&$.isPlainObject(src)?src:{},target[name]=$.extend(deep,clone,copy)):void 0!==copy&&(target[name]=copy));return target},$.queue=function(elem,type,data){function $makeArray(arr,results){var ret=results||[];return null!=arr&&(isArraylike(Object(arr))?!function(first,second){for(var len=+second.length,j=0,i=first.length;len>j;)first[i++]=second[j++];if(len!==len)for(;void 0!==second[j];)first[i++]=second[j++];return first.length=i,first}(ret,"string"==typeof arr?[arr]:arr):[].push.call(ret,arr)),ret}if(elem){type=(type||"fx")+"queue";var q=$.data(elem,type);return data?(!q||$.isArray(data)?q=$.data(elem,type,$makeArray(data)):q.push(data),q):q||[]}},$.dequeue=function(elems,type){$.each(elems.nodeType?[elems]:elems,function(i,elem){type=type||"fx";var queue=$.queue(elem,type),fn=queue.shift();"inprogress"===fn&&(fn=queue.shift()),fn&&("fx"===type&&queue.unshift("inprogress"),fn.call(elem,function(){$.dequeue(elem,type)}))})},$.fn=$.prototype={init:function(selector){if(selector.nodeType)return this[0]=selector,this;throw new Error("Not a DOM node.")},offset:function(){var box=this[0].getBoundingClientRect?this[0].getBoundingClientRect():{top:0,left:0};return{top:box.top+(window.pageYOffset||document.scrollTop||0)-(document.clientTop||0),left:box.left+(window.pageXOffset||document.scrollLeft||0)-(document.clientLeft||0)}},position:function(){function offsetParent(){for(var offsetParent=this.offsetParent||document;offsetParent&&"html"===!offsetParent.nodeType.toLowerCase&&"static"===offsetParent.style.position;)offsetParent=offsetParent.offsetParent;return offsetParent||document}var elem=this[0],offsetParent=offsetParent.apply(elem),offset=this.offset(),parentOffset=/^(?:body|html)$/i.test(offsetParent.nodeName)?{top:0,left:0}:$(offsetParent).offset();return offset.top-=parseFloat(elem.style.marginTop)||0,offset.left-=parseFloat(elem.style.marginLeft)||0,offsetParent.style&&(parentOffset.top+=parseFloat(offsetParent.style.borderTopWidth)||0,parentOffset.left+=parseFloat(offsetParent.style.borderLeftWidth)||0),{top:offset.top-parentOffset.top,left:offset.left-parentOffset.left}}};var cache={};$.expando="velocity"+(new Date).getTime(),$.uuid=0;for(var class2type={},hasOwn=class2type.hasOwnProperty,toString=class2type.toString,types="Boolean Number String Function Array Date RegExp Object Error".split(" "),i=0;i<types.length;i++)class2type["[object "+types[i]+"]"]=types[i].toLowerCase();$.fn.init.prototype=$.fn,window.Velocity={Utilities:$}}}(window),function(factory){"object"==typeof module&&"object"==typeof module.exports?module.exports=factory():"function"==typeof define&&define.amd?define(factory):factory()}(function(){return function(global,window,document,undefined){function compactSparseArray(array){for(var index=-1,length=array?array.length:0,result=[];++index<length;){var value=array[index];value&&result.push(value)}return result}function sanitizeElements(elements){return Type.isWrapped(elements)?elements=[].slice.call(elements):Type.isNode(elements)&&(elements=[elements]),elements}function Data(element){var response=$.data(element,"velocity");return null===response?undefined:response}function generateStep(steps){return function(p){return Math.round(p*steps)*(1/steps)}}function generateBezier(mX1,mY1,mX2,mY2){function A(aA1,aA2){return 1-3*aA2+3*aA1}function B(aA1,aA2){return 3*aA2-6*aA1}function C(aA1){return 3*aA1}function calcBezier(aT,aA1,aA2){return((A(aA1,aA2)*aT+B(aA1,aA2))*aT+C(aA1))*aT}function getSlope(aT,aA1,aA2){return 3*A(aA1,aA2)*aT*aT+2*B(aA1,aA2)*aT+C(aA1)}function newtonRaphsonIterate(aX,aGuessT){for(var i=0;NEWTON_ITERATIONS>i;++i){var currentSlope=getSlope(aGuessT,mX1,mX2);if(0===currentSlope)return aGuessT;var currentX=calcBezier(aGuessT,mX1,mX2)-aX;aGuessT-=currentX/currentSlope}return aGuessT}function calcSampleValues(){for(var i=0;kSplineTableSize>i;++i)mSampleValues[i]=calcBezier(i*kSampleStepSize,mX1,mX2)}function binarySubdivide(aX,aA,aB){var currentX,currentT,i=0;do currentT=aA+(aB-aA)/2,currentX=calcBezier(currentT,mX1,mX2)-aX,currentX>0?aB=currentT:aA=currentT;while(Math.abs(currentX)>SUBDIVISION_PRECISION&&++i<SUBDIVISION_MAX_ITERATIONS);return currentT}function getTForX(aX){for(var intervalStart=0,currentSample=1,lastSample=kSplineTableSize-1;currentSample!=lastSample&&mSampleValues[currentSample]<=aX;++currentSample)intervalStart+=kSampleStepSize;--currentSample;var dist=(aX-mSampleValues[currentSample])/(mSampleValues[currentSample+1]-mSampleValues[currentSample]),guessForT=intervalStart+dist*kSampleStepSize,initialSlope=getSlope(guessForT,mX1,mX2);return initialSlope>=NEWTON_MIN_SLOPE?newtonRaphsonIterate(aX,guessForT):0==initialSlope?guessForT:binarySubdivide(aX,intervalStart,intervalStart+kSampleStepSize)}function precompute(){_precomputed=!0,(mX1!=mY1||mX2!=mY2)&&calcSampleValues()}var NEWTON_ITERATIONS=4,NEWTON_MIN_SLOPE=.001,SUBDIVISION_PRECISION=1e-7,SUBDIVISION_MAX_ITERATIONS=10,kSplineTableSize=11,kSampleStepSize=1/(kSplineTableSize-1),float32ArraySupported="Float32Array"in window;if(4!==arguments.length)return!1;for(var i=0;4>i;++i)if("number"!=typeof arguments[i]||isNaN(arguments[i])||!isFinite(arguments[i]))return!1;mX1=Math.min(mX1,1),mX2=Math.min(mX2,1),mX1=Math.max(mX1,0),mX2=Math.max(mX2,0);var mSampleValues=float32ArraySupported?new Float32Array(kSplineTableSize):new Array(kSplineTableSize),_precomputed=!1,f=function(aX){return _precomputed||precompute(),mX1===mY1&&mX2===mY2?aX:0===aX?0:1===aX?1:calcBezier(getTForX(aX),mY1,mY2)};f.getControlPoints=function(){return[{x:mX1,y:mY1},{x:mX2,y:mY2}]};var str="generateBezier("+[mX1,mY1,mX2,mY2]+")";return f.toString=function(){return str},f}function getEasing(value,duration){var easing=value;return Type.isString(value)?Velocity.Easings[value]||(easing=!1):easing=Type.isArray(value)&&1===value.length?generateStep.apply(null,value):Type.isArray(value)&&2===value.length?generateSpringRK4.apply(null,value.concat([duration])):Type.isArray(value)&&4===value.length?generateBezier.apply(null,value):!1,easing===!1&&(easing=Velocity.Easings[Velocity.defaults.easing]?Velocity.defaults.easing:EASING_DEFAULT),easing}function tick(timestamp){if(timestamp)for(var timeCurrent=(new Date).getTime(),i=0,callsLength=Velocity.State.calls.length;callsLength>i;i++)if(Velocity.State.calls[i]){var callContainer=Velocity.State.calls[i],call=callContainer[0],opts=callContainer[2],timeStart=callContainer[3],firstTick=!!timeStart;timeStart||(timeStart=Velocity.State.calls[i][3]=timeCurrent-16);for(var percentComplete=Math.min((timeCurrent-timeStart)/opts.duration,1),j=0,callLength=call.length;callLength>j;j++){var tweensContainer=call[j],element=tweensContainer.element;if(Data(element)){var transformPropertyExists=!1;if(opts.display!==undefined&&null!==opts.display&&"none"!==opts.display){if("flex"===opts.display){var flexValues=["-webkit-box","-moz-box","-ms-flexbox","-webkit-flex"];$.each(flexValues,function(i,flexValue){CSS.setPropertyValue(element,"display",flexValue)})}CSS.setPropertyValue(element,"display",opts.display)}opts.visibility!==undefined&&"hidden"!==opts.visibility&&CSS.setPropertyValue(element,"visibility",opts.visibility);for(var property in tweensContainer)if("element"!==property){var currentValue,tween=tweensContainer[property],easing=Type.isString(tween.easing)?Velocity.Easings[tween.easing]:tween.easing;if(1===percentComplete)currentValue=tween.endValue;else if(currentValue=tween.startValue+(tween.endValue-tween.startValue)*easing(percentComplete),!firstTick&&currentValue===tween.currentValue)continue;if(tween.currentValue=currentValue,CSS.Hooks.registered[property]){var hookRoot=CSS.Hooks.getRoot(property),rootPropertyValueCache=Data(element).rootPropertyValueCache[hookRoot];rootPropertyValueCache&&(tween.rootPropertyValue=rootPropertyValueCache)}var adjustedSetData=CSS.setPropertyValue(element,property,tween.currentValue+(0===parseFloat(currentValue)?"":tween.unitType),tween.rootPropertyValue,tween.scrollData);CSS.Hooks.registered[property]&&(CSS.Normalizations.registered[hookRoot]?Data(element).rootPropertyValueCache[hookRoot]=CSS.Normalizations.registered[hookRoot]("extract",null,adjustedSetData[1]):Data(element).rootPropertyValueCache[hookRoot]=adjustedSetData[1]),"transform"===adjustedSetData[0]&&(transformPropertyExists=!0)}opts.mobileHA&&Data(element).transformCache.translate3d===undefined&&(Data(element).transformCache.translate3d="(0px, 0px, 0px)",transformPropertyExists=!0),transformPropertyExists&&CSS.flushTransformCache(element)}}opts.display!==undefined&&"none"!==opts.display&&(Velocity.State.calls[i][2].display=!1),opts.visibility!==undefined&&"hidden"!==opts.visibility&&(Velocity.State.calls[i][2].visibility=!1),opts.progress&&opts.progress.call(callContainer[1],callContainer[1],percentComplete,Math.max(0,timeStart+opts.duration-timeCurrent),timeStart),1===percentComplete&&completeCall(i)}Velocity.State.isTicking&&ticker(tick)}function completeCall(callIndex,isStopped){if(!Velocity.State.calls[callIndex])return!1;for(var call=Velocity.State.calls[callIndex][0],elements=Velocity.State.calls[callIndex][1],opts=Velocity.State.calls[callIndex][2],resolver=Velocity.State.calls[callIndex][4],remainingCallsExist=!1,i=0,callLength=call.length;callLength>i;i++){var element=call[i].element;if(isStopped||opts.loop||("none"===opts.display&&CSS.setPropertyValue(element,"display",opts.display),"hidden"===opts.visibility&&CSS.setPropertyValue(element,"visibility",opts.visibility)),opts.loop!==!0&&($.queue(element)[1]===undefined||!/\.velocityQueueEntryFlag/i.test($.queue(element)[1]))&&Data(element)){Data(element).isAnimating=!1,Data(element).rootPropertyValueCache={};var transformHAPropertyExists=!1;$.each(CSS.Lists.transforms3D,function(i,transformName){var defaultValue=/^scale/.test(transformName)?1:0,currentValue=Data(element).transformCache[transformName];Data(element).transformCache[transformName]!==undefined&&new RegExp("^\\("+defaultValue+"[^.]").test(currentValue)&&(transformHAPropertyExists=!0,delete Data(element).transformCache[transformName])}),opts.mobileHA&&(transformHAPropertyExists=!0,delete Data(element).transformCache.translate3d),transformHAPropertyExists&&CSS.flushTransformCache(element),CSS.Values.removeClass(element,"velocity-animating")}if(!isStopped&&opts.complete&&!opts.loop&&i===callLength-1)try{opts.complete.call(elements,elements)}catch(error){setTimeout(function(){throw error},1)}resolver&&opts.loop!==!0&&resolver(elements),opts.loop!==!0||isStopped||($.each(Data(element).tweensContainer,function(propertyName,tweenContainer){/^rotate/.test(propertyName)&&360===parseFloat(tweenContainer.endValue)&&(tweenContainer.endValue=0,tweenContainer.startValue=360)}),Velocity(element,"reverse",{loop:!0,delay:opts.delay})),opts.queue!==!1&&$.dequeue(element,opts.queue)}Velocity.State.calls[callIndex]=!1;for(var j=0,callsLength=Velocity.State.calls.length;callsLength>j;j++)if(Velocity.State.calls[j]!==!1){remainingCallsExist=!0;break}remainingCallsExist===!1&&(Velocity.State.isTicking=!1,delete Velocity.State.calls,Velocity.State.calls=[])}var $,IE=function(){if(document.documentMode)return document.documentMode;for(var i=7;i>4;i--){var div=document.createElement("div");if(div.innerHTML="<!--[if IE "+i+"]><span></span><![endif]-->",div.getElementsByTagName("span").length)return div=null,i}return undefined}(),rAFShim=function(){var timeLast=0;return window.webkitRequestAnimationFrame||window.mozRequestAnimationFrame||function(callback){var timeDelta,timeCurrent=(new Date).getTime();return timeDelta=Math.max(0,16-(timeCurrent-timeLast)),timeLast=timeCurrent+timeDelta,setTimeout(function(){callback(timeCurrent+timeDelta)},timeDelta)}}(),Type={isString:function(variable){return"string"==typeof variable},isArray:Array.isArray||function(variable){return"[object Array]"===Object.prototype.toString.call(variable)},isFunction:function(variable){return"[object Function]"===Object.prototype.toString.call(variable)},isNode:function(variable){return variable&&variable.nodeType},isNodeList:function(variable){return"object"==typeof variable&&/^\[object (HTMLCollection|NodeList|Object)\]$/.test(Object.prototype.toString.call(variable))&&variable.length!==undefined&&(0===variable.length||"object"==typeof variable[0]&&variable[0].nodeType>0)},isWrapped:function(variable){return variable&&(variable.jquery||window.Zepto&&window.Zepto.zepto.isZ(variable))},isSVG:function(variable){return window.SVGElement&&variable instanceof window.SVGElement},isEmptyObject:function(variable){for(var name in variable)return!1;return!0}},isJQuery=!1;if(global.fn&&global.fn.jquery?($=global,isJQuery=!0):$=window.Velocity.Utilities,8>=IE&&!isJQuery)throw new Error("Velocity: IE8 and below require jQuery to be loaded before Velocity.");if(7>=IE)return void(jQuery.fn.velocity=jQuery.fn.animate);var DURATION_DEFAULT=400,EASING_DEFAULT="swing",Velocity={State:{isMobile:/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent),isAndroid:/Android/i.test(navigator.userAgent),isGingerbread:/Android 2\.3\.[3-7]/i.test(navigator.userAgent),isChrome:window.chrome,isFirefox:/Firefox/i.test(navigator.userAgent),prefixElement:document.createElement("div"),prefixMatches:{},scrollAnchor:null,scrollPropertyLeft:null,scrollPropertyTop:null,isTicking:!1,calls:[]},CSS:{},Utilities:$,Redirects:{},Easings:{},Promise:window.Promise,defaults:{queue:"",duration:DURATION_DEFAULT,easing:EASING_DEFAULT,begin:undefined,complete:undefined,progress:undefined,display:undefined,visibility:undefined,loop:!1,delay:!1,mobileHA:!0,_cacheValues:!0},init:function(element){$.data(element,"velocity",{isSVG:Type.isSVG(element),isAnimating:!1,computedStyle:null,tweensContainer:null,rootPropertyValueCache:{},transformCache:{}})},hook:null,mock:!1,version:{major:1,minor:1,patch:0},debug:!1};window.pageYOffset!==undefined?(Velocity.State.scrollAnchor=window,Velocity.State.scrollPropertyLeft="pageXOffset",Velocity.State.scrollPropertyTop="pageYOffset"):(Velocity.State.scrollAnchor=document.documentElement||document.body.parentNode||document.body,Velocity.State.scrollPropertyLeft="scrollLeft",Velocity.State.scrollPropertyTop="scrollTop");var generateSpringRK4=function(){function springAccelerationForState(state){return-state.tension*state.x-state.friction*state.v}function springEvaluateStateWithDerivative(initialState,dt,derivative){var state={x:initialState.x+derivative.dx*dt,v:initialState.v+derivative.dv*dt,tension:initialState.tension,friction:initialState.friction};return{dx:state.v,dv:springAccelerationForState(state)}}function springIntegrateState(state,dt){var a={dx:state.v,dv:springAccelerationForState(state)},b=springEvaluateStateWithDerivative(state,.5*dt,a),c=springEvaluateStateWithDerivative(state,.5*dt,b),d=springEvaluateStateWithDerivative(state,dt,c),dxdt=1/6*(a.dx+2*(b.dx+c.dx)+d.dx),dvdt=1/6*(a.dv+2*(b.dv+c.dv)+d.dv);return state.x=state.x+dxdt*dt,state.v=state.v+dvdt*dt,state}return function springRK4Factory(tension,friction,duration){var have_duration,dt,last_state,initState={x:-1,v:0,tension:null,friction:null},path=[0],time_lapsed=0,tolerance=1e-4,DT=.016;for(tension=parseFloat(tension)||500,friction=parseFloat(friction)||20,duration=duration||null,initState.tension=tension,initState.friction=friction,have_duration=null!==duration,have_duration?(time_lapsed=springRK4Factory(tension,friction),dt=time_lapsed/duration*DT):dt=DT;;)if(last_state=springIntegrateState(last_state||initState,dt),path.push(1+last_state.x),time_lapsed+=16,!(Math.abs(last_state.x)>tolerance&&Math.abs(last_state.v)>tolerance))break;return have_duration?function(percentComplete){return path[percentComplete*(path.length-1)|0]}:time_lapsed}}();Velocity.Easings={linear:function(p){return p},swing:function(p){return.5-Math.cos(p*Math.PI)/2},spring:function(p){return 1-Math.cos(4.5*p*Math.PI)*Math.exp(6*-p)}},$.each([["ease",[.25,.1,.25,1]],["ease-in",[.42,0,1,1]],["ease-out",[0,0,.58,1]],["ease-in-out",[.42,0,.58,1]],["easeInSine",[.47,0,.745,.715]],["easeOutSine",[.39,.575,.565,1]],["easeInOutSine",[.445,.05,.55,.95]],["easeInQuad",[.55,.085,.68,.53]],["easeOutQuad",[.25,.46,.45,.94]],["easeInOutQuad",[.455,.03,.515,.955]],["easeInCubic",[.55,.055,.675,.19]],["easeOutCubic",[.215,.61,.355,1]],["easeInOutCubic",[.645,.045,.355,1]],["easeInQuart",[.895,.03,.685,.22]],["easeOutQuart",[.165,.84,.44,1]],["easeInOutQuart",[.77,0,.175,1]],["easeInQuint",[.755,.05,.855,.06]],["easeOutQuint",[.23,1,.32,1]],["easeInOutQuint",[.86,0,.07,1]],["easeInExpo",[.95,.05,.795,.035]],["easeOutExpo",[.19,1,.22,1]],["easeInOutExpo",[1,0,0,1]],["easeInCirc",[.6,.04,.98,.335]],["easeOutCirc",[.075,.82,.165,1]],["easeInOutCirc",[.785,.135,.15,.86]]],function(i,easingArray){
Velocity.Easings[easingArray[0]]=generateBezier.apply(null,easingArray[1])});var CSS=Velocity.CSS={RegEx:{isHex:/^#([A-f\d]{3}){1,2}$/i,valueUnwrap:/^[A-z]+\((.*)\)$/i,wrappedValueAlreadyExtracted:/[0-9.]+ [0-9.]+ [0-9.]+( [0-9.]+)?/,valueSplit:/([A-z]+\(.+\))|(([A-z0-9#-.]+?)(?=\s|$))/gi},Lists:{colors:["fill","stroke","stopColor","color","backgroundColor","borderColor","borderTopColor","borderRightColor","borderBottomColor","borderLeftColor","outlineColor"],transformsBase:["translateX","translateY","scale","scaleX","scaleY","skewX","skewY","rotateZ"],transforms3D:["transformPerspective","translateZ","scaleZ","rotateX","rotateY"]},Hooks:{templates:{textShadow:["Color X Y Blur","black 0px 0px 0px"],boxShadow:["Color X Y Blur Spread","black 0px 0px 0px 0px"],clip:["Top Right Bottom Left","0px 0px 0px 0px"],backgroundPosition:["X Y","0% 0%"],transformOrigin:["X Y Z","50% 50% 0px"],perspectiveOrigin:["X Y","50% 50%"]},registered:{},register:function(){for(var i=0;i<CSS.Lists.colors.length;i++){var rgbComponents="color"===CSS.Lists.colors[i]?"0 0 0 1":"255 255 255 1";CSS.Hooks.templates[CSS.Lists.colors[i]]=["Red Green Blue Alpha",rgbComponents]}var rootProperty,hookTemplate,hookNames;if(IE)for(rootProperty in CSS.Hooks.templates){hookTemplate=CSS.Hooks.templates[rootProperty],hookNames=hookTemplate[0].split(" ");var defaultValues=hookTemplate[1].match(CSS.RegEx.valueSplit);"Color"===hookNames[0]&&(hookNames.push(hookNames.shift()),defaultValues.push(defaultValues.shift()),CSS.Hooks.templates[rootProperty]=[hookNames.join(" "),defaultValues.join(" ")])}for(rootProperty in CSS.Hooks.templates){hookTemplate=CSS.Hooks.templates[rootProperty],hookNames=hookTemplate[0].split(" ");for(var i in hookNames){var fullHookName=rootProperty+hookNames[i],hookPosition=i;CSS.Hooks.registered[fullHookName]=[rootProperty,hookPosition]}}},getRoot:function(property){var hookData=CSS.Hooks.registered[property];return hookData?hookData[0]:property},cleanRootPropertyValue:function(rootProperty,rootPropertyValue){return CSS.RegEx.valueUnwrap.test(rootPropertyValue)&&(rootPropertyValue=rootPropertyValue.match(CSS.RegEx.valueUnwrap)[1]),CSS.Values.isCSSNullValue(rootPropertyValue)&&(rootPropertyValue=CSS.Hooks.templates[rootProperty][1]),rootPropertyValue},extractValue:function(fullHookName,rootPropertyValue){var hookData=CSS.Hooks.registered[fullHookName];if(hookData){var hookRoot=hookData[0],hookPosition=hookData[1];return rootPropertyValue=CSS.Hooks.cleanRootPropertyValue(hookRoot,rootPropertyValue),rootPropertyValue.toString().match(CSS.RegEx.valueSplit)[hookPosition]}return rootPropertyValue},injectValue:function(fullHookName,hookValue,rootPropertyValue){var hookData=CSS.Hooks.registered[fullHookName];if(hookData){var rootPropertyValueParts,rootPropertyValueUpdated,hookRoot=hookData[0],hookPosition=hookData[1];return rootPropertyValue=CSS.Hooks.cleanRootPropertyValue(hookRoot,rootPropertyValue),rootPropertyValueParts=rootPropertyValue.toString().match(CSS.RegEx.valueSplit),rootPropertyValueParts[hookPosition]=hookValue,rootPropertyValueUpdated=rootPropertyValueParts.join(" ")}return rootPropertyValue}},Normalizations:{registered:{clip:function(type,element,propertyValue){switch(type){case"name":return"clip";case"extract":var extracted;return CSS.RegEx.wrappedValueAlreadyExtracted.test(propertyValue)?extracted=propertyValue:(extracted=propertyValue.toString().match(CSS.RegEx.valueUnwrap),extracted=extracted?extracted[1].replace(/,(\s+)?/g," "):propertyValue),extracted;case"inject":return"rect("+propertyValue+")"}},blur:function(type,element,propertyValue){switch(type){case"name":return"-webkit-filter";case"extract":var extracted=parseFloat(propertyValue);if(!extracted&&0!==extracted){var blurComponent=propertyValue.toString().match(/blur\(([0-9]+[A-z]+)\)/i);extracted=blurComponent?blurComponent[1]:0}return extracted;case"inject":return parseFloat(propertyValue)?"blur("+propertyValue+")":"none"}},opacity:function(type,element,propertyValue){if(8>=IE)switch(type){case"name":return"filter";case"extract":var extracted=propertyValue.toString().match(/alpha\(opacity=(.*)\)/i);return propertyValue=extracted?extracted[1]/100:1;case"inject":return element.style.zoom=1,parseFloat(propertyValue)>=1?"":"alpha(opacity="+parseInt(100*parseFloat(propertyValue),10)+")"}else switch(type){case"name":return"opacity";case"extract":return propertyValue;case"inject":return propertyValue}}},register:function(){9>=IE||Velocity.State.isGingerbread||(CSS.Lists.transformsBase=CSS.Lists.transformsBase.concat(CSS.Lists.transforms3D));for(var i=0;i<CSS.Lists.transformsBase.length;i++)!function(){var transformName=CSS.Lists.transformsBase[i];CSS.Normalizations.registered[transformName]=function(type,element,propertyValue){switch(type){case"name":return"transform";case"extract":return Data(element)===undefined||Data(element).transformCache[transformName]===undefined?/^scale/i.test(transformName)?1:0:Data(element).transformCache[transformName].replace(/[()]/g,"");case"inject":var invalid=!1;switch(transformName.substr(0,transformName.length-1)){case"translate":invalid=!/(%|px|em|rem|vw|vh|\d)$/i.test(propertyValue);break;case"scal":case"scale":Velocity.State.isAndroid&&Data(element).transformCache[transformName]===undefined&&1>propertyValue&&(propertyValue=1),invalid=!/(\d)$/i.test(propertyValue);break;case"skew":invalid=!/(deg|\d)$/i.test(propertyValue);break;case"rotate":invalid=!/(deg|\d)$/i.test(propertyValue)}return invalid||(Data(element).transformCache[transformName]="("+propertyValue+")"),Data(element).transformCache[transformName]}}}();for(var i=0;i<CSS.Lists.colors.length;i++)!function(){var colorName=CSS.Lists.colors[i];CSS.Normalizations.registered[colorName]=function(type,element,propertyValue){switch(type){case"name":return colorName;case"extract":var extracted;if(CSS.RegEx.wrappedValueAlreadyExtracted.test(propertyValue))extracted=propertyValue;else{var converted,colorNames={black:"rgb(0, 0, 0)",blue:"rgb(0, 0, 255)",gray:"rgb(128, 128, 128)",green:"rgb(0, 128, 0)",red:"rgb(255, 0, 0)",white:"rgb(255, 255, 255)"};/^[A-z]+$/i.test(propertyValue)?converted=colorNames[propertyValue]!==undefined?colorNames[propertyValue]:colorNames.black:CSS.RegEx.isHex.test(propertyValue)?converted="rgb("+CSS.Values.hexToRgb(propertyValue).join(" ")+")":/^rgba?\(/i.test(propertyValue)||(converted=colorNames.black),extracted=(converted||propertyValue).toString().match(CSS.RegEx.valueUnwrap)[1].replace(/,(\s+)?/g," ")}return 8>=IE||3!==extracted.split(" ").length||(extracted+=" 1"),extracted;case"inject":return 8>=IE?4===propertyValue.split(" ").length&&(propertyValue=propertyValue.split(/\s+/).slice(0,3).join(" ")):3===propertyValue.split(" ").length&&(propertyValue+=" 1"),(8>=IE?"rgb":"rgba")+"("+propertyValue.replace(/\s+/g,",").replace(/\.(\d)+(?=,)/g,"")+")"}}}()}},Names:{camelCase:function(property){return property.replace(/-(\w)/g,function(match,subMatch){return subMatch.toUpperCase()})},SVGAttribute:function(property){var SVGAttributes="width|height|x|y|cx|cy|r|rx|ry|x1|x2|y1|y2";return(IE||Velocity.State.isAndroid&&!Velocity.State.isChrome)&&(SVGAttributes+="|transform"),new RegExp("^("+SVGAttributes+")$","i").test(property)},prefixCheck:function(property){if(Velocity.State.prefixMatches[property])return[Velocity.State.prefixMatches[property],!0];for(var vendors=["","Webkit","Moz","ms","O"],i=0,vendorsLength=vendors.length;vendorsLength>i;i++){var propertyPrefixed;if(propertyPrefixed=0===i?property:vendors[i]+property.replace(/^\w/,function(match){return match.toUpperCase()}),Type.isString(Velocity.State.prefixElement.style[propertyPrefixed]))return Velocity.State.prefixMatches[property]=propertyPrefixed,[propertyPrefixed,!0]}return[property,!1]}},Values:{hexToRgb:function(hex){var rgbParts,shortformRegex=/^#?([a-f\d])([a-f\d])([a-f\d])$/i,longformRegex=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i;return hex=hex.replace(shortformRegex,function(m,r,g,b){return r+r+g+g+b+b}),rgbParts=longformRegex.exec(hex),rgbParts?[parseInt(rgbParts[1],16),parseInt(rgbParts[2],16),parseInt(rgbParts[3],16)]:[0,0,0]},isCSSNullValue:function(value){return 0==value||/^(none|auto|transparent|(rgba\(0, ?0, ?0, ?0\)))$/i.test(value)},getUnitType:function(property){return/^(rotate|skew)/i.test(property)?"deg":/(^(scale|scaleX|scaleY|scaleZ|alpha|flexGrow|flexHeight|zIndex|fontWeight)$)|((opacity|red|green|blue|alpha)$)/i.test(property)?"":"px"},getDisplayType:function(element){var tagName=element&&element.tagName.toString().toLowerCase();return/^(b|big|i|small|tt|abbr|acronym|cite|code|dfn|em|kbd|strong|samp|var|a|bdo|br|img|map|object|q|script|span|sub|sup|button|input|label|select|textarea)$/i.test(tagName)?"inline":/^(li)$/i.test(tagName)?"list-item":/^(tr)$/i.test(tagName)?"table-row":"block"},addClass:function(element,className){element.classList?element.classList.add(className):element.className+=(element.className.length?" ":"")+className},removeClass:function(element,className){element.classList?element.classList.remove(className):element.className=element.className.toString().replace(new RegExp("(^|\\s)"+className.split(" ").join("|")+"(\\s|$)","gi")," ")}},getPropertyValue:function(element,property,rootPropertyValue,forceStyleLookup){function computePropertyValue(element,property){function revertDisplay(){toggleDisplay&&CSS.setPropertyValue(element,"display","none")}var computedValue=0;if(8>=IE)computedValue=$.css(element,property);else{var toggleDisplay=!1;if(/^(width|height)$/.test(property)&&0===CSS.getPropertyValue(element,"display")&&(toggleDisplay=!0,CSS.setPropertyValue(element,"display",CSS.Values.getDisplayType(element))),!forceStyleLookup){if("height"===property&&"border-box"!==CSS.getPropertyValue(element,"boxSizing").toString().toLowerCase()){var contentBoxHeight=element.offsetHeight-(parseFloat(CSS.getPropertyValue(element,"borderTopWidth"))||0)-(parseFloat(CSS.getPropertyValue(element,"borderBottomWidth"))||0)-(parseFloat(CSS.getPropertyValue(element,"paddingTop"))||0)-(parseFloat(CSS.getPropertyValue(element,"paddingBottom"))||0);return revertDisplay(),contentBoxHeight}if("width"===property&&"border-box"!==CSS.getPropertyValue(element,"boxSizing").toString().toLowerCase()){var contentBoxWidth=element.offsetWidth-(parseFloat(CSS.getPropertyValue(element,"borderLeftWidth"))||0)-(parseFloat(CSS.getPropertyValue(element,"borderRightWidth"))||0)-(parseFloat(CSS.getPropertyValue(element,"paddingLeft"))||0)-(parseFloat(CSS.getPropertyValue(element,"paddingRight"))||0);return revertDisplay(),contentBoxWidth}}var computedStyle;computedStyle=Data(element)===undefined?window.getComputedStyle(element,null):Data(element).computedStyle?Data(element).computedStyle:Data(element).computedStyle=window.getComputedStyle(element,null),(IE||Velocity.State.isFirefox)&&"borderColor"===property&&(property="borderTopColor"),computedValue=9===IE&&"filter"===property?computedStyle.getPropertyValue(property):computedStyle[property],(""===computedValue||null===computedValue)&&(computedValue=element.style[property]),revertDisplay()}if("auto"===computedValue&&/^(top|right|bottom|left)$/i.test(property)){var position=computePropertyValue(element,"position");("fixed"===position||"absolute"===position&&/top|left/i.test(property))&&(computedValue=$(element).position()[property]+"px")}return computedValue}var propertyValue;if(CSS.Hooks.registered[property]){var hook=property,hookRoot=CSS.Hooks.getRoot(hook);rootPropertyValue===undefined&&(rootPropertyValue=CSS.getPropertyValue(element,CSS.Names.prefixCheck(hookRoot)[0])),CSS.Normalizations.registered[hookRoot]&&(rootPropertyValue=CSS.Normalizations.registered[hookRoot]("extract",element,rootPropertyValue)),propertyValue=CSS.Hooks.extractValue(hook,rootPropertyValue)}else if(CSS.Normalizations.registered[property]){var normalizedPropertyName,normalizedPropertyValue;normalizedPropertyName=CSS.Normalizations.registered[property]("name",element),"transform"!==normalizedPropertyName&&(normalizedPropertyValue=computePropertyValue(element,CSS.Names.prefixCheck(normalizedPropertyName)[0]),CSS.Values.isCSSNullValue(normalizedPropertyValue)&&CSS.Hooks.templates[property]&&(normalizedPropertyValue=CSS.Hooks.templates[property][1])),propertyValue=CSS.Normalizations.registered[property]("extract",element,normalizedPropertyValue)}return/^[\d-]/.test(propertyValue)||(propertyValue=Data(element)&&Data(element).isSVG&&CSS.Names.SVGAttribute(property)?/^(height|width)$/i.test(property)?element.getBBox()[property]:element.getAttribute(property):computePropertyValue(element,CSS.Names.prefixCheck(property)[0])),CSS.Values.isCSSNullValue(propertyValue)&&(propertyValue=0),Velocity.debug>=2&&console.log("Get "+property+": "+propertyValue),propertyValue},setPropertyValue:function(element,property,propertyValue,rootPropertyValue,scrollData){var propertyName=property;if("scroll"===property)scrollData.container?scrollData.container["scroll"+scrollData.direction]=propertyValue:"Left"===scrollData.direction?window.scrollTo(propertyValue,scrollData.alternateValue):window.scrollTo(scrollData.alternateValue,propertyValue);else if(CSS.Normalizations.registered[property]&&"transform"===CSS.Normalizations.registered[property]("name",element))CSS.Normalizations.registered[property]("inject",element,propertyValue),propertyName="transform",propertyValue=Data(element).transformCache[property];else{if(CSS.Hooks.registered[property]){var hookName=property,hookRoot=CSS.Hooks.getRoot(property);rootPropertyValue=rootPropertyValue||CSS.getPropertyValue(element,hookRoot),propertyValue=CSS.Hooks.injectValue(hookName,propertyValue,rootPropertyValue),property=hookRoot}if(CSS.Normalizations.registered[property]&&(propertyValue=CSS.Normalizations.registered[property]("inject",element,propertyValue),property=CSS.Normalizations.registered[property]("name",element)),propertyName=CSS.Names.prefixCheck(property)[0],8>=IE)try{element.style[propertyName]=propertyValue}catch(error){Velocity.debug&&console.log("Browser does not support ["+propertyValue+"] for ["+propertyName+"]")}else Data(element)&&Data(element).isSVG&&CSS.Names.SVGAttribute(property)?element.setAttribute(property,propertyValue):element.style[propertyName]=propertyValue;Velocity.debug>=2&&console.log("Set "+property+" ("+propertyName+"): "+propertyValue)}return[propertyName,propertyValue]},flushTransformCache:function(element){function getTransformFloat(transformProperty){return parseFloat(CSS.getPropertyValue(element,transformProperty))}var transformString="";if((IE||Velocity.State.isAndroid&&!Velocity.State.isChrome)&&Data(element).isSVG){var SVGTransforms={translate:[getTransformFloat("translateX"),getTransformFloat("translateY")],skewX:[getTransformFloat("skewX")],skewY:[getTransformFloat("skewY")],scale:1!==getTransformFloat("scale")?[getTransformFloat("scale"),getTransformFloat("scale")]:[getTransformFloat("scaleX"),getTransformFloat("scaleY")],rotate:[getTransformFloat("rotateZ"),0,0]};$.each(Data(element).transformCache,function(transformName){/^translate/i.test(transformName)?transformName="translate":/^scale/i.test(transformName)?transformName="scale":/^rotate/i.test(transformName)&&(transformName="rotate"),SVGTransforms[transformName]&&(transformString+=transformName+"("+SVGTransforms[transformName].join(" ")+") ",delete SVGTransforms[transformName])})}else{var transformValue,perspective;$.each(Data(element).transformCache,function(transformName){return transformValue=Data(element).transformCache[transformName],"transformPerspective"===transformName?(perspective=transformValue,!0):(9===IE&&"rotateZ"===transformName&&(transformName="rotate"),void(transformString+=transformName+transformValue+" "))}),perspective&&(transformString="perspective"+perspective+" "+transformString)}CSS.setPropertyValue(element,"transform",transformString)}};CSS.Hooks.register(),CSS.Normalizations.register(),Velocity.hook=function(elements,arg2,arg3){var value=undefined;return elements=sanitizeElements(elements),$.each(elements,function(i,element){if(Data(element)===undefined&&Velocity.init(element),arg3===undefined)value===undefined&&(value=Velocity.CSS.getPropertyValue(element,arg2));else{var adjustedSet=Velocity.CSS.setPropertyValue(element,arg2,arg3);"transform"===adjustedSet[0]&&Velocity.CSS.flushTransformCache(element),value=adjustedSet}}),value};var animate=function(){function getChain(){return isUtility?promiseData.promise||null:elementsWrapped}function processElement(){function buildQueue(next){function parsePropertyValue(valueData,skipResolvingEasing){var endValue=undefined,easing=undefined,startValue=undefined;return Type.isArray(valueData)?(endValue=valueData[0],!Type.isArray(valueData[1])&&/^[\d-]/.test(valueData[1])||Type.isFunction(valueData[1])||CSS.RegEx.isHex.test(valueData[1])?startValue=valueData[1]:(Type.isString(valueData[1])&&!CSS.RegEx.isHex.test(valueData[1])||Type.isArray(valueData[1]))&&(easing=skipResolvingEasing?valueData[1]:getEasing(valueData[1],opts.duration),valueData[2]!==undefined&&(startValue=valueData[2]))):endValue=valueData,skipResolvingEasing||(easing=easing||opts.easing),Type.isFunction(endValue)&&(endValue=endValue.call(element,elementsIndex,elementsLength)),Type.isFunction(startValue)&&(startValue=startValue.call(element,elementsIndex,elementsLength)),[endValue||0,easing,startValue]}function separateValue(property,value){var unitType,numericValue;return numericValue=(value||"0").toString().toLowerCase().replace(/[%A-z]+$/,function(match){return unitType=match,""}),unitType||(unitType=CSS.Values.getUnitType(property)),[numericValue,unitType]}function calculateUnitRatios(){var sameRatioIndicators={myParent:element.parentNode||document.body,position:CSS.getPropertyValue(element,"position"),fontSize:CSS.getPropertyValue(element,"fontSize")},samePercentRatio=sameRatioIndicators.position===callUnitConversionData.lastPosition&&sameRatioIndicators.myParent===callUnitConversionData.lastParent,sameEmRatio=sameRatioIndicators.fontSize===callUnitConversionData.lastFontSize;callUnitConversionData.lastParent=sameRatioIndicators.myParent,callUnitConversionData.lastPosition=sameRatioIndicators.position,callUnitConversionData.lastFontSize=sameRatioIndicators.fontSize;var measurement=100,unitRatios={};if(sameEmRatio&&samePercentRatio)unitRatios.emToPx=callUnitConversionData.lastEmToPx,unitRatios.percentToPxWidth=callUnitConversionData.lastPercentToPxWidth,unitRatios.percentToPxHeight=callUnitConversionData.lastPercentToPxHeight;else{var dummy=Data(element).isSVG?document.createElementNS("http://www.w3.org/2000/svg","rect"):document.createElement("div");Velocity.init(dummy),sameRatioIndicators.myParent.appendChild(dummy),$.each(["overflow","overflowX","overflowY"],function(i,property){Velocity.CSS.setPropertyValue(dummy,property,"hidden")}),Velocity.CSS.setPropertyValue(dummy,"position",sameRatioIndicators.position),Velocity.CSS.setPropertyValue(dummy,"fontSize",sameRatioIndicators.fontSize),Velocity.CSS.setPropertyValue(dummy,"boxSizing","content-box"),$.each(["minWidth","maxWidth","width","minHeight","maxHeight","height"],function(i,property){Velocity.CSS.setPropertyValue(dummy,property,measurement+"%")}),Velocity.CSS.setPropertyValue(dummy,"paddingLeft",measurement+"em"),unitRatios.percentToPxWidth=callUnitConversionData.lastPercentToPxWidth=(parseFloat(CSS.getPropertyValue(dummy,"width",null,!0))||1)/measurement,unitRatios.percentToPxHeight=callUnitConversionData.lastPercentToPxHeight=(parseFloat(CSS.getPropertyValue(dummy,"height",null,!0))||1)/measurement,unitRatios.emToPx=callUnitConversionData.lastEmToPx=(parseFloat(CSS.getPropertyValue(dummy,"paddingLeft"))||1)/measurement,sameRatioIndicators.myParent.removeChild(dummy)}return null===callUnitConversionData.remToPx&&(callUnitConversionData.remToPx=parseFloat(CSS.getPropertyValue(document.body,"fontSize"))||16),null===callUnitConversionData.vwToPx&&(callUnitConversionData.vwToPx=parseFloat(window.innerWidth)/100,callUnitConversionData.vhToPx=parseFloat(window.innerHeight)/100),unitRatios.remToPx=callUnitConversionData.remToPx,unitRatios.vwToPx=callUnitConversionData.vwToPx,unitRatios.vhToPx=callUnitConversionData.vhToPx,Velocity.debug>=1&&console.log("Unit ratios: "+JSON.stringify(unitRatios),element),unitRatios}if(opts.begin&&0===elementsIndex)try{opts.begin.call(elements,elements)}catch(error){setTimeout(function(){throw error},1)}if("scroll"===action){var scrollPositionCurrent,scrollPositionCurrentAlternate,scrollPositionEnd,scrollDirection=/^x$/i.test(opts.axis)?"Left":"Top",scrollOffset=parseFloat(opts.offset)||0;opts.container?Type.isWrapped(opts.container)||Type.isNode(opts.container)?(opts.container=opts.container[0]||opts.container,scrollPositionCurrent=opts.container["scroll"+scrollDirection],scrollPositionEnd=scrollPositionCurrent+$(element).position()[scrollDirection.toLowerCase()]+scrollOffset):opts.container=null:(scrollPositionCurrent=Velocity.State.scrollAnchor[Velocity.State["scrollProperty"+scrollDirection]],scrollPositionCurrentAlternate=Velocity.State.scrollAnchor[Velocity.State["scrollProperty"+("Left"===scrollDirection?"Top":"Left")]],scrollPositionEnd=$(element).offset()[scrollDirection.toLowerCase()]+scrollOffset),tweensContainer={scroll:{rootPropertyValue:!1,startValue:scrollPositionCurrent,currentValue:scrollPositionCurrent,endValue:scrollPositionEnd,unitType:"",easing:opts.easing,scrollData:{container:opts.container,direction:scrollDirection,alternateValue:scrollPositionCurrentAlternate}},element:element},Velocity.debug&&console.log("tweensContainer (scroll): ",tweensContainer.scroll,element)}else if("reverse"===action){if(!Data(element).tweensContainer)return void $.dequeue(element,opts.queue);"none"===Data(element).opts.display&&(Data(element).opts.display="auto"),"hidden"===Data(element).opts.visibility&&(Data(element).opts.visibility="visible"),Data(element).opts.loop=!1,Data(element).opts.begin=null,Data(element).opts.complete=null,options.easing||delete opts.easing,options.duration||delete opts.duration,opts=$.extend({},Data(element).opts,opts);var lastTweensContainer=$.extend(!0,{},Data(element).tweensContainer);for(var lastTween in lastTweensContainer)if("element"!==lastTween){var lastStartValue=lastTweensContainer[lastTween].startValue;lastTweensContainer[lastTween].startValue=lastTweensContainer[lastTween].currentValue=lastTweensContainer[lastTween].endValue,lastTweensContainer[lastTween].endValue=lastStartValue,Type.isEmptyObject(options)||(lastTweensContainer[lastTween].easing=opts.easing),Velocity.debug&&console.log("reverse tweensContainer ("+lastTween+"): "+JSON.stringify(lastTweensContainer[lastTween]),element)}tweensContainer=lastTweensContainer}else if("start"===action){var lastTweensContainer;Data(element).tweensContainer&&Data(element).isAnimating===!0&&(lastTweensContainer=Data(element).tweensContainer),$.each(propertiesMap,function(property,value){if(RegExp("^"+CSS.Lists.colors.join("$|^")+"$").test(property)){var valueData=parsePropertyValue(value,!0),endValue=valueData[0],easing=valueData[1],startValue=valueData[2];if(CSS.RegEx.isHex.test(endValue)){for(var colorComponents=["Red","Green","Blue"],endValueRGB=CSS.Values.hexToRgb(endValue),startValueRGB=startValue?CSS.Values.hexToRgb(startValue):undefined,i=0;i<colorComponents.length;i++){var dataArray=[endValueRGB[i]];easing&&dataArray.push(easing),startValueRGB!==undefined&&dataArray.push(startValueRGB[i]),propertiesMap[property+colorComponents[i]]=dataArray}delete propertiesMap[property]}}});for(var property in propertiesMap){var valueData=parsePropertyValue(propertiesMap[property]),endValue=valueData[0],easing=valueData[1],startValue=valueData[2];property=CSS.Names.camelCase(property);var rootProperty=CSS.Hooks.getRoot(property),rootPropertyValue=!1;if(Data(element).isSVG||CSS.Names.prefixCheck(rootProperty)[1]!==!1||CSS.Normalizations.registered[rootProperty]!==undefined){(opts.display!==undefined&&null!==opts.display&&"none"!==opts.display||opts.visibility!==undefined&&"hidden"!==opts.visibility)&&/opacity|filter/.test(property)&&!startValue&&0!==endValue&&(startValue=0),opts._cacheValues&&lastTweensContainer&&lastTweensContainer[property]?(startValue===undefined&&(startValue=lastTweensContainer[property].endValue+lastTweensContainer[property].unitType),rootPropertyValue=Data(element).rootPropertyValueCache[rootProperty]):CSS.Hooks.registered[property]?startValue===undefined?(rootPropertyValue=CSS.getPropertyValue(element,rootProperty),startValue=CSS.getPropertyValue(element,property,rootPropertyValue)):rootPropertyValue=CSS.Hooks.templates[rootProperty][1]:startValue===undefined&&(startValue=CSS.getPropertyValue(element,property));var separatedValue,endValueUnitType,startValueUnitType,operator=!1;if(separatedValue=separateValue(property,startValue),startValue=separatedValue[0],startValueUnitType=separatedValue[1],separatedValue=separateValue(property,endValue),endValue=separatedValue[0].replace(/^([+-\/*])=/,function(match,subMatch){return operator=subMatch,""}),endValueUnitType=separatedValue[1],startValue=parseFloat(startValue)||0,endValue=parseFloat(endValue)||0,"%"===endValueUnitType&&(/^(fontSize|lineHeight)$/.test(property)?(endValue/=100,endValueUnitType="em"):/^scale/.test(property)?(endValue/=100,endValueUnitType=""):/(Red|Green|Blue)$/i.test(property)&&(endValue=endValue/100*255,endValueUnitType="")),/[\/*]/.test(operator))endValueUnitType=startValueUnitType;else if(startValueUnitType!==endValueUnitType&&0!==startValue)if(0===endValue)endValueUnitType=startValueUnitType;else{elementUnitConversionData=elementUnitConversionData||calculateUnitRatios();var axis=/margin|padding|left|right|width|text|word|letter/i.test(property)||/X$/.test(property)||"x"===property?"x":"y";switch(startValueUnitType){case"%":startValue*="x"===axis?elementUnitConversionData.percentToPxWidth:elementUnitConversionData.percentToPxHeight;break;case"px":break;default:startValue*=elementUnitConversionData[startValueUnitType+"ToPx"]}switch(endValueUnitType){case"%":startValue*=1/("x"===axis?elementUnitConversionData.percentToPxWidth:elementUnitConversionData.percentToPxHeight);break;case"px":break;default:startValue*=1/elementUnitConversionData[endValueUnitType+"ToPx"]}}switch(operator){case"+":endValue=startValue+endValue;break;case"-":endValue=startValue-endValue;break;case"*":endValue=startValue*endValue;break;case"/":endValue=startValue/endValue}tweensContainer[property]={rootPropertyValue:rootPropertyValue,startValue:startValue,currentValue:startValue,endValue:endValue,unitType:endValueUnitType,easing:easing},Velocity.debug&&console.log("tweensContainer ("+property+"): "+JSON.stringify(tweensContainer[property]),element)}else Velocity.debug&&console.log("Skipping ["+rootProperty+"] due to a lack of browser support.")}tweensContainer.element=element}tweensContainer.element&&(CSS.Values.addClass(element,"velocity-animating"),call.push(tweensContainer),""===opts.queue&&(Data(element).tweensContainer=tweensContainer,Data(element).opts=opts),Data(element).isAnimating=!0,elementsIndex===elementsLength-1?(Velocity.State.calls.length>1e4&&(Velocity.State.calls=compactSparseArray(Velocity.State.calls)),Velocity.State.calls.push([call,elements,opts,null,promiseData.resolver]),Velocity.State.isTicking===!1&&(Velocity.State.isTicking=!0,tick())):elementsIndex++)}var elementUnitConversionData,element=this,opts=$.extend({},Velocity.defaults,options),tweensContainer={};switch(Data(element)===undefined&&Velocity.init(element),parseFloat(opts.delay)&&opts.queue!==!1&&$.queue(element,opts.queue,function(next){Velocity.velocityQueueEntryFlag=!0,Data(element).delayTimer={setTimeout:setTimeout(next,parseFloat(opts.delay)),next:next}}),opts.duration.toString().toLowerCase()){case"fast":opts.duration=200;break;case"normal":opts.duration=DURATION_DEFAULT;break;case"slow":opts.duration=600;break;default:opts.duration=parseFloat(opts.duration)||1}Velocity.mock!==!1&&(Velocity.mock===!0?opts.duration=opts.delay=1:(opts.duration*=parseFloat(Velocity.mock)||1,opts.delay*=parseFloat(Velocity.mock)||1)),opts.easing=getEasing(opts.easing,opts.duration),opts.begin&&!Type.isFunction(opts.begin)&&(opts.begin=null),opts.progress&&!Type.isFunction(opts.progress)&&(opts.progress=null),opts.complete&&!Type.isFunction(opts.complete)&&(opts.complete=null),opts.display!==undefined&&null!==opts.display&&(opts.display=opts.display.toString().toLowerCase(),"auto"===opts.display&&(opts.display=Velocity.CSS.Values.getDisplayType(element))),opts.visibility!==undefined&&null!==opts.visibility&&(opts.visibility=opts.visibility.toString().toLowerCase()),opts.mobileHA=opts.mobileHA&&Velocity.State.isMobile&&!Velocity.State.isGingerbread,opts.queue===!1?opts.delay?setTimeout(buildQueue,opts.delay):buildQueue():$.queue(element,opts.queue,function(next,clearQueue){return clearQueue===!0?(promiseData.promise&&promiseData.resolver(elements),!0):(Velocity.velocityQueueEntryFlag=!0,void buildQueue(next))}),""!==opts.queue&&"fx"!==opts.queue||"inprogress"===$.queue(element)[0]||$.dequeue(element)}var isUtility,elementsWrapped,argumentIndex,elements,propertiesMap,options,syntacticSugar=arguments[0]&&($.isPlainObject(arguments[0].properties)&&!arguments[0].properties.names||Type.isString(arguments[0].properties));if(Type.isWrapped(this)?(isUtility=!1,argumentIndex=0,elements=this,elementsWrapped=this):(isUtility=!0,argumentIndex=1,elements=syntacticSugar?arguments[0].elements:arguments[0]),elements=sanitizeElements(elements)){syntacticSugar?(propertiesMap=arguments[0].properties,options=arguments[0].options):(propertiesMap=arguments[argumentIndex],options=arguments[argumentIndex+1]);var elementsLength=elements.length,elementsIndex=0;if("stop"!==propertiesMap&&!$.isPlainObject(options)){var startingArgumentPosition=argumentIndex+1;options={};for(var i=startingArgumentPosition;i<arguments.length;i++)Type.isArray(arguments[i])||!/^(fast|normal|slow)$/i.test(arguments[i])&&!/^\d/.test(arguments[i])?Type.isString(arguments[i])||Type.isArray(arguments[i])?options.easing=arguments[i]:Type.isFunction(arguments[i])&&(options.complete=arguments[i]):options.duration=arguments[i]}var promiseData={promise:null,resolver:null,rejecter:null};isUtility&&Velocity.Promise&&(promiseData.promise=new Velocity.Promise(function(resolve,reject){promiseData.resolver=resolve,promiseData.rejecter=reject}));var action;switch(propertiesMap){case"scroll":action="scroll";break;case"reverse":action="reverse";break;case"stop":$.each(elements,function(i,element){Data(element)&&Data(element).delayTimer&&(clearTimeout(Data(element).delayTimer.setTimeout),Data(element).delayTimer.next&&Data(element).delayTimer.next(),delete Data(element).delayTimer)});var callsToStop=[];return $.each(Velocity.State.calls,function(i,activeCall){activeCall&&$.each(activeCall[1],function(k,activeElement){var queueName=Type.isString(options)?options:"";return options!==undefined&&activeCall[2].queue!==queueName?!0:void $.each(elements,function(l,element){element===activeElement&&(options!==undefined&&($.each($.queue(element,queueName),function(_,item){Type.isFunction(item)&&item(null,!0)}),$.queue(element,queueName,[])),Data(element)&&""===queueName&&$.each(Data(element).tweensContainer,function(m,activeTween){activeTween.endValue=activeTween.currentValue}),callsToStop.push(i))})})}),$.each(callsToStop,function(i,j){completeCall(j,!0)}),promiseData.promise&&promiseData.resolver(elements),getChain();default:if(!$.isPlainObject(propertiesMap)||Type.isEmptyObject(propertiesMap)){if(Type.isString(propertiesMap)&&Velocity.Redirects[propertiesMap]){var opts=$.extend({},options),durationOriginal=opts.duration,delayOriginal=opts.delay||0;return opts.backwards===!0&&(elements=$.extend(!0,[],elements).reverse()),$.each(elements,function(elementIndex,element){parseFloat(opts.stagger)?opts.delay=delayOriginal+parseFloat(opts.stagger)*elementIndex:Type.isFunction(opts.stagger)&&(opts.delay=delayOriginal+opts.stagger.call(element,elementIndex,elementsLength)),opts.drag&&(opts.duration=parseFloat(durationOriginal)||(/^(callout|transition)/.test(propertiesMap)?1e3:DURATION_DEFAULT),
opts.duration=Math.max(opts.duration*(opts.backwards?1-elementIndex/elementsLength:(elementIndex+1)/elementsLength),.75*opts.duration,200)),Velocity.Redirects[propertiesMap].call(element,element,opts||{},elementIndex,elementsLength,elements,promiseData.promise?promiseData:undefined)}),getChain()}var abortError="Velocity: First argument ("+propertiesMap+") was not a property map, a known action, or a registered redirect. Aborting.";return promiseData.promise?promiseData.rejecter(new Error(abortError)):console.log(abortError),getChain()}action="start"}var callUnitConversionData={lastParent:null,lastPosition:null,lastFontSize:null,lastPercentToPxWidth:null,lastPercentToPxHeight:null,lastEmToPx:null,remToPx:null,vwToPx:null,vhToPx:null},call=[];$.each(elements,function(i,element){Type.isNode(element)&&processElement.call(element)});var reverseCallsCount,opts=$.extend({},Velocity.defaults,options);if(opts.loop=parseInt(opts.loop),reverseCallsCount=2*opts.loop-1,opts.loop)for(var x=0;reverseCallsCount>x;x++){var reverseOptions={delay:opts.delay,progress:opts.progress};x===reverseCallsCount-1&&(reverseOptions.display=opts.display,reverseOptions.visibility=opts.visibility,reverseOptions.complete=opts.complete),animate(elements,"reverse",reverseOptions)}return getChain()}};Velocity=$.extend(animate,Velocity),Velocity.animate=animate;var ticker=window.requestAnimationFrame||rAFShim;return Velocity.State.isMobile||document.hidden===undefined||document.addEventListener("visibilitychange",function(){document.hidden?(ticker=function(callback){return setTimeout(function(){callback(!0)},16)},tick()):ticker=window.requestAnimationFrame||rAFShim}),global.Velocity=Velocity,global!==window&&(global.fn.velocity=animate,global.fn.velocity.defaults=Velocity.defaults),$.each(["Down","Up"],function(i,direction){Velocity.Redirects["slide"+direction]=function(element,options,elementsIndex,elementsSize,elements,promiseData){var opts=$.extend({},options),begin=opts.begin,complete=opts.complete,computedValues={height:"",marginTop:"",marginBottom:"",paddingTop:"",paddingBottom:""},inlineValues={};opts.display===undefined&&(opts.display="Down"===direction?"inline"===Velocity.CSS.Values.getDisplayType(element)?"inline-block":"block":"none"),opts.begin=function(){begin&&begin.call(elements,elements);for(var property in computedValues){inlineValues[property]=element.style[property];var propertyValue=Velocity.CSS.getPropertyValue(element,property);computedValues[property]="Down"===direction?[propertyValue,0]:[0,propertyValue]}inlineValues.overflow=element.style.overflow,element.style.overflow="hidden"},opts.complete=function(){for(var property in inlineValues)element.style[property]=inlineValues[property];complete&&complete.call(elements,elements),promiseData&&promiseData.resolver(elements)},Velocity(element,computedValues,opts)}}),$.each(["In","Out"],function(i,direction){Velocity.Redirects["fade"+direction]=function(element,options,elementsIndex,elementsSize,elements,promiseData){var opts=$.extend({},options),propertiesMap={opacity:"In"===direction?1:0},originalComplete=opts.complete;elementsIndex!==elementsSize-1?opts.complete=opts.begin=null:opts.complete=function(){originalComplete&&originalComplete.call(elements,elements),promiseData&&promiseData.resolver(elements)},opts.display===undefined&&(opts.display="In"===direction?"auto":"none"),Velocity(this,propertiesMap,opts)}}),Velocity}(window.jQuery||window.Zepto||window,window,document)});var CryptoJS=CryptoJS||function(g,l){var e={},d=e.lib={},m=function(){},k=d.Base={extend:function(a){m.prototype=this;var c=new m;return a&&c.mixIn(a),c.hasOwnProperty("init")||(c.init=function(){c.$super.init.apply(this,arguments)}),c.init.prototype=c,c.$super=this,c},create:function(){var a=this.extend();return a.init.apply(a,arguments),a},init:function(){},mixIn:function(a){for(var c in a)a.hasOwnProperty(c)&&(this[c]=a[c]);a.hasOwnProperty("toString")&&(this.toString=a.toString)},clone:function(){return this.init.prototype.extend(this)}},p=d.WordArray=k.extend({init:function(a,c){a=this.words=a||[],this.sigBytes=c!=l?c:4*a.length},toString:function(a){return(a||n).stringify(this)},concat:function(a){var c=this.words,q=a.words,f=this.sigBytes;if(a=a.sigBytes,this.clamp(),f%4)for(var b=0;a>b;b++)c[f+b>>>2]|=(q[b>>>2]>>>24-8*(b%4)&255)<<24-8*((f+b)%4);else if(65535<q.length)for(b=0;a>b;b+=4)c[f+b>>>2]=q[b>>>2];else c.push.apply(c,q);return this.sigBytes+=a,this},clamp:function(){var a=this.words,c=this.sigBytes;a[c>>>2]&=4294967295<<32-8*(c%4),a.length=g.ceil(c/4)},clone:function(){var a=k.clone.call(this);return a.words=this.words.slice(0),a},random:function(a){for(var c=[],b=0;a>b;b+=4)c.push(4294967296*g.random()|0);return new p.init(c,a)}}),b=e.enc={},n=b.Hex={stringify:function(a){var c=a.words;a=a.sigBytes;for(var b=[],f=0;a>f;f++){var d=c[f>>>2]>>>24-8*(f%4)&255;b.push((d>>>4).toString(16)),b.push((15&d).toString(16))}return b.join("")},parse:function(a){for(var c=a.length,b=[],f=0;c>f;f+=2)b[f>>>3]|=parseInt(a.substr(f,2),16)<<24-4*(f%8);return new p.init(b,c/2)}},j=b.Latin1={stringify:function(a){var c=a.words;a=a.sigBytes;for(var b=[],f=0;a>f;f++)b.push(String.fromCharCode(c[f>>>2]>>>24-8*(f%4)&255));return b.join("")},parse:function(a){for(var c=a.length,b=[],f=0;c>f;f++)b[f>>>2]|=(255&a.charCodeAt(f))<<24-8*(f%4);return new p.init(b,c)}},h=b.Utf8={stringify:function(a){try{return decodeURIComponent(escape(j.stringify(a)))}catch(c){throw Error("Malformed UTF-8 data")}},parse:function(a){return j.parse(unescape(encodeURIComponent(a)))}},r=d.BufferedBlockAlgorithm=k.extend({reset:function(){this._data=new p.init,this._nDataBytes=0},_append:function(a){"string"==typeof a&&(a=h.parse(a)),this._data.concat(a),this._nDataBytes+=a.sigBytes},_process:function(a){var c=this._data,b=c.words,f=c.sigBytes,d=this.blockSize,e=f/(4*d),e=a?g.ceil(e):g.max((0|e)-this._minBufferSize,0);if(a=e*d,f=g.min(4*a,f),a){for(var k=0;a>k;k+=d)this._doProcessBlock(b,k);k=b.splice(0,a),c.sigBytes-=f}return new p.init(k,f)},clone:function(){var a=k.clone.call(this);return a._data=this._data.clone(),a},_minBufferSize:0});d.Hasher=r.extend({cfg:k.extend(),init:function(a){this.cfg=this.cfg.extend(a),this.reset()},reset:function(){r.reset.call(this),this._doReset()},update:function(a){return this._append(a),this._process(),this},finalize:function(a){return a&&this._append(a),this._doFinalize()},blockSize:16,_createHelper:function(a){return function(b,d){return new a.init(d).finalize(b)}},_createHmacHelper:function(a){return function(b,d){return new s.HMAC.init(a,d).finalize(b)}}});var s=e.algo={};return e}(Math);!function(){var g=CryptoJS,l=g.lib,e=l.WordArray,d=l.Hasher,m=[],l=g.algo.SHA1=d.extend({_doReset:function(){this._hash=new e.init([1732584193,4023233417,2562383102,271733878,3285377520])},_doProcessBlock:function(d,e){for(var b=this._hash.words,n=b[0],j=b[1],h=b[2],g=b[3],l=b[4],a=0;80>a;a++){if(16>a)m[a]=0|d[e+a];else{var c=m[a-3]^m[a-8]^m[a-14]^m[a-16];m[a]=c<<1|c>>>31}c=(n<<5|n>>>27)+l+m[a],c=20>a?c+((j&h|~j&g)+1518500249):40>a?c+((j^h^g)+1859775393):60>a?c+((j&h|j&g|h&g)-1894007588):c+((j^h^g)-899497514),l=g,g=h,h=j<<30|j>>>2,j=n,n=c}b[0]=b[0]+n|0,b[1]=b[1]+j|0,b[2]=b[2]+h|0,b[3]=b[3]+g|0,b[4]=b[4]+l|0},_doFinalize:function(){var d=this._data,e=d.words,b=8*this._nDataBytes,g=8*d.sigBytes;return e[g>>>5]|=128<<24-g%32,e[(g+64>>>9<<4)+14]=Math.floor(b/4294967296),e[(g+64>>>9<<4)+15]=b,d.sigBytes=4*e.length,this._process(),this._hash},clone:function(){var e=d.clone.call(this);return e._hash=this._hash.clone(),e}});g.SHA1=d._createHelper(l),g.HmacSHA1=d._createHmacHelper(l)}(),function(){var g=CryptoJS,l=g.enc.Utf8;g.algo.HMAC=g.lib.Base.extend({init:function(e,d){e=this._hasher=new e.init,"string"==typeof d&&(d=l.parse(d));var g=e.blockSize,k=4*g;d.sigBytes>k&&(d=e.finalize(d)),d.clamp();for(var p=this._oKey=d.clone(),b=this._iKey=d.clone(),n=p.words,j=b.words,h=0;g>h;h++)n[h]^=1549556828,j[h]^=909522486;p.sigBytes=b.sigBytes=k,this.reset()},reset:function(){var e=this._hasher;e.reset(),e.update(this._iKey)},update:function(e){return this._hasher.update(e),this},finalize:function(e){var d=this._hasher;return e=d.finalize(e),d.reset(),d.finalize(this._oKey.clone().concat(e))}})}(),function(){var C=CryptoJS,C_lib=C.lib,WordArray=C_lib.WordArray,C_enc=C.enc;C_enc.Base64={stringify:function(wordArray){var words=wordArray.words,sigBytes=wordArray.sigBytes,map=this._map;wordArray.clamp();for(var base64Chars=[],i=0;sigBytes>i;i+=3)for(var byte1=words[i>>>2]>>>24-i%4*8&255,byte2=words[i+1>>>2]>>>24-(i+1)%4*8&255,byte3=words[i+2>>>2]>>>24-(i+2)%4*8&255,triplet=byte1<<16|byte2<<8|byte3,j=0;4>j&&sigBytes>i+.75*j;j++)base64Chars.push(map.charAt(triplet>>>6*(3-j)&63));var paddingChar=map.charAt(64);if(paddingChar)for(;base64Chars.length%4;)base64Chars.push(paddingChar);return base64Chars.join("")},parse:function(base64Str){var base64StrLength=base64Str.length,map=this._map,paddingChar=map.charAt(64);if(paddingChar){var paddingIndex=base64Str.indexOf(paddingChar);-1!=paddingIndex&&(base64StrLength=paddingIndex)}for(var words=[],nBytes=0,i=0;base64StrLength>i;i++)if(i%4){var bits1=map.indexOf(base64Str.charAt(i-1))<<i%4*2,bits2=map.indexOf(base64Str.charAt(i))>>>6-i%4*2;words[nBytes>>>2]|=(bits1|bits2)<<24-nBytes%4*8,nBytes++}return WordArray.create(words,nBytes)},_map:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/="}}(),window.CodeMirror=function(){"use strict";function CodeMirror(place,options){if(!(this instanceof CodeMirror))return new CodeMirror(place,options);this.options=options=options||{};for(var opt in defaults)!options.hasOwnProperty(opt)&&defaults.hasOwnProperty(opt)&&(options[opt]=defaults[opt]);setGuttersForLineNumbers(options);var docStart="string"==typeof options.value?0:options.value.first,display=this.display=makeDisplay(place,docStart);display.wrapper.CodeMirror=this,updateGutters(this),options.autofocus&&!mobile&&focusInput(this),this.state={keyMaps:[],overlays:[],modeGen:0,overwrite:!1,focused:!1,suppressEdits:!1,pasteIncoming:!1,draggingText:!1,highlight:new Delayed},themeChanged(this),options.lineWrapping&&(this.display.wrapper.className+=" CodeMirror-wrap");var doc=options.value;"string"==typeof doc&&(doc=new Doc(options.value,options.mode)),operation(this,attachDoc)(this,doc),ie&&setTimeout(bind(resetInput,this,!0),20),registerEventHandlers(this);var hasFocus;try{hasFocus=document.activeElement==display.input}catch(e){}hasFocus||options.autofocus&&!mobile?setTimeout(bind(onFocus,this),20):onBlur(this),operation(this,function(){for(var opt in optionHandlers)optionHandlers.propertyIsEnumerable(opt)&&optionHandlers[opt](this,options[opt],Init);for(var i=0;i<initHooks.length;++i)initHooks[i](this)})()}function makeDisplay(place,docStart){var d={},input=d.input=elt("textarea",null,null,"position: absolute; padding: 0; width: 1px; height: 1em; outline: none; font-size: 4px;");return webkit?input.style.width="1000px":input.setAttribute("wrap","off"),ios&&(input.style.border="1px solid black"),input.setAttribute("autocorrect","off"),input.setAttribute("autocapitalize","off"),input.setAttribute("spellcheck","false"),d.inputDiv=elt("div",[input],null,"overflow: hidden; position: relative; width: 3px; height: 0px;"),d.scrollbarH=elt("div",[elt("div",null,null,"height: 1px")],"CodeMirror-hscrollbar"),d.scrollbarV=elt("div",[elt("div",null,null,"width: 1px")],"CodeMirror-vscrollbar"),d.scrollbarFiller=elt("div",null,"CodeMirror-scrollbar-filler"),d.gutterFiller=elt("div",null,"CodeMirror-gutter-filler"),d.lineDiv=elt("div",null,"CodeMirror-code"),d.selectionDiv=elt("div",null,null,"position: relative; z-index: 1"),d.cursor=elt("div"," ","CodeMirror-cursor"),d.otherCursor=elt("div"," ","CodeMirror-cursor CodeMirror-secondarycursor"),d.measure=elt("div",null,"CodeMirror-measure"),d.lineSpace=elt("div",[d.measure,d.selectionDiv,d.lineDiv,d.cursor,d.otherCursor],null,"position: relative; outline: none"),d.mover=elt("div",[elt("div",[d.lineSpace],"CodeMirror-lines")],null,"position: relative"),d.sizer=elt("div",[d.mover],"CodeMirror-sizer"),d.heightForcer=elt("div",null,null,"position: absolute; height: "+scrollerCutOff+"px; width: 1px;"),d.gutters=elt("div",null,"CodeMirror-gutters"),d.lineGutter=null,d.scroller=elt("div",[d.sizer,d.heightForcer,d.gutters],"CodeMirror-scroll"),d.scroller.setAttribute("tabIndex","-1"),d.wrapper=elt("div",[d.inputDiv,d.scrollbarH,d.scrollbarV,d.scrollbarFiller,d.gutterFiller,d.scroller],"CodeMirror"),ie_lt8&&(d.gutters.style.zIndex=-1,d.scroller.style.paddingRight=0),place.appendChild?place.appendChild(d.wrapper):place(d.wrapper),ios&&(input.style.width="0px"),webkit||(d.scroller.draggable=!0),khtml?(d.inputDiv.style.height="1px",d.inputDiv.style.position="absolute"):ie_lt8&&(d.scrollbarH.style.minWidth=d.scrollbarV.style.minWidth="18px"),d.viewOffset=d.lastSizeC=0,d.showingFrom=d.showingTo=docStart,d.lineNumWidth=d.lineNumInnerWidth=d.lineNumChars=null,d.prevInput="",d.alignWidgets=!1,d.pollingFast=!1,d.poll=new Delayed,d.cachedCharWidth=d.cachedTextHeight=null,d.measureLineCache=[],d.measureLineCachePos=0,d.inaccurateSelection=!1,d.maxLine=null,d.maxLineLength=0,d.maxLineChanged=!1,d.wheelDX=d.wheelDY=d.wheelStartX=d.wheelStartY=null,d}function loadMode(cm){cm.doc.mode=CodeMirror.getMode(cm.options,cm.doc.modeOption),cm.doc.iter(function(line){line.stateAfter&&(line.stateAfter=null),line.styles&&(line.styles=null)}),cm.doc.frontier=cm.doc.first,startWorker(cm,100),cm.state.modeGen++,cm.curOp&&regChange(cm)}function wrappingChanged(cm){cm.options.lineWrapping?(cm.display.wrapper.className+=" CodeMirror-wrap",cm.display.sizer.style.minWidth=""):(cm.display.wrapper.className=cm.display.wrapper.className.replace(" CodeMirror-wrap",""),computeMaxLength(cm)),estimateLineHeights(cm),regChange(cm),clearCaches(cm),setTimeout(function(){updateScrollbars(cm)},100)}function estimateHeight(cm){var th=textHeight(cm.display),wrapping=cm.options.lineWrapping,perLine=wrapping&&Math.max(5,cm.display.scroller.clientWidth/charWidth(cm.display)-3);return function(line){return lineIsHidden(cm.doc,line)?0:wrapping?(Math.ceil(line.text.length/perLine)||1)*th:th}}function estimateLineHeights(cm){var doc=cm.doc,est=estimateHeight(cm);doc.iter(function(line){var estHeight=est(line);estHeight!=line.height&&updateLineHeight(line,estHeight)})}function keyMapChanged(cm){var map=keyMap[cm.options.keyMap],style=map.style;cm.display.wrapper.className=cm.display.wrapper.className.replace(/\s*cm-keymap-\S+/g,"")+(style?" cm-keymap-"+style:""),cm.state.disableInput=map.disableInput}function themeChanged(cm){cm.display.wrapper.className=cm.display.wrapper.className.replace(/\s*cm-s-\S+/g,"")+cm.options.theme.replace(/(^|\s)\s*/g," cm-s-"),clearCaches(cm)}function guttersChanged(cm){updateGutters(cm),regChange(cm),setTimeout(function(){alignHorizontally(cm)},20)}function updateGutters(cm){var gutters=cm.display.gutters,specs=cm.options.gutters;removeChildren(gutters);for(var i=0;i<specs.length;++i){var gutterClass=specs[i],gElt=gutters.appendChild(elt("div",null,"CodeMirror-gutter "+gutterClass));"CodeMirror-linenumbers"==gutterClass&&(cm.display.lineGutter=gElt,gElt.style.width=(cm.display.lineNumWidth||1)+"px")}gutters.style.display=i?"":"none"}function lineLength(doc,line){if(0==line.height)return 0;for(var merged,len=line.text.length,cur=line;merged=collapsedSpanAtStart(cur);){var found=merged.find();cur=getLine(doc,found.from.line),len+=found.from.ch-found.to.ch}for(cur=line;merged=collapsedSpanAtEnd(cur);){var found=merged.find();len-=cur.text.length-found.from.ch,cur=getLine(doc,found.to.line),len+=cur.text.length-found.to.ch}return len}function computeMaxLength(cm){var d=cm.display,doc=cm.doc;d.maxLine=getLine(doc,doc.first),d.maxLineLength=lineLength(doc,d.maxLine),d.maxLineChanged=!0,doc.iter(function(line){var len=lineLength(doc,line);len>d.maxLineLength&&(d.maxLineLength=len,d.maxLine=line)})}function setGuttersForLineNumbers(options){for(var found=!1,i=0;i<options.gutters.length;++i)"CodeMirror-linenumbers"==options.gutters[i]&&(options.lineNumbers?found=!0:options.gutters.splice(i--,1));!found&&options.lineNumbers&&options.gutters.push("CodeMirror-linenumbers")}function updateScrollbars(cm){var d=cm.display,docHeight=cm.doc.height,totalHeight=docHeight+paddingVert(d);d.sizer.style.minHeight=d.heightForcer.style.top=totalHeight+"px",d.gutters.style.height=Math.max(totalHeight,d.scroller.clientHeight-scrollerCutOff)+"px";var scrollHeight=Math.max(totalHeight,d.scroller.scrollHeight),needsH=d.scroller.scrollWidth>d.scroller.clientWidth+1,needsV=scrollHeight>d.scroller.clientHeight+1;needsV?(d.scrollbarV.style.display="block",d.scrollbarV.style.bottom=needsH?scrollbarWidth(d.measure)+"px":"0",d.scrollbarV.firstChild.style.height=scrollHeight-d.scroller.clientHeight+d.scrollbarV.clientHeight+"px"):d.scrollbarV.style.display="",needsH?(d.scrollbarH.style.display="block",d.scrollbarH.style.right=needsV?scrollbarWidth(d.measure)+"px":"0",d.scrollbarH.firstChild.style.width=d.scroller.scrollWidth-d.scroller.clientWidth+d.scrollbarH.clientWidth+"px"):d.scrollbarH.style.display="",needsH&&needsV?(d.scrollbarFiller.style.display="block",d.scrollbarFiller.style.height=d.scrollbarFiller.style.width=scrollbarWidth(d.measure)+"px"):d.scrollbarFiller.style.display="",needsH&&cm.options.coverGutterNextToScrollbar&&cm.options.fixedGutter?(d.gutterFiller.style.display="block",d.gutterFiller.style.height=scrollbarWidth(d.measure)+"px",d.gutterFiller.style.width=d.gutters.offsetWidth+"px"):d.gutterFiller.style.display="",mac_geLion&&0===scrollbarWidth(d.measure)&&(d.scrollbarV.style.minWidth=d.scrollbarH.style.minHeight=mac_geMountainLion?"18px":"12px")}function visibleLines(display,doc,viewPort){var top=display.scroller.scrollTop,height=display.wrapper.clientHeight;"number"==typeof viewPort?top=viewPort:viewPort&&(top=viewPort.top,height=viewPort.bottom-viewPort.top),top=Math.floor(top-paddingTop(display));var bottom=Math.ceil(top+height);return{from:lineAtHeight(doc,top),to:lineAtHeight(doc,bottom)}}function alignHorizontally(cm){var display=cm.display;if(display.alignWidgets||display.gutters.firstChild&&cm.options.fixedGutter){for(var comp=compensateForHScroll(display)-display.scroller.scrollLeft+cm.doc.scrollLeft,gutterW=display.gutters.offsetWidth,l=comp+"px",n=display.lineDiv.firstChild;n;n=n.nextSibling)if(n.alignable)for(var i=0,a=n.alignable;i<a.length;++i)a[i].style.left=l;cm.options.fixedGutter&&(display.gutters.style.left=comp+gutterW+"px")}}function maybeUpdateLineNumberWidth(cm){if(!cm.options.lineNumbers)return!1;var doc=cm.doc,last=lineNumberFor(cm.options,doc.first+doc.size-1),display=cm.display;if(last.length!=display.lineNumChars){var test=display.measure.appendChild(elt("div",[elt("div",last)],"CodeMirror-linenumber CodeMirror-gutter-elt")),innerW=test.firstChild.offsetWidth,padding=test.offsetWidth-innerW;return display.lineGutter.style.width="",display.lineNumInnerWidth=Math.max(innerW,display.lineGutter.offsetWidth-padding),display.lineNumWidth=display.lineNumInnerWidth+padding,display.lineNumChars=display.lineNumInnerWidth?last.length:-1,display.lineGutter.style.width=display.lineNumWidth+"px",!0}return!1}function lineNumberFor(options,i){return String(options.lineNumberFormatter(i+options.firstLineNumber))}function compensateForHScroll(display){return getRect(display.scroller).left-getRect(display.sizer).left}function updateDisplay(cm,changes,viewPort,forced){for(var updated,oldFrom=cm.display.showingFrom,oldTo=cm.display.showingTo,visible=visibleLines(cm.display,cm.doc,viewPort);updateDisplayInner(cm,changes,visible,forced)&&(forced=!1,updated=!0,updateSelection(cm),updateScrollbars(cm),viewPort&&(viewPort=Math.min(cm.display.scroller.scrollHeight-cm.display.scroller.clientHeight,"number"==typeof viewPort?viewPort:viewPort.top)),visible=visibleLines(cm.display,cm.doc,viewPort),!(visible.from>=cm.display.showingFrom&&visible.to<=cm.display.showingTo));)changes=[];return updated&&(signalLater(cm,"update",cm),(cm.display.showingFrom!=oldFrom||cm.display.showingTo!=oldTo)&&signalLater(cm,"viewportChange",cm,cm.display.showingFrom,cm.display.showingTo)),updated}function updateDisplayInner(cm,changes,visible,forced){var display=cm.display,doc=cm.doc;if(!display.wrapper.clientWidth)return display.showingFrom=display.showingTo=doc.first,void(display.viewOffset=0);if(!(!forced&&0==changes.length&&visible.from>display.showingFrom&&visible.to<display.showingTo)){maybeUpdateLineNumberWidth(cm)&&(changes=[{from:doc.first,to:doc.first+doc.size}]);var gutterW=display.sizer.style.marginLeft=display.gutters.offsetWidth+"px";display.scrollbarH.style.left=cm.options.fixedGutter?gutterW:"0";var positionsChangedFrom=1/0;if(cm.options.lineNumbers)for(var i=0;i<changes.length;++i)if(changes[i].diff){positionsChangedFrom=changes[i].from;break}var end=doc.first+doc.size,from=Math.max(visible.from-cm.options.viewportMargin,doc.first),to=Math.min(end,visible.to+cm.options.viewportMargin);if(display.showingFrom<from&&from-display.showingFrom<20&&(from=Math.max(doc.first,display.showingFrom)),display.showingTo>to&&display.showingTo-to<20&&(to=Math.min(end,display.showingTo)),sawCollapsedSpans)for(from=lineNo(visualLine(doc,getLine(doc,from)));end>to&&lineIsHidden(doc,getLine(doc,to));)++to;var intact=[{from:Math.max(display.showingFrom,doc.first),to:Math.min(display.showingTo,end)}];if(intact=intact[0].from>=intact[0].to?[]:computeIntact(intact,changes),sawCollapsedSpans)for(var i=0;i<intact.length;++i)for(var merged,range=intact[i];merged=collapsedSpanAtEnd(getLine(doc,range.to-1));){var newTo=merged.find().from.line;if(!(newTo>range.from)){intact.splice(i--,1);break}range.to=newTo}for(var intactLines=0,i=0;i<intact.length;++i){var range=intact[i];range.from<from&&(range.from=from),range.to>to&&(range.to=to),range.from>=range.to?intact.splice(i--,1):intactLines+=range.to-range.from}if(!forced&&intactLines==to-from&&from==display.showingFrom&&to==display.showingTo)return void updateViewOffset(cm);intact.sort(function(a,b){return a.from-b.from});try{var focused=document.activeElement}catch(e){}.7*(to-from)>intactLines&&(display.lineDiv.style.display="none"),patchDisplay(cm,from,to,intact,positionsChangedFrom),display.lineDiv.style.display="",focused&&document.activeElement!=focused&&focused.offsetHeight&&focused.focus();var different=from!=display.showingFrom||to!=display.showingTo||display.lastSizeC!=display.wrapper.clientHeight;return different&&(display.lastSizeC=display.wrapper.clientHeight,startWorker(cm,400)),display.showingFrom=from,display.showingTo=to,updateHeightsInViewport(cm),updateViewOffset(cm),!0}}function updateHeightsInViewport(cm){for(var height,display=cm.display,prevBottom=display.lineDiv.offsetTop,node=display.lineDiv.firstChild;node;node=node.nextSibling)if(node.lineObj){if(ie_lt8){var bot=node.offsetTop+node.offsetHeight;height=bot-prevBottom,prevBottom=bot}else{var box=getRect(node);height=box.bottom-box.top}var diff=node.lineObj.height-height;if(2>height&&(height=textHeight(display)),diff>.001||-.001>diff){updateLineHeight(node.lineObj,height);var widgets=node.lineObj.widgets;if(widgets)for(var i=0;i<widgets.length;++i)widgets[i].height=widgets[i].node.offsetHeight}}}function updateViewOffset(cm){var off=cm.display.viewOffset=heightAtLine(cm,getLine(cm.doc,cm.display.showingFrom));cm.display.mover.style.top=off+"px"}function computeIntact(intact,changes){for(var i=0,l=changes.length||0;l>i;++i){for(var change=changes[i],intact2=[],diff=change.diff||0,j=0,l2=intact.length;l2>j;++j){var range=intact[j];change.to<=range.from&&change.diff?intact2.push({from:range.from+diff,to:range.to+diff}):change.to<=range.from||change.from>=range.to?intact2.push(range):(change.from>range.from&&intact2.push({from:range.from,to:change.from}),change.to<range.to&&intact2.push({from:change.to+diff,to:range.to+diff}))}intact=intact2}return intact}function getDimensions(cm){for(var d=cm.display,left={},width={},n=d.gutters.firstChild,i=0;n;n=n.nextSibling,++i)left[cm.options.gutters[i]]=n.offsetLeft,width[cm.options.gutters[i]]=n.offsetWidth;return{fixedPos:compensateForHScroll(d),gutterTotalWidth:d.gutters.offsetWidth,gutterLeft:left,gutterWidth:width,wrapperWidth:d.wrapper.clientWidth}}function patchDisplay(cm,from,to,intact,updateNumbersFrom){function rm(node){var next=node.nextSibling;return webkit&&mac&&cm.display.currentWheelTarget==node?(node.style.display="none",node.lineObj=null):node.parentNode.removeChild(node),next}var dims=getDimensions(cm),display=cm.display,lineNumbers=cm.options.lineNumbers;intact.length||webkit&&cm.display.currentWheelTarget||removeChildren(display.lineDiv);var container=display.lineDiv,cur=container.firstChild,nextIntact=intact.shift(),lineN=from;for(cm.doc.iter(from,to,function(line){if(nextIntact&&nextIntact.to==lineN&&(nextIntact=intact.shift()),lineIsHidden(cm.doc,line)){if(0!=line.height&&updateLineHeight(line,0),line.widgets&&cur.previousSibling)for(var i=0;i<line.widgets.length;++i){var w=line.widgets[i];if(w.showIfHidden){var prev=cur.previousSibling;if(/pre/i.test(prev.nodeName)){var wrap=elt("div",null,null,"position: relative");prev.parentNode.replaceChild(wrap,prev),wrap.appendChild(prev),prev=wrap}var wnode=prev.appendChild(elt("div",[w.node],"CodeMirror-linewidget"));w.handleMouseEvents||(wnode.ignoreEvents=!0),positionLineWidget(w,wnode,prev,dims)}}}else if(nextIntact&&nextIntact.from<=lineN&&nextIntact.to>lineN){for(;cur.lineObj!=line;)cur=rm(cur);lineNumbers&&lineN>=updateNumbersFrom&&cur.lineNumber&&setTextContent(cur.lineNumber,lineNumberFor(cm.options,lineN)),cur=cur.nextSibling}else{if(line.widgets)for(var reuse,j=0,search=cur;search&&20>j;++j,search=search.nextSibling)if(search.lineObj==line&&/div/i.test(search.nodeName)){reuse=search;break}var lineNode=buildLineElement(cm,line,lineN,dims,reuse);if(lineNode!=reuse)container.insertBefore(lineNode,cur);else{for(;cur!=reuse;)cur=rm(cur);cur=cur.nextSibling}lineNode.lineObj=line}++lineN});cur;)cur=rm(cur)}function buildLineElement(cm,line,lineNo,dims,reuse){var wrap,lineElement=lineContent(cm,line),markers=line.gutterMarkers,display=cm.display;if(!(cm.options.lineNumbers||markers||line.bgClass||line.wrapClass||line.widgets))return lineElement;if(reuse){reuse.alignable=null;for(var next,isOk=!0,widgetsSeen=0,insertBefore=null,n=reuse.firstChild;n;n=next)if(next=n.nextSibling,/\bCodeMirror-linewidget\b/.test(n.className)){for(var i=0;i<line.widgets.length;++i){var widget=line.widgets[i];if(widget.node==n.firstChild){widget.above||insertBefore||(insertBefore=n),positionLineWidget(widget,n,reuse,dims),++widgetsSeen;break}}if(i==line.widgets.length){isOk=!1;break}}else reuse.removeChild(n);reuse.insertBefore(lineElement,insertBefore),isOk&&widgetsSeen==line.widgets.length&&(wrap=reuse,reuse.className=line.wrapClass||"")}if(wrap||(wrap=elt("div",null,line.wrapClass,"position: relative"),wrap.appendChild(lineElement)),line.bgClass&&wrap.insertBefore(elt("div",null,line.bgClass+" CodeMirror-linebackground"),wrap.firstChild),cm.options.lineNumbers||markers){var gutterWrap=wrap.insertBefore(elt("div",null,null,"position: absolute; left: "+(cm.options.fixedGutter?dims.fixedPos:-dims.gutterTotalWidth)+"px"),wrap.firstChild);if(cm.options.fixedGutter&&(wrap.alignable||(wrap.alignable=[])).push(gutterWrap),!cm.options.lineNumbers||markers&&markers["CodeMirror-linenumbers"]||(wrap.lineNumber=gutterWrap.appendChild(elt("div",lineNumberFor(cm.options,lineNo),"CodeMirror-linenumber CodeMirror-gutter-elt","left: "+dims.gutterLeft["CodeMirror-linenumbers"]+"px; width: "+display.lineNumInnerWidth+"px"))),markers)for(var k=0;k<cm.options.gutters.length;++k){var id=cm.options.gutters[k],found=markers.hasOwnProperty(id)&&markers[id];found&&gutterWrap.appendChild(elt("div",[found],"CodeMirror-gutter-elt","left: "+dims.gutterLeft[id]+"px; width: "+dims.gutterWidth[id]+"px"))}}if(ie_lt8&&(wrap.style.zIndex=2),line.widgets&&wrap!=reuse)for(var i=0,ws=line.widgets;i<ws.length;++i){var widget=ws[i],node=elt("div",[widget.node],"CodeMirror-linewidget");widget.handleMouseEvents||(node.ignoreEvents=!0),positionLineWidget(widget,node,wrap,dims),widget.above?wrap.insertBefore(node,cm.options.lineNumbers&&0!=line.height?gutterWrap:lineElement):wrap.appendChild(node),signalLater(widget,"redraw")}return wrap}function positionLineWidget(widget,node,wrap,dims){if(widget.noHScroll){(wrap.alignable||(wrap.alignable=[])).push(node);var width=dims.wrapperWidth;node.style.left=dims.fixedPos+"px",widget.coverGutter||(width-=dims.gutterTotalWidth,node.style.paddingLeft=dims.gutterTotalWidth+"px"),node.style.width=width+"px"}widget.coverGutter&&(node.style.zIndex=5,node.style.position="relative",widget.noHScroll||(node.style.marginLeft=-dims.gutterTotalWidth+"px"))}function updateSelection(cm){var display=cm.display,collapsed=posEq(cm.doc.sel.from,cm.doc.sel.to);if(collapsed||cm.options.showCursorWhenSelecting?updateSelectionCursor(cm):display.cursor.style.display=display.otherCursor.style.display="none",collapsed?display.selectionDiv.style.display="none":updateSelectionRange(cm),cm.options.moveInputWithCursor){var headPos=cursorCoords(cm,cm.doc.sel.head,"div"),wrapOff=getRect(display.wrapper),lineOff=getRect(display.lineDiv);display.inputDiv.style.top=Math.max(0,Math.min(display.wrapper.clientHeight-10,headPos.top+lineOff.top-wrapOff.top))+"px",display.inputDiv.style.left=Math.max(0,Math.min(display.wrapper.clientWidth-10,headPos.left+lineOff.left-wrapOff.left))+"px"}}function updateSelectionCursor(cm){var display=cm.display,pos=cursorCoords(cm,cm.doc.sel.head,"div");display.cursor.style.left=pos.left+"px",display.cursor.style.top=pos.top+"px",display.cursor.style.height=Math.max(0,pos.bottom-pos.top)*cm.options.cursorHeight+"px",display.cursor.style.display="",pos.other?(display.otherCursor.style.display="",display.otherCursor.style.left=pos.other.left+"px",display.otherCursor.style.top=pos.other.top+"px",display.otherCursor.style.height=.85*(pos.other.bottom-pos.other.top)+"px"):display.otherCursor.style.display="none"}function updateSelectionRange(cm){function add(left,top,width,bottom){0>top&&(top=0),fragment.appendChild(elt("div",null,"CodeMirror-selected","position: absolute; left: "+left+"px; top: "+top+"px; width: "+(null==width?clientWidth-left:width)+"px; height: "+(bottom-top)+"px"))}function drawForLine(line,fromArg,toArg){function coords(ch,bias){return charCoords(cm,Pos(line,ch),"div",lineObj,bias)}var start,end,lineObj=getLine(doc,line),lineLen=lineObj.text.length;return iterateBidiSections(getOrder(lineObj),fromArg||0,null==toArg?lineLen:toArg,function(from,to,dir){var rightPos,left,right,leftPos=coords(from,"left");if(from==to)rightPos=leftPos,left=right=leftPos.left;else{if(rightPos=coords(to-1,"right"),"rtl"==dir){var tmp=leftPos;leftPos=rightPos,rightPos=tmp}left=leftPos.left,right=rightPos.right}null==fromArg&&0==from&&(left=pl),rightPos.top-leftPos.top>3&&(add(left,leftPos.top,null,leftPos.bottom),left=pl,leftPos.bottom<rightPos.top&&add(left,leftPos.bottom,null,rightPos.top)),null==toArg&&to==lineLen&&(right=clientWidth),(!start||leftPos.top<start.top||leftPos.top==start.top&&leftPos.left<start.left)&&(start=leftPos),(!end||rightPos.bottom>end.bottom||rightPos.bottom==end.bottom&&rightPos.right>end.right)&&(end=rightPos),pl+1>left&&(left=pl),add(left,rightPos.top,right-left,rightPos.bottom)}),{start:start,end:end}}var display=cm.display,doc=cm.doc,sel=cm.doc.sel,fragment=document.createDocumentFragment(),clientWidth=display.lineSpace.offsetWidth,pl=paddingLeft(cm.display);if(sel.from.line==sel.to.line)drawForLine(sel.from.line,sel.from.ch,sel.to.ch);else{var fromLine=getLine(doc,sel.from.line),toLine=getLine(doc,sel.to.line),singleVLine=visualLine(doc,fromLine)==visualLine(doc,toLine),leftEnd=drawForLine(sel.from.line,sel.from.ch,singleVLine?fromLine.text.length:null).end,rightStart=drawForLine(sel.to.line,singleVLine?0:null,sel.to.ch).start;singleVLine&&(leftEnd.top<rightStart.top-2?(add(leftEnd.right,leftEnd.top,null,leftEnd.bottom),
add(pl,rightStart.top,rightStart.left,rightStart.bottom)):add(leftEnd.right,leftEnd.top,rightStart.left-leftEnd.right,leftEnd.bottom)),leftEnd.bottom<rightStart.top&&add(pl,leftEnd.bottom,null,rightStart.top)}removeChildrenAndAdd(display.selectionDiv,fragment),display.selectionDiv.style.display=""}function restartBlink(cm){if(cm.state.focused){var display=cm.display;clearInterval(display.blinker);var on=!0;display.cursor.style.visibility=display.otherCursor.style.visibility="",display.blinker=setInterval(function(){display.cursor.style.visibility=display.otherCursor.style.visibility=(on=!on)?"":"hidden"},cm.options.cursorBlinkRate)}}function startWorker(cm,time){cm.doc.mode.startState&&cm.doc.frontier<cm.display.showingTo&&cm.state.highlight.set(time,bind(highlightWorker,cm))}function highlightWorker(cm){var doc=cm.doc;if(doc.frontier<doc.first&&(doc.frontier=doc.first),!(doc.frontier>=cm.display.showingTo)){var prevChange,end=+new Date+cm.options.workTime,state=copyState(doc.mode,getStateBefore(cm,doc.frontier)),changed=[];doc.iter(doc.frontier,Math.min(doc.first+doc.size,cm.display.showingTo+500),function(line){if(doc.frontier>=cm.display.showingFrom){var oldStyles=line.styles;line.styles=highlightLine(cm,line,state);for(var ischange=!oldStyles||oldStyles.length!=line.styles.length,i=0;!ischange&&i<oldStyles.length;++i)ischange=oldStyles[i]!=line.styles[i];ischange&&(prevChange&&prevChange.end==doc.frontier?prevChange.end++:changed.push(prevChange={start:doc.frontier,end:doc.frontier+1})),line.stateAfter=copyState(doc.mode,state)}else processLine(cm,line,state),line.stateAfter=doc.frontier%5==0?copyState(doc.mode,state):null;return++doc.frontier,+new Date>end?(startWorker(cm,cm.options.workDelay),!0):void 0}),changed.length&&operation(cm,function(){for(var i=0;i<changed.length;++i)regChange(this,changed[i].start,changed[i].end)})()}}function findStartLine(cm,n,precise){for(var minindent,minline,doc=cm.doc,search=n,lim=n-100;search>lim;--search){if(search<=doc.first)return doc.first;var line=getLine(doc,search-1);if(line.stateAfter&&(!precise||search<=doc.frontier))return search;var indented=countColumn(line.text,null,cm.options.tabSize);(null==minline||minindent>indented)&&(minline=search-1,minindent=indented)}return minline}function getStateBefore(cm,n,precise){var doc=cm.doc,display=cm.display;if(!doc.mode.startState)return!0;var pos=findStartLine(cm,n,precise),state=pos>doc.first&&getLine(doc,pos-1).stateAfter;return state=state?copyState(doc.mode,state):startState(doc.mode),doc.iter(pos,n,function(line){processLine(cm,line,state);var save=pos==n-1||pos%5==0||pos>=display.showingFrom&&pos<display.showingTo;line.stateAfter=save?copyState(doc.mode,state):null,++pos}),state}function paddingTop(display){return display.lineSpace.offsetTop}function paddingVert(display){return display.mover.offsetHeight-display.lineSpace.offsetHeight}function paddingLeft(display){var e=removeChildrenAndAdd(display.measure,elt("pre",null,null,"text-align: left")).appendChild(elt("span","x"));return e.offsetLeft}function measureChar(cm,line,ch,data,bias){var dir=-1;data=data||measureLine(cm,line);for(var pos=ch;;pos+=dir){var r=data[pos];if(r)break;0>dir&&0==pos&&(dir=1)}return bias=pos>ch?"left":ch>pos?"right":bias,"left"==bias&&r.leftSide?r=r.leftSide:"right"==bias&&r.rightSide&&(r=r.rightSide),{left:ch>pos?r.right:r.left,right:pos>ch?r.left:r.right,top:r.top,bottom:r.bottom}}function findCachedMeasurement(cm,line){for(var cache=cm.display.measureLineCache,i=0;i<cache.length;++i){var memo=cache[i];if(memo.text==line.text&&memo.markedSpans==line.markedSpans&&cm.display.scroller.clientWidth==memo.width&&memo.classes==line.textClass+"|"+line.bgClass+"|"+line.wrapClass)return memo}}function clearCachedMeasurement(cm,line){var exists=findCachedMeasurement(cm,line);exists&&(exists.text=exists.measure=exists.markedSpans=null)}function measureLine(cm,line){var cached=findCachedMeasurement(cm,line);if(cached)return cached.measure;var measure=measureLineInner(cm,line),cache=cm.display.measureLineCache,memo={text:line.text,width:cm.display.scroller.clientWidth,markedSpans:line.markedSpans,measure:measure,classes:line.textClass+"|"+line.bgClass+"|"+line.wrapClass};return 16==cache.length?cache[++cm.display.measureLineCachePos%16]=memo:cache.push(memo),measure}function measureLineInner(cm,line){function measureRect(rect){var top=rect.top-outer.top,bot=rect.bottom-outer.top;bot>maxBot&&(bot=maxBot),0>top&&(top=0);for(var i=vranges.length-2;i>=0;i-=2){var rtop=vranges[i],rbot=vranges[i+1];if(!(rtop>bot||top>rbot)&&(top>=rtop&&rbot>=bot||rtop>=top&&bot>=rbot||Math.min(bot,rbot)-Math.max(top,rtop)>=bot-top>>1)){vranges[i]=Math.min(top,rtop),vranges[i+1]=Math.max(bot,rbot);break}}return 0>i&&(i=vranges.length,vranges.push(top,bot)),{left:rect.left-outer.left,right:rect.right-outer.left,top:i,bottom:null}}function finishRect(rect){rect.bottom=vranges[rect.top+1],rect.top=vranges[rect.top]}var display=cm.display,measure=emptyArray(line.text.length),pre=lineContent(cm,line,measure,!0);if(ie&&!ie_lt8&&!cm.options.lineWrapping&&pre.childNodes.length>100){for(var fragment=document.createDocumentFragment(),chunk=10,n=pre.childNodes.length,i=0,chunks=Math.ceil(n/chunk);chunks>i;++i){for(var wrap=elt("div",null,null,"display: inline-block"),j=0;chunk>j&&n;++j)wrap.appendChild(pre.firstChild),--n;fragment.appendChild(wrap)}pre.appendChild(fragment)}removeChildrenAndAdd(display.measure,pre);var outer=getRect(display.lineDiv),vranges=[],data=emptyArray(line.text.length),maxBot=pre.offsetHeight;ie_lt9&&display.measure.first!=pre&&removeChildrenAndAdd(display.measure,pre);for(var cur,i=0;i<measure.length;++i)if(cur=measure[i]){var node=cur,rect=null;if(/\bCodeMirror-widget\b/.test(cur.className)&&cur.getClientRects){1==cur.firstChild.nodeType&&(node=cur.firstChild);var rects=node.getClientRects();rects.length>1&&(rect=data[i]=measureRect(rects[0]),rect.rightSide=measureRect(rects[rects.length-1]))}rect||(rect=data[i]=measureRect(getRect(node))),cur.measureRight&&(rect.right=getRect(cur.measureRight).left),cur.leftSide&&(rect.leftSide=measureRect(getRect(cur.leftSide)))}for(var cur,i=0;i<data.length;++i)(cur=data[i])&&(finishRect(cur),cur.leftSide&&finishRect(cur.leftSide),cur.rightSide&&finishRect(cur.rightSide));return data}function measureLineWidth(cm,line){var hasBadSpan=!1;if(line.markedSpans)for(var i=0;i<line.markedSpans;++i){var sp=line.markedSpans[i];!sp.collapsed||null!=sp.to&&sp.to!=line.text.length||(hasBadSpan=!0)}var cached=!hasBadSpan&&findCachedMeasurement(cm,line);if(cached)return measureChar(cm,line,line.text.length,cached.measure,"right").right;var pre=lineContent(cm,line,null,!0),end=pre.appendChild(zeroWidthElement(cm.display.measure));return removeChildrenAndAdd(cm.display.measure,pre),getRect(end).right-getRect(cm.display.lineDiv).left}function clearCaches(cm){cm.display.measureLineCache.length=cm.display.measureLineCachePos=0,cm.display.cachedCharWidth=cm.display.cachedTextHeight=null,cm.options.lineWrapping||(cm.display.maxLineChanged=!0),cm.display.lineNumChars=null}function pageScrollX(){return window.pageXOffset||(document.documentElement||document.body).scrollLeft}function pageScrollY(){return window.pageYOffset||(document.documentElement||document.body).scrollTop}function intoCoordSystem(cm,lineObj,rect,context){if(lineObj.widgets)for(var i=0;i<lineObj.widgets.length;++i)if(lineObj.widgets[i].above){var size=widgetHeight(lineObj.widgets[i]);rect.top+=size,rect.bottom+=size}if("line"==context)return rect;context||(context="local");var yOff=heightAtLine(cm,lineObj);if("local"==context?yOff+=paddingTop(cm.display):yOff-=cm.display.viewOffset,"page"==context||"window"==context){var lOff=getRect(cm.display.lineSpace);yOff+=lOff.top+("window"==context?0:pageScrollY());var xOff=lOff.left+("window"==context?0:pageScrollX());rect.left+=xOff,rect.right+=xOff}return rect.top+=yOff,rect.bottom+=yOff,rect}function fromCoordSystem(cm,coords,context){if("div"==context)return coords;var left=coords.left,top=coords.top;if("page"==context)left-=pageScrollX(),top-=pageScrollY();else if("local"==context||!context){var localBox=getRect(cm.display.sizer);left+=localBox.left,top+=localBox.top}var lineSpaceBox=getRect(cm.display.lineSpace);return{left:left-lineSpaceBox.left,top:top-lineSpaceBox.top}}function charCoords(cm,pos,context,lineObj,bias){return lineObj||(lineObj=getLine(cm.doc,pos.line)),intoCoordSystem(cm,lineObj,measureChar(cm,lineObj,pos.ch,null,bias),context)}function cursorCoords(cm,pos,context,lineObj,measurement){function get(ch,right){var m=measureChar(cm,lineObj,ch,measurement,right?"right":"left");return right?m.left=m.right:m.right=m.left,intoCoordSystem(cm,lineObj,m,context)}function getBidi(ch,partPos){var part=order[partPos],right=part.level%2;return ch==bidiLeft(part)&&partPos&&part.level<order[partPos-1].level?(part=order[--partPos],ch=bidiRight(part)-(part.level%2?0:1),right=!0):ch==bidiRight(part)&&partPos<order.length-1&&part.level<order[partPos+1].level&&(part=order[++partPos],ch=bidiLeft(part)-part.level%2,right=!1),right&&ch==part.to&&ch>part.from?get(ch-1):get(ch,right)}lineObj=lineObj||getLine(cm.doc,pos.line),measurement||(measurement=measureLine(cm,lineObj));var order=getOrder(lineObj),ch=pos.ch;if(!order)return get(ch);var partPos=getBidiPartAt(order,ch),val=getBidi(ch,partPos);return null!=bidiOther&&(val.other=getBidi(ch,bidiOther)),val}function PosWithInfo(line,ch,outside,xRel){var pos=new Pos(line,ch);return pos.xRel=xRel,outside&&(pos.outside=!0),pos}function coordsChar(cm,x,y){var doc=cm.doc;if(y+=cm.display.viewOffset,0>y)return PosWithInfo(doc.first,0,!0,-1);var lineNo=lineAtHeight(doc,y),last=doc.first+doc.size-1;if(lineNo>last)return PosWithInfo(doc.first+doc.size-1,getLine(doc,last).text.length,!0,1);for(0>x&&(x=0);;){var lineObj=getLine(doc,lineNo),found=coordsCharInner(cm,lineObj,lineNo,x,y),merged=collapsedSpanAtEnd(lineObj),mergedPos=merged&&merged.find();if(!merged||!(found.ch>mergedPos.from.ch||found.ch==mergedPos.from.ch&&found.xRel>0))return found;lineNo=mergedPos.to.line}}function coordsCharInner(cm,lineObj,lineNo,x,y){function getX(ch){var sp=cursorCoords(cm,Pos(lineNo,ch),"line",lineObj,measurement);return wrongLine=!0,innerOff>sp.bottom?sp.left-adjust:innerOff<sp.top?sp.left+adjust:(wrongLine=!1,sp.left)}var innerOff=y-heightAtLine(cm,lineObj),wrongLine=!1,adjust=2*cm.display.wrapper.clientWidth,measurement=measureLine(cm,lineObj),bidi=getOrder(lineObj),dist=lineObj.text.length,from=lineLeft(lineObj),to=lineRight(lineObj),fromX=getX(from),fromOutside=wrongLine,toX=getX(to),toOutside=wrongLine;if(x>toX)return PosWithInfo(lineNo,to,toOutside,1);for(;;){if(bidi?to==from||to==moveVisually(lineObj,from,1):1>=to-from){for(var ch=fromX>x||toX-x>=x-fromX?from:to,xDiff=x-(ch==from?fromX:toX);isExtendingChar.test(lineObj.text.charAt(ch));)++ch;var pos=PosWithInfo(lineNo,ch,ch==from?fromOutside:toOutside,0>xDiff?-1:xDiff?1:0);return pos}var step=Math.ceil(dist/2),middle=from+step;if(bidi){middle=from;for(var i=0;step>i;++i)middle=moveVisually(lineObj,middle,1)}var middleX=getX(middle);middleX>x?(to=middle,toX=middleX,(toOutside=wrongLine)&&(toX+=1e3),dist=step):(from=middle,fromX=middleX,fromOutside=wrongLine,dist-=step)}}function textHeight(display){if(null!=display.cachedTextHeight)return display.cachedTextHeight;if(null==measureText){measureText=elt("pre");for(var i=0;49>i;++i)measureText.appendChild(document.createTextNode("x")),measureText.appendChild(elt("br"));measureText.appendChild(document.createTextNode("x"))}removeChildrenAndAdd(display.measure,measureText);var height=measureText.offsetHeight/50;return height>3&&(display.cachedTextHeight=height),removeChildren(display.measure),height||1}function charWidth(display){if(null!=display.cachedCharWidth)return display.cachedCharWidth;var anchor=elt("span","x"),pre=elt("pre",[anchor]);removeChildrenAndAdd(display.measure,pre);var width=anchor.offsetWidth;return width>2&&(display.cachedCharWidth=width),width||10}function startOperation(cm){cm.curOp={changes:[],forceUpdate:!1,updateInput:null,userSelChange:null,textChanged:null,selectionChanged:!1,cursorActivity:!1,updateMaxLine:!1,updateScrollPos:!1,id:++nextOpId},delayedCallbackDepth++||(delayedCallbacks=[])}function endOperation(cm){var op=cm.curOp,doc=cm.doc,display=cm.display;if(cm.curOp=null,op.updateMaxLine&&computeMaxLength(cm),display.maxLineChanged&&!cm.options.lineWrapping&&display.maxLine){var width=measureLineWidth(cm,display.maxLine);display.sizer.style.minWidth=Math.max(0,width+3+scrollerCutOff)+"px",display.maxLineChanged=!1;var maxScrollLeft=Math.max(0,display.sizer.offsetLeft+display.sizer.offsetWidth-display.scroller.clientWidth);maxScrollLeft<doc.scrollLeft&&!op.updateScrollPos&&setScrollLeft(cm,Math.min(display.scroller.scrollLeft,maxScrollLeft),!0)}var newScrollPos,updated;if(op.updateScrollPos)newScrollPos=op.updateScrollPos;else if(op.selectionChanged&&display.scroller.clientHeight){var coords=cursorCoords(cm,doc.sel.head);newScrollPos=calculateScrollPos(cm,coords.left,coords.top,coords.left,coords.bottom)}(op.changes.length||op.forceUpdate||newScrollPos&&null!=newScrollPos.scrollTop)&&(updated=updateDisplay(cm,op.changes,newScrollPos&&newScrollPos.scrollTop,op.forceUpdate),cm.display.scroller.offsetHeight&&(cm.doc.scrollTop=cm.display.scroller.scrollTop)),!updated&&op.selectionChanged&&updateSelection(cm),op.updateScrollPos?(display.scroller.scrollTop=display.scrollbarV.scrollTop=doc.scrollTop=newScrollPos.scrollTop,display.scroller.scrollLeft=display.scrollbarH.scrollLeft=doc.scrollLeft=newScrollPos.scrollLeft,alignHorizontally(cm),op.scrollToPos&&scrollPosIntoView(cm,clipPos(cm.doc,op.scrollToPos),op.scrollToPosMargin)):newScrollPos&&scrollCursorIntoView(cm),op.selectionChanged&&restartBlink(cm),cm.state.focused&&op.updateInput&&resetInput(cm,op.userSelChange);var hidden=op.maybeHiddenMarkers,unhidden=op.maybeUnhiddenMarkers;if(hidden)for(var i=0;i<hidden.length;++i)hidden[i].lines.length||signal(hidden[i],"hide");if(unhidden)for(var i=0;i<unhidden.length;++i)unhidden[i].lines.length&&signal(unhidden[i],"unhide");var delayed;if(--delayedCallbackDepth||(delayed=delayedCallbacks,delayedCallbacks=null),op.textChanged&&signal(cm,"change",cm,op.textChanged),op.cursorActivity&&signal(cm,"cursorActivity",cm),delayed)for(var i=0;i<delayed.length;++i)delayed[i]()}function operation(cm1,f){return function(){var cm=cm1||this,withOp=!cm.curOp;withOp&&startOperation(cm);try{var result=f.apply(cm,arguments)}finally{withOp&&endOperation(cm)}return result}}function docOperation(f){return function(){var result,withOp=this.cm&&!this.cm.curOp;withOp&&startOperation(this.cm);try{result=f.apply(this,arguments)}finally{withOp&&endOperation(this.cm)}return result}}function runInOp(cm,f){var result,withOp=!cm.curOp;withOp&&startOperation(cm);try{result=f()}finally{withOp&&endOperation(cm)}return result}function regChange(cm,from,to,lendiff){null==from&&(from=cm.doc.first),null==to&&(to=cm.doc.first+cm.doc.size),cm.curOp.changes.push({from:from,to:to,diff:lendiff})}function slowPoll(cm){cm.display.pollingFast||cm.display.poll.set(cm.options.pollInterval,function(){readInput(cm),cm.state.focused&&slowPoll(cm)})}function fastPoll(cm){function p(){var changed=readInput(cm);changed||missed?(cm.display.pollingFast=!1,slowPoll(cm)):(missed=!0,cm.display.poll.set(60,p))}var missed=!1;cm.display.pollingFast=!0,cm.display.poll.set(20,p)}function readInput(cm){var input=cm.display.input,prevInput=cm.display.prevInput,doc=cm.doc,sel=doc.sel;if(!cm.state.focused||hasSelection(input)||isReadOnly(cm)||cm.state.disableInput)return!1;var text=input.value;if(text==prevInput&&posEq(sel.from,sel.to))return!1;if(ie&&!ie_lt9&&cm.display.inputHasSelection===text)return resetInput(cm,!0),!1;var withOp=!cm.curOp;withOp&&startOperation(cm),sel.shift=!1;for(var same=0,l=Math.min(prevInput.length,text.length);l>same&&prevInput.charCodeAt(same)==text.charCodeAt(same);)++same;var from=sel.from,to=sel.to;same<prevInput.length?from=Pos(from.line,from.ch-(prevInput.length-same)):cm.state.overwrite&&posEq(from,to)&&!cm.state.pasteIncoming&&(to=Pos(to.line,Math.min(getLine(doc,to.line).text.length,to.ch+(text.length-same))));var updateInput=cm.curOp.updateInput,changeEvent={from:from,to:to,text:splitLines(text.slice(same)),origin:cm.state.pasteIncoming?"paste":"+input"};return makeChange(cm.doc,changeEvent,"end"),cm.curOp.updateInput=updateInput,signalLater(cm,"inputRead",cm,changeEvent),text.length>1e3||text.indexOf("\n")>-1?input.value=cm.display.prevInput="":cm.display.prevInput=text,withOp&&endOperation(cm),cm.state.pasteIncoming=!1,!0}function resetInput(cm,user){var minimal,selected,doc=cm.doc;if(posEq(doc.sel.from,doc.sel.to))user&&(cm.display.prevInput=cm.display.input.value="",ie&&!ie_lt9&&(cm.display.inputHasSelection=null));else{cm.display.prevInput="",minimal=hasCopyEvent&&(doc.sel.to.line-doc.sel.from.line>100||(selected=cm.getSelection()).length>1e3);var content=minimal?"-":selected||cm.getSelection();cm.display.input.value=content,cm.state.focused&&selectInput(cm.display.input),ie&&!ie_lt9&&(cm.display.inputHasSelection=content)}cm.display.inaccurateSelection=minimal}function focusInput(cm){"nocursor"==cm.options.readOnly||mobile&&document.activeElement==cm.display.input||cm.display.input.focus()}function isReadOnly(cm){return cm.options.readOnly||cm.doc.cantEdit}function registerEventHandlers(cm){function reFocus(){cm.state.focused&&setTimeout(bind(focusInput,cm),0)}function onResize(){null==resizeTimer&&(resizeTimer=setTimeout(function(){resizeTimer=null,d.cachedCharWidth=d.cachedTextHeight=knownScrollbarWidth=null,clearCaches(cm),runInOp(cm,bind(regChange,cm))},100))}function unregister(){for(var p=d.wrapper.parentNode;p&&p!=document.body;p=p.parentNode);p?setTimeout(unregister,5e3):off(window,"resize",onResize)}function drag_(e){signalDOMEvent(cm,e)||cm.options.onDragEvent&&cm.options.onDragEvent(cm,addStop(e))||e_stop(e)}function prepareCopy(){d.inaccurateSelection&&(d.prevInput="",d.inaccurateSelection=!1,d.input.value=cm.getSelection(),selectInput(d.input))}var d=cm.display;on(d.scroller,"mousedown",operation(cm,onMouseDown)),ie?on(d.scroller,"dblclick",operation(cm,function(e){if(!signalDOMEvent(cm,e)){var pos=posFromMouse(cm,e);if(pos&&!clickInGutter(cm,e)&&!eventInWidget(cm.display,e)){e_preventDefault(e);var word=findWordAt(getLine(cm.doc,pos.line).text,pos);extendSelection(cm.doc,word.from,word.to)}}})):on(d.scroller,"dblclick",function(e){signalDOMEvent(cm,e)||e_preventDefault(e)}),on(d.lineSpace,"selectstart",function(e){eventInWidget(d,e)||e_preventDefault(e)}),captureMiddleClick||on(d.scroller,"contextmenu",function(e){onContextMenu(cm,e)}),on(d.scroller,"scroll",function(){d.scroller.clientHeight&&(setScrollTop(cm,d.scroller.scrollTop),setScrollLeft(cm,d.scroller.scrollLeft,!0),signal(cm,"scroll",cm))}),on(d.scrollbarV,"scroll",function(){d.scroller.clientHeight&&setScrollTop(cm,d.scrollbarV.scrollTop)}),on(d.scrollbarH,"scroll",function(){d.scroller.clientHeight&&setScrollLeft(cm,d.scrollbarH.scrollLeft)}),on(d.scroller,"mousewheel",function(e){onScrollWheel(cm,e)}),on(d.scroller,"DOMMouseScroll",function(e){onScrollWheel(cm,e)}),on(d.scrollbarH,"mousedown",reFocus),on(d.scrollbarV,"mousedown",reFocus),on(d.wrapper,"scroll",function(){d.wrapper.scrollTop=d.wrapper.scrollLeft=0});var resizeTimer;on(window,"resize",onResize),setTimeout(unregister,5e3),on(d.input,"keyup",operation(cm,function(e){signalDOMEvent(cm,e)||cm.options.onKeyEvent&&cm.options.onKeyEvent(cm,addStop(e))||16==e.keyCode&&(cm.doc.sel.shift=!1)})),on(d.input,"input",bind(fastPoll,cm)),on(d.input,"keydown",operation(cm,onKeyDown)),on(d.input,"keypress",operation(cm,onKeyPress)),on(d.input,"focus",bind(onFocus,cm)),on(d.input,"blur",bind(onBlur,cm)),cm.options.dragDrop&&(on(d.scroller,"dragstart",function(e){onDragStart(cm,e)}),on(d.scroller,"dragenter",drag_),on(d.scroller,"dragover",drag_),on(d.scroller,"drop",operation(cm,onDrop))),on(d.scroller,"paste",function(e){eventInWidget(d,e)||(focusInput(cm),fastPoll(cm))}),on(d.input,"paste",function(){cm.state.pasteIncoming=!0,fastPoll(cm)}),on(d.input,"cut",prepareCopy),on(d.input,"copy",prepareCopy),khtml&&on(d.sizer,"mouseup",function(){document.activeElement==d.input&&d.input.blur(),focusInput(cm)})}function eventInWidget(display,e){for(var n=e_target(e);n!=display.wrapper;n=n.parentNode)if(!n||n.ignoreEvents||n.parentNode==display.sizer&&n!=display.mover)return!0}function posFromMouse(cm,e,liberal){var display=cm.display;if(!liberal){var target=e_target(e);if(target==display.scrollbarH||target==display.scrollbarH.firstChild||target==display.scrollbarV||target==display.scrollbarV.firstChild||target==display.scrollbarFiller||target==display.gutterFiller)return null}var x,y,space=getRect(display.lineSpace);try{x=e.clientX,y=e.clientY}catch(e){return null}return coordsChar(cm,x-space.left,y-space.top)}function onMouseDown(e){function doSelect(cur){if(!posEq(lastPos,cur)){if(lastPos=cur,"single"==type)return void extendSelection(cm.doc,clipPos(doc,start),cur);if(startstart=clipPos(doc,startstart),startend=clipPos(doc,startend),"double"==type){var word=findWordAt(getLine(doc,cur.line).text,cur);posLess(cur,startstart)?extendSelection(cm.doc,word.from,startend):extendSelection(cm.doc,startstart,word.to)}else"triple"==type&&(posLess(cur,startstart)?extendSelection(cm.doc,startend,clipPos(doc,Pos(cur.line,0))):extendSelection(cm.doc,startstart,clipPos(doc,Pos(cur.line+1,0))))}}function extend(e){var curCount=++counter,cur=posFromMouse(cm,e,!0);if(cur)if(posEq(cur,last)){var outside=e.clientY<editorSize.top?-20:e.clientY>editorSize.bottom?20:0;outside&&setTimeout(operation(cm,function(){counter==curCount&&(display.scroller.scrollTop+=outside,extend(e))}),50)}else{cm.state.focused||onFocus(cm),last=cur,doSelect(cur);var visible=visibleLines(display,doc);(cur.line>=visible.to||cur.line<visible.from)&&setTimeout(operation(cm,function(){counter==curCount&&extend(e)}),150)}}function done(e){counter=1/0,e_preventDefault(e),focusInput(cm),off(document,"mousemove",move),off(document,"mouseup",up)}if(!signalDOMEvent(this,e)){var cm=this,display=cm.display,doc=cm.doc,sel=doc.sel;if(sel.shift=e.shiftKey,eventInWidget(display,e))return void(webkit||(display.scroller.draggable=!1,setTimeout(function(){display.scroller.draggable=!0},100)));if(!clickInGutter(cm,e)){var start=posFromMouse(cm,e);switch(e_button(e)){case 3:return void(captureMiddleClick&&onContextMenu.call(cm,cm,e));case 2:return start&&extendSelection(cm.doc,start),setTimeout(bind(focusInput,cm),20),void e_preventDefault(e)}if(!start)return void(e_target(e)==display.scroller&&e_preventDefault(e));cm.state.focused||onFocus(cm);var now=+new Date,type="single";if(lastDoubleClick&&lastDoubleClick.time>now-400&&posEq(lastDoubleClick.pos,start))type="triple",e_preventDefault(e),setTimeout(bind(focusInput,cm),20),selectLine(cm,start.line);else if(lastClick&&lastClick.time>now-400&&posEq(lastClick.pos,start)){type="double",lastDoubleClick={time:now,pos:start},e_preventDefault(e);var word=findWordAt(getLine(doc,start.line).text,start);extendSelection(cm.doc,word.from,word.to)}else lastClick={time:now,pos:start};var last=start;if(cm.options.dragDrop&&dragAndDrop&&!isReadOnly(cm)&&!posEq(sel.from,sel.to)&&!posLess(start,sel.from)&&!posLess(sel.to,start)&&"single"==type){var dragEnd=operation(cm,function(e2){webkit&&(display.scroller.draggable=!1),cm.state.draggingText=!1,off(document,"mouseup",dragEnd),off(display.scroller,"drop",dragEnd),Math.abs(e.clientX-e2.clientX)+Math.abs(e.clientY-e2.clientY)<10&&(e_preventDefault(e2),extendSelection(cm.doc,start),focusInput(cm))});return webkit&&(display.scroller.draggable=!0),cm.state.draggingText=dragEnd,display.scroller.dragDrop&&display.scroller.dragDrop(),on(document,"mouseup",dragEnd),void on(display.scroller,"drop",dragEnd)}e_preventDefault(e),"single"==type&&extendSelection(cm.doc,clipPos(doc,start));var startstart=sel.from,startend=sel.to,lastPos=start,editorSize=getRect(display.wrapper),counter=0,move=operation(cm,function(e){ie||e_button(e)?extend(e):done(e)}),up=operation(cm,done);on(document,"mousemove",move),on(document,"mouseup",up)}}}function clickInGutter(cm,e){var display=cm.display;try{var mX=e.clientX,mY=e.clientY}catch(e){return!1}if(mX>=Math.floor(getRect(display.gutters).right))return!1;if(e_preventDefault(e),!hasHandler(cm,"gutterClick"))return!0;var lineBox=getRect(display.lineDiv);if(mY>lineBox.bottom)return!0;mY-=lineBox.top-display.viewOffset;for(var i=0;i<cm.options.gutters.length;++i){var g=display.gutters.childNodes[i];if(g&&getRect(g).right>=mX){var line=lineAtHeight(cm.doc,mY),gutter=cm.options.gutters[i];signalLater(cm,"gutterClick",cm,line,gutter,e);break}}return!0}function onDrop(e){var cm=this;if(!(signalDOMEvent(cm,e)||eventInWidget(cm.display,e)||cm.options.onDragEvent&&cm.options.onDragEvent(cm,addStop(e)))){e_preventDefault(e),ie&&(lastDrop=+new Date);var pos=posFromMouse(cm,e,!0),files=e.dataTransfer.files;if(pos&&!isReadOnly(cm))if(files&&files.length&&window.FileReader&&window.File)for(var n=files.length,text=Array(n),read=0,loadFile=function(file,i){var reader=new FileReader;reader.onload=function(){text[i]=reader.result,++read==n&&(pos=clipPos(cm.doc,pos),makeChange(cm.doc,{from:pos,to:pos,text:splitLines(text.join("\n")),origin:"paste"},"around"))},reader.readAsText(file)},i=0;n>i;++i)loadFile(files[i],i);else{if(cm.state.draggingText&&!posLess(pos,cm.doc.sel.from)&&!posLess(cm.doc.sel.to,pos))return cm.state.draggingText(e),void setTimeout(bind(focusInput,cm),20);try{var text=e.dataTransfer.getData("Text");if(text){var curFrom=cm.doc.sel.from,curTo=cm.doc.sel.to;setSelection(cm.doc,pos,pos),cm.state.draggingText&&replaceRange(cm.doc,"",curFrom,curTo,"paste"),cm.replaceSelection(text,null,"paste"),focusInput(cm),onFocus(cm)}}catch(e){}}}}function onDragStart(cm,e){if(ie&&(!cm.state.draggingText||+new Date-lastDrop<100))return void e_stop(e);if(!signalDOMEvent(cm,e)&&!eventInWidget(cm.display,e)){var txt=cm.getSelection();if(e.dataTransfer.setData("Text",txt),e.dataTransfer.setDragImage&&!safari){var img=elt("img",null,null,"position: fixed; left: 0; top: 0;");opera&&(img.width=img.height=1,cm.display.wrapper.appendChild(img),img._top=img.offsetTop),e.dataTransfer.setDragImage(img,0,0),opera&&img.parentNode.removeChild(img)}}}function setScrollTop(cm,val){Math.abs(cm.doc.scrollTop-val)<2||(cm.doc.scrollTop=val,gecko||updateDisplay(cm,[],val),cm.display.scroller.scrollTop!=val&&(cm.display.scroller.scrollTop=val),cm.display.scrollbarV.scrollTop!=val&&(cm.display.scrollbarV.scrollTop=val),gecko&&updateDisplay(cm,[]),startWorker(cm,100))}function setScrollLeft(cm,val,isScroller){(isScroller?val==cm.doc.scrollLeft:Math.abs(cm.doc.scrollLeft-val)<2)||(val=Math.min(val,cm.display.scroller.scrollWidth-cm.display.scroller.clientWidth),cm.doc.scrollLeft=val,alignHorizontally(cm),cm.display.scroller.scrollLeft!=val&&(cm.display.scroller.scrollLeft=val),cm.display.scrollbarH.scrollLeft!=val&&(cm.display.scrollbarH.scrollLeft=val))}function onScrollWheel(cm,e){var dx=e.wheelDeltaX,dy=e.wheelDeltaY;null==dx&&e.detail&&e.axis==e.HORIZONTAL_AXIS&&(dx=e.detail),null==dy&&e.detail&&e.axis==e.VERTICAL_AXIS?dy=e.detail:null==dy&&(dy=e.wheelDelta);var display=cm.display,scroll=display.scroller;if(dx&&scroll.scrollWidth>scroll.clientWidth||dy&&scroll.scrollHeight>scroll.clientHeight){if(dy&&mac&&webkit)for(var cur=e.target;cur!=scroll;cur=cur.parentNode)if(cur.lineObj){cm.display.currentWheelTarget=cur;break}if(dx&&!gecko&&!opera&&null!=wheelPixelsPerUnit)return dy&&setScrollTop(cm,Math.max(0,Math.min(scroll.scrollTop+dy*wheelPixelsPerUnit,scroll.scrollHeight-scroll.clientHeight))),setScrollLeft(cm,Math.max(0,Math.min(scroll.scrollLeft+dx*wheelPixelsPerUnit,scroll.scrollWidth-scroll.clientWidth))),e_preventDefault(e),void(display.wheelStartX=null);if(dy&&null!=wheelPixelsPerUnit){var pixels=dy*wheelPixelsPerUnit,top=cm.doc.scrollTop,bot=top+display.wrapper.clientHeight;0>pixels?top=Math.max(0,top+pixels-50):bot=Math.min(cm.doc.height,bot+pixels+50),updateDisplay(cm,[],{top:top,bottom:bot})}20>wheelSamples&&(null==display.wheelStartX?(display.wheelStartX=scroll.scrollLeft,display.wheelStartY=scroll.scrollTop,display.wheelDX=dx,display.wheelDY=dy,setTimeout(function(){if(null!=display.wheelStartX){var movedX=scroll.scrollLeft-display.wheelStartX,movedY=scroll.scrollTop-display.wheelStartY,sample=movedY&&display.wheelDY&&movedY/display.wheelDY||movedX&&display.wheelDX&&movedX/display.wheelDX;display.wheelStartX=display.wheelStartY=null,sample&&(wheelPixelsPerUnit=(wheelPixelsPerUnit*wheelSamples+sample)/(wheelSamples+1),++wheelSamples)}},200)):(display.wheelDX+=dx,display.wheelDY+=dy))}}function doHandleBinding(cm,bound,dropShift){if("string"==typeof bound&&(bound=commands[bound],!bound))return!1;cm.display.pollingFast&&readInput(cm)&&(cm.display.pollingFast=!1);var doc=cm.doc,prevShift=doc.sel.shift,done=!1;try{isReadOnly(cm)&&(cm.state.suppressEdits=!0),dropShift&&(doc.sel.shift=!1),done=bound(cm)!=Pass}finally{doc.sel.shift=prevShift,cm.state.suppressEdits=!1}return done}function allKeyMaps(cm){var maps=cm.state.keyMaps.slice(0);return cm.options.extraKeys&&maps.push(cm.options.extraKeys),maps.push(cm.options.keyMap),maps}function handleKeyBinding(cm,e){var startMap=getKeyMap(cm.options.keyMap),next=startMap.auto;clearTimeout(maybeTransition),next&&!isModifierKey(e)&&(maybeTransition=setTimeout(function(){getKeyMap(cm.options.keyMap)==startMap&&(cm.options.keyMap=next.call?next.call(null,cm):next,keyMapChanged(cm))},50));var name=keyName(e,!0),handled=!1;if(!name)return!1;var keymaps=allKeyMaps(cm);return handled=e.shiftKey?lookupKey("Shift-"+name,keymaps,function(b){return doHandleBinding(cm,b,!0)})||lookupKey(name,keymaps,function(b){return("string"==typeof b?/^go[A-Z]/.test(b):b.motion)?doHandleBinding(cm,b):void 0}):lookupKey(name,keymaps,function(b){return doHandleBinding(cm,b)}),handled&&(e_preventDefault(e),restartBlink(cm),ie_lt9&&(e.oldKeyCode=e.keyCode,e.keyCode=0),signalLater(cm,"keyHandled",cm,name,e)),handled}function handleCharBinding(cm,e,ch){var handled=lookupKey("'"+ch+"'",allKeyMaps(cm),function(b){return doHandleBinding(cm,b,!0)});return handled&&(e_preventDefault(e),restartBlink(cm),signalLater(cm,"keyHandled",cm,"'"+ch+"'",e)),handled}function onKeyDown(e){var cm=this;if(cm.state.focused||onFocus(cm),ie&&27==e.keyCode&&(e.returnValue=!1),!(signalDOMEvent(cm,e)||cm.options.onKeyEvent&&cm.options.onKeyEvent(cm,addStop(e)))){var code=e.keyCode;cm.doc.sel.shift=16==code||e.shiftKey;var handled=handleKeyBinding(cm,e);opera&&(lastStoppedKey=handled?code:null,!handled&&88==code&&!hasCopyEvent&&(mac?e.metaKey:e.ctrlKey)&&cm.replaceSelection(""))}}function onKeyPress(e){var cm=this;if(!(signalDOMEvent(cm,e)||cm.options.onKeyEvent&&cm.options.onKeyEvent(cm,addStop(e)))){var keyCode=e.keyCode,charCode=e.charCode;if(opera&&keyCode==lastStoppedKey)return lastStoppedKey=null,void e_preventDefault(e);if(!(opera&&(!e.which||e.which<10)||khtml)||!handleKeyBinding(cm,e)){var ch=String.fromCharCode(null==charCode?keyCode:charCode);this.options.electricChars&&this.doc.mode.electricChars&&this.options.smartIndent&&!isReadOnly(this)&&this.doc.mode.electricChars.indexOf(ch)>-1&&setTimeout(operation(cm,function(){indentLine(cm,cm.doc.sel.to.line,"smart")}),75),handleCharBinding(cm,e,ch)||(ie&&!ie_lt9&&(cm.display.inputHasSelection=null),fastPoll(cm))}}}function onFocus(cm){"nocursor"!=cm.options.readOnly&&(cm.state.focused||(signal(cm,"focus",cm),cm.state.focused=!0,-1==cm.display.wrapper.className.search(/\bCodeMirror-focused\b/)&&(cm.display.wrapper.className+=" CodeMirror-focused"),resetInput(cm,!0)),slowPoll(cm),restartBlink(cm))}function onBlur(cm){cm.state.focused&&(signal(cm,"blur",cm),cm.state.focused=!1,cm.display.wrapper.className=cm.display.wrapper.className.replace(" CodeMirror-focused","")),clearInterval(cm.display.blinker),setTimeout(function(){cm.state.focused||(cm.doc.sel.shift=!1);
},150)}function onContextMenu(cm,e){function prepareSelectAllHack(){if(null!=display.input.selectionStart){var extval=display.input.value=" "+(posEq(sel.from,sel.to)?"":display.input.value);display.prevInput=" ",display.input.selectionStart=1,display.input.selectionEnd=extval.length}}function rehide(){if(display.inputDiv.style.position="relative",display.input.style.cssText=oldCSS,ie_lt9&&(display.scrollbarV.scrollTop=display.scroller.scrollTop=scrollPos),slowPoll(cm),null!=display.input.selectionStart){(!ie||ie_lt9)&&prepareSelectAllHack(),clearTimeout(detectingSelectAll);var i=0,poll=function(){" "==display.prevInput&&0==display.input.selectionStart?operation(cm,commands.selectAll)(cm):i++<10?detectingSelectAll=setTimeout(poll,500):resetInput(cm)};detectingSelectAll=setTimeout(poll,200)}}if(!signalDOMEvent(cm,e,"contextmenu")){var display=cm.display,sel=cm.doc.sel;if(!eventInWidget(display,e)){var pos=posFromMouse(cm,e),scrollPos=display.scroller.scrollTop;if(pos&&!opera){(posEq(sel.from,sel.to)||posLess(pos,sel.from)||!posLess(pos,sel.to))&&operation(cm,setSelection)(cm.doc,pos,pos);var oldCSS=display.input.style.cssText;if(display.inputDiv.style.position="absolute",display.input.style.cssText="position: fixed; width: 30px; height: 30px; top: "+(e.clientY-5)+"px; left: "+(e.clientX-5)+"px; z-index: 1000; background: white; outline: none;border-width: 0; outline: none; overflow: hidden; opacity: .05; -ms-opacity: .05; filter: alpha(opacity=5);",focusInput(cm),resetInput(cm,!0),posEq(sel.from,sel.to)&&(display.input.value=display.prevInput=" "),ie&&!ie_lt9&&prepareSelectAllHack(),captureMiddleClick){e_stop(e);var mouseup=function(){off(window,"mouseup",mouseup),setTimeout(rehide,20)};on(window,"mouseup",mouseup)}else setTimeout(rehide,50)}}}}function clipPostChange(doc,change,pos){if(!posLess(change.from,pos))return clipPos(doc,pos);var diff=change.text.length-1-(change.to.line-change.from.line);if(pos.line>change.to.line+diff){var preLine=pos.line-diff,lastLine=doc.first+doc.size-1;return preLine>lastLine?Pos(lastLine,getLine(doc,lastLine).text.length):clipToLen(pos,getLine(doc,preLine).text.length)}if(pos.line==change.to.line+diff)return clipToLen(pos,lst(change.text).length+(1==change.text.length?change.from.ch:0)+getLine(doc,change.to.line).text.length-change.to.ch);var inside=pos.line-change.from.line;return clipToLen(pos,change.text[inside].length+(inside?0:change.from.ch))}function computeSelAfterChange(doc,change,hint){if(hint&&"object"==typeof hint)return{anchor:clipPostChange(doc,change,hint.anchor),head:clipPostChange(doc,change,hint.head)};if("start"==hint)return{anchor:change.from,head:change.from};var end=changeEnd(change);if("around"==hint)return{anchor:change.from,head:end};if("end"==hint)return{anchor:end,head:end};var adjustPos=function(pos){if(posLess(pos,change.from))return pos;if(!posLess(change.to,pos))return end;var line=pos.line+change.text.length-(change.to.line-change.from.line)-1,ch=pos.ch;return pos.line==change.to.line&&(ch+=end.ch-change.to.ch),Pos(line,ch)};return{anchor:adjustPos(doc.sel.anchor),head:adjustPos(doc.sel.head)}}function filterChange(doc,change,update){var obj={canceled:!1,from:change.from,to:change.to,text:change.text,origin:change.origin,cancel:function(){this.canceled=!0}};return update&&(obj.update=function(from,to,text,origin){from&&(this.from=clipPos(doc,from)),to&&(this.to=clipPos(doc,to)),text&&(this.text=text),void 0!==origin&&(this.origin=origin)}),signal(doc,"beforeChange",doc,obj),doc.cm&&signal(doc.cm,"beforeChange",doc.cm,obj),obj.canceled?null:{from:obj.from,to:obj.to,text:obj.text,origin:obj.origin}}function makeChange(doc,change,selUpdate,ignoreReadOnly){if(doc.cm){if(!doc.cm.curOp)return operation(doc.cm,makeChange)(doc,change,selUpdate,ignoreReadOnly);if(doc.cm.state.suppressEdits)return}if(!(hasHandler(doc,"beforeChange")||doc.cm&&hasHandler(doc.cm,"beforeChange"))||(change=filterChange(doc,change,!0))){var split=sawReadOnlySpans&&!ignoreReadOnly&&removeReadOnlyRanges(doc,change.from,change.to);if(split){for(var i=split.length-1;i>=1;--i)makeChangeNoReadonly(doc,{from:split[i].from,to:split[i].to,text:[""]});split.length&&makeChangeNoReadonly(doc,{from:split[0].from,to:split[0].to,text:change.text},selUpdate)}else makeChangeNoReadonly(doc,change,selUpdate)}}function makeChangeNoReadonly(doc,change,selUpdate){var selAfter=computeSelAfterChange(doc,change,selUpdate);addToHistory(doc,change,selAfter,doc.cm?doc.cm.curOp.id:NaN),makeChangeSingleDoc(doc,change,selAfter,stretchSpansOverChange(doc,change));var rebased=[];linkedDocs(doc,function(doc,sharedHist){sharedHist||-1!=indexOf(rebased,doc.history)||(rebaseHist(doc.history,change),rebased.push(doc.history)),makeChangeSingleDoc(doc,change,null,stretchSpansOverChange(doc,change))})}function makeChangeFromHistory(doc,type){if(!doc.cm||!doc.cm.state.suppressEdits){var hist=doc.history,event=("undo"==type?hist.done:hist.undone).pop();if(event){var anti={changes:[],anchorBefore:event.anchorAfter,headBefore:event.headAfter,anchorAfter:event.anchorBefore,headAfter:event.headBefore,generation:hist.generation};("undo"==type?hist.undone:hist.done).push(anti),hist.generation=event.generation||++hist.maxGeneration;for(var filter=hasHandler(doc,"beforeChange")||doc.cm&&hasHandler(doc.cm,"beforeChange"),i=event.changes.length-1;i>=0;--i){var change=event.changes[i];if(change.origin=type,filter&&!filterChange(doc,change,!1))return void(("undo"==type?hist.done:hist.undone).length=0);anti.changes.push(historyChangeFromChange(doc,change));var after=i?computeSelAfterChange(doc,change,null):{anchor:event.anchorBefore,head:event.headBefore};makeChangeSingleDoc(doc,change,after,mergeOldSpans(doc,change));var rebased=[];linkedDocs(doc,function(doc,sharedHist){sharedHist||-1!=indexOf(rebased,doc.history)||(rebaseHist(doc.history,change),rebased.push(doc.history)),makeChangeSingleDoc(doc,change,null,mergeOldSpans(doc,change))})}}}}function shiftDoc(doc,distance){function shiftPos(pos){return Pos(pos.line+distance,pos.ch)}doc.first+=distance,doc.cm&&regChange(doc.cm,doc.first,doc.first,distance),doc.sel.head=shiftPos(doc.sel.head),doc.sel.anchor=shiftPos(doc.sel.anchor),doc.sel.from=shiftPos(doc.sel.from),doc.sel.to=shiftPos(doc.sel.to)}function makeChangeSingleDoc(doc,change,selAfter,spans){if(doc.cm&&!doc.cm.curOp)return operation(doc.cm,makeChangeSingleDoc)(doc,change,selAfter,spans);if(change.to.line<doc.first)return void shiftDoc(doc,change.text.length-1-(change.to.line-change.from.line));if(!(change.from.line>doc.lastLine())){if(change.from.line<doc.first){var shift=change.text.length-1-(doc.first-change.from.line);shiftDoc(doc,shift),change={from:Pos(doc.first,0),to:Pos(change.to.line+shift,change.to.ch),text:[lst(change.text)],origin:change.origin}}var last=doc.lastLine();change.to.line>last&&(change={from:change.from,to:Pos(last,getLine(doc,last).text.length),text:[change.text[0]],origin:change.origin}),change.removed=getBetween(doc,change.from,change.to),selAfter||(selAfter=computeSelAfterChange(doc,change,null)),doc.cm?makeChangeSingleDocInEditor(doc.cm,change,spans,selAfter):updateDoc(doc,change,spans,selAfter)}}function makeChangeSingleDocInEditor(cm,change,spans,selAfter){var doc=cm.doc,display=cm.display,from=change.from,to=change.to,recomputeMaxLength=!1,checkWidthStart=from.line;cm.options.lineWrapping||(checkWidthStart=lineNo(visualLine(doc,getLine(doc,from.line))),doc.iter(checkWidthStart,to.line+1,function(line){return line==display.maxLine?(recomputeMaxLength=!0,!0):void 0})),posLess(doc.sel.head,change.from)||posLess(change.to,doc.sel.head)||(cm.curOp.cursorActivity=!0),updateDoc(doc,change,spans,selAfter,estimateHeight(cm)),cm.options.lineWrapping||(doc.iter(checkWidthStart,from.line+change.text.length,function(line){var len=lineLength(doc,line);len>display.maxLineLength&&(display.maxLine=line,display.maxLineLength=len,display.maxLineChanged=!0,recomputeMaxLength=!1)}),recomputeMaxLength&&(cm.curOp.updateMaxLine=!0)),doc.frontier=Math.min(doc.frontier,from.line),startWorker(cm,400);var lendiff=change.text.length-(to.line-from.line)-1;if(regChange(cm,from.line,to.line+1,lendiff),hasHandler(cm,"change")){var changeObj={from:from,to:to,text:change.text,removed:change.removed,origin:change.origin};if(cm.curOp.textChanged){for(var cur=cm.curOp.textChanged;cur.next;cur=cur.next);cur.next=changeObj}else cm.curOp.textChanged=changeObj}}function replaceRange(doc,code,from,to,origin){if(to||(to=from),posLess(to,from)){var tmp=to;to=from,from=tmp}"string"==typeof code&&(code=splitLines(code)),makeChange(doc,{from:from,to:to,text:code,origin:origin},null)}function Pos(line,ch){return this instanceof Pos?(this.line=line,void(this.ch=ch)):new Pos(line,ch)}function posEq(a,b){return a.line==b.line&&a.ch==b.ch}function posLess(a,b){return a.line<b.line||a.line==b.line&&a.ch<b.ch}function copyPos(x){return Pos(x.line,x.ch)}function clipLine(doc,n){return Math.max(doc.first,Math.min(n,doc.first+doc.size-1))}function clipPos(doc,pos){if(pos.line<doc.first)return Pos(doc.first,0);var last=doc.first+doc.size-1;return pos.line>last?Pos(last,getLine(doc,last).text.length):clipToLen(pos,getLine(doc,pos.line).text.length)}function clipToLen(pos,linelen){var ch=pos.ch;return null==ch||ch>linelen?Pos(pos.line,linelen):0>ch?Pos(pos.line,0):pos}function isLine(doc,l){return l>=doc.first&&l<doc.first+doc.size}function extendSelection(doc,pos,other,bias){if(doc.sel.shift||doc.sel.extend){var anchor=doc.sel.anchor;if(other){var posBefore=posLess(pos,anchor);posBefore!=posLess(other,anchor)?(anchor=pos,pos=other):posBefore!=posLess(pos,other)&&(pos=other)}setSelection(doc,anchor,pos,bias)}else setSelection(doc,pos,other||pos,bias);doc.cm&&(doc.cm.curOp.userSelChange=!0)}function filterSelectionChange(doc,anchor,head){var obj={anchor:anchor,head:head};return signal(doc,"beforeSelectionChange",doc,obj),doc.cm&&signal(doc.cm,"beforeSelectionChange",doc.cm,obj),obj.anchor=clipPos(doc,obj.anchor),obj.head=clipPos(doc,obj.head),obj}function setSelection(doc,anchor,head,bias,checkAtomic){if(!checkAtomic&&hasHandler(doc,"beforeSelectionChange")||doc.cm&&hasHandler(doc.cm,"beforeSelectionChange")){var filtered=filterSelectionChange(doc,anchor,head);head=filtered.head,anchor=filtered.anchor}var sel=doc.sel;if(sel.goalColumn=null,(checkAtomic||!posEq(anchor,sel.anchor))&&(anchor=skipAtomic(doc,anchor,bias,"push"!=checkAtomic)),(checkAtomic||!posEq(head,sel.head))&&(head=skipAtomic(doc,head,bias,"push"!=checkAtomic)),!posEq(sel.anchor,anchor)||!posEq(sel.head,head)){sel.anchor=anchor,sel.head=head;var inv=posLess(head,anchor);sel.from=inv?head:anchor,sel.to=inv?anchor:head,doc.cm&&(doc.cm.curOp.updateInput=doc.cm.curOp.selectionChanged=doc.cm.curOp.cursorActivity=!0),signalLater(doc,"cursorActivity",doc)}}function reCheckSelection(cm){setSelection(cm.doc,cm.doc.sel.from,cm.doc.sel.to,null,"push")}function skipAtomic(doc,pos,bias,mayClear){var flipped=!1,curPos=pos,dir=bias||1;doc.cantEdit=!1;search:for(;;){var line=getLine(doc,curPos.line);if(line.markedSpans)for(var i=0;i<line.markedSpans.length;++i){var sp=line.markedSpans[i],m=sp.marker;if((null==sp.from||(m.inclusiveLeft?sp.from<=curPos.ch:sp.from<curPos.ch))&&(null==sp.to||(m.inclusiveRight?sp.to>=curPos.ch:sp.to>curPos.ch))){if(mayClear&&(signal(m,"beforeCursorEnter"),m.explicitlyCleared)){if(line.markedSpans){--i;continue}break}if(!m.atomic)continue;var newPos=m.find()[0>dir?"from":"to"];if(posEq(newPos,curPos)&&(newPos.ch+=dir,newPos.ch<0?newPos=newPos.line>doc.first?clipPos(doc,Pos(newPos.line-1)):null:newPos.ch>line.text.length&&(newPos=newPos.line<doc.first+doc.size-1?Pos(newPos.line+1,0):null),!newPos)){if(flipped)return mayClear?(doc.cantEdit=!0,Pos(doc.first,0)):skipAtomic(doc,pos,bias,!0);flipped=!0,newPos=pos,dir=-dir}curPos=newPos;continue search}}return curPos}}function scrollCursorIntoView(cm){var coords=scrollPosIntoView(cm,cm.doc.sel.head,cm.options.cursorScrollMargin);if(cm.state.focused){var display=cm.display,box=getRect(display.sizer),doScroll=null;if(coords.top+box.top<0?doScroll=!0:coords.bottom+box.top>(window.innerHeight||document.documentElement.clientHeight)&&(doScroll=!1),null!=doScroll&&!phantom){var hidden="none"==display.cursor.style.display;hidden&&(display.cursor.style.display="",display.cursor.style.left=coords.left+"px",display.cursor.style.top=coords.top-display.viewOffset+"px"),display.cursor.scrollIntoView(doScroll),hidden&&(display.cursor.style.display="none")}}}function scrollPosIntoView(cm,pos,margin){for(null==margin&&(margin=0);;){var changed=!1,coords=cursorCoords(cm,pos),scrollPos=calculateScrollPos(cm,coords.left,coords.top-margin,coords.left,coords.bottom+margin),startTop=cm.doc.scrollTop,startLeft=cm.doc.scrollLeft;if(null!=scrollPos.scrollTop&&(setScrollTop(cm,scrollPos.scrollTop),Math.abs(cm.doc.scrollTop-startTop)>1&&(changed=!0)),null!=scrollPos.scrollLeft&&(setScrollLeft(cm,scrollPos.scrollLeft),Math.abs(cm.doc.scrollLeft-startLeft)>1&&(changed=!0)),!changed)return coords}}function scrollIntoView(cm,x1,y1,x2,y2){var scrollPos=calculateScrollPos(cm,x1,y1,x2,y2);null!=scrollPos.scrollTop&&setScrollTop(cm,scrollPos.scrollTop),null!=scrollPos.scrollLeft&&setScrollLeft(cm,scrollPos.scrollLeft)}function calculateScrollPos(cm,x1,y1,x2,y2){var display=cm.display,snapMargin=textHeight(cm.display);0>y1&&(y1=0);var screen=display.scroller.clientHeight-scrollerCutOff,screentop=display.scroller.scrollTop,result={},docBottom=cm.doc.height+paddingVert(display),atTop=snapMargin>y1,atBottom=y2>docBottom-snapMargin;if(screentop>y1)result.scrollTop=atTop?0:y1;else if(y2>screentop+screen){var newTop=Math.min(y1,(atBottom?docBottom:y2)-screen);newTop!=screentop&&(result.scrollTop=newTop)}var screenw=display.scroller.clientWidth-scrollerCutOff,screenleft=display.scroller.scrollLeft;x1+=display.gutters.offsetWidth,x2+=display.gutters.offsetWidth;var gutterw=display.gutters.offsetWidth,atLeft=gutterw+10>x1;return screenleft+gutterw>x1||atLeft?(atLeft&&(x1=0),result.scrollLeft=Math.max(0,x1-10-gutterw)):x2>screenw+screenleft-3&&(result.scrollLeft=x2+10-screenw),result}function updateScrollPos(cm,left,top){cm.curOp.updateScrollPos={scrollLeft:null==left?cm.doc.scrollLeft:left,scrollTop:null==top?cm.doc.scrollTop:top}}function addToScrollPos(cm,left,top){var pos=cm.curOp.updateScrollPos||(cm.curOp.updateScrollPos={scrollLeft:cm.doc.scrollLeft,scrollTop:cm.doc.scrollTop}),scroll=cm.display.scroller;pos.scrollTop=Math.max(0,Math.min(scroll.scrollHeight-scroll.clientHeight,pos.scrollTop+top)),pos.scrollLeft=Math.max(0,Math.min(scroll.scrollWidth-scroll.clientWidth,pos.scrollLeft+left))}function indentLine(cm,n,how,aggressive){var doc=cm.doc;if(null==how&&(how="add"),"smart"==how)if(cm.doc.mode.indent)var state=getStateBefore(cm,n);else how="prev";var indentation,tabSize=cm.options.tabSize,line=getLine(doc,n),curSpace=countColumn(line.text,null,tabSize),curSpaceString=line.text.match(/^\s*/)[0];if("smart"==how&&(indentation=cm.doc.mode.indent(state,line.text.slice(curSpaceString.length),line.text),indentation==Pass)){if(!aggressive)return;how="prev"}"prev"==how?indentation=n>doc.first?countColumn(getLine(doc,n-1).text,null,tabSize):0:"add"==how?indentation=curSpace+cm.options.indentUnit:"subtract"==how?indentation=curSpace-cm.options.indentUnit:"number"==typeof how&&(indentation=curSpace+how),indentation=Math.max(0,indentation);var indentString="",pos=0;if(cm.options.indentWithTabs)for(var i=Math.floor(indentation/tabSize);i;--i)pos+=tabSize,indentString+="	";indentation>pos&&(indentString+=spaceStr(indentation-pos)),indentString!=curSpaceString&&replaceRange(cm.doc,indentString,Pos(n,0),Pos(n,curSpaceString.length),"+input"),line.stateAfter=null}function changeLine(cm,handle,op){var no=handle,line=handle,doc=cm.doc;return"number"==typeof handle?line=getLine(doc,clipLine(doc,handle)):no=lineNo(handle),null==no?null:op(line,no)?(regChange(cm,no,no+1),line):null}function findPosH(doc,pos,dir,unit,visually){function findNextLine(){var l=line+dir;return l<doc.first||l>=doc.first+doc.size?possible=!1:(line=l,lineObj=getLine(doc,l))}function moveOnce(boundToLine){var next=(visually?moveVisually:moveLogically)(lineObj,ch,dir,!0);if(null==next){if(boundToLine||!findNextLine())return possible=!1;ch=visually?(0>dir?lineRight:lineLeft)(lineObj):0>dir?lineObj.text.length:0}else ch=next;return!0}var line=pos.line,ch=pos.ch,origDir=dir,lineObj=getLine(doc,line),possible=!0;if("char"==unit)moveOnce();else if("column"==unit)moveOnce(!0);else if("word"==unit||"group"==unit)for(var sawType=null,group="group"==unit,first=!0;!(0>dir)||moveOnce(!first);first=!1){var cur=lineObj.text.charAt(ch)||"\n",type=isWordChar(cur)?"w":group?/\s/.test(cur)?null:"p":null;if(sawType&&sawType!=type){0>dir&&(dir=1,moveOnce());break}if(type&&(sawType=type),dir>0&&!moveOnce(!first))break}var result=skipAtomic(doc,Pos(line,ch),origDir,!0);return possible||(result.hitSide=!0),result}function findPosV(cm,pos,dir,unit){var y,doc=cm.doc,x=pos.left;if("page"==unit){var pageSize=Math.min(cm.display.wrapper.clientHeight,window.innerHeight||document.documentElement.clientHeight);y=pos.top+dir*(pageSize-(0>dir?1.5:.5)*textHeight(cm.display))}else"line"==unit&&(y=dir>0?pos.bottom+3:pos.top-3);for(;;){var target=coordsChar(cm,x,y);if(!target.outside)break;if(0>dir?0>=y:y>=doc.height){target.hitSide=!0;break}y+=5*dir}return target}function findWordAt(line,pos){var start=pos.ch,end=pos.ch;if(line){(pos.xRel<0||end==line.length)&&start?--start:++end;for(var startChar=line.charAt(start),check=isWordChar(startChar)?isWordChar:/\s/.test(startChar)?function(ch){return/\s/.test(ch)}:function(ch){return!/\s/.test(ch)&&!isWordChar(ch)};start>0&&check(line.charAt(start-1));)--start;for(;end<line.length&&check(line.charAt(end));)++end}return{from:Pos(pos.line,start),to:Pos(pos.line,end)}}function selectLine(cm,line){extendSelection(cm.doc,Pos(line,0),clipPos(cm.doc,Pos(line+1,0)))}function option(name,deflt,handle,notOnInit){CodeMirror.defaults[name]=deflt,handle&&(optionHandlers[name]=notOnInit?function(cm,val,old){old!=Init&&handle(cm,val,old)}:handle)}function copyState(mode,state){if(state===!0)return state;if(mode.copyState)return mode.copyState(state);var nstate={};for(var n in state){var val=state[n];val instanceof Array&&(val=val.concat([])),nstate[n]=val}return nstate}function startState(mode,a1,a2){return mode.startState?mode.startState(a1,a2):!0}function getKeyMap(val){return"string"==typeof val?keyMap[val]:val}function lookupKey(name,maps,handle){function lookup(map){map=getKeyMap(map);var found=map[name];if(found===!1)return"stop";if(null!=found&&handle(found))return!0;if(map.nofallthrough)return"stop";var fallthrough=map.fallthrough;if(null==fallthrough)return!1;if("[object Array]"!=Object.prototype.toString.call(fallthrough))return lookup(fallthrough);for(var i=0,e=fallthrough.length;e>i;++i){var done=lookup(fallthrough[i]);if(done)return done}return!1}for(var i=0;i<maps.length;++i){var done=lookup(maps[i]);if(done)return"stop"!=done}}function isModifierKey(event){var name=keyNames[event.keyCode];return"Ctrl"==name||"Alt"==name||"Shift"==name||"Mod"==name}function keyName(event,noShift){if(opera&&34==event.keyCode&&event["char"])return!1;var name=keyNames[event.keyCode];return null==name||event.altGraphKey?!1:(event.altKey&&(name="Alt-"+name),(flipCtrlCmd?event.metaKey:event.ctrlKey)&&(name="Ctrl-"+name),(flipCtrlCmd?event.ctrlKey:event.metaKey)&&(name="Cmd-"+name),!noShift&&event.shiftKey&&(name="Shift-"+name),name)}function StringStream(string,tabSize){this.pos=this.start=0,this.string=string,this.tabSize=tabSize||8,this.lastColumnPos=this.lastColumnValue=0}function TextMarker(doc,type){this.lines=[],this.type=type,this.doc=doc}function markText(doc,from,to,options,type){if(options&&options.shared)return markTextShared(doc,from,to,options,type);if(doc.cm&&!doc.cm.curOp)return operation(doc.cm,markText)(doc,from,to,options,type);var marker=new TextMarker(doc,type);if("range"==type&&!posLess(from,to))return marker;options&&copyObj(options,marker),marker.replacedWith&&(marker.collapsed=!0,marker.replacedWith=elt("span",[marker.replacedWith],"CodeMirror-widget"),options.handleMouseEvents||(marker.replacedWith.ignoreEvents=!0)),marker.collapsed&&(sawCollapsedSpans=!0),marker.addToHistory&&addToHistory(doc,{from:from,to:to,origin:"markText"},{head:doc.sel.head,anchor:doc.sel.anchor},NaN);var collapsedAtStart,collapsedAtEnd,updateMaxLine,curLine=from.line,size=0,cm=doc.cm;if(doc.iter(curLine,to.line+1,function(line){cm&&marker.collapsed&&!cm.options.lineWrapping&&visualLine(doc,line)==cm.display.maxLine&&(updateMaxLine=!0);var span={from:null,to:null,marker:marker};size+=line.text.length,curLine==from.line&&(span.from=from.ch,size-=from.ch),curLine==to.line&&(span.to=to.ch,size-=line.text.length-to.ch),marker.collapsed&&(curLine==to.line&&(collapsedAtEnd=collapsedSpanAt(line,to.ch)),curLine==from.line?collapsedAtStart=collapsedSpanAt(line,from.ch):updateLineHeight(line,0)),addMarkedSpan(line,span),++curLine}),marker.collapsed&&doc.iter(from.line,to.line+1,function(line){lineIsHidden(doc,line)&&updateLineHeight(line,0)}),marker.clearOnEnter&&on(marker,"beforeCursorEnter",function(){marker.clear()}),marker.readOnly&&(sawReadOnlySpans=!0,(doc.history.done.length||doc.history.undone.length)&&doc.clearHistory()),marker.collapsed){if(collapsedAtStart!=collapsedAtEnd)throw new Error("Inserting collapsed marker overlapping an existing one");marker.size=size,marker.atomic=!0}return cm&&(updateMaxLine&&(cm.curOp.updateMaxLine=!0),(marker.className||marker.title||marker.startStyle||marker.endStyle||marker.collapsed)&&regChange(cm,from.line,to.line+1),marker.atomic&&reCheckSelection(cm)),marker}function SharedTextMarker(markers,primary){this.markers=markers,this.primary=primary;for(var i=0,me=this;i<markers.length;++i)markers[i].parent=this,on(markers[i],"clear",function(){me.clear()})}function markTextShared(doc,from,to,options,type){options=copyObj(options),options.shared=!1;var markers=[markText(doc,from,to,options,type)],primary=markers[0],widget=options.replacedWith;return linkedDocs(doc,function(doc){widget&&(options.replacedWith=widget.cloneNode(!0)),markers.push(markText(doc,clipPos(doc,from),clipPos(doc,to),options,type));for(var i=0;i<doc.linked.length;++i)if(doc.linked[i].isParent)return;primary=lst(markers)}),new SharedTextMarker(markers,primary)}function getMarkedSpanFor(spans,marker){if(spans)for(var i=0;i<spans.length;++i){var span=spans[i];if(span.marker==marker)return span}}function removeMarkedSpan(spans,span){for(var r,i=0;i<spans.length;++i)spans[i]!=span&&(r||(r=[])).push(spans[i]);return r}function addMarkedSpan(line,span){line.markedSpans=line.markedSpans?line.markedSpans.concat([span]):[span],span.marker.attachLine(line)}function markedSpansBefore(old,startCh,isInsert){if(old)for(var nw,i=0;i<old.length;++i){var span=old[i],marker=span.marker,startsBefore=null==span.from||(marker.inclusiveLeft?span.from<=startCh:span.from<startCh);if(startsBefore||"bookmark"==marker.type&&span.from==startCh&&(!isInsert||!span.marker.insertLeft)){var endsAfter=null==span.to||(marker.inclusiveRight?span.to>=startCh:span.to>startCh);(nw||(nw=[])).push({from:span.from,to:endsAfter?null:span.to,marker:marker})}}return nw}function markedSpansAfter(old,endCh,isInsert){if(old)for(var nw,i=0;i<old.length;++i){var span=old[i],marker=span.marker,endsAfter=null==span.to||(marker.inclusiveRight?span.to>=endCh:span.to>endCh);if(endsAfter||"bookmark"==marker.type&&span.from==endCh&&(!isInsert||span.marker.insertLeft)){var startsBefore=null==span.from||(marker.inclusiveLeft?span.from<=endCh:span.from<endCh);(nw||(nw=[])).push({from:startsBefore?null:span.from-endCh,to:null==span.to?null:span.to-endCh,marker:marker})}}return nw}function stretchSpansOverChange(doc,change){var oldFirst=isLine(doc,change.from.line)&&getLine(doc,change.from.line).markedSpans,oldLast=isLine(doc,change.to.line)&&getLine(doc,change.to.line).markedSpans;if(!oldFirst&&!oldLast)return null;var startCh=change.from.ch,endCh=change.to.ch,isInsert=posEq(change.from,change.to),first=markedSpansBefore(oldFirst,startCh,isInsert),last=markedSpansAfter(oldLast,endCh,isInsert),sameLine=1==change.text.length,offset=lst(change.text).length+(sameLine?startCh:0);if(first)for(var i=0;i<first.length;++i){var span=first[i];if(null==span.to){var found=getMarkedSpanFor(last,span.marker);found?sameLine&&(span.to=null==found.to?null:found.to+offset):span.to=startCh}}if(last)for(var i=0;i<last.length;++i){var span=last[i];if(null!=span.to&&(span.to+=offset),null==span.from){var found=getMarkedSpanFor(first,span.marker);found||(span.from=offset,sameLine&&(first||(first=[])).push(span))}else span.from+=offset,sameLine&&(first||(first=[])).push(span)}if(sameLine&&first){for(var i=0;i<first.length;++i)null!=first[i].from&&first[i].from==first[i].to&&"bookmark"!=first[i].marker.type&&first.splice(i--,1);first.length||(first=null)}var newMarkers=[first];if(!sameLine){var gapMarkers,gap=change.text.length-2;if(gap>0&&first)for(var i=0;i<first.length;++i)null==first[i].to&&(gapMarkers||(gapMarkers=[])).push({from:null,to:null,marker:first[i].marker});for(var i=0;gap>i;++i)newMarkers.push(gapMarkers);newMarkers.push(last)}return newMarkers}function mergeOldSpans(doc,change){var old=getOldSpans(doc,change),stretched=stretchSpansOverChange(doc,change);if(!old)return stretched;if(!stretched)return old;for(var i=0;i<old.length;++i){var oldCur=old[i],stretchCur=stretched[i];if(oldCur&&stretchCur)spans:for(var j=0;j<stretchCur.length;++j){for(var span=stretchCur[j],k=0;k<oldCur.length;++k)if(oldCur[k].marker==span.marker)continue spans;oldCur.push(span)}else stretchCur&&(old[i]=stretchCur)}return old}function removeReadOnlyRanges(doc,from,to){var markers=null;if(doc.iter(from.line,to.line+1,function(line){if(line.markedSpans)for(var i=0;i<line.markedSpans.length;++i){var mark=line.markedSpans[i].marker;!mark.readOnly||markers&&-1!=indexOf(markers,mark)||(markers||(markers=[])).push(mark)}}),!markers)return null;for(var parts=[{from:from,to:to}],i=0;i<markers.length;++i)for(var mk=markers[i],m=mk.find(),j=0;j<parts.length;++j){var p=parts[j];if(!posLess(p.to,m.from)&&!posLess(m.to,p.from)){var newParts=[j,1];(posLess(p.from,m.from)||!mk.inclusiveLeft&&posEq(p.from,m.from))&&newParts.push({from:p.from,to:m.from}),(posLess(m.to,p.to)||!mk.inclusiveRight&&posEq(p.to,m.to))&&newParts.push({from:m.to,to:p.to}),parts.splice.apply(parts,newParts),j+=newParts.length-1}}return parts}function collapsedSpanAt(line,ch){var found,sps=sawCollapsedSpans&&line.markedSpans;if(sps)for(var sp,i=0;i<sps.length;++i)sp=sps[i],sp.marker.collapsed&&(null==sp.from||sp.from<ch)&&(null==sp.to||sp.to>ch)&&(!found||found.width<sp.marker.width)&&(found=sp.marker);return found}function collapsedSpanAtStart(line){return collapsedSpanAt(line,-1)}function collapsedSpanAtEnd(line){return collapsedSpanAt(line,line.text.length+1)}function visualLine(doc,line){for(var merged;merged=collapsedSpanAtStart(line);)line=getLine(doc,merged.find().from.line);return line}function lineIsHidden(doc,line){var sps=sawCollapsedSpans&&line.markedSpans;if(sps)for(var sp,i=0;i<sps.length;++i)if(sp=sps[i],sp.marker.collapsed){if(null==sp.from)return!0;if(!sp.marker.replacedWith&&0==sp.from&&sp.marker.inclusiveLeft&&lineIsHiddenInner(doc,line,sp))return!0}}function lineIsHiddenInner(doc,line,span){if(null==span.to){var end=span.marker.find().to,endLine=getLine(doc,end.line);return lineIsHiddenInner(doc,endLine,getMarkedSpanFor(endLine.markedSpans,span.marker))}if(span.marker.inclusiveRight&&span.to==line.text.length)return!0;for(var sp,i=0;i<line.markedSpans.length;++i)if(sp=line.markedSpans[i],sp.marker.collapsed&&!sp.marker.replacedWith&&sp.from==span.to&&(sp.marker.inclusiveLeft||span.marker.inclusiveRight)&&lineIsHiddenInner(doc,line,sp))return!0}function detachMarkedSpans(line){var spans=line.markedSpans;if(spans){for(var i=0;i<spans.length;++i)spans[i].marker.detachLine(line);line.markedSpans=null}}function attachMarkedSpans(line,spans){if(spans){for(var i=0;i<spans.length;++i)spans[i].marker.attachLine(line);line.markedSpans=spans}}function widgetOperation(f){return function(){var withOp=!this.cm.curOp;withOp&&startOperation(this.cm);try{var result=f.apply(this,arguments)}finally{withOp&&endOperation(this.cm)}return result}}function widgetHeight(widget){return null!=widget.height?widget.height:(widget.node.parentNode&&1==widget.node.parentNode.nodeType||removeChildrenAndAdd(widget.cm.display.measure,elt("div",[widget.node],null,"position: relative")),widget.height=widget.node.offsetHeight)}function addLineWidget(cm,handle,node,options){var widget=new LineWidget(cm,node,options);return widget.noHScroll&&(cm.display.alignWidgets=!0),changeLine(cm,handle,function(line){var widgets=line.widgets||(line.widgets=[]);if(null==widget.insertAt?widgets.push(widget):widgets.splice(Math.min(widgets.length-1,Math.max(0,widget.insertAt)),0,widget),widget.line=line,!lineIsHidden(cm.doc,line)||widget.showIfHidden){var aboveVisible=heightAtLine(cm,line)<cm.doc.scrollTop;updateLineHeight(line,line.height+widgetHeight(widget)),aboveVisible&&addToScrollPos(cm,0,widget.height)}return!0}),widget}function updateLine(line,text,markedSpans,estimateHeight){line.text=text,line.stateAfter&&(line.stateAfter=null),line.styles&&(line.styles=null),null!=line.order&&(line.order=null),detachMarkedSpans(line),attachMarkedSpans(line,markedSpans);var estHeight=estimateHeight?estimateHeight(line):1;estHeight!=line.height&&updateLineHeight(line,estHeight)}function cleanUpLine(line){line.parent=null,detachMarkedSpans(line)}function runMode(cm,text,mode,state,f){var flattenSpans=mode.flattenSpans;null==flattenSpans&&(flattenSpans=cm.options.flattenSpans);var style,curStart=0,curStyle=null,stream=new StringStream(text,cm.options.tabSize);for(""==text&&mode.blankLine&&mode.blankLine(state);!stream.eol();)stream.pos>cm.options.maxHighlightLength?(flattenSpans=!1,stream.pos=Math.min(text.length,stream.start+5e4),style=null):style=mode.token(stream,state),flattenSpans&&curStyle==style||(curStart<stream.start&&f(stream.start,curStyle),curStart=stream.start,curStyle=style),stream.start=stream.pos;curStart<stream.pos&&f(stream.pos,curStyle)}function highlightLine(cm,line,state){var st=[cm.state.modeGen];runMode(cm,line.text,cm.doc.mode,state,function(end,style){st.push(end,style)});for(var o=0;o<cm.state.overlays.length;++o){var overlay=cm.state.overlays[o],i=1,at=0;runMode(cm,line.text,overlay.mode,!0,function(end,style){for(var start=i;end>at;){var i_end=st[i];i_end>end&&st.splice(i,1,end,st[i+1],i_end),i+=2,at=Math.min(end,i_end)}if(style)if(overlay.opaque)st.splice(start,i-start,end,style),i=start+2;else for(;i>start;start+=2){var cur=st[start+1];st[start+1]=cur?cur+" "+style:style}})}return st}function getLineStyles(cm,line){return line.styles&&line.styles[0]==cm.state.modeGen||(line.styles=highlightLine(cm,line,line.stateAfter=getStateBefore(cm,lineNo(line)))),line.styles}function processLine(cm,line,state){var mode=cm.doc.mode,stream=new StringStream(line.text,cm.options.tabSize);for(""==line.text&&mode.blankLine&&mode.blankLine(state);!stream.eol()&&stream.pos<=cm.options.maxHighlightLength;)mode.token(stream,state),stream.start=stream.pos}function styleToClass(style){return style?styleToClassCache[style]||(styleToClassCache[style]="cm-"+style.replace(/ +/g," cm-")):null}function lineContent(cm,realLine,measure,copyWidgets){for(var merged,line=realLine,empty=!0;merged=collapsedSpanAtStart(line);)line=getLine(cm.doc,merged.find().from.line);var builder={pre:elt("pre"),col:0,pos:0,measure:null,measuredSomething:!1,cm:cm,copyWidgets:copyWidgets};line.textClass&&(builder.pre.className=line.textClass);do{line.text&&(empty=!1),builder.measure=line==realLine&&measure,builder.pos=0,builder.addToken=builder.measure?buildTokenMeasure:buildToken,(ie||webkit)&&cm.getOption("lineWrapping")&&(builder.addToken=buildTokenSplitSpaces(builder.addToken));var next=insertLineContent(line,builder,getLineStyles(cm,line));
measure&&line==realLine&&!builder.measuredSomething&&(measure[0]=builder.pre.appendChild(zeroWidthElement(cm.display.measure)),builder.measuredSomething=!0),next&&(line=getLine(cm.doc,next.to.line))}while(next);!measure||builder.measuredSomething||measure[0]||(measure[0]=builder.pre.appendChild(empty?elt("span"," "):zeroWidthElement(cm.display.measure))),builder.pre.firstChild||lineIsHidden(cm.doc,realLine)||builder.pre.appendChild(document.createTextNode(" "));var order;if(measure&&ie&&(order=getOrder(line))){var l=order.length-1;order[l].from==order[l].to&&--l;var last=order[l],prev=order[l-1];if(last.from+1==last.to&&prev&&last.level<prev.level){var span=measure[builder.pos-1];span&&span.parentNode.insertBefore(span.measureRight=zeroWidthElement(cm.display.measure),span.nextSibling)}}return signal(cm,"renderLine",cm,realLine,builder.pre),builder.pre}function buildToken(builder,text,style,startStyle,endStyle,title){if(text){if(tokenSpecialChars.test(text))for(var content=document.createDocumentFragment(),pos=0;;){tokenSpecialChars.lastIndex=pos;var m=tokenSpecialChars.exec(text),skipped=m?m.index-pos:text.length-pos;if(skipped&&(content.appendChild(document.createTextNode(text.slice(pos,pos+skipped))),builder.col+=skipped),!m)break;if(pos+=skipped+1,"	"==m[0]){var tabSize=builder.cm.options.tabSize,tabWidth=tabSize-builder.col%tabSize;content.appendChild(elt("span",spaceStr(tabWidth),"cm-tab")),builder.col+=tabWidth}else{var token=elt("span","•","cm-invalidchar");token.title="\\u"+m[0].charCodeAt(0).toString(16),content.appendChild(token),builder.col+=1}}else{builder.col+=text.length;var content=document.createTextNode(text)}if(style||startStyle||endStyle||builder.measure){var fullStyle=style||"";startStyle&&(fullStyle+=startStyle),endStyle&&(fullStyle+=endStyle);var token=elt("span",[content],fullStyle);return title&&(token.title=title),builder.pre.appendChild(token)}builder.pre.appendChild(content)}}function buildTokenMeasure(builder,text,style,startStyle,endStyle){for(var wrapping=builder.cm.options.lineWrapping,i=0;i<text.length;++i){var ch=text.charAt(i),start=0==i;ch>="�"&&"�">ch&&i<text.length-1?(ch=text.slice(i,i+2),++i):i&&wrapping&&spanAffectsWrapping(text,i)&&builder.pre.appendChild(elt("wbr"));var old=builder.measure[builder.pos],span=builder.measure[builder.pos]=buildToken(builder,ch,style,start&&startStyle,i==text.length-1&&endStyle);old&&(span.leftSide=old.leftSide||old),ie&&wrapping&&" "==ch&&i&&!/\s/.test(text.charAt(i-1))&&i<text.length-1&&!/\s/.test(text.charAt(i+1))&&(span.style.whiteSpace="normal"),builder.pos+=ch.length}text.length&&(builder.measuredSomething=!0)}function buildTokenSplitSpaces(inner){function split(old){for(var out=" ",i=0;i<old.length-2;++i)out+=i%2?" ":" ";return out+=" "}return function(builder,text,style,startStyle,endStyle,title){return inner(builder,text.replace(/ {3,}/,split),style,startStyle,endStyle,title)}}function buildCollapsedSpan(builder,size,marker,ignoreWidget){var widget=!ignoreWidget&&marker.replacedWith;if(widget&&(builder.copyWidgets&&(widget=widget.cloneNode(!0)),builder.pre.appendChild(widget),builder.measure)){if(size)builder.measure[builder.pos]=widget;else{var elt=builder.measure[builder.pos]=zeroWidthElement(builder.cm.display.measure);"bookmark"!=marker.type||marker.insertLeft?builder.pre.insertBefore(elt,widget):builder.pre.appendChild(elt)}builder.measuredSomething=!0}builder.pos+=size}function insertLineContent(line,builder,styles){var spans=line.markedSpans,allText=line.text,at=0;if(spans)for(var style,spanStyle,spanEndStyle,spanStartStyle,title,collapsed,len=allText.length,pos=0,i=1,text="",nextChange=0;;){if(nextChange==pos){spanStyle=spanEndStyle=spanStartStyle=title="",collapsed=null,nextChange=1/0;for(var foundBookmark=null,j=0;j<spans.length;++j){var sp=spans[j],m=sp.marker;sp.from<=pos&&(null==sp.to||sp.to>pos)?(null!=sp.to&&nextChange>sp.to&&(nextChange=sp.to,spanEndStyle=""),m.className&&(spanStyle+=" "+m.className),m.startStyle&&sp.from==pos&&(spanStartStyle+=" "+m.startStyle),m.endStyle&&sp.to==nextChange&&(spanEndStyle+=" "+m.endStyle),m.title&&!title&&(title=m.title),m.collapsed&&(!collapsed||collapsed.marker.size<m.size)&&(collapsed=sp)):sp.from>pos&&nextChange>sp.from&&(nextChange=sp.from),"bookmark"==m.type&&sp.from==pos&&m.replacedWith&&(foundBookmark=m)}if(collapsed&&(collapsed.from||0)==pos&&(buildCollapsedSpan(builder,(null==collapsed.to?len:collapsed.to)-pos,collapsed.marker,null==collapsed.from),null==collapsed.to))return collapsed.marker.find();foundBookmark&&!collapsed&&buildCollapsedSpan(builder,0,foundBookmark)}if(pos>=len)break;for(var upto=Math.min(len,nextChange);;){if(text){var end=pos+text.length;if(!collapsed){var tokenText=end>upto?text.slice(0,upto-pos):text;builder.addToken(builder,tokenText,style?style+spanStyle:spanStyle,spanStartStyle,pos+tokenText.length==nextChange?spanEndStyle:"",title)}if(end>=upto){text=text.slice(upto-pos),pos=upto;break}pos=end,spanStartStyle=""}text=allText.slice(at,at=styles[i++]),style=styleToClass(styles[i++])}}else for(var i=1;i<styles.length;i+=2)builder.addToken(builder,allText.slice(at,at=styles[i]),styleToClass(styles[i+1]))}function updateDoc(doc,change,markedSpans,selAfter,estimateHeight){function spansFor(n){return markedSpans?markedSpans[n]:null}function update(line,text,spans){updateLine(line,text,spans,estimateHeight),signalLater(line,"change",line,change)}var from=change.from,to=change.to,text=change.text,firstLine=getLine(doc,from.line),lastLine=getLine(doc,to.line),lastText=lst(text),lastSpans=spansFor(text.length-1),nlines=to.line-from.line;if(0==from.ch&&0==to.ch&&""==lastText){for(var i=0,e=text.length-1,added=[];e>i;++i)added.push(new Line(text[i],spansFor(i),estimateHeight));update(lastLine,lastLine.text,lastSpans),nlines&&doc.remove(from.line,nlines),added.length&&doc.insert(from.line,added)}else if(firstLine==lastLine)if(1==text.length)update(firstLine,firstLine.text.slice(0,from.ch)+lastText+firstLine.text.slice(to.ch),lastSpans);else{for(var added=[],i=1,e=text.length-1;e>i;++i)added.push(new Line(text[i],spansFor(i),estimateHeight));added.push(new Line(lastText+firstLine.text.slice(to.ch),lastSpans,estimateHeight)),update(firstLine,firstLine.text.slice(0,from.ch)+text[0],spansFor(0)),doc.insert(from.line+1,added)}else if(1==text.length)update(firstLine,firstLine.text.slice(0,from.ch)+text[0]+lastLine.text.slice(to.ch),spansFor(0)),doc.remove(from.line+1,nlines);else{update(firstLine,firstLine.text.slice(0,from.ch)+text[0],spansFor(0)),update(lastLine,lastText+lastLine.text.slice(to.ch),lastSpans);for(var i=1,e=text.length-1,added=[];e>i;++i)added.push(new Line(text[i],spansFor(i),estimateHeight));nlines>1&&doc.remove(from.line+1,nlines-1),doc.insert(from.line+1,added)}signalLater(doc,"change",doc,change),setSelection(doc,selAfter.anchor,selAfter.head,null,!0)}function LeafChunk(lines){this.lines=lines,this.parent=null;for(var i=0,e=lines.length,height=0;e>i;++i)lines[i].parent=this,height+=lines[i].height;this.height=height}function BranchChunk(children){this.children=children;for(var size=0,height=0,i=0,e=children.length;e>i;++i){var ch=children[i];size+=ch.chunkSize(),height+=ch.height,ch.parent=this}this.size=size,this.height=height,this.parent=null}function linkedDocs(doc,f,sharedHistOnly){function propagate(doc,skip,sharedHist){if(doc.linked)for(var i=0;i<doc.linked.length;++i){var rel=doc.linked[i];if(rel.doc!=skip){var shared=sharedHist&&rel.sharedHist;(!sharedHistOnly||shared)&&(f(rel.doc,shared),propagate(rel.doc,doc,shared))}}}propagate(doc,null,!0)}function attachDoc(cm,doc){if(doc.cm)throw new Error("This document is already in use.");cm.doc=doc,doc.cm=cm,estimateLineHeights(cm),loadMode(cm),cm.options.lineWrapping||computeMaxLength(cm),cm.options.mode=doc.modeOption,regChange(cm)}function getLine(chunk,n){for(n-=chunk.first;!chunk.lines;)for(var i=0;;++i){var child=chunk.children[i],sz=child.chunkSize();if(sz>n){chunk=child;break}n-=sz}return chunk.lines[n]}function getBetween(doc,start,end){var out=[],n=start.line;return doc.iter(start.line,end.line+1,function(line){var text=line.text;n==end.line&&(text=text.slice(0,end.ch)),n==start.line&&(text=text.slice(start.ch)),out.push(text),++n}),out}function getLines(doc,from,to){var out=[];return doc.iter(from,to,function(line){out.push(line.text)}),out}function updateLineHeight(line,height){for(var diff=height-line.height,n=line;n;n=n.parent)n.height+=diff}function lineNo(line){if(null==line.parent)return null;for(var cur=line.parent,no=indexOf(cur.lines,line),chunk=cur.parent;chunk;cur=chunk,chunk=chunk.parent)for(var i=0;chunk.children[i]!=cur;++i)no+=chunk.children[i].chunkSize();return no+cur.first}function lineAtHeight(chunk,h){var n=chunk.first;outer:do{for(var i=0,e=chunk.children.length;e>i;++i){var child=chunk.children[i],ch=child.height;if(ch>h){chunk=child;continue outer}h-=ch,n+=child.chunkSize()}return n}while(!chunk.lines);for(var i=0,e=chunk.lines.length;e>i;++i){var line=chunk.lines[i],lh=line.height;if(lh>h)break;h-=lh}return n+i}function heightAtLine(cm,lineObj){lineObj=visualLine(cm.doc,lineObj);for(var h=0,chunk=lineObj.parent,i=0;i<chunk.lines.length;++i){var line=chunk.lines[i];if(line==lineObj)break;h+=line.height}for(var p=chunk.parent;p;chunk=p,p=chunk.parent)for(var i=0;i<p.children.length;++i){var cur=p.children[i];if(cur==chunk)break;h+=cur.height}return h}function getOrder(line){var order=line.order;return null==order&&(order=line.order=bidiOrdering(line.text)),order}function makeHistory(startGen){return{done:[],undone:[],undoDepth:1/0,lastTime:0,lastOp:null,lastOrigin:null,generation:startGen||1,maxGeneration:startGen||1}}function attachLocalSpans(doc,change,from,to){var existing=change["spans_"+doc.id],n=0;doc.iter(Math.max(doc.first,from),Math.min(doc.first+doc.size,to),function(line){line.markedSpans&&((existing||(existing=change["spans_"+doc.id]={}))[n]=line.markedSpans),++n})}function historyChangeFromChange(doc,change){var from={line:change.from.line,ch:change.from.ch},histChange={from:from,to:changeEnd(change),text:getBetween(doc,change.from,change.to)};return attachLocalSpans(doc,histChange,change.from.line,change.to.line+1),linkedDocs(doc,function(doc){attachLocalSpans(doc,histChange,change.from.line,change.to.line+1)},!0),histChange}function addToHistory(doc,change,selAfter,opId){var hist=doc.history;hist.undone.length=0;var time=+new Date,cur=lst(hist.done);if(cur&&(hist.lastOp==opId||hist.lastOrigin==change.origin&&change.origin&&("+"==change.origin.charAt(0)&&doc.cm&&hist.lastTime>time-doc.cm.options.historyEventDelay||"*"==change.origin.charAt(0)))){var last=lst(cur.changes);posEq(change.from,change.to)&&posEq(change.from,last.to)?last.to=changeEnd(change):cur.changes.push(historyChangeFromChange(doc,change)),cur.anchorAfter=selAfter.anchor,cur.headAfter=selAfter.head}else for(cur={changes:[historyChangeFromChange(doc,change)],generation:hist.generation,anchorBefore:doc.sel.anchor,headBefore:doc.sel.head,anchorAfter:selAfter.anchor,headAfter:selAfter.head},hist.done.push(cur),hist.generation=++hist.maxGeneration;hist.done.length>hist.undoDepth;)hist.done.shift();hist.lastTime=time,hist.lastOp=opId,hist.lastOrigin=change.origin}function removeClearedSpans(spans){if(!spans)return null;for(var out,i=0;i<spans.length;++i)spans[i].marker.explicitlyCleared?out||(out=spans.slice(0,i)):out&&out.push(spans[i]);return out?out.length?out:null:spans}function getOldSpans(doc,change){var found=change["spans_"+doc.id];if(!found)return null;for(var i=0,nw=[];i<change.text.length;++i)nw.push(removeClearedSpans(found[i]));return nw}function copyHistoryArray(events,newGroup){for(var i=0,copy=[];i<events.length;++i){var event=events[i],changes=event.changes,newChanges=[];copy.push({changes:newChanges,anchorBefore:event.anchorBefore,headBefore:event.headBefore,anchorAfter:event.anchorAfter,headAfter:event.headAfter});for(var j=0;j<changes.length;++j){var m,change=changes[j];if(newChanges.push({from:change.from,to:change.to,text:change.text}),newGroup)for(var prop in change)(m=prop.match(/^spans_(\d+)$/))&&indexOf(newGroup,Number(m[1]))>-1&&(lst(newChanges)[prop]=change[prop],delete change[prop])}}return copy}function rebaseHistSel(pos,from,to,diff){to<pos.line?pos.line+=diff:from<pos.line&&(pos.line=from,pos.ch=0)}function rebaseHistArray(array,from,to,diff){for(var i=0;i<array.length;++i){for(var sub=array[i],ok=!0,j=0;j<sub.changes.length;++j){var cur=sub.changes[j];if(sub.copied||(cur.from=copyPos(cur.from),cur.to=copyPos(cur.to)),to<cur.from.line)cur.from.line+=diff,cur.to.line+=diff;else if(from<=cur.to.line){ok=!1;break}}sub.copied||(sub.anchorBefore=copyPos(sub.anchorBefore),sub.headBefore=copyPos(sub.headBefore),sub.anchorAfter=copyPos(sub.anchorAfter),sub.readAfter=copyPos(sub.headAfter),sub.copied=!0),ok?(rebaseHistSel(sub.anchorBefore),rebaseHistSel(sub.headBefore),rebaseHistSel(sub.anchorAfter),rebaseHistSel(sub.headAfter)):(array.splice(0,i+1),i=0)}}function rebaseHist(hist,change){var from=change.from.line,to=change.to.line,diff=change.text.length-(to-from)-1;rebaseHistArray(hist.done,from,to,diff),rebaseHistArray(hist.undone,from,to,diff)}function stopMethod(){e_stop(this)}function addStop(event){return event.stop||(event.stop=stopMethod),event}function e_preventDefault(e){e.preventDefault?e.preventDefault():e.returnValue=!1}function e_stopPropagation(e){e.stopPropagation?e.stopPropagation():e.cancelBubble=!0}function e_defaultPrevented(e){return null!=e.defaultPrevented?e.defaultPrevented:0==e.returnValue}function e_stop(e){e_preventDefault(e),e_stopPropagation(e)}function e_target(e){return e.target||e.srcElement}function e_button(e){var b=e.which;return null==b&&(1&e.button?b=1:2&e.button?b=3:4&e.button&&(b=2)),mac&&e.ctrlKey&&1==b&&(b=3),b}function on(emitter,type,f){if(emitter.addEventListener)emitter.addEventListener(type,f,!1);else if(emitter.attachEvent)emitter.attachEvent("on"+type,f);else{var map=emitter._handlers||(emitter._handlers={}),arr=map[type]||(map[type]=[]);arr.push(f)}}function off(emitter,type,f){if(emitter.removeEventListener)emitter.removeEventListener(type,f,!1);else if(emitter.detachEvent)emitter.detachEvent("on"+type,f);else{var arr=emitter._handlers&&emitter._handlers[type];if(!arr)return;for(var i=0;i<arr.length;++i)if(arr[i]==f){arr.splice(i,1);break}}}function signal(emitter,type){var arr=emitter._handlers&&emitter._handlers[type];if(arr)for(var args=Array.prototype.slice.call(arguments,2),i=0;i<arr.length;++i)arr[i].apply(null,args)}function signalLater(emitter,type){function bnd(f){return function(){f.apply(null,args)}}var arr=emitter._handlers&&emitter._handlers[type];if(arr){var args=Array.prototype.slice.call(arguments,2);delayedCallbacks||(++delayedCallbackDepth,delayedCallbacks=[],setTimeout(fireDelayed,0));for(var i=0;i<arr.length;++i)delayedCallbacks.push(bnd(arr[i]))}}function signalDOMEvent(cm,e,override){return signal(cm,override||e.type,cm,e),e_defaultPrevented(e)||e.codemirrorIgnore}function fireDelayed(){--delayedCallbackDepth;var delayed=delayedCallbacks;delayedCallbacks=null;for(var i=0;i<delayed.length;++i)delayed[i]()}function hasHandler(emitter,type){var arr=emitter._handlers&&emitter._handlers[type];return arr&&arr.length>0}function eventMixin(ctor){ctor.prototype.on=function(type,f){on(this,type,f)},ctor.prototype.off=function(type,f){off(this,type,f)}}function Delayed(){this.id=null}function countColumn(string,end,tabSize,startIndex,startValue){null==end&&(end=string.search(/[^\s\u00a0]/),-1==end&&(end=string.length));for(var i=startIndex||0,n=startValue||0;end>i;++i)"	"==string.charAt(i)?n+=tabSize-n%tabSize:++n;return n}function spaceStr(n){for(;spaceStrs.length<=n;)spaceStrs.push(lst(spaceStrs)+" ");return spaceStrs[n]}function lst(arr){return arr[arr.length-1]}function selectInput(node){if(ios)node.selectionStart=0,node.selectionEnd=node.value.length;else try{node.select()}catch(_e){}}function indexOf(collection,elt){if(collection.indexOf)return collection.indexOf(elt);for(var i=0,e=collection.length;e>i;++i)if(collection[i]==elt)return i;return-1}function createObj(base,props){function Obj(){}Obj.prototype=base;var inst=new Obj;return props&&copyObj(props,inst),inst}function copyObj(obj,target){target||(target={});for(var prop in obj)obj.hasOwnProperty(prop)&&(target[prop]=obj[prop]);return target}function emptyArray(size){for(var a=[],i=0;size>i;++i)a.push(void 0);return a}function bind(f){var args=Array.prototype.slice.call(arguments,1);return function(){return f.apply(null,args)}}function isWordChar(ch){return/\w/.test(ch)||ch>""&&(ch.toUpperCase()!=ch.toLowerCase()||nonASCIISingleCaseWordChar.test(ch))}function isEmpty(obj){for(var n in obj)if(obj.hasOwnProperty(n)&&obj[n])return!1;return!0}function elt(tag,content,className,style){var e=document.createElement(tag);if(className&&(e.className=className),style&&(e.style.cssText=style),"string"==typeof content)setTextContent(e,content);else if(content)for(var i=0;i<content.length;++i)e.appendChild(content[i]);return e}function removeChildren(e){for(var count=e.childNodes.length;count>0;--count)e.removeChild(e.firstChild);return e}function removeChildrenAndAdd(parent,e){return removeChildren(parent).appendChild(e)}function setTextContent(e,str){ie_lt9?(e.innerHTML="",e.appendChild(document.createTextNode(str))):e.textContent=str}function getRect(node){return node.getBoundingClientRect()}function spanAffectsWrapping(){return!1}function scrollbarWidth(measure){if(null!=knownScrollbarWidth)return knownScrollbarWidth;var test=elt("div",null,null,"width: 50px; height: 50px; overflow-x: scroll");return removeChildrenAndAdd(measure,test),test.offsetWidth&&(knownScrollbarWidth=test.offsetHeight-test.clientHeight),knownScrollbarWidth||0}function zeroWidthElement(measure){if(null==zwspSupported){var test=elt("span","​");removeChildrenAndAdd(measure,elt("span",[test,document.createTextNode("x")])),0!=measure.firstChild.offsetHeight&&(zwspSupported=test.offsetWidth<=1&&test.offsetHeight>2&&!ie_lt8)}return zwspSupported?elt("span","​"):elt("span"," ",null,"display: inline-block; width: 1px; margin-right: -1px")}function iterateBidiSections(order,from,to,f){if(!order)return f(from,to,"ltr");for(var found=!1,i=0;i<order.length;++i){var part=order[i];(part.from<to&&part.to>from||from==to&&part.to==from)&&(f(Math.max(part.from,from),Math.min(part.to,to),1==part.level?"rtl":"ltr"),found=!0)}found||f(from,to,"ltr")}function bidiLeft(part){return part.level%2?part.to:part.from}function bidiRight(part){return part.level%2?part.from:part.to}function lineLeft(line){var order=getOrder(line);return order?bidiLeft(order[0]):0}function lineRight(line){var order=getOrder(line);return order?bidiRight(lst(order)):line.text.length}function lineStart(cm,lineN){var line=getLine(cm.doc,lineN),visual=visualLine(cm.doc,line);visual!=line&&(lineN=lineNo(visual));var order=getOrder(visual),ch=order?order[0].level%2?lineRight(visual):lineLeft(visual):0;return Pos(lineN,ch)}function lineEnd(cm,lineN){for(var merged,line;merged=collapsedSpanAtEnd(line=getLine(cm.doc,lineN));)lineN=merged.find().to.line;var order=getOrder(line),ch=order?order[0].level%2?lineLeft(line):lineRight(line):line.text.length;return Pos(lineN,ch)}function compareBidiLevel(order,a,b){var linedir=order[0].level;return a==linedir?!0:b==linedir?!1:b>a}function getBidiPartAt(order,pos){for(var found,i=0;i<order.length;++i){var cur=order[i];if(cur.from<pos&&cur.to>pos)return bidiOther=null,i;if(cur.from==pos||cur.to==pos){if(null!=found)return compareBidiLevel(order,cur.level,order[found].level)?(bidiOther=found,i):(bidiOther=i,found);found=i}}return bidiOther=null,found}function moveInLine(line,pos,dir,byUnit){if(!byUnit)return pos+dir;do pos+=dir;while(pos>0&&isExtendingChar.test(line.text.charAt(pos)));return pos}function moveVisually(line,start,dir,byUnit){var bidi=getOrder(line);if(!bidi)return moveLogically(line,start,dir,byUnit);for(var pos=getBidiPartAt(bidi,start),part=bidi[pos],target=moveInLine(line,start,part.level%2?-dir:dir,byUnit);;){if(target>part.from&&target<part.to)return target;if(target==part.from||target==part.to)return getBidiPartAt(bidi,target)==pos?target:(part=bidi[pos+=dir],dir>0==part.level%2?part.to:part.from);if(part=bidi[pos+=dir],!part)return null;target=dir>0==part.level%2?moveInLine(line,part.to,-1,byUnit):moveInLine(line,part.from,1,byUnit)}}function moveLogically(line,start,dir,byUnit){var target=start+dir;if(byUnit)for(;target>0&&isExtendingChar.test(line.text.charAt(target));)target+=dir;return 0>target||target>line.text.length?null:target}var gecko=/gecko\/\d/i.test(navigator.userAgent),ie=/MSIE \d/.test(navigator.userAgent),ie_lt8=ie&&(null==document.documentMode||document.documentMode<8),ie_lt9=ie&&(null==document.documentMode||document.documentMode<9),webkit=/WebKit\//.test(navigator.userAgent),qtwebkit=webkit&&/Qt\/\d+\.\d+/.test(navigator.userAgent),chrome=/Chrome\//.test(navigator.userAgent),opera=/Opera\//.test(navigator.userAgent),safari=/Apple Computer/.test(navigator.vendor),khtml=/KHTML\//.test(navigator.userAgent),mac_geLion=/Mac OS X 1\d\D([7-9]|\d\d)\D/.test(navigator.userAgent),mac_geMountainLion=/Mac OS X 1\d\D([8-9]|\d\d)\D/.test(navigator.userAgent),phantom=/PhantomJS/.test(navigator.userAgent),ios=/AppleWebKit/.test(navigator.userAgent)&&/Mobile\/\w+/.test(navigator.userAgent),mobile=ios||/Android|webOS|BlackBerry|Opera Mini|Opera Mobi|IEMobile/i.test(navigator.userAgent),mac=ios||/Mac/.test(navigator.platform),windows=/windows/i.test(navigator.platform),opera_version=opera&&navigator.userAgent.match(/Version\/(\d*\.\d*)/);opera_version&&(opera_version=Number(opera_version[1])),opera_version&&opera_version>=15&&(opera=!1,webkit=!0);var measureText,lastClick,lastDoubleClick,flipCtrlCmd=mac&&(qtwebkit||opera&&(null==opera_version||12.11>opera_version)),captureMiddleClick=gecko||ie&&!ie_lt9,sawReadOnlySpans=!1,sawCollapsedSpans=!1,nextOpId=0,lastDrop=0,wheelSamples=0,wheelPixelsPerUnit=null;ie?wheelPixelsPerUnit=-.53:gecko?wheelPixelsPerUnit=15:chrome?wheelPixelsPerUnit=-.7:safari&&(wheelPixelsPerUnit=-1/3);var maybeTransition,detectingSelectAll,lastStoppedKey=null,changeEnd=CodeMirror.changeEnd=function(change){return change.text?Pos(change.from.line+change.text.length-1,lst(change.text).length+(1==change.text.length?change.from.ch:0)):change.to};CodeMirror.Pos=Pos,CodeMirror.prototype={constructor:CodeMirror,focus:function(){window.focus(),focusInput(this),onFocus(this),fastPoll(this)},setOption:function(option,value){var options=this.options,old=options[option];(options[option]!=value||"mode"==option)&&(options[option]=value,optionHandlers.hasOwnProperty(option)&&operation(this,optionHandlers[option])(this,value,old))},getOption:function(option){return this.options[option]},getDoc:function(){return this.doc},addKeyMap:function(map,bottom){this.state.keyMaps[bottom?"push":"unshift"](map)},removeKeyMap:function(map){for(var maps=this.state.keyMaps,i=0;i<maps.length;++i)if(maps[i]==map||"string"!=typeof maps[i]&&maps[i].name==map)return maps.splice(i,1),!0},addOverlay:operation(null,function(spec,options){var mode=spec.token?spec:CodeMirror.getMode(this.options,spec);if(mode.startState)throw new Error("Overlays may not be stateful.");this.state.overlays.push({mode:mode,modeSpec:spec,opaque:options&&options.opaque}),this.state.modeGen++,regChange(this)}),removeOverlay:operation(null,function(spec){for(var overlays=this.state.overlays,i=0;i<overlays.length;++i){var cur=overlays[i].modeSpec;if(cur==spec||"string"==typeof spec&&cur.name==spec)return overlays.splice(i,1),this.state.modeGen++,void regChange(this)}}),indentLine:operation(null,function(n,dir,aggressive){"string"!=typeof dir&&"number"!=typeof dir&&(dir=null==dir?this.options.smartIndent?"smart":"prev":dir?"add":"subtract"),isLine(this.doc,n)&&indentLine(this,n,dir,aggressive)}),indentSelection:operation(null,function(how){var sel=this.doc.sel;if(posEq(sel.from,sel.to))return indentLine(this,sel.from.line,how);for(var e=sel.to.line-(sel.to.ch?0:1),i=sel.from.line;e>=i;++i)indentLine(this,i,how)}),getTokenAt:function(pos,precise){var doc=this.doc;pos=clipPos(doc,pos);for(var state=getStateBefore(this,pos.line,precise),mode=this.doc.mode,line=getLine(doc,pos.line),stream=new StringStream(line.text,this.options.tabSize);stream.pos<pos.ch&&!stream.eol();){stream.start=stream.pos;var style=mode.token(stream,state)}return{start:stream.start,end:stream.pos,string:stream.current(),className:style||null,type:style||null,state:state}},getTokenTypeAt:function(pos){pos=clipPos(this.doc,pos);var styles=getLineStyles(this,getLine(this.doc,pos.line)),before=0,after=(styles.length-1)/2,ch=pos.ch;if(0==ch)return styles[2];for(;;){var mid=before+after>>1;if((mid?styles[2*mid-1]:0)>=ch)after=mid;else{if(!(styles[2*mid+1]<ch))return styles[2*mid+2];before=mid+1}}},getModeAt:function(pos){var mode=this.doc.mode;return mode.innerMode?CodeMirror.innerMode(mode,this.getTokenAt(pos).state).mode:mode},getHelper:function(pos,type){if(helpers.hasOwnProperty(type)){var help=helpers[type],mode=this.getModeAt(pos);return mode[type]&&help[mode[type]]||mode.helperType&&help[mode.helperType]||help[mode.name]}},getStateAfter:function(line,precise){var doc=this.doc;return line=clipLine(doc,null==line?doc.first+doc.size-1:line),getStateBefore(this,line+1,precise)},cursorCoords:function(start,mode){var pos,sel=this.doc.sel;return pos=null==start?sel.head:"object"==typeof start?clipPos(this.doc,start):start?sel.from:sel.to,cursorCoords(this,pos,mode||"page")},charCoords:function(pos,mode){return charCoords(this,clipPos(this.doc,pos),mode||"page")},coordsChar:function(coords,mode){return coords=fromCoordSystem(this,coords,mode||"page"),coordsChar(this,coords.left,coords.top)},lineAtHeight:function(height,mode){return height=fromCoordSystem(this,{top:height,left:0},mode||"page").top,lineAtHeight(this.doc,height+this.display.viewOffset)},heightAtLine:function(line,mode){var end=!1,last=this.doc.first+this.doc.size-1;line<this.doc.first?line=this.doc.first:line>last&&(line=last,end=!0);var lineObj=getLine(this.doc,line);return intoCoordSystem(this,getLine(this.doc,line),{top:0,left:0},mode||"page").top+(end?lineObj.height:0)},defaultTextHeight:function(){return textHeight(this.display)},defaultCharWidth:function(){return charWidth(this.display)},setGutterMarker:operation(null,function(line,gutterID,value){return changeLine(this,line,function(line){var markers=line.gutterMarkers||(line.gutterMarkers={});return markers[gutterID]=value,!value&&isEmpty(markers)&&(line.gutterMarkers=null),!0})}),clearGutter:operation(null,function(gutterID){var cm=this,doc=cm.doc,i=doc.first;doc.iter(function(line){line.gutterMarkers&&line.gutterMarkers[gutterID]&&(line.gutterMarkers[gutterID]=null,regChange(cm,i,i+1),isEmpty(line.gutterMarkers)&&(line.gutterMarkers=null)),++i})}),addLineClass:operation(null,function(handle,where,cls){return changeLine(this,handle,function(line){var prop="text"==where?"textClass":"background"==where?"bgClass":"wrapClass";if(line[prop]){if(new RegExp("(?:^|\\s)"+cls+"(?:$|\\s)").test(line[prop]))return!1;line[prop]+=" "+cls}else line[prop]=cls;return!0})}),removeLineClass:operation(null,function(handle,where,cls){return changeLine(this,handle,function(line){var prop="text"==where?"textClass":"background"==where?"bgClass":"wrapClass",cur=line[prop];if(!cur)return!1;if(null==cls)line[prop]=null;else{var found=cur.match(new RegExp("(?:^|\\s+)"+cls+"(?:$|\\s+)"));if(!found)return!1;var end=found.index+found[0].length;line[prop]=cur.slice(0,found.index)+(found.index&&end!=cur.length?" ":"")+cur.slice(end)||null}return!0})}),addLineWidget:operation(null,function(handle,node,options){return addLineWidget(this,handle,node,options)}),removeLineWidget:function(widget){widget.clear()},lineInfo:function(line){if("number"==typeof line){if(!isLine(this.doc,line))return null;var n=line;if(line=getLine(this.doc,line),!line)return null}else{var n=lineNo(line);if(null==n)return null}return{line:n,handle:line,text:line.text,gutterMarkers:line.gutterMarkers,textClass:line.textClass,bgClass:line.bgClass,wrapClass:line.wrapClass,widgets:line.widgets}},getViewport:function(){return{from:this.display.showingFrom,to:this.display.showingTo}},addWidget:function(pos,node,scroll,vert,horiz){var display=this.display;pos=cursorCoords(this,clipPos(this.doc,pos));var top=pos.bottom,left=pos.left;if(node.style.position="absolute",display.sizer.appendChild(node),"over"==vert)top=pos.top;else if("above"==vert||"near"==vert){var vspace=Math.max(display.wrapper.clientHeight,this.doc.height),hspace=Math.max(display.sizer.clientWidth,display.lineSpace.clientWidth);("above"==vert||pos.bottom+node.offsetHeight>vspace)&&pos.top>node.offsetHeight?top=pos.top-node.offsetHeight:pos.bottom+node.offsetHeight<=vspace&&(top=pos.bottom),left+node.offsetWidth>hspace&&(left=hspace-node.offsetWidth)}node.style.top=top+"px",node.style.left=node.style.right="","right"==horiz?(left=display.sizer.clientWidth-node.offsetWidth,node.style.right="0px"):("left"==horiz?left=0:"middle"==horiz&&(left=(display.sizer.clientWidth-node.offsetWidth)/2),node.style.left=left+"px"),scroll&&scrollIntoView(this,left,top,left+node.offsetWidth,top+node.offsetHeight)},triggerOnKeyDown:operation(null,onKeyDown),execCommand:function(cmd){return commands[cmd](this)},findPosH:function(from,amount,unit,visually){var dir=1;0>amount&&(dir=-1,amount=-amount);for(var i=0,cur=clipPos(this.doc,from);amount>i&&(cur=findPosH(this.doc,cur,dir,unit,visually),!cur.hitSide);++i);return cur},moveH:operation(null,function(dir,unit){var pos,sel=this.doc.sel;pos=sel.shift||sel.extend||posEq(sel.from,sel.to)?findPosH(this.doc,sel.head,dir,unit,this.options.rtlMoveVisually):0>dir?sel.from:sel.to,extendSelection(this.doc,pos,pos,dir)}),deleteH:operation(null,function(dir,unit){var sel=this.doc.sel;posEq(sel.from,sel.to)?replaceRange(this.doc,"",sel.from,findPosH(this.doc,sel.head,dir,unit,!1),"+delete"):replaceRange(this.doc,"",sel.from,sel.to,"+delete"),this.curOp.userSelChange=!0}),findPosV:function(from,amount,unit,goalColumn){var dir=1,x=goalColumn;0>amount&&(dir=-1,amount=-amount);for(var i=0,cur=clipPos(this.doc,from);amount>i;++i){var coords=cursorCoords(this,cur,"div");if(null==x?x=coords.left:coords.left=x,cur=findPosV(this,coords,dir,unit),cur.hitSide)break}return cur},moveV:operation(null,function(dir,unit){var sel=this.doc.sel,pos=cursorCoords(this,sel.head,"div");null!=sel.goalColumn&&(pos.left=sel.goalColumn);var target=findPosV(this,pos,dir,unit);"page"==unit&&addToScrollPos(this,0,charCoords(this,target,"div").top-pos.top),extendSelection(this.doc,target,target,dir),sel.goalColumn=pos.left}),toggleOverwrite:function(value){(null==value||value!=this.state.overwrite)&&((this.state.overwrite=!this.state.overwrite)?this.display.cursor.className+=" CodeMirror-overwrite":this.display.cursor.className=this.display.cursor.className.replace(" CodeMirror-overwrite",""))},hasFocus:function(){return this.state.focused},scrollTo:operation(null,function(x,y){updateScrollPos(this,x,y)}),getScrollInfo:function(){var scroller=this.display.scroller,co=scrollerCutOff;return{left:scroller.scrollLeft,top:scroller.scrollTop,height:scroller.scrollHeight-co,width:scroller.scrollWidth-co,clientHeight:scroller.clientHeight-co,clientWidth:scroller.clientWidth-co}},scrollIntoView:operation(null,function(pos,margin){"number"==typeof pos&&(pos=Pos(pos,0)),margin||(margin=0);var coords=pos;pos&&null==pos.line||(this.curOp.scrollToPos=pos?clipPos(this.doc,pos):this.doc.sel.head,this.curOp.scrollToPosMargin=margin,coords=cursorCoords(this,this.curOp.scrollToPos));var sPos=calculateScrollPos(this,coords.left,coords.top-margin,coords.right,coords.bottom+margin);updateScrollPos(this,sPos.scrollLeft,sPos.scrollTop)}),setSize:operation(null,function(width,height){function interpret(val){return"number"==typeof val||/^\d+$/.test(String(val))?val+"px":val}null!=width&&(this.display.wrapper.style.width=interpret(width)),null!=height&&(this.display.wrapper.style.height=interpret(height)),
this.options.lineWrapping&&(this.display.measureLineCache.length=this.display.measureLineCachePos=0),this.curOp.forceUpdate=!0}),operation:function(f){return runInOp(this,f)},refresh:operation(null,function(){clearCaches(this),updateScrollPos(this,this.doc.scrollLeft,this.doc.scrollTop),regChange(this)}),swapDoc:operation(null,function(doc){var old=this.doc;return old.cm=null,attachDoc(this,doc),clearCaches(this),resetInput(this,!0),updateScrollPos(this,doc.scrollLeft,doc.scrollTop),old}),getInputField:function(){return this.display.input},getWrapperElement:function(){return this.display.wrapper},getScrollerElement:function(){return this.display.scroller},getGutterElement:function(){return this.display.gutters}},eventMixin(CodeMirror);var optionHandlers=CodeMirror.optionHandlers={},defaults=CodeMirror.defaults={},Init=CodeMirror.Init={toString:function(){return"CodeMirror.Init"}};option("value","",function(cm,val){cm.setValue(val)},!0),option("mode",null,function(cm,val){cm.doc.modeOption=val,loadMode(cm)},!0),option("indentUnit",2,loadMode,!0),option("indentWithTabs",!1),option("smartIndent",!0),option("tabSize",4,function(cm){loadMode(cm),clearCaches(cm),regChange(cm)},!0),option("electricChars",!0),option("rtlMoveVisually",!windows),option("theme","default",function(cm){themeChanged(cm),guttersChanged(cm)},!0),option("keyMap","default",keyMapChanged),option("extraKeys",null),option("onKeyEvent",null),option("onDragEvent",null),option("lineWrapping",!1,wrappingChanged,!0),option("gutters",[],function(cm){setGuttersForLineNumbers(cm.options),guttersChanged(cm)},!0),option("fixedGutter",!0,function(cm,val){cm.display.gutters.style.left=val?compensateForHScroll(cm.display)+"px":"0",cm.refresh()},!0),option("coverGutterNextToScrollbar",!1,updateScrollbars,!0),option("lineNumbers",!1,function(cm){setGuttersForLineNumbers(cm.options),guttersChanged(cm)},!0),option("firstLineNumber",1,guttersChanged,!0),option("lineNumberFormatter",function(integer){return integer},guttersChanged,!0),option("showCursorWhenSelecting",!1,updateSelection,!0),option("readOnly",!1,function(cm,val){"nocursor"==val?(onBlur(cm),cm.display.input.blur()):val||resetInput(cm,!0)}),option("dragDrop",!0),option("cursorBlinkRate",530),option("cursorScrollMargin",0),option("cursorHeight",1),option("workTime",100),option("workDelay",100),option("flattenSpans",!0),option("pollInterval",100),option("undoDepth",40,function(cm,val){cm.doc.history.undoDepth=val}),option("historyEventDelay",500),option("viewportMargin",10,function(cm){cm.refresh()},!0),option("maxHighlightLength",1e4,function(cm){loadMode(cm),cm.refresh()},!0),option("moveInputWithCursor",!0,function(cm,val){val||(cm.display.inputDiv.style.top=cm.display.inputDiv.style.left=0)}),option("tabindex",null,function(cm,val){cm.display.input.tabIndex=val||""}),option("autofocus",null);var modes=CodeMirror.modes={},mimeModes=CodeMirror.mimeModes={};CodeMirror.defineMode=function(name,mode){if(CodeMirror.defaults.mode||"null"==name||(CodeMirror.defaults.mode=name),arguments.length>2){mode.dependencies=[];for(var i=2;i<arguments.length;++i)mode.dependencies.push(arguments[i])}modes[name]=mode},CodeMirror.defineMIME=function(mime,spec){mimeModes[mime]=spec},CodeMirror.resolveMode=function(spec){if("string"==typeof spec&&mimeModes.hasOwnProperty(spec))spec=mimeModes[spec];else if(spec&&"string"==typeof spec.name&&mimeModes.hasOwnProperty(spec.name)){var found=mimeModes[spec.name];spec=createObj(found,spec),spec.name=found.name}else if("string"==typeof spec&&/^[\w\-]+\/[\w\-]+\+xml$/.test(spec))return CodeMirror.resolveMode("application/xml");return"string"==typeof spec?{name:spec}:spec||{name:"null"}},CodeMirror.getMode=function(options,spec){var spec=CodeMirror.resolveMode(spec),mfactory=modes[spec.name];if(!mfactory)return CodeMirror.getMode(options,"text/plain");var modeObj=mfactory(options,spec);if(modeExtensions.hasOwnProperty(spec.name)){var exts=modeExtensions[spec.name];for(var prop in exts)exts.hasOwnProperty(prop)&&(modeObj.hasOwnProperty(prop)&&(modeObj["_"+prop]=modeObj[prop]),modeObj[prop]=exts[prop])}return modeObj.name=spec.name,modeObj},CodeMirror.defineMode("null",function(){return{token:function(stream){stream.skipToEnd()}}}),CodeMirror.defineMIME("text/plain","null");var modeExtensions=CodeMirror.modeExtensions={};CodeMirror.extendMode=function(mode,properties){var exts=modeExtensions.hasOwnProperty(mode)?modeExtensions[mode]:modeExtensions[mode]={};copyObj(properties,exts)},CodeMirror.defineExtension=function(name,func){CodeMirror.prototype[name]=func},CodeMirror.defineDocExtension=function(name,func){Doc.prototype[name]=func},CodeMirror.defineOption=option;var initHooks=[];CodeMirror.defineInitHook=function(f){initHooks.push(f)};var helpers=CodeMirror.helpers={};CodeMirror.registerHelper=function(type,name,value){helpers.hasOwnProperty(type)||(helpers[type]=CodeMirror[type]={}),helpers[type][name]=value},CodeMirror.isWordChar=isWordChar,CodeMirror.copyState=copyState,CodeMirror.startState=startState,CodeMirror.innerMode=function(mode,state){for(;mode.innerMode;){var info=mode.innerMode(state);if(!info||info.mode==mode)break;state=info.state,mode=info.mode}return info||{mode:mode,state:state}};var commands=CodeMirror.commands={selectAll:function(cm){cm.setSelection(Pos(cm.firstLine(),0),Pos(cm.lastLine()))},killLine:function(cm){var from=cm.getCursor(!0),to=cm.getCursor(!1),sel=!posEq(from,to);sel||cm.getLine(from.line).length!=from.ch?cm.replaceRange("",from,sel?to:Pos(from.line),"+delete"):cm.replaceRange("",from,Pos(from.line+1,0),"+delete")},deleteLine:function(cm){var l=cm.getCursor().line;cm.replaceRange("",Pos(l,0),Pos(l),"+delete")},delLineLeft:function(cm){var cur=cm.getCursor();cm.replaceRange("",Pos(cur.line,0),cur,"+delete")},undo:function(cm){cm.undo()},redo:function(cm){cm.redo()},goDocStart:function(cm){cm.extendSelection(Pos(cm.firstLine(),0))},goDocEnd:function(cm){cm.extendSelection(Pos(cm.lastLine()))},goLineStart:function(cm){cm.extendSelection(lineStart(cm,cm.getCursor().line))},goLineStartSmart:function(cm){var cur=cm.getCursor(),start=lineStart(cm,cur.line),line=cm.getLineHandle(start.line),order=getOrder(line);if(order&&0!=order[0].level)cm.extendSelection(start);else{var firstNonWS=Math.max(0,line.text.search(/\S/)),inWS=cur.line==start.line&&cur.ch<=firstNonWS&&cur.ch;cm.extendSelection(Pos(start.line,inWS?0:firstNonWS))}},goLineEnd:function(cm){cm.extendSelection(lineEnd(cm,cm.getCursor().line))},goLineRight:function(cm){var top=cm.charCoords(cm.getCursor(),"div").top+5;cm.extendSelection(cm.coordsChar({left:cm.display.lineDiv.offsetWidth+100,top:top},"div"))},goLineLeft:function(cm){var top=cm.charCoords(cm.getCursor(),"div").top+5;cm.extendSelection(cm.coordsChar({left:0,top:top},"div"))},goLineUp:function(cm){cm.moveV(-1,"line")},goLineDown:function(cm){cm.moveV(1,"line")},goPageUp:function(cm){cm.moveV(-1,"page")},goPageDown:function(cm){cm.moveV(1,"page")},goCharLeft:function(cm){cm.moveH(-1,"char")},goCharRight:function(cm){cm.moveH(1,"char")},goColumnLeft:function(cm){cm.moveH(-1,"column")},goColumnRight:function(cm){cm.moveH(1,"column")},goWordLeft:function(cm){cm.moveH(-1,"word")},goGroupRight:function(cm){cm.moveH(1,"group")},goGroupLeft:function(cm){cm.moveH(-1,"group")},goWordRight:function(cm){cm.moveH(1,"word")},delCharBefore:function(cm){cm.deleteH(-1,"char")},delCharAfter:function(cm){cm.deleteH(1,"char")},delWordBefore:function(cm){cm.deleteH(-1,"word")},delWordAfter:function(cm){cm.deleteH(1,"word")},delGroupBefore:function(cm){cm.deleteH(-1,"group")},delGroupAfter:function(cm){cm.deleteH(1,"group")},indentAuto:function(cm){cm.indentSelection("smart")},indentMore:function(cm){cm.indentSelection("add")},indentLess:function(cm){cm.indentSelection("subtract")},insertTab:function(cm){cm.replaceSelection("	","end","+input")},defaultTab:function(cm){cm.somethingSelected()?cm.indentSelection("add"):cm.replaceSelection("	","end","+input")},transposeChars:function(cm){var cur=cm.getCursor(),line=cm.getLine(cur.line);cur.ch>0&&cur.ch<line.length-1&&cm.replaceRange(line.charAt(cur.ch)+line.charAt(cur.ch-1),Pos(cur.line,cur.ch-1),Pos(cur.line,cur.ch+1))},newlineAndIndent:function(cm){operation(cm,function(){cm.replaceSelection("\n","end","+input"),cm.indentLine(cm.getCursor().line,null,!0)})()},toggleOverwrite:function(cm){cm.toggleOverwrite()}},keyMap=CodeMirror.keyMap={};keyMap.basic={Left:"goCharLeft",Right:"goCharRight",Up:"goLineUp",Down:"goLineDown",End:"goLineEnd",Home:"goLineStartSmart",PageUp:"goPageUp",PageDown:"goPageDown",Delete:"delCharAfter",Backspace:"delCharBefore",Tab:"defaultTab","Shift-Tab":"indentAuto",Enter:"newlineAndIndent",Insert:"toggleOverwrite"},keyMap.pcDefault={"Ctrl-A":"selectAll","Ctrl-D":"deleteLine","Ctrl-Z":"undo","Shift-Ctrl-Z":"redo","Ctrl-Y":"redo","Ctrl-Home":"goDocStart","Alt-Up":"goDocStart","Ctrl-End":"goDocEnd","Ctrl-Down":"goDocEnd","Ctrl-Left":"goGroupLeft","Ctrl-Right":"goGroupRight","Alt-Left":"goLineStart","Alt-Right":"goLineEnd","Ctrl-Backspace":"delGroupBefore","Ctrl-Delete":"delGroupAfter","Ctrl-S":"save","Ctrl-F":"find","Ctrl-G":"findNext","Shift-Ctrl-G":"findPrev","Shift-Ctrl-F":"replace","Shift-Ctrl-R":"replaceAll","Ctrl-[":"indentLess","Ctrl-]":"indentMore",fallthrough:"basic"},keyMap.macDefault={"Cmd-A":"selectAll","Cmd-D":"deleteLine","Cmd-Z":"undo","Shift-Cmd-Z":"redo","Cmd-Y":"redo","Cmd-Up":"goDocStart","Cmd-End":"goDocEnd","Cmd-Down":"goDocEnd","Alt-Left":"goGroupLeft","Alt-Right":"goGroupRight","Cmd-Left":"goLineStart","Cmd-Right":"goLineEnd","Alt-Backspace":"delGroupBefore","Ctrl-Alt-Backspace":"delGroupAfter","Alt-Delete":"delGroupAfter","Cmd-S":"save","Cmd-F":"find","Cmd-G":"findNext","Shift-Cmd-G":"findPrev","Cmd-Alt-F":"replace","Shift-Cmd-Alt-F":"replaceAll","Cmd-[":"indentLess","Cmd-]":"indentMore","Cmd-Backspace":"delLineLeft",fallthrough:["basic","emacsy"]},keyMap["default"]=mac?keyMap.macDefault:keyMap.pcDefault,keyMap.emacsy={"Ctrl-F":"goCharRight","Ctrl-B":"goCharLeft","Ctrl-P":"goLineUp","Ctrl-N":"goLineDown","Alt-F":"goWordRight","Alt-B":"goWordLeft","Ctrl-A":"goLineStart","Ctrl-E":"goLineEnd","Ctrl-V":"goPageDown","Shift-Ctrl-V":"goPageUp","Ctrl-D":"delCharAfter","Ctrl-H":"delCharBefore","Alt-D":"delWordAfter","Alt-Backspace":"delWordBefore","Ctrl-K":"killLine","Ctrl-T":"transposeChars"},CodeMirror.lookupKey=lookupKey,CodeMirror.isModifierKey=isModifierKey,CodeMirror.keyName=keyName,CodeMirror.fromTextArea=function(textarea,options){function save(){textarea.value=cm.getValue()}if(options||(options={}),options.value=textarea.value,!options.tabindex&&textarea.tabindex&&(options.tabindex=textarea.tabindex),!options.placeholder&&textarea.placeholder&&(options.placeholder=textarea.placeholder),null==options.autofocus){var hasFocus=document.body;try{hasFocus=document.activeElement}catch(e){}options.autofocus=hasFocus==textarea||null!=textarea.getAttribute("autofocus")&&hasFocus==document.body}if(textarea.form&&(on(textarea.form,"submit",save),!options.leaveSubmitMethodAlone)){var form=textarea.form,realSubmit=form.submit;try{var wrappedSubmit=form.submit=function(){save(),form.submit=realSubmit,form.submit(),form.submit=wrappedSubmit}}catch(e){}}textarea.style.display="none";var cm=CodeMirror(function(node){textarea.parentNode.insertBefore(node,textarea.nextSibling)},options);return cm.save=save,cm.getTextArea=function(){return textarea},cm.toTextArea=function(){save(),textarea.parentNode.removeChild(cm.getWrapperElement()),textarea.style.display="",textarea.form&&(off(textarea.form,"submit",save),"function"==typeof textarea.form.submit&&(textarea.form.submit=realSubmit))},cm},StringStream.prototype={eol:function(){return this.pos>=this.string.length},sol:function(){return 0==this.pos},peek:function(){return this.string.charAt(this.pos)||void 0},next:function(){return this.pos<this.string.length?this.string.charAt(this.pos++):void 0},eat:function(match){var ch=this.string.charAt(this.pos);if("string"==typeof match)var ok=ch==match;else var ok=ch&&(match.test?match.test(ch):match(ch));return ok?(++this.pos,ch):void 0},eatWhile:function(match){for(var start=this.pos;this.eat(match););return this.pos>start},eatSpace:function(){for(var start=this.pos;/[\s\u00a0]/.test(this.string.charAt(this.pos));)++this.pos;return this.pos>start},skipToEnd:function(){this.pos=this.string.length},skipTo:function(ch){var found=this.string.indexOf(ch,this.pos);return found>-1?(this.pos=found,!0):void 0},backUp:function(n){this.pos-=n},column:function(){return this.lastColumnPos<this.start&&(this.lastColumnValue=countColumn(this.string,this.start,this.tabSize,this.lastColumnPos,this.lastColumnValue),this.lastColumnPos=this.start),this.lastColumnValue},indentation:function(){return countColumn(this.string,null,this.tabSize)},match:function(pattern,consume,caseInsensitive){if("string"!=typeof pattern){var match=this.string.slice(this.pos).match(pattern);return match&&match.index>0?null:(match&&consume!==!1&&(this.pos+=match[0].length),match)}var cased=function(str){return caseInsensitive?str.toLowerCase():str},substr=this.string.substr(this.pos,pattern.length);return cased(substr)==cased(pattern)?(consume!==!1&&(this.pos+=pattern.length),!0):void 0},current:function(){return this.string.slice(this.start,this.pos)}},CodeMirror.StringStream=StringStream,CodeMirror.TextMarker=TextMarker,eventMixin(TextMarker),TextMarker.prototype.clear=function(){if(!this.explicitlyCleared){var cm=this.doc.cm,withOp=cm&&!cm.curOp;if(withOp&&startOperation(cm),hasHandler(this,"clear")){var found=this.find();found&&signalLater(this,"clear",found.from,found.to)}for(var min=null,max=null,i=0;i<this.lines.length;++i){var line=this.lines[i],span=getMarkedSpanFor(line.markedSpans,this);null!=span.to&&(max=lineNo(line)),line.markedSpans=removeMarkedSpan(line.markedSpans,span),null!=span.from?min=lineNo(line):this.collapsed&&!lineIsHidden(this.doc,line)&&cm&&updateLineHeight(line,textHeight(cm.display))}if(cm&&this.collapsed&&!cm.options.lineWrapping)for(var i=0;i<this.lines.length;++i){var visual=visualLine(cm.doc,this.lines[i]),len=lineLength(cm.doc,visual);len>cm.display.maxLineLength&&(cm.display.maxLine=visual,cm.display.maxLineLength=len,cm.display.maxLineChanged=!0)}null!=min&&cm&&regChange(cm,min,max+1),this.lines.length=0,this.explicitlyCleared=!0,this.atomic&&this.doc.cantEdit&&(this.doc.cantEdit=!1,cm&&reCheckSelection(cm)),withOp&&endOperation(cm)}},TextMarker.prototype.find=function(){for(var from,to,i=0;i<this.lines.length;++i){var line=this.lines[i],span=getMarkedSpanFor(line.markedSpans,this);if(null!=span.from||null!=span.to){var found=lineNo(line);null!=span.from&&(from=Pos(found,span.from)),null!=span.to&&(to=Pos(found,span.to))}}return"bookmark"==this.type?from:from&&{from:from,to:to}},TextMarker.prototype.changed=function(){var pos=this.find(),cm=this.doc.cm;if(pos&&cm){var line=getLine(this.doc,pos.from.line);if(clearCachedMeasurement(cm,line),pos.from.line>=cm.display.showingFrom&&pos.from.line<cm.display.showingTo){for(var node=cm.display.lineDiv.firstChild;node;node=node.nextSibling)if(node.lineObj==line){node.offsetHeight!=line.height&&updateLineHeight(line,node.offsetHeight);break}runInOp(cm,function(){cm.curOp.selectionChanged=cm.curOp.forceUpdate=cm.curOp.updateMaxLine=!0})}}},TextMarker.prototype.attachLine=function(line){if(!this.lines.length&&this.doc.cm){var op=this.doc.cm.curOp;op.maybeHiddenMarkers&&-1!=indexOf(op.maybeHiddenMarkers,this)||(op.maybeUnhiddenMarkers||(op.maybeUnhiddenMarkers=[])).push(this)}this.lines.push(line)},TextMarker.prototype.detachLine=function(line){if(this.lines.splice(indexOf(this.lines,line),1),!this.lines.length&&this.doc.cm){var op=this.doc.cm.curOp;(op.maybeHiddenMarkers||(op.maybeHiddenMarkers=[])).push(this)}},CodeMirror.SharedTextMarker=SharedTextMarker,eventMixin(SharedTextMarker),SharedTextMarker.prototype.clear=function(){if(!this.explicitlyCleared){this.explicitlyCleared=!0;for(var i=0;i<this.markers.length;++i)this.markers[i].clear();signalLater(this,"clear")}},SharedTextMarker.prototype.find=function(){return this.primary.find()};var LineWidget=CodeMirror.LineWidget=function(cm,node,options){if(options)for(var opt in options)options.hasOwnProperty(opt)&&(this[opt]=options[opt]);this.cm=cm,this.node=node};eventMixin(LineWidget),LineWidget.prototype.clear=widgetOperation(function(){var ws=this.line.widgets,no=lineNo(this.line);if(null!=no&&ws){for(var i=0;i<ws.length;++i)ws[i]==this&&ws.splice(i--,1);ws.length||(this.line.widgets=null);var aboveVisible=heightAtLine(this.cm,this.line)<this.cm.doc.scrollTop;updateLineHeight(this.line,Math.max(0,this.line.height-widgetHeight(this))),aboveVisible&&addToScrollPos(this.cm,0,-this.height),regChange(this.cm,no,no+1)}}),LineWidget.prototype.changed=widgetOperation(function(){var oldH=this.height;this.height=null;var diff=widgetHeight(this)-oldH;if(diff){updateLineHeight(this.line,this.line.height+diff);var no=lineNo(this.line);regChange(this.cm,no,no+1)}});var Line=CodeMirror.Line=function(text,markedSpans,estimateHeight){this.text=text,attachMarkedSpans(this,markedSpans),this.height=estimateHeight?estimateHeight(this):1};eventMixin(Line);var styleToClassCache={},tokenSpecialChars=/[\t\u0000-\u0019\u00ad\u200b\u2028\u2029\uFEFF]/g;LeafChunk.prototype={chunkSize:function(){return this.lines.length},removeInner:function(at,n){for(var i=at,e=at+n;e>i;++i){var line=this.lines[i];this.height-=line.height,cleanUpLine(line),signalLater(line,"delete")}this.lines.splice(at,n)},collapse:function(lines){lines.splice.apply(lines,[lines.length,0].concat(this.lines))},insertInner:function(at,lines,height){this.height+=height,this.lines=this.lines.slice(0,at).concat(lines).concat(this.lines.slice(at));for(var i=0,e=lines.length;e>i;++i)lines[i].parent=this},iterN:function(at,n,op){for(var e=at+n;e>at;++at)if(op(this.lines[at]))return!0}},BranchChunk.prototype={chunkSize:function(){return this.size},removeInner:function(at,n){this.size-=n;for(var i=0;i<this.children.length;++i){var child=this.children[i],sz=child.chunkSize();if(sz>at){var rm=Math.min(n,sz-at),oldHeight=child.height;if(child.removeInner(at,rm),this.height-=oldHeight-child.height,sz==rm&&(this.children.splice(i--,1),child.parent=null),0==(n-=rm))break;at=0}else at-=sz}if(this.size-n<25){var lines=[];this.collapse(lines),this.children=[new LeafChunk(lines)],this.children[0].parent=this}},collapse:function(lines){for(var i=0,e=this.children.length;e>i;++i)this.children[i].collapse(lines)},insertInner:function(at,lines,height){this.size+=lines.length,this.height+=height;for(var i=0,e=this.children.length;e>i;++i){var child=this.children[i],sz=child.chunkSize();if(sz>=at){if(child.insertInner(at,lines,height),child.lines&&child.lines.length>50){for(;child.lines.length>50;){var spilled=child.lines.splice(child.lines.length-25,25),newleaf=new LeafChunk(spilled);child.height-=newleaf.height,this.children.splice(i+1,0,newleaf),newleaf.parent=this}this.maybeSpill()}break}at-=sz}},maybeSpill:function(){if(!(this.children.length<=10)){var me=this;do{var spilled=me.children.splice(me.children.length-5,5),sibling=new BranchChunk(spilled);if(me.parent){me.size-=sibling.size,me.height-=sibling.height;var myIndex=indexOf(me.parent.children,me);me.parent.children.splice(myIndex+1,0,sibling)}else{var copy=new BranchChunk(me.children);copy.parent=me,me.children=[copy,sibling],me=copy}sibling.parent=me.parent}while(me.children.length>10);me.parent.maybeSpill()}},iterN:function(at,n,op){for(var i=0,e=this.children.length;e>i;++i){var child=this.children[i],sz=child.chunkSize();if(sz>at){var used=Math.min(n,sz-at);if(child.iterN(at,used,op))return!0;if(0==(n-=used))break;at=0}else at-=sz}}};var nextDocId=0,Doc=CodeMirror.Doc=function(text,mode,firstLine){if(!(this instanceof Doc))return new Doc(text,mode,firstLine);null==firstLine&&(firstLine=0),BranchChunk.call(this,[new LeafChunk([new Line("",null)])]),this.first=firstLine,this.scrollTop=this.scrollLeft=0,this.cantEdit=!1,this.history=makeHistory(),this.cleanGeneration=1,this.frontier=firstLine;var start=Pos(firstLine,0);this.sel={from:start,to:start,head:start,anchor:start,shift:!1,extend:!1,goalColumn:null},this.id=++nextDocId,this.modeOption=mode,"string"==typeof text&&(text=splitLines(text)),updateDoc(this,{from:start,to:start,text:text},null,{head:start,anchor:start})};Doc.prototype=createObj(BranchChunk.prototype,{constructor:Doc,iter:function(from,to,op){op?this.iterN(from-this.first,to-from,op):this.iterN(this.first,this.first+this.size,from)},insert:function(at,lines){for(var height=0,i=0,e=lines.length;e>i;++i)height+=lines[i].height;this.insertInner(at-this.first,lines,height)},remove:function(at,n){this.removeInner(at-this.first,n)},getValue:function(lineSep){var lines=getLines(this,this.first,this.first+this.size);return lineSep===!1?lines:lines.join(lineSep||"\n")},setValue:function(code){var top=Pos(this.first,0),last=this.first+this.size-1;makeChange(this,{from:top,to:Pos(last,getLine(this,last).text.length),text:splitLines(code),origin:"setValue"},{head:top,anchor:top},!0)},replaceRange:function(code,from,to,origin){from=clipPos(this,from),to=to?clipPos(this,to):from,replaceRange(this,code,from,to,origin)},getRange:function(from,to,lineSep){var lines=getBetween(this,clipPos(this,from),clipPos(this,to));return lineSep===!1?lines:lines.join(lineSep||"\n")},getLine:function(line){var l=this.getLineHandle(line);return l&&l.text},setLine:function(line,text){isLine(this,line)&&replaceRange(this,text,Pos(line,0),clipPos(this,Pos(line)))},removeLine:function(line){line?replaceRange(this,"",clipPos(this,Pos(line-1)),clipPos(this,Pos(line))):replaceRange(this,"",Pos(0,0),clipPos(this,Pos(1,0)))},getLineHandle:function(line){return isLine(this,line)?getLine(this,line):void 0},getLineNumber:function(line){return lineNo(line)},getLineHandleVisualStart:function(line){return"number"==typeof line&&(line=getLine(this,line)),visualLine(this,line)},lineCount:function(){return this.size},firstLine:function(){return this.first},lastLine:function(){return this.first+this.size-1},clipPos:function(pos){return clipPos(this,pos)},getCursor:function(start){var pos,sel=this.sel;return pos=null==start||"head"==start?sel.head:"anchor"==start?sel.anchor:"end"==start||start===!1?sel.to:sel.from,copyPos(pos)},somethingSelected:function(){return!posEq(this.sel.head,this.sel.anchor)},setCursor:docOperation(function(line,ch,extend){var pos=clipPos(this,"number"==typeof line?Pos(line,ch||0):line);extend?extendSelection(this,pos):setSelection(this,pos,pos)}),setSelection:docOperation(function(anchor,head){setSelection(this,clipPos(this,anchor),clipPos(this,head||anchor))}),extendSelection:docOperation(function(from,to){extendSelection(this,clipPos(this,from),to&&clipPos(this,to))}),getSelection:function(lineSep){return this.getRange(this.sel.from,this.sel.to,lineSep)},replaceSelection:function(code,collapse,origin){makeChange(this,{from:this.sel.from,to:this.sel.to,text:splitLines(code),origin:origin},collapse||"around")},undo:docOperation(function(){makeChangeFromHistory(this,"undo")}),redo:docOperation(function(){makeChangeFromHistory(this,"redo")}),setExtending:function(val){this.sel.extend=val},historySize:function(){var hist=this.history;return{undo:hist.done.length,redo:hist.undone.length}},clearHistory:function(){this.history=makeHistory(this.history.maxGeneration)},markClean:function(){this.cleanGeneration=this.changeGeneration()},changeGeneration:function(){return this.history.lastOp=this.history.lastOrigin=null,this.history.generation},isClean:function(gen){return this.history.generation==(gen||this.cleanGeneration)},getHistory:function(){return{done:copyHistoryArray(this.history.done),undone:copyHistoryArray(this.history.undone)}},setHistory:function(histData){var hist=this.history=makeHistory(this.history.maxGeneration);hist.done=histData.done.slice(0),hist.undone=histData.undone.slice(0)},markText:function(from,to,options){return markText(this,clipPos(this,from),clipPos(this,to),options,"range")},setBookmark:function(pos,options){var realOpts={replacedWith:options&&(null==options.nodeType?options.widget:options),insertLeft:options&&options.insertLeft};return pos=clipPos(this,pos),markText(this,pos,pos,realOpts,"bookmark")},findMarksAt:function(pos){pos=clipPos(this,pos);var markers=[],spans=getLine(this,pos.line).markedSpans;if(spans)for(var i=0;i<spans.length;++i){var span=spans[i];(null==span.from||span.from<=pos.ch)&&(null==span.to||span.to>=pos.ch)&&markers.push(span.marker.parent||span.marker)}return markers},getAllMarks:function(){var markers=[];return this.iter(function(line){var sps=line.markedSpans;if(sps)for(var i=0;i<sps.length;++i)null!=sps[i].from&&markers.push(sps[i].marker)}),markers},posFromIndex:function(off){var ch,lineNo=this.first;return this.iter(function(line){var sz=line.text.length+1;return sz>off?(ch=off,!0):(off-=sz,void++lineNo)}),clipPos(this,Pos(lineNo,ch))},indexFromPos:function(coords){coords=clipPos(this,coords);var index=coords.ch;return coords.line<this.first||coords.ch<0?0:(this.iter(this.first,coords.line,function(line){index+=line.text.length+1}),index)},copy:function(copyHistory){var doc=new Doc(getLines(this,this.first,this.first+this.size),this.modeOption,this.first);return doc.scrollTop=this.scrollTop,doc.scrollLeft=this.scrollLeft,doc.sel={from:this.sel.from,to:this.sel.to,head:this.sel.head,anchor:this.sel.anchor,shift:this.sel.shift,extend:!1,goalColumn:this.sel.goalColumn},copyHistory&&(doc.history.undoDepth=this.history.undoDepth,doc.setHistory(this.getHistory())),doc},linkedDoc:function(options){options||(options={});var from=this.first,to=this.first+this.size;null!=options.from&&options.from>from&&(from=options.from),null!=options.to&&options.to<to&&(to=options.to);var copy=new Doc(getLines(this,from,to),options.mode||this.modeOption,from);return options.sharedHist&&(copy.history=this.history),(this.linked||(this.linked=[])).push({doc:copy,sharedHist:options.sharedHist}),copy.linked=[{doc:this,isParent:!0,sharedHist:options.sharedHist}],copy},unlinkDoc:function(other){if(other instanceof CodeMirror&&(other=other.doc),this.linked)for(var i=0;i<this.linked.length;++i){var link=this.linked[i];if(link.doc==other){this.linked.splice(i,1),other.unlinkDoc(this);break}}if(other.history==this.history){var splitIds=[other.id];linkedDocs(other,function(doc){splitIds.push(doc.id)},!0),other.history=makeHistory(),other.history.done=copyHistoryArray(this.history.done,splitIds),other.history.undone=copyHistoryArray(this.history.undone,splitIds)}},iterLinkedDocs:function(f){linkedDocs(this,f)},getMode:function(){return this.mode},getEditor:function(){return this.cm}}),Doc.prototype.eachLine=Doc.prototype.iter;var dontDelegate="iter insert remove copy getEditor".split(" ");for(var prop in Doc.prototype)Doc.prototype.hasOwnProperty(prop)&&indexOf(dontDelegate,prop)<0&&(CodeMirror.prototype[prop]=function(method){return function(){return method.apply(this.doc,arguments)}}(Doc.prototype[prop]));eventMixin(Doc),CodeMirror.e_stop=e_stop,CodeMirror.e_preventDefault=e_preventDefault,CodeMirror.e_stopPropagation=e_stopPropagation;var delayedCallbacks,delayedCallbackDepth=0;CodeMirror.on=on,CodeMirror.off=off,CodeMirror.signal=signal;var scrollerCutOff=30,Pass=CodeMirror.Pass={toString:function(){return"CodeMirror.Pass"}};Delayed.prototype={set:function(ms,f){clearTimeout(this.id),this.id=setTimeout(f,ms)}},CodeMirror.countColumn=countColumn;var spaceStrs=[""],nonASCIISingleCaseWordChar=/[\u3040-\u309f\u30a0-\u30ff\u3400-\u4db5\u4e00-\u9fcc\uac00-\ud7af]/,isExtendingChar=/[\u0300-\u036F\u0483-\u0487\u0488-\u0489\u0591-\u05BD\u05BF\u05C1-\u05C2\u05C4-\u05C5\u05C7\u0610-\u061A\u064B-\u065F\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7-\u06E8\u06EA-\u06ED\uA66F\uA670-\uA672\uA674-\uA67D\uA69F\udc00-\udfff]/;CodeMirror.replaceGetRect=function(f){getRect=f};var dragAndDrop=function(){if(ie_lt9)return!1;var div=elt("div");return"draggable"in div||"dragDrop"in div}();gecko?spanAffectsWrapping=function(str,i){return 36==str.charCodeAt(i-1)&&39==str.charCodeAt(i)}:safari&&!/Version\/([6-9]|\d\d)\b/.test(navigator.userAgent)?spanAffectsWrapping=function(str,i){return/\-[^ \-?]|\?[^ !\'\"\),.\-\/:;\?\]\}]/.test(str.slice(i-1,i+1))}:webkit&&!/Chrome\/(?:29|[3-9]\d|\d\d\d)\./.test(navigator.userAgent)&&(spanAffectsWrapping=function(str,i){if(i>1&&45==str.charCodeAt(i-1)){if(/\w/.test(str.charAt(i-2))&&/[^\-?\.]/.test(str.charAt(i)))return!0;if(i>2&&/[\d\.,]/.test(str.charAt(i-2))&&/[\d\.,]/.test(str.charAt(i)))return!1}return/[~!#%&*)=+}\]|\"\.>,:;][({[<]|-[^\-?\.\u2010-\u201f\u2026]|\?[\w~`@#$%\^&*(_=+{[|><]|…[\w~`@#$%\^&*(_=+{[><]/.test(str.slice(i-1,i+1))});var knownScrollbarWidth,zwspSupported,splitLines=3!="\n\nb".split(/\n/).length?function(string){for(var pos=0,result=[],l=string.length;l>=pos;){var nl=string.indexOf("\n",pos);-1==nl&&(nl=string.length);var line=string.slice(pos,"\r"==string.charAt(nl-1)?nl-1:nl),rt=line.indexOf("\r");-1!=rt?(result.push(line.slice(0,rt)),pos+=rt+1):(result.push(line),pos=nl+1)}return result}:function(string){return string.split(/\r\n?|\n/)};CodeMirror.splitLines=splitLines;var hasSelection=window.getSelection?function(te){try{return te.selectionStart!=te.selectionEnd}catch(e){return!1}}:function(te){try{var range=te.ownerDocument.selection.createRange()}catch(e){}return range&&range.parentElement()==te?0!=range.compareEndPoints("StartToEnd",range):!1},hasCopyEvent=function(){var e=elt("div");return"oncopy"in e?!0:(e.setAttribute("oncopy","return;"),"function"==typeof e.oncopy)}(),keyNames={3:"Enter",8:"Backspace",9:"Tab",13:"Enter",16:"Shift",17:"Ctrl",18:"Alt",19:"Pause",20:"CapsLock",27:"Esc",32:"Space",33:"PageUp",34:"PageDown",35:"End",36:"Home",37:"Left",38:"Up",39:"Right",40:"Down",44:"PrintScrn",45:"Insert",46:"Delete",59:";",91:"Mod",92:"Mod",93:"Mod",109:"-",107:"=",127:"Delete",186:";",187:"=",188:",",189:"-",190:".",191:"/",192:"`",219:"[",220:"\\",221:"]",222:"'",63276:"PageUp",63277:"PageDown",63275:"End",63273:"Home",63234:"Left",63232:"Up",63235:"Right",63233:"Down",63302:"Insert",63272:"Delete"};CodeMirror.keyNames=keyNames,function(){for(var i=0;10>i;i++)keyNames[i+48]=String(i);for(var i=65;90>=i;i++)keyNames[i]=String.fromCharCode(i);for(var i=1;12>=i;i++)keyNames[i+111]=keyNames[i+63235]="F"+i}();var bidiOther,bidiOrdering=function(){function charType(code){return 255>=code?lowTypes.charAt(code):code>=1424&&1524>=code?"R":code>=1536&&1791>=code?arabicTypes.charAt(code-1536):code>=1792&&2220>=code?"r":"L"}var lowTypes="bbbbbbbbbtstwsbbbbbbbbbbbbbbssstwNN%%%NNNNNN,N,N1111111111NNNNNNNLLLLLLLLLLLLLLLLLLLLLLLLLLNNNNNNLLLLLLLLLLLLLLLLLLLLLLLLLLNNNNbbbbbbsbbbbbbbbbbbbbbbbbbbbbbbbbb,N%%%%NNNNLNNNNN%%11NLNNN1LNNNNNLLLLLLLLLLLLLLLLLLLLLLLNLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLNLLLLLLLL",arabicTypes="rrrrrrrrrrrr,rNNmmmmmmrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrmmmmmmmmmmmmmmrrrrrrrnnnnnnnnnn%nnrrrmrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrmmmmmmmmmmmmmmmmmmmNmmmmrrrrrrrrrrrrrrrrrr",bidiRE=/[\u0590-\u05f4\u0600-\u06ff\u0700-\u08ac]/,isNeutral=/[stwN]/,isStrong=/[LRr]/,countsAsLeft=/[Lb1n]/,countsAsNum=/[1n]/,outerType="L";return function(str){if(!bidiRE.test(str))return!1;for(var type,len=str.length,types=[],i=0;len>i;++i)types.push(type=charType(str.charCodeAt(i)));for(var i=0,prev=outerType;len>i;++i){var type=types[i];"m"==type?types[i]=prev:prev=type}for(var i=0,cur=outerType;len>i;++i){var type=types[i];"1"==type&&"r"==cur?types[i]="n":isStrong.test(type)&&(cur=type,"r"==type&&(types[i]="R"))}for(var i=1,prev=types[0];len-1>i;++i){var type=types[i];"+"==type&&"1"==prev&&"1"==types[i+1]?types[i]="1":","!=type||prev!=types[i+1]||"1"!=prev&&"n"!=prev||(types[i]=prev),prev=type}for(var i=0;len>i;++i){var type=types[i];if(","==type)types[i]="N";else if("%"==type){for(var end=i+1;len>end&&"%"==types[end];++end);for(var replace=i&&"!"==types[i-1]||len-1>end&&"1"==types[end]?"1":"N",j=i;end>j;++j)types[j]=replace;
i=end-1}}for(var i=0,cur=outerType;len>i;++i){var type=types[i];"L"==cur&&"1"==type?types[i]="L":isStrong.test(type)&&(cur=type)}for(var i=0;len>i;++i)if(isNeutral.test(types[i])){for(var end=i+1;len>end&&isNeutral.test(types[end]);++end);for(var before="L"==(i?types[i-1]:outerType),after="L"==(len-1>end?types[end]:outerType),replace=before||after?"L":"R",j=i;end>j;++j)types[j]=replace;i=end-1}for(var m,order=[],i=0;len>i;)if(countsAsLeft.test(types[i])){var start=i;for(++i;len>i&&countsAsLeft.test(types[i]);++i);order.push({from:start,to:i,level:0})}else{var pos=i,at=order.length;for(++i;len>i&&"L"!=types[i];++i);for(var j=pos;i>j;)if(countsAsNum.test(types[j])){j>pos&&order.splice(at,0,{from:pos,to:j,level:1});var nstart=j;for(++j;i>j&&countsAsNum.test(types[j]);++j);order.splice(at,0,{from:nstart,to:j,level:2}),pos=j}else++j;i>pos&&order.splice(at,0,{from:pos,to:i,level:1})}return 1==order[0].level&&(m=str.match(/^\s+/))&&(order[0].from=m[0].length,order.unshift({from:0,to:m[0].length,level:0})),1==lst(order).level&&(m=str.match(/\s+$/))&&(lst(order).to-=m[0].length,order.push({from:len-m[0].length,to:len,level:0})),order[0].level!=lst(order).level&&order.push({from:len,to:len,level:order[0].level}),order}}();return CodeMirror.version="3.15.0",CodeMirror}(),CodeMirror.defineMode("javascript",function(config,parserConfig){function chain(stream,state,f){return state.tokenize=f,f(stream,state)}function nextUntilUnescaped(stream,end){for(var next,escaped=!1;null!=(next=stream.next());){if(next==end&&!escaped)return!1;escaped=!escaped&&"\\"==next}return escaped}function ret(tp,style,cont){return type=tp,content=cont,style}function jsTokenBase(stream,state){var ch=stream.next();if('"'==ch||"'"==ch)return chain(stream,state,jsTokenString(ch));if(/[\[\]{}\(\),;\:\.]/.test(ch))return ret(ch);if("0"==ch&&stream.eat(/x/i))return stream.eatWhile(/[\da-f]/i),ret("number","number");if(/\d/.test(ch)||"-"==ch&&stream.eat(/\d/))return stream.match(/^\d*(?:\.\d*)?(?:[eE][+\-]?\d+)?/),ret("number","number");if("/"==ch)return stream.eat("*")?chain(stream,state,jsTokenComment):stream.eat("/")?(stream.skipToEnd(),ret("comment","comment")):"operator"==state.lastType||"keyword c"==state.lastType||/^[\[{}\(,;:]$/.test(state.lastType)?(nextUntilUnescaped(stream,"/"),stream.eatWhile(/[gimy]/),ret("regexp","string-2")):(stream.eatWhile(isOperatorChar),ret("operator",null,stream.current()));if("#"==ch)return stream.skipToEnd(),ret("error","error");if(isOperatorChar.test(ch))return stream.eatWhile(isOperatorChar),ret("operator",null,stream.current());stream.eatWhile(/[\w\$_]/);var word=stream.current(),known=keywords.propertyIsEnumerable(word)&&keywords[word];return known&&"."!=state.lastType?ret(known.type,known.style,word):ret("variable","variable",word)}function jsTokenString(quote){return function(stream,state){return nextUntilUnescaped(stream,quote)||(state.tokenize=jsTokenBase),ret("string","string")}}function jsTokenComment(stream,state){for(var ch,maybeEnd=!1;ch=stream.next();){if("/"==ch&&maybeEnd){state.tokenize=jsTokenBase;break}maybeEnd="*"==ch}return ret("comment","comment")}function JSLexical(indented,column,type,align,prev,info){this.indented=indented,this.column=column,this.type=type,this.prev=prev,this.info=info,null!=align&&(this.align=align)}function inScope(state,varname){for(var v=state.localVars;v;v=v.next)if(v.name==varname)return!0}function parseJS(state,style,type,content,stream){var cc=state.cc;for(cx.state=state,cx.stream=stream,cx.marked=null,cx.cc=cc,state.lexical.hasOwnProperty("align")||(state.lexical.align=!0);;){var combinator=cc.length?cc.pop():jsonMode?expression:statement;if(combinator(type,content)){for(;cc.length&&cc[cc.length-1].lex;)cc.pop()();return cx.marked?cx.marked:"variable"==type&&inScope(state,content)?"variable-2":style}}}function pass(){for(var i=arguments.length-1;i>=0;i--)cx.cc.push(arguments[i])}function cont(){return pass.apply(null,arguments),!0}function register(varname){function inList(list){for(var v=list;v;v=v.next)if(v.name==varname)return!0;return!1}var state=cx.state;if(state.context){if(cx.marked="def",inList(state.localVars))return;state.localVars={name:varname,next:state.localVars}}else{if(inList(state.globalVars))return;state.globalVars={name:varname,next:state.globalVars}}}function pushcontext(){cx.state.context={prev:cx.state.context,vars:cx.state.localVars},cx.state.localVars=defaultVars}function popcontext(){cx.state.localVars=cx.state.context.vars,cx.state.context=cx.state.context.prev}function pushlex(type,info){var result=function(){var state=cx.state,indent=state.indented;"stat"==state.lexical.type&&(indent=state.lexical.indented),state.lexical=new JSLexical(indent,cx.stream.column(),type,null,state.lexical,info)};return result.lex=!0,result}function poplex(){var state=cx.state;state.lexical.prev&&(")"==state.lexical.type&&(state.indented=state.lexical.indented),state.lexical=state.lexical.prev)}function expect(wanted){return function(type){return type==wanted?cont():";"==wanted?pass():cont(arguments.callee)}}function statement(type){return"var"==type?cont(pushlex("vardef"),vardef1,expect(";"),poplex):"keyword a"==type?cont(pushlex("form"),expression,statement,poplex):"keyword b"==type?cont(pushlex("form"),statement,poplex):"{"==type?cont(pushlex("}"),block,poplex):";"==type?cont():"if"==type?cont(pushlex("form"),expression,statement,poplex,maybeelse):"function"==type?cont(functiondef):"for"==type?cont(pushlex("form"),expect("("),pushlex(")"),forspec1,expect(")"),poplex,statement,poplex):"variable"==type?cont(pushlex("stat"),maybelabel):"switch"==type?cont(pushlex("form"),expression,pushlex("}","switch"),expect("{"),block,poplex,poplex):"case"==type?cont(expression,expect(":")):"default"==type?cont(expect(":")):"catch"==type?cont(pushlex("form"),pushcontext,expect("("),funarg,expect(")"),statement,poplex,popcontext):pass(pushlex("stat"),expression,expect(";"),poplex)}function expression(type){return expressionInner(type,!1)}function expressionNoComma(type){return expressionInner(type,!0)}function expressionInner(type,noComma){var maybeop=noComma?maybeoperatorNoComma:maybeoperatorComma;return atomicTypes.hasOwnProperty(type)?cont(maybeop):"function"==type?cont(functiondef):"keyword c"==type?cont(noComma?maybeexpressionNoComma:maybeexpression):"("==type?cont(pushlex(")"),maybeexpression,expect(")"),poplex,maybeop):"operator"==type?cont(noComma?expressionNoComma:expression):"["==type?cont(pushlex("]"),commasep(expressionNoComma,"]"),poplex,maybeop):"{"==type?cont(pushlex("}"),commasep(objprop,"}"),poplex,maybeop):cont()}function maybeexpression(type){return type.match(/[;\}\)\],]/)?pass():pass(expression)}function maybeexpressionNoComma(type){return type.match(/[;\}\)\],]/)?pass():pass(expressionNoComma)}function maybeoperatorComma(type,value){return","==type?cont(expression):maybeoperatorNoComma(type,value,!1)}function maybeoperatorNoComma(type,value,noComma){var me=0==noComma?maybeoperatorComma:maybeoperatorNoComma,expr=0==noComma?expression:expressionNoComma;return"operator"==type?/\+\+|--/.test(value)?cont(me):"?"==value?cont(expression,expect(":"),expr):cont(expr):";"!=type?"("==type?cont(pushlex(")","call"),commasep(expressionNoComma,")"),poplex,me):"."==type?cont(property,me):"["==type?cont(pushlex("]"),maybeexpression,expect("]"),poplex,me):void 0:void 0}function maybelabel(type){return":"==type?cont(poplex,statement):pass(maybeoperatorComma,expect(";"),poplex)}function property(type){return"variable"==type?(cx.marked="property",cont()):void 0}function objprop(type,value){if("variable"==type){if(cx.marked="property","get"==value||"set"==value)return cont(getterSetter)}else("number"==type||"string"==type)&&(cx.marked=type+" property");return atomicTypes.hasOwnProperty(type)?cont(expect(":"),expressionNoComma):void 0}function getterSetter(type){return":"==type?cont(expression):"variable"!=type?cont(expect(":"),expression):(cx.marked="property",cont(functiondef))}function commasep(what,end){function proceed(type){if(","==type){var lex=cx.state.lexical;return"call"==lex.info&&(lex.pos=(lex.pos||0)+1),cont(what,proceed)}return type==end?cont():cont(expect(end))}return function(type){return type==end?cont():pass(what,proceed)}}function block(type){return"}"==type?cont():pass(statement,block)}function maybetype(type){return":"==type?cont(typedef):pass()}function typedef(type){return"variable"==type?(cx.marked="variable-3",cont()):pass()}function vardef1(type,value){return"variable"==type?(register(value),isTS?cont(maybetype,vardef2):cont(vardef2)):pass()}function vardef2(type,value){return"="==value?cont(expressionNoComma,vardef2):","==type?cont(vardef1):void 0}function maybeelse(type,value){return"keyword b"==type&&"else"==value?cont(pushlex("form"),statement,poplex):void 0}function forspec1(type){return"var"==type?cont(vardef1,expect(";"),forspec2):";"==type?cont(forspec2):"variable"==type?cont(formaybein):pass(expression,expect(";"),forspec2)}function formaybein(_type,value){return"in"==value?cont(expression):cont(maybeoperatorComma,forspec2)}function forspec2(type,value){return";"==type?cont(forspec3):"in"==value?cont(expression):pass(expression,expect(";"),forspec3)}function forspec3(type){")"!=type&&cont(expression)}function functiondef(type,value){return"variable"==type?(register(value),cont(functiondef)):"("==type?cont(pushlex(")"),pushcontext,commasep(funarg,")"),poplex,statement,popcontext):void 0}function funarg(type,value){return"variable"==type?(register(value),isTS?cont(maybetype):cont()):void 0}var type,content,indentUnit=config.indentUnit,statementIndent=parserConfig.statementIndent,jsonMode=parserConfig.json,isTS=parserConfig.typescript,keywords=function(){function kw(type){return{type:type,style:"keyword"}}var A=kw("keyword a"),B=kw("keyword b"),C=kw("keyword c"),operator=kw("operator"),atom={type:"atom",style:"atom"},jsKeywords={"if":kw("if"),"while":A,"with":A,"else":B,"do":B,"try":B,"finally":B,"return":C,"break":C,"continue":C,"new":C,"delete":C,"throw":C,"var":kw("var"),"const":kw("var"),let:kw("var"),"function":kw("function"),"catch":kw("catch"),"for":kw("for"),"switch":kw("switch"),"case":kw("case"),"default":kw("default"),"in":operator,"typeof":operator,"instanceof":operator,"true":atom,"false":atom,"null":atom,undefined:atom,NaN:atom,Infinity:atom,"this":kw("this")};if(isTS){var type={type:"variable",style:"variable-3"},tsKeywords={"interface":kw("interface"),"class":kw("class"),"extends":kw("extends"),constructor:kw("constructor"),"public":kw("public"),"private":kw("private"),"protected":kw("protected"),"static":kw("static"),"super":kw("super"),string:type,number:type,bool:type,any:type};for(var attr in tsKeywords)jsKeywords[attr]=tsKeywords[attr]}return jsKeywords}(),isOperatorChar=/[+\-*&%=<>!?|~^]/,atomicTypes={atom:!0,number:!0,variable:!0,string:!0,regexp:!0,"this":!0},cx={state:null,column:null,marked:null,cc:null},defaultVars={name:"this",next:{name:"arguments"}};return poplex.lex=!0,{startState:function(basecolumn){return{tokenize:jsTokenBase,lastType:null,cc:[],lexical:new JSLexical((basecolumn||0)-indentUnit,0,"block",!1),localVars:parserConfig.localVars,globalVars:parserConfig.globalVars,context:parserConfig.localVars&&{vars:parserConfig.localVars},indented:0}},token:function(stream,state){if(stream.sol()&&(state.lexical.hasOwnProperty("align")||(state.lexical.align=!1),state.indented=stream.indentation()),state.tokenize!=jsTokenComment&&stream.eatSpace())return null;var style=state.tokenize(stream,state);return"comment"==type?style:(state.lastType="operator"!=type||"++"!=content&&"--"!=content?type:"incdec",parseJS(state,style,type,content,stream))},indent:function(state,textAfter){if(state.tokenize==jsTokenComment)return CodeMirror.Pass;if(state.tokenize!=jsTokenBase)return 0;for(var firstChar=textAfter&&textAfter.charAt(0),lexical=state.lexical,i=state.cc.length-1;i>=0;--i){var c=state.cc[i];if(c==poplex)lexical=lexical.prev;else if(c!=maybeelse||/^else\b/.test(textAfter))break}"stat"==lexical.type&&"}"==firstChar&&(lexical=lexical.prev),statementIndent&&")"==lexical.type&&"stat"==lexical.prev.type&&(lexical=lexical.prev);var type=lexical.type,closing=firstChar==type;return"vardef"==type?lexical.indented+("operator"==state.lastType||","==state.lastType?4:0):"form"==type&&"{"==firstChar?lexical.indented:"form"==type?lexical.indented+indentUnit:"stat"==type?lexical.indented+("operator"==state.lastType||","==state.lastType?statementIndent||indentUnit:0):"switch"!=lexical.info||closing||0==parserConfig.doubleIndentSwitch?lexical.align?lexical.column+(closing?0:1):lexical.indented+(closing?0:indentUnit):lexical.indented+(/^(?:case|default)\b/.test(textAfter)?indentUnit:2*indentUnit)},electricChars:":{}",blockCommentStart:jsonMode?null:"/*",blockCommentEnd:jsonMode?null:"*/",lineComment:jsonMode?null:"//",fold:"brace",helperType:jsonMode?"json":"javascript",jsonMode:jsonMode}}),CodeMirror.defineMIME("text/javascript","javascript"),CodeMirror.defineMIME("text/ecmascript","javascript"),CodeMirror.defineMIME("application/javascript","javascript"),CodeMirror.defineMIME("application/ecmascript","javascript"),CodeMirror.defineMIME("application/json",{name:"javascript",json:!0}),CodeMirror.defineMIME("application/x-json",{name:"javascript",json:!0}),CodeMirror.defineMIME("text/typescript",{name:"javascript",typescript:!0}),CodeMirror.defineMIME("application/typescript",{name:"javascript",typescript:!0}),CodeMirror.defineMode("xml",function(config,parserConfig){function inText(stream,state){function chain(parser){return state.tokenize=parser,parser(stream,state)}var ch=stream.next();if("<"==ch){if(stream.eat("!"))return stream.eat("[")?stream.match("CDATA[")?chain(inBlock("atom","]]>")):null:stream.match("--")?chain(inBlock("comment","-->")):stream.match("DOCTYPE",!0,!0)?(stream.eatWhile(/[\w\._\-]/),chain(doctype(1))):null;if(stream.eat("?"))return stream.eatWhile(/[\w\._\-]/),state.tokenize=inBlock("meta","?>"),"meta";var isClose=stream.eat("/");tagName="";for(var c;c=stream.eat(/[^\s\u00a0=<>\"\'\/?]/);)tagName+=c;return tagName?(type=isClose?"closeTag":"openTag",state.tokenize=inTag,"tag"):"error"}if("&"==ch){var ok;return ok=stream.eat("#")?stream.eat("x")?stream.eatWhile(/[a-fA-F\d]/)&&stream.eat(";"):stream.eatWhile(/[\d]/)&&stream.eat(";"):stream.eatWhile(/[\w\.\-:]/)&&stream.eat(";"),ok?"atom":"error"}return stream.eatWhile(/[^&<]/),null}function inTag(stream,state){var ch=stream.next();return">"==ch||"/"==ch&&stream.eat(">")?(state.tokenize=inText,type=">"==ch?"endTag":"selfcloseTag","tag"):"="==ch?(type="equals",null):"<"==ch?"error":/[\'\"]/.test(ch)?(state.tokenize=inAttribute(ch),state.stringStartCol=stream.column(),state.tokenize(stream,state)):(stream.eatWhile(/[^\s\u00a0=<>\"\']/),"word")}function inAttribute(quote){var closure=function(stream,state){for(;!stream.eol();)if(stream.next()==quote){state.tokenize=inTag;break}return"string"};return closure.isInAttribute=!0,closure}function inBlock(style,terminator){return function(stream,state){for(;!stream.eol();){if(stream.match(terminator)){state.tokenize=inText;break}stream.next()}return style}}function doctype(depth){return function(stream,state){for(var ch;null!=(ch=stream.next());){if("<"==ch)return state.tokenize=doctype(depth+1),state.tokenize(stream,state);if(">"==ch){if(1==depth){state.tokenize=inText;break}return state.tokenize=doctype(depth-1),state.tokenize(stream,state)}}return"meta"}}function pass(){for(var i=arguments.length-1;i>=0;i--)curState.cc.push(arguments[i])}function cont(){return pass.apply(null,arguments),!0}function pushContext(tagName,startOfLine){var noIndent=Kludges.doNotIndent.hasOwnProperty(tagName)||curState.context&&curState.context.noIndent;curState.context={prev:curState.context,tagName:tagName,indent:curState.indented,startOfLine:startOfLine,noIndent:noIndent}}function popContext(){curState.context&&(curState.context=curState.context.prev)}function element(type){if("openTag"==type)return curState.tagName=tagName,curState.tagStart=curStream.column(),cont(attributes,endtag(curState.startOfLine));if("closeTag"==type){var err=!1;return curState.context?curState.context.tagName!=tagName&&(Kludges.implicitlyClosed.hasOwnProperty(curState.context.tagName.toLowerCase())&&popContext(),err=!curState.context||curState.context.tagName!=tagName):err=!0,err&&(setStyle="error"),cont(endclosetag(err))}return cont()}function endtag(startOfLine){return function(type){var tagName=curState.tagName;return curState.tagName=curState.tagStart=null,"selfcloseTag"==type||"endTag"==type&&Kludges.autoSelfClosers.hasOwnProperty(tagName.toLowerCase())?(maybePopContext(tagName.toLowerCase()),cont()):"endTag"==type?(maybePopContext(tagName.toLowerCase()),pushContext(tagName,startOfLine),cont()):cont()}}function endclosetag(err){return function(type){return err&&(setStyle="error"),"endTag"==type?(popContext(),cont()):(setStyle="error",cont(arguments.callee))}}function maybePopContext(nextTagName){for(var parentTagName;;){if(!curState.context)return;if(parentTagName=curState.context.tagName.toLowerCase(),!Kludges.contextGrabbers.hasOwnProperty(parentTagName)||!Kludges.contextGrabbers[parentTagName].hasOwnProperty(nextTagName))return;popContext()}}function attributes(type){return"word"==type?(setStyle="attribute",cont(attribute,attributes)):"endTag"==type||"selfcloseTag"==type?pass():(setStyle="error",cont(attributes))}function attribute(type){return"equals"==type?cont(attvalue,attributes):(Kludges.allowMissing?"word"==type&&(setStyle="attribute"):setStyle="error","endTag"==type||"selfcloseTag"==type?pass():cont())}function attvalue(type){return"string"==type?cont(attvaluemaybe):"word"==type&&Kludges.allowUnquoted?(setStyle="string",cont()):(setStyle="error","endTag"==type||"selfCloseTag"==type?pass():cont())}function attvaluemaybe(type){return"string"==type?cont(attvaluemaybe):pass()}var tagName,type,curState,curStream,setStyle,indentUnit=config.indentUnit,multilineTagIndentFactor=parserConfig.multilineTagIndentFactor||1,multilineTagIndentPastTag=parserConfig.multilineTagIndentPastTag||!0,Kludges=parserConfig.htmlMode?{autoSelfClosers:{area:!0,base:!0,br:!0,col:!0,command:!0,embed:!0,frame:!0,hr:!0,img:!0,input:!0,keygen:!0,link:!0,meta:!0,param:!0,source:!0,track:!0,wbr:!0},implicitlyClosed:{dd:!0,li:!0,optgroup:!0,option:!0,p:!0,rp:!0,rt:!0,tbody:!0,td:!0,tfoot:!0,th:!0,tr:!0},contextGrabbers:{dd:{dd:!0,dt:!0},dt:{dd:!0,dt:!0},li:{li:!0},option:{option:!0,optgroup:!0},optgroup:{optgroup:!0},p:{address:!0,article:!0,aside:!0,blockquote:!0,dir:!0,div:!0,dl:!0,fieldset:!0,footer:!0,form:!0,h1:!0,h2:!0,h3:!0,h4:!0,h5:!0,h6:!0,header:!0,hgroup:!0,hr:!0,menu:!0,nav:!0,ol:!0,p:!0,pre:!0,section:!0,table:!0,ul:!0},rp:{rp:!0,rt:!0},rt:{rp:!0,rt:!0},tbody:{tbody:!0,tfoot:!0},td:{td:!0,th:!0},tfoot:{tbody:!0},th:{td:!0,th:!0},thead:{tbody:!0,tfoot:!0},tr:{tr:!0}},doNotIndent:{pre:!0},allowUnquoted:!0,allowMissing:!0}:{autoSelfClosers:{},implicitlyClosed:{},contextGrabbers:{},doNotIndent:{},allowUnquoted:!1,allowMissing:!1},alignCDATA=parserConfig.alignCDATA;return{startState:function(){return{tokenize:inText,cc:[],indented:0,startOfLine:!0,tagName:null,tagStart:null,context:null}},token:function(stream,state){if(!state.tagName&&stream.sol()&&(state.startOfLine=!0,state.indented=stream.indentation()),stream.eatSpace())return null;setStyle=type=tagName=null;var style=state.tokenize(stream,state);if(state.type=type,(style||type)&&"comment"!=style)for(curState=state,curStream=stream;;){var comb=state.cc.pop()||element;if(comb(type||style))break}return state.startOfLine=!1,setStyle||style},indent:function(state,textAfter,fullLine){var context=state.context;if(state.tokenize.isInAttribute)return state.stringStartCol+1;if(state.tokenize!=inTag&&state.tokenize!=inText||context&&context.noIndent)return fullLine?fullLine.match(/^(\s*)/)[0].length:0;if(state.tagName)return multilineTagIndentPastTag?state.tagStart+state.tagName.length+2:state.tagStart+indentUnit*multilineTagIndentFactor;if(alignCDATA&&/<!\[CDATA\[/.test(textAfter))return 0;for(context&&/^<\//.test(textAfter)&&(context=context.prev);context&&!context.startOfLine;)context=context.prev;return context?context.indent+indentUnit:0},electricChars:"/",blockCommentStart:"<!--",blockCommentEnd:"-->",configuration:parserConfig.htmlMode?"html":"xml",helperType:parserConfig.htmlMode?"html":"xml"}}),CodeMirror.defineMIME("text/xml","xml"),CodeMirror.defineMIME("application/xml","xml"),CodeMirror.mimeModes.hasOwnProperty("text/html")||CodeMirror.defineMIME("text/html",{name:"xml",htmlMode:!0}),CodeMirror.defineMode("yaml",function(){var cons=["true","false","on","off","yes","no"],keywordRegex=new RegExp("\\b(("+cons.join(")|(")+"))$","i");return{token:function(stream,state){var ch=stream.peek(),esc=state.escaped;if(state.escaped=!1,"#"==ch&&(0==stream.pos||/\s/.test(stream.string.charAt(stream.pos-1))))return stream.skipToEnd(),"comment";if(state.literal&&stream.indentation()>state.keyCol)return stream.skipToEnd(),"string";if(state.literal&&(state.literal=!1),stream.sol()){if(state.keyCol=0,state.pair=!1,state.pairStart=!1,stream.match(/---/))return"def";if(stream.match(/\.\.\./))return"def";if(stream.match(/\s*-\s+/))return"meta"}if(!state.pair&&stream.match(/^\s*([a-z0-9\._-])+(?=\s*:)/i))return state.pair=!0,state.keyCol=stream.indentation(),"atom";if(state.pair&&stream.match(/^:\s*/))return state.pairStart=!0,"meta";if(stream.match(/^(\{|\}|\[|\])/))return"{"==ch?state.inlinePairs++:"}"==ch?state.inlinePairs--:"["==ch?state.inlineList++:state.inlineList--,"meta";if(state.inlineList>0&&!esc&&","==ch)return stream.next(),"meta";if(state.inlinePairs>0&&!esc&&","==ch)return state.keyCol=0,state.pair=!1,state.pairStart=!1,stream.next(),"meta";if(state.pairStart){if(stream.match(/^\s*(\||\>)\s*/))return state.literal=!0,"meta";if(stream.match(/^\s*(\&|\*)[a-z0-9\._-]+\b/i))return"variable-2";if(0==state.inlinePairs&&stream.match(/^\s*-?[0-9\.\,]+\s?$/))return"number";if(state.inlinePairs>0&&stream.match(/^\s*-?[0-9\.\,]+\s?(?=(,|}))/))return"number";if(stream.match(keywordRegex))return"keyword"}return state.pairStart=!1,state.escaped="\\"==ch,stream.next(),null},startState:function(){return{pair:!1,pairStart:!1,keyCol:0,inlinePairs:0,inlineList:0,literal:!1,escaped:!1}}}}),CodeMirror.defineMIME("text/x-yaml","yaml"),function(){function dialogDiv(cm,template,bottom){var dialog,wrap=cm.getWrapperElement();return dialog=wrap.appendChild(document.createElement("div")),bottom?dialog.className="CodeMirror-dialog CodeMirror-dialog-bottom":dialog.className="CodeMirror-dialog CodeMirror-dialog-top",dialog.innerHTML=template,dialog}CodeMirror.defineExtension("openDialog",function(template,callback,options){function close(){closed||(closed=!0,dialog.parentNode.removeChild(dialog))}var button,dialog=dialogDiv(this,template,options&&options.bottom),closed=!1,me=this,inp=dialog.getElementsByTagName("input")[0];return inp?(CodeMirror.on(inp,"keydown",function(e){options&&options.onKeyDown&&options.onKeyDown(e,inp.value,close)||(13==e.keyCode||27==e.keyCode)&&(CodeMirror.e_stop(e),close(),me.focus(),13==e.keyCode&&callback(inp.value))}),options&&options.onKeyUp&&CodeMirror.on(inp,"keyup",function(e){options.onKeyUp(e,inp.value,close)}),options&&options.value&&(inp.value=options.value),inp.focus(),CodeMirror.on(inp,"blur",close)):(button=dialog.getElementsByTagName("button")[0])&&(CodeMirror.on(button,"click",function(){close(),me.focus()}),button.focus(),CodeMirror.on(button,"blur",close)),close}),CodeMirror.defineExtension("openConfirm",function(template,callbacks,options){function close(){closed||(closed=!0,dialog.parentNode.removeChild(dialog),me.focus())}var dialog=dialogDiv(this,template,options&&options.bottom),buttons=dialog.getElementsByTagName("button"),closed=!1,me=this,blurring=1;buttons[0].focus();for(var i=0;i<buttons.length;++i){var b=buttons[i];!function(callback){CodeMirror.on(b,"click",function(e){CodeMirror.e_preventDefault(e),close(),callback&&callback(me)})}(callbacks[i]),CodeMirror.on(b,"blur",function(){--blurring,setTimeout(function(){0>=blurring&&close()},200)}),CodeMirror.on(b,"focus",function(){++blurring})}})}(),function(){function searchOverlay(query){return"string"==typeof query?{token:function(stream){return stream.match(query)?"searching":(stream.next(),void(stream.skipTo(query.charAt(0))||stream.skipToEnd()))}}:{token:function(stream){if(stream.match(query))return"searching";for(;!stream.eol()&&(stream.next(),!stream.match(query,!1)););}}}function SearchState(){this.posFrom=this.posTo=this.query=null,this.overlay=null}function getSearchState(cm){return cm.state.search||(cm.state.search=new SearchState)}function getSearchCursor(cm,query,pos){return cm.getSearchCursor(query,pos,"string"==typeof query&&query==query.toLowerCase())}function dialog(cm,text,shortText,f){cm.openDialog?cm.openDialog(text,f):f(prompt(shortText,""))}function confirmDialog(cm,text,shortText,fs){cm.openConfirm?cm.openConfirm(text,fs):confirm(shortText)&&fs[0]()}function parseQuery(query){var isRE=query.match(/^\/(.*)\/([a-z]*)$/);return isRE?new RegExp(isRE[1],-1==isRE[2].indexOf("i")?"":"i"):query}function doSearch(cm,rev){var state=getSearchState(cm);return state.query?findNext(cm,rev):void dialog(cm,queryDialog,"Search for:",function(query){cm.operation(function(){query&&!state.query&&(state.query=parseQuery(query),cm.removeOverlay(state.overlay),state.overlay=searchOverlay(state.query),cm.addOverlay(state.overlay),state.posFrom=state.posTo=cm.getCursor(),findNext(cm,rev))})})}function findNext(cm,rev){cm.operation(function(){var state=getSearchState(cm),cursor=getSearchCursor(cm,state.query,rev?state.posFrom:state.posTo);(cursor.find(rev)||(cursor=getSearchCursor(cm,state.query,rev?CodeMirror.Pos(cm.lastLine()):CodeMirror.Pos(cm.firstLine(),0)),cursor.find(rev)))&&(cm.setSelection(cursor.from(),cursor.to()),state.posFrom=cursor.from(),state.posTo=cursor.to())})}function clearSearch(cm){cm.operation(function(){var state=getSearchState(cm);state.query&&(state.query=null,cm.removeOverlay(state.overlay))})}function replace(cm,all){dialog(cm,replaceQueryDialog,"Replace:",function(query){query&&(query=parseQuery(query),dialog(cm,replacementQueryDialog,"Replace with:",function(text){if(all)cm.operation(function(){for(var cursor=getSearchCursor(cm,query);cursor.findNext();)if("string"!=typeof query){var match=cm.getRange(cursor.from(),cursor.to()).match(query);cursor.replace(text.replace(/\$(\d)/,function(_,i){return match[i]}))}else cursor.replace(text)});else{clearSearch(cm);var cursor=getSearchCursor(cm,query,cm.getCursor()),advance=function(){var match,start=cursor.from();!(match=cursor.findNext())&&(cursor=getSearchCursor(cm,query),!(match=cursor.findNext())||start&&cursor.from().line==start.line&&cursor.from().ch==start.ch)||(cm.setSelection(cursor.from(),cursor.to()),confirmDialog(cm,doReplaceConfirm,"Replace?",[function(){doReplace(match)},advance]))},doReplace=function(match){cursor.replace("string"==typeof query?text:text.replace(/\$(\d)/,function(_,i){return match[i]})),advance()};advance()}}))})}var queryDialog='Search: <input type="text" style="width: 10em"/> <span style="color: #888">(Use /re/ syntax for regexp search)</span>',replaceQueryDialog='Replace: <input type="text" style="width: 10em"/> <span style="color: #888">(Use /re/ syntax for regexp search)</span>',replacementQueryDialog='With: <input type="text" style="width: 10em"/>',doReplaceConfirm="Replace? <button>Yes</button> <button>No</button> <button>Stop</button>";CodeMirror.commands.find=function(cm){clearSearch(cm),doSearch(cm)},CodeMirror.commands.findNext=doSearch,CodeMirror.commands.findPrev=function(cm){doSearch(cm,!0)},CodeMirror.commands.clearSearch=clearSearch,CodeMirror.commands.replace=replace,CodeMirror.commands.replaceAll=function(cm){replace(cm,!0)}}(),function(){function SearchCursor(doc,query,pos,caseFold){if(this.atOccurrence=!1,this.doc=doc,null==caseFold&&"string"==typeof query&&(caseFold=!1),pos=pos?doc.clipPos(pos):Pos(0,0),this.pos={from:pos,to:pos},"string"!=typeof query)query.global||(query=new RegExp(query.source,query.ignoreCase?"ig":"g")),this.matches=function(reverse,pos){if(reverse){query.lastIndex=0;for(var match,start,line=doc.getLine(pos.line).slice(0,pos.ch),cutOff=0;;){query.lastIndex=cutOff;var newMatch=query.exec(line);if(!newMatch)break;if(match=newMatch,start=match.index,cutOff=match.index+(match[0].length||1),cutOff==line.length)break}var matchLen=match&&match[0].length||0;matchLen||(0==start&&0==line.length?match=void 0:start!=doc.getLine(pos.line).length&&matchLen++)}else{query.lastIndex=pos.ch;var line=doc.getLine(pos.line),match=query.exec(line),matchLen=match&&match[0].length||0,start=match&&match.index;start+matchLen==line.length||matchLen||(matchLen=1)}return match&&matchLen?{from:Pos(pos.line,start),to:Pos(pos.line,start+matchLen),match:match}:void 0};else{caseFold&&(query=query.toLowerCase());var fold=caseFold?function(str){return str.toLowerCase()}:function(str){return str},target=query.split("\n");1==target.length?query.length?this.matches=function(reverse,pos){var match,line=fold(doc.getLine(pos.line)),len=query.length;return(reverse?pos.ch>=len&&-1!=(match=line.lastIndexOf(query,pos.ch-len)):-1!=(match=line.indexOf(query,pos.ch)))?{from:Pos(pos.line,match),to:Pos(pos.line,match+len)}:void 0}:this.matches=function(){}:this.matches=function(reverse,pos){var ln=pos.line,idx=reverse?target.length-1:0,match=target[idx],line=fold(doc.getLine(ln)),offsetA=reverse?line.indexOf(match)+match.length:line.lastIndexOf(match);if(!(reverse?offsetA>=pos.ch||offsetA!=match.length:offsetA<=pos.ch||offsetA!=line.length-match.length))for(;;){if(reverse?!ln:ln==doc.lineCount()-1)return;if(line=fold(doc.getLine(ln+=reverse?-1:1)),match=target[reverse?--idx:++idx],!(idx>0&&idx<target.length-1)){var offsetB=reverse?line.lastIndexOf(match):line.indexOf(match)+match.length;if(reverse?offsetB!=line.length-match.length:offsetB!=match.length)return;var start=Pos(pos.line,offsetA),end=Pos(ln,offsetB);return{from:reverse?end:start,to:reverse?start:end}}if(line!=match)return}}}}var Pos=CodeMirror.Pos;SearchCursor.prototype={findNext:function(){return this.find(!1)},findPrevious:function(){return this.find(!0)},find:function(reverse){function savePosAndFail(line){var pos=Pos(line,0);return self.pos={from:pos,to:pos},self.atOccurrence=!1,!1}for(var self=this,pos=this.doc.clipPos(reverse?this.pos.from:this.pos.to);;){if(this.pos=this.matches(reverse,pos))return this.pos.from&&this.pos.to||console.log(this.matches,this.pos),this.atOccurrence=!0,this.pos.match||!0;if(reverse){if(!pos.line)return savePosAndFail(0);pos=Pos(pos.line-1,this.doc.getLine(pos.line-1).length)}else{var maxLine=this.doc.lineCount();if(pos.line==maxLine-1)return savePosAndFail(maxLine);pos=Pos(pos.line+1,0)}}},from:function(){return this.atOccurrence?this.pos.from:void 0},to:function(){return this.atOccurrence?this.pos.to:void 0},replace:function(newText){if(this.atOccurrence){var lines=CodeMirror.splitLines(newText);this.doc.replaceRange(lines,this.pos.from,this.pos.to),this.pos.to=Pos(this.pos.from.line+lines.length-1,lines[lines.length-1].length+(1==lines.length?this.pos.from.ch:0))}}},CodeMirror.defineExtension("getSearchCursor",function(query,pos,caseFold){return new SearchCursor(this.doc,query,pos,caseFold)}),CodeMirror.defineDocExtension("getSearchCursor",function(query,pos,caseFold){return new SearchCursor(this,query,pos,caseFold)})}(),function(){"use strict";function showTooltip(e,content){function position(e){return tt.parentNode?(tt.style.top=Math.max(0,e.clientY-tt.offsetHeight-5)+"px",void(tt.style.left=e.clientX+5+"px")):CodeMirror.off(document,"mousemove",position)}var tt=document.createElement("div");return tt.className="CodeMirror-lint-tooltip",tt.appendChild(content.cloneNode(!0)),document.body.appendChild(tt),CodeMirror.on(document,"mousemove",position),position(e),null!=tt.style.opacity&&(tt.style.opacity=1),tt}function rm(elt){elt.parentNode&&elt.parentNode.removeChild(elt);
}function hideTooltip(tt){tt.parentNode&&(null==tt.style.opacity&&rm(tt),tt.style.opacity=0,setTimeout(function(){rm(tt)},600))}function showTooltipFor(e,content,node){function hide(){CodeMirror.off(node,"mouseout",hide),tooltip&&(hideTooltip(tooltip),tooltip=null)}var tooltip=showTooltip(e,content),poll=setInterval(function(){if(tooltip)for(var n=node;;n=n.parentNode){if(n==document.body)return;if(!n){hide();break}}return tooltip?void 0:clearInterval(poll)},400);CodeMirror.on(node,"mouseout",hide)}function LintState(cm,options,hasGutter){this.marked=[],this.options=options,this.timeout=null,this.hasGutter=hasGutter,this.onMouseOver=function(e){onMouseOver(cm,e)}}function parseOptions(cm,options){if(options instanceof Function)return{getAnnotations:options};if(options&&options!==!0||(options={}),options.getAnnotations||(options.getAnnotations=cm.getHelper(CodeMirror.Pos(0,0),"lint")),!options.getAnnotations)throw new Error("Required option 'getAnnotations' missing (lint addon)");return options}function clearMarks(cm){var state=cm.state.lint;state.hasGutter&&cm.clearGutter(GUTTER_ID);for(var i=0;i<state.marked.length;++i)state.marked[i].clear();state.marked.length=0}function makeMarker(labels,severity,multiple,tooltips){var marker=document.createElement("div"),inner=marker;return marker.className="CodeMirror-lint-marker-"+severity,multiple&&(inner=marker.appendChild(document.createElement("div")),inner.className="CodeMirror-lint-marker-multiple"),0!=tooltips&&CodeMirror.on(inner,"mouseover",function(e){showTooltipFor(e,labels,inner)}),marker}function getMaxSeverity(a,b){return"error"==a?a:b}function groupByLine(annotations){for(var lines=[],i=0;i<annotations.length;++i){var ann=annotations[i],line=ann.from.line;(lines[line]||(lines[line]=[])).push(ann)}return lines}function annotationTooltip(ann){var severity=ann.severity;SEVERITIES.test(severity)||(severity="error");var tip=document.createElement("div");return tip.className="CodeMirror-lint-message-"+severity,tip.appendChild(document.createTextNode(ann.message)),tip}function startLinting(cm){var state=cm.state.lint,options=state.options;options.async?options.getAnnotations(cm,updateLinting,options):updateLinting(cm,options.getAnnotations(cm.getValue()))}function updateLinting(cm,annotationsNotSorted){clearMarks(cm);for(var state=cm.state.lint,options=state.options,annotations=groupByLine(annotationsNotSorted),line=0;line<annotations.length;++line){var anns=annotations[line];if(anns){for(var maxSeverity=null,tipLabel=state.hasGutter&&document.createDocumentFragment(),i=0;i<anns.length;++i){var ann=anns[i],severity=ann.severity;SEVERITIES.test(severity)||(severity="error"),maxSeverity=getMaxSeverity(maxSeverity,severity),options.formatAnnotation&&(ann=options.formatAnnotation(ann)),state.hasGutter&&tipLabel.appendChild(annotationTooltip(ann)),ann.to&&state.marked.push(cm.markText(ann.from,ann.to,{className:"CodeMirror-lint-mark-"+severity,__annotation:ann}))}state.hasGutter&&cm.setGutterMarker(line,GUTTER_ID,makeMarker(tipLabel,maxSeverity,anns.length>1,state.options.tooltips))}}options.onUpdateLinting&&options.onUpdateLinting(annotationsNotSorted,annotations,cm)}function onChange(cm){var state=cm.state.lint;clearTimeout(state.timeout),state.timeout=setTimeout(function(){startLinting(cm)},state.options.delay||500)}function popupSpanTooltip(ann,e){var target=e.target||e.srcElement;showTooltipFor(e,annotationTooltip(ann),target)}function onMouseOver(cm,e){if(/\bCodeMirror-lint-mark-/.test((e.target||e.srcElement).className))for(var i=0;i<nearby.length;i+=2)for(var spans=cm.findMarksAt(cm.coordsChar({left:e.clientX+nearby[i],top:e.clientY+nearby[i+1]})),j=0;j<spans.length;++j){var span=spans[j],ann=span.__annotation;if(ann)return popupSpanTooltip(ann,e)}}function optionHandler(cm,val,old){if(old&&old!=CodeMirror.Init&&(clearMarks(cm),cm.off("change",onChange),CodeMirror.off(cm.getWrapperElement(),"mouseover",cm.state.lint.onMouseOver),delete cm.state.lint),val){for(var gutters=cm.getOption("gutters"),hasLintGutter=!1,i=0;i<gutters.length;++i)gutters[i]==GUTTER_ID&&(hasLintGutter=!0);var state=cm.state.lint=new LintState(cm,parseOptions(cm,val),hasLintGutter);cm.on("change",onChange),0!=state.options.tooltips&&CodeMirror.on(cm.getWrapperElement(),"mouseover",state.onMouseOver),startLinting(cm)}}var GUTTER_ID="CodeMirror-lint-markers",SEVERITIES=/^(?:error|warning)$/,nearby=[0,0,0,5,0,-5,5,0,-5,0];CodeMirror.defineOption("lintWith",!1,optionHandler),CodeMirror.defineOption("lint",!1,optionHandler)}(),function(window,document,undefined){"use strict";function minErr(module,ErrorConstructor){return ErrorConstructor=ErrorConstructor||Error,function(){var message,i,code=arguments[0],prefix="["+(module?module+":":"")+code+"] ",template=arguments[1],templateArgs=arguments;for(message=prefix+template.replace(/\{\d+\}/g,function(match){var index=+match.slice(1,-1);return index+2<templateArgs.length?toDebugString(templateArgs[index+2]):match}),message=message+"\nhttp://errors.angularjs.org/1.3.20/"+(module?module+"/":"")+code,i=2;i<arguments.length;i++)message=message+(2==i?"?":"&")+"p"+(i-2)+"="+encodeURIComponent(toDebugString(arguments[i]));return new ErrorConstructor(message)}}function isArrayLike(obj){if(null==obj||isWindow(obj))return!1;var length="length"in Object(obj)&&obj.length;return obj.nodeType===NODE_TYPE_ELEMENT&&length?!0:isString(obj)||isArray(obj)||0===length||"number"==typeof length&&length>0&&length-1 in obj}function forEach(obj,iterator,context){var key,length;if(obj)if(isFunction(obj))for(key in obj)"prototype"==key||"length"==key||"name"==key||obj.hasOwnProperty&&!obj.hasOwnProperty(key)||iterator.call(context,obj[key],key,obj);else if(isArray(obj)||isArrayLike(obj)){var isPrimitive="object"!=typeof obj;for(key=0,length=obj.length;length>key;key++)(isPrimitive||key in obj)&&iterator.call(context,obj[key],key,obj)}else if(obj.forEach&&obj.forEach!==forEach)obj.forEach(iterator,context,obj);else for(key in obj)obj.hasOwnProperty(key)&&iterator.call(context,obj[key],key,obj);return obj}function sortedKeys(obj){return Object.keys(obj).sort()}function forEachSorted(obj,iterator,context){for(var keys=sortedKeys(obj),i=0;i<keys.length;i++)iterator.call(context,obj[keys[i]],keys[i]);return keys}function reverseParams(iteratorFn){return function(value,key){iteratorFn(key,value)}}function nextUid(){return++uid}function setHashKey(obj,h){h?obj.$$hashKey=h:delete obj.$$hashKey}function extend(dst){for(var h=dst.$$hashKey,i=1,ii=arguments.length;ii>i;i++){var obj=arguments[i];if(obj)for(var keys=Object.keys(obj),j=0,jj=keys.length;jj>j;j++){var key=keys[j];dst[key]=obj[key]}}return setHashKey(dst,h),dst}function int(str){return parseInt(str,10)}function inherit(parent,extra){return extend(Object.create(parent),extra)}function noop(){}function identity($){return $}function valueFn(value){return function(){return value}}function isUndefined(value){return"undefined"==typeof value}function isDefined(value){return"undefined"!=typeof value}function isObject(value){return null!==value&&"object"==typeof value}function isString(value){return"string"==typeof value}function isNumber(value){return"number"==typeof value}function isDate(value){return"[object Date]"===toString.call(value)}function isFunction(value){return"function"==typeof value}function isRegExp(value){return"[object RegExp]"===toString.call(value)}function isWindow(obj){return obj&&obj.window===obj}function isScope(obj){return obj&&obj.$evalAsync&&obj.$watch}function isFile(obj){return"[object File]"===toString.call(obj)}function isFormData(obj){return"[object FormData]"===toString.call(obj)}function isBlob(obj){return"[object Blob]"===toString.call(obj)}function isBoolean(value){return"boolean"==typeof value}function isPromiseLike(obj){return obj&&isFunction(obj.then)}function isElement(node){return!(!node||!(node.nodeName||node.prop&&node.attr&&node.find))}function makeMap(str){var i,obj={},items=str.split(",");for(i=0;i<items.length;i++)obj[items[i]]=!0;return obj}function nodeName_(element){return lowercase(element.nodeName||element[0]&&element[0].nodeName)}function arrayRemove(array,value){var index=array.indexOf(value);return index>=0&&array.splice(index,1),value}function copy(source,destination,stackSource,stackDest){if(isWindow(source)||isScope(source))throw ngMinErr("cpws","Can't copy! Making copies of Window or Scope instances is not supported.");if(destination){if(source===destination)throw ngMinErr("cpi","Can't copy! Source and destination are identical.");if(stackSource=stackSource||[],stackDest=stackDest||[],isObject(source)){var index=stackSource.indexOf(source);if(-1!==index)return stackDest[index];stackSource.push(source),stackDest.push(destination)}var result;if(isArray(source)){destination.length=0;for(var i=0;i<source.length;i++)result=copy(source[i],null,stackSource,stackDest),isObject(source[i])&&(stackSource.push(source[i]),stackDest.push(result)),destination.push(result)}else{var h=destination.$$hashKey;isArray(destination)?destination.length=0:forEach(destination,function(value,key){delete destination[key]});for(var key in source)source.hasOwnProperty(key)&&(result=copy(source[key],null,stackSource,stackDest),isObject(source[key])&&(stackSource.push(source[key]),stackDest.push(result)),destination[key]=result);setHashKey(destination,h)}}else if(destination=source,source)if(isArray(source))destination=copy(source,[],stackSource,stackDest);else if(isDate(source))destination=new Date(source.getTime());else if(isRegExp(source))destination=new RegExp(source.source,source.toString().match(/[^\/]*$/)[0]),destination.lastIndex=source.lastIndex;else if(isObject(source)){var emptyObject=Object.create(Object.getPrototypeOf(source));destination=copy(source,emptyObject,stackSource,stackDest)}return destination}function shallowCopy(src,dst){if(isArray(src)){dst=dst||[];for(var i=0,ii=src.length;ii>i;i++)dst[i]=src[i]}else if(isObject(src)){dst=dst||{};for(var key in src)("$"!==key.charAt(0)||"$"!==key.charAt(1))&&(dst[key]=src[key])}return dst||src}function equals(o1,o2){if(o1===o2)return!0;if(null===o1||null===o2)return!1;if(o1!==o1&&o2!==o2)return!0;var length,key,keySet,t1=typeof o1,t2=typeof o2;if(t1==t2&&"object"==t1){if(!isArray(o1)){if(isDate(o1))return isDate(o2)?equals(o1.getTime(),o2.getTime()):!1;if(isRegExp(o1))return isRegExp(o2)?o1.toString()==o2.toString():!1;if(isScope(o1)||isScope(o2)||isWindow(o1)||isWindow(o2)||isArray(o2)||isDate(o2)||isRegExp(o2))return!1;keySet={};for(key in o1)if("$"!==key.charAt(0)&&!isFunction(o1[key])){if(!equals(o1[key],o2[key]))return!1;keySet[key]=!0}for(key in o2)if(!keySet.hasOwnProperty(key)&&"$"!==key.charAt(0)&&o2[key]!==undefined&&!isFunction(o2[key]))return!1;return!0}if(!isArray(o2))return!1;if((length=o1.length)==o2.length){for(key=0;length>key;key++)if(!equals(o1[key],o2[key]))return!1;return!0}}return!1}function concat(array1,array2,index){return array1.concat(slice.call(array2,index))}function sliceArgs(args,startIndex){return slice.call(args,startIndex||0)}function bind(self,fn){var curryArgs=arguments.length>2?sliceArgs(arguments,2):[];return!isFunction(fn)||fn instanceof RegExp?fn:curryArgs.length?function(){return arguments.length?fn.apply(self,concat(curryArgs,arguments,0)):fn.apply(self,curryArgs)}:function(){return arguments.length?fn.apply(self,arguments):fn.call(self)}}function toJsonReplacer(key,value){var val=value;return"string"==typeof key&&"$"===key.charAt(0)&&"$"===key.charAt(1)?val=undefined:isWindow(value)?val="$WINDOW":value&&document===value?val="$DOCUMENT":isScope(value)&&(val="$SCOPE"),val}function toJson(obj,pretty){return"undefined"==typeof obj?undefined:(isNumber(pretty)||(pretty=pretty?2:null),JSON.stringify(obj,toJsonReplacer,pretty))}function fromJson(json){return isString(json)?JSON.parse(json):json}function startingTag(element){element=jqLite(element).clone();try{element.empty()}catch(e){}var elemHtml=jqLite("<div>").append(element).html();try{return element[0].nodeType===NODE_TYPE_TEXT?lowercase(elemHtml):elemHtml.match(/^(<[^>]+>)/)[1].replace(/^<([\w\-]+)/,function(match,nodeName){return"<"+lowercase(nodeName)})}catch(e){return lowercase(elemHtml)}}function tryDecodeURIComponent(value){try{return decodeURIComponent(value)}catch(e){}}function parseKeyValue(keyValue){var key_value,key,obj={};return forEach((keyValue||"").split("&"),function(keyValue){if(keyValue&&(key_value=keyValue.replace(/\+/g,"%20").split("="),key=tryDecodeURIComponent(key_value[0]),isDefined(key))){var val=isDefined(key_value[1])?tryDecodeURIComponent(key_value[1]):!0;hasOwnProperty.call(obj,key)?isArray(obj[key])?obj[key].push(val):obj[key]=[obj[key],val]:obj[key]=val}}),obj}function toKeyValue(obj){var parts=[];return forEach(obj,function(value,key){isArray(value)?forEach(value,function(arrayValue){parts.push(encodeUriQuery(key,!0)+(arrayValue===!0?"":"="+encodeUriQuery(arrayValue,!0)))}):parts.push(encodeUriQuery(key,!0)+(value===!0?"":"="+encodeUriQuery(value,!0)))}),parts.length?parts.join("&"):""}function encodeUriSegment(val){return encodeUriQuery(val,!0).replace(/%26/gi,"&").replace(/%3D/gi,"=").replace(/%2B/gi,"+")}function encodeUriQuery(val,pctEncodeSpaces){return encodeURIComponent(val).replace(/%40/gi,"@").replace(/%3A/gi,":").replace(/%24/g,"$").replace(/%2C/gi,",").replace(/%3B/gi,";").replace(/%20/g,pctEncodeSpaces?"%20":"+")}function getNgAttribute(element,ngAttr){var attr,i,ii=ngAttrPrefixes.length;for(element=jqLite(element),i=0;ii>i;++i)if(attr=ngAttrPrefixes[i]+ngAttr,isString(attr=element.attr(attr)))return attr;return null}function angularInit(element,bootstrap){var appElement,module,config={};forEach(ngAttrPrefixes,function(prefix){var name=prefix+"app";!appElement&&element.hasAttribute&&element.hasAttribute(name)&&(appElement=element,module=element.getAttribute(name))}),forEach(ngAttrPrefixes,function(prefix){var candidate,name=prefix+"app";!appElement&&(candidate=element.querySelector("["+name.replace(":","\\:")+"]"))&&(appElement=candidate,module=candidate.getAttribute(name))}),appElement&&(config.strictDi=null!==getNgAttribute(appElement,"strict-di"),bootstrap(appElement,module?[module]:[],config))}function bootstrap(element,modules,config){isObject(config)||(config={});var defaultConfig={strictDi:!1};config=extend(defaultConfig,config);var doBootstrap=function(){if(element=jqLite(element),element.injector()){var tag=element[0]===document?"document":startingTag(element);throw ngMinErr("btstrpd","App Already Bootstrapped with this Element '{0}'",tag.replace(/</,"&lt;").replace(/>/,"&gt;"))}modules=modules||[],modules.unshift(["$provide",function($provide){$provide.value("$rootElement",element)}]),config.debugInfoEnabled&&modules.push(["$compileProvider",function($compileProvider){$compileProvider.debugInfoEnabled(!0)}]),modules.unshift("ng");var injector=createInjector(modules,config.strictDi);return injector.invoke(["$rootScope","$rootElement","$compile","$injector",function(scope,element,compile,injector){scope.$apply(function(){element.data("$injector",injector),compile(element)(scope)})}]),injector},NG_ENABLE_DEBUG_INFO=/^NG_ENABLE_DEBUG_INFO!/,NG_DEFER_BOOTSTRAP=/^NG_DEFER_BOOTSTRAP!/;return window&&NG_ENABLE_DEBUG_INFO.test(window.name)&&(config.debugInfoEnabled=!0,window.name=window.name.replace(NG_ENABLE_DEBUG_INFO,"")),window&&!NG_DEFER_BOOTSTRAP.test(window.name)?doBootstrap():(window.name=window.name.replace(NG_DEFER_BOOTSTRAP,""),angular.resumeBootstrap=function(extraModules){return forEach(extraModules,function(module){modules.push(module)}),doBootstrap()},void(isFunction(angular.resumeDeferredBootstrap)&&angular.resumeDeferredBootstrap()))}function reloadWithDebugInfo(){window.name="NG_ENABLE_DEBUG_INFO!"+window.name,window.location.reload()}function getTestability(rootElement){var injector=angular.element(rootElement).injector();if(!injector)throw ngMinErr("test","no injector found for element argument to getTestability");return injector.get("$$testability")}function snake_case(name,separator){return separator=separator||"_",name.replace(SNAKE_CASE_REGEXP,function(letter,pos){return(pos?separator:"")+letter.toLowerCase()})}function bindJQuery(){var originalCleanData;bindJQueryFired||(jQuery=window.jQuery,jQuery&&jQuery.fn.on?(jqLite=jQuery,extend(jQuery.fn,{scope:JQLitePrototype.scope,isolateScope:JQLitePrototype.isolateScope,controller:JQLitePrototype.controller,injector:JQLitePrototype.injector,inheritedData:JQLitePrototype.inheritedData}),originalCleanData=jQuery.cleanData,jQuery.cleanData=function(elems){var events;if(skipDestroyOnNextJQueryCleanData)skipDestroyOnNextJQueryCleanData=!1;else for(var elem,i=0;null!=(elem=elems[i]);i++)events=jQuery._data(elem,"events"),events&&events.$destroy&&jQuery(elem).triggerHandler("$destroy");originalCleanData(elems)}):jqLite=JQLite,angular.element=jqLite,bindJQueryFired=!0)}function assertArg(arg,name,reason){if(!arg)throw ngMinErr("areq","Argument '{0}' is {1}",name||"?",reason||"required");return arg}function assertArgFn(arg,name,acceptArrayAnnotation){return acceptArrayAnnotation&&isArray(arg)&&(arg=arg[arg.length-1]),assertArg(isFunction(arg),name,"not a function, got "+(arg&&"object"==typeof arg?arg.constructor.name||"Object":typeof arg)),arg}function assertNotHasOwnProperty(name,context){if("hasOwnProperty"===name)throw ngMinErr("badname","hasOwnProperty is not a valid {0} name",context)}function getter(obj,path,bindFnToScope){if(!path)return obj;for(var key,keys=path.split("."),lastInstance=obj,len=keys.length,i=0;len>i;i++)key=keys[i],obj&&(obj=(lastInstance=obj)[key]);return!bindFnToScope&&isFunction(obj)?bind(lastInstance,obj):obj}function getBlockNodes(nodes){var node=nodes[0],endNode=nodes[nodes.length-1],blockNodes=[node];do{if(node=node.nextSibling,!node)break;blockNodes.push(node)}while(node!==endNode);return jqLite(blockNodes)}function createMap(){return Object.create(null)}function setupModuleLoader(window){function ensure(obj,name,factory){return obj[name]||(obj[name]=factory())}var $injectorMinErr=minErr("$injector"),ngMinErr=minErr("ng"),angular=ensure(window,"angular",Object);return angular.$$minErr=angular.$$minErr||minErr,ensure(angular,"module",function(){var modules={};return function(name,requires,configFn){var assertNotHasOwnProperty=function(name,context){if("hasOwnProperty"===name)throw ngMinErr("badname","hasOwnProperty is not a valid {0} name",context)};return assertNotHasOwnProperty(name,"module"),requires&&modules.hasOwnProperty(name)&&(modules[name]=null),ensure(modules,name,function(){function invokeLater(provider,method,insertMethod,queue){return queue||(queue=invokeQueue),function(){return queue[insertMethod||"push"]([provider,method,arguments]),moduleInstance}}if(!requires)throw $injectorMinErr("nomod","Module '{0}' is not available! You either misspelled the module name or forgot to load it. If registering a module ensure that you specify the dependencies as the second argument.",name);var invokeQueue=[],configBlocks=[],runBlocks=[],config=invokeLater("$injector","invoke","push",configBlocks),moduleInstance={_invokeQueue:invokeQueue,_configBlocks:configBlocks,_runBlocks:runBlocks,requires:requires,name:name,provider:invokeLater("$provide","provider"),factory:invokeLater("$provide","factory"),service:invokeLater("$provide","service"),value:invokeLater("$provide","value"),constant:invokeLater("$provide","constant","unshift"),animation:invokeLater("$animateProvider","register"),filter:invokeLater("$filterProvider","register"),controller:invokeLater("$controllerProvider","register"),directive:invokeLater("$compileProvider","directive"),config:config,run:function(block){return runBlocks.push(block),this}};return configFn&&config(configFn),moduleInstance})}})}function serializeObject(obj){var seen=[];return JSON.stringify(obj,function(key,val){if(val=toJsonReplacer(key,val),isObject(val)){if(seen.indexOf(val)>=0)return"<<already seen>>";seen.push(val)}return val})}function toDebugString(obj){return"function"==typeof obj?obj.toString().replace(/ \{[\s\S]*$/,""):"undefined"==typeof obj?"undefined":"string"!=typeof obj?serializeObject(obj):obj}function publishExternalAPI(angular){extend(angular,{bootstrap:bootstrap,copy:copy,extend:extend,equals:equals,element:jqLite,forEach:forEach,injector:createInjector,noop:noop,bind:bind,toJson:toJson,fromJson:fromJson,identity:identity,isUndefined:isUndefined,isDefined:isDefined,isString:isString,isFunction:isFunction,isObject:isObject,isNumber:isNumber,isElement:isElement,isArray:isArray,version:version,isDate:isDate,lowercase:lowercase,uppercase:uppercase,callbacks:{counter:0},getTestability:getTestability,$$minErr:minErr,$$csp:csp,reloadWithDebugInfo:reloadWithDebugInfo}),angularModule=setupModuleLoader(window);try{angularModule("ngLocale")}catch(e){angularModule("ngLocale",[]).provider("$locale",$LocaleProvider)}angularModule("ng",["ngLocale"],["$provide",function($provide){$provide.provider({$$sanitizeUri:$$SanitizeUriProvider}),$provide.provider("$compile",$CompileProvider).directive({a:htmlAnchorDirective,input:inputDirective,textarea:inputDirective,form:formDirective,script:scriptDirective,select:selectDirective,style:styleDirective,option:optionDirective,ngBind:ngBindDirective,ngBindHtml:ngBindHtmlDirective,ngBindTemplate:ngBindTemplateDirective,ngClass:ngClassDirective,ngClassEven:ngClassEvenDirective,ngClassOdd:ngClassOddDirective,ngCloak:ngCloakDirective,ngController:ngControllerDirective,ngForm:ngFormDirective,ngHide:ngHideDirective,ngIf:ngIfDirective,ngInclude:ngIncludeDirective,ngInit:ngInitDirective,ngNonBindable:ngNonBindableDirective,ngPluralize:ngPluralizeDirective,ngRepeat:ngRepeatDirective,ngShow:ngShowDirective,ngStyle:ngStyleDirective,ngSwitch:ngSwitchDirective,ngSwitchWhen:ngSwitchWhenDirective,ngSwitchDefault:ngSwitchDefaultDirective,ngOptions:ngOptionsDirective,ngTransclude:ngTranscludeDirective,ngModel:ngModelDirective,ngList:ngListDirective,ngChange:ngChangeDirective,pattern:patternDirective,ngPattern:patternDirective,required:requiredDirective,ngRequired:requiredDirective,minlength:minlengthDirective,ngMinlength:minlengthDirective,maxlength:maxlengthDirective,ngMaxlength:maxlengthDirective,ngValue:ngValueDirective,ngModelOptions:ngModelOptionsDirective}).directive({ngInclude:ngIncludeFillContentDirective}).directive(ngAttributeAliasDirectives).directive(ngEventDirectives),$provide.provider({$anchorScroll:$AnchorScrollProvider,$animate:$AnimateProvider,$browser:$BrowserProvider,$cacheFactory:$CacheFactoryProvider,$controller:$ControllerProvider,$document:$DocumentProvider,$exceptionHandler:$ExceptionHandlerProvider,$filter:$FilterProvider,$interpolate:$InterpolateProvider,$interval:$IntervalProvider,$http:$HttpProvider,$httpBackend:$HttpBackendProvider,$location:$LocationProvider,$log:$LogProvider,$parse:$ParseProvider,$rootScope:$RootScopeProvider,$q:$QProvider,$$q:$$QProvider,$sce:$SceProvider,$sceDelegate:$SceDelegateProvider,$sniffer:$SnifferProvider,$templateCache:$TemplateCacheProvider,$templateRequest:$TemplateRequestProvider,$$testability:$$TestabilityProvider,$timeout:$TimeoutProvider,$window:$WindowProvider,$$rAF:$$RAFProvider,$$asyncCallback:$$AsyncCallbackProvider,$$jqLite:$$jqLiteProvider})}])}function jqNextId(){return++jqId}function camelCase(name){return name.replace(SPECIAL_CHARS_REGEXP,function(_,separator,letter,offset){return offset?letter.toUpperCase():letter}).replace(MOZ_HACK_REGEXP,"Moz$1")}function jqLiteIsTextNode(html){return!HTML_REGEXP.test(html)}function jqLiteAcceptsData(node){var nodeType=node.nodeType;return nodeType===NODE_TYPE_ELEMENT||!nodeType||nodeType===NODE_TYPE_DOCUMENT}function jqLiteBuildFragment(html,context){var tmp,tag,wrap,i,fragment=context.createDocumentFragment(),nodes=[];if(jqLiteIsTextNode(html))nodes.push(context.createTextNode(html));else{for(tmp=tmp||fragment.appendChild(context.createElement("div")),tag=(TAG_NAME_REGEXP.exec(html)||["",""])[1].toLowerCase(),wrap=wrapMap[tag]||wrapMap._default,tmp.innerHTML=wrap[1]+html.replace(XHTML_TAG_REGEXP,"<$1></$2>")+wrap[2],i=wrap[0];i--;)tmp=tmp.lastChild;nodes=concat(nodes,tmp.childNodes),tmp=fragment.firstChild,tmp.textContent=""}return fragment.textContent="",fragment.innerHTML="",forEach(nodes,function(node){fragment.appendChild(node)}),fragment}function jqLiteParseHTML(html,context){context=context||document;var parsed;return(parsed=SINGLE_TAG_REGEXP.exec(html))?[context.createElement(parsed[1])]:(parsed=jqLiteBuildFragment(html,context))?parsed.childNodes:[]}function JQLite(element){if(element instanceof JQLite)return element;var argIsString;if(isString(element)&&(element=trim(element),argIsString=!0),!(this instanceof JQLite)){if(argIsString&&"<"!=element.charAt(0))throw jqLiteMinErr("nosel","Looking up elements via selectors is not supported by jqLite! See: http://docs.angularjs.org/api/angular.element");return new JQLite(element)}argIsString?jqLiteAddNodes(this,jqLiteParseHTML(element)):jqLiteAddNodes(this,element)}function jqLiteClone(element){return element.cloneNode(!0)}function jqLiteDealoc(element,onlyDescendants){if(onlyDescendants||jqLiteRemoveData(element),element.querySelectorAll)for(var descendants=element.querySelectorAll("*"),i=0,l=descendants.length;l>i;i++)jqLiteRemoveData(descendants[i])}function jqLiteOff(element,type,fn,unsupported){if(isDefined(unsupported))throw jqLiteMinErr("offargs","jqLite#off() does not support the `selector` argument");var expandoStore=jqLiteExpandoStore(element),events=expandoStore&&expandoStore.events,handle=expandoStore&&expandoStore.handle;if(handle)if(type)forEach(type.split(" "),function(type){if(isDefined(fn)){var listenerFns=events[type];if(arrayRemove(listenerFns||[],fn),listenerFns&&listenerFns.length>0)return}removeEventListenerFn(element,type,handle),delete events[type]});else for(type in events)"$destroy"!==type&&removeEventListenerFn(element,type,handle),delete events[type]}function jqLiteRemoveData(element,name){var expandoId=element.ng339,expandoStore=expandoId&&jqCache[expandoId];if(expandoStore){if(name)return void delete expandoStore.data[name];expandoStore.handle&&(expandoStore.events.$destroy&&expandoStore.handle({},"$destroy"),jqLiteOff(element)),delete jqCache[expandoId],element.ng339=undefined}}function jqLiteExpandoStore(element,createIfNecessary){var expandoId=element.ng339,expandoStore=expandoId&&jqCache[expandoId];return createIfNecessary&&!expandoStore&&(element.ng339=expandoId=jqNextId(),expandoStore=jqCache[expandoId]={events:{},data:{},handle:undefined}),expandoStore}function jqLiteData(element,key,value){if(jqLiteAcceptsData(element)){var isSimpleSetter=isDefined(value),isSimpleGetter=!isSimpleSetter&&key&&!isObject(key),massGetter=!key,expandoStore=jqLiteExpandoStore(element,!isSimpleGetter),data=expandoStore&&expandoStore.data;if(isSimpleSetter)data[key]=value;else{if(massGetter)return data;if(isSimpleGetter)return data&&data[key];extend(data,key)}}}function jqLiteHasClass(element,selector){return element.getAttribute?(" "+(element.getAttribute("class")||"")+" ").replace(/[\n\t]/g," ").indexOf(" "+selector+" ")>-1:!1}function jqLiteRemoveClass(element,cssClasses){cssClasses&&element.setAttribute&&forEach(cssClasses.split(" "),function(cssClass){element.setAttribute("class",trim((" "+(element.getAttribute("class")||"")+" ").replace(/[\n\t]/g," ").replace(" "+trim(cssClass)+" "," ")))})}function jqLiteAddClass(element,cssClasses){if(cssClasses&&element.setAttribute){var existingClasses=(" "+(element.getAttribute("class")||"")+" ").replace(/[\n\t]/g," ");forEach(cssClasses.split(" "),function(cssClass){cssClass=trim(cssClass),-1===existingClasses.indexOf(" "+cssClass+" ")&&(existingClasses+=cssClass+" ")}),element.setAttribute("class",trim(existingClasses))}}function jqLiteAddNodes(root,elements){if(elements)if(elements.nodeType)root[root.length++]=elements;else{var length=elements.length;if("number"==typeof length&&elements.window!==elements){if(length)for(var i=0;length>i;i++)root[root.length++]=elements[i]}else root[root.length++]=elements}}function jqLiteController(element,name){return jqLiteInheritedData(element,"$"+(name||"ngController")+"Controller")}function jqLiteInheritedData(element,name,value){element.nodeType==NODE_TYPE_DOCUMENT&&(element=element.documentElement);for(var names=isArray(name)?name:[name];element;){for(var i=0,ii=names.length;ii>i;i++)if((value=jqLite.data(element,names[i]))!==undefined)return value;element=element.parentNode||element.nodeType===NODE_TYPE_DOCUMENT_FRAGMENT&&element.host}}function jqLiteEmpty(element){for(jqLiteDealoc(element,!0);element.firstChild;)element.removeChild(element.firstChild)}function jqLiteRemove(element,keepData){keepData||jqLiteDealoc(element);var parent=element.parentNode;parent&&parent.removeChild(element)}function jqLiteDocumentLoaded(action,win){win=win||window,"complete"===win.document.readyState?win.setTimeout(action):jqLite(win).on("load",action)}function getBooleanAttrName(element,name){var booleanAttr=BOOLEAN_ATTR[name.toLowerCase()];return booleanAttr&&BOOLEAN_ELEMENTS[nodeName_(element)]&&booleanAttr}function getAliasedAttrName(element,name){var nodeName=element.nodeName;return("INPUT"===nodeName||"TEXTAREA"===nodeName)&&ALIASED_ATTR[name]}function createEventHandler(element,events){var eventHandler=function(event,type){event.isDefaultPrevented=function(){return event.defaultPrevented};var eventFns=events[type||event.type],eventFnsLength=eventFns?eventFns.length:0;if(eventFnsLength){if(isUndefined(event.immediatePropagationStopped)){var originalStopImmediatePropagation=event.stopImmediatePropagation;event.stopImmediatePropagation=function(){event.immediatePropagationStopped=!0,event.stopPropagation&&event.stopPropagation(),originalStopImmediatePropagation&&originalStopImmediatePropagation.call(event)}}event.isImmediatePropagationStopped=function(){return event.immediatePropagationStopped===!0},eventFnsLength>1&&(eventFns=shallowCopy(eventFns));for(var i=0;eventFnsLength>i;i++)event.isImmediatePropagationStopped()||eventFns[i].call(element,event)}};return eventHandler.elem=element,eventHandler}function $$jqLiteProvider(){this.$get=function(){return extend(JQLite,{hasClass:function(node,classes){return node.attr&&(node=node[0]),jqLiteHasClass(node,classes)},addClass:function(node,classes){return node.attr&&(node=node[0]),jqLiteAddClass(node,classes)},removeClass:function(node,classes){return node.attr&&(node=node[0]),jqLiteRemoveClass(node,classes)}})}}function hashKey(obj,nextUidFn){var key=obj&&obj.$$hashKey;if(key)return"function"==typeof key&&(key=obj.$$hashKey()),key;var objType=typeof obj;return key="function"==objType||"object"==objType&&null!==obj?obj.$$hashKey=objType+":"+(nextUidFn||nextUid)():objType+":"+obj}function HashMap(array,isolatedUid){if(isolatedUid){var uid=0;this.nextUid=function(){return++uid}}forEach(array,this.put,this)}function anonFn(fn){var fnText=fn.toString().replace(STRIP_COMMENTS,""),args=fnText.match(FN_ARGS);return args?"function("+(args[1]||"").replace(/[\s\r\n]+/," ")+")":"fn"}function annotate(fn,strictDi,name){var $inject,fnText,argDecl,last;if("function"==typeof fn){if(!($inject=fn.$inject)){if($inject=[],fn.length){if(strictDi)throw isString(name)&&name||(name=fn.name||anonFn(fn)),$injectorMinErr("strictdi","{0} is not using explicit annotation and cannot be invoked in strict mode",name);fnText=fn.toString().replace(STRIP_COMMENTS,""),argDecl=fnText.match(FN_ARGS),forEach(argDecl[1].split(FN_ARG_SPLIT),function(arg){arg.replace(FN_ARG,function(all,underscore,name){$inject.push(name)})})}fn.$inject=$inject}}else isArray(fn)?(last=fn.length-1,assertArgFn(fn[last],"fn"),$inject=fn.slice(0,last)):assertArgFn(fn,"fn",!0);return $inject}function createInjector(modulesToLoad,strictDi){function supportObject(delegate){return function(key,value){return isObject(key)?void forEach(key,reverseParams(delegate)):delegate(key,value)}}function provider(name,provider_){if(assertNotHasOwnProperty(name,"service"),(isFunction(provider_)||isArray(provider_))&&(provider_=providerInjector.instantiate(provider_)),
!provider_.$get)throw $injectorMinErr("pget","Provider '{0}' must define $get factory method.",name);return providerCache[name+providerSuffix]=provider_}function enforceReturnValue(name,factory){return function(){var result=instanceInjector.invoke(factory,this);if(isUndefined(result))throw $injectorMinErr("undef","Provider '{0}' must return a value from $get factory method.",name);return result}}function factory(name,factoryFn,enforce){return provider(name,{$get:enforce!==!1?enforceReturnValue(name,factoryFn):factoryFn})}function service(name,constructor){return factory(name,["$injector",function($injector){return $injector.instantiate(constructor)}])}function value(name,val){return factory(name,valueFn(val),!1)}function constant(name,value){assertNotHasOwnProperty(name,"constant"),providerCache[name]=value,instanceCache[name]=value}function decorator(serviceName,decorFn){var origProvider=providerInjector.get(serviceName+providerSuffix),orig$get=origProvider.$get;origProvider.$get=function(){var origInstance=instanceInjector.invoke(orig$get,origProvider);return instanceInjector.invoke(decorFn,null,{$delegate:origInstance})}}function loadModules(modulesToLoad){var moduleFn,runBlocks=[];return forEach(modulesToLoad,function(module){function runInvokeQueue(queue){var i,ii;for(i=0,ii=queue.length;ii>i;i++){var invokeArgs=queue[i],provider=providerInjector.get(invokeArgs[0]);provider[invokeArgs[1]].apply(provider,invokeArgs[2])}}if(!loadedModules.get(module)){loadedModules.put(module,!0);try{isString(module)?(moduleFn=angularModule(module),runBlocks=runBlocks.concat(loadModules(moduleFn.requires)).concat(moduleFn._runBlocks),runInvokeQueue(moduleFn._invokeQueue),runInvokeQueue(moduleFn._configBlocks)):isFunction(module)?runBlocks.push(providerInjector.invoke(module)):isArray(module)?runBlocks.push(providerInjector.invoke(module)):assertArgFn(module,"module")}catch(e){throw isArray(module)&&(module=module[module.length-1]),e.message&&e.stack&&-1==e.stack.indexOf(e.message)&&(e=e.message+"\n"+e.stack),$injectorMinErr("modulerr","Failed to instantiate module {0} due to:\n{1}",module,e.stack||e.message||e)}}}),runBlocks}function createInternalInjector(cache,factory){function getService(serviceName,caller){if(cache.hasOwnProperty(serviceName)){if(cache[serviceName]===INSTANTIATING)throw $injectorMinErr("cdep","Circular dependency found: {0}",serviceName+" <- "+path.join(" <- "));return cache[serviceName]}try{return path.unshift(serviceName),cache[serviceName]=INSTANTIATING,cache[serviceName]=factory(serviceName,caller)}catch(err){throw cache[serviceName]===INSTANTIATING&&delete cache[serviceName],err}finally{path.shift()}}function invoke(fn,self,locals,serviceName){"string"==typeof locals&&(serviceName=locals,locals=null);var length,i,key,args=[],$inject=createInjector.$$annotate(fn,strictDi,serviceName);for(i=0,length=$inject.length;length>i;i++){if(key=$inject[i],"string"!=typeof key)throw $injectorMinErr("itkn","Incorrect injection token! Expected service name as string, got {0}",key);args.push(locals&&locals.hasOwnProperty(key)?locals[key]:getService(key,serviceName))}return isArray(fn)&&(fn=fn[length]),fn.apply(self,args)}function instantiate(Type,locals,serviceName){var instance=Object.create((isArray(Type)?Type[Type.length-1]:Type).prototype||null),returnedValue=invoke(Type,instance,locals,serviceName);return isObject(returnedValue)||isFunction(returnedValue)?returnedValue:instance}return{invoke:invoke,instantiate:instantiate,get:getService,annotate:createInjector.$$annotate,has:function(name){return providerCache.hasOwnProperty(name+providerSuffix)||cache.hasOwnProperty(name)}}}strictDi=strictDi===!0;var INSTANTIATING={},providerSuffix="Provider",path=[],loadedModules=new HashMap([],!0),providerCache={$provide:{provider:supportObject(provider),factory:supportObject(factory),service:supportObject(service),value:supportObject(value),constant:supportObject(constant),decorator:decorator}},providerInjector=providerCache.$injector=createInternalInjector(providerCache,function(serviceName,caller){throw angular.isString(caller)&&path.push(caller),$injectorMinErr("unpr","Unknown provider: {0}",path.join(" <- "))}),instanceCache={},instanceInjector=instanceCache.$injector=createInternalInjector(instanceCache,function(serviceName,caller){var provider=providerInjector.get(serviceName+providerSuffix,caller);return instanceInjector.invoke(provider.$get,provider,undefined,serviceName)});return forEach(loadModules(modulesToLoad),function(fn){instanceInjector.invoke(fn||noop)}),instanceInjector}function $AnchorScrollProvider(){var autoScrollingEnabled=!0;this.disableAutoScrolling=function(){autoScrollingEnabled=!1},this.$get=["$window","$location","$rootScope",function($window,$location,$rootScope){function getFirstAnchor(list){var result=null;return Array.prototype.some.call(list,function(element){return"a"===nodeName_(element)?(result=element,!0):void 0}),result}function getYOffset(){var offset=scroll.yOffset;if(isFunction(offset))offset=offset();else if(isElement(offset)){var elem=offset[0],style=$window.getComputedStyle(elem);offset="fixed"!==style.position?0:elem.getBoundingClientRect().bottom}else isNumber(offset)||(offset=0);return offset}function scrollTo(elem){if(elem){elem.scrollIntoView();var offset=getYOffset();if(offset){var elemTop=elem.getBoundingClientRect().top;$window.scrollBy(0,elemTop-offset)}}else $window.scrollTo(0,0)}function scroll(){var elm,hash=$location.hash();hash?(elm=document.getElementById(hash))?scrollTo(elm):(elm=getFirstAnchor(document.getElementsByName(hash)))?scrollTo(elm):"top"===hash&&scrollTo(null):scrollTo(null)}var document=$window.document;return autoScrollingEnabled&&$rootScope.$watch(function(){return $location.hash()},function(newVal,oldVal){(newVal!==oldVal||""!==newVal)&&jqLiteDocumentLoaded(function(){$rootScope.$evalAsync(scroll)})}),scroll}]}function $$AsyncCallbackProvider(){this.$get=["$$rAF","$timeout",function($$rAF,$timeout){return $$rAF.supported?function(fn){return $$rAF(fn)}:function(fn){return $timeout(fn,0,!1)}}]}function Browser(window,document,$log,$sniffer){function completeOutstandingRequest(fn){try{fn.apply(null,sliceArgs(arguments,1))}finally{if(outstandingRequestCount--,0===outstandingRequestCount)for(;outstandingRequestCallbacks.length;)try{outstandingRequestCallbacks.pop()()}catch(e){$log.error(e)}}}function getHash(url){var index=url.indexOf("#");return-1===index?"":url.substr(index)}function startPoller(interval,setTimeout){!function check(){forEach(pollFns,function(pollFn){pollFn()}),pollTimeout=setTimeout(check,interval)}()}function cacheStateAndFireUrlChange(){cacheState(),fireUrlChange()}function getCurrentState(){try{return history.state}catch(e){}}function cacheState(){cachedState=getCurrentState(),cachedState=isUndefined(cachedState)?null:cachedState,equals(cachedState,lastCachedState)&&(cachedState=lastCachedState),lastCachedState=cachedState}function fireUrlChange(){(lastBrowserUrl!==self.url()||lastHistoryState!==cachedState)&&(lastBrowserUrl=self.url(),lastHistoryState=cachedState,forEach(urlChangeListeners,function(listener){listener(self.url(),cachedState)}))}function safeDecodeURIComponent(str){try{return decodeURIComponent(str)}catch(e){return str}}var self=this,rawDocument=document[0],location=window.location,history=window.history,setTimeout=window.setTimeout,clearTimeout=window.clearTimeout,pendingDeferIds={};self.isMock=!1;var outstandingRequestCount=0,outstandingRequestCallbacks=[];self.$$completeOutstandingRequest=completeOutstandingRequest,self.$$incOutstandingRequestCount=function(){outstandingRequestCount++},self.notifyWhenNoOutstandingRequests=function(callback){forEach(pollFns,function(pollFn){pollFn()}),0===outstandingRequestCount?callback():outstandingRequestCallbacks.push(callback)};var pollTimeout,pollFns=[];self.addPollFn=function(fn){return isUndefined(pollTimeout)&&startPoller(100,setTimeout),pollFns.push(fn),fn};var cachedState,lastHistoryState,lastBrowserUrl=location.href,baseElement=document.find("base"),reloadLocation=null;cacheState(),lastHistoryState=cachedState,self.url=function(url,replace,state){if(isUndefined(state)&&(state=null),location!==window.location&&(location=window.location),history!==window.history&&(history=window.history),url){var sameState=lastHistoryState===state;if(lastBrowserUrl===url&&(!$sniffer.history||sameState))return self;var sameBase=lastBrowserUrl&&stripHash(lastBrowserUrl)===stripHash(url);return lastBrowserUrl=url,lastHistoryState=state,!$sniffer.history||sameBase&&sameState?((!sameBase||reloadLocation)&&(reloadLocation=url),replace?location.replace(url):sameBase?location.hash=getHash(url):location.href=url):(history[replace?"replaceState":"pushState"](state,"",url),cacheState(),lastHistoryState=cachedState),self}return reloadLocation||location.href.replace(/%27/g,"'")},self.state=function(){return cachedState};var urlChangeListeners=[],urlChangeInit=!1,lastCachedState=null;self.onUrlChange=function(callback){return urlChangeInit||($sniffer.history&&jqLite(window).on("popstate",cacheStateAndFireUrlChange),jqLite(window).on("hashchange",cacheStateAndFireUrlChange),urlChangeInit=!0),urlChangeListeners.push(callback),callback},self.$$checkUrlChange=fireUrlChange,self.baseHref=function(){var href=baseElement.attr("href");return href?href.replace(/^(https?\:)?\/\/[^\/]*/,""):""};var lastCookies={},lastCookieString="",cookiePath=self.baseHref();self.cookies=function(name,value){var cookieLength,cookieArray,cookie,i,index;if(!name){if(rawDocument.cookie!==lastCookieString)for(lastCookieString=rawDocument.cookie,cookieArray=lastCookieString.split("; "),lastCookies={},i=0;i<cookieArray.length;i++)cookie=cookieArray[i],index=cookie.indexOf("="),index>0&&(name=safeDecodeURIComponent(cookie.substring(0,index)),lastCookies[name]===undefined&&(lastCookies[name]=safeDecodeURIComponent(cookie.substring(index+1))));return lastCookies}value===undefined?rawDocument.cookie=encodeURIComponent(name)+"=;path="+cookiePath+";expires=Thu, 01 Jan 1970 00:00:00 GMT":isString(value)&&(cookieLength=(rawDocument.cookie=encodeURIComponent(name)+"="+encodeURIComponent(value)+";path="+cookiePath).length+1,cookieLength>4096&&$log.warn("Cookie '"+name+"' possibly not set or overflowed because it was too large ("+cookieLength+" > 4096 bytes)!"))},self.defer=function(fn,delay){var timeoutId;return outstandingRequestCount++,timeoutId=setTimeout(function(){delete pendingDeferIds[timeoutId],completeOutstandingRequest(fn)},delay||0),pendingDeferIds[timeoutId]=!0,timeoutId},self.defer.cancel=function(deferId){return pendingDeferIds[deferId]?(delete pendingDeferIds[deferId],clearTimeout(deferId),completeOutstandingRequest(noop),!0):!1}}function $BrowserProvider(){this.$get=["$window","$log","$sniffer","$document",function($window,$log,$sniffer,$document){return new Browser($window,$document,$log,$sniffer)}]}function $CacheFactoryProvider(){this.$get=function(){function cacheFactory(cacheId,options){function refresh(entry){entry!=freshEnd&&(staleEnd?staleEnd==entry&&(staleEnd=entry.n):staleEnd=entry,link(entry.n,entry.p),link(entry,freshEnd),freshEnd=entry,freshEnd.n=null)}function link(nextEntry,prevEntry){nextEntry!=prevEntry&&(nextEntry&&(nextEntry.p=prevEntry),prevEntry&&(prevEntry.n=nextEntry))}if(cacheId in caches)throw minErr("$cacheFactory")("iid","CacheId '{0}' is already taken!",cacheId);var size=0,stats=extend({},options,{id:cacheId}),data={},capacity=options&&options.capacity||Number.MAX_VALUE,lruHash={},freshEnd=null,staleEnd=null;return caches[cacheId]={put:function(key,value){if(capacity<Number.MAX_VALUE){var lruEntry=lruHash[key]||(lruHash[key]={key:key});refresh(lruEntry)}if(!isUndefined(value))return key in data||size++,data[key]=value,size>capacity&&this.remove(staleEnd.key),value},get:function(key){if(capacity<Number.MAX_VALUE){var lruEntry=lruHash[key];if(!lruEntry)return;refresh(lruEntry)}return data[key]},remove:function(key){if(capacity<Number.MAX_VALUE){var lruEntry=lruHash[key];if(!lruEntry)return;lruEntry==freshEnd&&(freshEnd=lruEntry.p),lruEntry==staleEnd&&(staleEnd=lruEntry.n),link(lruEntry.n,lruEntry.p),delete lruHash[key]}delete data[key],size--},removeAll:function(){data={},size=0,lruHash={},freshEnd=staleEnd=null},destroy:function(){data=null,stats=null,lruHash=null,delete caches[cacheId]},info:function(){return extend({},stats,{size:size})}}}var caches={};return cacheFactory.info=function(){var info={};return forEach(caches,function(cache,cacheId){info[cacheId]=cache.info()}),info},cacheFactory.get=function(cacheId){return caches[cacheId]},cacheFactory}}function $TemplateCacheProvider(){this.$get=["$cacheFactory",function($cacheFactory){return $cacheFactory("templates")}]}function $CompileProvider($provide,$$sanitizeUriProvider){function parseIsolateBindings(scope,directiveName){var LOCAL_REGEXP=/^\s*([@&]|=(\*?))(\??)\s*(\w*)\s*$/,bindings={};return forEach(scope,function(definition,scopeName){var match=definition.match(LOCAL_REGEXP);if(!match)throw $compileMinErr("iscp","Invalid isolate scope definition for directive '{0}'. Definition: {... {1}: '{2}' ...}",directiveName,scopeName,definition);bindings[scopeName]={mode:match[1][0],collection:"*"===match[2],optional:"?"===match[3],attrName:match[4]||scopeName}}),bindings}var hasDirectives={},Suffix="Directive",COMMENT_DIRECTIVE_REGEXP=/^\s*directive\:\s*([\w\-]+)\s+(.*)$/,CLASS_DIRECTIVE_REGEXP=/(([\w\-]+)(?:\:([^;]+))?;?)/,ALL_OR_NOTHING_ATTRS=makeMap("ngSrc,ngSrcset,src,srcset"),REQUIRE_PREFIX_REGEXP=/^(?:(\^\^?)?(\?)?(\^\^?)?)?/,EVENT_HANDLER_ATTR_REGEXP=/^(on[a-z]+|formaction)$/;this.directive=function registerDirective(name,directiveFactory){return assertNotHasOwnProperty(name,"directive"),isString(name)?(assertArg(directiveFactory,"directiveFactory"),hasDirectives.hasOwnProperty(name)||(hasDirectives[name]=[],$provide.factory(name+Suffix,["$injector","$exceptionHandler",function($injector,$exceptionHandler){var directives=[];return forEach(hasDirectives[name],function(directiveFactory,index){try{var directive=$injector.invoke(directiveFactory);isFunction(directive)?directive={compile:valueFn(directive)}:!directive.compile&&directive.link&&(directive.compile=valueFn(directive.link)),directive.priority=directive.priority||0,directive.index=index,directive.name=directive.name||name,directive.require=directive.require||directive.controller&&directive.name,directive.restrict=directive.restrict||"EA",isObject(directive.scope)&&(directive.$$isolateBindings=parseIsolateBindings(directive.scope,directive.name)),directives.push(directive)}catch(e){$exceptionHandler(e)}}),directives}])),hasDirectives[name].push(directiveFactory)):forEach(name,reverseParams(registerDirective)),this},this.aHrefSanitizationWhitelist=function(regexp){return isDefined(regexp)?($$sanitizeUriProvider.aHrefSanitizationWhitelist(regexp),this):$$sanitizeUriProvider.aHrefSanitizationWhitelist()},this.imgSrcSanitizationWhitelist=function(regexp){return isDefined(regexp)?($$sanitizeUriProvider.imgSrcSanitizationWhitelist(regexp),this):$$sanitizeUriProvider.imgSrcSanitizationWhitelist()};var debugInfoEnabled=!0;this.debugInfoEnabled=function(enabled){return isDefined(enabled)?(debugInfoEnabled=enabled,this):debugInfoEnabled},this.$get=["$injector","$interpolate","$exceptionHandler","$templateRequest","$parse","$controller","$rootScope","$document","$sce","$animate","$$sanitizeUri",function($injector,$interpolate,$exceptionHandler,$templateRequest,$parse,$controller,$rootScope,$document,$sce,$animate,$$sanitizeUri){function safeAddClass($element,className){try{$element.addClass(className)}catch(e){}}function compile($compileNodes,transcludeFn,maxPriority,ignoreDirective,previousCompileContext){$compileNodes instanceof jqLite||($compileNodes=jqLite($compileNodes)),forEach($compileNodes,function(node,index){node.nodeType==NODE_TYPE_TEXT&&node.nodeValue.match(/\S+/)&&($compileNodes[index]=jqLite(node).wrap("<span></span>").parent()[0])});var compositeLinkFn=compileNodes($compileNodes,transcludeFn,$compileNodes,maxPriority,ignoreDirective,previousCompileContext);compile.$$addScopeClass($compileNodes);var namespace=null;return function(scope,cloneConnectFn,options){assertArg(scope,"scope"),options=options||{};var parentBoundTranscludeFn=options.parentBoundTranscludeFn,transcludeControllers=options.transcludeControllers,futureParentElement=options.futureParentElement;parentBoundTranscludeFn&&parentBoundTranscludeFn.$$boundTransclude&&(parentBoundTranscludeFn=parentBoundTranscludeFn.$$boundTransclude),namespace||(namespace=detectNamespaceForChildElements(futureParentElement));var $linkNode;if($linkNode="html"!==namespace?jqLite(wrapTemplate(namespace,jqLite("<div>").append($compileNodes).html())):cloneConnectFn?JQLitePrototype.clone.call($compileNodes):$compileNodes,transcludeControllers)for(var controllerName in transcludeControllers)$linkNode.data("$"+controllerName+"Controller",transcludeControllers[controllerName].instance);return compile.$$addScopeInfo($linkNode,scope),cloneConnectFn&&cloneConnectFn($linkNode,scope),compositeLinkFn&&compositeLinkFn(scope,$linkNode,$linkNode,parentBoundTranscludeFn),$linkNode}}function detectNamespaceForChildElements(parentElement){var node=parentElement&&parentElement[0];return node&&"foreignobject"!==nodeName_(node)&&node.toString().match(/SVG/)?"svg":"html"}function compileNodes(nodeList,transcludeFn,$rootElement,maxPriority,ignoreDirective,previousCompileContext){function compositeLinkFn(scope,nodeList,$rootElement,parentBoundTranscludeFn){var nodeLinkFn,childLinkFn,node,childScope,i,ii,idx,childBoundTranscludeFn,stableNodeList;if(nodeLinkFnFound){var nodeListLength=nodeList.length;for(stableNodeList=new Array(nodeListLength),i=0;i<linkFns.length;i+=3)idx=linkFns[i],stableNodeList[idx]=nodeList[idx]}else stableNodeList=nodeList;for(i=0,ii=linkFns.length;ii>i;)node=stableNodeList[linkFns[i++]],nodeLinkFn=linkFns[i++],childLinkFn=linkFns[i++],nodeLinkFn?(nodeLinkFn.scope?(childScope=scope.$new(),compile.$$addScopeInfo(jqLite(node),childScope)):childScope=scope,childBoundTranscludeFn=nodeLinkFn.transcludeOnThisElement?createBoundTranscludeFn(scope,nodeLinkFn.transclude,parentBoundTranscludeFn,nodeLinkFn.elementTranscludeOnThisElement):!nodeLinkFn.templateOnThisElement&&parentBoundTranscludeFn?parentBoundTranscludeFn:!parentBoundTranscludeFn&&transcludeFn?createBoundTranscludeFn(scope,transcludeFn):null,nodeLinkFn(childLinkFn,childScope,node,$rootElement,childBoundTranscludeFn)):childLinkFn&&childLinkFn(scope,node.childNodes,undefined,parentBoundTranscludeFn)}for(var attrs,directives,nodeLinkFn,childNodes,childLinkFn,linkFnFound,nodeLinkFnFound,linkFns=[],i=0;i<nodeList.length;i++)attrs=new Attributes,directives=collectDirectives(nodeList[i],[],attrs,0===i?maxPriority:undefined,ignoreDirective),nodeLinkFn=directives.length?applyDirectivesToNode(directives,nodeList[i],attrs,transcludeFn,$rootElement,null,[],[],previousCompileContext):null,nodeLinkFn&&nodeLinkFn.scope&&compile.$$addScopeClass(attrs.$$element),childLinkFn=nodeLinkFn&&nodeLinkFn.terminal||!(childNodes=nodeList[i].childNodes)||!childNodes.length?null:compileNodes(childNodes,nodeLinkFn?(nodeLinkFn.transcludeOnThisElement||!nodeLinkFn.templateOnThisElement)&&nodeLinkFn.transclude:transcludeFn),(nodeLinkFn||childLinkFn)&&(linkFns.push(i,nodeLinkFn,childLinkFn),linkFnFound=!0,nodeLinkFnFound=nodeLinkFnFound||nodeLinkFn),previousCompileContext=null;return linkFnFound?compositeLinkFn:null}function createBoundTranscludeFn(scope,transcludeFn,previousBoundTranscludeFn,elementTransclusion){var boundTranscludeFn=function(transcludedScope,cloneFn,controllers,futureParentElement,containingScope){return transcludedScope||(transcludedScope=scope.$new(!1,containingScope),transcludedScope.$$transcluded=!0),transcludeFn(transcludedScope,cloneFn,{parentBoundTranscludeFn:previousBoundTranscludeFn,transcludeControllers:controllers,futureParentElement:futureParentElement})};return boundTranscludeFn}function collectDirectives(node,directives,attrs,maxPriority,ignoreDirective){var match,className,nodeType=node.nodeType,attrsMap=attrs.$attr;switch(nodeType){case NODE_TYPE_ELEMENT:addDirective(directives,directiveNormalize(nodeName_(node)),"E",maxPriority,ignoreDirective);for(var attr,name,nName,ngAttrName,value,isNgAttr,nAttrs=node.attributes,j=0,jj=nAttrs&&nAttrs.length;jj>j;j++){var attrStartName=!1,attrEndName=!1;attr=nAttrs[j],name=attr.name,value=trim(attr.value),ngAttrName=directiveNormalize(name),(isNgAttr=NG_ATTR_BINDING.test(ngAttrName))&&(name=name.replace(PREFIX_REGEXP,"").substr(8).replace(/_(.)/g,function(match,letter){return letter.toUpperCase()}));var directiveNName=ngAttrName.replace(/(Start|End)$/,"");directiveIsMultiElement(directiveNName)&&ngAttrName===directiveNName+"Start"&&(attrStartName=name,attrEndName=name.substr(0,name.length-5)+"end",name=name.substr(0,name.length-6)),nName=directiveNormalize(name.toLowerCase()),attrsMap[nName]=name,(isNgAttr||!attrs.hasOwnProperty(nName))&&(attrs[nName]=value,getBooleanAttrName(node,nName)&&(attrs[nName]=!0)),addAttrInterpolateDirective(node,directives,value,nName,isNgAttr),addDirective(directives,nName,"A",maxPriority,ignoreDirective,attrStartName,attrEndName)}if(className=node.className,isObject(className)&&(className=className.animVal),isString(className)&&""!==className)for(;match=CLASS_DIRECTIVE_REGEXP.exec(className);)nName=directiveNormalize(match[2]),addDirective(directives,nName,"C",maxPriority,ignoreDirective)&&(attrs[nName]=trim(match[3])),className=className.substr(match.index+match[0].length);break;case NODE_TYPE_TEXT:addTextInterpolateDirective(directives,node.nodeValue);break;case NODE_TYPE_COMMENT:try{match=COMMENT_DIRECTIVE_REGEXP.exec(node.nodeValue),match&&(nName=directiveNormalize(match[1]),addDirective(directives,nName,"M",maxPriority,ignoreDirective)&&(attrs[nName]=trim(match[2])))}catch(e){}}return directives.sort(byPriority),directives}function groupScan(node,attrStart,attrEnd){var nodes=[],depth=0;if(attrStart&&node.hasAttribute&&node.hasAttribute(attrStart)){do{if(!node)throw $compileMinErr("uterdir","Unterminated attribute, found '{0}' but no matching '{1}' found.",attrStart,attrEnd);node.nodeType==NODE_TYPE_ELEMENT&&(node.hasAttribute(attrStart)&&depth++,node.hasAttribute(attrEnd)&&depth--),nodes.push(node),node=node.nextSibling}while(depth>0)}else nodes.push(node);return jqLite(nodes)}function groupElementsLinkFnWrapper(linkFn,attrStart,attrEnd){return function(scope,element,attrs,controllers,transcludeFn){return element=groupScan(element[0],attrStart,attrEnd),linkFn(scope,element,attrs,controllers,transcludeFn)}}function applyDirectivesToNode(directives,compileNode,templateAttrs,transcludeFn,jqCollection,originalReplaceDirective,preLinkFns,postLinkFns,previousCompileContext){function addLinkFns(pre,post,attrStart,attrEnd){pre&&(attrStart&&(pre=groupElementsLinkFnWrapper(pre,attrStart,attrEnd)),pre.require=directive.require,pre.directiveName=directiveName,(newIsolateScopeDirective===directive||directive.$$isolateScope)&&(pre=cloneAndAnnotateFn(pre,{isolateScope:!0})),preLinkFns.push(pre)),post&&(attrStart&&(post=groupElementsLinkFnWrapper(post,attrStart,attrEnd)),post.require=directive.require,post.directiveName=directiveName,(newIsolateScopeDirective===directive||directive.$$isolateScope)&&(post=cloneAndAnnotateFn(post,{isolateScope:!0})),postLinkFns.push(post))}function getControllers(directiveName,require,$element,elementControllers){var value,match,retrievalMethod="data",optional=!1,$searchElement=$element;if(isString(require)){if(match=require.match(REQUIRE_PREFIX_REGEXP),require=require.substring(match[0].length),match[3]&&(match[1]?match[3]=null:match[1]=match[3]),"^"===match[1]?retrievalMethod="inheritedData":"^^"===match[1]&&(retrievalMethod="inheritedData",$searchElement=$element.parent()),"?"===match[2]&&(optional=!0),value=null,elementControllers&&"data"===retrievalMethod&&(value=elementControllers[require])&&(value=value.instance),value=value||$searchElement[retrievalMethod]("$"+require+"Controller"),!value&&!optional)throw $compileMinErr("ctreq","Controller '{0}', required by directive '{1}', can't be found!",require,directiveName);return value||null}return isArray(require)&&(value=[],forEach(require,function(require){value.push(getControllers(directiveName,require,$element,elementControllers))})),value}function nodeLinkFn(childLinkFn,scope,linkNode,$rootElement,boundTranscludeFn){function controllersBoundTransclude(scope,cloneAttachFn,futureParentElement){var transcludeControllers;return isScope(scope)||(futureParentElement=cloneAttachFn,cloneAttachFn=scope,scope=undefined),hasElementTranscludeDirective&&(transcludeControllers=elementControllers),futureParentElement||(futureParentElement=hasElementTranscludeDirective?$element.parent():$element),boundTranscludeFn(scope,cloneAttachFn,transcludeControllers,futureParentElement,scopeToChild)}var i,ii,linkFn,controller,isolateScope,elementControllers,transcludeFn,$element,attrs;if(compileNode===linkNode?(attrs=templateAttrs,$element=templateAttrs.$$element):($element=jqLite(linkNode),attrs=new Attributes($element,templateAttrs)),newIsolateScopeDirective&&(isolateScope=scope.$new(!0)),boundTranscludeFn&&(transcludeFn=controllersBoundTransclude,transcludeFn.$$boundTransclude=boundTranscludeFn),controllerDirectives&&(controllers={},elementControllers={},forEach(controllerDirectives,function(directive){var controllerInstance,locals={$scope:directive===newIsolateScopeDirective||directive.$$isolateScope?isolateScope:scope,$element:$element,$attrs:attrs,$transclude:transcludeFn};controller=directive.controller,"@"==controller&&(controller=attrs[directive.name]),controllerInstance=$controller(controller,locals,!0,directive.controllerAs),elementControllers[directive.name]=controllerInstance,hasElementTranscludeDirective||$element.data("$"+directive.name+"Controller",controllerInstance.instance),controllers[directive.name]=controllerInstance})),newIsolateScopeDirective){compile.$$addScopeInfo($element,isolateScope,!0,!(templateDirective&&(templateDirective===newIsolateScopeDirective||templateDirective===newIsolateScopeDirective.$$originalDirective))),compile.$$addScopeClass($element,!0);var isolateScopeController=controllers&&controllers[newIsolateScopeDirective.name],isolateBindingContext=isolateScope;isolateScopeController&&isolateScopeController.identifier&&newIsolateScopeDirective.bindToController===!0&&(isolateBindingContext=isolateScopeController.instance),forEach(isolateScope.$$isolateBindings=newIsolateScopeDirective.$$isolateBindings,function(definition,scopeName){var lastValue,parentGet,parentSet,compare,attrName=definition.attrName,optional=definition.optional,mode=definition.mode;switch(mode){case"@":attrs.$observe(attrName,function(value){isolateBindingContext[scopeName]=value}),attrs.$$observers[attrName].$$scope=scope,attrs[attrName]&&(isolateBindingContext[scopeName]=$interpolate(attrs[attrName])(scope));break;case"=":if(optional&&!attrs[attrName])return;parentGet=$parse(attrs[attrName]),compare=parentGet.literal?equals:function(a,b){return a===b||a!==a&&b!==b},parentSet=parentGet.assign||function(){throw lastValue=isolateBindingContext[scopeName]=parentGet(scope),$compileMinErr("nonassign","Expression '{0}' used with directive '{1}' is non-assignable!",attrs[attrName],newIsolateScopeDirective.name)},lastValue=isolateBindingContext[scopeName]=parentGet(scope);var parentValueWatch=function(parentValue){return compare(parentValue,isolateBindingContext[scopeName])||(compare(parentValue,lastValue)?parentSet(scope,parentValue=isolateBindingContext[scopeName]):isolateBindingContext[scopeName]=parentValue),lastValue=parentValue};parentValueWatch.$stateful=!0;var unwatch;unwatch=definition.collection?scope.$watchCollection(attrs[attrName],parentValueWatch):scope.$watch($parse(attrs[attrName],parentValueWatch),null,parentGet.literal),isolateScope.$on("$destroy",unwatch);break;case"&":parentGet=$parse(attrs[attrName]),isolateBindingContext[scopeName]=function(locals){return parentGet(scope,locals)}}})}for(controllers&&(forEach(controllers,function(controller){controller()}),controllers=null),i=0,ii=preLinkFns.length;ii>i;i++)linkFn=preLinkFns[i],invokeLinkFn(linkFn,linkFn.isolateScope?isolateScope:scope,$element,attrs,linkFn.require&&getControllers(linkFn.directiveName,linkFn.require,$element,elementControllers),transcludeFn);var scopeToChild=scope;for(newIsolateScopeDirective&&(newIsolateScopeDirective.template||null===newIsolateScopeDirective.templateUrl)&&(scopeToChild=isolateScope),childLinkFn&&childLinkFn(scopeToChild,linkNode.childNodes,undefined,boundTranscludeFn),i=postLinkFns.length-1;i>=0;i--)linkFn=postLinkFns[i],invokeLinkFn(linkFn,linkFn.isolateScope?isolateScope:scope,$element,attrs,linkFn.require&&getControllers(linkFn.directiveName,linkFn.require,$element,elementControllers),transcludeFn)}previousCompileContext=previousCompileContext||{};for(var newScopeDirective,controllers,directive,directiveName,$template,linkFn,directiveValue,terminalPriority=-Number.MAX_VALUE,controllerDirectives=previousCompileContext.controllerDirectives,newIsolateScopeDirective=previousCompileContext.newIsolateScopeDirective,templateDirective=previousCompileContext.templateDirective,nonTlbTranscludeDirective=previousCompileContext.nonTlbTranscludeDirective,hasTranscludeDirective=!1,hasTemplate=!1,hasElementTranscludeDirective=previousCompileContext.hasElementTranscludeDirective,$compileNode=templateAttrs.$$element=jqLite(compileNode),replaceDirective=originalReplaceDirective,childTranscludeFn=transcludeFn,i=0,ii=directives.length;ii>i;i++){directive=directives[i];var attrStart=directive.$$start,attrEnd=directive.$$end;if(attrStart&&($compileNode=groupScan(compileNode,attrStart,attrEnd)),$template=undefined,terminalPriority>directive.priority)break;if((directiveValue=directive.scope)&&(directive.templateUrl||(isObject(directiveValue)?(assertNoDuplicate("new/isolated scope",newIsolateScopeDirective||newScopeDirective,directive,$compileNode),newIsolateScopeDirective=directive):assertNoDuplicate("new/isolated scope",newIsolateScopeDirective,directive,$compileNode)),newScopeDirective=newScopeDirective||directive),directiveName=directive.name,!directive.templateUrl&&directive.controller&&(directiveValue=directive.controller,controllerDirectives=controllerDirectives||{},assertNoDuplicate("'"+directiveName+"' controller",controllerDirectives[directiveName],directive,$compileNode),controllerDirectives[directiveName]=directive),(directiveValue=directive.transclude)&&(hasTranscludeDirective=!0,directive.$$tlb||(assertNoDuplicate("transclusion",nonTlbTranscludeDirective,directive,$compileNode),nonTlbTranscludeDirective=directive),"element"==directiveValue?(hasElementTranscludeDirective=!0,terminalPriority=directive.priority,$template=$compileNode,$compileNode=templateAttrs.$$element=jqLite(document.createComment(" "+directiveName+": "+templateAttrs[directiveName]+" ")),compileNode=$compileNode[0],replaceWith(jqCollection,sliceArgs($template),compileNode),childTranscludeFn=compile($template,transcludeFn,terminalPriority,replaceDirective&&replaceDirective.name,{nonTlbTranscludeDirective:nonTlbTranscludeDirective})):($template=jqLite(jqLiteClone(compileNode)).contents(),$compileNode.empty(),childTranscludeFn=compile($template,transcludeFn))),directive.template)if(hasTemplate=!0,assertNoDuplicate("template",templateDirective,directive,$compileNode),templateDirective=directive,directiveValue=isFunction(directive.template)?directive.template($compileNode,templateAttrs):directive.template,directiveValue=denormalizeTemplate(directiveValue),directive.replace){if(replaceDirective=directive,$template=jqLiteIsTextNode(directiveValue)?[]:removeComments(wrapTemplate(directive.templateNamespace,trim(directiveValue))),compileNode=$template[0],1!=$template.length||compileNode.nodeType!==NODE_TYPE_ELEMENT)throw $compileMinErr("tplrt","Template for directive '{0}' must have exactly one root element. {1}",directiveName,"");
replaceWith(jqCollection,$compileNode,compileNode);var newTemplateAttrs={$attr:{}},templateDirectives=collectDirectives(compileNode,[],newTemplateAttrs),unprocessedDirectives=directives.splice(i+1,directives.length-(i+1));newIsolateScopeDirective&&markDirectivesAsIsolate(templateDirectives),directives=directives.concat(templateDirectives).concat(unprocessedDirectives),mergeTemplateAttributes(templateAttrs,newTemplateAttrs),ii=directives.length}else $compileNode.html(directiveValue);if(directive.templateUrl)hasTemplate=!0,assertNoDuplicate("template",templateDirective,directive,$compileNode),templateDirective=directive,directive.replace&&(replaceDirective=directive),nodeLinkFn=compileTemplateUrl(directives.splice(i,directives.length-i),$compileNode,templateAttrs,jqCollection,hasTranscludeDirective&&childTranscludeFn,preLinkFns,postLinkFns,{controllerDirectives:controllerDirectives,newIsolateScopeDirective:newIsolateScopeDirective,templateDirective:templateDirective,nonTlbTranscludeDirective:nonTlbTranscludeDirective}),ii=directives.length;else if(directive.compile)try{linkFn=directive.compile($compileNode,templateAttrs,childTranscludeFn),isFunction(linkFn)?addLinkFns(null,linkFn,attrStart,attrEnd):linkFn&&addLinkFns(linkFn.pre,linkFn.post,attrStart,attrEnd)}catch(e){$exceptionHandler(e,startingTag($compileNode))}directive.terminal&&(nodeLinkFn.terminal=!0,terminalPriority=Math.max(terminalPriority,directive.priority))}return nodeLinkFn.scope=newScopeDirective&&newScopeDirective.scope===!0,nodeLinkFn.transcludeOnThisElement=hasTranscludeDirective,nodeLinkFn.elementTranscludeOnThisElement=hasElementTranscludeDirective,nodeLinkFn.templateOnThisElement=hasTemplate,nodeLinkFn.transclude=childTranscludeFn,previousCompileContext.hasElementTranscludeDirective=hasElementTranscludeDirective,nodeLinkFn}function markDirectivesAsIsolate(directives){for(var j=0,jj=directives.length;jj>j;j++)directives[j]=inherit(directives[j],{$$isolateScope:!0})}function addDirective(tDirectives,name,location,maxPriority,ignoreDirective,startAttrName,endAttrName){if(name===ignoreDirective)return null;var match=null;if(hasDirectives.hasOwnProperty(name))for(var directive,directives=$injector.get(name+Suffix),i=0,ii=directives.length;ii>i;i++)try{directive=directives[i],(maxPriority===undefined||maxPriority>directive.priority)&&-1!=directive.restrict.indexOf(location)&&(startAttrName&&(directive=inherit(directive,{$$start:startAttrName,$$end:endAttrName})),tDirectives.push(directive),match=directive)}catch(e){$exceptionHandler(e)}return match}function directiveIsMultiElement(name){if(hasDirectives.hasOwnProperty(name))for(var directive,directives=$injector.get(name+Suffix),i=0,ii=directives.length;ii>i;i++)if(directive=directives[i],directive.multiElement)return!0;return!1}function mergeTemplateAttributes(dst,src){var srcAttr=src.$attr,dstAttr=dst.$attr,$element=dst.$$element;forEach(dst,function(value,key){"$"!=key.charAt(0)&&(src[key]&&src[key]!==value&&(value+=("style"===key?";":" ")+src[key]),dst.$set(key,value,!0,srcAttr[key]))}),forEach(src,function(value,key){"class"==key?(safeAddClass($element,value),dst["class"]=(dst["class"]?dst["class"]+" ":"")+value):"style"==key?($element.attr("style",$element.attr("style")+";"+value),dst.style=(dst.style?dst.style+";":"")+value):"$"==key.charAt(0)||dst.hasOwnProperty(key)||(dst[key]=value,dstAttr[key]=srcAttr[key])})}function compileTemplateUrl(directives,$compileNode,tAttrs,$rootElement,childTranscludeFn,preLinkFns,postLinkFns,previousCompileContext){var afterTemplateNodeLinkFn,afterTemplateChildLinkFn,linkQueue=[],beforeTemplateCompileNode=$compileNode[0],origAsyncDirective=directives.shift(),derivedSyncDirective=inherit(origAsyncDirective,{templateUrl:null,transclude:null,replace:null,$$originalDirective:origAsyncDirective}),templateUrl=isFunction(origAsyncDirective.templateUrl)?origAsyncDirective.templateUrl($compileNode,tAttrs):origAsyncDirective.templateUrl,templateNamespace=origAsyncDirective.templateNamespace;return $compileNode.empty(),$templateRequest(templateUrl).then(function(content){var compileNode,tempTemplateAttrs,$template,childBoundTranscludeFn;if(content=denormalizeTemplate(content),origAsyncDirective.replace){if($template=jqLiteIsTextNode(content)?[]:removeComments(wrapTemplate(templateNamespace,trim(content))),compileNode=$template[0],1!=$template.length||compileNode.nodeType!==NODE_TYPE_ELEMENT)throw $compileMinErr("tplrt","Template for directive '{0}' must have exactly one root element. {1}",origAsyncDirective.name,templateUrl);tempTemplateAttrs={$attr:{}},replaceWith($rootElement,$compileNode,compileNode);var templateDirectives=collectDirectives(compileNode,[],tempTemplateAttrs);isObject(origAsyncDirective.scope)&&markDirectivesAsIsolate(templateDirectives),directives=templateDirectives.concat(directives),mergeTemplateAttributes(tAttrs,tempTemplateAttrs)}else compileNode=beforeTemplateCompileNode,$compileNode.html(content);for(directives.unshift(derivedSyncDirective),afterTemplateNodeLinkFn=applyDirectivesToNode(directives,compileNode,tAttrs,childTranscludeFn,$compileNode,origAsyncDirective,preLinkFns,postLinkFns,previousCompileContext),forEach($rootElement,function(node,i){node==compileNode&&($rootElement[i]=$compileNode[0])}),afterTemplateChildLinkFn=compileNodes($compileNode[0].childNodes,childTranscludeFn);linkQueue.length;){var scope=linkQueue.shift(),beforeTemplateLinkNode=linkQueue.shift(),linkRootElement=linkQueue.shift(),boundTranscludeFn=linkQueue.shift(),linkNode=$compileNode[0];if(!scope.$$destroyed){if(beforeTemplateLinkNode!==beforeTemplateCompileNode){var oldClasses=beforeTemplateLinkNode.className;previousCompileContext.hasElementTranscludeDirective&&origAsyncDirective.replace||(linkNode=jqLiteClone(compileNode)),replaceWith(linkRootElement,jqLite(beforeTemplateLinkNode),linkNode),safeAddClass(jqLite(linkNode),oldClasses)}childBoundTranscludeFn=afterTemplateNodeLinkFn.transcludeOnThisElement?createBoundTranscludeFn(scope,afterTemplateNodeLinkFn.transclude,boundTranscludeFn):boundTranscludeFn,afterTemplateNodeLinkFn(afterTemplateChildLinkFn,scope,linkNode,$rootElement,childBoundTranscludeFn)}}linkQueue=null}),function(ignoreChildLinkFn,scope,node,rootElement,boundTranscludeFn){var childBoundTranscludeFn=boundTranscludeFn;scope.$$destroyed||(linkQueue?linkQueue.push(scope,node,rootElement,childBoundTranscludeFn):(afterTemplateNodeLinkFn.transcludeOnThisElement&&(childBoundTranscludeFn=createBoundTranscludeFn(scope,afterTemplateNodeLinkFn.transclude,boundTranscludeFn)),afterTemplateNodeLinkFn(afterTemplateChildLinkFn,scope,node,rootElement,childBoundTranscludeFn)))}}function byPriority(a,b){var diff=b.priority-a.priority;return 0!==diff?diff:a.name!==b.name?a.name<b.name?-1:1:a.index-b.index}function assertNoDuplicate(what,previousDirective,directive,element){if(previousDirective)throw $compileMinErr("multidir","Multiple directives [{0}, {1}] asking for {2} on: {3}",previousDirective.name,directive.name,what,startingTag(element))}function addTextInterpolateDirective(directives,text){var interpolateFn=$interpolate(text,!0);interpolateFn&&directives.push({priority:0,compile:function(templateNode){var templateNodeParent=templateNode.parent(),hasCompileParent=!!templateNodeParent.length;return hasCompileParent&&compile.$$addBindingClass(templateNodeParent),function(scope,node){var parent=node.parent();hasCompileParent||compile.$$addBindingClass(parent),compile.$$addBindingInfo(parent,interpolateFn.expressions),scope.$watch(interpolateFn,function(value){node[0].nodeValue=value})}}})}function wrapTemplate(type,template){switch(type=lowercase(type||"html")){case"svg":case"math":var wrapper=document.createElement("div");return wrapper.innerHTML="<"+type+">"+template+"</"+type+">",wrapper.childNodes[0].childNodes;default:return template}}function getTrustedContext(node,attrNormalizedName){if("srcdoc"==attrNormalizedName)return $sce.HTML;var tag=nodeName_(node);return"xlinkHref"==attrNormalizedName||"form"==tag&&"action"==attrNormalizedName||"img"!=tag&&("src"==attrNormalizedName||"ngSrc"==attrNormalizedName)?$sce.RESOURCE_URL:void 0}function addAttrInterpolateDirective(node,directives,value,name,allOrNothing){var trustedContext=getTrustedContext(node,name);allOrNothing=ALL_OR_NOTHING_ATTRS[name]||allOrNothing;var interpolateFn=$interpolate(value,!0,trustedContext,allOrNothing);if(interpolateFn){if("multiple"===name&&"select"===nodeName_(node))throw $compileMinErr("selmulti","Binding to the 'multiple' attribute is not supported. Element: {0}",startingTag(node));directives.push({priority:100,compile:function(){return{pre:function(scope,element,attr){var $$observers=attr.$$observers||(attr.$$observers={});if(EVENT_HANDLER_ATTR_REGEXP.test(name))throw $compileMinErr("nodomevents","Interpolations for HTML DOM event attributes are disallowed.  Please use the ng- versions (such as ng-click instead of onclick) instead.");var newValue=attr[name];newValue!==value&&(interpolateFn=newValue&&$interpolate(newValue,!0,trustedContext,allOrNothing),value=newValue),interpolateFn&&(attr[name]=interpolateFn(scope),($$observers[name]||($$observers[name]=[])).$$inter=!0,(attr.$$observers&&attr.$$observers[name].$$scope||scope).$watch(interpolateFn,function(newValue,oldValue){"class"===name&&newValue!=oldValue?attr.$updateClass(newValue,oldValue):attr.$set(name,newValue)}))}}}})}}function replaceWith($rootElement,elementsToRemove,newNode){var i,ii,firstElementToRemove=elementsToRemove[0],removeCount=elementsToRemove.length,parent=firstElementToRemove.parentNode;if($rootElement)for(i=0,ii=$rootElement.length;ii>i;i++)if($rootElement[i]==firstElementToRemove){$rootElement[i++]=newNode;for(var j=i,j2=j+removeCount-1,jj=$rootElement.length;jj>j;j++,j2++)jj>j2?$rootElement[j]=$rootElement[j2]:delete $rootElement[j];$rootElement.length-=removeCount-1,$rootElement.context===firstElementToRemove&&($rootElement.context=newNode);break}parent&&parent.replaceChild(newNode,firstElementToRemove);var fragment=document.createDocumentFragment();fragment.appendChild(firstElementToRemove),jqLite(newNode).data(jqLite(firstElementToRemove).data()),jQuery?(skipDestroyOnNextJQueryCleanData=!0,jQuery.cleanData([firstElementToRemove])):delete jqLite.cache[firstElementToRemove[jqLite.expando]];for(var k=1,kk=elementsToRemove.length;kk>k;k++){var element=elementsToRemove[k];jqLite(element).remove(),fragment.appendChild(element),delete elementsToRemove[k]}elementsToRemove[0]=newNode,elementsToRemove.length=1}function cloneAndAnnotateFn(fn,annotation){return extend(function(){return fn.apply(null,arguments)},fn,annotation)}function invokeLinkFn(linkFn,scope,$element,attrs,controllers,transcludeFn){try{linkFn(scope,$element,attrs,controllers,transcludeFn)}catch(e){$exceptionHandler(e,startingTag($element))}}var Attributes=function(element,attributesToCopy){if(attributesToCopy){var i,l,key,keys=Object.keys(attributesToCopy);for(i=0,l=keys.length;l>i;i++)key=keys[i],this[key]=attributesToCopy[key]}else this.$attr={};this.$$element=element};Attributes.prototype={$normalize:directiveNormalize,$addClass:function(classVal){classVal&&classVal.length>0&&$animate.addClass(this.$$element,classVal)},$removeClass:function(classVal){classVal&&classVal.length>0&&$animate.removeClass(this.$$element,classVal)},$updateClass:function(newClasses,oldClasses){var toAdd=tokenDifference(newClasses,oldClasses);toAdd&&toAdd.length&&$animate.addClass(this.$$element,toAdd);var toRemove=tokenDifference(oldClasses,newClasses);toRemove&&toRemove.length&&$animate.removeClass(this.$$element,toRemove)},$set:function(key,value,writeAttr,attrName){var nodeName,node=this.$$element[0],booleanKey=getBooleanAttrName(node,key),aliasedKey=getAliasedAttrName(node,key),observer=key;if(booleanKey?(this.$$element.prop(key,value),attrName=booleanKey):aliasedKey&&(this[aliasedKey]=value,observer=aliasedKey),this[key]=value,attrName?this.$attr[key]=attrName:(attrName=this.$attr[key],attrName||(this.$attr[key]=attrName=snake_case(key,"-"))),nodeName=nodeName_(this.$$element),"a"===nodeName&&"href"===key||"img"===nodeName&&"src"===key)this[key]=value=$$sanitizeUri(value,"src"===key);else if("img"===nodeName&&"srcset"===key){for(var result="",trimmedSrcset=trim(value),srcPattern=/(\s+\d+x\s*,|\s+\d+w\s*,|\s+,|,\s+)/,pattern=/\s/.test(trimmedSrcset)?srcPattern:/(,)/,rawUris=trimmedSrcset.split(pattern),nbrUrisWith2parts=Math.floor(rawUris.length/2),i=0;nbrUrisWith2parts>i;i++){var innerIdx=2*i;result+=$$sanitizeUri(trim(rawUris[innerIdx]),!0),result+=" "+trim(rawUris[innerIdx+1])}var lastTuple=trim(rawUris[2*i]).split(/\s/);result+=$$sanitizeUri(trim(lastTuple[0]),!0),2===lastTuple.length&&(result+=" "+trim(lastTuple[1])),this[key]=value=result}writeAttr!==!1&&(null===value||value===undefined?this.$$element.removeAttr(attrName):this.$$element.attr(attrName,value));var $$observers=this.$$observers;$$observers&&forEach($$observers[observer],function(fn){try{fn(value)}catch(e){$exceptionHandler(e)}})},$observe:function(key,fn){var attrs=this,$$observers=attrs.$$observers||(attrs.$$observers=createMap()),listeners=$$observers[key]||($$observers[key]=[]);return listeners.push(fn),$rootScope.$evalAsync(function(){!listeners.$$inter&&attrs.hasOwnProperty(key)&&fn(attrs[key])}),function(){arrayRemove(listeners,fn)}}};var startSymbol=$interpolate.startSymbol(),endSymbol=$interpolate.endSymbol(),denormalizeTemplate="{{"==startSymbol||"}}"==endSymbol?identity:function(template){return template.replace(/\{\{/g,startSymbol).replace(/}}/g,endSymbol)},NG_ATTR_BINDING=/^ngAttr[A-Z]/;return compile.$$addBindingInfo=debugInfoEnabled?function($element,binding){var bindings=$element.data("$binding")||[];isArray(binding)?bindings=bindings.concat(binding):bindings.push(binding),$element.data("$binding",bindings)}:noop,compile.$$addBindingClass=debugInfoEnabled?function($element){safeAddClass($element,"ng-binding")}:noop,compile.$$addScopeInfo=debugInfoEnabled?function($element,scope,isolated,noTemplate){var dataName=isolated?noTemplate?"$isolateScopeNoTemplate":"$isolateScope":"$scope";$element.data(dataName,scope)}:noop,compile.$$addScopeClass=debugInfoEnabled?function($element,isolated){safeAddClass($element,isolated?"ng-isolate-scope":"ng-scope")}:noop,compile}]}function directiveNormalize(name){return camelCase(name.replace(PREFIX_REGEXP,""))}function tokenDifference(str1,str2){var values="",tokens1=str1.split(/\s+/),tokens2=str2.split(/\s+/);outer:for(var i=0;i<tokens1.length;i++){for(var token=tokens1[i],j=0;j<tokens2.length;j++)if(token==tokens2[j])continue outer;values+=(values.length>0?" ":"")+token}return values}function removeComments(jqNodes){jqNodes=jqLite(jqNodes);var i=jqNodes.length;if(1>=i)return jqNodes;for(;i--;){var node=jqNodes[i];node.nodeType===NODE_TYPE_COMMENT&&splice.call(jqNodes,i,1)}return jqNodes}function $ControllerProvider(){var controllers={},globals=!1,CNTRL_REG=/^(\S+)(\s+as\s+(\w+))?$/;this.register=function(name,constructor){assertNotHasOwnProperty(name,"controller"),isObject(name)?extend(controllers,name):controllers[name]=constructor},this.allowGlobals=function(){globals=!0},this.$get=["$injector","$window",function($injector,$window){function addIdentifier(locals,identifier,instance,name){if(!locals||!isObject(locals.$scope))throw minErr("$controller")("noscp","Cannot export controller '{0}' as '{1}'! No $scope object provided via `locals`.",name,identifier);locals.$scope[identifier]=instance}return function(expression,locals,later,ident){var instance,match,constructor,identifier;if(later=later===!0,ident&&isString(ident)&&(identifier=ident),isString(expression)){if(match=expression.match(CNTRL_REG),!match)throw $controllerMinErr("ctrlfmt","Badly formed controller string '{0}'. Must match `__name__ as __id__` or `__name__`.",expression);constructor=match[1],identifier=identifier||match[3],expression=controllers.hasOwnProperty(constructor)?controllers[constructor]:getter(locals.$scope,constructor,!0)||(globals?getter($window,constructor,!0):undefined),assertArgFn(expression,constructor,!0)}if(later){var controllerPrototype=(isArray(expression)?expression[expression.length-1]:expression).prototype;return instance=Object.create(controllerPrototype||null),identifier&&addIdentifier(locals,identifier,instance,constructor||expression.name),extend(function(){return $injector.invoke(expression,instance,locals,constructor),instance},{instance:instance,identifier:identifier})}return instance=$injector.instantiate(expression,locals,constructor),identifier&&addIdentifier(locals,identifier,instance,constructor||expression.name),instance}}]}function $DocumentProvider(){this.$get=["$window",function(window){return jqLite(window.document)}]}function $ExceptionHandlerProvider(){this.$get=["$log",function($log){return function(exception,cause){$log.error.apply($log,arguments)}}]}function defaultHttpResponseTransform(data,headers){if(isString(data)){var tempData=data.replace(JSON_PROTECTION_PREFIX,"").trim();if(tempData){var contentType=headers("Content-Type");(contentType&&0===contentType.indexOf(APPLICATION_JSON)||isJsonLike(tempData))&&(data=fromJson(tempData))}}return data}function isJsonLike(str){var jsonStart=str.match(JSON_START);return jsonStart&&JSON_ENDS[jsonStart[0]].test(str)}function parseHeaders(headers){var key,val,i,parsed=createMap();return headers?(forEach(headers.split("\n"),function(line){i=line.indexOf(":"),key=lowercase(trim(line.substr(0,i))),val=trim(line.substr(i+1)),key&&(parsed[key]=parsed[key]?parsed[key]+", "+val:val)}),parsed):parsed}function headersGetter(headers){var headersObj=isObject(headers)?headers:undefined;return function(name){if(headersObj||(headersObj=parseHeaders(headers)),name){var value=headersObj[lowercase(name)];return void 0===value&&(value=null),value}return headersObj}}function transformData(data,headers,status,fns){return isFunction(fns)?fns(data,headers,status):(forEach(fns,function(fn){data=fn(data,headers,status)}),data)}function isSuccess(status){return status>=200&&300>status}function $HttpProvider(){var defaults=this.defaults={transformResponse:[defaultHttpResponseTransform],transformRequest:[function(d){return!isObject(d)||isFile(d)||isBlob(d)||isFormData(d)?d:toJson(d)}],headers:{common:{Accept:"application/json, text/plain, */*"},post:shallowCopy(CONTENT_TYPE_APPLICATION_JSON),put:shallowCopy(CONTENT_TYPE_APPLICATION_JSON),patch:shallowCopy(CONTENT_TYPE_APPLICATION_JSON)},xsrfCookieName:"XSRF-TOKEN",xsrfHeaderName:"X-XSRF-TOKEN"},useApplyAsync=!1;this.useApplyAsync=function(value){return isDefined(value)?(useApplyAsync=!!value,this):useApplyAsync};var interceptorFactories=this.interceptors=[];this.$get=["$httpBackend","$browser","$cacheFactory","$rootScope","$q","$injector",function($httpBackend,$browser,$cacheFactory,$rootScope,$q,$injector){function $http(requestConfig){function transformResponse(response){var resp=extend({},response);return response.data?resp.data=transformData(response.data,response.headers,response.status,config.transformResponse):resp.data=response.data,isSuccess(response.status)?resp:$q.reject(resp)}function executeHeaderFns(headers){var headerContent,processedHeaders={};return forEach(headers,function(headerFn,header){isFunction(headerFn)?(headerContent=headerFn(),null!=headerContent&&(processedHeaders[header]=headerContent)):processedHeaders[header]=headerFn}),processedHeaders}function mergeHeaders(config){var defHeaderName,lowercaseDefHeaderName,reqHeaderName,defHeaders=defaults.headers,reqHeaders=extend({},config.headers);defHeaders=extend({},defHeaders.common,defHeaders[lowercase(config.method)]);defaultHeadersIteration:for(defHeaderName in defHeaders){lowercaseDefHeaderName=lowercase(defHeaderName);for(reqHeaderName in reqHeaders)if(lowercase(reqHeaderName)===lowercaseDefHeaderName)continue defaultHeadersIteration;reqHeaders[defHeaderName]=defHeaders[defHeaderName]}return executeHeaderFns(reqHeaders)}if(!angular.isObject(requestConfig))throw minErr("$http")("badreq","Http request configuration must be an object.  Received: {0}",requestConfig);var config=extend({method:"get",transformRequest:defaults.transformRequest,transformResponse:defaults.transformResponse},requestConfig);config.headers=mergeHeaders(requestConfig),config.method=uppercase(config.method);var serverRequest=function(config){var headers=config.headers,reqData=transformData(config.data,headersGetter(headers),undefined,config.transformRequest);return isUndefined(reqData)&&forEach(headers,function(value,header){"content-type"===lowercase(header)&&delete headers[header]}),isUndefined(config.withCredentials)&&!isUndefined(defaults.withCredentials)&&(config.withCredentials=defaults.withCredentials),sendReq(config,reqData).then(transformResponse,transformResponse)},chain=[serverRequest,undefined],promise=$q.when(config);for(forEach(reversedInterceptors,function(interceptor){(interceptor.request||interceptor.requestError)&&chain.unshift(interceptor.request,interceptor.requestError),(interceptor.response||interceptor.responseError)&&chain.push(interceptor.response,interceptor.responseError)});chain.length;){var thenFn=chain.shift(),rejectFn=chain.shift();promise=promise.then(thenFn,rejectFn)}return promise.success=function(fn){return assertArgFn(fn,"fn"),promise.then(function(response){fn(response.data,response.status,response.headers,config)}),promise},promise.error=function(fn){return assertArgFn(fn,"fn"),promise.then(null,function(response){fn(response.data,response.status,response.headers,config)}),promise},promise}function createShortMethods(names){forEach(arguments,function(name){$http[name]=function(url,config){return $http(extend(config||{},{method:name,url:url}))}})}function createShortMethodsWithData(name){forEach(arguments,function(name){$http[name]=function(url,data,config){return $http(extend(config||{},{method:name,url:url,data:data}))}})}function sendReq(config,reqData){function done(status,response,headersString,statusText){function resolveHttpPromise(){resolvePromise(response,status,headersString,statusText)}cache&&(isSuccess(status)?cache.put(url,[status,response,parseHeaders(headersString),statusText]):cache.remove(url)),useApplyAsync?$rootScope.$applyAsync(resolveHttpPromise):(resolveHttpPromise(),$rootScope.$$phase||$rootScope.$apply())}function resolvePromise(response,status,headers,statusText){status=status>=-1?status:0,(isSuccess(status)?deferred.resolve:deferred.reject)({data:response,status:status,headers:headersGetter(headers),config:config,statusText:statusText})}function resolvePromiseWithResult(result){resolvePromise(result.data,result.status,shallowCopy(result.headers()),result.statusText)}function removePendingReq(){var idx=$http.pendingRequests.indexOf(config);-1!==idx&&$http.pendingRequests.splice(idx,1)}var cache,cachedResp,deferred=$q.defer(),promise=deferred.promise,reqHeaders=config.headers,url=buildUrl(config.url,config.params);if($http.pendingRequests.push(config),promise.then(removePendingReq,removePendingReq),!config.cache&&!defaults.cache||config.cache===!1||"GET"!==config.method&&"JSONP"!==config.method||(cache=isObject(config.cache)?config.cache:isObject(defaults.cache)?defaults.cache:defaultCache),cache&&(cachedResp=cache.get(url),isDefined(cachedResp)?isPromiseLike(cachedResp)?cachedResp.then(resolvePromiseWithResult,resolvePromiseWithResult):isArray(cachedResp)?resolvePromise(cachedResp[1],cachedResp[0],shallowCopy(cachedResp[2]),cachedResp[3]):resolvePromise(cachedResp,200,{},"OK"):cache.put(url,promise)),isUndefined(cachedResp)){var xsrfValue=urlIsSameOrigin(config.url)?$browser.cookies()[config.xsrfCookieName||defaults.xsrfCookieName]:undefined;xsrfValue&&(reqHeaders[config.xsrfHeaderName||defaults.xsrfHeaderName]=xsrfValue),$httpBackend(config.method,url,reqData,done,reqHeaders,config.timeout,config.withCredentials,config.responseType)}return promise}function buildUrl(url,params){if(!params)return url;var parts=[];return forEachSorted(params,function(value,key){null===value||isUndefined(value)||(isArray(value)||(value=[value]),forEach(value,function(v){isObject(v)&&(v=isDate(v)?v.toISOString():toJson(v)),parts.push(encodeUriQuery(key)+"="+encodeUriQuery(v))}))}),parts.length>0&&(url+=(-1==url.indexOf("?")?"?":"&")+parts.join("&")),url}var defaultCache=$cacheFactory("$http"),reversedInterceptors=[];return forEach(interceptorFactories,function(interceptorFactory){reversedInterceptors.unshift(isString(interceptorFactory)?$injector.get(interceptorFactory):$injector.invoke(interceptorFactory))}),$http.pendingRequests=[],createShortMethods("get","delete","head","jsonp"),createShortMethodsWithData("post","put","patch"),$http.defaults=defaults,$http}]}function createXhr(){return new window.XMLHttpRequest}function $HttpBackendProvider(){this.$get=["$browser","$window","$document",function($browser,$window,$document){return createHttpBackend($browser,createXhr,$browser.defer,$window.angular.callbacks,$document[0])}]}function createHttpBackend($browser,createXhr,$browserDefer,callbacks,rawDocument){function jsonpReq(url,callbackId,done){var script=rawDocument.createElement("script"),callback=null;return script.type="text/javascript",script.src=url,script.async=!0,callback=function(event){removeEventListenerFn(script,"load",callback),removeEventListenerFn(script,"error",callback),rawDocument.body.removeChild(script),script=null;var status=-1,text="unknown";event&&("load"!==event.type||callbacks[callbackId].called||(event={type:"error"}),text=event.type,status="error"===event.type?404:200),done&&done(status,text)},addEventListenerFn(script,"load",callback),addEventListenerFn(script,"error",callback),rawDocument.body.appendChild(script),callback}return function(method,url,post,callback,headers,timeout,withCredentials,responseType){function timeoutRequest(){jsonpDone&&jsonpDone(),xhr&&xhr.abort()}function completeRequest(callback,status,response,headersString,statusText){timeoutId!==undefined&&$browserDefer.cancel(timeoutId),jsonpDone=xhr=null,callback(status,response,headersString,statusText),$browser.$$completeOutstandingRequest(noop)}if($browser.$$incOutstandingRequestCount(),url=url||$browser.url(),"jsonp"==lowercase(method)){var callbackId="_"+(callbacks.counter++).toString(36);callbacks[callbackId]=function(data){callbacks[callbackId].data=data,callbacks[callbackId].called=!0};var jsonpDone=jsonpReq(url.replace("JSON_CALLBACK","angular.callbacks."+callbackId),callbackId,function(status,text){completeRequest(callback,status,callbacks[callbackId].data,"",text),callbacks[callbackId]=noop})}else{var xhr=createXhr();xhr.open(method,url,!0),forEach(headers,function(value,key){isDefined(value)&&xhr.setRequestHeader(key,value)}),xhr.onload=function(){var statusText=xhr.statusText||"",response="response"in xhr?xhr.response:xhr.responseText,status=1223===xhr.status?204:xhr.status;0===status&&(status=response?200:"file"==urlResolve(url).protocol?404:0),completeRequest(callback,status,response,xhr.getAllResponseHeaders(),statusText)};var requestError=function(){completeRequest(callback,-1,null,null,"")};if(xhr.onerror=requestError,xhr.onabort=requestError,withCredentials&&(xhr.withCredentials=!0),responseType)try{xhr.responseType=responseType}catch(e){if("json"!==responseType)throw e}xhr.send(post||null)}if(timeout>0)var timeoutId=$browserDefer(timeoutRequest,timeout);else isPromiseLike(timeout)&&timeout.then(timeoutRequest)}}function $InterpolateProvider(){var startSymbol="{{",endSymbol="}}";this.startSymbol=function(value){return value?(startSymbol=value,this):startSymbol},this.endSymbol=function(value){return value?(endSymbol=value,this):endSymbol},this.$get=["$parse","$exceptionHandler","$sce",function($parse,$exceptionHandler,$sce){function escape(ch){return"\\\\\\"+ch}function $interpolate(text,mustHaveExpression,trustedContext,allOrNothing){function unescapeText(text){return text.replace(escapedStartRegexp,startSymbol).replace(escapedEndRegexp,endSymbol)}function parseStringifyInterceptor(value){try{return value=getValue(value),allOrNothing&&!isDefined(value)?value:stringify(value)}catch(err){var newErr=$interpolateMinErr("interr","Can't interpolate: {0}\n{1}",text,err.toString());$exceptionHandler(newErr)}}allOrNothing=!!allOrNothing;for(var startIndex,endIndex,exp,index=0,expressions=[],parseFns=[],textLength=text.length,concat=[],expressionPositions=[];textLength>index;){if(-1==(startIndex=text.indexOf(startSymbol,index))||-1==(endIndex=text.indexOf(endSymbol,startIndex+startSymbolLength))){index!==textLength&&concat.push(unescapeText(text.substring(index)));break}index!==startIndex&&concat.push(unescapeText(text.substring(index,startIndex))),exp=text.substring(startIndex+startSymbolLength,endIndex),expressions.push(exp),parseFns.push($parse(exp,parseStringifyInterceptor)),index=endIndex+endSymbolLength,expressionPositions.push(concat.length),concat.push("")}if(trustedContext&&concat.length>1)throw $interpolateMinErr("noconcat","Error while interpolating: {0}\nStrict Contextual Escaping disallows interpolations that concatenate multiple expressions when a trusted value is required.  See http://docs.angularjs.org/api/ng.$sce",text);if(!mustHaveExpression||expressions.length){var compute=function(values){for(var i=0,ii=expressions.length;ii>i;i++){if(allOrNothing&&isUndefined(values[i]))return;concat[expressionPositions[i]]=values[i]}return concat.join("")},getValue=function(value){return trustedContext?$sce.getTrusted(trustedContext,value):$sce.valueOf(value)},stringify=function(value){if(null==value)return"";switch(typeof value){case"string":break;case"number":value=""+value;break;default:value=toJson(value)}return value};return extend(function(context){var i=0,ii=expressions.length,values=new Array(ii);try{for(;ii>i;i++)values[i]=parseFns[i](context);return compute(values)}catch(err){var newErr=$interpolateMinErr("interr","Can't interpolate: {0}\n{1}",text,err.toString());$exceptionHandler(newErr)}},{exp:text,expressions:expressions,$$watchDelegate:function(scope,listener,objectEquality){var lastValue;return scope.$watchGroup(parseFns,function(values,oldValues){var currValue=compute(values);isFunction(listener)&&listener.call(this,currValue,values!==oldValues?lastValue:currValue,scope),lastValue=currValue},objectEquality)}})}}var startSymbolLength=startSymbol.length,endSymbolLength=endSymbol.length,escapedStartRegexp=new RegExp(startSymbol.replace(/./g,escape),"g"),escapedEndRegexp=new RegExp(endSymbol.replace(/./g,escape),"g");return $interpolate.startSymbol=function(){return startSymbol},$interpolate.endSymbol=function(){return endSymbol},$interpolate}]}function $IntervalProvider(){this.$get=["$rootScope","$window","$q","$$q",function($rootScope,$window,$q,$$q){function interval(fn,delay,count,invokeApply){var setInterval=$window.setInterval,clearInterval=$window.clearInterval,iteration=0,skipApply=isDefined(invokeApply)&&!invokeApply,deferred=(skipApply?$$q:$q).defer(),promise=deferred.promise;return count=isDefined(count)?count:0,promise.then(null,null,fn),promise.$$intervalId=setInterval(function(){deferred.notify(iteration++),count>0&&iteration>=count&&(deferred.resolve(iteration),clearInterval(promise.$$intervalId),delete intervals[promise.$$intervalId]),skipApply||$rootScope.$apply()},delay),intervals[promise.$$intervalId]=deferred,promise}var intervals={};return interval.cancel=function(promise){return promise&&promise.$$intervalId in intervals?(intervals[promise.$$intervalId].reject("canceled"),$window.clearInterval(promise.$$intervalId),delete intervals[promise.$$intervalId],!0):!1},interval}]}function $LocaleProvider(){this.$get=function(){return{id:"en-us",NUMBER_FORMATS:{DECIMAL_SEP:".",GROUP_SEP:",",PATTERNS:[{minInt:1,minFrac:0,maxFrac:3,posPre:"",posSuf:"",negPre:"-",negSuf:"",gSize:3,lgSize:3},{minInt:1,minFrac:2,maxFrac:2,posPre:"¤",posSuf:"",negPre:"(¤",negSuf:")",gSize:3,lgSize:3}],CURRENCY_SYM:"$"},DATETIME_FORMATS:{MONTH:"January,February,March,April,May,June,July,August,September,October,November,December".split(","),SHORTMONTH:"Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec".split(","),
DAY:"Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday".split(","),SHORTDAY:"Sun,Mon,Tue,Wed,Thu,Fri,Sat".split(","),AMPMS:["AM","PM"],medium:"MMM d, y h:mm:ss a","short":"M/d/yy h:mm a",fullDate:"EEEE, MMMM d, y",longDate:"MMMM d, y",mediumDate:"MMM d, y",shortDate:"M/d/yy",mediumTime:"h:mm:ss a",shortTime:"h:mm a",ERANAMES:["Before Christ","Anno Domini"],ERAS:["BC","AD"]},pluralCat:function(num){return 1===num?"one":"other"}}}}function encodePath(path){for(var segments=path.split("/"),i=segments.length;i--;)segments[i]=encodeUriSegment(segments[i]);return segments.join("/")}function parseAbsoluteUrl(absoluteUrl,locationObj){var parsedUrl=urlResolve(absoluteUrl);locationObj.$$protocol=parsedUrl.protocol,locationObj.$$host=parsedUrl.hostname,locationObj.$$port=int(parsedUrl.port)||DEFAULT_PORTS[parsedUrl.protocol]||null}function parseAppUrl(relativeUrl,locationObj){var prefixed="/"!==relativeUrl.charAt(0);prefixed&&(relativeUrl="/"+relativeUrl);var match=urlResolve(relativeUrl);locationObj.$$path=decodeURIComponent(prefixed&&"/"===match.pathname.charAt(0)?match.pathname.substring(1):match.pathname),locationObj.$$search=parseKeyValue(match.search),locationObj.$$hash=decodeURIComponent(match.hash),locationObj.$$path&&"/"!=locationObj.$$path.charAt(0)&&(locationObj.$$path="/"+locationObj.$$path)}function beginsWith(begin,whole){return 0===whole.indexOf(begin)?whole.substr(begin.length):void 0}function stripHash(url){var index=url.indexOf("#");return-1==index?url:url.substr(0,index)}function trimEmptyHash(url){return url.replace(/(#.+)|#$/,"$1")}function stripFile(url){return url.substr(0,stripHash(url).lastIndexOf("/")+1)}function serverBase(url){return url.substring(0,url.indexOf("/",url.indexOf("//")+2))}function LocationHtml5Url(appBase,appBaseNoFile,basePrefix){this.$$html5=!0,basePrefix=basePrefix||"",parseAbsoluteUrl(appBase,this),this.$$parse=function(url){var pathUrl=beginsWith(appBaseNoFile,url);if(!isString(pathUrl))throw $locationMinErr("ipthprfx",'Invalid url "{0}", missing path prefix "{1}".',url,appBaseNoFile);parseAppUrl(pathUrl,this),this.$$path||(this.$$path="/"),this.$$compose()},this.$$compose=function(){var search=toKeyValue(this.$$search),hash=this.$$hash?"#"+encodeUriSegment(this.$$hash):"";this.$$url=encodePath(this.$$path)+(search?"?"+search:"")+hash,this.$$absUrl=appBaseNoFile+this.$$url.substr(1)},this.$$parseLinkUrl=function(url,relHref){if(relHref&&"#"===relHref[0])return this.hash(relHref.slice(1)),!0;var appUrl,prevAppUrl,rewrittenUrl;return(appUrl=beginsWith(appBase,url))!==undefined?(prevAppUrl=appUrl,rewrittenUrl=(appUrl=beginsWith(basePrefix,appUrl))!==undefined?appBaseNoFile+(beginsWith("/",appUrl)||appUrl):appBase+prevAppUrl):(appUrl=beginsWith(appBaseNoFile,url))!==undefined?rewrittenUrl=appBaseNoFile+appUrl:appBaseNoFile==url+"/"&&(rewrittenUrl=appBaseNoFile),rewrittenUrl&&this.$$parse(rewrittenUrl),!!rewrittenUrl}}function LocationHashbangUrl(appBase,appBaseNoFile,hashPrefix){parseAbsoluteUrl(appBase,this),this.$$parse=function(url){function removeWindowsDriveName(path,url,base){var firstPathSegmentMatch,windowsFilePathExp=/^\/[A-Z]:(\/.*)/;return 0===url.indexOf(base)&&(url=url.replace(base,"")),windowsFilePathExp.exec(url)?path:(firstPathSegmentMatch=windowsFilePathExp.exec(path),firstPathSegmentMatch?firstPathSegmentMatch[1]:path)}var withoutHashUrl,withoutBaseUrl=beginsWith(appBase,url)||beginsWith(appBaseNoFile,url);isUndefined(withoutBaseUrl)||"#"!==withoutBaseUrl.charAt(0)?this.$$html5?withoutHashUrl=withoutBaseUrl:(withoutHashUrl="",isUndefined(withoutBaseUrl)&&(appBase=url,this.replace())):(withoutHashUrl=beginsWith(hashPrefix,withoutBaseUrl),isUndefined(withoutHashUrl)&&(withoutHashUrl=withoutBaseUrl)),parseAppUrl(withoutHashUrl,this),this.$$path=removeWindowsDriveName(this.$$path,withoutHashUrl,appBase),this.$$compose()},this.$$compose=function(){var search=toKeyValue(this.$$search),hash=this.$$hash?"#"+encodeUriSegment(this.$$hash):"";this.$$url=encodePath(this.$$path)+(search?"?"+search:"")+hash,this.$$absUrl=appBase+(this.$$url?hashPrefix+this.$$url:"")},this.$$parseLinkUrl=function(url,relHref){return stripHash(appBase)==stripHash(url)?(this.$$parse(url),!0):!1}}function LocationHashbangInHtml5Url(appBase,appBaseNoFile,hashPrefix){this.$$html5=!0,LocationHashbangUrl.apply(this,arguments),this.$$parseLinkUrl=function(url,relHref){if(relHref&&"#"===relHref[0])return this.hash(relHref.slice(1)),!0;var rewrittenUrl,appUrl;return appBase==stripHash(url)?rewrittenUrl=url:(appUrl=beginsWith(appBaseNoFile,url))?rewrittenUrl=appBase+hashPrefix+appUrl:appBaseNoFile===url+"/"&&(rewrittenUrl=appBaseNoFile),rewrittenUrl&&this.$$parse(rewrittenUrl),!!rewrittenUrl},this.$$compose=function(){var search=toKeyValue(this.$$search),hash=this.$$hash?"#"+encodeUriSegment(this.$$hash):"";this.$$url=encodePath(this.$$path)+(search?"?"+search:"")+hash,this.$$absUrl=appBase+hashPrefix+this.$$url}}function locationGetter(property){return function(){return this[property]}}function locationGetterSetter(property,preprocess){return function(value){return isUndefined(value)?this[property]:(this[property]=preprocess(value),this.$$compose(),this)}}function $LocationProvider(){var hashPrefix="",html5Mode={enabled:!1,requireBase:!0,rewriteLinks:!0};this.hashPrefix=function(prefix){return isDefined(prefix)?(hashPrefix=prefix,this):hashPrefix},this.html5Mode=function(mode){return isBoolean(mode)?(html5Mode.enabled=mode,this):isObject(mode)?(isBoolean(mode.enabled)&&(html5Mode.enabled=mode.enabled),isBoolean(mode.requireBase)&&(html5Mode.requireBase=mode.requireBase),isBoolean(mode.rewriteLinks)&&(html5Mode.rewriteLinks=mode.rewriteLinks),this):html5Mode},this.$get=["$rootScope","$browser","$sniffer","$rootElement","$window",function($rootScope,$browser,$sniffer,$rootElement,$window){function setBrowserUrlWithFallback(url,replace,state){var oldUrl=$location.url(),oldState=$location.$$state;try{$browser.url(url,replace,state),$location.$$state=$browser.state()}catch(e){throw $location.url(oldUrl),$location.$$state=oldState,e}}function afterLocationChange(oldUrl,oldState){$rootScope.$broadcast("$locationChangeSuccess",$location.absUrl(),oldUrl,$location.$$state,oldState)}var $location,LocationMode,appBase,baseHref=$browser.baseHref(),initialUrl=$browser.url();if(html5Mode.enabled){if(!baseHref&&html5Mode.requireBase)throw $locationMinErr("nobase","$location in HTML5 mode requires a <base> tag to be present!");appBase=serverBase(initialUrl)+(baseHref||"/"),LocationMode=$sniffer.history?LocationHtml5Url:LocationHashbangInHtml5Url}else appBase=stripHash(initialUrl),LocationMode=LocationHashbangUrl;var appBaseNoFile=stripFile(appBase);$location=new LocationMode(appBase,appBaseNoFile,"#"+hashPrefix),$location.$$parseLinkUrl(initialUrl,initialUrl),$location.$$state=$browser.state();var IGNORE_URI_REGEXP=/^\s*(javascript|mailto):/i;$rootElement.on("click",function(event){if(html5Mode.rewriteLinks&&!event.ctrlKey&&!event.metaKey&&!event.shiftKey&&2!=event.which&&2!=event.button){for(var elm=jqLite(event.target);"a"!==nodeName_(elm[0]);)if(elm[0]===$rootElement[0]||!(elm=elm.parent())[0])return;var absHref=elm.prop("href"),relHref=elm.attr("href")||elm.attr("xlink:href");isObject(absHref)&&"[object SVGAnimatedString]"===absHref.toString()&&(absHref=urlResolve(absHref.animVal).href),IGNORE_URI_REGEXP.test(absHref)||!absHref||elm.attr("target")||event.isDefaultPrevented()||$location.$$parseLinkUrl(absHref,relHref)&&(event.preventDefault(),$location.absUrl()!=$browser.url()&&($rootScope.$apply(),$window.angular["ff-684208-preventDefault"]=!0))}}),trimEmptyHash($location.absUrl())!=trimEmptyHash(initialUrl)&&$browser.url($location.absUrl(),!0);var initializing=!0;return $browser.onUrlChange(function(newUrl,newState){return isUndefined(beginsWith(appBaseNoFile,newUrl))?void($window.location.href=newUrl):($rootScope.$evalAsync(function(){var defaultPrevented,oldUrl=$location.absUrl(),oldState=$location.$$state;$location.$$parse(newUrl),$location.$$state=newState,defaultPrevented=$rootScope.$broadcast("$locationChangeStart",newUrl,oldUrl,newState,oldState).defaultPrevented,$location.absUrl()===newUrl&&(defaultPrevented?($location.$$parse(oldUrl),$location.$$state=oldState,setBrowserUrlWithFallback(oldUrl,!1,oldState)):(initializing=!1,afterLocationChange(oldUrl,oldState)))}),void($rootScope.$$phase||$rootScope.$digest()))}),$rootScope.$watch(function(){var oldUrl=trimEmptyHash($browser.url()),newUrl=trimEmptyHash($location.absUrl()),oldState=$browser.state(),currentReplace=$location.$$replace,urlOrStateChanged=oldUrl!==newUrl||$location.$$html5&&$sniffer.history&&oldState!==$location.$$state;(initializing||urlOrStateChanged)&&(initializing=!1,$rootScope.$evalAsync(function(){var newUrl=$location.absUrl(),defaultPrevented=$rootScope.$broadcast("$locationChangeStart",newUrl,oldUrl,$location.$$state,oldState).defaultPrevented;$location.absUrl()===newUrl&&(defaultPrevented?($location.$$parse(oldUrl),$location.$$state=oldState):(urlOrStateChanged&&setBrowserUrlWithFallback(newUrl,currentReplace,oldState===$location.$$state?null:$location.$$state),afterLocationChange(oldUrl,oldState)))})),$location.$$replace=!1}),$location}]}function $LogProvider(){var debug=!0,self=this;this.debugEnabled=function(flag){return isDefined(flag)?(debug=flag,this):debug},this.$get=["$window",function($window){function formatError(arg){return arg instanceof Error&&(arg.stack?arg=arg.message&&-1===arg.stack.indexOf(arg.message)?"Error: "+arg.message+"\n"+arg.stack:arg.stack:arg.sourceURL&&(arg=arg.message+"\n"+arg.sourceURL+":"+arg.line)),arg}function consoleLog(type){var console=$window.console||{},logFn=console[type]||console.log||noop,hasApply=!1;try{hasApply=!!logFn.apply}catch(e){}return hasApply?function(){var args=[];return forEach(arguments,function(arg){args.push(formatError(arg))}),logFn.apply(console,args)}:function(arg1,arg2){logFn(arg1,null==arg2?"":arg2)}}return{log:consoleLog("log"),info:consoleLog("info"),warn:consoleLog("warn"),error:consoleLog("error"),debug:function(){var fn=consoleLog("debug");return function(){debug&&fn.apply(self,arguments)}}()}}]}function ensureSafeMemberName(name,fullExpression){if("__defineGetter__"===name||"__defineSetter__"===name||"__lookupGetter__"===name||"__lookupSetter__"===name||"__proto__"===name)throw $parseMinErr("isecfld","Attempting to access a disallowed field in Angular expressions! Expression: {0}",fullExpression);return name}function getStringValue(name,fullExpression){if(name+="",!isString(name))throw $parseMinErr("iseccst","Cannot convert object to primitive value! Expression: {0}",fullExpression);return name}function ensureSafeObject(obj,fullExpression){if(obj){if(obj.constructor===obj)throw $parseMinErr("isecfn","Referencing Function in Angular expressions is disallowed! Expression: {0}",fullExpression);if(obj.window===obj)throw $parseMinErr("isecwindow","Referencing the Window in Angular expressions is disallowed! Expression: {0}",fullExpression);if(obj.children&&(obj.nodeName||obj.prop&&obj.attr&&obj.find))throw $parseMinErr("isecdom","Referencing DOM nodes in Angular expressions is disallowed! Expression: {0}",fullExpression);if(obj===Object)throw $parseMinErr("isecobj","Referencing Object in Angular expressions is disallowed! Expression: {0}",fullExpression)}return obj}function ensureSafeFunction(obj,fullExpression){if(obj){if(obj.constructor===obj)throw $parseMinErr("isecfn","Referencing Function in Angular expressions is disallowed! Expression: {0}",fullExpression);if(obj===CALL||obj===APPLY||obj===BIND)throw $parseMinErr("isecff","Referencing call, apply or bind in Angular expressions is disallowed! Expression: {0}",fullExpression)}}function isConstant(exp){return exp.constant}function setter(obj,locals,path,setValue,fullExp){ensureSafeObject(obj,fullExp),ensureSafeObject(locals,fullExp);for(var key,element=path.split("."),i=0;element.length>1;i++){key=ensureSafeMemberName(element.shift(),fullExp);var propertyObj=0===i&&locals&&locals[key]||obj[key];propertyObj||(propertyObj={},obj[key]=propertyObj),obj=ensureSafeObject(propertyObj,fullExp)}return key=ensureSafeMemberName(element.shift(),fullExp),ensureSafeObject(obj[key],fullExp),obj[key]=setValue,setValue}function isPossiblyDangerousMemberName(name){return"constructor"==name}function cspSafeGetterFn(key0,key1,key2,key3,key4,fullExp,expensiveChecks){ensureSafeMemberName(key0,fullExp),ensureSafeMemberName(key1,fullExp),ensureSafeMemberName(key2,fullExp),ensureSafeMemberName(key3,fullExp),ensureSafeMemberName(key4,fullExp);var eso=function(o){return ensureSafeObject(o,fullExp)},eso0=expensiveChecks||isPossiblyDangerousMemberName(key0)?eso:identity,eso1=expensiveChecks||isPossiblyDangerousMemberName(key1)?eso:identity,eso2=expensiveChecks||isPossiblyDangerousMemberName(key2)?eso:identity,eso3=expensiveChecks||isPossiblyDangerousMemberName(key3)?eso:identity,eso4=expensiveChecks||isPossiblyDangerousMemberName(key4)?eso:identity;return function(scope,locals){var pathVal=locals&&locals.hasOwnProperty(key0)?locals:scope;return null==pathVal?pathVal:(pathVal=eso0(pathVal[key0]),key1?null==pathVal?undefined:(pathVal=eso1(pathVal[key1]),key2?null==pathVal?undefined:(pathVal=eso2(pathVal[key2]),key3?null==pathVal?undefined:(pathVal=eso3(pathVal[key3]),key4?null==pathVal?undefined:pathVal=eso4(pathVal[key4]):pathVal):pathVal):pathVal):pathVal)}}function getterFnWithEnsureSafeObject(fn,fullExpression){return function(s,l){return fn(s,l,ensureSafeObject,fullExpression)}}function getterFn(path,options,fullExp){var expensiveChecks=options.expensiveChecks,getterFnCache=expensiveChecks?getterFnCacheExpensive:getterFnCacheDefault,fn=getterFnCache[path];if(fn)return fn;var pathKeys=path.split("."),pathKeysLength=pathKeys.length;if(options.csp)fn=6>pathKeysLength?cspSafeGetterFn(pathKeys[0],pathKeys[1],pathKeys[2],pathKeys[3],pathKeys[4],fullExp,expensiveChecks):function(scope,locals){var val,i=0;do val=cspSafeGetterFn(pathKeys[i++],pathKeys[i++],pathKeys[i++],pathKeys[i++],pathKeys[i++],fullExp,expensiveChecks)(scope,locals),locals=undefined,scope=val;while(pathKeysLength>i);return val};else{var code="";expensiveChecks&&(code+="s = eso(s, fe);\nl = eso(l, fe);\n");var needsEnsureSafeObject=expensiveChecks;forEach(pathKeys,function(key,index){ensureSafeMemberName(key,fullExp);var lookupJs=(index?"s":'((l&&l.hasOwnProperty("'+key+'"))?l:s)')+"."+key;(expensiveChecks||isPossiblyDangerousMemberName(key))&&(lookupJs="eso("+lookupJs+", fe)",needsEnsureSafeObject=!0),code+="if(s == null) return undefined;\ns="+lookupJs+";\n"}),code+="return s;";var evaledFnGetter=new Function("s","l","eso","fe",code);evaledFnGetter.toString=valueFn(code),needsEnsureSafeObject&&(evaledFnGetter=getterFnWithEnsureSafeObject(evaledFnGetter,fullExp)),fn=evaledFnGetter}return fn.sharedGetter=!0,fn.assign=function(self,value,locals){return setter(self,locals,path,value,path)},getterFnCache[path]=fn,fn}function getValueOf(value){return isFunction(value.valueOf)?value.valueOf():objectValueOf.call(value)}function $ParseProvider(){var cacheDefault=createMap(),cacheExpensive=createMap();this.$get=["$filter","$sniffer",function($filter,$sniffer){function wrapSharedExpression(exp){var wrapped=exp;return exp.sharedGetter&&(wrapped=function(self,locals){return exp(self,locals)},wrapped.literal=exp.literal,wrapped.constant=exp.constant,wrapped.assign=exp.assign),wrapped}function collectExpressionInputs(inputs,list){for(var i=0,ii=inputs.length;ii>i;i++){var input=inputs[i];input.constant||(input.inputs?collectExpressionInputs(input.inputs,list):-1===list.indexOf(input)&&list.push(input))}return list}function expressionInputDirtyCheck(newValue,oldValueOfValue){return null==newValue||null==oldValueOfValue?newValue===oldValueOfValue:"object"==typeof newValue&&(newValue=getValueOf(newValue),"object"==typeof newValue)?!1:newValue===oldValueOfValue||newValue!==newValue&&oldValueOfValue!==oldValueOfValue}function inputsWatchDelegate(scope,listener,objectEquality,parsedExpression){var lastResult,inputExpressions=parsedExpression.$$inputs||(parsedExpression.$$inputs=collectExpressionInputs(parsedExpression.inputs,[]));if(1===inputExpressions.length){var oldInputValue=expressionInputDirtyCheck;return inputExpressions=inputExpressions[0],scope.$watch(function(scope){var newInputValue=inputExpressions(scope);return expressionInputDirtyCheck(newInputValue,oldInputValue)||(lastResult=parsedExpression(scope),oldInputValue=newInputValue&&getValueOf(newInputValue)),lastResult},listener,objectEquality)}for(var oldInputValueOfValues=[],i=0,ii=inputExpressions.length;ii>i;i++)oldInputValueOfValues[i]=expressionInputDirtyCheck;return scope.$watch(function(scope){for(var changed=!1,i=0,ii=inputExpressions.length;ii>i;i++){var newInputValue=inputExpressions[i](scope);(changed||(changed=!expressionInputDirtyCheck(newInputValue,oldInputValueOfValues[i])))&&(oldInputValueOfValues[i]=newInputValue&&getValueOf(newInputValue))}return changed&&(lastResult=parsedExpression(scope)),lastResult},listener,objectEquality)}function oneTimeWatchDelegate(scope,listener,objectEquality,parsedExpression){var unwatch,lastValue;return unwatch=scope.$watch(function(scope){return parsedExpression(scope)},function(value,old,scope){lastValue=value,isFunction(listener)&&listener.apply(this,arguments),isDefined(value)&&scope.$$postDigest(function(){isDefined(lastValue)&&unwatch()})},objectEquality)}function oneTimeLiteralWatchDelegate(scope,listener,objectEquality,parsedExpression){function isAllDefined(value){var allDefined=!0;return forEach(value,function(val){isDefined(val)||(allDefined=!1)}),allDefined}var unwatch,lastValue;return unwatch=scope.$watch(function(scope){return parsedExpression(scope)},function(value,old,scope){lastValue=value,isFunction(listener)&&listener.call(this,value,old,scope),isAllDefined(value)&&scope.$$postDigest(function(){isAllDefined(lastValue)&&unwatch()})},objectEquality)}function constantWatchDelegate(scope,listener,objectEquality,parsedExpression){var unwatch;return unwatch=scope.$watch(function(scope){return parsedExpression(scope)},function(value,old,scope){isFunction(listener)&&listener.apply(this,arguments),unwatch()},objectEquality)}function addInterceptor(parsedExpression,interceptorFn){if(!interceptorFn)return parsedExpression;var watchDelegate=parsedExpression.$$watchDelegate,regularWatch=watchDelegate!==oneTimeLiteralWatchDelegate&&watchDelegate!==oneTimeWatchDelegate,fn=regularWatch?function(scope,locals){var value=parsedExpression(scope,locals);return interceptorFn(value,scope,locals)}:function(scope,locals){var value=parsedExpression(scope,locals),result=interceptorFn(value,scope,locals);return isDefined(value)?result:value};return parsedExpression.$$watchDelegate&&parsedExpression.$$watchDelegate!==inputsWatchDelegate?fn.$$watchDelegate=parsedExpression.$$watchDelegate:interceptorFn.$stateful||(fn.$$watchDelegate=inputsWatchDelegate,fn.inputs=[parsedExpression]),fn}var $parseOptions={csp:$sniffer.csp,expensiveChecks:!1},$parseOptionsExpensive={csp:$sniffer.csp,expensiveChecks:!0};return function(exp,interceptorFn,expensiveChecks){var parsedExpression,oneTime,cacheKey;switch(typeof exp){case"string":cacheKey=exp=exp.trim();var cache=expensiveChecks?cacheExpensive:cacheDefault;if(parsedExpression=cache[cacheKey],!parsedExpression){":"===exp.charAt(0)&&":"===exp.charAt(1)&&(oneTime=!0,exp=exp.substring(2));var parseOptions=expensiveChecks?$parseOptionsExpensive:$parseOptions,lexer=new Lexer(parseOptions),parser=new Parser(lexer,$filter,parseOptions);parsedExpression=parser.parse(exp),parsedExpression.constant?parsedExpression.$$watchDelegate=constantWatchDelegate:oneTime?(parsedExpression=wrapSharedExpression(parsedExpression),parsedExpression.$$watchDelegate=parsedExpression.literal?oneTimeLiteralWatchDelegate:oneTimeWatchDelegate):parsedExpression.inputs&&(parsedExpression.$$watchDelegate=inputsWatchDelegate),cache[cacheKey]=parsedExpression}return addInterceptor(parsedExpression,interceptorFn);case"function":return addInterceptor(exp,interceptorFn);default:return addInterceptor(noop,interceptorFn)}}}]}function $QProvider(){this.$get=["$rootScope","$exceptionHandler",function($rootScope,$exceptionHandler){return qFactory(function(callback){$rootScope.$evalAsync(callback)},$exceptionHandler)}]}function $$QProvider(){this.$get=["$browser","$exceptionHandler",function($browser,$exceptionHandler){return qFactory(function(callback){$browser.defer(callback)},$exceptionHandler)}]}function qFactory(nextTick,exceptionHandler){function callOnce(self,resolveFn,rejectFn){function wrap(fn){return function(value){called||(called=!0,fn.call(self,value))}}var called=!1;return[wrap(resolveFn),wrap(rejectFn)]}function Promise(){this.$$state={status:0}}function simpleBind(context,fn){return function(value){fn.call(context,value)}}function processQueue(state){var fn,promise,pending;pending=state.pending,state.processScheduled=!1,state.pending=undefined;for(var i=0,ii=pending.length;ii>i;++i){promise=pending[i][0],fn=pending[i][state.status];try{isFunction(fn)?promise.resolve(fn(state.value)):1===state.status?promise.resolve(state.value):promise.reject(state.value)}catch(e){promise.reject(e),exceptionHandler(e)}}}function scheduleProcessQueue(state){!state.processScheduled&&state.pending&&(state.processScheduled=!0,nextTick(function(){processQueue(state)}))}function Deferred(){this.promise=new Promise,this.resolve=simpleBind(this,this.resolve),this.reject=simpleBind(this,this.reject),this.notify=simpleBind(this,this.notify)}function all(promises){var deferred=new Deferred,counter=0,results=isArray(promises)?[]:{};return forEach(promises,function(promise,key){counter++,when(promise).then(function(value){results.hasOwnProperty(key)||(results[key]=value,--counter||deferred.resolve(results))},function(reason){results.hasOwnProperty(key)||deferred.reject(reason)})}),0===counter&&deferred.resolve(results),deferred.promise}var $qMinErr=minErr("$q",TypeError),defer=function(){return new Deferred};Promise.prototype={then:function(onFulfilled,onRejected,progressBack){var result=new Deferred;return this.$$state.pending=this.$$state.pending||[],this.$$state.pending.push([result,onFulfilled,onRejected,progressBack]),this.$$state.status>0&&scheduleProcessQueue(this.$$state),result.promise},"catch":function(callback){return this.then(null,callback)},"finally":function(callback,progressBack){return this.then(function(value){return handleCallback(value,!0,callback)},function(error){return handleCallback(error,!1,callback)},progressBack)}},Deferred.prototype={resolve:function(val){this.promise.$$state.status||(val===this.promise?this.$$reject($qMinErr("qcycle","Expected promise to be resolved with value other than itself '{0}'",val)):this.$$resolve(val))},$$resolve:function(val){var then,fns;fns=callOnce(this,this.$$resolve,this.$$reject);try{(isObject(val)||isFunction(val))&&(then=val&&val.then),isFunction(then)?(this.promise.$$state.status=-1,then.call(val,fns[0],fns[1],this.notify)):(this.promise.$$state.value=val,this.promise.$$state.status=1,scheduleProcessQueue(this.promise.$$state))}catch(e){fns[1](e),exceptionHandler(e)}},reject:function(reason){this.promise.$$state.status||this.$$reject(reason)},$$reject:function(reason){this.promise.$$state.value=reason,this.promise.$$state.status=2,scheduleProcessQueue(this.promise.$$state)},notify:function(progress){var callbacks=this.promise.$$state.pending;this.promise.$$state.status<=0&&callbacks&&callbacks.length&&nextTick(function(){for(var callback,result,i=0,ii=callbacks.length;ii>i;i++){result=callbacks[i][0],callback=callbacks[i][3];try{result.notify(isFunction(callback)?callback(progress):progress)}catch(e){exceptionHandler(e)}}})}};var reject=function(reason){var result=new Deferred;return result.reject(reason),result.promise},makePromise=function(value,resolved){var result=new Deferred;return resolved?result.resolve(value):result.reject(value),result.promise},handleCallback=function(value,isResolved,callback){var callbackOutput=null;try{isFunction(callback)&&(callbackOutput=callback())}catch(e){return makePromise(e,!1)}return isPromiseLike(callbackOutput)?callbackOutput.then(function(){return makePromise(value,isResolved)},function(error){return makePromise(error,!1)}):makePromise(value,isResolved)},when=function(value,callback,errback,progressBack){var result=new Deferred;return result.resolve(value),result.promise.then(callback,errback,progressBack)},$Q=function Q(resolver){function resolveFn(value){deferred.resolve(value)}function rejectFn(reason){deferred.reject(reason)}if(!isFunction(resolver))throw $qMinErr("norslvr","Expected resolverFn, got '{0}'",resolver);if(!(this instanceof Q))return new Q(resolver);var deferred=new Deferred;return resolver(resolveFn,rejectFn),deferred.promise};return $Q.defer=defer,$Q.reject=reject,$Q.when=when,$Q.all=all,$Q}function $$RAFProvider(){this.$get=["$window","$timeout",function($window,$timeout){function flush(){for(var i=0;i<taskQueue.length;i++){var task=taskQueue[i];task&&(taskQueue[i]=null,task())}taskCount=taskQueue.length=0}function queueFn(asyncFn){var index=taskQueue.length;return taskCount++,taskQueue.push(asyncFn),0===index&&(cancelLastRAF=rafFn(flush)),function(){index>=0&&(taskQueue[index]=null,index=null,0===--taskCount&&cancelLastRAF&&(cancelLastRAF(),cancelLastRAF=null,taskQueue.length=0))}}var requestAnimationFrame=$window.requestAnimationFrame||$window.webkitRequestAnimationFrame,cancelAnimationFrame=$window.cancelAnimationFrame||$window.webkitCancelAnimationFrame||$window.webkitCancelRequestAnimationFrame,rafSupported=!!requestAnimationFrame,rafFn=rafSupported?function(fn){var id=requestAnimationFrame(fn);return function(){cancelAnimationFrame(id)}}:function(fn){var timer=$timeout(fn,16.66,!1);return function(){$timeout.cancel(timer)}};queueFn.supported=rafSupported;var cancelLastRAF,taskCount=0,taskQueue=[];return queueFn}]}function $RootScopeProvider(){function createChildScopeClass(parent){function ChildScope(){this.$$watchers=this.$$nextSibling=this.$$childHead=this.$$childTail=null,this.$$listeners={},this.$$listenerCount={},this.$id=nextUid(),this.$$ChildScope=null}return ChildScope.prototype=parent,ChildScope}var TTL=10,$rootScopeMinErr=minErr("$rootScope"),lastDirtyWatch=null,applyAsyncId=null;this.digestTtl=function(value){return arguments.length&&(TTL=value),TTL},this.$get=["$injector","$exceptionHandler","$parse","$browser",function($injector,$exceptionHandler,$parse,$browser){function destroyChildScope($event){$event.currentScope.$$destroyed=!0}function Scope(){this.$id=nextUid(),this.$$phase=this.$parent=this.$$watchers=this.$$nextSibling=this.$$prevSibling=this.$$childHead=this.$$childTail=null,this.$root=this,this.$$destroyed=!1,this.$$listeners={},this.$$listenerCount={},this.$$isolateBindings=null}function beginPhase(phase){if($rootScope.$$phase)throw $rootScopeMinErr("inprog","{0} already in progress",$rootScope.$$phase);$rootScope.$$phase=phase}function clearPhase(){$rootScope.$$phase=null}function decrementListenerCount(current,count,name){do current.$$listenerCount[name]-=count,0===current.$$listenerCount[name]&&delete current.$$listenerCount[name];while(current=current.$parent)}function initWatchVal(){}function flushApplyAsync(){for(;applyAsyncQueue.length;)try{applyAsyncQueue.shift()()}catch(e){$exceptionHandler(e)}applyAsyncId=null}function scheduleApplyAsync(){null===applyAsyncId&&(applyAsyncId=$browser.defer(function(){$rootScope.$apply(flushApplyAsync)}))}Scope.prototype={constructor:Scope,$new:function(isolate,parent){var child;return parent=parent||this,isolate?(child=new Scope,child.$root=this.$root):(this.$$ChildScope||(this.$$ChildScope=createChildScopeClass(this)),child=new this.$$ChildScope),child.$parent=parent,child.$$prevSibling=parent.$$childTail,parent.$$childHead?(parent.$$childTail.$$nextSibling=child,parent.$$childTail=child):parent.$$childHead=parent.$$childTail=child,(isolate||parent!=this)&&child.$on("$destroy",destroyChildScope),child},$watch:function(watchExp,listener,objectEquality){var get=$parse(watchExp);if(get.$$watchDelegate)return get.$$watchDelegate(this,listener,objectEquality,get);var scope=this,array=scope.$$watchers,watcher={fn:listener,last:initWatchVal,get:get,exp:watchExp,eq:!!objectEquality};return lastDirtyWatch=null,isFunction(listener)||(watcher.fn=noop),array||(array=scope.$$watchers=[]),array.unshift(watcher),function(){arrayRemove(array,watcher),lastDirtyWatch=null}},$watchGroup:function(watchExpressions,listener){function watchGroupAction(){changeReactionScheduled=!1,firstRun?(firstRun=!1,listener(newValues,newValues,self)):listener(newValues,oldValues,self)}var oldValues=new Array(watchExpressions.length),newValues=new Array(watchExpressions.length),deregisterFns=[],self=this,changeReactionScheduled=!1,firstRun=!0;if(!watchExpressions.length){var shouldCall=!0;return self.$evalAsync(function(){shouldCall&&listener(newValues,newValues,self)}),function(){shouldCall=!1}}return 1===watchExpressions.length?this.$watch(watchExpressions[0],function(value,oldValue,scope){newValues[0]=value,oldValues[0]=oldValue,listener(newValues,value===oldValue?newValues:oldValues,scope)}):(forEach(watchExpressions,function(expr,i){var unwatchFn=self.$watch(expr,function(value,oldValue){newValues[i]=value,oldValues[i]=oldValue,changeReactionScheduled||(changeReactionScheduled=!0,self.$evalAsync(watchGroupAction))});deregisterFns.push(unwatchFn)}),function(){for(;deregisterFns.length;)deregisterFns.shift()()})},$watchCollection:function(obj,listener){function $watchCollectionInterceptor(_value){newValue=_value;var newLength,key,bothNaN,newItem,oldItem;if(!isUndefined(newValue)){if(isObject(newValue))if(isArrayLike(newValue)){oldValue!==internalArray&&(oldValue=internalArray,oldLength=oldValue.length=0,changeDetected++),newLength=newValue.length,oldLength!==newLength&&(changeDetected++,oldValue.length=oldLength=newLength);for(var i=0;newLength>i;i++)oldItem=oldValue[i],newItem=newValue[i],bothNaN=oldItem!==oldItem&&newItem!==newItem,bothNaN||oldItem===newItem||(changeDetected++,oldValue[i]=newItem)}else{oldValue!==internalObject&&(oldValue=internalObject={},oldLength=0,changeDetected++),newLength=0;for(key in newValue)newValue.hasOwnProperty(key)&&(newLength++,newItem=newValue[key],oldItem=oldValue[key],key in oldValue?(bothNaN=oldItem!==oldItem&&newItem!==newItem,bothNaN||oldItem===newItem||(changeDetected++,oldValue[key]=newItem)):(oldLength++,oldValue[key]=newItem,changeDetected++));if(oldLength>newLength){changeDetected++;for(key in oldValue)newValue.hasOwnProperty(key)||(oldLength--,delete oldValue[key])}}else oldValue!==newValue&&(oldValue=newValue,changeDetected++);return changeDetected}}function $watchCollectionAction(){if(initRun?(initRun=!1,listener(newValue,newValue,self)):listener(newValue,veryOldValue,self),trackVeryOldValue)if(isObject(newValue))if(isArrayLike(newValue)){veryOldValue=new Array(newValue.length);for(var i=0;i<newValue.length;i++)veryOldValue[i]=newValue[i]}else{veryOldValue={};for(var key in newValue)hasOwnProperty.call(newValue,key)&&(veryOldValue[key]=newValue[key])}else veryOldValue=newValue}$watchCollectionInterceptor.$stateful=!0;var newValue,oldValue,veryOldValue,self=this,trackVeryOldValue=listener.length>1,changeDetected=0,changeDetector=$parse(obj,$watchCollectionInterceptor),internalArray=[],internalObject={},initRun=!0,oldLength=0;return this.$watch(changeDetector,$watchCollectionAction)},$digest:function(){var watch,value,last,watchers,length,dirty,next,current,logIdx,asyncTask,ttl=TTL,target=this,watchLog=[];beginPhase("$digest"),$browser.$$checkUrlChange(),this===$rootScope&&null!==applyAsyncId&&($browser.defer.cancel(applyAsyncId),flushApplyAsync()),lastDirtyWatch=null;do{for(dirty=!1,current=target;asyncQueue.length;){try{asyncTask=asyncQueue.shift(),asyncTask.scope.$eval(asyncTask.expression,asyncTask.locals)}catch(e){$exceptionHandler(e)}lastDirtyWatch=null}traverseScopesLoop:do{if(watchers=current.$$watchers)for(length=watchers.length;length--;)try{
if(watch=watchers[length])if((value=watch.get(current))===(last=watch.last)||(watch.eq?equals(value,last):"number"==typeof value&&"number"==typeof last&&isNaN(value)&&isNaN(last))){if(watch===lastDirtyWatch){dirty=!1;break traverseScopesLoop}}else dirty=!0,lastDirtyWatch=watch,watch.last=watch.eq?copy(value,null):value,watch.fn(value,last===initWatchVal?value:last,current),5>ttl&&(logIdx=4-ttl,watchLog[logIdx]||(watchLog[logIdx]=[]),watchLog[logIdx].push({msg:isFunction(watch.exp)?"fn: "+(watch.exp.name||watch.exp.toString()):watch.exp,newVal:value,oldVal:last}))}catch(e){$exceptionHandler(e)}if(!(next=current.$$childHead||current!==target&&current.$$nextSibling))for(;current!==target&&!(next=current.$$nextSibling);)current=current.$parent}while(current=next);if((dirty||asyncQueue.length)&&!ttl--)throw clearPhase(),$rootScopeMinErr("infdig","{0} $digest() iterations reached. Aborting!\nWatchers fired in the last 5 iterations: {1}",TTL,watchLog)}while(dirty||asyncQueue.length);for(clearPhase();postDigestQueue.length;)try{postDigestQueue.shift()()}catch(e){$exceptionHandler(e)}},$destroy:function(){if(!this.$$destroyed){var parent=this.$parent;if(this.$broadcast("$destroy"),this.$$destroyed=!0,this!==$rootScope){for(var eventName in this.$$listenerCount)decrementListenerCount(this,this.$$listenerCount[eventName],eventName);parent.$$childHead==this&&(parent.$$childHead=this.$$nextSibling),parent.$$childTail==this&&(parent.$$childTail=this.$$prevSibling),this.$$prevSibling&&(this.$$prevSibling.$$nextSibling=this.$$nextSibling),this.$$nextSibling&&(this.$$nextSibling.$$prevSibling=this.$$prevSibling),this.$destroy=this.$digest=this.$apply=this.$evalAsync=this.$applyAsync=noop,this.$on=this.$watch=this.$watchGroup=function(){return noop},this.$$listeners={},this.$parent=this.$$nextSibling=this.$$prevSibling=this.$$childHead=this.$$childTail=this.$root=this.$$watchers=null}}},$eval:function(expr,locals){return $parse(expr)(this,locals)},$evalAsync:function(expr,locals){$rootScope.$$phase||asyncQueue.length||$browser.defer(function(){asyncQueue.length&&$rootScope.$digest()}),asyncQueue.push({scope:this,expression:expr,locals:locals})},$$postDigest:function(fn){postDigestQueue.push(fn)},$apply:function(expr){try{return beginPhase("$apply"),this.$eval(expr)}catch(e){$exceptionHandler(e)}finally{clearPhase();try{$rootScope.$digest()}catch(e){throw $exceptionHandler(e),e}}},$applyAsync:function(expr){function $applyAsyncExpression(){scope.$eval(expr)}var scope=this;expr&&applyAsyncQueue.push($applyAsyncExpression),scheduleApplyAsync()},$on:function(name,listener){var namedListeners=this.$$listeners[name];namedListeners||(this.$$listeners[name]=namedListeners=[]),namedListeners.push(listener);var current=this;do current.$$listenerCount[name]||(current.$$listenerCount[name]=0),current.$$listenerCount[name]++;while(current=current.$parent);var self=this;return function(){var indexOfListener=namedListeners.indexOf(listener);-1!==indexOfListener&&(namedListeners[indexOfListener]=null,decrementListenerCount(self,1,name))}},$emit:function(name,args){var namedListeners,i,length,empty=[],scope=this,stopPropagation=!1,event={name:name,targetScope:scope,stopPropagation:function(){stopPropagation=!0},preventDefault:function(){event.defaultPrevented=!0},defaultPrevented:!1},listenerArgs=concat([event],arguments,1);do{for(namedListeners=scope.$$listeners[name]||empty,event.currentScope=scope,i=0,length=namedListeners.length;length>i;i++)if(namedListeners[i])try{namedListeners[i].apply(null,listenerArgs)}catch(e){$exceptionHandler(e)}else namedListeners.splice(i,1),i--,length--;if(stopPropagation)return event.currentScope=null,event;scope=scope.$parent}while(scope);return event.currentScope=null,event},$broadcast:function(name,args){var target=this,current=target,next=target,event={name:name,targetScope:target,preventDefault:function(){event.defaultPrevented=!0},defaultPrevented:!1};if(!target.$$listenerCount[name])return event;for(var listeners,i,length,listenerArgs=concat([event],arguments,1);current=next;){for(event.currentScope=current,listeners=current.$$listeners[name]||[],i=0,length=listeners.length;length>i;i++)if(listeners[i])try{listeners[i].apply(null,listenerArgs)}catch(e){$exceptionHandler(e)}else listeners.splice(i,1),i--,length--;if(!(next=current.$$listenerCount[name]&&current.$$childHead||current!==target&&current.$$nextSibling))for(;current!==target&&!(next=current.$$nextSibling);)current=current.$parent}return event.currentScope=null,event}};var $rootScope=new Scope,asyncQueue=$rootScope.$$asyncQueue=[],postDigestQueue=$rootScope.$$postDigestQueue=[],applyAsyncQueue=$rootScope.$$applyAsyncQueue=[];return $rootScope}]}function $$SanitizeUriProvider(){var aHrefSanitizationWhitelist=/^\s*(https?|ftp|mailto|tel|file):/,imgSrcSanitizationWhitelist=/^\s*((https?|ftp|file|blob):|data:image\/)/;this.aHrefSanitizationWhitelist=function(regexp){return isDefined(regexp)?(aHrefSanitizationWhitelist=regexp,this):aHrefSanitizationWhitelist},this.imgSrcSanitizationWhitelist=function(regexp){return isDefined(regexp)?(imgSrcSanitizationWhitelist=regexp,this):imgSrcSanitizationWhitelist},this.$get=function(){return function(uri,isImage){var normalizedVal,regex=isImage?imgSrcSanitizationWhitelist:aHrefSanitizationWhitelist;return normalizedVal=urlResolve(uri).href,""===normalizedVal||normalizedVal.match(regex)?uri:"unsafe:"+normalizedVal}}}function adjustMatcher(matcher){if("self"===matcher)return matcher;if(isString(matcher)){if(matcher.indexOf("***")>-1)throw $sceMinErr("iwcard","Illegal sequence *** in string matcher.  String: {0}",matcher);return matcher=escapeForRegexp(matcher).replace("\\*\\*",".*").replace("\\*","[^:/.?&;]*"),new RegExp("^"+matcher+"$")}if(isRegExp(matcher))return new RegExp("^"+matcher.source+"$");throw $sceMinErr("imatcher",'Matchers may only be "self", string patterns or RegExp objects')}function adjustMatchers(matchers){var adjustedMatchers=[];return isDefined(matchers)&&forEach(matchers,function(matcher){adjustedMatchers.push(adjustMatcher(matcher))}),adjustedMatchers}function $SceDelegateProvider(){this.SCE_CONTEXTS=SCE_CONTEXTS;var resourceUrlWhitelist=["self"],resourceUrlBlacklist=[];this.resourceUrlWhitelist=function(value){return arguments.length&&(resourceUrlWhitelist=adjustMatchers(value)),resourceUrlWhitelist},this.resourceUrlBlacklist=function(value){return arguments.length&&(resourceUrlBlacklist=adjustMatchers(value)),resourceUrlBlacklist},this.$get=["$injector",function($injector){function matchUrl(matcher,parsedUrl){return"self"===matcher?urlIsSameOrigin(parsedUrl):!!matcher.exec(parsedUrl.href)}function isResourceUrlAllowedByPolicy(url){var i,n,parsedUrl=urlResolve(url.toString()),allowed=!1;for(i=0,n=resourceUrlWhitelist.length;n>i;i++)if(matchUrl(resourceUrlWhitelist[i],parsedUrl)){allowed=!0;break}if(allowed)for(i=0,n=resourceUrlBlacklist.length;n>i;i++)if(matchUrl(resourceUrlBlacklist[i],parsedUrl)){allowed=!1;break}return allowed}function generateHolderType(Base){var holderType=function(trustedValue){this.$$unwrapTrustedValue=function(){return trustedValue}};return Base&&(holderType.prototype=new Base),holderType.prototype.valueOf=function(){return this.$$unwrapTrustedValue()},holderType.prototype.toString=function(){return this.$$unwrapTrustedValue().toString()},holderType}function trustAs(type,trustedValue){var Constructor=byType.hasOwnProperty(type)?byType[type]:null;if(!Constructor)throw $sceMinErr("icontext","Attempted to trust a value in invalid context. Context: {0}; Value: {1}",type,trustedValue);if(null===trustedValue||trustedValue===undefined||""===trustedValue)return trustedValue;if("string"!=typeof trustedValue)throw $sceMinErr("itype","Attempted to trust a non-string value in a content requiring a string: Context: {0}",type);return new Constructor(trustedValue)}function valueOf(maybeTrusted){return maybeTrusted instanceof trustedValueHolderBase?maybeTrusted.$$unwrapTrustedValue():maybeTrusted}function getTrusted(type,maybeTrusted){if(null===maybeTrusted||maybeTrusted===undefined||""===maybeTrusted)return maybeTrusted;var constructor=byType.hasOwnProperty(type)?byType[type]:null;if(constructor&&maybeTrusted instanceof constructor)return maybeTrusted.$$unwrapTrustedValue();if(type===SCE_CONTEXTS.RESOURCE_URL){if(isResourceUrlAllowedByPolicy(maybeTrusted))return maybeTrusted;throw $sceMinErr("insecurl","Blocked loading resource from url not allowed by $sceDelegate policy.  URL: {0}",maybeTrusted.toString())}if(type===SCE_CONTEXTS.HTML)return htmlSanitizer(maybeTrusted);throw $sceMinErr("unsafe","Attempting to use an unsafe value in a safe context.")}var htmlSanitizer=function(html){throw $sceMinErr("unsafe","Attempting to use an unsafe value in a safe context.")};$injector.has("$sanitize")&&(htmlSanitizer=$injector.get("$sanitize"));var trustedValueHolderBase=generateHolderType(),byType={};return byType[SCE_CONTEXTS.HTML]=generateHolderType(trustedValueHolderBase),byType[SCE_CONTEXTS.CSS]=generateHolderType(trustedValueHolderBase),byType[SCE_CONTEXTS.URL]=generateHolderType(trustedValueHolderBase),byType[SCE_CONTEXTS.JS]=generateHolderType(trustedValueHolderBase),byType[SCE_CONTEXTS.RESOURCE_URL]=generateHolderType(byType[SCE_CONTEXTS.URL]),{trustAs:trustAs,getTrusted:getTrusted,valueOf:valueOf}}]}function $SceProvider(){var enabled=!0;this.enabled=function(value){return arguments.length&&(enabled=!!value),enabled},this.$get=["$parse","$sceDelegate",function($parse,$sceDelegate){if(enabled&&8>msie)throw $sceMinErr("iequirks","Strict Contextual Escaping does not support Internet Explorer version < 11 in quirks mode.  You can fix this by adding the text <!doctype html> to the top of your HTML document.  See http://docs.angularjs.org/api/ng.$sce for more information.");var sce=shallowCopy(SCE_CONTEXTS);sce.isEnabled=function(){return enabled},sce.trustAs=$sceDelegate.trustAs,sce.getTrusted=$sceDelegate.getTrusted,sce.valueOf=$sceDelegate.valueOf,enabled||(sce.trustAs=sce.getTrusted=function(type,value){return value},sce.valueOf=identity),sce.parseAs=function(type,expr){var parsed=$parse(expr);return parsed.literal&&parsed.constant?parsed:$parse(expr,function(value){return sce.getTrusted(type,value)})};var parse=sce.parseAs,getTrusted=sce.getTrusted,trustAs=sce.trustAs;return forEach(SCE_CONTEXTS,function(enumValue,name){var lName=lowercase(name);sce[camelCase("parse_as_"+lName)]=function(expr){return parse(enumValue,expr)},sce[camelCase("get_trusted_"+lName)]=function(value){return getTrusted(enumValue,value)},sce[camelCase("trust_as_"+lName)]=function(value){return trustAs(enumValue,value)}}),sce}]}function $SnifferProvider(){this.$get=["$window","$document",function($window,$document){var vendorPrefix,match,eventSupport={},android=int((/android (\d+)/.exec(lowercase(($window.navigator||{}).userAgent))||[])[1]),boxee=/Boxee/i.test(($window.navigator||{}).userAgent),document=$document[0]||{},vendorRegex=/^(Moz|webkit|ms)(?=[A-Z])/,bodyStyle=document.body&&document.body.style,transitions=!1,animations=!1;if(bodyStyle){for(var prop in bodyStyle)if(match=vendorRegex.exec(prop)){vendorPrefix=match[0],vendorPrefix=vendorPrefix.substr(0,1).toUpperCase()+vendorPrefix.substr(1);break}vendorPrefix||(vendorPrefix="WebkitOpacity"in bodyStyle&&"webkit"),transitions=!!("transition"in bodyStyle||vendorPrefix+"Transition"in bodyStyle),animations=!!("animation"in bodyStyle||vendorPrefix+"Animation"in bodyStyle),!android||transitions&&animations||(transitions=isString(document.body.style.webkitTransition),animations=isString(document.body.style.webkitAnimation))}return{history:!(!$window.history||!$window.history.pushState||4>android||boxee),hasEvent:function(event){if("input"===event&&11>=msie)return!1;if(isUndefined(eventSupport[event])){var divElm=document.createElement("div");eventSupport[event]="on"+event in divElm}return eventSupport[event]},csp:csp(),vendorPrefix:vendorPrefix,transitions:transitions,animations:animations,android:android}}]}function $TemplateRequestProvider(){this.$get=["$templateCache","$http","$q","$sce",function($templateCache,$http,$q,$sce){function handleRequestFn(tpl,ignoreRequestError){function handleError(resp){if(!ignoreRequestError)throw $compileMinErr("tpload","Failed to load template: {0}",tpl);return $q.reject(resp)}handleRequestFn.totalPendingRequests++,isString(tpl)&&$templateCache.get(tpl)||(tpl=$sce.getTrustedResourceUrl(tpl));var transformResponse=$http.defaults&&$http.defaults.transformResponse;isArray(transformResponse)?transformResponse=transformResponse.filter(function(transformer){return transformer!==defaultHttpResponseTransform}):transformResponse===defaultHttpResponseTransform&&(transformResponse=null);var httpOptions={cache:$templateCache,transformResponse:transformResponse};return $http.get(tpl,httpOptions)["finally"](function(){handleRequestFn.totalPendingRequests--}).then(function(response){return response.data},handleError)}return handleRequestFn.totalPendingRequests=0,handleRequestFn}]}function $$TestabilityProvider(){this.$get=["$rootScope","$browser","$location",function($rootScope,$browser,$location){var testability={};return testability.findBindings=function(element,expression,opt_exactMatch){var bindings=element.getElementsByClassName("ng-binding"),matches=[];return forEach(bindings,function(binding){var dataBinding=angular.element(binding).data("$binding");dataBinding&&forEach(dataBinding,function(bindingName){if(opt_exactMatch){var matcher=new RegExp("(^|\\s)"+escapeForRegexp(expression)+"(\\s|\\||$)");matcher.test(bindingName)&&matches.push(binding)}else-1!=bindingName.indexOf(expression)&&matches.push(binding)})}),matches},testability.findModels=function(element,expression,opt_exactMatch){for(var prefixes=["ng-","data-ng-","ng\\:"],p=0;p<prefixes.length;++p){var attributeEquals=opt_exactMatch?"=":"*=",selector="["+prefixes[p]+"model"+attributeEquals+'"'+expression+'"]',elements=element.querySelectorAll(selector);if(elements.length)return elements}},testability.getLocation=function(){return $location.url()},testability.setLocation=function(url){url!==$location.url()&&($location.url(url),$rootScope.$digest())},testability.whenStable=function(callback){$browser.notifyWhenNoOutstandingRequests(callback)},testability}]}function $TimeoutProvider(){this.$get=["$rootScope","$browser","$q","$$q","$exceptionHandler",function($rootScope,$browser,$q,$$q,$exceptionHandler){function timeout(fn,delay,invokeApply){var timeoutId,skipApply=isDefined(invokeApply)&&!invokeApply,deferred=(skipApply?$$q:$q).defer(),promise=deferred.promise;return timeoutId=$browser.defer(function(){try{deferred.resolve(fn())}catch(e){deferred.reject(e),$exceptionHandler(e)}finally{delete deferreds[promise.$$timeoutId]}skipApply||$rootScope.$apply()},delay),promise.$$timeoutId=timeoutId,deferreds[timeoutId]=deferred,promise}var deferreds={};return timeout.cancel=function(promise){return promise&&promise.$$timeoutId in deferreds?(deferreds[promise.$$timeoutId].reject("canceled"),delete deferreds[promise.$$timeoutId],$browser.defer.cancel(promise.$$timeoutId)):!1},timeout}]}function urlResolve(url){var href=url;return msie&&(urlParsingNode.setAttribute("href",href),href=urlParsingNode.href),urlParsingNode.setAttribute("href",href),{href:urlParsingNode.href,protocol:urlParsingNode.protocol?urlParsingNode.protocol.replace(/:$/,""):"",host:urlParsingNode.host,search:urlParsingNode.search?urlParsingNode.search.replace(/^\?/,""):"",hash:urlParsingNode.hash?urlParsingNode.hash.replace(/^#/,""):"",hostname:urlParsingNode.hostname,port:urlParsingNode.port,pathname:"/"===urlParsingNode.pathname.charAt(0)?urlParsingNode.pathname:"/"+urlParsingNode.pathname}}function urlIsSameOrigin(requestUrl){var parsed=isString(requestUrl)?urlResolve(requestUrl):requestUrl;return parsed.protocol===originUrl.protocol&&parsed.host===originUrl.host}function $WindowProvider(){this.$get=valueFn(window)}function $FilterProvider($provide){function register(name,factory){if(isObject(name)){var filters={};return forEach(name,function(filter,key){filters[key]=register(key,filter)}),filters}return $provide.factory(name+suffix,factory)}var suffix="Filter";this.register=register,this.$get=["$injector",function($injector){return function(name){return $injector.get(name+suffix)}}],register("currency",currencyFilter),register("date",dateFilter),register("filter",filterFilter),register("json",jsonFilter),register("limitTo",limitToFilter),register("lowercase",lowercaseFilter),register("number",numberFilter),register("orderBy",orderByFilter),register("uppercase",uppercaseFilter)}function filterFilter(){return function(array,expression,comparator){if(!isArray(array))return array;var predicateFn,matchAgainstAnyProp,expressionType=null!==expression?typeof expression:"null";switch(expressionType){case"function":predicateFn=expression;break;case"boolean":case"null":case"number":case"string":matchAgainstAnyProp=!0;case"object":predicateFn=createPredicateFn(expression,comparator,matchAgainstAnyProp);break;default:return array}return array.filter(predicateFn)}}function createPredicateFn(expression,comparator,matchAgainstAnyProp){var predicateFn,shouldMatchPrimitives=isObject(expression)&&"$"in expression;return comparator===!0?comparator=equals:isFunction(comparator)||(comparator=function(actual,expected){return isUndefined(actual)?!1:null===actual||null===expected?actual===expected:isObject(actual)||isObject(expected)?!1:(actual=lowercase(""+actual),expected=lowercase(""+expected),-1!==actual.indexOf(expected))}),predicateFn=function(item){return shouldMatchPrimitives&&!isObject(item)?deepCompare(item,expression.$,comparator,!1):deepCompare(item,expression,comparator,matchAgainstAnyProp)}}function deepCompare(actual,expected,comparator,matchAgainstAnyProp,dontMatchWholeObject){var actualType=null!==actual?typeof actual:"null",expectedType=null!==expected?typeof expected:"null";if("string"===expectedType&&"!"===expected.charAt(0))return!deepCompare(actual,expected.substring(1),comparator,matchAgainstAnyProp);if(isArray(actual))return actual.some(function(item){return deepCompare(item,expected,comparator,matchAgainstAnyProp)});switch(actualType){case"object":var key;if(matchAgainstAnyProp){for(key in actual)if("$"!==key.charAt(0)&&deepCompare(actual[key],expected,comparator,!0))return!0;return dontMatchWholeObject?!1:deepCompare(actual,expected,comparator,!1)}if("object"===expectedType){for(key in expected){var expectedVal=expected[key];if(!isFunction(expectedVal)&&!isUndefined(expectedVal)){var matchAnyProperty="$"===key,actualVal=matchAnyProperty?actual:actual[key];if(!deepCompare(actualVal,expectedVal,comparator,matchAnyProperty,matchAnyProperty))return!1}}return!0}return comparator(actual,expected);case"function":return!1;default:return comparator(actual,expected)}}function currencyFilter($locale){var formats=$locale.NUMBER_FORMATS;return function(amount,currencySymbol,fractionSize){return isUndefined(currencySymbol)&&(currencySymbol=formats.CURRENCY_SYM),isUndefined(fractionSize)&&(fractionSize=formats.PATTERNS[1].maxFrac),null==amount?amount:formatNumber(amount,formats.PATTERNS[1],formats.GROUP_SEP,formats.DECIMAL_SEP,fractionSize).replace(/\u00A4/g,currencySymbol)}}function numberFilter($locale){var formats=$locale.NUMBER_FORMATS;return function(number,fractionSize){return null==number?number:formatNumber(number,formats.PATTERNS[0],formats.GROUP_SEP,formats.DECIMAL_SEP,fractionSize)}}function formatNumber(number,pattern,groupSep,decimalSep,fractionSize){if(!isFinite(number)||isObject(number))return"";var isNegative=0>number;number=Math.abs(number);var numStr=number+"",formatedText="",parts=[],hasExponent=!1;if(-1!==numStr.indexOf("e")){var match=numStr.match(/([\d\.]+)e(-?)(\d+)/);match&&"-"==match[2]&&match[3]>fractionSize+1?number=0:(formatedText=numStr,hasExponent=!0)}if(hasExponent)fractionSize>0&&1>number&&(formatedText=number.toFixed(fractionSize),number=parseFloat(formatedText));else{var fractionLen=(numStr.split(DECIMAL_SEP)[1]||"").length;isUndefined(fractionSize)&&(fractionSize=Math.min(Math.max(pattern.minFrac,fractionLen),pattern.maxFrac)),number=+(Math.round(+(number.toString()+"e"+fractionSize)).toString()+"e"+-fractionSize);var fraction=(""+number).split(DECIMAL_SEP),whole=fraction[0];fraction=fraction[1]||"";var i,pos=0,lgroup=pattern.lgSize,group=pattern.gSize;if(whole.length>=lgroup+group)for(pos=whole.length-lgroup,i=0;pos>i;i++)(pos-i)%group===0&&0!==i&&(formatedText+=groupSep),formatedText+=whole.charAt(i);for(i=pos;i<whole.length;i++)(whole.length-i)%lgroup===0&&0!==i&&(formatedText+=groupSep),formatedText+=whole.charAt(i);for(;fraction.length<fractionSize;)fraction+="0";fractionSize&&"0"!==fractionSize&&(formatedText+=decimalSep+fraction.substr(0,fractionSize))}return 0===number&&(isNegative=!1),parts.push(isNegative?pattern.negPre:pattern.posPre,formatedText,isNegative?pattern.negSuf:pattern.posSuf),parts.join("")}function padNumber(num,digits,trim){var neg="";for(0>num&&(neg="-",num=-num),num=""+num;num.length<digits;)num="0"+num;return trim&&(num=num.substr(num.length-digits)),neg+num}function dateGetter(name,size,offset,trim){return offset=offset||0,function(date){var value=date["get"+name]();return(offset>0||value>-offset)&&(value+=offset),0===value&&-12==offset&&(value=12),padNumber(value,size,trim)}}function dateStrGetter(name,shortForm){return function(date,formats){var value=date["get"+name](),get=uppercase(shortForm?"SHORT"+name:name);return formats[get][value]}}function timeZoneGetter(date){var zone=-1*date.getTimezoneOffset(),paddedZone=zone>=0?"+":"";return paddedZone+=padNumber(Math[zone>0?"floor":"ceil"](zone/60),2)+padNumber(Math.abs(zone%60),2)}function getFirstThursdayOfYear(year){var dayOfWeekOnFirst=new Date(year,0,1).getDay();return new Date(year,0,(4>=dayOfWeekOnFirst?5:12)-dayOfWeekOnFirst)}function getThursdayThisWeek(datetime){return new Date(datetime.getFullYear(),datetime.getMonth(),datetime.getDate()+(4-datetime.getDay()))}function weekGetter(size){return function(date){var firstThurs=getFirstThursdayOfYear(date.getFullYear()),thisThurs=getThursdayThisWeek(date),diff=+thisThurs-+firstThurs,result=1+Math.round(diff/6048e5);return padNumber(result,size)}}function ampmGetter(date,formats){return date.getHours()<12?formats.AMPMS[0]:formats.AMPMS[1]}function eraGetter(date,formats){return date.getFullYear()<=0?formats.ERAS[0]:formats.ERAS[1]}function longEraGetter(date,formats){return date.getFullYear()<=0?formats.ERANAMES[0]:formats.ERANAMES[1]}function dateFilter($locale){function jsonStringToDate(string){var match;if(match=string.match(R_ISO8601_STR)){var date=new Date(0),tzHour=0,tzMin=0,dateSetter=match[8]?date.setUTCFullYear:date.setFullYear,timeSetter=match[8]?date.setUTCHours:date.setHours;match[9]&&(tzHour=int(match[9]+match[10]),tzMin=int(match[9]+match[11])),dateSetter.call(date,int(match[1]),int(match[2])-1,int(match[3]));var h=int(match[4]||0)-tzHour,m=int(match[5]||0)-tzMin,s=int(match[6]||0),ms=Math.round(1e3*parseFloat("0."+(match[7]||0)));return timeSetter.call(date,h,m,s,ms),date}return string}var R_ISO8601_STR=/^(\d{4})-?(\d\d)-?(\d\d)(?:T(\d\d)(?::?(\d\d)(?::?(\d\d)(?:\.(\d+))?)?)?(Z|([+-])(\d\d):?(\d\d))?)?$/;return function(date,format,timezone){var fn,match,text="",parts=[];if(format=format||"mediumDate",format=$locale.DATETIME_FORMATS[format]||format,isString(date)&&(date=NUMBER_STRING.test(date)?int(date):jsonStringToDate(date)),isNumber(date)&&(date=new Date(date)),!isDate(date))return date;for(;format;)match=DATE_FORMATS_SPLIT.exec(format),match?(parts=concat(parts,match,1),format=parts.pop()):(parts.push(format),format=null);return timezone&&"UTC"===timezone&&(date=new Date(date.getTime()),date.setMinutes(date.getMinutes()+date.getTimezoneOffset())),forEach(parts,function(value){fn=DATE_FORMATS[value],text+=fn?fn(date,$locale.DATETIME_FORMATS):value.replace(/(^'|'$)/g,"").replace(/''/g,"'")}),text}}function jsonFilter(){return function(object,spacing){return isUndefined(spacing)&&(spacing=2),toJson(object,spacing)}}function limitToFilter(){return function(input,limit){return isNumber(input)&&(input=input.toString()),isArray(input)||isString(input)?(limit=Math.abs(Number(limit))===1/0?Number(limit):int(limit),limit?limit>0?input.slice(0,limit):input.slice(limit):isString(input)?"":[]):input}}function orderByFilter($parse){return function(array,sortPredicate,reverseOrder){function comparator(o1,o2){for(var i=0;i<sortPredicate.length;i++){var comp=sortPredicate[i](o1,o2);if(0!==comp)return comp}return 0}function reverseComparator(comp,descending){return descending?function(a,b){return comp(b,a)}:comp}function isPrimitive(value){switch(typeof value){case"number":case"boolean":case"string":return!0;default:return!1}}function objectToString(value){return null===value?"null":"function"==typeof value.valueOf&&(value=value.valueOf(),isPrimitive(value))?value:"function"==typeof value.toString&&(value=value.toString(),isPrimitive(value))?value:""}function compare(v1,v2){var t1=typeof v1,t2=typeof v2;return t1===t2&&"object"===t1&&(v1=objectToString(v1),v2=objectToString(v2)),t1===t2?("string"===t1&&(v1=v1.toLowerCase(),v2=v2.toLowerCase()),v1===v2?0:v2>v1?-1:1):t2>t1?-1:1}return isArrayLike(array)?(sortPredicate=isArray(sortPredicate)?sortPredicate:[sortPredicate],0===sortPredicate.length&&(sortPredicate=["+"]),sortPredicate=sortPredicate.map(function(predicate){var descending=!1,get=predicate||identity;if(isString(predicate)){if(("+"==predicate.charAt(0)||"-"==predicate.charAt(0))&&(descending="-"==predicate.charAt(0),predicate=predicate.substring(1)),""===predicate)return reverseComparator(compare,descending);if(get=$parse(predicate),get.constant){var key=get();return reverseComparator(function(a,b){return compare(a[key],b[key])},descending)}}return reverseComparator(function(a,b){return compare(get(a),get(b))},descending)}),slice.call(array).sort(reverseComparator(comparator,reverseOrder))):array}}function ngDirective(directive){return isFunction(directive)&&(directive={link:directive}),directive.restrict=directive.restrict||"AC",valueFn(directive)}function nullFormRenameControl(control,name){control.$name=name}function FormController(element,attrs,$scope,$animate,$interpolate){var form=this,controls=[],parentForm=form.$$parentForm=element.parent().controller("form")||nullFormCtrl;form.$error={},form.$$success={},form.$pending=undefined,form.$name=$interpolate(attrs.name||attrs.ngForm||"")($scope),form.$dirty=!1,form.$pristine=!0,form.$valid=!0,form.$invalid=!1,form.$submitted=!1,parentForm.$addControl(form),form.$rollbackViewValue=function(){forEach(controls,function(control){control.$rollbackViewValue()})},form.$commitViewValue=function(){forEach(controls,function(control){control.$commitViewValue()})},form.$addControl=function(control){assertNotHasOwnProperty(control.$name,"input"),controls.push(control),control.$name&&(form[control.$name]=control)},form.$$renameControl=function(control,newName){var oldName=control.$name;form[oldName]===control&&delete form[oldName],form[newName]=control,control.$name=newName},form.$removeControl=function(control){control.$name&&form[control.$name]===control&&delete form[control.$name],forEach(form.$pending,function(value,name){form.$setValidity(name,null,control)}),forEach(form.$error,function(value,name){form.$setValidity(name,null,control)}),forEach(form.$$success,function(value,name){form.$setValidity(name,null,control)}),arrayRemove(controls,control)},addSetValidityMethod({ctrl:this,$element:element,set:function(object,property,controller){var list=object[property];if(list){var index=list.indexOf(controller);-1===index&&list.push(controller)}else object[property]=[controller]},unset:function(object,property,controller){var list=object[property];list&&(arrayRemove(list,controller),0===list.length&&delete object[property])},parentForm:parentForm,$animate:$animate}),form.$setDirty=function(){$animate.removeClass(element,PRISTINE_CLASS),$animate.addClass(element,DIRTY_CLASS),form.$dirty=!0,form.$pristine=!1,parentForm.$setDirty()},form.$setPristine=function(){$animate.setClass(element,PRISTINE_CLASS,DIRTY_CLASS+" "+SUBMITTED_CLASS),form.$dirty=!1,form.$pristine=!0,form.$submitted=!1,forEach(controls,function(control){control.$setPristine()})},form.$setUntouched=function(){forEach(controls,function(control){control.$setUntouched()})},form.$setSubmitted=function(){$animate.addClass(element,SUBMITTED_CLASS),form.$submitted=!0,parentForm.$setSubmitted()}}function stringBasedInputType(ctrl){ctrl.$formatters.push(function(value){return ctrl.$isEmpty(value)?value:value.toString()})}function textInputType(scope,element,attr,ctrl,$sniffer,$browser){baseInputType(scope,element,attr,ctrl,$sniffer,$browser),stringBasedInputType(ctrl)}function baseInputType(scope,element,attr,ctrl,$sniffer,$browser){var type=lowercase(element[0].type);if(!$sniffer.android){var composing=!1;element.on("compositionstart",function(data){composing=!0}),element.on("compositionend",function(){composing=!1,listener()})}var listener=function(ev){if(timeout&&($browser.defer.cancel(timeout),timeout=null),!composing){var value=element.val(),event=ev&&ev.type;"password"===type||attr.ngTrim&&"false"===attr.ngTrim||(value=trim(value)),(ctrl.$viewValue!==value||""===value&&ctrl.$$hasNativeValidators)&&ctrl.$setViewValue(value,event)}};if($sniffer.hasEvent("input"))element.on("input",listener);else{var timeout,deferListener=function(ev,input,origValue){timeout||(timeout=$browser.defer(function(){timeout=null,input&&input.value===origValue||listener(ev)}))};element.on("keydown",function(event){var key=event.keyCode;91===key||key>15&&19>key||key>=37&&40>=key||deferListener(event,this,this.value)}),$sniffer.hasEvent("paste")&&element.on("paste cut",deferListener)}element.on("change",listener),ctrl.$render=function(){element.val(ctrl.$isEmpty(ctrl.$viewValue)?"":ctrl.$viewValue)}}function weekParser(isoWeek,existingDate){if(isDate(isoWeek))return isoWeek;if(isString(isoWeek)){WEEK_REGEXP.lastIndex=0;var parts=WEEK_REGEXP.exec(isoWeek);if(parts){var year=+parts[1],week=+parts[2],hours=0,minutes=0,seconds=0,milliseconds=0,firstThurs=getFirstThursdayOfYear(year),addDays=7*(week-1);return existingDate&&(hours=existingDate.getHours(),minutes=existingDate.getMinutes(),seconds=existingDate.getSeconds(),milliseconds=existingDate.getMilliseconds()),new Date(year,0,firstThurs.getDate()+addDays,hours,minutes,seconds,milliseconds)}}return NaN}function createDateParser(regexp,mapping){return function(iso,date){var parts,map;if(isDate(iso))return iso;if(isString(iso)){if('"'==iso.charAt(0)&&'"'==iso.charAt(iso.length-1)&&(iso=iso.substring(1,iso.length-1)),ISO_DATE_REGEXP.test(iso))return new Date(iso);if(regexp.lastIndex=0,parts=regexp.exec(iso))return parts.shift(),map=date?{yyyy:date.getFullYear(),MM:date.getMonth()+1,dd:date.getDate(),HH:date.getHours(),mm:date.getMinutes(),ss:date.getSeconds(),sss:date.getMilliseconds()/1e3}:{yyyy:1970,MM:1,dd:1,HH:0,mm:0,ss:0,sss:0},forEach(parts,function(part,index){index<mapping.length&&(map[mapping[index]]=+part)}),new Date(map.yyyy,map.MM-1,map.dd,map.HH,map.mm,map.ss||0,1e3*map.sss||0)}return NaN}}function createDateInputType(type,regexp,parseDate,format){return function(scope,element,attr,ctrl,$sniffer,$browser,$filter){function isValidDate(value){return value&&!(value.getTime&&value.getTime()!==value.getTime())}function parseObservedDateValue(val){return isDefined(val)?isDate(val)?val:parseDate(val):undefined}badInputChecker(scope,element,attr,ctrl),baseInputType(scope,element,attr,ctrl,$sniffer,$browser);var previousDate,timezone=ctrl&&ctrl.$options&&ctrl.$options.timezone;if(ctrl.$$parserName=type,ctrl.$parsers.push(function(value){if(ctrl.$isEmpty(value))return null;if(regexp.test(value)){var parsedDate=parseDate(value,previousDate);return"UTC"===timezone&&parsedDate.setMinutes(parsedDate.getMinutes()-parsedDate.getTimezoneOffset()),parsedDate}return undefined}),ctrl.$formatters.push(function(value){if(value&&!isDate(value))throw ngModelMinErr("datefmt","Expected `{0}` to be a date",value);
if(isValidDate(value)){if(previousDate=value,previousDate&&"UTC"===timezone){var timezoneOffset=6e4*previousDate.getTimezoneOffset();previousDate=new Date(previousDate.getTime()+timezoneOffset)}return $filter("date")(value,format,timezone)}return previousDate=null,""}),isDefined(attr.min)||attr.ngMin){var minVal;ctrl.$validators.min=function(value){return!isValidDate(value)||isUndefined(minVal)||parseDate(value)>=minVal},attr.$observe("min",function(val){minVal=parseObservedDateValue(val),ctrl.$validate()})}if(isDefined(attr.max)||attr.ngMax){var maxVal;ctrl.$validators.max=function(value){return!isValidDate(value)||isUndefined(maxVal)||parseDate(value)<=maxVal},attr.$observe("max",function(val){maxVal=parseObservedDateValue(val),ctrl.$validate()})}}}function badInputChecker(scope,element,attr,ctrl){var node=element[0],nativeValidation=ctrl.$$hasNativeValidators=isObject(node.validity);nativeValidation&&ctrl.$parsers.push(function(value){var validity=element.prop(VALIDITY_STATE_PROPERTY)||{};return validity.badInput&&!validity.typeMismatch?undefined:value})}function numberInputType(scope,element,attr,ctrl,$sniffer,$browser){if(badInputChecker(scope,element,attr,ctrl),baseInputType(scope,element,attr,ctrl,$sniffer,$browser),ctrl.$$parserName="number",ctrl.$parsers.push(function(value){return ctrl.$isEmpty(value)?null:NUMBER_REGEXP.test(value)?parseFloat(value):undefined}),ctrl.$formatters.push(function(value){if(!ctrl.$isEmpty(value)){if(!isNumber(value))throw ngModelMinErr("numfmt","Expected `{0}` to be a number",value);value=value.toString()}return value}),isDefined(attr.min)||attr.ngMin){var minVal;ctrl.$validators.min=function(value){return ctrl.$isEmpty(value)||isUndefined(minVal)||value>=minVal},attr.$observe("min",function(val){isDefined(val)&&!isNumber(val)&&(val=parseFloat(val,10)),minVal=isNumber(val)&&!isNaN(val)?val:undefined,ctrl.$validate()})}if(isDefined(attr.max)||attr.ngMax){var maxVal;ctrl.$validators.max=function(value){return ctrl.$isEmpty(value)||isUndefined(maxVal)||maxVal>=value},attr.$observe("max",function(val){isDefined(val)&&!isNumber(val)&&(val=parseFloat(val,10)),maxVal=isNumber(val)&&!isNaN(val)?val:undefined,ctrl.$validate()})}}function urlInputType(scope,element,attr,ctrl,$sniffer,$browser){baseInputType(scope,element,attr,ctrl,$sniffer,$browser),stringBasedInputType(ctrl),ctrl.$$parserName="url",ctrl.$validators.url=function(modelValue,viewValue){var value=modelValue||viewValue;return ctrl.$isEmpty(value)||URL_REGEXP.test(value)}}function emailInputType(scope,element,attr,ctrl,$sniffer,$browser){baseInputType(scope,element,attr,ctrl,$sniffer,$browser),stringBasedInputType(ctrl),ctrl.$$parserName="email",ctrl.$validators.email=function(modelValue,viewValue){var value=modelValue||viewValue;return ctrl.$isEmpty(value)||EMAIL_REGEXP.test(value)}}function radioInputType(scope,element,attr,ctrl){isUndefined(attr.name)&&element.attr("name",nextUid());var listener=function(ev){element[0].checked&&ctrl.$setViewValue(attr.value,ev&&ev.type)};element.on("click",listener),ctrl.$render=function(){var value=attr.value;element[0].checked=value==ctrl.$viewValue},attr.$observe("value",ctrl.$render)}function parseConstantExpr($parse,context,name,expression,fallback){var parseFn;if(isDefined(expression)){if(parseFn=$parse(expression),!parseFn.constant)throw ngModelMinErr("constexpr","Expected constant expression for `{0}`, but saw `{1}`.",name,expression);return parseFn(context)}return fallback}function checkboxInputType(scope,element,attr,ctrl,$sniffer,$browser,$filter,$parse){var trueValue=parseConstantExpr($parse,scope,"ngTrueValue",attr.ngTrueValue,!0),falseValue=parseConstantExpr($parse,scope,"ngFalseValue",attr.ngFalseValue,!1),listener=function(ev){ctrl.$setViewValue(element[0].checked,ev&&ev.type)};element.on("click",listener),ctrl.$render=function(){element[0].checked=ctrl.$viewValue},ctrl.$isEmpty=function(value){return value===!1},ctrl.$formatters.push(function(value){return equals(value,trueValue)}),ctrl.$parsers.push(function(value){return value?trueValue:falseValue})}function classDirective(name,selector){return name="ngClass"+name,["$animate",function($animate){function arrayDifference(tokens1,tokens2){var values=[];outer:for(var i=0;i<tokens1.length;i++){for(var token=tokens1[i],j=0;j<tokens2.length;j++)if(token==tokens2[j])continue outer;values.push(token)}return values}function arrayClasses(classVal){if(isArray(classVal))return classVal;if(isString(classVal))return classVal.split(" ");if(isObject(classVal)){var classes=[];return forEach(classVal,function(v,k){v&&(classes=classes.concat(k.split(" ")))}),classes}return classVal}return{restrict:"AC",link:function(scope,element,attr){function addClasses(classes){var newClasses=digestClassCounts(classes,1);attr.$addClass(newClasses)}function removeClasses(classes){var newClasses=digestClassCounts(classes,-1);attr.$removeClass(newClasses)}function digestClassCounts(classes,count){var classCounts=element.data("$classCounts")||{},classesToUpdate=[];return forEach(classes,function(className){(count>0||classCounts[className])&&(classCounts[className]=(classCounts[className]||0)+count,classCounts[className]===+(count>0)&&classesToUpdate.push(className))}),element.data("$classCounts",classCounts),classesToUpdate.join(" ")}function updateClasses(oldClasses,newClasses){var toAdd=arrayDifference(newClasses,oldClasses),toRemove=arrayDifference(oldClasses,newClasses);toAdd=digestClassCounts(toAdd,1),toRemove=digestClassCounts(toRemove,-1),toAdd&&toAdd.length&&$animate.addClass(element,toAdd),toRemove&&toRemove.length&&$animate.removeClass(element,toRemove)}function ngClassWatchAction(newVal){if(selector===!0||scope.$index%2===selector){var newClasses=arrayClasses(newVal||[]);if(oldVal){if(!equals(newVal,oldVal)){var oldClasses=arrayClasses(oldVal);updateClasses(oldClasses,newClasses)}}else addClasses(newClasses)}oldVal=shallowCopy(newVal)}var oldVal;scope.$watch(attr[name],ngClassWatchAction,!0),attr.$observe("class",function(value){ngClassWatchAction(scope.$eval(attr[name]))}),"ngClass"!==name&&scope.$watch("$index",function($index,old$index){var mod=1&$index;if(mod!==(1&old$index)){var classes=arrayClasses(scope.$eval(attr[name]));mod===selector?addClasses(classes):removeClasses(classes)}})}}}]}function addSetValidityMethod(context){function setValidity(validationErrorKey,state,controller){state===undefined?createAndSet("$pending",validationErrorKey,controller):unsetAndCleanup("$pending",validationErrorKey,controller),isBoolean(state)?state?(unset(ctrl.$error,validationErrorKey,controller),set(ctrl.$$success,validationErrorKey,controller)):(set(ctrl.$error,validationErrorKey,controller),unset(ctrl.$$success,validationErrorKey,controller)):(unset(ctrl.$error,validationErrorKey,controller),unset(ctrl.$$success,validationErrorKey,controller)),ctrl.$pending?(cachedToggleClass(PENDING_CLASS,!0),ctrl.$valid=ctrl.$invalid=undefined,toggleValidationCss("",null)):(cachedToggleClass(PENDING_CLASS,!1),ctrl.$valid=isObjectEmpty(ctrl.$error),ctrl.$invalid=!ctrl.$valid,toggleValidationCss("",ctrl.$valid));var combinedState;combinedState=ctrl.$pending&&ctrl.$pending[validationErrorKey]?undefined:ctrl.$error[validationErrorKey]?!1:ctrl.$$success[validationErrorKey]?!0:null,toggleValidationCss(validationErrorKey,combinedState),parentForm.$setValidity(validationErrorKey,combinedState,ctrl)}function createAndSet(name,value,controller){ctrl[name]||(ctrl[name]={}),set(ctrl[name],value,controller)}function unsetAndCleanup(name,value,controller){ctrl[name]&&unset(ctrl[name],value,controller),isObjectEmpty(ctrl[name])&&(ctrl[name]=undefined)}function cachedToggleClass(className,switchValue){switchValue&&!classCache[className]?($animate.addClass($element,className),classCache[className]=!0):!switchValue&&classCache[className]&&($animate.removeClass($element,className),classCache[className]=!1)}function toggleValidationCss(validationErrorKey,isValid){validationErrorKey=validationErrorKey?"-"+snake_case(validationErrorKey,"-"):"",cachedToggleClass(VALID_CLASS+validationErrorKey,isValid===!0),cachedToggleClass(INVALID_CLASS+validationErrorKey,isValid===!1)}var ctrl=context.ctrl,$element=context.$element,classCache={},set=context.set,unset=context.unset,parentForm=context.parentForm,$animate=context.$animate;classCache[INVALID_CLASS]=!(classCache[VALID_CLASS]=$element.hasClass(VALID_CLASS)),ctrl.$setValidity=setValidity}function isObjectEmpty(obj){if(obj)for(var prop in obj)return!1;return!0}var REGEX_STRING_REGEXP=/^\/(.+)\/([a-z]*)$/,VALIDITY_STATE_PROPERTY="validity",lowercase=function(string){return isString(string)?string.toLowerCase():string},hasOwnProperty=Object.prototype.hasOwnProperty,uppercase=function(string){return isString(string)?string.toUpperCase():string},manualLowercase=function(s){return isString(s)?s.replace(/[A-Z]/g,function(ch){return String.fromCharCode(32|ch.charCodeAt(0))}):s},manualUppercase=function(s){return isString(s)?s.replace(/[a-z]/g,function(ch){return String.fromCharCode(-33&ch.charCodeAt(0))}):s};"i"!=="I".toLowerCase()&&(lowercase=manualLowercase,uppercase=manualUppercase);var msie,jqLite,jQuery,angularModule,slice=[].slice,splice=[].splice,push=[].push,toString=Object.prototype.toString,ngMinErr=minErr("ng"),angular=window.angular||(window.angular={}),uid=0;msie=document.documentMode,noop.$inject=[],identity.$inject=[];var skipDestroyOnNextJQueryCleanData,isArray=Array.isArray,trim=function(value){return isString(value)?value.trim():value},escapeForRegexp=function(s){return s.replace(/([-()\[\]{}+?*.$\^|,:#<!\\])/g,"\\$1").replace(/\x08/g,"\\x08")},csp=function(){if(isDefined(csp.isActive_))return csp.isActive_;var active=!(!document.querySelector("[ng-csp]")&&!document.querySelector("[data-ng-csp]"));if(!active)try{new Function("")}catch(e){active=!0}return csp.isActive_=active},ngAttrPrefixes=["ng-","data-ng-","ng:","x-ng-"],SNAKE_CASE_REGEXP=/[A-Z]/g,bindJQueryFired=!1,NODE_TYPE_ELEMENT=1,NODE_TYPE_ATTRIBUTE=2,NODE_TYPE_TEXT=3,NODE_TYPE_COMMENT=8,NODE_TYPE_DOCUMENT=9,NODE_TYPE_DOCUMENT_FRAGMENT=11,version={full:"1.3.20",major:1,minor:3,dot:20,codeName:"shallow-translucence"};JQLite.expando="ng339";var jqCache=JQLite.cache={},jqId=1,addEventListenerFn=function(element,type,fn){element.addEventListener(type,fn,!1)},removeEventListenerFn=function(element,type,fn){element.removeEventListener(type,fn,!1)};JQLite._data=function(node){return this.cache[node[this.expando]]||{}};var SPECIAL_CHARS_REGEXP=/([\:\-\_]+(.))/g,MOZ_HACK_REGEXP=/^moz([A-Z])/,MOUSE_EVENT_MAP={mouseleave:"mouseout",mouseenter:"mouseover"},jqLiteMinErr=minErr("jqLite"),SINGLE_TAG_REGEXP=/^<(\w+)\s*\/?>(?:<\/\1>|)$/,HTML_REGEXP=/<|&#?\w+;/,TAG_NAME_REGEXP=/<([\w:]+)/,XHTML_TAG_REGEXP=/<(?!area|br|col|embed|hr|img|input|link|meta|param)(([\w:]+)[^>]*)\/>/gi,wrapMap={option:[1,'<select multiple="multiple">',"</select>"],thead:[1,"<table>","</table>"],col:[2,"<table><colgroup>","</colgroup></table>"],tr:[2,"<table><tbody>","</tbody></table>"],td:[3,"<table><tbody><tr>","</tr></tbody></table>"],_default:[0,"",""]};wrapMap.optgroup=wrapMap.option,wrapMap.tbody=wrapMap.tfoot=wrapMap.colgroup=wrapMap.caption=wrapMap.thead,wrapMap.th=wrapMap.td;var JQLitePrototype=JQLite.prototype={ready:function(fn){function trigger(){fired||(fired=!0,fn())}var fired=!1;"complete"===document.readyState?setTimeout(trigger):(this.on("DOMContentLoaded",trigger),JQLite(window).on("load",trigger))},toString:function(){var value=[];return forEach(this,function(e){value.push(""+e)}),"["+value.join(", ")+"]"},eq:function(index){return jqLite(index>=0?this[index]:this[this.length+index])},length:0,push:push,sort:[].sort,splice:[].splice},BOOLEAN_ATTR={};forEach("multiple,selected,checked,disabled,readOnly,required,open".split(","),function(value){BOOLEAN_ATTR[lowercase(value)]=value});var BOOLEAN_ELEMENTS={};forEach("input,select,option,textarea,button,form,details".split(","),function(value){BOOLEAN_ELEMENTS[value]=!0});var ALIASED_ATTR={ngMinlength:"minlength",ngMaxlength:"maxlength",ngMin:"min",ngMax:"max",ngPattern:"pattern"};forEach({data:jqLiteData,removeData:jqLiteRemoveData},function(fn,name){JQLite[name]=fn}),forEach({data:jqLiteData,inheritedData:jqLiteInheritedData,scope:function(element){return jqLite.data(element,"$scope")||jqLiteInheritedData(element.parentNode||element,["$isolateScope","$scope"])},isolateScope:function(element){return jqLite.data(element,"$isolateScope")||jqLite.data(element,"$isolateScopeNoTemplate")},controller:jqLiteController,injector:function(element){return jqLiteInheritedData(element,"$injector")},removeAttr:function(element,name){element.removeAttribute(name)},hasClass:jqLiteHasClass,css:function(element,name,value){return name=camelCase(name),isDefined(value)?void(element.style[name]=value):element.style[name]},attr:function(element,name,value){var nodeType=element.nodeType;if(nodeType!==NODE_TYPE_TEXT&&nodeType!==NODE_TYPE_ATTRIBUTE&&nodeType!==NODE_TYPE_COMMENT){var lowercasedName=lowercase(name);if(BOOLEAN_ATTR[lowercasedName]){if(!isDefined(value))return element[name]||(element.attributes.getNamedItem(name)||noop).specified?lowercasedName:undefined;value?(element[name]=!0,element.setAttribute(name,lowercasedName)):(element[name]=!1,element.removeAttribute(lowercasedName))}else if(isDefined(value))element.setAttribute(name,value);else if(element.getAttribute){var ret=element.getAttribute(name,2);return null===ret?undefined:ret}}},prop:function(element,name,value){return isDefined(value)?void(element[name]=value):element[name]},text:function(){function getText(element,value){if(isUndefined(value)){var nodeType=element.nodeType;return nodeType===NODE_TYPE_ELEMENT||nodeType===NODE_TYPE_TEXT?element.textContent:""}element.textContent=value}return getText.$dv="",getText}(),val:function(element,value){if(isUndefined(value)){if(element.multiple&&"select"===nodeName_(element)){var result=[];return forEach(element.options,function(option){option.selected&&result.push(option.value||option.text)}),0===result.length?null:result}return element.value}element.value=value},html:function(element,value){return isUndefined(value)?element.innerHTML:(jqLiteDealoc(element,!0),void(element.innerHTML=value))},empty:jqLiteEmpty},function(fn,name){JQLite.prototype[name]=function(arg1,arg2){var i,key,nodeCount=this.length;if(fn!==jqLiteEmpty&&(2==fn.length&&fn!==jqLiteHasClass&&fn!==jqLiteController?arg1:arg2)===undefined){if(isObject(arg1)){for(i=0;nodeCount>i;i++)if(fn===jqLiteData)fn(this[i],arg1);else for(key in arg1)fn(this[i],key,arg1[key]);return this}for(var value=fn.$dv,jj=value===undefined?Math.min(nodeCount,1):nodeCount,j=0;jj>j;j++){var nodeValue=fn(this[j],arg1,arg2);value=value?value+nodeValue:nodeValue}return value}for(i=0;nodeCount>i;i++)fn(this[i],arg1,arg2);return this}}),forEach({removeData:jqLiteRemoveData,on:function jqLiteOn(element,type,fn,unsupported){if(isDefined(unsupported))throw jqLiteMinErr("onargs","jqLite#on() does not support the `selector` or `eventData` parameters");if(jqLiteAcceptsData(element)){var expandoStore=jqLiteExpandoStore(element,!0),events=expandoStore.events,handle=expandoStore.handle;handle||(handle=expandoStore.handle=createEventHandler(element,events));for(var types=type.indexOf(" ")>=0?type.split(" "):[type],i=types.length;i--;){type=types[i];var eventFns=events[type];eventFns||(events[type]=[],"mouseenter"===type||"mouseleave"===type?jqLiteOn(element,MOUSE_EVENT_MAP[type],function(event){var target=this,related=event.relatedTarget;(!related||related!==target&&!target.contains(related))&&handle(event,type)}):"$destroy"!==type&&addEventListenerFn(element,type,handle),eventFns=events[type]),eventFns.push(fn)}}},off:jqLiteOff,one:function(element,type,fn){element=jqLite(element),element.on(type,function onFn(){element.off(type,fn),element.off(type,onFn)}),element.on(type,fn)},replaceWith:function(element,replaceNode){var index,parent=element.parentNode;jqLiteDealoc(element),forEach(new JQLite(replaceNode),function(node){index?parent.insertBefore(node,index.nextSibling):parent.replaceChild(node,element),index=node})},children:function(element){var children=[];return forEach(element.childNodes,function(element){element.nodeType===NODE_TYPE_ELEMENT&&children.push(element)}),children},contents:function(element){return element.contentDocument||element.childNodes||[]},append:function(element,node){var nodeType=element.nodeType;if(nodeType===NODE_TYPE_ELEMENT||nodeType===NODE_TYPE_DOCUMENT_FRAGMENT){node=new JQLite(node);for(var i=0,ii=node.length;ii>i;i++){var child=node[i];element.appendChild(child)}}},prepend:function(element,node){if(element.nodeType===NODE_TYPE_ELEMENT){var index=element.firstChild;forEach(new JQLite(node),function(child){element.insertBefore(child,index)})}},wrap:function(element,wrapNode){wrapNode=jqLite(wrapNode).eq(0).clone()[0];var parent=element.parentNode;parent&&parent.replaceChild(wrapNode,element),wrapNode.appendChild(element)},remove:jqLiteRemove,detach:function(element){jqLiteRemove(element,!0)},after:function(element,newElement){var index=element,parent=element.parentNode;newElement=new JQLite(newElement);for(var i=0,ii=newElement.length;ii>i;i++){var node=newElement[i];parent.insertBefore(node,index.nextSibling),index=node}},addClass:jqLiteAddClass,removeClass:jqLiteRemoveClass,toggleClass:function(element,selector,condition){selector&&forEach(selector.split(" "),function(className){var classCondition=condition;isUndefined(classCondition)&&(classCondition=!jqLiteHasClass(element,className)),(classCondition?jqLiteAddClass:jqLiteRemoveClass)(element,className)})},parent:function(element){var parent=element.parentNode;return parent&&parent.nodeType!==NODE_TYPE_DOCUMENT_FRAGMENT?parent:null},next:function(element){return element.nextElementSibling},find:function(element,selector){return element.getElementsByTagName?element.getElementsByTagName(selector):[]},clone:jqLiteClone,triggerHandler:function(element,event,extraParameters){var dummyEvent,eventFnsCopy,handlerArgs,eventName=event.type||event,expandoStore=jqLiteExpandoStore(element),events=expandoStore&&expandoStore.events,eventFns=events&&events[eventName];eventFns&&(dummyEvent={preventDefault:function(){this.defaultPrevented=!0},isDefaultPrevented:function(){return this.defaultPrevented===!0},stopImmediatePropagation:function(){this.immediatePropagationStopped=!0},isImmediatePropagationStopped:function(){return this.immediatePropagationStopped===!0},stopPropagation:noop,type:eventName,target:element},event.type&&(dummyEvent=extend(dummyEvent,event)),eventFnsCopy=shallowCopy(eventFns),handlerArgs=extraParameters?[dummyEvent].concat(extraParameters):[dummyEvent],forEach(eventFnsCopy,function(fn){dummyEvent.isImmediatePropagationStopped()||fn.apply(element,handlerArgs)}))}},function(fn,name){JQLite.prototype[name]=function(arg1,arg2,arg3){for(var value,i=0,ii=this.length;ii>i;i++)isUndefined(value)?(value=fn(this[i],arg1,arg2,arg3),isDefined(value)&&(value=jqLite(value))):jqLiteAddNodes(value,fn(this[i],arg1,arg2,arg3));return isDefined(value)?value:this},JQLite.prototype.bind=JQLite.prototype.on,JQLite.prototype.unbind=JQLite.prototype.off}),HashMap.prototype={put:function(key,value){this[hashKey(key,this.nextUid)]=value},get:function(key){return this[hashKey(key,this.nextUid)]},remove:function(key){var value=this[key=hashKey(key,this.nextUid)];return delete this[key],value}};var FN_ARGS=/^function\s*[^\(]*\(\s*([^\)]*)\)/m,FN_ARG_SPLIT=/,/,FN_ARG=/^\s*(_?)(\S+?)\1\s*$/,STRIP_COMMENTS=/((\/\/.*$)|(\/\*[\s\S]*?\*\/))/gm,$injectorMinErr=minErr("$injector");createInjector.$$annotate=annotate;var $animateMinErr=minErr("$animate"),$AnimateProvider=["$provide",function($provide){this.$$selectors={},this.register=function(name,factory){var key=name+"-animation";if(name&&"."!=name.charAt(0))throw $animateMinErr("notcsel","Expecting class selector starting with '.' got '{0}'.",name);this.$$selectors[name.substr(1)]=key,$provide.factory(key,factory)},this.classNameFilter=function(expression){return 1===arguments.length&&(this.$$classNameFilter=expression instanceof RegExp?expression:null),this.$$classNameFilter},this.$get=["$$q","$$asyncCallback","$rootScope",function($$q,$$asyncCallback,$rootScope){function runAnimationPostDigest(fn){var cancelFn,defer=$$q.defer();return defer.promise.$$cancelFn=function(){cancelFn&&cancelFn()},$rootScope.$$postDigest(function(){cancelFn=fn(function(){defer.resolve()})}),defer.promise}function resolveElementClasses(element,classes){var toAdd=[],toRemove=[],hasClasses=createMap();return forEach((element.attr("class")||"").split(/\s+/),function(className){hasClasses[className]=!0}),forEach(classes,function(status,className){var hasClass=hasClasses[className];status===!1&&hasClass?toRemove.push(className):status!==!0||hasClass||toAdd.push(className)}),toAdd.length+toRemove.length>0&&[toAdd.length?toAdd:null,toRemove.length?toRemove:null]}function cachedClassManipulation(cache,classes,op){for(var i=0,ii=classes.length;ii>i;++i){var className=classes[i];cache[className]=op}}function asyncPromise(){return currentDefer||(currentDefer=$$q.defer(),$$asyncCallback(function(){currentDefer.resolve(),currentDefer=null})),currentDefer.promise}function applyStyles(element,options){if(angular.isObject(options)){var styles=extend(options.from||{},options.to||{});element.css(styles)}}var currentDefer;return{animate:function(element,from,to){return applyStyles(element,{from:from,to:to}),asyncPromise()},enter:function(element,parent,after,options){return applyStyles(element,options),after?after.after(element):parent.prepend(element),asyncPromise()},leave:function(element,options){return applyStyles(element,options),element.remove(),asyncPromise()},move:function(element,parent,after,options){return this.enter(element,parent,after,options)},addClass:function(element,className,options){return this.setClass(element,className,[],options)},$$addClassImmediately:function(element,className,options){return element=jqLite(element),className=isString(className)?className:isArray(className)?className.join(" "):"",forEach(element,function(element){jqLiteAddClass(element,className)}),applyStyles(element,options),asyncPromise()},removeClass:function(element,className,options){return this.setClass(element,[],className,options)},$$removeClassImmediately:function(element,className,options){return element=jqLite(element),className=isString(className)?className:isArray(className)?className.join(" "):"",forEach(element,function(element){jqLiteRemoveClass(element,className)}),applyStyles(element,options),asyncPromise()},setClass:function(element,add,remove,options){var self=this,STORAGE_KEY="$$animateClasses",createdCache=!1;element=jqLite(element);var cache=element.data(STORAGE_KEY);cache?options&&cache.options&&(cache.options=angular.extend(cache.options||{},options)):(cache={classes:{},options:options},createdCache=!0);var classes=cache.classes;return add=isArray(add)?add:add.split(" "),remove=isArray(remove)?remove:remove.split(" "),cachedClassManipulation(classes,add,!0),cachedClassManipulation(classes,remove,!1),createdCache&&(cache.promise=runAnimationPostDigest(function(done){var cache=element.data(STORAGE_KEY);if(element.removeData(STORAGE_KEY),cache){var classes=resolveElementClasses(element,cache.classes);classes&&self.$$setClassImmediately(element,classes[0],classes[1],cache.options)}done()}),element.data(STORAGE_KEY,cache)),cache.promise},$$setClassImmediately:function(element,add,remove,options){return add&&this.$$addClassImmediately(element,add),remove&&this.$$removeClassImmediately(element,remove),applyStyles(element,options),asyncPromise()},enabled:noop,cancel:noop}}]}],$compileMinErr=minErr("$compile");$CompileProvider.$inject=["$provide","$$sanitizeUriProvider"];var PREFIX_REGEXP=/^((?:x|data)[\:\-_])/i,$controllerMinErr=minErr("$controller"),APPLICATION_JSON="application/json",CONTENT_TYPE_APPLICATION_JSON={"Content-Type":APPLICATION_JSON+";charset=utf-8"},JSON_START=/^\[|^\{(?!\{)/,JSON_ENDS={"[":/]$/,"{":/}$/},JSON_PROTECTION_PREFIX=/^\)\]\}',?\n/,$interpolateMinErr=minErr("$interpolate"),PATH_MATCH=/^([^\?#]*)(\?([^#]*))?(#(.*))?$/,DEFAULT_PORTS={http:80,https:443,ftp:21},$locationMinErr=minErr("$location"),locationPrototype={$$html5:!1,$$replace:!1,absUrl:locationGetter("$$absUrl"),url:function(url){if(isUndefined(url))return this.$$url;var match=PATH_MATCH.exec(url);return(match[1]||""===url)&&this.path(decodeURIComponent(match[1])),(match[2]||match[1]||""===url)&&this.search(match[3]||""),this.hash(match[5]||""),this},protocol:locationGetter("$$protocol"),host:locationGetter("$$host"),port:locationGetter("$$port"),path:locationGetterSetter("$$path",function(path){return path=null!==path?path.toString():"","/"==path.charAt(0)?path:"/"+path}),search:function(search,paramValue){switch(arguments.length){case 0:return this.$$search;case 1:if(isString(search)||isNumber(search))search=search.toString(),this.$$search=parseKeyValue(search);else{if(!isObject(search))throw $locationMinErr("isrcharg","The first argument of the `$location#search()` call must be a string or an object.");search=copy(search,{}),forEach(search,function(value,key){null==value&&delete search[key]}),this.$$search=search}break;default:isUndefined(paramValue)||null===paramValue?delete this.$$search[search]:this.$$search[search]=paramValue}return this.$$compose(),this},hash:locationGetterSetter("$$hash",function(hash){return null!==hash?hash.toString():""}),replace:function(){return this.$$replace=!0,this}};forEach([LocationHashbangInHtml5Url,LocationHashbangUrl,LocationHtml5Url],function(Location){Location.prototype=Object.create(locationPrototype),Location.prototype.state=function(state){if(!arguments.length)return this.$$state;if(Location!==LocationHtml5Url||!this.$$html5)throw $locationMinErr("nostate","History API state support is available only in HTML5 mode and only in browsers supporting HTML5 History API");return this.$$state=isUndefined(state)?null:state,this}});var $parseMinErr=minErr("$parse"),CALL=Function.prototype.call,APPLY=Function.prototype.apply,BIND=Function.prototype.bind,CONSTANTS=createMap();forEach({"null":function(){return null},"true":function(){return!0},"false":function(){return!1},undefined:function(){}},function(constantGetter,name){constantGetter.constant=constantGetter.literal=constantGetter.sharedGetter=!0,CONSTANTS[name]=constantGetter}),CONSTANTS["this"]=function(self){return self},CONSTANTS["this"].sharedGetter=!0;var OPERATORS=extend(createMap(),{"+":function(self,locals,a,b){return a=a(self,locals),b=b(self,locals),isDefined(a)?isDefined(b)?a+b:a:isDefined(b)?b:undefined},"-":function(self,locals,a,b){return a=a(self,locals),b=b(self,locals),(isDefined(a)?a:0)-(isDefined(b)?b:0)},"*":function(self,locals,a,b){return a(self,locals)*b(self,locals)},"/":function(self,locals,a,b){return a(self,locals)/b(self,locals)},"%":function(self,locals,a,b){return a(self,locals)%b(self,locals)},"===":function(self,locals,a,b){return a(self,locals)===b(self,locals)},"!==":function(self,locals,a,b){return a(self,locals)!==b(self,locals)},"==":function(self,locals,a,b){return a(self,locals)==b(self,locals)},"!=":function(self,locals,a,b){return a(self,locals)!=b(self,locals)},"<":function(self,locals,a,b){return a(self,locals)<b(self,locals)},">":function(self,locals,a,b){return a(self,locals)>b(self,locals)},"<=":function(self,locals,a,b){return a(self,locals)<=b(self,locals)},">=":function(self,locals,a,b){return a(self,locals)>=b(self,locals)},"&&":function(self,locals,a,b){return a(self,locals)&&b(self,locals)},"||":function(self,locals,a,b){return a(self,locals)||b(self,locals)},"!":function(self,locals,a){return!a(self,locals)},"=":!0,"|":!0}),ESCAPE={n:"\n",f:"\f",r:"\r",t:"	",v:"","'":"'",'"':'"'},Lexer=function(options){this.options=options};Lexer.prototype={constructor:Lexer,lex:function(text){for(this.text=text,this.index=0,this.tokens=[];this.index<this.text.length;){var ch=this.text.charAt(this.index);if('"'===ch||"'"===ch)this.readString(ch);else if(this.isNumber(ch)||"."===ch&&this.isNumber(this.peek()))this.readNumber();else if(this.isIdent(ch))this.readIdent();else if(this.is(ch,"(){}[].,;:?"))this.tokens.push({index:this.index,text:ch}),this.index++;else if(this.isWhitespace(ch))this.index++;else{var ch2=ch+this.peek(),ch3=ch2+this.peek(2),op1=OPERATORS[ch],op2=OPERATORS[ch2],op3=OPERATORS[ch3];if(op1||op2||op3){var token=op3?ch3:op2?ch2:ch;this.tokens.push({index:this.index,text:token,operator:!0}),this.index+=token.length}else this.throwError("Unexpected next character ",this.index,this.index+1)}}return this.tokens},is:function(ch,chars){return-1!==chars.indexOf(ch)},peek:function(i){var num=i||1;return this.index+num<this.text.length?this.text.charAt(this.index+num):!1},isNumber:function(ch){return ch>="0"&&"9">=ch&&"string"==typeof ch},isWhitespace:function(ch){return" "===ch||"\r"===ch||"	"===ch||"\n"===ch||""===ch||" "===ch},isIdent:function(ch){return ch>="a"&&"z">=ch||ch>="A"&&"Z">=ch||"_"===ch||"$"===ch},isExpOperator:function(ch){return"-"===ch||"+"===ch||this.isNumber(ch)},throwError:function(error,start,end){end=end||this.index;var colStr=isDefined(start)?"s "+start+"-"+this.index+" ["+this.text.substring(start,end)+"]":" "+end;throw $parseMinErr("lexerr","Lexer Error: {0} at column{1} in expression [{2}].",error,colStr,this.text)},readNumber:function(){for(var number="",start=this.index;this.index<this.text.length;){var ch=lowercase(this.text.charAt(this.index));if("."==ch||this.isNumber(ch))number+=ch;else{var peekCh=this.peek();if("e"==ch&&this.isExpOperator(peekCh))number+=ch;else if(this.isExpOperator(ch)&&peekCh&&this.isNumber(peekCh)&&"e"==number.charAt(number.length-1))number+=ch;else{if(!this.isExpOperator(ch)||peekCh&&this.isNumber(peekCh)||"e"!=number.charAt(number.length-1))break;this.throwError("Invalid exponent")}}this.index++}this.tokens.push({index:start,text:number,constant:!0,value:Number(number)})},readIdent:function(){for(var start=this.index;this.index<this.text.length;){var ch=this.text.charAt(this.index);if(!this.isIdent(ch)&&!this.isNumber(ch))break;this.index++}this.tokens.push({index:start,text:this.text.slice(start,this.index),identifier:!0})},readString:function(quote){var start=this.index;this.index++;for(var string="",rawString=quote,escape=!1;this.index<this.text.length;){var ch=this.text.charAt(this.index);if(rawString+=ch,escape){if("u"===ch){var hex=this.text.substring(this.index+1,this.index+5);hex.match(/[\da-f]{4}/i)||this.throwError("Invalid unicode escape [\\u"+hex+"]"),this.index+=4,string+=String.fromCharCode(parseInt(hex,16))}else{var rep=ESCAPE[ch];string+=rep||ch}escape=!1}else if("\\"===ch)escape=!0;else{if(ch===quote)return this.index++,void this.tokens.push({index:start,text:rawString,constant:!0,value:string});string+=ch}this.index++}this.throwError("Unterminated quote",start)}};var Parser=function(lexer,$filter,options){this.lexer=lexer,this.$filter=$filter,this.options=options};Parser.ZERO=extend(function(){return 0},{sharedGetter:!0,constant:!0}),Parser.prototype={constructor:Parser,parse:function(text){this.text=text,this.tokens=this.lexer.lex(text);var value=this.statements();return 0!==this.tokens.length&&this.throwError("is an unexpected token",this.tokens[0]),value.literal=!!value.literal,value.constant=!!value.constant,value},primary:function(){var primary;this.expect("(")?(primary=this.filterChain(),this.consume(")")):this.expect("[")?primary=this.arrayDeclaration():this.expect("{")?primary=this.object():this.peek().identifier&&this.peek().text in CONSTANTS?primary=CONSTANTS[this.consume().text]:this.peek().identifier?primary=this.identifier():this.peek().constant?primary=this.constant():this.throwError("not a primary expression",this.peek());for(var next,context;next=this.expect("(","[",".");)"("===next.text?(primary=this.functionCall(primary,context),context=null):"["===next.text?(context=primary,primary=this.objectIndex(primary)):"."===next.text?(context=primary,
primary=this.fieldAccess(primary)):this.throwError("IMPOSSIBLE");return primary},throwError:function(msg,token){throw $parseMinErr("syntax","Syntax Error: Token '{0}' {1} at column {2} of the expression [{3}] starting at [{4}].",token.text,msg,token.index+1,this.text,this.text.substring(token.index))},peekToken:function(){if(0===this.tokens.length)throw $parseMinErr("ueoe","Unexpected end of expression: {0}",this.text);return this.tokens[0]},peek:function(e1,e2,e3,e4){return this.peekAhead(0,e1,e2,e3,e4)},peekAhead:function(i,e1,e2,e3,e4){if(this.tokens.length>i){var token=this.tokens[i],t=token.text;if(t===e1||t===e2||t===e3||t===e4||!e1&&!e2&&!e3&&!e4)return token}return!1},expect:function(e1,e2,e3,e4){var token=this.peek(e1,e2,e3,e4);return token?(this.tokens.shift(),token):!1},consume:function(e1){if(0===this.tokens.length)throw $parseMinErr("ueoe","Unexpected end of expression: {0}",this.text);var token=this.expect(e1);return token||this.throwError("is unexpected, expecting ["+e1+"]",this.peek()),token},unaryFn:function(op,right){var fn=OPERATORS[op];return extend(function(self,locals){return fn(self,locals,right)},{constant:right.constant,inputs:[right]})},binaryFn:function(left,op,right,isBranching){var fn=OPERATORS[op];return extend(function(self,locals){return fn(self,locals,left,right)},{constant:left.constant&&right.constant,inputs:!isBranching&&[left,right]})},identifier:function(){for(var id=this.consume().text;this.peek(".")&&this.peekAhead(1).identifier&&!this.peekAhead(2,"(");)id+=this.consume().text+this.consume().text;return getterFn(id,this.options,this.text)},constant:function(){var value=this.consume().value;return extend(function(){return value},{constant:!0,literal:!0})},statements:function(){for(var statements=[];;)if(this.tokens.length>0&&!this.peek("}",")",";","]")&&statements.push(this.filterChain()),!this.expect(";"))return 1===statements.length?statements[0]:function(self,locals){for(var value,i=0,ii=statements.length;ii>i;i++)value=statements[i](self,locals);return value}},filterChain:function(){for(var token,left=this.expression();token=this.expect("|");)left=this.filter(left);return left},filter:function(inputFn){var argsFn,args,fn=this.$filter(this.consume().text);if(this.peek(":"))for(argsFn=[],args=[];this.expect(":");)argsFn.push(this.expression());var inputs=[inputFn].concat(argsFn||[]);return extend(function(self,locals){var input=inputFn(self,locals);if(args){args[0]=input;for(var i=argsFn.length;i--;)args[i+1]=argsFn[i](self,locals);return fn.apply(undefined,args)}return fn(input)},{constant:!fn.$stateful&&inputs.every(isConstant),inputs:!fn.$stateful&&inputs})},expression:function(){return this.assignment()},assignment:function(){var right,token,left=this.ternary();return(token=this.expect("="))?(left.assign||this.throwError("implies assignment but ["+this.text.substring(0,token.index)+"] can not be assigned to",token),right=this.ternary(),extend(function(scope,locals){return left.assign(scope,right(scope,locals),locals)},{inputs:[left,right]})):left},ternary:function(){var middle,token,left=this.logicalOR();if((token=this.expect("?"))&&(middle=this.assignment(),this.consume(":"))){var right=this.assignment();return extend(function(self,locals){return left(self,locals)?middle(self,locals):right(self,locals)},{constant:left.constant&&middle.constant&&right.constant})}return left},logicalOR:function(){for(var token,left=this.logicalAND();token=this.expect("||");)left=this.binaryFn(left,token.text,this.logicalAND(),!0);return left},logicalAND:function(){for(var token,left=this.equality();token=this.expect("&&");)left=this.binaryFn(left,token.text,this.equality(),!0);return left},equality:function(){for(var token,left=this.relational();token=this.expect("==","!=","===","!==");)left=this.binaryFn(left,token.text,this.relational());return left},relational:function(){for(var token,left=this.additive();token=this.expect("<",">","<=",">=");)left=this.binaryFn(left,token.text,this.additive());return left},additive:function(){for(var token,left=this.multiplicative();token=this.expect("+","-");)left=this.binaryFn(left,token.text,this.multiplicative());return left},multiplicative:function(){for(var token,left=this.unary();token=this.expect("*","/","%");)left=this.binaryFn(left,token.text,this.unary());return left},unary:function(){var token;return this.expect("+")?this.primary():(token=this.expect("-"))?this.binaryFn(Parser.ZERO,token.text,this.unary()):(token=this.expect("!"))?this.unaryFn(token.text,this.unary()):this.primary()},fieldAccess:function(object){var getter=this.identifier();return extend(function(scope,locals,self){var o=self||object(scope,locals);return null==o?undefined:getter(o)},{assign:function(scope,value,locals){var o=object(scope,locals);return o||object.assign(scope,o={},locals),getter.assign(o,value)}})},objectIndex:function(obj){var expression=this.text,indexFn=this.expression();return this.consume("]"),extend(function(self,locals){var v,o=obj(self,locals),i=getStringValue(indexFn(self,locals),expression);return ensureSafeMemberName(i,expression),o?v=ensureSafeObject(o[i],expression):undefined},{assign:function(self,value,locals){var key=ensureSafeMemberName(getStringValue(indexFn(self,locals),expression),expression),o=ensureSafeObject(obj(self,locals),expression);return o||obj.assign(self,o={},locals),o[key]=value}})},functionCall:function(fnGetter,contextGetter){var argsFn=[];if(")"!==this.peekToken().text)do argsFn.push(this.expression());while(this.expect(","));this.consume(")");var expressionText=this.text,args=argsFn.length?[]:null;return function(scope,locals){var context=contextGetter?contextGetter(scope,locals):isDefined(contextGetter)?undefined:scope,fn=fnGetter(scope,locals,context)||noop;if(args)for(var i=argsFn.length;i--;)args[i]=ensureSafeObject(argsFn[i](scope,locals),expressionText);ensureSafeObject(context,expressionText),ensureSafeFunction(fn,expressionText);var v=fn.apply?fn.apply(context,args):fn(args[0],args[1],args[2],args[3],args[4]);return args&&(args.length=0),ensureSafeObject(v,expressionText)}},arrayDeclaration:function(){var elementFns=[];if("]"!==this.peekToken().text)do{if(this.peek("]"))break;elementFns.push(this.expression())}while(this.expect(","));return this.consume("]"),extend(function(self,locals){for(var array=[],i=0,ii=elementFns.length;ii>i;i++)array.push(elementFns[i](self,locals));return array},{literal:!0,constant:elementFns.every(isConstant),inputs:elementFns})},object:function(){var keys=[],valueFns=[];if("}"!==this.peekToken().text)do{if(this.peek("}"))break;var token=this.consume();token.constant?keys.push(token.value):token.identifier?keys.push(token.text):this.throwError("invalid key",token),this.consume(":"),valueFns.push(this.expression())}while(this.expect(","));return this.consume("}"),extend(function(self,locals){for(var object={},i=0,ii=valueFns.length;ii>i;i++)object[keys[i]]=valueFns[i](self,locals);return object},{literal:!0,constant:valueFns.every(isConstant),inputs:valueFns})}};var getterFnCacheDefault=createMap(),getterFnCacheExpensive=createMap(),objectValueOf=Object.prototype.valueOf,$sceMinErr=minErr("$sce"),SCE_CONTEXTS={HTML:"html",CSS:"css",URL:"url",RESOURCE_URL:"resourceUrl",JS:"js"},$compileMinErr=minErr("$compile"),urlParsingNode=document.createElement("a"),originUrl=urlResolve(window.location.href);$FilterProvider.$inject=["$provide"],currencyFilter.$inject=["$locale"],numberFilter.$inject=["$locale"];var DECIMAL_SEP=".",DATE_FORMATS={yyyy:dateGetter("FullYear",4),yy:dateGetter("FullYear",2,0,!0),y:dateGetter("FullYear",1),MMMM:dateStrGetter("Month"),MMM:dateStrGetter("Month",!0),MM:dateGetter("Month",2,1),M:dateGetter("Month",1,1),dd:dateGetter("Date",2),d:dateGetter("Date",1),HH:dateGetter("Hours",2),H:dateGetter("Hours",1),hh:dateGetter("Hours",2,-12),h:dateGetter("Hours",1,-12),mm:dateGetter("Minutes",2),m:dateGetter("Minutes",1),ss:dateGetter("Seconds",2),s:dateGetter("Seconds",1),sss:dateGetter("Milliseconds",3),EEEE:dateStrGetter("Day"),EEE:dateStrGetter("Day",!0),a:ampmGetter,Z:timeZoneGetter,ww:weekGetter(2),w:weekGetter(1),G:eraGetter,GG:eraGetter,GGG:eraGetter,GGGG:longEraGetter},DATE_FORMATS_SPLIT=/((?:[^yMdHhmsaZEwG']+)|(?:'(?:[^']|'')*')|(?:E+|y+|M+|d+|H+|h+|m+|s+|a|Z|G+|w+))(.*)/,NUMBER_STRING=/^\-?\d+$/;dateFilter.$inject=["$locale"];var lowercaseFilter=valueFn(lowercase),uppercaseFilter=valueFn(uppercase);orderByFilter.$inject=["$parse"];var htmlAnchorDirective=valueFn({restrict:"E",compile:function(element,attr){return attr.href||attr.xlinkHref||attr.name?void 0:function(scope,element){if("a"===element[0].nodeName.toLowerCase()){var href="[object SVGAnimatedString]"===toString.call(element.prop("href"))?"xlink:href":"href";element.on("click",function(event){element.attr(href)||event.preventDefault()})}}}}),ngAttributeAliasDirectives={};forEach(BOOLEAN_ATTR,function(propName,attrName){if("multiple"!=propName){var normalized=directiveNormalize("ng-"+attrName);ngAttributeAliasDirectives[normalized]=function(){return{restrict:"A",priority:100,link:function(scope,element,attr){scope.$watch(attr[normalized],function(value){attr.$set(attrName,!!value)})}}}}}),forEach(ALIASED_ATTR,function(htmlAttr,ngAttr){ngAttributeAliasDirectives[ngAttr]=function(){return{priority:100,link:function(scope,element,attr){if("ngPattern"===ngAttr&&"/"==attr.ngPattern.charAt(0)){var match=attr.ngPattern.match(REGEX_STRING_REGEXP);if(match)return void attr.$set("ngPattern",new RegExp(match[1],match[2]))}scope.$watch(attr[ngAttr],function(value){attr.$set(ngAttr,value)})}}}}),forEach(["src","srcset","href"],function(attrName){var normalized=directiveNormalize("ng-"+attrName);ngAttributeAliasDirectives[normalized]=function(){return{priority:99,link:function(scope,element,attr){var propName=attrName,name=attrName;"href"===attrName&&"[object SVGAnimatedString]"===toString.call(element.prop("href"))&&(name="xlinkHref",attr.$attr[name]="xlink:href",propName=null),attr.$observe(normalized,function(value){return value?(attr.$set(name,value),void(msie&&propName&&element.prop(propName,attr[name]))):void("href"===attrName&&attr.$set(name,null))})}}}});var nullFormCtrl={$addControl:noop,$$renameControl:nullFormRenameControl,$removeControl:noop,$setValidity:noop,$setDirty:noop,$setPristine:noop,$setSubmitted:noop},SUBMITTED_CLASS="ng-submitted";FormController.$inject=["$element","$attrs","$scope","$animate","$interpolate"];var formDirectiveFactory=function(isNgForm){return["$timeout",function($timeout){var formDirective={name:"form",restrict:isNgForm?"EAC":"E",controller:FormController,compile:function(formElement,attr){formElement.addClass(PRISTINE_CLASS).addClass(VALID_CLASS);var nameAttr=attr.name?"name":isNgForm&&attr.ngForm?"ngForm":!1;return{pre:function(scope,formElement,attr,controller){if(!("action"in attr)){var handleFormSubmission=function(event){scope.$apply(function(){controller.$commitViewValue(),controller.$setSubmitted()}),event.preventDefault()};addEventListenerFn(formElement[0],"submit",handleFormSubmission),formElement.on("$destroy",function(){$timeout(function(){removeEventListenerFn(formElement[0],"submit",handleFormSubmission)},0,!1)})}var parentFormCtrl=controller.$$parentForm;nameAttr&&(setter(scope,null,controller.$name,controller,controller.$name),attr.$observe(nameAttr,function(newValue){controller.$name!==newValue&&(setter(scope,null,controller.$name,undefined,controller.$name),parentFormCtrl.$$renameControl(controller,newValue),setter(scope,null,controller.$name,controller,controller.$name))})),formElement.on("$destroy",function(){parentFormCtrl.$removeControl(controller),nameAttr&&setter(scope,null,attr[nameAttr],undefined,controller.$name),extend(controller,nullFormCtrl)})}}}};return formDirective}]},formDirective=formDirectiveFactory(),ngFormDirective=formDirectiveFactory(!0),ISO_DATE_REGEXP=/\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d:[0-5]\d\.\d+([+-][0-2]\d:[0-5]\d|Z)/,URL_REGEXP=/^(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?$/,EMAIL_REGEXP=/^[a-z0-9!#$%&'*+\/=?^_`{|}~.-]+@[a-z0-9]([a-z0-9-]*[a-z0-9])?(\.[a-z0-9]([a-z0-9-]*[a-z0-9])?)*$/i,NUMBER_REGEXP=/^\s*(\-|\+)?(\d+|(\d*(\.\d*)))\s*$/,DATE_REGEXP=/^(\d{4})-(\d{2})-(\d{2})$/,DATETIMELOCAL_REGEXP=/^(\d{4})-(\d\d)-(\d\d)T(\d\d):(\d\d)(?::(\d\d)(\.\d{1,3})?)?$/,WEEK_REGEXP=/^(\d{4})-W(\d\d)$/,MONTH_REGEXP=/^(\d{4})-(\d\d)$/,TIME_REGEXP=/^(\d\d):(\d\d)(?::(\d\d)(\.\d{1,3})?)?$/,inputType={text:textInputType,date:createDateInputType("date",DATE_REGEXP,createDateParser(DATE_REGEXP,["yyyy","MM","dd"]),"yyyy-MM-dd"),"datetime-local":createDateInputType("datetimelocal",DATETIMELOCAL_REGEXP,createDateParser(DATETIMELOCAL_REGEXP,["yyyy","MM","dd","HH","mm","ss","sss"]),"yyyy-MM-ddTHH:mm:ss.sss"),time:createDateInputType("time",TIME_REGEXP,createDateParser(TIME_REGEXP,["HH","mm","ss","sss"]),"HH:mm:ss.sss"),week:createDateInputType("week",WEEK_REGEXP,weekParser,"yyyy-Www"),month:createDateInputType("month",MONTH_REGEXP,createDateParser(MONTH_REGEXP,["yyyy","MM"]),"yyyy-MM"),number:numberInputType,url:urlInputType,email:emailInputType,radio:radioInputType,checkbox:checkboxInputType,hidden:noop,button:noop,submit:noop,reset:noop,file:noop},inputDirective=["$browser","$sniffer","$filter","$parse",function($browser,$sniffer,$filter,$parse){return{restrict:"E",require:["?ngModel"],link:{pre:function(scope,element,attr,ctrls){ctrls[0]&&(inputType[lowercase(attr.type)]||inputType.text)(scope,element,attr,ctrls[0],$sniffer,$browser,$filter,$parse)}}}}],CONSTANT_VALUE_REGEXP=/^(true|false|\d+)$/,ngValueDirective=function(){return{restrict:"A",priority:100,compile:function(tpl,tplAttr){return CONSTANT_VALUE_REGEXP.test(tplAttr.ngValue)?function(scope,elm,attr){attr.$set("value",scope.$eval(attr.ngValue))}:function(scope,elm,attr){scope.$watch(attr.ngValue,function(value){attr.$set("value",value)})}}}},ngBindDirective=["$compile",function($compile){return{restrict:"AC",compile:function(templateElement){return $compile.$$addBindingClass(templateElement),function(scope,element,attr){$compile.$$addBindingInfo(element,attr.ngBind),element=element[0],scope.$watch(attr.ngBind,function(value){element.textContent=value===undefined?"":value})}}}}],ngBindTemplateDirective=["$interpolate","$compile",function($interpolate,$compile){return{compile:function(templateElement){return $compile.$$addBindingClass(templateElement),function(scope,element,attr){var interpolateFn=$interpolate(element.attr(attr.$attr.ngBindTemplate));$compile.$$addBindingInfo(element,interpolateFn.expressions),element=element[0],attr.$observe("ngBindTemplate",function(value){element.textContent=value===undefined?"":value})}}}}],ngBindHtmlDirective=["$sce","$parse","$compile",function($sce,$parse,$compile){return{restrict:"A",compile:function(tElement,tAttrs){var ngBindHtmlGetter=$parse(tAttrs.ngBindHtml),ngBindHtmlWatch=$parse(tAttrs.ngBindHtml,function(value){return(value||"").toString()});return $compile.$$addBindingClass(tElement),function(scope,element,attr){$compile.$$addBindingInfo(element,attr.ngBindHtml),scope.$watch(ngBindHtmlWatch,function(){element.html($sce.getTrustedHtml(ngBindHtmlGetter(scope))||"")})}}}}],ngChangeDirective=valueFn({restrict:"A",require:"ngModel",link:function(scope,element,attr,ctrl){ctrl.$viewChangeListeners.push(function(){scope.$eval(attr.ngChange)})}}),ngClassDirective=classDirective("",!0),ngClassOddDirective=classDirective("Odd",0),ngClassEvenDirective=classDirective("Even",1),ngCloakDirective=ngDirective({compile:function(element,attr){attr.$set("ngCloak",undefined),element.removeClass("ng-cloak")}}),ngControllerDirective=[function(){return{restrict:"A",scope:!0,controller:"@",priority:500}}],ngEventDirectives={},forceAsyncEvents={blur:!0,focus:!0};forEach("click dblclick mousedown mouseup mouseover mouseout mousemove mouseenter mouseleave keydown keyup keypress submit focus blur copy cut paste".split(" "),function(eventName){var directiveName=directiveNormalize("ng-"+eventName);ngEventDirectives[directiveName]=["$parse","$rootScope",function($parse,$rootScope){return{restrict:"A",compile:function($element,attr){var fn=$parse(attr[directiveName],null,!0);return function(scope,element){element.on(eventName,function(event){var callback=function(){fn(scope,{$event:event})};forceAsyncEvents[eventName]&&$rootScope.$$phase?scope.$evalAsync(callback):scope.$apply(callback)})}}}}]});var ngIfDirective=["$animate",function($animate){return{multiElement:!0,transclude:"element",priority:600,terminal:!0,restrict:"A",$$tlb:!0,link:function($scope,$element,$attr,ctrl,$transclude){var block,childScope,previousElements;$scope.$watch($attr.ngIf,function(value){value?childScope||$transclude(function(clone,newScope){childScope=newScope,clone[clone.length++]=document.createComment(" end ngIf: "+$attr.ngIf+" "),block={clone:clone},$animate.enter(clone,$element.parent(),$element)}):(previousElements&&(previousElements.remove(),previousElements=null),childScope&&(childScope.$destroy(),childScope=null),block&&(previousElements=getBlockNodes(block.clone),$animate.leave(previousElements).then(function(){previousElements=null}),block=null))})}}}],ngIncludeDirective=["$templateRequest","$anchorScroll","$animate",function($templateRequest,$anchorScroll,$animate){return{restrict:"ECA",priority:400,terminal:!0,transclude:"element",controller:angular.noop,compile:function(element,attr){var srcExp=attr.ngInclude||attr.src,onloadExp=attr.onload||"",autoScrollExp=attr.autoscroll;return function(scope,$element,$attr,ctrl,$transclude){var currentScope,previousElement,currentElement,changeCounter=0,cleanupLastIncludeContent=function(){previousElement&&(previousElement.remove(),previousElement=null),currentScope&&(currentScope.$destroy(),currentScope=null),currentElement&&($animate.leave(currentElement).then(function(){previousElement=null}),previousElement=currentElement,currentElement=null)};scope.$watch(srcExp,function(src){var afterAnimation=function(){!isDefined(autoScrollExp)||autoScrollExp&&!scope.$eval(autoScrollExp)||$anchorScroll()},thisChangeId=++changeCounter;src?($templateRequest(src,!0).then(function(response){if(thisChangeId===changeCounter){var newScope=scope.$new();ctrl.template=response;var clone=$transclude(newScope,function(clone){cleanupLastIncludeContent(),$animate.enter(clone,null,$element).then(afterAnimation)});currentScope=newScope,currentElement=clone,currentScope.$emit("$includeContentLoaded",src),scope.$eval(onloadExp)}},function(){thisChangeId===changeCounter&&(cleanupLastIncludeContent(),scope.$emit("$includeContentError",src))}),scope.$emit("$includeContentRequested",src)):(cleanupLastIncludeContent(),ctrl.template=null)})}}}}],ngIncludeFillContentDirective=["$compile",function($compile){return{restrict:"ECA",priority:-400,require:"ngInclude",link:function(scope,$element,$attr,ctrl){return/SVG/.test($element[0].toString())?($element.empty(),void $compile(jqLiteBuildFragment(ctrl.template,document).childNodes)(scope,function(clone){$element.append(clone)},{futureParentElement:$element})):($element.html(ctrl.template),void $compile($element.contents())(scope))}}}],ngInitDirective=ngDirective({priority:450,compile:function(){return{pre:function(scope,element,attrs){scope.$eval(attrs.ngInit)}}}}),ngListDirective=function(){return{restrict:"A",priority:100,require:"ngModel",link:function(scope,element,attr,ctrl){var ngList=element.attr(attr.$attr.ngList)||", ",trimValues="false"!==attr.ngTrim,separator=trimValues?trim(ngList):ngList,parse=function(viewValue){if(!isUndefined(viewValue)){var list=[];return viewValue&&forEach(viewValue.split(separator),function(value){value&&list.push(trimValues?trim(value):value)}),list}};ctrl.$parsers.push(parse),ctrl.$formatters.push(function(value){return isArray(value)?value.join(ngList):undefined}),ctrl.$isEmpty=function(value){return!value||!value.length}}}},VALID_CLASS="ng-valid",INVALID_CLASS="ng-invalid",PRISTINE_CLASS="ng-pristine",DIRTY_CLASS="ng-dirty",UNTOUCHED_CLASS="ng-untouched",TOUCHED_CLASS="ng-touched",PENDING_CLASS="ng-pending",ngModelMinErr=minErr("ngModel"),NgModelController=["$scope","$exceptionHandler","$attrs","$element","$parse","$animate","$timeout","$rootScope","$q","$interpolate",function($scope,$exceptionHandler,$attr,$element,$parse,$animate,$timeout,$rootScope,$q,$interpolate){this.$viewValue=Number.NaN,this.$modelValue=Number.NaN,this.$$rawModelValue=undefined,this.$validators={},this.$asyncValidators={},this.$parsers=[],this.$formatters=[],this.$viewChangeListeners=[],this.$untouched=!0,this.$touched=!1,this.$pristine=!0,this.$dirty=!1,this.$valid=!0,this.$invalid=!1,this.$error={},this.$$success={},this.$pending=undefined,this.$name=$interpolate($attr.name||"",!1)($scope);var parserValid,parsedNgModel=$parse($attr.ngModel),parsedNgModelAssign=parsedNgModel.assign,ngModelGet=parsedNgModel,ngModelSet=parsedNgModelAssign,pendingDebounce=null,ctrl=this;this.$$setOptions=function(options){if(ctrl.$options=options,options&&options.getterSetter){var invokeModelGetter=$parse($attr.ngModel+"()"),invokeModelSetter=$parse($attr.ngModel+"($$$p)");ngModelGet=function($scope){var modelValue=parsedNgModel($scope);return isFunction(modelValue)&&(modelValue=invokeModelGetter($scope)),modelValue},ngModelSet=function($scope,newValue){isFunction(parsedNgModel($scope))?invokeModelSetter($scope,{$$$p:ctrl.$modelValue}):parsedNgModelAssign($scope,ctrl.$modelValue)}}else if(!parsedNgModel.assign)throw ngModelMinErr("nonassign","Expression '{0}' is non-assignable. Element: {1}",$attr.ngModel,startingTag($element))},this.$render=noop,this.$isEmpty=function(value){return isUndefined(value)||""===value||null===value||value!==value};var parentForm=$element.inheritedData("$formController")||nullFormCtrl,currentValidationRunId=0;addSetValidityMethod({ctrl:this,$element:$element,set:function(object,property){object[property]=!0},unset:function(object,property){delete object[property]},parentForm:parentForm,$animate:$animate}),this.$setPristine=function(){ctrl.$dirty=!1,ctrl.$pristine=!0,$animate.removeClass($element,DIRTY_CLASS),$animate.addClass($element,PRISTINE_CLASS)},this.$setDirty=function(){ctrl.$dirty=!0,ctrl.$pristine=!1,$animate.removeClass($element,PRISTINE_CLASS),$animate.addClass($element,DIRTY_CLASS),parentForm.$setDirty()},this.$setUntouched=function(){ctrl.$touched=!1,ctrl.$untouched=!0,$animate.setClass($element,UNTOUCHED_CLASS,TOUCHED_CLASS)},this.$setTouched=function(){ctrl.$touched=!0,ctrl.$untouched=!1,$animate.setClass($element,TOUCHED_CLASS,UNTOUCHED_CLASS)},this.$rollbackViewValue=function(){$timeout.cancel(pendingDebounce),ctrl.$viewValue=ctrl.$$lastCommittedViewValue,ctrl.$render()},this.$validate=function(){if(!isNumber(ctrl.$modelValue)||!isNaN(ctrl.$modelValue)){var viewValue=ctrl.$$lastCommittedViewValue,modelValue=ctrl.$$rawModelValue,prevValid=ctrl.$valid,prevModelValue=ctrl.$modelValue,allowInvalid=ctrl.$options&&ctrl.$options.allowInvalid;ctrl.$$runValidators(modelValue,viewValue,function(allValid){allowInvalid||prevValid===allValid||(ctrl.$modelValue=allValid?modelValue:undefined,ctrl.$modelValue!==prevModelValue&&ctrl.$$writeModelToScope())})}},this.$$runValidators=function(modelValue,viewValue,doneCallback){function processParseErrors(){var errorKey=ctrl.$$parserName||"parse";return parserValid!==undefined?(parserValid||(forEach(ctrl.$validators,function(v,name){setValidity(name,null)}),forEach(ctrl.$asyncValidators,function(v,name){setValidity(name,null)})),setValidity(errorKey,parserValid),parserValid):(setValidity(errorKey,null),!0)}function processSyncValidators(){var syncValidatorsValid=!0;return forEach(ctrl.$validators,function(validator,name){var result=validator(modelValue,viewValue);syncValidatorsValid=syncValidatorsValid&&result,setValidity(name,result)}),syncValidatorsValid?!0:(forEach(ctrl.$asyncValidators,function(v,name){setValidity(name,null)}),!1)}function processAsyncValidators(){var validatorPromises=[],allValid=!0;forEach(ctrl.$asyncValidators,function(validator,name){var promise=validator(modelValue,viewValue);if(!isPromiseLike(promise))throw ngModelMinErr("$asyncValidators","Expected asynchronous validator to return a promise but got '{0}' instead.",promise);setValidity(name,undefined),validatorPromises.push(promise.then(function(){setValidity(name,!0)},function(error){allValid=!1,setValidity(name,!1)}))}),validatorPromises.length?$q.all(validatorPromises).then(function(){validationDone(allValid)},noop):validationDone(!0)}function setValidity(name,isValid){localValidationRunId===currentValidationRunId&&ctrl.$setValidity(name,isValid)}function validationDone(allValid){localValidationRunId===currentValidationRunId&&doneCallback(allValid)}currentValidationRunId++;var localValidationRunId=currentValidationRunId;return processParseErrors()&&processSyncValidators()?void processAsyncValidators():void validationDone(!1)},this.$commitViewValue=function(){var viewValue=ctrl.$viewValue;$timeout.cancel(pendingDebounce),(ctrl.$$lastCommittedViewValue!==viewValue||""===viewValue&&ctrl.$$hasNativeValidators)&&(ctrl.$$lastCommittedViewValue=viewValue,ctrl.$pristine&&this.$setDirty(),this.$$parseAndValidate())},this.$$parseAndValidate=function(){function writeToModelIfNeeded(){ctrl.$modelValue!==prevModelValue&&ctrl.$$writeModelToScope()}var viewValue=ctrl.$$lastCommittedViewValue,modelValue=viewValue;if(parserValid=isUndefined(modelValue)?undefined:!0)for(var i=0;i<ctrl.$parsers.length;i++)if(modelValue=ctrl.$parsers[i](modelValue),isUndefined(modelValue)){parserValid=!1;break}isNumber(ctrl.$modelValue)&&isNaN(ctrl.$modelValue)&&(ctrl.$modelValue=ngModelGet($scope));var prevModelValue=ctrl.$modelValue,allowInvalid=ctrl.$options&&ctrl.$options.allowInvalid;ctrl.$$rawModelValue=modelValue,allowInvalid&&(ctrl.$modelValue=modelValue,writeToModelIfNeeded()),ctrl.$$runValidators(modelValue,ctrl.$$lastCommittedViewValue,function(allValid){allowInvalid||(ctrl.$modelValue=allValid?modelValue:undefined,writeToModelIfNeeded())})},this.$$writeModelToScope=function(){ngModelSet($scope,ctrl.$modelValue),forEach(ctrl.$viewChangeListeners,function(listener){try{listener()}catch(e){$exceptionHandler(e)}})},this.$setViewValue=function(value,trigger){ctrl.$viewValue=value,(!ctrl.$options||ctrl.$options.updateOnDefault)&&ctrl.$$debounceViewValueCommit(trigger)},this.$$debounceViewValueCommit=function(trigger){var debounce,debounceDelay=0,options=ctrl.$options;options&&isDefined(options.debounce)&&(debounce=options.debounce,isNumber(debounce)?debounceDelay=debounce:isNumber(debounce[trigger])?debounceDelay=debounce[trigger]:isNumber(debounce["default"])&&(debounceDelay=debounce["default"])),$timeout.cancel(pendingDebounce),debounceDelay?pendingDebounce=$timeout(function(){ctrl.$commitViewValue()},debounceDelay):$rootScope.$$phase?ctrl.$commitViewValue():$scope.$apply(function(){ctrl.$commitViewValue()})},$scope.$watch(function(){var modelValue=ngModelGet($scope);if(modelValue!==ctrl.$modelValue&&(ctrl.$modelValue===ctrl.$modelValue||modelValue===modelValue)){ctrl.$modelValue=ctrl.$$rawModelValue=modelValue,parserValid=undefined;for(var formatters=ctrl.$formatters,idx=formatters.length,viewValue=modelValue;idx--;)viewValue=formatters[idx](viewValue);ctrl.$viewValue!==viewValue&&(ctrl.$viewValue=ctrl.$$lastCommittedViewValue=viewValue,ctrl.$render(),ctrl.$$runValidators(modelValue,viewValue,noop))}return modelValue})}],ngModelDirective=["$rootScope",function($rootScope){return{restrict:"A",require:["ngModel","^?form","^?ngModelOptions"],controller:NgModelController,priority:1,compile:function(element){return element.addClass(PRISTINE_CLASS).addClass(UNTOUCHED_CLASS).addClass(VALID_CLASS),{pre:function(scope,element,attr,ctrls){var modelCtrl=ctrls[0],formCtrl=ctrls[1]||nullFormCtrl;modelCtrl.$$setOptions(ctrls[2]&&ctrls[2].$options),formCtrl.$addControl(modelCtrl),attr.$observe("name",function(newValue){modelCtrl.$name!==newValue&&formCtrl.$$renameControl(modelCtrl,newValue)}),scope.$on("$destroy",function(){formCtrl.$removeControl(modelCtrl)})},post:function(scope,element,attr,ctrls){var modelCtrl=ctrls[0];modelCtrl.$options&&modelCtrl.$options.updateOn&&element.on(modelCtrl.$options.updateOn,function(ev){modelCtrl.$$debounceViewValueCommit(ev&&ev.type)}),element.on("blur",function(ev){modelCtrl.$touched||($rootScope.$$phase?scope.$evalAsync(modelCtrl.$setTouched):scope.$apply(modelCtrl.$setTouched))})}}}}}],DEFAULT_REGEXP=/(\s+|^)default(\s+|$)/,ngModelOptionsDirective=function(){return{restrict:"A",controller:["$scope","$attrs",function($scope,$attrs){var that=this;this.$options=$scope.$eval($attrs.ngModelOptions),this.$options.updateOn!==undefined?(this.$options.updateOnDefault=!1,this.$options.updateOn=trim(this.$options.updateOn.replace(DEFAULT_REGEXP,function(){return that.$options.updateOnDefault=!0," "}))):this.$options.updateOnDefault=!0}]}},ngNonBindableDirective=ngDirective({terminal:!0,priority:1e3}),ngPluralizeDirective=["$locale","$interpolate",function($locale,$interpolate){var BRACE=/{}/g,IS_WHEN=/^when(Minus)?(.+)$/;return{restrict:"EA",link:function(scope,element,attr){function updateElementText(newText){element.text(newText||"")}var lastCount,numberExp=attr.count,whenExp=attr.$attr.when&&element.attr(attr.$attr.when),offset=attr.offset||0,whens=scope.$eval(whenExp)||{},whensExpFns={},startSymbol=$interpolate.startSymbol(),endSymbol=$interpolate.endSymbol(),braceReplacement=startSymbol+numberExp+"-"+offset+endSymbol,watchRemover=angular.noop;forEach(attr,function(expression,attributeName){var tmpMatch=IS_WHEN.exec(attributeName);if(tmpMatch){var whenKey=(tmpMatch[1]?"-":"")+lowercase(tmpMatch[2]);whens[whenKey]=element.attr(attr.$attr[attributeName])}}),forEach(whens,function(expression,key){whensExpFns[key]=$interpolate(expression.replace(BRACE,braceReplacement))}),scope.$watch(numberExp,function(newVal){var count=parseFloat(newVal),countIsNaN=isNaN(count);countIsNaN||count in whens||(count=$locale.pluralCat(count-offset)),count===lastCount||countIsNaN&&isNaN(lastCount)||(watchRemover(),watchRemover=scope.$watch(whensExpFns[count],updateElementText),lastCount=count)})}}}],ngRepeatDirective=["$parse","$animate",function($parse,$animate){var NG_REMOVED="$$NG_REMOVED",ngRepeatMinErr=minErr("ngRepeat"),updateScope=function(scope,index,valueIdentifier,value,keyIdentifier,key,arrayLength){scope[valueIdentifier]=value,keyIdentifier&&(scope[keyIdentifier]=key),scope.$index=index,scope.$first=0===index,scope.$last=index===arrayLength-1,scope.$middle=!(scope.$first||scope.$last),scope.$odd=!(scope.$even=0===(1&index))},getBlockStart=function(block){return block.clone[0]},getBlockEnd=function(block){return block.clone[block.clone.length-1]};return{restrict:"A",multiElement:!0,transclude:"element",priority:1e3,terminal:!0,$$tlb:!0,compile:function($element,$attr){var expression=$attr.ngRepeat,ngRepeatEndComment=document.createComment(" end ngRepeat: "+expression+" "),match=expression.match(/^\s*([\s\S]+?)\s+in\s+([\s\S]+?)(?:\s+as\s+([\s\S]+?))?(?:\s+track\s+by\s+([\s\S]+?))?\s*$/);if(!match)throw ngRepeatMinErr("iexp","Expected expression in form of '_item_ in _collection_[ track by _id_]' but got '{0}'.",expression);var lhs=match[1],rhs=match[2],aliasAs=match[3],trackByExp=match[4];if(match=lhs.match(/^(?:(\s*[\$\w]+)|\(\s*([\$\w]+)\s*,\s*([\$\w]+)\s*\))$/),!match)throw ngRepeatMinErr("iidexp","'_item_' in '_item_ in _collection_' should be an identifier or '(_key_, _value_)' expression, but got '{0}'.",lhs);var valueIdentifier=match[3]||match[1],keyIdentifier=match[2];if(aliasAs&&(!/^[$a-zA-Z_][$a-zA-Z0-9_]*$/.test(aliasAs)||/^(null|undefined|this|\$index|\$first|\$middle|\$last|\$even|\$odd|\$parent|\$root|\$id)$/.test(aliasAs)))throw ngRepeatMinErr("badident","alias '{0}' is invalid --- must be a valid JS identifier which is not a reserved name.",aliasAs);var trackByExpGetter,trackByIdExpFn,trackByIdArrayFn,trackByIdObjFn,hashFnLocals={$id:hashKey};return trackByExp?trackByExpGetter=$parse(trackByExp):(trackByIdArrayFn=function(key,value){
return hashKey(value)},trackByIdObjFn=function(key){return key}),function($scope,$element,$attr,ctrl,$transclude){trackByExpGetter&&(trackByIdExpFn=function(key,value,index){return keyIdentifier&&(hashFnLocals[keyIdentifier]=key),hashFnLocals[valueIdentifier]=value,hashFnLocals.$index=index,trackByExpGetter($scope,hashFnLocals)});var lastBlockMap=createMap();$scope.$watchCollection(rhs,function(collection){var index,length,nextNode,collectionLength,key,value,trackById,trackByIdFn,collectionKeys,block,nextBlockOrder,elementsToRemove,previousNode=$element[0],nextBlockMap=createMap();if(aliasAs&&($scope[aliasAs]=collection),isArrayLike(collection))collectionKeys=collection,trackByIdFn=trackByIdExpFn||trackByIdArrayFn;else{trackByIdFn=trackByIdExpFn||trackByIdObjFn,collectionKeys=[];for(var itemKey in collection)collection.hasOwnProperty(itemKey)&&"$"!=itemKey.charAt(0)&&collectionKeys.push(itemKey);collectionKeys.sort()}for(collectionLength=collectionKeys.length,nextBlockOrder=new Array(collectionLength),index=0;collectionLength>index;index++)if(key=collection===collectionKeys?index:collectionKeys[index],value=collection[key],trackById=trackByIdFn(key,value,index),lastBlockMap[trackById])block=lastBlockMap[trackById],delete lastBlockMap[trackById],nextBlockMap[trackById]=block,nextBlockOrder[index]=block;else{if(nextBlockMap[trackById])throw forEach(nextBlockOrder,function(block){block&&block.scope&&(lastBlockMap[block.id]=block)}),ngRepeatMinErr("dupes","Duplicates in a repeater are not allowed. Use 'track by' expression to specify unique keys. Repeater: {0}, Duplicate key: {1}, Duplicate value: {2}",expression,trackById,value);nextBlockOrder[index]={id:trackById,scope:undefined,clone:undefined},nextBlockMap[trackById]=!0}for(var blockKey in lastBlockMap){if(block=lastBlockMap[blockKey],elementsToRemove=getBlockNodes(block.clone),$animate.leave(elementsToRemove),elementsToRemove[0].parentNode)for(index=0,length=elementsToRemove.length;length>index;index++)elementsToRemove[index][NG_REMOVED]=!0;block.scope.$destroy()}for(index=0;collectionLength>index;index++)if(key=collection===collectionKeys?index:collectionKeys[index],value=collection[key],block=nextBlockOrder[index],block.scope){nextNode=previousNode;do nextNode=nextNode.nextSibling;while(nextNode&&nextNode[NG_REMOVED]);getBlockStart(block)!=nextNode&&$animate.move(getBlockNodes(block.clone),null,jqLite(previousNode)),previousNode=getBlockEnd(block),updateScope(block.scope,index,valueIdentifier,value,keyIdentifier,key,collectionLength)}else $transclude(function(clone,scope){block.scope=scope;var endNode=ngRepeatEndComment.cloneNode(!1);clone[clone.length++]=endNode,$animate.enter(clone,null,jqLite(previousNode)),previousNode=endNode,block.clone=clone,nextBlockMap[block.id]=block,updateScope(block.scope,index,valueIdentifier,value,keyIdentifier,key,collectionLength)});lastBlockMap=nextBlockMap})}}}}],NG_HIDE_CLASS="ng-hide",NG_HIDE_IN_PROGRESS_CLASS="ng-hide-animate",ngShowDirective=["$animate",function($animate){return{restrict:"A",multiElement:!0,link:function(scope,element,attr){scope.$watch(attr.ngShow,function(value){$animate[value?"removeClass":"addClass"](element,NG_HIDE_CLASS,{tempClasses:NG_HIDE_IN_PROGRESS_CLASS})})}}}],ngHideDirective=["$animate",function($animate){return{restrict:"A",multiElement:!0,link:function(scope,element,attr){scope.$watch(attr.ngHide,function(value){$animate[value?"addClass":"removeClass"](element,NG_HIDE_CLASS,{tempClasses:NG_HIDE_IN_PROGRESS_CLASS})})}}}],ngStyleDirective=ngDirective(function(scope,element,attr){scope.$watch(attr.ngStyle,function(newStyles,oldStyles){oldStyles&&newStyles!==oldStyles&&forEach(oldStyles,function(val,style){element.css(style,"")}),newStyles&&element.css(newStyles)},!0)}),ngSwitchDirective=["$animate",function($animate){return{restrict:"EA",require:"ngSwitch",controller:["$scope",function(){this.cases={}}],link:function(scope,element,attr,ngSwitchController){var watchExpr=attr.ngSwitch||attr.on,selectedTranscludes=[],selectedElements=[],previousLeaveAnimations=[],selectedScopes=[],spliceFactory=function(array,index){return function(){array.splice(index,1)}};scope.$watch(watchExpr,function(value){var i,ii;for(i=0,ii=previousLeaveAnimations.length;ii>i;++i)$animate.cancel(previousLeaveAnimations[i]);for(previousLeaveAnimations.length=0,i=0,ii=selectedScopes.length;ii>i;++i){var selected=getBlockNodes(selectedElements[i].clone);selectedScopes[i].$destroy();var promise=previousLeaveAnimations[i]=$animate.leave(selected);promise.then(spliceFactory(previousLeaveAnimations,i))}selectedElements.length=0,selectedScopes.length=0,(selectedTranscludes=ngSwitchController.cases["!"+value]||ngSwitchController.cases["?"])&&forEach(selectedTranscludes,function(selectedTransclude){selectedTransclude.transclude(function(caseElement,selectedScope){selectedScopes.push(selectedScope);var anchor=selectedTransclude.element;caseElement[caseElement.length++]=document.createComment(" end ngSwitchWhen: ");var block={clone:caseElement};selectedElements.push(block),$animate.enter(caseElement,anchor.parent(),anchor)})})})}}}],ngSwitchWhenDirective=ngDirective({transclude:"element",priority:1200,require:"^ngSwitch",multiElement:!0,link:function(scope,element,attrs,ctrl,$transclude){ctrl.cases["!"+attrs.ngSwitchWhen]=ctrl.cases["!"+attrs.ngSwitchWhen]||[],ctrl.cases["!"+attrs.ngSwitchWhen].push({transclude:$transclude,element:element})}}),ngSwitchDefaultDirective=ngDirective({transclude:"element",priority:1200,require:"^ngSwitch",multiElement:!0,link:function(scope,element,attr,ctrl,$transclude){ctrl.cases["?"]=ctrl.cases["?"]||[],ctrl.cases["?"].push({transclude:$transclude,element:element})}}),ngTranscludeDirective=ngDirective({restrict:"EAC",link:function($scope,$element,$attrs,controller,$transclude){if(!$transclude)throw minErr("ngTransclude")("orphan","Illegal use of ngTransclude directive in the template! No parent directive that requires a transclusion found. Element: {0}",startingTag($element));$transclude(function(clone){$element.empty(),$element.append(clone)})}}),scriptDirective=["$templateCache",function($templateCache){return{restrict:"E",terminal:!0,compile:function(element,attr){if("text/ng-template"==attr.type){var templateUrl=attr.id,text=element[0].text;$templateCache.put(templateUrl,text)}}}}],ngOptionsMinErr=minErr("ngOptions"),ngOptionsDirective=valueFn({restrict:"A",terminal:!0}),selectDirective=["$compile","$parse",function($compile,$parse){var NG_OPTIONS_REGEXP=/^\s*([\s\S]+?)(?:\s+as\s+([\s\S]+?))?(?:\s+group\s+by\s+([\s\S]+?))?\s+for\s+(?:([\$\w][\$\w]*)|(?:\(\s*([\$\w][\$\w]*)\s*,\s*([\$\w][\$\w]*)\s*\)))\s+in\s+([\s\S]+?)(?:\s+track\s+by\s+([\s\S]+?))?$/,nullModelCtrl={$setViewValue:noop};return{restrict:"E",require:["select","?ngModel"],controller:["$element","$scope","$attrs",function($element,$scope,$attrs){var nullOption,unknownOption,self=this,optionsMap={},ngModelCtrl=nullModelCtrl;self.databound=$attrs.ngModel,self.init=function(ngModelCtrl_,nullOption_,unknownOption_){ngModelCtrl=ngModelCtrl_,nullOption=nullOption_,unknownOption=unknownOption_},self.addOption=function(value,element){assertNotHasOwnProperty(value,'"option value"'),optionsMap[value]=!0,ngModelCtrl.$viewValue==value&&($element.val(value),unknownOption.parent()&&unknownOption.remove()),element&&element[0].hasAttribute("selected")&&(element[0].selected=!0)},self.removeOption=function(value){this.hasOption(value)&&(delete optionsMap[value],ngModelCtrl.$viewValue===value&&this.renderUnknownOption(value))},self.renderUnknownOption=function(val){var unknownVal="? "+hashKey(val)+" ?";unknownOption.val(unknownVal),$element.prepend(unknownOption),$element.val(unknownVal),unknownOption.prop("selected",!0)},self.hasOption=function(value){return optionsMap.hasOwnProperty(value)},$scope.$on("$destroy",function(){self.renderUnknownOption=noop})}],link:function(scope,element,attr,ctrls){function setupAsSingle(scope,selectElement,ngModelCtrl,selectCtrl){ngModelCtrl.$render=function(){var viewValue=ngModelCtrl.$viewValue;selectCtrl.hasOption(viewValue)?(unknownOption.parent()&&unknownOption.remove(),selectElement.val(viewValue),""===viewValue&&emptyOption.prop("selected",!0)):null==viewValue&&emptyOption?selectElement.val(""):selectCtrl.renderUnknownOption(viewValue)},selectElement.on("change",function(){scope.$apply(function(){unknownOption.parent()&&unknownOption.remove(),ngModelCtrl.$setViewValue(selectElement.val())})})}function setupAsMultiple(scope,selectElement,ctrl){var lastView;ctrl.$render=function(){var items=new HashMap(ctrl.$viewValue);forEach(selectElement.find("option"),function(option){option.selected=isDefined(items.get(option.value))})},scope.$watch(function(){equals(lastView,ctrl.$viewValue)||(lastView=shallowCopy(ctrl.$viewValue),ctrl.$render())}),selectElement.on("change",function(){scope.$apply(function(){var array=[];forEach(selectElement.find("option"),function(option){option.selected&&array.push(option.value)}),ctrl.$setViewValue(array)})})}function setupAsOptions(scope,selectElement,ctrl){function callExpression(exprFn,key,value){return locals[valueName]=value,keyName&&(locals[keyName]=key),exprFn(scope,locals)}function selectionChanged(){scope.$apply(function(){var viewValue,collection=valuesFn(scope)||[];if(multiple)viewValue=[],forEach(selectElement.val(),function(selectedKey){selectedKey=trackFn?trackKeysCache[selectedKey]:selectedKey,viewValue.push(getViewValue(selectedKey,collection[selectedKey]))});else{var selectedKey=trackFn?trackKeysCache[selectElement.val()]:selectElement.val();viewValue=getViewValue(selectedKey,collection[selectedKey])}ctrl.$setViewValue(viewValue),render()})}function getViewValue(key,value){if("?"===key)return undefined;if(""===key)return null;var viewValueFn=selectAsFn?selectAsFn:valueFn;return callExpression(viewValueFn,key,value)}function getLabels(){var toDisplay,values=valuesFn(scope);if(values&&isArray(values)){toDisplay=new Array(values.length);for(var i=0,ii=values.length;ii>i;i++)toDisplay[i]=callExpression(displayFn,i,values[i]);return toDisplay}if(values){toDisplay={};for(var prop in values)values.hasOwnProperty(prop)&&(toDisplay[prop]=callExpression(displayFn,prop,values[prop]))}return toDisplay}function createIsSelectedFn(viewValue){var selectedSet;if(multiple)if(trackFn&&isArray(viewValue)){selectedSet=new HashMap([]);for(var trackIndex=0;trackIndex<viewValue.length;trackIndex++)selectedSet.put(callExpression(trackFn,null,viewValue[trackIndex]),!0)}else selectedSet=new HashMap(viewValue);else trackFn&&(viewValue=callExpression(trackFn,null,viewValue));return function(key,value){var compareValueFn;return compareValueFn=trackFn?trackFn:selectAsFn?selectAsFn:valueFn,multiple?isDefined(selectedSet.remove(callExpression(compareValueFn,key,value))):viewValue===callExpression(compareValueFn,key,value)}}function scheduleRendering(){renderScheduled||(scope.$$postDigest(render),renderScheduled=!0)}function updateLabelMap(labelMap,label,added){labelMap[label]=labelMap[label]||0,labelMap[label]+=added?1:-1}function render(){renderScheduled=!1;var optionGroupName,optionGroup,option,existingParent,existingOptions,existingOption,key,value,groupLength,length,groupIndex,index,selected,lastElement,element,label,optionId,optionGroups={"":[]},optionGroupNames=[""],viewValue=ctrl.$viewValue,values=valuesFn(scope)||[],keys=keyName?sortedKeys(values):values,labelMap={},isSelected=createIsSelectedFn(viewValue),anySelected=!1;for(trackKeysCache={},index=0;length=keys.length,length>index;index++)key=index,keyName&&(key=keys[index],"$"===key.charAt(0))||(value=values[key],optionGroupName=callExpression(groupByFn,key,value)||"",(optionGroup=optionGroups[optionGroupName])||(optionGroup=optionGroups[optionGroupName]=[],optionGroupNames.push(optionGroupName)),selected=isSelected(key,value),anySelected=anySelected||selected,label=callExpression(displayFn,key,value),label=isDefined(label)?label:"",optionId=trackFn?trackFn(scope,locals):keyName?keys[index]:index,trackFn&&(trackKeysCache[optionId]=key),optionGroup.push({id:optionId,label:label,selected:selected}));for(multiple||(nullOption||null===viewValue?optionGroups[""].unshift({id:"",label:"",selected:!anySelected}):anySelected||optionGroups[""].unshift({id:"?",label:"",selected:!0})),groupIndex=0,groupLength=optionGroupNames.length;groupLength>groupIndex;groupIndex++){for(optionGroupName=optionGroupNames[groupIndex],optionGroup=optionGroups[optionGroupName],optionGroupsCache.length<=groupIndex?(existingParent={element:optGroupTemplate.clone().attr("label",optionGroupName),label:optionGroup.label},existingOptions=[existingParent],optionGroupsCache.push(existingOptions),selectElement.append(existingParent.element)):(existingOptions=optionGroupsCache[groupIndex],existingParent=existingOptions[0],existingParent.label!=optionGroupName&&existingParent.element.attr("label",existingParent.label=optionGroupName)),lastElement=null,index=0,length=optionGroup.length;length>index;index++)option=optionGroup[index],(existingOption=existingOptions[index+1])?(lastElement=existingOption.element,existingOption.label!==option.label&&(updateLabelMap(labelMap,existingOption.label,!1),updateLabelMap(labelMap,option.label,!0),lastElement.text(existingOption.label=option.label),lastElement.prop("label",existingOption.label)),existingOption.id!==option.id&&lastElement.val(existingOption.id=option.id),lastElement[0].selected!==option.selected&&(lastElement.prop("selected",existingOption.selected=option.selected),msie&&lastElement.prop("selected",existingOption.selected))):(""===option.id&&nullOption?element=nullOption:(element=optionTemplate.clone()).val(option.id).prop("selected",option.selected).attr("selected",option.selected).prop("label",option.label).text(option.label),existingOptions.push(existingOption={element:element,label:option.label,id:option.id,selected:option.selected}),updateLabelMap(labelMap,option.label,!0),lastElement?lastElement.after(element):existingParent.element.append(element),lastElement=element);for(index++;existingOptions.length>index;)option=existingOptions.pop(),updateLabelMap(labelMap,option.label,!1),option.element.remove()}for(;optionGroupsCache.length>groupIndex;){for(optionGroup=optionGroupsCache.pop(),index=1;index<optionGroup.length;++index)updateLabelMap(labelMap,optionGroup[index].label,!1);optionGroup[0].element.remove()}forEach(labelMap,function(count,label){count>0?selectCtrl.addOption(label):0>count&&selectCtrl.removeOption(label)})}var match;if(!(match=optionsExp.match(NG_OPTIONS_REGEXP)))throw ngOptionsMinErr("iexp","Expected expression in form of '_select_ (as _label_)? for (_key_,)?_value_ in _collection_' but got '{0}'. Element: {1}",optionsExp,startingTag(selectElement));var displayFn=$parse(match[2]||match[1]),valueName=match[4]||match[6],selectAs=/ as /.test(match[0])&&match[1],selectAsFn=selectAs?$parse(selectAs):null,keyName=match[5],groupByFn=$parse(match[3]||""),valueFn=$parse(match[2]?match[1]:valueName),valuesFn=$parse(match[7]),track=match[8],trackFn=track?$parse(match[8]):null,trackKeysCache={},optionGroupsCache=[[{element:selectElement,label:""}]],locals={};nullOption&&($compile(nullOption)(scope),nullOption.removeClass("ng-scope"),nullOption.remove()),selectElement.empty(),selectElement.on("change",selectionChanged),ctrl.$render=render,scope.$watchCollection(valuesFn,scheduleRendering),scope.$watchCollection(getLabels,scheduleRendering),multiple&&scope.$watchCollection(function(){return ctrl.$modelValue},scheduleRendering)}if(ctrls[1]){for(var emptyOption,selectCtrl=ctrls[0],ngModelCtrl=ctrls[1],multiple=attr.multiple,optionsExp=attr.ngOptions,nullOption=!1,renderScheduled=!1,optionTemplate=jqLite(document.createElement("option")),optGroupTemplate=jqLite(document.createElement("optgroup")),unknownOption=optionTemplate.clone(),i=0,children=element.children(),ii=children.length;ii>i;i++)if(""===children[i].value){emptyOption=nullOption=children.eq(i);break}selectCtrl.init(ngModelCtrl,nullOption,unknownOption),multiple&&(ngModelCtrl.$isEmpty=function(value){return!value||0===value.length}),optionsExp?setupAsOptions(scope,element,ngModelCtrl):multiple?setupAsMultiple(scope,element,ngModelCtrl):setupAsSingle(scope,element,ngModelCtrl,selectCtrl)}}}}],optionDirective=["$interpolate",function($interpolate){var nullSelectCtrl={addOption:noop,removeOption:noop};return{restrict:"E",priority:100,compile:function(element,attr){if(isUndefined(attr.value)){var interpolateFn=$interpolate(element.text(),!0);interpolateFn||attr.$set("value",element.text())}return function(scope,element,attr){var selectCtrlName="$selectController",parent=element.parent(),selectCtrl=parent.data(selectCtrlName)||parent.parent().data(selectCtrlName);selectCtrl&&selectCtrl.databound||(selectCtrl=nullSelectCtrl),interpolateFn?scope.$watch(interpolateFn,function(newVal,oldVal){attr.$set("value",newVal),oldVal!==newVal&&selectCtrl.removeOption(oldVal),selectCtrl.addOption(newVal,element)}):selectCtrl.addOption(attr.value,element),element.on("$destroy",function(){selectCtrl.removeOption(attr.value)})}}}}],styleDirective=valueFn({restrict:"E",terminal:!1}),requiredDirective=function(){return{restrict:"A",require:"?ngModel",link:function(scope,elm,attr,ctrl){ctrl&&(attr.required=!0,ctrl.$validators.required=function(modelValue,viewValue){return!attr.required||!ctrl.$isEmpty(viewValue)},attr.$observe("required",function(){ctrl.$validate()}))}}},patternDirective=function(){return{restrict:"A",require:"?ngModel",link:function(scope,elm,attr,ctrl){if(ctrl){var regexp,patternExp=attr.ngPattern||attr.pattern;attr.$observe("pattern",function(regex){if(isString(regex)&&regex.length>0&&(regex=new RegExp("^"+regex+"$")),regex&&!regex.test)throw minErr("ngPattern")("noregexp","Expected {0} to be a RegExp but was {1}. Element: {2}",patternExp,regex,startingTag(elm));regexp=regex||undefined,ctrl.$validate()}),ctrl.$validators.pattern=function(modelValue,viewValue){return ctrl.$isEmpty(viewValue)||isUndefined(regexp)||regexp.test(viewValue)}}}}},maxlengthDirective=function(){return{restrict:"A",require:"?ngModel",link:function(scope,elm,attr,ctrl){if(ctrl){var maxlength=-1;attr.$observe("maxlength",function(value){var intVal=int(value);maxlength=isNaN(intVal)?-1:intVal,ctrl.$validate()}),ctrl.$validators.maxlength=function(modelValue,viewValue){return 0>maxlength||ctrl.$isEmpty(viewValue)||viewValue.length<=maxlength}}}}},minlengthDirective=function(){return{restrict:"A",require:"?ngModel",link:function(scope,elm,attr,ctrl){if(ctrl){var minlength=0;attr.$observe("minlength",function(value){minlength=int(value)||0,ctrl.$validate()}),ctrl.$validators.minlength=function(modelValue,viewValue){return ctrl.$isEmpty(viewValue)||viewValue.length>=minlength}}}}};return window.angular.bootstrap?void console.log("WARNING: Tried to load angular more than once."):(bindJQuery(),publishExternalAPI(angular),void jqLite(document).ready(function(){angularInit(document,bootstrap)}))}(window,document),!window.angular.$$csp()&&window.angular.element(document.head).prepend('<style type="text/css">@charset "UTF-8";[ng\\:cloak],[ng-cloak],[data-ng-cloak],[x-ng-cloak],.ng-cloak,.x-ng-cloak,.ng-hide:not(.ng-hide-animate){display:none !important;}ng\\:form{display:block;}</style>'),angular.module("ui.codemirror",[]).constant("uiCodemirrorConfig",{}).directive("uiCodemirror",["uiCodemirrorConfig",function(uiCodemirrorConfig){return{restrict:"EA",require:"?ngModel",priority:1,compile:function(){if(angular.isUndefined(window.CodeMirror))throw new Error("ui-codemirror need CodeMirror to work... (o rly?)");return function(scope,iElement,iAttrs,ngModel){var options,opts,codeMirror,initialTextValue;if(initialTextValue=iElement.text(),options=uiCodemirrorConfig.codemirror||{},opts=angular.extend({value:initialTextValue},options,scope.$eval(iAttrs.uiCodemirror),scope.$eval(iAttrs.uiCodemirrorOpts)),"TEXTAREA"===iElement[0].tagName?codeMirror=window.CodeMirror.fromTextArea(iElement[0],opts):(iElement.html(""),codeMirror=new window.CodeMirror(function(cm_el){iElement.append(cm_el)},opts)),iAttrs.uiCodemirror||iAttrs.uiCodemirrorOpts){var codemirrorDefaultsKeys=Object.keys(window.CodeMirror.defaults);scope.$watch(iAttrs.uiCodemirror||iAttrs.uiCodemirrorOpts,function(newValues,oldValue){angular.isObject(newValues)&&codemirrorDefaultsKeys.forEach(function(key){if(newValues.hasOwnProperty(key)){if(oldValue&&newValues[key]===oldValue[key])return;codeMirror.setOption(key,newValues[key])}})},!0)}ngModel&&(ngModel.$formatters.push(function(value){if(angular.isUndefined(value)||null===value)return"";if(angular.isObject(value)||angular.isArray(value))throw new Error("ui-codemirror cannot use an object or an array as a model");return value}),ngModel.$render=function(){var safeViewValue=ngModel.$viewValue||"";codeMirror.setValue(safeViewValue)},codeMirror.on("change",function(instance){var newValue=instance.getValue();newValue!==ngModel.$viewValue&&scope.$apply(function(){ngModel.$setViewValue(newValue)})})),iAttrs.uiRefresh&&scope.$watch(iAttrs.uiRefresh,function(newVal,oldVal){newVal!==oldVal&&codeMirror.refresh()}),scope.$on("CodeMirror",function(event,callback){if(!angular.isFunction(callback))throw new Error("the CodeMirror event requires a callback function");callback(codeMirror)}),angular.isFunction(opts.onLoad)&&opts.onLoad(codeMirror)}}}}]),function(){"use strict";"undefined"!=typeof module&&"object"==typeof exports&&(module.exports="hc.marked"),angular.module("hc.marked",[]).provider("marked",function(){var self=this;self.setRenderer=function(opts){this.renderer=opts},self.setOptions=function(opts){this.defaults=opts},self.$get=["$window","$log",function($window,$log){var m=function(){return"undefined"!=typeof module&&"object"==typeof exports?require("marked"):$window.marked||marked}();if(angular.isUndefined(m))return void $log.error("angular-marked Error: marked not loaded.  See installation instructions.");if(self.renderer){for(var r=new m.Renderer,o=Object.keys(self.renderer),l=o.length;l--;)r[o[l]]=self.renderer[o[l]];self.defaults=self.defaults||{},self.defaults.renderer=r}return m.setOptions(self.defaults),m}]}).directive("marked",["marked",function(marked){return{restrict:"AE",replace:!0,scope:{opts:"=",marked:"="},link:function(scope,element,attrs){function unindent(text){if(!text)return text;var i,l,line,lines=text.replace(/\t/g,"  ").split(/\r?\n/),min=null,len=lines.length;for(i=0;len>i;i++)line=lines[i],l=line.match(/^(\s*)/)[0].length,l!==line.length&&(min=min>l||null===min?l:min);if(null!==min&&min>0)for(i=0;len>i;i++)lines[i]=lines[i].substr(min);return lines.join("\n")}function set(text){text=unindent(text||""),element.html(marked(text,scope.opts||null))}set(scope.marked||element.text()||""),attrs.marked&&scope.$watch("marked",set)}}}])}(),function(module){function shouldHighlightStatics(attrs){var should=!0;return angular.forEach(["source","include"],function(name){attrs[name]&&(should=!1)}),should}var dirHljs,dirLanguageFactory,dirSourceFactory,dirIncludeFactory;module.provider("hljsService",function(){var _hljsOptions={};return{setOptions:function(options){angular.extend(_hljsOptions,options)},getOptions:function(){return angular.copy(_hljsOptions)},$get:["$window",function($window){return($window.hljs.configure||angular.noop)(_hljsOptions),$window.hljs}]}}).factory("hljsCache",["$cacheFactory",function($cacheFactory){return $cacheFactory("hljsCache")}]).controller("HljsCtrl",["hljsCache","hljsService",function(hljsCache,hljsService){var ctrl=this,_elm=null,_lang=null,_code=null,_hlCb=null;ctrl.init=function(codeElm){_elm=codeElm},ctrl.setLanguage=function(lang){_lang=lang,_code&&ctrl.highlight(_code)},ctrl.highlightCallback=function(cb){_hlCb=cb},ctrl.highlight=function(code){if(_elm){var res,cacheKey;_code=code,_lang?(cacheKey=ctrl._cacheKey(_lang,_code),res=hljsCache.get(cacheKey),res||(res=hljsService.highlight(_lang,hljsService.fixMarkup(_code),!0),hljsCache.put(cacheKey,res))):(cacheKey=ctrl._cacheKey(_code),res=hljsCache.get(cacheKey),res||(res=hljsService.highlightAuto(hljsService.fixMarkup(_code)),hljsCache.put(cacheKey,res))),_elm.html(res.value),_elm.addClass(res.language),null!==_hlCb&&angular.isFunction(_hlCb)&&_hlCb()}},ctrl.clear=function(){_elm&&(_code=null,_elm.text(""))},ctrl.release=function(){_elm=null},ctrl._cacheKey=function(){var args=Array.prototype.slice.call(arguments),glue="!angular-highlightjs!";return args.join(glue)}}]),dirHljs=["$compile","$parse",function($compile,$parse){return{restrict:"EA",controller:"HljsCtrl",compile:function(tElm,tAttrs,transclude){var staticHTML=tElm[0].innerHTML.replace(/^(\r\n|\r|\n)/m,""),staticText=tElm[0].textContent.replace(/^(\r\n|\r|\n)/m,"");return tElm.html('<pre><code class="hljs"></code></pre>'),function(scope,iElm,iAttrs,ctrl){var compileCheck,escapeCheck;if(angular.isDefined(iAttrs.compile)&&(compileCheck=$parse(iAttrs.compile)),angular.isDefined(iAttrs.escape)?escapeCheck=$parse(iAttrs.escape):angular.isDefined(iAttrs.noEscape)&&(escapeCheck=$parse("false")),ctrl.init(iElm.find("code")),iAttrs.onhighlight&&ctrl.highlightCallback(function(){scope.$eval(iAttrs.onhighlight)}),(staticHTML||staticText)&&shouldHighlightStatics(iAttrs)){var code;code=escapeCheck&&!escapeCheck(scope)?staticText:staticHTML,ctrl.highlight(code),compileCheck&&compileCheck(scope)&&$compile(iElm.find("code").contents())(scope)}scope.$on("$destroy",function(){ctrl.release()})}}}}],dirLanguageFactory=function(dirName){return[function(){return{require:"?hljs",restrict:"A",link:function(scope,iElm,iAttrs,ctrl){ctrl&&iAttrs.$observe(dirName,function(lang){angular.isDefined(lang)&&ctrl.setLanguage(lang)})}}}]},dirSourceFactory=function(dirName){return["$compile","$parse",function($compile,$parse){return{require:"?hljs",restrict:"A",link:function(scope,iElm,iAttrs,ctrl){var compileCheck;ctrl&&(angular.isDefined(iAttrs.compile)&&(compileCheck=$parse(iAttrs.compile)),scope.$watch(iAttrs[dirName],function(newCode,oldCode){newCode?(ctrl.highlight(newCode),compileCheck&&compileCheck(scope)&&$compile(iElm.find("code").contents())(scope)):ctrl.clear()}))}}}]},dirIncludeFactory=function(dirName){return["$http","$templateCache","$q","$compile","$parse",function($http,$templateCache,$q,$compile,$parse){return{require:"?hljs",restrict:"A",compile:function(tElm,tAttrs,transclude){var srcExpr=tAttrs[dirName];return function(scope,iElm,iAttrs,ctrl){var compileCheck,changeCounter=0;ctrl&&(angular.isDefined(iAttrs.compile)&&(compileCheck=$parse(iAttrs.compile)),scope.$watch(srcExpr,function(src){var thisChangeId=++changeCounter;if(src&&angular.isString(src)){var templateCachePromise,dfd;templateCachePromise=$templateCache.get(src),templateCachePromise||(dfd=$q.defer(),$http.get(src,{cache:$templateCache,transformResponse:function(data,headersGetter){return data}}).success(function(code){thisChangeId===changeCounter&&dfd.resolve(code)}).error(function(){thisChangeId===changeCounter&&ctrl.clear(),dfd.resolve()}),templateCachePromise=dfd.promise),$q.when(templateCachePromise).then(function(code){code&&(angular.isArray(code)?code=code[1]:angular.isObject(code)&&(code=code.data),code=code.replace(/^(\r\n|\r|\n)/m,""),ctrl.highlight(code),compileCheck&&compileCheck(scope)&&$compile(iElm.find("code").contents())(scope))})}else ctrl.clear()}))}}}}]},module.directive("hljs",dirHljs).directive("language",dirLanguageFactory("language")).directive("source",dirSourceFactory("source")).directive("include",dirIncludeFactory("include"))}(angular.module("hljs",[])),function(window,angular,undefined){"use strict";function $SanitizeProvider(){this.$get=["$$sanitizeUri",function($$sanitizeUri){return function(html){var buf=[];return htmlParser(html,htmlSanitizeWriter(buf,function(uri,isImage){return!/^unsafe/.test($$sanitizeUri(uri,isImage))})),buf.join("")}}]}function sanitizeText(chars){var buf=[],writer=htmlSanitizeWriter(buf,angular.noop);return writer.chars(chars),buf.join("")}function makeMap(str){var i,obj={},items=str.split(",");for(i=0;i<items.length;i++)obj[items[i]]=!0;return obj}function htmlParser(html,handler){function parseStartTag(tag,tagName,rest,unary){if(tagName=angular.lowercase(tagName),blockElements[tagName])for(;stack.last()&&inlineElements[stack.last()];)parseEndTag("",stack.last());optionalEndTagElements[tagName]&&stack.last()==tagName&&parseEndTag("",tagName),unary=voidElements[tagName]||!!unary,unary||stack.push(tagName);var attrs={};rest.replace(ATTR_REGEXP,function(match,name,doubleQuotedValue,singleQuotedValue,unquotedValue){var value=doubleQuotedValue||singleQuotedValue||unquotedValue||"";attrs[name]=decodeEntities(value)}),handler.start&&handler.start(tagName,attrs,unary)}function parseEndTag(tag,tagName){var i,pos=0;if(tagName=angular.lowercase(tagName))for(pos=stack.length-1;pos>=0&&stack[pos]!=tagName;pos--);if(pos>=0){for(i=stack.length-1;i>=pos;i--)handler.end&&handler.end(stack[i]);stack.length=pos}}"string"!=typeof html&&(html=null===html||"undefined"==typeof html?"":""+html);var index,chars,match,text,stack=[],last=html;for(stack.last=function(){return stack[stack.length-1]};html;){if(text="",chars=!0,stack.last()&&specialElements[stack.last()]?(html=html.replace(new RegExp("([\\W\\w]*)<\\s*\\/\\s*"+stack.last()+"[^>]*>","i"),function(all,text){return text=text.replace(COMMENT_REGEXP,"$1").replace(CDATA_REGEXP,"$1"),handler.chars&&handler.chars(decodeEntities(text)),""}),parseEndTag("",stack.last())):(0===html.indexOf("<!--")?(index=html.indexOf("--",4),index>=0&&html.lastIndexOf("-->",index)===index&&(handler.comment&&handler.comment(html.substring(4,index)),html=html.substring(index+3),chars=!1)):DOCTYPE_REGEXP.test(html)?(match=html.match(DOCTYPE_REGEXP),match&&(html=html.replace(match[0],""),chars=!1)):BEGING_END_TAGE_REGEXP.test(html)?(match=html.match(END_TAG_REGEXP),match&&(html=html.substring(match[0].length),match[0].replace(END_TAG_REGEXP,parseEndTag),chars=!1)):BEGIN_TAG_REGEXP.test(html)&&(match=html.match(START_TAG_REGEXP),match?(match[4]&&(html=html.substring(match[0].length),match[0].replace(START_TAG_REGEXP,parseStartTag)),chars=!1):(text+="<",html=html.substring(1))),chars&&(index=html.indexOf("<"),text+=0>index?html:html.substring(0,index),html=0>index?"":html.substring(index),handler.chars&&handler.chars(decodeEntities(text)))),html==last)throw $sanitizeMinErr("badparse","The sanitizer was unable to parse the following block of html: {0}",html);last=html}parseEndTag()}function decodeEntities(value){return value?(hiddenPre.innerHTML=value.replace(/</g,"&lt;"),hiddenPre.textContent):""}function encodeEntities(value){return value.replace(/&/g,"&amp;").replace(SURROGATE_PAIR_REGEXP,function(value){var hi=value.charCodeAt(0),low=value.charCodeAt(1);return"&#"+(1024*(hi-55296)+(low-56320)+65536)+";"}).replace(NON_ALPHANUMERIC_REGEXP,function(value){return"&#"+value.charCodeAt(0)+";"}).replace(/</g,"&lt;").replace(/>/g,"&gt;")}function htmlSanitizeWriter(buf,uriValidator){var ignore=!1,out=angular.bind(buf,buf.push);return{start:function(tag,attrs,unary){tag=angular.lowercase(tag),!ignore&&specialElements[tag]&&(ignore=tag),ignore||validElements[tag]!==!0||(out("<"),out(tag),angular.forEach(attrs,function(value,key){var lkey=angular.lowercase(key),isImage="img"===tag&&"src"===lkey||"background"===lkey;validAttrs[lkey]!==!0||uriAttrs[lkey]===!0&&!uriValidator(value,isImage)||(out(" "),out(key),out('="'),out(encodeEntities(value)),out('"'))}),out(unary?"/>":">"))},end:function(tag){tag=angular.lowercase(tag),ignore||validElements[tag]!==!0||(out("</"),out(tag),out(">")),tag==ignore&&(ignore=!1)},chars:function(chars){ignore||out(encodeEntities(chars))}}}var $sanitizeMinErr=angular.$$minErr("$sanitize"),START_TAG_REGEXP=/^<((?:[a-zA-Z])[\w:-]*)((?:\s+[\w:-]+(?:\s*=\s*(?:(?:"[^"]*")|(?:'[^']*')|[^>\s]+))?)*)\s*(\/?)\s*(>?)/,END_TAG_REGEXP=/^<\/\s*([\w:-]+)[^>]*>/,ATTR_REGEXP=/([\w:-]+)(?:\s*=\s*(?:(?:"((?:[^"])*)")|(?:'((?:[^'])*)')|([^>\s]+)))?/g,BEGIN_TAG_REGEXP=/^</,BEGING_END_TAGE_REGEXP=/^<\//,COMMENT_REGEXP=/<!--(.*?)-->/g,DOCTYPE_REGEXP=/<!DOCTYPE([^>]*?)>/i,CDATA_REGEXP=/<!\[CDATA\[(.*?)]]>/g,SURROGATE_PAIR_REGEXP=/[\uD800-\uDBFF][\uDC00-\uDFFF]/g,NON_ALPHANUMERIC_REGEXP=/([^\#-~| |!])/g,voidElements=makeMap("area,br,col,hr,img,wbr"),optionalEndTagBlockElements=makeMap("colgroup,dd,dt,li,p,tbody,td,tfoot,th,thead,tr"),optionalEndTagInlineElements=makeMap("rp,rt"),optionalEndTagElements=angular.extend({},optionalEndTagInlineElements,optionalEndTagBlockElements),blockElements=angular.extend({},optionalEndTagBlockElements,makeMap("address,article,aside,blockquote,caption,center,del,dir,div,dl,figure,figcaption,footer,h1,h2,h3,h4,h5,h6,header,hgroup,hr,ins,map,menu,nav,ol,pre,script,section,table,ul")),inlineElements=angular.extend({},optionalEndTagInlineElements,makeMap("a,abbr,acronym,b,bdi,bdo,big,br,cite,code,del,dfn,em,font,i,img,ins,kbd,label,map,mark,q,ruby,rp,rt,s,samp,small,span,strike,strong,sub,sup,time,tt,u,var")),svgElements=makeMap("animate,animateColor,animateMotion,animateTransform,circle,defs,desc,ellipse,font-face,font-face-name,font-face-src,g,glyph,hkern,image,linearGradient,line,marker,metadata,missing-glyph,mpath,path,polygon,polyline,radialGradient,rect,set,stop,svg,switch,text,title,tspan,use"),specialElements=makeMap("script,style"),validElements=angular.extend({},voidElements,blockElements,inlineElements,optionalEndTagElements,svgElements),uriAttrs=makeMap("background,cite,href,longdesc,src,usemap,xlink:href"),htmlAttrs=makeMap("abbr,align,alt,axis,bgcolor,border,cellpadding,cellspacing,class,clear,color,cols,colspan,compact,coords,dir,face,headers,height,hreflang,hspace,ismap,lang,language,nohref,nowrap,rel,rev,rows,rowspan,rules,scope,scrolling,shape,size,span,start,summary,target,title,type,valign,value,vspace,width"),svgAttrs=makeMap("accent-height,accumulate,additive,alphabetic,arabic-form,ascent,attributeName,attributeType,baseProfile,bbox,begin,by,calcMode,cap-height,class,color,color-rendering,content,cx,cy,d,dx,dy,descent,display,dur,end,fill,fill-rule,font-family,font-size,font-stretch,font-style,font-variant,font-weight,from,fx,fy,g1,g2,glyph-name,gradientUnits,hanging,height,horiz-adv-x,horiz-origin-x,ideographic,k,keyPoints,keySplines,keyTimes,lang,marker-end,marker-mid,marker-start,markerHeight,markerUnits,markerWidth,mathematical,max,min,offset,opacity,orient,origin,overline-position,overline-thickness,panose-1,path,pathLength,points,preserveAspectRatio,r,refX,refY,repeatCount,repeatDur,requiredExtensions,requiredFeatures,restart,rotate,rx,ry,slope,stemh,stemv,stop-color,stop-opacity,strikethrough-position,strikethrough-thickness,stroke,stroke-dasharray,stroke-dashoffset,stroke-linecap,stroke-linejoin,stroke-miterlimit,stroke-opacity,stroke-width,systemLanguage,target,text-anchor,to,transform,type,u1,u2,underline-position,underline-thickness,unicode,unicode-range,units-per-em,values,version,viewBox,visibility,width,widths,x,x-height,x1,x2,xlink:actuate,xlink:arcrole,xlink:role,xlink:show,xlink:title,xlink:type,xml:base,xml:lang,xml:space,xmlns,xmlns:xlink,y,y1,y2,zoomAndPan"),validAttrs=angular.extend({},uriAttrs,svgAttrs,htmlAttrs),hiddenPre=document.createElement("pre");
angular.module("ngSanitize",[]).provider("$sanitize",$SanitizeProvider),angular.module("ngSanitize").filter("linky",["$sanitize",function($sanitize){var LINKY_URL_REGEXP=/((ftp|https?):\/\/|(www\.)|(mailto:)?[A-Za-z0-9._%+-]+@)\S*[^\s.;,(){}<>"”’]/i,MAILTO_REGEXP=/^mailto:/i;return function(text,target){function addText(text){text&&html.push(sanitizeText(text))}function addLink(url,text){html.push("<a "),angular.isDefined(target)&&html.push('target="',target,'" '),html.push('href="',url.replace(/"/g,"&quot;"),'">'),addText(text),html.push("</a>")}if(!text)return text;for(var match,url,i,raw=text,html=[];match=raw.match(LINKY_URL_REGEXP);)url=match[0],match[2]||match[4]||(url=(match[3]?"http://":"mailto:")+url),i=match.index,addText(raw.substr(0,i)),addLink(url,match[0].replace(MAILTO_REGEXP,"")),raw=raw.substring(i+match[0].length);return addText(raw),$sanitize(html.join(""))}}])}(window,window.angular);var JSZip=function(data,options){this.files={},this.root="",data&&this.load(data,options)};JSZip.signature={LOCAL_FILE_HEADER:"PK",CENTRAL_FILE_HEADER:"PK",CENTRAL_DIRECTORY_END:"PK",ZIP64_CENTRAL_DIRECTORY_LOCATOR:"PK",ZIP64_CENTRAL_DIRECTORY_END:"PK",DATA_DESCRIPTOR:"PK\b"},JSZip.defaults={base64:!1,binary:!1,dir:!1,date:null,compression:null},JSZip.support={arraybuffer:function(){return"undefined"!=typeof ArrayBuffer&&"undefined"!=typeof Uint8Array}(),nodebuffer:function(){return"undefined"!=typeof Buffer}(),uint8array:function(){return"undefined"!=typeof Uint8Array}(),blob:function(){if("undefined"==typeof ArrayBuffer)return!1;var buffer=new ArrayBuffer(0);try{return 0===new Blob([buffer],{type:"application/zip"}).size}catch(e){}try{var BlobBuilder=window.BlobBuilder||window.WebKitBlobBuilder||window.MozBlobBuilder||window.MSBlobBuilder,builder=new BlobBuilder;return builder.append(buffer),0===builder.getBlob("application/zip").size}catch(e){}return!1}()},JSZip.prototype=function(){var textEncoder,textDecoder;JSZip.support.uint8array&&"function"==typeof TextEncoder&&"function"==typeof TextDecoder&&(textEncoder=new TextEncoder("utf-8"),textDecoder=new TextDecoder("utf-8"));var getRawData=function(file){if(file._data instanceof JSZip.CompressedObject&&(file._data=file._data.getContent(),file.options.binary=!0,file.options.base64=!1,"uint8array"===JSZip.utils.getTypeOf(file._data))){var copy=file._data;file._data=new Uint8Array(copy.length),0!==copy.length&&file._data.set(copy,0)}return file._data},getBinaryData=function(file){var result=getRawData(file),type=JSZip.utils.getTypeOf(result);if("string"===type){if(!file.options.binary){if(textEncoder)return textEncoder.encode(result);if(JSZip.support.nodebuffer)return new Buffer(result,"utf-8")}return file.asBinary()}return result},dataToString=function(asUTF8){var result=getRawData(this);return null===result||"undefined"==typeof result?"":(this.options.base64&&(result=JSZip.base64.decode(result)),result=asUTF8&&this.options.binary?JSZip.prototype.utf8decode(result):JSZip.utils.transformTo("string",result),asUTF8||this.options.binary||(result=JSZip.prototype.utf8encode(result)),result)},ZipObject=function(name,data,options){this.name=name,this._data=data,this.options=options};ZipObject.prototype={asText:function(){return dataToString.call(this,!0)},asBinary:function(){return dataToString.call(this,!1)},asNodeBuffer:function(){var result=getBinaryData(this);return JSZip.utils.transformTo("nodebuffer",result)},asUint8Array:function(){var result=getBinaryData(this);return JSZip.utils.transformTo("uint8array",result)},asArrayBuffer:function(){return this.asUint8Array().buffer}};var decToHex=function(dec,bytes){var i,hex="";for(i=0;bytes>i;i++)hex+=String.fromCharCode(255&dec),dec>>>=8;return hex},extend=function(){var i,attr,result={};for(i=0;i<arguments.length;i++)for(attr in arguments[i])arguments[i].hasOwnProperty(attr)&&"undefined"==typeof result[attr]&&(result[attr]=arguments[i][attr]);return result},prepareFileAttrs=function(o){return o=o||{},o.base64===!0&&null==o.binary&&(o.binary=!0),o=extend(o,JSZip.defaults),o.date=o.date||new Date,null!==o.compression&&(o.compression=o.compression.toUpperCase()),o},fileAdd=function(name,data,o){var parent=parentFolder(name),dataType=JSZip.utils.getTypeOf(data);if(parent&&folderAdd.call(this,parent),o=prepareFileAttrs(o),o.dir||null===data||"undefined"==typeof data)o.base64=!1,o.binary=!1,data=null;else if("string"===dataType)o.binary&&!o.base64&&o.optimizedBinaryString!==!0&&(data=JSZip.utils.string2binary(data));else{if(o.base64=!1,o.binary=!0,!(dataType||data instanceof JSZip.CompressedObject))throw new Error("The data of '"+name+"' is in an unsupported format !");"arraybuffer"===dataType&&(data=JSZip.utils.transformTo("uint8array",data))}var object=new ZipObject(name,data,o);return this.files[name]=object,object},parentFolder=function(path){"/"==path.slice(-1)&&(path=path.substring(0,path.length-1));var lastSlash=path.lastIndexOf("/");return lastSlash>0?path.substring(0,lastSlash):""},folderAdd=function(name){return"/"!=name.slice(-1)&&(name+="/"),this.files[name]||fileAdd.call(this,name,null,{dir:!0}),this.files[name]},generateCompressedObjectFrom=function(file,compression){var content,result=new JSZip.CompressedObject;return file._data instanceof JSZip.CompressedObject?(result.uncompressedSize=file._data.uncompressedSize,result.crc32=file._data.crc32,0===result.uncompressedSize||file.options.dir?(compression=JSZip.compressions.STORE,result.compressedContent="",result.crc32=0):file._data.compressionMethod===compression.magic?result.compressedContent=file._data.getCompressedContent():(content=file._data.getContent(),result.compressedContent=compression.compress(JSZip.utils.transformTo(compression.compressInputType,content)))):(content=getBinaryData(file),(!content||0===content.length||file.options.dir)&&(compression=JSZip.compressions.STORE,content=""),result.uncompressedSize=content.length,result.crc32=this.crc32(content),result.compressedContent=compression.compress(JSZip.utils.transformTo(compression.compressInputType,content))),result.compressedSize=result.compressedContent.length,result.compressionMethod=compression.magic,result},generateZipParts=function(name,file,compressedObject,offset){var dosTime,dosDate,utfEncodedFileName=(compressedObject.compressedContent,this.utf8encode(file.name)),useUTF8=utfEncodedFileName!==file.name,o=file.options;dosTime=o.date.getHours(),dosTime<<=6,dosTime|=o.date.getMinutes(),dosTime<<=5,dosTime|=o.date.getSeconds()/2,dosDate=o.date.getFullYear()-1980,dosDate<<=4,dosDate|=o.date.getMonth()+1,dosDate<<=5,dosDate|=o.date.getDate();var header="";header+="\n\x00",header+=useUTF8?"\x00\b":"\x00\x00",header+=compressedObject.compressionMethod,header+=decToHex(dosTime,2),header+=decToHex(dosDate,2),header+=decToHex(compressedObject.crc32,4),header+=decToHex(compressedObject.compressedSize,4),header+=decToHex(compressedObject.uncompressedSize,4),header+=decToHex(utfEncodedFileName.length,2),header+="\x00\x00";var fileRecord=JSZip.signature.LOCAL_FILE_HEADER+header+utfEncodedFileName,dirRecord=JSZip.signature.CENTRAL_FILE_HEADER+"\x00"+header+"\x00\x00\x00\x00\x00\x00"+(file.options.dir===!0?"\x00\x00\x00":"\x00\x00\x00\x00")+decToHex(offset,4)+utfEncodedFileName;return{fileRecord:fileRecord,dirRecord:dirRecord,compressedObject:compressedObject}},StringWriter=function(){this.data=[]};StringWriter.prototype={append:function(input){input=JSZip.utils.transformTo("string",input),this.data.push(input)},finalize:function(){return this.data.join("")}};var Uint8ArrayWriter=function(length){this.data=new Uint8Array(length),this.index=0};return Uint8ArrayWriter.prototype={append:function(input){0!==input.length&&(input=JSZip.utils.transformTo("uint8array",input),this.data.set(input,this.index),this.index+=input.length)},finalize:function(){return this.data}},{load:function(stream,options){throw new Error("Load method is not defined. Is the file jszip-load.js included ?")},filter:function(search){var filename,relativePath,file,fileClone,result=[];for(filename in this.files)this.files.hasOwnProperty(filename)&&(file=this.files[filename],fileClone=new ZipObject(file.name,file._data,extend(file.options)),relativePath=filename.slice(this.root.length,filename.length),filename.slice(0,this.root.length)===this.root&&search(relativePath,fileClone)&&result.push(fileClone));return result},file:function(name,data,o){if(1===arguments.length){if(JSZip.utils.isRegExp(name)){var regexp=name;return this.filter(function(relativePath,file){return!file.options.dir&&regexp.test(relativePath)})}return this.filter(function(relativePath,file){return!file.options.dir&&relativePath===name})[0]||null}return name=this.root+name,fileAdd.call(this,name,data,o),this},folder:function(arg){if(!arg)return this;if(JSZip.utils.isRegExp(arg))return this.filter(function(relativePath,file){return file.options.dir&&arg.test(relativePath)});var name=this.root+arg,newFolder=folderAdd.call(this,name),ret=this.clone();return ret.root=newFolder.name,ret},remove:function(name){name=this.root+name;var file=this.files[name];if(file||("/"!=name.slice(-1)&&(name+="/"),file=this.files[name]),file)if(file.options.dir)for(var kids=this.filter(function(relativePath,file){return file.name.slice(0,name.length)===name}),i=0;i<kids.length;i++)delete this.files[kids[i].name];else delete this.files[name];return this},generate:function(options){options=extend(options||{},{base64:!0,compression:"STORE",type:"base64"}),JSZip.utils.checkSupport(options.type);var writer,i,zipData=[],localDirLength=0,centralDirLength=0;for(var name in this.files)if(this.files.hasOwnProperty(name)){var file=this.files[name],compressionName=file.options.compression||options.compression.toUpperCase(),compression=JSZip.compressions[compressionName];if(!compression)throw new Error(compressionName+" is not a valid compression method !");var compressedObject=generateCompressedObjectFrom.call(this,file,compression),zipPart=generateZipParts.call(this,name,file,compressedObject,localDirLength);localDirLength+=zipPart.fileRecord.length+compressedObject.compressedSize,centralDirLength+=zipPart.dirRecord.length,zipData.push(zipPart)}var dirEnd="";switch(dirEnd=JSZip.signature.CENTRAL_DIRECTORY_END+"\x00\x00\x00\x00"+decToHex(zipData.length,2)+decToHex(zipData.length,2)+decToHex(centralDirLength,4)+decToHex(localDirLength,4)+"\x00\x00",options.type.toLowerCase()){case"uint8array":case"arraybuffer":case"blob":case"nodebuffer":writer=new Uint8ArrayWriter(localDirLength+centralDirLength+dirEnd.length);break;default:writer=new StringWriter(localDirLength+centralDirLength+dirEnd.length)}for(i=0;i<zipData.length;i++)writer.append(zipData[i].fileRecord),writer.append(zipData[i].compressedObject.compressedContent);for(i=0;i<zipData.length;i++)writer.append(zipData[i].dirRecord);writer.append(dirEnd);var zip=writer.finalize();switch(options.type.toLowerCase()){case"uint8array":case"arraybuffer":case"nodebuffer":return JSZip.utils.transformTo(options.type.toLowerCase(),zip);case"blob":return JSZip.utils.arrayBuffer2Blob(JSZip.utils.transformTo("arraybuffer",zip));case"base64":return options.base64?JSZip.base64.encode(zip):zip;default:return zip}},crc32:function(input,crc){if("undefined"==typeof input||!input.length)return 0;var isArray="string"!==JSZip.utils.getTypeOf(input),table=[0,1996959894,3993919788,2567524794,124634137,1886057615,3915621685,2657392035,249268274,2044508324,3772115230,2547177864,162941995,2125561021,3887607047,2428444049,498536548,1789927666,4089016648,2227061214,450548861,1843258603,4107580753,2211677639,325883990,1684777152,4251122042,2321926636,335633487,1661365465,4195302755,2366115317,997073096,1281953886,3579855332,2724688242,1006888145,1258607687,3524101629,2768942443,901097722,1119000684,3686517206,2898065728,853044451,1172266101,3705015759,2882616665,651767980,1373503546,3369554304,3218104598,565507253,1454621731,3485111705,3099436303,671266974,1594198024,3322730930,2970347812,795835527,1483230225,3244367275,3060149565,1994146192,31158534,2563907772,4023717930,1907459465,112637215,2680153253,3904427059,2013776290,251722036,2517215374,3775830040,2137656763,141376813,2439277719,3865271297,1802195444,476864866,2238001368,4066508878,1812370925,453092731,2181625025,4111451223,1706088902,314042704,2344532202,4240017532,1658658271,366619977,2362670323,4224994405,1303535960,984961486,2747007092,3569037538,1256170817,1037604311,2765210733,3554079995,1131014506,879679996,2909243462,3663771856,1141124467,855842277,2852801631,3708648649,1342533948,654459306,3188396048,3373015174,1466479909,544179635,3110523913,3462522015,1591671054,702138776,2966460450,3352799412,1504918807,783551873,3082640443,3233442989,3988292384,2596254646,62317068,1957810842,3939845945,2647816111,81470997,1943803523,3814918930,2489596804,225274430,2053790376,3826175755,2466906013,167816743,2097651377,4027552580,2265490386,503444072,1762050814,4150417245,2154129355,426522225,1852507879,4275313526,2312317920,282753626,1742555852,4189708143,2394877945,397917763,1622183637,3604390888,2714866558,953729732,1340076626,3518719985,2797360999,1068828381,1219638859,3624741850,2936675148,906185462,1090812512,3747672003,2825379669,829329135,1181335161,3412177804,3160834842,628085408,1382605366,3423369109,3138078467,570562233,1426400815,3317316542,2998733608,733239954,1555261956,3268935591,3050360625,752459403,1541320221,2607071920,3965973030,1969922972,40735498,2617837225,3943577151,1913087877,83908371,2512341634,3803740692,2075208622,213261112,2463272603,3855990285,2094854071,198958881,2262029012,4057260610,1759359992,534414190,2176718541,4139329115,1873836001,414664567,2282248934,4279200368,1711684554,285281116,2405801727,4167216745,1634467795,376229701,2685067896,3608007406,1308918612,956543938,2808555105,3495958263,1231636301,1047427035,2932959818,3654703836,1088359270,936918e3,2847714899,3736837829,1202900863,817233897,3183342108,3401237130,1404277552,615818150,3134207493,3453421203,1423857449,601450431,3009837614,3294710456,1567103746,711928724,3020668471,3272380065,1510334235,755167117];"undefined"==typeof crc&&(crc=0);var x=0,y=0,byte=0;crc=-1^crc;for(var i=0,iTop=input.length;iTop>i;i++)byte=isArray?input[i]:input.charCodeAt(i),y=255&(crc^byte),x=table[y],crc=crc>>>8^x;return-1^crc},clone:function(){var newObj=new JSZip;for(var i in this)"function"!=typeof this[i]&&(newObj[i]=this[i]);return newObj},utf8encode:function(string){if(textEncoder){var u8=textEncoder.encode(string);return JSZip.utils.transformTo("string",u8)}if(JSZip.support.nodebuffer)return JSZip.utils.transformTo("string",new Buffer(string,"utf-8"));for(var result=[],resIndex=0,n=0;n<string.length;n++){var c=string.charCodeAt(n);128>c?result[resIndex++]=String.fromCharCode(c):c>127&&2048>c?(result[resIndex++]=String.fromCharCode(c>>6|192),result[resIndex++]=String.fromCharCode(63&c|128)):(result[resIndex++]=String.fromCharCode(c>>12|224),result[resIndex++]=String.fromCharCode(c>>6&63|128),result[resIndex++]=String.fromCharCode(63&c|128))}return result.join("")},utf8decode:function(input){var result=[],resIndex=0,type=JSZip.utils.getTypeOf(input),isArray="string"!==type,i=0,c=0,c2=0,c3=0;if(textDecoder)return textDecoder.decode(JSZip.utils.transformTo("uint8array",input));if(JSZip.support.nodebuffer)return JSZip.utils.transformTo("nodebuffer",input).toString("utf-8");for(;i<input.length;)c=isArray?input[i]:input.charCodeAt(i),128>c?(result[resIndex++]=String.fromCharCode(c),i++):c>191&&224>c?(c2=isArray?input[i+1]:input.charCodeAt(i+1),result[resIndex++]=String.fromCharCode((31&c)<<6|63&c2),i+=2):(c2=isArray?input[i+1]:input.charCodeAt(i+1),c3=isArray?input[i+2]:input.charCodeAt(i+2),result[resIndex++]=String.fromCharCode((15&c)<<12|(63&c2)<<6|63&c3),i+=3);return result.join("")}}}(),JSZip.compressions={STORE:{magic:"\x00\x00",compress:function(content){return content},uncompress:function(content){return content},compressInputType:null,uncompressInputType:null}},function(){function identity(input){return input}function stringToArrayLike(str,array){for(var i=0;i<str.length;++i)array[i]=255&str.charCodeAt(i);return array}function arrayLikeToString(array){var chunk=65536,result=[],len=array.length,type=JSZip.utils.getTypeOf(array),k=0,canUseApply=!0;try{switch(type){case"uint8array":String.fromCharCode.apply(null,new Uint8Array(0));break;case"nodebuffer":String.fromCharCode.apply(null,new Buffer(0))}}catch(e){canUseApply=!1}if(!canUseApply){for(var resultStr="",i=0;i<array.length;i++)resultStr+=String.fromCharCode(array[i]);return resultStr}for(;len>k&&chunk>1;)try{"array"===type||"nodebuffer"===type?result.push(String.fromCharCode.apply(null,array.slice(k,Math.min(k+chunk,len)))):result.push(String.fromCharCode.apply(null,array.subarray(k,Math.min(k+chunk,len)))),k+=chunk}catch(e){chunk=Math.floor(chunk/2)}return result.join("")}function arrayLikeToArrayLike(arrayFrom,arrayTo){for(var i=0;i<arrayFrom.length;i++)arrayTo[i]=arrayFrom[i];return arrayTo}JSZip.utils={string2binary:function(str){for(var result="",i=0;i<str.length;i++)result+=String.fromCharCode(255&str.charCodeAt(i));return result},string2Uint8Array:function(str){return JSZip.utils.transformTo("uint8array",str)},uint8Array2String:function(array){return JSZip.utils.transformTo("string",array)},arrayBuffer2Blob:function(buffer){JSZip.utils.checkSupport("blob");try{return new Blob([buffer],{type:"application/zip"})}catch(e){}try{var BlobBuilder=window.BlobBuilder||window.WebKitBlobBuilder||window.MozBlobBuilder||window.MSBlobBuilder,builder=new BlobBuilder;return builder.append(buffer),builder.getBlob("application/zip")}catch(e){}throw new Error("Bug : can't construct the Blob.")},string2Blob:function(str){var buffer=JSZip.utils.transformTo("arraybuffer",str);return JSZip.utils.arrayBuffer2Blob(buffer)}};var transform={};transform.string={string:identity,array:function(input){return stringToArrayLike(input,new Array(input.length))},arraybuffer:function(input){return transform.string.uint8array(input).buffer},uint8array:function(input){return stringToArrayLike(input,new Uint8Array(input.length))},nodebuffer:function(input){return stringToArrayLike(input,new Buffer(input.length))}},transform.array={string:arrayLikeToString,array:identity,arraybuffer:function(input){return new Uint8Array(input).buffer},uint8array:function(input){return new Uint8Array(input)},nodebuffer:function(input){return new Buffer(input)}},transform.arraybuffer={string:function(input){return arrayLikeToString(new Uint8Array(input))},array:function(input){return arrayLikeToArrayLike(new Uint8Array(input),new Array(input.byteLength))},arraybuffer:identity,uint8array:function(input){return new Uint8Array(input)},nodebuffer:function(input){return new Buffer(new Uint8Array(input))}},transform.uint8array={string:arrayLikeToString,array:function(input){return arrayLikeToArrayLike(input,new Array(input.length))},arraybuffer:function(input){return input.buffer},uint8array:identity,nodebuffer:function(input){return new Buffer(input)}},transform.nodebuffer={string:arrayLikeToString,array:function(input){return arrayLikeToArrayLike(input,new Array(input.length))},arraybuffer:function(input){return transform.nodebuffer.uint8array(input).buffer},uint8array:function(input){return arrayLikeToArrayLike(input,new Uint8Array(input.length))},nodebuffer:identity},JSZip.utils.transformTo=function(outputType,input){if(input||(input=""),!outputType)return input;JSZip.utils.checkSupport(outputType);var inputType=JSZip.utils.getTypeOf(input),result=transform[inputType][outputType](input);return result},JSZip.utils.getTypeOf=function(input){return"string"==typeof input?"string":"[object Array]"===Object.prototype.toString.call(input)?"array":JSZip.support.nodebuffer&&Buffer.isBuffer(input)?"nodebuffer":JSZip.support.uint8array&&input instanceof Uint8Array?"uint8array":JSZip.support.arraybuffer&&input instanceof ArrayBuffer?"arraybuffer":void 0},JSZip.utils.isRegExp=function(object){return"[object RegExp]"===Object.prototype.toString.call(object)},JSZip.utils.checkSupport=function(type){var supported=!0;switch(type.toLowerCase()){case"uint8array":supported=JSZip.support.uint8array;break;case"arraybuffer":supported=JSZip.support.arraybuffer;break;case"nodebuffer":supported=JSZip.support.nodebuffer;break;case"blob":supported=JSZip.support.blob}if(!supported)throw new Error(type+" is not supported by this browser")}}(),function(){JSZip.CompressedObject=function(){this.compressedSize=0,this.uncompressedSize=0,this.crc32=0,this.compressionMethod=null,this.compressedContent=null},JSZip.CompressedObject.prototype={getContent:function(){return null},getCompressedContent:function(){return null}}}(),JSZip.base64=function(){var _keyStr="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";return{encode:function(input,utf8){for(var chr1,chr2,chr3,enc1,enc2,enc3,enc4,output="",i=0;i<input.length;)chr1=input.charCodeAt(i++),chr2=input.charCodeAt(i++),chr3=input.charCodeAt(i++),enc1=chr1>>2,enc2=(3&chr1)<<4|chr2>>4,enc3=(15&chr2)<<2|chr3>>6,enc4=63&chr3,isNaN(chr2)?enc3=enc4=64:isNaN(chr3)&&(enc4=64),output=output+_keyStr.charAt(enc1)+_keyStr.charAt(enc2)+_keyStr.charAt(enc3)+_keyStr.charAt(enc4);return output},decode:function(input,utf8){var chr1,chr2,chr3,enc1,enc2,enc3,enc4,output="",i=0;for(input=input.replace(/[^A-Za-z0-9\+\/\=]/g,"");i<input.length;)enc1=_keyStr.indexOf(input.charAt(i++)),enc2=_keyStr.indexOf(input.charAt(i++)),enc3=_keyStr.indexOf(input.charAt(i++)),enc4=_keyStr.indexOf(input.charAt(i++)),chr1=enc1<<2|enc2>>4,chr2=(15&enc2)<<4|enc3>>2,chr3=(3&enc3)<<6|enc4,output+=String.fromCharCode(chr1),64!=enc3&&(output+=String.fromCharCode(chr2)),64!=enc4&&(output+=String.fromCharCode(chr3));return output}}}(),function(root){function symbols(code){return _symbols?_symbols[code]:(_symbols=require("unicode/category/So"),removelist=["sign","cross","of","symbol","staff","hand","black","white"].map(function(word){return new RegExp(word,"gi")}),_symbols[code])}function slug(string,opts){opts=opts||{},string=string.toString(),"string"==typeof opts&&(opts={replacement:opts}),opts.mode=opts.mode||slug.defaults.mode;var defaults=slug.defaults.modes[opts.mode];["replacement","multicharmap","charmap","remove"].forEach(function(key){opts[key]=opts[key]||defaults[key]}),"undefined"==typeof opts.symbols&&(opts.symbols=defaults.symbols);var lengths=[];Object.keys(opts.multicharmap).forEach(function(key){var len=key.length;-1===lengths.indexOf(len)&&lengths.push(len)});for(var code,unicode,char,result="",i=0,l=string.length;l>i;i++){if(char=string[i],!lengths.some(function(len){var str=string.substr(i,len);return opts.multicharmap[str]?(i+=len-1,char=opts.multicharmap[str],!0):!1})&&(opts.charmap[char]?(char=opts.charmap[char],code=char.charCodeAt(0)):code=string.charCodeAt(i),opts.symbols&&(unicode=symbols(code)))){char=unicode.name.toLowerCase();for(var j=0,rl=removelist.length;rl>j;j++)char=char.replace(removelist[j],"");char=char.replace(/^\s+|\s+$/g,"")}char=char.replace(/[^\w\s\-\.\_~]/g,""),opts.remove&&(char=char.replace(opts.remove,"")),result+=char}return result=result.replace(/^\s+|\s+$/g,""),result=result.replace(/[-\s]+/g,opts.replacement),result.replace(opts.replacement+"$","")}var _symbols,removelist;slug.defaults={mode:"pretty"},slug.multicharmap=slug.defaults.multicharmap={"<3":"love","&&":"and","||":"or","w/":"with"},slug.charmap=slug.defaults.charmap={"À":"A","Á":"A","Â":"A","Ã":"A","Ä":"A","Å":"A","Æ":"AE","Ç":"C","È":"E","É":"E","Ê":"E","Ë":"E","Ì":"I","Í":"I","Î":"I","Ï":"I","Ð":"D","Ñ":"N","Ò":"O","Ó":"O","Ô":"O","Õ":"O","Ö":"O","Ő":"O","Ø":"O","Ù":"U","Ú":"U","Û":"U","Ü":"U","Ű":"U","Ý":"Y","Þ":"TH","ß":"ss","à":"a","á":"a","â":"a","ã":"a","ä":"a","å":"a","æ":"ae","ç":"c","è":"e","é":"e","ê":"e","ë":"e","ì":"i","í":"i","î":"i","ï":"i","ð":"d","ñ":"n","ò":"o","ó":"o","ô":"o","õ":"o","ö":"o","ő":"o","ø":"o","ù":"u","ú":"u","û":"u","ü":"u","ű":"u","ý":"y","þ":"th","ÿ":"y","ẞ":"SS","α":"a","β":"b","γ":"g","δ":"d","ε":"e","ζ":"z","η":"h","θ":"8","ι":"i","κ":"k","λ":"l","μ":"m","ν":"n","ξ":"3","ο":"o","π":"p","ρ":"r","σ":"s","τ":"t","υ":"y","φ":"f","χ":"x","ψ":"ps","ω":"w","ά":"a","έ":"e","ί":"i","ό":"o","ύ":"y","ή":"h","ώ":"w","ς":"s","ϊ":"i","ΰ":"y","ϋ":"y","ΐ":"i","Α":"A","Β":"B","Γ":"G","Δ":"D","Ε":"E","Ζ":"Z","Η":"H","Θ":"8","Ι":"I","Κ":"K","Λ":"L","Μ":"M","Ν":"N","Ξ":"3","Ο":"O","Π":"P","Ρ":"R","Σ":"S","Τ":"T","Υ":"Y","Φ":"F","Χ":"X","Ψ":"PS","Ω":"W","Ά":"A","Έ":"E","Ί":"I","Ό":"O","Ύ":"Y","Ή":"H","Ώ":"W","Ϊ":"I","Ϋ":"Y","ş":"s","Ş":"S","ı":"i","İ":"I","ğ":"g","Ğ":"G","а":"a","б":"b","в":"v","г":"g","д":"d","е":"e","ё":"yo","ж":"zh","з":"z","и":"i","й":"j","к":"k","л":"l","м":"m","н":"n","о":"o","п":"p","р":"r","с":"s","т":"t","у":"u","ф":"f","х":"h","ц":"c","ч":"ch","ш":"sh","щ":"sh","ъ":"u","ы":"y","ь":"","э":"e","ю":"yu","я":"ya","А":"A","Б":"B","В":"V","Г":"G","Д":"D","Е":"E","Ё":"Yo","Ж":"Zh","З":"Z","И":"I","Й":"J","К":"K","Л":"L","М":"M","Н":"N","О":"O","П":"P","Р":"R","С":"S","Т":"T","У":"U","Ф":"F","Х":"H","Ц":"C","Ч":"Ch","Ш":"Sh","Щ":"Sh","Ъ":"U","Ы":"Y","Ь":"","Э":"E","Ю":"Yu","Я":"Ya","Є":"Ye","І":"I","Ї":"Yi","Ґ":"G","є":"ye","і":"i","ї":"yi","ґ":"g","č":"c","ď":"d","ě":"e","ň":"n","ř":"r","š":"s","ť":"t","ů":"u","ž":"z","Č":"C","Ď":"D","Ě":"E","Ň":"N","Ř":"R","Š":"S","Ť":"T","Ů":"U","Ž":"Z","ą":"a","ć":"c","ę":"e","ł":"l","ń":"n","ś":"s","ź":"z","ż":"z","Ą":"A","Ć":"C","Ę":"E","Ł":"L","Ń":"N","Ś":"S","Ź":"Z","Ż":"Z","ā":"a","ē":"e","ģ":"g","ī":"i","ķ":"k","ļ":"l","ņ":"n","ū":"u","Ā":"A","Ē":"E","Ģ":"G","Ī":"I","Ķ":"K","Ļ":"L","Ņ":"N","Ū":"U","ė":"e","į":"i","ų":"u","Ė":"E","Į":"I","Ų":"U","ț":"t","Ț":"T","ţ":"t","Ţ":"T","ș":"s","Ș":"S","ă":"a","Ă":"A","€":"euro","₢":"cruzeiro","₣":"french franc","£":"pound","₤":"lira","₥":"mill","₦":"naira","₧":"peseta","₨":"rupee","₩":"won","₪":"new shequel","₫":"dong","₭":"kip","₮":"tugrik","₯":"drachma","₰":"penny","₱":"peso","₲":"guarani","₳":"austral","₴":"hryvnia","₵":"cedi","¢":"cent","¥":"yen","元":"yuan","円":"yen","﷼":"rial","₠":"ecu","¤":"currency","฿":"baht",$:"dollar","₹":"indian rupee","©":"(c)","œ":"oe","Œ":"OE","∑":"sum","®":"(r)","†":"+","“":'"',"”":'"',"‘":"'","’":"'","∂":"d","ƒ":"f","™":"tm","℠":"sm","…":"...","˚":"o","º":"o","ª":"a","•":"*","∆":"delta","∞":"infinity","♥":"love","&":"and","|":"or","<":"less",">":"greater"},slug.defaults.modes={rfc3986:{replacement:"-",symbols:!0,remove:null,charmap:slug.defaults.charmap,multicharmap:slug.defaults.multicharmap},pretty:{replacement:"-",symbols:!0,remove:/[.]/g,charmap:slug.defaults.charmap,multicharmap:slug.defaults.multicharmap}},"undefined"!=typeof define&&define.amd?(Object.keys(slug.defaults.modes).forEach(function(key){slug.defaults.modes[key].symbols=!1}),define([],function(){return slug})):"undefined"!=typeof module&&module.exports?(symbols(),module.exports=slug):(Object.keys(slug.defaults.modes).forEach(function(key){slug.defaults.modes[key].symbols=!1}),root.slug=slug)}(this);var saveAs=saveAs||function(view){"use strict";if("undefined"==typeof navigator||!/MSIE [1-9]\./.test(navigator.userAgent)){var doc=view.document,get_URL=function(){return view.URL||view.webkitURL||view},save_link=doc.createElementNS("http://www.w3.org/1999/xhtml","a"),can_use_save_link="download"in save_link,click=function(node){var event=new MouseEvent("click");node.dispatchEvent(event)},is_safari=/Version\/[\d\.]+.*Safari/.test(navigator.userAgent),webkit_req_fs=view.webkitRequestFileSystem,req_fs=view.requestFileSystem||webkit_req_fs||view.mozRequestFileSystem,throw_outside=function(ex){(view.setImmediate||view.setTimeout)(function(){throw ex},0)},force_saveable_type="application/octet-stream",fs_min_size=0,arbitrary_revoke_timeout=4e4,revoke=function(file){var revoker=function(){"string"==typeof file?get_URL().revokeObjectURL(file):file.remove()};setTimeout(revoker,arbitrary_revoke_timeout)},dispatch=function(filesaver,event_types,event){event_types=[].concat(event_types);for(var i=event_types.length;i--;){var listener=filesaver["on"+event_types[i]];if("function"==typeof listener)try{listener.call(filesaver,event||filesaver)}catch(ex){throw_outside(ex)}}},auto_bom=function(blob){return/^\s*(?:text\/\S*|application\/xml|\S*\/\S*\+xml)\s*;.*charset\s*=\s*utf-8/i.test(blob.type)?new Blob(["\ufeff",blob],{type:blob.type}):blob},FileSaver=function(blob,name,no_auto_bom){no_auto_bom||(blob=auto_bom(blob));var object_url,target_view,slice,filesaver=this,type=blob.type,blob_changed=!1,dispatch_all=function(){dispatch(filesaver,"writestart progress write writeend".split(" "))},fs_error=function(){if(target_view&&is_safari&&"undefined"!=typeof FileReader){var reader=new FileReader;return reader.onloadend=function(){var base64Data=reader.result;target_view.location.href="data:attachment/file"+base64Data.slice(base64Data.search(/[,;]/)),filesaver.readyState=filesaver.DONE,dispatch_all()},reader.readAsDataURL(blob),void(filesaver.readyState=filesaver.INIT)}if((blob_changed||!object_url)&&(object_url=get_URL().createObjectURL(blob)),target_view)target_view.location.href=object_url;else{var new_tab=view.open(object_url,"_blank");void 0===new_tab&&is_safari&&(view.location.href=object_url)}filesaver.readyState=filesaver.DONE,dispatch_all(),revoke(object_url)},abortable=function(func){return function(){return filesaver.readyState!==filesaver.DONE?func.apply(this,arguments):void 0}},create_if_not_found={create:!0,exclusive:!1};return filesaver.readyState=filesaver.INIT,name||(name="download"),can_use_save_link?(object_url=get_URL().createObjectURL(blob),void setTimeout(function(){save_link.href=object_url,save_link.download=name,click(save_link),dispatch_all(),revoke(object_url),filesaver.readyState=filesaver.DONE})):(view.chrome&&type&&type!==force_saveable_type&&(slice=blob.slice||blob.webkitSlice,blob=slice.call(blob,0,blob.size,force_saveable_type),blob_changed=!0),webkit_req_fs&&"download"!==name&&(name+=".download"),(type===force_saveable_type||webkit_req_fs)&&(target_view=view),req_fs?(fs_min_size+=blob.size,void req_fs(view.TEMPORARY,fs_min_size,abortable(function(fs){fs.root.getDirectory("saved",create_if_not_found,abortable(function(dir){var save=function(){dir.getFile(name,create_if_not_found,abortable(function(file){file.createWriter(abortable(function(writer){writer.onwriteend=function(event){target_view.location.href=file.toURL(),filesaver.readyState=filesaver.DONE,dispatch(filesaver,"writeend",event),revoke(file)},writer.onerror=function(){var error=writer.error;error.code!==error.ABORT_ERR&&fs_error()},"writestart progress write abort".split(" ").forEach(function(event){writer["on"+event]=filesaver["on"+event]}),writer.write(blob),filesaver.abort=function(){writer.abort(),filesaver.readyState=filesaver.DONE},filesaver.readyState=filesaver.WRITING}),fs_error)}),fs_error)};dir.getFile(name,{create:!1},abortable(function(file){file.remove(),save()}),abortable(function(ex){ex.code===ex.NOT_FOUND_ERR?save():fs_error()}))}),fs_error)}),fs_error)):void fs_error())},FS_proto=FileSaver.prototype,saveAs=function(blob,name,no_auto_bom){return new FileSaver(blob,name,no_auto_bom)};return"undefined"!=typeof navigator&&navigator.msSaveOrOpenBlob?function(blob,name,no_auto_bom){return no_auto_bom||(blob=auto_bom(blob)),navigator.msSaveOrOpenBlob(blob,name||"download")}:(FS_proto.abort=function(){var filesaver=this;filesaver.readyState=filesaver.DONE,dispatch(filesaver,"abort")},FS_proto.readyState=FS_proto.INIT=0,FS_proto.WRITING=1,FS_proto.DONE=2,FS_proto.error=FS_proto.onwritestart=FS_proto.onprogress=FS_proto.onwrite=FS_proto.onabort=FS_proto.onerror=FS_proto.onwriteend=null,saveAs)}}("undefined"!=typeof self&&self||"undefined"!=typeof window&&window||this.content);"undefined"!=typeof module&&module.exports?module.exports.saveAs=saveAs:"undefined"!=typeof define&&null!==define&&null!==define.amd&&define([],function(){return saveAs}),!function(e){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=e();else if("function"==typeof define&&define.amd)define([],e);else{var n;"undefined"!=typeof window?n=window:"undefined"!=typeof global?n=global:"undefined"!=typeof self&&(n=self),
n.ramlClientGenerator=e()}}(function(){var define;return function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a="function"==typeof require&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}for(var i="function"==typeof require&&require,o=0;o<r.length;o++)s(r[o]);return s}({1:[function(require,module,exports){function mapDeps(deps,env){return env?deps.map(function(dep){return DEPS_MAP[env][dep]}):deps}var DEPS_MAP={node:{popsicle:"require('popsicle')",ClientOAuth2:"require('client-oauth2')"},amd:{popsicle:"'popsicle'",ClientOAuth2:"'ClientOAuth2'"},browser:{popsicle:"root.popsicle",ClientOAuth2:"root.ClientOAuth2"}};module.exports=function(context,env){var deps=["popsicle"];return context.security["OAuth 2.0"]&&deps.push("ClientOAuth2"),"amd"===env?"["+mapDeps(deps,env).join(", ")+"]":mapDeps(deps,env).join(", ")}},{}],2:[function(require,module,exports){module.exports=function(parameters){return Object.keys(parameters).map(function(key){var parameter=parameters[key],title="* **"+parameter.displayName+"**",options=[];return parameter.type&&options.push(parameter.type),Array.isArray(parameter["enum"])&&parameter["enum"].length&&options.push("one of ("+parameter["enum"].join(", ")+")"),parameter["default"]&&options.push("default: "+parameter["default"]),title+(options.length?" _"+options.join(", ")+"_":"")+(parameter.description?"\n\n"+parameter.description:"")}).join("\n\n")}},{}],3:[function(require,module,exports){var params=function(resource){return resource.uriParameters.map(function(param){return param.displayName}).join(", ")};module.exports=function(resource){for(var parts=[],part=resource;part&&part.parent;){var segment=part.key;part.uriParameters.length&&(segment+="("+params(part)+")"),parts.unshift(segment),part=part.parent}return"resources"+(parts.length?"."+parts.join("."):"")}},{}],4:[function(require,module,exports){var generator=require("../../lib/generator");module.exports=generator({templates:{".gitignore":require("./templates/.gitignore.hbs"),"index.js":require("./templates/index.js.hbs"),"README.md":require("./templates/README.md.hbs"),"INSTALL.md":require("./templates/INSTALL.md.hbs"),"package.json":require("./templates/package.json.hbs")},format:{variable:require("camel-case")},partials:{auth:require("./partials/auth.js.hbs"),utils:require("./partials/utils.js.hbs"),client:require("./partials/client.js.hbs"),resources:require("./partials/resources.js.hbs")},helpers:{stringify:require("javascript-stringify"),dependencies:require("./helpers/dependencies"),requestSnippet:require("./helpers/request-snippet"),parametersSnippet:require("./helpers/parameters-snippet")}})},{"../../lib/generator":20,"./helpers/dependencies":1,"./helpers/parameters-snippet":2,"./helpers/request-snippet":3,"./partials/auth.js.hbs":5,"./partials/client.js.hbs":6,"./partials/resources.js.hbs":7,"./partials/utils.js.hbs":8,"./templates/.gitignore.hbs":9,"./templates/INSTALL.md.hbs":10,"./templates/README.md.hbs":11,"./templates/index.js.hbs":12,"./templates/package.json.hbs":13,"camel-case":27,"javascript-stringify":45}],5:[function(require,module,exports){var HandlebarsCompiler=require("hbsfy/runtime");module.exports=HandlebarsCompiler.template({1:function(depth0,helpers,partials,data){var stack1;return"/**\n * @param {Object} options\n */\nfunction OAuth2 (options) {\n  ClientOAuth2.call(this, extend("+(null!=(stack1=(helpers.stringify||depth0&&depth0.stringify||helpers.helperMissing).call(depth0,null!=(stack1=null!=(stack1=null!=depth0?depth0.security:depth0)?stack1["OAuth 2.0"]:stack1)?stack1.settings:stack1,{name:"stringify",hash:{},data:data}))?stack1:"")+", options));\n}\n\nOAuth2.prototype = Object.create(ClientOAuth2.prototype);\nOAuth2.prototype.constructor = OAuth2;\nOAuth2.prototype.request = popsicle;\n\nClient.OAuth2 = OAuth2;\n"},compiler:[6,">= 2.0.0-beta.1"],main:function(depth0,helpers,partials,data){var stack1;return null!=(stack1=helpers["if"].call(depth0,null!=(stack1=null!=depth0?depth0.security:depth0)?stack1["OAuth 2.0"]:stack1,{name:"if",hash:{},fn:this.program(1,data,0),inverse:this.noop,data:data}))?stack1:""},useData:!0})},{"hbsfy/runtime":41}],6:[function(require,module,exports){var HandlebarsCompiler=require("hbsfy/runtime");module.exports=HandlebarsCompiler.template({compiler:[6,">= 2.0.0-beta.1"],main:function(depth0,helpers,partials,data){var stack1,alias1=helpers.helperMissing;return"function Client (options) {\n  this.options = extend({\n    baseUri: "+(null!=(stack1=(helpers.stringify||depth0&&depth0.stringify||alias1).call(depth0,null!=depth0?depth0.baseUri:depth0,{name:"stringify",hash:{},data:data}))?stack1:"")+",\n    baseUriParameters: "+(null!=(stack1=(helpers.stringify||depth0&&depth0.stringify||alias1).call(depth0,(helpers.object||depth0&&depth0.object||alias1).call(depth0,(helpers.keys||depth0&&depth0.keys||alias1).call(depth0,null!=depth0?depth0.baseUriParameters:depth0,{name:"keys",hash:{},data:data}),(helpers.pluck||depth0&&depth0.pluck||alias1).call(depth0,null!=depth0?depth0.baseUriParameters:depth0,"default",{name:"pluck",hash:{},data:data}),{name:"object",hash:{},data:data}),{name:"stringify",hash:{},data:data}))?stack1:"")+"\n  }, options);\n\n  this.resources = new "+this.escapeExpression((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=(stack1=null!=depth0?depth0.resources:depth0)?stack1.id:stack1,{name:"pascalCase",hash:{},data:data}))+"('', this);\n};\n\nClient.prototype.resource = function (route, parameters) {\n  var path = '/' + template(route, parameters).replace(/^\\//, '');\n\n  return new CustomResource(path, this);\n};\n\nClient.prototype.request = popsicle;\nClient.prototype.form = Client.form = popsicle.form;\nClient.prototype.version  = "+(null!=(stack1=(helpers.stringify||depth0&&depth0.stringify||alias1).call(depth0,null!=depth0?depth0.version:depth0,{name:"stringify",hash:{},data:data}))?stack1:"")+";\n"},useData:!0})},{"hbsfy/runtime":41}],7:[function(require,module,exports){var HandlebarsCompiler=require("hbsfy/runtime");module.exports=HandlebarsCompiler.template({1:function(depth0,helpers,partials,data,blockParams,depths){var stack1;return"function "+this.escapeExpression((helpers.pascalCase||depth0&&depth0.pascalCase||helpers.helperMissing).call(depth0,null!=depth0?depth0.id:depth0,{name:"pascalCase",hash:{},data:data}))+" (uri, client) {\n  this._uri    = uri;\n  this._client = client;\n\n"+(null!=(stack1=helpers.each.call(depth0,null!=depth0?depth0.children:depth0,{name:"each",hash:{},fn:this.program(2,data,0,blockParams,depths),inverse:this.noop,data:data}))?stack1:"")+"};\n\n"+(null!=(stack1=helpers.each.call(depth0,null!=depth0?depth0.children:depth0,{name:"each",hash:{},fn:this.program(5,data,0,blockParams,depths),inverse:this.noop,data:data}))?stack1:"")+"\n"+(null!=(stack1=helpers.each.call(depth0,null!=depth0?depth0.methods:depth0,{name:"each",hash:{},fn:this.program(8,data,0,blockParams,depths),inverse:this.noop,data:data}))?stack1:"")},2:function(depth0,helpers,partials,data){var stack1;return null!=(stack1=helpers.unless.call(depth0,null!=depth0?depth0.uriParameters:depth0,{name:"unless",hash:{},fn:this.program(3,data,0),inverse:this.noop,data:data}))?stack1:""},3:function(depth0,helpers,partials,data){var stack1,helper,alias1=helpers.helperMissing,alias2=this.escapeExpression;return"  this."+alias2((helper=null!=(helper=helpers.key||data&&data.key)?helper:alias1,"function"==typeof helper?helper.call(depth0,{name:"key",hash:{},data:data}):helper))+" = new "+alias2((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=depth0?depth0.id:depth0,{name:"pascalCase",hash:{},data:data}))+"(uri + "+(null!=(stack1=(helpers.stringify||depth0&&depth0.stringify||alias1).call(depth0,null!=depth0?depth0.relativeUri:depth0,{name:"stringify",hash:{},data:data}))?stack1:"")+", client);\n"},5:function(depth0,helpers,partials,data,blockParams,depths){var stack1;return null!=(stack1=helpers["if"].call(depth0,null!=depth0?depth0.uriParameters:depth0,{name:"if",hash:{},fn:this.program(6,data,0,blockParams,depths),inverse:this.noop,data:data}))?stack1:""},6:function(depth0,helpers,partials,data,blockParams,depths){var stack1,helper,alias1=helpers.helperMissing,alias2=this.escapeExpression;return alias2((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=depths[2]?depths[2].id:depths[2],{name:"pascalCase",hash:{},data:data}))+".prototype."+alias2((helper=null!=(helper=helpers.key||data&&data.key)?helper:alias1,"function"==typeof helper?helper.call(depth0,{name:"key",hash:{},data:data}):helper))+" = function (/* ...args */) {\n  var uri = this._uri + template("+(null!=(stack1=(helpers.stringify||depth0&&depth0.stringify||alias1).call(depth0,null!=depth0?depth0.relativeUri:depth0,{name:"stringify",hash:{},data:data}))?stack1:"")+", arguments, "+(null!=(stack1=(helpers.stringify||depth0&&depth0.stringify||alias1).call(depth0,(helpers.pluck||depth0&&depth0.pluck||alias1).call(depth0,null!=depth0?depth0.uriParameters:depth0,"default",{name:"pluck",hash:{},data:data}),{name:"stringify",hash:{},data:data}))?stack1:"")+");\n\n  return new "+alias2((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=depth0?depth0.id:depth0,{name:"pascalCase",hash:{},data:data}))+"(uri, this._client);\n};\n"},8:function(depth0,helpers,partials,data,blockParams,depths){var stack1,helper,alias1=helpers.helperMissing,alias2=this.escapeExpression;return alias2((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=depths[1]?depths[1].id:depths[1],{name:"pascalCase",hash:{},data:data}))+".prototype."+alias2((helper=null!=(helper=helpers.key||data&&data.key)?helper:alias1,"function"==typeof helper?helper.call(depth0,{name:"key",hash:{},data:data}):helper))+" = function (body, options) {\n"+(null!=(stack1=helpers["if"].call(depth0,(helpers.keys||depth0&&depth0.keys||alias1).call(depth0,null!=depth0?depth0.headers:depth0,{name:"keys",hash:{},data:data}),{name:"if",hash:{},fn:this.program(9,data,0,blockParams,depths),inverse:this.noop,data:data}))?stack1:"")+"  return handleRequest(this._client, this._uri, "+(null!=(stack1=(helpers.stringify||depth0&&depth0.stringify||alias1).call(depth0,(helpers.upperCase||depth0&&depth0.upperCase||alias1).call(depth0,null!=depth0?depth0.method:depth0,{name:"upperCase",hash:{},data:data}),{name:"stringify",hash:{},data:data}))?stack1:"")+", body, options);\n};\n"},9:function(depth0,helpers,partials,data){var stack1,alias1=helpers.helperMissing;return"  options = extend({}, options);\n  options.headers = extend("+(null!=(stack1=(helpers.stringify||depth0&&depth0.stringify||alias1).call(depth0,(helpers.object||depth0&&depth0.object||alias1).call(depth0,(helpers.keys||depth0&&depth0.keys||alias1).call(depth0,null!=depth0?depth0.headers:depth0,{name:"keys",hash:{},data:data}),(helpers.pluck||depth0&&depth0.pluck||alias1).call(depth0,null!=depth0?depth0.headers:depth0,"default",{name:"pluck",hash:{},data:data}),{name:"object",hash:{},data:data}),{name:"stringify",hash:{},data:data}))?stack1:"")+", options.headers);\n\n"},11:function(depth0,helpers,partials,data){var stack1,alias1=helpers.helperMissing;return"CustomResource.prototype."+this.escapeExpression((helpers.camelCase||depth0&&depth0.camelCase||alias1).call(depth0,depth0,{name:"camelCase",hash:{},data:data}))+" = function (body, options) {\n  return handleRequest(this._client, this._uri, "+(null!=(stack1=(helpers.stringify||depth0&&depth0.stringify||alias1).call(depth0,(helpers.upperCase||depth0&&depth0.upperCase||alias1).call(depth0,depth0,{name:"upperCase",hash:{},data:data}),{name:"stringify",hash:{},data:data}))?stack1:"")+", body, options);\n};\n"},compiler:[6,">= 2.0.0-beta.1"],main:function(depth0,helpers,partials,data,blockParams,depths){var stack1;return"function handleRequest (client, path, method, body, options) {\n  options = extend({}, client.options, options);\n\n  var baseUri = template(options.baseUri, options.baseUriParameters);\n  var hasBody = method !== 'GET' && method !== 'HEAD';\n  var reqOpts = {};\n\n  var reqBody = hasBody && body != null ? body : options.body;\n  var reqQuery = !hasBody && body != null ? body : options.query;\n\n  var reqOpts = {\n    url: baseUri.replace(/\\/$/, '') + path,\n    method: method,\n    headers: extend({}, options.headers),\n    body: reqBody,\n    query: typeof reqQuery === 'object' ? extend({}, reqQuery) : reqQuery\n  };\n\n  if (options.user && typeof options.user.sign === 'function') {\n    options.user.sign(reqOpts);\n  }\n\n  return client.request(reqOpts);\n}\n\n"+(null!=(stack1=helpers.each.call(depth0,null!=depth0?depth0.allResources:depth0,{name:"each",hash:{},fn:this.program(1,data,0,blockParams,depths),inverse:this.noop,data:data}))?stack1:"")+"\nfunction CustomResource (uri, client) {\n  this._uri    = uri;\n  this._client = client;\n}\n\n"+(null!=(stack1=helpers.each.call(depth0,null!=depth0?depth0.supportedMethods:depth0,{name:"each",hash:{},fn:this.program(11,data,0,blockParams,depths),inverse:this.noop,data:data}))?stack1:"")},useData:!0,useDepths:!0})},{"hbsfy/runtime":41}],8:[function(require,module,exports){var HandlebarsCompiler=require("hbsfy/runtime");module.exports=HandlebarsCompiler.template({compiler:[6,">= 2.0.0-beta.1"],main:function(depth0,helpers,partials,data){return"var TEMPLATE_REGEXP = /\\{([^\\{\\}]+)\\}/g;\n\n/**\n * @param  {String} string\n * @param  {Object} interpolate\n * @param  {Object} defaults\n * @return {String}\n */\nfunction template (string, interpolate, defaults) {\n  defaults    = defaults || {};\n  interpolate = interpolate || {};\n\n  return string.replace(TEMPLATE_REGEXP, function (match, key) {\n    if (interpolate[key] != null) {\n      return encodeURIComponent(interpolate[key]);\n    }\n\n    if (defaults[key] != null) {\n      return encodeURIComponent(defaults[key]);\n    }\n\n    return '';\n  });\n}\n\n/**\n * @param  {Object} dest\n * @param  {Object} ...source\n * @return {Object}\n */\nfunction extend (dest /*, ...source */) {\n  for (var i = 1; i < arguments.length; i++) {\n    for (var key in arguments[i]) {\n      dest[key] = arguments[i][key];\n    }\n  }\n\n  return dest;\n}\n"},useData:!0})},{"hbsfy/runtime":41}],9:[function(require,module,exports){var HandlebarsCompiler=require("hbsfy/runtime");module.exports=HandlebarsCompiler.template({compiler:[6,">= 2.0.0-beta.1"],main:function(depth0,helpers,partials,data){return"node_modules\n"},useData:!0})},{"hbsfy/runtime":41}],10:[function(require,module,exports){var HandlebarsCompiler=require("hbsfy/runtime");module.exports=HandlebarsCompiler.template({compiler:[6,">= 2.0.0-beta.1"],main:function(depth0,helpers,partials,data){var alias1=helpers.helperMissing,alias2=this.escapeExpression;return'# Installation\n\nFollow these instructions to publish and subsequently install the module in your project.\n\n## Git\n\n```\n# Initialize with git\ngit init\ngit add .\ngit commit -m "initial commit"\ngit push [git-url]\n\n# Install in project from git\nnpm install [git-url] --save\n```\n\n## Source Directory\n\n```\n# Link module globally\nnpm link\n\n# Link in project to local module\nnpm link '+alias2((helpers.paramCase||depth0&&depth0.paramCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"paramCase",hash:{},data:data}))+"\n```\n\n**Note:** You should publish it before you use it publicly.\n\n## NPM\n\n```\n# Publish to npm\nnpm publish\n\n# Install from npm\nnpm install "+alias2((helpers.paramCase||depth0&&depth0.paramCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"paramCase",hash:{},data:data}))+" --save\n```\n\n## Bower\n\n```\n# Register with bower\nbower register "+alias2((helpers.paramCase||depth0&&depth0.paramCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"paramCase",hash:{},data:data}))+" [git-url]\n\n# Install from bower\nbower install "+alias2((helpers.paramCase||depth0&&depth0.paramCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"paramCase",hash:{},data:data}))+" --save\n```\n"},useData:!0})},{"hbsfy/runtime":41}],11:[function(require,module,exports){var HandlebarsCompiler=require("hbsfy/runtime");module.exports=HandlebarsCompiler.template({1:function(depth0,helpers,partials,data){var stack1,alias1=helpers.helperMissing,alias2=this.escapeExpression;return"### Authentication\n\n#### OAuth 2.0\n\nThis API supports authentication with [OAuth 2.0](https://github.com/mulesoft/js-client-oauth2). Initialize the `OAuth2` instance with the application client id, client secret and a redirect uri to authenticate with users.\n\n```js\nvar auth = new "+alias2((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"pascalCase",hash:{},data:data}))+".OAuth2({\n  clientId:     '123',\n  clientSecret: 'abc',\n  redirectUri:  'http://example.com/auth/callback'\n});\n```\n\n**All `getToken()` calls are asynchronous and return promise objects which resolve to an access token instance.**\n\n"+(null!=(stack1=helpers["if"].call(depth0,(helpers.contains||depth0&&depth0.contains||alias1).call(depth0,null!=(stack1=null!=(stack1=null!=(stack1=null!=depth0?depth0.security:depth0)?stack1["OAuth 2.0"]:stack1)?stack1.settings:stack1)?stack1.authorizationGrants:stack1,"code",{name:"contains",hash:{},data:data}),{name:"if",hash:{},fn:this.program(2,data,0),inverse:this.noop,data:data}))?stack1:"")+(null!=(stack1=helpers["if"].call(depth0,(helpers.contains||depth0&&depth0.contains||alias1).call(depth0,null!=(stack1=null!=(stack1=null!=(stack1=null!=depth0?depth0.security:depth0)?stack1["OAuth 2.0"]:stack1)?stack1.settings:stack1)?stack1.authorizationGrants:stack1,"token",{name:"contains",hash:{},data:data}),{name:"if",hash:{},fn:this.program(4,data,0),inverse:this.noop,data:data}))?stack1:"")+(null!=(stack1=helpers["if"].call(depth0,(helpers.contains||depth0&&depth0.contains||alias1).call(depth0,null!=(stack1=null!=(stack1=null!=(stack1=null!=depth0?depth0.security:depth0)?stack1["OAuth 2.0"]:stack1)?stack1.settings:stack1)?stack1.authorizationGrants:stack1,"owner",{name:"contains",hash:{},data:data}),{name:"if",hash:{},fn:this.program(6,data,0),inverse:this.noop,data:data}))?stack1:"")+(null!=(stack1=helpers["if"].call(depth0,(helpers.contains||depth0&&depth0.contains||alias1).call(depth0,null!=(stack1=null!=(stack1=null!=(stack1=null!=depth0?depth0.security:depth0)?stack1["OAuth 2.0"]:stack1)?stack1.settings:stack1)?stack1.authorizationGrants:stack1,"credentials",{name:"contains",hash:{},data:data}),{name:"if",hash:{},fn:this.program(8,data,0),inverse:this.noop,data:data}))?stack1:"")+"##### Access Tokens\n\nAccess token instances can be manually re-created. This is critical for access token reuse, such as saving credentials to a database for reusing later in the codebase.\n\n```js\nvar token = auth.createToken('access token', 'refresh token');\n```\n\nAn access token instance (manually created or automatically generated by a `getToken()` method) can be passed into any API request. This will sign the API request with the current users access token credentials.\n\n```js\n// Existing API client instance.\nclient.resource('/').get(null, {\n  user: token\n});\n\n// New API client instance.\nvar client = new "+alias2((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"pascalCase",hash:{},data:data}))+"({\n  user: token\n});\n```\n\n"},2:function(depth0,helpers,partials,data){return"##### [Authorization Code Grant](https://github.com/mulesoft/js-client-oauth2#authorization-code-grant)\n\n1. Redirect user to `auth.code.getUri()`.\n2. Parse response uri and get an access token instance using `auth.code.getToken(uri)`.\n\n"},4:function(depth0,helpers,partials,data){return"\n##### [Implicit Grant](https://github.com/mulesoft/js-client-oauth2#implicit-grant)\n\n1. Redirect user to `auth.token.getUri()` in a browser.\n2. Parse response uri and get an access token instance using `auth.token.getToken(uri)`.\n\n"},6:function(depth0,helpers,partials,data){return"\n##### [Resource Owner Password Credentials Grant](https://github.com/mulesoft/js-client-oauth2#resource-owner-password-credentials-grant)\n\n1. Make a direct request for the access token on behalf of the user using `auth.owner.getToken(username, password)`.\n\n"},8:function(depth0,helpers,partials,data){return"\n##### [Client Credentials Grant](https://github.com/mulesoft/js-client-oauth2#client-credentials-grant)\n\n1. Get the access token for the application by using `auth.credentials.getToken()`.\n\n"},10:function(depth0,helpers,partials,data){var helper;return this.escapeExpression((helper=null!=(helper=helpers.version||(null!=depth0?depth0.version:depth0))?helper:helpers.helperMissing,"function"==typeof helper?helper.call(depth0,{name:"version",hash:{},data:data}):helper))},12:function(depth0,helpers,partials,data){return"v3"},14:function(depth0,helpers,partials,data){var stack1;return null!=(stack1=helpers["if"].call(depth0,(helpers.keys||depth0&&depth0.keys||helpers.helperMissing).call(depth0,null!=depth0?depth0.methods:depth0,{name:"keys",hash:{},data:data}),{name:"if",hash:{},fn:this.program(15,data,0),inverse:this.noop,data:data}))?stack1:""},15:function(depth0,helpers,partials,data){var stack1,alias1=helpers.helperMissing;return"#### "+(null!=(stack1=(helpers.requestSnippet||depth0&&depth0.requestSnippet||alias1).call(depth0,depth0,{name:"requestSnippet",hash:{},data:data}))?stack1:"")+"\n\n"+(null!=(stack1=helpers["if"].call(depth0,null!=depth0?depth0.uriParameters:depth0,{name:"if",hash:{},fn:this.program(16,data,0),inverse:this.noop,data:data}))?stack1:"")+(null!=(stack1=helpers["if"].call(depth0,null!=depth0?depth0.description:depth0,{name:"if",hash:{},fn:this.program(18,data,0),inverse:this.noop,data:data}))?stack1:"")+"```js\nvar resource = client."+(null!=(stack1=(helpers.requestSnippet||depth0&&depth0.requestSnippet||alias1).call(depth0,depth0,{name:"requestSnippet",hash:{},data:data}))?stack1:"")+";\n```\n\n"+(null!=(stack1=helpers.each.call(depth0,null!=depth0?depth0.methods:depth0,{name:"each",hash:{},fn:this.program(20,data,0),inverse:this.noop,data:data}))?stack1:"")},16:function(depth0,helpers,partials,data){var stack1;return(null!=(stack1=(helpers.parametersSnippet||depth0&&depth0.parametersSnippet||helpers.helperMissing).call(depth0,null!=depth0?depth0.uriParameters:depth0,{name:"parametersSnippet",hash:{},data:data}))?stack1:"")+"\n\n"},18:function(depth0,helpers,partials,data){var stack1,helper;return(null!=(helper=null!=(helper=helpers.description||(null!=depth0?depth0.description:depth0))?helper:helpers.helperMissing,stack1="function"==typeof helper?helper.call(depth0,{name:"description",hash:{},data:data}):helper)?stack1:"")+"\n\n"},20:function(depth0,helpers,partials,data){var stack1,helper,alias1=helpers.helperMissing,alias2=this.escapeExpression;return"##### "+alias2((helpers.upperCase||depth0&&depth0.upperCase||alias1).call(depth0,null!=depth0?depth0.method:depth0,{name:"upperCase",hash:{},data:data}))+"\n\n"+(null!=(stack1=helpers["if"].call(depth0,null!=depth0?depth0.description:depth0,{name:"if",hash:{},fn:this.program(18,data,0),inverse:this.noop,data:data}))?stack1:"")+"```js\nresource."+alias2((helper=null!=(helper=helpers.key||(null!=depth0?depth0.key:depth0))?helper:alias1,"function"==typeof helper?helper.call(depth0,{name:"key",hash:{},data:data}):helper))+"().then(function (res) { ... });\n```\n\n"+(null!=(stack1=helpers["if"].call(depth0,(helpers.keys||depth0&&depth0.keys||alias1).call(depth0,null!=depth0?depth0.queryParameters:depth0,{name:"keys",hash:{},data:data}),{name:"if",hash:{},fn:this.program(21,data,0),inverse:this.noop,data:data}))?stack1:"")+(null!=(stack1=helpers["if"].call(depth0,(helpers.keys||depth0&&depth0.keys||alias1).call(depth0,null!=depth0?depth0.headers:depth0,{name:"keys",hash:{},data:data}),{name:"if",hash:{},fn:this.program(26,data,0),inverse:this.noop,data:data}))?stack1:"")+(null!=(stack1=helpers["if"].call(depth0,(helpers.keys||depth0&&depth0.keys||alias1).call(depth0,null!=depth0?depth0.body:depth0,{name:"keys",hash:{},data:data}),{name:"if",hash:{},fn:this.program(28,data,0),inverse:this.noop,data:data}))?stack1:"")},21:function(depth0,helpers,partials,data){var stack1,alias1=helpers.helperMissing;return"##### Query Parameters\n\n```javascript\n"+(null!=(stack1=helpers["if"].call(depth0,(helpers.equal||depth0&&depth0.equal||alias1).call(depth0,null!=depth0?depth0.method:depth0,"get",{name:"equal",hash:{},data:data}),{name:"if",hash:{},fn:this.program(22,data,0),inverse:this.program(24,data,0),data:data}))?stack1:"")+"```\n\n"+(null!=(stack1=(helpers.parametersSnippet||depth0&&depth0.parametersSnippet||alias1).call(depth0,null!=depth0?depth0.queryParameters:depth0,{name:"parametersSnippet",hash:{},data:data}))?stack1:"")+"\n\n"},22:function(depth0,helpers,partials,data){var helper;return"resource."+this.escapeExpression((helper=null!=(helper=helpers.key||(null!=depth0?depth0.key:depth0))?helper:helpers.helperMissing,"function"==typeof helper?helper.call(depth0,{name:"key",hash:{},data:data}):helper))+"({ ... });\n"},24:function(depth0,helpers,partials,data){var helper;return"resource."+this.escapeExpression((helper=null!=(helper=helpers.key||(null!=depth0?depth0.key:depth0))?helper:helpers.helperMissing,"function"==typeof helper?helper.call(depth0,{name:"key",hash:{},data:data}):helper))+"(null, { query: { ... } });\n"},26:function(depth0,helpers,partials,data){var stack1,helper,alias1=helpers.helperMissing;return"##### Headers\n\n```javascript\nresource."+this.escapeExpression((helper=null!=(helper=helpers.key||(null!=depth0?depth0.key:depth0))?helper:alias1,"function"==typeof helper?helper.call(depth0,{name:"key",hash:{},data:data}):helper))+"(null, {\n  headers: { ... }\n});\n```\n\n"+(null!=(stack1=(helpers.parametersSnippet||depth0&&depth0.parametersSnippet||alias1).call(depth0,null!=depth0?depth0.headers:depth0,{name:"parametersSnippet",hash:{},data:data}))?stack1:"")+"\n\n"},28:function(depth0,helpers,partials,data){var stack1;return"##### Body\n\n"+(null!=(stack1=helpers.each.call(depth0,null!=depth0?depth0.body:depth0,{name:"each",hash:{},fn:this.program(29,data,0),inverse:this.noop,data:data}))?stack1:"")},29:function(depth0,helpers,partials,data){var stack1,helper;return"**"+this.escapeExpression((helper=null!=(helper=helpers.key||data&&data.key)?helper:helpers.helperMissing,"function"==typeof helper?helper.call(depth0,{name:"key",hash:{},data:data}):helper))+"**\n\n"+(null!=(stack1=helpers["if"].call(depth0,null!=depth0?depth0.schema:depth0,{name:"if",hash:{},fn:this.program(30,data,0),inverse:this.noop,data:data}))?stack1:"")+(null!=(stack1=helpers["if"].call(depth0,null!=depth0?depth0.formParameters:depth0,{name:"if",hash:{},fn:this.program(32,data,0),inverse:this.noop,data:data}))?stack1:"")},30:function(depth0,helpers,partials,data){var stack1,helper;return"```\n"+(null!=(helper=null!=(helper=helpers.schema||(null!=depth0?depth0.schema:depth0))?helper:helpers.helperMissing,stack1="function"==typeof helper?helper.call(depth0,{name:"schema",hash:{},data:data}):helper)?stack1:"")+"\n```\n\n"},32:function(depth0,helpers,partials,data){var stack1;return(null!=(stack1=(helpers.json||depth0&&depth0.json||helpers.helperMissing).call(depth0,null!=depth0?depth0.formParameters:depth0,2,{name:"json",hash:{},data:data}))?stack1:"")+"\n\n"},compiler:[6,">= 2.0.0-beta.1"],main:function(depth0,helpers,partials,data){var stack1,helper,alias1=helpers.helperMissing,alias2="function",alias3=this.escapeExpression;return"# "+alias3((helper=null!=(helper=helpers.title||(null!=depth0?depth0.title:depth0))?helper:alias1,typeof helper===alias2?helper.call(depth0,{name:"title",hash:{},data:data}):helper))+"\n\nBrowser and node module for making API requests against ["+alias3((helper=null!=(helper=helpers.title||(null!=depth0?depth0.title:depth0))?helper:alias1,typeof helper===alias2?helper.call(depth0,{name:"title",hash:{},data:data}):helper))+"]("+alias3((helper=null!=(helper=helpers.baseUri||(null!=depth0?depth0.baseUri:depth0))?helper:alias1,typeof helper===alias2?helper.call(depth0,{name:"baseUri",hash:{},data:data}):helper))+").\n\n**Please note: This module uses [Popsicle](https://github.com/blakeembrey/popsicle) to make API requests. Promises must be supported or polyfilled on all target environments.**\n\n## Installation\n\n```\nnpm install "+alias3((helpers.paramCase||depth0&&depth0.paramCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"paramCase",hash:{},data:data}))+" --save\nbower install "+alias3((helpers.paramCase||depth0&&depth0.paramCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"paramCase",hash:{},data:data}))+" --save\n```\n\n## Usage\n\n### Node\n\n```javascript\nvar "+alias3((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"pascalCase",hash:{},data:data}))+" = require('"+alias3((helpers.paramCase||depth0&&depth0.paramCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"paramCase",hash:{},data:data}))+"');\n\nvar client = new "+alias3((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"pascalCase",hash:{},data:data}))+'();\n```\n\n### Browsers\n\n```html\n<script src="'+alias3((helpers.paramCase||depth0&&depth0.paramCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"paramCase",hash:{},data:data}))+'/index.js">\n\n<script>\n  var client = new window.'+alias3((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"pascalCase",hash:{},data:data}))+"();\n</script>\n```\n\n"+(null!=(stack1=helpers["if"].call(depth0,null!=(stack1=null!=depth0?depth0.security:depth0)?stack1["OAuth 2.0"]:stack1,{name:"if",hash:{},fn:this.program(1,data,0),inverse:this.noop,data:data}))?stack1:"")+"### Options\n\nYou can set options when you initialize a client or at any time with the `options` property. You may also override options for a single request by passing an object as the second argument of any request method. For example:\n\n```javascript\nvar client = new "+alias3((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"pascalCase",hash:{},data:data}))+"({ ... });\n\nclient.options = { ... };\n\nclient.resource('/').get(null, {\n  baseUri: 'http://example.com',\n  headers: {\n    'Content-Type': 'application/json'\n  }\n});\n```\n\n#### Base URI\n\nYou can override the base URI by setting the `baseUri` property, or initializing a client with a base URI. For example:\n\n```javascript\nnew "+alias3((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"pascalCase",hash:{},data:data}))+"({\n  baseUri: 'https://example.com'\n});\n```\n\n#### Base URI Parameters\n\nIf the base URI has parameters inline, you can set them by updating the `baseUriParameters` property. For example:\n\n```javascript\nclient.options.baseUriParameters.version = '"+(null!=(stack1=helpers["if"].call(depth0,null!=depth0?depth0.version:depth0,{name:"if",hash:{},fn:this.program(10,data,0),inverse:this.program(12,data,0),data:data}))?stack1:"")+"';\n```\n\n### Resources\n\nAll methods return a HTTP request instance of [Popsicle](https://github.com/blakeembrey/popsicle), which allows the use of promises (and streaming in node).\n\n"+(null!=(stack1=helpers.each.call(depth0,null!=depth0?depth0.allResources:depth0,{name:"each",hash:{},fn:this.program(14,data,0),inverse:this.noop,data:data}))?stack1:"")+"\n\n### Custom Resources\n\nYou can make requests to a custom path in the API using the `#resource(path)` method.\n\n```javascript\nclient.resource('/example/path').get();\n```\n\n## License\n\nApache 2.0\n";
},useData:!0})},{"hbsfy/runtime":41}],12:[function(require,module,exports){var HandlebarsCompiler=require("hbsfy/runtime");module.exports=HandlebarsCompiler.template({1:function(depth0,helpers,partials,data){var stack1;return(null!=(stack1=this.invokePartial(partials.utils,depth0,{name:"utils",data:data,helpers:helpers,partials:partials}))?stack1:"")+"\n"+(null!=(stack1=this.invokePartial(partials.resources,depth0,{name:"resources",data:data,helpers:helpers,partials:partials}))?stack1:"")+"\n"+(null!=(stack1=this.invokePartial(partials.client,depth0,{name:"client",data:data,helpers:helpers,partials:partials}))?stack1:"")+"\n"+(null!=(stack1=this.invokePartial(partials.auth,depth0,{name:"auth",data:data,helpers:helpers,partials:partials}))?stack1:"")+"\nreturn Client;\n"},compiler:[6,">= 2.0.0-beta.1"],main:function(depth0,helpers,partials,data){var stack1,alias1=helpers.helperMissing;return"(function (root, client) {\n  if (typeof define === 'function' && define.amd) {\n    // AMD. Register as an anonymous module.\n    define("+(null!=(stack1=(helpers.dependencies||depth0&&depth0.dependencies||alias1).call(depth0,depth0,"amd",{name:"dependencies",hash:{},data:data}))?stack1:"")+", client);\n  } else if (typeof exports === 'object') {\n    // Node. Does not work with strict CommonJS, but only CommonJS-like\n    // environments that support `module.exports`, like Node.\n    module.exports = client("+(null!=(stack1=(helpers.dependencies||depth0&&depth0.dependencies||alias1).call(depth0,depth0,"node",{name:"dependencies",hash:{},data:data}))?stack1:"")+");\n  } else {\n    // Browser globals (root is window).\n    root."+this.escapeExpression((helpers.pascalCase||depth0&&depth0.pascalCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"pascalCase",hash:{},data:data}))+" = client("+(null!=(stack1=(helpers.dependencies||depth0&&depth0.dependencies||alias1).call(depth0,depth0,"browser",{name:"dependencies",hash:{},data:data}))?stack1:"")+");\n  }\n})(this, function ("+(null!=(stack1=(helpers.dependencies||depth0&&depth0.dependencies||alias1).call(depth0,depth0,!1,{name:"dependencies",hash:{},data:data}))?stack1:"")+") {\n"+(null!=(stack1=(helpers.indent||depth0&&depth0.indent||alias1).call(depth0,2,{name:"indent",hash:{},fn:this.program(1,data,0),inverse:this.noop,data:data}))?stack1:"")+"});\n"},usePartial:!0,useData:!0})},{"hbsfy/runtime":41}],13:[function(require,module,exports){var HandlebarsCompiler=require("hbsfy/runtime");module.exports=HandlebarsCompiler.template({1:function(depth0,helpers,partials,data){return'"client-oauth2": "^0.1.0",\n    '},compiler:[6,">= 2.0.0-beta.1"],main:function(depth0,helpers,partials,data){var stack1,helper,alias1=helpers.helperMissing,alias2=this.escapeExpression;return'{\n  "name": "'+alias2((helpers.paramCase||depth0&&depth0.paramCase||alias1).call(depth0,null!=depth0?depth0.title:depth0,{name:"paramCase",hash:{},data:data}))+'",\n  "version": "0.0.0",\n  "description": "'+alias2((helper=null!=(helper=helpers.description||(null!=depth0?depth0.description:depth0))?helper:alias1,"function"==typeof helper?helper.call(depth0,{name:"description",hash:{},data:data}):helper))+'",\n  "main": "index.js",\n  "files": [\n    "index.js"\n  ],\n  "repository": {\n    "type": "git",\n    "url": "git://github.com/mulesoft/raml-client-generator.git"\n  },\n  "keywords": [\n    "raml-api"\n  ],\n  "author": "MuleSoft, Inc.",\n  "license": "Apache 2.0",\n  "bugs": {\n    "url": "https://github.com/mulesoft/raml-client-generator/issues"\n  },\n  "homepage": "https://github.com/mulesoft/raml-client-generator",\n  "dependencies": {\n    '+(null!=(stack1=helpers["if"].call(depth0,null!=(stack1=null!=depth0?depth0.security:depth0)?stack1["OAuth 2.0"]:stack1,{name:"if",hash:{},fn:this.program(1,data,0),inverse:this.noop,data:data}))?stack1:"")+'"popsicle": "^0.3.6"\n  }\n}\n'},useData:!0})},{"hbsfy/runtime":41}],14:[function(require,module,exports){var PARAM_IDS,extend=require("extend"),sanitizeUri=require("./uri"),sanitizeSecurity=require("./security"),sanitizeResources=require("./resources"),sanitizeParameters=require("./parameters"),DEFAULT_FORMAT={uri:function(uri){return uri},variable:function(){throw new Error("No variable format specified")},uniqueId:function(prefix){var id=++PARAM_IDS[prefix]||(PARAM_IDS[prefix]=0);return prefix+id}},validateSpec=function(spec){return PARAM_IDS={},spec.format=extend({},DEFAULT_FORMAT,spec.format),extend({},spec)},flattenResources=function(resources){var array=[];return function recurse(resource){array.push(resource),Object.keys(resource.children).forEach(function(key){recurse(resource.children[key])})}(resources),array},flattenMethods=function(resources){var array=[];return function recurse(resource){resource.methods&&Object.keys(resource.methods).forEach(function(key){array.push(resource.methods[key])}),Object.keys(resource.children).forEach(function(key){recurse(resource.children[key])})}(resources),array};module.exports=function(ast,spec){spec=validateSpec(spec);var context={id:spec.format.uniqueId("client"),title:ast.title||"API Client",version:ast.version,baseUri:sanitizeUri(ast.baseUri,spec),security:sanitizeSecurity(ast.securitySchemes,spec),resources:sanitizeResources(ast.resources,spec),baseUriParameters:sanitizeParameters(ast.baseUriParameters,spec)};return context.allMethods=flattenMethods(context.resources),context.allResources=flattenResources(context.resources),context.supportedMethods=require("methods"),context}},{"./parameters":16,"./resources":17,"./security":18,"./uri":19,extend:33,methods:47}],15:[function(require,module,exports){var pick=require("object.pick"),sanitizeParameters=require("./parameters"),sanitizeMethod=function(method,resource,spec){var obj=pick(method,["method","protocols","responses","body","headers"]);return obj.id=spec.format.uniqueId("method"),obj.resource=resource,obj.queryParameters=sanitizeParameters(method.queryParameters),obj.description=(method.description||"").trim(),obj};module.exports=function(methods,resource,spec){var obj={};return methods?(methods.forEach(function(method){var key=spec.format.variable(method.method),sanitizedMethod=sanitizeMethod(method,resource,spec);obj[key]=sanitizedMethod,sanitizedMethod.key=key}),obj):obj}},{"./parameters":16,"object.pick":48}],16:[function(require,module,exports){var pick=require("object.pick"),sanitizeParameter=function(parameter){var obj=pick(parameter,["displayName","type","enum","pattern","minLength","maxLength","minimum","maximum","example","repeat","required","default"]);return obj.description=(parameter.description||"").trim(),null==obj["default"]&&Array.isArray(obj["enum"])&&(obj["default"]=obj["enum"][0]),obj};module.exports=function(parameters){var obj={};return parameters?(Object.keys(parameters).forEach(function(key){obj[key]=sanitizeParameter(parameters[key])}),obj):obj}},{"object.pick":48}],17:[function(require,module,exports){var sanitizeUri=require("./uri"),sanitizeMethods=require("./methods"),sanitizeParameters=require("./parameters"),TEMPLATE_REGEXP=/\{[^\{\}]+\}/g,toPropertyFormat=function(uri,spec){return uri=uri.replace(/^[\.\/]/,""),/^\{[^\{\}]+\}$/.test(uri)?spec.format.variable(uri.slice(1,-1)):/^[^\{\}]+(?:\{[^\{\}]+\})*$/.test(uri)?spec.format.variable(uri.replace(/\{.+\}$/,"")):void 0},toUriFormat=function(uri,spec){var index=0,indexedUri=uri.replace(/\{[^\{\}]+\}/g,function(){return"{"+index++ +"}"});return sanitizeUri(indexedUri,spec)},attachResource=function(obj,resource,spec){var uriParts=resource.relativeUri.split(/(?=\.|\/|\{mediaTypeExtension\}$)/),parameters=sanitizeParameters(resource.uriParameters),getParamTag=function(param){return parameters[param.slice(1,-1)]};!function recurse(obj,parts){var part=parts[0];if("{mediaTypeExtension}"===part&&1===parts.length&&(Array.isArray(parameters.mediaTypeExtension["enum"])&&parameters.mediaTypeExtension["enum"].forEach(function(extension){return extension="."+extension.replace(/^\./,""),recurse(obj,[extension])}),delete parameters.mediaTypeExtension["enum"],part=".{mediaTypeExtension}"),"/"!==part){var key=toPropertyFormat(part,spec);if(!key||obj.children.hasOwnProperty(key)){if(part!==obj.children[key].relativeUri)return;obj=obj.children[key]}else{var matches=part.match(TEMPLATE_REGEXP)||[],uriParameters=Array.prototype.map.call(matches,getParamTag);obj=obj.children[key]={id:spec.format.uniqueId("resource"),key:key,parent:obj,children:{},relativeUri:toUriFormat(part,spec),uriParameters:uriParameters}}}return parts.length>1?recurse(obj,parts.slice(1)):(obj.methods=sanitizeMethods(resource.methods,obj,spec),obj.description=(resource.description||"").trim(),resource.resources&&resource.resources.forEach(function(resource){attachResource(obj,resource,spec)}),obj)}(obj,uriParts)};module.exports=function(resources,spec){var obj={id:spec.format.uniqueId("resource"),children:{},relativeUri:"",uriParameters:[]};return resources?(resources.forEach(function(resource){return attachResource(obj,resource,spec)}),obj):obj}},{"./methods":15,"./parameters":16,"./uri":19}],18:[function(require,module,exports){module.exports=function(securitySchemes){var obj={};return Array.isArray(securitySchemes)?(securitySchemes.forEach(function(schemes){Object.keys(schemes).forEach(function(key){var scheme=schemes[key];obj[scheme.type]=scheme})}),obj):obj}},{}],19:[function(require,module,exports){module.exports=function(uri,spec){return spec.format.uri(uri||"").replace(/\/+$/,"")}},{}],20:[function(require,module,exports){function generate(ast,spec,data){var options={data:data,helpers:extend({},helpers,spec.helpers),partials:extend({},spec.partials)},createFiles=spec.files||generateFiles,context=createContext(ast,spec),files=createFiles(spec.templates,context,options);return{files:files,context:context,options:options}}function generateFiles(templates,context,options){var files={};return Object.keys(templates).forEach(function(key){files[key]=templates[key](context,options)}),files}var extend=require("extend"),helpers=require("./helpers"),createContext=require("./context");require("handlebars"),module.exports=function(spec){return function(ast,options){return generate(ast,spec,options)}}},{"./context":14,"./helpers":21,extend:33,handlebars:22}],21:[function(require,module,exports){var indent=require("indent-string"),trim=String.prototype.trim,hasOwn=Object.prototype.hasOwnProperty;exports.camelCase=require("camel-case"),exports.pascalCase=require("pascal-case"),exports.constantCase=require("constant-case"),exports.paramCase=require("param-case"),exports.lowerCase=require("lower-case"),exports.upperCase=require("upper-case"),exports.snakeCase=require("snake-case"),exports.indent=function(){var args=Array.prototype.slice.call(arguments),opts=args.pop(),input=opts.fn?opts.fn(this):args[0],count=(opts.fn?args[0]:args[1])||2,character=(opts.fn?args[1]:args[2])||" ";return indent(input,character,count)},exports.or=function(){for(var i=0;i<arguments.length-1;i++)if(arguments[i])return!0;return!1},exports.and=function(){for(var i=0;i<arguments.length-1;i++)if(!arguments[i])return!1;return!0},exports.not=function(condition){return!condition},exports.keys=function(obj){var keys=[];for(var prop in obj)hasOwn.call(obj,prop)&&keys.push(prop);return keys},exports.pluck=function(obj,name){return Object.keys(obj).map(function(key){return obj[key]&&obj[key][name]})},exports.object=function(keys,values){for(var obj={},i=0;i<keys.length;i++)obj[keys[i]]=values[i];return obj},exports.contains=function(array,value){return array.indexOf(value)>-1},exports.log=function(){var opts=arguments[arguments.length-1];opts.fn?console.log(opts.fn(this)):console.log.apply(console,Array.prototype.slice.call(arguments,0,-1))},exports.trim=function(){var opts=arguments[arguments.length-1];return arguments.length>1?trim.call(null==arguments[0]?"":arguments[0]):trim.call(opts.fn(this))},exports.equal=function(){for(var args=Array.prototype.slice.call(arguments,0,-1),opts=arguments[arguments.length-1],i=1;i<args.length;i++)if(args[i-1]!==args[i])return opts.fn?opts.inverse(this):!1;return opts.fn?opts.fn(this):!0},exports.json=function(){if(arguments.length>2)return JSON.stringify(arguments[0],null,arguments[1]);if(2===arguments.length)return JSON.stringify(arguments[0]);throw new Error("Unsupported usage of json helper")},exports.join=function(array,value){return Array.isArray(array)?array.join(value):array}},{"camel-case":27,"constant-case":32,"indent-string":42,"lower-case":46,"param-case":53,"pascal-case":55,"snake-case":60,"upper-case":61}],22:[function(require,module,exports){},{}],23:[function(require,module,exports){function Buffer(subject,encoding,noZero){if(!(this instanceof Buffer))return new Buffer(subject,encoding,noZero);var length,type=typeof subject;if("number"===type)length=+subject;else if("string"===type)length=Buffer.byteLength(subject,encoding);else{if("object"!==type||null===subject)throw new TypeError("must start with number, buffer, array or string");"Buffer"===subject.type&&isArray(subject.data)&&(subject=subject.data),length=+subject.length}if(length>kMaxLength)throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x"+kMaxLength.toString(16)+" bytes");0>length?length=0:length>>>=0;var self=this;Buffer.TYPED_ARRAY_SUPPORT?self=Buffer._augment(new Uint8Array(length)):(self.length=length,self._isBuffer=!0);var i;if(Buffer.TYPED_ARRAY_SUPPORT&&"number"==typeof subject.byteLength)self._set(subject);else if(isArrayish(subject))if(Buffer.isBuffer(subject))for(i=0;length>i;i++)self[i]=subject.readUInt8(i);else for(i=0;length>i;i++)self[i]=(subject[i]%256+256)%256;else if("string"===type)self.write(subject,0,encoding);else if("number"===type&&!Buffer.TYPED_ARRAY_SUPPORT&&!noZero)for(i=0;length>i;i++)self[i]=0;return length>0&&length<=Buffer.poolSize&&(self.parent=rootParent),self}function SlowBuffer(subject,encoding,noZero){if(!(this instanceof SlowBuffer))return new SlowBuffer(subject,encoding,noZero);var buf=new Buffer(subject,encoding,noZero);return delete buf.parent,buf}function hexWrite(buf,string,offset,length){offset=Number(offset)||0;var remaining=buf.length-offset;length?(length=Number(length),length>remaining&&(length=remaining)):length=remaining;var strLen=string.length;if(strLen%2!==0)throw new Error("Invalid hex string");length>strLen/2&&(length=strLen/2);for(var i=0;length>i;i++){var byte=parseInt(string.substr(2*i,2),16);if(isNaN(byte))throw new Error("Invalid hex string");buf[offset+i]=byte}return i}function utf8Write(buf,string,offset,length){var charsWritten=blitBuffer(utf8ToBytes(string,buf.length-offset),buf,offset,length);return charsWritten}function asciiWrite(buf,string,offset,length){var charsWritten=blitBuffer(asciiToBytes(string),buf,offset,length);return charsWritten}function binaryWrite(buf,string,offset,length){return asciiWrite(buf,string,offset,length)}function base64Write(buf,string,offset,length){var charsWritten=blitBuffer(base64ToBytes(string),buf,offset,length);return charsWritten}function utf16leWrite(buf,string,offset,length){var charsWritten=blitBuffer(utf16leToBytes(string,buf.length-offset),buf,offset,length);return charsWritten}function base64Slice(buf,start,end){return 0===start&&end===buf.length?base64.fromByteArray(buf):base64.fromByteArray(buf.slice(start,end))}function utf8Slice(buf,start,end){var res="",tmp="";end=Math.min(buf.length,end);for(var i=start;end>i;i++)buf[i]<=127?(res+=decodeUtf8Char(tmp)+String.fromCharCode(buf[i]),tmp=""):tmp+="%"+buf[i].toString(16);return res+decodeUtf8Char(tmp)}function asciiSlice(buf,start,end){var ret="";end=Math.min(buf.length,end);for(var i=start;end>i;i++)ret+=String.fromCharCode(127&buf[i]);return ret}function binarySlice(buf,start,end){var ret="";end=Math.min(buf.length,end);for(var i=start;end>i;i++)ret+=String.fromCharCode(buf[i]);return ret}function hexSlice(buf,start,end){var len=buf.length;(!start||0>start)&&(start=0),(!end||0>end||end>len)&&(end=len);for(var out="",i=start;end>i;i++)out+=toHex(buf[i]);return out}function utf16leSlice(buf,start,end){for(var bytes=buf.slice(start,end),res="",i=0;i<bytes.length;i+=2)res+=String.fromCharCode(bytes[i]+256*bytes[i+1]);return res}function checkOffset(offset,ext,length){if(offset%1!==0||0>offset)throw new RangeError("offset is not uint");if(offset+ext>length)throw new RangeError("Trying to access beyond buffer length")}function checkInt(buf,value,offset,ext,max,min){if(!Buffer.isBuffer(buf))throw new TypeError("buffer must be a Buffer instance");if(value>max||min>value)throw new RangeError("value is out of bounds");if(offset+ext>buf.length)throw new RangeError("index out of range")}function objectWriteUInt16(buf,value,offset,littleEndian){0>value&&(value=65535+value+1);for(var i=0,j=Math.min(buf.length-offset,2);j>i;i++)buf[offset+i]=(value&255<<8*(littleEndian?i:1-i))>>>8*(littleEndian?i:1-i)}function objectWriteUInt32(buf,value,offset,littleEndian){0>value&&(value=4294967295+value+1);for(var i=0,j=Math.min(buf.length-offset,4);j>i;i++)buf[offset+i]=value>>>8*(littleEndian?i:3-i)&255}function checkIEEE754(buf,value,offset,ext,max,min){if(value>max||min>value)throw new RangeError("value is out of bounds");if(offset+ext>buf.length)throw new RangeError("index out of range");if(0>offset)throw new RangeError("index out of range")}function writeFloat(buf,value,offset,littleEndian,noAssert){return noAssert||checkIEEE754(buf,value,offset,4,3.4028234663852886e38,-3.4028234663852886e38),ieee754.write(buf,value,offset,littleEndian,23,4),offset+4}function writeDouble(buf,value,offset,littleEndian,noAssert){return noAssert||checkIEEE754(buf,value,offset,8,1.7976931348623157e308,-1.7976931348623157e308),ieee754.write(buf,value,offset,littleEndian,52,8),offset+8}function base64clean(str){if(str=stringtrim(str).replace(INVALID_BASE64_RE,""),str.length<2)return"";for(;str.length%4!==0;)str+="=";return str}function stringtrim(str){return str.trim?str.trim():str.replace(/^\s+|\s+$/g,"")}function isArrayish(subject){return isArray(subject)||Buffer.isBuffer(subject)||subject&&"object"==typeof subject&&"number"==typeof subject.length}function toHex(n){return 16>n?"0"+n.toString(16):n.toString(16)}function utf8ToBytes(string,units){units=units||1/0;for(var codePoint,length=string.length,leadSurrogate=null,bytes=[],i=0;length>i;i++){if(codePoint=string.charCodeAt(i),codePoint>55295&&57344>codePoint){if(!leadSurrogate){if(codePoint>56319){(units-=3)>-1&&bytes.push(239,191,189);continue}if(i+1===length){(units-=3)>-1&&bytes.push(239,191,189);continue}leadSurrogate=codePoint;continue}if(56320>codePoint){(units-=3)>-1&&bytes.push(239,191,189),leadSurrogate=codePoint;continue}codePoint=leadSurrogate-55296<<10|codePoint-56320|65536,leadSurrogate=null}else leadSurrogate&&((units-=3)>-1&&bytes.push(239,191,189),leadSurrogate=null);if(128>codePoint){if((units-=1)<0)break;bytes.push(codePoint)}else if(2048>codePoint){if((units-=2)<0)break;bytes.push(codePoint>>6|192,63&codePoint|128)}else if(65536>codePoint){if((units-=3)<0)break;bytes.push(codePoint>>12|224,codePoint>>6&63|128,63&codePoint|128)}else{if(!(2097152>codePoint))throw new Error("Invalid code point");if((units-=4)<0)break;bytes.push(codePoint>>18|240,codePoint>>12&63|128,codePoint>>6&63|128,63&codePoint|128)}}return bytes}function asciiToBytes(str){for(var byteArray=[],i=0;i<str.length;i++)byteArray.push(255&str.charCodeAt(i));return byteArray}function utf16leToBytes(str,units){for(var c,hi,lo,byteArray=[],i=0;i<str.length&&!((units-=2)<0);i++)c=str.charCodeAt(i),hi=c>>8,lo=c%256,byteArray.push(lo),byteArray.push(hi);return byteArray}function base64ToBytes(str){return base64.toByteArray(base64clean(str))}function blitBuffer(src,dst,offset,length){for(var i=0;length>i&&!(i+offset>=dst.length||i>=src.length);i++)dst[i+offset]=src[i];return i}function decodeUtf8Char(str){try{return decodeURIComponent(str)}catch(err){return String.fromCharCode(65533)}}var base64=require("base64-js"),ieee754=require("ieee754"),isArray=require("is-array");exports.Buffer=Buffer,exports.SlowBuffer=SlowBuffer,exports.INSPECT_MAX_BYTES=50,Buffer.poolSize=8192;var kMaxLength=1073741823,rootParent={};Buffer.TYPED_ARRAY_SUPPORT=function(){try{var buf=new ArrayBuffer(0),arr=new Uint8Array(buf);return arr.foo=function(){return 42},42===arr.foo()&&"function"==typeof arr.subarray&&0===new Uint8Array(1).subarray(1,1).byteLength}catch(e){return!1}}(),Buffer.isBuffer=function(b){return!(null==b||!b._isBuffer)},Buffer.compare=function(a,b){if(!Buffer.isBuffer(a)||!Buffer.isBuffer(b))throw new TypeError("Arguments must be Buffers");if(a===b)return 0;for(var x=a.length,y=b.length,i=0,len=Math.min(x,y);len>i&&a[i]===b[i];i++);return i!==len&&(x=a[i],y=b[i]),y>x?-1:x>y?1:0},Buffer.isEncoding=function(encoding){switch(String(encoding).toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"binary":case"base64":case"raw":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return!0;default:return!1}},Buffer.concat=function(list,totalLength){if(!isArray(list))throw new TypeError("Usage: Buffer.concat(list[, length])");if(0===list.length)return new Buffer(0);if(1===list.length)return list[0];var i;if(void 0===totalLength)for(totalLength=0,i=0;i<list.length;i++)totalLength+=list[i].length;var buf=new Buffer(totalLength),pos=0;for(i=0;i<list.length;i++){var item=list[i];item.copy(buf,pos),pos+=item.length}return buf},Buffer.byteLength=function(str,encoding){var ret;switch(str+="",encoding||"utf8"){case"ascii":case"binary":case"raw":ret=str.length;break;case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":ret=2*str.length;break;case"hex":ret=str.length>>>1;break;case"utf8":case"utf-8":ret=utf8ToBytes(str).length;break;case"base64":ret=base64ToBytes(str).length;break;default:ret=str.length}return ret},Buffer.prototype.length=void 0,Buffer.prototype.parent=void 0,Buffer.prototype.toString=function(encoding,start,end){var loweredCase=!1;if(start>>>=0,end=void 0===end||end===1/0?this.length:end>>>0,encoding||(encoding="utf8"),0>start&&(start=0),end>this.length&&(end=this.length),start>=end)return"";for(;;)switch(encoding){case"hex":return hexSlice(this,start,end);case"utf8":case"utf-8":return utf8Slice(this,start,end);case"ascii":return asciiSlice(this,start,end);case"binary":return binarySlice(this,start,end);case"base64":return base64Slice(this,start,end);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return utf16leSlice(this,start,end);default:if(loweredCase)throw new TypeError("Unknown encoding: "+encoding);encoding=(encoding+"").toLowerCase(),loweredCase=!0}},Buffer.prototype.equals=function(b){if(!Buffer.isBuffer(b))throw new TypeError("Argument must be a Buffer");return this===b?!0:0===Buffer.compare(this,b)},Buffer.prototype.inspect=function(){var str="",max=exports.INSPECT_MAX_BYTES;return this.length>0&&(str=this.toString("hex",0,max).match(/.{2}/g).join(" "),this.length>max&&(str+=" ... ")),"<Buffer "+str+">"},Buffer.prototype.compare=function(b){if(!Buffer.isBuffer(b))throw new TypeError("Argument must be a Buffer");return this===b?0:Buffer.compare(this,b)},Buffer.prototype.get=function(offset){return console.log(".get() is deprecated. Access using array indexes instead."),this.readUInt8(offset)},Buffer.prototype.set=function(v,offset){return console.log(".set() is deprecated. Access using array indexes instead."),this.writeUInt8(v,offset)},Buffer.prototype.write=function(string,offset,length,encoding){if(isFinite(offset))isFinite(length)||(encoding=length,length=void 0);else{var swap=encoding;encoding=offset,offset=length,length=swap}if(offset=Number(offset)||0,0>length||0>offset||offset>this.length)throw new RangeError("attempt to write outside buffer bounds");var remaining=this.length-offset;length?(length=Number(length),length>remaining&&(length=remaining)):length=remaining,encoding=String(encoding||"utf8").toLowerCase();var ret;switch(encoding){case"hex":ret=hexWrite(this,string,offset,length);break;case"utf8":case"utf-8":ret=utf8Write(this,string,offset,length);break;case"ascii":ret=asciiWrite(this,string,offset,length);break;case"binary":ret=binaryWrite(this,string,offset,length);break;case"base64":ret=base64Write(this,string,offset,length);break;case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":ret=utf16leWrite(this,string,offset,length);break;default:throw new TypeError("Unknown encoding: "+encoding)}return ret},Buffer.prototype.toJSON=function(){return{type:"Buffer",data:Array.prototype.slice.call(this._arr||this,0)}},Buffer.prototype.slice=function(start,end){var len=this.length;start=~~start,end=void 0===end?len:~~end,0>start?(start+=len,0>start&&(start=0)):start>len&&(start=len),0>end?(end+=len,0>end&&(end=0)):end>len&&(end=len),start>end&&(end=start);var newBuf;if(Buffer.TYPED_ARRAY_SUPPORT)newBuf=Buffer._augment(this.subarray(start,end));else{var sliceLen=end-start;newBuf=new Buffer(sliceLen,void 0,!0);for(var i=0;sliceLen>i;i++)newBuf[i]=this[i+start]}return newBuf.length&&(newBuf.parent=this.parent||this),newBuf},Buffer.prototype.readUIntLE=function(offset,byteLength,noAssert){offset>>>=0,byteLength>>>=0,noAssert||checkOffset(offset,byteLength,this.length);for(var val=this[offset],mul=1,i=0;++i<byteLength&&(mul*=256);)val+=this[offset+i]*mul;return val},Buffer.prototype.readUIntBE=function(offset,byteLength,noAssert){offset>>>=0,byteLength>>>=0,noAssert||checkOffset(offset,byteLength,this.length);for(var val=this[offset+--byteLength],mul=1;byteLength>0&&(mul*=256);)val+=this[offset+--byteLength]*mul;return val},Buffer.prototype.readUInt8=function(offset,noAssert){return noAssert||checkOffset(offset,1,this.length),this[offset]},Buffer.prototype.readUInt16LE=function(offset,noAssert){return noAssert||checkOffset(offset,2,this.length),this[offset]|this[offset+1]<<8},Buffer.prototype.readUInt16BE=function(offset,noAssert){return noAssert||checkOffset(offset,2,this.length),this[offset]<<8|this[offset+1]},Buffer.prototype.readUInt32LE=function(offset,noAssert){return noAssert||checkOffset(offset,4,this.length),(this[offset]|this[offset+1]<<8|this[offset+2]<<16)+16777216*this[offset+3]},Buffer.prototype.readUInt32BE=function(offset,noAssert){return noAssert||checkOffset(offset,4,this.length),16777216*this[offset]+(this[offset+1]<<16|this[offset+2]<<8|this[offset+3])},Buffer.prototype.readIntLE=function(offset,byteLength,noAssert){offset>>>=0,byteLength>>>=0,noAssert||checkOffset(offset,byteLength,this.length);for(var val=this[offset],mul=1,i=0;++i<byteLength&&(mul*=256);)val+=this[offset+i]*mul;return mul*=128,val>=mul&&(val-=Math.pow(2,8*byteLength)),val},Buffer.prototype.readIntBE=function(offset,byteLength,noAssert){offset>>>=0,byteLength>>>=0,noAssert||checkOffset(offset,byteLength,this.length);for(var i=byteLength,mul=1,val=this[offset+--i];i>0&&(mul*=256);)val+=this[offset+--i]*mul;return mul*=128,val>=mul&&(val-=Math.pow(2,8*byteLength)),val},Buffer.prototype.readInt8=function(offset,noAssert){return noAssert||checkOffset(offset,1,this.length),128&this[offset]?-1*(255-this[offset]+1):this[offset]},Buffer.prototype.readInt16LE=function(offset,noAssert){noAssert||checkOffset(offset,2,this.length);var val=this[offset]|this[offset+1]<<8;return 32768&val?4294901760|val:val},Buffer.prototype.readInt16BE=function(offset,noAssert){noAssert||checkOffset(offset,2,this.length);var val=this[offset+1]|this[offset]<<8;return 32768&val?4294901760|val:val},Buffer.prototype.readInt32LE=function(offset,noAssert){return noAssert||checkOffset(offset,4,this.length),this[offset]|this[offset+1]<<8|this[offset+2]<<16|this[offset+3]<<24},Buffer.prototype.readInt32BE=function(offset,noAssert){return noAssert||checkOffset(offset,4,this.length),this[offset]<<24|this[offset+1]<<16|this[offset+2]<<8|this[offset+3]},Buffer.prototype.readFloatLE=function(offset,noAssert){return noAssert||checkOffset(offset,4,this.length),ieee754.read(this,offset,!0,23,4)},Buffer.prototype.readFloatBE=function(offset,noAssert){return noAssert||checkOffset(offset,4,this.length),ieee754.read(this,offset,!1,23,4)},Buffer.prototype.readDoubleLE=function(offset,noAssert){return noAssert||checkOffset(offset,8,this.length),ieee754.read(this,offset,!0,52,8)},Buffer.prototype.readDoubleBE=function(offset,noAssert){return noAssert||checkOffset(offset,8,this.length),ieee754.read(this,offset,!1,52,8)},Buffer.prototype.writeUIntLE=function(value,offset,byteLength,noAssert){value=+value,offset>>>=0,byteLength>>>=0,noAssert||checkInt(this,value,offset,byteLength,Math.pow(2,8*byteLength),0);var mul=1,i=0;for(this[offset]=255&value;++i<byteLength&&(mul*=256);)this[offset+i]=value/mul>>>0&255;return offset+byteLength},Buffer.prototype.writeUIntBE=function(value,offset,byteLength,noAssert){value=+value,offset>>>=0,byteLength>>>=0,noAssert||checkInt(this,value,offset,byteLength,Math.pow(2,8*byteLength),0);var i=byteLength-1,mul=1;for(this[offset+i]=255&value;--i>=0&&(mul*=256);)this[offset+i]=value/mul>>>0&255;return offset+byteLength},Buffer.prototype.writeUInt8=function(value,offset,noAssert){return value=+value,offset>>>=0,noAssert||checkInt(this,value,offset,1,255,0),Buffer.TYPED_ARRAY_SUPPORT||(value=Math.floor(value)),this[offset]=value,offset+1},Buffer.prototype.writeUInt16LE=function(value,offset,noAssert){return value=+value,offset>>>=0,noAssert||checkInt(this,value,offset,2,65535,0),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=value,this[offset+1]=value>>>8):objectWriteUInt16(this,value,offset,!0),offset+2},Buffer.prototype.writeUInt16BE=function(value,offset,noAssert){return value=+value,offset>>>=0,noAssert||checkInt(this,value,offset,2,65535,0),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=value>>>8,this[offset+1]=value):objectWriteUInt16(this,value,offset,!1),offset+2},Buffer.prototype.writeUInt32LE=function(value,offset,noAssert){return value=+value,offset>>>=0,noAssert||checkInt(this,value,offset,4,4294967295,0),Buffer.TYPED_ARRAY_SUPPORT?(this[offset+3]=value>>>24,this[offset+2]=value>>>16,this[offset+1]=value>>>8,this[offset]=value):objectWriteUInt32(this,value,offset,!0),offset+4},Buffer.prototype.writeUInt32BE=function(value,offset,noAssert){return value=+value,offset>>>=0,noAssert||checkInt(this,value,offset,4,4294967295,0),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=value>>>24,this[offset+1]=value>>>16,this[offset+2]=value>>>8,this[offset+3]=value):objectWriteUInt32(this,value,offset,!1),offset+4},Buffer.prototype.writeIntLE=function(value,offset,byteLength,noAssert){value=+value,offset>>>=0,noAssert||checkInt(this,value,offset,byteLength,Math.pow(2,8*byteLength-1)-1,-Math.pow(2,8*byteLength-1));var i=0,mul=1,sub=0>value?1:0;for(this[offset]=255&value;++i<byteLength&&(mul*=256);)this[offset+i]=(value/mul>>0)-sub&255;return offset+byteLength},Buffer.prototype.writeIntBE=function(value,offset,byteLength,noAssert){value=+value,offset>>>=0,noAssert||checkInt(this,value,offset,byteLength,Math.pow(2,8*byteLength-1)-1,-Math.pow(2,8*byteLength-1));var i=byteLength-1,mul=1,sub=0>value?1:0;for(this[offset+i]=255&value;--i>=0&&(mul*=256);)this[offset+i]=(value/mul>>0)-sub&255;return offset+byteLength},Buffer.prototype.writeInt8=function(value,offset,noAssert){return value=+value,offset>>>=0,noAssert||checkInt(this,value,offset,1,127,-128),Buffer.TYPED_ARRAY_SUPPORT||(value=Math.floor(value)),0>value&&(value=255+value+1),this[offset]=value,offset+1},Buffer.prototype.writeInt16LE=function(value,offset,noAssert){return value=+value,offset>>>=0,noAssert||checkInt(this,value,offset,2,32767,-32768),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=value,this[offset+1]=value>>>8):objectWriteUInt16(this,value,offset,!0),offset+2},Buffer.prototype.writeInt16BE=function(value,offset,noAssert){return value=+value,offset>>>=0,noAssert||checkInt(this,value,offset,2,32767,-32768),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=value>>>8,this[offset+1]=value):objectWriteUInt16(this,value,offset,!1),offset+2},Buffer.prototype.writeInt32LE=function(value,offset,noAssert){return value=+value,offset>>>=0,noAssert||checkInt(this,value,offset,4,2147483647,-2147483648),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=value,this[offset+1]=value>>>8,
this[offset+2]=value>>>16,this[offset+3]=value>>>24):objectWriteUInt32(this,value,offset,!0),offset+4},Buffer.prototype.writeInt32BE=function(value,offset,noAssert){return value=+value,offset>>>=0,noAssert||checkInt(this,value,offset,4,2147483647,-2147483648),0>value&&(value=4294967295+value+1),Buffer.TYPED_ARRAY_SUPPORT?(this[offset]=value>>>24,this[offset+1]=value>>>16,this[offset+2]=value>>>8,this[offset+3]=value):objectWriteUInt32(this,value,offset,!1),offset+4},Buffer.prototype.writeFloatLE=function(value,offset,noAssert){return writeFloat(this,value,offset,!0,noAssert)},Buffer.prototype.writeFloatBE=function(value,offset,noAssert){return writeFloat(this,value,offset,!1,noAssert)},Buffer.prototype.writeDoubleLE=function(value,offset,noAssert){return writeDouble(this,value,offset,!0,noAssert)},Buffer.prototype.writeDoubleBE=function(value,offset,noAssert){return writeDouble(this,value,offset,!1,noAssert)},Buffer.prototype.copy=function(target,target_start,start,end){var self=this;if(start||(start=0),end||0===end||(end=this.length),target_start>=target.length&&(target_start=target.length),target_start||(target_start=0),end>0&&start>end&&(end=start),end===start)return 0;if(0===target.length||0===self.length)return 0;if(0>target_start)throw new RangeError("targetStart out of bounds");if(0>start||start>=self.length)throw new RangeError("sourceStart out of bounds");if(0>end)throw new RangeError("sourceEnd out of bounds");end>this.length&&(end=this.length),target.length-target_start<end-start&&(end=target.length-target_start+start);var len=end-start;if(1e3>len||!Buffer.TYPED_ARRAY_SUPPORT)for(var i=0;len>i;i++)target[i+target_start]=this[i+start];else target._set(this.subarray(start,start+len),target_start);return len},Buffer.prototype.fill=function(value,start,end){if(value||(value=0),start||(start=0),end||(end=this.length),start>end)throw new RangeError("end < start");if(end!==start&&0!==this.length){if(0>start||start>=this.length)throw new RangeError("start out of bounds");if(0>end||end>this.length)throw new RangeError("end out of bounds");var i;if("number"==typeof value)for(i=start;end>i;i++)this[i]=value;else{var bytes=utf8ToBytes(value.toString()),len=bytes.length;for(i=start;end>i;i++)this[i]=bytes[i%len]}return this}},Buffer.prototype.toArrayBuffer=function(){if("undefined"!=typeof Uint8Array){if(Buffer.TYPED_ARRAY_SUPPORT)return new Buffer(this).buffer;for(var buf=new Uint8Array(this.length),i=0,len=buf.length;len>i;i+=1)buf[i]=this[i];return buf.buffer}throw new TypeError("Buffer.toArrayBuffer not supported in this browser")};var BP=Buffer.prototype;Buffer._augment=function(arr){return arr.constructor=Buffer,arr._isBuffer=!0,arr._get=arr.get,arr._set=arr.set,arr.get=BP.get,arr.set=BP.set,arr.write=BP.write,arr.toString=BP.toString,arr.toLocaleString=BP.toString,arr.toJSON=BP.toJSON,arr.equals=BP.equals,arr.compare=BP.compare,arr.copy=BP.copy,arr.slice=BP.slice,arr.readUIntLE=BP.readUIntLE,arr.readUIntBE=BP.readUIntBE,arr.readUInt8=BP.readUInt8,arr.readUInt16LE=BP.readUInt16LE,arr.readUInt16BE=BP.readUInt16BE,arr.readUInt32LE=BP.readUInt32LE,arr.readUInt32BE=BP.readUInt32BE,arr.readIntLE=BP.readIntLE,arr.readIntBE=BP.readIntBE,arr.readInt8=BP.readInt8,arr.readInt16LE=BP.readInt16LE,arr.readInt16BE=BP.readInt16BE,arr.readInt32LE=BP.readInt32LE,arr.readInt32BE=BP.readInt32BE,arr.readFloatLE=BP.readFloatLE,arr.readFloatBE=BP.readFloatBE,arr.readDoubleLE=BP.readDoubleLE,arr.readDoubleBE=BP.readDoubleBE,arr.writeUInt8=BP.writeUInt8,arr.writeUIntLE=BP.writeUIntLE,arr.writeUIntBE=BP.writeUIntBE,arr.writeUInt16LE=BP.writeUInt16LE,arr.writeUInt16BE=BP.writeUInt16BE,arr.writeUInt32LE=BP.writeUInt32LE,arr.writeUInt32BE=BP.writeUInt32BE,arr.writeIntLE=BP.writeIntLE,arr.writeIntBE=BP.writeIntBE,arr.writeInt8=BP.writeInt8,arr.writeInt16LE=BP.writeInt16LE,arr.writeInt16BE=BP.writeInt16BE,arr.writeInt32LE=BP.writeInt32LE,arr.writeInt32BE=BP.writeInt32BE,arr.writeFloatLE=BP.writeFloatLE,arr.writeFloatBE=BP.writeFloatBE,arr.writeDoubleLE=BP.writeDoubleLE,arr.writeDoubleBE=BP.writeDoubleBE,arr.fill=BP.fill,arr.inspect=BP.inspect,arr.toArrayBuffer=BP.toArrayBuffer,arr};var INVALID_BASE64_RE=/[^+\/0-9A-z\-]/g},{"base64-js":24,ieee754:25,"is-array":26}],24:[function(require,module,exports){var lookup="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";!function(exports){"use strict";function decode(elt){var code=elt.charCodeAt(0);return code===PLUS||code===PLUS_URL_SAFE?62:code===SLASH||code===SLASH_URL_SAFE?63:NUMBER>code?-1:NUMBER+10>code?code-NUMBER+26+26:UPPER+26>code?code-UPPER:LOWER+26>code?code-LOWER+26:void 0}function b64ToByteArray(b64){function push(v){arr[L++]=v}var i,j,l,tmp,placeHolders,arr;if(b64.length%4>0)throw new Error("Invalid string. Length must be a multiple of 4");var len=b64.length;placeHolders="="===b64.charAt(len-2)?2:"="===b64.charAt(len-1)?1:0,arr=new Arr(3*b64.length/4-placeHolders),l=placeHolders>0?b64.length-4:b64.length;var L=0;for(i=0,j=0;l>i;i+=4,j+=3)tmp=decode(b64.charAt(i))<<18|decode(b64.charAt(i+1))<<12|decode(b64.charAt(i+2))<<6|decode(b64.charAt(i+3)),push((16711680&tmp)>>16),push((65280&tmp)>>8),push(255&tmp);return 2===placeHolders?(tmp=decode(b64.charAt(i))<<2|decode(b64.charAt(i+1))>>4,push(255&tmp)):1===placeHolders&&(tmp=decode(b64.charAt(i))<<10|decode(b64.charAt(i+1))<<4|decode(b64.charAt(i+2))>>2,push(tmp>>8&255),push(255&tmp)),arr}function uint8ToBase64(uint8){function encode(num){return lookup.charAt(num)}function tripletToBase64(num){return encode(num>>18&63)+encode(num>>12&63)+encode(num>>6&63)+encode(63&num)}var i,temp,length,extraBytes=uint8.length%3,output="";for(i=0,length=uint8.length-extraBytes;length>i;i+=3)temp=(uint8[i]<<16)+(uint8[i+1]<<8)+uint8[i+2],output+=tripletToBase64(temp);switch(extraBytes){case 1:temp=uint8[uint8.length-1],output+=encode(temp>>2),output+=encode(temp<<4&63),output+="==";break;case 2:temp=(uint8[uint8.length-2]<<8)+uint8[uint8.length-1],output+=encode(temp>>10),output+=encode(temp>>4&63),output+=encode(temp<<2&63),output+="="}return output}var Arr="undefined"!=typeof Uint8Array?Uint8Array:Array,PLUS="+".charCodeAt(0),SLASH="/".charCodeAt(0),NUMBER="0".charCodeAt(0),LOWER="a".charCodeAt(0),UPPER="A".charCodeAt(0),PLUS_URL_SAFE="-".charCodeAt(0),SLASH_URL_SAFE="_".charCodeAt(0);exports.toByteArray=b64ToByteArray,exports.fromByteArray=uint8ToBase64}("undefined"==typeof exports?this.base64js={}:exports)},{}],25:[function(require,module,exports){exports.read=function(buffer,offset,isLE,mLen,nBytes){var e,m,eLen=8*nBytes-mLen-1,eMax=(1<<eLen)-1,eBias=eMax>>1,nBits=-7,i=isLE?nBytes-1:0,d=isLE?-1:1,s=buffer[offset+i];for(i+=d,e=s&(1<<-nBits)-1,s>>=-nBits,nBits+=eLen;nBits>0;e=256*e+buffer[offset+i],i+=d,nBits-=8);for(m=e&(1<<-nBits)-1,e>>=-nBits,nBits+=mLen;nBits>0;m=256*m+buffer[offset+i],i+=d,nBits-=8);if(0===e)e=1-eBias;else{if(e===eMax)return m?NaN:(s?-1:1)*(1/0);m+=Math.pow(2,mLen),e-=eBias}return(s?-1:1)*m*Math.pow(2,e-mLen)},exports.write=function(buffer,value,offset,isLE,mLen,nBytes){var e,m,c,eLen=8*nBytes-mLen-1,eMax=(1<<eLen)-1,eBias=eMax>>1,rt=23===mLen?Math.pow(2,-24)-Math.pow(2,-77):0,i=isLE?0:nBytes-1,d=isLE?1:-1,s=0>value||0===value&&0>1/value?1:0;for(value=Math.abs(value),isNaN(value)||value===1/0?(m=isNaN(value)?1:0,e=eMax):(e=Math.floor(Math.log(value)/Math.LN2),value*(c=Math.pow(2,-e))<1&&(e--,c*=2),value+=e+eBias>=1?rt/c:rt*Math.pow(2,1-eBias),value*c>=2&&(e++,c/=2),e+eBias>=eMax?(m=0,e=eMax):e+eBias>=1?(m=(value*c-1)*Math.pow(2,mLen),e+=eBias):(m=value*Math.pow(2,eBias-1)*Math.pow(2,mLen),e=0));mLen>=8;buffer[offset+i]=255&m,i+=d,m/=256,mLen-=8);for(e=e<<mLen|m,eLen+=mLen;eLen>0;buffer[offset+i]=255&e,i+=d,e/=256,eLen-=8);buffer[offset+i-d]|=128*s}},{}],26:[function(require,module,exports){var isArray=Array.isArray,str=Object.prototype.toString;module.exports=isArray||function(val){return!!val&&"[object Array]"==str.call(val)}},{}],27:[function(require,module,exports){var upperCase=require("upper-case"),sentenceCase=require("sentence-case");module.exports=function(string,locale){return sentenceCase(string,locale).replace(/(\d) (?=\d)/g,"$1_").replace(/ (.)/g,function(m,$1){return upperCase($1,locale)})}},{"sentence-case":28,"upper-case":61}],28:[function(require,module,exports){var lowerCase=require("lower-case"),NON_WORD_REGEXP=require("./vendor/non-word-regexp"),CAMEL_CASE_REGEXP=require("./vendor/camel-case-regexp"),TRAILING_DIGIT_REGEXP=require("./vendor/trailing-digit-regexp");module.exports=function(str,locale,replacement){function replace(match,index,string){return 0===index||index===string.length-match.length?"":replacement}return null==str?"":(replacement=replacement||" ",str=String(str).replace(CAMEL_CASE_REGEXP,"$1 $2").replace(TRAILING_DIGIT_REGEXP,"$1 $2").replace(NON_WORD_REGEXP,replace),lowerCase(str,locale))}},{"./vendor/camel-case-regexp":29,"./vendor/non-word-regexp":30,"./vendor/trailing-digit-regexp":31,"lower-case":46}],29:[function(require,module,exports){module.exports=/([\u0061-\u007A\u00B5\u00DF-\u00F6\u00F8-\u00FF\u0101\u0103\u0105\u0107\u0109\u010B\u010D\u010F\u0111\u0113\u0115\u0117\u0119\u011B\u011D\u011F\u0121\u0123\u0125\u0127\u0129\u012B\u012D\u012F\u0131\u0133\u0135\u0137\u0138\u013A\u013C\u013E\u0140\u0142\u0144\u0146\u0148\u0149\u014B\u014D\u014F\u0151\u0153\u0155\u0157\u0159\u015B\u015D\u015F\u0161\u0163\u0165\u0167\u0169\u016B\u016D\u016F\u0171\u0173\u0175\u0177\u017A\u017C\u017E-\u0180\u0183\u0185\u0188\u018C\u018D\u0192\u0195\u0199-\u019B\u019E\u01A1\u01A3\u01A5\u01A8\u01AA\u01AB\u01AD\u01B0\u01B4\u01B6\u01B9\u01BA\u01BD-\u01BF\u01C6\u01C9\u01CC\u01CE\u01D0\u01D2\u01D4\u01D6\u01D8\u01DA\u01DC\u01DD\u01DF\u01E1\u01E3\u01E5\u01E7\u01E9\u01EB\u01ED\u01EF\u01F0\u01F3\u01F5\u01F9\u01FB\u01FD\u01FF\u0201\u0203\u0205\u0207\u0209\u020B\u020D\u020F\u0211\u0213\u0215\u0217\u0219\u021B\u021D\u021F\u0221\u0223\u0225\u0227\u0229\u022B\u022D\u022F\u0231\u0233-\u0239\u023C\u023F\u0240\u0242\u0247\u0249\u024B\u024D\u024F-\u0293\u0295-\u02AF\u0371\u0373\u0377\u037B-\u037D\u0390\u03AC-\u03CE\u03D0\u03D1\u03D5-\u03D7\u03D9\u03DB\u03DD\u03DF\u03E1\u03E3\u03E5\u03E7\u03E9\u03EB\u03ED\u03EF-\u03F3\u03F5\u03F8\u03FB\u03FC\u0430-\u045F\u0461\u0463\u0465\u0467\u0469\u046B\u046D\u046F\u0471\u0473\u0475\u0477\u0479\u047B\u047D\u047F\u0481\u048B\u048D\u048F\u0491\u0493\u0495\u0497\u0499\u049B\u049D\u049F\u04A1\u04A3\u04A5\u04A7\u04A9\u04AB\u04AD\u04AF\u04B1\u04B3\u04B5\u04B7\u04B9\u04BB\u04BD\u04BF\u04C2\u04C4\u04C6\u04C8\u04CA\u04CC\u04CE\u04CF\u04D1\u04D3\u04D5\u04D7\u04D9\u04DB\u04DD\u04DF\u04E1\u04E3\u04E5\u04E7\u04E9\u04EB\u04ED\u04EF\u04F1\u04F3\u04F5\u04F7\u04F9\u04FB\u04FD\u04FF\u0501\u0503\u0505\u0507\u0509\u050B\u050D\u050F\u0511\u0513\u0515\u0517\u0519\u051B\u051D\u051F\u0521\u0523\u0525\u0527\u0561-\u0587\u1D00-\u1D2B\u1D6B-\u1D77\u1D79-\u1D9A\u1E01\u1E03\u1E05\u1E07\u1E09\u1E0B\u1E0D\u1E0F\u1E11\u1E13\u1E15\u1E17\u1E19\u1E1B\u1E1D\u1E1F\u1E21\u1E23\u1E25\u1E27\u1E29\u1E2B\u1E2D\u1E2F\u1E31\u1E33\u1E35\u1E37\u1E39\u1E3B\u1E3D\u1E3F\u1E41\u1E43\u1E45\u1E47\u1E49\u1E4B\u1E4D\u1E4F\u1E51\u1E53\u1E55\u1E57\u1E59\u1E5B\u1E5D\u1E5F\u1E61\u1E63\u1E65\u1E67\u1E69\u1E6B\u1E6D\u1E6F\u1E71\u1E73\u1E75\u1E77\u1E79\u1E7B\u1E7D\u1E7F\u1E81\u1E83\u1E85\u1E87\u1E89\u1E8B\u1E8D\u1E8F\u1E91\u1E93\u1E95-\u1E9D\u1E9F\u1EA1\u1EA3\u1EA5\u1EA7\u1EA9\u1EAB\u1EAD\u1EAF\u1EB1\u1EB3\u1EB5\u1EB7\u1EB9\u1EBB\u1EBD\u1EBF\u1EC1\u1EC3\u1EC5\u1EC7\u1EC9\u1ECB\u1ECD\u1ECF\u1ED1\u1ED3\u1ED5\u1ED7\u1ED9\u1EDB\u1EDD\u1EDF\u1EE1\u1EE3\u1EE5\u1EE7\u1EE9\u1EEB\u1EED\u1EEF\u1EF1\u1EF3\u1EF5\u1EF7\u1EF9\u1EFB\u1EFD\u1EFF-\u1F07\u1F10-\u1F15\u1F20-\u1F27\u1F30-\u1F37\u1F40-\u1F45\u1F50-\u1F57\u1F60-\u1F67\u1F70-\u1F7D\u1F80-\u1F87\u1F90-\u1F97\u1FA0-\u1FA7\u1FB0-\u1FB4\u1FB6\u1FB7\u1FBE\u1FC2-\u1FC4\u1FC6\u1FC7\u1FD0-\u1FD3\u1FD6\u1FD7\u1FE0-\u1FE7\u1FF2-\u1FF4\u1FF6\u1FF7\u210A\u210E\u210F\u2113\u212F\u2134\u2139\u213C\u213D\u2146-\u2149\u214E\u2184\u2C30-\u2C5E\u2C61\u2C65\u2C66\u2C68\u2C6A\u2C6C\u2C71\u2C73\u2C74\u2C76-\u2C7B\u2C81\u2C83\u2C85\u2C87\u2C89\u2C8B\u2C8D\u2C8F\u2C91\u2C93\u2C95\u2C97\u2C99\u2C9B\u2C9D\u2C9F\u2CA1\u2CA3\u2CA5\u2CA7\u2CA9\u2CAB\u2CAD\u2CAF\u2CB1\u2CB3\u2CB5\u2CB7\u2CB9\u2CBB\u2CBD\u2CBF\u2CC1\u2CC3\u2CC5\u2CC7\u2CC9\u2CCB\u2CCD\u2CCF\u2CD1\u2CD3\u2CD5\u2CD7\u2CD9\u2CDB\u2CDD\u2CDF\u2CE1\u2CE3\u2CE4\u2CEC\u2CEE\u2CF3\u2D00-\u2D25\u2D27\u2D2D\uA641\uA643\uA645\uA647\uA649\uA64B\uA64D\uA64F\uA651\uA653\uA655\uA657\uA659\uA65B\uA65D\uA65F\uA661\uA663\uA665\uA667\uA669\uA66B\uA66D\uA681\uA683\uA685\uA687\uA689\uA68B\uA68D\uA68F\uA691\uA693\uA695\uA697\uA723\uA725\uA727\uA729\uA72B\uA72D\uA72F-\uA731\uA733\uA735\uA737\uA739\uA73B\uA73D\uA73F\uA741\uA743\uA745\uA747\uA749\uA74B\uA74D\uA74F\uA751\uA753\uA755\uA757\uA759\uA75B\uA75D\uA75F\uA761\uA763\uA765\uA767\uA769\uA76B\uA76D\uA76F\uA771-\uA778\uA77A\uA77C\uA77F\uA781\uA783\uA785\uA787\uA78C\uA78E\uA791\uA793\uA7A1\uA7A3\uA7A5\uA7A7\uA7A9\uA7FA\uFB00-\uFB06\uFB13-\uFB17\uFF41-\uFF5A])([\u0041-\u005A\u00C0-\u00D6\u00D8-\u00DE\u0100\u0102\u0104\u0106\u0108\u010A\u010C\u010E\u0110\u0112\u0114\u0116\u0118\u011A\u011C\u011E\u0120\u0122\u0124\u0126\u0128\u012A\u012C\u012E\u0130\u0132\u0134\u0136\u0139\u013B\u013D\u013F\u0141\u0143\u0145\u0147\u014A\u014C\u014E\u0150\u0152\u0154\u0156\u0158\u015A\u015C\u015E\u0160\u0162\u0164\u0166\u0168\u016A\u016C\u016E\u0170\u0172\u0174\u0176\u0178\u0179\u017B\u017D\u0181\u0182\u0184\u0186\u0187\u0189-\u018B\u018E-\u0191\u0193\u0194\u0196-\u0198\u019C\u019D\u019F\u01A0\u01A2\u01A4\u01A6\u01A7\u01A9\u01AC\u01AE\u01AF\u01B1-\u01B3\u01B5\u01B7\u01B8\u01BC\u01C4\u01C7\u01CA\u01CD\u01CF\u01D1\u01D3\u01D5\u01D7\u01D9\u01DB\u01DE\u01E0\u01E2\u01E4\u01E6\u01E8\u01EA\u01EC\u01EE\u01F1\u01F4\u01F6-\u01F8\u01FA\u01FC\u01FE\u0200\u0202\u0204\u0206\u0208\u020A\u020C\u020E\u0210\u0212\u0214\u0216\u0218\u021A\u021C\u021E\u0220\u0222\u0224\u0226\u0228\u022A\u022C\u022E\u0230\u0232\u023A\u023B\u023D\u023E\u0241\u0243-\u0246\u0248\u024A\u024C\u024E\u0370\u0372\u0376\u0386\u0388-\u038A\u038C\u038E\u038F\u0391-\u03A1\u03A3-\u03AB\u03CF\u03D2-\u03D4\u03D8\u03DA\u03DC\u03DE\u03E0\u03E2\u03E4\u03E6\u03E8\u03EA\u03EC\u03EE\u03F4\u03F7\u03F9\u03FA\u03FD-\u042F\u0460\u0462\u0464\u0466\u0468\u046A\u046C\u046E\u0470\u0472\u0474\u0476\u0478\u047A\u047C\u047E\u0480\u048A\u048C\u048E\u0490\u0492\u0494\u0496\u0498\u049A\u049C\u049E\u04A0\u04A2\u04A4\u04A6\u04A8\u04AA\u04AC\u04AE\u04B0\u04B2\u04B4\u04B6\u04B8\u04BA\u04BC\u04BE\u04C0\u04C1\u04C3\u04C5\u04C7\u04C9\u04CB\u04CD\u04D0\u04D2\u04D4\u04D6\u04D8\u04DA\u04DC\u04DE\u04E0\u04E2\u04E4\u04E6\u04E8\u04EA\u04EC\u04EE\u04F0\u04F2\u04F4\u04F6\u04F8\u04FA\u04FC\u04FE\u0500\u0502\u0504\u0506\u0508\u050A\u050C\u050E\u0510\u0512\u0514\u0516\u0518\u051A\u051C\u051E\u0520\u0522\u0524\u0526\u0531-\u0556\u10A0-\u10C5\u10C7\u10CD\u1E00\u1E02\u1E04\u1E06\u1E08\u1E0A\u1E0C\u1E0E\u1E10\u1E12\u1E14\u1E16\u1E18\u1E1A\u1E1C\u1E1E\u1E20\u1E22\u1E24\u1E26\u1E28\u1E2A\u1E2C\u1E2E\u1E30\u1E32\u1E34\u1E36\u1E38\u1E3A\u1E3C\u1E3E\u1E40\u1E42\u1E44\u1E46\u1E48\u1E4A\u1E4C\u1E4E\u1E50\u1E52\u1E54\u1E56\u1E58\u1E5A\u1E5C\u1E5E\u1E60\u1E62\u1E64\u1E66\u1E68\u1E6A\u1E6C\u1E6E\u1E70\u1E72\u1E74\u1E76\u1E78\u1E7A\u1E7C\u1E7E\u1E80\u1E82\u1E84\u1E86\u1E88\u1E8A\u1E8C\u1E8E\u1E90\u1E92\u1E94\u1E9E\u1EA0\u1EA2\u1EA4\u1EA6\u1EA8\u1EAA\u1EAC\u1EAE\u1EB0\u1EB2\u1EB4\u1EB6\u1EB8\u1EBA\u1EBC\u1EBE\u1EC0\u1EC2\u1EC4\u1EC6\u1EC8\u1ECA\u1ECC\u1ECE\u1ED0\u1ED2\u1ED4\u1ED6\u1ED8\u1EDA\u1EDC\u1EDE\u1EE0\u1EE2\u1EE4\u1EE6\u1EE8\u1EEA\u1EEC\u1EEE\u1EF0\u1EF2\u1EF4\u1EF6\u1EF8\u1EFA\u1EFC\u1EFE\u1F08-\u1F0F\u1F18-\u1F1D\u1F28-\u1F2F\u1F38-\u1F3F\u1F48-\u1F4D\u1F59\u1F5B\u1F5D\u1F5F\u1F68-\u1F6F\u1FB8-\u1FBB\u1FC8-\u1FCB\u1FD8-\u1FDB\u1FE8-\u1FEC\u1FF8-\u1FFB\u2102\u2107\u210B-\u210D\u2110-\u2112\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u2130-\u2133\u213E\u213F\u2145\u2183\u2C00-\u2C2E\u2C60\u2C62-\u2C64\u2C67\u2C69\u2C6B\u2C6D-\u2C70\u2C72\u2C75\u2C7E-\u2C80\u2C82\u2C84\u2C86\u2C88\u2C8A\u2C8C\u2C8E\u2C90\u2C92\u2C94\u2C96\u2C98\u2C9A\u2C9C\u2C9E\u2CA0\u2CA2\u2CA4\u2CA6\u2CA8\u2CAA\u2CAC\u2CAE\u2CB0\u2CB2\u2CB4\u2CB6\u2CB8\u2CBA\u2CBC\u2CBE\u2CC0\u2CC2\u2CC4\u2CC6\u2CC8\u2CCA\u2CCC\u2CCE\u2CD0\u2CD2\u2CD4\u2CD6\u2CD8\u2CDA\u2CDC\u2CDE\u2CE0\u2CE2\u2CEB\u2CED\u2CF2\uA640\uA642\uA644\uA646\uA648\uA64A\uA64C\uA64E\uA650\uA652\uA654\uA656\uA658\uA65A\uA65C\uA65E\uA660\uA662\uA664\uA666\uA668\uA66A\uA66C\uA680\uA682\uA684\uA686\uA688\uA68A\uA68C\uA68E\uA690\uA692\uA694\uA696\uA722\uA724\uA726\uA728\uA72A\uA72C\uA72E\uA732\uA734\uA736\uA738\uA73A\uA73C\uA73E\uA740\uA742\uA744\uA746\uA748\uA74A\uA74C\uA74E\uA750\uA752\uA754\uA756\uA758\uA75A\uA75C\uA75E\uA760\uA762\uA764\uA766\uA768\uA76A\uA76C\uA76E\uA779\uA77B\uA77D\uA77E\uA780\uA782\uA784\uA786\uA78B\uA78D\uA790\uA792\uA7A0\uA7A2\uA7A4\uA7A6\uA7A8\uA7AA\uFF21-\uFF3A\u0030-\u0039\u00B2\u00B3\u00B9\u00BC-\u00BE\u0660-\u0669\u06F0-\u06F9\u07C0-\u07C9\u0966-\u096F\u09E6-\u09EF\u09F4-\u09F9\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0B72-\u0B77\u0BE6-\u0BF2\u0C66-\u0C6F\u0C78-\u0C7E\u0CE6-\u0CEF\u0D66-\u0D75\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F33\u1040-\u1049\u1090-\u1099\u1369-\u137C\u16EE-\u16F0\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1946-\u194F\u19D0-\u19DA\u1A80-\u1A89\u1A90-\u1A99\u1B50-\u1B59\u1BB0-\u1BB9\u1C40-\u1C49\u1C50-\u1C59\u2070\u2074-\u2079\u2080-\u2089\u2150-\u2182\u2185-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2CFD\u3007\u3021-\u3029\u3038-\u303A\u3192-\u3195\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\uA620-\uA629\uA6E6-\uA6EF\uA830-\uA835\uA8D0-\uA8D9\uA900-\uA909\uA9D0-\uA9D9\uAA50-\uAA59\uABF0-\uABF9\uFF10-\uFF19])/g},{}],30:[function(require,module,exports){module.exports=/[^\u0041-\u005A\u0061-\u007A\u00AA\u00B5\u00BA\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u0527\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u08A0\u08A2-\u08AC\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0977\u0979-\u097F\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C33\u0C35-\u0C39\u0C3D\u0C58\u0C59\u0C60\u0C61\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D60\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F4\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191C\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19C1-\u19C7\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2183\u2184\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005\u3006\u3031-\u3035\u303B\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FCC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA697\uA6A0-\uA6E5\uA717-\uA71F\uA722-\uA788\uA78B-\uA78E\uA790-\uA793\uA7A0-\uA7AA\uA7F8-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA80-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uABC0-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC\u0030-\u0039\u00B2\u00B3\u00B9\u00BC-\u00BE\u0660-\u0669\u06F0-\u06F9\u07C0-\u07C9\u0966-\u096F\u09E6-\u09EF\u09F4-\u09F9\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0B72-\u0B77\u0BE6-\u0BF2\u0C66-\u0C6F\u0C78-\u0C7E\u0CE6-\u0CEF\u0D66-\u0D75\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F33\u1040-\u1049\u1090-\u1099\u1369-\u137C\u16EE-\u16F0\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1946-\u194F\u19D0-\u19DA\u1A80-\u1A89\u1A90-\u1A99\u1B50-\u1B59\u1BB0-\u1BB9\u1C40-\u1C49\u1C50-\u1C59\u2070\u2074-\u2079\u2080-\u2089\u2150-\u2182\u2185-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2CFD\u3007\u3021-\u3029\u3038-\u303A\u3192-\u3195\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\uA620-\uA629\uA6E6-\uA6EF\uA830-\uA835\uA8D0-\uA8D9\uA900-\uA909\uA9D0-\uA9D9\uAA50-\uAA59\uABF0-\uABF9\uFF10-\uFF19]+/g},{}],31:[function(require,module,exports){module.exports=/([\u0030-\u0039\u00B2\u00B3\u00B9\u00BC-\u00BE\u0660-\u0669\u06F0-\u06F9\u07C0-\u07C9\u0966-\u096F\u09E6-\u09EF\u09F4-\u09F9\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0B72-\u0B77\u0BE6-\u0BF2\u0C66-\u0C6F\u0C78-\u0C7E\u0CE6-\u0CEF\u0D66-\u0D75\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F33\u1040-\u1049\u1090-\u1099\u1369-\u137C\u16EE-\u16F0\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1946-\u194F\u19D0-\u19DA\u1A80-\u1A89\u1A90-\u1A99\u1B50-\u1B59\u1BB0-\u1BB9\u1C40-\u1C49\u1C50-\u1C59\u2070\u2074-\u2079\u2080-\u2089\u2150-\u2182\u2185-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2CFD\u3007\u3021-\u3029\u3038-\u303A\u3192-\u3195\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\uA620-\uA629\uA6E6-\uA6EF\uA830-\uA835\uA8D0-\uA8D9\uA900-\uA909\uA9D0-\uA9D9\uAA50-\uAA59\uABF0-\uABF9\uFF10-\uFF19])([^\u0030-\u0039\u00B2\u00B3\u00B9\u00BC-\u00BE\u0660-\u0669\u06F0-\u06F9\u07C0-\u07C9\u0966-\u096F\u09E6-\u09EF\u09F4-\u09F9\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0B72-\u0B77\u0BE6-\u0BF2\u0C66-\u0C6F\u0C78-\u0C7E\u0CE6-\u0CEF\u0D66-\u0D75\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F33\u1040-\u1049\u1090-\u1099\u1369-\u137C\u16EE-\u16F0\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1946-\u194F\u19D0-\u19DA\u1A80-\u1A89\u1A90-\u1A99\u1B50-\u1B59\u1BB0-\u1BB9\u1C40-\u1C49\u1C50-\u1C59\u2070\u2074-\u2079\u2080-\u2089\u2150-\u2182\u2185-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2CFD\u3007\u3021-\u3029\u3038-\u303A\u3192-\u3195\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\uA620-\uA629\uA6E6-\uA6EF\uA830-\uA835\uA8D0-\uA8D9\uA900-\uA909\uA9D0-\uA9D9\uAA50-\uAA59\uABF0-\uABF9\uFF10-\uFF19])/g},{}],32:[function(require,module,exports){var upperCase=require("upper-case"),snakeCase=require("snake-case");module.exports=function(string,locale){return upperCase(snakeCase(string,locale),locale)}},{"snake-case":60,"upper-case":61}],33:[function(require,module,exports){var undefined,hasOwn=Object.prototype.hasOwnProperty,toString=Object.prototype.toString,isPlainObject=function(obj){"use strict";if(!obj||"[object Object]"!==toString.call(obj))return!1;var has_own_constructor=hasOwn.call(obj,"constructor"),has_is_property_of_method=obj.constructor&&obj.constructor.prototype&&hasOwn.call(obj.constructor.prototype,"isPrototypeOf");if(obj.constructor&&!has_own_constructor&&!has_is_property_of_method)return!1;var key;for(key in obj);return key===undefined||hasOwn.call(obj,key)};module.exports=function extend(){"use strict";var options,name,src,copy,copyIsArray,clone,target=arguments[0],i=1,length=arguments.length,deep=!1;for("boolean"==typeof target?(deep=target,target=arguments[1]||{},i=2):("object"!=typeof target&&"function"!=typeof target||null==target)&&(target={});length>i;++i)if(options=arguments[i],null!=options)for(name in options)src=target[name],copy=options[name],target!==copy&&(deep&&copy&&(isPlainObject(copy)||(copyIsArray=Array.isArray(copy)))?(copyIsArray?(copyIsArray=!1,clone=src&&Array.isArray(src)?src:[]):clone=src&&isPlainObject(src)?src:{},target[name]=extend(deep,clone,copy)):copy!==undefined&&(target[name]=copy));return target}},{}],34:[function(require,module,exports){(function(global){"use strict";var base=require("./handlebars/base"),SafeString=require("./handlebars/safe-string")["default"],Exception=require("./handlebars/exception")["default"],Utils=require("./handlebars/utils"),runtime=require("./handlebars/runtime"),create=function(){var hb=new base.HandlebarsEnvironment;return Utils.extend(hb,base),hb.SafeString=SafeString,hb.Exception=Exception,hb.Utils=Utils,hb.escapeExpression=Utils.escapeExpression,hb.VM=runtime,hb.template=function(spec){return runtime.template(spec,hb)},hb},Handlebars=create();Handlebars.create=create;var root="undefined"!=typeof global?global:window,$Handlebars=root.Handlebars;Handlebars.noConflict=function(){root.Handlebars===Handlebars&&(root.Handlebars=$Handlebars)},Handlebars["default"]=Handlebars,exports["default"]=Handlebars}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{"./handlebars/base":35,"./handlebars/exception":36,"./handlebars/runtime":37,"./handlebars/safe-string":38,"./handlebars/utils":39}],35:[function(require,module,exports){"use strict";function HandlebarsEnvironment(helpers,partials){this.helpers=helpers||{},this.partials=partials||{},registerDefaultHelpers(this)}function registerDefaultHelpers(instance){instance.registerHelper("helperMissing",function(){if(1===arguments.length)return void 0;throw new Exception("Missing helper: '"+arguments[arguments.length-1].name+"'")}),instance.registerHelper("blockHelperMissing",function(context,options){var inverse=options.inverse,fn=options.fn;if(context===!0)return fn(this);if(context===!1||null==context)return inverse(this);if(isArray(context))return context.length>0?(options.ids&&(options.ids=[options.name]),instance.helpers.each(context,options)):inverse(this);if(options.data&&options.ids){var data=createFrame(options.data);data.contextPath=Utils.appendContextPath(options.data.contextPath,options.name),options={data:data}}return fn(context,options)}),instance.registerHelper("each",function(context,options){function execIteration(key,i,last){data&&(data.key=key,data.index=i,data.first=0===i,data.last=!!last,contextPath&&(data.contextPath=contextPath+key)),ret+=fn(context[key],{data:data,blockParams:Utils.blockParams([context[key],key],[contextPath+key,null])})}if(!options)throw new Exception("Must pass iterator to #each");var data,contextPath,fn=options.fn,inverse=options.inverse,i=0,ret="";if(options.data&&options.ids&&(contextPath=Utils.appendContextPath(options.data.contextPath,options.ids[0])+"."),isFunction(context)&&(context=context.call(this)),options.data&&(data=createFrame(options.data)),context&&"object"==typeof context)if(isArray(context))for(var j=context.length;j>i;i++)execIteration(i,i,i===context.length-1);else{var priorKey;for(var key in context)context.hasOwnProperty(key)&&(priorKey&&execIteration(priorKey,i-1),priorKey=key,i++);priorKey&&execIteration(priorKey,i-1,!0)}return 0===i&&(ret=inverse(this)),ret}),instance.registerHelper("if",function(conditional,options){return isFunction(conditional)&&(conditional=conditional.call(this)),!options.hash.includeZero&&!conditional||Utils.isEmpty(conditional)?options.inverse(this):options.fn(this)}),instance.registerHelper("unless",function(conditional,options){return instance.helpers["if"].call(this,conditional,{fn:options.inverse,inverse:options.fn,hash:options.hash})}),instance.registerHelper("with",function(context,options){isFunction(context)&&(context=context.call(this));var fn=options.fn;if(Utils.isEmpty(context))return options.inverse(this);if(options.data&&options.ids){var data=createFrame(options.data);data.contextPath=Utils.appendContextPath(options.data.contextPath,options.ids[0]),options={data:data}}return fn(context,options)}),instance.registerHelper("log",function(message,options){var level=options.data&&null!=options.data.level?parseInt(options.data.level,10):1;instance.log(level,message)}),instance.registerHelper("lookup",function(obj,field){return obj&&obj[field]})}var Utils=require("./utils"),Exception=require("./exception")["default"],VERSION="3.0.0";exports.VERSION=VERSION;var COMPILER_REVISION=6;exports.COMPILER_REVISION=COMPILER_REVISION;var REVISION_CHANGES={1:"<= 1.0.rc.2",2:"== 1.0.0-rc.3",3:"== 1.0.0-rc.4",4:"== 1.x.x",5:"== 2.0.0-alpha.x",6:">= 2.0.0-beta.1"};exports.REVISION_CHANGES=REVISION_CHANGES;var isArray=Utils.isArray,isFunction=Utils.isFunction,toString=Utils.toString,objectType="[object Object]";exports.HandlebarsEnvironment=HandlebarsEnvironment,HandlebarsEnvironment.prototype={constructor:HandlebarsEnvironment,logger:logger,log:log,registerHelper:function(name,fn){if(toString.call(name)===objectType){if(fn)throw new Exception("Arg not supported with multiple helpers");Utils.extend(this.helpers,name)}else this.helpers[name]=fn},unregisterHelper:function(name){delete this.helpers[name]},registerPartial:function(name,partial){if(toString.call(name)===objectType)Utils.extend(this.partials,name);else{if("undefined"==typeof partial)throw new Exception("Attempting to register a partial as undefined");this.partials[name]=partial}},unregisterPartial:function(name){delete this.partials[name]}};var logger={methodMap:{0:"debug",1:"info",2:"warn",3:"error"},DEBUG:0,INFO:1,WARN:2,ERROR:3,level:1,log:function(level,message){if("undefined"!=typeof console&&logger.level<=level){var method=logger.methodMap[level];(console[method]||console.log).call(console,message)}}};exports.logger=logger;var log=logger.log;exports.log=log;var createFrame=function(object){var frame=Utils.extend({},object);return frame._parent=object,frame};exports.createFrame=createFrame},{"./exception":36,"./utils":39}],36:[function(require,module,exports){"use strict";function Exception(message,node){var line,column,loc=node&&node.loc;loc&&(line=loc.start.line,column=loc.start.column,message+=" - "+line+":"+column);for(var tmp=Error.prototype.constructor.call(this,message),idx=0;idx<errorProps.length;idx++)this[errorProps[idx]]=tmp[errorProps[idx]];loc&&(this.lineNumber=line,this.column=column)}var errorProps=["description","fileName","lineNumber","message","name","number","stack"];Exception.prototype=new Error,exports["default"]=Exception},{}],37:[function(require,module,exports){
"use strict";function checkRevision(compilerInfo){var compilerRevision=compilerInfo&&compilerInfo[0]||1,currentRevision=COMPILER_REVISION;if(compilerRevision!==currentRevision){if(currentRevision>compilerRevision){var runtimeVersions=REVISION_CHANGES[currentRevision],compilerVersions=REVISION_CHANGES[compilerRevision];throw new Exception("Template was precompiled with an older version of Handlebars than the current runtime. Please update your precompiler to a newer version ("+runtimeVersions+") or downgrade your runtime to an older version ("+compilerVersions+").")}throw new Exception("Template was precompiled with a newer version of Handlebars than the current runtime. Please update your runtime to a newer version ("+compilerInfo[1]+").")}}function template(templateSpec,env){if(!env)throw new Exception("No environment passed to template");if(!templateSpec||!templateSpec.main)throw new Exception("Unknown template object: "+typeof templateSpec);env.VM.checkRevision(templateSpec.compiler);var invokePartialWrapper=function(partial,context,options){options.hash&&(context=Utils.extend({},context,options.hash)),partial=env.VM.resolvePartial.call(this,partial,context,options);var result=env.VM.invokePartial.call(this,partial,context,options);if(null==result&&env.compile&&(options.partials[options.name]=env.compile(partial,templateSpec.compilerOptions,env),result=options.partials[options.name](context,options)),null!=result){if(options.indent){for(var lines=result.split("\n"),i=0,l=lines.length;l>i&&(lines[i]||i+1!==l);i++)lines[i]=options.indent+lines[i];result=lines.join("\n")}return result}throw new Exception("The partial "+options.name+" could not be compiled when running in runtime-only mode")},container={strict:function(obj,name){if(!(name in obj))throw new Exception('"'+name+'" not defined in '+obj);return obj[name]},lookup:function(depths,name){for(var len=depths.length,i=0;len>i;i++)if(depths[i]&&null!=depths[i][name])return depths[i][name]},lambda:function(current,context){return"function"==typeof current?current.call(context):current},escapeExpression:Utils.escapeExpression,invokePartial:invokePartialWrapper,fn:function(i){return templateSpec[i]},programs:[],program:function(i,data,declaredBlockParams,blockParams,depths){var programWrapper=this.programs[i],fn=this.fn(i);return data||depths||blockParams||declaredBlockParams?programWrapper=program(this,i,fn,data,declaredBlockParams,blockParams,depths):programWrapper||(programWrapper=this.programs[i]=program(this,i,fn)),programWrapper},data:function(data,depth){for(;data&&depth--;)data=data._parent;return data},merge:function(param,common){var ret=param||common;return param&&common&&param!==common&&(ret=Utils.extend({},common,param)),ret},noop:env.VM.noop,compilerInfo:templateSpec.compiler},ret=function(context,options){options=options||{};var data=options.data;ret._setup(options),!options.partial&&templateSpec.useData&&(data=initData(context,data));var depths,blockParams=templateSpec.useBlockParams?[]:void 0;return templateSpec.useDepths&&(depths=options.depths?[context].concat(options.depths):[context]),templateSpec.main.call(container,context,container.helpers,container.partials,data,blockParams,depths)};return ret.isTop=!0,ret._setup=function(options){options.partial?(container.helpers=options.helpers,container.partials=options.partials):(container.helpers=container.merge(options.helpers,env.helpers),templateSpec.usePartial&&(container.partials=container.merge(options.partials,env.partials)))},ret._child=function(i,data,blockParams,depths){if(templateSpec.useBlockParams&&!blockParams)throw new Exception("must pass block params");if(templateSpec.useDepths&&!depths)throw new Exception("must pass parent depths");return program(container,i,templateSpec[i],data,0,blockParams,depths)},ret}function program(container,i,fn,data,declaredBlockParams,blockParams,depths){var prog=function(context,options){return options=options||{},fn.call(container,context,container.helpers,container.partials,options.data||data,blockParams&&[options.blockParams].concat(blockParams),depths&&[context].concat(depths))};return prog.program=i,prog.depth=depths?depths.length:0,prog.blockParams=declaredBlockParams||0,prog}function resolvePartial(partial,context,options){return partial?partial.call||options.name||(options.name=partial,partial=options.partials[partial]):partial=options.partials[options.name],partial}function invokePartial(partial,context,options){if(options.partial=!0,void 0===partial)throw new Exception("The partial "+options.name+" could not be found");return partial instanceof Function?partial(context,options):void 0}function noop(){return""}function initData(context,data){return data&&"root"in data||(data=data?createFrame(data):{},data.root=context),data}var Utils=require("./utils"),Exception=require("./exception")["default"],COMPILER_REVISION=require("./base").COMPILER_REVISION,REVISION_CHANGES=require("./base").REVISION_CHANGES,createFrame=require("./base").createFrame;exports.checkRevision=checkRevision,exports.template=template,exports.program=program,exports.resolvePartial=resolvePartial,exports.invokePartial=invokePartial,exports.noop=noop},{"./base":35,"./exception":36,"./utils":39}],38:[function(require,module,exports){"use strict";function SafeString(string){this.string=string}SafeString.prototype.toString=SafeString.prototype.toHTML=function(){return""+this.string},exports["default"]=SafeString},{}],39:[function(require,module,exports){"use strict";function escapeChar(chr){return escape[chr]}function extend(obj){for(var i=1;i<arguments.length;i++)for(var key in arguments[i])Object.prototype.hasOwnProperty.call(arguments[i],key)&&(obj[key]=arguments[i][key]);return obj}function indexOf(array,value){for(var i=0,len=array.length;len>i;i++)if(array[i]===value)return i;return-1}function escapeExpression(string){return string&&string.toHTML?string.toHTML():null==string?"":string?(string=""+string,possible.test(string)?string.replace(badChars,escapeChar):string):string+""}function isEmpty(value){return value||0===value?isArray(value)&&0===value.length?!0:!1:!0}function blockParams(params,ids){return params.path=ids,params}function appendContextPath(contextPath,id){return(contextPath?contextPath+".":"")+id}var escape={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#x27;","`":"&#x60;"},badChars=/[&<>"'`]/g,possible=/[&<>"'`]/;exports.extend=extend;var toString=Object.prototype.toString;exports.toString=toString;var isFunction=function(value){return"function"==typeof value};isFunction(/x/)&&(isFunction=function(value){return"function"==typeof value&&"[object Function]"===toString.call(value)});var isFunction;exports.isFunction=isFunction;var isArray=Array.isArray||function(value){return value&&"object"==typeof value?"[object Array]"===toString.call(value):!1};exports.isArray=isArray,exports.indexOf=indexOf,exports.escapeExpression=escapeExpression,exports.isEmpty=isEmpty,exports.blockParams=blockParams,exports.appendContextPath=appendContextPath},{}],40:[function(require,module,exports){module.exports=require("./dist/cjs/handlebars.runtime")["default"]},{"./dist/cjs/handlebars.runtime":34}],41:[function(require,module,exports){module.exports=require("handlebars/runtime")["default"]},{"handlebars/runtime":40}],42:[function(require,module,exports){"use strict";var repeating=require("repeating");module.exports=function(str,indent,count){if("string"!=typeof str||"string"!=typeof indent)throw new TypeError("`string` and `indent` should be strings");if(null!=count&&"number"!=typeof count)throw new TypeError("`count` should be a number");return indent=count>1?repeating(indent,count):indent,str.replace(/^(?!\s*$)/gm,indent)}},{repeating:43}],43:[function(require,module,exports){"use strict";var isFinite=require("is-finite");module.exports=function(str,n){if("string"!=typeof str)throw new TypeError("Expected a string as the first argument");if(0>n||!isFinite(n))throw new TypeError("Expected a finite positive number");var ret="";do 1&n&&(ret+=str),str+=str;while(n>>=1);return ret}},{"is-finite":44}],44:[function(require,module,exports){"use strict";module.exports=Number.isFinite||function(val){return"number"!=typeof val||val!==val||val===1/0||val===-(1/0)?!1:!0}},{}],45:[function(require,module,exports){(function(Buffer){!function(root,stringify){"function"==typeof require&&"object"==typeof exports&&"object"==typeof module?module.exports=stringify():"function"==typeof define&&define.amd?define(function(){return stringify()}):root.javascriptStringify=stringify()}(this,function(){var ESCAPABLE=/[\\\'\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,META_CHARS={"\b":"\\b","	":"\\t","\n":"\\n","\f":"\\f","\r":"\\r","'":"\\'",'"':'\\"',"\\":"\\\\"},escapeChar=function(char){var meta=META_CHARS[char];return meta||"\\u"+("0000"+char.charCodeAt(0).toString(16)).slice(-4)},RESERVED_WORDS={};"break else new var case finally return void catch for switch while continue function this with default if throw delete in try do instanceof typeof abstract enum int short boolean export interface static byte extends long super char final native synchronized class float package throws const goto private transient debugger implements protected volatile double import public let yield".split(" ").map(function(key){RESERVED_WORDS[key]=!0});var isValidVariableName=function(name){return!RESERVED_WORDS[name]&&/^[a-zA-Z_$][0-9a-zA-Z_$]*$/.test(name)},getGlobalVariable=function(value,indent,stringify){return"Function("+stringify("return this;")+")()"},OBJECT_TYPES={"[object Array]":function(array,indent,stringify){var values=array.map(function(value){return indent+stringify(value).split("\n").join("\n"+indent)}).join(indent?",\n":",");return indent&&values?"[\n"+values+"\n]":"["+values+"]"},"[object Object]":function(object,indent,stringify){if("function"==typeof Buffer&&Buffer.isBuffer(object))return"new Buffer("+stringify(object.toString())+")";var values=Object.keys(object).reduce(function(values,key){var value=stringify(object[key]);return void 0===value?values:(key=isValidVariableName(key)?key:stringify(key),value=String(value).split("\n").join("\n"+indent),values.push(indent+key+":"+(indent?" ":"")+value),values)},[]).join(indent?",\n":",");return indent&&values?"{\n"+values+"\n}":"{"+values+"}"},"[object Date]":function(date,indent,stringify){return"new Date("+date.getTime()+")"},"[object String]":function(string,indent,stringify){return"new String("+stringify(string.toString())+")"},"[object Number]":function(number,indent,stringify){return"new Number("+number+")"},"[object Boolean]":function(boolean,indent,stringify){return"new Boolean("+boolean+")"},"[object RegExp]":String,"[object Function]":String,"[object global]":getGlobalVariable,"[object Window]":getGlobalVariable},PRIMITIVE_TYPES={string:function(string){return"'"+string.replace(ESCAPABLE,escapeChar)+"'"},number:String,object:String,"boolean":String,undefined:String},stringify=function(value,indent,stringify){if(Object(value)!==value)return PRIMITIVE_TYPES[typeof value](value,indent,stringify);var toString=OBJECT_TYPES[Object.prototype.toString.call(value)];return toString&&toString(value,indent,stringify)};return function(value,replacer,space){"string"!=typeof space&&(space=new Array(Math.max(0,0|space)+1).join(" "));var recurse=function(value,cache,next){return cache.indexOf(value)>-1?void 0:(cache.push(value),next(value,space,function(value){return recurse(value,cache.slice(),next)}))};return"function"==typeof replacer?recurse(value,[],function(value,space,next){return replacer(value,space,function(value){return stringify(value,space,next)})}):recurse(value,[],stringify)}})}).call(this,require("buffer").Buffer)},{buffer:23}],46:[function(require,module,exports){var LANGUAGES={tr:{regexp:/\u0130|\u0049|\u0049\u0307/g,map:{"İ":"i",I:"ı","İ":"i"}},az:{regexp:/[\u0130]/g,map:{"İ":"i",I:"ı","İ":"i"}},lt:{regexp:/[\u0049\u004A\u012E\u00CC\u00CD\u0128]/g,map:{I:"i̇",J:"j̇","Į":"į̇","Ì":"i̇̀","Í":"i̇́","Ĩ":"i̇̃"}}};module.exports=function(str,locale){var lang=LANGUAGES[locale];return str=null==str?"":String(str),lang&&(str=str.replace(lang.regexp,function(m){return lang.map[m]})),str.toLowerCase()}},{}],47:[function(require,module,exports){var http=require("http");http.METHODS?module.exports=http.METHODS.map(function(method){return method.toLowerCase()}):module.exports=["get","post","put","head","delete","options","trace","copy","lock","mkcol","move","purge","propfind","proppatch","unlock","report","mkactivity","checkout","merge","m-search","notify","subscribe","unsubscribe","patch","search","connect"]},{http:22}],48:[function(require,module,exports){"use strict";module.exports=function(obj,keys){var res={},i=0;if("object"!=typeof obj)return res;if("string"==typeof keys)return keys in obj&&(res[keys]=obj[keys]),res;for(var len=keys.length;len--;){var key=keys[i++];key in obj&&(res[key]=obj[key])}return res}},{}],49:[function(require,module,exports){arguments[4][28][0].apply(exports,arguments)},{"./vendor/camel-case-regexp":50,"./vendor/non-word-regexp":51,"./vendor/trailing-digit-regexp":52,dup:28,"lower-case":46}],50:[function(require,module,exports){arguments[4][29][0].apply(exports,arguments)},{dup:29}],51:[function(require,module,exports){arguments[4][30][0].apply(exports,arguments)},{dup:30}],52:[function(require,module,exports){arguments[4][31][0].apply(exports,arguments)},{dup:31}],53:[function(require,module,exports){var sentenceCase=require("sentence-case");module.exports=function(string,locale){return sentenceCase(string,locale,"-")}},{"sentence-case":49}],54:[function(require,module,exports){var upperCase=require("upper-case");module.exports=function(str,locale){return null==str?"":(str=String(str),upperCase(str.charAt(0),locale)+str.substr(1))}},{"upper-case":61}],55:[function(require,module,exports){var camelCase=require("camel-case"),upperCaseFirst=require("upper-case-first");module.exports=function(string,locale){return upperCaseFirst(camelCase(string,locale),locale)}},{"camel-case":27,"upper-case-first":54}],56:[function(require,module,exports){arguments[4][28][0].apply(exports,arguments)},{"./vendor/camel-case-regexp":57,"./vendor/non-word-regexp":58,"./vendor/trailing-digit-regexp":59,dup:28,"lower-case":46}],57:[function(require,module,exports){arguments[4][29][0].apply(exports,arguments)},{dup:29}],58:[function(require,module,exports){arguments[4][30][0].apply(exports,arguments)},{dup:30}],59:[function(require,module,exports){arguments[4][31][0].apply(exports,arguments)},{dup:31}],60:[function(require,module,exports){var sentenceCase=require("sentence-case");module.exports=function(str,locale){return sentenceCase(str,locale,"_")}},{"sentence-case":56}],61:[function(require,module,exports){var LANGUAGES={tr:{regexp:/[\u0069]/g,map:{i:"İ"}},az:{regexp:/[\u0069]/g,map:{i:"İ"}},lt:{regexp:/[\u0069\u006A\u012F]\u0307|\u0069\u0307[\u0300\u0301\u0303]/g,map:{"i̇":"I","j̇":"J","į̇":"Į","i̇̀":"Ì","i̇́":"Í","i̇̃":"Ĩ"}}};module.exports=function(str,locale){var lang=LANGUAGES[locale];return str=null==str?"":String(str),lang&&(str=str.replace(lang.regexp,function(m){return lang.map[m]})),str.toUpperCase()}},{}],62:[function(require,module,exports){exports.javascript=require("./javascript")},{"./javascript":4}]},{},[62])(62)}),void function(root,factory){"function"==typeof define&&define.amd?define(factory):"object"==typeof exports?module.exports=factory():root.resolveUrl=factory()}(this,function(){function resolveUrl(){var numUrls=arguments.length;if(0===numUrls)throw new Error("resolveUrl requires at least one argument; got none.");var base=document.createElement("base");if(base.href=arguments[0],1===numUrls)return base.href;var head=document.getElementsByTagName("head")[0];head.insertBefore(base,head.firstChild);for(var resolved,a=document.createElement("a"),index=1;numUrls>index;index++)a.href=arguments[index],resolved=a.href,base.href=resolved;return head.removeChild(base),resolved}return resolveUrl});